import { Location } from '@angular/common';
import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';
import { UsuarioModel } from '../models/usuario.model';
import { ConfigService } from './config.service';
import { SecurityService } from './security.service';
export declare class AuthService {
    private location;
    private httpClient;
    private configService;
    private securityService;
    user: UsuarioModel;
    private gettingOut$;
    constructor(location: Location, httpClient: HttpClient, configService: ConfigService, securityService: SecurityService);
    /**
     * Retorna o Observable com a URL de saida do sistema
     */
    gettingOutEvent(): Observable<string>;
    /**
     * Retorna o Observable se está logado ou não
     */
    isAuthenticated(): Observable<boolean>;
    /**
     * Retorna o nome completo do usuário autorizado
     */
    getUser(): Observable<UsuarioModel>;
    /**
     * Efetua o logout do sistema
     */
    logout(): void;
    login(): void;
    getOut(url: string): void;
    cookie(): Observable<string>;
}
