import { HttpClient, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs';
import { ConfigService } from './config.service';
export declare abstract class BaseService {
    private httpClient;
    private configService;
    constructor(httpClient: HttpClient, configService: ConfigService);
    protected baseDelete<T>(endpoint: string): Observable<T>;
    protected baseGet<T>(endpoint: string): Observable<T>;
    protected baseGetWithParams<T>(endpoint: string, params: HttpParams | {
        [param: string]: string | string[];
    }): Observable<T>;
    protected baseGetCached<T>(endpoint: string): Observable<T>;
    protected baseGetText(endpoint: string): Observable<string>;
    protected baseHead<T>(endpoint: string): Observable<T>;
    protected baseJsonp<T>(endpoint: string, callback: string): Observable<T>;
    protected baseOptions<T>(endpoint: string): Observable<T>;
    protected basePatch<T>(endpoint: string, data: any): Observable<T>;
    protected basePost<T>(endpoint: string, data: any): Observable<T>;
    protected basePostFile(files: File[], fileNames: string[]): Observable<string>;
    protected basePublicPostFile(files: File[], fileNames: string[]): Observable<string>;
    protected basePut<T>(endpoint: string, data: any): Observable<T>;
    private sanitizeEndpoint;
}
