/**
 * Atalho para `encodeURIComponent()`
 * @param uri Algo que precisa de ser codificado
 */
export declare function urlEncode(uri: string): string;
/**
 * Atalho para `decodeURIComponent()`
 * @param uri Algo que precisa de ser decodificado
 */
export declare function urlDecode(uri: string): string;
/**
 * Atalho para codificar em base64 usando UTF-8
 * @param str Texto a ser codificado
 */
export declare function base64Encode(str: string): string;
/**
 * Atalho para decodificar um texto em UTF-8 na codificação base64
 * @param base64 Texto a ser decodificado
 */
export declare function base64Decode(base64: string): string;
/**
 * Atalho para decodificar um texto em UTF-8 na codificação base64
 * Retornando um TypedArray: Uint8Array
 * @param base64 Texto a ser decodificado
 */
export declare function base64DecodeToTypedArray(base64: string): Uint8Array;
/**
 * Atalho para decodificar um texto em UTF-8 na codificação base64
 * Retornando um Blob
 * @param base64 Texto a ser decodificado
 * @param contentType Mime type do Blob
 */
export declare function base64DecodeToBlob(base64: string, contentType: string): Blob;
/**
 * Atalho para para converter uma string em objeto Blob
 * Retornando um Blob
 * @param str Texto a ser decodificado
 * @param contentType Mime type do Blob
 */
export declare function stringToBlob(str: string, contentType: string): Blob;
/**
 * Atalho para decodificar um texto em TypedArray
 * Retornando um TypedArray: Uint8Array
 * @param str Texto a ser decodificado
 */
export declare function stringToTypedArray(str: string): Uint8Array;
