(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/material/select'), require('@angular/material/icon'), require('@angular/material/button'), require('@angular/material/tooltip'), require('@angular/material'), require('@angular/cdk/scrolling'), require('rxjs'), require('rxjs/operators'), require('@datasus/commons'), require('@datasus/core'), require('@angular/core'), require('@angular/material/form-field'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('@datasus/forms', ['exports', '@angular/common', '@angular/material/select', '@angular/material/icon', '@angular/material/button', '@angular/material/tooltip', '@angular/material', '@angular/cdk/scrolling', 'rxjs', 'rxjs/operators', '@datasus/commons', '@datasus/core', '@angular/core', '@angular/material/form-field', '@angular/forms'], factory) :
    (factory((global.datasus = global.datasus || {}, global.datasus.forms = {}),global.ng.common,global.ng.material.select,global.ng.material.icon,global.ng.material.button,global.ng.material.tooltip,global.ng.material,global.ng.cdk.scrolling,global.rxjs,global.rxjs.operators,global['@datasus/commons'],global.core,global.ng.core,global.ng.material['form-field'],global.ng.forms));
}(this, (function (exports,common,select,icon,button,tooltip,material,scrolling,rxjs,operators,commons,core,core$1,formField,forms) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CpfValidator = /** @class */ (function () {
        function CpfValidator() {
        }
        /**
         * @param {?=} value
         * @return {?}
         */
        CpfValidator.isValid = /**
         * @param {?=} value
         * @return {?}
         */
            function (value) {
                if (value === void 0) {
                    value = '';
                }
                value = String(value);
                /** @type {?} */
                var cpf = value ? value.replace(/[^\d]+/g, '') : '';
                if (cpf === '') {
                    return false;
                }
                // Elimina CPFs invalidos conhecidos
                if (cpf.length !== 11 ||
                    cpf === '0'.repeat(11) ||
                    cpf === '1'.repeat(11) ||
                    cpf === '2'.repeat(11) ||
                    cpf === '3'.repeat(11) ||
                    cpf === '4'.repeat(11) ||
                    cpf === '5'.repeat(11) ||
                    cpf === '6'.repeat(11) ||
                    cpf === '7'.repeat(11) ||
                    cpf === '8'.repeat(11) ||
                    cpf === '9'.repeat(11)) {
                    return false;
                }
                // Valida 1o digito
                /** @type {?} */
                var add = 0;
                for (var i = 0; i < 9; i++) {
                    add += parseInt(cpf.charAt(i), 10) * (10 - i);
                }
                /** @type {?} */
                var rev = 11 - (add % 11);
                if (rev === 10 || rev === 11) {
                    rev = 0;
                }
                if (rev !== parseInt(cpf.charAt(9), 10)) {
                    return false;
                }
                // Valida 2o digito
                add = 0;
                for (var i = 0; i < 10; i++) {
                    add += parseInt(cpf.charAt(i), 10) * (11 - i);
                }
                rev = 11 - (add % 11);
                if (rev === 10 || rev === 11) {
                    rev = 0;
                }
                if (rev !== parseInt(cpf.charAt(10), 10)) {
                    return false;
                }
                return true;
            };
        CpfValidator.CPF_REG_EXP = new RegExp('^\\d{0,3}\\.{0,1}\\d{0,3}\\.{0,1}\\d{0,3}\\-{0,1}\\d{0,2}$');
        return CpfValidator;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CnpjValidator = /** @class */ (function () {
        function CnpjValidator() {
        }
        /**
         * @param {?=} value
         * @return {?}
         */
        CnpjValidator.isValid = /**
         * @param {?=} value
         * @return {?}
         */
            function (value) {
                if (value === void 0) {
                    value = '';
                }
                value = String(value);
                /** @type {?} */
                var cnpj = value ? value.replace(/[^\d]+/g, '') : '';
                if (cnpj === '') {
                    return false;
                }
                /** @type {?} */
                var MAX_LENGTH = 14;
                if (cnpj.length !== MAX_LENGTH) {
                    return false;
                }
                // Elimina CNPJs invalidos conhecidos
                if (cnpj.length !== MAX_LENGTH ||
                    cnpj === '0'.repeat(MAX_LENGTH) ||
                    cnpj === '1'.repeat(MAX_LENGTH) ||
                    cnpj === '2'.repeat(MAX_LENGTH) ||
                    cnpj === '3'.repeat(MAX_LENGTH) ||
                    cnpj === '4'.repeat(MAX_LENGTH) ||
                    cnpj === '5'.repeat(MAX_LENGTH) ||
                    cnpj === '6'.repeat(MAX_LENGTH) ||
                    cnpj === '7'.repeat(MAX_LENGTH) ||
                    cnpj === '8'.repeat(MAX_LENGTH) ||
                    cnpj === '9'.repeat(MAX_LENGTH)) {
                    return false;
                }
                // Valida DVs
                /** @type {?} */
                var tamanho = cnpj.length - 2;
                /** @type {?} */
                var numeros = cnpj.substring(0, tamanho);
                /** @type {?} */
                var digitos = cnpj.substring(tamanho);
                /** @type {?} */
                var soma = 0;
                /** @type {?} */
                var pos = tamanho - 7;
                for (var i = tamanho; i >= 1; i--) {
                    /** @type {?} */
                    var num = Number(numeros.charAt(tamanho - i));
                    soma += num * pos--;
                    if (pos < 2) {
                        pos = 9;
                    }
                }
                /** @type {?} */
                var resultado = soma % 11 < 2 ? 0 : 11 - (soma % 11);
                if (resultado !== Number(digitos.charAt(0))) {
                    return false;
                }
                tamanho = tamanho + 1;
                numeros = cnpj.substring(0, tamanho);
                soma = 0;
                pos = tamanho - 7;
                for (var i = tamanho; i >= 1; i--) {
                    /** @type {?} */
                    var num = Number(numeros.charAt(tamanho - i));
                    soma += num * pos--;
                    if (pos < 2) {
                        pos = 9;
                    }
                }
                resultado = soma % 11 < 2 ? 0 : 11 - (soma % 11);
                if (resultado !== Number(digitos.charAt(1))) {
                    return false;
                }
                return true;
            };
        CnpjValidator.CNPJ_REG_EXP = new RegExp('^\\d{0,2}\\.{0,1}\\d{0,3}\\.{0,1}\\d{0,3}/{0,1}\\d{0,4}\\-{0,1}\\d{0,2}$');
        return CnpjValidator;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CnsValidator = /** @class */ (function () {
        function CnsValidator() {
        }
        /**
         * @param {?=} value
         * @return {?}
         */
        CnsValidator.isValid = /**
         * @param {?=} value
         * @return {?}
         */
            function (value) {
                if (value === void 0) {
                    value = '';
                }
                value = String(value);
                /** @type {?} */
                var cns = value ? value.replace(/[^\d]+/g, '') : '';
                if (cns === '') {
                    return false;
                }
                /** @type {?} */
                var PIS_MAX_TAM = 11;
                /** @type {?} */
                var CNS_MAX_TAM = 15;
                /** @type {?} */
                var i = 0;
                /** @type {?} */
                var j = 0;
                /** @type {?} */
                var pis = '';
                /** @type {?} */
                var sum = 0;
                /** @type {?} */
                var mod = 0;
                /** @type {?} */
                var dv = 0;
                /** @type {?} */
                var res = 0;
                /** @type {?} */
                var tipo = '';
                if (cns.length !== CNS_MAX_TAM) {
                    return false;
                }
                if (parseInt(cns, 10).toString() !== cns) {
                    return false;
                }
                tipo = cns.charAt(0);
                if ((tipo === '1') || (tipo === '2')) {
                    /* Validacao de numeros definitivos (Baseados no PIS do usuario) */
                    pis = cns.substring(0, PIS_MAX_TAM);
                    for (i = 0, j = 15; i < PIS_MAX_TAM; i++, j--) {
                        sum += (parseInt(pis.charAt(i), 10) * j);
                    }
                    mod = sum % 11;
                    dv = 11 - mod;
                    if (dv === 11) {
                        dv = 0;
                    }
                    if (dv === 10) {
                        sum += 2;
                        mod = sum % 11;
                        dv = 11 - mod;
                        res = (parseInt(pis, 10) * 10000) + 10 + dv;
                    }
                    else {
                        res = (parseInt(pis, 10) * 10000) + dv;
                    }
                    if (res !== parseInt(cns, 10)) {
                        return false;
                    }
                }
                else if ((tipo === '7') || (tipo === '8') || (tipo === '9')) {
                    /* Validacao de numeros provisorios */
                    for (i = 0, j = 15; i < CNS_MAX_TAM; i++, j--) {
                        sum += (parseInt(cns.charAt(i), 10) * j);
                    }
                    mod = sum % 11;
                    if (mod) {
                        return false;
                    }
                }
                else {
                    return false;
                }
                return true;
            };
        CnsValidator.CNS_REG_EXP = new RegExp('\\d{0,15}$');
        return CnsValidator;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FormValidators = /** @class */ (function () {
        function FormValidators() {
        }
        /**
         * @param {?} ctrl
         * @return {?}
         */
        FormValidators.cpfCnpj = /**
         * @param {?} ctrl
         * @return {?}
         */
            function (ctrl) {
                if (FormValidators.isNull(ctrl)) {
                    return null;
                }
                /** @type {?} */
                var value = ctrl.value ? ctrl.value.replace(/[^\d]+/g, '') : '';
                if (value.length === 11) {
                    return FormValidators.cpf(ctrl);
                }
                else if (value.length === 14) {
                    return FormValidators.cnpj(ctrl);
                }
                else {
                    return null;
                }
            };
        /**
         * @param {?} ctrl
         * @return {?}
         */
        FormValidators.cpf = /**
         * @param {?} ctrl
         * @return {?}
         */
            function (ctrl) {
                if (FormValidators.isNull(ctrl)) {
                    return null;
                }
                if (CpfValidator.isValid(ctrl.value)) {
                    return null;
                }
                return { cpfInvalid: true };
            };
        /**
         * @param {?} ctrl
         * @return {?}
         */
        FormValidators.cnpj = /**
         * @param {?} ctrl
         * @return {?}
         */
            function (ctrl) {
                if (FormValidators.isNull(ctrl)) {
                    return null;
                }
                if (CnpjValidator.isValid(ctrl.value)) {
                    return null;
                }
                return { cnpjInvalid: true };
            };
        /**
         * @param {?} ctrl
         * @return {?}
         */
        FormValidators.cns = /**
         * @param {?} ctrl
         * @return {?}
         */
            function (ctrl) {
                if (FormValidators.isNull(ctrl)) {
                    return null;
                }
                if (CnsValidator.isValid(ctrl.value)) {
                    return null;
                }
                return { cnsInvalid: true };
            };
        /**
         * @param {?} checkFn
         * @return {?}
         */
        FormValidators.requiredIf = /**
         * @param {?} checkFn
         * @return {?}
         */
            function (checkFn) {
                /**
                 * @param {?} ctrl
                 * @return {?}
                 */
                function validator(ctrl) {
                    if (checkFn(ctrl)) {
                        if (!!ctrl.value) {
                            return null;
                        }
                        return { requiredIf: true };
                    }
                    return null;
                }
                return validator;
            };
        /**
         * @param {?} max
         * @return {?}
         */
        FormValidators.maxLength = /**
         * @param {?} max
         * @return {?}
         */
            function (max) {
                /**
                 * @param {?} ctrl
                 * @return {?}
                 */
                function validator(ctrl) {
                    if (FormValidators.isNull(ctrl)) {
                        return null;
                    }
                    if (ctrl.value.length <= max) {
                        return null;
                    }
                    return { maxLength: true };
                }
                return validator;
            };
        /**
         * @param {?} min
         * @return {?}
         */
        FormValidators.minLength = /**
         * @param {?} min
         * @return {?}
         */
            function (min) {
                /**
                 * @param {?} ctrl
                 * @return {?}
                 */
                function validator(ctrl) {
                    if (FormValidators.isNull(ctrl)) {
                        return null;
                    }
                    if (ctrl.value.length >= min) {
                        return null;
                    }
                    return { minLength: true };
                }
                return validator;
            };
        /**
         * @private
         * @param {?} ctrl
         * @return {?}
         */
        FormValidators.isNull = /**
         * @private
         * @param {?} ctrl
         * @return {?}
         */
            function (ctrl) {
                // if (ctrl.touched) {
                //   return false;
                // }
                return !(ctrl.value !== undefined && ctrl.value !== '' && ctrl.value !== null);
            };
        return FormValidators;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CustomErrorStateMatcher = /** @class */ (function () {
        function CustomErrorStateMatcher() {
        }
        /**
         * @param {?} control
         * @param {?} form
         * @return {?}
         */
        CustomErrorStateMatcher.prototype.isErrorState = /**
         * @param {?} control
         * @param {?} form
         * @return {?}
         */
            function (control, form) {
                /** @type {?} */
                var isSubmitted = form && form.submitted;
                return !!(control && control.invalid && (control.dirty || control.touched || isSubmitted));
            };
        return CustomErrorStateMatcher;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // tslint:disable-next-line: max-line-length
    /** @type {?} */
    var DATE_REG_EXP = /^(?:(?:31(\/|-|\.)(?:0?[13578]|1[02]))\1|(?:(?:29|30)(\/|-|\.)(?:0?[1,3-9]|1[0-2])\2))(?:(?:1[6-9]|[2-9]\d)?\d{2})$|^(?:29(\/|-|\.)0?2\3(?:(?:(?:1[6-9]|[2-9]\d)?(?:0[48]|[2468][048]|[13579][26])|(?:(?:16|[2468][048]|[3579][26])00))))$|^(?:0?[1-9]|1\d|2[0-8])(\/|-|\.)(?:(?:0?[1-9])|(?:1[0-2]))\4(?:(?:1[6-9]|[2-9]\d)?\d{2})$/gm;
    var DateMaskDirective = /** @class */ (function () {
        function DateMaskDirective(elementRef) {
            this.elementRef = elementRef;
            this.dateMaskSeparator = '/';
        }
        /**
         * @return {?}
         */
        DateMaskDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var allowed = ['-', '.', '/'];
                if (!allowed.includes(this.dateMaskSeparator)) {
                    this.dateMaskSeparator = '/';
                }
            };
        /**
         * @param {?} value
         * @return {?}
         */
        DateMaskDirective.prototype.onInput = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                this.elementRef.nativeElement.value = this.formatedValue(value);
            };
        /**
         * @param {?} value
         * @return {?}
         */
        DateMaskDirective.prototype.onBlur = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                /** @type {?} */
                var valid = DATE_REG_EXP.test(value);
                if (!valid) {
                    this.elementRef.nativeElement.value = '';
                }
            };
        /**
         * @private
         * @param {?=} value
         * @return {?}
         */
        DateMaskDirective.prototype.formatedValue = /**
         * @private
         * @param {?=} value
         * @return {?}
         */
            function (value) {
                if (value === void 0) {
                    value = '';
                }
                if (!value || typeof value !== 'string') {
                    return '';
                }
                return this.limit(this.addSeparator(this.clear(value)));
            };
        /**
         * @private
         * @param {?=} value
         * @return {?}
         */
        DateMaskDirective.prototype.clear = /**
         * @private
         * @param {?=} value
         * @return {?}
         */
            function (value) {
                if (value === void 0) {
                    value = '';
                }
                return value.replace(/[^(-./)\d]/g, '');
            };
        /**
         * @private
         * @param {?=} value
         * @return {?}
         */
        DateMaskDirective.prototype.addSeparator = /**
         * @private
         * @param {?=} value
         * @return {?}
         */
            function (value) {
                if (value === void 0) {
                    value = '';
                }
                if (value.length === 2 // dd + / = dd/
                    ||
                        value.length === 5 // dd/mm + / = dd/mm/
                ) {
                    return value.concat(this.dateMaskSeparator);
                }
                return value;
            };
        /**
         * @private
         * @param {?} value
         * @return {?}
         */
        DateMaskDirective.prototype.limit = /**
         * @private
         * @param {?} value
         * @return {?}
         */
            function (value) {
                if (value.length > 10) { // dd/mm/aaaa + ?
                    return value.substring(0, 10);
                }
                return value;
            };
        DateMaskDirective.decorators = [
            { type: core$1.Directive, args: [{
                        selector: 'input[datasusDateMask], input[matInput][matDatepicker]'
                    },] }
        ];
        /** @nocollapse */
        DateMaskDirective.ctorParameters = function () {
            return [
                { type: core$1.ElementRef }
            ];
        };
        DateMaskDirective.propDecorators = {
            dateMaskSeparator: [{ type: core$1.Input }],
            onInput: [{ type: core$1.HostListener, args: ['input', ['$event.target.value'],] }],
            onBlur: [{ type: core$1.HostListener, args: ['blur', ['$event.target.value'],] }]
        };
        return DateMaskDirective;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SelectAutocompleteComponent = /** @class */ (function () {
        function SelectAutocompleteComponent(ngControl, controlName, changeDetectorRef) {
            this.controlName = controlName;
            this.changeDetectorRef = changeDetectorRef;
            this.filteredOptions = [];
            this.filteredOptionsChange = new rxjs.Subject();
            this.selectedValue = null;
            this.floatLabel = true;
            this.options = [];
            this.disabled = false;
            this.display = 'display';
            this.inputSearchPlaceholder = 'Pesquisar';
            this.appearance = 'standard';
            this.loading = false;
            this.loadingDiameter = '18';
            this.selectionChange = new core$1.EventEmitter();
            this.openedChangeSelect = new core$1.EventEmitter();
            this.onChange = ( /**
             * @return {?}
             */function () { });
            this.onTouched = ( /**
             * @return {?}
             */function () { });
            if (ngControl) {
                ngControl.valueAccessor = this;
            }
        }
        Object.defineProperty(SelectAutocompleteComponent.prototype, "errorStateMatcher", {
            get: /**
             * @return {?}
             */ function () {
                return this.selectElem.errorStateMatcher;
            },
            set: /**
             * @param {?} val
             * @return {?}
             */ function (val) {
                this.selectElem.errorStateMatcher = val;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        SelectAutocompleteComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.options = this.options || [];
                this.filteredOptions = __spread(this.options);
                /** @type {?} */
                var filterPipe = new commons.FilterPipe();
                this.filteredOptionsChangeSubscription = this.filteredOptionsChange.pipe(operators.debounceTime(400), operators.map(( /**
                 * @param {?} value
                 * @return {?}
                 */function (value) { return filterPipe.transform(_this.options, value, _this.filterSearch); }))).subscribe(( /**
                 * @param {?} filtro
                 * @return {?}
                 */function (filtro) {
                    _this.filteredOptions = __spread(filtro);
                    _this.rerender();
                }), ( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) { return console.error('Erro SelectAutocompleteComponent', error.message); }));
            };
        /**
         * @return {?}
         */
        SelectAutocompleteComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.filteredOptionsChangeSubscription.unsubscribe();
            };
        /**
         * @return {?}
         */
        SelectAutocompleteComponent.prototype.ngOnChanges = /**
         * @return {?}
         */
            function () {
                this.options = this.options || [];
                this.filteredOptions = __spread(this.options);
                this.setValue();
            };
        /**
         * @return {?}
         */
        SelectAutocompleteComponent.prototype.ngDoCheck = /**
         * @return {?}
         */
            function () {
                this.selectElem.updateErrorState();
            };
        /**
         * @param {?} obj
         * @return {?}
         */
        SelectAutocompleteComponent.prototype.writeValue = /**
         * @param {?} obj
         * @return {?}
         */
            function (obj) {
                this.selectedValue = obj;
                this.setValue();
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        SelectAutocompleteComponent.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.selectElem.registerOnChange(fn);
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        SelectAutocompleteComponent.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.selectElem.registerOnTouched(fn);
            };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        SelectAutocompleteComponent.prototype.setDisabledState = /**
         * @param {?} isDisabled
         * @return {?}
         */
            function (isDisabled) {
                this.selectElem.setDisabledState(isDisabled);
            };
        /**
         * @param {?} value
         * @return {?}
         */
        SelectAutocompleteComponent.prototype.filterItem = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                this.filteredOptionsChange.next(value);
            };
        /**
         * @param {?} event
         * @return {?}
         */
        SelectAutocompleteComponent.prototype.stopEventAndAppendSpace = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                event.stopPropagation();
                event.preventDefault();
                this.searchInput.nativeElement.value += ' ';
            };
        /**
         * @return {?}
         */
        SelectAutocompleteComponent.prototype.clearFilterItem = /**
         * @return {?}
         */
            function () {
                this.searchInput.nativeElement.value = '';
                this.filterItem(this.searchInput.nativeElement.value);
            };
        /**
         * @param {?} event
         * @return {?}
         */
        SelectAutocompleteComponent.prototype.onSelectionChange = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                this.selectedValue = event.value;
                this.selectedOptionDisplay = event.source.triggerValue;
                this.setValue();
                this.onChange(this.selectedValue);
                this.onTouched();
                this.selectionChange.emit(this.selectedValue);
                this.rerender();
            };
        /**
         * @param {?} isOpen
         * @return {?}
         */
        SelectAutocompleteComponent.prototype.openedChange = /**
         * @param {?} isOpen
         * @return {?}
         */
            function (isOpen) {
                var _this = this;
                if (isOpen) {
                    setTimeout(( /**
                     * @return {?}
                     */function () { return _this.scrollToMiddle(); }), 0);
                    setTimeout(( /**
                     * @return {?}
                     */function () { return _this.scrollToBottom(); }), 1);
                    setTimeout(( /**
                     * @return {?}
                     */function () { return _this.scrollToMiddle(); }), 2);
                    setTimeout(( /**
                     * @return {?}
                     */function () { return _this.scrollToTop(); }), 3);
                    setTimeout(( /**
                     * @return {?}
                     */function () { return _this.scrollToMiddle(); }), 4);
                    setTimeout(( /**
                     * @return {?}
                     */function () { return _this.scrollToBottom(); }), 5);
                    setTimeout(( /**
                     * @return {?}
                     */function () { return _this.scrollToMiddle(); }), 6);
                    setTimeout(( /**
                     * @return {?}
                     */function () { return _this.scrollToTop(); }), 7);
                }
                this.openedChangeSelect.emit(isOpen);
                this.rerender();
            };
        /**
         * @param {?} o1
         * @param {?} o2
         * @return {?}
         */
        SelectAutocompleteComponent.prototype.compare = /**
         * @param {?} o1
         * @param {?} o2
         * @return {?}
         */
            function (o1, o2) {
                if (!!this.optionField && o1 != null) {
                    return o1 === o2[this.optionField];
                }
                return core.compareObjects(o1, o2);
            };
        /**
         * @return {?}
         */
        SelectAutocompleteComponent.prototype.setValue = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.selectedOptionDisplay = null;
                if (this.selectedValue !== null && this.optionField) {
                    /** @type {?} */
                    var selectedOptionValue = this.options.find(( /**
                     * @param {?} item
                     * @return {?}
                     */function (item) { return item[_this.optionField] === _this.selectedValue; }));
                    this.selectedOptionDisplay = this.findFieldInObj(this.display, selectedOptionValue);
                    this.selectedOptionTooltip = this.findFieldInObj(this.tooltip, selectedOptionValue);
                }
                this.rerender();
            };
        /**
         * @param {?} field
         * @param {?} obj
         * @return {?}
         */
        SelectAutocompleteComponent.prototype.findFieldInObj = /**
         * @param {?} field
         * @param {?} obj
         * @return {?}
         */
            function (field, obj) {
                if (obj instanceof Object && obj.hasOwnProperty(field)) {
                    return obj[field];
                }
                return null;
            };
        /**
         * @private
         * @return {?}
         */
        SelectAutocompleteComponent.prototype.scrollToTop = /**
         * @private
         * @return {?}
         */
            function () {
                /** @type {?} */
                var x = 0;
                /** @type {?} */
                var y = 0;
                this.cdkVirtualScrollViewport.elementRef.nativeElement.scrollTo(x, y);
                this.rerender();
            };
        /**
         * @private
         * @return {?}
         */
        SelectAutocompleteComponent.prototype.scrollToMiddle = /**
         * @private
         * @return {?}
         */
            function () {
                /** @type {?} */
                var x = 0;
                /** @type {?} */
                var y = Math.ceil(this.cdkVirtualScrollViewport.elementRef.nativeElement.scrollHeight / 2);
                this.cdkVirtualScrollViewport.elementRef.nativeElement.scrollTo(x, y);
                this.rerender();
            };
        /**
         * @private
         * @return {?}
         */
        SelectAutocompleteComponent.prototype.scrollToBottom = /**
         * @private
         * @return {?}
         */
            function () {
                /** @type {?} */
                var x = 0;
                /** @type {?} */
                var y = this.cdkVirtualScrollViewport.elementRef.nativeElement.scrollHeight;
                this.cdkVirtualScrollViewport.elementRef.nativeElement.scrollTo(x, y);
                this.rerender();
            };
        /**
         * @private
         * @return {?}
         */
        SelectAutocompleteComponent.prototype.rerender = /**
         * @private
         * @return {?}
         */
            function () {
                this.changeDetectorRef.detectChanges();
                this.cdkVirtualScrollViewport.checkViewportSize();
            };
        SelectAutocompleteComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: 'datasus-select-autocomplete',
                        template: "<mat-form-field [appearance]=\"appearance\" class=\"adjust-mat-field\">\n    <mat-label *ngIf=\"floatLabel\">{{ placeholder }}</mat-label>\n    <mat-select\n        #selectElem\n        class=\"select-custom virtual-scroll\"\n        [disabled]=\"disabled\"\n        [placeholder]=\"placeholder\"\n        [required]=\"required\"\n        (openedChange)=\"openedChange($event)\"\n        (selectionChange)=\"onSelectionChange($event)\"\n        [(ngModel)]=\"selectedValue\"\n    >\n        <div class=\"box-search styck-input\">\n            <input\n                #searchInput\n                type=\"text\"\n                (keydown.space)=\"stopEventAndAppendSpace($event)\"\n                (input)=\"filterItem(searchInput.value)\"\n                [placeholder]=\"inputSearchPlaceholder\"\n            />\n            <div class=\"box-search-icon\" (click)=\"clearFilterItem()\">\n                <button mat-icon-button class=\"search-button\">\n                    <mat-icon class=\"mat-24\" aria-label=\"Search icon\">clear</mat-icon>\n                </button>\n            </div>\n        </div>\n\n        <mat-option\n            *ngIf=\"!!selectedOptionDisplay || !!selectedValue\"\n            class=\"option-item\"\n            [value]=\"selectedValue || (!!optionField ? selectedValue[display] : selectedValue)\"\n            [matTooltip]=\"selectedOptionTooltip || findFieldInObj(tooltip, selectedValue)\"\n        >\n            {{ selectedOptionDisplay || findFieldInObj(display, selectedValue) }}\n        </mat-option>\n\n        <cdk-virtual-scroll-viewport\n            [class.has-mat-option-selected]=\"!!selectedOptionDisplay || !!selectedValue\"\n            itemSize=\"50\"\n            minBufferPx=\"200\"\n            maxBufferPx=\"400\"\n        >\n            <ng-container *cdkVirtualFor=\"let option of filteredOptions\">\n                <mat-option\n                    class=\"option-item\"\n                    [class.hidden]=\"compare(selectedValue, option)\"\n                    [disabled]=\"!!option?.disabled\"\n                    [value]=\"!!optionField ? option[optionField] : option\"\n                    [matTooltip]=\"findFieldInObj(tooltip, option)\"\n                >\n                    {{ findFieldInObj(display, option) || '\u2026' }}\n                </mat-option>\n            </ng-container>\n        </cdk-virtual-scroll-viewport>\n    </mat-select>\n    <mat-spinner *ngIf=\"loading\" matSuffix [diameter]=\"loadingDiameter\"></mat-spinner>\n    <mat-error *ngIf=\"customErroMessage\">{{customErroMessage}}</mat-error>\n</mat-form-field>\n\n",
                        providers: [{
                                provide: formField.MatFormFieldControl,
                                useExisting: core$1.forwardRef(( /**
                                 * @return {?}
                                 */function () { return SelectAutocompleteComponent; })),
                                multi: true
                            },
                        ],
                        changeDetection: core$1.ChangeDetectionStrategy.OnPush,
                        styles: [".box-search{margin:8px;border-radius:2px;box-shadow:0 2px 4px -1px rgba(0,0,0,.2),0 4px 5px 0 rgba(0,0,0,.14),0 1px 10px 0 rgba(0,0,0,.12);transition:box-shadow .2s cubic-bezier(.4,0,.2,1);display:flex;z-index:1002}.adjust-mat-field{margin-top:-14px}.box-search input{flex:1;border:none;outline:0;padding:5px 9px}.styck-input{position:-webkit-sticky;position:sticky;top:10px}.search-button{width:36px;height:36px;line-height:33px;color:#424242}.pl-1{padding-left:1rem}mat-form-field{width:100%}cdk-virtual-scroll-viewport{height:200px!important}cdk-virtual-scroll-viewport.has-mat-option-selected{height:150px!important}.option-item{height:50px!important}"]
                    }] }
        ];
        /** @nocollapse */
        SelectAutocompleteComponent.ctorParameters = function () {
            return [
                { type: forms.NgControl, decorators: [{ type: core$1.Optional }, { type: core$1.Self }] },
                { type: forms.FormControlName, decorators: [{ type: core$1.Optional }] },
                { type: core$1.ChangeDetectorRef }
            ];
        };
        SelectAutocompleteComponent.propDecorators = {
            placeholder: [{ type: core$1.Input }],
            floatLabel: [{ type: core$1.Input }],
            options: [{ type: core$1.Input }],
            disabled: [{ type: core$1.Input }],
            required: [{ type: core$1.Input }],
            display: [{ type: core$1.Input }],
            optionField: [{ type: core$1.Input }],
            inputSearchPlaceholder: [{ type: core$1.Input }],
            filterSearch: [{ type: core$1.Input }],
            appearance: [{ type: core$1.Input }],
            tooltip: [{ type: core$1.Input }],
            customErroMessage: [{ type: core$1.Input }],
            loading: [{ type: core$1.Input }],
            loadingDiameter: [{ type: core$1.Input }],
            errorStateMatcher: [{ type: core$1.Input }],
            selectionChange: [{ type: core$1.Output }],
            openedChangeSelect: [{ type: core$1.Output }],
            selectElem: [{ type: core$1.ViewChild, args: ['selectElem',] }],
            cdkVirtualScrollViewport: [{ type: core$1.ViewChild, args: [scrolling.CdkVirtualScrollViewport,] }],
            searchInput: [{ type: core$1.ViewChild, args: ['searchInput',] }]
        };
        return SelectAutocompleteComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SelectAutocompleteMultipleComponent = /** @class */ (function () {
        function SelectAutocompleteMultipleComponent(ngControl, changeDetectorRef, controlName) {
            this.changeDetectorRef = changeDetectorRef;
            this.controlName = controlName;
            this.searchText = '';
            this.selectedValue = null;
            this.floatLabel = true;
            this.options = [];
            this.disabled = false;
            this.display = 'display';
            this.inputSearchPlaceholder = 'Pesquisar';
            this.appearance = 'standard';
            this.loading = false;
            this.loadingDiameter = '18';
            this.selectionChange = new core$1.EventEmitter();
            this.openedChangeSelect = new core$1.EventEmitter();
            this.onChange = ( /**
             * @return {?}
             */function () { });
            this.onTouched = ( /**
             * @return {?}
             */function () { });
            if (ngControl) {
                ngControl.valueAccessor = this;
            }
        }
        Object.defineProperty(SelectAutocompleteMultipleComponent.prototype, "errorStateMatcher", {
            get: /**
             * @return {?}
             */ function () {
                return this.selectElem.errorStateMatcher;
            },
            set: /**
             * @param {?} val
             * @return {?}
             */ function (val) {
                console.log('vall --> ', val);
                this.selectElem.errorStateMatcher = val;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        SelectAutocompleteMultipleComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this.options = this.options || [];
            };
        /**
         * @return {?}
         */
        SelectAutocompleteMultipleComponent.prototype.ngDoCheck = /**
         * @return {?}
         */
            function () {
                this.selectElem.updateErrorState();
            };
        /**
         * @param {?} obj
         * @return {?}
         */
        SelectAutocompleteMultipleComponent.prototype.writeValue = /**
         * @param {?} obj
         * @return {?}
         */
            function (obj) {
                this.selectedValue = obj;
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        SelectAutocompleteMultipleComponent.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.selectElem.registerOnChange(fn);
                this.onChange = fn;
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        SelectAutocompleteMultipleComponent.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.selectElem.registerOnTouched(fn);
                this.onTouched = fn;
            };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        SelectAutocompleteMultipleComponent.prototype.setDisabledState = /**
         * @param {?} isDisabled
         * @return {?}
         */
            function (isDisabled) {
                this.selectElem.setDisabledState(isDisabled);
            };
        /**
         * @return {?}
         */
        SelectAutocompleteMultipleComponent.prototype.clearSearchText = /**
         * @return {?}
         */
            function () {
                this.searchText = '';
            };
        /**
         * @param {?} event
         * @return {?}
         */
        SelectAutocompleteMultipleComponent.prototype.onSelectionChange = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                this.selectedValue = event.value;
                this.onChange(this.selectedValue);
                this.selectElem.writeValue(this.selectedValue);
                this.onTouched();
                this.selectionChange.emit(this.selectedValue);
                this.changeDetectorRef.detectChanges();
            };
        /**
         * @param {?} isOpen
         * @return {?}
         */
        SelectAutocompleteMultipleComponent.prototype.openedChange = /**
         * @param {?} isOpen
         * @return {?}
         */
            function (isOpen) {
                this.openedChangeSelect.emit(isOpen);
                this.changeDetectorRef.detectChanges();
            };
        /**
         * @param {?} event
         * @return {?}
         */
        SelectAutocompleteMultipleComponent.prototype.stopEventAndAppendSpace = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                event.stopPropagation();
                event.preventDefault();
                this.searchText += ' ';
            };
        /**
         * @param {?} field
         * @param {?} obj
         * @return {?}
         */
        SelectAutocompleteMultipleComponent.prototype.findFieldInObj = /**
         * @param {?} field
         * @param {?} obj
         * @return {?}
         */
            function (field, obj) {
                if (obj instanceof Object && obj.hasOwnProperty(field)) {
                    return obj[field];
                }
                return null;
            };
        SelectAutocompleteMultipleComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: 'datasus-select-autocomplete-multiple',
                        template: "<mat-form-field [appearance]=\"appearance\" class=\"adjust-mat-field\">\n    <mat-label *ngIf=\"floatLabel\">{{ placeholder }}</mat-label>\n    <mat-select\n        #selectElem\n        class=\"select-custom\"\n        [disabled]=\"disabled\"\n        [placeholder]=\"placeholder\"\n        multiple\n        [required]=\"required\"\n        (openedChange)=\"openedChange($event)\"\n        (selectionChange)=\"onSelectionChange($event)\"\n        [(ngModel)]=\"selectedValue\"\n    >\n        <div class=\"box-search styck-input\">\n            <input\n                class=\"pl-1\"\n                type=\"text\"\n                [(ngModel)]=\"searchText\"\n                (keydown.space)=\"stopEventAndAppendSpace($event)\"\n                [placeholder]=\"inputSearchPlaceholder\"\n            />\n            <div class=\"box-search-icon\" (click)=\"clearSearchText()\">\n                <button mat-icon-button class=\"search-button\">\n                    <mat-icon class=\"mat-24\" aria-label=\"Search icon\">clear</mat-icon>\n                </button>\n            </div>\n        </div>\n        <mat-option\n            *ngFor=\"let option of (options | datasusFilter: searchText: filterSearch)\"\n            [disabled]=\"!!option?.disabled\"\n            [value]=\"!!optionField ? option[optionField] : option\"\n            [matTooltip]=\"findFieldInObj(tooltip, option)\"\n        >\n            {{ findFieldInObj(display, option) }}\n        </mat-option>\n        <mat-select-trigger [ngPlural]=\"selectedValue?.length\">\n            Voc\u00EA\n            <ng-template ngPluralCase=\"=0\">n\u00E3o selecionou</ng-template>\n            <ng-template ngPluralCase=\"=1\">selecionou somente um registro</ng-template>\n            <ng-template ngPluralCase=\"=2\">selecionou dois registros</ng-template>\n            <ng-template ngPluralCase=\"other\">selecionou {{ selectedValue?.length }} registros</ng-template>\n        </mat-select-trigger>\n    </mat-select>\n    <mat-spinner *ngIf=\"loading\" matSuffix [diameter]=\"loadingDiameter\"></mat-spinner>\n    <mat-error *ngIf=\"customErroMessage\">{{customErroMessage}}</mat-error>\n</mat-form-field>\n\n",
                        providers: [{
                                provide: formField.MatFormFieldControl,
                                useExisting: core$1.forwardRef(( /**
                                 * @return {?}
                                 */function () { return SelectAutocompleteMultipleComponent; })),
                                multi: true
                            }],
                        changeDetection: core$1.ChangeDetectionStrategy.OnPush,
                        styles: [".box-search{margin:8px;border-radius:2px;box-shadow:0 2px 4px -1px rgba(0,0,0,.2),0 4px 5px 0 rgba(0,0,0,.14),0 1px 10px 0 rgba(0,0,0,.12);transition:box-shadow .2s cubic-bezier(.4,0,.2,1);display:flex;z-index:1002}.adjust-mat-field{margin-top:-14px}.box-search input{flex:1;border:none;outline:0;padding:5px 9px}.styck-input{position:-webkit-sticky;position:sticky;top:10px}.search-button{width:36px;height:36px;line-height:33px;color:#424242}.pl-1{padding-left:1rem}mat-form-field{width:100%}"]
                    }] }
        ];
        /** @nocollapse */
        SelectAutocompleteMultipleComponent.ctorParameters = function () {
            return [
                { type: forms.NgControl, decorators: [{ type: core$1.Optional }, { type: core$1.Self }] },
                { type: core$1.ChangeDetectorRef },
                { type: forms.FormControlName, decorators: [{ type: core$1.Optional }] }
            ];
        };
        SelectAutocompleteMultipleComponent.propDecorators = {
            selectElem: [{ type: core$1.ViewChild, args: ['selectElem',] }],
            placeholder: [{ type: core$1.Input }],
            floatLabel: [{ type: core$1.Input }],
            options: [{ type: core$1.Input }],
            disabled: [{ type: core$1.Input }],
            required: [{ type: core$1.Input }],
            display: [{ type: core$1.Input }],
            optionField: [{ type: core$1.Input }],
            inputSearchPlaceholder: [{ type: core$1.Input }],
            filterSearch: [{ type: core$1.Input }],
            appearance: [{ type: core$1.Input }],
            tooltip: [{ type: core$1.Input }],
            customErroMessage: [{ type: core$1.Input }],
            loading: [{ type: core$1.Input }],
            loadingDiameter: [{ type: core$1.Input }],
            errorStateMatcher: [{ type: core$1.Input }],
            selectionChange: [{ type: core$1.Output }],
            openedChangeSelect: [{ type: core$1.Output }]
        };
        return SelectAutocompleteMultipleComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FormsModule = /** @class */ (function () {
        function FormsModule() {
        }
        FormsModule.decorators = [
            { type: core$1.NgModule, args: [{
                        imports: [
                            // Angular
                            common.CommonModule,
                            forms.FormsModule,
                            forms.ReactiveFormsModule,
                            // Angular Material
                            select.MatSelectModule,
                            icon.MatIconModule,
                            scrolling.ScrollingModule,
                            button.MatButtonModule,
                            tooltip.MatTooltipModule,
                            material.MatProgressSpinnerModule,
                            // Datasus
                            commons.CommonsModule,
                        ],
                        declarations: [
                            // Directives
                            DateMaskDirective,
                            // Components
                            SelectAutocompleteComponent,
                            SelectAutocompleteMultipleComponent,
                        ],
                        exports: [
                            // Directives
                            DateMaskDirective,
                            // Components
                            SelectAutocompleteComponent,
                            SelectAutocompleteMultipleComponent,
                        ]
                    },] }
        ];
        return FormsModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.FormValidators = FormValidators;
    exports.CnpjValidator = CnpjValidator;
    exports.CpfValidator = CpfValidator;
    exports.CnsValidator = CnsValidator;
    exports.CustomErrorStateMatcher = CustomErrorStateMatcher;
    exports.FormsModule = FormsModule;
    exports.ɵc = SelectAutocompleteMultipleComponent;
    exports.ɵb = SelectAutocompleteComponent;
    exports.ɵa = DateMaskDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=datasus-forms.umd.js.map