import { ChangeDetectorRef, DoCheck, ElementRef, EventEmitter, OnChanges, OnDestroy, OnInit } from '@angular/core';
import { FormControlName, ControlValueAccessor, NgControl } from '@angular/forms';
import { MatSelectChange, MatSelect } from '@angular/material/select';
import { CdkVirtualScrollViewport } from '@angular/cdk/scrolling';
import { ErrorStateMatcher } from '@angular/material';
import { Subject } from 'rxjs';
export declare class SelectAutocompleteComponent implements OnInit, OnDestroy, OnChanges, DoCheck, ControlValueAccessor {
    private controlName;
    private changeDetectorRef;
    selectedOptionDisplay: string;
    selectedOptionTooltip: string;
    filteredOptions: any[];
    filteredOptionsChange: Subject<any>;
    displayString: string;
    selectedValue: any;
    placeholder: string;
    floatLabel: boolean;
    options: any[];
    disabled: boolean;
    required: boolean;
    display: string;
    optionField: (string | number);
    inputSearchPlaceholder: string;
    filterSearch: string;
    appearance: ('legacy' | 'standard' | 'fill' | 'outline');
    tooltip: string;
    customErroMessage: string;
    loading: boolean;
    loadingDiameter: string;
    errorStateMatcher: ErrorStateMatcher;
    selectionChange: EventEmitter<any>;
    openedChangeSelect: EventEmitter<boolean>;
    selectElem: MatSelect;
    cdkVirtualScrollViewport: CdkVirtualScrollViewport;
    searchInput: ElementRef<HTMLInputElement>;
    private filteredOptionsChangeSubscription;
    constructor(ngControl: NgControl, controlName: FormControlName, changeDetectorRef: ChangeDetectorRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
    ngOnChanges(): void;
    ngDoCheck(): void;
    onChange: any;
    onTouched: any;
    writeValue(obj: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState(isDisabled: boolean): void;
    filterItem(value: any): void;
    stopEventAndAppendSpace(event: Event): void;
    clearFilterItem(): void;
    onSelectionChange(event: MatSelectChange): void;
    openedChange(isOpen: boolean): void;
    compare(o1: any, o2: any): boolean;
    setValue(): void;
    findFieldInObj(field: string, obj: any): any;
    private scrollToTop;
    private scrollToMiddle;
    private scrollToBottom;
    private rerender;
}
