import { OnInit, OnDestroy, AfterViewInit, ChangeDetectorRef } from '@angular/core';
import { Router, RouterOutlet } from '@angular/router';
import { MediaObserver } from '@angular/flex-layout';
import { Observable } from 'rxjs';
import { LayoutService } from '../../services/layout.service';
import { DialogService } from '../../services/dialog.service';
export declare class LayoutComponent implements OnInit, OnDestroy, AfterViewInit {
    private mediaObserver;
    private layoutService;
    private dialogService;
    private changeDetectorRef;
    routerOutlet: RouterOutlet;
    isLoading$: Observable<boolean>;
    menuSidenavMode: string;
    menuSidenavOpen$: Observable<boolean>;
    enabled$: Observable<boolean>;
    layoutColorClass$: Observable<string>;
    animatedClass$: Observable<string>;
    private mediaSubscription;
    private routerEventSubscription;
    constructor(mediaObserver: MediaObserver, layoutService: LayoutService, dialogService: DialogService, changeDetectorRef: ChangeDetectorRef, router: Router);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    menuSidenavClosed(): void;
    menuSidebarSwipeRight(): void;
    private colorizeAndAnimate;
    private calculateSidenavStatus;
}
