import { PipeTransform } from '@angular/core';
export declare class RelativeDatePipe implements PipeTransform {
    private readonly MILLISECOND;
    private readonly SECOND;
    private readonly MINUTE;
    private readonly HOUR;
    private readonly DAY;
    private readonly WEEK;
    /**
     * Retorna um texto com a data relativa
     *
     * Quando passado o parametro {lowAccuracy} os possíveis retornos são:
     *   Hoje,
     *   Ontem,
     *   Essa semana,
     *   Semana passada,
     *   Mês passado,
     *   Mais antigas
     * No contrário:
     *   Agora pouco,
     *   Minutos atrás,
     *   Horas atrás,
     *   Dias atrás,
     *   Semanas atrás,
     *   Meses atrás
     *   Anos atrás
     */
    transform(value: (number | string | Date), valueToCompare: (number | string | Date), lowAccuracy?: boolean): string;
    private getFullYearMonth;
    private highAccurancyCalc;
    private lowAccurancyCalc;
}
