import { Observable } from 'rxjs';
import { BreakpointObserver } from '@angular/cdk/layout';
export declare class LayoutService {
    private breakpointObserver;
    private title$;
    private enabled$;
    private loading$;
    private onMobile$;
    private menuSidenavOpen$;
    constructor(breakpointObserver: BreakpointObserver);
    /**
     * Ajusta o título da funcionalidade
     * @param title Título da funcionalidade
     */
    setTitle(title: string): void;
    /**
     * Recupera o título da funcionidade
     */
    getTitle(): Observable<string>;
    /**
     * Liga o layout
     */
    on(): void;
    /**
     * Desliga o layout
     */
    off(): void;
    /**
     * Recupera se o layout está ligado ou não
     */
    isEnabled(): Observable<boolean>;
    /**
     * Exibe o carregando...
     */
    loading(): void;
    /**
     * Esconde o carregando...
     */
    loaded(): void;
    /**
     * Recupera se está carregando ou não
     */
    isLoading(): Observable<boolean>;
    /**
     * Recupera se está em uma tela pequena
     */
    onMobile(): Observable<boolean>;
    /**
     * Recupera o estado do menu
     */
    menuSidenavOpen(): Observable<boolean>;
    /**
     * Expande o menu
     */
    menuSidenavExpanded(): void;
    /**
     * Recolhe o menu
     */
    menuSidenavCollapsed(): void;
}
