const source = process.argv[2];
const target = process.argv[3];

function fsFail(error) {
  console.log('✗ Favor instalar o pacote fs-extra: npm install -D fs-extra');
  console.error(error);
  process.exit(1);
}

function copyFail(error) {
  console.log(`✗ Erro ao copiar os arquivos de: "${source}" para: "${target}"`);
  console.error(error);
  process.exit(1);
}

if (!source || !target ) {
  console.error(`✗ Parametros incorretos. de: "${source}" para: "${target}"`);
  process.exit(1);
}

console.log(`⚒ Vamos copiar os arquivos de: "${source}" para: "${target}"`);

let fs;
try {
  fs = require("fs-extra");
  if (!fs) {
    throw 'Pacote fs-extra não encontrado';
  }
} catch(e) {
  fsFail(e);
}

try {
  console.log(`⚒ Removendo "${target}"`);
  fs.removeSync(target);
  console.log(`⚒ Copiando de "${source}" para "${target}"`);
  fs.copySync(source, target);
} catch (e) {
  copyFail(e);
}

console.log(`✔ Arquivos copiados de: "${source}" para: "${target}"\n\n`);