import { Component, OnInit, Input } from '@angular/core';

import { ActionConfig } from '../../configs/actions.config';

@Component({
  selector: 'datasus-dynamic-actions',
  templateUrl: './dynamic-actions.component.html',
  styleUrls: ['./dynamic-actions.component.scss'],
})
export class DynamicActionsComponent implements OnInit {

  @Input() type: ('menu' | 'actions' | 'staticActions');
  @Input() actions: ActionConfig[] = [];
  @Input() showActions = false;
  @Input() actionCallbackParam?: any;

  ngOnInit(): void {
    if (!this.type) {
      throw new Error('É necessário adicionar o tipo.');
    }
  }

  emitClick(menu: ActionConfig): void {
    if (!this.actionCallbackParam) {
      return menu.callback();
    }
    return menu.callback(this.actionCallbackParam);
  }
}
