import { Pipe, PipeTransform } from '@angular/core';
import { Observable, of as observableOf } from 'rxjs';
import { map } from 'rxjs/operators';

import { ConfigService } from '@datasus/core';

@Pipe({ name: 'datasusConfig$' })
export class ConfigPipe implements PipeTransform {

  constructor(
    private configService: ConfigService,
  ) { }

  transform(property: string): Observable<string> {
    if (!property) {
      return observableOf('');
    }

    return this.configService.get(property).pipe(
      map((value: string) => value)
    );
  }

}
