import { Pipe, PipeTransform } from '@angular/core';

import { NormalizePipe } from './normalize.pipe';

@Pipe({
  name: 'datasusFilter'
})
export class FilterPipe implements PipeTransform {

  transform(list: any[], filter?: string, key?: string): any[] {

    if (!list) {
      return [];
    }

    if (!filter) {
      return [...list];
    }

    if (!key) {
      return list.filter((item: string) => this.test(item, filter));
    }

    return list.filter((item: any) => {
      try {
        return this.test(item[key], filter);
      } catch (e) {
        console.error(e);
        return false;
      }
    });
  }

  private test(item: string, filter: string): boolean {
    return this.normalize(item).includes(this.normalize(filter));
  }

  private normalize(text: string): string {
    const normalizePipe = new NormalizePipe();
    return normalizePipe.transform('' + text);
  }
}
