import { Pipe, PipeTransform } from '@angular/core';
import { Observable, of as observableOf } from 'rxjs';
import { map } from 'rxjs/operators';

import { ConfigService } from '@datasus/core';

@Pipe({
  name: 'urlDownloadAssinatura$'
})
export class UrlDownloadAssinaturaPipe implements PipeTransform {

  constructor(
    private configService: ConfigService,
  ) { }

  transform(id: string): Observable<string> {
    if (!id) {
      return observableOf('');
    }

    return this.configService.getList(['backendUrl']).pipe(
      map(
        (configs: string[]) => `${configs[0]}/assinatura-digital/arquivo-assinado-modificado/${id}`
      )
    );
  }

}
