import { Pipe, PipeTransform } from '@angular/core';
import { Observable } from 'rxjs';


import { ConfigService } from '@datasus/core';
import { UrlDownloadPipe } from './url-download.pipe';

@Pipe({ name: 'datasusUrlDownload' })
export class UrlDownloadDeprecatedPipe implements PipeTransform {

  constructor(
    private configService: ConfigService,
  ) { }

  transform(id: string): Observable<string> {
    console.log(
      '%cPipe "datasusUrlDownload" deprecated. Use "datasusUrlDownload$" yet!',
      'font-size: 2em; color: #ff6; background-color: #424242'
    );

    const pipe = new UrlDownloadPipe(this.configService);
    return pipe.transform(id);
  }

}
