import { Pipe, PipeTransform } from '@angular/core';
import { Observable, of as observableOf } from 'rxjs';
import { map } from 'rxjs/operators';

import { ConfigService } from '@datasus/core';

@Pipe({ name: 'datasusUrlDownloadPublic$' })
export class UrlDownloadPublicPipe implements PipeTransform {

  constructor(
    private configService: ConfigService,
  ) { }

  transform(id: string): Observable<string> {
    console.log(
      '%c[!] UrlDownloadPublicPipe.transform(): Vc está usando um método temporário para atender um singelo felino',
      'color: #ff6; background-color: #424242; font-size: 1.2em'
    );

    if (!id) {
      return observableOf('');
    }

    return this.configService.getList(['backendUrl', 'clientId']).pipe(
      map(
        (configs: string[]) => `${configs[0]}/public/arquivo/sistema/${configs[1]}/id/${id}/download`
      )
    );
  }

}
