import { of as obervableOf } from 'rxjs';

import { UrlDownloadPipe } from './url-download.pipe';

describe('UrlDownloadPipe', () => {
  let pipe: UrlDownloadPipe;

  beforeEach(() => {
    const configServiceMock: any = { getList: () => obervableOf(['URL_BACKEND', 'CLIENT_ID'])};
    pipe = new UrlDownloadPipe(configServiceMock);
  });

  it('URL preenchida', () => {
    pipe.transform('ID').subscribe(
      (url: string) => expect(url).toEqual('URL_BACKEND/arquivo/sistema/CLIENT_ID/id/ID/download')
    );
  });

  it('Valor vazio', () => {
    pipe.transform('').subscribe(
      (url: string) => expect(url).toEqual('')
    );
  });

});
