import { Injectable } from '@angular/core';
import { HttpEvent, HttpHandler, HttpInterceptor, HttpRequest } from '@angular/common/http';
import { Observable } from 'rxjs';

import { CONFIG_ENV_JSON_PATH } from '../constants/config.constants';


@Injectable({
  providedIn: 'root'
})
export class AuthInterceptor implements HttpInterceptor {

  private termsWithoutCredentials: string[] = [
    CONFIG_ENV_JSON_PATH,
  ];

  intercept(
    request: HttpRequest<any>,
    next: HttpHandler
  ): Observable<HttpEvent<any>> {
    const authRequest = request.clone({
      withCredentials: this.canAppendCredentials(request.url)
    });
    // console.log('[AuthInterceptor::intercept] Injetando o withCredentials no request XHR', authRequest);
    return next.handle(authRequest);
  }

  private canAppendCredentials(url: string): boolean {
    const filtered = this.termsWithoutCredentials.filter(
      (term: string) => url.includes(term)
    );
    return !filtered.length;
  }
}
