import { Component, OnInit, Inject } from '@angular/core';
import { MAT_DIALOG_DATA, MatDialogRef } from '@angular/material/dialog';
import { Observable } from 'rxjs';

import { AssinaturaDigitalDialogInputData } from '../../services/assinatura-digital-dialog.service';
import {
  AssinaturaDigitalService,
  AssinaturaDigitalStampData,
} from '../../services/assinatura-digital.service';

@Component({
  selector: 'datasus-assinatura-digital-preview-dialog',
  templateUrl: './assinatura-digital-preview-dialog.component.html',
  styleUrls: ['./assinatura-digital-preview-dialog.component.scss']
})
export class AssinaturaDigitalPreviewDialogComponent implements OnInit {

  idArquivoAssinado$: Observable<string>;
  carimbos$: Observable<AssinaturaDigitalStampData[]>;

  constructor(
    private matDialogRef: MatDialogRef<AssinaturaDigitalPreviewDialogComponent>,
    @Inject(MAT_DIALOG_DATA)
    private data: AssinaturaDigitalDialogInputData,
    private assinaturaDigitalService: AssinaturaDigitalService,
  ) { }

  ngOnInit(): void {
    // TODO Implementar o preview do arquivo assinado e listar os carimbos logo abaixo
    this.idArquivoAssinado$ = this.assinaturaDigitalService.arquivoAssinado(this.data.idArquivo);
    this.carimbos$ = this.assinaturaDigitalService.carimbos(this.data.idArquivo);
  }

  close(): void {
    this.matDialogRef.close();
  }

}
