import { NgModule } from '@angular/core';
import { CommonModule as AngularCommonModule } from '@angular/common';
import { FormsModule as AngularFormsModule, ReactiveFormsModule } from '@angular/forms';
import { MatSelectModule } from '@angular/material/select';
import { MatIconModule } from '@angular/material/icon';
import { ScrollingModule } from '@angular/cdk/scrolling';
import { MatButtonModule } from '@angular/material/button';
import { MatTooltipModule } from '@angular/material/tooltip';

import { CommonsModule } from '@datasus/commons';

import { DateMaskDirective } from './directives/date-mask.directive';
import { MatProgressSpinnerModule } from '@angular/material';
import { SelectAutocompleteComponent } from './components/select-autocomplete/select-autocomplete.component';
import { SelectAutocompleteMultipleComponent } from './components/select-autocomplete-multiple/select-autocomplete-multiple.component';

@NgModule({
  imports: [
    // Angular
    AngularCommonModule,
    AngularFormsModule,
    ReactiveFormsModule,
    // Angular Material
    MatSelectModule,
    MatIconModule,
    ScrollingModule,
    MatButtonModule,
    MatTooltipModule,
    MatProgressSpinnerModule,
    // Datasus
    CommonsModule,
  ],
  declarations: [
    // Directives
    DateMaskDirective,
    // Components
    SelectAutocompleteComponent,
    SelectAutocompleteMultipleComponent,
  ],
  exports: [
    // Directives
    DateMaskDirective,
    // Components
    SelectAutocompleteComponent,
    SelectAutocompleteMultipleComponent,
  ]
})
export class FormsModule { }
