export class CnsValidator {

  static CNS_REG_EXP = new RegExp('\\d{0,15}$');

  static isValid(value: string = ''): boolean {
    value = String(value);
    const cns = value ? value.replace(/[^\d]+/g, '') : '';

    if (cns === '') {
      return false;
    }

    const PIS_MAX_TAM = 11;
    const CNS_MAX_TAM = 15;
    let i = 0;
    let j = 0;
    let pis = '';
    let sum = 0;
    let mod = 0;
    let dv = 0;
    let res = 0;
    let tipo = '';

    if (cns.length !== CNS_MAX_TAM) {
      return false;
    }

    if (parseInt(cns, 10).toString() !== cns) {
      return false;
    }

    tipo = cns.charAt(0);

    if ((tipo === '1') || (tipo === '2')) {
      /* Validacao de numeros definitivos (Baseados no PIS do usuario) */
      pis = cns.substring( 0, PIS_MAX_TAM );

      for (i = 0, j = 15; i < PIS_MAX_TAM; i++, j--) {
        sum += (parseInt(pis.charAt(i), 10) * j );
      }

      mod = sum % 11;
      dv = 11 - mod;

      if (dv === 11) {
        dv = 0;
      }

      if (dv === 10) {
        sum += 2;
        mod = sum % 11;
        dv = 11 - mod;
        res = (parseInt(pis, 10) * 10000) + 10 + dv;
      } else {
        res = (parseInt(pis, 10) * 10000) + dv;
      }

      if (res !== parseInt(cns, 10)) {
        return false;
      }
    } else if ((tipo === '7') || (tipo === '8') || (tipo === '9')) {
        /* Validacao de numeros provisorios */
      for (i = 0, j = 15; i < CNS_MAX_TAM; i++, j--) {
        sum += (parseInt(cns.charAt(i), 10) * j );
      }

      mod = sum % 11;
      if (mod) {
        return false;
      }
    } else {
      return false;
    }

    return true;
  }

}
