import { FormControl } from '@angular/forms';

import { CnsValidator } from './cns.validator';
import { FormValidators } from './form.validators';

describe('Min Length validator', () => {

  const ARRAY_VALID = [1, 2, 3];
  const ARRAY_INVALID = [1];
  const ARRAY_EMPTY_LIST = [null, undefined, ''];

  it(`Valida o FormControl com o array: ${ARRAY_VALID} (válido) [min: 2]`, () => {
    const formControlValid = new FormControl(ARRAY_VALID, FormValidators.minLength(2));
    expect(formControlValid.valid).toBeTruthy();
  });

  it(`Valida o FormControl com o array: ${ARRAY_INVALID} (inválido)`, () => {
    const formControlInvalid = new FormControl(ARRAY_INVALID, FormValidators.minLength(2));
    expect(formControlInvalid.valid).toBeFalsy();
  });

  it(`Valida FormControls com array vazio`, () => {
    ARRAY_EMPTY_LIST.map((TYPES: string) => {
      const formControlValid = new FormControl(TYPES, FormValidators.minLength(1));
      expect(formControlValid.valid).toBeTruthy();
    });
  });

});
