import { FormControl } from '@angular/forms';

import { FormValidators } from './form.validators';

describe('Required If Validator', () => {

  it('Valida FormControl com um requiredIf com o callback TRUE e com valor', () => {
    const checkCallbackTrue = (ctrl: FormControl) => {
      return true;
    };

    const formControlEmptyValid = new FormControl('asd', FormValidators.requiredIf(checkCallbackTrue));
    expect(formControlEmptyValid.valid).toBeTruthy();
  });

  it('Valida FormControl com um requiredIf com o callback FALSE e com valor', () => {
    const checkCallbackTrue = (ctrl: FormControl) => {
      return false;
    };

    const formControlEmptyValid = new FormControl('asd', FormValidators.requiredIf(checkCallbackTrue));
    expect(formControlEmptyValid.valid).toBeTruthy();
  });

  it('Valida FormControl com um requiredIf com o callback TRUE e sem valor', () => {
    const checkCallbackTrue = (ctrl: FormControl) => {
      return true;
    };

    const formControlEmptyValid = new FormControl(null, FormValidators.requiredIf(checkCallbackTrue));
    expect(formControlEmptyValid.invalid).toBeTruthy();
  });

  it('Valida FormControl com um requiredIf com o callback FALSE e sem valor', () => {
    const checkCallbackTrue = (ctrl: FormControl) => {
      return false;
    };

    const formControlEmptyValid = new FormControl(null, FormValidators.requiredIf(checkCallbackTrue));
    expect(formControlEmptyValid.valid).toBeTruthy();
  });

});
