# DATASUS Angular

## Layout

Pacote `@datasus/layout`.

## CHANGELOG

### 1.1.0

- Evolução que permite a aplicação enviar um menu local para ser montado.

### 1.0.22

- Colocado para poder tratar URL externas no menu.

### 1.0.21

- Ops, corrigindo o `color` e `colorVariant` do `<datasus-card-content />`.

### 1.0.20

- Ajuste removendo o flex desnecessário do conteudo do `<datasus-card-content />` e adicionado o atributo `elevation` recebendo de -24 até 24.

### 1.0.19

- Arrumado a execução dos eventos na hora de descartar uma notificação executando uma ação.

### 1.0.18

- Ajustado o rodapé para atender as _issues_ [MS-1328](https://jira.cast.com.br/browse/MS-1328) e [#241 do SAA Financeiro](https://gitlab.cast.com.br/datasus/saa-financeiro/saa-financeiro-doc/issues/241).

### 1.0.17

- Corrigindo o _pipe_ `datasusRelativeDate`;
- Colocando para obter a data atual da notificação na resposta do servidor.

### 1.0.16

- Voltando a barra do gov.br.

### 1.0.15

- Alterada a forma de pegar direto o nome do usuário. (de `map` para `pluck`).

### 1.0.14

- Evento de recarregando a lista das notificações.

### 1.0.13

- Corrigida a data relativa que vai na notificação;
- Colocados algumas informações de ARIA no fechar painel do menu e notificaçoes e nos cards das notificações.

### 1.0.12

- Pipe `datasusRelativeDate` na área.

### 1.0.11

- Arrumada a _flag_ de removendo a notificação.

### 1.0.10

- Colocando o `.hidden` para ficar sem _margin_.

### 1.0.9

- Colocando feedback ao descartar uma notificação;
- Tratando para não ficar indo pegar o contador de mensagens novas se a sidenav estiver aberta.

### 1.0.8

- Corrigido retorno da lista vazia das notificações.

### 1.0.7

- Corrigido o nome do atributo do `NotificacaoModel`;
- Travando a versão da barra do governo.

### 1.0.6

- Efetuando _merge_ entre `CHANGELOG` e `README`.

### 1.0.5

- Corrigido a chamada do descarte da notificação;
- Colocado para descartar todas as notificações em um botão só.

### 1.0.4

- Corrigindo a posição do _loading_ quando está numa tela com _scroll_. De novo )=

### 1.0.3

- Corrigindo a posição do _loading_ quando está numa tela com _scroll_;

### 1.0.2

- Mudando a posição do _loading_;
- Deixando a imagem do rodapé sincronizada com o [estatico.saude.gov.br](https://estatico.saude.gov.br/logos-colorido.png).

### 1.0.1

- Só para deixar o _registry_ ok.

### 1.0.0

- Fechando a vesão 1.
- Notificações na área;
- Disponibilização do _enum_ `DatasusColors`.

### 1.0.0-alpha.77

- Trocando de `[title]` para `[header]` no `<datasus-card-content />`.

### 1.0.0-alpha.76

- _Loading_ na lista dos sistemas;
- Corrigido o cache da lista dos sistemas.

### 1.0.0-alpha.75

- Ajustes no layout do `mat-pseudo-checkbox`;
- Arrumando quando não tem sufixo da versão.

### 1.0.0-alpha.74

- Melhorando a aparencia do sufixo da versão.

### 1.0.0-alpha.73

- Concatenado na versão o ambiente e o _build number_. Exemplo: `1.0.0-dev.1` ou `1.0.0-hmg.1`.

### 1.0.0-alpha.72

- Adicionado `(click)` em número de versão.

### 1.0.0-alpha.71

- Colocado um `word-break` nas `table>td, table>th`.

### 1.0.0-alpha.70

- Tratando o redirect para a home quando existe um `NavigationError`.

### 1.0.0-alpha.69

- Exibindo uma animação enquanto o menu carrega.

### 1.0.0-alpha.68

- Mensagem padrão em `NavigationError`.

### 1.0.0-alpha.67

- Tratando o erro de `NavigationError`.

### 1.0.0-alpha.66

- Deixando, para o _mobile_ o close do _backdrop_.

### 1.0.0-alpha.65

- Ops, faltou o _backdrop_ close da seleção de sistemas.

### 1.0.0-alpha.64

- Ops, foi invertida a aparencia da seleção de sistemas.

### 1.0.0-alpha.63

- Ajustado para poder filtrar a estrutura do menu;
- Ajustado para o _dialog_ da seleção de sistemas ficar com _backdrop_ no _mobile_.

### 1.0.0-alpha.62

- Ajustando o evento correto do carregamento da lista de sistemas.

### 1.0.0-alpha.61

- Inclusão de classe `no-padding` no componente `datasus-card-content`.

### 1.0.0-alpha.60

- Inclusão de componente de cartão `datasus-card-content`.

### 1.0.0-alpha.59

- Carregamento da fonte com `font-display: swap` para texto e `font-display: block` para icones;
- Lista de sistemas estilizada.

### 1.0.0-alpha.58

- Lista de sistemas na área.

### 1.0.0-alpha.57

- Ajustando erro de sem esfera na renderização do menu.

### 1.0.0-alpha.56

- Ajustando evento de renderização do menu.

### 1.0.0-alpha.55

- Corrigido o erro do `maxLength`;
- E altura do `<datasus-container />` travada como altura minima.

### 1.0.0-alpha.54

- Inclusão da propriedade `maxLength` no `DialogService.showPrompt()`.

### 1.0.0-alpha.53

- Colocada uma altura para o `<datasus-container />`.

### 1.0.0-alpha.52

- Forçando o _redirect_ da escolha de perfil/esfera para a _home_ quando acionado pelo menu do usuário.

### 1.0.0-alpha.51

- Refatorando o controle de apresentação do menu.

### 1.0.0-alpha.50

- Colocando link para a tela inicial no nome da aplicação, no menu.

### 1.0.0-alpha.49

- Arrumando a contagem para mostrar a troca de perfil/esfera.

### 1.0.0-alpha.48

- Arrumando a contagem para mostrar a troca de perfil/esfera.

### 1.0.0-alpha.47

- Alterando a contagem para mostrar a troca de perfil/esfera.

### 1.0.0-alpha.46

- Manipulando o menu via `LayoutService`.

### 1.0.0-alpha.45

- Voltando o loading para fora da _main content_;

### 1.0.0-alpha.44

- Trocando o loading para dentro da _main content_ e fora da área de animação;

### 1.0.0-alpha.43

- Trocando o loading para dentro da _main content_;
- Adicionado o caminho daonde estou para a tela de escolha de perfil;
- Arruamdo um deprecated do `MediaObserver` do pacote `@angular/flex-layout`.

### 1.0.0-alpha.42

- Adicionado o LEIA-ME.

### 1.0.0-alpha.41

- Alterada as URLs de acesso.

### 1.0.0-alpha.40

- Ajustando o _mixin_ `datasus-icon-sizing`;
- Ajustado a largura e altura dos componentes de container;
- Deixada uma área para fazer o _swipe_ para abrir e fechar o menu lateral;
- Ajustes no `showNotification` do `DialogService`;
- Criada as classes no CSS `.transparent` e `.hidden`;
- Debug log no "calculate sidenav status" removido;
- Ajustado o menu do usuário/perfil/esfera;
- Alerta com a opção de passar somente a mensagem como string;
- Disponibilizando os _pipes_ `datasusFirstWord` e `datasusSwitchSlashToDashPipe`.

### 1.0.0-alpha.39

- Removido o _padding_ do `<datasus-container-transparent />`.

### 1.0.0-alpha.38

- Posição das notificações.

### 1.0.0-alpha.37

- Deixando o `.mat-paginator` com uma `border-radius: 4px`.

### 1.0.0-alpha.36

- Adicionado no `DialogService` o `showNotification`.

### 1.0.0-alpha.35

- Estilos das colunas e de uma tabela;
- Deixanos as classes disponíveis para serem usadas:
  - `.align-left`
  - `.align-right`
  - `.align-center`

### 1.0.0-alpha.34

- Ajustado o _unsubscribe_ na _directive_ `[datasusOnMobile]`;
- Deixado os ícones dos _form-fields_ com uma cor padrão.

### 1.0.0-alpha.33

- Colocado no `LayoutService` o método `onMobile(): Observable<boolean>`.

### 1.0.0-alpha.32

- Deixando a classe `.mat-card` com um `z-index: 101` (para não colidir com header sticky de tabelas).

### 1.0.0-alpha.31

- Alterando o `datasus-media-mobile` para menor que largura de 960px;
- E adicionando os outros medias de acordo com o flex-layout do Angular:
  - `datasus-media-xs`
  - `datasus-media-sm`
  - `datasus-media-md`
  - `datasus-media-lg`
  - `datasus-media-xl`
  - `datasus-media-lt-sm`
  - `datasus-media-lt-md`
  - `datasus-media-lt-lg`
  - `datasus-media-lt-xl`
  - `datasus-media-gt-xs`
  - `datasus-media-gt-sm`
  - `datasus-media-gt-md`
  - `datasus-media-gt-lg`

### 1.0.0-alpha.30

- Deixando o `<datasus-container-transparent />` e o `<datasus-container />`.

### 1.0.0-alpha.29

- Removido o `<datasus-container [transparent]="true"> ... </datasus-conteiner>`;
- Removendo do public_api.ts os componentes. Deixando somento no `LayoutModule`.

### 1.0.0-alpha.28

- Arrumando o `<datasus-container [transparent]="true"> ... </datasus-conteiner>`.

### 1.0.0-alpha.27

- Removendo o debug no `[datasusOnMobile]`.

### 1.0.0-alpha.26

- Debug no `[datasusOnMobile]`.

### 1.0.0-alpha.25

- Debug no `[datasusOnMobile]`;
- Possibilitando de ter o `<datasus-container [transparent]="true"> ... </datasus-conteiner>`.

### 1.0.0-alpha.24

- Alterado o _endpoint_ para obter os dados do menu.
- Posição da barra do topo.

### 1.0.0-alpha.23

- Reconfigurada as opções de cor/animação.

### 1.0.0-alpha.22

- Montando a árvore do menu do usuário por perfil.

### 1.0.0-alpha.21

- Tratado para mostrar o nome do usuário autenticado no menu do usuário perfil/esfera.

### 1.0.0-alpha.20

- Melhorado o alinhamento do perfil/esfera do menu do usuário.

### 1.0.0-alpha.19

- Ajustado o rodapé, para alinhar a esquerda o logo;
- Setando o perfil/esfera selecionado no menu do usuário/perfil;
- Deixando a animação do conteúdo principal.

### 1.0.0-alpha.18

- Removendo as `"peerDependencies"` do `package.json`.

### 1.0.0-alpha.17

- Disponibilizando o `showPrompt(...)` no `DialogService`.

### 1.0.0-alpha.16

- Posição do ícone do usuário;
- Provendo o `DialogService`, disponibilizando o `showAlert(...)` e o `showConfirmation(...)`.

### 1.0.0-alpha.15

- Iniciado o menu dos sistemas.

### 1.0.0-alpha.14

- Inicio do menu do usuário/perfil;
- Disponibilizando o _resource_ SCSS `media` que contem o _mixin_ `datasus-media-mobile`, para utilizar os _medias queries_;
- Incrementando a versão do Angular Material;
- Disponibilizando a _directive_ `datasusOnMobile="'show'|'hide'"`.

### 1.0.0-alpha.13

- Inicio da tela de sem notificações.

### 1.0.0-alpha.12

- Disponibilizando o carregando e a implementação do desligar layout;
- Ícones na barra do topo.

### 1.0.0-alpha.11

- Colocando a opção de ligar e desligar o layout.

### 1.0.0-alpha.10

- Colocado um mini espaçamento para o miolo.

### 1.0.0-alpha.9

- Colocando para não explodir rolagem no menu lateral.

### 1.0.0-alpha.8

- Incrementando a versão do Angular.

### 1.0.0-alpha.7

- Provendo no `LayoutService` uma forma de injetar no layout o titulo da funcionalidade/tela;
- Colocando no `LayoutConfig` a opção de passar o nome da aplicação para exibir no layout.


### 1.0.0-alpha.6

- Normalizando a versão;
- Deixando o scroll do menu lateral invisivel.

### 0.0.5

- Adicionado o inicio dos components do layout: rodapé, menu lateral, barra de notificações, barra do topo;
- Colocando no `LayoutConfig` a opção de passar a versão da aplicação para exibir no layout;
- Iniciando a cor do menu lateral.

### 0.0.4

- Incrementando a versão do Angular.

### 0.0.3

- Incrementando a versão do Angular.

### 0.0.2

- Fechada a estrutura da barra do GOV.BR e das sidenav.

### 0.0.1

- Ponta pé inicial.


