import { Component, Inject } from '@angular/core';
import { MatBottomSheetRef, MAT_BOTTOM_SHEET_DATA } from '@angular/material/bottom-sheet';

import { DialogConfirmationConfig } from '../../configs/dialog-confirmation.config';

@Component({
  selector: 'datasus-dialog-confirmation',
  templateUrl: './dialog-confirmation.component.html',
  styleUrls: ['./dialog-confirmation.component.scss']
})
export class DialogConfirmationComponent {

  config: DialogConfirmationConfig;

  constructor(
    private bottomSheetRef: MatBottomSheetRef<DialogConfirmationComponent>,
    @Inject(MAT_BOTTOM_SHEET_DATA) data: any,
  ) {
    this.config = data as DialogConfirmationConfig;
  }

  closeMe(option: string): void {
    this.bottomSheetRef.dismiss(option);
  }

}
