import { Component } from '@angular/core';
import { Observable } from 'rxjs';
import { take } from 'rxjs/operators';

import { AuthService } from '@datasus/core';

import { LayoutService } from '../../services/layout.service';

@Component({
  selector: 'datasus-loader',
  templateUrl: './loader.component.html',
  styleUrls: ['./loader.component.scss']
})
export class LoaderComponent {

  constructor(
    private layoutService: LayoutService,
    private authService: AuthService,
  ) {
    this.authService.gettingOutEvent().pipe(take(1)).subscribe(() => this.layoutService.loading());
  }

}
