import { Component, OnInit, Inject } from '@angular/core';
import { MatDialogRef } from '@angular/material/dialog';
import { Observable } from 'rxjs';

import { SistemaModel } from '../../models/sistema.model';
import { SistemaService } from '../../services/sistema.service';
import { finalize } from 'rxjs/operators';

@Component({
  selector: 'datasus-system-menu-dialog',
  templateUrl: './system-menu-dialog.component.html',
  styleUrls: ['./system-menu-dialog.component.scss']
})
export class SystemMenuDialogComponent implements OnInit {

  loading: boolean;
  systems$: Observable<SistemaModel[]>;

  constructor(
    private matDialogRef: MatDialogRef<SystemMenuDialogComponent>,
    private sistemaService: SistemaService,
  ) { }

  ngOnInit(): void {
    this.loading = true;
    this.systems$ = this.sistemaService.get().pipe(
      finalize(() => this.loading = false)
    );
  }

  selected(system: SistemaModel): void {
    this.matDialogRef.close(system);
  }
}
