import { Component, OnInit, Input } from '@angular/core';
import { MatSidenav } from '@angular/material/sidenav';
import { Observable } from 'rxjs';

import { LayoutService } from '../../services/layout.service';

@Component({
  selector: 'datasus-toolbar',
  templateUrl: './toolbar.component.html',
  styleUrls: ['./toolbar.component.scss']
})
export class ToolbarComponent implements OnInit {

  @Input() notificationSidenav: MatSidenav;

  menuSidenavOpen$: Observable<boolean>;
  title$: Observable<string>;

  constructor(
    private layoutService: LayoutService,
  ) { }

  ngOnInit(): void {
    this.menuSidenavOpen$ = this.layoutService.menuSidenavOpen();
    this.title$ = this.layoutService.getTitle();
  }

  openMenu(): void {
    this.layoutService.menuSidenavExpanded();
  }
}
