import { FirstWordPipe } from './first-word.pipe';

describe('FirstWordPipe', () => {

  let pipe: FirstWordPipe;

  beforeEach(() => {
      pipe = new FirstWordPipe();
  });

  it(
    'Instancia o pipe',
    () => expect(pipe).toBeTruthy()
  );

  it(
    'Retorna com número',
    () => expect(pipe.transform('123')).toEqual('123')
  );

  it(
    'Retorna vazio',
    () => expect(pipe.transform(null)).toEqual('')
  );

  it(
    'Retorna a primeira palavra *sem acentuação',
    () => expect(pipe.transform('Abc Def')).toEqual('Abc')
  );

  it(
    'Retorna a primeira palavra *com acentuação',
    () => expect(pipe.transform('Ábç Def')).toEqual('Ábç')
  );

  it(
    'Retorna a primeira palavra *com quebra de linha',
    () => expect(pipe.transform(`Abç
    Def`)).toEqual('Abç')
  );

  it(
    'Retorna a primeira palavra *mais espaços',
    () => expect(pipe.transform('abc  def')).toEqual('abc')
  );

  it(
    'Retorna a primeira palavra *com um tab',
    () => expect(pipe.transform('abc	def')).toEqual('abc')
  );

});
