import { Pipe, PipeTransform } from '@angular/core';

@Pipe({
  name: 'datasusListAfterIndex'
})
export class ListAfterIndexPipe implements PipeTransform {

  transform(list: any[], index: number): any[] {
    if (!this.isArray(list)) {
      throw Error('Informe uma lista válida');
    }
    if (!list.length) {
        return [];
    }
    if (index < 0) {
        return [...list];
    }
    return [...list].splice(index);
  }

  private isArray(list: any): boolean {
    return list instanceof Array;
  }

}
