import { Pipe, PipeTransform } from '@angular/core';

@Pipe({
  name: 'datasusListUntilIndex'
})
export class ListUntilIndexPipe implements PipeTransform {

  transform(list: any[], index: number): any[] {
    if (!this.isArray(list)) {
      throw Error('Informe uma lista válida');
    }
    if (!list) {
        return [];
    }
    if (index < 0) {
        return [];
    }
    if (list.length <= index) {
        return [...list];
    }
    return [...list].filter((_: any, i: number) => i < index);
  }

  private isArray(list: any) {
    return list instanceof Array;
  }
}
