INSERT INTO
    dbscodes.tb_categoria
    (no_categoria)
VALUES
    ('Medicamentos'), ('Dietas e suplementos nutricionais'),
    ('Materiais'), ('Procedimentos'),
    ('Nutrição'), ('Outros itens');

INSERT INTO
    dbscodes.tb_tipo_controlado
    (no_tipo_controlado)
VALUES
    ('Não se aplica'), ('Receita azul'),
    ('Receita branca'), ('Receita amarela');

INSERT INTO
    dbscodes.tb_apresentacao
    (no_apresentacao)
VALUES
    ('Cápsula'), ('Cápsula gelatinosa'), ('Cápsula de liberação prolongada'),
    ('Comprimido sublingual'), ('Comprimido efervescente'), ('Comprimido'),
    ('Comprimido de liberação lenta'), ('Comprimido mastigável'), ('Comprimido revestido'),
    ('Drágea'), ('Óvulo'), ('Pastilha'), ('Sache'), ('Supositório'), ('Dose'), ('Bisnaga'), ('Frasco'),
    ('Frasco conta gotas'), ('Ampola'), ('Frasco-ampola'), ('Seringa preenchida'), ('Flaconete'),
    ('Aerossol'), ('Spray oral'), ('Spray nasal'), ('Nebulizador'), ('Inalador oral'), ('Unidade'),
    ('Outras'), ('Mililitro (ml)'), ('Grama (g)'), ('Comprimido revestido de liberação prolongada'),
    ('Comprimido revestido de liberação retardada'), ('Bolsa / Frasco');

INSERT INTO
    dbscodes.tb_grupo_especificacao
    (no_grupo_especificacao, co_grupo_anatomico, co_categoria)
VALUES
    ( 'Aparelho digestivo e metabolismo',                     'A', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Medicamentos') ),
    ( 'Sangue e órgãos hematopoéticos',                       'B', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Medicamentos') ),
    ( 'Sistema cardiovascular',                               'C', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Medicamentos') ),
    ( 'Dermatológicos',                                       'D', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Medicamentos') ),
    ( 'Sistema geniturinário e hormônios sexuais',            'G', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Medicamentos') ),
    ( 'Hormônios de uso sistêmico, exceto hormônios sexuais', 'H', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Medicamentos') ),
    ( 'Agentes antiinfecciosos para uso sistêmico',           'J', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Medicamentos') ),
    ( 'Antineoplásicos e agentes imunomoduladores',           'L', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Medicamentos') ),
    ( 'Sistema músculo-esquelético',                          'M', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Medicamentos') ),
    ( 'Sistema nervoso',                                      'N', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Medicamentos') ),
    ( 'Produtos antiparasitários',                            'P', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Medicamentos') ),
    ( 'Sistema respiratório',                                 'R', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Medicamentos') ),
    ( 'Órgãos dos sentidos',                                  'S', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Medicamentos') ),
    ( 'Vários',                                               'V', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Medicamentos') ),
    ( 'Dietas enterais',                                      'A', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Nutrição') ),
    ( 'Fórmulas infantis e metabólicas',                      'B', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Nutrição') ),
    ( 'Suplementos nutricionais',                             'C', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Nutrição') ),
    ( 'Equipamentos',                                         'A', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Materiais') ),
    ( 'Material de enfermagem',                               'B', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Materiais') ),
    ( 'Órteses / Próteses',                                   'D', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Materiais') ),
    ( 'Procedimento diagnóstico',                             'A', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Procedimentos') ),
    ( 'Consulta e tratamento',                                'B', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Procedimentos') ),
    ( 'Outros',                                               'C', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Procedimentos') ),
    ( 'Outros itens',                                         'A', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Outros itens') ),
    ( 'Material de higiene',                                  'C', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Materiais') ),
    ( 'Outros',                                               'E', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Materiais') ),
    ( 'Cosméticos',                                           'F', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Materiais') ),
    ( 'Módulos',                                              'D', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Nutrição') ),
    ( 'Alimentos',                                            'E', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Nutrição') ),
    ( 'Outros',                                               'F', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Nutrição') ),
    ( 'Dietas parenterais',                                   'G', (SELECT co_seq_categoria FROM dbscodes.tb_categoria WHERE no_categoria = 'Nutrição') );

INSERT INTO
    dbscodes.tb_programa
    (no_programa)
VALUES
    ('Não se aplica'), ('Dose certa'),
    ('Estratégicos'), ('Especializado'),
    ('Protocolo estadual'), ('Especializado / MS');

INSERT INTO
    dbscodes.tb_natureza_despesa
    (nu_natureza_despesa, ds_natureza_despesa)
VALUES
    (33903011, 'Gêneros alimentícios ppais - lei n° 14.591/11'),
    (33903012, 'Material de cama, mesa e banho'),
    (33903013, 'Material e utensílios para refeitório, copa e cozinha'),
    (33903014, 'Material de limpeza'),
    (33903015, 'Artigos de higiene pessoal'),
    (33903016, 'Material de acondicionamento e embalagem'),
    (33903019, 'Lubrificante automotivo'),
    (33903020, 'Gás automotivo'),
    (33903021, 'Gasolina automotiva'),
    (33903022, 'Dieselautomotivo'),
    (33903023, 'Etanol automotivo'),
    (33903024, 'Outros combustíveis e lubrificantes'),
    (33903025, 'Gasolina automotiva -reembolso'),
    (33903026, 'Cestas básicas'),
    (33903027, 'Etanol automotivo - reembolso'),
    (33903028, 'Diesel automotivo - reembolso'),
    (33903029, 'Outros combustíveis e lubrificantes - reembolso'),
    (33903030, 'Medicamentos e insumos farmacêuticos'),
    (33903031, 'Material médico, hospitalar e odontológico'),
    (33903032, 'Materialde uso laboratorial'),
    (33903033, 'Substâncias e produtos químicos'),
    (33903034, 'Ostomia'),
    (33903035, 'Saúde mental'),
    (33903036, 'Alto custo'),
    (33903037, 'Órteses / Próteses'),
    (33903038, 'Soros / Vacinas'),
    (33903039, 'Material esportivo e de lazer'),
    (33903040, 'Material educativo e cultural'),
    (33903041, 'Material de escritório, papelaria e impressos'),
    (33903042, 'Material para fotografia e filmagem'),
    (33903043, 'Livros para bibliotecas públicas, mapas e outraspublicações'),
    (33903044, 'Bandeiras, flâmulas, insígnias'),
    (33903050, 'Peças de reposição e acessórios'),
    (33903051, 'Ferramentas avulsas não acionadas por força motriz'),
    (33903052, 'Material para conservação e manutenção de imóveis'),
    (33903053, 'Peças e acessórios para viaturas policiais'),
    (33903054, 'Material para instalação elétrica e eletrônica'),
    (33903055, 'Material para telecomunicações'),
    (33903056, 'Suprimento de aviação'),
    (33903060, 'Suprimentos de informática'),
    (33903061, 'Peças, acessórios e componentes de informática'),
    (33903062, 'Munições e explosivos'),
    (33903063, 'Fardamento, vestuário, uniforme, tecido e aviamento'),
    (33903064, 'Peças para viaturas - regime de adiantamento'),
    (33903065, 'Peças e acessórios para viaturas de escolta de custodiados'),
    (33903066, 'Material de proteção, segurança, socorroe sobrevivência'),
    (33903080, 'Animais para abate, experimento e sêmen'),
    (33903081, 'Alimentos para animais'),
    (33903082, 'Sementes e mudas de plantas'),
    (33903090, 'Outros materiais de consumo'),
    (33903295, 'Outros materiais para distribuição gratuita'),
    (33903297, 'Material educativo, esportivo e cultural'),
    (33903983, 'Serviços de impressão'),
    (44905210, 'Veículos diversos'),
    (44905220, 'Equipamentos para informática'),
    (44905231, 'Máquinas e motores'),
    (44905232, 'Mobiliário em geral'),
    (44905233, 'Material educativo cultural e recreativo'),
    (44905234, 'Outros equipamentos e material permanente'),
    (44905235, 'Equipamentos e mobiliários médico - hospitalar e odontológico'),
    (     101, 'Não cadastrado para o produto'),
    (33903999, 'Nota de serviço'),
    (       0, 'Não cadastrado para o produto');

INSERT INTO
    dbscodes.tb_tipo_item
    (no_tipo_item)
VALUES
    ('Sem marca'), ('Manipulado'),
    ('Homeopático'), ('Marca');

INSERT INTO
    dbscodes.tb_tipo_dispensacao
    (no_tipo_dispensacao)
VALUES
    ('Padrão'), ('Diário'),
    ('Especial'), ('Irregular');
