--------------------------------------------------------
--  DDL FOR TABLE TB_ALTERACAO_DATA_RETORNO
--------------------------------------------------------

-- DROP TABLE IF EXISTS DBSCODES.TB_RL_ALTDATARET_UNID_DISPENSADORA;

-- DROP TABLE IF EXISTS DBSCODES.TB_ALTERACAO_DATA_RETORNO CASCADE;

-- DROP SEQUENCE IF EXISTS DBSCODES.SQ_ALTDATARET_COSEQALTDATARET;

CREATE SEQUENCE DBSCODES.SQ_ALTERADTRET_COSEQALTERDTRET;

CREATE TABLE DBSCODES.TB_ALTERACAO_DATA_RETORNO
(
  CO_SEQ_ALTERACAO_DATA_RETORNO BIGINT NOT NULL DEFAULT NEXTVAL('DBSCODES.SQ_ALTDATARET_COSEQALTDATARET'::REGCLASS),
  DT_CADASTRO DATE NOT NULL,
  DT_NOVA_DATA_RETORNO DATE NOT NULL,
  NO_TITULO CHARACTER VARYING(100) NOT NULL,
  CO_STATUS_ALTDTRET BIGINT NOT NULL,
	CONSTRAINT PK_ALTERACAODATARETORNO PRIMARY KEY (CO_SEQ_ALTERACAO_DATA_RETORNO)
);

COMMENT ON TABLE  DBSCODES.TB_ALTERACAO_DATA_RETORNO
	IS 'REGISTROS DA ALTERAÇÃO DE DATA DE RETORNO';
COMMENT ON COLUMN DBSCODES.TB_ALTERACAO_DATA_RETORNO.CO_SEQ_ALTERACAO_DATA_RETORNO
	IS 'CODIGO DE IDENTIFICACÃO DA ALTERAÇÃO DE DATA DE RETORNO, GERADO PELA SEQUENCE: DBSCODES.SQ_ALTDATARET_COSEQALTDATARET';
COMMENT ON COLUMN  DBSCODES.TB_ALTERACAO_DATA_RETORNO.DT_CADASTRO
  IS 'DATA DE CADASTRO DA ALTERAÇÃO DE DATA DE RETORNO';
COMMENT ON COLUMN  DBSCODES.TB_ALTERACAO_DATA_RETORNO.DT_NOVA_DATA_RETORNO
	IS 'NOVA DATA DE RETORNO DA ALTERAÇÃO DE DATA DE RETORNO';
COMMENT ON COLUMN  DBSCODES.TB_ALTERACAO_DATA_RETORNO.NO_TITULO
	IS 'NOME DO TITULO DA ALTERAÇÃO DE DATA DE RETORNO';
COMMENT ON COLUMN  DBSCODES.TB_ALTERACAO_DATA_RETORNO.CO_STATUS_ALTDTRET
  IS 'CHAVE ESTRANGEIRA PARA A TABELA DBSCODES.TB_STATUS_ALTERACAO_DATA_RETORNO';

--------------------------------------------------------
--  CONSTRAINTS FOR TABLE TB_ALTERACAO_DATA_RETORNO
--------------------------------------------------------

ALTER TABLE DBSCODES.TB_ALTERACAO_DATA_RETORNO ADD CONSTRAINT FK_ALTERACAODATARETORNO_STATUSALTERACAODATARETORNO FOREIGN KEY(CO_STATUS_ALTDTRET)
    REFERENCES DBSCODES.TB_STATUS_ALTERACAO_DATA_RETORNO(CO_SEQ_STATUS_ALT_DATA_RETORNO);
