CREATE OR REPLACE FUNCTION dbscodes.fc_descricao_item(id_item IN bigint)
RETURNS TEXT AS
$$
DECLARE
    descricao_item TEXT;
BEGIN
    SELECT
        (CASE WHEN prod.co_categoria = 4 THEN
            prod.no_produto || ' / ' || espec.no_especificacao
        WHEN item.co_tipo_item IN(2, 3) THEN
            prod.no_produto || ' / ' || espec.no_especificacao || ' / ' || apr.no_apresentacao || ' / ' || tpitem.no_tipo_item
        ELSE
            prod.no_produto || ' / ' || espec.no_especificacao || ' / ' || apr.no_apresentacao ||
            (CASE WHEN marca.no_marca IS NOT NULL THEN ' / ' || marca.no_marca ELSE '' END)
	    END) INTO descricao_item
    FROM dbscodes.tb_item item
    INNER JOIN dbscodes.tb_tipo_item tpitem ON item.co_tipo_item = tpitem.co_seq_tipo_item
    INNER JOIN dbscodes.tb_especificacao espec ON item.co_especificacao = espec.co_seq_especificacao
    INNER JOIN dbscodes.tb_produto prod ON espec.co_produto = prod.co_seq_produto
    INNER JOIN dbscodes.tb_apresentacao apr ON espec.co_apresentacao = apr.co_seq_apresentacao
    LEFT JOIN  dbscodes.tb_marca marca ON item.co_marca = marca.co_seq_marca
    WHERE item.co_seq_item = id_item;

    RETURN descricao_item;
END
$$ LANGUAGE plpgsql;
