package br.gov.datasus.scodes.acl.controller;

import br.gov.datasus.scodes.acl.api.PerfilApi;
import br.gov.datasus.scodes.acl.model.dto.PerfilDTO;
import br.gov.datasus.scodes.acl.service.PerfilService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@Api(tags = "Perfil")
@RequiredArgsConstructor
@RestController
public class PerfilController implements PerfilApi {

	private final PerfilService service;

	@ApiOperation(value = "Obter todos perfis de um sistema")
	@Override
	public ResponseEntity<List<PerfilDTO>> obterPorSistema(@PathVariable(name = "siglaSistema") String siglaSistema) {
		List<PerfilDTO> lista = service.obterPorSistema(siglaSistema);
		return ResponseEntity.ok(lista);
	}

	@ApiOperation(value = "Obter todos perfis de um sistema por usuário")
	@Override
	public ResponseEntity<List<PerfilDTO>> obterPorUsuarioSistema(@PathVariable(name = "idUsuario") Long idUsuario,
			@PathVariable(name = "siglaSistema") String siglaSistema) {
		List<PerfilDTO> lista = service.obterPorUsuarioSistema(idUsuario, siglaSistema);
		return ResponseEntity.ok(lista);
	}

}
