package br.gov.datasus.scodes.acl.model.converter;

import br.gov.datasus.scodes.acl.model.enums.SituacaoAcessoEnum;

import javax.persistence.AttributeConverter;
import javax.persistence.Converter;
import java.util.Optional;

@Converter
public class SituacaoAcessoEnumConverter implements AttributeConverter<SituacaoAcessoEnum, String> {

    @Override
    public String convertToDatabaseColumn(SituacaoAcessoEnum attribute) {
        if (attribute != null) {
            return attribute.getCodigo();
        }
        return null;
    }

    @Override
    public SituacaoAcessoEnum convertToEntityAttribute(String dbData) {
        Optional<SituacaoAcessoEnum> opt = SituacaoAcessoEnum.obterPorCodigo(dbData);
        if (opt.isPresent()) {
            return opt.get();
        }
        return null;
    }
}
