package br.gov.datasus.scodes.acl.model.converter;

import br.gov.datasus.scodes.acl.model.enums.TipoPerfilEnum;

import javax.persistence.AttributeConverter;
import javax.persistence.Converter;
import java.util.Optional;

@Converter
public class TipoPerfilEnumConverter implements AttributeConverter<TipoPerfilEnum, String> {

    @Override
    public String convertToDatabaseColumn(TipoPerfilEnum attribute) {
        if (attribute != null) {
            return attribute.getCodigo();
        }
        return null;
    }

    @Override
    public TipoPerfilEnum convertToEntityAttribute(String dbData) {
        Optional<TipoPerfilEnum> opt = TipoPerfilEnum.obterPorCodigo(dbData);
        if (opt.isPresent()) {
            return opt.get();
        }
        return null;
    }
}
