package br.gov.datasus.scodes.acl.model.converter;

import br.gov.datasus.scodes.acl.model.enums.TipoPermissaoEnum;

import javax.persistence.AttributeConverter;
import javax.persistence.Converter;
import java.util.Optional;

@Converter
public class TipoPermissaoEnumConverter implements AttributeConverter<TipoPermissaoEnum, String> {

    @Override
    public String convertToDatabaseColumn(TipoPermissaoEnum attribute) {
        if (attribute != null) {
            return attribute.getCodigo();
        }
        return null;
    }

    @Override
    public TipoPermissaoEnum convertToEntityAttribute(String dbData) {
        Optional<TipoPermissaoEnum> opt = TipoPermissaoEnum.obterPorCodigo(dbData);
        if (opt.isPresent()) {
            return opt.get();
        }
        return null;
    }
}
