package br.gov.datasus.scodes.acl.model.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQuery;
import javax.persistence.Table;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_ACL_ESFERA", schema = "DBSCODES")
@NamedQuery(name = "Esfera.obterPorUsuarioSistemaPerfil", query = "SELECT upe FROM UsuarioPerfilEsfera upe WHERE upe.situacaoAcesso = 'SIM' "
		+ "AND upe.usuarioPerfil.usuario.id = :idUsuario AND upe.esferaSistema.sistema.sigla =:siglaSistema "
		+ "AND upe.usuarioPerfil.perfil.sigla = :siglaPerfil ORDER BY upe.descricaoEsferaAtuacao ASC ")
public class Esfera extends BaseEntity<Long> {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@Column(name = "CO_SEQ_ESFERA")
	private Long id;

	@Column(name = "DS_ESFERA", length = 70)
	private String descricao;

	@Column(name = "SG_ESFERA", length = 15)
	private String sigla;

}
