package br.gov.datasus.scodes.acl.model.entity;

import javax.persistence.Column;
import javax.persistence.Convert;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import br.gov.datasus.api.core.model.converter.SimNaoToBooleanConverter;
import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "RL_ACL_ESFERA_SISTEMA", schema = "DBSCODES")
public class EsferaSistema extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "CO_SEQ_ESFERA_SISTEMA")
    private Long id;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "CO_ESFERA")
    private Esfera esfera;

    @Column(name = "CO_ESFERA_SISTEMA_PAI")
    private Long idEsferaSistemaPai;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "CO_PERFIL")
    private Perfil perfil;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "CO_SISTEMA")
    private Sistema sistema;

    @Column(name = "NU_ORDEM")
    private Long numeroOrdem;

    @Convert(converter = SimNaoToBooleanConverter.class)
    @Column(name = "ST_MOSTRA_ESFERA")
    private Boolean mostraEsfera;

}
