package br.gov.datasus.scodes.acl.model.entity;

import javax.persistence.Column;
import javax.persistence.Convert;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import br.gov.datasus.api.core.model.converter.SimNaoToBooleanConverter;
import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_MUNICIPIO", schema = "DBGERAL")
public class Municipio extends BaseEntity<String> {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "CO_MUNICIPIO_IBGE", length = 6)
    private String id;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "CO_UF_IBGE")
    private Uf uf;

    @Column(name = "NO_MUNICIPIO", length = 60)
    private String nomeMunicipio;

    @Convert(converter = SimNaoToBooleanConverter.class)
    @Column(name = "ST_REGISTRO_ATIVO")
    private Boolean registroAtivo;

}
