package br.gov.datasus.scodes.acl.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import br.gov.datasus.scodes.acl.model.converter.TipoPerfilEnumConverter;
import br.gov.datasus.scodes.acl.model.enums.TipoPerfilEnum;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_ACL_PERFIL", schema = "DBSCODES")
@NamedQueries({
		@NamedQuery(name = "Perfil.obterPorSistema", query = "SELECT  DISTINCT p FROM Perfil p WHERE p.sistema.sigla = :siglaSistema "),
		@NamedQuery(name = "Perfil.obterPorUsuarioSistema", query = "SELECT DISTINCT upe.usuarioPerfil.perfil FROM UsuarioPerfilEsfera upe "
				+ "WHERE upe.situacaoAcesso = 'SIM' AND upe.usuarioPerfil.usuario.id = :idUsuario  AND upe.esferaSistema.sistema.sigla =:siglaSistema ") })
public class Perfil extends BaseEntity<Long> {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@Column(name = "CO_SEQ_PERFIL")
	private Long id;

	@Column(name = "CO_PERFIL_PAI")
	private Long idPerfilPai;

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "CO_SISTEMA")
	private Sistema sistema;

	@Column(name = "DS_PERFIL", length = 100)
	private String descricao;

	@Column(name = "SG_PERFIL", length = 10)
	private String sigla;

	@Convert(converter = TipoPerfilEnumConverter.class)
	@Column(name = "TP_PERFIL")
	private TipoPerfilEnum tipoPerfil;

}
