package br.gov.datasus.scodes.acl.model.entity;

import javax.persistence.Column;
import javax.persistence.Convert;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;

import br.gov.datasus.api.core.model.converter.SimNaoToBooleanConverter;
import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_SEXO", schema = "DBGERAL")
public class Sexo extends BaseEntity<String> {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "CO_SEXO", length = 1)
    private String id;

    @Column(name = "DS_SEXO", length = 10)
    private String sexo;

    @Convert(converter = SimNaoToBooleanConverter.class)
    @Column(name = "ST_CADSUS")
    private Boolean cadsus;

    @Convert(converter = SimNaoToBooleanConverter.class)
    @Column(name = "ST_REGISTRO_ATIVO")
    private Boolean registroAtivo;

}
