package br.gov.datasus.scodes.acl.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import br.gov.datasus.scodes.acl.model.converter.SituacaoAcessoEnumConverter;
import br.gov.datasus.scodes.acl.model.enums.SituacaoAcessoEnum;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "RL_ACL_USUARIO_PERFIL_ESFERA", schema = "DBSCODES")
public class UsuarioPerfilEsfera extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "CO_SEQ_USUARIO_PERFIL_ESFERA")
    private Long id;

    @Column(name = "CO_ESFERA_ATUACAO", length = 250)
    private String esferaAtuacao;

    @Column(name = "DS_ESFERA_ATUACAO", length = 250)
    private String descricaoEsferaAtuacao;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "CO_USUARIO_PERFIL")
    private UsuarioPerfil usuarioPerfil;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "CO_ESFERA_SISTEMA")
    private EsferaSistema esferaSistema;

    @Convert(converter = SituacaoAcessoEnumConverter.class)
    @Column(name = "ST_USUARIO_PERFIL_ESFERA")
    private SituacaoAcessoEnum situacaoAcesso;

}
