package br.gov.datasus.scodes.acl.model.enums;

import br.gov.datasus.api.core.model.annotations.Dominio;
import com.fasterxml.jackson.annotation.JsonValue;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.io.Serializable;
import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import java.util.stream.Stream;


@Dominio("Informar descrição")
@JsonSerialize
@AllArgsConstructor
public enum TipoPerfilEnum implements Serializable {
    ADMINISTRADOR("ADM", "Administrador"),
    ANALISTA("ANA", "Analista"),
    GESTOR("GES", "Gestor"),
    USUARIO("USR", "Usuário");

	@Getter
	@JsonValue
	private String codigo;

	@Getter
	private String descricao;

	public static Optional<TipoPerfilEnum> obterPorCodigo(final String codigo) {
		return TipoPerfilEnum.stream().filter(e -> e.getCodigo().equals(codigo)).findFirst();
	}

	public static Optional<TipoPerfilEnum> obterPorDescricao(final String descricao) {
		return TipoPerfilEnum.stream().filter(e -> e.getDescricao().equals(descricao)).findFirst();
	}

	public static Stream<TipoPerfilEnum> stream() {
		return Stream.of(TipoPerfilEnum.values());
	}

	public static List<TipoPerfilEnum> list() {
		return Arrays.asList(TipoPerfilEnum.values());
	}
}
