package br.gov.datasus.scodes.acl.model.mapper;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;
import br.gov.datasus.scodes.acl.model.dto.FuncionalidadeDTO;
import br.gov.datasus.scodes.acl.model.entity.Funcionalidade;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.ReportingPolicy;

import java.util.List;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface FuncionalidadeMapper extends BaseMapper<Funcionalidade, FuncionalidadeDTO> {

    FuncionalidadeDTO toDto(Funcionalidade entity);

    List<FuncionalidadeDTO> toDto(List<Funcionalidade> entities);

    List<FuncionalidadeDTO> toDto(Iterable<Funcionalidade> entities);

    PageableResponseModel<FuncionalidadeDTO> toDtoPageableResponse(PageableResponseModel<Funcionalidade> pageableResponseModel);

    Funcionalidade toEntity(FuncionalidadeDTO dto);

    List<Funcionalidade> toEntity(List<FuncionalidadeDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(FuncionalidadeDTO dto, @MappingTarget Funcionalidade entity);
}
