package br.gov.datasus.scodes.acl.model.mapper;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.scodes.acl.model.dto.IdentificacaoUsuarioDTO;
import br.gov.datasus.scodes.acl.model.entity.IdentificacaoUsuario;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.ReportingPolicy;

import java.util.List;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface IdentificacaoUsuarioMapper extends BaseMapper<IdentificacaoUsuario, IdentificacaoUsuarioDTO> {

    IdentificacaoUsuarioDTO toDto(IdentificacaoUsuario entity);

    List<IdentificacaoUsuarioDTO> toDto(List<IdentificacaoUsuario> entities);

    List<IdentificacaoUsuarioDTO> toDto(Iterable<IdentificacaoUsuario> entities);

    IdentificacaoUsuario toEntity(IdentificacaoUsuarioDTO dto);

    List<IdentificacaoUsuario> toEntity(List<IdentificacaoUsuarioDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(IdentificacaoUsuarioDTO dto, @MappingTarget IdentificacaoUsuario entity);
}
