package br.gov.datasus.scodes.acl.model.mapper;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;
import br.gov.datasus.scodes.acl.model.dto.PermissaoDTO;
import br.gov.datasus.scodes.acl.model.entity.Permissao;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.ReportingPolicy;

import java.util.List;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface PermissaoMapper extends BaseMapper<Permissao, PermissaoDTO> {

    PermissaoDTO toDto(Permissao entity);

    List<PermissaoDTO> toDto(List<Permissao> entities);

    List<PermissaoDTO> toDto(Iterable<Permissao> entities);

    PageableResponseModel<PermissaoDTO> toDtoPageableResponse(PageableResponseModel<Permissao> pageableResponseModel);

    Permissao toEntity(PermissaoDTO dto);

    List<Permissao> toEntity(List<PermissaoDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(PermissaoDTO dto, @MappingTarget Permissao entity);
}
