package br.gov.datasus.scodes.acl.model.mapper;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;
import br.gov.datasus.scodes.acl.model.dto.SistemaDTO;
import br.gov.datasus.scodes.acl.model.entity.Sistema;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.ReportingPolicy;

import java.util.List;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface SistemaMapper extends BaseMapper<Sistema, SistemaDTO> {

    SistemaDTO toDto(Sistema entity);

    List<SistemaDTO> toDto(List<Sistema> entities);

    List<SistemaDTO> toDto(Iterable<Sistema> entities);

    Sistema toEntity(SistemaDTO dto);

    List<Sistema> toEntity(List<SistemaDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(SistemaDTO dto, @MappingTarget Sistema entity);

    PageableResponseModel<SistemaDTO> toDtoPageableResponse(PageableResponseModel<Sistema> pageableResponseModel);
}
