package br.gov.datasus.scodes.acl.model.mapper;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.scodes.acl.model.dto.UsuarioDTO;
import br.gov.datasus.scodes.acl.model.entity.Usuario;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.ReportingPolicy;

import java.util.List;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface UsuarioMapper extends BaseMapper<Usuario, UsuarioDTO> {

    UsuarioDTO toDto(Usuario entity);

    List<UsuarioDTO> toDto(List<Usuario> entities);

    List<UsuarioDTO> toDto(Iterable<Usuario> entities);

    Usuario toEntity(UsuarioDTO dto);

    List<Usuario> toEntity(List<UsuarioDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(UsuarioDTO dto, @MappingTarget Usuario entity);
}
