package br.gov.datasus.scodes.acl.model.mapper;

import br.gov.datasus.api.core.model.mapper.BaseGenericObjectMapper;
import br.gov.datasus.scodes.acl.model.dto.IdentificacaoUsuarioDTO;
import org.mapstruct.*;

import java.util.List;

@Mapper(
    componentModel = "spring",
    unmappedTargetPolicy = ReportingPolicy.IGNORE
)
public interface UsuariosSistemaPerfilEsferaMapper extends BaseGenericObjectMapper<IdentificacaoUsuarioDTO> {

    @InheritInverseConfiguration(name = "toMap")
    List<IdentificacaoUsuarioDTO> toList(List<Object> value);

    @Mappings({
        @Mapping(
            target = "id",
            expression = "java(toLong( value, 0 ))"
        ),
        @Mapping(
            target = "nome",
            expression = "java(toString( value, 1 ))"
        ),
        @Mapping(
            target = "email",
            expression = "java(toString( value, 2 ))"
        ),
        @Mapping(
            target = "cpf",
            expression = "java(toString( value, 3 ))"
        ),
        @Mapping(
            target = "dataCadastro",
            expression = "java(toDate( value, 4 ))"
        ),
    })
    IdentificacaoUsuarioDTO toMap(Object value);

}
