package br.gov.datasus.scodes.acl.repository;

import br.gov.datasus.api.core.dynamicquery.repository.DynamicNativeQueryRepository;
import br.gov.datasus.api.core.dynamicquery.repository.DynamicQueryRepository;
import br.gov.datasus.scodes.acl.model.entity.Funcionalidade;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;

public interface FuncionalidadeRepository
    extends CrudRepository<Funcionalidade, Long>, DynamicQueryRepository, DynamicNativeQueryRepository {

    Iterable<Funcionalidade> obterPorSistema(@Param("siglaSistema") String siglaSistema);

    Iterable<Funcionalidade> obterPorSistemaPerfil(@Param("siglaSistema") String siglaSistema,
                                                   @Param("siglaPerfil") String siglaPerfil);

    Iterable<Funcionalidade> obterDesbloqueadosPorSistemaPerfil(@Param("siglaSistema") String siglaSistema, @Param("siglaPerfil") String siglaPerfil);
}
