package br.gov.datasus.scodes.acl.repository;

import br.gov.datasus.api.core.dynamicquery.repository.DynamicNativeQueryRepository;
import br.gov.datasus.api.core.dynamicquery.repository.DynamicQueryRepository;
import br.gov.datasus.scodes.acl.model.entity.Perfil;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;

public interface PerfilRepository
    extends CrudRepository<Perfil, Long>, DynamicQueryRepository, DynamicNativeQueryRepository {

    Iterable<Perfil> obterPorSistema(@Param("siglaSistema") String siglaSistema);

    Iterable<Perfil> obterPorUsuarioSistema(@Param("idUsuario") Long idUsuario,
                                            @Param("siglaSistema") String siglaSistema);

}
