package br.gov.datasus.scodes.acl.service;

import br.gov.datasus.scodes.acl.model.dto.EsferaAtuacaoDTO;
import br.gov.datasus.scodes.acl.model.entity.UsuarioPerfilEsfera;
import br.gov.datasus.scodes.acl.model.mapper.EsferaAtuacaoMapper;
import br.gov.datasus.scodes.acl.repository.EsferaRepository;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@RequiredArgsConstructor
@Transactional(propagation = Propagation.SUPPORTS)
public class EsferaService {

	private final EsferaRepository repository;

	private final EsferaAtuacaoMapper mapper;

	public List<EsferaAtuacaoDTO> obterPorUsuarioSistemaPerfil(Long idUsuario, String siglaSistema,
                                                               String siglaPerfil) {
		Iterable<UsuarioPerfilEsfera> itens = repository.obterPorUsuarioSistemaPerfil(idUsuario, siglaSistema,
				siglaPerfil);
		return mapper.toDto(itens);
	}
}
