package br.gov.datasus.scodes.acl.service;

import br.gov.datasus.scodes.acl.model.dto.FuncionalidadeDTO;
import br.gov.datasus.scodes.acl.model.entity.Funcionalidade;
import br.gov.datasus.scodes.acl.model.mapper.FuncionalidadeMapper;
import br.gov.datasus.scodes.acl.repository.FuncionalidadeRepository;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@RequiredArgsConstructor
@Transactional(propagation = Propagation.SUPPORTS)
public class FuncionalidadeService {

	private final FuncionalidadeRepository repository;
	private final FuncionalidadeMapper mapper;

	public List<FuncionalidadeDTO> obterPorSistema(String siglaSistema) {
		Iterable<Funcionalidade> itens = repository.obterPorSistema(siglaSistema);
		return mapper.toDto(itens);
	}

	public List<FuncionalidadeDTO> obterPorSistemaPerfil(String siglaSistema, String siglaPerfil) {
		Iterable<Funcionalidade> itens = repository.obterPorSistemaPerfil(siglaSistema, siglaPerfil);
		return mapper.toDto(itens);
	}

	public List<FuncionalidadeDTO> obterDesbloqueadosPorSistemaPerfil(String siglaSistema, String siglaPerfil) {
		Iterable<Funcionalidade> itens = repository.obterDesbloqueadosPorSistemaPerfil(siglaSistema, siglaPerfil);
		return mapper.toDto(itens);
	}

}
