package br.gov.datasus.authorization.configuration.cache;

import br.gov.datasus.authorization.enums.CacheEnum;
import br.gov.datasus.authorization.security.oauth2.model.Client;
import br.gov.datasus.authorization.security.oauth2.provider.ClientProvider;
import com.hazelcast.core.IMap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.context.event.ApplicationReadyEvent;
import org.springframework.context.ApplicationListener;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

@Component
public class ClientCacheStartup implements ApplicationListener<ApplicationReadyEvent> {

	@Autowired
	private HazelcastComponent hazelcastComponent;

	@Autowired
	private ClientProvider clientProvider;

	@Override
	public void onApplicationEvent(ApplicationReadyEvent event) {
		cacheScpaClient();
	}

	@Scheduled(cron = "0 0/15 * * * ?")
	@SuppressWarnings("unchecked")
	public void cacheScpaClient() {
		IMap<String, Client> clientMap = (IMap<String, Client>) hazelcastComponent.getCacheMap(CacheEnum.CLIENTS);
		for (Client client : clientProvider.clients()) {
			clientMap.put(client.getClientId(), client);
		}
	}

}
