package br.gov.datasus.authorization.model.scodes;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_AREA", schema = "DBSCODES")
@NamedQueries({
   @NamedQuery(name = Area.OBTER_DOMINIO, query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(a.id, a.nome) FROM Area a ORDER BY a.nome ASC")
})
public class Area extends BaseEntity<Long> {

	private static final long serialVersionUID = 1L;

	public static final String OBTER_DOMINIO = "Area.obterDominio";

	@Id
	@GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_AREA")
	@SequenceGenerator(name = "SEQ_GENERATOR_AREA", sequenceName = "SQ_AREA_COSEQAREA", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
	@Column(name = "CO_SEQ_AREA", nullable = false)
	private Long id;

	@Column(name = "DS_AREA", length = 30, nullable = false)
	private String nome;

}
