package br.gov.datasus.authorization.security.oauth2.model;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

public class Client implements Serializable {

	private static final long serialVersionUID = 1L;

	private static final String CLIENT_CREDENTIALS_CHECK = "_INTEGRACAO";

	private String clientId;

	private String clientSecret;

	private Set<String> scopes = new HashSet<>();;

	private Set<String> urls = new HashSet<>();

	private Set<String> clientRoles = new HashSet<>();

	public Client() {
		super();
	}

	public String getClientId() {
		return clientId;
	}

	public void setClientId(String clientId) {
		this.clientId = clientId;
	}

	public String getClientSecret() {
		return clientSecret;
	}

	public void setClientSecret(String clientSecret) {
		this.clientSecret = clientSecret;
	}

	public Set<String> getUrls() {
		return urls;
	}

	public void setUrls(Set<String> urls) {
		this.urls = urls;
	}

	public Boolean isClientCredentials() {
		return clientId.contains(CLIENT_CREDENTIALS_CHECK);
	}

	public Set<String> getClientRoles() {
		return clientRoles;
	}

	public void setClientRoles(Set<String> clientRoles) {
		this.clientRoles = clientRoles;
	}

	public Set<String> getScopes() {
		return scopes;
	}

	public void setScopes(Set<String> scopes) {
		this.scopes = scopes;
	}

}
