package br.gov.datasus.authorization.security.oauth2.provider;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.authentication.UsernamePasswordAuthenticationToken;
import org.springframework.security.authentication.dao.AbstractUserDetailsAuthenticationProvider;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.AuthenticationException;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import br.gov.datasus.authorization.configuration.properties.ApplicationProperties;
import br.gov.datasus.authorization.service.IntegracaoCnsDigitalServide;

@Service("userDetailsAuthenticationCnsDigitalProvider")
public class UserDetailsAuthenticationCnsDigitalProvider extends AbstractUserDetailsAuthenticationProvider {

    @Autowired
    private IntegracaoCnsDigitalServide integracaoCnsDigitalServide;

    @Autowired
    private ApplicationProperties.IntegracaoCadsus integracaoCadsus;

    @Override
    public Authentication authenticate(Authentication authentication) throws AuthenticationException {
        String username = authentication.getPrincipal().toString();
        String password = authentication.getCredentials().toString();
        new RestTemplate().getForObject(integracaoCadsus.urlLoginCadsus, String.class, username, password);
        return super.authenticate(authentication);
    }

    @Override
    protected void additionalAuthenticationChecks(UserDetails userDetails,
            UsernamePasswordAuthenticationToken authentication) throws AuthenticationException {
    }

    @Override
    protected UserDetails retrieveUser(String username, UsernamePasswordAuthenticationToken authentication)
            throws AuthenticationException {
        return integracaoCnsDigitalServide.loadUser(username);
    }
}
