package br.gov.datasus.authorization.service;

import java.util.HashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;
import org.thymeleaf.util.StringUtils;

import br.gov.datasus.authorization.configuration.properties.ApplicationProperties;

@Service
public class GoogleCaptchaIntegrationService {

	private static final String CAPTCHA_SUCCESS_KEY = "success";

	private static final String CAPTCHA_PARAM_VALIDATION = "g-recaptcha-response";

	@Autowired
	private ApplicationProperties.Security security;

	@SuppressWarnings("rawtypes")
	public boolean validarCaptcha(HttpServletRequest request, HttpServletResponse response) {
		String captchaValidationKey = request.getParameter(CAPTCHA_PARAM_VALIDATION);
		if (!StringUtils.isEmpty(captchaValidationKey)) {
			ResponseEntity<Map> entity = new RestTemplate().postForEntity(security.captchaVerifyUrl, new HashMap<>(),
					Map.class, security.captchaPrivateKey, captchaValidationKey);
			if (entity.getStatusCode().value() == HttpStatus.OK.value()
					&& ((Boolean) entity.getBody().get(CAPTCHA_SUCCESS_KEY))) {
				return true;
			}
		}
		return false;
	}

}
