package br.gov.datasus.scodes.controller;

import br.gov.datasus.scodes.model.dto.StatusAlteracaoDataRetornoDTO;
import br.gov.datasus.scodes.service.StatusAlteracaoDataRetornoService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@Api(tags = "StatusAlteracaoDataRetorno")
@RequestMapping(value = "/status-alteracao-data-retorno")
@RequiredArgsConstructor
@RestController
public class StatusAlteracaoDataRetornoController {

    private final StatusAlteracaoDataRetornoService service;

    @ApiOperation(value = "Obter todos status-alteracao-data-retorno")
    @GetMapping(produces = MediaType.APPLICATION_JSON_VALUE)
    public ResponseEntity<List<StatusAlteracaoDataRetornoDTO>> obterTodos() {
        List<StatusAlteracaoDataRetornoDTO> lista = service.obterTodos();
        return ResponseEntity.ok(lista);
    }
}
