package br.gov.datasus.scodes.model.constants;

public class AutorDemandaConstants {

    public  class QUERYNAME {
        public static final String BUSCAR_ATORES_DEMANDA = "buscarAutoresDemanda";

        private QUERYNAME() {}
    }

    public class QUERIES {
        public static final String BUSCAR_ATORES_DEMANDA = "SELECT DISTINCT " +
            "    0 codigoReciboOrdemProduto, " +
            "    aut.co_seq_autor codigoAutor, " +
            "    aut.no_nome nomeAutor, " +
            "    tdema.nu_protocolo numeroProtocolo, " +
            "    tdema.nu_processo  numeroProcesso, " +
            "    tud.co_seq_unidade_dispensadora codigoUnidadeDispensadora, " +
            "    tud.ds_unidade_dispensadora descricaoUnidadeDispensadora,  " +
            "    tdema.co_tipo_demanda codigoTipoDemanda, " +
            "    CASE tdema.co_tipo_demanda " +
            "        WHEN 0   THEN " +
            "            'Administrativa' " +
            "        WHEN 1   THEN " +
            "            'Judicial' " +
            "        WHEN 3   THEN " +
            "            'Comissão de Farmacologia' " +
            "        WHEN 4   THEN " +
            "            'Jefaz' " +
            "    END tipoDemanda, " +
            "    tdema.dt_entrada dataCadastro, " +
            "    trop.dt_data_retorno dataRetornoAnterior, " +
            "    trop.dt_data_retorno dataRetornoAtual, " +
            "    tad.co_seq_autor_demanda codigoAutorDemanda " +
            "FROM " +
            "    dbscodes.tb_autor_demanda  tad " +
            "    INNER JOIN dbscodes.tb_autor aut   ON aut.co_seq_autor = tad.co_autor " +
            "    INNER JOIN dbscodes.tb_demanda tdema   ON tdema.co_seq_demanda = tad.co_demanda " +
            "    INNER JOIN dbscodes.tb_ordem_dispensacao tod   ON tod.co_autor_demanda = tad.co_seq_autor_demanda " +
            "    INNER JOIN dbscodes.tb_ordem_produto torp  ON (torp.co_ordem_dispensacao = tod.co_seq_ordem_dispensacao AND torp.nu_ativo_atual = 1) " +
            "    INNER JOIN dbscodes.tb_unidade_dispensadora tud    ON tud.co_seq_unidade_dispensadora = tod.co_unidade_dispensadora " +
            "    INNER JOIN dbscodes.tb_status tst  ON tst.co_seq_status = tad.co_status AND tst.co_seq_status IN (1,4,5,7,8,10,17)  " +
            "    INNER JOIN dbscodes.tb_produto tpro    ON tpro.co_seq_produto = torp.co_produto " +
            "    INNER JOIN dbscodes.tb_recibo_ordem_produto trop   ON (trop.co_ordem_produto = torp.co_seq_ordem_produto) " +
            "    LEFT OUTER JOIN dbscodes.tb_recibo trec    ON (trec.co_seq_recibo = trop.co_recibo) " +
            "WHERE " +
            "    1 = 1 " +
            "    AND trec.st_situacao = 'V'";

        private QUERIES() {}
    }

    public class RESULTSET {
        public static final String BUSCAR_ATORES_DEMANDA = "buscarAutoresDemandaRs";
    }


}
