package br.gov.datasus.scodes.model.converter;

import br.gov.datasus.scodes.model.enums.TipoPlanoSaudeEnum;

import javax.persistence.AttributeConverter;
import javax.persistence.Converter;

@Converter
public class TipoPlanoSaudeEnumConverter implements AttributeConverter<TipoPlanoSaudeEnum, String> {

    @Override
    public String convertToDatabaseColumn(TipoPlanoSaudeEnum attribute) {
        if (attribute != null) {
            return attribute.getCodigo();
        }
        return null;
    }

    @Override
    public TipoPlanoSaudeEnum convertToEntityAttribute(String dbData) {
        if (TipoPlanoSaudeEnum.obterPorCodigo(dbData).isPresent()) {
            return TipoPlanoSaudeEnum.obterPorCodigo(dbData).get();
        }
        return null;
    }
}
