package br.gov.datasus.scodes.model.converter;

import java.util.Optional;

import javax.persistence.AttributeConverter;
import javax.persistence.Converter;

import br.gov.datasus.scodes.model.enums.TipoProcessoEnum;

@Converter
public class TipoProcessoEnumConverter implements AttributeConverter<TipoProcessoEnum, String>,
    org.springframework.core.convert.converter.Converter<String, TipoProcessoEnum> {

    @Override
    public String convertToDatabaseColumn(TipoProcessoEnum attribute) {
        return Optional.ofNullable(attribute)
            .map(TipoProcessoEnum::getId)
            .orElse(null);
    }

    @Override
    public TipoProcessoEnum convertToEntityAttribute(String dbData) {
        return Optional.ofNullable(dbData)
            .flatMap(TipoProcessoEnum::obterPorId)
            .orElse(null);
    }

    @Override
    public TipoProcessoEnum convert(String source) {
        return TipoProcessoEnum.obterPorId(source).orElse(null);
    }
}
