package br.gov.datasus.scodes.model.converter;

import java.util.Optional;

import javax.persistence.AttributeConverter;
import javax.persistence.Converter;

import br.gov.datasus.scodes.model.enums.TipoStatusProcessualEnum;

@Converter
public class TipoStatusProcessualEnumConverter implements AttributeConverter<TipoStatusProcessualEnum, String>,
    org.springframework.core.convert.converter.Converter<String, TipoStatusProcessualEnum> {

    @Override
    public String convertToDatabaseColumn(TipoStatusProcessualEnum attribute) {
        return Optional.ofNullable(attribute)
            .map(TipoStatusProcessualEnum::getId)
            .orElse(null);
    }

    @Override
    public TipoStatusProcessualEnum convertToEntityAttribute(String dbData) {
        return Optional.ofNullable(dbData)
            .flatMap(TipoStatusProcessualEnum::obterPorId)
            .orElse(null);
    }

    @Override
    public TipoStatusProcessualEnum convert(String source) {
        return TipoStatusProcessualEnum.obterPorId(source).orElse(null);
    }
}
