package br.gov.datasus.scodes.model.dto;

import lombok.*;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import java.io.Serializable;
import java.util.Date;

@Getter
@Setter
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class AlteracaoDataRetornoDTO implements Serializable  {

    private static final long serialVersionUID = 1L;

    private Long id;

    @DateTimeFormat(iso = DateTimeFormat.ISO.DATE)
    private Date dataCadastro;

    @NotNull
    @DateTimeFormat(iso = DateTimeFormat.ISO.DATE)
    private Date novaDataRetorno;

    @DateTimeFormat(iso = DateTimeFormat.ISO.DATE)
    private Date dataRetornoAnterior;

    @NotNull
    @Size(max = 100)
    private String titulo;

    private StatusAlteracaoDataRetornoDTO status;

}
