package br.gov.datasus.scodes.model.dto;

import java.io.File;
import java.io.Serializable;
import java.util.Date;

import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

import org.springframework.format.annotation.DateTimeFormat;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;

import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
public class ArquivoDTO implements Serializable {

    private static final long serialVersionUID = 1L;

    @JsonProperty(access = Access.READ_ONLY)
    private Long id;

    @NotNull
    private AutorDemandaDTO autorDemanda;

    @NotNull
    private DiretorioDTO diretorio;

    @DateTimeFormat(iso = DateTimeFormat.ISO.DATE_TIME)
    private Date dataInclusao;

    @DateTimeFormat(iso = DateTimeFormat.ISO.DATE_TIME)
    private Date dataProtocolo;

    @Size(max = 80)
    private String descricao;

    @Size(max = 80)
    private String extencao;

    private byte[] arquivo;

    private String arquivo64;

    //private File file;

}
