package br.gov.datasus.scodes.model.dto;

import java.io.Serializable;
import java.util.Date;

import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

import br.gov.datasus.scodes.model.enums.TipoSexoEnum;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.springframework.format.annotation.DateTimeFormat;

@Getter
@Setter
@NoArgsConstructor
public class AutorDTO implements Serializable {

    private static final long serialVersionUID = 1L;

    private Long id;

    @Size(max = 80)
    private String nome;

    @DateTimeFormat(iso = DateTimeFormat.ISO.DATE_TIME)
    private Date dataNascimento;

    private TipoSexoEnum sexo;

    @Size(max = 16)
    private String rg;

    @Size(max = 15)
    private String cpf;

    @Size(max = 20)
    private String cns;

    @Size(max = 80)
    private String nomeMae;

    @NotNull
    private CidadeDTO cidade;

    @Size(max = 20)
    private String telefone;

    @Size(max = 100)
    private String obsTelefone;

    @Size(max = 20)
    private String outroTelefone;

    @Size(max = 100)
    private String obsOutroTelefone;

    @Size(max = 9)
    private String cep;

    @Size(max = 60)
    private String bairro;

    @Size(max = 100)
    private String logradouro;

    @Size(max = 5)
    private String numero;

    @Size(max = 30)
    private String complemento;

    @Size(max = 80)
    private String email;

}
