package br.gov.datasus.scodes.model.dto;

import java.io.Serializable;
import java.util.Date;
import java.util.List;
import java.util.Set;

import javax.validation.Valid;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;

import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.springframework.format.annotation.DateTimeFormat;

@Getter
@Setter
@NoArgsConstructor
public class AutorDemandaDTO implements Serializable {

    private static final long serialVersionUID = 1L;

    private Long id;

    @NotNull
    private DemandaDTO demanda;

    private ProcessualDTO processual;

    @NotEmpty
    @Valid
    private Set<AutorDTO> autores;

    // TODO: verificar como é setado no back-end
    // @NotNull
    private Boolean atendido;

    @NotNull
    @DateTimeFormat(iso = DateTimeFormat.ISO.DATE_TIME)
    private Date dataEntrada;

    private StatusDTO status;


}
