package br.gov.datasus.scodes.model.dto;

import java.io.Serializable;
import java.util.Date;

import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

import org.springframework.format.annotation.DateTimeFormat;

import br.gov.datasus.scodes.model.enums.TipoProcessoEnum;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
public class DemandaDTO implements Serializable {

    private static final long serialVersionUID = 1L;

    private Long id;

    @NotNull
    private UnidadeOrganizacionalDTO unidadeOrganizacional;

    @NotNull
    @DateTimeFormat(iso = DateTimeFormat.ISO.DATE_TIME)
    private Date dataEntrada;

    private String protocolo;

    private String processo;

    @Size(max = 50)
    private String senhaProcesso;

    @NotNull
    private TipoDemandaDTO tipoDemanda;

    @NotNull
    private TipoProcessoEnum tipoProcesso;

    private RelatorioTecnicoDTO relatorioTecnico;

    private CidadeDTO cidade;

    @NotNull
    @DateTimeFormat(iso = DateTimeFormat.ISO.DATE_TIME)
    private Date dataInclusao;

    private PerfilModelDTO perfilModel;
}
