package br.gov.datasus.scodes.model.dto;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import java.util.Set;

import com.fasterxml.jackson.annotation.JsonProperty;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.*;

import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
public class ItemDTO implements Serializable {

    private static final long serialVersionUID = 1L;

    private Long id;

    @Size(max = 30)
    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    private String codigo;

    @NotNull
    private EspecificacaoDTO especificacao;

    private MarcaDTO marca;

    private NaturezaDespesaDTO naturezaDespesa;

    @NotNull
    private ProgramaDTO programa;

    @Size(max = 20)
    private String codigoSiafisico;

    @NotNull
    private TipoDispensacaoDTO tipoDispensacao;

    @NotNull
    private TipoItemDTO tipoItem;

    @Size(max = 500)
    private String observacao;

    @Size(max = 400)
    private String descricaoSiafisico;

    @DateTimeFormat(iso = DateTimeFormat.ISO.DATE_TIME)
    private Date dataImportado;

    @DateTimeFormat(iso = DateTimeFormat.ISO.DATE_TIME)
    private Date dataRevisadoSiafisico;

    private BigDecimal custo;

    @NotNull
    private Long minimoAlerta;

    @NotNull
    private Long minimoDispensacao;

    @NotNull
    private Boolean importado;

    private Set<TipoDemandaDTO> tipoDemandas;

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    private String descricao;
}
