package br.gov.datasus.scodes.model.dto;

import java.io.Serializable;
import java.util.List;

import javax.validation.Valid;
import javax.validation.constraints.*;

import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
public class PerfilDTO implements Serializable {

    private static final long serialVersionUID = 1L;

    private Long id;
    
    @NotNull
    @Size(max = 20)
    private String nome;
    
    @NotNull
    @Size(max = 50)
    private String descricao;

    @NotNull
    private Boolean situacaoAtivo;
    
    @NotNull
    private AreaDTO area;
    
    @NotNull
    private Boolean demandaAdministrativa;
    
    @NotNull
    private Boolean demandaJudicial;
    
    @Valid
    private List<PerfilFuncionalidadeDTO> perfilFuncionalidades;
}
