package br.gov.datasus.scodes.model.dto;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.validation.constraints.Email;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import java.io.Serializable;
import java.util.Date;
import java.util.Set;

@Getter
@Setter
@NoArgsConstructor
public class UsuarioDTO implements Serializable {

    private static final long serialVersionUID = 1L;

    private Long id;

    @NotNull
    @Size(max = 12)
    private String nomeLogin;

    @Size(min = 5, max = 32)
    @JsonProperty(access = JsonProperty.Access.WRITE_ONLY)
    private String descricaoSenha;

    @NotNull
    @Email
    @Size(max = 50)
    private String descricaoEmail;

    @NotNull
    private Boolean situacaoAtivo;

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    private Boolean situacaoTravado;

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    private Long numeroTentativas;

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    private String descricaoFaltaAcesso;

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    private Date dataCadastro;

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    private Date dataUltimoAcesso;

    @NotEmpty
    private Set<PerfilDTO> perfis;

    @JsonProperty(access = JsonProperty.Access.WRITE_ONLY)
    private Boolean senhaAutomatica;
}
