package br.gov.datasus.scodes.model.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQuery;
import javax.persistence.Table;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_CATEGORIA", schema = "DBSCODES")
@NamedQuery(name = Categoria.OBTER_TODOS_PAGINADO, query = "SELECT categoria FROM Categoria categoria")
@NamedQuery(name = Categoria.OBTER_DOMINIO, query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(categoria.id, categoria.nome) FROM Categoria categoria")
public class Categoria extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;
    public static final String OBTER_TODOS_PAGINADO = "Categoria.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "Categoria.obterDominio";

    public static final Long MEDICAMENTOS = 1L;
    public static final Long DIETAS_SUPLEMENTOS_NUTRICIONAIS = 2L;
    public static final Long MATERIAIS = 3L;
    public static final Long PROCEDIMENTOS = 4L;
    public static final Long NUTRICAO = 5L;
    public static final Long OUTROS = 6L;

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "CO_SEQ_CATEGORIA")
    private Long id;

    @Column(name = "NO_CATEGORIA", length = 50)
    private String nome;

}
