package br.gov.datasus.scodes.model.entity;

import javax.persistence.Entity;
import javax.persistence.GenerationType;
import javax.persistence.Column;
import javax.persistence.Table;
import javax.persistence.GeneratedValue;
import javax.persistence.SequenceGenerator;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.Setter;
import lombok.NoArgsConstructor;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_CLASSIFICACAO_COBRANCA", schema = "DBSCODES")
@NamedQueries({ 
    @NamedQuery(name = ClassificacaoCobranca.OBTER_TODOS_PAGINADO,
        query = "SELECT classificacaoCobranca " +
            "FROM ClassificacaoCobranca classificacaoCobranca " +
            "WHERE 1 = 1 " +
            "AND (UPPER(classificacaoCobranca.descricao) LIKE UPPER(:descricao))")
   ,@NamedQuery(name = ClassificacaoCobranca.OBTER_DOMINIO, query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(classificacaoCobranca.id, '') FROM ClassificacaoCobranca classificacaoCobranca")
})
public class ClassificacaoCobranca extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;
    public static final String OBTER_TODOS_PAGINADO = "ClassificacaoCobranca.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "ClassificacaoCobranca.obterDominio";

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_CLASSIFICACAO_COBRANCA")
    @SequenceGenerator(name = "SEQ_GENERATOR_CLASSIFICACAO_COBRANCA", sequenceName = "SQ_CLASSCOB_COSEQCLASSCOB", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_CLASSIFICACAO_COBRANCA")
    private Long id;

    @Column(name = "DS_CLASSIFICACAO_COBRANCA", length = 1)
    private String descricao;

}
