package br.gov.datasus.scodes.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_COMPRA_MODALIDADE", schema = "DBSCODES")
@NamedQuery(name = CompraModalidade.OBTER_TODOS_PAGINADO, query = "SELECT cm FROM CompraModalidade cm")
@NamedQuery(name = CompraModalidade.OBTER_DOMINIO, query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(cm.id, cm.descricao) FROM CompraModalidade cm ORDER BY cm.descricao ASC")
public class CompraModalidade extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;

    public static final String OBTER_TODOS_PAGINADO = "CompraModalidade.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "CompraModalidade.obterDominio";

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_COMPRA_MODALIDADE")
    @SequenceGenerator(name = "SEQ_GENERATOR_COMPRA_MODALIDADE", sequenceName = "SQ_COMPRMOD_COSEQCOMPRMOD", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_COMPRA_MODALIDADE", nullable = false)
    private Long id;

    @Column(name = "DS_COMPRA_MODALIDADE", length = 30, nullable = false)
    private String descricao;
}
