package br.gov.datasus.scodes.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_COMPRA_TROCA", schema = "DBSCODES")
public class CompraTroca extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_COMPRA_TROCA")
    @SequenceGenerator(name = "SEQ_GENERATOR_COMPRA_TROCA", sequenceName = "SQ_COMPRTROCA_COSEQCOMPRATROCA", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_COMPRA_TROCA", nullable = false)
    private Long id;

    @Column(name = "DS_NOTA_EMPENHO", length = 30, nullable = false)
    private String notaEmpenho;

    @Column(name = "DS_NOTA_FISCAL", length = 30)
    private String notaFiscal;

    @ManyToOne
    @JoinColumn(name = "CO_COMPRA_MODALIDADE")
    private CompraModalidade compraModalidade;

    @ManyToOne
    @JoinColumn(name = "CO_FORNECEDOR")
    private Fornecedor fornecedor;

}
