package br.gov.datasus.scodes.model.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import org.hibernate.annotations.Formula;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_DIRETORIO", schema = "DBSCODES")
public class Diretorio extends BaseEntity<Long> {

    private static final long serialVersionUID = 1l;

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_DIRETORIO")
    @SequenceGenerator(name = "SEQ_GENERATOR_DIRETORIO", sequenceName = "SQ_DIRETORIO_COSEQDIRETORIO", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_DIRETORIO")
    private Long id;

    @Column(name = "DS_DESCRICAO", length = 80)
    private String descricao;
    
    @Formula(value = "(SELECT COUNT(*) FROM DBSCODES.TB_ARQUIVO AR WHERE AR.CO_DIRETORIO = CO_SEQ_DIRETORIO)")
    private Long quantidadeArquivos;

}
