package br.gov.datasus.scodes.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_DOACAO", schema = "DBSCODES")
public class Doacao extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_DOACAO")
    @SequenceGenerator(name = "SEQ_GENERATOR_DOACAO", sequenceName = "SQ_DOACAO_COSEQDOACAO", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_DOACAO", nullable = false)
    private Long id;

    @Column(name = "DS_DOACAO", length = 100, nullable = false)
    private String descricao;

    @Column(name = "NU_CPF_CNPJ_DOACAO", length = 14, nullable = false)
    private String cpfCnpj;

}
