package br.gov.datasus.scodes.model.entity;

import javax.persistence.Entity;
import javax.persistence.GenerationType;
import javax.persistence.Column;
import javax.persistence.Table;
import javax.persistence.GeneratedValue;
import javax.persistence.SequenceGenerator;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.Setter;
import lombok.NoArgsConstructor;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_DRS", schema = "DBSCODES")
@NamedQueries({
    @NamedQuery(name = Drs.OBTER_TODOS_PAGINADO, query = "SELECT drs FROM Drs drs")
   ,@NamedQuery(name = Drs.OBTER_DOMINIO, query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(drs.id, drs.descricao) FROM Drs drs")
})
public class Drs extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;
    public static final String OBTER_TODOS_PAGINADO = "Drs.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "Drs.obterDominio";

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_DRS")
    @SequenceGenerator(name = "SEQ_GENERATOR_DRS", sequenceName = "SQ_DRS_COSEQDRS", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_DRS")
    private Long id;

    @Column(name = "DS_DRS", length = 80)
    private String descricao;

    @Column(name = "NU_DRS")
    private Long numero;

    @Column(name = "NU_ORDEM_DRS")
    private Long numeroOrdem;

}
