package br.gov.datasus.scodes.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_FABRICANTE", schema = "DBSCODES")
@NamedQuery(name = Fabricante.OBTER_TODOS_PAGINADO, query = "SELECT fa FROM Fabricante fa")
@NamedQuery(name = Fabricante.OBTER_DOMINIO, query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(fa.id, fa.nome || ' - ' || fa.cnpj) FROM Fabricante fa ORDER BY fa.nome ASC")
public class Fabricante extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;

    public static final String OBTER_TODOS_PAGINADO = "Fabricante.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "Fabricante.obterDominio";

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_FABRICANTE")
    @SequenceGenerator(name = "SEQ_GENERATOR_FABRICANTE", sequenceName = "SQ_FABRICANTE_COSEQFABRICANTE", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_FABRICANTE", nullable = false)
    private Long id;

    @Column(name = "NO_FABRICANTE", length = 100, nullable = false)
    private String nome;

    @Column(name = "NU_CNPJ", length = 14, nullable = false)
    private String cnpj;
}
