package br.gov.datasus.scodes.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_FORNECEDOR", schema = "DBSCODES")
@NamedQuery(name = Fornecedor.OBTER_TODOS_PAGINADO, query = "SELECT fo FROM Fornecedor fo")
@NamedQuery(name = Fornecedor.OBTER_DOMINIO, query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(fo.id, fo.nome || ' - ' || fo.cnpj) FROM Fornecedor fo ORDER BY fo.nome ASC")
public class Fornecedor extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;

    public static final String OBTER_TODOS_PAGINADO = "Fornecedor.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "Fornecedor.obterDominio";

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_FORNECEDOR")
    @SequenceGenerator(name = "SEQ_GENERATOR_FORNECEDOR", sequenceName = "SQ_FORNECEDOR_COSEQFORNECEDOR", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_FORNECEDOR", nullable = false)
    private Long id;

    @Column(name = "NO_FORNECEDOR", length = 100, nullable = false)
    private String nome;

    @Column(name = "NU_CNPJ", length = 14, nullable = false)
    private String cnpj;
}
