package br.gov.datasus.scodes.model.entity;

import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_GRUPO", schema = "DBSCODES")
@NamedQueries({
	@NamedQuery(name = Grupo.OBTER_TODOS_PAGINADO, query = "SELECT g FROM Grupo g WHERE 1=1"
			+ " AND (UPPER(g.nome) LIKE UPPER(:nome))"),
	@NamedQuery(name = Grupo.OBTER_DOMINIO, query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(g.id, g.nome) FROM Grupo g ORDER BY g.nome ASC")
})
public class Grupo extends BaseEntity<Long> {

	private static final long serialVersionUID = 1L;

	public static final String OBTER_TODOS_PAGINADO = "Grupo.obterTodosPaginado";
	public static final String OBTER_DOMINIO = "Grupo.obterDominio";

	@Id
	@GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_GRUPO")
	@SequenceGenerator(name = "SEQ_GENERATOR_GRUPO", sequenceName = "SQ_GRUPO_COSEQRUPO", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
	@Column(name = "CO_SEQ_GRUPO", nullable = false)
	private Long id;

	@Column(name = "NO_GRUPO", length = 20, nullable = false)
	private String nome;

	@Column(name = "DS_GRUPO", length = 50, nullable = false)
	private String descricao;

	@Column(name = "ST_ATIVO", nullable = false)
	private Boolean situacaoAtivo;

	@ManyToMany
	@JoinTable(name = "RL_PERFIL_GRUPO", schema = "DBSCODES",
		joinColumns = { @JoinColumn(name = "CO_GRUPO") },
		inverseJoinColumns = { @JoinColumn(name = "CO_PERFIL") })
	private Set<Perfil> perfis;
}
