package br.gov.datasus.scodes.model.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQuery;
import javax.persistence.Table;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_GRUPO_ESPECIFICACAO", schema = "DBSCODES")
@NamedQuery(name = GrupoEspecificacao.OBTER_TODOS_PAGINADO, query = "SELECT grupoEspecificacao FROM GrupoEspecificacao grupoEspecificacao")
@NamedQuery(
    name = GrupoEspecificacao.OBTER_DOMINIO,
    query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel("
        + "   grupoEspecificacao.id, "
        + "   grupoEspecificacao.codigoGrupoAnatomico || ' - ' || grupoEspecificacao.nome"
        + ") FROM GrupoEspecificacao grupoEspecificacao"
)

public class GrupoEspecificacao extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;
    public static final String OBTER_TODOS_PAGINADO = "GrupoEspecificacao.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "GrupoEspecificacao.obterDominio";

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "CO_SEQ_GRUPO_ESPECIFICACAO")
    private Long id;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "CO_CATEGORIA")
    private Categoria categoria;

    @Column(name = "CO_GRUPO_ANATOMICO", length = 1)
    private String codigoGrupoAnatomico;

    @Column(name = "NO_GRUPO_ESPECIFICACAO", length = 100)
    private String nome;

}
