package br.gov.datasus.scodes.model.entity.Id;

import br.gov.datasus.scodes.model.entity.Item;
import br.gov.datasus.scodes.model.entity.UnidadeDispensadora;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.Embeddable;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import java.io.Serializable;
import java.util.Objects;

@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor(staticName = "of")
@Embeddable
public class EstoqueAuxiliarId implements Serializable {

	private static final long serialVersionUID = 1L;

	@ManyToOne
	@JoinColumn(name = "CO_ITEM", nullable = false)
	private Item item;

	@ManyToOne
	@JoinColumn(name = "CO_UNIDADE_DISPENSADORA", nullable = false)
	private UnidadeDispensadora unidadeDispensadora;

	@Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof EstoqueAuxiliarId)) return false;
        EstoqueAuxiliarId that = (EstoqueAuxiliarId) o;
        return getItem().equals(that.getItem()) &&
            getUnidadeDispensadora().equals(that.getUnidadeDispensadora());
    }

	@Override
	public int hashCode() {
		return Objects.hash(getItem(), getUnidadeDispensadora());
	}

    public static EstoqueAuxiliarId of(Long idItem, Long idUnidadeDispensadora) {
	    Item item = new Item();
	    item.setId(idItem);
        UnidadeDispensadora unidadeDispensadora = new UnidadeDispensadora();
        unidadeDispensadora.setId(idUnidadeDispensadora);
	    return EstoqueAuxiliarId.of(item, unidadeDispensadora);
    }
}
