package br.gov.datasus.scodes.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_LOCAL_JEFAZ", schema = "DBSCODES")
@NamedQueries({
    @NamedQuery(name = LocalJefaz.OBTER_TODOS_PAGINADO, query = "SELECT localJefaz FROM LocalJefaz localJefaz WHERE 1=1 " +
        "AND (UPPER(localJefaz.descricao) LIKE UPPER(:descricao))")
   ,@NamedQuery(name = LocalJefaz.OBTER_DOMINIO, query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(localJefaz.id, localJefaz.descricao) FROM LocalJefaz localJefaz")
})
public class LocalJefaz extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;
    public static final String OBTER_TODOS_PAGINADO = "LocalJefaz.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "LocalJefaz.obterDominio";

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_LOCAL_JEFAZ")
    @SequenceGenerator(name = "SEQ_GENERATOR_LOCAL_JEFAZ", sequenceName = "SQ_LOCALJEFAZ_COSEQLOCALJEFAZ", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_LOCAL_JEFAZ")
    private Long id;

    @Column(name = "DS_LOCAL_JEFAZ", length = 50)
    private String descricao;

    @Column(name = "ST_ATIVO")
    private Boolean situacaoAtivo;

    @Column(name = "TP_LOCAL_JEFAZ", length = 1)
    private String tipo;

}
