package br.gov.datasus.scodes.model.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQuery;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_MARCA", schema = "DBSCODES")
@NamedQuery(name = Marca.OBTER_TODOS_PAGINADO, query = "SELECT marca FROM Marca marca")
@NamedQuery(name = Marca.OBTER_DOMINIO, query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(marca.id, marca.nome) FROM Marca marca")
public class Marca extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;
    public static final String OBTER_TODOS_PAGINADO = "Marca.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "Marca.obterDominio";

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_MARCA")
    @SequenceGenerator(name = "SEQ_GENERATOR_MARCA", sequenceName = "SQ_MARCA_COSEQMARCA", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_MARCA")
    private Long id;

    @Column(name = "NO_MARCA", length = 100)
    private String nome;

}
