package br.gov.datasus.scodes.model.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQuery;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_MODELO", schema = "DBSCODES")
@NamedQuery(
    name = Modelo.OBTER_TODOS_PAGINADO,
    query = ""
        + " SELECT modelo FROM Modelo modelo WHERE 1 = 1"
        + " AND (modelo.tipoModelo.id = :tipoModeloId) "
        + " AND (modelo.tipoDemanda.id = :tipoDemandaId) "
        + " AND (UPPER(modelo.descritor) LIKE UPPER(:descritor)) "
        + " AND (modelo.situacaoInativo = :situacaoInativo) "
)
public class Modelo extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;
    public static final String OBTER_TODOS_PAGINADO = "Modelo.obterTodosPaginado";

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_MODELO")
    @SequenceGenerator(name = "SEQ_GENERATOR_MODELO", sequenceName = "SQ_MODELO_COSEQMODELO", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_MODELO")
    private Long id;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "CO_TIPO_DEMANDA")
    private TipoDemanda tipoDemanda;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "CO_TIPO_MODELO")
    private TipoModelo tipoModelo;

    @Column(name = "DS_DESCRITOR", length = 80)
    private String descritor;

    @Column(name = "DS_MODELO")
    private String modelo;

    @Column(name = "ST_INATIVO")
    private Boolean situacaoInativo;

}
