package br.gov.datasus.scodes.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;
import java.util.Date;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_ORDEM_DISPENSACAO", schema = "DBSCODES")
public class OrdemDispensacao extends BaseEntity<Long>  {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_ORDEM_DISPENSACAO")
    @SequenceGenerator(name = "SEQ_ORDEM_DISPENSACAO", sequenceName = "SQ_ORDEMDISPENSA_COSEQORDEMDISPENSA", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_ORDEM_DISPENSACAO", nullable = false)
    private Long id;

    @Column(name = "DS_OBSERVACAO", length = 500)
    private String observacao;

    @Column(name = "DT_DATA_FALTA_ESTOQUE", nullable = false)
    @Temporal(TemporalType.DATE)
    private Date dataFaltaEstoque;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "CO_AUTOR_DEMANDA")
    private AutorDemanda autorDemanda;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "CO_UNIDADE_DISPENSADORA")
    private UnidadeDispensadora unidadeDispensadora;
}
