package br.gov.datasus.scodes.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;
import java.util.Date;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_RECIBO_ORDEM_PRODUTO", schema = "DBSCODES")
public class ReciboOrdemProduto extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_RECIBO_ORDEM_PRODUTO")
    @SequenceGenerator(name = "SEQ_RECIBO_ORDEM_PRODUTO", sequenceName = "SQ_RECORDPRO_COSEQRECORDPRO", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_RECIBO_ORDEM_PRODUTO", nullable = false)
    private Long id;

    @Column(name = "DT_DATA_RETORNO", nullable = false)
    @Temporal(TemporalType.DATE)
    private Date dataRetorno;

}
