package br.gov.datasus.scodes.model.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_RELATORIO_TECNICO", schema = "DBSCODES")
public class RelatorioTecnico extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_RELATORIO_TECNICO")
    @SequenceGenerator(name = "SEQ_GENERATOR_RELATORIO_TECNICO", sequenceName = "SQ_RELATORIO_TECNICO_COSEQRELATORIO_TECNICO", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_RELATORIO_TECNICO", nullable = false)
    private Long id;
    
    @Column(name = "DS_PERMANENTE")
    private String permanente;

    @Column(name = "DS_PROVISORIO")
    private String provisorio;

    @Column(name = "NU_PAGINA")
    private Integer numeroPagina;
    
    @ManyToOne
    @JoinColumn(name = "CO_AUTOR_DEMANDA", nullable = false)
    private AutorDemanda autorDemanda;

}
