package br.gov.datasus.scodes.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.AccessLevel;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;
import java.util.Date;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_SAIDA_ESTOQUE_ITEM", schema = "DBSCODES")
public class SaidaEstoqueItem extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_SAIDA_ESTOQUE_ITEM")
    @SequenceGenerator(name = "SEQ_GENERATOR_SAIDA_ESTOQUE_ITEM", sequenceName = "SQ_SAIDAESTOITEM_COSEQSAIDAESTOQUEITEM", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_SAIDA_ESTOQUE_ITEM", nullable = false)
    private Long id;

    @ManyToOne
    @JoinColumn(name = "CO_SAIDA_ESTOQUE", nullable = false)
    private SaidaEstoque saidaEstoque;

    @ManyToOne
    @JoinColumn(name = "CO_ITEM", nullable = false)
    private Item item;

    @ManyToOne
    @JoinColumn(name = "CO_UNIDADE_DISPENSADORA", nullable = false)
    private UnidadeDispensadora unidadeDispensadora;

    @Column(name = "DT_SAIDA_ITEM", nullable = false)
    @Temporal(TemporalType.TIMESTAMP)
    @Setter(AccessLevel.NONE)
    private Date dataSaidaItem;

    @Column(name = "QT_ITEM", nullable = false)
    private Long quantidade;

    @PrePersist
    public void prePersist() {
        this.dataSaidaItem = new Date();
    }

    public TipoMovimentacao getTipoMovimentacao() {
        return this.saidaEstoque != null ? this.saidaEstoque.getTipoMovimentacao() : null;
    }

}
