package br.gov.datasus.scodes.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_STATUS_ALTERACAO_DATA_RETORNO", schema = "DBSCODES")
@NamedQueries({
    @NamedQuery(name = StatusAlteracaoDataRetorno.OBTER_TODOS_PAGINADO, query = "SELECT sadr FROM StatusAlteracaoDataRetorno sadr"),
    @NamedQuery(name = StatusAlteracaoDataRetorno.OBTER_DOMINIO, query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(sadr.id, sadr.descricao) FROM StatusAlteracaoDataRetorno sadr")
})
public class StatusAlteracaoDataRetorno extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;
    public static final String OBTER_TODOS_PAGINADO = "StatusAlteracaoDataRetorno.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "StatusAlteracaoDataRetorno.obterDominio";

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_STATUS_ALT_DATA_RETORNO")
    @SequenceGenerator(name = "SEQ_GENERATOR_STATUS_ALT_DATA_RETORNO", sequenceName = "SQ_STATALTDTRT_COSQSTATALTDTRT", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_STATUS_ALT_DATA_RETORNO")
    private Long id;

    @Column(name = "DS_DESCRICAO", length = 20)
    private String descricao;

}
