package br.gov.datasus.scodes.model.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQuery;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_TIPO_ACAO", schema = "DBSCODES")
@NamedQuery(
    name = TipoAcao.OBTER_TODOS_PAGINADO,
    query = ""
        + " SELECT tipoAcao FROM TipoAcao tipoAcao WHERE 1 = 1"
        + " AND (UPPER(tipoAcao.descricao) LIKE UPPER(:descricao)) "
)
@NamedQuery(
    name = TipoAcao.OBTER_DOMINIO,
    query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(tipoAcao.id, tipoAcao.descricao) FROM TipoAcao tipoAcao"
)
public class TipoAcao extends BaseEntity<Long> {

    private static final long serialVersionUID = 1l;
    public static final String OBTER_TODOS_PAGINADO = "TipoAcao.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "TipoAcao.obterDominio";

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_TIPO_ACAO")
    @SequenceGenerator(name = "SEQ_GENERATOR_TIPO_ACAO", sequenceName = "SQ_TIPOACAO_COSEQTIPOACAO", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_TIPO_ACAO")
    private Long id;

    @Column(name = "DS_TIPO_ACAO", length = 50)
    private String descricao;

}
