package br.gov.datasus.scodes.model.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQuery;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_TIPO_DEMANDA", schema = "DBSCODES")
@NamedQuery(
    name = TipoDemanda.OBTER_TODOS_PAGINADO,
    query = "SELECT tipoDemanda FROM TipoDemanda tipoDemanda"
)
@NamedQuery(
    name = TipoDemanda.OBTER_DOMINIO,
    query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(tipoDemanda.id, tipoDemanda.descricao) FROM TipoDemanda tipoDemanda"
)
public class TipoDemanda extends BaseEntity<Long> {

    private static final long serialVersionUID = 1l;
    public static final String OBTER_TODOS_PAGINADO = "TipoDemanda.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "TipoDemanda.obterDominio";

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_TIPO_DEMANDA")
    @SequenceGenerator(name = "SEQ_GENERATOR_TIPO_DEMANDA", sequenceName = "SQ_TIPODEMANDA_COSEQTIPODEM", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_TIPO_DEMANDA")
    private Long id;

    @Column(name = "DS_TIPO_DEMANDA", length = 50)
    private String descricao;

}
