package br.gov.datasus.scodes.model.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQuery;
import javax.persistence.Table;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_TIPO_ITEM", schema = "DBSCODES")
@NamedQuery(name = TipoItem.OBTER_TODOS_PAGINADO, query = "SELECT tipoItem FROM TipoItem tipoItem")
@NamedQuery(name = TipoItem.OBTER_DOMINIO, query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(tipoItem.id, tipoItem.nome) FROM TipoItem tipoItem")
public class TipoItem extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;
    public static final String OBTER_TODOS_PAGINADO = "TipoItem.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "TipoItem.obterDominio";

    public static final Long SEM_MARCA = 1L;
    public static final Long MANIPULADO = 2L;
    public static final Long HOMEOPATICO = 3L;
    public static final Long MARCA = 4L;

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "CO_SEQ_TIPO_ITEM")
    private Long id;

    @Column(name = "NO_TIPO_ITEM", length = 50)
    private String nome;

}
