package br.gov.datasus.scodes.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_UNIDADE_DISPENSADORA", schema = "DBSCODES")
@NamedQueries({
    @NamedQuery(name = UnidadeDispensadora.OBTER_TODOS_PAGINADO, query = "SELECT unidadeDispensadora FROM UnidadeDispensadora unidadeDispensadora")
   ,@NamedQuery(name = UnidadeDispensadora.OBTER_DOMINIO, query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(unidadeDispensadora.id, unidadeDispensadora.descricao) FROM UnidadeDispensadora unidadeDispensadora")
})
public class UnidadeDispensadora extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;
    public static final String OBTER_TODOS_PAGINADO = "UnidadeDispensadora.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "UnidadeDispensadora.obterDominio";

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_UNIDADE_DISPENSADORA")
    @SequenceGenerator(name = "SEQ_GENERATOR_UNIDADE_DISPENSADORA", sequenceName = "SQ_UNIDDISPENSA_COSEQUNIDDISPENSA", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_UNIDADE_DISPENSADORA")
    private Long id;

    @Column(name = "DS_UNIDADE_DISPENSADORA", length = 80)
    private String descricao;

    @Column(name = "NU_CAPACIDADE")
    private Long numeroCapacidade;

    @Column(name = "ST_ESTOQUE")
    private Boolean situacaoEstoque;

    @Column(name = "ST_LOCALIDADE", length = 1)
    private String situacaoLocalidade;

    @Column(name = "ST_STATUS")
    private Boolean situacaoStatus;

}
