package br.gov.datasus.scodes.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_UNIDADE_ORGANIZACIONAL", schema = "DBSCODES")
@NamedQueries({
    @NamedQuery(name = UnidadeOrganizacional.OBTER_TODOS_PAGINADO, query = "SELECT unidadeOrganizacional FROM UnidadeOrganizacional unidadeOrganizacional")
   ,@NamedQuery(name = UnidadeOrganizacional.OBTER_DOMINIO, query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(unidadeOrganizacional.id, unidadeOrganizacional.descricao) FROM UnidadeOrganizacional unidadeOrganizacional")
})
public class UnidadeOrganizacional extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;
    public static final String OBTER_TODOS_PAGINADO = "UnidadeOrganizacional.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "UnidadeOrganizacional.obterDominio";

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_UNIDADE_ORGANIZACIONAL")
    @SequenceGenerator(name = "SEQ_GENERATOR_UNIDADE_ORGANIZACIONAL", sequenceName = "SQ_UNIDORGANIZA_COSEQUNIDORGANIZA", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_UNIDADE_ORGANIZACIONAL")
    private Long id;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "CO_CIDADE")
    private Cidade cidade;

    @Column(name = "CO_SESSP")
    private Long idSessp;

    @Column(name = "CO_UNIDADE_ORGANIZACIONAL_PAI")
    private Long idPai;

    @Column(name = "DS_BAIRRO", length = 30)
    private String descricaoBairro;

    @Column(name = "DS_CEP", length = 10)
    private String descricaoCep;

    @Column(name = "DS_COMPLEMENTO", length = 30)
    private String descricaoComplemento;

    @Column(name = "DS_EMAIL", length = 80)
    private String descricaoEmail;

    @Column(name = "DS_EMAIL_ADM", length = 80)
    private String descricaoEmailAdm;

    @Column(name = "DS_LOGRADOURO", length = 100)
    private String descricaoLogradouro;

    @Column(name = "DS_NUMERO", length = 5)
    private String descricaoNumero;

    @Column(name = "DS_UNIDADE_ORGANIZACIONAL", length = 50)
    private String descricao;

    @Column(name = "NO_REMETENTE", length = 80)
    private String nomeRemetente;

    @Column(name = "ST_STATUS")
    private Boolean situacaoStatus;

    @Column(name = "ST_TELEGRAMA")
    private Boolean situacaoTelegrama;

}
