package br.gov.datasus.scodes.model.entity;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_UNIDADE_TRANSFERENCIA", schema = "DBSCODES")
@NamedQuery(
    name = UnidadeTransferencia.OBTER_TODOS_PAGINADO,
    query = "SELECT ut FROM UnidadeTransferencia ut" +
        " WHERE 1=1" +
        " AND (UPPER(ut.descricao) LIKE UPPER(:descricao))")
@NamedQuery(name = UnidadeTransferencia.OBTER_DOMINIO, query = "SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(ut.id, ut.descricao) FROM UnidadeTransferencia ut ORDER BY ut.descricao ASC")
public class UnidadeTransferencia extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;
    public static final String OBTER_TODOS_PAGINADO = "UnidadeTransferencia.obterTodosPaginado";
    public static final String OBTER_DOMINIO = "UnidadeTransferencia.obterDominio";

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_UNIDADE_TRANSFERENCIA")
    @SequenceGenerator(name = "SEQ_GENERATOR_UNIDADE_TRANSFERENCIA", sequenceName = "SQ_UNIDTRANSF_COSEQUNIDTRANSF", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_UNIDADE_TRANSFERENCIA", nullable = false)
    private Long id;

    @Column(name = "DS_UNIDADE_TRANSFERENCIA", length = 100, nullable = false)
    private String descricao;

}
