package br.gov.datasus.scodes.model.entity;

import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;
import java.util.Set;

@Getter
@Setter
@NoArgsConstructor
@Entity
@PrimaryKeyJoinColumn(name = "CO_USUARIO")
@Table(name = "TB_USUARIO_LOCAL", schema = "DBSCODES")
@NamedQuery(name = UsuarioLocal.OBTER_TODOS_PAGINADO, query = "SELECT ul FROM UsuarioLocal ul " +
    "WHERE 1=1 " +
    "AND (UPPER(ul.nomeLogin) LIKE UPPER(:nomeLogin))" +
    "AND (UPPER(ul.nomeUsuario) LIKE UPPER(:nomeLogin))"
)
public class UsuarioLocal extends Usuario {

    private static final long serialVersionUID = 1L;

    public static final String OBTER_TODOS_PAGINADO = "UsuarioLocal.obterTodosPaginado";

    @Column(name = "NO_USUARIO", length = 100)
    private String nomeUsuario;

    @Column(name = "NU_TELEFONE", length = 15)
    private String numeroTelefone;

    @ManyToOne
    @JoinColumn(name = "CO_TIPO_PROFISSAO")
    private TipoProfissao tipoProfissao;

    @Column(name = "NU_CONSELHO", length = 15)
    private String numeroConselho;

    @ManyToOne
    @JoinColumn(name = "CO_UNIDADE_ORGANIZACIONAL")
    private UnidadeOrganizacional unidadeOrganizacional;

    @ManyToMany
    @JoinTable(name = "RL_USUARIO_UNID_DISPENSADORA", schema = "DBSCODES",
        joinColumns = {@JoinColumn(name = "CO_USUARIO")},
        inverseJoinColumns = {@JoinColumn(name = "CO_UNIDADE_DISPENSADORA")
    })
    private Set<UnidadeDispensadora> unidadesDispensadoras;

    @ManyToOne
    @JoinColumn(name = "CO_PERFIL")
    private Perfil perfil;

}
