package br.gov.datasus.scodes.model.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQuery;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import br.gov.datasus.api.core.model.entity.BaseEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@Entity
@Table(name = "TB_VARA", schema = "DBSCODES")
@NamedQuery(
    name = Vara.OBTER_TODOS_PAGINADO,
    query = ""
        + " SELECT vara FROM Vara vara WHERE 1 = 1"
        + " AND (UPPER(vara.descricao) LIKE UPPER(:descricao)) "
        + " AND (vara.cidade.id = :cidadeId) "
)
@NamedQuery(
    name = Vara.PESQUISAR_TIPO_VARA_E_POR_NOME_CIDADE,
    query = " SELECT vara FROM Vara vara"
        + " WHERE 1 = 1 "
        + " AND (vara.cidade.id = :cidadeId) "
        + " AND (UPPER(vara.cidade.descricao) LIKE UPPER(:nome)) "
)
public class Vara extends BaseEntity<Long> {

    private static final long serialVersionUID = 1L;
    public static final String OBTER_TODOS_PAGINADO = "Vara.obterTodosPaginado";
    public static final String PESQUISAR_TIPO_VARA_E_POR_NOME_CIDADE = "Vara.pesquisarTipoVaraEVaraPorNomeCidade";

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "SEQ_GENERATOR_VARA")
    @SequenceGenerator(name = "SEQ_GENERATOR_VARA", sequenceName = "SQ_VARA_COSEQVARA", initialValue = 1, allocationSize = 1, schema = "DBSCODES")
    @Column(name = "CO_SEQ_VARA", nullable = false)
    private Long id;

    @ManyToOne
    @JoinColumn(name = "CO_TIPO_VARA", nullable = false)
    private TipoVara tipoVara;

    @Column(name = "DS_DESCRICAO", length = 100, nullable = false)
    private String descricao;

    @ManyToOne
    @JoinColumn(name = "CO_CIDADE", nullable = false)
    private Cidade cidade;

    @Column(name = "NO_FORUM", length = 100)
    private String forum;

    @Column(name = "NU_TELEFONE", length = 15)
    private String telefone;

    @Column(name = "NU_CEP", length = 15)
    private String cep;

    @Column(name = "DS_BAIRRO", length = 25)
    private String bairro;

    @Column(name = "DS_ENDERECO", length = 100)
    private String endereco;

}
