package br.gov.datasus.scodes.model.enums;

import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import java.util.stream.Stream;

import com.fasterxml.jackson.annotation.JsonValue;

import lombok.Getter;

public enum TipoDemandaEnum {
    ADMINISTRATIVA (1, "Administrativa"),
    JUDICIAL (2, "Judicial"),
    JEFAZ (3, "Jefaz"),
    COMISSÃO_FARMACOLOGIA (4, "Comissão de Farmacologia");
    
    private TipoDemandaEnum(Integer codigo, String descricao) {
        this.codigo = codigo;
        this.descricao = descricao;
    }

    @JsonValue
    @Getter
    private Integer codigo;

    @Getter
    private String descricao;
    
    @Override
    public String toString() {
        return this.descricao;
    }

    public static Optional<TipoDemandaEnum> obterPorCodigo(final Integer codigo) {
        return TipoDemandaEnum.stream().filter(e -> e.getCodigo().equals(codigo)).findFirst();
    }

    public static Optional<TipoDemandaEnum> obterPorDescricao(final String descricao) {
        return TipoDemandaEnum.stream().filter(e -> e.getDescricao().equals(descricao)).findFirst();
    }

    public static Stream<TipoDemandaEnum> stream() {
        return Stream.of(TipoDemandaEnum.values());
    }

    public static List<TipoDemandaEnum> list() {
        return Arrays.asList(TipoDemandaEnum.values());
    }
}
