package br.gov.datasus.scodes.model.mapper;

import java.util.List;

import org.mapstruct.*;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;
import br.gov.datasus.scodes.model.dto.AcessoDTO;
import br.gov.datasus.scodes.model.entity.Acesso;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface AcessoMapper extends BaseMapper<Acesso, AcessoDTO> {

	@Mappings({
		@Mapping(source = "usuarioLocal.id", target="idUsuario"),
		@Mapping(source = "usuarioLocal.nomeLogin", target="nomeLogin"),
		@Mapping(source = "usuarioLocal.nomeUsuario", target="nomeUsuario")
	})
	AcessoDTO toDto(Acesso entity);

	List<AcessoDTO> toDto(List<Acesso> entities);

	List<AcessoDTO> toDto(Iterable<Acesso> entities);

	PageableResponseModel<AcessoDTO> toDtoPageableResponse(PageableResponseModel<Acesso> pageableResponseModel);

	Acesso toEntity(AcessoDTO dto);

	List<Acesso> toEntity(List<AcessoDTO> dtos);

	@InheritInverseConfiguration(name = "toDto")
	void fromDto(AcessoDTO dto, @MappingTarget Acesso entity);
}
