package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;
import br.gov.datasus.scodes.model.dto.*;
import br.gov.datasus.scodes.model.entity.*;
import org.mapstruct.*;

import java.util.List;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface AlteracaoDataRetornoMapper extends BaseMapper<AlteracaoDataRetorno, AlteracaoDataRetornoDTO>  {

    AlteracaoDataRetornoDTO toDto(AlteracaoDataRetorno entity);

    List<AlteracaoDataRetornoDTO> toDto(List<AlteracaoDataRetorno> entities);

    List<AlteracaoDataRetornoDTO> toDto(Iterable<AlteracaoDataRetorno> entities);

    PageableResponseModel<AlteracaoDataRetornoDTO> toDtoPageableResponse(PageableResponseModel<AlteracaoDataRetorno> pageableResponseModel);

    AlteracaoDataRetorno toEntity(AlteracaoDataRetornoDTO dto);

    List<AlteracaoDataRetorno> toEntity(List<AlteracaoDataRetornoDTO> dtos);

    StatusAlteracaoDataRetorno toEntity(StatusAlteracaoDataRetornoDTO dto);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(AlteracaoDataRetornoDTO dto, @MappingTarget AlteracaoDataRetorno entity);

}
