package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;
import br.gov.datasus.scodes.model.dto.AlteracaoDataRetornoDTO;
import br.gov.datasus.scodes.model.dto.AlteracaoDataRetornoProdutoDTO;
import br.gov.datasus.scodes.model.entity.AlteracaoDataRetorno;
import br.gov.datasus.scodes.model.entity.AlteracaoDataRetornoProduto;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.ReportingPolicy;

import java.util.List;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface AlteracaoDataRetornoProdutoMapper extends BaseMapper<AlteracaoDataRetornoProduto, AlteracaoDataRetornoProdutoDTO> {

    AlteracaoDataRetornoProdutoDTO toDto(AlteracaoDataRetornoProduto entity);

    List<AlteracaoDataRetornoProdutoDTO> toDto(List<AlteracaoDataRetornoProduto> entities);

    List<AlteracaoDataRetornoProdutoDTO> toDto(Iterable<AlteracaoDataRetornoProduto> entities);

    PageableResponseModel<AlteracaoDataRetornoProdutoDTO> toDtoPageableResponse(PageableResponseModel<AlteracaoDataRetornoProduto> pageableResponseModel);

    AlteracaoDataRetornoProduto toEntity(AlteracaoDataRetornoProdutoDTO dto);

    List<AlteracaoDataRetornoProduto> toEntity(List<AlteracaoDataRetornoProdutoDTO> dtos);

    AlteracaoDataRetorno toEntity(AlteracaoDataRetornoDTO dto);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(AlteracaoDataRetornoProdutoDTO dto, @MappingTarget AlteracaoDataRetornoProduto entity);

}
