package br.gov.datasus.scodes.model.mapper;

import java.util.List;

import org.mapstruct.*;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;
import br.gov.datasus.scodes.model.dto.AreaDTO;
import br.gov.datasus.scodes.model.entity.Area;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface AreaMapper extends BaseMapper<Area, AreaDTO> {

	AreaDTO toDto(Area entity);

	List<AreaDTO> toDto(List<Area> entities);

	List<AreaDTO> toDto(Iterable<Area> entities);

	PageableResponseModel<AreaDTO> toDtoPageableResponse(PageableResponseModel<Area> pageableResponseModel);

	Area toEntity(AreaDTO dto);

	List<Area> toEntity(List<AreaDTO> dtos);
	
	@InheritInverseConfiguration(name = "toDto")
	void fromDto(AreaDTO dto, @MappingTarget Area entity);
}
