package br.gov.datasus.scodes.model.mapper;

import java.util.List;

import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.ReportingPolicy;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.scodes.model.dto.ArquivoDTO;
import br.gov.datasus.scodes.model.dto.AutorDemandaDTO;
import br.gov.datasus.scodes.model.dto.DemandaDTO;
import br.gov.datasus.scodes.model.entity.Arquivo;
import br.gov.datasus.scodes.model.entity.AutorDemanda;
import br.gov.datasus.scodes.model.entity.Demanda;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface ArquivoMapper extends BaseMapper<Arquivo, ArquivoDTO> {

    ArquivoDTO toDto(Arquivo entity);

    List<ArquivoDTO> toDto(List<Arquivo> entities);

    List<ArquivoDTO> toDto(Iterable<Arquivo> entities);

    Demanda toEntity(DemandaDTO dto);

    List<Arquivo> toEntity(List<ArquivoDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(ArquivoDTO dto, @MappingTarget Arquivo entity);

    AutorDemandaDTO autorDemandaToDto(AutorDemanda entity);

    AutorDemanda autorDemandaToEntity(AutorDemandaDTO dto);

}
