package br.gov.datasus.scodes.model.mapper;

import java.util.List;

import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.ReportingPolicy;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;
import br.gov.datasus.scodes.model.dto.AutorDTO;
import br.gov.datasus.scodes.model.dto.CidadeDTO;
import br.gov.datasus.scodes.model.entity.Autor;
import br.gov.datasus.scodes.model.entity.Cidade;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface AutorMapper extends BaseMapper<Autor, AutorDTO> {

    AutorDTO toDto(Autor entity);

    List<AutorDTO> toDto(List<Autor> entities);

    List<AutorDTO> toDto(Iterable<Autor> entities);

    PageableResponseModel<AutorDTO> toDtoPageableResponse(PageableResponseModel<Autor> pageableResponseModel);

    Autor toEntity(AutorDTO dto);

    List<Autor> toEntity(List<AutorDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(AutorDTO dto, @MappingTarget Autor entity);
    
    CidadeDTO cidadeToDto(Cidade entity);
    
    Cidade cidadeToDto(CidadeDTO entity);
}
