package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.scodes.model.entity.Categoria;
import br.gov.datasus.scodes.model.dto.CategoriaDTO;
import java.util.List;
import org.mapstruct.MappingTarget;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.ReportingPolicy;
import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface CategoriaMapper extends BaseMapper<Categoria, CategoriaDTO> {

    CategoriaDTO toDto(Categoria entity);

    List<CategoriaDTO> toDto(List<Categoria> entities);

    List<CategoriaDTO> toDto(Iterable<Categoria> entities);

    PageableResponseModel<CategoriaDTO> toDtoPageableResponse(PageableResponseModel<Categoria> pageableResponseModel);

    Categoria toEntity(CategoriaDTO dto);

    List<Categoria> toEntity(List<CategoriaDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(CategoriaDTO dto, @MappingTarget Categoria entity);
}
