package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

import br.gov.datasus.scodes.model.dto.ApresentacaoDTO;
import br.gov.datasus.scodes.model.dto.EspecificacaoDTO;
import br.gov.datasus.scodes.model.dto.GrupoEspecificacaoDTO;
import br.gov.datasus.scodes.model.dto.ProdutoDTO;
import br.gov.datasus.scodes.model.entity.Apresentacao;
import br.gov.datasus.scodes.model.entity.Especificacao;
import br.gov.datasus.scodes.model.entity.GrupoEspecificacao;
import br.gov.datasus.scodes.model.entity.Produto;

import org.mapstruct.*;

import java.util.List;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface EspecificacaoMapper extends BaseMapper<Especificacao, EspecificacaoDTO> {

    EspecificacaoDTO toDto(Especificacao entity);

    List<EspecificacaoDTO> toDto(List<Especificacao> entities);

    List<EspecificacaoDTO> toDto(Iterable<Especificacao> entities);

    PageableResponseModel<EspecificacaoDTO> toDtoPageableResponse(PageableResponseModel<Especificacao> pageableResponseModel);

    @InheritInverseConfiguration
    Especificacao toEntity(EspecificacaoDTO dto);

    List<Especificacao> toEntity(List<EspecificacaoDTO> dtos);

    @InheritConfiguration
    void fromDto(EspecificacaoDTO dto, @MappingTarget Especificacao entity);

    ApresentacaoDTO apresentacaoToDto(Apresentacao entity);

    Apresentacao apresentacaoToEntity(ApresentacaoDTO dto);

    GrupoEspecificacaoDTO grupoEspecificacaoToDto(GrupoEspecificacao entity);

    GrupoEspecificacao grupoEspecificacaoToEntity(GrupoEspecificacaoDTO dto);

    ProdutoDTO produtoToDto(Produto entity);

    Produto produtoToEntity(ProdutoDTO dto);
}
