package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;
import br.gov.datasus.scodes.model.dto.EstoqueAuxiliarDTO;
import br.gov.datasus.scodes.model.entity.EstoqueAuxiliar;
import org.mapstruct.*;

import java.util.List;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface EstoqueAuxiliarMapper extends BaseMapper<EstoqueAuxiliar, EstoqueAuxiliarDTO> {

    @Mappings({
        @Mapping(source = "id.item.id", target = "idItem"),
        @Mapping(source = "id.unidadeDispensadora.id", target = "idUnidadeDispensadora"),
    })
	EstoqueAuxiliarDTO toDto(EstoqueAuxiliar entity);

	List<EstoqueAuxiliarDTO> toDto(List<EstoqueAuxiliar> entities);

	List<EstoqueAuxiliarDTO> toDto(Iterable<EstoqueAuxiliar> entities);

	PageableResponseModel<EstoqueAuxiliarDTO> toDtoPageableResponse(PageableResponseModel<EstoqueAuxiliar> pageableResponseModel);

    @InheritInverseConfiguration
    @Mappings({
        @Mapping(target = "dataAtualizacao", ignore = true),
    })
	EstoqueAuxiliar toEntity(EstoqueAuxiliarDTO dto);

	List<EstoqueAuxiliar> toEntity(List<EstoqueAuxiliarDTO> dtos);

    @InheritConfiguration
	void fromDto(EstoqueAuxiliarDTO dto, @MappingTarget EstoqueAuxiliar entity);
}
