package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;
import br.gov.datasus.scodes.model.dto.FabricanteDTO;
import br.gov.datasus.scodes.model.entity.Fabricante;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.ReportingPolicy;

import java.util.List;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface FabricanteMapper extends BaseMapper<Fabricante, FabricanteDTO> {

	FabricanteDTO toDto(Fabricante entity);

	List<FabricanteDTO> toDto(List<Fabricante> entities);

	List<FabricanteDTO> toDto(Iterable<Fabricante> entities);

	PageableResponseModel<FabricanteDTO> toDtoPageableResponse(PageableResponseModel<Fabricante> pageableResponseModel);

	Fabricante toEntity(FabricanteDTO dto);

	List<Fabricante> toEntity(List<FabricanteDTO> dtos);
	
	@InheritInverseConfiguration(name = "toDto")
	void fromDto(FabricanteDTO dto, @MappingTarget Fabricante entity);
}
