package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;
import br.gov.datasus.scodes.model.dto.*;
import br.gov.datasus.scodes.model.entity.*;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.ReportingPolicy;

import java.util.List;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface FeriadoMapper extends BaseMapper<Feriado, FeriadoDTO> {

    FeriadoDTO toDto(Feriado entity);

    List<FeriadoDTO> toDto(List<Feriado> entities);

    List<FeriadoDTO> toDto(Iterable<Feriado> entities);

    PageableResponseModel<FeriadoDTO> toDtoPageableResponse(PageableResponseModel<Feriado> pageableResponseModel);

    Feriado toEntity(FeriadoDTO dto);

    List<Feriado> toEntity(List<FeriadoDTO> dtos);

    UnidadeDispensadora toEntity(UnidadeDispensadoraDTO dto);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(FeriadoDTO dto, @MappingTarget Feriado entity);
}
