package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.scodes.model.entity.GrupoEspecificacao;
import br.gov.datasus.scodes.model.dto.GrupoEspecificacaoDTO;
import java.util.List;
import org.mapstruct.MappingTarget;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.ReportingPolicy;
import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface GrupoEspecificacaoMapper extends BaseMapper<GrupoEspecificacao, GrupoEspecificacaoDTO> {

    GrupoEspecificacaoDTO toDto(GrupoEspecificacao entity);

    List<GrupoEspecificacaoDTO> toDto(List<GrupoEspecificacao> entities);

    List<GrupoEspecificacaoDTO> toDto(Iterable<GrupoEspecificacao> entities);

    PageableResponseModel<GrupoEspecificacaoDTO> toDtoPageableResponse(PageableResponseModel<GrupoEspecificacao> pageableResponseModel);

    GrupoEspecificacao toEntity(GrupoEspecificacaoDTO dto);

    List<GrupoEspecificacao> toEntity(List<GrupoEspecificacaoDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(GrupoEspecificacaoDTO dto, @MappingTarget GrupoEspecificacao entity);
}
