package br.gov.datasus.scodes.model.mapper;

import java.util.List;

import org.mapstruct.*;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;
import br.gov.datasus.scodes.model.dto.GrupoDTO;
import br.gov.datasus.scodes.model.entity.Grupo;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface GrupoMapper extends BaseMapper<Grupo, GrupoDTO> {

	GrupoDTO toDto(Grupo entity);

	@IterableMapping(qualifiedByName = "toDtoWithoutPerfis")
	List<GrupoDTO> toDto(List<Grupo> entities);

	@IterableMapping(qualifiedByName = "toDtoWithoutPerfis")
	List<GrupoDTO> toDto(Iterable<Grupo> entities);

	@IterableMapping(qualifiedByName = "toDtoWithoutPerfis")
	PageableResponseModel<GrupoDTO> toDtoPageableResponse(PageableResponseModel<Grupo> pageableResponseModel);

	Grupo toEntity(GrupoDTO dto);

	List<Grupo> toEntity(List<GrupoDTO> dtos);

	@InheritInverseConfiguration(name = "toDto")
	void fromDto(GrupoDTO dto, @MappingTarget Grupo entity);

	@Named("toDtoWithoutPerfis")
	@Mapping(target = "perfis", ignore = true)
	GrupoDTO toDtoWithoutPerfis(Grupo entity);
}
