package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;
import br.gov.datasus.scodes.model.dto.*;
import br.gov.datasus.scodes.model.entity.*;
import org.mapstruct.*;

import java.util.List;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE, uses = InventarioItemMapper.class)
public interface InventarioMapper extends BaseMapper<Inventario, InventarioDTO> {

    @Mappings({
        @Mapping(source = "usuario.id", target = "idUsuario"),
    })
	InventarioDTO toDto(Inventario entity);

	List<InventarioDTO> toDto(List<Inventario> entities);

	List<InventarioDTO> toDto(Iterable<Inventario> entities);

	PageableResponseModel<InventarioDTO> toDtoPageableResponse(PageableResponseModel<Inventario> pageableResponseModel);

    @InheritInverseConfiguration
	Inventario toEntity(InventarioDTO dto);

	List<Inventario> toEntity(List<InventarioDTO> dtos);

    @InheritConfiguration
    @Mappings({
        @Mapping(target = "descricao", ignore = true),
        @Mapping(target = "dataCadastro", ignore = true),
        @Mapping(target = "usuario", ignore = true),
        @Mapping(target = "situacaoAtivo", ignore = true),
    })
	void fromDto(InventarioDTO dto, @MappingTarget Inventario entity);

    UnidadeDispensadoraDTO unidadeDispensadoraToDto(UnidadeDispensadora entity);

    UnidadeDispensadora unidadeDispensadoraToEntity(UnidadeDispensadoraDTO dto);
}
