package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.scodes.model.entity.LocalJefaz;
import br.gov.datasus.scodes.model.dto.LocalJefazDTO;
import java.util.List;
import org.mapstruct.MappingTarget;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.ReportingPolicy;
import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface LocalJefazMapper extends BaseMapper<LocalJefaz, LocalJefazDTO> {

    LocalJefazDTO toDto(LocalJefaz entity);

    List<LocalJefazDTO> toDto(List<LocalJefaz> entities);

    List<LocalJefazDTO> toDto(Iterable<LocalJefaz> entities);

    PageableResponseModel<LocalJefazDTO> toDtoPageableResponse(PageableResponseModel<LocalJefaz> pageableResponseModel);

    LocalJefaz toEntity(LocalJefazDTO dto);

    List<LocalJefaz> toEntity(List<LocalJefazDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(LocalJefazDTO dto, @MappingTarget LocalJefaz entity);
}
