package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.scodes.model.dto.MarcaDTO;
import br.gov.datasus.scodes.model.entity.Marca;
import java.util.List;
import org.mapstruct.MappingTarget;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.ReportingPolicy;
import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface MarcaMapper extends BaseMapper<Marca, MarcaDTO> {

    MarcaDTO toDto(Marca entity);

    List<MarcaDTO> toDto(List<Marca> entities);

    List<MarcaDTO> toDto(Iterable<Marca> entities);

    PageableResponseModel<MarcaDTO> toDtoPageableResponse(PageableResponseModel<Marca> pageableResponseModel);

    Marca toEntity(MarcaDTO dto);

    List<Marca> toEntity(List<MarcaDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(MarcaDTO dto, @MappingTarget Marca entity);
}
