package br.gov.datasus.scodes.model.mapper;

import java.util.List;

import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.ReportingPolicy;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;
import br.gov.datasus.scodes.model.dto.ModeloDTO;
import br.gov.datasus.scodes.model.dto.TipoDemandaDTO;
import br.gov.datasus.scodes.model.dto.TipoModeloDTO;
import br.gov.datasus.scodes.model.entity.Modelo;
import br.gov.datasus.scodes.model.entity.TipoDemanda;
import br.gov.datasus.scodes.model.entity.TipoModelo;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface ModeloMapper extends BaseMapper<Modelo, ModeloDTO> {

    ModeloDTO toDto(Modelo entity);

    List<ModeloDTO> toDto(List<Modelo> entities);

    List<ModeloDTO> toDto(Iterable<Modelo> entities);

    PageableResponseModel<ModeloDTO> toDtoPageableResponse(PageableResponseModel<Modelo> pageableResponseModel);

    Modelo toEntity(ModeloDTO dto);

    List<Modelo> toEntity(List<ModeloDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(ModeloDTO dto, @MappingTarget Modelo entity);

    TipoDemandaDTO tipoDemandaToDto(TipoDemanda entity);

    TipoDemanda tipoDemandaFromDto(TipoDemandaDTO dto);

    TipoModeloDTO tipoModeloToDto(TipoModelo entity);

	TipoModelo tipoModeloFromDto(TipoModeloDTO dto);
}
