package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.scodes.model.dto.NaturezaDespesaDTO;
import br.gov.datasus.scodes.model.entity.NaturezaDespesa;
import java.util.List;
import org.mapstruct.MappingTarget;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.ReportingPolicy;
import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface NaturezaDespesaMapper extends BaseMapper<NaturezaDespesa, NaturezaDespesaDTO> {

    NaturezaDespesaDTO toDto(NaturezaDespesa entity);

    List<NaturezaDespesaDTO> toDto(List<NaturezaDespesa> entities);

    List<NaturezaDespesaDTO> toDto(Iterable<NaturezaDespesa> entities);

    PageableResponseModel<NaturezaDespesaDTO> toDtoPageableResponse(PageableResponseModel<NaturezaDespesa> pageableResponseModel);

    NaturezaDespesa toEntity(NaturezaDespesaDTO dto);

    List<NaturezaDespesa> toEntity(List<NaturezaDespesaDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(NaturezaDespesaDTO dto, @MappingTarget NaturezaDespesa entity);
}
