package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.scodes.model.dto.PlanoSaudeDTO;
import br.gov.datasus.scodes.model.entity.PlanoSaude;
import java.util.List;
import org.mapstruct.MappingTarget;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.ReportingPolicy;
import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface PlanoSaudeMapper extends BaseMapper<PlanoSaude, PlanoSaudeDTO> {

    PlanoSaudeDTO toDto(PlanoSaude entity);

    List<PlanoSaudeDTO> toDto(List<PlanoSaude> entities);

    List<PlanoSaudeDTO> toDto(Iterable<PlanoSaude> entities);

    PageableResponseModel<PlanoSaudeDTO> toDtoPageableResponse(PageableResponseModel<PlanoSaude> pageableResponseModel);

    PlanoSaude toEntity(PlanoSaudeDTO dto);

    List<PlanoSaude> toEntity(List<PlanoSaudeDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(PlanoSaudeDTO dto, @MappingTarget PlanoSaude entity);
}
