package br.gov.datasus.scodes.model.mapper;

import java.util.List;

import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.ReportingPolicy;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;
import br.gov.datasus.scodes.model.dto.ProfissionalDTO;
import br.gov.datasus.scodes.model.dto.TipoProfissaoDTO;
import br.gov.datasus.scodes.model.dto.UfDTO;
import br.gov.datasus.scodes.model.entity.Profissional;
import br.gov.datasus.scodes.model.entity.TipoProfissao;
import br.gov.datasus.scodes.model.entity.Uf;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface ProfissionalMapper extends BaseMapper<Profissional, ProfissionalDTO> {

    ProfissionalDTO toDto(Profissional entity);

    List<ProfissionalDTO> toDto(List<Profissional> entities);

    List<ProfissionalDTO> toDto(Iterable<Profissional> entities);

    PageableResponseModel<ProfissionalDTO> toDtoPageableResponse(PageableResponseModel<Profissional> pageableResponseModel);

    Profissional toEntity(ProfissionalDTO dto);

    List<Profissional> toEntity(List<ProfissionalDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(ProfissionalDTO dto, @MappingTarget Profissional entity);
    
    TipoProfissaoDTO tipoProfissionalToDto(TipoProfissao entity);
    
    TipoProfissao tipoProfissionalToDto(TipoProfissaoDTO entity);
    
    UfDTO ufToDto(Uf entity);
    
    Uf ufToDto(UfDTO ufDTO);
}
