package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.scodes.model.entity.Programa;
import br.gov.datasus.scodes.model.dto.ProgramaDTO;
import java.util.List;
import org.mapstruct.MappingTarget;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.ReportingPolicy;
import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface ProgramaMapper extends BaseMapper<Programa, ProgramaDTO> {

    ProgramaDTO toDto(Programa entity);

    List<ProgramaDTO> toDto(List<Programa> entities);

    List<ProgramaDTO> toDto(Iterable<Programa> entities);

    PageableResponseModel<ProgramaDTO> toDtoPageableResponse(PageableResponseModel<Programa> pageableResponseModel);

    Programa toEntity(ProgramaDTO dto);

    List<Programa> toEntity(List<ProgramaDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(ProgramaDTO dto, @MappingTarget Programa entity);
}
