package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;
import br.gov.datasus.scodes.model.dto.SaidaEstoqueItemDTO;
import br.gov.datasus.scodes.model.entity.SaidaEstoqueItem;
import org.mapstruct.*;

import java.util.List;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface SaidaEstoqueItemMapper extends BaseMapper<SaidaEstoqueItem, SaidaEstoqueItemDTO> {

    @Mappings({
        @Mapping(source = "item.id", target = "idItem"),
        @Mapping(source = "unidadeDispensadora.id", target = "idUnidadeDispensadora")
    })
    SaidaEstoqueItemDTO toDto(SaidaEstoqueItem entity);

    List<SaidaEstoqueItemDTO> toDto(List<SaidaEstoqueItem> entities);

    List<SaidaEstoqueItemDTO> toDto(Iterable<SaidaEstoqueItem> entities);

    PageableResponseModel<SaidaEstoqueItemDTO> toDtoPageableResponse(PageableResponseModel<SaidaEstoqueItem> pageableResponseModel);

    @InheritInverseConfiguration
    @Mapping(target = "dataSaidaItem", ignore = true)
    SaidaEstoqueItem toEntity(SaidaEstoqueItemDTO dto);

    List<SaidaEstoqueItem> toEntity(List<SaidaEstoqueItemDTO> dtos);

    @InheritConfiguration
    void fromDto(SaidaEstoqueItemDTO dto, @MappingTarget SaidaEstoqueItem entity);
}
