package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.scodes.model.dto.TipoAcaoDTO;
import br.gov.datasus.scodes.model.entity.TipoAcao;
import java.util.List;
import org.mapstruct.MappingTarget;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.ReportingPolicy;
import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface TipoAcaoMapper extends BaseMapper<TipoAcao, TipoAcaoDTO> {

    TipoAcaoDTO toDto(TipoAcao entity);

    List<TipoAcaoDTO> toDto(List<TipoAcao> entities);

    List<TipoAcaoDTO> toDto(Iterable<TipoAcao> entities);

    PageableResponseModel<TipoAcaoDTO> toDtoPageableResponse(PageableResponseModel<TipoAcao> pageableResponseModel);

    TipoAcao toEntity(TipoAcaoDTO dto);

    List<TipoAcao> toEntity(List<TipoAcaoDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(TipoAcaoDTO dto, @MappingTarget TipoAcao entity);
}
