package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.scodes.model.entity.TipoCobranca;
import br.gov.datasus.scodes.model.dto.TipoCobrancaDTO;
import java.util.List;
import org.mapstruct.MappingTarget;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.ReportingPolicy;
import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface TipoCobrancaMapper extends BaseMapper<TipoCobranca, TipoCobrancaDTO> {

    TipoCobrancaDTO toDto(TipoCobranca entity);

    List<TipoCobrancaDTO> toDto(List<TipoCobranca> entities);

    List<TipoCobrancaDTO> toDto(Iterable<TipoCobranca> entities);

    PageableResponseModel<TipoCobrancaDTO> toDtoPageableResponse(PageableResponseModel<TipoCobranca> pageableResponseModel);

    TipoCobranca toEntity(TipoCobrancaDTO dto);

    List<TipoCobranca> toEntity(List<TipoCobrancaDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(TipoCobrancaDTO dto, @MappingTarget TipoCobranca entity);
}
