package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.scodes.model.entity.TipoModelo;
import br.gov.datasus.scodes.model.dto.TipoModeloDTO;
import java.util.List;
import org.mapstruct.MappingTarget;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.ReportingPolicy;
import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface TipoModeloMapper extends BaseMapper<TipoModelo, TipoModeloDTO> {

    TipoModeloDTO toDto(TipoModelo entity);

    List<TipoModeloDTO> toDto(List<TipoModelo> entities);

    List<TipoModeloDTO> toDto(Iterable<TipoModelo> entities);

    PageableResponseModel<TipoModeloDTO> toDtoPageableResponse(PageableResponseModel<TipoModelo> pageableResponseModel);

    TipoModelo toEntity(TipoModeloDTO dto);

    List<TipoModelo> toEntity(List<TipoModeloDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(TipoModeloDTO dto, @MappingTarget TipoModelo entity);
}
