package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;
import br.gov.datasus.scodes.model.dto.TipoMovimentacaoDTO;
import br.gov.datasus.scodes.model.entity.TipoMovimentacao;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.ReportingPolicy;

import java.util.List;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface TipoMovimentacaoMapper extends BaseMapper<TipoMovimentacao, TipoMovimentacaoDTO> {

	TipoMovimentacaoDTO toDto(TipoMovimentacao entity);

	List<TipoMovimentacaoDTO> toDto(List<TipoMovimentacao> entities);

	List<TipoMovimentacaoDTO> toDto(Iterable<TipoMovimentacao> entities);

	PageableResponseModel<TipoMovimentacaoDTO> toDtoPageableResponse(PageableResponseModel<TipoMovimentacao> pageableResponseModel);

	TipoMovimentacao toEntity(TipoMovimentacaoDTO dto);

	List<TipoMovimentacao> toEntity(List<TipoMovimentacaoDTO> dtos);
	
	@InheritInverseConfiguration(name = "toDto")
	void fromDto(TipoMovimentacaoDTO dto, @MappingTarget TipoMovimentacao entity);
}
