package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.scodes.model.entity.TipoVara;
import br.gov.datasus.scodes.model.dto.TipoVaraDTO;
import java.util.List;
import org.mapstruct.MappingTarget;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.ReportingPolicy;
import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface TipoVaraMapper extends BaseMapper<TipoVara, TipoVaraDTO> {

    TipoVaraDTO toDto(TipoVara entity);

    List<TipoVaraDTO> toDto(List<TipoVara> entities);

    List<TipoVaraDTO> toDto(Iterable<TipoVara> entities);

    PageableResponseModel<TipoVaraDTO> toDtoPageableResponse(PageableResponseModel<TipoVara> pageableResponseModel);

    TipoVara toEntity(TipoVaraDTO dto);

    List<TipoVara> toEntity(List<TipoVaraDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(TipoVaraDTO dto, @MappingTarget TipoVara entity);
}
