package br.gov.datasus.scodes.model.mapper;

import br.gov.datasus.scodes.model.dto.UfDTO;
import br.gov.datasus.scodes.model.entity.Uf;
import java.util.List;
import org.mapstruct.MappingTarget;
import org.mapstruct.InheritInverseConfiguration;
import org.mapstruct.Mapper;
import org.mapstruct.ReportingPolicy;
import br.gov.datasus.api.core.model.mapper.BaseMapper;
import br.gov.datasus.api.core.pagination.PageableResponseModel;

@Mapper(componentModel = "spring", unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface UfMapper extends BaseMapper<Uf, UfDTO> {

    UfDTO toDto(Uf entity);

    List<UfDTO> toDto(List<Uf> entities);

    List<UfDTO> toDto(Iterable<Uf> entities);

    PageableResponseModel<UfDTO> toDtoPageableResponse(PageableResponseModel<Uf> pageableResponseModel);

    Uf toEntity(UfDTO dto);

    List<Uf> toEntity(List<UfDTO> dtos);

    @InheritInverseConfiguration(name = "toDto")
    void fromDto(UfDTO dto, @MappingTarget Uf entity);
}
