package br.gov.datasus.scodes.repository;

import br.gov.datasus.api.core.dynamicquery.repository.DynamicNativeQueryRepository;
import br.gov.datasus.api.core.dynamicquery.repository.DynamicQueryRepository;
import br.gov.datasus.scodes.model.entity.EntradaEstoqueItem;
import br.gov.datasus.scodes.model.entity.Item;
import br.gov.datasus.scodes.model.entity.UnidadeDispensadora;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;

import java.math.BigDecimal;
import java.util.Optional;

public interface EntradaEstoqueItemRepository extends CrudRepository<EntradaEstoqueItem, Long>, DynamicQueryRepository, DynamicNativeQueryRepository {

    @Query(value = "SELECT valor FROM EntradaEstoqueItem WHERE id = " +
        "(SELECT MAX(id) FROM EntradaEstoqueItem WHERE item = :item AND unidadeDispensadora = :unidadeDispensadora AND valor IS NOT NULL)")
    Optional<BigDecimal> findValorItemUltimaEntrada(Item item, UnidadeDispensadora unidadeDispensadora);
}
