package br.gov.datasus.scodes.repository;

import br.gov.datasus.scodes.model.entity.Especificacao;

import java.util.List;

import br.gov.datasus.api.core.model.dto.DominioItemModel;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import br.gov.datasus.api.core.dynamicquery.repository.DynamicNativeQueryRepository;
import br.gov.datasus.api.core.dynamicquery.repository.DynamicQueryRepository;
import org.springframework.data.repository.query.Param;

public interface EspecificacaoRepository extends CrudRepository<Especificacao, Long>, DynamicQueryRepository, DynamicNativeQueryRepository {

    List<DominioItemModel> obterDominio();

    @Query(
        " SELECT new br.gov.datasus.api.core.model.dto.DominioItemModel(espec.id, espec.nome)" +
        " FROM Especificacao espec" +
        " WHERE espec.produto.id = :idProduto"
    )
    List<DominioItemModel> obterDominio(@Param("idProduto") Long idProduto);

    @Query("SELECT COUNT(i) FROM Especificacao e INNER JOIN e.itens i WHERE e = :especificacao")
    Integer countVinculosItens(Especificacao especificacao);
}
