package br.gov.datasus.scodes.repository;

import br.gov.datasus.api.core.dynamicquery.repository.DynamicNativeQueryRepository;
import br.gov.datasus.api.core.dynamicquery.repository.DynamicQueryRepository;
import br.gov.datasus.scodes.model.entity.EstoqueAuxiliar;
import br.gov.datasus.scodes.model.entity.Id.EstoqueAuxiliarId;

import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;

import java.util.Optional;

public interface EstoqueAuxiliarRepository extends CrudRepository<EstoqueAuxiliar, EstoqueAuxiliarId>, DynamicQueryRepository, DynamicNativeQueryRepository {

    @Query("SELECT quantidadeItem FROM EstoqueAuxiliar WHERE id = :id")
    Optional<Long> findQuantidadeEstoque(EstoqueAuxiliarId id);

    @Modifying
    @Query("UPDATE EstoqueAuxiliar SET dataAtualizacao = CURRENT_TIMESTAMP, quantidadeItem = quantidadeItem + :quantidade WHERE id = :id")
    int adicionarEstoque(EstoqueAuxiliarId id, Long quantidade);

    @Modifying
    @Query("UPDATE EstoqueAuxiliar SET dataAtualizacao = CURRENT_TIMESTAMP, quantidadeItem = quantidadeItem - :quantidade WHERE id = :id")
    int removerEstoque(EstoqueAuxiliarId id, Long quantidade);
}
