package br.gov.datasus.scodes.repository;

import br.gov.datasus.api.core.dynamicquery.repository.DynamicNativeQueryRepository;
import br.gov.datasus.api.core.dynamicquery.repository.DynamicQueryRepository;
import br.gov.datasus.api.core.model.dto.DominioItemModel;
import br.gov.datasus.scodes.model.entity.Inventario;
import br.gov.datasus.scodes.model.entity.UnidadeDispensadora;
import org.springframework.data.repository.CrudRepository;

import java.util.List;

public interface InventarioRepository extends CrudRepository<Inventario, Long>, DynamicQueryRepository, DynamicNativeQueryRepository {

    List<DominioItemModel> obterDominio();

    Long countByUnidadeDispensadora(UnidadeDispensadora unidadeDispensadora);

    Long countByUnidadeDispensadoraAndSituacaoAtivoIsTrue(UnidadeDispensadora unidadeDispensadora);
}
