package br.gov.datasus.scodes.repository;

import br.gov.datasus.scodes.model.constants.ItemConstants;
import br.gov.datasus.scodes.model.entity.Item;

import java.util.List;
import java.util.Optional;

import br.gov.datasus.api.core.model.dto.DominioItemModel;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import br.gov.datasus.api.core.dynamicquery.repository.DynamicNativeQueryRepository;
import br.gov.datasus.api.core.dynamicquery.repository.DynamicQueryRepository;
import org.springframework.data.repository.query.Param;

public interface ItemRepository extends CrudRepository<Item, Long>, DynamicQueryRepository, DynamicNativeQueryRepository {

    List<DominioItemModel> obterDominio();
    
    @Query(ItemConstants.QUERIES.OBTER_AUTOCOMPLETE_POR_COGIGO)
    List<DominioItemModel> obterAutocompletePorCodigo(@Param("codigo") String codigo);
}
