package br.gov.datasus.scodes.repository;

import java.util.Optional;

import org.springframework.data.repository.CrudRepository;

import br.gov.datasus.api.core.dynamicquery.repository.DynamicNativeQueryRepository;
import br.gov.datasus.api.core.dynamicquery.repository.DynamicQueryRepository;
import br.gov.datasus.scodes.model.entity.Modelo;
import br.gov.datasus.scodes.model.entity.TipoModelo;
import br.gov.datasus.scodes.model.enums.TipoModeloEnum;

public interface ModeloRepository extends CrudRepository<Modelo, Long>, DynamicQueryRepository, DynamicNativeQueryRepository {

    public Iterable<Modelo> findByTipoModelo(TipoModelo tipoModelo);

	public Optional<Modelo> findByIdAndTipoModelo(Long id, TipoModeloEnum tipoModelo);
}
