package br.gov.datasus.scodes.service;

import br.gov.datasus.scodes.model.dto.ProtocoloJefazDTO;
import br.gov.datasus.scodes.model.entity.ProtocoloJefaz;
import br.gov.datasus.scodes.model.mapper.ProtocoloJefazMapper;
import br.gov.datasus.scodes.repository.ProtocoloJefazRepository;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

@Service
@RequiredArgsConstructor
@Transactional(propagation= Propagation.SUPPORTS)
public class ProtocoloJefazService {

    private final ProtocoloJefazRepository repository;
    private final ProtocoloJefazMapper mapper;

    @Transactional(propagation= Propagation.REQUIRED)
    public ProtocoloJefazDTO incluir(ProtocoloJefazDTO dto) {
        ProtocoloJefaz entity = mapper.toEntity(dto);
        return mapper.toDto(repository.save(entity));
    }
}
