package br.gov.datasus.scodes.service;

import br.gov.datasus.scodes.model.dto.StatusAlteracaoDataRetornoDTO;
import br.gov.datasus.scodes.model.entity.StatusAlteracaoDataRetorno;
import br.gov.datasus.scodes.model.mapper.StatusAlteracaoDataRetornoMapper;
import br.gov.datasus.scodes.repository.StatusAlteracaoDataRetornoRepository;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@RequiredArgsConstructor
@Transactional(propagation = Propagation.SUPPORTS)
public class StatusAlteracaoDataRetornoService {

    private final StatusAlteracaoDataRetornoRepository repository;
    private final StatusAlteracaoDataRetornoMapper mapper;

    public List<StatusAlteracaoDataRetornoDTO> obterTodos() {
        Iterable<StatusAlteracaoDataRetorno> itens = repository.findAll();
        return mapper.toDto(itens);
    }
}
