package br.gov.datasus.scodes.validation;

import br.gov.datasus.api.core.exception.BusinessException;
import br.gov.datasus.scodes.configuration.properties.MessageProperty;
import br.gov.datasus.scodes.service.FeriadoService;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;

import java.util.Date;

import static br.gov.datasus.scodes.configuration.properties.MessageProperty.NOVA_DATA_RETORNO_NAO_PODE_SER_FERIADO;

@Service
@RequiredArgsConstructor
public class FeriadoServiceValidation {

    private final FeriadoService feriadoService;

    public void validate(Date dataFeriado) {
        dataDeFeriadoForIgualDataDeFeriadoValidate(dataFeriado);
    }

    private void dataDeFeriadoForIgualDataDeFeriadoValidate(Date dataRetorno) {
        if (feriadoService.isDataRetornoFeriado(dataRetorno)) {
            throw  new BusinessException(NOVA_DATA_RETORNO_NAO_PODE_SER_FERIADO);
        }
    }
}
