SELECT
    inv.co_seq_inventario as "idInventario",
    item.co_seq_item as "idItem",
    item.co_item AS "codigoItem",
    dbscodes.fc_descricao_item(item.co_seq_item) AS "descricaoItem",
    espec.no_especificacao AS "unidadeMedida",
    invitem.co_seq_inventario_item as "idInventarioItem",
    invitem.qt_inventario_item AS "quantidadeFisica",
    invitem.dt_contagem AS "dataContagem"
FROM dbscodes.tb_inventario inv
INNER JOIN dbscodes.tb_estoque_auxiliar estaux ON inv.co_unidade_dispensadora = estaux.co_unidade_dispensadora
INNER JOIN dbscodes.tb_item item ON estaux.co_item = item.co_seq_item
INNER JOIN dbscodes.tb_especificacao espec ON item.co_especificacao = espec.co_seq_especificacao
INNER JOIN dbscodes.tb_produto prod ON espec.co_produto = prod.co_seq_produto
LEFT JOIN dbscodes.tb_inventario_item invitem ON inv.co_seq_inventario = invitem.co_inventario AND item.co_seq_item = invitem.co_item
WHERE 1=1
    AND (inv.co_seq_inventario = :idInventario)
    AND (item.co_seq_item IN(:idItens))
    AND (item.co_item = :codigoItem)
    AND (prod.co_seq_produto = :idProduto)
    AND (invitem.co_seq_inventario_item = :idIsNull)
ORDER BY
    (CASE WHEN invitem.co_seq_inventario_item IS NOT NULL THEN 1 ELSE 2 END) ASC,
    item.co_item ASC
