import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { FlexLayoutModule } from '@angular/flex-layout';

import { MaterialModule } from '../../../material/material.module';
import { DatasusModule } from '../../../datasus/datasus.module';
import { SharedModule } from '../../shared/shared.module';
import { AcessoRoutingModule } from './acesso-routing.module';
import { AcessoService } from './services/acesso.service';
import { LogAcessoComponent } from './pages/log-acesso/log-acesso.component';
import { RelatorioAcessoComponent } from './pages/relatorio-acesso/relatotorio-acesso.component';

@NgModule({
  imports: [
    // Angular
    CommonModule,
    FormsModule,
    ReactiveFormsModule,
    // Angular Flex Layout
    FlexLayoutModule,
    // Angular Material
    MaterialModule,
    // Datasus
    DatasusModule,
    // App
    SharedModule,
    // Acesso
    AcessoRoutingModule
  ],
  declarations: [
    LogAcessoComponent,
    RelatorioAcessoComponent
  ],
  providers: [
    AcessoService,
  ],
})
export class AcessoModule { }
