import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';

import { BaseService, DominioItemModel, PageableRequestModel, PageableResponseModel } from '@datasus/core';

import { FuncionalidadeModel } from '../models/funcionalidade.model';

@Injectable()
export class FuncionalidadeService extends BaseService {

  obterPorId(id: number): Observable<FuncionalidadeModel> {
    return this.baseGet<FuncionalidadeModel>(`/funcionalidade/${id}`);
  }

  obterTodos(): Observable<FuncionalidadeModel[]> {
    return this.baseGet<FuncionalidadeModel[]>('/funcionalidade');
  }

  obterTodosPaginado(body: PageableRequestModel<null>): Observable<PageableResponseModel<FuncionalidadeModel>> {
    return this.basePost<PageableResponseModel<FuncionalidadeModel>>('/funcionalidade/paginado', body);
  }

  obterDominio(): Observable<DominioItemModel[]> {
    return this.baseGet<DominioItemModel[]>('/funcionalidade/dominio');
  }

}
