import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { FlexLayoutModule } from '@angular/flex-layout';
import { NgxMaskModule } from 'ngx-mask';

import { MaterialModule } from '../../../material/material.module';
import { DatasusModule } from '../../../datasus/datasus.module';
import { SharedModule } from '../../shared/shared.module';
import { UsuarioRoutingModule } from './usuario-routing.module';
import { UsuarioService } from './services/usuario.service';
import { UsuarioResolver } from './resolvers/usuario.resolver';
import { UsuarioListComponent } from './pages/list/usuario.list.component';
import { UsuarioFormComponent } from './pages/form/usuario.form.component';
import { UsuarioLocalService } from './services/usuario-local.service';
import { UsuarioLocalResolver } from './resolvers/usuario-local.resolver';

@NgModule({
  imports: [
    // Angular
    CommonModule,
    FormsModule,
    ReactiveFormsModule,
    // Angular Flex Layout
    FlexLayoutModule,
    // Angular Material
    MaterialModule,
    // JSDADDY Ngx Mask
    NgxMaskModule.forChild({ dropSpecialCharacters: true }),
    // Datasus
    DatasusModule,
    // App
    SharedModule,
    // Usuario
    UsuarioRoutingModule,
  ],
  declarations: [
    /*declaration component*/
    UsuarioListComponent,
    UsuarioFormComponent,
  ],
  providers: [
    /*declaration provider*/
    UsuarioResolver,
    UsuarioLocalResolver,
  ],
})
export class UsuarioModule { }
