import { Component, OnInit } from '@angular/core';
import { FormGroup, FormBuilder } from '@angular/forms';
import { Observable } from 'rxjs';
import { ActivatedRoute, Router } from '@angular/router';

import { LayoutService, DialogService } from '@datasus/layout';

@Component({
  selector: 'scodes-historico-form',
  templateUrl: './historico-form.component.html',
  styleUrls: ['./historico-form.component.scss']
})
export class HistoricoFormComponent implements OnInit {

  isSalvo: boolean;
  // Form Group
  formGroup: FormGroup;

  // Viewport Observable
  onMobile$: Observable<boolean>;

  constructor(
    private route: ActivatedRoute,
    private formBuilder: FormBuilder,
    private router: Router,
    private layoutService: LayoutService,
    private dialogService: DialogService,
  ) { }

  ngOnInit() {
    this.layoutService.setTitle('Cadastro de Demanada - Histórico');
  }

  submit(event: Event) {
    event.preventDefault();

  }

}
