import { Injectable } from '@angular/core';
import { Resolve, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';
import { Observable } from 'rxjs';

import { DemandasService } from '../services/demandas.service';
import { AutorDemandaModel } from '../models/autor-demanda.model';

@Injectable()

export class DemandaResolver implements Resolve<AutorDemandaModel> {

  constructor(
    private demanadasService: DemandasService,
  ) { }

  resolve(
    route: ActivatedRouteSnapshot,
    state: RouterStateSnapshot,
  ): Observable<AutorDemandaModel> | Promise<AutorDemandaModel> | AutorDemandaModel {
    return this.demanadasService.obterPorId(route.params.id);
  }


}

