import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { FlexLayoutModule } from '@angular/flex-layout';
import { NgxCurrencyModule } from 'ngx-currency';
import { NgxMaskModule } from 'ngx-mask';

import { MaterialModule } from 'src/material/material.module';
import { DatasusModule } from 'src/datasus/datasus.module';
import { SharedModule } from 'src/app/shared/shared.module';
import { ListComponent } from './pages/list/list.component';
import { AlteracaoDataRetornoFormComponent } from './pages/alteracao-data-retorno-form/alteracao-data-retorno-form.component';

import { AlteracaoDataRetornoRoutingModule } from './alteracao-data-retorno-routing.module';
import { AlteracaoDataRetornoResolver } from './resolvers/alteracao-data-retorno.resolver';

@NgModule({
  imports: [
    // Angular
    CommonModule,
    FormsModule,
    ReactiveFormsModule,
    // Angular Flex Layout
    FlexLayoutModule,
    // Angular Material
    MaterialModule,
    // JSDADDY Ngx Mask
    NgxMaskModule.forChild({ dropSpecialCharacters: true }),
    // Ngx Currency
    NgxCurrencyModule,
    // Datasus
    DatasusModule,
    // App
    SharedModule,
    // Alteracao Data Retorno
    AlteracaoDataRetornoRoutingModule
  ],
  declarations: [
    /*declaration component*/
    ListComponent,
    AlteracaoDataRetornoFormComponent
  ],
  providers: [
    /*declaration provider*/
    AlteracaoDataRetornoResolver
  ]
})
export class AlteracaoDataRetornoModule {}
