import { Injectable } from '@angular/core';
import { Resolve, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';

import { Observable } from 'rxjs';

import { UnidadeDispensadoraService } from '../../../shared/services/unidade-dispensadora.service';
import { UnidadeDispensadoraModel } from '../../../shared/models/unidade-dispensadora.model';

@Injectable()
export class UnidadeDispensadoraResolver implements Resolve<UnidadeDispensadoraModel> {

  constructor(
    private unidadeDispensadoraService: UnidadeDispensadoraService,
  ) { }

  resolve(route: ActivatedRouteSnapshot, state: RouterStateSnapshot):
    Observable<UnidadeDispensadoraModel> | Promise<UnidadeDispensadoraModel> | UnidadeDispensadoraModel {
    return this.unidadeDispensadoraService.obterPorId(route.params.ud);
  }

}
