import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';

import { BaseService, DominioItemModel, PageableRequestModel, PageableResponseModel } from '@datasus/core';

import { CompraModalidadeModel } from '../models/compra-modalidade.model';

@Injectable()
export class CompraModalidadeService extends BaseService {

  obterPorId(id: number): Observable<CompraModalidadeModel> {
    return this.baseGet<CompraModalidadeModel>(`/compra-modalidade/${id}`);
  }

  obterTodos(): Observable<CompraModalidadeModel[]> {
    return this.baseGet<CompraModalidadeModel[]>('/compra-modalidade');
  }

  obterTodosPaginado(body: PageableRequestModel<void>): Observable<PageableResponseModel<CompraModalidadeModel>> {
    return this.basePost<PageableResponseModel<CompraModalidadeModel>>('/compra-modalidade/paginado', body);
  }

  obterDominio(): Observable<DominioItemModel[]> {
    return this.baseGet<DominioItemModel[]>('/compra-modalidade/dominio');
  }

}
