import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { FlexLayoutModule } from '@angular/flex-layout';

import { MaterialModule } from 'src/material/material.module';
import { DatasusModule } from 'src/datasus/datasus.module';
import { SharedModule } from '../../shared/shared.module';
import { InativarDemandaRoutingModule } from './inativar-demanda-routing.module';
import { InativarDemandaListComponent } from './page/inativar-demanda-list/inativar-demanda-list.component';
import { InativarDemandaFormComponent } from './page/inativar-demanda-form/inativar-demanda-form.component';
import { InativarDemandaService } from './services/inativar-demanda.service';

@NgModule({

  imports: [
    // Angular
    CommonModule,
    FormsModule,
    ReactiveFormsModule,
    // Angular Flex Layout
    FlexLayoutModule,
    // Angular Material
    MaterialModule,
    // Datasus
    DatasusModule,
    // App
    SharedModule,
    // inativar demanda
    InativarDemandaRoutingModule
  ],
  declarations: [
    InativarDemandaListComponent,
    InativarDemandaFormComponent,

  ],
  providers: [
    InativarDemandaService,
  ],
})
export class InativarDemandaModule { }
