import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';

import { BaseService, PageableResponseModel, PageableRequestModel } from '@datasus/core';

import { InventarioItemModel } from '../models/inventario-item.model';
import { InventarioItemFilterModel } from '../models/inventario-item-filter.model';

@Injectable({
  providedIn: 'root'
})
export class InventarioItemService extends BaseService {

  obterTodosPaginado(body: PageableRequestModel<InventarioItemFilterModel>): Observable<PageableResponseModel<InventarioItemModel>> {
    return this.basePost<PageableResponseModel<InventarioItemModel>>('/inventario-item/paginado', body);
  }

  obterPorId(id: number): Observable<InventarioItemModel> {
    return this.baseGet<InventarioItemModel>(`/inventario-item/${id}`);
  }

  salvar(body: InventarioItemModel[]): Observable<InventarioItemModel[]> {
    return this.basePost<InventarioItemModel[]>('/inventario-item', body);
  }

}
