import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { FlexLayoutModule } from '@angular/flex-layout';
import { NgxMaskModule } from 'ngx-mask';

import { MaterialModule } from 'src/material/material.module';
import { DatasusModule } from 'src/datasus/datasus.module';
import { SharedModule } from 'src/app/shared/shared.module';
import { ClassificacaoCobrancaRoutingModule } from './classificacao-cobranca-routing.module';

import { ClassificacaoCobrancaService } from './services/classificacao-cobranca.service';

import { ClassificacaoCobrancaResolver } from './resolvers/classificacao-cobranca.resolver';

import { ClassificacaoCobrancaListComponent } from './pages/list/classificacao-cobranca.list.component';
import { ClassificacaoCobrancaFormComponent } from './pages/form/classificacao-cobranca.form.component';
/*import*/

@NgModule({
  imports: [
    // Angular
    CommonModule,
    FormsModule,
    ReactiveFormsModule,
    // Angular Flex Layout
    FlexLayoutModule,
    // Angular Material
    MaterialModule,
    // JSDADDY Ngx Mask
    NgxMaskModule.forChild({ dropSpecialCharacters: true }),
    // Datasus
    DatasusModule,
    // App
    SharedModule,
    // ClassificacaoCobranca
    ClassificacaoCobrancaRoutingModule,
  ],
  declarations: [
    /*declaration component*/
    ClassificacaoCobrancaListComponent,
    ClassificacaoCobrancaFormComponent,
  ],
  providers: [
    /*declaration provider*/
    ClassificacaoCobrancaResolver,
    ClassificacaoCobrancaService,
  ],
})
export class ClassificacaoCobrancaModule { }
