import { Injectable } from '@angular/core';
import { Resolve, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';
import { Observable } from 'rxjs';

import { ClassificacaoCobrancaService } from '../services/classificacao-cobranca.service';
import { ClassificacaoCobrancaModel } from '../models/classificacao-cobranca.model';

@Injectable()
export class ClassificacaoCobrancaResolver implements Resolve<ClassificacaoCobrancaModel> {

  constructor(
    private classificacaoCobrancaService: ClassificacaoCobrancaService,
  ) { }

  resolve(
    route: ActivatedRouteSnapshot,
    state: RouterStateSnapshot,
  ): Observable<ClassificacaoCobrancaModel> | Promise<ClassificacaoCobrancaModel> | ClassificacaoCobrancaModel {
    return this.classificacaoCobrancaService.obterPorId(route.params.id);
  }

}
