import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';

import {guardsDefault, NotFoundComponent} from '@datasus/commons';

import { LocalJefazResolver } from './resolvers/local-jefaz.resolver';

import { LocalJefazListComponent } from './pages/list/local-jefaz.list.component';
import { LocalJefazFormComponent } from './pages/form/local-jefaz.form.component';
/*import*/

const routes: Routes = [
  { path: '', component: NotFoundComponent, data: { layoutAnimation: true, layoutColor: 'error', } },
  {
    path: 'listar',
    component: LocalJefazListComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'primary',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  {
    path: 'editar/:id',
    component: LocalJefazFormComponent,
    resolve: {
      item: LocalJefazResolver
    },
    data: {
      layoutAnimation: true,
      layoutColor: 'dusky',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  {
    path: 'inserir',
    component: LocalJefazFormComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'success',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  /*path component*/

  { path: '**', redirectTo: '', pathMatch: 'full' },
];

@NgModule({
  imports: [
    RouterModule.forChild(routes),
  ],
  exports: [
    RouterModule,
  ],
})
export class LocalJefazRoutingModule { }
