import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { FlexLayoutModule } from '@angular/flex-layout';
import { NgxMaskModule } from 'ngx-mask';

import { MaterialModule } from '../../../../material/material.module';
import { DatasusModule } from '../../../../datasus/datasus.module';

import { SharedModule } from '../../../shared/shared.module';

import { LocalJefazRoutingModule } from './local-jefaz-routing.module';
import { LocalJefazService } from './services/local-jefaz.service';
import { LocalJefazResolver } from './resolvers/local-jefaz.resolver';
import { LocalJefazListComponent } from './pages/list/local-jefaz.list.component';
import { LocalJefazFormComponent } from './pages/form/local-jefaz.form.component';
/*import*/

@NgModule({
  imports: [
    // Angular
    CommonModule,
    FormsModule,
    ReactiveFormsModule,
    // Angular Flex Layout
    FlexLayoutModule,
    // Angular Material
    MaterialModule,
    // JSDADDY Ngx Mask
    NgxMaskModule.forChild({ dropSpecialCharacters: true }),
    // Datasus
    DatasusModule,
    // App
    SharedModule,
    // LocalJefaz
    LocalJefazRoutingModule,
  ],
  declarations: [
    /*declaration component*/
    LocalJefazListComponent,
    LocalJefazFormComponent,
  ],
  providers: [
    /*declaration provider*/
    LocalJefazResolver,
    LocalJefazService,
  ],
})
export class LocalJefazModule { }
