import { Injectable } from '@angular/core';
import { Resolve, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';
import { Observable } from 'rxjs';

import { LocalJefazModel } from '../models/local-jefaz.model';
import { LocalJefazService } from '../services/local-jefaz.service';

@Injectable()
export class LocalJefazResolver implements Resolve<LocalJefazModel> {

  constructor(
    private localJefazService: LocalJefazService,
  ) { }

  resolve(
    route: ActivatedRouteSnapshot,
    state: RouterStateSnapshot,
  ): Observable<LocalJefazModel> | Promise<LocalJefazModel> | LocalJefazModel {
    return this.localJefazService.obterPorId(route.params.id);
  }

}
