import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';

import { NotFoundComponent } from '@datasus/commons';

import { ModeloOficioResolver } from '../../../shared/resolvers/modelo-oficio.resolver';

import { ModeloOficioListComponent } from './pages/list/modelo-oficio.list.component';
import { ModeloOficioFormComponent } from './pages/form/modelo-oficio.form.component';
import { ModeloOficioViewComponent } from './pages/view/modelo-oficio.view.component';
/*import*/

const routes: Routes = [
  { path: '', component: NotFoundComponent, data: { layoutAnimation: true, layoutColor: 'error', } },
  {
    path: 'listar',
    component: ModeloOficioListComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'primary',
    }
  },
  {
    path: 'visualizar/:id',
    component: ModeloOficioViewComponent,
    resolve: {
      item: ModeloOficioResolver
    },
    data: {
      layoutAnimation: true,
      layoutColor: 'dusky',
    }
  },
  {
    path: 'editar/:id',
    component: ModeloOficioFormComponent,
    resolve: {
      item: ModeloOficioResolver
    },
    data: {
      layoutAnimation: true,
      layoutColor: 'dusky',
    }
  },
  {
    path: 'inserir',
    component: ModeloOficioFormComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'success',
    }
  },
  /*path component*/

  { path: '**', redirectTo: '', pathMatch: 'full' },
];

@NgModule({
  imports: [
    RouterModule.forChild(routes),
  ],
  exports: [
    RouterModule,
  ],
})
export class ModeloOficioRoutingModule { }
