import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';

import { NotFoundComponent, guardsDefault } from '@datasus/commons';

import { NaturezaDespesaResolver } from './resolvers/natureza-despesa.resolver';

import { NaturezaDespesaListComponent } from './pages/list/natureza-despesa.list.component';
import { NaturezaDespesaFormComponent } from './pages/form/natureza-despesa.form.component';
/*import*/

const routes: Routes = [
  { path: '', component: NotFoundComponent, data: { layoutAnimation: true, layoutColor: 'error', } },
  {
    path: 'listar',
    component: NaturezaDespesaListComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'primary',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  {
    path: 'editar/:id',
    component: NaturezaDespesaFormComponent,
    resolve: {
      item: NaturezaDespesaResolver
    },
    data: {
      layoutAnimation: true,
      layoutColor: 'dusky',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  {
    path: 'inserir',
    component: NaturezaDespesaFormComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'success',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  /*path component*/

  { path: '**', redirectTo: '', pathMatch: 'full' },
];

@NgModule({
  imports: [
    RouterModule.forChild(routes),
  ],
  exports: [
    RouterModule,
  ],
})
export class NaturezaDespesaRoutingModule { }
