import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { FlexLayoutModule } from '@angular/flex-layout';
import { NgxMaskModule } from 'ngx-mask';

import { MaterialModule } from 'src/material/material.module';
import { DatasusModule } from 'src/datasus/datasus.module';
import { SharedModule } from 'src/app/shared/shared.module';
import { NaturezaDespesaRoutingModule } from './natureza-despesa-routing.module';

import { NaturezaDespesaService } from './services/natureza-despesa.service';

import { NaturezaDespesaResolver } from './resolvers/natureza-despesa.resolver';

import { NaturezaDespesaListComponent } from './pages/list/natureza-despesa.list.component';
import { NaturezaDespesaFormComponent } from './pages/form/natureza-despesa.form.component';
/*import*/

@NgModule({
  imports: [
    // Angular
    CommonModule,
    FormsModule,
    ReactiveFormsModule,
    // Angular Flex Layout
    FlexLayoutModule,
    // Angular Material
    MaterialModule,
    // JSDADDY Ngx Mask
    NgxMaskModule.forChild({ dropSpecialCharacters: true }),
    // Datasus
    DatasusModule,
    // App
    SharedModule,
    // NaturezaDespesa
    NaturezaDespesaRoutingModule,
  ],
  declarations: [
    /*declaration component*/
    NaturezaDespesaListComponent,
    NaturezaDespesaFormComponent,
  ],
  providers: [
    /*declaration provider*/
    NaturezaDespesaResolver,
    NaturezaDespesaService,
  ],
})
export class NaturezaDespesaModule { }
