import { Injectable } from '@angular/core';
import { Resolve, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';
import { Observable } from 'rxjs';

import { NaturezaDespesaService } from '../services/natureza-despesa.service';
import { NaturezaDespesaModel } from '../models/natureza-despesa.model';

@Injectable()
export class NaturezaDespesaResolver implements Resolve<NaturezaDespesaModel> {

  constructor(
    private NaturezaDespesaService: NaturezaDespesaService,
  ) { }

  resolve(
    route: ActivatedRouteSnapshot,
    state: RouterStateSnapshot,
  ): Observable<NaturezaDespesaModel> | Promise<NaturezaDespesaModel> | NaturezaDespesaModel {
    return this.NaturezaDespesaService.obterPorId(route.params.id);
  }

}
