import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { FlexLayoutModule } from '@angular/flex-layout';
import { NgxMaskModule } from 'ngx-mask';

import { MaterialModule } from '../../../../material/material.module';
import { DatasusModule } from '../../../../datasus/datasus.module';
import { SharedModule } from '../../../shared/shared.module';
import { PlanoSaudeRoutingModule } from './plano-saude-routing.module';

import { PlanoSaudeService } from './services/plano-saude.service';

import { PlanoSaudeResolver } from './resolvers/plano-saude.resolver';

import { PlanoSaudeListComponent } from './pages/list/plano-saude.list.component';
import { PlanoSaudeFormComponent } from './pages/form/plano-saude.form.component';
/*import*/

@NgModule({
  imports: [
    // Angular
    CommonModule,
    FormsModule,
    ReactiveFormsModule,
    // Angular Flex Layout
    FlexLayoutModule,
    // Angular Material
    MaterialModule,
    // JSDADDY Ngx Mask
    NgxMaskModule.forChild({ dropSpecialCharacters: true }),
    // Datasus
    DatasusModule,
    // App
    SharedModule,
    // PlanoSaude
    PlanoSaudeRoutingModule,
  ],
  declarations: [
    /*declaration component*/
    PlanoSaudeListComponent,
    PlanoSaudeFormComponent,
  ],
  providers: [
    /*declaration provider*/
    PlanoSaudeResolver,
    PlanoSaudeService,
  ],
})
export class PlanoSaudeModule { }
