import { Injectable } from '@angular/core';
import { Resolve, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';
import { Observable } from 'rxjs';

import { PlanoSaudeModel } from '../models/plano-saude.model';
import { PlanoSaudeService } from '../services/plano-saude.service';

@Injectable()
export class PlanoSaudeResolver implements Resolve<PlanoSaudeModel> {

  constructor(
    private planoSaudeService: PlanoSaudeService,
  ) { }

  resolve(
    route: ActivatedRouteSnapshot,
    state: RouterStateSnapshot,
  ): Observable<PlanoSaudeModel> | Promise<PlanoSaudeModel> | PlanoSaudeModel {
    return this.planoSaudeService.obterPorId(route.params.id);
  }

}
