import { Injectable } from '@angular/core';
import { Resolve, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';
import { Observable } from 'rxjs';

import { EspecificacaoService } from '../services/especificacao.service';
import { EspecificacaoModel } from '../models/especificacao.model';

@Injectable()
export class EspecificacaoResolver implements Resolve<EspecificacaoModel> {

  constructor(
    private especificacaoService: EspecificacaoService,
  ) { }

  resolve(
    route: ActivatedRouteSnapshot,
    state: RouterStateSnapshot,
  ): Observable<EspecificacaoModel> | Promise<EspecificacaoModel> | EspecificacaoModel {
    return this.especificacaoService.obterPorId(route.params.idEspecificacao);
  }
}
