import { ItemModel } from '../models/item.model';
import { ItemService } from '../../../../shared/services/item.service';
import { Resolve, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';
import { Observable } from 'rxjs';
import { Injectable } from '@angular/core';

@Injectable()
export class ItemResolver implements Resolve<ItemModel> {

  constructor(
    private itemService: ItemService,
  ) { }

  resolve(
    route: ActivatedRouteSnapshot,
    state: RouterStateSnapshot,
  ): Observable<ItemModel> | Promise<ItemModel> | ItemModel {
    return this.itemService.obterPorId(route.params.idItem);
  }

}
