import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';
import { NotFoundComponent } from '@datasus/commons';
import { ProfissionalResolver } from '../../../shared/resolvers/profissional.resolver';
import { ProfissionalFormComponent } from './pages/form/profissional.form.component';
import { ProfissionalListComponent } from './pages/list/profissional.list.component';

/*import*/

const routes: Routes = [
  { path: '', component: NotFoundComponent, data: { layoutAnimation: true, layoutColor: 'error', } },
  {
    path: 'listar',
    component: ProfissionalListComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'primary',
    }
  },
  {
    path: 'editar/:id',
    component: ProfissionalFormComponent,
    resolve: {
      item: ProfissionalResolver
    },
    data: {
      layoutAnimation: true,
      layoutColor: 'dusky',
    }
  },
  {
    path: 'inserir',
    component: ProfissionalFormComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'success',
    }
  },
  /*path component*/

  { path: '**', redirectTo: '', pathMatch: 'full' },
];

@NgModule({
  imports: [
    RouterModule.forChild(routes),
  ],
  exports: [
    RouterModule,
  ],
})
export class ProfissionalRoutingModule { }
