import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { FlexLayoutModule } from '@angular/flex-layout';
import { NgxMaskModule } from 'ngx-mask';

import { MaterialModule } from 'src/material/material.module';
import { DatasusModule } from 'src/datasus/datasus.module';
import { SharedModule } from 'src/app/shared/shared.module';
import { TipoAcaoRoutingModule } from './tipo-acao-routing.module';

import { TipoAcaoService } from './services/tipo-acao.service';

import { TipoAcaoResolver } from './resolvers/tipo-acao.resolver';

import { TipoAcaoListComponent } from './pages/list/tipo-acao.list.component';
import { TipoAcaoFormComponent } from './pages/form/tipo-acao.form.component';
/*import*/

@NgModule({
  imports: [
    // Angular
    CommonModule,
    FormsModule,
    ReactiveFormsModule,
    // Angular Flex Layout
    FlexLayoutModule,
    // Angular Material
    MaterialModule,
    // JSDADDY Ngx Mask
    NgxMaskModule.forChild({ dropSpecialCharacters: true }),
    // Datasus
    DatasusModule,
    // App
    SharedModule,
    // TipoAcao
    TipoAcaoRoutingModule,
  ],
  declarations: [
    /*declaration component*/
    TipoAcaoListComponent,
    TipoAcaoFormComponent,
  ],
  providers: [
    /*declaration provider*/
    TipoAcaoResolver,
    TipoAcaoService,
  ],
})
export class TipoAcaoModule { }
