import { Injectable } from '@angular/core';
import { Resolve, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';
import { Observable } from 'rxjs';

import { TipoDocumentoService } from '../services/tipo-documento.service';
import { TipoDocumentoModel } from '../models/tipo-documento.model';

@Injectable()
export class TipoDocumentoResolver implements Resolve<TipoDocumentoModel> {

  constructor(
    private tipoDocumentoService: TipoDocumentoService,
  ) { }

  resolve(
    route: ActivatedRouteSnapshot,
    state: RouterStateSnapshot,
  ): Observable<TipoDocumentoModel> | Promise<TipoDocumentoModel> | TipoDocumentoModel {
    return this.tipoDocumentoService.obterPorId(route.params.id);
  }

}
