import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';

import {guardsDefault, NotFoundComponent} from '@datasus/commons';

import { TipoDocumentoResolver } from './resolvers/tipo-documento.resolver';

import { TipoDocumentoListComponent } from './pages/list/tipo-documento.list.component';
import { TipoDocumentoFormComponent } from './pages/form/tipo-documento.form.component';
/*import*/

const routes: Routes = [
  { path: '', component: NotFoundComponent, data: { layoutAnimation: true, layoutColor: 'error', } },
  {
    path: 'listar',
    component: TipoDocumentoListComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'primary',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  {
    path: 'editar/:id',
    component: TipoDocumentoFormComponent,
    resolve: {
      item: TipoDocumentoResolver
    },
    data: {
      layoutAnimation: true,
      layoutColor: 'dusky',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  {
    path: 'inserir',
    component: TipoDocumentoFormComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'success',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  /*path component*/

  { path: '**', redirectTo: '', pathMatch: 'full' },
];

@NgModule({
  imports: [
    RouterModule.forChild(routes),
  ],
  exports: [
    RouterModule,
  ],
})
export class TipoDocumentoRoutingModule { }
