import { Injectable } from '@angular/core';
import { Resolve, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';
import { Observable } from 'rxjs';

import { UnidadeTransferenciaService } from '../services/unidade-transferencia.service';
import { UnidadeTransferenciaModel } from '../models/unidade-transferencia.model';

@Injectable()
export class UnidadeTransferenciaResolver implements Resolve<UnidadeTransferenciaModel> {

  constructor(
    private tipoAcaoService: UnidadeTransferenciaService,
  ) { }

  resolve(
    route: ActivatedRouteSnapshot,
    state: RouterStateSnapshot,
  ): Observable<UnidadeTransferenciaModel> | Promise<UnidadeTransferenciaModel> | UnidadeTransferenciaModel {
    return this.tipoAcaoService.obterPorId(route.params.id);
  }

}
