import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';

import { NotFoundComponent, guardsDefault } from '@datasus/commons';

import { UnidadeTransferenciaResolver } from './resolvers/unidade-transferencia.resolver';

import { UnidadeTransferenciaListComponent } from './pages/list/unidade-transferencia.list.component';
import { UnidadeTransferenciaFormComponent } from './pages/form/unidade-transferencia.form.component';
/*import*/

const routes: Routes = [
  { path: '', component: NotFoundComponent, data: { layoutAnimation: true, layoutColor: 'error', } },
  {
    path: 'listar',
    component: UnidadeTransferenciaListComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'primary',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  {
    path: 'editar/:id',
    component: UnidadeTransferenciaFormComponent,
    resolve: {
      item: UnidadeTransferenciaResolver
    },
    data: {
      layoutAnimation: true,
      layoutColor: 'dusky',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  {
    path: 'inserir',
    component: UnidadeTransferenciaFormComponent,
    data: {
      layoutAnimation: true,
      layoutColor: 'success',
    },
    canActivate: [
      ...guardsDefault,
    ],
  },
  /*path component*/

  { path: '**', redirectTo: '', pathMatch: 'full' },
];

@NgModule({
  imports: [
    RouterModule.forChild(routes),
  ],
  exports: [
    RouterModule,
  ],
})
export class UnidadeTransferenciaRoutingModule { }
