import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { FlexLayoutModule } from '@angular/flex-layout';

import { MaterialModule } from '../../../../material/material.module';
import { DatasusModule } from '../../../../datasus/datasus.module';
import { SharedModule } from '../../../shared/shared.module';
import { VaraService } from '../../../shared/services/vara.service';
import { VaraResolver } from '../../../shared/resolvers/vara.resolver';
import { VaraListComponent } from './pages/list/vara.list.component';
import { VaraFormComponent } from './pages/form/vara.form.component';
import { TipoDemandaService } from 'src/app/shared/services/tipo-demanda.service';
import { VaraRoutingModule } from './vara-routing.module';
import { NgxMaskModule } from 'ngx-mask';

/*import*/

@NgModule({
  imports: [
    // Angular
    CommonModule,
    FormsModule,
    ReactiveFormsModule,
    FlexLayoutModule,
    MaterialModule,
    DatasusModule,
    SharedModule,
    VaraRoutingModule,
    NgxMaskModule,
  ],
  declarations: [
    /*declaration component*/
    VaraListComponent,
    VaraFormComponent,
  ],
  providers: [
    /*declaration provider*/
    VaraResolver,
    VaraService,
    TipoDemandaService,
  ],
})
export class VaraModule { }
