import { Injectable } from '@angular/core';
import { Resolve, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';
import { Observable } from 'rxjs';

import { VaraModel } from '../models/vara.model';
import { VaraService } from '../services/vara.service';

@Injectable()
export class VaraResolver implements Resolve<VaraModel> {

  constructor(
    private modeloService: VaraService,
  ) { }

  resolve(
    route: ActivatedRouteSnapshot,
    _state: RouterStateSnapshot,
  ): Observable<VaraModel> | Promise<VaraModel> | VaraModel {
    return this.modeloService.obterPorId(route.params.id);
  }

}
