import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';

import { BaseService } from '@datasus/core';

import { EstoqueAuxiliarModel } from '../models/estoque-auxiliar.model';

@Injectable({
  providedIn: 'root'
})
export class EstoqueAuxiliarService extends BaseService {

  obterPorId(idItem: number, idUnidadeDispensadora: number): Observable<EstoqueAuxiliarModel> {
    return this.baseGet<EstoqueAuxiliarModel>(`/estoque-auxiliar/${idItem}/${idUnidadeDispensadora}`);
  }

  obterQuantidade(idItem: number, idUnidadeDispensadora: number): Observable<number> {
    return this.baseGet<number>(`/estoque-auxiliar/${idItem}/${idUnidadeDispensadora}/quantidade`);
  }

}
