import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';

import { BaseService, DominioItemModel, PageableRequestModel, PageableResponseModel } from '@datasus/core';

import { FabricanteModel } from '../models/fabricante.model';

@Injectable({
  providedIn: 'root'
})
export class FabricanteService extends BaseService {

  obterPorId(id: number): Observable<FabricanteModel> {
    return this.baseGet<FabricanteModel>(`/fabricante/${id}`);
  }

  obterTodos(): Observable<FabricanteModel[]> {
    return this.baseGet<FabricanteModel[]>('/fabricante');
  }

  obterTodosPaginado(body: PageableRequestModel<void>): Observable<PageableResponseModel<FabricanteModel>> {
    return this.basePost<PageableResponseModel<FabricanteModel>>('/fabricante/paginado', body);
  }

  obterDominio(): Observable<DominioItemModel[]> {
    return this.baseGet<DominioItemModel[]>('/fabricante/dominio');
  }

}
