import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';

import { BaseService, PageableRequestModel, PageableResponseModel } from '@datasus/core';

import { ModeloOficioModel } from '../models/modelo-oficio.model';

@Injectable()
export class ModeloOficioService extends BaseService {

  obterPorId(id: number): Observable<ModeloOficioModel> {
    return this.baseGet<ModeloOficioModel>(`/modelo-oficio/${id}`);
  }

  obterTodosPaginado(body: PageableRequestModel<ModeloOficioModel>): Observable<PageableResponseModel<ModeloOficioModel>> {
    return this.basePost<PageableResponseModel<ModeloOficioModel>>('/modelo-oficio/paginado', body);
  }

  incluir(body: ModeloOficioModel): Observable<ModeloOficioModel> {
    return this.basePost<ModeloOficioModel>('/modelo-oficio', body);
  }

  alterar(body: ModeloOficioModel, id: number): Observable<ModeloOficioModel> {
    return this.basePut<ModeloOficioModel>(`/modelo-oficio/${id}`, body);
  }

  excluir(id: number): Observable<void> {
    return this.baseDelete<void>(`/modelo-oficio/${id}`);
  }

}
