import { Injectable } from '@angular/core';
import { BaseService, PageableRequestModel, PageableResponseModel } from '@datasus/core';
import { Observable } from 'rxjs';
import { ProfissionalModel } from '../models/profissional.model';



@Injectable()
export class ProfissionalService extends BaseService {

  obterPorId(id: number): Observable<ProfissionalModel> {
    return this.baseGet<ProfissionalModel>(`/profissional/${id}`);
  }

  obterTodosPaginado(body: PageableRequestModel<ProfissionalModel>): Observable<PageableResponseModel<ProfissionalModel>> {
    return this.basePost<PageableResponseModel<ProfissionalModel>>('/profissional/paginado', body);
  }

  incluir(body: ProfissionalModel): Observable<ProfissionalModel> {
    return this.basePost<ProfissionalModel>('/profissional', body);
  }

  alterar(body: ProfissionalModel, id: number): Observable<ProfissionalModel> {
    return this.basePut<ProfissionalModel>(`/profissional/${id}`, body);
  }

  excluir(id: number): Observable<void> {
    return this.baseDelete<void>(`/profissional/${id}`);
  }

}
