/*
 Navicat Premium Data Transfer

 Source Server         : LOCALHOST
 Source Server Type    : PostgreSQL
 Source Server Version : 130004
 Source Host           : localhost:5432
 Source Catalog        : dfdp1
 Source Schema         : dbgeral

 Target Server Type    : PostgreSQL
 Target Server Version : 130004
 File Encoding         : 65001

 Date: 03/09/2021 16:32:07
*/


-- ----------------------------
-- Table structure for tb_municipio
-- ----------------------------
DROP TABLE IF EXISTS "dbgeral"."tb_municipio";
CREATE TABLE "dbgeral"."tb_municipio" (
  "co_municipio_ibge" varchar(6) COLLATE "pg_catalog"."default" NOT NULL,
  "co_regional_saude" varchar(4) COLLATE "pg_catalog"."default",
  "sg_uf" varchar(2) COLLATE "pg_catalog"."default",
  "co_macrorregional" varchar(4) COLLATE "pg_catalog"."default",
  "co_mesorregiao" varchar(4) COLLATE "pg_catalog"."default",
  "co_microrregiao" varchar(5) COLLATE "pg_catalog"."default",
  "co_uf_ibge" varchar(2) COLLATE "pg_catalog"."default",
  "no_municipio" varchar(60) COLLATE "pg_catalog"."default" NOT NULL,
  "sg_municipio" varchar(3) COLLATE "pg_catalog"."default",
  "nu_ddd" varchar(4) COLLATE "pg_catalog"."default",
  "nu_cep" varchar(8) COLLATE "pg_catalog"."default",
  "dv_municipio_ibge" varchar(1) COLLATE "pg_catalog"."default",
  "co_municipio_siafi" varchar(4) COLLATE "pg_catalog"."default",
  "co_municipio_siape" varchar(10) COLLATE "pg_catalog"."default",
  "co_sinpas" varchar(5) COLLATE "pg_catalog"."default",
  "co_regiao_correio" varchar(5) COLLATE "pg_catalog"."default",
  "st_municipio" varchar(10) COLLATE "pg_catalog"."default",
  "st_amazonia" varchar(1) COLLATE "pg_catalog"."default",
  "st_fronteira" varchar(1) COLLATE "pg_catalog"."default",
  "co_sucessor" varchar(6) COLLATE "pg_catalog"."default",
  "no_anterior" varchar(60) COLLATE "pg_catalog"."default",
  "st_comunidade_solidaria" varchar(1) COLLATE "pg_catalog"."default" DEFAULT 'N'::character varying,
  "st_seca" varchar(1) COLLATE "pg_catalog"."default" DEFAULT 'N'::character varying,
  "st_semi_arido" varchar(1) COLLATE "pg_catalog"."default",
  "st_prmi" varchar(1) COLLATE "pg_catalog"."default" DEFAULT 'N'::character varying,
  "st_calamidade" varchar(1) COLLATE "pg_catalog"."default" DEFAULT 'N'::character varying,
  "st_indigena" varchar(1) COLLATE "pg_catalog"."default" DEFAULT 'N'::character varying,
  "nu_distancia_capital" numeric(6,2),
  "st_capital" varchar(1) COLLATE "pg_catalog"."default" DEFAULT 'N'::character varying,
  "nu_area" numeric(10,3),
  "nu_latitude" varchar(10) COLLATE "pg_catalog"."default",
  "nu_longitude" varchar(10) COLLATE "pg_catalog"."default",
  "nu_altitude" numeric(4,0),
  "st_registro_ativo" varchar(1) COLLATE "pg_catalog"."default" DEFAULT 'S'::character varying,
  "nu_idh" numeric(5,4),
  "co_municipio_correio" varchar(6) COLLATE "pg_catalog"."default",
  "co_municipio_inss" varchar(5) COLLATE "pg_catalog"."default",
  "co_microrregional_saude" varchar(5) COLLATE "pg_catalog"."default",
  "st_pits" varchar(1) COLLATE "pg_catalog"."default",
  "st_quilombola" varchar(1) COLLATE "pg_catalog"."default",
  "co_seq_antigo" numeric(6,0),
  "no_popular" varchar(100) COLLATE "pg_catalog"."default",
  "co_regiao_metropolitana" varchar(4) COLLATE "pg_catalog"."default",
  "co_aglomerado_urbano" varchar(4) COLLATE "pg_catalog"."default",
  "nu_ano_extincao" varchar(4) COLLATE "pg_catalog"."default",
  "nu_ano_instalacao" varchar(4) COLLATE "pg_catalog"."default",
  "st_ibge" varchar(1) COLLATE "pg_catalog"."default",
  "co_municipio_svs" numeric(6,0),
  "no_municipio_acentuado" varchar(60) COLLATE "pg_catalog"."default",
  "st_ride" varchar(1) COLLATE "pg_catalog"."default" DEFAULT 'N'::character varying,
  "co_municipio_cnes" varchar(6) COLLATE "pg_catalog"."default",
  "st_sudam" varchar(1) COLLATE "pg_catalog"."default",
  "st_sudene" varchar(1) COLLATE "pg_catalog"."default",
  "st_cadsus" varchar(1) COLLATE "pg_catalog"."default" DEFAULT 'S'::character varying,
  "co_municipio_origem" varchar(6) COLLATE "pg_catalog"."default",
  "co_territorio_cidadania" numeric(3,0),
  "st_pse" varchar(1) COLLATE "pg_catalog"."default",
  "st_pan" varchar(1) COLLATE "pg_catalog"."default",
  "st_pacto_rminal" varchar(1) COLLATE "pg_catalog"."default",
  "co_municipio_tabnet_rj" varchar(6) COLLATE "pg_catalog"."default",
  "tp_tipologia_pndr" varchar(20) COLLATE "pg_catalog"."default",
  "co_grupo_pac2" varchar(2) COLLATE "pg_catalog"."default",
  "st_cnes" varchar(1) COLLATE "pg_catalog"."default" DEFAULT 'N'::character varying,
  "st_pacto" varchar(1) COLLATE "pg_catalog"."default",
  "st_cib_sas" varchar(1) COLLATE "pg_catalog"."default",
  "dt_manutencao" date,
  "co_regiao_saude" numeric(4,0)
)
;
COMMENT ON COLUMN "dbgeral"."tb_municipio"."co_municipio_ibge" IS 'Código IBGE do Município.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."co_regional_saude" IS 'Código da Regional de Saúde. Chave estrangeira com origem em TB_REGONAL_SAUDE.
Atualizado conforme resoluções RESOLUÇÃO SES/MG 3216/2012 e RESOLUÇÃO SES/MG 4659/2015 referentes às regionais do estado de Minas Gerais.
Última atualização em 28/03/2017.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."sg_uf" IS 'sigla da unidade da federaao';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."co_macrorregional" IS 'Código da Macrorregional de Saúde (se houver). Chave estrangeira com origem em TB_MACRORREGIONAL_SAUDE.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."co_mesorregiao" IS 'C¢digo IBGE da Mesorregiao a que o Munic¡pio pertence. Chave estrangeira com origem em TB_MESORREGIAO.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."co_microrregiao" IS 'C¢digo IBGE da Microrregiao a que o Munic¡pio pertence. Chave estrangeira com origem em TB_MICRORREGIAO.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."co_uf_ibge" IS 'C¢digo IBGE da Unidade da Federaao. Chave estrangeira com origem em TB_UF.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."no_municipio" IS 'nome do munic¡pio';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."sg_municipio" IS 'sigla do munic¡pio';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."nu_ddd" IS 'Código DDD do Município.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."nu_cep" IS 'Código CEP.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."dv_municipio_ibge" IS 'DV do código IBGE do Município.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."co_municipio_siafi" IS 'Código SIAFI do Município.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."co_municipio_siape" IS 'Código SIAPE do Município.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."co_sinpas" IS 'Código antigo SINPAS do Município.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."co_regiao_correio" IS 'Código da região do Correio.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."st_municipio" IS 'situaao do munic¡pio : ativo: munic¡pio em vigor. ignor: c¢digo atribu¡do para munic¡pio ignorado dentro do estado extin: munic¡pio extinto. trans: munic¡pio transferido de uma uf para outra. reg adm: regiao administrativa do distrito federal';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."st_amazonia" IS 'Indica ("S" ou "N") se faz parte da Amazônia Legal (conforme IBGE).';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."st_fronteira" IS 'indica ("s" ou "n") se faz parte da faixa de fronteira (conforme ibge).';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."co_sucessor" IS 'Para Munic¡pios com situaao EXTIN, indica o munic¡pio que o absorveu; para Munic¡pios com situaao TRANS, c¢digo do Munic¡pio na nova UF';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."no_anterior" IS 'nome anterior do munic¡pio, em caso de renomeao';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."st_comunidade_solidaria" IS 'Indica se o Município é atendido pela Comunidade Solidária.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."st_seca" IS 'Indica se o Município faz parte to polígono da seca.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."st_semi_arido" IS 'Indica se o Município faz parte da área do Semi-Árido.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."st_prmi" IS 'Indica se o Município é assistido pelo Programa de Redução da Mortalidade Infantil.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."st_calamidade" IS 'Indica se o Município está integrado ao Conselho Nacional de Defesa Civil.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."st_indigena" IS 'indica se o munic¡pio possui mun¡cipis ¡ndios';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."nu_distancia_capital" IS 'Distância em quilômetros da sede do Município até a sede da capital da UF.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."st_capital" IS 'indica ("s" ou "n") se  capital da uf';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."nu_area" IS 'Área em Km² do Município (Resolução 05 10/10/2002 - IBGE).';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."nu_latitude" IS 'Latitude da sede do Município.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."nu_longitude" IS 'Longitude da sede do Município.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."nu_altitude" IS 'Altitude do Município.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."st_registro_ativo" IS 'Indica se o registro está ativo.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."nu_idh" IS 'Número do Índice de Desenvolvimento Humano do município.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."co_municipio_correio" IS 'Código do município no correio.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."co_municipio_inss" IS 'Código do município no INSS.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."co_microrregional_saude" IS 'Código da Microrregional de Saúde. Chave estrangeira com origem em TB_MICRORREGIONAL_SAUDE.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."st_pits" IS 'indica se o munic¡pio possui mun¡cipios descendentes de quilombos';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."st_quilombola" IS 'indica se o munic¡pio possui mun¡cipis descendentes de quilombos.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."co_seq_antigo" IS 'Código sequencial de cidade referente a esse registro na DBGERAL do banco MSDF.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."no_popular" IS 'Outro(s) nome(s) pelo qual o município também é conhecido.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."co_regiao_metropolitana" IS 'C¢digo da Regiao Metropolitana ou Regiao Integrada de Desenvolvimento. Chave estrangeira com origem em TB_REGIAO_METROPOLITANA.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."co_aglomerado_urbano" IS 'Código do Aglomerado Urbano. Chave estrangeira com origem em TB_AGLOMERADO_URBANO.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."nu_ano_extincao" IS 'ano de extinao ou transferncia do munic¡pio';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."nu_ano_instalacao" IS 'ano de instalaao do munic¡pio (nao dispon¡vel para todos)';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."st_ibge" IS 'indica a origem do registro, se o munic¡pio pertence a tabela ibge ou nao. foi inclu¡do esse campo para atender as cidades satlites de bras¡lia que nao constam no ibge como munic¡pios.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."co_municipio_svs" IS 'c¢digo do municipio conforme a tabela utilizada pela svs';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."no_municipio_acentuado" IS 'nome do munic¡pio com acentuaao';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."st_ride" IS 'Identifica se o munic¡pio pertence a RIDE - RegiÆo Integrada de desenvolvimento do DF e entorno. (S ou N)';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."co_municipio_cnes" IS 'Código do município IBGE utilizado no Sistema do CNES. Este atributo foi necessário devido a
divergência dos códigos IBGEs atribuídos pelo DATASUS DF e RJ, esses códigos são fictícios e
dizem respeito as regiões administrativas do Distrito Federal e demais Municipios também. Fonte: http://cnes.datasus.gov.br/Lista_Tot_Es_Estado.asp. Atualizado em 22/04/2014';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."st_sudam" IS 'Indica se o municipio faz parte da área de atuação da Agência de Desenvolvimento da Amazônia.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."st_sudene" IS 'Indica se o municipio faz parte da área de atuação da Agência de Desenvolvimento do Nordeste.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."st_cadsus" IS 'Status utilizado como filtro para compor os domínios das tabelas do sistema CADSUS do RJ. S - sim, N - não.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."co_municipio_origem" IS 'Código IBGE do município do qual o município se originou (por desmembramento, emancipação, etc)';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."co_territorio_cidadania" IS 'Código do território da cidadania em que o município pertence. Chave estrangeira com origem na tabela tb_territorio_cidadania.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."st_pse" IS 'Indica se o município participa do Programa Saúde na Escola. S - sim participa e N - não participa. Os Municípios estão credenciados e definidos pelas seguintes portarias do MS: PORTARIA Nº 2.931, DE 4 DE DEZEMBRO DE 2008 e PORTARIA Nº 1.537, DE 15 DE JUNHO DE 2010.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."st_pan" IS 'Indica se o município participa da Programação Anual das Ações Municipais de Alimentação e Nutrição. S - sim participa e N - não participa.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."st_pacto_rminal" IS 'Indica se o município é prioritário no Pacto pela redução da Mortalidade Infantil Nordeste-Amazônia Legal. S - sim ou N - não. Esses municípios se comprometeram a reduzir em 5% ao ano, nos anos de 2009 e 2010, a taxa de mortalidade infantil e do componente neonatal. Deve-se remarcar que a redução da mortalidade infantil é uma das prioridades sanitárias do Pacto Pela Saúde, sendo um dos itens dos Termos de Compromisso de Gestão da União, Estados e Municípios. A fonte desta informação foi retirada do documento "Compromisso para Acelerar a Redução das Desigualdades na Região Nordeste e Amazônia Legal" do dia 17/08/2009.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."co_municipio_tabnet_rj" IS 'Código do município, também conhecido como CNV, gerado pelo TabNet no Rio de Janeiro. Esse código servirá para a conversão para o código IBGE que é utilizado pelos sistemas do DF. A fonte dessa informação foi o Sr. Jacques Levin, que ficou responsável em informar sobre possíveis alterações nesse código.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."tp_tipologia_pndr" IS 'Campo que armazena a tipologia em que se enquadra cada município dentro da PNDR. A Política Nacional de Desenvolvimento Regional (PNDR) é expressão da prioridade efetiva do tema. Como uma política de Estado, a PNDR vem sendo implementada para que possamos obter resultados conseqüentes na questão regional. Os municípios podem ser enquadrados nas seguintes tipologias: Alta Renda, Estagnada, Dinâmica e Baixa Renda. A fonte dessa informação é o Ministério da Integração Nacional. A GAAD recebeu email de Samuel Menezes de Castro no dia 29/06/2010, contendo uma planilha coma tipologia da PNDR para cada município, essa planilha tem como responsável Ubajara Berocan Leite, coordenador da CGIMP.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."st_cnes" IS 'Identifica se o registro é exclusivo para uso do CNES (Visa resolver os problemas com as RAs de Brasília) Utilizar ST_REGISTRO_ATIVO = ''S'' or ST_CNES = ''S''';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."st_pacto" IS 'Indicativo de existência de Pacto de Gestão. Onde S = Sim N = Não. Criando em 19/04/2013.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."st_cib_sas" IS 'Indicativo de existência de Pacto CIB. Criando em 22/04/2011.';
COMMENT ON COLUMN "dbgeral"."tb_municipio"."dt_manutencao" IS 'O campo armazena a data da manutenção do registro. Criado em 22/11/2013';
COMMENT ON TABLE "dbgeral"."tb_municipio" IS 'Contém informações a respeito dos Municípios existentes no Brasil (ativos e desativados).';

-- ----------------------------
-- Records of tb_municipio
-- ----------------------------
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539935', '5301', 'DF', '5301', '5301', '53001', '53', 'SETOR DE INDUSTRIA E ABASTECIMENTO', 'SIA', '61', '71205000', NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, NULL, 'S', NULL, NULL, NULL, '53001', 'N', 'N', NULL, NULL, '5301', '5301', NULL, NULL, 'N', NULL, 'SETOR DE INDÚSTRIA E ABASTECIMENTO', 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110143', '1101', 'RO', '1190', '1102', '11004', '11', 'NOVA UNIAO', NULL, '69', '78953000', '5', '0010', NULL, '26045', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 807.179, '-10,90400', '-62,56100', 250, 'S', 0.6800, NULL, NULL, '11900', 'S', 'N', 3342, NULL, '1190', '1190', NULL, '1997', 'S', 3870, 'NOVA UNIÃO', 'N', '110143', 'S', 'N', 'S', NULL, 29, 'N', 'N', 'N', '31', NULL, '03', 'N', NULL, NULL, NULL, 318);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110145', '1102', 'RO', '1190', '1102', '11007', '11', 'PARECIS', NULL, '69', '78989000', '0', '0012', '0012', '26046', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2548.691, '-12,17500', '-61,60300', 355, 'S', 0.6660, NULL, NULL, '11900', 'S', 'N', 3566, NULL, '1190', '1190', NULL, '1997', 'S', 3873, 'PARECIS', 'N', '110145', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '34', NULL, '03', 'N', NULL, NULL, NULL, 150);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110146', '1103', 'RO', '1190', '1102', '11008', '11', 'PIMENTEIRAS DO OESTE', NULL, '69', '78998000', '8', '0014', NULL, '26047', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 6014.726, '-13,48300', '-61,04700', 185, 'S', 0.7150, NULL, NULL, '11900', 'S', 'N', 3744, NULL, '1190', '1190', NULL, '1997', 'S', 3875, 'PIMENTEIRAS DO OESTE', 'N', '110146', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '36', NULL, '03', 'N', NULL, NULL, NULL, 151);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('120080', '1201', 'AC', '1290', '1202', '12004', '12', 'PORTO ACRE', NULL, '68', '69921000', '7', '0649', '0649', '24019', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 2984.643, '-9,58800', '-67,53300', 145, 'S', 0.6630, NULL, NULL, '12900', 'S', 'N', 3896, NULL, '1290', '1290', NULL, '1993', 'S', 14, 'PORTO ACRE', 'N', '120080', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '14', NULL, '03', 'N', NULL, NULL, NULL, 105);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130040', '1303', 'AM', '1301', '1301', '13001', '13', 'BARCELOS', NULL, '97', '69700000', '9', '0209', '0209', '03005', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 122475.728, '-0,97500', '-62,92400', 47, 'S', 0.5930, NULL, NULL, '13032', 'S', 'N', 496, NULL, '1390', '1390', NULL, '1931', 'S', 131, 'BARCELOS', 'N', '130040', 'S', 'N', 'S', NULL, 136, 'N', 'N', 'N', '8', NULL, '03', 'N', NULL, NULL, NULL, 334);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130050', '1302', 'AM', '1301', '1303', '13010', '13', 'BARREIRINHA', NULL, '92', '69160000', '8', '0211', '0211', '03006', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 5750.534, '-2,79300', '-57,07000', 19, 'S', 0.6450, NULL, NULL, '13022', 'S', 'N', 536, NULL, '1390', '1390', NULL, '1935', 'S', 132, 'BARREIRINHA', 'N', '130050', 'S', 'N', 'S', NULL, 17, 'N', 'N', 'N', '9', NULL, '03', 'N', NULL, NULL, NULL, 3);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130060', '1301', 'AM', '1301', '1302', '13003', '13', 'BENJAMIN CONSTANT', NULL, '97', '69630000', '7', '0213', '0213', '03007', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 8793.429, '-4,38300', '-70,03100', 65, 'S', 0.6400, NULL, NULL, '13011', 'S', 'N', 593, NULL, '1390', '1390', NULL, '1931', 'S', 133, 'BENJAMIN CONSTANT', 'N', '130060', 'S', 'N', 'S', NULL, 165, 'N', 'N', 'N', '10', NULL, '03', 'N', NULL, NULL, NULL, 286);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130068', '1302', 'AM', '1301', '1303', '13010', '13', 'BOA VISTA DO RAMOS', NULL, '92', '69195000', '0', '0297', '0297', '03055', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 2586.829, '-2,97000', '-57,59000', 32, 'S', 0.6420, NULL, NULL, '13021', 'S', 'N', 640, NULL, '1390', '1390', NULL, '1985', 'S', 135, 'BOA VISTA DO RAMOS', 'N', '130068', 'S', 'N', 'S', NULL, 17, 'N', 'N', 'N', '12', NULL, '03', 'N', NULL, NULL, NULL, 3);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130070', '1306', 'AM', '1301', '1304', '13011', '13', 'BOCA DO ACRE', NULL, '97', '69850000', '6', '0215', '0215', '03008', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 22348.948, '-8,75200', '-67,39800', 116, 'S', 0.6110, NULL, NULL, '13061', 'S', 'N', 644, NULL, '1390', '1390', NULL, '1934', 'S', 136, 'BOCA DO ACRE', 'N', '130070', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'S', '13', NULL, '03', 'N', NULL, NULL, NULL, 174);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130100', '1305', 'AM', '1301', '1302', '13004', '13', 'CARAUARI', NULL, '97', '69500000', '1', '0221', '0221', '03011', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 25767.348, '-4,88300', '-66,89600', 87, 'S', 0.5750, NULL, NULL, '13052', 'S', 'N', 1084, NULL, '1390', '1390', NULL, '1931', 'S', 140, 'CARAUARI', 'N', '130100', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '17', NULL, '03', 'N', NULL, NULL, NULL, 342);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130110', '1303', 'AM', '1301', '1303', '13007', '13', 'CAREIRO', NULL, '92', '69250000', '0', '0223', '0223', '03012', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 6091.547, '-3,76800', '-60,36900', 27, 'S', 0.6300, NULL, NULL, '13031', 'S', 'N', 1095, NULL, '1390', '1390', NULL, '1955', 'S', 141, 'CAREIRO', 'N', '130110', 'S', 'N', 'S', NULL, 44, 'S', 'N', 'N', '18', NULL, '03', 'N', NULL, NULL, NULL, 334);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130115', '1303', 'AM', '1301', '1303', '13007', '13', 'CAREIRO DA VARZEA', NULL, '92', '69255000', '9', '0965', '0965', '03072', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 2631.128, '-3,22100', '-59,82600', 25, 'S', 0.6580, NULL, NULL, '13031', 'S', 'N', 1096, NULL, '1301', '1390', NULL, '1989', 'S', 142, 'CAREIRO DA VÁRZEA', 'N', '130115', 'S', 'N', 'S', NULL, 44, 'S', 'N', 'N', '19', NULL, '03', 'N', NULL, NULL, NULL, 334);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130190', '1304', 'AM', '1301', '1303', '13009', '13', 'ITACOATIARA', NULL, '92', '69100000', '2', '0241', '0241', '03021', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 8891.993, '-3,14300', '-58,44400', 26, 'S', 0.7110, NULL, NULL, '13041', 'N', 'N', 2273, NULL, '1301', '1390', NULL, '1874', 'S', 152, 'ITACOATIARA', 'N', '130190', 'S', 'N', 'S', NULL, 44, 'S', 'N', 'S', '29', NULL, '01', 'N', NULL, NULL, NULL, 227);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130195', '1305', 'AM', '1301', '1302', '13004', '13', 'ITAMARATI', NULL, '97', '69510000', '1', '9837', '9837', '03062', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 25275.890, '-6,42500', '-68,25300', 60, 'S', 0.5050, NULL, NULL, '13052', 'S', 'N', 2310, NULL, '1390', '1390', NULL, '1985', 'S', 153, 'ITAMARATI', 'N', '130195', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '30', NULL, '03', 'N', NULL, NULL, NULL, 342);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130200', '1304', 'AM', '1301', '1303', '13009', '13', 'ITAPIRANGA', NULL, '92', '69120000', '9', '0243', '0243', '03022', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 4231.132, '-2,74900', '-58,02200', 43, 'S', 0.6940, NULL, NULL, '13041', 'S', 'N', 2352, NULL, '1390', '1390', NULL, '1935', 'S', 154, 'ITAPIRANGA', 'N', '130200', 'S', 'N', 'S', NULL, 44, 'N', 'N', 'N', '31', NULL, '03', 'N', NULL, NULL, NULL, 227);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130210', '1309', 'AM', '1301', '1301', '13002', '13', 'JAPURA', NULL, '97', '69495000', '8', '0245', '0245', '03023', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 55791.480, '-1,82600', '-66,59900', 50, 'S', 0.5770, NULL, NULL, '13091', 'S', 'N', 2500, NULL, '1390', '1390', NULL, '1955', 'S', 155, 'JAPURÁ', 'N', '130210', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '32', NULL, '03', 'N', NULL, NULL, NULL, 111);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130220', '1309', 'AM', '1301', '1302', '13004', '13', 'JURUA', NULL, '97', '69520000', '7', '0247', '0247', '03024', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 19400.418, '-3,48100', '-66,06900', 55, 'S', 0.5460, NULL, NULL, '13091', 'S', 'N', 2622, NULL, '1390', '1390', NULL, '1955', 'S', 156, 'JURUÁ', 'N', '130220', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '33', NULL, '03', 'N', NULL, NULL, NULL, 111);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130230', '1301', 'AM', '1301', '1302', '13003', '13', 'JUTAI', NULL, '97', '69660000', '6', '0249', '0249', '03025', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 69551.856, '-2,74700', '-66,76700', 48, 'S', 0.5330, NULL, NULL, '13013', 'S', 'N', 2632, NULL, '1390', '1390', NULL, '1955', 'S', 157, 'JUTAÍ', 'N', '130230', 'S', 'N', 'S', NULL, 165, 'N', 'N', 'N', '34', NULL, '03', 'N', NULL, NULL, NULL, 286);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130240', '1306', 'AM', '1301', '1304', '13012', '13', 'LABREA', NULL, '97', '69830000', '5', '0251', '0251', '03026', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 68229.009, '-7,25900', '-64,79800', 75, 'S', 0.5980, NULL, NULL, '13062', 'S', 'N', 2636, NULL, '1390', '1390', NULL, '1881', 'S', 158, 'LÁBREA', 'N', '130240', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '35', NULL, '03', 'N', NULL, NULL, NULL, 174);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130250', '1308', 'AM', '1301', '1303', '13007', '13', 'MANACAPURU', NULL, '92', '69400000', '4', '0253', '0253', '03027', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 7329.234, '-3,30000', '-60,62100', 60, 'S', 0.6630, NULL, NULL, '13082', 'N', 'N', 2846, NULL, '1301', '1390', NULL, '1894', 'S', 159, 'MANACAPURU', 'N', '130250', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'S', '36', NULL, '01', 'N', NULL, NULL, NULL, 282);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539925', '5301', 'DF', '5301', '5301', '53001', '53', 'VARJAO', NULL, '61', NULL, NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 11769, NULL, '5301', '5301', NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130255', '1303', 'AM', '1301', '1303', '13007', '13', 'MANAQUIRI', NULL, '92', '69435000', '3', '9839', '9839', '03063', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 3975.759, '-3,42800', '-60,45900', 48, 'S', 0.6630, NULL, NULL, '13031', 'S', 'N', 2848, NULL, '1390', '1390', NULL, '1985', 'S', 160, 'MANAQUIRI', 'N', '130255', 'S', 'N', 'S', NULL, 44, 'N', 'N', 'N', '37', NULL, '03', 'N', NULL, NULL, NULL, 334);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130260', '1303', 'AM', '1301', '1303', '13007', '13', 'MANAUS', NULL, '92', '69001970', '3', '0255', '0255', '03028', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'S', 11401.058, '-3,10200', '-60,02500', 92, 'S', 0.7740, NULL, NULL, '13031', 'N', 'N', 2850, NULL, '1301', '1301', NULL, '1833', 'S', 161, 'MANAUS', 'N', '130260', 'S', 'N', 'S', NULL, 44, 'S', 'S', 'S', '38', NULL, '01', 'N', NULL, NULL, NULL, 334);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130270', '1307', 'AM', '1301', '1304', '13013', '13', 'MANICORE', NULL, '97', '69280000', '2', '0257', '0257', '03029', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 48282.478, '-5,80900', '-61,30000', 45, 'S', 0.6210, NULL, NULL, '13072', 'S', 'N', 2862, NULL, '1390', '1390', NULL, '1877', 'S', 162, 'MANICORÉ', 'N', '130270', 'S', 'N', 'S', NULL, 119, 'N', 'N', 'N', '39', NULL, '03', 'N', NULL, NULL, NULL, 397);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130280', '1309', 'AM', '1301', '1301', '13002', '13', 'MARAA', NULL, '97', '69490000', '1', '0259', '0259', '03030', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 16910.419, '-1,85600', '-65,58100', 50, 'S', 0.5600, NULL, NULL, '13091', 'S', 'N', 2875, NULL, '1390', '1390', NULL, '1955', 'S', 163, 'MARAÃ', 'N', '130280', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '40', NULL, '03', 'N', NULL, NULL, NULL, 111);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130290', '1302', 'AM', '1301', '1303', '13010', '13', 'MAUES', NULL, '92', '69190000', '0', '0261', '0261', '03031', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 39988.394, '-3,38400', '-57,71900', 25, 'S', 0.6890, NULL, NULL, '13021', 'S', 'N', 2992, NULL, '1390', '1390', NULL, '1833', 'S', 164, 'MAUÉS', 'N', '130290', 'S', 'N', 'S', NULL, 17, 'S', 'N', 'S', '41', NULL, '03', 'N', NULL, NULL, NULL, 3);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110006', '1103', 'RO', '1190', '1102', '11008', '11', 'COLORADO DO OESTE', NULL, '69', '78996000', '4', '0023', '0023', '26008', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1451.058, '-13,11700', '-60,54200', 460, 'S', 0.7390, NULL, NULL, '11900', 'S', 'N', 1301, NULL, '1190', '1190', NULL, '1981', 'S', 3854, 'COLORADO DO OESTE', 'N', '110006', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '15', NULL, '03', 'N', NULL, NULL, NULL, 151);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110155', '1101', 'RO', '1190', '1102', '11004', '11', 'TEIXEIROPOLIS', NULL, '69', '78954000', '9', '0022', NULL, '26051', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 459.954, '-10,91800', '-62,24900', 260, 'S', 0.6850, NULL, NULL, '11900', 'S', 'N', 5133, NULL, '1190', '1190', NULL, '1997', 'S', 3886, 'TEIXEIRÓPOLIS', 'N', '110155', 'S', 'N', 'S', NULL, 29, 'N', 'N', 'N', '47', NULL, '03', 'N', NULL, NULL, NULL, 318);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('120005', '1202', 'AC', '1290', '1202', '12005', '12', 'ASSIS BRASIL', NULL, '68', '69935000', '4', '0157', '0157', '24001', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 2875.915, '-10,94100', '-69,56700', 239, 'S', 0.6700, NULL, NULL, '12900', 'S', 'N', 405, NULL, '1290', '1290', NULL, '1976', 'S', 2, 'ASSIS BRASIL', 'N', '120005', 'S', 'N', 'S', NULL, 4, 'S', 'N', 'N', '2', NULL, '03', 'N', NULL, NULL, NULL, 168);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('120025', '1202', 'AC', '1290', '1202', '12005', '12', 'EPITACIOLANDIA', NULL, '68', '69934000', '2', '0651', '0651', '24006', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1659.131, '-11,02900', '-68,74100', 0, 'S', 0.6840, NULL, NULL, '12900', 'S', 'N', 1657, NULL, '1290', '1290', NULL, '1993', 'S', 7, 'EPITACIOLÂNDIA', 'N', '120025', 'S', 'N', 'S', NULL, 4, 'S', 'N', 'N', '7', NULL, '03', 'N', NULL, NULL, NULL, 168);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130300', '1302', 'AM', '1301', '1303', '13010', '13', 'NHAMUNDA', NULL, '92', '69140000', '7', '0263', '0263', '03032', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 14105.619, '-2,18600', '-56,71300', 25, 'S', 0.6560, NULL, NULL, '13022', 'S', 'N', 3222, NULL, '1390', '1390', NULL, '1955', 'S', 165, 'NHAMUNDÁ', 'N', '130300', 'S', 'N', 'S', NULL, 17, 'N', 'N', 'N', '42', NULL, '03', 'N', NULL, NULL, NULL, 3);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130310', '1303', 'AM', '1301', '1303', '13009', '13', 'NOVA OLINDA DO NORTE', NULL, '92', '69230000', '6', '0265', '0265', '03033', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 5608.548, '-3,88800', '-59,09400', 32, 'S', 0.6290, NULL, NULL, '13031', 'S', 'N', 3316, NULL, '1390', '1390', NULL, '1955', 'S', 166, 'NOVA OLINDA DO NORTE', 'N', '130310', 'S', 'N', 'S', NULL, 44, 'N', 'N', 'N', '43', NULL, '03', 'N', NULL, NULL, NULL, 334);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130320', '1308', 'AM', '1301', '1301', '13001', '13', 'NOVO AIRAO', NULL, '92', '69730000', '5', '0201', '0201', '03001', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 37771.246, '-2,62100', '-60,94400', 45, 'S', 0.6560, NULL, NULL, '13082', 'S', 'N', 3350, NULL, '1301', '1390', NULL, '1955', 'S', 167, 'NOVO AIRÃO', 'N', '130320', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '44', NULL, '03', 'N', NULL, NULL, NULL, 282);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130330', '1307', 'AM', '1301', '1304', '13013', '13', 'NOVO ARIPUANA', NULL, '97', '69260000', '4', '0267', '0267', '03034', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 41191.345, '-5,12100', '-60,38000', 20, 'S', 0.6240, NULL, NULL, '13071', 'S', 'N', 3352, NULL, '1390', '1390', NULL, '1955', 'S', 168, 'NOVO ARIPUANÃ', 'N', '130330', 'S', 'N', 'S', NULL, 119, 'N', 'N', 'N', '45', NULL, '03', 'N', NULL, NULL, NULL, 397);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130340', '1302', 'AM', '1301', '1303', '13010', '13', 'PARINTINS', NULL, '92', '69150000', '3', '0269', '0269', '03035', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 5952.333, '-2,62800', '-56,73600', 27, 'S', 0.6960, NULL, NULL, '13022', 'N', 'N', 3569, NULL, '1390', '1390', NULL, '1848', 'S', 169, 'PARINTINS', 'N', '130340', 'S', 'N', 'S', NULL, 17, 'N', 'N', 'S', '46', NULL, '01', 'N', NULL, NULL, NULL, 3);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130350', '1306', 'AM', '1301', '1304', '13011', '13', 'PAUINI', NULL, '97', '69860000', '2', '0271', '0271', '03036', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 43263.388, '-7,71400', '-66,97600', 101, 'S', 0.5320, NULL, NULL, '13061', 'S', 'N', 3614, NULL, '1390', '1390', NULL, '1955', 'S', 170, 'PAUINI', 'N', '130350', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '47', NULL, '03', 'N', NULL, NULL, NULL, 174);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130430', '1304', 'AM', '1301', '1303', '13010', '13', 'URUCARA', NULL, '92', '69130000', '2', '0285', '0285', '03043', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 27904.858, '-2,53600', '-57,76000', 26, 'S', 0.6980, NULL, NULL, '13041', 'S', 'N', 5339, NULL, '1390', '1390', NULL, '1887', 'S', 184, 'URUCARÁ', 'N', '130430', 'S', 'N', 'S', NULL, 17, 'N', 'N', 'N', '61', NULL, '03', 'N', NULL, NULL, NULL, 227);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130440', '1304', 'AM', '1301', '1303', '13009', '13', 'URUCURITUBA', NULL, '92', '69180000', '1', '0287', '0287', '03044', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 2906.677, '-3,13100', '-58,15500', 40, 'S', 0.6630, NULL, NULL, '13041', 'S', 'N', 5343, NULL, '1390', '1390', NULL, '1935', 'S', 185, 'URUCURITUBA', 'N', '130440', 'S', 'N', 'S', NULL, 44, 'S', 'N', 'N', '62', NULL, '03', 'N', NULL, NULL, NULL, 227);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('140002', '1401', 'RR', '1490', '1401', '14001', '14', 'AMAJARI', NULL, '95', '69343000', '7', '0026', NULL, '27009', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 28472.223, '3,65200', '-61,37100', 100, 'S', 0.6540, NULL, NULL, '14900', 'S', 'N', 181, NULL, '1490', '1490', NULL, '1997', 'S', 3893, 'AMAJARI', 'N', '140002', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '2', NULL, '03', 'N', NULL, NULL, NULL, 207);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('140005', '1401', 'RR', '1490', '1401', '14001', '14', 'ALTO ALEGRE', NULL, '95', '69350000', '0', '0305', '0305', '27003', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 25566.845, '2,98000', '-61,29200', 72, 'S', 0.6620, NULL, NULL, '14900', 'S', 'N', 140, NULL, '1490', '1490', NULL, '1982', 'S', 3892, 'ALTO ALEGRE', 'N', '140005', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '1', NULL, '03', 'N', NULL, NULL, NULL, 207);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('140020', '1401', 'RR', '1490', '1402', '14003', '14', 'CARACARAI', NULL, '95', '69360000', '9', '0303', '0303', '27002', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 47410.891, '1,81600', '-61,12800', 52, 'S', 0.7020, NULL, NULL, '14900', 'S', 'N', 1071, NULL, '1403', '1490', NULL, '1955', 'S', 3897, 'CARACARAÍ', 'N', '140020', 'S', 'N', 'S', NULL, 91, 'N', 'N', 'N', '6', NULL, '03', 'N', NULL, NULL, NULL, 378);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('140023', '1401', 'RR', '1490', '1402', '14004', '14', 'CAROEBE', NULL, '95', '69378000', '3', '0030', '0302', '27011', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 12065.543, '0,88400', '-59,69600', 135, 'S', 0.6610, NULL, NULL, '14900', 'S', 'N', 1130, NULL, '1402', '1490', NULL, '1997', 'S', 3898, 'CAROEBE', 'N', '140023', 'S', 'N', 'S', NULL, 91, 'N', 'N', 'N', '7', NULL, '03', 'N', NULL, NULL, NULL, 378);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('140028', '1401', 'RR', '1490', '1402', '14003', '14', 'IRACEMA', NULL, '95', '69348000', '2', '0032', NULL, '27012', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 14119.412, '2,18200', '-61,04100', 80, 'S', 0.7130, NULL, NULL, '14900', 'S', 'N', 2230, NULL, '1403', '1490', NULL, '1997', 'S', 3899, 'IRACEMA', 'N', '140028', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '8', NULL, '03', 'N', NULL, NULL, NULL, 378);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539913', '5301', 'DF', '5301', '5301', '53001', '53', 'PARK WAY', NULL, '61', NULL, NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 11764, NULL, '5301', '5301', NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('140030', '1401', 'RR', '1490', '1402', '14003', '14', 'MUCAJAI', NULL, '95', '69340000', '8', '0309', '0309', '27005', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 12751.255, '2,43000', '-60,90000', 70, 'S', 0.7260, NULL, NULL, '14900', 'S', 'N', 3164, NULL, '1490', '1490', NULL, '1982', 'S', 3900, 'MUCAJAÍ', 'N', '140030', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '9', NULL, '03', 'N', NULL, NULL, NULL, 207);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('140050', '1401', 'RR', '1490', '1402', '14004', '14', 'SAO JOAO DA BALIZA', NULL, '95', '69375000', '6', '0313', '0313', '27007', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4284.122, '0,95100', '-59,91100', 255, 'S', 0.7290, NULL, NULL, '14900', 'S', 'N', 4629, NULL, '1402', '1490', NULL, '1982', 'S', 3904, 'SÃO JOÃO DA BALIZA', 'N', '140050', 'S', 'N', 'S', NULL, 91, 'S', 'N', 'N', '13', NULL, '03', 'N', NULL, NULL, NULL, 378);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('140060', '1401', 'RR', '1490', '1402', '14004', '14', 'SAO LUIZ', NULL, '95', '69370000', '5', '0315', '0315', '27008', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1526.892, '1,00500', '-60,15900', 52, 'S', 0.7040, NULL, NULL, '14900', 'S', 'N', 4759, NULL, '1402', '1490', NULL, '1982', 'S', 3905, 'SÃO LUIZ', 'N', '140060', 'S', 'N', 'S', NULL, 91, 'S', 'N', 'N', '14', NULL, '03', 'N', NULL, NULL, NULL, 378);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150040', '1509', 'PA', '1590', '1501', '15002', '15', 'ALENQUER', NULL, '93', '68200000', '4', '0407', '0407', '12004', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 22282.075, '-1,94200', '-54,73800', 52, 'S', 0.6730, NULL, NULL, '15900', 'S', 'N', 107, NULL, '1590', '1590', NULL, '1848', 'S', 2417, 'ALENQUER', 'N', '150040', 'S', 'N', 'S', NULL, 18, 'N', 'N', 'N', '6', NULL, '02', 'N', NULL, NULL, NULL, 446);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520700', '5298', 'GO', '5298', '5298', '52998', '52', 'DIANOPOLIS (TRANSF. P/TO)', NULL, NULL, ' ', '6', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '170700', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520700', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520755', '5298', 'GO', '5298', '5298', '52998', '52', 'FATIMA (TRANSF. P/TO)', NULL, NULL, NULL, '0', NULL, NULL, NULL, NULL, 'TRANS', NULL, 'N', '170755', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520755', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150050', '1509', 'PA', '1590', '1501', '15003', '15', 'ALMEIRIM', NULL, '93', '68230000', '3', '0409', '0409', '12005', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 72960.274, '-1,52300', '-52,58200', 65, 'S', 0.7450, NULL, NULL, '15900', 'S', 'N', 121, NULL, '1590', '1590', NULL, '1930', 'S', 2418, 'ALMEIRIM', 'N', '150050', 'S', 'N', 'S', NULL, 18, 'N', 'N', 'N', '7', NULL, '03', 'N', NULL, NULL, NULL, 446);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('666666', NULL, 'XX', NULL, NULL, NULL, 'XX', 'ESTRANGEIRO', NULL, NULL, NULL, '9', NULL, NULL, NULL, NULL, 'IGNOR', NULL, NULL, NULL, NULL, 'N', 'N', NULL, 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, 'ESTRANGEIRO', 'N', NULL, NULL, NULL, 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520820', '5298', 'GO', '5298', '5298', '52998', '52', 'FORMOSO DO ARAGUAIA (TRANSF. P/TO)', NULL, NULL, NULL, '2', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '170820', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520820', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521420', '5298', 'GO', '5298', '5298', '52998', '52', 'NATIVIDADE (TRANSF. P/TO)', NULL, NULL, NULL, '0', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '171420', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '521420', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('999999', NULL, 'XX', NULL, NULL, NULL, 'XX', 'INVALIDO', NULL, NULL, NULL, '9', NULL, NULL, NULL, NULL, 'IGNOR', NULL, NULL, NULL, NULL, 'N', 'N', NULL, 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, 'INVÁLIDO', 'N', NULL, NULL, NULL, 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110007', '1103', 'RO', '1190', '1102', '11008', '11', 'CORUMBIARA', NULL, '69', '78966000', '2', '0981', '0981', '26030', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 3060.318, '-12,96200', '-60,88700', 340, 'S', 0.6680, NULL, NULL, '11900', 'S', 'N', 1409, NULL, '1190', '1190', NULL, '1993', 'S', 3855, 'CORUMBIARA', 'N', '110007', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '16', NULL, '03', 'N', NULL, NULL, NULL, 151);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110008', '1101', 'RO', '1190', '1101', '11002', '11', 'COSTA MARQUES', NULL, '69', '78971000', '0', '0021', '0021', '26009', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 12722.168, '-12,44500', '-64,22700', 140, 'S', 0.6930, NULL, NULL, '11900', 'S', 'N', 1414, NULL, '1190', '1190', NULL, '1981', 'S', 3856, 'COSTA MARQUES', 'N', '110008', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '17', NULL, '03', 'N', NULL, NULL, NULL, 511);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110009', '1102', 'RO', '1190', '1102', '11006', '11', 'ESPIGAO D''OESTE', NULL, '69', '78983000', '8', '0025', '0025', '26010', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 4518.055, '-11,52500', '-61,01300', 270, 'S', 0.7380, NULL, NULL, '11900', 'S', 'N', 1680, NULL, '1190', '1190', NULL, '1981', 'S', 3858, 'ESPIGÃO D OESTE', 'N', '110009', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '19', NULL, '03', 'N', NULL, NULL, NULL, 86);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110010', '1104', 'RO', '1190', '1101', '11002', '11', 'GUAJARA-MIRIM', NULL, '69', '78957000', '6', '0001', '0001', '26001', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 24855.652, '-10,78300', '-65,33900', 128, 'S', 0.7430, NULL, NULL, '11900', 'S', 'N', 1961, NULL, '1190', '1190', NULL, '1943', 'S', 3860, 'GUAJARÁ-MIRIM', 'N', '110010', 'S', 'N', 'S', NULL, 53, 'N', 'N', 'N', '21', NULL, '03', 'N', NULL, NULL, NULL, 87);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110011', '1101', 'RO', '1190', '1102', '11004', '11', 'JARU', NULL, '69', '78940000', '4', '0015', '0015', '26011', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 2944.025, '-10,43900', '-62,46600', 124, 'S', 0.7290, NULL, NULL, '11900', 'N', 'N', 2519, NULL, '1190', '1190', NULL, '1981', 'S', 3862, 'JARU', 'N', '110011', 'S', 'N', 'S', NULL, 29, 'N', 'N', 'N', '23', NULL, '02', 'N', NULL, NULL, NULL, 318);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110013', '1104', 'RO', '1190', '1102', '11003', '11', 'MACHADINHO D''OESTE', NULL, '69', '78948000', '0', '0039', '0039', '26021', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 8509.274, '-9,44400', '-61,98100', 102, 'S', 0.6910, NULL, NULL, '11900', 'S', 'N', 2807, NULL, '1190', '1190', NULL, '1989', 'S', 3864, 'MACHADINHO D OESTE', 'N', '110013', 'S', 'N', 'S', NULL, 98, 'N', 'N', 'N', '25', NULL, '03', 'N', NULL, NULL, NULL, 149);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110014', '1102', 'RO', '1190', '1102', '11005', '11', 'NOVA BRASILANDIA D''OESTE', NULL, '69', '78974000', '8', '0041', '0041', '26019', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1155.353, '-11,72500', '-62,33100', 320, 'S', 0.6890, NULL, NULL, '11900', 'S', 'N', 3263, NULL, '1190', '1190', NULL, '1989', 'S', 3868, 'NOVA BRASILÂNDIA D OESTE', 'N', '110014', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '29', NULL, '03', 'N', NULL, NULL, NULL, 150);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110015', '1101', 'RO', '1190', '1102', '11004', '11', 'OURO PRETO DO OESTE', NULL, '69', '78950000', '5', '0017', '0017', '26012', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1970.151, '-10,71600', '-62,24800', 280, 'S', 0.7270, NULL, NULL, '11900', 'S', 'N', 3440, NULL, '1190', '1190', NULL, '1981', 'S', 3872, 'OURO PRETO DO OESTE', 'N', '110015', 'S', 'N', 'S', NULL, 29, 'N', 'N', 'N', '33', NULL, '03', 'N', NULL, NULL, NULL, 318);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110018', '1102', 'RO', '1190', '1102', '11007', '11', 'PIMENTA BUENO', NULL, '69', '78984000', '9', '0011', '0011', '26005', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 6241.072, '-11,67300', '-61,19300', 195, 'S', 0.7540, NULL, NULL, '11900', 'S', 'N', 3742, NULL, '1190', '1190', NULL, '1977', 'S', 3874, 'PIMENTA BUENO', 'N', '110018', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '35', NULL, '03', 'N', NULL, NULL, NULL, 86);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110025', '1101', 'RO', '1190', '1102', '11004', '11', 'PRESIDENTE MEDICI', NULL, '69', '78968000', '4', '0019', '0019', '26013', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1758.461, '-11,17600', '-61,90100', 185, 'S', 0.7070, NULL, NULL, '11900', 'S', 'N', 3979, NULL, '1190', '1190', NULL, '1981', 'S', 3877, 'PRESIDENTE MÉDICI', 'N', '110025', 'S', 'N', 'S', NULL, 29, 'N', 'N', 'N', '38', NULL, '03', 'N', NULL, NULL, NULL, 318);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110026', '1104', 'RO', '1190', '1102', '11003', '11', 'RIO CRESPO', NULL, '69', '78945000', '2', '0687', '0687', '26036', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1717.648, '-9,70500', '-62,90000', 0, 'S', 0.7120, NULL, NULL, '11900', 'S', 'N', 4148, NULL, '1190', '1190', NULL, '1993', 'S', 3879, 'RIO CRESPO', 'N', '110026', 'S', 'N', 'S', NULL, 98, 'N', 'N', 'N', '40', NULL, '03', 'N', NULL, NULL, NULL, 149);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110028', '1102', 'RO', '1190', '1102', '11006', '11', 'ROLIM DE MOURA', NULL, '69', '78987000', '8', '0029', '0029', '26015', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1457.885, '-11,73300', '-61,77800', 290, 'S', 0.7530, NULL, NULL, '11900', 'S', 'N', 4212, NULL, '1190', '1190', NULL, '1983', 'S', 3880, 'ROLIM DE MOURA', 'N', '110028', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '41', NULL, '02', 'N', NULL, NULL, NULL, 150);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110029', '1102', 'RO', '1190', '1102', '11006', '11', 'SANTA LUZIA D''OESTE', NULL, '69', '78993000', '6', '0043', '0043', '26018', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1197.781, '-11,90200', '-61,77900', 260, 'S', 0.6790, NULL, NULL, '11900', 'S', 'N', 4366, NULL, '1190', '1190', NULL, '1986', 'S', 3881, 'SANTA LUZIA D OESTE', 'N', '110029', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '42', NULL, '03', 'N', NULL, NULL, NULL, 150);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110030', '1103', 'RO', '1190', '1102', '11007', '11', 'VILHENA', NULL, '69', '78995000', '4', '0013', '0013', '26006', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 11518.929, '-12,74100', '-60,14600', 600, 'S', 0.7710, NULL, NULL, '11900', 'N', 'N', 5457, NULL, '1190', '1190', NULL, '1977', 'S', 3891, 'VILHENA', 'N', '110030', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '52', NULL, '02', 'N', NULL, NULL, NULL, 151);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110032', '1101', 'RO', '1190', '1102', '11005', '11', 'SAO MIGUEL DO GUAPORE', NULL, '69', '78970000', '0', '0045', '0045', '26022', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 8007.866, '-11,68100', '-62,68400', 205, 'S', 0.6690, NULL, NULL, '11900', 'S', 'N', 4786, NULL, '1190', '1190', NULL, '1989', 'S', 3884, 'SÃO MIGUEL DO GUAPORÉ', 'N', '110032', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '45', NULL, '03', 'N', NULL, NULL, NULL, 318);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110033', '1104', 'RO', '1190', '1101', '11001', '11', 'NOVA MAMORE', NULL, '69', '78939000', '8', '0047', '0047', '26023', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 10071.702, '-10,41100', '-65,33100', 134, 'S', 0.6590, NULL, NULL, '11900', 'S', 'N', 5595, NULL, '1190', '1190', NULL, '1989', 'S', 3869, 'NOVA MAMORÉ', 'N', '110033', 'S', 'N', 'S', NULL, 53, 'N', 'N', 'N', '30', NULL, '03', 'N', NULL, NULL, NULL, 87);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110034', '1101', 'RO', '1190', '1102', '11005', '11', 'ALVORADA D''OESTE', NULL, '69', '78969000', '6', '0035', '0035', '26017', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3029.190, '-11,40800', '-62,38900', 224, 'S', 0.6940, NULL, NULL, '11900', 'S', 'N', 176, NULL, '1190', '1190', NULL, '1986', 'S', 3843, 'ALVORADA D OESTE', 'N', '110034', 'S', 'N', 'S', NULL, 29, 'N', 'N', 'N', '4', NULL, '03', 'N', NULL, NULL, NULL, 318);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110037', '1102', 'RO', '1190', '1102', '11006', '11', 'ALTO ALEGRE DOS PARECIS', NULL, '69', '78994800', '9', '0002', NULL, '26041', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 3958.586, '-12,12800', '-61,85100', 405, 'S', 0.6740, NULL, NULL, '11900', 'S', 'N', 143, NULL, '1190', '1190', NULL, '1997', 'S', 3840, 'ALTO ALEGRE DOS PARECIS', 'N', '110037', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '2', NULL, '03', 'N', NULL, NULL, NULL, 150);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110040', '1104', 'RO', '1190', '1102', '11003', '11', 'ALTO PARAISO', NULL, '69', '78956000', '3', '0675', '0675', '26024', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2651.818, '-9,71300', '-63,32100', 0, 'S', 0.7150, NULL, NULL, '11900', 'S', 'N', 155, NULL, '1190', '1190', NULL, '1993', 'S', 3842, 'ALTO PARAÍSO', 'N', '110040', 'S', 'N', 'S', NULL, 98, 'N', 'N', 'N', '3', NULL, '03', 'N', NULL, NULL, NULL, 149);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110045', '1104', 'RO', '1190', '1101', '11001', '11', 'BURITIS', NULL, '69', '78967800', '2', '0004', NULL, '26042', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3265.739, '-10,21200', '-63,82900', 200, 'S', 0.6940, NULL, NULL, '11900', 'S', 'N', 800, NULL, '1190', '1190', NULL, '1997', 'S', 3845, 'BURITIS', 'N', '110045', 'S', 'N', 'S', NULL, 98, 'N', 'N', 'N', '6', NULL, '03', 'N', NULL, NULL, NULL, 149);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110050', '1102', 'RO', '1190', '1102', '11006', '11', 'NOVO HORIZONTE DO OESTE', NULL, '69', '78991000', '2', '0689', '0689', '26025', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 843.446, '-11,71000', '-62,00000', 0, 'S', 0.7070, NULL, NULL, '11900', 'S', 'N', 3363, NULL, '1190', '1190', NULL, '1993', 'S', 3871, 'NOVO HORIZONTE DO OESTE', 'N', '110050', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '32', NULL, '03', 'N', NULL, NULL, NULL, 150);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130063', '1308', 'AM', '1301', '1303', '13006', '13', 'BERURI', NULL, '97', '69430000', '1', '0295', '0295', '03053', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 17251.235, '-3,89800', '-61,37300', 35, 'S', 0.5750, NULL, NULL, '13082', 'S', 'N', 608, NULL, '1390', '1390', NULL, '1985', 'S', 134, 'BERURI', 'N', '130063', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '11', NULL, '03', 'N', NULL, NULL, NULL, 282);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350150', '3509', 'SP', '3510', '3509', '35038', '35', 'ALVINLANDIA', NULL, '14', '17430000', '9', '6129', '6129', '21015', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 85.040, '-22,44400', '-49,76300', 658, 'S', 0.7410, NULL, NULL, '35093', 'N', 'N', 172, NULL, '3590', '3590', NULL, '1959', 'S', 4759, 'ALVINLÂNDIA', 'N', '350150', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '18', NULL, '03', 'N', NULL, NULL, NULL, 96);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521750', '5298', 'GO', '5298', '5298', '52998', '52', 'PIUM (TRANSF. P/TO)', NULL, NULL, NULL, '0', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '171750', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '521750', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110060', '1104', 'RO', '1190', '1102', '11003', '11', 'CACAULANDIA', NULL, '69', '78944000', '1', '0677', '0677', '26026', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1961.745, '-10,34000', '-62,89600', 205, 'S', 0.7130, NULL, NULL, '11900', 'S', 'N', 824, NULL, '1190', '1190', NULL, '1993', 'S', 3847, 'CACAULÂNDIA', 'N', '110060', 'S', 'N', 'S', NULL, 98, 'N', 'N', 'N', '8', NULL, '03', 'N', NULL, NULL, NULL, 149);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521330', '5298', 'GO', '5298', '5298', '52998', '52', 'MIRANORTE (TRANSF. P/TO)', NULL, NULL, NULL, '1', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '171330', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '521330', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110070', '1104', 'RO', '1190', '1101', '11001', '11', 'CAMPO NOVO DE RONDONIA', NULL, '69', '78967000', '0', '0679', '0679', '26027', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 3442.003, '-10,57100', '-63,62700', 0, 'S', 0.6970, NULL, NULL, '11900', 'S', 'N', 970, NULL, '1190', '1190', NULL, '1993', 'S', 3849, 'CAMPO NOVO DE RONDÔNIA', 'N', '110070', 'S', 'N', 'S', NULL, 98, 'N', 'N', 'N', '10', NULL, '03', 'N', NULL, NULL, NULL, 149);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110080', '1104', 'RO', '1190', '1101', '11001', '11', 'CANDEIAS DO JAMARI', NULL, '69', '78938000', '9', '0681', '0681', '26028', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 6843.866, '-8,79100', '-63,70100', 0, 'S', 0.6710, NULL, NULL, '11900', 'S', 'N', 1003, NULL, '1190', '1190', NULL, '1993', 'S', 3850, 'CANDEIAS DO JAMARI', 'N', '110080', 'S', 'N', 'S', NULL, 53, 'N', 'N', 'N', '11', NULL, '03', 'N', NULL, NULL, NULL, 87);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110090', '1102', 'RO', '1190', '1102', '11006', '11', 'CASTANHEIRAS', NULL, '69', '78992000', '8', '0691', '0691', '26029', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 892.839, '-11,42700', '-61,95000', 190, 'S', 0.7020, NULL, NULL, '11900', 'S', 'N', 1157, NULL, '1190', '1190', NULL, '1993', 'S', 3851, 'CASTANHEIRAS', 'N', '110090', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '12', NULL, '03', 'N', NULL, NULL, NULL, 150);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110092', '1103', 'RO', '1190', '1102', '11007', '11', 'CHUPINGUAIA', NULL, '69', '78995800', '4', '0006', '0006', '26043', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 5126.675, '-12,55200', '-60,90000', 360, 'S', 0.7070, NULL, NULL, '11900', 'S', 'N', 1253, NULL, '1190', '1190', NULL, '1997', 'S', 3853, 'CHUPINGUAIA', 'N', '110092', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '14', NULL, '03', 'N', NULL, NULL, NULL, 151);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110094', '1104', 'RO', '1190', '1101', '11001', '11', 'CUJUBIM', NULL, '69', '78945800', '0', '0008', NULL, '26044', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3864.071, '-9,36300', '-62,58500', 95, 'S', 0.6950, NULL, NULL, '11900', 'S', 'N', 1475, NULL, '1190', '1190', NULL, '1997', 'S', 3857, 'CUJUBIM', 'N', '110094', 'S', 'N', 'S', NULL, 98, 'N', 'N', 'N', '18', NULL, '03', 'N', NULL, NULL, NULL, 149);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110100', '1101', 'RO', '1190', '1102', '11004', '11', 'GOVERNADOR JORGE TEIXEIRA', NULL, '69', '78946000', '5', '0693', '0693', '26031', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 5067.381, '-10,61000', '-62,73700', 190, 'S', 0.6830, NULL, NULL, '11900', 'S', 'N', 1923, NULL, '1190', '1190', NULL, '1993', 'S', 3859, 'GOVERNADOR JORGE TEIXEIRA', 'N', '110100', 'S', 'N', 'S', NULL, 29, 'N', 'N', 'N', '20', NULL, '03', 'N', NULL, NULL, NULL, 318);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110110', '1104', 'RO', '1190', '1101', '11001', '11', 'ITAPUA DO OESTE', NULL, '69', '78937000', '4', '0683', '0683', '26032', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4081.433, '-9,20500', '-63,18000', 0, 'S', 0.7020, NULL, NULL, '11900', 'S', 'N', 2368, NULL, '1190', '1190', NULL, '1993', 'S', 3861, 'ITAPUÃ DO OESTE', 'N', '110110', 'S', 'N', 'S', NULL, 53, 'N', 'N', 'N', '22', NULL, '03', 'N', NULL, NULL, NULL, 87);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110120', '1102', 'RO', '1190', '1102', '11006', '11', 'MINISTRO ANDREAZZA', NULL, '69', '78981000', '3', '0695', '0695', '26033', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 798.065, '-11,19600', '-61,51700', 400, 'S', 0.7010, NULL, NULL, '11900', 'S', 'N', 3036, NULL, '1190', '1190', NULL, '1993', 'S', 3865, 'MINISTRO ANDREAZZA', 'N', '110120', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '26', NULL, '03', 'N', NULL, NULL, NULL, 86);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110130', '1101', 'RO', '1190', '1102', '11004', '11', 'MIRANTE DA SERRA', NULL, '69', '78949000', '2', '0697', '0697', '26034', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1191.882, '-11,03000', '-62,67500', 230, 'S', 0.6910, NULL, NULL, '11900', 'S', 'N', 3055, NULL, '1190', '1190', NULL, '1993', 'S', 3866, 'MIRANTE DA SERRA', 'N', '110130', 'S', 'N', 'S', NULL, 29, 'N', 'N', 'N', '27', NULL, '03', 'N', NULL, NULL, NULL, 318);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110140', '1104', 'RO', '1190', '1102', '11003', '11', 'MONTE NEGRO', NULL, '69', '78965000', '1', '0685', '0685', '26035', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1931.371, '-10,24600', '-63,29000', 0, 'S', 0.6850, NULL, NULL, '11900', 'S', 'N', 3117, NULL, '1190', '1190', NULL, '1993', 'S', 3867, 'MONTE NEGRO', 'N', '110140', 'S', 'N', 'S', NULL, 98, 'N', 'N', 'N', '28', NULL, '03', 'N', NULL, NULL, NULL, 149);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150080', '1501', 'PA', '1590', '1503', '15007', '15', 'ANANINDEUA', NULL, '91', '67030970', '0', '0415', '0415', '12008', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 185.057, '-1,36600', '-48,37200', 17, 'S', 0.7820, NULL, NULL, '15900', 'N', 'N', 215, NULL, '1501', '1501', NULL, '1943', 'S', 2421, 'ANANINDEUA', 'N', '150080', 'S', 'N', 'S', NULL, NULL, 'S', 'S', 'S', '10', NULL, '01', 'N', NULL, NULL, NULL, 450);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150085', '1510', 'PA', '1590', '1505', '15015', '15', 'ANAPU', NULL, '91', '68365000', '9', '0040', NULL, '12129', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 11895.212, '-3,47200', '-51,19800', 96, 'S', 0.6450, NULL, NULL, '15900', 'S', 'N', 217, NULL, '1590', '1590', NULL, '1997', 'S', 2422, 'ANAPU', 'N', '150085', 'S', 'N', 'S', NULL, 95, 'N', 'N', 'N', '11', NULL, '03', 'N', NULL, NULL, NULL, 456);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539920', '5301', 'DF', '5301', '5301', '53001', '53', 'SAO SEBASTIAO', NULL, '61', '71690000', NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 11737, NULL, '5301', '5301', NULL, '1993', 'N', 817, NULL, 'N', '530160', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150070', '1508', 'PA', '1590', '1502', '15005', '15', 'ANAJAS', NULL, '91', '68810000', '1', '0413', '0413', '12007', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 6921.709, '-0,98700', '-49,94000', 10, 'S', 0.5950, NULL, NULL, '15900', 'S', 'N', 210, NULL, '1590', '1590', NULL, '1938', 'S', 2420, 'ANAJÁS', 'N', '150070', 'S', 'N', 'S', NULL, 129, 'N', 'N', 'N', '9', NULL, '03', 'N', NULL, NULL, NULL, 509);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230000', NULL, 'CE', NULL, NULL, NULL, '23', 'MUNICIPIO IGNORADO - CE ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IGNR', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', 0.00, 'N', NULL, NULL, NULL, NULL, 'N', 0.0000, NULL, NULL, NULL, 'N', 'N', NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110147', '1102', 'RO', '1190', '1102', '11007', '11', 'PRIMAVERA DE RONDONIA', NULL, '69', '78988000', '6', '0016', NULL, '26048', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 605.698, '-11,82800', '-61,32100', 210, 'S', 0.6910, NULL, NULL, '11900', 'S', 'N', 3989, NULL, '1190', '1190', NULL, '1997', 'S', 3878, 'PRIMAVERA DE RONDÔNIA', 'N', '110147', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '39', NULL, '03', 'N', NULL, NULL, NULL, 86);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110148', '1102', 'RO', '1190', '1102', '11007', '11', 'SAO FELIPE D''OESTE', NULL, '69', '78986000', '4', '0018', NULL, '26049', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 541.639, '-11,90300', '-61,50200', 290, 'S', 0.6940, NULL, NULL, '11900', 'S', 'N', 4569, NULL, '1190', '1190', NULL, '1997', 'S', 3882, 'SÃO FELIPE D OESTE', 'N', '110148', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '43', NULL, '03', 'N', NULL, NULL, NULL, 86);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110149', '1101', 'RO', '1190', '1101', '11002', '11', 'SAO FRANCISCO DO GUAPORE', NULL, '69', '78973000', '2', '0020', NULL, '26050', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4747.002, '-12,06200', '-63,56900', 185, 'S', 0.7200, NULL, NULL, '11900', 'S', 'N', 4594, NULL, '1190', '1190', NULL, '1997', 'S', 3883, 'SÃO FRANCISCO DO GUAPORÉ', 'N', '110149', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '44', NULL, '03', 'N', NULL, NULL, NULL, 511);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520730', '5298', 'GO', '5298', '5298', '52998', '52', 'DUERE (TRANSF. P/TO)', NULL, NULL, ' ', '3', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '170730', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520730', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110150', '1101', 'RO', '1190', '1102', '11005', '11', 'SERINGUEIRAS', NULL, '69', '78990000', '0', '0699', '0699', '26037', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2251.266, '-11,79800', '-63,03100', 0, 'S', 0.6870, NULL, NULL, '11900', 'S', 'N', 4929, NULL, '1190', '1190', NULL, '1993', 'S', 3885, 'SERINGUEIRAS', 'N', '110150', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '46', NULL, '03', 'N', NULL, NULL, NULL, 511);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('530000', NULL, 'DF', NULL, NULL, NULL, '53', 'MUNICIPIO IGNORADO - DF ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IGNR', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', 0.00, 'N', NULL, NULL, NULL, NULL, 'S', 0.0000, NULL, NULL, NULL, 'N', 'N', NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520220', '5298', 'GO', '5298', '5298', '52998', '52', 'ARAGUATINS (TRANSF. P/TO)', NULL, NULL, NULL, '5', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '170220', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520220', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520240', '5298', 'GO', '5298', '5298', '52998', '52', 'ARRAIAS (TRANSF. P/TO)', NULL, NULL, NULL, '3', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '170240', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520240', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520290', '5298', 'GO', '5298', '5298', '52998', '52', 'AXIXA DE GOIAS (TRANSF. P/TO)', NULL, NULL, NULL, '8', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '170290', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520290', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521240', '5298', 'GO', '5298', '5298', '52998', '52', 'LIZARDA (TRANSF. P/TO)', NULL, NULL, NULL, '2', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '171240', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '521240', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539907', '5301', 'DF', '5301', '5301', '53001', '53', 'GUARA', NULL, '61', '71000000', NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 11762, NULL, '5301', '5301', NULL, '1968', 'N', 807, NULL, 'N', '530070', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539911', '5301', 'DF', '5301', '5301', '53001', '53', 'OCTOGONAL', NULL, '61', NULL, NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 11763, NULL, '5301', '5301', NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539934', '5301', 'DF', '5301', '5301', '53001', '53', 'VICENTE PIRES', NULL, '61', NULL, NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, NULL, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 12140, NULL, '5301', '5301', NULL, '2009', 'N', NULL, NULL, 'N', '539934', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150090', '1504', 'PA', '1590', '1504', '15010', '15', 'AUGUSTO CORREA', NULL, '91', '68610000', '9', '0417', '0417', '12009', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1091.043, '-1,02200', '-46,64500', 20, 'S', 0.6180, NULL, NULL, '15900', 'S', 'N', 420, NULL, '1590', '1590', NULL, '1961', 'S', 2423, 'AUGUSTO CORRÊA', 'N', '150090', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '12', NULL, '03', 'N', NULL, NULL, NULL, 453);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539908', '5301', 'DF', '5301', '5301', '53001', '53', 'LAGO NORTE', NULL, '61', '71500000', NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 11729, NULL, '5301', '5301', NULL, '1994', 'N', 808, NULL, 'N', '530080', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539909', '5301', 'DF', '5301', '5301', '53001', '53', 'LAGO SUL', NULL, '61', '71600000', NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 11730, NULL, '5301', '5301', NULL, '1994', 'N', 809, NULL, 'N', '530090', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539910', '5301', 'DF', '5301', '5301', '53001', '53', 'NUCLEO BANDEIRANTE', NULL, '61', '71700000', NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 11731, NULL, '5301', '5301', NULL, '1956', 'N', 810, NULL, 'N', '530100', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539912', '5301', 'DF', '5301', '5301', '53001', '53', 'PARANOA', NULL, '61', '71570000', NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 11732, NULL, '5301', '5301', NULL, '1989', 'N', 811, NULL, 'N', '530110', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539914', '5301', 'DF', '5301', '5301', '53001', '53', 'PLANALTINA', NULL, '61', '73300000', NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 11733, NULL, '5301', '5301', NULL, '1959', 'N', 812, NULL, 'N', '530120', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539915', '5301', 'DF', '5301', '5301', '53001', '53', 'RECANTO DAS EMAS', NULL, '61', '72600000', NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 11734, NULL, '5301', '5301', NULL, '1993', 'N', 813, NULL, 'N', '530130', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150095', '1505', 'PA', '1590', '1504', '15013', '15', 'AURORA DO PARA', NULL, '91', '68658000', '8', '0389', '0389', '12107', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1811.827, '-2,13400', '-47,56300', 50, 'S', 0.6180, NULL, NULL, '15900', 'S', 'N', 429, NULL, '1590', '1590', NULL, '1993', 'S', 2424, 'AURORA DO PARÁ', 'N', '150095', 'S', 'N', 'S', NULL, 61, 'N', 'N', 'N', '13', NULL, '03', 'N', NULL, NULL, NULL, 452);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150100', '1509', 'PA', '1590', '1505', '15014', '15', 'AVEIRO', NULL, '93', '68150000', '6', '0419', '0419', '12010', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 17074.290, '-3,60600', '-55,33200', 28, 'S', 0.6350, NULL, NULL, '15900', 'S', 'N', 435, NULL, '1590', '1590', NULL, '1961', 'S', 2425, 'AVEIRO', 'N', '150100', 'S', 'N', 'S', NULL, 114, 'N', 'N', 'N', '14', NULL, '03', 'N', NULL, NULL, NULL, 454);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522080', '5298', 'GO', '5298', '5298', '52998', '52', 'SITIO NOVO DE GOIAS (TRANSF. P/TO)', NULL, NULL, NULL, '1', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '172080', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '522080', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210000', NULL, 'MA', NULL, NULL, NULL, '21', 'MUNICIPIO IGNORADO - MA ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IGNR', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', 0.00, 'N', NULL, NULL, NULL, NULL, 'N', 0.0000, NULL, NULL, NULL, 'N', 'N', NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220000', NULL, 'PI', NULL, NULL, NULL, '22', 'MUNICIPIO IGNORADO - PI ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IGNR', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', 0.00, 'N', NULL, NULL, NULL, NULL, 'N', 0.0000, NULL, NULL, NULL, 'N', 'N', NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150110', '1508', 'PA', '1590', '1502', '15004', '15', 'BAGRE', NULL, '91', '68475000', '5', '0421', '0421', '12011', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4397.290, '-1,90000', '-50,16400', 31, 'S', 0.5710, NULL, NULL, '15900', 'S', 'N', 448, NULL, '1590', '1590', NULL, '1961', 'S', 2426, 'BAGRE', 'N', '150110', 'S', 'N', 'S', NULL, 129, 'N', 'N', 'N', '15', NULL, '03', 'N', NULL, NULL, NULL, 509);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250000', NULL, 'PB', NULL, NULL, NULL, '25', 'MUNICIPIO IGNORADO - PB ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IGNR', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', 0.00, 'N', NULL, NULL, NULL, NULL, 'N', 0.0000, NULL, NULL, NULL, 'N', 'N', NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260000', NULL, 'PE', NULL, NULL, NULL, '26', 'MUNICIPIO IGNORADO - PE ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IGNR', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', 0.00, 'N', NULL, NULL, NULL, NULL, 'N', 0.0000, NULL, NULL, NULL, 'N', 'N', NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290000', NULL, 'BA', NULL, NULL, NULL, '29', 'MUNICIPIO IGNORADO - BA ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IGNR', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', 0.00, 'N', NULL, NULL, NULL, NULL, 'N', 0.0000, NULL, NULL, NULL, 'N', 'N', NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410000', NULL, 'PR', NULL, NULL, NULL, '41', 'MUNICIPIO IGNORADO - PR ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IGNR', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', 0.00, 'N', NULL, NULL, NULL, NULL, 'N', 0.0000, NULL, NULL, NULL, 'N', 'N', NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420000', NULL, 'SC', NULL, NULL, NULL, '42', 'MUNICIPIO IGNORADO - SC ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IGNR', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', 0.00, 'N', NULL, NULL, NULL, NULL, 'N', 0.0000, NULL, NULL, NULL, 'N', 'N', NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520000', NULL, 'GO', NULL, NULL, NULL, '52', 'MUNICIPIO IGNORADO - GO ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IGNR', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', 0.00, 'N', NULL, NULL, NULL, NULL, 'N', 0.0000, NULL, NULL, NULL, 'N', 'N', NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522120', '5298', 'GO', '5298', '5298', '52998', '52', 'TOCANTINOPOLIS (TRANSF. P/TO)', NULL, NULL, NULL, '5', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '172120', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '522120', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520255', '5298', 'GO', '5298', '5298', '52998', '52', 'AUGUSTINOPOLIS (TRANSF. P/TO)', NULL, NULL, NULL, '1', NULL, NULL, NULL, NULL, 'TRANS', NULL, 'N', '170255', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520255', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521488', '5298', 'GO', '5298', '5298', '52998', '52', 'NOVA OLINDA (TRANSF. P/TO)', NULL, NULL, NULL, '7', NULL, NULL, NULL, NULL, 'TRANS', NULL, 'N', '171488', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '521488', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521875', '5298', 'GO', '5298', '5298', '52998', '52', 'RIO SONO (TRANSF. P/TO)', NULL, NULL, NULL, '5', NULL, NULL, NULL, NULL, 'TRANS', NULL, 'N', '171875', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '521875', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539916', '5301', 'DF', '5301', '5301', '53001', '53', 'RIACHO FUNDO', NULL, '61', '71800000', NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 11735, NULL, '5301', '5301', NULL, '1993', 'N', 814, NULL, 'N', '530135', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539917', '5301', 'DF', '5301', '5301', '53001', '53', 'RIACHO FUNDO II', NULL, '61', NULL, NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 11765, NULL, '5301', '5301', NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539918', '5301', 'DF', '5301', '5301', '53001', '53', 'SAMAMBAIA', NULL, '61', '72300000', NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 11766, NULL, '5301', '5301', NULL, '1989', 'N', 815, NULL, 'N', '530140', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539919', '5301', 'DF', '5301', '5301', '53001', '53', 'SANTA MARIA', NULL, '61', '72500000', NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 11736, NULL, '5301', '5301', NULL, '1993', 'N', 816, NULL, 'N', '530150', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539921', '5301', 'DF', '5301', '5301', '53001', '53', 'SOBRADINHO', NULL, '61', '73000000', NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 5592, NULL, '5301', '5301', NULL, '1960', 'N', 818, NULL, 'N', '530170', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539922', '5301', 'DF', '5301', '5301', '53001', '53', 'SOBRADINHO II', NULL, '61', NULL, NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 11767, NULL, '5301', '5301', NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539923', '5301', 'DF', '5301', '5301', '53001', '53', 'SUDOESTE', NULL, '61', NULL, NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 11768, NULL, '5301', '5301', NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539924', '5301', 'DF', '5301', '5301', '53001', '53', 'TAGUATINGA', NULL, '61', '72000000', NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 5614, NULL, '5301', '5301', NULL, '1958', 'N', 819, NULL, 'N', '530180', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520040', '5298', 'GO', '5298', '5298', '52998', '52', 'ALMAS (TRANSF. P/TO)', NULL, NULL, NULL, '7', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '170040', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520040', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539901', '5301', 'DF', '5301', '5301', '53001', '53', 'AGUAS CLARAS', NULL, '61', 'gg', NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 11761, NULL, '5301', '5301', NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539902', '5301', 'DF', '5301', '5301', '53001', '53', 'BRAZLANDIA', NULL, '61', '72000000', NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 11740, NULL, '5301', '5301', NULL, '1933', 'N', 802, NULL, 'N', '530020', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539903', '5301', 'DF', '5301', '5301', '53001', '53', 'CANDANGOLANDIA', NULL, '61', '71720000', NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 11727, NULL, '5301', '5301', NULL, '1956', 'N', 803, NULL, 'N', '530030', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539904', '5301', 'DF', '5301', '5301', '53001', '53', 'CEILANDIA', NULL, '61', '72200000', NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 5593, NULL, '5301', '5301', NULL, '1971', 'N', 804, NULL, 'N', '530040', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539905', '5301', 'DF', '5301', '5301', '53001', '53', 'CRUZEIRO', NULL, '61', '70600000', NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 11725, NULL, '5301', '5301', NULL, '1959', 'N', 805, NULL, 'N', '530050', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539906', '5301', 'DF', '5301', '5301', '53001', '53', 'GAMA', NULL, '61', '72400000', NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 11728, NULL, '5301', '5301', NULL, '1960', 'N', 806, NULL, 'N', '530060', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150120', '1513', 'PA', '1590', '1504', '15011', '15', 'BAIAO', NULL, '91', '68465000', '4', '0423', '0423', '12012', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3758.273, '-2,79100', '-49,67200', 30, 'S', 0.6770, NULL, NULL, '15900', 'S', 'N', 452, NULL, '1590', '1590', NULL, '1833', 'S', 2427, 'BAIÃO', 'N', '150120', 'S', 'N', 'S', NULL, 130, 'N', 'N', 'N', '16', NULL, '03', 'N', NULL, NULL, NULL, 455);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150130', '1506', 'PA', '1590', '1503', '15007', '15', 'BARCARENA', NULL, '91', '68445000', '3', '0425', '0425', '12013', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1310.325, '-1,50600', '-48,62600', 15, 'S', 0.7680, NULL, NULL, '15900', 'N', 'N', 494, NULL, '1590', '1501', NULL, '1943', 'S', 2429, 'BARCARENA', 'N', '150130', 'S', 'N', 'S', NULL, 130, 'N', 'N', 'N', '18', NULL, '01', 'N', NULL, NULL, NULL, 455);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539930', '5301', 'DF', '5301', '5301', '53001', '53', 'JARDIM BOTANICO', NULL, '61', '71680000', NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, NULL, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 11918, NULL, '5301', '5301', NULL, NULL, 'N', NULL, 'JARDIM BOTÂNICO', 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539931', '5301', 'DF', '5301', '5301', '53001', '53', 'SUDOESTE / OCTOGONAL', NULL, '61', NULL, NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', NULL, '5301', '5301', NULL, '2003', NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150145', '1509', 'PA', '1590', '1501', '15002', '15', 'BELTERRA', NULL, '93', '68143000', '1', '0044', NULL, '12131', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4398.346, '-2,63600', '-54,93700', 152, 'S', 0.6470, NULL, NULL, '15900', 'S', 'N', 588, NULL, '1590', '1590', NULL, '1997', 'S', 2431, 'BELTERRA', 'N', '150145', 'S', 'N', 'S', NULL, 18, 'S', 'N', 'N', '20', NULL, '03', 'N', NULL, NULL, NULL, 446);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150150', '1501', 'PA', '1590', '1503', '15007', '15', 'BENEVIDES', NULL, '91', '68795000', '1', '0429', '0429', '12015', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 187.868, '-1,36100', '-48,24500', 28, 'S', 0.7110, NULL, NULL, '15900', 'S', 'N', 592, NULL, '1501', '1501', NULL, '1961', 'S', 2432, 'BENEVIDES', 'N', '150150', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '21', NULL, '01', 'N', NULL, NULL, NULL, 450);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539927', '5301', 'DF', '5301', '5301', '53001', '53', 'ASA NORTE', NULL, '61', NULL, NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 11724, NULL, '5301', '5301', NULL, NULL, 'N', NULL, NULL, 'N', '530005', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539928', '5301', 'DF', '5301', '5301', '53001', '53', 'ITAPUA', NULL, '61', NULL, NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 11808, NULL, '5301', '5301', NULL, NULL, 'N', NULL, 'ITAPUÃ', 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539929', '5301', 'DF', '5301', '5301', '53001', '53', 'ESTRUTURAL', NULL, '61', NULL, NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 11810, NULL, '5301', '5301', NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521320', '5298', 'GO', '5298', '5298', '52998', '52', 'MIRACEMA DO NORTE (TRANSF. P/TO)', NULL, NULL, NULL, '2', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '171320', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '521320', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521430', '5298', 'GO', '5298', '5298', '52998', '52', 'NAZARE (TRANSF. P/TO)', NULL, NULL, NULL, '9', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '171430', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '521430', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521610', '5298', 'GO', '5298', '5298', '52998', '52', 'PARAISO DO NORTE DE GOIAS (TRANSF. P/TO)', NULL, NULL, NULL, '6', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '171610', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '521610', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521660', '5298', 'GO', '5298', '5298', '52998', '52', 'PEIXE (TRANSF. P/TO)', NULL, NULL, NULL, '1', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '171660', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '521660', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521790', '5298', 'GO', '5298', '5298', '52998', '52', 'PONTE ALTA DO NORTE (TRANSF. P/TO)', NULL, NULL, NULL, '6', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '171790', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '521790', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521840', '5298', 'GO', '5298', '5298', '52998', '52', 'PRESIDENTE KENNEDY (TRANSF. P/TO)', NULL, NULL, NULL, '9', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '171840', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '521840', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520200', '5298', 'GO', '5298', '5298', '52998', '52', 'ARAGUACU (TRANSF. P/TO)', NULL, NULL, NULL, '7', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '170200', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520200', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240000', NULL, 'RN', NULL, NULL, NULL, '24', 'MUNICIPIO IGNORADO - RN ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IGNR', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', 0.00, 'N', NULL, NULL, NULL, NULL, 'N', 0.0000, NULL, NULL, NULL, 'N', 'N', NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520950', '5298', 'GO', '5298', '5298', '52998', '52', 'GURUPI (TRANSF. P/TO)', NULL, NULL, NULL, '7', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '170950', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520950', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521070', '5298', 'GO', '5298', '5298', '52998', '52', 'ITAGUATINS (TRANSF. P/TO)', NULL, NULL, NULL, '3', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '171070', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '521070', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521780', '5298', 'GO', '5298', '5298', '52998', '52', 'PONTE ALTA DO BOM JESUS (TRANSF. P/TO)', NULL, NULL, NULL, '7', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '171780', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '521780', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539933', '5301', 'DF', '5301', '5301', '53001', '53', 'SCIA/Estrutural', NULL, '61', NULL, NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', NULL, '5301', '5301', NULL, NULL, NULL, 'N', NULL, 'SCIA/Estrutural', 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, '2018-07-10', NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520610', '5298', 'GO', '5298', '5298', '52998', '52', 'CRISTALANDIA (TRANSF. P/TO)', NULL, NULL, '88801970', '7', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '170610', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520610', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521050', '5298', 'GO', '5298', '5298', '52998', '52', 'ITACAJA (TRANSF. P/TO)', NULL, NULL, NULL, '5', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '171050', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '521050', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520720', '5298', 'GO', '5298', '5298', '52998', '52', 'DOIS IRMAOS (TRANSF. P/TO)', NULL, NULL, ' ', '4', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '170720', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520720', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521820', '5298', 'GO', '5298', '5298', '52998', '52', 'PORTO NACIONAL (TRANSF. P/TO)', NULL, NULL, NULL, '1', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '171820', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '521820', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522030', '5298', 'GO', '5298', '5298', '52998', '52', 'SAO SEBASTIAO DO TOCANTINS (TRANSF. P/TO)', NULL, NULL, NULL, '6', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '172030', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '522030', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522090', '5298', 'GO', '5298', '5298', '52998', '52', 'TAGUATINGA (TRANSF. P/TO)', NULL, NULL, NULL, '0', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '172090', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '522090', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522110', '5298', 'GO', '5298', '5298', '52998', '52', 'TOCANTINIA (TRANSF. P/TO)', NULL, NULL, NULL, '6', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '172110', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '522110', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522210', '5298', 'GO', '5298', '5298', '52998', '52', 'XAMBIOA (TRANSF. P/TO)', NULL, NULL, NULL, '4', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '172210', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '522210', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520765', '5298', 'GO', '5298', '5298', '52998', '52', 'FIGUEIROPOLIS (TRANSF. P/TO)', NULL, NULL, NULL, '9', NULL, NULL, NULL, NULL, 'TRANS', NULL, 'N', '170765', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520765', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521575', '5298', 'GO', '5298', '5298', '52998', '52', 'PALMEIROPOLIS (TRANSF. P/TO)', NULL, NULL, NULL, '1', NULL, NULL, NULL, NULL, 'TRANS', NULL, 'N', '171575', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '521575', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522065', '5298', 'GO', '5298', '5298', '52998', '52', 'SILVANOPOLIS (TRANSF. P/TO)', NULL, NULL, NULL, '2', NULL, NULL, NULL, NULL, 'TRANS', NULL, 'N', '172065', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '522065', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522208', '5298', 'GO', '5298', '5298', '52998', '52', 'WANDERLANDIA (TRANSF. P/TO)', NULL, NULL, NULL, '8', NULL, NULL, NULL, NULL, 'TRANS', NULL, 'N', '172208', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '522208', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520550', '5298', 'GO', '5298', '5298', '52998', '52', 'COLINAS DE GOIAS (TRANSF. P/TO)', NULL, NULL, '77655000', '5', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '170550', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520550', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521670', '5298', 'GO', '5298', '5298', '52998', '52', 'COLMEIA (TRANSF. P/TO)', NULL, NULL, NULL, '0', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '171670', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '521670', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520560', '5298', 'GO', '5298', '5298', '52998', '52', 'CONCEICAO DO NORTE (TRANSF. P/TO)', NULL, NULL, '77305000', '4', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '170560', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520560', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520600', '5298', 'GO', '5298', '5298', '52998', '52', 'COUTO DE MAGALHAES (TRANSF. P/TO)', NULL, NULL, '77750000', '8', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '170600', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520600', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521510', '5298', 'GO', '5298', '5298', '52998', '52', 'NOVO ACORDO (TRANSF. P/TO)', NULL, NULL, NULL, '8', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '171510', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '521510', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520070', '5298', 'GO', '5298', '5298', '52998', '52', 'ALVORADA (TRANSF. P/TO)', NULL, NULL, NULL, '4', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '170070', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520070', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520100', '5298', 'GO', '5298', '5298', '52998', '52', 'ANANAS (TRANSF. P/TO)', NULL, NULL, NULL, '9', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '170100', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520100', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520190', '5298', 'GO', '5298', '5298', '52998', '52', 'ARAGUACEMA (TRANSF. P/TO)', NULL, NULL, NULL, '0', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '170190', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520190', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520210', '5298', 'GO', '5298', '5298', '52998', '52', 'ARAGUAINA (TRANSF. P/TO)', NULL, NULL, NULL, '6', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '170210', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520210', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520270', '5298', 'GO', '5298', '5298', '52998', '52', 'AURORA DO NORTE (TRANSF. P/TO)', NULL, NULL, NULL, '0', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '170270', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520270', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520300', '5298', 'GO', '5298', '5298', '52998', '52', 'BABACULANDIA (TRANSF. P/TO)', NULL, NULL, NULL, '5', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '170300', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520300', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520370', '5298', 'GO', '5298', '5298', '52998', '52', 'BREJINHO DE NAZARE (TRANSF. P/TO)', NULL, NULL, NULL, '8', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '170370', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520370', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520230', '5298', 'GO', '5298', '5298', '52998', '52', 'ARAPOEMA (TRANSF. P/TO)', NULL, NULL, NULL, '4', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '170230', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520230', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521360', '5298', 'GO', '5298', '5298', '52998', '52', 'MONTE DO CARMO (TRANSF. P/TO)', NULL, NULL, NULL, '8', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '171360', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '521360', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520770', '5298', 'GO', '5298', '5298', '52998', '52', 'FILADELFIA (TRANSF. P/TO)', NULL, NULL, NULL, '9', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '170770', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520770', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520900', '5298', 'GO', '5298', '5298', '52998', '52', 'GOIATINS (TRANSF. P/TO)', NULL, NULL, NULL, '2', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '170900', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520900', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539932', '5301', 'DF', '5301', '5301', '53001', '53', 'REGIAO ADMINISTRATIVA - BRASILIA', NULL, '61', NULL, NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'N', NULL, NULL, NULL, '53001', 'N', 'N', NULL, '5301', '5301', NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539926', '5301', 'DF', '5301', '5301', '53001', '53', 'ASA SUL', NULL, '61', NULL, NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, 1171, 'S', NULL, NULL, NULL, '53001', 'N', 'N', 11806, NULL, '5301', '5301', NULL, NULL, 'N', NULL, NULL, 'N', '530015', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130080', '1307', 'AM', '1301', '1304', '13013', '13', 'BORBA', NULL, '92', '69200000', '5', '0217', '0217', '03009', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 44251.185, '-4,38800', '-59,59400', 45, 'S', 0.5990, NULL, NULL, '13071', 'S', 'N', 716, NULL, '1390', '1390', NULL, '1888', 'S', 137, 'BORBA', 'N', '130080', 'S', 'N', 'S', NULL, 119, 'S', 'N', 'S', '14', NULL, '03', 'N', NULL, NULL, NULL, 397);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170000', NULL, 'TO', NULL, NULL, NULL, '17', 'MUNICIPIO IGNORADO - TO ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IGNR', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', 0.00, 'N', NULL, NULL, NULL, NULL, 'N', 0.0000, NULL, NULL, NULL, 'N', 'N', NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520930', '5298', 'GO', '5298', '5298', '52998', '52', 'GUARAI (TRANSF. P/TO)', NULL, NULL, NULL, '9', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '170930', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '520930', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521110', '5298', 'GO', '5298', '5298', '52998', '52', 'ITAPORA DE GOIAS (TRANSF. P/TO)', NULL, NULL, NULL, '7', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '171110', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '521110', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521620', '5298', 'GO', '5298', '5298', '52998', '52', 'PARANA (TRANSF. P/TO)', NULL, NULL, NULL, '5', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '171620', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '521620', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521650', '5298', 'GO', '5298', '5298', '52998', '52', 'PEDRO AFONSO (TRANSF. P/TO)', NULL, NULL, NULL, '2', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '171650', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '521650', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521700', '5298', 'GO', '5298', '5298', '52998', '52', 'PINDORAMA DE GOIAS (TRANSF. P/TO)', NULL, NULL, NULL, '5', NULL, NULL, NULL, NULL, 'TRANS', 'N', 'N', '171700', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '0,00000', '0,00000', 0, 'N', NULL, NULL, NULL, '52980', NULL, NULL, NULL, NULL, '5298', '5298', '1988', NULL, 'S', NULL, NULL, 'N', '521700', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130083', '1308', 'AM', '1301', '1303', '13006', '13', 'CAAPIRANGA', NULL, '92', '69410000', '9', '0299', '0299', '03056', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 9456.578, '-3,32800', '-61,20900', 32, 'S', 0.6240, NULL, NULL, '13082', 'S', 'N', 804, NULL, '1390', '1390', NULL, '1985', 'S', 138, 'CAAPIRANGA', 'N', '130083', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '15', NULL, '03', 'N', NULL, NULL, NULL, 282);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130090', '1306', 'AM', '1301', '1304', '13012', '13', 'CANUTAMA', NULL, '97', '69820000', '4', '0219', '0219', '03010', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 29819.631, '-6,53400', '-64,38300', 55, 'S', 0.5460, NULL, NULL, '13062', 'S', 'N', 1033, NULL, '1390', '1390', NULL, '1931', 'S', 139, 'CANUTAMA', 'N', '130090', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '16', NULL, '03', 'N', NULL, NULL, NULL, 174);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150157', '1511', 'PA', '1590', '1506', '15017', '15', 'BOM JESUS DO TOCANTINS', NULL, '94', '68525000', '6', '0575', '0575', '12088', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 2816.425, '-5,05100', '-48,60900', 175, 'S', 0.6180, NULL, NULL, '15900', 'S', 'N', 681, NULL, '1590', '1590', NULL, '1989', 'S', 2433, 'BOM JESUS DO TOCANTINS', 'N', '150157', 'S', 'N', 'S', NULL, 87, 'S', 'N', 'N', '22', NULL, '03', 'N', NULL, NULL, NULL, 447);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150160', '1504', 'PA', '1590', '1504', '15010', '15', 'BONITO', NULL, '91', '68645000', '0', '0431', '0431', '12016', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 587.497, '-1,36300', '-47,30700', 49, 'S', 0.6120, NULL, NULL, '15900', 'S', 'N', 703, NULL, '1590', '1590', NULL, '1961', 'S', 2434, 'BONITO', 'N', '150160', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '23', NULL, '03', 'N', NULL, NULL, NULL, 453);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150172', '1510', 'PA', '1590', '1505', '15015', '15', 'BRASIL NOVO', NULL, '93', '68148000', '5', '0639', '0639', '12108', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 6368.246, '-3,26200', '-52,66800', 0, 'S', 0.6740, NULL, NULL, '15900', 'S', 'N', 736, NULL, '1590', '1590', NULL, '1993', 'S', 2436, 'BRASIL NOVO', 'N', '150172', 'S', 'N', 'S', NULL, 95, 'N', 'N', 'N', '25', NULL, '03', 'N', NULL, NULL, NULL, 456);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150175', '1511', 'PA', '1590', '1506', '15020', '15', 'BREJO GRANDE DO ARAGUAIA', NULL, '94', '68521000', '8', '0577', '0577', '12089', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1187.816, '-5,69900', '-48,41300', 110, 'S', 0.6800, NULL, NULL, '15900', 'S', 'N', 763, NULL, '1590', '1590', NULL, '1989', 'S', 2437, 'BREJO GRANDE DO ARAGUAIA', 'N', '150175', 'S', 'N', 'S', NULL, 87, 'N', 'N', 'N', '26', NULL, '03', 'N', NULL, NULL, NULL, 447);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150178', '1511', 'PA', '1590', '1506', '15016', '15', 'BREU BRANCO', NULL, '94', '68488000', '2', '0625', '0625', '12109', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3943.171, '-4,00900', '-49,46100', 0, 'S', 0.6650, NULL, NULL, '15900', 'S', 'N', 767, NULL, '1590', '1590', NULL, '1993', 'S', 2438, 'BREU BRANCO', 'N', '150178', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '27', NULL, '02', 'N', NULL, NULL, NULL, 448);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150190', '1502', 'PA', '1590', '1503', '15008', '15', 'BUJARU', NULL, '91', '68670000', '7', '0437', '0437', '12019', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1005.160, '-1,51500', '-48,04500', 10, 'S', 0.6590, NULL, NULL, '15900', 'S', 'N', 785, NULL, '1590', '1590', NULL, '1943', 'S', 2440, 'BUJARU', 'N', '150190', 'S', 'N', 'S', NULL, 61, 'N', 'N', 'N', '29', NULL, '03', 'N', NULL, NULL, NULL, 451);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150195', '1504', 'PA', '1590', '1504', '15013', '15', 'CACHOEIRA DO PIRIA', NULL, '91', '68617000', '6', '0046', '0046', '12132', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2418.277, '-1,67100', '-46,52900', 0, 'S', 0.5510, NULL, NULL, '15900', 'S', 'N', 834, NULL, '1590', '1590', NULL, '1997', 'S', 2441, 'CACHOEIRA DO PIRIÁ', 'N', '150195', 'S', 'N', 'S', NULL, 61, 'N', 'N', 'N', '31', NULL, '03', 'N', NULL, NULL, NULL, 453);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150200', '1507', 'PA', '1590', '1502', '15006', '15', 'CACHOEIRA DO ARARI', NULL, '91', '68840000', '4', '0439', '0439', '12020', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3102.080, '-1,01100', '-48,96300', 20, 'S', 0.6800, NULL, NULL, '15900', 'S', 'N', 833, NULL, '1590', '1590', NULL, '1935', 'S', 2442, 'CACHOEIRA DO ARARI', 'N', '150200', 'S', 'N', 'S', NULL, 129, 'N', 'N', 'N', '30', NULL, '03', 'N', NULL, NULL, NULL, 508);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150215', '1511', 'PA', '1590', '1506', '15019', '15', 'CANAA DOS CARAJAS', NULL, '94', '68537000', '2', '0048', NULL, '12133', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 3146.608, '-6,49700', '-49,87800', 210, 'S', 0.7000, NULL, NULL, '15900', 'S', 'N', 990, NULL, '1590', '1590', NULL, '1997', 'S', 2444, 'CANAÃ DOS CARAJÁS', 'N', '150215', 'S', 'N', 'S', NULL, 87, 'N', 'N', 'N', '33', NULL, '03', 'N', NULL, NULL, NULL, 447);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150220', '1504', 'PA', '1590', '1504', '15010', '15', 'CAPANEMA', NULL, '91', '68700970', '2', '0443', '0443', '12022', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 614.026, '-1,19600', '-47,18100', 24, 'S', 0.7290, NULL, NULL, '15900', 'N', 'N', 1034, NULL, '1590', '1590', NULL, '1902', 'S', 2445, 'CAPANEMA', 'N', '150220', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '34', NULL, '02', 'N', NULL, NULL, NULL, 453);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150230', '1505', 'PA', '1590', '1504', '15013', '15', 'CAPITAO POCO', NULL, '91', '68650000', '1', '0445', '0445', '12023', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2899.532, '-1,74500', '-47,06500', 73, 'S', 0.6150, NULL, NULL, '15900', 'N', 'N', 1062, NULL, '1590', '1590', NULL, '1961', 'S', 2446, 'CAPITÃO POÇO', 'N', '150230', 'S', 'N', 'S', NULL, 61, 'N', 'N', 'N', '35', NULL, '02', 'N', NULL, NULL, NULL, 452);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150250', '1507', 'PA', '1590', '1502', '15006', '15', 'CHAVES', NULL, '91', '68880000', '9', '0449', '0449', '12025', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 13084.879, '-0,16000', '-49,98800', 6, 'S', 0.5810, NULL, NULL, '15900', 'S', 'N', 1245, NULL, '1590', '1590', NULL, '1755', 'S', 2448, 'CHAVES', 'N', '150250', 'S', 'N', 'S', NULL, 129, 'N', 'N', 'N', '37', NULL, '03', 'N', NULL, NULL, NULL, 508);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150260', '1502', 'PA', '1590', '1504', '15009', '15', 'COLARES', NULL, '91', '68785000', '8', '0451', '0451', '12026', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 609.776, '-0,93700', '-48,28200', 15, 'S', 0.7120, NULL, NULL, '15900', 'S', 'N', 1285, NULL, '1590', '1590', NULL, '1961', 'S', 2449, 'COLARES', 'N', '150260', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '38', NULL, '03', 'N', NULL, NULL, NULL, 451);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150270', '1512', 'PA', '1590', '1506', '15022', '15', 'CONCEICAO DO ARAGUAIA', NULL, '94', '68540000', '7', '0453', '0453', '12027', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 5829.441, '-8,25800', '-49,26500', 165, 'S', 0.7180, NULL, NULL, '15900', 'S', 'N', 1318, NULL, '1590', '1590', NULL, '1935', 'S', 2450, 'CONCEIÇÃO DO ARAGUAIA', 'N', '150270', 'S', 'N', 'S', NULL, 92, 'S', 'N', 'N', '39', NULL, '03', 'N', NULL, NULL, NULL, 445);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150275', '1502', 'PA', '1590', '1504', '15012', '15', 'CONCORDIA DO PARA', NULL, '91', '68685000', '6', '0579', '0579', '12090', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 690.942, '-1,99100', '-47,94900', 440, 'S', 0.6600, NULL, NULL, '15900', 'S', 'N', 1332, NULL, '1590', '1590', NULL, '1989', 'S', 2451, 'CONCÓRDIA DO PARÁ', 'N', '150275', 'S', 'N', 'S', NULL, 61, 'S', 'N', 'N', '40', NULL, '03', 'N', NULL, NULL, NULL, 451);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150276', '1512', 'PA', '1590', '1506', '15018', '15', 'CUMARU DO NORTE', NULL, '94', '68398000', '4', '0385', '0385', '12125', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 17084.907, '-7,82500', '-50,77300', 299, 'S', 0.6660, NULL, NULL, '15900', 'S', 'N', 1478, NULL, '1590', '1590', NULL, '1993', 'S', 2452, 'CUMARU DO NORTE', 'N', '150276', 'S', 'N', 'S', NULL, 92, 'S', 'N', 'N', '41', NULL, '03', 'N', NULL, NULL, NULL, 445);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150277', '1511', 'PA', '1590', '1506', '15019', '15', 'CURIONOPOLIS', NULL, '94', '68523000', '2', '0581', '0581', '12091', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2368.698, '-6,09100', '-49,54100', 180, 'S', 0.6820, NULL, NULL, '15900', 'S', 'N', 1487, NULL, '1590', '1590', NULL, '1989', 'S', 2453, 'CURIONÓPOLIS', 'N', '150277', 'S', 'N', 'S', NULL, 87, 'N', 'N', 'N', '42', NULL, '03', 'N', NULL, NULL, NULL, 447);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150285', '1509', 'PA', '1590', '1501', '15002', '15', 'CURUA', NULL, '93', '68210000', '5', '0050', NULL, '12134', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1431.104, '-1,88800', '-55,11700', 0, 'S', 0.6680, NULL, NULL, '15900', 'S', 'N', 1499, NULL, '1590', '1590', NULL, '1997', 'S', 2455, 'CURUÁ', 'N', '150285', 'S', 'N', 'S', NULL, 18, 'N', 'N', 'N', '44', NULL, '03', 'N', NULL, NULL, NULL, 446);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150290', '1503', 'PA', '1590', '1504', '15009', '15', 'CURUCA', NULL, '91', '68750000', '5', '0457', '0457', '12029', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 672.614, '-0,73400', '-47,85500', 37, 'S', 0.7090, NULL, NULL, '15900', 'S', 'N', 1500, NULL, '1590', '1590', NULL, '1933', 'S', 2456, 'CURUÇÁ', 'N', '150290', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '45', NULL, '03', 'N', NULL, NULL, NULL, 452);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150280', '1508', 'PA', '1590', '1502', '15005', '15', 'CURRALINHO', NULL, '91', '68815000', '6', '0455', '0455', '12028', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3617.240, '-1,81400', '-49,79500', 15, 'S', 0.5960, NULL, NULL, '15900', 'S', 'N', 1497, NULL, '1590', '1590', NULL, '1865', 'S', 2454, 'CURRALINHO', 'N', '150280', 'S', 'N', 'S', NULL, 129, 'N', 'N', 'N', '43', NULL, '03', 'N', NULL, NULL, NULL, 509);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130120', '1308', 'AM', '1301', '1303', '13006', '13', 'COARI', NULL, '97', '69460000', '9', '0225', '0225', '03013', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 57921.646, '-4,08500', '-63,14100', 10, 'S', 0.6270, NULL, NULL, '13081', 'N', 'N', 1271, NULL, '1390', '1390', NULL, '1874', 'S', 143, 'COARI', 'N', '130120', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'S', '20', NULL, '02', 'N', NULL, NULL, NULL, 282);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130130', '1308', 'AM', '1301', '1303', '13006', '13', 'CODAJAS', NULL, '97', '69450000', '8', '0227', '0227', '03014', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 18711.626, '-3,83700', '-62,05700', 47, 'S', 0.5930, NULL, NULL, '13081', 'S', 'N', 1279, NULL, '1390', '1390', NULL, '1875', 'S', 144, 'CODAJÁS', 'N', '130130', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '21', NULL, '03', 'N', NULL, NULL, NULL, 282);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130140', '1305', 'AM', '1301', '1302', '13004', '13', 'EIRUNEPE', NULL, '97', '69880000', '7', '0229', '0229', '03015', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 15831.571, '-6,66000', '-69,87400', 124, 'S', 0.5620, NULL, NULL, '13051', 'S', 'N', 1622, NULL, '1390', '1390', NULL, '1894', 'S', 145, 'EIRUNEPÉ', 'N', '130140', 'S', 'N', 'S', NULL, 6, 'S', 'N', 'N', '22', NULL, '03', 'N', NULL, NULL, NULL, 342);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130150', '1305', 'AM', '1301', '1302', '13004', '13', 'ENVIRA', NULL, '97', '69870000', '6', '0231', '0231', '03016', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 13369.291, '-7,43300', '-70,02300', 135, 'S', 0.5130, NULL, NULL, '13051', 'S', 'N', 1656, NULL, '1390', '1390', NULL, '1955', 'S', 146, 'ENVIRA', 'N', '130150', 'S', 'N', 'S', NULL, 6, 'N', 'N', 'N', '23', NULL, '03', 'N', NULL, NULL, NULL, 342);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130160', '1301', 'AM', '1301', '1302', '13003', '13', 'FONTE BOA', NULL, '97', '69670000', '5', '0233', '0233', '03017', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 12110.907, '-2,51400', '-66,09200', 62, 'S', 0.5320, NULL, NULL, '13013', 'S', 'N', 1794, NULL, '1390', '1390', NULL, '1891', 'S', 147, 'FONTE BOA', 'N', '130160', 'S', 'N', 'S', NULL, 165, 'N', 'N', 'N', '24', NULL, '03', 'N', NULL, NULL, NULL, 286);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130165', '1305', 'AM', '1301', '1302', '13004', '13', 'GUAJARA', NULL, '97', '69895000', '4', '0967', '0967', '03073', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 8904.244, '-7,54600', '-72,58400', 0, 'S', 0.5040, NULL, NULL, '13053', 'S', 'N', 1960, NULL, '1390', '1390', NULL, '1989', 'S', 148, 'GUAJARÁ', 'N', '130165', 'S', 'N', 'S', NULL, 6, 'S', 'N', 'N', '25', NULL, '03', 'N', NULL, NULL, NULL, 342);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130170', '1307', 'AM', '1301', '1304', '13013', '13', 'HUMAITA', NULL, '97', '69800000', '4', '0235', '0235', '03018', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 33071.667, '-7,50600', '-63,02100', 58, 'S', 0.6780, NULL, NULL, '13072', 'S', 'N', 2047, NULL, '1390', '1390', NULL, '1890', 'S', 149, 'HUMAITÁ', 'N', '130170', 'S', 'N', 'S', NULL, 119, 'N', 'N', 'N', '26', NULL, '03', 'N', NULL, NULL, NULL, 397);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130180', '1305', 'AM', '1301', '1302', '13004', '13', 'IPIXUNA', NULL, '97', '69890000', '3', '0239', '0239', '03020', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 13565.920, '-7,05100', '-71,69500', 190, 'S', 0.4870, NULL, NULL, '13053', 'S', 'N', 2212, NULL, '1390', '1390', NULL, '1955', 'S', 150, 'IPIXUNA', 'N', '130180', 'S', 'N', 'S', NULL, 6, 'N', 'N', 'N', '27', NULL, '03', 'N', NULL, NULL, NULL, 342);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130185', '1303', 'AM', '1301', '1303', '13007', '13', 'IRANDUBA', NULL, '92', '69405000', '2', '9835', '9835', '03061', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 2215.033, '-3,28500', '-60,18600', 60, 'S', 0.6940, NULL, NULL, '13031', 'S', 'N', 2238, NULL, '1301', '1390', NULL, '1985', 'S', 151, 'IRANDUBA', 'N', '130185', 'S', 'N', 'S', NULL, 44, 'S', 'N', 'N', '28', NULL, '03', 'N', NULL, NULL, NULL, 334);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350380', '3507', 'SP', '3515', '3507', '35031', '35', 'ARTUR NOGUEIRA', NULL, '19', '13160000', '2', '6175', '6175', '21038', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 177.752, '-22,57300', '-47,17300', 588, 'S', 0.7960, NULL, NULL, '35072', 'N', 'N', 395, NULL, '3503', '3503', NULL, '1948', 'S', 4785, 'ARTUR NOGUEIRA', 'N', '350380', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '44', NULL, '01', 'N', NULL, NULL, NULL, 515);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350800', '3516', 'SP', '3508', '3511', '35041', '35', 'BURI', NULL, '15', '18290000', '9', '6261', '6261', '21081', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1194.977, '-23,79800', '-48,59300', 590, 'S', 0.7010, NULL, NULL, '35162', 'N', 'N', 786, NULL, '3590', '3590', NULL, '1921', 'S', 4833, 'BURI', 'N', '350800', 'N', 'N', 'S', NULL, 89, 'N', 'N', 'N', '92', NULL, '03', 'N', NULL, NULL, NULL, 159);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130353', '1303', 'AM', '1301', '1303', '13008', '13', 'PRESIDENTE FIGUEIREDO', NULL, '92', '69735000', '6', '9841', '9841', '03045', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 25422.235, '-2,03400', '-60,02500', 122, 'S', 0.7410, NULL, NULL, '13031', 'S', 'N', 3969, NULL, '1301', '1390', NULL, '1985', 'S', 171, 'PRESIDENTE FIGUEIREDO', 'N', '130353', 'S', 'N', 'S', NULL, 44, 'N', 'N', 'N', '48', NULL, '03', 'N', NULL, NULL, NULL, 334);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150125', '1512', 'PA', '1590', '1506', '15018', '15', 'BANNACH', NULL, '94', '68388000', '3', '0042', '0426', '12130', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 2956.633, '-7,34800', '-50,39600', 420, 'S', 0.7000, NULL, NULL, '15900', 'S', 'N', 478, NULL, '1590', '1590', NULL, '1997', 'S', 2428, 'BANNACH', 'N', '150125', 'S', 'N', 'S', NULL, 92, 'N', 'N', 'N', '17', NULL, '03', 'N', NULL, NULL, NULL, 445);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('140017', '1401', 'RR', '1490', '1401', '14002', '14', 'CANTA', NULL, '95', '69390000', '5', '0028', NULL, '27010', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 7664.797, '2,61000', '-60,59700', 100, 'S', 0.6590, NULL, NULL, '14900', 'S', 'N', 1026, NULL, '1401', '1490', NULL, '1997', 'S', 3896, 'CANTÁ', 'N', '140017', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '5', NULL, '03', 'N', NULL, NULL, NULL, 207);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150293', '1505', 'PA', '1590', '1506', '15017', '15', 'DOM ELISEU', NULL, '94', '68633000', '9', '0583', '0583', '12092', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 5267.514, '-4,28500', '-47,50500', 180, 'S', 0.6650, NULL, NULL, '15900', 'S', 'N', 1573, NULL, '1590', '1590', NULL, '1989', 'S', 2457, 'DOM ELISEU', 'N', '150293', 'S', 'N', 'S', NULL, 61, 'N', 'N', 'N', '46', NULL, '03', 'N', NULL, NULL, NULL, 447);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351512', '3511', 'SP', '3511', '3508', '35036', '35', 'EMILIANOPOLIS', NULL, '18', '19350000', '9', '2961', '2961', '21598', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 223.311, '-21,83300', '-51,48300', 354, 'S', 0.7510, NULL, NULL, '35112', 'N', 'N', 1637, NULL, '3590', '3590', NULL, '1993', 'S', 4912, 'EMILIANÓPOLIS', 'N', '351512', 'N', 'N', 'S', NULL, 73, 'S', 'N', 'N', '171', NULL, '03', 'N', NULL, NULL, NULL, 323);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130356', '1303', 'AM', '1301', '1303', '13008', '13', 'RIO PRETO DA EVA', NULL, '92', '69115000', '9', '9843', '9843', '03065', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 5813.197, '-2,69900', '-59,70000', 47, 'S', 0.6770, NULL, NULL, '13031', 'S', 'N', 4187, NULL, '1301', '1390', NULL, '1985', 'S', 172, 'RIO PRETO DA EVA', 'N', '130356', 'S', 'N', 'S', NULL, 44, 'S', 'N', 'N', '49', NULL, '03', 'N', NULL, NULL, NULL, 334);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150440', '1503', 'PA', '1590', '1504', '15009', '15', 'MARAPANIM', NULL, '91', '68760000', '6', '0487', '0487', '12044', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 791.959, '-0,71400', '-47,69400', 40, 'S', 0.7000, NULL, NULL, '15900', 'S', 'N', 2891, NULL, '1590', '1590', NULL, '1931', 'S', 2479, 'MARAPANIM', 'N', '150440', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '68', NULL, '03', 'N', NULL, NULL, NULL, 452);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130360', '1303', 'AM', '1301', '1301', '13001', '13', 'SANTA ISABEL DO RIO NEGRO', NULL, '97', '69740000', '1', '0237', '0237', '03019', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 62846.237, '-0,41400', '-65,01900', 60, 'S', 0.5480, NULL, NULL, '13032', 'S', 'N', 4355, NULL, '1390', '1390', NULL, '1956', 'S', 173, 'SANTA ISABEL DO RIO NEGRO', 'N', '130360', 'S', 'N', 'S', NULL, 136, 'N', 'N', 'N', '50', NULL, '03', 'N', NULL, NULL, NULL, 334);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130370', '1301', 'AM', '1301', '1302', '13003', '13', 'SANTO ANTONIO DO ICA', NULL, '97', '69680000', '0', '0273', '0273', '03037', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 12307.773, '-3,10200', '-67,94000', 91, 'S', 0.5250, NULL, NULL, '13012', 'S', 'N', 4497, NULL, '1390', '1390', NULL, '1955', 'S', 174, 'SANTO ANTÔNIO DO IÇÁ', 'N', '130370', 'S', 'N', 'S', NULL, 165, 'N', 'N', 'N', '51', NULL, '03', 'N', NULL, NULL, NULL, 286);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130380', '1303', 'AM', '1301', '1301', '13001', '13', 'SAO GABRIEL DA CACHOEIRA', NULL, '97', '69750000', '9', '0283', '0283', '03042', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 109184.896, '-0,13000', '-67,08900', 132, 'S', 0.6730, NULL, NULL, '13032', 'S', 'N', 4602, NULL, '1390', '1390', NULL, '1935', 'S', 175, 'SÃO GABRIEL DA CACHOEIRA', 'N', '130380', 'S', 'N', 'S', NULL, 136, 'N', 'N', 'S', '52', NULL, '03', 'N', NULL, NULL, NULL, 334);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130390', '1301', 'AM', '1301', '1302', '13003', '13', 'SAO PAULO DE OLIVENCA', NULL, '97', '69600000', '8', '0275', '0275', '03038', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 19745.808, '-3,37800', '-68,87300', 102, 'S', 0.5360, NULL, NULL, '13011', 'S', 'N', 4797, NULL, '1390', '1390', NULL, '1882', 'S', 176, 'SÃO PAULO DE OLIVENÇA', 'N', '130390', 'S', 'N', 'S', NULL, 165, 'N', 'N', 'N', '53', NULL, '03', 'N', NULL, NULL, NULL, 286);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130395', '1304', 'AM', '1301', '1303', '13010', '13', 'SAO SEBASTIAO DO UATUMA', NULL, '92', '69135000', '7', '9845', '9845', '03066', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 10741.039, '-2,57200', '-57,87100', 24, 'S', 0.6590, NULL, NULL, '13041', 'S', 'N', 4845, NULL, '1390', '1390', NULL, '1985', 'S', 177, 'SÃO SEBASTIÃO DO UATUMÃ', 'N', '130395', 'S', 'N', 'S', NULL, 17, 'N', 'N', 'N', '54', NULL, '03', 'N', NULL, NULL, NULL, 227);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130400', '1304', 'AM', '1301', '1303', '13009', '13', 'SILVES', NULL, '92', '69110000', '5', '0277', '0277', '03039', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 3748.818, '-2,83900', '-58,20900', 46, 'S', 0.6750, NULL, NULL, '13041', 'S', 'N', 4992, NULL, '1390', '1390', NULL, '1985', 'S', 178, 'SILVES', 'N', '130400', 'S', 'N', 'S', NULL, 44, 'S', 'N', 'N', '55', NULL, '03', 'N', NULL, NULL, NULL, 227);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130406', '1301', 'AM', '1301', '1302', '13003', '13', 'TABATINGA', NULL, '97', '69640000', '2', '9847', '9847', '03068', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 3225.064, '-4,25300', '-69,93800', 60, 'S', 0.6990, NULL, NULL, '13011', 'S', 'N', 5051, NULL, '1390', '1390', NULL, '1981', 'S', 179, 'TABATINGA', 'N', '130406', 'S', 'N', 'S', NULL, 165, 'N', 'N', 'S', '56', NULL, '03', 'N', NULL, NULL, NULL, 286);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130410', '1306', 'AM', '1301', '1304', '13012', '13', 'TAPAUA', NULL, '97', '69480000', '4', '0279', '0279', '03040', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 89324.259, '-5,62800', '-63,18300', 54, 'S', 0.4980, NULL, NULL, '13062', 'S', 'N', 5090, NULL, '1390', '1390', NULL, '1955', 'S', 180, 'TAPAUÁ', 'N', '130410', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'S', '57', NULL, '03', 'N', NULL, NULL, NULL, 174);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130420', '1309', 'AM', '1301', '1303', '13005', '13', 'TEFE', NULL, '97', '69470000', '3', '0281', '0281', '03041', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 23704.426, '-3,35400', '-64,71100', 75, 'S', 0.6630, NULL, NULL, '13091', 'N', 'N', 5128, NULL, '1390', '1390', NULL, '1759', 'S', 181, 'TEFÉ', 'N', '130420', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'S', '58', NULL, '02', 'N', NULL, NULL, NULL, 111);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130423', '1301', 'AM', '1301', '1302', '13003', '13', 'TONANTINS', NULL, '97', '69685000', '7', '9851', '9851', '03070', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 6432.586, '-2,87300', '-67,80200', 55, 'S', 0.5870, NULL, NULL, '13012', 'S', 'N', 5198, NULL, '1390', '1390', NULL, '1985', 'S', 182, 'TONANTINS', 'N', '130423', 'S', 'N', 'S', NULL, 165, 'S', 'N', 'N', '59', NULL, '03', 'N', NULL, NULL, NULL, 286);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130426', '1309', 'AM', '1301', '1303', '13005', '13', 'UARINI', NULL, '97', '69485000', '0', '9849', '9849', '03071', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 10246.220, '-2,99000', '-65,10800', 60, 'S', 0.5990, NULL, NULL, '13091', 'S', 'N', 5284, NULL, '1390', '1390', NULL, '1985', 'S', 183, 'UARINI', 'N', '130426', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '60', NULL, '03', 'N', NULL, NULL, NULL, 111);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150295', '1511', 'PA', '1590', '1506', '15019', '15', 'ELDORADO DOS CARAJAS', NULL, '94', '68524000', '4', '0377', '0377', '12110', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2956.708, '-6,10400', '-49,35500', 140, 'S', 0.6630, NULL, NULL, '15900', 'S', 'N', 1626, NULL, '1590', '1590', NULL, '1993', 'S', 2458, 'ELDORADO DOS CARAJÁS', 'N', '150295', 'S', 'N', 'S', NULL, 87, 'N', 'N', 'N', '47', NULL, '03', 'N', NULL, NULL, NULL, 447);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150300', '1509', 'PA', '1590', '1501', '15001', '15', 'FARO', NULL, '93', '68280000', '2', '0459', '0459', '12030', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 11766.496, '-2,17100', '-56,74500', 31, 'S', 0.6230, NULL, NULL, '15900', 'S', 'N', 1720, NULL, '1590', '1590', NULL, '1935', 'S', 2459, 'FARO', 'N', '150300', 'S', 'N', 'S', NULL, 18, 'N', 'N', 'N', '48', NULL, '03', 'N', NULL, NULL, NULL, 446);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150304', '1512', 'PA', '1590', '1506', '15022', '15', 'FLORESTA DO ARAGUAIA', NULL, '94', '68543000', '4', '0052', NULL, '12135', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3444.251, '-7,55400', '-49,71300', 190, 'S', 0.6730, NULL, NULL, '15900', 'S', 'N', 1784, NULL, '1590', '1590', NULL, '1997', 'S', 2460, 'FLORESTA DO ARAGUAIA', 'N', '150304', 'S', 'N', 'S', NULL, 92, 'N', 'N', 'N', '49', NULL, '03', 'N', NULL, NULL, NULL, 445);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('140010', '1401', 'RR', '1490', '1401', '14001', '14', 'BOA VISTA', NULL, '95', '69301970', '0', '0301', '0301', '27001', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'S', 5687.064, '2,82000', '-60,67300', 85, 'S', 0.7790, NULL, NULL, '14900', 'N', 'N', 635, NULL, '1401', '1401', NULL, '1943', 'S', 3894, 'BOA VISTA', 'N', '140010', 'S', 'N', 'S', NULL, NULL, 'S', 'S', 'S', '3', NULL, '01', 'N', NULL, NULL, NULL, 207);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150307', '1505', 'PA', '1590', '1504', '15013', '15', 'GARRAFAO DO NORTE', NULL, '91', '68665000', '7', '0585', '0585', '12093', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1604.355, '-1,93400', '-47,05300', 56, 'S', 0.5780, NULL, NULL, '15900', 'S', 'N', 1864, NULL, '1590', '1590', NULL, '1989', 'S', 2461, 'GARRAFÃO DO NORTE', 'N', '150307', 'S', 'N', 'S', NULL, 61, 'N', 'N', 'N', '50', NULL, '03', 'N', NULL, NULL, NULL, 452);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150309', '1511', 'PA', '1590', '1506', '15017', '15', 'GOIANESIA DO PARA', NULL, '94', '68639000', '3', '0627', '0627', '12111', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 7021.191, '-3,84300', '-49,09700', 103, 'S', 0.6650, NULL, NULL, '15900', 'S', 'N', 1902, NULL, '1590', '1590', NULL, '1993', 'S', 2462, 'GOIANÉSIA DO PARÁ', 'N', '150309', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '51', NULL, '03', 'N', NULL, NULL, NULL, 448);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150320', '1503', 'PA', '1590', '1504', '15010', '15', 'IGARAPE-ACU', NULL, '91', '68725000', '0', '0463', '0463', '12032', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 785.976, '-1,12700', '-47,61800', 50, 'S', 0.6700, NULL, NULL, '15900', 'S', 'N', 2122, NULL, '1590', '1590', NULL, '1906', 'S', 2464, 'IGARAPÉ-AÇU', 'N', '150320', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '53', NULL, '03', 'N', NULL, NULL, NULL, 452);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150330', '1506', 'PA', '1590', '1504', '15011', '15', 'IGARAPE-MIRI', NULL, '91', '68430000', '9', '0465', '0465', '12033', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1996.823, '-1,97500', '-48,96000', 17, 'S', 0.6690, NULL, NULL, '15900', 'N', 'N', 2123, NULL, '1590', '1590', NULL, '1930', 'S', 2465, 'IGARAPÉ-MIRI', 'N', '150330', 'S', 'N', 'S', NULL, 130, 'N', 'N', 'N', '54', NULL, '02', 'N', NULL, NULL, NULL, 455);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150340', '1503', 'PA', '1590', '1503', '15008', '15', 'INHANGAPI', NULL, '91', '68770000', '8', '0467', '0467', '12034', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 471.145, '-1,43000', '-47,91700', 35, 'S', 0.6780, NULL, NULL, '15900', 'S', 'N', 2182, NULL, '1590', '1590', NULL, '1943', 'S', 2466, 'INHANGAPI', 'N', '150340', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '55', NULL, '03', 'N', NULL, NULL, NULL, 452);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150345', '1505', 'PA', '1590', '1504', '15013', '15', 'IPIXUNA DO PARA', NULL, '91', '68637000', '7', '0621', '0621', '12112', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 5216.948, '-2,55800', '-47,49400', 50, 'S', 0.6220, NULL, NULL, '15900', 'S', 'N', 2213, NULL, '1590', '1590', NULL, '1993', 'S', 2467, 'IPIXUNA DO PARÁ', 'N', '150345', 'S', 'N', 'S', NULL, 61, 'N', 'N', 'N', '56', NULL, '03', 'N', NULL, NULL, NULL, 452);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150350', '1505', 'PA', '1590', '1504', '15013', '15', 'IRITUIA', NULL, '91', '68655000', '7', '0469', '0469', '12035', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1379.523, '-1,76900', '-47,43900', 25, 'S', 0.6740, NULL, NULL, '15900', 'S', 'N', 2250, NULL, '1590', '1590', NULL, '1935', 'S', 2468, 'IRITUIA', 'N', '150350', 'S', 'N', 'S', NULL, 61, 'N', 'N', 'N', '57', NULL, '03', 'N', NULL, NULL, NULL, 452);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150370', '1511', 'PA', '1590', '1506', '15016', '15', 'ITUPIRANGA', NULL, '94', '68580000', '5', '0473', '0473', '12037', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 7879.995, '-5,13500', '-49,32700', 89, 'S', 0.6190, NULL, NULL, '15900', 'N', 'N', 2418, NULL, '1590', '1590', NULL, '1947', 'S', 2470, 'ITUPIRANGA', 'N', '150370', 'S', 'N', 'S', NULL, 87, 'N', 'N', 'N', '59', NULL, '03', 'N', NULL, NULL, NULL, 447);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150375', '1509', 'PA', '1590', '1505', '15014', '15', 'JACAREACANGA', NULL, '93', '68195000', '4', '0631', '0631', '12113', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 53303.089, '-6,22400', '-57,75400', 70, 'S', 0.6520, NULL, NULL, '15900', 'S', 'N', 2445, NULL, '1590', '1590', NULL, '1993', 'S', 2471, 'JACAREACANGA', 'N', '150375', 'S', 'N', 'S', NULL, 114, 'N', 'N', 'N', '60', NULL, '03', 'N', NULL, NULL, NULL, 454);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150380', '1511', 'PA', '1590', '1506', '15016', '15', 'JACUNDA', NULL, '94', '68590000', '4', '0475', '0475', '12038', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 2008.404, '-4,45100', '-49,11600', 108, 'S', 0.6910, NULL, NULL, '15900', 'S', 'N', 2456, NULL, '1590', '1590', NULL, '1961', 'S', 2472, 'JACUNDÁ', 'N', '150380', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '61', NULL, '02', 'N', NULL, NULL, NULL, 448);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150390', '1509', 'PA', '1590', '1501', '15001', '15', 'JURUTI', NULL, '93', '68170000', '3', '0477', '0477', '12039', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 8303.966, '-2,15200', '-56,09200', 36, 'S', 0.6300, NULL, NULL, '15900', 'S', 'N', 2625, NULL, '1590', '1590', NULL, '1935', 'S', 2473, 'JURUTI', 'N', '150390', 'S', 'N', 'S', NULL, 18, 'N', 'N', 'N', '62', NULL, '03', 'N', NULL, NULL, NULL, 446);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150400', '1513', 'PA', '1590', '1504', '15011', '15', 'LIMOEIRO DO AJURU', NULL, '91', '68415000', '0', '0479', '0479', '12040', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1490.172, '-1,89500', '-49,38100', 28, 'S', 0.6420, NULL, NULL, '15900', 'S', 'N', 2744, NULL, '1590', '1590', NULL, '1961', 'S', 2474, 'LIMOEIRO DO AJURU', 'N', '150400', 'S', 'N', 'S', NULL, 130, 'N', 'N', 'N', '63', NULL, '03', 'N', NULL, NULL, NULL, 455);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150405', '1505', 'PA', '1590', '1504', '15013', '15', 'MAE DO RIO', NULL, '91', '68675000', '9', '0587', '0587', '12094', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 469.488, '-2,06000', '-47,55300', 25, 'S', 0.6970, NULL, NULL, '15900', 'S', 'N', 2818, NULL, '1590', '1590', NULL, '1989', 'S', 2475, 'MÃE DO RIO', 'N', '150405', 'S', 'N', 'S', NULL, 61, 'N', 'N', 'N', '64', NULL, '03', 'N', NULL, NULL, NULL, 452);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150410', '1503', 'PA', '1590', '1504', '15009', '15', 'MAGALHAES BARATA', NULL, '91', '68722000', '9', '0481', '0481', '12041', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 324.788, '-0,79500', '-47,59800', 50, 'S', 0.6710, NULL, NULL, '15900', 'S', 'N', 2821, NULL, '1590', '1590', NULL, '1961', 'S', 2476, 'MAGALHÃES BARATA', 'N', '150410', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '65', NULL, '03', 'N', NULL, NULL, NULL, 452);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150430', '1503', 'PA', '1590', '1504', '15009', '15', 'MARACANA', NULL, '91', '68710000', '7', '0485', '0485', '12043', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 780.724, '-0,76500', '-47,45000', 45, 'S', 0.6560, NULL, NULL, '15900', 'S', 'N', 2882, NULL, '1590', '1590', NULL, '1755', 'S', 2478, 'MARACANÃ', 'N', '150430', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '67', NULL, '03', 'N', NULL, NULL, NULL, 452);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150442', '1501', 'PA', '1590', '1503', '15007', '15', 'MARITUBA', NULL, '91', '67200000', '2', '0054', '0054', '12136', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 103.279, '-1,35500', '-48,34200', 18, 'S', 0.7130, NULL, NULL, '15900', 'N', 'N', 2936, NULL, '1501', '1501', NULL, '1997', 'S', 2480, 'MARITUBA', 'N', '150442', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '69', NULL, '01', 'N', NULL, NULL, NULL, 450);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150445', '1510', 'PA', '1590', '1505', '15015', '15', 'MEDICILANDIA', NULL, '93', '68145000', '5', '0589', '0589', '12095', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 8272.583, '-3,44600', '-52,88900', 151, 'S', 0.7100, NULL, NULL, '15900', 'S', 'N', 3002, NULL, '1590', '1590', NULL, '1989', 'S', 2481, 'MEDICILÂNDIA', 'N', '150445', 'S', 'N', 'S', NULL, 95, 'N', 'N', 'N', '70', NULL, '03', 'N', NULL, NULL, NULL, 456);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150460', '1513', 'PA', '1590', '1504', '15011', '15', 'MOCAJUBA', NULL, '91', '68420000', '4', '0491', '0491', '12046', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 870.800, '-2,58400', '-49,50700', 30, 'S', 0.7020, NULL, NULL, '15900', 'S', 'N', 3066, NULL, '1590', '1590', NULL, '1935', 'S', 2483, 'MOCAJUBA', 'N', '150460', 'S', 'N', 'S', NULL, 130, 'S', 'N', 'N', '72', NULL, '03', 'N', NULL, NULL, NULL, 455);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150470', '1506', 'PA', '1590', '1504', '15012', '15', 'MOJU', NULL, '91', '68450000', '3', '0493', '0493', '12047', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 9093.850, '-1,88400', '-48,76900', 16, 'S', 0.6430, NULL, NULL, '15900', 'N', 'N', 3077, NULL, '1590', '1590', NULL, '1935', 'S', 2484, 'MOJU', 'N', '150470', 'S', 'N', 'S', NULL, 130, 'N', 'N', 'N', '73', NULL, '02', 'N', NULL, NULL, NULL, 455);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150548', '1510', 'PA', '1590', '1505', '15015', '15', 'PACAJA', NULL, '91', '68485000', '6', '0593', '0593', '12097', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 11832.183, '-3,83800', '-50,63800', 105, 'S', 0.6610, NULL, NULL, '15900', 'S', 'N', 3451, NULL, '1590', '1590', NULL, '1989', 'S', 2497, 'PACAJÁ', 'N', '150548', 'S', 'N', 'S', NULL, 95, 'N', 'N', 'N', '86', NULL, '03', 'N', NULL, NULL, NULL, 456);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150549', '1511', 'PA', '1590', '1506', '15020', '15', 'PALESTINA DO PARA', NULL, '94', '68535000', '4', '0379', '0379', '12116', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 983.885, '-5,74200', '-48,31700', 0, 'S', 0.6520, NULL, NULL, '15900', 'S', 'N', 3476, NULL, '1590', '1590', NULL, '1993', 'S', 2498, 'PALESTINA DO PARÁ', 'N', '150549', 'S', 'N', 'S', NULL, 87, 'S', 'N', 'N', '87', NULL, '03', 'N', NULL, NULL, NULL, 447);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150550', '1505', 'PA', '1590', '1506', '15017', '15', 'PARAGOMINAS', NULL, '91', '68620000', '2', '0509', '0509', '12055', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 19330.519, '-2,99500', '-47,35300', 90, 'S', 0.6900, NULL, NULL, '15900', 'N', 'N', 3524, NULL, '1590', '1590', NULL, '1965', 'S', 2499, 'PARAGOMINAS', 'N', '150550', 'S', 'N', 'S', NULL, 61, 'S', 'N', 'S', '88', NULL, '01', 'N', NULL, NULL, NULL, 452);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150555', '1512', 'PA', '1590', '1506', '15021', '15', 'PAU D''ARCO', NULL, '94', '68545000', '1', '0387', '0387', '12117', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1671.413, '-7,83300', '-50,04400', 0, 'S', 0.6640, NULL, NULL, '15900', 'S', 'N', 3610, NULL, '1590', '1590', NULL, '1993', 'S', 2501, 'PAU D ARCO', 'N', '150555', 'S', 'N', 'S', NULL, 92, 'S', 'N', 'N', '90', NULL, '03', 'N', NULL, NULL, NULL, 445);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150310', '1508', 'PA', '1590', '1502', '15004', '15', 'GURUPA', NULL, '91', '68300000', '1', '0461', '0461', '12031', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 8540.032, '-1,40500', '-51,64000', 20, 'S', 0.6310, NULL, NULL, '15900', 'S', 'N', 2025, NULL, '1590', '1590', NULL, '1639', 'S', 2463, 'GURUPÁ', 'N', '150310', 'S', 'N', 'S', NULL, 129, 'N', 'N', 'N', '52', NULL, '03', 'N', NULL, NULL, NULL, 509);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150560', '1504', 'PA', '1590', '1504', '15010', '15', 'PEIXE-BOI', NULL, '91', '68734000', '1', '0511', '0511', '12056', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 450.288, '-1,19200', '-47,31400', 34, 'S', 0.6400, NULL, NULL, '15900', 'S', 'N', 3680, NULL, '1590', '1590', NULL, '1961', 'S', 2502, 'PEIXE-BOI', 'N', '150560', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '91', NULL, '03', 'N', NULL, NULL, NULL, 453);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150563', '1511', 'PA', '1590', '1506', '15021', '15', 'PICARRA', NULL, '94', '68575000', '5', '0058', NULL, '12138', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3312.485, '-6,43800', '-48,87200', 215, 'S', 0.6620, NULL, NULL, '15900', 'S', 'N', 3723, NULL, '1590', '1590', NULL, '1997', 'S', 2503, 'PIÇARRA', 'N', '150563', 'S', 'N', 'S', NULL, 87, 'N', 'N', 'N', '92', NULL, '03', 'N', NULL, NULL, NULL, 447);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150620', '1504', 'PA', '1590', '1504', '15009', '15', 'SALINOPOLIS', NULL, '91', '68721000', '3', '0523', '0523', '12062', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 217.856, '-0,62900', '-47,35600', 21, 'S', 0.7400, NULL, NULL, '15900', 'S', 'N', 4263, NULL, '1590', '1590', NULL, '1933', 'S', 2515, 'SALINÓPOLIS', 'N', '150620', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '104', NULL, '03', 'N', NULL, NULL, NULL, 453);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150630', '1507', 'PA', '1590', '1502', '15006', '15', 'SALVATERRA', NULL, '91', '68860000', '2', '0525', '0525', '12063', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1043.504, '-0,75300', '-48,51700', 5, 'S', 0.7150, NULL, NULL, '15900', 'S', 'N', 4281, NULL, '1590', '1590', NULL, '1961', 'S', 2516, 'SALVATERRA', 'N', '150630', 'S', 'N', 'S', NULL, 129, 'S', 'N', 'N', '105', NULL, '03', 'N', NULL, NULL, NULL, 508);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150635', '1501', 'PA', '1590', '1503', '15007', '15', 'SANTA BARBARA DO PARA', NULL, '91', '68798000', '1', '0369', '0369', '12118', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 278.151, '-1,22400', '-48,29400', 21, 'S', 0.6860, NULL, NULL, '15900', 'S', 'N', 4299, NULL, '1501', '1501', NULL, '1993', 'S', 2517, 'SANTA BÁRBARA DO PARÁ', 'N', '150635', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '106', NULL, '01', 'N', NULL, NULL, NULL, 450);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150640', '1507', 'PA', '1590', '1502', '15006', '15', 'SANTA CRUZ DO ARARI', NULL, '91', '68850000', '1', '0527', '0527', '12064', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1074.854, '-0,66400', '-49,16300', 6, 'S', 0.6300, NULL, NULL, '15900', 'S', 'N', 4323, NULL, '1590', '1590', NULL, '1961', 'S', 2518, 'SANTA CRUZ DO ARARI', 'N', '150640', 'S', 'N', 'S', NULL, 129, 'N', 'N', 'N', '107', NULL, '03', 'N', NULL, NULL, NULL, 508);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150650', '1502', 'PA', '1590', '1503', '15008', '15', 'SANTA ISABEL DO PARA', NULL, '91', '68790000', '0', '0529', '0529', '12065', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 717.615, '-1,29900', '-48,16100', 24, 'S', 0.7210, NULL, NULL, '15900', 'S', 'N', 4354, NULL, '1501', '1590', NULL, '1933', 'S', 2519, 'SANTA ISABEL DO PARÁ', 'N', '150650', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '108', NULL, '02', 'N', NULL, NULL, NULL, 451);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150655', '1504', 'PA', '1590', '1504', '15013', '15', 'SANTA LUZIA DO PARA', NULL, '91', '68644000', '9', '0371', '0371', '12119', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1350.772, '-1,51700', '-46,94200', 0, 'S', 0.5940, NULL, NULL, '15900', 'S', 'N', 4369, NULL, '1590', '1590', NULL, '1993', 'S', 2520, 'SANTA LUZIA DO PARÁ', 'N', '150655', 'S', 'N', 'S', NULL, 61, 'S', 'N', 'N', '109', NULL, '03', 'N', NULL, NULL, NULL, 453);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150746', '1503', 'PA', '1590', '1504', '15009', '15', 'SAO JOAO DA PONTA', NULL, '91', '68774000', '6', '0064', NULL, '12141', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 195.987, '-0,85000', '-47,92000', 34, 'S', 0.6720, NULL, NULL, '15900', 'S', 'N', 4637, NULL, '1590', '1590', NULL, '1997', 'S', 2533, 'SÃO JOÃO DA PONTA', 'N', '150746', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '122', NULL, '03', 'N', NULL, NULL, NULL, 452);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150747', '1504', 'PA', '1590', '1504', '15009', '15', 'SAO JOAO DE PIRABAS', NULL, '91', '68719000', '4', '0393', '0393', '12102', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 701.896, '-0,76900', '-47,17400', 35, 'S', 0.6520, NULL, NULL, '15900', 'S', 'N', 4646, NULL, '1590', '1590', NULL, '1989', 'S', 2534, 'SÃO JOÃO DE PIRABAS', 'N', '150747', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '123', NULL, '03', 'N', NULL, NULL, NULL, 453);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150750', '1511', 'PA', '1590', '1506', '15020', '15', 'SAO JOAO DO ARAGUAIA', NULL, '94', '68518000', '8', '0549', '0549', '12075', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1280.010, '-5,35800', '-48,79100', 99, 'S', 0.5820, NULL, NULL, '15900', 'S', 'N', 4648, NULL, '1590', '1590', NULL, '1961', 'S', 2535, 'SÃO JOÃO DO ARAGUAIA', 'N', '150750', 'S', 'N', 'S', NULL, 87, 'S', 'N', 'N', '124', NULL, '03', 'N', NULL, NULL, NULL, 447);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150760', '1505', 'PA', '1590', '1504', '15013', '15', 'SAO MIGUEL DO GUAMA', NULL, '91', '68660000', '7', '0551', '0551', '12076', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1110.149, '-1,62700', '-47,48300', 10, 'S', 0.6700, NULL, NULL, '15900', 'S', 'N', 4785, NULL, '1590', '1590', NULL, '1870', 'S', 2536, 'SÃO MIGUEL DO GUAMÁ', 'N', '150760', 'S', 'N', 'S', NULL, 61, 'N', 'N', 'N', '125', NULL, '03', 'N', NULL, NULL, NULL, 452);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150770', '1507', 'PA', '1590', '1502', '15005', '15', 'SAO SEBASTIAO DA BOA VISTA', NULL, '91', '68820000', '6', '0553', '0553', '12077', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1632.218, '-1,71800', '-49,54100', 2, 'S', 0.6660, NULL, NULL, '15900', 'S', 'N', 4831, NULL, '1590', '1590', NULL, '1943', 'S', 2537, 'SÃO SEBASTIÃO DA BOA VISTA', 'N', '150770', 'S', 'N', 'S', NULL, 129, 'N', 'N', 'N', '126', NULL, '03', 'N', NULL, NULL, NULL, 508);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150775', '1512', 'PA', '1590', '1506', '15021', '15', 'SAPUCAIA', NULL, '94', '68548000', '5', '0066', NULL, '12142', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1298.180, '-6,94700', '-49,68200', 190, 'S', 0.7300, NULL, NULL, '15900', 'S', 'N', 4873, NULL, '1590', '1590', NULL, '1997', 'S', 2538, 'SAPUCAIA', 'N', '150775', 'S', 'N', 'S', NULL, 92, 'S', 'N', 'N', '127', NULL, '03', 'N', NULL, NULL, NULL, 445);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150780', '1510', 'PA', '1590', '1505', '15015', '15', 'SENADOR JOSE PORFIRIO', NULL, '91', '68360000', '5', '0555', '0555', '12078', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 14374.090, '-2,59100', '-51,95400', 20, 'S', 0.6380, NULL, NULL, '15900', 'S', 'N', 4912, NULL, '1590', '1590', NULL, '1961', 'S', 2539, 'SENADOR JOSÉ PORFÍRIO', 'N', '150780', 'S', 'N', 'S', NULL, 95, 'S', 'N', 'N', '128', NULL, '03', 'N', NULL, NULL, NULL, 456);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150790', '1507', 'PA', '1590', '1502', '15006', '15', 'SOURE', NULL, '91', '68870000', '4', '0557', '0557', '12079', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3512.863, '-0,71700', '-48,52300', 10, 'S', 0.7230, NULL, NULL, '15900', 'S', 'N', 5031, NULL, '1590', '1590', NULL, '1847', 'S', 2540, 'SOURE', 'N', '150790', 'S', 'N', 'S', NULL, 129, 'N', 'N', 'N', '129', NULL, '03', 'N', NULL, NULL, NULL, 508);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150795', '1506', 'PA', '1590', '1504', '15012', '15', 'TAILANDIA', NULL, '91', '68695000', '3', '0395', '0395', '12103', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4430.190, '-2,94700', '-48,95300', 460, 'S', 0.6970, NULL, NULL, '15900', 'S', 'N', 5066, NULL, '1590', '1590', NULL, '1989', 'S', 2541, 'TAILÂNDIA', 'N', '150795', 'S', 'N', 'S', NULL, 130, 'N', 'N', 'N', '130', NULL, '01', 'N', NULL, NULL, NULL, 448);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150796', '1503', 'PA', '1590', '1504', '15009', '15', 'TERRA ALTA', NULL, '91', '68773000', '1', '0373', '0373', '12128', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 206.412, '-1,03800', '-47,90800', 35, 'S', 0.7110, NULL, NULL, '15900', 'S', 'N', 5154, NULL, '1590', '1590', NULL, '1993', 'S', 2542, 'TERRA ALTA', 'N', '150796', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '131', NULL, '03', 'N', NULL, NULL, NULL, 452);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150797', '1509', 'PA', '1590', '1501', '15001', '15', 'TERRA SANTA', NULL, '93', '68285000', '9', '0637', '0637', '12120', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1900.570, '-2,10400', '-56,48700', 18, 'S', 0.6880, NULL, NULL, '15900', 'S', 'N', 5163, NULL, '1590', '1590', NULL, '1993', 'S', 2543, 'TERRA SANTA', 'N', '150797', 'S', 'N', 'S', NULL, 18, 'N', 'N', 'N', '132', NULL, '03', 'N', NULL, NULL, NULL, 446);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150800', '1502', 'PA', '1590', '1504', '15012', '15', 'TOME-ACU', NULL, '91', '68680000', '1', '0559', '0559', '12080', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 5145.325, '-2,41900', '-48,15200', 45, 'S', 0.6760, NULL, NULL, '15900', 'S', 'N', 5197, NULL, '1590', '1590', NULL, '1959', 'S', 2544, 'TOMÉ-AÇU', 'N', '150800', 'S', 'N', 'S', NULL, 61, 'N', 'N', 'N', '133', NULL, '03', 'N', NULL, NULL, NULL, 451);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150803', '1504', 'PA', '1590', '1504', '15010', '15', 'TRACUATEUA', NULL, '91', '68647000', '5', '0068', NULL, '12143', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 852.219, '-1,07200', '-46,89700', 20, 'S', 0.6140, NULL, NULL, '15900', 'S', 'N', 5207, NULL, '1590', '1590', NULL, '1997', 'S', 2545, 'TRACUATEUA', 'N', '150803', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '134', NULL, '03', 'N', NULL, NULL, NULL, 453);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150805', '1509', 'PA', '1590', '1505', '15014', '15', 'TRAIRAO', NULL, '93', '68198000', '0', '0635', '0635', '12121', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 11991.015, '-4,57400', '-55,94400', 105, 'S', 0.6510, NULL, NULL, '15900', 'S', 'N', 5210, NULL, '1590', '1590', NULL, '1993', 'S', 2546, 'TRAIRÃO', 'N', '150805', 'S', 'N', 'S', NULL, 114, 'N', 'N', 'N', '135', NULL, '03', 'N', NULL, NULL, NULL, 454);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150808', '1512', 'PA', '1590', '1506', '15018', '15', 'TUCUMA', NULL, '94', '68385000', '4', '0397', '0397', '12104', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2512.583, '-6,74800', '-51,16100', 34, 'S', 0.7470, NULL, NULL, '15900', 'S', 'N', 5248, NULL, '1590', '1590', NULL, '1989', 'S', 2547, 'TUCUMÃ', 'N', '150808', 'S', 'N', 'S', NULL, 92, 'S', 'N', 'N', '136', NULL, '03', 'N', NULL, NULL, NULL, 445);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150812', '1505', 'PA', '1590', '1506', '15017', '15', 'ULIANOPOLIS', NULL, '91', '68632000', '6', '0623', '0623', '12122', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 5081.069, '-3,75600', '-47,50100', 130, 'S', 0.6880, NULL, NULL, '15900', 'S', 'N', 5305, NULL, '1590', '1590', NULL, '1993', 'S', 2549, 'ULIANÓPOLIS', 'N', '150812', 'S', 'N', 'S', NULL, 61, 'N', 'N', 'N', '138', NULL, '03', 'N', NULL, NULL, NULL, 452);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150815', '1510', 'PA', '1590', '1505', '15015', '15', 'URUARA', NULL, '93', '68140000', '9', '0399', '0399', '12105', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 10791.315, '-3,71800', '-53,73700', 129, 'S', 0.7130, NULL, NULL, '15900', 'N', 'N', 5335, NULL, '1590', '1590', NULL, '1989', 'S', 2550, 'URUARÁ', 'N', '150815', 'S', 'N', 'S', NULL, 95, 'N', 'N', 'N', '139', NULL, '03', 'N', NULL, NULL, NULL, 456);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150820', '1502', 'PA', '1590', '1504', '15009', '15', 'VIGIA', NULL, '91', '68780000', '9', '0563', '0563', '12082', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 533.855, '-0,85800', '-48,14200', 6, 'S', 0.7310, NULL, NULL, '15900', 'S', 'N', 5440, NULL, '1590', '1590', NULL, '1698', 'S', 2551, 'VIGIA', 'N', '150820', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '140', NULL, '03', 'N', NULL, NULL, NULL, 451);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150835', '1510', 'PA', '1590', '1505', '15015', '15', 'VITORIA DO XINGU', NULL, '93', '68383000', '7', '0641', '0641', '12123', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 2966.329, '-2,88000', '-52,01000', 0, 'S', 0.6640, NULL, NULL, '15900', 'S', 'N', 5480, NULL, '1590', '1590', NULL, '1993', 'S', 2553, 'VITÓRIA DO XINGU', 'N', '150835', 'S', 'N', 'S', NULL, 95, 'S', 'N', 'N', '142', NULL, '03', 'N', NULL, NULL, NULL, 456);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150840', '1512', 'PA', '1590', '1506', '15021', '15', 'XINGUARA', NULL, '94', '68550000', '7', '0571', '0571', '12087', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3779.412, '-7,09500', '-49,94600', 279, 'S', 0.7390, NULL, NULL, '15900', 'S', 'N', 5503, NULL, '1590', '1590', NULL, '1982', 'S', 2554, 'XINGUARA', 'N', '150840', 'S', 'N', 'S', NULL, 92, 'N', 'N', 'N', '143', NULL, '03', 'N', NULL, NULL, NULL, 445);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('160005', '1601', 'AP', '1690', '1602', '16003', '16', 'SERRA DO NAVIO', NULL, '96', '68914000', '5', '0665', '0665', '25010', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 7756.506, '0,89600', '-52,00200', 0, 'S', 0.7430, NULL, NULL, '16900', 'S', 'N', 4943, NULL, '1690', '1690', NULL, '1993', 'S', 5582, 'SERRA DO NAVIO', 'N', '160005', 'S', 'N', 'S', NULL, 94, 'N', 'N', 'N', '14', NULL, '03', 'N', NULL, NULL, NULL, 231);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('160010', '1602', 'AP', '1690', '1601', '16002', '16', 'AMAPA', NULL, '96', '68950000', '5', '0601', '0601', '25001', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 9168.787, '2,05300', '-50,79300', 8, 'S', 0.7200, NULL, NULL, '16900', 'S', 'N', 183, NULL, '1690', '1690', NULL, '1956', 'S', 187, 'AMAPÁ', 'N', '160010', 'S', 'N', 'S', NULL, 112, 'S', 'N', 'N', '1', NULL, '03', 'N', NULL, NULL, NULL, 53);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('160015', '1601', 'AP', '1690', '1602', '16003', '16', 'PEDRA BRANCA DO AMAPARI', NULL, '96', '68948000', '4', '0663', '0663', '25011', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 9495.032, '0,77800', '-51,94400', 0, 'S', 0.6250, NULL, NULL, '16900', 'S', 'N', 3644, NULL, '1690', '1690', NULL, '1993', 'S', 186, 'PEDRA BRANCA DO AMAPARI', 'N', '160015', 'S', 'N', 'S', NULL, 94, 'N', 'N', 'N', '10', NULL, '03', 'N', NULL, NULL, NULL, 231);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('160070', '1602', 'AP', '1690', '1601', '16002', '16', 'TARTARUGALZINHO', NULL, '96', '68990000', '9', '0617', '0617', '25009', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 6711.950, '1,50600', '-50,91200', 13, 'S', 0.6670, NULL, NULL, '16900', 'S', 'N', 5119, NULL, '1690', '1690', NULL, '1989', 'S', 200, 'TARTARUGALZINHO', 'N', '160070', 'S', 'N', 'S', NULL, 112, 'N', 'N', 'N', '15', NULL, '03', 'N', NULL, NULL, NULL, 53);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('160080', '1601', 'AP', '1690', '1602', '16004', '16', 'VITORIA DO JARI', NULL, '96', '68924000', '8', '0070', NULL, '25016', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 2482.602, '-0,93800', '-52,42400', 0, 'S', 0.6590, NULL, NULL, '16900', 'S', 'N', 5478, NULL, '1690', '1690', NULL, '1997', 'S', 201, 'VITÓRIA DO JARI', 'N', '160080', 'S', 'N', 'S', NULL, 111, 'S', 'N', 'N', '16', NULL, '03', 'N', NULL, NULL, NULL, 232);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170030', '1712', 'TO', '1790', '1701', '17001', '17', 'AGUIARNOPOLIS', NULL, '63', '77908000', '1', '0072', '0072', '28126', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 235.391, '-6,56300', '-47,46600', 150, 'S', 0.6290, NULL, NULL, '17900', 'S', 'N', 80, NULL, '1790', '1790', NULL, '1997', 'S', 5388, 'AGUIARNÓPOLIS', 'N', '170030', 'S', 'N', 'S', NULL, 22, 'N', 'N', 'N', '2', NULL, '03', 'N', NULL, NULL, NULL, 387);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170035', '1709', 'TO', '1790', '1701', '17005', '17', 'ALIANCA DO TOCANTINS', NULL, '63', '77455000', '0', '9441', '9441', '28001', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1579.742, '-11,30600', '-48,93600', 333, 'S', 0.7170, NULL, NULL, '17900', 'S', 'N', 118, NULL, '1790', '1790', NULL, '1989', 'S', 5389, 'ALIANÇA DO TOCANTINS', 'N', '170035', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '3', NULL, '03', 'N', NULL, NULL, NULL, 505);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170255', '1713', 'TO', '1790', '1701', '17001', '17', 'AUGUSTINOPOLIS', NULL, '63', '77960000', '4', '9685', '9685', '28012', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 414.370, '-5,46600', '-47,88800', 145, 'S', 0.6170, NULL, NULL, '17900', 'S', 'N', 419, NULL, '1790', '1790', NULL, '1989', 'S', 5403, 'AUGUSTINÓPOLIS', 'N', '170255', 'S', 'N', 'S', NULL, 22, 'N', 'N', 'S', '17', NULL, '03', 'N', NULL, NULL, NULL, 387);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170290', '1713', 'TO', '1790', '1701', '17001', '17', 'AXIXA DO TOCANTINS', NULL, '63', '77930000', '1', '9257', '9257', '28014', NULL, 'ATIVO', 'S', 'N', NULL, 'AXIXA DE GOIAS            ', 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 150.214, '-5,61700', '-47,76900', 210, 'S', 0.5710, NULL, NULL, '17900', 'S', 'N', 439, NULL, '1790', '1790', NULL, '1989', 'S', 5405, 'AXIXÁ DO TOCANTINS', 'N', '170290', 'S', 'N', 'S', NULL, 22, 'N', 'N', 'N', '19', NULL, '03', 'N', NULL, NULL, NULL, 387);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170300', '1710', 'TO', '1790', '1701', '17002', '17', 'BABACULANDIA', NULL, '63', '77870000', '8', '9259', '9259', '28015', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1788.442, '-7,20500', '-47,75700', 178, 'S', 0.6100, NULL, NULL, '17900', 'S', 'N', 440, NULL, '1790', '1790', NULL, '1989', 'S', 5406, 'BABAÇULÂNDIA', 'N', '170300', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '20', NULL, '03', 'N', NULL, NULL, NULL, 386);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170305', '1708', 'TO', '1790', '1701', '17002', '17', 'BANDEIRANTES DO TOCANTINS', NULL, '63', '77783000', '7', '0074', '0744', '28127', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1672.322, '-7,75600', '-48,58400', 288, 'S', 0.6740, NULL, NULL, '17900', 'S', 'N', 477, NULL, '1790', '1790', NULL, '1997', 'S', 5407, 'BANDEIRANTES DO TOCANTINS', 'N', '170305', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '21', NULL, '03', 'N', NULL, NULL, NULL, 504);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170330', '1702', 'TO', '1790', '1702', '17006', '17', 'BOM JESUS DO TOCANTINS', NULL, '63', '77714000', '5', '0341', '0341', '28085', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1332.665, '-8,96500', '-48,16600', 204, 'S', 0.6290, NULL, NULL, '17900', 'S', 'N', 680, NULL, '1790', '1790', NULL, '1993', 'S', 5411, 'BOM JESUS DO TOCANTINS', 'N', '170330', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '25', NULL, '03', 'N', NULL, NULL, NULL, 504);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170360', '1708', 'TO', '1790', '1701', '17003', '17', 'BRASILANDIA DO TOCANTINS', NULL, '63', '77735000', '2', '0339', '0339', '28086', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 641.464, '-8,38800', '-48,48100', 224, 'S', 0.6830, NULL, NULL, '17900', 'S', 'N', 740, NULL, '1790', '1790', NULL, '1993', 'S', 5412, 'BRASILÂNDIA DO TOCANTINS', 'N', '170360', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '26', NULL, '03', 'N', NULL, NULL, NULL, 504);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170370', '1705', 'TO', '1790', '1701', '17005', '17', 'BREJINHO DE NAZARE', NULL, '63', '77560000', '1', '9273', '9273', '28018', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1724.441, '-11,00000', '-48,56600', 247, 'S', 0.6730, NULL, NULL, '17900', 'S', 'N', 754, NULL, '1790', '1790', NULL, '1989', 'S', 5413, 'BREJINHO DE NAZARÉ', 'N', '170370', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '27', NULL, '03', 'N', NULL, NULL, NULL, 278);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170380', '1713', 'TO', '1790', '1701', '17001', '17', 'BURITI DO TOCANTINS', NULL, '63', '77995000', '0', '9715', '9715', '28019', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 249.906, '-5,31600', '-48,22900', 198, 'S', 0.6140, NULL, NULL, '17900', 'S', 'N', 792, NULL, '1790', '1790', NULL, '1989', 'S', 5414, 'BURITI DO TOCANTINS', 'N', '170380', 'S', 'N', 'S', NULL, 22, 'N', 'N', 'N', '28', NULL, '03', 'N', NULL, NULL, NULL, 387);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170382', '1711', 'TO', '1790', '1701', '17001', '17', 'CACHOEIRINHA', NULL, '63', '77915000', '6', '0171', '0171', '28087', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 352.343, '-6,12200', '-47,92200', 190, 'S', 0.6390, NULL, NULL, '17900', 'S', 'N', 843, NULL, '1790', '1790', NULL, '1993', 'S', 5415, 'CACHOEIRINHA', 'N', '170382', 'S', 'N', 'S', NULL, 22, 'S', 'N', 'N', '29', NULL, '03', 'N', NULL, NULL, NULL, 387);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170384', '1710', 'TO', '1790', '1702', '17007', '17', 'CAMPOS LINDOS', NULL, '63', '77777000', '2', '0173', '0173', '28088', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3240.156, '-7,99400', '-46,86800', 0, 'S', 0.5800, NULL, NULL, '17900', 'S', 'N', 981, NULL, '1790', '1790', NULL, '1993', 'S', 5416, 'CAMPOS LINDOS', 'N', '170384', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '30', NULL, '03', 'N', NULL, NULL, NULL, 386);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170386', '1709', 'TO', '1790', '1701', '17005', '17', 'CARIRI DO TOCANTINS', NULL, '63', '77453000', '7', '0327', '0327', '28089', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1128.596, '-11,89100', '-49,16100', 295, 'S', 0.7520, NULL, NULL, '17900', 'S', 'N', 1103, NULL, '1790', '1790', NULL, '1993', 'S', 5417, 'CARIRI DO TOCANTINS', 'N', '170386', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '31', NULL, '03', 'N', NULL, NULL, NULL, 505);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170388', '1710', 'TO', '1790', '1701', '17002', '17', 'CARMOLANDIA', NULL, '63', '77840000', '3', '0175', '0175', '28090', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 339.401, '-7,03300', '-48,39600', 0, 'S', 0.6310, NULL, NULL, '17900', 'S', 'N', 1120, NULL, '1790', '1790', NULL, '1993', 'S', 5418, 'CARMOLÂNDIA', 'N', '170388', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '32', NULL, '03', 'N', NULL, NULL, NULL, 386);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170389', '1713', 'TO', '1790', '1701', '17001', '17', 'CARRASCO BONITO', NULL, '63', '77985000', '1', '0177', '0177', '28091', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 195.017, '-5,32200', '-48,03500', 285, 'S', 0.5620, NULL, NULL, '17900', 'S', 'N', 1135, NULL, '1790', '1790', NULL, '1993', 'S', 5419, 'CARRASCO BONITO', 'N', '170389', 'S', 'N', 'S', NULL, 22, 'N', 'N', 'N', '33', NULL, '03', 'N', NULL, NULL, NULL, 387);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170410', '1702', 'TO', '1790', '1702', '17007', '17', 'CENTENARIO', NULL, '63', '77723000', '5', '0343', '0343', '28092', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1954.688, '-8,95100', '-47,33600', 0, 'S', 0.6400, NULL, NULL, '17900', 'S', 'N', 1201, NULL, '1790', '1790', NULL, '1993', 'S', 5421, 'CENTENÁRIO', 'N', '170410', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '35', NULL, '03', 'N', NULL, NULL, NULL, 504);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170040', '1714', 'TO', '1790', '1702', '17008', '17', 'ALMAS', NULL, '63', '77310000', '0', '9207', '9207', '28002', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4021.111, '-11,57400', '-47,17000', 397, 'S', 0.6380, NULL, NULL, '17900', 'S', 'N', 120, NULL, '1790', '1790', NULL, '1989', 'S', 5390, 'ALMAS', 'N', '170040', 'S', 'N', 'S', NULL, 124, 'N', 'N', 'N', '4', NULL, '03', 'N', NULL, NULL, NULL, 218);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170510', '1705', 'TO', '1790', '1702', '17008', '17', 'CHAPADA DA NATIVIDADE', NULL, '63', '77378000', '2', '0080', NULL, '28130', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1671.256, '-11,61700', '-47,75100', 365, 'S', 0.6490, NULL, NULL, '17900', 'S', 'N', 1230, NULL, '1790', '1790', NULL, '1997', 'S', 5423, 'CHAPADA DA NATIVIDADE', 'N', '170510', 'S', 'N', 'S', NULL, 124, 'N', 'N', 'N', '36', NULL, '03', 'N', NULL, NULL, NULL, 278);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170550', '1708', 'TO', '1790', '1701', '17002', '17', 'COLINAS DO TOCANTINS', NULL, '63', '77760000', '8', '9311', '9311', '28021', NULL, 'ATIVO', 'S', 'N', NULL, 'COLINAS DE GOIAS          ', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 843.840, '-8,05900', '-48,47500', 227, 'S', 0.7390, NULL, NULL, '17900', 'S', 'N', 1292, NULL, '1790', '1790', NULL, '1989', 'S', 5424, 'COLINAS DO TOCANTINS', 'N', '170550', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'S', '38', NULL, '03', 'N', NULL, NULL, NULL, 504);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170600', '1708', 'TO', '1790', '1701', '17003', '17', 'COUTO MAGALHAES', NULL, '63', '77750000', '1', '9321', '9321', '28024', NULL, 'ATIVO', 'S', 'N', NULL, 'COUTO DE MAGALHAES        ', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1585.773, '-8,28400', '-49,24700', 150, 'S', 0.6280, NULL, NULL, '17900', 'S', 'N', 1420, NULL, '1790', '1790', NULL, '1989', 'S', 5428, 'COUTO MAGALHÃES', 'N', '170600', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '42', NULL, '03', 'N', NULL, NULL, NULL, 504);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170625', '1709', 'TO', '1790', '1701', '17005', '17', 'CRIXAS DO TOCANTINS', NULL, '63', '77463000', '8', '0082', NULL, '28131', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 986.689, '-11,10000', '-48,91900', 250, 'S', 0.7180, NULL, NULL, '17900', 'S', 'N', 1449, NULL, '1790', '1790', NULL, '1997', 'S', 5430, 'CRIXÁS DO TOCANTINS', 'N', '170625', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '44', NULL, '03', 'N', NULL, NULL, NULL, 505);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170650', '1712', 'TO', '1790', '1701', '17001', '17', 'DARCINOPOLIS', NULL, '63', '77910000', '6', '0179', '0179', '28093', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1548.890, '-6,71300', '-47,76000', 0, 'S', 0.6210, NULL, NULL, '17900', 'S', 'N', 1508, NULL, '1790', '1790', NULL, '1993', 'S', 5431, 'DARCINÓPOLIS', 'N', '170650', 'S', 'N', 'S', NULL, 22, 'N', 'N', 'N', '45', NULL, '03', 'N', NULL, NULL, NULL, 386);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171050', '1707', 'TO', '1790', '1702', '17007', '17', 'ITACAJA', NULL, '63', '77720000', '8', '9405', '9405', '28038', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 3051.341, '-8,39200', '-47,76800', 196, 'S', 0.6750, NULL, NULL, '17900', 'S', 'N', 2269, NULL, '1790', '1790', NULL, '1989', 'S', 5447, 'ITACAJÁ', 'N', '171050', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '61', NULL, '03', 'N', NULL, NULL, NULL, 504);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171070', '1713', 'TO', '1790', '1701', '17001', '17', 'ITAGUATINS', NULL, '63', '77920000', '6', '9409', '9409', '28039', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 739.846, '-5,76800', '-47,48100', 130, 'S', 0.6170, NULL, NULL, '17900', 'S', 'N', 2287, NULL, '1790', '1790', NULL, '1989', 'S', 5448, 'ITAGUATINS', 'N', '171070', 'S', 'N', 'S', NULL, 22, 'S', 'N', 'N', '62', NULL, '03', 'N', NULL, NULL, NULL, 387);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171090', '1708', 'TO', '1790', '1702', '17007', '17', 'ITAPIRATINS', NULL, '63', '77718000', '4', '0347', '0347', '28096', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1243.954, '-8,38400', '-48,11100', 160, 'S', 0.6310, NULL, NULL, '17900', 'S', 'N', 2356, NULL, '1790', '1790', NULL, '1993', 'S', 5449, 'ITAPIRATINS', 'N', '171090', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '63', NULL, '03', 'N', NULL, NULL, NULL, 504);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171110', '1707', 'TO', '1790', '1701', '17003', '17', 'ITAPORA DO TOCANTINS', NULL, '63', '77740000', '0', '9417', '9417', '28040', NULL, 'ATIVO', 'S', 'N', NULL, 'ITAPORA DE GOIAS          ', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 918.916, '-8,57100', '-48,68900', 350, 'S', 0.7090, NULL, NULL, '17900', 'S', 'N', 2363, NULL, '1790', '1790', NULL, '1989', 'S', 5450, 'ITAPORÃ DO TOCANTINS', 'N', '171110', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '64', NULL, '03', 'N', NULL, NULL, NULL, 504);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171270', '1705', 'TO', '1790', '1702', '17007', '17', 'MATEIROS', NULL, '63', '77593000', '2', '0317', '0317', '28102', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 9591.543, '-10,54800', '-46,42100', 493, 'S', 0.5840, NULL, NULL, '17900', 'S', 'N', 2963, NULL, '1790', '1790', NULL, '1993', 'S', 5460, 'MATEIROS', 'N', '171270', 'S', 'N', 'S', NULL, 107, 'N', 'N', 'N', '74', NULL, '03', 'N', NULL, NULL, NULL, 278);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171280', '1713', 'TO', '1790', '1701', '17001', '17', 'MAURILANDIA DO TOCANTINS', NULL, '63', '77918000', '1', '0183', '0183', '28103', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 738.101, '-5,95300', '-47,50600', 0, 'S', 0.6360, NULL, NULL, '17900', 'S', 'N', 2994, NULL, '1790', '1790', NULL, '1993', 'S', 5461, 'MAURILÂNDIA DO TOCANTINS', 'N', '171280', 'S', 'N', 'S', NULL, 22, 'N', 'N', 'N', '75', NULL, '03', 'N', NULL, NULL, NULL, 387);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171395', '1710', 'TO', '1790', '1701', '17002', '17', 'MURICILANDIA', NULL, '63', '77850000', '7', '0187', '0187', '28105', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1187.798, '-7,14700', '-48,61100', 190, 'S', 0.6100, NULL, NULL, '17900', 'S', 'N', 3188, NULL, '1790', '1790', NULL, '1993', 'S', 5467, 'MURICILÂNDIA', 'N', '171395', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '80', NULL, '03', 'N', NULL, NULL, NULL, 386);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171420', '1705', 'TO', '1790', '1702', '17008', '17', 'NATIVIDADE', NULL, '63', '77370000', '3', '9481', '9481', '28046', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3215.903, '-11,71000', '-47,72300', 323, 'S', 0.6690, NULL, NULL, '17900', 'S', 'N', 3205, NULL, '1790', '1790', NULL, '1889', 'S', 5468, 'NATIVIDADE', 'N', '171420', 'S', 'N', 'S', NULL, 124, 'N', 'N', 'N', '81', NULL, '03', 'N', NULL, NULL, NULL, 278);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171430', '1712', 'TO', '1790', '1701', '17001', '17', 'NAZARE', NULL, '63', '77895000', '2', '9483', '9483', '28047', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 395.903, '-6,37200', '-47,66400', 240, 'S', 0.6480, NULL, NULL, '17900', 'S', 'N', 3211, NULL, '1790', '1790', NULL, '1989', 'S', 5469, 'NAZARÉ', 'N', '171430', 'S', 'N', 'S', NULL, 22, 'N', 'N', 'N', '82', NULL, '03', 'N', NULL, NULL, NULL, 387);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171488', '1710', 'TO', '1790', '1701', '17002', '17', 'NOVA OLINDA', NULL, '63', '77790000', '0', '9663', '9663', '28048', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1566.237, '-7,63200', '-48,42300', 257, 'S', 0.6430, NULL, NULL, '17900', 'S', 'N', 3314, NULL, '1790', '1790', NULL, '1989', 'S', 5470, 'NOVA OLINDA', 'N', '171488', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '83', NULL, '03', 'N', NULL, NULL, NULL, 386);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171550', '1705', 'TO', '1790', '1701', '17004', '17', 'OLIVEIRA DE FATIMA', NULL, '63', '77558000', '7', '0092', NULL, '28136', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 205.849, '-10,70800', '-48,90700', 302, 'S', 0.6900, NULL, NULL, '17900', 'S', 'N', 3405, NULL, '1790', '1790', NULL, '1997', 'S', 5475, 'OLIVEIRA DE FÁTIMA', 'N', '171550', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '88', NULL, '03', 'N', NULL, NULL, NULL, 278);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171720', '1711', 'TO', '1790', '1701', '17002', '17', 'PIRAQUE', NULL, '63', '77888000', '6', '0355', '0355', '28109', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 921.585, '-6,77400', '-48,29700', 186, 'S', 0.6800, NULL, NULL, '17900', 'S', 'N', 3801, NULL, '1790', '1790', NULL, '1993', 'S', 5486, 'PIRAQUÊ', 'N', '171720', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '100', NULL, '03', 'N', NULL, NULL, NULL, 386);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150480', '1509', 'PA', '1590', '1501', '15002', '15', 'MONTE ALEGRE', NULL, '93', '68220000', '2', '0495', '0495', '12048', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 21703.027, '-2,00800', '-54,06900', 38, 'S', 0.6900, NULL, NULL, '15900', 'N', 'N', 3094, NULL, '1590', '1590', NULL, '1755', 'S', 2485, 'MONTE ALEGRE', 'N', '150480', 'S', 'N', 'S', NULL, 18, 'N', 'N', 'N', '74', NULL, '02', 'N', NULL, NULL, NULL, 446);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171790', '1705', 'TO', '1790', '1702', '17007', '17', 'PONTE ALTA DO TOCANTINS', NULL, '63', '77590000', '9', '9553', '9553', '28061', NULL, 'ATIVO', 'S', 'N', NULL, 'PONTE ALTA DO NORTE       ', 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 6491.089, '-10,74400', '-47,53600', 294, 'S', 0.6750, NULL, NULL, '17900', 'S', 'N', 3871, NULL, '1790', '1790', NULL, '1989', 'S', 5489, 'PONTE ALTA DO TOCANTINS', 'N', '171790', 'S', 'N', 'S', NULL, 107, 'S', 'N', 'N', '103', NULL, '03', 'N', NULL, NULL, NULL, 278);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171820', '1705', 'TO', '1790', '1702', '17006', '17', 'PORTO NACIONAL', NULL, '63', '77500000', '4', '9559', '9559', '28063', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4449.892, '-10,70800', '-48,41700', 212, 'S', 0.7500, NULL, NULL, '17900', 'S', 'N', 3920, NULL, '1790', '1790', NULL, '1989', 'S', 5491, 'PORTO NACIONAL', 'N', '171820', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'S', '105', NULL, '03', 'N', NULL, NULL, NULL, 278);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171830', '1713', 'TO', '1790', '1701', '17001', '17', 'PRAIA NORTE', NULL, '63', '77970000', '3', '9725', '9725', '28064', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 289.052, '-5,39300', '-47,81100', 122, 'S', 0.5790, NULL, NULL, '17900', 'S', 'N', 3952, NULL, '1790', '1790', NULL, '1989', 'S', 5492, 'PRAIA NORTE', 'N', '171830', 'S', 'N', 'S', NULL, 22, 'S', 'N', 'N', '106', NULL, '03', 'N', NULL, NULL, NULL, 387);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171840', '1707', 'TO', '1790', '1701', '17003', '17', 'PRESIDENTE KENNEDY', NULL, '63', '77745000', '2', '9629', '9629', '28065', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 770.418, '-8,53900', '-48,50600', 247, 'S', 0.6920, NULL, NULL, '17900', 'S', 'N', 3974, NULL, '1790', '1790', NULL, '1989', 'S', 5493, 'PRESIDENTE KENNEDY', 'N', '171840', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '107', NULL, '03', 'N', NULL, NULL, NULL, 504);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171850', '1702', 'TO', '1790', '1702', '17007', '17', 'RECURSOLANDIA', NULL, '63', '77733000', '1', '0357', '0357', '28125', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2216.650, '-8,73700', '-47,24700', 0, 'S', 0.5670, NULL, NULL, '17900', 'S', 'N', 4061, NULL, '1790', '1790', NULL, '1993', 'S', 5495, 'RECURSOLÂNDIA', 'N', '171850', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '109', NULL, '03', 'N', NULL, NULL, NULL, 504);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171855', '1711', 'TO', '1790', '1701', '17001', '17', 'RIACHINHO', NULL, '63', '77893000', '0', '0193', '0193', '28110', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 610.726, '-6,43800', '-48,13700', 160, 'S', 0.5970, NULL, NULL, '17900', 'S', 'N', 4093, NULL, '1790', '1790', NULL, '1993', 'S', 5496, 'RIACHINHO', 'N', '171855', 'S', 'N', 'S', NULL, 22, 'N', 'N', 'N', '110', NULL, '03', 'N', NULL, NULL, NULL, 387);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171880', '1713', 'TO', '1790', '1701', '17001', '17', 'SAMPAIO', NULL, '63', '77980000', '8', '9727', '9727', '28067', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 200.813, '-5,34800', '-47,87300', 115, 'S', 0.5760, NULL, NULL, '17900', 'S', 'N', 4283, NULL, '1790', '1790', NULL, '1989', 'S', 5500, 'SAMPAIO', 'N', '171880', 'S', 'N', 'S', NULL, 22, 'N', 'N', 'N', '114', NULL, '03', 'N', NULL, NULL, NULL, 387);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171884', '1709', 'TO', '1790', '1701', '17004', '17', 'SANDOLANDIA', NULL, '63', '77478000', '0', '0331', '0331', '28113', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 3528.609, '-12,53700', '-49,92500', 0, 'S', 0.7120, NULL, NULL, '17900', 'S', 'N', 4286, NULL, '1790', '1790', NULL, '1993', 'S', 5501, 'SANDOLÂNDIA', 'N', '171884', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '115', NULL, '03', 'N', NULL, NULL, NULL, 505);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171886', '1710', 'TO', '1790', '1701', '17002', '17', 'SANTA FE DO ARAGUAIA', NULL, '63', '77848000', '5', '0195', '0195', '28114', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1676.945, '-7,15700', '-48,72100', 190, 'S', 0.6570, NULL, NULL, '17900', 'S', 'N', 4335, NULL, '1790', '1790', NULL, '1993', 'S', 5502, 'SANTA FÉ DO ARAGUAIA', 'N', '171886', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '116', NULL, '03', 'N', NULL, NULL, NULL, 386);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171888', '1702', 'TO', '1790', '1702', '17006', '17', 'SANTA MARIA DO TOCANTINS', NULL, '63', '77716000', '1', '0361', '0361', '28115', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1410.446, '-8,79700', '-47,79500', 310, 'S', 0.6160, NULL, NULL, '17900', 'S', 'N', 4386, NULL, '1790', '1790', NULL, '1993', 'S', 5503, 'SANTA MARIA DO TOCANTINS', 'N', '171888', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '117', NULL, '03', 'N', NULL, NULL, NULL, 504);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171889', '1709', 'TO', '1790', '1701', '17005', '17', 'SANTA RITA DO TOCANTINS', NULL, '63', '77565000', '9', '0096', NULL, '28138', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3274.930, '-10,86100', '-48,91400', 280, 'S', 0.6630, NULL, NULL, '17900', 'S', 'N', 4407, NULL, '1790', '1790', NULL, '1997', 'S', 5504, 'SANTA RITA DO TOCANTINS', 'N', '171889', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '118', NULL, '03', 'N', NULL, NULL, NULL, 505);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171890', '1705', 'TO', '1790', '1702', '17008', '17', 'SANTA ROSA DO TOCANTINS', NULL, '63', '77375000', '7', '9729', '9729', '28068', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1796.248, '-11,44900', '-48,12100', 310, 'S', 0.6520, NULL, NULL, '17900', 'S', 'N', 4417, NULL, '1790', '1790', NULL, '1989', 'S', 5505, 'SANTA ROSA DO TOCANTINS', 'N', '171890', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '119', NULL, '03', 'N', NULL, NULL, NULL, 278);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('172010', '1713', 'TO', '1790', '1701', '17001', '17', 'SAO BENTO DO TOCANTINS', NULL, '63', '77958000', '1', '0197', '0197', '28116', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1105.893, '-5,91500', '-48,06000', 230, 'S', 0.6120, NULL, NULL, '17900', 'S', 'N', 4534, NULL, '1790', '1790', NULL, '1993', 'S', 5508, 'SÃO BENTO DO TOCANTINS', 'N', '172010', 'S', 'N', 'S', NULL, 22, 'S', 'N', 'N', '122', NULL, '03', 'N', NULL, NULL, NULL, 387);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('172020', '1713', 'TO', '1790', '1701', '17001', '17', 'SAO MIGUEL DO TOCANTINS', NULL, '63', '77925000', '0', '0199', '0199', '28118', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 398.817, '-5,55500', '-47,57500', 160, 'S', 0.5800, NULL, NULL, '17900', 'S', 'N', 4790, NULL, '1790', '1790', NULL, '1993', 'S', 5510, 'SÃO MIGUEL DO TOCANTINS', 'N', '172020', 'S', 'N', 'S', NULL, 22, 'N', 'N', 'N', '124', NULL, '03', 'N', NULL, NULL, NULL, 387);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('172025', '1704', 'TO', '1790', '1701', '17005', '17', 'SAO SALVADOR DO TOCANTINS', NULL, '63', '77368000', '9', '0333', '0333', '28119', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1422.025, '-12,74400', '-48,23600', 120, 'S', 0.6280, NULL, NULL, '17900', 'S', 'N', 4826, NULL, '1790', '1790', NULL, '1993', 'S', 5511, 'SÃO SALVADOR DO TOCANTINS', 'N', '172025', 'S', 'N', 'S', NULL, 124, 'N', 'N', 'N', '125', NULL, '03', 'N', NULL, NULL, NULL, 505);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('172030', '1713', 'TO', '1790', '1701', '17001', '17', 'SAO SEBASTIAO DO TOCANTINS', NULL, '63', '77990000', '9', '9603', '9603', '28070', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 287.271, '-5,25700', '-48,20000', 105, 'S', 0.6100, NULL, NULL, '17900', 'S', 'N', 4844, NULL, '1790', '1790', NULL, '1963', 'S', 5512, 'SÃO SEBASTIÃO DO TOCANTINS', 'N', '172030', 'S', 'N', 'S', NULL, 22, 'S', 'N', 'N', '126', NULL, '03', 'N', NULL, NULL, NULL, 387);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('172049', '1704', 'TO', '1790', '1702', '17008', '17', 'SAO VALERIO DA NATIVIDADE', NULL, '63', '77390000', '9', '9691', '9691', '28071', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2519.572, '-11,97500', '-48,23400', 360, 'S', 0.6740, NULL, NULL, '17900', 'S', 'N', 4857, NULL, '1790', '1790', NULL, '1989', 'S', 5513, 'SÃO VALÉRIO DA NATIVIDADE', 'N', '172049', 'S', 'N', 'S', NULL, 124, 'N', 'N', 'N', '127', NULL, '03', 'N', NULL, NULL, NULL, 505);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('172065', '1705', 'TO', '1790', '1702', '17006', '17', 'SILVANOPOLIS', NULL, '63', '77580000', '5', '9659', '9659', '28072', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1258.824, '-11,14700', '-48,16900', 269, 'S', 0.6670, NULL, NULL, '17900', 'S', 'N', 4988, NULL, '1790', '1790', NULL, '1980', 'S', 5514, 'SILVANÓPOLIS', 'N', '172065', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '128', NULL, '03', 'N', NULL, NULL, NULL, 278);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171780', '1714', 'TO', '1790', '1702', '17008', '17', 'PONTE ALTA DO BOM JESUS', NULL, '63', '77315000', '0', '9551', '9551', '28060', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1806.132, '-12,09100', '-46,47900', 512, 'S', 0.6160, NULL, NULL, '17900', 'S', 'N', 3869, NULL, '1790', '1790', NULL, '1989', 'S', 5488, 'PONTE ALTA DO BOM JESUS', 'N', '171780', 'S', 'N', 'S', NULL, 124, 'N', 'N', 'N', '102', NULL, '03', 'N', NULL, NULL, NULL, 218);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150490', '1507', 'PA', '1590', '1502', '15006', '15', 'MUANA', NULL, '91', '68825000', '1', '0497', '0497', '12049', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3765.524, '-1,52800', '-49,21700', 22, 'S', 0.6530, NULL, NULL, '15900', 'S', 'N', 3163, NULL, '1590', '1590', NULL, '1833', 'S', 2486, 'MUANÁ', 'N', '150490', 'S', 'N', 'S', NULL, 129, 'N', 'N', 'N', '75', NULL, '03', 'N', NULL, NULL, NULL, 508);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150495', '1505', 'PA', '1590', '1504', '15013', '15', 'NOVA ESPERANCA DO PIRIA', NULL, '91', '68618000', '0', '0391', '0391', '12126', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2809.984, '-2,26900', '-46,96600', 0, 'S', 0.5980, NULL, NULL, '15900', 'S', 'N', 3278, NULL, '1590', '1590', NULL, '1993', 'S', 2487, 'NOVA ESPERANÇA DO PIRIÁ', 'N', '150495', 'S', 'N', 'S', NULL, 61, 'N', 'N', 'N', '76', NULL, '03', 'N', NULL, NULL, NULL, 452);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150497', '1511', 'PA', '1590', '1506', '15016', '15', 'NOVA IPIXUNA', NULL, '94', '68585000', '6', '0056', NULL, '12137', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1600.317, '-4,92100', '-49,07700', 118, 'S', 0.6640, NULL, NULL, '15900', 'S', 'N', 3296, NULL, '1590', '1590', NULL, '1997', 'S', 2488, 'NOVA IPIXUNA', 'N', '150497', 'S', 'N', 'S', NULL, 87, 'S', 'N', 'N', '77', NULL, '03', 'N', NULL, NULL, NULL, 447);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150500', '1504', 'PA', '1590', '1504', '15010', '15', 'NOVA TIMBOTEUA', NULL, '91', '68730000', '7', '0499', '0499', '12050', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 489.859, '-1,20600', '-47,38600', 51, 'S', 0.6460, NULL, NULL, '15900', 'S', 'N', 3338, NULL, '1590', '1590', NULL, '1943', 'S', 2489, 'NOVA TIMBOTEUA', 'N', '150500', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '78', NULL, '03', 'N', NULL, NULL, NULL, 453);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150503', '1509', 'PA', '1590', '1505', '15014', '15', 'NOVO PROGRESSO', NULL, '93', '68193000', '1', '0633', '0633', '12114', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 38162.317, '-7,14700', '-55,38200', 240, 'S', 0.7600, NULL, NULL, '15900', 'S', 'N', 3374, NULL, '1590', '1590', NULL, '1993', 'S', 2490, 'NOVO PROGRESSO', 'N', '150503', 'S', 'N', 'S', NULL, 114, 'N', 'N', 'N', '79', NULL, '03', 'N', NULL, NULL, NULL, 454);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150506', '1511', 'PA', '1590', '1506', '15016', '15', 'NOVO REPARTIMENTO', NULL, '94', '68473000', '4', '0629', '0629', '12115', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 15398.627, '-4,33100', '-49,79600', 0, 'S', 0.6260, NULL, NULL, '15900', 'S', 'N', 3375, NULL, '1590', '1590', NULL, '1993', 'S', 2491, 'NOVO REPARTIMENTO', 'N', '150506', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '80', NULL, '02', 'N', NULL, NULL, NULL, 448);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150510', '1509', 'PA', '1590', '1501', '15001', '15', 'OBIDOS', NULL, '93', '68250000', '6', '0501', '0501', '12051', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 28021.287, '-1,91800', '-55,51800', 45, 'S', 0.6810, NULL, NULL, '15900', 'S', 'N', 3382, NULL, '1590', '1590', NULL, '1755', 'S', 2492, 'ÓBIDOS', 'N', '150510', 'S', 'N', 'S', NULL, 18, 'N', 'N', 'N', '81', NULL, '03', 'N', NULL, NULL, NULL, 446);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150520', '1513', 'PA', '1590', '1504', '15011', '15', 'OEIRAS DO PARA', NULL, '91', '68470000', '5', '0503', '0503', '12052', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3852.256, '-2,00300', '-49,85400', 2, 'S', 0.6520, NULL, NULL, '15900', 'S', 'N', 3386, NULL, '1590', '1590', NULL, '1938', 'S', 2493, 'OEIRAS DO PARÁ', 'N', '150520', 'S', 'N', 'S', NULL, 130, 'N', 'N', 'N', '82', NULL, '03', 'N', NULL, NULL, NULL, 455);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150530', '1509', 'PA', '1590', '1501', '15001', '15', 'ORIXIMINA', NULL, '93', '68270000', '4', '0505', '0505', '12053', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 107602.992, '-1,76600', '-55,86600', 46, 'S', 0.7170, NULL, NULL, '15900', 'N', 'N', 3414, NULL, '1590', '1590', NULL, '1934', 'S', 2494, 'ORIXIMINÁ', 'N', '150530', 'S', 'N', 'S', NULL, 18, 'N', 'N', 'N', '83', NULL, '02', 'N', NULL, NULL, NULL, 446);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150540', '1504', 'PA', '1590', '1504', '15013', '15', 'OUREM', NULL, '91', '68640000', '3', '0507', '0507', '12054', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 562.133, '-1,54800', '-47,11900', 40, 'S', 0.6690, NULL, NULL, '15900', 'S', 'N', 3428, NULL, '1590', '1590', NULL, '1933', 'S', 2495, 'OURÉM', 'N', '150540', 'S', 'N', 'S', NULL, 61, 'S', 'N', 'N', '84', NULL, '03', 'N', NULL, NULL, NULL, 453);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150543', '1512', 'PA', '1590', '1506', '15018', '15', 'OURILANDIA DO NORTE', NULL, '94', '68390000', '7', '0591', '0591', '12096', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 13826.010, '-6,75500', '-51,08400', 280, 'S', 0.6990, NULL, NULL, '15900', 'S', 'N', 3431, NULL, '1590', '1590', NULL, '1989', 'S', 2496, 'OURILÂNDIA DO NORTE', 'N', '150543', 'S', 'N', 'S', NULL, 92, 'N', 'N', 'N', '85', NULL, '03', 'N', NULL, NULL, NULL, 445);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351990', '3511', 'SP', '3511', '3510', '35039', '35', 'IEPE', NULL, '18', '19640000', '7', '6499', '6499', '21200', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 596.066, '-22,66100', '-51,07600', 400, 'S', 0.7500, NULL, NULL, '35113', 'N', 'N', 2113, NULL, '3590', '3590', NULL, '1944', 'S', 4971, 'IEPÊ', 'N', '351990', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '230', NULL, '03', 'N', NULL, NULL, NULL, 154);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150565', '1509', 'PA', '1590', '1501', '15002', '15', 'PLACAS', NULL, '93', '68138000', '0', '0060', NULL, '12139', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 7173.154, '-3,86800', '-54,22000', 95, 'S', 0.6900, NULL, NULL, '15900', 'S', 'N', 3822, NULL, '1590', '1590', NULL, '1997', 'S', 2504, 'PLACAS', 'N', '150565', 'S', 'N', 'S', NULL, 95, 'N', 'N', 'N', '93', NULL, '03', 'N', NULL, NULL, NULL, 446);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150570', '1507', 'PA', '1590', '1502', '15006', '15', 'PONTA DE PEDRAS', NULL, '91', '68830000', '0', '0513', '0513', '12057', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3365.126, '-1,39000', '-48,87100', 10, 'S', 0.6520, NULL, NULL, '15900', 'S', 'N', 3859, NULL, '1590', '1590', NULL, '1877', 'S', 2505, 'PONTA DE PEDRAS', 'N', '150570', 'S', 'N', 'S', NULL, 129, 'N', 'N', 'N', '94', NULL, '03', 'N', NULL, NULL, NULL, 508);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150580', '1508', 'PA', '1590', '1502', '15004', '15', 'PORTEL', NULL, '91', '68480000', '9', '0515', '0515', '12058', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 25384.779, '-1,93600', '-50,82100', 19, 'S', 0.6080, NULL, NULL, '15900', 'S', 'N', 3893, NULL, '1590', '1590', NULL, '1935', 'S', 2506, 'PORTEL', 'N', '150580', 'S', 'N', 'S', NULL, 129, 'N', 'N', 'N', '95', NULL, '03', 'N', NULL, NULL, NULL, 509);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150590', '1510', 'PA', '1590', '1501', '15003', '15', 'PORTO DE MOZ', NULL, '93', '68330000', '8', '0517', '0517', '12059', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 17422.876, '-1,74800', '-52,23800', 15, 'S', 0.6500, NULL, NULL, '15900', 'S', 'N', 3906, NULL, '1590', '1590', NULL, '1937', 'S', 2507, 'PORTO DE MOZ', 'N', '150590', 'S', 'N', 'S', NULL, 95, 'N', 'N', 'N', '96', NULL, '03', 'N', NULL, NULL, NULL, 456);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150600', '1509', 'PA', '1590', '1501', '15002', '15', 'PRAINHA', NULL, '93', '68130000', '5', '0519', '0519', '12060', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 12599.481, '-1,80000', '-53,48000', 70, 'S', 0.6210, NULL, NULL, '15900', 'S', 'N', 3953, NULL, '1590', '1590', NULL, '1935', 'S', 2508, 'PRAINHA', 'N', '150600', 'S', 'N', 'S', NULL, 18, 'N', 'N', 'N', '97', NULL, '03', 'N', NULL, NULL, NULL, 446);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150610', '1504', 'PA', '1590', '1504', '15010', '15', 'PRIMAVERA', NULL, '91', '68707000', '4', '0521', '0521', '12061', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 258.598, '-0,94300', '-47,11600', 48, 'S', 0.6550, NULL, NULL, '15900', 'S', 'N', 3987, NULL, '1590', '1590', NULL, '1961', 'S', 2509, 'PRIMAVERA', 'N', '150610', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '98', NULL, '03', 'N', NULL, NULL, NULL, 453);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150611', '1504', 'PA', '1590', '1504', '15010', '15', 'QUATIPURU', NULL, '91', '68709000', '2', '0062', NULL, '12140', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 324.252, '-0,90100', '-47,00600', 29, 'S', 0.6220, NULL, NULL, '15900', 'S', 'N', 4012, NULL, '1590', '1590', NULL, '1997', 'S', 2510, 'QUATIPURU', 'N', '150611', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '99', NULL, '03', 'N', NULL, NULL, NULL, 453);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150613', '1512', 'PA', '1590', '1506', '15021', '15', 'REDENCAO', NULL, '94', '68550970', '8', '0567', '0567', '12084', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 3823.787, '-8,02900', '-50,03100', 227, 'S', 0.7440, NULL, NULL, '15900', 'N', 'N', 4063, NULL, '1590', '1590', NULL, '1982', 'S', 2511, 'REDENÇÃO', 'N', '150613', 'S', 'N', 'S', NULL, 92, 'N', 'N', 'N', '100', NULL, '02', 'N', NULL, NULL, NULL, 445);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150616', '1512', 'PA', '1590', '1506', '15021', '15', 'RIO MARIA', NULL, '94', '68530000', '1', '0569', '0569', '12085', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4114.601, '-7,31100', '-50,04800', 205, 'S', 0.7180, NULL, NULL, '15900', 'S', 'N', 4175, NULL, '1590', '1590', NULL, '1982', 'S', 2512, 'RIO MARIA', 'N', '150616', 'S', 'N', 'S', NULL, 92, 'N', 'N', 'N', '101', NULL, '03', 'N', NULL, NULL, NULL, 445);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150618', '1511', 'PA', '1590', '1506', '15017', '15', 'RONDON DO PARA', NULL, '94', '68638000', '7', '0573', '0573', '12086', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 8246.634, '-4,77600', '-48,06700', 195, 'S', 0.6850, NULL, NULL, '15900', 'S', 'N', 4219, NULL, '1590', '1590', NULL, '1982', 'S', 2513, 'RONDON DO PARÁ', 'N', '150618', 'S', 'N', 'S', NULL, 61, 'N', 'N', 'N', '102', NULL, '03', 'N', NULL, NULL, NULL, 447);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150619', '1509', 'PA', '1590', '1505', '15014', '15', 'RUROPOLIS', NULL, '93', '68165000', '5', '0597', '0597', '12099', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 7021.294, '-4,09600', '-54,91000', 170, 'S', 0.6510, NULL, NULL, '15900', 'S', 'N', 4237, NULL, '1590', '1590', NULL, '1989', 'S', 2514, 'RURÓPOLIS', 'N', '150619', 'S', 'N', 'S', NULL, 114, 'N', 'N', 'N', '103', NULL, '03', 'N', NULL, NULL, NULL, 454);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150658', '1512', 'PA', '1590', '1506', '15022', '15', 'SANTA MARIA DAS BARREIRAS', NULL, '94', '68565000', '3', '0599', '0599', '12100', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 10330.170, '-8,85500', '-49,72200', 150, 'S', 0.6530, NULL, NULL, '15900', 'S', 'N', 4377, NULL, '1590', '1590', NULL, '1989', 'S', 2521, 'SANTA MARIA DAS BARREIRAS', 'N', '150658', 'S', 'N', 'S', NULL, 92, 'N', 'N', 'N', '110', NULL, '03', 'N', NULL, NULL, NULL, 445);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150660', '1505', 'PA', '1590', '1504', '15010', '15', 'SANTA MARIA DO PARA', NULL, '91', '68738000', '9', '0531', '0531', '12066', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 457.717, '-1,35200', '-47,57600', 51, 'S', 0.6510, NULL, NULL, '15900', 'S', 'N', 4383, NULL, '1590', '1590', NULL, '1961', 'S', 2522, 'SANTA MARIA DO PARÁ', 'N', '150660', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '111', NULL, '03', 'N', NULL, NULL, NULL, 452);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150670', '1512', 'PA', '1590', '1506', '15022', '15', 'SANTANA DO ARAGUAIA', NULL, '94', '68560000', '8', '0533', '0533', '12067', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 11591.452, '-9,50500', '-50,62500', 160, 'S', 0.6900, NULL, NULL, '15900', 'S', 'N', 4446, NULL, '1590', '1590', NULL, '1961', 'S', 2523, 'SANTANA DO ARAGUAIA', 'N', '150670', 'S', 'N', 'S', NULL, 92, 'N', 'N', 'N', '112', NULL, '02', 'N', NULL, NULL, NULL, 445);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150680', '1509', 'PA', '1590', '1501', '15002', '15', 'SANTAREM', NULL, '93', '68001970', '7', '0535', '0535', '12068', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 22887.080, '-2,44300', '-54,70800', 51, 'S', 0.7460, NULL, NULL, '15900', 'N', 'N', 4467, NULL, '1590', '1590', NULL, '1755', 'S', 2524, 'SANTARÉM', 'N', '150680', 'S', 'N', 'S', NULL, 18, 'S', 'S', 'S', '113', NULL, '01', 'N', NULL, NULL, NULL, 446);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150690', '1504', 'PA', '1590', '1504', '15010', '15', 'SANTAREM NOVO', NULL, '91', '68720000', '6', '0537', '0537', '12069', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 229.507, '-0,92900', '-47,39700', 30, 'S', 0.6420, NULL, NULL, '15900', 'S', 'N', 4468, NULL, '1590', '1590', NULL, '1961', 'S', 2525, 'SANTARÉM NOVO', 'N', '150690', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '114', NULL, '03', 'N', NULL, NULL, NULL, 453);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150700', '1502', 'PA', '1590', '1503', '15008', '15', 'SANTO ANTONIO DO TAUA', NULL, '91', '68786000', '3', '0539', '0539', '12070', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 537.627, '-1,15200', '-48,12900', 17, 'S', 0.6940, NULL, NULL, '15900', 'S', 'N', 4510, NULL, '1590', '1590', NULL, '1961', 'S', 2526, 'SANTO ANTÔNIO DO TAUÁ', 'N', '150700', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '115', NULL, '03', 'N', NULL, NULL, NULL, 451);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150710', '1502', 'PA', '1590', '1504', '15009', '15', 'SAO CAETANO DE ODIVELAS', NULL, '91', '68775000', '2', '0541', '0541', '12071', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 748.694, '-0,75000', '-48,02000', 5, 'S', 0.7000, NULL, NULL, '15900', 'S', 'N', 4545, NULL, '1590', '1590', NULL, '1935', 'S', 2527, 'SÃO CAETANO DE ODIVELAS', 'N', '150710', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '116', NULL, '03', 'N', NULL, NULL, NULL, 451);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150715', '1511', 'PA', '1590', '1506', '15020', '15', 'SAO DOMINGOS DO ARAGUAIA', NULL, '94', '68520000', '1', '0381', '0381', '12127', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1392.326, '-5,53800', '-48,73300', 130, 'S', 0.6710, NULL, NULL, '15900', 'S', 'N', 4560, NULL, '1590', '1590', NULL, '1993', 'S', 2528, 'SÃO DOMINGOS DO ARAGUAIA', 'N', '150715', 'S', 'N', 'S', NULL, 87, 'S', 'N', 'N', '117', NULL, '03', 'N', NULL, NULL, NULL, 447);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150720', '1503', 'PA', '1590', '1504', '15013', '15', 'SAO DOMINGOS DO CAPIM', NULL, '91', '68635000', '1', '0543', '0543', '12072', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1677.080, '-1,67500', '-47,77500', 20, 'S', 0.6250, NULL, NULL, '15900', 'S', 'N', 4562, NULL, '1590', '1590', NULL, '1890', 'S', 2529, 'SÃO DOMINGOS DO CAPIM', 'N', '150720', 'S', 'N', 'S', NULL, 61, 'S', 'N', 'N', '118', NULL, '03', 'N', NULL, NULL, NULL, 452);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150730', '1512', 'PA', '1590', '1506', '15018', '15', 'SAO FELIX DO XINGU', NULL, '94', '68380000', '0', '0545', '0545', '12073', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 84212.426, '-6,64500', '-51,99500', 220, 'S', 0.7090, NULL, NULL, '15900', 'S', 'N', 4577, NULL, '1590', '1590', NULL, '1961', 'S', 2530, 'SÃO FÉLIX DO XINGU', 'N', '150730', 'S', 'N', 'S', NULL, 92, 'N', 'N', 'N', '119', NULL, '02', 'N', NULL, NULL, NULL, 445);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('172120', '1712', 'TO', '1790', '1701', '17001', '17', 'TOCANTINOPOLIS', NULL, '63', '77900000', '8', '9621', '9621', '28077', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1077.066, '-6,32900', '-47,41600', 134, 'S', 0.6870, NULL, NULL, '17900', 'S', 'N', 5189, NULL, '1790', '1790', NULL, '1989', 'S', 5521, 'TOCANTINÓPOLIS', 'N', '172120', 'S', 'N', 'S', NULL, 22, 'N', 'N', 'S', '135', NULL, '03', 'N', NULL, NULL, NULL, 387);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('172125', '1702', 'TO', '1790', '1701', '17003', '17', 'TUPIRAMA', NULL, '63', '77704000', '7', '0102', NULL, '28141', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 712.202, '-8,97300', '-48,18800', 202, 'S', 0.6290, NULL, NULL, '17900', 'S', 'N', 5269, NULL, '1790', '1790', NULL, '1997', 'S', 5522, 'TUPIRAMA', 'N', '172125', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '136', NULL, '03', 'N', NULL, NULL, NULL, 504);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('172130', '1708', 'TO', '1790', '1701', '17003', '17', 'TUPIRATINS', NULL, '63', '77743000', '7', '0365', '0365', '28124', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 895.302, '-8,39400', '-48,11600', 160, 'S', 0.6390, NULL, NULL, '17900', 'S', 'N', 5270, NULL, '1790', '1790', NULL, '1993', 'S', 5523, 'TUPIRATINS', 'N', '172130', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '137', NULL, '03', 'N', NULL, NULL, NULL, 504);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('172208', '1710', 'TO', '1790', '1701', '17002', '17', 'WANDERLANDIA', NULL, '63', '77860000', '1', '9665', '9665', '28078', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1373.055, '-6,84900', '-47,96300', 257, 'S', 0.6330, NULL, NULL, '17900', 'S', 'N', 5489, NULL, '1790', '1790', NULL, '1989', 'S', 5524, 'WANDERLÂNDIA', 'N', '172208', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '138', NULL, '03', 'N', NULL, NULL, NULL, 386);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('172210', '1711', 'TO', '1790', '1701', '17002', '17', 'XAMBIOA', NULL, '63', '77880000', '7', '9643', '9643', '28079', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1633.769, '-6,41100', '-48,53600', 141, 'S', 0.6530, NULL, NULL, '17900', 'S', 'N', 5495, NULL, '1790', '1790', NULL, '1989', 'S', 5525, 'XAMBIOÁ', 'N', '172210', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '139', NULL, '03', 'N', NULL, NULL, NULL, 386);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210005', '2102', 'MA', '2104', '2102', '21009', '21', 'ACAILANDIA', NULL, '99', '65930000', '5', '0961', '0961', '09131', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 5806.307, '-4,94700', '-47,50500', 240, 'S', 0.6660, NULL, NULL, '21900', 'N', 'N', 17, NULL, '2190', '2190', NULL, '1981', 'S', 1139, 'AÇAILÂNDIA', 'N', '210005', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '1', NULL, '01', 'N', NULL, NULL, NULL, 10);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('172110', '1703', 'TO', '1790', '1702', '17006', '17', 'TOCANTINIA', NULL, '63', '77640000', '9', '9619', '9619', '28076', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 2601.587, '-9,56400', '-48,37700', 202, 'S', 0.6220, NULL, NULL, '17900', 'S', 'N', 5188, NULL, '1790', '1790', NULL, '1989', 'S', 5520, 'TOCANTÍNIA', 'N', '172110', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '134', NULL, '03', 'N', NULL, NULL, NULL, 163);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150740', '1503', 'PA', '1590', '1504', '15010', '15', 'SAO FRANCISCO DO PARA', NULL, '91', '68748000', '9', '0547', '0547', '12074', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 479.558, '-1,16900', '-47,79500', 46, 'S', 0.6900, NULL, NULL, '15900', 'S', 'N', 4597, NULL, '1590', '1590', NULL, '1943', 'S', 2531, 'SÃO FRANCISCO DO PARÁ', 'N', '150740', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '120', NULL, '03', 'N', NULL, NULL, NULL, 452);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150745', '1511', 'PA', '1590', '1506', '15021', '15', 'SAO GERALDO DO ARAGUAIA', NULL, '94', '68570000', '8', '0619', '0619', '12101', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3269.541, '-6,40100', '-48,55500', 145, 'S', 0.6910, NULL, NULL, '15900', 'S', 'N', 4607, NULL, '1590', '1590', NULL, '1989', 'S', 2532, 'SÃO GERALDO DO ARAGUAIA', 'N', '150745', 'S', 'N', 'S', NULL, 87, 'S', 'N', 'N', '121', NULL, '03', 'N', NULL, NULL, NULL, 447);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('160020', '1602', 'AP', '1690', '1601', '16001', '16', 'CALCOENE', NULL, '96', '68960000', '4', '0603', '0603', '25002', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 14269.258, '2,49800', '-50,94900', 12, 'S', 0.6880, NULL, NULL, '16900', 'S', 'N', 892, NULL, '1690', '1690', NULL, '1956', 'S', 189, 'CALÇOENE', 'N', '160020', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '2', NULL, '03', 'N', NULL, NULL, NULL, 53);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('160021', '1601', 'AP', '1690', '1602', '16003', '16', 'CUTIAS', NULL, '96', '68973000', '2', '0667', '0667', '25012', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 2114.732, '0,98600', '-50,80200', 0, 'S', 0.6750, NULL, NULL, '16900', 'S', 'N', 1504, NULL, '1690', '1690', NULL, '1993', 'S', 190, 'CUTIAS', 'N', '160021', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '3', NULL, '03', 'N', NULL, NULL, NULL, 231);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('160023', '1601', 'AP', '1690', '1602', '16003', '16', 'FERREIRA GOMES', NULL, '96', '68915000', '8', '0611', '0611', '25006', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 5046.696, '0,85800', '-51,18000', 50, 'S', 0.7200, NULL, NULL, '16900', 'S', 'N', 1759, NULL, '1690', '1690', NULL, '1989', 'S', 191, 'FERREIRA GOMES', 'N', '160023', 'S', 'N', 'S', NULL, 94, 'N', 'N', 'N', '4', NULL, '03', 'N', NULL, NULL, NULL, 231);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('160025', '1601', 'AP', '1690', '1602', '16003', '16', 'ITAUBAL', NULL, '96', '68976000', '3', '0669', '0669', '25013', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1703.793, '-0,59600', '-50,67100', 27, 'S', 0.6420, NULL, NULL, '16900', 'S', 'N', 2395, NULL, '1690', '1690', NULL, '1993', 'S', 192, 'ITAUBAL', 'N', '160025', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '5', NULL, '03', 'N', NULL, NULL, NULL, 231);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('160027', '1601', 'AP', '1690', '1602', '16004', '16', 'LARANJAL DO JARI', NULL, '96', '68920000', '9', '0613', '0613', '25007', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 30966.177, '-0,84200', '-52,51600', 22, 'S', 0.7320, NULL, NULL, '16900', 'S', 'N', 2709, NULL, '1690', '1690', NULL, '1989', 'S', 193, 'LARANJAL DO JARI', 'N', '160027', 'S', 'N', 'S', NULL, 111, 'S', 'N', 'N', '6', NULL, '03', 'N', NULL, NULL, NULL, 232);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('160030', '1601', 'AP', '1690', '1602', '16003', '16', 'MACAPA', NULL, '96', '68900970', '3', '0605', '0605', '25003', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'S', 6407.123, '0,03900', '-51,06600', 16, 'S', 0.7720, NULL, NULL, '16900', 'N', 'N', 2796, NULL, '1601', '1601', NULL, '1943', 'S', 194, 'MACAPÁ', 'N', '160030', 'S', 'N', 'S', NULL, NULL, 'S', 'S', 'S', '7', NULL, '01', 'N', NULL, NULL, NULL, 231);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('160040', '1601', 'AP', '1690', '1602', '16004', '16', 'MAZAGAO', NULL, '96', '68940000', '2', '0607', '0607', '25004', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 13130.892, '-0,11500', '-51,28900', 60, 'S', 0.6590, NULL, NULL, '16900', 'S', 'N', 2998, NULL, '1690', '1690', NULL, '1841', 'S', 195, 'MAZAGÃO', 'N', '160040', 'S', 'N', 'S', NULL, 111, 'S', 'N', 'N', '8', NULL, '03', 'N', NULL, NULL, NULL, 232);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('160050', '1601', 'AP', '1690', '1601', '16001', '16', 'OIAPOQUE', NULL, '96', '68980000', '1', '0609', '0609', '25005', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 22625.018, '3,84300', '-51,83500', 10, 'S', 0.7380, NULL, NULL, '16900', 'S', 'N', 3387, NULL, '1690', '1690', NULL, '1945', 'S', 196, 'OIAPOQUE', 'N', '160050', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '9', NULL, '03', 'N', NULL, NULL, NULL, 53);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('160053', '1601', 'AP', '1690', '1602', '16003', '16', 'PORTO GRANDE', NULL, '96', '68997000', '5', '0671', '0671', '25014', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 4401.763, '0,71300', '-51,41300', 60, 'S', 0.7190, NULL, NULL, '16900', 'S', 'N', 3916, NULL, '1690', '1690', NULL, '1993', 'S', 197, 'PORTO GRANDE', 'N', '160053', 'S', 'N', 'S', NULL, 94, 'N', 'N', 'N', '11', NULL, '03', 'N', NULL, NULL, NULL, 231);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('160055', '1602', 'AP', '1690', '1601', '16002', '16', 'PRACUUBA', NULL, '96', '68918000', '0', '0673', '0673', '25015', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 4956.739, '1,74300', '-50,79100', 0, 'S', 0.6600, NULL, NULL, '16900', 'S', 'N', 3945, NULL, '1690', '1690', NULL, '1993', 'S', 198, 'PRACUÚBA', 'N', '160055', 'S', 'N', 'S', NULL, 112, 'N', 'N', 'N', '12', NULL, '03', 'N', NULL, NULL, NULL, 53);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('160060', '1601', 'AP', '1690', '1602', '16003', '16', 'SANTANA', NULL, '96', '68925000', '0', '0615', '0615', '25008', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1577.517, '-0,05800', '-51,18200', 15, 'S', 0.7420, NULL, NULL, '16900', 'N', 'N', 4437, NULL, '1601', '1690', NULL, '1989', 'S', 199, 'SANTANA', 'N', '160060', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'S', '13', NULL, '01', 'N', NULL, NULL, NULL, 232);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170070', '1709', 'TO', '1790', '1701', '17005', '17', 'ALVORADA', NULL, '63', '77480000', '7', '9213', '9213', '28003', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1212.161, '-12,48000', '-49,12500', 289, 'S', 0.7310, NULL, NULL, '17900', 'S', 'N', 174, NULL, '1790', '1790', NULL, '1989', 'S', 5391, 'ALVORADA', 'N', '170070', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '5', NULL, '03', 'N', NULL, NULL, NULL, 505);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170100', '1711', 'TO', '1790', '1701', '17001', '17', 'ANANAS', NULL, '63', '77890000', '2', '9219', '9219', '28004', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1587.000, '-6,36600', '-48,07300', 220, 'S', 0.6670, NULL, NULL, '17900', 'S', 'N', 214, NULL, '1790', '1790', NULL, '1989', 'S', 5392, 'ANANÁS', 'N', '170100', 'S', 'N', 'S', NULL, 22, 'N', 'N', 'N', '6', NULL, '03', 'N', NULL, NULL, NULL, 387);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170105', '1711', 'TO', '1790', '1701', '17001', '17', 'ANGICO', NULL, '63', '77905000', '1', '0165', '0165', '28082', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 438.703, '-6,39000', '-47,86500', 290, 'S', 0.6680, NULL, NULL, '17900', 'S', 'N', 237, NULL, '1790', '1790', NULL, '1993', 'S', 5393, 'ANGICO', 'N', '170105', 'S', 'N', 'S', NULL, 22, 'N', 'N', 'N', '7', NULL, '03', 'N', NULL, NULL, NULL, 387);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170110', '1701', 'TO', '1790', '1702', '17006', '17', 'APARECIDA DO RIO NEGRO', NULL, '63', '77620000', '1', '9713', '9713', '28005', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1160.363, '-9,95200', '-47,97200', 265, 'S', 0.6750, NULL, NULL, '17900', 'S', 'N', 270, NULL, '1790', '1790', NULL, '1989', 'S', 5394, 'APARECIDA DO RIO NEGRO', 'N', '170110', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '8', NULL, '03', 'N', NULL, NULL, NULL, 163);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170130', '1710', 'TO', '1790', '1701', '17002', '17', 'ARAGOMINAS', NULL, '63', '77845000', '9', '0167', '0167', '28083', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1173.026, '-7,16200', '-48,52800', 345, 'S', 0.6260, NULL, NULL, '17900', 'S', 'N', 307, NULL, '1790', '1790', NULL, '1993', 'S', 5395, 'ARAGOMINAS', 'N', '170130', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '9', NULL, '03', 'N', NULL, NULL, NULL, 386);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170200', '1709', 'TO', '1790', '1701', '17004', '17', 'ARAGUACU', NULL, '63', '77475000', '0', '9239', '9239', '28007', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 5167.886, '-12,93100', '-49,82600', 278, 'S', 0.7050, NULL, NULL, '17900', 'S', 'N', 309, NULL, '1790', '1790', NULL, '1989', 'S', 5397, 'ARAGUAÇU', 'N', '170200', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '11', NULL, '03', 'N', NULL, NULL, NULL, 505);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170210', '1710', 'TO', '1790', '1701', '17002', '17', 'ARAGUAINA', NULL, '63', '77804970', '9', '9241', '9241', '28008', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4000.395, '-7,19100', '-48,20700', 227, 'S', 0.7490, NULL, NULL, '17900', 'N', 'N', 311, NULL, '1790', '1790', NULL, '1989', 'S', 5398, 'ARAGUAÍNA', 'N', '170210', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'S', '12', NULL, '01', 'N', NULL, NULL, NULL, 386);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170190', '1706', 'TO', '1790', '1701', '17003', '17', 'ARAGUACEMA', NULL, '63', '77690000', '3', '9237', '9237', '28006', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2778.452, '-8,80400', '-49,55600', 159, 'S', 0.6730, NULL, NULL, '17900', 'S', 'N', 308, NULL, '1790', '1790', NULL, '1989', 'S', 5396, 'ARAGUACEMA', 'N', '170190', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '10', NULL, '03', 'N', NULL, NULL, NULL, 216);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170215', '1711', 'TO', '1790', '1701', '17002', '17', 'ARAGUANA', NULL, '63', '77855000', '8', '0169', '0169', '28084', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 834.701, '-6,58100', '-48,64400', 142, 'S', 0.6770, NULL, NULL, '17900', 'S', 'N', 313, NULL, '1790', '1790', NULL, '1993', 'S', 5399, 'ARAGUANÃ', 'N', '170215', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '13', NULL, '03', 'N', NULL, NULL, NULL, 386);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170220', '1713', 'TO', '1790', '1701', '17001', '17', 'ARAGUATINS', NULL, '63', '77950000', '8', '9243', '9243', '28009', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2627.280, '-5,65100', '-48,12400', 103, 'S', 0.6400, NULL, NULL, '17900', 'S', 'N', 317, NULL, '1790', '1790', NULL, '1989', 'S', 5400, 'ARAGUATINS', 'N', '170220', 'S', 'N', 'S', NULL, 22, 'N', 'N', 'S', '14', NULL, '03', 'N', NULL, NULL, NULL, 387);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170230', '1708', 'TO', '1790', '1701', '17002', '17', 'ARAPOEMA', NULL, '63', '77780000', '7', '9245', '9245', '28010', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1552.207, '-7,65800', '-49,06400', 221, 'S', 0.6540, NULL, NULL, '17900', 'S', 'N', 328, NULL, '1790', '1790', NULL, '1989', 'S', 5401, 'ARAPOEMA', 'N', '170230', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '15', NULL, '03', 'N', NULL, NULL, NULL, 504);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170307', '1710', 'TO', '1790', '1702', '17007', '17', 'BARRA DO OURO', NULL, '63', '77765000', '3', '0076', NULL, '28128', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1106.339, '-7,68900', '-47,68300', 161, 'S', 0.6160, NULL, NULL, '17900', 'S', 'N', 518, NULL, '1790', '1790', NULL, '1997', 'S', 5408, 'BARRA DO OURO', 'N', '170307', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '22', NULL, '03', 'N', NULL, NULL, NULL, 386);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170310', '1706', 'TO', '1790', '1701', '17003', '17', 'BARROLANDIA', NULL, '63', '77665000', '7', '9693', '9693', '28016', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 713.297, '-9,83600', '-48,72500', 361, 'S', 0.7190, NULL, NULL, '17900', 'S', 'N', 545, NULL, '1790', '1790', NULL, '1989', 'S', 5409, 'BARROLÂNDIA', 'N', '170310', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '23', NULL, '03', 'N', NULL, NULL, NULL, 216);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170320', '1708', 'TO', '1790', '1701', '17003', '17', 'BERNARDO SAYAO', NULL, '63', '77755000', '6', '9695', '9695', '28017', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 926.884, '-7,87400', '-48,88800', 149, 'S', 0.7130, NULL, NULL, '17900', 'S', 'N', 604, NULL, '1790', '1790', NULL, '1989', 'S', 5410, 'BERNARDO SAYÃO', 'N', '170320', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '24', NULL, '03', 'N', NULL, NULL, NULL, 504);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353284', '3515', 'SP', '3512', '3501', '35001', '35', 'NOVA CANAA PAULISTA', NULL, '17', '15773000', '3', '2985', '2985', '21606', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 124.092, '-20,38600', '-50,94900', 401, 'S', 0.7260, NULL, NULL, '35152', 'N', 'N', 3268, NULL, '3590', '3590', NULL, '1993', 'S', 5113, 'NOVA CANAÃ PAULISTA', 'N', '353284', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '372', NULL, '03', 'N', NULL, NULL, NULL, 219);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170720', '1706', 'TO', '1790', '1701', '17003', '17', 'DOIS IRMAOS DO TOCANTINS', NULL, '63', '77685000', '7', '9345', '9345', '28028', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3757.015, '-9,25800', '-49,06400', 241, 'S', 0.6610, NULL, NULL, '17900', 'S', 'N', 1564, NULL, '1790', '1790', NULL, '1989', 'S', 5434, 'DOIS IRMÃOS DO TOCANTINS', 'N', '170720', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '48', NULL, '03', 'N', NULL, NULL, NULL, 216);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170730', '1709', 'TO', '1790', '1701', '17004', '17', 'DUERE', NULL, '63', '77485000', '6', '9347', '9347', '28029', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3424.836, '-11,34400', '-49,27100', 235, 'S', 0.7010, NULL, NULL, '17900', 'S', 'N', 1613, NULL, '1790', '1790', NULL, '1989', 'S', 5435, 'DUERÉ', 'N', '170730', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '49', NULL, '03', 'N', NULL, NULL, NULL, 505);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170740', '1713', 'TO', '1790', '1701', '17001', '17', 'ESPERANTINA', NULL, '63', '77993000', '5', '0181', '0181', '28094', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 504.019, '-5,34300', '-48,51100', 0, 'S', 0.5720, NULL, NULL, '17900', 'S', 'N', 1676, NULL, '1790', '1790', NULL, '1993', 'S', 5436, 'ESPERANTINA', 'N', '170740', 'S', 'N', 'S', NULL, 22, 'S', 'N', 'S', '50', NULL, '03', 'N', NULL, NULL, NULL, 387);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170755', '1705', 'TO', '1790', '1701', '17004', '17', 'FATIMA', NULL, '63', '77555000', '3', '9683', '9683', '28030', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 382.908, '-10,76100', '-48,90700', 342, 'S', 0.6980, NULL, NULL, '17900', 'S', 'N', 1726, NULL, '1790', '1790', NULL, '1989', 'S', 5437, 'FÁTIMA', 'N', '170755', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '51', NULL, '03', 'N', NULL, NULL, NULL, 278);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170765', '1709', 'TO', '1790', '1701', '17005', '17', 'FIGUEIROPOLIS', NULL, '63', '77465000', '2', '9667', '9667', '28031', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1930.064, '-12,13100', '-49,17400', 291, 'S', 0.7190, NULL, NULL, '17900', 'S', 'N', 1764, NULL, '1790', '1790', NULL, '1989', 'S', 5438, 'FIGUEIRÓPOLIS', 'N', '170765', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '52', NULL, '03', 'N', NULL, NULL, NULL, 505);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170770', '1710', 'TO', '1790', '1701', '17002', '17', 'FILADELFIA', NULL, '63', '77795000', '2', '9355', '9355', '28032', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1988.068, '-7,33600', '-47,49000', 169, 'S', 0.6680, NULL, NULL, '17900', 'S', 'N', 1767, NULL, '1790', '1790', NULL, '1989', 'S', 5439, 'FILADÉLFIA', 'N', '170770', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '53', NULL, '03', 'N', NULL, NULL, NULL, 386);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170820', '1709', 'TO', '1790', '1701', '17004', '17', 'FORMOSO DO ARAGUAIA', NULL, '63', '77470000', '5', '9365', '9365', '28033', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 13423.256, '-11,79700', '-49,52900', 240, 'S', 0.7100, NULL, NULL, '17900', 'S', 'N', 1805, NULL, '1790', '1790', NULL, '1989', 'S', 5440, 'FORMOSO DO ARAGUAIA', 'N', '170820', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'S', '54', NULL, '03', 'N', NULL, NULL, NULL, 505);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170825', '1707', 'TO', '1790', '1701', '17003', '17', 'FORTALEZA DO TABOCAO', NULL, '63', '77708000', '4', '0345', '0345', '28095', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 621.558, '-9,05700', '-48,51900', 0, 'S', 0.6880, NULL, NULL, '17900', 'S', 'N', 1810, NULL, '1790', '1790', NULL, '1993', 'S', 5441, 'FORTALEZA DO TABOCÃO', 'N', '170825', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '55', NULL, '03', 'N', NULL, NULL, NULL, 163);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170900', '1710', 'TO', '1790', '1702', '17007', '17', 'GOIATINS', NULL, '63', '77770000', '5', '9533', '9533', '28035', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 6408.562, '-7,71000', '-47,31400', 192, 'S', 0.5870, NULL, NULL, '17900', 'S', 'N', 1908, NULL, '1790', '1790', NULL, '1989', 'S', 5443, 'GOIATINS', 'N', '170900', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '57', NULL, '03', 'N', NULL, NULL, NULL, 386);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170930', '1707', 'TO', '1790', '1701', '17003', '17', 'GUARAI', NULL, '63', '77700000', '2', '9627', '9627', '28036', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2268.147, '-8,83400', '-48,51000', 259, 'S', 0.7190, NULL, NULL, '17900', 'S', 'N', 1984, NULL, '1790', '1790', NULL, '1989', 'S', 5444, 'GUARAÍ', 'N', '170930', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '58', NULL, '03', 'N', NULL, NULL, NULL, 504);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170950', '1709', 'TO', '1790', '1701', '17005', '17', 'GURUPI', NULL, '63', '77400000', '0', '9385', '9385', '28037', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1836.081, '-11,72900', '-49,06900', 287, 'S', 0.7930, NULL, NULL, '17900', 'N', 'N', 2026, NULL, '1790', '1790', NULL, '1958', 'S', 5445, 'GURUPI', 'N', '170950', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'S', '59', NULL, '01', 'N', NULL, NULL, NULL, 505);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170980', '1705', 'TO', '1790', '1702', '17006', '17', 'IPUEIRAS', NULL, '63', '77553000', '7', '0084', NULL, '28132', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 815.250, '-11,23900', '-48,46300', 237, 'S', 0.6590, NULL, NULL, '17900', 'S', 'N', 2224, NULL, '1790', '1790', NULL, '1997', 'S', 5446, 'IPUEIRAS', 'N', '170980', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '60', NULL, '03', 'N', NULL, NULL, NULL, 278);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171190', '1706', 'TO', '1790', '1701', '17004', '17', 'LAGOA DA CONFUSAO', NULL, '63', '77493000', '2', '0367', '0367', '28099', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 10564.512, '-10,79400', '-49,62400', 0, 'S', 0.6700, NULL, NULL, '17900', 'S', 'N', 2652, NULL, '1790', '1790', NULL, '1993', 'S', 5453, 'LAGOA DA CONFUSÃO', 'N', '171190', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '67', NULL, '03', 'N', NULL, NULL, NULL, 216);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171150', '1704', 'TO', '1790', '1701', '17005', '17', 'JAU DO TOCANTINS', NULL, '63', '77450000', '6', '0329', '0329', '28097', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2173.038, '-12,65400', '-48,59400', 365, 'S', 0.6920, NULL, NULL, '17900', 'S', 'N', 2529, NULL, '1790', '1790', NULL, '1993', 'S', 5451, 'JAÚ DO TOCANTINS', 'N', '171150', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '65', NULL, '03', 'N', NULL, NULL, NULL, 505);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171180', '1708', 'TO', '1790', '1701', '17003', '17', 'JUARINA', NULL, '63', '77753000', '3', '0349', '0349', '28098', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 481.046, '-8,11900', '-49,06500', 180, 'S', 0.6770, NULL, NULL, '17900', 'S', 'N', 2589, NULL, '1790', '1790', NULL, '1993', 'S', 5452, 'JUARINA', 'N', '171180', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '66', NULL, '03', 'N', NULL, NULL, NULL, 504);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171195', '1701', 'TO', '1790', '1702', '17007', '17', 'LAGOA DO TOCANTINS', NULL, '63', '77613000', '1', '0353', '0353', '28100', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 911.336, '-10,37800', '-47,55100', 0, 'S', 0.5740, NULL, NULL, '17900', 'S', 'N', 2665, NULL, '1790', '1790', NULL, '1993', 'S', 5454, 'LAGOA DO TOCANTINS', 'N', '171195', 'S', 'N', 'S', NULL, 107, 'S', 'N', 'N', '68', NULL, '03', 'N', NULL, NULL, NULL, 163);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171200', '1701', 'TO', '1790', '1702', '17006', '17', 'LAJEADO', NULL, '63', '77645000', '9', '0351', '0351', '28101', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 322.481, '-9,75100', '-48,35800', 202, 'S', 0.7150, NULL, NULL, '17900', 'S', 'N', 2688, NULL, '1790', '1790', NULL, '1993', 'S', 5455, 'LAJEADO', 'N', '171200', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '69', NULL, '03', 'N', NULL, NULL, NULL, 163);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171215', '1715', 'TO', '1790', '1702', '17008', '17', 'LAVANDEIRA', NULL, '63', '77328000', '7', '0086', NULL, '28133', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 519.569, '-12,78900', '-46,50600', 330, 'S', 0.5970, NULL, NULL, '17900', 'S', 'N', 2718, NULL, '1790', '1790', NULL, '1997', 'S', 5456, 'LAVANDEIRA', 'N', '171215', 'S', 'N', 'S', NULL, 124, 'N', 'N', 'N', '70', NULL, '03', 'N', NULL, NULL, NULL, 218);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171240', '1701', 'TO', '1790', '1702', '17007', '17', 'LIZARDA', NULL, '63', '77630000', '5', '9569', '9569', '28041', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 5723.201, '-9,59400', '-46,67300', 423, 'S', 0.6340, NULL, NULL, '17900', 'S', 'N', 2755, NULL, '1790', '1790', NULL, '1989', 'S', 5457, 'LIZARDA', 'N', '171240', 'S', 'N', 'S', NULL, 107, 'S', 'N', 'N', '71', NULL, '03', 'N', NULL, NULL, NULL, 163);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171245', '1712', 'TO', '1790', '1701', '17001', '17', 'LUZINOPOLIS', NULL, '63', '77903000', '4', '0088', NULL, '28134', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 279.562, '-6,18200', '-47,85600', 250, 'S', 0.6410, NULL, NULL, '17900', 'S', 'N', 2790, NULL, '1790', '1790', NULL, '1997', 'S', 5458, 'LUZINÓPOLIS', 'N', '171245', 'S', 'N', 'S', NULL, 22, 'N', 'N', 'N', '72', NULL, '03', 'N', NULL, NULL, NULL, 387);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171370', '1706', 'TO', '1790', '1701', '17003', '17', 'MONTE SANTO DO TOCANTINS', NULL, '63', '77673000', '0', '0090', NULL, '28135', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1091.548, '-10,00400', '-48,99500', 280, 'S', 0.7160, NULL, NULL, '17900', 'S', 'N', 3120, NULL, '1790', '1790', NULL, '1997', 'S', 5465, 'MONTE SANTO DO TOCANTINS', 'N', '171370', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '79', NULL, '03', 'N', NULL, NULL, NULL, 216);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171320', '1703', 'TO', '1790', '1701', '17003', '17', 'MIRACEMA DO TOCANTINS', NULL, '63', '77650000', '5', '9461', '9461', '28043', NULL, 'ATIVO', 'S', 'N', NULL, 'MIRACEMA DO NORTE         ', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2656.078, '-9,56700', '-48,39200', 197, 'S', 0.7430, NULL, NULL, '17900', 'S', 'N', 3041, NULL, '1790', '1790', NULL, '1989', 'S', 5462, 'MIRACEMA DO TOCANTINS', 'N', '171320', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'S', '76', NULL, '03', 'N', NULL, NULL, NULL, 163);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171360', '1705', 'TO', '1790', '1702', '17006', '17', 'MONTE DO CARMO', NULL, '63', '77585000', '1', '9469', '9469', '28045', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3616.655, '-10,76300', '-48,10900', 295, 'S', 0.6420, NULL, NULL, '17900', 'S', 'N', 3113, NULL, '1790', '1790', NULL, '1989', 'S', 5464, 'MONTE DO CARMO', 'N', '171360', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '78', NULL, '03', 'N', NULL, NULL, NULL, 278);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171380', '1712', 'TO', '1790', '1701', '17001', '17', 'PALMEIRAS DO TOCANTINS', NULL, '63', '77913000', '9', '0185', '0185', '28104', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 747.895, '-6,61300', '-47,54600', 0, 'S', 0.5820, NULL, NULL, '17900', 'S', 'N', 3499, NULL, '1790', '1790', NULL, '1993', 'S', 5466, 'PALMEIRAS DO TOCANTINS', 'N', '171380', 'S', 'N', 'S', NULL, 22, 'S', 'N', 'N', '91', NULL, '03', 'N', NULL, NULL, NULL, 387);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210010', '2104', 'MA', '2102', '2104', '21016', '21', 'AFONSO CUNHA', NULL, '98', '65505000', '5', '0701', '0701', '09001', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 371.247, '-4,13300', '-43,32400', 76, 'S', 0.5580, NULL, NULL, '21900', 'S', 'N', 38, NULL, '2190', '2190', NULL, '1959', 'S', 1140, 'AFONSO CUNHA', 'N', '210010', 'S', 'S', 'S', NULL, 34, 'S', 'N', 'N', '2', NULL, '03', 'N', NULL, NULL, NULL, 407);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210020', '2101', 'MA', '2101', '2101', '21001', '21', 'ALCANTARA', NULL, '98', '65250000', '4', '0703', '0703', '09002', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1483.232, '-2,40900', '-44,41500', 32, 'S', 0.6000, NULL, NULL, '21900', 'S', 'N', 95, NULL, '2101', '2190', NULL, '1648', 'S', 1142, 'ALCÂNTARA', 'N', '210020', 'S', 'S', 'S', NULL, 115, 'S', 'N', 'S', '4', NULL, '03', 'N', NULL, NULL, NULL, 13);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210030', '2104', 'MA', '2102', '2104', '21016', '21', 'ALDEIAS ALTAS', NULL, '99', '65610000', '3', '0705', '0705', '09003', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1942.128, '-4,62800', '-43,47100', 94, 'S', 0.5490, NULL, NULL, '21900', 'S', 'N', 100, NULL, '2190', '2190', NULL, '1961', 'S', 1143, 'ALDEIAS ALTAS', 'N', '210030', 'S', 'S', 'S', NULL, 34, 'S', 'N', 'N', '5', NULL, '03', 'N', NULL, NULL, NULL, 407);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210050', '2106', 'MA', '2108', '2105', '21020', '21', 'ALTO PARNAIBA', NULL, '99', '65810000', '1', '0709', '0709', '09005', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 11132.105, '-9,11100', '-45,93000', 282, 'S', 0.6360, NULL, NULL, '21900', 'S', 'N', 158, NULL, '2190', '2190', NULL, '1881', 'S', 1147, 'ALTO PARNAÍBA', 'N', '210050', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '9', NULL, '03', 'N', NULL, NULL, NULL, 355);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210055', '2119', 'MA', '2107', '2102', '21007', '21', 'AMAPA DO MARANHAO', NULL, '98', '65293000', '0', '0110', '0110', '09140', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 442.319, '-1,67500', '-46,00200', 0, 'S', 0.5720, NULL, NULL, '21900', 'S', 'N', 184, NULL, '2190', '2190', NULL, '1997', 'S', 1148, 'AMAPÁ DO MARANHÃO', 'N', '210055', 'S', 'S', 'S', NULL, 139, 'S', 'N', 'N', '10', NULL, '03', 'N', NULL, NULL, NULL, 299);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210070', '2110', 'MA', '2101', '2101', '21005', '21', 'ANAJATUBA', NULL, '98', '65490000', '9', '0713', '0713', '09007', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1116.947, '-3,26400', '-44,62000', 9, 'S', 0.5670, NULL, NULL, '21900', 'S', 'N', 211, NULL, '2190', '2190', NULL, '1935', 'S', 1150, 'ANAJATUBA', 'N', '210070', 'S', 'S', 'S', NULL, 97, 'S', 'N', 'N', '12', NULL, '03', 'N', NULL, NULL, NULL, 122);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210083', '2112', 'MA', '2103', '2101', '21001', '21', 'APICUM-ACU', NULL, '98', '65275000', '2', '0112', '0112', '09141', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 651.915, '-1,46100', '-45,10300', 0, 'S', 0.5650, NULL, NULL, '21900', 'S', 'N', 276, NULL, '2190', '2190', NULL, '1997', 'S', 1152, 'APICUM-AÇU', 'N', '210083', 'S', 'S', 'S', NULL, 115, 'S', 'N', 'N', '14', NULL, '03', 'N', NULL, NULL, NULL, 239);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210087', '2119', 'MA', '2107', '2102', '21008', '21', 'ARAGUANA', NULL, '98', '65368000', '3', '0114', '0114', '09142', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 804.394, '-2,95300', '-45,66500', 0, 'S', 0.5480, NULL, NULL, '21900', 'S', 'N', 314, NULL, '2190', '2190', NULL, '1997', 'S', 1153, 'ARAGUANÃ', 'N', '210087', 'S', 'S', 'S', NULL, 139, 'S', 'N', 'N', '15', NULL, '03', 'N', NULL, NULL, NULL, 299);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210120', '2103', 'MA', '2106', '2103', '21010', '21', 'BACABAL', NULL, '99', '65700000', '2', '0723', '0723', '09012', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1682.601, '-4,22500', '-44,78000', 21, 'S', 0.6230, NULL, NULL, '21900', 'N', 'N', 441, NULL, '2190', '2190', NULL, '1920', 'S', 1158, 'BACABAL', 'N', '210120', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '20', NULL, '01', 'N', NULL, NULL, NULL, 237);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210450', '2113', 'MA', '2105', '2103', '21012', '21', 'GOVERNADOR ARCHER', NULL, '99', '65770000', '3', '0787', '0787', '09044', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 435.731, '-5,02200', '-44,27100', 145, 'S', 0.5670, NULL, NULL, '21900', 'S', 'N', 1918, NULL, '2190', '2190', NULL, '1959', 'S', 1215, 'GOVERNADOR ARCHER', 'N', '210450', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '77', NULL, '03', 'N', NULL, NULL, NULL, 11);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210540', '2110', 'MA', '2101', '2101', '21006', '21', 'ITAPECURU MIRIM', NULL, '98', '65485000', '1', '0807', '0807', '09054', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1165.585, '-3,39300', '-44,35900', 20, 'S', 0.6090, NULL, NULL, '21900', 'N', 'N', 2337, NULL, '2190', '2190', NULL, '1818', 'S', 1230, 'ITAPECURU MIRIM', 'N', '210540', 'S', 'S', 'S', NULL, 97, 'N', 'N', 'S', '92', NULL, '02', 'N', NULL, NULL, NULL, 122);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210542', '2102', 'MA', '2104', '2102', '21009', '21', 'ITINGA DO MARANHAO', NULL, '99', '65939000', '7', '0174', '0174', '09172', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3590.033, '-4,45000', '-47,52600', 200, 'S', 0.6640, NULL, NULL, '21900', 'S', 'N', 2402, NULL, '2190', '2190', NULL, '1997', 'S', 1231, 'ITINGA DO MARANHÃO', 'N', '210542', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '93', NULL, '03', 'N', NULL, NULL, NULL, 10);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210545', '2118', 'MA', '2105', '2104', '21018', '21', 'JATOBA', NULL, '99', '65693000', '0', '0176', '0176', '09173', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 387.083, '-5,81700', '-44,22300', 190, 'S', 0.6170, NULL, NULL, '21900', 'S', 'N', 2525, NULL, '2190', '2190', NULL, '1997', 'S', 1232, 'JATOBÁ', 'N', '210545', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '94', NULL, '03', 'N', NULL, NULL, NULL, 12);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210547', '2105', 'MA', '2105', '2103', '21011', '21', 'JENIPAPO DOS VIEIRAS', NULL, '99', '65962000', '6', '0178', '0178', '09174', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1507.458, '-5,37100', '-45,63600', 150, 'S', 0.5160, NULL, NULL, '21900', 'S', 'N', 2534, NULL, '2190', '2190', NULL, '1997', 'S', 1233, 'JENIPAPO DOS VIEIRAS', 'N', '210547', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '95', NULL, '03', 'N', NULL, NULL, NULL, 121);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210550', '2109', 'MA', '2104', '2102', '21009', '21', 'JOAO LISBOA', NULL, '99', '65922000', '0', '0809', '0809', '09055', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1126.517, '-5,44800', '-47,40100', 291, 'S', 0.6300, NULL, NULL, '21900', 'S', 'N', 2562, NULL, '2102', '2190', NULL, '1961', 'S', 1234, 'JOÃO LISBOA', 'N', '210550', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '96', NULL, '03', 'N', NULL, NULL, NULL, 298);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210560', '2113', 'MA', '2105', '2103', '21011', '21', 'JOSELANDIA', NULL, '99', '65755000', '9', '0811', '0811', '09056', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 681.684, '-4,96700', '-44,70000', 60, 'S', 0.5340, NULL, NULL, '21900', 'S', 'N', 2584, NULL, '2190', '2190', NULL, '1961', 'S', 1235, 'JOSELÂNDIA', 'N', '210560', 'S', 'S', 'S', NULL, 140, 'N', 'N', 'N', '97', NULL, '03', 'N', NULL, NULL, NULL, 11);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210565', '2119', 'MA', '2107', '2102', '21007', '21', 'JUNCO DO MARANHAO', NULL, '98', '65294000', '8', '0180', '0180', '09175', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 539.126, '-1,84400', '-46,09200', 0, 'S', 0.5600, NULL, NULL, '21900', 'S', 'N', 2605, NULL, '2190', '2190', NULL, '1997', 'S', 1236, 'JUNCO DO MARANHÃO', 'N', '210565', 'S', 'S', 'S', NULL, 139, 'N', 'N', 'N', '98', NULL, '03', 'N', NULL, NULL, NULL, 299);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210570', '2111', 'MA', '2106', '2102', '21008', '21', 'LAGO DA PEDRA', NULL, '99', '65715000', '8', '0813', '0813', '09057', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1636.467, '-4,57000', '-45,13200', 95, 'S', 0.6070, NULL, NULL, '21900', 'S', 'N', 2644, NULL, '2190', '2190', NULL, '1952', 'S', 1237, 'LAGO DA PEDRA', 'N', '210570', 'S', 'S', 'S', NULL, 140, 'N', 'N', 'S', '99', NULL, '03', 'N', NULL, NULL, NULL, 238);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210580', '2111', 'MA', '2106', '2103', '21010', '21', 'LAGO DO JUNCO', NULL, '99', '65710000', '7', '0815', '0815', '09058', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 308.771, '-4,60900', '-45,04900', 90, 'S', 0.5660, NULL, NULL, '21900', 'S', 'N', 2645, NULL, '2190', '2190', NULL, '1961', 'S', 1238, 'LAGO DO JUNCO', 'N', '210580', 'S', 'S', 'S', NULL, 140, 'N', 'N', 'N', '100', NULL, '03', 'N', NULL, NULL, NULL, 238);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210590', '2103', 'MA', '2106', '2103', '21010', '21', 'LAGO VERDE', NULL, '99', '65705000', '6', '0817', '0817', '09059', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 460.218, '-3,95700', '-44,82200', 16, 'S', 0.5330, NULL, NULL, '21900', 'S', 'N', 2647, NULL, '2190', '2190', NULL, '1961', 'S', 1240, 'LAGO VERDE', 'N', '210590', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '102', NULL, '03', 'N', NULL, NULL, NULL, 237);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210592', '2118', 'MA', '2105', '2104', '21018', '21', 'LAGOA DO MATO', NULL, '99', '65683000', '2', '0182', '0182', '09176', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1288.863, '-6,04700', '-43,52600', 200, 'S', 0.5500, NULL, NULL, '21900', 'S', 'N', 2661, NULL, '2190', '2190', NULL, '1997', 'S', 1241, 'LAGOA DO MATO', 'N', '210592', 'S', 'S', 'S', NULL, 34, 'S', 'N', 'N', '103', NULL, '03', 'N', NULL, NULL, NULL, 12);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210596', '2111', 'MA', '2106', '2102', '21008', '21', 'LAGOA GRANDE DO MARANHAO', NULL, '99', '65718000', '3', '0186', '0186', '09178', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 733.635, '-4,81300', '-45,33000', 0, 'S', 0.4920, NULL, NULL, '21900', 'S', 'N', 2673, NULL, '2190', '2190', NULL, '1997', 'S', 1242, 'LAGOA GRANDE DO MARANHÃO', 'N', '210596', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '104', NULL, '03', 'N', NULL, NULL, NULL, 238);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210598', '2109', 'MA', '2104', '2102', '21009', '21', 'LAJEADO NOVO', NULL, '99', '65937000', '9', '0188', '0188', '09179', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1047.725, '-6,18900', '-47,03500', 100, 'S', 0.6460, NULL, NULL, '21900', 'S', 'N', 2691, NULL, '2190', '2190', NULL, '1997', 'S', 1243, 'LAJEADO NOVO', 'N', '210598', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '105', NULL, '03', 'N', NULL, NULL, NULL, 298);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210600', '2111', 'MA', '2106', '2103', '21010', '21', 'LIMA CAMPOS', NULL, '99', '65728000', '3', '0819', '0819', '09060', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 321.932, '-4,52000', '-44,46700', 82, 'S', 0.5810, NULL, NULL, '21900', 'S', 'N', 2738, NULL, '2190', '2190', NULL, '1961', 'S', 1244, 'LIMA CAMPOS', 'N', '210600', 'S', 'S', 'S', NULL, 140, 'N', 'N', 'N', '106', NULL, '03', 'N', NULL, NULL, NULL, 238);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210610', '2106', 'MA', '2108', '2105', '21021', '21', 'LORETO', NULL, '99', '65895000', '2', '0821', '0821', '09061', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3596.888, '-7,08400', '-45,14100', 193, 'S', 0.6030, NULL, NULL, '21900', 'S', 'N', 2763, NULL, '2190', '2190', NULL, '1873', 'S', 1245, 'LORETO', 'N', '210610', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '107', NULL, '03', 'N', NULL, NULL, NULL, 355);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210620', '2119', 'MA', '2107', '2102', '21007', '21', 'LUIS DOMINGUES', NULL, '98', '65290000', '1', '0823', '0823', '09062', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 466.762, '-1,26800', '-45,87300', 5, 'S', 0.6320, NULL, NULL, '21900', 'S', 'N', 2774, NULL, '2190', '2190', NULL, '1961', 'S', 1246, 'LUÍS DOMINGUES', 'N', '210620', 'S', 'S', 'S', NULL, 139, 'S', 'N', 'N', '108', NULL, '03', 'N', NULL, NULL, NULL, 299);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210630', '2107', 'MA', '2101', '2104', '21013', '21', 'MAGALHAES DE ALMEIDA', NULL, '98', '65560000', '0', '0825', '0825', '09063', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 433.141, '-3,39600', '-42,20400', 36, 'S', 0.5470, NULL, NULL, '21900', 'S', 'N', 2822, NULL, '2190', '2190', NULL, '1952', 'S', 1247, 'MAGALHÃES DE ALMEIDA', 'N', '210630', 'S', 'S', 'S', NULL, 20, 'N', 'N', 'N', '109', NULL, '03', 'N', NULL, NULL, NULL, 408);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210632', '2119', 'MA', '2107', '2102', '21007', '21', 'MARACACUME', NULL, '98', '65289000', '6', '0190', '0190', '09180', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 629.330, '-2,04300', '-45,95900', 0, 'S', 0.6130, NULL, NULL, '21900', 'S', 'N', 2878, NULL, '2190', '2190', NULL, '1997', 'S', 1248, 'MARACAÇUMÉ', 'N', '210632', 'S', 'S', 'S', NULL, 139, 'S', 'N', 'N', '110', NULL, '03', 'N', NULL, NULL, NULL, 299);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210635', '2103', 'MA', '2106', '2102', '21008', '21', 'MARAJA DO SENA', NULL, '98', '65714000', '9', '0192', '0192', '09181', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 824.044, '-4,59900', '-45,57700', 0, 'S', 0.5190, NULL, NULL, '21900', 'S', 'N', 2888, NULL, '2190', '2190', NULL, '1997', 'S', 1249, 'MARAJÁ DO SENA', 'N', '210635', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '111', NULL, '03', 'N', NULL, NULL, NULL, 237);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210637', '2119', 'MA', '2107', '2102', '21007', '21', 'MARANHAOZINHO', NULL, '98', '65283000', '5', '0194', '0194', '09182', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 956.064, '-2,24100', '-45,85100', 0, 'S', 0.5290, NULL, NULL, '21900', 'S', 'N', 2890, NULL, '2190', '2190', NULL, '1997', 'S', 1250, 'MARANHÃOZINHO', 'N', '210637', 'S', 'S', 'S', NULL, 139, 'N', 'N', 'N', '112', NULL, '03', 'N', NULL, NULL, NULL, 299);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210640', '2107', 'MA', '2101', '2104', '21014', '21', 'MATA ROMA', NULL, '98', '65510000', '9', '0827', '0827', '09064', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 548.411, '-3,62500', '-43,11100', 80, 'S', 0.5670, NULL, NULL, '21900', 'S', 'N', 2959, NULL, '2190', '2190', NULL, '1961', 'S', 1251, 'MATA ROMA', 'N', '210640', 'S', 'S', 'S', NULL, 20, 'N', 'N', 'N', '113', NULL, '03', 'N', NULL, NULL, NULL, 408);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210650', '2116', 'MA', '2103', '2101', '21005', '21', 'MATINHA', NULL, '98', '65218000', '8', '0829', '0829', '09065', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 408.726, '-3,10100', '-45,03400', 39, 'S', 0.6400, NULL, NULL, '21900', 'S', 'N', 2972, NULL, '2190', '2190', NULL, '1948', 'S', 1252, 'MATINHA', 'N', '210650', 'S', 'S', 'S', NULL, 141, 'S', 'N', 'N', '114', NULL, '03', 'N', NULL, NULL, NULL, 124);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210675', '2110', 'MA', '2101', '2101', '21006', '21', 'MIRANDA DO NORTE', NULL, '98', '65495000', '5', '1283', '1283', '09135', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 353.553, '-3,56900', '-44,58400', 62, 'S', 0.6250, NULL, NULL, '21900', 'S', 'N', 3049, NULL, '2190', '2190', NULL, '1988', 'S', 1257, 'MIRANDA DO NORTE', 'N', '210675', 'S', 'S', 'S', NULL, 97, 'S', 'N', 'N', '119', NULL, '03', 'N', NULL, NULL, NULL, 122);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210680', '2112', 'MA', '2103', '2101', '21001', '21', 'MIRINZAL', NULL, '98', '65265000', '5', '0835', '0835', '09068', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 687.732, '-2,06500', '-44,78400', 31, 'S', 0.6500, NULL, NULL, '21900', 'S', 'N', 3063, NULL, '2190', '2190', NULL, '1961', 'S', 1258, 'MIRINZAL', 'N', '210680', 'S', 'S', 'S', NULL, 115, 'S', 'N', 'N', '120', NULL, '03', 'N', NULL, NULL, NULL, 239);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210690', '2115', 'MA', '2107', '2101', '21005', '21', 'MONCAO', NULL, '98', '65360000', '4', '0837', '0837', '09069', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1345.041, '-3,49200', '-45,25100', 14, 'S', 0.5640, NULL, NULL, '21900', 'S', 'N', 3080, NULL, '2190', '2190', NULL, '1935', 'S', 1259, 'MONÇÃO', 'N', '210690', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '121', NULL, '03', 'N', NULL, NULL, NULL, 356);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210700', '2109', 'MA', '2104', '2102', '21009', '21', 'MONTES ALTOS', NULL, '99', '65936000', '1', '0839', '0839', '09070', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1338.390, '-5,83100', '-47,06700', 244, 'S', 0.6110, NULL, NULL, '21900', 'S', 'N', 3126, NULL, '2102', '2190', NULL, '1958', 'S', 1260, 'MONTES ALTOS', 'N', '210700', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '122', NULL, '03', 'N', NULL, NULL, NULL, 298);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210710', '2114', 'MA', '2101', '2101', '21003', '21', 'MORROS', NULL, '98', '65160000', '0', '0841', '0841', '09071', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1715.325, '-2,86400', '-44,03900', 38, 'S', 0.5610, NULL, NULL, '21900', 'S', 'N', 3155, NULL, '2190', '2190', NULL, '1935', 'S', 1261, 'MORROS', 'N', '210710', 'S', 'S', 'S', NULL, 52, 'S', 'N', 'N', '123', NULL, '03', 'N', NULL, NULL, NULL, 123);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210720', '2110', 'MA', '2101', '2101', '21006', '21', 'NINA RODRIGUES', NULL, '98', '65450000', '9', '0843', '0843', '09072', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 572.513, '-3,46600', '-43,90500', 15, 'S', 0.5500, NULL, NULL, '21900', 'S', 'N', 3227, NULL, '2190', '2190', NULL, '1961', 'S', 1262, 'NINA RODRIGUES', 'N', '210720', 'S', 'S', 'S', NULL, 97, 'S', 'N', 'N', '124', NULL, '03', 'N', NULL, NULL, NULL, 122);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210725', '2106', 'MA', '2108', '2105', '21021', '21', 'NOVA COLINAS', NULL, '99', '65808000', '8', '0200', '0200', '09185', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 743.100, '-7,11600', '-46,25700', 400, 'S', 0.5940, NULL, NULL, '21900', 'S', 'N', 3272, NULL, '2190', '2190', NULL, '1997', 'S', 1263, 'NOVA COLINAS', 'N', '210725', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '125', NULL, '03', 'N', NULL, NULL, NULL, 355);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210730', '2118', 'MA', '2105', '2104', '21018', '21', 'NOVA IORQUE', NULL, '99', '65880000', '8', '0845', '0845', '09073', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 976.629, '-6,73400', '-44,04400', 178, 'S', 0.5740, NULL, NULL, '21900', 'S', 'N', 3295, NULL, '2190', '2190', NULL, '1886', 'S', 1264, 'NOVA IORQUE', 'N', '210730', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '126', NULL, '03', 'N', NULL, NULL, NULL, 12);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210735', '2119', 'MA', '2107', '2102', '21008', '21', 'NOVA OLINDA DO MARANHAO', NULL, '98', '65274000', '7', '0202', '0202', '09186', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 2464.124, '-2,84700', '-45,69500', 0, 'S', 0.5680, NULL, NULL, '21900', 'S', 'N', 3315, NULL, '2190', '2190', NULL, '1997', 'S', 1265, 'NOVA OLINDA DO MARANHÃO', 'N', '210735', 'S', 'S', 'S', NULL, 139, 'N', 'N', 'N', '127', NULL, '03', 'N', NULL, NULL, NULL, 299);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210745', '2116', 'MA', '2103', '2101', '21005', '21', 'OLINDA NOVA DO MARANHAO', NULL, '98', '65223000', '6', '0204', '0204', '09187', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 197.630, '-2,99800', '-44,99700', 28, 'S', 0.5960, NULL, NULL, '21900', 'S', 'N', 3401, NULL, '2190', '2190', NULL, '1997', 'S', 1267, 'OLINDA NOVA DO MARANHÃO', 'N', '210745', 'S', 'S', 'S', NULL, 141, 'S', 'N', 'N', '129', NULL, '03', 'N', NULL, NULL, NULL, 124);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210750', '2101', 'MA', '2101', '2101', '21002', '21', 'PACO DO LUMIAR', NULL, '98', '65130000', '6', '0849', '0849', '09075', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 132.410, '-2,53200', '-44,10800', 16, 'S', 0.7270, NULL, NULL, '21900', 'N', 'N', 3456, NULL, '2101', '2101', NULL, '1959', 'S', 1268, 'PAÇO DO LUMIAR', 'N', '210750', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '130', NULL, '01', 'N', NULL, NULL, NULL, 13);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210760', '2116', 'MA', '2103', '2101', '21005', '21', 'PALMEIRANDIA', NULL, '98', '65238000', '5', '0851', '0851', '09076', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 525.633, '-2,64500', '-44,89500', 20, 'S', 0.5690, NULL, NULL, '21900', 'S', 'N', 3495, NULL, '2190', '2190', NULL, '1959', 'S', 1269, 'PALMEIRÂNDIA', 'N', '210760', 'S', 'S', 'S', NULL, 141, 'N', 'N', 'N', '131', NULL, '03', 'N', NULL, NULL, NULL, 124);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210770', '2118', 'MA', '2105', '2104', '21018', '21', 'PARAIBANO', NULL, '99', '65670000', '4', '0853', '0853', '09077', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 530.500, '-6,43300', '-43,98400', 282, 'S', 0.5920, NULL, NULL, '21900', 'S', 'N', 3529, NULL, '2190', '2190', NULL, '1952', 'S', 1270, 'PARAIBANO', 'N', '210770', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '132', NULL, '03', 'N', NULL, NULL, NULL, 12);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210780', '2117', 'MA', '2102', '2104', '21017', '21', 'PARNARAMA', NULL, '99', '65640000', '3', '0855', '0855', '09078', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3487.119, '-5,68200', '-43,09300', 89, 'S', 0.5580, NULL, NULL, '21900', 'S', 'N', 3578, NULL, '2190', '2190', NULL, '1870', 'S', 1271, 'PARNARAMA', 'N', '210780', 'S', 'S', 'S', NULL, 34, 'S', 'N', 'N', '133', NULL, '03', 'N', NULL, NULL, NULL, 186);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210790', '2118', 'MA', '2105', '2104', '21018', '21', 'PASSAGEM FRANCA', NULL, '99', '65680000', '2', '0857', '0857', '09079', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1358.302, '-6,18000', '-43,78400', 243, 'S', 0.5450, NULL, NULL, '21900', 'S', 'N', 3588, NULL, '2190', '2190', NULL, '1935', 'S', 1272, 'PASSAGEM FRANCA', 'N', '210790', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '134', NULL, '03', 'N', NULL, NULL, NULL, 12);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171570', '1708', 'TO', '1790', '1701', '17002', '17', 'PALMEIRANTE', NULL, '63', '77798000', '5', '0189', '0189', '28107', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2640.738, '-7,86000', '-47,92600', 140, 'S', 0.6160, NULL, NULL, '17900', 'S', 'N', 3496, NULL, '1790', '1790', NULL, '1993', 'S', 5477, 'PALMEIRANTE', 'N', '171570', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '90', NULL, '03', 'N', NULL, NULL, NULL, 504);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171575', '1704', 'TO', '1790', '1701', '17005', '17', 'PALMEIROPOLIS', NULL, '63', '77365000', '4', '9649', '9649', '28051', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1703.936, '-13,04400', '-48,40200', 438, 'S', 0.7280, NULL, NULL, '17900', 'S', 'N', 3501, NULL, '1790', '1790', NULL, '1989', 'S', 5478, 'PALMEIRÓPOLIS', 'N', '171575', 'S', 'N', 'S', NULL, 124, 'N', 'N', 'N', '92', NULL, '03', 'N', NULL, NULL, NULL, 505);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171620', '1715', 'TO', '1790', '1702', '17008', '17', 'PARANA', NULL, '63', '77360000', '8', '9521', '9521', '28053', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 11260.151, '-12,61500', '-47,88300', 274, 'S', 0.6300, NULL, NULL, '17900', 'S', 'N', 3541, NULL, '1790', '1790', NULL, '1989', 'S', 5480, 'PARANÃ', 'N', '171620', 'S', 'N', 'S', NULL, 124, 'N', 'N', 'N', '94', NULL, '03', 'N', NULL, NULL, NULL, 218);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171630', '1710', 'TO', '1790', '1701', '17002', '17', 'PAU D''ARCO', NULL, '63', '77785000', '7', '0191', '0191', '28108', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1300.970, '-7,54000', '-49,37200', 0, 'S', 0.6500, NULL, NULL, '17900', 'S', 'N', 3611, NULL, '1790', '1790', NULL, '1993', 'S', 5481, 'PAU D ARCO', 'N', '171630', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '95', NULL, '03', 'N', NULL, NULL, NULL, 386);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171650', '1702', 'TO', '1790', '1702', '17006', '17', 'PEDRO AFONSO', NULL, '63', '77710000', '5', '9525', '9525', '28054', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2010.892, '-8,96800', '-48,17500', 201, 'S', 0.7380, NULL, NULL, '17900', 'S', 'N', 3665, NULL, '1790', '1790', NULL, '1989', 'S', 5482, 'PEDRO AFONSO', 'N', '171650', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '96', NULL, '03', 'N', NULL, NULL, NULL, 504);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171660', '1704', 'TO', '1790', '1701', '17005', '17', 'PEIXE', NULL, '63', '77460000', '4', '9527', '9527', '28055', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 5291.182, '-12,02500', '-48,53900', 240, 'S', 0.6950, NULL, NULL, '17900', 'S', 'N', 3679, NULL, '1790', '1790', NULL, '1989', 'S', 5483, 'PEIXE', 'N', '171660', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '97', NULL, '03', 'N', NULL, NULL, NULL, 505);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171665', '1707', 'TO', '1790', '1701', '17003', '17', 'PEQUIZEIRO', NULL, '63', '77730000', '3', '9705', '9705', '28056', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1209.798, '-8,59500', '-48,93400', 283, 'S', 0.6590, NULL, NULL, '17900', 'S', 'N', 3693, NULL, '1790', '1790', NULL, '1989', 'S', 5484, 'PEQUIZEIRO', 'N', '171665', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '98', NULL, '03', 'N', NULL, NULL, NULL, 504);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171670', '1707', 'TO', '1790', '1701', '17003', '17', 'COLMEIA', NULL, '63', '77725000', '3', '9529', '9529', '28057', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 990.712, '-8,72900', '-48,76500', 362, 'S', 0.6840, NULL, NULL, '17900', 'S', 'N', 1293, NULL, '1790', '1790', NULL, '1989', 'S', 5425, 'COLMÉIA', 'N', '171670', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '39', NULL, '03', 'N', NULL, NULL, NULL, 504);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171700', '1705', 'TO', '1790', '1702', '17008', '17', 'PINDORAMA DO TOCANTINS', NULL, '63', '77380000', '8', '9537', '9537', '28058', NULL, 'ATIVO', 'S', 'N', NULL, 'PINDORAMA DE GOIAS        ', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1559.080, '-11,13900', '-47,57900', 429, 'S', 0.6580, NULL, NULL, '17900', 'S', 'N', 3751, NULL, '1790', '1790', NULL, '1989', 'S', 5485, 'PINDORAMA DO TOCANTINS', 'N', '171700', 'S', 'N', 'S', NULL, 124, 'S', 'N', 'N', '99', NULL, '03', 'N', NULL, NULL, NULL, 278);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210800', '2118', 'MA', '2105', '2104', '21018', '21', 'PASTOS BONS', NULL, '99', '65870000', '9', '0859', '0859', '09080', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1620.196, '-6,60200', '-44,07700', 309, 'S', 0.6130, NULL, NULL, '21900', 'S', 'N', 3597, NULL, '2190', '2190', NULL, '1880', 'S', 1273, 'PASTOS BONS', 'N', '210800', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '135', NULL, '03', 'N', NULL, NULL, NULL, 12);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210805', '2107', 'MA', '2101', '2101', '21004', '21', 'PAULINO NEVES', NULL, '98', '65585000', '8', '0206', '0206', '09188', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 979.341, '-2,71900', '-42,53300', 4, 'S', 0.5080, NULL, NULL, '21900', 'S', 'N', 3619, NULL, '2190', '2190', NULL, '1997', 'S', 1274, 'PAULINO NEVES', 'N', '210805', 'S', 'S', 'S', NULL, 52, 'N', 'N', 'N', '136', NULL, '03', 'N', NULL, NULL, NULL, 408);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210810', '2103', 'MA', '2106', '2102', '21008', '21', 'PAULO RAMOS', NULL, '98', '65716000', '8', '0959', '0959', '09130', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 927.317, '-4,44500', '-45,23900', 70, 'S', 0.5370, NULL, NULL, '21900', 'S', 'N', 3630, NULL, '2190', '2190', NULL, '1968', 'S', 1275, 'PAULO RAMOS', 'N', '210810', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '137', NULL, '03', 'N', NULL, NULL, NULL, 237);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210820', '2111', 'MA', '2106', '2103', '21010', '21', 'PEDREIRAS', NULL, '99', '65725000', '7', '0861', '0861', '09081', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 288.507, '-4,57400', '-44,59700', 0, 'S', 0.6390, NULL, NULL, '21900', 'S', 'N', 3661, NULL, '2190', '2190', NULL, '1889', 'S', 1276, 'PEDREIRAS', 'N', '210820', 'S', 'S', 'S', NULL, 140, 'N', 'N', 'S', '138', NULL, '03', 'N', NULL, NULL, NULL, 238);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210825', '2112', 'MA', '2103', '2101', '21005', '21', 'PEDRO DO ROSARIO', NULL, '98', '65206000', '6', '0208', '0208', '09189', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1749.866, '-2,97300', '-45,34900', 38, 'S', 0.5360, NULL, NULL, '21900', 'S', 'N', 3670, NULL, '2190', '2190', NULL, '1997', 'S', 1277, 'PEDRO DO ROSÁRIO', 'N', '210825', 'S', 'S', 'S', NULL, 141, 'S', 'N', 'N', '139', NULL, '03', 'N', NULL, NULL, NULL, 239);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210845', '2108', 'MA', '2106', '2104', '21015', '21', 'PERITORO', NULL, '99', '65418000', '4', '0210', '0210', '09190', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 747.682, '-4,38300', '-44,33300', 53, 'S', 0.5370, NULL, NULL, '21900', 'S', 'N', 3703, NULL, '2190', '2190', NULL, '1997', 'S', 1280, 'PERITORÓ', 'N', '210845', 'S', 'S', 'S', NULL, 34, 'S', 'N', 'N', '142', NULL, '03', 'N', NULL, NULL, NULL, 297);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210850', '2115', 'MA', '2107', '2102', '21008', '21', 'PINDARE-MIRIM', NULL, '98', '65370000', '4', '0867', '0867', '09084', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 238.542, '-3,60800', '-45,34300', 19, 'S', 0.6200, NULL, NULL, '21900', 'S', 'N', 3747, NULL, '2190', '2190', NULL, '1931', 'S', 1281, 'PINDARÉ-MIRIM', 'N', '210850', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '143', NULL, '03', 'N', NULL, NULL, NULL, 356);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210860', '2112', 'MA', '2103', '2101', '21005', '21', 'PINHEIRO', NULL, '98', '65200000', '3', '0869', '0869', '09085', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1465.503, '-2,52100', '-45,08300', 15, 'S', 0.6390, NULL, NULL, '21900', 'N', 'N', 3765, NULL, '2190', '2190', NULL, '1856', 'S', 1282, 'PINHEIRO', 'N', '210860', 'S', 'S', 'S', NULL, 115, 'N', 'N', 'S', '144', NULL, '01', 'N', NULL, NULL, NULL, 239);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210870', '2115', 'MA', '2107', '2103', '21010', '21', 'PIO XII', NULL, '98', '65707000', '2', '0871', '0871', '09086', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 817.346, '-3,89400', '-45,17000', 0, 'S', 0.5420, NULL, NULL, '21900', 'S', 'N', 3772, NULL, '2190', '2190', NULL, '1959', 'S', 1283, 'PIO XII', 'N', '210870', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '145', NULL, '03', 'N', NULL, NULL, NULL, 356);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210880', '2110', 'MA', '2101', '2101', '21006', '21', 'PIRAPEMAS', NULL, '98', '65460000', '1', '0873', '0873', '09087', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 688.737, '-3,72700', '-44,22300', 39, 'S', 0.5720, NULL, NULL, '21900', 'S', 'N', 3794, NULL, '2190', '2190', NULL, '1952', 'S', 1284, 'PIRAPEMAS', 'N', '210880', 'S', 'S', 'S', NULL, 97, 'S', 'N', 'N', '146', NULL, '03', 'N', NULL, NULL, NULL, 122);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354085', '3509', 'SP', '3510', '3508', '35035', '35', 'PRACINHA', NULL, '18', '17790000', '3', '0812', NULL, '21639', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 63.047, '-21,85100', '-51,08700', 402, 'S', 0.7440, NULL, NULL, '35091', 'N', 'N', 3944, NULL, '3590', '3590', NULL, '1997', 'S', 5201, 'PRACINHA', 'N', '354085', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '460', NULL, '03', 'N', NULL, NULL, NULL, 322);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('172080', '1713', 'TO', '1790', '1701', '17001', '17', 'SITIO NOVO DO TOCANTINS', NULL, '63', '77940000', '4', '9613', '9613', '28073', NULL, 'ATIVO', 'S', 'N', NULL, 'SITIO NOVO DE GOIAS       ', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 324.102, '-5,60100', '-47,63800', 200, 'S', 0.5920, NULL, NULL, '17900', 'S', 'N', 5011, NULL, '1790', '1790', NULL, '1963', 'S', 5515, 'SÍTIO NOVO DO TOCANTINS', 'N', '172080', 'S', 'N', 'S', NULL, 22, 'N', 'N', 'N', '129', NULL, '03', 'N', NULL, NULL, NULL, 387);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('172085', '1709', 'TO', '1790', '1701', '17005', '17', 'SUCUPIRA', NULL, '63', '77458000', '3', '0335', '0335', '28120', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1025.515, '-11,99300', '-48,97100', 250, 'S', 0.7190, NULL, NULL, '17900', 'S', 'N', 5034, NULL, '1790', '1790', NULL, '1993', 'S', 5516, 'SUCUPIRA', 'N', '172085', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '130', NULL, '03', 'N', NULL, NULL, NULL, 505);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('172090', '1714', 'TO', '1790', '1702', '17008', '17', 'TAGUATINGA', NULL, '63', '77320000', '3', '9615', '9615', '28074', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2437.386, '-12,40400', '-46,43600', 599, 'S', 0.6670, NULL, NULL, '17900', 'S', 'N', 5064, NULL, '1790', '1790', NULL, '1989', 'S', 5517, 'TAGUATINGA', 'N', '172090', 'S', 'N', 'S', NULL, 124, 'N', 'N', 'N', '131', NULL, '03', 'N', NULL, NULL, NULL, 218);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('172097', '1709', 'TO', '1790', '1701', '17005', '17', 'TALISMA', NULL, '63', '77483000', '8', '0100', NULL, '28140', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2156.892, '-12,79500', '-49,09300', 270, 'S', 0.7190, NULL, NULL, '17900', 'S', 'N', 5072, NULL, '1790', '1790', NULL, '1997', 'S', 5519, 'TALISMÃ', 'N', '172097', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '133', NULL, '03', 'N', NULL, NULL, NULL, 505);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('172093', '1714', 'TO', '1790', '1702', '17008', '17', 'TAIPAS DO TOCANTINS', NULL, '63', '77308000', '7', '0325', '0325', '28121', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1116.195, '-12,18800', '-46,98900', 407, 'S', 0.6370, NULL, NULL, '17900', 'S', 'N', 5069, NULL, '1790', '1790', NULL, '1993', 'S', 5518, 'TAIPAS DO TOCANTINS', 'N', '172093', 'S', 'N', 'S', NULL, 124, 'N', 'N', 'N', '132', NULL, '03', 'N', NULL, NULL, NULL, 218);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('172100', '1701', 'TO', '1790', '1702', '17006', '17', 'PALMAS', NULL, '63', '77000000', '0', '9733', '9733', '28075', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'S', 2218.934, '-10,16700', '-48,33300', 230, 'S', 0.8000, NULL, NULL, '17900', 'N', 'N', 3486, NULL, '1790', '1701', NULL, '1989', 'S', 5476, 'PALMAS', 'N', '172100', 'S', 'N', 'S', NULL, NULL, 'S', 'S', 'S', '89', NULL, '01', 'N', NULL, NULL, NULL, 163);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210130', '2112', 'MA', '2103', '2101', '21001', '21', 'BACURI', NULL, '98', '65270000', '1', '0725', '0725', '09013', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 788.062, '-1,70300', '-45,13400', 15, 'S', 0.5940, NULL, NULL, '21900', 'S', 'N', 443, NULL, '2190', '2190', NULL, '1961', 'S', 1160, 'BACURI', 'N', '210130', 'S', 'S', 'S', NULL, 115, 'S', 'N', 'N', '22', NULL, '03', 'N', NULL, NULL, NULL, 239);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210135', '2116', 'MA', '2103', '2101', '21001', '21', 'BACURITUBA', NULL, '98', '65233000', '0', '0118', '0118', '09144', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 674.512, '-2,70600', '-44,73800', 15, 'S', 0.5690, NULL, NULL, '21900', 'S', 'N', 444, NULL, '2190', '2190', NULL, '1997', 'S', 1161, 'BACURITUBA', 'N', '210135', 'S', 'S', 'S', NULL, 115, 'N', 'N', 'N', '23', NULL, '03', 'N', NULL, NULL, NULL, 124);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210140', '2106', 'MA', '2108', '2105', '21020', '21', 'BALSAS', NULL, '99', '65800000', '0', '0727', '0727', '09014', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 13141.637, '-7,53300', '-46,03600', 247, 'S', 0.6960, NULL, NULL, '21900', 'N', 'N', 467, NULL, '2190', '2190', NULL, '1892', 'S', 1162, 'BALSAS', 'N', '210140', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '24', NULL, '01', 'N', NULL, NULL, NULL, 355);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210150', '2118', 'MA', '2105', '2104', '21018', '21', 'BARAO DE GRAJAU', NULL, '86', '65660000', '9', '0729', '0729', '09015', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2247.229, '-6,75600', '-43,02400', 108, 'S', 0.6310, NULL, NULL, '21900', 'S', 'N', 484, NULL, '2190', '2190', NULL, '1911', 'S', 1163, 'BARÃO DE GRAJAÚ', 'N', '210150', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '25', NULL, '03', 'N', NULL, NULL, NULL, 12);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210160', '2105', 'MA', '2105', '2103', '21011', '21', 'BARRA DO CORDA', NULL, '99', '65950000', '8', '0731', '0731', '09016', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 7962.428, '-5,50600', '-45,24300', 83, 'S', 0.6180, NULL, NULL, '21900', 'N', 'N', 513, NULL, '2190', '2190', NULL, '1854', 'S', 1164, 'BARRA DO CORDA', 'N', '210160', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '26', NULL, '01', 'N', NULL, NULL, NULL, 121);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210170', '2114', 'MA', '2101', '2101', '21004', '21', 'BARREIRINHAS', NULL, '98', '65590000', '7', '0733', '0733', '09017', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3111.296, '-2,74700', '-42,82600', 4, 'S', 0.5520, NULL, NULL, '21900', 'S', 'N', 537, NULL, '2190', '2190', NULL, '1871', 'S', 1165, 'BARREIRINHAS', 'N', '210170', 'S', 'S', 'S', NULL, 52, 'N', 'N', 'S', '27', NULL, '02', 'N', NULL, NULL, NULL, 123);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210173', '2110', 'MA', '2101', '2104', '21014', '21', 'BELAGUA', NULL, '98', '65535000', '1', '0120', '0120', '09145', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 499.427, '-3,15500', '-43,51000', 92, 'S', 0.4950, NULL, NULL, '21900', 'S', 'N', 570, NULL, '2190', '2190', NULL, '1997', 'S', 1167, 'BELÁGUA', 'N', '210173', 'S', 'S', 'S', NULL, 20, 'S', 'N', 'N', '29', NULL, '03', 'N', NULL, NULL, NULL, 122);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210177', '2115', 'MA', '2107', '2101', '21005', '21', 'BELA VISTA DO MARANHAO', NULL, '98', '65335000', '2', '0122', '0122', '09146', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 252.524, '-3,73100', '-45,31500', 0, 'S', 0.5690, NULL, NULL, '21900', 'S', 'N', 566, NULL, '2190', '2190', NULL, '1997', 'S', 1166, 'BELA VISTA DO MARANHÃO', 'N', '210177', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '28', NULL, '03', 'N', NULL, NULL, NULL, 356);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210180', '2118', 'MA', '2105', '2105', '21021', '21', 'BENEDITO LEITE', NULL, '99', '65885000', '6', '0735', '0735', '09018', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1781.662, '-7,22300', '-44,55800', 173, 'S', 0.5950, NULL, NULL, '21900', 'S', 'N', 590, NULL, '2190', '2190', NULL, '1935', 'S', 1168, 'BENEDITO LEITE', 'N', '210180', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '30', NULL, '03', 'N', NULL, NULL, NULL, 12);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210190', '2112', 'MA', '2103', '2101', '21001', '21', 'BEQUIMAO', NULL, '98', '65248000', '5', '0737', '0737', '09019', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 768.957, '-2,44900', '-44,78300', 17, 'S', 0.5770, NULL, NULL, '21900', 'S', 'N', 598, NULL, '2190', '2190', NULL, '1935', 'S', 1169, 'BEQUIMÃO', 'N', '210190', 'S', 'S', 'S', NULL, 115, 'S', 'N', 'N', '31', NULL, '03', 'N', NULL, NULL, NULL, 239);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210193', '2111', 'MA', '2106', '2103', '21010', '21', 'BERNARDO DO MEARIM', NULL, '99', '65723000', '9', '0124', '0124', '09147', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 261.401, '-4,58400', '-44,76400', 0, 'S', 0.5790, NULL, NULL, '21900', 'S', 'N', 603, NULL, '2190', '2190', NULL, '1997', 'S', 1170, 'BERNARDO DO MEARIM', 'N', '210193', 'S', 'S', 'S', NULL, 140, 'N', 'N', 'N', '32', NULL, '03', 'N', NULL, NULL, NULL, 238);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210890', '2111', 'MA', '2106', '2103', '21010', '21', 'POCAO DE PEDRAS', NULL, '99', '65740000', '0', '0875', '0875', '09088', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 655.179, '-4,74600', '-44,94300', 90, 'S', 0.5820, NULL, NULL, '21900', 'S', 'N', 3837, NULL, '2190', '2190', NULL, '1961', 'S', 1285, 'POÇÃO DE PEDRAS', 'N', '210890', 'S', 'S', 'S', NULL, 140, 'N', 'N', 'N', '147', NULL, '03', 'N', NULL, NULL, NULL, 238);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210900', '2109', 'MA', '2104', '2105', '21019', '21', 'PORTO FRANCO', NULL, '99', '65970000', '7', '0877', '0877', '09089', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1417.483, '-6,33800', '-47,39900', 162, 'S', 0.6780, NULL, NULL, '21900', 'S', 'N', 3915, NULL, '2190', '2190', NULL, '1919', 'S', 1286, 'PORTO FRANCO', 'N', '210900', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '148', NULL, '03', 'N', NULL, NULL, NULL, 298);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210905', '2112', 'MA', '2103', '2101', '21001', '21', 'PORTO RICO DO MARANHAO', NULL, '98', '65263000', '6', '0212', '0212', '09191', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 224.300, '-1,89300', '-44,60500', 0, 'S', 0.6140, NULL, NULL, '21900', 'S', 'N', 3924, NULL, '2190', '2190', NULL, '1997', 'S', 1287, 'PORTO RICO DO MARANHÃO', 'N', '210905', 'S', 'S', 'S', NULL, 115, 'S', 'N', 'N', '149', NULL, '03', 'N', NULL, NULL, NULL, 239);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210910', '2113', 'MA', '2105', '2103', '21012', '21', 'PRESIDENTE DUTRA', NULL, '99', '65760000', '6', '0879', '0879', '09090', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 793.853, '-5,29000', '-44,49000', 112, 'S', 0.6240, NULL, NULL, '21900', 'S', 'N', 3967, NULL, '2190', '2190', NULL, '1943', 'S', 1288, 'PRESIDENTE DUTRA', 'N', '210910', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '150', NULL, '03', 'N', NULL, NULL, NULL, 11);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210920', '2114', 'MA', '2101', '2101', '21003', '21', 'PRESIDENTE JUSCELINO', NULL, '98', '65140000', '5', '0881', '0881', '09091', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 442.135, '-2,92800', '-44,06500', 15, 'S', 0.5060, NULL, NULL, '21900', 'S', 'N', 3973, NULL, '2190', '2190', NULL, '1964', 'S', 1289, 'PRESIDENTE JUSCELINO', 'N', '210920', 'S', 'S', 'S', NULL, 52, 'S', 'N', 'N', '151', NULL, '03', 'N', NULL, NULL, NULL, 123);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210923', '2119', 'MA', '2107', '2102', '21008', '21', 'PRESIDENTE MEDICI', NULL, '98', '65279000', '9', '0214', '0214', '09192', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 437.665, '-2,38700', '-45,82000', 0, 'S', 0.5750, NULL, NULL, '21900', 'S', 'N', 3978, NULL, '2190', '2190', NULL, '1997', 'S', 1290, 'PRESIDENTE MÉDICI', 'N', '210923', 'S', 'S', 'S', NULL, 139, 'N', 'N', 'N', '152', NULL, '03', 'N', NULL, NULL, NULL, 299);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354620', '3510', 'SP', '3514', '3506', '35027', '35', 'SANTA CRUZ DA CONCEICAO', NULL, '19', '13625000', '7', '7025', '7025', '21463', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 149.432, '-22,14000', '-47,45200', 645, 'S', 0.8030, NULL, NULL, '35101', 'N', 'N', 4315, NULL, '3590', '3590', NULL, '1953', 'S', 5260, 'SANTA CRUZ DA CONCEIÇÃO', 'N', '354620', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '519', NULL, '03', 'N', NULL, NULL, NULL, 155);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210197', '2119', 'MA', '2107', '2102', '21007', '21', 'BOA VISTA DO GURUPI', NULL, '98', '65292000', '0', '0126', '0126', '09148', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 401.433, '-1,78800', '-46,30300', 0, 'S', 0.6210, NULL, NULL, '21900', 'S', 'N', 639, NULL, '2190', '2190', NULL, '1997', 'S', 1171, 'BOA VISTA DO GURUPI', 'N', '210197', 'S', 'S', 'S', NULL, 139, 'S', 'N', 'N', '33', NULL, '03', 'N', NULL, NULL, NULL, 299);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210200', '2115', 'MA', '2107', '2102', '21008', '21', 'BOM JARDIM', NULL, '98', '65380000', '2', '0955', '0955', '09128', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 6590.475, '-3,56500', '-45,99400', 40, 'S', 0.5150, NULL, NULL, '21900', 'S', 'N', 659, NULL, '2190', '2190', NULL, '1966', 'S', 1172, 'BOM JARDIM', 'N', '210200', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '34', NULL, '03', 'N', NULL, NULL, NULL, 356);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210203', '2102', 'MA', '2104', '2102', '21008', '21', 'BOM JESUS DAS SELVAS', NULL, '98', '65395000', '6', '0128', '0128', '09149', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 2679.418, '-4,42000', '-46,76500', 0, 'S', 0.5800, NULL, NULL, '21900', 'S', 'N', 672, NULL, '2190', '2190', NULL, '1997', 'S', 1173, 'BOM JESUS DAS SELVAS', 'N', '210203', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '35', NULL, '03', 'N', NULL, NULL, NULL, 10);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210207', '2103', 'MA', '2106', '2103', '21010', '21', 'BOM LUGAR', NULL, '99', '65704000', '7', '0130', '0130', '09150', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 446.444, '-4,22000', '-45,03900', 0, 'S', 0.5410, NULL, NULL, '21900', 'S', 'N', 683, NULL, '2190', '2190', NULL, '1997', 'S', 1174, 'BOM LUGAR', 'N', '210207', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '36', NULL, '03', 'N', NULL, NULL, NULL, 237);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210210', '2107', 'MA', '2101', '2104', '21014', '21', 'BREJO', NULL, '98', '65520000', '1', '0739', '0739', '09020', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1074.500, '-3,68400', '-42,75000', 55, 'S', 0.5520, NULL, NULL, '21900', 'S', 'N', 755, NULL, '2190', '2190', NULL, '1820', 'S', 1175, 'BREJO', 'N', '210210', 'S', 'S', 'S', NULL, 20, 'N', 'N', 'N', '37', NULL, '03', 'N', NULL, NULL, NULL, 408);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210220', '2104', 'MA', '2102', '2104', '21014', '21', 'BURITI', NULL, '98', '65515000', '0', '0741', '0741', '09021', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1474.041, '-3,94200', '-42,92500', 227, 'S', 0.5520, NULL, NULL, '21900', 'S', 'N', 788, NULL, '2190', '2190', NULL, '1888', 'S', 1177, 'BURITI', 'N', '210220', 'S', 'S', 'S', NULL, 20, 'S', 'N', 'S', '39', NULL, '03', 'N', NULL, NULL, NULL, 407);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210230', '2118', 'MA', '2105', '2104', '21017', '21', 'BURITI BAVO', NULL, '99', '65685000', '9', '0743', '0743', '09022', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1582.525, '-5,83700', '-43,83400', 227, 'S', 0.5830, NULL, NULL, '21900', 'S', 'N', 790, NULL, '2190', '2190', NULL, '1935', 'S', 1178, 'BURITI BRAVO', 'N', '210230', 'S', 'S', 'S', NULL, 34, 'N', 'N', 'N', '40', NULL, '03', 'N', NULL, NULL, NULL, 12);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210927', '2112', 'MA', '2103', '2101', '21005', '21', 'PRESIDENTE SARNEY', NULL, '98', '65204000', '0', '0216', '0216', '09193', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 724.164, '-2,59100', '-45,36400', 29, 'S', 0.5550, NULL, NULL, '21900', 'S', 'N', 3983, NULL, '2190', '2190', NULL, '1997', 'S', 1291, 'PRESIDENTE SARNEY', 'N', '210927', 'S', 'S', 'S', NULL, 115, 'S', 'N', 'N', '153', NULL, '03', 'N', NULL, NULL, NULL, 239);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210930', '2110', 'MA', '2101', '2101', '21006', '21', 'PRESIDENTE VARGAS', NULL, '98', '65455000', '4', '0883', '0883', '09092', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 467.323, '-3,40700', '-44,02400', 58, 'S', 0.5430, NULL, NULL, '21900', 'S', 'N', 3985, NULL, '2190', '2190', NULL, '1964', 'S', 1292, 'PRESIDENTE VARGAS', 'N', '210930', 'S', 'S', 'S', NULL, 97, 'N', 'N', 'N', '154', NULL, '03', 'N', NULL, NULL, NULL, 122);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210940', '2114', 'MA', '2101', '2101', '21004', '21', 'PRIMEIRA CRUZ', NULL, '98', '65190000', '3', '0885', '0885', '09093', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1367.833, '-2,51000', '-43,43800', 16, 'S', 0.5570, NULL, NULL, '21900', 'S', 'N', 3991, NULL, '2190', '2190', NULL, '1947', 'S', 1293, 'PRIMEIRA CRUZ', 'N', '210940', 'S', 'S', 'S', NULL, 52, 'S', 'N', 'N', '155', NULL, '03', 'N', NULL, NULL, NULL, 123);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210945', '2101', 'MA', '2101', '2101', '21002', '21', 'RAPOSA', NULL, '98', '65138000', '2', '0218', '0218', '09194', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 64.182, '-2,42300', '-44,10300', 3, 'S', 0.6320, NULL, NULL, '21900', 'S', 'N', 4054, NULL, '2101', '2190', NULL, '1997', 'S', 1294, 'RAPOSA', 'N', '210945', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '156', NULL, '03', 'N', NULL, NULL, NULL, 13);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210950', '2106', 'MA', '2108', '2105', '21020', '21', 'RIACHAO', NULL, '99', '65990000', '2', '0887', '0887', '09094', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 6373.153, '-7,36200', '-46,61700', 383, 'S', 0.5910, NULL, NULL, '21900', 'S', 'N', 4087, NULL, '2190', '2190', NULL, '1835', 'S', 1295, 'RIACHÃO', 'N', '210950', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '157', NULL, '03', 'N', NULL, NULL, NULL, 355);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210955', '2109', 'MA', '2104', '2102', '21009', '21', 'RIBAMAR FIQUENE', NULL, '99', '65938000', '1', '0220', '0220', '09195', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 900.483, '-5,93000', '-47,38400', 156, 'S', 0.6240, NULL, NULL, '21900', 'S', 'N', 4107, NULL, '2102', '2190', NULL, '1997', 'S', 1296, 'RIBAMAR FIQUENE', 'N', '210955', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '158', NULL, '03', 'N', NULL, NULL, NULL, 298);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210960', '2114', 'MA', '2101', '2101', '21003', '21', 'ROSARIO', NULL, '98', '65100000', '1', '0891', '0891', '09096', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 685.027, '-2,93400', '-44,23500', 14, 'S', 0.6300, NULL, NULL, '21900', 'S', 'N', 4224, NULL, '2190', '2190', NULL, '1835', 'S', 1297, 'ROSÁRIO', 'N', '210960', 'S', 'S', 'S', NULL, 52, 'N', 'N', 'S', '159', NULL, '03', 'N', NULL, NULL, NULL, 123);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210975', '2113', 'MA', '2105', '2103', '21011', '21', 'SANTA FILOMENA DO MARANHAO', NULL, '99', '65768000', '9', '0222', '0222', '09196', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 403.849, '-5,50100', '-44,56100', 180, 'S', 0.5330, NULL, NULL, '21900', 'S', 'N', 4339, NULL, '2190', '2190', NULL, '1997', 'S', 1299, 'SANTA FILOMENA DO MARANHÃO', 'N', '210975', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '161', NULL, '03', 'N', NULL, NULL, NULL, 11);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210980', '2112', 'MA', '2103', '2101', '21005', '21', 'SANTA HELENA', NULL, '98', '65208000', '9', '0895', '0895', '09098', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2308.403, '-2,23100', '-45,30000', 29, 'S', 0.6000, NULL, NULL, '21900', 'S', 'N', 4344, NULL, '2190', '2190', NULL, '1935', 'S', 1300, 'SANTA HELENA', 'N', '210980', 'S', 'S', 'S', NULL, 115, 'S', 'N', 'N', '162', NULL, '03', 'N', NULL, NULL, NULL, 239);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210990', '2115', 'MA', '2107', '2102', '21008', '21', 'SANTA INES', NULL, '98', '65300000', '8', '0957', '0957', '09129', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 407.681, '-3,66700', '-45,38000', 24, 'S', 0.6710, NULL, NULL, '21900', 'N', 'N', 4349, NULL, '2190', '2190', NULL, '1966', 'S', 1301, 'SANTA INÊS', 'N', '210990', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '163', NULL, '01', 'N', NULL, NULL, NULL, 356);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211000', '2115', 'MA', '2107', '2102', '21008', '21', 'SANTA LUZIA', NULL, '98', '65390000', '5', '0897', '0897', '09099', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 6133.424, '-4,06900', '-45,69000', 60, 'S', 0.5560, NULL, NULL, '21900', 'N', 'N', 4365, NULL, '2190', '2190', NULL, '1959', 'S', 1302, 'SANTA LUZIA', 'N', '211000', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '164', NULL, '01', 'N', NULL, NULL, NULL, 356);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211003', '2119', 'MA', '2107', '2102', '21008', '21', 'SANTA LUZIA DO PARUA', NULL, '98', '65272000', '9', '1285', '1285', '09133', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 904.946, '-2,62900', '-45,77300', 0, 'S', 0.6160, NULL, NULL, '21900', 'S', 'N', 4370, NULL, '2190', '2190', NULL, '1987', 'S', 1303, 'SANTA LUZIA DO PARUÁ', 'N', '211003', 'S', 'S', 'S', NULL, 139, 'S', 'N', 'N', '165', NULL, '03', 'N', NULL, NULL, NULL, 299);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211010', '2107', 'MA', '2101', '2104', '21013', '21', 'SANTA QUITERIA DO MARANHAO', NULL, '98', '65540000', '4', '0899', '0899', '09100', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2112.890, '-3,51600', '-42,54700', 36, 'S', 0.5610, NULL, NULL, '21900', 'S', 'N', 4392, NULL, '2190', '2190', NULL, '1935', 'S', 1304, 'SANTA QUITÉRIA DO MARANHÃO', 'N', '211010', 'S', 'S', 'S', NULL, 20, 'N', 'N', 'N', '166', NULL, '03', 'N', NULL, NULL, NULL, 408);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211020', '2114', 'MA', '2101', '2101', '21003', '21', 'SANTA RITA', NULL, '98', '65105000', '3', '0901', '0901', '09101', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 786.081, '-3,14400', '-44,32600', 28, 'S', 0.5920, NULL, NULL, '21900', 'S', 'N', 4393, NULL, '2190', '2190', NULL, '1961', 'S', 1305, 'SANTA RITA', 'N', '211020', 'S', 'S', 'S', NULL, 97, 'S', 'N', 'N', '167', NULL, '03', 'N', NULL, NULL, NULL, 123);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354765', '3515', 'SP', '3512', '3501', '35001', '35', 'SANTA SALETE', NULL, '17', '15768000', '0', '0822', NULL, '21644', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 79.168, '-20,24500', '-50,68800', 460, 'S', 0.7720, NULL, NULL, '35153', 'N', 'N', 4418, NULL, '3590', '3590', NULL, '1997', 'S', 5274, 'SANTA SALETE', 'N', '354765', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '533', NULL, '03', 'N', NULL, NULL, NULL, 436);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210232', '2102', 'MA', '2104', '2102', '21008', '21', 'BURITICUPU', NULL, '98', '65393000', '5', '0134', '0134', '09152', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2544.975, '-4,34600', '-46,40100', 0, 'S', 0.5950, NULL, NULL, '21900', 'N', 'N', 795, NULL, '2190', '2190', NULL, '1997', 'S', 1179, 'BURITICUPU', 'N', '210232', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '41', NULL, '02', 'N', NULL, NULL, NULL, 10);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211023', '2107', 'MA', '2101', '2104', '21013', '21', 'SANTANA DO MARANHAO', NULL, '98', '65555000', '7', '0224', '0224', '09197', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1094.650, '-3,11600', '-42,41200', 33, 'S', 0.4880, NULL, NULL, '21900', 'S', 'N', 4455, NULL, '2190', '2190', NULL, '1997', 'S', 1306, 'SANTANA DO MARANHÃO', 'N', '211023', 'S', 'S', 'S', NULL, 20, 'N', 'N', 'N', '168', NULL, '03', 'N', NULL, NULL, NULL, 408);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211027', '2114', 'MA', '2101', '2101', '21004', '21', 'SANTO AMARO DO MARANHAO', NULL, '98', '65195000', '8', '0226', '0226', '09198', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1601.164, '-2,50000', '-43,25400', 10, 'S', 0.5120, NULL, NULL, '21900', 'S', 'N', 4475, NULL, '2190', '2190', NULL, '1997', 'S', 1307, 'SANTO AMARO DO MARANHÃO', 'N', '211027', 'S', 'S', 'S', NULL, 52, 'S', 'N', 'N', '169', NULL, '03', 'N', NULL, NULL, NULL, 123);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211030', '2113', 'MA', '2105', '2103', '21010', '21', 'SANTO ANTONIO DOS LOPES', NULL, '99', '65730000', '2', '0903', '0903', '09102', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 770.190, '-4,86900', '-44,36000', 129, 'S', 0.5760, NULL, NULL, '21900', 'S', 'N', 4511, NULL, '2190', '2190', NULL, '1961', 'S', 1308, 'SANTO ANTÔNIO DOS LOPES', 'N', '211030', 'S', 'S', 'S', NULL, 140, 'S', 'N', 'N', '170', NULL, '03', 'N', NULL, NULL, NULL, 11);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211040', '2110', 'MA', '2101', '2104', '21014', '21', 'SAO BENEDITO DO RIO PRETO', NULL, '98', '65440000', '1', '0905', '0905', '09103', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 931.592, '-3,33400', '-43,52800', 34, 'S', 0.5430, NULL, NULL, '21900', 'S', 'N', 4525, NULL, '2190', '2190', NULL, '1948', 'S', 1309, 'SÃO BENEDITO DO RIO PRETO', 'N', '211040', 'S', 'S', 'S', NULL, 20, 'S', 'N', 'N', '171', NULL, '03', 'N', NULL, NULL, NULL, 122);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211050', '2116', 'MA', '2103', '2101', '21005', '21', 'SAO BENTO', NULL, '98', '65235000', '0', '0907', '0907', '09104', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 459.452, '-2,69600', '-44,82100', 2, 'S', 0.5920, NULL, NULL, '21900', 'S', 'N', 4528, NULL, '2190', '2190', NULL, '1948', 'S', 1310, 'SÃO BENTO', 'N', '211050', 'S', 'S', 'S', NULL, 141, 'N', 'N', 'N', '172', NULL, '03', 'N', NULL, NULL, NULL, 124);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211060', '2107', 'MA', '2101', '2104', '21013', '21', 'SAO BERNARDO', NULL, '98', '65550000', '9', '0909', '0909', '09105', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1006.657, '-3,36100', '-42,41800', 43, 'S', 0.5380, NULL, NULL, '21900', 'S', 'N', 4538, NULL, '2190', '2190', NULL, '1935', 'S', 1311, 'SÃO BERNARDO', 'N', '211060', 'S', 'S', 'S', NULL, 20, 'S', 'N', 'N', '173', NULL, '03', 'N', NULL, NULL, NULL, 408);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211065', '2118', 'MA', '2105', '2105', '21021', '21', 'SAO DOMINGOS DO AZEITAO', NULL, '99', '65888000', '8', '0228', '0228', '09199', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1058.637, '-6,81000', '-44,64500', 308, 'S', 0.6090, NULL, NULL, '21900', 'S', 'N', 4561, NULL, '2190', '2190', NULL, '1997', 'S', 1312, 'SÃO DOMINGOS DO AZEITÃO', 'N', '211065', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '174', NULL, '03', 'N', NULL, NULL, NULL, 12);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211070', '2113', 'MA', '2105', '2103', '21012', '21', 'SAO DOMINGOS DO MARANHAO', NULL, '99', '65790000', '8', '0911', '0911', '09106', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1303.155, '-5,57600', '-44,38500', 191, 'S', 0.5950, NULL, NULL, '21900', 'S', 'N', 4564, NULL, '2190', '2190', NULL, '1952', 'S', 1313, 'SÃO DOMINGOS DO MARANHÃO', 'N', '211070', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '175', NULL, '03', 'N', NULL, NULL, NULL, 11);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211080', '2106', 'MA', '2108', '2105', '21021', '21', 'SAO FELIX DE BALSAS', NULL, '99', '65890000', '7', '0913', '0913', '09107', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2032.302, '-7,08300', '-44,81300', 188, 'S', 0.5950, NULL, NULL, '21900', 'S', 'N', 4571, NULL, '2190', '2190', NULL, '1959', 'S', 1314, 'SÃO FÉLIX DE BALSAS', 'N', '211080', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '176', NULL, '03', 'N', NULL, NULL, NULL, 355);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211085', '2102', 'MA', '2104', '2102', '21009', '21', 'SAO FRANCISCO DO BREJAO', NULL, '99', '65929000', '6', '0230', '0230', '09200', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 745.593, '-5,12300', '-47,38600', 255, 'S', 0.6290, NULL, NULL, '21900', 'S', 'N', 4591, NULL, '2190', '2190', NULL, '1997', 'S', 1315, 'SÃO FRANCISCO DO BREJÃO', 'N', '211085', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '177', NULL, '03', 'N', NULL, NULL, NULL, 10);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211090', '2117', 'MA', '2102', '2104', '21018', '21', 'SAO FRANCISCO DO MARANHAO', NULL, '99', '65650000', '6', '0915', '0915', '09108', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2745.804, '-6,25100', '-42,85700', 76, 'S', 0.5550, NULL, NULL, '21900', 'S', 'N', 4595, NULL, '2190', '2190', NULL, '1835', 'S', 1316, 'SÃO FRANCISCO DO MARANHÃO', 'N', '211090', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '178', NULL, '03', 'N', NULL, NULL, NULL, 186);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211100', '2116', 'MA', '2103', '2101', '21005', '21', 'SAO JOAO BATISTA', NULL, '98', '65225000', '3', '0917', '0917', '09109', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 690.676, '-2,95500', '-44,80700', 29, 'S', 0.5920, NULL, NULL, '21900', 'S', 'N', 4625, NULL, '2190', '2190', NULL, '1958', 'S', 1317, 'SÃO JOÃO BATISTA', 'N', '211100', 'S', 'S', 'S', NULL, 141, 'N', 'N', 'N', '179', NULL, '03', 'N', NULL, NULL, NULL, 124);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211102', '2115', 'MA', '2107', '2102', '21008', '21', 'SAO JOAO DO CARU', NULL, '98', '65385000', '9', '0232', '0232', '09201', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 615.749, '-3,55400', '-46,25600', 50, 'S', 0.5110, NULL, NULL, '21900', 'S', 'N', 4652, NULL, '2190', '2190', NULL, '1997', 'S', 1318, 'SÃO JOÃO DO CARÚ', 'N', '211102', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '180', NULL, '03', 'N', NULL, NULL, NULL, 356);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211105', '2109', 'MA', '2104', '2105', '21019', '21', 'SAO JOAO DO PARAISO', NULL, '99', '65973000', '2', '0234', '0234', '09202', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2053.830, '-6,46100', '-47,05800', 230, 'S', 0.6540, NULL, NULL, '21900', 'S', 'N', 4661, NULL, '2190', '2190', NULL, '1997', 'S', 1319, 'SÃO JOÃO DO PARAÍSO', 'N', '211105', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '181', NULL, '03', 'N', NULL, NULL, NULL, 298);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211107', '2104', 'MA', '2102', '2104', '21017', '21', 'SAO JOAO DO SOTER', NULL, '99', '65615000', '8', '0236', '0236', '09203', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1438.020, '-5,11400', '-43,81000', 153, 'S', 0.5230, NULL, NULL, '21900', 'S', 'N', 4668, NULL, '2190', '2190', NULL, '1997', 'S', 1320, 'SÃO JOÃO DO SOTER', 'N', '211107', 'S', 'S', 'S', NULL, 34, 'S', 'N', 'N', '182', NULL, '03', 'N', NULL, NULL, NULL, 407);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211110', '2118', 'MA', '2105', '2104', '21018', '21', 'SAO JOAO DOS PATOS', NULL, '99', '65665000', '2', '0919', '0919', '09110', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1500.661, '-6,49500', '-43,70200', 328, 'S', 0.6400, NULL, NULL, '21900', 'S', 'N', 4672, NULL, '2190', '2190', NULL, '1931', 'S', 1321, 'SÃO JOÃO DOS PATOS', 'N', '211110', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '183', NULL, '03', 'N', NULL, NULL, NULL, 12);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211120', '2101', 'MA', '2101', '2101', '21002', '21', 'SAO JOSE DE RIBAMAR', NULL, '98', '65110000', '1', '0889', '0889', '09095', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 386.282, '-2,56200', '-44,05400', 20, 'S', 0.7000, NULL, NULL, '21900', 'N', 'N', 4702, NULL, '2101', '2101', NULL, '1952', 'S', 1322, 'SÃO JOSÉ DE RIBAMAR', 'N', '211120', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '184', NULL, '01', 'N', NULL, NULL, NULL, 13);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211125', '2113', 'MA', '2105', '2103', '21012', '21', 'SAO JOSE DOS BASILIOS', NULL, '99', '65762000', '0', '0238', '0238', '09204', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 362.617, '-5,05100', '-44,58400', 80, 'S', 0.5560, NULL, NULL, '21900', 'S', 'N', 4736, NULL, '2190', '2190', NULL, '1997', 'S', 1323, 'SÃO JOSÉ DOS BASÍLIOS', 'N', '211125', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '185', NULL, '03', 'N', NULL, NULL, NULL, 11);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211130', '2101', 'MA', '2101', '2101', '21002', '21', 'SAO LUIS', NULL, '98', '65001970', '0', '0921', '0921', '09111', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'S', 827.141, '-2,53000', '-44,30300', 24, 'S', 0.7780, NULL, NULL, '21900', 'N', 'N', 4752, NULL, '2101', '2101', NULL, '1612', 'S', 1324, 'SÃO LUÍS', 'N', '211130', 'S', 'S', 'S', NULL, NULL, 'S', 'S', 'S', '186', NULL, '01', 'N', NULL, NULL, NULL, 13);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211140', '2103', 'MA', '2106', '2103', '21010', '21', 'SAO LUIS GONZAGA DO MARANHAO', NULL, '99', '65708000', '9', '0805', '0805', '09053', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 968.554, '-4,38000', '-44,67000', 44, 'S', 0.5420, NULL, NULL, '21900', 'S', 'N', 4758, NULL, '2190', '2190', NULL, '1854', 'S', 1325, 'SÃO LUÍS GONZAGA DO MARANHÃO', 'N', '211140', 'S', 'S', 'S', NULL, 140, 'S', 'N', 'N', '187', NULL, '03', 'N', NULL, NULL, NULL, 237);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211150', '2108', 'MA', '2106', '2103', '21010', '21', 'SAO MATEUS DO MARANHAO', NULL, '99', '65470000', '8', '0923', '0923', '09112', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 783.224, '-4,04000', '-44,47000', 44, 'S', 0.5840, NULL, NULL, '21900', 'S', 'N', 4770, NULL, '2190', '2190', NULL, '1961', 'S', 1326, 'SÃO MATEUS DO MARANHÃO', 'N', '211150', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '188', NULL, '03', 'N', NULL, NULL, NULL, 297);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211153', '2102', 'MA', '2104', '2102', '21009', '21', 'SAO PEDRO DA AGUA BRANCA', NULL, '99', '65920000', '2', '0240', '0240', '09205', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 720.492, '-5,08500', '-48,42900', 171, 'S', 0.5880, NULL, NULL, '21900', 'S', 'N', 4801, NULL, '2190', '2190', NULL, '1997', 'S', 1327, 'SÃO PEDRO DA ÁGUA BRANCA', 'N', '211153', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '189', NULL, '03', 'N', NULL, NULL, NULL, 10);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211157', '2106', 'MA', '2108', '2105', '21019', '21', 'SAO PEDRO DOS CRENTES', NULL, '99', '65978000', '3', '0242', '0242', '09206', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 979.803, '-6,82600', '-46,53200', 342, 'S', 0.6260, NULL, NULL, '21900', 'S', 'N', 4815, NULL, '2190', '2190', NULL, '1997', 'S', 1328, 'SÃO PEDRO DOS CRENTES', 'N', '211157', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '190', NULL, '03', 'N', NULL, NULL, NULL, 355);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211160', '2106', 'MA', '2108', '2105', '21021', '21', 'SAO RAIMUNDO DAS MANGABEIRAS', NULL, '99', '65840000', '7', '0925', '0925', '09113', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3521.740, '-7,02200', '-45,48100', 225, 'S', 0.6380, NULL, NULL, '21900', 'S', 'N', 4818, NULL, '2190', '2190', NULL, '1948', 'S', 1329, 'SÃO RAIMUNDO DAS MANGABEIRAS', 'N', '211160', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '191', NULL, '03', 'N', NULL, NULL, NULL, 355);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522200', '5202', 'GO', '5205', '5205', '52016', '52', 'VIANOPOLIS', NULL, '62', '75260000', '5', '9641', '9641', '08221', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 954.279, '-16,74200', '-48,51600', 1002, 'S', 0.7840, NULL, NULL, '52900', 'N', 'N', 5426, NULL, '5290', '5290', NULL, '1948', 'S', 1135, 'VIANÓPOLIS', 'N', '522200', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '243', NULL, '03', 'N', NULL, NULL, NULL, 60);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210237', '2114', 'MA', '2101', '2101', '21003', '21', 'CACHOEIRA GRANDE', NULL, '98', '65165000', '4', '0138', '0138', '09154', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 705.636, '-2,92700', '-44,05800', 48, 'S', 0.5200, NULL, NULL, '21900', 'S', 'N', 839, NULL, '2190', '2190', NULL, '1997', 'S', 1181, 'CACHOEIRA GRANDE', 'N', '210237', 'S', 'S', 'S', NULL, 52, 'S', 'N', 'N', '43', NULL, '03', 'N', NULL, NULL, NULL, 123);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210240', '2116', 'MA', '2103', '2101', '21001', '21', 'CAJAPIO', NULL, '98', '65230000', '8', '0745', '0745', '09023', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 908.721, '-2,88100', '-44,67500', 18, 'S', 0.5620, NULL, NULL, '21900', 'S', 'N', 880, NULL, '2190', '2190', NULL, '1935', 'S', 1182, 'CAJAPIÓ', 'N', '210240', 'S', 'S', 'S', NULL, 115, 'S', 'N', 'N', '44', NULL, '03', 'N', NULL, NULL, NULL, 124);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210250', '2116', 'MA', '2103', '2101', '21005', '21', 'CAJARI', NULL, '98', '65210000', '7', '0747', '0747', '09024', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 544.050, '-3,32100', '-45,01100', 13, 'S', 0.5890, NULL, NULL, '21900', 'S', 'N', 881, NULL, '2190', '2190', NULL, '1948', 'S', 1183, 'CAJARI', 'N', '210250', 'S', 'S', 'S', NULL, 141, 'S', 'N', 'N', '45', NULL, '03', 'N', NULL, NULL, NULL, 124);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210255', '2109', 'MA', '2104', '2105', '21019', '21', 'CAMPESTRE DO MARANHAO', NULL, '99', '65968000', '6', '0140', '0140', '09155', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 615.379, '-6,17200', '-47,36400', 100, 'S', 0.6330, NULL, NULL, '21900', 'S', 'N', 929, NULL, '2190', '2190', NULL, '1997', 'S', 1184, 'CAMPESTRE DO MARANHÃO', 'N', '210255', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '46', NULL, '03', 'N', NULL, NULL, NULL, 298);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210260', '2119', 'MA', '2107', '2102', '21007', '21', 'CANDIDO MENDES', NULL, '98', '65280000', '6', '0749', '0749', '09025', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1731.794, '-1,44700', '-45,71700', 10, 'S', 0.5840, NULL, NULL, '21900', 'S', 'N', 1008, NULL, '2190', '2190', NULL, '1948', 'S', 1185, 'CÂNDIDO MENDES', 'N', '210260', 'S', 'S', 'S', NULL, 139, 'N', 'N', 'N', '47', NULL, '03', 'N', NULL, NULL, NULL, 299);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210270', '2110', 'MA', '2101', '2101', '21006', '21', 'CANTANHEDE', NULL, '98', '65465000', '5', '0751', '0751', '09026', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 797.887, '-3,63300', '-44,37700', 25, 'S', 0.5220, NULL, NULL, '21900', 'S', 'N', 1030, NULL, '2190', '2190', NULL, '1952', 'S', 1186, 'CANTANHEDE', 'N', '210270', 'S', 'S', 'S', NULL, 97, 'S', 'N', 'N', '48', NULL, '03', 'N', NULL, NULL, NULL, 122);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210275', '2113', 'MA', '2105', '2104', '21015', '21', 'CAPINZAL DO NORTE', NULL, '99', '65735000', '4', '0142', '0142', '09156', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 626.873, '-4,72800', '-44,32700', 132, 'S', 0.5430, NULL, NULL, '21900', 'S', 'N', 1054, NULL, '2190', '2190', NULL, '1997', 'S', 1187, 'CAPINZAL DO NORTE', 'N', '210275', 'S', 'S', 'S', NULL, 140, 'S', 'N', 'N', '49', NULL, '03', 'N', NULL, NULL, NULL, 11);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210280', '2106', 'MA', '2108', '2105', '21019', '21', 'CAROLINA', NULL, '99', '65980000', '4', '0753', '0753', '09027', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 6441.559, '-7,33300', '-47,46900', 167, 'S', 0.6580, NULL, NULL, '21900', 'S', 'N', 1131, NULL, '2190', '2190', NULL, '1831', 'S', 1188, 'CAROLINA', 'N', '210280', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '50', NULL, '03', 'N', NULL, NULL, NULL, 355);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210290', '2119', 'MA', '2107', '2102', '21007', '21', 'CARUTAPERA', NULL, '98', '65295000', '3', '0755', '0755', '09028', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1255.555, '-1,19500', '-46,02000', 26, 'S', 0.5710, NULL, NULL, '21900', 'S', 'N', 1137, NULL, '2190', '2190', NULL, '1935', 'S', 1189, 'CARUTAPERA', 'N', '210290', 'S', 'S', 'S', NULL, 139, 'N', 'N', 'N', '51', NULL, '03', 'N', NULL, NULL, NULL, 299);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210300', '2104', 'MA', '2102', '2104', '21017', '21', 'CAXIAS', NULL, '99', '65606970', '0', '0757', '0757', '09029', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 5223.981, '-4,85900', '-43,35600', 66, 'S', 0.6140, NULL, NULL, '21900', 'N', 'N', 1189, NULL, '2190', '2190', NULL, '1811', 'S', 1190, 'CAXIAS', 'N', '210300', 'S', 'S', 'S', NULL, 34, 'S', 'N', 'S', '52', NULL, '01', 'N', NULL, NULL, NULL, 407);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210310', '2112', 'MA', '2103', '2101', '21001', '21', 'CEDRAL', NULL, '98', '65260000', '9', '0759', '0759', '09030', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 262.278, '-2,00000', '-44,53600', 30, 'S', 0.6190, NULL, NULL, '21900', 'S', 'N', 1194, NULL, '2190', '2190', NULL, '1964', 'S', 1191, 'CEDRAL', 'N', '210310', 'S', 'S', 'S', NULL, 115, 'N', 'N', 'N', '53', NULL, '03', 'N', NULL, NULL, NULL, 239);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210312', '2112', 'MA', '2103', '2101', '21001', '21', 'CENTRAL DO MARANHAO', NULL, '98', '65267000', '5', '0144', '0144', '09157', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 366.458, '-2,19900', '-44,82600', 45, 'S', 0.5910, NULL, NULL, '21900', 'S', 'N', 1205, NULL, '2190', '2190', NULL, '1997', 'S', 1192, 'CENTRAL DO MARANHÃO', 'N', '210312', 'S', 'S', 'S', NULL, 115, 'S', 'N', 'N', '54', NULL, '03', 'N', NULL, NULL, NULL, 239);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211163', '2111', 'MA', '2106', '2103', '21010', '21', 'SAO RAIMUNDO DO DOCA BEZERRA', NULL, '99', '65753000', '1', '0244', '0244', '09207', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 281.225, '-5,10500', '-45,07700', 180, 'S', 0.5490, NULL, NULL, '21900', 'S', 'N', 4819, NULL, '2190', '2190', NULL, '1997', 'S', 1330, 'SÃO RAIMUNDO DO DOCA BEZERRA', 'N', '211163', 'S', 'S', 'S', NULL, 140, 'S', 'N', 'N', '192', NULL, '03', 'N', NULL, NULL, NULL, 238);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211170', '2116', 'MA', '2103', '2101', '21005', '21', 'SAO VICENTE FERRER', NULL, '98', '65220000', '6', '0927', '0927', '09114', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 390.404, '-2,89400', '-44,88000', 16, 'S', 0.5710, NULL, NULL, '21900', 'S', 'N', 4865, NULL, '2190', '2190', NULL, '1864', 'S', 1332, 'SÃO VICENTE FERRER', 'N', '211170', 'S', 'S', 'S', NULL, 141, 'S', 'N', 'N', '194', NULL, '03', 'N', NULL, NULL, NULL, 124);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211172', '2115', 'MA', '2107', '2103', '21010', '21', 'SATUBINHA', NULL, '98', '65709000', '2', '0248', '0248', '09209', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 605.838, '-4,03900', '-45,23800', 0, 'S', 0.5250, NULL, NULL, '21900', 'S', 'N', 4884, NULL, '2190', '2190', NULL, '1997', 'S', 1333, 'SATUBINHA', 'N', '211172', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '195', NULL, '03', 'N', NULL, NULL, NULL, 356);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522205', '5202', 'GO', '5205', '5205', '52015', '52', 'VICENTINOPOLIS', NULL, '64', '75555000', '4', '9657', '9657', '08233', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 737.251, '-17,73500', '-49,80600', 646, 'S', 0.7730, NULL, NULL, '52900', 'N', 'N', 5430, NULL, '5290', '5290', NULL, '1980', 'S', 1136, 'VICENTINÓPOLIS', 'N', '522205', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '244', NULL, '03', 'N', NULL, NULL, NULL, 60);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211174', '2113', 'MA', '2105', '2103', '21012', '21', 'SENADOR ALEXANDRE COSTA', NULL, '99', '65783000', '8', '0250', '0250', '09210', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 426.461, '-5,25600', '-44,05600', 149, 'S', 0.5340, NULL, NULL, '21900', 'S', 'N', 4903, NULL, '2190', '2190', NULL, '1997', 'S', 1334, 'SENADOR ALEXANDRE COSTA', 'N', '211174', 'S', 'S', 'S', NULL, 34, 'S', 'N', 'N', '196', NULL, '03', 'N', NULL, NULL, NULL, 11);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211176', '2109', 'MA', '2104', '2102', '21009', '21', 'SENADOR LA ROCQUE', NULL, '99', '65935000', '3', '0252', '0252', '09211', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 746.738, '-5,44300', '-47,29100', 180, 'S', 0.5880, NULL, NULL, '21900', 'S', 'N', 4913, NULL, '2102', '2190', NULL, '1997', 'S', 1335, 'SENADOR LA ROCQUE', 'N', '211176', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '197', NULL, '03', 'N', NULL, NULL, NULL, 298);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211178', '2112', 'MA', '2103', '2101', '21001', '21', 'SERRANO DO MARANHAO', NULL, '98', '65269000', '9', '0254', '0254', '09212', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1207.043, '-1,85600', '-45,12300', 0, 'S', 0.5610, NULL, NULL, '21900', 'S', 'N', 4956, NULL, '2190', '2190', NULL, '1997', 'S', 1336, 'SERRANO DO MARANHÃO', 'N', '211178', 'S', 'S', 'S', NULL, 115, 'S', 'N', 'N', '198', NULL, '03', 'N', NULL, NULL, NULL, 239);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211180', '2109', 'MA', '2104', '2103', '21011', '21', 'SITIO NOVO', NULL, '99', '65925000', '5', '0929', '0929', '09115', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3114.827, '-5,87800', '-46,69900', 260, 'S', 0.6310, NULL, NULL, '21900', 'S', 'N', 5009, NULL, '2190', '2190', NULL, '1961', 'S', 1337, 'SÍTIO NOVO', 'N', '211180', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '199', NULL, '03', 'N', NULL, NULL, NULL, 298);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211190', '2118', 'MA', '2105', '2104', '21018', '21', 'SUCUPIRA DO NORTE', NULL, '99', '65860000', '4', '0931', '0931', '09116', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 991.926, '-6,47700', '-44,19200', 485, 'S', 0.5940, NULL, NULL, '21900', 'S', 'N', 5035, NULL, '2190', '2190', NULL, '1961', 'S', 1338, 'SUCUPIRA DO NORTE', 'N', '211190', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '200', NULL, '03', 'N', NULL, NULL, NULL, 12);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211195', '2118', 'MA', '2105', '2104', '21018', '21', 'SUCUPIRA DO RIACHAO', NULL, '99', '65668000', '3', '0256', '0256', '09213', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 564.974, '-6,41100', '-43,54600', 290, 'S', 0.6050, NULL, NULL, '21900', 'S', 'N', 5036, NULL, '2190', '2190', NULL, '1997', 'S', 1339, 'SUCUPIRA DO RIACHÃO', 'N', '211195', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '201', NULL, '03', 'N', NULL, NULL, NULL, 12);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211200', '2106', 'MA', '2108', '2105', '21020', '21', 'TASSO FRAGOSO', NULL, '99', '65820000', '1', '0933', '0933', '09117', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4382.944, '-8,47500', '-45,74300', 242, 'S', 0.5990, NULL, NULL, '21900', 'S', 'N', 5122, NULL, '2190', '2190', NULL, '1961', 'S', 1340, 'TASSO FRAGOSO', 'N', '211200', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '202', NULL, '03', 'N', NULL, NULL, NULL, 355);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211210', '2108', 'MA', '2106', '2104', '21015', '21', 'TIMBIRAS', NULL, '99', '65420000', '0', '0935', '0935', '09118', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1486.479, '-4,25500', '-43,94100', 49, 'S', 0.5240, NULL, NULL, '21900', 'S', 'N', 5178, NULL, '2190', '2190', NULL, '1935', 'S', 1341, 'TIMBIRAS', 'N', '211210', 'S', 'S', 'S', NULL, 34, 'N', 'N', 'N', '203', NULL, '03', 'N', NULL, NULL, NULL, 297);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211220', '2117', 'MA', '2102', '2104', '21017', '21', 'TIMON', NULL, '99', '65630000', '9', '0937', '0937', '09119', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1740.559, '-5,09400', '-42,83700', 69, 'S', 0.6550, NULL, NULL, '21900', 'N', 'N', 5182, NULL, '2201', '2201', NULL, '1890', 'S', 1342, 'TIMON', 'N', '211220', 'S', 'S', 'S', NULL, 34, 'N', 'N', 'S', '204', NULL, '01', 'N', NULL, NULL, NULL, 186);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211223', '2111', 'MA', '2106', '2103', '21010', '21', 'TRIZIDELA DO VALE', NULL, '99', '65727000', '3', '0258', '0258', '09214', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 223.306, '-4,53800', '-44,62800', 0, 'S', 0.6080, NULL, NULL, '21900', 'S', 'N', 5243, NULL, '2190', '2190', NULL, '1997', 'S', 1343, 'TRIZIDELA DO VALE', 'N', '211223', 'S', 'S', 'S', NULL, 140, 'N', 'N', 'N', '205', NULL, '03', 'N', NULL, NULL, NULL, 238);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211227', '2115', 'MA', '2107', '2102', '21008', '21', 'TUFILANDIA', NULL, '98', '65378000', '4', '0260', '0260', '09215', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 276.924, '-3,72900', '-45,55400', 0, 'S', 0.5210, NULL, NULL, '21900', 'S', 'N', 5251, NULL, '2190', '2190', NULL, '1997', 'S', 1344, 'TUFILÂNDIA', 'N', '211227', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '206', NULL, '03', 'N', NULL, NULL, NULL, 356);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211230', '2113', 'MA', '2105', '2103', '21011', '21', 'TUNTUM', NULL, '99', '65763000', '8', '0939', '0939', '09120', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3573.041, '-5,25800', '-44,64900', 320, 'S', 0.5560, NULL, NULL, '21900', 'S', 'N', 5258, NULL, '2190', '2190', NULL, '1955', 'S', 1345, 'TUNTUM', 'N', '211230', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '207', NULL, '03', 'N', NULL, NULL, NULL, 11);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211240', '2112', 'MA', '2103', '2102', '21007', '21', 'TURIACU', NULL, '98', '65278000', '7', '0941', '0941', '09121', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2577.603, '-1,66300', '-45,37200', 5, 'S', 0.5670, NULL, NULL, '21900', 'S', 'N', 5271, NULL, '2190', '2190', NULL, '1818', 'S', 1346, 'TURIAÇU', 'N', '211240', 'S', 'S', 'S', NULL, 115, 'N', 'N', 'N', '208', NULL, '03', 'N', NULL, NULL, NULL, 239);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211245', '2112', 'MA', '2103', '2102', '21007', '21', 'TURILANDIA', NULL, '98', '65276000', '6', '0262', '0262', '09216', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1511.575, '-2,20100', '-45,34300', 0, 'S', 0.5270, NULL, NULL, '21900', 'S', 'N', 5272, NULL, '2190', '2190', NULL, '1997', 'S', 1347, 'TURILÂNDIA', 'N', '211245', 'S', 'S', 'S', NULL, 115, 'S', 'N', 'N', '209', NULL, '03', 'N', NULL, NULL, NULL, 239);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211250', '2107', 'MA', '2101', '2101', '21004', '21', 'TUTOIA', NULL, '98', '65580000', '6', '0943', '0943', '09122', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1489.376, '-2,76200', '-42,27400', 20, 'S', 0.5380, NULL, NULL, '21900', 'S', 'N', 5283, NULL, '2190', '2190', NULL, '1890', 'S', 1348, 'TUTÓIA', 'N', '211250', 'S', 'S', 'S', NULL, 20, 'N', 'N', 'N', '210', NULL, '03', 'N', NULL, NULL, NULL, 408);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211260', '2110', 'MA', '2101', '2104', '21014', '21', 'URBANO SANTOS', NULL, '98', '65530000', '5', '0945', '0945', '09123', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1207.774, '-3,20800', '-43,40400', 41, 'S', 0.5560, NULL, NULL, '21900', 'S', 'N', 5330, NULL, '2190', '2190', NULL, '1935', 'S', 1349, 'URBANO SANTOS', 'N', '211260', 'S', 'S', 'S', NULL, 20, 'S', 'N', 'N', '211', NULL, '03', 'N', NULL, NULL, NULL, 122);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211270', '2110', 'MA', '2101', '2101', '21006', '21', 'VARGEM GRANDE', NULL, '98', '65430000', '4', '0947', '0947', '09124', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1957.772, '-3,54300', '-43,91600', 43, 'S', 0.5440, NULL, NULL, '21900', 'S', 'N', 5374, NULL, '2190', '2190', NULL, '1935', 'S', 1350, 'VARGEM GRANDE', 'N', '211270', 'S', 'S', 'S', NULL, 97, 'S', 'N', 'S', '212', NULL, '03', 'N', NULL, NULL, NULL, 122);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211280', '2116', 'MA', '2103', '2101', '21005', '21', 'VIANA', NULL, '98', '65215000', '3', '0949', '0949', '09125', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1162.494, '-3,22000', '-45,00400', 22, 'S', 0.6190, NULL, NULL, '21900', 'S', 'N', 5425, NULL, '2190', '2190', NULL, '1757', 'S', 1351, 'VIANA', 'N', '211280', 'S', 'S', 'S', NULL, 141, 'N', 'N', 'S', '213', NULL, '03', 'N', NULL, NULL, NULL, 124);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211285', '2102', 'MA', '2104', '2102', '21009', '21', 'VILA NOVA DOS MARTIRIOS', NULL, '99', '65924000', '2', '0264', '0264', '09217', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1188.771, '-5,18800', '-48,13600', 307, 'S', 0.5940, NULL, NULL, '21900', 'S', 'N', 5451, NULL, '2190', '2190', NULL, '1997', 'S', 1352, 'VILA NOVA DOS MARTÍRIOS', 'N', '211285', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '214', NULL, '03', 'N', NULL, NULL, NULL, 10);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211290', '2110', 'MA', '2101', '2101', '21005', '21', 'VITORIA DO MEARIM', NULL, '98', '65350000', '2', '0951', '0951', '09126', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 726.435, '-3,46200', '-44,87100', 13, 'S', 0.6150, NULL, NULL, '21900', 'S', 'N', 5479, NULL, '2190', '2190', NULL, '1835', 'S', 1353, 'VITÓRIA DO MEARIM', 'N', '211290', 'S', 'S', 'S', NULL, 141, 'S', 'N', 'N', '215', NULL, '03', 'N', NULL, NULL, NULL, 122);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211300', '2103', 'MA', '2106', '2102', '21008', '21', 'VITORINO FREIRE', NULL, '98', '65320000', '9', '0953', '0953', '09127', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1122.700, '-4,28200', '-45,25100', 50, 'S', 0.5940, NULL, NULL, '21900', 'S', 'N', 5482, NULL, '2190', '2190', NULL, '1952', 'S', 1354, 'VITORINO FREIRE', 'N', '211300', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '216', NULL, '03', 'N', NULL, NULL, NULL, 237);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220010', '2204', 'PI', '2203', '2202', '22005', '22', 'AGRICOLANDIA', NULL, '86', '64440000', '3', '1001', '1001', '16001', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 112.419, '-5,79900', '-42,66900', 230, 'S', 0.6220, NULL, NULL, '22900', 'S', 'N', 42, NULL, '2290', '2290', NULL, '1962', 'S', 2964, 'AGRICOLÂNDIA', 'N', '220010', 'N', 'S', 'S', NULL, 45, 'S', 'N', 'N', '2', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220020', '2204', 'PI', '2203', '2202', '22005', '22', 'AGUA BRANCA', NULL, '86', '64460000', '2', '1003', '1003', '16002', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 97.039, '-5,89000', '-42,63800', 240, 'S', 0.6530, NULL, NULL, '22900', 'S', 'N', 50, NULL, '2290', '2290', NULL, '1954', 'S', 2965, 'ÁGUA BRANCA', 'N', '220020', 'N', 'S', 'S', NULL, 45, 'S', 'N', 'N', '3', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220025', '2206', 'PI', '2204', '2204', '22014', '22', 'ALAGOINHA DO PIAUI', NULL, '89', '64655000', '1', '9767', '9767', '16120', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 448.101, '-7,00800', '-40,93900', 375, 'S', 0.5760, NULL, NULL, '22900', 'S', 'N', 91, NULL, '2290', '2290', NULL, '1986', 'S', 2966, 'ALAGOINHA DO PIAUÍ', 'N', '220025', 'N', 'S', 'S', NULL, 96, 'S', 'N', 'N', '4', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220070', '2208', 'PI', '2205', '2203', '22011', '22', 'ANISIO DE ABREU', NULL, '89', '64780000', '7', '1013', '1013', '16007', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 326.822, '-9,18900', '-43,04600', 440, 'S', 0.6350, NULL, NULL, '22900', 'S', 'N', 246, NULL, '2290', '2290', NULL, '1962', 'S', 2973, 'ANÍSIO DE ABREU', 'N', '220070', 'N', 'S', 'S', NULL, 77, 'S', 'N', 'N', '11', NULL, '03', 'N', NULL, NULL, NULL, 140);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220080', '2210', 'PI', '2203', '2203', '22008', '22', 'ANTONIO ALMEIDA', NULL, '89', '64855000', '6', '1015', '1015', '16008', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 652.732, '-7,21900', '-44,19800', 240, 'S', 0.6430, NULL, NULL, '22900', 'S', 'N', 254, NULL, '2290', '2290', NULL, '1963', 'S', 2974, 'ANTÔNIO ALMEIDA', 'N', '220080', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '12', NULL, '03', 'N', NULL, NULL, NULL, 197);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220100', '2209', 'PI', '2203', '2202', '22005', '22', 'ARRAIAL', NULL, '89', '64480000', '2', '1019', '1019', '16010', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 635.818, '-6,65500', '-42,53200', 155, 'S', 0.6150, NULL, NULL, '22900', 'S', 'N', 386, NULL, '2290', '2290', NULL, '1963', 'S', 2976, 'ARRAIAL', 'N', '220100', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '15', NULL, '03', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220105', '2203', 'PI', '2202', '2202', '22004', '22', 'ASSUNCAO DO PIAUI', NULL, '86', '64333000', '1', '0270', NULL, '16153', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1690.716, '-5,19800', '-41,04400', 532, 'S', 0.5630, NULL, NULL, '22900', 'S', 'N', 409, NULL, '2290', '2290', NULL, '1997', 'S', 2977, 'ASSUNÇÃO DO PIAUÍ', 'N', '220105', 'N', 'S', 'S', NULL, 28, 'S', 'N', 'N', '16', NULL, '03', 'N', NULL, NULL, NULL, 422);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220115', '2210', 'PI', '2203', '2203', '22007', '22', 'BAIXA GRANDE DO RIBEIRO', NULL, '89', '64868000', '0', '2245', '2245', '16124', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 7808.945, '-7,85000', '-45,21400', 325, 'S', 0.5760, NULL, NULL, '22900', 'S', 'N', 454, NULL, '2290', '2290', NULL, '1993', 'S', 2979, 'BAIXA GRANDE DO RIBEIRO', 'N', '220115', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '18', NULL, '03', 'N', NULL, NULL, NULL, 197);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220117', '2205', 'PI', '2204', '2202', '22006', '22', 'BARRA D''ALCANTARA', NULL, '89', '64528000', '6', '0272', NULL, '16154', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 351.028, '-6,51700', '-42,11400', 310, 'S', 0.5880, NULL, NULL, '22900', 'S', 'N', 501, NULL, '2290', '2290', NULL, '1997', 'S', 2980, 'BARRA D ALCÂNTARA', 'N', '220117', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '19', NULL, '03', 'N', NULL, NULL, NULL, 366);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220120', '2202', 'PI', '2202', '2201', '22001', '22', 'BARRAS', NULL, '86', '64100000', '0', '1023', '1023', '16012', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1721.586, '-4,24700', '-42,29600', 70, 'S', 0.5810, NULL, NULL, '22900', 'N', 'N', 532, NULL, '2290', '2290', NULL, '1889', 'S', 2981, 'BARRAS', 'N', '220120', 'N', 'S', 'S', NULL, 161, 'N', 'N', 'S', '20', NULL, '03', 'N', NULL, NULL, NULL, 196);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220130', '2211', 'PI', '2206', '2203', '22010', '22', 'BARREIRAS DO PIAUI', NULL, '89', '64990000', '9', '1025', '1025', '16013', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2028.282, '-9,92500', '-45,47500', 400, 'S', 0.6680, NULL, NULL, '22900', 'S', 'N', 535, NULL, '2290', '2290', NULL, '1962', 'S', 2982, 'BARREIRAS DO PIAUÍ', 'N', '220130', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '21', NULL, '03', 'N', NULL, NULL, NULL, 199);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220140', '2204', 'PI', '2203', '2202', '22005', '22', 'BARRO DURO', NULL, '86', '64455000', '8', '1027', '1027', '16014', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 131.116, '-5,81800', '-42,51300', 200, 'S', 0.6240, NULL, NULL, '22900', 'S', 'N', 544, NULL, '2290', '2290', NULL, '1962', 'S', 2983, 'BARRO DURO', 'N', '220140', 'N', 'S', 'S', NULL, 45, 'S', 'N', 'N', '22', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220150', '2202', 'PI', '2202', '2201', '22001', '22', 'BATALHA', NULL, '86', '64190000', '7', '1029', '1029', '16015', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1588.905, '-4,02400', '-42,07800', 150, 'S', 0.5530, NULL, NULL, '22900', 'S', 'N', 554, NULL, '2290', '2290', NULL, '1938', 'S', 2984, 'BATALHA', 'N', '220150', 'N', 'S', 'S', NULL, 161, 'N', 'N', 'S', '23', NULL, '03', 'N', NULL, NULL, NULL, 196);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220155', '2207', 'PI', '2204', '2204', '22015', '22', 'BELA VISTA DO PIAUI', NULL, '89', '64705000', '6', '0274', NULL, '16155', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 312.361, '-7,98900', '-41,86800', 330, 'S', 0.6200, NULL, NULL, '22900', 'S', 'N', 568, NULL, '2290', '2290', NULL, '1997', 'S', 2985, 'BELA VISTA DO PIAUÍ', 'N', '220155', 'N', 'S', 'S', NULL, 133, 'S', 'N', 'N', '24', NULL, '03', 'N', NULL, NULL, NULL, 75);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220160', '2204', 'PI', '2203', '2202', '22003', '22', 'BENEDITINOS', NULL, '86', '64380000', '6', '1031', '1031', '16016', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 792.562, '-5,45500', '-42,36000', 150, 'S', 0.6040, NULL, NULL, '22900', 'S', 'N', 589, NULL, '2201', '2290', NULL, '1925', 'S', 2987, 'BENEDITINOS', 'N', '220160', 'N', 'S', 'S', NULL, 45, 'S', 'N', 'N', '26', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220170', '2209', 'PI', '2203', '2203', '22008', '22', 'BERTOLINIA', NULL, '89', '64870000', '5', '1033', '1033', '16017', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1225.168, '-7,64100', '-43,95100', 271, 'S', 0.6260, NULL, NULL, '22900', 'S', 'N', 606, NULL, '2290', '2290', NULL, '1938', 'S', 2988, 'BERTOLÍNIA', 'N', '220170', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '27', NULL, '03', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220173', '2206', 'PI', '2204', '2204', '22015', '22', 'BETANIA DO PIAUI', NULL, '89', '64753000', '9', '0278', NULL, '16157', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1092.305, '-8,14800', '-40,79600', 480, 'S', 0.4970, NULL, NULL, '22900', 'S', 'N', 610, NULL, '2290', '2290', NULL, '1997', 'S', 2989, 'BETÂNIA DO PIAUÍ', 'N', '220173', 'N', 'S', 'S', NULL, 96, 'S', 'N', 'N', '28', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220177', '2203', 'PI', '2202', '2201', '22001', '22', 'BOA HORA', NULL, '86', '64108000', '0', '0280', NULL, '16158', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 335.747, '-4,41100', '-42,08600', 121, 'S', 0.5360, NULL, NULL, '22900', 'S', 'N', 628, NULL, '2290', '2290', NULL, '1997', 'S', 2990, 'BOA HORA', 'N', '220177', 'N', 'S', 'S', NULL, 28, 'S', 'N', 'N', '29', NULL, '03', 'N', NULL, NULL, NULL, 422);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220190', '2211', 'PI', '2206', '2203', '22010', '22', 'BOM JESUS', NULL, '89', '64900000', '3', '1037', '1037', '16019', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 5469.156, '-9,07400', '-44,35900', 277, 'S', 0.6840, NULL, NULL, '22900', 'S', 'N', 666, NULL, '2290', '2290', NULL, '1938', 'S', 2992, 'BOM JESUS', 'N', '220190', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '31', NULL, '03', 'N', NULL, NULL, NULL, 199);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220192', '2208', 'PI', '2205', '2203', '22011', '22', 'BONFIM DO PIAUI', NULL, '89', '64775000', '9', '2251', '2251', '16116', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 293.593, '-9,16600', '-42,87400', 0, 'S', 0.6090, NULL, NULL, '22900', 'S', 'N', 698, NULL, '2290', '2290', NULL, '1993', 'S', 2994, 'BONFIM DO PIAUÍ', 'N', '220192', 'N', 'S', 'S', NULL, 77, 'S', 'N', 'N', '33', NULL, '03', 'N', NULL, NULL, NULL, 140);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220194', '2203', 'PI', '2202', '2202', '22004', '22', 'BOQUEIRAO DO PIAUI', NULL, '86', '64283000', '5', '0282', NULL, '16159', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 281.194, '-4,48700', '-42,07400', 123, 'S', 0.5660, NULL, NULL, '22900', 'S', 'N', 711, NULL, '2290', '2290', NULL, '1997', 'S', 2995, 'BOQUEIRÃO DO PIAUÍ', 'N', '220194', 'N', 'S', 'S', NULL, 28, 'S', 'N', 'N', '34', NULL, '03', 'N', NULL, NULL, NULL, 422);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220196', '2202', 'PI', '2202', '2201', '22001', '22', 'BRASILEIRA', NULL, '86', '64265000', '0', '2283', '2283', '16126', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 880.893, '-4,13100', '-41,78200', 180, 'S', 0.5800, NULL, NULL, '22900', 'S', 'N', 742, NULL, '2290', '2290', NULL, '1993', 'S', 2996, 'BRASILEIRA', 'N', '220196', 'N', 'S', 'S', NULL, 161, 'S', 'N', 'N', '35', NULL, '03', 'N', NULL, NULL, NULL, 196);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220209', '2206', 'PI', '2204', '2204', '22015', '22', 'CALDEIRAO GRANDE DO PIAUI', NULL, '89', '64695000', '1', '2271', '2271', '16129', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 514.307, '-7,33200', '-40,63700', 0, 'S', 0.5570, NULL, NULL, '22900', 'S', 'N', 898, NULL, '2290', '2290', NULL, '1993', 'S', 3003, 'CALDEIRÃO GRANDE DO PIAUÍ', 'N', '220209', 'N', 'S', 'S', NULL, 96, 'N', 'N', 'N', '42', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220210', '2207', 'PI', '2204', '2204', '22015', '22', 'CAMPINAS DO PIAUI', NULL, '89', '64730000', '9', '1041', '1041', '16021', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 796.953, '-7,66000', '-41,88200', 230, 'S', 0.5880, NULL, NULL, '22900', 'S', 'N', 940, NULL, '2290', '2290', NULL, '1963', 'S', 3004, 'CAMPINAS DO PIAUÍ', 'N', '220210', 'N', 'S', 'S', NULL, 133, 'S', 'N', 'N', '43', NULL, '03', 'N', NULL, NULL, NULL, 75);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220211', '2208', 'PI', '2205', '2204', '22015', '22', 'CAMPO ALEGRE DO FIDALGO', NULL, '89', '64767000', '7', '0290', NULL, '16163', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 755.529, '-8,37600', '-41,83600', 330, 'S', 0.5290, NULL, NULL, '22900', 'S', 'N', 947, NULL, '2290', '2290', NULL, '1997', 'S', 3005, 'CAMPO ALEGRE DO FIDALGO', 'N', '220211', 'N', 'S', 'S', NULL, 77, 'S', 'N', 'N', '44', NULL, '03', 'N', NULL, NULL, NULL, 140);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220213', '2206', 'PI', '2204', '2204', '22015', '22', 'CAMPO GRANDE DO PIAUI', NULL, '89', '64578000', '3', '0292', NULL, '16164', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 291.581, '-7,13200', '-41,03600', 440, 'S', 0.5700, NULL, NULL, '22900', 'S', 'N', 962, NULL, '2290', '2290', NULL, '1997', 'S', 3006, 'CAMPO GRANDE DO PIAUÍ', 'N', '220213', 'N', 'S', 'S', NULL, 96, 'N', 'N', 'N', '45', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220217', '2202', 'PI', '2202', '2201', '22001', '22', 'CAMPO LARGO DO PIAUI', NULL, '86', '64148000', '4', '0294', NULL, '16165', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 477.915, '-3,81200', '-42,62900', 60, 'S', 0.5100, NULL, NULL, '22900', 'S', 'N', 964, NULL, '2290', '2290', NULL, '1997', 'S', 3007, 'CAMPO LARGO DO PIAUÍ', 'N', '220217', 'N', 'S', 'S', NULL, 161, 'S', 'N', 'N', '46', NULL, '03', 'N', NULL, NULL, NULL, 196);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220220', '2203', 'PI', '2202', '2202', '22004', '22', 'CAMPO MAIOR', NULL, '86', '64280000', '8', '1043', '1043', '16022', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1699.383, '-4,82800', '-42,16900', 125, 'S', 0.6750, NULL, NULL, '22900', 'N', 'N', 967, NULL, '2290', '2290', NULL, '1889', 'S', 3008, 'CAMPO MAIOR', 'N', '220220', 'N', 'S', 'S', NULL, 28, 'N', 'N', 'N', '47', NULL, '03', 'N', NULL, NULL, NULL, 422);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220225', '2209', 'PI', '2203', '2203', '22009', '22', 'CANAVIEIRA', NULL, '89', '64833000', '1', '2247', '2247', '16130', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1803.466, '-7,68800', '-43,72100', 180, 'S', 0.6010, NULL, NULL, '22900', 'S', 'N', 998, NULL, '2290', '2290', NULL, '1993', 'S', 3009, 'CANAVIEIRA', 'N', '220225', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '48', NULL, '03', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220230', '2209', 'PI', '2203', '2203', '22011', '22', 'CANTO DO BURITI', NULL, '89', '64890000', '7', '1045', '1045', '16023', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 4409.804, '-8,11000', '-42,94400', 269, 'S', 0.6160, NULL, NULL, '22900', 'S', 'N', 1031, NULL, '2290', '2290', NULL, '1938', 'S', 3010, 'CANTO DO BURITI', 'N', '220230', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '49', NULL, '03', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220240', '2203', 'PI', '2202', '2202', '22004', '22', 'CAPITAO DE CAMPOS', NULL, '86', '64270000', '6', '1047', '1047', '16024', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 538.681, '-4,45700', '-41,94400', 130, 'S', 0.6030, NULL, NULL, '22900', 'S', 'N', 1058, NULL, '2290', '2290', NULL, '1956', 'S', 3011, 'CAPITÃO DE CAMPOS', 'N', '220240', 'N', 'S', 'S', NULL, 28, 'S', 'N', 'N', '50', NULL, '03', 'N', NULL, NULL, NULL, 196);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220245', '2208', 'PI', '2205', '2204', '22015', '22', 'CAPITAO GERVASIO OLIVEIRA', NULL, '89', '64763000', '5', '0296', NULL, '16166', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1114.408, '-8,49000', '-41,82000', 400, 'S', 0.5800, NULL, NULL, '22900', 'S', 'N', 1060, NULL, '2290', '2290', NULL, '1997', 'S', 3012, 'CAPITÃO GERVÁSIO OLIVEIRA', 'N', '220245', 'N', 'S', 'S', NULL, 77, 'N', 'N', 'N', '51', NULL, '03', 'N', NULL, NULL, NULL, 140);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220250', '2208', 'PI', '2205', '2203', '22011', '22', 'CARACOL', NULL, '89', '64795000', '5', '1049', '1049', '16025', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 449.465, '-9,27900', '-43,33000', 566, 'S', 0.5950, NULL, NULL, '22900', 'S', 'N', 1072, NULL, '2290', '2290', NULL, '1947', 'S', 3013, 'CARACOL', 'N', '220250', 'N', 'S', 'S', NULL, 77, 'N', 'N', 'N', '52', NULL, '03', 'N', NULL, NULL, NULL, 140);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211400', '2119', 'MA', '2107', '2102', '21008', '21', 'ZE DOCA', NULL, '98', '65365000', '7', '1287', '1287', '09136', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 2413.751, '-3,24300', '-45,82400', 0, 'S', 0.5900, NULL, NULL, '21900', 'S', 'N', 5507, NULL, '2190', '2190', NULL, '1988', 'S', 1355, 'ZÉ DOCA', 'N', '211400', 'S', 'S', 'S', NULL, 139, 'N', 'N', 'S', '217', NULL, '03', 'N', NULL, NULL, NULL, 299);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220253', '2201', 'PI', '2201', '2201', '22002', '22', 'CARAUBAS DO PIAUI', NULL, '86', '64233000', '9', '0298', '0298', '16167', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 471.447, '-3,47600', '-41,84300', 50, 'S', 0.4870, NULL, NULL, '22900', 'S', 'N', 1087, NULL, '2290', '2290', NULL, '1997', 'S', 3014, 'CARAÚBAS DO PIAUÍ', 'N', '220253', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '53', NULL, '03', 'N', NULL, NULL, NULL, 365);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220255', '2206', 'PI', '2204', '2204', '22015', '22', 'CARIDADE DO PIAUI', NULL, '89', '64590000', '4', '0300', NULL, '16168', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 423.369, '-7,73300', '-40,99000', 347, 'S', 0.5820, NULL, NULL, '22900', 'S', 'N', 1099, NULL, '2290', '2290', NULL, '1997', 'S', 3015, 'CARIDADE DO PIAUÍ', 'N', '220255', 'N', 'S', 'S', NULL, 96, 'S', 'N', 'N', '54', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220260', '2203', 'PI', '2202', '2202', '22004', '22', 'CASTELO DO PIAUI', NULL, '86', '64340000', '4', '1051', '1051', '16026', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 2063.960, '-5,32200', '-41,55300', 239, 'S', 0.5960, NULL, NULL, '22900', 'S', 'N', 1160, NULL, '2290', '2290', NULL, '1938', 'S', 3016, 'CASTELO DO PIAUÍ', 'N', '220260', 'N', 'S', 'S', NULL, 28, 'N', 'N', 'S', '55', NULL, '03', 'N', NULL, NULL, NULL, 422);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220265', '2201', 'PI', '2201', '2201', '22002', '22', 'CAXINGO', NULL, '86', '64228000', '3', '0302', NULL, '16169', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 488.162, '-3,41800', '-41,89600', 13, 'S', 0.5000, NULL, NULL, '22900', 'S', 'N', 1191, NULL, '2290', '2290', NULL, '1997', 'S', 3017, 'CAXINGÓ', 'N', '220265', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '56', NULL, '03', 'N', NULL, NULL, NULL, 365);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220310', '2211', 'PI', '2206', '2203', '22010', '22', 'CRISTINO CASTRO', NULL, '89', '64920000', '7', '1061', '1061', '16031', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1848.690, '-8,81800', '-44,22400', 239, 'S', 0.6570, NULL, NULL, '22900', 'S', 'N', 1446, NULL, '2290', '2290', NULL, '1953', 'S', 3028, 'CRISTINO CASTRO', 'N', '220310', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '67', NULL, '03', 'N', NULL, NULL, NULL, 199);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220323', '2211', 'PI', '2206', '2203', '22010', '22', 'CURRAIS', NULL, '89', '64905000', '0', '0308', '0308', '16172', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 3156.647, '-9,00700', '-44,41100', 320, 'S', 0.5590, NULL, NULL, '22900', 'S', 'N', 1491, NULL, '2290', '2290', NULL, '1997', 'S', 3030, 'CURRAIS', 'N', '220323', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '69', NULL, '03', 'N', NULL, NULL, NULL, 199);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220325', '2204', 'PI', '2203', '2202', '22003', '22', 'CURRALINHOS', NULL, '86', '64453000', '5', '0310', NULL, '16173', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 362.793, '-5,58300', '-42,77800', 126, 'S', 0.5710, NULL, NULL, '22900', 'S', 'N', 1498, NULL, '2201', '2290', NULL, '1997', 'S', 3032, 'CURRALINHOS', 'N', '220325', 'N', 'S', 'S', NULL, 45, 'S', 'N', 'N', '71', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220327', '2206', 'PI', '2204', '2204', '22015', '22', 'CURRAL NOVO DO PIAUI', NULL, '89', '64595000', '1', '0312', NULL, '16174', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 765.534, '-7,83200', '-40,90100', 370, 'S', 0.5380, NULL, NULL, '22900', 'S', 'N', 1495, NULL, '2290', '2290', NULL, '1997', 'S', 3031, 'CURRAL NOVO DO PIAUÍ', 'N', '220327', 'N', 'S', 'S', NULL, 96, 'S', 'N', 'N', '70', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220330', '2204', 'PI', '2203', '2202', '22003', '22', 'DEMERVAL LOBAO', NULL, '86', '64390000', '5', '1065', '1065', '16033', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 221.023, '-5,35800', '-42,67600', 112, 'S', 0.6310, NULL, NULL, '22900', 'S', 'N', 1518, NULL, '2201', '2290', NULL, '1963', 'S', 3033, 'DEMERVAL LOBÃO', 'N', '220330', 'N', 'S', 'S', NULL, 45, 'S', 'N', 'N', '72', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220335', '2208', 'PI', '2205', '2203', '22011', '22', 'DIRCEU ARCOVERDE', NULL, '89', '64785000', '4', '1229', '1229', '16119', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1005.706, '-9,33800', '-42,42800', 740, 'S', 0.6200, NULL, NULL, '22900', 'S', 'N', 1545, NULL, '2290', '2290', NULL, '1979', 'S', 3034, 'DIRCEU ARCOVERDE', 'N', '220335', 'N', 'S', 'S', NULL, 77, 'S', 'N', 'N', '73', NULL, '03', 'N', NULL, NULL, NULL, 140);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220410', '2209', 'PI', '2203', '2202', '22005', '22', 'FRANCISCO AYRES', NULL, '89', '64475000', '5', '1081', '1081', '16041', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 656.448, '-6,62300', '-42,69300', 125, 'S', 0.5860, NULL, NULL, '22900', 'S', 'N', 1822, NULL, '2290', '2290', NULL, '1963', 'S', 3046, 'FRANCISCO AYRES', 'N', '220410', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '85', NULL, '03', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220415', '2206', 'PI', '2204', '2204', '22015', '22', 'FRANCISCO MACEDO', NULL, '89', '64683000', '4', '0316', NULL, '16176', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 117.317, '-7,33100', '-40,78800', 360, 'S', 0.5450, NULL, NULL, '22900', 'S', 'N', 1827, NULL, '2290', '2290', NULL, '1997', 'S', 3047, 'FRANCISCO MACEDO', 'N', '220415', 'N', 'S', 'S', NULL, 96, 'N', 'N', 'N', '86', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220420', '2206', 'PI', '2204', '2204', '22014', '22', 'FRANCISCO SANTOS', NULL, '89', '64645000', '4', '1083', '1083', '16042', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 569.502, '-6,99300', '-41,13800', 270, 'S', 0.6070, NULL, NULL, '22900', 'S', 'N', 1830, NULL, '2290', '2290', NULL, '1960', 'S', 3048, 'FRANCISCO SANTOS', 'N', '220420', 'N', 'S', 'S', NULL, 96, 'N', 'N', 'N', '87', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220430', '2206', 'PI', '2204', '2204', '22015', '22', 'FRONTEIRAS', NULL, '89', '64690000', '3', '1085', '1085', '16043', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 789.828, '-7,08800', '-40,61600', 426, 'S', 0.6130, NULL, NULL, '22900', 'S', 'N', 1844, NULL, '2290', '2290', NULL, '1938', 'S', 3049, 'FRONTEIRAS', 'N', '220430', 'N', 'S', 'S', NULL, 96, 'S', 'N', 'N', '88', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220435', '2206', 'PI', '2204', '2204', '22013', '22', 'GEMINIANO', NULL, '89', '64613000', '2', '0318', NULL, '16177', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 471.570, '-7,15800', '-41,36100', 260, 'S', 0.5420, NULL, NULL, '22900', 'S', 'N', 1873, NULL, '2290', '2290', NULL, '1997', 'S', 3050, 'GEMINIANO', 'N', '220435', 'N', 'S', 'S', NULL, 96, 'S', 'N', 'N', '89', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220440', '2211', 'PI', '2206', '2203', '22010', '22', 'GILBUES', NULL, '89', '64930000', '2', '1087', '1087', '16044', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 3495.016, '-9,83200', '-45,34400', 481, 'S', 0.6510, NULL, NULL, '22900', 'S', 'N', 1884, NULL, '2290', '2290', NULL, '1938', 'S', 3051, 'GILBUÉS', 'N', '220440', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '90', NULL, '03', 'N', NULL, NULL, NULL, 199);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220535', '2208', 'PI', '2205', '2204', '22015', '22', 'JOAO COSTA', NULL, '89', '64765000', '9', '0326', NULL, '16181', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1716.165, '-8,51100', '-42,41400', 300, 'S', 0.5960, NULL, NULL, '22900', 'S', 'N', 2559, NULL, '2290', '2290', NULL, '1997', 'S', 3066, 'JOÃO COSTA', 'N', '220535', 'N', 'S', 'S', NULL, 77, 'S', 'N', 'N', '105', NULL, '03', 'N', NULL, NULL, NULL, 140);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220540', '2202', 'PI', '2202', '2201', '22001', '22', 'JOAQUIM PIRES', NULL, '86', '64170000', '9', '1107', '1107', '16054', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 739.570, '-3,50800', '-42,19800', 7, 'S', 0.5260, NULL, NULL, '22900', 'S', 'N', 2571, NULL, '2290', '2290', NULL, '1960', 'S', 3067, 'JOAQUIM PIRES', 'N', '220540', 'N', 'S', 'S', NULL, 161, 'S', 'N', 'N', '106', NULL, '03', 'N', NULL, NULL, NULL, 196);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220545', '2202', 'PI', '2202', '2201', '22001', '22', 'JOCA MARQUES', NULL, '86', '64165000', '8', '0328', NULL, '16182', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 166.441, '-3,47800', '-42,42800', 24, 'S', 0.5240, NULL, NULL, '22900', 'S', 'N', 2573, NULL, '2290', '2290', NULL, '1997', 'S', 3068, 'JOCA MARQUES', 'N', '220545', 'N', 'S', 'S', NULL, 161, 'S', 'N', 'N', '107', NULL, '03', 'N', NULL, NULL, NULL, 196);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220550', '2204', 'PI', '2203', '2202', '22003', '22', 'JOSE DE FREITAS', NULL, '86', '64110000', '8', '1109', '1109', '16055', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1538.205, '-4,75600', '-42,57600', 138, 'S', 0.6150, NULL, NULL, '22900', 'N', 'N', 2581, NULL, '2201', '2290', NULL, '1924', 'S', 3069, 'JOSÉ DE FREITAS', 'N', '220550', 'N', 'S', 'S', NULL, 45, 'S', 'N', 'S', '108', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220551', '2203', 'PI', '2202', '2202', '22004', '22', 'JUAZEIRO DO PIAUI', NULL, '86', '64343000', '6', '0330', NULL, '16183', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 827.199, '-5,17200', '-41,70300', 175, 'S', 0.5390, NULL, NULL, '22900', 'S', 'N', 2594, NULL, '2290', '2290', NULL, '1997', 'S', 3070, 'JUAZEIRO DO PIAUÍ', 'N', '220551', 'N', 'S', 'S', NULL, 28, 'S', 'N', 'N', '109', NULL, '03', 'N', NULL, NULL, NULL, 422);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220552', '2211', 'PI', '2206', '2203', '22012', '22', 'JULIO BORGES', NULL, '89', '64963000', '4', '0332', NULL, '16184', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1290.413, '-10,32300', '-44,23800', 389, 'S', 0.5930, NULL, NULL, '22900', 'S', 'N', 2601, NULL, '2290', '2290', NULL, '1997', 'S', 3071, 'JÚLIO BORGES', 'N', '220552', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '110', NULL, '03', 'N', NULL, NULL, NULL, 199);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220553', '2208', 'PI', '2205', '2203', '22011', '22', 'JUREMA', NULL, '89', '64782000', '2', '0334', NULL, '16185', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1297.315, '-9,23100', '-43,12800', 535, 'S', 0.5430, NULL, NULL, '22900', 'S', 'N', 2618, NULL, '2290', '2290', NULL, '1997', 'S', 3072, 'JUREMA', 'N', '220553', 'N', 'S', 'S', NULL, 77, 'S', 'N', 'N', '111', NULL, '03', 'N', NULL, NULL, NULL, 140);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220554', '2204', 'PI', '2203', '2202', '22005', '22', 'LAGOINHA DO PIAUI', NULL, '86', '64465000', '0', '0336', NULL, '16186', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 67.507, '-5,83100', '-42,62300', 240, 'S', 0.6310, NULL, NULL, '22900', 'S', 'N', 2682, NULL, '2290', '2290', NULL, '1997', 'S', 3078, 'LAGOINHA DO PIAUÍ', 'N', '220554', 'N', 'S', 'S', NULL, 45, 'N', 'N', 'N', '117', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220555', '2204', 'PI', '2203', '2202', '22003', '22', 'LAGOA ALEGRE', NULL, '86', '64138000', '7', '0999', '0999', '16137', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 394.658, '-4,51600', '-42,62500', 0, 'S', 0.5820, NULL, NULL, '22900', 'S', 'N', 2649, NULL, '2201', '2290', NULL, '1993', 'S', 3073, 'LAGOA ALEGRE', 'N', '220555', 'N', 'S', 'S', NULL, 45, 'S', 'N', 'N', '112', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220556', '2208', 'PI', '2205', '2204', '22015', '22', 'LAGOA DO BARRO DO PIAUI', NULL, '89', '64768000', '5', '2259', '2259', '16138', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1300.538, '-8,47800', '-41,52700', 0, 'S', 0.5470, NULL, NULL, '22900', 'S', 'N', 2658, NULL, '2290', '2290', NULL, '1993', 'S', 3075, 'LAGOA DO BARRO DO PIAUÍ', 'N', '220556', 'N', 'S', 'S', NULL, 77, 'S', 'N', 'N', '114', NULL, '03', 'N', NULL, NULL, NULL, 140);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210315', '2119', 'MA', '2107', '2102', '21007', '21', 'CENTRO DO GUILHERME', NULL, '98', '65288000', '8', '0146', '0146', '09158', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1074.039, '-2,36900', '-46,00200', 0, 'S', 0.4840, NULL, NULL, '21900', 'S', 'N', 1207, NULL, '2190', '2190', NULL, '1997', 'S', 1193, 'CENTRO DO GUILHERME', 'N', '210315', 'S', 'S', 'S', NULL, 139, 'S', 'N', 'N', '55', NULL, '03', 'N', NULL, NULL, NULL, 299);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210317', '2119', 'MA', '2107', '2102', '21007', '21', 'CENTRO NOVO DO MARANHAO', NULL, '98', '65299000', '4', '0148', '0148', '09159', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 8294.828, '-2,10700', '-46,12800', 0, 'S', 0.5710, NULL, NULL, '21900', 'S', 'N', 1208, NULL, '2190', '2190', NULL, '1997', 'S', 1194, 'CENTRO NOVO DO MARANHÃO', 'N', '210317', 'S', 'S', 'S', NULL, 139, 'N', 'N', 'N', '56', NULL, '03', 'N', NULL, NULL, NULL, 299);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210320', '2107', 'MA', '2101', '2104', '21014', '21', 'CHAPADINHA', NULL, '98', '65500000', '8', '0761', '0761', '09031', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3247.159, '-3,74200', '-43,36000', 105, 'S', 0.5880, NULL, NULL, '21900', 'N', 'N', 1238, NULL, '2190', '2190', NULL, '1890', 'S', 1195, 'CHAPADINHA', 'N', '210320', 'S', 'S', 'S', NULL, 20, 'N', 'N', 'S', '57', NULL, '01', 'N', NULL, NULL, NULL, 408);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210325', '2102', 'MA', '2104', '2102', '21009', '21', 'CIDELANDIA', NULL, '99', '65921000', '7', '0150', '0150', '09160', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1464.421, '-5,17400', '-47,78200', 241, 'S', 0.6130, NULL, NULL, '21900', 'S', 'N', 1259, NULL, '2190', '2190', NULL, '1997', 'S', 1196, 'CIDELÂNDIA', 'N', '210325', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '58', NULL, '03', 'N', NULL, NULL, NULL, 10);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220557', '2202', 'PI', '2202', '2202', '22004', '22', 'LAGOA DE SAO FRANCISCO', NULL, '86', '64258000', '3', '0338', NULL, '16187', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 155.637, '-4,39200', '-41,60100', 368, 'S', 0.5370, NULL, NULL, '22900', 'S', 'N', 2656, NULL, '2290', '2290', NULL, '1997', 'S', 3074, 'LAGOA DE SÃO FRANCISCO', 'N', '220557', 'N', 'S', 'S', NULL, 161, 'S', 'N', 'N', '113', NULL, '03', 'N', NULL, NULL, NULL, 196);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220558', '2204', 'PI', '2203', '2202', '22003', '22', 'LAGOA DO PIAUI', NULL, '86', '64388000', '1', '0340', NULL, '16188', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 427.195, '-5,41500', '-42,64300', 185, 'S', 0.5990, NULL, NULL, '22900', 'S', 'N', 2663, NULL, '2201', '2290', NULL, '1997', 'S', 3076, 'LAGOA DO PIAUÍ', 'N', '220558', 'N', 'S', 'S', NULL, 45, 'S', 'N', 'N', '115', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220559', '2205', 'PI', '2204', '2202', '22006', '22', 'LAGOA DO SITIO', NULL, '89', '64308000', '9', '0342', NULL, '16189', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 789.710, '-6,51300', '-41,58400', 455, 'S', 0.5740, NULL, NULL, '22900', 'S', 'N', 2664, NULL, '2290', '2290', NULL, '1997', 'S', 3077, 'LAGOA DO SÍTIO', 'N', '220559', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '116', NULL, '03', 'N', NULL, NULL, NULL, 366);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220560', '2209', 'PI', '2203', '2203', '22008', '22', 'LANDRI SALES', NULL, '89', '64850000', '7', '1111', '1111', '16056', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1193.316, '-7,26600', '-43,93000', 310, 'S', 0.6380, NULL, NULL, '22900', 'S', 'N', 2703, NULL, '2290', '2290', NULL, '1957', 'S', 3079, 'LANDRI SALES', 'N', '220560', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '118', NULL, '03', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220570', '2201', 'PI', '2201', '2201', '22002', '22', 'LUIS CORREIA', NULL, '86', '64220000', '6', '1113', '1113', '16057', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1071.276, '-2,87900', '-41,66700', 10, 'S', 0.5730, NULL, NULL, '22900', 'S', 'N', 2773, NULL, '2290', '2290', NULL, '1938', 'S', 3080, 'LUÍS CORREIA', 'N', '220570', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '119', NULL, '03', 'N', NULL, NULL, NULL, 365);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220580', '2202', 'PI', '2202', '2201', '22001', '22', 'LUZILANDIA', NULL, '86', '64160000', '5', '1115', '1115', '16058', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 704.433, '-3,45800', '-42,37000', 30, 'S', 0.5640, NULL, NULL, '22900', 'S', 'N', 2789, NULL, '2290', '2290', NULL, '1938', 'S', 3081, 'LUZILÂNDIA', 'N', '220580', 'N', 'S', 'S', NULL, 161, 'S', 'N', 'S', '120', NULL, '03', 'N', NULL, NULL, NULL, 196);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220585', '2202', 'PI', '2202', '2201', '22001', '22', 'MADEIRO', NULL, '86', '64168000', '4', '0344', NULL, '16190', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 177.219, '-3,48300', '-42,50400', 30, 'S', 0.5260, NULL, NULL, '22900', 'S', 'N', 2814, NULL, '2290', '2290', NULL, '1997', 'S', 3082, 'MADEIRO', 'N', '220585', 'N', 'S', 'S', NULL, 161, 'S', 'N', 'N', '121', NULL, '03', 'N', NULL, NULL, NULL, 196);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220590', '2209', 'PI', '2203', '2203', '22008', '22', 'MANOEL EMIDIO', NULL, '89', '64875000', '4', '1117', '1117', '16059', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1618.951, '-8,01300', '-43,87200', 227, 'S', 0.6110, NULL, NULL, '22900', 'S', 'N', 2863, NULL, '2290', '2290', NULL, '1963', 'S', 3083, 'MANOEL EMÍDIO', 'N', '220590', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '122', NULL, '03', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220595', '2206', 'PI', '2204', '2204', '22015', '22', 'MARCOLANDIA', NULL, '89', '64685000', '3', '2275', '2275', '16139', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 137.069, '-7,44300', '-40,66100', 0, 'S', 0.5980, NULL, NULL, '22900', 'S', 'N', 2906, NULL, '2290', '2290', NULL, '1993', 'S', 3084, 'MARCOLÂNDIA', 'N', '220595', 'N', 'S', 'S', NULL, 96, 'S', 'N', 'N', '123', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220600', '2209', 'PI', '2203', '2203', '22008', '22', 'MARCOS PARENTE', NULL, '89', '64845000', '1', '1119', '1119', '16060', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 775.767, '-7,12100', '-43,89400', 274, 'S', 0.6260, NULL, NULL, '22900', 'S', 'N', 2907, NULL, '2290', '2290', NULL, '1962', 'S', 3085, 'MARCOS PARENTE', 'N', '220600', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '124', NULL, '03', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220605', '2206', 'PI', '2204', '2204', '22015', '22', 'MASSAPE DO PIAUI', NULL, '89', '64573000', '0', '0346', '3468', '16191', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 525.619, '-7,46300', '-41,12600', 270, 'S', 0.5040, NULL, NULL, '22900', 'S', 'N', 2953, NULL, '2290', '2290', NULL, '1997', 'S', 3086, 'MASSAPÊ DO PIAUÍ', 'N', '220605', 'N', 'S', 'S', NULL, 96, 'S', 'N', 'N', '125', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220610', '2202', 'PI', '2202', '2201', '22001', '22', 'MATIAS OLIMPIO', NULL, '86', '64150000', '0', '1121', '1121', '16061', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 226.220, '-3,71600', '-42,55600', 69, 'S', 0.5440, NULL, NULL, '22900', 'S', 'N', 2970, NULL, '2290', '2290', NULL, '1953', 'S', 3087, 'MATIAS OLÍMPIO', 'N', '220610', 'N', 'S', 'S', NULL, 161, 'S', 'N', 'N', '126', NULL, '03', 'N', NULL, NULL, NULL, 196);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220620', '2204', 'PI', '2203', '2201', '22001', '22', 'MIGUEL ALVES', NULL, '86', '64130000', '9', '1123', '1123', '16062', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1393.708, '-4,16600', '-42,89500', 50, 'S', 0.5400, NULL, NULL, '22900', 'N', 'N', 3017, NULL, '2290', '2290', NULL, '1911', 'S', 3088, 'MIGUEL ALVES', 'N', '220620', 'N', 'S', 'S', NULL, 45, 'S', 'N', 'S', '127', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220630', '2204', 'PI', '2203', '2202', '22003', '22', 'MIGUEL LEAO', NULL, '86', '64445000', '8', '1125', '1125', '16063', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 74.517, '-5,68100', '-42,73900', 185, 'S', 0.6280, NULL, NULL, '22900', 'S', 'N', 3019, NULL, '2201', '2290', NULL, '1963', 'S', 3089, 'MIGUEL LEÃO', 'N', '220630', 'N', 'S', 'S', NULL, 45, 'S', 'N', 'N', '128', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220675', '2203', 'PI', '2202', '2202', '22004', '22', 'NOSSA SENHORA DE NAZARE', NULL, '86', '64288000', '3', '0356', NULL, '16196', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 356.341, '-4,63100', '-42,17300', 40, 'S', 0.5940, NULL, NULL, '22900', 'S', 'N', 3244, NULL, '2290', '2290', NULL, '1997', 'S', 3098, 'NOSSA SENHORA DE NAZARÉ', 'N', '220675', 'N', 'S', 'S', NULL, 28, 'S', 'N', 'N', '138', NULL, '03', 'N', NULL, NULL, NULL, 422);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220680', '2202', 'PI', '2202', '2201', '22001', '22', 'NOSSA SENHORA DOS REMEDIOS', NULL, '86', '64140000', '3', '1135', '1135', '16068', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 358.364, '-3,97900', '-42,62100', 53, 'S', 0.5230, NULL, NULL, '22900', 'S', 'N', 3247, NULL, '2290', '2290', NULL, '1961', 'S', 3099, 'NOSSA SENHORA DOS REMÉDIOS', 'N', '220680', 'N', 'S', 'S', NULL, 161, 'S', 'N', 'N', '139', NULL, '03', 'N', NULL, NULL, NULL, 196);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220690', '2205', 'PI', '2204', '2202', '22006', '22', 'NOVO ORIENTE DO PIAUI', NULL, '89', '64530000', '2', '1137', '1137', '16069', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 500.467, '-6,44900', '-41,93900', 235, 'S', 0.6030, NULL, NULL, '22900', 'S', 'N', 3372, NULL, '2290', '2290', NULL, '1961', 'S', 3101, 'NOVO ORIENTE DO PIAUÍ', 'N', '220690', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '141', NULL, '03', 'N', NULL, NULL, NULL, 366);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220695', '2203', 'PI', '2202', '2202', '22004', '22', 'NOVO SANTO ANTONIO', NULL, '86', '64365000', '1', '0358', NULL, '16197', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 528.408, '-5,28800', '-41,93300', 180, 'S', 0.5090, NULL, NULL, '22900', 'S', 'N', 3376, NULL, '2290', '2290', NULL, '1997', 'S', 3102, 'NOVO SANTO ANTÔNIO', 'N', '220695', 'N', 'S', 'S', NULL, 28, 'N', 'N', 'N', '142', NULL, '03', 'N', NULL, NULL, NULL, 422);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220700', '2207', 'PI', '2204', '2204', '22013', '22', 'OEIRAS', NULL, '89', '64500000', '9', '1139', '1139', '16070', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 2719.536, '-7,02500', '-42,13100', 166, 'S', 0.6250, NULL, NULL, '22900', 'N', 'N', 3385, NULL, '2290', '2290', NULL, '1761', 'S', 3103, 'OEIRAS', 'N', '220700', 'N', 'S', 'S', NULL, 133, 'N', 'N', 'S', '143', NULL, '03', 'N', NULL, NULL, NULL, 75);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210330', '2108', 'MA', '2106', '2104', '21015', '21', 'CODO', NULL, '99', '65400000', '7', '0763', '0763', '09032', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4364.499, '-4,45500', '-43,88600', 47, 'S', 0.5580, NULL, NULL, '21900', 'N', 'N', 1280, NULL, '2190', '2190', NULL, '1833', 'S', 1197, 'CODÓ', 'N', '210330', 'S', 'S', 'S', NULL, 34, 'S', 'N', 'S', '59', NULL, '01', 'N', NULL, NULL, NULL, 297);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210340', '2104', 'MA', '2102', '2104', '21016', '21', 'COELHO NETO', NULL, '98', '65620000', '6', '0765', '0765', '09033', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 975.523, '-4,25700', '-43,01300', 81, 'S', 0.5880, NULL, NULL, '21900', 'S', 'N', 1281, NULL, '2190', '2190', NULL, '1931', 'S', 1198, 'COELHO NETO', 'N', '210340', 'S', 'S', 'S', NULL, 34, 'S', 'N', 'S', '60', NULL, '03', 'N', NULL, NULL, NULL, 407);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210350', '2118', 'MA', '2105', '2104', '21018', '21', 'COLINAS', NULL, '99', '65690000', '5', '0767', '0767', '09034', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2033.570, '-6,02600', '-44,24900', 141, 'S', 0.5630, NULL, NULL, '21900', 'S', 'N', 1290, NULL, '2190', '2190', NULL, '1870', 'S', 1199, 'COLINAS', 'N', '210350', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '61', NULL, '03', 'N', NULL, NULL, NULL, 12);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220710', '2204', 'PI', '2203', '2202', '22005', '22', 'OLHO D''AGUA DO PIAUI', NULL, '86', '64468000', '8', '0360', NULL, '16198', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 220.127, '-5,84100', '-42,57500', 235, 'S', 0.5820, NULL, NULL, '22900', 'S', 'N', 3395, NULL, '2290', '2290', NULL, '1997', 'S', 3104, 'OLHO D ÁGUA DO PIAUÍ', 'N', '220710', 'N', 'S', 'S', NULL, 45, 'S', 'N', 'N', '144', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220720', '2206', 'PI', '2204', '2204', '22015', '22', 'PADRE MARCOS', NULL, '89', '64680000', '7', '1143', '1143', '16072', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 319.124, '-7,35500', '-40,90400', 360, 'S', 0.5390, NULL, NULL, '22900', 'S', 'N', 3461, NULL, '2290', '2290', NULL, '1964', 'S', 3105, 'PADRE MARCOS', 'N', '220720', 'N', 'S', 'S', NULL, 96, 'N', 'N', 'N', '145', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220735', '2209', 'PI', '2203', '2203', '22011', '22', 'PAJEU DO PIAUI', NULL, '89', '64898000', '5', '0362', NULL, '16199', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1075.263, '-7,85600', '-42,82200', 290, 'S', 0.6300, NULL, NULL, '22900', 'S', 'N', 3472, NULL, '2290', '2290', NULL, '1997', 'S', 3107, 'PAJEÚ DO PIAUÍ', 'N', '220735', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '147', NULL, '03', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220740', '2211', 'PI', '2206', '2203', '22010', '22', 'PALMEIRA DO PIAUI', NULL, '89', '64925000', '5', '1147', '1147', '16074', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 2021.228, '-8,72700', '-44,23600', 270, 'S', 0.6160, NULL, NULL, '22900', 'S', 'N', 3492, NULL, '2290', '2290', NULL, '1962', 'S', 3108, 'PALMEIRA DO PIAUÍ', 'N', '220740', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '148', NULL, '03', 'N', NULL, NULL, NULL, 199);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220785', '2209', 'PI', '2203', '2203', '22009', '22', 'PAVUSSU', NULL, '89', '64838000', '0', '0366', NULL, '16201', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1494.687, '-7,96600', '-43,22300', 300, 'S', 0.5550, NULL, NULL, '22900', 'S', 'N', 3633, NULL, '2290', '2290', NULL, '1997', 'S', 3116, 'PAVUSSU', 'N', '220785', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '157', NULL, '03', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220790', '2202', 'PI', '2202', '2202', '22004', '22', 'PEDRO II', NULL, '86', '64255000', '0', '1157', '1157', '16079', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1518.186, '-4,42500', '-41,45900', 603, 'S', 0.6050, NULL, NULL, '22900', 'N', 'N', 3672, NULL, '2290', '2290', NULL, '1854', 'S', 3117, 'PEDRO II', 'N', '220790', 'N', 'S', 'S', NULL, 161, 'S', 'N', 'S', '158', NULL, '03', 'N', NULL, NULL, NULL, 196);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220793', '2209', 'PI', '2203', '2204', '22015', '22', 'PEDRO LAURENTINO', NULL, '89', '64728000', '4', '0368', NULL, '16202', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 835.050, '-8,06800', '-42,28500', 200, 'S', 0.6300, NULL, NULL, '22900', 'S', 'N', 3673, NULL, '2290', '2290', NULL, '1997', 'S', 3118, 'PEDRO LAURENTINO', 'N', '220793', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '159', NULL, '03', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220795', '2209', 'PI', '2203', '2204', '22015', '22', 'NOVA SANTA RITA', NULL, '89', '64764000', '9', '0370', NULL, '16203', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1119.144, '-8,08700', '-42,05200', 292, 'S', 0.5400, NULL, NULL, '22900', 'S', 'N', 3715, NULL, '2290', '2290', NULL, '1997', 'S', 3100, 'NOVA SANTA RITA', 'N', '220795', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '140', NULL, '03', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220800', '2206', 'PI', '2204', '2204', '22013', '22', 'PICOS', NULL, '89', '64600000', '7', '1159', '1159', '16080', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 803.261, '-7,07700', '-41,46700', 206, 'S', 0.7030, NULL, NULL, '22900', 'N', 'N', 3725, NULL, '2290', '2290', NULL, '1890', 'S', 3119, 'PICOS', 'N', '220800', 'N', 'S', 'S', NULL, 96, 'S', 'N', 'S', '160', NULL, '01', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220810', '2205', 'PI', '2204', '2202', '22006', '22', 'PIMENTEIRAS', NULL, '89', '64320000', '6', '1161', '1161', '16081', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 4577.587, '-6,24500', '-41,41900', 283, 'S', 0.5740, NULL, NULL, '22900', 'S', 'N', 3743, NULL, '2290', '2290', NULL, '1954', 'S', 3120, 'PIMENTEIRAS', 'N', '220810', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '161', NULL, '03', 'N', NULL, NULL, NULL, 366);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220820', '2206', 'PI', '2204', '2204', '22014', '22', 'PIO IX', NULL, '89', '64660000', '5', '1163', '1163', '16082', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1948.843, '-6,83800', '-40,57900', 495, 'S', 0.5720, NULL, NULL, '22900', 'S', 'N', 3771, NULL, '2290', '2290', NULL, '1938', 'S', 3121, 'PIO IX', 'N', '220820', 'N', 'S', 'S', NULL, 96, 'N', 'N', 'N', '162', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220830', '2202', 'PI', '2202', '2201', '22002', '22', 'PIRACURUCA', NULL, '86', '64240000', '4', '1165', '1165', '16083', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 2380.511, '-3,92800', '-41,70900', 60, 'S', 0.6090, NULL, NULL, '22900', 'S', 'N', 3780, NULL, '2290', '2290', NULL, '1832', 'S', 3122, 'PIRACURUCA', 'N', '220830', 'N', 'S', 'S', NULL, 161, 'N', 'N', 'S', '163', NULL, '03', 'N', NULL, NULL, NULL, 196);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220840', '2202', 'PI', '2202', '2201', '22001', '22', 'PIRIPIRI', NULL, '86', '64260000', '3', '1167', '1167', '16084', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1408.928, '-4,27300', '-41,77700', 170, 'S', 0.6410, NULL, NULL, '22900', 'N', 'N', 3811, NULL, '2290', '2290', NULL, '1874', 'S', 3123, 'PIRIPIRI', 'N', '220840', 'N', 'S', 'S', NULL, 161, 'N', 'N', 'S', '164', NULL, '02', 'N', NULL, NULL, NULL, 196);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220850', '2202', 'PI', '2202', '2201', '22001', '22', 'PORTO', NULL, '86', '64145000', '2', '1169', '1169', '16085', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 252.713, '-3,89300', '-42,71000', 38, 'S', 0.5280, NULL, NULL, '22900', 'S', 'N', 3895, NULL, '2290', '2290', NULL, '1938', 'S', 3124, 'PORTO', 'N', '220850', 'N', 'S', 'S', NULL, 161, 'S', 'N', 'N', '165', NULL, '03', 'N', NULL, NULL, NULL, 196);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220855', '2209', 'PI', '2203', '2203', '22008', '22', 'PORTO ALEGRE DO PIAUI', NULL, '89', '64858000', '1', '0372', NULL, '16204', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1136.804, '-6,96700', '-44,18200', 180, 'S', 0.6080, NULL, NULL, '22900', 'S', 'N', 3899, NULL, '2290', '2290', NULL, '1997', 'S', 3125, 'PORTO ALEGRE DO PIAUÍ', 'N', '220855', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '166', NULL, '03', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220860', '2205', 'PI', '2204', '2202', '22006', '22', 'PRATA DO PIAUI', NULL, '86', '64370000', '1', '1171', '1171', '16086', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 196.323, '-5,66700', '-42,20700', 115, 'S', 0.6110, NULL, NULL, '22900', 'S', 'N', 3957, NULL, '2290', '2290', NULL, '1962', 'S', 3126, 'PRATA DO PIAUÍ', 'N', '220860', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '167', NULL, '03', 'N', NULL, NULL, NULL, 366);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220935', '2206', 'PI', '2204', '2204', '22013', '22', 'SANTANA DO PIAUI', NULL, '89', '64615000', '1', '2281', '2281', '16144', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 140.688, '-6,94800', '-41,51900', 0, 'S', 0.5770, NULL, NULL, '22900', 'S', 'N', 4459, NULL, '2290', '2290', NULL, '1993', 'S', 3139, 'SANTANA DO PIAUÍ', 'N', '220935', 'N', 'S', 'S', NULL, 96, 'N', 'N', 'N', '180', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220937', '2207', 'PI', '2204', '2204', '22013', '22', 'SANTA ROSA DO PIAUI', NULL, '89', '64518000', '7', '2261', '2261', '16145', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 356.237, '-6,79900', '-42,28800', 0, 'S', 0.5840, NULL, NULL, '22900', 'S', 'N', 4414, NULL, '2290', '2290', NULL, '1993', 'S', 3138, 'SANTA ROSA DO PIAUÍ', 'N', '220937', 'N', 'S', 'S', NULL, 133, 'N', 'N', 'N', '179', NULL, '03', 'N', NULL, NULL, NULL, 75);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220940', '2206', 'PI', '2204', '2204', '22014', '22', 'SANTO ANTONIO DE LISBOA', NULL, '89', '64640000', '1', '1187', '1187', '16094', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 395.799, '-6,98100', '-41,23400', 237, 'S', 0.6190, NULL, NULL, '22900', 'S', 'N', 4488, NULL, '2290', '2290', NULL, '1963', 'S', 3140, 'SANTO ANTÔNIO DE LISBOA', 'N', '220940', 'N', 'S', 'S', NULL, 96, 'N', 'N', 'N', '181', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220945', '2204', 'PI', '2203', '2202', '22005', '22', 'SANTO ANTONIO DOS MILAGRES', NULL, '86', '64438000', '0', '0378', NULL, '16207', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 33.152, '-6,04700', '-42,71000', 240, 'S', 0.5650, NULL, NULL, '22900', 'S', 'N', 4512, NULL, '2290', '2290', NULL, '1997', 'S', 3141, 'SANTO ANTÔNIO DOS MILAGRES', 'N', '220945', 'N', 'S', 'S', NULL, 45, 'N', 'N', 'N', '182', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220950', '2207', 'PI', '2204', '2204', '22015', '22', 'SANTO INACIO DO PIAUI', NULL, '89', '64560000', '0', '1189', '1189', '16095', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 895.671, '-7,43000', '-41,91100', 210, 'S', 0.6280, NULL, NULL, '22900', 'S', 'N', 4520, NULL, '2290', '2290', NULL, '1963', 'S', 3142, 'SANTO INÁCIO DO PIAUÍ', 'N', '220950', 'N', 'S', 'S', NULL, 133, 'N', 'N', 'N', '183', NULL, '03', 'N', NULL, NULL, NULL, 75);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220990', '2203', 'PI', '2202', '2202', '22004', '22', 'SAO JOAO DA SERRA', NULL, '86', '64350000', '6', '1197', '1197', '16099', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 962.258, '-5,51400', '-41,89900', 155, 'S', 0.5490, NULL, NULL, '22900', 'S', 'N', 4639, NULL, '2290', '2290', NULL, '1963', 'S', 3151, 'SÃO JOÃO DA SERRA', 'N', '220990', 'N', 'S', 'S', NULL, 28, 'N', 'N', 'N', '192', NULL, '03', 'N', NULL, NULL, NULL, 422);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210355', '2103', 'MA', '2106', '2101', '21005', '21', 'CONCEICAO DO LAGO-ACU', NULL, '98', '65340000', '4', '0152', '0152', '09161', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 827.426, '-3,83400', '-44,89300', 21, 'S', 0.5290, NULL, NULL, '21900', 'S', 'N', 1323, NULL, '2190', '2190', NULL, '1997', 'S', 1200, 'CONCEIÇÃO DO LAGO-AÇU', 'N', '210355', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '62', NULL, '03', 'N', NULL, NULL, NULL, 237);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220995', '2207', 'PI', '2204', '2204', '22013', '22', 'SAO JOAO DA VARJOTA', NULL, '89', '64510000', '5', '0386', NULL, '16211', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 395.368, '-6,94200', '-41,89000', 340, 'S', 0.5760, NULL, NULL, '22900', 'S', 'N', 4641, NULL, '2290', '2290', NULL, '1997', 'S', 3152, 'SÃO JOÃO DA VARJOTA', 'N', '220995', 'N', 'S', 'S', NULL, 133, 'S', 'N', 'N', '193', NULL, '03', 'N', NULL, NULL, NULL, 75);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220997', '2202', 'PI', '2202', '2201', '22001', '22', 'SAO JOAO DO ARRAIAL', NULL, '86', '64155000', '1', '0388', NULL, '16212', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 213.351, '-3,81900', '-42,44600', 110, 'S', 0.5280, NULL, NULL, '22900', 'S', 'N', 4649, NULL, '2290', '2290', NULL, '1997', 'S', 3153, 'SÃO JOÃO DO ARRAIAL', 'N', '220997', 'N', 'S', 'S', NULL, 161, 'S', 'N', 'N', '194', NULL, '03', 'N', NULL, NULL, NULL, 196);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221000', '2208', 'PI', '2205', '2204', '22015', '22', 'SAO JOAO DO PIAUI', NULL, '89', '64760000', '3', '1199', '1199', '16100', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1532.432, '-8,35800', '-42,24700', 222, 'S', 0.6500, NULL, NULL, '22900', 'S', 'N', 4664, NULL, '2290', '2290', NULL, '1906', 'S', 3154, 'SÃO JOÃO DO PIAUÍ', 'N', '221000', 'N', 'S', 'S', NULL, 77, 'S', 'N', 'S', '195', NULL, '03', 'N', NULL, NULL, NULL, 140);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221005', '2202', 'PI', '2202', '2201', '22002', '22', 'SAO JOSE DO DIVINO', NULL, '86', '64245000', '2', '2285', '2285', '16147', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 319.114, '-3,81100', '-41,83300', 55, 'S', 0.5440, NULL, NULL, '22900', 'S', 'N', 4714, NULL, '2290', '2290', NULL, '1993', 'S', 3155, 'SÃO JOSÉ DO DIVINO', 'N', '221005', 'N', 'S', 'S', NULL, 161, 'N', 'N', 'N', '196', NULL, '03', 'N', NULL, NULL, NULL, 196);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221010', '2209', 'PI', '2203', '2203', '22009', '22', 'SAO JOSE DO PEIXE', NULL, '89', '64555000', '2', '1201', '1201', '16101', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1339.496, '-7,49400', '-42,56400', 170, 'S', 0.6090, NULL, NULL, '22900', 'S', 'N', 4725, NULL, '2290', '2290', NULL, '1956', 'S', 3156, 'SÃO JOSÉ DO PEIXE', 'N', '221010', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '197', NULL, '03', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231040', '2305', 'CE', '2304', '2302', '23012', '23', 'PARAMOTI', NULL, '85', '62736000', '7', '1509', '1509', '05105', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 482.648, '-4,09700', '-39,23900', 90, 'S', 0.5970, NULL, NULL, '23900', 'S', 'N', 3540, NULL, '2390', '2390', NULL, '1957', 'S', 752, 'PARAMOTI', 'N', '231040', 'N', 'S', 'S', NULL, 85, 'N', 'N', 'N', '136', NULL, '03', 'N', NULL, NULL, NULL, 172);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221020', '2206', 'PI', '2204', '2204', '22013', '22', 'SAO JOSE DO PIAUI', NULL, '89', '64625000', '1', '1203', '1203', '16102', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 330.719, '-6,87200', '-41,47500', 395, 'S', 0.5590, NULL, NULL, '22900', 'S', 'N', 4726, NULL, '2290', '2290', NULL, '1963', 'S', 3157, 'SÃO JOSÉ DO PIAUÍ', 'N', '221020', 'N', 'S', 'S', NULL, 96, 'S', 'N', 'N', '198', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221030', '2206', 'PI', '2204', '2204', '22014', '22', 'SAO JULIAO', NULL, '89', '64670000', '0', '1205', '1205', '16103', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 298.106, '-7,08500', '-40,82600', 377, 'S', 0.5780, NULL, NULL, '22900', 'S', 'N', 4742, NULL, '2290', '2290', NULL, '1960', 'S', 3158, 'SÃO JULIÃO', 'N', '221030', 'N', 'S', 'S', NULL, 96, 'N', 'N', 'N', '199', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221035', '2208', 'PI', '2205', '2203', '22011', '22', 'SAO LOURENCO DO PIAUI', NULL, '89', '64778000', '9', '2265', '2265', '16148', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 683.661, '-9,16900', '-42,54500', 0, 'S', 0.6210, NULL, NULL, '22900', 'S', 'N', 4749, NULL, '2290', '2290', NULL, '1993', 'S', 3159, 'SÃO LOURENÇO DO PIAUÍ', 'N', '221035', 'N', 'S', 'S', NULL, 77, 'N', 'N', 'N', '200', NULL, '03', 'N', NULL, NULL, NULL, 140);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221037', '2206', 'PI', '2204', '2204', '22013', '22', 'SAO LUIS DO PIAUI', NULL, '89', '64638000', '5', '0390', NULL, '16213', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 219.895, '-6,82500', '-41,32400', 328, 'S', 0.5440, NULL, NULL, '22900', 'S', 'N', 4756, NULL, '2290', '2290', NULL, '1997', 'S', 3160, 'SÃO LUIS DO PIAUÍ', 'N', '221037', 'N', 'S', 'S', NULL, 96, 'N', 'N', 'N', '201', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221065', '2203', 'PI', '2202', '2202', '22004', '22', 'SIGEFREDO PACHECO', NULL, '86', '64285000', '6', '1379', '1379', '16149', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 982.074, '-4,91800', '-41,73200', 230, 'S', 0.5820, NULL, NULL, '22900', 'S', 'N', 4985, NULL, '2290', '2290', NULL, '1993', 'S', 3168, 'SIGEFREDO PACHECO', 'N', '221065', 'N', 'S', 'S', NULL, 28, 'S', 'N', 'N', '209', NULL, '03', 'N', NULL, NULL, NULL, 422);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221070', '2206', 'PI', '2204', '2204', '22015', '22', 'SIMOES', NULL, '89', '64585000', '6', '1213', '1213', '16107', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1023.917, '-7,59900', '-40,81800', 437, 'S', 0.5650, NULL, NULL, '22900', 'S', 'N', 4996, NULL, '2290', '2290', NULL, '1954', 'S', 3169, 'SIMÕES', 'N', '221070', 'N', 'S', 'S', NULL, 96, 'N', 'N', 'N', '210', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221080', '2207', 'PI', '2204', '2204', '22015', '22', 'SIMPLICIO MENDES', NULL, '89', '64700000', '5', '1215', '1215', '16108', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1398.952, '-7,85400', '-41,91000', 302, 'S', 0.6700, NULL, NULL, '22900', 'S', 'N', 5000, NULL, '2290', '2290', NULL, '1938', 'S', 3170, 'SIMPLÍCIO MENDES', 'N', '221080', 'N', 'S', 'S', NULL, 133, 'S', 'N', 'N', '211', NULL, '03', 'N', NULL, NULL, NULL, 75);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221090', '2209', 'PI', '2203', '2204', '22015', '22', 'SOCORRO DO PIAUI', NULL, '89', '64720000', '4', '1217', '1217', '16109', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 692.990, '-7,86600', '-42,49100', 191, 'S', 0.5690, NULL, NULL, '22900', 'S', 'N', 5018, NULL, '2290', '2290', NULL, '1962', 'S', 3171, 'SOCORRO DO PIAUÍ', 'N', '221090', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '212', NULL, '03', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221093', '2206', 'PI', '2204', '2204', '22013', '22', 'SUSSUAPARA', NULL, '89', '64610000', '8', '0400', NULL, '16218', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 220.074, '-7,04300', '-41,38400', 240, 'S', 0.5950, NULL, NULL, '22900', 'S', 'N', 5044, NULL, '2290', '2290', NULL, '1997', 'S', 3172, 'SUSSUAPARA', 'N', '221093', 'N', 'S', 'S', NULL, 96, 'S', 'N', 'N', '213', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221095', '2209', 'PI', '2203', '2203', '22011', '22', 'TAMBORIL DO PIAUI', NULL, '89', '64893000', '3', '0402', NULL, '16219', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1578.640, '-8,40000', '-42,91400', 350, 'S', 0.5500, NULL, NULL, '22900', 'S', 'N', 5078, NULL, '2290', '2290', NULL, '1997', 'S', 3173, 'TAMBORIL DO PIAUÍ', 'N', '221095', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '214', NULL, '03', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221097', '2207', 'PI', '2204', '2204', '22013', '22', 'TANQUE DO PIAUI', NULL, '89', '64512000', '9', '0404', NULL, '16220', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 377.042, '-6,60000', '-42,28200', 280, 'S', 0.5940, NULL, NULL, '22900', 'S', 'N', 5086, NULL, '2290', '2290', NULL, '1997', 'S', 3174, 'TANQUE DO PIAUÍ', 'N', '221097', 'N', 'S', 'S', NULL, 133, 'N', 'N', 'N', '215', NULL, '03', 'N', NULL, NULL, NULL, 75);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221100', '2204', 'PI', '2203', '2202', '22003', '22', 'TERESINA', NULL, '86', '64001970', '1', '1219', '1219', '16110', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'S', 1755.698, '-5,08900', '-42,80200', 72, 'S', 0.7660, NULL, NULL, '22900', 'N', 'N', 5149, NULL, '2201', '2201', NULL, '1832', 'S', 3175, 'TERESINA', 'N', '221100', 'N', 'S', 'S', NULL, 45, 'S', 'S', 'S', '216', NULL, '01', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221110', '2204', 'PI', '2203', '2202', '22003', '22', 'UNIAO', NULL, '86', '64120000', '0', '1221', '1221', '16111', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1173.447, '-4,58600', '-42,86400', 52, 'S', 0.6010, NULL, NULL, '22900', 'N', 'N', 5316, NULL, '2201', '2290', NULL, '1853', 'S', 3176, 'UNIÃO', 'N', '221110', 'N', 'S', 'S', NULL, 45, 'S', 'N', 'S', '217', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221120', '2210', 'PI', '2203', '2203', '22007', '22', 'URUCUI', NULL, '89', '64860000', '9', '1223', '1223', '16112', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 8452.025, '-7,22900', '-44,55600', 167, 'S', 0.6230, NULL, NULL, '22900', 'S', 'N', 5341, NULL, '2290', '2290', NULL, '1902', 'S', 3177, 'URUÇUÍ', 'N', '221120', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '218', NULL, '03', 'N', NULL, NULL, NULL, 197);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221130', '2205', 'PI', '2204', '2202', '22006', '22', 'VALENCA DO PIAUI', NULL, '89', '64300000', '8', '1225', '1225', '16113', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1350.519, '-6,40800', '-41,74600', 308, 'S', 0.6470, NULL, NULL, '22900', 'S', 'N', 5360, NULL, '2290', '2290', NULL, '1889', 'S', 3178, 'VALENÇA DO PIAUÍ', 'N', '221130', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '219', NULL, '03', 'N', NULL, NULL, NULL, 366);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221135', '2208', 'PI', '2205', '2203', '22011', '22', 'VARZEA BRANCA', NULL, '89', '64773000', '7', '2267', '2267', '16150', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 435.182, '-9,23900', '-42,96400', 0, 'S', 0.5490, NULL, NULL, '22900', 'S', 'N', 5386, NULL, '2290', '2290', NULL, '1993', 'S', 3179, 'VÁRZEA BRANCA', 'N', '221135', 'N', 'S', 'S', NULL, 77, 'S', 'N', 'N', '220', NULL, '03', 'N', NULL, NULL, NULL, 140);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221140', '2205', 'PI', '2204', '2202', '22006', '22', 'VARZEA GRANDE', NULL, '89', '64525000', '7', '1227', '1227', '16114', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 233.927, '-6,54500', '-42,24600', 245, 'S', 0.6100, NULL, NULL, '22900', 'S', 'N', 5391, NULL, '2290', '2290', NULL, '1961', 'S', 3180, 'VÁRZEA GRANDE', 'N', '221140', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '221', NULL, '03', 'N', NULL, NULL, NULL, 366);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230365', '2311', 'CE', '2302', '2301', '23007', '23', 'CATUNDA', NULL, '88', '62297000', '9', '0983', '0983', '05183', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 790.483, '-4,64800', '-40,20100', 280, 'S', 0.6280, NULL, NULL, '23900', 'S', 'N', 1180, NULL, '2390', '2390', NULL, '1993', 'S', 659, 'CATUNDA', 'N', '230365', 'N', 'S', 'S', NULL, 49, 'N', 'N', 'N', '43', NULL, '03', 'N', NULL, NULL, NULL, 284);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230370', '2302', 'CE', '2301', '2303', '23016', '23', 'CAUCAIA', NULL, '85', '61600000', '9', '1373', '1373', '05037', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'S', NULL, 'N', 1227.895, '-3,73300', '-38,65600', 29, 'S', 0.7210, NULL, NULL, '23900', 'N', 'N', 1185, NULL, '2301', '2301', NULL, '1903', 'S', 660, 'CAUCAIA', 'N', '230370', 'N', 'S', 'S', NULL, NULL, 'S', 'S', 'S', '44', NULL, '01', 'N', NULL, NULL, NULL, 5);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230380', '2317', 'CE', '2303', '2306', '23026', '23', 'CEDRO', NULL, '88', '63400000', '8', '1375', '1375', '05038', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 725.786, '-6,60700', '-39,06200', 250, 'S', 0.6340, NULL, NULL, '23900', 'S', 'N', 1196, NULL, '2390', '2390', NULL, '1920', 'S', 661, 'CEDRO', 'N', '230380', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '45', NULL, '03', 'N', NULL, NULL, NULL, 48);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230390', '2316', 'CE', '2302', '2301', '23001', '23', 'CHAVAL', NULL, '88', '62420000', '7', '1377', '1377', '05039', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 238.228, '-3,03400', '-41,24400', 12, 'S', 0.5790, NULL, NULL, '23900', 'S', 'N', 1243, NULL, '2390', '2390', NULL, '1951', 'S', 662, 'CHAVAL', 'N', '230390', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '46', NULL, '03', 'N', NULL, NULL, NULL, 338);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210360', '2108', 'MA', '2106', '2104', '21015', '21', 'COROATA', NULL, '99', '65415000', '4', '0769', '0769', '09035', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2263.823, '-4,13000', '-44,12400', 35, 'S', 0.5560, NULL, NULL, '21900', 'N', 'N', 1376, NULL, '2190', '2190', NULL, '1843', 'S', 1201, 'COROATÁ', 'N', '210360', 'S', 'S', 'S', NULL, 34, 'N', 'N', 'S', '63', NULL, '02', 'N', NULL, NULL, NULL, 297);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230393', '2308', 'CE', '2304', '2304', '23019', '23', 'CHORO', NULL, '88', '63950000', '1', '0993', '0993', '05185', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 815.759, '-4,84300', '-39,14100', 237, 'S', 0.5700, NULL, NULL, '23900', 'S', 'N', 1249, NULL, '2390', '2390', NULL, '1993', 'S', 663, 'CHORÓ', 'N', '230393', 'N', 'S', 'S', NULL, 80, 'N', 'N', 'N', '47', NULL, '03', 'N', NULL, NULL, NULL, 51);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230395', '2322', 'CE', '2301', '2302', '23014', '23', 'CHOROZINHO', NULL, '85', '62875000', '6', '1239', '1239', '05158', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 278.400, '-4,30000', '-38,49700', 48, 'S', 0.6330, NULL, NULL, '23900', 'S', 'N', 1250, NULL, '2301', '2390', NULL, '1989', 'S', 664, 'CHOROZINHO', 'N', '230395', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '48', NULL, '01', 'N', NULL, NULL, NULL, 340);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230400', '2311', 'CE', '2302', '2301', '23003', '23', 'COREAU', NULL, '88', '62160000', '4', '1381', '1381', '05041', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 775.746, '-3,53300', '-40,65700', 72, 'S', 0.5910, NULL, NULL, '23900', 'S', 'N', 1368, NULL, '2390', '2390', NULL, '1935', 'S', 665, 'COREAÚ', 'N', '230400', 'N', 'S', 'S', NULL, 86, 'S', 'N', 'N', '49', NULL, '03', 'N', NULL, NULL, NULL, 284);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230410', '2315', 'CE', '2302', '2304', '23018', '23', 'CRATEUS', NULL, '88', '63700000', '3', '1383', '1383', '05042', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 2985.411, '-5,17800', '-40,67800', 274, 'S', 0.6760, NULL, NULL, '23900', 'N', 'N', 1426, NULL, '2390', '2390', NULL, '1832', 'S', 666, 'CRATEÚS', 'N', '230410', 'N', 'S', 'S', NULL, 49, 'N', 'N', 'S', '50', NULL, '01', 'N', NULL, NULL, NULL, 285);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230420', '2320', 'CE', '2303', '2307', '23032', '23', 'CRATO', NULL, '88', '63100000', '2', '1385', '1385', '05043', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 1009.202, '-7,23400', '-39,40900', 426, 'S', 0.7160, NULL, NULL, '23900', 'N', 'N', 1427, NULL, '2302', '2302', NULL, '1853', 'S', 667, 'CRATO', 'N', '230420', 'N', 'S', 'S', NULL, 131, 'N', 'N', 'S', '51', NULL, '01', 'N', NULL, NULL, NULL, 339);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230426', '2318', 'CE', '2303', '2304', '23021', '23', 'DEPUTADO IRAPUAN PINHEIRO', NULL, '88', '63645000', '9', '1243', '1243', '05177', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 470.421, '-5,91700', '-39,26800', 288, 'S', 0.6000, NULL, NULL, '23900', 'S', 'N', 1521, NULL, '2390', '2390', NULL, '1989', 'S', 670, 'DEPUTADO IRAPUAN PINHEIRO', 'N', '230426', 'N', 'S', 'S', NULL, 80, 'N', 'N', 'N', '54', NULL, '03', 'N', NULL, NULL, NULL, 108);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230427', '2310', 'CE', '2301', '2305', '23025', '23', 'ERERE', NULL, '88', '63470000', '7', '1245', '1245', '05159', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 382.730, '-6,03200', '-38,34900', 200, 'S', 0.6190, NULL, NULL, '23900', 'S', 'N', 1661, NULL, '2390', '2390', NULL, '1989', 'S', 671, 'ERERÊ', 'N', '230427', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '55', NULL, '03', 'N', NULL, NULL, NULL, 336);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230428', '2301', 'CE', '2301', '2303', '23016', '23', 'EUSEBIO', NULL, '85', NULL, '5', '1247', '1247', '05160', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 76.583, '-3,89000', '-38,45100', 28, 'S', 0.6840, NULL, NULL, '23900', 'N', 'N', 1709, NULL, '2301', '2301', NULL, '1989', 'S', 672, 'EUSÉBIO', 'N', '230428', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '56', NULL, '01', 'N', NULL, NULL, NULL, 50);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230430', '2320', 'CE', '2303', '2307', '23030', '23', 'FARIAS BRITO', NULL, '88', '63185000', '1', '1387', '1387', '05044', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 503.574, '-6,93100', '-39,56600', 337, 'S', 0.6090, NULL, NULL, '23900', 'S', 'N', 1719, NULL, '2302', '2390', NULL, '1890', 'S', 673, 'FARIAS BRITO', 'N', '230430', 'N', 'S', 'S', NULL, 131, 'N', 'N', 'N', '57', NULL, '03', 'N', NULL, NULL, NULL, 339);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230440', '2301', 'CE', '2301', '2303', '23016', '23', 'FORTALEZA', NULL, '85', '60001970', '0', '1389', '1389', '05045', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'S', NULL, 'S', 313.140, '-3,71700', '-38,54300', 21, 'S', 0.7860, NULL, NULL, '23900', 'N', 'N', 1808, NULL, '2301', '2301', NULL, '1725', 'S', 675, 'FORTALEZA', 'N', '230440', 'N', 'S', 'S', NULL, NULL, 'S', 'S', 'S', '59', NULL, '01', 'N', NULL, NULL, NULL, 50);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230450', '2311', 'CE', '2302', '2301', '23003', '23', 'FRECHEIRINHA', NULL, '88', '62340000', '9', '1391', '1391', '05046', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 181.240, '-3,76000', '-40,81600', 120, 'S', 0.6050, NULL, NULL, '23900', 'S', 'N', 1833, NULL, '2390', '2390', NULL, '1951', 'S', 677, 'FRECHEIRINHA', 'N', '230450', 'N', 'S', 'S', NULL, 86, 'N', 'N', 'N', '61', NULL, '03', 'N', NULL, NULL, NULL, 284);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230460', '2302', 'CE', '2301', '2302', '23011', '23', 'GENERAL SAMPAIO', NULL, '85', '62738000', '8', '1393', '1393', '05047', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 206.198, '-4,05300', '-39,45400', 95, 'S', 0.6060, NULL, NULL, '23900', 'S', 'N', 1879, NULL, '2390', '2390', NULL, '1956', 'S', 678, 'GENERAL SAMPAIO', 'N', '230460', 'N', 'S', 'S', NULL, 51, 'S', 'N', 'N', '62', NULL, '03', 'N', NULL, NULL, NULL, 5);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230465', '2311', 'CE', '2302', '2301', '23005', '23', 'GRACA', NULL, '88', '62365000', '7', '1249', '1249', '05161', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 281.890, '-4,04600', '-40,75300', 179, 'S', 0.5930, NULL, NULL, '23900', 'S', 'N', 1930, NULL, '2390', '2390', NULL, '1989', 'S', 679, 'GRAÇA', 'N', '230465', 'N', 'S', 'S', NULL, 86, 'S', 'N', 'N', '63', NULL, '03', 'N', NULL, NULL, NULL, 284);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230470', '2316', 'CE', '2302', '2301', '23001', '23', 'GRANJA', NULL, '88', '62430000', '7', '1395', '1395', '05048', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 2697.202, '-3,12000', '-40,82600', 10, 'S', 0.5540, NULL, NULL, '23900', 'N', 'N', 1939, NULL, '2390', '2390', NULL, '1776', 'S', 680, 'GRANJA', 'N', '230470', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '64', NULL, '02', 'N', NULL, NULL, NULL, 338);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230480', '2321', 'CE', '2303', '2307', '23030', '23', 'GRANJEIRO', NULL, '88', '63230000', '6', '1397', '1397', '05049', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 100.135, '-6,88800', '-39,21800', 311, 'S', 0.5760, NULL, NULL, '23900', 'S', 'N', 1940, NULL, '2390', '2390', NULL, '1957', 'S', 681, 'GRANJEIRO', 'N', '230480', 'N', 'S', 'S', NULL, 131, 'N', 'N', 'N', '65', NULL, '03', 'N', NULL, NULL, NULL, 109);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230490', '2311', 'CE', '2302', '2301', '23005', '23', 'GROAIRAS', NULL, '88', '62190000', '5', '1399', '1399', '05050', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 155.963, '-3,91300', '-40,38300', 88, 'S', 0.6530, NULL, NULL, '23900', 'S', 'N', 1946, NULL, '2390', '2390', NULL, '1957', 'S', 682, 'GROAÍRAS', 'N', '230490', 'N', 'S', 'S', NULL, 86, 'N', 'N', 'N', '66', NULL, '03', 'N', NULL, NULL, NULL, 284);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230495', '2303', 'CE', '2301', '2303', '23016', '23', 'GUAIUBA', NULL, '85', '61890000', '4', '1251', '1251', '05162', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 267.203, '-4,04000', '-38,63700', 62, 'S', 0.6520, NULL, NULL, '23900', 'S', 'N', 1959, NULL, '2301', '2301', NULL, '1989', 'S', 683, 'GUAIÚBA', 'N', '230495', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '67', NULL, '01', 'N', NULL, NULL, NULL, 228);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230500', '2313', 'CE', '2302', '2301', '23002', '23', 'GUARACIABA DO NORTE', NULL, '88', '62380000', '1', '1401', '1401', '05051', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 611.463, '-4,16700', '-40,74800', 902, 'S', 0.6290, NULL, NULL, '23900', 'N', 'N', 1982, NULL, '2390', '2390', NULL, '1879', 'S', 684, 'GUARACIABA DO NORTE', 'N', '230500', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '68', NULL, '03', 'N', NULL, NULL, NULL, 171);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230510', '2304', 'CE', '2301', '2302', '23013', '23', 'GUARAMIRANGA', NULL, '85', '62766000', '0', '1403', '1403', '05052', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 59.471, '-4,26300', '-38,93300', 900, 'S', 0.6540, NULL, NULL, '23900', 'S', 'N', 1986, NULL, '2390', '2390', NULL, '1990', 'S', 685, 'GUARAMIRANGA', 'N', '230510', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '69', NULL, '03', 'N', NULL, NULL, NULL, 6);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230520', '2311', 'CE', '2302', '2301', '23007', '23', 'HIDROLANDIA', NULL, '88', '62270000', '9', '1405', '1405', '05053', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 966.572, '-4,40800', '-40,43800', 190, 'S', 0.6380, NULL, NULL, '23900', 'S', 'N', 2036, NULL, '2390', '2390', NULL, '1957', 'S', 686, 'HIDROLÂNDIA', 'N', '230520', 'N', 'S', 'S', NULL, 49, 'S', 'N', 'N', '70', NULL, '03', 'N', NULL, NULL, NULL, 284);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230523', '2322', 'CE', '2301', '2303', '23017', '23', 'HORIZONTE', NULL, '85', '62880000', '3', '1253', '1253', '05163', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 159.972, '-4,09900', '-38,49600', 65, 'S', 0.6790, NULL, NULL, '23900', 'N', 'N', 2041, NULL, '2301', '2301', NULL, '1989', 'S', 687, 'HORIZONTE', 'N', '230523', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '71', NULL, '01', 'N', NULL, NULL, NULL, 340);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230526', '2308', 'CE', '2304', '2304', '23019', '23', 'IBARETAMA', NULL, '88', '63970000', '6', '1255', '1255', '05178', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 877.260, '-4,80400', '-38,75300', 190, 'S', 0.5970, NULL, NULL, '23900', 'S', 'N', 2058, NULL, '2390', '2390', NULL, '1989', 'S', 688, 'IBARETAMA', 'N', '230526', 'N', 'S', 'S', NULL, 80, 'S', 'N', 'N', '72', NULL, '03', 'N', NULL, NULL, NULL, 51);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230530', '2313', 'CE', '2302', '2301', '23002', '23', 'IBIAPINA', NULL, '88', '62360000', '8', '1407', '1407', '05054', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 414.902, '-3,92300', '-40,88900', 878, 'S', 0.6460, NULL, NULL, '23900', 'S', 'N', 2068, NULL, '2390', '2390', NULL, '1933', 'S', 689, 'IBIAPINA', 'N', '230530', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '73', NULL, '03', 'N', NULL, NULL, NULL, 171);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230533', '2308', 'CE', '2304', '2305', '23023', '23', 'IBICUITINGA', NULL, '88', '62955000', '2', '1257', '1257', '05179', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 424.242, '-4,97400', '-38,63900', 200, 'S', 0.6420, NULL, NULL, '23900', 'S', 'N', 2075, NULL, '2390', '2390', NULL, '1989', 'S', 690, 'IBICUITINGA', 'N', '230533', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '74', NULL, '03', 'N', NULL, NULL, NULL, 51);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230535', '2307', 'CE', '2301', '2305', '23022', '23', 'ICAPUI', NULL, '88', '62810000', '7', '1593', '1593', '05149', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 428.688, '-4,71300', '-37,35500', 5, 'S', 0.6310, NULL, NULL, '23900', 'S', 'N', 2103, NULL, '2390', '2390', NULL, '1986', 'S', 691, 'ICAPUÍ', 'N', '230535', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '75', NULL, '03', 'N', NULL, NULL, NULL, 230);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230540', '2317', 'CE', '2303', '2306', '23026', '23', 'ICO', NULL, '88', '63430000', '7', '1409', '1409', '05055', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1871.980, '-6,40100', '-38,86200', 153, 'S', 0.6070, NULL, NULL, '23900', 'N', 'N', 2110, NULL, '2390', '2390', NULL, '1738', 'S', 692, 'ICÓ', 'N', '230540', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '76', NULL, '02', 'N', NULL, NULL, NULL, 48);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230550', '2318', 'CE', '2303', '2306', '23026', '23', 'IGUATU', NULL, '88', '63500000', '6', '1411', '1411', '05056', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 1029.002, '-6,35900', '-39,29900', 217, 'S', 0.6920, NULL, NULL, '23900', 'N', 'N', 2138, NULL, '2390', '2390', NULL, '1851', 'S', 693, 'IGUATU', 'N', '230550', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '77', NULL, '01', 'N', NULL, NULL, NULL, 108);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210370', '2112', 'MA', '2103', '2101', '21001', '21', 'CURURUPU', NULL, '98', '65268000', '3', '0771', '0771', '09036', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 935.586, '-1,82800', '-44,86800', 12, 'S', 0.6230, NULL, NULL, '21900', 'S', 'N', 1501, NULL, '2190', '2190', NULL, '1841', 'S', 1202, 'CURURUPU', 'N', '210370', 'S', 'S', 'S', NULL, 115, 'N', 'N', 'S', '64', NULL, '03', 'N', NULL, NULL, NULL, 239);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210375', '2109', 'MA', '2104', '2102', '21009', '21', 'DAVINOPOLIS', NULL, '99', '65927000', '2', '0154', '0154', '09162', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 337.041, '-5,55800', '-47,42600', 180, 'S', 0.5930, NULL, NULL, '21900', 'S', 'N', 1512, NULL, '2102', '2190', NULL, '1997', 'S', 1203, 'DAVINÓPOLIS', 'N', '210375', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '65', NULL, '03', 'N', NULL, NULL, NULL, 298);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210380', '2113', 'MA', '2105', '2103', '21012', '21', 'DOM PEDRO', NULL, '99', '65765000', '2', '0773', '0773', '09037', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 369.964, '-5,03300', '-44,43600', 142, 'S', 0.6340, NULL, NULL, '21900', 'S', 'N', 1580, NULL, '2190', '2190', NULL, '1952', 'S', 1204, 'DOM PEDRO', 'N', '210380', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '66', NULL, '03', 'N', NULL, NULL, NULL, 11);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210390', '2104', 'MA', '2102', '2104', '21016', '21', 'DUQUE BACELAR', NULL, '98', '65625000', '1', '0775', '0775', '09038', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 317.924, '-4,15600', '-42,94400', 74, 'S', 0.5400, NULL, NULL, '21900', 'S', 'N', 1615, NULL, '2190', '2190', NULL, '1954', 'S', 1205, 'DUQUE BACELAR', 'N', '210390', 'S', 'S', 'S', NULL, 34, 'S', 'N', 'N', '67', NULL, '03', 'N', NULL, NULL, NULL, 407);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210400', '2111', 'MA', '2106', '2103', '21010', '21', 'ESPERANTINOPOLIS', NULL, '99', '65750000', '8', '0777', '0777', '09039', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 480.943, '-4,88300', '-44,68800', 90, 'S', 0.5930, NULL, NULL, '21900', 'S', 'N', 1678, NULL, '2190', '2190', NULL, '1954', 'S', 1206, 'ESPERANTINÓPOLIS', 'N', '210400', 'S', 'S', 'S', NULL, 140, 'N', 'N', 'N', '68', NULL, '03', 'N', NULL, NULL, NULL, 238);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210405', '2109', 'MA', '2104', '2105', '21019', '21', 'ESTREITO', NULL, '99', '65975000', '7', '0963', '0963', '09132', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2718.960, '-6,56100', '-47,45100', 153, 'S', 0.6810, NULL, NULL, '21900', 'S', 'N', 1694, NULL, '2190', '2190', NULL, '1982', 'S', 1207, 'ESTREITO', 'N', '210405', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '69', NULL, '03', 'N', NULL, NULL, NULL, 298);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210407', '2106', 'MA', '2108', '2105', '21020', '21', 'FEIRA NOVA DO MARANHAO', NULL, '99', '65995000', '3', '0156', '0156', '09163', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1473.272, '-6,96000', '-46,68600', 331, 'S', 0.5690, NULL, NULL, '21900', 'S', 'N', 1741, NULL, '2190', '2190', NULL, '1997', 'S', 1208, 'FEIRA NOVA DO MARANHÃO', 'N', '210407', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '70', NULL, '03', 'N', NULL, NULL, NULL, 355);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210408', '2105', 'MA', '2105', '2103', '21011', '21', 'FERNANDO FALCAO', NULL, '99', '65964000', '1', '0158', '0158', '09164', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 3506.445, '-6,15200', '-44,89300', 210, 'S', 0.4980, NULL, NULL, '21900', 'S', 'N', 1753, NULL, '2190', '2190', NULL, '1997', 'S', 1209, 'FERNANDO FALCÃO', 'N', '210408', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '71', NULL, '03', 'N', NULL, NULL, NULL, 121);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210409', '2106', 'MA', '2108', '2103', '21011', '21', 'FORMOSA DA SERRA NEGRA', NULL, '99', '65943000', '9', '0160', '0160', '09165', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3941.185, '-6,43500', '-46,19100', 288, 'S', 0.5690, NULL, NULL, '21900', 'S', 'N', 1799, NULL, '2190', '2190', NULL, '1997', 'S', 1210, 'FORMOSA DA SERRA NEGRA', 'N', '210409', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '72', NULL, '03', 'N', NULL, NULL, NULL, 355);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210410', '2106', 'MA', '2108', '2105', '21021', '21', 'FORTALEZA DOS NOGUEIRAS', NULL, '99', '65805000', '7', '0779', '0779', '09040', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1664.058, '-6,96400', '-46,17700', 430, 'S', 0.6370, NULL, NULL, '21900', 'S', 'N', 1811, NULL, '2190', '2190', NULL, '1961', 'S', 1211, 'FORTALEZA DOS NOGUEIRAS', 'N', '210410', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '73', NULL, '03', 'N', NULL, NULL, NULL, 355);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210420', '2113', 'MA', '2105', '2103', '21012', '21', 'FORTUNA', NULL, '99', '65695000', '6', '0781', '0781', '09041', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 694.981, '-5,73300', '-44,15800', 215, 'S', 0.5680, NULL, NULL, '21900', 'S', 'N', 1814, NULL, '2190', '2190', NULL, '1959', 'S', 1212, 'FORTUNA', 'N', '210420', 'S', 'S', 'S', NULL, 34, 'S', 'N', 'N', '74', NULL, '03', 'N', NULL, NULL, NULL, 11);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210430', '2119', 'MA', '2107', '2102', '21007', '21', 'GODOFREDO VIANA', NULL, '98', '65285000', '5', '0783', '0783', '09042', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 640.093, '-1,40300', '-45,78000', 10, 'S', 0.5960, NULL, NULL, '21900', 'S', 'N', 1894, NULL, '2190', '2190', NULL, '1964', 'S', 1213, 'GODOFREDO VIANA', 'N', '210430', 'S', 'S', 'S', NULL, 139, 'S', 'N', 'N', '75', NULL, '03', 'N', NULL, NULL, NULL, 299);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210440', '2113', 'MA', '2105', '2103', '21012', '21', 'GONCALVES DIAS', NULL, '99', '65775000', '4', '0785', '0785', '09043', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 875.975, '-5,15100', '-44,29900', 140, 'S', 0.5680, NULL, NULL, '21900', 'S', 'N', 1913, NULL, '2190', '2190', NULL, '1958', 'S', 1214, 'GONÇALVES DIAS', 'N', '210440', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '76', NULL, '03', 'N', NULL, NULL, NULL, 11);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210455', '2109', 'MA', '2104', '2102', '21009', '21', 'GOVERNADOR EDISON LOBAO', NULL, '99', '65928000', '2', '0162', '0162', '09166', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 615.850, '-5,74900', '-47,36100', 208, 'S', 0.6250, NULL, NULL, '21900', 'S', 'N', 1921, NULL, '2102', '2190', NULL, '1997', 'S', 1216, 'GOVERNADOR EDISON LOBÃO', 'N', '210455', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '78', NULL, '03', 'N', NULL, NULL, NULL, 298);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230770', '2303', 'CE', '2301', '2303', '23016', '23', 'MARANGUAPE', NULL, '85', '61940000', '0', '1455', '1455', '05078', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 590.824, '-3,89000', '-38,68600', 80, 'S', 0.6910, NULL, NULL, '23900', 'N', 'N', 2889, NULL, '2301', '2301', NULL, '1851', 'S', 721, 'MARANGUAPE', 'N', '230770', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '105', NULL, '01', 'N', NULL, NULL, NULL, 228);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210460', '2113', 'MA', '2105', '2103', '21012', '21', 'GOVERNADOR EUGENIO BARROS', NULL, '99', '65780000', '2', '0789', '0789', '09045', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 816.952, '-5,32300', '-44,24700', 145, 'S', 0.5560, NULL, NULL, '21900', 'S', 'N', 1922, NULL, '2190', '2190', NULL, '1961', 'S', 1217, 'GOVERNADOR EUGÊNIO BARROS', 'N', '210460', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '79', NULL, '03', 'N', NULL, NULL, NULL, 11);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230560', '2315', 'CE', '2302', '2304', '23018', '23', 'INDEPENDENCIA', NULL, '88', '63640000', '5', '1413', '1413', '05057', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 3218.641, '-5,39600', '-40,30900', 343, 'S', 0.6570, NULL, NULL, '23900', 'S', 'N', 2169, NULL, '2390', '2390', NULL, '1933', 'S', 694, 'INDEPENDÊNCIA', 'N', '230560', 'N', 'S', 'S', NULL, 49, 'N', 'N', 'N', '78', NULL, '03', 'N', NULL, NULL, NULL, 285);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230565', '2315', 'CE', '2302', '2304', '23018', '23', 'IPAPORANGA', NULL, '88', '62215000', '4', '1259', '1259', '05169', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 701.990, '-4,90000', '-40,75900', 278, 'S', 0.6090, NULL, NULL, '23900', 'S', 'N', 2196, NULL, '2390', '2390', NULL, '1989', 'S', 695, 'IPAPORANGA', 'N', '230565', 'N', 'S', 'S', NULL, 49, 'N', 'N', 'N', '79', NULL, '03', 'N', NULL, NULL, NULL, 285);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230570', '2317', 'CE', '2303', '2306', '23028', '23', 'IPAUMIRIM', NULL, '88', '63340000', '4', '1415', '1415', '05058', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 273.696, '-6,79000', '-38,71900', 273, 'S', 0.6460, NULL, NULL, '23900', 'S', 'N', 2199, NULL, '2390', '2390', NULL, '1951', 'S', 696, 'IPAUMIRIM', 'N', '230570', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '80', NULL, '03', 'N', NULL, NULL, NULL, 48);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230580', '2311', 'CE', '2302', '2301', '23006', '23', 'IPU', NULL, '88', '62250000', '3', '1417', '1417', '05059', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 630.468, '-4,32200', '-40,71100', 247, 'S', 0.6700, NULL, NULL, '23900', 'N', 'N', 2219, NULL, '2390', '2390', NULL, '1842', 'S', 697, 'IPU', 'N', '230580', 'N', 'S', 'S', NULL, 49, 'N', 'N', 'N', '81', NULL, '03', 'N', NULL, NULL, NULL, 284);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230590', '2315', 'CE', '2302', '2301', '23006', '23', 'IPUEIRAS', NULL, '88', '62230000', '2', '1419', '1419', '05060', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1474.108, '-4,54200', '-40,71900', 231, 'S', 0.6170, NULL, NULL, '23900', 'N', 'N', 2225, NULL, '2390', '2390', NULL, '1935', 'S', 698, 'IPUEIRAS', 'N', '230590', 'N', 'S', 'S', NULL, 49, 'N', 'N', 'N', '82', NULL, '03', 'N', NULL, NULL, NULL, 285);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230600', '2310', 'CE', '2301', '2305', '23025', '23', 'IRACEMA', NULL, '88', '62980000', '9', '1421', '1421', '05061', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 822.833, '-5,81200', '-38,30600', 131, 'S', 0.6600, NULL, NULL, '23900', 'S', 'N', 2229, NULL, '2390', '2390', NULL, '1951', 'S', 699, 'IRACEMA', 'N', '230600', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '83', NULL, '03', 'N', NULL, NULL, NULL, 336);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230610', '2311', 'CE', '2302', '2301', '23005', '23', 'IRAUCUBA', NULL, '88', '62620000', '8', '1423', '1423', '05062', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 1461.223, '-3,74600', '-39,78300', 153, 'S', 0.6180, NULL, NULL, '23900', 'S', 'N', 2246, NULL, '2390', '2390', NULL, '1957', 'S', 700, 'IRAUÇUBA', 'N', '230610', 'N', 'S', 'S', NULL, 51, 'N', 'N', 'N', '84', NULL, '03', 'N', NULL, NULL, NULL, 284);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230620', '2307', 'CE', '2301', '2305', '23022', '23', 'ITAICABA', NULL, '88', '62820000', '7', '1425', '1425', '05063', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 209.490, '-4,67400', '-37,82200', 7, 'S', 0.6410, NULL, NULL, '23900', 'S', 'N', 2290, NULL, '2390', '2390', NULL, '1956', 'S', 701, 'ITAIÇABA', 'N', '230620', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '85', NULL, '03', 'N', NULL, NULL, NULL, 230);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230625', '2301', 'CE', '2301', '2303', '23016', '23', 'ITAITINGA', NULL, '85', '61880000', '6', '0991', '0991', '05187', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 150.788, '-3,96900', '-38,52800', 60, 'S', 0.6800, NULL, NULL, '23900', 'N', 'N', 2296, NULL, '2301', '2301', NULL, '1993', 'S', 702, 'ITAITINGA', 'N', '230625', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '86', NULL, '01', 'N', NULL, NULL, NULL, 50);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230630', '2302', 'CE', '2301', '2302', '23010', '23', 'ITAPAGE', NULL, '85', '62600000', '6', '1427', '1427', '05064', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 439.501, '-3,68700', '-39,58600', 262, 'S', 0.6420, NULL, NULL, '23900', 'N', 'N', 2330, NULL, '2390', '2390', NULL, '1933', 'S', 703, 'ITAPAGÉ', 'N', '230630', 'N', 'S', 'S', NULL, 51, 'N', 'N', 'N', '87', NULL, '03', 'N', NULL, NULL, NULL, 5);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230640', '2306', 'CE', '2301', '2302', '23008', '23', 'ITAPIPOCA', NULL, '88', '62500000', '5', '1429', '1429', '05065', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 1614.682, '-3,49400', '-39,57900', 108, 'S', 0.6590, NULL, NULL, '23900', 'N', 'N', 2350, NULL, '2390', '2390', NULL, '1823', 'S', 704, 'ITAPIPOCA', 'N', '230640', 'N', 'S', 'S', NULL, 51, 'N', 'N', 'S', '88', NULL, '01', 'N', NULL, NULL, NULL, 229);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230650', '2304', 'CE', '2301', '2302', '23013', '23', 'ITAPIUNA', NULL, '88', '62740000', '4', '1431', '1431', '05066', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 588.684, '-4,56400', '-38,92200', 133, 'S', 0.6330, NULL, NULL, '23900', 'S', 'N', 2359, NULL, '2390', '2390', NULL, '1957', 'S', 705, 'ITAPIÚNA', 'N', '230650', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '89', NULL, '03', 'N', NULL, NULL, NULL, 6);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230655', '2312', 'CE', '2302', '2301', '23001', '23', 'ITAREMA', NULL, '88', '62590000', '3', '1595', '1595', '05154', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 720.668, '-2,92000', '-39,91500', 34, 'S', 0.6010, NULL, NULL, '23900', 'N', 'N', 2381, NULL, '2390', '2390', NULL, '1986', 'S', 706, 'ITAREMA', 'N', '230655', 'N', 'S', 'S', NULL, 51, 'N', 'N', 'N', '90', NULL, '03', 'N', NULL, NULL, NULL, 170);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230660', '2305', 'CE', '2304', '2302', '23012', '23', 'ITATIRA', NULL, '88', '62720000', '3', '1433', '1433', '05067', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 783.347, '-4,52900', '-39,62200', 794, 'S', 0.5690, NULL, NULL, '23900', 'S', 'N', 2390, NULL, '2390', '2390', NULL, '1951', 'S', 707, 'ITATIRA', 'N', '230660', 'N', 'S', 'S', NULL, 85, 'S', 'N', 'N', '91', NULL, '03', 'N', NULL, NULL, NULL, 172);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230670', '2309', 'CE', '2301', '2305', '23024', '23', 'JAGUARETAMA', NULL, '88', '63480000', '2', '1435', '1435', '05068', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 1759.722, '-5,61300', '-38,76700', 120, 'S', 0.6450, NULL, NULL, '23900', 'S', 'N', 2466, NULL, '2390', '2390', NULL, '1935', 'S', 708, 'JAGUARETAMA', 'N', '230670', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '92', NULL, '03', 'N', NULL, NULL, NULL, 341);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230680', '2310', 'CE', '2301', '2305', '23024', '23', 'JAGUARIBARA', NULL, '88', '63490000', '1', '1437', '1437', '05069', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 668.291, '-5,65800', '-38,62000', 92, 'S', 0.6530, NULL, NULL, '23900', 'S', 'N', 2469, NULL, '2390', '2390', NULL, '1957', 'S', 709, 'JAGUARIBARA', 'N', '230680', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '93', NULL, '03', 'N', NULL, NULL, NULL, 336);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230690', '2310', 'CE', '2301', '2305', '23024', '23', 'JAGUARIBE', NULL, '88', '63475000', '0', '1439', '1439', '05070', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 1876.793, '-5,89100', '-38,62200', 123, 'S', 0.6720, NULL, NULL, '23900', 'N', 'N', 2470, NULL, '2390', '2390', NULL, '1864', 'S', 710, 'JAGUARIBE', 'N', '230690', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '94', NULL, '03', 'N', NULL, NULL, NULL, 336);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230700', '2309', 'CE', '2301', '2305', '23023', '23', 'JAGUARUANA', NULL, '88', '62823000', '7', '1441', '1441', '05071', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 867.251, '-4,83400', '-37,78100', 12, 'S', 0.6540, NULL, NULL, '23900', 'N', 'N', 2473, NULL, '2390', '2390', NULL, '1865', 'S', 711, 'JAGUARUANA', 'N', '230700', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '95', NULL, '03', 'N', NULL, NULL, NULL, 341);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230710', '2321', 'CE', '2303', '2307', '23032', '23', 'JARDIM', NULL, '88', '63290000', '6', '1443', '1443', '05072', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 457.034, '-7,58200', '-39,29800', 648, 'S', 0.6420, NULL, NULL, '23900', 'S', 'N', 2508, NULL, '2302', '2390', NULL, '1814', 'S', 712, 'JARDIM', 'N', '230710', 'N', 'S', 'S', NULL, 131, 'N', 'N', 'N', '96', NULL, '03', 'N', NULL, NULL, NULL, 109);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230720', '2319', 'CE', '2303', '2307', '23033', '23', 'JATI', NULL, '88', '63275000', '5', '1445', '1445', '05073', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 312.584, '-7,68600', '-39,01600', 434, 'S', 0.6530, NULL, NULL, '23900', 'S', 'N', 2524, NULL, '2390', '2390', NULL, '1951', 'S', 713, 'JATI', 'N', '230720', 'N', 'S', 'S', NULL, 131, 'N', 'N', 'N', '97', NULL, '03', 'N', NULL, NULL, NULL, 49);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230725', '2312', 'CE', '2302', '2301', '23001', '23', 'JIJOCA DE JERICOACOARA', NULL, '88', '62598000', '4', '0985', '0985', '05184', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 201.858, '-2,79400', '-40,51300', 100, 'S', 0.6230, NULL, NULL, '23900', 'S', 'N', 2550, NULL, '2390', '2390', NULL, '1990', 'S', 714, 'JIJOCA DE JERICOACOARA', 'N', '230725', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '98', NULL, '03', 'N', NULL, NULL, NULL, 170);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230730', '2321', 'CE', '2303', '2307', '23032', '23', 'JUAZEIRO DO NORTE', NULL, '88', '63011970', '4', '1447', '1447', '05074', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 248.558, '-7,21300', '-39,31500', 377, 'S', 0.6970, NULL, NULL, '23900', 'N', 'N', 2593, NULL, '2302', '2302', NULL, '1911', 'S', 715, 'JUAZEIRO DO NORTE', 'N', '230730', 'N', 'S', 'S', NULL, 131, 'N', 'S', 'S', '99', NULL, '01', 'N', NULL, NULL, NULL, 109);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230740', '2318', 'CE', '2303', '2306', '23027', '23', 'JUCAS', NULL, '88', '63580000', '3', '1449', '1449', '05075', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 937.180, '-6,52500', '-39,52800', 246, 'S', 0.5970, NULL, NULL, '23900', 'S', 'N', 2595, NULL, '2390', '2390', NULL, '1859', 'S', 716, 'JUCÁS', 'N', '230740', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '100', NULL, '03', 'N', NULL, NULL, NULL, 108);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230750', '2317', 'CE', '2303', '2306', '23028', '23', 'LAVRAS DA MANGABEIRA', NULL, '88', '63300000', '2', '1451', '1451', '05076', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 947.957, '-6,75300', '-38,97200', 239, 'S', 0.6360, NULL, NULL, '23900', 'N', 'N', 2721, NULL, '2390', '2390', NULL, '1816', 'S', 717, 'LAVRAS DA MANGABEIRA', 'N', '230750', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '101', NULL, '03', 'N', NULL, NULL, NULL, 48);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210462', '2113', 'MA', '2105', '2103', '21012', '21', 'GOVERNADOR LUIZ ROCHA', NULL, '99', '65795000', '8', '0164', '0164', '09167', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 372.991, '-5,46900', '-44,07400', 119, 'S', 0.5580, NULL, NULL, '21900', 'S', 'N', 1925, NULL, '2190', '2190', NULL, '1997', 'S', 1218, 'GOVERNADOR LUIZ ROCHA', 'N', '210462', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '80', NULL, '03', 'N', NULL, NULL, NULL, 11);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210465', '2115', 'MA', '2107', '2102', '21008', '21', 'GOVERNADOR NEWTON BELLO', NULL, '98', '65363000', '1', '0166', '0166', '09168', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1160.866, '-3,42600', '-45,67600', 0, 'S', 0.4940, NULL, NULL, '21900', 'S', 'N', 1927, NULL, '2190', '2190', NULL, '1997', 'S', 1219, 'GOVERNADOR NEWTON BELLO', 'N', '210465', 'S', 'S', 'S', NULL, 139, 'S', 'N', 'N', '81', NULL, '03', 'N', NULL, NULL, NULL, 356);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230760', '2310', 'CE', '2301', '2305', '23023', '23', 'LIMOEIRO DO NORTE', NULL, '88', '62930000', '1', '1453', '1453', '05077', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 751.535, '-5,14600', '-38,09800', 30, 'S', 0.7110, NULL, NULL, '23900', 'N', 'N', 2745, NULL, '2390', '2390', NULL, '1871', 'S', 718, 'LIMOEIRO DO NORTE', 'N', '230760', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '102', NULL, '02', 'N', NULL, NULL, NULL, 336);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230763', '2305', 'CE', '2304', '2304', '23019', '23', 'MADALENA', NULL, '88', '63860000', '5', '1261', '1261', '05170', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 1034.773, '-4,85700', '-39,57700', 299, 'S', 0.6340, NULL, NULL, '23900', 'S', 'N', 2813, NULL, '2390', '2390', NULL, '1989', 'S', 719, 'MADALENA', 'N', '230763', 'N', 'S', 'S', NULL, 85, 'S', 'N', 'N', '103', NULL, '03', 'N', NULL, NULL, NULL, 172);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230765', '2303', 'CE', '2301', '2303', '23016', '23', 'MARACANAU', NULL, '85', '61900000', '0', '1585', '1585', '05145', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 105.696, '-3,87700', '-38,62600', 40, 'S', 0.7360, NULL, NULL, '23900', 'N', 'N', 2883, NULL, '2301', '2301', NULL, '1983', 'S', 720, 'MARACANAÚ', 'N', '230765', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '104', NULL, '01', 'N', NULL, NULL, NULL, 228);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230810', '2319', 'CE', '2303', '2307', '23031', '23', 'MAURITI', NULL, '88', '63210000', '4', '1463', '1463', '05082', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1111.856, '-7,38900', '-38,77400', 373, 'S', 0.6460, NULL, NULL, '23900', 'N', 'N', 2995, NULL, '2390', '2390', NULL, '1933', 'S', 725, 'MAURITI', 'N', '230810', 'N', 'S', 'S', NULL, 131, 'S', 'N', 'N', '109', NULL, '03', 'N', NULL, NULL, NULL, 49);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230835', '2308', 'CE', '2304', '2304', '23021', '23', 'MILHA', NULL, '88', '63635000', '1', '1597', '1597', '05150', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 502.036, '-5,67500', '-39,19400', 215, 'S', 0.6320, NULL, NULL, '23900', 'S', 'N', 3025, NULL, '2390', '2390', NULL, '1986', 'S', 728, 'MILHÃ', 'N', '230835', 'N', 'S', 'S', NULL, 80, 'N', 'N', 'N', '112', NULL, '03', 'N', NULL, NULL, NULL, 51);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230837', '2306', 'CE', '2301', '2301', '23005', '23', 'MIRAIMA', NULL, '88', '62530000', '7', '1263', '1263', '05180', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 699.588, '-3,56900', '-39,97000', 79, 'S', 0.5830, NULL, NULL, '23900', 'S', 'N', 3047, NULL, '2390', '2390', NULL, '1989', 'S', 729, 'MIRAÍMA', 'N', '230837', 'N', 'S', 'S', NULL, 51, 'N', 'N', 'N', '113', NULL, '03', 'N', NULL, NULL, NULL, 229);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230840', '2321', 'CE', '2303', '2307', '23032', '23', 'MISSAO VELHA', NULL, '88', '63200000', '1', '1469', '1469', '05085', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 651.108, '-7,25000', '-39,14300', 360, 'S', 0.6310, NULL, NULL, '23900', 'N', 'N', 3065, NULL, '2302', '2390', NULL, '1864', 'S', 730, 'MISSÃO VELHA', 'N', '230840', 'N', 'S', 'S', NULL, 131, 'S', 'N', 'N', '114', NULL, '03', 'N', NULL, NULL, NULL, 109);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230850', '2318', 'CE', '2303', '2304', '23021', '23', 'MOMBACA', NULL, '88', '63610000', '0', '1471', '1471', '05086', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 2119.462, '-5,74300', '-39,62800', 244, 'S', 0.6040, NULL, NULL, '23900', 'N', 'N', 3078, NULL, '2390', '2390', NULL, '1933', 'S', 731, 'MOMBAÇA', 'N', '230850', 'N', 'S', 'S', NULL, 80, 'N', 'N', 'N', '115', NULL, '03', 'N', NULL, NULL, NULL, 108);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230870', '2309', 'CE', '2301', '2305', '23023', '23', 'MORADA NOVA', NULL, '88', '62940000', '8', '1475', '1475', '05088', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 2779.229, '-5,10700', '-38,37300', 52, 'S', 0.6700, NULL, NULL, '23900', 'N', 'N', 3132, NULL, '2390', '2390', NULL, '1876', 'S', 733, 'MORADA NOVA', 'N', '230870', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '117', NULL, '02', 'N', NULL, NULL, NULL, 341);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230890', '2312', 'CE', '2302', '2301', '23001', '23', 'MORRINHOS', NULL, '88', '62550000', '6', '1479', '1479', '05090', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 408.878, '-3,22900', '-40,12500', 35, 'S', 0.6080, NULL, NULL, '23900', 'S', 'N', 3142, NULL, '2390', '2390', NULL, '1957', 'S', 735, 'MORRINHOS', 'N', '230890', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '119', NULL, '03', 'N', NULL, NULL, NULL, 170);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230910', '2304', 'CE', '2301', '2302', '23013', '23', 'MULUNGU', NULL, '85', '62764000', '2', '1483', '1483', '05092', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 134.594, '-4,30600', '-38,99600', 801, 'S', 0.6500, NULL, NULL, '23900', 'S', 'N', 3172, NULL, '2390', '2390', NULL, '1957', 'S', 737, 'MULUNGU', 'N', '230910', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '121', NULL, '03', 'N', NULL, NULL, NULL, 6);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230920', '2320', 'CE', '2303', '2307', '23032', '23', 'NOVA OLINDA', NULL, '88', '63165000', '1', '1485', '1485', '05093', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 284.404, '-7,09200', '-39,68100', 446, 'S', 0.6370, NULL, NULL, '23900', 'S', 'N', 3313, NULL, '2302', '2390', NULL, '1957', 'S', 738, 'NOVA OLINDA', 'N', '230920', 'N', 'S', 'S', NULL, 131, 'S', 'N', 'N', '122', NULL, '03', 'N', NULL, NULL, NULL, 339);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230930', '2315', 'CE', '2302', '2304', '23018', '23', 'NOVA RUSSAS', NULL, '88', '62200000', '0', '1487', '1487', '05094', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 742.763, '-4,70700', '-40,56300', 240, 'S', 0.6400, NULL, NULL, '23900', 'S', 'N', 3331, NULL, '2390', '2390', NULL, '1933', 'S', 739, 'NOVA RUSSAS', 'N', '230930', 'N', 'S', 'S', NULL, 49, 'S', 'N', 'N', '123', NULL, '03', 'N', NULL, NULL, NULL, 285);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230940', '2315', 'CE', '2302', '2304', '23018', '23', 'NOVO ORIENTE', NULL, '88', '63740000', '9', '1489', '1489', '05095', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 949.206, '-5,53400', '-40,77400', 347, 'S', 0.6020, NULL, NULL, '23900', 'S', 'N', 3370, NULL, '2390', '2390', NULL, '1957', 'S', 740, 'NOVO ORIENTE', 'N', '230940', 'N', 'S', 'S', NULL, 49, 'N', 'N', 'N', '124', NULL, '03', 'N', NULL, NULL, NULL, 285);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230945', '2322', 'CE', '2301', '2302', '23014', '23', 'OCARA', NULL, '85', '62755000', '8', '1265', '1265', '05171', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 765.366, '-4,49100', '-38,59700', 100, 'S', 0.5940, NULL, NULL, '23900', 'S', 'N', 3383, NULL, '2390', '2390', NULL, '1989', 'S', 741, 'OCARA', 'N', '230945', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '125', NULL, '03', 'N', NULL, NULL, NULL, 340);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230950', '2317', 'CE', '2303', '2306', '23026', '23', 'OROS', NULL, '88', '63520000', '8', '1491', '1491', '05096', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 576.269, '-6,24400', '-38,91400', 184, 'S', 0.6270, NULL, NULL, '23900', 'S', 'N', 3421, NULL, '2390', '2390', NULL, '1956', 'S', 742, 'ORÓS', 'N', '230950', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '126', NULL, '03', 'N', NULL, NULL, NULL, 48);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230960', '2322', 'CE', '2301', '2303', '23017', '23', 'PACAJUS', NULL, '85', '62870000', '7', '1493', '1493', '05097', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 254.435, '-4,17300', '-38,46100', 60, 'S', 0.6780, NULL, NULL, '23900', 'N', 'N', 3452, NULL, '2301', '2301', NULL, '1935', 'S', 743, 'PACAJUS', 'N', '230960', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '127', NULL, '01', 'N', NULL, NULL, NULL, 340);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230970', '2303', 'CE', '2301', '2303', '23016', '23', 'PACATUBA', NULL, '85', '61800000', '6', '1495', '1495', '05098', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 132.427, '-3,98400', '-38,62000', 65, 'S', 0.7170, NULL, NULL, '23900', 'N', 'N', 3454, NULL, '2301', '2301', NULL, '1869', 'S', 744, 'PACATUBA', 'N', '230970', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '128', NULL, '01', 'N', NULL, NULL, NULL, 228);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230980', '2304', 'CE', '2301', '2302', '23013', '23', 'PACOTI', NULL, '85', '62770000', '5', '1497', '1497', '05099', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 111.959, '-4,22500', '-38,92300', 736, 'S', 0.6680, NULL, NULL, '23900', 'S', 'N', 3457, NULL, '2390', '2390', NULL, '1933', 'S', 745, 'PACOTI', 'N', '230980', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '129', NULL, '03', 'N', NULL, NULL, NULL, 6);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230990', '2311', 'CE', '2302', '2301', '23005', '23', 'PACUJA', NULL, '88', '62180000', '4', '1499', '1499', '05100', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 76.100, '-3,98800', '-40,69700', 142, 'S', 0.6390, NULL, NULL, '23900', 'S', 'N', 3458, NULL, '2390', '2390', NULL, '1957', 'S', 746, 'PACUJÁ', 'N', '230990', 'N', 'S', 'S', NULL, 86, 'N', 'N', 'N', '130', NULL, '03', 'N', NULL, NULL, NULL, 284);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231000', '2309', 'CE', '2301', '2305', '23023', '23', 'PALHANO', NULL, '88', '62910000', '1', '1501', '1501', '05101', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 442.785, '-4,74500', '-37,95900', 14, 'S', 0.6490, NULL, NULL, '23900', 'S', 'N', 3477, NULL, '2390', '2390', NULL, '1958', 'S', 747, 'PALHANO', 'N', '231000', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '131', NULL, '03', 'N', NULL, NULL, NULL, 341);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231010', '2303', 'CE', '2301', '2302', '23013', '23', 'PALMACIA', NULL, '85', '62780000', '0', '1503', '1503', '05102', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 117.816, '-4,15000', '-38,84600', 425, 'S', 0.6500, NULL, NULL, '23900', 'S', 'N', 3481, NULL, '2390', '2390', NULL, '1957', 'S', 748, 'PALMÁCIA', 'N', '231010', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '132', NULL, '03', 'N', NULL, NULL, NULL, 228);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231020', '2302', 'CE', '2301', '2302', '23009', '23', 'PARACURU', NULL, '85', '62680000', '9', '1505', '1505', '05103', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 303.253, '-3,41000', '-39,03100', 19, 'S', 0.6410, NULL, NULL, '23900', 'S', 'N', 3523, NULL, '2390', '2390', NULL, '1951', 'S', 749, 'PARACURU', 'N', '231020', 'N', 'S', 'S', NULL, 51, 'N', 'N', 'N', '133', NULL, '03', 'N', NULL, NULL, NULL, 5);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210467', '2119', 'MA', '2107', '2102', '21007', '21', 'GOVERNADOR NUNES FREIRE', NULL, '98', '65284000', '7', '0168', '0168', '09169', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1037.121, '-2,12600', '-45,88500', 0, 'S', 0.5920, NULL, NULL, '21900', 'S', 'N', 1928, NULL, '2190', '2190', NULL, '1997', 'S', 1220, 'GOVERNADOR NUNES FREIRE', 'N', '210467', 'S', 'S', 'S', NULL, 139, 'N', 'N', 'S', '82', NULL, '03', 'N', NULL, NULL, NULL, 299);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210470', '2113', 'MA', '2105', '2103', '21012', '21', 'GRACA ARANHA', NULL, '99', '65785000', '1', '0791', '0791', '09046', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 271.457, '-5,41000', '-44,33400', 192, 'S', 0.5710, NULL, NULL, '21900', 'S', 'N', 1931, NULL, '2190', '2190', NULL, '1959', 'S', 1221, 'GRAÇA ARANHA', 'N', '210470', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '83', NULL, '03', 'N', NULL, NULL, NULL, 11);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210480', '2105', 'MA', '2105', '2103', '21011', '21', 'GRAJAU', NULL, '99', '65940000', '0', '0793', '0793', '09047', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 7407.824, '-5,81900', '-46,13900', 172, 'S', 0.6390, NULL, NULL, '21900', 'N', 'N', 1933, NULL, '2190', '2190', NULL, '1835', 'S', 1222, 'GRAJAÚ', 'N', '210480', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '84', NULL, '02', 'N', NULL, NULL, NULL, 121);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210490', '2112', 'MA', '2103', '2101', '21001', '21', 'GUIMARAES', NULL, '98', '65255000', '9', '0795', '0795', '09048', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 598.796, '-2,13300', '-44,60100', 41, 'S', 0.6400, NULL, NULL, '21900', 'S', 'N', 2018, NULL, '2190', '2190', NULL, '1758', 'S', 1223, 'GUIMARÃES', 'N', '210490', 'S', 'S', 'S', NULL, 115, 'N', 'N', 'N', '85', NULL, '03', 'N', NULL, NULL, NULL, 239);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210500', '2114', 'MA', '2101', '2101', '21004', '21', 'HUMBERTO CAMPOS', NULL, '98', '65180000', '5', '0797', '0797', '09049', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2131.079, '-2,59800', '-43,46100', 17, 'S', 0.5690, NULL, NULL, '21900', 'S', 'N', 2048, NULL, '2190', '2190', NULL, '1859', 'S', 1224, 'HUMBERTO DE CAMPOS', 'N', '210500', 'S', 'S', 'S', NULL, 52, 'S', 'N', 'N', '86', NULL, '03', 'N', NULL, NULL, NULL, 123);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210515', '2115', 'MA', '2107', '2101', '21005', '21', 'IGARAPE DO MEIO', NULL, '98', '65345000', '3', '0170', '0170', '09170', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 392.847, '-3,66100', '-45,22700', 0, 'S', 0.5400, NULL, NULL, '21900', 'S', 'N', 2120, NULL, '2190', '2190', NULL, '1997', 'S', 1226, 'IGARAPÉ DO MEIO', 'N', '210515', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '88', NULL, '03', 'N', NULL, NULL, NULL, 356);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231025', '2302', 'CE', '2301', '2302', '23009', '23', 'PARAIPABA', NULL, '85', '62685000', '8', '1599', '1599', '05147', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 301.123, '-3,43900', '-39,14800', 31, 'S', 0.6660, NULL, NULL, '23900', 'S', 'N', 3531, NULL, '2390', '2390', NULL, '1986', 'S', 750, 'PARAIPABA', 'N', '231025', 'N', 'S', 'S', NULL, 51, 'N', 'N', 'N', '134', NULL, '03', 'N', NULL, NULL, NULL, 5);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231030', '2314', 'CE', '2304', '2304', '23020', '23', 'PARAMBU', NULL, '88', '63680000', '8', '1507', '1507', '05104', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 2303.402, '-6,21100', '-40,69400', 478, 'S', 0.6130, NULL, NULL, '23900', 'N', 'N', 3538, NULL, '2390', '2390', NULL, '1956', 'S', 751, 'PARAMBU', 'N', '231030', 'N', 'S', 'S', NULL, 49, 'N', 'N', 'N', '135', NULL, '03', 'N', NULL, NULL, NULL, 337);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231050', '2308', 'CE', '2304', '2304', '23021', '23', 'PEDRA BRANCA', NULL, '88', '63630000', '6', '1511', '1511', '05106', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 1303.273, '-5,45400', '-39,71700', 500, 'S', 0.6050, NULL, NULL, '23900', 'N', 'N', 3642, NULL, '2390', '2390', NULL, '1935', 'S', 753, 'PEDRA BRANCA', 'N', '231050', 'N', 'S', 'S', NULL, 80, 'N', 'N', 'N', '137', NULL, '03', 'N', NULL, NULL, NULL, 51);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231060', '2319', 'CE', '2303', '2307', '23033', '23', 'PENAFORTE', NULL, '88', '63280000', '5', '1513', '1513', '05107', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 190.428, '-7,82900', '-39,07700', 509, 'S', 0.6870, NULL, NULL, '23900', 'S', 'N', 3684, NULL, '2390', '2390', NULL, '1958', 'S', 754, 'PENAFORTE', 'N', '231060', 'N', 'S', 'S', NULL, 131, 'S', 'N', 'N', '138', NULL, '03', 'N', NULL, NULL, NULL, 49);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231070', '2302', 'CE', '2301', '2302', '23011', '23', 'PENTECOSTE', NULL, '85', '62640000', '4', '1515', '1515', '05108', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 1378.295, '-3,79300', '-39,27000', 45, 'S', 0.6350, NULL, NULL, '23900', 'N', 'N', 3690, NULL, '2390', '2390', NULL, '1935', 'S', 755, 'PENTECOSTE', 'N', '231070', 'N', 'S', 'S', NULL, 51, 'N', 'N', 'N', '139', NULL, '03', 'N', NULL, NULL, NULL, 5);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231080', '2310', 'CE', '2301', '2305', '23025', '23', 'PEREIRO', NULL, '88', '63460000', '3', '1517', '1517', '05109', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 432.881, '-6,04500', '-38,46100', 560, 'S', 0.6260, NULL, NULL, '23900', 'S', 'N', 3699, NULL, '2390', '2390', NULL, '1933', 'S', 756, 'PEREIRO', 'N', '231080', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '140', NULL, '03', 'N', NULL, NULL, NULL, 336);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231085', '2322', 'CE', '2301', '2302', '23015', '23', 'PINDORETAMA', NULL, '85', '62860000', '2', '1267', '1267', '05172', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 72.855, '-4,02800', '-38,30600', 40, 'S', 0.6570, NULL, NULL, '23900', 'S', 'N', 3752, NULL, '2301', '2390', NULL, '1989', 'S', 757, 'PINDORETAMA', 'N', '231085', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '141', NULL, '01', 'N', NULL, NULL, NULL, 340);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231140', '2308', 'CE', '2304', '2304', '23019', '23', 'QUIXERAMOBIM', NULL, '88', '63800000', '5', '1529', '1529', '05115', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 3275.838, '-5,19900', '-39,29300', 191, 'S', 0.6400, NULL, NULL, '23900', 'N', 'N', 4043, NULL, '2390', '2390', NULL, '1856', 'S', 767, 'QUIXERAMOBIM', 'N', '231140', 'N', 'S', 'S', NULL, 80, 'N', 'N', 'N', '151', NULL, '01', 'N', NULL, NULL, NULL, 51);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231150', '2310', 'CE', '2301', '2305', '23023', '23', 'QUIXERE', NULL, '88', '62920000', '4', '1531', '1531', '05116', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 616.825, '-5,07400', '-37,98900', 25, 'S', 0.6520, NULL, NULL, '23900', 'S', 'N', 4044, NULL, '2390', '2390', NULL, '1957', 'S', 768, 'QUIXERÉ', 'N', '231150', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '152', NULL, '03', 'N', NULL, NULL, NULL, 336);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231160', '2303', 'CE', '2301', '2302', '23013', '23', 'REDENCAO', NULL, '85', '62790000', '3', '1533', '1533', '05117', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 225.626, '-4,22600', '-38,73100', 88, 'S', 0.6510, NULL, NULL, '23900', 'S', 'N', 4062, NULL, '2390', '2390', NULL, '1889', 'S', 769, 'REDENÇÃO', 'N', '231160', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '153', NULL, '03', 'N', NULL, NULL, NULL, 228);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231170', '2311', 'CE', '2302', '2301', '23006', '23', 'RERIUTABA', NULL, '88', '62260000', '2', '1535', '1535', '05118', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 383.119, '-4,14200', '-40,58200', 145, 'S', 0.6530, NULL, NULL, '23900', 'S', 'N', 4076, NULL, '2390', '2390', NULL, '1935', 'S', 770, 'RERIUTABA', 'N', '231170', 'N', 'S', 'S', NULL, 86, 'N', 'N', 'N', '154', NULL, '03', 'N', NULL, NULL, NULL, 284);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231180', '2309', 'CE', '2301', '2305', '23023', '23', 'RUSSAS', NULL, '88', '62900000', '1', '1537', '1537', '05119', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 1588.105, '-4,94000', '-37,97600', 20, 'S', 0.6980, NULL, NULL, '23900', 'N', 'N', 4238, NULL, '2390', '2390', NULL, '1859', 'S', 771, 'RUSSAS', 'N', '231180', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '155', NULL, '02', 'N', NULL, NULL, NULL, 341);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231190', '2318', 'CE', '2303', '2304', '23020', '23', 'SABOEIRO', NULL, '88', '63590000', '0', '1539', '1539', '05120', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 1383.472, '-6,54200', '-39,90700', 291, 'S', 0.5600, NULL, NULL, '23900', 'S', 'N', 4245, NULL, '2390', '2390', NULL, '1935', 'S', 772, 'SABOEIRO', 'N', '231190', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '156', NULL, '03', 'N', NULL, NULL, NULL, 108);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231195', '2320', 'CE', '2303', '2307', '23029', '23', 'SALITRE', NULL, '88', '63155000', '9', '1273', '1273', '05181', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 899.824, '-7,28500', '-40,45700', 680, 'S', 0.5580, NULL, NULL, '23900', 'S', 'N', 4264, NULL, '2390', '2390', NULL, '1989', 'S', 773, 'SALITRE', 'N', '231195', 'N', 'S', 'S', NULL, 131, 'S', 'N', 'N', '157', NULL, '03', 'N', NULL, NULL, NULL, 339);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231200', '2311', 'CE', '2302', '2301', '23005', '23', 'SANTANA DO ACARAU', NULL, '88', '62150000', '7', '1541', '1541', '05121', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 969.323, '-3,46100', '-40,21200', 45, 'S', 0.6190, NULL, NULL, '23900', 'S', 'N', 4445, NULL, '2390', '2390', NULL, '1862', 'S', 775, 'SANTANA DO ACARAÚ', 'N', '231200', 'N', 'S', 'S', NULL, 86, 'S', 'N', 'N', '159', NULL, '03', 'N', NULL, NULL, NULL, 284);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210520', '2111', 'MA', '2106', '2103', '21010', '21', 'IGARAPE GRANDE', NULL, '99', '65720000', '3', '0801', '0801', '09051', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 374.283, '-4,58500', '-44,85300', 80, 'S', 0.6020, NULL, NULL, '21900', 'S', 'N', 2121, NULL, '2190', '2190', NULL, '1961', 'S', 1227, 'IGARAPÉ GRANDE', 'N', '210520', 'S', 'S', 'S', NULL, 140, 'N', 'N', 'N', '89', NULL, '03', 'N', NULL, NULL, NULL, 238);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210530', '2109', 'MA', '2104', '2102', '21009', '21', 'IMPERATRIZ', NULL, '99', '65903970', '2', '0803', '0803', '09052', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1367.901, '-5,52600', '-47,47600', 116, 'S', 0.7220, NULL, NULL, '21900', 'N', 'N', 2159, NULL, '2102', '2190', NULL, '1856', 'S', 1228, 'IMPERATRIZ', 'N', '210530', 'S', 'S', 'S', NULL, NULL, 'N', 'S', 'S', '90', NULL, '01', 'N', NULL, NULL, NULL, 298);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210535', '2105', 'MA', '2105', '2103', '21011', '21', 'ITAIPAVA DO GRAJAU', NULL, '99', '65948000', '1', '0172', '0172', '09171', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1540.286, '-5,14500', '-45,79100', 110, 'S', 0.5310, NULL, NULL, '21900', 'S', 'N', 2293, NULL, '2190', '2190', NULL, '1997', 'S', 1229, 'ITAIPAVA DO GRAJAÚ', 'N', '210535', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '91', NULL, '03', 'N', NULL, NULL, NULL, 121);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355420', '3506', 'SP', '3509', '3510', '35040', '35', 'TEJUPA', NULL, '14', '18830000', '1', '7185', '7185', '21543', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 296.343, '-23,34300', '-49,37600', 765, 'S', 0.7040, NULL, NULL, '35061', 'N', 'N', 5135, NULL, '3590', '3590', NULL, '1964', 'S', 5349, 'TEJUPÁ', 'N', '355420', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '608', NULL, '03', 'N', NULL, NULL, NULL, 102);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210660', '2117', 'MA', '2102', '2104', '21017', '21', 'MATOES', NULL, '99', '65645000', '7', '0831', '0831', '09066', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1858.007, '-5,51900', '-43,19900', 38, 'S', 0.5670, NULL, NULL, '21900', 'S', 'N', 2981, NULL, '2190', '2190', NULL, '1952', 'S', 1253, 'MATÕES', 'N', '210660', 'S', 'S', 'S', NULL, 34, 'S', 'N', 'N', '115', NULL, '03', 'N', NULL, NULL, NULL, 186);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210663', '2110', 'MA', '2101', '2101', '21006', '21', 'MATOES DO NORTE', NULL, '98', '65468000', '1', '0196', '0196', '09183', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 781.963, '-3,63200', '-44,55600', 30, 'S', 0.4950, NULL, NULL, '21900', 'S', 'N', 2982, NULL, '2190', '2190', NULL, '1997', 'S', 1254, 'MATÕES DO NORTE', 'N', '210663', 'S', 'S', 'S', NULL, 97, 'S', 'N', 'N', '116', NULL, '03', 'N', NULL, NULL, NULL, 122);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210667', '2107', 'MA', '2101', '2104', '21014', '21', 'MILAGRES DO MARANHAO', NULL, '98', '65545000', '2', '0198', '0198', '09184', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 439.365, '-3,58100', '-42,60900', 20, 'S', 0.5630, NULL, NULL, '21900', 'S', 'N', 3024, NULL, '2190', '2190', NULL, '1997', 'S', 1255, 'MILAGRES DO MARANHÃO', 'N', '210667', 'S', 'S', 'S', NULL, 20, 'N', 'N', 'N', '117', NULL, '03', 'N', NULL, NULL, NULL, 408);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210670', '2118', 'MA', '2105', '2104', '21018', '21', 'MIRADOR', NULL, '99', '65850000', '6', '0833', '0833', '09067', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 8609.822, '-6,37100', '-44,36300', 186, 'S', 0.5640, NULL, NULL, '21900', 'S', 'N', 3043, NULL, '2190', '2190', NULL, '1870', 'S', 1256, 'MIRADOR', 'N', '210670', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '118', NULL, '03', 'N', NULL, NULL, NULL, 12);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350630', '3509', 'SP', '3510', '3510', '35040', '35', 'BERNARDINO DE CAMPOS', NULL, '14', '18960000', '0', '6225', '6225', '21063', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 244.018, '-23,01300', '-49,47400', 695, 'S', 0.7790, NULL, NULL, '35094', 'N', 'N', 602, NULL, '3590', '3590', NULL, '1923', 'S', 4812, 'BERNARDINO DE CAMPOS', 'N', '350630', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '71', NULL, '03', 'N', NULL, NULL, NULL, 329);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351015', '3509', 'SP', '3510', '3510', '35040', '35', 'CANITAR', NULL, '14', '18990000', '3', '2947', '2947', '21596', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 57.380, '-23,00600', '-49,78300', 508, 'S', 0.7380, NULL, NULL, '35094', 'N', 'N', 1022, NULL, '3590', '3590', NULL, '1993', 'S', 4858, 'CANITAR', 'N', '351015', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '117', NULL, '03', 'N', NULL, NULL, NULL, 329);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351519', '3509', 'SP', '3510', '3510', '35040', '35', 'ESPIRITO SANTO DO TURVO', NULL, '14', '18935000', '4', '7253', '7253', '21577', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 191.294, '-22,69200', '-49,43000', 520, 'S', 0.7550, NULL, NULL, '35094', 'N', 'N', 1685, NULL, '3590', '3590', NULL, '1993', 'S', 4915, 'ESPÍRITO SANTO DO TURVO', 'N', '351519', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '174', NULL, '03', 'N', NULL, NULL, NULL, 329);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352090', '3509', 'SP', '3510', '3510', '35040', '35', 'IPAUSSU', NULL, '14', '18950000', '5', '6519', '6519', '21210', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 209.141, '-23,05700', '-49,62600', 568, 'S', 0.7950, NULL, NULL, '35094', 'N', 'N', 2198, NULL, '3590', '3590', NULL, '1915', 'S', 4983, 'IPAUSSU', 'N', '352090', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '242', NULL, '03', 'N', NULL, NULL, NULL, 329);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353470', '3509', 'SP', '3510', '3510', '35040', '35', 'OURINHOS', NULL, '14', '19900000', '8', '6795', '6795', '21348', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 296.203, '-22,97900', '-49,87100', 483, 'S', 0.8130, NULL, NULL, '35094', 'N', 'N', 3432, NULL, '3590', '3590', NULL, '1918', 'S', 5134, 'OURINHOS', 'N', '353470', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '393', NULL, '01', 'N', NULL, NULL, NULL, 329);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354320', '3509', 'SP', '3510', '3510', '35040', '35', 'RIBEIRAO DO SUL', NULL, '14', '19930000', '4', '6965', '6965', '21433', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 203.356, '-22,78400', '-49,93400', 479, 'S', 0.7620, NULL, NULL, '35094', 'N', 'N', 4122, NULL, '3590', '3590', NULL, '1964', 'S', 5227, 'RIBEIRÃO DO SUL', 'N', '354320', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '486', NULL, '03', 'N', NULL, NULL, NULL, 329);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354640', '3509', 'SP', '3510', '3510', '35040', '35', 'SANTA CRUZ DO RIO PARDO', NULL, '14', '18900000', '5', '7029', '7029', '21465', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1116.377, '-22,89900', '-49,63300', 467, 'S', 0.8110, NULL, NULL, '35094', 'N', 'N', 4327, NULL, '3590', '3590', NULL, '1876', 'S', 5263, 'SANTA CRUZ DO RIO PARDO', 'N', '354640', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '522', NULL, '03', 'N', NULL, NULL, NULL, 329);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355050', '3509', 'SP', '3510', '3510', '35040', '35', 'SAO PEDRO DO TURVO', NULL, '14', '18940000', '6', '7111', '7111', '21506', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 731.016, '-22,74700', '-49,74000', 457, 'S', 0.7560, NULL, NULL, '35094', 'N', 'N', 4814, NULL, '3590', '3590', NULL, '1891', 'S', 5308, 'SÃO PEDRO DO TURVO', 'N', '355050', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '567', NULL, '03', 'N', NULL, NULL, NULL, 329);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355460', '3509', 'SP', '3510', '3510', '35040', '35', 'TIMBURI', NULL, '14', '18860000', '7', '7193', '7193', '21547', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 197.220, '-23,20500', '-49,60700', 838, 'S', 0.7490, NULL, NULL, '35094', 'N', 'N', 5181, NULL, '3590', '3590', NULL, '1948', 'S', 5353, 'TIMBURI', 'N', '355460', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '612', NULL, '03', 'N', NULL, NULL, NULL, 329);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355715', '3515', 'SP', '3512', '3501', '35004', '35', 'ZACARIAS', NULL, '18', '15265000', '4', '2973', '2973', '21627', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 318.800, '-21,05200', '-50,05100', 405, 'S', 0.7770, NULL, NULL, '35156', 'N', 'N', 5506, NULL, '3590', '3590', NULL, '1993', 'S', 5386, 'ZACARIAS', 'N', '355715', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '645', NULL, '03', 'N', NULL, NULL, NULL, 160);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355720', '3509', 'SP', '3510', '3510', '35040', '35', 'CHAVANTES', NULL, '14', '18970000', '4', '6337', '6337', '21119', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 188.212, '-23,03900', '-49,70900', 563, 'S', 0.7760, NULL, NULL, '35094', 'N', 'N', 1244, NULL, '3590', '3590', NULL, '1922', 'S', 4875, 'CHAVANTES', 'N', '355720', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '134', NULL, '03', 'N', NULL, NULL, NULL, 329);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355730', '3514', 'SP', '3515', '3507', '35031', '35', 'ESTIVA GERBI', NULL, '19', '13857000', '3', '2959', '2959', '21600', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 73.723, '-22,27100', '-46,94500', 590, 'S', 0.7940, NULL, NULL, '35141', 'N', 'N', 1693, NULL, '3590', '3509', NULL, '1993', 'S', 4916, 'ESTIVA GERBI', 'N', '355730', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '175', NULL, '03', 'N', NULL, NULL, NULL, 432);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210830', '2116', 'MA', '2103', '2101', '21005', '21', 'PENALVA', NULL, '98', '65213000', '6', '0863', '0863', '09082', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 785.565, '-3,29400', '-45,17400', 17, 'S', 0.5840, NULL, NULL, '21900', 'S', 'N', 3685, NULL, '2190', '2190', NULL, '1871', 'S', 1278, 'PENALVA', 'N', '210830', 'S', 'S', 'S', NULL, 141, 'N', 'N', 'N', '140', NULL, '03', 'N', NULL, NULL, NULL, 124);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150450', '1508', 'PA', '1590', '1502', '15004', '15', 'MELGACO', NULL, '91', '68490000', '5', '0489', '0489', '12045', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 6773.975, '-1,80400', '-50,71200', 12, 'S', 0.5250, NULL, NULL, '15900', 'S', 'N', 3005, NULL, '1590', '1590', NULL, '1961', 'S', 2482, 'MELGAÇO', 'N', '150450', 'S', 'N', 'S', NULL, 129, 'S', 'N', 'N', '71', NULL, '03', 'N', NULL, NULL, NULL, 509);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170240', '1715', 'TO', '1790', '1702', '17008', '17', 'ARRAIAS', NULL, '63', '77330000', '6', '9247', '9247', '28011', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 5786.844, '-12,93100', '-46,93800', 682, 'S', 0.6850, NULL, NULL, '17900', 'S', 'N', 388, NULL, '1790', '1790', NULL, '1889', 'S', 5402, 'ARRAIAS', 'N', '170240', 'S', 'N', 'S', NULL, 124, 'N', 'N', 'N', '16', NULL, '03', 'N', NULL, NULL, NULL, 218);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170270', '1715', 'TO', '1790', '1702', '17008', '17', 'AURORA DO TOCANTINS', NULL, '63', '77325000', '3', '9253', '9253', '28013', NULL, 'ATIVO', 'S', 'N', NULL, 'AURORA DO NORTE           ', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 752.826, '-12,71300', '-46,40800', 468, 'S', 0.6580, NULL, NULL, '17900', 'S', 'N', 430, NULL, '1790', '1790', NULL, '1989', 'S', 5404, 'AURORA DO TOCANTINS', 'N', '170270', 'S', 'N', 'S', NULL, 124, 'N', 'N', 'N', '18', NULL, '03', 'N', NULL, NULL, NULL, 218);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170555', '1715', 'TO', '1790', '1702', '17008', '17', 'COMBINADO', NULL, '63', '77350000', '7', '9697', '9697', '28022', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 209.613, '-12,79200', '-46,53900', 383, 'S', 0.6730, NULL, NULL, '17900', 'S', 'N', 1303, NULL, '1790', '1790', NULL, '1989', 'S', 5426, 'COMBINADO', 'N', '170555', 'S', 'N', 'S', NULL, 124, 'N', 'N', 'N', '40', NULL, '03', 'N', NULL, NULL, NULL, 218);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170560', '1715', 'TO', '1790', '1702', '17008', '17', 'CONCEICAO DO TOCANTINS', NULL, '63', '77305000', '7', '9313', '9313', '28023', NULL, 'ATIVO', 'S', 'N', NULL, 'CONCEICAO DO NORTE        ', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2500.733, '-12,21900', '-47,29800', 400, 'S', 0.6500, NULL, NULL, '17900', 'S', 'N', 1327, NULL, '1790', '1790', NULL, '1989', 'S', 5427, 'CONCEIÇÃO DO TOCANTINS', 'N', '170560', 'S', 'N', 'S', NULL, 124, 'N', 'N', 'N', '41', NULL, '03', 'N', NULL, NULL, NULL, 218);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170700', '1714', 'TO', '1790', '1702', '17008', '17', 'DIANOPOLIS', NULL, '63', '77300000', '9', '9341', '9341', '28026', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3217.179, '-11,62800', '-46,82100', 693, 'S', 0.6930, NULL, NULL, '17900', 'S', 'N', 1537, NULL, '1790', '1790', NULL, '1989', 'S', 5432, 'DIANÓPOLIS', 'N', '170700', 'S', 'N', 'S', NULL, 124, 'N', 'N', 'S', '46', NULL, '03', 'N', NULL, NULL, NULL, 218);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171510', '1701', 'TO', '1790', '1702', '17007', '17', 'NOVO ACORDO', NULL, '63', '77610000', '1', '9499', '9499', '28050', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2671.882, '-9,96300', '-47,67700', 205, 'S', 0.6770, NULL, NULL, '17900', 'S', 'N', 3349, NULL, '1790', '1790', NULL, '1989', 'S', 5472, 'NOVO ACORDO', 'N', '171510', 'S', 'N', 'S', NULL, 107, 'S', 'N', 'N', '85', NULL, '03', 'N', NULL, NULL, NULL, 163);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171515', '1715', 'TO', '1790', '1702', '17008', '17', 'NOVO ALEGRE', NULL, '63', '77353000', '0', '9703', '9703', '28080', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 200.105, '-12,93100', '-46,57400', 539, 'S', 0.6940, NULL, NULL, '17900', 'S', 'N', 3351, NULL, '1790', '1790', NULL, '1993', 'S', 5473, 'NOVO ALEGRE', 'N', '171515', 'S', 'N', 'S', NULL, 124, 'N', 'N', 'N', '86', NULL, '03', 'N', NULL, NULL, NULL, 218);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171525', '1714', 'TO', '1790', '1702', '17008', '17', 'NOVO JARDIM', NULL, '63', '77318000', '9', '0321', '0321', '28106', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1309.658, '-11,82400', '-46,62800', 0, 'S', 0.6520, NULL, NULL, '17900', 'S', 'N', 3366, NULL, '1790', '1790', NULL, '1993', 'S', 5474, 'NOVO JARDIM', 'N', '171525', 'S', 'N', 'S', NULL, 124, 'N', 'N', 'N', '87', NULL, '03', 'N', NULL, NULL, NULL, 218);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171800', '1714', 'TO', '1790', '1702', '17008', '17', 'PORTO ALEGRE DO TOCANTINS', NULL, '63', '77395000', '6', '9723', '9723', '28062', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 501.970, '-11,60900', '-47,04900', 387, 'S', 0.6540, NULL, NULL, '17900', 'S', 'N', 3900, NULL, '1790', '1790', NULL, '1989', 'S', 5490, 'PORTO ALEGRE DO TOCANTINS', 'N', '171800', 'S', 'N', 'S', NULL, 124, 'N', 'N', 'N', '104', NULL, '03', 'N', NULL, NULL, NULL, 218);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171865', '1714', 'TO', '1790', '1702', '17008', '17', 'RIO DA CONCEICAO', NULL, '63', '77303000', '9', '0323', '0323', '28111', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 771.112, '-11,40000', '-46,88300', 496, 'S', 0.6340, NULL, NULL, '17900', 'S', 'N', 4149, NULL, '1790', '1790', NULL, '1993', 'S', 5497, 'RIO DA CONCEIÇÃO', 'N', '171865', 'S', 'N', 'S', NULL, 124, 'N', 'N', 'N', '111', NULL, '03', 'N', NULL, NULL, NULL, 218);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210840', '2112', 'MA', '2103', '2101', '21005', '21', 'PERI MIRIM', NULL, '98', '65245000', '5', '0865', '0865', '09083', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 405.295, '-2,57800', '-44,85400', 11, 'S', 0.5930, NULL, NULL, '21900', 'S', 'N', 3700, NULL, '2190', '2190', NULL, '1935', 'S', 1279, 'PERI MIRIM', 'N', '210840', 'S', 'S', 'S', NULL, 115, 'S', 'N', 'N', '141', NULL, '03', 'N', NULL, NULL, NULL, 239);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171870', '1703', 'TO', '1790', '1701', '17003', '17', 'RIO DOS BOIS', NULL, '63', '77655000', '9', '0359', '0359', '28112', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 845.062, '-9,29300', '-48,46600', 230, 'S', 0.6250, NULL, NULL, '17900', 'S', 'N', 4164, NULL, '1790', '1790', NULL, '1993', 'S', 5498, 'RIO DOS BOIS', 'N', '171870', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '112', NULL, '03', 'N', NULL, NULL, NULL, 163);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171875', '1703', 'TO', '1790', '1702', '17007', '17', 'RIO SONO', NULL, '63', '77635000', '8', '9679', '9679', '28066', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 6357.117, '-9,34400', '-47,90200', 196, 'S', 0.6260, NULL, NULL, '17900', 'S', 'N', 4191, NULL, '1790', '1790', NULL, '1989', 'S', 5499, 'RIO SONO', 'N', '171875', 'S', 'N', 'S', NULL, 107, 'N', 'N', 'N', '113', NULL, '03', 'N', NULL, NULL, NULL, 163);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('172015', '1701', 'TO', '1790', '1702', '17007', '17', 'SAO FELIX DO TOCANTINS', NULL, '63', '77605000', '0', '0363', '0363', '28117', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1908.669, '-10,16800', '-46,65900', 0, 'S', 0.6110, NULL, NULL, '17900', 'S', 'N', 4576, NULL, '1790', '1790', NULL, '1993', 'S', 5509, 'SÃO FÉLIX DO TOCANTINS', 'N', '172015', 'S', 'N', 'S', NULL, 107, 'N', 'N', 'N', '123', NULL, '03', 'N', NULL, NULL, NULL, 163);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350010', '3509', 'SP', '3510', '3508', '35035', '35', 'ADAMANTINA', NULL, '18', '17800000', '5', '6101', '6101', '21001', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 411.781, '-21,68500', '-51,07300', 401, 'S', 0.8120, NULL, NULL, '35091', 'N', 'N', 30, NULL, '3590', '3590', NULL, '1948', 'S', 4742, 'ADAMANTINA', 'N', '350010', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '1', NULL, '03', 'N', NULL, NULL, NULL, 322);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350020', '3515', 'SP', '3512', '3501', '35004', '35', 'ADOLFO', NULL, '17', '15230000', '4', '6103', '6103', '21002', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 210.843, '-21,23500', '-49,64400', 443, 'S', 0.7950, NULL, NULL, '35156', 'N', 'N', 32, NULL, '3590', '3590', NULL, '1959', 'S', 4743, 'ADOLFO', 'N', '350020', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '2', NULL, '03', 'N', NULL, NULL, NULL, 160);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350030', '3514', 'SP', '3515', '3507', '35029', '35', 'AGUAI', NULL, '19', '13860000', '3', '6105', '6105', '21003', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 473.365, '-22,05900', '-46,97900', 660, 'S', 0.7860, NULL, NULL, '35142', 'N', 'N', 62, NULL, '3590', '3590', NULL, '1944', 'S', 4744, 'AGUAÍ', 'N', '350030', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '3', NULL, '03', 'N', NULL, NULL, NULL, 328);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170390', '1706', 'TO', '1790', '1701', '17003', '17', 'CASEARA', NULL, '63', '77680000', '9', '9717', '9717', '28020', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1691.612, '-9,27800', '-49,95600', 174, 'S', 0.6870, NULL, NULL, '17900', 'S', 'N', 1147, NULL, '1790', '1790', NULL, '1989', 'S', 5420, 'CASEARA', 'N', '170390', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '34', NULL, '03', 'N', NULL, NULL, NULL, 216);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350040', '3514', 'SP', '3515', '3507', '35030', '35', 'AGUAS DA PRATA', NULL, '19', '13890000', '2', '6107', '6107', '21004', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 142.588, '-21,93700', '-46,71700', 842, 'S', 0.8100, NULL, NULL, '35142', 'N', 'N', 65, NULL, '3590', '3590', NULL, '1935', 'S', 4745, 'ÁGUAS DA PRATA', 'N', '350040', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '4', NULL, '03', 'N', NULL, NULL, NULL, 328);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350050', '3507', 'SP', '3515', '3507', '35033', '35', 'AGUAS DE LINDOIA', NULL, '19', '13940000', '1', '6109', '6109', '21005', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 60.000, '-22,47600', '-46,63300', 904, 'S', 0.8070, NULL, NULL, '35074', 'N', 'N', 67, NULL, '3590', '3590', NULL, '1953', 'S', 4746, 'ÁGUAS DE LINDÓIA', 'N', '350050', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '5', NULL, '03', 'N', NULL, NULL, NULL, 517);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350055', '3506', 'SP', '3509', '3504', '35022', '35', 'AGUAS DE SANTA BARBARA', NULL, '14', '18770000', '0', '7019', '7019', '21460', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 408.471, '-22,88100', '-49,23900', 644, 'S', 0.8240, NULL, NULL, '35061', 'N', 'N', 68, NULL, '3590', '3590', NULL, '1876', 'S', 4747, 'ÁGUAS DE SANTA BÁRBARA', 'N', '350055', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '6', NULL, '03', 'N', NULL, NULL, NULL, 102);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350060', '3510', 'SP', '3514', '3506', '35028', '35', 'AGUAS DE SAO PEDRO', NULL, '19', '13525000', '0', '6111', '6111', '21006', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3.640, '-22,59900', '-47,87600', 470, 'S', 0.9080, NULL, NULL, '35103', 'N', 'N', 69, NULL, '3590', '3590', NULL, '1948', 'S', 4748, 'ÁGUAS DE SÃO PEDRO', 'N', '350060', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '7', NULL, '03', 'N', NULL, NULL, NULL, 100);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350075', '3516', 'SP', '3508', '3511', '35042', '35', 'ALAMBARI', NULL, '15', '18220000', '8', '2995', '2995', '21586', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 159.190, '-23,55100', '-47,89900', 585, 'S', 0.7480, NULL, NULL, '35161', 'N', 'N', 93, NULL, '3590', '3590', NULL, '1993', 'S', 4750, 'ALAMBARI', 'N', '350075', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '9', NULL, '03', 'N', NULL, NULL, NULL, 158);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350080', '3511', 'SP', '3511', '3508', '35036', '35', 'ALFREDO MARCONDES', NULL, '18', '19180000', '8', '6115', '6115', '21008', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 119.504, '-21,95500', '-51,41300', 448, 'S', 0.7990, NULL, NULL, '35112', 'N', 'N', 112, NULL, '3590', '3590', NULL, '1948', 'S', 4751, 'ALFREDO MARCONDES', 'N', '350080', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '10', NULL, '03', 'N', NULL, NULL, NULL, 323);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350100', '3513', 'SP', '3514', '3502', '35015', '35', 'ALTINOPOLIS', NULL, '16', '14350000', '4', '6119', '6119', '21010', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 929.426, '-21,02600', '-47,37400', 889, 'S', 0.8230, NULL, NULL, '35133', 'N', 'N', 137, NULL, '3590', '3590', NULL, '1918', 'S', 4753, 'ALTINÓPOLIS', 'N', '350100', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '12', NULL, '03', 'N', NULL, NULL, NULL, 166);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350115', '3516', 'SP', '3508', '3512', '35046', '35', 'ALUMINIO', NULL, '11', '18125000', '2', '3065', '3065', '21587', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 83.739, '-23,53500', '-47,26200', 790, 'S', 0.7870, NULL, NULL, '35163', 'N', 'N', 166, NULL, '3590', '3513', NULL, '1993', 'S', 4755, 'ALUMÍNIO', 'N', '350115', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '14', NULL, '03', 'N', NULL, NULL, NULL, 165);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350120', '3515', 'SP', '3512', '3501', '35003', '35', 'ALVARES FLORENCE', NULL, '17', '15540000', '2', '6123', '6123', '21012', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 361.844, '-20,32100', '-49,91100', 452, 'S', 0.7710, NULL, NULL, '35157', 'N', 'N', 169, NULL, '3590', '3590', NULL, '1948', 'S', 4756, 'ÁLVARES FLORENCE', 'N', '350120', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '15', NULL, '03', 'N', NULL, NULL, NULL, 162);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350130', '3511', 'SP', '3511', '3508', '35036', '35', 'ALVARES MACHADO', NULL, '18', '19160000', '1', '6125', '6125', '21013', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 346.283, '-22,07900', '-51,47200', 475, 'S', 0.7720, NULL, NULL, '35112', 'N', 'N', 170, NULL, '3590', '3590', NULL, '1944', 'S', 4757, 'ÁLVARES MACHADO', 'N', '350130', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '16', NULL, '03', 'N', NULL, NULL, NULL, 323);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350140', '3509', 'SP', '3510', '3509', '35038', '35', 'ALVARO DE CARVALHO', NULL, '14', '17410000', '0', '6127', '6127', '21014', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 152.623, '-22,08900', '-49,71900', 627, 'S', 0.7300, NULL, NULL, '35093', 'N', 'N', 171, NULL, '3590', '3590', NULL, '1948', 'S', 4758, 'ÁLVARO DE CARVALHO', 'N', '350140', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '17', NULL, '03', 'N', NULL, NULL, NULL, 96);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350160', '3507', 'SP', '3515', '3507', '35032', '35', 'AMERICANA', NULL, '19', '13465000', '8', '6131', '6131', '21016', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 133.630, '-22,73900', '-47,33100', 545, 'S', 0.8400, NULL, NULL, '35072', 'N', 'N', 195, NULL, '3503', '3503', NULL, '1924', 'S', 4760, 'AMERICANA', 'N', '350160', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '19', NULL, '01', 'N', NULL, NULL, NULL, 515);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350180', '3515', 'SP', '3512', '3501', '35003', '35', 'AMERICO DE CAMPOS', NULL, '17', '15550000', '6', '6135', '6135', '21018', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 253.849, '-20,29900', '-49,73200', 471, 'S', 0.7740, NULL, NULL, '35157', 'N', 'N', 198, NULL, '3590', '3590', NULL, '1948', 'S', 4762, 'AMÉRICO DE CAMPOS', 'N', '350180', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '21', NULL, '03', 'N', NULL, NULL, NULL, 162);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350190', '3507', 'SP', '3515', '3507', '35033', '35', 'AMPARO', NULL, '19', '13900000', '5', '6137', '6137', '21019', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 446.009, '-22,70100', '-46,76400', 674, 'S', 0.8060, NULL, NULL, '35074', 'N', 'N', 203, NULL, '3590', '3590', NULL, '1857', 'S', 4763, 'AMPARO', 'N', '350190', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '22', NULL, '02', 'N', NULL, NULL, NULL, 517);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350200', '3510', 'SP', '3514', '3505', '35025', '35', 'ANALANDIA', NULL, '19', '13550000', '2', '6139', '6139', '21020', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 326.630, '-22,12600', '-47,66300', 675, 'S', 0.8040, NULL, NULL, '35104', 'N', 'N', 212, NULL, '3590', '3590', NULL, '1897', 'S', 4764, 'ANALÂNDIA', 'N', '350200', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '23', NULL, '03', 'N', NULL, NULL, NULL, 43);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350220', '3516', 'SP', '3508', '3511', '35042', '35', 'ANGATUBA', NULL, '15', '18240000', '0', '6143', '6143', '21022', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1028.702, '-23,49000', '-48,41300', 624, 'S', 0.7620, NULL, NULL, '35161', 'N', 'N', 230, NULL, '3590', '3590', NULL, '1885', 'S', 4766, 'ANGATUBA', 'N', '350220', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '25', NULL, '03', 'N', NULL, NULL, NULL, 158);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350240', '3511', 'SP', '3511', '3508', '35036', '35', 'ANHUMAS', NULL, '18', '19580000', '8', '6147', '6147', '21024', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 320.926, '-22,29500', '-51,38700', 422, 'S', 0.7520, NULL, NULL, '35112', 'N', 'N', 244, NULL, '3590', '3590', NULL, '1953', 'S', 4768, 'ANHUMAS', 'N', '350240', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '27', NULL, '03', 'N', NULL, NULL, NULL, 323);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350250', '3517', 'SP', '3517', '3513', '35051', '35', 'APARECIDA', NULL, '12', '12570000', '7', '6149', '6149', '21025', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 120.939, '-22,84700', '-45,23000', 542, 'S', 0.8040, NULL, NULL, '35172', 'N', 'N', 265, NULL, '3590', '3506', NULL, '1928', 'S', 4769, 'APARECIDA', 'N', '350250', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '28', NULL, '03', 'N', NULL, NULL, NULL, 433);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350260', '3515', 'SP', '3512', '3501', '35001', '35', 'APARECIDA D''OESTE', NULL, '17', '15735000', '6', '6151', '6151', '21026', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 179.069, '-20,44900', '-50,88000', 413, 'S', 0.7590, NULL, NULL, '35153', 'N', 'N', 267, NULL, '3590', '3590', NULL, '1928', 'S', 4770, 'APARECIDA D OESTE', 'N', '350260', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '29', NULL, '03', 'N', NULL, NULL, NULL, 436);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350270', '3516', 'SP', '3508', '3511', '35044', '35', 'APIAI', NULL, '15', '18320000', '5', '6153', '6153', '21027', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 968.841, '-24,50900', '-48,84300', 925, 'S', 0.7160, NULL, NULL, '35162', 'N', 'N', 275, NULL, '3590', '3590', NULL, '1771', 'S', 4771, 'APIAÍ', 'N', '350270', 'N', 'N', 'S', NULL, 100, 'N', 'N', 'N', '30', NULL, '03', 'N', NULL, NULL, NULL, 159);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350275', '3516', 'SP', '3508', '3512', '35046', '35', 'ARACARIGUAMA', NULL, '11', '18147000', '4', '3067', '3067', '21589', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 146.331, '-23,43900', '-47,06100', 695, 'S', 0.7700, NULL, NULL, '35163', 'N', 'N', 292, NULL, '3590', '3590', NULL, '1993', 'S', 4772, 'ARAÇARIGUAMA', 'N', '350275', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '31', NULL, '03', 'N', NULL, NULL, NULL, 165);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350290', '3516', 'SP', '3508', '3512', '35046', '35', 'ARACOIABA DA SERRA', NULL, '15', '18190000', '3', '6157', '6157', '21029', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 255.550, '-23,50500', '-47,61400', 625, 'S', 0.7850, NULL, NULL, '35163', 'N', 'N', 301, NULL, '3590', '3590', NULL, '1857', 'S', 4774, 'ARAÇOIABA DA SERRA', 'N', '350290', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '33', NULL, '03', 'N', NULL, NULL, NULL, 165);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350300', '3508', 'SP', '3513', '3502', '35011', '35', 'ARAMINA', NULL, '16', '14550000', '0', '6159', '6159', '21030', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 202.704, '-20,09000', '-47,78600', 614, 'S', 0.7940, NULL, NULL, '35083', 'N', 'N', 323, NULL, '3590', '3590', NULL, '1964', 'S', 4775, 'ARAMINA', 'N', '350300', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '34', NULL, '03', 'N', NULL, NULL, NULL, 272);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350310', '3506', 'SP', '3509', '3504', '35022', '35', 'ARANDU', NULL, '14', '18710000', '9', '6161', '6161', '21031', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 286.328, '-23,13400', '-49,05400', 640, 'S', 0.7310, NULL, NULL, '35061', 'N', 'N', 324, NULL, '3590', '3590', NULL, '1964', 'S', 4776, 'ARANDU', 'N', '350310', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '35', NULL, '03', 'N', NULL, NULL, NULL, 102);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350315', '3517', 'SP', '3517', '3513', '35052', '35', 'ARAPEI', NULL, '12', '12870000', '8', '2991', '2991', '21588', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 155.707, '-22,67400', '-44,44800', 510, 'S', 0.7160, NULL, NULL, '35172', 'N', 'N', 326, NULL, '3590', '3590', NULL, '1993', 'S', 4777, 'ARAPEÍ', 'N', '350315', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '36', NULL, '03', 'N', NULL, NULL, NULL, 433);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350335', '3509', 'SP', '3510', '3509', '35037', '35', 'ARCO-IRIS', NULL, '14', '17630000', '6', '0790', NULL, '21628', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 263.214, '-21,77300', '-50,46500', 419, 'S', 0.7080, NULL, NULL, '35095', 'N', 'N', 358, NULL, '3590', '3590', NULL, '1997', 'S', 4780, 'ARCO-ÍRIS', 'N', '350335', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '39', NULL, '03', 'N', NULL, NULL, NULL, 221);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350350', '3517', 'SP', '3517', '3513', '35052', '35', 'AREIAS', NULL, '12', '12820000', '5', '6169', '6169', '21035', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 306.566, '-22,58000', '-44,69700', 519, 'S', 0.7230, NULL, NULL, '35172', 'N', 'N', 369, NULL, '3590', '3590', NULL, '1816', 'S', 4782, 'AREIAS', 'N', '350350', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '41', NULL, '03', 'N', NULL, NULL, NULL, 433);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350370', '3515', 'SP', '3512', '3501', '35005', '35', 'ARIRANHA', NULL, '17', '15960000', '3', '6173', '6173', '21037', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 133.112, '-21,18800', '-48,78700', 595, 'S', 0.7690, NULL, NULL, '35151', 'N', 'N', 379, NULL, '3590', '3590', NULL, '1918', 'S', 4784, 'ARIRANHA', 'N', '350370', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '43', NULL, '03', 'N', NULL, NULL, NULL, 382);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('211167', '2111', 'MA', '2106', '2103', '21010', '21', 'SAO ROBERTO', NULL, '99', '65758000', '2', '0246', '0246', '09208', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 227.458, '-5,02100', '-44,99100', 100, 'S', 0.5020, NULL, NULL, '21900', 'S', 'N', 4821, NULL, '2190', '2190', NULL, '1997', 'S', 1331, 'SÃO ROBERTO', 'N', '211167', 'S', 'S', 'S', NULL, 140, 'N', 'N', 'N', '193', NULL, '03', 'N', NULL, NULL, NULL, 238);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350395', '3515', 'SP', '3512', '3501', '35001', '35', 'ASPASIA', NULL, '17', '15763000', '0', '2981', '2981', '21590', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 69.394, '-20,15900', '-50,73300', 403, 'S', 0.7380, NULL, NULL, '35153', 'N', 'N', 401, NULL, '3590', '3590', NULL, '1993', 'S', 4787, 'ASPÁSIA', 'N', '350395', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '46', NULL, '03', 'N', NULL, NULL, NULL, 436);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350400', '3509', 'SP', '3510', '3510', '35039', '35', 'ASSIS', NULL, '18', '19800000', '8', '6179', '6179', '21040', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 461.705, '-22,66200', '-50,41200', 546, 'S', 0.8290, NULL, NULL, '35092', 'N', 'N', 404, NULL, '3590', '3590', NULL, '1917', 'S', 4788, 'ASSIS', 'N', '350400', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '47', NULL, '02', 'N', NULL, NULL, NULL, 274);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350410', '3507', 'SP', '3516', '3512', '35048', '35', 'ATIBAIA', NULL, '11', '12940000', '7', '6181', '6181', '21041', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 478.101, '-23,11700', '-46,55000', 803, 'S', 0.8190, NULL, NULL, '35071', 'N', 'N', 417, NULL, '3590', '3501', NULL, '1769', 'S', 4789, 'ATIBAIA', 'N', '350410', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '48', NULL, '01', 'N', NULL, NULL, NULL, 275);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350450', '3506', 'SP', '3509', '3504', '35022', '35', 'AVARE', NULL, '14', '18700970', '3', '6189', '6189', '21045', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1216.640, '-23,09900', '-48,92600', 766, 'S', 0.8060, NULL, NULL, '35061', 'N', 'N', 434, NULL, '3590', '3590', NULL, '1875', 'S', 4793, 'AVARÉ', 'N', '350450', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '52', NULL, '02', 'N', NULL, NULL, NULL, 102);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350460', '3515', 'SP', '3512', '3501', '35004', '35', 'BADY BASSITT', NULL, '17', '15115000', '2', '6191', '6191', '21046', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 109.587, '-20,91800', '-49,44500', 510, 'S', 0.8120, NULL, NULL, '35155', 'N', 'N', 445, NULL, '3590', '3511', NULL, '1959', 'S', 4794, 'BADY BASSITT', 'N', '350460', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '53', NULL, '03', 'N', NULL, NULL, NULL, 392);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350480', '3515', 'SP', '3512', '3501', '35004', '35', 'BALSAMO', NULL, '17', '15140000', '0', '6195', '6195', '21048', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 150.410, '-20,73500', '-49,58400', 545, 'S', 0.8110, NULL, NULL, '35155', 'N', 'N', 466, NULL, '3590', '3590', NULL, '1953', 'S', 4796, 'BÁLSAMO', 'N', '350480', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '55', NULL, '03', 'N', NULL, NULL, NULL, 392);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350490', '3517', 'SP', '3517', '3513', '35052', '35', 'BANANAL', NULL, '12', '12850000', '9', '6197', '6197', '21049', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 616.320, '-22,68400', '-44,32300', 454, 'S', 0.7580, NULL, NULL, '35172', 'N', 'N', 470, NULL, '3590', '3590', NULL, '1832', 'S', 4797, 'BANANAL', 'N', '350490', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '56', NULL, '03', 'N', NULL, NULL, NULL, 433);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350500', '3506', 'SP', '3509', '3511', '35041', '35', 'BARAO DE ANTONINA', NULL, '15', '18490000', '5', '6201', '6201', '21051', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 154.922, '-23,62700', '-49,56100', 559, 'S', 0.7060, NULL, NULL, '35061', 'N', 'N', 481, NULL, '3590', '3590', NULL, '1964', 'S', 4798, 'BARÃO DE ANTONINA', 'N', '350500', 'N', 'N', 'S', NULL, 89, 'N', 'N', 'N', '57', NULL, '03', 'N', NULL, NULL, NULL, 102);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350535', '3516', 'SP', '3508', '3511', '35044', '35', 'BARRA DO CHAPEU', NULL, '15', '18325000', '1', '2997', '2997', '21591', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 407.286, '-24,47300', '-49,02500', 784, 'S', 0.6460, NULL, NULL, '35162', 'S', 'N', 511, NULL, '3590', '3590', NULL, '1993', 'S', 4802, 'BARRA DO CHAPÉU', 'N', '350535', 'N', 'N', 'S', NULL, 100, 'N', 'N', 'N', '61', NULL, '03', 'N', NULL, NULL, NULL, 159);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350540', '3512', 'SP', '3507', '3514', '35055', '35', 'BARRA DO TURVO', NULL, '15', '11955000', '1', '6207', '6207', '21054', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1007.285, '-24,75600', '-48,50500', 158, 'S', 0.6630, NULL, NULL, '35121', 'S', 'N', 524, NULL, '3590', '3590', NULL, '1964', 'S', 4803, 'BARRA DO TURVO', 'N', '350540', 'N', 'N', 'S', NULL, 100, 'N', 'N', 'N', '62', NULL, '03', 'N', NULL, NULL, NULL, 222);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350560', '3513', 'SP', '3514', '3502', '35014', '35', 'BARRINHA', NULL, '16', '14860000', '9', '6211', '6211', '21056', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 146.567, '-21,19400', '-48,16400', 505, 'S', 0.7660, NULL, NULL, '35131', 'N', 'N', 540, NULL, '3590', '3510', NULL, '1953', 'S', 4805, 'BARRINHA', 'N', '350560', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '64', NULL, '03', 'N', NULL, NULL, NULL, 383);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350590', '3513', 'SP', '3514', '3502', '35015', '35', 'BATATAIS', NULL, '16', '14300000', '6', '6217', '6217', '21059', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 850.718, '-20,89100', '-47,58500', 862, 'S', 0.8250, NULL, NULL, '35133', 'N', 'N', 555, NULL, '3590', '3590', NULL, '1839', 'S', 4808, 'BATATAIS', 'N', '350590', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '67', NULL, '02', 'N', NULL, NULL, NULL, 166);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350680', '3506', 'SP', '3509', '3504', '35021', '35', 'BOCAINA', NULL, '14', '17240000', '5', '6235', '6235', '21068', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 364.044, '-22,13600', '-48,51800', 580, 'S', 0.8070, NULL, NULL, '35064', 'N', 'N', 645, NULL, '3590', '3590', NULL, '1891', 'S', 4818, 'BOCAINA', 'N', '350680', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '77', NULL, '03', 'N', NULL, NULL, NULL, 277);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350690', '3506', 'SP', '3509', '3504', '35023', '35', 'BOFETE', NULL, '14', '18590000', '4', '6237', '6237', '21069', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 653.360, '-23,10200', '-48,25800', 576, 'S', 0.7910, NULL, NULL, '35063', 'N', 'N', 654, NULL, '3590', '3590', NULL, '1880', 'S', 4819, 'BOFETE', 'N', '350690', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '78', NULL, '03', 'N', NULL, NULL, NULL, 384);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350700', '3516', 'SP', '3508', '3511', '35043', '35', 'BOITUVA', NULL, '15', '18550000', '1', '6239', '6239', '21070', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 249.014, '-23,28300', '-47,67200', 637, 'S', 0.7980, NULL, NULL, '35163', 'N', 'N', 655, NULL, '3590', '3590', NULL, '1937', 'S', 4820, 'BOITUVA', 'N', '350700', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '79', NULL, '03', 'N', NULL, NULL, NULL, 165);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350710', '3507', 'SP', '3516', '3512', '35048', '35', 'BOM JESUS DOS PERDOES', NULL, '11', '12955000', '0', '6241', '6241', '21071', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 108.513, '-23,13500', '-46,46500', 770, 'S', 0.7800, NULL, NULL, '35071', 'N', 'N', 682, NULL, '3590', '3590', NULL, '1958', 'S', 4821, 'BOM JESUS DOS PERDÕES', 'N', '350710', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '80', NULL, '03', 'N', NULL, NULL, NULL, 275);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350715', '3516', 'SP', '3508', '3511', '35041', '35', 'BOM SUCESSO DE ITARARE', NULL, '15', '18475000', '9', '3059', '3059', '21593', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 133.221, '-24,31800', '-49,14400', 950, 'S', 0.6930, NULL, NULL, '35162', 'S', 'N', 693, NULL, '3590', '3590', NULL, '1993', 'S', 4822, 'BOM SUCESSO DE ITARARÉ', 'N', '350715', 'N', 'N', 'S', NULL, 89, 'N', 'N', 'N', '81', NULL, '03', 'N', NULL, NULL, NULL, 159);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350720', '3509', 'SP', '3510', '3510', '35039', '35', 'BORA', NULL, '18', '19740000', '9', '6243', '6243', '21072', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 118.669, '-22,27000', '-50,53400', 582, 'S', 0.7940, NULL, NULL, '35092', 'N', 'N', 714, NULL, '3590', '3590', NULL, '1964', 'S', 4823, 'BORÁ', 'N', '350720', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '82', NULL, '03', 'N', NULL, NULL, NULL, 274);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350730', '3506', 'SP', '3509', '3504', '35021', '35', 'BORACEIA', NULL, '14', '17270000', '8', '6245', '6245', '21073', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 120.796, '-22,19300', '-48,77900', 480, 'S', 0.7830, NULL, NULL, '35064', 'N', 'N', 715, NULL, '3590', '3590', NULL, '1959', 'S', 4824, 'BORACÉIA', 'N', '350730', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '83', NULL, '03', 'N', NULL, NULL, NULL, 277);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350740', '3503', 'SP', '3513', '3505', '35024', '35', 'BORBOREMA', NULL, '16', '14955000', '7', '6247', '6247', '21074', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 552.604, '-21,62000', '-49,07400', 429, 'S', 0.7710, NULL, NULL, '35032', 'N', 'N', 717, NULL, '3590', '3590', NULL, '1925', 'S', 4825, 'BORBOREMA', 'N', '350740', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '84', NULL, '03', 'N', NULL, NULL, NULL, 325);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350745', '3506', 'SP', '3509', '3504', '35020', '35', 'BOREBI', NULL, '14', '18675000', '6', '7247', '7247', '21575', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 348.116, '-22,56900', '-48,97100', 590, 'S', 0.7460, NULL, NULL, '35062', 'N', 'N', 720, NULL, '3590', '3590', NULL, '1993', 'S', 4826, 'BOREBI', 'N', '350745', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '85', NULL, '03', 'N', NULL, NULL, NULL, 214);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350750', '3506', 'SP', '3509', '3504', '35023', '35', 'BOTUCATU', NULL, '14', '18603970', '6', '6249', '6249', '21075', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1482.874, '-22,88600', '-48,44500', 804, 'S', 0.8220, NULL, NULL, '35063', 'N', 'N', 724, NULL, '3590', '3590', NULL, '1855', 'S', 4827, 'BOTUCATU', 'N', '350750', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '86', NULL, '01', 'N', NULL, NULL, NULL, 384);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350760', '3507', 'SP', '3516', '3512', '35048', '35', 'BRAGANCA PAULISTA', NULL, '11', '12900000', '5', '6251', '6251', '21076', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 513.589, '-22,95200', '-46,54200', 817, 'S', 0.8200, NULL, NULL, '35071', 'N', 'N', 732, NULL, '3590', '3590', NULL, '1797', 'S', 4828, 'BRAGANÇA PAULISTA', 'N', '350760', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '87', NULL, '01', 'N', NULL, NULL, NULL, 275);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350770', '3502', 'SP', '3512', '3503', '35018', '35', 'BRAUNA', NULL, '18', '16290000', '4', '6255', '6255', '21078', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 195.516, '-21,49900', '-50,31600', 401, 'S', 0.7960, NULL, NULL, '35023', 'N', 'N', 747, NULL, '3590', '3590', NULL, '1953', 'S', 4829, 'BRAÚNA', 'N', '350770', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '88', NULL, '03', 'N', NULL, NULL, NULL, 157);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350775', '3502', 'SP', '3512', '3503', '35018', '35', 'BREJO ALEGRE', NULL, '18', '16265000', '3', '0792', NULL, '21629', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 104.832, '-21,16600', '-50,18500', 390, 'S', 0.7480, NULL, NULL, '35023', 'N', 'N', 756, NULL, '3590', '3590', NULL, '1997', 'S', 4830, 'BREJO ALEGRE', 'N', '350775', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '89', NULL, '03', 'N', NULL, NULL, NULL, 157);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350780', '3513', 'SP', '3514', '3502', '35014', '35', 'BRODOWSKI', NULL, '16', '14340000', '3', '6257', '6257', '21079', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 279.804, '-20,99100', '-47,65900', 861, 'S', 0.8050, NULL, NULL, '35133', 'N', 'N', 771, NULL, '3590', '3590', NULL, '1913', 'S', 4831, 'BRODOWSKI', 'N', '350780', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '90', NULL, '03', 'N', NULL, NULL, NULL, 166);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350790', '3506', 'SP', '3509', '3506', '35026', '35', 'BROTAS', NULL, '14', '17380000', '2', '6259', '6259', '21080', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1101.468, '-22,28400', '-48,12700', 647, 'S', 0.8170, NULL, NULL, '35064', 'N', 'N', 772, NULL, '3590', '3590', NULL, '1859', 'S', 4832, 'BROTAS', 'N', '350790', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '91', NULL, '03', 'N', NULL, NULL, NULL, 277);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350820', '3508', 'SP', '3513', '3502', '35011', '35', 'BURITIZAL', NULL, '16', '14570000', '7', '6265', '6265', '21083', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 266.271, '-20,19100', '-47,70800', 855, 'S', 0.7770, NULL, NULL, '35083', 'N', 'N', 801, NULL, '3590', '3590', NULL, '1953', 'S', 4835, 'BURITIZAL', 'N', '350820', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '94', NULL, '03', 'N', NULL, NULL, NULL, 272);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220030', '2204', 'PI', '2203', '2202', '22004', '22', 'ALTO LONGA', NULL, '86', '64360000', '1', '1005', '1005', '16003', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1621.354, '-5,25100', '-42,21000', 170, 'S', 0.5800, NULL, NULL, '22900', 'S', 'N', 153, NULL, '2290', '2290', NULL, '1938', 'S', 2968, 'ALTO LONGÁ', 'N', '220030', 'N', 'S', 'S', NULL, 45, 'S', 'N', 'N', '6', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220040', '2204', 'PI', '2203', '2202', '22003', '22', 'ALTOS', NULL, '86', '64290000', '0', '1007', '1007', '16004', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 957.617, '-5,03900', '-42,46100', 180, 'S', 0.6180, NULL, NULL, '22900', 'N', 'N', 165, NULL, '2201', '2290', NULL, '1922', 'S', 2969, 'ALTOS', 'N', '220040', 'N', 'S', 'S', NULL, 45, 'S', 'N', 'S', '7', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220045', '2211', 'PI', '2206', '2203', '22010', '22', 'ALVORADA DO GURGUEIA', NULL, '89', '64923000', '9', '0268', '0268', '16152', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 2131.942, '-8,42400', '-43,77700', 281, 'S', 0.5740, NULL, NULL, '22900', 'S', 'N', 178, NULL, '2290', '2290', NULL, '1997', 'S', 2970, 'ALVORADA DO GURGUÉIA', 'N', '220045', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '8', NULL, '03', 'N', NULL, NULL, NULL, 199);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220050', '2204', 'PI', '2203', '2202', '22005', '22', 'AMARANTE', NULL, '86', '64400000', '9', '1009', '1009', '16005', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1304.775, '-6,24100', '-42,85500', 104, 'S', 0.6300, NULL, NULL, '22900', 'S', 'N', 189, NULL, '2290', '2290', NULL, '1871', 'S', 2971, 'AMARANTE', 'N', '220050', 'N', 'S', 'S', NULL, 45, 'S', 'N', 'N', '9', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350840', '3507', 'SP', '3516', '3512', '35046', '35', 'CABREUVA', NULL, '11', '13315000', '5', '6269', '6269', '21085', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 259.807, '-23,30800', '-47,13300', 650, 'S', 0.7740, NULL, NULL, '35073', 'N', 'N', 819, NULL, '3504', '3501', NULL, '1859', 'S', 4837, 'CABREÚVA', 'N', '350840', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '96', NULL, '03', 'N', NULL, NULL, NULL, 41);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350850', '3517', 'SP', '3517', '3513', '35050', '35', 'CACAPAVA', NULL, '12', '12280000', '4', '6271', '6271', '21086', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 369.907, '-23,10100', '-45,70700', 560, 'S', 0.8340, NULL, NULL, '35171', 'N', 'N', 822, NULL, '3590', '3512', NULL, '1855', 'S', 4838, 'CAÇAPAVA', 'N', '350850', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '97', NULL, '02', 'N', NULL, NULL, NULL, 324);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350860', '3517', 'SP', '3517', '3513', '35051', '35', 'CACHOEIRA PAULISTA', NULL, '12', '12630000', '3', '6273', '6273', '21087', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 287.837, '-22,66500', '-45,00900', 521, 'S', 0.7940, NULL, NULL, '35172', 'N', 'N', 840, NULL, '3590', '3506', NULL, '1880', 'S', 4839, 'CACHOEIRA PAULISTA', 'N', '350860', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '98', NULL, '03', 'N', NULL, NULL, NULL, 433);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350870', '3514', 'SP', '3515', '3507', '35030', '35', 'CACONDE', NULL, '19', '13770000', '2', '6275', '6275', '21088', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 470.487, '-21,52900', '-46,64400', 780, 'S', 0.7820, NULL, NULL, '35143', 'N', 'N', 852, NULL, '3590', '3590', NULL, '1864', 'S', 4840, 'CACONDE', 'N', '350870', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '99', NULL, '03', 'N', NULL, NULL, NULL, 279);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350890', '3511', 'SP', '3511', '3508', '35036', '35', 'CAIABU', NULL, '18', '19530000', '0', '6279', '6279', '21090', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 251.949, '-22,01200', '-51,23600', 520, 'S', 0.7790, NULL, NULL, '35112', 'N', 'N', 866, NULL, '3590', '3590', NULL, '1953', 'S', 4842, 'CAIABU', 'N', '350890', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '101', NULL, '03', 'N', NULL, NULL, NULL, 323);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350910', '3511', 'SP', '3511', '3508', '35036', '35', 'CAIUA', NULL, '18', '19450000', '6', '6283', '6283', '21092', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 535.522, '-21,83200', '-51,99800', 375, 'S', 0.7100, NULL, NULL, '35114', 'N', 'N', 878, NULL, '3590', '3590', NULL, '1953', 'S', 4844, 'CAIUÁ', 'N', '350910', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '103', NULL, '03', 'N', NULL, NULL, NULL, 435);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350925', '3512', 'SP', '3507', '3514', '35055', '35', 'CAJATI', NULL, '13', '11950000', '4', '2967', '2967', '21594', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 454.925, '-24,73600', '-48,12300', 75, 'S', 0.7510, NULL, NULL, '35121', 'N', 'N', 882, NULL, '3590', '3590', NULL, '1993', 'S', 4846, 'CAJATI', 'N', '350925', 'N', 'N', 'S', NULL, 100, 'N', 'N', 'N', '105', NULL, '03', 'N', NULL, NULL, NULL, 222);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350940', '3513', 'SP', '3514', '3502', '35015', '35', 'CAJURU', NULL, '16', '14240000', '3', '6289', '6289', '21095', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 660.687, '-21,27500', '-47,30400', 775, 'S', 0.7830, NULL, NULL, '35133', 'N', 'N', 890, NULL, '3590', '3590', NULL, '1865', 'S', 4848, 'CAJURU', 'N', '350940', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '107', NULL, '03', 'N', NULL, NULL, NULL, 166);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350945', '3516', 'SP', '3508', '3511', '35042', '35', 'CAMPINA DO MONTE ALEGRE', NULL, '15', '18245000', '2', '2999', '2999', '21595', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 184.077, '-23,59200', '-48,47700', 612, 'S', 0.7420, NULL, NULL, '35161', 'N', 'N', 932, NULL, '3590', '3590', NULL, '1993', 'S', 4849, 'CAMPINA DO MONTE ALEGRE', 'N', '350945', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '108', NULL, '03', 'N', NULL, NULL, NULL, 158);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350950', '3507', 'SP', '3515', '3507', '35032', '35', 'CAMPINAS', NULL, '19', '13001970', '2', '6291', '6291', '21096', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 795.697, '-22,90600', '-47,06100', 854, 'S', 0.8520, NULL, NULL, '35072', 'N', 'N', 939, NULL, '3503', '3503', NULL, '1797', 'S', 4850, 'CAMPINAS', 'N', '350950', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '109', NULL, '01', 'N', NULL, NULL, NULL, 515);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350960', '3507', 'SP', '3516', '3512', '35047', '35', 'CAMPO LIMPO PAULISTA', NULL, '11', '13230000', '1', '6293', '6293', '21097', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 80.048, '-23,20600', '-46,78400', 745, 'S', 0.8050, NULL, NULL, '35073', 'N', 'N', 965, NULL, '3504', '3507', NULL, '1964', 'S', 4851, 'CAMPO LIMPO PAULISTA', 'N', '350960', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '110', NULL, '02', 'N', NULL, NULL, NULL, 41);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350980', '3509', 'SP', '3510', '3510', '35039', '35', 'CAMPOS NOVOS PAULISTA', NULL, '14', '19960000', '9', '6297', '6297', '21099', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 484.577, '-22,60300', '-50,00300', 446, 'S', 0.7610, NULL, NULL, '35093', 'N', 'N', 983, NULL, '3590', '3590', NULL, '1948', 'S', 4853, 'CAMPOS NOVOS PAULISTA', 'N', '350980', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '112', NULL, '03', 'N', NULL, NULL, NULL, 96);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350990', '3512', 'SP', '3507', '3514', '35055', '35', 'CANANEIA', NULL, '13', '11990000', '8', '6299', '6299', '21100', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1242.010, '-25,01500', '-47,92700', 8, 'S', 0.7750, NULL, NULL, '35121', 'N', 'N', 991, NULL, '3590', '3590', NULL, '1600', 'S', 4854, 'CANANÉIA', 'N', '350990', 'N', 'N', 'S', NULL, 100, 'N', 'N', 'N', '113', NULL, '03', 'N', NULL, NULL, NULL, 222);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350995', '3517', 'SP', '3517', '3513', '35051', '35', 'CANAS', NULL, '12', '12615000', '7', '0794', NULL, '21630', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 53.494, '-22,70400', '-45,05500', 530, 'S', 0.7530, NULL, NULL, '35172', 'N', 'N', 997, NULL, '3590', '3506', NULL, '1997', 'S', 4855, 'CANAS', 'N', '350995', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '114', NULL, '03', 'N', NULL, NULL, NULL, 433);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351000', '3509', 'SP', '3510', '3510', '35039', '35', 'CANDIDO MOTA', NULL, '18', '19880000', '5', '6301', '6301', '21101', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 596.290, '-22,74600', '-50,38700', 479, 'S', 0.7900, NULL, NULL, '35092', 'N', 'N', 1009, NULL, '3590', '3590', NULL, '1923', 'S', 4856, 'CÂNDIDO MOTA', 'N', '351000', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '115', NULL, '03', 'N', NULL, NULL, NULL, 274);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351020', '3516', 'SP', '3508', '3511', '35044', '35', 'CAPAO BONITO', NULL, '15', '18300000', '3', '6305', '6305', '21103', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1641.043, '-24,00600', '-48,34900', 705, 'S', 0.7160, NULL, NULL, '35161', 'N', 'N', 1037, NULL, '3590', '3590', NULL, '1857', 'S', 4859, 'CAPÃO BONITO', 'N', '351020', 'N', 'N', 'S', NULL, 89, 'N', 'N', 'N', '118', NULL, '03', 'N', NULL, NULL, NULL, 158);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351030', '3516', 'SP', '3508', '3512', '35046', '35', 'CAPELA DO ALTO', NULL, '15', '18195000', '2', '6307', '6307', '21104', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 169.981, '-23,47100', '-47,73500', 625, 'S', 0.7480, NULL, NULL, '35163', 'N', 'N', 1044, NULL, '3590', '3590', NULL, '1964', 'S', 4860, 'CAPELA DO ALTO', 'N', '351030', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '119', NULL, '03', 'N', NULL, NULL, NULL, 165);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351040', '3510', 'SP', '3514', '3506', '35028', '35', 'CAPIVARI', NULL, '19', '13360000', '1', '6309', '6309', '21105', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 323.198, '-22,99500', '-47,50800', 636, 'S', 0.8030, NULL, NULL, '35103', 'N', 'N', 1064, NULL, '3590', '3590', NULL, '1832', 'S', 4861, 'CAPIVARI', 'N', '351040', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '120', NULL, '03', 'N', NULL, NULL, NULL, 100);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351050', '3517', 'SP', '3517', '3513', '35054', '35', 'CARAGUATATUBA', NULL, '12', '11660970', '0', '6311', '6311', '21106', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 483.950, '-23,62000', '-45,41300', 2, 'S', 0.8020, NULL, NULL, '35173', 'N', 'N', 1074, NULL, '3590', '3590', NULL, '1857', 'S', 4862, 'CARAGUATATUBA', 'N', '351050', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '121', NULL, '02', 'N', NULL, NULL, NULL, 437);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351070', '3515', 'SP', '3512', '3501', '35003', '35', 'CARDOSO', NULL, '17', '15570000', '8', '6315', '6315', '21108', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 637.571, '-20,08200', '-49,91400', 422, 'S', 0.7560, NULL, NULL, '35157', 'N', 'N', 1092, NULL, '3590', '3590', NULL, '1948', 'S', 4864, 'CARDOSO', 'N', '351070', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '123', NULL, '03', 'N', NULL, NULL, NULL, 162);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351080', '3514', 'SP', '3515', '3507', '35030', '35', 'CASA BRANCA', NULL, '19', '13700000', '7', '6317', '6317', '21109', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 865.544, '-21,77400', '-47,08600', 684, 'S', 0.8100, NULL, NULL, '35143', 'N', 'N', 1140, NULL, '3590', '3590', NULL, '1841', 'S', 4865, 'CASA BRANCA', 'N', '351080', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '124', NULL, '03', 'N', NULL, NULL, NULL, 279);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351090', '3513', 'SP', '3514', '3502', '35015', '35', 'CASSIA DOS COQUEIROS', NULL, '16', '14260000', '6', '6319', '6319', '21110', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 190.916, '-21,28300', '-47,17000', 890, 'S', 0.7960, NULL, NULL, '35133', 'N', 'N', 1153, NULL, '3590', '3590', NULL, '1959', 'S', 4866, 'CÁSSIA DOS COQUEIROS', 'N', '351090', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '125', NULL, '03', 'N', NULL, NULL, NULL, 166);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351110', '3515', 'SP', '3512', '3501', '35005', '35', 'CATANDUVA', NULL, '17', '15800000', '2', '6323', '6323', '21112', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 292.240, '-21,13800', '-48,97300', 503, 'S', 0.8330, NULL, NULL, '35151', 'N', 'N', 1166, NULL, '3590', '3590', NULL, '1917', 'S', 4868, 'CATANDUVA', 'N', '351110', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '127', NULL, '01', 'N', NULL, NULL, NULL, 382);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351120', '3515', 'SP', '3512', '3501', '35005', '35', 'CATIGUA', NULL, '17', '15870000', '1', '6325', '6325', '21113', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 145.431, '-21,04900', '-49,05800', 483, 'S', 0.7870, NULL, NULL, '35151', 'N', 'N', 1173, NULL, '3590', '3590', NULL, '1959', 'S', 4869, 'CATIGUÁ', 'N', '351120', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '128', NULL, '03', 'N', NULL, NULL, NULL, 382);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220198', '2209', 'PI', '2203', '2203', '22011', '22', 'BREJO DO PIAUI', NULL, '89', '64895000', '8', '0284', NULL, '16160', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 2212.932, '-8,21400', '-42,82600', 297, 'S', 0.5470, NULL, NULL, '22900', 'S', 'N', 760, NULL, '2290', '2290', NULL, '1997', 'S', 2997, 'BREJO DO PIAUÍ', 'N', '220198', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '36', NULL, '03', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220200', '2201', 'PI', '2201', '2201', '22002', '22', 'BURITI DOS LOPES', NULL, '86', '64230000', '0', '1039', '1039', '16020', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 691.363, '-3,17500', '-41,86700', 50, 'S', 0.5640, NULL, NULL, '22900', 'S', 'N', 793, NULL, '2290', '2290', NULL, '1938', 'S', 2998, 'BURITI DOS LOPES', 'N', '220200', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '37', NULL, '03', 'N', NULL, NULL, NULL, 365);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220202', '2203', 'PI', '2202', '2202', '22004', '22', 'BURITI DOS MONTES', NULL, '86', '64345000', '6', '1297', '1297', '16127', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 2652.103, '-5,31200', '-41,09800', 500, 'S', 0.5600, NULL, NULL, '22900', 'S', 'N', 794, NULL, '2290', '2290', NULL, '1993', 'S', 2999, 'BURITI DOS MONTES', 'N', '220202', 'N', 'S', 'S', NULL, 28, 'S', 'N', 'N', '38', NULL, '03', 'N', NULL, NULL, NULL, 422);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220205', '2203', 'PI', '2202', '2201', '22001', '22', 'CABECEIRAS DO PIAUI', NULL, '86', '64105000', '9', '1299', '1299', '16128', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 608.505, '-4,47600', '-42,30900', 0, 'S', 0.5250, NULL, NULL, '22900', 'S', 'N', 812, NULL, '2290', '2290', NULL, '1993', 'S', 3000, 'CABECEIRAS DO PIAUÍ', 'N', '220205', 'N', 'S', 'S', NULL, 28, 'S', 'N', 'N', '39', NULL, '03', 'N', NULL, NULL, NULL, 422);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220207', '2207', 'PI', '2204', '2204', '22013', '22', 'CAJAZEIRAS DO PIAUI', NULL, '89', '64514000', '5', '0286', NULL, '16161', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 555.553, '-6,76600', '-42,39200', 157, 'S', 0.5710, NULL, NULL, '22900', 'S', 'N', 884, NULL, '2290', '2290', NULL, '1997', 'S', 3001, 'CAJAZEIRAS DO PIAUÍ', 'N', '220207', 'N', 'S', 'S', NULL, 133, 'N', 'N', 'N', '40', NULL, '03', 'N', NULL, NULL, NULL, 75);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220208', '2201', 'PI', '2201', '2201', '22002', '22', 'CAJUEIRO DA PRAIA', NULL, '86', '64222000', '3', '0288', NULL, '16162', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 271.348, '-2,92800', '-41,33600', 10, 'S', 0.5630, NULL, NULL, '22900', 'S', 'N', 888, NULL, '2290', '2290', NULL, '1997', 'S', 3002, 'CAJUEIRO DA PRAIA', 'N', '220208', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '41', NULL, '03', 'N', NULL, NULL, NULL, 365);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351130', '3515', 'SP', '3512', '3501', '35004', '35', 'CEDRAL', NULL, '17', '15895000', '0', '6327', '6327', '21114', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 197.619, '-20,90300', '-49,26800', 558, 'S', 0.8030, NULL, NULL, '35155', 'N', 'N', 1193, NULL, '3590', '3590', NULL, '1929', 'S', 4870, 'CEDRAL', 'N', '351130', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '129', NULL, '03', 'N', NULL, NULL, NULL, 392);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351140', '3506', 'SP', '3509', '3504', '35022', '35', 'CERQUEIRA CESAR', NULL, '14', '18760000', '9', '6329', '6329', '21115', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 503.640, '-23,03600', '-49,16600', 737, 'S', 0.7640, NULL, NULL, '35061', 'N', 'N', 1211, NULL, '3590', '3590', NULL, '1917', 'S', 4871, 'CERQUEIRA CÉSAR', 'N', '351140', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '130', NULL, '03', 'N', NULL, NULL, NULL, 102);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351150', '3516', 'SP', '3508', '3511', '35043', '35', 'CERQUILHO', NULL, '15', '18520000', '8', '6331', '6331', '21116', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 127.758, '-23,16500', '-47,74400', 595, 'S', 0.8250, NULL, NULL, '35161', 'N', 'N', 1212, NULL, '3590', '3590', NULL, '1948', 'S', 4872, 'CERQUILHO', 'N', '351150', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '131', NULL, '03', 'N', NULL, NULL, NULL, 158);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351160', '3516', 'SP', '3508', '3511', '35043', '35', 'CESARIO LANGE', NULL, '15', '18285000', '7', '6333', '6333', '21117', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 190.189, '-23,22700', '-47,95300', 590, 'S', 0.7670, NULL, NULL, '35161', 'N', 'N', 1221, NULL, '3590', '3590', NULL, '1959', 'S', 4873, 'CESÁRIO LANGE', 'N', '351160', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '132', NULL, '03', 'N', NULL, NULL, NULL, 158);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351170', '3510', 'SP', '3514', '3506', '35028', '35', 'CHARQUEADA', NULL, '19', '13515000', '6', '6335', '6335', '21118', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 175.998, '-22,51000', '-47,77800', 610, 'S', 0.7820, NULL, NULL, '35103', 'N', 'N', 1240, NULL, '3590', '3590', NULL, '1953', 'S', 4874, 'CHARQUEADA', 'N', '351170', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '133', NULL, '03', 'N', NULL, NULL, NULL, 100);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351220', '3510', 'SP', '3514', '3506', '35027', '35', 'CONCHAL', NULL, '19', '13835000', '9', '6345', '6345', '21123', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 183.826, '-22,33000', '-47,17300', 591, 'S', 0.7700, NULL, NULL, '35101', 'N', 'N', 1329, NULL, '3590', '3590', NULL, '1948', 'S', 4879, 'CONCHAL', 'N', '351220', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '138', NULL, '03', 'N', NULL, NULL, NULL, 155);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351240', '3510', 'SP', '3514', '3506', '35027', '35', 'CORDEIROPOLIS', NULL, '19', '13490000', '7', '6349', '6349', '21125', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 137.337, '-22,48200', '-47,45700', 668, 'S', 0.8350, NULL, NULL, '35102', 'N', 'N', 1363, NULL, '3590', '3508', NULL, '1948', 'S', 4881, 'CORDEIRÓPOLIS', 'N', '351240', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '140', NULL, '03', 'N', NULL, NULL, NULL, 327);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351260', '3506', 'SP', '3509', '3511', '35041', '35', 'CORONEL MACEDO', NULL, '14', '18745000', '5', '6353', '6353', '21127', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 304.505, '-23,63100', '-49,31400', 624, 'S', 0.7110, NULL, NULL, '35061', 'N', 'N', 1387, NULL, '3590', '3590', NULL, '1964', 'S', 4883, 'CORONEL MACEDO', 'N', '351260', 'N', 'N', 'S', NULL, 89, 'N', 'N', 'N', '142', NULL, '03', 'N', NULL, NULL, NULL, 102);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351270', '3510', 'SP', '3514', '3506', '35026', '35', 'CORUMBATAI', NULL, '19', '13540000', '4', '6355', '6355', '21128', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 278.143, '-22,22000', '-47,62600', 608, 'S', 0.7800, NULL, NULL, '35104', 'N', 'N', 1407, NULL, '3590', '3590', NULL, '1948', 'S', 4884, 'CORUMBATAÍ', 'N', '351270', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '143', NULL, '03', 'N', NULL, NULL, NULL, 43);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351280', '3507', 'SP', '3515', '3507', '35032', '35', 'COSMOPOLIS', NULL, '19', '13150000', '3', '6357', '6357', '21129', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 154.730, '-22,64600', '-47,19600', 652, 'S', 0.7990, NULL, NULL, '35072', 'N', 'N', 1412, NULL, '3503', '3503', NULL, '1944', 'S', 4885, 'COSMÓPOLIS', 'N', '351280', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '144', NULL, '01', 'N', NULL, NULL, NULL, 515);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351290', '3515', 'SP', '3512', '3501', '35003', '35', 'COSMORAMA', NULL, '17', '15530000', '2', '6359', '6359', '21130', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 441.326, '-20,47800', '-49,77800', 540, 'S', 0.7550, NULL, NULL, '35157', 'N', 'N', 1413, NULL, '3590', '3590', NULL, '1948', 'S', 4886, 'COSMORAMA', 'N', '351290', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '145', NULL, '03', 'N', NULL, NULL, NULL, 162);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351310', '3513', 'SP', '3514', '3502', '35014', '35', 'CRAVINHOS', NULL, '16', '14140000', '8', '6363', '6363', '21132', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 311.341, '-21,34000', '-47,72900', 788, 'S', 0.8150, NULL, NULL, '35132', 'N', 'N', 1428, NULL, '3590', '3510', NULL, '1897', 'S', 4888, 'CRAVINHOS', 'N', '351310', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '147', NULL, '03', 'N', NULL, NULL, NULL, 273);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351320', '3508', 'SP', '3513', '3502', '35012', '35', 'CRISTAIS PAULISTA', NULL, '16', '14460000', '7', '6365', '6365', '21133', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 385.460, '-20,39700', '-47,42000', 996, 'S', 0.7710, NULL, NULL, '35081', 'N', 'N', 1435, NULL, '3590', '3590', NULL, '1959', 'S', 4889, 'CRISTAIS PAULISTA', 'N', '351320', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '148', NULL, '03', 'N', NULL, NULL, NULL, 101);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351330', '3509', 'SP', '3510', '3510', '35039', '35', 'CRUZALIA', NULL, '18', '19860000', '6', '6367', '6367', '21134', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 149.173, '-22,67700', '-50,79400', 318, 'S', 0.7860, NULL, NULL, '35092', 'N', 'N', 1458, NULL, '3590', '3590', NULL, '1964', 'S', 4890, 'CRUZÁLIA', 'N', '351330', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '149', NULL, '03', 'N', NULL, NULL, NULL, 274);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351340', '3517', 'SP', '3517', '3513', '35051', '35', 'CRUZEIRO', NULL, '12', '12700000', '5', '6369', '6369', '21135', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 304.572, '-22,57600', '-44,96300', 517, 'S', 0.8090, NULL, NULL, '35172', 'N', 'N', 1459, NULL, '3590', '3590', NULL, '1871', 'S', 4891, 'CRUZEIRO', 'N', '351340', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '150', NULL, '02', 'N', NULL, NULL, NULL, 433);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351360', '3517', 'SP', '3517', '3513', '35053', '35', 'CUNHA', NULL, '12', '12530000', '3', '6373', '6373', '21137', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1407.172, '-23,07400', '-44,96000', 950, 'S', 0.7330, NULL, NULL, '35172', 'N', 'N', 1480, NULL, '3590', '3590', NULL, '1785', 'S', 4893, 'CUNHA', 'N', '351360', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '152', NULL, '03', 'N', NULL, NULL, NULL, 433);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351370', '3503', 'SP', '3513', '3505', '35025', '35', 'DESCALVADO', NULL, '19', '13690000', '2', '6375', '6375', '21138', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 755.226, '-21,90400', '-47,61900', 679, 'S', 0.8200, NULL, NULL, '35034', 'N', 'N', 1523, NULL, '3590', '3590', NULL, '1865', 'S', 4894, 'DESCALVADO', 'N', '351370', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '153', NULL, '03', 'N', NULL, NULL, NULL, 434);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351380', '3501', 'SP', '3501', '3515', '35061', '35', 'DIADEMA', NULL, '11', '09901970', '1', '6377', '6377', '21139', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 30.650, '-23,68600', '-46,62300', 780, 'S', 0.7900, NULL, NULL, '35015', 'N', 'N', 1530, NULL, '3501', '3501', NULL, '1959', 'S', 4895, 'DIADEMA', 'N', '351380', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '154', NULL, '01', 'N', NULL, NULL, NULL, 94);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351385', '3515', 'SP', '3512', '3501', '35001', '35', 'DIRCE REIS', NULL, '17', '15715000', '0', '7249', '7249', '21576', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 88.400, '-20,46600', '-50,60600', 402, 'S', 0.7370, NULL, NULL, '35153', 'N', 'N', 1544, NULL, '3590', '3590', NULL, '1993', 'S', 4896, 'DIRCE REIS', 'N', '351385', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '155', NULL, '03', 'N', NULL, NULL, NULL, 436);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351390', '3514', 'SP', '3515', '3507', '35030', '35', 'DIVINOLANDIA', NULL, '19', '13780000', '0', '6379', '6379', '21140', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 222.257, '-21,66100', '-46,73900', 1040, 'S', 0.7880, NULL, NULL, '35143', 'N', 'N', 1551, NULL, '3590', '3590', NULL, '1953', 'S', 4897, 'DIVINOLÂNDIA', 'N', '351390', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '156', NULL, '03', 'N', NULL, NULL, NULL, 279);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351420', '3515', 'SP', '3512', '3501', '35001', '35', 'DOLCINOPOLIS', NULL, '17', '15740000', '5', '6385', '6385', '21143', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 78.144, '-20,12300', '-50,51300', 463, 'S', 0.7600, NULL, NULL, '35153', 'N', 'N', 1568, NULL, '3590', '3590', NULL, '1959', 'S', 4900, 'DOLCINÓPOLIS', 'N', '351420', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '159', NULL, '03', 'N', NULL, NULL, NULL, 436);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351430', '3503', 'SP', '3513', '3505', '35025', '35', 'DOURADO', NULL, '16', '13590000', '4', '6387', '6387', '21144', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 205.981, '-22,10000', '-48,31800', 706, 'S', 0.7800, NULL, NULL, '35034', 'N', 'N', 1599, NULL, '3590', '3590', NULL, '1897', 'S', 4901, 'DOURADO', 'N', '351430', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '160', NULL, '03', 'N', NULL, NULL, NULL, 434);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220270', '2201', 'PI', '2201', '2201', '22002', '22', 'COCAL', NULL, '86', '64235000', '3', '1053', '1053', '16027', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1269.066, '-3,47100', '-41,55500', 160, 'S', 0.5400, NULL, NULL, '22900', 'S', 'N', 1272, NULL, '2290', '2290', NULL, '1947', 'S', 3018, 'COCAL', 'N', '220270', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '57', NULL, '03', 'N', NULL, NULL, NULL, 365);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220271', '2203', 'PI', '2202', '2202', '22004', '22', 'COCAL DE TELHA', NULL, '86', '64278000', '1', '0304', NULL, '16170', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 322.103, '-4,55900', '-41,97200', 140, 'S', 0.5970, NULL, NULL, '22900', 'S', 'N', 1273, NULL, '2290', '2290', NULL, '1997', 'S', 3019, 'COCAL DE TELHA', 'N', '220271', 'N', 'S', 'S', NULL, 28, 'N', 'N', 'N', '58', NULL, '03', 'N', NULL, NULL, NULL, 422);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220272', '2201', 'PI', '2201', '2201', '22002', '22', 'COCAL DOS ALVES', NULL, '86', '64238000', '9', '0306', NULL, '16171', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 358.104, '-3,72900', '-41,44900', 100, 'S', 0.5090, NULL, NULL, '22900', 'S', 'N', 1275, NULL, '2290', '2290', NULL, '1997', 'S', 3020, 'COCAL DOS ALVES', 'N', '220272', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '59', NULL, '03', 'N', NULL, NULL, NULL, 365);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220273', '2204', 'PI', '2203', '2202', '22003', '22', 'COIVARAS', NULL, '86', '64335000', '7', '0995', '0995', '16131', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 506.719, '-5,09400', '-42,20700', 190, 'S', 0.5870, NULL, NULL, '22900', 'S', 'N', 1284, NULL, '2201', '2290', NULL, '1993', 'S', 3021, 'COIVARAS', 'N', '220273', 'N', 'S', 'S', NULL, 45, 'N', 'N', 'N', '60', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220275', '2211', 'PI', '2206', '2203', '22008', '22', 'COLONIA DO GURGUEIA', NULL, '89', '64885000', '2', '2249', '2249', '16132', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 430.613, '-8,18200', '-43,79200', 216, 'S', 0.6410, NULL, NULL, '22900', 'S', 'N', 1296, NULL, '2290', '2290', NULL, '1993', 'S', 3022, 'COLÔNIA DO GURGUÉIA', 'N', '220275', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '61', NULL, '03', 'N', NULL, NULL, NULL, 199);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220277', '2207', 'PI', '2204', '2204', '22013', '22', 'COLONIA DO PIAUI', NULL, '89', '64516000', '8', '2253', '2253', '16133', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 947.934, '-7,23100', '-42,17800', 0, 'S', 0.5710, NULL, NULL, '22900', 'S', 'N', 1297, NULL, '2290', '2290', NULL, '1993', 'S', 3023, 'COLÔNIA DO PIAUÍ', 'N', '220277', 'N', 'S', 'S', NULL, 133, 'N', 'N', 'N', '62', NULL, '03', 'N', NULL, NULL, NULL, 75);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220280', '2207', 'PI', '2204', '2204', '22015', '22', 'CONCEICAO DO CANINDE', NULL, '89', '64740000', '2', '1055', '1055', '16028', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 903.884, '-7,87800', '-41,59700', 252, 'S', 0.5650, NULL, NULL, '22900', 'S', 'N', 1319, NULL, '2290', '2290', NULL, '1954', 'S', 3024, 'CONCEIÇÃO DO CANINDÉ', 'N', '220280', 'N', 'S', 'S', NULL, 133, 'N', 'N', 'N', '63', NULL, '03', 'N', NULL, NULL, NULL, 75);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220285', '2208', 'PI', '2205', '2203', '22011', '22', 'CORONEL JOSE DIAS', NULL, '89', '64793000', '1', '2255', '2255', '16118', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1822.115, '-8,81600', '-42,51300', 0, 'S', 0.5800, NULL, NULL, '22900', 'S', 'N', 1386, NULL, '2290', '2290', NULL, '1993', 'S', 3025, 'CORONEL JOSÉ DIAS', 'N', '220285', 'N', 'S', 'S', NULL, 77, 'N', 'N', 'N', '64', NULL, '03', 'N', NULL, NULL, NULL, 140);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220290', '2211', 'PI', '2206', '2203', '22012', '22', 'CORRENTE', NULL, '89', '64980000', '1', '1057', '1057', '16029', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 3051.161, '-10,44300', '-45,16200', 438, 'S', 0.6790, NULL, NULL, '22900', 'S', 'N', 1400, NULL, '2290', '2290', NULL, '1872', 'S', 3026, 'CORRENTE', 'N', '220290', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '65', NULL, '03', 'N', NULL, NULL, NULL, 199);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220300', '2211', 'PI', '2206', '2203', '22012', '22', 'CRISTALANDIA DO PIAUI', NULL, '89', '64995000', '8', '1059', '1059', '16030', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1202.901, '-10,65300', '-45,18500', 469, 'S', 0.6010, NULL, NULL, '22900', 'S', 'N', 1439, NULL, '2290', '2290', NULL, '1962', 'S', 3027, 'CRISTALÂNDIA DO PIAUÍ', 'N', '220300', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '66', NULL, '03', 'N', NULL, NULL, NULL, 199);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220320', '2211', 'PI', '2206', '2203', '22012', '22', 'CURIMATA', NULL, '89', '64960000', '6', '1063', '1063', '16032', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 2360.527, '-10,03600', '-44,30600', 328, 'S', 0.6800, NULL, NULL, '22900', 'S', 'N', 1486, NULL, '2290', '2290', NULL, '1953', 'S', 3029, 'CURIMATÁ', 'N', '220320', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '68', NULL, '03', 'N', NULL, NULL, NULL, 199);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351440', '3511', 'SP', '3511', '3508', '35034', '35', 'DRACENA', NULL, '18', '17900000', '3', '6389', '6389', '21145', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 488.044, '-21,48300', '-51,53300', 421, 'S', 0.8000, NULL, NULL, '35111', 'N', 'N', 1609, NULL, '3590', '3590', NULL, '1948', 'S', 4902, 'DRACENA', 'N', '351440', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '161', NULL, '03', 'N', NULL, NULL, NULL, 431);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351460', '3513', 'SP', '3514', '3502', '35014', '35', 'DUMONT', NULL, '16', '14120000', '1', '6393', '6393', '21147', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 110.866, '-21,23600', '-47,97300', 595, 'S', 0.8020, NULL, NULL, '35131', 'N', 'N', 1614, NULL, '3590', '3510', NULL, '1964', 'S', 4904, 'DUMONT', 'N', '351460', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '163', NULL, '03', 'N', NULL, NULL, NULL, 383);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351470', '3509', 'SP', '3510', '3509', '35038', '35', 'ECHAPORA', NULL, '18', '19830000', '0', '6395', '6395', '21148', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 514.587, '-22,42900', '-50,20100', 700, 'S', 0.7800, NULL, NULL, '35093', 'N', 'N', 1618, NULL, '3590', '3590', NULL, '1885', 'S', 4905, 'ECHAPORÃ', 'N', '351470', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '164', NULL, '03', 'N', NULL, NULL, NULL, 96);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351480', '3512', 'SP', '3507', '3514', '35055', '35', 'ELDORADO', NULL, '13', '11960000', '9', '6397', '6397', '21149', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1656.728, '-24,52000', '-48,10800', 62, 'S', 0.7330, NULL, NULL, '35121', 'N', 'N', 1623, NULL, '3590', '3590', NULL, '1842', 'S', 4906, 'ELDORADO', 'N', '351480', 'N', 'N', 'S', NULL, 100, 'N', 'N', 'N', '165', NULL, '03', 'N', NULL, NULL, NULL, 222);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351490', '3510', 'SP', '3514', '3507', '35032', '35', 'ELIAS FAUSTO', NULL, '19', '13350000', '8', '6399', '6399', '21150', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 201.471, '-23,04300', '-47,37400', 605, 'S', 0.7680, NULL, NULL, '35103', 'N', 'N', 1628, NULL, '3590', '3590', NULL, '1944', 'S', 4907, 'ELIAS FAUSTO', 'N', '351490', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '166', NULL, '03', 'N', NULL, NULL, NULL, 100);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351492', '3515', 'SP', '3512', '3501', '35005', '35', 'ELISIARIO', NULL, '17', '15823000', '4', '2975', '2975', '21597', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 92.708, '-21,16600', '-49,11200', 494, 'S', 0.7640, NULL, NULL, '35151', 'N', 'N', 1630, NULL, '3590', '3590', NULL, '1993', 'S', 4908, 'ELISIÁRIO', 'N', '351492', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '167', NULL, '03', 'N', NULL, NULL, NULL, 382);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351495', '3515', 'SP', '3512', '3501', '35005', '35', 'EMBAUBA', NULL, '17', '15425000', '7', '7251', '7251', '21578', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 83.699, '-20,98300', '-48,83600', 570, 'S', 0.7570, NULL, NULL, '35151', 'N', 'N', 1634, NULL, '3590', '3590', NULL, '1993', 'S', 4909, 'EMBAÚBA', 'N', '351495', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '168', NULL, '03', 'N', NULL, NULL, NULL, 382);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351515', '3510', 'SP', '3514', '3507', '35031', '35', 'ENGENHEIRO COELHO', NULL, '19', '13165000', '2', '2949', '2949', '21599', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 109.798, '-22,48800', '-47,21500', 655, 'S', 0.7920, NULL, NULL, '35102', 'N', 'N', 1645, NULL, '3503', '3503', NULL, '1993', 'S', 4913, 'ENGENHEIRO COELHO', 'N', '351515', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '172', NULL, '01', 'N', NULL, NULL, NULL, 327);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351518', '3514', 'SP', '3515', '3507', '35030', '35', 'ESPIRITO SANTO DO PINHAL', NULL, '19', '13990000', '6', '6865', '6865', '21383', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 390.413, '-22,19100', '-46,74100', 870, 'S', 0.8080, NULL, NULL, '35142', 'N', 'N', 1684, NULL, '3590', '3590', NULL, '1877', 'S', 4914, 'ESPÍRITO SANTO DO PINHAL', 'N', '351518', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '173', NULL, '03', 'N', NULL, NULL, NULL, 328);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351520', '3515', 'SP', '3512', '3501', '35002', '35', 'ESTRELA D''OESTE', NULL, '17', '15650000', '2', '6405', '6405', '21153', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 296.261, '-20,28800', '-50,40100', 456, 'S', 0.7920, NULL, NULL, '35154', 'N', 'N', 1696, NULL, '3590', '3590', NULL, '1948', 'S', 4918, 'ESTRELA D OESTE', 'N', '351520', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '176', NULL, '03', 'N', NULL, NULL, NULL, 276);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351530', '3511', 'SP', '3511', '3508', '35036', '35', 'ESTRELA DO NORTE', NULL, '18', '19230000', '1', '6407', '6407', '21154', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 263.273, '-22,48800', '-51,66000', 409, 'S', 0.7670, NULL, NULL, '35112', 'N', 'N', 1700, NULL, '3590', '3590', NULL, '1964', 'S', 4917, 'ESTRELA DO NORTE', 'N', '351530', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '177', NULL, '03', 'N', NULL, NULL, NULL, 323);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351535', '3511', 'SP', '3511', '3508', '35036', '35', 'EUCLIDES DA CUNHA PAULISTA', NULL, '18', '19275000', '0', '7255', '7255', '21579', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 577.122, '-22,56100', '-52,59000', 265, 'S', 0.7380, NULL, NULL, '35115', 'N', 'N', 1705, NULL, '3590', '3590', NULL, '1993', 'S', 4919, 'EUCLIDES DA CUNHA PAULISTA', 'N', '351535', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '178', NULL, '03', 'N', NULL, NULL, NULL, 331);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351540', '3506', 'SP', '3509', '3510', '35040', '35', 'FARTURA', NULL, '14', '18870000', '0', '6409', '6409', '21155', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 429.464, '-23,38800', '-49,51000', 516, 'S', 0.7720, NULL, NULL, '35061', 'N', 'N', 1723, NULL, '3590', '3590', NULL, '1891', 'S', 4920, 'FARTURA', 'N', '351540', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '179', NULL, '03', 'N', NULL, NULL, NULL, 102);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351550', '3515', 'SP', '3512', '3501', '35002', '35', 'FERNANDOPOLIS', NULL, '17', '15600000', '9', '6411', '6411', '21156', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 549.551, '-20,28400', '-50,24600', 535, 'S', 0.8320, NULL, NULL, '35154', 'N', 'N', 1756, NULL, '3590', '3590', NULL, '1944', 'S', 4922, 'FERNANDÓPOLIS', 'N', '351550', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '181', NULL, '02', 'N', NULL, NULL, NULL, 276);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351560', '3515', 'SP', '3512', '3502', '35013', '35', 'FERNANDO PRESTES', NULL, '16', '15940000', '8', '6413', '6413', '21157', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 170.112, '-21,26400', '-48,68500', 545, 'S', 0.7760, NULL, NULL, '35151', 'N', 'N', 1755, NULL, '3590', '3590', NULL, '1935', 'S', 4921, 'FERNANDO PRESTES', 'N', '351560', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '180', NULL, '03', 'N', NULL, NULL, NULL, 382);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351565', '3509', 'SP', '3510', '3509', '35038', '35', 'FERNAO', NULL, '14', '17455000', '7', '0796', NULL, '21631', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 100.297, '-22,35900', '-49,52100', 558, 'S', 0.7480, NULL, NULL, '35093', 'N', 'N', 1757, NULL, '3590', '3590', NULL, '1997', 'S', 4923, 'FERNÃO', 'N', '351565', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '182', NULL, '03', 'N', NULL, NULL, NULL, 96);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351580', '3511', 'SP', '3511', '3508', '35035', '35', 'FLORA RICA', NULL, '18', '17870000', '6', '6417', '6417', '21159', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 225.115, '-21,67600', '-51,38400', 382, 'S', 0.7470, NULL, NULL, '35111', 'N', 'N', 1773, NULL, '3590', '3590', NULL, '1953', 'S', 4925, 'FLORA RICA', 'N', '351580', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '184', NULL, '03', 'N', NULL, NULL, NULL, 431);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220340', '2206', 'PI', '2204', '2204', '22013', '22', 'DOM EXPEDITO LOPES', NULL, '89', '64620000', '4', '1067', '1067', '16034', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 219.070, '-6,95900', '-41,64100', 405, 'S', 0.6350, NULL, NULL, '22900', 'S', 'N', 1574, NULL, '2290', '2290', NULL, '1963', 'S', 3035, 'DOM EXPEDITO LOPES', 'N', '220340', 'N', 'S', 'S', NULL, 96, 'N', 'N', 'N', '74', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220342', '2202', 'PI', '2202', '2202', '22004', '22', 'DOMINGOS MOURAO', NULL, '86', '64250000', '0', '1141', '1141', '16071', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 846.831, '-4,25400', '-41,27000', 150, 'S', 0.5460, NULL, NULL, '22900', 'S', 'N', 1585, NULL, '2290', '2290', NULL, '1962', 'S', 3037, 'DOMINGOS MOURÃO', 'N', '220342', 'N', 'S', 'S', NULL, 161, 'S', 'N', 'N', '76', NULL, '03', 'N', NULL, NULL, NULL, 196);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220345', '2208', 'PI', '2205', '2203', '22011', '22', 'DOM INOCENCIO', NULL, '89', '64790000', '3', '1289', '1289', '16121', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 4024.385, '-9,00200', '-41,97400', 340, 'S', 0.5960, NULL, NULL, '22900', 'S', 'N', 1576, NULL, '2290', '2290', NULL, '1989', 'S', 3036, 'DOM INOCÊNCIO', 'N', '220345', 'N', 'S', 'S', NULL, 77, 'N', 'N', 'N', '75', NULL, '03', 'N', NULL, NULL, NULL, 140);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220350', '2205', 'PI', '2204', '2202', '22006', '22', 'ELESBAO VELOSO', NULL, '86', '64325000', '3', '1069', '1069', '16035', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1285.678, '-6,20200', '-42,14000', 203, 'S', 0.6010, NULL, NULL, '22900', 'S', 'N', 1627, NULL, '2290', '2290', NULL, '1954', 'S', 3038, 'ELESBÃO VELOSO', 'N', '220350', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '77', NULL, '03', 'N', NULL, NULL, NULL, 366);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220360', '2211', 'PI', '2206', '2203', '22008', '22', 'ELISEU MARTINS', NULL, '89', '64880000', '2', '1071', '1071', '16036', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1090.496, '-8,09700', '-43,66400', 258, 'S', 0.6550, NULL, NULL, '22900', 'S', 'N', 1629, NULL, '2290', '2290', NULL, '1957', 'S', 3039, 'ELISEU MARTINS', 'N', '220360', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '78', NULL, '03', 'N', NULL, NULL, NULL, 199);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220370', '2202', 'PI', '2202', '2201', '22001', '22', 'ESPERANTINA', NULL, '86', '64180000', '1', '1073', '1073', '16037', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 911.213, '-3,90200', '-42,23400', 59, 'S', 0.5910, NULL, NULL, '22900', 'N', 'N', 1677, NULL, '2290', '2290', NULL, '1938', 'S', 3040, 'ESPERANTINA', 'N', '220370', 'N', 'S', 'S', NULL, 161, 'S', 'N', 'S', '79', NULL, '03', 'N', NULL, NULL, NULL, 196);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220375', '2208', 'PI', '2205', '2203', '22011', '22', 'FARTURA DO PIAUI', NULL, '89', '64788000', '0', '2257', '2257', '16134', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 717.991, '-9,48400', '-42,79100', 0, 'S', 0.6070, NULL, NULL, '22900', 'S', 'N', 1724, NULL, '2290', '2290', NULL, '1993', 'S', 3041, 'FARTURA DO PIAUÍ', 'N', '220375', 'N', 'S', 'S', NULL, 77, 'N', 'N', 'N', '80', NULL, '03', 'N', NULL, NULL, NULL, 140);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220380', '2209', 'PI', '2203', '2203', '22009', '22', 'FLORES DO PIAUI', NULL, '89', '64815000', '0', '1075', '1075', '16038', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 972.209, '-7,79100', '-42,92700', 300, 'S', 0.5900, NULL, NULL, '22900', 'S', 'N', 1780, NULL, '2290', '2290', NULL, '1963', 'S', 3042, 'FLORES DO PIAUÍ', 'N', '220380', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '81', NULL, '03', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220385', '2207', 'PI', '2204', '2204', '22015', '22', 'FLORESTA DO PIAUI', NULL, '89', '64563000', '9', '0314', NULL, '16175', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 206.144, '-7,46900', '-41,79400', 180, 'S', 0.5120, NULL, NULL, '22900', 'S', 'N', 1785, NULL, '2290', '2290', NULL, '1997', 'S', 3043, 'FLORESTA DO PIAUÍ', 'N', '220385', 'N', 'S', 'S', NULL, 133, 'N', 'N', 'N', '82', NULL, '03', 'N', NULL, NULL, NULL, 75);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220390', '2209', 'PI', '2203', '2203', '22009', '22', 'FLORIANO', NULL, '89', '64800000', '9', '1077', '1077', '16039', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 3409.664, '-6,76700', '-43,02300', 112, 'S', 0.7110, NULL, NULL, '22900', 'N', 'N', 1788, NULL, '2290', '2290', NULL, '1897', 'S', 3044, 'FLORIANO', 'N', '220390', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '83', NULL, '02', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220400', '2205', 'PI', '2204', '2202', '22006', '22', 'FRANCINOPOLIS', NULL, '89', '64520000', '6', '1079', '1079', '16040', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 254.407, '-6,39600', '-42,26200', 245, 'S', 0.5490, NULL, NULL, '22900', 'S', 'N', 1820, NULL, '2290', '2290', NULL, '1961', 'S', 3045, 'FRANCINÓPOLIS', 'N', '220400', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '84', NULL, '03', 'N', NULL, NULL, NULL, 366);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351590', '3515', 'SP', '3512', '3501', '35006', '35', 'FLOREAL', NULL, '17', '15320000', '5', '6419', '6419', '21160', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 203.661, '-20,67700', '-50,14500', 518, 'S', 0.8000, NULL, NULL, '35157', 'N', 'N', 1776, NULL, '3590', '3590', NULL, '1959', 'S', 4926, 'FLOREAL', 'N', '351590', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '185', NULL, '03', 'N', NULL, NULL, NULL, 162);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351600', '3509', 'SP', '3510', '3508', '35035', '35', 'FLORIDA PAULISTA', NULL, '18', '17830000', '2', '6421', '6421', '21161', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 524.910, '-21,61500', '-51,17400', 410, 'S', 0.7670, NULL, NULL, '35091', 'N', 'N', 1792, NULL, '3590', '3590', NULL, '1948', 'S', 4927, 'FLÓRIDA PAULISTA', 'N', '351600', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '186', NULL, '03', 'N', NULL, NULL, NULL, 322);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351610', '3509', 'SP', '3510', '3510', '35039', '35', 'FLORINIA', NULL, '18', '19870000', '1', '6423', '6423', '21162', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 227.359, '-22,90300', '-50,73800', 360, 'S', 0.7590, NULL, NULL, '35092', 'N', 'N', 1793, NULL, '3590', '3590', NULL, '1953', 'S', 4928, 'FLORÍNIA', 'N', '351610', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '187', NULL, '03', 'N', NULL, NULL, NULL, 274);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351620', '3508', 'SP', '3513', '3502', '35012', '35', 'FRANCA', NULL, '16', '14400970', '0', '6425', '6425', '21163', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 607.333, '-20,53900', '-47,40100', 996, 'S', 0.8200, NULL, NULL, '35081', 'N', 'N', 1819, NULL, '3590', '3590', NULL, '1821', 'S', 4929, 'FRANCA', 'N', '351620', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '188', NULL, '01', 'N', NULL, NULL, NULL, 101);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351660', '3509', 'SP', '3510', '3509', '35038', '35', 'GALIA', NULL, '14', '17450000', '6', '6433', '6433', '21167', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 355.794, '-22,29100', '-49,55300', 561, 'S', 0.7450, NULL, NULL, '35093', 'N', 'N', 1852, NULL, '3590', '3590', NULL, '1927', 'S', 4933, 'GÁLIA', 'N', '351660', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '192', NULL, '03', 'N', NULL, NULL, NULL, 96);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351670', '3509', 'SP', '3510', '3509', '35038', '35', 'GARCA', NULL, '14', '17400000', '5', '6435', '6435', '21168', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 555.771, '-22,21100', '-49,65600', 683, 'S', 0.7830, NULL, NULL, '35093', 'N', 'N', 1861, NULL, '3590', '3590', NULL, '1928', 'S', 4934, 'GARÇA', 'N', '351670', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '193', NULL, '03', 'N', NULL, NULL, NULL, 96);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351680', '3515', 'SP', '3512', '3501', '35006', '35', 'GASTAO VIDIGAL', NULL, '17', '15330000', '4', '6437', '6437', '21169', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 180.818, '-20,79900', '-50,18700', 401, 'S', 0.7680, NULL, NULL, '35157', 'N', 'N', 1868, NULL, '3590', '3590', NULL, '1953', 'S', 4935, 'GASTÃO VIDIGAL', 'N', '351680', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '194', NULL, '03', 'N', NULL, NULL, NULL, 162);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351690', '3515', 'SP', '3512', '3501', '35006', '35', 'GENERAL SALGADO', NULL, '17', '15300000', '3', '6439', '6439', '21170', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 493.276, '-20,64800', '-50,36100', 418, 'S', 0.7620, NULL, NULL, '35157', 'N', 'N', 1878, NULL, '3590', '3590', NULL, '1944', 'S', 4937, 'GENERAL SALGADO', 'N', '351690', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '196', NULL, '03', 'N', NULL, NULL, NULL, 162);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351730', '3509', 'SP', '3510', '3504', '35019', '35', 'GUAIMBE', NULL, '14', '16480000', '7', '6447', '6447', '21174', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 217.448, '-21,91000', '-49,89700', 469, 'S', 0.7570, NULL, NULL, '35093', 'N', 'N', 1955, NULL, '3590', '3590', NULL, '1953', 'S', 4941, 'GUAIMBÊ', 'N', '351730', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '200', NULL, '03', 'N', NULL, NULL, NULL, 96);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351750', '3515', 'SP', '3512', '3501', '35004', '35', 'GUAPIACU', NULL, '17', '15110000', '5', '6451', '6451', '21176', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 325.028, '-20,79500', '-49,22000', 505, 'S', 0.8170, NULL, NULL, '35155', 'N', 'N', 1968, NULL, '3590', '3590', NULL, '1953', 'S', 4943, 'GUAPIAÇU', 'N', '351750', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '202', NULL, '03', 'N', NULL, NULL, NULL, 392);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351760', '3516', 'SP', '3508', '3511', '35044', '35', 'GUAPIARA', NULL, '15', '18310000', '4', '6453', '6453', '21177', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 407.619, '-24,18500', '-48,53300', 750, 'S', 0.7060, NULL, NULL, '35162', 'N', 'N', 1969, NULL, '3590', '3590', NULL, '1948', 'S', 4944, 'GUAPIARA', 'N', '351760', 'N', 'N', 'S', NULL, 89, 'N', 'N', 'N', '203', NULL, '03', 'N', NULL, NULL, NULL, 159);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351770', '3508', 'SP', '3513', '3502', '35011', '35', 'GUARA', NULL, '16', '14580000', '3', '6455', '6455', '21178', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 362.617, '-20,42800', '-47,82400', 573, 'S', 0.7590, NULL, NULL, '35083', 'N', 'N', 1975, NULL, '3590', '3590', NULL, '1925', 'S', 4945, 'GUARÁ', 'N', '351770', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '204', NULL, '03', 'N', NULL, NULL, NULL, 272);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351800', '3515', 'SP', '3512', '3501', '35002', '35', 'GUARANI D''OESTE', NULL, '17', '15680000', '8', '6461', '6461', '21181', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 84.534, '-20,07500', '-50,33900', 499, 'S', 0.7570, NULL, NULL, '35154', 'N', 'N', 1990, NULL, '3590', '3590', NULL, '1959', 'S', 4948, 'GUARANI D OESTE', 'N', '351800', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '207', NULL, '03', 'N', NULL, NULL, NULL, 276);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351810', '3509', 'SP', '3510', '3504', '35020', '35', 'GUARANTA', NULL, '14', '16570000', '7', '6463', '6463', '21182', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 461.795, '-21,89500', '-49,59000', 505, 'S', 0.7270, NULL, NULL, '35093', 'N', 'N', 1994, NULL, '3590', '3590', NULL, '1944', 'S', 4949, 'GUARANTÃ', 'N', '351810', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '208', NULL, '03', 'N', NULL, NULL, NULL, 96);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351840', '3517', 'SP', '3517', '3513', '35051', '35', 'GUARATINGUETA', NULL, '12', '12500000', '4', '6469', '6469', '21185', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 751.443, '-22,81600', '-45,19300', 539, 'S', 0.8180, NULL, NULL, '35172', 'N', 'N', 2003, NULL, '3590', '3506', NULL, '1651', 'S', 4952, 'GUARATINGUETÁ', 'N', '351840', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '211', NULL, '01', 'N', NULL, NULL, NULL, 433);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351850', '3516', 'SP', '3508', '3511', '35042', '35', 'GUAREI', NULL, '15', '18250000', '3', '6471', '6471', '21186', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 566.260, '-23,37300', '-48,18400', 635, 'S', 0.7460, NULL, NULL, '35161', 'N', 'N', 2006, NULL, '3590', '3590', NULL, '1936', 'S', 4953, 'GUAREÍ', 'N', '351850', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '212', NULL, '03', 'N', NULL, NULL, NULL, 158);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351860', '3513', 'SP', '3514', '3502', '35013', '35', 'GUARIBA', NULL, '16', '14840000', '2', '6473', '6473', '21187', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 270.454, '-21,36000', '-48,22800', 618, 'S', 0.7560, NULL, NULL, '35131', 'N', 'N', 2007, NULL, '3590', '3590', NULL, '1917', 'S', 4954, 'GUARIBA', 'N', '351860', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '213', NULL, '03', 'N', NULL, NULL, NULL, 383);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220450', '2209', 'PI', '2203', '2203', '22009', '22', 'GUADALUPE', NULL, '89', '64840000', '1', '1089', '1089', '16045', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1019.645, '-6,78700', '-43,56900', 177, 'S', 0.6810, NULL, NULL, '22900', 'S', 'N', 1952, NULL, '2290', '2290', NULL, '1938', 'S', 3052, 'GUADALUPE', 'N', '220450', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '91', NULL, '03', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220455', '2208', 'PI', '2205', '2203', '22011', '22', 'GUARIBAS', NULL, '89', '64798000', '0', '0320', '0320', '16178', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 4279.673, '-9,39800', '-43,68700', 520, 'S', 0.4790, NULL, NULL, '22900', 'S', 'N', 2008, NULL, '2290', '2290', NULL, '1997', 'S', 3053, 'GUARIBAS', 'N', '220455', 'N', 'S', 'S', NULL, 77, 'S', 'N', 'N', '92', NULL, '03', 'N', NULL, NULL, NULL, 140);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220460', '2204', 'PI', '2203', '2202', '22005', '22', 'HUGO NAPOLEAO', NULL, '86', '64470000', '0', '1091', '1091', '16046', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 273.721, '-5,98900', '-42,55600', 232, 'S', 0.5750, NULL, NULL, '22900', 'S', 'N', 2044, NULL, '2290', '2290', NULL, '1963', 'S', 3054, 'HUGO NAPOLEÃO', 'N', '220460', 'N', 'S', 'S', NULL, 45, 'S', 'N', 'N', '93', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220465', '2201', 'PI', '2201', '2201', '22002', '22', 'ILHA GRANDE', NULL, '86', '64224000', '9', '0322', NULL, '16179', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 134.318, '-2,85800', '-41,82100', 10, 'S', 0.5610, NULL, NULL, '22900', 'S', 'N', 2143, NULL, '2290', '2290', NULL, '1997', 'S', 3055, 'ILHA GRANDE', 'N', '220465', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '94', NULL, '03', 'N', NULL, NULL, NULL, 365);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220470', '2205', 'PI', '2204', '2202', '22006', '22', 'INHUMA', NULL, '89', '64535000', '9', '1093', '1093', '16047', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1042.815, '-6,66800', '-41,70800', 387, 'S', 0.6210, NULL, NULL, '22900', 'S', 'N', 2186, NULL, '2290', '2290', NULL, '1954', 'S', 3056, 'INHUMA', 'N', '220470', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '95', NULL, '03', 'N', NULL, NULL, NULL, 366);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220480', '2206', 'PI', '2204', '2204', '22013', '22', 'IPIRANGA DO PIAUI', NULL, '89', '64540000', '8', '1095', '1095', '16048', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 527.716, '-6,82800', '-41,74100', 424, 'S', 0.6010, NULL, NULL, '22900', 'S', 'N', 2210, NULL, '2290', '2290', NULL, '1960', 'S', 3057, 'IPIRANGA DO PIAUÍ', 'N', '220480', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '96', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220490', '2207', 'PI', '2204', '2204', '22015', '22', 'ISAIAS COELHO', NULL, '89', '64570000', '7', '1097', '1097', '16049', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 664.660, '-7,73800', '-41,67600', 260, 'S', 0.5830, NULL, NULL, '22900', 'S', 'N', 2252, NULL, '2290', '2290', NULL, '1963', 'S', 3058, 'ISAÍAS COELHO', 'N', '220490', 'N', 'S', 'S', NULL, 133, 'N', 'N', 'N', '97', NULL, '03', 'N', NULL, NULL, NULL, 75);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220500', '2206', 'PI', '2204', '2204', '22015', '22', 'ITAINOPOLIS', NULL, '89', '64565000', '3', '1099', '1099', '16050', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 810.752, '-7,44700', '-41,47800', 200, 'S', 0.5850, NULL, NULL, '22900', 'S', 'N', 2291, NULL, '2290', '2290', NULL, '1954', 'S', 3059, 'ITAINÓPOLIS', 'N', '220500', 'N', 'S', 'S', NULL, 96, 'N', 'N', 'N', '98', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220510', '2209', 'PI', '2203', '2203', '22009', '22', 'ITAUEIRA', NULL, '89', '64820000', '2', '1101', '1101', '16051', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 2534.502, '-7,60300', '-43,02600', 258, 'S', 0.6370, NULL, NULL, '22900', 'S', 'N', 2397, NULL, '2290', '2290', NULL, '1952', 'S', 3060, 'ITAUEIRA', 'N', '220510', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '99', NULL, '03', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220515', '2206', 'PI', '2204', '2204', '22015', '22', 'JACOBINA DO PIAUI', NULL, '89', '64755000', '1', '2273', '2273', '16135', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1443.257, '-7,93500', '-41,21000', 0, 'S', 0.5700, NULL, NULL, '22900', 'S', 'N', 2453, NULL, '2290', '2290', NULL, '1993', 'S', 3061, 'JACOBINA DO PIAUÍ', 'N', '220515', 'N', 'S', 'S', NULL, 96, 'S', 'N', 'N', '100', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220520', '2206', 'PI', '2204', '2204', '22015', '22', 'JAICOS', NULL, '89', '64575000', '1', '1103', '1103', '16052', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 854.342, '-7,35900', '-41,13800', 280, 'S', 0.5820, NULL, NULL, '22900', 'S', 'N', 2476, NULL, '2290', '2290', NULL, '1832', 'S', 3062, 'JAICÓS', 'N', '220520', 'N', 'S', 'S', NULL, 96, 'S', 'N', 'N', '101', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220730', '2209', 'PI', '2203', '2204', '22015', '22', 'PAES LANDIM', NULL, '89', '64710000', '6', '1145', '1145', '16073', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 349.679, '-7,77800', '-42,25600', 193, 'S', 0.6030, NULL, NULL, '22900', 'S', 'N', 3463, NULL, '2290', '2290', NULL, '1962', 'S', 3106, 'PAES LANDIM', 'N', '220730', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '146', NULL, '03', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231210', '2320', 'CE', '2303', '2307', '23032', '23', 'SANTANA DO CARIRI', NULL, '88', '63190000', '6', '1543', '1543', '05122', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 768.768, '-7,18800', '-39,73700', 500, 'S', 0.6090, NULL, NULL, '23900', 'S', 'N', 4447, NULL, '2302', '2390', NULL, '1885', 'S', 776, 'SANTANA DO CARIRI', 'N', '231210', 'N', 'S', 'S', NULL, 131, 'N', 'N', 'N', '160', NULL, '03', 'N', NULL, NULL, NULL, 339);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231220', '2311', 'CE', '2302', '2301', '23007', '23', 'SANTA QUITERIA', NULL, '88', '62280000', '5', '1545', '1545', '05123', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 4260.681, '-4,33200', '-40,15700', 197, 'S', 0.6420, NULL, NULL, '23900', 'N', 'N', 4391, NULL, '2390', '2390', NULL, '1856', 'S', 774, 'SANTA QUITÉRIA', 'N', '231220', 'N', 'S', 'S', NULL, 49, 'N', 'N', 'N', '158', NULL, '03', 'N', NULL, NULL, NULL, 284);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231335', '2302', 'CE', '2301', '2302', '23011', '23', 'TEJUCUOCA', NULL, '85', '62610000', '1', '1277', '1277', '05174', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 750.605, '-3,98900', '-39,58100', 140, 'S', 0.6110, NULL, NULL, '23900', 'S', 'N', 5134, NULL, '2390', '2390', NULL, '1989', 'S', 789, 'TEJUÇUOCA', 'N', '231335', 'N', 'S', 'S', NULL, 51, 'N', 'N', 'N', '173', NULL, '03', 'N', NULL, NULL, NULL, 5);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231340', '2313', 'CE', '2302', '2301', '23002', '23', 'TIANGUA', NULL, '88', '62320000', '1', '1569', '1569', '05135', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 908.893, '-3,73200', '-40,99200', 775, 'S', 0.6400, NULL, NULL, '23900', 'N', 'N', 5167, NULL, '2390', '2390', NULL, '1933', 'S', 790, 'TIANGUÁ', 'N', '231340', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '174', NULL, '02', 'N', NULL, NULL, NULL, 171);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351885', '3513', 'SP', '3514', '3502', '35014', '35', 'GUATAPARA', NULL, '16', '14115000', '9', '7257', '7257', '21580', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 412.637, '-21,49700', '-48,03800', 512, 'S', 0.7760, NULL, NULL, '35132', 'N', 'N', 2014, NULL, '3590', '3510', NULL, '1993', 'S', 4957, 'GUATAPARÁ', 'N', '351885', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '216', NULL, '03', 'N', NULL, NULL, NULL, 273);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351900', '3509', 'SP', '3510', '3509', '35037', '35', 'HERCULANDIA', NULL, '14', '17650000', '6', '6481', '6481', '21191', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 365.136, '-22,00400', '-50,38500', 502, 'S', 0.7380, NULL, NULL, '35095', 'N', 'N', 2032, NULL, '3590', '3590', NULL, '1944', 'S', 4959, 'HERCULÂNDIA', 'N', '351900', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '218', NULL, '03', 'N', NULL, NULL, NULL, 221);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351905', '3507', 'SP', '3515', '3507', '35032', '35', 'HOLAMBRA', NULL, '19', '13825000', '5', '2953', '2953', '21601', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 64.277, '-22,63300', '-47,05600', 0, 'S', 0.8270, NULL, NULL, '35072', 'N', 'N', 2039, NULL, '3503', '3503', NULL, '1993', 'S', 4960, 'HOLAMBRA', 'N', '351905', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '219', NULL, '01', 'N', NULL, NULL, NULL, 515);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351907', '3507', 'SP', '3515', '3507', '35032', '35', 'HORTOLANDIA', NULL, '19', '13180000', '1', '2951', '2951', '21602', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 62.224, '-22,85800', '-47,22000', 587, 'S', 0.7900, NULL, NULL, '35072', 'N', 'N', 2043, NULL, '3503', '3503', NULL, '1993', 'S', 4961, 'HORTOLÂNDIA', 'N', '351907', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '220', NULL, '01', 'N', NULL, NULL, NULL, 515);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351920', '3509', 'SP', '3510', '3509', '35037', '35', 'IACRI', NULL, '14', '17680000', '4', '6485', '6485', '21193', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 324.029, '-21,85800', '-50,68900', 499, 'S', 0.7750, NULL, NULL, '35095', 'N', 'N', 2051, NULL, '3590', '3590', NULL, '1959', 'S', 4963, 'IACRI', 'N', '351920', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '222', NULL, '03', 'N', NULL, NULL, NULL, 221);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351925', '3506', 'SP', '3509', '3504', '35022', '35', 'IARAS', NULL, '14', '18775000', '3', '7259', '7259', '21581', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 401.371, '-22,87100', '-49,16300', 648, 'S', 0.7420, NULL, NULL, '35061', 'N', 'N', 2054, NULL, '3590', '3590', NULL, '1993', 'S', 4964, 'IARAS', 'N', '351925', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '223', NULL, '03', 'N', NULL, NULL, NULL, 102);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351930', '3503', 'SP', '3513', '3505', '35025', '35', 'IBATE', NULL, '16', '14815000', '3', '6487', '6487', '21194', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 289.544, '-21,95500', '-47,99700', 839, 'S', 0.7900, NULL, NULL, '35034', 'N', 'N', 2059, NULL, '3590', '3590', NULL, '1953', 'S', 4965, 'IBATÉ', 'N', '351930', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '224', NULL, '03', 'N', NULL, NULL, NULL, 434);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351940', '3515', 'SP', '3512', '3501', '35004', '35', 'IBIRA', NULL, '17', '15860000', '2', '6489', '6489', '21195', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 270.748, '-21,08000', '-49,24100', 446, 'S', 0.8010, NULL, NULL, '35155', 'N', 'N', 2081, NULL, '3590', '3590', NULL, '1921', 'S', 4966, 'IBIRÁ', 'N', '351940', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '225', NULL, '03', 'N', NULL, NULL, NULL, 392);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351950', '3509', 'SP', '3510', '3510', '35039', '35', 'IBIRAREMA', NULL, '14', '19940000', '1', '6491', '6491', '21196', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 228.453, '-22,81800', '-50,07300', 483, 'S', 0.7750, NULL, NULL, '35092', 'N', 'N', 2091, NULL, '3590', '3590', NULL, '1944', 'S', 4967, 'IBIRAREMA', 'N', '351950', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '226', NULL, '03', 'N', NULL, NULL, NULL, 274);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351970', '3516', 'SP', '3508', '3512', '35045', '35', 'IBIUNA', NULL, '15', '18150000', '9', '6495', '6495', '21198', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1059.689, '-23,65600', '-47,22300', 860, 'S', 0.7460, NULL, NULL, '35163', 'N', 'N', 2101, NULL, '3590', '3590', NULL, '1857', 'S', 4969, 'IBIÚNA', 'N', '351970', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '228', NULL, '02', 'N', NULL, NULL, NULL, 165);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351980', '3515', 'SP', '3512', '3501', '35004', '35', 'ICEM', NULL, '17', '15460000', '8', '6497', '6497', '21199', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 363.132, '-20,34200', '-49,19500', 449, 'S', 0.7610, NULL, NULL, '35155', 'N', 'N', 2108, NULL, '3590', '3590', NULL, '1953', 'S', 4970, 'ICÉM', 'N', '351980', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '229', NULL, '03', 'N', NULL, NULL, NULL, 392);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352010', '3508', 'SP', '3513', '3502', '35011', '35', 'IGARAPAVA', NULL, '16', '14540000', '3', '6503', '6503', '21202', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 467.112, '-20,03800', '-47,74700', 576, 'S', 0.7900, NULL, NULL, '35083', 'N', 'N', 2118, NULL, '3590', '3590', NULL, '1873', 'S', 4973, 'IGARAPAVA', 'N', '352010', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '232', NULL, '03', 'N', NULL, NULL, NULL, 272);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210235', '2109', 'MA', '2104', '2102', '21009', '21', 'BURITIRANA', NULL, '99', '65935500', '8', '0136', '0136', '09153', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 818.416, '-5,59300', '-47,01800', 250, 'S', 0.5470, NULL, NULL, '21900', 'S', 'N', 798, NULL, '2102', '2190', NULL, '1997', 'S', 1180, 'BURITIRANA', 'N', '210235', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '42', NULL, '03', 'N', NULL, NULL, NULL, 298);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231350', '2306', 'CE', '2301', '2302', '23008', '23', 'TRAIRI', NULL, '85', '62690000', '0', '1571', '1571', '05136', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 924.555, '-3,27800', '-39,26900', 9, 'S', 0.6320, NULL, NULL, '23900', 'N', 'N', 5211, NULL, '2390', '2390', NULL, '1951', 'S', 791, 'TRAIRI', 'N', '231350', 'N', 'S', 'S', NULL, 51, 'S', 'N', 'N', '175', NULL, '02', 'N', NULL, NULL, NULL, 229);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231355', '2306', 'CE', '2301', '2302', '23010', '23', 'TURURU', NULL, '85', '62655000', '9', '1279', '1279', '05167', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 192.548, '-3,58100', '-39,43700', 103, 'S', 0.6000, NULL, NULL, '23900', 'S', 'N', 5277, NULL, '2390', '2390', NULL, '1989', 'S', 792, 'TURURU', 'N', '231355', 'N', 'S', 'S', NULL, 51, 'N', 'N', 'N', '176', NULL, '03', 'N', NULL, NULL, NULL, 229);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231360', '2313', 'CE', '2302', '2301', '23002', '23', 'UBAJARA', NULL, '88', '62350000', '9', '1573', '1573', '05137', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 421.037, '-3,85400', '-40,92100', 847, 'S', 0.6570, NULL, NULL, '23900', 'S', 'N', 5290, NULL, '2390', '2390', NULL, '1915', 'S', 793, 'UBAJARA', 'N', '231360', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '177', NULL, '03', 'N', NULL, NULL, NULL, 171);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231370', '2317', 'CE', '2303', '2306', '23028', '23', 'UMARI', NULL, '88', '63310000', '8', '1575', '1575', '05138', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 263.917, '-6,64800', '-38,70000', 272, 'S', 0.5840, NULL, NULL, '23900', 'S', 'N', 5306, NULL, '2390', '2390', NULL, '1956', 'S', 794, 'UMARI', 'N', '231370', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '178', NULL, '03', 'N', NULL, NULL, NULL, 48);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231375', '2306', 'CE', '2301', '2302', '23010', '23', 'UMIRIM', NULL, '85', '62660000', '7', '9855', '9855', '05155', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 326.496, '-3,67700', '-39,35000', 65, 'S', 0.5780, NULL, NULL, '23900', 'S', 'N', 5312, NULL, '2390', '2390', NULL, '1989', 'S', 795, 'UMIRIM', 'N', '231375', 'N', 'S', 'S', NULL, 51, 'N', 'N', 'N', '179', NULL, '03', 'N', NULL, NULL, NULL, 229);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231380', '2306', 'CE', '2301', '2302', '23010', '23', 'URUBURETAMA', NULL, '85', '62650000', '7', '1577', '1577', '05139', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 97.107, '-3,62500', '-39,50800', 125, 'S', 0.6320, NULL, NULL, '23900', 'S', 'N', 5337, NULL, '2390', '2390', NULL, '1899', 'S', 796, 'URUBURETAMA', 'N', '231380', 'N', 'S', 'S', NULL, 51, 'N', 'N', 'N', '180', NULL, '03', 'N', NULL, NULL, NULL, 229);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231390', '2311', 'CE', '2302', '2301', '23003', '23', 'URUOCA', NULL, '88', '62460000', '6', '1579', '1579', '05140', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 696.770, '-3,31400', '-40,55700', 81, 'S', 0.5870, NULL, NULL, '23900', 'S', 'N', 5345, NULL, '2390', '2390', NULL, '1957', 'S', 797, 'URUOCA', 'N', '231390', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '181', NULL, '03', 'N', NULL, NULL, NULL, 284);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231395', '2311', 'CE', '2302', '2301', '23006', '23', 'VARJOTA', NULL, '88', '62265000', '5', '9857', '9857', '05148', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 179.255, '-4,19400', '-40,47700', 183, 'S', 0.6680, NULL, NULL, '23900', 'S', 'N', 5381, NULL, '2390', '2390', NULL, '1986', 'S', 798, 'VARJOTA', 'N', '231395', 'N', 'S', 'S', NULL, 86, 'N', 'N', 'N', '182', NULL, '03', 'N', NULL, NULL, NULL, 284);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231400', '2320', 'CE', '2303', '2306', '23027', '23', 'VARZEA ALEGRE', NULL, '88', '63540000', '3', '1581', '1581', '05141', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 835.706, '-6,78900', '-39,29600', 317, 'S', 0.6330, NULL, NULL, '23900', 'N', 'N', 5385, NULL, '2390', '2390', NULL, '1933', 'S', 799, 'VÁRZEA ALEGRE', 'N', '231400', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '183', NULL, '03', 'N', NULL, NULL, NULL, 339);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231410', '2313', 'CE', '2302', '2301', '23002', '23', 'VICOSA DO CEARA', NULL, '88', '62300000', '2', '1583', '1583', '05142', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 1311.592, '-3,56200', '-41,09200', 717, 'S', 0.5930, NULL, NULL, '23900', 'N', 'N', 5434, NULL, '2390', '2390', NULL, '1882', 'S', 800, 'VIÇOSA DO CEARÁ', 'N', '231410', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '184', NULL, '02', 'N', NULL, NULL, NULL, 171);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240010', '2404', 'RN', '2490', '2402', '24012', '24', 'ACARI', NULL, '84', '59370000', '9', '1601', '1601', '18001', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 608.565, '-6,43600', '-36,63900', 270, 'S', 0.6980, NULL, NULL, '24900', 'S', 'N', 22, NULL, '2490', '2490', NULL, '1833', 'S', 3674, 'ACARI', 'N', '240010', 'N', 'S', 'S', NULL, 76, 'N', 'N', 'N', '1', NULL, '03', 'N', NULL, NULL, NULL, 83);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240020', '2402', 'RN', '2490', '2401', '24004', '24', 'ACU', NULL, '84', '59650000', '8', '1603', '1603', '18002', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1269.235, '-5,57700', '-36,90900', 27, 'S', 0.6770, NULL, NULL, '24900', 'N', 'N', 28, NULL, '2490', '2490', NULL, '1788', 'S', 3675, 'AÇU', 'N', '240020', 'N', 'S', 'S', NULL, 1, 'N', 'N', 'N', '2', NULL, '02', 'N', NULL, NULL, NULL, 37);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240030', '2403', 'RN', '2490', '2402', '24009', '24', 'AFONSO BEZERRA', NULL, '84', '59510000', '7', '1605', '1605', '18003', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 576.248, '-5,49800', '-36,50600', 62, 'S', 0.6290, NULL, NULL, '24900', 'S', 'N', 36, NULL, '2490', '2490', NULL, '1954', 'S', 3676, 'AFONSO BEZERRA', 'N', '240030', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '3', NULL, '03', 'N', NULL, NULL, NULL, 84);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240040', '2406', 'RN', '2490', '2401', '24005', '24', 'AGUA NOVA', NULL, '84', '59995000', '6', '1607', '1607', '18004', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 50.683, '-6,20900', '-38,29700', 270, 'S', 0.5870, NULL, NULL, '24900', 'S', 'N', 59, NULL, '2490', '2490', NULL, '1963', 'S', 3677, 'ÁGUA NOVA', 'N', '240040', 'N', 'S', 'S', NULL, 134, 'N', 'N', 'N', '4', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240050', '2406', 'RN', '2490', '2401', '24006', '24', 'ALEXANDRIA', NULL, '84', '59965000', '5', '1609', '1609', '18005', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 381.202, '-6,41300', '-38,01600', 319, 'S', 0.6370, NULL, NULL, '24900', 'S', 'N', 108, NULL, '2490', '2490', NULL, '1930', 'S', 3678, 'ALEXANDRIA', 'N', '240050', 'N', 'S', 'S', NULL, 134, 'S', 'N', 'N', '5', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240060', '2406', 'RN', '2490', '2401', '24007', '24', 'ALMINO AFONSO', NULL, '84', '59760000', '4', '1611', '1611', '18006', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 128.029, '-6,15200', '-37,76600', 236, 'S', 0.6400, NULL, NULL, '24900', 'S', 'N', 123, NULL, '2490', '2490', NULL, '1953', 'S', 3679, 'ALMINO AFONSO', 'N', '240060', 'N', 'S', 'S', NULL, 134, 'S', 'N', 'N', '6', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240070', '2402', 'RN', '2490', '2401', '24004', '24', 'ALTO DO RODRIGUES', NULL, '84', '59507000', '3', '1613', '1613', '18007', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 191.311, '-5,28800', '-36,76200', 13, 'S', 0.6880, NULL, NULL, '24900', 'S', 'N', 148, NULL, '2490', '2490', NULL, '1963', 'S', 3680, 'ALTO DO RODRIGUES', 'N', '240070', 'N', 'S', 'S', NULL, 1, 'N', 'N', 'N', '7', NULL, '03', 'N', NULL, NULL, NULL, 37);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240080', '2402', 'RN', '2490', '2402', '24009', '24', 'ANGICOS', NULL, '84', '59515000', '2', '1615', '1615', '18008', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 741.654, '-5,66600', '-36,60100', 110, 'S', 0.6880, NULL, NULL, '24900', 'S', 'N', 238, NULL, '2490', '2490', NULL, '1850', 'S', 3681, 'ANGICOS', 'N', '240080', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '8', NULL, '03', 'N', NULL, NULL, NULL, 37);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240090', '2406', 'RN', '2490', '2401', '24007', '24', 'ANTONIO MARTINS', NULL, '84', '59870000', '1', '1617', '1617', '18009', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 244.620, '-6,21300', '-37,90600', 312, 'S', 0.6360, NULL, NULL, '24900', 'S', 'N', 261, NULL, '2490', '2490', NULL, '1962', 'S', 3682, 'ANTÔNIO MARTINS', 'N', '240090', 'N', 'S', 'S', NULL, 134, 'S', 'N', 'N', '9', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240100', '2402', 'RN', '2490', '2401', '24002', '24', 'APODI', NULL, '84', '59700000', '8', '1619', '1619', '18010', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1602.659, '-5,66400', '-37,79900', 67, 'S', 0.6540, NULL, NULL, '24900', 'N', 'N', 278, NULL, '2490', '2490', NULL, '1883', 'S', 3683, 'APODI', 'N', '240100', 'N', 'S', 'S', NULL, 32, 'N', 'N', 'N', '10', NULL, '03', 'N', NULL, NULL, NULL, 147);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240110', '2402', 'RN', '2490', '2401', '24001', '24', 'AREIA BRANCA', NULL, '84', '59655000', '7', '1621', '1621', '18011', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 357.580, '-4,95600', '-37,13700', 3, 'S', 0.7100, NULL, NULL, '24900', 'N', 'N', 365, NULL, '2490', '2490', NULL, '1892', 'S', 3684, 'AREIA BRANCA', 'N', '240110', 'N', 'S', 'S', NULL, 1, 'S', 'N', 'N', '11', NULL, '03', 'N', NULL, NULL, NULL, 147);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240120', '2401', 'RN', '2490', '2404', '24019', '24', 'ARES', NULL, '84', '59170000', '6', '1623', '1623', '18012', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 112.584, '-6,19400', '-35,16000', 52, 'S', 0.6240, NULL, NULL, '24900', 'S', 'N', 373, NULL, '2490', '2490', NULL, '1876', 'S', 3685, 'ARÊS', 'N', '240120', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '12', NULL, '03', 'N', NULL, NULL, NULL, 148);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240130', '2402', 'RN', '2490', '2401', '24003', '24', 'AUGUSTO SEVERO', NULL, '84', '59680000', '5', '1625', '1625', '18013', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 896.962, '-5,86400', '-37,31000', 96, 'S', 0.6110, NULL, NULL, '24900', 'S', 'N', 5597, NULL, '2490', '2490', NULL, '1870', 'S', 5583, 'AUGUSTO SEVERO', 'N', '240130', 'N', 'S', 'S', NULL, 32, 'N', 'N', 'N', '13', NULL, '03', 'N', NULL, NULL, NULL, 147);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240140', '2401', 'RN', '2490', '2404', '24019', '24', 'BAIA FORMOSA', NULL, '84', '59194000', '4', '1627', '1627', '18014', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 245.510, '-6,36900', '-35,00800', 4, 'S', 0.6430, NULL, NULL, '24900', 'S', 'N', 450, NULL, '2490', '2490', NULL, '1958', 'S', 3686, 'BAÍA FORMOSA', 'N', '240140', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '14', NULL, '03', 'N', NULL, NULL, NULL, 148);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240145', '2402', 'RN', '2490', '2401', '24001', '24', 'BARAUNA', NULL, '84', '59695000', '3', '3003', '3003', '18151', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 825.802, '-5,08000', '-37,61700', 94, 'S', 0.6000, NULL, NULL, '24900', 'S', 'N', 489, NULL, '2490', '2490', NULL, '1981', 'S', 3687, 'BARAÚNA', 'N', '240145', 'N', 'S', 'S', NULL, 1, 'S', 'N', 'N', '15', NULL, '03', 'N', NULL, NULL, NULL, 147);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240150', '2405', 'RN', '2490', '2403', '24014', '24', 'BARCELONA', NULL, '84', '59410000', '3', '1629', '1629', '18015', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 152.629, '-5,95100', '-35,92600', 124, 'S', 0.6130, NULL, NULL, '24900', 'S', 'N', 495, NULL, '2490', '2490', NULL, '1958', 'S', 3688, 'BARCELONA', 'N', '240150', 'N', 'S', 'S', NULL, 123, 'N', 'N', 'N', '16', NULL, '03', 'N', NULL, NULL, NULL, 270);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352020', '3517', 'SP', '3517', '3513', '35050', '35', 'IGARATA', NULL, '11', '12350000', '2', '6505', '6505', '21203', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 293.322, '-23,20400', '-46,15600', 745, 'S', 0.7640, NULL, NULL, '35171', 'N', 'N', 2125, NULL, '3590', '3590', NULL, '1953', 'S', 4974, 'IGARATÁ', 'N', '352020', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '233', NULL, '03', 'N', NULL, NULL, NULL, 324);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352030', '3512', 'SP', '3507', '3514', '35055', '35', 'IGUAPE', NULL, '13', '11920000', '1', '6507', '6507', '21204', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'S', NULL, 'N', 1980.916, '-24,70800', '-47,55500', 3, 'S', 0.7570, NULL, NULL, '35121', 'N', 'N', 2132, NULL, '3590', '3590', NULL, '1635', 'S', 4975, 'IGUAPE', 'N', '352030', 'N', 'N', 'S', NULL, 100, 'N', 'N', 'N', '234', NULL, '03', 'N', NULL, NULL, NULL, 222);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220525', '2204', 'PI', '2203', '2202', '22005', '22', 'JARDIM DO MULATO', NULL, '86', '64495000', '0', '0997', '0997', '16136', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 460.518, '-6,09900', '-42,63000', 0, 'S', 0.5800, NULL, NULL, '22900', 'S', 'N', 2512, NULL, '2290', '2290', NULL, '1993', 'S', 3063, 'JARDIM DO MULATO', 'N', '220525', 'N', 'S', 'S', NULL, 45, 'N', 'N', 'N', '102', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240160', '2403', 'RN', '2490', '2403', '24013', '24', 'BENTO FERNANDES', NULL, '84', '59555000', '2', '1631', '1631', '18016', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 301.075, '-5,69400', '-35,82000', 111, 'S', 0.5780, NULL, NULL, '24900', 'S', 'N', 596, NULL, '2490', '2490', NULL, '1958', 'S', 3689, 'BENTO FERNANDES', 'N', '240160', 'N', 'S', 'S', NULL, 55, 'S', 'N', 'N', '17', NULL, '03', 'N', NULL, NULL, NULL, 84);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240165', '2404', 'RN', '2490', '2402', '24010', '24', 'BODO', NULL, '84', '59528000', '1', '0412', NULL, '18153', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 253.513, '-5,98800', '-36,41300', 560, 'S', 0.5950, NULL, NULL, '24900', 'S', 'N', 651, NULL, '2490', '2490', NULL, '1997', 'S', 3691, 'BODÓ', 'N', '240165', 'N', 'S', 'S', NULL, 76, 'S', 'N', 'N', '18', NULL, '03', 'N', NULL, NULL, NULL, 83);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240170', '2405', 'RN', '2490', '2403', '24015', '24', 'BOM JESUS', NULL, '84', '59270000', '1', '1633', '1633', '18017', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 122.033, '-5,98400', '-35,58100', 98, 'S', 0.6250, NULL, NULL, '24900', 'S', 'N', 667, NULL, '2490', '2490', NULL, '1962', 'S', 3692, 'BOM JESUS', 'N', '240170', 'N', 'S', 'S', NULL, 123, 'S', 'N', 'N', '19', NULL, '03', 'N', NULL, NULL, NULL, 270);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240180', '2401', 'RN', '2490', '2403', '24015', '24', 'BREJINHO', NULL, '84', '59219000', '0', '1635', '1635', '18018', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 58.528, '-6,19100', '-35,35700', 144, 'S', 0.6250, NULL, NULL, '24900', 'S', 'N', 752, NULL, '2490', '2490', NULL, '1963', 'S', 3693, 'BREJINHO', 'N', '240180', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '20', NULL, '03', 'N', NULL, NULL, NULL, 148);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240185', '2403', 'RN', '2490', '2402', '24008', '24', 'CAICARA DO NORTE', NULL, '84', '59592000', '9', '0414', '0414', '18159', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 189.495, '-5,07800', '-36,06800', 0, 'S', 0.6310, NULL, NULL, '24900', 'S', 'N', 873, NULL, '2490', '2490', NULL, '1997', 'S', 3694, 'CAIÇARA DO NORTE', 'N', '240185', 'N', 'S', 'S', NULL, 55, 'S', 'N', 'N', '21', NULL, '03', 'N', NULL, NULL, NULL, 84);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240190', '2403', 'RN', '2490', '2402', '24009', '24', 'CAICARA DO RIO DO VENTO', NULL, '84', '59540000', '9', '1637', '1637', '18019', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 261.191, '-5,76000', '-35,99800', 167, 'S', 0.6190, NULL, NULL, '24900', 'S', 'N', 874, NULL, '2490', '2490', NULL, '1963', 'S', 3695, 'CAIÇARA DO RIO DO VENTO', 'N', '240190', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '22', NULL, '03', 'N', NULL, NULL, NULL, 84);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240200', '2404', 'RN', '2490', '2402', '24011', '24', 'CAICO', NULL, '84', '59300000', '6', '1639', '1639', '18020', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1228.574, '-6,45800', '-37,09800', 151, 'S', 0.7560, NULL, NULL, '24900', 'N', 'N', 875, NULL, '2490', '2490', NULL, '1788', 'S', 3696, 'CAICÓ', 'N', '240200', 'N', 'S', 'S', NULL, 76, 'S', 'N', 'S', '23', NULL, '02', 'N', NULL, NULL, NULL, 83);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240210', '2405', 'RN', '2490', '2403', '24014', '24', 'CAMPO REDONDO', NULL, '84', '59230000', '5', '1641', '1641', '18021', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 213.729, '-6,24300', '-36,18300', 471, 'S', 0.6330, NULL, NULL, '24900', 'S', 'N', 972, NULL, '2490', '2490', NULL, '1963', 'S', 3698, 'CAMPO REDONDO', 'N', '240210', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '24', NULL, '03', 'N', NULL, NULL, NULL, 270);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240220', '2401', 'RN', '2490', '2404', '24019', '24', 'CANGUARETAMA', NULL, '84', '59190000', '4', '1643', '1643', '18022', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 245.529, '-6,38000', '-35,12900', 5, 'S', 0.6000, NULL, NULL, '24900', 'S', 'N', 1016, NULL, '2490', '2490', NULL, '1769', 'S', 3699, 'CANGUARETAMA', 'N', '240220', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '25', NULL, '03', 'N', NULL, NULL, NULL, 148);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240230', '2402', 'RN', '2490', '2401', '24002', '24', 'CARAUBAS', NULL, '84', '59780000', '3', '1645', '1645', '18023', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1095.001, '-5,79300', '-37,55700', 144, 'S', 0.6140, NULL, NULL, '24900', 'S', 'N', 1085, NULL, '2490', '2490', NULL, '1868', 'S', 3700, 'CARAÚBAS', 'N', '240230', 'N', 'S', 'S', NULL, 32, 'S', 'N', 'N', '26', NULL, '03', 'N', NULL, NULL, NULL, 147);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240240', '2404', 'RN', '2490', '2402', '24012', '24', 'CARNAUBA DOS DANTAS', NULL, '84', '59374000', '2', '1647', '1647', '18024', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 245.648, '-6,55600', '-36,59500', 306, 'S', 0.7420, NULL, NULL, '24900', 'N', 'N', 1124, NULL, '2490', '2490', NULL, '1953', 'S', 3701, 'CARNAÚBA DOS DANTAS', 'N', '240240', 'N', 'S', 'S', NULL, 76, 'N', 'N', 'N', '27', NULL, '03', 'N', NULL, NULL, NULL, 83);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240250', '2402', 'RN', '2490', '2401', '24004', '24', 'CARNAUBAIS', NULL, '84', '59665000', '1', '1649', '1649', '18025', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 529.835, '-5,34100', '-36,83300', 30, 'S', 0.6510, NULL, NULL, '24900', 'S', 'N', 1125, NULL, '2490', '2490', NULL, '1963', 'S', 3702, 'CARNAUBAIS', 'N', '240250', 'N', 'S', 'S', NULL, 1, 'N', 'N', 'N', '28', NULL, '03', 'N', NULL, NULL, NULL, 37);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240260', '2407', 'RN', '2490', '2404', '24017', '24', 'CEARA-MIRIM', NULL, '84', '59570000', '0', '1651', '1651', '18026', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 739.686, '-5,63400', '-35,42600', 33, 'S', 0.6460, NULL, NULL, '24900', 'N', 'N', 1192, NULL, '2401', '2401', NULL, '1755', 'S', 3703, 'CEARÁ-MIRIM', 'N', '240260', 'N', 'S', 'S', NULL, 55, 'S', 'N', 'S', '29', NULL, '02', 'N', NULL, NULL, NULL, 84);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240270', '2404', 'RN', '2490', '2402', '24010', '24', 'CERRO CORA', NULL, '84', '59395000', '9', '1653', '1653', '18027', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 393.569, '-6,04600', '-36,34600', 575, 'S', 0.5920, NULL, NULL, '24900', 'S', 'N', 1216, NULL, '2490', '2490', NULL, '1953', 'S', 3704, 'CERRO CORÁ', 'N', '240270', 'N', 'S', 'S', NULL, 76, 'N', 'N', 'N', '30', NULL, '03', 'N', NULL, NULL, NULL, 83);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240280', '2405', 'RN', '2490', '2403', '24014', '24', 'CORONEL EZEQUIEL', NULL, '84', '59220000', '8', '1655', '1655', '18028', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 185.752, '-6,38300', '-36,21500', 584, 'S', 0.6000, NULL, NULL, '24900', 'S', 'N', 1381, NULL, '2490', '2490', NULL, '1953', 'S', 3705, 'CORONEL EZEQUIEL', 'N', '240280', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '31', NULL, '03', 'N', NULL, NULL, NULL, 270);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240290', '2406', 'RN', '2490', '2401', '24005', '24', 'CORONEL JOAO PESSOA', NULL, '84', '59930000', '7', '1657', '1657', '18029', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 117.140, '-6,26000', '-38,44400', 401, 'S', 0.5920, NULL, NULL, '24900', 'S', 'N', 1384, NULL, '2490', '2490', NULL, '1963', 'S', 3706, 'CORONEL JOÃO PESSOA', 'N', '240290', 'N', 'S', 'S', NULL, 134, 'S', 'N', 'N', '32', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240300', '2404', 'RN', '2490', '2402', '24012', '24', 'CRUZETA', NULL, '84', '59375000', '4', '1659', '1659', '18030', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 295.829, '-6,41200', '-36,79000', 231, 'S', 0.7130, NULL, NULL, '24900', 'N', 'N', 1466, NULL, '2490', '2490', NULL, '1953', 'S', 3707, 'CRUZETA', 'N', '240300', 'N', 'S', 'S', NULL, 76, 'N', 'N', 'N', '33', NULL, '03', 'N', NULL, NULL, NULL, 83);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240310', '2404', 'RN', '2490', '2402', '24012', '24', 'CURRAIS NOVOS', NULL, '84', '59380000', '3', '1661', '1661', '18031', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 864.341, '-6,26100', '-36,51500', 341, 'S', 0.7240, NULL, NULL, '24900', 'N', 'N', 1492, NULL, '2490', '2490', NULL, '1890', 'S', 3708, 'CURRAIS NOVOS', 'N', '240310', 'N', 'S', 'S', NULL, 76, 'N', 'N', 'S', '34', NULL, '03', 'N', NULL, NULL, NULL, 83);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240320', '2406', 'RN', '2490', '2401', '24005', '24', 'DOUTOR SEVERIANO', NULL, '84', '59910000', '2', '1663', '1663', '18032', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 108.277, '-6,09400', '-38,37500', 370, 'S', 0.5980, NULL, NULL, '24900', 'S', 'N', 1606, NULL, '2490', '2490', NULL, '1962', 'S', 3709, 'DOUTOR SEVERIANO', 'N', '240320', 'N', 'S', 'S', NULL, 134, 'N', 'N', 'N', '35', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240325', '2407', 'RN', '2490', '2404', '24018', '24', 'PARNAMIRIM', NULL, '84', '59150000', '1', '1779', '1779', '18090', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 120.202, '-5,91600', '-35,26300', 53, 'S', 0.7600, NULL, NULL, '24900', 'N', 'N', 3576, NULL, '2401', '2401', NULL, '1958', 'S', 3769, 'PARNAMIRIM', 'N', '240325', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '97', NULL, '01', 'N', NULL, NULL, NULL, 377);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240330', '2406', 'RN', '2490', '2401', '24005', '24', 'ENCANTO', NULL, '84', '59905000', '1', '1665', '1665', '18033', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 125.747, '-6,11100', '-38,30600', 212, 'S', 0.6250, NULL, NULL, '24900', 'S', 'N', 1639, NULL, '2490', '2490', NULL, '1963', 'S', 3710, 'ENCANTO', 'N', '240330', 'N', 'S', 'S', NULL, 134, 'S', 'N', 'N', '36', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240340', '2404', 'RN', '2490', '2402', '24012', '24', 'EQUADOR', NULL, '84', '59355000', '0', '1667', '1667', '18034', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 264.983, '-6,94500', '-36,71800', 572, 'S', 0.6650, NULL, NULL, '24900', 'S', 'N', 1658, NULL, '2490', '2490', NULL, '1962', 'S', 3711, 'EQUADOR', 'N', '240340', 'N', 'S', 'S', NULL, 76, 'N', 'N', 'N', '37', NULL, '03', 'N', NULL, NULL, NULL, 83);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240350', '2401', 'RN', '2490', '2404', '24019', '24', 'ESPIRITO SANTO', NULL, '84', '59180000', '9', '1669', '1669', '18035', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 143.673, '-6,33200', '-35,30900', 44, 'S', 0.5810, NULL, NULL, '24900', 'S', 'N', 1682, NULL, '2490', '2490', NULL, '1962', 'S', 3712, 'ESPÍRITO SANTO', 'N', '240350', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '38', NULL, '03', 'N', NULL, NULL, NULL, 148);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240360', '2407', 'RN', '2490', '2404', '24018', '24', 'EXTREMOZ', NULL, '84', '59575000', '8', '1671', '1671', '18036', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 125.665, '-5,70600', '-35,30700', 41, 'S', 0.6940, NULL, NULL, '24900', 'S', 'N', 1712, NULL, '2401', '2401', NULL, '1963', 'S', 3714, 'EXTREMOZ', 'N', '240360', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '39', NULL, '03', 'N', NULL, NULL, NULL, 377);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240370', '2402', 'RN', '2490', '2401', '24002', '24', 'FELIPE GUERRA', NULL, '84', '59795000', '7', '1673', '1673', '18037', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 268.427, '-5,60300', '-37,68900', 40, 'S', 0.6330, NULL, NULL, '24900', 'S', 'N', 1743, NULL, '2490', '2490', NULL, '1963', 'S', 3715, 'FELIPE GUERRA', 'N', '240370', 'N', 'S', 'S', NULL, 32, 'S', 'N', 'N', '40', NULL, '03', 'N', NULL, NULL, NULL, 147);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240510', '2403', 'RN', '2490', '2403', '24013', '24', 'JANDAIRA', NULL, '84', '59594000', '8', '1699', '1699', '18050', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 435.678, '-5,35600', '-36,12800', 110, 'S', 0.5710, NULL, NULL, '24900', 'S', 'N', 2484, NULL, '2490', '2490', NULL, '1963', 'S', 3731, 'JANDAÍRA', 'N', '240510', 'N', 'S', 'S', NULL, 55, 'S', 'N', 'N', '56', NULL, '03', 'N', NULL, NULL, NULL, 84);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352040', '3517', 'SP', '3517', '3513', '35054', '35', 'ILHA BELA', NULL, '12', '11630000', '0', '6509', '6509', '21205', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 348.300, '-23,77800', '-45,35800', 4, 'S', 0.7810, NULL, NULL, '35173', 'N', 'N', 2145, NULL, '3590', '3590', NULL, '1806', 'S', 4978, 'ILHABELA', 'N', '352040', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '237', NULL, '03', 'N', NULL, NULL, NULL, 437);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210970', '2106', 'MA', '2108', '2105', '21021', '21', 'SAMBAIBA', NULL, '99', '65830000', '0', '0893', '0893', '09097', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2478.569, '-7,14000', '-45,34600', 212, 'S', 0.6090, NULL, NULL, '21900', 'S', 'N', 4282, NULL, '2190', '2190', NULL, '1953', 'S', 1298, 'SAMBAÍBA', 'N', '210970', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '160', NULL, '03', 'N', NULL, NULL, NULL, 355);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240520', '2402', 'RN', '2490', '2401', '24003', '24', 'JANDUIS', NULL, '84', '59690000', '7', '1701', '1701', '18051', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 304.899, '-6,01600', '-37,40900', 141, 'S', 0.6040, NULL, NULL, '24900', 'S', 'N', 2486, NULL, '2490', '2490', NULL, '1962', 'S', 3732, 'JANDUÍS', 'N', '240520', 'N', 'S', 'S', NULL, 32, 'S', 'N', 'N', '57', NULL, '03', 'N', NULL, NULL, NULL, 147);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240530', '2405', 'RN', '2490', '2403', '24015', '24', 'JANUARIO CICCO', NULL, '84', '59260000', '6', '1703', NULL, '18052', NULL, 'ATIVO', 'N', 'N', NULL, 'BOA SAUDE                 ', 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 187.211, '-6,15800', '-35,60100', 104, 'S', 0.5960, NULL, NULL, '24900', 'S', 'N', 5598, NULL, '2490', '2490', NULL, '1953', 'S', 3690, 'JANUÁRIO CICCO', 'N', '240530', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '58', NULL, '03', 'N', NULL, NULL, NULL, 270);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240540', '2405', 'RN', '2490', '2403', '24014', '24', 'JAPI', NULL, '84', '59213000', '5', '1705', '1705', '18053', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 188.990, '-6,46500', '-35,94700', 284, 'S', 0.5700, NULL, NULL, '24900', 'S', 'N', 2494, NULL, '2490', '2490', NULL, '1959', 'S', 3733, 'JAPI', 'N', '240540', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '59', NULL, '03', 'N', NULL, NULL, NULL, 270);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240550', '2403', 'RN', '2490', '2402', '24009', '24', 'JARDIM DE ANGICOS', NULL, '84', '59544000', '4', '1707', '1707', '18054', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 254.045, '-5,65400', '-35,96900', 132, 'S', 0.6280, NULL, NULL, '24900', 'S', 'N', 2510, NULL, '2490', '2490', NULL, '1962', 'S', 3734, 'JARDIM DE ANGICOS', 'N', '240550', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '60', NULL, '03', 'N', NULL, NULL, NULL, 84);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240560', '2404', 'RN', '2490', '2402', '24011', '24', 'JARDIM DE PIRANHAS', NULL, '84', '59324000', '3', '1709', '1709', '18055', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 330.533, '-6,37900', '-37,35200', 134, 'S', 0.6750, NULL, NULL, '24900', 'S', 'N', 2511, NULL, '2490', '2490', NULL, '1948', 'S', 3735, 'JARDIM DE PIRANHAS', 'N', '240560', 'N', 'S', 'S', NULL, 76, 'S', 'N', 'N', '61', NULL, '03', 'N', NULL, NULL, NULL, 83);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240570', '2404', 'RN', '2490', '2402', '24012', '24', 'JARDIM DO SERIDO', NULL, '84', '59343000', '2', '1711', '1711', '18056', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 368.643, '-6,58400', '-36,77400', 236, 'S', 0.7220, NULL, NULL, '24900', 'N', 'N', 2513, NULL, '2490', '2490', NULL, '1858', 'S', 3736, 'JARDIM DO SERIDÓ', 'N', '240570', 'N', 'S', 'S', NULL, 76, 'N', 'N', 'N', '62', NULL, '03', 'N', NULL, NULL, NULL, 83);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240580', '2403', 'RN', '2490', '2403', '24013', '24', 'JOAO CAMARA', NULL, '84', '59550000', '1', '1713', '1713', '18057', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 714.951, '-5,53800', '-35,82000', 160, 'S', 0.6390, NULL, NULL, '24900', 'N', 'N', 2558, NULL, '2490', '2490', NULL, '1928', 'S', 3737, 'JOÃO CÂMARA', 'N', '240580', 'N', 'S', 'S', NULL, 55, 'S', 'N', 'N', '63', NULL, '03', 'N', NULL, NULL, NULL, 84);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240590', '2406', 'RN', '2490', '2401', '24007', '24', 'JOAO DIAS', NULL, '84', '59880000', '0', '1715', '1715', '18058', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 88.173, '-6,27400', '-37,79600', 436, 'S', 0.5870, NULL, NULL, '24900', 'S', 'N', 2560, NULL, '2490', '2490', NULL, '1963', 'S', 3738, 'JOÃO DIAS', 'N', '240590', 'N', 'S', 'S', NULL, 134, 'S', 'N', 'N', '64', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240600', '2406', 'RN', '2490', '2401', '24006', '24', 'JOSE DA PENHA', NULL, '84', '59980000', '7', '1717', '1717', '18059', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 117.634, '-6,31700', '-38,28100', 264, 'S', 0.6290, NULL, NULL, '24900', 'S', 'N', 2580, NULL, '2490', '2490', NULL, '1958', 'S', 3739, 'JOSÉ DA PENHA', 'N', '240600', 'N', 'S', 'S', NULL, 134, 'S', 'N', 'N', '65', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240610', '2404', 'RN', '2490', '2401', '24004', '24', 'JUCURUTU', NULL, '84', '59330000', '6', '1719', '1719', '18060', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 933.718, '-6,03400', '-37,02000', 63, 'S', 0.6370, NULL, NULL, '24900', 'S', 'N', 2598, NULL, '2490', '2490', NULL, '1935', 'S', 3740, 'JUCURUTU', 'N', '240610', 'N', 'S', 'S', NULL, 76, 'S', 'N', 'N', '66', NULL, '03', 'N', NULL, NULL, NULL, 83);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240615', '2401', 'RN', '2490', '2403', '24015', '24', 'JUNDIA', NULL, '84', '59188000', '5', '1108', NULL, '18168', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 45.261, '-6,27100', '-35,34500', 0, 'S', NULL, NULL, NULL, '24900', 'N', 'N', 5620, NULL, '2490', '2490', NULL, '2001', 'S', 5558, 'JUNDIÁ', 'N', '240615', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '67', NULL, '03', 'N', NULL, NULL, NULL, 148);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240620', '2401', 'RN', '2490', '2403', '24015', '24', 'LAGOA D''ANTA', NULL, '84', '59227000', '5', '1723', '1723', '18062', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 105.650, '-6,39100', '-35,59800', 154, 'S', 0.6010, NULL, NULL, '24900', 'S', 'N', 2650, NULL, '2490', '2490', NULL, '1962', 'S', 3741, 'LAGOA D ANTA', 'N', '240620', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '68', NULL, '03', 'N', NULL, NULL, NULL, 148);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240630', '2401', 'RN', '2490', '2403', '24015', '24', 'LAGOA DE PEDRAS', NULL, '84', '59244000', '4', '1725', '1725', '18063', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 117.660, '-6,14900', '-35,43800', 91, 'S', 0.5940, NULL, NULL, '24900', 'S', 'N', 2655, NULL, '2490', '2490', NULL, '1962', 'S', 3742, 'LAGOA DE PEDRAS', 'N', '240630', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '69', NULL, '03', 'N', NULL, NULL, NULL, 148);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240640', '2405', 'RN', '2490', '2403', '24014', '24', 'LAGOA DE VELHOS', NULL, '84', '59430000', '3', '1727', '1727', '18064', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 112.832, '-6,00400', '-35,87200', 154, 'S', 0.6300, NULL, NULL, '24900', 'S', 'N', 2657, NULL, '2490', '2490', NULL, '1962', 'S', 3743, 'LAGOA DE VELHOS', 'N', '240640', 'N', 'S', 'S', NULL, 123, 'N', 'N', 'N', '70', NULL, '03', 'N', NULL, NULL, NULL, 270);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240650', '2404', 'RN', '2490', '2402', '24010', '24', 'LAGOA NOVA', NULL, '84', '59390000', '2', '1729', '1729', '18065', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 176.299, '-6,09600', '-36,46900', 686, 'S', 0.6200, NULL, NULL, '24900', 'S', 'N', 2674, NULL, '2490', '2490', NULL, '1962', 'S', 3744, 'LAGOA NOVA', 'N', '240650', 'N', 'S', 'S', NULL, 76, 'S', 'N', 'N', '71', NULL, '03', 'N', NULL, NULL, NULL, 83);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240660', '2401', 'RN', '2490', '2403', '24015', '24', 'LAGOA SALGADA', NULL, '84', '59247000', '1', '1731', '1731', '18066', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 79.515, '-6,13400', '-35,49400', 99, 'S', 0.5980, NULL, NULL, '24900', 'S', 'N', 2676, NULL, '2490', '2490', NULL, '1962', 'S', 3745, 'LAGOA SALGADA', 'N', '240660', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '72', NULL, '03', 'N', NULL, NULL, NULL, 148);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240670', '2403', 'RN', '2490', '2402', '24009', '24', 'LAJES', NULL, '84', '59535000', '0', '1733', '1733', '18067', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 676.417, '-5,70000', '-36,24500', 199, 'S', 0.6400, NULL, NULL, '24900', 'S', 'N', 2696, NULL, '2490', '2490', NULL, '1890', 'S', 3746, 'LAJES', 'N', '240670', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '73', NULL, '03', 'N', NULL, NULL, NULL, 84);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240680', '2405', 'RN', '2490', '2403', '24014', '24', 'LAJES PINTADAS', NULL, '84', '59235000', '9', '1735', '1735', '18068', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 130.208, '-6,15000', '-36,11700', 315, 'S', 0.6550, NULL, NULL, '24900', 'S', 'N', 2697, NULL, '2490', '2490', NULL, '1958', 'S', 3747, 'LAJES PINTADAS', 'N', '240680', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '74', NULL, '03', 'N', NULL, NULL, NULL, 270);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240690', '2406', 'RN', '2490', '2401', '24007', '24', 'LUCRECIA', NULL, '84', '59805000', '8', '1737', '1737', '18069', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 30.935, '-6,12000', '-37,81600', 216, 'S', 0.6600, NULL, NULL, '24900', 'S', 'N', 2771, NULL, '2490', '2490', NULL, '1963', 'S', 3748, 'LUCRÉCIA', 'N', '240690', 'N', 'S', 'S', NULL, 134, 'N', 'N', 'N', '75', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240700', '2406', 'RN', '2490', '2401', '24005', '24', 'LUIS GOMES', NULL, '84', '59940000', '5', '1739', '1739', '18070', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 166.637, '-6,41400', '-38,38900', 636, 'S', 0.6440, NULL, NULL, '24900', 'S', 'N', 2775, NULL, '2490', '2490', NULL, '1890', 'S', 3749, 'LUÍS GOMES', 'N', '240700', 'N', 'S', 'S', NULL, 134, 'S', 'N', 'N', '76', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240710', '2407', 'RN', '2490', '2404', '24017', '24', 'MACAIBA', NULL, '84', '59280000', '4', '1741', '1741', '18071', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 512.487, '-5,85800', '-35,35400', 11, 'S', 0.6650, NULL, NULL, '24900', 'N', 'N', 2792, NULL, '2401', '2401', NULL, '1877', 'S', 3750, 'MACAÍBA', 'N', '240710', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '77', NULL, '02', 'N', NULL, NULL, NULL, 377);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240720', '2403', 'RN', '2490', '2402', '24008', '24', 'MACAU', NULL, '84', '59500000', '3', '1743', '1743', '18072', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 788.022, '-5,11500', '-36,63400', 4, 'S', 0.6900, NULL, NULL, '24900', 'S', 'N', 2800, NULL, '2490', '2490', NULL, '1847', 'S', 3751, 'MACAU', 'N', '240720', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '78', NULL, '03', 'N', NULL, NULL, NULL, 84);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240725', '2406', 'RN', '2490', '2401', '24005', '24', 'MAJOR SALES', NULL, '84', '59945000', '2', '0420', NULL, '18156', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 31.971, '-6,40600', '-38,32400', 306, 'S', 0.6300, NULL, NULL, '24900', 'S', 'N', 2832, NULL, '2490', '2490', NULL, '1997', 'S', 3752, 'MAJOR SALES', 'N', '240725', 'N', 'S', 'S', NULL, 134, 'N', 'N', 'N', '79', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240730', '2406', 'RN', '2490', '2401', '24006', '24', 'MARCELINO VIEIRA', NULL, '84', '59970000', '2', '1745', '1745', '18073', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 345.707, '-6,29400', '-38,16700', 230, 'S', 0.6130, NULL, NULL, '24900', 'S', 'N', 2903, NULL, '2490', '2490', NULL, '1953', 'S', 3753, 'MARCELINO VIEIRA', 'N', '240730', 'N', 'S', 'S', NULL, 134, 'S', 'N', 'N', '80', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240740', '2406', 'RN', '2490', '2401', '24007', '24', 'MARTINS', NULL, '84', '59800000', '1', '1747', '1747', '18074', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 169.466, '-6,08800', '-37,91100', 703, 'S', 0.6940, NULL, NULL, '24900', 'S', 'N', 2946, NULL, '2490', '2490', NULL, '1841', 'S', 3754, 'MARTINS', 'N', '240740', 'N', 'S', 'S', NULL, 134, 'S', 'N', 'N', '81', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240750', '2403', 'RN', '2490', '2404', '24016', '24', 'MAXARANGUAPE', NULL, '84', '59580000', '0', '1749', '1749', '18075', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 131.300, '-5,51600', '-35,26200', 7, 'S', 0.6090, NULL, NULL, '24900', 'S', 'N', 2996, NULL, '2490', '2490', NULL, '1958', 'S', 3755, 'MAXARANGUAPE', 'N', '240750', 'N', 'S', 'S', NULL, 55, 'S', 'N', 'N', '82', NULL, '03', 'N', NULL, NULL, NULL, 84);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352042', '3512', 'SP', '3507', '3514', '35055', '35', 'ILHA COMPRIDA', NULL, '13', '11925000', '6', '2969', '2969', '21620', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 188.530, '-24,74100', '-47,54000', 0, 'S', 0.8030, NULL, NULL, '35121', 'N', 'N', 2141, NULL, '3590', '3590', NULL, '1993', 'S', 4976, 'ILHA COMPRIDA', 'N', '352042', 'N', 'N', 'S', NULL, 100, 'N', 'N', 'N', '235', NULL, '03', 'N', NULL, NULL, NULL, 222);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220527', '2203', 'PI', '2202', '2202', '22004', '22', 'JATOBA DO PIAUI', NULL, '86', '64275000', '6', '0324', NULL, '16180', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 663.797, '-4,77100', '-41,81800', 240, 'S', 0.5870, NULL, NULL, '22900', 'S', 'N', 2527, NULL, '2290', '2290', NULL, '1997', 'S', 3064, 'JATOBÁ DO PIAUÍ', 'N', '220527', 'N', 'S', 'S', NULL, 28, 'S', 'N', 'N', '103', NULL, '03', 'N', NULL, NULL, NULL, 422);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220530', '2209', 'PI', '2203', '2203', '22009', '22', 'JERUMENHA', NULL, '89', '64830000', '0', '1105', '1105', '16053', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1693.772, '-7,08800', '-43,51000', 145, 'S', 0.6530, NULL, NULL, '22900', 'S', 'N', 2545, NULL, '2290', '2290', NULL, '1890', 'S', 3065, 'JERUMENHA', 'N', '220530', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '104', NULL, '03', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352050', '3507', 'SP', '3515', '3507', '35032', '35', 'INDAIATUBA', NULL, '19', '13331520', '9', '6511', '6511', '21206', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 310.564, '-23,09000', '-47,21800', 624, 'S', 0.8290, NULL, NULL, '35072', 'N', 'N', 2167, NULL, '3503', '3503', NULL, '1859', 'S', 4979, 'INDAIATUBA', 'N', '352050', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '238', NULL, '01', 'N', NULL, NULL, NULL, 515);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352060', '3511', 'SP', '3511', '3508', '35036', '35', 'INDIANA', NULL, '18', '19560000', '8', '6513', '6513', '21207', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 127.597, '-22,17400', '-51,25200', 479, 'S', 0.7890, NULL, NULL, '35112', 'N', 'N', 2170, NULL, '3590', '3590', NULL, '1948', 'S', 4980, 'INDIANA', 'N', '352060', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '239', NULL, '03', 'N', NULL, NULL, NULL, 323);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352070', '3515', 'SP', '3512', '3501', '35002', '35', 'INDIAPORA', NULL, '17', '15690000', '7', '6515', '6515', '21208', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 279.466, '-19,98000', '-50,29000', 440, 'S', 0.7720, NULL, NULL, '35154', 'N', 'N', 2173, NULL, '3590', '3590', NULL, '1953', 'S', 4981, 'INDIAPORÃ', 'N', '352070', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '240', NULL, '03', 'N', NULL, NULL, NULL, 276);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352080', '3509', 'SP', '3510', '3508', '35035', '35', 'INUBIA PAULISTA', NULL, '18', '17760000', '6', '6517', '6517', '21209', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 86.710, '-21,77000', '-50,96200', 467, 'S', 0.7860, NULL, NULL, '35091', 'N', 'N', 2190, NULL, '3590', '3590', NULL, '1958', 'S', 4982, 'INÚBIA PAULISTA', 'N', '352080', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '241', NULL, '03', 'N', NULL, NULL, NULL, 322);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352100', '3516', 'SP', '3508', '3512', '35046', '35', 'IPERO', NULL, '15', '18560000', '2', '6521', '6521', '21211', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 170.940, '-23,35000', '-47,68900', 590, 'S', 0.7790, NULL, NULL, '35163', 'N', 'N', 2202, NULL, '3590', '3513', NULL, '1964', 'S', 4984, 'IPERÓ', 'N', '352100', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '243', NULL, '03', 'N', NULL, NULL, NULL, 165);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352110', '3510', 'SP', '3514', '3506', '35026', '35', 'IPEUNA', NULL, '19', '13537000', '1', '6523', '6523', '21212', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 190.534, '-22,43600', '-47,71900', 635, 'S', 0.7860, NULL, NULL, '35104', 'N', 'N', 2203, NULL, '3590', '3590', NULL, '1964', 'S', 4985, 'IPEÚNA', 'N', '352110', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '244', NULL, '03', 'N', NULL, NULL, NULL, 43);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352115', '3515', 'SP', '3512', '3501', '35004', '35', 'IPIGUA', NULL, '17', '15108000', '0', '0800', NULL, '21633', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 135.617, '-20,65700', '-49,38700', 508, 'S', 0.7900, NULL, NULL, '35155', 'N', 'N', 2206, NULL, '3590', '3590', NULL, '1997', 'S', 4986, 'IPIGUÁ', 'N', '352115', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '245', NULL, '03', 'N', NULL, NULL, NULL, 392);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352120', '3512', 'SP', '3507', '3511', '35044', '35', 'IPORANGA', NULL, '15', '18330000', '0', '6525', '6525', '21213', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1160.293, '-24,58600', '-48,59300', 81, 'S', 0.6930, NULL, NULL, '35121', 'S', 'N', 2218, NULL, '3590', '3590', NULL, '1936', 'S', 4987, 'IPORANGA', 'N', '352120', 'N', 'N', 'S', NULL, 100, 'N', 'N', 'N', '246', NULL, '03', 'N', NULL, NULL, NULL, 222);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352130', '3508', 'SP', '3513', '3502', '35010', '35', 'IPUA', NULL, '16', '14610000', '9', '6527', '6527', '21214', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 465.602, '-20,43800', '-48,01200', 555, 'S', 0.7800, NULL, NULL, '35082', 'N', 'N', 2220, NULL, '3590', '3590', NULL, '1948', 'S', 4988, 'IPUÃ', 'N', '352130', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '247', NULL, '03', 'N', NULL, NULL, NULL, 271);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352140', '3510', 'SP', '3514', '3506', '35027', '35', 'IRACEMAPOLIS', NULL, '19', '13495000', '8', '6529', '6529', '21215', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 115.947, '-22,58100', '-47,51900', 608, 'S', 0.8280, NULL, NULL, '35102', 'N', 'N', 2232, NULL, '3590', '3508', NULL, '1953', 'S', 4989, 'IRACEMÁPOLIS', 'N', '352140', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '248', NULL, '03', 'N', NULL, NULL, NULL, 327);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352150', '3515', 'SP', '3512', '3501', '35008', '35', 'IRAPUA', NULL, '17', '14990000', '7', '6531', '6531', '21216', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 257.423, '-21,27900', '-49,40900', 428, 'S', 0.7660, NULL, NULL, '35151', 'N', 'N', 2240, NULL, '3590', '3590', NULL, '1944', 'S', 4990, 'IRAPUÃ', 'N', '352150', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '249', NULL, '03', 'N', NULL, NULL, NULL, 382);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352160', '3511', 'SP', '3511', '3508', '35035', '35', 'IRAPURU', NULL, '18', '17880000', '6', '6533', '6533', '21217', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 213.403, '-21,57100', '-51,34500', 436, 'S', 0.7600, NULL, NULL, '35111', 'N', 'N', 2241, NULL, '3590', '3590', NULL, '1953', 'S', 4991, 'IRAPURU', 'N', '352160', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '250', NULL, '03', 'N', NULL, NULL, NULL, 431);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352170', '3516', 'SP', '3508', '3511', '35041', '35', 'ITABERA', NULL, '15', '18440000', '5', '6535', '6535', '21218', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1082.851, '-23,86200', '-49,13700', 651, 'S', 0.7350, NULL, NULL, '35162', 'N', 'N', 2260, NULL, '3590', '3590', NULL, '1891', 'S', 4992, 'ITABERÁ', 'N', '352170', 'N', 'N', 'S', NULL, 89, 'N', 'N', 'N', '251', NULL, '03', 'N', NULL, NULL, NULL, 159);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352180', '3506', 'SP', '3509', '3504', '35022', '35', 'ITAI', NULL, '14', '18730000', '4', '6537', '6537', '21219', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1112.267, '-23,41800', '-49,09100', 614, 'S', 0.7280, NULL, NULL, '35061', 'N', 'N', 2288, NULL, '3590', '3590', NULL, '1981', 'S', 4993, 'ITAÍ', 'N', '352180', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '252', NULL, '03', 'N', NULL, NULL, NULL, 102);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352190', '3515', 'SP', '3512', '3501', '35008', '35', 'ITAJOBI', NULL, '17', '15840000', '3', '6539', '6539', '21220', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 501.842, '-21,31800', '-49,05400', 453, 'S', 0.7980, NULL, NULL, '35151', 'N', 'N', 2301, NULL, '3590', '3590', NULL, '1918', 'S', 4994, 'ITAJOBI', 'N', '352190', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '253', NULL, '03', 'N', NULL, NULL, NULL, 382);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352215', '3516', 'SP', '3508', '3511', '35044', '35', 'ITAOCA', NULL, '15', '18360000', '8', '3053', '3053', '21604', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 182.495, '-24,64000', '-48,84300', 155, 'S', 0.6500, NULL, NULL, '35162', 'S', 'N', 2327, NULL, '3590', '3590', NULL, '1993', 'S', 4997, 'ITAÓCA', 'N', '352215', 'N', 'N', 'S', NULL, 100, 'N', 'N', 'N', '256', NULL, '03', 'N', NULL, NULL, NULL, 159);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352230', '3516', 'SP', '3508', '3511', '35042', '35', 'ITAPETININGA', NULL, '15', '18200000', '7', '6547', '6547', '21224', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1792.079, '-23,59200', '-48,05300', 656, 'S', 0.7860, NULL, NULL, '35161', 'N', 'N', 2345, NULL, '3590', '3590', NULL, '1771', 'S', 4999, 'ITAPETININGA', 'N', '352230', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '258', NULL, '01', 'N', NULL, NULL, NULL, 158);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352240', '3516', 'SP', '3508', '3511', '35041', '35', 'ITAPEVA', NULL, '15', '18400000', '6', '6549', '6549', '21225', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1826.754, '-23,98200', '-48,87600', 684, 'S', 0.7450, NULL, NULL, '35162', 'N', 'N', 2347, NULL, '3590', '3590', NULL, '1769', 'S', 5000, 'ITAPEVA', 'N', '352240', 'N', 'N', 'S', NULL, 89, 'N', 'N', 'N', '259', NULL, '02', 'N', NULL, NULL, NULL, 159);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352260', '3514', 'SP', '3515', '3507', '35031', '35', 'ITAPIRA', NULL, '19', '13970000', '4', '6553', '6553', '21227', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 517.504, '-22,43600', '-46,82200', 643, 'S', 0.7940, NULL, NULL, '35141', 'N', 'N', 2351, NULL, '3590', '3509', NULL, '1858', 'S', 5002, 'ITAPIRA', 'N', '352260', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '261', NULL, '02', 'N', NULL, NULL, NULL, 432);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352265', '3516', 'SP', '3508', '3511', '35044', '35', 'ITAPIRAPUA PAULISTA', NULL, '15', '18385000', '3', '3055', '3055', '21621', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 406.306, '-24,57400', '-49,16800', 589, 'S', 0.6450, NULL, NULL, '35162', 'S', 'N', 2355, NULL, '3590', '3590', NULL, '1993', 'S', 5003, 'ITAPIRAPUÃ PAULISTA', 'N', '352265', 'N', 'N', 'S', NULL, 100, 'S', 'N', 'N', '262', NULL, '03', 'N', NULL, NULL, NULL, 159);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352280', '3506', 'SP', '3509', '3511', '35041', '35', 'ITAPORANGA', NULL, '15', '18480000', '2', '6557', '6557', '21229', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 507.737, '-23,70800', '-49,49000', 589, 'S', 0.7090, NULL, NULL, '35061', 'N', 'N', 2365, NULL, '3590', '3590', NULL, '1871', 'S', 5005, 'ITAPORANGA', 'N', '352280', 'N', 'N', 'S', NULL, 89, 'N', 'N', 'N', '264', NULL, '03', 'N', NULL, NULL, NULL, 102);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352320', '3516', 'SP', '3508', '3511', '35041', '35', 'ITARARE', NULL, '15', '18460000', '6', '6565', '6565', '21233', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1003.576, '-24,11500', '-49,34100', 740, 'S', 0.7320, NULL, NULL, '35162', 'N', 'N', 2380, NULL, '3590', '3590', NULL, '1893', 'S', 5009, 'ITARARÉ', 'N', '352320', 'N', 'N', 'S', NULL, 89, 'N', 'N', 'N', '268', NULL, '02', 'N', NULL, NULL, NULL, 159);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352340', '3507', 'SP', '3515', '3512', '35048', '35', 'ITATIBA', NULL, '11', '13250000', '4', '6569', '6569', '21235', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 322.522, '-23,00600', '-46,83900', 750, 'S', 0.8280, NULL, NULL, '35072', 'N', 'N', 2386, NULL, '3503', '3590', NULL, '1857', 'S', 5011, 'ITATIBA', 'N', '352340', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '270', NULL, '01', 'N', NULL, NULL, NULL, 515);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352360', '3510', 'SP', '3514', '3506', '35026', '35', 'ITIRAPINA', NULL, '19', '13530000', '2', '6573', '6573', '21237', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 564.261, '-22,25300', '-47,82300', 770, 'S', 0.7830, NULL, NULL, '35104', 'N', 'N', 2404, NULL, '3590', '3590', NULL, '1935', 'S', 5013, 'ITIRAPINA', 'N', '352360', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '272', NULL, '03', 'N', NULL, NULL, NULL, 43);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352370', '3508', 'SP', '3513', '3502', '35012', '35', 'ITIRAPUA', NULL, '16', '14420000', '1', '6575', '6575', '21238', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 161.490, '-20,64100', '-47,21900', 865, 'S', 0.7600, NULL, NULL, '35081', 'N', 'N', 2405, NULL, '3590', '3590', NULL, '1948', 'S', 5014, 'ITIRAPUÃ', 'N', '352370', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '273', NULL, '03', 'N', NULL, NULL, NULL, 101);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352380', '3514', 'SP', '3515', '3507', '35030', '35', 'ITOBI', NULL, '19', '13715000', '0', '6577', '6577', '21239', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 138.610, '-21,73700', '-46,97500', 658, 'S', 0.7820, NULL, NULL, '35143', 'N', 'N', 2408, NULL, '3590', '3590', NULL, '1959', 'S', 5015, 'ITOBI', 'N', '352380', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '274', NULL, '03', 'N', NULL, NULL, NULL, 279);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352390', '3516', 'SP', '3508', '3512', '35046', '35', 'ITU', NULL, '11', '13300000', '9', '6579', '6579', '21240', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 639.981, '-23,26400', '-47,29900', 583, 'S', 0.8150, NULL, NULL, '35163', 'N', 'N', 2410, NULL, '3590', '3513', NULL, '1657', 'S', 5016, 'ITU', 'N', '352390', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '275', NULL, '01', 'N', NULL, NULL, NULL, 165);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220635', '2202', 'PI', '2202', '2202', '22004', '22', 'MILTON BRANDAO', NULL, '86', '64253000', '7', '0348', NULL, '16192', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1371.766, '-4,68400', '-41,42200', 322, 'S', 0.4940, NULL, NULL, '22900', 'S', 'N', 3026, NULL, '2290', '2290', NULL, '1997', 'S', 3090, 'MILTON BRANDÃO', 'N', '220635', 'N', 'S', 'S', NULL, 161, 'S', 'N', 'N', '129', NULL, '03', 'N', NULL, NULL, NULL, 196);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220640', '2204', 'PI', '2203', '2202', '22003', '22', 'MONSENHOR GIL', NULL, '86', '64450000', '7', '1127', '1127', '16064', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 582.058, '-5,56400', '-42,60800', 116, 'S', 0.6220, NULL, NULL, '22900', 'S', 'N', 3085, NULL, '2201', '2290', NULL, '1963', 'S', 3091, 'MONSENHOR GIL', 'N', '220640', 'N', 'S', 'S', NULL, 45, 'N', 'N', 'N', '130', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220650', '2206', 'PI', '2204', '2204', '22014', '22', 'MONSENHOR HIPOLITO', NULL, '89', '64650000', '6', '1129', '1129', '16065', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 391.304, '-6,99600', '-41,03000', 257, 'S', 0.6020, NULL, NULL, '22900', 'S', 'N', 3086, NULL, '2290', '2290', NULL, '1956', 'S', 3092, 'MONSENHOR HIPÓLITO', 'N', '220650', 'N', 'S', 'S', NULL, 96, 'N', 'N', 'N', '131', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220660', '2211', 'PI', '2206', '2203', '22010', '22', 'MONTE ALEGRE DO PIAUI', NULL, '89', '64940000', '5', '1131', '1131', '16066', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 2417.854, '-9,75400', '-45,30400', 453, 'S', 0.5850, NULL, NULL, '22900', 'S', 'N', 3099, NULL, '2290', '2290', NULL, '1955', 'S', 3093, 'MONTE ALEGRE DO PIAUÍ', 'N', '220660', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '132', NULL, '03', 'N', NULL, NULL, NULL, 199);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220665', '2211', 'PI', '2206', '2203', '22012', '22', 'MORRO CABECA NO TEMPO', NULL, '89', '64968000', '4', '0350', NULL, '16193', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 2210.922, '-9,72500', '-43,90100', 479, 'S', 0.5580, NULL, NULL, '22900', 'S', 'N', 3146, NULL, '2290', '2290', NULL, '1997', 'S', 3094, 'MORRO CABEÇA NO TEMPO', 'N', '220665', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '133', NULL, '03', 'N', NULL, NULL, NULL, 199);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220667', '2202', 'PI', '2202', '2201', '22001', '22', 'MORRO DO CHAPEU DO PIAUI', NULL, '86', '64178000', '0', '0352', NULL, '16194', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 328.284, '-3,74300', '-42,31200', 99, 'S', 0.5190, NULL, NULL, '22900', 'S', 'N', 3150, NULL, '2290', '2290', NULL, '1997', 'S', 3095, 'MORRO DO CHAPÉU DO PIAUÍ', 'N', '220667', 'N', 'S', 'S', NULL, 161, 'S', 'N', 'N', '134', NULL, '03', 'N', NULL, NULL, NULL, 196);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220669', '2201', 'PI', '2201', '2201', '22002', '22', 'MURICI DOS PORTELAS', NULL, '86', '64175000', '6', '0354', NULL, '16195', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 481.521, '-3,31900', '-42,09400', 19, 'S', 0.4940, NULL, NULL, '22900', 'S', 'N', 3187, NULL, '2290', '2290', NULL, '1997', 'S', 3096, 'MURICI DOS PORTELAS', 'N', '220669', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '135', NULL, '03', 'N', NULL, NULL, NULL, 365);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220670', '2209', 'PI', '2203', '2203', '22009', '22', 'NAZARE DO PIAUI', NULL, '89', '64825000', '4', '1133', '1133', '16067', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1311.565, '-6,97300', '-42,67200', 136, 'S', 0.5750, NULL, NULL, '22900', 'S', 'N', 3213, NULL, '2290', '2290', NULL, '1955', 'S', 3097, 'NAZARÉ DO PIAUÍ', 'N', '220670', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '136', NULL, '03', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352400', '3507', 'SP', '3516', '3512', '35047', '35', 'ITUPEVA', NULL, '11', '13295000', '6', '6581', '6581', '21241', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 200.516, '-23,15300', '-47,05800', 675, 'S', 0.8070, NULL, NULL, '35073', 'N', 'N', 2417, NULL, '3504', '3507', NULL, '1964', 'S', 5017, 'ITUPEVA', 'N', '352400', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '276', NULL, '03', 'N', NULL, NULL, NULL, 41);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352410', '3508', 'SP', '3513', '3502', '35011', '35', 'ITUVERAVA', NULL, '16', '14500000', '5', '6583', '6583', '21242', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 697.760, '-20,33900', '-47,78100', 605, 'S', 0.7890, NULL, NULL, '35083', 'N', 'N', 2422, NULL, '3590', '3590', NULL, '1885', 'S', 5018, 'ITUVERAVA', 'N', '352410', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '277', NULL, '03', 'N', NULL, NULL, NULL, 272);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352430', '3513', 'SP', '3514', '3502', '35013', '35', 'JABOTICABAL', NULL, '16', '14870000', '3', '6587', '6587', '21244', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 706.499, '-21,25500', '-48,32200', 605, 'S', 0.8150, NULL, NULL, '35131', 'N', 'N', 2439, NULL, '3590', '3590', NULL, '1867', 'S', 5020, 'JABOTICABAL', 'N', '352430', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '279', NULL, '02', 'N', NULL, NULL, NULL, 383);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352440', '3517', 'SP', '3517', '3513', '35050', '35', 'JACAREI', NULL, '12', '12300000', '2', '6589', '6589', '21245', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 460.073, '-23,30500', '-45,96600', 567, 'S', 0.8090, NULL, NULL, '35171', 'N', 'N', 2446, NULL, '3590', '3512', NULL, '1653', 'S', 5021, 'JACAREÍ', 'N', '352440', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '280', NULL, '01', 'N', NULL, NULL, NULL, 324);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352450', '3515', 'SP', '3512', '3501', '35004', '35', 'JACI', NULL, '17', '15155000', '1', '6591', '6591', '21246', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 144.441, '-20,88200', '-49,57000', 545, 'S', 0.7810, NULL, NULL, '35156', 'N', 'N', 2448, NULL, '3590', '3590', NULL, '1959', 'S', 5022, 'JACI', 'N', '352450', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '281', NULL, '03', 'N', NULL, NULL, NULL, 160);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352460', '3512', 'SP', '3507', '3514', '35055', '35', 'JACUPIRANGA', NULL, '13', '11940000', '0', '6593', '6593', '21247', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 708.382, '-24,69300', '-48,00200', 33, 'S', 0.7600, NULL, NULL, '35121', 'N', 'N', 2457, NULL, '3590', '3590', NULL, '1927', 'S', 5023, 'JACUPIRANGA', 'N', '352460', 'N', 'N', 'S', NULL, 100, 'N', 'N', 'N', '282', NULL, '03', 'N', NULL, NULL, NULL, 222);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352470', '3507', 'SP', '3515', '3507', '35032', '35', 'JAGUARIUNA', NULL, '19', '13820000', '9', '6595', '6595', '21248', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 142.437, '-22,70600', '-46,98600', 584, 'S', 0.8290, NULL, NULL, '35072', 'N', 'N', 2472, NULL, '3503', '3503', NULL, '1953', 'S', 5024, 'JAGUARIÚNA', 'N', '352470', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '283', NULL, '01', 'N', NULL, NULL, NULL, 515);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352480', '3515', 'SP', '3512', '3501', '35001', '35', 'JALES', NULL, '17', '15700000', '8', '6597', '6597', '21249', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 368.757, '-20,26900', '-50,54600', 478, 'S', 0.8040, NULL, NULL, '35153', 'N', 'N', 2477, NULL, '3590', '3590', NULL, '1948', 'S', 5025, 'JALES', 'N', '352480', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '284', NULL, '03', 'N', NULL, NULL, NULL, 436);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352490', '3517', 'SP', '3517', '3513', '35053', '35', 'JAMBEIRO', NULL, '12', '12270000', '7', '6599', '6599', '21250', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 183.758, '-23,25400', '-45,68800', 695, 'S', 0.7790, NULL, NULL, '35171', 'N', 'N', 2478, NULL, '3590', '3590', NULL, '1876', 'S', 5026, 'JAMBEIRO', 'N', '352490', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '285', NULL, '03', 'N', NULL, NULL, NULL, 324);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352510', '3513', 'SP', '3514', '3502', '35014', '35', 'JARDINOPOLIS', NULL, '16', '14680000', '2', '6603', '6603', '21252', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 503.355, '-21,01800', '-47,76400', 590, 'S', 0.8080, NULL, NULL, '35132', 'N', 'N', 2516, NULL, '3590', '3590', NULL, '1898', 'S', 5028, 'JARDINÓPOLIS', 'N', '352510', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '287', NULL, '03', 'N', NULL, NULL, NULL, 273);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352520', '3507', 'SP', '3516', '3512', '35048', '35', 'JARINU', NULL, '11', '13240000', '1', '6605', '6605', '21253', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 207.671, '-23,10100', '-46,72800', 755, 'S', 0.7590, NULL, NULL, '35073', 'N', 'N', 2518, NULL, '3504', '3590', NULL, '1948', 'S', 5029, 'JARINU', 'N', '352520', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '288', NULL, '03', 'N', NULL, NULL, NULL, 41);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352540', '3508', 'SP', '3513', '3502', '35012', '35', 'JERIQUARA', NULL, '16', '14450000', '9', '6609', '6609', '21255', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 140.992, '-20,31100', '-47,58900', 860, 'S', 0.7480, NULL, NULL, '35081', 'N', 'N', 2543, NULL, '3590', '3590', NULL, '1964', 'S', 5031, 'JERIQUARA', 'N', '352540', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '290', NULL, '03', 'N', NULL, NULL, NULL, 101);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352550', '3507', 'SP', '3516', '3512', '35048', '35', 'JOANOPOLIS', NULL, '11', '12980000', '8', '6611', '6611', '21256', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 374.583, '-22,93000', '-46,27600', 906, 'S', 0.7660, NULL, NULL, '35071', 'N', 'N', 2556, NULL, '3590', '3590', NULL, '1895', 'S', 5032, 'JOANÓPOLIS', 'N', '352550', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '291', NULL, '03', 'N', NULL, NULL, NULL, 275);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352560', '3511', 'SP', '3511', '3508', '35036', '35', 'JOAO RAMALHO', NULL, '18', '19680000', '7', '6613', '6613', '21257', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 416.035, '-22,25000', '-50,76800', 551, 'S', 0.7760, NULL, NULL, '35113', 'N', 'N', 2567, NULL, '3590', '3590', NULL, '1959', 'S', 5033, 'JOÃO RAMALHO', 'N', '352560', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '292', NULL, '03', 'N', NULL, NULL, NULL, 154);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352570', '3515', 'SP', '3512', '3501', '35004', '35', 'JOSE BONIFACIO', NULL, '17', '15200000', '6', '6615', '6615', '21258', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 858.641, '-21,05300', '-49,68800', 458, 'S', 0.8170, NULL, NULL, '35156', 'N', 'N', 2579, NULL, '3590', '3590', NULL, '1926', 'S', 5034, 'JOSÉ BONIFÁCIO', 'N', '352570', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '293', NULL, '03', 'N', NULL, NULL, NULL, 160);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352580', '3509', 'SP', '3510', '3504', '35019', '35', 'JULIO MESQUITA', NULL, '14', '17550000', '5', '6617', '6617', '21259', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 128.209, '-22,00900', '-49,78700', 520, 'S', 0.7550, NULL, NULL, '35093', 'N', 'N', 2603, NULL, '3590', '3590', NULL, '1948', 'S', 5035, 'JÚLIO MESQUITA', 'N', '352580', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '294', NULL, '03', 'N', NULL, NULL, NULL, 96);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352585', '3516', 'SP', '3508', '3506', '35028', '35', 'JUMIRIM', NULL, '15', '18535000', '4', '0802', NULL, '21634', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 56.738, '-23,08700', '-47,78400', 561, 'S', 0.7950, NULL, NULL, '35163', 'N', 'N', 2604, NULL, '3590', '3590', NULL, '1997', 'S', 5036, 'JUMIRIM', 'N', '352585', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '295', NULL, '03', 'N', NULL, NULL, NULL, 165);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352590', '3507', 'SP', '3516', '3512', '35047', '35', 'JUNDIAI', NULL, '11', '13200970', '4', '6619', '6619', '21260', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 431.969, '-23,18600', '-46,88400', 761, 'S', 0.8570, NULL, NULL, '35073', 'N', 'N', 2608, NULL, '3504', '3507', NULL, '1655', 'S', 5037, 'JUNDIAÍ', 'N', '352590', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '296', NULL, '01', 'N', NULL, NULL, NULL, 41);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352600', '3511', 'SP', '3511', '3508', '35034', '35', 'JUNQUEIROPOLIS', NULL, '18', '17890000', '1', '6621', '6621', '21261', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 582.836, '-21,51500', '-51,43400', 421, 'S', 0.7660, NULL, NULL, '35111', 'N', 'N', 2611, NULL, '3590', '3590', NULL, '1948', 'S', 5038, 'JUNQUEIRÓPOLIS', 'N', '352600', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '297', NULL, '03', 'N', NULL, NULL, NULL, 431);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240760', '2402', 'RN', '2490', '2401', '24003', '24', 'MESSIAS TARGINO', NULL, '84', '59775000', '9', '1721', '1721', '18061', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 135.094, '-6,07900', '-37,51400', 181, 'S', 0.6140, NULL, NULL, '24900', 'S', 'N', 3016, NULL, '2490', '2490', NULL, '1962', 'S', 3756, 'MESSIAS TARGINO', 'N', '240760', 'N', 'S', 'S', NULL, 32, 'S', 'N', 'N', '83', NULL, '03', 'N', NULL, NULL, NULL, 147);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240770', '2401', 'RN', '2490', '2404', '24019', '24', 'MONTANHAS', NULL, '84', '59198000', '8', '1753', '1753', '18077', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 82.213, '-6,48600', '-35,28800', 87, 'S', 0.5860, NULL, NULL, '24900', 'S', 'N', 3092, NULL, '2490', '2490', NULL, '1962', 'S', 3757, 'MONTANHAS', 'N', '240770', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '84', NULL, '03', 'N', NULL, NULL, NULL, 148);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240780', '2401', 'RN', '2490', '2403', '24015', '24', 'MONTE ALEGRE', NULL, '84', '59182000', '7', '1755', '1755', '18078', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 199.519, '-6,06800', '-35,33200', 52, 'S', 0.6450, NULL, NULL, '24900', 'S', 'N', 3095, NULL, '2401', '2490', NULL, '1953', 'S', 3758, 'MONTE ALEGRE', 'N', '240780', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '85', NULL, '03', 'N', NULL, NULL, NULL, 148);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240790', '2401', 'RN', '2490', '2403', '24014', '24', 'MONTE DAS GAMELEIRAS', NULL, '84', '59217000', '6', '1757', '1757', '18079', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 71.945, '-6,44100', '-35,78300', 501, 'S', 0.5930, NULL, NULL, '24900', 'S', 'N', 3112, NULL, '2490', '2490', NULL, '1963', 'S', 3759, 'MONTE DAS GAMELEIRAS', 'N', '240790', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '86', NULL, '03', 'N', NULL, NULL, NULL, 148);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240800', '2402', 'RN', '2490', '2401', '24001', '24', 'MOSSORO', NULL, '84', '59600970', '3', '1759', '1759', '18080', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 2110.207, '-5,18800', '-37,34400', 16, 'S', 0.7350, NULL, NULL, '24900', 'N', 'N', 3159, NULL, '2490', '2490', NULL, '1852', 'S', 3760, 'MOSSORÓ', 'N', '240800', 'N', 'S', 'S', NULL, 1, 'S', 'S', 'S', '87', NULL, '01', 'N', NULL, NULL, NULL, 147);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240810', '2407', 'RN', '2490', '2404', '24018', '24', 'NATAL', NULL, '84', '59001970', '2', '1761', '1761', '18081', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'S', 170.298, '-5,79500', '-35,20900', 30, 'S', 0.7880, NULL, NULL, '24900', 'N', 'N', 3201, NULL, '2401', '2401', NULL, '1599', 'S', 3761, 'NATAL', 'N', '240810', 'N', 'S', 'S', NULL, NULL, 'S', 'S', 'S', '88', NULL, '01', 'N', NULL, NULL, NULL, 377);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240820', '2401', 'RN', '2490', '2404', '24017', '24', 'NISIA FLORESTA', NULL, '84', '59164000', '1', '1763', '1763', '18082', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 306.051, '-6,09100', '-35,20900', 20, 'S', 0.6660, NULL, NULL, '24900', 'S', 'N', 3232, NULL, '2401', '2490', NULL, '1852', 'S', 3762, 'NÍSIA FLORESTA', 'N', '240820', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '89', NULL, '03', 'N', NULL, NULL, NULL, 148);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240830', '2401', 'RN', '2490', '2403', '24015', '24', 'NOVA CRUZ', NULL, '84', '59215000', '0', '1765', '1765', '18083', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 277.657, '-6,47800', '-35,43400', 73, 'S', 0.6170, NULL, NULL, '24900', 'N', 'N', 3274, NULL, '2490', '2490', NULL, '1852', 'S', 3763, 'NOVA CRUZ', 'N', '240830', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '90', NULL, '03', 'N', NULL, NULL, NULL, 148);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240840', '2406', 'RN', '2490', '2401', '24007', '24', 'OLHO-D''AGUA DO BORGES', NULL, '84', '59730000', '9', '1767', '1767', '18084', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 141.170, '-5,95600', '-37,70600', 164, 'S', 0.6310, NULL, NULL, '24900', 'S', 'N', 3396, NULL, '2490', '2490', NULL, '1963', 'S', 3764, 'OLHO-D ÁGUA DO BORGES', 'N', '240840', 'N', 'S', 'S', NULL, 32, 'S', 'N', 'N', '91', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240850', '2404', 'RN', '2490', '2402', '24012', '24', 'OURO BRANCO', NULL, '84', '59347000', '8', '1769', '1769', '18085', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 253.300, '-6,70100', '-36,94600', 223, 'S', 0.7020, NULL, NULL, '24900', 'N', 'N', 3437, NULL, '2490', '2490', NULL, '1953', 'S', 3765, 'OURO BRANCO', 'N', '240850', 'N', 'S', 'S', NULL, 76, 'S', 'N', 'N', '92', NULL, '03', 'N', NULL, NULL, NULL, 83);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240860', '2406', 'RN', '2490', '2401', '24006', '24', 'PARANA', NULL, '84', '59950000', '7', '1771', '1771', '18086', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 81.390, '-6,48600', '-38,31300', 373, 'S', 0.6090, NULL, NULL, '24900', 'S', 'N', 3542, NULL, '2490', '2490', NULL, '1963', 'S', 3766, 'PARANÁ', 'N', '240860', 'N', 'S', 'S', NULL, 134, 'S', 'N', 'N', '93', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240870', '2402', 'RN', '2490', '2401', '24003', '24', 'PARAU', NULL, '84', '59660000', '6', '1773', '1773', '18087', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 410.858, '-5,77400', '-37,10100', 75, 'S', 0.6120, NULL, NULL, '24900', 'S', 'N', 3560, NULL, '2490', '2490', NULL, '1962', 'S', 5584, 'PARAÚ', 'N', '240870', 'N', 'S', 'S', NULL, 32, 'N', 'N', 'N', '94', NULL, '03', 'N', NULL, NULL, NULL, 37);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240880', '2403', 'RN', '2490', '2403', '24013', '24', 'PARAZINHO', NULL, '84', '59586000', '5', '1775', '1775', '18088', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 274.668, '-5,22300', '-35,83800', 71, 'S', 0.5640, NULL, NULL, '24900', 'S', 'N', 3563, NULL, '2490', '2490', NULL, '1962', 'S', 3767, 'PARAZINHO', 'N', '240880', 'N', 'S', 'S', NULL, 55, 'S', 'N', 'N', '95', NULL, '03', 'N', NULL, NULL, NULL, 84);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240890', '2404', 'RN', '2490', '2402', '24012', '24', 'PARELHAS', NULL, '84', '59360000', '4', '1777', '1777', '18089', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 513.052, '-6,68800', '-36,65800', 266, 'S', 0.7040, NULL, NULL, '24900', 'N', 'N', 3567, NULL, '2490', '2490', NULL, '1926', 'S', 3768, 'PARELHAS', 'N', '240890', 'N', 'S', 'S', NULL, 76, 'N', 'N', 'N', '96', NULL, '03', 'N', NULL, NULL, NULL, 83);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240895', '2403', 'RN', '2490', '2404', '24016', '24', 'RIO DO FOGO', NULL, '84', '59578000', '3', '0422', '0422', '18161', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 150.282, '-5,27300', '-35,38300', 30, 'S', 0.5980, NULL, NULL, '24900', 'S', 'N', 4158, NULL, '2490', '2490', NULL, '1997', 'S', 3789, 'RIO DO FOGO', 'N', '240895', 'N', 'S', 'S', NULL, 55, 'S', 'N', 'N', '118', NULL, '03', 'N', NULL, NULL, NULL, 84);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240910', '2401', 'RN', '2490', '2403', '24015', '24', 'PASSA E FICA', NULL, '84', '59218000', '0', '1781', '1781', '18091', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 42.137, '-6,43600', '-35,64300', 189, 'S', 0.6110, NULL, NULL, '24900', 'S', 'N', 3580, NULL, '2490', '2490', NULL, '1962', 'S', 3770, 'PASSA E FICA', 'N', '240910', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '98', NULL, '03', 'N', NULL, NULL, NULL, 148);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240920', '2401', 'RN', '2490', '2403', '24015', '24', 'PASSAGEM', NULL, '84', '59259000', '9', '1783', '1783', '18092', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 41.235, '-6,27900', '-35,37800', 65, 'S', 0.6480, NULL, NULL, '24900', 'S', 'N', 3587, NULL, '2490', '2490', NULL, '1963', 'S', 3771, 'PASSAGEM', 'N', '240920', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '99', NULL, '03', 'N', NULL, NULL, NULL, 148);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240930', '2406', 'RN', '2490', '2401', '24007', '24', 'PATU', NULL, '84', '59770000', '8', '1785', '1785', '18093', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 319.132, '-6,11000', '-37,63700', 248, 'S', 0.6760, NULL, NULL, '24900', 'S', 'N', 3607, NULL, '2490', '2490', NULL, '1890', 'S', 3772, 'PATU', 'N', '240930', 'N', 'S', 'S', NULL, 32, 'S', 'N', 'N', '100', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240933', '2405', 'RN', '2490', '2403', '24015', '24', 'SANTA MARIA', NULL, '84', '59464000', '2', '0424', NULL, '18162', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 219.572, '-5,84000', '-35,69500', 115, 'S', 0.6270, NULL, NULL, '24900', 'S', 'N', 4373, NULL, '2490', '2490', NULL, '1997', 'S', 3793, 'SANTA MARIA', 'N', '240933', 'N', 'S', 'S', NULL, 123, 'S', 'N', 'N', '122', NULL, '03', 'N', NULL, NULL, NULL, 270);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240940', '2406', 'RN', '2490', '2401', '24006', '24', 'PAU DOS FERROS', NULL, '84', '59900000', '7', '1787', '1787', '18094', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 259.960, '-6,11100', '-38,20900', 193, 'S', 0.7250, NULL, NULL, '24900', 'N', 'N', 3612, NULL, '2490', '2490', NULL, '1856', 'S', 3773, 'PAU DOS FERROS', 'N', '240940', 'N', 'S', 'S', NULL, 134, 'S', 'N', 'S', '101', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240950', '2403', 'RN', '2490', '2404', '24016', '24', 'PEDRA GRANDE', NULL, '84', '59588000', '6', '1789', '1789', '18095', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 221.429, '-5,15000', '-35,87900', 25, 'S', 0.5870, NULL, NULL, '24900', 'S', 'N', 3648, NULL, '2490', '2490', NULL, '1962', 'S', 3774, 'PEDRA GRANDE', 'N', '240950', 'N', 'S', 'S', NULL, 55, 'S', 'N', 'N', '102', NULL, '03', 'N', NULL, NULL, NULL, 84);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240960', '2403', 'RN', '2490', '2402', '24009', '24', 'PEDRA PRETA', NULL, '84', '59547000', '5', '1791', '1791', '18096', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 294.979, '-5,58300', '-36,10500', 168, 'S', 0.5750, NULL, NULL, '24900', 'S', 'N', 3652, NULL, '2490', '2490', NULL, '1963', 'S', 3775, 'PEDRA PRETA', 'N', '240960', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '103', NULL, '03', 'N', NULL, NULL, NULL, 84);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240970', '2403', 'RN', '2490', '2402', '24009', '24', 'PEDRO AVELINO', NULL, '84', '59530000', '4', '1793', '1793', '18097', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 952.688, '-5,52200', '-36,38800', 95, 'S', 0.6220, NULL, NULL, '24900', 'S', 'N', 3667, NULL, '2490', '2490', NULL, '1948', 'S', 3776, 'PEDRO AVELINO', 'N', '240970', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '104', NULL, '03', 'N', NULL, NULL, NULL, 84);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240980', '2401', 'RN', '2490', '2404', '24019', '24', 'PEDRO VELHO', NULL, '84', '59196000', '3', '1795', '1795', '18098', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 192.707, '-6,43900', '-35,22100', 22, 'S', 0.6260, NULL, NULL, '24900', 'S', 'N', 3678, NULL, '2490', '2490', NULL, '1890', 'S', 3777, 'PEDRO VELHO', 'N', '240980', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '105', NULL, '03', 'N', NULL, NULL, NULL, 148);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240990', '2402', 'RN', '2490', '2401', '24004', '24', 'PENDENCIAS', NULL, '84', '59504000', '2', '1797', '1797', '18099', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 419.141, '-5,26000', '-36,72200', 16, 'S', 0.6310, NULL, NULL, '24900', 'S', 'N', 3687, NULL, '2490', '2490', NULL, '1953', 'S', 3778, 'PENDÊNCIAS', 'N', '240990', 'N', 'S', 'S', NULL, 1, 'S', 'N', 'N', '106', NULL, '03', 'N', NULL, NULL, NULL, 37);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241000', '2406', 'RN', '2490', '2401', '24006', '24', 'PILOES', NULL, '84', '59960000', '9', '1799', '1799', '18100', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 82.691, '-6,26900', '-38,04300', 265, 'S', 0.6430, NULL, NULL, '24900', 'S', 'N', 3739, NULL, '2490', '2490', NULL, '1963', 'S', 3779, 'PILÕES', 'N', '241000', 'N', 'S', 'S', NULL, 134, 'N', 'N', 'N', '107', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241010', '2403', 'RN', '2490', '2403', '24013', '24', 'POCO BRANCO', NULL, '84', '59560000', '8', '1801', '1801', '18101', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 230.370, '-5,62300', '-35,66300', 82, 'S', 0.6060, NULL, NULL, '24900', 'S', 'N', 3839, NULL, '2490', '2490', NULL, '1963', 'S', 3780, 'POÇO BRANCO', 'N', '241010', 'N', 'S', 'S', NULL, 55, 'S', 'N', 'N', '108', NULL, '03', 'N', NULL, NULL, NULL, 84);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241020', '2406', 'RN', '2490', '2401', '24006', '24', 'PORTALEGRE', NULL, '84', '59810000', '7', '1803', '1803', '18102', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 110.052, '-6,02400', '-37,98800', 642, 'S', 0.6330, NULL, NULL, '24900', 'S', 'N', 3888, NULL, '2490', '2490', NULL, '1755', 'S', 3781, 'PORTALEGRE', 'N', '241020', 'N', 'S', 'S', NULL, 134, 'S', 'N', 'N', '109', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241025', '2402', 'RN', '2490', '2401', '24004', '24', 'PORTO DO MANGUE', NULL, '84', '59668000', '6', '0426', NULL, '18163', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 318.636, '-5,06800', '-36,78200', 5, 'S', 0.5980, NULL, NULL, '24900', 'S', 'N', 3908, NULL, '2490', '2490', NULL, '1997', 'S', 3782, 'PORTO DO MANGUE', 'N', '241025', 'N', 'S', 'S', NULL, 1, 'N', 'N', 'N', '110', NULL, '03', 'N', NULL, NULL, NULL, 37);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241030', '2405', 'RN', '2490', '2403', '24015', '24', 'PRESIDENTE JUSCELINO', NULL, '84', '59245000', '6', '1805', NULL, '18103', NULL, 'ATIVO', 'N', 'N', NULL, 'SERRA CAIADA              ', 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 167.348, '-6,10600', '-35,71300', 129, 'S', 0.6050, NULL, NULL, '24900', 'S', 'N', 5599, NULL, '2490', '2490', NULL, '1953', 'S', 3815, 'PRESIDENTE JUSCELINO', 'N', '241030', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '111', NULL, '03', 'N', NULL, NULL, NULL, 270);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241040', '2403', 'RN', '2490', '2404', '24016', '24', 'PUREZA', NULL, '84', '59582000', '5', '1807', '1807', '18104', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 504.317, '-5,46700', '-35,55600', 40, 'S', 0.5770, NULL, NULL, '24900', 'S', 'N', 4003, NULL, '2490', '2490', NULL, '1963', 'S', 3783, 'PUREZA', 'N', '241040', 'N', 'S', 'S', NULL, 55, 'S', 'N', 'N', '112', NULL, '03', 'N', NULL, NULL, NULL, 84);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241050', '2406', 'RN', '2490', '2401', '24006', '24', 'RAFAEL FERNANDES', NULL, '84', '59990000', '4', '1809', '1809', '18105', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 78.230, '-6,19500', '-38,22600', 227, 'S', 0.6520, NULL, NULL, '24900', 'S', 'N', 4045, NULL, '2490', '2490', NULL, '1963', 'S', 3784, 'RAFAEL FERNANDES', 'N', '241050', 'N', 'S', 'S', NULL, 134, 'S', 'N', 'N', '113', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241060', '2406', 'RN', '2490', '2401', '24007', '24', 'RAFAEL GODEIRO', NULL, '84', '59740000', '3', '1893', '1893', '18147', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 100.073, '-6,07600', '-37,71700', 193, 'S', 0.6370, NULL, NULL, '24900', 'S', 'N', 4046, NULL, '2490', '2490', NULL, '1963', 'S', 3785, 'RAFAEL GODEIRO', 'N', '241060', 'N', 'S', 'S', NULL, 32, 'N', 'N', 'N', '114', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241070', '2406', 'RN', '2490', '2401', '24006', '24', 'RIACHO DA CRUZ', NULL, '84', '59820000', '2', '1811', '1811', '18106', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 127.221, '-5,93600', '-37,94600', 163, 'S', 0.6240, NULL, NULL, '24900', 'S', 'N', 4095, NULL, '2490', '2490', NULL, '1962', 'S', 3786, 'RIACHO DA CRUZ', 'N', '241070', 'N', 'S', 'S', NULL, 134, 'S', 'N', 'N', '115', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241080', '2406', 'RN', '2490', '2401', '24005', '24', 'RIACHO DE SANTANA', NULL, '84', '59987000', '1', '1813', '1813', '18107', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 128.104, '-6,26300', '-38,31600', 273, 'S', 0.6210, NULL, NULL, '24900', 'S', 'N', 4098, NULL, '2490', '2490', NULL, '1962', 'S', 3787, 'RIACHO DE SANTANA', 'N', '241080', 'N', 'S', 'S', NULL, 134, 'N', 'N', 'N', '116', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241090', '2403', 'RN', '2490', '2403', '24015', '24', 'RIACHUELO', NULL, '84', '59470000', '0', '1815', '1815', '18108', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 262.873, '-5,81500', '-35,82500', 118, 'S', 0.6560, NULL, NULL, '24900', 'S', 'N', 4104, NULL, '2490', '2490', NULL, '1963', 'S', 3788, 'RIACHUELO', 'N', '241090', 'N', 'S', 'S', NULL, 123, 'S', 'N', 'N', '117', NULL, '03', 'N', NULL, NULL, NULL, 84);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241100', '2406', 'RN', '2490', '2401', '24006', '24', 'RODOLFO FERNANDES', NULL, '84', '59830000', '7', '1817', '1817', '18109', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 154.840, '-5,78800', '-38,06000', 188, 'S', 0.6530, NULL, NULL, '24900', 'S', 'N', 4208, NULL, '2490', '2490', NULL, '1962', 'S', 3790, 'RODOLFO FERNANDES', 'N', '241100', 'N', 'S', 'S', NULL, 32, 'S', 'N', 'N', '119', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241105', '2402', 'RN', '2490', '2401', '24001', '24', 'TIBAU', NULL, '84', '59678000', '6', '0428', '4286', '18164', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 162.402, '-4,83700', '-37,25300', 5, 'S', 0.6780, NULL, NULL, '24900', 'S', 'N', 5169, NULL, '2490', '2490', NULL, '1997', 'S', 3828, 'TIBAU', 'N', '241105', 'N', 'S', 'S', NULL, 1, 'S', 'N', 'N', '156', NULL, '03', 'N', NULL, NULL, NULL, 147);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241110', '2405', 'RN', '2490', '2403', '24014', '24', 'RUY BARBOSA', NULL, '84', '59420000', '6', '1819', '1819', '18110', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 125.813, '-5,88100', '-35,93500', 168, 'S', 0.5790, NULL, NULL, '24900', 'S', 'N', 4239, NULL, '2490', '2490', NULL, '1962', 'S', 3791, 'RUY BARBOSA', 'N', '241110', 'N', 'S', 'S', NULL, 123, 'S', 'N', 'N', '120', NULL, '03', 'N', NULL, NULL, NULL, 270);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241120', '2405', 'RN', '2490', '2403', '24014', '24', 'SANTA CRUZ', NULL, '84', '59200000', '5', '1823', '1823', '18112', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 624.390, '-6,22900', '-36,02300', 236, 'S', 0.6550, NULL, NULL, '24900', 'N', 'N', 4312, NULL, '2490', '2490', NULL, '1876', 'S', 3792, 'SANTA CRUZ', 'N', '241120', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '121', NULL, '03', 'N', NULL, NULL, NULL, 270);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241140', '2404', 'RN', '2490', '2402', '24010', '24', 'SANTANA DO MATOS', NULL, '84', '59520000', '3', '1827', '1827', '18114', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1420.313, '-5,95800', '-36,65600', 141, 'S', 0.5940, NULL, NULL, '24900', 'S', 'N', 4456, NULL, '2490', '2490', NULL, '1855', 'S', 3794, 'SANTANA DO MATOS', 'N', '241140', 'N', 'S', 'S', NULL, 76, 'S', 'N', 'N', '123', NULL, '03', 'N', NULL, NULL, NULL, 83);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241142', '2404', 'RN', '2490', '2402', '24012', '24', 'SANTANA DO SERIDO', NULL, '84', '59350000', '9', '1825', '1825', '18113', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 188.402, '-6,77100', '-36,73300', 336, 'S', 0.6840, NULL, NULL, '24900', 'S', 'N', 4462, NULL, '2490', '2490', NULL, '1962', 'S', 3795, 'SANTANA DO SERIDÓ', 'N', '241142', 'N', 'S', 'S', NULL, 76, 'N', 'N', 'N', '124', NULL, '03', 'N', NULL, NULL, NULL, 83);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241150', '2401', 'RN', '2490', '2403', '24015', '24', 'SANTO ANTONIO', NULL, '84', '59255000', '2', '1829', '1829', '18115', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 301.052, '-6,31100', '-35,47900', 92, 'S', 0.6550, NULL, NULL, '24900', 'S', 'N', 4480, NULL, '2490', '2490', NULL, '1892', 'S', 3796, 'SANTO ANTÔNIO', 'N', '241150', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '125', NULL, '03', 'N', NULL, NULL, NULL, 148);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241160', '2403', 'RN', '2490', '2402', '24008', '24', 'SAO BENTO DO NORTE', NULL, '84', '59590000', '1', '1831', '1831', '18116', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 288.637, '-5,09300', '-35,95900', 0, 'S', 0.6430, NULL, NULL, '24900', 'S', 'N', 4531, NULL, '2490', '2490', NULL, '1953', 'S', 3797, 'SÃO BENTO DO NORTE', 'N', '241160', 'N', 'S', 'S', NULL, 55, 'S', 'N', 'N', '126', NULL, '03', 'N', NULL, NULL, NULL, 84);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241170', '2405', 'RN', '2490', '2403', '24014', '24', 'SAO BENTO DO TRAIRI', NULL, '84', '59210000', '0', '1833', '1833', '18117', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 190.816, '-6,34200', '-36,08700', 279, 'S', 0.6160, NULL, NULL, '24900', 'S', 'N', 4535, NULL, '2490', '2490', NULL, '1958', 'S', 3798, 'SÃO BENTO DO TRAIRÍ', 'N', '241170', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '127', NULL, '03', 'N', NULL, NULL, NULL, 270);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241180', '2404', 'RN', '2490', '2402', '24011', '24', 'SAO FERNANDO', NULL, '84', '59327000', '9', '1835', '1835', '18118', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 404.415, '-6,37600', '-37,18400', 139, 'S', 0.6640, NULL, NULL, '24900', 'S', 'N', 4578, NULL, '2490', '2490', NULL, '1958', 'S', 3799, 'SÃO FERNANDO', 'N', '241180', 'N', 'S', 'S', NULL, 76, 'S', 'N', 'N', '128', NULL, '03', 'N', NULL, NULL, NULL, 83);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241190', '2406', 'RN', '2490', '2401', '24006', '24', 'SAO FRANCISCO DO OESTE', NULL, '84', '59908000', '8', '1821', '1821', '18111', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 75.550, '-5,97500', '-38,15200', 181, 'S', 0.6520, NULL, NULL, '24900', 'S', 'N', 4596, NULL, '2490', '2490', NULL, '1963', 'S', 3800, 'SÃO FRANCISCO DO OESTE', 'N', '241190', 'N', 'S', 'S', NULL, 134, 'S', 'N', 'N', '129', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241200', '2407', 'RN', '2490', '2404', '24017', '24', 'SAO GONCALO DO AMARANTE', NULL, '84', '59290000', '5', '1837', '1837', '18119', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 251.308, '-5,79300', '-35,32900', 15, 'S', 0.6950, NULL, NULL, '24900', 'N', 'N', 4611, NULL, '2401', '2401', NULL, '1958', 'S', 3801, 'SÃO GONÇALO DO AMARANTE', 'N', '241200', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '130', NULL, '01', 'N', NULL, NULL, NULL, 377);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241210', '2404', 'RN', '2490', '2402', '24011', '24', 'SAO JOAO DO SABUGI', NULL, '84', '59310000', '4', '1839', '1839', '18120', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 277.010, '-6,71800', '-37,20100', 187, 'S', 0.7250, NULL, NULL, '24900', 'N', 'N', 4667, NULL, '2490', '2490', NULL, '1948', 'S', 3802, 'SÃO JOÃO DO SABUGI', 'N', '241210', 'N', 'S', 'S', NULL, 76, 'S', 'N', 'N', '131', NULL, '03', 'N', NULL, NULL, NULL, 83);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241220', '2401', 'RN', '2490', '2404', '24017', '24', 'SAO JOSE DE MIPIBU', NULL, '84', '59162000', '3', '1841', '1841', '18121', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 293.877, '-6,07500', '-35,23800', 58, 'S', 0.6710, NULL, NULL, '24900', 'N', 'N', 4699, NULL, '2401', '2490', NULL, '1845', 'S', 3803, 'SÃO JOSÉ DE MIPIBU', 'N', '241220', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '132', NULL, '03', 'N', NULL, NULL, NULL, 148);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241230', '2405', 'RN', '2490', '2403', '24014', '24', 'SAO JOSE DO CAMPESTRE', NULL, '84', '59275000', '2', '1843', '1843', '18122', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 341.103, '-6,31600', '-35,71400', 149, 'S', 0.6310, NULL, NULL, '24900', 'S', 'N', 4710, NULL, '2490', '2490', NULL, '1948', 'S', 3804, 'SÃO JOSÉ DO CAMPESTRE', 'N', '241230', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '133', NULL, '03', 'N', NULL, NULL, NULL, 270);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241240', '2404', 'RN', '2490', '2402', '24012', '24', 'SAO JOSE DO SERIDO', NULL, '84', '59378000', '1', '1845', '1845', '18123', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 174.504, '-6,44900', '-36,87800', 207, 'S', 0.7400, NULL, NULL, '24900', 'N', 'N', 4732, NULL, '2490', '2490', NULL, '1962', 'S', 3805, 'SÃO JOSÉ DO SERIDÓ', 'N', '241240', 'N', 'S', 'S', NULL, 76, 'N', 'N', 'N', '134', NULL, '03', 'N', NULL, NULL, NULL, 83);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241250', '2406', 'RN', '2490', '2401', '24005', '24', 'SAO MIGUEL', NULL, '84', '59920000', '0', '1847', '1847', '18124', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 171.690, '-6,21200', '-38,49700', 679, 'S', 0.6150, NULL, NULL, '24900', 'S', 'N', 4772, NULL, '2490', '2490', NULL, '1876', 'S', 3806, 'SÃO MIGUEL', 'N', '241250', 'N', 'S', 'S', NULL, 134, 'S', 'N', 'N', '135', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241255', '2403', 'RN', '2490', '2404', '24016', '24', 'SAO MIGUEL DO GOSTOSO', NULL, '84', '59585000', '9', '0430', '0430', '18165', NULL, 'ATIVO', 'N', 'N', NULL, 'SÃO MIGUEL DE TOUROS      ', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 342.445, '-5,12500', '-35,63900', 18, 'S', 0.5580, NULL, NULL, '24900', 'S', 'N', 4780, NULL, '2490', '2490', NULL, '1997', 'S', 3807, 'SÃO MIGUEL DO GOSTOSO', 'N', '241255', 'N', 'S', 'S', NULL, 55, 'S', 'N', 'N', '136', NULL, '03', 'N', NULL, NULL, NULL, 84);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241260', '2405', 'RN', '2490', '2403', '24015', '24', 'SAO PAULO DO POTENGI', NULL, '84', '59460000', '9', '1849', '1849', '18125', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 240.435, '-5,89500', '-35,76300', 91, 'S', 0.6420, NULL, NULL, '24900', 'S', 'N', 4798, NULL, '2490', '2490', NULL, '1943', 'S', 3808, 'SÃO PAULO DO POTENGI', 'N', '241260', 'N', 'S', 'S', NULL, 123, 'N', 'N', 'N', '137', NULL, '03', 'N', NULL, NULL, NULL, 270);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220750', '2204', 'PI', '2203', '2202', '22005', '22', 'PALMEIRAIS', NULL, '86', '64420000', '4', '1149', '1149', '16075', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1360.307, '-5,97800', '-43,06300', 85, 'S', 0.5870, NULL, NULL, '22900', 'S', 'N', 3494, NULL, '2290', '2290', NULL, '1934', 'S', 3109, 'PALMEIRAIS', 'N', '220750', 'N', 'S', 'S', NULL, 45, 'N', 'N', 'N', '149', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220755', '2206', 'PI', '2204', '2204', '22013', '22', 'PAQUETA', NULL, '89', '64618000', '3', '0364', NULL, '16200', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 448.457, '-7,10400', '-41,70400', 340, 'S', 0.5290, NULL, NULL, '22900', 'S', 'N', 3519, NULL, '2290', '2290', NULL, '1997', 'S', 3110, 'PAQUETÁ', 'N', '220755', 'N', 'S', 'S', NULL, 96, 'S', 'N', 'N', '150', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220760', '2211', 'PI', '2206', '2203', '22012', '22', 'PARNAGUA', NULL, '89', '64970000', '3', '1151', '1151', '16076', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 3284.562, '-10,22700', '-44,63900', 334, 'S', 0.5920, NULL, NULL, '22900', 'S', 'N', 3574, NULL, '2290', '2290', NULL, '1938', 'S', 3111, 'PARNAGUÁ', 'N', '220760', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '151', NULL, '03', 'N', NULL, NULL, NULL, 199);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220770', '2201', 'PI', '2201', '2201', '22002', '22', 'PARNAIBA', NULL, '86', '64200970', '2', '1153', '1153', '16077', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 435.564, '-2,90500', '-41,77700', 5, 'S', 0.6740, NULL, NULL, '22900', 'N', 'N', 3575, NULL, '2290', '2290', NULL, '1844', 'S', 3112, 'PARNAÍBA', 'N', '220770', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '152', NULL, '01', 'N', NULL, NULL, NULL, 365);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220775', '2204', 'PI', '2203', '2202', '22005', '22', 'PASSAGEM FRANCA DO PIAUI', NULL, '86', '64395000', '1', '1293', '1293', '16140', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 849.601, '-5,85800', '-42,44000', 140, 'S', 0.5640, NULL, NULL, '22900', 'S', 'N', 3589, NULL, '2290', '2290', NULL, '1993', 'S', 3113, 'PASSAGEM FRANCA DO PIAUÍ', 'N', '220775', 'N', 'S', 'S', NULL, 45, 'S', 'N', 'N', '153', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220777', '2206', 'PI', '2204', '2204', '22015', '22', 'PATOS DO PIAUI', NULL, '89', '64580000', '7', '2277', '2277', '16141', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 723.273, '-7,66800', '-41,24400', 0, 'S', 0.5790, NULL, NULL, '22900', 'S', 'N', 3603, NULL, '2290', '2290', NULL, '1993', 'S', 3114, 'PATOS DO PIAUÍ', 'N', '220777', 'N', 'S', 'S', NULL, 96, 'S', 'N', 'N', '154', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220779', '2204', 'PI', '2203', '2202', '22003', '22', 'PAU D''ARCO DO PIAUI', NULL, '86', '64295000', '3', '1104', NULL, '16224', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 426.628, '-5,26100', '-42,39400', 0, 'S', NULL, NULL, NULL, '22900', 'S', 'N', 5618, NULL, '2290', '2290', NULL, '2001', 'S', 5557, 'PAU D ARCO DO PIAUÍ', 'N', '220779', 'N', 'S', 'S', NULL, 45, 'N', 'N', 'N', '155', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220780', '2206', 'PI', '2204', '2204', '22015', '22', 'PAULISTANA', NULL, '89', '64750000', '1', '1155', '1155', '16078', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1751.993, '-8,14400', '-41,15000', 359, 'S', 0.6050, NULL, NULL, '22900', 'S', 'N', 3622, NULL, '2290', '2290', NULL, '1938', 'S', 3115, 'PAULISTANA', 'N', '220780', 'N', 'S', 'S', NULL, 96, 'S', 'N', 'S', '156', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352610', '3512', 'SP', '3507', '3514', '35055', '35', 'JUQUIA', NULL, '13', '11800000', '0', '6623', '6623', '21262', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 820.961, '-24,32100', '-47,63500', 17, 'S', 0.7420, NULL, NULL, '35121', 'N', 'N', 2614, NULL, '3590', '3590', NULL, '1948', 'S', 5039, 'JUQUIÁ', 'N', '352610', 'N', 'N', 'S', NULL, 100, 'N', 'N', 'N', '298', NULL, '03', 'N', NULL, NULL, NULL, 222);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352660', '3517', 'SP', '3517', '3513', '35051', '35', 'LAVRINHAS', NULL, '12', '12760000', '5', '6633', '6633', '21267', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 166.860, '-22,57100', '-44,90200', 508, 'S', 0.7680, NULL, NULL, '35172', 'N', 'N', 2723, NULL, '3590', '3590', NULL, '1944', 'S', 5044, 'LAVRINHAS', 'N', '352660', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '303', NULL, '03', 'N', NULL, NULL, NULL, 433);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352670', '3510', 'SP', '3514', '3506', '35027', '35', 'LEME', NULL, '19', '13610000', '4', '6635', '6635', '21268', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 403.077, '-22,18600', '-47,39000', 619, 'S', 0.7960, NULL, NULL, '35101', 'N', 'N', 2726, NULL, '3590', '3508', NULL, '1895', 'S', 5045, 'LEME', 'N', '352670', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '304', NULL, '02', 'N', NULL, NULL, NULL, 155);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352690', '3510', 'SP', '3514', '3506', '35027', '35', 'LIMEIRA', NULL, '19', '13480970', '2', '6639', '6639', '21270', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 580.983, '-22,56500', '-47,40200', 588, 'S', 0.8140, NULL, NULL, '35102', 'N', 'N', 2740, NULL, '3590', '3508', NULL, '1842', 'S', 5047, 'LIMEIRA', 'N', '352690', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '306', NULL, '01', 'N', NULL, NULL, NULL, 327);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352700', '3507', 'SP', '3515', '3507', '35033', '35', 'LINDOIA', NULL, '19', '13950000', '9', '6641', '6641', '21271', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 48.600, '-22,52300', '-46,65000', 677, 'S', 0.8200, NULL, NULL, '35074', 'N', 'N', 2747, NULL, '3590', '3590', NULL, '1964', 'S', 5048, 'LINDÓIA', 'N', '352700', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '307', NULL, '03', 'N', NULL, NULL, NULL, 517);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352720', '3517', 'SP', '3517', '3513', '35051', '35', 'LORENA', NULL, '12', '12600000', '7', '6645', '6645', '21273', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 413.776, '-22,73100', '-45,12500', 524, 'S', 0.8070, NULL, NULL, '35172', 'N', 'N', 2762, NULL, '3590', '3506', NULL, '1788', 'S', 5050, 'LORENA', 'N', '352720', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '309', NULL, '02', 'N', NULL, NULL, NULL, 433);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352730', '3507', 'SP', '3516', '3512', '35047', '35', 'LOUVEIRA', NULL, '19', '13290000', '6', '6647', '6647', '21274', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 55.349, '-23,08600', '-46,95100', 690, 'S', 0.8000, NULL, NULL, '35073', 'N', 'N', 2765, NULL, '3504', '3507', NULL, '1964', 'S', 5052, 'LOUVEIRA', 'N', '352730', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '311', NULL, '03', 'N', NULL, NULL, NULL, 41);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352740', '3509', 'SP', '3510', '3508', '35035', '35', 'LUCELIA', NULL, '18', '17780000', '5', '6649', '6649', '21275', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 314.455, '-21,72000', '-51,01900', 438, 'S', 0.7820, NULL, NULL, '35091', 'N', 'N', 2767, NULL, '3590', '3590', NULL, '1944', 'S', 5053, 'LUCÉLIA', 'N', '352740', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '312', NULL, '03', 'N', NULL, NULL, NULL, 322);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352760', '3513', 'SP', '3514', '3502', '35014', '35', 'LUIS ANTONIO', NULL, '16', '14210000', '3', '6653', '6653', '21277', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 597.617, '-21,55500', '-47,70400', 675, 'S', 0.7950, NULL, NULL, '35132', 'N', 'N', 2772, NULL, '3590', '3590', NULL, '1959', 'S', 5055, 'LUÍS ANTÔNIO', 'N', '352760', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '314', NULL, '03', 'N', NULL, NULL, NULL, 273);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352780', '3509', 'SP', '3510', '3509', '35038', '35', 'LUPERCIO', NULL, '14', '17420000', '1', '6657', '6657', '21279', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 155.025, '-22,41500', '-49,81700', 661, 'S', 0.7360, NULL, NULL, '35093', 'N', 'N', 2783, NULL, '3590', '3590', NULL, '1953', 'S', 5057, 'LUPÉRCIO', 'N', '352780', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '316', NULL, '03', 'N', NULL, NULL, NULL, 96);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352790', '3509', 'SP', '3510', '3510', '35039', '35', 'LUTECIA', NULL, '18', '19750000', '0', '6659', '6659', '21280', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 474.627, '-22,34000', '-50,39200', 581, 'S', 0.7550, NULL, NULL, '35092', 'N', 'N', 2785, NULL, '3590', '3590', NULL, '1944', 'S', 5058, 'LUTÉCIA', 'N', '352790', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '317', NULL, '03', 'N', NULL, NULL, NULL, 274);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352810', '3515', 'SP', '3512', '3501', '35007', '35', 'MACAUBAL', NULL, '17', '15270000', '6', '6663', '6663', '21282', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 248.649, '-20,80600', '-49,96400', 516, 'S', 0.7810, NULL, NULL, '35157', 'N', 'N', 2801, NULL, '3590', '3590', NULL, '1948', 'S', 5060, 'MACAUBAL', 'N', '352810', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '319', NULL, '03', 'N', NULL, NULL, NULL, 162);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352820', '3515', 'SP', '3512', '3501', '35002', '35', 'MACEDONIA', NULL, '17', '15620000', '5', '6665', '6665', '21283', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 329.103, '-20,14600', '-50,19400', 502, 'S', 0.7570, NULL, NULL, '35154', 'N', 'N', 2803, NULL, '3590', '3590', NULL, '1964', 'S', 5061, 'MACEDÔNIA', 'N', '352820', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '320', NULL, '03', 'N', NULL, NULL, NULL, 276);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352830', '3515', 'SP', '3512', '3501', '35006', '35', 'MAGDA', NULL, '17', '15310000', '4', '6667', '6667', '21284', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 312.085, '-20,64400', '-50,22600', 526, 'S', 0.7840, NULL, NULL, '35157', 'N', 'N', 2823, NULL, '3590', '3590', NULL, '1953', 'S', 5062, 'MAGDA', 'N', '352830', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '321', NULL, '03', 'N', NULL, NULL, NULL, 162);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352840', '3516', 'SP', '3508', '3512', '35046', '35', 'MAIRINQUE', NULL, '11', '18120000', '3', '6669', '6669', '21285', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 209.757, '-23,54600', '-47,18300', 850, 'S', 0.8010, NULL, NULL, '35163', 'N', 'N', 2827, NULL, '3590', '3513', NULL, '1959', 'S', 5063, 'MAIRINQUE', 'N', '352840', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '322', NULL, '03', 'N', NULL, NULL, NULL, 165);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352860', '3506', 'SP', '3509', '3510', '35040', '35', 'MANDURI', NULL, '14', '18780000', '1', '6673', '6673', '21287', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 228.866, '-23,00300', '-49,32200', 710, 'S', 0.7720, NULL, NULL, '35061', 'N', 'N', 2855, NULL, '3590', '3590', NULL, '1944', 'S', 5065, 'MANDURI', 'N', '352860', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '324', NULL, '03', 'N', NULL, NULL, NULL, 102);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352870', '3511', 'SP', '3511', '3508', '35036', '35', 'MARABA PAULISTA', NULL, '18', '19430000', '0', '6675', '6675', '21288', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 917.119, '-22,10800', '-51,96300', 401, 'S', 0.7280, NULL, NULL, '35114', 'N', 'N', 2877, NULL, '3590', '3590', NULL, '1953', 'S', 5066, 'MARABÁ PAULISTA', 'N', '352870', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '325', NULL, '03', 'N', NULL, NULL, NULL, 435);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352880', '3509', 'SP', '3510', '3510', '35039', '35', 'MARACAI', NULL, '18', '19840000', '9', '6677', '6677', '21289', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 533.024, '-22,61100', '-50,66700', 435, 'S', 0.7730, NULL, NULL, '35092', 'N', 'N', 2879, NULL, '3590', '3590', NULL, '1924', 'S', 5067, 'MARACAÍ', 'N', '352880', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '326', NULL, '03', 'N', NULL, NULL, NULL, 274);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352885', '3515', 'SP', '3512', '3501', '35008', '35', 'MARAPOAMA', NULL, '17', '15845000', '8', '2977', '2977', '21605', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 113.345, '-21,25900', '-49,12900', 467, 'S', 0.7800, NULL, NULL, '35151', 'N', 'N', 2892, NULL, '3590', '3590', NULL, '1993', 'S', 5068, 'MARAPOAMA', 'N', '352885', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '327', NULL, '03', 'N', NULL, NULL, NULL, 382);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352890', '3509', 'SP', '3510', '3508', '35035', '35', 'MARIAPOLIS', NULL, '18', '17810000', '8', '6679', '6679', '21290', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 186.098, '-21,79900', '-51,18100', 410, 'S', 0.7390, NULL, NULL, '35091', 'N', 'N', 2921, NULL, '3590', '3590', NULL, '1953', 'S', 5069, 'MARIÁPOLIS', 'N', '352890', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '328', NULL, '03', 'N', NULL, NULL, NULL, 322);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352900', '3509', 'SP', '3510', '3509', '35038', '35', 'MARILIA', NULL, '14', '17500970', '5', '6681', '6681', '21291', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1170.054, '-22,21400', '-49,94600', 675, 'S', 0.8210, NULL, NULL, '35093', 'N', 'N', 2928, NULL, '3590', '3590', NULL, '1928', 'S', 5070, 'MARÍLIA', 'N', '352900', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '329', NULL, '01', 'N', NULL, NULL, NULL, 96);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220865', '2206', 'PI', '2204', '2204', '22015', '22', 'QUEIMADA NOVA', NULL, '89', '64758000', '0', '2279', '2279', '16142', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1499.865, '-8,57900', '-41,41900', 410, 'S', 0.5320, NULL, NULL, '22900', 'S', 'N', 4018, NULL, '2290', '2290', NULL, '1993', 'S', 3127, 'QUEIMADA NOVA', 'N', '220865', 'N', 'S', 'S', NULL, 96, 'S', 'N', 'N', '168', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220870', '2211', 'PI', '2206', '2203', '22010', '22', 'REDENCAO DO GURGUEIA', NULL, '89', '64915000', '0', '1173', '1173', '16087', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 2468.006, '-9,48700', '-44,58600', 292, 'S', 0.5830, NULL, NULL, '22900', 'S', 'N', 4065, NULL, '2290', '2290', NULL, '1962', 'S', 3128, 'REDENÇÃO DO GURGUÉIA', 'N', '220870', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '169', NULL, '03', 'N', NULL, NULL, NULL, 199);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220880', '2204', 'PI', '2203', '2202', '22005', '22', 'REGENERACAO', NULL, '86', '64490000', '9', '1175', '1175', '16088', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1257.157, '-6,23800', '-42,68800', 164, 'S', 0.6110, NULL, NULL, '22900', 'S', 'N', 4068, NULL, '2290', '2290', NULL, '1934', 'S', 3129, 'REGENERAÇÃO', 'N', '220880', 'N', 'S', 'S', NULL, 45, 'S', 'N', 'N', '170', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220885', '2211', 'PI', '2206', '2203', '22012', '22', 'RIACHO FRIO', NULL, '89', '64975000', '8', '0374', NULL, '16205', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 2221.950, '-10,12500', '-44,95300', 400, 'S', 0.6080, NULL, NULL, '22900', 'S', 'N', 4102, NULL, '2290', '2290', NULL, '1997', 'S', 3130, 'RIACHO FRIO', 'N', '220885', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '171', NULL, '03', 'N', NULL, NULL, NULL, 199);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220887', '2209', 'PI', '2203', '2204', '22015', '22', 'RIBEIRA DO PIAUI', NULL, '89', '64725000', '4', '0376', NULL, '16206', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 990.678, '-7,69100', '-42,71300', 200, 'S', 0.5300, NULL, NULL, '22900', 'S', 'N', 4111, NULL, '2290', '2290', NULL, '1997', 'S', 3131, 'RIBEIRA DO PIAUÍ', 'N', '220887', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '172', NULL, '03', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220890', '2210', 'PI', '2203', '2203', '22007', '22', 'RIBEIRO GONCALVES', NULL, '89', '64865000', '8', '1177', '1177', '16089', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 3979.036, '-7,55800', '-45,24200', 210, 'S', 0.6470, NULL, NULL, '22900', 'S', 'N', 4129, NULL, '2290', '2290', NULL, '1938', 'S', 3132, 'RIBEIRO GONÇALVES', 'N', '220890', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '173', NULL, '03', 'N', NULL, NULL, NULL, 197);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220900', '2209', 'PI', '2203', '2203', '22009', '22', 'RIO GRANDE DO PIAUI', NULL, '89', '64835000', '5', '1179', '1179', '16090', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 611.011, '-7,77500', '-43,14200', 310, 'S', 0.6430, NULL, NULL, '22900', 'S', 'N', 4172, NULL, '2290', '2290', NULL, '1961', 'S', 3133, 'RIO GRANDE DO PIAUÍ', 'N', '220900', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '174', NULL, '03', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220910', '2206', 'PI', '2204', '2204', '22013', '22', 'SANTA CRUZ DO PIAUI', NULL, '89', '64545000', '4', '1181', '1181', '16091', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 611.501, '-7,18500', '-41,76800', 190, 'S', 0.6200, NULL, NULL, '22900', 'S', 'N', 4326, NULL, '2290', '2290', NULL, '1956', 'S', 3134, 'SANTA CRUZ DO PIAUÍ', 'N', '220910', 'N', 'S', 'S', NULL, 133, 'S', 'N', 'N', '175', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220915', '2205', 'PI', '2204', '2202', '22006', '22', 'SANTA CRUZ DOS MILAGRES', NULL, '89', '64315000', '3', '1295', '1295', '16143', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 984.084, '-5,80400', '-41,95600', 160, 'S', 0.5880, NULL, NULL, '22900', 'S', 'N', 4329, NULL, '2290', '2290', NULL, '1993', 'S', 3135, 'SANTA CRUZ DOS MILAGRES', 'N', '220915', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '176', NULL, '03', 'N', NULL, NULL, NULL, 366);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220920', '2211', 'PI', '2206', '2203', '22007', '22', 'SANTA FILOMENA', NULL, '89', '64945000', '3', '1183', '1183', '16092', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 5285.447, '-9,11200', '-45,92200', 277, 'S', 0.6180, NULL, NULL, '22900', 'S', 'N', 4337, NULL, '2290', '2290', NULL, '1938', 'S', 3136, 'SANTA FILOMENA', 'N', '220920', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '177', NULL, '03', 'N', NULL, NULL, NULL, 199);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220930', '2211', 'PI', '2206', '2203', '22010', '22', 'SANTA LUZ', NULL, '89', '64910000', '2', '1185', '1185', '16093', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1186.831, '-8,95400', '-44,12900', 345, 'S', 0.6410, NULL, NULL, '22900', 'S', 'N', 4361, NULL, '2290', '2290', NULL, '1962', 'S', 3137, 'SANTA LUZ', 'N', '220930', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '178', NULL, '03', 'N', NULL, NULL, NULL, 199);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352910', '3515', 'SP', '3512', '3501', '35001', '35', 'MARINOPOLIS', NULL, '17', '15730000', '4', '6683', '6683', '21292', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 78.095, '-20,44100', '-50,82300', 408, 'S', 0.7400, NULL, NULL, '35153', 'N', 'N', 2931, NULL, '3590', '3590', NULL, '1924', 'S', 5071, 'MARINÓPOLIS', 'N', '352910', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '330', NULL, '03', 'N', NULL, NULL, NULL, 436);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352920', '3511', 'SP', '3511', '3508', '35036', '35', 'MARTINOPOLIS', NULL, '18', '19500000', '3', '6685', '6685', '21293', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1253.158, '-22,14600', '-51,17100', 488, 'S', 0.7500, NULL, NULL, '35112', 'N', 'N', 2945, NULL, '3590', '3590', NULL, '1938', 'S', 5072, 'MARTINÓPOLIS', 'N', '352920', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '331', NULL, '03', 'N', NULL, NULL, NULL, 323);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352940', '3501', 'SP', '3501', '3515', '35061', '35', 'MAUA', NULL, '11', '09301970', '1', '6689', '6689', '21295', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 62.293, '-23,66800', '-46,46100', 764, 'S', 0.7810, NULL, NULL, '35015', 'N', 'N', 2990, NULL, '3501', '3501', NULL, '1953', 'S', 5074, 'MAUÁ', 'N', '352940', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '333', NULL, '01', 'N', NULL, NULL, NULL, 94);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352950', '3515', 'SP', '3512', '3501', '35004', '35', 'MENDONCA', NULL, '17', '15220000', '0', '6691', '6691', '21296', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 194.974, '-21,16700', '-49,58100', 484, 'S', 0.7710, NULL, NULL, '35156', 'N', 'N', 3008, NULL, '3590', '3590', NULL, '1959', 'S', 5075, 'MENDONÇA', 'N', '352950', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '334', NULL, '03', 'N', NULL, NULL, NULL, 160);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352960', '3515', 'SP', '3512', '3501', '35002', '35', 'MERIDIANO', NULL, '17', '15625000', '9', '6693', '6693', '21297', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 228.158, '-20,35900', '-50,17300', 529, 'S', 0.7620, NULL, NULL, '35154', 'N', 'N', 3011, NULL, '3590', '3590', NULL, '1959', 'S', 5076, 'MERIDIANO', 'N', '352960', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '335', NULL, '03', 'N', NULL, NULL, NULL, 276);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352965', '3515', 'SP', '3512', '3501', '35001', '35', 'MESOPOLIS', NULL, '17', '15748000', '8', '2983', '2983', '21623', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 149.714, '-19,96600', '-50,63800', 400, 'S', 0.7320, NULL, NULL, '35153', 'N', 'N', 3013, NULL, '3590', '3590', NULL, '1993', 'S', 5077, 'MESÓPOLIS', 'N', '352965', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '336', NULL, '03', 'N', NULL, NULL, NULL, 436);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352970', '3508', 'SP', '3513', '3502', '35010', '35', 'MIGUELOPOLIS', NULL, '16', '14530000', '8', '6695', '6695', '21298', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 826.889, '-20,17900', '-48,03200', 510, 'S', 0.7910, NULL, NULL, '35083', 'N', 'N', 3021, NULL, '3590', '3590', NULL, '1944', 'S', 5078, 'MIGUELÓPOLIS', 'N', '352970', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '337', NULL, '03', 'N', NULL, NULL, NULL, 272);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352990', '3512', 'SP', '3507', '3514', '35055', '35', 'MIRACATU', NULL, '13', '11850000', '6', '6699', '6699', '21300', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1000.736, '-24,28100', '-47,46000', 27, 'S', 0.7480, NULL, NULL, '35121', 'N', 'N', 3039, NULL, '3590', '3590', NULL, '1944', 'S', 5081, 'MIRACATU', 'N', '352990', 'N', 'N', 'S', NULL, 100, 'N', 'N', 'N', '340', NULL, '03', 'N', NULL, NULL, NULL, 222);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353000', '3515', 'SP', '3512', '3501', '35002', '35', 'MIRA ESTRELA', NULL, '17', '15580000', '3', '6701', '6701', '21301', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 217.116, '-19,97900', '-50,13700', 458, 'S', 0.7710, NULL, NULL, '35154', 'N', 'N', 3037, NULL, '3590', '3590', NULL, '1964', 'S', 5080, 'MIRA ESTRELA', 'N', '353000', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '339', NULL, '03', 'N', NULL, NULL, NULL, 276);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353020', '3511', 'SP', '3511', '3508', '35036', '35', 'MIRANTE DO PARANAPANEMA', NULL, '18', '19260000', '1', '6705', '6705', '21303', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1237.847, '-22,29200', '-51,90600', 448, 'S', 0.7350, NULL, NULL, '35115', 'N', 'N', 3056, NULL, '3590', '3590', NULL, '1953', 'S', 5083, 'MIRANTE DO PARANAPANEMA', 'N', '353020', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '342', NULL, '03', 'N', NULL, NULL, NULL, 331);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353030', '3515', 'SP', '3512', '3501', '35004', '35', 'MIRASSOL', NULL, '17', '15130000', '0', '6707', '6707', '21304', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 243.802, '-20,81900', '-49,52100', 587, 'S', 0.8220, NULL, NULL, '35155', 'N', 'N', 3058, NULL, '3590', '3511', NULL, '1924', 'S', 5084, 'MIRASSOL', 'N', '353030', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '343', NULL, '02', 'N', NULL, NULL, NULL, 392);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353040', '3515', 'SP', '3512', '3501', '35004', '35', 'MIRASSOLANDIA', NULL, '17', '15145000', '9', '6709', '6709', '21305', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 166.421, '-20,61700', '-49,46400', 524, 'S', 0.7640, NULL, NULL, '35155', 'N', 'N', 3060, NULL, '3590', '3590', NULL, '1959', 'S', 5085, 'MIRASSOLÂNDIA', 'N', '353040', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '344', NULL, '03', 'N', NULL, NULL, NULL, 392);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353050', '3514', 'SP', '3515', '3507', '35030', '35', 'MOCOCA', NULL, '19', '13730000', '8', '6711', '6711', '21306', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 854.074, '-21,46800', '-47,00500', 645, 'S', 0.8090, NULL, NULL, '35143', 'N', 'N', 3067, NULL, '3590', '3590', NULL, '1871', 'S', 5086, 'MOCOCA', 'N', '353050', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '345', NULL, '02', 'N', NULL, NULL, NULL, 279);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353070', '3514', 'SP', '3515', '3507', '35031', '35', 'MOGI GUACU', NULL, '19', '13840000', '6', '6715', '6715', '21308', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 813.138, '-22,37200', '-46,94200', 591, 'S', 0.8130, NULL, NULL, '35141', 'N', 'N', 3076, NULL, '3590', '3509', NULL, '1877', 'S', 5088, 'MOGI GUAÇU', 'N', '353070', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '347', NULL, '01', 'N', NULL, NULL, NULL, 432);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353090', '3510', 'SP', '3514', '3506', '35028', '35', 'MOMBUCA', NULL, '19', '13380000', '4', '6719', '6719', '21310', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 133.198, '-22,92900', '-47,56600', 550, 'S', 0.7500, NULL, NULL, '35103', 'N', 'N', 3079, NULL, '3590', '3590', NULL, '1964', 'S', 5090, 'MOMBUCA', 'N', '353090', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '349', NULL, '03', 'N', NULL, NULL, NULL, 100);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353100', '3515', 'SP', '3512', '3501', '35007', '35', 'MONCOES', NULL, '17', '15275000', '1', '6721', '6721', '21311', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 104.494, '-20,85000', '-50,09200', 406, 'S', 0.7710, NULL, NULL, '35157', 'N', 'N', 3081, NULL, '3590', '3590', NULL, '1964', 'S', 5091, 'MONÇÕES', 'N', '353100', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '350', NULL, '03', 'N', NULL, NULL, NULL, 162);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220955', '2208', 'PI', '2205', '2203', '22011', '22', 'SAO BRAZ DO PIAUI', NULL, '89', '64783000', '9', '2263', '2263', '16146', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 604.081, '-8,96200', '-43,00400', 0, 'S', 0.5930, NULL, NULL, '22900', 'S', 'N', 4544, NULL, '2290', '2290', NULL, '1993', 'S', 3143, 'SÃO BRAZ DO PIAUÍ', 'N', '220955', 'N', 'S', 'S', NULL, 77, 'N', 'N', 'N', '184', NULL, '03', 'N', NULL, NULL, NULL, 140);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220960', '2205', 'PI', '2204', '2202', '22006', '22', 'SAO FELIX DO PIAUI', NULL, '86', '64375000', '9', '1191', '1191', '16096', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 656.520, '-5,93300', '-42,11400', 175, 'S', 0.6240, NULL, NULL, '22900', 'S', 'N', 4575, NULL, '2290', '2290', NULL, '1954', 'S', 3144, 'SÃO FÉLIX DO PIAUÍ', 'N', '220960', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '185', NULL, '03', 'N', NULL, NULL, NULL, 366);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220965', '2207', 'PI', '2204', '2204', '22015', '22', 'SAO FRANCISCO DE ASSIS DO PIAUI', NULL, '89', '64745000', '8', '0380', NULL, '16208', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 842.453, '-8,23800', '-41,68600', 415, 'S', 0.5200, NULL, NULL, '22900', 'S', 'N', 4585, NULL, '2290', '2290', NULL, '1997', 'S', 3145, 'SÃO FRANCISCO DE ASSIS DO PIAUÍ', 'N', '220965', 'N', 'S', 'S', NULL, 133, 'S', 'N', 'N', '186', NULL, '03', 'N', NULL, NULL, NULL, 75);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220970', '2209', 'PI', '2203', '2203', '22009', '22', 'SAO FRANCISCO DO PIAUI', NULL, '89', '64550000', '8', '1193', '1193', '16097', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1340.654, '-7,25100', '-42,54300', 158, 'S', 0.5590, NULL, NULL, '22900', 'S', 'N', 4598, NULL, '2290', '2290', NULL, '1956', 'S', 3146, 'SÃO FRANCISCO DO PIAUÍ', 'N', '220970', 'N', 'S', 'S', NULL, 133, 'N', 'N', 'N', '187', NULL, '03', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220975', '2211', 'PI', '2206', '2203', '22010', '22', 'SAO GONCALO DO GURGUEIA', NULL, '89', '64993000', '7', '0382', NULL, '16209', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1385.307, '-10,03000', '-45,30300', 440, 'S', 0.5790, NULL, NULL, '22900', 'S', 'N', 4613, NULL, '2290', '2290', NULL, '1997', 'S', 3147, 'SÃO GONÇALO DO GURGUÉIA', 'N', '220975', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '188', NULL, '03', 'N', NULL, NULL, NULL, 199);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220980', '2204', 'PI', '2203', '2202', '22005', '22', 'SAO GONCALO DO PIAUI', NULL, '86', '64435000', '7', '1195', '1195', '16098', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 147.592, '-5,99300', '-42,70300', 270, 'S', 0.6430, NULL, NULL, '22900', 'S', 'N', 4615, NULL, '2290', '2290', NULL, '1963', 'S', 3148, 'SÃO GONÇALO DO PIAUÍ', 'N', '220980', 'N', 'S', 'S', NULL, 45, 'S', 'N', 'N', '189', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220985', '2206', 'PI', '2204', '2204', '22013', '22', 'SAO JOAO DA CANABRAVA', NULL, '89', '64635000', '6', '1291', '1291', '16122', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 470.954, '-6,81700', '-41,34300', 310, 'S', 0.5670, NULL, NULL, '22900', 'S', 'N', 4632, NULL, '2290', '2290', NULL, '1989', 'S', 3149, 'SÃO JOÃO DA CANABRAVA', 'N', '220985', 'N', 'S', 'S', NULL, 96, 'S', 'N', 'N', '190', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220987', '2202', 'PI', '2202', '2201', '22002', '22', 'SAO JOAO DA FRONTEIRA', NULL, '86', '64243000', '2', '0384', NULL, '16210', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 764.742, '-3,95600', '-41,25800', 241, 'S', 0.5540, NULL, NULL, '22900', 'S', 'N', 4633, NULL, '2290', '2290', NULL, '1997', 'S', 3150, 'SÃO JOÃO DA FRONTEIRA', 'N', '220987', 'N', 'S', 'S', NULL, 161, 'S', 'N', 'N', '191', NULL, '03', 'N', NULL, NULL, NULL, 196);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353120', '3507', 'SP', '3515', '3507', '35033', '35', 'MONTE ALEGRE DO SUL', NULL, '19', '13910000', '9', '6725', '6725', '21313', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 110.860, '-22,68200', '-46,68100', 750, 'S', 0.8120, NULL, NULL, '35074', 'N', 'N', 3100, NULL, '3590', '3590', NULL, '1948', 'S', 5093, 'MONTE ALEGRE DO SUL', 'N', '353120', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '352', NULL, '03', 'N', NULL, NULL, NULL, 517);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353130', '3513', 'SP', '3514', '3502', '35013', '35', 'MONTE ALTO', NULL, '16', '15910000', '8', '6727', '6727', '21314', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 347.119, '-21,26100', '-48,49600', 735, 'S', 0.8130, NULL, NULL, '35131', 'N', 'N', 3102, NULL, '3590', '3590', NULL, '1895', 'S', 5094, 'MONTE ALTO', 'N', '353130', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '353', NULL, '03', 'N', NULL, NULL, NULL, 383);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353140', '3515', 'SP', '3512', '3501', '35007', '35', 'MONTE APRAZIVEL', NULL, '17', '15150000', '7', '6729', '6729', '21315', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 482.934, '-20,77300', '-49,71400', 475, 'S', 0.8080, NULL, NULL, '35156', 'N', 'N', 3103, NULL, '3590', '3590', NULL, '1924', 'S', 5095, 'MONTE APRAZÍVEL', 'N', '353140', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '354', NULL, '03', 'N', NULL, NULL, NULL, 160);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353170', '3517', 'SP', '3517', '3513', '35049', '35', 'MONTEIRO LOBATO', NULL, '12', '12250000', '4', '6735', '6735', '21318', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 332.740, '-22,95700', '-45,84000', 685, 'S', 0.7750, NULL, NULL, '35171', 'N', 'N', 3123, NULL, '3590', '3590', NULL, '1948', 'S', 5099, 'MONTEIRO LOBATO', 'N', '353170', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '358', NULL, '03', 'N', NULL, NULL, NULL, 324);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353180', '3507', 'SP', '3515', '3507', '35032', '35', 'MONTE MOR', NULL, '19', '13190000', '3', '6737', '6737', '21319', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 240.787, '-22,94700', '-47,31600', 560, 'S', 0.7830, NULL, NULL, '35072', 'N', 'N', 3116, NULL, '3503', '3590', NULL, '1871', 'S', 5098, 'MONTE MOR', 'N', '353180', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '357', NULL, '01', 'N', NULL, NULL, NULL, 515);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353190', '3508', 'SP', '3513', '3502', '35010', '35', 'MORRO AGUDO', NULL, '16', '14640000', '2', '6739', '6739', '21320', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1386.176, '-20,73100', '-48,05800', 546, 'S', 0.7670, NULL, NULL, '35082', 'N', 'N', 3144, NULL, '3590', '3590', NULL, '1934', 'S', 5100, 'MORRO AGUDO', 'N', '353190', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '359', NULL, '03', 'N', NULL, NULL, NULL, 271);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353200', '3507', 'SP', '3516', '3512', '35048', '35', 'MORUNGABA', NULL, '11', '13260000', '9', '6741', '6741', '21321', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 146.496, '-22,88000', '-46,79200', 765, 'S', 0.7880, NULL, NULL, '35071', 'N', 'N', 3157, NULL, '3590', '3590', NULL, '1964', 'S', 5101, 'MORUNGABA', 'N', '353200', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '360', NULL, '03', 'N', NULL, NULL, NULL, 515);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353215', '3511', 'SP', '3511', '3510', '35039', '35', 'NANTES', NULL, '18', '19645000', '7', '0804', NULL, '21635', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 285.415, '-22,62100', '-51,23700', 418, 'S', 0.7220, NULL, NULL, '35113', 'N', 'N', 3196, NULL, '3590', '3590', NULL, '1997', 'S', 5104, 'NANTES', 'N', '353215', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '363', NULL, '03', 'N', NULL, NULL, NULL, 154);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353220', '3511', 'SP', '3511', '3508', '35036', '35', 'NARANDIBA', NULL, '18', '19220000', '7', '6745', '6745', '21323', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 358.139, '-22,40700', '-51,52400', 419, 'S', 0.7630, NULL, NULL, '35112', 'N', 'N', 3200, NULL, '3590', '3590', NULL, '1964', 'S', 5105, 'NARANDIBA', 'N', '353220', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '364', NULL, '03', 'N', NULL, NULL, NULL, 323);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353240', '3507', 'SP', '3516', '3512', '35048', '35', 'NAZARE PAULISTA', NULL, '11', '12960000', '5', '6749', '6749', '21325', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 326.542, '-23,18100', '-46,39500', 845, 'S', 0.7460, NULL, NULL, '35071', 'N', 'N', 3214, NULL, '3590', '3590', NULL, '1850', 'S', 5107, 'NAZARÉ PAULISTA', 'N', '353240', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '366', NULL, '03', 'N', NULL, NULL, NULL, 275);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353250', '3515', 'SP', '3512', '3501', '35007', '35', 'NEVES PAULISTA', NULL, '17', '15120000', '4', '6751', '6751', '21326', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 232.143, '-20,84600', '-49,63000', 549, 'S', 0.8040, NULL, NULL, '35155', 'N', 'N', 3221, NULL, '3590', '3590', NULL, '1944', 'S', 5108, 'NEVES PAULISTA', 'N', '353250', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '367', NULL, '03', 'N', NULL, NULL, NULL, 392);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353260', '3515', 'SP', '3512', '3501', '35007', '35', 'NHANDEARA', NULL, '17', '15190000', '3', '6753', '6753', '21327', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 437.420, '-20,69400', '-50,03800', 525, 'S', 0.8060, NULL, NULL, '35157', 'N', 'N', 3223, NULL, '3590', '3590', NULL, '1944', 'S', 5109, 'NHANDEARA', 'N', '353260', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '368', NULL, '03', 'N', NULL, NULL, NULL, 162);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353270', '3515', 'SP', '3512', '3501', '35007', '35', 'NIPOA', NULL, '17', '15240000', '2', '6755', '6755', '21328', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 138.048, '-20,91300', '-49,77800', 439, 'S', 0.7750, NULL, NULL, '35156', 'N', 'N', 3230, NULL, '3590', '3590', NULL, '1953', 'S', 5110, 'NIPOÃ', 'N', '353270', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '369', NULL, '03', 'N', NULL, NULL, NULL, 160);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353280', '3515', 'SP', '3512', '3501', '35004', '35', 'NOVA ALIANCA', NULL, '17', '15210000', '1', '6757', '6757', '21329', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 217.829, '-21,01600', '-49,49600', 464, 'S', 0.8060, NULL, NULL, '35155', 'N', 'N', 3248, NULL, '3590', '3590', NULL, '1944', 'S', 5111, 'NOVA ALIANÇA', 'N', '353280', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '370', NULL, '03', 'N', NULL, NULL, NULL, 392);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353282', '3516', 'SP', '3508', '3511', '35041', '35', 'NOVA CAMPINA', NULL, '15', '18435000', '7', '3061', '3061', '21624', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 385.328, '-24,12100', '-48,90400', 848, 'S', 0.7090, NULL, NULL, '35162', 'N', 'N', 3265, NULL, '3590', '3590', NULL, '1993', 'S', 5112, 'NOVA CAMPINA', 'N', '353282', 'N', 'N', 'S', NULL, 89, 'N', 'N', 'N', '371', NULL, '03', 'N', NULL, NULL, NULL, 159);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353300', '3515', 'SP', '3512', '3501', '35004', '35', 'NOVA GRANADA', NULL, '17', '15440000', '7', '6761', '6761', '21331', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 531.855, '-20,53400', '-49,31400', 542, 'S', 0.7900, NULL, NULL, '35155', 'N', 'N', 3287, NULL, '3590', '3590', NULL, '1925', 'S', 5116, 'NOVA GRANADA', 'N', '353300', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '375', NULL, '03', 'N', NULL, NULL, NULL, 392);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353310', '3511', 'SP', '3511', '3508', '35034', '35', 'NOVA GUATAPORANGA', NULL, '18', '17950000', '6', '6763', '6763', '21332', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 34.116, '-21,33400', '-51,64400', 382, 'S', 0.7400, NULL, NULL, '35111', 'N', 'N', 3289, NULL, '3590', '3590', NULL, '1959', 'S', 5117, 'NOVA GUATAPORANGA', 'N', '353310', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '376', NULL, '03', 'N', NULL, NULL, NULL, 431);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353325', '3515', 'SP', '3512', '3501', '35005', '35', 'NOVAIS', NULL, '17', '15885000', '4', '2979', '2979', '21607', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 116.929, '-20,99200', '-48,91900', 555, 'S', 0.7590, NULL, NULL, '35151', 'N', 'N', 3348, NULL, '3590', '3590', NULL, '1993', 'S', 5121, 'NOVAIS', 'N', '353325', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '380', NULL, '03', 'N', NULL, NULL, NULL, 382);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353340', '3507', 'SP', '3515', '3507', '35032', '35', 'NOVA ODESSA', NULL, '19', '13460000', '3', '6769', '6769', '21335', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 73.298, '-22,77800', '-47,29600', 570, 'S', 0.8260, NULL, NULL, '35072', 'N', 'N', 3309, NULL, '3503', '3503', NULL, '1959', 'S', 5120, 'NOVA ODESSA', 'N', '353340', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '379', NULL, '01', 'N', NULL, NULL, NULL, 515);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221038', '2205', 'PI', '2204', '2202', '22006', '22', 'SAO MIGUEL DA BAIXA GRANDE', NULL, '86', '64378000', '3', '0392', NULL, '16214', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 384.188, '-5,86400', '-42,18600', 160, 'S', 0.5740, NULL, NULL, '22900', 'S', 'N', 4775, NULL, '2290', '2290', NULL, '1997', 'S', 3161, 'SÃO MIGUEL DA BAIXA GRANDE', 'N', '221038', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '202', NULL, '03', 'N', NULL, NULL, NULL, 366);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221039', '2209', 'PI', '2203', '2203', '22009', '22', 'SAO MIGUEL DO FIDALGO', NULL, '89', '64558000', '1', '0394', NULL, '16215', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 802.748, '-7,58600', '-42,37000', 200, 'S', 0.5660, NULL, NULL, '22900', 'S', 'N', 4784, NULL, '2290', '2290', NULL, '1997', 'S', 3162, 'SÃO MIGUEL DO FIDALGO', 'N', '221039', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '203', NULL, '03', 'N', NULL, NULL, NULL, 198);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221040', '2203', 'PI', '2202', '2202', '22004', '22', 'SAO MIGUEL DO TAPUIO', NULL, '86', '64330000', '9', '1207', '1207', '16104', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 5220.513, '-5,50400', '-41,32300', 285, 'S', 0.5400, NULL, NULL, '22900', 'S', 'N', 4789, NULL, '2290', '2290', NULL, '1930', 'S', 3163, 'SÃO MIGUEL DO TAPUIO', 'N', '221040', 'N', 'S', 'S', NULL, 28, 'S', 'N', 'N', '204', NULL, '03', 'N', NULL, NULL, NULL, 422);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221050', '2204', 'PI', '2203', '2202', '22005', '22', 'SAO PEDRO DO PIAUI', NULL, '86', '64430000', '8', '1209', '1209', '16105', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 525.723, '-5,92900', '-42,71900', 264, 'S', 0.6340, NULL, NULL, '22900', 'S', 'N', 4811, NULL, '2290', '2290', NULL, '1933', 'S', 3164, 'SÃO PEDRO DO PIAUÍ', 'N', '221050', 'N', 'S', 'S', NULL, 45, 'S', 'N', 'N', '205', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221060', '2208', 'PI', '2205', '2203', '22011', '22', 'SAO RAIMUNDO NONATO', NULL, '89', '64770000', '7', '1211', '1211', '16106', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 2427.894, '-9,01500', '-42,69900', 332, 'S', 0.6810, NULL, NULL, '22900', 'S', 'N', 4820, NULL, '2290', '2290', NULL, '1912', 'S', 3165, 'SÃO RAIMUNDO NONATO', 'N', '221060', 'N', 'S', 'S', NULL, 77, 'S', 'N', 'S', '206', NULL, '03', 'N', NULL, NULL, NULL, 140);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221062', '2211', 'PI', '2206', '2203', '22012', '22', 'SEBASTIAO BARROS', NULL, '89', '64985000', '3', '0396', NULL, '16216', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1013.926, '-10,81700', '-44,83400', 500, 'S', 0.5660, NULL, NULL, '22900', 'S', 'N', 4893, NULL, '2290', '2290', NULL, '1997', 'S', 3166, 'SEBASTIÃO BARROS', 'N', '221062', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '207', NULL, '03', 'N', NULL, NULL, NULL, 199);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221063', '2210', 'PI', '2203', '2203', '22008', '22', 'SEBASTIAO LEAL', NULL, '89', '64873000', '1', '0398', NULL, '16217', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3111.103, '-7,56600', '-44,06400', 360, 'S', 0.6070, NULL, NULL, '22900', 'S', 'N', 4895, NULL, '2290', '2290', NULL, '1997', 'S', 3167, 'SEBASTIÃO LEAL', 'N', '221063', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '208', NULL, '03', 'N', NULL, NULL, NULL, 197);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353350', '3515', 'SP', '3512', '3501', '35008', '35', 'NOVO HORIZONTE', NULL, '17', '14960000', '2', '6771', '6771', '21336', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 932.888, '-21,46800', '-49,22100', 447, 'S', 0.8080, NULL, NULL, '35151', 'N', 'N', 3361, NULL, '3590', '3590', NULL, '1916', 'S', 5122, 'NOVO HORIZONTE', 'N', '353350', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '381', NULL, '03', 'N', NULL, NULL, NULL, 382);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353360', '3508', 'SP', '3513', '3502', '35010', '35', 'NUPORANGA', NULL, '16', '14670000', '1', '6773', '6773', '21337', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 346.982, '-20,73000', '-47,74900', 775, 'S', 0.7840, NULL, NULL, '35082', 'N', 'N', 3381, NULL, '3590', '3590', NULL, '1926', 'S', 5123, 'NUPORANGA', 'N', '353360', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '382', NULL, '03', 'N', NULL, NULL, NULL, 271);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353370', '3509', 'SP', '3510', '3509', '35038', '35', 'OCAUCU', NULL, '14', '17540000', '0', '6775', '6775', '21338', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 300.276, '-22,43900', '-49,92300', 551, 'S', 0.7650, NULL, NULL, '35093', 'N', 'N', 3384, NULL, '3590', '3590', NULL, '1959', 'S', 5124, 'OCAUÇU', 'N', '353370', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '383', NULL, '03', 'N', NULL, NULL, NULL, 96);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353380', '3509', 'SP', '3510', '3510', '35040', '35', 'OLEO', NULL, '14', '18790000', '9', '6777', '6777', '21339', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 197.974, '-22,94100', '-49,34200', 682, 'S', 0.7610, NULL, NULL, '35094', 'N', 'N', 3389, NULL, '3590', '3590', NULL, '1917', 'S', 5125, 'ÓLEO', 'N', '353380', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '384', NULL, '03', 'N', NULL, NULL, NULL, 329);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353400', '3515', 'SP', '3512', '3501', '35004', '35', 'ONDA VERDE', NULL, '17', '15450000', '5', '6781', '6781', '21341', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 243.435, '-20,61400', '-49,29900', 534, 'S', 0.7770, NULL, NULL, '35155', 'N', 'N', 3410, NULL, '3590', '3590', NULL, '1964', 'S', 5127, 'ONDA VERDE', 'N', '353400', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '386', NULL, '03', 'N', NULL, NULL, NULL, 392);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353410', '3509', 'SP', '3510', '3509', '35038', '35', 'ORIENTE', NULL, '14', '17570000', '4', '6783', '6783', '21342', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 217.819, '-22,15300', '-50,09100', 604, 'S', 0.7910, NULL, NULL, '35093', 'N', 'N', 3412, NULL, '3590', '3590', NULL, '1944', 'S', 5128, 'ORIENTE', 'N', '353410', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '387', NULL, '03', 'N', NULL, NULL, NULL, 96);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353420', '3515', 'SP', '3512', '3501', '35004', '35', 'ORINDIUVA', NULL, '17', '15480000', '3', '6785', '6785', '21343', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 248.299, '-20,18200', '-49,35100', 633, 'S', 0.7760, NULL, NULL, '35155', 'N', 'N', 3413, NULL, '3590', '3590', NULL, '1964', 'S', 5129, 'ORINDIÚVA', 'N', '353420', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '388', NULL, '03', 'N', NULL, NULL, NULL, 392);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353430', '3508', 'SP', '3513', '3502', '35010', '35', 'ORLANDIA', NULL, '16', '14620000', '2', '6787', '6787', '21344', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 296.431, '-20,72000', '-47,88700', 695, 'S', 0.8240, NULL, NULL, '35082', 'N', 'N', 3417, NULL, '3590', '3590', NULL, '1909', 'S', 5130, 'ORLÂNDIA', 'N', '353430', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '389', NULL, '03', 'N', NULL, NULL, NULL, 271);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353450', '3509', 'SP', '3510', '3509', '35038', '35', 'OSCAR BRESSANE', NULL, '14', '19770000', '0', '6791', '6791', '21346', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 221.429, '-22,31800', '-50,28100', 481, 'S', 0.7520, NULL, NULL, '35093', 'N', 'N', 3424, NULL, '3590', '3590', NULL, '1948', 'S', 5132, 'OSCAR BRESSANE', 'N', '353450', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '391', NULL, '03', 'N', NULL, NULL, NULL, 96);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353460', '3509', 'SP', '3510', '3508', '35035', '35', 'OSVALDO CRUZ', NULL, '18', '17700000', '9', '6793', '6793', '21347', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 247.941, '-21,79700', '-50,89000', 485, 'S', 0.7980, NULL, NULL, '35091', 'N', 'N', 3426, NULL, '3590', '3590', NULL, '1944', 'S', 5133, 'OSVALDO CRUZ', 'N', '353460', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '392', NULL, '03', 'N', NULL, NULL, NULL, 322);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353475', '3515', 'SP', '3512', '3501', '35002', '35', 'OUROESTE', NULL, '17', '15685000', '7', '0808', NULL, '21637', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 287.549, '-20,00100', '-50,37200', 500, 'S', 0.7870, NULL, NULL, '35154', 'N', 'N', 3447, NULL, '3590', '3590', NULL, '1997', 'S', 5136, 'OUROESTE', 'N', '353475', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '395', NULL, '03', 'N', NULL, NULL, NULL, 276);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353480', '3511', 'SP', '3511', '3508', '35034', '35', 'OURO VERDE', NULL, '18', '17920000', '7', '6797', '6797', '21349', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 266.452, '-21,48900', '-51,70000', 350, 'S', 0.7230, NULL, NULL, '35111', 'N', 'N', 3442, NULL, '3590', '3590', NULL, '1953', 'S', 5135, 'OURO VERDE', 'N', '353480', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '394', NULL, '03', 'N', NULL, NULL, NULL, 431);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353490', '3509', 'SP', '3510', '3508', '35035', '35', 'PACAEMBU', NULL, '18', '17860000', '6', '6799', '6799', '21350', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 339.722, '-21,56200', '-51,26100', 415, 'S', 0.7630, NULL, NULL, '35091', 'N', 'N', 3450, NULL, '3590', '3590', NULL, '1948', 'S', 5137, 'PACAEMBU', 'N', '353490', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '396', NULL, '03', 'N', NULL, NULL, NULL, 322);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353500', '3515', 'SP', '3512', '3501', '35004', '35', 'PALESTINA', NULL, '17', '15470000', '2', '6801', '6801', '21351', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 695.358, '-20,39000', '-49,43300', 550, 'S', 0.7640, NULL, NULL, '35155', 'N', 'N', 3474, NULL, '3590', '3590', NULL, '1936', 'S', 5138, 'PALESTINA', 'N', '353500', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '397', NULL, '03', 'N', NULL, NULL, NULL, 392);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353510', '3515', 'SP', '3512', '3501', '35005', '35', 'PALMARES PAULISTA', NULL, '17', '15828000', '1', '6803', '6803', '21352', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 82.228, '-21,08300', '-48,80100', 530, 'S', 0.7650, NULL, NULL, '35151', 'N', 'N', 3484, NULL, '3590', '3590', NULL, '1959', 'S', 5139, 'PALMARES PAULISTA', 'N', '353510', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '398', NULL, '03', 'N', NULL, NULL, NULL, 382);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353520', '3515', 'SP', '3512', '3501', '35001', '35', 'PALMEIRA D''OESTE', NULL, '17', '15720000', '0', '6805', '6805', '21353', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 320.086, '-20,41600', '-50,76200', 433, 'S', 0.7650, NULL, NULL, '35153', 'N', 'N', 3490, NULL, '3590', '3590', NULL, '1959', 'S', 5140, 'PALMEIRA D OESTE', 'N', '353520', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '399', NULL, '03', 'N', NULL, NULL, NULL, 436);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353530', '3509', 'SP', '3510', '3510', '35039', '35', 'PALMITAL', NULL, '18', '19970000', '9', '6807', '6807', '21354', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 549.040, '-22,78900', '-50,21800', 508, 'S', 0.7830, NULL, NULL, '35092', 'N', 'N', 3505, NULL, '3590', '3590', NULL, '1919', 'S', 5141, 'PALMITAL', 'N', '353530', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '400', NULL, '03', 'N', NULL, NULL, NULL, 274);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353540', '3511', 'SP', '3511', '3508', '35034', '35', 'PANORAMA', NULL, '18', '17980000', '8', '6809', '6809', '21355', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 353.137, '-21,35600', '-51,86000', 276, 'S', 0.7830, NULL, NULL, '35111', 'N', 'N', 3514, NULL, '3590', '3590', NULL, '1953', 'S', 5142, 'PANORAMA', 'N', '353540', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '401', NULL, '03', 'N', NULL, NULL, NULL, 431);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353550', '3509', 'SP', '3510', '3510', '35039', '35', 'PARAGUACU PAULISTA', NULL, '18', '19700000', '7', '6811', '6811', '21356', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1001.094, '-22,41300', '-50,57600', 506, 'S', 0.7730, NULL, NULL, '35092', 'N', 'N', 3526, NULL, '3590', '3590', NULL, '1924', 'S', 5143, 'PARAGUAÇU PAULISTA', 'N', '353550', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '402', NULL, '03', 'N', NULL, NULL, NULL, 274);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353560', '3517', 'SP', '3517', '3513', '35053', '35', 'PARAIBUNA', NULL, '12', '12260000', '6', '6813', '6813', '21357', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 809.794, '-23,38600', '-45,66200', 635, 'S', 0.7710, NULL, NULL, '35171', 'N', 'N', 3530, NULL, '3590', '3590', NULL, '1832', 'S', 5144, 'PARAIBUNA', 'N', '353560', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '403', NULL, '03', 'N', NULL, NULL, NULL, 324);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353570', '3515', 'SP', '3512', '3501', '35005', '35', 'PARAISO', NULL, '17', '15825000', '5', '6815', '6815', '21358', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 154.558, '-21,01600', '-48,77400', 598, 'S', 0.7930, NULL, NULL, '35151', 'N', 'N', 3532, NULL, '3590', '3590', NULL, '1953', 'S', 5145, 'PARAÍSO', 'N', '353570', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '404', NULL, '03', 'N', NULL, NULL, NULL, 382);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221150', '2206', 'PI', '2204', '2204', '22015', '22', 'VERA MENDES', NULL, '89', '64568000', '6', '0406', NULL, '16221', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 310.368, '-7,60300', '-41,48300', 297, 'S', 0.5150, NULL, NULL, '22900', 'S', 'N', 5409, NULL, '2290', '2290', NULL, '1997', 'S', 3181, 'VERA MENDES', 'N', '221150', 'N', 'S', 'S', NULL, 96, 'S', 'N', 'N', '222', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221160', '2206', 'PI', '2204', '2204', '22015', '22', 'VILA NOVA DO PIAUI', NULL, '89', '64688000', '5', '0408', NULL, '16222', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 167.959, '-7,13600', '-40,94000', 400, 'S', 0.5800, NULL, NULL, '22900', 'S', 'N', 5449, NULL, '2290', '2290', NULL, '1997', 'S', 3182, 'VILA NOVA DO PIAUÍ', 'N', '221160', 'N', 'S', 'S', NULL, 96, 'N', 'N', 'N', '223', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('221170', '2206', 'PI', '2204', '2204', '22013', '22', 'WALL FERRAZ', NULL, '89', '64548000', '4', '0410', NULL, '16223', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 264.710, '-7,23300', '-41,91000', 160, 'S', 0.5360, NULL, NULL, '22900', 'S', 'N', 5488, NULL, '2290', '2290', NULL, '1997', 'S', 3183, 'WALL FERRAZ', 'N', '221170', 'N', 'S', 'S', NULL, 133, 'S', 'N', 'N', '224', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230015', '2303', 'CE', '2301', '2302', '23013', '23', 'ACARAPE', NULL, '85', '62785000', '0', '1231', '1231', '05156', NULL, 'ATIVO', 'N', 'N', NULL, 'ACARAPÉ                   ', 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 155.188, '-4,22400', '-38,70800', 80, 'S', 0.6230, NULL, NULL, '23900', 'S', 'N', 20, NULL, '2390', '2301', NULL, '1989', 'S', 618, 'ACARAPE', 'N', '230015', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '2', NULL, '03', 'N', NULL, NULL, NULL, 228);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230020', '2312', 'CE', '2302', '2301', '23001', '23', 'ACARAU', NULL, '88', '62580000', '0', '1303', '1303', '05002', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 842.884, '-2,88600', '-40,12000', 7, 'S', 0.6170, NULL, NULL, '23900', 'N', 'N', 21, NULL, '2390', '2390', NULL, '1849', 'S', 619, 'ACARAÚ', 'N', '230020', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '3', NULL, '02', 'N', NULL, NULL, NULL, 170);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230030', '2318', 'CE', '2303', '2304', '23021', '23', 'ACOPIARA', NULL, '88', '63560000', '9', '1305', '1305', '05003', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 2265.316, '-6,09500', '-39,45300', 317, 'S', 0.5970, NULL, NULL, '23900', 'N', 'N', 24, NULL, '2390', '2390', NULL, '1921', 'S', 620, 'ACOPIARA', 'N', '230030', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '4', NULL, '02', 'N', NULL, NULL, NULL, 108);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241270', '2405', 'RN', '2490', '2403', '24015', '24', 'SAO PEDRO', NULL, '84', '59480000', '8', '1851', '1851', '18126', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 195.238, '-5,89800', '-35,63400', 61, 'S', 0.6300, NULL, NULL, '24900', 'S', 'N', 4800, NULL, '2490', '2490', NULL, '1962', 'S', 3809, 'SÃO PEDRO', 'N', '241270', 'N', 'S', 'S', NULL, 123, 'S', 'N', 'N', '138', NULL, '03', 'N', NULL, NULL, NULL, 270);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241280', '2402', 'RN', '2490', '2401', '24004', '24', 'SAO RAFAEL', NULL, '84', '59518000', '7', '1853', '1853', '18127', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 469.096, '-5,79900', '-36,92100', 69, 'S', 0.6380, NULL, NULL, '24900', 'S', 'N', 4817, NULL, '2490', '2490', NULL, '1948', 'S', 3810, 'SÃO RAFAEL', 'N', '241280', 'N', 'S', 'S', NULL, 1, 'S', 'N', 'N', '139', NULL, '03', 'N', NULL, NULL, NULL, 37);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241350', '2401', 'RN', '2490', '2403', '24015', '24', 'SERRINHA', NULL, '84', '59258000', '8', '1867', '1867', '18134', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 193.352, '-6,27600', '-35,49900', 90, 'S', 0.5980, NULL, NULL, '24900', 'S', 'N', 4963, NULL, '2490', '2490', NULL, '1963', 'S', 3819, 'SERRINHA', 'N', '241350', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '147', NULL, '03', 'N', NULL, NULL, NULL, 148);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241355', '2406', 'RN', '2490', '2401', '24007', '24', 'SERRINHA DOS PINTOS', NULL, '84', '59808000', '7', '0432', NULL, '18166', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 122.644, '-6,11000', '-37,95600', 615, 'S', 0.6370, NULL, NULL, '24900', 'S', 'N', 4964, NULL, '2490', '2490', NULL, '1997', 'S', 3820, 'SERRINHA DOS PINTOS', 'N', '241355', 'N', 'S', 'S', NULL, 134, 'S', 'N', 'N', '148', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241360', '2406', 'RN', '2490', '2401', '24006', '24', 'SEVERIANO MELO', NULL, '84', '59856000', '7', '1869', '1869', '18135', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 157.833, '-5,77700', '-37,95800', 147, 'S', 0.6310, NULL, NULL, '24900', 'S', 'N', 4981, NULL, '2490', '2490', NULL, '1963', 'S', 3821, 'SEVERIANO MELO', 'N', '241360', 'N', 'S', 'S', NULL, 32, 'S', 'N', 'N', '149', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241370', '2405', 'RN', '2490', '2403', '24014', '24', 'SITIO NOVO', NULL, '84', '59440000', '6', '1871', '1871', '18136', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 213.470, '-6,10400', '-35,91100', 175, 'S', 0.6050, NULL, NULL, '24900', 'S', 'N', 5010, NULL, '2490', '2490', NULL, '1958', 'S', 3822, 'SÍTIO NOVO', 'N', '241370', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '150', NULL, '03', 'N', NULL, NULL, NULL, 270);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241380', '2406', 'RN', '2490', '2401', '24006', '24', 'TABOLEIRO GRANDE', NULL, '84', '59840000', '5', '1873', '1873', '18137', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 124.094, '-5,93000', '-38,04500', 139, 'S', 0.6410, NULL, NULL, '24900', 'S', 'N', 5057, NULL, '2490', '2490', NULL, '1963', 'S', 3823, 'TABOLEIRO GRANDE', 'N', '241380', 'N', 'S', 'S', NULL, 134, 'N', 'N', 'N', '151', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241390', '2403', 'RN', '2490', '2404', '24016', '24', 'TAIPU', NULL, '84', '59565000', '4', '1875', '1875', '18138', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 352.818, '-5,62200', '-35,59700', 41, 'S', 0.5840, NULL, NULL, '24900', 'S', 'N', 5070, NULL, '2490', '2490', NULL, '1891', 'S', 3824, 'TAIPU', 'N', '241390', 'N', 'S', 'S', NULL, 55, 'S', 'N', 'N', '152', NULL, '03', 'N', NULL, NULL, NULL, 84);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241400', '2405', 'RN', '2490', '2403', '24014', '24', 'TANGARA', NULL, '84', '59240000', '1', '1877', '1877', '18139', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 356.780, '-6,19900', '-35,80200', 186, 'S', 0.6310, NULL, NULL, '24900', 'S', 'N', 5080, NULL, '2490', '2490', NULL, '1958', 'S', 3825, 'TANGARÁ', 'N', '241400', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '153', NULL, '03', 'N', NULL, NULL, NULL, 270);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241410', '2406', 'RN', '2490', '2401', '24006', '24', 'TENENTE ANANIAS', NULL, '84', '59955000', '0', '1879', '1879', '18140', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 223.670, '-6,46500', '-38,18000', 340, 'S', 0.5970, NULL, NULL, '24900', 'S', 'N', 5138, NULL, '2490', '2490', NULL, '1962', 'S', 3826, 'TENENTE ANANIAS', 'N', '241410', 'N', 'S', 'S', NULL, 134, 'S', 'N', 'N', '154', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241415', '2404', 'RN', '2490', '2402', '24010', '24', 'TENENTE LAURENTINO CRUZ', NULL, '84', '59338000', '9', '0434', NULL, '18167', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 74.376, '-6,14800', '-36,71900', 730, 'S', 0.6280, NULL, NULL, '24900', 'S', 'N', 5139, NULL, '2490', '2490', NULL, '1997', 'S', 3827, 'TENENTE LAURENTINO CRUZ', 'N', '241415', 'N', 'S', 'S', NULL, 76, 'N', 'N', 'N', '155', NULL, '03', 'N', NULL, NULL, NULL, 83);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241420', '2401', 'RN', '2490', '2404', '24019', '24', 'TIBAU DO SUL', NULL, '84', '59178000', '9', '1881', '1881', '18141', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 101.793, '-6,18700', '-35,09200', 38, 'S', 0.6550, NULL, NULL, '24900', 'S', 'N', 5170, NULL, '2490', '2490', NULL, '1963', 'S', 3829, 'TIBAU DO SUL', 'N', '241420', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '157', NULL, '03', 'N', NULL, NULL, NULL, 148);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241430', '2404', 'RN', '2490', '2402', '24011', '24', 'TIMBAUBA DOS BATISTAS', NULL, '84', '59320000', '8', '1883', '1883', '18142', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 135.450, '-6,46500', '-37,27400', 161, 'S', 0.7190, NULL, NULL, '24900', 'N', 'N', 5176, NULL, '2490', '2490', NULL, '1962', 'S', 3830, 'TIMBAÚBA DOS BATISTAS', 'N', '241430', 'N', 'S', 'S', NULL, 76, 'N', 'N', 'N', '158', NULL, '03', 'N', NULL, NULL, NULL, 83);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241440', '2403', 'RN', '2490', '2404', '24016', '24', 'TOUROS', NULL, '84', '59584000', '7', '1885', '1885', '18143', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 839.351, '-5,19900', '-35,46100', 2, 'S', 0.5950, NULL, NULL, '24900', 'S', 'N', 5205, NULL, '2490', '2490', NULL, '1833', 'S', 3831, 'TOUROS', 'N', '241440', 'N', 'S', 'S', NULL, 55, 'S', 'N', 'N', '159', NULL, '03', 'N', NULL, NULL, NULL, 84);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241445', '2402', 'RN', '2490', '2401', '24003', '24', 'TRIUNFO POTIGUAR', NULL, '84', '59685000', '6', '0436', NULL, '18157', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 268.706, '-5,86700', '-37,18900', 100, 'S', 0.5770, NULL, NULL, '24900', 'S', 'N', 5242, NULL, '2490', '2490', NULL, '1997', 'S', 3832, 'TRIUNFO POTIGUAR', 'N', '241445', 'N', 'S', 'S', NULL, 32, 'S', 'N', 'N', '160', NULL, '03', 'N', NULL, NULL, NULL, 37);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250057', '2503', 'PB', '2590', '2503', '25012', '25', 'ALGODAO DE JANDAIRA', NULL, '83', '58399000', '7', '0442', '0442', '13174', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'S', NULL, 'N', 220.246, '-6,81600', '-35,92200', 470, 'S', 0.5520, NULL, NULL, '25900', 'S', 'N', 115, NULL, '2590', '2590', NULL, '1997', 'S', 2561, 'ALGODÃO DE JANDAÍRA', 'N', '250057', 'N', 'S', 'S', NULL, 24, 'S', 'N', 'N', '7', NULL, '03', 'N', NULL, NULL, NULL, 310);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353580', '3506', 'SP', '3509', '3504', '35022', '35', 'PARANAPANEMA', NULL, '14', '18720000', '4', '6817', '6817', '21359', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1019.841, '-23,38900', '-48,72300', 610, 'S', 0.7550, NULL, NULL, '35061', 'N', 'N', 3548, NULL, '3590', '3590', NULL, '1944', 'S', 5146, 'PARANAPANEMA', 'N', '353580', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '405', NULL, '03', 'N', NULL, NULL, NULL, 102);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353590', '3515', 'SP', '3512', '3501', '35001', '35', 'PARANAPUA', NULL, '17', '15745000', '3', '6819', '6819', '21360', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 139.514, '-20,10300', '-50,58600', 474, 'S', 0.7750, NULL, NULL, '35153', 'N', 'N', 3550, NULL, '3590', '3590', NULL, '1964', 'S', 5147, 'PARANAPUÃ', 'N', '353590', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '406', NULL, '03', 'N', NULL, NULL, NULL, 436);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353600', '3509', 'SP', '3510', '3508', '35035', '35', 'PARAPUA', NULL, '18', '17730000', '0', '6821', '6821', '21361', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 365.224, '-21,78300', '-50,79300', 486, 'S', 0.7920, NULL, NULL, '35095', 'N', 'N', 3556, NULL, '3590', '3590', NULL, '1944', 'S', 5148, 'PARAPUÃ', 'N', '353600', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '407', NULL, '03', 'N', NULL, NULL, NULL, 221);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353620', '3512', 'SP', '3507', '3514', '35055', '35', 'PARIQUERA-ACU', NULL, '13', '11930000', '8', '6825', '6825', '21363', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 359.691, '-24,71500', '-47,88100', 39, 'S', 0.7700, NULL, NULL, '35121', 'N', 'N', 3572, NULL, '3590', '3590', NULL, '1953', 'S', 5150, 'PARIQUERA-AÇU', 'N', '353620', 'N', 'N', 'S', NULL, 100, 'N', 'N', 'N', '409', NULL, '03', 'N', NULL, NULL, NULL, 222);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353625', '3515', 'SP', '3512', '3501', '35003', '35', 'PARISI', NULL, '17', '15525000', '7', '2989', '2989', '21608', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 84.509, '-20,30400', '-50,01500', 496, 'S', 0.7560, NULL, NULL, '35157', 'N', 'N', 3573, NULL, '3590', '3590', NULL, '1993', 'S', 5151, 'PARISI', 'N', '353625', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '410', NULL, '03', 'N', NULL, NULL, NULL, 162);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353630', '3508', 'SP', '3513', '3502', '35012', '35', 'PATROCINIO PAULISTA', NULL, '16', '14415000', '7', '6827', '6827', '21364', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 600.107, '-20,63900', '-47,28200', 743, 'S', 0.8090, NULL, NULL, '35081', 'N', 'N', 3606, NULL, '3590', '3590', NULL, '1885', 'S', 5152, 'PATROCÍNIO PAULISTA', 'N', '353630', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '411', NULL, '03', 'N', NULL, NULL, NULL, 101);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250060', '2501', 'PB', '2590', '2504', '25023', '25', 'ALHANDRA', NULL, '83', '58320000', '1', '1911', '1911', '13006', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 182.656, '-7,43900', '-34,91400', 49, 'S', 0.6050, NULL, NULL, '25900', 'S', 'N', 116, NULL, '2501', '2590', NULL, '1959', 'S', 2562, 'ALHANDRA', 'N', '250060', 'N', 'S', 'S', NULL, 120, 'N', 'N', 'S', '8', NULL, '03', 'N', NULL, NULL, NULL, 26);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250135', '2503', 'PB', '2590', '2502', '25010', '25', 'ASSUNCAO', NULL, '83', '58685000', '1', '0450', '0450', '13178', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'S', NULL, 'N', 126.427, '-7,07400', '-36,73100', 573, 'S', 0.6110, NULL, NULL, '25900', 'S', 'N', 408, NULL, '2590', '2590', NULL, '1997', 'S', 2573, 'ASSUNÇÃO', 'N', '250135', 'N', 'S', 'S', NULL, 27, 'S', 'N', 'N', '18', NULL, '03', 'N', NULL, NULL, NULL, 419);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250140', '2501', 'PB', '2590', '2504', '25020', '25', 'BAIA DA TRAICAO', NULL, '83', '58295000', '1', '1929', '1929', '13015', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 102.364, '-6,68800', '-34,93600', 2, 'S', 0.5940, NULL, NULL, '25900', 'S', 'N', 449, NULL, '2590', '2590', NULL, '1962', 'S', 2574, 'BAÍA DA TRAIÇÃO', 'N', '250140', 'N', 'S', 'S', NULL, 103, 'N', 'N', 'N', '19', NULL, '03', 'N', NULL, NULL, NULL, 252);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250150', '2502', 'PB', '2590', '2503', '25015', '25', 'BANANEIRAS', NULL, '83', '58220000', '0', '1931', '1931', '13016', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'S', NULL, 'N', 257.981, '-6,75000', '-35,63300', 520, 'S', 0.5990, NULL, NULL, '25900', 'S', 'N', 471, NULL, '2590', '2590', NULL, '1833', 'S', 2575, 'BANANEIRAS', 'N', '250150', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '20', NULL, '03', 'N', NULL, NULL, NULL, 420);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250153', '2504', 'PB', '2590', '2502', '25009', '25', 'BARAUNA', NULL, '83', '58188000', '4', '0452', '0452', '13179', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'S', NULL, 'N', 50.577, '-6,64300', '-36,25400', 626, 'S', 0.5920, NULL, NULL, '25900', 'S', 'N', 488, NULL, '2590', '2590', NULL, '1997', 'S', 2576, 'BARAÚNA', 'N', '250153', 'N', 'S', 'S', NULL, 160, 'N', 'N', 'N', '21', NULL, '03', 'N', NULL, NULL, NULL, 137);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250157', '2503', 'PB', '2590', '2502', '25011', '25', 'BARRA DE SANTANA', NULL, '83', '58458000', '5', '0454', '0454', '13180', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 369.290, '-7,52000', '-36,00000', 350, 'S', 0.5750, NULL, NULL, '25900', 'S', 'N', 505, NULL, '2502', '2590', NULL, '1997', 'S', 2578, 'BARRA DE SANTANA', 'N', '250157', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '23', NULL, '03', 'N', NULL, NULL, NULL, 72);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250160', '2504', 'PB', '2590', '2503', '25012', '25', 'BARRA DE SANTA ROSA', NULL, '83', '58170000', '9', '1933', '1933', '13017', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 825.097, '-6,72000', '-36,06100', 457, 'S', 0.5750, NULL, NULL, '25900', 'S', 'N', 504, NULL, '2590', '2590', NULL, '1959', 'S', 2577, 'BARRA DE SANTA ROSA', 'N', '250160', 'N', 'S', 'S', NULL, 160, 'S', 'N', 'N', '22', NULL, '03', 'N', NULL, NULL, NULL, 137);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250170', '2503', 'PB', '2590', '2502', '25011', '25', 'BARRA DE SAO MIGUEL', NULL, '83', '58483000', '8', '1935', '1935', '13018', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 595.205, '-7,75100', '-36,31800', 486, 'S', 0.6130, NULL, NULL, '25900', 'S', 'N', 508, NULL, '2590', '2590', NULL, '1961', 'S', 2579, 'BARRA DE SÃO MIGUEL', 'N', '250170', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '24', NULL, '03', 'N', NULL, NULL, NULL, 72);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250180', '2501', 'PB', '2590', '2504', '25022', '25', 'BAYEUX', NULL, '83', '58306970', '7', '1937', '1937', '13019', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 31.784, '-7,12500', '-34,93200', 11, 'S', 0.6890, NULL, NULL, '25900', 'N', 'N', 558, NULL, '2501', '2501', NULL, '1959', 'S', 2580, 'BAYEUX', 'N', '250180', 'N', 'S', 'S', NULL, 120, 'S', 'N', 'S', '25', NULL, '01', 'N', NULL, NULL, NULL, 26);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250280', '2508', 'PB', '2590', '2501', '25001', '25', 'BREJO DO CRUZ', NULL, '83', '58890000', '5', '1957', '1957', '13029', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 398.917, '-6,34900', '-37,49800', 199, 'S', 0.6350, NULL, NULL, '25900', 'S', 'N', 759, NULL, '2590', '2590', NULL, '1881', 'S', 2591, 'BREJO DO CRUZ', 'N', '250280', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '36', NULL, '03', 'N', NULL, NULL, NULL, 255);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250290', '2508', 'PB', '2590', '2501', '25001', '25', 'BREJO DOS SANTOS', NULL, '83', '58880000', '4', '1959', '1959', '13030', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 93.848, '-6,37700', '-37,82500', 328, 'S', 0.6130, NULL, NULL, '25900', 'S', 'N', 761, NULL, '2590', '2590', NULL, '1965', 'S', 2592, 'BREJO DOS SANTOS', 'N', '250290', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '37', NULL, '03', 'N', NULL, NULL, NULL, 255);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250300', '2501', 'PB', '2590', '2504', '25023', '25', 'CAAPORA', NULL, '83', '58326000', '1', '1961', '1961', '13031', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 150.168, '-7,51600', '-34,90800', 29, 'S', 0.6170, NULL, NULL, '25900', 'S', 'N', 805, NULL, '2501', '2590', NULL, '1963', 'S', 2593, 'CAAPORÃ', 'N', '250300', 'N', 'S', 'S', NULL, 120, 'S', 'N', 'N', '38', NULL, '03', 'N', NULL, NULL, NULL, 26);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250310', '2503', 'PB', '2590', '2502', '25011', '25', 'CABACEIRAS', NULL, '83', '58480000', '0', '1963', '1963', '13032', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 400.222, '-7,48900', '-36,28700', 388, 'S', 0.6820, NULL, NULL, '25900', 'S', 'N', 808, NULL, '2590', '2590', NULL, '1834', 'S', 2594, 'CABACEIRAS', 'N', '250310', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '39', NULL, '03', 'N', NULL, NULL, NULL, 72);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250320', '2501', 'PB', '2590', '2504', '25022', '25', 'CABEDELO', NULL, '83', '58310000', '9', '1965', '1965', '13033', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 31.265, '-6,98100', '-34,83400', 3, 'S', 0.7570, NULL, NULL, '25900', 'N', 'N', 813, NULL, '2501', '2501', NULL, '1956', 'S', 2595, 'CABEDELO', 'N', '250320', 'N', 'S', 'S', NULL, 103, 'S', 'N', 'S', '40', NULL, '02', 'N', NULL, NULL, NULL, 26);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250330', '2509', 'PB', '2590', '2501', '25002', '25', 'CACHOEIRA DOS INDIOS', NULL, '83', '58935000', '8', '1967', '1967', '13034', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 172.906, '-6,92700', '-38,67400', 319, 'S', 0.5770, NULL, NULL, '25900', 'S', 'N', 836, NULL, '2590', '2590', NULL, '1961', 'S', 2596, 'CACHOEIRA DOS ÍNDIOS', 'N', '250330', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '41', NULL, '03', 'N', NULL, NULL, NULL, 74);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250340', '2506', 'PB', '2590', '2501', '25004', '25', 'CACIMBA DE AREIA', NULL, '83', '58730000', '7', '1969', '1969', '13035', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 233.037, '-7,12900', '-37,15700', 272, 'S', 0.5810, NULL, NULL, '25900', 'S', 'N', 846, NULL, '2504', '2590', NULL, '1961', 'S', 2597, 'CACIMBA DE AREIA', 'N', '250340', 'N', 'S', 'S', NULL, 59, 'S', 'N', 'N', '42', NULL, '03', 'N', NULL, NULL, NULL, 254);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250350', '2502', 'PB', '2590', '2503', '25013', '25', 'CACIMBA DE DENTRO', NULL, '83', '58230000', '6', '1971', '1971', '13036', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 181.221, '-6,64200', '-35,79000', 536, 'S', 0.5480, NULL, NULL, '25900', 'S', 'N', 847, NULL, '2590', '2590', NULL, '1959', 'S', 2598, 'CACIMBA DE DENTRO', 'N', '250350', 'N', 'S', 'S', NULL, 160, 'S', 'N', 'N', '43', NULL, '03', 'N', NULL, NULL, NULL, 420);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250355', '2506', 'PB', '2590', '2501', '25007', '25', 'CACIMBAS', NULL, '83', '58698000', '5', '0460', '0460', '13183', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 142.926, '-7,21100', '-37,05800', 645, 'S', 0.4940, NULL, NULL, '25900', 'S', 'N', 848, NULL, '2504', '2590', NULL, '1997', 'S', 2599, 'CACIMBAS', 'N', '250355', 'N', 'S', 'S', NULL, 59, 'S', 'N', 'N', '44', NULL, '03', 'N', NULL, NULL, NULL, 254);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250360', '2502', 'PB', '2590', '2503', '25016', '25', 'CAICARA', NULL, '83', '58253000', '5', '1973', '1973', '13037', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 127.911, '-6,55400', '-35,41100', 150, 'S', 0.5760, NULL, NULL, '25900', 'S', 'N', 872, NULL, '2503', '2590', NULL, '1908', 'S', 2600, 'CAIÇARA', 'N', '250360', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '45', NULL, '03', 'N', NULL, NULL, NULL, 420);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250370', '2509', 'PB', '2590', '2501', '25002', '25', 'CAJAZEIRAS', NULL, '83', '58900000', '4', '1975', '1975', '13038', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 586.275, '-6,89000', '-38,56200', 298, 'S', 0.6850, NULL, NULL, '25900', 'N', 'N', 883, NULL, '2590', '2590', NULL, '1863', 'S', 2601, 'CAJAZEIRAS', 'N', '250370', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '46', NULL, '02', 'N', NULL, NULL, NULL, 74);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250375', '2510', 'PB', '2590', '2501', '25003', '25', 'CAJAZEIRINHAS', NULL, '83', '58855000', '3', '0462', '0462', '13184', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 287.891, '-6,96100', '-37,80600', 261, 'S', 0.5430, NULL, NULL, '25900', 'S', 'N', 885, NULL, '2590', '2590', NULL, '1997', 'S', 2602, 'CAJAZEIRINHAS', 'N', '250375', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '47', NULL, '03', 'N', NULL, NULL, NULL, 136);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250380', '2512', 'PB', '2590', '2503', '25018', '25', 'CALDAS BRANDAO', NULL, '83', '58350000', '3', '1977', '1977', '13039', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 55.853, '-7,10300', '-35,32600', 75, 'S', 0.5480, NULL, NULL, '25900', 'S', 'N', 894, NULL, '2590', '2590', NULL, '1965', 'S', 2603, 'CALDAS BRANDÃO', 'N', '250380', 'N', 'S', 'S', NULL, 120, 'N', 'N', 'N', '48', NULL, '03', 'N', NULL, NULL, NULL, 309);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250390', '2505', 'PB', '2590', '2502', '25010', '25', 'CAMALAU', NULL, '83', '58530000', '2', '1979', '1979', '13040', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 603.060, '-7,88900', '-36,82300', 521, 'S', 0.5810, NULL, NULL, '25900', 'S', 'N', 905, NULL, '2590', '2590', NULL, '1961', 'S', 2604, 'CAMALAÚ', 'N', '250390', 'N', 'S', 'S', NULL, 27, 'N', 'N', 'N', '49', NULL, '03', 'N', NULL, NULL, NULL, 253);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250400', '2503', 'PB', '2590', '2503', '25017', '25', 'CAMPINA GRANDE', NULL, '83', '58100970', '9', '1981', '1981', '13041', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 620.628, '-7,23100', '-35,88100', 551, 'S', 0.7210, NULL, NULL, '25900', 'N', 'N', 934, NULL, '2502', '2590', NULL, '1788', 'S', 2605, 'CAMPINA GRANDE', 'N', '250400', 'N', 'S', 'S', NULL, 24, 'N', 'S', 'S', '50', NULL, '01', 'N', NULL, NULL, NULL, 419);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250403', '2501', 'PB', '2590', '2504', '25020', '25', 'CAPIM', NULL, '83', '58287000', '3', '0464', '0464', '13185', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 78.165, '-6,91600', '-35,17200', 101, 'S', 0.5190, NULL, NULL, '25900', 'S', 'N', 1049, NULL, '2590', '2590', NULL, '1997', 'S', 2606, 'CAPIM', 'N', '250403', 'N', 'S', 'S', NULL, 103, 'S', 'N', 'N', '52', NULL, '03', 'N', NULL, NULL, NULL, 252);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250407', '2505', 'PB', '2590', '2502', '25011', '25', 'CARAUBAS', NULL, '83', '58595000', '4', '0466', '0466', '13186', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 445.575, '-7,72700', '-36,49200', 451, 'S', 0.6230, NULL, NULL, '25900', 'S', 'N', 1086, NULL, '2590', '2590', NULL, '1997', 'S', 2607, 'CARAÚBAS', 'N', '250407', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '53', NULL, '03', 'N', NULL, NULL, NULL, 253);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250410', '2509', 'PB', '2590', '2501', '25002', '25', 'CARRAPATEIRA', NULL, '83', '58945000', '8', '1983', '1983', '13042', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 72.778, '-7,03900', '-38,34400', 372, 'S', 0.6020, NULL, NULL, '25900', 'S', 'N', 1134, NULL, '2590', '2590', NULL, '1961', 'S', 2608, 'CARRAPATEIRA', 'N', '250410', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '54', NULL, '03', 'N', NULL, NULL, NULL, 74);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250415', '2502', 'PB', '2590', '2503', '25013', '25', 'CASSERENGUE', NULL, '83', '58238000', '7', '0468', '0468', '13187', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 201.379, '-6,78300', '-35,82100', 0, 'S', 0.5130, NULL, NULL, '25900', 'S', 'N', 1151, NULL, '2590', '2590', NULL, '1997', 'S', 2609, 'CASSERENGUE', 'N', '250415', 'N', 'S', 'S', NULL, 24, 'S', 'N', 'N', '55', NULL, '03', 'N', NULL, NULL, NULL, 420);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230040', '2314', 'CE', '2304', '2304', '23020', '23', 'AIUABA', NULL, '88', '63575000', '8', '1307', '1307', '05004', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 2434.414, '-6,57400', '-40,12400', 466, 'S', 0.5660, NULL, NULL, '23900', 'S', 'N', 83, NULL, '2390', '2390', NULL, '1956', 'S', 621, 'AIUABA', 'N', '230040', 'N', 'S', 'S', NULL, 49, 'N', 'N', 'N', '5', NULL, '03', 'N', NULL, NULL, NULL, 337);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250420', '2506', 'PB', '2590', '2501', '25005', '25', 'CATINGUEIRA', NULL, '83', '58715000', '7', '1985', '1985', '13043', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 529.456, '-7,12600', '-37,60900', 287, 'S', 0.5550, NULL, NULL, '25900', 'S', 'N', 1174, NULL, '2504', '2590', NULL, '1959', 'S', 2610, 'CATINGUEIRA', 'N', '250420', 'N', 'S', 'S', NULL, 59, 'S', 'N', 'N', '56', NULL, '03', 'N', NULL, NULL, NULL, 254);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250430', '2508', 'PB', '2590', '2501', '25001', '25', 'CATOLE DO ROCHA', NULL, '83', '58884000', '6', '1987', '1987', '13044', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 552.098, '-6,34400', '-37,74700', 272, 'S', 0.6680, NULL, NULL, '25900', 'S', 'N', 1176, NULL, '2590', '2590', NULL, '1835', 'S', 2611, 'CATOLÉ DO ROCHA', 'N', '250430', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '57', NULL, '03', 'N', NULL, NULL, NULL, 255);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250435', '2503', 'PB', '2590', '2502', '25011', '25', 'CATURITE', NULL, '83', '58455000', '5', '0470', '0470', '13188', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 118.089, '-7,42000', '-36,02700', 405, 'S', 0.6170, NULL, NULL, '25900', 'S', 'N', 1183, NULL, '2502', '2590', NULL, '1997', 'S', 2612, 'CATURITÉ', 'N', '250435', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '58', NULL, '03', 'N', NULL, NULL, NULL, 72);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250450', '2506', 'PB', '2590', '2501', '25003', '25', 'CONDADO', NULL, '83', '58714000', '4', '1991', '1991', '13046', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 280.913, '-6,91000', '-37,60100', 253, 'S', 0.6030, NULL, NULL, '25900', 'S', 'N', 1334, NULL, '2504', '2590', NULL, '1961', 'S', 2614, 'CONDADO', 'N', '250450', 'N', 'S', 'S', NULL, 59, 'S', 'N', 'N', '60', NULL, '03', 'N', NULL, NULL, NULL, 254);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250460', '2501', 'PB', '2590', '2504', '25022', '25', 'CONDE', NULL, '83', '58322000', '3', '1993', '1993', '13047', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 172.949, '-7,26000', '-34,90800', 112, 'S', 0.6130, NULL, NULL, '25900', 'S', 'N', 1336, NULL, '2501', '2590', NULL, '1963', 'S', 2615, 'CONDE', 'N', '250460', 'N', 'S', 'S', NULL, 120, 'N', 'N', 'N', '61', NULL, '03', 'N', NULL, NULL, NULL, 26);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250470', '2505', 'PB', '2590', '2502', '25010', '25', 'CONGO', NULL, '83', '58535000', '2', '1995', '1995', '13048', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 274.075, '-7,79700', '-36,66000', 480, 'S', 0.6310, NULL, NULL, '25900', 'S', 'N', 1342, NULL, '2590', '2590', NULL, '1959', 'S', 2616, 'CONGO', 'N', '250470', 'N', 'S', 'S', NULL, 27, 'N', 'N', 'N', '62', NULL, '03', 'N', NULL, NULL, NULL, 253);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250480', '2507', 'PB', '2590', '2501', '25005', '25', 'COREMAS', NULL, '83', '58770000', '1', '1997', '1997', '13049', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 379.491, '-7,01400', '-37,94600', 218, 'S', 0.5950, NULL, NULL, '25900', 'S', 'N', 1369, NULL, '2590', '2590', NULL, '1953', 'S', 2617, 'COREMAS', 'N', '250480', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '63', NULL, '03', 'N', NULL, NULL, NULL, 73);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250485', '2505', 'PB', '2590', '2502', '25010', '25', 'COXIXOLA', NULL, '83', '58588000', '0', '0472', '0472', '13189', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 119.059, '-7,62700', '-36,60600', 475, 'S', 0.6390, NULL, NULL, '25900', 'S', 'N', 1424, NULL, '2590', '2590', NULL, '1997', 'S', 2618, 'COXIXOLA', 'N', '250485', 'N', 'S', 'S', NULL, 27, 'N', 'N', 'N', '64', NULL, '03', 'N', NULL, NULL, NULL, 253);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250490', '2501', 'PB', '2590', '2504', '25021', '25', 'CRUZ DO ESPIRITO SANTO', NULL, '83', '58337000', '0', '1999', '1999', '13050', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 195.596, '-7,14000', '-35,08600', 19, 'S', 0.5470, NULL, NULL, '25900', 'S', 'N', 1456, NULL, '2501', '2590', NULL, '1896', 'S', 2619, 'CRUZ DO ESPÍRITO SANTO', 'N', '250490', 'N', 'S', 'S', NULL, 103, 'S', 'N', 'N', '65', NULL, '03', 'N', NULL, NULL, NULL, 26);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250500', '2504', 'PB', '2590', '2502', '25009', '25', 'CUBATI', NULL, '83', '58167000', '6', '2001', '2001', '13051', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 136.965, '-6,86800', '-36,35100', 555, 'S', 0.5910, NULL, NULL, '25900', 'S', 'N', 1470, NULL, '2590', '2590', NULL, '1959', 'S', 2620, 'CUBATI', 'N', '250500', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '66', NULL, '03', 'N', NULL, NULL, NULL, 137);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250510', '2504', 'PB', '2590', '2503', '25012', '25', 'CUITE', NULL, '83', '58175000', '5', '2003', '2003', '13052', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 735.334, '-6,48500', '-36,15700', 649, 'S', 0.5880, NULL, NULL, '25900', 'S', 'N', 1472, NULL, '2590', '2590', NULL, '1936', 'S', 2621, 'CUITÉ', 'N', '250510', 'N', 'S', 'S', NULL, 160, 'S', 'N', 'N', '67', NULL, '03', 'N', NULL, NULL, NULL, 137);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250520', '2502', 'PB', '2590', '2503', '25016', '25', 'CUITEGI', NULL, '83', '58208000', '4', '2005', '2005', '13053', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 39.302, '-6,89300', '-35,52300', 90, 'S', 0.5620, NULL, NULL, '25900', 'S', 'N', 1474, NULL, '2503', '2590', NULL, '1961', 'S', 2623, 'CUITEGI', 'N', '250520', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '69', NULL, '03', 'N', NULL, NULL, NULL, 420);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250523', '2501', 'PB', '2590', '2504', '25020', '25', 'CUITE DE MAMANGUAPE', NULL, '83', '58289000', '8', '0474', '0474', '13190', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 109.806, '-6,91500', '-35,25200', 75, 'S', 0.5440, NULL, NULL, '25900', 'S', 'N', 1473, NULL, '2590', '2590', NULL, '1997', 'S', 2622, 'CUITÉ DE MAMANGUAPE', 'N', '250523', 'N', 'S', 'S', NULL, 103, 'S', 'N', 'N', '68', NULL, '03', 'N', NULL, NULL, NULL, 252);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250527', '2501', 'PB', '2590', '2504', '25020', '25', 'CURRAL DE CIMA', NULL, '83', '58291000', '9', '0476', '0476', '13191', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 85.096, '-6,71700', '-35,26900', 75, 'S', 0.5080, NULL, NULL, '25900', 'S', 'N', 1493, NULL, '2590', '2590', NULL, '1997', 'S', 2624, 'CURRAL DE CIMA', 'N', '250527', 'N', 'S', 'S', NULL, 103, 'N', 'N', 'N', '70', NULL, '03', 'N', NULL, NULL, NULL, 252);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250530', '2507', 'PB', '2590', '2501', '25006', '25', 'CURRAL VELHO', NULL, '83', '58990000', '3', '2007', '2007', '13054', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 180.585, '-7,58100', '-38,19800', 338, 'S', 0.5950, NULL, NULL, '25900', 'S', 'N', 1496, NULL, '2590', '2590', NULL, '1963', 'S', 2625, 'CURRAL VELHO', 'N', '250530', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '71', NULL, '03', 'N', NULL, NULL, NULL, 73);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250535', '2504', 'PB', '2590', '2503', '25012', '25', 'DAMIAO', NULL, '83', '58173000', '2', '0478', '0478', '13192', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 109.760, '-6,63200', '-35,91000', 0, 'S', 0.5270, NULL, NULL, '25900', 'S', 'N', 1506, NULL, '2590', '2590', NULL, '1997', 'S', 2626, 'DAMIÃO', 'N', '250535', 'N', 'S', 'S', NULL, 160, 'N', 'N', 'N', '72', NULL, '03', 'N', NULL, NULL, NULL, 137);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250540', '2506', 'PB', '2590', '2501', '25007', '25', 'DESTERRO', NULL, '83', '58695000', '2', '2009', '2009', '13055', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 179.388, '-7,29100', '-37,09400', 591, 'S', 0.5750, NULL, NULL, '25900', 'S', 'N', 1526, NULL, '2504', '2590', NULL, '1959', 'S', 2627, 'DESTERRO', 'N', '250540', 'N', 'S', 'S', NULL, 59, 'S', 'N', 'N', '73', NULL, '03', 'N', NULL, NULL, NULL, 254);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250550', '2506', 'PB', '2590', '2501', '25003', '25', 'VISTA SERRANA', NULL, '83', '58710000', '1', '2011', '2011', '13056', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 61.361, '-6,73800', '-37,56700', 240, 'S', 0.6500, NULL, NULL, '25900', 'S', 'N', 5471, NULL, '2504', '2590', NULL, '1963', 'S', 2776, 'VISTA SERRANA', 'N', '250550', 'N', 'S', 'S', NULL, 59, 'N', 'N', 'N', '222', NULL, '03', 'N', NULL, NULL, NULL, 254);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250560', '2507', 'PB', '2590', '2501', '25006', '25', 'DIAMANTE', NULL, '83', '58994000', '0', '2013', '2013', '13057', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 269.109, '-7,42800', '-38,26400', 315, 'S', 0.5740, NULL, NULL, '25900', 'S', 'N', 1531, NULL, '2590', '2590', NULL, '1961', 'S', 2628, 'DIAMANTE', 'N', '250560', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '74', NULL, '03', 'N', NULL, NULL, NULL, 73);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250570', '2502', 'PB', '2590', '2503', '25013', '25', 'DONA INES', NULL, '83', '58228000', '9', '2015', '2015', '13058', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 132.445, '-6,61800', '-35,63200', 421, 'S', 0.5510, NULL, NULL, '25900', 'S', 'N', 1589, NULL, '2503', '2590', NULL, '1959', 'S', 2629, 'DONA INÊS', 'N', '250570', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '75', NULL, '03', 'N', NULL, NULL, NULL, 420);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250580', '2502', 'PB', '2590', '2503', '25016', '25', 'DUAS ESTRADAS', NULL, '83', '58265000', '8', '2017', '2017', '13059', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 26.361, '-6,68500', '-35,41800', 144, 'S', 0.5690, NULL, NULL, '25900', 'S', 'N', 1612, NULL, '2503', '2590', NULL, '1961', 'S', 2630, 'DUAS ESTRADAS', 'N', '250580', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '76', NULL, '03', 'N', NULL, NULL, NULL, 420);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250590', '2506', 'PB', '2590', '2501', '25005', '25', 'EMAS', NULL, '83', '58763000', '7', '2019', '2019', '13060', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 240.898, '-7,10800', '-37,71600', 268, 'S', 0.5600, NULL, NULL, '25900', 'S', 'N', 1633, NULL, '2504', '2590', NULL, '1963', 'S', 2631, 'EMAS', 'N', '250590', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '77', NULL, '03', 'N', NULL, NULL, NULL, 254);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250600', '2503', 'PB', '2590', '2503', '25014', '25', 'ESPERANCA', NULL, '83', '58135000', '4', '2021', '2021', '13061', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 165.189, '-7,02300', '-35,86000', 631, 'S', 0.6320, NULL, NULL, '25900', 'S', 'N', 1673, NULL, '2502', '2590', NULL, '1925', 'S', 2632, 'ESPERANÇA', 'N', '250600', 'N', 'S', 'S', NULL, 24, 'N', 'N', 'S', '78', NULL, '03', 'N', NULL, NULL, NULL, 310);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250610', '2503', 'PB', '2590', '2503', '25017', '25', 'FAGUNDES', NULL, '83', '58487000', '3', '2023', '2023', '13062', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 162.101, '-7,35500', '-35,77500', 505, 'S', 0.5590, NULL, NULL, '25900', 'S', 'N', 1714, NULL, '2502', '2590', NULL, '1961', 'S', 2633, 'FAGUNDES', 'N', '250610', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '79', NULL, '03', 'N', NULL, NULL, NULL, 419);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250620', '2504', 'PB', '2590', '2502', '25009', '25', 'FREI MARTINHO', NULL, '83', '58195000', '2', '2025', '2025', '13063', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 244.315, '-6,40300', '-36,45600', 369, 'S', 0.6100, NULL, NULL, '25900', 'S', 'N', 1838, NULL, '2590', '2590', NULL, '1961', 'S', 2634, 'FREI MARTINHO', 'N', '250620', 'N', 'S', 'S', NULL, 160, 'N', 'N', 'N', '80', NULL, '03', 'N', NULL, NULL, NULL, 137);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250625', '2503', 'PB', '2590', '2503', '25019', '25', 'GADO BRAVO', NULL, '83', '58492000', '1', '0480', '0480', '13193', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 192.424, '-7,58300', '-35,79100', 400, 'S', 0.5270, NULL, NULL, '25900', 'S', 'N', 1851, NULL, '2502', '2590', NULL, '1997', 'S', 2635, 'GADO BRAVO', 'N', '250625', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '81', NULL, '03', 'N', NULL, NULL, NULL, 72);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353640', '3511', 'SP', '3511', '3508', '35034', '35', 'PAULICEIA', NULL, '18', '17990000', '6', '6829', '6829', '21365', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 373.891, '-21,31800', '-51,83100', 328, 'S', 0.7540, NULL, NULL, '35111', 'N', 'N', 3617, NULL, '3590', '3590', NULL, '1948', 'S', 5153, 'PAULICÉIA', 'N', '353640', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '412', NULL, '03', 'N', NULL, NULL, NULL, 431);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250630', '2502', 'PB', '2590', '2503', '25016', '25', 'GUARABIRA', NULL, '83', '58200000', '1', '2027', '2027', '13064', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 180.764, '-6,85500', '-35,49000', 97, 'S', 0.6590, NULL, NULL, '25900', 'N', 'N', 1976, NULL, '2503', '2590', NULL, '1837', 'S', 2636, 'GUARABIRA', 'N', '250630', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '82', NULL, '02', 'N', NULL, NULL, NULL, 420);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250640', '2512', 'PB', '2590', '2503', '25018', '25', 'GURINHEM', NULL, '83', '58356000', '0', '2029', '2029', '13065', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 309.276, '-7,12400', '-35,42400', 104, 'S', 0.5450, NULL, NULL, '25900', 'S', 'N', 2023, NULL, '2590', '2590', NULL, '1958', 'S', 2637, 'GURINHÉM', 'N', '250640', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '83', NULL, '03', 'N', NULL, NULL, NULL, 309);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250650', '2503', 'PB', '2590', '2502', '25011', '25', 'GURJAO', NULL, '83', '58670000', '9', '2031', '2031', '13066', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 343.214, '-7,24700', '-36,48900', 491, 'S', 0.6390, NULL, NULL, '25900', 'S', 'N', 2024, NULL, '2590', '2590', NULL, '1962', 'S', 2638, 'GURJÃO', 'N', '250650', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '84', NULL, '03', 'N', NULL, NULL, NULL, 253);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250660', '2507', 'PB', '2590', '2501', '25006', '25', 'IBIARA', NULL, '83', '58980000', '8', '2033', '2033', '13067', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 244.480, '-7,50100', '-38,40500', 341, 'S', 0.5890, NULL, NULL, '25900', 'S', 'N', 2069, NULL, '2590', '2590', NULL, '1959', 'S', 2639, 'IBIARA', 'N', '250660', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '85', NULL, '03', 'N', NULL, NULL, NULL, 73);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250700', '2507', 'PB', '2590', '2501', '25006', '25', 'ITAPORANGA', NULL, '83', '58780000', '2', '2041', '2041', '13071', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 468.069, '-7,30400', '-38,15000', 291, 'S', 0.6240, NULL, NULL, '25900', 'S', 'N', 2364, NULL, '2590', '2590', NULL, '1938', 'S', 2644, 'ITAPORANGA', 'N', '250700', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '90', NULL, '03', 'N', NULL, NULL, NULL, 73);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250710', '2501', 'PB', '2590', '2504', '25020', '25', 'ITAPOROROCA', NULL, '83', '58275000', '1', '2043', '2043', '13072', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 146.067, '-6,83000', '-35,24700', 81, 'S', 0.5730, NULL, NULL, '25900', 'S', 'N', 2367, NULL, '2590', '2590', NULL, '1961', 'S', 2645, 'ITAPOROROCA', 'N', '250710', 'N', 'S', 'S', NULL, 103, 'S', 'N', 'N', '91', NULL, '03', 'N', NULL, NULL, NULL, 252);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250720', '2512', 'PB', '2590', '2503', '25018', '25', 'ITATUBA', NULL, '83', '58378000', '0', '2045', '2045', '13073', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 244.205, '-7,37500', '-35,62800', 117, 'S', 0.5260, NULL, NULL, '25900', 'S', 'N', 2391, NULL, '2502', '2590', NULL, '1961', 'S', 2646, 'ITATUBA', 'N', '250720', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '92', NULL, '03', 'N', NULL, NULL, NULL, 309);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250730', '2501', 'PB', '2590', '2504', '25020', '25', 'JACARAU', NULL, '83', '58278000', '9', '2047', '2047', '13074', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 253.206, '-6,61200', '-35,29300', 170, 'S', 0.5550, NULL, NULL, '25900', 'S', 'N', 2443, NULL, '2590', '2590', NULL, '1961', 'S', 2647, 'JACARAÚ', 'N', '250730', 'N', 'S', 'S', NULL, 103, 'S', 'N', 'N', '93', NULL, '03', 'N', NULL, NULL, NULL, 252);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250740', '2508', 'PB', '2590', '2501', '25001', '25', 'JERICO', NULL, '83', '58830000', '8', '2049', '2049', '13075', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 179.311, '-6,55400', '-37,80900', 233, 'S', 0.6100, NULL, NULL, '25900', 'S', 'N', 2542, NULL, '2590', '2590', NULL, '1959', 'S', 2648, 'JERICÓ', 'N', '250740', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '94', NULL, '03', 'N', NULL, NULL, NULL, 255);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250750', '2501', 'PB', '2590', '2504', '25022', '25', 'JOAO PESSOA', NULL, '83', '58001970', '7', '2051', '2051', '13076', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'S', 210.551, '-7,11500', '-34,86300', 47, 'S', 0.7830, NULL, NULL, '25900', 'N', 'N', 2565, NULL, '2501', '2501', NULL, '1585', 'S', 2649, 'JOÃO PESSOA', 'N', '250750', 'N', 'S', 'S', NULL, 120, 'S', 'S', 'S', '95', NULL, '01', 'N', NULL, NULL, NULL, 26);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250760', '2512', 'PB', '2590', '2503', '25018', '25', 'JUAREZ TAVORA', NULL, '83', '58387000', '6', '2053', '2053', '13077', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 82.593, '-7,17200', '-35,58300', 145, 'S', 0.5520, NULL, NULL, '25900', 'S', 'N', 2588, NULL, '2590', '2590', NULL, '1959', 'S', 2650, 'JUAREZ TÁVORA', 'N', '250760', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '96', NULL, '03', 'N', NULL, NULL, NULL, 309);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250770', '2503', 'PB', '2590', '2502', '25009', '25', 'JUAZEIRINHO', NULL, '83', '58660000', '5', '2055', '2055', '13078', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 467.526, '-7,06800', '-36,57800', 553, 'S', 0.5810, NULL, NULL, '25900', 'S', 'N', 2591, NULL, '2590', '2590', NULL, '1957', 'S', 2651, 'JUAZEIRINHO', 'N', '250770', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '97', NULL, '03', 'N', NULL, NULL, NULL, 419);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250780', '2506', 'PB', '2590', '2502', '25008', '25', 'JUNCO DO SERIDO', NULL, '83', '58640000', '4', '2057', '2057', '13079', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 170.415, '-6,99700', '-36,71300', 590, 'S', 0.5940, NULL, NULL, '25900', 'S', 'N', 2606, NULL, '2504', '2590', NULL, '1961', 'S', 2652, 'JUNCO DO SERIDÓ', 'N', '250780', 'N', 'S', 'S', NULL, 59, 'S', 'N', 'N', '98', NULL, '03', 'N', NULL, NULL, NULL, 254);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250790', '2512', 'PB', '2590', '2504', '25021', '25', 'JURIPIRANGA', NULL, '83', '58330000', '3', '2059', '2059', '13080', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 78.761, '-7,37300', '-35,23800', 119, 'S', 0.5330, NULL, NULL, '25900', 'S', 'N', 2620, NULL, '2590', '2590', NULL, '1961', 'S', 2653, 'JURIPIRANGA', 'N', '250790', 'N', 'S', 'S', NULL, 120, 'S', 'N', 'N', '99', NULL, '03', 'N', NULL, NULL, NULL, 309);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250800', '2511', 'PB', '2590', '2501', '25007', '25', 'JURU', NULL, '83', '58750000', '0', '2061', '2061', '13081', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 403.276, '-7,53700', '-37,81900', 580, 'S', 0.5610, NULL, NULL, '25900', 'S', 'N', 2621, NULL, '2590', '2590', NULL, '1961', 'S', 2654, 'JURU', 'N', '250800', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '100', NULL, '03', 'N', NULL, NULL, NULL, 135);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250810', '2510', 'PB', '2590', '2501', '25001', '25', 'LAGOA', NULL, '83', '58835000', '9', '2063', '2063', '13082', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 177.900, '-6,57100', '-37,91600', 273, 'S', 0.5750, NULL, NULL, '25900', 'S', 'N', 2648, NULL, '2590', '2590', NULL, '1961', 'S', 2655, 'LAGOA', 'N', '250810', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '101', NULL, '03', 'N', NULL, NULL, NULL, 136);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250820', '2502', 'PB', '2590', '2503', '25016', '25', 'LAGOA DE DENTRO', NULL, '83', '58250000', '8', '2065', '2065', '13083', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 84.505, '-6,67300', '-35,37900', 154, 'S', 0.5650, NULL, NULL, '25900', 'S', 'N', 2654, NULL, '2503', '2590', NULL, '1961', 'S', 2656, 'LAGOA DE DENTRO', 'N', '250820', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '102', NULL, '03', 'N', NULL, NULL, NULL, 420);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250830', '2503', 'PB', '2590', '2503', '25017', '25', 'LAGOA SECA', NULL, '83', '58117000', '7', '2067', '2067', '13084', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 109.342, '-7,17100', '-35,85400', 634, 'S', 0.6120, NULL, NULL, '25900', 'S', 'N', 2678, NULL, '2502', '2590', NULL, '1964', 'S', 2657, 'LAGOA SECA', 'N', '250830', 'N', 'S', 'S', NULL, 24, 'N', 'N', 'N', '103', NULL, '03', 'N', NULL, NULL, NULL, 310);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250840', '2510', 'PB', '2590', '2501', '25003', '25', 'LASTRO', NULL, '83', '58820000', '6', '2069', '2069', '13085', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 102.668, '-6,51600', '-38,18000', 336, 'S', 0.5910, NULL, NULL, '25900', 'S', 'N', 2714, NULL, '2590', '2590', NULL, '1963', 'S', 2658, 'LASTRO', 'N', '250840', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '104', NULL, '03', 'N', NULL, NULL, NULL, 195);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250850', '2503', 'PB', '2590', '2502', '25010', '25', 'LIVRAMENTO', NULL, '83', '58690000', '5', '2071', '2071', '13086', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 283.155, '-7,37400', '-36,94600', 584, 'S', 0.5860, NULL, NULL, '25900', 'S', 'N', 2753, NULL, '2590', '2590', NULL, '1961', 'S', 2659, 'LIVRAMENTO', 'N', '250850', 'N', 'S', 'S', NULL, 27, 'N', 'N', 'N', '105', NULL, '03', 'N', NULL, NULL, NULL, 253);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250855', '2502', 'PB', '2590', '2503', '25016', '25', 'LOGRADOURO', NULL, '83', '58254000', '4', '0482', '0482', '13194', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 37.996, '-6,61400', '-35,44300', 140, 'S', 0.5480, NULL, NULL, '25900', 'S', 'N', 2758, NULL, '2503', '2590', NULL, '1997', 'S', 2660, 'LOGRADOURO', 'N', '250855', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '106', NULL, '03', 'N', NULL, NULL, NULL, 420);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250860', '2501', 'PB', '2590', '2504', '25022', '25', 'LUCENA', NULL, '83', '58315000', '4', '2073', '2073', '13087', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 89.202, '-6,90000', '-34,86900', 3, 'S', 0.6040, NULL, NULL, '25900', 'S', 'N', 2768, NULL, '2501', '2590', NULL, '1961', 'S', 2661, 'LUCENA', 'N', '250860', 'N', 'S', 'S', NULL, 103, 'N', 'N', 'N', '107', NULL, '03', 'N', NULL, NULL, NULL, 26);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250870', '2506', 'PB', '2590', '2501', '25004', '25', 'MAE D''AGUA', NULL, '83', '58740000', '3', '2075', '2075', '13088', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 177.250, '-7,25900', '-37,42700', 414, 'S', 0.5800, NULL, NULL, '25900', 'S', 'N', 2817, NULL, '2504', '2590', NULL, '1961', 'S', 2662, 'MÃE D ÁGUA', 'N', '250870', 'N', 'S', 'S', NULL, 59, 'S', 'N', 'N', '108', NULL, '03', 'N', NULL, NULL, NULL, 254);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250880', '2506', 'PB', '2590', '2501', '25003', '25', 'MALTA', NULL, '83', '58713000', '2', '2077', '2077', '13089', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 156.242, '-6,90400', '-37,52200', 257, 'S', 0.6130, NULL, NULL, '25900', 'S', 'N', 2840, NULL, '2504', '2590', NULL, '1953', 'S', 2663, 'MALTA', 'N', '250880', 'N', 'S', 'S', NULL, 59, 'N', 'N', 'N', '109', NULL, '03', 'N', NULL, NULL, NULL, 254);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250890', '2501', 'PB', '2590', '2504', '25020', '25', 'MAMANGUAPE', NULL, '83', '58280000', '1', '2079', '2079', '13090', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 348.745, '-6,83900', '-35,12600', 35, 'S', 0.5810, NULL, NULL, '25900', 'N', 'N', 2841, NULL, '2501', '2590', NULL, '1839', 'S', 2664, 'MAMANGUAPE', 'N', '250890', 'N', 'S', 'S', NULL, 103, 'S', 'N', 'S', '110', NULL, '03', 'N', NULL, NULL, NULL, 252);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250900', '2511', 'PB', '2590', '2501', '25007', '25', 'MANAIRA', NULL, '83', '58995000', '8', '2081', '2081', '13091', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 352.566, '-7,70600', '-38,15400', 757, 'S', 0.5490, NULL, NULL, '25900', 'S', 'N', 2847, NULL, '2590', '2590', NULL, '1961', 'S', 2665, 'MANAÍRA', 'N', '250900', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '111', NULL, '03', 'N', NULL, NULL, NULL, 135);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250905', '2501', 'PB', '2590', '2504', '25020', '25', 'MARCACAO', NULL, '83', '58294000', '7', '0484', '0484', '13195', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 122.897, '-6,77000', '-35,01500', 89, 'S', 0.5260, NULL, NULL, '25900', 'S', 'N', 2900, NULL, '2590', '2590', NULL, '1997', 'S', 2666, 'MARCAÇÃO', 'N', '250905', 'N', 'S', 'S', NULL, 103, 'S', 'N', 'N', '112', NULL, '03', 'N', NULL, NULL, NULL, 252);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250910', '2501', 'PB', '2590', '2504', '25021', '25', 'MARI', NULL, '83', '58345000', '7', '2083', '2083', '13092', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 154.726, '-7,06000', '-35,31900', 143, 'S', 0.5600, NULL, NULL, '25900', 'S', 'N', 2913, NULL, '2590', '2590', NULL, '1958', 'S', 2667, 'MARI', 'N', '250910', 'N', 'S', 'S', NULL, 103, 'N', 'N', 'N', '113', NULL, '03', 'N', NULL, NULL, NULL, 26);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250915', '2510', 'PB', '2590', '2501', '25003', '25', 'MARIZOPOLIS', NULL, '83', '58819000', '6', '0486', '0486', '13196', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 63.609, '-6,84200', '-38,34700', 300, 'S', 0.5900, NULL, NULL, '25900', 'S', 'N', 2937, NULL, '2590', '2590', NULL, '1997', 'S', 2668, 'MARIZÓPOLIS', 'N', '250915', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '114', NULL, '03', 'N', NULL, NULL, NULL, 195);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220110', '2211', 'PI', '2206', '2203', '22012', '22', 'AVELINO LOPES', NULL, '89', '64965000', '1', '1021', '1021', '16011', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1209.379, '-10,13700', '-43,94900', 437, 'S', 0.5740, NULL, NULL, '22900', 'S', 'N', 436, NULL, '2290', '2290', NULL, '1961', 'S', 2978, 'AVELINO LOPES', 'N', '220110', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '17', NULL, '03', 'N', NULL, NULL, NULL, 199);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250920', '2503', 'PB', '2590', '2503', '25017', '25', 'MASSARANDUBA', NULL, '83', '58120000', '6', '2085', '2085', '13093', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 205.941, '-7,20000', '-35,78900', 541, 'S', 0.5610, NULL, NULL, '25900', 'S', 'N', 2954, NULL, '2502', '2590', NULL, '1965', 'S', 2669, 'MASSARANDUBA', 'N', '250920', 'N', 'S', 'S', NULL, 24, 'N', 'N', 'N', '115', NULL, '03', 'N', NULL, NULL, NULL, 419);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250930', '2501', 'PB', '2590', '2504', '25020', '25', 'MATARACA', NULL, '83', '58292000', '5', '2087', '2087', '13094', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 174.398, '-6,60100', '-35,05100', 14, 'S', 0.5730, NULL, NULL, '25900', 'S', 'N', 2962, NULL, '2590', '2590', NULL, '1963', 'S', 2670, 'MATARACA', 'N', '250930', 'N', 'S', 'S', NULL, 103, 'S', 'N', 'N', '116', NULL, '03', 'N', NULL, NULL, NULL, 252);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250933', '2503', 'PB', '2590', '2503', '25015', '25', 'MATINHAS', NULL, '83', '58128000', '9', '0488', '0488', '13197', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 38.123, '-7,12500', '-35,76700', 300, 'S', 0.5760, NULL, NULL, '25900', 'S', 'N', 2973, NULL, '2502', '2590', NULL, '1997', 'S', 2671, 'MATINHAS', 'N', '250933', 'N', 'S', 'S', NULL, 24, 'N', 'N', 'N', '117', NULL, '03', 'N', NULL, NULL, NULL, 310);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250937', '2508', 'PB', '2590', '2501', '25001', '25', 'MATO GROSSO', NULL, '83', '58832000', '0', '0490', '0490', '13198', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 83.521, '-6,53400', '-37,72500', 225, 'S', 0.5530, NULL, NULL, '25900', 'S', 'N', 2977, NULL, '2590', '2590', NULL, '1997', 'S', 2672, 'MATO GROSSO', 'N', '250937', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '118', NULL, '03', 'N', NULL, NULL, NULL, 255);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250939', '2506', 'PB', '2590', '2501', '25007', '25', 'MATUREIA', NULL, '83', '58737000', '6', '0492', NULL, '13199', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 83.714, '-7,26700', '-37,35100', 815, 'S', 0.5530, NULL, NULL, '25900', 'S', 'N', 2988, NULL, '2504', '2590', NULL, '1997', 'S', 2673, 'MATURÉIA', 'N', '250939', 'N', 'S', 'S', NULL, 59, 'N', 'N', 'N', '119', NULL, '03', 'N', NULL, NULL, NULL, 254);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250940', '2512', 'PB', '2590', '2503', '25018', '25', 'MOGEIRO', NULL, '83', '58375000', '4', '2089', '2089', '13095', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 218.993, '-7,29900', '-35,47900', 117, 'S', 0.5450, NULL, NULL, '25900', 'S', 'N', 3071, NULL, '2590', '2590', NULL, '1961', 'S', 2674, 'MOGEIRO', 'N', '250940', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '120', NULL, '03', 'N', NULL, NULL, NULL, 309);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250950', '2503', 'PB', '2590', '2503', '25014', '25', 'MONTADAS', NULL, '83', '58145000', '3', '2091', '2091', '13096', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 25.924, '-7,08800', '-35,95900', 713, 'S', 0.5800, NULL, NULL, '25900', 'S', 'N', 3089, NULL, '2502', '2590', NULL, '1963', 'S', 2675, 'MONTADAS', 'N', '250950', 'N', 'S', 'S', NULL, 24, 'N', 'N', 'N', '121', NULL, '03', 'N', NULL, NULL, NULL, 310);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250960', '2509', 'PB', '2590', '2501', '25002', '25', 'MONTE HOREBE', NULL, '83', '58950000', '2', '2093', '2093', '13097', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 116.172, '-7,21500', '-38,58600', 718, 'S', 0.6110, NULL, NULL, '25900', 'S', 'N', 3115, NULL, '2590', '2590', NULL, '1961', 'S', 2676, 'MONTE HOREBE', 'N', '250960', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '122', NULL, '03', 'N', NULL, NULL, NULL, 74);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250970', '2505', 'PB', '2590', '2502', '25010', '25', 'MONTEIRO', NULL, '83', '58500000', '1', '2095', '2095', '13098', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 986.370, '-7,88900', '-37,12000', 599, 'S', 0.6030, NULL, NULL, '25900', 'S', 'N', 3122, NULL, '2590', '2590', NULL, '1872', 'S', 2677, 'MONTEIRO', 'N', '250970', 'N', 'S', 'S', NULL, 27, 'N', 'N', 'S', '123', NULL, '03', 'N', NULL, NULL, NULL, 253);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250980', '2502', 'PB', '2590', '2503', '25016', '25', 'MULUNGU', NULL, '83', '58354000', '0', '2097', '2097', '13099', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 192.211, '-7,02400', '-35,46200', 99, 'S', 0.5670, NULL, NULL, '25900', 'S', 'N', 3173, NULL, '2503', '2590', NULL, '1959', 'S', 2678, 'MULUNGU', 'N', '250980', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '124', NULL, '03', 'N', NULL, NULL, NULL, 420);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251000', '2510', 'PB', '2590', '2501', '25003', '25', 'NAZAREZINHO', NULL, '83', '58817000', '6', '2101', '2101', '13101', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 173.244, '-6,91600', '-38,32500', 272, 'S', 0.5790, NULL, NULL, '25900', 'S', 'N', 3216, NULL, '2590', '2590', NULL, '1961', 'S', 2680, 'NAZAREZINHO', 'N', '251000', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '126', NULL, '03', 'N', NULL, NULL, NULL, 195);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251010', '2504', 'PB', '2590', '2503', '25012', '25', 'NOVA FLORESTA', NULL, '83', '58178000', '5', '2103', '2103', '13102', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 58.839, '-6,45500', '-36,20300', 666, 'S', 0.6060, NULL, NULL, '25900', 'S', 'N', 3284, NULL, '2590', '2590', NULL, '1959', 'S', 2681, 'NOVA FLORESTA', 'N', '251010', 'N', 'S', 'S', NULL, 160, 'S', 'N', 'N', '127', NULL, '03', 'N', NULL, NULL, NULL, 137);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251020', '2507', 'PB', '2590', '2501', '25005', '25', 'NOVA OLINDA', NULL, '83', '58798000', '4', '2105', '2105', '13103', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 84.253, '-7,48000', '-38,04200', 319, 'S', 0.6050, NULL, NULL, '25900', 'S', 'N', 3312, NULL, '2590', '2590', NULL, '1961', 'S', 2682, 'NOVA OLINDA', 'N', '251020', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '128', NULL, '03', 'N', NULL, NULL, NULL, 73);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251030', '2504', 'PB', '2590', '2502', '25009', '25', 'NOVA PALMEIRA', NULL, '83', '58184000', '3', '2107', '2107', '13104', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 310.348, '-6,67800', '-36,42100', 560, 'S', 0.6320, NULL, NULL, '25900', 'S', 'N', 3319, NULL, '2590', '2590', NULL, '1963', 'S', 2683, 'NOVA PALMEIRA', 'N', '251030', 'N', 'S', 'S', NULL, 160, 'S', 'N', 'N', '129', NULL, '03', 'N', NULL, NULL, NULL, 137);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251040', '2507', 'PB', '2590', '2501', '25005', '25', 'OLHO D''AGUA', NULL, '83', '58760000', '2', '2109', '2109', '13105', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 596.123, '-7,22800', '-37,75100', 267, 'S', 0.5590, NULL, NULL, '25900', 'S', 'N', 3390, NULL, '2590', '2590', NULL, '1961', 'S', 2684, 'OLHO D ÁGUA', 'N', '251040', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '130', NULL, '03', 'N', NULL, NULL, NULL, 73);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251050', '2503', 'PB', '2590', '2503', '25012', '25', 'OLIVEDOS', NULL, '83', '58160000', '1', '2111', '2111', '13106', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 317.900, '-6,99100', '-36,24400', 559, 'S', 0.6270, NULL, NULL, '25900', 'S', 'N', 3403, NULL, '2590', '2590', NULL, '1961', 'S', 2685, 'OLIVEDOS', 'N', '251050', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '131', NULL, '03', 'N', NULL, NULL, NULL, 419);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251060', '2505', 'PB', '2590', '2502', '25010', '25', 'OURO VELHO', NULL, '83', '58560000', '0', '2113', '2113', '13107', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 129.399, '-7,62000', '-37,15200', 591, 'S', 0.6330, NULL, NULL, '25900', 'S', 'N', 3441, NULL, '2590', '2590', NULL, '1961', 'S', 2686, 'OURO VELHO', 'N', '251060', 'N', 'S', 'S', NULL, 27, 'S', 'N', 'N', '132', NULL, '03', 'N', NULL, NULL, NULL, 253);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251065', '2505', 'PB', '2590', '2502', '25010', '25', 'PARARI', NULL, '83', '58575000', '9', '0494', '0494', '13200', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 128.483, '-7,32100', '-36,65600', 495, 'S', 0.6290, NULL, NULL, '25900', 'S', 'N', 3557, NULL, '2590', '2590', NULL, '1997', 'S', 2687, 'PARARI', 'N', '251065', 'N', 'S', 'S', NULL, 27, 'N', 'N', 'N', '133', NULL, '03', 'N', NULL, NULL, NULL, 253);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251070', '2506', 'PB', '2590', '2501', '25004', '25', 'PASSAGEM', NULL, '83', '58734000', '9', '2115', '2115', '13108', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 111.875, '-7,13800', '-37,04900', 305, 'S', 0.6280, NULL, NULL, '25900', 'S', 'N', 3586, NULL, '2504', '2590', NULL, '1961', 'S', 2688, 'PASSAGEM', 'N', '251070', 'N', 'S', 'S', NULL, 59, 'N', 'N', 'N', '134', NULL, '03', 'N', NULL, NULL, NULL, 254);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251080', '2506', 'PB', '2590', '2501', '25004', '25', 'PATOS', NULL, '83', '58700000', '8', '2117', '2117', '13109', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 512.791, '-7,02400', '-37,28000', 242, 'S', 0.6780, NULL, NULL, '25900', 'N', 'N', 3601, NULL, '2504', '2590', NULL, '1832', 'S', 2689, 'PATOS', 'N', '251080', 'N', 'S', 'S', NULL, 59, 'S', 'N', 'S', '135', NULL, '01', 'N', NULL, NULL, NULL, 254);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251090', '2510', 'PB', '2590', '2501', '25003', '25', 'PAULISTA', NULL, '83', '58860000', '7', '2119', '2119', '13110', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 576.880, '-6,59400', '-37,62400', 160, 'S', 0.6190, NULL, NULL, '25900', 'S', 'N', 3621, NULL, '2590', '2590', NULL, '1961', 'S', 2690, 'PAULISTA', 'N', '251090', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '136', NULL, '03', 'N', NULL, NULL, NULL, 136);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251100', '2507', 'PB', '2590', '2501', '25006', '25', 'PEDRA BRANCA', NULL, '83', '58790000', '4', '2121', '2121', '13111', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 193.733, '-7,42700', '-38,06800', 299, 'S', 0.6150, NULL, NULL, '25900', 'S', 'N', 3643, NULL, '2590', '2590', NULL, '1964', 'S', 2691, 'PEDRA BRANCA', 'N', '251100', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '137', NULL, '03', 'N', NULL, NULL, NULL, 73);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251110', '2504', 'PB', '2590', '2502', '25009', '25', 'PEDRA LAVRADA', NULL, '83', '58180000', '3', '2123', '2123', '13112', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 351.688, '-6,75700', '-36,48000', 516, 'S', 0.5810, NULL, NULL, '25900', 'S', 'N', 3649, NULL, '2590', '2590', NULL, '1959', 'S', 2692, 'PEDRA LAVRADA', 'N', '251110', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '138', NULL, '03', 'N', NULL, NULL, NULL, 137);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251120', '2512', 'PB', '2590', '2504', '25023', '25', 'PEDRAS DE FOGO', NULL, '83', '58328000', '2', '2125', '2125', '13113', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 401.120, '-7,40200', '-35,11600', 177, 'S', 0.5680, NULL, NULL, '25900', 'S', 'N', 3656, NULL, '2501', '2590', NULL, '1953', 'S', 2693, 'PEDRAS DE FOGO', 'N', '251120', 'N', 'S', 'S', NULL, 120, 'S', 'N', 'N', '139', NULL, '03', 'N', NULL, NULL, NULL, 309);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251130', '2507', 'PB', '2590', '2501', '25005', '25', 'PIANCO', NULL, '83', '58765000', '1', '2127', '2127', '13114', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 564.730, '-7,19800', '-37,92900', 269, 'S', 0.6340, NULL, NULL, '25900', 'S', 'N', 3719, NULL, '2590', '2590', NULL, '1831', 'S', 2695, 'PIANCÓ', 'N', '251130', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '141', NULL, '03', 'N', NULL, NULL, NULL, 73);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251140', '2504', 'PB', '2590', '2502', '25009', '25', 'PICUI', NULL, '83', '58187000', '0', '2129', '2129', '13115', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 665.570, '-6,55500', '-36,34900', 439, 'S', 0.6060, NULL, NULL, '25900', 'S', 'N', 3726, NULL, '2590', '2590', NULL, '1904', 'S', 2696, 'PICUÍ', 'N', '251140', 'N', 'S', 'S', NULL, 160, 'S', 'N', 'N', '142', NULL, '03', 'N', NULL, NULL, NULL, 137);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353650', '3507', 'SP', '3515', '3507', '35032', '35', 'PAULINIA', NULL, '19', '13140000', '5', '6831', '6831', '21366', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 139.332, '-22,76100', '-47,15400', 590, 'S', 0.8470, NULL, NULL, '35072', 'N', 'N', 3618, NULL, '3503', '3503', NULL, '1964', 'S', 5154, 'PAULÍNIA', 'N', '353650', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '413', NULL, '01', 'N', NULL, NULL, NULL, 515);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251150', '2512', 'PB', '2590', '2504', '25021', '25', 'PILAR', NULL, '83', '58338000', '9', '2131', '2131', '13116', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 101.262, '-7,26700', '-35,26000', 35, 'S', 0.5690, NULL, NULL, '25900', 'S', 'N', 3735, NULL, '2590', '2590', NULL, '1885', 'S', 2697, 'PILAR', 'N', '251150', 'N', 'S', 'S', NULL, 120, 'S', 'N', 'N', '143', NULL, '03', 'N', NULL, NULL, NULL, 309);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251160', '2502', 'PB', '2590', '2503', '25015', '25', 'PILOES', NULL, '83', '58393000', '8', '2133', '2133', '13117', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 64.447, '-6,90200', '-35,62300', 334, 'S', 0.5600, NULL, NULL, '25900', 'S', 'N', 3738, NULL, '2503', '2590', NULL, '1953', 'S', 2698, 'PILÕES', 'N', '251160', 'N', 'S', 'S', NULL, 24, 'S', 'N', 'N', '144', NULL, '03', 'N', NULL, NULL, NULL, 420);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251170', '2502', 'PB', '2590', '2503', '25016', '25', 'PILOEZINHOS', NULL, '83', '58210000', '7', '2135', '2135', '13118', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 43.900, '-6,84400', '-35,53100', 133, 'S', 0.5310, NULL, NULL, '25900', 'S', 'N', 3740, NULL, '2503', '2590', NULL, '1963', 'S', 2699, 'PILÕEZINHOS', 'N', '251170', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '145', NULL, '03', 'N', NULL, NULL, NULL, 420);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251180', '2502', 'PB', '2590', '2503', '25016', '25', 'PIRPIRITUBA', NULL, '83', '58213000', '6', '2137', '2137', '13119', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 79.849, '-6,78000', '-35,49900', 99, 'S', 0.6120, NULL, NULL, '25900', 'S', 'N', 3813, NULL, '2503', '2590', NULL, '1953', 'S', 2700, 'PIRPIRITUBA', 'N', '251180', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '146', NULL, '03', 'N', NULL, NULL, NULL, 420);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251190', '2501', 'PB', '2590', '2504', '25023', '25', 'PITIMBU', NULL, '83', '58324000', '5', '2139', '2139', '13120', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 136.045, '-7,47100', '-34,80900', 3, 'S', 0.5940, NULL, NULL, '25900', 'S', 'N', 3818, NULL, '2501', '2590', NULL, '1961', 'S', 2701, 'PITIMBU', 'N', '251190', 'N', 'S', 'S', NULL, 120, 'N', 'N', 'N', '147', NULL, '03', 'N', NULL, NULL, NULL, 26);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251200', '2503', 'PB', '2590', '2503', '25012', '25', 'POCINHOS', NULL, '83', '58150000', '2', '2141', '2141', '13121', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 629.521, '-7,07700', '-36,06100', 646, 'S', 0.5920, NULL, NULL, '25900', 'S', 'N', 3838, NULL, '2502', '2590', NULL, '1953', 'S', 2702, 'POCINHOS', 'N', '251200', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '148', NULL, '03', 'N', NULL, NULL, NULL, 419);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251203', '2509', 'PB', '2590', '2501', '25002', '25', 'POCO DANTAS', NULL, '83', '58933000', '6', '0496', '0496', '13201', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 97.249, '-6,40300', '-38,49500', 470, 'S', 0.5170, NULL, NULL, '25900', 'S', 'N', 3840, NULL, '2590', '2590', NULL, '1997', 'S', 2703, 'POÇO DANTAS', 'N', '251203', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '149', NULL, '03', 'N', NULL, NULL, NULL, 74);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251207', '2509', 'PB', '2590', '2501', '25002', '25', 'POCO DE JOSE DE MOURA', NULL, '83', '58908000', '7', '0498', '0498', '13202', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 97.888, '-6,57500', '-38,51200', 280, 'S', 0.5740, NULL, NULL, '25900', 'S', 'N', 3843, NULL, '2590', '2590', NULL, '1997', 'S', 2704, 'POÇO DE JOSÉ DE MOURA', 'N', '251207', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '150', NULL, '03', 'N', NULL, NULL, NULL, 74);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251210', '2510', 'PB', '2590', '2501', '25003', '25', 'POMBAL', NULL, '83', '58840000', '1', '2143', '2143', '13122', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 888.811, '-6,77000', '-37,80200', 184, 'S', 0.6610, NULL, NULL, '25900', 'N', 'N', 3853, NULL, '2590', '2590', NULL, '1766', 'S', 2705, 'POMBAL', 'N', '251210', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '151', NULL, '03', 'N', NULL, NULL, NULL, 136);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251220', '2505', 'PB', '2590', '2502', '25010', '25', 'PRATA', NULL, '83', '58550000', '0', '2145', '2145', '13123', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 192.012, '-7,69100', '-37,08000', 577, 'S', 0.6080, NULL, NULL, '25900', 'S', 'N', 3956, NULL, '2590', '2590', NULL, '1955', 'S', 2706, 'PRATA', 'N', '251220', 'N', 'S', 'S', NULL, 27, 'N', 'N', 'N', '152', NULL, '03', 'N', NULL, NULL, NULL, 253);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251230', '2511', 'PB', '2590', '2501', '25007', '25', 'PRINCESA ISABEL', NULL, '83', '58755000', '9', '2147', '2147', '13124', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 368.067, '-7,73700', '-37,99300', 683, 'S', 0.6310, NULL, NULL, '25900', 'S', 'N', 3994, NULL, '2590', '2590', NULL, '1880', 'S', 2707, 'PRINCESA ISABEL', 'N', '251230', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '153', NULL, '03', 'N', NULL, NULL, NULL, 135);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251240', '2503', 'PB', '2590', '2503', '25017', '25', 'PUXINANA', NULL, '83', '58115000', '8', '2149', '2149', '13125', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 73.673, '-7,16100', '-35,96100', 657, 'S', 0.6280, NULL, NULL, '25900', 'S', 'N', 4005, NULL, '2502', '2590', NULL, '1961', 'S', 2708, 'PUXINANÃ', 'N', '251240', 'N', 'S', 'S', NULL, 24, 'N', 'N', 'N', '154', NULL, '03', 'N', NULL, NULL, NULL, 419);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251250', '2503', 'PB', '2590', '2503', '25017', '25', 'QUEIMADAS', NULL, '83', '58475000', '7', '2151', '2151', '13126', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 409.196, '-7,35800', '-35,89800', 450, 'S', 0.5950, NULL, NULL, '25900', 'N', 'N', 4020, NULL, '2502', '2590', NULL, '1961', 'S', 2709, 'QUEIMADAS', 'N', '251250', 'N', 'S', 'S', NULL, 24, 'S', 'N', 'S', '155', NULL, '03', 'N', NULL, NULL, NULL, 72);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251260', '2506', 'PB', '2590', '2501', '25004', '25', 'QUIXABA', NULL, '83', '58733000', '6', '2153', '2153', '13127', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 116.946, '-7,03100', '-37,14900', 293, 'S', 0.5990, NULL, NULL, '25900', 'S', 'N', 4039, NULL, '2504', '2590', NULL, '1964', 'S', 2710, 'QUIXABÁ', 'N', '251260', 'N', 'S', 'S', NULL, 59, 'N', 'N', 'N', '156', NULL, '03', 'N', NULL, NULL, NULL, 254);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251270', '2503', 'PB', '2590', '2503', '25012', '25', 'REMIGIO', NULL, '83', '58398000', '5', '2155', '2155', '13128', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 178.064, '-6,90300', '-35,83400', 593, 'S', 0.6120, NULL, NULL, '25900', 'S', 'N', 4074, NULL, '2502', '2590', NULL, '1957', 'S', 2711, 'REMÍGIO', 'N', '251270', 'N', 'S', 'S', NULL, 24, 'S', 'N', 'N', '157', NULL, '03', 'N', NULL, NULL, NULL, 310);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251272', '2501', 'PB', '2590', '2504', '25020', '25', 'PEDRO REGIS', NULL, '83', '58273000', '1', '0500', NULL, '13203', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 73.362, '-6,63300', '-35,29700', 80, 'S', 0.5320, NULL, NULL, '25900', 'S', 'N', 3676, NULL, '2590', '2590', NULL, '1997', 'S', 2694, 'PEDRO RÉGIS', 'N', '251272', 'N', 'S', 'S', NULL, 103, 'S', 'N', 'N', '140', NULL, '03', 'N', NULL, NULL, NULL, 252);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251274', '2502', 'PB', '2590', '2503', '25013', '25', 'RIACHAO', NULL, '83', '58235000', '7', '0502', '0502', '13204', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 90.150, '-6,55000', '-35,64600', 0, 'S', 0.5680, NULL, NULL, '25900', 'S', 'N', 4088, NULL, '2590', '2590', NULL, '1997', 'S', 2712, 'RIACHÃO', 'N', '251274', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '158', NULL, '03', 'N', NULL, NULL, NULL, 420);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251276', '2501', 'PB', '2590', '2504', '25021', '25', 'RIACHAO DO POCO', NULL, '83', '58348000', '2', '0506', '0506', '13206', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 39.067, '-7,14200', '-35,29100', 82, 'S', 0.5530, NULL, NULL, '25900', 'S', 'N', 4092, NULL, '2590', '2590', NULL, '1997', 'S', 2713, 'RIACHÃO DO POÇO', 'N', '251276', 'N', 'S', 'S', NULL, 103, 'N', 'N', 'N', '160', NULL, '03', 'N', NULL, NULL, NULL, 26);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251278', '2503', 'PB', '2590', '2502', '25011', '25', 'RIACHO DE SANTO ANTONIO', NULL, '83', '58465000', '8', '0508', '0508', '13207', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 91.322, '-7,69300', '-36,15700', 440, 'S', 0.5890, NULL, NULL, '25900', 'S', 'N', 4099, NULL, '2590', '2590', NULL, '1997', 'S', 2714, 'RIACHO DE SANTO ANTÔNIO', 'N', '251278', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '161', NULL, '03', 'N', NULL, NULL, NULL, 72);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251280', '2508', 'PB', '2590', '2501', '25001', '25', 'RIACHO DOS CAVALOS', NULL, '83', '58870000', '4', '2157', '2157', '13129', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 264.027, '-6,44300', '-37,65100', 198, 'S', 0.5830, NULL, NULL, '25900', 'S', 'N', 4100, NULL, '2590', '2590', NULL, '1961', 'S', 2715, 'RIACHO DOS CAVALOS', 'N', '251280', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '162', NULL, '03', 'N', NULL, NULL, NULL, 255);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251290', '2501', 'PB', '2590', '2504', '25020', '25', 'RIO TINTO', NULL, '83', '58297000', '3', '2159', '2159', '13130', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'S', NULL, 'N', 466.397, '-6,80300', '-35,08100', 11, 'S', 0.6030, NULL, NULL, '25900', 'S', 'N', 4192, NULL, '2501', '2590', NULL, '1956', 'S', 2716, 'RIO TINTO', 'N', '251290', 'N', 'S', 'S', NULL, 103, 'S', 'N', 'N', '163', NULL, '03', 'N', NULL, NULL, NULL, 252);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251300', '2506', 'PB', '2590', '2502', '25008', '25', 'SALGADINHO', NULL, '83', '58650000', '0', '2161', '2161', '13131', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 184.237, '-7,10300', '-36,84500', 420, 'S', 0.5640, NULL, NULL, '25900', 'S', 'N', 4255, NULL, '2504', '2590', NULL, '1961', 'S', 2717, 'SALGADINHO', 'N', '251300', 'N', 'S', 'S', NULL, 59, 'S', 'N', 'N', '164', NULL, '03', 'N', NULL, NULL, NULL, 254);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251310', '2512', 'PB', '2590', '2503', '25018', '25', 'SALGADO DE SAO FELIX', NULL, '83', '58370000', '9', '2163', '2163', '13132', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 196.092, '-7,35700', '-35,44100', 58, 'S', 0.5520, NULL, NULL, '25900', 'S', 'N', 4258, NULL, '2590', '2590', NULL, '1961', 'S', 2718, 'SALGADO DE SÃO FÉLIX', 'N', '251310', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '165', NULL, '03', 'N', NULL, NULL, NULL, 309);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251315', '2503', 'PB', '2590', '2503', '25019', '25', 'SANTA CECILIA', NULL, '83', '58463000', '8', '0510', NULL, '13208', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 227.838, '-7,73900', '-35,87900', 0, 'S', 0.5200, NULL, NULL, '25900', 'S', 'N', 4306, NULL, '2502', '2590', NULL, '1997', 'S', 2719, 'SANTA CECÍLIA', 'N', '251315', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '166', NULL, '03', 'N', NULL, NULL, NULL, 72);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251320', '2510', 'PB', '2590', '2501', '25003', '25', 'SANTA CRUZ', NULL, '83', '58824000', '8', '2165', '2165', '13133', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 210.152, '-6,53300', '-38,06200', 314, 'S', 0.6420, NULL, NULL, '25900', 'S', 'N', 4311, NULL, '2590', '2590', NULL, '1961', 'S', 2720, 'SANTA CRUZ', 'N', '251320', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '167', NULL, '03', 'N', NULL, NULL, NULL, 195);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251330', '2509', 'PB', '2590', '2501', '25002', '25', 'SANTA HELENA', NULL, '83', '58925000', '7', '2167', '2167', '13134', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 210.317, '-6,72000', '-38,63800', 287, 'S', 0.6240, NULL, NULL, '25900', 'S', 'N', 4343, NULL, '2590', '2590', NULL, '1961', 'S', 2721, 'SANTA HELENA', 'N', '251330', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '168', NULL, '03', 'N', NULL, NULL, NULL, 74);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251335', '2507', 'PB', '2590', '2501', '25006', '25', 'SANTA INES', NULL, '83', '58978000', '6', '0512', '0512', '13209', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 324.422, '-7,62100', '-38,55400', 0, 'S', 0.5530, NULL, NULL, '25900', 'S', 'N', 4347, NULL, '2590', '2590', NULL, '1997', 'S', 2722, 'SANTA INÊS', 'N', '251335', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '169', NULL, '03', 'N', NULL, NULL, NULL, 73);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251365', '2509', 'PB', '2590', '2501', '25002', '25', 'JOCA CLAUDINO', NULL, '83', '58928000', '3', '0514', '0514', '13210', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 74.005, '-6,49000', '-38,47600', 345, 'S', 0.5790, NULL, NULL, '25900', 'S', 'N', 4466, NULL, '2590', '2590', NULL, '1997', 'S', 2728, 'SANTARÉM', 'N', '251365', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '175', NULL, '03', 'N', NULL, NULL, NULL, 74);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251370', '2501', 'PB', '2590', '2504', '25022', '25', 'SANTA RITA', NULL, '83', '58304000', '3', '2175', '2175', '13138', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 726.565, '-7,11400', '-34,97800', 16, 'S', 0.6590, NULL, NULL, '25900', 'N', 'N', 4394, NULL, '2501', '2501', NULL, '1897', 'S', 2724, 'SANTA RITA', 'N', '251370', 'N', 'S', 'S', NULL, 103, 'N', 'N', 'S', '171', NULL, '01', 'N', NULL, NULL, NULL, 26);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251380', '2506', 'PB', '2590', '2501', '25004', '25', 'SANTA TERESINHA', NULL, '83', '58720000', '2', '2177', '2177', '13139', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 357.942, '-7,11600', '-37,45200', 306, 'S', 0.5860, NULL, NULL, '25900', 'S', 'N', 4421, NULL, '2504', '2590', NULL, '1961', 'S', 2725, 'SANTA TERESINHA', 'N', '251380', 'N', 'S', 'S', NULL, 59, 'N', 'N', 'N', '172', NULL, '03', 'N', NULL, NULL, NULL, 254);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251385', '2503', 'PB', '2590', '2502', '25011', '25', 'SANTO ANDRE', NULL, '83', '58675000', '1', '0516', '0516', '13211', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 225.166, '-7,21800', '-36,63300', 523, 'S', 0.6260, NULL, NULL, '25900', 'S', 'N', 4477, NULL, '2590', '2590', NULL, '1997', 'S', 2729, 'SANTO ANDRÉ', 'N', '251385', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '176', NULL, '03', 'N', NULL, NULL, NULL, 419);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251390', '2508', 'PB', '2590', '2501', '25001', '25', 'SAO BENTO', NULL, '83', '58865000', '1', '2179', '2179', '13140', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 248.198, '-6,48600', '-37,45100', 141, 'S', 0.6380, NULL, NULL, '25900', 'S', 'N', 4527, NULL, '2590', '2590', NULL, '1959', 'S', 2730, 'SÃO BENTO', 'N', '251390', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '178', NULL, '03', 'N', NULL, NULL, NULL, 255);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251392', '2510', 'PB', '2590', '2501', '25003', '25', 'SAO BENTINHO', NULL, '83', NULL, '7', '0518', '0518', '13212', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 195.964, '-6,90100', '-37,72900', 251, 'S', 0.6260, NULL, NULL, '25900', 'S', 'N', 4530, NULL, '2590', '2590', NULL, '1997', 'S', 2731, 'SÃO BENTINHO', 'N', '251392', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '177', NULL, '03', 'N', NULL, NULL, NULL, 136);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251394', '2503', 'PB', '2590', '2502', '25011', '25', 'SAO DOMINGOS DO CARIRI', NULL, '83', '58485000', '3', '0520', NULL, '13213', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 222.159, '-7,63600', '-36,43300', 400, 'S', 0.6750, NULL, NULL, '25900', 'S', 'N', 4563, NULL, '2590', '2590', NULL, '1997', 'S', 2733, 'SÃO DOMINGOS DO CARIRI', 'N', '251394', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '180', NULL, '03', 'N', NULL, NULL, NULL, 72);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251396', '2510', 'PB', '2590', '2501', '25003', '25', 'SAO DOMINGOS POMBAL', NULL, '83', '58853000', '8', '0522', '0522', '13214', NULL, 'ATIVO', 'N', 'N', NULL, 'SAO DOMINGOS DE POMBAL    ', 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 169.103, '-6,81400', '-37,94200', 190, 'S', 0.5610, NULL, NULL, '25900', 'S', 'N', 4559, NULL, '2590', '2590', NULL, '1997', 'S', 2732, 'SÃO DOMINGOS', 'N', '251396', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '179', NULL, '03', 'N', NULL, NULL, NULL, 136);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251398', '2510', 'PB', '2590', '2501', '25003', '25', 'SAO FRANCISCO', NULL, '83', '58818000', '4', '0524', '0524', '13215', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 95.054, '-6,61900', '-38,09400', 285, 'S', 0.6320, NULL, NULL, '25900', 'S', 'N', 4580, NULL, '2590', '2590', NULL, '1997', 'S', 2734, 'SÃO FRANCISCO', 'N', '251398', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '181', NULL, '03', 'N', NULL, NULL, NULL, 195);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251400', '2505', 'PB', '2590', '2502', '25011', '25', 'SAO JOAO DO CARIRI', NULL, '83', '58590000', '8', '2181', '2181', '13141', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 701.856, '-7,39100', '-36,53300', 458, 'S', 0.6740, NULL, NULL, '25900', 'S', 'N', 4651, NULL, '2590', '2590', NULL, '1800', 'S', 2735, 'SÃO JOÃO DO CARIRI', 'N', '251400', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '182', NULL, '03', 'N', NULL, NULL, NULL, 253);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251410', '2505', 'PB', '2590', '2502', '25010', '25', 'SAO JOAO DO TIGRE', NULL, '83', '58520000', '7', '2183', '2183', '13142', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 816.111, '-8,07900', '-36,84800', 577, 'S', 0.5270, NULL, NULL, '25900', 'S', 'N', 4670, NULL, '2590', '2590', NULL, '1962', 'S', 2737, 'SÃO JOÃO DO TIGRE', 'N', '251410', 'N', 'S', 'S', NULL, 27, 'N', 'N', 'N', '184', NULL, '03', 'N', NULL, NULL, NULL, 253);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251420', '2510', 'PB', '2590', '2501', '25003', '25', 'SAO JOSE DA LAGOA TAPADA', NULL, '83', '58815000', '6', '2185', '2185', '13143', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 304.419, '-6,94100', '-38,16200', 257, 'S', 0.5510, NULL, NULL, '25900', 'S', 'N', 4688, NULL, '2590', '2590', NULL, '1959', 'S', 2738, 'SÃO JOSÉ DA LAGOA TAPADA', 'N', '251420', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '185', NULL, '03', 'N', NULL, NULL, NULL, 195);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251430', '2507', 'PB', '2590', '2501', '25006', '25', 'SAO JOSE DE CAIANA', NULL, '83', '58784000', '5', '2187', '2187', '13144', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 176.326, '-7,24900', '-38,30100', 610, 'S', 0.5610, NULL, NULL, '25900', 'S', 'N', 4697, NULL, '2590', '2590', NULL, '1963', 'S', 2739, 'SÃO JOSÉ DE CAIANA', 'N', '251430', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '186', NULL, '03', 'N', NULL, NULL, NULL, 73);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251440', '2506', 'PB', '2590', '2501', '25004', '25', 'SAO JOSE DE ESPINHARAS', NULL, '83', '58723000', '4', '2189', '2189', '13145', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 725.654, '-6,84700', '-37,32600', 208, 'S', 0.5930, NULL, NULL, '25900', 'S', 'N', 4698, NULL, '2504', '2590', NULL, '1961', 'S', 2740, 'SÃO JOSÉ DE ESPINHARAS', 'N', '251440', 'N', 'S', 'S', NULL, 59, 'N', 'N', 'N', '187', NULL, '03', 'N', NULL, NULL, NULL, 254);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251445', '2512', 'PB', '2590', '2504', '25021', '25', 'SAO JOSE DOS RAMOS', NULL, '83', '58339000', '3', '0526', NULL, '13216', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 98.229, '-7,25100', '-35,38400', 140, 'S', 0.5250, NULL, NULL, '25900', 'S', 'N', 4741, NULL, '2590', '2590', NULL, '1997', 'S', 2747, 'SÃO JOSÉ DOS RAMOS', 'N', '251445', 'N', 'S', 'S', NULL, 120, 'S', 'N', 'N', '194', NULL, '03', 'N', NULL, NULL, NULL, 309);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251450', '2509', 'PB', '2590', '2501', '25002', '25', 'SAO JOSE DE PIRANHAS', NULL, '83', '58940000', '3', '2191', '2191', '13146', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 677.292, '-7,12100', '-38,50200', 342, 'S', 0.6120, NULL, NULL, '25900', 'S', 'N', 4700, NULL, '2590', '2590', NULL, '1885', 'S', 2741, 'SÃO JOSÉ DE PIRANHAS', 'N', '251450', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '188', NULL, '03', 'N', NULL, NULL, NULL, 74);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251455', '2511', 'PB', '2590', '2501', '25007', '25', 'SAO JOSE DE PRINCESA', NULL, '83', '58758000', '2', '0528', '0528', '13217', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 158.021, '-7,73800', '-38,09400', 720, 'S', 0.5520, NULL, NULL, '25900', 'S', 'N', 4701, NULL, '2590', '2590', NULL, '1997', 'S', 2742, 'SÃO JOSÉ DE PRINCESA', 'N', '251455', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '189', NULL, '03', 'N', NULL, NULL, NULL, 135);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251460', '2506', 'PB', '2590', '2501', '25004', '25', 'SAO JOSE DO BONFIM', NULL, '83', '58725000', '2', '2193', '2193', '13147', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 152.135, '-7,16300', '-37,30900', 278, 'S', 0.5620, NULL, NULL, '25900', 'S', 'N', 4707, NULL, '2504', '2590', NULL, '1964', 'S', 2743, 'SÃO JOSÉ DO BONFIM', 'N', '251460', 'N', 'S', 'S', NULL, 59, 'N', 'N', 'N', '190', NULL, '03', 'N', NULL, NULL, NULL, 254);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251465', '2508', 'PB', '2590', '2501', '25001', '25', 'SAO JOSE DO BREJO DO CRUZ', NULL, '83', '58893000', '1', '0530', '0530', '13218', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 253.017, '-6,21300', '-37,35200', 147, 'S', 0.6020, NULL, NULL, '25900', 'S', 'N', 4708, NULL, '2590', '2590', NULL, '1997', 'S', 2744, 'SÃO JOSÉ DO BREJO DO CRUZ', 'N', '251465', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '191', NULL, '03', 'N', NULL, NULL, NULL, 255);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251470', '2506', 'PB', '2590', '2502', '25008', '25', 'SAO JOSE DO SABUGI', NULL, '83', '58610000', '1', '2195', '2195', '13148', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 206.914, '-6,77600', '-36,79900', 333, 'S', 0.6560, NULL, NULL, '25900', 'S', 'N', 4731, NULL, '2504', '2590', NULL, '1961', 'S', 2745, 'SÃO JOSÉ DO SABUGI', 'N', '251470', 'N', 'S', 'S', NULL, 59, 'S', 'N', 'N', '192', NULL, '03', 'N', NULL, NULL, NULL, 254);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251480', '2505', 'PB', '2590', '2502', '25010', '25', 'SAO JOSE DOS CORDEIROS', NULL, '83', '58570000', '0', '2197', '2197', '13149', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 417.744, '-7,39100', '-36,80800', 527, 'S', 0.6310, NULL, NULL, '25900', 'S', 'N', 4738, NULL, '2590', '2590', NULL, '1961', 'S', 2746, 'SÃO JOSÉ DOS CORDEIROS', 'N', '251480', 'N', 'S', 'S', NULL, 27, 'N', 'N', 'N', '193', NULL, '03', 'N', NULL, NULL, NULL, 253);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251490', '2506', 'PB', '2590', '2502', '25008', '25', 'SAO MAMEDE', NULL, '83', '58625000', '9', '2199', '2199', '13150', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 530.724, '-6,92700', '-37,09600', 263, 'S', 0.6460, NULL, NULL, '25900', 'S', 'N', 4762, NULL, '2504', '2590', NULL, '1953', 'S', 2748, 'SÃO MAMEDE', 'N', '251490', 'N', 'S', 'S', NULL, 59, 'N', 'N', 'N', '195', NULL, '03', 'N', NULL, NULL, NULL, 254);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251500', '2512', 'PB', '2590', '2504', '25021', '25', 'SAO MIGUEL DE TAIPU', NULL, '83', '58334000', '5', '2201', '2201', '13151', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 92.524, '-7,25000', '-35,21000', 45, 'S', 0.5240, NULL, NULL, '25900', 'S', 'N', 4779, NULL, '2590', '2590', NULL, '1961', 'S', 2749, 'SÃO MIGUEL DE TAIPU', 'N', '251500', 'N', 'S', 'S', NULL, 120, 'S', 'N', 'N', '196', NULL, '03', 'N', NULL, NULL, NULL, 309);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251510', '2503', 'PB', '2590', '2503', '25014', '25', 'SAO SEBASTIAO DE LAGOA DE ROCA', NULL, '83', '58119000', '4', '2203', '2203', '13152', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 49.882, '-7,08300', '-35,83500', 641, 'S', 0.6220, NULL, NULL, '25900', 'S', 'N', 4834, NULL, '2502', '2590', NULL, '1961', 'S', 2750, 'SÃO SEBASTIÃO DE LAGOA DE ROÇA', 'N', '251510', 'N', 'S', 'S', NULL, 24, 'N', 'N', 'N', '197', NULL, '03', 'N', NULL, NULL, NULL, 310);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251520', '2505', 'PB', '2590', '2502', '25010', '25', 'SAO SEBASTIAO DO UMBUZEIRO', NULL, '83', '58510000', '3', '2205', '2205', '13153', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 460.569, '-8,15200', '-37,01000', 594, 'S', 0.5740, NULL, NULL, '25900', 'S', 'N', 4846, NULL, '2590', '2590', NULL, '1959', 'S', 2751, 'SÃO SEBASTIÃO DO UMBUZEIRO', 'N', '251520', 'N', 'S', 'S', NULL, 27, 'S', 'N', 'N', '198', NULL, '03', 'N', NULL, NULL, NULL, 253);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251530', '2501', 'PB', '2590', '2504', '25021', '25', 'SAPE', NULL, '83', '58340000', '2', '2207', '2207', '13154', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 316.330, '-7,09500', '-35,23300', 123, 'S', 0.5560, NULL, NULL, '25900', 'N', 'N', 4866, NULL, '2590', '2590', NULL, '1896', 'S', 2752, 'SAPÉ', 'N', '251530', 'N', 'S', 'S', NULL, 103, 'S', 'N', 'S', '199', NULL, '03', 'N', NULL, NULL, NULL, 26);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251540', '2504', 'PB', '2590', '2502', '25009', '25', 'SERIDO', NULL, '83', '58158000', '1', '2209', '2209', '13155', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 276.460, '-6,93400', '-36,40200', 631, 'S', 0.5750, NULL, NULL, '25900', 'S', 'N', 4928, NULL, '2590', '2590', NULL, '1961', 'S', 2753, 'SERIDÓ', 'N', '251540', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '200', NULL, '03', 'N', NULL, NULL, NULL, 137);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251550', '2505', 'PB', '2590', '2502', '25010', '25', 'SERRA BRANCA', NULL, '83', '58580000', '0', '2211', '2211', '13156', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 737.743, '-7,48300', '-36,66500', 493, 'S', 0.6620, NULL, NULL, '25900', 'S', 'N', 4937, NULL, '2590', '2590', NULL, '1959', 'S', 2754, 'SERRA BRANCA', 'N', '251550', 'N', 'S', 'S', NULL, 27, 'N', 'N', 'N', '201', NULL, '03', 'N', NULL, NULL, NULL, 253);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251560', '2502', 'PB', '2590', '2503', '25016', '25', 'SERRA DA RAIZ', NULL, '83', '58260000', '9', '2213', '2213', '13157', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 28.984, '-6,68700', '-35,44400', 331, 'S', 0.5650, NULL, NULL, '25900', 'S', 'N', 4939, NULL, '2503', '2590', NULL, '1959', 'S', 2755, 'SERRA DA RAIZ', 'N', '251560', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '202', NULL, '03', 'N', NULL, NULL, NULL, 420);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251570', '2507', 'PB', '2590', '2501', '25006', '25', 'SERRA GRANDE', NULL, '83', '58955000', '8', '2215', '2215', '13158', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 83.473, '-7,21500', '-38,37000', 593, 'S', 0.5900, NULL, NULL, '25900', 'S', 'N', 4948, NULL, '2590', '2590', NULL, '1961', 'S', 2756, 'SERRA GRANDE', 'N', '251570', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '203', NULL, '03', 'N', NULL, NULL, NULL, 73);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251580', '2503', 'PB', '2590', '2503', '25017', '25', 'SERRA REDONDA', NULL, '83', '58385000', '7', '2217', '2217', '13159', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 55.906, '-7,17800', '-35,67500', 391, 'S', 0.5760, NULL, NULL, '25900', 'S', 'N', 4952, NULL, '2502', '2590', NULL, '1953', 'S', 2757, 'SERRA REDONDA', 'N', '251580', 'N', 'S', 'S', NULL, 24, 'S', 'N', 'N', '204', NULL, '03', 'N', NULL, NULL, NULL, 419);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251590', '2502', 'PB', '2590', '2503', '25015', '25', 'SERRARIA', NULL, '83', '58395000', '6', '2219', '2219', '13160', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 75.397, '-6,82000', '-35,63300', 533, 'S', 0.5630, NULL, NULL, '25900', 'S', 'N', 4961, NULL, '2503', '2590', NULL, '1895', 'S', 2758, 'SERRARIA', 'N', '251590', 'N', 'S', 'S', NULL, 24, 'S', 'N', 'N', '205', NULL, '03', 'N', NULL, NULL, NULL, 420);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251593', '2502', 'PB', '2590', '2503', '25016', '25', 'SERTAOZINHO', NULL, '83', '58268000', '0', '0532', '0532', '13219', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 32.798, '-6,75100', '-35,44200', 135, 'S', 0.6110, NULL, NULL, '25900', 'S', 'N', 4974, NULL, '2503', '2590', NULL, '1997', 'S', 2759, 'SERTÃOZINHO', 'N', '251593', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '206', NULL, '03', 'N', NULL, NULL, NULL, 420);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251597', '2501', 'PB', '2590', '2504', '25021', '25', 'SOBRADO', NULL, '83', '58342000', '1', '0534', '0534', '13220', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 63.093, '-7,14400', '-35,23900', 82, 'S', 0.5550, NULL, NULL, '25900', 'S', 'N', 5014, NULL, '2590', '2590', NULL, '1997', 'S', 2760, 'SOBRADO', 'N', '251597', 'N', 'S', 'S', NULL, 103, 'S', 'N', 'N', '207', NULL, '03', 'N', NULL, NULL, NULL, 26);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251600', '2502', 'PB', '2590', '2503', '25013', '25', 'SOLANEA', NULL, '83', '58225000', '3', '2221', '2221', '13161', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 265.921, '-6,77800', '-35,69700', 626, 'S', 0.6150, NULL, NULL, '25900', 'N', 'N', 5019, NULL, '2590', '2590', NULL, '1953', 'S', 2761, 'SOLÂNEA', 'N', '251600', 'N', 'S', 'S', NULL, 24, 'S', 'N', 'N', '208', NULL, '03', 'N', NULL, NULL, NULL, 420);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251610', '2503', 'PB', '2590', '2503', '25012', '25', 'SOLEDADE', NULL, '83', '58155000', '2', '2223', '2223', '13162', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 560.062, '-7,05700', '-36,36300', 521, 'S', 0.6390, NULL, NULL, '25900', 'S', 'N', 5021, NULL, '2590', '2590', NULL, '1885', 'S', 2762, 'SOLEDADE', 'N', '251610', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '209', NULL, '03', 'N', NULL, NULL, NULL, 419);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251615', '2504', 'PB', '2590', '2503', '25012', '25', 'SOSSEGO', NULL, '83', '58177000', '1', '0536', '0536', '13221', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 154.795, '-6,76900', '-36,25400', 580, 'S', 0.5510, NULL, NULL, '25900', 'S', 'N', 5030, NULL, '2590', '2590', NULL, '1997', 'S', 2763, 'SOSSÊGO', 'N', '251615', 'N', 'S', 'S', NULL, 160, 'S', 'N', 'N', '210', NULL, '03', 'N', NULL, NULL, NULL, 137);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251620', '2510', 'PB', '2590', '2501', '25003', '25', 'SOUSA', NULL, '83', '58800970', '1', '2225', '2225', '13163', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 842.487, '-6,76100', '-38,23100', 220, 'S', 0.6580, NULL, NULL, '25900', 'N', 'N', 5032, NULL, '2590', '2590', NULL, '1766', 'S', 2764, 'SOUSA', 'N', '251620', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '211', NULL, '02', 'N', NULL, NULL, NULL, 195);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251630', '2505', 'PB', '2590', '2502', '25010', '25', 'SUME', NULL, '83', '58540000', '0', '2227', '2227', '13164', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 838.058, '-7,67200', '-36,88000', 532, 'S', 0.6580, NULL, NULL, '25900', 'S', 'N', 5041, NULL, '2590', '2590', NULL, '1951', 'S', 2765, 'SUMÉ', 'N', '251630', 'N', 'S', 'S', NULL, 27, 'N', 'N', 'N', '212', NULL, '03', 'N', NULL, NULL, NULL, 253);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251640', '2502', 'PB', '2590', '2503', '25013', '25', 'TACIMA', NULL, '83', '58240000', '9', '2229', '2229', '13165', NULL, 'ATIVO', 'N', 'N', NULL, 'TACIMA                    ', 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 246.656, '-6,48800', '-35,63700', 168, 'S', 0.5480, NULL, NULL, '25900', 'S', 'N', 5061, NULL, '2590', '2590', NULL, '1959', 'S', 2766, 'CAMPO DE SANTANA', 'N', '251640', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '51', NULL, '03', 'N', NULL, NULL, NULL, 420);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251650', '2503', 'PB', '2590', '2502', '25010', '25', 'TAPEROA', NULL, '83', '58680000', '8', '2231', '2231', '13166', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 639.959, '-7,20700', '-36,82700', 532, 'S', 0.5750, NULL, NULL, '25900', 'S', 'N', 5094, NULL, '2590', '2590', NULL, '1886', 'S', 2767, 'TAPEROÁ', 'N', '251650', 'N', 'S', 'S', NULL, 27, 'N', 'N', 'S', '213', NULL, '03', 'N', NULL, NULL, NULL, 419);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251660', '2511', 'PB', '2590', '2501', '25007', '25', 'TAVARES', NULL, '83', '58753000', '7', '2233', '2233', '13167', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 228.599, '-7,63600', '-37,87800', 724, 'S', 0.5870, NULL, NULL, '25900', 'S', 'N', 5127, NULL, '2590', '2590', NULL, '1959', 'S', 2768, 'TAVARES', 'N', '251660', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '214', NULL, '03', 'N', NULL, NULL, NULL, 135);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251670', '2506', 'PB', '2590', '2501', '25007', '25', 'TEIXEIRA', NULL, '83', '58735000', '6', '2235', '2235', '13168', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 114.437, '-7,22300', '-37,25400', 768, 'S', 0.6240, NULL, NULL, '25900', 'S', 'N', 5129, NULL, '2504', '2590', NULL, '1859', 'S', 2769, 'TEIXEIRA', 'N', '251670', 'N', 'S', 'S', NULL, 59, 'S', 'N', 'N', '215', NULL, '03', 'N', NULL, NULL, NULL, 254);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251675', '2503', 'PB', '2590', '2502', '25009', '25', 'TENORIO', NULL, '83', '58665000', '5', '0538', '0538', '13222', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 105.270, '-6,94200', '-36,62900', 610, 'S', 0.5700, NULL, NULL, '25900', 'S', 'N', 5141, NULL, '2590', '2590', NULL, '1997', 'S', 2770, 'TENÓRIO', 'N', '251675', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '216', NULL, '03', 'N', NULL, NULL, NULL, 419);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251680', '2509', 'PB', '2590', '2501', '25002', '25', 'TRIUNFO', NULL, '83', '58920000', '5', '2237', '2237', '13169', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 222.947, '-6,57900', '-38,59700', 310, 'S', 0.5800, NULL, NULL, '25900', 'S', 'N', 5241, NULL, '2590', '2590', NULL, '1961', 'S', 2771, 'TRIUNFO', 'N', '251680', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '217', NULL, '03', 'N', NULL, NULL, NULL, 74);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251690', '2509', 'PB', '2590', '2501', '25002', '25', 'UIRAUNA', NULL, '83', '58915000', '4', '2239', '2239', '13170', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 294.495, '-6,51800', '-38,41200', 301, 'S', 0.6460, NULL, NULL, '25900', 'S', 'N', 5304, NULL, '2590', '2590', NULL, '1953', 'S', 2772, 'UIRAÚNA', 'N', '251690', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '218', NULL, '03', 'N', NULL, NULL, NULL, 74);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251700', '2503', 'PB', '2590', '2503', '25019', '25', 'UMBUZEIRO', NULL, '83', '58497000', '1', '2241', '2241', '13171', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 180.872, '-7,69600', '-35,66400', 541, 'S', 0.5390, NULL, NULL, '25900', 'S', 'N', 5311, NULL, '2502', '2590', NULL, '1890', 'S', 2773, 'UMBUZEIRO', 'N', '251700', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '219', NULL, '03', 'N', NULL, NULL, NULL, 72);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251710', '2506', 'PB', '2590', '2502', '25008', '25', 'VARZEA', NULL, '83', '58620000', '0', '2243', '2243', '13172', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 190.444, '-6,77200', '-36,99200', 265, 'S', 0.6970, NULL, NULL, '25900', 'S', 'N', 5383, NULL, '2504', '2590', NULL, '1961', 'S', 2774, 'VÁRZEA', 'N', '251710', 'N', 'S', 'S', NULL, 59, 'N', 'N', 'N', '220', NULL, '03', 'N', NULL, NULL, NULL, 254);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251720', '2510', 'PB', '2590', '2501', '25003', '25', 'VIEIROPOLIS', NULL, '83', '58822000', '9', '0540', '0540', '13223', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 146.778, '-6,50700', '-38,25600', 414, 'S', 0.5490, NULL, NULL, '25900', 'S', 'N', 5439, NULL, '2590', '2590', NULL, '1997', 'S', 2775, 'VIEIRÓPOLIS', 'N', '251720', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '221', NULL, '03', 'N', NULL, NULL, NULL, 195);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251740', '2505', 'PB', '2590', '2502', '25010', '25', 'ZABELE', NULL, '83', '58515000', '7', '0542', '0542', '13224', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 109.394, '-8,07600', '-37,09800', 632, 'S', 0.5980, NULL, NULL, '25900', 'S', 'N', 5505, NULL, '2590', '2590', NULL, '1997', 'S', 2777, 'ZABELÊ', 'N', '251740', 'N', 'S', 'S', NULL, 27, 'N', 'N', 'N', '223', NULL, '03', 'N', NULL, NULL, NULL, 253);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260005', '2601', 'PE', '2601', '2605', '26017', '26', 'ABREU E LIMA', NULL, '81', '53580970', '4', '2631', '2631', '15167', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 125.991, '-7,91200', '-34,90300', 19, 'S', 0.7300, NULL, NULL, '26001', 'N', 'N', 14, NULL, '2601', '2601', NULL, '1982', 'S', 2778, 'ABREU E LIMA', 'N', '260005', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '1', NULL, '01', 'N', NULL, NULL, NULL, 314);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260010', '2610', 'PE', '2603', '2601', '26003', '26', 'AFOGADOS DA INGAZEIRA', NULL, '87', '56800000', '4', '2301', '2301', '15001', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 377.863, '-7,75100', '-37,63900', 514, 'S', 0.6830, NULL, NULL, '26900', 'N', 'N', 35, NULL, '2690', '2690', NULL, '1852', 'S', 2779, 'AFOGADOS DA INGAZEIRA', 'N', '260010', 'N', 'S', 'S', NULL, 82, 'N', 'N', 'N', '2', NULL, '03', 'N', NULL, NULL, NULL, 256);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260020', '2608', 'PE', '2604', '2602', '26005', '26', 'AFRANIO', NULL, '87', '56360000', '3', '2303', '2303', '15002', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1490.615, '-8,51500', '-41,00500', 522, 'S', 0.6340, NULL, NULL, '26900', 'S', 'N', 39, NULL, '2690', '2690', NULL, '1963', 'S', 2780, 'AFRÂNIO', 'N', '260020', 'N', 'S', 'S', NULL, 83, 'N', 'N', 'N', '3', NULL, '03', 'N', NULL, NULL, NULL, 313);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260030', '2604', 'PE', '2602', '2603', '26012', '26', 'AGRESTINA', NULL, '81', '55495000', '2', '2305', '2305', '15003', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 201.437, '-8,45800', '-35,94500', 427, 'S', 0.6120, NULL, NULL, '26006', 'S', 'N', 41, NULL, '2690', '2690', NULL, '1928', 'S', 2781, 'AGRESTINA', 'N', '260030', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '4', NULL, '03', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260040', '2603', 'PE', '2601', '2604', '26015', '26', 'AGUA PRETA', NULL, '81', '55550000', '1', '2307', '2307', '15004', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 543.158, '-8,70700', '-35,53100', 93, 'S', 0.5970, NULL, NULL, '26900', 'S', 'N', 60, NULL, '2690', '2690', NULL, '1879', 'S', 2782, 'ÁGUA PRETA', 'N', '260040', 'N', 'S', 'S', NULL, 54, 'S', 'N', 'N', '5', NULL, '03', 'N', NULL, NULL, NULL, 368);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260050', '2605', 'PE', '2602', '2603', '26007', '26', 'AGUAS BELAS', NULL, '87', '55340000', '0', '2309', '2309', '15005', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'S', NULL, 'N', 885.981, '-9,11100', '-37,12300', 376, 'S', 0.5320, NULL, NULL, '26900', 'N', 'N', 64, NULL, '2690', '2690', NULL, '1871', 'S', 2783, 'ÁGUAS BELAS', 'N', '260050', 'N', 'S', 'S', NULL, 2, 'N', 'N', 'N', '6', NULL, '03', 'N', NULL, NULL, NULL, 257);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230075', '2306', 'CE', '2301', '2302', '23008', '23', 'AMONTADA', NULL, '88', '62540000', '4', '1587', '1587', '05153', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 1179.590, '-3,36100', '-39,83100', 34, 'S', 0.6160, NULL, NULL, '23900', 'N', 'N', 200, NULL, '2390', '2390', NULL, '1986', 'S', 625, 'AMONTADA', 'N', '230075', 'N', 'S', 'S', NULL, 51, 'N', 'N', 'N', '9', NULL, '03', 'N', NULL, NULL, NULL, 229);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230080', '2320', 'CE', '2303', '2306', '23027', '23', 'ANTONINA DO NORTE', NULL, '88', '63570000', '4', '1315', '1315', '05008', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 260.101, '-6,77500', '-39,98900', 365, 'S', 0.6130, NULL, NULL, '23900', 'S', 'N', 253, NULL, '2390', '2390', NULL, '1958', 'S', 626, 'ANTONINA DO NORTE', 'N', '230080', 'N', 'S', 'S', NULL, 131, 'N', 'N', 'N', '10', NULL, '03', 'N', NULL, NULL, NULL, 339);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230100', '2301', 'CE', '2301', '2303', '23016', '23', 'AQUIRAZ', NULL, '85', '61700000', '0', '1319', '1319', '05010', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'S', NULL, 'N', 480.976, '-3,90100', '-38,39100', 14, 'S', 0.6700, NULL, NULL, '23900', 'N', 'N', 287, NULL, '2301', '2301', NULL, '1933', 'S', 628, 'AQUIRAZ', 'N', '230100', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '12', NULL, '01', 'N', NULL, NULL, NULL, 50);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230110', '2307', 'CE', '2301', '2305', '23022', '23', 'ARACATI', NULL, '88', '62800000', '9', '1321', '1321', '05011', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 1229.194, '-4,56200', '-37,77000', 5, 'S', 0.6720, NULL, NULL, '23900', 'N', 'N', 294, NULL, '2390', '2390', NULL, '1842', 'S', 629, 'ARACATI', 'N', '230110', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '13', NULL, '02', 'N', NULL, NULL, NULL, 230);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230130', '2320', 'CE', '2303', '2307', '23029', '23', 'ARARIPE', NULL, '88', '63170000', '7', '1325', '1325', '05013', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 1347.047, '-7,21300', '-40,04600', 605, 'S', 0.5840, NULL, NULL, '23900', 'S', 'N', 344, NULL, '2390', '2390', NULL, '1935', 'S', 632, 'ARARIPE', 'N', '230130', 'N', 'S', 'S', NULL, 131, 'S', 'N', 'N', '16', NULL, '03', 'N', NULL, NULL, NULL, 339);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230150', '2314', 'CE', '2304', '2304', '23020', '23', 'ARNEIROZ', NULL, '88', '63670000', '5', '1329', '1329', '05015', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 1066.426, '-6,32400', '-40,16100', 337, 'S', 0.5870, NULL, NULL, '23900', 'S', 'N', 383, NULL, '2390', '2390', NULL, '1957', 'S', 634, 'ARNEIROZ', 'N', '230150', 'N', 'S', 'S', NULL, 49, 'N', 'N', 'N', '18', NULL, '03', 'N', NULL, NULL, NULL, 337);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230170', '2319', 'CE', '2303', '2307', '23031', '23', 'AURORA', NULL, '88', '63360000', '3', '1333', '1333', '05017', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 885.827, '-6,94300', '-38,96800', 267, 'S', 0.6130, NULL, NULL, '23900', 'S', 'N', 428, NULL, '2390', '2390', NULL, '1933', 'S', 636, 'AURORA', 'N', '230170', 'N', 'S', 'S', NULL, 131, 'S', 'N', 'N', '20', NULL, '03', 'N', NULL, NULL, NULL, 49);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230180', '2317', 'CE', '2303', '2306', '23028', '23', 'BAIXIO', NULL, '88', '63320000', '2', '1335', '1335', '05018', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 146.442, '-6,73000', '-38,71700', 279, 'S', 0.5890, NULL, NULL, '23900', 'S', 'N', 455, NULL, '2390', '2390', NULL, '1956', 'S', 637, 'BAIXIO', 'N', '230180', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '21', NULL, '03', 'N', NULL, NULL, NULL, 48);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230185', '2308', 'CE', '2304', '2304', '23019', '23', 'BANABUIU', NULL, '88', '63960000', '1', '1233', '1233', '05168', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1079.987, '-5,31000', '-38,92100', 170, 'S', 0.6290, NULL, NULL, '23900', 'S', 'N', 469, NULL, '2390', '2390', NULL, '1989', 'S', 638, 'BANABUIÚ', 'N', '230185', 'N', 'S', 'S', NULL, 80, 'N', 'N', 'N', '22', NULL, '03', 'N', NULL, NULL, NULL, 51);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230190', '2321', 'CE', '2303', '2307', '23032', '23', 'BARBALHA', NULL, '88', '63180000', '1', '1337', '1337', '05019', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 479.184, '-7,30500', '-39,30200', 414, 'S', 0.6870, NULL, NULL, '23900', 'N', 'N', 491, NULL, '2302', '2302', NULL, '1876', 'S', 639, 'BARBALHA', 'N', '230190', 'N', 'S', 'S', NULL, 131, 'N', 'N', 'S', '23', NULL, '02', 'N', NULL, NULL, NULL, 109);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230195', '2303', 'CE', '2301', '2302', '23014', '23', 'BARREIRA', NULL, '85', '62795000', '0', '1235', '1235', '05157', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 245.946, '-4,28700', '-38,64300', 100, 'S', 0.6190, NULL, NULL, '23900', 'S', 'N', 533, NULL, '2390', '2390', NULL, '1989', 'S', 640, 'BARREIRA', 'N', '230195', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '24', NULL, '03', 'N', NULL, NULL, NULL, 228);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230210', '2304', 'CE', '2301', '2302', '23013', '23', 'BATURITE', NULL, '85', '62760000', '7', '1341', '1341', '05021', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 308.780, '-4,32900', '-38,88500', 171, 'S', 0.6420, NULL, NULL, '23900', 'N', 'N', 556, NULL, '2390', '2390', NULL, '1858', 'S', 643, 'BATURITÉ', 'N', '230210', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '27', NULL, '03', 'N', NULL, NULL, NULL, 6);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260060', '2604', 'PE', '2602', '2603', '26008', '26', 'ALAGOINHA', NULL, '87', '55260000', '9', '2311', '2311', '15006', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 200.422, '-8,46600', '-36,77600', 726, 'S', 0.6300, NULL, NULL, '26008', 'S', 'N', 90, NULL, '2690', '2690', NULL, '1948', 'S', 2784, 'ALAGOINHA', 'N', '260060', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '7', NULL, '03', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260070', '2612', 'PE', '2601', '2604', '26013', '26', 'ALIANCA', NULL, '81', '55890000', '8', '2313', '2313', '15007', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 272.728, '-7,60300', '-35,23100', 123, 'S', 0.5780, NULL, NULL, '26900', 'N', 'N', 117, NULL, '2690', '2690', NULL, '1928', 'S', 2785, 'ALIANÇA', 'N', '260070', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '8', NULL, '03', 'N', NULL, NULL, NULL, 259);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260090', '2603', 'PE', '2601', '2604', '26015', '26', 'AMARAJI', NULL, '81', '55515000', '6', '2317', '2317', '15009', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 234.780, '-8,38300', '-35,45300', 289, 'S', 0.6170, NULL, NULL, '26900', 'S', 'N', 186, NULL, '2690', '2690', NULL, '1889', 'S', 2787, 'AMARAJI', 'N', '260090', 'N', 'S', 'S', NULL, 54, 'N', 'N', 'N', '10', NULL, '03', 'N', NULL, NULL, NULL, 368);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260100', '2605', 'PE', '2602', '2603', '26011', '26', 'ANGELIM', NULL, '87', '55430000', '3', '2319', '2319', '15010', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 118.032, '-8,89000', '-36,28600', 631, 'S', 0.6020, NULL, NULL, '26900', 'S', 'N', 233, NULL, '2690', '2690', NULL, '1928', 'S', 2788, 'ANGELIM', 'N', '260100', 'N', 'S', 'S', NULL, 2, 'S', 'N', 'N', '11', NULL, '03', 'N', NULL, NULL, NULL, 257);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260105', '2601', 'PE', '2601', '2605', '26016', '26', 'ARACOIABA', NULL, '81', '53690000', '2', '0544', NULL, '15179', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 96.381, '-7,79000', '-35,09100', 160, 'S', 0.6370, NULL, NULL, '26001', 'S', 'N', 300, NULL, '2601', '2601', NULL, '1997', 'S', 2789, 'ARAÇOIABA', 'N', '260105', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '12', NULL, '01', 'N', NULL, NULL, NULL, 314);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353660', '3515', 'SP', '3512', '3501', '35004', '35', 'PAULO DE FARIA', NULL, '17', '15490000', '4', '6833', '6833', '21367', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 740.833, '-20,03100', '-49,38300', 444, 'S', 0.7540, NULL, NULL, '35155', 'N', 'N', 3626, NULL, '3590', '3590', NULL, '1938', 'S', 5156, 'PAULO DE FARIA', 'N', '353660', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '415', NULL, '03', 'N', NULL, NULL, NULL, 392);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353680', '3507', 'SP', '3516', '3507', '35033', '35', 'PEDRA BELA', NULL, '11', '12990000', '2', '6837', '6837', '21369', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 157.184, '-22,79300', '-46,44300', 1120, 'S', 0.7330, NULL, NULL, '35071', 'N', 'N', 3640, NULL, '3590', '3590', NULL, '1964', 'S', 5158, 'PEDRA BELA', 'N', '353680', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '417', NULL, '03', 'N', NULL, NULL, NULL, 275);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353690', '3515', 'SP', '3512', '3501', '35002', '35', 'PEDRANOPOLIS', NULL, '17', '15630000', '1', '6839', '6839', '21370', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 259.992, '-20,24800', '-50,11000', 475, 'S', 0.7780, NULL, NULL, '35154', 'N', 'N', 3654, NULL, '3590', '3590', NULL, '1964', 'S', 5159, 'PEDRANÓPOLIS', 'N', '353690', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '418', NULL, '03', 'N', NULL, NULL, NULL, 276);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353700', '3508', 'SP', '3513', '3502', '35012', '35', 'PEDREGULHO', NULL, '16', '14470000', '8', '6841', '6841', '21371', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 701.886, '-20,25700', '-47,47700', 1035, 'S', 0.7940, NULL, NULL, '35081', 'N', 'N', 3659, NULL, '3590', '3590', NULL, '1921', 'S', 5160, 'PEDREGULHO', 'N', '353700', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '419', NULL, '03', 'N', NULL, NULL, NULL, 101);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353710', '3507', 'SP', '3515', '3507', '35032', '35', 'PEDREIRA', NULL, '19', '13920000', '7', '6843', '6843', '21372', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 109.710, '-22,74200', '-46,90100', 590, 'S', 0.8100, NULL, NULL, '35072', 'N', 'N', 3660, NULL, '3503', '3503', NULL, '1896', 'S', 5161, 'PEDREIRA', 'N', '353710', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '420', NULL, '01', 'N', NULL, NULL, NULL, 515);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353715', '3509', 'SP', '3510', '3510', '35039', '35', 'PEDRINHAS PAULISTA', NULL, '18', '19865000', '6', '2963', '2963', '21609', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 152.173, '-22,81500', '-50,79400', 330, 'S', 0.8190, NULL, NULL, '35092', 'N', 'N', 3663, NULL, '3590', '3590', NULL, '1993', 'S', 5162, 'PEDRINHAS PAULISTA', 'N', '353715', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '421', NULL, '03', 'N', NULL, NULL, NULL, 274);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353720', '3512', 'SP', '3507', '3514', '35056', '35', 'PEDRO DE TOLEDO', NULL, '13', '11790000', '6', '6845', '6845', '21373', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 671.113, '-24,27500', '-47,23300', 45, 'S', 0.7290, NULL, NULL, '35121', 'N', 'N', 3669, NULL, '3590', '3590', NULL, '1948', 'S', 5163, 'PEDRO DE TOLEDO', 'N', '353720', 'N', 'N', 'S', NULL, 100, 'N', 'N', 'N', '422', NULL, '03', 'N', NULL, NULL, NULL, 222);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353780', '3516', 'SP', '3508', '3512', '35045', '35', 'PIEDADE', NULL, '15', '18170000', '0', '6857', '6857', '21379', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 745.536, '-23,71200', '-47,42800', 781, 'S', 0.7570, NULL, NULL, '35163', 'N', 'N', 3727, NULL, '3590', '3590', NULL, '1857', 'S', 5169, 'PIEDADE', 'N', '353780', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '428', NULL, '03', 'N', NULL, NULL, NULL, 165);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353790', '3516', 'SP', '3508', '3512', '35045', '35', 'PILAR DO SUL', NULL, '15', '18185000', '9', '6859', '6859', '21380', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 682.395, '-23,81300', '-47,71600', 689, 'S', 0.7740, NULL, NULL, '35163', 'N', 'N', 3737, NULL, '3590', '3590', NULL, '1891', 'S', 5170, 'PILAR DO SUL', 'N', '353790', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '429', NULL, '03', 'N', NULL, NULL, NULL, 165);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353810', '3515', 'SP', '3512', '3501', '35005', '35', 'PINDORAMA', NULL, '17', '15830000', '5', '6863', '6863', '21382', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 184.525, '-21,18600', '-48,90700', 527, 'S', 0.8080, NULL, NULL, '35151', 'N', 'N', 3750, NULL, '3590', '3590', NULL, '1925', 'S', 5172, 'PINDORAMA', 'N', '353810', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '431', NULL, '03', 'N', NULL, NULL, NULL, 382);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353820', '3507', 'SP', '3516', '3507', '35033', '35', 'PINHALZINHO', NULL, '11', '12995000', '4', '6867', '6867', '21384', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 154.948, '-22,77900', '-46,59100', 910, 'S', 0.7880, NULL, NULL, '35071', 'N', 'N', 3760, NULL, '3590', '3590', NULL, '1964', 'S', 5173, 'PINHALZINHO', 'N', '353820', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '432', NULL, '03', 'N', NULL, NULL, NULL, 275);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230220', '2322', 'CE', '2301', '2302', '23015', '23', 'BEBERIBE', NULL, '85', '62840000', '6', '1343', '1343', '05022', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1616.389, '-4,18000', '-38,13100', 12, 'S', 0.6510, NULL, NULL, '23900', 'N', 'N', 560, NULL, '2390', '2390', NULL, '1951', 'S', 644, 'BEBERIBE', 'N', '230220', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '28', NULL, '03', 'N', NULL, NULL, NULL, 340);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230240', '2305', 'CE', '2304', '2304', '23019', '23', 'BOA VIAGEM', NULL, '88', '63870000', '4', '1347', '1347', '05024', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 2836.774, '-5,12800', '-39,73200', 275, 'S', 0.6110, NULL, NULL, '23900', 'N', 'N', 633, NULL, '2390', '2390', NULL, '1936', 'S', 646, 'BOA VIAGEM', 'N', '230240', 'N', 'S', 'S', NULL, 85, 'N', 'N', 'N', '30', NULL, '02', 'N', NULL, NULL, NULL, 172);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230250', '2319', 'CE', '2303', '2307', '23033', '23', 'BREJO SANTO', NULL, '88', '63260000', '3', '1349', '1349', '05025', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 661.959, '-7,49300', '-38,98500', 381, 'S', 0.6730, NULL, NULL, '23900', 'N', 'N', 764, NULL, '2390', '2390', NULL, '1890', 'S', 647, 'BREJO SANTO', 'N', '230250', 'N', 'S', 'S', NULL, 131, 'S', 'N', 'N', '31', NULL, '03', 'N', NULL, NULL, NULL, 49);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230260', '2316', 'CE', '2302', '2301', '23001', '23', 'CAMOCIM', NULL, '88', '62400000', '2', '1351', '1351', '05026', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1123.937, '-2,90200', '-40,84100', 8, 'S', 0.6290, NULL, NULL, '23900', 'N', 'N', 921, NULL, '2390', '2390', NULL, '1879', 'S', 648, 'CAMOCIM', 'N', '230260', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '32', NULL, '02', 'N', NULL, NULL, NULL, 338);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230280', '2305', 'CE', '2304', '2302', '23012', '23', 'CANINDE', NULL, '85', '62700000', '0', '1355', '1355', '05028', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 3218.423, '-4,35900', '-39,31200', 148, 'S', 0.6340, NULL, NULL, '23900', 'N', 'N', 1020, NULL, '2390', '2390', NULL, '1846', 'S', 650, 'CANINDÉ', 'N', '230280', 'N', 'S', 'S', NULL, 85, 'N', 'N', 'S', '34', NULL, '01', 'N', NULL, NULL, NULL, 172);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230300', '2305', 'CE', '2304', '2302', '23012', '23', 'CARIDADE', NULL, '85', '62730000', '6', '1359', '1359', '05030', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 846.373, '-4,23200', '-39,19300', 144, 'S', 0.6180, NULL, NULL, '23900', 'S', 'N', 1098, NULL, '2390', '2390', NULL, '1958', 'S', 652, 'CARIDADE', 'N', '230300', 'N', 'S', 'S', NULL, 85, 'S', 'N', 'N', '36', NULL, '03', 'N', NULL, NULL, NULL, 172);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230310', '2311', 'CE', '2302', '2301', '23005', '23', 'CARIRE', NULL, '88', '62184000', '5', '1361', '1361', '05031', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 756.893, '-3,95100', '-40,47300', 158, 'S', 0.6220, NULL, NULL, '23900', 'S', 'N', 1102, NULL, '2390', '2390', NULL, '1935', 'S', 653, 'CARIRÉ', 'N', '230310', 'N', 'S', 'S', NULL, 86, 'N', 'N', 'N', '37', NULL, '03', 'N', NULL, NULL, NULL, 284);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230320', '2321', 'CE', '2303', '2307', '23030', '23', 'CARIRIACU', NULL, '88', '63220000', '4', '1363', '1363', '05032', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 623.823, '-7,04200', '-39,28400', 715, 'S', 0.5910, NULL, NULL, '23900', 'S', 'N', 1104, NULL, '2302', '2390', NULL, '1933', 'S', 654, 'CARIRIAÇU', 'N', '230320', 'N', 'S', 'S', NULL, 131, 'S', 'N', 'N', '38', NULL, '03', 'N', NULL, NULL, NULL, 109);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230330', '2318', 'CE', '2303', '2306', '23027', '23', 'CARIUS', NULL, '88', '63530000', '3', '1365', '1365', '05033', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 1061.825, '-6,53700', '-39,49700', 240, 'S', 0.6300, NULL, NULL, '23900', 'S', 'N', 1105, NULL, '2390', '2390', NULL, '1951', 'S', 655, 'CARIÚS', 'N', '230330', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '39', NULL, '03', 'N', NULL, NULL, NULL, 108);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230340', '2313', 'CE', '2302', '2301', '23002', '23', 'CARNAUBAL', NULL, '88', '62375000', '2', '1367', '1367', '05034', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 364.750, '-4,16700', '-40,94300', 766, 'S', 0.6090, NULL, NULL, '23900', 'S', 'N', 1126, NULL, '2390', '2390', NULL, '1957', 'S', 656, 'CARNAUBAL', 'N', '230340', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '40', NULL, '03', 'N', NULL, NULL, NULL, 171);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230350', '2322', 'CE', '2301', '2302', '23015', '23', 'CASCAVEL', NULL, '85', '62850000', '1', '1369', '1369', '05035', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 837.967, '-4,13100', '-38,23600', 40, 'S', 0.6730, NULL, NULL, '23900', 'N', 'N', 1146, NULL, '2301', '2390', NULL, '1833', 'S', 657, 'CASCAVEL', 'N', '230350', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '41', NULL, '01', 'N', NULL, NULL, NULL, 340);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230360', '2318', 'CE', '2303', '2304', '23020', '23', 'CATARINA', NULL, '88', '63595000', '0', '1371', '1371', '05036', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 486.859, '-6,13100', '-39,87800', 589, 'S', 0.5800, NULL, NULL, '23900', 'S', 'N', 1169, NULL, '2390', '2390', NULL, '1957', 'S', 658, 'CATARINA', 'N', '230360', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '42', NULL, '03', 'N', NULL, NULL, NULL, 108);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260110', '2609', 'PE', '2604', '2601', '26001', '26', 'ARARIPINA', NULL, '87', '56280000', '2', '2321', '2321', '15011', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1847.470, '-7,57600', '-40,49800', 622, 'S', 0.6500, NULL, NULL, '26900', 'N', 'N', 345, NULL, '2690', '2690', NULL, '1928', 'S', 2790, 'ARARIPINA', 'N', '260110', 'N', 'S', 'S', NULL, 81, 'N', 'N', 'S', '13', NULL, '01', 'N', NULL, NULL, NULL, 260);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260120', '2606', 'PE', '2603', '2601', '26004', '26', 'ARCOVERDE', NULL, '87', '56500000', '1', '2323', '2323', '15012', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 353.383, '-8,41900', '-37,05400', 663, 'S', 0.7080, NULL, NULL, '26010', 'N', 'N', 360, NULL, '2690', '2690', NULL, '1925', 'S', 2791, 'ARCOVERDE', 'N', '260120', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '14', NULL, '02', 'N', NULL, NULL, NULL, 138);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260130', '2604', 'PE', '2602', '2603', '26012', '26', 'BARRA DE GUABIRABA', NULL, '81', '55690000', '0', '2325', '2325', '15013', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 114.216, '-8,42000', '-35,65800', 482, 'S', 0.5540, NULL, NULL, '26007', 'S', 'N', 503, NULL, '2690', '2690', NULL, '1958', 'S', 2792, 'BARRA DE GUABIRABA', 'N', '260130', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '15', NULL, '03', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260140', '2603', 'PE', '2601', '2604', '26015', '26', 'BARREIROS', NULL, '81', '55560000', '9', '2327', '2327', '15014', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 233.370, '-8,81800', '-35,18600', 22, 'S', 0.6350, NULL, NULL, '26900', 'N', 'N', 538, NULL, '2690', '2690', NULL, '1953', 'S', 2793, 'BARREIROS', 'N', '260140', 'N', 'S', 'S', NULL, 54, 'N', 'N', 'N', '16', NULL, '03', 'N', NULL, NULL, NULL, 368);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260150', '2603', 'PE', '2601', '2604', '26015', '26', 'BELEM DE MARIA', NULL, '81', '55440000', '8', '2329', '2329', '15015', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 69.465, '-8,61400', '-35,80900', 227, 'S', 0.5900, NULL, NULL, '26900', 'S', 'N', 574, NULL, '2690', '2690', NULL, '1958', 'S', 2794, 'BELÉM DE MARIA', 'N', '260150', 'N', 'S', 'S', NULL, 54, 'N', 'N', 'N', '17', NULL, '03', 'N', NULL, NULL, NULL, 368);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353830', '3511', 'SP', '3511', '3508', '35036', '35', 'PIQUEROBI', NULL, '18', '19410000', '3', '6869', '6869', '21385', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 482.506, '-21,86800', '-51,72900', 440, 'S', 0.7440, NULL, NULL, '35114', 'N', 'N', 3773, NULL, '3590', '3590', NULL, '1948', 'S', 5174, 'PIQUEROBI', 'N', '353830', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '433', NULL, '03', 'N', NULL, NULL, NULL, 435);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353850', '3517', 'SP', '3517', '3513', '35051', '35', 'PIQUETE', NULL, '12', '12620000', '1', '6871', '6871', '21386', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 175.881, '-22,61400', '-45,17600', 645, 'S', 0.8010, NULL, NULL, '35172', 'N', 'N', 3775, NULL, '3590', '3506', NULL, '1891', 'S', 5175, 'PIQUETE', 'N', '353850', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '434', NULL, '03', 'N', NULL, NULL, NULL, 433);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353860', '3507', 'SP', '3516', '3512', '35048', '35', 'PIRACAIA', NULL, '11', '12970000', '0', '6873', '6873', '21387', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 384.729, '-23,05400', '-46,35800', 792, 'S', 0.7920, NULL, NULL, '35071', 'N', 'N', 3776, NULL, '3590', '3590', NULL, '1859', 'S', 5176, 'PIRACAIA', 'N', '353860', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '435', NULL, '03', 'N', NULL, NULL, NULL, 275);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353870', '3510', 'SP', '3514', '3506', '35028', '35', 'PIRACICABA', NULL, '19', '13400000', '9', '6875', '6875', '21388', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1369.511, '-22,72500', '-47,64900', 547, 'S', 0.8360, NULL, NULL, '35103', 'N', 'N', 3779, NULL, '3590', '3590', NULL, '1821', 'S', 5177, 'PIRACICABA', 'N', '353870', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '436', NULL, '01', 'N', NULL, NULL, NULL, 100);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353880', '3506', 'SP', '3509', '3510', '35040', '35', 'PIRAJU', NULL, '14', '18800000', '8', '6877', '6877', '21389', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 505.225, '-23,19400', '-49,38400', 646, 'S', 0.7910, NULL, NULL, '35061', 'N', 'N', 3784, NULL, '3590', '3590', NULL, '1880', 'S', 5178, 'PIRAJU', 'N', '353880', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '437', NULL, '03', 'N', NULL, NULL, NULL, 102);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353900', '3515', 'SP', '3512', '3502', '35013', '35', 'PIRANGI', NULL, '17', '15820000', '4', '6881', '6881', '21391', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 215.791, '-21,09100', '-48,65800', 538, 'S', 0.7790, NULL, NULL, '35151', 'N', 'N', 3789, NULL, '3590', '3590', NULL, '1935', 'S', 5180, 'PIRANGI', 'N', '353900', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '439', NULL, '03', 'N', NULL, NULL, NULL, 382);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353920', '3511', 'SP', '3511', '3508', '35036', '35', 'PIRAPOZINHO', NULL, '18', '19200000', '2', '6885', '6885', '21393', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 480.795, '-22,27500', '-51,50000', 487, 'S', 0.7830, NULL, NULL, '35112', 'N', 'N', 3799, NULL, '3590', '3590', NULL, '1948', 'S', 5182, 'PIRAPOZINHO', 'N', '353920', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '441', NULL, '03', 'N', NULL, NULL, NULL, 323);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353930', '3510', 'SP', '3514', '3507', '35029', '35', 'PIRASSUNUNGA', NULL, '19', '13630000', '1', '6887', '6887', '21394', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 726.942, '-21,99600', '-47,42600', 627, 'S', 0.8390, NULL, NULL, '35101', 'N', 'N', 3802, NULL, '3590', '3590', NULL, '1865', 'S', 5183, 'PIRASSUNUNGA', 'N', '353930', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '442', NULL, '02', 'N', NULL, NULL, NULL, 155);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353950', '3513', 'SP', '3514', '3502', '35013', '35', 'PITANGUEIRAS', NULL, '16', '14750000', '9', '6891', '6891', '21396', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 429.577, '-21,00900', '-48,22200', 512, 'S', 0.7640, NULL, NULL, '35131', 'N', 'N', 3815, NULL, '3590', '3590', NULL, '1893', 'S', 5185, 'PITANGUEIRAS', 'N', '353950', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '444', NULL, '03', 'N', NULL, NULL, NULL, 383);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353960', '3515', 'SP', '3512', '3501', '35004', '35', 'PLANALTO', NULL, '18', '15260000', '8', '6893', '6893', '21397', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 289.538, '-21,03400', '-49,92900', 434, 'S', 0.7440, NULL, NULL, '35156', 'N', 'N', 3829, NULL, '3590', '3590', NULL, '1948', 'S', 5186, 'PLANALTO', 'N', '353960', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '445', NULL, '03', 'N', NULL, NULL, NULL, 160);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353970', '3509', 'SP', '3510', '3510', '35039', '35', 'PLATINA', NULL, '18', '19990000', '7', '6895', '6895', '21398', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 327.826, '-22,63800', '-50,20400', 466, 'S', 0.7350, NULL, NULL, '35092', 'N', 'N', 3834, NULL, '3590', '3590', NULL, '1915', 'S', 5187, 'PLATINA', 'N', '353970', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '446', NULL, '03', 'N', NULL, NULL, NULL, 274);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353990', '3515', 'SP', '3512', '3501', '35007', '35', 'POLONI', NULL, '17', '15160000', '5', '6899', '6899', '21400', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 134.766, '-20,78500', '-49,82400', 548, 'S', 0.7870, NULL, NULL, '35156', 'N', 'N', 3852, NULL, '3590', '3590', NULL, '1953', 'S', 5189, 'POLONI', 'N', '353990', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '448', NULL, '03', 'N', NULL, NULL, NULL, 160);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354000', '3509', 'SP', '3510', '3509', '35038', '35', 'POMPEIA', NULL, '14', '17580000', '2', '6901', '6901', '21401', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 786.406, '-22,10900', '-50,17200', 597, 'S', 0.8160, NULL, NULL, '35093', 'N', 'N', 3856, NULL, '3590', '3590', NULL, '1938', 'S', 5190, 'POMPÉIA', 'N', '354000', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '449', NULL, '03', 'N', NULL, NULL, NULL, 96);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354020', '3513', 'SP', '3514', '3502', '35014', '35', 'PONTAL', NULL, '16', '14180000', '0', '6905', '6905', '21403', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 355.262, '-21,02300', '-48,03700', 515, 'S', 0.7920, NULL, NULL, '35131', 'N', 'N', 3862, NULL, '3590', '3590', NULL, '1935', 'S', 5192, 'PONTAL', 'N', '354020', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '451', NULL, '03', 'N', NULL, NULL, NULL, 383);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354025', '3515', 'SP', '3512', '3501', '35001', '35', 'PONTALINDA', NULL, '17', '15718000', '9', '2987', '2987', '21610', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 210.257, '-20,44100', '-50,52300', 435, 'S', 0.7310, NULL, NULL, '35153', 'N', 'N', 3866, NULL, '3590', '3590', NULL, '1993', 'S', 5193, 'PONTALINDA', 'N', '354025', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '452', NULL, '03', 'N', NULL, NULL, NULL, 436);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354030', '3515', 'SP', '3512', '3501', '35003', '35', 'PONTES GESTAL', NULL, '17', '15560000', '9', '6907', '6907', '21404', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 217.134, '-20,16700', '-49,70300', 449, 'S', 0.7490, NULL, NULL, '35157', 'N', 'N', 3877, NULL, '3590', '3590', NULL, '1964', 'S', 5194, 'PONTES GESTAL', 'N', '354030', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '453', NULL, '03', 'N', NULL, NULL, NULL, 162);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354040', '3515', 'SP', '3512', '3501', '35001', '35', 'POPULINA', NULL, '17', '15670000', '8', '6909', '6909', '21405', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 315.432, '-19,95400', '-50,53800', 443, 'S', 0.7550, NULL, NULL, '35154', 'N', 'N', 3882, NULL, '3590', '3590', NULL, '1959', 'S', 5195, 'POPULINA', 'N', '354040', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '454', NULL, '03', 'N', NULL, NULL, NULL, 276);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354060', '3516', 'SP', '3508', '3512', '35046', '35', 'PORTO FELIZ', NULL, '15', '18540000', '6', '6913', '6913', '21407', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 556.563, '-23,21500', '-47,52400', 523, 'S', 0.8000, NULL, NULL, '35163', 'N', 'N', 3912, NULL, '3590', '3590', NULL, '1797', 'S', 5197, 'PORTO FELIZ', 'N', '354060', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '456', NULL, '03', 'N', NULL, NULL, NULL, 165);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354070', '3503', 'SP', '3513', '3507', '35029', '35', 'PORTO FERREIRA', NULL, '19', '13660000', '5', '6915', '6915', '21408', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 243.906, '-21,85400', '-47,47900', 558, 'S', 0.8020, NULL, NULL, '35034', 'N', 'N', 3913, NULL, '3590', '3590', NULL, '1896', 'S', 5198, 'PORTO FERREIRA', 'N', '354070', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '457', NULL, '02', 'N', NULL, NULL, NULL, 434);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354075', '3517', 'SP', '3517', '3513', '35051', '35', 'POTIM', NULL, '12', '12525000', '4', '2993', '2993', '21611', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 44.651, '-22,84300', '-45,25100', 535, 'S', 0.7580, NULL, NULL, '35172', 'N', 'N', 3935, NULL, '3590', '3590', NULL, '1993', 'S', 5199, 'POTIM', 'N', '354075', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '458', NULL, '03', 'N', NULL, NULL, NULL, 433);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354080', '3515', 'SP', '3512', '3501', '35004', '35', 'POTIRENDABA', NULL, '17', '15105000', '4', '6917', '6917', '21409', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 342.388, '-21,04300', '-49,37700', 469, 'S', 0.8050, NULL, NULL, '35155', 'N', 'N', 3937, NULL, '3590', '3590', NULL, '1925', 'S', 5200, 'POTIRENDABA', 'N', '354080', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '459', NULL, '03', 'N', NULL, NULL, NULL, 392);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354090', '3513', 'SP', '3514', '3502', '35014', '35', 'PRADOPOLIS', NULL, '16', '14850000', '3', '6919', '6919', '21410', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 167.202, '-21,35900', '-48,06600', 538, 'S', 0.7980, NULL, NULL, '35131', 'N', 'N', 3948, NULL, '3590', '3510', NULL, '1959', 'S', 5202, 'PRADÓPOLIS', 'N', '354090', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '461', NULL, '03', 'N', NULL, NULL, NULL, 383);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354120', '3511', 'SP', '3511', '3508', '35036', '35', 'PRESIDENTE BERNARDES', NULL, '18', '19300000', '8', '6925', '6925', '21413', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 753.743, '-22,00600', '-51,55300', 429, 'S', 0.7900, NULL, NULL, '35112', 'N', 'N', 3963, NULL, '3590', '3590', NULL, '1935', 'S', 5206, 'PRESIDENTE BERNARDES', 'N', '354120', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '465', NULL, '03', 'N', NULL, NULL, NULL, 323);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354130', '3511', 'SP', '3511', '3508', '35036', '35', 'PRESIDENTE EPITACIO', NULL, '18', '19470000', '7', '6927', '6927', '21414', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1281.779, '-21,76300', '-52,11600', 310, 'S', 0.7660, NULL, NULL, '35114', 'N', 'N', 3968, NULL, '3590', '3590', NULL, '1948', 'S', 5207, 'PRESIDENTE EPITÁCIO', 'N', '354130', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '466', NULL, '03', 'N', NULL, NULL, NULL, 435);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354140', '3511', 'SP', '3511', '3508', '35036', '35', 'PRESIDENTE PRUDENTE', NULL, '18', '19000000', '6', '6929', '6929', '21415', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 562.107, '-22,12600', '-51,38900', 475, 'S', 0.8460, NULL, NULL, '35112', 'N', 'N', 3982, NULL, '3590', '3590', NULL, '1921', 'S', 5208, 'PRESIDENTE PRUDENTE', 'N', '354140', 'N', 'N', 'S', NULL, 73, 'N', 'S', 'N', '467', NULL, '01', 'N', NULL, NULL, NULL, 323);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354150', '3511', 'SP', '3511', '3508', '35036', '35', 'PRESIDENTE VENCESLAU', NULL, '18', '19400000', '5', '6931', '6931', '21416', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 755.010, '-21,87600', '-51,84400', 422, 'S', 0.8180, NULL, NULL, '35114', 'N', 'N', 3986, NULL, '3590', '3590', NULL, '1926', 'S', 5209, 'PRESIDENTE VENCESLAU', 'N', '354150', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '468', NULL, '03', 'N', NULL, NULL, NULL, 435);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354165', '3516', 'SP', '3508', '3511', '35043', '35', 'QUADRA', NULL, '15', '18255000', '3', '0816', '8168', '21641', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 205.033, '-23,29900', '-48,05500', 638, 'S', 0.7550, NULL, NULL, '35161', 'N', 'N', 4006, NULL, '3590', '3590', NULL, '1997', 'S', 5211, 'QUADRA', 'N', '354165', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '470', NULL, '03', 'N', NULL, NULL, NULL, 158);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354170', '3511', 'SP', '3511', '3510', '35039', '35', 'QUATA', NULL, '18', '19780000', '3', '6935', '6935', '21418', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 652.744, '-22,24800', '-50,69800', 550, 'S', 0.7920, NULL, NULL, '35113', 'N', 'N', 4010, NULL, '3590', '3590', NULL, '1925', 'S', 5212, 'QUATÁ', 'N', '354170', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '471', NULL, '03', 'N', NULL, NULL, NULL, 154);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354180', '3509', 'SP', '3510', '3509', '35037', '35', 'QUEIROZ', NULL, '14', '17590000', '2', '6937', '6937', '21419', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 235.496, '-21,79900', '-50,24000', 431, 'S', 0.7300, NULL, NULL, '35095', 'N', 'N', 4022, NULL, '3590', '3590', NULL, '1964', 'S', 5213, 'QUEIROZ', 'N', '354180', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '472', NULL, '03', 'N', NULL, NULL, NULL, 221);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354190', '3517', 'SP', '3517', '3513', '35051', '35', 'QUELUZ', NULL, '12', '12800000', '1', '6939', '6939', '21420', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 249.408, '-22,53700', '-44,77400', 497, 'S', 0.7660, NULL, NULL, '35172', 'N', 'N', 4023, NULL, '3590', '3590', NULL, '1842', 'S', 5214, 'QUELUZ', 'N', '354190', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '473', NULL, '03', 'N', NULL, NULL, NULL, 433);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354200', '3509', 'SP', '3510', '3509', '35037', '35', 'QUINTANA', NULL, '14', '17670000', '8', '6941', '6941', '21421', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 319.759, '-22,07300', '-50,30800', 595, 'S', 0.7410, NULL, NULL, '35093', 'N', 'N', 4031, NULL, '3590', '3590', NULL, '1944', 'S', 5215, 'QUINTANA', 'N', '354200', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '474', NULL, '03', 'N', NULL, NULL, NULL, 96);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354210', '3510', 'SP', '3514', '3506', '35028', '35', 'RAFARD', NULL, '19', '13370000', '7', '6943', '6943', '21422', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 132.471, '-23,01200', '-47,52700', 515, 'S', 0.8030, NULL, NULL, '35103', 'N', 'N', 4048, NULL, '3590', '3590', NULL, '1964', 'S', 5216, 'RAFARD', 'N', '354210', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '475', NULL, '03', 'N', NULL, NULL, NULL, 100);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354220', '3511', 'SP', '3511', '3508', '35036', '35', 'RANCHARIA', NULL, '18', '19600000', '6', '6945', '6945', '21423', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1584.726, '-22,22900', '-50,89300', 519, 'S', 0.7890, NULL, NULL, '35113', 'N', 'N', 4050, NULL, '3590', '3590', NULL, '1935', 'S', 5217, 'RANCHARIA', 'N', '354220', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '476', NULL, '03', 'N', NULL, NULL, NULL, 154);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354240', '3511', 'SP', '3511', '3508', '35036', '35', 'REGENTE FEIJO', NULL, '18', '19570000', '4', '6949', '6949', '21425', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 265.087, '-22,22100', '-51,30300', 504, 'S', 0.7970, NULL, NULL, '35112', 'N', 'N', 4069, NULL, '3590', '3590', NULL, '1935', 'S', 5219, 'REGENTE FEIJÓ', 'N', '354240', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '478', NULL, '03', 'N', NULL, NULL, NULL, 323);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354260', '3512', 'SP', '3507', '3514', '35055', '35', 'REGISTRO', NULL, '13', '11900000', '2', '6953', '6953', '21427', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'S', NULL, 'N', 716.331, '-24,48800', '-47,84400', 25, 'S', 0.7770, NULL, NULL, '35121', 'N', 'N', 4071, NULL, '3590', '3590', NULL, '1944', 'S', 5221, 'REGISTRO', 'N', '354260', 'N', 'N', 'S', NULL, 100, 'N', 'N', 'N', '480', NULL, '02', 'N', NULL, NULL, NULL, 222);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354270', '3508', 'SP', '3513', '3502', '35012', '35', 'RESTINGA', NULL, '16', '14430000', '1', '6955', '6955', '21428', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 245.599, '-20,60300', '-47,48300', 910, 'S', 0.7570, NULL, NULL, '35081', 'N', 'N', 4084, NULL, '3590', '3590', NULL, '1964', 'S', 5222, 'RESTINGA', 'N', '354270', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '481', NULL, '03', 'N', NULL, NULL, NULL, 101);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354280', '3516', 'SP', '3508', '3511', '35044', '35', 'RIBEIRA', NULL, '15', '18380000', '0', '6957', '6957', '21429', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 335.029, '-24,65700', '-49,00900', 167, 'S', 0.6780, NULL, NULL, '35162', 'S', 'N', 4109, NULL, '3590', '3590', NULL, '1910', 'S', 5223, 'RIBEIRA', 'N', '354280', 'N', 'N', 'S', NULL, 100, 'N', 'N', 'N', '482', NULL, '03', 'N', NULL, NULL, NULL, 159);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354290', '3503', 'SP', '3513', '3505', '35025', '35', 'RIBEIRAO BONITO', NULL, '16', '13580000', '9', '6959', '6959', '21430', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 471.498, '-22,06700', '-48,17600', 590, 'S', 0.7810, NULL, NULL, '35034', 'N', 'N', 4114, NULL, '3590', '3590', NULL, '1890', 'S', 5224, 'RIBEIRÃO BONITO', 'N', '354290', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '483', NULL, '03', 'N', NULL, NULL, NULL, 434);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354300', '3516', 'SP', '3508', '3511', '35044', '35', 'RIBEIRAO BRANCO', NULL, '15', '18430000', '6', '6961', '6961', '21431', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 697.813, '-24,22100', '-48,76600', 875, 'S', 0.6490, NULL, NULL, '35162', 'S', 'N', 4115, NULL, '3590', '3590', NULL, '1892', 'S', 5225, 'RIBEIRÃO BRANCO', 'N', '354300', 'N', 'N', 'S', NULL, 100, 'N', 'N', 'N', '484', NULL, '03', 'N', NULL, NULL, NULL, 159);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354310', '3508', 'SP', '3513', '3502', '35012', '35', 'RIBEIRAO CORRENTE', NULL, '16', '14445000', '5', '6963', '6963', '21432', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 148.456, '-20,45700', '-47,59000', 855, 'S', 0.7510, NULL, NULL, '35081', 'N', 'N', 4118, NULL, '3590', '3590', NULL, '1964', 'S', 5226, 'RIBEIRÃO CORRENTE', 'N', '354310', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '485', NULL, '03', 'N', NULL, NULL, NULL, 101);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354323', '3511', 'SP', '3511', '3508', '35036', '35', 'RIBEIRAO DOS INDIOS', NULL, '18', '19380000', '8', '0818', NULL, '21642', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 196.991, '-21,83700', '-51,60400', 386, 'S', 0.7540, NULL, NULL, '35112', 'N', 'N', 4123, NULL, '3590', '3590', NULL, '1997', 'S', 5228, 'RIBEIRÃO DOS ÍNDIOS', 'N', '354323', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '487', NULL, '03', 'N', NULL, NULL, NULL, 323);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354325', '3516', 'SP', '3508', '3511', '35044', '35', 'RIBEIRAO GRANDE', NULL, '15', '18315000', '3', '3057', '3057', '21612', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 332.071, '-24,09900', '-48,36500', 690, 'S', 0.7050, NULL, NULL, '35161', 'N', 'N', 4124, NULL, '3590', '3590', NULL, '1993', 'S', 5229, 'RIBEIRÃO GRANDE', 'N', '354325', 'N', 'N', 'S', NULL, 89, 'N', 'N', 'N', '488', NULL, '03', 'N', NULL, NULL, NULL, 158);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354330', '3501', 'SP', '3501', '3515', '35061', '35', 'RIBEIRAO PIRES', NULL, '11', '10940000', '3', '6967', '6967', '21434', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 99.175, '-23,71100', '-46,41300', 763, 'S', 0.8070, NULL, NULL, '35015', 'N', 'N', 4125, NULL, '3501', '3501', NULL, '1953', 'S', 5230, 'RIBEIRÃO PIRES', 'N', '354330', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '489', NULL, '01', 'N', NULL, NULL, NULL, 94);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354340', '3513', 'SP', '3514', '3502', '35014', '35', 'RIBEIRAO PRETO', NULL, '16', '14001970', '2', '6969', '6969', '21435', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 650.366, '-21,17800', '-47,81000', 546, 'S', 0.8550, NULL, NULL, '35132', 'N', 'N', 4126, NULL, '3590', '3510', NULL, '1871', 'S', 5231, 'RIBEIRÃO PRETO', 'N', '354340', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '490', NULL, '01', 'N', NULL, NULL, NULL, 273);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354350', '3516', 'SP', '3508', '3511', '35041', '35', 'RIVERSUL', NULL, '15', '18470000', '1', '6971', '6971', '21436', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 386.204, '-23,82800', '-49,42900', 587, 'S', 0.6940, NULL, NULL, '35162', 'S', 'N', 4200, NULL, '3590', '3590', NULL, '1953', 'S', 5239, 'RIVERSUL', 'N', '354350', 'N', 'N', 'S', NULL, 89, 'N', 'N', 'N', '498', NULL, '03', 'N', NULL, NULL, NULL, 159);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354360', '3508', 'SP', '3513', '3502', '35012', '35', 'RIFAINA', NULL, '16', '14490000', '0', '6973', '6973', '21437', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 171.583, '-20,08100', '-47,42100', 575, 'S', 0.7740, NULL, NULL, '35081', 'N', 'N', 4131, NULL, '3590', '3590', NULL, '1948', 'S', 5232, 'RIFAINA', 'N', '354360', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '491', NULL, '03', 'N', NULL, NULL, NULL, 101);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354380', '3509', 'SP', '3510', '3508', '35035', '35', 'RINOPOLIS', NULL, '18', '17740000', '8', '6977', '6977', '21439', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 358.500, '-21,72600', '-50,72200', 425, 'S', 0.7570, NULL, NULL, '35095', 'N', 'N', 4133, NULL, '3590', '3590', NULL, '1944', 'S', 5234, 'RINÓPOLIS', 'N', '354380', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '493', NULL, '03', 'N', NULL, NULL, NULL, 221);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354390', '3510', 'SP', '3514', '3506', '35026', '35', 'RIO CLARO', NULL, '19', '11350970', '7', '6979', '6979', '21440', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 498.008, '-22,41100', '-47,56100', 625, 'S', 0.8250, NULL, NULL, '35104', 'N', 'N', 4146, NULL, '3590', '3508', NULL, '1845', 'S', 5235, 'RIO CLARO', 'N', '354390', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '494', NULL, '01', 'N', NULL, NULL, NULL, 43);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354400', '3510', 'SP', '3514', '3506', '35028', '35', 'RIO DAS PEDRAS', NULL, '19', '13390000', '4', '6981', '6981', '21441', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 226.939, '-22,84300', '-47,60600', 625, 'S', 0.7910, NULL, NULL, '35103', 'N', 'N', 4153, NULL, '3590', '3590', NULL, '1894', 'S', 5236, 'RIO DAS PEDRAS', 'N', '354400', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '495', NULL, '03', 'N', NULL, NULL, NULL, 100);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354410', '3501', 'SP', '3501', '3515', '35061', '35', 'RIO GRANDE DA SERRA', NULL, '11', '09450000', '3', '6983', '6983', '21442', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 36.671, '-23,74400', '-46,39800', 739, 'S', 0.7640, NULL, NULL, '35015', 'N', 'N', 4171, NULL, '3501', '3501', NULL, '1964', 'S', 5237, 'RIO GRANDE DA SERRA', 'N', '354410', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '496', NULL, '01', 'N', NULL, NULL, NULL, 94);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354420', '3515', 'SP', '3512', '3501', '35003', '35', 'RIOLANDIA', NULL, '17', '15495000', '2', '6985', '6985', '21443', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 630.681, '-19,99000', '-49,68100', 438, 'S', 0.7370, NULL, NULL, '35157', 'N', 'N', 4196, NULL, '3590', '3590', NULL, '1953', 'S', 5238, 'RIOLÂNDIA', 'N', '354420', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '497', NULL, '03', 'N', NULL, NULL, NULL, 162);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354425', '3511', 'SP', '3511', '3508', '35036', '35', 'ROSANA', NULL, '18', '19273000', '1', '7265', '7265', '21584', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 741.216, '-22,58000', '-53,05900', 236, 'S', 0.8150, NULL, NULL, '35115', 'N', 'N', 4223, NULL, '3590', '3590', NULL, '1993', 'S', 5240, 'ROSANA', 'N', '354425', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '499', NULL, '03', 'N', NULL, NULL, NULL, 331);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354450', '3515', 'SP', '3512', '3501', '35001', '35', 'RUBINEIA', NULL, '17', '15790000', '9', '6991', '6991', '21446', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 234.381, '-20,17900', '-51,00200', 317, 'S', 0.7880, NULL, NULL, '35152', 'N', 'N', 4236, NULL, '3590', '3590', NULL, '1964', 'S', 5243, 'RUBINÉIA', 'N', '354450', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '502', NULL, '03', 'N', NULL, NULL, NULL, 219);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354470', '3509', 'SP', '3510', '3508', '35035', '35', 'SAGRES', NULL, '18', '17710000', '7', '6995', '6995', '21448', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 148.931, '-21,88400', '-50,95600', 419, 'S', 0.7230, NULL, NULL, '35091', 'N', 'N', 4248, NULL, '3590', '3590', NULL, '1959', 'S', 5245, 'SAGRES', 'N', '354470', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '504', NULL, '03', 'N', NULL, NULL, NULL, 322);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354480', '3515', 'SP', '3512', '3501', '35008', '35', 'SALES', NULL, '17', '14980000', '6', '6997', '6997', '21449', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 308.663, '-21,34100', '-49,48500', 448, 'S', 0.7700, NULL, NULL, '35151', 'N', 'N', 4251, NULL, '3590', '3590', NULL, '1959', 'S', 5246, 'SALES', 'N', '354480', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '505', NULL, '03', 'N', NULL, NULL, NULL, 382);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354490', '3508', 'SP', '3513', '3502', '35010', '35', 'SALES OLIVEIRA', NULL, '16', '14660000', '5', '6999', '6999', '21450', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 303.752, '-20,77200', '-47,83800', 730, 'S', 0.8190, NULL, NULL, '35082', 'N', 'N', 4252, NULL, '3590', '3590', NULL, '1944', 'S', 5247, 'SALES OLIVEIRA', 'N', '354490', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '506', NULL, '03', 'N', NULL, NULL, NULL, 271);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354510', '3509', 'SP', '3510', '3508', '35035', '35', 'SALMOURAO', NULL, '18', '17720000', '0', '7003', '7003', '21452', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 172.745, '-21,62400', '-50,86100', 461, 'S', 0.7340, NULL, NULL, '35091', 'N', 'N', 4265, NULL, '3590', '3590', NULL, '1959', 'S', 5249, 'SALMOURÃO', 'N', '354510', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '508', NULL, '03', 'N', NULL, NULL, NULL, 322);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354515', '3510', 'SP', '3514', '3506', '35028', '35', 'SALTINHO', NULL, '19', '13440000', '9', '5445', '5445', '21613', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 101.404, '-22,84700', '-47,67700', 595, 'S', 0.8510, NULL, NULL, '35103', 'N', 'N', 4267, NULL, '3590', '3590', NULL, '1993', 'S', 5250, 'SALTINHO', 'N', '354515', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '509', NULL, '03', 'N', NULL, NULL, NULL, 100);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354520', '3516', 'SP', '3508', '3512', '35046', '35', 'SALTO', NULL, '11', '13320000', '9', '7005', '7005', '21453', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 134.258, '-23,20100', '-47,28700', 555, 'S', 0.8090, NULL, NULL, '35163', 'N', 'N', 4269, NULL, '3590', '3513', NULL, '1889', 'S', 5251, 'SALTO', 'N', '354520', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '510', NULL, '01', 'N', NULL, NULL, NULL, 165);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354530', '3516', 'SP', '3508', '3512', '35046', '35', 'SALTO DE PIRAPORA', NULL, '15', '18160000', '8', '7007', '7007', '21454', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 280.312, '-23,64900', '-47,57300', 630, 'S', 0.7710, NULL, NULL, '35163', 'N', 'N', 4271, NULL, '3590', '3513', NULL, '1953', 'S', 5252, 'SALTO DE PIRAPORA', 'N', '354530', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '511', NULL, '03', 'N', NULL, NULL, NULL, 165);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354540', '3509', 'SP', '3510', '3510', '35040', '35', 'SALTO GRANDE', NULL, '14', '19920000', '7', '7009', '7009', '21455', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 189.072, '-22,89300', '-49,98600', 396, 'S', 0.7610, NULL, NULL, '35094', 'N', 'N', 4276, NULL, '3590', '3590', NULL, '1911', 'S', 5253, 'SALTO GRANDE', 'N', '354540', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '512', NULL, '03', 'N', NULL, NULL, NULL, 329);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354550', '3511', 'SP', '3511', '3508', '35036', '35', 'SANDOVALINA', NULL, '18', '19250000', '6', '7011', '7011', '21456', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 455.393, '-22,45600', '-51,76300', 424, 'S', 0.7730, NULL, NULL, '35112', 'N', 'N', 4287, NULL, '3590', '3590', NULL, '1959', 'S', 5254, 'SANDOVALINA', 'N', '354550', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '513', NULL, '03', 'N', NULL, NULL, NULL, 323);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354560', '3515', 'SP', '3512', '3501', '35005', '35', 'SANTA ADELIA', NULL, '17', '15950000', '5', '7013', '7013', '21457', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 331.015, '-21,24300', '-48,80400', 618, 'S', 0.7760, NULL, NULL, '35151', 'N', 'N', 4290, NULL, '3590', '3590', NULL, '1916', 'S', 5255, 'SANTA ADÉLIA', 'N', '354560', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '514', NULL, '03', 'N', NULL, NULL, NULL, 382);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270890', '2701', 'AL', '2701', '2703', '27011', '27', 'SATUBA', NULL, '82', '57120000', '7', '2877', '2877', '02089', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 42.559, '-9,56300', '-35,82400', 6, 'S', 0.7050, NULL, NULL, '27001', 'N', 'N', 4883, NULL, '2701', '2701', NULL, '1960', 'S', 116, 'SATUBA', 'N', '270890', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '95', NULL, '03', 'N', NULL, NULL, NULL, 44);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291350', '2914', 'BA', '2908', '2906', '29028', '29', 'IGUAI', NULL, '73', '45280000', '7', '3571', '3571', '04136', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 833.333, '-14,75600', '-40,08900', 352, 'S', 0.6180, NULL, NULL, '29083', 'S', 'N', 2131, NULL, '2990', '2990', NULL, '1952', 'S', 363, 'IGUAÍ', 'N', '291350', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '163', NULL, '03', 'N', NULL, NULL, NULL, 176);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354570', '3515', 'SP', '3512', '3501', '35001', '35', 'SANTA ALBERTINA', NULL, '17', '15750000', '4', '7015', '7015', '21458', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 274.277, '-20,03200', '-50,72800', 420, 'S', 0.7840, NULL, NULL, '35153', 'N', 'N', 4291, NULL, '3590', '3590', NULL, '1959', 'S', 5256, 'SANTA ALBERTINA', 'N', '354570', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '515', NULL, '03', 'N', NULL, NULL, NULL, 436);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354580', '3507', 'SP', '3515', '3507', '35032', '35', 'SANTA BARBARA D''OESTE', NULL, '19', '13450000', '3', '7017', '7017', '21459', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 271.492, '-22,75400', '-47,41400', 565, 'S', 0.8190, NULL, NULL, '35072', 'N', 'N', 4295, NULL, '3503', '3503', NULL, '1869', 'S', 5257, 'SANTA BÁRBARA D OESTE', 'N', '354580', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '516', NULL, '01', 'N', NULL, NULL, NULL, 515);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354600', '3517', 'SP', '3517', '3513', '35050', '35', 'SANTA BRANCA', NULL, '12', '12380000', '9', '7021', '7021', '21461', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 275.004, '-23,39700', '-45,88400', 648, 'S', 0.7960, NULL, NULL, '35171', 'N', 'N', 4302, NULL, '3590', '3501', NULL, '1856', 'S', 5258, 'SANTA BRANCA', 'N', '354600', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '517', NULL, '03', 'N', NULL, NULL, NULL, 324);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354610', '3515', 'SP', '3512', '3501', '35001', '35', 'SANTA CLARA D''OESTE', NULL, '17', '15785000', '8', '7023', '7023', '21462', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 183.399, '-20,08900', '-50,95400', 401, 'S', 0.7540, NULL, NULL, '35152', 'N', 'N', 4308, NULL, '3590', '3590', NULL, '1964', 'S', 5259, 'SANTA CLARA D OESTE', 'N', '354610', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '518', NULL, '03', 'N', NULL, NULL, NULL, 219);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354625', '3513', 'SP', '3514', '3502', '35015', '35', 'SANTA CRUZ DA ESPERANCA', NULL, '16', '14250000', '6', '0820', NULL, '21643', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 147.819, '-21,29100', '-47,43000', 612, 'S', 0.7940, NULL, NULL, '35133', 'N', 'N', 4316, NULL, '3590', '3590', NULL, '1997', 'S', 5261, 'SANTA CRUZ DA ESPERANÇA', 'N', '354625', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '520', NULL, '03', 'N', NULL, NULL, NULL, 166);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354630', '3514', 'SP', '3515', '3507', '35029', '35', 'SANTA CRUZ DAS PALMEIRAS', NULL, '19', '13650000', '6', '7027', '7027', '21464', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 295.698, '-21,82700', '-47,24900', 635, 'S', 0.7960, NULL, NULL, '35142', 'N', 'N', 4318, NULL, '3590', '3590', NULL, '1885', 'S', 5262, 'SANTA CRUZ DAS PALMEIRAS', 'N', '354630', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '521', NULL, '03', 'N', NULL, NULL, NULL, 328);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354660', '3515', 'SP', '3512', '3501', '35001', '35', 'SANTA FE DO SUL', NULL, '17', '15775000', '3', '7033', '7033', '21467', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 208.245, '-20,21100', '-50,92600', 370, 'S', 0.8090, NULL, NULL, '35152', 'N', 'N', 4336, NULL, '3590', '3590', NULL, '1953', 'S', 5265, 'SANTA FÉ DO SUL', 'N', '354660', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '524', NULL, '03', 'N', NULL, NULL, NULL, 219);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354670', '3510', 'SP', '3514', '3506', '35027', '35', 'SANTA GERTRUDES', NULL, '19', '13510000', '2', '7035', '7035', '21468', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 97.694, '-22,45700', '-47,53000', 595, 'S', 0.7820, NULL, NULL, '35104', 'N', 'N', 4340, NULL, '3590', '3590', NULL, '1948', 'S', 5266, 'SANTA GERTRUDES', 'N', '354670', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '525', NULL, '03', 'N', NULL, NULL, NULL, 43);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354700', '3510', 'SP', '3514', '3506', '35028', '35', 'SANTA MARIA DA SERRA', NULL, '19', '17370000', '7', '7041', '7041', '21471', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 256.481, '-22,56700', '-48,16100', 495, 'S', 0.7800, NULL, NULL, '35103', 'N', 'N', 4375, NULL, '3590', '3590', NULL, '1959', 'S', 5269, 'SANTA MARIA DA SERRA', 'N', '354700', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '528', NULL, '03', 'N', NULL, NULL, NULL, 100);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354710', '3511', 'SP', '3511', '3508', '35034', '35', 'SANTA MERCEDES', NULL, '18', '17940000', '6', '7043', '7043', '21472', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 166.868, '-21,35100', '-51,75500', 351, 'S', 0.7410, NULL, NULL, '35111', 'N', 'N', 4389, NULL, '3590', '3590', NULL, '1953', 'S', 5270, 'SANTA MERCEDES', 'N', '354710', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '529', NULL, '03', 'N', NULL, NULL, NULL, 431);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354720', '3515', 'SP', '3512', '3501', '35001', '35', 'SANTANA DA PONTE PENSA', NULL, '17', '15765000', '5', '7045', '7045', '21473', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 129.909, '-20,25300', '-50,79700', 426, 'S', 0.7530, NULL, NULL, '35153', 'N', 'N', 4439, NULL, '3590', '3590', NULL, '1964', 'S', 5275, 'SANTANA DA PONTE PENSA', 'N', '354720', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '534', NULL, '03', 'N', NULL, NULL, NULL, 436);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354740', '3515', 'SP', '3512', '3501', '35001', '35', 'SANTA RITA D''OESTE', NULL, '17', '15780000', '3', '7049', '7049', '21475', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 210.265, '-20,14300', '-50,83300', 400, 'S', 0.7520, NULL, NULL, '35152', 'N', 'N', 4395, NULL, '3590', '3590', NULL, '1964', 'S', 5272, 'SANTA RITA D OESTE', 'N', '354740', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '530', NULL, '03', 'N', NULL, NULL, NULL, 219);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354750', '3513', 'SP', '3514', '3502', '35014', '35', 'SANTA RITA DO PASSA QUATRO', NULL, '19', '13670000', '2', '7051', '7051', '21476', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 752.993, '-21,71000', '-47,47800', 748, 'S', 0.8320, NULL, NULL, '35132', 'N', 'N', 4405, NULL, '3590', '3590', NULL, '1885', 'S', 5271, 'SANTA RITA DO PASSA QUATRO', 'N', '354750', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '531', NULL, '03', 'N', NULL, NULL, NULL, 273);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354760', '3513', 'SP', '3514', '3502', '35014', '35', 'SANTA ROSA DE VITERBO', NULL, '16', '14270000', '1', '7053', '7053', '21477', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 289.669, '-21,47300', '-47,36300', 675, 'S', 0.8040, NULL, NULL, '35132', 'N', 'N', 4413, NULL, '3590', '3590', NULL, '1910', 'S', 5273, 'SANTA ROSA DE VITERBO', 'N', '354760', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '532', NULL, '03', 'N', NULL, NULL, NULL, 273);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354770', '3511', 'SP', '3511', '3508', '35036', '35', 'SANTO ANASTACIO', NULL, '18', '19360000', '0', '7055', '7055', '21478', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 552.546, '-21,97700', '-51,65200', 436, 'S', 0.7920, NULL, NULL, '35112', 'N', 'N', 4476, NULL, '3590', '3590', NULL, '1925', 'S', 5277, 'SANTO ANASTÁCIO', 'N', '354770', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '536', NULL, '03', 'N', NULL, NULL, NULL, 323);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354780', '3501', 'SP', '3501', '3515', '35061', '35', 'SANTO ANDRE', NULL, '11', '09001970', '9', '7057', '7057', '21479', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 174.840, '-23,66400', '-46,53800', 755, 'S', 0.8350, NULL, NULL, '35015', 'N', 'N', 4478, NULL, '3501', '3501', NULL, '1925', 'S', 5278, 'SANTO ANDRÉ', 'N', '354780', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '537', NULL, '01', 'N', NULL, NULL, NULL, 94);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354790', '3513', 'SP', '3514', '3502', '35015', '35', 'SANTO ANTONIO DA ALEGRIA', NULL, '16', '14390000', '8', '7059', '7059', '21480', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 309.677, '-21,08700', '-47,15100', 791, 'S', 0.7700, NULL, NULL, '35133', 'N', 'N', 4481, NULL, '3590', '3590', NULL, '1885', 'S', 5279, 'SANTO ANTÔNIO DA ALEGRIA', 'N', '354790', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '538', NULL, '03', 'N', NULL, NULL, NULL, 166);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354800', '3507', 'SP', '3515', '3507', '35031', '35', 'SANTO ANTONIO DE POSSE', NULL, '19', '13830000', '5', '7061', '7061', '21481', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 154.113, '-22,60600', '-46,91900', 695, 'S', 0.7900, NULL, NULL, '35072', 'N', 'N', 4490, NULL, '3503', '3503', NULL, '1953', 'S', 5280, 'SANTO ANTÔNIO DE POSSE', 'N', '354800', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '539', NULL, '01', 'N', NULL, NULL, NULL, 515);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354810', '3514', 'SP', '3515', '3507', '35030', '35', 'SANTO ANTONIO DO JARDIM', NULL, '19', '13995000', '4', '7063', '7063', '21482', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 109.449, '-22,11600', '-46,68000', 850, 'S', 0.7660, NULL, NULL, '35142', 'N', 'N', 4500, NULL, '3590', '3590', NULL, '1953', 'S', 5282, 'SANTO ANTÔNIO DO JARDIM', 'N', '354810', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '541', NULL, '03', 'N', NULL, NULL, NULL, 328);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354830', '3511', 'SP', '3511', '3508', '35036', '35', 'SANTO EXPEDITO', NULL, '18', '19190000', '2', '7067', '7067', '21484', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 93.913, '-21,85100', '-51,39200', 416, 'S', 0.7850, NULL, NULL, '35112', 'N', 'N', 4516, NULL, '3590', '3590', NULL, '1959', 'S', 5284, 'SANTO EXPEDITO', 'N', '354830', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '543', NULL, '03', 'N', NULL, NULL, NULL, 323);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354870', '3501', 'SP', '3501', '3515', '35061', '35', 'SAO BERNARDO DO CAMPO', NULL, '11', '09701970', '8', '7075', '7075', '21488', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 406.180, '-23,69400', '-46,56500', 762, 'S', 0.8340, NULL, NULL, '35015', 'N', 'N', 4539, NULL, '3501', '3501', NULL, '1944', 'S', 5288, 'SÃO BERNARDO DO CAMPO', 'N', '354870', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '547', NULL, '01', 'N', NULL, NULL, NULL, 94);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354880', '3501', 'SP', '3501', '3515', '35061', '35', 'SAO CAETANO DO SUL', NULL, '11', '09501970', '7', '7077', '7077', '21489', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 15.360, '-23,62300', '-46,55100', 744, 'S', 0.9190, NULL, NULL, '35015', 'N', 'N', 4546, NULL, '3501', '3501', NULL, '1948', 'S', 5289, 'SÃO CAETANO DO SUL', 'N', '354880', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '548', NULL, '01', 'N', NULL, NULL, NULL, 94);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354890', '3503', 'SP', '3513', '3505', '35025', '35', 'SAO CARLOS', NULL, '16', '13560970', '6', '7079', '7079', '21490', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1140.920, '-22,01800', '-47,89100', 854, 'S', 0.8410, NULL, NULL, '35034', 'N', 'N', 4549, NULL, '3590', '3505', NULL, '1865', 'S', 5290, 'SÃO CARLOS', 'N', '354890', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '549', NULL, '01', 'N', NULL, NULL, NULL, 434);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354900', '3515', 'SP', '3512', '3501', '35001', '35', 'SAO FRANCISCO', NULL, '17', '15710000', '3', '7081', '7081', '21491', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 75.317, '-20,35900', '-50,69700', 402, 'S', 0.7580, NULL, NULL, '35153', 'N', 'N', 4581, NULL, '3590', '3590', NULL, '1964', 'S', 5291, 'SÃO FRANCISCO', 'N', '354900', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '550', NULL, '03', 'N', NULL, NULL, NULL, 436);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354910', '3514', 'SP', '3515', '3507', '35030', '35', 'SAO JOAO DA BOA VISTA', NULL, '19', '13870000', '2', '7083', '7083', '21492', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 516.146, '-21,96900', '-46,79800', 767, 'S', 0.8430, NULL, NULL, '35142', 'N', 'N', 4631, NULL, '3590', '3590', NULL, '1859', 'S', 5292, 'SÃO JOÃO DA BOA VISTA', 'N', '354910', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '551', NULL, '02', 'N', NULL, NULL, NULL, 328);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354920', '3515', 'SP', '3512', '3501', '35002', '35', 'SAO JOAO DAS DUAS PONTES', NULL, '17', '15640000', '1', '7085', '7085', '21493', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 129.532, '-20,38900', '-50,37800', 427, 'S', 0.7540, NULL, NULL, '35154', 'N', 'N', 4642, NULL, '3590', '3590', NULL, '1964', 'S', 5293, 'SÃO JOÃO DAS DUAS PONTES', 'N', '354920', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '552', NULL, '03', 'N', NULL, NULL, NULL, 276);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354925', '3515', 'SP', '3512', '3501', '35006', '35', 'SAO JOAO DE IRACEMA', NULL, '17', '15315000', '0', '2941', '2941', '21615', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 177.906, '-20,51300', '-50,35200', 508, 'S', 0.7610, NULL, NULL, '35154', 'N', 'N', 4644, NULL, '3590', '3590', NULL, '1993', 'S', 5294, 'SÃO JOÃO DE IRACEMA', 'N', '354925', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '553', NULL, '03', 'N', NULL, NULL, NULL, 276);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354930', '3511', 'SP', '3511', '3508', '35034', '35', 'SAO JOAO DO PAU D''ALHO', NULL, '18', '17970000', '0', '7087', '7087', '21494', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 117.845, '-21,26800', '-51,66600', 354, 'S', 0.7540, NULL, NULL, '35111', 'N', 'N', 4663, NULL, '3590', '3590', NULL, '1959', 'S', 5295, 'SÃO JOÃO DO PAU D ALHO', 'N', '354930', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '554', NULL, '03', 'N', NULL, NULL, NULL, 431);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354940', '3508', 'SP', '3513', '3502', '35010', '35', 'SAO JOAQUIM DA BARRA', NULL, '16', '14600000', '9', '7089', '7089', '21495', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 412.271, '-20,58100', '-47,85500', 625, 'S', 0.8100, NULL, NULL, '35082', 'N', 'N', 4676, NULL, '3590', '3590', NULL, '1917', 'S', 5296, 'SÃO JOAQUIM DA BARRA', 'N', '354940', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '555', NULL, '03', 'N', NULL, NULL, NULL, 271);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354950', '3508', 'SP', '3513', '3502', '35012', '35', 'SAO JOSE DA BELA VISTA', NULL, '16', '14440000', '8', '7091', '7091', '21496', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 276.964, '-20,59300', '-47,64000', 730, 'S', 0.7530, NULL, NULL, '35081', 'N', 'N', 4685, NULL, '3590', '3590', NULL, '1948', 'S', 5297, 'SÃO JOSÉ DA BELA VISTA', 'N', '354950', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '556', NULL, '03', 'N', NULL, NULL, NULL, 101);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354960', '3517', 'SP', '3517', '3513', '35052', '35', 'SAO JOSE DO BARREIRO', NULL, '12', '12830000', '7', '7093', '7093', '21497', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 570.629, '-22,64500', '-44,57800', 510, 'S', 0.7270, NULL, NULL, '35172', 'N', 'N', 4705, NULL, '3590', '3590', NULL, '1859', 'S', 5298, 'SÃO JOSÉ DO BARREIRO', 'N', '354960', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '557', NULL, '03', 'N', NULL, NULL, NULL, 433);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231090', '2318', 'CE', '2303', '2304', '23021', '23', 'PIQUET CARNEIRO', NULL, '88', '63605000', '2', '1519', '1519', '05110', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 587.887, '-5,80400', '-39,41800', 251, 'S', 0.6220, NULL, NULL, '23900', 'S', 'N', 3774, NULL, '2390', '2390', NULL, '1957', 'S', 758, 'PIQUET CARNEIRO', 'N', '231090', 'N', 'S', 'S', NULL, 80, 'S', 'N', 'N', '142', NULL, '03', 'N', NULL, NULL, NULL, 108);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231095', '2311', 'CE', '2302', '2301', '23006', '23', 'PIRES FERREIRA', NULL, '88', '62255000', '1', '1269', '1269', '05164', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 242.189, '-4,24700', '-40,64500', 196, 'S', 0.6060, NULL, NULL, '23900', 'S', 'N', 3809, NULL, '2390', '2390', NULL, '1989', 'S', 759, 'PIRES FERREIRA', 'N', '231095', 'N', 'S', 'S', NULL, 49, 'N', 'N', 'N', '143', NULL, '03', 'N', NULL, NULL, NULL, 284);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231100', '2315', 'CE', '2302', '2301', '23006', '23', 'PORANGA', NULL, '88', '62220000', '9', '1521', '1521', '05111', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1309.274, '-4,74500', '-40,92600', 713, 'S', 0.5970, NULL, NULL, '23900', 'S', 'N', 3883, NULL, '2390', '2390', NULL, '1957', 'S', 760, 'PORANGA', 'N', '231100', 'N', 'S', 'S', NULL, 49, 'N', 'N', 'N', '144', NULL, '03', 'N', NULL, NULL, NULL, 285);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231110', '2319', 'CE', '2303', '2307', '23032', '23', 'PORTEIRAS', NULL, '88', '63270000', '8', '1523', '1523', '05112', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 217.570, '-7,53500', '-39,11800', 523, 'S', 0.6440, NULL, NULL, '23900', 'S', 'N', 3891, NULL, '2390', '2390', NULL, '1951', 'S', 761, 'PORTEIRAS', 'N', '231110', 'N', 'S', 'S', NULL, 131, 'N', 'N', 'N', '145', NULL, '03', 'N', NULL, NULL, NULL, 49);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231120', '2320', 'CE', '2303', '2307', '23029', '23', 'POTENGI', NULL, '88', '63160000', '7', '1525', '1525', '05113', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 338.723, '-7,09100', '-40,02700', 560, 'S', 0.5960, NULL, NULL, '23900', 'S', 'N', 3934, NULL, '2390', '2390', NULL, '1957', 'S', 762, 'POTENGI', 'N', '231120', 'N', 'S', 'S', NULL, 131, 'S', 'N', 'N', '146', NULL, '03', 'N', NULL, NULL, NULL, 339);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231123', '2310', 'CE', '2301', '2305', '23025', '23', 'POTIRETAMA', NULL, '88', '62990000', '1', '1271', '1271', '05165', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 409.238, '-5,66800', '-38,25100', 150, 'S', 0.6170, NULL, NULL, '23900', 'S', 'N', 3938, NULL, '2390', '2390', NULL, '1989', 'S', 763, 'POTIRETAMA', 'N', '231123', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '147', NULL, '03', 'N', NULL, NULL, NULL, 336);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231126', '2315', 'CE', '2302', '2304', '23018', '23', 'QUITERIANOPOLIS', NULL, '88', '63650000', '4', '9917', '9917', '05166', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 1040.955, '-5,84300', '-40,70100', 430, 'S', 0.6250, NULL, NULL, '23900', 'S', 'N', 4037, NULL, '2390', '2390', NULL, '1989', 'S', 764, 'QUITERIANÓPOLIS', 'N', '231126', 'N', 'S', 'S', NULL, 49, 'N', 'N', 'N', '148', NULL, '03', 'N', NULL, NULL, NULL, 285);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231130', '2308', 'CE', '2304', '2304', '23019', '23', 'QUIXADA', NULL, '88', '63900000', '6', '1527', '1527', '05114', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 2019.816, '-4,97100', '-39,01500', 189, 'S', 0.6730, NULL, NULL, '23900', 'N', 'N', 4041, NULL, '2390', '2390', NULL, '1870', 'S', 765, 'QUIXADÁ', 'N', '231130', 'N', 'S', 'S', NULL, 80, 'N', 'N', 'S', '149', NULL, '01', 'N', NULL, NULL, NULL, 51);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231135', '2318', 'CE', '2303', '2306', '23026', '23', 'QUIXELO', NULL, '88', '63515000', '5', '9853', '9853', '05151', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 559.760, '-6,25400', '-39,20200', 195, 'S', 0.5920, NULL, NULL, '23900', 'S', 'N', 4042, NULL, '2390', '2390', NULL, '1986', 'S', 766, 'QUIXELÔ', 'N', '231135', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '150', NULL, '03', 'N', NULL, NULL, NULL, 108);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354970', '3514', 'SP', '3515', '3507', '35030', '35', 'SAO JOSE DO RIO PARDO', NULL, '19', '13720000', '6', '7095', '7095', '21498', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 419.017, '-21,59600', '-46,88900', 705, 'S', 0.8150, NULL, NULL, '35143', 'N', 'N', 4729, NULL, '3590', '3590', NULL, '1885', 'S', 5299, 'SÃO JOSÉ DO RIO PARDO', 'N', '354970', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '558', NULL, '02', 'N', NULL, NULL, NULL, 279);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354980', '3515', 'SP', '3512', '3501', '35004', '35', 'SAO JOSE DO RIO PRETO', NULL, '17', '15001970', '5', '7097', '7097', '21499', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 431.307, '-20,82000', '-49,37900', 489, 'S', 0.8340, NULL, NULL, '35155', 'N', 'N', 4730, NULL, '3590', '3511', NULL, '1894', 'S', 5300, 'SÃO JOSÉ DO RIO PRETO', 'N', '354980', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '559', NULL, '01', 'N', NULL, NULL, NULL, 392);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354990', '3517', 'SP', '3517', '3513', '35050', '35', 'SAO JOSE DOS CAMPOS', NULL, '12', '12249000', '4', '7099', '7099', '21500', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1099.613, '-23,17900', '-45,88700', 600, 'S', 0.8490, NULL, NULL, '35171', 'N', 'N', 4737, NULL, '3590', '3512', NULL, '1767', 'S', 5301, 'SÃO JOSÉ DOS CAMPOS', 'N', '354990', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '560', NULL, '01', 'N', NULL, NULL, NULL, 324);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355020', '3516', 'SP', '3508', '3512', '35045', '35', 'SAO MIGUEL ARCANJO', NULL, '15', '18230000', '9', '7105', '7105', '21503', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 930.012, '-23,87800', '-47,99700', 659, 'S', 0.7690, NULL, NULL, '35161', 'N', 'N', 4773, NULL, '3590', '3590', NULL, '1889', 'S', 5305, 'SÃO MIGUEL ARCANJO', 'N', '355020', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '564', NULL, '03', 'N', NULL, NULL, NULL, 158);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355030', '3501', 'SP', '3506', '3515', '35061', '35', 'SAO PAULO', NULL, '11', '01051970', '8', '7107', '7107', '21504', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'S', NULL, 'S', 1522.986, '-23,54800', '-46,63600', 760, 'S', 0.8410, NULL, NULL, '35016', 'N', 'N', 4795, NULL, '3501', '3501', NULL, '1554', 'S', 5306, 'SÃO PAULO', 'N', '355030', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '565', NULL, '01', 'N', NULL, NULL, NULL, 280);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355040', '3510', 'SP', '3514', '3506', '35028', '35', 'SAO PEDRO', NULL, '19', '13520000', '7', '7109', '7109', '21505', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 618.204, '-22,54900', '-47,91400', 550, 'S', 0.7850, NULL, NULL, '35103', 'N', 'N', 4799, NULL, '3590', '3590', NULL, '1881', 'S', 5307, 'SÃO PEDRO', 'N', '355040', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '566', NULL, '03', 'N', NULL, NULL, NULL, 100);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355060', '3516', 'SP', '3508', '3512', '35046', '35', 'SAO ROQUE', NULL, '11', '18130000', '5', '7113', '7113', '21507', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 307.553, '-23,52900', '-47,13500', 771, 'S', 0.8200, NULL, NULL, '35163', 'N', 'N', 4823, NULL, '3590', '3513', NULL, '1832', 'S', 5309, 'SÃO ROQUE', 'N', '355060', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '568', NULL, '02', 'N', NULL, NULL, NULL, 165);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355070', '3517', 'SP', '3517', '3513', '35054', '35', 'SAO SEBASTIAO', NULL, '12', '11600000', '4', '7115', '7115', '21508', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 403.336, '-23,76000', '-45,41000', 1, 'S', 0.7980, NULL, NULL, '35173', 'N', 'N', 4828, NULL, '3590', '3590', NULL, '1636', 'S', 5310, 'SÃO SEBASTIÃO', 'N', '355070', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '569', NULL, '02', 'N', NULL, NULL, NULL, 437);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355080', '3514', 'SP', '3515', '3507', '35030', '35', 'SAO SEBASTIAO DA GRAMA', NULL, '19', '13790000', '3', '7117', '7117', '21509', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 252.181, '-21,71100', '-46,82100', 945, 'S', 0.7780, NULL, NULL, '35143', 'N', 'N', 4832, NULL, '3590', '3590', NULL, '1925', 'S', 5311, 'SÃO SEBASTIÃO DA GRAMA', 'N', '355080', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '570', NULL, '03', 'N', NULL, NULL, NULL, 279);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355090', '3513', 'SP', '3514', '3502', '35014', '35', 'SAO SIMAO', NULL, '16', '14200000', '2', '7119', '7119', '21510', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 617.964, '-21,47900', '-47,55100', 665, 'S', 0.8010, NULL, NULL, '35132', 'N', 'N', 4848, NULL, '3590', '3590', NULL, '1865', 'S', 5312, 'SÃO SIMÃO', 'N', '355090', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '571', NULL, '03', 'N', NULL, NULL, NULL, 273);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355110', '3516', 'SP', '3508', '3512', '35046', '35', 'SARAPUI', NULL, '15', '18225000', '8', '7123', '7123', '21512', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 354.463, '-23,64100', '-47,82500', 590, 'S', 0.7560, NULL, NULL, '35161', 'N', 'N', 4878, NULL, '3590', '3590', NULL, '1872', 'S', 5314, 'SARAPUÍ', 'N', '355110', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '573', NULL, '03', 'N', NULL, NULL, NULL, 158);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355120', '3506', 'SP', '3509', '3510', '35040', '35', 'SARUTAIA', NULL, '14', '18840000', '7', '7125', '7125', '21513', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 141.511, '-23,27300', '-49,48000', 756, 'S', 0.7190, NULL, NULL, '35061', 'N', 'N', 4880, NULL, '3590', '3590', NULL, '1959', 'S', 5315, 'SARUTAIÁ', 'N', '355120', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '574', NULL, '03', 'N', NULL, NULL, NULL, 102);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355130', '3515', 'SP', '3512', '3501', '35007', '35', 'SEBASTIANOPOLIS DO SUL', NULL, '17', '15180000', '6', '7127', '7127', '21514', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 168.114, '-20,65500', '-49,92100', 468, 'S', 0.7690, NULL, NULL, '35157', 'N', 'N', 4892, NULL, '3590', '3590', NULL, '1964', 'S', 5316, 'SEBASTIANÓPOLIS DO SUL', 'N', '355130', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '575', NULL, '03', 'N', NULL, NULL, NULL, 162);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355140', '3513', 'SP', '3514', '3502', '35014', '35', 'SERRA AZUL', NULL, '16', '14230000', '5', '7129', '7129', '21515', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 282.846, '-21,31100', '-47,56600', 610, 'S', 0.7420, NULL, NULL, '35132', 'N', 'N', 4935, NULL, '3590', '3590', NULL, '1927', 'S', 5317, 'SERRA AZUL', 'N', '355140', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '576', NULL, '03', 'N', NULL, NULL, NULL, 273);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355150', '3513', 'SP', '3514', '3502', '35014', '35', 'SERRANA', NULL, '16', '14150000', '4', '7131', '7131', '21516', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 125.744, '-21,21100', '-47,59600', 427, 'S', 0.7750, NULL, NULL, '35132', 'N', 'N', 4954, NULL, '3590', '3510', NULL, '1948', 'S', 5319, 'SERRANA', 'N', '355150', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '578', NULL, '03', 'N', NULL, NULL, NULL, 273);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355160', '3507', 'SP', '3515', '3507', '35033', '35', 'SERRA NEGRA', NULL, '19', '13930000', '3', '7133', '7133', '21517', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 203.010, '-22,61200', '-46,70100', 925, 'S', 0.8170, NULL, NULL, '35074', 'N', 'N', 4949, NULL, '3590', '3590', NULL, '1859', 'S', 5318, 'SERRA NEGRA', 'N', '355160', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '577', NULL, '03', 'N', NULL, NULL, NULL, 517);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355170', '3513', 'SP', '3514', '3502', '35014', '35', 'SERTAOZINHO', NULL, '16', '14160000', '2', '7135', '7135', '21518', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 402.803, '-21,13800', '-47,99000', 579, 'S', 0.8330, NULL, NULL, '35131', 'N', 'N', 4973, NULL, '3590', '3510', NULL, '1896', 'S', 5320, 'SERTÃOZINHO', 'N', '355170', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '579', NULL, '01', 'N', NULL, NULL, NULL, 383);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355180', '3512', 'SP', '3507', '3514', '35055', '35', 'SETE BARRAS', NULL, '13', '11910000', '1', '7137', '7137', '21519', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'S', NULL, 'N', 1052.106, '-24,38800', '-47,92600', 30, 'S', 0.7310, NULL, NULL, '35121', 'N', 'N', 4975, NULL, '3590', '3590', NULL, '1959', 'S', 5321, 'SETE BARRAS', 'N', '355180', 'N', 'N', 'S', NULL, 100, 'N', 'N', 'N', '580', NULL, '03', 'N', NULL, NULL, NULL, 222);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355200', '3517', 'SP', '3517', '3513', '35052', '35', 'SILVEIRAS', NULL, '12', '12690000', '7', '7141', '7141', '21521', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 414.698, '-22,66400', '-44,85300', 615, 'S', 0.7210, NULL, NULL, '35172', 'N', 'N', 4991, NULL, '3590', '3590', NULL, '1864', 'S', 5323, 'SILVEIRAS', 'N', '355200', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '582', NULL, '03', 'N', NULL, NULL, NULL, 433);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231230', '2313', 'CE', '2302', '2301', '23002', '23', 'SAO BENEDITO', NULL, '88', '62370000', '4', '1547', '1547', '05124', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 338.149, '-4,04900', '-40,86500', 901, 'S', 0.6180, NULL, NULL, '23900', 'N', 'N', 4524, NULL, '2390', '2390', NULL, '1872', 'S', 777, 'SÃO BENEDITO', 'N', '231230', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '161', NULL, '03', 'N', NULL, NULL, NULL, 171);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231240', '2302', 'CE', '2301', '2302', '23009', '23', 'SAO GONCALO DO AMARANTE', NULL, '85', '62670000', '3', '1549', '1549', '05125', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 834.394, '-3,60600', '-38,96900', 30, 'S', 0.6390, NULL, NULL, '23900', 'N', 'N', 4612, NULL, '2301', '2390', NULL, '1921', 'S', 778, 'SÃO GONÇALO DO AMARANTE', 'N', '231240', 'N', 'S', 'S', NULL, 51, 'N', 'N', 'N', '162', NULL, '01', 'N', NULL, NULL, NULL, 5);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231250', '2310', 'CE', '2301', '2305', '23023', '23', 'SAO JOAO DO JAGUARIBE', NULL, '88', '62965000', '2', '1551', '1551', '05126', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 280.436, '-5,27100', '-38,27400', 51, 'S', 0.6940, NULL, NULL, '23900', 'S', 'N', 4655, NULL, '2390', '2390', NULL, '1957', 'S', 779, 'SÃO JOÃO DO JAGUARIBE', 'N', '231250', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '163', NULL, '03', 'N', NULL, NULL, NULL, 336);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231260', '2302', 'CE', '2301', '2302', '23011', '23', 'SAO LUIS DO CURU', NULL, '85', '62665000', '1', '1553', '1553', '05127', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 122.420, '-3,67000', '-39,24300', 38, 'S', 0.6500, NULL, NULL, '23900', 'S', 'N', 4754, NULL, '2390', '2390', NULL, '1951', 'S', 780, 'SÃO LUÍS DO CURU', 'N', '231260', 'N', 'S', 'S', NULL, 51, 'N', 'N', 'N', '164', NULL, '03', 'N', NULL, NULL, NULL, 5);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231270', '2308', 'CE', '2304', '2304', '23021', '23', 'SENADOR POMPEU', NULL, '88', '63600000', '0', '1555', '1555', '05128', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1002.127, '-5,58800', '-39,37200', 177, 'S', 0.6180, NULL, NULL, '23900', 'S', 'N', 4915, NULL, '2390', '2390', NULL, '1896', 'S', 781, 'SENADOR POMPEU', 'N', '231270', 'N', 'S', 'S', NULL, 80, 'S', 'N', 'N', '165', NULL, '03', 'N', NULL, NULL, NULL, 51);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231280', '2311', 'CE', '2302', '2301', '23005', '23', 'SENADOR SA', NULL, '88', '62470000', '9', '1557', '1557', '05129', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 430.580, '-3,35100', '-40,46300', 87, 'S', 0.6000, NULL, NULL, '23900', 'S', 'N', 4917, NULL, '2390', '2390', NULL, '1957', 'S', 782, 'SENADOR SÁ', 'N', '231280', 'N', 'S', 'S', NULL, 86, 'N', 'N', 'N', '166', NULL, '03', 'N', NULL, NULL, NULL, 284);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231290', '2311', 'CE', '2302', '2301', '23005', '23', 'SOBRAL', NULL, '88', '62010305', '8', '1559', '1559', '05130', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 2122.989, '-3,67400', '-40,23900', 69, 'S', 0.6990, NULL, NULL, '23900', 'N', 'N', 5015, NULL, '2390', '2390', NULL, '1841', 'S', 783, 'SOBRAL', 'N', '231290', 'N', 'S', 'S', NULL, 86, 'N', 'N', 'S', '167', NULL, '01', 'N', NULL, NULL, NULL, 284);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231300', '2308', 'CE', '2304', '2304', '23021', '23', 'SOLONOPOLE', NULL, '88', '63620000', '5', '1561', '1561', '05131', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 1536.158, '-5,73300', '-39,00800', 155, 'S', 0.6400, NULL, NULL, '23900', 'S', 'N', 5024, NULL, '2390', '2390', NULL, '1935', 'S', 784, 'SOLONÓPOLE', 'N', '231300', 'N', 'S', 'S', NULL, 80, 'N', 'N', 'N', '168', NULL, '03', 'N', NULL, NULL, NULL, 51);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231310', '2310', 'CE', '2301', '2305', '23023', '23', 'TABULEIRO DO NORTE', NULL, '88', '62960000', '4', '1563', '1563', '05132', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 861.838, '-5,24700', '-38,13100', 39, 'S', 0.6980, NULL, NULL, '23900', 'S', 'N', 5056, NULL, '2390', '2390', NULL, '1957', 'S', 785, 'TABULEIRO DO NORTE', 'N', '231310', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '169', NULL, '03', 'N', NULL, NULL, NULL, 336);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260160', '2607', 'PE', '2604', '2602', '26006', '26', 'BELEM DE SAO FRANCISCO ', NULL, '87', '56440000', '7', '2331', '2331', '15016', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1830.807, '-8,75800', '-38,96400', 305, 'S', 0.6690, NULL, NULL, '26900', 'S', 'N', 575, NULL, '2690', '2690', NULL, '1928', 'S', 2795, 'BELÉM DE SÃO FRANCISCO', 'N', '260160', 'N', 'S', 'S', NULL, 118, 'N', 'N', 'N', '18', NULL, '03', 'N', NULL, NULL, NULL, 369);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260170', '2604', 'PE', '2602', '2603', '26008', '26', 'BELO JARDIM', NULL, '81', '55157020', '6', '2333', '2333', '15017', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 647.696, '-8,33600', '-36,42400', 608, 'S', 0.6250, NULL, NULL, '26008', 'N', 'N', 584, NULL, '2690', '2690', NULL, '1928', 'S', 2796, 'BELO JARDIM', 'N', '260170', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '19', NULL, '01', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260180', '2611', 'PE', '2603', '2601', '26004', '26', 'BETANIA', NULL, '87', '56670000', '5', '2335', '2335', '15018', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1244.071, '-8,27600', '-38,03400', 441, 'S', 0.5930, NULL, NULL, '26900', 'S', 'N', 609, NULL, '2690', '2690', NULL, '1958', 'S', 2797, 'BETÂNIA', 'N', '260180', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '20', NULL, '03', 'N', NULL, NULL, NULL, 261);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260190', '2604', 'PE', '2602', '2603', '26008', '26', 'BEZERROS', NULL, '81', '55660000', '4', '2337', '2337', '15019', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 492.556, '-8,23300', '-35,79700', 470, 'S', 0.6190, NULL, NULL, '26007', 'N', 'N', 612, NULL, '2690', '2690', NULL, '1870', 'S', 2798, 'BEZERROS', 'N', '260190', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '21', NULL, '02', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260200', '2609', 'PE', '2604', '2601', '26001', '26', 'BODOCO', NULL, '87', '56220000', '1', '2339', '2339', '15020', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1553.853, '-7,77800', '-39,94100', 443, 'S', 0.6110, NULL, NULL, '26900', 'N', 'N', 652, NULL, '2690', '2690', NULL, '1924', 'S', 2799, 'BODOCÓ', 'N', '260200', 'N', 'S', 'S', NULL, 81, 'S', 'N', 'N', '22', NULL, '03', 'N', NULL, NULL, NULL, 260);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260210', '2605', 'PE', '2602', '2603', '26011', '26', 'BOM CONSELHO', NULL, '87', '55330000', '0', '2341', '2341', '15021', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 786.195, '-9,17000', '-36,68000', 654, 'S', 0.5720, NULL, NULL, '26900', 'N', 'N', 656, NULL, '2690', '2690', NULL, '1860', 'S', 2800, 'BOM CONSELHO', 'N', '260210', 'N', 'S', 'S', NULL, 2, 'N', 'N', 'S', '23', NULL, '03', 'N', NULL, NULL, NULL, 257);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260220', '2602', 'PE', '2601', '2603', '26010', '26', 'BOM JARDIM', NULL, '81', '55730000', '9', '2343', '2343', '15022', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 222.883, '-7,79600', '-35,58700', 333, 'S', 0.6180, NULL, NULL, '26004', 'N', 'N', 660, NULL, '2690', '2690', NULL, '1870', 'S', 2801, 'BOM JARDIM', 'N', '260220', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '24', NULL, '03', 'N', NULL, NULL, NULL, 421);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260230', '2604', 'PE', '2602', '2603', '26012', '26', 'BONITO', NULL, '81', '55680000', '8', '2345', '2345', '15023', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 399.503, '-8,47000', '-35,72900', 443, 'S', 0.5930, NULL, NULL, '26007', 'N', 'N', 704, NULL, '2690', '2690', NULL, '1839', 'S', 2802, 'BONITO', 'N', '260230', 'N', 'S', 'S', NULL, 54, 'S', 'N', 'N', '25', NULL, '03', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260240', '2605', 'PE', '2602', '2603', '26011', '26', 'BREJAO', NULL, '87', '55325000', '7', '2347', '2347', '15024', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 159.791, '-9,03000', '-36,56900', 788, 'S', 0.5690, NULL, NULL, '26900', 'S', 'N', 750, NULL, '2690', '2690', NULL, '1958', 'S', 2803, 'BREJÃO', 'N', '260240', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '26', NULL, '03', 'N', NULL, NULL, NULL, 257);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260250', '2610', 'PE', '2603', '2601', '26003', '26', 'BREJINHO', NULL, '87', '56740000', '6', '2349', '2349', '15025', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 106.297, '-7,34900', '-37,28600', 737, 'S', 0.5860, NULL, NULL, '26900', 'S', 'N', 753, NULL, '2690', '2690', NULL, '1963', 'S', 2804, 'BREJINHO', 'N', '260250', 'N', 'S', 'S', NULL, 82, 'N', 'N', 'N', '27', NULL, '03', 'N', NULL, NULL, NULL, 256);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355240', '3507', 'SP', '3515', '3507', '35032', '35', 'SUMARE', NULL, '19', '13170970', '3', '7149', '7149', '21525', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 153.033, '-22,82200', '-47,26700', 583, 'S', 0.8000, NULL, NULL, '35072', 'N', 'N', 5040, NULL, '3503', '3503', NULL, '1953', 'S', 5327, 'SUMARÉ', 'N', '355240', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '586', NULL, '01', 'N', NULL, NULL, NULL, 515);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355260', '3515', 'SP', '3512', '3501', '35005', '35', 'TABAPUA', NULL, '17', '15880000', '1', '7153', '7153', '21527', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 345.603, '-20,96400', '-49,03200', 516, 'S', 0.7710, NULL, NULL, '35151', 'N', 'N', 5049, NULL, '3590', '3590', NULL, '1919', 'S', 5330, 'TABAPUÃ', 'N', '355260', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '589', NULL, '03', 'N', NULL, NULL, NULL, 382);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355290', '3511', 'SP', '3511', '3508', '35036', '35', 'TACIBA', NULL, '18', '19590000', '8', '7159', '7159', '21530', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 608.310, '-22,39000', '-51,28500', 416, 'S', 0.7680, NULL, NULL, '35112', 'N', 'N', 5060, NULL, '3590', '3590', NULL, '1953', 'S', 5333, 'TACIBA', 'N', '355290', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '592', NULL, '03', 'N', NULL, NULL, NULL, 323);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355300', '3506', 'SP', '3509', '3510', '35040', '35', 'TAGUAI', NULL, '14', '18890000', '5', '7161', '7161', '21531', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 145.800, '-23,45200', '-49,40900', 575, 'S', 0.7680, NULL, NULL, '35061', 'N', 'N', 5063, NULL, '3590', '3590', NULL, '1959', 'S', 5334, 'TAGUAÍ', 'N', '355300', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '593', NULL, '03', 'N', NULL, NULL, NULL, 102);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355330', '3514', 'SP', '3515', '3507', '35030', '35', 'TAMBAU', NULL, '19', '13710000', '2', '7167', '7167', '21534', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 561.566, '-21,70500', '-47,27400', 698, 'S', 0.7920, NULL, NULL, '35142', 'N', 'N', 5075, NULL, '3590', '3590', NULL, '1898', 'S', 5337, 'TAMBAÚ', 'N', '355330', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '596', NULL, '03', 'N', NULL, NULL, NULL, 328);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355340', '3515', 'SP', '3512', '3501', '35004', '35', 'TANABI', NULL, '17', '15170000', '1', '7169', '7169', '21535', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 745.233, '-20,62600', '-49,64900', 518, 'S', 0.7920, NULL, NULL, '35155', 'N', 'N', 5079, NULL, '3590', '3590', NULL, '1924', 'S', 5338, 'TANABI', 'N', '355340', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '597', NULL, '03', 'N', NULL, NULL, NULL, 392);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355350', '3516', 'SP', '3508', '3512', '35045', '35', 'TAPIRAI', NULL, '15', '18180000', '0', '7171', '7171', '21536', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 755.293, '-23,96400', '-47,50700', 875, 'S', 0.7380, NULL, NULL, '35163', 'N', 'N', 5100, NULL, '3590', '3590', NULL, '1959', 'S', 5339, 'TAPIRAÍ', 'N', '355350', 'N', 'N', 'S', NULL, 100, 'N', 'N', 'N', '598', NULL, '03', 'N', NULL, NULL, NULL, 165);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355360', '3514', 'SP', '3515', '3507', '35030', '35', 'TAPIRATIBA', NULL, '19', '13760000', '9', '7173', '7173', '21537', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 220.575, '-21,46800', '-46,74900', 760, 'S', 0.7920, NULL, NULL, '35143', 'N', 'N', 5102, NULL, '3590', '3590', NULL, '1928', 'S', 5340, 'TAPIRATIBA', 'N', '355360', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '599', NULL, '03', 'N', NULL, NULL, NULL, 279);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355380', '3506', 'SP', '3509', '3511', '35041', '35', 'TAQUARITUBA', NULL, '14', '18740000', '7', '7177', '7177', '21539', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 447.085, '-23,53300', '-49,24400', 618, 'S', 0.7410, NULL, NULL, '35061', 'N', 'N', 5112, NULL, '3590', '3590', NULL, '1925', 'S', 5343, 'TAQUARITUBA', 'N', '355380', 'N', 'N', 'S', NULL, 89, 'N', 'N', 'N', '602', NULL, '03', 'N', NULL, NULL, NULL, 102);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231320', '2315', 'CE', '2302', '2304', '23018', '23', 'TAMBORIL', NULL, '88', '63750000', '3', '1565', '1565', '05133', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 1961.634, '-4,83200', '-40,32100', 322, 'S', 0.6200, NULL, NULL, '23900', 'S', 'N', 5077, NULL, '2390', '2390', NULL, '1933', 'S', 786, 'TAMBORIL', 'N', '231320', 'N', 'S', 'S', NULL, 49, 'S', 'N', 'N', '170', NULL, '03', 'N', NULL, NULL, NULL, 285);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231330', '2314', 'CE', '2304', '2304', '23020', '23', 'TAUA', NULL, '88', '63660000', '2', '1567', '1567', '05134', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 4018.188, '-6,00300', '-40,29300', 402, 'S', 0.6650, NULL, NULL, '23900', 'N', 'N', 5124, NULL, '2390', '2390', NULL, '1929', 'S', 788, 'TAUÁ', 'N', '231330', 'N', 'S', 'S', NULL, 49, 'N', 'N', 'N', '172', NULL, '02', 'N', NULL, NULL, NULL, 337);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355385', '3516', 'SP', '3508', '3511', '35041', '35', 'TAQUARIVAI', NULL, '15', '18425000', '6', '3063', '3063', '21617', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 232.963, '-23,92400', '-48,69300', 555, 'S', 0.7020, NULL, NULL, '35162', 'N', 'N', 5113, NULL, '3590', '3590', NULL, '1993', 'S', 5344, 'TAQUARIVAÍ', 'N', '355385', 'N', 'N', 'S', NULL, 89, 'N', 'N', 'N', '603', NULL, '03', 'N', NULL, NULL, NULL, 159);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355390', '3511', 'SP', '3511', '3508', '35036', '35', 'TARABAI', NULL, '18', '19210000', '6', '7179', '7179', '21540', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 197.221, '-22,30300', '-51,55900', 445, 'S', 0.7630, NULL, NULL, '35112', 'N', 'N', 5116, NULL, '3590', '3590', NULL, '1959', 'S', 5345, 'TARABAI', 'N', '355390', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '604', NULL, '03', 'N', NULL, NULL, NULL, 323);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355395', '3509', 'SP', '3510', '3510', '35039', '35', 'TARUMA', NULL, '18', '19820000', '5', '7267', '7267', '21585', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 303.503, '-22,74700', '-50,57700', 441, 'S', 0.7750, NULL, NULL, '35092', 'N', 'N', 5120, NULL, '3590', '3590', NULL, '1993', 'S', 5346, 'TARUMÃ', 'N', '355395', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '605', NULL, '03', 'N', NULL, NULL, NULL, 274);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355400', '3516', 'SP', '3508', '3511', '35043', '35', 'TATUI', NULL, '15', '18270000', '3', '7181', '7181', '21541', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 524.156, '-23,35600', '-47,85700', 645, 'S', 0.7940, NULL, NULL, '35161', 'N', 'N', 5123, NULL, '3590', '3590', NULL, '1844', 'S', 5347, 'TATUÍ', 'N', '355400', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '606', NULL, '01', 'N', NULL, NULL, NULL, 158);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355430', '3511', 'SP', '3511', '3508', '35036', '35', 'TEODORO SAMPAIO', NULL, '18', '19280000', '0', '7187', '7187', '21544', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1556.670, '-22,53300', '-52,16800', 321, 'S', 0.7570, NULL, NULL, '35115', 'N', 'N', 5143, NULL, '3590', '3590', NULL, '1964', 'S', 5350, 'TEODORO SAMPAIO', 'N', '355430', 'N', 'N', 'S', NULL, 73, 'N', 'N', 'N', '609', NULL, '03', 'N', NULL, NULL, NULL, 331);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355450', '3516', 'SP', '3508', '3506', '35028', '35', 'TIETE', NULL, '15', '18530000', '8', '7191', '7191', '21546', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 392.509, '-23,10200', '-47,71500', 508, 'S', 0.8100, NULL, NULL, '35163', 'N', 'N', 5171, NULL, '3590', '3590', NULL, '1842', 'S', 5352, 'TIETÊ', 'N', '355450', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '611', NULL, '03', 'N', NULL, NULL, NULL, 165);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355490', '3515', 'SP', '3512', '3501', '35001', '35', 'TRES FRONTEIRAS', NULL, '17', '15770000', '4', '7199', '7199', '21550', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 152.698, '-20,23500', '-50,89000', 395, 'S', 0.7610, NULL, NULL, '35152', 'N', 'N', 5225, NULL, '3590', '3590', NULL, '1959', 'S', 5358, 'TRÊS FRONTEIRAS', 'N', '355490', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '617', NULL, '03', 'N', NULL, NULL, NULL, 219);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355495', '3507', 'SP', '3516', '3512', '35048', '35', 'TUIUTI', NULL, '11', '12930000', '3', '2955', '2955', '21618', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 126.465, '-22,81600', '-46,69400', 790, 'S', 0.7630, NULL, NULL, '35071', 'N', 'N', 5252, NULL, '3590', '3590', NULL, '1993', 'S', 5359, 'TUIUTI', 'N', '355495', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '618', NULL, '03', 'N', NULL, NULL, NULL, 275);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355500', '3509', 'SP', '3510', '3509', '35037', '35', 'TUPA', NULL, '14', '17600970', '0', '7201', '7201', '21551', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 629.108, '-21,93500', '-50,51400', 524, 'S', 0.8000, NULL, NULL, '35095', 'N', 'N', 5259, NULL, '3590', '3590', NULL, '1938', 'S', 5360, 'TUPÃ', 'N', '355500', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '619', NULL, '02', 'N', NULL, NULL, NULL, 221);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355510', '3511', 'SP', '3511', '3508', '35034', '35', 'TUPI PAULISTA', NULL, '18', '17930000', '9', '7203', '7203', '21552', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 244.646, '-21,38100', '-51,57100', 400, 'S', 0.7920, NULL, NULL, '35111', 'N', 'N', 5268, NULL, '3590', '3590', NULL, '1948', 'S', 5361, 'TUPI PAULISTA', 'N', '355510', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '620', NULL, '03', 'N', NULL, NULL, NULL, 431);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355530', '3515', 'SP', '3512', '3501', '35002', '35', 'TURMALINA', NULL, '17', '15755000', '7', '7207', '7207', '21554', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 147.356, '-20,05200', '-50,47600', 467, 'S', 0.7820, NULL, NULL, '35154', 'N', 'N', 5274, NULL, '3590', '3590', NULL, '1964', 'S', 5363, 'TURMALINA', 'N', '355530', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '622', NULL, '03', 'N', NULL, NULL, NULL, 276);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355535', '3515', 'SP', '3512', '3501', '35004', '35', 'UBARANA', NULL, '17', '15225000', '6', '2971', '2971', '21619', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 210.239, '-21,16600', '-49,71800', 458, 'S', 0.7520, NULL, NULL, '35156', 'N', 'N', 5292, NULL, '3590', '3590', NULL, '1993', 'S', 5364, 'UBARANA', 'N', '355535', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '623', NULL, '03', 'N', NULL, NULL, NULL, 160);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355540', '3517', 'SP', '3517', '3513', '35054', '35', 'UBATUBA', NULL, '12', '11680000', '6', '7209', '7209', '21555', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 712.116, '-23,43400', '-45,07100', 3, 'S', 0.7950, NULL, NULL, '35173', 'N', 'N', 5294, NULL, '3590', '3590', NULL, '1637', 'S', 5365, 'UBATUBA', 'N', '355540', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '624', NULL, '02', 'N', NULL, NULL, NULL, 437);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355550', '3509', 'SP', '3510', '3504', '35020', '35', 'UBIRAJARA', NULL, '14', '17440000', '5', '7211', '7211', '21556', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 283.326, '-22,52700', '-49,66300', 499, 'S', 0.7640, NULL, NULL, '35093', 'N', 'N', 5297, NULL, '3590', '3590', NULL, '1948', 'S', 5366, 'UBIRAJARA', 'N', '355550', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '625', NULL, '03', 'N', NULL, NULL, NULL, 96);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355560', '3515', 'SP', '3512', '3501', '35004', '35', 'UCHOA', NULL, '17', '15890000', '4', '7213', '7213', '21557', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 252.213, '-20,95300', '-49,17500', 485, 'S', 0.7500, NULL, NULL, '35155', 'N', 'N', 5300, NULL, '3590', '3590', NULL, '1925', 'S', 5367, 'UCHOA', 'N', '355560', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '626', NULL, '03', 'N', NULL, NULL, NULL, 392);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355570', '3515', 'SP', '3512', '3501', '35007', '35', 'UNIAO PAULISTA', NULL, '17', '15250000', '3', '7215', '7215', '21558', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 79.148, '-20,88700', '-49,89700', 480, 'S', 0.7770, NULL, NULL, '35156', 'N', 'N', 5323, NULL, '3590', '3590', NULL, '1964', 'S', 5368, 'UNIÃO PAULISTA', 'N', '355570', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '627', NULL, '03', 'N', NULL, NULL, NULL, 160);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355580', '3515', 'SP', '3512', '3501', '35001', '35', 'URANIA', NULL, '17', '15760000', '2', '7217', '7217', '21559', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 209.273, '-20,24600', '-50,64300', 458, 'S', 0.7650, NULL, NULL, '35153', 'N', 'N', 5329, NULL, '3590', '3590', NULL, '1959', 'S', 5369, 'URÂNIA', 'N', '355580', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '628', NULL, '03', 'N', NULL, NULL, NULL, 436);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355600', '3515', 'SP', '3512', '3501', '35008', '35', 'URUPES', NULL, '17', '15850000', '8', '7221', '7221', '21561', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 324.785, '-21,20200', '-49,29000', 436, 'S', 0.7950, NULL, NULL, '35151', 'N', 'N', 5348, NULL, '3590', '3590', NULL, '1928', 'S', 5371, 'URUPÊS', 'N', '355600', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '630', NULL, '03', 'N', NULL, NULL, NULL, 382);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355610', '3515', 'SP', '3512', '3501', '35003', '35', 'VALENTIM GENTIL', NULL, '17', '15520000', '7', '7223', '7223', '21562', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 149.208, '-20,42200', '-50,08800', 510, 'S', 0.7850, NULL, NULL, '35157', 'N', 'N', 5362, NULL, '3590', '3590', NULL, '1948', 'S', 5372, 'VALENTIM GENTIL', 'N', '355610', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '631', NULL, '03', 'N', NULL, NULL, NULL, 162);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355620', '3507', 'SP', '3515', '3507', '35032', '35', 'VALINHOS', NULL, '19', '13270000', '6', '7225', '7225', '21563', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 148.528, '-22,97100', '-46,99600', 660, 'S', 0.8420, NULL, NULL, '35072', 'N', 'N', 5363, NULL, '3503', '3503', NULL, '1953', 'S', 5373, 'VALINHOS', 'N', '355620', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '632', NULL, '01', 'N', NULL, NULL, NULL, 515);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355635', '3507', 'SP', '3516', '3512', '35048', '35', 'VARGEM', NULL, '11', '12935000', '4', '2957', '2957', '21565', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 142.596, '-22,88900', '-46,41400', 845, 'S', 0.7820, NULL, NULL, '35071', 'N', 'N', 5369, NULL, '3590', '3590', NULL, '1993', 'S', 5375, 'VARGEM', 'N', '355635', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '634', NULL, '03', 'N', NULL, NULL, NULL, 275);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355640', '3514', 'SP', '3515', '3507', '35030', '35', 'VARGEM GRANDE DO SUL', NULL, '19', '13880000', '4', '7231', '7231', '21566', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 266.530, '-21,83200', '-46,89400', 721, 'S', 0.8020, NULL, NULL, '35142', 'N', 'N', 5376, NULL, '3590', '3590', NULL, '1921', 'S', 5376, 'VARGEM GRANDE DO SUL', 'N', '355640', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '635', NULL, '03', 'N', NULL, NULL, NULL, 328);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355650', '3507', 'SP', '3516', '3512', '35047', '35', 'VARZEA PAULISTA', NULL, '11', '13220000', '3', '7233', '7233', '21567', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 34.627, '-23,21100', '-46,82800', 745, 'S', 0.7950, NULL, NULL, '35073', 'N', 'N', 5393, NULL, '3504', '3507', NULL, '1964', 'S', 5378, 'VÁRZEA PAULISTA', 'N', '355650', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '637', NULL, '01', 'N', NULL, NULL, NULL, 41);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355660', '3509', 'SP', '3510', '3509', '35038', '35', 'VERA CRUZ', NULL, '14', '17560000', '2', '7235', '7235', '21568', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 247.854, '-22,22000', '-49,81900', 628, 'S', 0.7580, NULL, NULL, '35093', 'N', 'N', 5406, NULL, '3590', '3590', NULL, '1934', 'S', 5379, 'VERA CRUZ', 'N', '355660', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '638', NULL, '03', 'N', NULL, NULL, NULL, 96);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355670', '3507', 'SP', '3515', '3507', '35032', '35', 'VINHEDO', NULL, '19', '13280000', '1', '7237', '7237', '21569', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 81.742, '-23,03000', '-46,97500', 725, 'S', 0.8570, NULL, NULL, '35072', 'N', 'N', 5458, NULL, '3503', '3503', NULL, '1948', 'S', 5380, 'VINHEDO', 'N', '355670', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '639', NULL, '01', 'N', NULL, NULL, NULL, 515);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355695', '3515', 'SP', '3512', '3501', '35001', '35', 'VITORIA BRASIL', NULL, '17', '15705000', '8', '0828', NULL, '21647', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 49.818, '-20,19700', '-50,48400', 505, 'S', 0.7470, NULL, NULL, '35153', 'N', 'N', 5474, NULL, '3590', '3590', NULL, '1997', 'S', 5383, 'VITÓRIA BRASIL', 'N', '355695', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '642', NULL, '03', 'N', NULL, NULL, NULL, 436);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355700', '3516', 'SP', '3508', '3512', '35046', '35', 'VOTORANTIM', NULL, '15', '18110000', '6', '7243', '7243', '21572', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 183.998, '-23,54700', '-47,43800', 570, 'S', 0.8140, NULL, NULL, '35163', 'N', 'N', 5485, NULL, '3590', '3513', NULL, '1964', 'S', 5384, 'VOTORANTIM', 'N', '355700', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '643', NULL, '01', 'N', NULL, NULL, NULL, 165);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355710', '3515', 'SP', '3512', '3501', '35003', '35', 'VOTUPORANGA', NULL, '17', '15500000', '5', '7245', '7245', '21573', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 421.686, '-20,42300', '-49,97300', 525, 'S', 0.8170, NULL, NULL, '35157', 'N', 'N', 5486, NULL, '3590', '3590', NULL, '1944', 'S', 5385, 'VOTUPORANGA', 'N', '355710', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '644', NULL, '02', 'N', NULL, NULL, NULL, 162);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170025', '1706', 'TO', '1790', '1701', '17003', '17', 'ABREULANDIA', NULL, '63', '77693000', '1', '0337', '0337', '28081', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1895.201, '-9,62100', '-49,15100', 245, 'S', 0.6670, NULL, NULL, '17900', 'S', 'N', 15, NULL, '1790', '1790', NULL, '1993', 'S', 5387, 'ABREULÂNDIA', 'N', '170025', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '1', NULL, '03', 'N', NULL, NULL, NULL, 216);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240375', '2402', 'RN', '2490', '2402', '24009', '24', 'FERNANDO PEDROZA', NULL, '84', '59517000', '6', '0416', NULL, '18154', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 322.540, '-5,69700', '-36,53100', 133, 'S', 0.6250, NULL, NULL, '24900', 'S', 'N', 1754, NULL, '2490', '2490', NULL, '1997', 'S', 3716, 'FERNANDO PEDROZA', 'N', '240375', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '41', NULL, '03', 'N', NULL, NULL, NULL, 37);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240380', '2404', 'RN', '2490', '2402', '24010', '24', 'FLORANIA', NULL, '84', '59335000', '6', '1675', '1675', '18038', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 504.022, '-6,12700', '-36,81800', 315, 'S', 0.6570, NULL, NULL, '24900', 'S', 'N', 1775, NULL, '2490', '2490', NULL, '1890', 'S', 3717, 'FLORÂNIA', 'N', '240380', 'N', 'S', 'S', NULL, 76, 'S', 'N', 'N', '42', NULL, '03', 'N', NULL, NULL, NULL, 83);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240390', '2406', 'RN', '2490', '2401', '24006', '24', 'FRANCISCO DANTAS', NULL, '84', '59902000', '5', '1677', '1677', '18039', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 181.593, '-6,07800', '-38,11900', 224, 'S', 0.6220, NULL, NULL, '24900', 'S', 'N', 1825, NULL, '2490', '2490', NULL, '1963', 'S', 3718, 'FRANCISCO DANTAS', 'N', '240390', 'N', 'S', 'S', NULL, 134, 'N', 'N', 'N', '43', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240400', '2406', 'RN', '2490', '2401', '24007', '24', 'FRUTUOSO GOMES', NULL, '84', '59890000', '2', '1751', '1751', '18076', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 63.278, '-6,15800', '-37,84000', 231, 'S', 0.6390, NULL, NULL, '24900', 'S', 'N', 1847, NULL, '2490', '2490', NULL, '1963', 'S', 3719, 'FRUTUOSO GOMES', 'N', '240400', 'N', 'S', 'S', NULL, 134, 'S', 'N', 'N', '44', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240410', '2403', 'RN', '2490', '2402', '24008', '24', 'GALINHOS', NULL, '84', '59596000', '1', '1679', '1679', '18040', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 342.442, '-5,09100', '-36,27500', 2, 'S', 0.6120, NULL, NULL, '24900', 'S', 'N', 1854, NULL, '2490', '2490', NULL, '1963', 'S', 3720, 'GALINHOS', 'N', '240410', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '45', NULL, '03', 'N', NULL, NULL, NULL, 84);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240420', '2401', 'RN', '2490', '2404', '24019', '24', 'GOIANINHA', NULL, '84', '59173000', '0', '1681', '1681', '18041', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 192.277, '-6,26700', '-35,21000', 19, 'S', 0.6510, NULL, NULL, '24900', 'S', 'N', 1904, NULL, '2490', '2490', NULL, '1832', 'S', 3721, 'GOIANINHA', 'N', '240420', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '46', NULL, '03', 'N', NULL, NULL, NULL, 148);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240430', '2402', 'RN', '2490', '2401', '24002', '24', 'GOVERNADOR DIX-SEPT ROSADO', NULL, '84', '59790000', '9', '1683', '1683', '18042', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1129.356, '-5,45900', '-37,52100', 26, 'S', 0.6370, NULL, NULL, '24900', 'S', 'N', 1920, NULL, '2490', '2490', NULL, '1963', 'S', 3722, 'GOVERNADOR DIX-SEPT ROSADO', 'N', '240430', 'N', 'S', 'S', NULL, 32, 'S', 'N', 'N', '47', NULL, '03', 'N', NULL, NULL, NULL, 147);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240440', '2402', 'RN', '2490', '2401', '24001', '24', 'GROSSOS', NULL, '84', '59675000', '8', '1685', '1685', '18043', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 126.451, '-4,98000', '-37,15500', 5, 'S', 0.6830, NULL, NULL, '24900', 'S', 'N', 1947, NULL, '2490', '2490', NULL, '1953', 'S', 3723, 'GROSSOS', 'N', '240440', 'N', 'S', 'S', NULL, 1, 'S', 'N', 'N', '48', NULL, '03', 'N', NULL, NULL, NULL, 147);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240450', '2403', 'RN', '2490', '2402', '24008', '24', 'GUAMARE', NULL, '84', '59598000', '7', '1687', '1687', '18044', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 259.181, '-5,10800', '-36,32000', 3, 'S', 0.6460, NULL, NULL, '24900', 'S', 'N', 1963, NULL, '2490', '2490', NULL, '1962', 'S', 3724, 'GUAMARÉ', 'N', '240450', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '49', NULL, '03', 'N', NULL, NULL, NULL, 84);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240460', '2403', 'RN', '2490', '2403', '24015', '24', 'IELMO MARINHO', NULL, '84', '59490000', '6', '1689', '1689', '18045', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 305.185, '-5,82400', '-35,55300', 65, 'S', 0.5900, NULL, NULL, '24900', 'S', 'N', 2112, NULL, '2490', '2490', NULL, '1963', 'S', 3725, 'IELMO MARINHO', 'N', '240460', 'N', 'S', 'S', NULL, 123, 'N', 'N', 'N', '50', NULL, '03', 'N', NULL, NULL, NULL, 84);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240470', '2402', 'RN', '2490', '2401', '24004', '24', 'IPANGUACU', NULL, '84', '59508000', '5', '1691', '1691', '18046', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 374.239, '-5,49800', '-36,85500', 16, 'S', 0.6130, NULL, NULL, '24900', 'S', 'N', 2195, NULL, '2490', '2490', NULL, '1948', 'S', 3726, 'IPANGUAÇU', 'N', '240470', 'N', 'S', 'S', NULL, 1, 'S', 'N', 'N', '51', NULL, '03', 'N', NULL, NULL, NULL, 37);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240480', '2404', 'RN', '2490', '2402', '24011', '24', 'IPUEIRA', NULL, '84', '59315000', '4', '1693', '1693', '18047', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 127.347, '-6,81400', '-37,19900', 217, 'S', 0.6910, NULL, NULL, '24900', 'S', 'N', 2223, NULL, '2490', '2490', NULL, '1963', 'S', 3727, 'IPUEIRA', 'N', '240480', 'N', 'S', 'S', NULL, 76, 'N', 'N', 'N', '52', NULL, '03', 'N', NULL, NULL, NULL, 83);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240485', '2402', 'RN', '2490', '2401', '24004', '24', 'ITAJA', NULL, '84', '59513000', '3', '0418', NULL, '18160', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 203.623, '-5,64400', '-36,87100', 55, 'S', 0.6350, NULL, NULL, '24900', 'S', 'N', 2299, NULL, '2490', '2490', NULL, '1997', 'S', 3728, 'ITAJÁ', 'N', '240485', 'N', 'S', 'S', NULL, 1, 'N', 'N', 'N', '53', NULL, '03', 'N', NULL, NULL, NULL, 37);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260280', '2606', 'PE', '2603', '2603', '26007', '26', 'BUIQUE', NULL, '87', '56520000', '3', '2355', '2355', '15028', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1345.124, '-8,62300', '-37,15600', 798, 'S', 0.5750, NULL, NULL, '26010', 'N', 'N', 783, NULL, '2690', '2690', NULL, '1854', 'S', 2807, 'BUÍQUE', 'N', '260280', 'N', 'S', 'S', NULL, 2, 'N', 'N', 'S', '30', NULL, '02', 'N', NULL, NULL, NULL, 138);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260290', '2601', 'PE', '2601', '2605', '26018', '26', 'CABO DE SANTO AGOSTINHO', NULL, '81', '54580000', '2', '2357', NULL, '15029', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 447.875, '-8,28700', '-35,03500', 29, 'S', 0.7070, NULL, NULL, '26003', 'N', 'N', 815, NULL, '2601', '2601', NULL, '1849', 'S', 2808, 'CABO DE SANTO AGOSTINHO', 'N', '260290', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '31', NULL, '01', 'N', NULL, NULL, NULL, 314);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170460', '1706', 'TO', '1790', '1701', '17004', '17', 'CHAPADA DE AREIA', NULL, '63', '77575000', '0', '0078', NULL, '28129', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 659.244, '-10,14400', '-49,14000', 240, 'S', 0.6960, NULL, NULL, '17900', 'S', 'N', 1231, NULL, '1790', '1790', NULL, '1997', 'S', 5422, 'CHAPADA DE AREIA', 'N', '170460', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '37', NULL, '03', 'N', NULL, NULL, NULL, 216);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170610', '1706', 'TO', '1790', '1701', '17004', '17', 'CRISTALANDIA', NULL, '63', '77490000', '0', '9323', '9323', '28025', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1848.231, '-10,60000', '-49,19300', 286, 'S', 0.7490, NULL, NULL, '17900', 'S', 'N', 1438, NULL, '1790', '1790', NULL, '1989', 'S', 5429, 'CRISTALÂNDIA', 'N', '170610', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '43', NULL, '03', 'N', NULL, NULL, NULL, 216);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170710', '1706', 'TO', '1790', '1701', '17003', '17', 'DIVINOPOLIS DO TOCANTINS', NULL, '63', '77670000', '8', '9719', '9719', '28027', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2347.421, '-9,80000', '-49,21400', 270, 'S', 0.6600, NULL, NULL, '17900', 'S', 'N', 1555, NULL, '1790', '1790', NULL, '1989', 'S', 5433, 'DIVINÓPOLIS DO TOCANTINS', 'N', '170710', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '47', NULL, '03', 'N', NULL, NULL, NULL, 216);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171250', '1706', 'TO', '1790', '1701', '17003', '17', 'MARIANOPOLIS DO TOCANTINS', NULL, '63', '77675000', '4', '9711', '9711', '28042', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2091.364, '-9,79600', '-49,65400', 146, 'S', 0.6950, NULL, NULL, '17900', 'S', 'N', 2920, NULL, '1790', '1790', NULL, '1989', 'S', 5459, 'MARIANÓPOLIS DO TOCANTINS', 'N', '171250', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '73', NULL, '03', 'N', NULL, NULL, NULL, 216);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171500', '1706', 'TO', '1790', '1701', '17004', '17', 'NOVA ROSALANDIA', NULL, '63', '77495000', '2', '9721', '9721', '28049', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 488.636, '-10,56700', '-48,91400', 255, 'S', 0.7090, NULL, NULL, '17900', 'S', 'N', 3330, NULL, '1790', '1790', NULL, '1989', 'S', 5471, 'NOVA ROSALÂNDIA', 'N', '171500', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '84', NULL, '03', 'N', NULL, NULL, NULL, 216);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171750', '1706', 'TO', '1790', '1701', '17004', '17', 'PIUM', NULL, '63', '77570000', '3', '9547', '9547', '28059', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 10012.666, '-10,44300', '-49,18200', 249, 'S', 0.6900, NULL, NULL, '17900', 'S', 'N', 3819, NULL, '1790', '1790', NULL, '1989', 'S', 5487, 'PIUM', 'N', '171750', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '101', NULL, '03', 'N', NULL, NULL, NULL, 216);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171845', '1706', 'TO', '1790', '1701', '17004', '17', 'PUGMIL', NULL, '63', '77603000', '1', '0094', '0094', '28137', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 401.689, '-10,42400', '-48,89400', 340, 'S', 0.6710, NULL, NULL, '17900', 'S', 'N', 4002, NULL, '1790', '1790', NULL, '1997', 'S', 5494, 'PUGMIL', 'N', '171845', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '108', NULL, '03', 'N', NULL, NULL, NULL, 216);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310800', '3115', 'MG', '3105', '3109', '31046', '31', 'BOM SUCESSO', NULL, '35', '37220000', '8', '4159', '4159', '11080', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 706.192, '-21,03300', '-44,75800', 952, 'S', 0.7540, NULL, NULL, '31033', 'N', 'N', 691, NULL, '3190', '3190', NULL, '1872', 'S', 1440, 'BOM SUCESSO', 'N', '310800', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '85', NULL, '03', 'N', NULL, NULL, NULL, 114);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291970', '2914', 'BA', '2908', '2906', '29029', '29', 'MACARANI', NULL, '77', '45760000', '2', '3695', '3695', '04198', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1371.657, '-15,56800', '-40,42300', 324, 'S', 0.6370, NULL, NULL, '29083', 'S', 'N', 2798, NULL, '2990', '2990', NULL, '1939', 'S', 436, 'MACARANI', 'N', '291970', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '237', NULL, '03', 'N', NULL, NULL, NULL, 176);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330115', '3308', 'RJ', '3390', '3302', '33003', '33', 'CARDOSO MOREIRA', NULL, '22', '28180000', '7', '2915', '2915', '17071', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 514.882, '-21,48800', '-41,61600', 22, 'S', 0.7060, NULL, NULL, '33900', 'N', 'N', 1093, NULL, '3390', '3390', NULL, '1993', 'S', 3600, 'CARDOSO MOREIRA', 'N', '330115', 'N', 'N', 'S', NULL, 65, 'N', 'N', 'N', '18', NULL, '03', 'N', NULL, NULL, NULL, 36);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430810', '4305', 'RS', '4305', '4305', '43023', '43', 'FELIZ', NULL, '51', '95770000', '2', '8659', '8659', '19080', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 96.232, '-29,45100', '-51,30600', 68, 'S', 0.8390, NULL, NULL, '43900', 'N', 'N', 1746, NULL, '4390', '4390', NULL, '1959', 'S', 4060, 'FELIZ', 'N', '430810', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '166', NULL, '03', 'N', NULL, NULL, NULL, 482);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220672', '2204', 'PI', '2203', '2202', '22003', '22', 'NAZARIA', NULL, '86', '64040990', '0', '1180', NULL, NULL, NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', NULL, 'N', 'S', 'N', NULL, 'N', NULL, '-5,08900', '-42,80200', 72, 'S', NULL, NULL, NULL, '22900', 'N', 'N', 12111, NULL, '2201', '2201', NULL, '2009', 'S', NULL, 'NAZÁRIA', 'N', '220672', 'N', NULL, 'S', '', NULL, 'N', 'N', 'N', '137', NULL, NULL, 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510454', '5114', 'MT', '5190', '5101', '51006', '51', 'ITANHANGA', NULL, '65', '78579000', NULL, '1186', NULL, NULL, NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, '-12,17200', '-56,68000', NULL, 'S', NULL, NULL, NULL, '51900', NULL, NULL, NULL, NULL, '5190', '5190', NULL, '2005', 'S', 5590, 'ITANHANGÁ', 'N', '510454', 'S', 'N', 'S', '', NULL, 'N', 'N', 'N', '52', NULL, '03', 'N', NULL, NULL, NULL, 248);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240490', '2406', 'RN', '2490', '2401', '24006', '24', 'ITAU', NULL, '84', '59855000', '3', '1695', '1695', '18048', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 133.032, '-5,84000', '-37,99300', 143, 'S', 0.6750, NULL, NULL, '24900', 'S', 'N', 2392, NULL, '2490', '2490', NULL, '1953', 'S', 3729, 'ITAÚ', 'N', '240490', 'N', 'S', 'S', NULL, 32, 'S', 'N', 'N', '54', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260300', '2608', 'PE', '2604', '2602', '26005', '26', 'CABROBO', NULL, '87', '56180000', '9', '2359', '2359', '15030', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'S', NULL, 'N', 1658.075, '-8,51200', '-39,30700', 325, 'S', 0.6770, NULL, NULL, '26900', 'S', 'N', 820, NULL, '2690', '2690', NULL, '1928', 'S', 2809, 'CABROBÓ', 'N', '260300', 'N', 'S', 'S', NULL, 83, 'N', 'N', 'N', '32', NULL, '03', 'N', NULL, NULL, NULL, 313);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260310', '2604', 'PE', '2602', '2603', '26008', '26', 'CACHOEIRINHA', NULL, '81', '55380000', '8', '2361', '2361', '15031', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 179.268, '-8,48600', '-36,23300', 536, 'S', 0.6420, NULL, NULL, '26008', 'S', 'N', 842, NULL, '2690', '2690', NULL, '1958', 'S', 2810, 'CACHOEIRINHA', 'N', '260310', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '33', NULL, '03', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260320', '2605', 'PE', '2602', '2603', '26011', '26', 'CAETES', NULL, '87', '55360000', '7', '2363', '2363', '15032', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 330.472, '-8,77300', '-36,62300', 849, 'S', 0.5210, NULL, NULL, '26900', 'S', 'N', 859, NULL, '2690', '2690', NULL, '1963', 'S', 2811, 'CAETÉS', 'N', '260320', 'N', 'S', 'S', NULL, 2, 'N', 'N', 'N', '34', NULL, '03', 'N', NULL, NULL, NULL, 257);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260330', '2605', 'PE', '2602', '2603', '26011', '26', 'CALCADO', NULL, '87', '55375000', '6', '2365', '2365', '15033', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 114.440, '-8,74200', '-36,33400', 643, 'S', 0.5820, NULL, NULL, '26900', 'S', 'N', 891, NULL, '2690', '2690', NULL, '1963', 'S', 2812, 'CALÇADO', 'N', '260330', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '35', NULL, '03', 'N', NULL, NULL, NULL, 257);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260340', '2611', 'PE', '2603', '2601', '26003', '26', 'CALUMBI', NULL, '87', '56930000', '5', '2367', '2367', '15034', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 221.038, '-7,94100', '-38,15000', 446, 'S', 0.5800, NULL, NULL, '26900', 'S', 'N', 901, NULL, '2690', '2690', NULL, '1963', 'S', 2813, 'CALUMBI', 'N', '260340', 'N', 'S', 'S', NULL, 82, 'N', 'N', 'N', '36', NULL, '03', 'N', NULL, NULL, NULL, 261);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260345', '2601', 'PE', '2601', '2605', '26017', '26', 'CAMARAGIBE', NULL, '81', '54759970', '4', '2629', '2629', '15168', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 55.083, '-8,02200', '-34,98100', 55, 'S', 0.7470, NULL, NULL, '26002', 'N', 'N', 910, NULL, '2601', '2601', NULL, '1982', 'S', 2814, 'CAMARAGIBE', 'N', '260345', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '37', NULL, '01', 'N', NULL, NULL, NULL, 314);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260350', '2604', 'PE', '2602', '2603', '26012', '26', 'CAMOCIM DE SAO FELIX', NULL, '81', '55665000', '4', '2369', '2369', '15035', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 53.576, '-8,35900', '-35,76200', 691, 'S', 0.6260, NULL, NULL, '26007', 'S', 'N', 922, NULL, '2690', '2690', NULL, '1953', 'S', 2815, 'CAMOCIM DE SÃO FÉLIX', 'N', '260350', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '38', NULL, '03', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260360', '2612', 'PE', '2601', '2604', '26013', '26', 'CAMUTANGA', NULL, '81', '55930000', '3', '2371', '2371', '15036', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 37.297, '-7,40700', '-35,27400', 98, 'S', 0.6320, NULL, NULL, '26900', 'S', 'N', 986, NULL, '2690', '2690', NULL, '1963', 'S', 2816, 'CAMUTANGA', 'N', '260360', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '39', NULL, '03', 'N', NULL, NULL, NULL, 259);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260370', '2605', 'PE', '2602', '2603', '26011', '26', 'CANHOTINHO', NULL, '87', '55420000', '2', '2373', '2373', '15037', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 423.075, '-8,88200', '-36,19100', 520, 'S', 0.5880, NULL, NULL, '26900', 'S', 'N', 1019, NULL, '2690', '2690', NULL, '1890', 'S', 2817, 'CANHOTINHO', 'N', '260370', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '40', NULL, '03', 'N', NULL, NULL, NULL, 257);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260380', '2605', 'PE', '2602', '2603', '26008', '26', 'CAPOEIRAS', NULL, '87', '55365000', '1', '2375', '2375', '15038', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 335.258, '-8,73500', '-36,62700', 888, 'S', 0.5930, NULL, NULL, '26900', 'S', 'N', 1068, NULL, '2690', '2690', NULL, '1963', 'S', 2818, 'CAPOEIRAS', 'N', '260380', 'N', 'S', 'S', NULL, 2, 'S', 'N', 'N', '41', NULL, '03', 'N', NULL, NULL, NULL, 257);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260390', '2610', 'PE', '2603', '2601', '26003', '26', 'CARNAIBA', NULL, '87', '56820000', '0', '2377', '2377', '15039', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 436.981, '-7,80500', '-37,79400', 485, 'S', 0.5830, NULL, NULL, '26900', 'S', 'N', 1123, NULL, '2690', '2690', NULL, '1953', 'S', 2819, 'CARNAÍBA', 'N', '260390', 'N', 'S', 'S', NULL, 82, 'N', 'N', 'N', '42', NULL, '03', 'N', NULL, NULL, NULL, 256);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260392', '2611', 'PE', '2603', '2602', '26006', '26', 'CARNAUBEIRA DA PENHA', NULL, '87', '56420000', '6', '2635', '2635', '15170', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'S', NULL, 'N', 1010.171, '-8,32200', '-38,74400', 446, 'S', 0.5370, NULL, NULL, '26900', 'S', 'N', 1127, NULL, '2690', '2690', NULL, '1993', 'S', 2820, 'CARNAUBEIRA DA PENHA', 'N', '260392', 'N', 'S', 'S', NULL, 118, 'N', 'N', 'N', '43', NULL, '03', 'N', NULL, NULL, NULL, 261);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260400', '2602', 'PE', '2601', '2604', '26013', '26', 'CARPINA', NULL, '81', '55815110', '7', '2379', '2379', '15040', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 146.124, '-7,85100', '-35,25500', 184, 'S', 0.7240, NULL, NULL, '26005', 'N', 'N', 1132, NULL, '2690', '2690', NULL, '1928', 'S', 2821, 'CARPINA', 'N', '260400', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '44', NULL, '02', 'N', NULL, NULL, NULL, 421);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260410', '2604', 'PE', '2602', '2603', '26008', '26', 'CARUARU', NULL, '81', '55000000', '6', '2381', '2381', '15041', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 920.610, '-8,28300', '-35,97600', 554, 'S', 0.7130, NULL, NULL, '26006', 'N', 'N', 1136, NULL, '2690', '2602', NULL, '1848', 'S', 2822, 'CARUARU', 'N', '260410', 'N', 'S', 'S', NULL, NULL, 'N', 'S', 'S', '45', NULL, '01', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260415', '2602', 'PE', '2601', '2603', '26009', '26', 'CASINHAS', NULL, '81', '55755000', '5', '0546', NULL, '15180', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 125.282, '-7,74100', '-35,72100', 0, 'S', 0.5880, NULL, NULL, '26004', 'S', 'N', 1150, NULL, '2690', '2690', NULL, '1997', 'S', 2823, 'CASINHAS', 'N', '260415', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '46', NULL, '03', 'N', NULL, NULL, NULL, 421);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260420', '2603', 'PE', '2601', '2604', '26015', '26', 'CATENDE', NULL, '81', '55400000', '5', '2383', '2383', '15042', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 206.923, '-8,66700', '-35,71700', 168, 'S', 0.6440, NULL, NULL, '26900', 'N', 'N', 1172, NULL, '2690', '2690', NULL, '1928', 'S', 2824, 'CATENDE', 'N', '260420', 'N', 'S', 'S', NULL, 54, 'S', 'N', 'N', '47', NULL, '03', 'N', NULL, NULL, NULL, 368);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260430', '2607', 'PE', '2604', '2601', '26002', '26', 'CEDRO', NULL, '87', '56130000', '4', '2385', '2385', '15043', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 144.085, '-7,72200', '-39,23900', 546, 'S', 0.6720, NULL, NULL, '26900', 'S', 'N', 1195, NULL, '2690', '2690', NULL, '1963', 'S', 2825, 'CEDRO', 'N', '260430', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '48', NULL, '03', 'N', NULL, NULL, NULL, 369);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260440', '2601', 'PE', '2601', '2604', '26014', '26', 'CHA DE ALEGRIA', NULL, '81', '55835000', '3', '2387', '2387', '15044', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 48.453, '-8,00100', '-35,21300', 160, 'S', 0.6290, NULL, NULL, '26002', 'S', 'N', 1224, NULL, '2690', '2690', NULL, '1963', 'S', 2826, 'CHÃ DE ALEGRIA', 'N', '260440', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '49', NULL, '03', 'N', NULL, NULL, NULL, 314);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260450', '2601', 'PE', '2601', '2604', '26014', '26', 'CHA GRANDE', NULL, '81', '55636000', '2', '2389', '2389', '15045', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 70.192, '-8,23800', '-35,46200', 470, 'S', 0.6120, NULL, NULL, '26002', 'S', 'N', 1225, NULL, '2690', '2690', NULL, '1963', 'S', 2827, 'CHÃ GRANDE', 'N', '260450', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '50', NULL, '03', 'N', NULL, NULL, NULL, 314);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260460', '2612', 'PE', '2601', '2604', '26013', '26', 'CONDADO', NULL, '81', '55940000', '1', '2391', '2391', '15046', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 89.643, '-7,58600', '-35,10600', 129, 'S', 0.6270, NULL, NULL, '26900', 'S', 'N', 1333, NULL, '2690', '2690', NULL, '1958', 'S', 2828, 'CONDADO', 'N', '260460', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '51', NULL, '03', 'N', NULL, NULL, NULL, 259);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260470', '2605', 'PE', '2602', '2603', '26011', '26', 'CORRENTES', NULL, '87', '55315000', '0', '2393', '2393', '15047', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 339.303, '-9,12900', '-36,33000', 391, 'S', 0.5870, NULL, NULL, '26900', 'S', 'N', 1401, NULL, '2690', '2690', NULL, '1879', 'S', 2829, 'CORRENTES', 'N', '260470', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '52', NULL, '03', 'N', NULL, NULL, NULL, 257);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260480', '2603', 'PE', '2601', '2604', '26015', '26', 'CORTES', NULL, '81', '55525000', '9', '2395', '2395', '15048', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 101.332, '-8,47000', '-35,54100', 302, 'S', 0.5820, NULL, NULL, '26900', 'S', 'N', 1403, NULL, '2690', '2690', NULL, '1953', 'S', 2830, 'CORTÊS', 'N', '260480', 'N', 'S', 'S', NULL, 54, 'N', 'N', 'N', '53', NULL, '03', 'N', NULL, NULL, NULL, 368);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260500', '2604', 'PE', '2602', '2603', '26012', '26', 'CUPIRA', NULL, '81', '55460000', '4', '2399', '2399', '15050', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 105.924, '-8,61700', '-35,95000', 416, 'S', 0.6060, NULL, NULL, '26006', 'S', 'N', 1484, NULL, '2690', '2690', NULL, '1953', 'S', 2832, 'CUPIRA', 'N', '260500', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '55', NULL, '03', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260510', '2606', 'PE', '2603', '2601', '26004', '26', 'CUSTODIA', NULL, '87', '56640000', '3', '2401', '2401', '15051', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1404.100, '-8,08800', '-37,64300', 542, 'S', 0.6530, NULL, NULL, '26010', 'S', 'N', 1503, NULL, '2690', '2690', NULL, '1928', 'S', 2833, 'CUSTÓDIA', 'N', '260510', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '56', NULL, '03', 'N', NULL, NULL, NULL, 138);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260515', '2608', 'PE', '2604', '2602', '26005', '26', 'DORMENTES', NULL, '87', '56355000', '2', '2299', '2299', '15171', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1537.588, '-8,44700', '-40,77100', 492, 'S', 0.6000, NULL, NULL, '26900', 'S', 'N', 1596, NULL, '2690', '2690', NULL, '1993', 'S', 2834, 'DORMENTES', 'N', '260515', 'N', 'S', 'S', NULL, 83, 'N', 'N', 'N', '57', NULL, '03', 'N', NULL, NULL, NULL, 313);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260520', '2603', 'PE', '2601', '2604', '26015', '26', 'ESCADA', NULL, '81', '55500000', '2', '2403', '2403', '15052', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 347.197, '-8,35900', '-35,22400', 109, 'S', 0.6450, NULL, NULL, '26900', 'N', 'N', 1669, NULL, '2690', '2690', NULL, '1854', 'S', 2835, 'ESCADA', 'N', '260520', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '58', NULL, '02', 'N', NULL, NULL, NULL, 368);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260530', '2609', 'PE', '2604', '2601', '26001', '26', 'EXU', NULL, '87', '56230000', '1', '2405', '2405', '15053', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1473.958, '-7,51200', '-39,72400', 523, 'S', 0.5920, NULL, NULL, '26900', 'N', 'N', 1713, NULL, '2690', '2690', NULL, '1907', 'S', 2836, 'EXU', 'N', '260530', 'N', 'S', 'S', NULL, 81, 'S', 'N', 'N', '59', NULL, '03', 'N', NULL, NULL, NULL, 260);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510452', '5114', 'MT', '5190', '5101', '51006', '51', 'IPIRANGA DO NORTE', NULL, '65', '78578000', NULL, '1184', NULL, NULL, NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, '-12,24100', '-56,14600', NULL, 'S', NULL, NULL, NULL, '51900', NULL, NULL, NULL, NULL, '5190', '5190', NULL, '2005', 'S', 5589, 'IPIRANGA DO NORTE', 'N', '510452', 'S', 'N', 'S', '', NULL, 'N', 'N', 'N', '51', NULL, '03', 'N', NULL, NULL, NULL, 248);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260540', '2602', 'PE', '2601', '2603', '26010', '26', 'FEIRA NOVA', NULL, '81', '55715000', '0', '2407', '2407', '15054', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 107.745, '-7,95100', '-35,38900', 154, 'S', 0.6060, NULL, NULL, '26004', 'S', 'N', 1740, NULL, '2690', '2690', NULL, '1963', 'S', 2837, 'FEIRA NOVA', 'N', '260540', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '60', NULL, '03', 'N', NULL, NULL, NULL, 421);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260545', '2601', 'PE', '2601', '2605', '26019', '26', 'FERNANDO DE NORONHA', NULL, '81', '53990000', '9', '', '3001', '15187', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 16.987, '-3,84000', '-32,41100', 38, 'S', 0.8620, NULL, NULL, '26001', 'N', 'N', 1752, NULL, '2690', '2690', NULL, '1989', 'S', 2838, 'FERNANDO DE NORONHA', 'N', '260545', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '61', NULL, '03', 'N', NULL, NULL, NULL, 314);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260550', '2612', 'PE', '2601', '2604', '26013', '26', 'FERREIROS', NULL, '81', '55880000', '9', '2409', '2409', '15055', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 92.103, '-7,44800', '-35,24400', 96, 'S', 0.6290, NULL, NULL, '26900', 'S', 'N', 1760, NULL, '2690', '2690', NULL, '1963', 'S', 2839, 'FERREIROS', 'N', '260550', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '62', NULL, '03', 'N', NULL, NULL, NULL, 259);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260560', '2611', 'PE', '2603', '2601', '26003', '26', 'FLORES', NULL, '87', '56850000', '8', '2411', '2411', '15056', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 953.846, '-7,86600', '-37,97500', 466, 'S', 0.6130, NULL, NULL, '26900', 'S', 'N', 1777, NULL, '2690', '2690', NULL, '1858', 'S', 2840, 'FLORES', 'N', '260560', 'N', 'S', 'S', NULL, 82, 'N', 'N', 'N', '63', NULL, '03', 'N', NULL, NULL, NULL, 261);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260570', '2611', 'PE', '2603', '2602', '26006', '26', 'FLORESTA', NULL, '87', '56400000', '7', '2413', '2413', '15057', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'S', NULL, 'N', 3643.970, '-8,60100', '-38,56800', 316, 'S', 0.6980, NULL, NULL, '26900', 'S', 'N', 1782, NULL, '2690', '2690', NULL, '1864', 'S', 2841, 'FLORESTA', 'N', '260570', 'N', 'S', 'S', NULL, 118, 'N', 'N', 'N', '64', NULL, '03', 'N', NULL, NULL, NULL, 261);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260580', '2604', 'PE', '2602', '2603', '26009', '26', 'FREI MIGUELINHO', NULL, '81', '55780000', '6', '2415', '2415', '15058', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 212.702, '-7,94000', '-35,91200', 370, 'S', 0.6100, NULL, NULL, '26009', 'S', 'N', 1839, NULL, '2690', '2690', NULL, '1963', 'S', 2842, 'FREI MIGUELINHO', 'N', '260580', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '65', NULL, '03', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260590', '2603', 'PE', '2601', '2604', '26015', '26', 'GAMELEIRA', NULL, '81', '55530000', '5', '2417', '2417', '15059', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 257.716, '-8,58400', '-35,38700', 101, 'S', 0.5900, NULL, NULL, '26900', 'S', 'N', 1856, NULL, '2690', '2690', NULL, '1872', 'S', 2843, 'GAMELEIRA', 'N', '260590', 'N', 'S', 'S', NULL, 54, 'S', 'N', 'N', '66', NULL, '03', 'N', NULL, NULL, NULL, 368);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260600', '2605', 'PE', '2602', '2603', '26011', '26', 'GARANHUNS', NULL, '87', '55290000', '2', '2419', '2419', '15060', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 472.462, '-8,89000', '-36,49300', 842, 'S', 0.6930, NULL, NULL, '26900', 'N', 'N', 1859, NULL, '2690', '2690', NULL, '1811', 'S', 2844, 'GARANHUNS', 'N', '260600', 'N', 'S', 'S', NULL, 2, 'S', 'N', 'S', '67', NULL, '01', 'N', NULL, NULL, NULL, 257);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260610', '2601', 'PE', '2601', '2604', '26014', '26', 'GLORIA DO GOITA', NULL, '81', '55620000', '1', '2421', '2421', '15061', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 231.185, '-8,00200', '-35,29300', 158, 'S', 0.6360, NULL, NULL, '26002', 'S', 'N', 1892, NULL, '2690', '2690', NULL, '1884', 'S', 2845, 'GLÓRIA DO GOITÁ', 'N', '260610', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '68', NULL, '03', 'N', NULL, NULL, NULL, 314);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260620', '2612', 'PE', '2601', '2604', '26013', '26', 'GOIANA', NULL, '81', '55900000', '0', '2423', '2423', '15062', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 501.170, '-7,56100', '-35,00300', 13, 'S', 0.6920, NULL, NULL, '26900', 'N', 'N', 1898, NULL, '2690', '2601', NULL, '1742', 'S', 2846, 'GOIANA', 'N', '260620', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '69', NULL, '01', 'N', NULL, NULL, NULL, 259);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260630', '2609', 'PE', '2604', '2601', '26001', '26', 'GRANITO', NULL, '87', '56160000', '9', '2425', '2425', '15063', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 521.857, '-7,71600', '-39,61500', 447, 'S', 0.5970, NULL, NULL, '26900', 'S', 'N', 1938, NULL, '2690', '2690', NULL, '1963', 'S', 2847, 'GRANITO', 'N', '260630', 'N', 'S', 'S', NULL, 81, 'S', 'N', 'N', '70', NULL, '03', 'N', NULL, NULL, NULL, 260);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260640', '2604', 'PE', '2602', '2603', '26008', '26', 'GRAVATA', NULL, '81', '55640000', '8', '2427', '2427', '15064', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 513.367, '-8,20100', '-35,56500', 447, 'S', 0.6540, NULL, NULL, '26007', 'N', 'N', 1943, NULL, '2690', '2690', NULL, '1881', 'S', 2848, 'GRAVATÁ', 'N', '260640', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '71', NULL, '01', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260660', '2606', 'PE', '2603', '2601', '26004', '26', 'IBIMIRIM', NULL, '87', '56580000', '6', '2431', '2431', '15066', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'S', NULL, 'N', 2033.593, '-8,54100', '-37,69000', 401, 'S', 0.5660, NULL, NULL, '26010', 'S', 'N', 2076, NULL, '2690', '2690', NULL, '1963', 'S', 2850, 'IBIMIRIM', 'N', '260660', 'N', 'S', 'S', NULL, 2, 'N', 'N', 'N', '73', NULL, '03', 'N', NULL, NULL, NULL, 138);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260670', '2604', 'PE', '2602', '2603', '26012', '26', 'IBIRAJUBA', NULL, '87', '55390000', '5', '2433', '2433', '15067', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 189.591, '-8,58100', '-36,17900', 612, 'S', 0.5580, NULL, NULL, '26006', 'S', 'N', 2086, NULL, '2690', '2690', NULL, '1963', 'S', 2851, 'IBIRAJUBA', 'N', '260670', 'N', 'S', 'S', NULL, 2, 'S', 'N', 'N', '74', NULL, '03', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260680', '2601', 'PE', '2601', '2605', '26016', '26', 'IGARASSU', NULL, '81', '53600000', '4', '2435', '2435', '15068', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 305.565, '-7,83400', '-34,90600', 19, 'S', 0.7190, NULL, NULL, '26001', 'N', 'N', 2124, NULL, '2601', '2601', NULL, '1943', 'S', 2852, 'IGARASSU', 'N', '260680', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '75', NULL, '01', 'N', NULL, NULL, NULL, 314);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260690', '2610', 'PE', '2603', '2601', '26003', '26', 'IGUARACI', NULL, '87', '56840000', '3', '2437', '2437', '15069', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 838.124, '-7,83500', '-37,51500', 571, 'S', 0.6040, NULL, NULL, '26900', 'S', 'N', 2133, NULL, '2690', '2690', NULL, '1963', 'S', 2853, 'IGUARACI', 'N', '260690', 'N', 'S', 'S', NULL, 82, 'N', 'N', 'N', '76', NULL, '03', 'N', NULL, NULL, NULL, 256);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260700', '2606', 'PE', '2603', '2601', '26004', '26', 'INAJA', NULL, '87', '56560000', '0', '2439', '2439', '15070', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'S', NULL, 'N', 1182.159, '-8,90300', '-37,82700', 355, 'S', 0.5660, NULL, NULL, '26011', 'S', 'N', 2163, NULL, '2690', '2690', NULL, '1928', 'S', 2854, 'INAJÁ', 'N', '260700', 'N', 'S', 'S', NULL, 2, 'S', 'N', 'N', '78', NULL, '03', 'N', NULL, NULL, NULL, 138);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260710', '2610', 'PE', '2603', '2601', '26003', '26', 'INGAZEIRA', NULL, '87', '56830000', '9', '2441', '2441', '15071', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 243.666, '-7,67600', '-37,46000', 534, 'S', 0.6380, NULL, NULL, '26900', 'S', 'N', 2179, NULL, '2690', '2690', NULL, '1963', 'S', 2855, 'INGAZEIRA', 'N', '260710', 'N', 'S', 'S', NULL, 82, 'N', 'N', 'N', '79', NULL, '03', 'N', NULL, NULL, NULL, 256);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260720', '2601', 'PE', '2601', '2605', '26018', '26', 'IPOJUCA', NULL, '81', '55590000', '8', '2443', '2443', '15072', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 527.317, '-8,39900', '-35,06400', 10, 'S', 0.6580, NULL, NULL, '26003', 'N', 'N', 2214, NULL, '2601', '2601', NULL, '1861', 'S', 2856, 'IPOJUCA', 'N', '260720', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '80', NULL, '01', 'N', NULL, NULL, NULL, 314);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260730', '2609', 'PE', '2604', '2601', '26001', '26', 'IPUBI', NULL, '87', '56260000', '7', '2445', '2445', '15073', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 665.624, '-7,65200', '-40,14900', 535, 'S', 0.6000, NULL, NULL, '26900', 'S', 'N', 2222, NULL, '2690', '2690', NULL, '1958', 'S', 2857, 'IPUBI', 'N', '260730', 'N', 'S', 'S', NULL, 81, 'S', 'N', 'N', '81', NULL, '03', 'N', NULL, NULL, NULL, 260);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260740', '2611', 'PE', '2603', '2602', '26006', '26', 'ITACURUBA', NULL, '87', '56430000', '6', '2447', '2447', '15074', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 430.010, '-8,83400', '-38,70400', 292, 'S', 0.6840, NULL, NULL, '26900', 'S', 'N', 2274, NULL, '2690', '2690', NULL, '1963', 'S', 2858, 'ITACURUBA', 'N', '260740', 'N', 'S', 'S', NULL, 118, 'S', 'N', 'N', '82', NULL, '03', 'N', NULL, NULL, NULL, 261);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260750', '2605', 'PE', '2602', '2603', '26007', '26', 'ITAIBA', NULL, '87', '56550000', '5', '2449', '2449', '15075', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1068.286, '-8,94800', '-37,42300', 478, 'S', 0.5670, NULL, NULL, '26900', 'S', 'N', 2289, NULL, '2690', '2690', NULL, '1958', 'S', 2859, 'ITAÍBA', 'N', '260750', 'N', 'S', 'S', NULL, 2, 'S', 'N', 'N', '83', NULL, '03', 'N', NULL, NULL, NULL, 257);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260760', '2601', 'PE', '2601', '2605', '26016', '26', 'ILHA DE ITAMARACA', NULL, '81', '53900000', '4', '2451', '2451', '15076', NULL, 'ATIVO', 'N', 'N', NULL, 'ITAMARACÁ                 ', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 65.411, '-7,74800', '-34,82600', 3, 'S', 0.7430, NULL, NULL, '26001', 'N', 'N', 2307, NULL, '2601', '2601', NULL, '1958', 'S', 2860, 'ILHA DE ITAMARACÁ', 'N', '260760', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '77', NULL, '01', 'N', NULL, NULL, NULL, 314);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260765', '2612', 'PE', '2601', '2604', '26013', '26', 'ITAMBE', NULL, '81', '55920000', '3', '2597', '2597', '15149', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 304.383, '-7,41000', '-35,11300', 179, 'S', 0.5730, NULL, NULL, '26900', 'N', 'N', 2316, NULL, '2690', '2690', NULL, '1867', 'S', 2861, 'ITAMBÉ', 'N', '260765', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '84', NULL, '03', 'N', NULL, NULL, NULL, 259);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260770', '2610', 'PE', '2603', '2601', '26003', '26', 'ITAPETIM', NULL, '87', '56720000', '3', '2453', '2453', '15077', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 404.824, '-7,37800', '-37,19000', 637, 'S', 0.6200, NULL, NULL, '26900', 'S', 'N', 2343, NULL, '2690', '2690', NULL, '1953', 'S', 2862, 'ITAPETIM', 'N', '260770', 'N', 'S', 'S', NULL, 82, 'S', 'N', 'N', '85', NULL, '03', 'N', NULL, NULL, NULL, 256);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260775', '2601', 'PE', '2601', '2605', '26016', '26', 'ITAPISSUMA', NULL, '81', '53700000', '2', '2633', '2633', '15169', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 74.249, '-7,77600', '-34,89200', 7, 'S', 0.6950, NULL, NULL, '26001', 'S', 'N', 2357, NULL, '2601', '2601', NULL, '1982', 'S', 2863, 'ITAPISSUMA', 'N', '260775', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '86', NULL, '01', 'N', NULL, NULL, NULL, 314);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260780', '2612', 'PE', '2601', '2604', '26013', '26', 'ITAQUITINGA', NULL, '81', '55950000', '2', '2455', '2455', '15078', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 103.442, '-7,66800', '-35,10200', 88, 'S', 0.5870, NULL, NULL, '26900', 'S', 'N', 2377, NULL, '2690', '2690', NULL, '1963', 'S', 2864, 'ITAQUITINGA', 'N', '260780', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '87', NULL, '03', 'N', NULL, NULL, NULL, 259);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260790', '2601', 'PE', '2601', '2605', '26017', '26', 'JABOATAO DOS GUARARAPES', NULL, '81', '54111970', '1', '2457', '2457', '15079', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 256.073, '-8,11300', '-35,01500', 76, 'S', 0.7770, NULL, NULL, '26003', 'N', 'N', 2433, NULL, '2601', '2601', NULL, '1873', 'S', 2865, 'JABOATÃO DOS GUARARAPES', 'N', '260790', 'N', 'S', 'S', NULL, NULL, 'S', 'S', 'S', '88', NULL, '01', 'N', NULL, NULL, NULL, 314);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500390', '5011', 'MS', '5001', '5002', '50003', '50', 'FIGUEIRAO', NULL, '67', NULL, '0', '1178', NULL, NULL, NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, '-18,68600', '-53,63100', NULL, 'S', NULL, NULL, NULL, '50012', NULL, NULL, NULL, NULL, '5090', '5090', NULL, '2005', 'S', 5588, 'FIGUEIRÃO', 'N', '500390', 'N', 'N', 'S', '', NULL, 'N', 'N', 'N', '35', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210015', '2107', 'MA', '2101', '2104', '21013', '21', 'AGUA DOCE DO MARANHAO', NULL, '98', '65578000', '4', '0104', '0104', '09137', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 442.963, '-2,84100', '-42,11200', 21, 'S', 0.5290, NULL, NULL, '21900', 'S', 'N', 54, NULL, '2190', '2190', NULL, '1997', 'S', 1141, 'ÁGUA DOCE DO MARANHÃO', 'N', '210015', 'S', 'S', 'S', NULL, 20, 'N', 'N', 'N', '3', NULL, '03', 'N', NULL, NULL, NULL, 408);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210040', '2103', 'MA', '2106', '2102', '21008', '21', 'ALTAMIRA DO MARANHAO', NULL, '98', '65310000', '2', '0707', '0707', '09004', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 668.690, '-4,16500', '-45,47000', 0, 'S', 0.5670, NULL, NULL, '21900', 'S', 'N', 132, NULL, '2190', '2190', NULL, '1961', 'S', 1144, 'ALTAMIRA DO MARANHÃO', 'N', '210040', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '6', NULL, '03', 'N', NULL, NULL, NULL, 237);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210043', '2108', 'MA', '2106', '2104', '21015', '21', 'ALTO ALEGRE DO MARANHAO', NULL, '99', '65413000', '6', '0106', '0106', '09138', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 420.874, '-4,21300', '-44,44600', 50, 'S', 0.5380, NULL, NULL, '21900', 'S', 'N', 141, NULL, '2190', '2190', NULL, '1997', 'S', 1145, 'ALTO ALEGRE DO MARANHÃO', 'N', '210043', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '7', NULL, '03', 'N', NULL, NULL, NULL, 297);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210047', '2115', 'MA', '2107', '2102', '21008', '21', 'ALTO ALEGRE DO PINDARE', NULL, '98', '65398000', '7', '0108', '0108', '09139', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1932.317, '-3,69000', '-45,90300', 0, 'S', 0.5420, NULL, NULL, '21900', 'S', 'N', 142, NULL, '2190', '2190', NULL, '1997', 'S', 1146, 'ALTO ALEGRE DO PINDARÉ', 'N', '210047', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '8', NULL, '03', 'N', NULL, NULL, NULL, 356);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210060', '2109', 'MA', '2104', '2102', '21009', '21', 'AMARANTE DO MARANHAO', NULL, '99', '65923000', '0', '0711', '0711', '09006', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 7669.090, '-5,56700', '-46,74200', 249, 'S', 0.5820, NULL, NULL, '21900', 'S', 'N', 190, NULL, '2190', '2190', NULL, '1953', 'S', 1149, 'AMARANTE DO MARANHÃO', 'N', '210060', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '11', NULL, '03', 'N', NULL, NULL, NULL, 298);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210080', '2107', 'MA', '2101', '2104', '21014', '21', 'ANAPURUS', NULL, '98', '65525000', '8', '0715', '0715', '09008', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 608.274, '-3,67200', '-43,11600', 82, 'S', 0.5920, NULL, NULL, '21900', 'S', 'N', 218, NULL, '2190', '2190', NULL, '1964', 'S', 1151, 'ANAPURUS', 'N', '210080', 'S', 'S', 'S', NULL, 20, 'N', 'N', 'N', '13', NULL, '03', 'N', NULL, NULL, NULL, 408);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210090', '2107', 'MA', '2101', '2104', '21013', '21', 'ARAIOSES', NULL, '98', '65570000', '7', '0717', '0717', '09009', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1782.564, '-2,89000', '-41,90300', 6, 'S', 0.4860, NULL, NULL, '21900', 'S', 'N', 318, NULL, '2190', '2190', NULL, '1938', 'S', 1154, 'ARAIOSES', 'N', '210090', 'S', 'S', 'S', NULL, 20, 'N', 'N', 'N', '16', NULL, '03', 'N', NULL, NULL, NULL, 408);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210095', '2105', 'MA', '2105', '2103', '21011', '21', 'ARAME', NULL, '99', '65945000', '6', '1281', '1281', '09134', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 3044.801, '-4,73300', '-45,90800', 10, 'S', 0.5350, NULL, NULL, '21900', 'S', 'N', 322, NULL, '2190', '2190', NULL, '1988', 'S', 1155, 'ARAME', 'N', '210095', 'S', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '17', NULL, '03', 'N', NULL, NULL, NULL, 121);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210100', '2110', 'MA', '2101', '2101', '21005', '21', 'ARARI', NULL, '98', '65480000', '4', '0719', '0719', '09010', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1100.285, '-3,45400', '-44,78000', 7, 'S', 0.6170, NULL, NULL, '21900', 'S', 'N', 342, NULL, '2190', '2190', NULL, '1864', 'S', 1156, 'ARARI', 'N', '210100', 'S', 'S', 'S', NULL, 141, 'N', 'N', 'N', '18', NULL, '03', 'N', NULL, NULL, NULL, 122);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210110', '2114', 'MA', '2101', '2101', '21003', '21', 'AXIXA', NULL, '98', '65108000', '3', '0721', '0721', '09011', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 203.194, '-2,83700', '-44,05300', 27, 'S', 0.6190, NULL, NULL, '21900', 'S', 'N', 438, NULL, '2190', '2190', NULL, '1935', 'S', 1157, 'AXIXÁ', 'N', '210110', 'S', 'S', 'S', NULL, 52, 'N', 'N', 'N', '19', NULL, '03', 'N', NULL, NULL, NULL, 123);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210125', '2114', 'MA', '2101', '2101', '21003', '21', 'BACABEIRA', NULL, '98', '65103000', '1', '0116', '0116', '09143', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 615.761, '-2,97100', '-44,31600', 44, 'S', 0.6020, NULL, NULL, '21900', 'S', 'N', 442, NULL, '2190', '2190', NULL, '1997', 'S', 1159, 'BACABEIRA', 'N', '210125', 'S', 'S', 'S', NULL, 52, 'N', 'N', 'N', '21', NULL, '03', 'N', NULL, NULL, NULL, 123);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260795', '2603', 'PE', '2601', '2604', '26015', '26', 'JAQUEIRA', NULL, '81', '55409000', '0', '0548', NULL, '15181', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 89.096, '-8,72700', '-35,79300', 0, 'S', 0.5880, NULL, NULL, '26900', 'S', 'N', 2501, NULL, '2690', '2690', NULL, '1997', 'S', 2866, 'JAQUEIRA', 'N', '260795', 'N', 'S', 'S', NULL, 54, 'S', 'N', 'N', '89', NULL, '03', 'N', NULL, NULL, NULL, 368);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260800', '2604', 'PE', '2602', '2603', '26008', '26', 'JATAUBA', NULL, '81', '55180000', '8', '2459', '2459', '15080', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 719.217, '-7,99000', '-36,49600', 516, 'S', 0.5830, NULL, NULL, '26009', 'S', 'N', 2522, NULL, '2690', '2690', NULL, '1958', 'S', 2867, 'JATAÚBA', 'N', '260800', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '90', NULL, '03', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260805', '2606', 'PE', '2603', '2602', '26006', '26', 'JATOBA', NULL, '87', '56470000', '7', '0550', NULL, '15182', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 277.856, '-9,18300', '-38,26900', 280, 'S', 0.6860, NULL, NULL, '26011', 'S', 'N', 2526, NULL, '2690', '2690', NULL, '1997', 'S', 2868, 'JATOBÁ', 'N', '260805', 'N', 'S', 'S', NULL, 118, 'N', 'N', 'N', '91', NULL, '03', 'N', NULL, NULL, NULL, 138);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260810', '2602', 'PE', '2601', '2603', '26010', '26', 'JOAO ALFREDO', NULL, '81', '55720000', '7', '2461', '2461', '15081', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 133.524, '-7,85600', '-35,58800', 328, 'S', 0.6100, NULL, NULL, '26004', 'S', 'N', 2557, NULL, '2690', '2690', NULL, '1935', 'S', 2869, 'JOÃO ALFREDO', 'N', '260810', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '92', NULL, '03', 'N', NULL, NULL, NULL, 421);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260820', '2603', 'PE', '2601', '2604', '26015', '26', 'JOAQUIM NABUCO', NULL, '81', '55535000', '6', '2463', '2463', '15082', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 121.884, '-8,62400', '-35,53300', 152, 'S', 0.6130, NULL, NULL, '26900', 'S', 'N', 2570, NULL, '2690', '2690', NULL, '1953', 'S', 2870, 'JOAQUIM NABUCO', 'N', '260820', 'N', 'S', 'S', NULL, 54, 'S', 'N', 'N', '93', NULL, '03', 'N', NULL, NULL, NULL, 368);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260825', '2605', 'PE', '2602', '2603', '26011', '26', 'JUCATI', NULL, '87', '55398000', '5', '2295', '2295', '15172', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 120.654, '-8,70600', '-36,48900', 820, 'S', 0.5530, NULL, NULL, '26900', 'S', 'N', 2596, NULL, '2690', '2690', NULL, '1993', 'S', 2871, 'JUCATI', 'N', '260825', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '94', NULL, '03', 'N', NULL, NULL, NULL, 257);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220095', '2206', 'PI', '2204', '2204', '22013', '22', 'AROEIRAS DO ITAIM', NULL, '86', '64612000', NULL, '1188', NULL, NULL, NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, '-7,27600', '-41,56400', NULL, 'S', NULL, NULL, NULL, '22900', NULL, NULL, NULL, NULL, '2290', '2290', NULL, '2005', 'S', 5587, 'AROEIRAS DO ITAIM', 'N', '220095', 'N', 'S', 'S', '', 96, 'N', 'N', 'N', '14', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260830', '2605', 'PE', '2602', '2603', '26011', '26', 'JUPI', NULL, '87', '55395000', '5', '2465', '2465', '15083', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 112.531, '-8,71200', '-36,41500', 782, 'S', 0.6090, NULL, NULL, '26900', 'S', 'N', 2612, NULL, '2690', '2690', NULL, '1958', 'S', 2872, 'JUPI', 'N', '260830', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '95', NULL, '03', 'N', NULL, NULL, NULL, 257);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260840', '2604', 'PE', '2602', '2603', '26011', '26', 'JUREMA', NULL, '87', '55480000', '4', '2467', '2467', '15084', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 148.246, '-8,71800', '-36,13600', 723, 'S', 0.5500, NULL, NULL, '26006', 'S', 'N', 2619, NULL, '2690', '2690', NULL, '1928', 'S', 2873, 'JUREMA', 'N', '260840', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '96', NULL, '03', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260845', '2602', 'PE', '2601', '2604', '26013', '26', 'LAGOA DO CARRO', NULL, '81', '55820000', '3', '2289', '2289', '15173', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 69.870, '-7,84500', '-35,32000', 128, 'S', 0.6540, NULL, NULL, '26005', 'S', 'N', 2659, NULL, '2690', '2690', NULL, '1993', 'S', 2874, 'LAGOA DO CARRO', 'N', '260845', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '97', NULL, '03', 'N', NULL, NULL, NULL, 421);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260850', '2602', 'PE', '2601', '2604', '26013', '26', 'LAGOA DO ITAENGA ', NULL, '81', '55840000', '3', '2469', '2469', '15085', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 57.903, '-7,93600', '-35,29000', 183, 'S', 0.6380, NULL, NULL, '26005', 'S', 'N', 2660, NULL, '2690', '2690', NULL, '1963', 'S', 2875, 'LAGOA DO ITAENGA', 'N', '260850', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '98', NULL, '03', 'N', NULL, NULL, NULL, 421);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260860', '2605', 'PE', '2602', '2603', '26011', '26', 'LAGOA DO OURO', NULL, '87', '55320000', '2', '2471', '2471', '15086', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 198.768, '-9,12700', '-36,45900', 653, 'S', 0.5690, NULL, NULL, '26900', 'S', 'N', 2662, NULL, '2690', '2690', NULL, '1958', 'S', 2876, 'LAGOA DO OURO', 'N', '260860', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '99', NULL, '03', 'N', NULL, NULL, NULL, 257);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260870', '2603', 'PE', '2601', '2603', '26012', '26', 'LAGOA DOS GATOS', NULL, '81', '55450000', '1', '2473', '2473', '15087', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 233.165, '-8,65800', '-35,90000', 464, 'S', 0.5360, NULL, NULL, '26900', 'S', 'N', 2666, NULL, '2690', '2690', NULL, '1928', 'S', 2877, 'LAGOA DOS GATOS', 'N', '260870', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '100', NULL, '03', 'N', NULL, NULL, NULL, 368);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260875', '2608', 'PE', '2604', '2602', '26005', '26', 'LAGOA GRANDE', NULL, '87', '56395000', '0', '0552', NULL, '15183', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1852.186, '-8,99700', '-40,27200', 300, 'S', 0.6270, NULL, NULL, '26900', 'S', 'N', 2672, NULL, '2602', '2690', NULL, '1997', 'S', 2878, 'LAGOA GRANDE', 'N', '260875', 'N', 'S', 'S', NULL, 83, 'S', 'N', 'N', '101', NULL, '03', 'N', NULL, NULL, NULL, 313);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260880', '2605', 'PE', '2602', '2603', '26011', '26', 'LAJEDO', NULL, '87', '55385000', '0', '2475', '2475', '15088', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 189.055, '-8,66400', '-36,32000', 661, 'S', 0.6250, NULL, NULL, '26900', 'N', 'N', 2694, NULL, '2690', '2690', NULL, '1948', 'S', 2879, 'LAJEDO', 'N', '260880', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '102', NULL, '03', 'N', NULL, NULL, NULL, 257);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260890', '2602', 'PE', '2601', '2603', '26010', '26', 'LIMOEIRO', NULL, '81', '55700000', '9', '2477', '2477', '15089', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 269.970, '-7,87500', '-35,45000', 138, 'S', 0.6880, NULL, NULL, '26004', 'N', 'N', 2742, NULL, '2690', '2690', NULL, '1811', 'S', 2880, 'LIMOEIRO', 'N', '260890', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '103', NULL, '02', 'N', NULL, NULL, NULL, 421);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260900', '2612', 'PE', '2601', '2604', '26013', '26', 'MACAPARANA', NULL, '81', '55865000', '6', '2479', '2479', '15090', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 126.353, '-7,55500', '-35,45300', 350, 'S', 0.5970, NULL, NULL, '26900', 'S', 'N', 2797, NULL, '2690', '2690', NULL, '1931', 'S', 2881, 'MACAPARANA', 'N', '260900', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '104', NULL, '03', 'N', NULL, NULL, NULL, 259);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260910', '2602', 'PE', '2601', '2603', '26010', '26', 'MACHADOS', NULL, '81', '55740000', '5', '2481', '2481', '15091', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 56.957, '-7,68600', '-35,51500', 416, 'S', 0.6010, NULL, NULL, '26004', 'S', 'N', 2809, NULL, '2690', '2690', NULL, '1963', 'S', 2882, 'MACHADOS', 'N', '260910', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '105', NULL, '03', 'N', NULL, NULL, NULL, 421);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260915', '2606', 'PE', '2603', '2601', '26004', '26', 'MANARI', NULL, '87', '56565000', '4', '0554', NULL, '15184', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 406.636, '-8,96400', '-37,62800', 570, 'S', 0.4670, NULL, NULL, '26010', 'S', 'N', 2849, NULL, '2690', '2690', NULL, '1997', 'S', 2883, 'MANARI', 'N', '260915', 'N', 'S', 'S', NULL, 2, 'N', 'N', 'N', '106', NULL, '03', 'N', NULL, NULL, NULL, 138);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260920', '2603', 'PE', '2601', '2604', '26015', '26', 'MARAIAL', NULL, '81', '55405000', '4', '2483', '2483', '15092', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 196.246, '-8,80300', '-35,82900', 0, 'S', 0.5640, NULL, NULL, '26900', 'S', 'N', 2887, NULL, '2690', '2690', NULL, '1928', 'S', 2884, 'MARAIAL', 'N', '260920', 'N', 'S', 'S', NULL, 54, 'S', 'N', 'N', '107', NULL, '03', 'N', NULL, NULL, NULL, 368);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260930', '2607', 'PE', '2604', '2601', '26002', '26', 'MIRANDIBA', NULL, '87', '56980000', '3', '2485', '2485', '15093', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'S', NULL, 'N', 809.255, '-8,11900', '-38,72800', 450, 'S', 0.6360, NULL, NULL, '26900', 'S', 'N', 3050, NULL, '2690', '2690', NULL, '1958', 'S', 2885, 'MIRANDIBA', 'N', '260930', 'N', 'S', 'S', NULL, 82, 'S', 'N', 'N', '108', NULL, '03', 'N', NULL, NULL, NULL, 369);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260940', '2601', 'PE', '2601', '2605', '26017', '26', 'MORENO', NULL, '81', '54800000', '2', '2487', '2487', '15094', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 195.603, '-8,11900', '-35,09200', 96, 'S', 0.6930, NULL, NULL, '26003', 'N', 'N', 3137, NULL, '2601', '2601', NULL, '1928', 'S', 2887, 'MORENO', 'N', '260940', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '110', NULL, '01', 'N', NULL, NULL, NULL, 314);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260950', '2602', 'PE', '2601', '2604', '26013', '26', 'NAZARE DA MATA', NULL, '81', '55800000', '1', '2489', '2489', '15095', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 150.816, '-7,74200', '-35,22800', 89, 'S', 0.7030, NULL, NULL, '26005', 'N', 'N', 3212, NULL, '2690', '2690', NULL, '1833', 'S', 2888, 'NAZARÉ DA MATA', 'N', '260950', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '111', NULL, '03', 'N', NULL, NULL, NULL, 421);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260960', '2601', 'PE', '2601', '2605', '26017', '26', 'OLINDA', NULL, '81', '53001970', '0', '2491', '2491', '15096', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 43.548, '-8,00900', '-34,85500', 16, 'S', 0.7920, NULL, NULL, '26001', 'N', 'N', 3400, NULL, '2601', '2601', NULL, '1537', 'S', 2889, 'OLINDA', 'N', '260960', 'N', 'S', 'S', NULL, NULL, 'S', 'S', 'S', '112', NULL, '01', 'N', NULL, NULL, NULL, 314);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260980', '2608', 'PE', '2604', '2602', '26005', '26', 'OROCO', NULL, '87', '56170000', '8', '2495', '2495', '15098', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 554.752, '-8,62000', '-39,60200', 349, 'S', 0.6670, NULL, NULL, '26900', 'S', 'N', 3420, NULL, '2602', '2690', NULL, '1963', 'S', 2891, 'OROCÓ', 'N', '260980', 'N', 'S', 'S', NULL, 83, 'S', 'N', 'N', '114', NULL, '03', 'N', NULL, NULL, NULL, 313);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260990', '2609', 'PE', '2604', '2601', '26001', '26', 'OURICURI', NULL, '87', '56200000', '7', '2497', '2497', '15099', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 2422.860, '-7,88300', '-40,08200', 451, 'S', 0.6140, NULL, NULL, '26900', 'N', 'N', 3430, NULL, '2690', '2690', NULL, '1849', 'S', 2892, 'OURICURI', 'N', '260990', 'N', 'S', 'S', NULL, 81, 'S', 'N', 'S', '115', NULL, '02', 'N', NULL, NULL, NULL, 260);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261000', '2603', 'PE', '2601', '2604', '26015', '26', 'PALMARES', NULL, '81', '55540000', '4', '2499', '2499', '15100', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 336.838, '-8,68300', '-35,59200', 108, 'S', 0.6530, NULL, NULL, '26900', 'N', 'N', 3482, NULL, '2690', '2690', NULL, '1873', 'S', 2893, 'PALMARES', 'N', '261000', 'N', 'S', 'S', NULL, 54, 'N', 'N', 'S', '116', NULL, '02', 'N', NULL, NULL, NULL, 368);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261010', '2605', 'PE', '2602', '2603', '26011', '26', 'PALMEIRINA', NULL, '87', '55310000', '3', '2501', '2501', '15101', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 158.014, '-9,00400', '-36,32600', 531, 'S', 0.5960, NULL, NULL, '26900', 'S', 'N', 3500, NULL, '2690', '2690', NULL, '1948', 'S', 2894, 'PALMEIRINA', 'N', '261010', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '117', NULL, '03', 'N', NULL, NULL, NULL, 257);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261020', '2604', 'PE', '2602', '2603', '26012', '26', 'PANELAS', NULL, '81', '55470000', '2', '2503', '2503', '15102', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 371.157, '-8,66400', '-36,00600', 532, 'S', 0.5760, NULL, NULL, '26006', 'S', 'N', 3513, NULL, '2690', '2690', NULL, '1870', 'S', 2895, 'PANELAS', 'N', '261020', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '118', NULL, '03', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261030', '2605', 'PE', '2602', '2603', '26011', '26', 'PARANATAMA', NULL, '87', '55355000', '1', '2505', '2505', '15103', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 230.878, '-8,92100', '-36,65800', 879, 'S', 0.5610, NULL, NULL, '26900', 'S', 'N', 3551, NULL, '2690', '2690', NULL, '1963', 'S', 2896, 'PARANATAMA', 'N', '261030', 'N', 'S', 'S', NULL, 2, 'N', 'N', 'N', '119', NULL, '03', 'N', NULL, NULL, NULL, 257);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261040', '2609', 'PE', '2604', '2601', '26002', '26', 'PARNAMIRIM', NULL, '87', '56163000', '0', '2507', '2507', '15104', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 2608.072, '-8,09100', '-39,57800', 392, 'S', 0.6650, NULL, NULL, '26900', 'S', 'N', 3577, NULL, '2690', '2690', NULL, '1938', 'S', 2897, 'PARNAMIRIM', 'N', '261040', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '120', NULL, '03', 'N', NULL, NULL, NULL, 260);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261050', '2602', 'PE', '2601', '2603', '26010', '26', 'PASSIRA', NULL, '81', '55650000', '9', '2509', '2509', '15105', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 329.755, '-7,99500', '-35,58100', 176, 'S', 0.6250, NULL, NULL, '26004', 'S', 'N', 3590, NULL, '2690', '2690', NULL, '1963', 'S', 2898, 'PASSIRA', 'N', '261050', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '121', NULL, '03', 'N', NULL, NULL, NULL, 421);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261060', '2602', 'PE', '2601', '2604', '26013', '26', 'PAUDALHO', NULL, '81', '55825000', '8', '2511', '2511', '15106', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 277.796, '-7,89700', '-35,18000', 69, 'S', 0.6700, NULL, NULL, '26005', 'N', 'N', 3613, NULL, '2690', '2601', NULL, '1811', 'S', 2899, 'PAUDALHO', 'N', '261060', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '122', NULL, '03', 'N', NULL, NULL, NULL, 421);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261070', '2601', 'PE', '2601', '2605', '26017', '26', 'PAULISTA', NULL, '81', '53401970', '7', '2513', '2513', '15107', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 93.518, '-7,94100', '-34,87300', 13, 'S', 0.7990, NULL, NULL, '26001', 'N', 'N', 3620, NULL, '2601', '2601', NULL, '1935', 'S', 2900, 'PAULISTA', 'N', '261070', 'N', 'S', 'S', NULL, NULL, 'S', 'S', 'S', '123', NULL, '01', 'N', NULL, NULL, NULL, 314);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261080', '2606', 'PE', '2603', '2603', '26007', '26', 'PEDRA', NULL, '87', '55280000', '6', '2515', '2515', '15108', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 803.024, '-8,49700', '-36,94100', 593, 'S', 0.6010, NULL, NULL, '26010', 'S', 'N', 3638, NULL, '2690', '2690', NULL, '1881', 'S', 2901, 'PEDRA', 'N', '261080', 'N', 'S', 'S', NULL, 2, 'N', 'N', 'N', '124', NULL, '03', 'N', NULL, NULL, NULL, 138);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261090', '2604', 'PE', '2602', '2603', '26008', '26', 'PESQUEIRA', NULL, '87', '55200000', '5', '2517', '2517', '15109', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'S', NULL, 'N', 1000.225, '-8,35800', '-36,69600', 654, 'S', 0.6360, NULL, NULL, '26008', 'N', 'N', 3710, NULL, '2690', '2690', NULL, '1762', 'S', 2902, 'PESQUEIRA', 'N', '261090', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '125', NULL, '02', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210594', '2111', 'MA', '2106', '2103', '21010', '21', 'LAGO DOS RODRIGUES', NULL, '99', '65712000', '8', '0184', '0184', '09177', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 195.222, '-4,60900', '-44,98000', 0, 'S', 0.5750, NULL, NULL, '21900', 'S', 'N', 2646, NULL, '2190', '2190', NULL, '1997', 'S', 1239, 'LAGO DOS RODRIGUES', 'N', '210594', 'N', 'S', 'S', NULL, 140, 'N', 'N', 'N', '101', NULL, '03', 'N', NULL, NULL, NULL, 238);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210740', '2103', 'MA', '2106', '2103', '21010', '21', 'OLHO D''AGUA DAS CUNHAS', NULL, '98', '65706000', '7', '0847', '0847', '09074', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 552.619, '-4,13900', '-45,12000', 30, 'S', 0.5710, NULL, NULL, '21900', 'S', 'N', 3391, NULL, '2190', '2190', NULL, '1961', 'S', 1266, 'OLHO D ÁGUA DAS CUNHÃS', 'N', '210740', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '128', NULL, '03', 'N', NULL, NULL, NULL, 237);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('240500', '2405', 'RN', '2490', '2403', '24014', '24', 'JACANA', NULL, '84', '59225000', '9', '1697', '1697', '18049', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 54.558, '-6,42600', '-36,20500', 664, 'S', 0.6310, NULL, NULL, '24900', 'S', 'N', 2441, NULL, '2490', '2490', NULL, '1963', 'S', 3730, 'JAÇANÃ', 'N', '240500', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '55', NULL, '03', 'N', NULL, NULL, NULL, 270);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261100', '2606', 'PE', '2603', '2602', '26006', '26', 'PETROLANDIA', NULL, '87', '56460000', '2', '2519', '2519', '15110', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'S', NULL, 'N', 1056.648, '-9,06900', '-38,30300', 282, 'S', 0.6880, NULL, NULL, '26011', 'S', 'N', 3712, NULL, '2690', '2690', NULL, '1849', 'S', 2903, 'PETROLÂNDIA', 'N', '261100', 'N', 'S', 'S', NULL, 118, 'N', 'N', 'N', '126', NULL, '03', 'N', NULL, NULL, NULL, 138);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261110', '2608', 'PE', '2604', '2602', '26005', '26', 'PETROLINA', NULL, '87', '56300000', '1', '2521', '2521', '15111', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 4558.537, '-9,39300', '-40,50800', 376, 'S', 0.7470, NULL, NULL, '26900', 'N', 'N', 3713, NULL, '2602', '2603', NULL, '1870', 'S', 2904, 'PETROLINA', 'N', '261110', 'N', 'S', 'S', NULL, 83, 'N', 'S', 'S', '127', NULL, '01', 'N', NULL, NULL, NULL, 313);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261120', '2604', 'PE', '2602', '2603', '26008', '26', 'POCAO', NULL, '87', '55240000', '0', '2523', '2523', '15112', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 199.742, '-8,18600', '-36,70500', 1000, 'S', 0.5710, NULL, NULL, '26008', 'S', 'N', 3836, NULL, '2690', '2690', NULL, '1953', 'S', 2905, 'POÇÃO', 'N', '261120', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '128', NULL, '03', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261130', '2601', 'PE', '2601', '2604', '26014', '26', 'POMBOS', NULL, '81', '55630000', '9', '2525', '2525', '15113', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 207.656, '-8,14100', '-35,39600', 208, 'S', 0.6410, NULL, NULL, '26002', 'S', 'N', 3854, NULL, '2690', '2690', NULL, '1963', 'S', 2906, 'POMBOS', 'N', '261130', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '129', NULL, '03', 'N', NULL, NULL, NULL, 314);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261140', '2603', 'PE', '2601', '2604', '26015', '26', 'PRIMAVERA', NULL, '81', '55510000', '8', '2527', '2527', '15114', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 109.942, '-8,33100', '-35,35400', 129, 'S', 0.6320, NULL, NULL, '26900', 'S', 'N', 3988, NULL, '2690', '2690', NULL, '1963', 'S', 2907, 'PRIMAVERA', 'N', '261140', 'N', 'S', 'S', NULL, 54, 'S', 'N', 'N', '130', NULL, '03', 'N', NULL, NULL, NULL, 368);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261150', '2603', 'PE', '2601', '2604', '26015', '26', 'QUIPAPA', NULL, '81', '55415000', '7', '2529', '2529', '15115', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 230.614, '-8,82800', '-36,01200', 462, 'S', 0.5790, NULL, NULL, '26900', 'S', 'N', 4033, NULL, '2690', '2690', NULL, '1879', 'S', 2908, 'QUIPAPÁ', 'N', '261150', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '131', NULL, '03', 'N', NULL, NULL, NULL, 368);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261153', '2610', 'PE', '2603', '2601', '26003', '26', 'QUIXABA', NULL, '87', '56828000', '3', '2637', '2637', '15174', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 209.964, '-7,72000', '-37,84800', 542, 'S', 0.5810, NULL, NULL, '26900', 'S', 'N', 4038, NULL, '2690', '2690', NULL, '1993', 'S', 2909, 'QUIXABA', 'N', '261153', 'N', 'S', 'S', NULL, 82, 'N', 'N', 'N', '132', NULL, '03', 'N', NULL, NULL, NULL, 256);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261160', '2601', 'PE', '2601', '2605', '26017', '26', 'RECIFE', NULL, '81', '50001970', '6', '2531', '2531', '15116', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'S', 217.494, '-8,05400', '-34,88100', 4, 'S', 0.7970, NULL, NULL, '26001', 'N', 'N', 4059, NULL, '2601', '2601', NULL, '1709', 'S', 2910, 'RECIFE', 'N', '261160', 'N', 'S', 'S', NULL, NULL, 'S', 'S', 'S', '133', NULL, '01', 'N', NULL, NULL, NULL, 314);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261170', '2604', 'PE', '2602', '2603', '26008', '26', 'RIACHO DAS ALMAS', NULL, '81', '55120000', '5', '2533', '2533', '15117', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 313.990, '-8,13400', '-35,85600', 407, 'S', 0.6090, NULL, NULL, '26006', 'S', 'N', 4096, NULL, '2690', '2690', NULL, '1953', 'S', 2911, 'RIACHO DAS ALMAS', 'N', '261170', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '134', NULL, '03', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261180', '2603', 'PE', '2601', '2604', '26015', '26', 'RIBEIRAO', NULL, '81', '55520000', '4', '2535', '2535', '15118', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 287.987, '-8,51400', '-35,37800', 97, 'S', 0.6580, NULL, NULL, '26900', 'N', 'N', 4113, NULL, '2690', '2690', NULL, '1928', 'S', 2912, 'RIBEIRÃO', 'N', '261180', 'N', 'S', 'S', NULL, 54, 'S', 'N', 'N', '135', NULL, '03', 'N', NULL, NULL, NULL, 368);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261190', '2603', 'PE', '2601', '2604', '26015', '26', 'RIO FORMOSO', NULL, '81', '55570000', '3', '2537', '2537', '15119', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 239.814, '-8,66400', '-35,15900', 5, 'S', 0.6210, NULL, NULL, '26900', 'S', 'N', 4168, NULL, '2690', '2690', NULL, '1833', 'S', 2913, 'RIO FORMOSO', 'N', '261190', 'N', 'S', 'S', NULL, 54, 'N', 'N', 'N', '136', NULL, '03', 'N', NULL, NULL, NULL, 368);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261200', '2604', 'PE', '2602', '2603', '26012', '26', 'SAIRE', NULL, '81', '55695000', '0', '2539', '2539', '15120', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 195.457, '-8,32800', '-35,70600', 663, 'S', 0.5980, NULL, NULL, '26007', 'S', 'N', 4249, NULL, '2690', '2690', NULL, '1963', 'S', 2914, 'SAIRÉ', 'N', '261200', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '137', NULL, '03', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261210', '2602', 'PE', '2601', '2603', '26010', '26', 'SALGADINHO', NULL, '81', '55675000', '9', '2541', '2541', '15121', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 88.812, '-7,93600', '-35,63300', 232, 'S', 0.6020, NULL, NULL, '26004', 'S', 'N', 4256, NULL, '2690', '2690', NULL, '1963', 'S', 2915, 'SALGADINHO', 'N', '261210', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '138', NULL, '03', 'N', NULL, NULL, NULL, 421);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261220', '2607', 'PE', '2604', '2601', '26002', '26', 'SALGUEIRO', NULL, '87', '56000000', '8', '2543', '2543', '15122', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1639.264, '-8,06700', '-39,12000', 420, 'S', 0.7080, NULL, NULL, '26900', 'N', 'N', 4260, NULL, '2690', '2690', NULL, '1864', 'S', 2916, 'SALGUEIRO', 'N', '261220', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '139', NULL, '02', 'N', NULL, NULL, NULL, 369);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261230', '2605', 'PE', '2602', '2603', '26011', '26', 'SALOA', NULL, '87', '55350000', '7', '2545', '2545', '15123', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 252.080, '-8,97600', '-36,68800', 745, 'S', 0.5610, NULL, NULL, '26900', 'S', 'N', 4266, NULL, '2690', '2690', NULL, '1963', 'S', 2917, 'SALOÁ', 'N', '261230', 'N', 'S', 'S', NULL, 2, 'S', 'N', 'N', '140', NULL, '03', 'N', NULL, NULL, NULL, 257);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261250', '2604', 'PE', '2602', '2603', '26009', '26', 'SANTA CRUZ DO CAPIBARIBE', NULL, '81', '55190000', '5', '2549', '2549', '15125', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 335.526, '-7,95700', '-36,20500', 438, 'S', 0.6990, NULL, NULL, '26009', 'N', 'N', 4324, NULL, '2690', '2690', NULL, '1953', 'S', 2921, 'SANTA CRUZ DO CAPIBARIBE', 'N', '261250', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '144', NULL, '01', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261255', '2609', 'PE', '2604', '2601', '26001', '26', 'SANTA FILOMENA', NULL, '87', '56210000', '4', '0556', NULL, '15185', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1005.062, '-8,16300', '-40,61600', 630, 'S', 0.5820, NULL, NULL, '26900', 'S', 'N', 4338, NULL, '2690', '2690', NULL, '1997', 'S', 2922, 'SANTA FILOMENA', 'N', '261255', 'N', 'S', 'S', NULL, 81, 'S', 'N', 'N', '145', NULL, '03', 'N', NULL, NULL, NULL, 260);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261260', '2608', 'PE', '2604', '2602', '26005', '26', 'SANTA MARIA DA BOA VISTA', NULL, '87', '56380000', '4', '2551', '2551', '15126', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 3001.168, '-8,80900', '-39,82500', 361, 'S', 0.6690, NULL, NULL, '26900', 'N', 'N', 4374, NULL, '2602', '2690', NULL, '1872', 'S', 2923, 'SANTA MARIA DA BOA VISTA', 'N', '261260', 'N', 'S', 'S', NULL, 83, 'N', 'N', 'N', '146', NULL, '03', 'N', NULL, NULL, NULL, 313);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261270', '2604', 'PE', '2602', '2603', '26009', '26', 'SANTA MARIA DO CAMBUCA', NULL, '81', '55765000', '3', '2553', '2553', '15127', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 92.145, '-7,84000', '-35,90200', 494, 'S', 0.5660, NULL, NULL, '26009', 'S', 'N', 4380, NULL, '2690', '2690', NULL, '1963', 'S', 2924, 'SANTA MARIA DO CAMBUCÁ', 'N', '261270', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '147', NULL, '03', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261280', '2610', 'PE', '2603', '2601', '26003', '26', 'SANTA TEREZINHA', NULL, '87', '56750000', '2', '2555', '2555', '15128', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 195.584, '-7,37800', '-37,48000', 813, 'S', 0.6020, NULL, NULL, '26900', 'S', 'N', 4428, NULL, '2690', '2690', NULL, '1963', 'S', 2925, 'SANTA TEREZINHA', 'N', '261280', 'N', 'S', 'S', NULL, 82, 'N', 'N', 'N', '148', NULL, '03', 'N', NULL, NULL, NULL, 256);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261290', '2603', 'PE', '2601', '2604', '26015', '26', 'SAO BENEDITO DO SUL', NULL, '81', '55410000', '1', '2557', '2557', '15129', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 156.782, '-8,80800', '-35,95200', 474, 'S', 0.5490, NULL, NULL, '26900', 'S', 'N', 4526, NULL, '2690', '2690', NULL, '1963', 'S', 2926, 'SÃO BENEDITO DO SUL', 'N', '261290', 'N', 'S', 'S', NULL, 54, 'S', 'N', 'N', '149', NULL, '03', 'N', NULL, NULL, NULL, 368);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261300', '2604', 'PE', '2602', '2603', '26008', '26', 'SAO BENTO DO UNA', NULL, '81', '55370000', '8', '2559', '2559', '15130', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 726.964, '-8,52300', '-36,44400', 614, 'S', 0.6230, NULL, NULL, '26008', 'N', 'N', 4536, NULL, '2690', '2690', NULL, '1860', 'S', 2927, 'SÃO BENTO DO UNA', 'N', '261300', 'N', 'S', 'S', NULL, 2, 'N', 'N', 'S', '150', NULL, '03', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220005', '2206', 'PI', '2204', '2204', '22015', '22', 'ACAUA', NULL, '89', '64748000', '3', '0266', '0266', '16151', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1029.410, '-8,21500', '-41,08200', 374, 'S', 0.5320, NULL, NULL, '22900', 'S', 'N', 23, NULL, '2290', '2290', NULL, '1997', 'S', 2963, 'ACAUÃ', 'N', '220005', 'N', 'S', 'S', NULL, 96, 'N', 'N', 'N', '1', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220027', '2206', 'PI', '2204', '2204', '22014', '22', 'ALEGRETE DO PIAUI', NULL, '89', '64675000', '7', '2269', '2269', '16123', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 281.271, '-7,24300', '-40,85800', 0, 'S', 0.5660, NULL, NULL, '22900', 'S', 'N', 104, NULL, '2290', '2290', NULL, '1993', 'S', 2967, 'ALEGRETE DO PIAUÍ', 'N', '220027', 'N', 'S', 'S', NULL, 96, 'N', 'N', 'N', '5', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220060', '2204', 'PI', '2203', '2202', '22005', '22', 'ANGICAL DO PIAUI', NULL, '86', '64410000', '8', '1011', '1011', '16006', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 201.208, '-6,08600', '-42,73900', 192, 'S', 0.6480, NULL, NULL, '22900', 'S', 'N', 236, NULL, '2290', '2290', NULL, '1954', 'S', 2972, 'ANGICAL DO PIAUÍ', 'N', '220060', 'N', 'S', 'S', NULL, 45, 'N', 'N', 'N', '10', NULL, '03', 'N', NULL, NULL, NULL, 27);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220090', '2205', 'PI', '2204', '2202', '22006', '22', 'AROAZES', NULL, '89', '64310000', '5', '1017', '1017', '16009', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 816.609, '-6,11900', '-41,79300', 230, 'S', 0.5820, NULL, NULL, '22900', 'S', 'N', 384, NULL, '2290', '2290', NULL, '1962', 'S', 2975, 'AROAZES', 'N', '220090', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '13', NULL, '03', 'N', NULL, NULL, NULL, 366);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220157', '2206', 'PI', '2204', '2204', '22015', '22', 'BELEM DO PIAUI', NULL, '89', '64678000', '2', '0276', NULL, '16156', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 220.933, '-7,37600', '-40,97200', 340, 'S', 0.5480, NULL, NULL, '22900', 'S', 'N', 577, NULL, '2290', '2290', NULL, '1997', 'S', 2986, 'BELÉM DO PIAUÍ', 'N', '220157', 'N', 'S', 'S', NULL, 96, 'N', 'N', 'N', '25', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220180', '2206', 'PI', '2204', '2204', '22013', '22', 'BOCAINA', NULL, '89', '64630000', '4', '1035', '1035', '16018', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 257.302, '-6,94300', '-41,32300', 235, 'S', 0.6570, NULL, NULL, '22900', 'S', 'N', 646, NULL, '2290', '2290', NULL, '1963', 'S', 2991, 'BOCAINA', 'N', '220180', 'N', 'S', 'S', NULL, 96, 'N', 'N', 'N', '30', NULL, '03', 'N', NULL, NULL, NULL, 311);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('220191', '2201', 'PI', '2201', '2201', '22002', '22', 'BOM PRINCIPIO DO PIAUI', NULL, '86', '64225000', '9', '2287', '2287', '16125', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 521.571, '-3,19100', '-41,64500', 70, 'S', 0.5520, NULL, NULL, '22900', 'S', 'N', 685, NULL, '2290', '2290', NULL, '1993', 'S', 2993, 'BOM PRINCÍPIO DO PIAUÍ', 'N', '220191', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '32', NULL, '03', 'N', NULL, NULL, NULL, 365);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261310', '2604', 'PE', '2602', '2603', '26008', '26', 'SAO CAITANO', NULL, '81', '55130000', '7', '2561', '2561', '15131', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 382.475, '-8,32600', '-36,14300', 552, 'S', 0.5800, NULL, NULL, '26006', 'N', 'N', 4547, NULL, '2690', '2690', NULL, '1928', 'S', 2928, 'SÃO CAITANO', 'N', '261310', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '151', NULL, '03', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261320', '2605', 'PE', '2602', '2603', '26011', '26', 'SAO JOAO', NULL, '87', '55435000', '6', '2563', '2563', '15132', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 244.437, '-8,87600', '-36,36700', 716, 'S', 0.5930, NULL, NULL, '26900', 'S', 'N', 4623, NULL, '2690', '2690', NULL, '1958', 'S', 2929, 'SÃO JOÃO', 'N', '261320', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '152', NULL, '03', 'N', NULL, NULL, NULL, 257);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261330', '2604', 'PE', '2602', '2603', '26012', '26', 'SAO JOAQUIM DO MONTE', NULL, '81', '55670000', '5', '2565', '2565', '15133', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 242.629, '-8,43200', '-35,80400', 463, 'S', 0.5710, NULL, NULL, '26007', 'S', 'N', 4678, NULL, '2690', '2690', NULL, '1928', 'S', 2930, 'SÃO JOAQUIM DO MONTE', 'N', '261330', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '153', NULL, '03', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261340', '2603', 'PE', '2601', '2604', '26015', '26', 'SAO JOSE DA COROA GRANDE', NULL, '81', '55565000', '4', '2567', '2567', '15134', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 69.196, '-8,89800', '-35,14800', 2, 'S', 0.6280, NULL, NULL, '26900', 'S', 'N', 4687, NULL, '2690', '2690', NULL, '1958', 'S', 2931, 'SÃO JOSÉ DA COROA GRANDE', 'N', '261340', 'N', 'S', 'S', NULL, 54, 'N', 'N', 'N', '154', NULL, '03', 'N', NULL, NULL, NULL, 368);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261350', '2611', 'PE', '2603', '2601', '26002', '26', 'SAO JOSE DO BELMONTE', NULL, '87', '56950000', '3', '2569', '2569', '15135', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1479.964, '-7,86100', '-38,76000', 486, 'S', 0.6350, NULL, NULL, '26900', 'N', 'N', 4706, NULL, '2690', '2690', NULL, '1892', 'S', 2932, 'SÃO JOSÉ DO BELMONTE', 'N', '261350', 'N', 'S', 'S', NULL, 82, 'N', 'N', 'N', '155', NULL, '03', 'N', NULL, NULL, NULL, 261);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261360', '2610', 'PE', '2603', '2601', '26003', '26', 'SAO JOSE DO EGITO', NULL, '87', '56700000', '2', '2571', '2571', '15136', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 791.901, '-7,47900', '-37,27400', 585, 'S', 0.6570, NULL, NULL, '26900', 'S', 'N', 4715, NULL, '2690', '2690', NULL, '1883', 'S', 2933, 'SÃO JOSÉ DO EGITO', 'N', '261360', 'N', 'S', 'S', NULL, 82, 'N', 'N', 'N', '156', NULL, '03', 'N', NULL, NULL, NULL, 256);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261370', '2601', 'PE', '2601', '2605', '26017', '26', 'SAO LOURENCO DA MATA', NULL, '81', '54700000', '1', '2573', '2573', '15137', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 264.346, '-8,00200', '-35,01800', 58, 'S', 0.7070, NULL, NULL, '26002', 'N', 'N', 4746, NULL, '2601', '2601', NULL, '1884', 'S', 2934, 'SÃO LOURENÇO DA MATA', 'N', '261370', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '157', NULL, '01', 'N', NULL, NULL, NULL, 314);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261380', '2612', 'PE', '2601', '2603', '26010', '26', 'SAO VICENTE FERRER', NULL, '81', '55860000', '0', '2575', '2575', '15138', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 110.489, '-7,59100', '-35,49100', 419, 'S', 0.5980, NULL, NULL, '26900', 'S', 'N', 4864, NULL, '2690', '2690', NULL, '1953', 'S', 2935, 'SÃO VICENTE FERRER', 'N', '261380', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '158', NULL, '03', 'N', NULL, NULL, NULL, 259);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261390', '2611', 'PE', '2603', '2601', '26003', '26', 'SERRA TALHADA', NULL, '87', '56900000', '9', '2577', '2577', '15139', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 2979.974, '-7,98600', '-38,29600', 429, 'S', 0.6820, NULL, NULL, '26900', 'N', 'N', 4953, NULL, '2690', '2690', NULL, '1851', 'S', 2936, 'SERRA TALHADA', 'N', '261390', 'N', 'S', 'S', NULL, 82, 'N', 'N', 'S', '159', NULL, '01', 'N', NULL, NULL, NULL, 261);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261400', '2607', 'PE', '2604', '2601', '26002', '26', 'SERRITA', NULL, '87', '56140000', '6', '2579', '2579', '15140', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1603.599, '-7,93300', '-39,29600', 419, 'S', 0.6450, NULL, NULL, '26900', 'S', 'N', 4965, NULL, '2690', '2690', NULL, '1934', 'S', 2937, 'SERRITA', 'N', '261400', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '160', NULL, '03', 'N', NULL, NULL, NULL, 369);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261410', '2606', 'PE', '2603', '2601', '26004', '26', 'SERTANIA', NULL, '87', '56600000', '5', '2581', '2581', '15141', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 2421.511, '-8,07400', '-37,26400', 558, 'S', 0.6480, NULL, NULL, '26010', 'N', 'N', 4969, NULL, '2690', '2690', NULL, '1873', 'S', 2938, 'SERTÂNIA', 'N', '261410', 'N', 'S', 'S', NULL, 82, 'N', 'N', 'N', '161', NULL, '03', 'N', NULL, NULL, NULL, 138);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261420', '2603', 'PE', '2601', '2604', '26015', '26', 'SIRINHAEM', NULL, '81', '55580000', '4', '2583', '2583', '15142', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 378.790, '-8,59100', '-35,11600', 49, 'S', 0.6330, NULL, NULL, '26900', 'N', 'N', 5004, NULL, '2690', '2690', NULL, '1627', 'S', 2939, 'SIRINHAÉM', 'N', '261420', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '162', NULL, '03', 'N', NULL, NULL, NULL, 368);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261430', '2609', 'PE', '2604', '2601', '26001', '26', 'MOREILANDIA', NULL, '87', '56150000', '3', '2585', '2585', '15143', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 637.599, '-7,63100', '-39,55100', 502, 'S', 0.6160, NULL, NULL, '26900', 'S', 'N', 3135, NULL, '2690', '2690', NULL, '1963', 'S', 2886, 'MOREILÂNDIA', 'N', '261430', 'N', 'S', 'S', NULL, 81, 'N', 'N', 'N', '109', NULL, '03', 'N', NULL, NULL, NULL, 260);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261440', '2610', 'PE', '2603', '2601', '26003', '26', 'SOLIDAO', NULL, '87', '56795000', '2', '2587', '2587', '15144', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 138.399, '-7,60000', '-37,65200', 586, 'S', 0.5810, NULL, NULL, '26900', 'S', 'N', 5023, NULL, '2690', '2690', NULL, '1963', 'S', 2940, 'SOLIDÃO', 'N', '261440', 'N', 'S', 'S', NULL, 82, 'N', 'N', 'N', '163', NULL, '03', 'N', NULL, NULL, NULL, 256);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261460', '2610', 'PE', '2603', '2601', '26003', '26', 'TABIRA', NULL, '87', '56780000', '0', '2591', '2591', '15146', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 388.001, '-7,59100', '-37,53900', 558, 'S', 0.6300, NULL, NULL, '26900', 'S', 'N', 5052, NULL, '2690', '2690', NULL, '1948', 'S', 2942, 'TABIRA', 'N', '261460', 'N', 'S', 'S', NULL, 82, 'N', 'N', 'N', '165', NULL, '03', 'N', NULL, NULL, NULL, 256);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261470', '2604', 'PE', '2602', '2603', '26008', '26', 'TACAIMBO', NULL, '81', '55140000', '9', '2593', '2593', '15147', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 227.586, '-8,31600', '-36,29300', 576, 'S', 0.5980, NULL, NULL, '26008', 'S', 'N', 5058, NULL, '2690', '2690', NULL, '1963', 'S', 2943, 'TACAIMBÓ', 'N', '261470', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '166', NULL, '03', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261480', '2606', 'PE', '2603', '2602', '26006', '26', 'TACARATU', NULL, '87', '56480000', '8', '2595', '2595', '15148', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1264.541, '-9,10600', '-38,15000', 514, 'S', 0.5850, NULL, NULL, '26011', 'S', 'N', 5059, NULL, '2690', '2690', NULL, '1953', 'S', 2944, 'TACARATU', 'N', '261480', 'N', 'S', 'S', NULL, 118, 'N', 'N', 'N', '167', NULL, '03', 'N', NULL, NULL, NULL, 138);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261485', '2603', 'PE', '2601', '2604', '26015', '26', 'TAMANDARE', NULL, '81', '55578000', '7', '0558', '0558', '15186', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 190.017, '-8,76000', '-35,10500', 8, 'S', 0.5960, NULL, NULL, '26900', 'S', 'N', 5073, NULL, '2690', '2690', NULL, '1997', 'S', 2945, 'TAMANDARÉ', 'N', '261485', 'N', 'S', 'S', NULL, 54, 'N', 'N', 'N', '168', NULL, '03', 'N', NULL, NULL, NULL, 368);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261500', '2604', 'PE', '2602', '2603', '26009', '26', 'TAQUARITINGA DO NORTE', NULL, '81', '55790000', '3', '2599', '2599', '15150', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 475.176, '-7,90300', '-36,04400', 774, 'S', 0.6880, NULL, NULL, '26009', 'S', 'N', 5111, NULL, '2690', '2690', NULL, '1877', 'S', 2946, 'TAQUARITINGA DO NORTE', 'N', '261500', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '169', NULL, '03', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261510', '2605', 'PE', '2602', '2603', '26011', '26', 'TEREZINHA', NULL, '87', '55305000', '2', '2601', '2601', '15151', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 151.449, '-9,05600', '-36,62300', 736, 'S', 0.5650, NULL, NULL, '26900', 'S', 'N', 5152, NULL, '2690', '2690', NULL, '1963', 'S', 2947, 'TEREZINHA', 'N', '261510', 'N', 'S', 'S', NULL, 2, 'S', 'N', 'N', '170', NULL, '03', 'N', NULL, NULL, NULL, 257);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261520', '2607', 'PE', '2604', '2602', '26005', '26', 'TERRA NOVA', NULL, '87', '56190000', '1', '2603', '2603', '15152', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 360.863, '-8,23000', '-39,37600', 363, 'S', 0.6660, NULL, NULL, '26900', 'S', 'N', 5158, NULL, '2690', '2690', NULL, '1958', 'S', 2948, 'TERRA NOVA', 'N', '261520', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '171', NULL, '03', 'N', NULL, NULL, NULL, 369);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261530', '2612', 'PE', '2601', '2604', '26013', '26', 'TIMBAUBA', NULL, '81', '55870000', '0', '2605', '2605', '15153', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 289.511, '-7,50500', '-35,31800', 102, 'S', 0.6490, NULL, NULL, '26900', 'N', 'N', 5175, NULL, '2690', '2690', NULL, '1879', 'S', 2949, 'TIMBAÚBA', 'N', '261530', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '172', NULL, '02', 'N', NULL, NULL, NULL, 259);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261540', '2604', 'PE', '2602', '2603', '26009', '26', 'TORITAMA', NULL, '81', '55125000', '9', '2607', '2607', '15154', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 30.930, '-7,99900', '-36,05100', 349, 'S', 0.6700, NULL, NULL, '26009', 'S', 'N', 5199, NULL, '2690', '2602', NULL, '1953', 'S', 2950, 'TORITAMA', 'N', '261540', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '173', NULL, '03', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261550', '2602', 'PE', '2601', '2604', '26013', '26', 'TRACUNHAEM', NULL, '81', '55805000', '8', '2609', '2609', '15155', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 116.659, '-7,80500', '-35,24000', 120, 'S', 0.6360, NULL, NULL, '26005', 'S', 'N', 5208, NULL, '2690', '2690', NULL, '1963', 'S', 2951, 'TRACUNHAÉM', 'N', '261550', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '174', NULL, '03', 'N', NULL, NULL, NULL, 421);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261560', '2609', 'PE', '2604', '2601', '26001', '26', 'TRINDADE', NULL, '87', '56250000', '7', '2611', '2611', '15156', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 229.569, '-7,76200', '-40,26800', 518, 'S', 0.6410, NULL, NULL, '26900', 'S', 'N', 5236, NULL, '2690', '2690', NULL, '1963', 'S', 2952, 'TRINDADE', 'N', '261560', 'N', 'S', 'S', NULL, 81, 'S', 'N', 'N', '175', NULL, '03', 'N', NULL, NULL, NULL, 260);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261570', '2611', 'PE', '2603', '2601', '26003', '26', 'TRIUNFO', NULL, '87', '56870000', '6', '2613', '2613', '15157', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 191.516, '-7,83800', '-38,10200', 1004, 'S', 0.7140, NULL, NULL, '26900', 'N', 'N', 5240, NULL, '2690', '2690', NULL, '1870', 'S', 2953, 'TRIUNFO', 'N', '261570', 'N', 'S', 'S', NULL, 82, 'N', 'N', 'N', '176', NULL, '03', 'N', NULL, NULL, NULL, 261);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261580', '2606', 'PE', '2603', '2603', '26007', '26', 'TUPANATINGA', NULL, '87', '56540000', '5', '2615', '2615', '15158', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'S', NULL, 'N', 795.638, '-8,75300', '-37,34000', 710, 'S', 0.5400, NULL, NULL, '26010', 'S', 'N', 5261, NULL, '2690', '2690', NULL, '1963', 'S', 2954, 'TUPANATINGA', 'N', '261580', 'N', 'S', 'S', NULL, 2, 'N', 'N', 'N', '177', NULL, '03', 'N', NULL, NULL, NULL, 138);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261590', '2610', 'PE', '2603', '2601', '26003', '26', 'TUPARETAMA', NULL, '87', '56760000', '4', '2617', '2617', '15159', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 185.541, '-7,60200', '-37,31100', 560, 'S', 0.6620, NULL, NULL, '26900', 'S', 'N', 5266, NULL, '2690', '2690', NULL, '1958', 'S', 2955, 'TUPARETAMA', 'N', '261590', 'N', 'S', 'S', NULL, 82, 'N', 'N', 'N', '178', NULL, '03', 'N', NULL, NULL, NULL, 256);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261600', '2606', 'PE', '2603', '2603', '26007', '26', 'VENTUROSA', NULL, '87', '55270000', '1', '2619', '2619', '15160', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 338.121, '-8,57500', '-36,87400', 530, 'S', 0.6330, NULL, NULL, '26010', 'S', 'N', 5402, NULL, '2690', '2690', NULL, '1958', 'S', 2956, 'VENTUROSA', 'N', '261600', 'N', 'S', 'S', NULL, 2, 'S', 'N', 'N', '179', NULL, '03', 'N', NULL, NULL, NULL, 138);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261610', '2607', 'PE', '2604', '2601', '26002', '26', 'VERDEJANTE', NULL, '87', '56120000', '0', '2621', '2621', '15161', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 476.034, '-7,92600', '-38,97200', 494, 'S', 0.6500, NULL, NULL, '26900', 'S', 'N', 5411, NULL, '2690', '2690', NULL, '1958', 'S', 2957, 'VERDEJANTE', 'N', '261610', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '180', NULL, '03', 'N', NULL, NULL, NULL, 369);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261618', '2602', 'PE', '2601', '2603', '26009', '26', 'VERTENTE DO LERIO', NULL, '81', '55760000', '3', '2291', '2291', '15177', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 67.075, '-7,77100', '-35,85000', 290, 'S', 0.5630, NULL, NULL, '26004', 'S', 'N', 5418, NULL, '2690', '2690', NULL, '1993', 'S', 2958, 'VERTENTE DO LÉRIO', 'N', '261618', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '181', NULL, '03', 'N', NULL, NULL, NULL, 421);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261620', '2604', 'PE', '2602', '2603', '26009', '26', 'VERTENTES', NULL, '81', '55770000', '9', '2623', '2623', '15162', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 191.091, '-7,90300', '-35,98800', 401, 'S', 0.6160, NULL, NULL, '26009', 'S', 'N', 5419, NULL, '2690', '2690', NULL, '1928', 'S', 2959, 'VERTENTES', 'N', '261620', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '182', NULL, '03', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261630', '2602', 'PE', '2601', '2604', '26013', '26', 'VICENCIA', NULL, '81', '55850000', '8', '2625', '2625', '15163', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 230.818, '-7,65700', '-35,32700', 119, 'S', 0.6440, NULL, NULL, '26005', 'S', 'N', 5427, NULL, '2690', '2690', NULL, '1928', 'S', 2960, 'VICÊNCIA', 'N', '261630', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '183', NULL, '03', 'N', NULL, NULL, NULL, 421);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261640', '2601', 'PE', '2601', '2604', '26014', '26', 'VITORIA DE SANTO ANTAO', NULL, '81', '55600000', '7', '2627', '2627', '15164', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 371.796, '-8,11800', '-35,29100', 156, 'S', 0.6630, NULL, NULL, '26002', 'N', 'N', 5477, NULL, '2690', '2601', NULL, '1811', 'S', 2961, 'VITÓRIA DE SANTO ANTÃO', 'N', '261640', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '184', NULL, '01', 'N', NULL, NULL, NULL, 314);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261650', '2603', 'PE', '2601', '2604', '26015', '26', 'XEXEU', NULL, '81', '55555000', '6', '2293', '2293', '15178', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 110.803, '-8,80200', '-35,62700', 200, 'S', 0.5610, NULL, NULL, '26900', 'S', 'N', 5502, NULL, '2690', '2690', NULL, '1993', 'S', 2962, 'XEXÉU', 'N', '261650', 'N', 'S', 'S', NULL, 54, 'S', 'N', 'N', '185', NULL, '03', 'N', NULL, NULL, NULL, 368);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270010', '2710', 'AL', '2702', '2701', '27001', '27', 'AGUA BRANCA', NULL, '82', '57490000', '2', '2701', '2701', '02001', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'S', NULL, 'N', 454.719, '-9,26200', '-37,93800', 570, 'S', 0.5970, NULL, NULL, '27007', 'S', 'N', 49, NULL, '2790', '2790', NULL, '1875', 'S', 23, 'ÁGUA BRANCA', 'N', '270010', 'N', 'S', 'S', NULL, 40, 'N', 'N', 'N', '1', NULL, '03', 'N', NULL, NULL, NULL, 226);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270020', '2705', 'AL', '2701', '2703', '27012', '27', 'ANADIA', NULL, '82', '57660000', '1', '2703', '2703', '02002', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 189.471, '-9,68400', '-36,30400', 153, 'S', 0.6090, NULL, NULL, '27003', 'S', 'N', 207, NULL, '2790', '2790', NULL, '1801', 'S', 24, 'ANADIA', 'N', '270020', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '2', NULL, '03', 'N', NULL, NULL, NULL, 394);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270030', '2707', 'AL', '2702', '2702', '27006', '27', 'ARAPIRACA', NULL, '82', '57300970', '0', '2705', '2705', '02003', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 351.475, '-9,75200', '-36,66100', 264, 'S', 0.6560, NULL, NULL, '27005', 'N', 'N', 327, NULL, '2702', '2790', NULL, '1924', 'S', 25, 'ARAPIRACA', 'N', '270030', 'N', 'S', 'S', NULL, 39, 'S', 'S', 'S', '3', NULL, '01', 'N', NULL, NULL, NULL, 45);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270040', '2704', 'AL', '2701', '2703', '27009', '27', 'ATALAIA', NULL, '82', '57690000', '9', '2707', '2707', '02004', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 531.983, '-9,50200', '-36,02300', 54, 'S', 0.5940, NULL, NULL, '27001', 'N', 'N', 413, NULL, '2790', '2790', NULL, '1764', 'S', 26, 'ATALAIA', 'N', '270040', 'N', 'S', 'S', NULL, 126, 'S', 'N', 'S', '4', NULL, '02', 'N', NULL, NULL, NULL, 393);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270050', '2701', 'AL', '2701', '2703', '27011', '27', 'BARRA DE SANTO ANTONIO', NULL, '82', '57925000', '8', '2709', '2709', '02005', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 137.977, '-9,40500', '-35,50700', 10, 'S', 0.5940, NULL, NULL, '27001', 'S', 'N', 506, NULL, '2701', '2790', NULL, '1960', 'S', 27, 'BARRA DE SANTO ANTÔNIO', 'N', '270050', 'N', 'S', 'S', NULL, 41, 'S', 'N', 'N', '5', NULL, '03', 'N', NULL, NULL, NULL, 44);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270070', '2707', 'AL', '2702', '2701', '27004', '27', 'BATALHA', NULL, '82', '57420000', '6', '2713', '2713', '02007', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 321.131, '-9,67800', '-37,12500', 120, 'S', 0.6090, NULL, NULL, '27006', 'S', 'N', 553, NULL, '2790', '2790', NULL, '1947', 'S', 29, 'BATALHA', 'N', '270070', 'N', 'S', 'S', NULL, 36, 'S', 'N', 'N', '7', NULL, '03', 'N', NULL, NULL, NULL, 45);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270080', '2708', 'AL', '2702', '2702', '27005', '27', 'BELEM', NULL, '82', '57630000', '5', '2715', '2715', '02008', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 48.196, '-9,57100', '-36,49200', 311, 'S', 0.6000, NULL, NULL, '27009', 'S', 'N', 571, NULL, '2702', '2790', NULL, '1962', 'S', 30, 'BELÉM', 'N', '270080', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '8', NULL, '03', 'N', NULL, NULL, NULL, 396);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270090', '2707', 'AL', '2702', '2701', '27004', '27', 'BELO MONTE', NULL, '82', '57435000', '4', '2717', '2717', '02009', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 334.047, '-9,82800', '-37,28000', 30, 'S', 0.5650, NULL, NULL, '27006', 'S', 'N', 585, NULL, '2790', '2790', NULL, '1958', 'S', 31, 'BELO MONTE', 'N', '270090', 'N', 'S', 'S', NULL, 36, 'S', 'N', 'N', '9', NULL, '03', 'N', NULL, NULL, NULL, 45);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270100', '2705', 'AL', '2701', '2703', '27012', '27', 'BOCA DA MATA', NULL, '82', '57680000', '1', '2719', '2719', '02010', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 186.568, '-9,64100', '-36,22000', 132, 'S', 0.6260, NULL, NULL, '27003', 'S', 'N', 643, NULL, '2790', '2790', NULL, '1958', 'S', 32, 'BOCA DA MATA', 'N', '270100', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '10', NULL, '03', 'N', NULL, NULL, NULL, 394);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270110', '2703', 'AL', '2701', '2703', '27009', '27', 'BRANQUINHA', NULL, '82', '57830000', '0', '2721', '2721', '02011', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 191.011, '-9,24600', '-36,01500', 100, 'S', 0.5130, NULL, NULL, '27011', 'S', 'N', 734, NULL, '2790', '2790', NULL, '1962', 'S', 33, 'BRANQUINHA', 'N', '270110', 'N', 'S', 'S', NULL, 126, 'S', 'N', 'N', '11', NULL, '03', 'N', NULL, NULL, NULL, 169);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270120', '2708', 'AL', '2702', '2702', '27005', '27', 'CACIMBINHAS', NULL, '82', '57570000', '9', '2723', '2723', '02012', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 272.978, '-9,40000', '-36,99000', 270, 'S', 0.5580, NULL, NULL, '27009', 'S', 'N', 849, NULL, '2790', '2790', NULL, '1958', 'S', 34, 'CACIMBINHAS', 'N', '270120', 'N', 'S', 'S', NULL, 36, 'S', 'N', 'N', '12', NULL, '03', 'N', NULL, NULL, NULL, 396);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270130', '2704', 'AL', '2701', '2703', '27009', '27', 'CAJUEIRO', NULL, '82', '57770000', '8', '2725', '2725', '02013', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 124.344, '-9,39700', '-36,15400', 102, 'S', 0.5470, NULL, NULL, '27010', 'S', 'N', 887, NULL, '2790', '2790', NULL, '1958', 'S', 35, 'CAJUEIRO', 'N', '270130', 'N', 'S', 'S', NULL, 126, 'S', 'N', 'N', '13', NULL, '03', 'N', NULL, NULL, NULL, 393);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270135', '2703', 'AL', '2701', '2703', '27009', '27', 'CAMPESTRE', NULL, '82', '57968000', '7', '0560', NULL, '02101', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 53.988, '-8,84600', '-35,56800', 0, 'S', 0.5820, NULL, NULL, '27012', 'S', 'N', 925, NULL, '2790', '2790', NULL, '1997', 'S', 36, 'CAMPESTRE', 'N', '270135', 'N', 'S', 'S', NULL, 41, 'S', 'N', 'N', '14', NULL, '03', 'N', NULL, NULL, NULL, 169);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270140', '2705', 'AL', '2701', '2703', '27012', '27', 'CAMPO ALEGRE', NULL, '82', '57250000', '7', '2727', '2727', '02014', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 308.058, '-9,78200', '-36,35100', 176, 'S', 0.5950, NULL, NULL, '27003', 'N', 'N', 944, NULL, '2790', '2790', NULL, '1960', 'S', 37, 'CAMPO ALEGRE', 'N', '270140', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '15', NULL, '03', 'N', NULL, NULL, NULL, 394);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270150', '2707', 'AL', '2702', '2702', '27006', '27', 'CAMPO GRANDE', NULL, '82', '57350000', '6', '2729', '2729', '02015', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 166.404, '-9,95800', '-36,79200', 142, 'S', 0.5470, NULL, NULL, '27005', 'S', 'N', 960, NULL, '2702', '2790', NULL, '1960', 'S', 38, 'CAMPO GRANDE', 'N', '270150', 'N', 'S', 'S', NULL, 39, 'S', 'N', 'N', '16', NULL, '03', 'N', NULL, NULL, NULL, 45);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270160', '2709', 'AL', '2702', '2701', '27001', '27', 'CANAPI', NULL, '82', '57530000', '5', '2731', '2731', '02016', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 571.855, '-9,12700', '-37,60500', 342, 'S', 0.5070, NULL, NULL, '27008', 'S', 'N', 992, NULL, '2790', '2790', NULL, '1962', 'S', 39, 'CANAPI', 'N', '270160', 'N', 'S', 'S', NULL, 40, 'S', 'N', 'N', '17', NULL, '03', 'N', NULL, NULL, NULL, 46);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270170', '2704', 'AL', '2701', '2703', '27009', '27', 'CAPELA', NULL, '82', '57780000', '4', '2733', '2733', '02017', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 205.283, '-9,40800', '-36,07400', 84, 'S', 0.5690, NULL, NULL, '27010', 'S', 'N', 1042, NULL, '2790', '2790', NULL, '1890', 'S', 40, 'CAPELA', 'N', '270170', 'N', 'S', 'S', NULL, 126, 'S', 'N', 'N', '18', NULL, '03', 'N', NULL, NULL, NULL, 393);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270180', '2709', 'AL', '2702', '2701', '27003', '27', 'CARNEIROS', NULL, '82', '57535000', '3', '2735', '2735', '02018', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 113.058, '-9,48300', '-37,37700', 347, 'S', 0.5700, NULL, NULL, '27008', 'S', 'N', 1129, NULL, '2790', '2790', NULL, '1962', 'S', 41, 'CARNEIROS', 'N', '270180', 'N', 'S', 'S', NULL, 42, 'N', 'N', 'N', '19', NULL, '03', 'N', NULL, NULL, NULL, 46);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270190', '2704', 'AL', '2701', '2703', '27008', '27', 'CHA PRETA', NULL, '82', '57760000', '2', '2737', '2737', '02019', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 200.802, '-9,25500', '-36,29600', 463, 'S', 0.5590, NULL, NULL, '27010', 'S', 'N', 1226, NULL, '2790', '2790', NULL, '1962', 'S', 42, 'CHÃ PRETA', 'N', '270190', 'N', 'S', 'S', NULL, 126, 'S', 'N', 'N', '20', NULL, '03', 'N', NULL, NULL, NULL, 393);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270200', '2707', 'AL', '2702', '2702', '27006', '27', 'COITE DO NOIA', NULL, '82', '57325000', '9', '2739', '2739', '02020', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 88.488, '-9,63200', '-36,57900', 280, 'S', 0.5690, NULL, NULL, '27005', 'S', 'N', 1283, NULL, '2702', '2790', NULL, '1963', 'S', 43, 'COITÉ DO NÓIA', 'N', '270200', 'N', 'S', 'S', NULL, 39, 'S', 'N', 'N', '21', NULL, '03', 'N', NULL, NULL, NULL, 45);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270210', '2703', 'AL', '2701', '2703', '27009', '27', 'COLONIA LEOPOLDINA', NULL, '82', '57975000', '8', '2741', '2741', '02021', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 287.459, '-8,90900', '-35,72500', 140, 'S', 0.5780, NULL, NULL, '27012', 'S', 'N', 1298, NULL, '2790', '2790', NULL, '1901', 'S', 44, 'COLÔNIA LEOPOLDINA', 'N', '270210', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '22', NULL, '03', 'N', NULL, NULL, NULL, 169);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270220', '2701', 'AL', '2701', '2703', '27011', '27', 'COQUEIRO SECO', NULL, '82', '57140000', '7', '2743', '2743', '02022', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 40.262, '-9,63800', '-35,80300', 31, 'S', 0.6310, NULL, NULL, '27001', 'S', 'N', 1357, NULL, '2701', '2701', NULL, '1962', 'S', 45, 'COQUEIRO SECO', 'N', '270220', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '23', NULL, '03', 'N', NULL, NULL, NULL, 44);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270230', '2706', 'AL', '2701', '2703', '27012', '27', 'CORURIPE', NULL, '82', '57230000', '6', '2745', '2745', '02023', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 912.716, '-10,12600', '-36,17600', 16, 'S', 0.6150, NULL, NULL, '27013', 'N', 'N', 1411, NULL, '2790', '2790', NULL, '1866', 'S', 46, 'CORURIPE', 'N', '270230', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '24', NULL, '02', 'N', NULL, NULL, NULL, 395);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270235', '2707', 'AL', '2702', '2702', '27006', '27', 'CRAIBAS', NULL, '82', '57320000', '5', '2889', '2889', '02095', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 275.325, '-9,61800', '-36,76800', 252, 'S', 0.5530, NULL, NULL, '27005', 'S', 'N', 1425, NULL, '2702', '2790', NULL, '1982', 'S', 47, 'CRAÍBAS', 'N', '270235', 'N', 'S', 'S', NULL, 39, 'S', 'N', 'N', '25', NULL, '03', 'N', NULL, NULL, NULL, 45);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270240', '2710', 'AL', '2702', '2701', '27002', '27', 'DELMIRO GOUVEIA', NULL, '82', '57480000', '5', '2747', '2747', '02024', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 605.395, '-9,38600', '-37,99600', 256, 'S', 0.6450, NULL, NULL, '27007', 'N', 'N', 1516, NULL, '2790', '2790', NULL, '1952', 'S', 48, 'DELMIRO GOUVEIA', 'N', '270240', 'N', 'S', 'S', NULL, 40, 'N', 'N', 'S', '26', NULL, '03', 'N', NULL, NULL, NULL, 226);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270250', '2709', 'AL', '2702', '2701', '27003', '27', 'DOIS RIACHOS', NULL, '82', '57560000', '4', '2749', '2749', '02025', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 140.472, '-9,39300', '-37,10100', 245, 'S', 0.5470, NULL, NULL, '27008', 'S', 'N', 1566, NULL, '2790', '2790', NULL, '1960', 'S', 49, 'DOIS RIACHOS', 'N', '270250', 'N', 'S', 'S', NULL, 42, 'S', 'N', 'N', '27', NULL, '03', 'N', NULL, NULL, NULL, 46);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270255', '2708', 'AL', '2702', '2702', '27005', '27', 'ESTRELA DE ALAGOAS', NULL, '82', '57625000', '3', '2643', '2643', '02100', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 264.203, '-9,39000', '-36,76000', 0, 'S', 0.5450, NULL, NULL, '27009', 'S', 'N', 1698, NULL, '2702', '2790', NULL, '1993', 'S', 50, 'ESTRELA DE ALAGOAS', 'N', '270255', 'N', 'S', 'S', NULL, 39, 'S', 'N', 'N', '28', NULL, '03', 'N', NULL, NULL, NULL, 396);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270260', '2707', 'AL', '2702', '2702', '27006', '27', 'FEIRA GRANDE', NULL, '82', '57340000', '3', '2751', '2751', '02026', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 155.974, '-9,90000', '-36,67800', 220, 'S', 0.5600, NULL, NULL, '27005', 'S', 'N', 1738, NULL, '2702', '2790', NULL, '1954', 'S', 51, 'FEIRA GRANDE', 'N', '270260', 'N', 'S', 'S', NULL, 39, 'N', 'N', 'N', '29', NULL, '03', 'N', NULL, NULL, NULL, 45);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270270', '2706', 'AL', '2701', '2703', '27013', '27', 'FELIZ DESERTO', NULL, '82', '57220000', '2', '2753', '2753', '02027', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 91.824, '-10,29200', '-36,30600', 6, 'S', 0.6090, NULL, NULL, '27013', 'S', 'N', 1747, NULL, '2790', '2790', NULL, '1960', 'S', 52, 'FELIZ DESERTO', 'N', '270270', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '30', NULL, '03', 'N', NULL, NULL, NULL, 395);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270280', '2701', 'AL', '2701', '2703', '27009', '27', 'FLEXEIRAS', NULL, '82', '57995000', '1', '2755', '2755', '02028', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 315.791, '-9,27300', '-35,71500', 78, 'S', 0.5540, NULL, NULL, '27012', 'S', 'N', 1770, NULL, '2790', '2790', NULL, '1960', 'S', 53, 'FLEXEIRAS', 'N', '270280', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '31', NULL, '03', 'N', NULL, NULL, NULL, 44);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270290', '2707', 'AL', '2702', '2702', '27006', '27', 'GIRAU DO PONCIANO', NULL, '82', '57360000', '0', '2757', '2757', '02029', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 502.150, '-9,88400', '-36,82900', 244, 'S', 0.5350, NULL, NULL, '27005', 'N', 'N', 1885, NULL, '2702', '2790', NULL, '1958', 'S', 54, 'GIRAU DO PONCIANO', 'N', '270290', 'N', 'S', 'S', NULL, 39, 'S', 'N', 'N', '32', NULL, '03', 'N', NULL, NULL, NULL, 45);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270310', '2708', 'AL', '2702', '2702', '27005', '27', 'IGACI', NULL, '82', '57620000', '6', '2761', '2761', '02031', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 333.586, '-9,53700', '-36,63400', 240, 'S', 0.5400, NULL, NULL, '27009', 'S', 'N', 2114, NULL, '2702', '2790', NULL, '1957', 'S', 56, 'IGACI', 'N', '270310', 'N', 'S', 'S', NULL, 39, 'S', 'N', 'N', '34', NULL, '03', 'N', NULL, NULL, NULL, 396);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270320', '2706', 'AL', '2701', '2703', '27013', '27', 'IGREJA NOVA', NULL, '82', '57280000', '5', '2763', '2763', '02032', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 428.550, '-10,12500', '-36,66200', 14, 'S', 0.5850, NULL, NULL, '27004', 'S', 'N', 2128, NULL, '2790', '2790', NULL, '1890', 'S', 57, 'IGREJA NOVA', 'N', '270320', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '35', NULL, '03', 'N', NULL, NULL, NULL, 395);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270330', '2710', 'AL', '2702', '2701', '27001', '27', 'INHAPI', NULL, '82', '57545000', '4', '2765', '2765', '02033', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 374.161, '-9,21900', '-37,75400', 410, 'S', 0.5150, NULL, NULL, '27007', 'S', 'N', 2183, NULL, '2790', '2790', NULL, '1962', 'S', 58, 'INHAPI', 'N', '270330', 'N', 'S', 'S', NULL, 40, 'N', 'N', 'N', '36', NULL, '03', 'N', NULL, NULL, NULL, 226);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230010', '2319', 'CE', '2303', '2307', '23033', '23', 'ABAIARA', NULL, '88', '63240000', '1', '1301', '1301', '05001', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 179.906, '-7,35900', '-39,04600', 409, 'S', 0.6270, NULL, NULL, '23900', 'S', 'N', 6, NULL, '2390', '2390', NULL, '1957', 'S', 617, 'ABAIARA', 'N', '230010', 'N', 'S', 'S', NULL, 131, 'N', 'N', 'N', '1', NULL, '03', 'N', NULL, NULL, NULL, 49);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230050', '2311', 'CE', '2302', '2301', '23004', '23', 'ALCANTARAS', NULL, '88', '62120000', '7', '1309', '1309', '05005', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 138.598, '-3,58900', '-40,54600', 656, 'S', 0.6070, NULL, NULL, '23900', 'S', 'N', 96, NULL, '2390', '2390', NULL, '1957', 'S', 622, 'ALCÂNTARAS', 'N', '230050', 'N', 'S', 'S', NULL, 86, 'N', 'N', 'N', '6', NULL, '03', 'N', NULL, NULL, NULL, 284);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230060', '2320', 'CE', '2303', '2307', '23030', '23', 'ALTANEIRA', NULL, '88', '63195000', '6', '1311', '1311', '05006', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 73.296, '-7,00200', '-39,74100', 661, 'S', 0.5760, NULL, NULL, '23900', 'S', 'N', 134, NULL, '2390', '2390', NULL, '1958', 'S', 623, 'ALTANEIRA', 'N', '230060', 'N', 'S', 'S', NULL, 131, 'N', 'N', 'N', '7', NULL, '03', 'N', NULL, NULL, NULL, 339);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230070', '2310', 'CE', '2301', '2305', '23023', '23', 'ALTO SANTO', NULL, '88', '62970000', '5', '1313', '1313', '05007', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 1338.743, '-5,52100', '-38,27200', 79, 'S', 0.6540, NULL, NULL, '23900', 'S', 'N', 162, NULL, '2390', '2390', NULL, '1957', 'S', 624, 'ALTO SANTO', 'N', '230070', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '8', NULL, '03', 'N', NULL, NULL, NULL, 336);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230090', '2302', 'CE', '2301', '2302', '23011', '23', 'APUIARES', NULL, '85', '62630000', '3', '1317', '1317', '05009', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 544.744, '-3,94900', '-39,43200', 91, 'S', 0.6220, NULL, NULL, '23900', 'S', 'N', 284, NULL, '2390', '2390', NULL, '1957', 'S', 627, 'APUIARÉS', 'N', '230090', 'N', 'S', 'S', NULL, 51, 'N', 'N', 'N', '11', NULL, '03', 'N', NULL, NULL, NULL, 5);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230120', '2304', 'CE', '2301', '2302', '23013', '23', 'ARACOIABA', NULL, '85', '62750000', '8', '1323', '1323', '05012', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 656.532, '-4,37100', '-38,81400', 107, 'S', 0.5970, NULL, NULL, '23900', 'S', 'N', 299, NULL, '2390', '2390', NULL, '1933', 'S', 630, 'ARACOIABA', 'N', '230120', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '14', NULL, '03', 'N', NULL, NULL, NULL, 6);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230125', '2315', 'CE', '2302', '2304', '23018', '23', 'ARARENDA', NULL, '88', '62210000', '7', '0989', '0989', '05182', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 344.132, '-4,75300', '-40,83300', 380, 'S', 0.6260, NULL, NULL, '23900', 'S', 'N', 341, NULL, '2390', '2390', NULL, '1993', 'S', 631, 'ARARENDÁ', 'N', '230125', 'N', 'S', 'S', NULL, 49, 'N', 'N', 'N', '15', NULL, '03', 'N', NULL, NULL, NULL, 285);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230140', '2304', 'CE', '2301', '2302', '23013', '23', 'ARATUBA', NULL, '85', '62762000', '6', '1327', '1327', '05014', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 142.538, '-4,41800', '-39,04500', 838, 'S', 0.6330, NULL, NULL, '23900', 'S', 'N', 351, NULL, '2390', '2390', NULL, '1957', 'S', 633, 'ARATUBA', 'N', '230140', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '17', NULL, '03', 'N', NULL, NULL, NULL, 6);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230160', '2320', 'CE', '2303', '2307', '23029', '23', 'ASSARE', NULL, '88', '63140000', '4', '1331', '1331', '05016', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 1116.320, '-6,87400', '-39,87500', 442, 'S', 0.5770, NULL, NULL, '23900', 'S', 'N', 403, NULL, '2390', '2390', NULL, '1865', 'S', 635, 'ASSARÉ', 'N', '230160', 'N', 'S', 'S', NULL, 131, 'N', 'N', 'N', '19', NULL, '03', 'N', NULL, NULL, NULL, 339);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230200', '2319', 'CE', '2303', '2307', '23031', '23', 'BARRO', NULL, '88', '63380000', '8', '1339', '1339', '05020', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 709.655, '-7,17700', '-38,78200', 362, 'S', 0.6580, NULL, NULL, '23900', 'S', 'N', 541, NULL, '2390', '2390', NULL, '1951', 'S', 641, 'BARRO', 'N', '230200', 'N', 'S', 'S', NULL, 131, 'N', 'N', 'N', '25', NULL, '03', 'N', NULL, NULL, NULL, 49);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230205', '2316', 'CE', '2302', '2301', '23001', '23', 'BARROQUINHA', NULL, '88', '62410000', '7', '1237', '1237', '05175', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 383.426, '-3,01900', '-41,13700', 25, 'S', 0.5510, NULL, NULL, '23900', 'S', 'N', 546, NULL, '2390', '2390', NULL, '1989', 'S', 642, 'BARROQUINHA', 'N', '230205', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '26', NULL, '03', 'N', NULL, NULL, NULL, 338);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230230', '2312', 'CE', '2302', '2301', '23001', '23', 'BELA CRUZ', NULL, '88', '62570000', '5', '1345', '1345', '05023', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 841.718, '-3,05100', '-40,16800', 15, 'S', 0.5950, NULL, NULL, '23900', 'S', 'N', 561, NULL, '2390', '2390', NULL, '1957', 'S', 645, 'BELA CRUZ', 'N', '230230', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '29', NULL, '03', 'N', NULL, NULL, NULL, 170);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230270', '2320', 'CE', '2303', '2307', '23029', '23', 'CAMPOS SALES', NULL, '88', '63150000', '1', '1353', '1353', '05027', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 1082.771, '-7,07400', '-40,37600', 566, 'S', 0.6550, NULL, NULL, '23900', 'S', 'N', 984, NULL, '2390', '2390', NULL, '1933', 'S', 649, 'CAMPOS SALES', 'N', '230270', 'N', 'S', 'S', NULL, 131, 'N', 'N', 'N', '33', NULL, '03', 'N', NULL, NULL, NULL, 339);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230290', '2304', 'CE', '2301', '2302', '23013', '23', 'CAPISTRANO', NULL, '85', '62748000', '9', '1357', '1357', '05029', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 194.797, '-4,47000', '-38,90100', 159, 'S', 0.6310, NULL, NULL, '23900', 'S', 'N', 1055, NULL, '2390', '2390', NULL, '1951', 'S', 651, 'CAPISTRANO', 'N', '230290', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '35', NULL, '03', 'N', NULL, NULL, NULL, 6);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230423', '2313', 'CE', '2302', '2301', '23002', '23', 'CROATA', NULL, '88', '62390000', '6', '1241', '1241', '05176', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 700.356, '-4,40000', '-40,91100', 571, 'S', 0.5570, NULL, NULL, '23900', 'S', 'N', 1450, NULL, '2390', '2390', NULL, '1989', 'S', 668, 'CROATÁ', 'N', '230423', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '52', NULL, '03', 'N', NULL, NULL, NULL, 171);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230425', '2312', 'CE', '2302', '2301', '23001', '23', 'CRUZ', NULL, '88', '62595000', '1', '1589', '1589', '05146', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 334.833, '-2,91800', '-40,17200', 16, 'S', 0.6430, NULL, NULL, '23900', 'S', 'N', 1453, NULL, '2390', '2390', NULL, '1986', 'S', 669, 'CRUZ', 'N', '230425', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '53', NULL, '03', 'N', NULL, NULL, NULL, 170);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230435', '2311', 'CE', '2302', '2301', '23005', '23', 'FORQUILHA', NULL, '88', '62115000', '0', '1591', '1591', '05152', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 516.988, '-3,79800', '-40,26100', 99, 'S', 0.6430, NULL, NULL, '23900', 'S', 'N', 1806, NULL, '2390', '2390', NULL, '1986', 'S', 674, 'FORQUILHA', 'N', '230435', 'N', 'S', 'S', NULL, 86, 'N', 'N', 'N', '58', NULL, '03', 'N', NULL, NULL, NULL, 284);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230445', '2307', 'CE', '2301', '2305', '23022', '23', 'FORTIM', NULL, '88', '62815000', '9', '0987', '0987', '05186', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 280.184, '-4,45200', '-37,79700', 15, 'S', 0.6330, NULL, NULL, '23900', 'S', 'N', 1813, NULL, '2390', '2390', NULL, '1993', 'S', 676, 'FORTIM', 'N', '230445', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '60', NULL, '03', 'N', NULL, NULL, NULL, 230);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230780', '2312', 'CE', '2302', '2301', '23001', '23', 'MARCO', NULL, '88', '62560000', '9', '1457', '1457', '05079', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 574.148, '-3,12400', '-40,14700', 20, 'S', 0.6160, NULL, NULL, '23900', 'S', 'N', 2905, NULL, '2390', '2390', NULL, '1951', 'S', 722, 'MARCO', 'N', '230780', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '106', NULL, '03', 'N', NULL, NULL, NULL, 170);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230790', '2316', 'CE', '2302', '2301', '23001', '23', 'MARTINOPOLE', NULL, '88', '62450000', '8', '1459', '1459', '05080', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 298.948, '-3,22600', '-40,69700', 85, 'S', 0.5830, NULL, NULL, '23900', 'S', 'N', 2944, NULL, '2390', '2390', NULL, '1957', 'S', 723, 'MARTINÓPOLE', 'N', '230790', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '107', NULL, '03', 'N', NULL, NULL, NULL, 338);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230800', '2311', 'CE', '2302', '2301', '23005', '23', 'MASSAPE', NULL, '88', '62140000', '5', '1461', '1461', '05081', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 571.531, '-3,52300', '-40,34300', 83, 'S', 0.6000, NULL, NULL, '23900', 'N', 'N', 2952, NULL, '2390', '2390', NULL, '1897', 'S', 724, 'MASSAPÊ', 'N', '230800', 'N', 'S', 'S', NULL, 86, 'N', 'N', 'N', '108', NULL, '03', 'N', NULL, NULL, NULL, 284);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230820', '2311', 'CE', '2302', '2301', '23004', '23', 'MERUOCA', NULL, '88', '62130000', '3', '1465', '1465', '05083', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 144.940, '-3,54200', '-40,45500', 657, 'S', 0.6380, NULL, NULL, '23900', 'S', 'N', 3012, NULL, '2390', '2390', NULL, '1951', 'S', 726, 'MERUOCA', 'N', '230820', 'N', 'S', 'S', NULL, 86, 'N', 'N', 'N', '110', NULL, '03', 'N', NULL, NULL, NULL, 284);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230830', '2319', 'CE', '2303', '2307', '23033', '23', 'MILAGRES', NULL, '88', '63250000', '2', '1467', '1467', '05084', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 546.637, '-7,31300', '-38,94600', 334, 'S', 0.6410, NULL, NULL, '23900', 'S', 'N', 3023, NULL, '2390', '2390', NULL, '1846', 'S', 727, 'MILAGRES', 'N', '230830', 'N', 'S', 'S', NULL, 131, 'N', 'N', 'N', '111', NULL, '03', 'N', NULL, NULL, NULL, 49);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230860', '2315', 'CE', '2302', '2304', '23018', '23', 'MONSENHOR TABOSA', NULL, '88', '63780000', '9', '1473', '1473', '05087', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 886.303, '-4,78900', '-40,06300', 687, 'S', 0.6280, NULL, NULL, '23900', 'S', 'N', 3088, NULL, '2390', '2390', NULL, '1951', 'S', 732, 'MONSENHOR TABOSA', 'N', '230860', 'N', 'S', 'S', NULL, 49, 'N', 'N', 'N', '116', NULL, '03', 'N', NULL, NULL, NULL, 285);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230880', '2311', 'CE', '2302', '2301', '23003', '23', 'MORAUJO', NULL, '88', '62480000', '7', '1477', '1477', '05089', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 415.614, '-3,46700', '-40,68100', 66, 'S', 0.5940, NULL, NULL, '23900', 'S', 'N', 3134, NULL, '2390', '2390', NULL, '1957', 'S', 734, 'MORAÚJO', 'N', '230880', 'N', 'S', 'S', NULL, 86, 'N', 'N', 'N', '118', NULL, '03', 'N', NULL, NULL, NULL, 284);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('230900', '2311', 'CE', '2302', '2301', '23005', '23', 'MUCAMBO', NULL, '88', '62170000', '3', '1481', '1481', '05091', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 190.538, '-3,90900', '-40,74700', 170, 'S', 0.6290, NULL, NULL, '23900', 'S', 'N', 3165, NULL, '2390', '2390', NULL, '1953', 'S', 736, 'MUCAMBO', 'N', '230900', 'N', 'S', 'S', NULL, 86, 'N', 'N', 'N', '120', NULL, '03', 'N', NULL, NULL, NULL, 284);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('231325', '2320', 'CE', '2303', '2306', '23027', '23', 'TARRAFAS', NULL, '88', '63145000', '2', '1275', '1275', '05173', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 454.390, '-6,68400', '-39,76100', 280, 'S', 0.5700, NULL, NULL, '23900', 'S', 'N', 5118, NULL, '2390', '2390', NULL, '1989', 'S', 787, 'TARRAFAS', 'N', '231325', 'N', 'S', 'S', NULL, 131, 'N', 'N', 'N', '171', NULL, '03', 'N', NULL, NULL, NULL, 339);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241290', '2405', 'RN', '2490', '2403', '24014', '24', 'SAO TOME', NULL, '84', '59400000', '6', '1855', '1855', '18128', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 862.577, '-5,97300', '-36,07500', 159, 'S', 0.6130, NULL, NULL, '24900', 'S', 'N', 4852, NULL, '2490', '2490', NULL, '1928', 'S', 3811, 'SÃO TOMÉ', 'N', '241290', 'N', 'S', 'S', NULL, 123, 'S', 'N', 'N', '140', NULL, '03', 'N', NULL, NULL, NULL, 270);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241300', '2404', 'RN', '2490', '2402', '24010', '24', 'SAO VICENTE', NULL, '84', '59340000', '3', '1857', '1857', '18129', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 197.814, '-6,21600', '-36,68400', 323, 'S', 0.6390, NULL, NULL, '24900', 'S', 'N', 4860, NULL, '2490', '2490', NULL, '1953', 'S', 3812, 'SÃO VICENTE', 'N', '241300', 'N', 'S', 'S', NULL, 76, 'S', 'N', 'N', '141', NULL, '03', 'N', NULL, NULL, NULL, 83);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241310', '2405', 'RN', '2490', '2403', '24015', '24', 'SENADOR ELOI DE SOUZA', NULL, '84', '59250000', '2', '1859', '1859', '18130', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 167.592, '-6,03600', '-35,69300', 113, 'S', 0.5880, NULL, NULL, '24900', 'S', 'N', 4907, NULL, '2490', '2490', NULL, '1958', 'S', 3813, 'SENADOR ELÓI DE SOUZA', 'N', '241310', 'N', 'S', 'S', NULL, 123, 'S', 'N', 'N', '142', NULL, '03', 'N', NULL, NULL, NULL, 270);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241320', '2401', 'RN', '2490', '2404', '24019', '24', 'SENADOR GEORGINO AVELINO', NULL, '84', '59168000', '1', '1861', '1861', '18131', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 26.383, '-6,16300', '-35,12300', 4, 'S', 0.6470, NULL, NULL, '24900', 'S', 'N', 4909, NULL, '2490', '2490', NULL, '1963', 'S', 3814, 'SENADOR GEORGINO AVELINO', 'N', '241320', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '143', NULL, '03', 'N', NULL, NULL, NULL, 148);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241330', '2401', 'RN', '2490', '2403', '24014', '24', 'SERRA DE SAO BENTO', NULL, '84', '59214000', '0', '1863', '1863', '18132', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 96.635, '-6,41700', '-35,70400', 401, 'S', 0.6000, NULL, NULL, '24900', 'S', 'N', 4941, NULL, '2490', '2490', NULL, '1958', 'S', 3816, 'SERRA DE SÃO BENTO', 'N', '241330', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '144', NULL, '03', 'N', NULL, NULL, NULL, 148);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241335', '2402', 'RN', '2490', '2401', '24001', '24', 'SERRA DO MEL', NULL, '84', '59663000', '9', '1927', '1927', '18152', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 616.509, '-5,17000', '-37,02900', 215, 'S', 0.6190, NULL, NULL, '24900', 'S', 'N', 4942, NULL, '2490', '2490', NULL, '1989', 'S', 3817, 'SERRA DO MEL', 'N', '241335', 'N', 'S', 'S', NULL, 1, 'N', 'N', 'N', '145', NULL, '03', 'N', NULL, NULL, NULL, 147);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241340', '2404', 'RN', '2490', '2402', '24011', '24', 'SERRA NEGRA DO NORTE', NULL, '84', '59318000', '9', '1865', '1865', '18133', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 562.395, '-6,66600', '-37,39700', 167, 'S', 0.6630, NULL, NULL, '24900', 'S', 'N', 4950, NULL, '2490', '2490', NULL, '1874', 'S', 3818, 'SERRA NEGRA DO NORTE', 'N', '241340', 'N', 'S', 'S', NULL, 76, 'S', 'N', 'N', '146', NULL, '03', 'N', NULL, NULL, NULL, 83);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241450', '2406', 'RN', '2490', '2401', '24007', '24', 'UMARIZAL', NULL, '84', '59865000', '6', '1887', '1887', '18144', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 213.582, '-5,99100', '-37,81400', 166, 'S', 0.6430, NULL, NULL, '24900', 'S', 'N', 5307, NULL, '2490', '2490', NULL, '1958', 'S', 3833, 'UMARIZAL', 'N', '241450', 'N', 'S', 'S', NULL, 32, 'S', 'N', 'N', '161', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241460', '2402', 'RN', '2490', '2401', '24003', '24', 'UPANEMA', NULL, '84', '59670000', '5', '1889', '1889', '18145', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 881.806, '-5,64200', '-37,25800', 47, 'S', 0.5890, NULL, NULL, '24900', 'S', 'N', 5326, NULL, '2490', '2490', NULL, '1953', 'S', 3834, 'UPANEMA', 'N', '241460', 'N', 'S', 'S', NULL, 32, 'S', 'N', 'N', '162', NULL, '03', 'N', NULL, NULL, NULL, 147);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241470', '2401', 'RN', '2490', '2403', '24015', '24', 'VARZEA', NULL, '84', '59185000', '4', '1891', '1891', '18146', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 67.245, '-6,34800', '-35,37600', 59, 'S', 0.6210, NULL, NULL, '24900', 'S', 'N', 5384, NULL, '2490', '2490', NULL, '1959', 'S', 3835, 'VÁRZEA', 'N', '241470', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '163', NULL, '03', 'N', NULL, NULL, NULL, 148);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241475', '2406', 'RN', '2490', '2401', '24005', '24', 'VENHA-VER', NULL, '84', '59925000', '3', '0438', NULL, '18158', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 71.622, '-6,32600', '-38,48400', 650, 'S', 0.5440, NULL, NULL, '24900', 'S', 'N', 5400, NULL, '2490', '2490', NULL, '1997', 'S', 3836, 'VENHA-VER', 'N', '241475', 'N', 'S', 'S', NULL, 134, 'S', 'N', 'N', '164', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241480', '2401', 'RN', '2490', '2403', '24015', '24', 'VERA CRUZ', NULL, '84', '59184000', '3', '1895', '1895', '18148', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 92.117, '-6,04400', '-35,42800', 94, 'S', 0.6070, NULL, NULL, '24900', 'S', 'N', 5407, NULL, '2401', '2490', NULL, '1963', 'S', 3837, 'VERA CRUZ', 'N', '241480', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '165', NULL, '03', 'N', NULL, NULL, NULL, 148);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241490', '2406', 'RN', '2490', '2401', '24006', '24', 'VICOSA', NULL, '84', '59815000', '2', '1897', '1897', '18149', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 37.905, '-5,99400', '-37,94400', 200, 'S', 0.6530, NULL, NULL, '24900', 'S', 'N', 5431, NULL, '2490', '2490', NULL, '1963', 'S', 3838, 'VIÇOSA', 'N', '241490', 'N', 'S', 'S', NULL, 134, 'S', 'N', 'N', '166', NULL, '03', 'N', NULL, NULL, NULL, 85);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('241500', '2401', 'RN', '2490', '2404', '24019', '24', 'VILA FLOR', NULL, '84', '59192000', '8', '1899', '1899', '18150', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 47.656, '-6,31400', '-35,07700', 40, 'S', 0.6390, NULL, NULL, '24900', 'S', 'N', 5444, NULL, '2490', '2490', NULL, '1963', 'S', 3839, 'VILA FLOR', 'N', '241500', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '167', NULL, '03', 'N', NULL, NULL, NULL, 148);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250010', '2511', 'PB', '2590', '2501', '25007', '25', 'AGUA BRANCA', NULL, '83', '58748000', '6', '1901', '1901', '13001', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 220.648, '-7,51200', '-37,64100', 735, 'S', 0.5630, NULL, NULL, '25900', 'S', 'N', 48, NULL, '2590', '2590', NULL, '1959', 'S', 2555, 'ÁGUA BRANCA', 'N', '250010', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '1', NULL, '03', 'N', NULL, NULL, NULL, 135);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250020', '2507', 'PB', '2590', '2501', '25005', '25', 'AGUIAR', NULL, '83', '58778000', '5', '1903', '1903', '13002', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 344.691, '-7,09200', '-38,17100', 262, 'S', 0.5600, NULL, NULL, '25900', 'S', 'N', 79, NULL, '2590', '2590', NULL, '1961', 'S', 2556, 'AGUIAR', 'N', '250020', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '2', NULL, '03', 'N', NULL, NULL, NULL, 73);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250030', '2503', 'PB', '2590', '2503', '25015', '25', 'ALAGOA GRANDE', NULL, '83', '58388000', '4', '1905', '1905', '13003', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 320.558, '-7,08900', '-35,63500', 143, 'S', 0.6090, NULL, NULL, '25900', 'S', 'N', 87, NULL, '2590', '2590', NULL, '1864', 'S', 2557, 'ALAGOA GRANDE', 'N', '250030', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '3', NULL, '03', 'N', NULL, NULL, NULL, 310);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250040', '2503', 'PB', '2590', '2503', '25015', '25', 'ALAGOA NOVA', NULL, '83', '58125000', '3', '1907', '1907', '13004', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 122.254, '-7,07100', '-35,75800', 530, 'S', 0.6120, NULL, NULL, '25900', 'S', 'N', 88, NULL, '2502', '2590', NULL, '1904', 'S', 2558, 'ALAGOA NOVA', 'N', '250040', 'N', 'S', 'S', NULL, 24, 'S', 'N', 'N', '4', NULL, '03', 'N', NULL, NULL, NULL, 310);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250050', '2502', 'PB', '2590', '2503', '25016', '25', 'ALAGOINHA', NULL, '83', '58390000', '2', '1909', '1909', '13005', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 85.060, '-6,95000', '-35,54500', 133, 'S', 0.5730, NULL, NULL, '25900', 'S', 'N', 89, NULL, '2503', '2590', NULL, '1953', 'S', 2559, 'ALAGOINHA', 'N', '250050', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '5', NULL, '03', 'N', NULL, NULL, NULL, 420);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250053', '2503', 'PB', '2590', '2502', '25011', '25', 'ALCANTIL', NULL, '83', '58460000', '6', '0440', '0440', '13173', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'S', NULL, 'N', 305.391, '-7,74400', '-36,05600', 500, 'S', 0.6060, NULL, NULL, '25900', 'S', 'N', 97, NULL, '2502', '2590', NULL, '1997', 'S', 2560, 'ALCANTIL', 'N', '250053', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '6', NULL, '03', 'N', NULL, NULL, NULL, 72);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250070', '2509', 'PB', '2590', '2501', '25002', '25', 'SAO JOAO DO RIO DO PEIXE', NULL, '83', '58910000', '0', '1913', '1913', '13007', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 474.426, '-6,72900', '-38,44900', 245, 'S', 0.5950, NULL, NULL, '25900', 'S', 'N', 4666, NULL, '2590', '2590', NULL, '1881', 'S', 2736, 'SÃO JOÃO DO RIO DO PEIXE', 'N', '250070', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '183', NULL, '03', 'N', NULL, NULL, NULL, 74);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250073', '2505', 'PB', '2590', '2502', '25010', '25', 'AMPARO', NULL, '83', '58548000', '4', '0444', '0444', '13175', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 121.983, '-7,56800', '-37,06400', 635, 'S', 0.6030, NULL, NULL, '25900', 'S', 'N', 202, NULL, '2590', '2590', NULL, '1997', 'S', 2563, 'AMPARO', 'N', '250073', 'N', 'S', 'S', NULL, 27, 'N', 'N', 'N', '9', NULL, '03', 'N', NULL, NULL, NULL, 253);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250077', '2510', 'PB', '2590', '2501', '25003', '25', 'APARECIDA', NULL, '83', '58823000', '5', '0446', '0446', '13176', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 229.153, '-6,78400', '-38,08700', 214, 'S', 0.6280, NULL, NULL, '25900', 'S', 'N', 266, NULL, '2590', '2590', NULL, '1997', 'S', 2564, 'APARECIDA', 'N', '250077', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '10', NULL, '03', 'N', NULL, NULL, NULL, 195);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250080', '2502', 'PB', '2590', '2503', '25016', '25', 'ARACAGI', NULL, '83', '58270000', '9', '1915', '1915', '13008', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 229.722, '-6,85300', '-35,38100', 57, 'S', 0.5600, NULL, NULL, '25900', 'S', 'N', 289, NULL, '2503', '2590', NULL, '1959', 'S', 2565, 'ARAÇAGI', 'N', '250080', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '11', NULL, '03', 'N', NULL, NULL, NULL, 420);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250090', '2503', 'PB', '2590', '2503', '25012', '25', 'ARARA', NULL, '83', '58396000', '8', '1917', '1917', '13009', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'S', NULL, 'N', 88.858, '-6,82800', '-35,75800', 467, 'S', 0.5510, NULL, NULL, '25900', 'S', 'N', 337, NULL, '2590', '2590', NULL, '1961', 'S', 2566, 'ARARA', 'N', '250090', 'N', 'S', 'S', NULL, 24, 'S', 'N', 'N', '12', NULL, '03', 'N', NULL, NULL, NULL, 310);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250100', '2502', 'PB', '2590', '2503', '25013', '25', 'ARARUNA', NULL, '83', '58233000', '5', '1919', '1919', '13010', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'S', NULL, 'N', 245.720, '-6,55800', '-35,74200', 570, 'S', 0.5460, NULL, NULL, '25900', 'S', 'N', 348, NULL, '2590', '2590', NULL, '1876', 'S', 2567, 'ARARUNA', 'N', '250100', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '13', NULL, '03', 'N', NULL, NULL, NULL, 420);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250110', '2503', 'PB', '2590', '2503', '25015', '25', 'AREIA', NULL, '83', '58397000', '4', '1921', '1921', '13011', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 269.424, '-6,96300', '-35,69200', 618, 'S', 0.6110, NULL, NULL, '25900', 'S', 'N', 364, NULL, '2590', '2590', NULL, '1815', 'S', 2568, 'AREIA', 'N', '250110', 'N', 'S', 'S', NULL, 24, 'N', 'N', 'S', '14', NULL, '03', 'N', NULL, NULL, NULL, 310);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250115', '2506', 'PB', '2590', '2501', '25004', '25', 'AREIA DE BARAUNAS', NULL, '83', '58732000', '3', '0448', '0448', '13177', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'S', 'S', NULL, 'N', 96.342, '-7,12300', '-36,94100', 371, 'S', 0.5710, NULL, NULL, '25900', 'S', 'N', 367, NULL, '2504', '2590', NULL, '1997', 'S', 2569, 'AREIA DE BARAÚNAS', 'N', '250115', 'N', 'S', 'S', NULL, 59, 'N', 'N', 'N', '15', NULL, '03', 'N', NULL, NULL, NULL, 254);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250120', '2503', 'PB', '2590', '2503', '25014', '25', 'AREIAL', NULL, '83', '58140000', '3', '1923', '1923', '13012', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'S', NULL, 'N', 33.935, '-7,04800', '-35,93100', 695, 'S', 0.5990, NULL, NULL, '25900', 'S', 'N', 368, NULL, '2502', '2590', NULL, '1961', 'S', 2570, 'AREIAL', 'N', '250120', 'N', 'S', 'S', NULL, 24, 'N', 'N', 'N', '16', NULL, '03', 'N', NULL, NULL, NULL, 310);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250130', '2503', 'PB', '2590', '2503', '25019', '25', 'AROEIRAS', NULL, '83', '58489000', '2', '1925', '1925', '13013', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'S', 'S', NULL, 'N', 374.674, '-7,54500', '-35,70800', 363, 'S', 0.5590, NULL, NULL, '25900', 'S', 'N', 385, NULL, '2502', '2590', NULL, '1953', 'S', 2571, 'AROEIRAS', 'N', '250130', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '17', NULL, '03', 'N', NULL, NULL, NULL, 72);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250190', '2502', 'PB', '2590', '2503', '25016', '25', 'BELEM', NULL, '83', '58255000', '6', '1939', '1939', '13020', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 100.143, '-6,74700', '-35,51900', 149, 'S', 0.5950, NULL, NULL, '25900', 'S', 'N', 573, NULL, '2503', '2590', NULL, '1957', 'S', 2581, 'BELÉM', 'N', '250190', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '26', NULL, '03', 'N', NULL, NULL, NULL, 420);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270340', '2707', 'AL', '2702', '2701', '27004', '27', 'JACARE DOS HOMENS', NULL, '82', '57430000', '3', '2767', '2767', '02034', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 142.344, '-9,63600', '-37,20500', 135, 'S', 0.5710, NULL, NULL, '27006', 'S', 'N', 2444, NULL, '2790', '2790', NULL, '1957', 'S', 59, 'JACARÉ DOS HOMENS', 'N', '270340', 'N', 'S', 'S', NULL, 36, 'S', 'N', 'N', '37', NULL, '03', 'N', NULL, NULL, NULL, 45);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270350', '2702', 'AL', '2701', '2703', '27009', '27', 'JACUIPE', NULL, '82', '57960000', '2', '2769', '2769', '02035', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 216.762, '-8,84200', '-35,46000', 74, 'S', 0.5480, NULL, NULL, '27002', 'S', 'N', 2455, NULL, '2790', '2790', NULL, '1958', 'S', 60, 'JACUÍPE', 'N', '270350', 'N', 'S', 'S', NULL, 41, 'S', 'N', 'N', '38', NULL, '03', 'N', NULL, NULL, NULL, 2);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270360', '2702', 'AL', '2701', '2703', '27010', '27', 'JAPARATINGA', NULL, '82', '57950000', '1', '2771', '2771', '02036', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 85.502, '-9,08800', '-35,25800', 5, 'S', 0.6130, NULL, NULL, '27002', 'S', 'N', 2491, NULL, '2790', '2790', NULL, '1960', 'S', 61, 'JAPARATINGA', 'N', '270360', 'N', 'S', 'S', NULL, 41, 'S', 'N', 'N', '39', NULL, '03', 'N', NULL, NULL, NULL, 2);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270370', '2707', 'AL', '2702', '2701', '27004', '27', 'JARAMATAIA', NULL, '82', '57425000', '0', '2773', '2773', '02037', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 103.710, '-9,65900', '-37,00200', 164, 'S', 0.5800, NULL, NULL, '27005', 'S', 'N', 2506, NULL, '2702', '2790', NULL, '1962', 'S', 62, 'JARAMATAIA', 'N', '270370', 'N', 'S', 'S', NULL, 36, 'S', 'N', 'N', '40', NULL, '03', 'N', NULL, NULL, NULL, 45);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270375', '2706', 'AL', '2701', '2703', '27012', '27', 'JEQUIA DA PRAIA', NULL, '82', '57244000', '9', '0562', NULL, '02102', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 338.600, '-10,01200', '-36,02100', 0, 'S', NULL, NULL, NULL, '27003', 'S', 'N', 5622, NULL, '2790', '2790', NULL, '2001', 'S', 5556, 'JEQUIÁ DA PRAIA', 'N', '270375', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '41', NULL, '03', 'N', NULL, NULL, NULL, 395);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270380', '2703', 'AL', '2701', '2703', '27009', '27', 'JOAQUIM GOMES', NULL, '82', '57980000', '9', '2775', '2775', '02038', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 238.595, '-9,13300', '-35,74800', 104, 'S', 0.5400, NULL, NULL, '27012', 'S', 'N', 2569, NULL, '2790', '2790', NULL, '1962', 'S', 63, 'JOAQUIM GOMES', 'N', '270380', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '42', NULL, '03', 'N', NULL, NULL, NULL, 169);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270390', '2703', 'AL', '2701', '2703', '27009', '27', 'JUNDIA', NULL, '82', '57965000', '8', '2777', '2777', '02039', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 119.713, '-8,93500', '-35,57400', 94, 'S', 0.5600, NULL, NULL, '27012', 'S', 'N', 2607, NULL, '2790', '2790', NULL, '1960', 'S', 64, 'JUNDIÁ', 'N', '270390', 'N', 'S', 'S', NULL, 41, 'S', 'N', 'N', '43', NULL, '03', 'N', NULL, NULL, NULL, 169);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270400', '2705', 'AL', '2701', '2703', '27012', '27', 'JUNQUEIRO', NULL, '82', '57270000', '5', '2779', '2779', '02040', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 254.067, '-9,92500', '-36,47600', 175, 'S', 0.6150, NULL, NULL, '27013', 'S', 'N', 2610, NULL, '2702', '2790', NULL, '1947', 'S', 65, 'JUNQUEIRO', 'N', '270400', 'N', 'S', 'S', NULL, 39, 'S', 'N', 'N', '44', NULL, '03', 'N', NULL, NULL, NULL, 394);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270410', '2707', 'AL', '2702', '2702', '27006', '27', 'LAGOA DA CANOA', NULL, '82', '57330000', '4', '2781', '2781', '02041', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 102.831, '-9,83000', '-36,73800', 283, 'S', 0.5800, NULL, NULL, '27005', 'S', 'N', 2651, NULL, '2702', '2790', NULL, '1962', 'S', 66, 'LAGOA DA CANOA', 'N', '270410', 'N', 'S', 'S', NULL, 39, 'N', 'N', 'N', '45', NULL, '03', 'N', NULL, NULL, NULL, 45);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270420', '2707', 'AL', '2702', '2702', '27006', '27', 'LIMOEIRO DE ANADIA', NULL, '82', '57260000', '3', '2783', '2783', '02042', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 315.668, '-9,74100', '-36,50300', 140, 'S', 0.5690, NULL, NULL, '27005', 'S', 'N', 2743, NULL, '2702', '2790', NULL, '1882', 'S', 67, 'LIMOEIRO DE ANADIA', 'N', '270420', 'N', 'S', 'S', NULL, 39, 'S', 'N', 'N', '46', NULL, '03', 'N', NULL, NULL, NULL, 45);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270430', '2701', 'AL', '2701', '2703', '27011', '27', 'MACEIO', NULL, '82', '57020970', '2', '2785', '2785', '02043', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'S', 510.655, '-9,66600', '-35,73500', 16, 'S', 0.7390, NULL, NULL, '27001', 'N', 'N', 2804, NULL, '2701', '2701', NULL, '1815', 'S', 68, 'MACEIÓ', 'N', '270430', 'N', 'S', 'S', NULL, NULL, 'S', 'S', 'S', '47', NULL, '01', 'N', NULL, NULL, NULL, 44);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270440', '2707', 'AL', '2702', '2701', '27004', '27', 'MAJOR ISIDORO', NULL, '82', '57580000', '1', '2787', '2787', '02044', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 453.893, '-9,53200', '-36,98500', 182, 'S', 0.5240, NULL, NULL, '27009', 'S', 'N', 2831, NULL, '2790', '2790', NULL, '1949', 'S', 69, 'MAJOR ISIDORO', 'N', '270440', 'N', 'S', 'S', NULL, 36, 'S', 'N', 'N', '48', NULL, '03', 'N', NULL, NULL, NULL, 45);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270450', '2702', 'AL', '2701', '2703', '27010', '27', 'MARAGOGI', NULL, '82', '57955000', '0', '2789', '2789', '02045', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 333.733, '-9,01200', '-35,22200', 5, 'S', 0.6190, NULL, NULL, '27002', 'S', 'N', 2885, NULL, '2790', '2790', NULL, '1875', 'S', 71, 'MARAGOGI', 'N', '270450', 'N', 'S', 'S', NULL, 41, 'S', 'N', 'N', '50', NULL, '03', 'N', NULL, NULL, NULL, 2);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270460', '2709', 'AL', '2702', '2701', '27003', '27', 'MARAVILHA', NULL, '82', '57520000', '9', '2791', '2791', '02046', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 279.462, '-9,23600', '-37,35000', 362, 'S', 0.5630, NULL, NULL, '27008', 'S', 'N', 2897, NULL, '2790', '2790', NULL, '1958', 'S', 72, 'MARAVILHA', 'N', '270460', 'N', 'S', 'S', NULL, 42, 'S', 'N', 'N', '51', NULL, '03', 'N', NULL, NULL, NULL, 46);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270470', '2701', 'AL', '2701', '2703', '27011', '27', 'MARECHAL DEODORO', NULL, '82', '57160000', '8', '2793', '2793', '02047', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 333.548, '-9,71000', '-35,89500', 31, 'S', 0.6490, NULL, NULL, '27001', 'N', 'N', 2909, NULL, '2701', '2790', NULL, '1636', 'S', 73, 'MARECHAL DEODORO', 'N', '270470', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '52', NULL, '03', 'N', NULL, NULL, NULL, 44);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270480', '2708', 'AL', '2702', '2702', '27005', '27', 'MARIBONDO', NULL, '82', '57670000', '7', '2795', '2795', '02048', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 171.279, '-9,57700', '-36,30500', 157, 'S', 0.6360, NULL, NULL, '27009', 'S', 'N', 2922, NULL, '2790', '2790', NULL, '1962', 'S', 74, 'MARIBONDO', 'N', '270480', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '53', NULL, '03', 'N', NULL, NULL, NULL, 396);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270490', '2704', 'AL', '2701', '2702', '27005', '27', 'MAR VERMELHO', NULL, '82', '57730000', '6', '2797', '2797', '02049', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 91.538, '-9,44800', '-36,38800', 542, 'S', 0.6110, NULL, NULL, '27009', 'S', 'N', 2873, NULL, '2790', '2790', NULL, '1962', 'S', 70, 'MAR VERMELHO', 'N', '270490', 'N', 'S', 'S', NULL, 126, 'S', 'N', 'N', '49', NULL, '03', 'N', NULL, NULL, NULL, 393);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270500', '2710', 'AL', '2702', '2701', '27001', '27', 'MATA GRANDE', NULL, '82', '57540000', '2', '2799', '2799', '02050', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 908.264, '-9,11800', '-37,73400', 633, 'S', 0.5630, NULL, NULL, '27007', 'S', 'N', 2958, NULL, '2790', '2790', NULL, '1837', 'S', 75, 'MATA GRANDE', 'N', '270500', 'N', 'S', 'S', NULL, 40, 'S', 'N', 'N', '54', NULL, '03', 'N', NULL, NULL, NULL, 226);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270510', '2702', 'AL', '2701', '2703', '27009', '27', 'MATRIZ DE CAMARAGIBE', NULL, '82', '57910000', '1', '2801', '2801', '02051', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 330.061, '-9,15200', '-35,53300', 16, 'S', 0.5680, NULL, NULL, '27002', 'S', 'N', 2986, NULL, '2790', '2790', NULL, '1958', 'S', 76, 'MATRIZ DE CAMARAGIBE', 'N', '270510', 'N', 'S', 'S', NULL, 41, 'S', 'N', 'N', '55', NULL, '03', 'N', NULL, NULL, NULL, 2);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270520', '2701', 'AL', '2701', '2703', '27009', '27', 'MESSIAS', NULL, '82', '57990000', '0', '2803', '2803', '02052', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 112.856, '-9,38300', '-35,84200', 148, 'S', 0.5980, NULL, NULL, '27001', 'S', 'N', 3015, NULL, '2701', '2790', NULL, '1962', 'S', 77, 'MESSIAS', 'N', '270520', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '56', NULL, '03', 'N', NULL, NULL, NULL, 44);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270530', '2708', 'AL', '2702', '2702', '27005', '27', 'MINADOR DO NEGRAO', NULL, '82', '57615000', '9', '2805', '2805', '02053', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 164.476, '-9,30500', '-36,86500', 270, 'S', 0.5690, NULL, NULL, '27009', 'S', 'N', 3030, NULL, '2790', '2790', NULL, '1962', 'S', 78, 'MINADOR DO NEGRÃO', 'N', '270530', 'N', 'S', 'S', NULL, 36, 'S', 'N', 'N', '57', NULL, '03', 'N', NULL, NULL, NULL, 396);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270540', '2709', 'AL', '2702', '2701', '27004', '27', 'MONTEIROPOLIS', NULL, '82', '57440000', '8', '2807', '2807', '02054', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 86.097, '-9,60300', '-37,24800', 228, 'S', 0.5730, NULL, NULL, '27006', 'S', 'N', 3124, NULL, '2790', '2790', NULL, '1960', 'S', 79, 'MONTEIRÓPOLIS', 'N', '270540', 'N', 'S', 'S', NULL, 36, 'S', 'N', 'N', '58', NULL, '03', 'N', NULL, NULL, NULL, 46);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270550', '2703', 'AL', '2701', '2703', '27009', '27', 'MURICI', NULL, '82', '57820000', '7', '2809', '2809', '02055', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 423.983, '-9,30700', '-35,94300', 82, 'S', 0.5800, NULL, NULL, '27011', 'S', 'N', 3186, NULL, '2790', '2790', NULL, '1872', 'S', 80, 'MURICI', 'N', '270550', 'N', 'S', 'S', NULL, 126, 'S', 'N', 'N', '59', NULL, '03', 'N', NULL, NULL, NULL, 169);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270560', '2703', 'AL', '2701', '2703', '27009', '27', 'NOVO LINO', NULL, '82', '57970000', '6', '2811', '2811', '02056', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 182.288, '-8,91500', '-35,64700', 146, 'S', 0.5340, NULL, NULL, '27012', 'S', 'N', 3367, NULL, '2790', '2790', NULL, '1962', 'S', 81, 'NOVO LINO', 'N', '270560', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '60', NULL, '03', 'N', NULL, NULL, NULL, 169);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270570', '2709', 'AL', '2702', '2701', '27004', '27', 'OLHO D''AGUA DAS FLORES', NULL, '82', '57442000', '5', '2813', '2813', '02057', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 183.440, '-9,53600', '-37,29400', 286, 'S', 0.6060, NULL, NULL, '27008', 'S', 'N', 3392, NULL, '2790', '2790', NULL, '1953', 'S', 83, 'OLHO D ÁGUA DAS FLORES', 'N', '270570', 'N', 'S', 'S', NULL, 36, 'S', 'N', 'N', '61', NULL, '03', 'N', NULL, NULL, NULL, 46);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270580', '2710', 'AL', '2702', '2701', '27002', '27', 'OLHO D''AGUA DO CASADO', NULL, '82', '57470000', '4', '2815', '2815', '02058', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 322.945, '-9,50100', '-37,83200', 230, 'S', 0.5420, NULL, NULL, '27007', 'S', 'N', 3393, NULL, '2790', '2790', NULL, '1962', 'S', 84, 'OLHO D ÁGUA DO CASADO', 'N', '270580', 'N', 'S', 'S', NULL, 40, 'S', 'N', 'N', '62', NULL, '03', 'N', NULL, NULL, NULL, 226);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270590', '2707', 'AL', '2702', '2702', '27007', '27', 'OLHO D''AGUA GRANDE', NULL, '82', '57390000', '3', '2817', '2817', '02059', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 118.508, '-10,05800', '-36,81700', 118, 'S', 0.5440, NULL, NULL, '27005', 'S', 'N', 3394, NULL, '2702', '2790', NULL, '1962', 'S', 82, 'OLHO D ÁGUA GRANDE', 'N', '270590', 'N', 'S', 'S', NULL, 39, 'S', 'N', 'N', '63', NULL, '03', 'N', NULL, NULL, NULL, 45);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270600', '2709', 'AL', '2702', '2701', '27004', '27', 'OLIVENCA', NULL, '82', '57550000', '0', '2819', '2819', '02060', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 172.957, '-9,51900', '-37,19100', 231, 'S', 0.5340, NULL, NULL, '27008', 'S', 'N', 3408, NULL, '2790', '2790', NULL, '1958', 'S', 85, 'OLIVENÇA', 'N', '270600', 'N', 'S', 'S', NULL, 42, 'S', 'N', 'N', '64', NULL, '03', 'N', NULL, NULL, NULL, 46);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270610', '2709', 'AL', '2702', '2701', '27003', '27', 'OURO BRANCO', NULL, '82', '57525000', '9', '2821', '2821', '02061', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 204.841, '-9,16700', '-37,35700', 380, 'S', 0.5990, NULL, NULL, '27008', 'S', 'N', 3436, NULL, '2790', '2790', NULL, '1962', 'S', 86, 'OURO BRANCO', 'N', '270610', 'N', 'S', 'S', NULL, 42, 'N', 'N', 'N', '65', NULL, '03', 'N', NULL, NULL, NULL, 46);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270620', '2709', 'AL', '2702', '2701', '27003', '27', 'PALESTINA', NULL, '82', '57410000', '8', '2823', '2823', '02062', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 48.884, '-9,67200', '-37,32900', 160, 'S', 0.5710, NULL, NULL, '27006', 'S', 'N', 3473, NULL, '2790', '2790', NULL, '1962', 'S', 87, 'PALESTINA', 'N', '270620', 'N', 'S', 'S', NULL, 36, 'N', 'N', 'N', '66', NULL, '03', 'N', NULL, NULL, NULL, 46);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270630', '2708', 'AL', '2702', '2702', '27005', '27', 'PALMEIRA DOS INDIOS', NULL, '82', '57600000', '7', '2825', '2825', '02063', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 460.610, '-9,40700', '-36,62800', 342, 'S', 0.6660, NULL, NULL, '27009', 'N', 'N', 3493, NULL, '2702', '2790', NULL, '1835', 'S', 88, 'PALMEIRA DOS ÍNDIOS', 'N', '270630', 'N', 'S', 'S', NULL, 39, 'S', 'N', 'S', '67', NULL, '01', 'N', NULL, NULL, NULL, 396);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270640', '2709', 'AL', '2702', '2701', '27003', '27', 'PAO DE ACUCAR', NULL, '82', '57400000', '6', '2827', '2827', '02064', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 658.955, '-9,74800', '-37,43700', 19, 'S', 0.6140, NULL, NULL, '27006', 'S', 'N', 3516, NULL, '2790', '2790', NULL, '1854', 'S', 89, 'PÃO DE AÇÚCAR', 'N', '270640', 'N', 'S', 'S', NULL, 36, 'S', 'N', 'N', '68', NULL, '03', 'N', NULL, NULL, NULL, 46);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270642', '2710', 'AL', '2702', '2701', '27001', '27', 'PARICONHA', NULL, '82', '57475000', '2', '2645', '2645', '02098', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'S', NULL, 'N', 260.858, '-9,25400', '-38,00600', 0, 'S', 0.5510, NULL, NULL, '27007', 'S', 'N', 3568, NULL, '2790', '2790', NULL, '1993', 'S', 90, 'PARICONHA', 'N', '270642', 'N', 'S', 'S', NULL, 40, 'S', 'N', 'N', '69', NULL, '03', 'N', NULL, NULL, NULL, 226);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270644', '2701', 'AL', '2701', '2703', '27011', '27', 'PARIPUEIRA', NULL, '82', '57935000', '8', '2641', '2641', '02099', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 92.712, '-9,46500', '-35,55200', 0, 'S', 0.6170, NULL, NULL, '27001', 'S', 'N', 3571, NULL, '2701', '2701', NULL, '1993', 'S', 91, 'PARIPUEIRA', 'N', '270644', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '70', NULL, '03', 'N', NULL, NULL, NULL, 44);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270650', '2702', 'AL', '2701', '2703', '27010', '27', 'PASSO DE CAMARAGIBE', NULL, '82', '57930000', '5', '2829', '2829', '02065', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 187.197, '-9,23800', '-35,49300', 4, 'S', 0.5630, NULL, NULL, '27002', 'S', 'N', 3591, NULL, '2790', '2790', NULL, '1852', 'S', 92, 'PASSO DE CAMARAGIBE', 'N', '270650', 'N', 'S', 'S', NULL, 41, 'S', 'N', 'N', '71', NULL, '03', 'N', NULL, NULL, NULL, 2);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270660', '2704', 'AL', '2701', '2702', '27005', '27', 'PAULO JACINTO', NULL, '82', '57740000', '4', '2831', '2831', '02066', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 107.943, '-9,36600', '-36,37000', 292, 'S', 0.6020, NULL, NULL, '27010', 'S', 'N', 3628, NULL, '2790', '2790', NULL, '1953', 'S', 93, 'PAULO JACINTO', 'N', '270660', 'N', 'S', 'S', NULL, 126, 'S', 'N', 'N', '72', NULL, '03', 'N', NULL, NULL, NULL, 393);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270670', '2706', 'AL', '2701', '2703', '27013', '27', 'PENEDO', NULL, '82', '57200000', '3', '2833', '2833', '02067', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 689.269, '-10,29000', '-36,58600', 27, 'S', 0.6650, NULL, NULL, '27004', 'N', 'N', 3688, NULL, '2790', '2790', NULL, '1636', 'S', 94, 'PENEDO', 'N', '270670', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '73', NULL, '02', 'N', NULL, NULL, NULL, 395);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270680', '2706', 'AL', '2701', '2703', '27013', '27', 'PIACABUCU', NULL, '82', '57210000', '2', '2835', '2835', '02068', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 239.989, '-10,40600', '-36,43400', 3, 'S', 0.6130, NULL, NULL, '27004', 'S', 'N', 3717, NULL, '2790', '2790', NULL, '1882', 'S', 95, 'PIAÇABUÇU', 'N', '270680', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '74', NULL, '03', 'N', NULL, NULL, NULL, 395);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270690', '2701', 'AL', '2701', '2703', '27011', '27', 'PILAR', NULL, '82', '57150000', '1', '2837', '2837', '02069', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 248.975, '-9,59700', '-35,95700', 13, 'S', 0.6040, NULL, NULL, '27001', 'N', 'N', 3734, NULL, '2701', '2790', NULL, '1857', 'S', 96, 'PILAR', 'N', '270690', 'N', 'S', 'S', NULL, 126, 'S', 'N', 'N', '75', NULL, '03', 'N', NULL, NULL, NULL, 44);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270700', '2704', 'AL', '2701', '2703', '27008', '27', 'PINDOBA', NULL, '82', '57720000', '8', '2839', '2839', '02070', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 83.218, '-9,47500', '-36,29000', 310, 'S', 0.5610, NULL, NULL, '27010', 'S', 'N', 3748, NULL, '2790', '2790', NULL, '1957', 'S', 97, 'PINDOBA', 'N', '270700', 'N', 'S', 'S', NULL, 126, 'S', 'N', 'N', '76', NULL, '03', 'N', NULL, NULL, NULL, 393);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270710', '2710', 'AL', '2702', '2701', '27002', '27', 'PIRANHAS', NULL, '82', '57460000', '7', '2841', '2841', '02071', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 407.647, '-9,62400', '-37,75700', 88, 'S', 0.6070, NULL, NULL, '27007', 'S', 'N', 3793, NULL, '2790', '2790', NULL, '1887', 'S', 98, 'PIRANHAS', 'N', '270710', 'N', 'S', 'S', NULL, 40, 'N', 'N', 'N', '77', NULL, '03', 'N', NULL, NULL, NULL, 226);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270720', '2709', 'AL', '2702', '2701', '27003', '27', 'POCO DAS TRINCHEIRAS', NULL, '82', '57510000', '6', '2843', '2843', '02072', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 302.916, '-9,31300', '-37,28600', 292, 'S', 0.4990, NULL, NULL, '27008', 'S', 'N', 3842, NULL, '2790', '2790', NULL, '1958', 'S', 99, 'POÇO DAS TRINCHEIRAS', 'N', '270720', 'N', 'S', 'S', NULL, 42, 'S', 'N', 'N', '78', NULL, '03', 'N', NULL, NULL, NULL, 46);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270730', '2702', 'AL', '2701', '2703', '27009', '27', 'PORTO CALVO', NULL, '82', '57900000', '5', '2845', '2845', '02073', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 260.158, '-9,04500', '-35,39800', 54, 'S', 0.5990, NULL, NULL, '27002', 'S', 'N', 3904, NULL, '2790', '2790', NULL, '1636', 'S', 100, 'PORTO CALVO', 'N', '270730', 'N', 'S', 'S', NULL, 41, 'S', 'N', 'N', '79', NULL, '03', 'N', NULL, NULL, NULL, 2);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270740', '2702', 'AL', '2701', '2703', '27010', '27', 'PORTO DE PEDRAS', NULL, '82', '57945000', '4', '2847', '2847', '02074', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 266.236, '-9,15800', '-35,29500', 22, 'S', 0.4990, NULL, NULL, '27002', 'S', 'N', 3907, NULL, '2790', '2790', NULL, '1815', 'S', 101, 'PORTO DE PEDRAS', 'N', '270740', 'N', 'S', 'S', NULL, 41, 'S', 'N', 'N', '80', NULL, '03', 'N', NULL, NULL, NULL, 2);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270750', '2706', 'AL', '2701', '2703', '27013', '27', 'PORTO REAL DO COLEGIO', NULL, '82', '57290000', '3', '2849', '2849', '02075', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 240.310, '-10,18600', '-36,84000', 10, 'S', 0.5660, NULL, NULL, '27004', 'S', 'N', 3922, NULL, '2790', '2790', NULL, '1876', 'S', 102, 'PORTO REAL DO COLÉGIO', 'N', '270750', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '81', NULL, '03', 'N', NULL, NULL, NULL, 395);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270760', '2704', 'AL', '2701', '2702', '27005', '27', 'QUEBRANGULO', NULL, '82', '57750000', '2', '2851', '2851', '02076', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 299.922, '-9,31900', '-36,47100', 366, 'S', 0.5740, NULL, NULL, '27009', 'S', 'N', 4016, NULL, '2790', '2790', NULL, '1872', 'S', 103, 'QUEBRANGULO', 'N', '270760', 'N', 'S', 'S', NULL, 126, 'S', 'N', 'N', '82', NULL, '03', 'N', NULL, NULL, NULL, 393);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270770', '2701', 'AL', '2701', '2703', '27011', '27', 'RIO LARGO', NULL, '82', '57100000', '1', '2853', '2853', '02077', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 309.425, '-9,47800', '-35,85300', 39, 'S', 0.6710, NULL, NULL, '27001', 'N', 'N', 4173, NULL, '2701', '2701', NULL, '1915', 'S', 104, 'RIO LARGO', 'N', '270770', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '83', NULL, '02', 'N', NULL, NULL, NULL, 44);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270780', '2705', 'AL', '2701', '2703', '27012', '27', 'ROTEIRO', NULL, '82', '57246000', '0', '2855', '2855', '02078', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 129.288, '-9,83300', '-35,97800', 32, 'S', 0.5220, NULL, NULL, '27003', 'S', 'N', 4231, NULL, '2790', '2790', NULL, '1963', 'S', 105, 'ROTEIRO', 'N', '270780', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '84', NULL, '03', 'N', NULL, NULL, NULL, 394);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270790', '2701', 'AL', '2701', '2703', '27011', '27', 'SANTA LUZIA DO NORTE', NULL, '82', '57130000', '9', '2857', '2857', '02079', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 28.541, '-9,60300', '-35,82200', 32, 'S', 0.6320, NULL, NULL, '27001', 'S', 'N', 4368, NULL, '2701', '2701', NULL, '1962', 'S', 106, 'SANTA LUZIA DO NORTE', 'N', '270790', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '85', NULL, '03', 'N', NULL, NULL, NULL, 44);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270800', '2709', 'AL', '2702', '2701', '27003', '27', 'SANTANA DO IPANEMA', NULL, '82', '57500000', '6', '2859', '2859', '02080', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 437.847, '-9,37800', '-37,24500', 250, 'S', 0.6160, NULL, NULL, '27008', 'N', 'N', 4450, NULL, '2790', '2790', NULL, '1875', 'S', 107, 'SANTANA DO IPANEMA', 'N', '270800', 'N', 'S', 'S', NULL, 42, 'S', 'N', 'S', '86', NULL, '03', 'N', NULL, NULL, NULL, 46);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270810', '2703', 'AL', '2701', '2703', '27008', '27', 'SANTANA DO MUNDAU', NULL, '82', '57840000', '5', '2861', '2861', '02081', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 223.615, '-9,16800', '-36,22200', 221, 'S', 0.5580, NULL, NULL, '27011', 'S', 'N', 4457, NULL, '2790', '2790', NULL, '1960', 'S', 108, 'SANTANA DO MUNDAÚ', 'N', '270810', 'N', 'S', 'S', NULL, 126, 'S', 'N', 'N', '87', NULL, '03', 'N', NULL, NULL, NULL, 169);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270830', '2703', 'AL', '2701', '2703', '27008', '27', 'SAO JOSE DA LAJE', NULL, '82', '57860000', '3', '2865', '2865', '02083', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 264.674, '-9,01000', '-36,05800', 256, 'S', 0.5880, NULL, NULL, '27011', 'S', 'N', 4689, NULL, '2790', '2790', NULL, '1876', 'S', 110, 'SÃO JOSÉ DA LAJE', 'N', '270830', 'N', 'S', 'S', NULL, 126, 'N', 'N', 'N', '89', NULL, '03', 'N', NULL, NULL, NULL, 169);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270840', '2709', 'AL', '2702', '2701', '27003', '27', 'SAO JOSE DA TAPERA', NULL, '82', '57445000', '2', '2867', '2867', '02084', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 519.626, '-9,55800', '-37,38100', 255, 'S', 0.5290, NULL, NULL, '27006', 'S', 'N', 4692, NULL, '2790', '2790', NULL, '1957', 'S', 111, 'SÃO JOSÉ DA TAPERA', 'N', '270840', 'N', 'S', 'S', NULL, 42, 'S', 'N', 'N', '90', NULL, '03', 'N', NULL, NULL, NULL, 46);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270850', '2702', 'AL', '2701', '2703', '27009', '27', 'SAO LUIS DO QUITUNDE', NULL, '82', '57920000', '1', '2869', '2869', '02085', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 404.005, '-9,31800', '-35,56100', 4, 'S', 0.5820, NULL, NULL, '27002', 'S', 'N', 4757, NULL, '2790', '2790', NULL, '1879', 'S', 112, 'SÃO LUÍS DO QUITUNDE', 'N', '270850', 'N', 'S', 'S', NULL, 41, 'S', 'N', 'S', '91', NULL, '03', 'N', NULL, NULL, NULL, 2);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250200', '2508', 'PB', '2590', '2501', '25001', '25', 'BELEM DO BREJO DO CRUZ', NULL, '83', '58895000', '3', '1941', '1941', '13021', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 603.038, '-6,18900', '-37,53600', 176, 'S', 0.5700, NULL, NULL, '25900', 'S', 'N', 576, NULL, '2590', '2590', NULL, '1961', 'S', 2582, 'BELÉM DO BREJO DO CRUZ', 'N', '250200', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '27', NULL, '03', 'N', NULL, NULL, NULL, 255);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250205', '2509', 'PB', '2590', '2501', '25002', '25', 'BERNARDINO BATISTA', NULL, '83', '58922000', '2', '0456', '0456', '13181', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 50.628, '-6,45200', '-38,55100', 700, 'S', 0.5520, NULL, NULL, '25900', 'S', 'N', 601, NULL, '2590', '2590', NULL, '1997', 'S', 2583, 'BERNARDINO BATISTA', 'N', '250205', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '28', NULL, '03', 'N', NULL, NULL, NULL, 74);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250210', '2507', 'PB', '2590', '2501', '25006', '25', 'BOA VENTURA', NULL, '83', '58993000', '2', '1943', '1943', '13022', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 132.136, '-7,41400', '-38,21600', 303, 'S', 0.6000, NULL, NULL, '25900', 'S', 'N', 631, NULL, '2590', '2590', NULL, '1961', 'S', 2584, 'BOA VENTURA', 'N', '250210', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '29', NULL, '03', 'N', NULL, NULL, NULL, 73);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250215', '2503', 'PB', '2590', '2503', '25017', '25', 'BOA VISTA', NULL, '83', '58123000', '1', '0458', '0458', '13182', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 476.539, '-7,25900', '-36,24000', 493, 'S', 0.6880, NULL, NULL, '25900', 'S', 'N', 634, NULL, '2502', '2590', NULL, '1997', 'S', 2585, 'BOA VISTA', 'N', '250215', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '30', NULL, '03', 'N', NULL, NULL, NULL, 419);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250220', '2509', 'PB', '2590', '2501', '25002', '25', 'BOM JESUS', NULL, '83', '58930000', '1', '1945', '1945', '13023', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 47.421, '-6,81700', '-38,65000', 318, 'S', 0.5800, NULL, NULL, '25900', 'S', 'N', 665, NULL, '2590', '2590', NULL, '1963', 'S', 2586, 'BOM JESUS', 'N', '250220', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '31', NULL, '03', 'N', NULL, NULL, NULL, 74);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250230', '2508', 'PB', '2590', '2501', '25001', '25', 'BOM SUCESSO', NULL, '83', '58887000', '0', '1947', '1947', '13024', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 184.101, '-6,44500', '-37,92900', 312, 'S', 0.6350, NULL, NULL, '25900', 'S', 'N', 690, NULL, '2590', '2590', NULL, '1963', 'S', 2587, 'BOM SUCESSO', 'N', '250230', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '32', NULL, '03', 'N', NULL, NULL, NULL, 255);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250240', '2509', 'PB', '2590', '2501', '25002', '25', 'BONITO DE SANTA FE', NULL, '83', '58960000', '9', '1949', '1949', '13025', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 228.326, '-7,31300', '-38,51500', 593, 'S', 0.5740, NULL, NULL, '25900', 'S', 'N', 707, NULL, '2590', '2590', NULL, '1938', 'S', 2588, 'BONITO DE SANTA FÉ', 'N', '250240', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '33', NULL, '03', 'N', NULL, NULL, NULL, 74);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270860', '2705', 'AL', '2701', '2703', '27012', '27', 'SAO MIGUEL DOS CAMPOS', NULL, '82', '57240000', '0', '2871', '2871', '02086', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 360.846, '-9,78100', '-36,09400', 12, 'S', 0.6710, NULL, NULL, '27003', 'N', 'N', 4791, NULL, '2790', '2790', NULL, '1832', 'S', 113, 'SÃO MIGUEL DOS CAMPOS', 'N', '270860', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '92', NULL, '02', 'N', NULL, NULL, NULL, 394);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270870', '2702', 'AL', '2701', '2703', '27010', '27', 'SAO MIGUEL DOS MILAGRES', NULL, '82', '57940000', '9', '2873', '2873', '02087', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 65.189, '-9,26600', '-35,37300', 1, 'S', 0.6210, NULL, NULL, '27002', 'S', 'N', 4792, NULL, '2790', '2790', NULL, '1960', 'S', 114, 'SÃO MIGUEL DOS MILAGRES', 'N', '270870', 'N', 'S', 'S', NULL, 41, 'S', 'N', 'N', '93', NULL, '03', 'N', NULL, NULL, NULL, 2);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270880', '2707', 'AL', '2702', '2702', '27006', '27', 'SAO SEBASTIAO', NULL, '82', '57275000', '8', '2875', '2875', '02088', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 305.746, '-9,93400', '-36,55400', 201, 'S', 0.5650, NULL, NULL, '27005', 'N', 'N', 4827, NULL, '2702', '2790', NULL, '1960', 'S', 115, 'SÃO SEBASTIÃO', 'N', '270880', 'N', 'S', 'S', NULL, 39, 'S', 'N', 'N', '94', NULL, '03', 'N', NULL, NULL, NULL, 45);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270895', '2709', 'AL', '2702', '2701', '27003', '27', 'SENADOR RUI PALMEIRA', NULL, '82', '57515000', '6', '2891', '2891', '02096', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 359.667, '-9,35400', '-37,50700', 352, 'S', 0.5070, NULL, NULL, '27008', 'S', 'N', 4916, NULL, '2790', '2790', NULL, '1982', 'S', 117, 'SENADOR RUI PALMEIRA', 'N', '270895', 'N', 'S', 'S', NULL, 42, 'S', 'N', 'N', '96', NULL, '03', 'N', NULL, NULL, NULL, 46);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270900', '2708', 'AL', '2702', '2702', '27005', '27', 'TANQUE D''ARCA', NULL, '82', '57635000', '4', '2879', '2879', '02090', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 155.959, '-9,53200', '-36,43300', 212, 'S', 0.5860, NULL, NULL, '27009', 'S', 'N', 5085, NULL, '2702', '2790', NULL, '1962', 'S', 118, 'TANQUE D ARCA', 'N', '270900', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '97', NULL, '03', 'N', NULL, NULL, NULL, 396);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270910', '2707', 'AL', '2702', '2702', '27006', '27', 'TAQUARANA', NULL, '82', '57640000', '3', '2881', '2881', '02091', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 166.477, '-9,64500', '-36,49700', 159, 'S', 0.5830, NULL, NULL, '27005', 'S', 'N', 5108, NULL, '2702', '2790', NULL, '1962', 'S', 119, 'TAQUARANA', 'N', '270910', 'N', 'S', 'S', NULL, 39, 'N', 'N', 'N', '98', NULL, '03', 'N', NULL, NULL, NULL, 45);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270915', '2705', 'AL', '2701', '2703', '27012', '27', 'TEOTONIO VILELA', NULL, '82', '57265000', '2', '0971', '0971', '02097', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 297.875, '-9,90500', '-36,35300', 156, 'S', 0.5670, NULL, NULL, '27013', 'N', 'N', 5147, NULL, '2790', '2790', NULL, '1987', 'S', 120, 'TEOTÔNIO VILELA', 'N', '270915', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '99', NULL, '03', 'N', NULL, NULL, NULL, 394);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270920', '2707', 'AL', '2702', '2702', '27007', '27', 'TRAIPU', NULL, '82', '57370000', '2', '2883', '2883', '02092', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 697.843, '-9,97100', '-37,00300', 10, 'S', 0.4790, NULL, NULL, '27005', 'S', 'N', 5209, NULL, '2702', '2790', NULL, '1835', 'S', 121, 'TRAIPU', 'N', '270920', 'N', 'S', 'S', NULL, 39, 'S', 'N', 'N', '100', NULL, '03', 'N', NULL, NULL, NULL, 45);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280120', '2806', 'SE', '2890', '2801', '28001', '28', 'CANINDE DE SAO FRANCISCO', NULL, '79', '49820000', '7', '3123', '3123', '22012', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 902.251, '-9,64200', '-37,78800', 38, 'S', 0.5800, NULL, NULL, '28900', 'S', 'N', 1021, NULL, '2890', '2890', NULL, '1953', 'S', 4677, 'CANINDÉ DE SÃO FRANCISCO', 'N', '280120', 'N', 'S', 'S', NULL, 8, 'S', 'N', 'N', '11', NULL, '03', 'N', NULL, NULL, NULL, 321);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280130', '2802', 'SE', '2890', '2803', '28008', '28', 'CAPELA', NULL, '79', '49700000', '6', '3125', '3125', '22013', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 440.716, '-10,50300', '-37,05300', 162, 'S', 0.6150, NULL, NULL, '28900', 'S', 'N', 1041, NULL, '2890', '2890', NULL, '1835', 'S', 4678, 'CAPELA', 'N', '280130', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '12', NULL, '03', 'N', NULL, NULL, NULL, 381);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280140', '2804', 'SE', '2890', '2801', '28002', '28', 'CARIRA', NULL, '79', '49550000', '5', '3127', '3127', '22014', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 636.404, '-10,36100', '-37,70100', 351, 'S', 0.5810, NULL, NULL, '28900', 'S', 'N', 1101, NULL, '2890', '2890', NULL, '1953', 'S', 4679, 'CARIRA', 'N', '280140', 'N', 'S', 'S', NULL, 84, 'N', 'N', 'N', '13', NULL, '03', 'N', NULL, NULL, NULL, 90);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280150', '2802', 'SE', '2890', '2803', '28010', '28', 'CARMOPOLIS', NULL, '79', '49740000', '4', '3129', '3129', '22015', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 45.905, '-10,64800', '-36,98900', 13, 'S', 0.6760, NULL, NULL, '28900', 'S', 'N', 1121, NULL, '2890', '2890', NULL, '1922', 'S', 4680, 'CARMÓPOLIS', 'N', '280150', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '14', NULL, '03', 'N', NULL, NULL, NULL, 381);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280160', '2807', 'SE', '2890', '2803', '28007', '28', 'CEDRO DE SAO JOAO', NULL, '79', '49930000', '3', '3131', '3131', '22016', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 79.594, '-10,25200', '-36,88400', 32, 'S', 0.6840, NULL, NULL, '28900', 'S', 'N', 1197, NULL, '2890', '2890', NULL, '1928', 'S', 4681, 'CEDRO DE SÃO JOÃO', 'N', '280160', 'N', 'S', 'S', NULL, 135, 'S', 'N', 'N', '15', NULL, '03', 'N', NULL, NULL, NULL, 430);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250250', '2503', 'PB', '2590', '2502', '25011', '25', 'BOQUEIRAO', NULL, '83', '58450000', '8', '1951', '1951', '13026', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 424.646, '-7,48200', '-36,13500', 355, 'S', 0.6080, NULL, NULL, '25900', 'S', 'N', 709, NULL, '2502', '2590', NULL, '1959', 'S', 2589, 'BOQUEIRÃO', 'N', '250250', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '34', NULL, '03', 'N', NULL, NULL, NULL, 72);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250260', '2507', 'PB', '2590', '2501', '25005', '25', 'IGARACY', NULL, '83', '58775000', '7', '1953', NULL, '13027', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 192.258, '-7,18100', '-38,14900', 313, 'S', 0.6080, NULL, NULL, '25900', 'S', 'N', 2117, NULL, '2590', '2590', NULL, '1961', 'S', 2640, 'IGARACY', 'N', '250260', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '86', NULL, '03', 'N', NULL, NULL, NULL, 73);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250270', '2502', 'PB', '2590', '2503', '25015', '25', 'BORBOREMA', NULL, '83', '58394000', '6', '1955', '1955', '13028', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 25.984, '-6,80100', '-35,62600', 368, 'S', 0.6000, NULL, NULL, '25900', 'S', 'N', 718, NULL, '2503', '2590', NULL, '1959', 'S', 2590, 'BORBOREMA', 'N', '250270', 'N', 'S', 'S', NULL, 24, 'N', 'N', 'N', '35', NULL, '03', 'N', NULL, NULL, NULL, 420);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250440', '2507', 'PB', '2590', '2501', '25006', '25', 'CONCEICAO', NULL, '83', '58970000', '5', '1989', '1989', '13045', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 579.432, '-7,56200', '-38,50900', 376, 'S', 0.6080, NULL, NULL, '25900', 'S', 'N', 1308, NULL, '2590', '2590', NULL, '1881', 'S', 2613, 'CONCEIÇÃO', 'N', '250440', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '59', NULL, '03', 'N', NULL, NULL, NULL, 73);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250670', '2511', 'PB', '2590', '2501', '25007', '25', 'IMACULADA', NULL, '83', '58745000', '7', '2035', '2035', '13068', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 399.409, '-7,39000', '-37,50900', 763, 'S', 0.5420, NULL, NULL, '25900', 'S', 'N', 2150, NULL, '2590', '2590', NULL, '1965', 'S', 2641, 'IMACULADA', 'N', '250670', 'N', 'S', 'S', NULL, 59, 'S', 'N', 'N', '87', NULL, '03', 'N', NULL, NULL, NULL, 135);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250680', '2512', 'PB', '2590', '2503', '25018', '25', 'INGA', NULL, '83', '58380000', '6', '2037', '2037', '13069', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 287.969, '-7,26800', '-35,61300', 0, 'S', 0.5650, NULL, NULL, '25900', 'S', 'N', 2177, NULL, '2502', '2590', NULL, '1904', 'S', 2642, 'INGÁ', 'N', '250680', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '88', NULL, '03', 'N', NULL, NULL, NULL, 309);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250690', '2512', 'PB', '2590', '2503', '25018', '25', 'ITABAIANA', NULL, '83', '58360000', '5', '2039', '2039', '13070', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 218.847, '-7,32900', '-35,33300', 45, 'S', 0.6120, NULL, NULL, '25900', 'S', 'N', 2256, NULL, '2590', '2590', NULL, '1890', 'S', 2643, 'ITABAIANA', 'N', '250690', 'N', 'S', 'S', NULL, 120, 'S', 'N', 'S', '89', NULL, '03', 'N', NULL, NULL, NULL, 309);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('250990', '2503', 'PB', '2590', '2503', '25019', '25', 'NATUBA', NULL, '83', '58494000', '9', '2099', '2099', '13100', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 192.166, '-7,64100', '-35,55000', 331, 'S', 0.5130, NULL, NULL, '25900', 'S', 'N', 3207, NULL, '2502', '2590', NULL, '1961', 'S', 2679, 'NATUBA', 'N', '250990', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '125', NULL, '03', 'N', NULL, NULL, NULL, 72);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251340', '2506', 'PB', '2590', '2502', '25008', '25', 'SANTA LUZIA', NULL, '83', '58600000', '6', '2169', '2169', '13135', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 455.702, '-6,87200', '-36,91900', 299, 'S', 0.6760, NULL, NULL, '25900', 'S', 'N', 4363, NULL, '2504', '2590', NULL, '1871', 'S', 2723, 'SANTA LUZIA', 'N', '251340', 'N', 'S', 'S', NULL, 59, 'S', 'N', 'N', '170', NULL, '03', 'N', NULL, NULL, NULL, 254);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251350', '2507', 'PB', '2590', '2501', '25006', '25', 'SANTANA DE MANGUEIRA', NULL, '83', '58985000', '5', '2171', '2171', '13136', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 402.151, '-7,55500', '-38,33200', 350, 'S', 0.5570, NULL, NULL, '25900', 'S', 'N', 4442, NULL, '2590', '2590', NULL, '1963', 'S', 2726, 'SANTANA DE MANGUEIRA', 'N', '251350', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '173', NULL, '03', 'N', NULL, NULL, NULL, 73);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251360', '2507', 'PB', '2590', '2501', '25005', '25', 'SANTANA DOS GARROTES', NULL, '83', '58795000', '4', '2173', '2173', '13137', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 353.813, '-7,38400', '-37,98600', 322, 'S', 0.6190, NULL, NULL, '25900', 'S', 'N', 4463, NULL, '2590', '2590', NULL, '1961', 'S', 2727, 'SANTANA DOS GARROTES', 'N', '251360', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '174', NULL, '03', 'N', NULL, NULL, NULL, 73);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260080', '2604', 'PE', '2602', '2603', '26012', '26', 'ALTINHO', NULL, '81', '55490000', '7', '2315', '2315', '15008', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 454.486, '-8,49000', '-36,05900', 454, 'S', 0.5900, NULL, NULL, '26006', 'S', 'N', 136, NULL, '2690', '2690', NULL, '1881', 'S', 2786, 'ALTINHO', 'N', '260080', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '9', NULL, '03', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260260', '2604', 'PE', '2602', '2603', '26008', '26', 'BREJO DA MADRE DE DEUS', NULL, '81', '55175000', '5', '2351', '2351', '15026', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 762.088, '-8,14600', '-36,37100', 627, 'S', 0.5790, NULL, NULL, '26009', 'N', 'N', 757, NULL, '2690', '2690', NULL, '1833', 'S', 2805, 'BREJO DA MADRE DE DEUS', 'N', '260260', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '28', NULL, '03', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260270', '2602', 'PE', '2601', '2604', '26013', '26', 'BUENOS AIRES', NULL, '81', '55845000', '4', '2353', '2353', '15027', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 96.686, '-7,72600', '-35,32700', 149, 'S', 0.6210, NULL, NULL, '26005', 'S', 'N', 780, NULL, '2690', '2690', NULL, '1963', 'S', 2806, 'BUENOS AIRES', 'N', '260270', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '29', NULL, '03', 'N', NULL, NULL, NULL, 421);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260490', '2602', 'PE', '2601', '2603', '26010', '26', 'CUMARU', NULL, '81', '55655000', '8', '2397', '2397', '15049', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 292.242, '-8,00600', '-35,69700', 443, 'S', 0.5750, NULL, NULL, '26004', 'N', 'N', 1477, NULL, '2690', '2690', NULL, '1963', 'S', 2831, 'CUMARU', 'N', '260490', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '54', NULL, '03', 'N', NULL, NULL, NULL, 421);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260970', '2602', 'PE', '2601', '2603', '26010', '26', 'OROBO', NULL, '81', '55745000', '9', '2493', '2493', '15097', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 140.785, '-7,74500', '-35,60200', 415, 'S', 0.6120, NULL, NULL, '26004', 'S', 'N', 3419, NULL, '2690', '2690', NULL, '1928', 'S', 2890, 'OROBÓ', 'N', '260970', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '113', NULL, '03', 'N', NULL, NULL, NULL, 421);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261240', '2604', 'PE', '2602', '2603', '26008', '26', 'SANHARO', NULL, '87', '55250000', '6', '2547', '2547', '15124', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 256.183, '-8,36100', '-36,56600', 653, 'S', 0.6180, NULL, NULL, '26008', 'S', 'N', 4289, NULL, '2690', '2690', NULL, '1948', 'S', 2918, 'SANHARÓ', 'N', '261240', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '141', NULL, '03', 'N', NULL, NULL, NULL, 139);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261245', '2609', 'PE', '2604', '2601', '26001', '26', 'SANTA CRUZ', NULL, '87', '56215000', '5', '2297', '2297', '15175', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1255.905, '-8,24000', '-40,33600', 515, 'S', 0.5790, NULL, NULL, '26900', 'S', 'N', 4310, NULL, '2690', '2690', NULL, '1993', 'S', 2919, 'SANTA CRUZ', 'N', '261245', 'N', 'S', 'S', NULL, 81, 'S', 'N', 'N', '142', NULL, '03', 'N', NULL, NULL, NULL, 260);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261247', '2611', 'PE', '2603', '2601', '26003', '26', 'SANTA CRUZ DA BAIXA VERDE', NULL, '87', '56895000', '1', '2639', '2639', '15176', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 114.931, '-7,82100', '-38,15300', 852, 'S', 0.6550, NULL, NULL, '26900', 'S', 'N', 4314, NULL, '2690', '2690', NULL, '1993', 'S', 2920, 'SANTA CRUZ DA BAIXA VERDE', 'N', '261247', 'N', 'S', 'S', NULL, 82, 'N', 'N', 'N', '143', NULL, '03', 'N', NULL, NULL, NULL, 261);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('261450', '2602', 'PE', '2601', '2603', '26009', '26', 'SURUBIM', NULL, '81', '55750000', '1', '2589', '2589', '15145', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 252.845, '-7,83200', '-35,75600', 0, 'S', 0.6410, NULL, NULL, '26004', 'N', 'N', 5043, NULL, '2690', '2690', NULL, '1928', 'S', 2941, 'SURUBIM', 'N', '261450', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '164', NULL, '02', 'N', NULL, NULL, NULL, 421);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270060', '2701', 'AL', '2701', '2703', '27011', '27', 'BARRA DE SAO MIGUEL', NULL, '82', '57180000', '7', '2711', '2711', '02006', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 76.612, '-9,84000', '-35,90800', 2, 'S', 0.6390, NULL, NULL, '27001', 'S', 'N', 509, NULL, '2701', '2790', NULL, '1963', 'S', 28, 'BARRA DE SÃO MIGUEL', 'N', '270060', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '6', NULL, '03', 'N', NULL, NULL, NULL, 44);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270300', '2703', 'AL', '2701', '2703', '27008', '27', 'IBATEGUARA', NULL, '82', '57890000', '7', '2759', '2759', '02030', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 261.277, '-8,97300', '-35,93900', 505, 'S', 0.5800, NULL, NULL, '27011', 'S', 'N', 2060, NULL, '2790', '2790', NULL, '1957', 'S', 55, 'IBATEGUARA', 'N', '270300', 'N', 'S', 'S', NULL, 126, 'S', 'N', 'N', '33', NULL, '03', 'N', NULL, NULL, NULL, 169);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270820', '2706', 'AL', '2701', '2702', '27007', '27', 'SAO BRAS', NULL, '82', '57380000', '4', '2863', '2863', '02082', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 139.884, '-10,12800', '-36,90100', 25, 'S', 0.6060, NULL, NULL, '27004', 'S', 'N', 4542, NULL, '2702', '2790', NULL, '1947', 'S', 109, 'SÃO BRÁS', 'N', '270820', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '88', NULL, '03', 'N', NULL, NULL, NULL, 395);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270930', '2703', 'AL', '2701', '2703', '27008', '27', 'UNIAO DOS PALMARES', NULL, '82', '57800000', '1', '2885', '2885', '02093', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 427.825, '-9,16300', '-36,03200', 155, 'S', 0.6000, NULL, NULL, '27011', 'N', 'N', 5322, NULL, '2790', '2790', NULL, '1831', 'S', 122, 'UNIÃO DOS PALMARES', 'N', '270930', 'N', 'S', 'S', NULL, 126, 'S', 'N', 'S', '101', NULL, '02', 'N', NULL, NULL, NULL, 169);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270940', '2704', 'AL', '2701', '2703', '27008', '27', 'VICOSA', NULL, '82', '57700000', '0', '2887', '2887', '02094', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 354.762, '-9,37100', '-36,24100', 210, 'S', 0.6070, NULL, NULL, '27010', 'S', 'N', 5432, NULL, '2790', '2790', NULL, '1831', 'S', 123, 'VIÇOSA', 'N', '270940', 'N', 'S', 'S', NULL, 126, 'N', 'N', 'N', '102', NULL, '03', 'N', NULL, NULL, NULL, 393);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280170', '2803', 'SE', '2890', '2803', '28012', '28', 'CRISTINAPOLIS', NULL, '79', '49270000', '2', '3133', '3133', '22017', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 253.867, '-11,47600', '-37,75500', 145, 'S', 0.5770, NULL, NULL, '28900', 'S', 'N', 1445, NULL, '2890', '2890', NULL, '1882', 'S', 4682, 'CRISTINÁPOLIS', 'N', '280170', 'N', 'S', 'S', NULL, 105, 'S', 'N', 'N', '16', NULL, '03', 'N', NULL, NULL, NULL, 213);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280190', '2802', 'SE', '2890', '2802', '28003', '28', 'CUMBE', NULL, '79', '49660000', '0', '3137', '3137', '22019', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 129.196, '-10,35500', '-37,18300', 187, 'S', 0.6380, NULL, NULL, '28900', 'S', 'N', 1479, NULL, '2890', '2890', NULL, '1953', 'S', 4683, 'CUMBE', 'N', '280190', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '17', NULL, '03', 'N', NULL, NULL, NULL, 381);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280010', '2807', 'SE', '2890', '2803', '28007', '28', 'AMPARO DE SAO FRANCISCO', NULL, '79', '49920000', '0', '3101', '3101', '22001', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 35.173, '-10,13400', '-36,93000', 12, 'S', 0.6020, NULL, NULL, '28900', 'S', 'N', 205, NULL, '2890', '2890', NULL, '1953', 'S', 4667, 'AMPARO DE SÃO FRANCISCO', 'N', '280010', 'N', 'S', 'S', NULL, 135, 'N', 'N', 'N', '1', NULL, '03', 'N', NULL, NULL, NULL, 430);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280020', '2807', 'SE', '2890', '2802', '28003', '28', 'AQUIDABA', NULL, '79', '49790000', '9', '3103', '3103', '22002', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 357.003, '-10,28100', '-37,01900', 216, 'S', 0.6050, NULL, NULL, '28900', 'S', 'N', 285, NULL, '2890', '2890', NULL, '1882', 'S', 4668, 'AQUIDABÃ', 'N', '280020', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '2', NULL, '03', 'N', NULL, NULL, NULL, 430);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280030', '2801', 'SE', '2890', '2803', '28011', '28', 'ARACAJU', NULL, '79', '49001970', '8', '3105', '3105', '22003', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'S', 174.053, '-10,91100', '-37,07200', 4, 'S', 0.7940, NULL, NULL, '28900', 'N', 'N', 291, NULL, '2801', '2801', NULL, '1855', 'S', 4669, 'ARACAJU', 'N', '280030', 'N', 'S', 'S', NULL, NULL, 'S', 'S', 'S', '3', NULL, '01', 'N', NULL, NULL, NULL, 104);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280040', '2803', 'SE', '2890', '2803', '28012', '28', 'ARAUA', NULL, '79', '49220000', '7', '3107', '3107', '22004', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 192.723, '-11,26200', '-37,62000', 109, 'S', 0.6210, NULL, NULL, '28900', 'S', 'N', 353, NULL, '2890', '2890', NULL, '1870', 'S', 4670, 'ARAUÁ', 'N', '280040', 'N', 'S', 'S', NULL, 105, 'N', 'N', 'N', '4', NULL, '03', 'N', NULL, NULL, NULL, 213);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280050', '2804', 'SE', '2890', '2802', '28004', '28', 'AREIA BRANCA', NULL, '79', '49580000', '6', '3109', '3109', '22005', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 128.392, '-10,75800', '-37,31500', 160, 'S', 0.6440, NULL, NULL, '28900', 'S', 'N', 366, NULL, '2890', '2890', NULL, '1963', 'S', 4671, 'AREIA BRANCA', 'N', '280050', 'N', 'S', 'S', NULL, 84, 'S', 'N', 'N', '5', NULL, '03', 'N', NULL, NULL, NULL, 90);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280060', '2801', 'SE', '2890', '2803', '28011', '28', 'BARRA DOS COQUEIROS', NULL, '79', '49140000', '5', '3111', '3111', '22006', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 91.101, '-10,90900', '-37,03900', 8, 'S', 0.6760, NULL, NULL, '28900', 'S', 'N', 525, NULL, '2801', '2801', NULL, '1953', 'S', 4672, 'BARRA DOS COQUEIROS', 'N', '280060', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '6', NULL, '03', 'N', NULL, NULL, NULL, 104);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280067', '2803', 'SE', '2890', '2803', '28012', '28', 'BOQUIM', NULL, '79', '49360000', '0', '3115', '3115', '22008', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 214.566, '-11,14700', '-37,62100', 165, 'S', 0.6340, NULL, NULL, '28900', 'S', 'N', 712, NULL, '2890', '2890', NULL, '1857', 'S', 4673, 'BOQUIM', 'N', '280067', 'N', 'S', 'S', NULL, 105, 'S', 'N', 'N', '7', NULL, '03', 'N', NULL, NULL, NULL, 213);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280070', '2807', 'SE', '2890', '2803', '28007', '28', 'BREJO GRANDE', NULL, '79', '49995000', '4', '3113', '3113', '22007', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 149.952, '-10,42900', '-36,46600', 30, 'S', 0.5500, NULL, NULL, '28900', 'S', 'N', 762, NULL, '2890', '2890', NULL, '1926', 'S', 4674, 'BREJO GRANDE', 'N', '280070', 'N', 'S', 'S', NULL, 135, 'S', 'N', 'N', '8', NULL, '03', 'N', NULL, NULL, NULL, 430);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280100', '2804', 'SE', '2890', '2802', '28004', '28', 'CAMPO DO BRITO', NULL, '79', '49520000', '9', '3119', '3119', '22010', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 201.724, '-10,73300', '-37,49300', 208, 'S', 0.6610, NULL, NULL, '28900', 'S', 'N', 953, NULL, '2890', '2890', NULL, '1912', 'S', 4675, 'CAMPO DO BRITO', 'N', '280100', 'N', 'S', 'S', NULL, 84, 'S', 'N', 'N', '9', NULL, '03', 'N', NULL, NULL, NULL, 90);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280110', '2807', 'SE', '2890', '2803', '28007', '28', 'CANHOBA', NULL, '79', '49880000', '8', '3121', '3121', '22011', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 170.052, '-10,13800', '-36,98500', 20, 'S', 0.5970, NULL, NULL, '28900', 'S', 'N', 1018, NULL, '2890', '2890', NULL, '1937', 'S', 4676, 'CANHOBA', 'N', '280110', 'N', 'S', 'S', NULL, 135, 'N', 'N', 'N', '10', NULL, '03', 'N', NULL, NULL, NULL, 430);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280200', '2801', 'SE', '2890', '2803', '28008', '28', 'DIVINA PASTORA', NULL, '79', '49650000', '7', '3139', '3139', '22020', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 92.249, '-10,68900', '-37,14800', 78, 'S', 0.6550, NULL, NULL, '28900', 'S', 'N', 1546, NULL, '2890', '2890', NULL, '1838', 'S', 4684, 'DIVINA PASTORA', 'N', '280200', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '18', NULL, '03', 'N', NULL, NULL, NULL, 104);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280210', '2803', 'SE', '2890', '2803', '28013', '28', 'ESTANCIA', NULL, '79', '49200000', '6', '3141', '3141', '22021', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 642.306, '-11,26800', '-37,43800', 53, 'S', 0.6720, NULL, NULL, '28900', 'N', 'N', 1689, NULL, '2890', '2890', NULL, '1831', 'S', 4685, 'ESTÂNCIA', 'N', '280210', 'N', 'S', 'S', NULL, 105, 'S', 'N', 'S', '19', NULL, '02', 'N', NULL, NULL, NULL, 213);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280220', '2806', 'SE', '2890', '2801', '28001', '28', 'FEIRA NOVA', NULL, '79', '49670000', '5', '3143', '3143', '22022', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 188.012, '-10,26400', '-37,31300', 241, 'S', 0.6200, NULL, NULL, '28900', 'S', 'N', 1739, NULL, '2890', '2890', NULL, '1963', 'S', 4686, 'FEIRA NOVA', 'N', '280220', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '20', NULL, '03', 'N', NULL, NULL, NULL, 321);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280230', '2804', 'SE', '2890', '2801', '28002', '28', 'FREI PAULO', NULL, '79', '49514000', '4', '3145', '3145', '22023', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 399.439, '-10,54900', '-37,53400', 272, 'S', 0.6460, NULL, NULL, '28900', 'S', 'N', 1840, NULL, '2890', '2890', NULL, '1890', 'S', 4687, 'FREI PAULO', 'N', '280230', 'N', 'S', 'S', NULL, 84, 'S', 'N', 'N', '21', NULL, '03', 'N', NULL, NULL, NULL, 90);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280240', '2806', 'SE', '2890', '2801', '28001', '28', 'GARARU', NULL, '79', '49830000', '3', '3149', '3149', '22025', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 644.722, '-9,96800', '-37,08300', 16, 'S', 0.5720, NULL, NULL, '28900', 'S', 'N', 1860, NULL, '2890', '2890', NULL, '1877', 'S', 4688, 'GARARU', 'N', '280240', 'N', 'S', 'S', NULL, 8, 'N', 'N', 'N', '22', NULL, '03', 'N', NULL, NULL, NULL, 321);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280250', '2802', 'SE', '2890', '2803', '28010', '28', 'GENERAL MAYNARD', NULL, '79', '49750000', '2', '3147', '3147', '22024', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 20.221, '-10,68900', '-36,98400', 38, 'S', 0.6710, NULL, NULL, '28900', 'S', 'N', 1877, NULL, '2890', '2890', NULL, '1963', 'S', 4689, 'GENERAL MAYNARD', 'N', '280250', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '23', NULL, '03', 'N', NULL, NULL, NULL, 381);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280260', '2806', 'SE', '2890', '2801', '28001', '28', 'GRACHO CARDOSO', NULL, '79', '49860000', '1', '3151', '3151', '22026', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 242.148, '-10,22700', '-37,19800', 242, 'S', 0.5940, NULL, NULL, '28900', 'S', 'N', 1932, NULL, '2890', '2890', NULL, '1953', 'S', 4690, 'GRACHO CARDOSO', 'N', '280260', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '24', NULL, '03', 'N', NULL, NULL, NULL, 321);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280270', '2807', 'SE', '2890', '2803', '28007', '28', 'ILHA DAS FLORES', NULL, '79', '49990000', '0', '3153', '3153', '22027', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 52.816, '-10,43600', '-36,54000', 3, 'S', 0.5840, NULL, NULL, '28900', 'S', 'N', 2142, NULL, '2890', '2890', NULL, '1959', 'S', 4691, 'ILHA DAS FLORES', 'N', '280270', 'N', 'S', 'S', NULL, 135, 'S', 'N', 'N', '25', NULL, '03', 'N', NULL, NULL, NULL, 430);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280280', '2803', 'SE', '2890', '2803', '28013', '28', 'INDIAROBA', NULL, '79', '49250000', '9', '3155', '3155', '22028', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 313.576, '-11,51900', '-37,51200', 26, 'S', 0.6050, NULL, NULL, '28900', 'S', 'N', 2175, NULL, '2890', '2890', NULL, '1846', 'S', 4692, 'INDIAROBA', 'N', '280280', 'N', 'S', 'S', NULL, 105, 'S', 'N', 'N', '26', NULL, '03', 'N', NULL, NULL, NULL, 213);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280290', '2804', 'SE', '2890', '2802', '28004', '28', 'ITABAIANA', NULL, '79', '49500000', '8', '3157', '3157', '22029', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 336.685, '-10,68500', '-37,42500', 188, 'S', 0.6780, NULL, NULL, '28900', 'N', 'N', 2257, NULL, '2890', '2890', NULL, '1698', 'S', 4693, 'ITABAIANA', 'N', '280290', 'N', 'S', 'S', NULL, 84, 'S', 'N', 'S', '27', NULL, '01', 'N', NULL, NULL, NULL, 90);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280300', '2803', 'SE', '2890', '2803', '28012', '28', 'ITABAIANINHA', NULL, '79', '49290000', '5', '3159', '3159', '22030', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 493.310, '-11,27400', '-37,79000', 223, 'S', 0.5900, NULL, NULL, '28900', 'N', 'N', 2258, NULL, '2890', '2890', NULL, '1832', 'S', 4694, 'ITABAIANINHA', 'N', '280300', 'N', 'S', 'S', NULL, 105, 'N', 'N', 'N', '28', NULL, '03', 'N', NULL, NULL, NULL, 213);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280310', '2806', 'SE', '2890', '2801', '28001', '28', 'ITABI', NULL, '79', '49870000', '4', '3161', '3161', '22031', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 195.086, '-10,12600', '-37,10300', 172, 'S', 0.6230, NULL, NULL, '28900', 'S', 'N', 2263, NULL, '2890', '2890', NULL, '1953', 'S', 4695, 'ITABI', 'N', '280310', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '29', NULL, '03', 'N', NULL, NULL, NULL, 321);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290340', '2908', 'BA', '2903', '2907', '29031', '29', 'BELMONTE', NULL, '73', '45800000', '9', '3367', '3367', '04034', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 2009.896, '-15,86300', '-38,88300', 8, 'S', 0.6180, NULL, NULL, '29031', 'S', 'N', 581, NULL, '2990', '2990', NULL, '1764', 'S', 242, 'BELMONTE', 'N', '290340', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '42', NULL, '03', 'N', NULL, NULL, NULL, 346);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280320', '2801', 'SE', '2890', '2803', '28013', '28', 'ITAPORANGA D''AJUDA', NULL, '79', '49120000', '3', '3163', '3163', '22032', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 757.283, '-10,99800', '-37,31100', 9, 'S', 0.6380, NULL, NULL, '28900', 'S', 'N', 2366, NULL, '2890', '2890', NULL, '1854', 'S', 4696, 'ITAPORANGA D AJUDA', 'N', '280320', 'N', 'S', 'S', NULL, 105, 'N', 'N', 'N', '30', NULL, '03', 'N', NULL, NULL, NULL, 104);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280330', '2802', 'SE', '2890', '2803', '28009', '28', 'JAPARATUBA', NULL, '79', '49960000', '2', '3165', '3165', '22033', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 359.513, '-10,59300', '-36,94000', 79, 'S', 0.6510, NULL, NULL, '28900', 'S', 'N', 2492, NULL, '2890', '2890', NULL, '1859', 'S', 4697, 'JAPARATUBA', 'N', '280330', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '31', NULL, '03', 'N', NULL, NULL, NULL, 381);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280340', '2807', 'SE', '2890', '2803', '28009', '28', 'JAPOATA', NULL, '79', '49950000', '1', '3167', '3167', '22034', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 420.491, '-10,34700', '-36,80100', 91, 'S', 0.6040, NULL, NULL, '28900', 'S', 'N', 2496, NULL, '2890', '2890', NULL, '1926', 'S', 4698, 'JAPOATÃ', 'N', '280340', 'N', 'S', 'S', NULL, 135, 'S', 'N', 'N', '32', NULL, '03', 'N', NULL, NULL, NULL, 430);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280350', '2805', 'SE', '2890', '2802', '28006', '28', 'LAGARTO', NULL, '79', '49400000', '0', '3169', '3169', '22035', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 969.226, '-10,91700', '-37,65000', 183, 'S', 0.6140, NULL, NULL, '28900', 'N', 'N', 2642, NULL, '2890', '2890', NULL, '1698', 'S', 4699, 'LAGARTO', 'N', '280350', 'N', 'S', 'S', NULL, 84, 'S', 'N', 'S', '33', NULL, '01', 'N', NULL, NULL, NULL, 91);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280360', '2801', 'SE', '2890', '2803', '28010', '28', 'LARANJEIRAS', NULL, '79', '49170000', '9', '3171', '3171', '22036', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 162.538, '-10,80600', '-37,17000', 9, 'S', 0.6420, NULL, NULL, '28900', 'S', 'N', 2711, NULL, '2890', '2801', NULL, '1832', 'S', 4700, 'LARANJEIRAS', 'N', '280360', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '34', NULL, '03', 'N', NULL, NULL, NULL, 104);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280370', '2804', 'SE', '2890', '2802', '28004', '28', 'MACAMBIRA', NULL, '79', '49565000', '8', '3173', '3173', '22037', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 137.366, '-10,66600', '-37,54100', 282, 'S', 0.6490, NULL, NULL, '28900', 'S', 'N', 2795, NULL, '2890', '2890', NULL, '1953', 'S', 4701, 'MACAMBIRA', 'N', '280370', 'N', 'S', 'S', NULL, 84, 'S', 'N', 'N', '35', NULL, '03', 'N', NULL, NULL, NULL, 90);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280380', '2807', 'SE', '2890', '2802', '28003', '28', 'MALHADA DOS BOIS', NULL, '79', '49940000', '7', '3175', '3175', '22038', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 62.372, '-10,34900', '-36,92400', 120, 'S', 0.6300, NULL, NULL, '28900', 'S', 'N', 2837, NULL, '2890', '2890', NULL, '1953', 'S', 4702, 'MALHADA DOS BOIS', 'N', '280380', 'N', 'S', 'S', NULL, 135, 'S', 'N', 'N', '36', NULL, '03', 'N', NULL, NULL, NULL, 430);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280390', '2804', 'SE', '2890', '2802', '28004', '28', 'MALHADOR', NULL, '79', '49570000', '6', '3177', '3177', '22039', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 100.940, '-10,65800', '-37,30500', 251, 'S', 0.6180, NULL, NULL, '28900', 'S', 'N', 2838, NULL, '2890', '2890', NULL, '1953', 'S', 4703, 'MALHADOR', 'N', '280390', 'N', 'S', 'S', NULL, 84, 'N', 'N', 'N', '37', NULL, '03', 'N', NULL, NULL, NULL, 90);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280400', '2802', 'SE', '2890', '2803', '28010', '28', 'MARUIM', NULL, '79', '49770000', '3', '3179', '3179', '22040', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 94.293, '-10,73800', '-37,08200', 10, 'S', 0.6620, NULL, NULL, '28900', 'S', 'N', 2948, NULL, '2890', '2801', NULL, '1835', 'S', 4704, 'MARUIM', 'N', '280400', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '38', NULL, '03', 'N', NULL, NULL, NULL, 381);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280410', '2804', 'SE', '2890', '2802', '28004', '28', 'MOITA BONITA', NULL, '79', '49560000', '2', '3181', '3181', '22041', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 95.820, '-10,57800', '-37,34300', 212, 'S', 0.6620, NULL, NULL, '28900', 'S', 'N', 3074, NULL, '2890', '2890', NULL, '1963', 'S', 4705, 'MOITA BONITA', 'N', '280410', 'N', 'S', 'S', NULL, 84, 'N', 'N', 'N', '39', NULL, '03', 'N', NULL, NULL, NULL, 90);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280420', '2806', 'SE', '2890', '2801', '28001', '28', 'MONTE ALEGRE DE SERGIPE', NULL, '79', '49690000', '1', '3183', '3183', '22042', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 407.409, '-10,02700', '-37,56200', 265, 'S', 0.5680, NULL, NULL, '28900', 'S', 'N', 3098, NULL, '2890', '2890', NULL, '1953', 'S', 4706, 'MONTE ALEGRE DE SERGIPE', 'N', '280420', 'N', 'S', 'S', NULL, 8, 'S', 'N', 'N', '40', NULL, '03', 'N', NULL, NULL, NULL, 321);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280430', '2807', 'SE', '2890', '2802', '28003', '28', 'MURIBECA', NULL, '79', '49780000', '0', '3185', '3185', '22043', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 79.147, '-10,42700', '-36,95900', 151, 'S', 0.5970, NULL, NULL, '28900', 'S', 'N', 3185, NULL, '2890', '2890', NULL, '1926', 'S', 4707, 'MURIBECA', 'N', '280430', 'N', 'S', 'S', NULL, 135, 'S', 'N', 'N', '41', NULL, '03', 'N', NULL, NULL, NULL, 430);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280440', '2807', 'SE', '2890', '2803', '28007', '28', 'NEOPOLIS', NULL, '79', '49980000', '9', '3187', '3187', '22044', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 259.334, '-10,32000', '-36,57900', 30, 'S', 0.6210, NULL, NULL, '28900', 'S', 'N', 3218, NULL, '2890', '2890', NULL, '1679', 'S', 4708, 'NEÓPOLIS', 'N', '280440', 'N', 'S', 'S', NULL, 135, 'S', 'N', 'N', '42', NULL, '03', 'N', NULL, NULL, NULL, 430);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280445', '2804', 'SE', '2890', '2801', '28002', '28', 'NOSSA SENHORA APARECIDA', NULL, '79', '49540000', '8', '3135', '3135', '22018', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 340.378, '-10,44300', '-37,48900', 248, 'S', 0.5670, NULL, NULL, '28900', 'S', 'N', 3239, NULL, '2890', '2890', NULL, '1963', 'S', 4709, 'NOSSA SENHORA APARECIDA', 'N', '280445', 'N', 'S', 'S', NULL, 84, 'S', 'N', 'N', '43', NULL, '03', 'N', NULL, NULL, NULL, 90);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280450', '2806', 'SE', '2890', '2801', '28001', '28', 'NOSSA SENHORA DA GLORIA', NULL, '79', '49680000', '8', '3189', '3189', '22045', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 756.485, '-10,21800', '-37,42000', 291, 'S', 0.6310, NULL, NULL, '28900', 'S', 'N', 3240, NULL, '2890', '2890', NULL, '1928', 'S', 4710, 'NOSSA SENHORA DA GLÓRIA', 'N', '280450', 'N', 'S', 'S', NULL, 8, 'S', 'N', 'S', '44', NULL, '03', 'N', NULL, NULL, NULL, 321);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280460', '2802', 'SE', '2890', '2802', '28003', '28', 'NOSSA SENHORA DAS DORES', NULL, '79', '49600000', '7', '3191', '3191', '22046', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 471.001, '-10,49200', '-37,19300', 204, 'S', 0.6370, NULL, NULL, '28900', 'S', 'N', 3241, NULL, '2890', '2890', NULL, '1859', 'S', 4711, 'NOSSA SENHORA DAS DORES', 'N', '280460', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '45', NULL, '03', 'N', NULL, NULL, NULL, 381);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280470', '2807', 'SE', '2890', '2803', '28007', '28', 'NOSSA SENHORA DE LOURDES', NULL, '79', '49890000', '6', '3193', '3193', '22047', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 80.421, '-10,07900', '-37,05800', 222, 'S', 0.5830, NULL, NULL, '28900', 'S', 'N', 3243, NULL, '2890', '2890', NULL, '1963', 'S', 4712, 'NOSSA SENHORA DE LOURDES', 'N', '280470', 'N', 'S', 'S', NULL, 8, 'S', 'N', 'N', '46', NULL, '03', 'N', NULL, NULL, NULL, 430);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280480', '2802', 'SE', '2890', '2803', '28011', '28', 'NOSSA SENHORA DO SOCORRO', NULL, '79', '49160000', '5', '3195', '3195', '22048', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 157.515, '-10,85500', '-37,12600', 36, 'S', 0.6960, NULL, NULL, '28900', 'N', 'N', 3246, NULL, '2801', '2801', NULL, '1868', 'S', 4713, 'NOSSA SENHORA DO SOCORRO', 'N', '280480', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '47', NULL, '01', 'N', NULL, NULL, NULL, 381);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280490', '2807', 'SE', '2890', '2803', '28009', '28', 'PACATUBA', NULL, '79', '49970000', '4', '3197', '3197', '22049', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 363.761, '-10,45300', '-36,65100', 87, 'S', 0.5840, NULL, NULL, '28900', 'S', 'N', 3455, NULL, '2890', '2890', NULL, '1953', 'S', 4714, 'PACATUBA', 'N', '280490', 'N', 'S', 'S', NULL, 135, 'S', 'N', 'N', '48', NULL, '03', 'N', NULL, NULL, NULL, 430);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280500', '2804', 'SE', '2890', '2801', '28002', '28', 'PEDRA MOLE', NULL, '79', '49512000', '0', '3199', '3199', '22050', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 81.616, '-10,61700', '-37,68700', 192, 'S', 0.6200, NULL, NULL, '28900', 'S', 'N', 3650, NULL, '2890', '2890', NULL, '1963', 'S', 4715, 'PEDRA MOLE', 'N', '280500', 'N', 'S', 'S', NULL, 84, 'N', 'N', 'N', '49', NULL, '03', 'N', NULL, NULL, NULL, 90);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280510', '2803', 'SE', '2890', '2803', '28012', '28', 'PEDRINHAS', NULL, '79', '49350000', '9', '3201', '3201', '22051', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 33.942, '-11,19200', '-37,67400', 165, 'S', 0.6010, NULL, NULL, '28900', 'S', 'N', 3662, NULL, '2890', '2890', NULL, '1953', 'S', 4716, 'PEDRINHAS', 'N', '280510', 'N', 'S', 'S', NULL, 105, 'S', 'N', 'N', '50', NULL, '03', 'N', NULL, NULL, NULL, 213);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280520', '2804', 'SE', '2890', '2801', '28002', '28', 'PINHAO', NULL, '79', '49517000', '8', '3203', '3203', '22052', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 155.886, '-10,56700', '-37,72300', 258, 'S', 0.6000, NULL, NULL, '28900', 'S', 'N', 3762, NULL, '2890', '2890', NULL, '1953', 'S', 4717, 'PINHÃO', 'N', '280520', 'N', 'S', 'S', NULL, 84, 'S', 'N', 'N', '51', NULL, '03', 'N', NULL, NULL, NULL, 90);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280530', '2802', 'SE', '2890', '2803', '28009', '28', 'PIRAMBU', NULL, '79', '49190000', '7', '3205', '3205', '22053', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 218.084, '-10,73800', '-36,85600', 4, 'S', 0.6520, NULL, NULL, '28900', 'S', 'N', 3787, NULL, '2890', '2890', NULL, '1963', 'S', 4718, 'PIRAMBU', 'N', '280530', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '52', NULL, '03', 'N', NULL, NULL, NULL, 381);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280540', '2806', 'SE', '2890', '2801', '28001', '28', 'POCO REDONDO', NULL, '79', '49810000', '6', '3207', '3207', '22054', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1212.461, '-9,80600', '-37,68500', 188, 'S', 0.5360, NULL, NULL, '28900', 'S', 'N', 3845, NULL, '2890', '2890', NULL, '1953', 'S', 4719, 'POÇO REDONDO', 'N', '280540', 'N', 'S', 'S', NULL, 8, 'N', 'N', 'N', '53', NULL, '03', 'N', NULL, NULL, NULL, 321);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280550', '2805', 'SE', '2890', '2802', '28005', '28', 'POCO VERDE', NULL, '79', '49490000', '5', '3209', '3209', '22055', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 430.973, '-10,70800', '-38,18300', 268, 'S', 0.5970, NULL, NULL, '28900', 'S', 'N', 3846, NULL, '2890', '2890', NULL, '1953', 'S', 4720, 'POÇO VERDE', 'N', '280550', 'N', 'S', 'S', NULL, 84, 'N', 'N', 'N', '54', NULL, '03', 'N', NULL, NULL, NULL, 91);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280560', '2806', 'SE', '2890', '2801', '28001', '28', 'PORTO DA FOLHA', NULL, '79', '49800000', '4', '3211', '3211', '22056', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'S', NULL, 'N', 896.937, '-9,91700', '-37,27800', 38, 'S', 0.5560, NULL, NULL, '28900', 'S', 'N', 3905, NULL, '2890', '2890', NULL, '1835', 'S', 4721, 'PORTO DA FOLHA', 'N', '280560', 'N', 'S', 'S', NULL, 8, 'S', 'N', 'N', '55', NULL, '03', 'N', NULL, NULL, NULL, 321);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280570', '2807', 'SE', '2890', '2803', '28007', '28', 'PROPRIA', NULL, '79', '49900000', '3', '3213', '3213', '22057', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 95.041, '-10,21100', '-36,84000', 14, 'S', 0.6530, NULL, NULL, '28900', 'S', 'N', 3998, NULL, '2890', '2890', NULL, '1801', 'S', 4722, 'PROPRIÁ', 'N', '280570', 'N', 'S', 'S', NULL, 135, 'S', 'N', 'S', '56', NULL, '03', 'N', NULL, NULL, NULL, 430);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280580', '2805', 'SE', '2890', '2802', '28006', '28', 'RIACHAO DO DANTAS', NULL, '79', '49320000', '2', '3215', '3215', '22058', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 528.256, '-11,06900', '-37,72500', 185, 'S', 0.5560, NULL, NULL, '28900', 'S', 'N', 4090, NULL, '2890', '2890', NULL, '1870', 'S', 4723, 'RIACHÃO DO DANTAS', 'N', '280580', 'N', 'S', 'S', NULL, 84, 'S', 'N', 'N', '57', NULL, '03', 'N', NULL, NULL, NULL, 91);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280590', '2801', 'SE', '2890', '2803', '28010', '28', 'RIACHUELO', NULL, '79', '49130000', '1', '3217', '3217', '22059', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 78.480, '-10,72800', '-37,18700', 37, 'S', 0.6710, NULL, NULL, '28900', 'S', 'N', 4103, NULL, '2890', '2890', NULL, '1874', 'S', 4724, 'RIACHUELO', 'N', '280590', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '58', NULL, '03', 'N', NULL, NULL, NULL, 104);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280600', '2804', 'SE', '2890', '2801', '28002', '28', 'RIBEIROPOLIS', NULL, '79', '49530000', '8', '3219', '3219', '22060', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 261.548, '-10,53900', '-37,41700', 293, 'S', 0.6560, NULL, NULL, '28900', 'S', 'N', 4130, NULL, '2890', '2890', NULL, '1933', 'S', 4725, 'RIBEIRÓPOLIS', 'N', '280600', 'N', 'S', 'S', NULL, 84, 'S', 'N', 'N', '59', NULL, '03', 'N', NULL, NULL, NULL, 90);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280610', '2802', 'SE', '2890', '2803', '28010', '28', 'ROSARIO DO CATETE', NULL, '79', '49760000', '7', '3221', '3221', '22061', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 105.413, '-10,69600', '-37,03100', 22, 'S', 0.6720, NULL, NULL, '28900', 'S', 'N', 4226, NULL, '2890', '2890', NULL, '1836', 'S', 4726, 'ROSÁRIO DO CATETE', 'N', '280610', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '60', NULL, '03', 'N', NULL, NULL, NULL, 381);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280620', '2805', 'SE', '2890', '2803', '28012', '28', 'SALGADO', NULL, '79', '49390000', '6', '3223', '3223', '22062', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 248.453, '-11,03200', '-37,47500', 100, 'S', 0.6110, NULL, NULL, '28900', 'S', 'N', 4257, NULL, '2890', '2890', NULL, '1927', 'S', 4727, 'SALGADO', 'N', '280620', 'N', 'S', 'S', NULL, 105, 'S', 'N', 'N', '61', NULL, '03', 'N', NULL, NULL, NULL, 91);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280630', '2803', 'SE', '2890', '2803', '28013', '28', 'SANTA LUZIA DO ITANHY', NULL, '79', '49230000', '5', '3225', '3225', '22063', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 329.496, '-11,35100', '-37,44800', 37, 'S', 0.5450, NULL, NULL, '28900', 'S', 'N', 4367, NULL, '2890', '2890', NULL, '1835', 'S', 4728, 'SANTA LUZIA DO ITANHY', 'N', '280630', 'N', 'S', 'S', NULL, 105, 'S', 'N', 'N', '62', NULL, '03', 'N', NULL, NULL, NULL, 213);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280640', '2807', 'SE', '2890', '2803', '28007', '28', 'SANTANA DO SAO FRANCISCO', NULL, '79', '49985000', '4', '2647', '2647', '22064', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 46.340, '-10,29100', '-36,60800', 0, 'S', 0.5790, NULL, NULL, '28900', 'S', 'N', 4461, NULL, '2890', '2890', NULL, '1993', 'S', 4730, 'SANTANA DO SÃO FRANCISCO', 'N', '280640', 'N', 'S', 'S', NULL, 135, 'S', 'N', 'N', '64', NULL, '03', 'N', NULL, NULL, NULL, 430);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280650', '2801', 'SE', '2890', '2803', '28008', '28', 'SANTA ROSA DE LIMA', NULL, '79', '49640000', '3', '3229', '3229', '22065', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 67.607, '-10,64600', '-37,19400', 39, 'S', 0.6280, NULL, NULL, '28900', 'S', 'N', 4411, NULL, '2890', '2890', NULL, '1953', 'S', 4729, 'SANTA ROSA DE LIMA', 'N', '280650', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '63', NULL, '03', 'N', NULL, NULL, NULL, 104);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280660', '2802', 'SE', '2890', '2803', '28010', '28', 'SANTO AMARO DAS BROTAS', NULL, '79', '49180000', '2', '3231', '3231', '22066', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 234.654, '-10,78900', '-37,05400', 55, 'S', 0.6550, NULL, NULL, '28900', 'S', 'N', 4474, NULL, '2890', '2890', NULL, '1835', 'S', 4731, 'SANTO AMARO DAS BROTAS', 'N', '280660', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '65', NULL, '03', 'N', NULL, NULL, NULL, 381);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280670', '2801', 'SE', '2890', '2803', '28011', '28', 'SAO CRISTOVAO', NULL, '79', '49100000', '1', '3233', '3233', '22067', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 437.437, '-11,01500', '-37,20600', 47, 'S', 0.7000, NULL, NULL, '28900', 'N', 'N', 4551, NULL, '2801', '2801', NULL, '1590', 'S', 4732, 'SÃO CRISTÓVÃO', 'N', '280670', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '66', NULL, '01', 'N', NULL, NULL, NULL, 104);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280680', '2804', 'SE', '2890', '2802', '28004', '28', 'SAO DOMINGOS', NULL, '79', '49525000', '0', '3235', '3235', '22068', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 102.470, '-10,79100', '-37,56800', 200, 'S', 0.5940, NULL, NULL, '28900', 'S', 'N', 4557, NULL, '2890', '2890', NULL, '1963', 'S', 4733, 'SÃO DOMINGOS', 'N', '280680', 'N', 'S', 'S', NULL, 84, 'S', 'N', 'N', '67', NULL, '03', 'N', NULL, NULL, NULL, 90);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280690', '2807', 'SE', '2890', '2803', '28009', '28', 'SAO FRANCISCO', NULL, '79', '49945000', '9', '3237', '3237', '22069', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 82.565, '-10,33300', '-36,88800', 121, 'S', 0.6290, NULL, NULL, '28900', 'S', 'N', 4582, NULL, '2890', '2890', NULL, '1963', 'S', 4734, 'SÃO FRANCISCO', 'N', '280690', 'N', 'S', 'S', NULL, 135, 'S', 'N', 'N', '68', NULL, '03', 'N', NULL, NULL, NULL, 430);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280700', '2804', 'SE', '2890', '2802', '28003', '28', 'SAO MIGUEL DO ALEIXO', NULL, '79', '49535000', '6', '3239', '3239', '22070', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 144.543, '-10,38800', '-37,38100', 197, 'S', 0.6080, NULL, NULL, '28900', 'S', 'N', 4781, NULL, '2890', '2890', NULL, '1963', 'S', 4735, 'SÃO MIGUEL DO ALEIXO', 'N', '280700', 'N', 'S', 'S', NULL, 84, 'S', 'N', 'N', '69', NULL, '03', 'N', NULL, NULL, NULL, 90);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280710', '2805', 'SE', '2890', '2802', '28005', '28', 'SIMAO DIAS', NULL, '79', '49480000', '5', '3241', '3241', '22071', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 559.615, '-10,73800', '-37,81100', 263, 'S', 0.5910, NULL, NULL, '28900', 'N', 'N', 4994, NULL, '2890', '2890', NULL, '1850', 'S', 4736, 'SIMÃO DIAS', 'N', '280710', 'N', 'S', 'S', NULL, 84, 'N', 'N', 'N', '70', NULL, '03', 'N', NULL, NULL, NULL, 91);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280720', '2802', 'SE', '2890', '2803', '28008', '28', 'SIRIRI', NULL, '79', '49630000', '4', '3243', '3243', '22072', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 168.956, '-10,60400', '-37,11300', 38, 'S', 0.6450, NULL, NULL, '28900', 'S', 'N', 5005, NULL, '2890', '2890', NULL, '1874', 'S', 4737, 'SIRIRI', 'N', '280720', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '71', NULL, '03', 'N', NULL, NULL, NULL, 381);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280730', '2807', 'SE', '2890', '2803', '28007', '28', 'TELHA', NULL, '79', '49910000', '3', '3245', '3245', '22073', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 49.452, '-10,20800', '-36,88400', 23, 'S', 0.6010, NULL, NULL, '28900', 'S', 'N', 5137, NULL, '2890', '2890', NULL, '1964', 'S', 4738, 'TELHA', 'N', '280730', 'N', 'S', 'S', NULL, 135, 'S', 'N', 'N', '72', NULL, '03', 'N', NULL, NULL, NULL, 430);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280740', '2805', 'SE', '2890', '2802', '28005', '28', 'TOBIAS BARRETO', NULL, '79', '49300000', '2', '3247', '3247', '22074', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1032.829, '-11,18400', '-37,99800', 158, 'S', 0.5960, NULL, NULL, '28900', 'N', 'N', 5187, NULL, '2890', '2890', NULL, '1835', 'S', 4739, 'TOBIAS BARRETO', 'N', '280740', 'N', 'S', 'S', NULL, 84, 'N', 'N', 'N', '73', NULL, '03', 'N', NULL, NULL, NULL, 91);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280750', '2803', 'SE', '2890', '2803', '28012', '28', 'TOMAR DO GERU', NULL, '79', '49280000', '1', '3249', '3249', '22075', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 287.658, '-11,37300', '-37,84100', 170, 'S', 0.5630, NULL, NULL, '28900', 'S', 'N', 5194, NULL, '2890', '2890', NULL, '1953', 'S', 4740, 'TOMAR DO GERU', 'N', '280750', 'N', 'S', 'S', NULL, 105, 'S', 'N', 'N', '74', NULL, '03', 'N', NULL, NULL, NULL, 213);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280760', '2803', 'SE', '2890', '2803', '28012', '28', 'UMBAUBA', NULL, '79', '49260000', '0', '3251', '3251', '22076', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 121.101, '-11,38300', '-37,65800', 130, 'S', 0.6010, NULL, NULL, '28900', 'S', 'N', 5308, NULL, '2890', '2890', NULL, '1953', 'S', 4741, 'UMBAÚBA', 'N', '280760', 'N', 'S', 'S', NULL, 105, 'S', 'N', 'N', '75', NULL, '03', 'N', NULL, NULL, NULL, 213);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290010', '2927', 'BA', '2901', '2906', '29023', '29', 'ABAIRA', NULL, '77', '46690000', '8', '3301', '3301', '04001', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 578.359, '-13,25000', '-41,66400', 641, 'S', 0.6810, NULL, NULL, '29013', 'S', 'N', 7, NULL, '2990', '2990', NULL, '1962', 'S', 202, 'ABAÍRA', 'N', '290010', 'N', 'S', 'S', NULL, 31, 'N', 'N', 'N', '1', NULL, '03', 'N', NULL, NULL, NULL, 4);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290020', '2910', 'BA', '2906', '2902', '29005', '29', 'ABARE', NULL, '75', '48680000', '7', '3303', '3303', '04002', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 1693.690, '-8,72100', '-39,11500', 318, 'S', 0.5950, NULL, NULL, '29062', 'S', 'N', 8, NULL, '2990', '2990', NULL, '1962', 'S', 203, 'ABARÉ', 'N', '290020', 'N', 'S', 'S', NULL, 118, 'S', 'N', 'N', '2', NULL, '03', 'N', NULL, NULL, NULL, 345);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290030', '2903', 'BA', '2905', '2904', '29017', '29', 'ACAJUTIBA', NULL, '75', '48360000', '6', '3305', '3305', '04003', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 267.662, '-11,66200', '-38,01700', 162, 'S', 0.6070, NULL, NULL, '29051', 'S', 'N', 18, NULL, '2990', '2990', NULL, '1952', 'S', 204, 'ACAJUTIBA', 'N', '290030', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '3', NULL, '03', 'N', NULL, NULL, NULL, 400);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290035', '2911', 'BA', '2905', '2904', '29015', '29', 'ADUSTINA', NULL, '75', '48435000', '5', '3253', '3253', '04369', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 619.664, '-10,53300', '-38,10000', 300, 'S', 0.5510, NULL, NULL, '29052', 'S', 'N', 34, NULL, '2990', '2990', NULL, '1990', 'S', 205, 'ADUSTINA', 'N', '290035', 'N', 'S', 'S', NULL, 162, 'N', 'N', 'N', '4', NULL, '03', 'N', NULL, NULL, NULL, 56);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290040', '2912', 'BA', '2901', '2903', '29012', '29', 'AGUA FRIA', NULL, '75', '48170000', '5', '3307', '3307', '04004', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 643.180, '-11,86700', '-38,76700', 312, 'S', 0.5720, NULL, NULL, '29014', 'S', 'N', 56, NULL, '2990', '2990', NULL, '1962', 'S', 206, 'ÁGUA FRIA', 'N', '290040', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '5', NULL, '03', 'N', NULL, NULL, NULL, 47);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290050', '2923', 'BA', '2908', '2906', '29025', '29', 'ERICO CARDOSO', NULL, '77', '46180000', '4', '3309', '3309', '04005', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 701.458, '-13,41800', '-42,14000', 688, 'S', 0.5920, NULL, NULL, '29081', 'S', 'N', 1662, NULL, '2990', '2990', NULL, '1985', 'S', 325, 'ÉRICO CARDOSO', 'N', '290050', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '125', NULL, '03', 'N', NULL, NULL, NULL, 288);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290060', '2913', 'BA', '2909', '2906', '29024', '29', 'AIQUARA', NULL, '73', '45220000', '3', '3311', '3311', '04006', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 195.174, '-14,12900', '-39,88800', 198, 'S', 0.6270, NULL, NULL, '29093', 'S', 'N', 82, NULL, '2990', '2990', NULL, '1962', 'S', 207, 'AIQUARA', 'N', '290060', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '6', NULL, '03', 'N', NULL, NULL, NULL, 290);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290070', '2903', 'BA', '2905', '2904', '29017', '29', 'ALAGOINHAS', NULL, '75', '48100000', '2', '3313', '3313', '04007', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 733.969, '-12,13600', '-38,41900', 132, 'S', 0.7290, NULL, NULL, '29051', 'N', 'N', 92, NULL, '2990', '2990', NULL, '1852', 'S', 208, 'ALAGOINHAS', 'N', '290070', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '7', NULL, '01', 'N', NULL, NULL, NULL, 400);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290080', '2909', 'BA', '2903', '2907', '29032', '29', 'ALCOBACA', NULL, '73', '45990000', '1', '3315', '3315', '04008', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1505.992, '-17,51900', '-39,19600', 9, 'S', 0.6370, NULL, NULL, '29032', 'S', 'N', 99, NULL, '2990', '2990', NULL, '1755', 'S', 209, 'ALCOBAÇA', 'N', '290080', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '8', NULL, '03', 'N', NULL, NULL, NULL, 398);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290090', '2907', 'BA', '2909', '2907', '29031', '29', 'ALMADINA', NULL, '73', '45640000', '0', '3317', '3317', '04009', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 246.894, '-14,70500', '-39,63700', 279, 'S', 0.6230, NULL, NULL, '29092', 'S', 'N', 119, NULL, '2990', '2990', NULL, '1962', 'S', 210, 'ALMADINA', 'N', '290090', 'N', 'S', 'S', NULL, 90, 'S', 'N', 'N', '9', NULL, '03', 'N', NULL, NULL, NULL, 175);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290100', '2929', 'BA', '2904', '2906', '29024', '29', 'AMARGOSA', NULL, '75', '45300000', '7', '3319', '3319', '04010', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 435.932, '-13,03000', '-39,60500', 400, 'S', 0.6620, NULL, NULL, '29044', 'N', 'N', 191, NULL, '2990', '2990', NULL, '1877', 'S', 211, 'AMARGOSA', 'N', '290100', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '10', NULL, '03', 'N', NULL, NULL, NULL, 106);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290110', '2902', 'BA', '2901', '2905', '29019', '29', 'AMELIA RODRIGUES', NULL, '75', '44230000', '6', '3321', '3321', '04011', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 124.075, '-12,40900', '-38,75900', 217, 'S', 0.6950, NULL, NULL, '29011', 'S', 'N', 193, NULL, '2902', '2990', NULL, '1961', 'S', 212, 'AMÉLIA RODRIGUES', 'N', '290110', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '11', NULL, '03', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290115', '2921', 'BA', '2902', '2903', '29009', '29', 'AMERICA DOURADA', NULL, '74', '44910000', '5', '3071', '3071', '04337', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 743.889, '-11,45500', '-41,43600', 666, 'S', 0.5640, NULL, NULL, '29021', 'S', 'N', 194, NULL, '2990', '2990', NULL, '1986', 'S', 213, 'AMÉRICA DOURADA', 'N', '290115', 'N', 'S', 'S', NULL, 50, 'N', 'N', 'N', '12', NULL, '03', 'N', NULL, NULL, NULL, 401);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290120', '2920', 'BA', '2908', '2906', '29028', '29', 'ANAGE', NULL, '77', '45180000', '5', '3323', '3323', '04012', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 1852.554, '-14,61200', '-41,13600', 384, 'S', 0.5860, NULL, NULL, '29084', 'S', 'N', 208, NULL, '2990', '2990', NULL, '1962', 'S', 214, 'ANAGÉ', 'N', '290120', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '13', NULL, '03', 'N', NULL, NULL, NULL, 335);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290130', '2918', 'BA', '2901', '2906', '29023', '29', 'ANDARAI', NULL, '75', '46830000', '4', '3325', '3325', '04013', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1895.162, '-12,80700', '-41,33100', 405, 'S', 0.5690, NULL, NULL, '29012', 'S', 'N', 223, NULL, '2990', '2990', NULL, '1884', 'S', 215, 'ANDARAÍ', 'N', '290130', 'N', 'S', 'S', NULL, 31, 'N', 'N', 'N', '14', NULL, '03', 'N', NULL, NULL, NULL, 55);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290135', '2928', 'BA', '2906', '2903', '29008', '29', 'ANDORINHA', NULL, '74', '48990000', '3', '3255', '3255', '04390', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 1207.680, '-10,34500', '-39,83300', 428, 'S', 0.5700, NULL, NULL, '29063', 'S', 'N', 225, NULL, '2990', '2990', NULL, '1990', 'S', 216, 'ANDORINHA', 'N', '290135', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '15', NULL, '03', 'N', NULL, NULL, NULL, 107);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290140', '2925', 'BA', '2907', '2901', '29002', '29', 'ANGICAL', NULL, '77', '47960000', '3', '3327', '3327', '04014', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1638.717, '-12,00700', '-44,69400', 470, 'S', 0.6250, NULL, NULL, '29071', 'S', 'N', 235, NULL, '2990', '2990', NULL, '1890', 'S', 217, 'ANGICAL', 'N', '290140', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '16', NULL, '03', 'N', NULL, NULL, NULL, 287);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290150', '2902', 'BA', '2901', '2903', '29012', '29', 'ANGUERA', NULL, '75', '44670000', '2', '3329', '3329', '04015', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 158.729, '-12,15100', '-39,24600', 235, 'S', 0.6230, NULL, NULL, '29011', 'S', 'N', 240, NULL, '2903', '2990', NULL, '1961', 'S', 218, 'ANGUERA', 'N', '290150', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '17', NULL, '03', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290160', '2911', 'BA', '2905', '2904', '29015', '29', 'ANTAS', NULL, '75', '48420000', '1', '3331', '3331', '04016', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 383.991, '-10,40000', '-38,33300', 510, 'S', 0.6320, NULL, NULL, '29052', 'S', 'N', 251, NULL, '2990', '2990', NULL, '1953', 'S', 219, 'ANTAS', 'N', '290160', 'N', 'S', 'S', NULL, 162, 'S', 'N', 'N', '18', NULL, '03', 'N', NULL, NULL, NULL, 56);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290170', '2902', 'BA', '2901', '2903', '29012', '29', 'ANTONIO CARDOSO', NULL, '75', '44180000', '0', '3333', '3333', '04017', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 293.217, '-12,43500', '-39,12000', 191, 'S', 0.6470, NULL, NULL, '29011', 'S', 'N', 255, NULL, '2903', '2990', NULL, '1962', 'S', 220, 'ANTÔNIO CARDOSO', 'N', '290170', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '19', NULL, '03', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290180', '2928', 'BA', '2906', '2903', '29008', '29', 'ANTONIO GONCALVES', NULL, '74', '44780000', '9', '3335', '3335', '04018', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 316.131, '-10,57300', '-40,27400', 472, 'S', 0.6200, NULL, NULL, '29063', 'S', 'N', 259, NULL, '2990', '2990', NULL, '1962', 'S', 221, 'ANTÔNIO GONÇALVES', 'N', '290180', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '20', NULL, '03', 'N', NULL, NULL, NULL, 107);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290190', '2903', 'BA', '2905', '2904', '29017', '29', 'APORA', NULL, '75', '48350000', '8', '3337', '3337', '04019', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 572.226, '-11,66000', '-38,08100', 186, 'S', 0.6040, NULL, NULL, '29051', 'S', 'N', 279, NULL, '2990', '2990', NULL, '1958', 'S', 222, 'APORÁ', 'N', '290190', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '21', NULL, '03', 'N', NULL, NULL, NULL, 400);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290195', '2913', 'BA', '2909', '2906', '29024', '29', 'APUAREMA', NULL, '73', '45355000', '7', '3257', '3257', '04391', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 150.686, '-13,85600', '-39,74400', 278, 'S', 0.6170, NULL, NULL, '29093', 'S', 'N', 281, NULL, '2990', '2990', NULL, '1990', 'S', 223, 'APUAREMA', 'N', '290195', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '22', NULL, '03', 'N', NULL, NULL, NULL, 290);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290200', '2919', 'BA', '2908', '2906', '29027', '29', 'ARACATU', NULL, '77', '46130000', '5', '3339', '3339', '04020', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 1535.887, '-14,42800', '-41,46200', 740, 'S', 0.5960, NULL, NULL, '29081', 'S', 'N', 295, NULL, '2990', '2990', NULL, '1962', 'S', 225, 'ARACATU', 'N', '290200', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '24', NULL, '03', 'N', NULL, NULL, NULL, 288);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290205', '2903', 'BA', '2905', '2904', '29017', '29', 'ARACAS', NULL, '75', '48108000', '4', '3259', '3259', '04370', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 419.933, '-12,22000', '-38,20300', 145, 'S', 0.5690, NULL, NULL, '29051', 'S', 'N', 293, NULL, '2990', '2990', NULL, '1990', 'S', 224, 'ARAÇAS', 'N', '290205', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '23', NULL, '03', 'N', NULL, NULL, NULL, 400);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290210', '2912', 'BA', '2901', '2904', '29016', '29', 'ARACI', NULL, '75', '48760000', '4', '3341', '3341', '04021', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 1524.068, '-11,33300', '-38,96700', 272, 'S', 0.5570, NULL, NULL, '29014', 'N', 'N', 297, NULL, '2990', '2990', NULL, '1956', 'S', 226, 'ARACI', 'N', '290210', 'N', 'S', 'S', NULL, 43, 'N', 'N', 'N', '25', NULL, '02', 'N', NULL, NULL, NULL, 47);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290220', '2903', 'BA', '2905', '2904', '29017', '29', 'ARAMARI', NULL, '75', '48130000', '3', '3343', '3343', '04022', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 352.535, '-12,08200', '-38,49900', 394, 'S', 0.5880, NULL, NULL, '29051', 'S', 'N', 320, NULL, '2990', '2990', NULL, '1961', 'S', 227, 'ARAMARI', 'N', '290220', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '26', NULL, '03', 'N', NULL, NULL, NULL, 400);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290225', '2906', 'BA', '2909', '2907', '29031', '29', 'ARATACA', NULL, '73', '45695000', '2', '3073', '3073', '04342', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 396.086, '-15,26300', '-39,41400', 152, 'S', 0.5780, NULL, NULL, '29091', 'S', 'N', 349, NULL, '2990', '2990', NULL, '1986', 'S', 228, 'ARATACA', 'N', '290225', 'N', 'S', 'S', NULL, 90, 'S', 'N', 'N', '27', NULL, '03', 'N', NULL, NULL, NULL, 112);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290230', '2904', 'BA', '2904', '2905', '29020', '29', 'ARATUIPE', NULL, '75', '44490000', '2', '3345', '3345', '04023', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 177.150, '-13,07900', '-39,00200', 36, 'S', 0.6110, NULL, NULL, '29044', 'S', 'N', 352, NULL, '2990', '2990', NULL, '1890', 'S', 229, 'ARATUÍPE', 'N', '290230', 'N', 'S', 'S', NULL, 21, 'S', 'N', 'N', '28', NULL, '03', 'N', NULL, NULL, NULL, 106);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290240', '2907', 'BA', '2909', '2907', '29031', '29', 'AURELINO LEAL', NULL, '73', '45675000', '1', '3347', '3347', '04024', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 446.446, '-14,31700', '-39,32700', 52, 'S', 0.5740, NULL, NULL, '29092', 'S', 'N', 424, NULL, '2990', '2990', NULL, '1961', 'S', 230, 'AURELINO LEAL', 'N', '290240', 'N', 'S', 'S', NULL, 90, 'S', 'N', 'N', '29', NULL, '03', 'N', NULL, NULL, NULL, 175);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290250', '2925', 'BA', '2907', '2901', '29001', '29', 'BAIANOPOLIS', NULL, '77', '47830000', '0', '3349', '3349', '04025', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 3360.088, '-12,30600', '-44,53500', 667, 'S', 0.5920, NULL, NULL, '29071', 'S', 'N', 451, NULL, '2990', '2990', NULL, '1962', 'S', 231, 'BAIANÓPOLIS', 'N', '290250', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '30', NULL, '03', 'N', NULL, NULL, NULL, 287);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290260', '2917', 'BA', '2901', '2903', '29011', '29', 'BAIXA GRANDE', NULL, '74', '44620000', '9', '3351', '3351', '04026', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 982.657, '-11,96000', '-40,16800', 369, 'S', 0.6600, NULL, NULL, '29011', 'S', 'N', 453, NULL, '2990', '2990', NULL, '1885', 'S', 232, 'BAIXA GRANDE', 'N', '290260', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '31', NULL, '03', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290265', '2911', 'BA', '2905', '2904', '29015', '29', 'BANZAE', NULL, '75', '48405000', '8', '3261', '3261', '04371', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 212.316, '-10,57700', '-38,61500', 340, 'S', 0.5920, NULL, NULL, '29052', 'S', 'N', 479, NULL, '2990', '2990', NULL, '1990', 'S', 233, 'BANZAÊ', 'N', '290265', 'N', 'S', 'S', NULL, 162, 'S', 'N', 'N', '32', NULL, '03', 'N', NULL, NULL, NULL, 56);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290270', '2922', 'BA', '2907', '2902', '29006', '29', 'BARRA', NULL, '74', '47100000', '8', '3353', '3353', '04027', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 11332.950, '-11,08900', '-43,14200', 406, 'S', 0.5860, NULL, NULL, '29072', 'N', 'N', 498, NULL, '2990', '2990', NULL, '1752', 'S', 234, 'BARRA', 'N', '290270', 'N', 'S', 'S', NULL, 102, 'N', 'N', 'N', '33', NULL, '02', 'N', NULL, NULL, NULL, 289);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290280', '2919', 'BA', '2908', '2906', '29023', '29', 'BARRA DA ESTIVA', NULL, '77', '46650000', '7', '3355', '3355', '04028', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1401.979, '-13,62600', '-41,32700', 1026, 'S', 0.6390, NULL, NULL, '29081', 'S', 'N', 502, NULL, '2990', '2990', NULL, '1890', 'S', 235, 'BARRA DA ESTIVA', 'N', '290280', 'N', 'S', 'S', NULL, 31, 'N', 'N', 'N', '34', NULL, '03', 'N', NULL, NULL, NULL, 288);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290290', '2920', 'BA', '2908', '2906', '29028', '29', 'BARRA DO CHOCA', NULL, '77', '45120000', '6', '3357', '3357', '04029', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 778.335, '-14,88100', '-40,57900', 847, 'S', 0.6030, NULL, NULL, '29084', 'N', 'N', 512, NULL, '2990', '2990', NULL, '1962', 'S', 236, 'BARRA DO CHOÇA', 'N', '290290', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '35', NULL, '03', 'N', NULL, NULL, NULL, 335);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290300', '2921', 'BA', '2902', '2903', '29009', '29', 'BARRA DO MENDES', NULL, '74', '44990000', '3', '3359', '3359', '04030', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 1252.094, '-11,81000', '-42,05900', 715, 'S', 0.6360, NULL, NULL, '29021', 'S', 'N', 517, NULL, '2990', '2990', NULL, '1958', 'S', 237, 'BARRA DO MENDES', 'N', '290300', 'N', 'S', 'S', NULL, 50, 'N', 'N', 'N', '36', NULL, '03', 'N', NULL, NULL, NULL, 401);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290310', '2913', 'BA', '2909', '2907', '29031', '29', 'BARRA DO ROCHA', NULL, '73', '45560000', '2', '3361', '3361', '04031', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 192.556, '-14,21100', '-39,60200', 142, 'S', 0.5790, NULL, NULL, '29093', 'S', 'N', 523, NULL, '2990', '2990', NULL, '1961', 'S', 238, 'BARRA DO ROCHA', 'N', '290310', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '37', NULL, '03', 'N', NULL, NULL, NULL, 290);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290320', '2925', 'BA', '2907', '2901', '29001', '29', 'BARREIRAS', NULL, '77', '47800000', '1', '3363', '3363', '04032', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 7895.241, '-12,15300', '-44,99000', 452, 'S', 0.7230, NULL, NULL, '29071', 'N', 'N', 534, NULL, '2990', '2990', NULL, '1891', 'S', 239, 'BARREIRAS', 'N', '290320', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '38', NULL, '01', 'N', NULL, NULL, NULL, 287);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290323', '2921', 'BA', '2902', '2903', '29009', '29', 'BARRO ALTO', NULL, '74', '44895000', '5', '3075', '3075', '04338', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 425.750, '-11,76100', '-41,91200', 705, 'S', 0.6210, NULL, NULL, '29021', 'S', 'N', 542, NULL, '2990', '2990', NULL, '1986', 'S', 240, 'BARRO ALTO', 'N', '290323', 'N', 'S', 'S', NULL, 50, 'N', 'N', 'N', '39', NULL, '03', 'N', NULL, NULL, NULL, 401);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290327', '2912', 'BA', '2901', '2904', '29016', '29', 'BARROCAS', NULL, '75', '48705000', '6', '3077', NULL, '04343', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 188.105, '-11,52900', '-39,07800', 0, 'S', NULL, NULL, NULL, '29014', 'S', 'N', 5624, NULL, '2990', '2990', NULL, '2001', 'S', 5559, 'BARROCAS', 'N', '290327', 'N', 'S', 'S', NULL, 43, 'S', 'N', 'N', '41', NULL, '03', 'N', NULL, NULL, NULL, 47);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290330', '2907', 'BA', '2909', '2907', '29031', '29', 'BARRO PRETO', NULL, '73', '45620000', '0', '3365', '3365', '04033', NULL, 'ATIVO', 'N', 'N', NULL, 'GOVERNADOR LOMANTO JUNIOR ', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 120.570, '-14,81000', '-39,47100', 100, 'S', 0.6060, NULL, NULL, '29092', 'S', 'N', 5600, NULL, '2990', '2990', NULL, '1962', 'S', 241, 'BARRO PRETO', 'N', '290330', 'N', 'S', 'S', NULL, 90, 'S', 'N', 'N', '40', NULL, '03', 'N', NULL, NULL, NULL, 175);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290350', '2920', 'BA', '2908', '2906', '29028', '29', 'BELO CAMPO', NULL, '77', '45160000', '8', '3369', '3369', '04035', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 608.594, '-15,03800', '-41,26000', 819, 'S', 0.6310, NULL, NULL, '29084', 'S', 'N', 582, NULL, '2990', '2990', NULL, '1962', 'S', 243, 'BELO CAMPO', 'N', '290350', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '43', NULL, '03', 'N', NULL, NULL, NULL, 335);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290360', '2912', 'BA', '2901', '2904', '29016', '29', 'BIRITINGA', NULL, '75', '48780000', '7', '3371', '3371', '04036', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 430.602, '-11,61700', '-38,80000', 249, 'S', 0.5960, NULL, NULL, '29014', 'S', 'N', 620, NULL, '2990', '2990', NULL, '1962', 'S', 244, 'BIRITINGA', 'N', '290360', 'N', 'S', 'S', NULL, 43, 'S', 'N', 'N', '44', NULL, '03', 'N', NULL, NULL, NULL, 47);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290370', '2913', 'BA', '2909', '2906', '29028', '29', 'BOA NOVA', NULL, '77', '45250000', '6', '3373', '3373', '04037', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 856.886, '-14,36300', '-40,20800', 726, 'S', 0.5640, NULL, NULL, '29093', 'S', 'N', 629, NULL, '2990', '2990', NULL, '1880', 'S', 245, 'BOA NOVA', 'N', '290370', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '45', NULL, '03', 'N', NULL, NULL, NULL, 290);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290380', '2918', 'BA', '2901', '2903', '29011', '29', 'BOA VISTA DO TUPIM', NULL, '75', '46850000', '5', '3375', '3375', '04038', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 2629.822, '-12,66000', '-40,60900', 317, 'S', 0.6050, NULL, NULL, '29012', 'S', 'N', 642, NULL, '2990', '2990', NULL, '1962', 'S', 246, 'BOA VISTA DO TUPIM', 'N', '290380', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '46', NULL, '03', 'N', NULL, NULL, NULL, 55);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290390', '2926', 'BA', '2907', '2902', '29007', '29', 'BOM JESUS DA LAPA', NULL, '77', '47600000', '4', '3377', '3377', '04039', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 3951.425, '-13,25500', '-43,41800', 436, 'S', 0.6540, NULL, NULL, '29073', 'N', 'N', 669, NULL, '2990', '2990', NULL, '1890', 'S', 247, 'BOM JESUS DA LAPA', 'N', '290390', 'N', 'S', 'S', NULL, 102, 'N', 'N', 'S', '47', NULL, '02', 'N', NULL, NULL, NULL, 402);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290395', '2920', 'BA', '2908', '2906', '29028', '29', 'BOM JESUS DA SERRA', NULL, '77', '45263000', '3', '3263', '3263', '04392', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 410.033, '-14,37200', '-40,50400', 600, 'S', 0.5840, NULL, NULL, '29084', 'S', 'N', 671, NULL, '2990', '2990', NULL, '1990', 'S', 248, 'BOM JESUS DA SERRA', 'N', '290395', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '48', NULL, '03', 'N', NULL, NULL, NULL, 335);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290400', '2927', 'BA', '2901', '2906', '29023', '29', 'BONINAL', NULL, '75', '46740000', '1', '3379', '3379', '04040', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 847.905, '-12,70200', '-41,82800', 955, 'S', 0.6560, NULL, NULL, '29013', 'S', 'N', 701, NULL, '2990', '2990', NULL, '1962', 'S', 249, 'BONINAL', 'N', '290400', 'N', 'S', 'S', NULL, 31, 'N', 'N', 'N', '49', NULL, '03', 'N', NULL, NULL, NULL, 4);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290405', '2918', 'BA', '2901', '2906', '29023', '29', 'BONITO', NULL, '75', '46820000', '0', '3265', '3265', '04393', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 641.229, '-11,96600', '-41,26700', 990, 'S', 0.5910, NULL, NULL, '29012', 'S', 'N', 705, NULL, '2990', '2990', NULL, '1990', 'S', 250, 'BONITO', 'N', '290405', 'N', 'S', 'S', NULL, 31, 'S', 'N', 'N', '50', NULL, '03', 'N', NULL, NULL, NULL, 55);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290410', '2923', 'BA', '2908', '2906', '29022', '29', 'BOQUIRA', NULL, '77', '46530000', '0', '3381', '3381', '04041', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 1430.780, '-12,82300', '-42,73100', 641, 'S', 0.6380, NULL, NULL, '29081', 'S', 'N', 713, NULL, '2990', '2990', NULL, '1962', 'S', 251, 'BOQUIRA', 'N', '290410', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '51', NULL, '03', 'N', NULL, NULL, NULL, 288);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290420', '2923', 'BA', '2908', '2906', '29022', '29', 'BOTUPORA', NULL, '77', '46570000', '9', '3383', '3383', '04042', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 552.570, '-13,38200', '-42,52300', 685, 'S', 0.6200, NULL, NULL, '29081', 'S', 'N', 726, NULL, '2990', '2990', NULL, '1962', 'S', 252, 'BOTUPORÃ', 'N', '290420', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '52', NULL, '03', 'N', NULL, NULL, NULL, 288);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290430', '2913', 'BA', '2909', '2906', '29024', '29', 'BREJOES', NULL, '75', '45325000', '8', '3385', '3385', '04043', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 481.292, '-13,10400', '-39,79600', 611, 'S', 0.6430, NULL, NULL, '29093', 'S', 'N', 765, NULL, '2990', '2990', NULL, '1924', 'S', 253, 'BREJÕES', 'N', '290430', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '53', NULL, '03', 'N', NULL, NULL, NULL, 290);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290440', '2925', 'BA', '2907', '2901', '29002', '29', 'BREJOLANDIA', NULL, '77', '47750000', '7', '3387', '3387', '04044', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 2619.439, '-12,48300', '-43,96600', 542, 'S', 0.6340, NULL, NULL, '29071', 'S', 'N', 766, NULL, '2990', '2990', NULL, '1962', 'S', 254, 'BREJOLÂNDIA', 'N', '290440', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '54', NULL, '03', 'N', NULL, NULL, NULL, 287);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290450', '2922', 'BA', '2907', '2906', '29022', '29', 'BROTAS DE MACAUBAS', NULL, '77', '47560000', '6', '3389', '3389', '04045', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 2372.644, '-11,99900', '-42,62600', 813, 'S', 0.6280, NULL, NULL, '29072', 'S', 'N', 773, NULL, '2990', '2990', NULL, '1878', 'S', 255, 'BROTAS DE MACAÚBAS', 'N', '290450', 'N', 'S', 'S', NULL, 102, 'N', 'N', 'N', '55', NULL, '03', 'N', NULL, NULL, NULL, 289);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290460', '2919', 'BA', '2908', '2906', '29027', '29', 'BRUMADO', NULL, '77', '46100000', '5', '3391', '3391', '04046', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 2166.532, '-14,20400', '-41,66500', 422, 'S', 0.6930, NULL, NULL, '29081', 'N', 'N', 775, NULL, '2990', '2990', NULL, '1877', 'S', 256, 'BRUMADO', 'N', '290460', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '56', NULL, '02', 'N', NULL, NULL, NULL, 288);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290470', '2907', 'BA', '2909', '2907', '29031', '29', 'BUERAREMA', NULL, '73', '45615000', '4', '3393', '3393', '04047', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 209.559, '-14,95900', '-39,30000', 107, 'S', 0.6310, NULL, NULL, '29092', 'S', 'N', 781, NULL, '2990', '2990', NULL, '1959', 'S', 257, 'BUERAREMA', 'N', '290470', 'N', 'S', 'S', NULL, 90, 'S', 'N', 'N', '57', NULL, '03', 'N', NULL, NULL, NULL, 175);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290475', '2922', 'BA', '2907', '2902', '29006', '29', 'BURITIRAMA', NULL, '77', '47120000', '3', '3079', '3079', '04344', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 3797.871, '-10,70800', '-43,63100', 492, 'S', 0.5820, NULL, NULL, '29072', 'S', 'N', 797, NULL, '2990', '2990', NULL, '1986', 'S', 258, 'BURITIRAMA', 'N', '290475', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '58', NULL, '03', 'N', NULL, NULL, NULL, 289);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290480', '2914', 'BA', '2908', '2906', '29028', '29', 'CAATIBA', NULL, '77', '45130000', '3', '3395', '3395', '04048', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 655.581, '-14,97700', '-40,40800', 307, 'S', 0.6060, NULL, NULL, '29083', 'S', 'N', 807, NULL, '2990', '2990', NULL, '1961', 'S', 259, 'CAATIBA', 'N', '290480', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '59', NULL, '03', 'N', NULL, NULL, NULL, 176);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290485', '2931', 'BA', '2904', '2905', '29020', '29', 'CABACEIRAS DO PARAGUACU', NULL, '75', '44345000', '2', '3267', '3267', '04394', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 213.550, '-12,53600', '-39,19100', 210, 'S', 0.5920, NULL, NULL, '29042', 'S', 'N', 809, NULL, '2990', '2990', NULL, '1990', 'S', 260, 'CABACEIRAS DO PARAGUAÇU', 'N', '290485', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '60', NULL, '03', 'N', NULL, NULL, NULL, 344);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290490', '2931', 'BA', '2904', '2905', '29020', '29', 'CACHOEIRA', NULL, '75', '44300000', '2', '3397', '3397', '04049', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 398.472, '-12,61800', '-38,95600', 5, 'S', 0.6810, NULL, NULL, '29042', 'N', 'N', 827, NULL, '2990', '2990', NULL, '1693', 'S', 261, 'CACHOEIRA', 'N', '290490', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '61', NULL, '03', 'N', NULL, NULL, NULL, 344);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290500', '2924', 'BA', '2908', '2906', '29026', '29', 'CACULE', NULL, '77', '46300000', '8', '3399', '3399', '04050', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 685.914, '-14,50300', '-42,22200', 587, 'S', 0.6960, NULL, NULL, '29082', 'S', 'N', 854, NULL, '2990', '2990', NULL, '1919', 'S', 262, 'CACULÉ', 'N', '290500', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '62', NULL, '03', 'N', NULL, NULL, NULL, 7);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290510', '2916', 'BA', '2902', '2903', '29010', '29', 'CAEM', NULL, '74', '44730000', '7', '3401', '3401', '04051', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 497.467, '-11,09100', '-40,43500', 472, 'S', 0.5800, NULL, NULL, '29022', 'S', 'N', 855, NULL, '2990', '2990', NULL, '1962', 'S', 263, 'CAÉM', 'N', '290510', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '63', NULL, '03', 'N', NULL, NULL, NULL, 177);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290515', '2920', 'BA', '2908', '2906', '29028', '29', 'CAETANOS', NULL, '77', '45265000', '6', '3269', '3269', '04372', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 857.282, '-14,33800', '-40,91000', 455, 'S', 0.5800, NULL, NULL, '29084', 'S', 'N', 857, NULL, '2990', '2990', NULL, '1990', 'S', 264, 'CAETANOS', 'N', '290515', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '64', NULL, '03', 'N', NULL, NULL, NULL, 335);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290520', '2924', 'BA', '2908', '2906', '29026', '29', 'CAETITE', NULL, '77', '46400000', '6', '3403', '3403', '04052', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 2306.382, '-14,06900', '-42,47500', 824, 'S', 0.6730, NULL, NULL, '29082', 'N', 'N', 860, NULL, '2990', '2990', NULL, '1810', 'S', 265, 'CAETITÉ', 'N', '290520', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '65', NULL, '03', 'N', NULL, NULL, NULL, 7);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290530', '2921', 'BA', '2902', '2903', '29009', '29', 'CAFARNAUM', NULL, '74', '44880000', '5', '3405', '3405', '04053', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 927.491, '-11,69400', '-41,46800', 770, 'S', 0.5980, NULL, NULL, '29021', 'S', 'N', 861, NULL, '2990', '2990', NULL, '1962', 'S', 266, 'CAFARNAUM', 'N', '290530', 'N', 'S', 'S', NULL, 50, 'N', 'N', 'N', '66', NULL, '03', 'N', NULL, NULL, NULL, 401);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290540', '2905', 'BA', '2909', '2907', '29030', '29', 'CAIRU', NULL, '75', '45420000', '4', '3407', '3407', '04054', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 451.194, '-13,48700', '-39,04400', 19, 'S', 0.6390, NULL, NULL, '29094', 'S', 'N', 877, NULL, '2990', '2990', NULL, '1608', 'S', 267, 'CAIRU', 'N', '290540', 'N', 'S', 'S', NULL, 21, 'S', 'N', 'N', '67', NULL, '03', 'N', NULL, NULL, NULL, 283);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290550', '2916', 'BA', '2902', '2903', '29010', '29', 'CALDEIRAO GRANDE', NULL, '74', '44750000', '3', '3409', '3409', '04055', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 495.837, '-11,02000', '-40,30300', 492, 'S', 0.5880, NULL, NULL, '29022', 'S', 'N', 897, NULL, '2990', '2990', NULL, '1962', 'S', 268, 'CALDEIRÃO GRANDE', 'N', '290550', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '68', NULL, '03', 'N', NULL, NULL, NULL, 177);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290560', '2907', 'BA', '2909', '2907', '29031', '29', 'CAMACAN', NULL, '73', '45880000', '2', '3411', '3411', '04056', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 632.926, '-15,41900', '-39,49600', 180, 'S', 0.6310, NULL, NULL, '29092', 'S', 'N', 902, NULL, '2990', '2990', NULL, '1961', 'S', 269, 'CAMACAN', 'N', '290560', 'N', 'S', 'S', NULL, 90, 'S', 'N', 'N', '69', NULL, '03', 'N', NULL, NULL, NULL, 175);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290570', '2901', 'BA', '2904', '2905', '29021', '29', 'CAMACARI', NULL, '71', '42800000', '1', '3413', '3413', '04057', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 759.802, '-12,69800', '-38,32400', 36, 'S', 0.7340, NULL, NULL, '29041', 'N', 'N', 903, NULL, '2901', '2901', NULL, '1758', 'S', 270, 'CAMAÇARI', 'N', '290570', 'N', 'S', 'S', NULL, NULL, 'N', 'S', 'S', '70', NULL, '01', 'N', NULL, NULL, NULL, 343);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290580', '2905', 'BA', '2909', '2907', '29030', '29', 'CAMAMU', NULL, '73', '45445000', '0', '3415', '3415', '04058', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 885.195, '-13,94500', '-39,10400', 40, 'S', 0.6240, NULL, NULL, '29094', 'N', 'N', 906, NULL, '2990', '2990', NULL, '1693', 'S', 271, 'CAMAMU', 'N', '290580', 'N', 'S', 'S', NULL, 21, 'S', 'N', 'N', '71', NULL, '03', 'N', NULL, NULL, NULL, 283);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290590', '2915', 'BA', '2906', '2902', '29004', '29', 'CAMPO ALEGRE DE LOURDES', NULL, '74', '47220000', '9', '3417', '3417', '04059', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 2753.919, '-9,51600', '-43,01100', 477, 'S', 0.5800, NULL, NULL, '29061', 'S', 'N', 946, NULL, '2990', '2990', NULL, '1962', 'S', 272, 'CAMPO ALEGRE DE LOURDES', 'N', '290590', 'N', 'S', 'S', NULL, 143, 'N', 'N', 'N', '72', NULL, '03', 'N', NULL, NULL, NULL, 113);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290600', '2928', 'BA', '2906', '2903', '29008', '29', 'CAMPO FORMOSO', NULL, '74', '44790000', '6', '3419', '3419', '04060', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 6806.097, '-10,50900', '-40,32100', 556, 'S', 0.6130, NULL, NULL, '29063', 'N', 'N', 958, NULL, '2990', '2990', NULL, '1880', 'S', 273, 'CAMPO FORMOSO', 'N', '290600', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '73', NULL, '02', 'N', NULL, NULL, NULL, 107);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290610', '2926', 'BA', '2907', '2901', '29003', '29', 'CANAPOLIS', NULL, '77', '47730000', '5', '3421', '3421', '04061', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 464.307, '-13,07000', '-44,20200', 680, 'S', 0.6250, NULL, NULL, '29073', 'S', 'N', 993, NULL, '2990', '2990', NULL, '1962', 'S', 274, 'CANÁPOLIS', 'N', '290610', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '74', NULL, '03', 'N', NULL, NULL, NULL, 402);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290620', '2921', 'BA', '2902', '2903', '29009', '29', 'CANARANA', NULL, '74', '44890000', '4', '3423', '3423', '04062', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 617.991, '-11,68500', '-41,76900', 691, 'S', 0.6010, NULL, NULL, '29021', 'S', 'N', 996, NULL, '2990', '2990', NULL, '1962', 'S', 275, 'CANARANA', 'N', '290620', 'N', 'S', 'S', NULL, 50, 'N', 'N', 'N', '75', NULL, '03', 'N', NULL, NULL, NULL, 401);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290630', '2906', 'BA', '2909', '2907', '29031', '29', 'CANAVIEIRAS', NULL, '73', '45860000', '3', '3425', '3425', '04063', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1375.556, '-15,67500', '-38,94700', 4, 'S', 0.6390, NULL, NULL, '29091', 'N', 'N', 999, NULL, '2990', '2990', NULL, '1833', 'S', 276, 'CANAVIEIRAS', 'N', '290630', 'N', 'S', 'S', NULL, 90, 'S', 'N', 'N', '76', NULL, '03', 'N', NULL, NULL, NULL, 112);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290640', '2902', 'BA', '2901', '2904', '29016', '29', 'CANDEAL', NULL, '75', '48710000', '2', '3427', '3427', '04064', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 455.278, '-11,80800', '-39,11900', 240, 'S', 0.6100, NULL, NULL, '29011', 'S', 'N', 1000, NULL, '2903', '2990', NULL, '1962', 'S', 277, 'CANDEAL', 'N', '290640', 'N', 'S', 'S', NULL, 43, 'S', 'N', 'N', '77', NULL, '03', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290650', '2901', 'BA', '2904', '2905', '29021', '29', 'CANDEIAS', NULL, '71', '43800000', '1', '3429', '3429', '04065', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 264.487, '-12,66800', '-38,55100', 97, 'S', 0.7190, NULL, NULL, '29043', 'N', 'N', 1001, NULL, '2901', '2901', NULL, '1958', 'S', 278, 'CANDEIAS', 'N', '290650', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '78', NULL, '01', 'N', NULL, NULL, NULL, 178);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290660', '2930', 'BA', '2908', '2906', '29026', '29', 'CANDIBA', NULL, '77', '46380000', '0', '3431', '3431', '04066', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 397.965, '-14,41100', '-42,86700', 578, 'S', 0.6450, NULL, NULL, '29082', 'S', 'N', 1005, NULL, '2990', '2990', NULL, '1962', 'S', 279, 'CANDIBA', 'N', '290660', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '79', NULL, '03', 'N', NULL, NULL, NULL, 7);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290670', '2920', 'BA', '2908', '2906', '29028', '29', 'CANDIDO SALES', NULL, '77', '45157000', '9', '3433', '3433', '04067', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1301.378, '-15,50500', '-41,23900', 627, 'S', 0.6360, NULL, NULL, '29084', 'N', 'N', 1011, NULL, '2990', '2990', NULL, '1962', 'S', 280, 'CÂNDIDO SALES', 'N', '290670', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '80', NULL, '03', 'N', NULL, NULL, NULL, 335);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290680', '2912', 'BA', '2901', '2904', '29014', '29', 'CANSANCAO', NULL, '75', '48840000', '8', '3435', '3435', '04068', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 1319.495, '-10,67100', '-39,49800', 395, 'S', 0.5380, NULL, NULL, '29014', 'N', 'N', 1025, NULL, '2990', '2990', NULL, '1958', 'S', 281, 'CANSANÇÃO', 'N', '290680', 'N', 'S', 'S', NULL, 43, 'S', 'N', 'N', '81', NULL, '03', 'N', NULL, NULL, NULL, 47);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290682', '2915', 'BA', '2901', '2904', '29014', '29', 'CANUDOS', NULL, '75', '48520000', '4', '3085', '3085', '04345', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 2984.883, '-9,96400', '-39,16400', 402, 'S', 0.5990, NULL, NULL, '29061', 'S', 'N', 1032, NULL, '2990', '2990', NULL, '1986', 'S', 282, 'CANUDOS', 'N', '290682', 'N', 'S', 'S', NULL, 143, 'N', 'N', 'N', '82', NULL, '03', 'N', NULL, NULL, NULL, 113);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290685', '2917', 'BA', '2901', '2904', '29016', '29', 'CAPELA DO ALTO ALEGRE', NULL, '75', '44645000', '7', '3081', '3081', '04346', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 655.805, '-11,66800', '-39,83800', 412, 'S', 0.6340, NULL, NULL, '29011', 'S', 'N', 1045, NULL, '2990', '2990', NULL, '1986', 'S', 283, 'CAPELA DO ALTO ALEGRE', 'N', '290685', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '83', NULL, '03', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290687', '2916', 'BA', '2902', '2903', '29010', '29', 'CAPIM GROSSO', NULL, '74', '44695000', '3', '3083', '3083', '04347', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 350.032, '-11,38100', '-40,01300', 416, 'S', 0.6070, NULL, NULL, '29022', 'S', 'N', 1051, NULL, '2990', '2990', NULL, '1986', 'S', 284, 'CAPIM GROSSO', 'N', '290687', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '84', NULL, '03', 'N', NULL, NULL, NULL, 177);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290689', '2920', 'BA', '2908', '2906', '29027', '29', 'CARAIBAS', NULL, '77', '45177000', '9', '3271', '3271', '04373', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1125.474, '-14,60000', '-41,33500', 401, 'S', 0.5780, NULL, NULL, '29084', 'S', 'N', 1076, NULL, '2990', '2990', NULL, '1990', 'S', 285, 'CARAÍBAS', 'N', '290689', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '85', NULL, '03', 'N', NULL, NULL, NULL, 335);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290690', '2909', 'BA', '2903', '2907', '29032', '29', 'CARAVELAS', NULL, '73', '45900000', '7', '3437', '3437', '04069', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 2361.278, '-17,73200', '-39,26600', 10, 'S', 0.6670, NULL, NULL, '29032', 'S', 'N', 1088, NULL, '2990', '2990', NULL, '1700', 'S', 286, 'CARAVELAS', 'N', '290690', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '86', NULL, '03', 'N', NULL, NULL, NULL, 398);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290700', '2903', 'BA', '2905', '2904', '29018', '29', 'CARDEAL DA SILVA', NULL, '75', '48390000', '4', '3439', '3439', '04070', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 184.859, '-11,94200', '-37,94900', 60, 'S', 0.6020, NULL, NULL, '29051', 'S', 'N', 1091, NULL, '2990', '2990', NULL, '1962', 'S', 287, 'CARDEAL DA SILVA', 'N', '290700', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '87', NULL, '03', 'N', NULL, NULL, NULL, 400);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290710', '2930', 'BA', '2908', '2902', '29007', '29', 'CARINHANHA', NULL, '77', '46445000', '3', '3441', '3441', '04071', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 2751.856, '-14,30500', '-43,76500', 440, 'S', 0.6070, NULL, NULL, '29082', 'S', 'N', 1100, NULL, '2990', '2990', NULL, '1832', 'S', 288, 'CARINHANHA', 'N', '290710', 'N', 'S', 'S', NULL, 102, 'N', 'N', 'N', '88', NULL, '03', 'N', NULL, NULL, NULL, 7);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290720', '2915', 'BA', '2906', '2902', '29004', '29', 'CASA NOVA', NULL, '74', '47300000', '2', '3443', '3443', '04072', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 9657.505, '-9,16200', '-40,97100', 397, 'S', 0.6110, NULL, NULL, '29061', 'N', 'N', 1142, NULL, '2602', '2990', NULL, '1879', 'S', 289, 'CASA NOVA', 'N', '290720', 'N', 'S', 'S', NULL, 143, 'N', 'N', 'S', '89', NULL, '02', 'N', NULL, NULL, NULL, 113);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290730', '2904', 'BA', '2904', '2905', '29020', '29', 'CASTRO ALVES', NULL, '75', '44500000', '1', '3445', '3445', '04073', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 762.981, '-12,76600', '-39,42800', 278, 'S', 0.6420, NULL, NULL, '29044', 'S', 'N', 1163, NULL, '2990', '2990', NULL, '1880', 'S', 290, 'CASTRO ALVES', 'N', '290730', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '90', NULL, '03', 'N', NULL, NULL, NULL, 106);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290740', '2925', 'BA', '2907', '2901', '29001', '29', 'CATOLANDIA', NULL, '77', '47815000', '0', '3447', '3447', '04074', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 659.717, '-12,31800', '-44,86100', 650, 'S', 0.6260, NULL, NULL, '29071', 'S', 'N', 1175, NULL, '2990', '2990', NULL, '1962', 'S', 291, 'CATOLÂNDIA', 'N', '290740', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '91', NULL, '03', 'N', NULL, NULL, NULL, 287);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290750', '2903', 'BA', '2905', '2905', '29019', '29', 'CATU', NULL, '71', '48110000', '9', '3449', '3449', '04075', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 439.573, '-12,35300', '-38,37900', 100, 'S', 0.7160, NULL, NULL, '29051', 'N', 'N', 1177, NULL, '2990', '2990', NULL, '1868', 'S', 292, 'CATU', 'N', '290750', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '92', NULL, '02', 'N', NULL, NULL, NULL, 400);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290755', '2923', 'BA', '2908', '2906', '29022', '29', 'CATURAMA', NULL, '77', '46575000', '8', '3273', '3273', '04395', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 646.080, '-13,32900', '-42,29100', 591, 'S', 0.6050, NULL, NULL, '29081', 'S', 'N', 1182, NULL, '2990', '2990', NULL, '1990', 'S', 293, 'CATURAMA', 'N', '290755', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '93', NULL, '03', 'N', NULL, NULL, NULL, 288);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290760', '2921', 'BA', '2902', '2903', '29009', '29', 'CENTRAL', NULL, '74', '44940000', '8', '3451', '3451', '04076', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 606.999, '-11,13600', '-42,11300', 698, 'S', 0.6140, NULL, NULL, '29021', 'S', 'N', 1203, NULL, '2990', '2990', NULL, '1958', 'S', 294, 'CENTRAL', 'N', '290760', 'N', 'S', 'S', NULL, 50, 'N', 'N', 'N', '94', NULL, '03', 'N', NULL, NULL, NULL, 401);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290770', '2910', 'BA', '2906', '2902', '29005', '29', 'CHORROCHO', NULL, '75', '48660000', '7', '3453', '3453', '04077', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 2647.887, '-8,98000', '-39,09400', 350, 'S', 0.5890, NULL, NULL, '29062', 'S', 'N', 1251, NULL, '2990', '2990', NULL, '1952', 'S', 295, 'CHORROCHÓ', 'N', '290770', 'N', 'S', 'S', NULL, 118, 'S', 'N', 'N', '95', NULL, '03', 'N', NULL, NULL, NULL, 345);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290780', '2911', 'BA', '2905', '2904', '29015', '29', 'CICERO DANTAS', NULL, '75', '48410000', '6', '3455', '3455', '04078', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 658.940, '-10,60000', '-38,38300', 436, 'S', 0.5740, NULL, NULL, '29052', 'N', 'N', 1256, NULL, '2990', '2990', NULL, '1875', 'S', 296, 'CÍCERO DANTAS', 'N', '290780', 'N', 'S', 'S', NULL, 162, 'N', 'N', 'N', '96', NULL, '03', 'N', NULL, NULL, NULL, 56);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290790', '2911', 'BA', '2905', '2904', '29015', '29', 'CIPO', NULL, '75', '48450000', '5', '3457', '3457', '04079', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 166.953, '-11,10000', '-38,51700', 132, 'S', 0.6100, NULL, NULL, '29052', 'S', 'N', 1261, NULL, '2990', '2990', NULL, '1931', 'S', 297, 'CIPÓ', 'N', '290790', 'N', 'S', 'S', NULL, 162, 'N', 'N', 'N', '97', NULL, '03', 'N', NULL, NULL, NULL, 56);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290800', '2907', 'BA', '2909', '2907', '29031', '29', 'COARACI', NULL, '73', '45638000', '2', '3459', '3459', '04080', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 296.820, '-14,64100', '-39,55100', 195, 'S', 0.6550, NULL, NULL, '29092', 'S', 'N', 1270, NULL, '2990', '2990', NULL, '1952', 'S', 298, 'COARACI', 'N', '290800', 'N', 'S', 'S', NULL, 90, 'N', 'N', 'N', '98', NULL, '03', 'N', NULL, NULL, NULL, 175);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290810', '2926', 'BA', '2907', '2901', '29003', '29', 'COCOS', NULL, '77', '47680000', '1', '3461', '3461', '04081', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 10084.274, '-14,18400', '-44,53400', 559, 'S', 0.6150, NULL, NULL, '29073', 'S', 'N', 1278, NULL, '2990', '2990', NULL, '1958', 'S', 299, 'COCOS', 'N', '290810', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '99', NULL, '03', 'N', NULL, NULL, NULL, 402);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290820', '2931', 'BA', '2904', '2903', '29012', '29', 'CONCEICAO DA FEIRA', NULL, '75', '44320000', '0', '3463', '3463', '04082', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 159.776, '-12,50600', '-38,99900', 227, 'S', 0.6680, NULL, NULL, '29042', 'S', 'N', 1312, NULL, '2902', '2990', NULL, '1926', 'S', 300, 'CONCEIÇÃO DA FEIRA', 'N', '290820', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '100', NULL, '03', 'N', NULL, NULL, NULL, 344);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290830', '2904', 'BA', '2904', '2905', '29020', '29', 'CONCEICAO DO ALMEIDA', NULL, '75', '44540000', '9', '3465', '3465', '04083', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 281.903, '-12,80900', '-39,16400', 216, 'S', 0.6420, NULL, NULL, '29044', 'S', 'N', 1317, NULL, '2990', '2990', NULL, '1890', 'S', 301, 'CONCEIÇÃO DO ALMEIDA', 'N', '290830', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '101', NULL, '03', 'N', NULL, NULL, NULL, 106);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290840', '2912', 'BA', '2901', '2904', '29016', '29', 'CONCEICAO DO COITE', NULL, '75', '48730000', '8', '3467', '3467', '04084', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 1086.224, '-11,56400', '-39,28300', 440, 'S', 0.6110, NULL, NULL, '29014', 'N', 'N', 1321, NULL, '2990', '2990', NULL, '1890', 'S', 302, 'CONCEIÇÃO DO COITÉ', 'N', '290840', 'N', 'S', 'S', NULL, 43, 'S', 'N', 'N', '102', NULL, '02', 'N', NULL, NULL, NULL, 47);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290850', '2902', 'BA', '2901', '2903', '29012', '29', 'CONCEICAO DO JACUIPE', NULL, '75', '44245000', '7', '3469', '3469', '04085', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 115.680, '-12,32700', '-38,76500', 219, 'S', 0.6950, NULL, NULL, '29011', 'S', 'N', 1322, NULL, '2902', '2990', NULL, '1961', 'S', 303, 'CONCEIÇÃO DO JACUÍPE', 'N', '290850', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '103', NULL, '03', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290860', '2901', 'BA', '2904', '2904', '29018', '29', 'CONDE', NULL, '75', '48300000', '6', '3471', '3471', '04086', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 950.620, '-11,81400', '-37,61100', 12, 'S', 0.5940, NULL, NULL, '29041', 'S', 'N', 1335, NULL, '2990', '2990', NULL, '1935', 'S', 304, 'CONDE', 'N', '290860', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '104', NULL, '03', 'N', NULL, NULL, NULL, 343);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290870', '2920', 'BA', '2908', '2906', '29027', '29', 'CONDEUBA', NULL, '77', '46200000', '5', '3473', '3473', '04087', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 1236.889, '-14,89500', '-41,96900', 680, 'S', 0.6310, NULL, NULL, '29084', 'S', 'N', 1337, NULL, '2990', '2990', NULL, '1860', 'S', 305, 'CONDEÚBA', 'N', '290870', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '105', NULL, '03', 'N', NULL, NULL, NULL, 335);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290880', '2919', 'BA', '2908', '2906', '29023', '29', 'CONTENDAS DO SINCORA', NULL, '77', '46620000', '4', '3475', '3475', '04088', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 862.085, '-13,76300', '-41,04100', 291, 'S', 0.6190, NULL, NULL, '29081', 'S', 'N', 1355, NULL, '2990', '2990', NULL, '1961', 'S', 306, 'CONTENDAS DO SINCORÁ', 'N', '290880', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '106', NULL, '03', 'N', NULL, NULL, NULL, 288);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290890', '2902', 'BA', '2901', '2903', '29012', '29', 'CORACAO DE MARIA', NULL, '75', '44250000', '3', '3477', '3477', '04089', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 372.315, '-12,23300', '-38,75000', 240, 'S', 0.6400, NULL, NULL, '29011', 'S', 'N', 1360, NULL, '2903', '2990', NULL, '1891', 'S', 307, 'CORAÇÃO DE MARIA', 'N', '290890', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '107', NULL, '03', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290900', '2920', 'BA', '2908', '2906', '29027', '29', 'CORDEIROS', NULL, '77', '46280000', '0', '3479', '3479', '04090', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 554.511, '-15,03900', '-41,93500', 710, 'S', 0.6150, NULL, NULL, '29084', 'S', 'N', 1364, NULL, '2990', '2990', NULL, '1961', 'S', 308, 'CORDEIROS', 'N', '290900', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '108', NULL, '03', 'N', NULL, NULL, NULL, 335);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290910', '2926', 'BA', '2907', '2901', '29003', '29', 'CORIBE', NULL, '77', '47690000', '9', '3481', '3481', '04091', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 2678.441, '-13,82900', '-44,45400', 657, 'S', 0.6110, NULL, NULL, '29073', 'S', 'N', 1371, NULL, '2990', '2990', NULL, '1958', 'S', 309, 'CORIBE', 'N', '290910', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '109', NULL, '03', 'N', NULL, NULL, NULL, 402);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290920', '2911', 'BA', '2905', '2904', '29013', '29', 'CORONEL JOAO SA', NULL, '75', '48590000', '8', '3483', '3483', '04092', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 825.767, '-10,28400', '-37,92600', 200, 'S', 0.5260, NULL, NULL, '29052', 'S', 'N', 1385, NULL, '2990', '2990', NULL, '1962', 'S', 310, 'CORONEL JOÃO SÁ', 'N', '290920', 'N', 'S', 'S', NULL, 162, 'S', 'N', 'N', '110', NULL, '03', 'N', NULL, NULL, NULL, 56);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290930', '2926', 'BA', '2907', '2901', '29003', '29', 'CORRENTINA', NULL, '77', '47650000', '7', '3485', '3485', '04093', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 12142.427, '-13,34300', '-44,63700', 561, 'S', 0.6420, NULL, NULL, '29073', 'N', 'N', 1402, NULL, '2990', '2990', NULL, '1891', 'S', 311, 'CORRENTINA', 'N', '290930', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '111', NULL, '03', 'N', NULL, NULL, NULL, 402);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290940', '2925', 'BA', '2907', '2901', '29002', '29', 'COTEGIPE', NULL, '77', '47900000', '6', '3487', '3487', '04094', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 4018.594, '-12,02800', '-44,25800', 472, 'S', 0.6070, NULL, NULL, '29071', 'S', 'N', 1416, NULL, '2990', '2990', NULL, '1820', 'S', 312, 'COTEGIPE', 'N', '290940', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '112', NULL, '03', 'N', NULL, NULL, NULL, 287);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290950', '2913', 'BA', '2909', '2906', '29024', '29', 'CRAVOLANDIA', NULL, '73', '45330000', '5', '3489', '3489', '04095', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 159.645, '-13,35900', '-39,81500', 477, 'S', 0.6360, NULL, NULL, '29093', 'S', 'N', 1429, NULL, '2990', '2990', NULL, '1962', 'S', 313, 'CRAVOLÂNDIA', 'N', '290950', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '113', NULL, '03', 'N', NULL, NULL, NULL, 290);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290960', '2903', 'BA', '2905', '2904', '29017', '29', 'CRISOPOLIS', NULL, '75', '48480000', '4', '3491', '3491', '04096', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 505.433, '-11,51100', '-38,15000', 149, 'S', 0.5530, NULL, NULL, '29051', 'S', 'N', 1432, NULL, '2990', '2990', NULL, '1962', 'S', 314, 'CRISÓPOLIS', 'N', '290960', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '114', NULL, '03', 'N', NULL, NULL, NULL, 400);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290970', '2925', 'BA', '2907', '2901', '29002', '29', 'CRISTOPOLIS', NULL, '77', '47950000', '3', '3493', '3493', '04097', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 896.458, '-12,23400', '-44,42100', 688, 'S', 0.6190, NULL, NULL, '29071', 'S', 'N', 1447, NULL, '2990', '2990', NULL, '1962', 'S', 315, 'CRISTÓPOLIS', 'N', '290970', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '115', NULL, '03', 'N', NULL, NULL, NULL, 287);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290980', '2931', 'BA', '2904', '2905', '29020', '29', 'CRUZ DAS ALMAS', NULL, '75', '44380000', '2', '3495', '3495', '04098', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 150.903, '-12,67000', '-39,10200', 220, 'S', 0.7230, NULL, NULL, '29042', 'N', 'N', 1455, NULL, '2990', '2990', NULL, '1897', 'S', 316, 'CRUZ DAS ALMAS', 'N', '290980', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '116', NULL, '02', 'N', NULL, NULL, NULL, 344);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('290990', '2915', 'BA', '2906', '2902', '29004', '29', 'CURACA', NULL, '74', '48930000', '1', '3497', '3497', '04099', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 6442.190, '-8,99200', '-39,90800', 330, 'S', 0.6260, NULL, NULL, '29061', 'N', 'N', 1485, NULL, '2602', '2990', NULL, '1832', 'S', 317, 'CURAÇÁ', 'N', '290990', 'N', 'S', 'S', NULL, 143, 'N', 'N', 'N', '117', NULL, '03', 'N', NULL, NULL, NULL, 113);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291000', '2913', 'BA', '2909', '2906', '29028', '29', 'DARIO MEIRA', NULL, '73', '45590000', '8', '3499', '3499', '04100', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 400.330, '-14,43600', '-39,90800', 208, 'S', 0.5490, NULL, NULL, '29093', 'S', 'N', 1509, NULL, '2990', '2990', NULL, '1962', 'S', 318, 'DÁRIO MEIRA', 'N', '291000', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '118', NULL, '03', 'N', NULL, NULL, NULL, 290);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291005', '2901', 'BA', '2904', '2905', '29021', '29', 'DIAS D''AVILA', NULL, '71', '42850000', '7', '3087', '3087', '04348', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 207.504, '-12,61300', '-38,29700', 35, 'S', 0.7320, NULL, NULL, '29041', 'N', 'N', 1538, NULL, '2901', '2901', NULL, '1986', 'S', 319, 'DIAS D ÁVILA', 'N', '291005', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '119', NULL, '01', 'N', NULL, NULL, NULL, 343);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291010', '2919', 'BA', '2908', '2906', '29025', '29', 'DOM BASILIO', NULL, '77', '46165000', '7', '3501', '3501', '04101', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 653.025, '-13,76000', '-41,77100', 440, 'S', 0.6390, NULL, NULL, '29081', 'S', 'N', 1570, NULL, '2990', '2990', NULL, '1962', 'S', 320, 'DOM BASÍLIO', 'N', '291010', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '120', NULL, '03', 'N', NULL, NULL, NULL, 288);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291020', '2904', 'BA', '2904', '2905', '29020', '29', 'DOM MACEDO COSTA', NULL, '75', '44560000', '6', '3503', '3503', '04102', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 93.215, '-12,90500', '-39,19300', 192, 'S', 0.6470, NULL, NULL, '29044', 'S', 'N', 1578, NULL, '2990', '2990', NULL, '1962', 'S', 321, 'DOM MACEDO COSTA', 'N', '291020', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '121', NULL, '03', 'N', NULL, NULL, NULL, 106);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291030', '2929', 'BA', '2904', '2903', '29012', '29', 'ELISIO MEDRADO', NULL, '75', '45305000', '5', '3505', '3505', '04103', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 199.541, '-12,94600', '-39,52200', 390, 'S', 0.6550, NULL, NULL, '29044', 'S', 'N', 1631, NULL, '2990', '2990', NULL, '1962', 'S', 322, 'ELÍSIO MEDRADO', 'N', '291030', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '122', NULL, '03', 'N', NULL, NULL, NULL, 106);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291040', '2920', 'BA', '2908', '2906', '29029', '29', 'ENCRUZILHADA', NULL, '77', '45150000', '4', '3507', '3507', '04104', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 2041.093, '-15,53100', '-40,90900', 650, 'S', 0.6020, NULL, NULL, '29084', 'N', 'N', 1640, NULL, '2990', '2990', NULL, '1952', 'S', 323, 'ENCRUZILHADA', 'N', '291040', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '123', NULL, '03', 'N', NULL, NULL, NULL, 335);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291050', '2903', 'BA', '2905', '2904', '29018', '29', 'ENTRE RIOS', NULL, '75', '48180000', '3', '3509', '3509', '04105', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 1235.821, '-11,94200', '-38,08400', 162, 'S', 0.6280, NULL, NULL, '29051', 'N', 'N', 1651, NULL, '2990', '2990', NULL, '1872', 'S', 324, 'ENTRE RIOS', 'N', '291050', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '124', NULL, '03', 'N', NULL, NULL, NULL, 400);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291060', '2903', 'BA', '2905', '2904', '29018', '29', 'ESPLANADA', NULL, '75', '48370000', '2', '3511', '3511', '04106', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1370.693, '-11,79600', '-37,94500', 142, 'S', 0.6090, NULL, NULL, '29051', 'S', 'N', 1686, NULL, '2990', '2990', NULL, '1806', 'S', 326, 'ESPLANADA', 'N', '291060', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '126', NULL, '03', 'N', NULL, NULL, NULL, 400);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291070', '2912', 'BA', '2901', '2904', '29014', '29', 'EUCLIDES DA CUNHA', NULL, '75', '48500000', '1', '3513', '3513', '04107', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 2324.965, '-10,50800', '-39,01400', 472, 'S', 0.5960, NULL, NULL, '29014', 'N', 'N', 1704, NULL, '2990', '2990', NULL, '1933', 'S', 327, 'EUCLIDES DA CUNHA', 'N', '291070', 'N', 'S', 'S', NULL, 162, 'N', 'N', 'N', '127', NULL, '02', 'N', NULL, NULL, NULL, 47);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291072', '2908', 'BA', '2903', '2907', '29032', '29', 'EUNAPOLIS', NULL, '73', '45800000', '7', '3117', '3117', '04368', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 1196.695, '-16,37800', '-39,58000', 189, 'S', 0.7040, NULL, NULL, '29031', 'N', 'N', 1708, NULL, '2990', '2990', NULL, '1989', 'S', 328, 'EUNÁPOLIS', 'N', '291072', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '128', NULL, '01', 'N', NULL, NULL, NULL, 346);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291075', '2911', 'BA', '2905', '2904', '29015', '29', 'FATIMA', NULL, '75', '48415000', '0', '3089', '3089', '04349', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 356.278, '-10,60000', '-38,21700', 100, 'S', 0.5540, NULL, NULL, '29052', 'S', 'N', 1725, NULL, '2990', '2990', NULL, '1986', 'S', 329, 'FÁTIMA', 'N', '291075', 'N', 'S', 'S', NULL, 162, 'S', 'N', 'N', '129', NULL, '03', 'N', NULL, NULL, NULL, 56);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291077', '2926', 'BA', '2907', '2902', '29007', '29', 'FEIRA DA MATA', NULL, '77', '46446000', '6', '3275', '3275', '04374', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1655.819, '-14,20700', '-44,28100', 40, 'S', 0.6340, NULL, NULL, '29073', 'S', 'N', 1736, NULL, '2990', '2990', NULL, '1990', 'S', 330, 'FEIRA DA MATA', 'N', '291077', 'N', 'S', 'S', NULL, 102, 'N', 'N', 'N', '130', NULL, '03', 'N', NULL, NULL, NULL, 402);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291080', '2902', 'BA', '2901', '2903', '29012', '29', 'FEIRA DE SANTANA', NULL, '75', '44001970', '0', '3515', '3515', '04108', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'S', NULL, 'N', 1362.880, '-12,26700', '-38,96700', 234, 'S', 0.7400, NULL, NULL, '29011', 'N', 'N', 1737, NULL, '2902', '2990', NULL, '1832', 'S', 331, 'FEIRA DE SANTANA', 'N', '291080', 'N', 'S', 'S', NULL, NULL, 'N', 'S', 'S', '131', NULL, '01', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291085', '2928', 'BA', '2906', '2903', '29008', '29', 'FILADELFIA', NULL, '74', '44775000', '9', '3091', '3091', '04350', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 564.017, '-10,74100', '-40,13300', 424, 'S', 0.5860, NULL, NULL, '29063', 'S', 'N', 1766, NULL, '2990', '2990', NULL, '1986', 'S', 332, 'FILADÉLFIA', 'N', '291085', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '132', NULL, '03', 'N', NULL, NULL, NULL, 107);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291090', '2914', 'BA', '2908', '2907', '29031', '29', 'FIRMINO ALVES', NULL, '73', '45720000', '9', '3517', '3517', '04109', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 159.397, '-14,98500', '-39,92400', 353, 'S', 0.6410, NULL, NULL, '29083', 'S', 'N', 1768, NULL, '2990', '2990', NULL, '1962', 'S', 333, 'FIRMINO ALVES', 'N', '291090', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '133', NULL, '03', 'N', NULL, NULL, NULL, 176);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291100', '2907', 'BA', '2909', '2907', '29031', '29', 'FLORESTA AZUL', NULL, '73', '45740000', '6', '3519', '3519', '04110', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 351.596, '-14,86000', '-39,66000', 186, 'S', 0.6410, NULL, NULL, '29092', 'S', 'N', 1783, NULL, '2990', '2990', NULL, '1962', 'S', 334, 'FLORESTA AZUL', 'N', '291100', 'N', 'S', 'S', NULL, 90, 'S', 'N', 'N', '134', NULL, '03', 'N', NULL, NULL, NULL, 175);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291110', '2925', 'BA', '2907', '2901', '29001', '29', 'FORMOSA DO RIO PRETO', NULL, '77', '47990000', '5', '3521', '3521', '04111', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 16185.171, '-11,04800', '-45,19300', 490, 'S', 0.6460, NULL, NULL, '29071', 'S', 'N', 1801, NULL, '2990', '2990', NULL, '1961', 'S', 335, 'FORMOSA DO RIO PRETO', 'N', '291110', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '135', NULL, '03', 'N', NULL, NULL, NULL, 287);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291120', '2905', 'BA', '2909', '2907', '29031', '29', 'GANDU', NULL, '73', '45450000', '4', '3523', '3523', '04112', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 229.121, '-13,74400', '-39,48700', 164, 'S', 0.6740, NULL, NULL, '29094', 'S', 'N', 1858, NULL, '2990', '2990', NULL, '1958', 'S', 336, 'GANDU', 'N', '291120', 'N', 'S', 'S', NULL, 21, 'N', 'N', 'N', '136', NULL, '03', 'N', NULL, NULL, NULL, 283);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291125', '2917', 'BA', '2901', '2904', '29016', '29', 'GAVIAO', NULL, '75', '44650000', '3', '3093', '3093', '04351', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 335.567, '-11,47100', '-39,78400', 312, 'S', 0.6400, NULL, NULL, '29011', 'S', 'N', 1871, NULL, '2990', '2990', NULL, '1986', 'S', 337, 'GAVIÃO', 'N', '291125', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '137', NULL, '03', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291130', '2921', 'BA', '2902', '2903', '29009', '29', 'GENTIO DO OURO', NULL, '74', '47450000', '3', '3525', '3525', '04113', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 3671.237, '-11,42900', '-42,50600', 1098, 'S', 0.5750, NULL, NULL, '29021', 'S', 'N', 1881, NULL, '2990', '2990', NULL, '1933', 'S', 338, 'GENTIO DO OURO', 'N', '291130', 'N', 'S', 'S', NULL, 50, 'N', 'N', 'N', '138', NULL, '03', 'N', NULL, NULL, NULL, 401);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291140', '2910', 'BA', '2906', '2902', '29005', '29', 'GLORIA', NULL, '75', '48610000', '2', '3527', '3527', '04114', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 1402.488, '-9,33900', '-38,25700', 250, 'S', 0.6410, NULL, NULL, '29062', 'S', 'N', 1889, NULL, '2990', '2990', NULL, '1886', 'S', 339, 'GLÓRIA', 'N', '291140', 'N', 'S', 'S', NULL, 118, 'N', 'N', 'N', '139', NULL, '03', 'N', NULL, NULL, NULL, 345);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291150', '2907', 'BA', '2909', '2907', '29031', '29', 'GONGOGI', NULL, '73', '45540000', '1', '3529', '3529', '04115', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 198.305, '-14,32200', '-39,46500', 115, 'S', 0.5860, NULL, NULL, '29092', 'S', 'N', 1914, NULL, '2990', '2990', NULL, '1962', 'S', 340, 'GONGOGI', 'N', '291150', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '140', NULL, '03', 'N', NULL, NULL, NULL, 175);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291160', '2931', 'BA', '2904', '2905', '29020', '29', 'GOVERNADOR MANGABEIRA', NULL, '75', '44350000', '0', '3531', '3531', '04116', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 94.359, '-12,60200', '-39,04300', 204, 'S', 0.6760, NULL, NULL, '29042', 'S', 'N', 1926, NULL, '2990', '2990', NULL, '1962', 'S', 341, 'GOVERNADOR MANGABEIRA', 'N', '291160', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '141', NULL, '03', 'N', NULL, NULL, NULL, 344);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291165', '2919', 'BA', '2908', '2906', '29027', '29', 'GUAJERU', NULL, '77', '46205000', '9', '3095', '3095', '04352', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 643.439, '-14,54700', '-41,94000', 628, 'S', 0.6330, NULL, NULL, '29081', 'S', 'N', 1962, NULL, '2990', '2990', NULL, '1986', 'S', 342, 'GUAJERU', 'N', '291165', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '142', NULL, '03', 'N', NULL, NULL, NULL, 288);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291170', '2930', 'BA', '2908', '2906', '29026', '29', 'GUANAMBI', NULL, '77', '46430000', '9', '3533', '3533', '04117', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 1301.799, '-14,22300', '-42,78100', 530, 'S', 0.7010, NULL, NULL, '29082', 'N', 'N', 1965, NULL, '2990', '2990', NULL, '1919', 'S', 343, 'GUANAMBI', 'N', '291170', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '143', NULL, '01', 'N', NULL, NULL, NULL, 7);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291180', '2908', 'BA', '2903', '2907', '29032', '29', 'GUARATINGA', NULL, '73', '45840000', '8', '3535', '3535', '04118', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 2324.317, '-16,58400', '-39,78300', 200, 'S', 0.5930, NULL, NULL, '29031', 'S', 'N', 2002, NULL, '2990', '2990', NULL, '1961', 'S', 344, 'GUARATINGA', 'N', '291180', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '144', NULL, '03', 'N', NULL, NULL, NULL, 346);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291185', '2911', 'BA', '2905', '2904', '29015', '29', 'HELIOPOLIS', NULL, '75', '48445000', '7', '3097', '3097', '04353', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 324.005, '-10,68300', '-38,28600', 328, 'S', 0.5800, NULL, NULL, '29052', 'S', 'N', 2031, NULL, '2990', '2990', NULL, '1986', 'S', 345, 'HELIÓPOLIS', 'N', '291185', 'N', 'S', 'S', NULL, 162, 'S', 'N', 'N', '145', NULL, '03', 'N', NULL, NULL, NULL, 56);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291190', '2918', 'BA', '2901', '2903', '29011', '29', 'IACU', NULL, '75', '46860000', '7', '3537', '3537', '04119', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 2442.840, '-12,76700', '-40,21200', 242, 'S', 0.5920, NULL, NULL, '29012', 'S', 'N', 2052, NULL, '2990', '2990', NULL, '1958', 'S', 346, 'IAÇU', 'N', '291190', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '146', NULL, '03', 'N', NULL, NULL, NULL, 55);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291200', '2924', 'BA', '2908', '2906', '29026', '29', 'IBIASSUCE', NULL, '77', '46390000', '4', '3539', '3539', '04120', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 382.472, '-14,25900', '-42,25700', 574, 'S', 0.6590, NULL, NULL, '29082', 'S', 'N', 2070, NULL, '2990', '2990', NULL, '1962', 'S', 347, 'IBIASSUCÊ', 'N', '291200', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '147', NULL, '03', 'N', NULL, NULL, NULL, 7);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291210', '2907', 'BA', '2909', '2907', '29031', '29', 'IBICARAI', NULL, '73', '45745000', '3', '3541', '3541', '04121', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 217.914, '-14,86500', '-39,58800', 162, 'S', 0.6340, NULL, NULL, '29092', 'S', 'N', 2071, NULL, '2990', '2990', NULL, '1952', 'S', 348, 'IBICARAÍ', 'N', '291210', 'N', 'S', 'S', NULL, 90, 'S', 'N', 'N', '148', NULL, '03', 'N', NULL, NULL, NULL, 175);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291220', '2919', 'BA', '2908', '2906', '29023', '29', 'IBICOARA', NULL, '77', '46760000', '2', '3543', '3543', '04122', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 977.170, '-13,41100', '-41,28500', 1027, 'S', 0.6320, NULL, NULL, '29081', 'S', 'N', 2073, NULL, '2990', '2990', NULL, '1962', 'S', 349, 'IBICOARA', 'N', '291220', 'N', 'S', 'S', NULL, 31, 'N', 'N', 'N', '149', NULL, '03', 'N', NULL, NULL, NULL, 288);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291230', '2914', 'BA', '2908', '2906', '29028', '29', 'IBICUI', NULL, '73', '45290000', '1', '3545', '3545', '04123', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1163.296, '-14,84200', '-39,98700', 365, 'S', 0.6250, NULL, NULL, '29083', 'S', 'N', 2074, NULL, '2990', '2990', NULL, '1952', 'S', 350, 'IBICUÍ', 'N', '291230', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '150', NULL, '03', 'N', NULL, NULL, NULL, 176);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291240', '2921', 'BA', '2902', '2903', '29009', '29', 'IBIPEBA', NULL, '74', '44970000', '0', '3547', '3547', '04124', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1417.141, '-11,64100', '-42,01100', 682, 'S', 0.6280, NULL, NULL, '29021', 'S', 'N', 2077, NULL, '2990', '2990', NULL, '1961', 'S', 351, 'IBIPEBA', 'N', '291240', 'N', 'S', 'S', NULL, 50, 'N', 'N', 'N', '151', NULL, '03', 'N', NULL, NULL, NULL, 401);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291250', '2923', 'BA', '2908', '2906', '29022', '29', 'IBIPITANGA', NULL, '77', '46540000', '9', '3551', '3551', '04126', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 945.222, '-12,88200', '-42,48600', 492, 'S', 0.6250, NULL, NULL, '29081', 'S', 'N', 2078, NULL, '2990', '2990', NULL, '1962', 'S', 352, 'IBIPITANGA', 'N', '291250', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '152', NULL, '03', 'N', NULL, NULL, NULL, 288);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291260', '2918', 'BA', '2901', '2903', '29011', '29', 'IBIQUERA', NULL, '75', '46840000', '8', '3553', '3553', '04127', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1010.776, '-12,65100', '-40,93400', 584, 'S', 0.5720, NULL, NULL, '29012', 'S', 'N', 2080, NULL, '2990', '2990', NULL, '1958', 'S', 353, 'IBIQUERA', 'N', '291260', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '153', NULL, '03', 'N', NULL, NULL, NULL, 55);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291270', '2907', 'BA', '2909', '2907', '29031', '29', 'IBIRAPITANGA', NULL, '73', '45500000', '7', '3555', '3555', '04128', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 470.264, '-14,16400', '-39,37400', 113, 'S', 0.6010, NULL, NULL, '29092', 'S', 'N', 2088, NULL, '2990', '2990', NULL, '1961', 'S', 354, 'IBIRAPITANGA', 'N', '291270', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '154', NULL, '03', 'N', NULL, NULL, NULL, 175);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291280', '2909', 'BA', '2903', '2907', '29032', '29', 'IBIRAPUA', NULL, '73', '45940000', '6', '3557', '3557', '04129', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 786.058, '-17,68800', '-40,10900', 190, 'S', 0.6730, NULL, NULL, '29032', 'S', 'N', 2089, NULL, '2990', '2990', NULL, '1962', 'S', 355, 'IBIRAPUÃ', 'N', '291280', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '155', NULL, '03', 'N', NULL, NULL, NULL, 398);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291290', '2913', 'BA', '2909', '2907', '29031', '29', 'IBIRATAIA', NULL, '73', '45580000', '5', '3559', '3559', '04130', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 226.139, '-14,06700', '-39,64100', 141, 'S', 0.6420, NULL, NULL, '29093', 'S', 'N', 2092, NULL, '2990', '2990', NULL, '1960', 'S', 356, 'IBIRATAIA', 'N', '291290', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '156', NULL, '03', 'N', NULL, NULL, NULL, 290);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291300', '2927', 'BA', '2901', '2906', '29022', '29', 'IBITIARA', NULL, '77', '46700000', '2', '3561', '3561', '04131', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 1748.846, '-12,65200', '-42,21800', 889, 'S', 0.6560, NULL, NULL, '29013', 'S', 'N', 2095, NULL, '2990', '2990', NULL, '1934', 'S', 357, 'IBITIARA', 'N', '291300', 'N', 'S', 'S', NULL, 31, 'N', 'N', 'N', '157', NULL, '03', 'N', NULL, NULL, NULL, 4);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291310', '2921', 'BA', '2902', '2903', '29009', '29', 'IBITITA', NULL, '74', '44960000', '1', '3563', '3563', '04132', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 564.921, '-11,54700', '-41,97800', 782, 'S', 0.6020, NULL, NULL, '29021', 'S', 'N', 2098, NULL, '2990', '2990', NULL, '1961', 'S', 358, 'IBITITÁ', 'N', '291310', 'N', 'S', 'S', NULL, 50, 'N', 'N', 'N', '158', NULL, '03', 'N', NULL, NULL, NULL, 401);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291320', '2922', 'BA', '2907', '2902', '29006', '29', 'IBOTIRAMA', NULL, '77', '47520000', '0', '3565', '3565', '04133', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 1391.232, '-12,18500', '-43,22100', 419, 'S', 0.6970, NULL, NULL, '29072', 'S', 'N', 2102, NULL, '2990', '2990', NULL, '1958', 'S', 359, 'IBOTIRAMA', 'N', '291320', 'N', 'S', 'S', NULL, 102, 'N', 'N', 'N', '159', NULL, '03', 'N', NULL, NULL, NULL, 289);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291330', '2902', 'BA', '2901', '2904', '29016', '29', 'ICHU', NULL, '75', '48725000', '9', '3567', '3567', '04134', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 127.965, '-11,74900', '-39,19200', 280, 'S', 0.6750, NULL, NULL, '29011', 'S', 'N', 2109, NULL, '2990', '2990', NULL, '1962', 'S', 360, 'ICHU', 'N', '291330', 'N', 'S', 'S', NULL, 43, 'S', 'N', 'N', '160', NULL, '03', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291340', '2924', 'BA', '2908', '2906', '29026', '29', 'IGAPORA', NULL, '77', '46490000', '8', '3569', '3569', '04135', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 789.252, '-13,77300', '-42,71400', 765, 'S', 0.6550, NULL, NULL, '29082', 'S', 'N', 2115, NULL, '2990', '2990', NULL, '1960', 'S', 361, 'IGAPORÃ', 'N', '291340', 'N', 'S', 'S', NULL, 102, 'S', 'N', 'N', '161', NULL, '03', 'N', NULL, NULL, NULL, 7);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291345', '2905', 'BA', '2909', '2907', '29030', '29', 'IGRAPIUNA', NULL, '73', '45443000', '7', '3277', '3277', '04375', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 512.837, '-13,82600', '-39,14200', 48, 'S', 0.6010, NULL, NULL, '29094', 'S', 'N', 2127, NULL, '2990', '2990', NULL, '1990', 'S', 362, 'IGRAPIÚNA', 'N', '291345', 'N', 'S', 'S', NULL, 21, 'S', 'N', 'N', '162', NULL, '03', 'N', NULL, NULL, NULL, 283);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291360', '2906', 'BA', '2909', '2907', '29031', '29', 'ILHEUS', NULL, '73', '45660000', '6', '3573', '3573', '04137', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 1840.991, '-14,78900', '-39,04900', 52, 'S', 0.7030, NULL, NULL, '29091', 'N', 'N', 2146, NULL, '2990', '2902', NULL, '1534', 'S', 364, 'ILHÉUS', 'N', '291360', 'N', 'S', 'S', NULL, 90, 'N', 'S', 'S', '164', NULL, '01', 'N', NULL, NULL, NULL, 112);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291370', '2903', 'BA', '2905', '2904', '29017', '29', 'INHAMBUPE', NULL, '75', '48490000', '5', '3575', '3575', '04138', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 1163.561, '-11,78400', '-38,35300', 179, 'S', 0.5670, NULL, NULL, '29051', 'N', 'N', 2181, NULL, '2990', '2990', NULL, '1728', 'S', 365, 'INHAMBUPE', 'N', '291370', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '165', NULL, '03', 'N', NULL, NULL, NULL, 400);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291380', '2902', 'BA', '2901', '2903', '29012', '29', 'IPECAETA', NULL, '75', '44680000', '4', '3577', '3577', '04139', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 393.904, '-12,30000', '-39,30800', 189, 'S', 0.5920, NULL, NULL, '29011', 'S', 'N', 2201, NULL, '2903', '2990', NULL, '1962', 'S', 366, 'IPECAETÁ', 'N', '291380', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '166', NULL, '03', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291390', '2913', 'BA', '2909', '2907', '29031', '29', 'IPIAU', NULL, '73', '45570000', '3', '3579', '3579', '04140', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 286.597, '-14,13700', '-39,73400', 135, 'S', 0.6620, NULL, NULL, '29093', 'N', 'N', 2205, NULL, '2990', '2990', NULL, '1933', 'S', 367, 'IPIAÚ', 'N', '291390', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '167', NULL, '03', 'N', NULL, NULL, NULL, 290);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291400', '2902', 'BA', '2901', '2903', '29012', '29', 'IPIRA', NULL, '75', '44600000', '0', '3581', '3581', '04141', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 3023.659, '-12,15800', '-39,73700', 328, 'S', 0.6090, NULL, NULL, '29011', 'N', 'N', 2208, NULL, '2990', '2990', NULL, '1855', 'S', 368, 'IPIRÁ', 'N', '291400', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '168', NULL, '02', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291410', '2922', 'BA', '2907', '2906', '29022', '29', 'IPUPIARA', NULL, '77', '47590000', '9', '3583', '3583', '04142', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 1179.535, '-11,82000', '-42,61400', 731, 'S', 0.6700, NULL, NULL, '29072', 'S', 'N', 2228, NULL, '2990', '2990', NULL, '1958', 'S', 369, 'IPUPIARA', 'N', '291410', 'N', 'S', 'S', NULL, 50, 'N', 'N', 'N', '169', NULL, '03', 'N', NULL, NULL, NULL, 289);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291420', '2913', 'BA', '2909', '2906', '29024', '29', 'IRAJUBA', NULL, '73', '45370000', '8', '3585', '3585', '04143', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 383.371, '-13,25100', '-40,08400', 542, 'S', 0.5930, NULL, NULL, '29093', 'S', 'N', 2236, NULL, '2990', '2990', NULL, '1962', 'S', 370, 'IRAJUBA', 'N', '291420', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '170', NULL, '03', 'N', NULL, NULL, NULL, 290);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291430', '2913', 'BA', '2909', '2906', '29024', '29', 'IRAMAIA', NULL, '77', '46770000', '7', '3587', '3587', '04144', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 1948.488, '-13,28600', '-40,95100', 607, 'S', 0.6300, NULL, NULL, '29093', 'S', 'N', 2237, NULL, '2990', '2990', NULL, '1960', 'S', 371, 'IRAMAIA', 'N', '291430', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '171', NULL, '03', 'N', NULL, NULL, NULL, 290);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291440', '2927', 'BA', '2901', '2903', '29009', '29', 'IRAQUARA', NULL, '75', '46980000', '6', '3589', '3589', '04145', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 800.332, '-12,24900', '-41,61900', 687, 'S', 0.6050, NULL, NULL, '29013', 'S', 'N', 2242, NULL, '2990', '2990', NULL, '1962', 'S', 372, 'IRAQUARA', 'N', '291440', 'N', 'S', 'S', NULL, 31, 'N', 'N', 'N', '172', NULL, '03', 'N', NULL, NULL, NULL, 4);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291450', '2902', 'BA', '2901', '2903', '29012', '29', 'IRARA', NULL, '75', '44255000', '5', '3591', '3591', '04146', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 239.659, '-12,05000', '-38,76700', 283, 'S', 0.6470, NULL, NULL, '29011', 'S', 'N', 2243, NULL, '2903', '2990', NULL, '1842', 'S', 373, 'IRARÁ', 'N', '291450', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '173', NULL, '03', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291460', '2921', 'BA', '2902', '2903', '29009', '29', 'IRECE', NULL, '74', '44900000', '4', '3593', '3593', '04147', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 313.695, '-11,30400', '-41,85600', 721, 'S', 0.6660, NULL, NULL, '29021', 'N', 'N', 2247, NULL, '2990', '2990', NULL, '1926', 'S', 374, 'IRECÊ', 'N', '291460', 'N', 'S', 'S', NULL, 50, 'N', 'N', 'S', '174', NULL, '02', 'N', NULL, NULL, NULL, 401);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291465', '2908', 'BA', '2903', '2907', '29032', '29', 'ITABELA', NULL, '73', '45848000', '3', '3279', '3279', '04396', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 853.267, '-16,57500', '-39,55300', 130, 'S', 0.6370, NULL, NULL, '29031', 'S', 'N', 2259, NULL, '2990', '2990', NULL, '1990', 'S', 375, 'ITABELA', 'N', '291465', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '175', NULL, '03', 'N', NULL, NULL, NULL, 346);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291470', '2918', 'BA', '2901', '2903', '29011', '29', 'ITABERABA', NULL, '75', '46880000', '3', '3595', '3595', '04148', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 2357.185, '-12,52800', '-40,30700', 265, 'S', 0.6380, NULL, NULL, '29012', 'N', 'N', 2261, NULL, '2990', '2990', NULL, '1877', 'S', 376, 'ITABERABA', 'N', '291470', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '176', NULL, '02', 'N', NULL, NULL, NULL, 55);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291480', '2907', 'BA', '2909', '2907', '29031', '29', 'ITABUNA', NULL, '73', '45600000', '2', '3597', '3597', '04149', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 443.198, '-14,78600', '-39,28000', 54, 'S', 0.7480, NULL, NULL, '29092', 'N', 'N', 2268, NULL, '2990', '2902', NULL, '1906', 'S', 377, 'ITABUNA', 'N', '291480', 'N', 'S', 'S', NULL, 90, 'N', 'S', 'S', '177', NULL, '01', 'N', NULL, NULL, NULL, 175);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291490', '2906', 'BA', '2909', '2907', '29031', '29', 'ITACARE', NULL, '73', '45530000', '1', '3599', '3599', '04150', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 730.280, '-14,27800', '-38,99700', 29, 'S', 0.5880, NULL, NULL, '29091', 'S', 'N', 2272, NULL, '2990', '2990', NULL, '1732', 'S', 378, 'ITACARÉ', 'N', '291490', 'N', 'S', 'S', NULL, 90, 'N', 'N', 'N', '178', NULL, '03', 'N', NULL, NULL, NULL, 112);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291500', '2918', 'BA', '2901', '2906', '29023', '29', 'ITAETE', NULL, '75', '46790000', '7', '3601', '3601', '04151', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1194.489, '-12,98600', '-40,97300', 321, 'S', 0.5820, NULL, NULL, '29012', 'S', 'N', 2276, NULL, '2990', '2990', NULL, '1961', 'S', 379, 'ITAETÉ', 'N', '291500', 'N', 'S', 'S', NULL, 31, 'S', 'N', 'N', '179', NULL, '03', 'N', NULL, NULL, NULL, 55);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291510', '2913', 'BA', '2909', '2906', '29024', '29', 'ITAGI', NULL, '73', '45230000', '6', '3603', '3603', '04152', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 303.462, '-14,16300', '-40,00600', 258, 'S', 0.5860, NULL, NULL, '29093', 'S', 'N', 2277, NULL, '2990', '2990', NULL, '1960', 'S', 380, 'ITAGI', 'N', '291510', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '180', NULL, '03', 'N', NULL, NULL, NULL, 290);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291520', '2913', 'BA', '2909', '2907', '29031', '29', 'ITAGIBA', NULL, '73', '45585000', '5', '3605', '3605', '04153', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 810.340, '-14,28400', '-39,84300', 185, 'S', 0.6150, NULL, NULL, '29093', 'S', 'N', 2278, NULL, '2990', '2990', NULL, '1958', 'S', 381, 'ITAGIBÁ', 'N', '291520', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '181', NULL, '03', 'N', NULL, NULL, NULL, 290);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291530', '2908', 'BA', '2903', '2907', '29032', '29', 'ITAGIMIRIM', NULL, '73', '45850000', '4', '3607', '3607', '04154', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 817.306, '-16,08700', '-39,61400', 176, 'S', 0.6330, NULL, NULL, '29031', 'S', 'N', 2279, NULL, '2990', '2990', NULL, '1962', 'S', 382, 'ITAGIMIRIM', 'N', '291530', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '182', NULL, '03', 'N', NULL, NULL, NULL, 346);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291535', '2921', 'BA', '2902', '2902', '29006', '29', 'ITAGUACU DA BAHIA', NULL, '74', '47440000', '3', '3281', '3281', '04376', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 4396.339, '-11,01200', '-42,39900', 44, 'S', 0.5860, NULL, NULL, '29021', 'S', 'N', 2281, NULL, '2990', '2990', NULL, '1990', 'S', 383, 'ITAGUAÇU DA BAHIA', 'N', '291535', 'N', 'S', 'S', NULL, 50, 'N', 'N', 'N', '183', NULL, '03', 'N', NULL, NULL, NULL, 401);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291540', '2907', 'BA', '2909', '2907', '29031', '29', 'ITAJU DO COLONIA', NULL, '73', '45730000', '3', '3609', '3609', '04155', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 1217.535, '-15,14300', '-39,72400', 167, 'S', 0.6180, NULL, NULL, '29092', 'S', 'N', 2303, NULL, '2990', '2990', NULL, '1962', 'S', 384, 'ITAJU DO COLÔNIA', 'N', '291540', 'N', 'S', 'S', NULL, 90, 'S', 'N', 'N', '184', NULL, '03', 'N', NULL, NULL, NULL, 175);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291550', '2907', 'BA', '2909', '2907', '29031', '29', 'ITAJUIPE', NULL, '73', '45630000', '2', '3611', '3611', '04156', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 295.912, '-14,67800', '-39,37500', 101, 'S', 0.6480, NULL, NULL, '29092', 'S', 'N', 2305, NULL, '2990', '2990', NULL, '1952', 'S', 385, 'ITAJUÍPE', 'N', '291550', 'N', 'S', 'S', NULL, 90, 'N', 'N', 'N', '185', NULL, '03', 'N', NULL, NULL, NULL, 175);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291560', '2909', 'BA', '2903', '2907', '29032', '29', 'ITAMARAJU', NULL, '73', '45836000', '1', '3613', '3613', '04157', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 2369.912, '-17,03900', '-39,53100', 112, 'S', 0.6500, NULL, NULL, '29032', 'N', 'N', 2308, NULL, '2990', '2990', NULL, '1961', 'S', 386, 'ITAMARAJU', 'N', '291560', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '186', NULL, '02', 'N', NULL, NULL, NULL, 398);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291570', '2913', 'BA', '2909', '2907', '29031', '29', 'ITAMARI', NULL, '73', '45455000', '0', '3615', '3615', '04158', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 131.469, '-13,77800', '-39,68400', 232, 'S', 0.6350, NULL, NULL, '29093', 'S', 'N', 2312, NULL, '2990', '2990', NULL, '1962', 'S', 387, 'ITAMARI', 'N', '291570', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '187', NULL, '03', 'N', NULL, NULL, NULL, 290);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291580', '2914', 'BA', '2908', '2906', '29029', '29', 'ITAMBE', NULL, '77', '45140000', '9', '3617', '3617', '04159', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1625.681, '-15,24500', '-40,62400', 346, 'S', 0.6080, NULL, NULL, '29083', 'N', 'N', 2317, NULL, '2990', '2990', NULL, '1927', 'S', 388, 'ITAMBÉ', 'N', '291580', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '188', NULL, '03', 'N', NULL, NULL, NULL, 176);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291590', '2903', 'BA', '2905', '2905', '29019', '29', 'ITANAGRA', NULL, '75', '48290000', '8', '3619', '3619', '04160', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 452.375, '-12,26300', '-38,04200', 44, 'S', 0.6030, NULL, NULL, '29051', 'S', 'N', 2321, NULL, '2990', '2990', NULL, '1962', 'S', 389, 'ITANAGRA', 'N', '291590', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '189', NULL, '03', 'N', NULL, NULL, NULL, 400);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291600', '2909', 'BA', '2903', '2907', '29032', '29', 'ITANHEM', NULL, '73', '45970000', '5', '3621', '3621', '04161', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1445.063, '-17,16600', '-40,33000', 210, 'S', 0.6730, NULL, NULL, '29032', 'S', 'N', 2324, NULL, '2990', '2990', NULL, '1958', 'S', 390, 'ITANHÉM', 'N', '291600', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '190', NULL, '03', 'N', NULL, NULL, NULL, 398);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291610', '2901', 'BA', '2904', '2905', '29021', '29', 'ITAPARICA', NULL, '71', '44460000', '4', '3623', '3623', '04162', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 115.922, '-12,88800', '-38,67900', 15, 'S', 0.7120, NULL, NULL, '29043', 'N', 'N', 2332, NULL, '2901', '2901', NULL, '1831', 'S', 391, 'ITAPARICA', 'N', '291610', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '191', NULL, '01', 'N', NULL, NULL, NULL, 178);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291620', '2907', 'BA', '2909', '2907', '29031', '29', 'ITAPE', NULL, '73', '45750000', '3', '3625', '3625', '04163', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 443.270, '-14,89800', '-39,42100', 40, 'S', 0.6530, NULL, NULL, '29092', 'S', 'N', 2333, NULL, '2990', '2990', NULL, '1961', 'S', 392, 'ITAPÉ', 'N', '291620', 'N', 'S', 'S', NULL, 90, 'S', 'N', 'N', '192', NULL, '03', 'N', NULL, NULL, NULL, 175);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291630', '2908', 'BA', '2903', '2907', '29031', '29', 'ITAPEBI', NULL, '73', '45855000', '2', '3627', '3627', '04164', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 972.036, '-15,95100', '-39,53400', 177, 'S', 0.6360, NULL, NULL, '29031', 'S', 'N', 2334, NULL, '2990', '2990', NULL, '1958', 'S', 393, 'ITAPEBI', 'N', '291630', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '193', NULL, '03', 'N', NULL, NULL, NULL, 346);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291640', '2914', 'BA', '2908', '2906', '29029', '29', 'ITAPETINGA', NULL, '77', '45700000', '1', '3629', '3629', '04165', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1609.515, '-15,24900', '-40,24800', 279, 'S', 0.7000, NULL, NULL, '29083', 'N', 'N', 2344, NULL, '2990', '2990', NULL, '1952', 'S', 394, 'ITAPETINGA', 'N', '291640', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '194', NULL, '02', 'N', NULL, NULL, NULL, 176);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291650', '2903', 'BA', '2905', '2904', '29015', '29', 'ITAPICURU', NULL, '75', '48475000', '0', '3631', '3631', '04166', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 1550.832, '-11,31700', '-38,23300', 155, 'S', 0.5210, NULL, NULL, '29051', 'S', 'N', 2349, NULL, '2990', '2990', NULL, '1728', 'S', 395, 'ITAPICURU', 'N', '291650', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '195', NULL, '03', 'N', NULL, NULL, NULL, 400);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291660', '2907', 'BA', '2909', '2907', '29031', '29', 'ITAPITANGA', NULL, '73', '45645000', '9', '3633', '3633', '04167', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 410.422, '-14,42300', '-39,56500', 152, 'S', 0.6080, NULL, NULL, '29092', 'S', 'N', 2358, NULL, '2990', '2990', NULL, '1960', 'S', 396, 'ITAPITANGA', 'N', '291660', 'N', 'S', 'S', NULL, 90, 'S', 'N', 'N', '196', NULL, '03', 'N', NULL, NULL, NULL, 175);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291670', '2913', 'BA', '2909', '2906', '29024', '29', 'ITAQUARA', NULL, '73', '45340000', '8', '3635', '3635', '04168', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 296.896, '-13,45100', '-39,94100', 578, 'S', 0.5860, NULL, NULL, '29093', 'S', 'N', 2374, NULL, '2990', '2990', NULL, '1926', 'S', 397, 'ITAQUARA', 'N', '291670', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '197', NULL, '03', 'N', NULL, NULL, NULL, 290);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291680', '2914', 'BA', '2908', '2906', '29029', '29', 'ITARANTIM', NULL, '73', '45780000', '7', '3637', '3637', '04169', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1783.747, '-15,66000', '-40,06600', 259, 'S', 0.6590, NULL, NULL, '29083', 'S', 'N', 2379, NULL, '2990', '2990', NULL, '1961', 'S', 398, 'ITARANTIM', 'N', '291680', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '198', NULL, '03', 'N', NULL, NULL, NULL, 176);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291685', '2929', 'BA', '2904', '2903', '29012', '29', 'ITATIM', NULL, '75', '46875000', '6', '3283', '3283', '04397', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 574.259, '-12,71200', '-39,69800', 260, 'S', 0.6350, NULL, NULL, '29044', 'S', 'N', 2388, NULL, '2990', '2990', NULL, '1990', 'S', 399, 'ITATIM', 'N', '291685', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '199', NULL, '03', 'N', NULL, NULL, NULL, 106);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291690', '2913', 'BA', '2909', '2906', '29024', '29', 'ITIRUCU', NULL, '73', '45350000', '6', '3639', '3639', '04170', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 302.926, '-13,53200', '-40,15000', 820, 'S', 0.6540, NULL, NULL, '29093', 'S', 'N', 2406, NULL, '2990', '2990', NULL, '1935', 'S', 400, 'ITIRUÇU', 'N', '291690', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '200', NULL, '03', 'N', NULL, NULL, NULL, 290);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291700', '2928', 'BA', '2906', '2903', '29008', '29', 'ITIUBA', NULL, '74', '48850000', '3', '3641', '3641', '04171', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 1730.792, '-10,69100', '-39,85300', 377, 'S', 0.5740, NULL, NULL, '29063', 'N', 'N', 2407, NULL, '2990', '2990', NULL, '1935', 'S', 401, 'ITIÚBA', 'N', '291700', 'N', 'S', 'S', NULL, 43, 'N', 'N', 'N', '201', NULL, '03', 'N', NULL, NULL, NULL, 107);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291710', '2914', 'BA', '2908', '2906', '29029', '29', 'ITORORO', NULL, '73', '45710000', '2', '3643', '3643', '04172', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 330.716, '-15,11700', '-40,07000', 237, 'S', 0.6250, NULL, NULL, '29083', 'S', 'N', 2409, NULL, '2990', '2990', NULL, '1958', 'S', 402, 'ITORORÓ', 'N', '291710', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '202', NULL, '03', 'N', NULL, NULL, NULL, 176);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291720', '2919', 'BA', '2908', '2906', '29027', '29', 'ITUACU', NULL, '77', '46640000', '1', '3645', '3645', '04173', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 1216.149, '-13,81300', '-41,29700', 520, 'S', 0.6190, NULL, NULL, '29081', 'S', 'N', 2411, NULL, '2990', '2990', NULL, '1867', 'S', 403, 'ITUAÇU', 'N', '291720', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '203', NULL, '03', 'N', NULL, NULL, NULL, 288);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291730', '2905', 'BA', '2909', '2907', '29030', '29', 'ITUBERA', NULL, '73', '45435000', '0', '3647', '3647', '04174', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 417.542, '-13,73200', '-39,14900', 27, 'S', 0.6200, NULL, NULL, '29094', 'S', 'N', 2412, NULL, '2990', '2990', NULL, '1758', 'S', 404, 'ITUBERÁ', 'N', '291730', 'N', 'S', 'S', NULL, 21, 'N', 'N', 'N', '204', NULL, '03', 'N', NULL, NULL, NULL, 283);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291733', '2930', 'BA', '2908', '2906', '29026', '29', 'IUIU', NULL, '77', '46438000', '4', '3285', '3285', '04377', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1095.715, '-14,41400', '-43,55400', 490, 'S', 0.6110, NULL, NULL, '29082', 'S', 'N', 2423, NULL, '2990', '2990', NULL, '1990', 'S', 405, 'IUIÚ', 'N', '291733', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '205', NULL, '03', 'N', NULL, NULL, NULL, 7);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291735', '2926', 'BA', '2907', '2901', '29003', '29', 'JABORANDI', NULL, '77', '47655000', '9', '9859', '9859', '04354', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 9479.853, '-13,61900', '-44,43300', 448, 'S', 0.6170, NULL, NULL, '29073', 'S', 'N', 2436, NULL, '2990', '2990', NULL, '1986', 'S', 406, 'JABORANDI', 'N', '291735', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '206', NULL, '03', 'N', NULL, NULL, NULL, 402);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291740', '2924', 'BA', '2908', '2906', '29026', '29', 'JACARACI', NULL, '77', '46310000', '9', '3649', '3649', '04175', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 1241.918, '-14,85000', '-42,43300', 900, 'S', 0.6540, NULL, NULL, '29082', 'S', 'N', 2442, NULL, '2990', '2990', NULL, '1880', 'S', 407, 'JACARACI', 'N', '291740', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '207', NULL, '03', 'N', NULL, NULL, NULL, 7);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291750', '2916', 'BA', '2902', '2903', '29010', '29', 'JACOBINA', NULL, '74', '44700000', '8', '3651', '3651', '04176', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 2319.825, '-11,18100', '-40,51800', 463, 'S', 0.6520, NULL, NULL, '29022', 'N', 'N', 2452, NULL, '2990', '2990', NULL, '1722', 'S', 408, 'JACOBINA', 'N', '291750', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '208', NULL, '01', 'N', NULL, NULL, NULL, 177);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291760', '2913', 'BA', '2909', '2906', '29024', '29', 'JAGUAQUARA', NULL, '73', '45345000', '7', '3653', '3653', '04177', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 960.398, '-13,53100', '-39,97100', 667, 'S', 0.6470, NULL, NULL, '29093', 'N', 'N', 2461, NULL, '2990', '2990', NULL, '1921', 'S', 409, 'JAGUAQUARA', 'N', '291760', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '209', NULL, '03', 'N', NULL, NULL, NULL, 290);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291770', '2928', 'BA', '2906', '2903', '29008', '29', 'JAGUARARI', NULL, '74', '48960000', '6', '3655', '3655', '04178', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 2567.158, '-10,26000', '-40,19600', 662, 'S', 0.6460, NULL, NULL, '29063', 'S', 'N', 2464, NULL, '2990', '2990', NULL, '1926', 'S', 410, 'JAGUARARI', 'N', '291770', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '210', NULL, '03', 'N', NULL, NULL, NULL, 107);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291780', '2904', 'BA', '2904', '2905', '29020', '29', 'JAGUARIPE', NULL, '75', '44480000', '5', '3657', '3657', '04179', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 891.345, '-13,11300', '-38,89600', 11, 'S', 0.6040, NULL, NULL, '29044', 'S', 'N', 2471, NULL, '2990', '2990', NULL, '1693', 'S', 411, 'JAGUARIPE', 'N', '291780', 'N', 'S', 'S', NULL, 21, 'N', 'N', 'N', '211', NULL, '03', 'N', NULL, NULL, NULL, 106);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291790', '2903', 'BA', '2905', '2904', '29018', '29', 'JANDAIRA', NULL, '75', '48310000', '4', '3659', '3659', '04180', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 642.652, '-11,56400', '-37,78400', 146, 'S', 0.5750, NULL, NULL, '29051', 'S', 'N', 2483, NULL, '2990', '2990', NULL, '1944', 'S', 412, 'JANDAÍRA', 'N', '291790', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '212', NULL, '03', 'N', NULL, NULL, NULL, 400);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291800', '2913', 'BA', '2909', '2906', '29024', '29', 'JEQUIE', NULL, '73', '45200000', '1', '3661', '3661', '04181', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 3035.423, '-13,85800', '-40,08400', 215, 'S', 0.6940, NULL, NULL, '29093', 'N', 'N', 2537, NULL, '2990', '2990', NULL, '1897', 'S', 413, 'JEQUIÉ', 'N', '291800', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '213', NULL, '01', 'N', NULL, NULL, NULL, 290);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291810', '2910', 'BA', '2906', '2904', '29013', '29', 'JEREMOABO', NULL, '75', '48540000', '0', '3663', '3663', '04182', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 4761.114, '-10,06700', '-38,35000', 275, 'S', 0.5570, NULL, NULL, '29062', 'N', 'N', 2541, NULL, '2990', '2990', NULL, '1831', 'S', 415, 'JEREMOABO', 'N', '291810', 'N', 'S', 'S', NULL, 162, 'N', 'N', 'N', '214', NULL, '03', 'N', NULL, NULL, NULL, 345);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291820', '2929', 'BA', '2904', '2906', '29024', '29', 'JIQUIRICA', NULL, '75', '45470000', '9', '3665', '3665', '04183', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 236.255, '-13,25700', '-39,57200', 342, 'S', 0.6330, NULL, NULL, '29044', 'S', 'N', 2551, NULL, '2990', '2990', NULL, '1891', 'S', 414, 'JIQUIRIÇÁ', 'N', '291820', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '215', NULL, '03', 'N', NULL, NULL, NULL, 106);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291830', '2913', 'BA', '2909', '2906', '29024', '29', 'JITAUNA', NULL, '73', '45225000', '8', '3667', '3667', '04184', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 332.805, '-14,01900', '-39,88900', 163, 'S', 0.6190, NULL, NULL, '29093', 'S', 'N', 2552, NULL, '2990', '2990', NULL, '1961', 'S', 416, 'JITAÚNA', 'N', '291830', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '216', NULL, '03', 'N', NULL, NULL, NULL, 290);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291835', '2921', 'BA', '2902', '2903', '29009', '29', 'JOAO DOURADO', NULL, '74', '44920000', '7', '3099', '3099', '04339', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 984.019, '-11,35000', '-41,66400', 815, 'S', 0.5960, NULL, NULL, '29021', 'S', 'N', 2561, NULL, '2990', '2990', NULL, '1986', 'S', 417, 'JOÃO DOURADO', 'N', '291835', 'N', 'S', 'S', NULL, 50, 'N', 'N', 'N', '217', NULL, '03', 'N', NULL, NULL, NULL, 401);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291840', '2915', 'BA', '2906', '2902', '29004', '29', 'JUAZEIRO', NULL, '74', '48900000', '7', '3669', '3669', '04185', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 6389.623, '-9,41400', '-40,50300', 368, 'S', 0.6830, NULL, NULL, '29061', 'N', 'N', 2592, NULL, '2602', '2603', NULL, '1833', 'S', 418, 'JUAZEIRO', 'N', '291840', 'N', 'S', 'S', NULL, 143, 'N', 'S', 'S', '218', NULL, '01', 'N', NULL, NULL, NULL, 113);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291845', '2909', 'BA', '2903', '2907', '29032', '29', 'JUCURUCU', NULL, '73', '45834000', '6', '3287', '3287', '04378', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1438.463, '-16,84300', '-40,15900', 365, 'S', 0.5830, NULL, NULL, '29032', 'S', 'N', 2597, NULL, '2990', '2990', NULL, '1990', 'S', 419, 'JUCURUÇU', 'N', '291845', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '219', NULL, '03', 'N', NULL, NULL, NULL, 398);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291850', '2921', 'BA', '2902', '2903', '29009', '29', 'JUSSARA', NULL, '74', '44925000', '6', '3671', '3671', '04186', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 886.019, '-11,04700', '-41,96900', 620, 'S', 0.5680, NULL, NULL, '29021', 'S', 'N', 2627, NULL, '2990', '2990', NULL, '1962', 'S', 420, 'JUSSARA', 'N', '291850', 'N', 'S', 'S', NULL, 50, 'N', 'N', 'N', '220', NULL, '03', 'N', NULL, NULL, NULL, 401);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291855', '2907', 'BA', '2909', '2907', '29031', '29', 'JUSSARI', NULL, '73', '45610000', '5', '3069', '3069', '04355', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 356.735, '-15,19100', '-39,49500', 196, 'S', 0.6470, NULL, NULL, '29092', 'S', 'N', 2630, NULL, '2990', '2990', NULL, '1986', 'S', 421, 'JUSSARI', 'N', '291855', 'N', 'S', 'S', NULL, 90, 'S', 'N', 'N', '221', NULL, '03', 'N', NULL, NULL, NULL, 175);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291860', '2919', 'BA', '2908', '2906', '29023', '29', 'JUSSIAPE', NULL, '77', '46670000', '5', '3673', '3673', '04187', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 523.395, '-13,51700', '-41,59300', 538, 'S', 0.6600, NULL, NULL, '29081', 'S', 'N', 2631, NULL, '2990', '2990', NULL, '1962', 'S', 422, 'JUSSIAPE', 'N', '291860', 'N', 'S', 'S', NULL, 31, 'S', 'N', 'N', '222', NULL, '03', 'N', NULL, NULL, NULL, 288);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291870', '2913', 'BA', '2909', '2906', '29024', '29', 'LAFAIETE COUTINHO', NULL, '73', '45215000', '4', '3675', '3675', '04188', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 352.658, '-13,65600', '-40,21300', 558, 'S', 0.6070, NULL, NULL, '29093', 'S', 'N', 2640, NULL, '2990', '2990', NULL, '1962', 'S', 423, 'LAFAIETE COUTINHO', 'N', '291870', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '223', NULL, '03', 'N', NULL, NULL, NULL, 290);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291875', '2924', 'BA', '2908', '2906', '29026', '29', 'LAGOA REAL', NULL, '77', '46425000', '3', '3289', '3289', '04399', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 996.292, '-14,03500', '-42,14200', 525, 'S', 0.6050, NULL, NULL, '29082', 'S', 'N', 2675, NULL, '2990', '2990', NULL, '1990', 'S', 424, 'LAGOA REAL', 'N', '291875', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '224', NULL, '03', 'N', NULL, NULL, NULL, 7);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291880', '2929', 'BA', '2904', '2906', '29024', '29', 'LAJE', NULL, '75', '45490000', '3', '3677', '3677', '04189', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 498.089, '-13,18200', '-39,42500', 190, 'S', 0.6540, NULL, NULL, '29044', 'S', 'N', 2685, NULL, '2990', '2990', NULL, '1905', 'S', 425, 'LAJE', 'N', '291880', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '225', NULL, '03', 'N', NULL, NULL, NULL, 106);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291890', '2909', 'BA', '2903', '2907', '29032', '29', 'LAJEDAO', NULL, '73', '45950000', '2', '3679', '3679', '04190', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 613.907, '-17,61400', '-40,34500', 290, 'S', 0.6390, NULL, NULL, '29032', 'S', 'N', 2692, NULL, '2990', '2990', NULL, '1962', 'S', 426, 'LAJEDÃO', 'N', '291890', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '226', NULL, '03', 'N', NULL, NULL, NULL, 398);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291900', '2918', 'BA', '2901', '2903', '29011', '29', 'LAJEDINHO', NULL, '75', '46825000', '9', '3681', '3681', '04191', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 807.336, '-12,35600', '-40,90600', 530, 'S', 0.5830, NULL, NULL, '29012', 'S', 'N', 2693, NULL, '2990', '2990', NULL, '1962', 'S', 427, 'LAJEDINHO', 'N', '291900', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '227', NULL, '03', 'N', NULL, NULL, NULL, 55);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291905', '2913', 'BA', '2909', '2906', '29024', '29', 'LAJEDO DO TABOCAL', NULL, '73', '45365000', '8', '3291', '3291', '04398', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 423.785, '-13,47500', '-40,22400', 875, 'S', 0.6240, NULL, NULL, '29093', 'S', 'N', 2695, NULL, '2990', '2990', NULL, '1990', 'S', 428, 'LAJEDO DO TABOCAL', 'N', '291905', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '228', NULL, '03', 'N', NULL, NULL, NULL, 290);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291910', '2912', 'BA', '2901', '2904', '29016', '29', 'LAMARAO', NULL, '75', '48720000', '8', '3683', '3683', '04192', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 356.002, '-11,78300', '-38,90000', 315, 'S', 0.6080, NULL, NULL, '29014', 'S', 'N', 2699, NULL, '2990', '2990', NULL, '1962', 'S', 429, 'LAMARÃO', 'N', '291910', 'N', 'S', 'S', NULL, 43, 'S', 'N', 'N', '229', NULL, '03', 'N', NULL, NULL, NULL, 47);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291915', '2921', 'BA', '2902', '2903', '29009', '29', 'LAPAO', NULL, '74', '44905000', '7', '3973', '3973', '04340', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 638.317, '-11,38300', '-41,83200', 775, 'S', 0.6210, NULL, NULL, '29021', 'S', 'N', 2705, NULL, '2990', '2990', NULL, '1986', 'S', 430, 'LAPÃO', 'N', '291915', 'N', 'S', 'S', NULL, 50, 'N', 'N', 'N', '230', NULL, '03', 'N', NULL, NULL, NULL, 401);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291920', '2901', 'BA', '2904', '2905', '29021', '29', 'LAURO DE FREITAS', NULL, '71', '42700000', '7', '3685', '3685', '04193', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 59.905, '-12,89400', '-38,32700', 30, 'S', 0.7710, NULL, NULL, '29043', 'N', 'N', 2716, NULL, '2901', '2901', NULL, '1962', 'S', 431, 'LAURO DE FREITAS', 'N', '291920', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '231', NULL, '01', 'N', NULL, NULL, NULL, 178);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291930', '2927', 'BA', '2901', '2906', '29023', '29', 'LENCOIS', NULL, '75', '46960000', '6', '3687', '3687', '04194', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1240.362, '-12,56300', '-41,39000', 394, 'S', 0.6140, NULL, NULL, '29013', 'S', 'N', 2728, NULL, '2990', '2990', NULL, '1857', 'S', 432, 'LENÇÓIS', 'N', '291930', 'N', 'S', 'S', NULL, 31, 'S', 'N', 'N', '232', NULL, '03', 'N', NULL, NULL, NULL, 4);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291940', '2924', 'BA', '2908', '2906', '29026', '29', 'LICINIO DE ALMEIDA', NULL, '77', '46330000', '5', '3689', '3689', '04195', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 785.417, '-14,68200', '-42,50800', 852, 'S', 0.6750, NULL, NULL, '29082', 'S', 'N', 2736, NULL, '2990', '2990', NULL, '1962', 'S', 433, 'LICÍNIO DE ALMEIDA', 'N', '291940', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '233', NULL, '03', 'N', NULL, NULL, NULL, 7);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291950', '2919', 'BA', '2908', '2906', '29025', '29', 'LIVRAMENTO DE NOSSA SENHORA', NULL, '77', '46140000', '4', '3691', '3691', '04196', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 2267.021, '-13,64300', '-41,84100', 475, 'S', 0.6540, NULL, NULL, '29081', 'N', 'N', 2754, NULL, '2990', '2990', NULL, '1921', 'S', 434, 'LIVRAMENTO DE NOSSA SENHORA', 'N', '291950', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '234', NULL, '03', 'N', NULL, NULL, NULL, 288);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291955', '2925', 'BA', '2907', '2901', '29001', '29', 'LUIS EDUARDO MAGALHAES', NULL, '77', '47850000', '3', '1112', NULL, '04417', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4018.778, '-12,09200', '-45,80500', 0, 'S', NULL, NULL, NULL, '29071', 'S', 'N', 5626, NULL, '2990', '2990', NULL, '2001', 'S', 5560, 'LUÍS EDUARDO MAGALHÃES', 'N', '291955', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '235', NULL, '02', 'N', NULL, NULL, NULL, 287);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291960', '2918', 'BA', '2901', '2903', '29011', '29', 'MACAJUBA', NULL, '74', '46805000', '3', '3693', '3693', '04197', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 707.098, '-12,13600', '-40,36000', 353, 'S', 0.5900, NULL, NULL, '29012', 'S', 'N', 2793, NULL, '2990', '2990', NULL, '1944', 'S', 435, 'MACAJUBA', 'N', '291960', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '236', NULL, '03', 'N', NULL, NULL, NULL, 55);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291990', '2910', 'BA', '2906', '2902', '29005', '29', 'MACURURE', NULL, '75', '48650000', '0', '3699', '3699', '04200', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 2278.726, '-9,16800', '-39,05800', 357, 'S', 0.5990, NULL, NULL, '29062', 'S', 'N', 2812, NULL, '2990', '2990', NULL, '1962', 'S', 438, 'MACURURÉ', 'N', '291990', 'N', 'S', 'S', NULL, 118, 'S', 'N', 'N', '239', NULL, '03', 'N', NULL, NULL, NULL, 345);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291992', '2901', 'BA', '2904', '2905', '29021', '29', 'MADRE DE DEUS', NULL, '71', '42600000', '6', '3293', '3293', '04400', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 11.141, '-12,74100', '-38,62100', 5, 'S', 0.7400, NULL, NULL, '29043', 'N', 'N', 2815, NULL, '2901', '2901', NULL, '1990', 'S', 439, 'MADRE DE DEUS', 'N', '291992', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '240', NULL, '01', 'N', NULL, NULL, NULL, 178);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291995', '2920', 'BA', '2908', '2906', '29027', '29', 'MAETINGA', NULL, '77', '46255000', '9', '3975', '3975', '04356', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 368.390, '-14,66300', '-41,49200', 600, 'S', 0.5870, NULL, NULL, '29084', 'S', 'N', 2819, NULL, '2990', '2990', NULL, '1986', 'S', 440, 'MAETINGA', 'N', '291995', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '241', NULL, '03', 'N', NULL, NULL, NULL, 335);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292000', '2914', 'BA', '2908', '2906', '29029', '29', 'MAIQUINIQUE', NULL, '77', '45770000', '7', '3701', '3701', '04201', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 413.863, '-15,62100', '-40,26600', 309, 'S', 0.6230, NULL, NULL, '29083', 'S', 'N', 2825, NULL, '2990', '2990', NULL, '1962', 'S', 441, 'MAIQUINIQUE', 'N', '292000', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '242', NULL, '03', 'N', NULL, NULL, NULL, 176);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292010', '2916', 'BA', '2902', '2903', '29011', '29', 'MAIRI', NULL, '74', '44630000', '6', '3703', '3703', '04202', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 905.851, '-11,71100', '-40,14900', 468, 'S', 0.6050, NULL, NULL, '29022', 'S', 'N', 2826, NULL, '2990', '2990', NULL, '1857', 'S', 442, 'MAIRI', 'N', '292010', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '243', NULL, '03', 'N', NULL, NULL, NULL, 177);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292020', '2930', 'BA', '2908', '2906', '29026', '29', 'MALHADA', NULL, '77', '46440000', '5', '3705', '3705', '04203', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 2138.093, '-14,33600', '-43,77400', 433, 'S', 0.5750, NULL, NULL, '29082', 'S', 'N', 2835, NULL, '2990', '2990', NULL, '1961', 'S', 443, 'MALHADA', 'N', '292020', 'N', 'S', 'S', NULL, 102, 'N', 'N', 'N', '244', NULL, '03', 'N', NULL, NULL, NULL, 7);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292030', '2919', 'BA', '2908', '2906', '29027', '29', 'MALHADA DE PEDRAS', NULL, '77', '46110000', '4', '3707', '3707', '04204', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 479.393, '-14,38800', '-41,87900', 515, 'S', 0.6190, NULL, NULL, '29081', 'S', 'N', 2836, NULL, '2990', '2990', NULL, '1962', 'S', 444, 'MALHADA DE PEDRAS', 'N', '292030', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '245', NULL, '03', 'N', NULL, NULL, NULL, 288);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292040', '2913', 'BA', '2909', '2906', '29028', '29', 'MANOEL VITORINO', NULL, '73', '45240000', '3', '3709', '3709', '04205', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 2400.228, '-14,14500', '-40,24300', 292, 'S', 0.5880, NULL, NULL, '29093', 'S', 'N', 2867, NULL, '2990', '2990', NULL, '1962', 'S', 445, 'MANOEL VITORINO', 'N', '292040', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '246', NULL, '03', 'N', NULL, NULL, NULL, 290);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292045', '2925', 'BA', '2907', '2901', '29002', '29', 'MANSIDAO', NULL, '77', '47160000', '2', '3977', '3977', '04357', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 3142.825, '-10,71600', '-44,03400', 519, 'S', 0.6380, NULL, NULL, '29071', 'S', 'N', 2868, NULL, '2990', '2990', NULL, '1986', 'S', 446, 'MANSIDÃO', 'N', '292045', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '247', NULL, '03', 'N', NULL, NULL, NULL, 287);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292050', '2913', 'BA', '2909', '2906', '29024', '29', 'MARACAS', NULL, '73', '45360000', '2', '3711', '3711', '04206', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 2435.201, '-13,44100', '-40,43100', 964, 'S', 0.6090, NULL, NULL, '29093', 'N', 'N', 2884, NULL, '2990', '2990', NULL, '1855', 'S', 447, 'MARACÁS', 'N', '292050', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '248', NULL, '03', 'N', NULL, NULL, NULL, 290);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292060', '2931', 'BA', '2904', '2905', '29020', '29', 'MARAGOGIPE', NULL, '75', '44420000', '1', '3713', '3713', '04207', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 436.072, '-12,77800', '-38,91900', 39, 'S', 0.6340, NULL, NULL, '29042', 'N', 'N', 2886, NULL, '2990', '2990', NULL, '1725', 'S', 448, 'MARAGOGIPE', 'N', '292060', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '249', NULL, '03', 'N', NULL, NULL, NULL, 344);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292070', '2907', 'BA', '2909', '2907', '29030', '29', 'MARAU', NULL, '73', '45520000', '0', '3715', '3715', '04208', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 774.447, '-14,10300', '-39,01500', 36, 'S', 0.5940, NULL, NULL, '29092', 'S', 'N', 2895, NULL, '2990', '2990', NULL, '1761', 'S', 449, 'MARAÚ', 'N', '292070', 'N', 'S', 'S', NULL, 90, 'S', 'N', 'N', '250', NULL, '03', 'N', NULL, NULL, NULL, 175);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292080', '2918', 'BA', '2901', '2906', '29024', '29', 'MARCIONILIO SOUZA', NULL, '75', '46780000', '9', '3717', '3717', '04209', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1162.138, '-13,00300', '-40,53100', 292, 'S', 0.6000, NULL, NULL, '29012', 'S', 'N', 2904, NULL, '2990', '2990', NULL, '1962', 'S', 450, 'MARCIONÍLIO SOUZA', 'N', '292080', 'N', 'S', 'S', NULL, 31, 'S', 'N', 'N', '251', NULL, '03', 'N', NULL, NULL, NULL, 55);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292090', '2906', 'BA', '2909', '2907', '29031', '29', 'MASCOTE', NULL, '73', '45870000', '8', '3719', '3719', '04210', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 709.253, '-15,56300', '-39,30300', 43, 'S', 0.5960, NULL, NULL, '29091', 'S', 'N', 2951, NULL, '2990', '2990', NULL, '1982', 'S', 451, 'MASCOTE', 'N', '292090', 'N', 'S', 'S', NULL, 90, 'S', 'N', 'N', '252', NULL, '03', 'N', NULL, NULL, NULL, 112);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292100', '2901', 'BA', '2904', '2905', '29019', '29', 'MATA DE SAO JOAO', NULL, '71', '48280000', '5', '3721', '3721', '04211', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 670.380, '-12,53000', '-38,29900', 32, 'S', 0.6710, NULL, NULL, '29041', 'N', 'N', 2957, NULL, '2901', '2990', NULL, '1846', 'S', 452, 'MATA DE SÃO JOÃO', 'N', '292100', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '253', NULL, '01', 'N', NULL, NULL, NULL, 343);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('291980', '2923', 'BA', '2908', '2906', '29022', '29', 'MACAUBAS', NULL, '77', '46500000', '1', '3697', '3697', '04199', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 3039.268, '-13,01900', '-42,69900', 697, 'S', 0.6290, NULL, NULL, '29081', 'N', 'N', 2802, NULL, '2990', '2990', NULL, '1939', 'S', 437, 'MACAÚBAS', 'N', '291980', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '238', NULL, '03', 'N', NULL, NULL, NULL, 288);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292550', '2909', 'BA', '2903', '2907', '29032', '29', 'PRADO', NULL, '73', '45980000', '1', '3811', '3811', '04256', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 1664.536, '-17,34100', '-39,22100', 4, 'S', 0.6650, NULL, NULL, '29032', 'S', 'N', 3946, NULL, '2990', '2990', NULL, '1755', 'S', 512, 'PRADO', 'N', '292550', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '313', NULL, '03', 'N', NULL, NULL, NULL, 398);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292105', '2930', 'BA', '2908', '2906', '29026', '29', 'MATINA', NULL, '77', '46480000', '4', '3295', '3295', '04379', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 773.386, '-13,90900', '-42,84900', 509, 'S', 0.5920, NULL, NULL, '29082', 'S', 'N', 2971, NULL, '2990', '2990', NULL, '1990', 'S', 453, 'MATINA', 'N', '292105', 'N', 'S', 'S', NULL, 102, 'S', 'N', 'N', '254', NULL, '03', 'N', NULL, NULL, NULL, 7);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292110', '2909', 'BA', '2903', '2907', '29032', '29', 'MEDEIROS NETO', NULL, '73', '45960000', '4', '3723', '3723', '04212', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1245.749, '-17,37400', '-40,22100', 185, 'S', 0.6820, NULL, NULL, '29032', 'S', 'N', 3000, NULL, '2990', '2990', NULL, '1958', 'S', 454, 'MEDEIROS NETO', 'N', '292110', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '255', NULL, '03', 'N', NULL, NULL, NULL, 398);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292120', '2916', 'BA', '2902', '2903', '29010', '29', 'MIGUEL CALMON', NULL, '74', '44720000', '3', '3725', '3725', '04213', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1465.438, '-11,42900', '-40,59500', 532, 'S', 0.6190, NULL, NULL, '29022', 'S', 'N', 3018, NULL, '2990', '2990', NULL, '1924', 'S', 455, 'MIGUEL CALMON', 'N', '292120', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '256', NULL, '03', 'N', NULL, NULL, NULL, 177);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292130', '2929', 'BA', '2904', '2906', '29024', '29', 'MILAGRES', NULL, '75', '45315000', '2', '3727', '3727', '04214', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 307.779, '-12,87000', '-39,85900', 419, 'S', 0.6240, NULL, NULL, '29044', 'S', 'N', 3022, NULL, '2990', '2990', NULL, '1961', 'S', 456, 'MILAGRES', 'N', '292130', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '257', NULL, '03', 'N', NULL, NULL, NULL, 106);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292140', '2916', 'BA', '2902', '2903', '29010', '29', 'MIRANGABA', NULL, '74', '44745000', '1', '3729', '3729', '04215', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 1952.295, '-10,95400', '-40,57600', 829, 'S', 0.5890, NULL, NULL, '29022', 'S', 'N', 3052, NULL, '2990', '2990', NULL, '1961', 'S', 457, 'MIRANGABA', 'N', '292140', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '258', NULL, '03', 'N', NULL, NULL, NULL, 177);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292145', '2920', 'BA', '2908', '2906', '29028', '29', 'MIRANTE', NULL, '77', '45255000', '0', '3297', '3297', '04401', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 927.826, '-14,24200', '-40,77300', 420, 'S', 0.5630, NULL, NULL, '29084', 'S', 'N', 3054, NULL, '2990', '2990', NULL, '1990', 'S', 458, 'MIRANTE', 'N', '292145', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '259', NULL, '03', 'N', NULL, NULL, NULL, 335);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292150', '2912', 'BA', '2901', '2904', '29014', '29', 'MONTE SANTO', NULL, '75', '48800000', '0', '3731', '3731', '04216', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 3285.166, '-10,43800', '-39,33300', 489, 'S', 0.5340, NULL, NULL, '29014', 'N', 'N', 3118, NULL, '2990', '2990', NULL, '1837', 'S', 459, 'MONTE SANTO', 'N', '292150', 'N', 'S', 'S', NULL, 43, 'S', 'N', 'N', '260', NULL, '02', 'N', NULL, NULL, NULL, 47);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292160', '2922', 'BA', '2907', '2902', '29006', '29', 'MORPARA', NULL, '77', '47580000', '9', '3733', '3733', '04217', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1731.929, '-11,55900', '-43,28100', 405, 'S', 0.6400, NULL, NULL, '29072', 'S', 'N', 3139, NULL, '2990', '2990', NULL, '1962', 'S', 460, 'MORPARÁ', 'N', '292160', 'N', 'S', 'S', NULL, 102, 'N', 'N', 'N', '261', NULL, '03', 'N', NULL, NULL, NULL, 289);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292170', '2916', 'BA', '2902', '2903', '29010', '29', 'MORRO DO CHAPEU', NULL, '74', '44850000', '8', '3735', '3735', '04218', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 5531.854, '-11,55000', '-41,15600', 1011, 'S', 0.6050, NULL, NULL, '29022', 'N', 'N', 3149, NULL, '2990', '2990', NULL, '1864', 'S', 461, 'MORRO DO CHAPÉU', 'N', '292170', 'N', 'S', 'S', NULL, 31, 'N', 'N', 'N', '262', NULL, '03', 'N', NULL, NULL, NULL, 177);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292180', '2924', 'BA', '2908', '2906', '29026', '29', 'MORTUGABA', NULL, '77', '46290000', '7', '3737', '3737', '04219', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 670.608, '-15,02300', '-42,36800', 384, 'S', 0.6540, NULL, NULL, '29082', 'S', 'N', 3156, NULL, '2990', '2990', NULL, '1961', 'S', 462, 'MORTUGABA', 'N', '292180', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '263', NULL, '03', 'N', NULL, NULL, NULL, 7);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292190', '2927', 'BA', '2901', '2906', '29023', '29', 'MUCUGE', NULL, '75', '46750000', '6', '3739', '3739', '04220', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 2482.204, '-13,00500', '-41,37100', 983, 'S', 0.6210, NULL, NULL, '29013', 'S', 'N', 3166, NULL, '2990', '2990', NULL, '1847', 'S', 463, 'MUCUGÊ', 'N', '292190', 'N', 'S', 'S', NULL, 31, 'N', 'N', 'N', '264', NULL, '03', 'N', NULL, NULL, NULL, 4);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292200', '2909', 'BA', '2903', '2907', '29032', '29', 'MUCURI', NULL, '73', '45930000', '3', '3741', '3741', '04221', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1774.763, '-18,08600', '-39,55100', 7, 'S', 0.6900, NULL, NULL, '29032', 'N', 'N', 3168, NULL, '2990', '2990', NULL, '1769', 'S', 464, 'MUCURI', 'N', '292200', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '265', NULL, '03', 'N', NULL, NULL, NULL, 398);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292205', '2921', 'BA', '2902', '2903', '29009', '29', 'MULUNGU DO MORRO', NULL, '74', '44885000', '2', '3299', '3299', '04402', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 517.598, '-11,96600', '-41,63900', 850, 'S', 0.5780, NULL, NULL, '29021', 'S', 'N', 3174, NULL, '2990', '2990', NULL, '1990', 'S', 465, 'MULUNGU DO MORRO', 'N', '292205', 'N', 'S', 'S', NULL, 50, 'N', 'N', 'N', '266', NULL, '03', 'N', NULL, NULL, NULL, 401);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292210', '2917', 'BA', '2901', '2903', '29011', '29', 'MUNDO NOVO', NULL, '74', '44800000', '2', '3743', '3743', '04222', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 1496.144, '-11,85900', '-40,47200', 604, 'S', 0.6420, NULL, NULL, '29011', 'S', 'N', 3177, NULL, '2990', '2990', NULL, '1890', 'S', 466, 'MUNDO NOVO', 'N', '292210', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '267', NULL, '03', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292220', '2904', 'BA', '2904', '2905', '29020', '29', 'MUNIZ FERREIRA', NULL, '75', '44575000', '1', '3745', '3745', '04223', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 113.706, '-13,00300', '-39,11000', 86, 'S', 0.6530, NULL, NULL, '29044', 'S', 'N', 3180, NULL, '2990', '2990', NULL, '1962', 'S', 467, 'MUNIZ FERREIRA', 'N', '292220', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '268', NULL, '03', 'N', NULL, NULL, NULL, 106);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292225', '2922', 'BA', '2907', '2902', '29006', '29', 'MUQUEM DE SAO FRANCISCO', NULL, '77', '47115000', '0', '3005', '3005', '04403', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 3833.915, '-12,06500', '-43,54900', 560, 'S', 0.6030, NULL, NULL, '29072', 'S', 'N', 3182, NULL, '2990', '2990', NULL, '1990', 'S', 468, 'MUQUÉM DE SÃO FRANCISCO', 'N', '292225', 'N', 'S', 'S', NULL, 102, 'S', 'N', 'N', '269', NULL, '03', 'N', NULL, NULL, NULL, 289);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292230', '2931', 'BA', '2904', '2905', '29020', '29', 'MURITIBA', NULL, '75', '44340000', '0', '3747', '3747', '04224', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 110.562, '-12,62600', '-38,99000', 213, 'S', 0.6760, NULL, NULL, '29042', 'N', 'N', 3189, NULL, '2990', '2990', NULL, '1919', 'S', 469, 'MURITIBA', 'N', '292230', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '270', NULL, '03', 'N', NULL, NULL, NULL, 344);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292240', '2929', 'BA', '2904', '2906', '29024', '29', 'MUTUIPE', NULL, '75', '45480000', '9', '3749', '3749', '04225', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 273.320, '-13,22900', '-39,50500', 271, 'S', 0.6570, NULL, NULL, '29044', 'S', 'N', 3191, NULL, '2990', '2990', NULL, '1926', 'S', 470, 'MUTUÍPE', 'N', '292240', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '271', NULL, '03', 'N', NULL, NULL, NULL, 106);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292250', '2904', 'BA', '2904', '2905', '29020', '29', 'NAZARE', NULL, '75', '44400000', '8', '3751', '3751', '04226', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 256.352, '-13,03500', '-39,01400', 39, 'S', 0.6760, NULL, NULL, '29044', 'S', 'N', 3210, NULL, '2990', '2990', NULL, '1831', 'S', 471, 'NAZARÉ', 'N', '292250', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '272', NULL, '03', 'N', NULL, NULL, NULL, 106);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292260', '2905', 'BA', '2909', '2907', '29030', '29', 'NILO PECANHA', NULL, '73', '45440000', '7', '3753', '3753', '04227', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 385.381, '-13,59900', '-39,10700', 20, 'S', 0.5920, NULL, NULL, '29094', 'S', 'N', 3225, NULL, '2990', '2990', NULL, '1873', 'S', 472, 'NILO PEÇANHA', 'N', '292260', 'N', 'S', 'S', NULL, 21, 'S', 'N', 'N', '273', NULL, '03', 'N', NULL, NULL, NULL, 283);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292265', '2912', 'BA', '2901', '2904', '29014', '29', 'NORDESTINA', NULL, '75', '48870000', '6', '3979', '3979', '04358', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 470.916, '-10,82300', '-39,42800', 370, 'S', 0.5500, NULL, NULL, '29014', 'S', 'N', 3236, NULL, '2990', '2990', NULL, '1986', 'S', 473, 'NORDESTINA', 'N', '292265', 'N', 'S', 'S', NULL, 43, 'S', 'N', 'N', '274', NULL, '03', 'N', NULL, NULL, NULL, 47);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292270', '2914', 'BA', '2908', '2906', '29028', '29', 'NOVA CANAA', NULL, '73', '45270000', '6', '3755', '3755', '04228', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 757.461, '-14,79400', '-40,14200', 422, 'S', 0.5960, NULL, NULL, '29083', 'S', 'N', 3266, NULL, '2990', '2990', NULL, '1961', 'S', 474, 'NOVA CANAÃ', 'N', '292270', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '275', NULL, '03', 'N', NULL, NULL, NULL, 176);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292273', '2917', 'BA', '2901', '2904', '29016', '29', 'NOVA FATIMA', NULL, '75', '44642000', '0', '3007', '3007', '04404', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 371.480, '-11,60600', '-39,63100', 298, 'S', 0.6350, NULL, NULL, '29011', 'S', 'N', 3283, NULL, '2990', '2990', NULL, '1990', 'S', 475, 'NOVA FÁTIMA', 'N', '292273', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '276', NULL, '03', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292275', '2905', 'BA', '2909', '2907', '29031', '29', 'NOVA IBIA', NULL, '73', '45452000', '5', '3009', '3009', '04405', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 180.701, '-13,81000', '-39,62600', 292, 'S', 0.6160, NULL, NULL, '29094', 'S', 'N', 3291, NULL, '2990', '2990', NULL, '1990', 'S', 476, 'NOVA IBIÁ', 'N', '292275', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '277', NULL, '03', 'N', NULL, NULL, NULL, 283);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292280', '2929', 'BA', '2904', '2906', '29024', '29', 'NOVA ITARANA', NULL, '73', '45390000', '5', '3757', '3757', '04229', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 456.256, '-13,02700', '-40,06900', 560, 'S', 0.5680, NULL, NULL, '29044', 'S', 'N', 3298, NULL, '2990', '2990', NULL, '1962', 'S', 477, 'NOVA ITARANA', 'N', '292280', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '278', NULL, '03', 'N', NULL, NULL, NULL, 106);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292285', '2918', 'BA', '2901', '2906', '29023', '29', 'NOVA REDENCAO', NULL, '75', '46835000', '4', '3011', '3011', '04380', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 510.918, '-12,81900', '-41,07100', 415, 'S', 0.5870, NULL, NULL, '29012', 'S', 'N', 3326, NULL, '2990', '2990', NULL, '1990', 'S', 478, 'NOVA REDENÇÃO', 'N', '292285', 'N', 'S', 'S', NULL, 31, 'N', 'N', 'N', '279', NULL, '03', 'N', NULL, NULL, NULL, 55);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292290', '2911', 'BA', '2905', '2904', '29015', '29', 'NOVA SOURE', NULL, '75', '48460000', '4', '3759', '3759', '04230', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 1021.277, '-11,23300', '-38,48300', 169, 'S', 0.5960, NULL, NULL, '29052', 'S', 'N', 3336, NULL, '2990', '2990', NULL, '1754', 'S', 479, 'NOVA SOURE', 'N', '292290', 'N', 'S', 'S', NULL, 162, 'N', 'N', 'N', '280', NULL, '03', 'N', NULL, NULL, NULL, 56);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292300', '2909', 'BA', '2903', '2907', '29032', '29', 'NOVA VICOSA', NULL, '73', '45920000', '1', '3761', '3761', '04231', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1326.122, '-17,89200', '-39,37200', 11, 'S', 0.6580, NULL, NULL, '29032', 'N', 'N', 3346, NULL, '2990', '2990', NULL, '1962', 'S', 480, 'NOVA VIÇOSA', 'N', '292300', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '281', NULL, '03', 'N', NULL, NULL, NULL, 398);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292303', '2927', 'BA', '2901', '2906', '29022', '29', 'NOVO HORIZONTE', NULL, '77', '46730000', '5', '3013', '3013', '04406', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 612.451, '-12,80800', '-42,16800', 835, 'S', 0.6580, NULL, NULL, '29013', 'S', 'N', 3360, NULL, '2990', '2990', NULL, '1990', 'S', 481, 'NOVO HORIZONTE', 'N', '292303', 'N', 'S', 'S', NULL, 31, 'N', 'N', 'N', '282', NULL, '03', 'N', NULL, NULL, NULL, 4);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293260', '2930', 'BA', '2908', '2906', '29026', '29', 'URANDI', NULL, '77', '46350000', '6', '3951', '3951', '04326', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 895.926, '-14,77100', '-42,65500', 637, 'S', 0.6700, NULL, NULL, '29082', 'S', 'N', 5328, NULL, '2990', '2990', NULL, '1889', 'S', 601, 'URANDI', 'N', '293260', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '402', NULL, '03', 'N', NULL, NULL, NULL, 7);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292305', '2911', 'BA', '2905', '2904', '29015', '29', 'NOVO TRIUNFO', NULL, '75', '48455000', '0', '3015', '3015', '04381', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 217.894, '-10,31700', '-38,40600', 460, 'S', 0.5810, NULL, NULL, '29052', 'S', 'N', 3379, NULL, '2990', '2990', NULL, '1990', 'S', 482, 'NOVO TRIUNFO', 'N', '292305', 'N', 'S', 'S', NULL, 162, 'S', 'N', 'N', '283', NULL, '03', 'N', NULL, NULL, NULL, 56);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292310', '2911', 'BA', '2905', '2904', '29015', '29', 'OLINDINA', NULL, '75', '48470000', '0', '3763', '3763', '04232', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 575.412, '-11,36700', '-38,33300', 139, 'S', 0.5930, NULL, NULL, '29052', 'S', 'N', 3402, NULL, '2990', '2990', NULL, '1958', 'S', 483, 'OLINDINA', 'N', '292310', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '284', NULL, '03', 'N', NULL, NULL, NULL, 56);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292320', '2922', 'BA', '2907', '2906', '29022', '29', 'OLIVEIRA DOS BREJINHOS', NULL, '77', '47530000', '9', '3765', '3765', '04233', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 3563.908, '-12,31700', '-42,89600', 550, 'S', 0.6470, NULL, NULL, '29072', 'S', 'N', 3406, NULL, '2990', '2990', NULL, '1891', 'S', 484, 'OLIVEIRA DOS BREJINHOS', 'N', '292320', 'N', 'S', 'S', NULL, 102, 'S', 'N', 'N', '285', NULL, '03', 'N', NULL, NULL, NULL, 289);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292330', '2903', 'BA', '2905', '2903', '29012', '29', 'OURICANGAS', NULL, '75', '48150000', '8', '3767', '3767', '04234', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 148.166, '-12,01700', '-38,61700', 327, 'S', 0.6180, NULL, NULL, '29051', 'S', 'N', 3429, NULL, '2990', '2990', NULL, '1962', 'S', 485, 'OURIÇANGAS', 'N', '292330', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '286', NULL, '03', 'N', NULL, NULL, NULL, 400);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292335', '2916', 'BA', '2902', '2903', '29010', '29', 'OUROLANDIA', NULL, '74', '44718000', '7', '3017', '3017', '04407', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1276.011, '-10,97000', '-41,08300', 560, 'S', 0.5420, NULL, NULL, '29022', 'S', 'N', 3448, NULL, '2990', '2990', NULL, '1990', 'S', 486, 'OUROLÂNDIA', 'N', '292335', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '287', NULL, '03', 'N', NULL, NULL, NULL, 177);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292340', '2930', 'BA', '2908', '2906', '29026', '29', 'PALMAS DE MONTE ALTO', NULL, '77', '46460000', '7', '3769', '3769', '04235', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 2789.417, '-14,26700', '-43,16200', 802, 'S', 0.6410, NULL, NULL, '29082', 'S', 'N', 3487, NULL, '2990', '2990', NULL, '1840', 'S', 487, 'PALMAS DE MONTE ALTO', 'N', '292340', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '288', NULL, '03', 'N', NULL, NULL, NULL, 7);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292350', '2927', 'BA', '2901', '2906', '29023', '29', 'PALMEIRAS', NULL, '75', '46930000', '6', '3771', '3771', '04236', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 695.719, '-12,52900', '-41,55900', 697, 'S', 0.6790, NULL, NULL, '29013', 'S', 'N', 3497, NULL, '2990', '2990', NULL, '1890', 'S', 488, 'PALMEIRAS', 'N', '292350', 'N', 'S', 'S', NULL, 31, 'N', 'N', 'N', '289', NULL, '03', 'N', NULL, NULL, NULL, 4);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292360', '2923', 'BA', '2908', '2906', '29025', '29', 'PARAMIRIM', NULL, '77', '46190000', '5', '3773', '3773', '04237', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 1115.641, '-13,44300', '-42,23900', 654, 'S', 0.6430, NULL, NULL, '29081', 'S', 'N', 3539, NULL, '2990', '2990', NULL, '1890', 'S', 489, 'PARAMIRIM', 'N', '292360', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '290', NULL, '03', 'N', NULL, NULL, NULL, 288);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292370', '2922', 'BA', '2907', '2902', '29007', '29', 'PARATINGA', NULL, '77', '47500000', '4', '3775', '3775', '04238', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 2956.387, '-12,69100', '-43,18400', 425, 'S', 0.6170, NULL, NULL, '29072', 'S', 'N', 3559, NULL, '2990', '2990', NULL, '1745', 'S', 490, 'PARATINGA', 'N', '292370', 'N', 'S', 'S', NULL, 102, 'N', 'N', 'N', '291', NULL, '03', 'N', NULL, NULL, NULL, 289);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292380', '2911', 'BA', '2905', '2904', '29015', '29', 'PARIPIRANGA', NULL, '75', '48430000', '3', '3777', '3777', '04239', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 388.784, '-10,68800', '-37,86200', 434, 'S', 0.5960, NULL, NULL, '29052', 'S', 'N', 3570, NULL, '2990', '2990', NULL, '1886', 'S', 491, 'PARIPIRANGA', 'N', '292380', 'N', 'S', 'S', NULL, 162, 'N', 'N', 'N', '292', NULL, '03', 'N', NULL, NULL, NULL, 56);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292390', '2907', 'BA', '2909', '2907', '29031', '29', 'PAU BRASIL', NULL, '73', '45890000', '2', '3779', '3779', '04240', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 609.505, '-15,46400', '-39,65100', 169, 'S', 0.6000, NULL, NULL, '29092', 'S', 'N', 3609, NULL, '2990', '2990', NULL, '1962', 'S', 492, 'PAU BRASIL', 'N', '292390', 'N', 'S', 'S', NULL, 90, 'S', 'N', 'N', '293', NULL, '03', 'N', NULL, NULL, NULL, 175);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292400', '2910', 'BA', '2906', '2902', '29005', '29', 'PAULO AFONSO', NULL, '75', '48600000', '9', '3781', '3781', '04241', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 1573.627, '-9,40800', '-38,22200', 243, 'S', 0.7190, NULL, NULL, '29062', 'N', 'N', 3625, NULL, '2990', '2990', NULL, '1958', 'S', 493, 'PAULO AFONSO', 'N', '292400', 'N', 'S', 'S', NULL, 118, 'N', 'N', 'S', '294', NULL, '01', 'N', NULL, NULL, NULL, 345);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292405', '2917', 'BA', '2901', '2904', '29016', '29', 'PE DE SERRA', NULL, '75', '44655000', '8', '3981', '3981', '04359', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 558.438, '-11,83400', '-39,61300', 286, 'S', 0.6300, NULL, NULL, '29011', 'S', 'N', 3634, NULL, '2990', '2990', NULL, '1986', 'S', 494, 'PÉ DE SERRA', 'N', '292405', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '295', NULL, '03', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292410', '2903', 'BA', '2905', '2903', '29012', '29', 'PEDRAO', NULL, '75', '48140000', '8', '3783', '3783', '04242', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 172.458, '-12,15000', '-38,65000', 230, 'S', 0.6270, NULL, NULL, '29051', 'S', 'N', 3655, NULL, '2990', '2990', NULL, '1962', 'S', 495, 'PEDRÃO', 'N', '292410', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '296', NULL, '03', 'N', NULL, NULL, NULL, 400);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292420', '2910', 'BA', '2906', '2904', '29013', '29', 'PEDRO ALEXANDRE', NULL, '75', '48580000', '7', '3785', '3785', '04243', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1110.078, '-10,01400', '-37,89400', 356, 'S', 0.5350, NULL, NULL, '29062', 'S', 'N', 3666, NULL, '2990', '2990', NULL, '1962', 'S', 496, 'PEDRO ALEXANDRE', 'N', '292420', 'N', 'S', 'S', NULL, 162, 'N', 'N', 'N', '297', NULL, '03', 'N', NULL, NULL, NULL, 345);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292430', '2927', 'BA', '2901', '2906', '29023', '29', 'PIATA', NULL, '77', '46765000', '6', '3787', '3787', '04244', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1508.036, '-13,15200', '-41,77300', 1268, 'S', 0.6360, NULL, NULL, '29013', 'S', 'N', 3720, NULL, '2990', '2990', NULL, '1878', 'S', 497, 'PIATÃ', 'N', '292430', 'N', 'S', 'S', NULL, 31, 'N', 'N', 'N', '298', NULL, '03', 'N', NULL, NULL, NULL, 4);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292440', '2915', 'BA', '2906', '2902', '29004', '29', 'PILAO ARCADO', NULL, '74', '47240000', '5', '3789', '3789', '04245', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 11700.012, '-10,00300', '-42,50400', 394, 'S', 0.5460, NULL, NULL, '29061', 'S', 'N', 3733, NULL, '2990', '2990', NULL, '1890', 'S', 498, 'PILÃO ARCADO', 'N', '292440', 'N', 'S', 'S', NULL, 143, 'N', 'N', 'N', '299', NULL, '03', 'N', NULL, NULL, NULL, 113);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292450', '2930', 'BA', '2908', '2906', '29026', '29', 'PINDAI', NULL, '77', '46360000', '4', '3791', '3791', '04246', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 715.482, '-14,49300', '-42,68700', 610, 'S', 0.6410, NULL, NULL, '29082', 'S', 'N', 3745, NULL, '2990', '2990', NULL, '1962', 'S', 499, 'PINDAÍ', 'N', '292450', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '300', NULL, '03', 'N', NULL, NULL, NULL, 7);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292460', '2928', 'BA', '2906', '2903', '29008', '29', 'PINDOBACU', NULL, '74', '44770000', '3', '3793', '3793', '04247', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 527.742, '-10,74300', '-40,36300', 448, 'S', 0.5960, NULL, NULL, '29063', 'S', 'N', 3749, NULL, '2990', '2990', NULL, '1953', 'S', 500, 'PINDOBAÇU', 'N', '292460', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '301', NULL, '03', 'N', NULL, NULL, NULL, 107);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292465', '2902', 'BA', '2901', '2903', '29012', '29', 'PINTADAS', NULL, '75', '44610000', '2', '3983', '3983', '04360', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 529.211, '-11,81300', '-39,90900', 300, 'S', 0.6250, NULL, NULL, '29011', 'S', 'N', 3769, NULL, '2990', '2990', NULL, '1986', 'S', 501, 'PINTADAS', 'N', '292465', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '302', NULL, '03', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292467', '2905', 'BA', '2909', '2907', '29030', '29', 'PIRAI DO NORTE', NULL, '73', '45436000', '8', '3019', '3019', '04382', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 227.638, '-13,76200', '-39,37900', 148, 'S', 0.6050, NULL, NULL, '29094', 'S', 'N', 3782, NULL, '2990', '2990', NULL, '1990', 'S', 502, 'PIRAÍ DO NORTE', 'N', '292467', 'N', 'S', 'S', NULL, 21, 'S', 'N', 'N', '303', NULL, '03', 'N', NULL, NULL, NULL, 283);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292470', '2920', 'BA', '2908', '2906', '29027', '29', 'PIRIPA', NULL, '77', '46270000', '2', '3795', '3795', '04248', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 651.302, '-14,94000', '-41,72000', 618, 'S', 0.6350, NULL, NULL, '29084', 'S', 'N', 3810, NULL, '2990', '2990', NULL, '1962', 'S', 503, 'PIRIPÁ', 'N', '292470', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '304', NULL, '03', 'N', NULL, NULL, NULL, 335);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292480', '2916', 'BA', '2902', '2903', '29010', '29', 'PIRITIBA', NULL, '74', '44830000', '1', '3797', '3797', '04249', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 990.598, '-11,73000', '-40,55500', 554, 'S', 0.6390, NULL, NULL, '29022', 'S', 'N', 3812, NULL, '2990', '2990', NULL, '1952', 'S', 504, 'PIRITIBA', 'N', '292480', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '305', NULL, '03', 'N', NULL, NULL, NULL, 177);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292490', '2913', 'BA', '2909', '2906', '29024', '29', 'PLANALTINO', NULL, '73', '45375000', '0', '3799', '3799', '04250', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 938.104, '-13,25900', '-40,36900', 691, 'S', 0.5770, NULL, NULL, '29093', 'S', 'N', 3826, NULL, '2990', '2990', NULL, '1962', 'S', 505, 'PLANALTINO', 'N', '292490', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '306', NULL, '03', 'N', NULL, NULL, NULL, 290);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292500', '2920', 'BA', '2908', '2906', '29028', '29', 'PLANALTO', NULL, '77', '45190000', '6', '3801', '3801', '04251', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 722.987, '-14,67000', '-40,47100', 943, 'S', 0.5980, NULL, NULL, '29084', 'S', 'N', 3830, NULL, '2990', '2990', NULL, '1962', 'S', 506, 'PLANALTO', 'N', '292500', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '307', NULL, '03', 'N', NULL, NULL, NULL, 335);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292510', '2920', 'BA', '2908', '2906', '29028', '29', 'POCOES', NULL, '77', '45260000', '5', '3803', '3803', '04252', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 962.857, '-14,53000', '-40,36500', 760, 'S', 0.6160, NULL, NULL, '29084', 'N', 'N', 3847, NULL, '2990', '2990', NULL, '1922', 'S', 507, 'POÇÕES', 'N', '292510', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '308', NULL, '03', 'N', NULL, NULL, NULL, 335);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292520', '2901', 'BA', '2904', '2905', '29019', '29', 'POJUCA', NULL, '71', '48120000', '4', '3805', '3805', '04253', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 318.205, '-12,43100', '-38,32800', 60, 'S', 0.7080, NULL, NULL, '29041', 'N', 'N', 3851, NULL, '2901', '2990', NULL, '1913', 'S', 508, 'POJUCA', 'N', '292520', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '309', NULL, '01', 'N', NULL, NULL, NULL, 343);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292525', '2928', 'BA', '2906', '2903', '29010', '29', 'PONTO NOVO', NULL, '74', '44755000', '3', '3021', '3021', '04383', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 465.311, '-10,86200', '-40,13400', 362, 'S', 0.6000, NULL, NULL, '29063', 'S', 'N', 3881, NULL, '2990', '2990', NULL, '1990', 'S', 509, 'PONTO NOVO', 'N', '292525', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '310', NULL, '03', 'N', NULL, NULL, NULL, 107);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292530', '2908', 'BA', '2903', '2907', '29032', '29', 'PORTO SEGURO', NULL, '73', '45810000', '3', '3807', '3807', '04254', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 2408.594, '-16,45000', '-39,06500', 49, 'S', 0.6990, NULL, NULL, '29031', 'N', 'N', 3925, NULL, '2990', '2990', NULL, '1534', 'S', 510, 'PORTO SEGURO', 'N', '292530', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '311', NULL, '01', 'N', NULL, NULL, NULL, 346);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292540', '2914', 'BA', '2908', '2906', '29029', '29', 'POTIRAGUA', NULL, '73', '45790000', '2', '3809', '3809', '04255', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 989.471, '-15,59500', '-39,87700', 181, 'S', 0.6050, NULL, NULL, '29083', 'S', 'N', 3936, NULL, '2990', '2990', NULL, '1958', 'S', 511, 'POTIRAGUÁ', 'N', '292540', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '312', NULL, '03', 'N', NULL, NULL, NULL, 176);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292560', '2921', 'BA', '2902', '2903', '29009', '29', 'PRESIDENTE DUTRA', NULL, '74', '44930000', '0', '3813', '3813', '04257', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 243.922, '-11,29600', '-41,98700', 672, 'S', 0.6140, NULL, NULL, '29021', 'S', 'N', 3966, NULL, '2990', '2990', NULL, '1962', 'S', 513, 'PRESIDENTE DUTRA', 'N', '292560', 'N', 'S', 'S', NULL, 50, 'N', 'N', 'N', '314', NULL, '03', 'N', NULL, NULL, NULL, 401);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292570', '2920', 'BA', '2908', '2906', '29027', '29', 'PRESIDENTE JANIO QUADROS', NULL, '77', '46250000', '9', '3815', '3815', '04258', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1327.379, '-14,68900', '-41,67800', 682, 'S', 0.5870, NULL, NULL, '29084', 'S', 'N', 3971, NULL, '2990', '2990', NULL, '1961', 'S', 514, 'PRESIDENTE JÂNIO QUADROS', 'N', '292570', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '315', NULL, '03', 'N', NULL, NULL, NULL, 335);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292575', '2904', 'BA', '2904', '2907', '29030', '29', 'PRESIDENTE TANCREDO NEVES', NULL, '73', '45416000', '8', '3023', '3023', '04384', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 414.912, '-13,44900', '-39,42000', 150, 'S', 0.6050, NULL, NULL, '29044', 'S', 'N', 3984, NULL, '2990', '2990', NULL, '1990', 'S', 515, 'PRESIDENTE TANCREDO NEVES', 'N', '292575', 'N', 'S', 'S', NULL, 21, 'N', 'N', 'N', '316', NULL, '03', 'N', NULL, NULL, NULL, 106);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292580', '2912', 'BA', '2901', '2904', '29014', '29', 'QUEIMADAS', NULL, '75', '48860000', '8', '3817', '3817', '04259', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 2097.668, '-10,97800', '-39,62400', 295, 'S', 0.6130, NULL, NULL, '29014', 'S', 'N', 4019, NULL, '2990', '2990', NULL, '1884', 'S', 516, 'QUEIMADAS', 'N', '292580', 'N', 'S', 'S', NULL, 43, 'N', 'N', 'N', '317', NULL, '03', 'N', NULL, NULL, NULL, 47);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292590', '2912', 'BA', '2901', '2904', '29014', '29', 'QUIJINGUE', NULL, '75', '48830000', '7', '3819', '3819', '04260', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 1271.069, '-10,75300', '-39,21000', 352, 'S', 0.5260, NULL, NULL, '29014', 'S', 'N', 4028, NULL, '2990', '2990', NULL, '1962', 'S', 517, 'QUIJINGUE', 'N', '292590', 'N', 'S', 'S', NULL, 43, 'N', 'N', 'N', '318', NULL, '03', 'N', NULL, NULL, NULL, 47);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292593', '2916', 'BA', '2902', '2903', '29010', '29', 'QUIXABEIRA', NULL, '74', '44713000', '1', '3025', '3025', '04408', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 368.017, '-11,41200', '-40,12800', 420, 'S', 0.6060, NULL, NULL, '29022', 'S', 'N', 4040, NULL, '2990', '2990', NULL, '1990', 'S', 518, 'QUIXABEIRA', 'N', '292593', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '319', NULL, '03', 'N', NULL, NULL, NULL, 177);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292595', '2902', 'BA', '2901', '2903', '29012', '29', 'RAFAEL JAMBEIRO', NULL, '75', '44520000', '6', '3985', '3985', '04361', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 1234.248, '-12,40800', '-39,50100', 238, 'S', 0.5690, NULL, NULL, '29011', 'S', 'N', 4047, NULL, '2990', '2990', NULL, '1986', 'S', 519, 'RAFAEL JAMBEIRO', 'N', '292595', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '320', NULL, '03', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292600', '2915', 'BA', '2906', '2902', '29004', '29', 'REMANSO', NULL, '74', '47200000', '4', '3821', '3821', '04261', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 4693.505, '-9,62200', '-42,08100', 388, 'S', 0.6150, NULL, NULL, '29061', 'N', 'N', 4073, NULL, '2990', '2990', NULL, '1857', 'S', 520, 'REMANSO', 'N', '292600', 'N', 'S', 'S', NULL, 143, 'S', 'N', 'N', '321', NULL, '03', 'N', NULL, NULL, NULL, 113);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292610', '2912', 'BA', '2901', '2904', '29016', '29', 'RETIROLANDIA', NULL, '75', '48750000', '3', '3823', '3823', '04262', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 203.786, '-11,49500', '-39,42600', 325, 'S', 0.6250, NULL, NULL, '29014', 'S', 'N', 4086, NULL, '2990', '2990', NULL, '1962', 'S', 521, 'RETIROLÂNDIA', 'N', '292610', 'N', 'S', 'S', NULL, 43, 'S', 'N', 'N', '322', NULL, '03', 'N', NULL, NULL, NULL, 47);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292620', '2925', 'BA', '2907', '2901', '29001', '29', 'RIACHAO DAS NEVES', NULL, '77', '47970000', '2', '3825', '3825', '04263', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 5840.191, '-11,74600', '-44,91000', 495, 'S', 0.5690, NULL, NULL, '29071', 'S', 'N', 4089, NULL, '2990', '2990', NULL, '1962', 'S', 522, 'RIACHÃO DAS NEVES', 'N', '292620', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '323', NULL, '03', 'N', NULL, NULL, NULL, 287);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292630', '2902', 'BA', '2901', '2904', '29016', '29', 'RIACHAO DO JACUIPE', NULL, '75', '44640000', '1', '3827', '3827', '04264', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 1199.201, '-11,81000', '-39,38200', 219, 'S', 0.6460, NULL, NULL, '29011', 'S', 'N', 4091, NULL, '2903', '2990', NULL, '1878', 'S', 523, 'RIACHÃO DO JACUÍPE', 'N', '292630', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '324', NULL, '03', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292640', '2924', 'BA', '2908', '2906', '29026', '29', 'RIACHO DE SANTANA', NULL, '77', '46470000', '0', '3829', '3829', '04265', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 2698.465, '-13,60900', '-42,93900', 627, 'S', 0.6320, NULL, NULL, '29082', 'S', 'N', 4097, NULL, '2990', '2990', NULL, '1878', 'S', 524, 'RIACHO DE SANTANA', 'N', '292640', 'N', 'S', 'S', NULL, 102, 'N', 'N', 'N', '325', NULL, '03', 'N', NULL, NULL, NULL, 7);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292670', '2919', 'BA', '2908', '2906', '29023', '29', 'RIO DE CONTAS', NULL, '77', '46170000', '7', '3835', '3835', '04268', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 1052.302, '-13,57900', '-41,81100', 999, 'S', 0.6530, NULL, NULL, '29081', 'S', 'N', 4154, NULL, '2990', '2990', NULL, '1723', 'S', 528, 'RIO DE CONTAS', 'N', '292670', 'N', 'S', 'S', NULL, 31, 'N', 'N', 'N', '329', NULL, '03', 'N', NULL, NULL, NULL, 288);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292680', '2924', 'BA', '2908', '2906', '29027', '29', 'RIO DO ANTONIO', NULL, '77', '46220000', '6', '3837', '3837', '04269', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 986.990, '-14,41100', '-42,07600', 598, 'S', 0.5900, NULL, NULL, '29082', 'S', 'N', 4156, NULL, '2990', '2990', NULL, '1962', 'S', 529, 'RIO DO ANTÔNIO', 'N', '292680', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '330', NULL, '03', 'N', NULL, NULL, NULL, 7);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292700', '2903', 'BA', '2905', '2904', '29017', '29', 'RIO REAL', NULL, '75', '48330000', '2', '3841', '3841', '04271', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 675.911, '-11,48500', '-37,93300', 169, 'S', 0.6000, NULL, NULL, '29051', 'N', 'N', 4189, NULL, '2990', '2990', NULL, '1880', 'S', 531, 'RIO REAL', 'N', '292700', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '332', NULL, '03', 'N', NULL, NULL, NULL, 400);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292710', '2910', 'BA', '2906', '2902', '29005', '29', 'RODELAS', NULL, '75', '48630000', '1', '3843', '3843', '04272', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 2575.088, '-8,85100', '-38,75600', 295, 'S', 0.6550, NULL, NULL, '29062', 'S', 'N', 4207, NULL, '2990', '2990', NULL, '1962', 'S', 532, 'RODELAS', 'N', '292710', 'N', 'S', 'S', NULL, 118, 'N', 'N', 'N', '333', NULL, '03', 'N', NULL, NULL, NULL, 345);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292720', '2918', 'BA', '2901', '2903', '29011', '29', 'RUY BARBOSA', NULL, '75', '46800000', '0', '3845', '3845', '04273', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 2128.936, '-12,28400', '-40,49400', 368, 'S', 0.6440, NULL, NULL, '29012', 'S', 'N', 4240, NULL, '2990', '2990', NULL, '1914', 'S', 533, 'RUY BARBOSA', 'N', '292720', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '334', NULL, '03', 'N', NULL, NULL, NULL, 55);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292730', '2904', 'BA', '2904', '2905', '29020', '29', 'SALINAS DA MARGARIDA', NULL, '75', '44450000', '9', '3847', '3847', '04274', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 148.327, '-12,87100', '-38,76400', 6, 'S', 0.6590, NULL, NULL, '29044', 'S', 'N', 4262, NULL, '2990', '2990', NULL, '1962', 'S', 534, 'SALINAS DA MARGARIDA', 'N', '292730', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '335', NULL, '03', 'N', NULL, NULL, NULL, 106);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292740', '2901', 'BA', '2904', '2905', '29021', '29', 'SALVADOR', NULL, '71', '40011970', '8', '3849', '3849', '04275', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'S', 706.799, '-12,97100', '-38,51100', 8, 'S', 0.8050, NULL, NULL, '29043', 'N', 'N', 4278, NULL, '2901', '2901', NULL, '1549', 'S', 535, 'SALVADOR', 'N', '292740', 'N', 'S', 'S', NULL, NULL, 'S', 'S', 'S', '336', NULL, '01', 'N', NULL, NULL, NULL, 178);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292650', '2911', 'BA', '2905', '2904', '29015', '29', 'RIBEIRA DO AMPARO', NULL, '75', '48440000', '9', '3831', '3831', '04266', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 699.342, '-11,04700', '-38,43300', 180, 'S', 0.5490, NULL, NULL, '29052', 'S', 'N', 4110, NULL, '2990', '2990', NULL, '1958', 'S', 525, 'RIBEIRA DO AMPARO', 'N', '292650', 'N', 'S', 'S', NULL, 162, 'S', 'N', 'N', '326', NULL, '03', 'N', NULL, NULL, NULL, 56);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292660', '2911', 'BA', '2905', '2904', '29015', '29', 'RIBEIRA DO POMBAL', NULL, '75', '48400000', '8', '3833', '3833', '04267', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 807.137, '-10,83400', '-38,53600', 228, 'S', 0.6030, NULL, NULL, '29052', 'N', 'N', 4112, NULL, '2990', '2990', NULL, '1758', 'S', 526, 'RIBEIRA DO POMBAL', 'N', '292660', 'N', 'S', 'S', NULL, 162, 'S', 'N', 'S', '327', NULL, '03', 'N', NULL, NULL, NULL, 56);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292665', '2920', 'BA', '2908', '2906', '29029', '29', 'RIBEIRAO DO LARGO', NULL, '77', '45155000', '7', '3027', '3027', '04385', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 1222.153, '-15,45900', '-40,73900', 0, 'S', 0.5680, NULL, NULL, '29084', 'S', 'N', 4120, NULL, '2990', '2990', NULL, '1990', 'S', 527, 'RIBEIRÃO DO LARGO', 'N', '292665', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '328', NULL, '03', 'N', NULL, NULL, NULL, 335);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292690', '2923', 'BA', '2908', '2906', '29025', '29', 'RIO DO PIRES', NULL, '77', '46550000', '5', '3839', '3839', '04270', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 889.359, '-13,12800', '-42,29200', 551, 'S', 0.6350, NULL, NULL, '29081', 'S', 'N', 4160, NULL, '2990', '2990', NULL, '1961', 'S', 530, 'RIO DO PIRES', 'N', '292690', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '331', NULL, '03', 'N', NULL, NULL, NULL, 288);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292750', '2902', 'BA', '2901', '2903', '29012', '29', 'SANTA BARBARA', NULL, '75', '44150000', '7', '3851', '3851', '04276', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 338.574, '-11,95800', '-38,97500', 293, 'S', 0.6210, NULL, NULL, '29011', 'S', 'N', 4294, NULL, '2903', '2990', NULL, '1961', 'S', 536, 'SANTA BÁRBARA', 'N', '292750', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '337', NULL, '03', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292760', '2910', 'BA', '2906', '2904', '29013', '29', 'SANTA BRIGIDA', NULL, '75', '48570000', '6', '3853', '3853', '04277', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 848.873, '-9,73600', '-38,12600', 317, 'S', 0.5300, NULL, NULL, '29062', 'S', 'N', 4303, NULL, '2990', '2990', NULL, '1962', 'S', 537, 'SANTA BRÍGIDA', 'N', '292760', 'N', 'S', 'S', NULL, 162, 'S', 'N', 'N', '338', NULL, '03', 'N', NULL, NULL, NULL, 345);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292770', '2908', 'BA', '2903', '2907', '29032', '29', 'SANTA CRUZ CABRALIA', NULL, '73', '45807000', '5', '3855', '3855', '04278', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 1550.791, '-16,27800', '-39,02500', 32, 'S', 0.6880, NULL, NULL, '29031', 'S', 'N', 4313, NULL, '2990', '2990', NULL, '1832', 'S', 538, 'SANTA CRUZ CABRÁLIA', 'N', '292770', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '339', NULL, '03', 'N', NULL, NULL, NULL, 346);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292780', '2907', 'BA', '2909', '2907', '29031', '29', 'SANTA CRUZ DA VITORIA', NULL, '73', '45725000', '4', '3857', '3857', '04279', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 250.035, '-14,96100', '-39,81200', 281, 'S', 0.6090, NULL, NULL, '29092', 'S', 'N', 4317, NULL, '2990', '2990', NULL, '1962', 'S', 539, 'SANTA CRUZ DA VITÓRIA', 'N', '292780', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '340', NULL, '03', 'N', NULL, NULL, NULL, 175);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292790', '2913', 'BA', '2909', '2906', '29024', '29', 'SANTA INES', NULL, '73', '45320000', '3', '3859', '3859', '04280', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 356.193, '-13,29200', '-39,81900', 398, 'S', 0.6510, NULL, NULL, '29093', 'S', 'N', 4348, NULL, '2990', '2990', NULL, '1924', 'S', 540, 'SANTA INÊS', 'N', '292790', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '341', NULL, '03', 'N', NULL, NULL, NULL, 290);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292800', '2912', 'BA', '2901', '2904', '29016', '29', 'SANTALUZ', NULL, '75', '48880000', '0', '3861', '3861', '04281', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1597.202, '-11,25600', '-39,37500', 370, 'S', 0.6460, NULL, NULL, '29014', 'N', 'N', 4435, NULL, '2990', '2990', NULL, '1935', 'S', 545, 'SANTALUZ', 'N', '292800', 'N', 'S', 'S', NULL, 43, 'N', 'N', 'N', '346', NULL, '03', 'N', NULL, NULL, NULL, 47);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292805', '2906', 'BA', '2909', '2907', '29031', '29', 'SANTA LUZIA', NULL, '73', '45865000', '9', '3987', '3987', '04362', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 785.193, '-15,42900', '-39,33400', 195, 'S', 0.5830, NULL, NULL, '29091', 'S', 'N', 4362, NULL, '2990', '2990', NULL, '1986', 'S', 541, 'SANTA LUZIA', 'N', '292805', 'N', 'S', 'S', NULL, 90, 'S', 'N', 'N', '342', NULL, '03', 'N', NULL, NULL, NULL, 112);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292810', '2926', 'BA', '2907', '2901', '29003', '29', 'SANTA MARIA DA VITORIA', NULL, '77', '47640000', '9', '3863', '3863', '04282', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1890.695, '-13,39800', '-44,19800', 436, 'S', 0.6690, NULL, NULL, '29073', 'N', 'N', 4376, NULL, '2990', '2990', NULL, '1888', 'S', 542, 'SANTA MARIA DA VITÓRIA', 'N', '292810', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '343', NULL, '03', 'N', NULL, NULL, NULL, 402);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292820', '2926', 'BA', '2907', '2901', '29003', '29', 'SANTANA', NULL, '77', '47700000', '8', '3865', '3865', '04283', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 1999.407, '-12,98300', '-44,05100', 526, 'S', 0.6450, NULL, NULL, '29073', 'S', 'N', 4436, NULL, '2990', '2990', NULL, '1890', 'S', 546, 'SANTANA', 'N', '292820', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '347', NULL, '03', 'N', NULL, NULL, NULL, 402);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292830', '2902', 'BA', '2901', '2903', '29012', '29', 'SANTANOPOLIS', NULL, '75', '44260000', '7', '3867', '3867', '04284', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 250.027, '-12,01700', '-38,86700', 278, 'S', 0.6270, NULL, NULL, '29011', 'S', 'N', 4465, NULL, '2903', '2990', NULL, '1962', 'S', 547, 'SANTANÓPOLIS', 'N', '292830', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '348', NULL, '03', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292840', '2925', 'BA', '2907', '2901', '29002', '29', 'SANTA RITA DE CASSIA', NULL, '77', '47150000', '6', '3549', '3549', '04125', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 6071.116, '-11,00900', '-44,51900', 440, 'S', 0.6510, NULL, NULL, '29071', 'S', 'N', 4397, NULL, '2990', '2990', NULL, '1840', 'S', 543, 'SANTA RITA DE CÁSSIA', 'N', '292840', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '344', NULL, '03', 'N', NULL, NULL, NULL, 287);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292850', '2904', 'BA', '2904', '2903', '29012', '29', 'SANTA TERESINHA', NULL, '75', '44590000', '5', '3869', '3869', '04285', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 710.313, '-12,77200', '-39,52300', 227, 'S', 0.6280, NULL, NULL, '29044', 'S', 'N', 4420, NULL, '2990', '2990', NULL, '1849', 'S', 544, 'SANTA TERESINHA', 'N', '292850', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '345', NULL, '03', 'N', NULL, NULL, NULL, 106);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292860', '2901', 'BA', '2904', '2905', '29020', '29', 'SANTO AMARO', NULL, '75', '44200000', '4', '3871', '3871', '04286', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 518.260, '-12,54700', '-38,71200', 42, 'S', 0.6840, NULL, NULL, '29043', 'N', 'N', 4472, NULL, '2990', '2901', NULL, '1727', 'S', 548, 'SANTO AMARO', 'N', '292860', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '349', NULL, '02', 'N', NULL, NULL, NULL, 178);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292870', '2904', 'BA', '2904', '2905', '29020', '29', 'SANTO ANTONIO DE JESUS', NULL, '75', '44570000', '3', '3873', '3873', '04287', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 259.213, '-12,96900', '-39,26100', 213, 'S', 0.7290, NULL, NULL, '29044', 'N', 'N', 4487, NULL, '2990', '2990', NULL, '1880', 'S', 549, 'SANTO ANTÔNIO DE JESUS', 'N', '292870', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '350', NULL, '01', 'N', NULL, NULL, NULL, 106);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292880', '2902', 'BA', '2901', '2903', '29012', '29', 'SANTO ESTEVAO', NULL, '75', '44190000', '2', '3875', '3875', '04288', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 365.141, '-12,43000', '-39,25100', 242, 'S', 0.6490, NULL, NULL, '29011', 'N', 'N', 4515, NULL, '2990', '2990', NULL, '1921', 'S', 550, 'SANTO ESTÊVÃO', 'N', '292880', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '351', NULL, '03', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292890', '2925', 'BA', '2907', '2901', '29001', '29', 'SAO DESIDERIO', NULL, '77', '47820000', '1', '3877', '3877', '04289', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 14819.585, '-12,36300', '-44,97300', 497, 'S', 0.6100, NULL, NULL, '29071', 'S', 'N', 4553, NULL, '2990', '2990', NULL, '1962', 'S', 551, 'SÃO DESIDÉRIO', 'N', '292890', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '352', NULL, '03', 'N', NULL, NULL, NULL, 287);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292910', '2904', 'BA', '2904', '2905', '29020', '29', 'SAO FELIPE', NULL, '75', '44550000', '7', '3881', '3881', '04291', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 197.898, '-12,84700', '-39,08900', 195, 'S', 0.6690, NULL, NULL, '29044', 'S', 'N', 4568, NULL, '2990', '2990', NULL, '1939', 'S', 553, 'SÃO FELIPE', 'N', '292910', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '354', NULL, '03', 'N', NULL, NULL, NULL, 106);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292895', '2912', 'BA', '2901', '2904', '29016', '29', 'SAO DOMINGOS', NULL, '75', '48895000', '0', '3029', '3029', '04409', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 265.375, '-11,50300', '-39,54200', 0, 'S', 0.6240, NULL, NULL, '29014', 'S', 'N', 4555, NULL, '2990', '2990', NULL, '1990', 'S', 552, 'SÃO DOMINGOS', 'N', '292895', 'N', 'S', 'S', NULL, 43, 'N', 'N', 'N', '353', NULL, '03', 'N', NULL, NULL, NULL, 47);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292900', '2931', 'BA', '2904', '2905', '29020', '29', 'SAO FELIX', NULL, '75', '44360000', '8', '3879', '3879', '04290', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 95.502, '-12,60500', '-38,97200', 45, 'S', 0.6570, NULL, NULL, '29042', 'S', 'N', 4570, NULL, '2990', '2990', NULL, '1889', 'S', 554, 'SÃO FÉLIX', 'N', '292900', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '355', NULL, '03', 'N', NULL, NULL, NULL, 344);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292905', '2926', 'BA', '2907', '2901', '29003', '29', 'SAO FELIX DO CORIBE', NULL, '77', '47665000', '7', '3031', '3031', '04410', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 846.123, '-13,40200', '-44,19500', 40, 'S', 0.6830, NULL, NULL, '29073', 'S', 'N', 4574, NULL, '2990', '2990', NULL, '1990', 'S', 555, 'SÃO FÉLIX DO CORIBE', 'N', '292905', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '356', NULL, '03', 'N', NULL, NULL, NULL, 402);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292920', '2901', 'BA', '2904', '2905', '29021', '29', 'SAO FRANCISCO DO CONDE', NULL, '71', '43900000', '6', '3883', '3883', '04292', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 266.631, '-12,62800', '-38,68000', 11, 'S', 0.7140, NULL, NULL, '29043', 'N', 'N', 4592, NULL, '2901', '2901', NULL, '1697', 'S', 556, 'SÃO FRANCISCO DO CONDE', 'N', '292920', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '357', NULL, '01', 'N', NULL, NULL, NULL, 178);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292925', '2921', 'BA', '2902', '2903', '29009', '29', 'SAO GABRIEL', NULL, '74', '44915000', '5', '3989', '3989', '04341', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1156.798, '-11,22900', '-41,91200', 692, 'S', 0.6190, NULL, NULL, '29021', 'S', 'N', 4601, NULL, '2990', '2990', NULL, '1986', 'S', 557, 'SÃO GABRIEL', 'N', '292925', 'N', 'S', 'S', NULL, 50, 'N', 'N', 'N', '358', NULL, '03', 'N', NULL, NULL, NULL, 401);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292930', '2902', 'BA', '2901', '2903', '29012', '29', 'SAO GONCALO DOS CAMPOS', NULL, '75', '44330000', '5', '3885', '3885', '04293', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 293.989, '-12,43300', '-38,96700', 234, 'S', 0.6670, NULL, NULL, '29011', 'S', 'N', 4619, NULL, '2902', '2990', NULL, '1884', 'S', 558, 'SÃO GONÇALO DOS CAMPOS', 'N', '292930', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '359', NULL, '03', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292935', '2907', 'BA', '2909', '2907', '29031', '29', 'SAO JOSE DA VITORIA', NULL, '73', '45620000', '4', '3035', '3035', '04411', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 53.395, '-15,08400', '-39,33900', 180, 'S', 0.6260, NULL, NULL, '29092', 'S', 'N', 4694, NULL, '2990', '2990', NULL, '1990', 'S', 559, 'SÃO JOSÉ DA VITÓRIA', 'N', '292935', 'N', 'S', 'S', NULL, 90, 'S', 'N', 'N', '360', NULL, '03', 'N', NULL, NULL, NULL, 175);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292937', '2916', 'BA', '2902', '2903', '29010', '29', 'SAO JOSE DO JACUIPE', NULL, '74', '44698000', '0', '3033', '3033', '04412', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 369.229, '-11,41200', '-39,86700', 361, 'S', 0.5770, NULL, NULL, '29022', 'S', 'N', 4720, NULL, '2990', '2990', NULL, '1990', 'S', 560, 'SÃO JOSÉ DO JACUÍPE', 'N', '292937', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '361', NULL, '03', 'N', NULL, NULL, NULL, 177);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292940', '2929', 'BA', '2904', '2906', '29024', '29', 'SAO MIGUEL DAS MATAS', NULL, '75', '44580000', '4', '3887', '3887', '04294', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 207.446, '-13,04800', '-39,45600', 293, 'S', 0.6590, NULL, NULL, '29044', 'S', 'N', 4777, NULL, '2990', '2990', NULL, '1891', 'S', 561, 'SÃO MIGUEL DAS MATAS', 'N', '292940', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '362', NULL, '03', 'N', NULL, NULL, NULL, 106);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292950', '2901', 'BA', '2904', '2905', '29019', '29', 'SAO SEBASTIAO DO PASSE', NULL, '71', '43850000', '3', '3889', '3889', '04295', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 549.425, '-12,51300', '-38,49500', 37, 'S', 0.6930, NULL, NULL, '29043', 'N', 'N', 4841, NULL, '2901', '2901', NULL, '1931', 'S', 562, 'SÃO SEBASTIÃO DO PASSÉ', 'N', '292950', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '363', NULL, '01', 'N', NULL, NULL, NULL, 178);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292960', '2931', 'BA', '2904', '2905', '29020', '29', 'SAPEACU', NULL, '75', '44530000', '2', '3891', '3891', '04296', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 125.582, '-12,72800', '-39,18200', 226, 'S', 0.6770, NULL, NULL, '29042', 'S', 'N', 4867, NULL, '2990', '2990', NULL, '1953', 'S', 563, 'SAPEAÇU', 'N', '292960', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '364', NULL, '03', 'N', NULL, NULL, NULL, 344);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292970', '2903', 'BA', '2905', '2904', '29017', '29', 'SATIRO DIAS', NULL, '75', '48485000', '1', '3893', '3893', '04297', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 974.549, '-11,60000', '-38,60000', 213, 'S', 0.5490, NULL, NULL, '29051', 'S', 'N', 4882, NULL, '2990', '2990', NULL, '1958', 'S', 564, 'SÁTIRO DIAS', 'N', '292970', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '365', NULL, '03', 'N', NULL, NULL, NULL, 400);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292975', '2901', 'BA', '2904', '2905', '29020', '29', 'SAUBARA', NULL, '75', '44220000', '0', '3037', '3037', '04413', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 158.933, '-12,73800', '-38,76900', 44, 'S', 0.6720, NULL, NULL, '29043', 'S', 'N', 4885, NULL, '2990', '2990', NULL, '1990', 'S', 565, 'SAUBARA', 'N', '292975', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '366', NULL, '03', 'N', NULL, NULL, NULL, 178);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292980', '2916', 'BA', '2902', '2903', '29010', '29', 'SAUDE', NULL, '74', '44740000', '0', '3895', '3895', '04298', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 499.722, '-10,94100', '-40,41800', 542, 'S', 0.6160, NULL, NULL, '29022', 'S', 'N', 4888, NULL, '2990', '2990', NULL, '1933', 'S', 566, 'SAÚDE', 'N', '292980', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '367', NULL, '03', 'N', NULL, NULL, NULL, 177);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('292990', '2927', 'BA', '2901', '2906', '29023', '29', 'SEABRA', NULL, '75', '46900000', '9', '3897', '3897', '04299', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 2825.016, '-12,41900', '-41,77000', 812, 'S', 0.6610, NULL, NULL, '29013', 'N', 'N', 4890, NULL, '2990', '2990', NULL, '1889', 'S', 567, 'SEABRA', 'N', '292990', 'N', 'S', 'S', NULL, 31, 'N', 'N', 'N', '368', NULL, '03', 'N', NULL, NULL, NULL, 4);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293000', '2930', 'BA', '2908', '2906', '29026', '29', 'SEBASTIAO LARANJEIRAS', NULL, '77', '46450000', '6', '3899', '3899', '04300', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 2004.185, '-14,57300', '-42,94000', 533, 'S', 0.6450, NULL, NULL, '29082', 'S', 'N', 4894, NULL, '2990', '2990', NULL, '1962', 'S', 568, 'SEBASTIÃO LARANJEIRAS', 'N', '293000', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '369', NULL, '03', 'N', NULL, NULL, NULL, 7);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293010', '2928', 'BA', '2906', '2903', '29008', '29', 'SENHOR DO BONFIM', NULL, '74', '48970000', '5', '3901', '3901', '04301', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 816.697, '-10,46300', '-40,19100', 538, 'S', 0.6900, NULL, NULL, '29063', 'N', 'N', 4920, NULL, '2990', '2990', NULL, '1797', 'S', 569, 'SENHOR DO BONFIM', 'N', '293010', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '370', NULL, '01', 'N', NULL, NULL, NULL, 107);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293015', '2926', 'BA', '2907', '2902', '29007', '29', 'SERRA DO RAMALHO', NULL, '77', '47630000', '4', '3039', '3039', '04414', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 2677.366, '-13,57200', '-43,59800', 0, 'S', 0.5980, NULL, NULL, '29073', 'N', 'N', 4944, NULL, '2990', '2990', NULL, '1990', 'S', 571, 'SERRA DO RAMALHO', 'N', '293015', 'N', 'S', 'S', NULL, 102, 'N', 'N', 'N', '372', NULL, '03', 'N', NULL, NULL, NULL, 402);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293020', '2915', 'BA', '2906', '2902', '29004', '29', 'SENTO SE', NULL, '74', '47350000', '4', '3903', '3903', '04302', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 12871.039, '-9,74600', '-41,88500', 410, 'S', 0.6030, NULL, NULL, '29061', 'N', 'N', 4925, NULL, '2990', '2990', NULL, '1832', 'S', 570, 'SENTO SÉ', 'N', '293020', 'N', 'S', 'S', NULL, 143, 'N', 'N', 'N', '371', NULL, '03', 'N', NULL, NULL, NULL, 113);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293030', '2926', 'BA', '2907', '2901', '29003', '29', 'SERRA DOURADA', NULL, '77', '47740000', '3', '3905', '3905', '04303', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 1441.545, '-12,76100', '-43,95000', 500, 'S', 0.6370, NULL, NULL, '29073', 'S', 'N', 4947, NULL, '2990', '2990', NULL, '1962', 'S', 572, 'SERRA DOURADA', 'N', '293030', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '373', NULL, '03', 'N', NULL, NULL, NULL, 402);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293040', '2902', 'BA', '2901', '2903', '29012', '29', 'SERRA PRETA', NULL, '75', '44660000', '2', '3907', '3907', '04304', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 536.892, '-12,16000', '-39,33200', 311, 'S', 0.6040, NULL, NULL, '29011', 'S', 'N', 4951, NULL, '2903', '2990', NULL, '1953', 'S', 573, 'SERRA PRETA', 'N', '293040', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '374', NULL, '03', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293050', '2912', 'BA', '2901', '2904', '29016', '29', 'SERRINHA', NULL, '75', '48700000', '1', '3909', '3909', '04305', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'S', 'N', NULL, 'N', 568.405, '-11,66400', '-39,00800', 379, 'S', 0.6580, NULL, NULL, '29014', 'N', 'N', 4962, NULL, '2990', '2990', NULL, '1876', 'S', 574, 'SERRINHA', 'N', '293050', 'N', 'S', 'S', NULL, 43, 'N', 'N', 'S', '375', NULL, '01', 'N', NULL, NULL, NULL, 47);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293060', '2916', 'BA', '2902', '2903', '29010', '29', 'SERROLANDIA', NULL, '74', '44710000', '0', '3911', '3911', '04306', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 373.762, '-11,41600', '-40,30200', 478, 'S', 0.6300, NULL, NULL, '29022', 'S', 'N', 4967, NULL, '2990', '2990', NULL, '1962', 'S', 575, 'SERROLÂNDIA', 'N', '293060', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '376', NULL, '03', 'N', NULL, NULL, NULL, 177);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293070', '2901', 'BA', '2904', '2905', '29021', '29', 'SIMOES FILHO', NULL, '71', '43700000', '9', '3913', '3913', '04307', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 192.163, '-12,78400', '-38,40400', 52, 'S', 0.7300, NULL, NULL, '29041', 'N', 'N', 4997, NULL, '2901', '2901', NULL, '1961', 'S', 576, 'SIMÕES FILHO', 'N', '293070', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'S', '377', NULL, '01', 'N', NULL, NULL, NULL, 343);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293075', '2926', 'BA', '2907', '2902', '29007', '29', 'SITIO DO MATO', NULL, '77', '47610000', '8', '3041', '3041', '04386', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1709.762, '-13,08500', '-43,46500', 428, 'S', 0.6000, NULL, NULL, '29073', 'S', 'N', 5007, NULL, '2990', '2990', NULL, '1990', 'S', 577, 'SÍTIO DO MATO', 'N', '293075', 'N', 'S', 'S', NULL, 102, 'N', 'N', 'N', '378', NULL, '03', 'N', NULL, NULL, NULL, 402);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293076', '2911', 'BA', '2905', '2904', '29013', '29', 'SITIO DO QUINTO', NULL, '75', '48565000', '6', '3043', '3043', '04415', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 651.958, '-10,35000', '-38,21700', 332, 'S', 0.5610, NULL, NULL, '29052', 'S', 'N', 5008, NULL, '2990', '2990', NULL, '1990', 'S', 578, 'SÍTIO DO QUINTO', 'N', '293076', 'N', 'S', 'S', NULL, 162, 'N', 'N', 'N', '379', NULL, '03', 'N', NULL, NULL, NULL, 56);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293077', '2915', 'BA', '2906', '2902', '29004', '29', 'SOBRADINHO', NULL, '74', '48925000', '4', '3045', '3045', '04387', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 1322.661, '-9,45500', '-40,82300', 0, 'S', 0.6840, NULL, NULL, '29061', 'S', 'N', 5013, NULL, '2602', '2990', NULL, '1990', 'S', 579, 'SOBRADINHO', 'N', '293077', 'N', 'S', 'S', NULL, 143, 'N', 'N', 'N', '380', NULL, '03', 'N', NULL, NULL, NULL, 113);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293080', '2927', 'BA', '2901', '2903', '29009', '29', 'SOUTO SOARES', NULL, '75', '46990000', '8', '3915', '3915', '04308', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 1095.850, '-12,08900', '-41,63800', 620, 'S', 0.6040, NULL, NULL, '29013', 'S', 'N', 5033, NULL, '2990', '2990', NULL, '1962', 'S', 580, 'SOUTO SOARES', 'N', '293080', 'N', 'S', 'S', NULL, 31, 'N', 'N', 'N', '381', NULL, '03', 'N', NULL, NULL, NULL, 4);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293090', '2925', 'BA', '2907', '2901', '29002', '29', 'TABOCAS DO BREJO VELHO', NULL, '77', '47760000', '7', '3917', '3917', '04309', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1550.518, '-12,70600', '-44,00700', 532, 'S', 0.5990, NULL, NULL, '29071', 'S', 'N', 5054, NULL, '2990', '2990', NULL, '1962', 'S', 581, 'TABOCAS DO BREJO VELHO', 'N', '293090', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '382', NULL, '03', 'N', NULL, NULL, NULL, 287);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293100', '2919', 'BA', '2908', '2906', '29027', '29', 'TANHACU', NULL, '77', '46600000', '4', '3919', '3919', '04310', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 1341.793, '-14,02100', '-41,24800', 430, 'S', 0.6530, NULL, NULL, '29081', 'S', 'N', 5084, NULL, '2990', '2990', NULL, '1961', 'S', 582, 'TANHAÇU', 'N', '293100', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '383', NULL, '03', 'N', NULL, NULL, NULL, 288);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293105', '2924', 'BA', '2908', '2906', '29022', '29', 'TANQUE NOVO', NULL, '77', '46580000', '3', '3991', '3991', '04363', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 825.943, '-13,54600', '-42,49100', 835, 'S', 0.6130, NULL, NULL, '29082', 'S', 'N', 5087, NULL, '2990', '2990', NULL, '1986', 'S', 583, 'TANQUE NOVO', 'N', '293105', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '384', NULL, '03', 'N', NULL, NULL, NULL, 7);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293110', '2902', 'BA', '2901', '2903', '29012', '29', 'TANQUINHO', NULL, '75', '44160000', '3', '3921', '3921', '04311', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 209.026, '-11,97900', '-39,10400', 248, 'S', 0.6610, NULL, NULL, '29011', 'S', 'N', 5088, NULL, '2902', '2990', NULL, '1958', 'S', 584, 'TANQUINHO', 'N', '293110', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '385', NULL, '03', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293120', '2905', 'BA', '2909', '2907', '29030', '29', 'TAPEROA', NULL, '75', '45430000', '2', '3923', '3923', '04312', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 408.576, '-13,53800', '-39,09900', 15, 'S', 0.6060, NULL, NULL, '29094', 'S', 'N', 5095, NULL, '2990', '2990', NULL, '1847', 'S', 585, 'TAPEROÁ', 'N', '293120', 'N', 'S', 'S', NULL, 21, 'S', 'N', 'N', '386', NULL, '03', 'N', NULL, NULL, NULL, 283);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293130', '2916', 'BA', '2902', '2903', '29011', '29', 'TAPIRAMUTA', NULL, '74', '44840000', '1', '3925', '3925', '04313', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 663.870, '-11,84700', '-40,79100', 820, 'S', 0.6150, NULL, NULL, '29022', 'S', 'N', 5101, NULL, '2990', '2990', NULL, '1962', 'S', 586, 'TAPIRAMUTÁ', 'N', '293130', 'N', 'S', 'S', NULL, 31, 'N', 'N', 'N', '387', NULL, '03', 'N', NULL, NULL, NULL, 177);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293135', '2909', 'BA', '2903', '2907', '29032', '29', 'TEIXEIRA DE FREITAS', NULL, '73', '45999000', '0', '3993', '3993', '04364', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1153.791, '-17,53500', '-39,74200', 186, 'S', 0.6980, NULL, NULL, '29032', 'N', 'N', 5130, NULL, '2990', '2990', NULL, '1986', 'S', 587, 'TEIXEIRA DE FREITAS', 'N', '293135', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'S', '388', NULL, '01', 'N', NULL, NULL, NULL, 398);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293140', '2902', 'BA', '2901', '2903', '29012', '29', 'TEODORO SAMPAIO', NULL, '75', '44280000', '0', '3927', '3927', '04314', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 277.766, '-12,30300', '-38,64300', 121, 'S', 0.6610, NULL, NULL, '29011', 'S', 'N', 5142, NULL, '2990', '2990', NULL, '1961', 'S', 588, 'TEODORO SAMPAIO', 'N', '293140', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '389', NULL, '03', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293150', '2912', 'BA', '2901', '2904', '29016', '29', 'TEOFILANDIA', NULL, '75', '48770000', '9', '3929', '3929', '04315', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 317.982, '-11,48900', '-38,99800', 430, 'S', 0.6070, NULL, NULL, '29014', 'S', 'N', 5144, NULL, '2990', '2990', NULL, '1962', 'S', 589, 'TEOFILÂNDIA', 'N', '293150', 'N', 'S', 'S', NULL, 43, 'N', 'N', 'N', '390', NULL, '03', 'N', NULL, NULL, NULL, 47);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293160', '2905', 'BA', '2909', '2907', '29031', '29', 'TEOLANDIA', NULL, '73', '45465000', '8', '3931', '3931', '04316', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 288.272, '-13,60200', '-39,49100', 192, 'S', 0.5910, NULL, NULL, '29094', 'S', 'N', 5146, NULL, '2990', '2990', NULL, '1962', 'S', 590, 'TEOLÂNDIA', 'N', '293160', 'N', 'S', 'S', NULL, 21, 'S', 'N', 'N', '391', NULL, '03', 'N', NULL, NULL, NULL, 283);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293170', '2902', 'BA', '2901', '2905', '29019', '29', 'TERRA NOVA', NULL, '75', '44270000', '7', '3933', '3933', '04317', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 198.626, '-12,39200', '-38,62500', 720, 'S', 0.6720, NULL, NULL, '29011', 'S', 'N', 5157, NULL, '2990', '2990', NULL, '1961', 'S', 591, 'TERRA NOVA', 'N', '293170', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '392', NULL, '03', 'N', NULL, NULL, NULL, 54);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293180', '2920', 'BA', '2908', '2906', '29027', '29', 'TREMEDAL', NULL, '77', '45170000', '6', '3935', '3935', '04318', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 1779.422, '-14,97600', '-41,41100', 530, 'S', 0.6080, NULL, NULL, '29084', 'S', 'N', 5215, NULL, '2990', '2990', NULL, '1953', 'S', 592, 'TREMEDAL', 'N', '293180', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '393', NULL, '03', 'N', NULL, NULL, NULL, 335);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293190', '2912', 'BA', '2901', '2904', '29014', '29', 'TUCANO', NULL, '75', '48790000', '5', '3937', '3937', '04319', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 2801.292, '-10,96300', '-38,78700', 209, 'S', 0.5820, NULL, NULL, '29014', 'N', 'N', 5247, NULL, '2990', '2990', NULL, '1837', 'S', 593, 'TUCANO', 'N', '293190', 'N', 'S', 'S', NULL, 43, 'N', 'N', 'N', '394', NULL, '03', 'N', NULL, NULL, NULL, 47);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293200', '2915', 'BA', '2906', '2904', '29014', '29', 'UAUA', NULL, '74', '48950000', '2', '3939', '3939', '04320', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 2950.274, '-9,84200', '-39,48200', 439, 'S', 0.6160, NULL, NULL, '29061', 'S', 'N', 5285, NULL, '2990', '2990', NULL, '1933', 'S', 594, 'UAUÁ', 'N', '293200', 'N', 'S', 'S', NULL, 143, 'N', 'N', 'N', '395', NULL, '03', 'N', NULL, NULL, NULL, 113);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293210', '2929', 'BA', '2904', '2906', '29024', '29', 'UBAIRA', NULL, '75', '45310000', '1', '3941', '3941', '04321', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 762.404, '-13,26800', '-39,66300', 324, 'S', 0.6240, NULL, NULL, '29044', 'S', 'N', 5288, NULL, '2990', '2990', NULL, '1832', 'S', 595, 'UBAÍRA', 'N', '293210', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '396', NULL, '03', 'N', NULL, NULL, NULL, 106);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293220', '2907', 'BA', '2909', '2907', '29031', '29', 'UBAITABA', NULL, '73', '45545000', '0', '3943', '3943', '04322', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 221.753, '-14,31300', '-39,32300', 68, 'S', 0.6410, NULL, NULL, '29092', 'S', 'N', 5289, NULL, '2990', '2990', NULL, '1933', 'S', 596, 'UBAITABA', 'N', '293220', 'N', 'S', 'S', NULL, 90, 'N', 'N', 'N', '397', NULL, '03', 'N', NULL, NULL, NULL, 175);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293230', '2907', 'BA', '2909', '2907', '29031', '29', 'UBATA', NULL, '73', '45550000', '9', '3945', '3945', '04323', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 332.985, '-14,21400', '-39,52300', 109, 'S', 0.6400, NULL, NULL, '29092', 'S', 'N', 5293, NULL, '2990', '2990', NULL, '1952', 'S', 597, 'UBATÃ', 'N', '293230', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '398', NULL, '03', 'N', NULL, NULL, NULL, 175);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293240', '2921', 'BA', '2902', '2903', '29009', '29', 'UIBAI', NULL, '74', '44950000', '8', '3947', '3947', '04324', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 515.662, '-11,33700', '-42,13300', 582, 'S', 0.6150, NULL, NULL, '29021', 'S', 'N', 5301, NULL, '2990', '2990', NULL, '1961', 'S', 598, 'UIBAÍ', 'N', '293240', 'N', 'S', 'S', NULL, 50, 'N', 'N', 'N', '399', NULL, '03', 'N', NULL, NULL, NULL, 401);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293245', '2916', 'BA', '2902', '2903', '29008', '29', 'UMBURANAS', NULL, '74', '44798000', '7', '3047', '3047', '04388', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 1812.741, '-10,73300', '-41,32600', 738, 'S', 0.5530, NULL, NULL, '29022', 'S', 'N', 5309, NULL, '2990', '2990', NULL, '1990', 'S', 599, 'UMBURANAS', 'N', '293245', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '400', NULL, '03', 'N', NULL, NULL, NULL, 177);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293250', '2906', 'BA', '2909', '2907', '29031', '29', 'UNA', NULL, '73', '45690000', '7', '3949', '3949', '04325', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1159.525, '-15,29300', '-39,07500', 28, 'S', 0.6080, NULL, NULL, '29091', 'N', 'N', 5314, NULL, '2990', '2990', NULL, '1924', 'S', 600, 'UNA', 'N', '293250', 'N', 'S', 'S', NULL, 90, 'N', 'N', 'N', '401', NULL, '03', 'N', NULL, NULL, NULL, 112);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293270', '2906', 'BA', '2909', '2907', '29031', '29', 'URUCUCA', NULL, '73', '45680000', '5', '3953', '3953', '04327', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 337.705, '-14,59300', '-39,28400', 102, 'S', 0.6520, NULL, NULL, '29091', 'S', 'N', 5340, NULL, '2990', '2990', NULL, '1952', 'S', 602, 'URUÇUCA', 'N', '293270', 'N', 'S', 'S', NULL, 90, 'S', 'N', 'N', '403', NULL, '03', 'N', NULL, NULL, NULL, 112);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293280', '2918', 'BA', '2901', '2906', '29023', '29', 'UTINGA', NULL, '75', '46810000', '4', '3955', '3955', '04328', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 717.344, '-12,08200', '-41,09400', 530, 'S', 0.5960, NULL, NULL, '29012', 'S', 'N', 5351, NULL, '2990', '2990', NULL, '1953', 'S', 603, 'UTINGA', 'N', '293280', 'N', 'S', 'S', NULL, 31, 'S', 'N', 'N', '404', NULL, '03', 'N', NULL, NULL, NULL, 55);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293290', '2905', 'BA', '2909', '2907', '29030', '29', 'VALENCA', NULL, '75', '45400000', '3', '3957', '3957', '04329', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1190.381, '-13,37000', '-39,07300', 39, 'S', 0.6720, NULL, NULL, '29094', 'N', 'N', 5359, NULL, '2990', '2990', NULL, '1799', 'S', 604, 'VALENÇA', 'N', '293290', 'N', 'S', 'S', NULL, 21, 'N', 'N', 'S', '405', NULL, '01', 'N', NULL, NULL, NULL, 283);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293300', '2912', 'BA', '2901', '2904', '29016', '29', 'VALENTE', NULL, '75', '48890000', '0', '3959', '3959', '04330', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 356.895, '-11,41200', '-39,46200', 358, 'S', 0.6570, NULL, NULL, '29014', 'S', 'N', 5361, NULL, '2990', '2990', NULL, '1958', 'S', 605, 'VALENTE', 'N', '293300', 'N', 'S', 'S', NULL, 43, 'N', 'N', 'N', '406', NULL, '03', 'N', NULL, NULL, NULL, 47);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293305', '2916', 'BA', '2902', '2903', '29011', '29', 'VARZEA DA ROCA', NULL, '74', '44635000', '9', '3997', '3997', '04365', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 549.339, '-11,60700', '-40,13700', 459, 'S', 0.5910, NULL, NULL, '29022', 'S', 'N', 5388, NULL, '2990', '2990', NULL, '1986', 'S', 606, 'VÁRZEA DA ROÇA', 'N', '293305', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '407', NULL, '03', 'N', NULL, NULL, NULL, 177);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293310', '2916', 'BA', '2902', '2903', '29010', '29', 'VARZEA DO POCO', NULL, '74', '44715000', '9', '3961', '3961', '04331', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 220.414, '-11,52900', '-40,32000', 462, 'S', 0.6650, NULL, NULL, '29022', 'S', 'N', 5389, NULL, '2990', '2990', NULL, '1962', 'S', 607, 'VÁRZEA DO POÇO', 'N', '293310', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '408', NULL, '03', 'N', NULL, NULL, NULL, 177);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293315', '2916', 'BA', '2902', '2903', '29010', '29', 'VARZEA NOVA', NULL, '74', '44690000', '8', '3995', '3995', '04366', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1165.165, '-11,25900', '-40,94200', 742, 'S', 0.5860, NULL, NULL, '29022', 'S', 'N', 5392, NULL, '2990', '2990', NULL, '1986', 'S', 608, 'VÁRZEA NOVA', 'N', '293315', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '409', NULL, '03', 'N', NULL, NULL, NULL, 177);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293317', '2904', 'BA', '2904', '2905', '29020', '29', 'VARZEDO', NULL, '75', '44565000', '4', '3049', '3049', '04416', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 167.003, '-12,97100', '-39,39400', 280, 'S', 0.6300, NULL, NULL, '29044', 'S', 'N', 5394, NULL, '2990', '2990', NULL, '1990', 'S', 609, 'VARZEDO', 'N', '293317', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '410', NULL, '03', 'N', NULL, NULL, NULL, 106);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293320', '2901', 'BA', '2904', '2905', '29021', '29', 'VERA CRUZ', NULL, '71', '44470000', '8', '3963', '3963', '04332', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 252.759, '-12,96000', '-38,60900', 13, 'S', 0.7040, NULL, NULL, '29043', 'N', 'N', 5405, NULL, '2901', '2901', NULL, '1962', 'S', 610, 'VERA CRUZ', 'N', '293320', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '411', NULL, '01', 'N', NULL, NULL, NULL, 178);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293325', '2909', 'BA', '2903', '2907', '29032', '29', 'VEREDA', NULL, '73', '45955000', '7', '3051', '3051', '04389', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 828.700, '-17,22300', '-40,09000', 100, 'S', 0.5970, NULL, NULL, '29032', 'S', 'N', 5414, NULL, '2990', '2990', NULL, '1990', 'S', 611, 'VEREDA', 'N', '293325', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '412', NULL, '03', 'N', NULL, NULL, NULL, 398);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293330', '2920', 'BA', '2908', '2906', '29028', '29', 'VITORIA DA CONQUISTA', NULL, '77', '45115000', '7', '3965', '3965', '04333', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 3204.257, '-14,86600', '-40,83900', 923, 'S', 0.7080, NULL, NULL, '29084', 'N', 'N', 5475, NULL, '2990', '2990', NULL, '1840', 'S', 612, 'VITÓRIA DA CONQUISTA', 'N', '293330', 'N', 'S', 'S', NULL, NULL, 'N', 'S', 'S', '413', NULL, '01', 'N', NULL, NULL, NULL, 335);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293340', '2918', 'BA', '2901', '2906', '29023', '29', 'WAGNER', NULL, '75', '46970000', '6', '3967', '3967', '04334', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 415.819, '-12,28700', '-41,16800', 460, 'S', 0.6100, NULL, NULL, '29012', 'S', 'N', 5487, NULL, '2990', '2990', NULL, '1962', 'S', 613, 'WAGNER', 'N', '293340', 'N', 'S', 'S', NULL, 31, 'N', 'N', 'N', '414', NULL, '03', 'N', NULL, NULL, NULL, 55);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293345', '2925', 'BA', '2907', '2901', '29002', '29', 'WANDERLEY', NULL, '77', '47940000', '5', '3999', '3999', '04367', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 3043.408, '-12,12000', '-43,88800', 583, 'S', 0.6190, NULL, NULL, '29071', 'S', 'N', 5490, NULL, '2990', '2990', NULL, '1986', 'S', 614, 'WANDERLEY', 'N', '293345', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '415', NULL, '03', 'N', NULL, NULL, NULL, 287);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293350', '2905', 'BA', '2909', '2907', '29031', '29', 'WENCESLAU GUIMARAES', NULL, '73', '45460000', '5', '3969', '3969', '04335', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 661.792, '-13,68700', '-39,47900', 178, 'S', 0.5750, NULL, NULL, '29094', 'S', 'N', 5493, NULL, '2990', '2990', NULL, '1962', 'S', 615, 'WENCESLAU GUIMARÃES', 'N', '293350', 'N', 'S', 'S', NULL, 21, 'S', 'N', 'N', '416', NULL, '03', 'N', NULL, NULL, NULL, 283);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('293360', '2921', 'BA', '2902', '2902', '29006', '29', 'XIQUE-XIQUE', NULL, '74', '47400000', '4', '3971', '3971', '04336', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'S', 'N', 'N', NULL, 'N', 5671.439, '-10,82200', '-42,73100', 402, 'S', 0.5800, NULL, NULL, '29021', 'N', 'N', 5504, NULL, '2990', '2990', NULL, '1832', 'S', 616, 'XIQUE-XIQUE', 'N', '293360', 'N', 'S', 'S', NULL, 50, 'N', 'N', 'N', '417', NULL, '03', 'N', NULL, NULL, NULL, 401);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310010', '3112', 'MG', '3113', '3105', '31019', '31', 'ABADIA DOS DOURADOS', NULL, '34', '38540000', '4', '4001', '4001', '11001', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 894.515, '-18,48600', '-47,40300', 742, 'S', 0.7600, NULL, NULL, '31074', 'N', 'N', 2, NULL, '3190', '3190', NULL, '1948', 'S', 1356, 'ABADIA DOS DOURADOS', 'N', '310010', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '1', NULL, '03', 'N', NULL, NULL, NULL, 247);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310020', '3114', 'MG', '3103', '3106', '31024', '31', 'ABAETE', NULL, '37', '35620000', '3', '4003', '4003', '11002', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1816.856, '-19,16000', '-45,44600', 647, 'S', 0.7780, NULL, NULL, '31024', 'N', 'N', 4, NULL, '3190', '3190', NULL, '1870', 'S', 1357, 'ABAETÉ', 'N', '310020', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '2', NULL, '03', 'N', NULL, NULL, NULL, 58);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310030', '3124', 'MG', '3110', '3112', '31061', '31', 'ABRE CAMPO', NULL, '31', '35365000', '2', '4005', '4005', '11003', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 471.055, '-20,30100', '-42,47800', 548, 'S', 0.7190, NULL, NULL, '31059', 'N', 'N', 13, NULL, '3190', '3190', NULL, '1889', 'S', 1358, 'ABRE CAMPO', 'N', '310030', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '3', NULL, '03', 'N', NULL, NULL, NULL, 191);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310040', '3108', 'MG', '3110', '3112', '31060', '31', 'ACAIACA', NULL, '31', '35438000', '1', '4007', '4007', '11004', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 100.876, '-20,36300', '-43,14500', 421, 'S', 0.6780, NULL, NULL, '31060', 'S', 'N', 16, NULL, '3190', '3190', NULL, '1962', 'S', 1359, 'ACAIACA', 'N', '310040', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '4', NULL, '03', 'N', NULL, NULL, NULL, 347);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310050', '3123', 'MG', '3106', '3108', '31039', '31', 'ACUCENA', NULL, '33', '35150000', '0', '4009', '4009', '11005', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 811.490, '-19,07300', '-42,54600', 472, 'S', 0.6590, NULL, NULL, '31037', 'S', 'N', 29, NULL, '3104', '3190', NULL, '1943', 'S', 1360, 'AÇUCENA', 'N', '310050', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '5', NULL, '03', 'N', NULL, NULL, NULL, 358);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310060', '3116', 'MG', '3106', '3108', '31036', '31', 'AGUA BOA', NULL, '33', '39790000', '9', '4011', '4011', '11006', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1317.748, '-17,99600', '-42,38900', 407, 'S', 0.6420, NULL, NULL, '31039', 'S', 'N', 46, NULL, '3190', '3190', NULL, '1953', 'S', 1361, 'ÁGUA BOA', 'N', '310060', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '6', NULL, '03', 'N', NULL, NULL, NULL, 179);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310070', '3113', 'MG', '3112', '3105', '31022', '31', 'AGUA COMPRIDA', NULL, '34', '38110000', '8', '4013', '4013', '11007', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 489.513, '-20,05600', '-48,10900', 543, 'S', 0.7930, NULL, NULL, '31072', 'N', 'N', 52, NULL, '3190', '3190', NULL, '1953', 'S', 1362, 'ÁGUA COMPRIDA', 'N', '310070', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '7', NULL, '03', 'N', NULL, NULL, NULL, 349);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310080', '3115', 'MG', '3105', '3109', '31045', '31', 'AGUANIL', NULL, '35', '37273000', '7', '4015', '4015', '11008', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 235.025, '-20,94300', '-45,39300', 823, 'S', 0.7410, NULL, NULL, '31033', 'N', 'N', 63, NULL, '3190', '3190', NULL, '1962', 'S', 1363, 'AGUANIL', 'N', '310080', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '8', NULL, '03', 'N', NULL, NULL, NULL, 235);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310090', '3117', 'MG', '3111', '3104', '31016', '31', 'AGUAS FORMOSAS', NULL, '33', '39880000', '6', '4017', '4017', '11009', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 817.727, '-17,08200', '-40,93600', 273, 'S', 0.6390, NULL, NULL, '31062', 'S', 'N', 70, NULL, '3190', '3190', NULL, '1938', 'S', 1364, 'ÁGUAS FORMOSAS', 'N', '310090', 'N', 'S', 'S', NULL, 99, 'S', 'N', 'N', '9', NULL, '03', 'N', NULL, NULL, NULL, 62);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310100', '3119', 'MG', '3111', '3102', '31005', '31', 'AGUAS VERMELHAS', NULL, '33', '39990000', '3', '4019', '4019', '11010', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1257.601, '-15,74700', '-41,46000', 758, 'S', 0.6280, NULL, NULL, '31068', 'S', 'N', 74, NULL, '3190', '3190', NULL, '1962', 'S', 1365, 'ÁGUAS VERMELHAS', 'N', '310100', 'N', 'S', 'S', NULL, 57, 'N', 'N', 'N', '10', NULL, '03', 'N', NULL, NULL, NULL, 21);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310110', '3116', 'MG', '3106', '3108', '31041', '31', 'AIMORES', NULL, '33', '35200000', '2', '4021', '4021', '11011', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1349.987, '-19,49600', '-41,06400', 80, 'S', 0.7310, NULL, NULL, '31040', 'N', 'N', 81, NULL, '3190', '3190', NULL, '1916', 'S', 1366, 'AIMORÉS', 'N', '310110', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '11', NULL, '03', 'N', NULL, NULL, NULL, 403);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310120', '3111', 'MG', '3101', '3110', '31055', '31', 'AIURUOCA', NULL, '35', '37450000', '1', '4023', '4023', '11012', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 650.069, '-21,97600', '-44,60300', 974, 'S', 0.7360, NULL, NULL, '31008', 'N', 'N', 84, NULL, '3190', '3190', NULL, '1834', 'S', 1367, 'AIURUOCA', 'N', '310120', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '12', NULL, '03', 'N', NULL, NULL, NULL, 57);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310130', '3111', 'MG', '3101', '3110', '31054', '31', 'ALAGOA', NULL, '35', '37458000', '0', '4025', '4025', '11013', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 161.555, '-22,17100', '-44,64200', 1132, 'S', 0.7260, NULL, NULL, '31008', 'N', 'N', 86, NULL, '3190', '3190', NULL, '1962', 'S', 1368, 'ALAGOA', 'N', '310130', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '13', NULL, '03', 'N', NULL, NULL, NULL, 57);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310140', '3110', 'MG', '3101', '3110', '31051', '31', 'ALBERTINA', NULL, '35', '37596000', '9', '4027', '4027', '11014', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 57.617, '-22,20100', '-46,61600', 1011, 'S', 0.7470, NULL, NULL, '31007', 'N', 'N', 94, NULL, '3190', '3190', NULL, '1962', 'S', 1369, 'ALBERTINA', 'N', '310140', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '14', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310150', '3127', 'MG', '3107', '3112', '31066', '31', 'ALEM PARAIBA', NULL, '32', '36660000', '8', '4029', '4029', '11015', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 511.199, '-21,88800', '-42,70400', 140, 'S', 0.7770, NULL, NULL, '31041', 'N', 'N', 106, NULL, '3190', '3190', NULL, '1880', 'S', 1370, 'ALÉM PARAÍBA', 'N', '310150', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '15', NULL, '03', 'N', NULL, NULL, NULL, 409);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310160', '3121', 'MG', '3101', '3110', '31049', '31', 'ALFENAS', NULL, '35', '37130000', '7', '4031', '4031', '11016', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 848.320, '-21,42900', '-45,94700', 881, 'S', 0.8290, NULL, NULL, '31001', 'N', 'N', 110, NULL, '3190', '3190', NULL, '1860', 'S', 1371, 'ALFENAS', 'N', '310160', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '16', NULL, '02', 'N', NULL, NULL, NULL, 300);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310163', '3103', 'MG', '3102', '3111', '31059', '31', 'ALFREDO VASCONCELOS', NULL, '32', '36272000', '1', '2681', '2681', '11724', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 126.913, '-21,14500', '-43,77700', 1052, 'S', 0.7200, NULL, NULL, '31013', 'N', 'N', 113, NULL, '3190', '3190', NULL, '1993', 'S', 1372, 'ALFREDO VASCONCELOS', 'N', '310163', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '17', NULL, '03', 'N', NULL, NULL, NULL, 241);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310170', '3119', 'MG', '3111', '3103', '31014', '31', 'ALMENARA', NULL, '33', '39900000', '6', '4033', '4033', '11017', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 2300.797, '-16,18400', '-40,69400', 187, 'S', 0.6680, NULL, NULL, '31063', 'N', 'N', 122, NULL, '3190', '3190', NULL, '1938', 'S', 1373, 'ALMENARA', 'N', '310170', 'N', 'S', 'S', NULL, 117, 'N', 'N', 'N', '18', NULL, '03', 'N', NULL, NULL, NULL, 125);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310180', '3116', 'MG', '3106', '3108', '31037', '31', 'ALPERCATA', NULL, '33', '35138000', '5', '4035', '4035', '11018', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 167.349, '-18,97400', '-41,97000', 192, 'S', 0.7020, NULL, NULL, '31036', 'N', 'N', 126, NULL, '3190', '3190', NULL, '1962', 'S', 1374, 'ALPERCATA', 'N', '310180', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '19', NULL, '03', 'N', NULL, NULL, NULL, 189);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310190', '3122', 'MG', '3101', '3110', '31047', '31', 'ALPINOPOLIS', NULL, '35', '37940000', '4', '4037', '4037', '11019', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 458.976, '-20,86400', '-46,38800', 876, 'S', 0.7790, NULL, NULL, '31005', 'N', 'N', 128, NULL, '3190', '3190', NULL, '1938', 'S', 1375, 'ALPINÓPOLIS', 'N', '310190', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '20', NULL, '03', 'N', NULL, NULL, NULL, 361);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310200', '3121', 'MG', '3101', '3110', '31049', '31', 'ALTEROSA', NULL, '35', '37145000', '1', '4039', '4039', '11020', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 366.101, '-21,24900', '-46,14300', 843, 'S', 0.7360, NULL, NULL, '31001', 'N', 'N', 135, NULL, '3190', '3190', NULL, '1938', 'S', 1376, 'ALTEROSA', 'N', '310200', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '21', NULL, '03', 'N', NULL, NULL, NULL, 300);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310205', '3124', 'MG', '3110', '3112', '31061', '31', 'ALTO CAPARAO', NULL, '32', '36979000', '0', '0564', NULL, '11771', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 104.571, '-20,43400', '-41,86800', 1000, 'S', 0.7580, NULL, NULL, '31059', 'N', 'N', 147, NULL, '3190', '3190', NULL, '1997', 'S', 1377, 'ALTO CAPARAÓ', 'N', '310205', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '22', NULL, '03', 'N', NULL, NULL, NULL, 191);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310210', '3103', 'MG', '3102', '3112', '31062', '31', 'ALTO RIO DOCE', NULL, '32', '36260000', '0', '4041', '4041', '11021', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 518.982, '-21,02600', '-43,41100', 793, 'S', 0.6960, NULL, NULL, '31013', 'S', 'N', 160, NULL, '3190', '3190', NULL, '1892', 'S', 1379, 'ALTO RIO DOCE', 'N', '310210', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '24', NULL, '03', 'N', NULL, NULL, NULL, 241);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310220', '3116', 'MG', '3106', '3108', '31041', '31', 'ALVARENGA', NULL, '33', '35249000', '9', '4043', '4043', '11022', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 367.319, '-19,41700', '-41,72900', 390, 'S', 0.6570, NULL, NULL, '31040', 'S', 'N', 168, NULL, '3190', '3190', NULL, '1962', 'S', 1380, 'ALVARENGA', 'N', '310220', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '25', NULL, '03', 'N', NULL, NULL, NULL, 403);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310230', '3108', 'MG', '3110', '3107', '31031', '31', 'ALVINOPOLIS', NULL, '31', '35950000', '8', '4045', '4045', '11023', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 599.343, '-20,10700', '-43,04900', 572, 'S', 0.7270, NULL, NULL, '31060', 'N', 'N', 173, NULL, '3190', '3190', NULL, '1891', 'S', 1381, 'ALVINÓPOLIS', 'N', '310230', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '26', NULL, '03', 'N', NULL, NULL, NULL, 347);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310240', '3104', 'MG', '3104', '3107', '31028', '31', 'ALVORADA DE MINAS', NULL, '31', '39140000', '7', '4047', '4047', '11024', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 374.910, '-18,73600', '-43,36500', 657, 'S', 0.6670, NULL, NULL, '31026', 'S', 'N', 177, NULL, '3190', '3190', NULL, '1962', 'S', 1382, 'ALVORADA DE MINAS', 'N', '310240', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '27', NULL, '03', 'N', NULL, NULL, NULL, 126);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310250', '3108', 'MG', '3110', '3112', '31062', '31', 'AMPARO DO SERRA', NULL, '31', '35444000', '6', '4049', '4049', '11025', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 145.811, '-20,50700', '-42,80300', 580, 'S', 0.6750, NULL, NULL, '31060', 'S', 'N', 204, NULL, '3190', '3190', NULL, '1962', 'S', 1383, 'AMPARO DO SERRA', 'N', '310250', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '28', NULL, '03', 'N', NULL, NULL, NULL, 347);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310260', '3110', 'MG', '3101', '3110', '31051', '31', 'ANDRADAS', NULL, '35', '37795000', '5', '4051', '4051', '11026', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 467.403, '-22,06800', '-46,56900', 913, 'S', 0.8120, NULL, NULL, '31006', 'N', 'N', 226, NULL, '3190', '3190', NULL, '1888', 'S', 1384, 'ANDRADAS', 'N', '310260', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '29', NULL, '03', 'N', NULL, NULL, NULL, 291);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310270', '3119', 'MG', '3111', '3103', '31013', '31', 'CACHOEIRA DE PAJEU', NULL, '33', '39980000', '4', '4053', '4053', '11027', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 673.761, '-15,96600', '-41,49800', 721, 'S', 0.6220, NULL, NULL, '31068', 'S', 'N', 832, NULL, '3190', '3190', NULL, '1989', 'S', 1462, 'CACHOEIRA DE PAJEÚ', 'N', '310270', 'N', 'S', 'S', NULL, 57, 'N', 'N', 'N', '107', NULL, '03', 'N', NULL, NULL, NULL, 21);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310280', '3105', 'MG', '3107', '3110', '31055', '31', 'ANDRELANDIA', NULL, '35', '37300000', '3', '4055', '4055', '11028', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1004.536, '-21,74000', '-44,30900', 998, 'S', 0.7330, NULL, NULL, '31043', 'N', 'N', 229, NULL, '3190', '3190', NULL, '1864', 'S', 1385, 'ANDRELÂNDIA', 'N', '310280', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '30', NULL, '03', 'N', NULL, NULL, NULL, 360);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310285', '3117', 'MG', '3111', '3103', '31011', '31', 'ANGELANDIA', NULL, '33', '39685000', '2', '0566', NULL, '11772', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 184.882, '-17,73000', '-42,26500', 891, 'S', 0.6350, NULL, NULL, '31069', 'S', 'N', 231, NULL, '3190', '3190', NULL, '1997', 'S', 1386, 'ANGELÂNDIA', 'N', '310285', 'N', 'S', 'S', NULL, 57, 'N', 'N', 'N', '31', NULL, '03', 'N', NULL, NULL, NULL, 292);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310290', '3103', 'MG', '3102', '3111', '31059', '31', 'ANTONIO CARLOS', NULL, '32', '36220000', '2', '4057', '4057', '11029', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 525.025, '-21,31800', '-43,74700', 1058, 'S', 0.7330, NULL, NULL, '31013', 'N', 'N', 256, NULL, '3190', '3190', NULL, '1948', 'S', 1387, 'ANTÔNIO CARLOS', 'N', '310290', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '32', NULL, '03', 'N', NULL, NULL, NULL, 241);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310300', '3123', 'MG', '3106', '3108', '31039', '31', 'ANTONIO DIAS', NULL, '31', '35177000', '9', '4059', '4059', '11030', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 877.844, '-19,65300', '-42,87200', 398, 'S', 0.6610, NULL, NULL, '31035', 'S', 'N', 258, NULL, '3104', '3190', NULL, '1911', 'S', 1388, 'ANTÔNIO DIAS', 'N', '310300', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '33', NULL, '03', 'N', NULL, NULL, NULL, 64);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310310', '3118', 'MG', '3107', '3112', '31063', '31', 'ANTONIO PRADO DE MINAS', NULL, '32', '36850000', '8', '4061', '4061', '11031', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 85.042, '-21,01600', '-42,10900', 312, 'S', 0.7200, NULL, NULL, '31045', 'N', 'N', 264, NULL, '3190', '3190', NULL, '1962', 'S', 1389, 'ANTÔNIO PRADO DE MINAS', 'N', '310310', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '34', NULL, '03', 'N', NULL, NULL, NULL, 130);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310320', '3114', 'MG', '3103', '3107', '31027', '31', 'ARACAI', NULL, '31', '35777000', '7', '4063', '4063', '11032', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 185.764, '-19,19900', '-44,24800', 739, 'S', 0.7480, NULL, NULL, '31024', 'N', 'N', 290, NULL, '3190', '3190', NULL, '1962', 'S', 1390, 'ARAÇAÍ', 'N', '310320', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '35', NULL, '03', 'N', NULL, NULL, NULL, 58);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310330', '3105', 'MG', '3107', '3112', '31065', '31', 'ARACITABA', NULL, '32', '36255000', '6', '4065', '4065', '11033', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 105.885, '-21,34300', '-43,37800', 573, 'S', 0.6840, NULL, NULL, '31046', 'S', 'N', 298, NULL, '3190', '3190', NULL, '1962', 'S', 1391, 'ARACITABA', 'N', '310330', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '36', NULL, '03', 'N', NULL, NULL, NULL, 180);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310340', '3104', 'MG', '3104', '3103', '31012', '31', 'ARACUAI', NULL, '33', '39600000', '5', '4067', '4067', '11034', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 2235.696, '-16,85000', '-42,07000', 307, 'S', 0.6870, NULL, NULL, '31064', 'N', 'N', 304, NULL, '3190', '3190', NULL, '1870', 'S', 1392, 'ARAÇUAÍ', 'N', '310340', 'N', 'S', 'S', NULL, 57, 'N', 'N', 'N', '37', NULL, '03', 'N', NULL, NULL, NULL, 357);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310350', '3112', 'MG', '3113', '3105', '31018', '31', 'ARAGUARI', NULL, '34', '38440000', '4', '4069', '4069', '11035', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 2730.632, '-18,64900', '-48,18700', 921, 'S', 0.8150, NULL, NULL, '31075', 'N', 'N', 316, NULL, '3190', '3190', NULL, '1882', 'S', 1393, 'ARAGUARI', 'N', '310350', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '38', NULL, '01', 'N', NULL, NULL, NULL, 116);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310360', '3105', 'MG', '3107', '3110', '31055', '31', 'ARANTINA', NULL, '32', '37360000', '3', '4071', '4071', '11036', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 89.382, '-21,91100', '-44,25600', 1049, 'S', 0.7360, NULL, NULL, '31043', 'N', 'N', 325, NULL, '3190', '3190', NULL, '1962', 'S', 1394, 'ARANTINA', 'N', '310360', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '39', NULL, '03', 'N', NULL, NULL, NULL, 360);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310370', '3108', 'MG', '3110', '3112', '31062', '31', 'ARAPONGA', NULL, '31', '36594000', '2', '4073', '4073', '11037', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 304.421, '-20,66700', '-42,52100', 1040, 'S', 0.6570, NULL, NULL, '31061', 'S', 'N', 329, NULL, '3190', '3190', NULL, '1962', 'S', 1395, 'ARAPONGA', 'N', '310370', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '40', NULL, '03', 'N', NULL, NULL, NULL, 117);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310375', '3112', 'MG', '3113', '3105', '31018', '31', 'ARAPORA', NULL, '34', '38435000', '1', '2903', '2903', '11725', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 298.490, '-18,43700', '-49,18700', 461, 'S', 0.7800, NULL, NULL, '31075', 'N', 'N', 331, NULL, '3190', '3190', NULL, '1993', 'S', 1396, 'ARAPORÃ', 'N', '310375', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '41', NULL, '03', 'N', NULL, NULL, NULL, 116);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310380', '3107', 'MG', '3109', '3105', '31020', '31', 'ARAPUA', NULL, '34', '38860000', '1', '4075', '4075', '11038', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 172.529, '-19,03400', '-46,15600', 1031, 'S', 0.7760, NULL, NULL, '31057', 'N', 'N', 333, NULL, '3190', '3190', NULL, '1962', 'S', 1397, 'ARAPUÁ', 'N', '310380', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '42', NULL, '03', 'N', NULL, NULL, NULL, 194);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310390', '3115', 'MG', '3105', '3106', '31026', '31', 'ARAUJOS', NULL, '37', '35603000', '0', '4077', '4077', '11039', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 245.617, '-19,94800', '-45,16600', 821, 'S', 0.7550, NULL, NULL, '31029', 'N', 'N', 355, NULL, '3190', '3190', NULL, '1953', 'S', 1398, 'ARAÚJOS', 'N', '310390', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '43', NULL, '03', 'N', NULL, NULL, NULL, 413);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310400', '3113', 'MG', '3112', '3105', '31023', '31', 'ARAXA', NULL, '34', '38180000', '7', '4079', '4079', '11040', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1165.169, '-19,59300', '-46,94100', 997, 'S', 0.7990, NULL, NULL, '31070', 'N', 'N', 356, NULL, '3190', '3190', NULL, '1831', 'S', 1399, 'ARAXÁ', 'N', '310400', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '44', NULL, '02', 'N', NULL, NULL, NULL, 240);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310410', '3121', 'MG', '3101', '3110', '31048', '31', 'ARCEBURGO', NULL, '35', '37820000', '6', '4081', '4081', '11041', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 162.460, '-21,36400', '-46,94000', 693, 'S', 0.7460, NULL, NULL, '31002', 'N', 'N', 357, NULL, '3190', '3190', NULL, '1911', 'S', 1400, 'ARCEBURGO', 'N', '310410', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '45', NULL, '03', 'N', NULL, NULL, NULL, 302);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310420', '3115', 'MG', '3105', '3109', '31044', '31', 'ARCOS', NULL, '37', '35588000', '5', '4083', '4083', '11042', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 510.048, '-20,28200', '-45,53900', 740, 'S', 0.8080, NULL, NULL, '31029', 'N', 'N', 359, NULL, '3190', '3190', NULL, '1938', 'S', 1401, 'ARCOS', 'N', '310420', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '46', NULL, '03', 'N', NULL, NULL, NULL, 413);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310430', '3121', 'MG', '3101', '3110', '31049', '31', 'AREADO', NULL, '35', '37140000', '4', '4085', '4085', '11043', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 280.754, '-21,35900', '-46,14600', 815, 'S', 0.7800, NULL, NULL, '31001', 'N', 'N', 361, NULL, '3190', '3190', NULL, '1911', 'S', 1402, 'AREADO', 'N', '310430', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '47', NULL, '03', 'N', NULL, NULL, NULL, 300);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310440', '3127', 'MG', '3107', '3112', '31066', '31', 'ARGIRITA', NULL, '32', '36710000', '3', '4087', '4087', '11044', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 159.326, '-21,61000', '-42,83600', 250, 'S', 0.7350, NULL, NULL, '31044', 'N', 'N', 374, NULL, '3190', '3190', NULL, '1962', 'S', 1403, 'ARGIRITA', 'N', '310440', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '48', NULL, '03', 'N', NULL, NULL, NULL, 246);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310445', '3104', 'MG', '3104', '3103', '31011', '31', 'ARICANDUVA', NULL, '38', '39678000', '2', '0568', NULL, '11773', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 243.539, '-17,86700', '-42,55700', 682, 'S', 0.6360, NULL, NULL, '31027', 'S', 'N', 375, NULL, '3190', '3190', NULL, '1997', 'S', 1404, 'ARICANDUVA', 'N', '310445', 'N', 'S', 'S', NULL, 5, 'N', 'N', 'N', '49', NULL, '03', 'N', NULL, NULL, NULL, 67);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310450', '3126', 'MG', '3109', '3101', '31001', '31', 'ARINOS', NULL, '38', '38680000', '2', '4089', '4089', '11045', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 5322.795, '-15,91700', '-46,10600', 509, 'S', 0.7110, NULL, NULL, '31058', 'N', 'N', 376, NULL, '3190', '3190', NULL, '1962', 'S', 1405, 'ARINOS', 'N', '310450', 'N', 'S', 'S', NULL, 63, 'N', 'N', 'N', '50', NULL, '03', 'N', NULL, NULL, NULL, 295);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310460', '3127', 'MG', '3107', '3112', '31064', '31', 'ASTOLFO DUTRA', NULL, '32', '36780000', '1', '4091', '4091', '11046', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 159.139, '-21,31500', '-42,86200', 257, 'S', 0.7710, NULL, NULL, '31044', 'N', 'N', 410, NULL, '3190', '3190', NULL, '1938', 'S', 1406, 'ASTOLFO DUTRA', 'N', '310460', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '51', NULL, '03', 'N', NULL, NULL, NULL, 246);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310470', '3117', 'MG', '3111', '3104', '31015', '31', 'ATALEIA', NULL, '33', '39850000', '0', '4093', '4093', '11047', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1838.384, '-18,04400', '-41,11000', 240, 'S', 0.6530, NULL, NULL, '31069', 'S', 'N', 416, NULL, '3190', '3190', NULL, '1943', 'S', 1407, 'ATALÉIA', 'N', '310470', 'N', 'S', 'S', NULL, 99, 'N', 'N', 'N', '52', NULL, '03', 'N', NULL, NULL, NULL, 292);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310480', '3114', 'MG', '3103', '3106', '31025', '31', 'AUGUSTO DE LIMA', NULL, '38', '39220000', '9', '4095', '4095', '11048', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1250.649, '-18,10900', '-44,26700', 534, 'S', 0.6900, NULL, NULL, '31019', 'S', 'N', 421, NULL, '3190', '3190', NULL, '1962', 'S', 1408, 'AUGUSTO DE LIMA', 'N', '310480', 'N', 'N', 'S', NULL, 48, 'N', 'N', 'N', '53', NULL, '03', 'N', NULL, NULL, NULL, 65);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310490', '3111', 'MG', '3101', '3110', '31054', '31', 'BAEPENDI', NULL, '35', '37443000', '8', '4097', '4097', '11049', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 751.748, '-21,95900', '-44,89000', 893, 'S', 0.7420, NULL, NULL, '31008', 'N', 'N', 446, NULL, '3190', '3190', NULL, '1814', 'S', 1409, 'BAEPENDI', 'N', '310490', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '54', NULL, '03', 'N', NULL, NULL, NULL, 57);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310500', '3114', 'MG', '3103', '3107', '31027', '31', 'BALDIM', NULL, '31', '35706000', '4', '4099', '4099', '11050', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 554.029, '-19,28800', '-43,95700', 603, 'S', 0.7420, NULL, NULL, '31024', 'N', 'N', 458, NULL, '3101', '3190', NULL, '1948', 'S', 1410, 'BALDIM', 'N', '310500', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '55', NULL, '01', 'N', NULL, NULL, NULL, 58);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310510', '3115', 'MG', '3105', '3109', '31042', '31', 'BAMBUI', NULL, '37', '38900000', '3', '4101', '4101', '11051', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1455.380, '-20,00600', '-45,97700', 706, 'S', 0.7880, NULL, NULL, '31030', 'N', 'N', 468, NULL, '3190', '3190', NULL, '1881', 'S', 1411, 'BAMBUÍ', 'N', '310510', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '56', NULL, '03', 'N', NULL, NULL, NULL, 15);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310520', '3119', 'MG', '3111', '3103', '31014', '31', 'BANDEIRA', NULL, '33', '39917000', '2', '4103', '4103', '11052', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'N', 'N', 'S', 'N', NULL, 'N', 484.680, '-15,88500', '-40,55900', 292, 'S', 0.6190, NULL, NULL, '31063', 'S', 'N', 472, NULL, '3190', '3190', NULL, '1962', 'S', 1412, 'BANDEIRA', 'N', '310520', 'N', 'S', 'S', NULL, 117, 'N', 'N', 'N', '57', NULL, '03', 'N', NULL, NULL, NULL, 125);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310530', '3121', 'MG', '3101', '3110', '31051', '31', 'BANDEIRA DO SUL', NULL, '35', '37740000', '1', '4105', '4105', '11053', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 46.917, '-21,72800', '-46,38600', 962, 'S', 0.7740, NULL, NULL, '31001', 'N', 'N', 473, NULL, '3190', '3190', NULL, '1962', 'S', 1413, 'BANDEIRA DO SUL', 'N', '310530', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '58', NULL, '03', 'N', NULL, NULL, NULL, 300);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310540', '3109', 'MG', '3103', '3107', '31031', '31', 'BARAO DE COCAIS', NULL, '31', '35970000', '0', '4107', '4107', '11054', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 340.675, '-19,94600', '-43,48700', 740, 'S', 0.7570, NULL, NULL, '31021', 'N', 'N', 482, NULL, '3102', '3101', NULL, '1943', 'S', 1414, 'BARÃO DE COCAIS', 'N', '310540', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '59', NULL, '03', 'N', NULL, NULL, NULL, 190);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310550', '3118', 'MG', '3107', '3112', '31063', '31', 'BARAO DE MONTE ALTO', NULL, '32', '36870000', '9', '4109', '4109', '11055', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 199.105, '-21,24500', '-42,23800', 205, 'S', 0.6940, NULL, NULL, '31045', 'S', 'N', 486, NULL, '3190', '3190', NULL, '1962', 'S', 1415, 'BARÃO DE MONTE ALTO', 'N', '310550', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '60', NULL, '03', 'N', NULL, NULL, NULL, 130);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310560', '3103', 'MG', '3102', '3111', '31059', '31', 'BARBACENA', NULL, '32', '36200000', '8', '4111', '4111', '11056', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 788.001, '-21,22600', '-43,77400', 1164, 'S', 0.7980, NULL, NULL, '31013', 'N', 'N', 490, NULL, '3190', '3190', NULL, '1791', 'S', 1416, 'BARBACENA', 'N', '310560', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '61', NULL, '01', 'N', NULL, NULL, NULL, 241);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310570', '3108', 'MG', '3110', '3112', '31060', '31', 'BARRA LONGA', NULL, '31', '35447000', '7', '4113', '4113', '11057', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 386.101, '-20,28300', '-43,04100', 400, 'S', 0.6680, NULL, NULL, '31060', 'S', 'N', 527, NULL, '3190', '3190', NULL, '1841', 'S', 1417, 'BARRA LONGA', 'N', '310570', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '62', NULL, '03', 'N', NULL, NULL, NULL, 347);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310590', '3120', 'MG', '3102', '3111', '31059', '31', 'BARROSO', NULL, '32', '36212000', '5', '4117', '4117', '11059', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 81.726, '-21,18700', '-43,97600', 922, 'S', 0.7450, NULL, NULL, '31015', 'N', 'N', 548, NULL, '3190', '3190', NULL, '1953', 'S', 1418, 'BARROSO', 'N', '310590', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '63', NULL, '03', 'N', NULL, NULL, NULL, 114);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310600', '3109', 'MG', '3103', '3107', '31031', '31', 'BELA VISTA DE MINAS', NULL, '31', '35938000', '2', '4119', '4119', '11060', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 108.606, '-19,83000', '-43,09100', 686, 'S', 0.7380, NULL, NULL, '31023', 'N', 'N', 564, NULL, '3190', '3104', NULL, '1962', 'S', 1419, 'BELA VISTA DE MINAS', 'N', '310600', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '64', NULL, '03', 'N', NULL, NULL, NULL, 18);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310610', '3105', 'MG', '3107', '3112', '31065', '31', 'BELMIRO BRAGA', NULL, '32', '36126000', '1', '4121', '4121', '11061', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 392.319, '-21,94900', '-43,41500', 493, 'S', 0.7350, NULL, NULL, '31043', 'N', 'N', 579, NULL, '3190', '3190', NULL, '1962', 'S', 1420, 'BELMIRO BRAGA', 'N', '310610', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '65', NULL, '03', 'N', NULL, NULL, NULL, 360);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310620', '3101', 'MG', '3103', '3107', '31030', '31', 'BELO HORIZONTE', NULL, '31', '30161970', '0', '4123', '4123', '11062', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'S', 330.954, '-19,81700', '-43,95600', 858, 'S', 0.8390, NULL, NULL, '31016', 'N', 'N', 583, NULL, '3101', '3101', NULL, '1893', 'S', 1421, 'BELO HORIZONTE', 'N', '310620', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '66', NULL, '01', 'N', NULL, NULL, NULL, 410);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310630', '3123', 'MG', '3106', '3108', '31039', '31', 'BELO ORIENTE', NULL, '33', '35195000', '9', '4125', '4125', '11063', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 336.012, '-19,22000', '-42,48400', 300, 'S', 0.6970, NULL, NULL, '31037', 'S', 'N', 586, NULL, '3104', '3103', NULL, '1962', 'S', 1422, 'BELO ORIENTE', 'N', '310630', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '67', NULL, '03', 'N', NULL, NULL, NULL, 358);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310640', '3101', 'MG', '3103', '3107', '31032', '31', 'BELO VALE', NULL, '31', '35473000', '8', '4127', '4127', '11064', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 365.437, '-20,40800', '-44,02400', 832, 'S', 0.7330, NULL, NULL, '31016', 'N', 'N', 587, NULL, '3102', '3190', NULL, '1938', 'S', 1423, 'BELO VALE', 'N', '310640', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '68', NULL, '03', 'N', NULL, NULL, NULL, 410);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310650', '3104', 'MG', '3104', '3103', '31011', '31', 'BERILO', NULL, '33', '39640000', '7', '4129', '4129', '11065', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 586.752, '-16,95200', '-42,46600', 401, 'S', 0.6800, NULL, NULL, '31064', 'S', 'N', 599, NULL, '3190', '3190', NULL, '1962', 'S', 1424, 'BERILO', 'N', '310650', 'N', 'S', 'S', NULL, 57, 'N', 'N', 'N', '69', NULL, '03', 'N', NULL, NULL, NULL, 357);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310660', '3117', 'MG', '3111', '3104', '31016', '31', 'BERTOPOLIS', NULL, '33', '39875000', '6', '4131', '4131', '11066', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 425.575, '-17,06300', '-40,57400', 278, 'S', 0.5850, NULL, NULL, '31062', 'S', 'N', 607, NULL, '3190', '3190', NULL, '1962', 'S', 1426, 'BERTÓPOLIS', 'N', '310660', 'N', 'S', 'S', NULL, 99, 'S', 'N', 'N', '71', NULL, '03', 'N', NULL, NULL, NULL, 62);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310665', '3106', 'MG', '3108', '3102', '31005', '31', 'BERIZAL', NULL, '38', '39555000', '5', '0570', NULL, '11774', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 493.335, '-15,61300', '-41,74500', 692, 'S', 0.5990, NULL, NULL, '31056', 'S', 'N', 600, NULL, '3190', '3190', NULL, '1997', 'S', 1425, 'BERIZAL', 'N', '310665', 'N', 'S', 'S', NULL, 7, 'N', 'N', 'N', '70', NULL, '03', 'N', NULL, NULL, NULL, 348);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310670', '3101', 'MG', '3103', '3107', '31030', '31', 'BETIM', NULL, '31', '32501970', '5', '4133', '4133', '11067', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 345.913, '-19,96800', '-44,19800', 860, 'S', 0.7750, NULL, NULL, '31017', 'N', 'N', 611, NULL, '3101', '3101', NULL, '1938', 'S', 1427, 'BETIM', 'N', '310670', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '72', NULL, '01', 'N', NULL, NULL, NULL, 242);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310680', '3105', 'MG', '3107', '3112', '31065', '31', 'BIAS FORTES', NULL, '32', '36230000', '4', '4135', '4135', '11068', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 284.271, '-21,60600', '-43,75700', 763, 'S', 0.7130, NULL, NULL, '31043', 'N', 'N', 613, NULL, '3190', '3190', NULL, '1938', 'S', 1428, 'BIAS FORTES', 'N', '310680', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '73', NULL, '03', 'N', NULL, NULL, NULL, 360);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310690', '3105', 'MG', '3107', '3112', '31065', '31', 'BICAS', NULL, '32', '36600000', '3', '4137', '4137', '11069', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 139.538, '-21,72500', '-43,05900', 601, 'S', 0.7990, NULL, NULL, '31047', 'N', 'N', 614, NULL, '3190', '3190', NULL, '1923', 'S', 1429, 'BICAS', 'N', '310690', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '74', NULL, '03', 'N', NULL, NULL, NULL, 115);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310700', '3114', 'MG', '3103', '3106', '31024', '31', 'BIQUINHAS', NULL, '37', '35621000', '0', '4139', '4139', '11070', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 457.226, '-18,78300', '-45,50200', 629, 'S', 0.7460, NULL, NULL, '31024', 'N', 'N', 617, NULL, '3190', '3190', NULL, '1962', 'S', 1430, 'BIQUINHAS', 'N', '310700', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '75', NULL, '03', 'N', NULL, NULL, NULL, 58);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310710', '3111', 'MG', '3101', '3110', '31050', '31', 'BOA ESPERANCA', NULL, '35', '37170000', '9', '4141', '4141', '11071', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 858.728, '-21,09000', '-45,56600', 775, 'S', 0.7830, NULL, NULL, '31011', 'N', 'N', 624, NULL, '3190', '3190', NULL, '1866', 'S', 1431, 'BOA ESPERANÇA', 'N', '310710', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '76', NULL, '03', 'N', NULL, NULL, NULL, 294);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310720', '3105', 'MG', '3107', '3110', '31055', '31', 'BOCAINA DE MINAS', NULL, '32', '37340000', '8', '4143', '4143', '11072', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 501.446, '-22,16800', '-44,39500', 1210, 'S', 0.7240, NULL, NULL, '31043', 'N', 'N', 647, NULL, '3190', '3190', NULL, '1953', 'S', 1432, 'BOCAINA DE MINAS', 'N', '310720', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '77', NULL, '03', 'N', NULL, NULL, NULL, 360);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310730', '3106', 'MG', '3108', '3102', '31009', '31', 'BOCAIUVA', NULL, '38', '39390000', '7', '4145', '4145', '11073', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 3232.660, '-17,10800', '-43,81500', 698, 'S', 0.7360, NULL, NULL, '31054', 'N', 'N', 649, NULL, '3190', '3190', NULL, '1873', 'S', 1433, 'BOCAIÚVA', 'N', '310730', 'N', 'S', 'S', NULL, 48, 'N', 'N', 'N', '78', NULL, '03', 'N', NULL, NULL, NULL, 192);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310740', '3115', 'MG', '3105', '3106', '31026', '31', 'BOM DESPACHO', NULL, '37', '35600000', '6', '4147', '4147', '11074', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1209.139, '-19,73600', '-45,25200', 769, 'S', 0.7990, NULL, NULL, '31028', 'N', 'N', 657, NULL, '3190', '3190', NULL, '1911', 'S', 1434, 'BOM DESPACHO', 'N', '310740', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '79', NULL, '03', 'N', NULL, NULL, NULL, 411);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310750', '3105', 'MG', '3107', '3110', '31055', '31', 'BOM JARDIM DE MINAS', NULL, '32', '37310000', '5', '4149', '4149', '11075', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 395.289, '-21,94700', '-44,19100', 1112, 'S', 0.7590, NULL, NULL, '31043', 'N', 'N', 663, NULL, '3190', '3190', NULL, '1938', 'S', 1435, 'BOM JARDIM DE MINAS', 'N', '310750', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '80', NULL, '03', 'N', NULL, NULL, NULL, 360);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310760', '3122', 'MG', '3101', '3110', '31047', '31', 'BOM JESUS DA PENHA', NULL, '35', '37948000', '4', '4151', '4151', '11076', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 209.069, '-21,01700', '-46,52300', 990, 'S', 0.7760, NULL, NULL, '31005', 'N', 'N', 670, NULL, '3190', '3190', NULL, '1962', 'S', 1436, 'BOM JESUS DA PENHA', 'N', '310760', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '81', NULL, '03', 'N', NULL, NULL, NULL, 361);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310770', '3109', 'MG', '3103', '3107', '31031', '31', 'BOM JESUS DO AMPARO', NULL, '31', '35908000', '3', '4153', '4153', '11077', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 195.457, '-19,70400', '-43,47400', 693, 'S', 0.7110, NULL, NULL, '31021', 'N', 'N', 674, NULL, '3190', '3190', NULL, '1953', 'S', 1437, 'BOM JESUS DO AMPARO', 'N', '310770', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '82', NULL, '03', 'N', NULL, NULL, NULL, 190);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310780', '3123', 'MG', '3106', '3108', '31040', '31', 'BOM JESUS DO GALHO', NULL, '33', '35340000', '2', '4155', '4155', '11078', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 590.971, '-19,82900', '-42,31600', 542, 'S', 0.6570, NULL, NULL, '31034', 'S', 'N', 675, NULL, '3190', '3190', NULL, '1943', 'S', 1438, 'BOM JESUS DO GALHO', 'N', '310780', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '83', NULL, '03', 'N', NULL, NULL, NULL, 14);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310790', '3110', 'MG', '3101', '3110', '31052', '31', 'BOM REPOUSO', NULL, '35', '37610000', '1', '4157', '4157', '11079', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 229.785, '-22,47100', '-46,14500', 1375, 'S', 0.7500, NULL, NULL, '31007', 'N', 'N', 687, NULL, '3190', '3190', NULL, '1953', 'S', 1439, 'BOM REPOUSO', 'N', '310790', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '84', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310810', '3101', 'MG', '3103', '3107', '31032', '31', 'BONFIM', NULL, '31', '35521000', '7', '4161', '4161', '11081', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 301.210, '-20,32700', '-44,23900', 930, 'S', 0.7150, NULL, NULL, '31017', 'N', 'N', 696, NULL, '3102', '3190', NULL, '1839', 'S', 1441, 'BONFIM', 'N', '310810', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '86', NULL, '03', 'N', NULL, NULL, NULL, 242);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310820', '3126', 'MG', '3109', '3101', '31001', '31', 'BONFINOPOLIS DE MINAS', NULL, '38', '38650000', '6', '4163', '4163', '11082', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1778.162, '-16,56700', '-45,99000', 651, 'S', 0.7540, NULL, NULL, '31058', 'N', 'N', 700, NULL, '3190', '3190', NULL, '1962', 'S', 1442, 'BONFINÓPOLIS DE MINAS', 'N', '310820', 'N', 'N', 'S', NULL, 63, 'N', 'N', 'N', '87', NULL, '03', 'N', NULL, NULL, NULL, 295);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310825', '3129', 'MG', '3108', '3102', '31003', '31', 'BONITO DE MINAS', NULL, '38', '39490000', '5', '0572', NULL, '11775', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 3900.641, '-15,32300', '-44,75400', 629, 'S', 0.5800, NULL, NULL, '31053', 'S', 'N', 706, NULL, '3190', '3190', NULL, '1997', 'S', 1443, 'BONITO DE MINAS', 'N', '310825', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '88', NULL, '03', 'N', NULL, NULL, NULL, 129);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310830', '3110', 'MG', '3101', '3110', '31052', '31', 'BORDA DA MATA', NULL, '35', '37564000', '5', '4165', '4165', '11083', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 300.081, '-22,27400', '-46,16500', 892, 'S', 0.7800, NULL, NULL, '31007', 'N', 'N', 719, NULL, '3190', '3190', NULL, '1923', 'S', 1444, 'BORDA DA MATA', 'N', '310830', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '89', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310840', '3121', 'MG', '3101', '3110', '31051', '31', 'BOTELHOS', NULL, '35', '37720000', '4', '4167', '4167', '11084', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 333.666, '-21,63300', '-46,39500', 1008, 'S', 0.7870, NULL, NULL, '31001', 'N', 'N', 723, NULL, '3190', '3190', NULL, '1911', 'S', 1445, 'BOTELHOS', 'N', '310840', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '90', NULL, '03', 'N', NULL, NULL, NULL, 300);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310850', '3106', 'MG', '3108', '3102', '31008', '31', 'BOTUMIRIM', NULL, '38', '39596000', '3', '4169', '4169', '11085', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1571.797, '-16,87200', '-43,01100', 948, 'S', 0.6650, NULL, NULL, '31051', 'S', 'N', 725, NULL, '3190', '3190', NULL, '1962', 'S', 1446, 'BOTUMIRIM', 'N', '310850', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '91', NULL, '03', 'N', NULL, NULL, NULL, 301);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310855', '3107', 'MG', '3109', '3101', '31002', '31', 'BRASILANDIA DE MINAS', NULL, '38', '38779000', '2', '0574', NULL, '11726', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2515.339, '-17,01000', '-46,00900', 530, 'S', 0.7450, NULL, NULL, '31077', 'N', 'N', 738, NULL, '3190', '3190', NULL, '1997', 'S', 1448, 'BRASILÂNDIA DE MINAS', 'N', '310855', 'N', 'N', 'S', NULL, 63, 'N', 'N', 'N', '93', NULL, '03', 'N', NULL, NULL, NULL, 414);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310860', '3129', 'MG', '3108', '3102', '31007', '31', 'BRASILIA DE MINAS', NULL, '38', '39330000', '2', '4171', '4171', '11086', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1398.563, '-16,20800', '-44,42900', 732, 'S', 0.6920, NULL, NULL, '31049', 'N', 'N', 744, NULL, '3190', '3190', NULL, '1890', 'S', 1449, 'BRASÍLIA DE MINAS', 'N', '310860', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '94', NULL, '03', 'N', NULL, NULL, NULL, 243);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310870', '3118', 'MG', '3107', '3112', '31062', '31', 'BRAS PIRES', NULL, '32', '36542000', '1', '4173', '4173', '11087', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 223.362, '-20,92100', '-43,24200', 640, 'S', 0.7050, NULL, NULL, '31048', 'N', 'N', 735, NULL, '3190', '3190', NULL, '1953', 'S', 1447, 'BRÁS PIRES', 'N', '310870', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '92', NULL, '03', 'N', NULL, NULL, NULL, 181);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310880', '3123', 'MG', '3106', '3108', '31035', '31', 'BRAUNAS', NULL, '33', '35169000', '0', '4175', '4175', '11088', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 377.155, '-19,05600', '-42,71600', 425, 'S', 0.6650, NULL, NULL, '31037', 'S', 'N', 748, NULL, '3104', '3190', NULL, '1953', 'S', 1451, 'BRAÚNAS', 'N', '310880', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '96', NULL, '03', 'N', NULL, NULL, NULL, 358);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310890', '3110', 'MG', '3101', '3110', '31056', '31', 'BRASOPOLIS', NULL, '35', '37530000', '9', '4177', '4177', '11089', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 361.160, '-22,47400', '-45,60800', 922, 'S', 0.7350, NULL, NULL, '31003', 'N', 'N', 746, NULL, '3190', '3190', NULL, '1901', 'S', 1450, 'BRASÓPOLIS', 'N', '310890', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '95', NULL, '03', 'N', NULL, NULL, NULL, 16);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310900', '3101', 'MG', '3103', '3107', '31030', '31', 'BRUMADINHO', NULL, '31', '35460000', '6', '4179', '4179', '11090', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 640.150, '-20,14300', '-44,20000', 892, 'S', 0.7730, NULL, NULL, '31017', 'N', 'N', 774, NULL, '3101', '3101', NULL, '1938', 'S', 1452, 'BRUMADINHO', 'N', '310900', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '97', NULL, '01', 'N', NULL, NULL, NULL, 242);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310910', '3110', 'MG', '3101', '3110', '31052', '31', 'BUENO BRANDAO', NULL, '35', '37578000', '5', '4181', '4181', '11091', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 355.233, '-22,44100', '-46,35100', 1204, 'S', 0.7690, NULL, NULL, '31007', 'N', 'N', 778, NULL, '3190', '3190', NULL, '1938', 'S', 1453, 'BUENO BRANDÃO', 'N', '310910', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '98', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310920', '3114', 'MG', '3103', '3106', '31025', '31', 'BUENOPOLIS', NULL, '38', '39230000', '4', '4183', '4183', '11092', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1610.959, '-17,87300', '-44,18000', 586, 'S', 0.6790, NULL, NULL, '31019', 'S', 'N', 779, NULL, '3190', '3190', NULL, '1938', 'S', 1454, 'BUENÓPOLIS', 'N', '310920', 'N', 'N', 'S', NULL, 48, 'N', 'N', 'N', '99', NULL, '03', 'N', NULL, NULL, NULL, 65);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310925', '3123', 'MG', '3106', '3108', '31040', '31', 'BUGRE', NULL, '33', '35193000', '3', '0576', NULL, '11776', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 162.432, '-19,40700', '-42,26500', 410, 'S', 0.6590, NULL, NULL, '31037', 'S', 'N', 782, NULL, '3104', '3190', NULL, '1997', 'S', 1455, 'BUGRE', 'N', '310925', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '100', NULL, '03', 'N', NULL, NULL, NULL, 358);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310930', '3126', 'MG', '3109', '3101', '31001', '31', 'BURITIS', NULL, '38', '38660000', '3', '4185', '4185', '11093', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 5219.469, '-15,61800', '-46,42300', 538, 'S', 0.7330, NULL, NULL, '31058', 'N', 'N', 799, NULL, '5301', '5301', NULL, '1962', 'S', 1456, 'BURITIS', 'S', '310930', 'N', 'N', 'S', NULL, 38, 'N', 'N', 'N', '101', NULL, '01', 'N', NULL, NULL, NULL, 295);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310940', '3128', 'MG', '3108', '3102', '31006', '31', 'BURITIZEIRO', NULL, '38', '39280000', '2', '4187', '4187', '11094', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 7225.595, '-17,35100', '-44,96200', 538, 'S', 0.6590, NULL, NULL, '31055', 'S', 'N', 802, NULL, '3190', '3190', NULL, '1962', 'S', 1457, 'BURITIZEIRO', 'N', '310940', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '102', NULL, '03', 'N', NULL, NULL, NULL, 233);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310945', '3126', 'MG', '3109', '3101', '31001', '31', 'CABECEIRA GRANDE', NULL, '38', '38625000', '1', '0578', NULL, '11777', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1025.991, '-16,03000', '-47,09100', 923, 'S', 0.7300, NULL, NULL, '31058', 'N', 'N', 810, NULL, '5301', '3190', NULL, '1997', 'S', 1458, 'CABECEIRA GRANDE', 'S', '310945', 'N', 'N', 'S', NULL, 38, 'N', 'N', 'N', '103', NULL, '01', 'N', NULL, NULL, NULL, 295);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310950', '3121', 'MG', '3101', '3110', '31048', '31', 'CABO VERDE', NULL, '35', '37880000', '1', '4189', '4189', '11095', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 367.470, '-21,47200', '-46,39600', 927, 'S', 0.7490, NULL, NULL, '31002', 'N', 'N', 817, NULL, '3190', '3190', NULL, '1866', 'S', 1459, 'CABO VERDE', 'N', '310950', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '104', NULL, '03', 'N', NULL, NULL, NULL, 302);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310960', '3114', 'MG', '3103', '3107', '31027', '31', 'CACHOEIRA DA PRATA', NULL, '31', '35765000', '0', '4191', '4191', '11096', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 61.206, '-19,52500', '-44,45400', 716, 'S', 0.7870, NULL, NULL, '31024', 'N', 'N', 829, NULL, '3190', '3190', NULL, '1962', 'S', 1460, 'CACHOEIRA DA PRATA', 'N', '310960', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '105', NULL, '03', 'N', NULL, NULL, NULL, 58);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310970', '3110', 'MG', '3101', '3110', '31053', '31', 'CACHOEIRA DE MINAS', NULL, '35', '37545000', '9', '4193', '4193', '11097', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 305.420, '-22,35500', '-45,77900', 849, 'S', 0.7680, NULL, NULL, '31007', 'N', 'N', 831, NULL, '3190', '3190', NULL, '1923', 'S', 1461, 'CACHOEIRA DE MINAS', 'N', '310970', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '106', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310980', '3125', 'MG', '3113', '3105', '31017', '31', 'CACHOEIRA DOURADA', NULL, '34', '38370000', '8', '4195', '4195', '11098', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 202.739, '-18,51500', '-49,50100', 469, 'S', 0.7530, NULL, NULL, '31073', 'N', 'N', 837, NULL, '3190', '3190', NULL, '1962', 'S', 1463, 'CACHOEIRA DOURADA', 'N', '310980', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '108', NULL, '03', 'N', NULL, NULL, NULL, 17);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310990', '3114', 'MG', '3103', '3107', '31027', '31', 'CAETANOPOLIS', NULL, '31', '35770000', '7', '4197', '4197', '11099', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 156.231, '-19,29500', '-44,41900', 742, 'S', 0.7700, NULL, NULL, '31024', 'N', 'N', 856, NULL, '3190', '3190', NULL, '1953', 'S', 1464, 'CAETANÓPOLIS', 'N', '310990', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '109', NULL, '03', 'N', NULL, NULL, NULL, 58);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311000', '3101', 'MG', '3103', '3107', '31030', '31', 'CAETE', NULL, '31', '34800000', '4', '4199', '4199', '11100', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 541.094, '-19,88000', '-43,67000', 945, 'S', 0.7890, NULL, NULL, '31016', 'N', 'N', 858, NULL, '3101', '3101', NULL, '1840', 'S', 1465, 'CAETÉ', 'N', '311000', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '110', NULL, '01', 'N', NULL, NULL, NULL, 410);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311010', '3124', 'MG', '3107', '3112', '31063', '31', 'CAIANA', NULL, '32', '36832000', '3', '4201', '4201', '11101', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 106.513, '-20,69600', '-41,92500', 750, 'S', 0.7100, NULL, NULL, '31042', 'N', 'N', 867, NULL, '3190', '3190', NULL, '1962', 'S', 1466, 'CAIANA', 'N', '311010', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '111', NULL, '03', 'N', NULL, NULL, NULL, 412);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311020', '3108', 'MG', '3110', '3112', '31062', '31', 'CAJURI', NULL, '31', '36560000', '2', '4203', '4203', '11102', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 83.365, '-20,79100', '-42,79700', 698, 'S', 0.6940, NULL, NULL, '31061', 'S', 'N', 889, NULL, '3190', '3190', NULL, '1962', 'S', 1467, 'CAJURI', 'N', '311020', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '112', NULL, '03', 'N', NULL, NULL, NULL, 117);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311030', '3110', 'MG', '3101', '3110', '31051', '31', 'CALDAS', NULL, '35', '37780000', '1', '4205', '4205', '11103', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 713.634, '-21,92400', '-46,38600', 1105, 'S', 0.7820, NULL, NULL, '31006', 'N', 'N', 893, NULL, '3190', '3190', NULL, '1849', 'S', 1468, 'CALDAS', 'N', '311030', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '113', NULL, '03', 'N', NULL, NULL, NULL, 291);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311040', '3115', 'MG', '3105', '3109', '31044', '31', 'CAMACHO', NULL, '37', '35555000', '0', '4207', '4207', '11104', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 222.218, '-20,62500', '-45,15700', 957, 'S', 0.6980, NULL, NULL, '31033', 'S', 'N', 904, NULL, '3190', '3190', NULL, '1962', 'S', 1469, 'CAMACHO', 'N', '311040', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '114', NULL, '03', 'N', NULL, NULL, NULL, 235);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311050', '3110', 'MG', '3101', '3110', '31052', '31', 'CAMANDUCAIA', NULL, '35', '37650000', '9', '4209', '4209', '11105', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 527.572, '-22,75500', '-46,14500', 1048, 'S', 0.7750, NULL, NULL, '31007', 'N', 'N', 907, NULL, '3190', '3190', NULL, '1840', 'S', 1470, 'CAMANDUCAIA', 'N', '311050', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '115', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311060', '3110', 'MG', '3101', '3110', '31052', '31', 'CAMBUI', NULL, '35', '37600000', '8', '4211', '4211', '11106', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 242.859, '-22,61200', '-46,05800', 907, 'S', 0.7860, NULL, NULL, '31007', 'N', 'N', 918, NULL, '3190', '3190', NULL, '1889', 'S', 1471, 'CAMBUÍ', 'N', '311060', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '116', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311070', '3111', 'MG', '3101', '3110', '31054', '31', 'CAMBUQUIRA', NULL, '35', '37420000', '7', '4213', '4213', '11107', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 245.792, '-21,85200', '-45,29600', 950, 'S', 0.7880, NULL, NULL, '31010', 'N', 'N', 919, NULL, '3190', '3190', NULL, '1911', 'S', 1472, 'CAMBUQUIRA', 'N', '311070', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '117', NULL, '03', 'N', NULL, NULL, NULL, 293);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311080', '3117', 'MG', '3111', '3108', '31037', '31', 'CAMPANARIO', NULL, '33', '39835000', '6', '4215', '4215', '11108', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 441.421, '-18,23900', '-41,74800', 268, 'S', 0.6680, NULL, NULL, '31069', 'S', 'N', 923, NULL, '3190', '3190', NULL, '1962', 'S', 1473, 'CAMPANÁRIO', 'N', '311080', 'N', 'S', 'S', NULL, 99, 'N', 'N', 'N', '118', NULL, '03', 'N', NULL, NULL, NULL, 292);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311090', '3111', 'MG', '3101', '3110', '31050', '31', 'CAMPANHA', NULL, '35', '37400000', '5', '4217', '4217', '11109', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 336.033, '-21,83600', '-45,40100', 928, 'S', 0.7840, NULL, NULL, '31010', 'N', 'N', 924, NULL, '3190', '3190', NULL, '1798', 'S', 1474, 'CAMPANHA', 'N', '311090', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '119', NULL, '03', 'N', NULL, NULL, NULL, 293);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311100', '3121', 'MG', '3101', '3110', '31051', '31', 'CAMPESTRE', NULL, '35', '37730000', '2', '4219', '4219', '11110', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 577.152, '-21,71100', '-46,24600', 1076, 'S', 0.7590, NULL, NULL, '31001', 'N', 'N', 926, NULL, '3190', '3190', NULL, '1911', 'S', 1475, 'CAMPESTRE', 'N', '311100', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '120', NULL, '03', 'N', NULL, NULL, NULL, 300);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311110', '3125', 'MG', '3113', '3105', '31021', '31', 'CAMPINA VERDE', NULL, '34', '38270000', '1', '4221', '4221', '11111', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3663.418, '-19,53600', '-49,48600', 494, 'S', 0.7950, NULL, NULL, '31073', 'N', 'N', 936, NULL, '3190', '3190', NULL, '1938', 'S', 1476, 'CAMPINA VERDE', 'N', '311110', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '121', NULL, '03', 'N', NULL, NULL, NULL, 17);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311115', '3129', 'MG', '3108', '3102', '31007', '31', 'CAMPO AZUL', NULL, '38', '39338000', '0', '0580', NULL, '11778', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 506.463, '-16,50400', '-44,81100', 600, 'S', 0.6500, NULL, NULL, '31049', 'S', 'N', 948, NULL, '3190', '3190', NULL, '1997', 'S', 1477, 'CAMPO AZUL', 'N', '311115', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '122', NULL, '03', 'N', NULL, NULL, NULL, 243);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311120', '3115', 'MG', '3105', '3109', '31045', '31', 'CAMPO BELO', NULL, '35', '37270000', '0', '4223', '4223', '11112', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 526.753, '-20,89700', '-45,27700', 945, 'S', 0.7760, NULL, NULL, '31033', 'N', 'N', 949, NULL, '3190', '3190', NULL, '1876', 'S', 1478, 'CAMPO BELO', 'N', '311120', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '123', NULL, '02', 'N', NULL, NULL, NULL, 235);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311130', '3121', 'MG', '3101', '3110', '31050', '31', 'CAMPO DO MEIO', NULL, '35', '37165000', '9', '4225', '4225', '11113', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 273.830, '-21,10700', '-45,83000', 785, 'S', 0.7490, NULL, NULL, '31001', 'N', 'N', 954, NULL, '3190', '3190', NULL, '1948', 'S', 1479, 'CAMPO DO MEIO', 'N', '311130', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '124', NULL, '03', 'N', NULL, NULL, NULL, 300);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311140', '3113', 'MG', '3112', '3105', '31022', '31', 'CAMPO FLORIDO', NULL, '34', '38130000', '8', '4227', '4227', '11114', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1261.726, '-19,76100', '-48,57200', 642, 'S', 0.7580, NULL, NULL, '31072', 'N', 'N', 957, NULL, '3190', '3190', NULL, '1938', 'S', 1480, 'CAMPO FLORIDO', 'N', '311140', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '125', NULL, '03', 'N', NULL, NULL, NULL, 349);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311150', '3113', 'MG', '3112', '3105', '31023', '31', 'CAMPOS ALTOS', NULL, '37', '38970000', '7', '4229', '4229', '11115', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 719.121, '-19,69600', '-46,17100', 1050, 'S', 0.7860, NULL, NULL, '31070', 'N', 'N', 974, NULL, '3190', '3190', NULL, '1943', 'S', 1481, 'CAMPOS ALTOS', 'N', '311150', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '126', NULL, '03', 'N', NULL, NULL, NULL, 240);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311160', '3121', 'MG', '3101', '3110', '31050', '31', 'CAMPOS GERAIS', NULL, '35', '37160000', '6', '4231', '4231', '11116', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 769.207, '-21,23500', '-45,75900', 843, 'S', 0.7510, NULL, NULL, '31001', 'N', 'N', 980, NULL, '3190', '3190', NULL, '1901', 'S', 1482, 'CAMPOS GERAIS', 'N', '311160', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '127', NULL, '03', 'N', NULL, NULL, NULL, 300);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311170', '3108', 'MG', '3110', '3112', '31062', '31', 'CANAA', NULL, '31', '36592000', '5', '4233', '4233', '11117', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 175.066, '-20,68600', '-42,62000', 718, 'S', 0.6780, NULL, NULL, '31061', 'S', 'N', 989, NULL, '3190', '3190', NULL, '1962', 'S', 1484, 'CANAÃ', 'N', '311170', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '129', NULL, '03', 'N', NULL, NULL, NULL, 117);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311180', '3125', 'MG', '3113', '3105', '31018', '31', 'CANAPOLIS', NULL, '34', '38380000', '4', '4235', '4235', '11118', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 845.238, '-18,72500', '-49,20400', 662, 'S', 0.7550, NULL, NULL, '31073', 'N', 'N', 994, NULL, '3190', '3190', NULL, '1948', 'S', 1485, 'CANÁPOLIS', 'N', '311180', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '130', NULL, '03', 'N', NULL, NULL, NULL, 17);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311190', '3115', 'MG', '3105', '3109', '31045', '31', 'CANA VERDE', NULL, '35', '37267000', '3', '4237', '4237', '11119', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 212.367, '-21,02100', '-45,18200', 867, 'S', 0.7470, NULL, NULL, '31033', 'N', 'N', 988, NULL, '3190', '3190', NULL, '1962', 'S', 1483, 'CANA VERDE', 'N', '311190', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '128', NULL, '03', 'N', NULL, NULL, NULL, 235);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311200', '3115', 'MG', '3105', '3109', '31045', '31', 'CANDEIAS', NULL, '35', '37280000', '0', '4239', '4239', '11120', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 720.650, '-20,76700', '-45,27600', 967, 'S', 0.7230, NULL, NULL, '31033', 'N', 'N', 1002, NULL, '3190', '3190', NULL, '1938', 'S', 1486, 'CANDEIAS', 'N', '311200', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '131', NULL, '03', 'N', NULL, NULL, NULL, 235);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311205', '3116', 'MG', '3106', '3108', '31036', '31', 'CANTAGALO', NULL, '33', '39703000', '9', '0582', NULL, '11779', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 141.839, '-18,52600', '-42,62700', 650, 'S', 0.6740, NULL, NULL, '31039', 'S', 'N', 1028, NULL, '3190', '3190', NULL, '1997', 'S', 1487, 'CANTAGALO', 'N', '311205', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '132', NULL, '03', 'N', NULL, NULL, NULL, 179);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311210', '3124', 'MG', '3107', '3112', '31061', '31', 'CAPARAO', NULL, '32', '36834000', '9', '4241', '4241', '11121', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 130.064, '-20,52100', '-41,90700', 850, 'S', 0.7160, NULL, NULL, '31042', 'N', 'N', 1040, NULL, '3190', '3190', NULL, '1962', 'S', 1488, 'CAPARAÓ', 'N', '311210', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '133', NULL, '03', 'N', NULL, NULL, NULL, 412);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311220', '3103', 'MG', '3102', '3111', '31059', '31', 'CAPELA NOVA', NULL, '31', '36290000', '8', '4243', '4243', '11122', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 110.955, '-20,92300', '-43,61800', 825, 'S', 0.7120, NULL, NULL, '31013', 'N', 'N', 1046, NULL, '3190', '3190', NULL, '1953', 'S', 1489, 'CAPELA NOVA', 'N', '311220', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '134', NULL, '03', 'N', NULL, NULL, NULL, 241);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311230', '3104', 'MG', '3104', '3103', '31011', '31', 'CAPELINHA', NULL, '33', '39680000', '7', '4245', '4245', '11123', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 965.901, '-17,69100', '-42,51600', 948, 'S', 0.6730, NULL, NULL, '31027', 'N', 'N', 1047, NULL, '3190', '3190', NULL, '1911', 'S', 1490, 'CAPELINHA', 'N', '311230', 'N', 'S', 'S', NULL, 5, 'N', 'N', 'N', '135', NULL, '03', 'N', NULL, NULL, NULL, 67);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311240', '3122', 'MG', '3101', '3110', '31047', '31', 'CAPETINGA', NULL, '35', '37993000', '6', '4247', '4247', '11124', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 296.722, '-20,61600', '-47,05400', 792, 'S', 0.7640, NULL, NULL, '31005', 'N', 'N', 1048, NULL, '3190', '3190', NULL, '1938', 'S', 1491, 'CAPETINGA', 'N', '311240', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '136', NULL, '03', 'N', NULL, NULL, NULL, 361);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311250', '3114', 'MG', '3103', '3107', '31027', '31', 'CAPIM BRANCO', NULL, '31', '35730000', '5', '4249', '4249', '11125', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 94.147, '-19,54900', '-44,11700', 830, 'S', 0.7510, NULL, NULL, '31024', 'N', 'N', 1050, NULL, '3101', '3101', NULL, '1953', 'S', 1492, 'CAPIM BRANCO', 'N', '311250', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '137', NULL, '01', 'N', NULL, NULL, NULL, 58);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311260', '3125', 'MG', '3113', '3105', '31017', '31', 'CAPINOPOLIS', NULL, '34', '38360000', '4', '4251', '4251', '11126', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 621.159, '-18,68200', '-49,57000', 564, 'S', 0.7660, NULL, NULL, '31073', 'N', 'N', 1052, NULL, '3190', '3190', NULL, '1953', 'S', 1493, 'CAPINÓPOLIS', 'N', '311260', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '138', NULL, '03', 'N', NULL, NULL, NULL, 17);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311265', '3116', 'MG', '3106', '3108', '31037', '31', 'CAPITAO ANDRADE', NULL, '33', '35123000', '3', '2651', '2651', '11727', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 275.603, '-19,06700', '-41,85800', 230, 'S', 0.6760, NULL, NULL, '31036', 'S', 'N', 1057, NULL, '3190', '3190', NULL, '1993', 'S', 1494, 'CAPITÃO ANDRADE', 'N', '311265', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '139', NULL, '03', 'N', NULL, NULL, NULL, 189);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311270', '3106', 'MG', '3108', '3102', '31007', '31', 'CAPITAO ENEAS', NULL, '38', '39445000', '3', '4253', '4253', '11127', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 970.341, '-16,32400', '-43,71100', 571, 'S', 0.6670, NULL, NULL, '31051', 'S', 'N', 1059, NULL, '3190', '3190', NULL, '1962', 'S', 1495, 'CAPITÃO ENÉAS', 'N', '311270', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '140', NULL, '03', 'N', NULL, NULL, NULL, 301);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311280', '3122', 'MG', '3101', '3110', '31047', '31', 'CAPITOLIO', NULL, '37', '37930000', '2', '4255', '4255', '11128', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 522.079, '-20,61500', '-46,05000', 766, 'S', 0.7850, NULL, NULL, '31005', 'N', 'N', 1063, NULL, '3190', '3190', NULL, '1948', 'S', 1496, 'CAPITÓLIO', 'N', '311280', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '141', NULL, '03', 'N', NULL, NULL, NULL, 361);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311290', '3124', 'MG', '3110', '3112', '31061', '31', 'CAPUTIRA', NULL, '31', '36925000', '1', '4257', '4257', '11129', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 188.112, '-20,17200', '-42,27100', 592, 'S', 0.6930, NULL, NULL, '31059', 'S', 'N', 1069, NULL, '3190', '3190', NULL, '1962', 'S', 1497, 'CAPUTIRA', 'N', '311290', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '142', NULL, '03', 'N', NULL, NULL, NULL, 191);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311300', '3117', 'MG', '3111', '3103', '31012', '31', 'CARAI', NULL, '33', '39810000', '8', '4259', '4259', '11130', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 1240.160, '-17,18900', '-41,69500', 910, 'S', 0.6360, NULL, NULL, '31067', 'S', 'N', 1075, NULL, '3190', '3190', NULL, '1948', 'S', 1498, 'CARAÍ', 'N', '311300', 'N', 'S', 'S', NULL, 99, 'N', 'N', 'N', '143', NULL, '03', 'N', NULL, NULL, NULL, 20);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311310', '3103', 'MG', '3102', '3111', '31059', '31', 'CARANAIBA', NULL, '31', '36428000', '7', '4261', '4261', '11131', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 160.022, '-20,87600', '-43,73900', 822, 'S', 0.7060, NULL, NULL, '31014', 'N', 'N', 1078, NULL, '3190', '3190', NULL, '1962', 'S', 1499, 'CARANAÍBA', 'N', '311310', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '144', NULL, '03', 'N', NULL, NULL, NULL, 187);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311320', '3103', 'MG', '3102', '3111', '31059', '31', 'CARANDAI', NULL, '32', '36280000', '6', '4263', '4263', '11132', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 486.409, '-20,95400', '-43,80600', 1080, 'S', 0.7600, NULL, NULL, '31013', 'N', 'N', 1079, NULL, '3190', '3190', NULL, '1923', 'S', 1500, 'CARANDAÍ', 'N', '311320', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '145', NULL, '03', 'N', NULL, NULL, NULL, 241);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311330', '3124', 'MG', '3107', '3112', '31063', '31', 'CARANGOLA', NULL, '32', '36800000', '5', '4265', '4265', '11133', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 352.510, '-20,73300', '-42,02900', 408, 'S', 0.7830, NULL, NULL, '31042', 'N', 'N', 1080, NULL, '3190', '3190', NULL, '1878', 'S', 1501, 'CARANGOLA', 'N', '311330', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '146', NULL, '03', 'N', NULL, NULL, NULL, 412);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311340', '3123', 'MG', '3106', '3108', '31040', '31', 'CARATINGA', NULL, '33', '35300970', '4', '4267', '4267', '11134', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1250.874, '-19,79000', '-42,13900', 578, 'S', 0.7540, NULL, NULL, '31034', 'N', 'N', 1083, NULL, '3190', '3190', NULL, '1890', 'S', 1502, 'CARATINGA', 'N', '311340', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '147', NULL, '02', 'N', NULL, NULL, NULL, 14);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311350', '3104', 'MG', '3104', '3103', '31011', '31', 'CARBONITA', NULL, '38', '39665000', '3', '4269', '4269', '11135', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 1454.935, '-17,52700', '-43,01600', 726, 'S', 0.6790, NULL, NULL, '31026', 'S', 'N', 1090, NULL, '3190', '3190', NULL, '1962', 'S', 1503, 'CARBONITA', 'N', '311350', 'N', 'S', 'S', NULL, 5, 'N', 'N', 'N', '148', NULL, '03', 'N', NULL, NULL, NULL, 126);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311360', '3110', 'MG', '3101', '3110', '31053', '31', 'CAREACU', NULL, '35', '37556000', '2', '4271', '4271', '11136', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 181.297, '-22,04300', '-45,69900', 816, 'S', 0.7700, NULL, NULL, '31007', 'N', 'N', 1094, NULL, '3190', '3190', NULL, '1953', 'S', 1504, 'CAREAÇU', 'N', '311360', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '149', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311370', '3117', 'MG', '3111', '3104', '31016', '31', 'CARLOS CHAGAS', NULL, '33', '39864000', '1', '4273', '4273', '11137', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 3198.853, '-17,70300', '-40,76600', 159, 'S', 0.6810, NULL, NULL, '31066', 'S', 'N', 1109, NULL, '3190', '3190', NULL, '1938', 'S', 1505, 'CARLOS CHAGAS', 'N', '311370', 'N', 'S', 'S', NULL, 99, 'N', 'N', 'N', '150', NULL, '03', 'N', NULL, NULL, NULL, 304);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311380', '3109', 'MG', '3103', '3108', '31035', '31', 'CARMESIA', NULL, '31', '35878000', '0', '4275', '4275', '11138', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 258.533, '-19,08900', '-43,14200', 551, 'S', 0.6980, NULL, NULL, '31020', 'S', 'N', 1111, NULL, '3190', '3190', NULL, '1962', 'S', 1506, 'CARMÉSIA', 'N', '311380', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '151', NULL, '03', 'N', NULL, NULL, NULL, 245);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311390', '3111', 'MG', '3101', '3110', '31050', '31', 'CARMO DA CACHOEIRA', NULL, '35', '37225000', '9', '4277', '4277', '11139', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 505.947, '-21,46100', '-45,22400', 945, 'S', 0.7450, NULL, NULL, '31010', 'N', 'N', 1113, NULL, '3190', '3190', NULL, '1938', 'S', 1507, 'CARMO DA CACHOEIRA', 'N', '311390', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '152', NULL, '03', 'N', NULL, NULL, NULL, 293);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311400', '3115', 'MG', '3105', '3109', '31046', '31', 'CARMO DA MATA', NULL, '37', '35547000', '6', '4279', '4279', '11140', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 356.658, '-20,55800', '-44,87100', 846, 'S', 0.7430, NULL, NULL, '31033', 'N', 'N', 1114, NULL, '3190', '3190', NULL, '1938', 'S', 1508, 'CARMO DA MATA', 'N', '311400', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '153', NULL, '03', 'N', NULL, NULL, NULL, 235);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311410', '3111', 'MG', '3101', '3110', '31054', '31', 'CARMO DE MINAS', NULL, '35', '37472000', '5', '4281', '4281', '11141', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 323.321, '-22,12200', '-45,12900', 958, 'S', 0.7440, NULL, NULL, '31008', 'N', 'N', 1115, NULL, '3190', '3190', NULL, '1901', 'S', 1509, 'CARMO DE MINAS', 'N', '311410', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '154', NULL, '03', 'N', NULL, NULL, NULL, 57);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311420', '3115', 'MG', '3105', '3109', '31043', '31', 'CARMO DO CAJURU', NULL, '37', '35510000', '4', '4283', '4283', '11142', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 455.005, '-20,18400', '-44,77100', 772, 'S', 0.7740, NULL, NULL, '31029', 'N', 'N', 1116, NULL, '3190', '3190', NULL, '1948', 'S', 1510, 'CARMO DO CAJURU', 'N', '311420', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '155', NULL, '03', 'N', NULL, NULL, NULL, 413);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311430', '3107', 'MG', '3109', '3105', '31020', '31', 'CARMO DO PARANAIBA', NULL, '34', '38840000', '3', '4285', '4285', '11143', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1307.119, '-19,00100', '-46,31600', 1061, 'S', 0.7920, NULL, NULL, '31057', 'N', 'N', 1117, NULL, '3190', '3190', NULL, '1873', 'S', 1511, 'CARMO DO PARANAÍBA', 'N', '311430', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '156', NULL, '03', 'N', NULL, NULL, NULL, 194);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311440', '3121', 'MG', '3101', '3110', '31049', '31', 'CARMO DO RIO CLARO', NULL, '35', '37150000', '2', '4287', '4287', '11144', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1064.790, '-20,97200', '-46,11900', 830, 'S', 0.7720, NULL, NULL, '31001', 'N', 'N', 1118, NULL, '3190', '3190', NULL, '1875', 'S', 1512, 'CARMO DO RIO CLARO', 'N', '311440', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '157', NULL, '03', 'N', NULL, NULL, NULL, 300);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311450', '3115', 'MG', '3105', '3109', '31046', '31', 'CARMOPOLIS DE MINAS', NULL, '37', '35534000', '1', '4289', '4289', '11145', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 400.621, '-20,54100', '-44,63500', 903, 'S', 0.7490, NULL, NULL, '31033', 'N', 'N', 1122, NULL, '3190', '3190', NULL, '1948', 'S', 1513, 'CARMÓPOLIS DE MINAS', 'N', '311450', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '158', NULL, '03', 'N', NULL, NULL, NULL, 235);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311455', '3113', 'MG', '3112', '3105', '31021', '31', 'CARNEIRINHO', NULL, '34', '38290000', '0', '2685', '2685', '11728', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2060.720, '-19,69800', '-50,68800', 431, 'S', 0.7630, NULL, NULL, '31071', 'N', 'N', 1128, NULL, '3190', '3190', NULL, '1993', 'S', 1514, 'CARNEIRINHO', 'N', '311455', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '159', NULL, '03', 'N', NULL, NULL, NULL, 244);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311460', '3111', 'MG', '3101', '3111', '31057', '31', 'CARRANCAS', NULL, '35', '37245000', '0', '4291', '4291', '11146', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 727.822, '-21,48800', '-44,64300', 1052, 'S', 0.7500, NULL, NULL, '31004', 'N', 'N', 1133, NULL, '3190', '3190', NULL, '1948', 'S', 1515, 'CARRANCAS', 'N', '311460', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '160', NULL, '03', 'N', NULL, NULL, NULL, 19);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311470', '3121', 'MG', '3101', '3110', '31049', '31', 'CARVALHOPOLIS', NULL, '35', '37760000', '9', '4293', '4293', '11147', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 80.703, '-21,77800', '-45,84100', 868, 'S', 0.7730, NULL, NULL, '31001', 'N', 'N', 1138, NULL, '3190', '3190', NULL, '1953', 'S', 1516, 'CARVALHÓPOLIS', 'N', '311470', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '161', NULL, '03', 'N', NULL, NULL, NULL, 300);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311480', '3111', 'MG', '3101', '3110', '31055', '31', 'CARVALHOS', NULL, '35', '37456000', '8', '4295', '4295', '11148', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 282.587, '-22,00100', '-44,46100', 1092, 'S', 0.7180, NULL, NULL, '31008', 'N', 'N', 1139, NULL, '3190', '3190', NULL, '1948', 'S', 1517, 'CARVALHOS', 'N', '311480', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '162', NULL, '03', 'N', NULL, NULL, NULL, 57);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311490', '3103', 'MG', '3102', '3107', '31034', '31', 'CASA GRANDE', NULL, '31', '36422000', '7', '4297', '4297', '11149', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 157.994, '-20,79300', '-43,93000', 972, 'S', 0.7110, NULL, NULL, '31014', 'N', 'N', 1141, NULL, '3190', '3190', NULL, '1962', 'S', 1518, 'CASA GRANDE', 'N', '311490', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '163', NULL, '03', 'N', NULL, NULL, NULL, 187);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311500', '3112', 'MG', '3113', '3105', '31018', '31', 'CASCALHO RICO', NULL, '34', '38460000', '3', '4299', '4299', '11150', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 367.732, '-18,57600', '-47,87700', 709, 'S', 0.7880, NULL, NULL, '31075', 'N', 'N', 1144, NULL, '3190', '3190', NULL, '1948', 'S', 1519, 'CASCALHO RICO', 'N', '311500', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '164', NULL, '03', 'N', NULL, NULL, NULL, 116);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311510', '3122', 'MG', '3101', '3110', '31047', '31', 'CASSIA', NULL, '35', '37980000', '2', '4301', '4301', '11151', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 643.866, '-20,58300', '-46,92200', 738, 'S', 0.7770, NULL, NULL, '31005', 'N', 'N', 1152, NULL, '3190', '3190', NULL, '1890', 'S', 1520, 'CÁSSIA', 'N', '311510', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '165', NULL, '03', 'N', NULL, NULL, NULL, 361);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312738', '3105', 'MG', '3107', '3112', '31065', '31', 'GOIANA', NULL, '32', '36152000', '8', '0620', NULL, '11797', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 153.229, '-21,53700', '-43,20200', 410, 'S', 0.7410, NULL, NULL, '31043', 'N', 'N', 1897, NULL, '3190', '3190', NULL, '1997', 'S', 1666, 'GOIANÁ', 'N', '312738', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '311', NULL, '03', 'N', NULL, NULL, NULL, 360);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311520', '3120', 'MG', '3102', '3111', '31058', '31', 'CONCEICAO DA BARRA DE MINAS', NULL, '32', '36360000', '1', '4303', '4303', '11152', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 273.048, '-21,12900', '-44,47200', 928, 'S', 0.7010, NULL, NULL, '31015', 'N', 'N', 1311, NULL, '3190', '3190', NULL, '1962', 'S', 1544, 'CONCEIÇÃO DA BARRA DE MINAS', 'N', '311520', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '189', NULL, '03', 'N', NULL, NULL, NULL, 114);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311530', '3127', 'MG', '3107', '3112', '31066', '31', 'CATAGUASES', NULL, '32', '36770000', '0', '4305', '4305', '11153', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 482.325, '-21,38900', '-42,69700', 169, 'S', 0.7940, NULL, NULL, '31044', 'N', 'N', 1164, NULL, '3190', '3190', NULL, '1875', 'S', 1521, 'CATAGUASES', 'N', '311530', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '166', NULL, '02', 'N', NULL, NULL, NULL, 246);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311535', '3109', 'MG', '3103', '3107', '31031', '31', 'CATAS ALTAS', NULL, '31', '35969000', '9', '0584', NULL, '11780', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 240.223, '-20,07500', '-43,40800', 752, 'S', 0.7560, NULL, NULL, '31021', 'N', 'N', 1170, NULL, '3190', '3190', NULL, '1997', 'S', 1522, 'CATAS ALTAS', 'N', '311535', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '167', NULL, '03', 'N', NULL, NULL, NULL, 190);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311640', '3122', 'MG', '3101', '3110', '31047', '31', 'CLARAVAL', NULL, '34', '37997000', '7', '4327', '4327', '11164', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 210.715, '-20,39900', '-47,26700', 749, 'S', 0.7400, NULL, NULL, '31005', 'N', 'N', 1264, NULL, '3190', '3190', NULL, '1953', 'S', 1536, 'CLARAVAL', 'N', '311640', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '181', NULL, '03', 'N', NULL, NULL, NULL, 361);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311540', '3103', 'MG', '3102', '3107', '31034', '31', 'CATAS ALTAS DA NORUEGA', NULL, '31', '36450000', '9', '4307', '4307', '11154', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 143.366, '-20,69000', '-43,49800', 752, 'S', 0.6730, NULL, NULL, '31014', 'S', 'N', 1171, NULL, '3190', '3190', NULL, '1962', 'S', 1523, 'CATAS ALTAS DA NORUEGA', 'N', '311540', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '168', NULL, '03', 'N', NULL, NULL, NULL, 187);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311545', '3117', 'MG', '3111', '3104', '31015', '31', 'CATUJI', NULL, '33', '39816000', '8', '2653', '2653', '11729', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 421.016, '-17,31200', '-41,51700', 625, 'S', 0.6210, NULL, NULL, '31067', 'S', 'N', 1179, NULL, '3190', '3190', NULL, '1993', 'S', 1524, 'CATUJI', 'N', '311545', 'N', 'S', 'S', NULL, 99, 'S', 'N', 'N', '169', NULL, '03', 'N', NULL, NULL, NULL, 20);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311547', '3106', 'MG', '3108', '3102', '31004', '31', 'CATUTI', NULL, '38', '39526000', '4', '0586', NULL, '11781', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 285.988, '-15,35800', '-42,96300', 530, 'S', 0.6050, NULL, NULL, '31052', 'S', 'N', 1184, NULL, '3190', '3190', NULL, '1997', 'S', 1525, 'CATUTI', 'N', '311547', 'N', 'S', 'S', NULL, 79, 'N', 'N', 'N', '170', NULL, '03', 'N', NULL, NULL, NULL, 128);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311550', '3111', 'MG', '3101', '3110', '31054', '31', 'CAXAMBU', NULL, '35', '37440000', '8', '4309', '4309', '11155', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 100.203, '-21,97700', '-44,93300', 895, 'S', 0.7960, NULL, NULL, '31008', 'N', 'N', 1187, NULL, '3190', '3190', NULL, '1901', 'S', 1526, 'CAXAMBU', 'N', '311550', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '171', NULL, '03', 'N', NULL, NULL, NULL, 57);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311560', '3114', 'MG', '3103', '3106', '31024', '31', 'CEDRO DO ABAETE', NULL, '37', '35624000', '7', '4311', '4311', '11156', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 279.906, '-19,14800', '-45,71100', 935, 'S', 0.7480, NULL, NULL, '31024', 'N', 'N', 1198, NULL, '3190', '3190', NULL, '1962', 'S', 1527, 'CEDRO DO ABAETÉ', 'N', '311560', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '172', NULL, '03', 'N', NULL, NULL, NULL, 58);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311570', '3116', 'MG', '3106', '3108', '31038', '31', 'CENTRAL DE MINAS', NULL, '33', '35260000', '6', '4313', '4313', '11157', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 203.675, '-18,76200', '-41,30600', 242, 'S', 0.6920, NULL, NULL, '31038', 'S', 'N', 1204, NULL, '3190', '3190', NULL, '1962', 'S', 1528, 'CENTRAL DE MINAS', 'N', '311570', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '173', NULL, '03', 'N', NULL, NULL, NULL, 66);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311580', '3125', 'MG', '3113', '3105', '31018', '31', 'CENTRALINA', NULL, '34', '38390000', '5', '4315', '4315', '11158', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 321.985, '-18,58400', '-49,19900', 531, 'S', 0.7500, NULL, NULL, '31073', 'N', 'N', 1206, NULL, '3190', '3190', NULL, '1953', 'S', 1529, 'CENTRALINA', 'N', '311580', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '174', NULL, '03', 'N', NULL, NULL, NULL, 17);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311590', '3105', 'MG', '3107', '3112', '31065', '31', 'CHACARA', NULL, '32', '36110000', '4', '4317', '4317', '11159', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 152.874, '-21,67200', '-43,22200', 800, 'S', 0.7240, NULL, NULL, '31043', 'N', 'N', 1227, NULL, '3190', '3190', NULL, '1962', 'S', 1530, 'CHÁCARA', 'N', '311590', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '175', NULL, '03', 'N', NULL, NULL, NULL, 360);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311600', '3124', 'MG', '3110', '3112', '31061', '31', 'CHALE', NULL, '33', '36985000', '1', '4319', '4319', '11160', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 212.513, '-20,04400', '-41,68800', 370, 'S', 0.7200, NULL, NULL, '31059', 'N', 'N', 1228, NULL, '3190', '3190', NULL, '1962', 'S', 1531, 'CHALÉ', 'N', '311600', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '176', NULL, '03', 'N', NULL, NULL, NULL, 191);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311610', '3104', 'MG', '3104', '3103', '31011', '31', 'CHAPADA DO NORTE', NULL, '33', '39648000', '0', '4321', '4321', '11161', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 827.958, '-17,08700', '-42,53500', 597, 'S', 0.6410, NULL, NULL, '31027', 'S', 'N', 1232, NULL, '3190', '3190', NULL, '1962', 'S', 1532, 'CHAPADA DO NORTE', 'N', '311610', 'N', 'S', 'S', NULL, 57, 'N', 'N', 'N', '177', NULL, '03', 'N', NULL, NULL, NULL, 67);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311615', '3126', 'MG', '3109', '3102', '31003', '31', 'CHAPADA GAUCHA', NULL, '38', '39314000', '9', '0588', NULL, '11782', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3214.698, '-15,30600', '-45,61800', 858, 'S', 0.6830, NULL, NULL, '31058', 'S', 'N', 1234, NULL, '3190', '3190', NULL, '1997', 'S', 1533, 'CHAPADA GAÚCHA', 'N', '311615', 'N', 'S', 'S', NULL, 63, 'N', 'N', 'N', '178', NULL, '03', 'N', NULL, NULL, NULL, 295);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311620', '3105', 'MG', '3107', '3112', '31065', '31', 'CHIADOR', NULL, '32', '36630000', '9', '4323', '4323', '11162', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 252.346, '-22,00300', '-43,05800', 332, 'S', 0.7190, NULL, NULL, '31043', 'N', 'N', 1246, NULL, '3190', '3190', NULL, '1953', 'S', 1534, 'CHIADOR', 'N', '311620', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '179', NULL, '03', 'N', NULL, NULL, NULL, 360);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311630', '3103', 'MG', '3102', '3112', '31062', '31', 'CIPOTANEA', NULL, '32', '36265000', '8', '4325', '4325', '11163', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 153.435, '-20,90500', '-43,36600', 660, 'S', 0.6430, NULL, NULL, '31013', 'S', 'N', 1262, NULL, '3190', '3190', NULL, '1953', 'S', 1535, 'CIPOTÂNEA', 'N', '311630', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '180', NULL, '03', 'N', NULL, NULL, NULL, 241);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311650', '3106', 'MG', '3108', '3102', '31007', '31', 'CLARO DOS POCOES', NULL, '38', '39380000', '6', '4329', '4329', '11165', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 705.965, '-17,08000', '-44,20900', 632, 'S', 0.6850, NULL, NULL, '31054', 'S', 'N', 1265, NULL, '3190', '3190', NULL, '1962', 'S', 1537, 'CLARO DOS POÇÕES', 'N', '311650', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '182', NULL, '03', 'N', NULL, NULL, NULL, 192);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311660', '3115', 'MG', '3105', '3109', '31043', '31', 'CLAUDIO', NULL, '37', '35530000', '5', '4331', '4331', '11166', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 630.278, '-20,44300', '-44,76600', 832, 'S', 0.7350, NULL, NULL, '31029', 'N', 'N', 1267, NULL, '3190', '3190', NULL, '1911', 'S', 1538, 'CLÁUDIO', 'N', '311660', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '183', NULL, '03', 'N', NULL, NULL, NULL, 413);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311670', '3118', 'MG', '3107', '3112', '31062', '31', 'COIMBRA', NULL, '32', '36550000', '4', '4333', '4333', '11167', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 106.834, '-20,85700', '-42,80300', 720, 'S', 0.7560, NULL, NULL, '31048', 'N', 'N', 1282, NULL, '3190', '3190', NULL, '1948', 'S', 1539, 'COIMBRA', 'N', '311670', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '184', NULL, '03', 'N', NULL, NULL, NULL, 181);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311680', '3104', 'MG', '3104', '3108', '31035', '31', 'COLUNA', NULL, '33', '39770000', '3', '4335', '4335', '11168', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 347.610, '-18,23400', '-42,84000', 691, 'S', 0.6560, NULL, NULL, '31026', 'S', 'N', 1302, NULL, '3190', '3190', NULL, '1953', 'S', 1540, 'COLUNA', 'N', '311680', 'N', 'N', 'S', NULL, 5, 'N', 'N', 'N', '185', NULL, '03', 'N', NULL, NULL, NULL, 126);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311690', '3113', 'MG', '3112', '3105', '31021', '31', 'COMENDADOR GOMES', NULL, '34', '38250000', '2', '4337', '4337', '11169', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1042.882, '-19,69800', '-49,08100', 557, 'S', 0.7950, NULL, NULL, '31071', 'N', 'N', 1304, NULL, '3190', '3190', NULL, '1948', 'S', 1541, 'COMENDADOR GOMES', 'N', '311690', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '186', NULL, '03', 'N', NULL, NULL, NULL, 244);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311700', '3119', 'MG', '3111', '3103', '31013', '31', 'COMERCINHO', NULL, '33', '39628000', '9', '4339', '4339', '11170', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 656.563, '-16,29600', '-41,79300', 620, 'S', 0.6030, NULL, NULL, '31065', 'S', 'N', 1306, NULL, '3190', '3190', NULL, '1948', 'S', 1542, 'COMERCINHO', 'N', '311700', 'N', 'S', 'S', NULL, 57, 'N', 'N', 'N', '187', NULL, '03', 'N', NULL, NULL, NULL, 127);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311995', '3115', 'MG', '3105', '3109', '31044', '31', 'CORREGO FUNDO', NULL, '37', '35578000', '5', '0594', NULL, '11785', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 105.387, '-20,44900', '-45,55500', 844, 'S', 0.7300, NULL, NULL, '31030', 'N', 'N', 1397, NULL, '3190', '3190', NULL, '1997', 'S', 1575, 'CÓRREGO FUNDO', 'N', '311995', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '220', NULL, '03', 'N', NULL, NULL, NULL, 15);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311710', '3121', 'MG', '3101', '3110', '31049', '31', 'CONCEICAO DA APARECIDA', NULL, '35', '37148000', '8', '4341', '4341', '11171', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 349.489, '-21,09400', '-46,20400', 985, 'S', 0.7840, NULL, NULL, '31001', 'N', 'N', 1309, NULL, '3190', '3190', NULL, '1943', 'S', 1543, 'CONCEIÇÃO DA APARECIDA', 'N', '311710', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '188', NULL, '03', 'N', NULL, NULL, NULL, 300);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311720', '3110', 'MG', '3101', '3110', '31053', '31', 'CONCEICAO DAS PEDRAS', NULL, '35', '37527000', '7', '4343', '4343', '11172', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 101.562, '-22,16000', '-45,45500', 1068, 'S', 0.7510, NULL, NULL, '31003', 'N', 'N', 1314, NULL, '3190', '3190', NULL, '1962', 'S', 1546, 'CONCEIÇÃO DAS PEDRAS', 'N', '311720', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '191', NULL, '03', 'N', NULL, NULL, NULL, 16);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311730', '3113', 'MG', '3112', '3105', '31022', '31', 'CONCEICAO DAS ALAGOAS', NULL, '34', '38120000', '6', '4345', '4345', '11173', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1348.222, '-19,91500', '-48,38800', 509, 'S', 0.7670, NULL, NULL, '31072', 'N', 'N', 1313, NULL, '3190', '3190', NULL, '1938', 'S', 1545, 'CONCEIÇÃO DAS ALAGOAS', 'N', '311730', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '190', NULL, '03', 'N', NULL, NULL, NULL, 349);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311740', '3124', 'MG', '3110', '3108', '31041', '31', 'CONCEICAO DE IPANEMA', NULL, '33', '36947000', '5', '4347', '4347', '11174', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 254.513, '-19,92800', '-41,69400', 294, 'S', 0.7040, NULL, NULL, '31059', 'N', 'N', 1315, NULL, '3190', '3190', NULL, '1953', 'S', 1547, 'CONCEIÇÃO DE IPANEMA', 'N', '311740', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '192', NULL, '03', 'N', NULL, NULL, NULL, 191);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311760', '3115', 'MG', '3105', '3109', '31043', '31', 'CONCEICAO DO PARA', NULL, '37', '35668000', '3', '4351', '4351', '11176', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 249.409, '-19,75300', '-44,89700', 650, 'S', 0.7490, NULL, NULL, '31032', 'N', 'N', 1325, NULL, '3190', '3190', NULL, '1962', 'S', 1549, 'CONCEIÇÃO DO PARÁ', 'N', '311760', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '194', NULL, '03', 'N', NULL, NULL, NULL, 131);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311770', '3111', 'MG', '3101', '3110', '31054', '31', 'CONCEICAO DO RIO VERDE', NULL, '35', '37430000', '2', '4353', '4353', '11177', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 370.040, '-21,88100', '-45,08500', 880, 'S', 0.7470, NULL, NULL, '31008', 'N', 'N', 1326, NULL, '3190', '3190', NULL, '1911', 'S', 1550, 'CONCEIÇÃO DO RIO VERDE', 'N', '311770', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '195', NULL, '03', 'N', NULL, NULL, NULL, 57);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311780', '3110', 'MG', '3101', '3110', '31053', '31', 'CONCEICAO DOS OUROS', NULL, '35', '37548000', '1', '4355', '4355', '11178', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 182.673, '-22,41300', '-45,79800', 863, 'S', 0.7570, NULL, NULL, '31007', 'N', 'N', 1328, NULL, '3190', '3190', NULL, '1948', 'S', 1551, 'CONCEIÇÃO DOS OUROS', 'N', '311780', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '196', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311783', '3129', 'MG', '3108', '3102', '31003', '31', 'CONEGO MARINHO', NULL, '38', '39489000', '6', '0590', NULL, '11783', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1617.916, '-15,29400', '-44,41800', 637, 'S', 0.6390, NULL, NULL, '31053', 'S', 'N', 1339, NULL, '3190', '3190', NULL, '1997', 'S', 1552, 'CÔNEGO MARINHO', 'N', '311783', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '197', NULL, '03', 'N', NULL, NULL, NULL, 129);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311787', '3101', 'MG', '3103', '3107', '31030', '31', 'CONFINS', NULL, '31', '33500000', '6', '0592', NULL, '11784', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 42.008, '-19,63300', '-43,98300', 750, 'S', 0.7730, NULL, NULL, '31025', 'N', 'N', 1340, NULL, '3101', '3101', NULL, '1997', 'S', 1553, 'CONFINS', 'N', '311787', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '198', NULL, '01', 'N', NULL, NULL, NULL, 404);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311790', '3110', 'MG', '3101', '3110', '31052', '31', 'CONGONHAL', NULL, '35', '37557000', '0', '4357', '4357', '11179', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 205.756, '-22,15300', '-46,03900', 862, 'S', 0.7260, NULL, NULL, '31007', 'N', 'N', 1343, NULL, '3190', '3190', NULL, '1953', 'S', 1554, 'CONGONHAL', 'N', '311790', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '199', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311800', '3103', 'MG', '3102', '3107', '31034', '31', 'CONGONHAS', NULL, '31', '36415000', '7', '4359', '4359', '11180', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 305.579, '-20,50000', '-43,85800', 871, 'S', 0.7880, NULL, NULL, '31014', 'N', 'N', 1344, NULL, '3190', '3190', NULL, '1938', 'S', 1555, 'CONGONHAS', 'N', '311800', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '200', NULL, '03', 'N', NULL, NULL, NULL, 187);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311810', '3104', 'MG', '3104', '3107', '31028', '31', 'CONGONHAS DO NORTE', NULL, '31', '35850000', '6', '4361', '4361', '11181', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 483.002, '-18,80700', '-43,68100', 1050, 'S', 0.6550, NULL, NULL, '31026', 'S', 'N', 1345, NULL, '3190', '3190', NULL, '1962', 'S', 1556, 'CONGONHAS DO NORTE', 'N', '311810', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '201', NULL, '03', 'N', NULL, NULL, NULL, 126);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311820', '3113', 'MG', '3112', '3105', '31022', '31', 'CONQUISTA', NULL, '34', '38195000', '5', '4363', '4363', '11182', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 616.211, '-19,93700', '-47,54200', 673, 'S', 0.7790, NULL, NULL, '31072', 'N', 'N', 1347, NULL, '3190', '3190', NULL, '1911', 'S', 1557, 'CONQUISTA', 'N', '311820', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '202', NULL, '03', 'N', NULL, NULL, NULL, 349);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311830', '3103', 'MG', '3102', '3107', '31034', '31', 'CONSELHEIRO LAFAIETE', NULL, '31', '36400000', '4', '4365', '4365', '11183', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 369.544, '-20,66000', '-43,78600', 995, 'S', 0.7930, NULL, NULL, '31014', 'N', 'N', 1348, NULL, '3190', '3190', NULL, '1790', 'S', 1558, 'CONSELHEIRO LAFAIETE', 'N', '311830', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '203', NULL, '01', 'N', NULL, NULL, NULL, 187);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311840', '3116', 'MG', '3106', '3108', '31041', '31', 'CONSELHEIRO PENA', NULL, '33', '35240000', '3', '4367', '4367', '11184', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1408.017, '-19,17200', '-41,47200', 121, 'S', 0.7340, NULL, NULL, '31040', 'N', 'N', 1350, NULL, '3190', '3190', NULL, '1938', 'S', 1559, 'CONSELHEIRO PENA', 'N', '311840', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '204', NULL, '03', 'N', NULL, NULL, NULL, 403);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311850', '3110', 'MG', '3101', '3110', '31056', '31', 'CONSOLACAO', NULL, '35', '37670000', '2', '4369', '4369', '11185', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 85.936, '-22,55100', '-45,92100', 1035, 'S', 0.7030, NULL, NULL, '31003', 'N', 'N', 1351, NULL, '3190', '3190', NULL, '1962', 'S', 1560, 'CONSOLAÇÃO', 'N', '311850', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '205', NULL, '03', 'N', NULL, NULL, NULL, 16);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311860', '3101', 'MG', '3103', '3107', '31030', '31', 'CONTAGEM', NULL, '31', '32161970', '1', '4371', '4371', '11186', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 194.586, '-19,93200', '-44,05400', 902, 'S', 0.7890, NULL, NULL, '31018', 'N', 'N', 1353, NULL, '3101', '3101', NULL, '1948', 'S', 1561, 'CONTAGEM', 'N', '311860', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '206', NULL, '01', 'N', NULL, NULL, NULL, 188);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311870', '3111', 'MG', '3101', '3110', '31050', '31', 'COQUEIRAL', NULL, '35', '37235000', '0', '4373', '4373', '11187', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 296.556, '-21,18900', '-45,44100', 867, 'S', 0.7520, NULL, NULL, '31011', 'N', 'N', 1356, NULL, '3190', '3190', NULL, '1948', 'S', 1562, 'COQUEIRAL', 'N', '311870', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '207', NULL, '03', 'N', NULL, NULL, NULL, 294);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311880', '3106', 'MG', '3108', '3102', '31007', '31', 'CORACAO DE JESUS', NULL, '38', '39340000', '9', '4375', '4375', '11188', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 2236.236, '-16,68500', '-44,36500', 760, 'S', 0.6870, NULL, NULL, '31050', 'S', 'N', 1359, NULL, '3190', '3190', NULL, '1911', 'S', 1563, 'CORAÇÃO DE JESUS', 'N', '311880', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '208', NULL, '03', 'N', NULL, NULL, NULL, 63);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311890', '3114', 'MG', '3103', '3107', '31027', '31', 'CORDISBURGO', NULL, '31', '35780000', '8', '4377', '4377', '11189', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 823.215, '-19,12500', '-44,32100', 720, 'S', 0.7330, NULL, NULL, '31024', 'N', 'N', 1366, NULL, '3190', '3190', NULL, '1938', 'S', 1564, 'CORDISBURGO', 'N', '311890', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '209', NULL, '03', 'N', NULL, NULL, NULL, 58);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311900', '3111', 'MG', '3101', '3110', '31053', '31', 'CORDISLANDIA', NULL, '35', '37498000', '5', '4379', '4379', '11190', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 179.220, '-21,79300', '-45,70100', 819, 'S', 0.7500, NULL, NULL, '31012', 'N', 'N', 1367, NULL, '3190', '3190', NULL, '1962', 'S', 1565, 'CORDISLÂNDIA', 'N', '311900', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '210', NULL, '03', 'N', NULL, NULL, NULL, 59);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311910', '3114', 'MG', '3103', '3106', '31025', '31', 'CORINTO', NULL, '38', '39200000', '4', '4381', '4381', '11191', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2524.503, '-18,38100', '-44,45600', 636, 'S', 0.7220, NULL, NULL, '31019', 'N', 'N', 1372, NULL, '3190', '3190', NULL, '1923', 'S', 1566, 'CORINTO', 'N', '311910', 'N', 'N', 'S', NULL, 48, 'N', 'N', 'N', '211', NULL, '03', 'N', NULL, NULL, NULL, 65);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311920', '3116', 'MG', '3106', '3108', '31037', '31', 'COROACI', NULL, '33', '39710000', '3', '4383', '4383', '11192', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 576.700, '-18,62200', '-42,28600', 467, 'S', 0.6990, NULL, NULL, '31036', 'S', 'N', 1374, NULL, '3190', '3190', NULL, '1948', 'S', 1567, 'COROACI', 'N', '311920', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '212', NULL, '03', 'N', NULL, NULL, NULL, 189);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311930', '3112', 'MG', '3113', '3105', '31019', '31', 'COROMANDEL', NULL, '34', '38550000', '2', '4385', '4385', '11193', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3296.267, '-18,47300', '-47,20000', 976, 'S', 0.7860, NULL, NULL, '31074', 'N', 'N', 1377, NULL, '3190', '3190', NULL, '1923', 'S', 1568, 'COROMANDEL', 'N', '311930', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '213', NULL, '03', 'N', NULL, NULL, NULL, 247);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311940', '3123', 'MG', '3106', '3108', '31039', '31', 'CORONEL FABRICIANO', NULL, '31', '35135970', '1', '4387', '4387', '11194', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 221.049, '-19,51900', '-42,62900', 250, 'S', 0.7890, NULL, NULL, '31035', 'N', 'N', 1382, NULL, '3103', '3103', NULL, '1948', 'S', 1569, 'CORONEL FABRICIANO', 'N', '311940', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '214', NULL, '01', 'N', NULL, NULL, NULL, 64);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311950', '3104', 'MG', '3104', '3103', '31012', '31', 'CORONEL MURTA', NULL, '33', '39635000', '0', '4389', '4389', '11195', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'N', 'S', NULL, 'N', 813.853, '-16,61900', '-42,18200', 322, 'S', 0.6730, NULL, NULL, '31064', 'S', 'N', 1389, NULL, '3190', '3190', NULL, '1953', 'S', 1570, 'CORONEL MURTA', 'N', '311950', 'N', 'S', 'S', NULL, 57, 'N', 'N', 'N', '215', NULL, '03', 'N', NULL, NULL, NULL, 357);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311960', '3105', 'MG', '3107', '3112', '31065', '31', 'CORONEL PACHECO', NULL, '32', '36155000', '9', '4391', '4391', '11196', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 130.287, '-21,58800', '-43,26600', 484, 'S', 0.7360, NULL, NULL, '31043', 'N', 'N', 1390, NULL, '3190', '3190', NULL, '1962', 'S', 1571, 'CORONEL PACHECO', 'N', '311960', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '216', NULL, '03', 'N', NULL, NULL, NULL, 360);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311970', '3120', 'MG', '3102', '3111', '31058', '31', 'CORONEL XAVIER CHAVES', NULL, '32', '36330000', '8', '4393', '4393', '11197', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 141.137, '-21,02400', '-44,22300', 931, 'S', 0.7310, NULL, NULL, '31015', 'N', 'N', 1393, NULL, '3190', '3190', NULL, '1962', 'S', 1572, 'CORONEL XAVIER CHAVES', 'N', '311970', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '217', NULL, '03', 'N', NULL, NULL, NULL, 114);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311980', '3115', 'MG', '3105', '3109', '31042', '31', 'CORREGO DANTA', NULL, '37', '38990000', '7', '4395', '4395', '11198', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 644.920, '-19,82400', '-45,90400', 648, 'S', 0.7520, NULL, NULL, '31030', 'N', 'N', 1394, NULL, '3190', '3190', NULL, '1948', 'S', 1573, 'CÓRREGO DANTA', 'N', '311980', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '218', NULL, '03', 'N', NULL, NULL, NULL, 15);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311990', '3110', 'MG', '3101', '3110', '31052', '31', 'CORREGO DO BOM JESUS', NULL, '35', '37605000', '6', '4397', '4397', '11199', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 123.263, '-22,63000', '-46,02000', 911, 'S', 0.7350, NULL, NULL, '31007', 'N', 'N', 1395, NULL, '3190', '3190', NULL, '1953', 'S', 1574, 'CÓRREGO DO BOM JESUS', 'N', '311990', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '219', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312000', '3123', 'MG', '3106', '3108', '31040', '31', 'CORREGO NOVO', NULL, '33', '35345000', '3', '4399', '4399', '11200', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 198.035, '-19,83200', '-42,39600', 425, 'S', 0.6770, NULL, NULL, '31035', 'S', 'N', 1398, NULL, '3104', '3190', NULL, '1962', 'S', 1576, 'CÓRREGO NOVO', 'N', '312000', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '221', NULL, '03', 'N', NULL, NULL, NULL, 64);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312010', '3104', 'MG', '3104', '3103', '31010', '31', 'COUTO DE MAGALHAES DE MINAS', NULL, '38', '39188000', '2', '4401', '4401', '11201', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 484.045, '-18,07100', '-43,47100', 726, 'S', 0.7120, NULL, NULL, '31026', 'N', 'N', 1421, NULL, '3190', '3190', NULL, '1962', 'S', 1577, 'COUTO DE MAGALHÃES DE MINAS', 'N', '312010', 'N', 'S', 'S', NULL, 5, 'N', 'N', 'N', '222', NULL, '03', 'N', NULL, NULL, NULL, 126);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312015', '3117', 'MG', '3111', '3104', '31016', '31', 'CRISOLITA', NULL, '33', '39885000', '1', '0596', NULL, '11786', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 969.804, '-17,23700', '-40,91200', 282, 'S', 0.5860, NULL, NULL, '31062', 'S', 'N', 1431, NULL, '3190', '3190', NULL, '1997', 'S', 1578, 'CRISÓLITA', 'N', '312015', 'N', 'S', 'S', NULL, 99, 'S', 'N', 'N', '223', NULL, '03', 'N', NULL, NULL, NULL, 62);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312020', '3115', 'MG', '3105', '3109', '31045', '31', 'CRISTAIS', NULL, '35', '37275000', '1', '4403', '4403', '11202', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 627.704, '-20,87600', '-45,51900', 873, 'S', 0.7540, NULL, NULL, '31033', 'N', 'N', 1434, NULL, '3190', '3190', NULL, '1948', 'S', 1579, 'CRISTAIS', 'N', '312020', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '224', NULL, '03', 'N', NULL, NULL, NULL, 235);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312030', '3106', 'MG', '3108', '3102', '31008', '31', 'CRISTALIA', NULL, '38', '39598000', '0', '4405', '4405', '11203', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 840.673, '-16,80000', '-42,86200', 728, 'S', 0.6470, NULL, NULL, '31051', 'S', 'N', 1440, NULL, '3190', '3190', NULL, '1962', 'S', 1580, 'CRISTÁLIA', 'N', '312030', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '225', NULL, '03', 'N', NULL, NULL, NULL, 301);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312040', '3103', 'MG', '3102', '3107', '31034', '31', 'CRISTIANO OTONI', NULL, '31', '36426000', '9', '4407', '4407', '11204', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 132.869, '-20,83200', '-43,80600', 1005, 'S', 0.7380, NULL, NULL, '31014', 'N', 'N', 1442, NULL, '3190', '3190', NULL, '1962', 'S', 1581, 'CRISTIANO OTONI', 'N', '312040', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '226', NULL, '03', 'N', NULL, NULL, NULL, 187);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312050', '3111', 'MG', '3101', '3110', '31056', '31', 'CRISTINA', NULL, '35', '37476000', '8', '4409', '4409', '11205', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 311.925, '-22,21200', '-45,26400', 1025, 'S', 0.7280, NULL, NULL, '31008', 'N', 'N', 1444, NULL, '3190', '3190', NULL, '1850', 'S', 1582, 'CRISTINA', 'N', '312050', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '227', NULL, '03', 'N', NULL, NULL, NULL, 57);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312060', '3101', 'MG', '3103', '3107', '31032', '31', 'CRUCILANDIA', NULL, '31', '35520000', '7', '4411', '4411', '11206', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 166.451, '-20,38400', '-44,33700', 908, 'S', 0.7180, NULL, NULL, '31017', 'N', 'N', 1452, NULL, '3190', '3190', NULL, '1948', 'S', 1583, 'CRUCILÂNDIA', 'N', '312060', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '228', NULL, '03', 'N', NULL, NULL, NULL, 242);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312070', '3107', 'MG', '3109', '3105', '31019', '31', 'CRUZEIRO DA FORTALEZA', NULL, '34', '38738000', '6', '4413', '4413', '11207', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 185.505, '-18,94600', '-46,67400', 859, 'S', 0.7950, NULL, NULL, '31057', 'N', 'N', 1460, NULL, '3190', '3190', NULL, '1962', 'S', 1584, 'CRUZEIRO DA FORTALEZA', 'N', '312070', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '229', NULL, '03', 'N', NULL, NULL, NULL, 194);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312080', '3111', 'MG', '3101', '3110', '31055', '31', 'CRUZILIA', NULL, '35', '37445000', '5', '4415', '4415', '11208', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 523.470, '-21,83900', '-44,80800', 1010, 'S', 0.7450, NULL, NULL, '31008', 'N', 'N', 1467, NULL, '3190', '3190', NULL, '1948', 'S', 1585, 'CRUZÍLIA', 'N', '312080', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '230', NULL, '03', 'N', NULL, NULL, NULL, 57);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312083', '3116', 'MG', '3106', '3108', '31041', '31', 'CUPARAQUE', NULL, '33', '35246000', '9', '0598', NULL, '11787', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 227.030, '-18,96900', '-41,09900', 180, 'S', 0.7100, NULL, NULL, '31038', 'N', 'N', 1483, NULL, '3190', '3190', NULL, '1997', 'S', 1586, 'CUPARAQUE', 'N', '312083', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '231', NULL, '03', 'N', NULL, NULL, NULL, 403);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312087', '3106', 'MG', '3108', '3102', '31005', '31', 'CURRAL DE DENTRO', NULL, '33', '39998000', '0', '0600', NULL, '11788', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 570.503, '-15,93800', '-41,84400', 890, 'S', 0.5970, NULL, NULL, '31056', 'S', 'N', 1494, NULL, '3190', '3190', NULL, '1997', 'S', 1587, 'CURRAL DE DENTRO', 'N', '312087', 'N', 'S', 'S', NULL, 7, 'N', 'N', 'N', '232', NULL, '03', 'N', NULL, NULL, NULL, 348);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312090', '3114', 'MG', '3103', '3106', '31025', '31', 'CURVELO', NULL, '38', '35790000', '4', '4417', '4417', '11209', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3295.894, '-18,75600', '-44,43100', 632, 'S', 0.7550, NULL, NULL, '31019', 'N', 'N', 1502, NULL, '3190', '3190', NULL, '1831', 'S', 1588, 'CURVELO', 'N', '312090', 'N', 'N', 'S', NULL, 48, 'N', 'N', 'N', '233', NULL, '02', 'N', NULL, NULL, NULL, 65);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312100', '3104', 'MG', '3104', '3103', '31010', '31', 'DATAS', NULL, '38', '39130000', '1', '4419', '4419', '11210', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 309.013, '-18,44600', '-43,65600', 1231, 'S', 0.6940, NULL, NULL, '31026', 'S', 'N', 1510, NULL, '3190', '3190', NULL, '1962', 'S', 1589, 'DATAS', 'N', '312100', 'N', 'S', 'S', NULL, 5, 'N', 'N', 'N', '234', NULL, '03', 'N', NULL, NULL, NULL, 126);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312110', '3110', 'MG', '3101', '3110', '31056', '31', 'DELFIM MOREIRA', NULL, '35', '37514000', '0', '4421', '4421', '11211', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 408.181, '-22,50900', '-45,28000', 1200, 'S', 0.7200, NULL, NULL, '31003', 'N', 'N', 1514, NULL, '3190', '3190', NULL, '1938', 'S', 1590, 'DELFIM MOREIRA', 'N', '312110', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '235', NULL, '03', 'N', NULL, NULL, NULL, 16);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312120', '3122', 'MG', '3101', '3110', '31047', '31', 'DELFINOPOLIS', NULL, '35', '37910000', '9', '4423', '4423', '11212', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1374.969, '-20,34400', '-46,85400', 684, 'S', 0.7520, NULL, NULL, '31005', 'N', 'N', 1515, NULL, '3190', '3190', NULL, '1938', 'S', 1591, 'DELFINÓPOLIS', 'N', '312120', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '236', NULL, '03', 'N', NULL, NULL, NULL, 361);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312125', '3113', 'MG', '3112', '3105', '31022', '31', 'DELTA', NULL, '34', '38108000', '8', '0602', '0602', '11789', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 104.472, '-19,97700', '-47,77100', 500, 'S', 0.7500, NULL, NULL, '31072', 'N', 'N', 1517, NULL, '3190', '3190', NULL, '1997', 'S', 1592, 'DELTA', 'N', '312125', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '237', NULL, '03', 'N', NULL, NULL, NULL, 349);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312130', '3105', 'MG', '3107', '3112', '31065', '31', 'DESCOBERTO', NULL, '32', '36690000', '8', '4425', '4425', '11213', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 213.198, '-21,46000', '-42,96800', 340, 'S', 0.7480, NULL, NULL, '31047', 'N', 'N', 1525, NULL, '3190', '3190', NULL, '1953', 'S', 1593, 'DESCOBERTO', 'N', '312130', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '238', NULL, '03', 'N', NULL, NULL, NULL, 115);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312140', '3120', 'MG', '3102', '3107', '31034', '31', 'DESTERRO DE ENTRE RIOS', NULL, '31', '35494000', '7', '4427', '4427', '11214', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 370.122, '-20,66000', '-44,33300', 1052, 'S', 0.7040, NULL, NULL, '31014', 'N', 'N', 1527, NULL, '3190', '3190', NULL, '1953', 'S', 1594, 'DESTERRO DE ENTRE RIOS', 'N', '312140', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '239', NULL, '03', 'N', NULL, NULL, NULL, 187);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312150', '3103', 'MG', '3102', '3111', '31059', '31', 'DESTERRO DO MELO', NULL, '32', '36210000', '6', '4429', '4429', '11215', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 142.455, '-21,14700', '-43,51800', 818, 'S', 0.6890, NULL, NULL, '31013', 'S', 'N', 1528, NULL, '3190', '3190', NULL, '1962', 'S', 1595, 'DESTERRO DO MELO', 'N', '312150', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '240', NULL, '03', 'N', NULL, NULL, NULL, 241);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312160', '3104', 'MG', '3104', '3103', '31010', '31', 'DIAMANTINA', NULL, '38', '39100000', '5', '4431', '4431', '11216', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 3869.830, '-18,24900', '-43,60000', 1113, 'S', 0.7480, NULL, NULL, '31026', 'N', 'N', 1535, NULL, '3190', '3190', NULL, '1831', 'S', 1596, 'DIAMANTINA', 'N', '312160', 'N', 'S', 'S', NULL, 5, 'N', 'N', 'N', '241', NULL, '03', 'N', NULL, NULL, NULL, 126);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312170', '3108', 'MG', '3110', '3107', '31033', '31', 'DIOGO DE VASCONCELOS', NULL, '31', '35437000', '4', '4433', '4433', '11217', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 165.035, '-20,48800', '-43,19800', 592, 'S', 0.6600, NULL, NULL, '31060', 'S', 'N', 1540, NULL, '3190', '3190', NULL, '1962', 'S', 1597, 'DIOGO DE VASCONCELOS', 'N', '312170', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '242', NULL, '03', 'N', NULL, NULL, NULL, 347);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312180', '3123', 'MG', '3106', '3107', '31031', '31', 'DIONISIO', NULL, '31', '35984000', '3', '4435', '4435', '11218', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 343.422, '-19,84300', '-42,77700', 355, 'S', 0.6810, NULL, NULL, '31035', 'S', 'N', 1541, NULL, '3104', '3190', NULL, '1948', 'S', 1598, 'DIONÍSIO', 'N', '312180', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '243', NULL, '03', 'N', NULL, NULL, NULL, 64);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312190', '3118', 'MG', '3107', '3112', '31064', '31', 'DIVINESIA', NULL, '32', '36546000', '2', '4437', '4437', '11219', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 118.361, '-20,99000', '-43,00400', 753, 'S', 0.7240, NULL, NULL, '31048', 'N', 'N', 1547, NULL, '3190', '3190', NULL, '1962', 'S', 1599, 'DIVINÉSIA', 'N', '312190', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '244', NULL, '03', 'N', NULL, NULL, NULL, 181);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312200', '3124', 'MG', '3107', '3112', '31063', '31', 'DIVINO', NULL, '32', '36820000', '9', '4439', '4439', '11220', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 338.716, '-20,61400', '-42,14900', 660, 'S', 0.6920, NULL, NULL, '31042', 'S', 'N', 1548, NULL, '3190', '3190', NULL, '1938', 'S', 1600, 'DIVINO', 'N', '312200', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '245', NULL, '03', 'N', NULL, NULL, NULL, 412);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312210', '3116', 'MG', '3106', '3108', '31037', '31', 'DIVINO DAS LARANJEIRAS', NULL, '33', '35265000', '8', '4441', '4441', '11221', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 342.629, '-18,77800', '-41,48000', 240, 'S', 0.7030, NULL, NULL, '31038', 'N', 'N', 1549, NULL, '3190', '3190', NULL, '1962', 'S', 1601, 'DIVINO DAS LARANJEIRAS', 'N', '312210', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '246', NULL, '03', 'N', NULL, NULL, NULL, 66);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312220', '3116', 'MG', '3106', '3108', '31035', '31', 'DIVINOLANDIA DE MINAS', NULL, '33', '39735000', '7', '4443', '4443', '11222', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 132.754, '-18,80400', '-42,59800', 748, 'S', 0.7050, NULL, NULL, '31036', 'N', 'N', 1552, NULL, '3190', '3190', NULL, '1962', 'S', 1602, 'DIVINOLÂNDIA DE MINAS', 'N', '312220', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '247', NULL, '03', 'N', NULL, NULL, NULL, 189);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312230', '3115', 'MG', '3105', '3109', '31043', '31', 'DIVINOPOLIS', NULL, '37', '35500970', '6', '4445', '4445', '11223', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 708.909, '-20,13900', '-44,88400', 712, 'S', 0.8310, NULL, NULL, '31029', 'N', 'N', 1553, NULL, '3190', '3190', NULL, '1911', 'S', 1603, 'DIVINÓPOLIS', 'N', '312230', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '248', NULL, '01', 'N', NULL, NULL, NULL, 413);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312235', '3119', 'MG', '3111', '3102', '31005', '31', 'DIVISA ALEGRE', NULL, '33', '39995000', '5', '0604', NULL, '11730', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 118.477, '-15,72600', '-41,34500', 975, 'S', 0.6560, NULL, NULL, '31068', 'S', 'N', 1556, NULL, '3190', '3190', NULL, '1997', 'S', 1604, 'DIVISA ALEGRE', 'N', '312235', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '249', NULL, '03', 'N', NULL, NULL, NULL, 21);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312240', '3121', 'MG', '3101', '3110', '31049', '31', 'DIVISA NOVA', NULL, '35', '37134000', '5', '4447', '4447', '11224', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 216.697, '-21,51100', '-46,19600', 877, 'S', 0.7350, NULL, NULL, '31001', 'N', 'N', 1557, NULL, '3190', '3190', NULL, '1938', 'S', 1605, 'DIVISA NOVA', 'N', '312240', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '250', NULL, '03', 'N', NULL, NULL, NULL, 300);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312245', '3119', 'MG', '3111', '3103', '31014', '31', 'DIVISOPOLIS', NULL, '33', '39912000', '4', '2657', '2657', '11731', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 566.070, '-15,72600', '-41,00000', 910, 'S', 0.6050, NULL, NULL, '31063', 'S', 'N', 1558, NULL, '3190', '3190', NULL, '1993', 'S', 1606, 'DIVISÓPOLIS', 'N', '312245', 'N', 'S', 'S', NULL, 117, 'N', 'N', 'N', '251', NULL, '03', 'N', NULL, NULL, NULL, 125);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312247', '3126', 'MG', '3109', '3101', '31001', '31', 'DOM BOSCO', NULL, '38', '38654000', '0', '0606', NULL, '11790', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 821.755, '-16,65200', '-46,27100', 610, 'S', 0.7500, NULL, NULL, '31058', 'N', 'N', 1571, NULL, '3190', '3190', NULL, '1997', 'S', 1607, 'DOM BOSCO', 'N', '312247', 'N', 'N', 'S', NULL, 63, 'N', 'N', 'N', '252', NULL, '03', 'N', NULL, NULL, NULL, 295);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312250', '3123', 'MG', '3106', '3108', '31040', '31', 'DOM CAVATI', NULL, '33', '35148000', '4', '4449', '4449', '11225', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 69.088, '-19,37400', '-42,10600', 358, 'S', 0.7310, NULL, NULL, '31037', 'N', 'N', 1572, NULL, '3104', '3190', NULL, '1962', 'S', 1608, 'DOM CAVATI', 'N', '312250', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '253', NULL, '03', 'N', NULL, NULL, NULL, 358);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312260', '3109', 'MG', '3103', '3107', '31028', '31', 'DOM JOAQUIM', NULL, '31', '35865000', '3', '4451', '4451', '11226', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 406.672, '-18,96700', '-43,25600', 546, 'S', 0.6520, NULL, NULL, '31020', 'S', 'N', 1577, NULL, '3190', '3190', NULL, '1938', 'S', 1609, 'DOM JOAQUIM', 'N', '312260', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '254', NULL, '03', 'N', NULL, NULL, NULL, 245);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312270', '3108', 'MG', '3110', '3112', '31060', '31', 'DOM SILVERIO', NULL, '31', '35440000', '2', '4453', '4453', '11227', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 194.956, '-20,16000', '-42,96800', 519, 'S', 0.7280, NULL, NULL, '31060', 'N', 'N', 1582, NULL, '3190', '3190', NULL, '1938', 'S', 1610, 'DOM SILVÉRIO', 'N', '312270', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '255', NULL, '03', 'N', NULL, NULL, NULL, 347);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312280', '3111', 'MG', '3101', '3110', '31056', '31', 'DOM VICOSO', NULL, '35', '37474000', '1', '4455', '4455', '11228', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 113.178, '-22,25400', '-45,16100', 923, 'S', 0.7150, NULL, NULL, '31008', 'N', 'N', 1583, NULL, '3190', '3190', NULL, '1953', 'S', 1611, 'DOM VIÇOSO', 'N', '312280', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '256', NULL, '03', 'N', NULL, NULL, NULL, 57);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312290', '3127', 'MG', '3107', '3112', '31066', '31', 'DONA EUSEBIA', NULL, '32', '36784000', '0', '4457', '4457', '11229', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 54.466, '-21,31600', '-42,81100', 222, 'S', 0.7430, NULL, NULL, '31044', 'N', 'N', 1587, NULL, '3190', '3190', NULL, '1962', 'S', 1612, 'DONA EUSÉBIA', 'N', '312290', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '257', NULL, '03', 'N', NULL, NULL, NULL, 246);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312300', '3120', 'MG', '3102', '3111', '31058', '31', 'DORES DE CAMPOS', NULL, '32', '36213000', '7', '4459', '4459', '11230', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 127.306, '-21,10900', '-44,02300', 931, 'S', 0.7600, NULL, NULL, '31015', 'N', 'N', 1590, NULL, '3190', '3190', NULL, '1938', 'S', 1613, 'DORES DE CAMPOS', 'N', '312300', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '258', NULL, '03', 'N', NULL, NULL, NULL, 114);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312310', '3109', 'MG', '3103', '3108', '31035', '31', 'DORES DE GUANHAES', NULL, '33', '35894000', '6', '4461', '4461', '11231', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 381.826, '-19,05800', '-42,92900', 497, 'S', 0.6660, NULL, NULL, '31020', 'S', 'N', 1591, NULL, '3190', '3190', NULL, '1962', 'S', 1614, 'DORES DE GUANHÃES', 'N', '312310', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '259', NULL, '03', 'N', NULL, NULL, NULL, 245);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312320', '3115', 'MG', '3105', '3106', '31026', '31', 'DORES DO INDAIA', NULL, '37', '35610000', '5', '4463', '4463', '11232', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1110.641, '-19,46300', '-45,60200', 723, 'S', 0.7520, NULL, NULL, '31028', 'N', 'N', 1592, NULL, '3190', '3190', NULL, '1880', 'S', 1615, 'DORES DO INDAIÁ', 'N', '312320', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '260', NULL, '03', 'N', NULL, NULL, NULL, 411);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312330', '3118', 'MG', '3107', '3112', '31064', '31', 'DORES DO TURVO', NULL, '32', '36513000', '4', '4465', '4465', '11233', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 231.285, '-20,97600', '-43,18900', 672, 'S', 0.7110, NULL, NULL, '31048', 'N', 'N', 1594, NULL, '3190', '3190', NULL, '1953', 'S', 1616, 'DORES DO TURVO', 'N', '312330', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '261', NULL, '03', 'N', NULL, NULL, NULL, 181);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312340', '3122', 'MG', '3101', '3109', '31042', '31', 'DORESOPOLIS', NULL, '37', '37926000', '3', '4467', '4467', '11234', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 153.087, '-20,28700', '-45,90300', 679, 'S', 0.7550, NULL, NULL, '31005', 'N', 'N', 1595, NULL, '3190', '3190', NULL, '1962', 'S', 1617, 'DORESÓPOLIS', 'N', '312340', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '262', NULL, '03', 'N', NULL, NULL, NULL, 361);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312350', '3112', 'MG', '3113', '3105', '31019', '31', 'DOURADOQUARA', NULL, '34', '38530000', '2', '4469', '4469', '11235', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 313.370, '-18,43100', '-47,60900', 713, 'S', 0.7760, NULL, NULL, '31074', 'N', 'N', 1600, NULL, '3190', '3190', NULL, '1962', 'S', 1618, 'DOURADOQUARA', 'N', '312350', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '263', NULL, '03', 'N', NULL, NULL, NULL, 247);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312352', '3124', 'MG', '3110', '3112', '31061', '31', 'DURANDE', NULL, '33', '36974000', '8', '2675', '2675', '11732', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 217.778, '-20,20300', '-41,79800', 705, 'S', 0.6750, NULL, NULL, '31059', 'S', 'N', 1617, NULL, '3190', '3190', NULL, '1993', 'S', 1619, 'DURANDÉ', 'N', '312352', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '264', NULL, '03', 'N', NULL, NULL, NULL, 191);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312360', '3111', 'MG', '3101', '3110', '31050', '31', 'ELOI MENDES', NULL, '35', '37110000', '1', '4471', '4471', '11236', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 498.366, '-21,61000', '-45,56500', 907, 'S', 0.7680, NULL, NULL, '31012', 'N', 'N', 1632, NULL, '3190', '3190', NULL, '1911', 'S', 1620, 'ELÓI MENDES', 'N', '312360', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '265', NULL, '03', 'N', NULL, NULL, NULL, 59);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312370', '3116', 'MG', '3106', '3108', '31037', '31', 'ENGENHEIRO CALDAS', NULL, '33', '35130000', '0', '4473', '4473', '11237', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 188.009, '-19,21900', '-42,04600', 231, 'S', 0.6610, NULL, NULL, '31036', 'S', 'N', 1644, NULL, '3190', '3190', NULL, '1962', 'S', 1621, 'ENGENHEIRO CALDAS', 'N', '312370', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '266', NULL, '03', 'N', NULL, NULL, NULL, 189);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312380', '3106', 'MG', '3108', '3102', '31009', '31', 'ENGENHEIRO NAVARRO', NULL, '38', '39417000', '9', '4475', '4475', '11238', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 631.974, '-17,28000', '-43,95000', 671, 'S', 0.6860, NULL, NULL, '31054', 'S', 'N', 1646, NULL, '3190', '3190', NULL, '1962', 'S', 1622, 'ENGENHEIRO NAVARRO', 'N', '312380', 'N', 'S', 'S', NULL, 48, 'N', 'N', 'N', '267', NULL, '03', 'N', NULL, NULL, NULL, 192);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312385', '3123', 'MG', '3106', '3108', '31040', '31', 'ENTRE FOLHAS', NULL, '33', '35324000', '8', '2663', NULL, '11733', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 85.870, '-19,62500', '-42,23100', 495, 'S', 0.7120, NULL, NULL, '31034', 'N', 'N', 1649, NULL, '3104', '3190', NULL, '1993', 'S', 1623, 'ENTRE FOLHAS', 'N', '312385', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '268', NULL, '03', 'N', NULL, NULL, NULL, 14);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312390', '3120', 'MG', '3102', '3107', '31034', '31', 'ENTRE RIOS DE MINAS', NULL, '31', '35490000', '8', '4477', '4477', '11239', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 462.816, '-20,67100', '-44,06600', 957, 'S', 0.7440, NULL, NULL, '31014', 'N', 'N', 1652, NULL, '3190', '3190', NULL, '1875', 'S', 1624, 'ENTRE RIOS DE MINAS', 'N', '312390', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '269', NULL, '03', 'N', NULL, NULL, NULL, 187);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312400', '3118', 'MG', '3107', '3112', '31062', '31', 'ERVALIA', NULL, '32', '36555000', '5', '4479', '4479', '11240', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 357.071, '-20,84000', '-42,65700', 730, 'S', 0.7000, NULL, NULL, '31048', 'N', 'N', 1668, NULL, '3190', '3190', NULL, '1938', 'S', 1625, 'ERVÁLIA', 'N', '312400', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '270', NULL, '03', 'N', NULL, NULL, NULL, 181);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312410', '3101', 'MG', '3103', '3107', '31030', '31', 'ESMERALDAS', NULL, '31', '35740000', '4', '4481', '4481', '11241', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 909.592, '-19,76300', '-44,31400', 760, 'S', 0.7480, NULL, NULL, '31017', 'N', 'N', 1671, NULL, '3101', '3101', NULL, '1901', 'S', 1626, 'ESMERALDAS', 'N', '312410', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '271', NULL, '01', 'N', NULL, NULL, NULL, 242);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312420', '3124', 'MG', '3107', '3112', '31063', '31', 'ESPERA FELIZ', NULL, '32', '36830000', '3', '4483', '4483', '11242', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 324.988, '-20,65000', '-41,90700', 772, 'S', 0.7000, NULL, NULL, '31042', 'S', 'N', 1672, NULL, '3190', '3190', NULL, '1938', 'S', 1627, 'ESPERA FELIZ', 'N', '312420', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '272', NULL, '03', 'N', NULL, NULL, NULL, 412);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312430', '3106', 'MG', '3108', '3102', '31004', '31', 'ESPINOSA', NULL, '38', '39510000', '2', '4485', '4485', '11243', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1876.401, '-14,92600', '-42,81900', 570, 'S', 0.6570, NULL, NULL, '31052', 'N', 'N', 1681, NULL, '3190', '3190', NULL, '1923', 'S', 1628, 'ESPINOSA', 'N', '312430', 'N', 'S', 'S', NULL, 79, 'N', 'N', 'N', '273', NULL, '03', 'N', NULL, NULL, NULL, 128);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312440', '3110', 'MG', '3101', '3110', '31052', '31', 'ESPIRITO SANTO DO DOURADO', NULL, '35', '37566000', '1', '4487', '4487', '11244', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 263.849, '-22,04600', '-45,95100', 907, 'S', 0.7420, NULL, NULL, '31007', 'N', 'N', 1683, NULL, '3190', '3190', NULL, '1962', 'S', 1629, 'ESPÍRITO SANTO DO DOURADO', 'N', '312440', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '274', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312450', '3110', 'MG', '3101', '3110', '31052', '31', 'ESTIVA', NULL, '35', '37542000', '0', '4489', '4489', '11245', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 245.295, '-22,46300', '-46,01700', 560, 'S', 0.7470, NULL, NULL, '31007', 'N', 'N', 1692, NULL, '3190', '3190', NULL, '1948', 'S', 1630, 'ESTIVA', 'N', '312450', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '275', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312460', '3127', 'MG', '3107', '3112', '31066', '31', 'ESTRELA DALVA', NULL, '32', '36725000', '9', '4491', '4491', '11246', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 131.877, '-21,74200', '-42,46100', 218, 'S', 0.7310, NULL, NULL, '31041', 'N', 'N', 1697, NULL, '3190', '3190', NULL, '1953', 'S', 1631, 'ESTRELA DALVA', 'N', '312460', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '276', NULL, '03', 'N', NULL, NULL, NULL, 409);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312470', '3115', 'MG', '3105', '3106', '31026', '31', 'ESTRELA DO INDAIA', NULL, '37', '35613000', '8', '4493', '4493', '11247', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 635.364, '-19,52200', '-45,78800', 721, 'S', 0.7380, NULL, NULL, '31028', 'N', 'N', 1699, NULL, '3190', '3190', NULL, '1948', 'S', 1632, 'ESTRELA DO INDAIÁ', 'N', '312470', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '277', NULL, '03', 'N', NULL, NULL, NULL, 411);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312480', '3112', 'MG', '3113', '3105', '31019', '31', 'ESTRELA DO SUL', NULL, '34', '38525000', '7', '4495', '4495', '11248', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 820.334, '-18,74600', '-47,69300', 765, 'S', 0.7470, NULL, NULL, '31074', 'N', 'N', 1702, NULL, '3190', '3190', NULL, '1856', 'S', 1633, 'ESTRELA DO SUL', 'N', '312480', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '278', NULL, '03', 'N', NULL, NULL, NULL, 247);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312490', '3118', 'MG', '3107', '3112', '31063', '31', 'EUGENOPOLIS', NULL, '32', '36855000', '6', '4497', '4497', '11249', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 310.538, '-21,09900', '-42,18700', 194, 'S', 0.7390, NULL, NULL, '31045', 'N', 'N', 1707, NULL, '3190', '3190', NULL, '1891', 'S', 1634, 'EUGENÓPOLIS', 'N', '312490', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '279', NULL, '03', 'N', NULL, NULL, NULL, 130);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312500', '3105', 'MG', '3107', '3112', '31065', '31', 'EWBANK DA CAMARA', NULL, '32', '36108000', '2', '4499', '4499', '11250', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 103.844, '-21,55100', '-43,51000', 778, 'S', 0.7150, NULL, NULL, '31043', 'N', 'N', 1710, NULL, '3190', '3190', NULL, '1962', 'S', 1635, 'EWBANK DA CÂMARA', 'N', '312500', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '280', NULL, '03', 'N', NULL, NULL, NULL, 360);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312510', '3110', 'MG', '3101', '3110', '31052', '31', 'EXTREMA', NULL, '35', '37640000', '1', '4501', '4501', '11251', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 243.099, '-22,85500', '-46,31800', 973, 'S', 0.7810, NULL, NULL, '31007', 'N', 'N', 1711, NULL, '3190', '3190', NULL, '1901', 'S', 1636, 'EXTREMA', 'N', '312510', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '281', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312520', '3121', 'MG', '3101', '3110', '31049', '31', 'FAMA', NULL, '35', '37138000', '0', '4503', '4503', '11252', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 86.132, '-21,40600', '-45,82900', 776, 'S', 0.7860, NULL, NULL, '31001', 'N', 'N', 1717, NULL, '3190', '3190', NULL, '1948', 'S', 1637, 'FAMA', 'N', '312520', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '282', NULL, '03', 'N', NULL, NULL, NULL, 300);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312530', '3124', 'MG', '3107', '3112', '31063', '31', 'FARIA LEMOS', NULL, '32', '36840000', '9', '4505', '4505', '11253', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 165.654, '-20,80800', '-42,03000', 380, 'S', 0.7160, NULL, NULL, '31042', 'N', 'N', 1718, NULL, '3190', '3190', NULL, '1953', 'S', 1638, 'FARIA LEMOS', 'N', '312530', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '283', NULL, '03', 'N', NULL, NULL, NULL, 412);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312540', '3104', 'MG', '3104', '3103', '31010', '31', 'FELICIO DOS SANTOS', NULL, '38', '39180000', '8', '4507', '4507', '11254', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'N', 'N', 'N', 'N', NULL, 'N', 358.862, '-18,07700', '-43,24700', 740, 'S', 0.6570, NULL, NULL, '31026', 'S', 'N', 1742, NULL, '3190', '3190', NULL, '1962', 'S', 1639, 'FELÍCIO DOS SANTOS', 'N', '312540', 'N', 'S', 'S', NULL, 5, 'N', 'N', 'N', '284', NULL, '03', 'N', NULL, NULL, NULL, 126);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312550', '3104', 'MG', '3104', '3103', '31010', '31', 'SAO GONCALO DO RIO PRETO', NULL, '38', '39185000', '7', '4509', '4509', '11255', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 313.218, '-18,00400', '-43,39100', 742, 'S', 0.6350, NULL, NULL, '31026', 'S', 'N', 4617, NULL, '3190', '3190', NULL, '1986', 'S', 2078, 'SÃO GONÇALO DO RIO PRETO', 'N', '312550', 'N', 'S', 'S', NULL, 5, 'N', 'N', 'N', '723', NULL, '03', 'N', NULL, NULL, NULL, 126);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312560', '3119', 'MG', '3111', '3103', '31014', '31', 'FELISBURGO', NULL, '33', '39895000', '6', '4511', '4511', '11256', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 593.962, '-16,63900', '-40,76100', 638, 'S', 0.6420, NULL, NULL, '31063', 'S', 'N', 1744, NULL, '3190', '3190', NULL, '1962', 'S', 1640, 'FELISBURGO', 'N', '312560', 'N', 'S', 'S', NULL, 117, 'N', 'N', 'N', '285', NULL, '03', 'N', NULL, NULL, NULL, 125);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312570', '3114', 'MG', '3103', '3106', '31025', '31', 'FELIXLANDIA', NULL, '38', '35794000', '5', '4513', '4513', '11257', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1553.352, '-18,75800', '-44,89900', 614, 'S', 0.7300, NULL, NULL, '31019', 'N', 'N', 1745, NULL, '3190', '3190', NULL, '1948', 'S', 1641, 'FELIXLÂNDIA', 'N', '312570', 'N', 'N', 'S', NULL, 48, 'N', 'N', 'N', '286', NULL, '03', 'N', NULL, NULL, NULL, 65);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312580', '3116', 'MG', '3106', '3108', '31037', '31', 'FERNANDES TOURINHO', NULL, '33', '35135000', '4', '4515', '4515', '11258', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 152.502, '-19,15400', '-42,08200', 250, 'S', 0.6720, NULL, NULL, '31036', 'S', 'N', 1751, NULL, '3190', '3190', NULL, '1962', 'S', 1642, 'FERNANDES TOURINHO', 'N', '312580', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '287', NULL, '03', 'N', NULL, NULL, NULL, 189);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312590', '3109', 'MG', '3103', '3107', '31031', '31', 'FERROS', NULL, '31', '35800000', '3', '4517', '4517', '11259', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1090.221, '-19,23200', '-43,02300', 425, 'S', 0.6790, NULL, NULL, '31021', 'S', 'N', 1761, NULL, '3190', '3190', NULL, '1884', 'S', 1643, 'FERROS', 'N', '312590', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '288', NULL, '03', 'N', NULL, NULL, NULL, 190);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312595', '3124', 'MG', '3107', '3112', '31063', '31', 'FERVEDOURO', NULL, '32', '36815000', '2', '2683', '2683', '11734', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 357.272, '-20,72600', '-42,27900', 697, 'S', 0.6860, NULL, NULL, '31042', 'S', 'N', 1762, NULL, '3190', '3190', NULL, '1993', 'S', 1644, 'FERVEDOURO', 'N', '312595', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '289', NULL, '03', 'N', NULL, NULL, NULL, 412);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312600', '3101', 'MG', '3103', '3107', '31029', '31', 'FLORESTAL', NULL, '31', '35690000', '0', '4519', '4519', '11260', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 194.356, '-19,88900', '-44,43300', 776, 'S', 0.7940, NULL, NULL, '31017', 'N', 'N', 1786, NULL, '3101', '3101', NULL, '1962', 'S', 1645, 'FLORESTAL', 'N', '312600', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '290', NULL, '01', 'N', NULL, NULL, NULL, 242);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312610', '3115', 'MG', '3105', '3109', '31044', '31', 'FORMIGA', NULL, '37', '35570000', '9', '4521', '4521', '11261', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1502.443, '-20,46400', '-45,42600', 841, 'S', 0.7930, NULL, NULL, '31030', 'N', 'N', 1796, NULL, '3190', '3190', NULL, '1839', 'S', 1646, 'FORMIGA', 'N', '312610', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '291', NULL, '02', 'N', NULL, NULL, NULL, 15);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312620', '3126', 'MG', '3109', '3101', '31001', '31', 'FORMOSO', NULL, '38', '38690000', '8', '4523', '4523', '11262', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3691.483, '-14,94700', '-46,23200', 839, 'S', 0.6950, NULL, NULL, '31058', 'S', 'N', 1803, NULL, '3190', '3190', NULL, '1962', 'S', 1647, 'FORMOSO', 'N', '312620', 'N', 'S', 'S', NULL, 63, 'N', 'N', 'N', '292', NULL, '03', 'N', NULL, NULL, NULL, 295);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312630', '3122', 'MG', '3101', '3110', '31047', '31', 'FORTALEZA DE MINAS', NULL, '35', '37905000', '7', '4525', '4525', '11263', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 218.854, '-20,84900', '-46,71800', 856, 'S', 0.7650, NULL, NULL, '31005', 'N', 'N', 1809, NULL, '3190', '3190', NULL, '1962', 'S', 1648, 'FORTALEZA DE MINAS', 'N', '312630', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '293', NULL, '03', 'N', NULL, NULL, NULL, 361);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312640', '3114', 'MG', '3103', '3107', '31027', '31', 'FORTUNA DE MINAS', NULL, '31', '35760000', '6', '4527', '4527', '11264', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 198.070, '-19,56100', '-44,44700', 740, 'S', 0.7160, NULL, NULL, '31024', 'N', 'N', 1815, NULL, '3102', '3190', NULL, '1962', 'S', 1649, 'FORTUNA DE MINAS', 'N', '312640', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '294', NULL, '03', 'N', NULL, NULL, NULL, 58);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312650', '3104', 'MG', '3104', '3103', '31011', '31', 'FRANCISCO BADARO', NULL, '33', '39644000', '5', '4529', '4529', '11265', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'S', 'N', NULL, 'N', 463.777, '-16,99300', '-42,35200', 398, 'S', 0.6460, NULL, NULL, '31064', 'S', 'N', 1823, NULL, '3190', '3190', NULL, '1962', 'S', 1650, 'FRANCISCO BADARÓ', 'N', '312650', 'N', 'S', 'S', NULL, 57, 'N', 'N', 'N', '295', NULL, '03', 'N', NULL, NULL, NULL, 357);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312660', '3106', 'MG', '3108', '3102', '31009', '31', 'FRANCISCO DUMONT', NULL, '38', '39387000', '4', '4531', '4531', '11266', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1553.326, '-17,31500', '-44,23400', 635, 'S', 0.6560, NULL, NULL, '31054', 'S', 'N', 1826, NULL, '3190', '3190', NULL, '1962', 'S', 1651, 'FRANCISCO DUMONT', 'N', '312660', 'N', 'S', 'S', NULL, 48, 'N', 'N', 'N', '296', NULL, '03', 'N', NULL, NULL, NULL, 192);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312670', '3106', 'MG', '3108', '3102', '31007', '31', 'FRANCISCO SA', NULL, '38', '39580000', '3', '4533', '4533', '11267', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 2749.393, '-16,47600', '-43,48800', 656, 'S', 0.6620, NULL, NULL, '31051', 'S', 'N', 1829, NULL, '3190', '3190', NULL, '1923', 'S', 1652, 'FRANCISCO SÁ', 'N', '312670', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '297', NULL, '03', 'N', NULL, NULL, NULL, 301);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312675', '3117', 'MG', '3111', '3104', '31015', '31', 'FRANCISCOPOLIS', NULL, '33', '39695000', '2', '0608', NULL, '11791', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 715.870, '-17,96000', '-42,00900', 380, 'S', 0.6050, NULL, NULL, '31069', 'S', 'N', 1831, NULL, '3190', '3190', NULL, '1997', 'S', 1653, 'FRANCISCÓPOLIS', 'N', '312675', 'N', 'S', 'S', NULL, 99, 'S', 'N', 'N', '298', NULL, '03', 'N', NULL, NULL, NULL, 292);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312680', '3117', 'MG', '3111', '3104', '31015', '31', 'FREI GASPAR', NULL, '33', '39840000', '2', '4535', '4535', '11268', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 628.303, '-18,06600', '-41,42900', 440, 'S', 0.6210, NULL, NULL, '31069', 'S', 'N', 1835, NULL, '3190', '3190', NULL, '1962', 'S', 1654, 'FREI GASPAR', 'N', '312680', 'N', 'S', 'S', NULL, 99, 'N', 'N', 'N', '299', NULL, '03', 'N', NULL, NULL, NULL, 292);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312690', '3116', 'MG', '3106', '3108', '31037', '31', 'FREI INOCENCIO', NULL, '33', '35112000', '1', '4537', '4537', '11269', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 468.196, '-18,54500', '-41,92200', 195, 'S', 0.7030, NULL, NULL, '31036', 'N', 'N', 1836, NULL, '3190', '3190', NULL, '1962', 'S', 1655, 'FREI INOCÊNCIO', 'N', '312690', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '300', NULL, '03', 'N', NULL, NULL, NULL, 189);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312695', '3116', 'MG', '3106', '3108', '31036', '31', 'FREI LAGONEGRO', NULL, '33', '39708000', '0', '0610', NULL, '11792', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 168.790, '-18,16800', '-42,76600', 830, 'S', 0.6120, NULL, NULL, '31039', 'S', 'N', 1837, NULL, '3190', '3190', NULL, '1997', 'S', 1656, 'FREI LAGONEGRO', 'N', '312695', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '301', NULL, '03', 'N', NULL, NULL, NULL, 179);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312700', '3113', 'MG', '3112', '3105', '31021', '31', 'FRONTEIRA', NULL, '34', '38230000', '8', '4539', '4539', '11270', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 199.228, '-20,26800', '-49,19900', 458, 'S', 0.7940, NULL, NULL, '31071', 'N', 'N', 1842, NULL, '3190', '3190', NULL, '1962', 'S', 1657, 'FRONTEIRA', 'N', '312700', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '302', NULL, '03', 'N', NULL, NULL, NULL, 244);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312705', '3117', 'MG', '3111', '3104', '31016', '31', 'FRONTEIRA DOS VALES', NULL, '33', '39870000', '7', '4935', '4935', '11468', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 317.826, '-16,89100', '-40,92500', 314, 'S', 0.5990, NULL, NULL, '31062', 'S', 'N', 1843, NULL, '3190', '3190', NULL, '1978', 'S', 1658, 'FRONTEIRA DOS VALES', 'N', '312705', 'N', 'S', 'S', NULL, 99, 'N', 'N', 'N', '303', NULL, '03', 'N', NULL, NULL, NULL, 62);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312707', '3106', 'MG', '3108', '3102', '31005', '31', 'FRUTA DE LEITE', NULL, '38', '39558000', '3', '0612', NULL, '11793', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 758.422, '-16,13100', '-42,53300', 910, 'S', 0.5860, NULL, NULL, '31056', 'S', 'N', 1845, NULL, '3190', '3190', NULL, '1997', 'S', 1659, 'FRUTA DE LEITE', 'N', '312707', 'N', 'S', 'S', NULL, 7, 'N', 'N', 'N', '304', NULL, '03', 'N', NULL, NULL, NULL, 348);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312710', '3113', 'MG', '3112', '3105', '31021', '31', 'FRUTAL', NULL, '34', '38200000', '7', '4541', '4541', '11271', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2429.679, '-20,02500', '-48,94100', 516, 'S', 0.8030, NULL, NULL, '31071', 'N', 'N', 1846, NULL, '3190', '3190', NULL, '1885', 'S', 1660, 'FRUTAL', 'N', '312710', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '305', NULL, '02', 'N', NULL, NULL, NULL, 244);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312720', '3114', 'MG', '3103', '3107', '31027', '31', 'FUNILANDIA', NULL, '31', '35709000', '6', '4543', '4543', '11272', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 201.656, '-19,36800', '-44,05600', 690, 'S', 0.7060, NULL, NULL, '31024', 'N', 'N', 1849, NULL, '3102', '3190', NULL, '1962', 'S', 1661, 'FUNILÂNDIA', 'N', '312720', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '306', NULL, '03', 'N', NULL, NULL, NULL, 58);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312730', '3116', 'MG', '3106', '3108', '31037', '31', 'GALILEIA', NULL, '33', '35250000', '5', '4545', '4545', '11273', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 721.317, '-18,99900', '-41,53800', 142, 'S', 0.6880, NULL, NULL, '31036', 'S', 'N', 1853, NULL, '3190', '3190', NULL, '1948', 'S', 1662, 'GALILÉIA', 'N', '312730', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '307', NULL, '03', 'N', NULL, NULL, NULL, 189);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312733', '3106', 'MG', '3108', '3102', '31004', '31', 'GAMELEIRAS', NULL, '38', '39505000', '9', '0614', NULL, '11794', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1733.399, '-15,08200', '-43,12400', 515, 'S', 0.5810, NULL, NULL, '31052', 'S', 'N', 1857, NULL, '3190', '3190', NULL, '1997', 'S', 1663, 'GAMELEIRAS', 'N', '312733', 'N', 'S', 'S', NULL, 79, 'N', 'N', 'N', '308', NULL, '03', 'N', NULL, NULL, NULL, 128);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312735', '3106', 'MG', '3108', '3102', '31007', '31', 'GLAUCILANDIA', NULL, '38', '39592000', '4', '0616', NULL, '11795', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 145.632, '-16,85000', '-43,69700', 665, 'S', 0.6970, NULL, NULL, '31054', 'S', 'N', 1887, NULL, '3190', '3190', NULL, '1997', 'S', 1664, 'GLAUCILÂNDIA', 'N', '312735', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '309', NULL, '03', 'N', NULL, NULL, NULL, 192);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312737', '3116', 'MG', '3106', '3108', '31041', '31', 'GOIABEIRA', NULL, '33', '35248000', '0', '0618', NULL, '11796', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 111.592, '-18,98200', '-41,22300', 180, 'S', 0.6700, NULL, NULL, '31040', 'S', 'N', 1896, NULL, '3190', '3190', NULL, '1997', 'S', 1665, 'GOIABEIRA', 'N', '312737', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '310', NULL, '03', 'N', NULL, NULL, NULL, 403);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312740', '3110', 'MG', '3101', '3110', '31052', '31', 'GONCALVES', NULL, '35', '37680000', '4', '4547', '4547', '11274', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 187.596, '-22,65900', '-45,85600', 1256, 'S', 0.7590, NULL, NULL, '31003', 'N', 'N', 1912, NULL, '3190', '3190', NULL, '1962', 'S', 1667, 'GONÇALVES', 'N', '312740', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '312', NULL, '03', 'N', NULL, NULL, NULL, 16);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312750', '3116', 'MG', '3106', '3108', '31035', '31', 'GONZAGA', NULL, '33', '39720000', '3', '4549', '4549', '11275', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 210.673, '-18,82200', '-42,47900', 795, 'S', 0.6460, NULL, NULL, '31036', 'S', 'N', 1915, NULL, '3190', '3190', NULL, '1962', 'S', 1668, 'GONZAGA', 'N', '312750', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '313', NULL, '03', 'N', NULL, NULL, NULL, 189);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312760', '3104', 'MG', '3104', '3103', '31010', '31', 'GOUVEIA', NULL, '38', '39120000', '2', '4551', '4551', '11276', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 874.927, '-18,45400', '-43,74100', 1113, 'S', 0.7350, NULL, NULL, '31026', 'N', 'N', 1916, NULL, '3190', '3190', NULL, '1953', 'S', 1669, 'GOUVEIA', 'N', '312760', 'N', 'N', 'S', NULL, 5, 'N', 'N', 'N', '314', NULL, '03', 'N', NULL, NULL, NULL, 126);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312770', '3116', 'MG', '3106', '3108', '31037', '31', 'GOVERNADOR VALADARES', NULL, '33', '35001000', '1', '4553', '4553', '11277', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 2348.100, '-18,85100', '-41,94900', 170, 'S', 0.7720, NULL, NULL, '31036', 'N', 'N', 1929, NULL, '3190', '3190', NULL, '1937', 'S', 1670, 'GOVERNADOR VALADARES', 'N', '312770', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '315', NULL, '01', 'N', NULL, NULL, NULL, 189);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312780', '3106', 'MG', '3108', '3102', '31008', '31', 'GRAO MOGOL', NULL, '38', '39570000', '0', '4555', '4555', '11278', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 3889.622, '-16,55900', '-42,89000', 829, 'S', 0.6720, NULL, NULL, '31051', 'S', 'N', 1941, NULL, '3190', '3190', NULL, '1840', 'S', 1671, 'GRÃO MOGOL', 'N', '312780', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '316', NULL, '03', 'N', NULL, NULL, NULL, 301);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312790', '3112', 'MG', '3113', '3105', '31019', '31', 'GRUPIARA', NULL, '34', '38470000', '9', '4557', '4557', '11279', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 192.557, '-18,49400', '-47,72200', 669, 'S', 0.7740, NULL, NULL, '31074', 'N', 'N', 1948, NULL, '3190', '3190', NULL, '1962', 'S', 1672, 'GRUPIARA', 'N', '312790', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '317', NULL, '03', 'N', NULL, NULL, NULL, 247);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312800', '3109', 'MG', '3103', '3108', '31035', '31', 'GUANHAES', NULL, '33', '39740000', '6', '4559', '4559', '11280', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1076.036, '-18,77500', '-42,93300', 777, 'S', 0.7190, NULL, NULL, '31020', 'N', 'N', 1966, NULL, '3190', '3190', NULL, '1875', 'S', 1673, 'GUANHÃES', 'N', '312800', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '318', NULL, '03', 'N', NULL, NULL, NULL, 245);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312810', '3122', 'MG', '3101', '3110', '31050', '31', 'GUAPE', NULL, '35', '37177000', '5', '4561', '4561', '11281', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 934.598, '-20,76200', '-45,91800', 760, 'S', 0.7520, NULL, NULL, '31005', 'N', 'N', 1967, NULL, '3190', '3190', NULL, '1923', 'S', 1674, 'GUAPÉ', 'N', '312810', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '319', NULL, '03', 'N', NULL, NULL, NULL, 361);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312820', '3108', 'MG', '3110', '3112', '31060', '31', 'GUARACIABA', NULL, '31', '35436000', '4', '4563', '4563', '11282', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 348.533, '-20,57100', '-43,00800', 578, 'S', 0.6660, NULL, NULL, '31060', 'S', 'N', 1980, NULL, '3190', '3190', NULL, '1948', 'S', 1675, 'GUARACIABA', 'N', '312820', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '320', NULL, '03', 'N', NULL, NULL, NULL, 347);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312825', '3106', 'MG', '3108', '3102', '31009', '31', 'GUARACIAMA', NULL, '38', '39397000', '3', '0622', NULL, '11798', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 392.051, '-17,01400', '-43,67300', 795, 'S', 0.6890, NULL, NULL, '31054', 'S', 'N', 1983, NULL, '3190', '3190', NULL, '1997', 'S', 1676, 'GUARACIAMA', 'N', '312825', 'N', 'S', 'S', NULL, 48, 'N', 'N', 'N', '321', NULL, '03', 'N', NULL, NULL, NULL, 192);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312830', '3121', 'MG', '3101', '3110', '31048', '31', 'GUARANESIA', NULL, '35', '37810000', '3', '4565', '4565', '11283', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 294.007, '-21,29900', '-46,80300', 751, 'S', 0.7690, NULL, NULL, '31002', 'N', 'N', 1988, NULL, '3190', '3190', NULL, '1901', 'S', 1677, 'GUARANÉSIA', 'N', '312830', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '322', NULL, '03', 'N', NULL, NULL, NULL, 302);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312840', '3118', 'MG', '3107', '3112', '31064', '31', 'GUARANI', NULL, '32', '36160000', '2', '4567', '4567', '11284', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 264.837, '-21,35200', '-43,04700', 420, 'S', 0.7590, NULL, NULL, '31048', 'N', 'N', 1989, NULL, '3190', '3190', NULL, '1911', 'S', 1678, 'GUARANI', 'N', '312840', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '323', NULL, '03', 'N', NULL, NULL, NULL, 181);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312850', '3105', 'MG', '3107', '3112', '31065', '31', 'GUARARA', NULL, '32', '36606000', '1', '4569', '4569', '11285', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 88.589, '-21,73200', '-43,03800', 558, 'S', 0.7500, NULL, NULL, '31047', 'N', 'N', 1999, NULL, '3190', '3190', NULL, '1890', 'S', 1679, 'GUARARÁ', 'N', '312850', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '324', NULL, '03', 'N', NULL, NULL, NULL, 115);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312860', '3107', 'MG', '3109', '3101', '31002', '31', 'GUARDA-MOR', NULL, '38', '38570000', '0', '4571', '4571', '11286', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 2065.595, '-17,77100', '-47,09800', 616, 'S', 0.7440, NULL, NULL, '31057', 'N', 'N', 2005, NULL, '3190', '3190', NULL, '1962', 'S', 1680, 'GUARDA-MOR', 'N', '312860', 'N', 'N', 'S', NULL, 63, 'N', 'N', 'N', '325', NULL, '03', 'N', NULL, NULL, NULL, 194);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312870', '3121', 'MG', '3101', '3110', '31048', '31', 'GUAXUPE', NULL, '35', '37800000', '9', '4573', '4573', '11287', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 285.913, '-21,30500', '-46,71300', 829, 'S', 0.7960, NULL, NULL, '31002', 'N', 'N', 2015, NULL, '3190', '3190', NULL, '1911', 'S', 1681, 'GUAXUPÉ', 'N', '312870', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '326', NULL, '03', 'N', NULL, NULL, NULL, 302);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312880', '3118', 'MG', '3107', '3112', '31064', '31', 'GUIDOVAL', NULL, '32', '36515000', '8', '4575', '4575', '11288', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 158.975, '-21,15200', '-42,79700', 302, 'S', 0.7360, NULL, NULL, '31048', 'N', 'N', 2017, NULL, '3190', '3190', NULL, '1948', 'S', 1682, 'GUIDOVAL', 'N', '312880', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '327', NULL, '03', 'N', NULL, NULL, NULL, 181);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312890', '3107', 'MG', '3109', '3105', '31020', '31', 'GUIMARANIA', NULL, '34', '38730000', '7', '4577', '4577', '11289', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 370.807, '-18,84400', '-46,79300', 912, 'S', 0.7760, NULL, NULL, '31057', 'N', 'N', 2019, NULL, '3190', '3190', NULL, '1962', 'S', 1683, 'GUIMARÂNIA', 'N', '312890', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '328', NULL, '03', 'N', NULL, NULL, NULL, 194);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312900', '3118', 'MG', '3107', '3112', '31064', '31', 'GUIRICEMA', NULL, '32', '36525000', '4', '4579', '4579', '11290', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 294.417, '-21,00800', '-42,71800', 298, 'S', 0.7350, NULL, NULL, '31048', 'N', 'N', 2021, NULL, '3190', '3190', NULL, '1938', 'S', 1684, 'GUIRICEMA', 'N', '312900', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '329', NULL, '03', 'N', NULL, NULL, NULL, 181);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312910', '3125', 'MG', '3113', '3105', '31017', '31', 'GURINHATA', NULL, '34', '38310000', '3', '4581', '4581', '11291', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1844.347, '-19,21300', '-49,78600', 543, 'S', 0.7580, NULL, NULL, '31073', 'N', 'N', 2022, NULL, '3190', '3190', NULL, '1962', 'S', 1685, 'GURINHATÃ', 'N', '312910', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '330', NULL, '03', 'N', NULL, NULL, NULL, 17);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312920', '3110', 'MG', '3101', '3110', '31053', '31', 'HELIODORA', NULL, '35', '37484000', '2', '4583', '4583', '11292', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 153.884, '-22,06700', '-45,54200', 893, 'S', 0.7330, NULL, NULL, '31007', 'N', 'N', 2030, NULL, '3190', '3190', NULL, '1948', 'S', 1686, 'HELIODORA', 'N', '312920', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '331', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312930', '3123', 'MG', '3106', '3108', '31040', '31', 'IAPU', NULL, '33', '35190000', '1', '4585', '4585', '11293', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 337.389, '-19,43700', '-42,21800', 430, 'S', 0.6970, NULL, NULL, '31037', 'S', 'N', 2053, NULL, '3104', '3190', NULL, '1948', 'S', 1687, 'IAPU', 'N', '312930', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '332', NULL, '03', 'N', NULL, NULL, NULL, 358);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312940', '3103', 'MG', '3102', '3111', '31059', '31', 'IBERTIOGA', NULL, '32', '36225000', '0', '4587', '4587', '11294', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 353.506, '-21,43000', '-43,96300', 1032, 'S', 0.7120, NULL, NULL, '31013', 'N', 'N', 2063, NULL, '3190', '3190', NULL, '1962', 'S', 1688, 'IBERTIOGA', 'N', '312940', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '333', NULL, '03', 'N', NULL, NULL, NULL, 241);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312950', '3113', 'MG', '3112', '3105', '31023', '31', 'IBIA', NULL, '34', '38950000', '9', '4589', '4589', '11295', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2707.582, '-19,47800', '-46,53900', 895, 'S', 0.7970, NULL, NULL, '31070', 'N', 'N', 2064, NULL, '3190', '3190', NULL, '1923', 'S', 1689, 'IBIÁ', 'N', '312950', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '334', NULL, '03', 'N', NULL, NULL, NULL, 240);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312960', '3128', 'MG', '3108', '3102', '31006', '31', 'IBIAI', NULL, '38', '39350000', '8', '4591', '4591', '11296', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 870.453, '-16,86100', '-44,91400', 470, 'S', 0.6870, NULL, NULL, '31055', 'S', 'N', 2066, NULL, '3190', '3190', NULL, '1962', 'S', 1690, 'IBIAÍ', 'N', '312960', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '335', NULL, '03', 'N', NULL, NULL, NULL, 233);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312965', '3129', 'MG', '3108', '3102', '31007', '31', 'IBIRACATU', NULL, '38', '39455000', '7', '0624', NULL, '11799', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 359.220, '-15,66400', '-44,16400', 750, 'S', 0.6150, NULL, NULL, '31049', 'S', 'N', 2082, NULL, '3190', '3190', NULL, '1997', 'S', 1691, 'IBIRACATU', 'N', '312965', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '336', NULL, '03', 'N', NULL, NULL, NULL, 243);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312970', '3122', 'MG', '3101', '3110', '31047', '31', 'IBIRACI', NULL, '35', '37990000', '7', '4593', '4593', '11297', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 598.801, '-20,46200', '-47,12200', 1071, 'S', 0.7620, NULL, NULL, '31005', 'N', 'N', 2083, NULL, '3190', '3190', NULL, '1923', 'S', 1692, 'IBIRACI', 'N', '312970', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '337', NULL, '03', 'N', NULL, NULL, NULL, 361);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312980', '3101', 'MG', '3103', '3107', '31030', '31', 'IBIRITE', NULL, '31', '32400000', '6', '4595', '4595', '11298', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 73.027, '-20,02200', '-44,05900', 872, 'S', 0.7290, NULL, NULL, '31018', 'N', 'N', 2093, NULL, '3101', '3101', NULL, '1962', 'S', 1693, 'IBIRITÉ', 'N', '312980', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '338', NULL, '01', 'N', NULL, NULL, NULL, 188);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('312990', '3110', 'MG', '3101', '3110', '31051', '31', 'IBITIURA DE MINAS', NULL, '35', '37790000', '5', '4597', '4597', '11299', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 68.386, '-22,06100', '-46,44000', 913, 'S', 0.7750, NULL, NULL, '31006', 'N', 'N', 2099, NULL, '3190', '3190', NULL, '1962', 'S', 1694, 'IBITIÚRA DE MINAS', 'N', '312990', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '339', NULL, '03', 'N', NULL, NULL, NULL, 291);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313000', '3120', 'MG', '3102', '3109', '31046', '31', 'IBITURUNA', NULL, '35', '37223000', '2', '4599', '4599', '11300', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 158.618, '-21,15300', '-44,74800', 892, 'S', 0.7240, NULL, NULL, '31015', 'N', 'N', 2100, NULL, '3190', '3190', NULL, '1962', 'S', 1695, 'IBITURUNA', 'N', '313000', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '340', NULL, '03', 'N', NULL, NULL, NULL, 114);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313005', '3129', 'MG', '3108', '3102', '31003', '31', 'ICARAI DE MINAS', NULL, '38', '39318000', '1', '2693', '2693', '11736', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 616.582, '-16,21700', '-44,90600', 595, 'S', 0.6500, NULL, NULL, '31049', 'S', 'N', 2105, NULL, '3190', '3190', NULL, '1993', 'S', 1696, 'ICARAÍ DE MINAS', 'N', '313005', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '341', NULL, '03', 'N', NULL, NULL, NULL, 243);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313010', '3101', 'MG', '3103', '3107', '31030', '31', 'IGARAPE', NULL, '31', '32900000', '1', '4601', '4601', '11301', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 109.930, '-20,07000', '-44,30200', 786, 'S', 0.7530, NULL, NULL, '31017', 'N', 'N', 2119, NULL, '3101', '3101', NULL, '1962', 'S', 1697, 'IGARAPÉ', 'N', '313010', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '342', NULL, '01', 'N', NULL, NULL, NULL, 242);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313020', '3115', 'MG', '3105', '3109', '31043', '31', 'IGARATINGA', NULL, '37', '35695000', '0', '4603', '4603', '11302', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 219.318, '-19,95500', '-44,70900', 816, 'S', 0.7390, NULL, NULL, '31032', 'N', 'N', 2126, NULL, '3190', '3190', NULL, '1962', 'S', 1698, 'IGARATINGA', 'N', '313020', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '343', NULL, '03', 'N', NULL, NULL, NULL, 131);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313030', '3115', 'MG', '3105', '3109', '31042', '31', 'IGUATAMA', NULL, '37', '38910000', '9', '4605', '4605', '11303', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 627.819, '-20,17400', '-45,71100', 664, 'S', 0.7860, NULL, NULL, '31030', 'N', 'N', 2135, NULL, '3190', '3190', NULL, '1943', 'S', 1699, 'IGUATAMA', 'N', '313030', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '344', NULL, '03', 'N', NULL, NULL, NULL, 15);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313040', '3111', 'MG', '3101', '3111', '31057', '31', 'IJACI', NULL, '35', '37205000', '8', '4607', '4607', '11304', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 105.387, '-21,17000', '-44,92500', 832, 'S', 0.7380, NULL, NULL, '31004', 'N', 'N', 2139, NULL, '3190', '3190', NULL, '1962', 'S', 1700, 'IJACI', 'N', '313040', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '345', NULL, '03', 'N', NULL, NULL, NULL, 19);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313050', '3111', 'MG', '3101', '3110', '31050', '31', 'ILICINEA', NULL, '35', '37175000', '7', '4609', '4609', '11305', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 376.004, '-20,93600', '-45,83300', 857, 'S', 0.7580, NULL, NULL, '31011', 'N', 'N', 2148, NULL, '3190', '3190', NULL, '1953', 'S', 1701, 'ILICÍNEA', 'N', '313050', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '346', NULL, '03', 'N', NULL, NULL, NULL, 294);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313055', '3123', 'MG', '3106', '3108', '31040', '31', 'IMBE DE MINAS', NULL, '33', '35323000', '6', '0626', NULL, '11800', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 199.521, '-19,59700', '-41,97100', 582, 'S', 0.6730, NULL, NULL, '31034', 'S', 'N', 2154, NULL, '3190', '3190', NULL, '1997', 'S', 1702, 'IMBÉ DE MINAS', 'N', '313055', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '347', NULL, '03', 'N', NULL, NULL, NULL, 14);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313060', '3110', 'MG', '3101', '3110', '31051', '31', 'INCONFIDENTES', NULL, '35', '37576000', '6', '4611', '4611', '11306', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 149.467, '-22,31700', '-46,32800', 869, 'S', 0.7700, NULL, NULL, '31007', 'N', 'N', 2164, NULL, '3190', '3190', NULL, '1962', 'S', 1703, 'INCONFIDENTES', 'N', '313060', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '348', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313065', '3106', 'MG', '3108', '3102', '31005', '31', 'INDAIABIRA', NULL, '38', '39536000', '5', '0628', NULL, '11801', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1008.181, '-15,49200', '-42,19700', 750, 'S', 0.5710, NULL, NULL, '31056', 'S', 'N', 2165, NULL, '3190', '3190', NULL, '1997', 'S', 1704, 'INDAIABIRA', 'N', '313065', 'N', 'S', 'S', NULL, 7, 'S', 'N', 'N', '349', NULL, '03', 'N', NULL, NULL, NULL, 348);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313070', '3112', 'MG', '3113', '3105', '31018', '31', 'INDIANOPOLIS', NULL, '34', '38490000', '5', '4613', '4613', '11307', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 833.870, '-19,03900', '-47,91700', 809, 'S', 0.7640, NULL, NULL, '31075', 'N', 'N', 2171, NULL, '3190', '3190', NULL, '1933', 'S', 1705, 'INDIANÓPOLIS', 'N', '313070', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '350', NULL, '03', 'N', NULL, NULL, NULL, 116);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313080', '3111', 'MG', '3101', '3111', '31057', '31', 'INGAI', NULL, '35', '37215000', '4', '4615', '4615', '11308', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 305.005, '-21,40100', '-44,91700', 951, 'S', 0.7590, NULL, NULL, '31004', 'N', 'N', 2178, NULL, '3190', '3190', NULL, '1962', 'S', 1706, 'INGAÍ', 'N', '313080', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '351', NULL, '03', 'N', NULL, NULL, NULL, 19);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313090', '3123', 'MG', '3106', '3108', '31040', '31', 'INHAPIM', NULL, '33', '35330000', '3', '4617', '4617', '11309', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 847.837, '-19,54900', '-42,12000', 482, 'S', 0.7090, NULL, NULL, '31034', 'N', 'N', 2184, NULL, '3190', '3190', NULL, '1938', 'S', 1707, 'INHAPIM', 'N', '313090', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '352', NULL, '03', 'N', NULL, NULL, NULL, 14);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313100', '3114', 'MG', '3103', '3107', '31027', '31', 'INHAUMA', NULL, '31', '35710000', '0', '4619', '4619', '11310', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 244.349, '-19,49100', '-44,39000', 746, 'S', 0.7390, NULL, NULL, '31024', 'N', 'N', 2185, NULL, '3102', '3190', NULL, '1948', 'S', 1708, 'INHAÚMA', 'N', '313100', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '353', NULL, '03', 'N', NULL, NULL, NULL, 58);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313110', '3114', 'MG', '3103', '3106', '31025', '31', 'INIMUTABA', NULL, '38', '35796000', '9', '4621', '4621', '11311', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 529.134, '-18,72900', '-44,36100', 600, 'S', 0.6910, NULL, NULL, '31019', 'S', 'N', 2188, NULL, '3190', '3190', NULL, '1962', 'S', 1709, 'INIMUTABA', 'N', '313110', 'N', 'N', 'S', NULL, 48, 'N', 'N', 'N', '354', NULL, '03', 'N', NULL, NULL, NULL, 65);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313115', '3123', 'MG', '3106', '3108', '31040', '31', 'IPABA', NULL, '33', '35198000', '8', '2665', '2665', '11737', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 114.349, '-19,41400', '-42,41900', 200, 'S', 0.7020, NULL, NULL, '31037', 'N', 'N', 2192, NULL, '3104', '3190', NULL, '1993', 'S', 1710, 'IPABA', 'N', '313115', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '355', NULL, '03', 'N', NULL, NULL, NULL, 358);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313120', '3124', 'MG', '3110', '3108', '31041', '31', 'IPANEMA', NULL, '33', '36950000', '8', '4623', '4623', '11312', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 458.590, '-19,80100', '-41,71300', 241, 'S', 0.7240, NULL, NULL, '31059', 'N', 'N', 2194, NULL, '3190', '3190', NULL, '1911', 'S', 1711, 'IPANEMA', 'N', '313120', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '356', NULL, '03', 'N', NULL, NULL, NULL, 191);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313130', '3123', 'MG', '3106', '3108', '31039', '31', 'IPATINGA', NULL, '31', '35160000', '7', '4625', '4625', '11313', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 165.509, '-19,46800', '-42,53700', 240, 'S', 0.8060, NULL, NULL, '31037', 'N', 'N', 2197, NULL, '3103', '3103', NULL, '1962', 'S', 1712, 'IPATINGA', 'N', '313130', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '357', NULL, '01', 'N', NULL, NULL, NULL, 358);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313140', '3125', 'MG', '3113', '3105', '31017', '31', 'IPIACU', NULL, '34', '38350000', '6', '4627', '4627', '11314', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 469.662, '-18,69200', '-49,94300', 452, 'S', 0.7640, NULL, NULL, '31073', 'N', 'N', 2204, NULL, '3190', '3190', NULL, '1962', 'S', 1713, 'IPIAÇU', 'N', '313140', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '358', NULL, '03', 'N', NULL, NULL, NULL, 17);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313150', '3110', 'MG', '3101', '3110', '31052', '31', 'IPUIUNA', NULL, '35', '37559000', '5', '4629', '4629', '11315', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 298.893, '-22,09900', '-46,19000', 1182, 'S', 0.7840, NULL, NULL, '31007', 'N', 'N', 2226, NULL, '3190', '3190', NULL, '1953', 'S', 1714, 'IPUIÚNA', 'N', '313150', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '359', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313160', '3112', 'MG', '3113', '3105', '31019', '31', 'IRAI DE MINAS', NULL, '34', '38510000', '4', '4631', '4631', '11316', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 357.575, '-18,98400', '-47,46100', 951, 'S', 0.7580, NULL, NULL, '31074', 'N', 'N', 2235, NULL, '3190', '3190', NULL, '1962', 'S', 1715, 'IRAÍ DE MINAS', 'N', '313160', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '360', NULL, '03', 'N', NULL, NULL, NULL, 247);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313170', '3109', 'MG', '3103', '3107', '31031', '31', 'ITABIRA', NULL, '31', '35901970', '3', '4633', '4633', '11317', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1256.496, '-19,61900', '-43,22700', 779, 'S', 0.7980, NULL, NULL, '31021', 'N', 'N', 2264, NULL, '3190', '3104', NULL, '1833', 'S', 1716, 'ITABIRA', 'N', '313170', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '361', NULL, '01', 'N', NULL, NULL, NULL, 190);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313180', '3116', 'MG', '3106', '3108', '31038', '31', 'ITABIRINHA', NULL, '33', '35280000', '2', '4635', '4635', '11318', NULL, 'ATIVO', 'N', 'N', NULL, 'ITABIRINHA DE MANTENA     ', 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 208.059, '-18,56600', '-41,23300', 330, 'S', 0.6810, NULL, NULL, '31038', 'S', 'N', 2265, NULL, '3190', '3190', NULL, '1962', 'S', 1717, 'ITABIRINHA DE MANTENA', 'N', '313180', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '362', NULL, '03', 'N', NULL, NULL, NULL, 66);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313190', '3101', 'MG', '3103', '3107', '31033', '31', 'ITABIRITO', NULL, '31', '35450000', '1', '4637', '4637', '11319', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 543.007, '-20,25300', '-43,80100', 901, 'S', 0.7860, NULL, NULL, '31022', 'N', 'N', 2266, NULL, '3102', '3101', NULL, '1923', 'S', 1718, 'ITABIRITO', 'N', '313190', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '363', NULL, '03', 'N', NULL, NULL, NULL, 193);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313200', '3106', 'MG', '3108', '3102', '31008', '31', 'ITACAMBIRA', NULL, '38', '39594000', '8', '4639', '4639', '11320', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1788.052, '-17,06500', '-43,30900', 1048, 'S', 0.6680, NULL, NULL, '31054', 'S', 'N', 2270, NULL, '3190', '3190', NULL, '1962', 'S', 1719, 'ITACAMBIRA', 'N', '313200', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '364', NULL, '03', 'N', NULL, NULL, NULL, 192);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313210', '3129', 'MG', '3108', '3102', '31003', '31', 'ITACARAMBI', NULL, '38', '39470000', '7', '4641', '4641', '11321', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1252.074, '-15,10200', '-44,09200', 445, 'S', 0.6220, NULL, NULL, '31053', 'S', 'N', 2271, NULL, '3190', '3190', NULL, '1962', 'S', 1720, 'ITACARAMBI', 'N', '313210', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '365', NULL, '03', 'N', NULL, NULL, NULL, 129);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313220', '3115', 'MG', '3105', '3107', '31032', '31', 'ITAGUARA', NULL, '37', '35514000', '6', '4643', '4643', '11322', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 410.719, '-20,39200', '-44,48800', 839, 'S', 0.7430, NULL, NULL, '31031', 'N', 'N', 2284, NULL, '3101', '3190', NULL, '1943', 'S', 1721, 'ITAGUARA', 'N', '313220', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '366', NULL, '01', 'N', NULL, NULL, NULL, 359);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313230', '3117', 'MG', '3111', '3104', '31015', '31', 'ITAIPE', NULL, '33', '39815000', '5', '4645', '4645', '11323', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 480.931, '-17,40200', '-41,66900', 847, 'S', 0.6330, NULL, NULL, '31067', 'S', 'N', 2294, NULL, '3190', '3190', NULL, '1962', 'S', 1722, 'ITAIPÉ', 'N', '313230', 'N', 'S', 'S', NULL, 99, 'N', 'N', 'N', '367', NULL, '03', 'N', NULL, NULL, NULL, 20);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313240', '3110', 'MG', '3101', '3110', '31056', '31', 'ITAJUBA', NULL, '35', '37500000', '4', '4647', '4647', '11324', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 290.450, '-22,42600', '-45,45300', 856, 'S', 0.8150, NULL, NULL, '31003', 'N', 'N', 2304, NULL, '3190', '3190', NULL, '1848', 'S', 1723, 'ITAJUBÁ', 'N', '313240', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '368', NULL, '02', 'N', NULL, NULL, NULL, 16);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313250', '3104', 'MG', '3104', '3103', '31011', '31', 'ITAMARANDIBA', NULL, '38', '39670000', '3', '4649', '4649', '11325', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 2736.096, '-17,85700', '-42,85900', 910, 'S', 0.6630, NULL, NULL, '31026', 'S', 'N', 2309, NULL, '3190', '3190', NULL, '1862', 'S', 1724, 'ITAMARANDIBA', 'N', '313250', 'N', 'S', 'S', NULL, 5, 'N', 'N', 'N', '369', NULL, '03', 'N', NULL, NULL, NULL, 126);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313260', '3127', 'MG', '3107', '3112', '31066', '31', 'ITAMARATI DE MINAS', NULL, '32', '36788000', '2', '4651', '4651', '11326', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 118.347, '-21,41600', '-42,81800', 213, 'S', 0.7510, NULL, NULL, '31044', 'N', 'N', 2311, NULL, '3190', '3190', NULL, '1962', 'S', 1725, 'ITAMARATI DE MINAS', 'N', '313260', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '370', NULL, '03', 'N', NULL, NULL, NULL, 246);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313270', '3117', 'MG', '3111', '3108', '31037', '31', 'ITAMBACURI', NULL, '33', '39830000', '1', '4653', '4653', '11327', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1418.619, '-18,03100', '-41,68500', 356, 'S', 0.6660, NULL, NULL, '31069', 'S', 'N', 2313, NULL, '3190', '3190', NULL, '1923', 'S', 1726, 'ITAMBACURI', 'N', '313270', 'N', 'S', 'S', NULL, 99, 'S', 'N', 'N', '371', NULL, '03', 'N', NULL, NULL, NULL, 292);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313280', '3109', 'MG', '3103', '3107', '31028', '31', 'ITAMBE DO MATO DENTRO', NULL, '31', '35820000', '0', '4655', '4655', '11328', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 381.066, '-19,41400', '-43,32100', 689, 'S', 0.6740, NULL, NULL, '31021', 'S', 'N', 2318, NULL, '3190', '3190', NULL, '1962', 'S', 1727, 'ITAMBÉ DO MATO DENTRO', 'N', '313280', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '372', NULL, '03', 'N', NULL, NULL, NULL, 190);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313290', '3122', 'MG', '3101', '3110', '31048', '31', 'ITAMOGI', NULL, '35', '37955000', '9', '4657', '4657', '11329', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 236.453, '-21,07800', '-47,04800', 1017, 'S', 0.7640, NULL, NULL, '31009', 'N', 'N', 2319, NULL, '3190', '3190', NULL, '1923', 'S', 1728, 'ITAMOGI', 'N', '313290', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '373', NULL, '03', 'N', NULL, NULL, NULL, 8);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313300', '3111', 'MG', '3101', '3110', '31054', '31', 'ITAMONTE', NULL, '35', '37466000', '6', '4659', '4659', '11330', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 430.597, '-22,28400', '-44,87000', 906, 'S', 0.7920, NULL, NULL, '31008', 'N', 'N', 2320, NULL, '3190', '3190', NULL, '1930', 'S', 1729, 'ITAMONTE', 'N', '313300', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '374', NULL, '03', 'N', NULL, NULL, NULL, 57);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313370', '3115', 'MG', '3105', '3107', '31032', '31', 'ITATIAIUCU', NULL, '31', '35685000', '9', '4673', '4673', '11337', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 295.062, '-20,19700', '-44,42100', 892, 'S', 0.7270, NULL, NULL, '31031', 'N', 'N', 2385, NULL, '3101', '3190', NULL, '1963', 'S', 1736, 'ITATIAIUÇU', 'N', '313370', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '381', NULL, '01', 'N', NULL, NULL, NULL, 359);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313310', '3111', 'MG', '3101', '3110', '31054', '31', 'ITANHANDU', NULL, '35', '37464000', '5', '4661', '4661', '11331', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 143.938, '-22,29600', '-44,93500', 892, 'S', 0.7950, NULL, NULL, '31008', 'N', 'N', 2323, NULL, '3190', '3190', NULL, '1923', 'S', 1730, 'ITANHANDU', 'N', '313310', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '375', NULL, '03', 'N', NULL, NULL, NULL, 57);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313320', '3116', 'MG', '3106', '3108', '31037', '31', 'ITANHOMI', NULL, '33', '35120000', '4', '4663', '4663', '11332', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 488.229, '-19,17200', '-41,86500', 252, 'S', 0.7000, NULL, NULL, '31036', 'S', 'N', 2325, NULL, '3190', '3190', NULL, '1948', 'S', 1731, 'ITANHOMI', 'N', '313320', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '376', NULL, '03', 'N', NULL, NULL, NULL, 189);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313330', '3119', 'MG', '3111', '3103', '31013', '31', 'ITAOBIM', NULL, '33', '39625000', '3', '4665', '4665', '11333', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'N', 'N', 'N', 'N', NULL, 'N', 679.889, '-16,56200', '-41,50300', 271, 'S', 0.6890, NULL, NULL, '31065', 'S', 'N', 2326, NULL, '3190', '3190', NULL, '1962', 'S', 1732, 'ITAOBIM', 'N', '313330', 'N', 'S', 'S', NULL, 57, 'N', 'N', 'N', '377', NULL, '03', 'N', NULL, NULL, NULL, 127);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313340', '3113', 'MG', '3112', '3105', '31021', '31', 'ITAPAGIPE', NULL, '34', '38240000', '2', '4667', '4667', '11334', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1795.431, '-19,90900', '-49,38100', 490, 'S', 0.7880, NULL, NULL, '31071', 'N', 'N', 2331, NULL, '3190', '3190', NULL, '1948', 'S', 1733, 'ITAPAGIPE', 'N', '313340', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '378', NULL, '03', 'N', NULL, NULL, NULL, 244);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313350', '3115', 'MG', '3105', '3109', '31044', '31', 'ITAPECERICA', NULL, '37', '35550000', '1', '4669', '4669', '11335', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1042.060, '-20,47300', '-45,12600', 835, 'S', 0.7630, NULL, NULL, '31029', 'N', 'N', 2335, NULL, '3190', '3190', NULL, '1789', 'S', 1734, 'ITAPECERICA', 'N', '313350', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '379', NULL, '03', 'N', NULL, NULL, NULL, 413);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313360', '3110', 'MG', '3101', '3110', '31052', '31', 'ITAPEVA', NULL, '35', '37655000', '0', '4671', '4671', '11336', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 177.992, '-22,76800', '-46,22100', 989, 'S', 0.7470, NULL, NULL, '31007', 'N', 'N', 2346, NULL, '3190', '3190', NULL, '1962', 'S', 1735, 'ITAPEVA', 'N', '313360', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '380', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313375', '3122', 'MG', '3101', '3110', '31047', '31', 'ITAU DE MINAS', NULL, '35', '37975000', '8', '5731', '5731', '11723', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 154.015, '-20,73900', '-46,75200', 735, 'S', 0.7960, NULL, NULL, '31005', 'N', 'N', 2393, NULL, '3190', '3190', NULL, '1989', 'S', 1737, 'ITAÚ DE MINAS', 'N', '313375', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '382', NULL, '03', 'N', NULL, NULL, NULL, 361);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313380', '3115', 'MG', '3105', '3109', '31043', '31', 'ITAUNA', NULL, '37', '35680970', '8', '4675', '4675', '11338', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 495.875, '-20,07500', '-44,57600', 880, 'S', 0.8230, NULL, NULL, '31031', 'N', 'N', 2398, NULL, '3102', '3190', NULL, '1901', 'S', 1738, 'ITAÚNA', 'N', '313380', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '383', NULL, '02', 'N', NULL, NULL, NULL, 359);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313390', '3103', 'MG', '3102', '3107', '31034', '31', 'ITAVERAVA', NULL, '31', '36440000', '7', '4677', '4677', '11339', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 282.642, '-20,67800', '-43,61000', 792, 'S', 0.6840, NULL, NULL, '31014', 'S', 'N', 2400, NULL, '3190', '3190', NULL, '1962', 'S', 1739, 'ITAVERAVA', 'N', '313390', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '384', NULL, '03', 'N', NULL, NULL, NULL, 187);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313400', '3119', 'MG', '3111', '3103', '31012', '31', 'ITINGA', NULL, '33', '39610000', '4', '4679', '4679', '11340', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 1640.657, '-16,61300', '-41,76500', 269, 'S', 0.6240, NULL, NULL, '31065', 'S', 'N', 2401, NULL, '3190', '3190', NULL, '1943', 'S', 1740, 'ITINGA', 'N', '313400', 'N', 'S', 'S', NULL, 57, 'N', 'N', 'N', '385', NULL, '03', 'N', NULL, NULL, NULL, 127);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313410', '3116', 'MG', '3106', '3108', '31041', '31', 'ITUETA', NULL, '33', '35220000', '3', '4681', '4681', '11341', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 454.918, '-19,39400', '-41,17000', 98, 'S', 0.7040, NULL, NULL, '31040', 'N', 'N', 2413, NULL, '3190', '3190', NULL, '1948', 'S', 1741, 'ITUETA', 'N', '313410', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '386', NULL, '03', 'N', NULL, NULL, NULL, 403);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313420', '3125', 'MG', '3113', '3105', '31017', '31', 'ITUIUTABA', NULL, '34', '38300000', '2', '4683', '4683', '11342', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2587.339, '-18,96900', '-49,46500', 544, 'S', 0.8180, NULL, NULL, '31073', 'N', 'N', 2414, NULL, '3190', '3190', NULL, '1901', 'S', 1742, 'ITUIUTABA', 'N', '313420', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '387', NULL, '02', 'N', NULL, NULL, NULL, 17);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313430', '3111', 'MG', '3101', '3111', '31057', '31', 'ITUMIRIM', NULL, '35', '37210000', '1', '4685', '4685', '11343', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 234.553, '-21,31700', '-44,87100', 871, 'S', 0.7600, NULL, NULL, '31004', 'N', 'N', 2416, NULL, '3190', '3190', NULL, '1943', 'S', 1743, 'ITUMIRIM', 'N', '313430', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '388', NULL, '03', 'N', NULL, NULL, NULL, 19);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313440', '3113', 'MG', '3112', '3105', '31021', '31', 'ITURAMA', NULL, '34', '38280000', '0', '4687', '4687', '11344', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1401.236, '-19,72800', '-50,19600', 453, 'S', 0.8020, NULL, NULL, '31071', 'N', 'N', 2420, NULL, '3190', '3190', NULL, '1948', 'S', 1744, 'ITURAMA', 'N', '313440', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '389', NULL, '03', 'N', NULL, NULL, NULL, 244);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313450', '3111', 'MG', '3101', '3111', '31057', '31', 'ITUTINGA', NULL, '35', '36390000', '9', '4689', '4689', '11345', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 372.508, '-21,29800', '-44,65800', 958, 'S', 0.7510, NULL, NULL, '31004', 'N', 'N', 2421, NULL, '3190', '3190', NULL, '1953', 'S', 1745, 'ITUTINGA', 'N', '313450', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '390', NULL, '03', 'N', NULL, NULL, NULL, 19);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313460', '3101', 'MG', '3103', '3107', '31027', '31', 'JABOTICATUBAS', NULL, '31', '35830000', '8', '4691', '4691', '11346', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1113.774, '-19,51400', '-43,74500', 772, 'S', 0.7310, NULL, NULL, '31016', 'N', 'N', 2440, NULL, '3101', '3190', NULL, '1938', 'S', 1746, 'JABOTICATUBAS', 'N', '313460', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '391', NULL, '01', 'N', NULL, NULL, NULL, 410);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313470', '3119', 'MG', '3111', '3103', '31014', '31', 'JACINTO', NULL, '33', '39930000', '7', '4693', '4693', '11347', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'S', 'N', NULL, 'N', 1390.518, '-16,14400', '-40,29300', 180, 'S', 0.6320, NULL, NULL, '31063', 'S', 'N', 2450, NULL, '3190', '3190', NULL, '1943', 'S', 1747, 'JACINTO', 'N', '313470', 'N', 'S', 'S', NULL, 117, 'N', 'N', 'N', '392', NULL, '03', 'N', NULL, NULL, NULL, 125);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313480', '3122', 'MG', '3101', '3110', '31048', '31', 'JACUI', NULL, '35', '37965000', '6', '4695', '4695', '11348', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 409.738, '-21,01700', '-46,74100', 1011, 'S', 0.7500, NULL, NULL, '31009', 'N', 'N', 2454, NULL, '3190', '3190', NULL, '1801', 'S', 1748, 'JACUÍ', 'N', '313480', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '393', NULL, '03', 'N', NULL, NULL, NULL, 8);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313490', '3110', 'MG', '3101', '3110', '31051', '31', 'JACUTINGA', NULL, '35', '37590000', '5', '4697', '4697', '11349', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 347.273, '-22,28600', '-46,61200', 839, 'S', 0.7970, NULL, NULL, '31007', 'N', 'N', 2458, NULL, '3190', '3190', NULL, '1901', 'S', 1749, 'JACUTINGA', 'N', '313490', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '394', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313500', '3123', 'MG', '3106', '3108', '31039', '31', 'JAGUARACU', NULL, '31', '35188000', '1', '4699', '4699', '11350', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 161.964, '-19,64900', '-42,75000', 497, 'S', 0.7420, NULL, NULL, '31035', 'N', 'N', 2462, NULL, '3104', '3190', NULL, '1953', 'S', 1750, 'JAGUARAÇU', 'N', '313500', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '395', NULL, '03', 'N', NULL, NULL, NULL, 64);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313505', '3106', 'MG', '3108', '3102', '31004', '31', 'JAIBA', NULL, '38', '39508000', '0', '2893', '2893', '11738', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 2740.276, '-15,33800', '-43,67400', 0, 'S', 0.6520, NULL, NULL, '31052', 'N', 'N', 2475, NULL, '3190', '3190', NULL, '1993', 'S', 1751, 'JAÍBA', 'N', '313505', 'N', 'S', 'S', NULL, 79, 'N', 'N', 'N', '396', NULL, '03', 'N', NULL, NULL, NULL, 128);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313507', '3116', 'MG', '3106', '3108', '31037', '31', 'JAMPRUCA', NULL, '33', '39837000', '6', '2655', '2655', '11739', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 520.998, '-18,46300', '-41,80400', 200, 'S', 0.5980, NULL, NULL, '31036', 'S', 'N', 2479, NULL, '3190', '3190', NULL, '1993', 'S', 1752, 'JAMPRUCA', 'N', '313507', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '397', NULL, '03', 'N', NULL, NULL, NULL, 189);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313510', '3106', 'MG', '3108', '3102', '31004', '31', 'JANAUBA', NULL, '38', '39440000', '0', '4701', '4701', '11351', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 2188.842, '-15,80300', '-43,30900', 533, 'S', 0.7160, NULL, NULL, '31052', 'N', 'N', 2480, NULL, '3190', '3190', NULL, '1948', 'S', 1753, 'JANAÚBA', 'N', '313510', 'N', 'S', 'S', NULL, 79, 'N', 'N', 'N', '398', NULL, '02', 'N', NULL, NULL, NULL, 128);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313520', '3129', 'MG', '3108', '3102', '31003', '31', 'JANUARIA', NULL, '38', '39480000', '9', '4703', '4703', '11352', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 6691.174, '-15,48800', '-44,36200', 554, 'S', 0.6990, NULL, NULL, '31053', 'N', 'N', 2489, NULL, '3190', '3190', NULL, '1833', 'S', 1754, 'JANUÁRIA', 'N', '313520', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '399', NULL, '02', 'N', NULL, NULL, NULL, 129);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313530', '3115', 'MG', '3105', '3106', '31026', '31', 'JAPARAIBA', NULL, '37', '35580000', '8', '4705', '4705', '11353', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 172.129, '-20,14100', '-45,50300', 711, 'S', 0.7530, NULL, NULL, '31029', 'N', 'N', 2490, NULL, '3190', '3190', NULL, '1953', 'S', 1755, 'JAPARAÍBA', 'N', '313530', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '400', NULL, '03', 'N', NULL, NULL, NULL, 413);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313535', '3129', 'MG', '3108', '3102', '31007', '31', 'JAPONVAR', NULL, '38', '39335000', '7', '0630', NULL, '11802', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 376.371, '-15,99500', '-44,27000', 700, 'S', 0.6180, NULL, NULL, '31049', 'S', 'N', 2497, NULL, '3190', '3190', NULL, '1997', 'S', 1756, 'JAPONVAR', 'N', '313535', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '401', NULL, '03', 'N', NULL, NULL, NULL, 243);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313540', '3103', 'MG', '3102', '3107', '31032', '31', 'JECEABA', NULL, '31', '35498000', '7', '4707', '4707', '11354', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 235.603, '-20,53500', '-43,98300', 850, 'S', 0.7320, NULL, NULL, '31014', 'N', 'N', 2532, NULL, '3190', '3190', NULL, '1953', 'S', 1757, 'JECEABA', 'N', '313540', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '402', NULL, '03', 'N', NULL, NULL, NULL, 187);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313545', '3104', 'MG', '3104', '3103', '31011', '31', 'JENIPAPO DE MINAS', NULL, '33', '39645000', '6', '0632', NULL, '11803', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 284.861, '-17,08300', '-42,25800', 521, 'S', 0.6180, NULL, NULL, '31064', 'S', 'N', 2533, NULL, '3190', '3190', NULL, '1997', 'S', 1758, 'JENIPAPO DE MINAS', 'N', '313545', 'N', 'S', 'S', NULL, 57, 'N', 'N', 'N', '403', NULL, '03', 'N', NULL, NULL, NULL, 357);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313550', '3108', 'MG', '3110', '3112', '31060', '31', 'JEQUERI', NULL, '31', '35390000', '6', '4709', '4709', '11355', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 547.817, '-20,45600', '-42,66600', 412, 'S', 0.6620, NULL, NULL, '31060', 'S', 'N', 2535, NULL, '3190', '3190', NULL, '1923', 'S', 1759, 'JEQUERI', 'N', '313550', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '404', NULL, '03', 'N', NULL, NULL, NULL, 347);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313560', '3106', 'MG', '3108', '3102', '31006', '31', 'JEQUITAI', NULL, '38', '39370000', '5', '4711', '4711', '11356', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1268.279, '-17,23600', '-44,44600', 517, 'S', 0.7050, NULL, NULL, '31050', 'N', 'N', 2538, NULL, '3190', '3190', NULL, '1948', 'S', 1760, 'JEQUITAÍ', 'N', '313560', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '405', NULL, '03', 'N', NULL, NULL, NULL, 63);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313570', '3114', 'MG', '3103', '3107', '31027', '31', 'JEQUITIBA', NULL, '31', '35767000', '4', '4713', '4713', '11357', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 446.010, '-19,23600', '-44,02800', 642, 'S', 0.6920, NULL, NULL, '31024', 'S', 'N', 2539, NULL, '3190', '3190', NULL, '1948', 'S', 1761, 'JEQUITIBÁ', 'N', '313570', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '406', NULL, '03', 'N', NULL, NULL, NULL, 58);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313580', '3119', 'MG', '3111', '3103', '31014', '31', 'JEQUITINHONHA', NULL, '33', '39960000', '3', '4715', '4715', '11358', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 3517.529, '-16,43400', '-41,00300', 223, 'S', 0.6680, NULL, NULL, '31063', 'S', 'N', 2540, NULL, '3190', '3190', NULL, '1911', 'S', 1762, 'JEQUITINHONHA', 'N', '313580', 'N', 'S', 'S', NULL, 117, 'N', 'N', 'N', '407', NULL, '03', 'N', NULL, NULL, NULL, 125);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313590', '3111', 'MG', '3101', '3110', '31054', '31', 'JESUANIA', NULL, '35', '37485000', '2', '4717', '4717', '11359', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 153.296, '-21,99800', '-45,29100', 903, 'S', 0.7390, NULL, NULL, '31008', 'N', 'N', 2546, NULL, '3190', '3190', NULL, '1948', 'S', 1763, 'JESUÂNIA', 'N', '313590', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '408', NULL, '03', 'N', NULL, NULL, NULL, 57);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313600', '3119', 'MG', '3111', '3103', '31014', '31', 'JOAIMA', NULL, '33', '39890000', '9', '4719', '4719', '11360', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 1667.725, '-16,65400', '-41,03100', 293, 'S', 0.6460, NULL, NULL, '31063', 'S', 'N', 2554, NULL, '3190', '3190', NULL, '1948', 'S', 1764, 'JOAÍMA', 'N', '313600', 'N', 'S', 'S', NULL, 117, 'N', 'N', 'N', '409', NULL, '03', 'N', NULL, NULL, NULL, 125);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313610', '3123', 'MG', '3106', '3108', '31039', '31', 'JOANESIA', NULL, '33', '35168000', '8', '4721', '4721', '11361', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 233.301, '-19,17200', '-42,67900', 430, 'S', 0.6820, NULL, NULL, '31037', 'S', 'N', 2555, NULL, '3104', '3190', NULL, '1953', 'S', 1765, 'JOANÉSIA', 'N', '313610', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '410', NULL, '03', 'N', NULL, NULL, NULL, 358);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313620', '3109', 'MG', '3103', '3107', '31031', '31', 'JOAO MONLEVADE', NULL, '31', '35930970', '7', '4723', '4723', '11362', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 99.283, '-19,81000', '-43,17400', 732, 'S', 0.8070, NULL, NULL, '31023', 'N', 'N', 2563, NULL, '3190', '3104', NULL, '1962', 'S', 1766, 'JOÃO MONLEVADE', 'N', '313620', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '411', NULL, '02', 'N', NULL, NULL, NULL, 18);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313630', '3107', 'MG', '3109', '3101', '31002', '31', 'JOAO PINHEIRO', NULL, '38', '38770000', '6', '4725', '4725', '11363', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 10716.960, '-17,74300', '-46,17300', 765, 'S', 0.7480, NULL, NULL, '31077', 'N', 'N', 2566, NULL, '3190', '3190', NULL, '1911', 'S', 1767, 'JOÃO PINHEIRO', 'N', '313630', 'N', 'N', 'S', NULL, 63, 'N', 'N', 'N', '412', NULL, '03', 'N', NULL, NULL, NULL, 414);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313640', '3106', 'MG', '3108', '3106', '31025', '31', 'JOAQUIM FELICIO', NULL, '38', '39240000', '5', '4727', '4727', '11364', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 791.100, '-17,75800', '-44,17200', 657, 'S', 0.6730, NULL, NULL, '31054', 'S', 'N', 2568, NULL, '3190', '3190', NULL, '1962', 'S', 1768, 'JOAQUIM FELÍCIO', 'N', '313640', 'N', 'N', 'S', NULL, 48, 'N', 'N', 'N', '413', NULL, '03', 'N', NULL, NULL, NULL, 192);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313650', '3119', 'MG', '3111', '3103', '31014', '31', 'JORDANIA', NULL, '33', '39920000', '4', '4729', '4729', '11365', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'N', 'N', 'N', 'N', NULL, 'N', 549.209, '-15,90000', '-40,17800', 198, 'S', 0.6460, NULL, NULL, '31063', 'S', 'N', 2576, NULL, '3190', '3190', NULL, '1948', 'S', 1769, 'JORDÂNIA', 'N', '313650', 'N', 'S', 'S', NULL, 117, 'N', 'N', 'N', '414', NULL, '03', 'N', NULL, NULL, NULL, 125);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313652', '3104', 'MG', '3104', '3103', '31011', '31', 'JOSE GONCALVES DE MINAS', NULL, '33', '39642000', '0', '0634', NULL, '11804', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 382.863, '-16,90700', '-42,60400', 545, 'S', 0.6460, NULL, NULL, '31027', 'S', 'N', 2582, NULL, '3190', '3190', NULL, '1997', 'S', 1770, 'JOSÉ GONÇALVES DE MINAS', 'N', '313652', 'N', 'S', 'S', NULL, 57, 'N', 'N', 'N', '415', NULL, '03', 'N', NULL, NULL, NULL, 67);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313655', '3116', 'MG', '3106', '3108', '31036', '31', 'JOSE RAYDAN', NULL, '33', '39775000', '3', '0636', NULL, '11805', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 181.407, '-18,21900', '-42,49900', 450, 'S', 0.6250, NULL, NULL, '31039', 'S', 'N', 2583, NULL, '3190', '3190', NULL, '1997', 'S', 1771, 'JOSÉ RAYDAN', 'N', '313655', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '416', NULL, '03', 'N', NULL, NULL, NULL, 179);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313657', '3106', 'MG', '3108', '3102', '31008', '31', 'JOSENOPOLIS', NULL, '38', '39575000', '9', '0638', NULL, '11806', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 535.603, '-16,54700', '-42,51500', 692, 'S', 0.6100, NULL, NULL, '31051', 'S', 'N', 2585, NULL, '3190', '3190', NULL, '1997', 'S', 1772, 'JOSENÓPOLIS', 'N', '313657', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '417', NULL, '03', 'N', NULL, NULL, NULL, 301);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313660', '3101', 'MG', '3103', '3107', '31031', '31', 'NOVA UNIAO', NULL, '31', '34990000', '3', '4731', '4731', '11366', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 171.482, '-19,69000', '-43,58000', 937, 'S', 0.7000, NULL, NULL, '31016', 'S', 'N', 3341, NULL, '3101', '3190', NULL, '1987', 'S', 1881, 'NOVA UNIÃO', 'N', '313660', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '526', NULL, '01', 'N', NULL, NULL, NULL, 410);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313665', '3101', 'MG', '3103', '3107', '31030', '31', 'JUATUBA', NULL, '31', '35675000', '2', '2691', '2691', '11740', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 96.789, '-19,95200', '-44,34300', 737, 'S', 0.7510, NULL, NULL, '31017', 'N', 'N', 2590, NULL, '3101', '3101', NULL, '1993', 'S', 1773, 'JUATUBA', 'N', '313665', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '418', NULL, '01', 'N', NULL, NULL, NULL, 242);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313670', '3105', 'MG', '3107', '3112', '31065', '31', 'JUIZ DE FORA', NULL, '32', '36001970', '2', '4733', '4733', '11367', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1436.850, '-21,76400', '-43,35000', 695, 'S', 0.8280, NULL, NULL, '31043', 'N', 'N', 2600, NULL, '3190', '3190', NULL, '1850', 'S', 1774, 'JUIZ DE FORA', 'N', '313670', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '419', NULL, '01', 'N', NULL, NULL, NULL, 360);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313680', '3106', 'MG', '3108', '3102', '31007', '31', 'JURAMENTO', NULL, '38', '39590000', '1', '4735', '4735', '11368', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 432.009, '-16,84800', '-43,58700', 682, 'S', 0.6800, NULL, NULL, '31054', 'S', 'N', 2616, NULL, '3190', '3190', NULL, '1953', 'S', 1775, 'JURAMENTO', 'N', '313680', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '420', NULL, '03', 'N', NULL, NULL, NULL, 192);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313690', '3121', 'MG', '3101', '3110', '31048', '31', 'JURUAIA', NULL, '35', '37805000', '0', '4737', '4737', '11369', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 219.512, '-21,25300', '-46,57700', 877, 'S', 0.7550, NULL, NULL, '31002', 'N', 'N', 2623, NULL, '3190', '3190', NULL, '1948', 'S', 1776, 'JURUAIA', 'N', '313690', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '421', NULL, '03', 'N', NULL, NULL, NULL, 302);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313695', '3129', 'MG', '3108', '3102', '31003', '31', 'JUVENILIA', NULL, '38', '39467000', '9', '0640', NULL, '11807', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1076.889, '-14,26300', '-44,16000', 445, 'S', 0.6250, NULL, NULL, '31076', 'S', 'N', 2634, NULL, '3190', '3190', NULL, '1997', 'S', 1777, 'JUVENÍLIA', 'N', '313695', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '422', NULL, '03', 'N', NULL, NULL, NULL, 303);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313700', '3117', 'MG', '3111', '3104', '31015', '31', 'LADAINHA', NULL, '33', '39825000', '7', '4739', '4739', '11370', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 865.245, '-17,63200', '-41,73800', 670, 'S', 0.6090, NULL, NULL, '31069', 'S', 'N', 2638, NULL, '3190', '3190', NULL, '1948', 'S', 1778, 'LADAINHA', 'N', '313700', 'N', 'S', 'S', NULL, 99, 'N', 'N', 'N', '423', NULL, '03', 'N', NULL, NULL, NULL, 292);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313710', '3107', 'MG', '3109', '3101', '31002', '31', 'LAGAMAR', NULL, '34', '38785000', '6', '4741', '4741', '11371', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1472.741, '-18,17800', '-46,80800', 836, 'S', 0.7310, NULL, NULL, '31057', 'N', 'N', 2641, NULL, '3190', '3190', NULL, '1962', 'S', 1779, 'LAGAMAR', 'N', '313710', 'N', 'N', 'S', NULL, 63, 'N', 'N', 'N', '424', NULL, '03', 'N', NULL, NULL, NULL, 194);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313720', '3115', 'MG', '3105', '3106', '31026', '31', 'LAGOA DA PRATA', NULL, '37', '35590000', '5', '4743', '4743', '11372', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 439.682, '-20,02300', '-45,54400', 655, 'S', 0.7630, NULL, NULL, '31029', 'N', 'N', 2653, NULL, '3190', '3190', NULL, '1938', 'S', 1780, 'LAGOA DA PRATA', 'N', '313720', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '425', NULL, '03', 'N', NULL, NULL, NULL, 413);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313730', '3106', 'MG', '3108', '3102', '31006', '31', 'LAGOA DOS PATOS', NULL, '38', '39360000', '4', '4745', '4745', '11373', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 599.449, '-16,98300', '-44,58200', 690, 'S', 0.6570, NULL, NULL, '31050', 'S', 'N', 2667, NULL, '3190', '3190', NULL, '1962', 'S', 1781, 'LAGOA DOS PATOS', 'N', '313730', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '426', NULL, '03', 'N', NULL, NULL, NULL, 63);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313740', '3120', 'MG', '3102', '3111', '31058', '31', 'LAGOA DOURADA', NULL, '32', '36345000', '3', '4747', '4747', '11374', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 479.573, '-20,91400', '-44,07800', 1080, 'S', 0.7340, NULL, NULL, '31015', 'N', 'N', 2669, NULL, '3190', '3190', NULL, '1911', 'S', 1782, 'LAGOA DOURADA', 'N', '313740', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '427', NULL, '03', 'N', NULL, NULL, NULL, 114);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313750', '3107', 'MG', '3109', '3105', '31020', '31', 'LAGOA FORMOSA', NULL, '34', '38720000', '2', '4749', '4749', '11375', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 844.539, '-18,77900', '-46,40800', 902, 'S', 0.7500, NULL, NULL, '31057', 'N', 'N', 2670, NULL, '3190', '3190', NULL, '1962', 'S', 1783, 'LAGOA FORMOSA', 'N', '313750', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '428', NULL, '03', 'N', NULL, NULL, NULL, 194);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313753', '3107', 'MG', '3109', '3101', '31002', '31', 'LAGOA GRANDE', NULL, '34', '38755000', '6', '2905', '2905', '11741', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1219.891, '-17,83500', '-46,51400', 572, 'S', 0.7210, NULL, NULL, '31077', 'N', 'N', 2671, NULL, '3190', '3190', NULL, '1993', 'S', 1784, 'LAGOA GRANDE', 'N', '313753', 'N', 'N', 'S', NULL, 63, 'N', 'N', 'N', '429', NULL, '03', 'N', NULL, NULL, NULL, 414);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313760', '3101', 'MG', '3103', '3107', '31030', '31', 'LAGOA SANTA', NULL, '31', '33400000', '1', '4751', '4751', '11376', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 231.994, '-19,62700', '-43,89000', 760, 'S', 0.7830, NULL, NULL, '31025', 'N', 'N', 2677, NULL, '3101', '3101', NULL, '1938', 'S', 1785, 'LAGOA SANTA', 'N', '313760', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '430', NULL, '01', 'N', NULL, NULL, NULL, 404);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313770', '3124', 'MG', '3110', '3112', '31061', '31', 'LAJINHA', NULL, '33', '36980000', '0', '4753', '4753', '11377', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 429.303, '-20,15100', '-41,62300', 470, 'S', 0.6940, NULL, NULL, '31059', 'S', 'N', 2698, NULL, '3190', '3190', NULL, '1938', 'S', 1786, 'LAJINHA', 'N', '313770', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '431', NULL, '03', 'N', NULL, NULL, NULL, 191);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313780', '3111', 'MG', '3101', '3110', '31054', '31', 'LAMBARI', NULL, '35', '37480000', '9', '4755', '4755', '11378', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 213.139, '-21,97600', '-45,35000', 887, 'S', 0.7810, NULL, NULL, '31008', 'N', 'N', 2700, NULL, '3190', '3190', NULL, '1901', 'S', 1787, 'LAMBARI', 'N', '313780', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '432', NULL, '03', 'N', NULL, NULL, NULL, 57);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313790', '3103', 'MG', '3102', '3112', '31062', '31', 'LAMIM', NULL, '31', '36455000', '8', '4757', '4757', '11379', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 118.160, '-20,79000', '-43,47400', 732, 'S', 0.6910, NULL, NULL, '31014', 'S', 'N', 2702, NULL, '3190', '3190', NULL, '1962', 'S', 1788, 'LAMIM', 'N', '313790', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '433', NULL, '03', 'N', NULL, NULL, NULL, 187);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313800', '3127', 'MG', '3107', '3112', '31066', '31', 'LARANJAL', NULL, '32', '36760000', '5', '4759', '4759', '11380', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 204.190, '-21,37400', '-42,47700', 175, 'S', 0.7690, NULL, NULL, '31044', 'N', 'N', 2708, NULL, '3190', '3190', NULL, '1938', 'S', 1789, 'LARANJAL', 'N', '313800', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '434', NULL, '03', 'N', NULL, NULL, NULL, 246);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313810', '3128', 'MG', '3108', '3102', '31006', '31', 'LASSANCE', NULL, '38', '39250000', '4', '4761', '4761', '11381', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 3213.578, '-17,88700', '-44,57800', 504, 'S', 0.6810, NULL, NULL, '31055', 'S', 'N', 2713, NULL, '3190', '3190', NULL, '1953', 'S', 1790, 'LASSANCE', 'N', '313810', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '435', NULL, '03', 'N', NULL, NULL, NULL, 233);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313820', '3111', 'MG', '3101', '3111', '31057', '31', 'LAVRAS', NULL, '35', '37200000', '3', '4763', '4763', '11382', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 564.495, '-21,24500', '-45,00000', 919, 'S', 0.8190, NULL, NULL, '31004', 'N', 'N', 2720, NULL, '3190', '3190', NULL, '1831', 'S', 1791, 'LAVRAS', 'N', '313820', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '436', NULL, '02', 'N', NULL, NULL, NULL, 19);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313830', '3115', 'MG', '3105', '3106', '31026', '31', 'LEANDRO FERREIRA', NULL, '37', '35657000', '2', '4765', '4765', '11383', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 355.221, '-19,71800', '-45,02500', 707, 'S', 0.7370, NULL, NULL, '31032', 'N', 'N', 2724, NULL, '3190', '3190', NULL, '1962', 'S', 1792, 'LEANDRO FERREIRA', 'N', '313830', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '437', NULL, '03', 'N', NULL, NULL, NULL, 131);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313835', '3104', 'MG', '3104', '3103', '31011', '31', 'LEME DO PRADO', NULL, '33', '39655000', '1', '0642', NULL, '11808', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 281.305, '-17,08300', '-42,69300', 431, 'S', 0.6830, NULL, NULL, '31027', 'S', 'N', 2727, NULL, '3190', '3190', NULL, '1997', 'S', 1793, 'LEME DO PRADO', 'N', '313835', 'N', 'S', 'S', NULL, 5, 'N', 'N', 'N', '438', NULL, '03', 'N', NULL, NULL, NULL, 67);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313840', '3127', 'MG', '3107', '3112', '31066', '31', 'LEOPOLDINA', NULL, '32', '36700000', '1', '4767', '4767', '11384', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 942.307, '-21,53200', '-42,64300', 212, 'S', 0.7780, NULL, NULL, '31044', 'N', 'N', 2731, NULL, '3190', '3190', NULL, '1854', 'S', 1794, 'LEOPOLDINA', 'N', '313840', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '439', NULL, '02', 'N', NULL, NULL, NULL, 246);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313850', '3105', 'MG', '3107', '3110', '31055', '31', 'LIBERDADE', NULL, '32', '37350000', '0', '4769', '4769', '11385', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 402.242, '-22,02900', '-44,32000', 1152, 'S', 0.7360, NULL, NULL, '31043', 'N', 'N', 2735, NULL, '3190', '3190', NULL, '1938', 'S', 1795, 'LIBERDADE', 'N', '313850', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '440', NULL, '03', 'N', NULL, NULL, NULL, 360);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313860', '3105', 'MG', '3107', '3112', '31065', '31', 'LIMA DUARTE', NULL, '32', '36140000', '9', '4771', '4771', '11386', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 848.089, '-21,84300', '-43,79300', 728, 'S', 0.7390, NULL, NULL, '31043', 'N', 'N', 2739, NULL, '3190', '3190', NULL, '1881', 'S', 1796, 'LIMA DUARTE', 'N', '313860', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '441', NULL, '03', 'N', NULL, NULL, NULL, 360);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313862', '3113', 'MG', '3112', '3105', '31021', '31', 'LIMEIRA DO OESTE', NULL, '34', '38295000', '5', '2687', '2687', '11742', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1317.515, '-19,55100', '-50,58100', 428, 'S', 0.7510, NULL, NULL, '31071', 'N', 'N', 2741, NULL, '3190', '3190', NULL, '1993', 'S', 1797, 'LIMEIRA DO OESTE', 'N', '313862', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '442', NULL, '03', 'N', NULL, NULL, NULL, 244);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313865', '3129', 'MG', '3108', '3102', '31007', '31', 'LONTRA', NULL, '38', '39437000', '8', '2695', '2695', '11743', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 257.220, '-15,90300', '-44,30500', 781, 'S', 0.6430, NULL, NULL, '31049', 'S', 'N', 2760, NULL, '3190', '3190', NULL, '1993', 'S', 1798, 'LONTRA', 'N', '313865', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '443', NULL, '03', 'N', NULL, NULL, NULL, 243);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313867', '3124', 'MG', '3110', '3112', '31061', '31', 'LUISBURGO', NULL, '33', '36923000', '4', '0644', NULL, '11809', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 146.124, '-20,44000', '-42,10300', 800, 'S', 0.7010, NULL, NULL, '31059', 'N', 'N', 2776, NULL, '3190', '3190', NULL, '1997', 'S', 1799, 'LUISBURGO', 'N', '313867', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '444', NULL, '03', 'N', NULL, NULL, NULL, 191);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313868', '3129', 'MG', '3108', '3102', '31007', '31', 'LUISLANDIA', NULL, '38', '39336000', '2', '0646', '0646', '11810', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 424.748, '-16,11800', '-44,58900', 758, 'S', 0.6340, NULL, NULL, '31049', 'S', 'N', 2777, NULL, '3190', '3190', NULL, '1997', 'S', 1800, 'LUISLÂNDIA', 'N', '313868', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '445', NULL, '03', 'N', NULL, NULL, NULL, 243);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313870', '3111', 'MG', '3101', '3111', '31057', '31', 'LUMINARIAS', NULL, '35', '37240000', '8', '4773', '4773', '11387', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 498.715, '-21,51100', '-44,90300', 957, 'S', 0.7630, NULL, NULL, '31004', 'N', 'N', 2781, NULL, '3190', '3190', NULL, '1948', 'S', 1801, 'LUMINÁRIAS', 'N', '313870', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '446', NULL, '03', 'N', NULL, NULL, NULL, 19);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313880', '3115', 'MG', '3105', '3106', '31026', '31', 'LUZ', NULL, '37', '35595000', '7', '4775', '4775', '11388', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1171.670, '-19,80100', '-45,68600', 675, 'S', 0.8010, NULL, NULL, '31028', 'N', 'N', 2786, NULL, '3190', '3190', NULL, '1923', 'S', 1802, 'LUZ', 'N', '313880', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '447', NULL, '03', 'N', NULL, NULL, NULL, 411);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313890', '3117', 'MG', '3111', '3104', '31016', '31', 'MACHACALIS', NULL, '33', '39873000', '6', '4777', '4777', '11389', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 329.757, '-17,07700', '-40,71600', 285, 'S', 0.6370, NULL, NULL, '31062', 'S', 'N', 2805, NULL, '3190', '3190', NULL, '1953', 'S', 1803, 'MACHACALIS', 'N', '313890', 'N', 'S', 'S', NULL, 99, 'N', 'N', 'N', '448', NULL, '03', 'N', NULL, NULL, NULL, 62);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313900', '3121', 'MG', '3101', '3110', '31049', '31', 'MACHADO', NULL, '35', '37750000', '3', '4779', '4779', '11390', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 583.752, '-21,67500', '-45,92000', 820, 'S', 0.7890, NULL, NULL, '31001', 'N', 'N', 2808, NULL, '3190', '3190', NULL, '1880', 'S', 1804, 'MACHADO', 'N', '313900', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '449', NULL, '03', 'N', NULL, NULL, NULL, 300);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313910', '3120', 'MG', '3102', '3111', '31058', '31', 'MADRE DE DEUS DE MINAS', NULL, '32', '37305000', '2', '4781', '4781', '11391', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 493.569, '-21,48300', '-44,33000', 1018, 'S', 0.7340, NULL, NULL, '31015', 'N', 'N', 2816, NULL, '3190', '3190', NULL, '1953', 'S', 1805, 'MADRE DE DEUS DE MINAS', 'N', '313910', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '450', NULL, '03', 'N', NULL, NULL, NULL, 114);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313920', '3117', 'MG', '3111', '3104', '31015', '31', 'MALACACHETA', NULL, '33', '39690000', '1', '4783', '4783', '11392', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'N', 'N', 'S', 'N', NULL, 'N', 719.345, '-17,84200', '-42,07700', 432, 'S', 0.6530, NULL, NULL, '31069', 'S', 'N', 2834, NULL, '3190', '3190', NULL, '1923', 'S', 1806, 'MALACACHETA', 'N', '313920', 'N', 'S', 'S', NULL, 99, 'N', 'N', 'N', '451', NULL, '03', 'N', NULL, NULL, NULL, 292);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313925', '3106', 'MG', '3108', '3102', '31004', '31', 'MAMONAS', NULL, '38', '39516000', '0', '2895', '2895', '11744', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 290.283, '-15,05000', '-42,94900', 681, 'S', 0.6210, NULL, NULL, '31052', 'S', 'N', 2844, NULL, '3190', '3190', NULL, '1993', 'S', 1807, 'MAMONAS', 'N', '313925', 'N', 'S', 'S', NULL, 79, 'N', 'N', 'N', '452', NULL, '03', 'N', NULL, NULL, NULL, 128);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313930', '3129', 'MG', '3108', '3102', '31003', '31', 'MANGA', NULL, '38', '39460000', '0', '4785', '4785', '11393', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1968.082, '-14,75600', '-43,93200', 440, 'S', 0.6030, NULL, NULL, '31076', 'S', 'N', 2857, NULL, '3190', '3190', NULL, '1923', 'S', 1808, 'MANGA', 'N', '313930', 'N', 'S', 'S', NULL, 79, 'S', 'N', 'N', '453', NULL, '03', 'N', NULL, NULL, NULL, 303);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313940', '3124', 'MG', '3110', '3112', '31061', '31', 'MANHUACU', NULL, '33', '36900000', '9', '4787', '4787', '11394', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 627.281, '-20,25800', '-42,03400', 635, 'S', 0.7760, NULL, NULL, '31059', 'N', 'N', 2860, NULL, '3190', '3190', NULL, '1877', 'S', 1809, 'MANHUAÇU', 'N', '313940', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '454', NULL, '02', 'N', NULL, NULL, NULL, 191);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313950', '3124', 'MG', '3110', '3112', '31061', '31', 'MANHUMIRIM', NULL, '33', '36970000', '8', '4789', '4789', '11395', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 183.588, '-20,35800', '-41,95800', 611, 'S', 0.7320, NULL, NULL, '31059', 'N', 'N', 2861, NULL, '3190', '3190', NULL, '1923', 'S', 1810, 'MANHUMIRIM', 'N', '313950', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '455', NULL, '03', 'N', NULL, NULL, NULL, 191);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313960', '3116', 'MG', '3106', '3108', '31038', '31', 'MANTENA', NULL, '33', '35290000', '7', '4791', '4791', '11396', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 682.827, '-18,78200', '-40,98000', 212, 'S', 0.7240, NULL, NULL, '31038', 'N', 'N', 2869, NULL, '3190', '3190', NULL, '1943', 'S', 1811, 'MANTENA', 'N', '313960', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '456', NULL, '03', 'N', NULL, NULL, NULL, 66);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313970', '3114', 'MG', '3103', '3107', '31027', '31', 'MARAVILHAS', NULL, '37', '35666000', '6', '4793', '4793', '11397', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 260.440, '-19,51600', '-44,67600', 775, 'S', 0.7380, NULL, NULL, '31024', 'N', 'N', 2899, NULL, '3190', '3190', NULL, '1953', 'S', 1813, 'MARAVILHAS', 'N', '313970', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '458', NULL, '03', 'N', NULL, NULL, NULL, 58);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313980', '3105', 'MG', '3107', '3112', '31065', '31', 'MAR DE ESPANHA', NULL, '32', '36640000', '5', '4795', '4795', '11398', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 372.108, '-21,86700', '-43,01000', 478, 'S', 0.7410, NULL, NULL, '31047', 'N', 'N', 2872, NULL, '3190', '3190', NULL, '1851', 'S', 1812, 'MAR DE ESPANHA', 'N', '313980', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '457', NULL, '03', 'N', NULL, NULL, NULL, 115);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('313990', '3110', 'MG', '3101', '3110', '31056', '31', 'MARIA DA FE', NULL, '35', '37517000', '4', '4797', '4797', '11399', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 203.774, '-22,30800', '-45,37500', 1278, 'S', 0.7330, NULL, NULL, '31003', 'N', 'N', 2914, NULL, '3190', '3190', NULL, '1911', 'S', 1814, 'MARIA DA FÉ', 'N', '313990', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '459', NULL, '03', 'N', NULL, NULL, NULL, 16);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314000', '3101', 'MG', '3103', '3107', '31033', '31', 'MARIANA', NULL, '31', '35420000', '1', '4799', '4799', '11400', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1193.293, '-20,37800', '-43,41600', 712, 'S', 0.7720, NULL, NULL, '31022', 'N', 'N', 2917, NULL, '3190', '3190', NULL, '1711', 'S', 1815, 'MARIANA', 'N', '314000', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '460', NULL, '02', 'N', NULL, NULL, NULL, 193);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314010', '3116', 'MG', '3106', '3108', '31037', '31', 'MARILAC', NULL, '33', '35115000', '0', '4801', '4801', '11401', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 164.123, '-18,50800', '-42,08400', 248, 'S', 0.6480, NULL, NULL, '31036', 'S', 'N', 2924, NULL, '3190', '3190', NULL, '1962', 'S', 1816, 'MARILAC', 'N', '314010', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '461', NULL, '03', 'N', NULL, NULL, NULL, 189);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314015', '3101', 'MG', '3103', '3107', '31030', '31', 'MARIO CAMPOS', NULL, '31', '32470000', '9', '0648', NULL, '11811', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 35.155, '-20,05600', '-44,18800', 730, 'S', 0.7110, NULL, NULL, '31017', 'N', 'N', 2932, NULL, '3101', '3101', NULL, '1997', 'S', 1817, 'MÁRIO CAMPOS', 'N', '314015', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '462', NULL, '01', 'N', NULL, NULL, NULL, 242);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150170', '1504', 'PA', '1590', '1504', '15010', '15', 'BRAGANCA', NULL, '91', '68600000', '9', '0433', '0433', '12017', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2090.234, '-1,06300', '-46,77300', 19, 'S', 0.6620, NULL, NULL, '15900', 'N', 'N', 731, NULL, '1590', '1590', NULL, '1753', 'S', 2435, 'BRAGANÇA', 'N', '150170', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'S', '24', NULL, '01', 'N', NULL, NULL, NULL, 453);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150210', '1513', 'PA', '1590', '1504', '15011', '15', 'CAMETA', NULL, '91', '68400000', '3', '0441', '0441', '12021', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3081.360, '-2,24400', '-49,49600', 150, 'S', 0.6710, NULL, NULL, '15900', 'N', 'N', 920, NULL, '1590', '1590', NULL, '1635', 'S', 2443, 'CAMETÁ', 'N', '150210', 'S', 'N', 'S', NULL, 130, 'N', 'N', 'S', '32', NULL, '01', 'N', NULL, NULL, NULL, 455);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150360', '1509', 'PA', '1590', '1505', '15014', '15', 'ITAITUBA', NULL, '93', '68181000', '6', '0471', '0471', '12036', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 62040.947, '-4,27600', '-55,98400', 15, 'S', 0.7040, NULL, NULL, '15900', 'N', 'N', 2297, NULL, '1590', '1590', NULL, '1935', 'S', 2469, 'ITAITUBA', 'N', '150360', 'S', 'N', 'S', NULL, 114, 'N', 'N', 'S', '58', NULL, '01', 'N', NULL, NULL, NULL, 454);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150420', '1511', 'PA', '1590', '1506', '15020', '15', 'MARABA', NULL, '94', '68500970', '8', '0483', '0483', '12042', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 15092.268, '-5,36900', '-49,11800', 84, 'S', 0.7140, NULL, NULL, '15900', 'N', 'N', 2876, NULL, '1590', '1590', NULL, '1913', 'S', 2477, 'MARABÁ', 'N', '150420', 'S', 'N', 'S', NULL, 87, 'N', 'S', 'S', '66', NULL, '01', 'N', NULL, NULL, NULL, 447);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('530015', '5301', 'DF', '5301', '5301', '53001', '53', 'ASA SUL', '', '61', '', '', '', '', '', '', 'REG ADM', 'N', 'N', '', '', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, '', '', 1171, 'S', NULL, '', '', '53001', 'N', 'N', 11806, '', '5301', '5301', '', '', 'N', NULL, '', 'N', '', 'N', 'N', 'S', '', NULL, 'N', 'N', 'N', '', '', '', 'S', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('530005', '5301', 'DF', '5301', '5301', '53001', '53', 'ASA NORTE', '', '61', '', '', '', '', '', '', 'REG ADM', 'N', 'N', '', '', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, '', '', 1171, 'S', NULL, '', '', '53001', 'N', 'N', 11724, '', '5301', '5301', '', '', 'N', NULL, '', 'N', '', 'N', 'N', 'S', '', NULL, 'N', 'N', 'N', '', '', '', 'S', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('530020', '5301', 'DF', '5301', '5301', '53001', '53', 'BRAZLANDIA', '', '61', '72000000', '', '', '', '', '', 'REG ADM', 'N', 'N', '', '', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, '', '', 1171, 'S', NULL, '', '', '53001', 'N', 'N', 11740, '', '5301', '5301', '', '1933', 'N', 802, 'BRAZLÂNDIA', 'N', '', 'N', 'N', 'S', '', NULL, 'N', 'N', 'N', '', '', '', 'S', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('530030', '5301', 'DF', '5301', '5301', '53001', '53', 'CANDANGOLANDIA', '', '61', '71720000', '', '', '', '', '', 'REG ADM', 'N', 'N', '', '', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, '', '', 1171, 'S', NULL, '', '', '53001', 'N', 'N', 11727, '', '5301', '5301', '', '1956', 'N', 803, 'CANDANGOLÂNDIA', 'N', '', 'N', 'N', 'S', '', NULL, 'N', 'N', 'N', '', '', '', 'S', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('530040', '5301', 'DF', '5301', '5301', '53001', '53', 'CEILANDIA', '', '61', '72200000', '', '', '', '', '', 'REG ADM', 'N', 'N', '', '', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, '', '', 1171, 'S', NULL, '', '', '53001', 'N', 'N', 5593, '', '5301', '5301', '', '1971', 'N', 804, 'CEILÂNDIA', 'N', '', 'N', 'N', 'S', '', NULL, 'N', 'N', 'N', '', '', '', 'S', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('530050', '5301', 'DF', '5301', '5301', '53001', '53', 'CRUZEIRO', '', '61', '70600000', '', '', '', '', '', 'REG ADM', 'N', 'N', '', '', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, '', '', 1171, 'S', NULL, '', '', '53001', 'N', 'N', 11725, '', '5301', '5301', '', '1959', 'N', 805, 'CRUZEIRO', 'N', '', 'N', 'N', 'S', '', NULL, 'N', 'N', 'N', '', '', '', 'S', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('530060', '5301', 'DF', '5301', '5301', '53001', '53', 'GAMA', '', '61', '72400000', '', '', '', '', '', 'REG ADM', 'N', 'N', '', '', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, '', '', 1171, 'S', NULL, '', '', '53001', 'N', 'N', 11728, '', '5301', '5301', '', '1960', 'N', 806, 'GAMA', 'N', '', 'N', 'N', 'S', '', NULL, 'N', 'N', 'N', '', '', '', 'S', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('530070', '5301', 'DF', '5301', '5301', '53001', '53', 'GUARA', '', '61', '71000000', '', '', '', '', '', 'REG ADM', 'N', 'N', '', '', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, '', '', 1171, 'S', NULL, '', '', '53001', 'N', 'N', 11762, '', '5301', '5301', '', '1968', 'N', 807, 'GUARÁ', 'N', '', 'N', 'N', 'S', '', NULL, 'N', 'N', 'N', '', '', '', 'S', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('530080', '5301', 'DF', '5301', '5301', '53001', '53', 'LAGO NORTE', '', '61', '71500000', '', '', '', '', '', 'REG ADM', 'N', 'N', '', '', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, '', '', 1171, 'S', NULL, '', '', '53001', 'N', 'N', 11729, '', '5301', '5301', '', '1994', 'N', 808, 'LAGO NORTE', 'N', '', 'N', 'N', 'S', '', NULL, 'N', 'N', 'N', '', '', '', 'S', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('530090', '5301', 'DF', '5301', '5301', '53001', '53', 'LAGO SUL', '', '61', '71600000', '', '', '', '', '', 'REG ADM', 'N', 'N', '', '', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, '', '', 1171, 'S', NULL, '', '', '53001', 'N', 'N', 11730, '', '5301', '5301', '', '1994', 'N', 809, 'LAGO SUL', 'N', '', 'N', 'N', 'S', '', NULL, 'N', 'N', 'N', '', '', '', 'S', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('530100', '5301', 'DF', '5301', '5301', '53001', '53', 'NUCLEO BANDEIRANTE', '', '61', '71700000', '', '', '', '', '', 'REG ADM', 'N', 'N', '', '', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, '', '', 1171, 'S', NULL, '', '', '53001', 'N', 'N', 11731, '', '5301', '5301', '', '1956', 'N', 810, 'NÚCLEO BANDEIRANTE', 'N', '', 'N', 'N', 'S', '', NULL, 'N', 'N', 'N', '', '', '', 'S', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('530110', '5301', 'DF', '5301', '5301', '53001', '53', 'PARANOA', '', '61', '71570000', '', '', '', '', '', 'REG ADM', 'N', 'N', '', '', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, '', '', 1171, 'S', NULL, '', '', '53001', 'N', 'N', 11732, '', '5301', '5301', '', '1989', 'N', 811, 'PARANOÁ', 'N', '', 'N', 'N', 'S', '', NULL, 'N', 'N', 'N', '', '', '', 'S', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('530120', '5301', 'DF', '5301', '5301', '53001', '53', 'PLANALTINA', '', '61', '73300000', '', '', '', '', '', 'REG ADM', 'N', 'N', '', '', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, '', '', 1171, 'S', NULL, '', '', '53001', 'N', 'N', 11733, '', '5301', '5301', '', '1959', 'N', 812, 'PLANALTINA', 'N', '', 'N', 'N', 'S', '', NULL, 'N', 'N', 'N', '', '', '', 'S', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('530130', '5301', 'DF', '5301', '5301', '53001', '53', 'RECANTO DAS EMAS', '', '61', '72600000', '', '', '', '', '', 'REG ADM', 'N', 'N', '', '', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, '', '', 1171, 'S', NULL, '', '', '53001', 'N', 'N', 11734, '', '5301', '5301', '', '1993', 'N', 813, 'RECANTO DAS EMAS', 'N', '', 'N', 'N', 'S', '', NULL, 'N', 'N', 'N', '', '', '', 'S', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('530135', '5301', 'DF', '5301', '5301', '53001', '53', 'RIACHO FUNDO I', '', '61', '71800000', '', '', '', '', '', 'REG ADM', 'N', 'N', '', '', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, '', '', 1171, 'S', NULL, '', '', '53001', 'N', 'N', 11735, '', '5301', '5301', '', '1993', 'N', 814, 'RIACHO FUNDO I', 'N', '', 'N', 'N', 'S', '', NULL, 'N', 'N', 'N', '', '', '', 'S', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('530140', '5301', 'DF', '5301', '5301', '53001', '53', 'SAMAMBAIA', '', '61', '72300000', '', '', '', '', '', 'REG ADM', 'N', 'N', '', '', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, '', '', 1171, 'S', NULL, '', '', '53001', 'N', 'N', 11766, '', '5301', '5301', '', '1989', 'N', 815, 'SAMAMBAIA', 'N', '', 'N', 'N', 'S', '', NULL, 'N', 'N', 'N', '', '', '', 'S', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('530150', '5301', 'DF', '5301', '5301', '53001', '53', 'SANTA MARIA', '', '61', '72500000', '', '', '', '', '', 'REG ADM', 'N', 'N', '', '', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, '', '', 1171, 'S', NULL, '', '', '53001', 'N', 'N', 11736, '', '5301', '5301', '', '1993', 'N', 816, 'SANTA MARIA', 'N', '', 'N', 'N', 'S', '', NULL, 'N', 'N', 'N', '', '', '', 'S', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('530160', '5301', 'DF', '5301', '5301', '53001', '53', 'SAO SEBASTIAO', '', '61', '71690000', '', '', '', '', '', 'REG ADM', 'N', 'N', '', '', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, '', '', 1171, 'S', NULL, '', '', '53001', 'N', 'N', 11737, '', '5301', '5301', '', '1993', 'N', 817, 'SÃO SEBASTIÃO', 'N', '', 'N', 'N', 'S', '', NULL, 'N', 'N', 'N', '', '', '', 'S', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('530170', '5301', 'DF', '5301', '5301', '53001', '53', 'SOBRADINHO', '', '61', '73000000', '', '', '', '', '', 'REG ADM', 'N', 'N', '', '', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, '', '', 1171, 'S', NULL, '', '', '53001', 'N', 'N', 5592, '', '5301', '5301', '', '1960', 'N', 818, 'SOBRADINHO', 'N', '', 'N', 'N', 'S', '', NULL, 'N', 'N', 'N', '', '', '', 'S', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('530180', '5301', 'DF', '5301', '5301', '53001', '53', 'TAGUATINGA', '', '61', '72000000', '', '', '', '', '', 'REG ADM', 'N', 'N', '', '', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, '', '', 1171, 'S', NULL, '', '', '53001', 'N', 'N', 5614, '', '5301', '5301', '', '1958', 'N', 819, 'TAGUATINGA', 'N', '', 'N', 'N', 'S', '', NULL, 'N', 'N', 'N', '', '', '', 'S', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171610', '1706', 'TO', '1790', '1701', '17004', '17', 'PARAISO DO TOCANTINS', NULL, '63', '77600000', '9', '9519', '9519', '28052', NULL, 'ATIVO', 'S', 'N', NULL, 'PARAISO DO NORTE DE GOIAS ', 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1297.018, '-10,17600', '-48,86700', 387, 'S', 0.7770, NULL, NULL, '17900', 'S', 'N', 3536, NULL, '1790', '1790', NULL, '1989', 'S', 5479, 'PARAÍSO DO TOCANTINS', 'N', '171610', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'S', '93', NULL, '03', 'N', NULL, NULL, NULL, 216);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314020', '3105', 'MG', '3107', '3112', '31065', '31', 'MARIPA DE MINAS', NULL, '32', '36608000', '9', '4803', '4803', '11402', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 77.736, '-21,69800', '-42,95900', 550, 'S', 0.7490, NULL, NULL, '31047', 'N', 'N', 2935, NULL, '3190', '3190', NULL, '1962', 'S', 1818, 'MARIPÁ DE MINAS', 'N', '314020', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '463', NULL, '03', 'N', NULL, NULL, NULL, 115);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110012', '1101', 'RO', '1190', '1102', '11004', '11', 'JI-PARANA', NULL, '69', '78958000', '2', '0005', '0005', '26003', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 6896.782, '-10,88200', '-61,94400', 170, 'S', 0.7530, NULL, NULL, '11900', 'N', 'N', 2549, NULL, '1190', '1190', NULL, '1977', 'S', 3863, 'JI-PARANÁ', 'N', '110012', 'S', 'N', 'S', NULL, 29, 'N', 'N', 'S', '24', NULL, '01', 'N', NULL, NULL, NULL, 318);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('120010', '1202', 'AC', '1290', '1202', '12005', '12', 'BRASILEIA', NULL, '68', '69932000', '4', '0105', '0105', '24003', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 4336.189, '-11,01000', '-68,74800', 172, 'S', 0.6690, NULL, NULL, '12900', 'S', 'N', 741, NULL, '1290', '1290', NULL, '1938', 'S', 3, 'BRASILÉIA', 'N', '120010', 'S', 'N', 'S', NULL, 4, 'N', 'N', 'S', '3', NULL, '03', 'N', NULL, NULL, NULL, 168);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('140070', '1401', 'RR', '1490', '1401', '14002', '14', 'UIRAMUTA', NULL, '95', '69358000', '4', '0038', NULL, '27015', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 8065.520, '4,59600', '-60,16800', 0, 'S', 0.5420, NULL, NULL, '14900', 'S', 'N', 5302, NULL, '1490', '1490', NULL, '1997', 'S', 3906, 'UIRAMUTÃ', 'N', '140070', 'S', 'N', 'S', NULL, 122, 'N', 'N', 'S', '15', NULL, '03', 'N', NULL, NULL, NULL, 207);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150010', '1506', 'PA', '1590', '1504', '15011', '15', 'ABAETETUBA', NULL, '91', '68440000', '7', '0401', '0401', '12001', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1610.743, '-1,71800', '-48,88300', 10, 'S', 0.7060, NULL, NULL, '15900', 'N', 'N', 5, NULL, '1590', '1590', NULL, '1880', 'S', 2412, 'ABAETETUBA', 'N', '150010', 'S', 'N', 'S', NULL, 130, 'N', 'N', 'S', '1', NULL, '01', 'N', NULL, NULL, NULL, 455);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150180', '1508', 'PA', '1590', '1502', '15005', '15', 'BREVES', NULL, '91', '68800000', '8', '0435', '0435', '12018', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 9550.454, '-1,68200', '-50,48000', 40, 'S', 0.6300, NULL, NULL, '15900', 'N', 'N', 768, NULL, '1590', '1590', NULL, '1851', 'S', 2439, 'BREVES', 'N', '150180', 'S', 'N', 'S', NULL, 129, 'N', 'N', 'S', '28', NULL, '01', 'N', NULL, NULL, NULL, 509);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314585', '3108', 'MG', '3110', '3112', '31060', '31', 'ORATORIOS', NULL, '31', '35439000', '1', '0672', NULL, '11821', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 89.187, '-20,43100', '-42,80600', 494, 'S', 0.6630, NULL, NULL, '31060', 'S', 'N', 3411, NULL, '3190', '3190', NULL, '1997', 'S', 1891, 'ORATÓRIOS', 'N', '314585', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '536', NULL, '03', 'N', NULL, NULL, NULL, 347);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150553', '1511', 'PA', '1590', '1506', '15019', '15', 'PARAUAPEBAS', NULL, '94', '68515000', '6', '0595', '0595', '12098', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 7007.737, '-6,06800', '-49,90200', 18, 'S', 0.7410, NULL, NULL, '15900', 'N', 'N', 3561, NULL, '1590', '1590', NULL, '1989', 'S', 2500, 'PARAUAPEBAS', 'N', '150553', 'S', 'N', 'S', NULL, 87, 'N', 'N', 'S', '89', NULL, '01', 'N', NULL, NULL, NULL, 447);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150810', '1511', 'PA', '1590', '1506', '15016', '15', 'TUCURUI', NULL, '94', '68458970', '0', '0561', '0561', '12081', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 2086.170, '-3,76800', '-49,67300', 42, 'S', 0.7550, NULL, NULL, '15900', 'N', 'N', 5250, NULL, '1590', '1590', NULL, '1947', 'S', 2548, 'TUCURUÍ', 'N', '150810', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'S', '137', NULL, '01', 'N', NULL, NULL, NULL, 448);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314030', '3123', 'MG', '3106', '3108', '31039', '31', 'MARLIERIA', NULL, '31', '35185000', '8', '4805', '4805', '11403', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 546.255, '-19,71200', '-42,73200', 536, 'S', 0.7310, NULL, NULL, '31035', 'N', 'N', 2938, NULL, '3104', '3190', NULL, '1953', 'S', 1819, 'MARLIÉRIA', 'N', '314030', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '464', NULL, '03', 'N', NULL, NULL, NULL, 64);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314040', '3110', 'MG', '3101', '3110', '31056', '31', 'MARMELOPOLIS', NULL, '35', '37516000', '7', '4807', '4807', '11404', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 107.861, '-22,44900', '-45,16500', 1277, 'S', 0.7210, NULL, NULL, '31003', 'N', 'N', 2940, NULL, '3190', '3190', NULL, '1962', 'S', 1820, 'MARMELÓPOLIS', 'N', '314040', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '465', NULL, '03', 'N', NULL, NULL, NULL, 16);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314050', '3115', 'MG', '3105', '3106', '31026', '31', 'MARTINHO CAMPOS', NULL, '37', '35606000', '6', '4809', '4809', '11405', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1060.302, '-19,33200', '-45,23700', 674, 'S', 0.7480, NULL, NULL, '31028', 'N', 'N', 2943, NULL, '3190', '3190', NULL, '1938', 'S', 1821, 'MARTINHO CAMPOS', 'N', '314050', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '466', NULL, '03', 'N', NULL, NULL, NULL, 411);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314053', '3124', 'MG', '3110', '3112', '31061', '31', 'MARTINS SOARES', NULL, '33', '36972000', '0', '0650', NULL, '11812', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 112.941, '-20,25700', '-41,87700', 700, 'S', 0.7070, NULL, NULL, '31059', 'N', 'N', 2947, NULL, '3190', '3190', NULL, '1997', 'S', 1822, 'MARTINS SOARES', 'N', '314053', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '467', NULL, '03', 'N', NULL, NULL, NULL, 191);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('120000', NULL, 'AC', NULL, NULL, NULL, '12', 'MUNICIPIO IGNORADO - AC ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IGNR', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', 0.00, 'N', NULL, NULL, NULL, NULL, 'N', 0.0000, NULL, NULL, NULL, 'N', 'N', NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110003', '1103', 'RO', '1190', '1102', '11008', '11', 'CABIXI', NULL, '69', '78999000', '1', '0037', '0037', '26020', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1314.355, '-13,49200', '-60,54500', 230, 'S', 0.7050, NULL, NULL, '11900', 'S', 'N', 814, NULL, '1190', '1190', NULL, '1989', 'S', 3846, 'CABIXI', 'N', '110003', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '7', NULL, '03', 'N', NULL, NULL, NULL, 151);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110005', '1103', 'RO', '1190', '1102', '11008', '11', 'CEREJEIRAS', NULL, '69', '78997000', '6', '0027', '0027', '26014', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2783.305, '-13,18900', '-60,81200', 277, 'S', 0.7510, NULL, NULL, '11900', 'S', 'N', 1209, NULL, '1190', '1190', NULL, '1983', 'S', 3852, 'CEREJEIRAS', 'N', '110005', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '13', NULL, '03', 'N', NULL, NULL, NULL, 151);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314055', '3119', 'MG', '3111', '3103', '31014', '31', 'MATA VERDE', NULL, '33', '39915000', '5', '2659', '2659', '11745', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 230.241, '-15,68600', '-40,74100', 865, 'S', 0.6040, NULL, NULL, '31063', 'S', 'N', 2960, NULL, '3190', '3190', NULL, '1993', 'S', 1823, 'MATA VERDE', 'N', '314055', 'N', 'S', 'S', NULL, 117, 'N', 'N', 'N', '468', NULL, '03', 'N', NULL, NULL, NULL, 125);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314060', '3104', 'MG', '3103', '3108', '31035', '31', 'MATERLANDIA', NULL, '33', '39755000', '5', '4811', '4811', '11406', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 282.253, '-18,47400', '-43,06000', 781, 'S', 0.6470, NULL, NULL, '31020', 'S', 'N', 2965, NULL, '3190', '3190', NULL, '1962', 'S', 1824, 'MATERLÂNDIA', 'N', '314060', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '469', NULL, '03', 'N', NULL, NULL, NULL, 245);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314070', '3101', 'MG', '3103', '3107', '31030', '31', 'MATEUS LEME', NULL, '31', '35670000', '4', '4813', '4813', '11407', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 302.589, '-19,98600', '-44,42800', 813, 'S', 0.7450, NULL, NULL, '31017', 'N', 'N', 2966, NULL, '3101', '3101', NULL, '1938', 'S', 1825, 'MATEUS LEME', 'N', '314070', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '470', NULL, '01', 'N', NULL, NULL, NULL, 242);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314080', '3105', 'MG', '3107', '3112', '31065', '31', 'MATIAS BARBOSA', NULL, '32', '36120000', '3', '4815', '4815', '11408', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 156.728, '-21,86900', '-43,31900', 474, 'S', 0.7820, NULL, NULL, '31043', 'N', 'N', 2968, NULL, '3190', '3190', NULL, '1923', 'S', 1827, 'MATIAS BARBOSA', 'N', '314080', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '472', NULL, '03', 'N', NULL, NULL, NULL, 360);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110001', '1102', 'RO', '1190', '1102', '11006', '11', 'ALTA FLORESTA D''OESTE', NULL, '69', '78994000', '5', '0033', '0033', '26016', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 7066.702, '-11,92900', '-61,99600', 350, 'S', 0.7150, NULL, NULL, '11900', 'S', 'N', 5594, NULL, '1190', '1190', NULL, '1986', 'S', 3841, 'ALTA FLORESTA D OESTE', 'N', '110001', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '1', NULL, '03', 'N', NULL, NULL, NULL, 150);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110000', NULL, 'RO', NULL, NULL, NULL, '11', 'MUNICIPIO IGNORADO - RO', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IGNR', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', 0.00, 'N', NULL, NULL, NULL, NULL, 'N', 0.0000, NULL, NULL, NULL, 'N', 'N', NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130000', NULL, 'AM', NULL, NULL, NULL, '13', 'MUNICIPIO IGNORADO - AM ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IGNR', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', 0.00, 'N', NULL, NULL, NULL, NULL, 'N', 0.0000, NULL, NULL, NULL, 'N', 'N', NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('140000', NULL, 'RR', NULL, NULL, NULL, '14', 'MUNICIPIO IGNORADO - RR ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IGNR', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', 0.00, 'N', NULL, NULL, NULL, NULL, 'N', 0.0000, NULL, NULL, NULL, 'N', 'N', NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150830', '1504', 'PA', '1590', '1504', '15013', '15', 'VISEU', NULL, '91', '68620000', '8', '0565', '0565', '12083', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4904.138, '-1,19700', '-46,14000', 15, 'S', 0.6050, NULL, NULL, '15900', 'N', 'N', 5466, NULL, '1590', '1590', NULL, '1935', 'S', 2552, 'VISEU', 'N', '150830', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '141', NULL, '02', 'N', NULL, NULL, NULL, 453);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150000', NULL, 'PA', NULL, NULL, NULL, '15', 'MUNICIPIO IGNORADO - PA ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IGNR', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', 0.00, 'N', NULL, NULL, NULL, NULL, 'N', 0.0000, NULL, NULL, NULL, 'N', 'N', NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110160', '1101', 'RO', '1190', '1102', '11004', '11', 'THEOBROMA', NULL, '69', '78947000', '9', '0975', '0975', '26038', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2197.415, '-10,24400', '-62,35500', 205, 'S', 0.6610, NULL, NULL, '11900', 'S', 'N', 5166, NULL, '1190', '1190', NULL, '1993', 'S', 3887, 'THEOBROMA', 'N', '110160', 'S', 'N', 'S', NULL, 29, 'N', 'N', 'N', '48', NULL, '03', 'N', NULL, NULL, NULL, 318);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110170', '1101', 'RO', '1190', '1102', '11004', '11', 'URUPA', NULL, '69', '78955000', '8', '0977', '0977', '26039', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 831.865, '-11,12500', '-62,37600', 200, 'S', 0.6710, NULL, NULL, '11900', 'S', 'N', 5346, NULL, '1190', '1190', NULL, '1993', 'S', 3888, 'URUPÁ', 'N', '110170', 'S', 'N', 'S', NULL, 29, 'N', 'N', 'N', '49', NULL, '03', 'N', NULL, NULL, NULL, 318);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110175', '1104', 'RO', '1190', '1102', '11003', '11', 'VALE DO ANARI', NULL, '69', '78948800', '7', '0024', '0024', '26052', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3135.141, '-9,86300', '-62,18600', 140, 'S', 0.6880, NULL, NULL, '11900', 'S', 'N', 5353, NULL, '1190', '1190', NULL, '1997', 'S', 3889, 'VALE DO ANARI', 'N', '110175', 'S', 'N', 'S', NULL, 29, 'N', 'N', 'N', '50', NULL, '03', 'N', NULL, NULL, NULL, 318);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110180', '1101', 'RO', '1190', '1102', '11004', '11', 'VALE DO PARAISO', NULL, '69', '78959000', '7', '0979', '0979', '26040', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 965.377, '-10,44900', '-62,13400', 204, 'S', 0.7040, NULL, NULL, '11900', 'S', 'N', 5354, NULL, '1190', '1190', NULL, '1993', 'S', 3890, 'VALE DO PARAÍSO', 'N', '110180', 'S', 'N', 'S', NULL, 29, 'N', 'N', 'N', '51', NULL, '03', 'N', NULL, NULL, NULL, 318);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('120001', '1201', 'AC', '1290', '1202', '12004', '12', 'ACRELANDIA', NULL, '68', '69945000', '3', '0643', '0643', '24027', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1574.550, '-9,82800', '-66,88300', 25, 'S', 0.6800, NULL, NULL, '12900', 'S', 'N', 26, NULL, '1290', '1290', NULL, '1993', 'S', 1, 'ACRELÂNDIA', 'N', '120001', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '1', NULL, '03', 'N', NULL, NULL, NULL, 105);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('120013', '1201', 'AC', '1290', '1202', '12004', '12', 'BUJARI', NULL, '68', '69923000', '8', '0645', '0645', '24028', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 3467.681, '-9,83100', '-67,95200', 50, 'S', 0.6390, NULL, NULL, '12900', 'S', 'N', 784, NULL, '1290', '1290', NULL, '1993', 'S', 4, 'BUJARI', 'N', '120013', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '4', NULL, '03', 'N', NULL, NULL, NULL, 105);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('120017', '1201', 'AC', '1290', '1202', '12004', '12', 'CAPIXABA', NULL, '68', '69922000', '9', '0647', '0647', '24029', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1713.412, '-10,57300', '-67,67600', 40, 'S', 0.6070, NULL, NULL, '12900', 'S', 'N', 1067, NULL, '1290', '1290', NULL, '1993', 'S', 5, 'CAPIXABA', 'N', '120017', 'S', 'N', 'S', NULL, 4, 'N', 'N', 'N', '5', NULL, '03', 'N', NULL, NULL, NULL, 105);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('120030', '1203', 'AC', '1290', '1201', '12002', '12', 'FEIJO', NULL, '68', '69960000', '2', '0113', '0113', '24007', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 24202.027, '-8,16400', '-70,35400', 153, 'S', 0.5410, NULL, NULL, '12900', 'S', 'N', 1735, NULL, '1290', '1290', NULL, '1906', 'S', 8, 'FEIJÓ', 'N', '120030', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '8', NULL, '03', 'N', NULL, NULL, NULL, 225);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('120032', '1203', 'AC', '1290', '1201', '12002', '12', 'JORDAO', NULL, '68', '69975000', '8', '0653', '0653', '24012', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 5428.765, '-9,43400', '-71,88400', 278, 'S', 0.4750, NULL, NULL, '12900', 'S', 'N', 2577, NULL, '1290', '1290', NULL, '1993', 'S', 9, 'JORDÃO', 'N', '120032', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '9', NULL, '03', 'N', NULL, NULL, NULL, 105);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('120039', '1203', 'AC', '1290', '1201', '12001', '12', 'PORTO WALTER', NULL, '68', '69982000', '3', '0657', '0657', '24030', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 6135.544, '-8,26900', '-72,74400', 195, 'S', 0.5400, NULL, NULL, '12900', 'S', 'N', 3930, NULL, '1290', '1290', NULL, '1993', 'S', 15, 'PORTO WALTER', 'N', '120039', 'S', 'N', 'S', NULL, 106, 'N', 'N', 'N', '15', NULL, '03', 'N', NULL, NULL, NULL, 225);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('120042', '1203', 'AC', '1290', '1201', '12001', '12', 'RODRIGUES ALVES', NULL, '68', '69985000', '7', '0659', '0659', '24031', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 3304.559, '-7,74200', '-72,64700', 0, 'S', 0.5500, NULL, NULL, '12900', 'S', 'N', 4209, NULL, '1290', '1290', NULL, '1993', 'S', 17, 'RODRIGUES ALVES', 'N', '120042', 'S', 'N', 'S', NULL, 106, 'N', 'N', 'N', '17', NULL, '03', 'N', NULL, NULL, NULL, 225);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('120045', '1201', 'AC', '1290', '1202', '12004', '12', 'SENADOR GUIOMARD', NULL, '68', '69925000', '0', '0153', '0153', '24021', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1837.294, '-10,15100', '-67,73600', 201, 'S', 0.7010, NULL, NULL, '12900', 'S', 'N', 4910, NULL, '1290', '1290', NULL, '1976', 'S', 20, 'SENADOR GUIOMARD', 'N', '120045', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '20', NULL, '03', 'N', NULL, NULL, NULL, 105);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('120070', '1202', 'AC', '1290', '1202', '12005', '12', 'XAPURI', NULL, '68', '69930000', '8', '0149', '0149', '24025', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 5250.931, '-10,65200', '-68,50400', 150, 'S', 0.6690, NULL, NULL, '12900', 'S', 'N', 5499, NULL, '1290', '1290', NULL, '1904', 'S', 22, 'XAPURI', 'N', '120070', 'S', 'N', 'S', NULL, 4, 'N', 'N', 'N', '22', NULL, '03', 'N', NULL, NULL, NULL, 168);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314085', '3106', 'MG', '3108', '3102', '31003', '31', 'MATIAS CARDOSO', NULL, '38', '39478000', '2', '2897', '2897', '11746', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1938.429, '-14,85500', '-43,92200', 472, 'S', 0.6020, NULL, NULL, '31052', 'S', 'N', 2969, NULL, '3190', '3190', NULL, '1993', 'S', 1828, 'MATIAS CARDOSO', 'N', '314085', 'N', 'S', 'S', NULL, 79, 'N', 'N', 'N', '473', NULL, '03', 'N', NULL, NULL, NULL, 128);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314090', '3124', 'MG', '3110', '3112', '31061', '31', 'MATIPO', NULL, '31', '35367000', '2', '4817', '4817', '11409', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 277.098, '-20,28400', '-42,34100', 615, 'S', 0.6830, NULL, NULL, '31059', 'S', 'N', 2975, NULL, '3190', '3190', NULL, '1938', 'S', 1829, 'MATIPÓ', 'N', '314090', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '474', NULL, '03', 'N', NULL, NULL, NULL, 191);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('140040', '1401', 'RR', '1490', '1401', '14002', '14', 'NORMANDIA', NULL, '95', '69355000', '7', '0311', '0311', '27006', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 6966.777, '3,88100', '-59,62300', 100, 'S', 0.6000, NULL, NULL, '14900', 'S', 'N', 3237, NULL, '1490', '1490', NULL, '1982', 'S', 3901, 'NORMANDIA', 'N', '140040', 'S', 'N', 'S', NULL, 122, 'N', 'N', 'N', '10', NULL, '03', 'N', NULL, NULL, NULL, 207);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('140045', '1401', 'RR', '1490', '1401', '14001', '14', 'PACARAIMA', NULL, '95', '69345000', '6', '0034', '0034', '27013', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 8028.428, '4,43100', '-61,14600', 920, 'S', 0.7180, NULL, NULL, '14900', 'S', 'N', 3453, NULL, '1490', '1490', NULL, '1997', 'S', 3902, 'PACARAIMA', 'N', '140045', 'S', 'N', 'S', NULL, 122, 'N', 'N', 'N', '11', NULL, '03', 'N', NULL, NULL, NULL, 207);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('140047', '1401', 'RR', '1490', '1402', '14004', '14', 'RORAINOPOLIS', NULL, '95', '69373000', '2', '0036', '0036', '27014', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 33593.892, '0,94600', '-60,41800', 98, 'S', 0.6760, NULL, NULL, '14900', 'S', 'N', 4222, NULL, '1490', '1490', NULL, '1997', 'S', 3903, 'RORAINÓPOLIS', 'N', '140047', 'S', 'N', 'S', NULL, 91, 'N', 'N', 'N', '12', NULL, '03', 'N', NULL, NULL, NULL, 378);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150020', '1502', 'PA', '1590', '1504', '15012', '15', 'ACARA', NULL, '91', '68690000', '6', '0403', '0403', '12002', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4343.772, '-1,96100', '-48,19700', 25, 'S', 0.6290, NULL, NULL, '15900', 'N', 'N', 19, NULL, '1590', '1590', NULL, '1932', 'S', 2414, 'ACARÁ', 'N', '150020', 'S', 'N', 'S', NULL, 130, 'N', 'N', 'N', '3', NULL, '03', 'N', NULL, NULL, NULL, 451);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150030', '1507', 'PA', '1590', '1502', '15005', '15', 'AFUA', NULL, '91', '68890000', '5', '0405', '0405', '12003', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 8372.772, '-0,15700', '-50,38700', 8, 'S', 0.6120, NULL, NULL, '15900', 'S', 'N', 40, NULL, '1590', '1590', NULL, '1890', 'S', 2415, 'AFUÁ', 'N', '150030', 'S', 'N', 'S', NULL, 129, 'N', 'N', 'N', '4', NULL, '03', 'N', NULL, NULL, NULL, 508);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150034', '1512', 'PA', '1590', '1506', '15019', '15', 'AGUA AZUL DO NORTE', NULL, '94', '68533000', '7', '0383', '0383', '12106', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 7576.621, '-6,79100', '-50,46700', 0, 'S', 0.6650, NULL, NULL, '15900', 'S', 'N', 45, NULL, '1590', '1590', NULL, '1993', 'S', 2416, 'ÁGUA AZUL DO NORTE', 'N', '150034', 'S', 'N', 'S', NULL, 92, 'N', 'N', 'N', '5', NULL, '03', 'N', NULL, NULL, NULL, 445);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314100', '3106', 'MG', '3108', '3102', '31004', '31', 'MATO VERDE', NULL, '38', '39527000', '9', '4819', '4819', '11410', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 474.446, '-15,39700', '-42,86600', 541, 'S', 0.6690, NULL, NULL, '31052', 'S', 'N', 2980, NULL, '3190', '3190', NULL, '1953', 'S', 1830, 'MATO VERDE', 'N', '314100', 'N', 'S', 'S', NULL, 79, 'N', 'N', 'N', '475', NULL, '03', 'N', NULL, NULL, NULL, 128);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314110', '3101', 'MG', '3103', '3107', '31027', '31', 'MATOZINHOS', NULL, '31', '35720000', '8', '4821', '4821', '11411', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 252.908, '-19,55800', '-44,08100', 812, 'S', 0.7740, NULL, NULL, '31025', 'N', 'N', 2984, NULL, '3101', '3101', NULL, '1943', 'S', 1831, 'MATOZINHOS', 'N', '314110', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '476', NULL, '01', 'N', NULL, NULL, NULL, 404);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314120', '3107', 'MG', '3109', '3105', '31020', '31', 'MATUTINA', NULL, '34', '38870000', '7', '4823', '4823', '11412', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 259.718, '-19,22300', '-45,96900', 1040, 'S', 0.7660, NULL, NULL, '31057', 'N', 'N', 2989, NULL, '3190', '3190', NULL, '1953', 'S', 1832, 'MATUTINA', 'N', '314120', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '477', NULL, '03', 'N', NULL, NULL, NULL, 194);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314130', '3115', 'MG', '3105', '3109', '31042', '31', 'MEDEIROS', NULL, '37', '38930000', '6', '4825', '4825', '11413', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 939.118, '-19,99600', '-46,22600', 922, 'S', 0.7920, NULL, NULL, '31030', 'N', 'N', 2999, NULL, '3190', '3190', NULL, '1962', 'S', 1833, 'MEDEIROS', 'N', '314130', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '478', NULL, '03', 'N', NULL, NULL, NULL, 15);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314140', '3119', 'MG', '3111', '3103', '31013', '31', 'MEDINA', NULL, '33', '39620000', '5', '4827', '4827', '11414', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 1439.982, '-16,22300', '-41,47700', 587, 'S', 0.6450, NULL, NULL, '31065', 'S', 'N', 3003, NULL, '3190', '3190', NULL, '1938', 'S', 1834, 'MEDINA', 'N', '314140', 'N', 'S', 'S', NULL, 57, 'N', 'N', 'N', '479', NULL, '03', 'N', NULL, NULL, NULL, 127);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314150', '3116', 'MG', '3106', '3108', '31038', '31', 'MENDES PIMENTEL', NULL, '33', '35270000', '4', '4829', '4829', '11415', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 303.412, '-18,66100', '-41,40500', 340, 'S', 0.6610, NULL, NULL, '31038', 'S', 'N', 3007, NULL, '3190', '3190', NULL, '1953', 'S', 1835, 'MENDES PIMENTEL', 'N', '314150', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '480', NULL, '03', 'N', NULL, NULL, NULL, 66);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314160', '3118', 'MG', '3107', '3112', '31064', '31', 'MERCES', NULL, '32', '36190000', '3', '4831', '4831', '11416', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 352.808, '-21,19400', '-43,34100', 522, 'S', 0.7170, NULL, NULL, '31048', 'N', 'N', 3010, NULL, '3190', '3190', NULL, '1911', 'S', 1836, 'MERCÊS', 'N', '314160', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '481', NULL, '03', 'N', NULL, NULL, NULL, 181);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314170', '3123', 'MG', '3106', '3108', '31039', '31', 'MESQUITA', NULL, '33', '35166000', '2', '4833', '4833', '11417', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 275.049, '-19,22300', '-42,60700', 352, 'S', 0.6770, NULL, NULL, '31037', 'S', 'N', 3014, NULL, '3104', '3190', NULL, '1923', 'S', 1837, 'MESQUITA', 'N', '314170', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '482', NULL, '03', 'N', NULL, NULL, NULL, 358);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314180', '3104', 'MG', '3104', '3103', '31011', '31', 'MINAS NOVAS', NULL, '33', '39650000', '1', '4835', '4835', '11418', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'S', 'N', NULL, 'N', 1810.772, '-17,21900', '-42,59000', 635, 'S', 0.6330, NULL, NULL, '31027', 'N', 'N', 3032, NULL, '3190', '3190', NULL, '1730', 'S', 1838, 'MINAS NOVAS', 'N', '314180', 'N', 'S', 'S', NULL, 5, 'S', 'N', 'N', '483', NULL, '03', 'N', NULL, NULL, NULL, 67);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314190', '3111', 'MG', '3101', '3110', '31055', '31', 'MINDURI', NULL, '35', '37447000', '0', '4837', '4837', '11419', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 220.425, '-21,68200', '-44,60400', 1000, 'S', 0.7520, NULL, NULL, '31008', 'N', 'N', 3033, NULL, '3190', '3190', NULL, '1953', 'S', 1839, 'MINDURI', 'N', '314190', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '484', NULL, '03', 'N', NULL, NULL, NULL, 57);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314200', '3129', 'MG', '3108', '3102', '31007', '31', 'MIRABELA', NULL, '38', '39420000', '7', '4839', '4839', '11420', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 720.828, '-16,26300', '-44,16400', 800, 'S', 0.6580, NULL, NULL, '31049', 'S', 'N', 3038, NULL, '3190', '3190', NULL, '1962', 'S', 1840, 'MIRABELA', 'N', '314200', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '485', NULL, '03', 'N', NULL, NULL, NULL, 243);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314210', '3118', 'MG', '3107', '3112', '31063', '31', 'MIRADOURO', NULL, '32', '36893000', '6', '4841', '4841', '11421', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 301.548, '-20,89100', '-42,34300', 409, 'S', 0.6980, NULL, NULL, '31045', 'S', 'N', 3044, NULL, '3190', '3190', NULL, '1938', 'S', 1841, 'MIRADOURO', 'N', '314210', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '486', NULL, '03', 'N', NULL, NULL, NULL, 130);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314220', '3118', 'MG', '3107', '3112', '31063', '31', 'MIRAI', NULL, '32', '36790000', '5', '4843', '4843', '11422', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 320.628, '-21,19500', '-42,61400', 306, 'S', 0.7240, NULL, NULL, '31045', 'N', 'N', 3046, NULL, '3190', '3190', NULL, '1923', 'S', 1842, 'MIRAÍ', 'N', '314220', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '487', NULL, '03', 'N', NULL, NULL, NULL, 130);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314225', '3129', 'MG', '3108', '3102', '31003', '31', 'MIRAVANIA', NULL, '38', '39465000', '4', '0652', NULL, '11813', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 603.005, '-14,74100', '-44,40400', 632, 'S', 0.6440, NULL, NULL, '31076', 'S', 'N', 3061, NULL, '3190', '3190', NULL, '1997', 'S', 1843, 'MIRAVÂNIA', 'N', '314225', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '488', NULL, '03', 'N', NULL, NULL, NULL, 303);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314230', '3101', 'MG', '3103', '3107', '31032', '31', 'MOEDA', NULL, '31', '35470000', '4', '4845', '4845', '11423', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 154.228, '-20,33300', '-44,05300', 812, 'S', 0.7330, NULL, NULL, '31016', 'N', 'N', 3069, NULL, '3102', '3190', NULL, '1953', 'S', 1844, 'MOEDA', 'N', '314230', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '489', NULL, '03', 'N', NULL, NULL, NULL, 410);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314240', '3115', 'MG', '3105', '3106', '31026', '31', 'MOEMA', NULL, '37', '35604000', '3', '4847', '4847', '11424', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 202.663, '-19,84300', '-45,41100', 673, 'S', 0.7730, NULL, NULL, '31028', 'N', 'N', 3070, NULL, '3190', '3190', NULL, '1953', 'S', 1845, 'MOEMA', 'N', '314240', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '490', NULL, '03', 'N', NULL, NULL, NULL, 411);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316870', '3123', 'MG', '3106', '3108', '31039', '31', 'TIMOTEO', NULL, '31', '35180000', '5', '5373', '5373', '11687', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 145.159, '-19,58300', '-42,64400', 333, 'S', 0.8310, NULL, NULL, '31035', 'N', 'N', 5183, NULL, '3103', '3103', NULL, '1962', 'S', 2162, 'TIMÓTEO', 'N', '316870', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '807', NULL, '02', 'N', NULL, NULL, NULL, 64);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('120020', '1203', 'AC', '1290', '1201', '12001', '12', 'CRUZEIRO DO SUL', NULL, '68', '69980000', '3', '0107', '0107', '24004', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 7924.943, '-7,63100', '-72,67000', 182, 'S', 0.6680, NULL, NULL, '12900', 'N', 'N', 1465, NULL, '1290', '1290', NULL, '1904', 'S', 6, 'CRUZEIRO DO SUL', 'N', '120020', 'S', 'N', 'S', NULL, 106, 'S', 'N', 'S', '6', NULL, '01', 'N', NULL, NULL, NULL, 225);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('120033', '1203', 'AC', '1290', '1201', '12001', '12', 'MANCIO LIMA', NULL, '68', '69990000', '6', '0109', '0109', '24014', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 4672.321, '-7,61400', '-72,89600', 195, 'S', 0.6420, NULL, NULL, '12900', 'S', 'N', 2851, NULL, '1290', '1290', NULL, '1976', 'S', 10, 'MÂNCIO LIMA', 'N', '120033', 'S', 'N', 'S', NULL, 106, 'S', 'N', 'N', '10', NULL, '03', 'N', NULL, NULL, NULL, 225);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('120034', '1201', 'AC', '1290', '1202', '12003', '12', 'MANOEL URBANO', NULL, '68', '69950000', '4', '0155', '0155', '24015', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 9386.961, '-8,83900', '-69,26000', 162, 'S', 0.6010, NULL, NULL, '12900', 'S', 'N', 2865, NULL, '1290', '1290', NULL, '1976', 'S', 11, 'MANOEL URBANO', 'N', '120034', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '11', NULL, '03', 'N', NULL, NULL, NULL, 105);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('120035', '1203', 'AC', '1290', '1201', '12001', '12', 'MARECHAL THAUMATURGO', NULL, '68', '69983000', '1', '0655', '0655', '24016', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 7743.828, '-8,94100', '-72,79200', 190, 'S', 0.5330, NULL, NULL, '12900', 'S', 'N', 2911, NULL, '1290', '1290', NULL, '1993', 'S', 12, 'MARECHAL THAUMATURGO', 'N', '120035', 'S', 'N', 'S', NULL, 106, 'S', 'N', 'N', '12', NULL, '03', 'N', NULL, NULL, NULL, 225);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('120038', '1201', 'AC', '1290', '1202', '12004', '12', 'PLACIDO DE CASTRO', NULL, '68', '69928000', '5', '0151', '0151', '24018', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 2047.455, '-10,33500', '-67,18400', 136, 'S', 0.6830, NULL, NULL, '12900', 'S', 'N', 3823, NULL, '1290', '1290', NULL, '1976', 'S', 13, 'PLÁCIDO DE CASTRO', 'N', '120038', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '13', NULL, '03', 'N', NULL, NULL, NULL, 105);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('120040', '1201', 'AC', '1290', '1202', '12004', '12', 'RIO BRANCO', NULL, '68', '69908970', '1', '0139', '0139', '24020', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'S', 9222.577, '-9,97500', '-67,81000', 153, 'S', 0.7540, NULL, NULL, '12900', 'N', 'N', 4140, NULL, '1290', '1201', NULL, '1904', 'S', 16, 'RIO BRANCO', 'N', '120040', 'S', 'N', 'S', NULL, NULL, 'S', 'S', 'S', '16', NULL, '01', 'N', NULL, NULL, NULL, 105);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('120043', '1201', 'AC', '1290', '1202', '12003', '12', 'SANTA ROSA DO PURUS', NULL, '68', '69955000', '5', '0661', '0661', '24026', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 5981.137, '-9,43300', '-70,49300', 25, 'S', 0.5250, NULL, NULL, '12900', 'S', 'N', 4415, NULL, '1290', '1290', NULL, '1993', 'S', 18, 'SANTA ROSA DO PURUS', 'N', '120043', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '18', NULL, '03', 'N', NULL, NULL, NULL, 105);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('120050', '1201', 'AC', '1290', '1202', '12003', '12', 'SENA MADUREIRA', NULL, '68', '69940000', '0', '0145', '0145', '24023', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 25278.095, '-9,06600', '-68,65700', 150, 'S', 0.6520, NULL, NULL, '12900', 'S', 'N', 4902, NULL, '1290', '1290', NULL, '1904', 'S', 19, 'SENA MADUREIRA', 'N', '120050', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '19', NULL, '03', 'N', NULL, NULL, NULL, 105);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('120060', '1203', 'AC', '1290', '1201', '12002', '12', 'TARAUACA', NULL, '68', '69970000', '9', '0147', '0147', '24024', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 15553.430, '-8,16100', '-70,76600', 168, 'S', 0.6040, NULL, NULL, '12900', 'S', 'N', 5117, NULL, '1290', '1290', NULL, '1907', 'S', 21, 'TARAUACÁ', 'N', '120060', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'S', '21', NULL, '03', 'N', NULL, NULL, NULL, 225);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314250', '3114', 'MG', '3103', '3106', '31025', '31', 'MONJOLOS', NULL, '38', '39215000', '2', '4849', '4849', '11425', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 652.106, '-18,32500', '-44,11900', 560, 'S', 0.6760, NULL, NULL, '31019', 'S', 'N', 3084, NULL, '3190', '3190', NULL, '1962', 'S', 1846, 'MONJOLOS', 'N', '314250', 'N', 'N', 'S', NULL, 48, 'N', 'N', 'N', '491', NULL, '03', 'N', NULL, NULL, NULL, 65);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314260', '3111', 'MG', '3101', '3110', '31050', '31', 'MONSENHOR PAULO', NULL, '35', '37405000', '1', '4851', '4851', '11426', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 216.460, '-21,75800', '-45,54100', 898, 'S', 0.7640, NULL, NULL, '31012', 'N', 'N', 3087, NULL, '3190', '3190', NULL, '1948', 'S', 1847, 'MONSENHOR PAULO', 'N', '314260', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '492', NULL, '03', 'N', NULL, NULL, NULL, 59);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314270', '3129', 'MG', '3108', '3102', '31003', '31', 'MONTALVANIA', NULL, '38', '39495000', '0', '4853', '4853', '11427', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1484.388, '-14,42300', '-44,36600', 510, 'S', 0.6450, NULL, NULL, '31076', 'S', 'N', 3090, NULL, '3190', '3190', NULL, '1962', 'S', 1848, 'MONTALVÂNIA', 'N', '314270', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '493', NULL, '03', 'N', NULL, NULL, NULL, 303);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314280', '3112', 'MG', '3113', '3105', '31018', '31', 'MONTE ALEGRE DE MINAS', NULL, '34', '38420000', '9', '4855', '4855', '11428', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2593.171, '-18,87100', '-48,88100', 730, 'S', 0.7590, NULL, NULL, '31075', 'N', 'N', 3097, NULL, '3190', '3190', NULL, '1870', 'S', 1849, 'MONTE ALEGRE DE MINAS', 'N', '314280', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '494', NULL, '03', 'N', NULL, NULL, NULL, 116);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314290', '3106', 'MG', '3108', '3102', '31004', '31', 'MONTE AZUL', NULL, '38', '39500000', '8', '4857', '4857', '11429', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 991.568, '-15,15500', '-42,87500', 582, 'S', 0.6570, NULL, NULL, '31052', 'S', 'N', 3104, NULL, '3190', '3190', NULL, '1878', 'S', 1850, 'MONTE AZUL', 'N', '314290', 'N', 'S', 'S', NULL, 79, 'N', 'N', 'N', '495', NULL, '03', 'N', NULL, NULL, NULL, 128);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314300', '3121', 'MG', '3101', '3110', '31048', '31', 'MONTE BELO', NULL, '35', '37115000', '5', '4859', '4859', '11430', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 421.286, '-21,32600', '-46,36800', 912, 'S', 0.7280, NULL, NULL, '31002', 'N', 'N', 3106, NULL, '3190', '3190', NULL, '1938', 'S', 1851, 'MONTE BELO', 'N', '314300', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '496', NULL, '03', 'N', NULL, NULL, NULL, 302);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314310', '3112', 'MG', '3113', '3105', '31019', '31', 'MONTE CARMELO', NULL, '34', '38500000', '4', '4861', '4861', '11431', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1353.677, '-18,72500', '-47,49900', 870, 'S', 0.7680, NULL, NULL, '31074', 'N', 'N', 3109, NULL, '3190', '3190', NULL, '1882', 'S', 1852, 'MONTE CARMELO', 'N', '314310', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '497', NULL, '03', 'N', NULL, NULL, NULL, 247);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314315', '3119', 'MG', '3111', '3103', '31014', '31', 'MONTE FORMOSO', NULL, '33', '39893000', '3', '0654', NULL, '11814', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 383.821, '-16,86600', '-41,25500', 700, 'S', 0.5700, NULL, NULL, '31063', 'S', 'N', 3114, NULL, '3190', '3190', NULL, '1997', 'S', 1853, 'MONTE FORMOSO', 'N', '314315', 'N', 'S', 'S', NULL, 117, 'N', 'N', 'N', '498', NULL, '03', 'N', NULL, NULL, NULL, 127);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314320', '3122', 'MG', '3101', '3110', '31048', '31', 'MONTE SANTO DE MINAS', NULL, '35', '37958000', '3', '4863', '4863', '11432', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 590.896, '-21,19000', '-46,98000', 878, 'S', 0.7450, NULL, NULL, '31009', 'N', 'N', 3119, NULL, '3190', '3190', NULL, '1890', 'S', 1854, 'MONTE SANTO DE MINAS', 'N', '314320', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '499', NULL, '03', 'N', NULL, NULL, NULL, 8);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314330', '3106', 'MG', '3108', '3102', '31007', '31', 'MONTES CLAROS', NULL, '38', '39400000', '2', '4865', '4865', '11433', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 3582.034, '-16,73500', '-43,86200', 648, 'S', 0.7830, NULL, NULL, '31054', 'N', 'N', 3127, NULL, '3190', '3190', NULL, '1831', 'S', 1856, 'MONTES CLAROS', 'N', '314330', 'N', 'S', 'S', NULL, NULL, 'N', 'S', 'N', '501', NULL, '01', 'N', NULL, NULL, NULL, 192);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150013', '1511', 'PA', '1590', '1506', '15017', '15', 'ABEL FIGUEIREDO', NULL, '94', '68527000', '1', '0375', '0375', '12124', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 614.252, '-4,95400', '-48,39300', 0, 'S', 0.7040, NULL, NULL, '15900', 'S', 'N', 11, NULL, '1590', '1590', NULL, '1993', 'S', 2413, 'ABEL FIGUEIREDO', 'N', '150013', 'S', 'N', 'S', NULL, 61, 'S', 'N', 'N', '2', NULL, '03', 'N', NULL, NULL, NULL, 447);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150060', '1510', 'PA', '1590', '1505', '15015', '15', 'ALTAMIRA', NULL, '93', '68371970', '2', '0411', '0411', '12006', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 159695.938, '-3,20300', '-52,20600', 109, 'S', 0.7370, NULL, NULL, '15900', 'N', 'N', 131, NULL, '1590', '1590', NULL, '1911', 'S', 2419, 'ALTAMIRA', 'N', '150060', 'S', 'N', 'S', NULL, 95, 'S', 'N', 'S', '8', NULL, '01', 'N', NULL, NULL, NULL, 456);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314340', '3110', 'MG', '3101', '3110', '31051', '31', 'MONTE SIAO', NULL, '35', '37580000', '1', '4867', '4867', '11434', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 290.201, '-22,43300', '-46,57300', 857, 'S', 0.8110, NULL, NULL, '31007', 'N', 'N', 3121, NULL, '3190', '3190', NULL, '1936', 'S', 1855, 'MONTE SIÃO', 'N', '314340', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '500', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314345', '3106', 'MG', '3108', '3102', '31005', '31', 'MONTEZUMA', NULL, '38', '39547000', '0', '2697', '2697', '11747', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 1133.739, '-15,17200', '-42,49700', 950, 'S', 0.5890, NULL, NULL, '31056', 'S', 'N', 3129, NULL, '3190', '3190', NULL, '1993', 'S', 1857, 'MONTEZUMA', 'N', '314345', 'N', 'S', 'S', NULL, 7, 'N', 'N', 'N', '502', NULL, '03', 'N', NULL, NULL, NULL, 348);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150140', '1501', 'PA', '1590', '1503', '15007', '15', 'BELEM', NULL, '91', '66017970', '2', '0427', '0427', '12014', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'S', 1064.918, '-1,45600', '-48,50400', 10, 'S', 0.8060, NULL, NULL, '15900', 'N', 'N', 572, NULL, '1501', '1501', NULL, '1616', 'S', 2430, 'BELÉM', 'N', '150140', 'S', 'N', 'S', NULL, NULL, 'S', 'S', 'S', '19', NULL, '01', 'N', NULL, NULL, NULL, 450);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110002', '1104', 'RO', '1190', '1102', '11003', '11', 'ARIQUEMES', NULL, '69', '78932000', '3', '0007', '0007', '26004', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4426.558, '-9,91300', '-63,04100', 142, 'S', 0.7520, NULL, NULL, '11900', 'N', 'N', 378, NULL, '1190', '1190', NULL, '1977', 'S', 3844, 'ARIQUEMES', 'N', '110002', 'S', 'N', 'S', NULL, 98, 'S', 'N', 'S', '5', NULL, '01', 'N', NULL, NULL, NULL, 149);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110004', '1102', 'RO', '1190', '1102', '11006', '11', 'CACOAL', NULL, '69', '78975000', '9', '0009', '0009', '26007', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 3792.638, '-11,43800', '-61,44800', 200, 'S', 0.7550, NULL, NULL, '11900', 'N', 'N', 851, NULL, '1190', '1190', NULL, '1977', 'S', 3848, 'CACOAL', 'N', '110004', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'S', '9', NULL, '01', 'N', NULL, NULL, NULL, 86);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('110020', '1104', 'RO', '1190', '1101', '11001', '11', 'PORTO VELHO', NULL, '69', '78900900', '5', '0003', '0003', '26002', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'S', 34082.366, '-8,76200', '-63,90400', 85, 'S', 0.7630, NULL, NULL, '11900', 'N', 'N', 3927, NULL, '1190', '1101', NULL, '1943', 'S', 3876, 'PORTO VELHO', 'N', '110020', 'S', 'N', 'S', NULL, 53, 'S', 'S', 'S', '37', NULL, '01', 'N', NULL, NULL, NULL, 87);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('140015', '1401', 'RR', '1490', '1401', '14002', '14', 'BONFIM', NULL, '95', '69380000', '9', '0307', '0307', '27004', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 8095.319, '3,36000', '-59,83300', 92, 'S', 0.6540, NULL, NULL, '14900', 'S', 'N', 697, NULL, '1490', '1490', NULL, '1982', 'S', 3895, 'BONFIM', 'N', '140015', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '4', NULL, '03', 'N', NULL, NULL, NULL, 207);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314350', '3114', 'MG', '3103', '3106', '31024', '31', 'MORADA NOVA DE MINAS', NULL, '38', '35628000', '0', '4869', '4869', '11435', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2084.612, '-18,60400', '-45,35700', 586, 'S', 0.7600, NULL, NULL, '31024', 'N', 'N', 3133, NULL, '3190', '3190', NULL, '1943', 'S', 1858, 'MORADA NOVA DE MINAS', 'N', '314350', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '503', NULL, '03', 'N', NULL, NULL, NULL, 58);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314360', '3114', 'MG', '3103', '3106', '31025', '31', 'MORRO DA GARCA', NULL, '38', '35798000', '9', '4871', '4871', '11436', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 414.009, '-18,54700', '-44,60300', 600, 'S', 0.6800, NULL, NULL, '31019', 'S', 'N', 3148, NULL, '3190', '3190', NULL, '1962', 'S', 1859, 'MORRO DA GARÇA', 'N', '314360', 'N', 'N', 'S', NULL, 48, 'N', 'N', 'N', '504', NULL, '03', 'N', NULL, NULL, NULL, 65);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314370', '3109', 'MG', '3103', '3107', '31028', '31', 'MORRO DO PILAR', NULL, '31', '35875000', '8', '4873', '4873', '11437', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 476.473, '-19,21600', '-43,37600', 622, 'S', 0.6820, NULL, NULL, '31021', 'S', 'N', 3151, NULL, '3190', '3190', NULL, '1953', 'S', 1860, 'MORRO DO PILAR', 'N', '314370', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '505', NULL, '03', 'N', NULL, NULL, NULL, 190);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('170830', '1707', 'TO', '1790', '1701', '17003', '17', 'GOIANORTE', NULL, '63', '77695000', '4', '9699', '9699', '28034', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1800.974, '-8,77600', '-48,93200', 256, 'S', 0.6400, NULL, NULL, '17900', 'S', 'N', 1906, NULL, '1790', '1790', NULL, '1989', 'S', 5442, 'GOIANORTE', 'N', '170830', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '56', NULL, '03', 'N', NULL, NULL, NULL, 504);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171330', '1703', 'TO', '1790', '1701', '17003', '17', 'MIRANORTE', NULL, '63', '77660000', '4', '9463', '9463', '28044', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1031.616, '-9,52900', '-48,59000', 222, 'S', 0.7060, NULL, NULL, '17900', 'S', 'N', 3053, NULL, '1790', '1790', NULL, '1989', 'S', 5463, 'MIRANORTE', 'N', '171330', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '77', NULL, '03', 'N', NULL, NULL, NULL, 163);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('171900', '1701', 'TO', '1790', '1702', '17007', '17', 'SANTA TEREZA DO TOCANTINS', NULL, '63', '77615000', '4', '9731', '9731', '28069', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 539.908, '-10,28200', '-47,80800', 263, 'S', 0.6680, NULL, NULL, '17900', 'S', 'N', 4425, NULL, '1790', '1790', NULL, '1989', 'S', 5506, 'SANTA TEREZA DO TOCANTINS', 'N', '171900', 'S', 'N', 'S', NULL, 107, 'N', 'N', 'N', '120', NULL, '03', 'N', NULL, NULL, NULL, 163);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('172000', '1712', 'TO', '1790', '1701', '17001', '17', 'SANTA TEREZINHA DO TOCANTINS', NULL, '63', '77885000', '2', '0098', NULL, '28139', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 269.676, '-6,43400', '-47,67300', 250, 'S', 0.5850, NULL, NULL, '17900', 'S', 'N', 4432, NULL, '1790', '1790', NULL, '1997', 'S', 5507, 'SANTA TEREZINHA DO TOCANTINS', 'N', '172000', 'S', 'N', 'S', NULL, 22, 'N', 'N', 'N', '121', NULL, '03', 'N', NULL, NULL, NULL, 387);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314380', '3110', 'MG', '3101', '3110', '31052', '31', 'MUNHOZ', NULL, '35', '37620000', '7', '4875', '4875', '11438', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 190.563, '-22,61300', '-46,36100', 1235, 'S', 0.7430, NULL, NULL, '31007', 'N', 'N', 3178, NULL, '3190', '3190', NULL, '1953', 'S', 1861, 'MUNHOZ', 'N', '314380', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '506', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314390', '3118', 'MG', '3107', '3112', '31063', '31', 'MURIAE', NULL, '32', '36880000', '6', '4877', '4877', '11439', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 843.327, '-21,13100', '-42,36600', 209, 'S', 0.7730, NULL, NULL, '31045', 'N', 'N', 3184, NULL, '3190', '3190', NULL, '1855', 'S', 1862, 'MURIAÉ', 'N', '314390', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '507', NULL, '02', 'N', NULL, NULL, NULL, 130);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314400', '3124', 'MG', '3110', '3108', '31041', '31', 'MUTUM', NULL, '33', '36955000', '3', '4879', '4879', '11440', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1255.800, '-19,80000', '-41,43800', 230, 'S', 0.7120, NULL, NULL, '31059', 'N', 'N', 3192, NULL, '3190', '3190', NULL, '1912', 'S', 1863, 'MUTUM', 'N', '314400', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '508', NULL, '03', 'N', NULL, NULL, NULL, 191);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314410', '3121', 'MG', '3101', '3110', '31048', '31', 'MUZAMBINHO', NULL, '35', '37890000', '2', '4881', '4881', '11441', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 409.036, '-21,37600', '-46,52600', 1048, 'S', 0.8010, NULL, NULL, '31002', 'N', 'N', 3194, NULL, '3190', '3190', NULL, '1878', 'S', 1864, 'MUZAMBINHO', 'N', '314410', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '509', NULL, '03', 'N', NULL, NULL, NULL, 302);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314420', '3116', 'MG', '3106', '3108', '31037', '31', 'NACIP RAYDAN', NULL, '33', '39718000', '1', '4883', '4883', '11442', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 228.587, '-18,45900', '-42,24900', 332, 'S', 0.6110, NULL, NULL, '31036', 'S', 'N', 3195, NULL, '3190', '3190', NULL, '1962', 'S', 1865, 'NACIP RAYDAN', 'N', '314420', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '510', NULL, '03', 'N', NULL, NULL, NULL, 189);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314430', '3117', 'MG', '3111', '3104', '31016', '31', 'NANUQUE', NULL, '33', '39860000', '0', '4885', '4885', '11443', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1515.370, '-17,83900', '-40,35400', 103, 'S', 0.7080, NULL, NULL, '31066', 'N', 'N', 3197, NULL, '3190', '3190', NULL, '1948', 'S', 1866, 'NANUQUE', 'N', '314430', 'N', 'S', 'S', NULL, 99, 'N', 'N', 'N', '511', NULL, '03', 'N', NULL, NULL, NULL, 304);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314435', '3123', 'MG', '3106', '3108', '31039', '31', 'NAQUE', NULL, '33', '35157000', '9', '0656', NULL, '11748', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 129.304, '-19,23000', '-42,32800', 330, 'S', 0.7030, NULL, NULL, '31037', 'N', 'N', 3199, NULL, '3104', '3190', NULL, '1997', 'S', 1867, 'NAQUE', 'N', '314435', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '512', NULL, '03', 'N', NULL, NULL, NULL, 358);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314437', '3126', 'MG', '3109', '3101', '31001', '31', 'NATALANDIA', NULL, '38', '38658000', '5', '0658', NULL, '11815', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 471.355, '-16,50400', '-46,49300', 550, 'S', 0.7220, NULL, NULL, '31058', 'N', 'N', 3202, NULL, '3190', '3190', NULL, '1997', 'S', 1868, 'NATALÂNDIA', 'N', '314437', 'N', 'N', 'S', NULL, 63, 'N', 'N', 'N', '513', NULL, '03', 'N', NULL, NULL, NULL, 295);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314440', '3110', 'MG', '3101', '3110', '31053', '31', 'NATERCIA', NULL, '35', '37524000', '9', '4887', '4887', '11444', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 190.422, '-22,12000', '-45,51200', 918, 'S', 0.7840, NULL, NULL, '31007', 'N', 'N', 3203, NULL, '3190', '3190', NULL, '1923', 'S', 1869, 'NATÉRCIA', 'N', '314440', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '514', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314450', '3120', 'MG', '3102', '3111', '31058', '31', 'NAZARENO', NULL, '35', '36370000', '8', '4889', '4889', '11445', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 323.510, '-21,21600', '-44,61100', 935, 'S', 0.7260, NULL, NULL, '31015', 'N', 'N', 3215, NULL, '3190', '3190', NULL, '1953', 'S', 1870, 'NAZARENO', 'N', '314450', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '515', NULL, '03', 'N', NULL, NULL, NULL, 114);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314460', '3111', 'MG', '3101', '3111', '31057', '31', 'NEPOMUCENO', NULL, '35', '37250000', '7', '4891', '4891', '11446', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 582.033, '-21,23600', '-45,23600', 840, 'S', 0.7470, NULL, NULL, '31004', 'N', 'N', 3219, NULL, '3190', '3190', NULL, '1911', 'S', 1871, 'NEPOMUCENO', 'N', '314460', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '516', NULL, '03', 'N', NULL, NULL, NULL, 19);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314465', '3106', 'MG', '3108', '3102', '31005', '31', 'NINHEIRA', NULL, '38', '39553000', '6', '0660', NULL, '11816', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1114.242, '-15,32100', '-41,75400', 900, 'S', 0.6040, NULL, NULL, '31056', 'S', 'N', 3228, NULL, '3190', '3190', NULL, '1997', 'S', 1872, 'NINHEIRA', 'N', '314465', 'N', 'S', 'S', NULL, 7, 'S', 'N', 'N', '517', NULL, '03', 'N', NULL, NULL, NULL, 348);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314467', '3116', 'MG', '3106', '3108', '31038', '31', 'NOVA BELEM', NULL, '33', '35298000', '2', '0662', NULL, '11817', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 148.789, '-18,47500', '-41,01700', 349, 'S', 0.6480, NULL, NULL, '31038', 'S', 'N', 3260, NULL, '3190', '3190', NULL, '1997', 'S', 1873, 'NOVA BELÉM', 'N', '314467', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '518', NULL, '03', 'N', NULL, NULL, NULL, 66);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314470', '3109', 'MG', '3103', '3107', '31031', '31', 'NOVA ERA', NULL, '31', '35920000', '6', '4893', '4893', '11447', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 363.195, '-19,75000', '-43,03800', 529, 'S', 0.7920, NULL, NULL, '31023', 'N', 'N', 3275, NULL, '3190', '3190', NULL, '1938', 'S', 1874, 'NOVA ERA', 'N', '314470', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '519', NULL, '03', 'N', NULL, NULL, NULL, 18);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314480', '3101', 'MG', '3103', '3107', '31030', '31', 'NOVA LIMA', NULL, '31', '34000000', '5', '4895', '4895', '11448', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 428.449, '-19,98600', '-43,84700', 744, 'S', 0.8210, NULL, NULL, '31016', 'N', 'N', 3301, NULL, '3101', '3101', NULL, '1891', 'S', 1875, 'NOVA LIMA', 'N', '314480', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '520', NULL, '01', 'N', NULL, NULL, NULL, 410);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314490', '3117', 'MG', '3111', '3108', '31037', '31', 'NOVA MODICA', NULL, '33', '35113000', '4', '4897', '4897', '11449', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 377.009, '-18,43700', '-41,50100', 342, 'S', 0.6590, NULL, NULL, '31069', 'S', 'N', 3306, NULL, '3190', '3190', NULL, '1962', 'S', 1876, 'NOVA MÓDICA', 'N', '314490', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '521', NULL, '03', 'N', NULL, NULL, NULL, 292);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314500', '3112', 'MG', '3113', '3105', '31023', '31', 'NOVA PONTE', NULL, '34', '38160000', '0', '4899', '4899', '11450', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1105.766, '-19,13600', '-47,68300', 791, 'S', 0.8030, NULL, NULL, '31075', 'N', 'N', 3321, NULL, '3190', '3190', NULL, '1938', 'S', 1877, 'NOVA PONTE', 'N', '314500', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '522', NULL, '03', 'N', NULL, NULL, NULL, 116);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314505', '3106', 'MG', '3108', '3102', '31004', '31', 'NOVA PORTEIRINHA', NULL, '38', '39525000', '9', '0664', NULL, '11818', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 121.017, '-15,80300', '-43,30100', 533, 'S', 0.6850, NULL, NULL, '31052', 'S', 'N', 3322, NULL, '3190', '3190', NULL, '1997', 'S', 1878, 'NOVA PORTEIRINHA', 'N', '314505', 'N', 'S', 'S', NULL, 79, 'N', 'N', 'N', '523', NULL, '03', 'N', NULL, NULL, NULL, 128);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314510', '3121', 'MG', '3101', '3110', '31048', '31', 'NOVA RESENDE', NULL, '35', '37860000', '9', '4901', '4901', '11451', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 390.181, '-21,12600', '-46,42000', 1184, 'S', 0.7270, NULL, NULL, '31002', 'N', 'N', 3327, NULL, '3190', '3190', NULL, '1901', 'S', 1879, 'NOVA RESENDE', 'N', '314510', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '524', NULL, '03', 'N', NULL, NULL, NULL, 302);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314520', '3115', 'MG', '3105', '3109', '31043', '31', 'NOVA SERRANA', NULL, '37', '35519000', '8', '4903', '4903', '11452', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 283.101, '-19,87600', '-44,98400', 761, 'S', 0.8010, NULL, NULL, '31032', 'N', 'N', 3335, NULL, '3190', '3190', NULL, '1953', 'S', 1880, 'NOVA SERRANA', 'N', '314520', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '525', NULL, '02', 'N', NULL, NULL, NULL, 131);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314530', '3117', 'MG', '3111', '3103', '31012', '31', 'NOVO CRUZEIRO', NULL, '33', '39820000', '7', '4905', '4905', '11453', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 1700.601, '-17,46800', '-41,87500', 980, 'S', 0.6290, NULL, NULL, '31069', 'N', 'N', 3356, NULL, '3190', '3190', NULL, '1943', 'S', 1882, 'NOVO CRUZEIRO', 'N', '314530', 'N', 'S', 'S', NULL, 57, 'N', 'N', 'N', '527', NULL, '03', 'N', NULL, NULL, NULL, 292);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314535', '3117', 'MG', '3111', '3104', '31015', '31', 'NOVO ORIENTE DE MINAS', NULL, '33', '39817000', '6', '0666', NULL, '11749', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 754.084, '-17,41500', '-41,21500', 400, 'S', 0.5820, NULL, NULL, '31062', 'S', 'N', 3371, NULL, '3190', '3190', NULL, '1997', 'S', 1883, 'NOVO ORIENTE DE MINAS', 'N', '314535', 'N', 'S', 'S', NULL, 99, 'N', 'N', 'N', '528', NULL, '03', 'N', NULL, NULL, NULL, 292);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314537', '3106', 'MG', '3108', '3102', '31005', '31', 'NOVORIZONTE', NULL, '38', '39568000', '2', '0668', NULL, '11819', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 264.076, '-16,01700', '-42,40800', 920, 'S', 0.6480, NULL, NULL, '31056', 'S', 'N', 3380, NULL, '3190', '3190', NULL, '1997', 'S', 1884, 'NOVORIZONTE', 'N', '314537', 'N', 'S', 'S', NULL, 7, 'N', 'N', 'N', '529', NULL, '03', 'N', NULL, NULL, NULL, 348);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314540', '3105', 'MG', '3107', '3112', '31065', '31', 'OLARIA', NULL, '32', '36145000', '6', '4907', '4907', '11454', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 178.493, '-21,86100', '-43,93700', 912, 'S', 0.6900, NULL, NULL, '31043', 'S', 'N', 3388, NULL, '3190', '3190', NULL, '1962', 'S', 1885, 'OLARIA', 'N', '314540', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '530', NULL, '03', 'N', NULL, NULL, NULL, 360);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314545', '3106', 'MG', '3108', '3102', '31009', '31', 'OLHOS-D''AGUA', NULL, '38', '39398000', '5', '0670', NULL, '11820', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 2086.383, '-17,39700', '-43,57300', 751, 'S', 0.6690, NULL, NULL, '31054', 'S', 'N', 3397, NULL, '3190', '3190', NULL, '1997', 'S', 1886, 'OLHOS-D ÁGUA', 'N', '314545', 'N', 'S', 'S', NULL, 48, 'S', 'N', 'N', '531', NULL, '03', 'N', NULL, NULL, NULL, 192);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314550', '3111', 'MG', '3101', '3110', '31054', '31', 'OLIMPIO NORONHA', NULL, '35', '37488000', '5', '4909', '4909', '11455', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 53.930, '-22,06800', '-45,26400', 890, 'S', 0.7470, NULL, NULL, '31008', 'N', 'N', 3399, NULL, '3190', '3190', NULL, '1962', 'S', 1887, 'OLÍMPIO NORONHA', 'N', '314550', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '532', NULL, '03', 'N', NULL, NULL, NULL, 57);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314560', '3115', 'MG', '3105', '3109', '31046', '31', 'OLIVEIRA', NULL, '37', '35540000', '4', '4911', '4911', '11456', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 896.494, '-20,69600', '-44,82700', 982, 'S', 0.7700, NULL, NULL, '31033', 'N', 'N', 3404, NULL, '3190', '3190', NULL, '1839', 'S', 1888, 'OLIVEIRA', 'N', '314560', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '533', NULL, '03', 'N', NULL, NULL, NULL, 235);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314570', '3105', 'MG', '3107', '3112', '31065', '31', 'OLIVEIRA FORTES', NULL, '32', '36250000', '3', '4913', '4913', '11457', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 110.850, '-21,33900', '-43,45600', 851, 'S', 0.6950, NULL, NULL, '31046', 'S', 'N', 3407, NULL, '3190', '3190', NULL, '1953', 'S', 1889, 'OLIVEIRA FORTES', 'N', '314570', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '534', NULL, '03', 'N', NULL, NULL, NULL, 180);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314580', '3115', 'MG', '3105', '3107', '31029', '31', 'ONCA DE PITANGUI', NULL, '37', '35655000', '2', '4915', '4915', '11458', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 247.052, '-19,73000', '-44,80700', 741, 'S', 0.7580, NULL, NULL, '31032', 'N', 'N', 3409, NULL, '3190', '3190', NULL, '1962', 'S', 1890, 'ONÇA DE PITANGUI', 'N', '314580', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '535', NULL, '03', 'N', NULL, NULL, NULL, 131);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314587', '3124', 'MG', '3107', '3112', '31063', '31', 'ORIZANIA', NULL, '32', '36828000', '7', '0674', NULL, '11822', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 121.550, '-20,50600', '-42,21000', 819, 'S', 0.6480, NULL, NULL, '31042', 'S', 'N', 3415, NULL, '3190', '3190', NULL, '1997', 'S', 1892, 'ORIZÂNIA', 'N', '314587', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '537', NULL, '03', 'N', NULL, NULL, NULL, 412);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314590', '3103', 'MG', '3102', '3107', '31034', '31', 'OURO BRANCO', NULL, '31', '36420000', '1', '4917', '4917', '11459', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 260.766, '-20,52100', '-43,69200', 1052, 'S', 0.8010, NULL, NULL, '31014', 'N', 'N', 3435, NULL, '3190', '3190', NULL, '1953', 'S', 1893, 'OURO BRANCO', 'N', '314590', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '538', NULL, '03', 'N', NULL, NULL, NULL, 187);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314600', '3110', 'MG', '3101', '3110', '31051', '31', 'OURO FINO', NULL, '35', '37570000', '8', '4919', '4919', '11460', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 533.795, '-22,28300', '-46,36900', 908, 'S', 0.7980, NULL, NULL, '31007', 'N', 'N', 3438, NULL, '3190', '3190', NULL, '1880', 'S', 1894, 'OURO FINO', 'N', '314600', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '539', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314610', '3101', 'MG', '3103', '3107', '31033', '31', 'OURO PRETO', NULL, '31', '35400000', '7', '4921', '4921', '11461', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1245.114, '-20,28800', '-43,50800', 1179, 'S', 0.7870, NULL, NULL, '31022', 'N', 'N', 3439, NULL, '3190', '3190', NULL, '1711', 'S', 1895, 'OURO PRETO', 'N', '314610', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '540', NULL, '02', 'N', NULL, NULL, NULL, 193);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314620', '3117', 'MG', '3111', '3104', '31015', '31', 'OURO VERDE DE MINAS', NULL, '33', '39855000', '6', '4923', '4923', '11462', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 174.990, '-18,07100', '-41,27000', 380, 'S', 0.6150, NULL, NULL, '31069', 'S', 'N', 3445, NULL, '3190', '3190', NULL, '1962', 'S', 1896, 'OURO VERDE DE MINAS', 'N', '314620', 'N', 'S', 'S', NULL, 99, 'N', 'N', 'N', '541', NULL, '03', 'N', NULL, NULL, NULL, 292);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314625', '3106', 'MG', '3108', '3102', '31008', '31', 'PADRE CARVALHO', NULL, '38', '39573000', '5', '0676', NULL, '11823', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 449.963, '-16,36400', '-42,51500', 750, 'S', 0.6180, NULL, NULL, '31056', 'S', 'N', 3460, NULL, '3190', '3190', NULL, '1997', 'S', 1897, 'PADRE CARVALHO', 'N', '314625', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '542', NULL, '03', 'N', NULL, NULL, NULL, 348);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314630', '3117', 'MG', '3111', '3103', '31012', '31', 'PADRE PARAISO', NULL, '33', '39818000', '5', '4925', '4925', '11463', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 543.942, '-17,07200', '-41,52400', 930, 'S', 0.6560, NULL, NULL, '31067', 'S', 'N', 3462, NULL, '3190', '3190', NULL, '1962', 'S', 1898, 'PADRE PARAÍSO', 'N', '314630', 'N', 'S', 'S', NULL, 57, 'N', 'N', 'N', '543', NULL, '03', 'N', NULL, NULL, NULL, 20);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314640', '3114', 'MG', '3103', '3106', '31024', '31', 'PAINEIRAS', NULL, '37', '35622000', '4', '4927', '4927', '11464', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 637.751, '-18,90800', '-45,53200', 637, 'S', 0.7580, NULL, NULL, '31024', 'N', 'N', 3468, NULL, '3190', '3190', NULL, '1962', 'S', 1900, 'PAINEIRAS', 'N', '314640', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '545', NULL, '03', 'N', NULL, NULL, NULL, 58);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314650', '3115', 'MG', '3105', '3109', '31044', '31', 'PAINS', NULL, '37', '35582000', '3', '4929', '4929', '11465', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 418.043, '-20,37100', '-45,66100', 693, 'S', 0.7830, NULL, NULL, '31030', 'N', 'N', 3470, NULL, '3190', '3190', NULL, '1943', 'S', 1901, 'PAINS', 'N', '314650', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '546', NULL, '03', 'N', NULL, NULL, NULL, 15);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314655', '3106', 'MG', '3108', '3102', '31004', '31', 'PAI PEDRO', NULL, '38', '39517000', '2', '0678', NULL, '11824', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 785.106, '-15,51700', '-43,06500', 520, 'S', 0.5750, NULL, NULL, '31052', 'S', 'N', 3464, NULL, '3190', '3190', NULL, '1997', 'S', 1899, 'PAI PEDRO', 'N', '314655', 'N', 'S', 'S', NULL, 79, 'N', 'N', 'N', '544', NULL, '03', 'N', NULL, NULL, NULL, 128);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314660', '3103', 'MG', '3102', '3112', '31065', '31', 'PAIVA', NULL, '32', '36195000', '2', '4931', '4931', '11466', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 58.313, '-21,28900', '-43,41600', 568, 'S', 0.7080, NULL, NULL, '31013', 'N', 'N', 3471, NULL, '3190', '3190', NULL, '1953', 'S', 1902, 'PAIVA', 'N', '314660', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '547', NULL, '03', 'N', NULL, NULL, NULL, 241);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314670', '3127', 'MG', '3107', '3112', '31066', '31', 'PALMA', NULL, '32', '36750000', '1', '4933', '4933', '11467', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 317.983, '-21,37500', '-42,31400', 172, 'S', 0.7440, NULL, NULL, '31044', 'N', 'N', 3479, NULL, '3190', '3190', NULL, '1890', 'S', 1903, 'PALMA', 'N', '314670', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '548', NULL, '03', 'N', NULL, NULL, NULL, 246);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314675', '3119', 'MG', '3111', '3103', '31014', '31', 'PALMOPOLIS', NULL, '33', '39945000', '0', '2661', '2661', '11750', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 436.471, '-16,73500', '-40,42000', 600, 'S', 0.6150, NULL, NULL, '31063', 'S', 'N', 3508, NULL, '3190', '3190', NULL, '1993', 'S', 1904, 'PALMÓPOLIS', 'N', '314675', 'N', 'S', 'S', NULL, 117, 'N', 'N', 'N', '549', NULL, '03', 'N', NULL, NULL, NULL, 125);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314690', '3114', 'MG', '3103', '3107', '31027', '31', 'PAPAGAIOS', NULL, '37', '35669000', '9', '4937', '4937', '11469', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 552.776, '-19,44900', '-44,74800', 718, 'S', 0.7360, NULL, NULL, '31024', 'N', 'N', 3517, NULL, '3190', '3190', NULL, '1953', 'S', 1905, 'PAPAGAIOS', 'N', '314690', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '550', NULL, '03', 'N', NULL, NULL, NULL, 58);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314700', '3126', 'MG', '3109', '3101', '31002', '31', 'PARACATU', NULL, '38', '38600000', '6', '4939', '4939', '11470', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 8232.233, '-17,22200', '-46,87500', 687, 'S', 0.7600, NULL, NULL, '31058', 'N', 'N', 3522, NULL, '3190', '3190', NULL, '1798', 'S', 1907, 'PARACATU', 'N', '314700', 'N', 'N', 'S', NULL, 63, 'N', 'N', 'N', '552', NULL, '02', 'N', NULL, NULL, NULL, 295);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314710', '3115', 'MG', '3105', '3107', '31029', '31', 'PARA DE MINAS', NULL, '37', '35660000', '5', '4941', '4941', '11471', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 550.991, '-19,86000', '-44,60800', 791, 'S', 0.8110, NULL, NULL, '31032', 'N', 'N', 3520, NULL, '3102', '3190', NULL, '1874', 'S', 1906, 'PARÁ DE MINAS', 'N', '314710', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '551', NULL, '02', 'N', NULL, NULL, NULL, 131);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314720', '3121', 'MG', '3101', '3110', '31049', '31', 'PARAGUACU', NULL, '35', '37120000', '4', '4943', '4943', '11472', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 425.026, '-21,54700', '-45,73800', 826, 'S', 0.7880, NULL, NULL, '31001', 'N', 'N', 3525, NULL, '3190', '3190', NULL, '1911', 'S', 1908, 'PARAGUAÇU', 'N', '314720', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '553', NULL, '03', 'N', NULL, NULL, NULL, 300);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314730', '3110', 'MG', '3101', '3110', '31056', '31', 'PARAISOPOLIS', NULL, '35', '37660000', '3', '4945', '4945', '11473', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 331.510, '-22,55400', '-45,78000', 931, 'S', 0.7790, NULL, NULL, '31003', 'N', 'N', 3537, NULL, '3190', '3190', NULL, '1872', 'S', 1909, 'PARAISÓPOLIS', 'N', '314730', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '554', NULL, '03', 'N', NULL, NULL, NULL, 16);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314740', '3114', 'MG', '3103', '3107', '31027', '31', 'PARAOPEBA', NULL, '31', '35774000', '2', '4947', '4947', '11474', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 625.053, '-19,27400', '-44,40400', 733, 'S', 0.7670, NULL, NULL, '31024', 'N', 'N', 3555, NULL, '3190', '3190', NULL, '1911', 'S', 1910, 'PARAOPEBA', 'N', '314740', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '555', NULL, '03', 'N', NULL, NULL, NULL, 58);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314750', '3109', 'MG', '3103', '3107', '31028', '31', 'PASSABEM', NULL, '31', '35810000', '1', '4949', '4949', '11475', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 94.538, '-19,35300', '-43,13600', 678, 'S', 0.6940, NULL, NULL, '31021', 'S', 'N', 3585, NULL, '3190', '3190', NULL, '1962', 'S', 1914, 'PASSABÉM', 'N', '314750', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '559', NULL, '03', 'N', NULL, NULL, NULL, 190);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314760', '3111', 'MG', '3101', '3110', '31054', '31', 'PASSA QUATRO', NULL, '35', '37460000', '0', '4951', '4951', '11476', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 276.568, '-22,39000', '-44,96700', 938, 'S', 0.7770, NULL, NULL, '31008', 'N', 'N', 3581, NULL, '3190', '3190', NULL, '1888', 'S', 1911, 'PASSA QUATRO', 'N', '314760', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '556', NULL, '03', 'N', NULL, NULL, NULL, 57);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314770', '3115', 'MG', '3105', '3109', '31046', '31', 'PASSA TEMPO', NULL, '37', '35537000', '9', '4953', '4953', '11477', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 429.444, '-20,65100', '-44,49600', 980, 'S', 0.7690, NULL, NULL, '31033', 'N', 'N', 3583, NULL, '3190', '3190', NULL, '1911', 'S', 1912, 'PASSA TEMPO', 'N', '314770', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '557', NULL, '03', 'N', NULL, NULL, NULL, 235);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314780', '3105', 'MG', '3107', '3110', '31055', '31', 'PASSA-VINTE', NULL, '32', '37330000', '8', '4955', '4955', '11478', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 245.649, '-22,20900', '-44,23400', 752, 'S', 0.7400, NULL, NULL, '31043', 'N', 'N', 3584, NULL, '3190', '3190', NULL, '1953', 'S', 1913, 'PASSA-VINTE', 'N', '314780', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '558', NULL, '03', 'N', NULL, NULL, NULL, 360);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314790', '3122', 'MG', '3101', '3110', '31047', '31', 'PASSOS', NULL, '35', '37900000', '7', '4957', '4957', '11479', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1339.199, '-20,71900', '-46,61000', 745, 'S', 0.7970, NULL, NULL, '31005', 'N', 'N', 3595, NULL, '3190', '3190', NULL, '1848', 'S', 1915, 'PASSOS', 'N', '314790', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '560', NULL, '01', 'N', NULL, NULL, NULL, 361);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314795', '3129', 'MG', '3108', '3102', '31007', '31', 'PATIS', NULL, '38', '39425000', '6', '0680', NULL, '11825', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 444.646, '-16,07600', '-44,08200', 752, 'S', 0.6050, NULL, NULL, '31049', 'S', 'N', 3598, NULL, '3190', '3190', NULL, '1997', 'S', 1916, 'PATIS', 'N', '314795', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '561', NULL, '03', 'N', NULL, NULL, NULL, 243);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314800', '3107', 'MG', '3109', '3105', '31020', '31', 'PATOS DE MINAS', NULL, '34', '38700000', '4', '4959', '4959', '11480', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3189.006, '-18,57900', '-46,51800', 832, 'S', 0.8130, NULL, NULL, '31057', 'N', 'N', 3602, NULL, '3190', '3190', NULL, '1866', 'S', 1917, 'PATOS DE MINAS', 'N', '314800', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '562', NULL, '01', 'N', NULL, NULL, NULL, 194);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314810', '3112', 'MG', '3113', '3105', '31019', '31', 'PATROCINIO', NULL, '34', '38740000', '3', '4961', '4961', '11481', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2866.559, '-18,94400', '-46,99300', 965, 'S', 0.7990, NULL, NULL, '31074', 'N', 'N', 3604, NULL, '3190', '3190', NULL, '1840', 'S', 1918, 'PATROCÍNIO', 'N', '314810', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '563', NULL, '02', 'N', NULL, NULL, NULL, 247);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314820', '3118', 'MG', '3107', '3112', '31063', '31', 'PATROCINIO DO MURIAE', NULL, '32', '36860000', '2', '4963', '4963', '11482', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 108.471, '-21,15300', '-42,21500', 179, 'S', 0.7420, NULL, NULL, '31045', 'N', 'N', 3605, NULL, '3190', '3190', NULL, '1953', 'S', 1919, 'PATROCÍNIO DO MURIAÉ', 'N', '314820', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '564', NULL, '03', 'N', NULL, NULL, NULL, 130);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314830', '3108', 'MG', '3110', '3112', '31062', '31', 'PAULA CANDIDO', NULL, '32', '36544000', '1', '4965', '4965', '11483', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 268.740, '-20,87400', '-42,98000', 731, 'S', 0.6990, NULL, NULL, '31061', 'S', 'N', 3615, NULL, '3190', '3190', NULL, '1953', 'S', 1920, 'PAULA CÂNDIDO', 'N', '314830', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '565', NULL, '03', 'N', NULL, NULL, NULL, 117);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314840', '3116', 'MG', '3106', '3108', '31035', '31', 'PAULISTAS', NULL, '33', '39765000', '0', '4967', '4967', '11484', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 220.075, '-18,42700', '-42,86800', 747, 'S', 0.6870, NULL, NULL, '31039', 'S', 'N', 3624, NULL, '3190', '3190', NULL, '1953', 'S', 1921, 'PAULISTAS', 'N', '314840', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '566', NULL, '03', 'N', NULL, NULL, NULL, 179);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314850', '3117', 'MG', '3111', '3104', '31015', '31', 'PAVAO', NULL, '33', '39814000', '9', '4969', '4969', '11485', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 599.369, '-17,42800', '-40,99900', 228, 'S', 0.6670, NULL, NULL, '31062', 'S', 'N', 3631, NULL, '3190', '3190', NULL, '1962', 'S', 1922, 'PAVÃO', 'N', '314850', 'N', 'S', 'S', NULL, 99, 'N', 'N', 'N', '567', NULL, '03', 'N', NULL, NULL, NULL, 62);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314860', '3116', 'MG', '3106', '3108', '31036', '31', 'PECANHA', NULL, '33', '39700000', '8', '4971', '4971', '11486', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 995.699, '-18,54900', '-42,55700', 780, 'S', 0.6350, NULL, NULL, '31039', 'S', 'N', 3636, NULL, '3190', '3190', NULL, '1875', 'S', 1923, 'PEÇANHA', 'N', '314860', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '568', NULL, '03', 'N', NULL, NULL, NULL, 179);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314870', '3119', 'MG', '3111', '3103', '31013', '31', 'PEDRA AZUL', NULL, '33', '39970000', '7', '4973', '4973', '11487', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 1618.686, '-16,00500', '-41,29700', 617, 'S', 0.6600, NULL, NULL, '31068', 'S', 'N', 3639, NULL, '3190', '3190', NULL, '1911', 'S', 1924, 'PEDRA AZUL', 'N', '314870', 'N', 'S', 'S', NULL, 57, 'N', 'N', 'N', '569', NULL, '03', 'N', NULL, NULL, NULL, 21);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314875', '3124', 'MG', '3107', '3112', '31061', '31', 'PEDRA BONITA', NULL, '31', '35364000', '6', '0682', NULL, '11826', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 163.504, '-20,52100', '-42,33000', 900, 'S', 0.6850, NULL, NULL, '31042', 'S', 'N', 3641, NULL, '3190', '3190', NULL, '1997', 'S', 1925, 'PEDRA BONITA', 'N', '314875', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '570', NULL, '03', 'N', NULL, NULL, NULL, 412);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314880', '3108', 'MG', '3110', '3112', '31062', '31', 'PEDRA DO ANTA', NULL, '31', '36585000', '6', '4975', '4975', '11488', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 163.788, '-20,59700', '-42,71400', 632, 'S', 0.6640, NULL, NULL, '31061', 'S', 'N', 3645, NULL, '3190', '3190', NULL, '1962', 'S', 1926, 'PEDRA DO ANTA', 'N', '314880', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '571', NULL, '03', 'N', NULL, NULL, NULL, 117);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314890', '3115', 'MG', '3105', '3109', '31044', '31', 'PEDRA DO INDAIA', NULL, '37', '35565000', '5', '4977', '4977', '11489', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 349.092, '-20,25800', '-45,20900', 837, 'S', 0.7550, NULL, NULL, '31029', 'N', 'N', 3646, NULL, '3190', '3190', NULL, '1962', 'S', 1927, 'PEDRA DO INDAIÁ', 'N', '314890', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '572', NULL, '03', 'N', NULL, NULL, NULL, 413);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314900', '3124', 'MG', '3107', '3112', '31063', '31', 'PEDRA DOURADA', NULL, '32', '36847000', '2', '4979', '4979', '11490', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 70.362, '-20,83000', '-42,15400', 741, 'S', 0.7100, NULL, NULL, '31042', 'N', 'N', 3647, NULL, '3190', '3190', NULL, '1962', 'S', 1928, 'PEDRA DOURADA', 'N', '314900', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '573', NULL, '03', 'N', NULL, NULL, NULL, 412);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314910', '3110', 'MG', '3101', '3110', '31053', '31', 'PEDRALVA', NULL, '35', '37520000', '1', '4981', '4981', '11491', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 217.298, '-22,24300', '-45,46600', 911, 'S', 0.7400, NULL, NULL, '31003', 'N', 'N', 3653, NULL, '3190', '3190', NULL, '1884', 'S', 1929, 'PEDRALVA', 'N', '314910', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '574', NULL, '03', 'N', NULL, NULL, NULL, 16);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314915', '3129', 'MG', '3108', '3102', '31003', '31', 'PEDRAS DE MARIA DA CRUZ', NULL, '38', '39492000', '0', '2899', '2899', '11751', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1520.086, '-15,60700', '-44,39100', 476, 'S', 0.6340, NULL, NULL, '31053', 'S', 'N', 3657, NULL, '3190', '3190', NULL, '1993', 'S', 1930, 'PEDRAS DE MARIA DA CRUZ', 'N', '314915', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '575', NULL, '03', 'N', NULL, NULL, NULL, 129);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314920', '3113', 'MG', '3112', '3105', '31023', '31', 'PEDRINOPOLIS', NULL, '34', '38178000', '0', '4983', '4983', '11492', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 357.689, '-19,22800', '-47,46200', 918, 'S', 0.7890, NULL, NULL, '31070', 'N', 'N', 3664, NULL, '3190', '3190', NULL, '1962', 'S', 1931, 'PEDRINÓPOLIS', 'N', '314920', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '576', NULL, '03', 'N', NULL, NULL, NULL, 240);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314930', '3101', 'MG', '3103', '3107', '31030', '31', 'PEDRO LEOPOLDO', NULL, '31', '33600000', '9', '4985', '4985', '11493', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 291.038, '-19,61800', '-44,04300', 710, 'S', 0.8070, NULL, NULL, '31025', 'N', 'N', 3674, NULL, '3101', '3101', NULL, '1923', 'S', 1932, 'PEDRO LEOPOLDO', 'N', '314930', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '577', NULL, '01', 'N', NULL, NULL, NULL, 404);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314940', '3105', 'MG', '3107', '3112', '31065', '31', 'PEDRO TEIXEIRA', NULL, '32', '36148000', '8', '4987', '4987', '11494', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 113.074, '-21,70600', '-43,74600', 818, 'S', 0.6840, NULL, NULL, '31043', 'S', 'N', 3677, NULL, '3190', '3190', NULL, '1962', 'S', 1933, 'PEDRO TEIXEIRA', 'N', '314940', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '578', NULL, '03', 'N', NULL, NULL, NULL, 360);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314950', '3105', 'MG', '3107', '3112', '31065', '31', 'PEQUERI', NULL, '32', '36610000', '7', '4989', '4989', '11495', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 90.929, '-21,83400', '-43,12100', 571, 'S', 0.7460, NULL, NULL, '31047', 'N', 'N', 3691, NULL, '3190', '3190', NULL, '1953', 'S', 1934, 'PEQUERI', 'N', '314950', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '579', NULL, '03', 'N', NULL, NULL, NULL, 115);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314960', '3114', 'MG', '3103', '3107', '31027', '31', 'PEQUI', NULL, '37', '35667000', '6', '4991', '4991', '11496', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 204.142, '-19,63300', '-44,65900', 810, 'S', 0.7700, NULL, NULL, '31024', 'N', 'N', 3692, NULL, '3190', '3190', NULL, '1911', 'S', 1935, 'PEQUI', 'N', '314960', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '580', NULL, '03', 'N', NULL, NULL, NULL, 58);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314970', '3115', 'MG', '3105', '3109', '31043', '31', 'PERDIGAO', NULL, '37', '35515000', '5', '4993', '4993', '11497', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 249.845, '-19,95300', '-45,08400', 852, 'S', 0.7940, NULL, NULL, '31029', 'N', 'N', 3694, NULL, '3190', '3190', NULL, '1953', 'S', 1936, 'PERDIGÃO', 'N', '314970', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '581', NULL, '03', 'N', NULL, NULL, NULL, 413);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314980', '3113', 'MG', '3112', '3105', '31023', '31', 'PERDIZES', NULL, '34', '38170000', '4', '4995', '4995', '11498', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2450.145, '-19,35300', '-47,29300', 1000, 'S', 0.7770, NULL, NULL, '31070', 'N', 'N', 3695, NULL, '3190', '3190', NULL, '1938', 'S', 1937, 'PERDIZES', 'N', '314980', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '582', NULL, '03', 'N', NULL, NULL, NULL, 240);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314990', '3111', 'MG', '3101', '3109', '31045', '31', 'PERDOES', NULL, '35', '37260000', '3', '4997', '4997', '11499', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 276.978, '-21,09100', '-45,09100', 842, 'S', 0.7840, NULL, NULL, '31004', 'N', 'N', 3696, NULL, '3190', '3190', NULL, '1911', 'S', 1938, 'PERDÕES', 'N', '314990', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '583', NULL, '03', 'N', NULL, NULL, NULL, 19);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('314995', '3123', 'MG', '3106', '3108', '31039', '31', 'PERIQUITO', NULL, '33', '35156000', '2', '0684', NULL, '11752', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 227.803, '-19,15800', '-42,23400', 231, 'S', 0.6470, NULL, NULL, '31037', 'S', 'N', 3701, NULL, '3104', '3190', NULL, '1997', 'S', 1939, 'PERIQUITO', 'N', '314995', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '584', NULL, '03', 'N', NULL, NULL, NULL, 358);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315000', '3117', 'MG', '3111', '3108', '31037', '31', 'PESCADOR', NULL, '33', '35114000', '0', '4999', '4999', '11500', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 317.615, '-18,35700', '-41,59800', 442, 'S', 0.6790, NULL, NULL, '31069', 'S', 'N', 3709, NULL, '3190', '3190', NULL, '1962', 'S', 1940, 'PESCADOR', 'N', '315000', 'N', 'S', 'S', NULL, 99, 'N', 'N', 'N', '585', NULL, '03', 'N', NULL, NULL, NULL, 292);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315010', '3105', 'MG', '3107', '3112', '31065', '31', 'PIAU', NULL, '32', '36157000', '9', '5001', '5001', '11501', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 191.378, '-21,50900', '-43,32300', 462, 'S', 0.7320, NULL, NULL, '31043', 'N', 'N', 3721, NULL, '3190', '3190', NULL, '1953', 'S', 1941, 'PIAU', 'N', '315010', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '586', NULL, '03', 'N', NULL, NULL, NULL, 360);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315015', '3123', 'MG', '3106', '3108', '31040', '31', 'PIEDADE DE CARATINGA', NULL, '33', '35325000', '8', '0686', NULL, '11827', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 110.121, '-19,75900', '-42,07600', 900, 'S', 0.6610, NULL, NULL, '31034', 'S', 'N', 3728, NULL, '3190', '3190', NULL, '1997', 'S', 1942, 'PIEDADE DE CARATINGA', 'N', '315015', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '587', NULL, '03', 'N', NULL, NULL, NULL, 14);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315020', '3108', 'MG', '3110', '3112', '31060', '31', 'PIEDADE DE PONTE NOVA', NULL, '31', '35382000', '8', '5003', '5003', '11502', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 84.008, '-20,24500', '-42,73400', 421, 'S', 0.6740, NULL, NULL, '31060', 'S', 'N', 3729, NULL, '3190', '3190', NULL, '1962', 'S', 1943, 'PIEDADE DE PONTE NOVA', 'N', '315020', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '588', NULL, '03', 'N', NULL, NULL, NULL, 347);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315030', '3120', 'MG', '3102', '3111', '31058', '31', 'PIEDADE DO RIO GRANDE', NULL, '32', '36227000', '7', '5005', '5005', '11503', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 322.743, '-21,46900', '-44,19600', 1022, 'S', 0.6880, NULL, NULL, '31015', 'S', 'N', 3730, NULL, '3190', '3190', NULL, '1953', 'S', 1944, 'PIEDADE DO RIO GRANDE', 'N', '315030', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '589', NULL, '03', 'N', NULL, NULL, NULL, 114);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315040', '3101', 'MG', '3103', '3107', '31032', '31', 'PIEDADE DOS GERAIS', NULL, '31', '35526000', '6', '5007', '5007', '11504', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 260.633, '-20,47100', '-44,22700', 995, 'S', 0.6940, NULL, NULL, '31017', 'S', 'N', 3731, NULL, '3190', '3190', NULL, '1962', 'S', 1945, 'PIEDADE DOS GERAIS', 'N', '315040', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '590', NULL, '03', 'N', NULL, NULL, NULL, 242);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315050', '3115', 'MG', '3105', '3109', '31044', '31', 'PIMENTA', NULL, '37', '35585000', '5', '5009', '5009', '11505', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 415.070, '-20,48400', '-45,79900', 776, 'S', 0.7680, NULL, NULL, '31030', 'N', 'N', 3741, NULL, '3190', '3190', NULL, '1948', 'S', 1946, 'PIMENTA', 'N', '315050', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '591', NULL, '03', 'N', NULL, NULL, NULL, 15);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316550', '3116', 'MG', '3106', '3108', '31035', '31', 'SARDOA', NULL, '33', '39728000', '3', '5309', '5309', '11655', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 141.508, '-18,78400', '-42,36500', 691, 'S', 0.6840, NULL, NULL, '31036', 'S', 'N', 4879, NULL, '3190', '3190', NULL, '1962', 'S', 2124, 'SARDOÁ', 'N', '316550', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '769', NULL, '03', 'N', NULL, NULL, NULL, 189);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315053', '3123', 'MG', '3106', '3108', '31040', '31', 'PINGO-D''AGUA', NULL, '33', '35348000', '9', '0688', NULL, '11828', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 66.820, '-19,72700', '-42,40800', 200, 'S', 0.6850, NULL, NULL, '31035', 'S', 'N', 3753, NULL, '3104', '3190', NULL, '1997', 'S', 1947, 'PINGO-D ÁGUA', 'N', '315053', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '592', NULL, '03', 'N', NULL, NULL, NULL, 64);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315057', '3129', 'MG', '3108', '3102', '31003', '31', 'PINTOPOLIS', NULL, '38', '39317000', '0', '0690', NULL, '11829', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1238.432, '-16,05900', '-45,15600', 516, 'S', 0.6370, NULL, NULL, '31049', 'S', 'N', 3770, NULL, '3190', '3190', NULL, '1997', 'S', 1948, 'PINTÓPOLIS', 'N', '315057', 'N', 'S', 'S', NULL, 63, 'N', 'N', 'N', '593', NULL, '03', 'N', NULL, NULL, NULL, 243);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315060', '3115', 'MG', '3105', '3109', '31046', '31', 'PIRACEMA', NULL, '37', '35536000', '4', '5011', '5011', '11506', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 280.358, '-20,50800', '-44,48300', 872, 'S', 0.7100, NULL, NULL, '31031', 'N', 'N', 3778, NULL, '3190', '3190', NULL, '1953', 'S', 1949, 'PIRACEMA', 'N', '315060', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '594', NULL, '03', 'N', NULL, NULL, NULL, 359);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315070', '3113', 'MG', '3112', '3105', '31021', '31', 'PIRAJUBA', NULL, '34', '38210000', '3', '5013', '5013', '11507', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 331.793, '-19,90700', '-48,70100', 525, 'S', 0.7860, NULL, NULL, '31071', 'N', 'N', 3785, NULL, '3190', '3190', NULL, '1953', 'S', 1950, 'PIRAJUBA', 'N', '315070', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '595', NULL, '03', 'N', NULL, NULL, NULL, 244);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315080', '3103', 'MG', '3102', '3112', '31062', '31', 'PIRANGA', NULL, '31', '36480000', '2', '5015', '5015', '11508', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 657.484, '-20,68500', '-43,30000', 620, 'S', 0.6610, NULL, NULL, '31014', 'S', 'N', 3788, NULL, '3190', '3190', NULL, '1868', 'S', 1951, 'PIRANGA', 'N', '315080', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '596', NULL, '03', 'N', NULL, NULL, NULL, 187);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315090', '3110', 'MG', '3101', '3110', '31056', '31', 'PIRANGUCU', NULL, '35', '37511000', '1', '5017', '5017', '11509', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 206.417, '-22,52800', '-45,49500', 907, 'S', 0.7340, NULL, NULL, '31003', 'N', 'N', 3790, NULL, '3190', '3190', NULL, '1962', 'S', 1952, 'PIRANGUÇU', 'N', '315090', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '597', NULL, '03', 'N', NULL, NULL, NULL, 16);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315100', '3110', 'MG', '3101', '3110', '31056', '31', 'PIRANGUINHO', NULL, '35', '37508000', '8', '5019', '5019', '11510', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 130.334, '-22,40100', '-45,53200', 837, 'S', 0.7570, NULL, NULL, '31003', 'N', 'N', 3791, NULL, '3190', '3190', NULL, '1962', 'S', 1953, 'PIRANGUINHO', 'N', '315100', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '598', NULL, '03', 'N', NULL, NULL, NULL, 16);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315110', '3127', 'MG', '3107', '3112', '31066', '31', 'PIRAPETINGA', NULL, '32', '36730000', '7', '5021', '5021', '11511', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 192.230, '-21,65600', '-42,34600', 152, 'S', 0.7590, NULL, NULL, '31041', 'N', 'N', 3795, NULL, '3190', '3190', NULL, '1938', 'S', 1954, 'PIRAPETINGA', 'N', '315110', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '599', NULL, '03', 'N', NULL, NULL, NULL, 409);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315120', '3128', 'MG', '3108', '3102', '31006', '31', 'PIRAPORA', NULL, '38', '39270000', '6', '5023', '5023', '11512', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 575.460, '-17,34500', '-44,94200', 489, 'S', 0.7580, NULL, NULL, '31055', 'N', 'N', 3797, NULL, '3190', '3190', NULL, '1911', 'S', 1955, 'PIRAPORA', 'N', '315120', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '600', NULL, '02', 'N', NULL, NULL, NULL, 233);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315130', '3118', 'MG', '3107', '3112', '31064', '31', 'PIRAUBA', NULL, '32', '36170000', '5', '5025', '5025', '11513', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 143.982, '-21,27600', '-43,02600', 374, 'S', 0.7590, NULL, NULL, '31048', 'N', 'N', 3806, NULL, '3190', '3190', NULL, '1953', 'S', 1956, 'PIRAÚBA', 'N', '315130', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '601', NULL, '03', 'N', NULL, NULL, NULL, 181);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315140', '3115', 'MG', '3105', '3107', '31029', '31', 'PITANGUI', NULL, '37', '35650000', '4', '5027', '5027', '11514', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 568.332, '-19,68300', '-44,89000', 709, 'S', 0.7910, NULL, NULL, '31032', 'N', 'N', 3817, NULL, '3190', '3190', NULL, '1715', 'S', 1957, 'PITANGUI', 'N', '315140', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '602', NULL, '03', 'N', NULL, NULL, NULL, 131);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315150', '3122', 'MG', '3101', '3109', '31042', '31', 'PIUMHI', NULL, '37', '37925000', '3', '5029', '5029', '11515', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 902.348, '-20,46500', '-45,95800', 793, 'S', 0.8000, NULL, NULL, '31005', 'N', 'N', 3821, NULL, '3190', '3190', NULL, '1841', 'S', 1958, 'PIUMHI', 'N', '315150', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '603', NULL, '03', 'N', NULL, NULL, NULL, 361);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315160', '3113', 'MG', '3112', '3105', '31021', '31', 'PLANURA', NULL, '34', '38220000', '2', '5031', '5031', '11516', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 317.992, '-20,13800', '-48,70200', 492, 'S', 0.7790, NULL, NULL, '31071', 'N', 'N', 3833, NULL, '3190', '3190', NULL, '1962', 'S', 1959, 'PLANURA', 'N', '315160', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '604', NULL, '03', 'N', NULL, NULL, NULL, 244);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315170', '3121', 'MG', '3101', '3110', '31049', '31', 'POCO FUNDO', NULL, '35', '37757000', '1', '5033', '5033', '11517', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 474.228, '-21,78100', '-45,96500', 836, 'S', 0.7740, NULL, NULL, '31001', 'N', 'N', 3844, NULL, '3190', '3190', NULL, '1923', 'S', 1960, 'POÇO FUNDO', 'N', '315170', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '605', NULL, '03', 'N', NULL, NULL, NULL, 300);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315180', '3110', 'MG', '3101', '3110', '31051', '31', 'POCOS DE CALDAS', NULL, '35', '37701970', '0', '5035', '5035', '11518', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 544.420, '-21,78800', '-46,56100', 1196, 'S', 0.8410, NULL, NULL, '31006', 'N', 'N', 3849, NULL, '3190', '3190', NULL, '1888', 'S', 1961, 'POÇOS DE CALDAS', 'N', '315180', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '606', NULL, '01', 'N', NULL, NULL, NULL, 291);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315190', '3124', 'MG', '3110', '3108', '31041', '31', 'POCRANE', NULL, '33', '36960000', '9', '5037', '5037', '11519', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 691.475, '-19,62000', '-41,63700', 225, 'S', 0.6900, NULL, NULL, '31059', 'S', 'N', 3850, NULL, '3190', '3190', NULL, '1948', 'S', 1962, 'POCRANE', 'N', '315190', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '607', NULL, '03', 'N', NULL, NULL, NULL, 191);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315200', '3114', 'MG', '3103', '3106', '31024', '31', 'POMPEU', NULL, '37', '35640000', '6', '5039', '5039', '11520', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2557.734, '-19,22400', '-44,93500', 657, 'S', 0.7450, NULL, NULL, '31024', 'N', 'N', 3857, NULL, '3190', '3190', NULL, '1938', 'S', 1963, 'POMPÉU', 'N', '315200', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '608', NULL, '03', 'N', NULL, NULL, NULL, 58);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315210', '3108', 'MG', '3110', '3112', '31060', '31', 'PONTE NOVA', NULL, '31', '35430970', '5', '5041', '5041', '11521', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 470.338, '-20,41600', '-42,90900', 431, 'S', 0.7660, NULL, NULL, '31060', 'N', 'N', 3873, NULL, '3190', '3190', NULL, '1857', 'S', 1964, 'PONTE NOVA', 'N', '315210', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '609', NULL, '02', 'N', NULL, NULL, NULL, 347);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315213', '3128', 'MG', '3108', '3102', '31007', '31', 'PONTO CHIQUE', NULL, '38', '39328000', '1', '0692', NULL, '11830', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 602.367, '-16,63100', '-45,06600', 470, 'S', 0.6600, NULL, NULL, '31055', 'S', 'N', 3879, NULL, '3190', '3190', NULL, '1997', 'S', 1965, 'PONTO CHIQUE', 'N', '315213', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '610', NULL, '03', 'N', NULL, NULL, NULL, 233);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315217', '3119', 'MG', '3111', '3103', '31012', '31', 'PONTO DOS VOLANTES', NULL, '33', '39615000', '0', '0694', NULL, '11753', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1215.189, '-16,75300', '-41,50400', 400, 'S', 0.5950, NULL, NULL, '31065', 'S', 'N', 3880, NULL, '3190', '3190', NULL, '1997', 'S', 1966, 'PONTO DOS VOLANTES', 'N', '315217', 'N', 'S', 'S', NULL, 57, 'N', 'N', 'N', '611', NULL, '03', 'N', NULL, NULL, NULL, 127);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315220', '3106', 'MG', '3108', '3102', '31004', '31', 'PORTEIRINHA', NULL, '38', '39520000', '4', '5043', '5043', '11522', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1806.253, '-15,74300', '-43,02800', 566, 'S', 0.6330, NULL, NULL, '31052', 'N', 'N', 3892, NULL, '3190', '3190', NULL, '1938', 'S', 1967, 'PORTEIRINHA', 'N', '315220', 'N', 'S', 'S', NULL, 79, 'N', 'N', 'N', '612', NULL, '03', 'N', NULL, NULL, NULL, 128);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315230', '3108', 'MG', '3110', '3112', '31062', '31', 'PORTO FIRME', NULL, '31', '36576000', '3', '5045', '5045', '11523', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 285.005, '-20,67300', '-43,08400', 595, 'S', 0.6860, NULL, NULL, '31061', 'S', 'N', 3914, NULL, '3190', '3190', NULL, '1953', 'S', 1968, 'PORTO FIRME', 'N', '315230', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '613', NULL, '03', 'N', NULL, NULL, NULL, 117);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315240', '3117', 'MG', '3111', '3104', '31015', '31', 'POTE', NULL, '33', '39827000', '2', '5047', '5047', '11524', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 632.692, '-17,80700', '-41,78600', 594, 'S', 0.6420, NULL, NULL, '31069', 'S', 'N', 3933, NULL, '3190', '3190', NULL, '1938', 'S', 1969, 'POTÉ', 'N', '315240', 'N', 'S', 'S', NULL, 99, 'N', 'N', 'N', '614', NULL, '03', 'N', NULL, NULL, NULL, 292);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315250', '3110', 'MG', '3101', '3110', '31052', '31', 'POUSO ALEGRE', NULL, '35', '37550000', '1', '5049', '5049', '11525', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 543.883, '-22,23000', '-45,93600', 832, 'S', 0.8260, NULL, NULL, '31007', 'N', 'N', 3939, NULL, '3190', '3190', NULL, '1831', 'S', 1970, 'POUSO ALEGRE', 'N', '315250', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '615', NULL, '01', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315260', '3111', 'MG', '3101', '3110', '31054', '31', 'POUSO ALTO', NULL, '35', '37468000', '0', '5051', '5051', '11526', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 261.211, '-22,19400', '-44,97300', 884, 'S', 0.7530, NULL, NULL, '31008', 'N', 'N', 3940, NULL, '3190', '3190', NULL, '1874', 'S', 1971, 'POUSO ALTO', 'N', '315260', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '616', NULL, '03', 'N', NULL, NULL, NULL, 57);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315270', '3120', 'MG', '3102', '3111', '31058', '31', 'PRADOS', NULL, '32', '36320000', '9', '5053', '5053', '11527', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 261.410, '-21,05800', '-44,08000', 979, 'S', 0.7290, NULL, NULL, '31015', 'N', 'N', 3949, NULL, '3190', '3190', NULL, '1890', 'S', 1972, 'PRADOS', 'N', '315270', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '617', NULL, '03', 'N', NULL, NULL, NULL, 114);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315280', '3112', 'MG', '3113', '3105', '31018', '31', 'PRATA', NULL, '34', '38140000', '8', '5055', '5055', '11528', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4856.626, '-19,30700', '-48,92400', 630, 'S', 0.7690, NULL, NULL, '31075', 'N', 'N', 3955, NULL, '3190', '3190', NULL, '1854', 'S', 1973, 'PRATA', 'N', '315280', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '618', NULL, '03', 'N', NULL, NULL, NULL, 116);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315290', '3122', 'MG', '3101', '3110', '31047', '31', 'PRATAPOLIS', NULL, '35', '37970000', '7', '5057', '5057', '11529', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 214.345, '-20,74500', '-46,86100', 742, 'S', 0.7730, NULL, NULL, '31009', 'N', 'N', 3959, NULL, '3190', '3190', NULL, '1943', 'S', 1974, 'PRATÁPOLIS', 'N', '315290', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '619', NULL, '03', 'N', NULL, NULL, NULL, 8);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315300', '3113', 'MG', '3112', '3105', '31023', '31', 'PRATINHA', NULL, '34', '38960000', '4', '5059', '5059', '11530', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 619.296, '-19,75100', '-46,37800', 1162, 'S', 0.7740, NULL, NULL, '31070', 'N', 'N', 3960, NULL, '3190', '3190', NULL, '1948', 'S', 1975, 'PRATINHA', 'N', '315300', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '620', NULL, '03', 'N', NULL, NULL, NULL, 240);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315310', '3118', 'MG', '3107', '3112', '31062', '31', 'PRESIDENTE BERNARDES', NULL, '32', '36475000', '3', '5061', '5061', '11531', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 236.929, '-20,76900', '-43,18800', 591, 'S', 0.6990, NULL, NULL, '31048', 'S', 'N', 3962, NULL, '3190', '3190', NULL, '1989', 'S', 1976, 'PRESIDENTE BERNARDES', 'N', '315310', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '621', NULL, '03', 'N', NULL, NULL, NULL, 181);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315320', '3114', 'MG', '3103', '3106', '31025', '31', 'PRESIDENTE JUSCELINO', NULL, '38', '35797000', '2', '5063', '5063', '11532', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 696.639, '-18,63700', '-44,05800', 596, 'S', 0.6540, NULL, NULL, '31019', 'S', 'N', 3972, NULL, '3190', '3190', NULL, '1962', 'S', 1977, 'PRESIDENTE JUSCELINO', 'N', '315320', 'N', 'N', 'S', NULL, 48, 'N', 'N', 'N', '622', NULL, '03', 'N', NULL, NULL, NULL, 65);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315330', '3104', 'MG', '3104', '3103', '31010', '31', 'PRESIDENTE KUBITSCHEK', NULL, '38', '39135000', '1', '5065', '5065', '11533', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 189.546, '-18,61400', '-43,56200', 1109, 'S', 0.6710, NULL, NULL, '31026', 'S', 'N', 3976, NULL, '3190', '3190', NULL, '1962', 'S', 1978, 'PRESIDENTE KUBITSCHEK', 'N', '315330', 'N', 'N', 'S', NULL, 5, 'N', 'N', 'N', '623', NULL, '03', 'N', NULL, NULL, NULL, 126);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315340', '3107', 'MG', '3109', '3101', '31002', '31', 'PRESIDENTE OLEGARIO', NULL, '34', '38750000', '0', '5067', '5067', '11534', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3531.221, '-18,41800', '-46,41800', 947, 'S', 0.7210, NULL, NULL, '31057', 'N', 'N', 3981, NULL, '3190', '3190', NULL, '1938', 'S', 1979, 'PRESIDENTE OLEGÁRIO', 'N', '315340', 'N', 'N', 'S', NULL, 63, 'N', 'N', 'N', '624', NULL, '03', 'N', NULL, NULL, NULL, 194);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315350', '3124', 'MG', '3110', '3112', '31061', '31', 'ALTO JEQUITIBA', NULL, '33', '36976000', '9', '5069', '5069', '11535', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 152.737, '-20,42400', '-41,96600', 645, 'S', 0.7350, NULL, NULL, '31059', 'N', 'N', 152, NULL, '3190', '3190', NULL, '1953', 'S', 1378, 'ALTO JEQUITIBÁ', 'N', '315350', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '23', NULL, '03', 'N', NULL, NULL, NULL, 191);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315360', '3114', 'MG', '3103', '3107', '31027', '31', 'PRUDENTE DE MORAIS', NULL, '31', '35715000', '8', '5071', '5071', '11536', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 125.783, '-19,48200', '-44,15500', 748, 'S', 0.7520, NULL, NULL, '31024', 'N', 'N', 4000, NULL, '3102', '3190', NULL, '1962', 'S', 1980, 'PRUDENTE DE MORAIS', 'N', '315360', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '625', NULL, '03', 'N', NULL, NULL, NULL, 58);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315370', '3114', 'MG', '3103', '3106', '31026', '31', 'QUARTEL GERAL', NULL, '37', '35625000', '7', '5073', '5073', '11537', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 555.534, '-19,27400', '-45,55700', 681, 'S', 0.7140, NULL, NULL, '31024', 'N', 'N', 4008, NULL, '3190', '3190', NULL, '1953', 'S', 1981, 'QUARTEL GERAL', 'N', '315370', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '626', NULL, '03', 'N', NULL, NULL, NULL, 58);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315380', '3103', 'MG', '3102', '3107', '31034', '31', 'QUELUZITO', NULL, '31', '36424000', '6', '5075', '5075', '11538', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 153.038, '-20,74000', '-43,88400', 952, 'S', 0.7300, NULL, NULL, '31014', 'N', 'N', 4024, NULL, '3190', '3190', NULL, '1962', 'S', 1982, 'QUELUZITO', 'N', '315380', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '627', NULL, '03', 'N', NULL, NULL, NULL, 187);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315390', '3101', 'MG', '3103', '3107', '31030', '31', 'RAPOSOS', NULL, '31', '34400000', '5', '5077', '5077', '11539', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 71.850, '-19,96700', '-43,80400', 732, 'S', 0.7580, NULL, NULL, '31016', 'N', 'N', 4055, NULL, '3101', '3101', NULL, '1948', 'S', 1983, 'RAPOSOS', 'N', '315390', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '628', NULL, '01', 'N', NULL, NULL, NULL, 410);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315400', '3108', 'MG', '3110', '3112', '31060', '31', 'RAUL SOARES', NULL, '33', '35350000', '2', '5079', '5079', '11540', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 771.469, '-20,10200', '-42,45300', 294, 'S', 0.7290, NULL, NULL, '31060', 'N', 'N', 4056, NULL, '3190', '3190', NULL, '1923', 'S', 1984, 'RAUL SOARES', 'N', '315400', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '629', NULL, '03', 'N', NULL, NULL, NULL, 347);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315410', '3127', 'MG', '3107', '3112', '31066', '31', 'RECREIO', NULL, '32', '36740000', '1', '5081', '5081', '11541', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 234.240, '-21,52500', '-42,46900', 193, 'S', 0.7460, NULL, NULL, '31044', 'N', 'N', 4060, NULL, '3190', '3190', NULL, '1938', 'S', 1985, 'RECREIO', 'N', '315410', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '630', NULL, '03', 'N', NULL, NULL, NULL, 246);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315415', '3124', 'MG', '3110', '3112', '31061', '31', 'REDUTO', NULL, '33', '36920000', '0', '0696', NULL, '11831', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 151.308, '-20,24000', '-41,98300', 610, 'S', 0.7150, NULL, NULL, '31059', 'N', 'N', 4067, NULL, '3190', '3190', NULL, '1997', 'S', 1986, 'REDUTO', 'N', '315415', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '631', NULL, '03', 'N', NULL, NULL, NULL, 191);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315420', '3120', 'MG', '3102', '3111', '31058', '31', 'RESENDE COSTA', NULL, '32', '36340000', '0', '5083', '5083', '11542', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 631.561, '-20,92200', '-44,23800', 1032, 'S', 0.7360, NULL, NULL, '31015', 'N', 'N', 4078, NULL, '3190', '3190', NULL, '1911', 'S', 1987, 'RESENDE COSTA', 'N', '315420', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '632', NULL, '03', 'N', NULL, NULL, NULL, 114);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315430', '3116', 'MG', '3106', '3108', '31041', '31', 'RESPLENDOR', NULL, '33', '35230000', '9', '5085', '5085', '11543', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1072.112, '-19,32600', '-41,25500', 100, 'S', 0.7300, NULL, NULL, '31040', 'N', 'N', 4082, NULL, '3190', '3190', NULL, '1938', 'S', 1988, 'RESPLENDOR', 'N', '315430', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '633', NULL, '03', 'N', NULL, NULL, NULL, 403);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315440', '3103', 'MG', '3102', '3111', '31059', '31', 'RESSAQUINHA', NULL, '32', '36270000', '8', '5087', '5087', '11544', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 188.745, '-21,06300', '-43,76300', 1123, 'S', 0.7250, NULL, NULL, '31013', 'N', 'N', 4083, NULL, '3190', '3190', NULL, '1953', 'S', 1989, 'RESSAQUINHA', 'N', '315440', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '634', NULL, '03', 'N', NULL, NULL, NULL, 241);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315445', '3126', 'MG', '3109', '3102', '31006', '31', 'RIACHINHO', NULL, '38', '38640000', '7', '2901', '2901', '11754', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1774.924, '-16,23000', '-45,99200', 550, 'S', 0.7000, NULL, NULL, '31058', 'S', 'N', 4094, NULL, '3190', '3190', NULL, '1993', 'S', 1990, 'RIACHINHO', 'N', '315445', 'N', 'S', 'S', NULL, 63, 'N', 'N', 'N', '635', NULL, '03', 'N', NULL, NULL, NULL, 295);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315450', '3106', 'MG', '3108', '3102', '31004', '31', 'RIACHO DOS MACHADOS', NULL, '38', '39529000', '7', '5089', '5089', '11545', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1308.545, '-16,00600', '-43,04900', 821, 'S', 0.6040, NULL, NULL, '31052', 'S', 'N', 4101, NULL, '3190', '3190', NULL, '1962', 'S', 1991, 'RIACHO DOS MACHADOS', 'N', '315450', 'N', 'S', 'S', NULL, 79, 'N', 'N', 'N', '636', NULL, '03', 'N', NULL, NULL, NULL, 128);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315460', '3101', 'MG', '3103', '3107', '31030', '31', 'RIBEIRAO DAS NEVES', NULL, '31', '33805970', '6', '5091', '5091', '11546', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 154.180, '-19,76700', '-44,08700', 800, 'S', 0.7490, NULL, NULL, '31016', 'N', 'N', 4119, NULL, '3101', '3101', NULL, '1953', 'S', 1992, 'RIBEIRÃO DAS NEVES', 'N', '315460', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '637', NULL, '01', 'N', NULL, NULL, NULL, 410);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315470', '3111', 'MG', '3101', '3111', '31057', '31', 'RIBEIRAO VERMELHO', NULL, '35', '37264000', '5', '5093', '5093', '11547', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 40.210, '-21,19100', '-45,06200', 808, 'S', 0.7830, NULL, NULL, '31004', 'N', 'N', 4127, NULL, '3190', '3190', NULL, '1948', 'S', 1993, 'RIBEIRÃO VERMELHO', 'N', '315470', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '638', NULL, '03', 'N', NULL, NULL, NULL, 19);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315480', '3101', 'MG', '3103', '3107', '31030', '31', 'RIO ACIMA', NULL, '31', '34300000', '4', '5095', '5095', '11548', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 230.143, '-20,08800', '-43,78900', 740, 'S', 0.7350, NULL, NULL, '31016', 'N', 'N', 4134, NULL, '3101', '3101', NULL, '1948', 'S', 1994, 'RIO ACIMA', 'N', '315480', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '639', NULL, '01', 'N', NULL, NULL, NULL, 410);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315490', '3108', 'MG', '3110', '3112', '31060', '31', 'RIO CASCA', NULL, '31', '35370000', '3', '5097', '5097', '11549', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 384.174, '-20,22600', '-42,65100', 333, 'S', 0.7120, NULL, NULL, '31060', 'N', 'N', 4145, NULL, '3190', '3190', NULL, '1911', 'S', 1995, 'RIO CASCA', 'N', '315490', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '640', NULL, '03', 'N', NULL, NULL, NULL, 347);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315500', '3108', 'MG', '3110', '3112', '31060', '31', 'RIO DOCE', NULL, '31', '35442000', '9', '5099', '5099', '11550', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 112.305, '-20,24200', '-42,90700', 380, 'S', 0.7020, NULL, NULL, '31060', 'N', 'N', 4163, NULL, '3190', '3190', NULL, '1962', 'S', 1997, 'RIO DOCE', 'N', '315500', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '642', NULL, '03', 'N', NULL, NULL, NULL, 347);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315510', '3119', 'MG', '3111', '3103', '31014', '31', 'RIO DO PRADO', NULL, '33', '39940000', '8', '5101', '5101', '11551', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'S', 'N', NULL, 'N', 479.424, '-16,60800', '-40,57000', 350, 'S', 0.6260, NULL, NULL, '31063', 'S', 'N', 4161, NULL, '3190', '3190', NULL, '1953', 'S', 1996, 'RIO DO PRADO', 'N', '315510', 'N', 'S', 'S', NULL, 117, 'S', 'N', 'N', '641', NULL, '03', 'N', NULL, NULL, NULL, 125);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315520', '3103', 'MG', '3102', '3112', '31062', '31', 'RIO ESPERA', NULL, '31', '36460000', '7', '5103', '5103', '11552', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 239.688, '-20,85500', '-43,47400', 712, 'S', 0.6730, NULL, NULL, '31014', 'S', 'N', 4167, NULL, '3190', '3190', NULL, '1911', 'S', 1998, 'RIO ESPERA', 'N', '315520', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '643', NULL, '03', 'N', NULL, NULL, NULL, 187);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315530', '3101', 'MG', '3103', '3107', '31032', '31', 'RIO MANSO', NULL, '31', '35525000', '6', '5105', '5105', '11553', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 232.102, '-20,26500', '-44,30800', 890, 'S', 0.7080, NULL, NULL, '31017', 'N', 'N', 4174, NULL, '3101', '3101', NULL, '1962', 'S', 1999, 'RIO MANSO', 'N', '315530', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '644', NULL, '01', 'N', NULL, NULL, NULL, 242);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315540', '3105', 'MG', '3107', '3112', '31065', '31', 'RIO NOVO', NULL, '32', '36150000', '5', '5107', '5107', '11554', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 207.559, '-21,45800', '-43,12500', 418, 'S', 0.7660, NULL, NULL, '31043', 'N', 'N', 4179, NULL, '3190', '3190', NULL, '1870', 'S', 2000, 'RIO NOVO', 'N', '315540', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '645', NULL, '03', 'N', NULL, NULL, NULL, 360);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315550', '3107', 'MG', '3109', '3105', '31020', '31', 'RIO PARANAIBA', NULL, '34', '38810000', '4', '5109', '5109', '11555', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1353.423, '-19,19400', '-46,24700', 1067, 'S', 0.7550, NULL, NULL, '31057', 'N', 'N', 4181, NULL, '3190', '3190', NULL, '1911', 'S', 2001, 'RIO PARANAÍBA', 'N', '315550', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '646', NULL, '03', 'N', NULL, NULL, NULL, 194);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315560', '3106', 'MG', '3108', '3102', '31005', '31', 'RIO PARDO DE MINAS', NULL, '38', '39530000', '3', '5111', '5111', '11556', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 3118.672, '-15,61000', '-42,54000', 755, 'S', 0.6330, NULL, NULL, '31056', 'S', 'N', 4183, NULL, '3190', '3190', NULL, '1831', 'S', 2002, 'RIO PARDO DE MINAS', 'N', '315560', 'N', 'S', 'S', NULL, 7, 'N', 'N', 'N', '647', NULL, '03', 'N', NULL, NULL, NULL, 348);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315570', '3109', 'MG', '3103', '3107', '31031', '31', 'RIO PIRACICABA', NULL, '31', '35940000', '2', '5113', '5113', '11557', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 370.355, '-19,92900', '-43,17400', 639, 'S', 0.7350, NULL, NULL, '31023', 'N', 'N', 4184, NULL, '3190', '3190', NULL, '1911', 'S', 2003, 'RIO PIRACICABA', 'N', '315570', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '648', NULL, '03', 'N', NULL, NULL, NULL, 18);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315580', '3118', 'MG', '3107', '3112', '31064', '31', 'RIO POMBA', NULL, '32', '36180000', '1', '5115', '5115', '11558', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 251.760, '-21,27500', '-43,17900', 441, 'S', 0.7710, NULL, NULL, '31048', 'N', 'N', 4185, NULL, '3190', '3190', NULL, '1831', 'S', 2004, 'RIO POMBA', 'N', '315580', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '649', NULL, '03', 'N', NULL, NULL, NULL, 181);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315590', '3105', 'MG', '3107', '3112', '31065', '31', 'RIO PRETO', NULL, '32', '36130000', '0', '5117', '5117', '11559', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 347.097, '-22,08900', '-43,82800', 430, 'S', 0.7520, NULL, NULL, '31043', 'N', 'N', 4186, NULL, '3190', '3190', NULL, '1870', 'S', 2005, 'RIO PRETO', 'N', '315590', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '650', NULL, '03', 'N', NULL, NULL, NULL, 360);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315600', '3104', 'MG', '3103', '3107', '31028', '31', 'RIO VERMELHO', NULL, '33', '39170000', '7', '5119', '5119', '11560', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 987.222, '-18,29400', '-43,00900', 730, 'S', 0.6350, NULL, NULL, '31020', 'S', 'N', 4195, NULL, '3190', '3190', NULL, '1938', 'S', 2006, 'RIO VERMELHO', 'N', '315600', 'N', 'S', 'S', NULL, 5, 'N', 'N', 'N', '651', NULL, '03', 'N', NULL, NULL, NULL, 245);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315610', '3120', 'MG', '3102', '3111', '31058', '31', 'RITAPOLIS', NULL, '32', '36335000', '6', '5121', '5121', '11561', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 391.839, '-21,02200', '-44,31800', 1051, 'S', 0.7070, NULL, NULL, '31015', 'N', 'N', 4199, NULL, '3190', '3190', NULL, '1962', 'S', 2007, 'RITÁPOLIS', 'N', '315610', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '652', NULL, '03', 'N', NULL, NULL, NULL, 114);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315620', '3105', 'MG', '3107', '3112', '31065', '31', 'ROCHEDO DE MINAS', NULL, '32', '36604000', '5', '5123', '5123', '11562', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 79.550, '-21,63000', '-43,02000', 330, 'S', 0.7500, NULL, NULL, '31047', 'N', 'N', 4203, NULL, '3190', '3190', NULL, '1962', 'S', 2008, 'ROCHEDO DE MINAS', 'N', '315620', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '653', NULL, '03', 'N', NULL, NULL, NULL, 115);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315630', '3118', 'MG', '3107', '3112', '31064', '31', 'RODEIRO', NULL, '32', '36510000', '4', '5125', '5125', '11563', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 72.029, '-21,20000', '-42,86500', 336, 'S', 0.7450, NULL, NULL, '31048', 'N', 'N', 4206, NULL, '3190', '3190', NULL, '1962', 'S', 2009, 'RODEIRO', 'N', '315630', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '654', NULL, '03', 'N', NULL, NULL, NULL, 181);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315640', '3112', 'MG', '3113', '3105', '31019', '31', 'ROMARIA', NULL, '34', '38520000', '3', '5127', '5127', '11564', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 401.965, '-18,88300', '-47,58600', 958, 'S', 0.7750, NULL, NULL, '31074', 'N', 'N', 4213, NULL, '3190', '3190', NULL, '1962', 'S', 2010, 'ROMARIA', 'N', '315640', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '655', NULL, '03', 'N', NULL, NULL, NULL, 247);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315645', '3118', 'MG', '3107', '3112', '31063', '31', 'ROSARIO DA LIMEIRA', NULL, '32', '36878000', '2', '0698', NULL, '11755', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 112.319, '-20,97900', '-42,51200', 680, 'S', 0.7130, NULL, NULL, '31045', 'N', 'N', 4225, NULL, '3190', '3190', NULL, '1997', 'S', 2011, 'ROSÁRIO DA LIMEIRA', 'N', '315645', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '656', NULL, '03', 'N', NULL, NULL, NULL, 130);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315650', '3106', 'MG', '3108', '3102', '31005', '31', 'RUBELITA', NULL, '38', '39565000', '2', '5129', '5129', '11565', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1109.229, '-16,40800', '-42,26300', 391, 'S', 0.6600, NULL, NULL, '31056', 'S', 'N', 4232, NULL, '3190', '3190', NULL, '1962', 'S', 2012, 'RUBELITA', 'N', '315650', 'N', 'S', 'S', NULL, 7, 'N', 'N', 'N', '657', NULL, '03', 'N', NULL, NULL, NULL, 348);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315660', '3119', 'MG', '3111', '3103', '31014', '31', 'RUBIM', NULL, '33', '39950000', '1', '5131', '5131', '11566', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 968.732, '-16,37500', '-40,53800', 254, 'S', 0.6250, NULL, NULL, '31063', 'S', 'N', 4235, NULL, '3190', '3190', NULL, '1943', 'S', 2013, 'RUBIM', 'N', '315660', 'N', 'S', 'S', NULL, 117, 'N', 'N', 'N', '658', NULL, '03', 'N', NULL, NULL, NULL, 125);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315670', '3101', 'MG', '3103', '3107', '31030', '31', 'SABARA', NULL, '31', '34505970', '0', '5133', '5133', '11567', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 303.564, '-19,88600', '-43,80700', 723, 'S', 0.7730, NULL, NULL, '31016', 'N', 'N', 4241, NULL, '3101', '3101', NULL, '1711', 'S', 2014, 'SABARÁ', 'N', '315670', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '659', NULL, '01', 'N', NULL, NULL, NULL, 410);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315680', '3104', 'MG', '3103', '3108', '31035', '31', 'SABINOPOLIS', NULL, '33', '39750000', '9', '5135', '5135', '11568', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 919.397, '-18,66600', '-43,08400', 707, 'S', 0.6890, NULL, NULL, '31020', 'S', 'N', 4244, NULL, '3190', '3190', NULL, '1923', 'S', 2015, 'SABINÓPOLIS', 'N', '315680', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '660', NULL, '03', 'N', NULL, NULL, NULL, 245);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315690', '3113', 'MG', '3112', '3105', '31023', '31', 'SACRAMENTO', NULL, '34', '38190000', '8', '5137', '5137', '11569', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3071.454, '-19,86500', '-47,44000', 832, 'S', 0.7970, NULL, NULL, '31072', 'N', 'N', 4246, NULL, '3190', '3190', NULL, '1870', 'S', 2016, 'SACRAMENTO', 'N', '315690', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '661', NULL, '03', 'N', NULL, NULL, NULL, 349);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315700', '3106', 'MG', '3108', '3102', '31005', '31', 'SALINAS', NULL, '38', '39560000', '5', '5139', '5139', '11570', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1897.169, '-16,17000', '-42,29000', 471, 'S', 0.6990, NULL, NULL, '31056', 'N', 'N', 4261, NULL, '3190', '3190', NULL, '1880', 'S', 2017, 'SALINAS', 'N', '315700', 'N', 'S', 'S', NULL, 7, 'N', 'N', 'N', '662', NULL, '03', 'N', NULL, NULL, NULL, 348);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315710', '3119', 'MG', '3111', '3103', '31014', '31', 'SALTO DA DIVISA', NULL, '33', '39925000', '4', '5141', '5141', '11571', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 943.647, '-16,00300', '-39,94700', 142, 'S', 0.6420, NULL, NULL, '31063', 'S', 'N', 4270, NULL, '3190', '3190', NULL, '1948', 'S', 2018, 'SALTO DA DIVISA', 'N', '315710', 'N', 'S', 'S', NULL, 117, 'N', 'N', 'N', '663', NULL, '03', 'N', NULL, NULL, NULL, 125);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315720', '3109', 'MG', '3103', '3107', '31031', '31', 'SANTA BARBARA', NULL, '31', '35960000', '3', '5143', '5143', '11572', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 684.210, '-19,95900', '-43,41500', 732, 'S', 0.7620, NULL, NULL, '31021', 'N', 'N', 4293, NULL, '3102', '3190', NULL, '1839', 'S', 2019, 'SANTA BÁRBARA', 'N', '315720', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '664', NULL, '03', 'N', NULL, NULL, NULL, 190);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315725', '3123', 'MG', '3106', '3108', '31040', '31', 'SANTA BARBARA DO LESTE', NULL, '33', '35328000', '2', '2667', '2667', '11756', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 110.789, '-19,97800', '-42,14000', 850, 'S', 0.7070, NULL, NULL, '31034', 'N', 'N', 4297, NULL, '3190', '3190', NULL, '1993', 'S', 2020, 'SANTA BÁRBARA DO LESTE', 'N', '315725', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '665', NULL, '03', 'N', NULL, NULL, NULL, 14);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315727', '3105', 'MG', '3107', '3112', '31065', '31', 'SANTA BARBARA DO MONTE VERDE', NULL, '32', '36132000', '8', '0700', NULL, '11832', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 416.081, '-21,95900', '-43,70200', 730, 'S', 0.6930, NULL, NULL, '31043', 'S', 'N', 4298, NULL, '3190', '3190', NULL, '1997', 'S', 2021, 'SANTA BÁRBARA DO MONTE VERDE', 'N', '315727', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '666', NULL, '03', 'N', NULL, NULL, NULL, 360);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315730', '3103', 'MG', '3102', '3111', '31059', '31', 'SANTA BARBARA DO TUGURIO', NULL, '32', '36215000', '2', '5145', '5145', '11573', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 159.907, '-21,24600', '-43,55900', 605, 'S', 0.6660, NULL, NULL, '31013', 'S', 'N', 4301, NULL, '3190', '3190', NULL, '1962', 'S', 2022, 'SANTA BÁRBARA DO TUGÚRIO', 'N', '315730', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '667', NULL, '03', 'N', NULL, NULL, NULL, 241);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315733', '3120', 'MG', '3102', '3111', '31058', '31', 'SANTA CRUZ DE MINAS', NULL, '32', '36328000', '6', '0702', NULL, '11833', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2.859, '-21,12000', '-44,22300', 911, 'S', 0.7550, NULL, NULL, '31015', 'N', 'N', 4320, NULL, '3190', '3190', NULL, '1997', 'S', 2023, 'SANTA CRUZ DE MINAS', 'N', '315733', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '668', NULL, '03', 'N', NULL, NULL, NULL, 114);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315737', '3106', 'MG', '3108', '3102', '31005', '31', 'SANTA CRUZ DE SALINAS', NULL, '38', '39563000', '7', '0704', NULL, '11834', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 587.268, '-16,09800', '-41,74600', 761, 'S', 0.5990, NULL, NULL, '31056', 'S', 'N', 4322, NULL, '3190', '3190', NULL, '1997', 'S', 2024, 'SANTA CRUZ DE SALINAS', 'N', '315737', 'N', 'S', 'S', NULL, 7, 'N', 'N', 'N', '669', NULL, '03', 'N', NULL, NULL, NULL, 348);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315740', '3108', 'MG', '3110', '3112', '31060', '31', 'SANTA CRUZ DO ESCALVADO', NULL, '31', '35384000', '1', '5147', '5147', '11574', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 258.335, '-20,23600', '-42,81400', 412, 'S', 0.6700, NULL, NULL, '31060', 'S', 'N', 4325, NULL, '3190', '3190', NULL, '1948', 'S', 2025, 'SANTA CRUZ DO ESCALVADO', 'N', '315740', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '670', NULL, '03', 'N', NULL, NULL, NULL, 347);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315750', '3116', 'MG', '3106', '3108', '31035', '31', 'SANTA EFIGENIA DE MINAS', NULL, '33', '39725000', '0', '5149', '5149', '11575', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 132.183, '-18,82700', '-42,44800', 741, 'S', 0.6670, NULL, NULL, '31036', 'S', 'N', 4330, NULL, '3190', '3190', NULL, '1962', 'S', 2026, 'SANTA EFIGÊNIA DE MINAS', 'N', '315750', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '671', NULL, '03', 'N', NULL, NULL, NULL, 189);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315760', '3128', 'MG', '3108', '3102', '31006', '31', 'SANTA FE DE MINAS', NULL, '38', '39295000', '9', '5151', '5151', '11576', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 2916.648, '-16,69000', '-45,41400', 493, 'S', 0.6220, NULL, NULL, '31055', 'S', 'N', 4334, NULL, '3190', '3190', NULL, '1962', 'S', 2027, 'SANTA FÉ DE MINAS', 'N', '315760', 'N', 'S', 'S', NULL, 63, 'N', 'N', 'N', '672', NULL, '03', 'N', NULL, NULL, NULL, 233);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315765', '3117', 'MG', '3111', '3104', '31016', '31', 'SANTA HELENA DE MINAS', NULL, '33', '39874000', '8', '0706', '0706', '11835', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'S', NULL, 'N', 276.918, '-16,98300', '-40,68600', 312, 'S', 0.5940, NULL, NULL, '31062', 'S', 'N', 4346, NULL, '3190', '3190', NULL, '1997', 'S', 2028, 'SANTA HELENA DE MINAS', 'N', '315765', 'N', 'S', 'S', NULL, 99, 'N', 'N', 'N', '673', NULL, '03', 'N', NULL, NULL, NULL, 62);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315770', '3113', 'MG', '3112', '3105', '31023', '31', 'SANTA JULIANA', NULL, '34', '38175000', '8', '5153', '5153', '11577', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 727.351, '-19,30900', '-47,52500', 907, 'S', 0.7860, NULL, NULL, '31070', 'N', 'N', 4357, NULL, '3190', '3190', NULL, '1938', 'S', 2029, 'SANTA JULIANA', 'N', '315770', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '674', NULL, '03', 'N', NULL, NULL, NULL, 240);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315780', '3101', 'MG', '3103', '3107', '31030', '31', 'SANTA LUZIA', NULL, '31', '33010970', '7', '5155', '5155', '11578', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 233.759, '-19,77000', '-43,85100', 751, 'S', 0.7540, NULL, NULL, '31016', 'N', 'N', 4364, NULL, '3101', '3101', NULL, '1856', 'S', 2030, 'SANTA LUZIA', 'N', '315780', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '675', NULL, '01', 'N', NULL, NULL, NULL, 410);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315790', '3124', 'MG', '3110', '3112', '31061', '31', 'SANTA MARGARIDA', NULL, '31', '36910000', '6', '5157', '5157', '11579', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 256.183, '-20,38400', '-42,25100', 720, 'S', 0.6960, NULL, NULL, '31059', 'S', 'N', 4371, NULL, '3190', '3190', NULL, '1948', 'S', 2031, 'SANTA MARGARIDA', 'N', '315790', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '676', NULL, '03', 'N', NULL, NULL, NULL, 191);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315800', '3109', 'MG', '3103', '3107', '31031', '31', 'SANTA MARIA DE ITABIRA', NULL, '31', '35910000', '3', '5159', '5159', '11580', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 509.698, '-19,44900', '-43,11300', 506, 'S', 0.7000, NULL, NULL, '31021', 'S', 'N', 4378, NULL, '3190', '3190', NULL, '1943', 'S', 2032, 'SANTA MARIA DE ITABIRA', 'N', '315800', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '677', NULL, '03', 'N', NULL, NULL, NULL, 190);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315810', '3119', 'MG', '3111', '3103', '31014', '31', 'SANTA MARIA DO SALTO', NULL, '33', '39928000', '2', '5161', '5161', '11581', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 442.101, '-16,24900', '-40,14900', 200, 'S', 0.6330, NULL, NULL, '31063', 'S', 'N', 4384, NULL, '3190', '3190', NULL, '1962', 'S', 2033, 'SANTA MARIA DO SALTO', 'N', '315810', 'N', 'S', 'S', NULL, 117, 'S', 'N', 'N', '678', NULL, '03', 'N', NULL, NULL, NULL, 125);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315820', '3116', 'MG', '3106', '3108', '31036', '31', 'SANTA MARIA DO SUACUI', NULL, '33', '39780000', '1', '5163', '5163', '11582', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 623.660, '-18,19000', '-42,41400', 476, 'S', 0.6480, NULL, NULL, '31039', 'S', 'N', 4385, NULL, '3190', '3190', NULL, '1923', 'S', 2034, 'SANTA MARIA DO SUAÇUÍ', 'N', '315820', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '679', NULL, '03', 'N', NULL, NULL, NULL, 179);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315830', '3111', 'MG', '3101', '3110', '31050', '31', 'SANTANA DA VARGEM', NULL, '35', '37195000', '0', '5165', '5165', '11583', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 172.729, '-21,24900', '-45,50700', 817, 'S', 0.7490, NULL, NULL, '31011', 'N', 'N', 4440, NULL, '3190', '3190', NULL, '1962', 'S', 2043, 'SANTANA DA VARGEM', 'N', '315830', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '688', NULL, '03', 'N', NULL, NULL, NULL, 294);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315840', '3127', 'MG', '3107', '3112', '31066', '31', 'SANTANA DE CATAGUASES', NULL, '32', '36795000', '9', '5167', '5167', '11584', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 162.549, '-21,28700', '-42,55700', 232, 'S', 0.7390, NULL, NULL, '31044', 'N', 'N', 4441, NULL, '3190', '3190', NULL, '1962', 'S', 2044, 'SANTANA DE CATAGUASES', 'N', '315840', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '689', NULL, '03', 'N', NULL, NULL, NULL, 246);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315850', '3114', 'MG', '3103', '3107', '31027', '31', 'SANTANA DE PIRAPAMA', NULL, '31', '35785000', '8', '5169', '5169', '11585', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1220.985, '-19,00600', '-44,04300', 628, 'S', 0.6790, NULL, NULL, '31024', 'S', 'N', 4444, NULL, '3190', '3190', NULL, '1948', 'S', 2045, 'SANTANA DE PIRAPAMA', 'N', '315850', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '690', NULL, '03', 'N', NULL, NULL, NULL, 58);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350510', '3502', 'SP', '3512', '3503', '35018', '35', 'BARBOSA', NULL, '18', '16350000', '4', '6199', '6199', '21050', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 205.131, '-21,26700', '-49,94900', 386, 'S', 0.7460, NULL, NULL, '35023', 'N', 'N', 492, NULL, '3590', '3590', NULL, '1959', 'S', 4799, 'BARBOSA', 'N', '350510', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '58', NULL, '03', 'N', NULL, NULL, NULL, 157);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315860', '3105', 'MG', '3107', '3112', '31065', '31', 'SANTANA DO DESERTO', NULL, '32', '36620000', '7', '5171', '5171', '11586', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 182.207, '-21,95000', '-43,16600', 372, 'S', 0.7440, NULL, NULL, '31043', 'N', 'N', 4448, NULL, '3190', '3190', NULL, '1953', 'S', 2046, 'SANTANA DO DESERTO', 'N', '315860', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '691', NULL, '03', 'N', NULL, NULL, NULL, 360);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315870', '3103', 'MG', '3102', '3111', '31058', '31', 'SANTANA DO GARAMBEU', NULL, '32', '36146000', '6', '5173', '5173', '11587', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 202.794, '-21,60100', '-44,10400', 1105, 'S', 0.6820, NULL, NULL, '31013', 'S', 'N', 4449, NULL, '3190', '3190', NULL, '1962', 'S', 2047, 'SANTANA DO GARAMBÉU', 'N', '315870', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '692', NULL, '03', 'N', NULL, NULL, NULL, 241);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315880', '3115', 'MG', '3105', '3109', '31045', '31', 'SANTANA DO JACARE', NULL, '35', '37278000', '5', '5175', '5175', '11588', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 107.445, '-20,89800', '-45,13100', 797, 'S', 0.7000, NULL, NULL, '31033', 'N', 'N', 4452, NULL, '3190', '3190', NULL, '1953', 'S', 2048, 'SANTANA DO JACARÉ', 'N', '315880', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '693', NULL, '03', 'N', NULL, NULL, NULL, 235);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315890', '3124', 'MG', '3110', '3112', '31061', '31', 'SANTANA DO MANHUACU', NULL, '33', '36940000', '4', '5177', '5177', '11589', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 346.964, '-20,10800', '-41,92500', 650, 'S', 0.6690, NULL, NULL, '31059', 'S', 'N', 4454, NULL, '3190', '3190', NULL, '1962', 'S', 2049, 'SANTANA DO MANHUAÇU', 'N', '315890', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '694', NULL, '03', 'N', NULL, NULL, NULL, 191);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315895', '3123', 'MG', '3106', '3108', '31039', '31', 'SANTANA DO PARAISO', NULL, '33', '35167000', '3', '2673', '2673', '11758', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 275.529, '-19,36400', '-42,56900', 285, 'S', 0.7120, NULL, NULL, '31037', 'N', 'N', 4458, NULL, '3103', '3190', NULL, '1993', 'S', 2050, 'SANTANA DO PARAÍSO', 'N', '315895', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '695', NULL, '03', 'N', NULL, NULL, NULL, 358);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315900', '3101', 'MG', '3103', '3107', '31027', '31', 'SANTANA DO RIACHO', NULL, '31', '35845000', '1', '5179', '5179', '11590', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 676.760, '-19,16900', '-43,71400', 700, 'S', 0.6850, NULL, NULL, '31025', 'S', 'N', 4460, NULL, '3190', '3190', NULL, '1962', 'S', 2051, 'SANTANA DO RIACHO', 'N', '315900', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '696', NULL, '03', 'N', NULL, NULL, NULL, 404);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315910', '3103', 'MG', '3102', '3107', '31034', '31', 'SANTANA DOS MONTES', NULL, '31', '36430000', '0', '5181', '5181', '11591', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 196.437, '-20,78800', '-43,69200', 746, 'S', 0.6920, NULL, NULL, '31014', 'S', 'N', 4464, NULL, '3190', '3190', NULL, '1962', 'S', 2052, 'SANTANA DOS MONTES', 'N', '315910', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '697', NULL, '03', 'N', NULL, NULL, NULL, 187);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315920', '3110', 'MG', '3101', '3110', '31051', '31', 'SANTA RITA DE CALDAS', NULL, '35', '37775000', '9', '5183', '5183', '11592', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 502.037, '-22,02900', '-46,33700', 1072, 'S', 0.7680, NULL, NULL, '31006', 'N', 'N', 4396, NULL, '3190', '3190', NULL, '1943', 'S', 2035, 'SANTA RITA DE CALDAS', 'N', '315920', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '680', NULL, '03', 'N', NULL, NULL, NULL, 291);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315930', '3105', 'MG', '3107', '3112', '31065', '31', 'SANTA RITA DE JACUTINGA', NULL, '32', '36135000', '8', '5185', '5185', '11593', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 437.555, '-22,14900', '-44,09500', 550, 'S', 0.7360, NULL, NULL, '31043', 'N', 'N', 4398, NULL, '3190', '3190', NULL, '1943', 'S', 2036, 'SANTA RITA DE JACUTINGA', 'N', '315930', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '682', NULL, '03', 'N', NULL, NULL, NULL, 360);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315935', '3123', 'MG', '3106', '3108', '31040', '31', 'SANTA RITA DE MINAS', NULL, '33', '35326000', '7', '2669', '2669', '11757', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 67.594, '-19,87500', '-42,13200', 950, 'S', 0.6810, NULL, NULL, '31034', 'S', 'N', 4399, NULL, '3190', '3190', NULL, '1993', 'S', 2037, 'SANTA RITA DE MINAS', 'N', '315935', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '683', NULL, '03', 'N', NULL, NULL, NULL, 14);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315940', '3103', 'MG', '3102', '3112', '31065', '31', 'SANTA RITA DE IBITIPOCA', NULL, '32', '36235000', '7', '5187', '5187', '11594', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 324.070, '-21,56300', '-43,91500', 1101, 'S', 0.6900, NULL, NULL, '31013', 'S', 'N', 4401, NULL, '3190', '3190', NULL, '1962', 'S', 2038, 'SANTA RITA DE IBITIPOCA', 'N', '315940', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '681', NULL, '03', 'N', NULL, NULL, NULL, 241);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315950', '3116', 'MG', '3106', '3108', '31041', '31', 'SANTA RITA DO ITUETO', NULL, '33', '35225000', '6', '5189', '5189', '11595', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 486.539, '-19,36000', '-41,38000', 320, 'S', 0.6910, NULL, NULL, '31040', 'S', 'N', 4402, NULL, '3190', '3190', NULL, '1962', 'S', 2039, 'SANTA RITA DO ITUETO', 'N', '315950', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '684', NULL, '03', 'N', NULL, NULL, NULL, 403);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315960', '3110', 'MG', '3101', '3110', '31053', '31', 'SANTA RITA DO SAPUCAI', NULL, '35', '37540000', '5', '5191', '5191', '11596', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 350.874, '-22,25200', '-45,70300', 826, 'S', 0.7890, NULL, NULL, '31007', 'N', 'N', 4406, NULL, '3190', '3190', NULL, '1888', 'S', 2040, 'SANTA RITA DO SAPUCAÍ', 'N', '315960', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '685', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130002', '1309', 'AM', '1301', '1303', '13005', '13', 'ALVARAES', NULL, '97', '69475000', '9', '0289', '0289', '03046', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 5911.754, '-3,22100', '-64,80400', 75, 'S', 0.6470, NULL, NULL, '13091', 'S', 'N', 167, NULL, '1390', '1390', NULL, '1985', 'S', 124, 'ALVARÃES', 'N', '130002', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '1', NULL, '03', 'N', NULL, NULL, NULL, 111);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130006', '1301', 'AM', '1301', '1302', '13003', '13', 'AMATURA', NULL, '97', '69620000', '0', '0291', '0291', '03048', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 4758.821, '-3,36400', '-68,19800', 58, 'S', 0.6310, NULL, NULL, '13012', 'S', 'N', 192, NULL, '1390', '1390', NULL, '1985', 'S', 125, 'AMATURÁ', 'N', '130006', 'S', 'N', 'S', NULL, 165, 'N', 'N', 'N', '2', NULL, '03', 'N', NULL, NULL, NULL, 286);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130008', '1308', 'AM', '1301', '1303', '13006', '13', 'ANAMA', NULL, '97', '69445000', '6', '0293', '0293', '03049', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 2453.934, '-3,58000', '-61,40400', 28, 'S', 0.6370, NULL, NULL, '13082', 'S', 'N', 213, NULL, '1390', '1390', NULL, '1985', 'S', 126, 'ANAMÃ', 'N', '130008', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '3', NULL, '03', 'N', NULL, NULL, NULL, 282);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130010', '1308', 'AM', '1301', '1303', '13006', '13', 'ANORI', NULL, '97', '69440000', '2', '0203', '0203', '03002', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 5795.283, '-3,77300', '-61,64400', 120, 'S', 0.6340, NULL, NULL, '13082', 'S', 'N', 249, NULL, '1390', '1390', NULL, '1985', 'S', 127, 'ANORI', 'N', '130010', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '4', NULL, '03', 'N', NULL, NULL, NULL, 282);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130014', '1307', 'AM', '1301', '1304', '13013', '13', 'APUI', NULL, '97', '69265000', '4', '0969', '0969', '03050', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 54239.904, '-7,19700', '-59,89100', 135, 'S', 0.6760, NULL, NULL, '13072', 'S', 'N', 283, NULL, '1390', '1390', NULL, '1989', 'S', 128, 'APUÍ', 'N', '130014', 'S', 'N', 'S', NULL, 119, 'N', 'N', 'N', '5', NULL, '03', 'N', NULL, NULL, NULL, 397);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130020', '1301', 'AM', '1301', '1302', '13003', '13', 'ATALAIA DO NORTE', NULL, '97', '69650000', '1', '0205', '0205', '03003', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 76354.985, '-4,37200', '-70,19200', 65, 'S', 0.5590, NULL, NULL, '13011', 'S', 'N', 414, NULL, '1390', '1390', NULL, '1955', 'S', 129, 'ATALAIA DO NORTE', 'N', '130020', 'S', 'N', 'S', NULL, 165, 'N', 'N', 'N', '6', NULL, '03', 'N', NULL, NULL, NULL, 286);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('130030', '1303', 'AM', '1301', '1303', '13007', '13', 'AUTAZES', NULL, '92', '69240000', '0', '0207', '0207', '03004', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 7599.282, '-3,58000', '-59,13100', 36, 'S', 0.6610, NULL, NULL, '13031', 'S', 'N', 431, NULL, '1390', '1390', NULL, '1985', 'S', 130, 'AUTAZES', 'N', '130030', 'S', 'N', 'S', NULL, 44, 'N', 'N', 'N', '7', NULL, '03', 'N', NULL, NULL, NULL, 334);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315970', '3107', 'MG', '3109', '3105', '31020', '31', 'SANTA ROSA DA SERRA', NULL, '34', '38805000', '4', '5193', '5193', '11597', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 296.342, '-19,53000', '-45,96600', 1011, 'S', 0.7450, NULL, NULL, '31057', 'N', 'N', 4409, NULL, '3190', '3190', NULL, '1962', 'S', 2041, 'SANTA ROSA DA SERRA', 'N', '315970', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '686', NULL, '03', 'N', NULL, NULL, NULL, 194);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150475', NULL, 'PA', NULL, NULL, NULL, NULL, 'MOJUI DOS CAMPOS', NULL, NULL, NULL, NULL, '1190', NULL, NULL, NULL, 'ATIVO', NULL, NULL, NULL, NULL, 'N', 'N', NULL, 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, NULL, 'S', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2013', NULL, NULL, NULL, 'N', NULL, NULL, NULL, 'S', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, NULL, 446);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315980', '3125', 'MG', '3113', '3105', '31017', '31', 'SANTA VITORIA', NULL, '34', '38320000', '3', '5195', '5195', '11598', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3002.817, '-18,83900', '-50,12100', 498, 'S', 0.7600, NULL, NULL, '31073', 'N', 'N', 4433, NULL, '3190', '3190', NULL, '1948', 'S', 2042, 'SANTA VITÓRIA', 'N', '315980', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '687', NULL, '03', 'N', NULL, NULL, NULL, 17);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('315990', '3115', 'MG', '3105', '3109', '31046', '31', 'SANTO ANTONIO DO AMPARO', NULL, '35', '37262000', '2', '5197', '5197', '11599', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 491.725, '-20,94600', '-44,91900', 1013, 'S', 0.7260, NULL, NULL, '31033', 'N', 'N', 4491, NULL, '3190', '3190', NULL, '1938', 'S', 2053, 'SANTO ANTÔNIO DO AMPARO', 'N', '315990', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '698', NULL, '03', 'N', NULL, NULL, NULL, 235);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430145', NULL, 'RS', NULL, NULL, NULL, NULL, 'PINTO BANDEIRA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'ATIVO', NULL, NULL, NULL, NULL, 'N', 'N', NULL, 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, NULL, 'S', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2013', NULL, NULL, NULL, 'N', NULL, NULL, NULL, 'S', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316000', '3127', 'MG', '3107', '3112', '31066', '31', 'SANTO ANTONIO DO AVENTUREIRO', NULL, '32', '36670000', '9', '5199', '5199', '11600', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 201.887, '-21,75800', '-42,81600', 625, 'S', 0.7090, NULL, NULL, '31041', 'N', 'N', 4493, NULL, '3190', '3190', NULL, '1962', 'S', 2054, 'SANTO ANTÔNIO DO AVENTUREIRO', 'N', '316000', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '699', NULL, '03', 'N', NULL, NULL, NULL, 409);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316010', '3108', 'MG', '3110', '3112', '31060', '31', 'SANTO ANTONIO DO GRAMA', NULL, '31', '35388000', '8', '5201', '5201', '11601', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 129.810, '-20,31400', '-42,60900', 421, 'S', 0.6930, NULL, NULL, '31060', 'S', 'N', 4496, NULL, '3190', '3190', NULL, '1953', 'S', 2055, 'SANTO ANTÔNIO DO GRAMA', 'N', '316010', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '700', NULL, '03', 'N', NULL, NULL, NULL, 347);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316020', '3104', 'MG', '3104', '3107', '31028', '31', 'SANTO ANTONIO DO ITAMBE', NULL, '33', '39160000', '7', '5203', '5203', '11602', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 303.857, '-18,46600', '-43,30700', 701, 'S', 0.6350, NULL, NULL, '31026', 'S', 'N', 4498, NULL, '3190', '3190', NULL, '1962', 'S', 2056, 'SANTO ANTÔNIO DO ITAMBÉ', 'N', '316020', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '701', NULL, '03', 'N', NULL, NULL, NULL, 126);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500000', NULL, 'MS', NULL, NULL, NULL, '50', 'MUNICIPIO IGNORADO - MS ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IGNR', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', 0.00, 'N', NULL, NULL, NULL, NULL, 'N', 0.0000, NULL, NULL, NULL, 'N', 'N', NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('160000', NULL, 'AP', NULL, NULL, NULL, '16', 'MUNICIPIO IGNORADO - AP ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IGNR', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', 0.00, 'N', NULL, NULL, NULL, NULL, 'N', 0.0000, NULL, NULL, NULL, 'N', 'N', NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('150240', '1503', 'PA', '1590', '1503', '15008', '15', 'CASTANHAL', NULL, '91', '68740970', '0', '0447', '0447', '12024', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1029.191, '-1,29700', '-47,92200', 41, 'S', 0.7460, NULL, NULL, '15900', 'N', 'N', 1155, NULL, '1501', '1590', NULL, '1932', 'S', 2447, 'CASTANHAL', 'N', '150240', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'S', '36', NULL, '01', 'N', NULL, NULL, NULL, 452);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210215', '2103', 'MA', '2106', '2102', '21008', '21', 'BREJO DE AREIA', NULL, '98', '65315000', '0', '0132', '0132', '09151', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 482.892, '-4,33400', '-45,58100', 0, 'S', 0.5010, NULL, NULL, '21900', 'S', 'N', 758, NULL, '2190', '2190', NULL, '1997', 'S', 1176, 'BREJO DE AREIA', 'N', '210215', 'S', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '38', NULL, '03', 'N', NULL, NULL, NULL, 237);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('210510', '2114', 'MA', '2101', '2101', '21003', '21', 'ICATU', NULL, '98', '65170000', '4', '0799', '0799', '09050', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1448.796, '-2,77600', '-44,06600', 12, 'S', 0.5720, NULL, NULL, '21900', 'S', 'N', 2107, NULL, '2190', '2190', NULL, '1688', 'S', 1225, 'ICATU', 'N', '210510', 'S', 'S', 'S', NULL, 52, 'S', 'N', 'N', '87', NULL, '03', 'N', NULL, NULL, NULL, 123);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('260650', '2605', 'PE', '2602', '2603', '26011', '26', 'IATI', NULL, '87', '55345000', '7', '2429', '2429', '15065', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 635.143, '-9,04600', '-36,84600', 487, 'S', 0.5260, NULL, NULL, '26900', 'S', 'N', 2055, NULL, '2690', '2690', NULL, '1963', 'S', 2849, 'IATI', 'N', '260650', 'N', 'S', 'S', NULL, 2, 'N', 'N', 'N', '72', NULL, '03', 'N', NULL, NULL, NULL, 257);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('251275', '2512', 'PB', '2590', '2503', '25018', '25', 'RIACHAO DO BACAMARTE', NULL, '83', NULL, '4', '0504', NULL, '13205', NULL, 'ATIVO', 'N', 'N', NULL, 'ASSIS CHATEAUBRIAND       ', 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 38.369, '-7,24300', '-35,66600', 0, 'S', 0.5620, NULL, NULL, '25900', 'S', 'N', 407, NULL, '2502', '2590', NULL, '1997', 'S', 5585, 'RIACHÃO DO BACAMARTE', 'N', '251275', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '159', NULL, '03', 'N', NULL, NULL, NULL, 309);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('270000', NULL, 'AL', NULL, NULL, NULL, '27', 'MUNICIPIO IGNORADO - AL ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IGNR', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', 0.00, 'N', NULL, NULL, NULL, NULL, 'N', 0.0000, NULL, NULL, NULL, 'N', 'N', NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('280000', NULL, 'SE', NULL, NULL, NULL, '28', 'MUNICIPIO IGNORADO - SE ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IGNR', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', 0.00, 'N', NULL, NULL, NULL, NULL, 'N', 0.0000, NULL, NULL, NULL, 'N', 'N', NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('310000', NULL, 'MG', NULL, NULL, NULL, '31', 'MUNICIPIO IGNORADO - MG ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IGNR', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', 0.00, 'N', NULL, NULL, NULL, NULL, 'N', 0.0000, NULL, NULL, NULL, 'N', 'N', NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320000', NULL, 'ES', NULL, NULL, NULL, '32', 'MUNICIPIO IGNORADO - ES ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IGNR', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', 0.00, 'N', NULL, NULL, NULL, NULL, 'N', 0.0000, NULL, NULL, NULL, 'N', 'N', NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330000', NULL, 'RJ', NULL, NULL, NULL, '33', 'MUNICIPIO IGNORADO - RJ ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IGNR', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', 0.00, 'N', NULL, NULL, NULL, NULL, 'N', 0.0000, NULL, NULL, NULL, 'N', 'N', NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316030', '3119', 'MG', '3111', '3103', '31014', '31', 'SANTO ANTONIO DO JACINTO', NULL, '33', '39935000', '6', '5205', '5205', '11603', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 497.437, '-16,53400', '-40,17600', 400, 'S', 0.6110, NULL, NULL, '31063', 'S', 'N', 4499, NULL, '3190', '3190', NULL, '1962', 'S', 2057, 'SANTO ANTÔNIO DO JACINTO', 'N', '316030', 'N', 'S', 'S', NULL, 117, 'N', 'N', 'N', '702', NULL, '03', 'N', NULL, NULL, NULL, 125);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350000', NULL, 'SP', NULL, NULL, NULL, '35', 'MUNICIPIO IGNORADO - SP ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IGNR', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', 0.00, 'N', NULL, NULL, NULL, NULL, 'N', 0.0000, NULL, NULL, NULL, 'N', 'N', NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420230', '4207', 'SC', '4205', '4205', '42016', '42', 'BIGUACU', NULL, '48', '88160000', '5', '8045', '8045', '20023', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'S', NULL, 'N', 324.521, '-27,49400', '-48,65600', 2, 'S', 0.8180, NULL, NULL, '42900', 'N', 'N', 615, NULL, '4201', '4201', NULL, '1833', 'S', 4409, 'BIGUAÇU', 'N', '420230', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '37', NULL, '02', 'N', NULL, NULL, NULL, 494);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420775', '4201', 'SC', '4201', '4201', '42002', '42', 'IRACEMINHA', NULL, '49', '89891000', '9', '9953', '9953', '20205', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 164.375, '-26,82300', '-53,27400', 445, 'S', 0.7770, NULL, NULL, '42900', 'N', 'N', 2233, NULL, '4290', '4290', NULL, '1990', 'S', 4493, 'IRACEMINHA', 'N', '420775', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '121', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316040', '3115', 'MG', '3105', '3109', '31043', '31', 'SANTO ANTONIO DO MONTE', NULL, '37', '35560000', '5', '5207', '5207', '11604', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1129.365, '-20,08700', '-45,29400', 919, 'S', 0.7790, NULL, NULL, '31029', 'N', 'N', 4502, NULL, '3190', '3190', NULL, '1870', 'S', 2058, 'SANTO ANTÔNIO DO MONTE', 'N', '316040', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '703', NULL, '03', 'N', NULL, NULL, NULL, 413);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421265', NULL, 'SC', NULL, NULL, NULL, NULL, 'PESCARIA BRAVA', NULL, NULL, NULL, NULL, '1194', NULL, NULL, NULL, 'ATIVO', NULL, NULL, NULL, NULL, 'N', 'N', NULL, 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, NULL, 'S', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2013', NULL, NULL, NULL, 'N', NULL, NULL, NULL, 'S', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, NULL, 495);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316045', '3106', 'MG', '3108', '3102', '31005', '31', 'SANTO ANTONIO DO RETIRO', NULL, '38', '39538000', '4', '0708', NULL, '11836', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 796.872, '-15,33900', '-42,62400', 815, 'S', 0.6010, NULL, NULL, '31056', 'S', 'N', 4507, NULL, '3190', '3190', NULL, '1997', 'S', 2059, 'SANTO ANTÔNIO DO RETIRO', 'N', '316045', 'N', 'S', 'S', NULL, 7, 'S', 'N', 'N', '704', NULL, '03', 'N', NULL, NULL, NULL, 348);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430460', '4301', 'RS', '4302', '4305', '43026', '43', 'CANOAS', NULL, '51', '92001970', '6', '8589', '8589', '19045', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 131.097, '-29,91800', '-51,18400', 8, 'S', 0.8150, NULL, NULL, '43900', 'N', 'N', 1023, NULL, '4301', '4301', NULL, '1939', 'S', 3980, 'CANOAS', 'N', '430460', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '80', NULL, '01', 'N', NULL, NULL, NULL, 464);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430003', '4307', 'RS', '4306', '4306', '43031', '43', 'ACEGUA', NULL, '53', '96445000', '4', '1118', NULL, '19471', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1549.522, '-31,86800', '-54,16200', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5632, NULL, '4390', '4390', NULL, '2001', 'S', 5526, 'ACEGUÁ', 'N', '430003', 'N', 'N', 'S', NULL, 104, 'N', 'N', 'N', '1', NULL, '03', 'N', NULL, NULL, NULL, 478);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316050', '3109', 'MG', '3103', '3107', '31028', '31', 'SANTO ANTONIO DO RIO ABAIXO', NULL, '31', '35880000', '4', '5209', '5209', '11605', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 107.154, '-19,22800', '-43,25400', 550, 'S', 0.6980, NULL, NULL, '31021', 'S', 'N', 4508, NULL, '3190', '3190', NULL, '1962', 'S', 2060, 'SANTO ANTÔNIO DO RIO ABAIXO', 'N', '316050', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '705', NULL, '03', 'N', NULL, NULL, NULL, 190);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316245', '3129', 'MG', '3108', '3102', '31003', '31', 'SAO JOAO DAS MISSOES', NULL, '38', '39475000', '0', '0718', '0718', '11840', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 675.089, '-14,88400', '-44,09100', 505, 'S', 0.5950, NULL, NULL, '31076', 'S', 'N', 4643, NULL, '3190', '3190', NULL, '1997', 'S', 2085, 'SÃO JOÃO DAS MISSÕES', 'N', '316245', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '730', NULL, '03', 'N', NULL, NULL, NULL, 303);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500627', NULL, 'MS', NULL, NULL, NULL, NULL, 'PARAISO DAS AGUAS', NULL, NULL, NULL, NULL, '1196', NULL, NULL, NULL, 'ATIVO', NULL, NULL, NULL, NULL, 'N', 'N', NULL, 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, NULL, 'S', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2013', NULL, NULL, NULL, 'N', NULL, NULL, NULL, 'S', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432200', '4301', 'RS', '4302', '4305', '43025', '43', 'TRIUNFO', NULL, '51', '95840000', '4', '8943', '8943', '19221', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 823.416, '-29,94300', '-51,71800', 31, 'S', 0.7880, NULL, NULL, '43900', 'N', 'N', 5239, NULL, '4301', '4301', NULL, '1831', 'S', 4340, 'TRIUNFO', 'N', '432200', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '462', NULL, '01', 'N', NULL, NULL, NULL, 464);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430000', NULL, 'RS', NULL, NULL, NULL, '43', 'MUNICIPIO IGNORADO - RS ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IGNR', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', 0.00, 'N', NULL, NULL, NULL, NULL, 'N', 0.0000, NULL, NULL, NULL, 'N', 'N', NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431453', '4305', 'RS', '4305', '4302', '43016', '43', 'PINTO BANDEIRA (EXTINTO)', NULL, '54', NULL, '0', NULL, NULL, '19492', NULL, 'TRANS', NULL, 'N', '430210', NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 0.000, '-29,096', '-51,45', 0, 'N', NULL, NULL, NULL, '43900', NULL, NULL, 5674, NULL, '4303', '4302', '2002', '2001', 'S', 5548, NULL, 'N', '431453', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '497', NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510000', NULL, 'MT', NULL, NULL, NULL, '51', 'MUNICIPIO IGNORADO - MT ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IGNR', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', 0.00, 'N', NULL, NULL, NULL, NULL, 'N', 0.0000, NULL, NULL, NULL, 'N', 'N', NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, 'N', NULL, 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316060', '3114', 'MG', '3103', '3106', '31025', '31', 'SANTO HIPOLITO', NULL, '38', '39210000', '3', '5211', '5211', '11606', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 430.775, '-18,29700', '-44,22300', 526, 'S', 0.6710, NULL, NULL, '31019', 'S', 'N', 4518, NULL, '3190', '3190', NULL, '1962', 'S', 2061, 'SANTO HIPÓLITO', 'N', '316060', 'N', 'N', 'S', NULL, 48, 'N', 'N', 'N', '706', NULL, '03', 'N', NULL, NULL, NULL, 65);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316070', '3105', 'MG', '3107', '3112', '31065', '31', 'SANTOS DUMONT', NULL, '32', '36240000', '2', '5213', '5213', '11607', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 637.377, '-21,45700', '-43,55300', 839, 'S', 0.7660, NULL, NULL, '31046', 'N', 'N', 4523, NULL, '3190', '3190', NULL, '1889', 'S', 2062, 'SANTOS DUMONT', 'N', '316070', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '707', NULL, '03', 'N', NULL, NULL, NULL, 180);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316080', '3111', 'MG', '3101', '3110', '31050', '31', 'SAO BENTO ABADE', NULL, '35', '37414000', '1', '5215', '5215', '11608', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 80.404, '-21,58200', '-45,07600', 971, 'S', 0.7120, NULL, NULL, '31010', 'N', 'N', 4529, NULL, '3190', '3190', NULL, '1962', 'S', 2063, 'SÃO BENTO ABADE', 'N', '316080', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '708', NULL, '03', 'N', NULL, NULL, NULL, 293);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316090', '3103', 'MG', '3102', '3107', '31034', '31', 'SAO BRAS DO SUACUI', NULL, '31', '35495000', '0', '5217', '5217', '11609', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 110.442, '-20,62500', '-43,94900', 971, 'S', 0.7430, NULL, NULL, '31014', 'N', 'N', 4543, NULL, '3190', '3190', NULL, '1953', 'S', 2064, 'SÃO BRÁS DO SUAÇUÍ', 'N', '316090', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '709', NULL, '03', 'N', NULL, NULL, NULL, 187);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316265', '3106', 'MG', '3108', '3102', '31007', '31', 'SAO JOAO DO PACUI', NULL, '38', '39365000', '8', '0720', NULL, '11762', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 420.462, '-16,54200', '-44,51600', 675, 'S', 0.6150, NULL, NULL, '31050', 'S', 'N', 4660, NULL, '3190', '3190', NULL, '1997', 'S', 2090, 'SÃO JOÃO DO PACUÍ', 'N', '316265', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '735', NULL, '03', 'N', NULL, NULL, NULL, 63);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316095', '3123', 'MG', '3106', '3108', '31040', '31', 'SAO DOMINGOS DAS DORES', NULL, '33', '35335000', '9', '0710', NULL, '11837', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 61.157, '-19,52700', '-42,01100', 700, 'S', 0.7230, NULL, NULL, '31034', 'N', 'N', 4558, NULL, '3190', '3190', NULL, '1997', 'S', 2065, 'SÃO DOMINGOS DAS DORES', 'N', '316095', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '710', NULL, '03', 'N', NULL, NULL, NULL, 14);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316100', '3109', 'MG', '3103', '3107', '31031', '31', 'SAO DOMINGOS DO PRATA', NULL, '31', '35995000', '7', '5219', '5219', '11610', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 746.917, '-19,86500', '-42,96800', 577, 'S', 0.7510, NULL, NULL, '31023', 'N', 'N', 4566, NULL, '3190', '3190', NULL, '1890', 'S', 2066, 'SÃO DOMINGOS DO PRATA', 'N', '316100', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '711', NULL, '03', 'N', NULL, NULL, NULL, 18);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316180', '3115', 'MG', '3105', '3109', '31043', '31', 'SAO GONCALO DO PARA', NULL, '37', '35516000', '9', '5235', '5235', '11618', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 265.578, '-19,98300', '-44,85900', 739, 'S', 0.7440, NULL, NULL, '31029', 'N', 'N', 4614, NULL, '3190', '3190', NULL, '1948', 'S', 2076, 'SÃO GONÇALO DO PARÁ', 'N', '316180', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '721', NULL, '03', 'N', NULL, NULL, NULL, 413);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316190', '3109', 'MG', '3103', '3107', '31031', '31', 'SAO GONCALO DO RIO ABAIXO', NULL, '31', '35935000', '8', '5237', '5237', '11619', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 364.631, '-19,82600', '-43,36200', 627, 'S', 0.7020, NULL, NULL, '31021', 'N', 'N', 4616, NULL, '3190', '3190', NULL, '1962', 'S', 2077, 'SÃO GONÇALO DO RIO ABAIXO', 'N', '316190', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '722', NULL, '03', 'N', NULL, NULL, NULL, 190);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316105', '3116', 'MG', '3106', '3108', '31038', '31', 'SAO FELIX DE MINAS', NULL, '33', '35275000', '6', '0712', NULL, '11838', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 165.744, '-18,59100', '-41,48600', 550, 'S', 0.6350, NULL, NULL, '31038', 'S', 'N', 4572, NULL, '3190', '3190', NULL, '1997', 'S', 2067, 'SÃO FÉLIX DE MINAS', 'N', '316105', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '712', NULL, '03', 'N', NULL, NULL, NULL, 66);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316110', '3129', 'MG', '3108', '3102', '31003', '31', 'SAO FRANCISCO', NULL, '38', '39300000', '6', '5221', '5221', '11611', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 3299.801, '-15,94900', '-44,86400', 695, 'S', 0.6800, NULL, NULL, '31049', 'N', 'N', 4583, NULL, '3190', '3190', NULL, '1831', 'S', 2068, 'SÃO FRANCISCO', 'N', '316110', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '713', NULL, '02', 'N', NULL, NULL, NULL, 243);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316120', '3115', 'MG', '3105', '3109', '31046', '31', 'SAO FRANCISCO DE PAULA', NULL, '37', '35543000', '5', '5223', '5223', '11612', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 316.414, '-20,71000', '-44,98500', 931, 'S', 0.7140, NULL, NULL, '31033', 'N', 'N', 4589, NULL, '3190', '3190', NULL, '1962', 'S', 2069, 'SÃO FRANCISCO DE PAULA', 'N', '316120', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '714', NULL, '03', 'N', NULL, NULL, NULL, 235);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316130', '3113', 'MG', '3112', '3105', '31021', '31', 'SAO FRANCISCO DE SALES', NULL, '34', '38260000', '4', '5225', '5225', '11613', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1128.745, '-19,86300', '-49,77400', 423, 'S', 0.7710, NULL, NULL, '31071', 'N', 'N', 4590, NULL, '3190', '3190', NULL, '1962', 'S', 2070, 'SÃO FRANCISCO DE SALES', 'N', '316130', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '715', NULL, '03', 'N', NULL, NULL, NULL, 244);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316140', '3118', 'MG', '3107', '3112', '31063', '31', 'SAO FRANCISCO DO GLORIA', NULL, '32', '36810000', '3', '5227', '5227', '11614', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 164.023, '-20,78900', '-42,26800', 729, 'S', 0.6920, NULL, NULL, '31045', 'S', 'N', 4593, NULL, '3190', '3190', NULL, '1953', 'S', 2071, 'SÃO FRANCISCO DO GLÓRIA', 'N', '316140', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '716', NULL, '03', 'N', NULL, NULL, NULL, 130);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316150', '3118', 'MG', '3107', '3112', '31064', '31', 'SAO GERALDO', NULL, '32', '36530000', '2', '5229', '5229', '11615', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 187.387, '-20,92300', '-42,83400', 372, 'S', 0.7320, NULL, NULL, '31048', 'N', 'N', 4605, NULL, '3190', '3190', NULL, '1948', 'S', 2072, 'SÃO GERALDO', 'N', '316150', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '717', NULL, '03', 'N', NULL, NULL, NULL, 181);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316160', '3116', 'MG', '3106', '3108', '31037', '31', 'SAO GERALDO DA PIEDADE', NULL, '33', '39723000', '1', '5231', '5231', '11616', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 153.527, '-18,83600', '-42,28800', 292, 'S', 0.6470, NULL, NULL, '31036', 'S', 'N', 4606, NULL, '3190', '3190', NULL, '1962', 'S', 2073, 'SÃO GERALDO DA PIEDADE', 'N', '316160', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '718', NULL, '03', 'N', NULL, NULL, NULL, 189);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316165', '3116', 'MG', '3106', '3108', '31037', '31', 'SAO GERALDO DO BAIXIO', NULL, '33', '35258000', '0', '0714', NULL, '11839', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 280.010, '-18,90000', '-41,36000', 210, 'S', 0.6950, NULL, NULL, '31036', 'S', 'N', 4608, NULL, '3190', '3190', NULL, '1997', 'S', 2074, 'SÃO GERALDO DO BAIXIO', 'N', '316165', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '719', NULL, '03', 'N', NULL, NULL, NULL, 189);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316170', '3107', 'MG', '3109', '3101', '31002', '31', 'SAO GONCALO DO ABAETE', NULL, '38', '38790000', '0', '5233', '5233', '11617', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2687.410, '-18,33800', '-45,83300', 789, 'S', 0.7390, NULL, NULL, '31057', 'N', 'N', 4610, NULL, '3190', '3190', NULL, '1943', 'S', 2075, 'SÃO GONÇALO DO ABAETÉ', 'N', '316170', 'N', 'N', 'S', NULL, 63, 'N', 'N', 'N', '720', NULL, '03', 'N', NULL, NULL, NULL, 194);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316210', '3107', 'MG', '3109', '3105', '31020', '31', 'SAO GOTARDO', NULL, '34', '38800000', '4', '5241', '5241', '11621', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 853.745, '-19,31100', '-46,04900', 1055, 'S', 0.8070, NULL, NULL, '31057', 'N', 'N', 4620, NULL, '3190', '3190', NULL, '1911', 'S', 2080, 'SÃO GOTARDO', 'N', '316210', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '725', NULL, '03', 'N', NULL, NULL, NULL, 194);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316220', '3122', 'MG', '3101', '3110', '31047', '31', 'SAO JOAO BATISTA DO GLORIA', NULL, '35', '37920000', '3', '5243', '5243', '11622', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 553.346, '-20,64100', '-46,50600', 695, 'S', 0.7700, NULL, NULL, '31005', 'N', 'N', 4627, NULL, '3190', '3190', NULL, '1948', 'S', 2081, 'SÃO JOÃO BATISTA DO GLÓRIA', 'N', '316220', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '726', NULL, '03', 'N', NULL, NULL, NULL, 361);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316225', '3106', 'MG', '3108', '3102', '31007', '31', 'SAO JOAO DA LAGOA', NULL, '38', '39355000', '2', '0716', NULL, '11759', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 989.854, '-16,85300', '-44,35200', 835, 'S', 0.6730, NULL, NULL, '31050', 'S', 'N', 4634, NULL, '3190', '3190', NULL, '1997', 'S', 2082, 'SÃO JOÃO DA LAGOA', 'N', '316225', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '727', NULL, '03', 'N', NULL, NULL, NULL, 63);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316230', '3110', 'MG', '3101', '3110', '31053', '31', 'SAO JOAO DA MATA', NULL, '35', '37568000', '2', '5245', '5245', '11623', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 120.500, '-21,93000', '-45,92900', 884, 'S', 0.7730, NULL, NULL, '31007', 'N', 'N', 4635, NULL, '3190', '3190', NULL, '1962', 'S', 2083, 'SÃO JOÃO DA MATA', 'N', '316230', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '728', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316240', '3129', 'MG', '3108', '3102', '31007', '31', 'SAO JOAO DA PONTE', NULL, '38', '39430000', '1', '5247', '5247', '11624', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1849.188, '-15,92900', '-44,00800', 752, 'S', 0.6260, NULL, NULL, '31049', 'S', 'N', 4638, NULL, '3190', '3190', NULL, '1943', 'S', 2084, 'SÃO JOÃO DA PONTE', 'N', '316240', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '729', NULL, '03', 'N', NULL, NULL, NULL, 243);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316250', '3120', 'MG', '3102', '3111', '31058', '31', 'SAO JOAO DEL REI', NULL, '32', '36300000', '0', '5249', '5249', '11625', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1463.593, '-21,13600', '-44,26200', 910, 'S', 0.8160, NULL, NULL, '31015', 'N', 'N', 4647, NULL, '3190', '3190', NULL, '1714', 'S', 2086, 'SÃO JOÃO DEL REI', 'N', '316250', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '731', NULL, '02', 'N', NULL, NULL, NULL, 114);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316255', '3124', 'MG', '3110', '3112', '31061', '31', 'SAO JOAO DO MANHUACU', NULL, '33', '36918000', '9', '2677', '2677', '11760', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 142.510, '-20,39400', '-42,15100', 852, 'S', 0.6980, NULL, NULL, '31059', 'S', 'N', 4656, NULL, '3190', '3190', NULL, '1993', 'S', 2087, 'SÃO JOÃO DO MANHUAÇU', 'N', '316255', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '732', NULL, '03', 'N', NULL, NULL, NULL, 191);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316257', '3116', 'MG', '3106', '3108', '31038', '31', 'SAO JOAO DO MANTENINHA', NULL, '33', '35277000', '5', '2679', '2679', '11761', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 139.388, '-18,72100', '-41,16000', 0, 'S', 0.6660, NULL, NULL, '31038', 'S', 'N', 4657, NULL, '3190', '3190', NULL, '1993', 'S', 2088, 'SÃO JOÃO DO MANTENINHA', 'N', '316257', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '733', NULL, '03', 'N', NULL, NULL, NULL, 66);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316260', '3123', 'MG', '3106', '3108', '31040', '31', 'SAO JOAO DO ORIENTE', NULL, '33', '35146000', '9', '5251', '5251', '11626', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 120.237, '-19,33900', '-42,15800', 240, 'S', 0.6790, NULL, NULL, '31037', 'S', 'N', 4659, NULL, '3104', '3190', NULL, '1962', 'S', 2089, 'SÃO JOÃO DO ORIENTE', 'N', '316260', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '734', NULL, '03', 'N', NULL, NULL, NULL, 358);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316270', '3106', 'MG', '3108', '3102', '31005', '31', 'SAO JOAO DO PARAISO', NULL, '38', '39540000', '8', '5253', '5253', '11627', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1921.172, '-15,31400', '-42,01400', 780, 'S', 0.6440, NULL, NULL, '31056', 'S', 'N', 4662, NULL, '3190', '3190', NULL, '1943', 'S', 2091, 'SÃO JOÃO DO PARAÍSO', 'N', '316270', 'N', 'S', 'S', NULL, 7, 'N', 'N', 'N', '736', NULL, '03', 'N', NULL, NULL, NULL, 348);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316280', '3116', 'MG', '3106', '3108', '31035', '31', 'SAO JOAO EVANGELISTA', NULL, '33', '39705000', '7', '5255', '5255', '11628', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 478.820, '-18,54800', '-42,76300', 690, 'S', 0.6830, NULL, NULL, '31039', 'S', 'N', 4673, NULL, '3190', '3190', NULL, '1911', 'S', 2092, 'SÃO JOÃO EVANGELISTA', 'N', '316280', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '737', NULL, '03', 'N', NULL, NULL, NULL, 179);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316290', '3105', 'MG', '3107', '3112', '31065', '31', 'SAO JOAO NEPOMUCENO', NULL, '32', '36680000', '6', '5257', '5257', '11629', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 407.896, '-21,54000', '-43,01100', 370, 'S', 0.7630, NULL, NULL, '31047', 'N', 'N', 4674, NULL, '3190', '3190', NULL, '1880', 'S', 2093, 'SÃO JOÃO NEPOMUCENO', 'N', '316290', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '738', NULL, '03', 'N', NULL, NULL, NULL, 115);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316292', '3101', 'MG', '3103', '3107', '31030', '31', 'SAO JOAQUIM DE BICAS', NULL, '31', '32920000', '2', '0722', '0722', '11841', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 72.455, '-20,04900', '-44,27400', 758, 'S', 0.7070, NULL, NULL, '31017', 'N', 'N', 4677, NULL, '3101', '3101', NULL, '1997', 'S', 2094, 'SÃO JOAQUIM DE BICAS', 'N', '316292', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '739', NULL, '01', 'N', NULL, NULL, NULL, 242);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316294', '3122', 'MG', '3101', '3110', '31047', '31', 'SAO JOSE DA BARRA', NULL, '35', '37945000', '8', '0724', NULL, '11770', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 312.496, '-20,71800', '-46,31100', 730, 'S', 0.7920, NULL, NULL, '31005', 'N', 'N', 4684, NULL, '3190', '3190', NULL, '1997', 'S', 2095, 'SÃO JOSÉ DA BARRA', 'N', '316294', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '740', NULL, '03', 'N', NULL, NULL, NULL, 361);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316295', '3101', 'MG', '3103', '3107', '31030', '31', 'SAO JOSE DA LAPA', NULL, '31', '33350000', '5', '2649', '2649', '11763', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 48.636, '-19,70100', '-43,95500', 120, 'S', 0.7470, NULL, NULL, '31025', 'N', 'N', 4690, NULL, '3101', '3101', NULL, '1993', 'S', 2096, 'SÃO JOSÉ DA LAPA', 'N', '316295', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '741', NULL, '01', 'N', NULL, NULL, NULL, 404);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316300', '3116', 'MG', '3106', '3108', '31037', '31', 'SAO JOSE DA SAFIRA', NULL, '33', '39785000', '3', '5259', '5259', '11630', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 214.454, '-18,32400', '-42,14300', 310, 'S', 0.6140, NULL, NULL, '31036', 'S', 'N', 4691, NULL, '3190', '3190', NULL, '1962', 'S', 2097, 'SÃO JOSÉ DA SAFIRA', 'N', '316300', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '742', NULL, '03', 'N', NULL, NULL, NULL, 189);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316310', '3115', 'MG', '3105', '3107', '31029', '31', 'SAO JOSE DA VARGINHA', NULL, '37', '35694000', '2', '5261', '5261', '11631', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 205.099, '-19,71000', '-44,55700', 755, 'S', 0.7600, NULL, NULL, '31032', 'N', 'N', 4693, NULL, '3102', '3190', NULL, '1962', 'S', 2098, 'SÃO JOSÉ DA VARGINHA', 'N', '316310', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '743', NULL, '03', 'N', NULL, NULL, NULL, 131);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316320', '3110', 'MG', '3101', '3110', '31053', '31', 'SAO JOSE DO ALEGRE', NULL, '35', '37510000', '1', '5263', '5263', '11632', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 89.243, '-22,32900', '-45,52600', 851, 'S', 0.7560, NULL, NULL, '31003', 'N', 'N', 4704, NULL, '3190', '3190', NULL, '1953', 'S', 2099, 'SÃO JOSÉ DO ALEGRE', 'N', '316320', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '744', NULL, '03', 'N', NULL, NULL, NULL, 16);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316330', '3117', 'MG', '3111', '3108', '31037', '31', 'SAO JOSE DO DIVINO', NULL, '33', '39848000', '0', '5265', '5265', '11633', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 326.230, '-18,47900', '-41,38900', 340, 'S', 0.6700, NULL, NULL, '31069', 'S', 'N', 4713, NULL, '3190', '3190', NULL, '1962', 'S', 2100, 'SÃO JOSÉ DO DIVINO', 'N', '316330', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '745', NULL, '03', 'N', NULL, NULL, NULL, 292);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316340', '3108', 'MG', '3110', '3107', '31031', '31', 'SAO JOSE DO GOIABAL', NULL, '31', '35986000', '9', '5267', '5267', '11634', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 185.241, '-19,92900', '-42,70500', 287, 'S', 0.6850, NULL, NULL, '31060', 'S', 'N', 4716, NULL, '3104', '3190', NULL, '1953', 'S', 2101, 'SÃO JOSÉ DO GOIABAL', 'N', '316340', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '746', NULL, '03', 'N', NULL, NULL, NULL, 347);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316350', '3116', 'MG', '3106', '3108', '31036', '31', 'SAO JOSE DO JACURI', NULL, '33', '39707000', '8', '5269', '5269', '11635', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 345.861, '-18,27500', '-42,67000', 642, 'S', 0.6690, NULL, NULL, '31039', 'S', 'N', 4721, NULL, '3190', '3190', NULL, '1953', 'S', 2102, 'SÃO JOSÉ DO JACURI', 'N', '316350', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '747', NULL, '03', 'N', NULL, NULL, NULL, 179);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316360', '3124', 'MG', '3110', '3112', '31061', '31', 'SAO JOSE DO MANTIMENTO', NULL, '33', '36990000', '7', '5271', '5271', '11636', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 54.475, '-20,00500', '-41,74500', 360, 'S', 0.6830, NULL, NULL, '31059', 'S', 'N', 4722, NULL, '3190', '3190', NULL, '1962', 'S', 2103, 'SÃO JOSÉ DO MANTIMENTO', 'N', '316360', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '748', NULL, '03', 'N', NULL, NULL, NULL, 191);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316370', '3111', 'MG', '3101', '3110', '31054', '31', 'SAO LOURENCO', NULL, '35', '37470000', '6', '5273', '5273', '11637', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 57.065, '-22,11600', '-45,05400', 874, 'S', 0.8390, NULL, NULL, '31008', 'N', 'N', 4744, NULL, '3190', '3190', NULL, '1927', 'S', 2104, 'SÃO LOURENÇO', 'N', '316370', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '749', NULL, '03', 'N', NULL, NULL, NULL, 57);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316380', '3108', 'MG', '3110', '3112', '31062', '31', 'SAO MIGUEL DO ANTA', NULL, '31', '36590000', '5', '5275', '5275', '11638', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 152.276, '-20,70700', '-42,71900', 760, 'S', 0.7170, NULL, NULL, '31061', 'N', 'N', 4782, NULL, '3190', '3190', NULL, '1953', 'S', 2105, 'SÃO MIGUEL DO ANTA', 'N', '316380', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '750', NULL, '03', 'N', NULL, NULL, NULL, 117);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316390', '3121', 'MG', '3101', '3110', '31048', '31', 'SAO PEDRO DA UNIAO', NULL, '35', '37855000', '4', '5277', '5277', '11639', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 258.511, '-21,12700', '-46,61500', 977, 'S', 0.7450, NULL, NULL, '31002', 'N', 'N', 4805, NULL, '3190', '3190', NULL, '1943', 'S', 2106, 'SÃO PEDRO DA UNIÃO', 'N', '316390', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '751', NULL, '03', 'N', NULL, NULL, NULL, 302);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316400', '3108', 'MG', '3110', '3112', '31060', '31', 'SAO PEDRO DOS FERROS', NULL, '33', '35360000', '1', '5279', '5279', '11640', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 400.669, '-20,17000', '-42,52400', 363, 'S', 0.7050, NULL, NULL, '31060', 'N', 'N', 4816, NULL, '3190', '3190', NULL, '1943', 'S', 2108, 'SÃO PEDRO DOS FERROS', 'N', '316400', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '753', NULL, '03', 'N', NULL, NULL, NULL, 347);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316410', '3116', 'MG', '3106', '3108', '31036', '31', 'SAO PEDRO DO SUACUI', NULL, '33', '39784000', '0', '5281', '5281', '11641', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 308.771, '-18,36600', '-42,60300', 473, 'S', 0.6650, NULL, NULL, '31039', 'S', 'N', 4812, NULL, '3190', '3190', NULL, '1962', 'S', 2107, 'SÃO PEDRO DO SUAÇUÍ', 'N', '316410', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '752', NULL, '03', 'N', NULL, NULL, NULL, 179);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316420', '3129', 'MG', '3108', '3102', '31006', '31', 'SAO ROMAO', NULL, '38', '39290000', '9', '5283', '5283', '11642', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 2431.658, '-16,36900', '-45,06900', 480, 'S', 0.6490, NULL, NULL, '31049', 'S', 'N', 4822, NULL, '3190', '3190', NULL, '1923', 'S', 2109, 'SÃO ROMÃO', 'N', '316420', 'N', 'S', 'S', NULL, 63, 'N', 'N', 'N', '754', NULL, '03', 'N', NULL, NULL, NULL, 243);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316430', '3122', 'MG', '3101', '3109', '31042', '31', 'SAO ROQUE DE MINAS', NULL, '37', '37928000', '8', '5285', '5285', '11643', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2100.702, '-20,24500', '-46,36600', 818, 'S', 0.7660, NULL, NULL, '31005', 'N', 'N', 4824, NULL, '3190', '3190', NULL, '1938', 'S', 2110, 'SÃO ROQUE DE MINAS', 'N', '316430', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '755', NULL, '03', 'N', NULL, NULL, NULL, 361);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316440', '3110', 'MG', '3101', '3110', '31053', '31', 'SAO SEBASTIAO DA BELA VISTA', NULL, '35', '37567000', '7', '5287', '5287', '11644', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 166.929, '-22,15900', '-45,75400', 842, 'S', 0.7280, NULL, NULL, '31007', 'N', 'N', 4830, NULL, '3190', '3190', NULL, '1962', 'S', 2111, 'SÃO SEBASTIÃO DA BELA VISTA', 'N', '316440', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '756', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316443', '3118', 'MG', '3107', '3112', '31063', '31', 'SAO SEBASTIAO DA VARGEM ALEGRE', NULL, '32', '36793000', '1', '0726', NULL, '11843', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 73.711, '-21,07200', '-42,63600', 718, 'S', 0.6890, NULL, NULL, '31045', 'S', 'N', 4833, NULL, '3190', '3190', NULL, '1997', 'S', 2112, 'SÃO SEBASTIÃO DA VARGEM ALEGRE', 'N', '316443', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '757', NULL, '03', 'N', NULL, NULL, NULL, 130);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316447', '3123', 'MG', '3106', '3108', '31040', '31', 'SAO SEBASTIAO DO ANTA', NULL, '33', '35334000', '2', '0728', NULL, '11844', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 80.181, '-19,49800', '-41,98400', 782, 'S', 0.6540, NULL, NULL, '31034', 'S', 'N', 4836, NULL, '3190', '3190', NULL, '1997', 'S', 2113, 'SÃO SEBASTIÃO DO ANTA', 'N', '316447', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '758', NULL, '03', 'N', NULL, NULL, NULL, 14);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316450', '3116', 'MG', '3106', '3108', '31036', '31', 'SAO SEBASTIAO DO MARANHAO', NULL, '33', '39795000', '6', '5289', '5289', '11645', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 519.302, '-18,08400', '-42,57100', 539, 'S', 0.6080, NULL, NULL, '31039', 'S', 'N', 4838, NULL, '3190', '3190', NULL, '1948', 'S', 2114, 'SÃO SEBASTIÃO DO MARANHÃO', 'N', '316450', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '759', NULL, '03', 'N', NULL, NULL, NULL, 179);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316460', '3115', 'MG', '3105', '3109', '31043', '31', 'SAO SEBASTIAO DO OESTE', NULL, '37', '35506000', '5', '5291', '5291', '11646', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 404.045, '-20,27600', '-45,00500', 780, 'S', 0.7460, NULL, NULL, '31029', 'N', 'N', 4839, NULL, '3190', '3190', NULL, '1962', 'S', 2115, 'SÃO SEBASTIÃO DO OESTE', 'N', '316460', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '760', NULL, '03', 'N', NULL, NULL, NULL, 413);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316470', '3122', 'MG', '3101', '3110', '31048', '31', 'SAO SEBASTIAO DO PARAISO', NULL, '35', '37950000', '4', '5293', '5293', '11647', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 822.295, '-20,91700', '-46,99100', 991, 'S', 0.8120, NULL, NULL, '31009', 'N', 'N', 4840, NULL, '3190', '3190', NULL, '1870', 'S', 2116, 'SÃO SEBASTIÃO DO PARAÍSO', 'N', '316470', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '761', NULL, '02', 'N', NULL, NULL, NULL, 8);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316480', '3109', 'MG', '3103', '3107', '31028', '31', 'SAO SEBASTIAO DO RIO PRETO', NULL, '31', '35815000', '3', '5295', '5295', '11648', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 127.182, '-19,29200', '-43,17400', 487, 'S', 0.7060, NULL, NULL, '31021', 'N', 'N', 4842, NULL, '3190', '3190', NULL, '1962', 'S', 2117, 'SÃO SEBASTIÃO DO RIO PRETO', 'N', '316480', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '762', NULL, '03', 'N', NULL, NULL, NULL, 190);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316490', '3111', 'MG', '3101', '3110', '31054', '31', 'SAO SEBASTIAO DO RIO VERDE', NULL, '35', '37467000', '2', '5297', '5297', '11649', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 91.893, '-22,21800', '-44,97600', 897, 'S', 0.7710, NULL, NULL, '31008', 'N', 'N', 4843, NULL, '3190', '3190', NULL, '1962', 'S', 2118, 'SÃO SEBASTIÃO DO RIO VERDE', 'N', '316490', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '763', NULL, '03', 'N', NULL, NULL, NULL, 57);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316500', '3120', 'MG', '3102', '3111', '31058', '31', 'SAO TIAGO', NULL, '32', '36350000', '8', '5299', '5299', '11650', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 574.017, '-20,91300', '-44,50900', 1103, 'S', 0.7270, NULL, NULL, '31015', 'N', 'N', 4850, NULL, '3190', '3190', NULL, '1948', 'S', 2119, 'SÃO TIAGO', 'N', '316500', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '765', NULL, '03', 'N', NULL, NULL, NULL, 114);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316510', '3122', 'MG', '3101', '3110', '31048', '31', 'SAO TOMAS DE AQUINO', NULL, '35', '37960000', '7', '5301', '5301', '11651', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 277.546, '-20,78400', '-47,09800', 979, 'S', 0.7530, NULL, NULL, '31009', 'N', 'N', 4851, NULL, '3190', '3190', NULL, '1923', 'S', 2120, 'SÃO TOMÁS DE AQUINO', 'N', '316510', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '766', NULL, '03', 'N', NULL, NULL, NULL, 8);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316520', '3111', 'MG', '3101', '3110', '31050', '31', 'SAO THOME DAS LETRAS', NULL, '35', '37418000', '6', '5303', '5303', '11652', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 369.515, '-21,72200', '-44,98500', 1291, 'S', 0.7170, NULL, NULL, '31010', 'N', 'N', 4854, NULL, '3190', '3190', NULL, '1962', 'S', 2121, 'SÃO THOMÉ DAS LETRAS', 'N', '316520', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '764', NULL, '03', 'N', NULL, NULL, NULL, 293);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316530', '3120', 'MG', '3102', '3110', '31055', '31', 'SAO VICENTE DE MINAS', NULL, '35', '37370000', '5', '5305', '5305', '11653', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 392.067, '-21,71300', '-44,44400', 1057, 'S', 0.7690, NULL, NULL, '31015', 'N', 'N', 4862, NULL, '3190', '3190', NULL, '1938', 'S', 2122, 'SÃO VICENTE DE MINAS', 'N', '316530', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '767', NULL, '03', 'N', NULL, NULL, NULL, 114);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316540', '3110', 'MG', '3101', '3110', '31052', '31', 'SAPUCAI-MIRIM', NULL, '35', '37690000', '4', '5307', '5307', '11654', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 284.796, '-22,74800', '-45,74300', 885, 'S', 0.7570, NULL, NULL, '31003', 'N', 'N', 4871, NULL, '3190', '3190', NULL, '1938', 'S', 2123, 'SAPUCAÍ-MIRIM', 'N', '316540', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '768', NULL, '03', 'N', NULL, NULL, NULL, 16);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316553', '3101', 'MG', '3103', '3107', '31030', '31', 'SARZEDO', NULL, '31', '32450000', '7', '0730', NULL, '11764', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 61.892, '-20,03500', '-44,14500', 796, 'S', 0.7480, NULL, NULL, '31018', 'N', 'N', 4881, NULL, '3101', '3101', NULL, '1997', 'S', 2125, 'SARZEDO', 'N', '316553', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '770', NULL, '01', 'N', NULL, NULL, NULL, 188);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316555', '3117', 'MG', '3111', '3104', '31015', '31', 'SETUBINHA', NULL, '33', '39688000', '2', '0732', NULL, '11845', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 535.738, '-17,60000', '-42,15900', 731, 'S', 0.5680, NULL, NULL, '31069', 'S', 'N', 4979, NULL, '3190', '3190', NULL, '1997', 'S', 2146, 'SETUBINHA', 'N', '316555', 'N', 'S', 'S', NULL, 99, 'N', 'N', 'N', '791', NULL, '03', 'N', NULL, NULL, NULL, 292);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316556', '3108', 'MG', '3110', '3112', '31060', '31', 'SEM-PEIXE', NULL, '31', '35441000', '0', '0734', NULL, '11765', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 176.439, '-20,10900', '-42,83900', 301, 'S', 0.6770, NULL, NULL, '31060', 'S', 'N', 4901, NULL, '3190', '3190', NULL, '1997', 'S', 2126, 'SEM-PEIXE', 'N', '316556', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '771', NULL, '03', 'N', NULL, NULL, NULL, 347);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316557', '3110', 'MG', '3101', '3110', '31052', '31', 'SENADOR AMARAL', NULL, '35', '37615000', '8', '2689', '2689', '11766', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 151.135, '-22,58700', '-46,17700', 1505, 'S', 0.7220, NULL, NULL, '31007', 'N', 'N', 4904, NULL, '3190', '3190', NULL, '1993', 'S', 2127, 'SENADOR AMARAL', 'N', '316557', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '772', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316560', '3105', 'MG', '3107', '3112', '31065', '31', 'SENADOR CORTES', NULL, '32', '36650000', '2', '5311', '5311', '11656', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 98.430, '-21,80100', '-42,94600', 585, 'S', 0.7310, NULL, NULL, '31047', 'N', 'N', 4906, NULL, '3190', '3190', NULL, '1962', 'S', 2128, 'SENADOR CORTES', 'N', '316560', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '773', NULL, '03', 'N', NULL, NULL, NULL, 115);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316570', '3118', 'MG', '3107', '3112', '31064', '31', 'SENADOR FIRMINO', NULL, '32', '36540000', '1', '5313', '5313', '11657', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 166.152, '-20,91200', '-43,09700', 660, 'S', 0.7300, NULL, NULL, '31048', 'N', 'N', 4908, NULL, '3190', '3190', NULL, '1938', 'S', 2129, 'SENADOR FIRMINO', 'N', '316570', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '774', NULL, '03', 'N', NULL, NULL, NULL, 181);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316580', '3110', 'MG', '3101', '3110', '31052', '31', 'SENADOR JOSE BENTO', NULL, '35', '37558000', '0', '5315', '5315', '11658', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 94.589, '-22,16400', '-46,17900', 885, 'S', 0.7740, NULL, NULL, '31007', 'N', 'N', 4911, NULL, '3190', '3190', NULL, '1962', 'S', 2130, 'SENADOR JOSÉ BENTO', 'N', '316580', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '775', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316590', '3104', 'MG', '3104', '3103', '31010', '31', 'SENADOR MODESTINO GONCALVES', NULL, '38', '39190000', '9', '5317', '5317', '11659', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 948.588, '-17,94700', '-43,22500', 743, 'S', 0.6260, NULL, NULL, '31026', 'S', 'N', 4914, NULL, '3190', '3190', NULL, '1962', 'S', 2131, 'SENADOR MODESTINO GONÇALVES', 'N', '316590', 'N', 'S', 'S', NULL, 5, 'N', 'N', 'N', '776', NULL, '03', 'N', NULL, NULL, NULL, 126);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316600', '3103', 'MG', '3102', '3112', '31062', '31', 'SENHORA DE OLIVEIRA', NULL, '31', '36470000', '6', '5319', '5319', '11660', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 169.804, '-20,79400', '-43,34400', 715, 'S', 0.6540, NULL, NULL, '31014', 'S', 'N', 4921, NULL, '3190', '3190', NULL, '1953', 'S', 2132, 'SENHORA DE OLIVEIRA', 'N', '316600', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '777', NULL, '03', 'N', NULL, NULL, NULL, 187);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316610', '3109', 'MG', '3103', '3108', '31035', '31', 'SENHORA DO PORTO', NULL, '33', '39745000', '5', '5321', '5321', '11661', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 382.256, '-18,89200', '-43,08400', 591, 'S', 0.6530, NULL, NULL, '31020', 'S', 'N', 4922, NULL, '3190', '3190', NULL, '1953', 'S', 2133, 'SENHORA DO PORTO', 'N', '316610', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '778', NULL, '03', 'N', NULL, NULL, NULL, 245);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316620', '3103', 'MG', '3102', '3111', '31059', '31', 'SENHORA DOS REMEDIOS', NULL, '32', '36275000', '4', '5323', '5323', '11662', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 237.107, '-21,02800', '-43,58300', 810, 'S', 0.6850, NULL, NULL, '31013', 'S', 'N', 4923, NULL, '3190', '3190', NULL, '1953', 'S', 2134, 'SENHORA DOS REMÉDIOS', 'N', '316620', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '779', NULL, '03', 'N', NULL, NULL, NULL, 241);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316630', '3108', 'MG', '3110', '3112', '31060', '31', 'SERICITA', NULL, '31', '35368000', '3', '5325', '5325', '11663', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 166.674, '-20,47400', '-42,48200', 772, 'S', 0.6620, NULL, NULL, '31060', 'S', 'N', 4927, NULL, '3190', '3190', NULL, '1962', 'S', 2135, 'SERICITA', 'N', '316630', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '780', NULL, '03', 'N', NULL, NULL, NULL, 347);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316640', '3111', 'MG', '3101', '3110', '31055', '31', 'SERITINGA', NULL, '35', '37454000', '2', '5327', '5327', '11664', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 114.451, '-21,90900', '-44,51900', 979, 'S', 0.7350, NULL, NULL, '31008', 'N', 'N', 4931, NULL, '3190', '3190', NULL, '1962', 'S', 2136, 'SERITINGA', 'N', '316640', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '781', NULL, '03', 'N', NULL, NULL, NULL, 57);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316650', '3104', 'MG', '3103', '3107', '31028', '31', 'SERRA AZUL DE MINAS', NULL, '38', '39165000', '1', '5329', '5329', '11665', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 222.706, '-18,36200', '-43,17000', 700, 'S', 0.6530, NULL, NULL, '31020', 'S', 'N', 4936, NULL, '3190', '3190', NULL, '1962', 'S', 2137, 'SERRA AZUL DE MINAS', 'N', '316650', 'N', 'N', 'S', NULL, 5, 'N', 'N', 'N', '782', NULL, '03', 'N', NULL, NULL, NULL, 245);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316660', '3115', 'MG', '3105', '3106', '31026', '31', 'SERRA DA SAUDADE', NULL, '37', '35617000', '0', '5331', '5331', '11666', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 335.581, '-19,43800', '-45,79600', 738, 'S', 0.7420, NULL, NULL, '31028', 'N', 'N', 4940, NULL, '3190', '3190', NULL, '1962', 'S', 2138, 'SERRA DA SAUDADE', 'N', '316660', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '783', NULL, '03', 'N', NULL, NULL, NULL, 411);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316670', '3117', 'MG', '3111', '3104', '31016', '31', 'SERRA DOS AIMORES', NULL, '33', '39868000', '9', '5333', '5333', '11667', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 215.150, '-17,78300', '-40,24800', 209, 'S', 0.6550, NULL, NULL, '31066', 'S', 'N', 4946, NULL, '3190', '3190', NULL, '1962', 'S', 2140, 'SERRA DOS AIMORÉS', 'N', '316670', 'N', 'S', 'S', NULL, 99, 'S', 'N', 'N', '785', NULL, '03', 'N', NULL, NULL, NULL, 304);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316680', '3107', 'MG', '3109', '3105', '31019', '31', 'SERRA DO SALITRE', NULL, '34', '38760000', '8', '5335', '5335', '11668', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1297.748, '-19,11100', '-46,69000', 1203, 'S', 0.7450, NULL, NULL, '31057', 'N', 'N', 4945, NULL, '3190', '3190', NULL, '1953', 'S', 2139, 'SERRA DO SALITRE', 'N', '316680', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '784', NULL, '03', 'N', NULL, NULL, NULL, 194);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316690', '3121', 'MG', '3101', '3110', '31049', '31', 'SERRANIA', NULL, '35', '37136000', '7', '5337', '5337', '11669', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 211.477, '-21,54800', '-46,04000', 875, 'S', 0.7450, NULL, NULL, '31001', 'N', 'N', 4955, NULL, '3190', '3190', NULL, '1938', 'S', 2141, 'SERRANIA', 'N', '316690', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '786', NULL, '03', 'N', NULL, NULL, NULL, 300);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316695', '3106', 'MG', '3108', '3102', '31004', '31', 'SERRANOPOLIS DE MINAS', NULL, '38', '39518000', '6', '0736', NULL, '11846', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 553.103, '-15,82900', '-42,87100', 621, 'S', 0.6550, NULL, NULL, '31052', 'S', 'N', 4958, NULL, '3190', '3190', NULL, '1997', 'S', 2142, 'SERRANÓPOLIS DE MINAS', 'N', '316695', 'N', 'S', 'S', NULL, 79, 'N', 'N', 'N', '787', NULL, '03', 'N', NULL, NULL, NULL, 128);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316700', '3111', 'MG', '3101', '3110', '31055', '31', 'SERRANOS', NULL, '35', '37452000', '4', '5339', '5339', '11670', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 212.493, '-21,89000', '-44,51000', 1031, 'S', 0.6970, NULL, NULL, '31008', 'S', 'N', 4960, NULL, '3190', '3190', NULL, '1953', 'S', 2143, 'SERRANOS', 'N', '316700', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '788', NULL, '03', 'N', NULL, NULL, NULL, 57);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316710', '3104', 'MG', '3104', '3107', '31028', '31', 'SERRO', NULL, '38', '39150000', '3', '5341', '5341', '11671', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 1217.645, '-18,60500', '-43,37900', 781, 'S', 0.6580, NULL, NULL, '31026', 'S', 'N', 4966, NULL, '3190', '3190', NULL, '1714', 'S', 2144, 'SERRO', 'N', '316710', 'N', 'S', 'S', NULL, 5, 'N', 'N', 'N', '789', NULL, '03', 'N', NULL, NULL, NULL, 126);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316720', '3114', 'MG', '3103', '3107', '31027', '31', 'SETE LAGOAS', NULL, '31', '35701970', '2', '5343', '5343', '11672', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 537.476, '-19,46600', '-44,24700', 761, 'S', 0.7910, NULL, NULL, '31024', 'N', 'N', 4977, NULL, '3102', '3190', NULL, '1867', 'S', 2145, 'SETE LAGOAS', 'N', '316720', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '790', NULL, '01', 'N', NULL, NULL, NULL, 58);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316730', '3118', 'MG', '3107', '3112', '31064', '31', 'SILVEIRANIA', NULL, '32', '36185000', '1', '5345', '5345', '11673', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 157.484, '-21,15900', '-43,21500', 512, 'S', 0.7210, NULL, NULL, '31048', 'N', 'N', 4990, NULL, '3190', '3190', NULL, '1962', 'S', 2147, 'SILVEIRÂNIA', 'N', '316730', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '792', NULL, '03', 'N', NULL, NULL, NULL, 181);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316740', '3110', 'MG', '3101', '3110', '31053', '31', 'SILVIANOPOLIS', NULL, '35', '37560000', '0', '5347', '5347', '11674', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 312.043, '-22,02900', '-45,83500', 897, 'S', 0.7590, NULL, NULL, '31007', 'N', 'N', 4993, NULL, '3190', '3190', NULL, '1923', 'S', 2148, 'SILVIANÓPOLIS', 'N', '316740', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '793', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316750', '3105', 'MG', '3107', '3112', '31065', '31', 'SIMAO PEREIRA', NULL, '32', '36123000', '9', '5349', '5349', '11675', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 134.676, '-21,96400', '-43,31200', 472, 'S', 0.7600, NULL, NULL, '31043', 'N', 'N', 4995, NULL, '3190', '3190', NULL, '1962', 'S', 2149, 'SIMÃO PEREIRA', 'N', '316750', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '794', NULL, '03', 'N', NULL, NULL, NULL, 360);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316760', '3124', 'MG', '3110', '3112', '31061', '31', 'SIMONESIA', NULL, '33', '36930000', '8', '5351', '5351', '11676', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 487.850, '-20,12400', '-42,00100', 591, 'S', 0.6790, NULL, NULL, '31059', 'S', 'N', 4999, NULL, '3190', '3190', NULL, '1943', 'S', 2150, 'SIMONÉSIA', 'N', '316760', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '795', NULL, '03', 'N', NULL, NULL, NULL, 191);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316770', '3116', 'MG', '3106', '3108', '31037', '31', 'SOBRALIA', NULL, '33', '35145000', '7', '5353', '5353', '11677', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 206.970, '-19,23500', '-42,09800', 342, 'S', 0.6850, NULL, NULL, '31036', 'S', 'N', 5016, NULL, '3104', '3190', NULL, '1962', 'S', 2151, 'SOBRÁLIA', 'N', '316770', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '796', NULL, '03', 'N', NULL, NULL, NULL, 189);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316780', '3111', 'MG', '3101', '3110', '31054', '31', 'SOLEDADE DE MINAS', NULL, '35', '37478000', '6', '5355', '5355', '11678', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 196.859, '-22,06000', '-45,04500', 881, 'S', 0.7690, NULL, NULL, '31008', 'N', 'N', 5022, NULL, '3190', '3190', NULL, '1938', 'S', 2152, 'SOLEDADE DE MINAS', 'N', '316780', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '797', NULL, '03', 'N', NULL, NULL, NULL, 57);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316790', '3118', 'MG', '3107', '3112', '31064', '31', 'TABULEIRO', NULL, '32', '36165000', '5', '5357', '5357', '11679', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 211.382, '-21,35900', '-43,24800', 459, 'S', 0.7240, NULL, NULL, '31048', 'N', 'N', 5055, NULL, '3190', '3190', NULL, '1953', 'S', 2153, 'TABULEIRO', 'N', '316790', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '798', NULL, '03', 'N', NULL, NULL, NULL, 181);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316800', '3106', 'MG', '3108', '3102', '31005', '31', 'TAIOBEIRAS', NULL, '38', '39550000', '2', '5359', '5359', '11680', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 1194.230, '-15,80800', '-42,23300', 821, 'S', 0.6990, NULL, NULL, '31056', 'S', 'N', 5068, NULL, '3190', '3190', NULL, '1953', 'S', 2154, 'TAIOBEIRAS', 'N', '316800', 'N', 'S', 'S', NULL, 7, 'N', 'N', 'N', '799', NULL, '03', 'N', NULL, NULL, NULL, 348);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316805', '3124', 'MG', '3110', '3108', '31041', '31', 'TAPARUBA', NULL, '33', '36953000', '1', '0738', NULL, '11847', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 190.801, '-19,75900', '-41,61600', 233, 'S', 0.7000, NULL, NULL, '31059', 'S', 'N', 5089, NULL, '3190', '3190', NULL, '1997', 'S', 2155, 'TAPARUBA', 'N', '316805', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '800', NULL, '03', 'N', NULL, NULL, NULL, 191);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316810', '3113', 'MG', '3112', '3105', '31023', '31', 'TAPIRA', NULL, '34', '38185000', '1', '5361', '5361', '11681', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1180.229, '-19,92200', '-46,82300', 1091, 'S', 0.7800, NULL, NULL, '31070', 'N', 'N', 5098, NULL, '3190', '3190', NULL, '1962', 'S', 2156, 'TAPIRA', 'N', '316810', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '801', NULL, '03', 'N', NULL, NULL, NULL, 240);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316820', '3115', 'MG', '3105', '3109', '31042', '31', 'TAPIRAI', NULL, '37', '38980000', '0', '5363', '5363', '11682', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 412.442, '-19,88800', '-46,02000', 673, 'S', 0.7390, NULL, NULL, '31030', 'N', 'N', 5099, NULL, '3190', '3190', NULL, '1953', 'S', 2157, 'TAPIRAÍ', 'N', '316820', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '802', NULL, '03', 'N', NULL, NULL, NULL, 15);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316830', '3101', 'MG', '3103', '3107', '31031', '31', 'TAQUARACU DE MINAS', NULL, '31', '33980000', '9', '5365', '5365', '11683', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 329.363, '-19,67000', '-43,68700', 742, 'S', 0.7350, NULL, NULL, '31016', 'N', 'N', 5105, NULL, '3101', '3190', NULL, '1962', 'S', 2158, 'TAQUARAÇU DE MINAS', 'N', '316830', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '803', NULL, '01', 'N', NULL, NULL, NULL, 410);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316840', '3116', 'MG', '3106', '3108', '31040', '31', 'TARUMIRIM', NULL, '33', '35140000', '8', '5367', '5367', '11684', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 730.270, '-19,28100', '-42,00700', 284, 'S', 0.6930, NULL, NULL, '31036', 'S', 'N', 5121, NULL, '3190', '3190', NULL, '1938', 'S', 2159, 'TARUMIRIM', 'N', '316840', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '804', NULL, '03', 'N', NULL, NULL, NULL, 189);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316850', '3108', 'MG', '3110', '3112', '31062', '31', 'TEIXEIRAS', NULL, '31', '36580000', '7', '5369', '5369', '11685', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 166.519, '-20,65100', '-42,85700', 648, 'S', 0.7120, NULL, NULL, '31061', 'N', 'N', 5132, NULL, '3190', '3190', NULL, '1938', 'S', 2160, 'TEIXEIRAS', 'N', '316850', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '805', NULL, '03', 'N', NULL, NULL, NULL, 117);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316860', '3117', 'MG', '3111', '3104', '31015', '31', 'TEOFILO OTONI', NULL, '33', '39800000', '6', '5371', '5371', '11686', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'S', 'N', NULL, 'N', 3242.818, '-17,85800', '-41,50500', 334, 'S', 0.7420, NULL, NULL, '31069', 'N', 'N', 5145, NULL, '3190', '3190', NULL, '1878', 'S', 2161, 'TEÓFILO OTONI', 'N', '316860', 'N', 'S', 'S', NULL, 99, 'N', 'N', 'N', '806', NULL, '01', 'N', NULL, NULL, NULL, 292);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316880', '3120', 'MG', '3102', '3111', '31058', '31', 'TIRADENTES', NULL, '32', '36325000', '4', '5375', '5375', '11688', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 83.209, '-21,11000', '-44,17800', 927, 'S', 0.7730, NULL, NULL, '31015', 'N', 'N', 5184, NULL, '3190', '3190', NULL, '1849', 'S', 2163, 'TIRADENTES', 'N', '316880', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '808', NULL, '03', 'N', NULL, NULL, NULL, 114);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316890', '3107', 'MG', '3109', '3105', '31020', '31', 'TIROS', NULL, '34', '38880000', '3', '5377', '5377', '11689', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2093.160, '-19,00400', '-45,96400', 1037, 'S', 0.7550, NULL, NULL, '31057', 'N', 'N', 5186, NULL, '3190', '3190', NULL, '1923', 'S', 2164, 'TIROS', 'N', '316890', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '809', NULL, '03', 'N', NULL, NULL, NULL, 194);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316900', '3118', 'MG', '3107', '3112', '31064', '31', 'TOCANTINS', NULL, '32', '36512000', '0', '5379', '5379', '11690', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 173.994, '-21,17500', '-43,01800', 363, 'S', 0.7620, NULL, NULL, '31048', 'N', 'N', 5190, NULL, '3190', '3190', NULL, '1948', 'S', 2165, 'TOCANTINS', 'N', '316900', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '810', NULL, '03', 'N', NULL, NULL, NULL, 181);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316905', '3110', 'MG', '3101', '3110', '31052', '31', 'TOCOS DO MOJI', NULL, '35', '37563000', '9', '0740', NULL, '11848', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 114.945, '-22,37100', '-46,09600', 1059, 'S', 0.7380, NULL, NULL, '31007', 'N', 'N', 5191, NULL, '3190', '3190', NULL, '1997', 'S', 2166, 'TOCOS DO MOJI', 'N', '316905', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '811', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316910', '3110', 'MG', '3101', '3110', '31052', '31', 'TOLEDO', NULL, '35', '37630000', '9', '5381', '5381', '11691', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 136.133, '-22,74300', '-46,37200', 1128, 'S', 0.7230, NULL, NULL, '31007', 'N', 'N', 5193, NULL, '3190', '3190', NULL, '1953', 'S', 2167, 'TOLEDO', 'N', '316910', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '812', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316920', '3124', 'MG', '3107', '3112', '31063', '31', 'TOMBOS', NULL, '32', '36844000', '8', '5383', '5383', '11692', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 283.483, '-20,90500', '-42,02300', 273, 'S', 0.7540, NULL, NULL, '31042', 'N', 'N', 5196, NULL, '3190', '3190', NULL, '1923', 'S', 2168, 'TOMBOS', 'N', '316920', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '813', NULL, '03', 'N', NULL, NULL, NULL, 412);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316930', '3111', 'MG', '3101', '3110', '31050', '31', 'TRES CORACOES', NULL, '35', '37410000', '7', '5385', '5385', '11693', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 825.924, '-21,69700', '-45,25300', 864, 'S', 0.7800, NULL, NULL, '31010', 'N', 'N', 5221, NULL, '3190', '3190', NULL, '1884', 'S', 2169, 'TRÊS CORAÇÕES', 'N', '316930', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '814', NULL, '02', 'N', NULL, NULL, NULL, 293);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316935', '3114', 'MG', '3103', '3106', '31024', '31', 'TRES MARIAS', NULL, '38', '39205000', '6', '4115', '4115', '11058', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2675.153, '-18,20600', '-45,24200', 538, 'S', 0.7860, NULL, NULL, '31019', 'N', 'N', 5227, NULL, '3190', '3190', NULL, '1962', 'S', 2170, 'TRÊS MARIAS', 'N', '316935', 'N', 'N', 'S', NULL, 48, 'N', 'N', 'N', '815', NULL, '03', 'N', NULL, NULL, NULL, 65);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316940', '3111', 'MG', '3101', '3110', '31050', '31', 'TRES PONTAS', NULL, '35', '37190000', '6', '5387', '5387', '11694', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 689.421, '-21,36700', '-45,51300', 885, 'S', 0.7730, NULL, NULL, '31011', 'N', 'N', 5230, NULL, '3190', '3190', NULL, '1841', 'S', 2171, 'TRÊS PONTAS', 'N', '316940', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '816', NULL, '02', 'N', NULL, NULL, NULL, 294);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316950', '3116', 'MG', '3106', '3108', '31037', '31', 'TUMIRITINGA', NULL, '33', '35125000', '5', '5389', '5389', '11695', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 496.783, '-18,97900', '-41,64500', 138, 'S', 0.6830, NULL, NULL, '31036', 'S', 'N', 5253, NULL, '3190', '3190', NULL, '1948', 'S', 2172, 'TUMIRITINGA', 'N', '316950', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '817', NULL, '03', 'N', NULL, NULL, NULL, 189);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316960', '3112', 'MG', '3113', '3105', '31018', '31', 'TUPACIGUARA', NULL, '34', '38430000', '4', '5391', '5391', '11696', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1826.028, '-18,59300', '-48,70500', 865, 'S', 0.7800, NULL, NULL, '31075', 'N', 'N', 5260, NULL, '3190', '3190', NULL, '1911', 'S', 2173, 'TUPACIGUARA', 'N', '316960', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '818', NULL, '03', 'N', NULL, NULL, NULL, 116);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316970', '3104', 'MG', '3104', '3103', '31011', '31', 'TURMALINA', NULL, '38', '39660000', '3', '5393', '5393', '11697', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 1153.086, '-17,28600', '-42,73000', 718, 'S', 0.7050, NULL, NULL, '31027', 'N', 'N', 5275, NULL, '3190', '3190', NULL, '1948', 'S', 2174, 'TURMALINA', 'N', '316970', 'N', 'S', 'S', NULL, 5, 'S', 'N', 'N', '819', NULL, '03', 'N', NULL, NULL, NULL, 67);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316980', '3110', 'MG', '3101', '3110', '31053', '31', 'TURVOLANDIA', NULL, '35', '37496000', '2', '5395', '5395', '11698', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 221.284, '-21,87600', '-45,78700', 840, 'S', 0.7580, NULL, NULL, '31007', 'N', 'N', 5282, NULL, '3190', '3190', NULL, '1962', 'S', 2175, 'TURVOLÂNDIA', 'N', '316980', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '820', NULL, '03', 'N', NULL, NULL, NULL, 234);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316990', '3118', 'MG', '3107', '3112', '31064', '31', 'UBA', NULL, '32', '36500000', '1', '5397', '5397', '11699', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 407.699, '-21,12000', '-42,94300', 338, 'S', 0.7730, NULL, NULL, '31048', 'N', 'N', 5286, NULL, '3190', '3190', NULL, '1871', 'S', 2176, 'UBÁ', 'N', '316990', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '821', NULL, '02', 'N', NULL, NULL, NULL, 181);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317000', '3129', 'MG', '3108', '3102', '31007', '31', 'UBAI', NULL, '38', '39320000', '8', '5399', '5399', '11700', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 820.872, '-16,28500', '-44,77800', 589, 'S', 0.6510, NULL, NULL, '31049', 'S', 'N', 5287, NULL, '3190', '3190', NULL, '1962', 'S', 2177, 'UBAÍ', 'N', '317000', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '822', NULL, '03', 'N', NULL, NULL, NULL, 243);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317005', '3123', 'MG', '3106', '3108', '31040', '31', 'UBAPORANGA', NULL, '33', '35338000', '7', '2671', '2671', '11767', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 190.886, '-19,63500', '-42,10600', 505, 'S', 0.6980, NULL, NULL, '31034', 'S', 'N', 5291, NULL, '3190', '3190', NULL, '1993', 'S', 2178, 'UBAPORANGA', 'N', '317005', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '823', NULL, '03', 'N', NULL, NULL, NULL, 14);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317010', '3113', 'MG', '3112', '3105', '31022', '31', 'UBERABA', NULL, '34', '38001970', '7', '5401', '5401', '11701', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4512.135, '-19,74800', '-47,93200', 801, 'S', 0.8340, NULL, NULL, '31072', 'N', 'N', 5295, NULL, '3190', '3190', NULL, '1836', 'S', 2179, 'UBERABA', 'N', '317010', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '824', NULL, '01', 'N', NULL, NULL, NULL, 349);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317020', '3112', 'MG', '3113', '3105', '31018', '31', 'UBERLANDIA', NULL, '34', '38400970', '6', '5403', '5403', '11702', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4115.822, '-18,91900', '-48,27700', 863, 'S', 0.8300, NULL, NULL, '31075', 'N', 'N', 5296, NULL, '3190', '3190', NULL, '1888', 'S', 2180, 'UBERLÂNDIA', 'N', '317020', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '825', NULL, '01', 'N', NULL, NULL, NULL, 116);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317030', '3117', 'MG', '3111', '3104', '31016', '31', 'UMBURATIBA', NULL, '33', '39878000', '5', '5405', '5405', '11703', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 404.892, '-17,25600', '-40,57300', 238, 'S', 0.6180, NULL, NULL, '31062', 'S', 'N', 5310, NULL, '3190', '3190', NULL, '1962', 'S', 2181, 'UMBURATIBA', 'N', '317030', 'N', 'S', 'S', NULL, 99, 'N', 'N', 'N', '826', NULL, '03', 'N', NULL, NULL, NULL, 62);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317040', '3126', 'MG', '3109', '3101', '31001', '31', 'UNAI', NULL, '38', '38610000', '4', '5407', '5407', '11704', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 8463.579, '-16,35800', '-46,90600', 575, 'S', 0.8120, NULL, NULL, '31058', 'N', 'N', 5315, NULL, '5301', '5301', NULL, '1943', 'S', 2182, 'UNAÍ', 'S', '317040', 'N', 'N', 'S', NULL, 38, 'N', 'N', 'N', '827', NULL, '01', 'N', NULL, NULL, NULL, 295);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317043', '3113', 'MG', '3112', '3105', '31021', '31', 'UNIAO DE MINAS', NULL, '34', '38288000', '8', '0742', NULL, '11849', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1150.596, '-19,53000', '-50,33600', 521, 'S', 0.7160, NULL, NULL, '31071', 'N', 'N', 5319, NULL, '3190', '3190', NULL, '1997', 'S', 2183, 'UNIÃO DE MINAS', 'N', '317043', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '828', NULL, '03', 'N', NULL, NULL, NULL, 244);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317047', '3126', 'MG', '3109', '3101', '31001', '31', 'URUANA DE MINAS', NULL, '38', '38630000', '9', '0744', NULL, '11850', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 589.221, '-16,06400', '-46,25400', 530, 'S', 0.6980, NULL, NULL, '31058', 'S', 'N', 5334, NULL, '3190', '3190', NULL, '1997', 'S', 2184, 'URUANA DE MINAS', 'N', '317047', 'N', 'N', 'S', NULL, 63, 'N', 'N', 'N', '829', NULL, '03', 'N', NULL, NULL, NULL, 295);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317050', '3108', 'MG', '3110', '3112', '31060', '31', 'URUCANIA', NULL, '31', '35380000', '3', '5409', '5409', '11705', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 139.182, '-20,35100', '-42,73900', 437, 'S', 0.6930, NULL, NULL, '31060', 'S', 'N', 5338, NULL, '3190', '3190', NULL, '1962', 'S', 2185, 'URUCÂNIA', 'N', '317050', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '830', NULL, '03', 'N', NULL, NULL, NULL, 347);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317052', '3129', 'MG', '3108', '3102', '31003', '31', 'URUCUIA', NULL, '38', '39315000', '9', '2699', '2699', '11768', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 2072.340, '-16,13300', '-45,74200', 498, 'S', 0.6750, NULL, NULL, '31049', 'S', 'N', 5342, NULL, '3190', '3190', NULL, '1993', 'S', 2186, 'URUCUIA', 'N', '317052', 'N', 'S', 'S', NULL, 63, 'N', 'N', 'N', '831', NULL, '03', 'N', NULL, NULL, NULL, 243);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317057', '3123', 'MG', '3106', '3108', '31040', '31', 'VARGEM ALEGRE', NULL, '33', '35199000', '8', '0746', NULL, '11769', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 116.614, '-19,60800', '-42,29800', 250, 'S', 0.6980, NULL, NULL, '31034', 'S', 'N', 5370, NULL, '3104', '3190', NULL, '1997', 'S', 2187, 'VARGEM ALEGRE', 'N', '317057', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '832', NULL, '03', 'N', NULL, NULL, NULL, 14);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317060', '3122', 'MG', '3101', '3109', '31042', '31', 'VARGEM BONITA', NULL, '37', '37922000', '2', '5411', '5411', '11706', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 409.116, '-20,32700', '-46,36600', 768, 'S', 0.7600, NULL, NULL, '31005', 'N', 'N', 5373, NULL, '3190', '3190', NULL, '1953', 'S', 2188, 'VARGEM BONITA', 'N', '317060', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '833', NULL, '03', 'N', NULL, NULL, NULL, 361);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317065', '3106', 'MG', '3108', '3102', '31005', '31', 'VARGEM GRANDE DO RIO PARDO', NULL, '38', '39535000', '1', '0748', NULL, '11851', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 494.089, '-15,40300', '-42,30800', 800, 'S', 0.5980, NULL, NULL, '31056', 'S', 'N', 5375, NULL, '3190', '3190', NULL, '1997', 'S', 2189, 'VARGEM GRANDE DO RIO PARDO', 'N', '317065', 'N', 'S', 'S', NULL, 7, 'N', 'N', 'N', '834', NULL, '03', 'N', NULL, NULL, NULL, 348);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317070', '3111', 'MG', '3101', '3110', '31050', '31', 'VARGINHA', NULL, '35', '37002970', '1', '5413', '5413', '11707', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 395.647, '-21,55100', '-45,43000', 916, 'S', 0.8240, NULL, NULL, '31012', 'N', 'N', 5378, NULL, '3190', '3190', NULL, '1881', 'S', 2190, 'VARGINHA', 'N', '317070', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '835', NULL, '01', 'N', NULL, NULL, NULL, 59);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317075', '3107', 'MG', '3109', '3101', '31002', '31', 'VARJAO DE MINAS', NULL, '38', '38794000', '0', '0750', NULL, '11852', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 652.789, '-18,37800', '-46,03200', 900, 'S', 0.7360, NULL, NULL, '31057', 'N', 'N', 5380, NULL, '3190', '3190', NULL, '1997', 'S', 2191, 'VARJÃO DE MINAS', 'N', '317075', 'N', 'N', 'S', NULL, 63, 'N', 'N', 'N', '836', NULL, '03', 'N', NULL, NULL, NULL, 194);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317080', '3128', 'MG', '3108', '3102', '31006', '31', 'VARZEA DA PALMA', NULL, '38', '39260000', '0', '5415', '5415', '11708', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 2195.653, '-17,59800', '-44,73100', 515, 'S', 0.7260, NULL, NULL, '31055', 'N', 'N', 5387, NULL, '3190', '3190', NULL, '1953', 'S', 2192, 'VÁRZEA DA PALMA', 'N', '317080', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '837', NULL, '03', 'N', NULL, NULL, NULL, 233);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317090', '3129', 'MG', '3108', '3102', '31007', '31', 'VARZELANDIA', NULL, '38', '39450000', '9', '5417', '5417', '11709', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 803.909, '-15,70100', '-44,02800', 483, 'S', 0.6310, NULL, NULL, '31049', 'S', 'N', 5395, NULL, '3190', '3190', NULL, '1962', 'S', 2193, 'VARZELÂNDIA', 'N', '317090', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '838', NULL, '03', 'N', NULL, NULL, NULL, 243);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317100', '3107', 'MG', '3109', '3101', '31002', '31', 'VAZANTE', NULL, '34', '38780000', '6', '5419', '5419', '11710', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1903.072, '-17,98700', '-46,90800', 680, 'S', 0.7570, NULL, NULL, '31057', 'N', 'N', 5397, NULL, '3190', '3190', NULL, '1953', 'S', 2194, 'VAZANTE', 'N', '317100', 'N', 'N', 'S', NULL, 63, 'N', 'N', 'N', '839', NULL, '03', 'N', NULL, NULL, NULL, 194);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317103', '3106', 'MG', '3108', '3102', '31007', '31', 'VERDELANDIA', NULL, '38', '39458000', '0', '0752', '0752', '11853', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 1451.856, '-15,58900', '-43,60300', 480, 'S', 0.6020, NULL, NULL, '31052', 'S', 'N', 5412, NULL, '3190', '3190', NULL, '1997', 'S', 2195, 'VERDELÂNDIA', 'N', '317103', 'N', 'S', 'S', NULL, 79, 'S', 'N', 'N', '840', NULL, '03', 'N', NULL, NULL, NULL, 128);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317107', '3104', 'MG', '3104', '3103', '31011', '31', 'VEREDINHA', NULL, '38', '39663000', '1', '0754', NULL, '11854', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'S', 'N', 'N', 'N', NULL, 'N', 635.262, '-17,39900', '-42,73600', 832, 'S', 0.6690, NULL, NULL, '31027', 'S', 'N', 5415, NULL, '3190', '3190', NULL, '1997', 'S', 2196, 'VEREDINHA', 'N', '317107', 'N', 'S', 'S', NULL, 5, 'N', 'N', 'N', '841', NULL, '03', 'N', NULL, NULL, NULL, 67);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317110', '3113', 'MG', '3112', '3105', '31022', '31', 'VERISSIMO', NULL, '34', '38150000', '5', '5423', '5423', '11711', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1028.577, '-19,66300', '-48,30800', 674, 'S', 0.7760, NULL, NULL, '31072', 'N', 'N', 5416, NULL, '3190', '3190', NULL, '1938', 'S', 2197, 'VERÍSSIMO', 'N', '317110', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '842', NULL, '03', 'N', NULL, NULL, NULL, 349);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317115', '3123', 'MG', '3106', '3112', '31060', '31', 'VERMELHO NOVO', NULL, '33', '35359000', '4', '0756', NULL, '11855', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 113.941, '-20,03600', '-42,26700', 640, 'S', 0.6890, NULL, NULL, '31034', 'S', 'N', 5417, NULL, '3190', '3190', NULL, '1997', 'S', 2198, 'VERMELHO NOVO', 'N', '317115', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '843', NULL, '03', 'N', NULL, NULL, NULL, 14);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317120', '3101', 'MG', '3103', '3107', '31030', '31', 'VESPASIANO', NULL, '31', '33200000', '4', '5425', '5425', '11712', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 70.108, '-19,69200', '-43,92300', 693, 'S', 0.7470, NULL, NULL, '31025', 'N', 'N', 5420, NULL, '3101', '3101', NULL, '1948', 'S', 2199, 'VESPASIANO', 'N', '317120', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '844', NULL, '01', 'N', NULL, NULL, NULL, 404);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317130', '3108', 'MG', '3110', '3112', '31062', '31', 'VICOSA', NULL, '31', '36570000', '3', '5427', '5427', '11713', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 299.397, '-20,75400', '-42,88200', 648, 'S', 0.8090, NULL, NULL, '31061', 'N', 'N', 5433, NULL, '3190', '3190', NULL, '1871', 'S', 2200, 'VIÇOSA', 'N', '317130', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '845', NULL, '02', 'N', NULL, NULL, NULL, 117);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317140', '3118', 'MG', '3107', '3112', '31063', '31', 'VIEIRAS', NULL, '32', '36895000', '2', '5429', '5429', '11714', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 112.185, '-20,86600', '-42,24400', 718, 'S', 0.7100, NULL, NULL, '31045', 'N', 'N', 5438, NULL, '3190', '3190', NULL, '1953', 'S', 2201, 'VIEIRAS', 'N', '317140', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '846', NULL, '03', 'N', NULL, NULL, NULL, 130);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317150', '3116', 'MG', '3106', '3108', '31037', '31', 'MATHIAS LOBATO', NULL, '33', '35110000', '1', '5431', NULL, '11715', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 170.882, '-18,59200', '-41,90800', 210, 'S', 0.6830, NULL, NULL, '31036', 'S', 'N', 2967, NULL, '3190', '3190', NULL, '1962', 'S', 1826, 'MATHIAS LOBATO', 'N', '317150', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '471', NULL, '03', 'N', NULL, NULL, NULL, 189);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317160', '3104', 'MG', '3104', '3103', '31012', '31', 'VIRGEM DA LAPA', NULL, '33', '39630000', '0', '5433', '5433', '11716', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'S', 'N', 'N', 'N', NULL, 'N', 871.888, '-16,80400', '-42,34300', 385, 'S', 0.6640, NULL, NULL, '31064', 'S', 'N', 5460, NULL, '3190', '3190', NULL, '1948', 'S', 2202, 'VIRGEM DA LAPA', 'N', '317160', 'N', 'S', 'S', NULL, 57, 'N', 'N', 'N', '847', NULL, '03', 'N', NULL, NULL, NULL, 357);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317170', '3111', 'MG', '3101', '3110', '31056', '31', 'VIRGINIA', NULL, '35', '37465000', '9', '5435', '5435', '11717', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 326.418, '-22,33300', '-45,09200', 945, 'S', 0.7090, NULL, NULL, '31008', 'N', 'N', 5461, NULL, '3190', '3190', NULL, '1911', 'S', 2203, 'VIRGÍNIA', 'N', '317170', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '848', NULL, '03', 'N', NULL, NULL, NULL, 57);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317180', '3109', 'MG', '3103', '3108', '31035', '31', 'VIRGINOPOLIS', NULL, '33', '39730000', '8', '5437', '5437', '11718', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 440.424, '-18,82300', '-42,70400', 750, 'S', 0.7170, NULL, NULL, '31020', 'N', 'N', 5462, NULL, '3190', '3190', NULL, '1923', 'S', 2204, 'VIRGINÓPOLIS', 'N', '317180', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '849', NULL, '03', 'N', NULL, NULL, NULL, 245);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317190', '3116', 'MG', '3106', '3108', '31037', '31', 'VIRGOLANDIA', NULL, '33', '39715000', '7', '5439', '5439', '11719', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 281.541, '-18,47600', '-42,30700', 444, 'S', 0.6670, NULL, NULL, '31036', 'S', 'N', 5463, NULL, '3190', '3190', NULL, '1948', 'S', 2205, 'VIRGOLÂNDIA', 'N', '317190', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '850', NULL, '03', 'N', NULL, NULL, NULL, 189);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317200', '3118', 'MG', '3107', '3112', '31064', '31', 'VISCONDE DO RIO BRANCO', NULL, '32', '36520000', '4', '5441', '5441', '11720', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 241.957, '-21,01000', '-42,84100', 352, 'S', 0.7530, NULL, NULL, '31048', 'N', 'N', 5465, NULL, '3190', '3190', NULL, '1881', 'S', 2206, 'VISCONDE DO RIO BRANCO', 'N', '317200', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '851', NULL, '03', 'N', NULL, NULL, NULL, 181);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317210', '3127', 'MG', '3107', '3112', '31066', '31', 'VOLTA GRANDE', NULL, '32', '36720000', '3', '5443', '5443', '11721', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 208.874, '-21,77100', '-42,53900', 209, 'S', 0.7320, NULL, NULL, '31041', 'N', 'N', 5483, NULL, '3190', '3190', NULL, '1938', 'S', 2207, 'VOLTA GRANDE', 'N', '317210', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '852', NULL, '03', 'N', NULL, NULL, NULL, 409);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('317220', '3110', 'MG', '3101', '3110', '31056', '31', 'WENCESLAU BRAZ', NULL, '35', '37512000', '2', '5421', '5421', '11722', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 101.986, '-22,53400', '-45,36300', 1005, 'S', 0.7430, NULL, NULL, '31003', 'N', 'N', 5492, NULL, '3190', '3190', NULL, '1962', 'S', 2208, 'WENCESLAU BRAZ', 'N', '317220', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '853', NULL, '03', 'N', NULL, NULL, NULL, 16);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320010', '3201', 'ES', '3202', '3203', '32007', '32', 'AFONSO CLAUDIO', NULL, '27', '29600000', '2', '5601', '5601', '07001', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 954.656, '-20,07400', '-41,12400', 370, 'S', 0.7170, NULL, NULL, '32006', 'N', 'N', 37, NULL, '3290', '3290', NULL, '1890', 'S', 820, 'AFONSO CLÁUDIO', 'N', '320010', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '1', NULL, '03', 'N', NULL, NULL, NULL, 173);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320013', '3204', 'ES', '3201', '3201', '32002', '32', 'AGUIA BRANCA', NULL, '27', '29795000', '6', '5733', '5733', '07060', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 449.630, '-18,98300', '-40,74000', 140, 'S', 0.6860, NULL, NULL, '32002', 'S', 'N', 78, NULL, '3290', '3290', NULL, '1989', 'S', 822, 'ÁGUIA BRANCA', 'N', '320013', 'N', 'S', 'S', NULL, 64, 'N', 'N', 'N', '3', NULL, '03', 'N', NULL, NULL, NULL, 110);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320016', '3204', 'ES', '3201', '3201', '32001', '32', 'AGUA DOCE DO NORTE', NULL, '27', '29820000', '9', '5717', '5717', '07059', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'N', 'S', 'N', 'N', NULL, 'N', 484.046, '-18,54700', '-40,97900', 194, 'S', 0.6590, NULL, NULL, '32002', 'S', 'N', 55, NULL, '3290', '3290', NULL, '1989', 'S', 821, 'ÁGUA DOCE DO NORTE', 'N', '320016', 'N', 'S', 'S', NULL, 64, 'N', 'N', 'N', '2', NULL, '03', 'N', NULL, NULL, NULL, 399);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320020', '3202', 'ES', '3203', '3204', '32011', '32', 'ALEGRE', NULL, '28', '29500000', '1', '5603', '5603', '07002', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 772.714, '-20,76400', '-41,53300', 254, 'S', 0.7390, NULL, NULL, '32008', 'N', 'N', 102, NULL, '3290', '3290', NULL, '1890', 'S', 823, 'ALEGRE', 'N', '320020', 'N', 'N', 'S', NULL, 26, 'N', 'N', 'N', '4', NULL, '03', 'N', NULL, NULL, NULL, 52);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320030', '3201', 'ES', '3202', '3203', '32010', '32', 'ALFREDO CHAVES', NULL, '27', '29240000', '0', '5605', '5605', '07003', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 615.593, '-20,63500', '-40,75000', 17, 'S', 0.7540, NULL, NULL, '32006', 'N', 'N', 111, NULL, '3290', '3290', NULL, '1891', 'S', 824, 'ALFREDO CHAVES', 'N', '320030', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '5', NULL, '03', 'N', NULL, NULL, NULL, 52);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320035', '3204', 'ES', '3201', '3201', '32003', '32', 'ALTO RIO NOVO', NULL, '27', '29760000', '9', '5719', '5719', '07061', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'N', 'S', 'S', 'N', NULL, 'N', 227.725, '-19,05600', '-41,01700', 540, 'S', 0.6790, NULL, NULL, '32002', 'S', 'N', 161, NULL, '3290', '3290', NULL, '1989', 'S', 825, 'ALTO RIO NOVO', 'N', '320035', 'N', 'S', 'S', NULL, NULL, 'S', 'N', 'N', '6', NULL, '03', 'N', NULL, NULL, NULL, 110);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320040', '3201', 'ES', '3202', '3203', '32010', '32', 'ANCHIETA', NULL, '28', '29230000', '9', '5607', '5607', '07004', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 404.882, '-20,80500', '-40,64500', 2, 'S', 0.7850, NULL, NULL, '32006', 'N', 'N', 222, NULL, '3290', '3290', NULL, '1759', 'S', 826, 'ANCHIETA', 'N', '320040', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '7', NULL, '03', 'N', NULL, NULL, NULL, 52);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320050', '3202', 'ES', '3203', '3204', '32012', '32', 'APIACA', NULL, '28', '29450000', '8', '5609', '5609', '07005', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 193.579, '-21,15400', '-41,56800', 70, 'S', 0.7230, NULL, NULL, '32007', 'N', 'N', 273, NULL, '3290', '3290', NULL, '1958', 'S', 827, 'APIACÁ', 'N', '320050', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '8', NULL, '03', 'N', NULL, NULL, NULL, 52);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320060', '3204', 'ES', '3201', '3202', '32006', '32', 'ARACRUZ', NULL, '27', '29192733', '7', '5611', '5611', '07006', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 1436.020, '-19,82000', '-40,27300', 60, 'S', 0.7720, NULL, NULL, '32003', 'N', 'N', 302, NULL, '3290', '3290', NULL, '1848', 'S', 828, 'ARACRUZ', 'N', '320060', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '9', NULL, '02', 'N', NULL, NULL, NULL, 110);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320070', '3202', 'ES', '3203', '3204', '32012', '32', 'ATILIO VIVACQUA', NULL, '28', '29490000', '6', '5613', '5613', '07007', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 226.813, '-20,91400', '-41,19800', 85, 'S', 0.7280, NULL, NULL, '32007', 'N', 'N', 418, NULL, '3290', '3290', NULL, '1963', 'S', 829, 'ATILIO VIVACQUA', 'N', '320070', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '10', NULL, '03', 'N', NULL, NULL, NULL, 52);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320080', '3204', 'ES', '3201', '3201', '32003', '32', 'BAIXO GUANDU', NULL, '27', '29730000', '5', '5615', '5615', '07008', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'N', 'S', 'S', 'N', NULL, 'N', 917.888, '-19,51900', '-41,01600', 77, 'S', 0.7100, NULL, NULL, '32002', 'N', 'N', 456, NULL, '3290', '3290', NULL, '1935', 'S', 830, 'BAIXO GUANDU', 'N', '320080', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '11', NULL, '03', 'N', NULL, NULL, NULL, 110);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320090', '3204', 'ES', '3201', '3201', '32001', '32', 'BARRA DE SAO FRANCISCO', NULL, '27', '29800000', '4', '5617', '5617', '07009', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'N', 'S', 'N', 'N', NULL, 'N', 933.747, '-18,75500', '-40,89100', 192, 'S', 0.7010, NULL, NULL, '32002', 'N', 'N', 507, NULL, '3290', '3290', NULL, '1943', 'S', 831, 'BARRA DE SÃO FRANCISCO', 'N', '320090', 'N', 'S', 'S', NULL, 64, 'N', 'N', 'N', '12', NULL, '03', 'N', NULL, NULL, NULL, 399);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320100', '3203', 'ES', '3201', '3201', '32002', '32', 'BOA ESPERANCA', NULL, '27', '29845000', '1', '5619', '5619', '07010', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'N', 'S', 'N', 'N', NULL, 'N', 428.626, '-18,54000', '-40,29600', 140, 'S', 0.6940, NULL, NULL, '32001', 'S', 'N', 623, NULL, '3290', '3290', NULL, '1963', 'S', 832, 'BOA ESPERANÇA', 'N', '320100', 'N', 'S', 'S', NULL, 64, 'N', 'N', 'N', '13', NULL, '03', 'N', NULL, NULL, NULL, 399);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320110', '3202', 'ES', '3203', '3204', '32012', '32', 'BOM JESUS DO NORTE', NULL, '28', '29460000', '0', '5621', '5621', '07011', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 89.111, '-21,11400', '-41,67200', 70, 'S', 0.7660, NULL, NULL, '32008', 'N', 'N', 677, NULL, '3290', '3290', NULL, '1963', 'S', 833, 'BOM JESUS DO NORTE', 'N', '320110', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '14', NULL, '03', 'N', NULL, NULL, NULL, 52);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320115', '3201', 'ES', '3202', '3203', '32007', '32', 'BREJETUBA', NULL, '27', '29630000', '9', '0758', NULL, '07073', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 342.507, '-20,14600', '-41,29000', 780, 'S', 0.6800, NULL, NULL, '32006', 'S', 'N', 751, NULL, '3290', '3290', NULL, '1997', 'S', 834, 'BREJETUBA', 'N', '320115', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '15', NULL, '03', 'N', NULL, NULL, NULL, 173);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320120', '3202', 'ES', '3203', '3204', '32012', '32', 'CACHOEIRO DE ITAPEMIRIM', NULL, '28', '29327000', '9', '5623', '5623', '07012', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 876.792, '-20,84900', '-41,11300', 36, 'S', 0.7700, NULL, NULL, '32007', 'N', 'N', 845, NULL, '3290', '3290', NULL, '1864', 'S', 835, 'CACHOEIRO DE ITAPEMIRIM', 'N', '320120', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '16', NULL, '01', 'N', NULL, NULL, NULL, 52);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320130', '3201', 'ES', '3202', '3203', '32009', '32', 'CARIACICA', NULL, '27', '29150970', '8', '5625', '5625', '07013', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 279.975, '-20,26400', '-40,42000', 73, 'S', 0.7500, NULL, NULL, '32004', 'N', 'N', 1097, NULL, '3201', '3201', NULL, '1890', 'S', 836, 'CARIACICA', 'N', '320130', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '17', NULL, '01', 'N', NULL, NULL, NULL, 173);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320140', '3202', 'ES', '3203', '3204', '32012', '32', 'CASTELO', NULL, '28', '29360000', '7', '5627', '5627', '07014', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 668.971, '-20,60400', '-41,18500', 100, 'S', 0.7620, NULL, NULL, '32007', 'N', 'N', 1159, NULL, '3290', '3290', NULL, '1928', 'S', 837, 'CASTELO', 'N', '320140', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '18', NULL, '03', 'N', NULL, NULL, NULL, 52);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320150', '3204', 'ES', '3201', '3201', '32003', '32', 'COLATINA', NULL, '27', '29700970', '6', '5629', '5629', '07015', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'N', 'S', 'S', 'N', NULL, 'N', 1423.271, '-19,53900', '-40,63100', 38, 'S', 0.7730, NULL, NULL, '32002', 'N', 'N', 1286, NULL, '3290', '3290', NULL, '1907', 'S', 838, 'COLATINA', 'N', '320150', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '19', NULL, '01', 'N', NULL, NULL, NULL, 110);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320160', '3203', 'ES', '3201', '3202', '32005', '32', 'CONCEICAO DA BARRA', NULL, '27', '29960000', '5', '5631', '5631', '07016', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'N', 'S', 'S', 'N', NULL, 'N', 1188.044, '-18,59300', '-39,73200', 2, 'S', 0.6880, NULL, NULL, '32001', 'S', 'N', 1310, NULL, '3290', '3290', NULL, '1833', 'S', 839, 'CONCEIÇÃO DA BARRA', 'N', '320160', 'N', 'S', 'S', NULL, 64, 'N', 'N', 'N', '20', NULL, '03', 'N', NULL, NULL, NULL, 399);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320170', '3201', 'ES', '3202', '3203', '32007', '32', 'CONCEICAO DO CASTELO', NULL, '28', '29370000', '4', '5633', '5633', '07017', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 364.531, '-20,36800', '-41,24400', 610, 'S', 0.7090, NULL, NULL, '32006', 'N', 'N', 1320, NULL, '3290', '3290', NULL, '1963', 'S', 840, 'CONCEIÇÃO DO CASTELO', 'N', '320170', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '21', NULL, '03', 'N', NULL, NULL, NULL, 173);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320180', '3202', 'ES', '3203', '3204', '32011', '32', 'DIVINO DE SAO LOURENCO', NULL, '28', '29590000', '3', '5635', '5635', '07018', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 175.792, '-20,62000', '-41,68600', 680, 'S', 0.6880, NULL, NULL, '32008', 'S', 'N', 1550, NULL, '3290', '3290', NULL, '1963', 'S', 841, 'DIVINO DE SÃO LOURENÇO', 'N', '320180', 'N', 'N', 'S', NULL, 26, 'N', 'N', 'N', '22', NULL, '03', 'N', NULL, NULL, NULL, 52);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320190', '3201', 'ES', '3202', '3203', '32007', '32', 'DOMINGOS MARTINS', NULL, '27', '29260000', '2', '5637', '5637', '07019', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 1225.327, '-20,36300', '-40,65900', 620, 'S', 0.7360, NULL, NULL, '32006', 'N', 'N', 1584, NULL, '3290', '3290', NULL, '1893', 'S', 842, 'DOMINGOS MARTINS', 'N', '320190', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '23', NULL, '03', 'N', NULL, NULL, NULL, 173);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320200', '3202', 'ES', '3203', '3204', '32011', '32', 'DORES DO RIO PRETO', NULL, '28', '29580000', '9', '5639', '5639', '07020', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 153.106, '-20,68900', '-41,84500', 770, 'S', 0.7690, NULL, NULL, '32008', 'N', 'N', 1593, NULL, '3290', '3290', NULL, '1963', 'S', 843, 'DORES DO RIO PRETO', 'N', '320200', 'N', 'N', 'S', NULL, 26, 'S', 'N', 'N', '24', NULL, '03', 'N', NULL, NULL, NULL, 52);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320210', '3204', 'ES', '3201', '3201', '32001', '32', 'ECOPORANGA', NULL, '27', '29850000', '8', '5641', '5641', '07021', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'N', 'S', 'S', 'N', NULL, 'N', 2283.233, '-18,37300', '-40,83100', 260, 'S', 0.6950, NULL, NULL, '32002', 'S', 'N', 1619, NULL, '3290', '3290', NULL, '1953', 'S', 844, 'ECOPORANGA', 'N', '320210', 'N', 'S', 'S', NULL, 64, 'N', 'N', 'N', '25', NULL, '03', 'N', NULL, NULL, NULL, 399);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320220', '3201', 'ES', '3202', '3202', '32006', '32', 'FUNDAO', NULL, '27', '29185000', '7', '5643', '5643', '07022', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 279.648, '-19,93300', '-40,40700', 63, 'S', 0.7520, NULL, NULL, '32005', 'N', 'N', 1848, NULL, '3201', '3290', NULL, '1759', 'S', 845, 'FUNDÃO', 'N', '320220', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '26', NULL, '03', 'N', NULL, NULL, NULL, 173);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320225', '3204', 'ES', '3201', '3201', '32003', '32', 'GOVERNADOR LINDENBERG', NULL, '27', '29720000', '6', '1114', NULL, '07078', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 359.613, '-19,25200', '-40,46100', 0, 'S', NULL, NULL, NULL, '32002', 'N', 'N', 5628, NULL, '3290', '3290', NULL, '2001', 'S', 5561, 'GOVERNADOR LINDENBERG', 'N', '320225', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '27', NULL, '03', 'N', NULL, NULL, NULL, 110);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320230', '3202', 'ES', '3203', '3204', '32011', '32', 'GUACUI', NULL, '28', '29560000', '6', '5645', '5645', '07023', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 467.758, '-20,77600', '-41,67900', 590, 'S', 0.7430, NULL, NULL, '32008', 'N', 'N', 1951, NULL, '3290', '3290', NULL, '1928', 'S', 846, 'GUAÇUÍ', 'N', '320230', 'N', 'N', 'S', NULL, 26, 'N', 'N', 'N', '28', NULL, '03', 'N', NULL, NULL, NULL, 52);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320240', '3201', 'ES', '3202', '3203', '32010', '32', 'GUARAPARI', NULL, '27', '29200000', '5', '5647', '5647', '07024', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 592.231, '-20,65800', '-40,51100', 2, 'S', 0.7890, NULL, NULL, '32006', 'N', 'N', 1996, NULL, '3201', '3290', NULL, '1679', 'S', 847, 'GUARAPARI', 'N', '320240', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '29', NULL, '01', 'N', NULL, NULL, NULL, 173);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320245', '3202', 'ES', '3203', '3204', '32011', '32', 'IBATIBA', NULL, '28', '29395000', '4', '5709', '5709', '07054', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 241.490, '-20,23400', '-41,51100', 740, 'S', 0.7210, NULL, NULL, '32008', 'N', 'N', 2061, NULL, '3290', '3290', NULL, '1981', 'S', 848, 'IBATIBA', 'N', '320245', 'N', 'N', 'S', NULL, 26, 'N', 'N', 'N', '30', NULL, '03', 'N', NULL, NULL, NULL, 173);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320250', '3204', 'ES', '3201', '3202', '32006', '32', 'IBIRACU', NULL, '27', '29670000', '4', '5649', '5649', '07025', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 199.824, '-19,83200', '-40,37000', 36, 'S', 0.7800, NULL, NULL, '32003', 'N', 'N', 2084, NULL, '3290', '3290', NULL, '1891', 'S', 849, 'IBIRAÇU', 'N', '320250', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '31', NULL, '03', 'N', NULL, NULL, NULL, 110);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320255', '3202', 'ES', '3203', '3204', '32011', '32', 'IBITIRAMA', NULL, '28', '29540000', '3', '6011', '6011', '07062', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 329.451, '-20,54100', '-41,66700', 770, 'S', 0.6900, NULL, NULL, '32008', 'S', 'N', 2097, NULL, '3290', '3290', NULL, '1990', 'S', 850, 'IBITIRAMA', 'N', '320255', 'N', 'N', 'S', NULL, 26, 'S', 'N', 'N', '32', NULL, '03', 'N', NULL, NULL, NULL, 52);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320260', '3202', 'ES', '3203', '3203', '32010', '32', 'ICONHA', NULL, '28', '29280000', '3', '5651', '5651', '07026', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 202.920, '-20,79300', '-40,81100', 8, 'S', 0.7900, NULL, NULL, '32007', 'N', 'N', 2111, NULL, '3290', '3290', NULL, '1891', 'S', 851, 'ICONHA', 'N', '320260', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '33', NULL, '03', 'N', NULL, NULL, NULL, 52);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320265', '3202', 'ES', '3203', '3204', '32011', '32', 'IRUPI', NULL, '28', '29398000', '2', '2931', '2931', '07070', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 184.428, '-20,34500', '-41,64100', 730, 'S', 0.7190, NULL, NULL, '32008', 'N', 'N', 2251, NULL, '3290', '3290', NULL, '1993', 'S', 852, 'IRUPI', 'N', '320265', 'N', 'N', 'S', NULL, 26, 'S', 'N', 'N', '34', NULL, '03', 'N', NULL, NULL, NULL, 52);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320270', '3201', 'ES', '3202', '3203', '32008', '32', 'ITAGUACU', NULL, '27', '29690000', '2', '5653', '5653', '07027', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 530.388, '-19,80200', '-40,85600', 157, 'S', 0.7480, NULL, NULL, '32005', 'N', 'N', 2280, NULL, '3290', '3290', NULL, '1914', 'S', 853, 'ITAGUAÇU', 'N', '320270', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '35', NULL, '03', 'N', NULL, NULL, NULL, 173);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320280', '3202', 'ES', '3203', '3204', '32013', '32', 'ITAPEMIRIM', NULL, '28', '29330000', '1', '5655', '5655', '07028', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 557.156, '-21,01100', '-40,83400', 20, 'S', 0.6870, NULL, NULL, '32007', 'N', 'N', 2340, NULL, '3290', '3290', NULL, '1815', 'S', 854, 'ITAPEMIRIM', 'N', '320280', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '36', NULL, '03', 'N', NULL, NULL, NULL, 52);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320290', '3201', 'ES', '3202', '3203', '32008', '32', 'ITARANA', NULL, '27', '29620000', '0', '5657', '5657', '07029', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 299.077, '-19,87400', '-40,87500', 150, 'S', 0.7410, NULL, NULL, '32005', 'N', 'N', 2378, NULL, '3290', '3290', NULL, '1963', 'S', 855, 'ITARANA', 'N', '320290', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '37', NULL, '03', 'N', NULL, NULL, NULL, 173);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320300', '3202', 'ES', '3203', '3204', '32011', '32', 'IUNA', NULL, '28', '29390000', '7', '5659', '5659', '07030', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 460.522, '-20,34600', '-41,53600', 661, 'S', 0.7290, NULL, NULL, '32008', 'N', 'N', 2424, NULL, '3290', '3290', NULL, '1890', 'S', 856, 'IÚNA', 'N', '320300', 'N', 'N', 'S', NULL, 26, 'N', 'N', 'N', '38', NULL, '03', 'N', NULL, NULL, NULL, 52);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320305', '3203', 'ES', '3201', '3202', '32005', '32', 'JAGUARE', NULL, '27', '29950000', '6', '5713', '5713', '07055', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 656.358, '-18,90600', '-40,07600', 80, 'S', 0.6910, NULL, NULL, '32001', 'S', 'N', 2465, NULL, '3290', '3290', NULL, '1981', 'S', 857, 'JAGUARÉ', 'N', '320305', 'N', 'S', 'S', NULL, 64, 'N', 'N', 'N', '39', NULL, '03', 'N', NULL, NULL, NULL, 399);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350520', '3506', 'SP', '3509', '3504', '35021', '35', 'BARIRI', NULL, '14', '17250000', '3', '6203', '6203', '21052', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 440.600, '-22,07400', '-48,74000', 447, 'S', 0.8020, NULL, NULL, '35064', 'N', 'N', 497, NULL, '3590', '3590', NULL, '1890', 'S', 4800, 'BARIRI', 'N', '350520', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '59', NULL, '03', 'N', NULL, NULL, NULL, 277);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320310', '3202', 'ES', '3203', '3204', '32012', '32', 'JERONIMO MONTEIRO', NULL, '28', '29550000', '6', '5661', '5661', '07031', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 162.164, '-20,78900', '-41,39500', 110, 'S', 0.7060, NULL, NULL, '32007', 'N', 'N', 2544, NULL, '3290', '3290', NULL, '1958', 'S', 858, 'JERÔNIMO MONTEIRO', 'N', '320310', 'N', 'N', 'S', NULL, 26, 'N', 'N', 'N', '40', NULL, '03', 'N', NULL, NULL, NULL, 52);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320313', '3204', 'ES', '3201', '3202', '32006', '32', 'JOAO NEIVA', NULL, '27', '29680000', '0', '5721', '5721', '07063', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 272.865, '-19,75800', '-40,38600', 56, 'S', 0.7660, NULL, NULL, '32003', 'N', 'N', 2564, NULL, '3290', '3290', NULL, '1989', 'S', 859, 'JOÃO NEIVA', 'N', '320313', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '41', NULL, '03', 'N', NULL, NULL, NULL, 110);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320316', '3201', 'ES', '3202', '3203', '32007', '32', 'LARANJA DA TERRA', NULL, '27', '29615000', '3', '5723', '5723', '07064', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 456.985, '-19,89900', '-41,05700', 180, 'S', 0.7190, NULL, NULL, '32005', 'N', 'N', 2706, NULL, '3290', '3290', NULL, '1989', 'S', 860, 'LARANJA DA TERRA', 'N', '320316', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '42', NULL, '03', 'N', NULL, NULL, NULL, 173);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320320', '3204', 'ES', '3201', '3202', '32006', '32', 'LINHARES', NULL, '27', '29900970', '5', '5663', '5663', '07032', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'N', 'S', 'S', 'N', NULL, 'N', 3501.604, '-19,39100', '-40,07200', 33, 'S', 0.7570, NULL, NULL, '32003', 'N', 'N', 2751, NULL, '3290', '3290', NULL, '1943', 'S', 861, 'LINHARES', 'N', '320320', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '43', NULL, '01', 'N', NULL, NULL, NULL, 110);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320330', '3204', 'ES', '3201', '3201', '32001', '32', 'MANTENOPOLIS', NULL, '27', '29770000', '4', '5665', '5665', '07033', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'N', 'S', 'N', 'N', NULL, 'N', 320.750, '-18,86300', '-41,12300', 430, 'S', 0.6830, NULL, NULL, '32002', 'S', 'N', 2870, NULL, '3290', '3290', NULL, '1953', 'S', 862, 'MANTENÓPOLIS', 'N', '320330', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '44', NULL, '03', 'N', NULL, NULL, NULL, 110);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320332', '3202', 'ES', '3203', '3204', '32013', '32', 'MARATAIZES', NULL, '28', '29345000', '0', '0760', '0760', '07071', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 135.402, '-21,04300', '-40,82400', 19, 'S', 0.7240, NULL, NULL, '32007', 'N', 'N', 2894, NULL, '3290', '3290', NULL, '1997', 'S', 863, 'MARATAÍZES', 'N', '320332', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '45', NULL, '03', 'N', NULL, NULL, NULL, 52);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320334', '3201', 'ES', '3202', '3203', '32007', '32', 'MARECHAL FLORIANO', NULL, '27', '29255000', '6', '2929', '2929', '07069', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 286.102, '-20,41300', '-40,68300', 560, 'S', 0.7540, NULL, NULL, '32006', 'N', 'N', 2910, NULL, '3290', '3290', NULL, '1993', 'S', 864, 'MARECHAL FLORIANO', 'N', '320334', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '46', NULL, '03', 'N', NULL, NULL, NULL, 173);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320335', '3204', 'ES', '3201', '3201', '32003', '32', 'MARILANDIA', NULL, '27', '29725000', '3', '5707', '5707', '07056', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'N', 'S', 'N', 'N', NULL, 'N', 309.446, '-19,41300', '-40,54200', 150, 'S', 0.7450, NULL, NULL, '32002', 'N', 'N', 2925, NULL, '3290', '3290', NULL, '1980', 'S', 865, 'MARILÂNDIA', 'N', '320335', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '47', NULL, '03', 'N', NULL, NULL, NULL, 110);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320340', '3202', 'ES', '3203', '3204', '32012', '32', 'MIMOSO DO SUL', NULL, '28', '29400000', '3', '5667', '5667', '07034', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 867.281, '-21,06400', '-41,36600', 70, 'S', 0.7420, NULL, NULL, '32007', 'N', 'N', 3028, NULL, '3290', '3290', NULL, '1887', 'S', 866, 'MIMOSO DO SUL', 'N', '320340', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '48', NULL, '03', 'N', NULL, NULL, NULL, 52);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320350', '3203', 'ES', '3201', '3202', '32004', '32', 'MONTANHA', NULL, '27', '29890000', '2', '5669', '5669', '07035', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'N', 'S', 'N', 'N', NULL, 'N', 1099.027, '-18,12700', '-40,36300', 150, 'S', 0.7170, NULL, NULL, '32001', 'N', 'N', 3091, NULL, '3290', '3290', NULL, '1963', 'S', 867, 'MONTANHA', 'N', '320350', 'N', 'S', 'S', NULL, 64, 'N', 'N', 'N', '49', NULL, '03', 'N', NULL, NULL, NULL, 399);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320360', '3203', 'ES', '3201', '3202', '32004', '32', 'MUCURICI', NULL, '27', '29880000', '1', '5671', '5671', '07036', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'N', 'S', 'N', 'N', NULL, 'N', 537.711, '-18,09300', '-40,51600', 240, 'S', 0.6790, NULL, NULL, '32001', 'S', 'N', 3169, NULL, '3290', '3290', NULL, '1953', 'S', 868, 'MUCURICI', 'N', '320360', 'N', 'S', 'S', NULL, 64, 'S', 'N', 'N', '50', NULL, '03', 'N', NULL, NULL, NULL, 399);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320370', '3202', 'ES', '3203', '3204', '32011', '32', 'MUNIZ FREIRE', NULL, '28', '29380000', '0', '5673', '5673', '07037', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 679.922, '-20,46400', '-41,41300', 650, 'S', 0.7230, NULL, NULL, '32008', 'N', 'N', 3181, NULL, '3290', '3290', NULL, '1890', 'S', 869, 'MUNIZ FREIRE', 'N', '320370', 'N', 'N', 'S', NULL, 26, 'N', 'N', 'N', '51', NULL, '03', 'N', NULL, NULL, NULL, 52);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320380', '3202', 'ES', '3203', '3204', '32012', '32', 'MUQUI', NULL, '28', '29480000', '9', '5675', '5675', '07038', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 326.873, '-20,95200', '-41,34600', 250, 'S', 0.7230, NULL, NULL, '32007', 'N', 'N', 3183, NULL, '3290', '3290', NULL, '1943', 'S', 870, 'MUQUI', 'N', '320380', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '52', NULL, '03', 'N', NULL, NULL, NULL, 52);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320390', '3204', 'ES', '3201', '3201', '32002', '32', 'NOVA VENECIA', NULL, '27', '29830000', '8', '5677', '5677', '07039', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'N', 'S', 'S', 'N', NULL, 'N', 1448.289, '-18,71100', '-40,40100', 65, 'S', 0.7380, NULL, NULL, '32002', 'N', 'N', 3343, NULL, '3290', '3290', NULL, '1953', 'S', 871, 'NOVA VENÉCIA', 'N', '320390', 'N', 'S', 'S', NULL, 64, 'N', 'N', 'N', '53', NULL, '03', 'N', NULL, NULL, NULL, 399);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320400', '3204', 'ES', '3201', '3201', '32003', '32', 'PANCAS', NULL, '27', '29750000', '5', '5679', '5679', '07040', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'N', 'S', 'S', 'N', NULL, 'N', 823.834, '-19,22500', '-40,85100', 190, 'S', 0.6670, NULL, NULL, '32002', 'S', 'N', 3512, NULL, '3290', '3290', NULL, '1963', 'S', 872, 'PANCAS', 'N', '320400', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '54', NULL, '03', 'N', NULL, NULL, NULL, 110);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320405', '3203', 'ES', '3201', '3202', '32005', '32', 'PEDRO CANARIO', NULL, '27', '29970000', '4', '5715', '5715', '07058', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'N', 'S', 'N', 'N', NULL, 'N', 434.040, '-18,03000', '-40,15100', 140, 'S', 0.6730, NULL, NULL, '32001', 'S', 'N', 3668, NULL, '3290', '3290', NULL, '1983', 'S', 873, 'PEDRO CANÁRIO', 'N', '320405', 'N', 'S', 'S', NULL, 64, 'N', 'N', 'N', '55', NULL, '03', 'N', NULL, NULL, NULL, 399);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320410', '3203', 'ES', '3201', '3202', '32004', '32', 'PINHEIROS', NULL, '27', '29980000', '4', '5681', '5681', '07041', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'N', 'S', 'N', 'N', NULL, 'N', 975.056, '-18,41200', '-40,21500', 710, 'S', 0.7090, NULL, NULL, '32001', 'N', 'N', 3766, NULL, '3290', '3290', NULL, '1963', 'S', 874, 'PINHEIROS', 'N', '320410', 'N', 'S', 'S', NULL, 64, 'N', 'N', 'N', '56', NULL, '03', 'N', NULL, NULL, NULL, 399);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320420', '3201', 'ES', '3202', '3203', '32010', '32', 'PIUMA', NULL, '28', '29285000', '3', '5683', '5683', '07042', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 73.504, '-20,83500', '-40,72900', 2, 'S', 0.7760, NULL, NULL, '32006', 'N', 'N', 3820, NULL, '3290', '3290', NULL, '1963', 'S', 875, 'PIÚMA', 'N', '320420', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '57', NULL, '03', 'N', NULL, NULL, NULL, 52);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320425', '3203', 'ES', '3201', '3202', '32004', '32', 'PONTO BELO', NULL, '27', '29885000', '2', '0762', NULL, '07074', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'S', 'N', 'S', 'N', 'N', NULL, 'N', 356.156, '-18,12400', '-40,54100', 290, 'S', 0.6960, NULL, NULL, '32001', 'S', 'N', 3878, NULL, '3290', '3290', NULL, '1997', 'S', 876, 'PONTO BELO', 'N', '320425', 'N', 'S', 'S', NULL, 64, 'S', 'N', 'N', '58', NULL, '03', 'N', NULL, NULL, NULL, 399);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320430', '3202', 'ES', '3203', '3204', '32013', '32', 'PRESIDENTE KENNEDY', NULL, '28', '29350000', '2', '5685', '5685', '07043', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 586.464, '-21,09900', '-41,04700', 55, 'S', 0.6740, NULL, NULL, '32007', 'S', 'N', 3975, NULL, '3290', '3290', NULL, '1963', 'S', 877, 'PRESIDENTE KENNEDY', 'N', '320430', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '59', NULL, '03', 'N', NULL, NULL, NULL, 52);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320435', '3204', 'ES', '3201', '3202', '32006', '32', 'RIO BANANAL', NULL, '27', '29920000', '1', '5711', '5711', '07057', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'N', 'S', 'S', 'N', NULL, 'N', 645.483, '-19,26500', '-40,33300', 95, 'S', 0.7250, NULL, NULL, '32003', 'N', 'N', 4136, NULL, '3290', '3290', NULL, '1979', 'S', 878, 'RIO BANANAL', 'N', '320435', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '60', NULL, '03', 'N', NULL, NULL, NULL, 110);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320440', '3202', 'ES', '3203', '3203', '32010', '32', 'RIO NOVO DO SUL', NULL, '28', '29290000', '1', '5687', '5687', '07044', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 203.721, '-20,86300', '-40,93600', 70, 'S', 0.7600, NULL, NULL, '32007', 'N', 'N', 4180, NULL, '3290', '3290', NULL, '1893', 'S', 879, 'RIO NOVO DO SUL', 'N', '320440', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '61', NULL, '03', 'N', NULL, NULL, NULL, 52);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320450', '3201', 'ES', '3202', '3203', '32008', '32', 'SANTA LEOPOLDINA', NULL, '27', '29640000', '0', '5689', '5689', '07045', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 716.441, '-20,10100', '-40,53000', 16, 'S', 0.7110, NULL, NULL, '32004', 'N', 'N', 4358, NULL, '3290', '3290', NULL, '1884', 'S', 880, 'SANTA LEOPOLDINA', 'N', '320450', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '62', NULL, '03', 'N', NULL, NULL, NULL, 173);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320455', '3201', 'ES', '3202', '3203', '32008', '32', 'SANTA MARIA DE JETIBA', NULL, '27', '29645000', '9', '5725', '5725', '07065', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 735.552, '-20,04100', '-40,74600', 700, 'S', 0.7240, NULL, NULL, '32005', 'N', 'N', 4379, NULL, '3290', '3290', NULL, '1989', 'S', 881, 'SANTA MARIA DE JETIBÁ', 'N', '320455', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '63', NULL, '03', 'N', NULL, NULL, NULL, 173);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320460', '3201', 'ES', '3202', '3203', '32008', '32', 'SANTA TERESA', NULL, '27', '29650000', '9', '5691', '5691', '07046', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 694.532, '-19,93600', '-40,60000', 655, 'S', 0.7890, NULL, NULL, '32005', 'N', 'N', 4419, NULL, '3290', '3290', NULL, '1890', 'S', 882, 'SANTA TERESA', 'N', '320460', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '64', NULL, '03', 'N', NULL, NULL, NULL, 173);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320465', '3204', 'ES', '3201', '3201', '32003', '32', 'SAO DOMINGOS DO NORTE', NULL, '27', '29745000', '8', '2933', '2933', '07068', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'N', 'S', 'S', 'N', NULL, 'N', 299.489, '-19,14400', '-40,62400', 180, 'S', 0.7100, NULL, NULL, '32002', 'N', 'N', 4565, NULL, '3290', '3290', NULL, '1993', 'S', 883, 'SÃO DOMINGOS DO NORTE', 'N', '320465', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '65', NULL, '03', 'N', NULL, NULL, NULL, 110);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320470', '3204', 'ES', '3201', '3201', '32002', '32', 'SAO GABRIEL DA PALHA', NULL, '27', '29780000', '8', '5693', '5693', '07047', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'N', 'S', 'S', 'N', NULL, 'N', 432.814, '-19,01700', '-40,53600', 140, 'S', 0.7420, NULL, NULL, '32002', 'N', 'N', 4603, NULL, '3290', '3290', NULL, '1963', 'S', 884, 'SÃO GABRIEL DA PALHA', 'N', '320470', 'N', 'S', 'S', NULL, 64, 'N', 'N', 'N', '66', NULL, '03', 'N', NULL, NULL, NULL, 110);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320480', '3202', 'ES', '3203', '3204', '32012', '32', 'SAO JOSE DO CALCADO', NULL, '28', '29470000', '7', '5695', '5695', '07048', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 272.771, '-21,02500', '-41,65400', 320, 'S', 0.7450, NULL, NULL, '32008', 'N', 'N', 4709, NULL, '3290', '3290', NULL, '1890', 'S', 885, 'SÃO JOSÉ DO CALÇADO', 'N', '320480', 'N', 'N', 'S', NULL, 26, 'N', 'N', 'N', '67', NULL, '03', 'N', NULL, NULL, NULL, 52);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320490', '3203', 'ES', '3201', '3202', '32005', '32', 'SAO MATEUS', NULL, '27', '29931170', '6', '5697', '5697', '07049', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'N', 'S', 'N', 'N', NULL, 'N', 2343.251, '-18,71600', '-39,85900', 36, 'S', 0.7300, NULL, NULL, '32001', 'N', 'N', 4769, NULL, '3290', '3290', NULL, '1764', 'S', 886, 'SÃO MATEUS', 'N', '320490', 'N', 'S', 'S', NULL, 64, 'N', 'N', 'N', '68', NULL, '01', 'N', NULL, NULL, NULL, 399);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320495', '3204', 'ES', '3201', '3203', '32008', '32', 'SAO ROQUE DO CANAA', NULL, '27', '29665000', '5', '0764', '0764', '07075', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 342.395, '-19,73900', '-40,65700', 120, 'S', 0.7510, NULL, NULL, '32002', 'N', 'N', 4825, NULL, '3290', '3290', NULL, '1997', 'S', 887, 'SÃO ROQUE DO CANAÃ', 'N', '320495', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '69', NULL, '03', 'N', NULL, NULL, NULL, 110);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320500', '3201', 'ES', '3202', '3203', '32009', '32', 'SERRA', NULL, '27', '29160970', '2', '5699', '5699', '07050', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 553.254, '-20,12900', '-40,30800', 70, 'S', 0.7610, NULL, NULL, '32005', 'N', 'N', 4933, NULL, '3201', '3201', NULL, '1833', 'S', 888, 'SERRA', 'N', '320500', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '70', NULL, '01', 'N', NULL, NULL, NULL, 173);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320501', '3204', 'ES', '3201', '3202', '32006', '32', 'SOORETAMA', NULL, '27', '29927000', '0', '0766', '0766', '07076', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'N', 'S', 'N', 'N', NULL, 'N', 593.366, '-19,19700', '-40,09800', 59, 'S', 0.7020, NULL, NULL, '32003', 'N', 'N', 5027, NULL, '3290', '3290', NULL, '1997', 'S', 889, 'SOORETAMA', 'N', '320501', 'N', 'S', 'S', NULL, NULL, 'N', 'N', 'N', '71', NULL, '03', 'N', NULL, NULL, NULL, 110);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320503', '3202', 'ES', '3203', '3204', '32012', '32', 'VARGEM ALTA', NULL, '28', '29295000', '6', '5727', '5727', '07066', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 414.737, '-20,67100', '-41,00700', 650, 'S', 0.7270, NULL, NULL, '32007', 'N', 'N', 5371, NULL, '3290', '3290', NULL, '1989', 'S', 890, 'VARGEM ALTA', 'N', '320503', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '72', NULL, '03', 'N', NULL, NULL, NULL, 52);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320506', '3201', 'ES', '3202', '3203', '32007', '32', 'VENDA NOVA DO IMIGRANTE', NULL, '28', '29375000', '9', '5729', '5729', '07067', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 187.894, '-20,34000', '-41,13500', 630, 'S', 0.7780, NULL, NULL, '32006', 'N', 'N', 5399, NULL, '3290', '3290', NULL, '1989', 'S', 891, 'VENDA NOVA DO IMIGRANTE', 'N', '320506', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '73', NULL, '03', 'N', NULL, NULL, NULL, 173);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320510', '3201', 'ES', '3202', '3203', '32009', '32', 'VIANA', NULL, '27', '29135000', '1', '5701', '5701', '07051', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 311.608, '-20,39000', '-40,49600', 34, 'S', 0.7370, NULL, NULL, '32004', 'N', 'N', 5424, NULL, '3201', '3201', NULL, '1862', 'S', 892, 'VIANA', 'N', '320510', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '74', NULL, '02', 'N', NULL, NULL, NULL, 173);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320515', '3204', 'ES', '3201', '3201', '32002', '32', 'VILA PAVAO', NULL, '27', '29843000', '0', '2935', '2935', '07072', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'N', 'S', 'N', 'N', NULL, 'N', 432.741, '-18,61500', '-40,61100', 195, 'S', 0.6880, NULL, NULL, '32002', 'S', 'N', 5452, NULL, '3290', '3290', NULL, '1993', 'S', 893, 'VILA PAVÃO', 'N', '320515', 'N', 'S', 'S', NULL, 64, 'N', 'N', 'N', '75', NULL, '03', 'N', NULL, NULL, NULL, 399);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320517', '3204', 'ES', '3201', '3201', '32002', '32', 'VILA VALERIO', NULL, '27', '29785000', '6', '0768', '0768', '07077', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'S', 'N', 'S', 'N', 'N', NULL, 'N', 464.351, '-18,99800', '-40,38900', 140, 'S', 0.6990, NULL, NULL, '32002', 'S', 'N', 5455, NULL, '3290', '3290', NULL, '1997', 'S', 894, 'VILA VALÉRIO', 'N', '320517', 'N', 'S', 'S', NULL, 64, 'N', 'N', 'N', '76', NULL, '03', 'N', NULL, NULL, NULL, 110);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320520', '3201', 'ES', '3202', '3203', '32009', '32', 'VILA VELHA', NULL, '27', '29101970', '0', '5703', '5703', '07052', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'N', 208.820, '-20,33000', '-40,29200', 5, 'S', 0.8170, NULL, NULL, '32006', 'N', 'N', 5456, NULL, '3201', '3201', NULL, '1947', 'S', 895, 'VILA VELHA', 'N', '320520', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '77', NULL, '01', 'N', NULL, NULL, NULL, 173);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('320530', '3201', 'ES', '3202', '3203', '32009', '32', 'VITORIA', NULL, '27', '29053245', '9', '5705', '5705', '07053', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'S', 'N', NULL, 'S', 93.381, '-20,31900', '-40,33800', 3, 'S', 0.8560, NULL, NULL, '32004', 'N', 'N', 5473, NULL, '3201', '3201', NULL, '1823', 'S', 896, 'VITÓRIA', 'N', '320530', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '78', NULL, '01', 'N', NULL, NULL, NULL, 173);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330010', '3301', 'RJ', '3390', '3305', '33013', '33', 'ANGRA DOS REIS', NULL, '24', '23900000', '0', '5801', '5801', '17001', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 800.430, '-23,00700', '-44,31800', 6, 'S', 0.7720, NULL, NULL, '33900', 'N', 'N', 239, NULL, '3390', '3390', NULL, '1835', 'S', 3583, 'ANGRA DOS REIS', 'N', '330010', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '1', NULL, '01', 'N', NULL, NULL, NULL, 317);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330015', '3308', 'RJ', '3390', '3301', '33002', '33', 'APERIBE', NULL, '22', '28495000', '9', '2919', '2919', '17077', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 88.780, '-21,62100', '-42,10300', 71, 'S', 0.7560, NULL, NULL, '33900', 'N', 'N', 272, NULL, '3390', '3390', NULL, '1993', 'S', 3584, 'APERIBÉ', 'N', '330015', 'N', 'N', 'S', NULL, 62, 'N', 'N', 'N', '2', NULL, '03', 'N', NULL, NULL, NULL, 36);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330020', '3302', 'RJ', '3390', '3304', '33010', '33', 'ARARUAMA', NULL, '22', '28970000', '9', '5803', '5803', '17002', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 633.795, '-22,87300', '-42,34300', 15, 'S', 0.7560, NULL, NULL, '33900', 'N', 'N', 346, NULL, '3390', '3302', NULL, '1890', 'S', 3585, 'ARARUAMA', 'N', '330020', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '3', NULL, '01', 'N', NULL, NULL, NULL, 35);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330022', '3304', 'RJ', '3390', '3303', '33005', '33', 'AREAL', NULL, '24', '25845000', '5', '2925', '2925', '17078', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 111.494, '-22,23100', '-43,10600', 444, 'S', 0.7650, NULL, NULL, '33900', 'N', 'N', 362, NULL, '3390', '3390', NULL, '1993', 'S', 3586, 'AREAL', 'N', '330022', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '4', NULL, '03', 'N', NULL, NULL, NULL, 269);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330023', '3302', 'RJ', '3390', '3304', '33010', '33', 'ARMACAO DOS BUZIOS', NULL, '22', '28950000', '3', '0770', NULL, '17082', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 69.287, '-22,74700', '-41,88200', 3, 'S', 0.7910, NULL, NULL, '33900', 'N', 'N', 381, NULL, '3390', '3302', NULL, '1997', 'S', 3587, 'ARMAÇÃO DOS BÚZIOS', 'N', '330023', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '5', NULL, '03', 'N', NULL, NULL, NULL, 35);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330025', '3302', 'RJ', '3390', '3304', '33010', '33', 'ARRAIAL DO CABO', NULL, '22', '28930000', '8', '5927', '5927', '17066', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 152.305, '-22,96600', '-42,02800', 8, 'S', 0.7900, NULL, NULL, '33900', 'N', 'N', 387, NULL, '3390', '3302', NULL, '1986', 'S', 3588, 'ARRAIAL DO CABO', 'N', '330025', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '6', NULL, '03', 'N', NULL, NULL, NULL, 35);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330030', '3305', 'RJ', '3390', '3305', '33012', '33', 'BARRA DO PIRAI', NULL, '24', '27101970', '8', '5805', '5805', '17003', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 578.471, '-22,47000', '-43,82600', 363, 'S', 0.7810, NULL, NULL, '33900', 'N', 'N', 519, NULL, '3390', '3303', NULL, '1890', 'S', 3589, 'BARRA DO PIRAÍ', 'N', '330030', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '7', NULL, '01', 'N', NULL, NULL, NULL, 205);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330040', '3305', 'RJ', '3390', '3305', '33011', '33', 'BARRA MANSA', NULL, '24', '27301970', '7', '5807', '5807', '17004', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 547.441, '-22,54400', '-44,17100', 381, 'S', 0.8060, NULL, NULL, '33900', 'N', 'N', 528, NULL, '3390', '3303', NULL, '1857', 'S', 3590, 'BARRA MANSA', 'N', '330040', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '8', NULL, '01', 'N', NULL, NULL, NULL, 205);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330045', '3306', 'RJ', '3390', '3306', '33018', '33', 'BELFORD ROXO', NULL, '21', '26100000', '6', '2909', '2909', '17072', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 79.791, '-22,76400', '-43,39900', 18, 'S', 0.7420, NULL, NULL, '33900', 'N', 'N', 578, NULL, '3301', '3301', NULL, '1993', 'S', 3591, 'BELFORD ROXO', 'N', '330045', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '9', NULL, '01', 'N', NULL, NULL, NULL, 81);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330050', '3310', 'RJ', '3390', '3303', '33007', '33', 'BOM JARDIM', NULL, '22', '28660000', '6', '5809', '5809', '17005', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 384.981, '-22,15200', '-42,41900', 560, 'S', 0.7330, NULL, NULL, '33900', 'N', 'N', 658, NULL, '3390', '3390', NULL, '1929', 'S', 3592, 'BOM JARDIM', 'N', '330050', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '10', NULL, '03', 'N', NULL, NULL, NULL, 376);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330060', '3308', 'RJ', '3390', '3301', '33001', '33', 'BOM JESUS DO ITABAPOANA', NULL, '22', '28360000', '5', '5811', '5811', '17006', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 598.401, '-21,13400', '-41,68000', 88, 'S', 0.7460, NULL, NULL, '33900', 'N', 'N', 676, NULL, '3390', '3390', NULL, '1938', 'S', 3593, 'BOM JESUS DO ITABAPOANA', 'N', '330060', 'N', 'N', 'S', NULL, 62, 'N', 'N', 'N', '11', NULL, '03', 'N', NULL, NULL, NULL, 36);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330070', '3302', 'RJ', '3390', '3304', '33010', '33', 'CABO FRIO', NULL, '22', '28901970', '4', '5813', '5813', '17007', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 400.693, '-22,87900', '-42,01900', 4, 'S', 0.7920, NULL, NULL, '33900', 'N', 'N', 816, NULL, '3390', '3302', NULL, '1615', 'S', 3594, 'CABO FRIO', 'N', '330070', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '12', NULL, '01', 'N', NULL, NULL, NULL, 35);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330080', '3310', 'RJ', '3390', '3306', '33016', '33', 'CACHOEIRAS DE MACACU', NULL, '21', '28680000', '3', '5815', '5815', '17008', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 955.806, '-22,46300', '-42,65300', 57, 'S', 0.7520, NULL, NULL, '33900', 'N', 'N', 841, NULL, '3390', '3390', NULL, '1697', 'S', 3595, 'CACHOEIRAS DE MACACU', 'N', '330080', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '13', NULL, '02', 'N', NULL, NULL, NULL, 376);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330090', '3308', 'RJ', '3390', '3301', '33002', '33', 'CAMBUCI', NULL, '22', '28430000', '2', '5817', '5817', '17009', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 561.739, '-21,57500', '-41,91100', 35, 'S', 0.7330, NULL, NULL, '33900', 'N', 'N', 917, NULL, '3390', '3390', NULL, '1891', 'S', 3596, 'CAMBUCI', 'N', '330090', 'N', 'N', 'S', NULL, 62, 'N', 'N', 'N', '14', NULL, '03', 'N', NULL, NULL, NULL, 36);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330093', '3309', 'RJ', '3390', '3302', '33004', '33', 'CARAPEBUS', NULL, '22', '27998000', '6', '0772', NULL, '17083', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 305.502, '-22,18700', '-41,66100', 15, 'S', 0.7400, NULL, NULL, '33900', 'N', 'N', 1081, NULL, '3390', '3390', NULL, '1997', 'S', 3599, 'CARAPEBUS', 'N', '330093', 'N', 'N', 'S', NULL, 65, 'S', 'N', 'N', '17', NULL, '03', 'N', NULL, NULL, NULL, 82);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330095', '3304', 'RJ', '3390', '3303', '33005', '33', 'COMENDADOR LEVY GASPARIAN', NULL, '24', '25870000', '1', '2927', '2927', '17079', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 107.266, '-22,02900', '-43,20500', 315, 'S', 0.7530, NULL, NULL, '33900', 'N', 'N', 1305, NULL, '3390', '3390', NULL, '1993', 'S', 3603, 'COMENDADOR LEVY GASPARIAN', 'N', '330095', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '21', NULL, '03', 'N', NULL, NULL, NULL, 269);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330100', '3309', 'RJ', '3390', '3302', '33003', '33', 'CAMPOS DOS GOYTACAZES', NULL, '22', '28140000', '9', '5819', '5819', '17010', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4031.910, '-21,75400', '-41,32400', 13, 'S', 0.7520, NULL, NULL, '33900', 'N', 'N', 979, NULL, '3390', '3390', NULL, '1677', 'S', 3597, 'CAMPOS DOS GOYTACAZES', 'N', '330100', 'N', 'N', 'S', NULL, 65, 'S', 'S', 'N', '15', NULL, '01', 'N', NULL, NULL, NULL, 82);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330110', '3310', 'RJ', '3390', '3303', '33006', '33', 'CANTAGALO', NULL, '22', '28500000', '8', '5821', '5821', '17011', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 748.777, '-21,98100', '-42,36800', 391, 'S', 0.7790, NULL, NULL, '33900', 'N', 'N', 1027, NULL, '3390', '3390', NULL, '1814', 'S', 3598, 'CANTAGALO', 'N', '330110', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '16', NULL, '03', 'N', NULL, NULL, NULL, 376);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330120', '3310', 'RJ', '3390', '3303', '33006', '33', 'CARMO', NULL, '22', '28640000', '7', '5823', '5823', '17012', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 321.187, '-21,93400', '-42,60900', 347, 'S', 0.7630, NULL, NULL, '33900', 'N', 'N', 1112, NULL, '3390', '3390', NULL, '1881', 'S', 3601, 'CARMO', 'N', '330120', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '19', NULL, '03', 'N', NULL, NULL, NULL, 376);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330130', '3302', 'RJ', '3390', '3304', '33009', '33', 'CASIMIRO DE ABREU', NULL, '22', '28880000', '6', '5825', '5825', '17013', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 460.843, '-22,48100', '-42,20400', 17, 'S', 0.7810, NULL, NULL, '33900', 'N', 'N', 1149, NULL, '3390', '3390', NULL, '1846', 'S', 3602, 'CASIMIRO DE ABREU', 'N', '330130', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '20', NULL, '03', 'N', NULL, NULL, NULL, 35);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330140', '3309', 'RJ', '3390', '3302', '33004', '33', 'CONCEICAO DE MACABU', NULL, '22', '28740000', '5', '5827', '5827', '17014', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 348.327, '-22,08500', '-41,86800', 50, 'S', 0.7380, NULL, NULL, '33900', 'N', 'N', 1316, NULL, '3390', '3390', NULL, '1952', 'S', 3604, 'CONCEIÇÃO DE MACABU', 'N', '330140', 'N', 'N', 'S', NULL, 65, 'N', 'N', 'N', '22', NULL, '03', 'N', NULL, NULL, NULL, 82);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330150', '3310', 'RJ', '3390', '3303', '33006', '33', 'CORDEIRO', NULL, '22', '28540000', '4', '5829', '5829', '17015', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 116.044, '-22,02900', '-42,36100', 485, 'S', 0.7890, NULL, NULL, '33900', 'N', 'N', 1362, NULL, '3390', '3390', NULL, '1943', 'S', 3605, 'CORDEIRO', 'N', '330150', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '23', NULL, '03', 'N', NULL, NULL, NULL, 376);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330160', '3310', 'RJ', '3390', '3303', '33007', '33', 'DUAS BARRAS', NULL, '22', '28650000', '3', '5831', '5831', '17016', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 375.238, '-22,05100', '-42,52200', 530, 'S', 0.7120, NULL, NULL, '33900', 'N', 'N', 1611, NULL, '3390', '3390', NULL, '1891', 'S', 3606, 'DUAS BARRAS', 'N', '330160', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '24', NULL, '03', 'N', NULL, NULL, NULL, 376);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330170', '3306', 'RJ', '3390', '3306', '33018', '33', 'DUQUE DE CAXIAS', NULL, '21', '25001000', '2', '5833', '5833', '17017', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 464.573, '-22,78600', '-43,31200', 19, 'S', 0.7530, NULL, NULL, '33900', 'N', 'N', 1616, NULL, '3301', '3301', NULL, '1943', 'S', 3607, 'DUQUE DE CAXIAS', 'N', '330170', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '25', NULL, '01', 'N', NULL, NULL, NULL, 81);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330180', '3304', 'RJ', '3390', '3306', '33014', '33', 'ENGENHEIRO PAULO DE FRONTIN', NULL, '24', '26650000', '1', '5835', '5835', '17018', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 139.008, '-22,55000', '-43,67800', 395, 'S', 0.7530, NULL, NULL, '33900', 'N', 'N', 1647, NULL, '3390', '3390', NULL, '1958', 'S', 3608, 'ENGENHEIRO PAULO DE FRONTIN', 'N', '330180', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '26', NULL, '03', 'N', NULL, NULL, NULL, 269);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330185', '3310', 'RJ', '3390', '3306', '33018', '33', 'GUAPIMIRIM', NULL, '21', '25940000', '0', '2907', '2907', '17073', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 360.813, '-22,53700', '-42,98200', 48, 'S', 0.7390, NULL, NULL, '33900', 'N', 'N', 1970, NULL, '3301', '3301', NULL, '1993', 'S', 3609, 'GUAPIMIRIM', 'N', '330185', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '27', NULL, '01', 'N', NULL, NULL, NULL, 376);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330187', '3302', 'RJ', '3390', '3304', '33010', '33', 'IGUABA GRANDE', NULL, '22', '28960000', '6', '0774', NULL, '17084', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 53.601, '-22,83900', '-42,22900', 18, 'S', 0.7960, NULL, NULL, '33900', 'N', 'N', 2130, NULL, '3390', '3302', NULL, '1997', 'S', 3610, 'IGUABA GRANDE', 'N', '330187', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '28', NULL, '03', 'N', NULL, NULL, NULL, 35);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330190', '3307', 'RJ', '3390', '3306', '33018', '33', 'ITABORAI', NULL, '21', '24800000', '0', '5837', '5837', '17019', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 424.219, '-22,74400', '-42,85900', 46, 'S', 0.7370, NULL, NULL, '33900', 'N', 'N', 2267, NULL, '3301', '3301', NULL, '1833', 'S', 3611, 'ITABORAÍ', 'N', '330190', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '29', NULL, '01', 'N', NULL, NULL, NULL, 206);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330200', '3306', 'RJ', '3390', '3306', '33017', '33', 'ITAGUAI', NULL, '21', '23801000', '7', '5839', '5839', '17020', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 271.563, '-22,85200', '-43,77500', 13, 'S', 0.7680, NULL, NULL, '33900', 'N', 'N', 2282, NULL, '3301', '3301', NULL, '1818', 'S', 3612, 'ITAGUAÍ', 'N', '330200', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '30', NULL, '01', 'N', NULL, NULL, NULL, 81);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330205', '3308', 'RJ', '3390', '3301', '33001', '33', 'ITALVA', NULL, '22', '28250000', '6', '5929', '5929', '17065', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 296.174, '-21,42100', '-41,69100', 36, 'S', 0.7240, NULL, NULL, '33900', 'N', 'N', 2306, NULL, '3390', '3390', NULL, '1986', 'S', 3613, 'ITALVA', 'N', '330205', 'N', 'N', 'S', NULL, 62, 'N', 'N', 'N', '31', NULL, '03', 'N', NULL, NULL, NULL, 36);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330210', '3308', 'RJ', '3390', '3301', '33002', '33', 'ITAOCARA', NULL, '22', '28570000', '6', '5841', '5841', '17021', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 428.440, '-21,67900', '-42,08200', 60, 'S', 0.7710, NULL, NULL, '33900', 'N', 'N', 2328, NULL, '3390', '3390', NULL, '1890', 'S', 3614, 'ITAOCARA', 'N', '330210', 'N', 'N', 'S', NULL, 62, 'N', 'N', 'N', '32', NULL, '03', 'N', NULL, NULL, NULL, 36);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330220', '3308', 'RJ', '3390', '3301', '33001', '33', 'ITAPERUNA', NULL, '22', '28300000', '5', '5843', '5843', '17022', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1105.566, '-21,20500', '-41,88800', 108, 'S', 0.7870, NULL, NULL, '33900', 'N', 'N', 2342, NULL, '3390', '3390', NULL, '1885', 'S', 3615, 'ITAPERUNA', 'N', '330220', 'N', 'N', 'S', NULL, 62, 'N', 'N', 'N', '33', NULL, '02', 'N', NULL, NULL, NULL, 36);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330225', '3305', 'RJ', '3390', '3305', '33011', '33', 'ITATIAIA', NULL, '24', '27580000', '4', '6003', '6003', '17069', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 224.957, '-22,49600', '-44,56300', 390, 'S', 0.8000, NULL, NULL, '33900', 'N', 'N', 2384, NULL, '3390', '3390', NULL, '1989', 'S', 3616, 'ITATIAIA', 'N', '330225', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '34', NULL, '03', 'N', NULL, NULL, NULL, 205);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330227', '3306', 'RJ', '3390', '3306', '33018', '33', 'JAPERI', NULL, '21', '26400000', '0', '2913', '2913', '17080', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 82.832, '-22,64300', '-43,65300', 30, 'S', 0.7240, NULL, NULL, '33900', 'N', 'N', 2493, NULL, '3301', '3301', NULL, '1993', 'S', 3617, 'JAPERI', 'N', '330227', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '35', NULL, '01', 'N', NULL, NULL, NULL, 81);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330230', '3308', 'RJ', '3390', '3301', '33001', '33', 'LAJE DO MURIAE', NULL, '22', '28350000', '4', '5845', '5845', '17023', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 250.518, '-21,20600', '-42,12300', 172, 'S', 0.7100, NULL, NULL, '33900', 'N', 'N', 2686, NULL, '3390', '3390', NULL, '1962', 'S', 3618, 'LAJE DO MURIAÉ', 'N', '330230', 'N', 'N', 'S', NULL, 62, 'N', 'N', 'N', '36', NULL, '03', 'N', NULL, NULL, NULL, 36);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330240', '3309', 'RJ', '3390', '3302', '33004', '33', 'MACAE', NULL, '22', '27901970', '3', '5847', '5847', '17024', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1215.904, '-22,37100', '-41,78700', 2, 'S', 0.7900, NULL, NULL, '33900', 'N', 'N', 2791, NULL, '3390', '3390', NULL, '1813', 'S', 3619, 'MACAÉ', 'N', '330240', 'N', 'N', 'S', NULL, 65, 'N', 'N', 'N', '37', NULL, '01', 'N', NULL, NULL, NULL, 82);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330245', '3310', 'RJ', '3390', '3303', '33006', '33', 'MACUCO', NULL, '22', '28545000', '2', '0776', NULL, '17085', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 77.080, '-21,98400', '-42,25300', 266, 'S', 0.7690, NULL, NULL, '33900', 'N', 'N', 2811, NULL, '3390', '3390', NULL, '1997', 'S', 3620, 'MACUCO', 'N', '330245', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '38', NULL, '03', 'N', NULL, NULL, NULL, 376);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330250', '3306', 'RJ', '3390', '3306', '33018', '33', 'MAGE', NULL, '21', '25900000', '2', '5849', '5849', '17025', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 385.696, '-22,65300', '-43,04100', 5, 'S', 0.7460, NULL, NULL, '33900', 'N', 'N', 2824, NULL, '3301', '3301', NULL, '1789', 'S', 3621, 'MAGÉ', 'N', '330250', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '39', NULL, '01', 'N', NULL, NULL, NULL, 81);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330260', '3301', 'RJ', '3390', '3306', '33017', '33', 'MANGARATIBA', NULL, '21', '23860000', '1', '5851', '5851', '17026', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 351.653, '-22,96000', '-44,04100', 18, 'S', 0.7900, NULL, NULL, '33900', 'N', 'N', 2858, NULL, '3390', '3301', NULL, '1831', 'S', 3622, 'MANGARATIBA', 'N', '330260', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '40', NULL, '01', 'N', NULL, NULL, NULL, 317);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330270', '3307', 'RJ', '3390', '3306', '33018', '33', 'MARICA', NULL, '21', '24900000', '0', '5853', '5853', '17027', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 362.477, '-22,91900', '-42,81900', 5, 'S', 0.7860, NULL, NULL, '33900', 'N', 'N', 2923, NULL, '3301', '3301', NULL, '1833', 'S', 3623, 'MARICÁ', 'N', '330270', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '41', NULL, '01', 'N', NULL, NULL, NULL, 206);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330280', '3304', 'RJ', '3390', '3306', '33014', '33', 'MENDES', NULL, '24', '26700000', '9', '5855', '5855', '17028', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 77.288, '-22,52700', '-43,73300', 410, 'S', 0.7750, NULL, NULL, '33900', 'N', 'N', 3006, NULL, '3390', '3390', NULL, '1952', 'S', 3624, 'MENDES', 'N', '330280', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '42', NULL, '03', 'N', NULL, NULL, NULL, 269);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330285', '3306', 'RJ', '3390', '3306', '33018', '33', 'MESQUITA', NULL, '21', '26500000', '8', '1116', NULL, '17092', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 34.767, '-22,78150', '-43,42870', 0, 'S', NULL, NULL, NULL, '33900', 'N', 'N', 5630, NULL, '3301', '3301', NULL, '2001', 'S', 5562, 'MESQUITA', 'N', '330285', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '43', NULL, '01', 'N', NULL, NULL, NULL, 81);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330290', '3304', 'RJ', '3390', '3306', '33014', '33', 'MIGUEL PEREIRA', NULL, '24', '26910000', '8', '5857', '5857', '17029', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 287.356, '-22,45400', '-43,46900', 618, 'S', 0.7770, NULL, NULL, '33900', 'N', 'N', 3020, NULL, '3390', '3390', NULL, '1955', 'S', 3625, 'MIGUEL PEREIRA', 'N', '330290', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '44', NULL, '03', 'N', NULL, NULL, NULL, 269);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330300', '3308', 'RJ', '3390', '3301', '33002', '33', 'MIRACEMA', NULL, '22', '28460000', '5', '5859', '5859', '17030', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 303.353, '-21,41200', '-42,19700', 137, 'S', 0.7330, NULL, NULL, '33900', 'N', 'N', 3040, NULL, '3390', '3390', NULL, '1935', 'S', 3626, 'MIRACEMA', 'N', '330300', 'N', 'N', 'S', NULL, 62, 'N', 'N', 'N', '45', NULL, '03', 'N', NULL, NULL, NULL, 36);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330310', '3308', 'RJ', '3390', '3301', '33001', '33', 'NATIVIDADE', NULL, '22', '28380000', '4', '5861', '5861', '17031', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 387.026, '-21,04200', '-41,97300', 182, 'S', 0.7360, NULL, NULL, '33900', 'N', 'N', 3204, NULL, '3390', '3390', NULL, '1947', 'S', 3627, 'NATIVIDADE', 'N', '330310', 'N', 'N', 'S', NULL, 62, 'N', 'N', 'N', '46', NULL, '03', 'N', NULL, NULL, NULL, 36);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330320', '3306', 'RJ', '3390', '3306', '33018', '33', 'NILOPOLIS', NULL, '21', '26501970', '3', '5863', '5863', '17032', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 19.157, '-22,80800', '-43,41400', 16, 'S', 0.7880, NULL, NULL, '33900', 'N', 'N', 3226, NULL, '3301', '3301', NULL, '1947', 'S', 3628, 'NILÓPOLIS', 'N', '330320', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '47', NULL, '01', 'N', NULL, NULL, NULL, 81);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330330', '3307', 'RJ', '3390', '3306', '33018', '33', 'NITEROI', NULL, '21', '24001970', '2', '5865', '5865', '17033', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 129.375, '-22,88300', '-43,10400', 5, 'S', 0.8860, NULL, NULL, '33900', 'N', 'N', 3233, NULL, '3301', '3301', NULL, '1818', 'S', 3629, 'NITERÓI', 'N', '330330', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '48', NULL, '01', 'N', NULL, NULL, NULL, 206);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330340', '3310', 'RJ', '3390', '3303', '33007', '33', 'NOVA FRIBURGO', NULL, '22', '28600000', '1', '5867', '5867', '17034', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 932.635, '-22,28200', '-42,53100', 846, 'S', 0.8100, NULL, NULL, '33900', 'N', 'N', 3285, NULL, '3390', '3390', NULL, '1820', 'S', 3630, 'NOVA FRIBURGO', 'N', '330340', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '49', NULL, '01', 'N', NULL, NULL, NULL, 376);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330350', '3306', 'RJ', '3390', '3306', '33018', '33', 'NOVA IGUACU', NULL, '21', '26000000', '0', '5869', '5869', '17035', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 523.888, '-22,75900', '-43,45100', 25, 'S', 0.7620, NULL, NULL, '33900', 'N', 'N', 3292, NULL, '3301', '3301', NULL, '1833', 'S', 3631, 'NOVA IGUAÇU', 'N', '330350', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '50', NULL, '01', 'N', NULL, NULL, NULL, 81);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330360', '3304', 'RJ', '3390', '3306', '33014', '33', 'PARACAMBI', NULL, '21', '26600000', '9', '5871', '5871', '17036', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 179.374, '-22,61100', '-43,70900', 50, 'S', 0.7710, NULL, NULL, '33900', 'N', 'N', 3521, NULL, '3301', '3301', NULL, '1960', 'S', 3632, 'PARACAMBI', 'N', '330360', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '51', NULL, '01', 'N', NULL, NULL, NULL, 269);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330370', '3304', 'RJ', '3390', '3303', '33005', '33', 'PARAIBA DO SUL', NULL, '24', '25850000', '8', '5873', '5873', '17037', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 580.803, '-22,16200', '-43,29300', 275, 'S', 0.7710, NULL, NULL, '33900', 'N', 'N', 3528, NULL, '3390', '3390', NULL, '1833', 'S', 3633, 'PARAÍBA DO SUL', 'N', '330370', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '52', NULL, '03', 'N', NULL, NULL, NULL, 269);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330380', '3301', 'RJ', '3390', '3305', '33013', '33', 'PARATY', NULL, '24', '23970000', '7', '5875', '5875', '17038', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 928.467, '-23,21800', '-44,71300', 5, 'S', 0.7770, NULL, NULL, '33900', 'N', 'N', 3558, NULL, '3390', '3390', NULL, '1667', 'S', 3634, 'PARATY', 'N', '330380', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '53', NULL, '03', 'N', NULL, NULL, NULL, 317);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330385', '3304', 'RJ', '3390', '3306', '33014', '33', 'PATY DO ALFERES', NULL, '24', '26950000', '6', '6005', '6005', '17067', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 319.103, '-22,42900', '-43,41900', 610, 'S', 0.7180, NULL, NULL, '33900', 'N', 'N', 3608, NULL, '3390', '3390', NULL, '1989', 'S', 3635, 'PATY DO ALFERES', 'N', '330385', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '54', NULL, '03', 'N', NULL, NULL, NULL, 269);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330390', '3310', 'RJ', '3390', '3306', '33015', '33', 'PETROPOLIS', NULL, '24', '25000000', '6', '5877', '5877', '17039', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 774.606, '-22,50500', '-43,17900', 809, 'S', 0.8040, NULL, NULL, '33900', 'N', 'N', 3716, NULL, '3390', '3301', NULL, '1857', 'S', 3636, 'PETRÓPOLIS', 'N', '330390', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '55', NULL, '01', 'N', NULL, NULL, NULL, 376);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330395', '3305', 'RJ', '3390', '3305', '33011', '33', 'PINHEIRAL', NULL, '24', '27197000', '5', '0778', NULL, '17086', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 76.793, '-22,51300', '-44,00100', 345, 'S', 0.7960, NULL, NULL, '33900', 'N', 'N', 3763, NULL, '3390', '3390', NULL, '1997', 'S', 3637, 'PINHEIRAL', 'N', '330395', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '56', NULL, '03', 'N', NULL, NULL, NULL, 205);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330400', '3305', 'RJ', '3390', '3305', '33011', '33', 'PIRAI', NULL, '24', '27175000', '3', '5879', '5879', '17040', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 505.466, '-22,62900', '-43,89800', 387, 'S', 0.7760, NULL, NULL, '33900', 'N', 'N', 3781, NULL, '3390', '3303', NULL, '1837', 'S', 3638, 'PIRAÍ', 'N', '330400', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '57', NULL, '03', 'N', NULL, NULL, NULL, 205);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330410', '3308', 'RJ', '3390', '3301', '33001', '33', 'PORCIUNCULA', NULL, '22', '28390000', '2', '5881', '5881', '17041', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 302.201, '-20,96300', '-42,04100', 190, 'S', 0.7300, NULL, NULL, '33900', 'N', 'N', 3886, NULL, '3390', '3390', NULL, '1947', 'S', 3639, 'PORCIÚNCULA', 'N', '330410', 'N', 'N', 'S', NULL, 62, 'N', 'N', 'N', '58', NULL, '03', 'N', NULL, NULL, NULL, 36);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330411', '3305', 'RJ', '3390', '3305', '33011', '33', 'PORTO REAL', NULL, '24', '27570000', '0', '0780', '0780', '17087', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 50.587, '-22,42000', '-44,29000', 385, 'S', 0.7430, NULL, NULL, '33900', 'N', 'N', 3921, NULL, '3390', '3390', NULL, '1997', 'S', 3640, 'PORTO REAL', 'N', '330411', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '59', NULL, '03', 'N', NULL, NULL, NULL, 205);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330412', '3305', 'RJ', '3390', '3305', '33011', '33', 'QUATIS', NULL, '24', '27400000', '8', '2923', '2923', '17075', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 286.244, '-22,40700', '-44,25800', 415, 'S', 0.7910, NULL, NULL, '33900', 'N', 'N', 4013, NULL, '3390', '3390', NULL, '1993', 'S', 3641, 'QUATIS', 'N', '330412', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '60', NULL, '03', 'N', NULL, NULL, NULL, 205);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330414', '3306', 'RJ', '3390', '3306', '33018', '33', 'QUEIMADOS', NULL, '21', '26300000', '4', '2911', '2911', '17074', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 76.921, '-22,71600', '-43,55500', 30, 'S', 0.7320, NULL, NULL, '33900', 'N', 'N', 4021, NULL, '3301', '3301', NULL, '1993', 'S', 3642, 'QUEIMADOS', 'N', '330414', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '61', NULL, '01', 'N', NULL, NULL, NULL, 81);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330415', '3309', 'RJ', '3390', '3302', '33004', '33', 'QUISSAMA', NULL, '22', '28735000', '1', '6007', '6007', '17070', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 715.877, '-22,10700', '-41,47200', 19, 'S', 0.7320, NULL, NULL, '33900', 'N', 'N', 4035, NULL, '3390', '3390', NULL, '1990', 'S', 3643, 'QUISSAMÃ', 'N', '330415', 'N', 'N', 'S', NULL, 65, 'N', 'N', 'N', '62', NULL, '03', 'N', NULL, NULL, NULL, 82);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330420', '3305', 'RJ', '3390', '3305', '33011', '33', 'RESENDE', NULL, '24', '27501970', '1', '5883', '5883', '17042', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1113.507, '-22,46900', '-44,44700', 407, 'S', 0.8090, NULL, NULL, '33900', 'N', 'N', 4077, NULL, '3390', '3303', NULL, '1801', 'S', 3644, 'RESENDE', 'N', '330420', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '63', NULL, '01', 'N', NULL, NULL, NULL, 205);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330430', '3307', 'RJ', '3390', '3306', '33016', '33', 'RIO BONITO', NULL, '21', '28800000', '0', '5885', '5885', '17043', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 462.176, '-22,70800', '-42,62600', 40, 'S', 0.7720, NULL, NULL, '33900', 'N', 'N', 4138, NULL, '3390', '3301', NULL, '1846', 'S', 3645, 'RIO BONITO', 'N', '330430', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '64', NULL, '02', 'N', NULL, NULL, NULL, 206);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330440', '3305', 'RJ', '3390', '3305', '33011', '33', 'RIO CLARO', NULL, '24', '27460000', '9', '5887', '5887', '17044', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 841.390, '-22,72300', '-44,13600', 446, 'S', 0.7370, NULL, NULL, '33900', 'N', 'N', 4147, NULL, '3390', '3390', NULL, '1849', 'S', 3646, 'RIO CLARO', 'N', '330440', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '65', NULL, '03', 'N', NULL, NULL, NULL, 205);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330450', '3305', 'RJ', '3390', '3305', '33012', '33', 'RIO DAS FLORES', NULL, '24', '27660000', '8', '5889', '5889', '17045', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 477.662, '-22,16800', '-43,58600', 525, 'S', 0.7390, NULL, NULL, '33900', 'N', 'N', 4151, NULL, '3390', '3390', NULL, '1890', 'S', 3647, 'RIO DAS FLORES', 'N', '330450', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '66', NULL, '03', 'N', NULL, NULL, NULL, 205);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330452', '3302', 'RJ', '3390', '3304', '33009', '33', 'RIO DAS OSTRAS', NULL, '22', '28890000', '4', '2921', '2921', '17081', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 230.621, '-22,52700', '-41,94500', 4, 'S', 0.7750, NULL, NULL, '33900', 'N', 'N', 4152, NULL, '3390', '3390', NULL, '1993', 'S', 3648, 'RIO DAS OSTRAS', 'N', '330452', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '67', NULL, '02', 'N', NULL, NULL, NULL, 35);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330455', '3306', 'RJ', '3390', '3306', '33018', '33', 'RIO DE JANEIRO', NULL, '21', '20062970', '7', '6001', '6001', '17064', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'S', 1182.296, '-22,90300', '-43,20800', 2, 'S', 0.8420, NULL, NULL, '33900', 'N', 'N', 4155, NULL, '3301', '3301', NULL, '1975', 'S', 3649, 'RIO DE JANEIRO', 'N', '330455', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '68', NULL, '01', 'N', NULL, NULL, NULL, 81);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330460', '3310', 'RJ', '3390', '3303', '33008', '33', 'SANTA MARIA MADALENA', NULL, '22', '28770000', '7', '5891', '5891', '17046', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 815.591, '-21,95500', '-42,00800', 615, 'S', 0.7340, NULL, NULL, '33900', 'N', 'N', 4387, NULL, '3390', '3390', NULL, '1861', 'S', 3650, 'SANTA MARIA MADALENA', 'N', '330460', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '69', NULL, '03', 'N', NULL, NULL, NULL, 376);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330470', '3308', 'RJ', '3390', '3301', '33002', '33', 'SANTO ANTONIO DE PADUA', NULL, '22', '28470000', '6', '5893', '5893', '17047', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 611.981, '-21,53900', '-42,18000', 86, 'S', 0.7540, NULL, NULL, '33900', 'N', 'N', 4489, NULL, '3390', '3390', NULL, '1882', 'S', 3651, 'SANTO ANTÔNIO DE PÁDUA', 'N', '330470', 'N', 'N', 'S', NULL, 62, 'N', 'N', 'N', '70', NULL, '03', 'N', NULL, NULL, NULL, 36);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330475', '3309', 'RJ', '3390', '3302', '33003', '33', 'SAO FRANCISCO DE ITABAPOANA', NULL, '22', '28230000', '5', '0782', '0782', '17088', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1111.335, '-21,47000', '-41,11900', 8, 'S', 0.6880, NULL, NULL, '33900', 'N', 'N', 4587, NULL, '3390', '3390', NULL, '1997', 'S', 3653, 'SÃO FRANCISCO DE ITABAPOANA', 'N', '330475', 'N', 'N', 'S', NULL, 65, 'N', 'N', 'N', '72', NULL, '03', 'N', NULL, NULL, NULL, 82);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330480', '3309', 'RJ', '3390', '3302', '33003', '33', 'SAO FIDELIS', NULL, '22', '28400000', '5', '5895', '5895', '17048', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1028.095, '-21,64600', '-41,74700', 15, 'S', 0.7410, NULL, NULL, '33900', 'N', 'N', 4579, NULL, '3390', '3390', NULL, '1850', 'S', 3652, 'SÃO FIDÉLIS', 'N', '330480', 'N', 'N', 'S', NULL, 65, 'N', 'N', 'N', '71', NULL, '03', 'N', NULL, NULL, NULL, 82);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330490', '3307', 'RJ', '3390', '3306', '33018', '33', 'SAO GONCALO', NULL, '21', '24001970', '4', '5897', '5897', '17049', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 249.142, '-22,82700', '-43,05400', 19, 'S', 0.7820, NULL, NULL, '33900', 'N', 'N', 4609, NULL, '3301', '3301', NULL, '1890', 'S', 3654, 'SÃO GONÇALO', 'N', '330490', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '73', NULL, '01', 'N', NULL, NULL, NULL, 206);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330500', '3309', 'RJ', '3390', '3302', '33003', '33', 'SAO JOAO DA BARRA', NULL, '22', '28200000', '0', '5899', '5899', '17050', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 458.611, '-21,64000', '-41,05100', 5, 'S', 0.7230, NULL, NULL, '33900', 'N', 'N', 4630, NULL, '3390', '3390', NULL, '1677', 'S', 3655, 'SÃO JOÃO DA BARRA', 'N', '330500', 'N', 'N', 'S', NULL, 65, 'N', 'N', 'N', '74', NULL, '03', 'N', NULL, NULL, NULL, 82);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352200', '3506', 'SP', '3509', '3504', '35021', '35', 'ITAJU', NULL, '14', '17260000', '0', '6541', '6541', '21221', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 228.777, '-21,98100', '-48,80500', 498, 'S', 0.8070, NULL, NULL, '35064', 'N', 'N', 2302, NULL, '3590', '3590', NULL, '1953', 'S', 4995, 'ITAJU', 'N', '352200', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '254', NULL, '03', 'N', NULL, NULL, NULL, 277);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330510', '3306', 'RJ', '3390', '3306', '33018', '33', 'SAO JOAO DE MERITI', NULL, '21', '25501970', '9', '5901', '5901', '17051', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 34.838, '-22,80400', '-43,37200', 19, 'S', 0.7740, NULL, NULL, '33900', 'N', 'N', 4645, NULL, '3301', '3301', NULL, '1947', 'S', 3656, 'SÃO JOÃO DE MERITI', 'N', '330510', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '75', NULL, '01', 'N', NULL, NULL, NULL, 81);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330513', '3308', 'RJ', '3390', '3301', '33002', '33', 'SAO JOSE DE UBA', NULL, '22', '28455000', '3', '0784', NULL, '17089', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 250.596, '-21,35800', '-41,94300', 95, 'S', 0.7180, NULL, NULL, '33900', 'N', 'N', 4703, NULL, '3390', '3390', NULL, '1997', 'S', 3657, 'SÃO JOSÉ DE UBÁ', 'N', '330513', 'N', 'N', 'S', NULL, 62, 'N', 'N', 'N', '76', NULL, '03', 'N', NULL, NULL, NULL, 36);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330515', '3310', 'RJ', '3390', '3306', '33015', '33', 'SAO JOSE DO VALE DO RIO PRETO', NULL, '24', '25780000', '8', '6009', '6009', '17068', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 239.950, '-22,15100', '-42,92400', 615, 'S', 0.7200, NULL, NULL, '33900', 'N', 'N', 4733, NULL, '3390', '3390', NULL, '1989', 'S', 3658, 'SÃO JOSÉ DO VALE DO RIO PRETO', 'N', '330515', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '77', NULL, '03', 'N', NULL, NULL, NULL, 376);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330520', '3302', 'RJ', '3390', '3304', '33010', '33', 'SAO PEDRO DA ALDEIA', NULL, '22', '28940000', '8', '5903', '5903', '17052', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 339.647, '-22,83900', '-42,10300', 5, 'S', 0.7800, NULL, NULL, '33900', 'N', 'N', 4802, NULL, '3390', '3302', NULL, '1892', 'S', 3659, 'SÃO PEDRO DA ALDEIA', 'N', '330520', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '78', NULL, '02', 'N', NULL, NULL, NULL, 35);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330530', '3310', 'RJ', '3390', '3303', '33008', '33', 'SAO SEBASTIAO DO ALTO', NULL, '22', '28555000', '7', '5905', '5905', '17053', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 397.180, '-21,95700', '-42,13500', 575, 'S', 0.7230, NULL, NULL, '33900', 'N', 'N', 4835, NULL, '3390', '3390', NULL, '1891', 'S', 3660, 'SÃO SEBASTIÃO DO ALTO', 'N', '330530', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '79', NULL, '03', 'N', NULL, NULL, NULL, 376);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330540', '3304', 'RJ', '3390', '3303', '33005', '33', 'SAPUCAIA', NULL, '24', '25880000', '6', '5907', '5907', '17054', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 540.350, '-21,99500', '-42,91400', 221, 'S', 0.7420, NULL, NULL, '33900', 'N', 'N', 4872, NULL, '3390', '3390', NULL, '1874', 'S', 3661, 'SAPUCAIA', 'N', '330540', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '80', NULL, '03', 'N', NULL, NULL, NULL, 269);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330550', '3302', 'RJ', '3390', '3304', '33010', '33', 'SAQUAREMA', NULL, '22', '28990000', '5', '5909', '5909', '17055', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 354.675, '-22,92000', '-42,51000', 10, 'S', 0.7620, NULL, NULL, '33900', 'N', 'N', 4875, NULL, '3390', '3301', NULL, '1841', 'S', 3662, 'SAQUAREMA', 'N', '330550', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '81', NULL, '02', 'N', NULL, NULL, NULL, 35);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330555', '3306', 'RJ', '3390', '3306', '33017', '33', 'SEROPEDICA', NULL, '21', '23890000', '4', '0786', NULL, '17090', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 283.794, '-22,74400', '-43,70800', 26, 'S', 0.7590, NULL, NULL, '33900', 'N', 'N', 4932, NULL, '3301', '3301', NULL, '1997', 'S', 3663, 'SEROPÉDICA', 'N', '330555', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '82', NULL, '01', 'N', NULL, NULL, NULL, 81);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330560', '3307', 'RJ', '3390', '3304', '33009', '33', 'SILVA JARDIM', NULL, '22', '28820000', '4', '5911', '5911', '17056', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 938.336, '-22,65100', '-42,39200', 35, 'S', 0.7310, NULL, NULL, '33900', 'N', 'N', 4986, NULL, '3390', '3390', NULL, '1841', 'S', 3664, 'SILVA JARDIM', 'N', '330560', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '83', NULL, '03', 'N', NULL, NULL, NULL, 206);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330570', '3310', 'RJ', '3390', '3303', '33007', '33', 'SUMIDOURO', NULL, '22', '28637000', '3', '5913', '5913', '17057', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 395.213, '-22,05000', '-42,67500', 355, 'S', 0.7120, NULL, NULL, '33900', 'N', 'N', 5042, NULL, '3390', '3390', NULL, '1890', 'S', 3665, 'SUMIDOURO', 'N', '330570', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '84', NULL, '03', 'N', NULL, NULL, NULL, 376);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330575', '3307', 'RJ', '3390', '3306', '33018', '33', 'TANGUA', NULL, '21', '24890000', '2', '0788', '0788', '17091', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 146.623, '-22,73000', '-42,71400', 20, 'S', 0.7220, NULL, NULL, '33900', 'N', 'N', 5083, NULL, '3301', '3301', NULL, '1997', 'S', 3666, 'TANGUÁ', 'N', '330575', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '85', NULL, '01', 'N', NULL, NULL, NULL, 206);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330580', '3310', 'RJ', '3390', '3306', '33015', '33', 'TERESOPOLIS', NULL, '21', '45430000', '2', '5915', '5915', '17058', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 770.507, '-22,41200', '-42,96600', 871, 'S', 0.7900, NULL, NULL, '33900', 'N', 'N', 5151, NULL, '3390', '3390', NULL, '1891', 'S', 3667, 'TERESÓPOLIS', 'N', '330580', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '86', NULL, '01', 'N', NULL, NULL, NULL, 376);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330590', '3310', 'RJ', '3390', '3303', '33008', '33', 'TRAJANO DE MORAES', NULL, '22', '28755000', '1', '5917', '5917', '17059', NULL, 'ATIVO', 'N', 'N', NULL, 'TRAJANO DE MORAIS         ', 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 589.397, '-22,06300', '-42,06600', 655, 'S', 0.7230, NULL, NULL, '33900', 'N', 'N', 5212, NULL, '3390', '3390', NULL, '1891', 'S', 3668, 'TRAJANO DE MORAES', 'N', '330590', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '87', NULL, '03', 'N', NULL, NULL, NULL, 376);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330600', '3304', 'RJ', '3390', '3303', '33005', '33', 'TRES RIOS', NULL, '24', '12580970', '8', '5919', '5919', '17060', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 324.496, '-22,11700', '-43,20900', 269, 'S', 0.7820, NULL, NULL, '33900', 'N', 'N', 5232, NULL, '3390', '3390', NULL, '1938', 'S', 3669, 'TRÊS RIOS', 'N', '330600', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '88', NULL, '02', 'N', NULL, NULL, NULL, 269);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330610', '3305', 'RJ', '3390', '3305', '33012', '33', 'VALENCA', NULL, '24', '27657000', '7', '5921', '5921', '17061', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1304.769, '-22,24600', '-43,70000', 560, 'S', 0.7760, NULL, NULL, '33900', 'N', 'N', 5358, NULL, '3390', '3390', NULL, '1823', 'S', 3670, 'VALENÇA', 'N', '330610', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '89', NULL, '02', 'N', NULL, NULL, NULL, 205);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330615', '3308', 'RJ', '3390', '3301', '33001', '33', 'VARRE-SAI', NULL, '22', '28375000', '6', '2917', '2917', '17076', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 188.770, '-20,93100', '-41,86900', 680, 'S', 0.6790, NULL, NULL, '33900', 'S', 'N', 5382, NULL, '3390', '3390', NULL, '1993', 'S', 3671, 'VARRE-SAI', 'N', '330615', 'N', 'N', 'S', NULL, 62, 'N', 'N', 'N', '90', NULL, '03', 'N', NULL, NULL, NULL, 36);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330620', '3304', 'RJ', '3390', '3306', '33014', '33', 'VASSOURAS', NULL, '24', '27700000', '6', '5923', '5923', '17062', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 552.438, '-22,40400', '-43,66300', 434, 'S', 0.7810, NULL, NULL, '33900', 'N', 'N', 5396, NULL, '3390', '3390', NULL, '1833', 'S', 3672, 'VASSOURAS', 'N', '330620', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '91', NULL, '03', 'N', NULL, NULL, NULL, 269);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('330630', '3305', 'RJ', '3390', '3305', '33011', '33', 'VOLTA REDONDA', NULL, '24', '27251970', '5', '5925', '5925', '17063', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 182.317, '-22,52300', '-44,10400', 390, 'S', 0.8150, NULL, NULL, '33900', 'N', 'N', 5484, NULL, '3390', '3303', NULL, '1954', 'S', 3673, 'VOLTA REDONDA', 'N', '330630', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '92', NULL, '01', 'N', NULL, NULL, NULL, 205);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350070', '3506', 'SP', '3509', '3504', '35020', '35', 'AGUDOS', NULL, '14', '17120000', '9', '6113', '6113', '21007', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 967.591, '-22,46900', '-48,98800', 580, 'S', 0.7860, NULL, NULL, '35062', 'N', 'N', 76, NULL, '3590', '3590', NULL, '1898', 'S', 4749, 'AGUDOS', 'N', '350070', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '8', NULL, '03', 'N', NULL, NULL, NULL, 214);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350090', '3505', 'SP', '3513', '3501', '35004', '35', 'ALTAIR', NULL, '17', '15430000', '7', '6117', '6117', '21009', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 316.088, '-20,52400', '-49,05900', 557, 'S', 0.7660, NULL, NULL, '35051', 'N', 'N', 130, NULL, '3590', '3590', NULL, '1959', 'S', 4752, 'ALTAIR', 'N', '350090', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '11', NULL, '03', 'N', NULL, NULL, NULL, 42);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350110', '3502', 'SP', '3512', '3503', '35018', '35', 'ALTO ALEGRE', NULL, '18', '16310000', '3', '6121', '6121', '21011', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 318.216, '-21,58100', '-50,16400', 521, 'S', 0.7740, NULL, NULL, '35023', 'N', 'N', 139, NULL, '3590', '3590', NULL, '1953', 'S', 4754, 'ALTO ALEGRE', 'N', '350110', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '13', NULL, '03', 'N', NULL, NULL, NULL, 157);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350170', '3503', 'SP', '3513', '3505', '35024', '35', 'AMERICO BRASILIENSE', NULL, '16', '14820000', '7', '6133', '6133', '21017', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 123.429, '-21,72400', '-48,10200', 715, 'S', 0.7880, NULL, NULL, '35031', 'N', 'N', 197, NULL, '3590', '3590', NULL, '1964', 'S', 4761, 'AMÉRICO BRASILIENSE', 'N', '350170', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '20', NULL, '03', 'N', NULL, NULL, NULL, 40);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350210', '3502', 'SP', '3512', '3503', '35016', '35', 'ANDRADINA', NULL, '18', '16900000', '1', '6141', '6141', '21021', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 960.095, '-20,89600', '-51,37900', 405, 'S', 0.7980, NULL, NULL, '35022', 'N', 'N', 227, NULL, '3590', '3590', NULL, '1938', 'S', 4765, 'ANDRADINA', 'N', '350210', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '24', NULL, '02', 'N', NULL, NULL, NULL, 95);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350230', '3506', 'SP', '3509', '3504', '35023', '35', 'ANHEMBI', NULL, '14', '18620000', '9', '6145', '6145', '21023', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 736.463, '-22,78900', '-48,12700', 472, 'S', 0.7680, NULL, NULL, '35063', 'N', 'N', 243, NULL, '3590', '3590', NULL, '1891', 'S', 4767, 'ANHEMBI', 'N', '350230', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '26', NULL, '03', 'N', NULL, NULL, NULL, 384);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350280', '3502', 'SP', '3512', '3503', '35017', '35', 'ARACATUBA', NULL, '18', '16001970', '4', '6155', '6155', '21028', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1167.311, '-21,20900', '-50,43300', 390, 'S', 0.8480, NULL, NULL, '35021', 'N', 'N', 296, NULL, '3590', '3504', NULL, '1921', 'S', 4773, 'ARAÇATUBA', 'N', '350280', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '32', NULL, '01', 'N', NULL, NULL, NULL, 156);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350320', '3503', 'SP', '3513', '3505', '35024', '35', 'ARARAQUARA', NULL, '16', '14801970', '8', '6163', '6163', '21032', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1005.968, '-21,79400', '-48,17600', 664, 'S', 0.8300, NULL, NULL, '35031', 'N', 'N', 339, NULL, '3590', '3505', NULL, '1832', 'S', 4778, 'ARARAQUARA', 'N', '350320', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '37', NULL, '01', 'N', NULL, NULL, NULL, 40);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350330', '3510', 'SP', '3514', '3506', '35027', '35', 'ARARAS', NULL, '19', '13600000', '7', '6165', '6165', '21033', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 643.457, '-22,35700', '-47,38400', 629, 'S', 0.8280, NULL, NULL, '35101', 'N', 'N', 340, NULL, '3590', '3508', NULL, '1871', 'S', 4779, 'ARARAS', 'N', '350330', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '38', NULL, '01', 'N', NULL, NULL, NULL, 155);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350340', '3506', 'SP', '3509', '3504', '35020', '35', 'AREALVA', NULL, '14', '17160000', '6', '6167', '6167', '21034', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 506.465, '-22,02900', '-48,91100', 445, 'S', 0.7900, NULL, NULL, '35062', 'N', 'N', 363, NULL, '3590', '3590', NULL, '1948', 'S', 4781, 'AREALVA', 'N', '350340', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '40', NULL, '03', 'N', NULL, NULL, NULL, 214);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350360', '3506', 'SP', '3509', '3504', '35020', '35', 'AREIOPOLIS', NULL, '14', '18670000', '4', '6171', '6171', '21036', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 85.947, '-22,66800', '-48,66500', 635, 'S', 0.7450, NULL, NULL, '35063', 'N', 'N', 370, NULL, '3590', '3590', NULL, '1959', 'S', 4783, 'AREIÓPOLIS', 'N', '350360', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '42', NULL, '03', 'N', NULL, NULL, NULL, 384);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350390', '3501', 'SP', '3502', '3515', '35059', '35', 'ARUJA', NULL, '11', '07400000', '1', '6177', '6177', '21039', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 97.448, '-23,39600', '-46,32100', 775, 'S', 0.7880, NULL, NULL, '35011', 'N', 'N', 397, NULL, '3501', '3501', NULL, '1959', 'S', 4786, 'ARUJÁ', 'N', '350390', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '45', NULL, '01', 'N', NULL, NULL, NULL, 39);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350420', '3502', 'SP', '3512', '3501', '35006', '35', 'AURIFLAMA', NULL, '17', '15350000', '6', '6183', '6183', '21042', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 432.902, '-20,68600', '-50,55500', 482, 'S', 0.7870, NULL, NULL, '35021', 'N', 'N', 425, NULL, '3590', '3590', NULL, '1953', 'S', 4790, 'AURIFLAMA', 'N', '350420', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '49', NULL, '03', 'N', NULL, NULL, NULL, 156);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350430', '3506', 'SP', '3509', '3504', '35020', '35', 'AVAI', NULL, '14', '16680000', '5', '6185', '6185', '21043', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 542.157, '-22,14700', '-49,33300', 481, 'S', 0.7480, NULL, NULL, '35062', 'N', 'N', 432, NULL, '3590', '3590', NULL, '1919', 'S', 4791, 'AVAÍ', 'N', '350430', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '50', NULL, '03', 'N', NULL, NULL, NULL, 214);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350440', '3502', 'SP', '3512', '3503', '35018', '35', 'AVANHANDAVA', NULL, '18', '16360000', '4', '6187', '6187', '21044', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 340.338, '-21,46100', '-49,95000', 428, 'S', 0.7680, NULL, NULL, '35023', 'N', 'N', 433, NULL, '3590', '3590', NULL, '1925', 'S', 4792, 'AVANHANDAVA', 'N', '350440', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '51', NULL, '03', 'N', NULL, NULL, NULL, 157);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350470', '3506', 'SP', '3509', '3504', '35020', '35', 'BALBINOS', NULL, '14', '16640000', '1', '6193', '6193', '21047', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 90.858, '-21,90000', '-49,35700', 460, 'S', 0.7610, NULL, NULL, '35062', 'N', 'N', 457, NULL, '3590', '3590', NULL, '1953', 'S', 4795, 'BALBINOS', 'N', '350470', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '54', NULL, '03', 'N', NULL, NULL, NULL, 214);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350530', '3506', 'SP', '3509', '3504', '35021', '35', 'BARRA BONITA', NULL, '14', '17340000', '2', '6205', '6205', '21053', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 150.178, '-22,49500', '-48,55800', 457, 'S', 0.8200, NULL, NULL, '35064', 'N', 'N', 500, NULL, '3590', '3590', NULL, '1912', 'S', 4801, 'BARRA BONITA', 'N', '350530', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '60', NULL, '03', 'N', NULL, NULL, NULL, 277);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350550', '3505', 'SP', '3513', '3502', '35009', '35', 'BARRETOS', NULL, '17', '14780000', '0', '6209', '6209', '21055', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1563.611, '-20,55700', '-48,56800', 530, 'S', 0.8020, NULL, NULL, '35051', 'N', 'N', 539, NULL, '3590', '3590', NULL, '1885', 'S', 4804, 'BARRETOS', 'N', '350550', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '63', NULL, '01', 'N', NULL, NULL, NULL, 42);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350570', '3501', 'SP', '3505', '3515', '35057', '35', 'BARUERI', NULL, '11', '06402970', '8', '6213', '6213', '21057', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 64.167, '-23,51100', '-46,87600', 719, 'S', 0.8260, NULL, NULL, '35014', 'N', 'N', 549, NULL, '3501', '3501', NULL, '1948', 'S', 4806, 'BARUERI', 'N', '350570', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '65', NULL, '01', 'N', NULL, NULL, NULL, 391);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350580', '3509', 'SP', '3510', '3509', '35037', '35', 'BASTOS', NULL, '14', '17690000', '7', '6215', '6215', '21058', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 170.454, '-21,92200', '-50,73400', 445, 'S', 0.7980, NULL, NULL, '35095', 'N', 'N', 550, NULL, '3590', '3590', NULL, '1944', 'S', 4807, 'BASTOS', 'N', '350580', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '66', NULL, '03', 'N', NULL, NULL, NULL, 221);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350600', '3506', 'SP', '3509', '3504', '35020', '35', 'BAURU', NULL, '14', '17001970', '3', '6219', '6219', '21060', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 673.488, '-22,31500', '-49,06100', 526, 'S', 0.8250, NULL, NULL, '35062', 'N', 'N', 557, NULL, '3590', '3590', NULL, '1896', 'S', 4809, 'BAURU', 'N', '350600', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '68', NULL, '01', 'N', NULL, NULL, NULL, 214);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350610', '3505', 'SP', '3513', '3502', '35013', '35', 'BEBEDOURO', NULL, '17', '14700000', '2', '6221', '6221', '21061', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 682.511, '-20,94900', '-48,47900', 573, 'S', 0.8190, NULL, NULL, '35052', 'N', 'N', 559, NULL, '3590', '3590', NULL, '1894', 'S', 4810, 'BEBEDOURO', 'N', '350610', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '69', NULL, '02', 'N', NULL, NULL, NULL, 220);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350620', '3502', 'SP', '3512', '3503', '35017', '35', 'BENTO DE ABREU', NULL, '18', '16790000', '1', '6223', '6223', '21062', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 301.848, '-21,27100', '-50,81200', 431, 'S', 0.8020, NULL, NULL, '35021', 'N', 'N', 595, NULL, '3590', '3590', NULL, '1948', 'S', 4811, 'BENTO DE ABREU', 'N', '350620', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '70', NULL, '03', 'N', NULL, NULL, NULL, 156);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350635', '3504', 'SP', '3507', '3515', '35063', '35', 'BERTIOGA', NULL, '13', '11250000', '9', '2965', '2965', '21592', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 491.701, '-23,85400', '-46,13900', 8, 'S', 0.7920, NULL, NULL, '35041', 'N', 'N', 605, NULL, '3502', '3502', NULL, '1993', 'S', 4813, 'BERTIOGA', 'N', '350635', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '72', NULL, '01', 'N', NULL, NULL, NULL, 92);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350640', '3502', 'SP', '3512', '3503', '35018', '35', 'BILAC', NULL, '18', '16210000', '9', '6227', '6227', '21064', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 157.278, '-21,40300', '-50,47100', 431, 'S', 0.8090, NULL, NULL, '35021', 'N', 'N', 616, NULL, '3590', '3590', NULL, '1944', 'S', 4814, 'BILAC', 'N', '350640', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '73', NULL, '03', 'N', NULL, NULL, NULL, 156);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350650', '3502', 'SP', '3512', '3503', '35018', '35', 'BIRIGUI', NULL, '18', '16200000', '8', '6229', '6229', '21065', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 530.651, '-21,28900', '-50,34000', 406, 'S', 0.8290, NULL, NULL, '35023', 'N', 'N', 618, NULL, '3590', '3504', NULL, '1921', 'S', 4815, 'BIRIGUI', 'N', '350650', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '74', NULL, '01', 'N', NULL, NULL, NULL, 157);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350660', '3501', 'SP', '3502', '3515', '35062', '35', 'BIRITIBA-MIRIM', NULL, '11', '08940000', '7', '6231', '6231', '21066', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 316.717, '-23,57300', '-46,03900', 780, 'S', 0.7500, NULL, NULL, '35011', 'N', 'N', 619, NULL, '3501', '3501', NULL, '1964', 'S', 4816, 'BIRITIBA-MIRIM', 'N', '350660', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '75', NULL, '01', 'N', NULL, NULL, NULL, 39);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350670', '3503', 'SP', '3513', '3505', '35024', '35', 'BOA ESPERANCA DO SUL', NULL, '16', '14930000', '6', '6233', '6233', '21067', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 691.017, '-21,99300', '-48,39100', 490, 'S', 0.7550, NULL, NULL, '35031', 'N', 'N', 627, NULL, '3590', '3590', NULL, '1898', 'S', 4817, 'BOA ESPERANÇA DO SUL', 'N', '350670', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '76', NULL, '03', 'N', NULL, NULL, NULL, 40);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350810', '3502', 'SP', '3512', '3503', '35018', '35', 'BURITAMA', NULL, '18', '15290000', '8', '6263', '6263', '21082', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 326.638, '-21,06600', '-50,14700', 391, 'S', 0.7900, NULL, NULL, '35023', 'N', 'N', 787, NULL, '3590', '3590', NULL, '1948', 'S', 4834, 'BURITAMA', 'N', '350810', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '93', NULL, '03', 'N', NULL, NULL, NULL, 157);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350830', '3506', 'SP', '3509', '3504', '35020', '35', 'CABRALIA PAULISTA', NULL, '14', '17480000', '6', '6267', '6267', '21084', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 239.210, '-22,45600', '-49,33800', 539, 'S', 0.7430, NULL, NULL, '35062', 'N', 'N', 818, NULL, '3590', '3590', NULL, '1948', 'S', 4836, 'CABRÁLIA PAULISTA', 'N', '350830', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '95', NULL, '03', 'N', NULL, NULL, NULL, 214);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350880', '3506', 'SP', '3509', '3504', '35019', '35', 'CAFELANDIA', NULL, '14', '16500000', '1', '6277', '6277', '21089', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 919.860, '-21,80300', '-49,61000', 445, 'S', 0.7880, NULL, NULL, '35065', 'N', 'N', 864, NULL, '3590', '3590', NULL, '1925', 'S', 4841, 'CAFELÂNDIA', 'N', '350880', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '100', NULL, '03', 'N', NULL, NULL, NULL, 215);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350900', '3501', 'SP', '3503', '3515', '35058', '35', 'CAIEIRAS', NULL, '11', '07700000', '7', '6281', '6281', '21091', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 95.894, '-23,36400', '-46,74100', 785, 'S', 0.8130, NULL, NULL, '35012', 'N', 'N', 876, NULL, '3501', '3501', NULL, '1959', 'S', 4843, 'CAIEIRAS', 'N', '350900', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '102', NULL, '01', 'N', NULL, NULL, NULL, 326);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350920', '3501', 'SP', '3503', '3515', '35057', '35', 'CAJAMAR', NULL, '11', '07750000', '5', '6285', '6285', '21093', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 128.356, '-23,35600', '-46,87700', 735, 'S', 0.7860, NULL, NULL, '35012', 'N', 'N', 879, NULL, '3501', '3501', NULL, '1959', 'S', 4845, 'CAJAMAR', 'N', '350920', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '104', NULL, '01', 'N', NULL, NULL, NULL, 326);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350930', '3505', 'SP', '3513', '3501', '35005', '35', 'CAJOBI', NULL, '17', '15410000', '4', '6287', '6287', '21094', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 176.786, '-20,88000', '-48,80900', 565, 'S', 0.7750, NULL, NULL, '35051', 'N', 'N', 886, NULL, '3590', '3590', NULL, '1926', 'S', 4847, 'CAJOBI', 'N', '350930', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '106', NULL, '03', 'N', NULL, NULL, NULL, 42);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351010', '3503', 'SP', '3513', '3502', '35013', '35', 'CANDIDO RODRIGUES', NULL, '16', '15930000', '4', '6303', '6303', '21102', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 69.523, '-21,32500', '-48,63100', 610, 'S', 0.7760, NULL, NULL, '35033', 'N', 'N', 1010, NULL, '3590', '3590', NULL, '1959', 'S', 4857, 'CÂNDIDO RODRIGUES', 'N', '351010', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '116', NULL, '03', 'N', NULL, NULL, NULL, 97);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('350970', '3517', 'SP', '3517', '3513', '35049', '35', 'CAMPOS DO JORDAO', NULL, '12', '12460000', '0', '6295', '6295', '21098', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 289.512, '-22,73900', '-45,59100', 1628, 'S', 0.8200, NULL, NULL, '35174', 'N', 'N', 978, NULL, '3590', '3590', NULL, '1935', 'S', 4852, 'CAMPOS DO JORDÃO', 'N', '350970', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '111', NULL, '03', 'N', NULL, NULL, NULL, 518);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351060', '3501', 'SP', '3505', '3515', '35057', '35', 'CARAPICUIBA', NULL, '11', '06320970', '9', '6313', '6313', '21107', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 34.967, '-23,52300', '-46,83600', 770, 'S', 0.7930, NULL, NULL, '35014', 'N', 'N', 1082, NULL, '3501', '3501', NULL, '1964', 'S', 4863, 'CARAPICUÍBA', 'N', '351060', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '122', NULL, '01', 'N', NULL, NULL, NULL, 391);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351100', '3502', 'SP', '3512', '3503', '35016', '35', 'CASTILHO', NULL, '18', '16920000', '3', '6321', '6321', '21111', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1062.653, '-20,87200', '-51,48800', 365, 'S', 0.7600, NULL, NULL, '35022', 'N', 'N', 1161, NULL, '3590', '3590', NULL, '1953', 'S', 4867, 'CASTILHO', 'N', '351100', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '126', NULL, '03', 'N', NULL, NULL, NULL, 95);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351190', '3502', 'SP', '3512', '3503', '35018', '35', 'CLEMENTINA', NULL, '18', '16250000', '4', '6339', '6339', '21120', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 168.739, '-21,56000', '-50,44900', 465, 'S', 0.7920, NULL, NULL, '35023', 'N', 'N', 1268, NULL, '3590', '3590', NULL, '1953', 'S', 4876, 'CLEMENTINA', 'N', '351190', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '135', NULL, '03', 'N', NULL, NULL, NULL, 157);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351200', '3505', 'SP', '3513', '3502', '35009', '35', 'COLINA', NULL, '17', '14770000', '1', '6341', '6341', '21121', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 423.963, '-20,71300', '-48,54100', 595, 'S', 0.8130, NULL, NULL, '35051', 'N', 'N', 1288, NULL, '3590', '3590', NULL, '1925', 'S', 4877, 'COLINA', 'N', '351200', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '136', NULL, '03', 'N', NULL, NULL, NULL, 42);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351210', '3505', 'SP', '3513', '3502', '35009', '35', 'COLOMBIA', NULL, '17', '14795000', '0', '6343', '6343', '21122', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 729.252, '-20,17600', '-48,68900', 492, 'S', 0.7630, NULL, NULL, '35051', 'N', 'N', 1294, NULL, '3590', '3590', NULL, '1959', 'S', 4878, 'COLÔMBIA', 'N', '351210', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '137', NULL, '03', 'N', NULL, NULL, NULL, 42);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351230', '3506', 'SP', '3509', '3504', '35023', '35', 'CONCHAS', NULL, '14', '18570000', '8', '6347', '6347', '21124', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 468.243, '-23,01500', '-48,01100', 503, 'S', 0.7960, NULL, NULL, '35063', 'N', 'N', 1330, NULL, '3590', '3590', NULL, '1916', 'S', 4880, 'CONCHAS', 'N', '351230', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '139', NULL, '03', 'N', NULL, NULL, NULL, 384);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351250', '3502', 'SP', '3512', '3503', '35018', '35', 'COROADOS', NULL, '18', '16260000', '6', '6351', '6351', '21126', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 246.544, '-21,35200', '-50,28100', 409, 'S', 0.8020, NULL, NULL, '35023', 'N', 'N', 1375, NULL, '3590', '3590', NULL, '1928', 'S', 4882, 'COROADOS', 'N', '351250', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '141', NULL, '03', 'N', NULL, NULL, NULL, 157);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351300', '3501', 'SP', '3504', '3515', '35060', '35', 'COTIA', NULL, '11', '06700000', '9', '6361', '6361', '21131', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 323.891, '-23,60400', '-46,91900', 853, 'S', 0.8260, NULL, NULL, '35013', 'N', 'N', 1417, NULL, '3501', '3501', NULL, '1856', 'S', 4887, 'COTIA', 'N', '351300', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '146', NULL, '01', 'N', NULL, NULL, NULL, 161);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351350', '3504', 'SP', '3507', '3515', '35063', '35', 'CUBATAO', NULL, '13', '11510970', '4', '6371', '6371', '21136', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 142.281, '-23,89500', '-46,42500', 4, 'S', 0.7720, NULL, NULL, '35041', 'N', 'N', 1469, NULL, '3502', '3502', NULL, '1948', 'S', 4892, 'CUBATÃO', 'N', '351350', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '151', NULL, '01', 'N', NULL, NULL, NULL, 92);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351400', '3503', 'SP', '3513', '3505', '35024', '35', 'DOBRADA', NULL, '16', '15980000', '7', '6381', '6381', '21141', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 150.085, '-21,51700', '-48,39400', 575, 'S', 0.7450, NULL, NULL, '35033', 'N', 'N', 1559, NULL, '3590', '3590', NULL, '1964', 'S', 4898, 'DOBRADA', 'N', '351400', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '157', NULL, '03', 'N', NULL, NULL, NULL, 97);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351410', '3506', 'SP', '3509', '3504', '35021', '35', 'DOIS CORREGOS', NULL, '14', '17300000', '6', '6383', '6383', '21142', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 632.559, '-22,36600', '-48,38000', 673, 'S', 0.7860, NULL, NULL, '35064', 'N', 'N', 1560, NULL, '3590', '3590', NULL, '1874', 'S', 4899, 'DOIS CÓRREGOS', 'N', '351410', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '158', NULL, '03', 'N', NULL, NULL, NULL, 277);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351450', '3506', 'SP', '3509', '3504', '35020', '35', 'DUARTINA', NULL, '14', '17470000', '2', '6391', '6391', '21146', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 264.281, '-22,41400', '-49,40400', 520, 'S', 0.7750, NULL, NULL, '35062', 'N', 'N', 1610, NULL, '3590', '3590', NULL, '1926', 'S', 4903, 'DUARTINA', 'N', '351450', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '162', NULL, '03', 'N', NULL, NULL, NULL, 214);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351500', '3501', 'SP', '3504', '3515', '35060', '35', 'EMBU', NULL, '11', '06801970', '4', '6401', '6401', '21151', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 70.079, '-23,64900', '-46,85200', 775, 'S', 0.7720, NULL, NULL, '35013', 'N', 'N', 1635, NULL, '3501', '3501', NULL, '1959', 'S', 4910, 'EMBU DAS ARTES', 'N', '351500', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '169', NULL, '01', 'N', NULL, NULL, NULL, 161);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351510', '3501', 'SP', '3504', '3515', '35060', '35', 'EMBU-GUACU', NULL, '11', '06900000', '3', '6403', '6403', '21152', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 155.036, '-23,83200', '-46,81100', 742, 'S', 0.8110, NULL, NULL, '35013', 'N', 'N', 1636, NULL, '3501', '3501', NULL, '1959', 'S', 4911, 'EMBU-GUAÇU', 'N', '351510', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '170', NULL, '01', 'N', NULL, NULL, NULL, 161);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351570', '3501', 'SP', '3502', '3515', '35062', '35', 'FERRAZ DE VASCONCELOS', NULL, '11', '08529900', '7', '6415', '6415', '21158', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 30.071, '-23,54100', '-46,36900', 755, 'S', 0.7720, NULL, NULL, '35011', 'N', 'N', 1758, NULL, '3501', '3501', NULL, '1953', 'S', 4924, 'FERRAZ DE VASCONCELOS', 'N', '351570', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '183', NULL, '01', 'N', NULL, NULL, NULL, 39);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351630', '3501', 'SP', '3503', '3515', '35058', '35', 'FRANCISCO MORATO', NULL, '11', '07790000', '9', '6427', '6427', '21164', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 49.164, '-23,28200', '-46,74500', 792, 'S', 0.7380, NULL, NULL, '35012', 'N', 'N', 1828, NULL, '3501', '3501', NULL, '1964', 'S', 4930, 'FRANCISCO MORATO', 'N', '351630', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '189', NULL, '01', 'N', NULL, NULL, NULL, 326);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351640', '3501', 'SP', '3503', '3515', '35058', '35', 'FRANCO DA ROCHA', NULL, '11', '07780000', '8', '6429', '6429', '21165', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 133.931, '-23,32200', '-46,72700', 740, 'S', 0.7780, NULL, NULL, '35012', 'N', 'N', 1832, NULL, '3501', '3501', NULL, '1944', 'S', 4931, 'FRANCO DA ROCHA', 'N', '351640', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '190', NULL, '01', 'N', NULL, NULL, NULL, 326);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351650', '3502', 'SP', '3512', '3503', '35018', '35', 'GABRIEL MONTEIRO', NULL, '18', '16220000', '7', '6431', '6431', '21166', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 138.533, '-21,53100', '-50,55500', 436, 'S', 0.7680, NULL, NULL, '35023', 'N', 'N', 1850, NULL, '3590', '3590', NULL, '1959', 'S', 4932, 'GABRIEL MONTEIRO', 'N', '351650', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '191', NULL, '03', 'N', NULL, NULL, NULL, 157);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351685', '3503', 'SP', '3513', '3505', '35024', '35', 'GAVIAO PEIXOTO', NULL, '16', '14813000', '3', '0798', '0798', '21632', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 243.711, '-21,83900', '-48,49500', 515, 'S', 0.7630, NULL, NULL, '35031', 'N', 'N', 1872, NULL, '3590', '3590', NULL, '1997', 'S', 4936, 'GAVIÃO PEIXOTO', 'N', '351685', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '195', NULL, '03', 'N', NULL, NULL, NULL, 40);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351700', '3506', 'SP', '3509', '3504', '35019', '35', 'GETULINA', NULL, '14', '16450000', '0', '6441', '6441', '21171', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 675.428, '-21,79900', '-49,92900', 487, 'S', 0.7700, NULL, NULL, '35065', 'N', 'N', 1882, NULL, '3590', '3590', NULL, '1935', 'S', 4938, 'GETULINA', 'N', '351700', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '197', NULL, '03', 'N', NULL, NULL, NULL, 215);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351710', '3502', 'SP', '3512', '3503', '35018', '35', 'GLICERIO', NULL, '18', '16270000', '9', '6443', '6443', '21172', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 274.124, '-21,38400', '-50,21100', 400, 'S', 0.7610, NULL, NULL, '35023', 'N', 'N', 1888, NULL, '3590', '3590', NULL, '1925', 'S', 4939, 'GLICÉRIO', 'N', '351710', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '198', NULL, '03', 'N', NULL, NULL, NULL, 157);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351720', '3506', 'SP', '3509', '3504', '35019', '35', 'GUAICARA', NULL, '14', '16430000', '8', '6445', '6445', '21173', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 269.300, '-21,62200', '-49,79900', 461, 'S', 0.7780, NULL, NULL, '35065', 'N', 'N', 1954, NULL, '3590', '3590', NULL, '1953', 'S', 4940, 'GUAIÇARA', 'N', '351720', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '199', NULL, '03', 'N', NULL, NULL, NULL, 215);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351740', '3505', 'SP', '3513', '3502', '35010', '35', 'GUAIRA', NULL, '17', '14790000', '6', '6449', '6449', '21175', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1258.671, '-20,31800', '-48,31100', 517, 'S', 0.8220, NULL, NULL, '35051', 'N', 'N', 1956, NULL, '3590', '3590', NULL, '1928', 'S', 4942, 'GUAÍRA', 'N', '351740', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '201', NULL, '03', 'N', NULL, NULL, NULL, 42);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351780', '3502', 'SP', '3512', '3503', '35016', '35', 'GUARACAI', NULL, '18', '16980000', '2', '6457', '6457', '21179', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 568.397, '-21,02800', '-51,20700', 440, 'S', 0.7710, NULL, NULL, '35022', 'N', 'N', 1977, NULL, '3590', '3590', NULL, '1948', 'S', 4946, 'GUARAÇAÍ', 'N', '351780', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '205', NULL, '03', 'N', NULL, NULL, NULL, 95);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351790', '3505', 'SP', '3513', '3501', '35004', '35', 'GUARACI', NULL, '17', '15420000', '1', '6459', '6459', '21180', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 638.820, '-20,49900', '-48,94500', 481, 'S', 0.7580, NULL, NULL, '35051', 'N', 'N', 1978, NULL, '3590', '3590', NULL, '1944', 'S', 4947, 'GUARACI', 'N', '351790', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '206', NULL, '03', 'N', NULL, NULL, NULL, 42);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351820', '3502', 'SP', '3512', '3503', '35017', '35', 'GUARARAPES', NULL, '18', '16700000', '6', '6465', '6465', '21183', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 956.580, '-21,26100', '-50,64300', 415, 'S', 0.8020, NULL, NULL, '35021', 'N', 'N', 2000, NULL, '3590', '3590', NULL, '1937', 'S', 4950, 'GUARARAPES', 'N', '351820', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '209', NULL, '03', 'N', NULL, NULL, NULL, 156);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351830', '3501', 'SP', '3502', '3515', '35062', '35', 'GUARAREMA', NULL, '11', '08900000', '5', '6467', '6467', '21184', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 270.496, '-23,41500', '-46,03500', 585, 'S', 0.7980, NULL, NULL, '35011', 'N', 'N', 2001, NULL, '3501', '3501', NULL, '1898', 'S', 4951, 'GUARAREMA', 'N', '351830', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '210', NULL, '01', 'N', NULL, NULL, NULL, 39);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351870', '3504', 'SP', '3507', '3515', '35063', '35', 'GUARUJA', NULL, '13', '11401970', '1', '6475', '6475', '21188', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 142.589, '-23,99300', '-46,25600', 4, 'S', 0.7880, NULL, NULL, '35041', 'N', 'N', 2010, NULL, '3502', '3502', NULL, '1934', 'S', 4955, 'GUARUJÁ', 'N', '351870', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '214', NULL, '01', 'N', NULL, NULL, NULL, 92);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351880', '3501', 'SP', '3502', '3515', '35059', '35', 'GUARULHOS', NULL, '11', '07001970', '0', '6477', '6477', '21189', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 318.014, '-23,46300', '-46,53300', 759, 'S', 0.7980, NULL, NULL, '35011', 'N', 'N', 2012, NULL, '3501', '3501', NULL, '1880', 'S', 4956, 'GUARULHOS', 'N', '351880', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '215', NULL, '01', 'N', NULL, NULL, NULL, 39);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351890', '3502', 'SP', '3512', '3501', '35006', '35', 'GUZOLANDIA', NULL, '17', '15355000', '9', '6479', '6479', '21190', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 253.669, '-20,65000', '-50,66200', 465, 'S', 0.7290, NULL, NULL, '35021', 'N', 'N', 2027, NULL, '3590', '3590', NULL, '1964', 'S', 4958, 'GUZOLÂNDIA', 'N', '351890', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '217', NULL, '03', 'N', NULL, NULL, NULL, 156);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351910', '3506', 'SP', '3509', '3504', '35020', '35', 'IACANGA', NULL, '14', '17180000', '5', '6483', '6483', '21192', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 548.029, '-21,89000', '-49,02500', 422, 'S', 0.7790, NULL, NULL, '35062', 'N', 'N', 2049, NULL, '3590', '3590', NULL, '1924', 'S', 4962, 'IACANGA', 'N', '351910', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '221', NULL, '03', 'N', NULL, NULL, NULL, 214);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('351960', '3503', 'SP', '3513', '3505', '35024', '35', 'IBITINGA', NULL, '16', '14940000', '0', '6493', '6493', '21197', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 688.676, '-21,75800', '-48,82900', 491, 'S', 0.7890, NULL, NULL, '35032', 'N', 'N', 2096, NULL, '3590', '3590', NULL, '1890', 'S', 4968, 'IBITINGA', 'N', '351960', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '227', NULL, '02', 'N', NULL, NULL, NULL, 325);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352000', '3506', 'SP', '3509', '3504', '35021', '35', 'IGARACU DO TIETE', NULL, '14', '17350000', '4', '6501', '6501', '21201', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 96.618, '-22,50900', '-48,55800', 498, 'S', 0.7700, NULL, NULL, '35064', 'N', 'N', 2116, NULL, '3590', '3590', NULL, '1953', 'S', 4972, 'IGARAÇU DO TIETÊ', 'N', '352000', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '231', NULL, '03', 'N', NULL, NULL, NULL, 277);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352044', '3502', 'SP', '3512', '3503', '35016', '35', 'ILHA SOLTEIRA', NULL, '18', '15385000', '2', '2943', '2943', '21603', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 659.379, '-20,43300', '-51,34300', 0, 'S', 0.8500, NULL, NULL, '35022', 'N', 'N', 2144, NULL, '3590', '3590', NULL, '1993', 'S', 4977, 'ILHA SOLTEIRA', 'N', '352044', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '236', NULL, '03', 'N', NULL, NULL, NULL, 95);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352210', '3504', 'SP', '3507', '3514', '35056', '35', 'ITANHAEM', NULL, '13', '11740000', '9', '6543', '6543', '21222', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 599.017, '-24,18300', '-46,78900', 5, 'S', 0.7790, NULL, NULL, '35041', 'N', 'N', 2322, NULL, '3502', '3502', NULL, '1561', 'S', 4996, 'ITANHAÉM', 'N', '352210', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '255', NULL, '01', 'N', NULL, NULL, NULL, 92);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352220', '3501', 'SP', '3504', '3515', '35060', '35', 'ITAPECERICA DA SERRA', NULL, '11', '06850000', '8', '6545', '6545', '21223', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 151.458, '-23,71700', '-46,84900', 906, 'S', 0.7830, NULL, NULL, '35013', 'N', 'N', 2336, NULL, '3501', '3501', NULL, '1877', 'S', 4998, 'ITAPECERICA DA SERRA', 'N', '352220', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '257', NULL, '01', 'N', NULL, NULL, NULL, 161);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352250', '3501', 'SP', '3505', '3515', '35057', '35', 'ITAPEVI', NULL, '11', '06651970', '5', '6551', '6551', '21226', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 91.353, '-23,54900', '-46,93400', 770, 'S', 0.7590, NULL, NULL, '35014', 'N', 'N', 2348, NULL, '3501', '3501', NULL, '1959', 'S', 5001, 'ITAPEVI', 'N', '352250', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '260', NULL, '01', 'N', NULL, NULL, NULL, 391);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352270', '3503', 'SP', '3513', '3505', '35024', '35', 'ITAPOLIS', NULL, '16', '14900000', '3', '6555', '6555', '21228', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 997.126, '-21,59600', '-48,81300', 481, 'S', 0.7850, NULL, NULL, '35032', 'N', 'N', 2361, NULL, '3590', '3590', NULL, '1891', 'S', 5004, 'ITÁPOLIS', 'N', '352270', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '263', NULL, '03', 'N', NULL, NULL, NULL, 325);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352290', '3506', 'SP', '3509', '3504', '35021', '35', 'ITAPUI', NULL, '14', '17230000', '1', '6559', '6559', '21230', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 139.666, '-22,23300', '-48,71900', 456, 'S', 0.7740, NULL, NULL, '35064', 'N', 'N', 2370, NULL, '3590', '3590', NULL, '1913', 'S', 5006, 'ITAPUÍ', 'N', '352290', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '265', NULL, '03', 'N', NULL, NULL, NULL, 277);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352300', '3502', 'SP', '3512', '3503', '35016', '35', 'ITAPURA', NULL, '18', '15390000', '8', '6561', '6561', '21231', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 307.265, '-20,64600', '-51,50900', 318, 'S', 0.7390, NULL, NULL, '35022', 'N', 'N', 2371, NULL, '3590', '3590', NULL, '1964', 'S', 5007, 'ITAPURA', 'N', '352300', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '266', NULL, '03', 'N', NULL, NULL, NULL, 95);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352310', '3501', 'SP', '3502', '3515', '35062', '35', 'ITAQUAQUECETUBA', NULL, '11', '08570970', '7', '6563', '6563', '21232', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 81.777, '-23,48600', '-46,34800', 790, 'S', 0.7440, NULL, NULL, '35011', 'N', 'N', 2373, NULL, '3501', '3501', NULL, '1953', 'S', 5008, 'ITAQUAQUECETUBA', 'N', '352310', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '267', NULL, '01', 'N', NULL, NULL, NULL, 39);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352330', '3512', 'SP', '3507', '3514', '35056', '35', 'ITARIRI', NULL, '13', '11760000', '5', '6567', '6567', '21234', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 272.777, '-24,28900', '-47,17400', 55, 'S', 0.7500, NULL, NULL, '35121', 'N', 'N', 2382, NULL, '3590', '3590', NULL, '1948', 'S', 5010, 'ITARIRI', 'N', '352330', 'N', 'N', 'S', NULL, 100, 'N', 'N', 'N', '269', NULL, '03', 'N', NULL, NULL, NULL, 222);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352350', '3506', 'SP', '3509', '3504', '35022', '35', 'ITATINGA', NULL, '14', '18690000', '3', '6571', '6571', '21236', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 979.872, '-23,10200', '-48,61600', 845, 'S', 0.7590, NULL, NULL, '35063', 'N', 'N', 2389, NULL, '3590', '3590', NULL, '1896', 'S', 5012, 'ITATINGA', 'N', '352350', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '271', NULL, '03', 'N', NULL, NULL, NULL, 384);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352420', '3505', 'SP', '3513', '3502', '35010', '35', 'JABORANDI', NULL, '17', '14775000', '4', '6585', '6585', '21243', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 274.219, '-20,68800', '-48,41300', 493, 'S', 0.7600, NULL, NULL, '35051', 'N', 'N', 2435, NULL, '3590', '3590', NULL, '1948', 'S', 5019, 'JABORANDI', 'N', '352420', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '278', NULL, '03', 'N', NULL, NULL, NULL, 42);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352500', '3501', 'SP', '3505', '3515', '35057', '35', 'JANDIRA', NULL, '11', '06600000', '3', '6601', '6601', '21251', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 17.523, '-23,52800', '-46,90300', 720, 'S', 0.8010, NULL, NULL, '35014', 'N', 'N', 2485, NULL, '3501', '3501', NULL, '1964', 'S', 5027, 'JANDIRA', 'N', '352500', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '286', NULL, '01', 'N', NULL, NULL, NULL, 391);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352530', '3506', 'SP', '3509', '3504', '35021', '35', 'JAU', NULL, '14', '17201970', '0', '6607', '6607', '21254', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 688.337, '-22,29600', '-48,55800', 522, 'S', 0.8190, NULL, NULL, '35064', 'N', 'N', 2528, NULL, '3590', '3590', NULL, '1866', 'S', 5030, 'JAÚ', 'N', '352530', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '289', NULL, '01', 'N', NULL, NULL, NULL, 277);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352620', '3501', 'SP', '3504', '3515', '35060', '35', 'JUQUITIBA', NULL, '11', '06950000', '9', '6625', '6625', '21263', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 521.598, '-23,93200', '-47,06800', 685, 'S', 0.7540, NULL, NULL, '35013', 'N', 'N', 2615, NULL, '3501', '3501', NULL, '1964', 'S', 5040, 'JUQUITIBA', 'N', '352620', 'N', 'N', 'S', NULL, 100, 'N', 'N', 'N', '299', NULL, '01', 'N', NULL, NULL, NULL, 161);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352640', '3506', 'SP', '3509', '3511', '35043', '35', 'LARANJAL PAULISTA', NULL, '15', '18500000', '7', '6629', '6629', '21265', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 386.763, '-23,05000', '-47,83700', 536, 'S', 0.7990, NULL, NULL, '35063', 'N', 'N', 2710, NULL, '3590', '3590', NULL, '1944', 'S', 5042, 'LARANJAL PAULISTA', 'N', '352640', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '301', NULL, '03', 'N', NULL, NULL, NULL, 384);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352650', '3502', 'SP', '3512', '3503', '35017', '35', 'LAVINIA', NULL, '18', '16850000', '6', '6631', '6631', '21266', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 538.523, '-21,16800', '-51,04000', 458, 'S', 0.7650, NULL, NULL, '35022', 'N', 'N', 2719, NULL, '3590', '3590', NULL, '1944', 'S', 5043, 'LAVÍNIA', 'N', '352650', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '302', NULL, '03', 'N', NULL, NULL, NULL, 95);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352680', '3506', 'SP', '3509', '3504', '35020', '35', 'LENCOIS PAULISTA', NULL, '14', '18682970', '3', '6637', '6637', '21269', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 803.860, '-22,59900', '-48,80000', 550, 'S', 0.8130, NULL, NULL, '35062', 'N', 'N', 2729, NULL, '3590', '3590', NULL, '1865', 'S', 5046, 'LENÇÓIS PAULISTA', 'N', '352680', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '305', NULL, '02', 'N', NULL, NULL, NULL, 214);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352710', '3506', 'SP', '3509', '3504', '35019', '35', 'LINS', NULL, '14', '16400000', '8', '6643', '6643', '21272', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 571.442, '-21,67900', '-49,74300', 437, 'S', 0.8270, NULL, NULL, '35065', 'N', 'N', 2752, NULL, '3590', '3590', NULL, '1919', 'S', 5049, 'LINS', 'N', '352710', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '308', NULL, '02', 'N', NULL, NULL, NULL, 215);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352725', '3502', 'SP', '3512', '3503', '35018', '35', 'LOURDES', NULL, '18', '15285000', '6', '2937', '2937', '21622', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 113.833, '-20,96700', '-50,22400', 403, 'S', 0.7370, NULL, NULL, '35023', 'N', 'N', 2764, NULL, '3590', '3590', NULL, '1993', 'S', 5051, 'LOURDES', 'N', '352725', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '310', NULL, '03', 'N', NULL, NULL, NULL, 157);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352750', '3506', 'SP', '3509', '3504', '35020', '35', 'LUCIANOPOLIS', NULL, '14', '17475000', '4', '6651', '6651', '21276', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 190.908, '-22,43100', '-49,52300', 561, 'S', 0.7540, NULL, NULL, '35062', 'N', 'N', 2769, NULL, '3590', '3590', NULL, '1953', 'S', 5054, 'LUCIANÓPOLIS', 'N', '352750', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '313', NULL, '03', 'N', NULL, NULL, NULL, 214);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352770', '3502', 'SP', '3512', '3503', '35018', '35', 'LUIZIANIA', NULL, '18', '16340000', '2', '6655', '6655', '21278', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 167.008, '-21,67600', '-50,32700', 426, 'S', 0.7620, NULL, NULL, '35023', 'N', 'N', 2780, NULL, '3590', '3590', NULL, '1958', 'S', 5056, 'LUIZIÂNIA', 'N', '352770', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '315', NULL, '03', 'N', NULL, NULL, NULL, 157);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352800', '3506', 'SP', '3509', '3504', '35021', '35', 'MACATUBA', NULL, '14', '17290000', '7', '6661', '6661', '21281', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 226.182, '-22,50200', '-48,71100', 515, 'S', 0.7770, NULL, NULL, '35062', 'N', 'N', 2799, NULL, '3590', '3590', NULL, '1924', 'S', 5059, 'MACATUBA', 'N', '352800', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '318', NULL, '03', 'N', NULL, NULL, NULL, 214);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352850', '3501', 'SP', '3503', '3515', '35058', '35', 'MAIRIPORA', NULL, '11', '07600000', '2', '6671', '6671', '21286', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 321.480, '-23,31900', '-46,58700', 750, 'S', 0.8030, NULL, NULL, '35012', 'N', 'N', 2828, NULL, '3501', '3501', NULL, '1889', 'S', 5064, 'MAIRIPORÃ', 'N', '352850', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '323', NULL, '01', 'N', NULL, NULL, NULL, 326);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352630', '3517', 'SP', '3517', '3513', '35053', '35', 'LAGOINHA', NULL, '12', '12130000', '8', '6627', '6627', '21264', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 255.924, '-23,09100', '-45,19000', 913, 'S', 0.7520, NULL, NULL, '35174', 'N', 'N', 2681, NULL, '3590', '3590', NULL, '1953', 'S', 5041, 'LAGOINHA', 'N', '352630', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '300', NULL, '03', 'N', NULL, NULL, NULL, 518);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352930', '3503', 'SP', '3513', '3505', '35024', '35', 'MATAO', NULL, '16', '15990000', '2', '6687', '6687', '21294', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 527.012, '-21,60300', '-48,36600', 585, 'S', 0.8060, NULL, NULL, '35033', 'N', 'N', 2961, NULL, '3590', '3590', NULL, '1898', 'S', 5073, 'MATÃO', 'N', '352930', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '332', NULL, '02', 'N', NULL, NULL, NULL, 97);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('352980', '3506', 'SP', '3509', '3504', '35021', '35', 'MINEIROS DO TIETE', NULL, '14', '17320000', '7', '6697', '6697', '21299', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 211.892, '-22,40900', '-48,45100', 669, 'S', 0.7880, NULL, NULL, '35064', 'N', 'N', 3035, NULL, '3590', '3590', NULL, '1898', 'S', 5079, 'MINEIROS DO TIETÊ', 'N', '352980', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '338', NULL, '03', 'N', NULL, NULL, NULL, 277);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353010', '3502', 'SP', '3512', '3503', '35016', '35', 'MIRANDOPOLIS', NULL, '18', '16800000', '2', '6703', '6703', '21302', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 918.269, '-21,13400', '-51,10200', 429, 'S', 0.7970, NULL, NULL, '35022', 'N', 'N', 3051, NULL, '3590', '3590', NULL, '1944', 'S', 5082, 'MIRANDÓPOLIS', 'N', '353010', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '341', NULL, '03', 'N', NULL, NULL, NULL, 95);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353060', '3501', 'SP', '3502', '3515', '35062', '35', 'MOGI DAS CRUZES', NULL, '11', '08701970', '7', '6713', '6713', '21307', NULL, 'ATIVO', 'N', 'N', NULL, 'MOJI DAS CRUZES           ', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 714.156, '-23,52300', '-46,18800', 742, 'S', 0.8010, NULL, NULL, '35011', 'N', 'N', 3075, NULL, '3501', '3501', NULL, '1611', 'S', 5087, 'MOGI DAS CRUZES', 'N', '353060', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '346', NULL, '01', 'N', NULL, NULL, NULL, 39);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353110', '3504', 'SP', '3507', '3514', '35056', '35', 'MONGAGUA', NULL, '13', '11730000', '0', '6723', '6723', '21312', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 143.171, '-24,08700', '-46,62900', 18, 'S', 0.7830, NULL, NULL, '35041', 'N', 'N', 3083, NULL, '3502', '3502', NULL, '1959', 'S', 5092, 'MONGAGUÁ', 'N', '353110', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '351', NULL, '01', 'N', NULL, NULL, NULL, 92);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353150', '3505', 'SP', '3513', '3502', '35013', '35', 'MONTE AZUL PAULISTA', NULL, '17', '14730000', '6', '6731', '6731', '21316', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 263.492, '-20,90700', '-48,64100', 611, 'S', 0.7760, NULL, NULL, '35052', 'N', 'N', 3105, NULL, '3590', '3590', NULL, '1914', 'S', 5096, 'MONTE AZUL PAULISTA', 'N', '353150', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '355', NULL, '03', 'N', NULL, NULL, NULL, 220);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353160', '3511', 'SP', '3511', '3508', '35034', '35', 'MONTE CASTELO', NULL, '18', '17960000', '5', '6733', '6733', '21317', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 233.161, '-21,29900', '-51,56900', 375, 'S', 0.7430, NULL, NULL, '35111', 'N', 'N', 3110, NULL, '3590', '3590', NULL, '1953', 'S', 5097, 'MONTE CASTELO', 'N', '353160', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '356', NULL, '03', 'N', NULL, NULL, NULL, 431);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353205', '3503', 'SP', '3513', '3505', '35024', '35', 'MOTUCA', NULL, '16', '14835000', '8', '7263', '7263', '21583', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 229.426, '-21,50800', '-48,15100', 618, 'S', 0.7610, NULL, NULL, '35031', 'N', 'N', 3161, NULL, '3590', '3590', NULL, '1993', 'S', 5102, 'MOTUCA', 'N', '353205', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '361', NULL, '03', 'N', NULL, NULL, NULL, 40);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353210', '3502', 'SP', '3512', '3503', '35016', '35', 'MURUTINGA DO SUL', NULL, '18', '16950000', '8', '6743', '6743', '21322', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 248.278, '-20,99300', '-51,27800', 409, 'S', 0.7800, NULL, NULL, '35022', 'N', 'N', 3190, NULL, '3590', '3590', NULL, '1953', 'S', 5103, 'MURUTINGA DO SUL', 'N', '353210', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '362', NULL, '03', 'N', NULL, NULL, NULL, 95);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353286', '3502', 'SP', '3512', '3501', '35006', '35', 'NOVA CASTILHO', NULL, '17', '15313000', '8', '0806', NULL, '21636', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 183.799, '-20,76300', '-50,34300', 420, 'S', 0.7610, NULL, NULL, '35021', 'N', 'N', 3271, NULL, '3590', '3590', NULL, '1997', 'S', 5114, 'NOVA CASTILHO', 'N', '353286', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '373', NULL, '03', 'N', NULL, NULL, NULL, 156);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353290', '3503', 'SP', '3513', '3505', '35024', '35', 'NOVA EUROPA', NULL, '16', '14920000', '0', '6759', '6759', '21330', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 160.876, '-21,77800', '-48,56100', 490, 'S', 0.7910, NULL, NULL, '35032', 'N', 'N', 3281, NULL, '3590', '3590', NULL, '1953', 'S', 5115, 'NOVA EUROPA', 'N', '353290', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '374', NULL, '03', 'N', NULL, NULL, NULL, 325);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353320', '3502', 'SP', '3512', '3503', '35016', '35', 'NOVA INDEPENDENCIA', NULL, '18', '16940000', '5', '6765', '6765', '21333', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 265.282, '-21,10400', '-51,49000', 316, 'S', 0.7370, NULL, NULL, '35022', 'N', 'N', 3294, NULL, '3590', '3590', NULL, '1964', 'S', 5118, 'NOVA INDEPENDÊNCIA', 'N', '353320', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '377', NULL, '03', 'N', NULL, NULL, NULL, 95);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353330', '3502', 'SP', '3512', '3501', '35006', '35', 'NOVA LUZITANIA', NULL, '17', '15340000', '4', '6767', '6767', '21334', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 73.978, '-20,85600', '-50,26200', 420, 'S', 0.7400, NULL, NULL, '35021', 'N', 'N', 3303, NULL, '3590', '3590', NULL, '1964', 'S', 5119, 'NOVA LUZITÂNIA', 'N', '353330', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '378', NULL, '03', 'N', NULL, NULL, NULL, 156);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353230', '3517', 'SP', '3517', '3513', '35053', '35', 'NATIVIDADE DA SERRA', NULL, '12', '12180000', '6', '6747', '6747', '21324', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 832.606, '-23,37600', '-45,44200', 720, 'S', 0.7330, NULL, NULL, '35174', 'N', 'N', 3206, NULL, '3590', '3590', NULL, '1935', 'S', 5106, 'NATIVIDADE DA SERRA', 'N', '353230', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '365', NULL, '03', 'N', NULL, NULL, NULL, 518);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353390', '3505', 'SP', '3513', '3501', '35004', '35', 'OLIMPIA', NULL, '17', '15400000', '8', '6779', '6779', '21340', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 803.509, '-20,73700', '-48,91500', 506, 'S', 0.8150, NULL, NULL, '35051', 'N', 'N', 3398, NULL, '3590', '3590', NULL, '1917', 'S', 5126, 'OLÍMPIA', 'N', '353390', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '385', NULL, '02', 'N', NULL, NULL, NULL, 42);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353440', '3501', 'SP', '3505', '3515', '35057', '35', 'OSASCO', NULL, '11', '06001970', '1', '6789', '6789', '21345', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 64.935, '-23,53300', '-46,79200', 745, 'S', 0.8180, NULL, NULL, '35014', 'N', 'N', 3423, NULL, '3501', '3501', NULL, '1959', 'S', 5131, 'OSASCO', 'N', '353440', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '390', NULL, '01', 'N', NULL, NULL, NULL, 391);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353610', '3506', 'SP', '3509', '3504', '35023', '35', 'PARDINHO', NULL, '14', '18640000', '9', '6823', '6823', '21362', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 210.036, '-23,08100', '-48,37400', 898, 'S', 0.7880, NULL, NULL, '35063', 'N', 'N', 3564, NULL, '3590', '3590', NULL, '1959', 'S', 5149, 'PARDINHO', 'N', '353610', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '408', NULL, '03', 'N', NULL, NULL, NULL, 384);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353657', '3506', 'SP', '3509', '3504', '35020', '35', 'PAULISTANIA', NULL, '14', '17150000', '0', '0810', NULL, '21638', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 256.553, '-22,57800', '-49,40300', 645, 'S', 0.7740, NULL, NULL, '35062', 'N', 'N', 3623, NULL, '3590', '3590', NULL, '1997', 'S', 5155, 'PAULISTÂNIA', 'N', '353657', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '414', NULL, '03', 'N', NULL, NULL, NULL, 214);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353670', '3506', 'SP', '3509', '3504', '35021', '35', 'PEDERNEIRAS', NULL, '14', '17280000', '3', '6835', '6835', '21368', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 729.179, '-22,35200', '-48,77500', 475, 'S', 0.7800, NULL, NULL, '35062', 'N', 'N', 3637, NULL, '3590', '3590', NULL, '1891', 'S', 5157, 'PEDERNEIRAS', 'N', '353670', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '416', NULL, '03', 'N', NULL, NULL, NULL, 214);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353730', '3502', 'SP', '3512', '3503', '35018', '35', 'PENAPOLIS', NULL, '18', '16300000', '5', '6847', '6847', '21374', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 708.500, '-21,42000', '-50,07800', 416, 'S', 0.8100, NULL, NULL, '35023', 'N', 'N', 3686, NULL, '3590', '3590', NULL, '1913', 'S', 5164, 'PENÁPOLIS', 'N', '353730', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '423', NULL, '02', 'N', NULL, NULL, NULL, 157);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353740', '3502', 'SP', '3512', '3503', '35016', '35', 'PEREIRA BARRETO', NULL, '18', '15370000', '4', '6849', '6849', '21375', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 979.960, '-20,63800', '-51,10900', 347, 'S', 0.7880, NULL, NULL, '35022', 'N', 'N', 3697, NULL, '3590', '3590', NULL, '1938', 'S', 5165, 'PEREIRA BARRETO', 'N', '353740', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '424', NULL, '03', 'N', NULL, NULL, NULL, 95);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353750', '3506', 'SP', '3509', '3511', '35043', '35', 'PEREIRAS', NULL, '14', '18580000', '3', '6851', '6851', '21376', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 222.156, '-23,07600', '-47,97600', 490, 'S', 0.7770, NULL, NULL, '35063', 'N', 'N', 3698, NULL, '3590', '3590', NULL, '1889', 'S', 5166, 'PEREIRAS', 'N', '353750', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '425', NULL, '03', 'N', NULL, NULL, NULL, 384);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353760', '3504', 'SP', '3507', '3514', '35056', '35', 'PERUIBE', NULL, '13', '11750000', '2', '6853', '6853', '21377', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 326.214, '-24,32000', '-46,99800', 5, 'S', 0.7830, NULL, NULL, '35041', 'N', 'N', 3708, NULL, '3502', '3502', NULL, '1959', 'S', 5167, 'PERUÍBE', 'N', '353760', 'N', 'N', 'S', NULL, 100, 'N', 'N', 'N', '426', NULL, '01', 'N', NULL, NULL, NULL, 92);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353770', '3502', 'SP', '3512', '3503', '35018', '35', 'PIACATU', NULL, '18', '16230000', '1', '6855', '6855', '21378', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 232.543, '-21,59200', '-50,59900', 422, 'S', 0.7570, NULL, NULL, '35023', 'N', 'N', 3718, NULL, '3590', '3590', NULL, '1953', 'S', 5168, 'PIACATU', 'N', '353770', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '427', NULL, '03', 'N', NULL, NULL, NULL, 157);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353890', '3506', 'SP', '3509', '3504', '35020', '35', 'PIRAJUI', NULL, '14', '16600000', '7', '6879', '6879', '21390', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 819.432, '-21,99900', '-49,45700', 468, 'S', 0.7790, NULL, NULL, '35062', 'N', 'N', 3786, NULL, '3590', '3590', NULL, '1914', 'S', 5179, 'PIRAJUÍ', 'N', '353890', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '438', NULL, '03', 'N', NULL, NULL, NULL, 214);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353910', '3501', 'SP', '3505', '3515', '35057', '35', 'PIRAPORA DO BOM JESUS', NULL, '11', '06550000', '3', '6883', '6883', '21392', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 108.257, '-23,39700', '-47,00200', 665, 'S', 0.7670, NULL, NULL, '35014', 'N', 'N', 3798, NULL, '3501', '3501', NULL, '1959', 'S', 5181, 'PIRAPORA DO BOM JESUS', 'N', '353910', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '440', NULL, '01', 'N', NULL, NULL, NULL, 391);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353800', '3517', 'SP', '3517', '3513', '35050', '35', 'PINDAMONHANGABA', NULL, '12', '12400000', '6', '6861', '6861', '21381', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 730.172, '-22,92400', '-45,46200', 557, 'S', 0.8150, NULL, NULL, '35174', 'N', 'N', 3746, NULL, '3590', '3512', NULL, '1705', 'S', 5171, 'PINDAMONHANGABA', 'N', '353800', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '430', NULL, '01', 'N', NULL, NULL, NULL, 518);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353940', '3506', 'SP', '3509', '3504', '35020', '35', 'PIRATININGA', NULL, '14', '17490000', '0', '6889', '6889', '21395', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 397.207, '-22,41300', '-49,13500', 516, 'S', 0.7970, NULL, NULL, '35062', 'N', 'N', 3804, NULL, '3590', '3590', NULL, '1913', 'S', 5184, 'PIRATININGA', 'N', '353940', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '443', NULL, '03', 'N', NULL, NULL, NULL, 214);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353980', '3501', 'SP', '3502', '3515', '35062', '35', 'POA', NULL, '11', '08550000', '6', '6897', '6897', '21399', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 17.179, '-23,52800', '-46,34500', 760, 'S', 0.8060, NULL, NULL, '35011', 'N', 'N', 3835, NULL, '3501', '3501', NULL, '1948', 'S', 5188, 'POÁ', 'N', '353980', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '447', NULL, '01', 'N', NULL, NULL, NULL, 39);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354010', '3506', 'SP', '3509', '3504', '35020', '35', 'PONGAI', NULL, '14', '16660000', '1', '6903', '6903', '21402', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 183.382, '-21,73600', '-49,36700', 422, 'S', 0.7940, NULL, NULL, '35065', 'N', 'N', 3858, NULL, '3590', '3590', NULL, '1948', 'S', 5191, 'PONGAÍ', 'N', '354010', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '450', NULL, '03', 'N', NULL, NULL, NULL, 215);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354050', '3506', 'SP', '3509', '3511', '35043', '35', 'PORANGABA', NULL, '15', '18260000', '7', '6911', '6911', '21406', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 266.565, '-23,17600', '-48,12500', 525, 'S', 0.7680, NULL, NULL, '35063', 'N', 'N', 3884, NULL, '3590', '3590', NULL, '1927', 'S', 5196, 'PORANGABA', 'N', '354050', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '455', NULL, '03', 'N', NULL, NULL, NULL, 384);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354100', '3504', 'SP', '3507', '3515', '35063', '35', 'PRAIA GRANDE', NULL, '13', '11700970', '0', '6921', '6921', '21411', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 149.079, '-24,00600', '-46,40300', 3, 'S', 0.7960, NULL, NULL, '35041', 'N', 'N', 3951, NULL, '3502', '3502', NULL, '1964', 'S', 5203, 'PRAIA GRANDE', 'N', '354100', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '462', NULL, '01', 'N', NULL, NULL, NULL, 92);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354105', '3506', 'SP', '3509', '3504', '35023', '35', 'PRATANIA', NULL, '14', '18660000', '9', '0814', NULL, '21640', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 179.817, '-22,80800', '-48,66600', 685, 'S', 0.7450, NULL, NULL, '35063', 'N', 'N', 3958, NULL, '3590', '3590', NULL, '1997', 'S', 5204, 'PRATÂNIA', 'N', '354105', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '463', NULL, '03', 'N', NULL, NULL, NULL, 384);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354110', '3506', 'SP', '3509', '3504', '35020', '35', 'PRESIDENTE ALVES', NULL, '14', '16670000', '9', '6923', '6923', '21412', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 288.570, '-22,10000', '-49,43800', 576, 'S', 0.7630, NULL, NULL, '35062', 'N', 'N', 3961, NULL, '3590', '3590', NULL, '1927', 'S', 5205, 'PRESIDENTE ALVES', 'N', '354110', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '464', NULL, '03', 'N', NULL, NULL, NULL, 214);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354160', '3506', 'SP', '3509', '3504', '35019', '35', 'PROMISSAO', NULL, '14', '16370000', '4', '6933', '6933', '21417', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 782.145, '-21,53700', '-49,85800', 426, 'S', 0.8170, NULL, NULL, '35065', 'N', 'N', 3997, NULL, '3590', '3590', NULL, '1923', 'S', 5210, 'PROMISSÃO', 'N', '354160', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '469', NULL, '03', 'N', NULL, NULL, NULL, 215);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354250', '3506', 'SP', '3509', '3504', '35020', '35', 'REGINOPOLIS', NULL, '14', '17190000', '3', '6951', '6951', '21426', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 409.914, '-21,88800', '-49,22500', 391, 'S', 0.7630, NULL, NULL, '35062', 'N', 'N', 4070, NULL, '3590', '3590', NULL, '1948', 'S', 5220, 'REGINÓPOLIS', 'N', '354250', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '479', NULL, '03', 'N', NULL, NULL, NULL, 214);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354370', '3503', 'SP', '3513', '3505', '35024', '35', 'RINCAO', NULL, '16', '14830000', '9', '6975', '6975', '21438', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 313.422, '-21,58700', '-48,07100', 530, 'S', 0.7770, NULL, NULL, '35031', 'N', 'N', 4132, NULL, '3590', '3590', NULL, '1948', 'S', 5233, 'RINCÃO', 'N', '354370', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '492', NULL, '03', 'N', NULL, NULL, NULL, 40);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354230', '3517', 'SP', '3517', '3513', '35053', '35', 'REDENCAO DA SERRA', NULL, '12', '12170000', '5', '6947', '6947', '21424', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 309.111, '-23,26700', '-45,53700', 730, 'S', 0.7360, NULL, NULL, '35174', 'N', 'N', 4064, NULL, '3590', '3590', NULL, '1877', 'S', 5218, 'REDENÇÃO DA SERRA', 'N', '354230', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '477', NULL, '03', 'N', NULL, NULL, NULL, 518);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354430', '3517', 'SP', '3517', '3513', '35051', '35', 'ROSEIRA', NULL, '12', '12580000', '1', '6987', '6987', '21444', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 130.190, '-22,89800', '-45,30500', 551, 'S', 0.7770, NULL, NULL, '35172', 'N', 'N', 4230, NULL, '3590', '3590', NULL, '1964', 'S', 5241, 'ROSEIRA', 'N', '354430', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '500', NULL, '03', 'N', NULL, NULL, NULL, 433);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354440', '3502', 'SP', '3512', '3503', '35017', '35', 'RUBIACEA', NULL, '18', '16750000', '0', '6989', '6989', '21445', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 236.907, '-21,30100', '-50,72700', 420, 'S', 0.7810, NULL, NULL, '35021', 'N', 'N', 4233, NULL, '3590', '3590', NULL, '1948', 'S', 5242, 'RUBIÁCEA', 'N', '354440', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '501', NULL, '03', 'N', NULL, NULL, NULL, 156);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354460', '3506', 'SP', '3509', '3504', '35019', '35', 'SABINO', NULL, '14', '16440000', '8', '6993', '6993', '21447', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 311.663, '-21,46000', '-49,57800', 412, 'S', 0.7920, NULL, NULL, '35065', 'N', 'N', 4243, NULL, '3590', '3590', NULL, '1953', 'S', 5244, 'SABINO', 'N', '354460', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '503', NULL, '03', 'N', NULL, NULL, NULL, 215);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354500', '3501', 'SP', '3502', '3515', '35062', '35', 'SALESOPOLIS', NULL, '11', '08970000', '1', '7001', '7001', '21451', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 425.842, '-23,53200', '-45,84600', 806, 'S', 0.7480, NULL, NULL, '35011', 'N', 'N', 4253, NULL, '3501', '3501', NULL, '1857', 'S', 5248, 'SALESÓPOLIS', 'N', '354500', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '507', NULL, '01', 'N', NULL, NULL, NULL, 39);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354650', '3503', 'SP', '3513', '3502', '35013', '35', 'SANTA ERNESTINA', NULL, '16', '15970000', '4', '7031', '7031', '21466', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 134.964, '-21,46300', '-48,39100', 570, 'S', 0.7700, NULL, NULL, '35033', 'N', 'N', 4331, NULL, '3590', '3590', NULL, '1964', 'S', 5264, 'SANTA ERNESTINA', 'N', '354650', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '523', NULL, '03', 'N', NULL, NULL, NULL, 97);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354680', '3501', 'SP', '3502', '3515', '35059', '35', 'SANTA ISABEL', NULL, '11', '07500000', '1', '7037', '7037', '21469', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 361.494, '-23,31600', '-46,22100', 655, 'S', 0.7660, NULL, NULL, '35011', 'N', 'N', 4352, NULL, '3501', '3501', NULL, '1832', 'S', 5267, 'SANTA ISABEL', 'N', '354680', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '526', NULL, '01', 'N', NULL, NULL, NULL, 39);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354690', '3503', 'SP', '3513', '3505', '35024', '35', 'SANTA LUCIA', NULL, '16', '14825000', '0', '7039', '7039', '21470', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 152.314, '-21,68500', '-48,08400', 705, 'S', 0.7820, NULL, NULL, '35031', 'N', 'N', 4360, NULL, '3590', '3590', NULL, '1959', 'S', 5268, 'SANTA LÚCIA', 'N', '354690', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '527', NULL, '03', 'N', NULL, NULL, NULL, 40);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354730', '3501', 'SP', '3505', '3515', '35057', '35', 'SANTANA DE PARNAIBA', NULL, '11', '06500000', '4', '7047', '7047', '21474', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 183.816, '-23,44400', '-46,91800', 719, 'S', 0.8530, NULL, NULL, '35014', 'N', 'N', 4443, NULL, '3501', '3501', NULL, '1625', 'S', 5276, 'SANTANA DE PARNAÍBA', 'N', '354730', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '535', NULL, '01', 'N', NULL, NULL, NULL, 391);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354805', '3502', 'SP', '3512', '3503', '35017', '35', 'SANTO ANTONIO DO ARACANGUA', NULL, '18', '16130000', '4', '2939', '2939', '21614', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1306.082, '-20,93700', '-50,49600', 385, 'S', 0.7540, NULL, NULL, '35021', 'N', 'N', 4492, NULL, '3590', '3590', NULL, '1993', 'S', 5281, 'SANTO ANTÔNIO DO ARACANGUÁ', 'N', '354805', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '540', NULL, '03', 'N', NULL, NULL, NULL, 156);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354840', '3502', 'SP', '3512', '3503', '35018', '35', 'SANTOPOLIS DO AGUAPEI', NULL, '18', '16240000', '1', '7069', '7069', '21485', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 127.545, '-21,63800', '-50,50000', 429, 'S', 0.7740, NULL, NULL, '35023', 'N', 'N', 4521, NULL, '3590', '3590', NULL, '1959', 'S', 5285, 'SANTÓPOLIS DO AGUAPEÍ', 'N', '354840', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '544', NULL, '03', 'N', NULL, NULL, NULL, 157);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354850', '3504', 'SP', '3507', '3515', '35063', '35', 'SANTOS', NULL, '13', '11001970', '0', '7071', '7071', '21486', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 280.300, '-23,96100', '-46,33400', 2, 'S', 0.8710, NULL, NULL, '35041', 'N', 'N', 4522, NULL, '3502', '3502', NULL, '1545', 'S', 5286, 'SANTOS', 'N', '354850', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '545', NULL, '01', 'N', NULL, NULL, NULL, 92);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354820', '3517', 'SP', '3517', '3513', '35049', '35', 'SANTO ANTONIO DO PINHAL', NULL, '12', '12450000', '3', '7065', '7065', '21483', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 132.886, '-22,82700', '-45,66300', 1080, 'S', 0.7960, NULL, NULL, '35174', 'N', 'N', 4505, NULL, '3590', '3590', NULL, '1959', 'S', 5283, 'SANTO ANTÔNIO DO PINHAL', 'N', '354820', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '542', NULL, '03', 'N', NULL, NULL, NULL, 518);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354860', '3517', 'SP', '3517', '3513', '35049', '35', 'SAO BENTO DO SAPUCAI', NULL, '12', '12490000', '9', '7073', '7073', '21487', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 252.200, '-22,68900', '-45,73100', 886, 'S', 0.7760, NULL, NULL, '35174', 'N', 'N', 4532, NULL, '3590', '3590', NULL, '1858', 'S', 5287, 'SÃO BENTO DO SAPUCAÍ', 'N', '354860', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '546', NULL, '03', 'N', NULL, NULL, NULL, 518);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('354995', '3501', 'SP', '3504', '3515', '35060', '35', 'SAO LOURENCO DA SERRA', NULL, '11', '06890000', '3', '5447', '5447', '21625', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 186.709, '-23,85300', '-46,94300', 690, 'S', 0.7710, NULL, NULL, '35013', 'N', 'N', 4747, NULL, '3501', '3501', NULL, '1993', 'S', 5302, 'SÃO LOURENÇO DA SERRA', 'N', '354995', 'N', 'N', 'S', NULL, 100, 'N', 'N', 'N', '561', NULL, '01', 'N', NULL, NULL, NULL, 161);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355010', '3506', 'SP', '3509', '3504', '35023', '35', 'SAO MANUEL', NULL, '14', '18650000', '0', '7103', '7103', '21502', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 651.041, '-22,73100', '-48,57100', 709, 'S', 0.8090, NULL, NULL, '35063', 'N', 'N', 4764, NULL, '3590', '3590', NULL, '1885', 'S', 5304, 'SÃO MANUEL', 'N', '355010', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '563', NULL, '03', 'N', NULL, NULL, NULL, 384);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355100', '3504', 'SP', '3507', '3515', '35063', '35', 'SAO VICENTE', NULL, '13', '11301970', '9', '7121', '7121', '21511', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 148.424, '-23,96300', '-46,39200', 6, 'S', 0.7980, NULL, NULL, '35041', 'N', 'N', 4861, NULL, '3502', '3502', NULL, '1700', 'S', 5313, 'SÃO VICENTE', 'N', '355100', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '572', NULL, '01', 'N', NULL, NULL, NULL, 92);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355190', '3505', 'SP', '3513', '3501', '35005', '35', 'SEVERINIA', NULL, '17', '14735000', '0', '7139', '7139', '21520', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 140.395, '-20,80900', '-48,80300', 605, 'S', 0.7500, NULL, NULL, '35051', 'N', 'N', 4982, NULL, '3590', '3590', NULL, '1953', 'S', 5322, 'SEVERÍNIA', 'N', '355190', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '581', NULL, '03', 'N', NULL, NULL, NULL, 42);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355000', '3517', 'SP', '3517', '3513', '35053', '35', 'SAO LUIS DO PARAITINGA', NULL, '12', '12140000', '1', '7101', '7101', '21501', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 617.148, '-23,22200', '-45,31000', 741, 'S', 0.7540, NULL, NULL, '35174', 'N', 'N', 4755, NULL, '3590', '3590', NULL, '1773', 'S', 5303, 'SÃO LUÍS DO PARAITINGA', 'N', '355000', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '562', NULL, '03', 'N', NULL, NULL, NULL, 518);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355210', '3507', 'SP', '3516', '3507', '35033', '35', 'SOCORRO', NULL, '19', '13960000', '6', '7143', '7143', '21522', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 448.074, '-22,59100', '-46,52900', 752, 'S', 0.8120, NULL, NULL, '35071', 'N', 'N', 5017, NULL, '3590', '3590', NULL, '1871', 'S', 5324, 'SOCORRO', 'N', '355210', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '583', NULL, '03', 'N', NULL, NULL, NULL, 275);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355220', '3516', 'SP', '3508', '3512', '35046', '35', 'SOROCABA', NULL, '15', '18001970', '5', '7145', '7145', '21523', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 449.122, '-23,50200', '-47,45800', 601, 'S', 0.8280, NULL, NULL, '35163', 'N', 'N', 5028, NULL, '3590', '3513', NULL, '1661', 'S', 5325, 'SOROCABA', 'N', '355220', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '584', NULL, '01', 'N', NULL, NULL, NULL, 165);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355230', '3502', 'SP', '3512', '3503', '35016', '35', 'SUD MENNUCCI', NULL, '18', '15360000', '4', '7147', '7147', '21524', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 590.682, '-20,69100', '-50,92400', 386, 'S', 0.7790, NULL, NULL, '35022', 'N', 'N', 5037, NULL, '3590', '3590', NULL, '1959', 'S', 5326, 'SUD MENNUCCI', 'N', '355230', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '585', NULL, '03', 'N', NULL, NULL, NULL, 95);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355250', '3501', 'SP', '3502', '3515', '35062', '35', 'SUZANO', NULL, '11', '08675970', '2', '7151', '7151', '21526', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 205.865, '-23,54300', '-46,31100', 738, 'S', 0.7750, NULL, NULL, '35011', 'N', 'N', 5046, NULL, '3501', '3501', NULL, '1948', 'S', 5329, 'SUZANO', 'N', '355250', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '588', NULL, '01', 'N', NULL, NULL, NULL, 39);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355255', '3502', 'SP', '3512', '3503', '35016', '35', 'SUZANAPOLIS', NULL, '18', '15380000', '1', '2945', NULL, '21616', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 327.889, '-20,50100', '-51,02500', 350, 'S', 0.7430, NULL, NULL, '35022', 'N', 'N', 5045, NULL, '3590', '3590', NULL, '1993', 'S', 5328, 'SUZANÁPOLIS', 'N', '355255', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '587', NULL, '03', 'N', NULL, NULL, NULL, 95);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355270', '3503', 'SP', '3513', '3505', '35024', '35', 'TABATINGA', NULL, '16', '14910000', '0', '7155', '7155', '21528', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 366.456, '-21,71700', '-48,68800', 490, 'S', 0.7600, NULL, NULL, '35032', 'N', 'N', 5050, NULL, '3590', '3590', NULL, '1925', 'S', 5331, 'TABATINGA', 'N', '355270', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '590', NULL, '03', 'N', NULL, NULL, NULL, 325);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355280', '3501', 'SP', '3504', '3515', '35060', '35', 'TABOAO DA SERRA', NULL, '11', '06751970', '9', '7157', '7157', '21529', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 20.478, '-23,60200', '-46,75300', 747, 'S', 0.8090, NULL, NULL, '35013', 'N', 'N', 5053, NULL, '3501', '3501', NULL, '1959', 'S', 5332, 'TABOÃO DA SERRA', 'N', '355280', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '591', NULL, '01', 'N', NULL, NULL, NULL, 161);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355310', '3505', 'SP', '3513', '3502', '35013', '35', 'TAIACU', NULL, '16', '14725000', '4', '7163', '7163', '21532', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 106.932, '-21,14400', '-48,51300', 565, 'S', 0.7510, NULL, NULL, '35052', 'N', 'N', 5065, NULL, '3590', '3590', NULL, '1953', 'S', 5335, 'TAIAÇU', 'N', '355310', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '594', NULL, '03', 'N', NULL, NULL, NULL, 220);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355320', '3505', 'SP', '3513', '3502', '35013', '35', 'TAIUVA', NULL, '16', '14720000', '3', '7165', '7165', '21533', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 132.157, '-21,12400', '-48,45200', 630, 'S', 0.7890, NULL, NULL, '35052', 'N', 'N', 5071, NULL, '3590', '3590', NULL, '1948', 'S', 5336, 'TAIÚVA', 'N', '355320', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '595', NULL, '03', 'N', NULL, NULL, NULL, 220);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355365', '3505', 'SP', '3513', '3502', '35013', '35', 'TAQUARAL', NULL, '16', '14765000', '8', '0824', NULL, '21645', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 54.208, '-21,07200', '-48,41000', 639, 'S', 0.7650, NULL, NULL, '35052', 'N', 'N', 5106, NULL, '3590', '3590', NULL, '1997', 'S', 5341, 'TAQUARAL', 'N', '355365', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '600', NULL, '03', 'N', NULL, NULL, NULL, 220);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355370', '3503', 'SP', '3513', '3502', '35013', '35', 'TAQUARITINGA', NULL, '16', '15900000', '8', '7175', '7175', '21538', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 594.224, '-21,40600', '-48,50500', 565, 'S', 0.7780, NULL, NULL, '35033', 'N', 'N', 5110, NULL, '3590', '3590', NULL, '1892', 'S', 5342, 'TAQUARITINGA', 'N', '355370', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '601', NULL, '02', 'N', NULL, NULL, NULL, 97);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355410', '3517', 'SP', '3517', '3513', '35050', '35', 'TAUBATE', NULL, '12', '12010970', '2', '7183', '7183', '21542', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 625.916, '-23,02600', '-45,55500', 580, 'S', 0.8370, NULL, NULL, '35174', 'N', 'N', 5125, NULL, '3590', '3512', NULL, '1650', 'S', 5348, 'TAUBATÉ', 'N', '355410', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '607', NULL, '01', 'N', NULL, NULL, NULL, 518);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355440', '3505', 'SP', '3513', '3502', '35013', '35', 'TERRA ROXA', NULL, '17', '14745000', '9', '7189', '7189', '21545', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 219.894, '-20,78900', '-48,33000', 494, 'S', 0.7730, NULL, NULL, '35052', 'N', 'N', 5161, NULL, '3590', '3590', NULL, '1948', 'S', 5351, 'TERRA ROXA', 'N', '355440', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '610', NULL, '03', 'N', NULL, NULL, NULL, 220);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355465', '3506', 'SP', '3509', '3511', '35043', '35', 'TORRE DE PEDRA', NULL, '15', '18265000', '6', '3227', '3227', '21626', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 71.303, '-23,24400', '-48,19500', 560, 'S', 0.7770, NULL, NULL, '35063', 'N', 'N', 5202, NULL, '3590', '3590', NULL, '1993', 'S', 5354, 'TORRE DE PEDRA', 'N', '355465', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '613', NULL, '03', 'N', NULL, NULL, NULL, 384);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355470', '3506', 'SP', '3509', '3506', '35026', '35', 'TORRINHA', NULL, '14', '17360000', '6', '7195', '7195', '21548', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 311.172, '-22,42600', '-48,16900', 802, 'S', 0.8100, NULL, NULL, '35064', 'N', 'N', 5204, NULL, '3590', '3590', NULL, '1922', 'S', 5355, 'TORRINHA', 'N', '355470', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '614', NULL, '03', 'N', NULL, NULL, NULL, 277);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355475', '3503', 'SP', '3513', '3505', '35024', '35', 'TRABIJU', NULL, '16', '14935000', '5', '0826', NULL, '21646', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 63.378, '-22,04200', '-48,33600', 548, 'S', 0.7550, NULL, NULL, '35031', 'N', 'N', 5206, NULL, '3590', '3590', NULL, '1997', 'S', 5356, 'TRABIJU', 'N', '355475', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '615', NULL, '03', 'N', NULL, NULL, NULL, 40);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355520', '3502', 'SP', '3512', '3503', '35018', '35', 'TURIUBA', NULL, '18', '15280000', '8', '7205', '7205', '21553', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 153.085, '-20,93300', '-50,10800', 439, 'S', 0.8000, NULL, NULL, '35023', 'N', 'N', 5273, NULL, '3590', '3590', NULL, '1959', 'S', 5362, 'TURIÚBA', 'N', '355520', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '621', NULL, '03', 'N', NULL, NULL, NULL, 157);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355590', '3506', 'SP', '3509', '3504', '35020', '35', 'URU', NULL, '14', '16650000', '1', '7219', '7219', '21560', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 147.581, '-21,78400', '-49,28100', 427, 'S', 0.7390, NULL, NULL, '35065', 'N', 'N', 5331, NULL, '3590', '3590', NULL, '1953', 'S', 5370, 'URU', 'N', '355590', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '629', NULL, '03', 'N', NULL, NULL, NULL, 215);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355630', '3502', 'SP', '3512', '3503', '35017', '35', 'VALPARAISO', NULL, '18', '16880000', '5', '7227', '7227', '21564', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 858.757, '-21,22800', '-50,86800', 449, 'S', 0.8070, NULL, NULL, '35021', 'N', 'N', 5364, NULL, '3590', '3590', NULL, '1937', 'S', 5374, 'VALPARAÍSO', 'N', '355630', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '633', NULL, '03', 'N', NULL, NULL, NULL, 156);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355645', '3501', 'SP', '3504', '3515', '35060', '35', 'VARGEM GRANDE PAULISTA', NULL, '11', '06730000', '3', '7273', '7273', '21574', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 33.512, '-23,60300', '-47,02600', 875, 'S', 0.8020, NULL, NULL, '35013', 'N', 'N', 5377, NULL, '3501', '3501', NULL, '1981', 'S', 5377, 'VARGEM GRANDE PAULISTA', 'N', '355645', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '636', NULL, '01', 'N', NULL, NULL, NULL, 161);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355480', '3517', 'SP', '3517', '3513', '35050', '35', 'TREMEMBE', NULL, '12', '12120000', '5', '7197', '7197', '21549', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 192.416, '-22,95800', '-45,54900', 560, 'S', 0.8340, NULL, NULL, '35174', 'N', 'N', 5216, NULL, '3590', '3512', NULL, '1896', 'S', 5357, 'TREMEMBÉ', 'N', '355480', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '616', NULL, '03', 'N', NULL, NULL, NULL, 518);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410010', '4118', 'PR', '4190', '4104', '41015', '41', 'ABATIA', NULL, '43', '86460000', '3', '7401', '7401', '14001', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 229.083, '-23,30400', '-50,31300', 620, 'S', 0.7100, NULL, NULL, '41900', 'N', 'N', 9, NULL, '4190', '4190', NULL, '1947', 'S', 3185, 'ABATIÁ', 'N', '410010', 'N', 'N', 'S', NULL, 146, 'N', 'N', 'N', '1', NULL, '03', 'N', NULL, NULL, NULL, 31);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410020', '4102', 'PR', '4190', '4110', '41035', '41', 'ADRIANOPOLIS', NULL, '41', '83490000', '2', '7403', '7403', '14002', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1349.338, '-24,65700', '-48,99100', 250, 'S', 0.6830, NULL, NULL, '41900', 'S', 'N', 33, NULL, '4101', '4101', NULL, '1960', 'S', 3186, 'ADRIANÓPOLIS', 'N', '410020', 'N', 'N', 'S', NULL, 101, 'N', 'N', 'N', '2', NULL, '01', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410030', '4102', 'PR', '4190', '4110', '41039', '41', 'AGUDOS DO SUL', NULL, '41', '83850000', '1', '7405', '7405', '14003', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 192.228, '-25,99300', '-49,33500', 850, 'S', 0.7120, NULL, NULL, '41900', 'N', 'N', 77, NULL, '4101', '4190', NULL, '1960', 'S', 3187, 'AGUDOS DO SUL', 'N', '410030', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '3', NULL, '01', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410040', '4102', 'PR', '4190', '4110', '41037', '41', 'ALMIRANTE TAMANDARE', NULL, '41', '83501970', '0', '7407', '7407', '14004', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 195.145, '-25,32500', '-49,31000', 945, 'S', 0.7280, NULL, NULL, '41900', 'N', 'N', 124, NULL, '4101', '4101', NULL, '1947', 'S', 5527, 'ALMIRANTE TAMANDARÉ', 'N', '410040', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '4', NULL, '01', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410045', '4111', 'PR', '4190', '4102', '41004', '41', 'ALTAMIRA DO PARANA', NULL, '42', '85280000', '9', '8455', '8455', '14304', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 388.634, '-24,79800', '-52,71300', 560, 'S', 0.6770, NULL, NULL, '41900', 'S', 'N', 133, NULL, '4190', '4190', NULL, '1982', 'S', 3189, 'ALTAMIRA DO PARANÁ', 'N', '410045', 'N', 'N', 'S', NULL, 68, 'N', 'N', 'N', '5', NULL, '03', 'N', NULL, NULL, NULL, 141);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410050', '4112', 'PR', '4190', '4101', '41002', '41', 'ALTONIA', NULL, '44', '87550000', '9', '7951', '7951', '14276', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 661.558, '-23,87400', '-53,90200', 380, 'S', 0.7430, NULL, NULL, '41900', 'N', 'N', 164, NULL, '4190', '4190', NULL, '1966', 'S', 3192, 'ALTÔNIA', 'N', '410050', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '9', NULL, '03', 'N', NULL, NULL, NULL, 312);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410060', '4114', 'PR', '4190', '4101', '41001', '41', 'ALTO PARANA', NULL, '44', '87750000', '8', '7409', '7409', '14005', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 407.719, '-23,12900', '-52,31900', 525, 'S', 0.7430, NULL, NULL, '41900', 'N', 'N', 157, NULL, '4190', '4190', NULL, '1953', 'S', 3190, 'ALTO PARANÁ', 'N', '410060', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '7', NULL, '03', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410070', '4112', 'PR', '4190', '4101', '41002', '41', 'ALTO PIQUIRI', NULL, '44', '87580000', '7', '7411', '7411', '14006', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 447.722, '-24,02800', '-53,44100', 436, 'S', 0.7500, NULL, NULL, '41900', 'N', 'N', 159, NULL, '4190', '4190', NULL, '1960', 'S', 3191, 'ALTO PIQUIRI', 'N', '410070', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '8', NULL, '03', 'N', NULL, NULL, NULL, 312);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410080', '4117', 'PR', '4190', '4103', '41007', '41', 'ALVORADA DO SUL', NULL, '43', '86150000', '6', '7413', '7413', '14007', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 424.245, '-22,78000', '-51,23100', 320, 'S', 0.7570, NULL, NULL, '41900', 'N', 'N', 180, NULL, '4102', '4190', NULL, '1951', 'S', 3193, 'ALVORADA DO SUL', 'N', '410080', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '10', NULL, '03', 'N', NULL, NULL, NULL, 374);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410090', '4114', 'PR', '4190', '4101', '41001', '41', 'AMAPORA', NULL, '44', '87850000', '5', '7415', '7415', '14008', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 384.734, '-23,09600', '-52,78800', 430, 'S', 0.7090, NULL, NULL, '41900', 'N', 'N', 185, NULL, '4190', '4190', NULL, '1960', 'S', 3194, 'AMAPORÃ', 'N', '410090', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '11', NULL, '03', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410100', '4108', 'PR', '4190', '4107', '41025', '41', 'AMPERE', NULL, '46', '85640000', '2', '7417', '7417', '14009', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 298.334, '-25,91500', '-53,47300', 521, 'S', 0.7930, NULL, NULL, '41900', 'N', 'N', 206, NULL, '4190', '4190', NULL, '1961', 'S', 3195, 'AMPÉRE', 'N', '410100', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '12', NULL, '03', 'N', NULL, NULL, NULL, 34);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410105', '4110', 'PR', '4190', '4106', '41023', '41', 'ANAHY', NULL, '45', '85425000', '1', '5463', '5463', '14325', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 102.648, '-24,64400', '-53,13500', 651, 'S', 0.7250, NULL, NULL, '41900', 'N', 'N', 209, NULL, '4190', '4190', NULL, '1993', 'S', 3196, 'ANAHY', 'N', '410105', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '13', NULL, '03', 'N', NULL, NULL, NULL, 258);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410110', '4118', 'PR', '4190', '4104', '41015', '41', 'ANDIRA', NULL, '43', '86380000', '1', '7419', '7419', '14010', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 234.802, '-23,05100', '-50,22900', 470, 'S', 0.7420, NULL, NULL, '41900', 'N', 'N', 224, NULL, '4190', '4190', NULL, '1943', 'S', 3197, 'ANDIRÁ', 'N', '410110', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '14', NULL, '03', 'N', NULL, NULL, NULL, 31);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410115', '4115', 'PR', '4190', '4103', '41006', '41', 'ANGULO', NULL, '44', '86755000', '0', '5509', '5509', '14361', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 106.021, '-23,19500', '-51,91500', 300, 'S', 0.7420, NULL, NULL, '41900', 'N', 'N', 241, NULL, '4103', '4104', NULL, '1993', 'S', 3198, 'ÂNGULO', 'N', '410115', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '15', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410120', '4101', 'PR', '4190', '4110', '41038', '41', 'ANTONINA', NULL, '41', '83370000', '0', '7421', '7421', '14011', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 882.316, '-25,42900', '-48,71200', 20, 'S', 0.7700, NULL, NULL, '41900', 'N', 'N', 252, NULL, '4190', '4190', NULL, '1797', 'S', 3199, 'ANTONINA', 'N', '410120', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '16', NULL, '03', 'N', NULL, NULL, NULL, 428);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410130', '4106', 'PR', '4190', '4109', '41034', '41', 'ANTONIO OLINTO', NULL, '42', '83980000', '9', '7423', '7423', '14012', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 469.755, '-25,98600', '-50,19700', 802, 'S', 0.7110, NULL, NULL, '41900', 'N', 'N', 262, NULL, '4190', '4190', NULL, '1960', 'S', 3200, 'ANTÔNIO OLINTO', 'N', '410130', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '17', NULL, '03', 'N', NULL, NULL, NULL, 33);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410140', '4116', 'PR', '4190', '4103', '41010', '41', 'APUCARANA', NULL, '43', '86800970', '8', '7425', '7425', '14013', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 558.388, '-23,55100', '-51,46100', 820, 'S', 0.7990, NULL, NULL, '41900', 'N', 'N', 282, NULL, '4190', '4103', NULL, '1943', 'S', 3201, 'APUCARANA', 'N', '410140', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '18', NULL, '01', 'N', NULL, NULL, NULL, 373);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410150', '4116', 'PR', '4190', '4103', '41010', '41', 'ARAPONGAS', NULL, '43', '86700970', '7', '7427', '7427', '14014', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 381.091, '-23,41900', '-51,42400', 729, 'S', 0.7740, NULL, NULL, '41900', 'N', 'N', 330, NULL, '4190', '4103', NULL, '1947', 'S', 3202, 'ARAPONGAS', 'N', '410150', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '19', NULL, '01', 'N', NULL, NULL, NULL, 373);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410160', '4103', 'PR', '4190', '4105', '41020', '41', 'ARAPOTI', NULL, '43', '84990000', '6', '7429', '7429', '14015', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1360.498, '-24,15800', '-49,82700', 860, 'S', 0.7610, NULL, NULL, '41900', 'N', 'N', 332, NULL, '4190', '4190', NULL, '1954', 'S', 3203, 'ARAPOTI', 'N', '410160', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '20', NULL, '03', 'N', NULL, NULL, NULL, 146);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410165', '4122', 'PR', '4190', '4103', '41013', '41', 'ARAPUA', NULL, '43', '86884000', '5', '0830', NULL, '14392', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 218.838, '-24,31600', '-51,78700', 680, 'S', 0.6870, NULL, NULL, '41900', 'S', 'N', 334, NULL, '4190', '4190', NULL, '1997', 'S', 3204, 'ARAPUÃ', 'N', '410165', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '21', NULL, '03', 'N', NULL, NULL, NULL, 316);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355680', '3505', 'SP', '3513', '3502', '35013', '35', 'VIRADOURO', NULL, '17', '14740000', '0', '7239', '7239', '21570', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 219.044, '-20,87300', '-48,29700', 528, 'S', 0.7980, NULL, NULL, '35052', 'N', 'N', 5459, NULL, '3590', '3590', NULL, '1916', 'S', 5381, 'VIRADOURO', 'N', '355680', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '640', NULL, '03', 'N', NULL, NULL, NULL, 220);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('355690', '3505', 'SP', '3513', '3502', '35013', '35', 'VISTA ALEGRE DO ALTO', NULL, '16', '15920000', '9', '7241', '7241', '21571', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 95.297, '-21,17100', '-48,62900', 619, 'S', 0.8160, NULL, NULL, '35052', 'N', 'N', 5468, NULL, '3590', '3590', NULL, '1959', 'S', 5382, 'VISTA ALEGRE DO ALTO', 'N', '355690', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '641', NULL, '03', 'N', NULL, NULL, NULL, 220);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410170', '4111', 'PR', '4190', '4102', '41005', '41', 'ARARUNA', NULL, '44', '87260000', '5', '7431', '7431', '14016', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 493.190, '-23,93200', '-52,49600', 610, 'S', 0.7320, NULL, NULL, '41900', 'N', 'N', 347, NULL, '4190', '4190', NULL, '1954', 'S', 3205, 'ARARUNA', 'N', '410170', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '22', NULL, '03', 'N', NULL, NULL, NULL, 141);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410180', '4102', 'PR', '4190', '4110', '41037', '41', 'ARAUCARIA', NULL, '41', '83700970', '4', '7435', '7435', '14018', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 469.166, '-25,59300', '-49,41000', 897, 'S', 0.8010, NULL, NULL, '41900', 'N', 'N', 354, NULL, '4101', '4101', NULL, '1890', 'S', 3206, 'ARAUCÁRIA', 'N', '410180', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '23', NULL, '01', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410185', '4122', 'PR', '4190', '4103', '41013', '41', 'ARIRANHA DO IVAI', NULL, '43', '86880000', '3', '0832', NULL, '14393', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 240.625, '-24,38600', '-51,58500', 700, 'S', 0.6880, NULL, NULL, '41900', 'S', 'N', 380, NULL, '4190', '4190', NULL, '1997', 'S', 3207, 'ARIRANHA DO IVAÍ', 'N', '410185', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '24', NULL, '03', 'N', NULL, NULL, NULL, 316);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410190', '4117', 'PR', '4190', '4104', '41014', '41', 'ASSAI', NULL, '43', '86220000', '3', '7437', '7437', '14019', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 440.346, '-23,37300', '-50,84100', 605, 'S', 0.7480, NULL, NULL, '41900', 'N', 'N', 402, NULL, '4102', '4190', NULL, '1943', 'S', 3208, 'ASSAÍ', 'N', '410190', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '25', NULL, '03', 'N', NULL, NULL, NULL, 374);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410200', '4120', 'PR', '4190', '4106', '41022', '41', 'ASSIS CHATEAUBRIAND', NULL, '44', '85935000', '0', '7953', '7953', '14277', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 969.588, '-24,42000', '-53,52100', 406, 'S', 0.7870, NULL, NULL, '41900', 'N', 'N', 406, NULL, '4190', '4190', NULL, '1966', 'S', 3209, 'ASSIS CHATEAUBRIAND', 'N', '410200', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '26', NULL, '03', 'N', NULL, NULL, NULL, 267);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410210', '4115', 'PR', '4190', '4103', '41006', '41', 'ASTORGA', NULL, '44', '86730000', '9', '7439', '7439', '14020', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 434.791, '-23,23300', '-51,66600', 675, 'S', 0.7500, NULL, NULL, '41900', 'N', 'N', 411, NULL, '4103', '4190', NULL, '1951', 'S', 3210, 'ASTORGA', 'N', '410210', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '27', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410220', '4115', 'PR', '4190', '4103', '41006', '41', 'ATALAIA', NULL, '44', '87630000', '8', '7441', '7441', '14021', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 137.663, '-23,15100', '-52,05400', 502, 'S', 0.7650, NULL, NULL, '41900', 'N', 'N', 412, NULL, '4103', '4190', NULL, '1960', 'S', 3211, 'ATALAIA', 'N', '410220', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '28', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410230', '4102', 'PR', '4190', '4110', '41037', '41', 'BALSA NOVA', NULL, '41', '83650000', '7', '7443', '7443', '14022', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 396.914, '-25,58400', '-49,63600', 871, 'S', 0.7810, NULL, NULL, '41900', 'N', 'N', 465, NULL, '4101', '4101', NULL, '1961', 'S', 3212, 'BALSA NOVA', 'N', '410230', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '29', NULL, '01', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410240', '4118', 'PR', '4190', '4104', '41015', '41', 'BANDEIRANTES', NULL, '43', '86360000', '6', '7445', '7445', '14023', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 447.617, '-23,11000', '-50,36800', 420, 'S', 0.7560, NULL, NULL, '41900', 'N', 'N', 475, NULL, '4190', '4190', NULL, '1938', 'S', 3213, 'BANDEIRANTES', 'N', '410240', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '30', NULL, '03', 'N', NULL, NULL, NULL, 31);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410250', '4111', 'PR', '4190', '4102', '41005', '41', 'BARBOSA FERRAZ', NULL, '44', '86960000', '5', '7447', '7447', '14024', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 538.621, '-24,03000', '-52,01200', 374, 'S', 0.7000, NULL, NULL, '41900', 'S', 'N', 493, NULL, '4190', '4190', NULL, '1960', 'S', 3214, 'BARBOSA FERRAZ', 'N', '410250', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '31', NULL, '03', 'N', NULL, NULL, NULL, 141);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410260', '4108', 'PR', '4190', '4107', '41026', '41', 'BARRACAO', NULL, '54', '85700000', '4', '7449', '7449', '14025', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 163.931, '-26,25400', '-53,63300', 828, 'S', 0.7640, NULL, NULL, '41900', 'N', 'N', 531, NULL, '4190', '4190', NULL, '1951', 'S', 3216, 'BARRACÃO', 'N', '410260', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '33', NULL, '03', 'N', NULL, NULL, NULL, 34);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410270', '4119', 'PR', '4190', '4104', '41016', '41', 'BARRA DO JACARE', NULL, '43', '86385000', '3', '7451', '7451', '14026', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 115.592, '-23,11500', '-50,18100', 560, 'S', 0.7890, NULL, NULL, '41900', 'N', 'N', 516, NULL, '4190', '4190', NULL, '1964', 'S', 3215, 'BARRA DO JACARÉ', 'N', '410270', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '32', NULL, '03', 'N', NULL, NULL, NULL, 427);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410275', '4108', 'PR', '4190', '4107', '41025', '41', 'BELA VISTA DA CAROBA', NULL, '46', '85745000', '2', '0834', NULL, '14394', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 148.107, '-25,88100', '-53,66500', 558, 'S', 0.7380, NULL, NULL, '41900', 'N', 'N', 565, NULL, '4190', '4190', NULL, '1997', 'S', 3217, 'BELA VISTA DA CAROBA', 'N', '410275', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '34', NULL, '03', 'N', NULL, NULL, NULL, 34);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410280', '4117', 'PR', '4190', '4103', '41007', '41', 'BELA VISTA DO PARAISO', NULL, '43', '86130000', '2', '7453', '7453', '14027', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 242.692, '-22,99700', '-51,19100', 590, 'S', 0.7710, NULL, NULL, '41900', 'N', 'N', 567, NULL, '4102', '4190', NULL, '1947', 'S', 3218, 'BELA VISTA DO PARAÍSO', 'N', '410280', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '35', NULL, '03', 'N', NULL, NULL, NULL, 374);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410290', '4106', 'PR', '4190', '4109', '41033', '41', 'BITURUNA', NULL, '42', '84640000', '1', '7455', '7455', '14028', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1214.905, '-26,16100', '-51,55300', 987, 'S', 0.7150, NULL, NULL, '41900', 'N', 'N', 621, NULL, '4190', '4190', NULL, '1954', 'S', 3219, 'BITURUNA', 'N', '410290', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '36', NULL, '03', 'N', NULL, NULL, NULL, 33);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410300', '4111', 'PR', '4190', '4102', '41004', '41', 'BOA ESPERANCA', NULL, '44', '87390000', '8', '7457', '7457', '14029', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 307.381, '-24,24200', '-52,78900', 500, 'S', 0.7220, NULL, NULL, '41900', 'N', 'N', 625, NULL, '4190', '4190', NULL, '1964', 'S', 3220, 'BOA ESPERANÇA', 'N', '410300', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '37', NULL, '03', 'N', NULL, NULL, NULL, 141);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410302', '4108', 'PR', '4190', '4107', '41026', '41', 'BOA ESPERANCA DO IGUACU', NULL, '46', '85680000', '4', '5471', '5471', '14326', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 151.986, '-25,63600', '-53,21200', 521, 'S', 0.7410, NULL, NULL, '41900', 'N', 'N', 626, NULL, '4190', '4190', NULL, '1993', 'S', 3221, 'BOA ESPERANÇA DO IGUAÇU', 'N', '410302', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '38', NULL, '03', 'N', NULL, NULL, NULL, 34);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410304', '4105', 'PR', '4190', '4108', '41028', '41', 'BOA VENTURA DE SAO ROQUE', NULL, '42', '85225000', '0', '0836', '0836', '14395', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 622.185, '-24,86900', '-51,62800', 950, 'S', 0.7110, NULL, NULL, '41900', 'N', 'N', 632, NULL, '4190', '4190', NULL, '1997', 'S', 3222, 'BOA VENTURA DE SÃO ROQUE', 'N', '410304', 'N', 'N', 'S', NULL, 68, 'N', 'N', 'N', '39', NULL, '03', 'N', NULL, NULL, NULL, 32);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410305', '4110', 'PR', '4190', '4106', '41023', '41', 'BOA VISTA DA APARECIDA', NULL, '45', '85780000', '7', '7981', '7981', '14291', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 256.296, '-25,43600', '-53,40800', 445, 'S', 0.6970, NULL, NULL, '41900', 'S', 'N', 636, NULL, '4190', '4190', NULL, '1981', 'S', 3223, 'BOA VISTA DA APARECIDA', 'N', '410305', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '40', NULL, '03', 'N', NULL, NULL, NULL, 258);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410310', '4102', 'PR', '4190', '4110', '41037', '41', 'BOCAIUVA DO SUL', NULL, '41', '83450000', '7', '7459', '7459', '14030', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 826.344, '-25,20600', '-49,11500', 980, 'S', 0.7190, NULL, NULL, '41900', 'N', 'N', 650, NULL, '4101', '4101', NULL, '1934', 'S', 3224, 'BOCAIÚVA DO SUL', 'N', '410310', 'N', 'N', 'S', NULL, 101, 'N', 'N', 'N', '41', NULL, '01', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410315', '4108', 'PR', '4190', '4107', '41026', '41', 'BOM JESUS DO SUL', NULL, '46', '85708000', '6', '0838', NULL, '14396', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 173.972, '-26,19300', '-53,59700', 660, 'S', 0.6960, NULL, NULL, '41900', 'S', 'N', 679, NULL, '4190', '4190', NULL, '1997', 'S', 3225, 'BOM JESUS DO SUL', 'N', '410315', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '42', NULL, '03', 'N', NULL, NULL, NULL, 34);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410320', '4116', 'PR', '4190', '4103', '41012', '41', 'BOM SUCESSO', NULL, '43', '86940000', '6', '7461', '7461', '14031', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 322.755, '-23,71000', '-51,76400', 580, 'S', 0.7350, NULL, NULL, '41900', 'N', 'N', 692, NULL, '4103', '4190', NULL, '1954', 'S', 3226, 'BOM SUCESSO', 'N', '410320', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '43', NULL, '03', 'N', NULL, NULL, NULL, 373);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410322', '4107', 'PR', '4190', '4107', '41027', '41', 'BOM SUCESSO DO SUL', NULL, '46', '85515000', '2', '9979', '9979', '14327', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 195.867, '-26,07600', '-52,83400', 640, 'S', 0.7760, NULL, NULL, '41900', 'N', 'N', 694, NULL, '4190', '4190', NULL, '1993', 'S', 3227, 'BOM SUCESSO DO SUL', 'N', '410322', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '44', NULL, '03', 'N', NULL, NULL, NULL, 268);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410330', '4116', 'PR', '4190', '4103', '41012', '41', 'BORRAZOPOLIS', NULL, '43', '86925000', '5', '7463', '7463', '14032', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 334.377, '-23,94100', '-51,58800', 635, 'S', 0.7270, NULL, NULL, '41900', 'N', 'N', 721, NULL, '4190', '4190', NULL, '1951', 'S', 3228, 'BORRAZÓPOLIS', 'N', '410330', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '45', NULL, '03', 'N', NULL, NULL, NULL, 373);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410335', '4110', 'PR', '4190', '4106', '41023', '41', 'BRAGANEY', NULL, '45', '85430000', '4', '7983', '7983', '14305', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 343.321, '-24,81600', '-53,12200', 654, 'S', 0.7040, NULL, NULL, '41900', 'N', 'N', 733, NULL, '4190', '4190', NULL, '1982', 'S', 3229, 'BRAGANEY', 'N', '410335', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '46', NULL, '03', 'N', NULL, NULL, NULL, 258);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410337', '4112', 'PR', '4190', '4101', '41002', '41', 'BRASILANDIA DO SUL', NULL, '44', '87595000', '0', '5521', '5521', '14362', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 291.039, '-24,19700', '-53,52500', 378, 'S', 0.7070, NULL, NULL, '41900', 'N', 'N', 739, NULL, '4190', '4190', NULL, '1993', 'S', 3230, 'BRASILÂNDIA DO SUL', 'N', '410337', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '47', NULL, '03', 'N', NULL, NULL, NULL, 312);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410340', '4117', 'PR', '4190', '4103', '41006', '41', 'CAFEARA', NULL, '43', '86640000', '4', '7465', '7465', '14033', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 185.798, '-22,79300', '-51,71600', 420, 'S', 0.6990, NULL, NULL, '41900', 'S', 'N', 862, NULL, '4190', '4190', NULL, '1954', 'S', 3231, 'CAFEARA', 'N', '410340', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '48', NULL, '03', 'N', NULL, NULL, NULL, 374);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410345', '4110', 'PR', '4190', '4106', '41023', '41', 'CAFELANDIA', NULL, '45', '85415000', '3', '7985', '7985', '14299', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 271.724, '-24,61800', '-53,32000', 521, 'S', 0.7870, NULL, NULL, '41900', 'N', 'N', 863, NULL, '4190', '4190', NULL, '1979', 'S', 3232, 'CAFELÂNDIA', 'N', '410345', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '49', NULL, '03', 'N', NULL, NULL, NULL, 258);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410347', '4112', 'PR', '4190', '4101', '41002', '41', 'CAFEZAL DO SUL', NULL, '44', '87565000', '9', '5491', '5491', '14329', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 336.205, '-23,90200', '-53,51300', 425, 'S', 0.7300, NULL, NULL, '41900', 'N', 'N', 865, NULL, '4190', '4190', NULL, '1993', 'S', 3233, 'CAFEZAL DO SUL', 'N', '410347', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '50', NULL, '03', 'N', NULL, NULL, NULL, 312);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410350', '4116', 'PR', '4190', '4103', '41010', '41', 'CALIFORNIA', NULL, '43', '86820000', '3', '7467', '7467', '14034', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 141.816, '-23,65000', '-51,35500', 800, 'S', 0.7450, NULL, NULL, '41900', 'N', 'N', 899, NULL, '4190', '4190', NULL, '1954', 'S', 3234, 'CALIFÓRNIA', 'N', '410350', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '51', NULL, '03', 'N', NULL, NULL, NULL, 373);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410360', '4119', 'PR', '4190', '4104', '41016', '41', 'CAMBARA', NULL, '43', '86390000', '2', '7469', '7469', '14035', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 366.173, '-23,04600', '-50,07400', 545, 'S', 0.7690, NULL, NULL, '41900', 'N', 'N', 912, NULL, '4190', '4190', NULL, '1923', 'S', 3235, 'CAMBARÁ', 'N', '410360', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '52', NULL, '03', 'N', NULL, NULL, NULL, 427);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410370', '4117', 'PR', '4190', '4103', '41011', '41', 'CAMBE', NULL, '43', '86180970', '1', '7471', '7471', '14036', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 494.692, '-23,27600', '-51,27800', 650, 'S', 0.7930, NULL, NULL, '41900', 'N', 'N', 914, NULL, '4102', '4103', NULL, '1947', 'S', 3236, 'CAMBÉ', 'N', '410370', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '53', NULL, '02', 'N', NULL, NULL, NULL, 374);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410380', '4116', 'PR', '4190', '4103', '41010', '41', 'CAMBIRA', NULL, '43', '86890000', '0', '7473', '7473', '14037', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 162.635, '-23,58300', '-51,57800', 805, 'S', 0.7670, NULL, NULL, '41900', 'N', 'N', 915, NULL, '4103', '4190', NULL, '1961', 'S', 3237, 'CAMBIRA', 'N', '410380', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '54', NULL, '03', 'N', NULL, NULL, NULL, 373);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410390', '4111', 'PR', '4190', '4102', '41004', '41', 'CAMPINA DA LAGOA', NULL, '44', '87345000', '9', '7475', '7475', '14038', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 808.824, '-24,59200', '-52,79900', 610, 'S', 0.7100, NULL, NULL, '41900', 'N', 'N', 930, NULL, '4190', '4190', NULL, '1960', 'S', 3238, 'CAMPINA DA LAGOA', 'N', '410390', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '55', NULL, '03', 'N', NULL, NULL, NULL, 141);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410395', '4105', 'PR', '4190', '4108', '41029', '41', 'CAMPINA DO SIMAO', NULL, '42', '85148000', '8', '0840', NULL, '14397', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 449.401, '-25,07900', '-51,82700', 994, 'S', 0.7010, NULL, NULL, '41900', 'N', 'N', 933, NULL, '4190', '4190', NULL, '1997', 'S', 3239, 'CAMPINA DO SIMÃO', 'N', '410395', 'N', 'N', 'S', NULL, 68, 'N', 'N', 'N', '56', NULL, '03', 'N', NULL, NULL, NULL, 32);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410400', '4102', 'PR', '4190', '4110', '41037', '41', 'CAMPINA GRANDE DO SUL', NULL, '41', '83430000', '6', '7477', '7477', '14039', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 539.861, '-25,30600', '-49,05500', 903, 'S', 0.7610, NULL, NULL, '41900', 'N', 'N', 935, NULL, '4101', '4101', NULL, '1951', 'S', 3240, 'CAMPINA GRANDE DO SUL', 'N', '410400', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '57', NULL, '01', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410405', '4110', 'PR', '4190', '4106', '41023', '41', 'CAMPO BONITO', NULL, '45', '85450000', '5', '8475', '8475', '14312', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 433.836, '-25,03100', '-52,99300', 720, 'S', 0.6870, NULL, NULL, '41900', 'S', 'N', 952, NULL, '4190', '4190', NULL, '1989', 'S', 3241, 'CAMPO BONITO', 'N', '410405', 'N', 'N', 'S', NULL, 25, 'N', 'N', 'N', '58', NULL, '03', 'N', NULL, NULL, NULL, 258);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410410', '4102', 'PR', '4190', '4110', '41039', '41', 'CAMPO DO TENENTE', NULL, '41', '83870000', '5', '7479', '7479', '14040', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 304.489, '-25,97800', '-49,68300', 798, 'S', 0.6870, NULL, NULL, '41900', 'S', 'N', 955, NULL, '4101', '4190', NULL, '1961', 'S', 3242, 'CAMPO DO TENENTE', 'N', '410410', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '59', NULL, '03', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410420', '4102', 'PR', '4190', '4110', '41037', '41', 'CAMPO LARGO', NULL, '41', '83600970', '4', '7481', '7481', '14041', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1249.422, '-25,45900', '-49,52800', 956, 'S', 0.7740, NULL, NULL, '41900', 'N', 'N', 963, NULL, '4101', '4101', NULL, '1870', 'S', 3243, 'CAMPO LARGO', 'N', '410420', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '60', NULL, '01', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410425', '4102', 'PR', '4190', '4110', '41037', '41', 'CAMPO MAGRO', NULL, '41', '83535000', '3', '0842', NULL, '14398', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 275.466, '-25,36900', '-49,45100', 931, 'S', 0.7400, NULL, NULL, '41900', 'N', 'N', 966, NULL, '4101', '4101', NULL, '1997', 'S', 3244, 'CAMPO MAGRO', 'N', '410425', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '61', NULL, '01', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410430', '4111', 'PR', '4190', '4102', '41005', '41', 'CAMPO MOURAO', NULL, '44', '87300970', '3', '7483', '7483', '14042', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 757.109, '-24,04600', '-52,38300', 585, 'S', 0.7740, NULL, NULL, '41900', 'N', 'N', 968, NULL, '4190', '4190', NULL, '1947', 'S', 3245, 'CAMPO MOURÃO', 'N', '410430', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '62', NULL, '02', 'N', NULL, NULL, NULL, 141);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410440', '4122', 'PR', '4190', '4103', '41013', '41', 'CANDIDO DE ABREU', NULL, '43', '84470000', '2', '7485', '7485', '14043', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1510.157, '-24,56700', '-51,33300', 540, 'S', 0.6670, NULL, NULL, '41900', 'S', 'N', 1006, NULL, '4190', '4190', NULL, '1954', 'S', 3246, 'CÂNDIDO DE ABREU', 'N', '410440', 'N', 'N', 'S', NULL, 68, 'N', 'N', 'N', '63', NULL, '03', 'N', NULL, NULL, NULL, 316);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410442', '4105', 'PR', '4190', '4108', '41029', '41', 'CANDOI', NULL, '42', '85140000', '8', '5499', '5499', '14363', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1512.768, '-25,66300', '-52,12600', 950, 'S', 0.7120, NULL, NULL, '41900', 'N', 'N', 1013, NULL, '4190', '4190', NULL, '1993', 'S', 3247, 'CANDÓI', 'N', '410442', 'N', 'N', 'S', NULL, 25, 'N', 'N', 'N', '64', NULL, '03', 'N', NULL, NULL, NULL, 32);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410445', '4105', 'PR', '4190', '4108', '41029', '41', 'CANTAGALO', NULL, '42', '85160000', '1', '8451', '8451', '14306', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 583.539, '-25,37400', '-52,12600', 840, 'S', 0.6860, NULL, NULL, '41900', 'S', 'N', 1029, NULL, '4190', '4190', NULL, '1982', 'S', 3248, 'CANTAGALO', 'N', '410445', 'N', 'N', 'S', NULL, 25, 'N', 'N', 'N', '65', NULL, '03', 'N', NULL, NULL, NULL, 32);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410450', '4108', 'PR', '4190', '4107', '41025', '41', 'CAPANEMA', NULL, '46', '85760000', '1', '7487', '7487', '14044', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 418.705, '-25,67200', '-53,80900', 368, 'S', 0.8030, NULL, NULL, '41900', 'N', 'N', 1035, NULL, '4190', '4190', NULL, '1951', 'S', 3249, 'CAPANEMA', 'N', '410450', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '66', NULL, '03', 'N', NULL, NULL, NULL, 34);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410460', '4110', 'PR', '4190', '4106', '41023', '41', 'CAPITAO LEONIDAS MARQUES', NULL, '45', '85790000', '0', '7489', '7489', '14045', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 275.748, '-25,47900', '-53,61400', 250, 'S', 0.7510, NULL, NULL, '41900', 'N', 'N', 1061, NULL, '4190', '4190', NULL, '1964', 'S', 3250, 'CAPITÃO LEÔNIDAS MARQUES', 'N', '410460', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '67', NULL, '03', 'N', NULL, NULL, NULL, 258);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410465', '4103', 'PR', '4190', '4105', '41021', '41', 'CARAMBEI', NULL, '42', '84145000', '9', '0844', NULL, '14365', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 649.679, '-24,91800', '-50,09700', 120, 'S', 0.7850, NULL, NULL, '41900', 'N', 'N', 1077, NULL, '4190', '4190', NULL, '1997', 'S', 3251, 'CARAMBEÍ', 'N', '410465', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '68', NULL, '03', 'N', NULL, NULL, NULL, 146);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410470', '4119', 'PR', '4190', '4104', '41018', '41', 'CARLOPOLIS', NULL, '43', '86420000', '9', '7491', '7491', '14046', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 447.857, '-23,42500', '-49,72100', 521, 'S', 0.7270, NULL, NULL, '41900', 'N', 'N', 1107, NULL, '4190', '4190', NULL, '1907', 'S', 3252, 'CARLÓPOLIS', 'N', '410470', 'N', 'N', 'S', NULL, 146, 'N', 'N', 'N', '69', NULL, '03', 'N', NULL, NULL, NULL, 427);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410480', '4110', 'PR', '4190', '4106', '41023', '41', 'CASCAVEL', NULL, '45', '85806970', '8', '7493', '7493', '14047', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2100.105, '-24,95600', '-53,45500', 781, 'S', 0.8100, NULL, NULL, '41900', 'N', 'N', 1145, NULL, '4190', '4102', NULL, '1951', 'S', 3253, 'CASCAVEL', 'N', '410480', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '70', NULL, '01', 'N', NULL, NULL, NULL, 258);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410490', '4103', 'PR', '4190', '4105', '41021', '41', 'CASTRO', NULL, '42', '84165970', '7', '7495', '7495', '14048', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2531.503, '-24,79100', '-50,01200', 999, 'S', 0.7360, NULL, NULL, '41900', 'N', 'N', 1162, NULL, '4190', '4190', NULL, '1778', 'S', 3254, 'CASTRO', 'N', '410490', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '71', NULL, '02', 'N', NULL, NULL, NULL, 146);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410500', '4110', 'PR', '4190', '4106', '41023', '41', 'CATANDUVAS', NULL, '45', '85470000', '3', '7497', '7497', '14049', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 581.754, '-25,20300', '-53,15700', 762, 'S', 0.7170, NULL, NULL, '41900', 'N', 'N', 1167, NULL, '4190', '4190', NULL, '1960', 'S', 3255, 'CATANDUVAS', 'N', '410500', 'N', 'N', 'S', NULL, 25, 'N', 'N', 'N', '72', NULL, '03', 'N', NULL, NULL, NULL, 258);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410510', '4117', 'PR', '4190', '4103', '41006', '41', 'CENTENARIO DO SUL', NULL, '43', '86630000', '2', '7499', '7499', '14050', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 371.835, '-22,82100', '-51,59500', 560, 'S', 0.7380, NULL, NULL, '41900', 'N', 'N', 1202, NULL, '4190', '4190', NULL, '1951', 'S', 3256, 'CENTENÁRIO DO SUL', 'N', '410510', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '73', NULL, '03', 'N', NULL, NULL, NULL, 374);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410520', '4102', 'PR', '4190', '4110', '41035', '41', 'CERRO AZUL', NULL, '41', '83570000', '1', '7501', '7501', '14051', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1341.187, '-24,82400', '-49,26100', 318, 'S', 0.6840, NULL, NULL, '41900', 'S', 'N', 1214, NULL, '4101', '4101', NULL, '1882', 'S', 3257, 'CERRO AZUL', 'N', '410520', 'N', 'N', 'S', NULL, 101, 'N', 'N', 'N', '74', NULL, '01', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410530', '4110', 'PR', '4190', '4106', '41024', '41', 'CEU AZUL', NULL, '45', '85840000', '0', '7957', '7957', '14279', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1179.442, '-25,14700', '-53,84900', 620, 'S', 0.7800, NULL, NULL, '41900', 'N', 'N', 1222, NULL, '4190', '4190', NULL, '1966', 'S', 3258, 'CÉU AZUL', 'N', '410530', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '75', NULL, '03', 'N', NULL, NULL, NULL, 258);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410540', '4107', 'PR', '4190', '4107', '41027', '41', 'CHOPINZINHO', NULL, '46', '85560000', '9', '7503', '7503', '14052', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 959.692, '-25,85600', '-52,52300', 720, 'S', 0.7730, NULL, NULL, '41900', 'N', 'N', 1248, NULL, '4190', '4190', NULL, '1954', 'S', 3259, 'CHOPINZINHO', 'N', '410540', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '76', NULL, '03', 'N', NULL, NULL, NULL, 268);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410550', '4113', 'PR', '4190', '4101', '41003', '41', 'CIANORTE', NULL, '44', '87200000', '8', '7505', '7505', '14053', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 811.666, '-23,66300', '-52,60500', 543, 'S', 0.8180, NULL, NULL, '41900', 'N', 'N', 1255, NULL, '4190', '4190', NULL, '1955', 'S', 3260, 'CIANORTE', 'N', '410550', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '77', NULL, '02', 'N', NULL, NULL, NULL, 142);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410560', '4113', 'PR', '4190', '4101', '41003', '41', 'CIDADE GAUCHA', NULL, '44', '87820000', '7', '7507', '7507', '14054', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 403.044, '-23,38000', '-52,94500', 404, 'S', 0.7490, NULL, NULL, '41900', 'N', 'N', 1257, NULL, '4190', '4190', NULL, '1960', 'S', 3261, 'CIDADE GAÚCHA', 'N', '410560', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '78', NULL, '03', 'N', NULL, NULL, NULL, 142);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410570', '4107', 'PR', '4190', '4108', '41030', '41', 'CLEVELANDIA', NULL, '46', '85530000', '6', '7509', '7509', '14055', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 704.634, '-26,39600', '-52,47100', 967, 'S', 0.7300, NULL, NULL, '41900', 'N', 'N', 1269, NULL, '4190', '4190', NULL, '1892', 'S', 3262, 'CLEVELÂNDIA', 'N', '410570', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '79', NULL, '03', 'N', NULL, NULL, NULL, 268);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410580', '4102', 'PR', '4190', '4110', '41037', '41', 'COLOMBO', NULL, '41', '83414970', '5', '7513', '7513', '14057', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 198.007, '-25,29200', '-49,22400', 1027, 'S', 0.7640, NULL, NULL, '41900', 'N', 'N', 1295, NULL, '4101', '4101', NULL, '1890', 'S', 3263, 'COLOMBO', 'N', '410580', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '80', NULL, '01', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410590', '4115', 'PR', '4190', '4103', '41006', '41', 'COLORADO', NULL, '44', '86690000', '4', '7515', '7515', '14058', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 403.263, '-22,83800', '-51,97300', 400, 'S', 0.7820, NULL, NULL, '41900', 'N', 'N', 1300, NULL, '4190', '4190', NULL, '1954', 'S', 3264, 'COLORADO', 'N', '410590', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '81', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410600', '4118', 'PR', '4190', '4104', '41015', '41', 'CONGONHINHAS', NULL, '43', '86320000', '1', '7517', '7517', '14059', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 535.959, '-23,55100', '-50,55400', 753, 'S', 0.6920, NULL, NULL, '41900', 'S', 'N', 1346, NULL, '4190', '4190', NULL, '1920', 'S', 3265, 'CONGONHINHAS', 'N', '410600', 'N', 'N', 'S', NULL, 146, 'N', 'N', 'N', '82', NULL, '03', 'N', NULL, NULL, NULL, 31);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410980', '4117', 'PR', '4190', '4103', '41011', '41', 'IBIPORA', NULL, '43', '86200000', '7', '7591', '7591', '14096', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 300.187, '-23,26900', '-51,04800', 497, 'S', 0.8010, NULL, NULL, '41900', 'N', 'N', 2079, NULL, '4102', '4103', NULL, '1947', 'S', 3326, 'IBIPORÃ', 'N', '410980', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '143', NULL, '03', 'N', NULL, NULL, NULL, 374);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410610', '4119', 'PR', '4190', '4104', '41017', '41', 'CONSELHEIRO MAIRINCK', NULL, '43', '86480000', '0', '7519', '7519', '14060', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 204.705, '-23,63000', '-50,16900', 520, 'S', 0.7070, NULL, NULL, '41900', 'N', 'N', 1349, NULL, '4190', '4190', NULL, '1960', 'S', 3266, 'CONSELHEIRO MAIRINCK', 'N', '410610', 'N', 'N', 'S', NULL, 146, 'N', 'N', 'N', '83', NULL, '03', 'N', NULL, NULL, NULL, 427);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410620', '4102', 'PR', '4190', '4110', '41037', '41', 'CONTENDA', NULL, '41', '83730000', '9', '7521', '7521', '14061', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 299.037, '-25,67600', '-49,53500', 883, 'S', 0.7610, NULL, NULL, '41900', 'N', 'N', 1354, NULL, '4101', '4101', NULL, '1951', 'S', 3267, 'CONTENDA', 'N', '410620', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '84', NULL, '01', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410630', '4110', 'PR', '4190', '4106', '41023', '41', 'CORBELIA', NULL, '45', '85420000', '8', '7523', '7523', '14062', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 529.385, '-24,79900', '-53,30700', 895, 'S', 0.7670, NULL, NULL, '41900', 'N', 'N', 1361, NULL, '4190', '4190', NULL, '1961', 'S', 3268, 'CORBÉLIA', 'N', '410630', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '85', NULL, '03', 'N', NULL, NULL, NULL, 258);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410640', '4118', 'PR', '4190', '4104', '41015', '41', 'CORNELIO PROCOPIO', NULL, '43', '86300000', '7', '7525', '7525', '14063', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 637.322, '-23,18100', '-50,64700', 676, 'S', 0.7910, NULL, NULL, '41900', 'N', 'N', 1373, NULL, '4190', '4190', NULL, '1934', 'S', 3269, 'CORNÉLIO PROCÓPIO', 'N', '410640', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '86', NULL, '03', 'N', NULL, NULL, NULL, 31);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410645', '4107', 'PR', '4190', '4108', '41030', '41', 'CORONEL DOMINGOS SOARES', NULL, '46', '85557000', '6', '0846', NULL, '14366', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1557.894, '-26,22800', '-52,03200', 1113, 'S', 0.7040, NULL, NULL, '41900', 'N', 'N', 1380, NULL, '4190', '4190', NULL, '1997', 'S', 3270, 'CORONEL DOMINGOS SOARES', 'N', '410645', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '87', NULL, '03', 'N', NULL, NULL, NULL, 268);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410650', '4107', 'PR', '4190', '4107', '41027', '41', 'CORONEL VIVIDA', NULL, '46', '85550000', '6', '7527', '7527', '14064', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 684.417, '-25,98000', '-52,56800', 700, 'S', 0.7750, NULL, NULL, '41900', 'N', 'N', 1392, NULL, '4190', '4190', NULL, '1954', 'S', 3271, 'CORONEL VIVIDA', 'N', '410650', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '88', NULL, '03', 'N', NULL, NULL, NULL, 268);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410655', '4111', 'PR', '4190', '4102', '41005', '41', 'CORUMBATAI DO SUL', NULL, '44', '86970000', '5', '8479', '8479', '14318', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 164.442, '-24,10100', '-52,12000', 601, 'S', 0.6780, NULL, NULL, '41900', 'S', 'N', 1408, NULL, '4190', '4190', NULL, '1989', 'S', 3272, 'CORUMBATAÍ DO SUL', 'N', '410655', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '89', NULL, '03', 'N', NULL, NULL, NULL, 141);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410657', '4108', 'PR', '4190', '4107', '41026', '41', 'CRUZEIRO DO IGUACU', NULL, '46', '85598000', '1', '5473', '5473', '14330', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 161.493, '-25,61600', '-53,12800', 535, 'S', 0.7370, NULL, NULL, '41900', 'N', 'N', 1461, NULL, '4190', '4190', NULL, '1993', 'S', 3274, 'CRUZEIRO DO IGUAÇU', 'N', '410657', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '91', NULL, '03', 'N', NULL, NULL, NULL, 34);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410660', '4112', 'PR', '4190', '4101', '41002', '41', 'CRUZEIRO DO OESTE', NULL, '44', '87400000', '5', '7529', '7529', '14065', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 779.222, '-23,78500', '-53,07300', 438, 'S', 0.7510, NULL, NULL, '41900', 'N', 'N', 1462, NULL, '4190', '4190', NULL, '1954', 'S', 3275, 'CRUZEIRO DO OESTE', 'N', '410660', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '92', NULL, '03', 'N', NULL, NULL, NULL, 312);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410670', '4114', 'PR', '4190', '4101', '41001', '41', 'CRUZEIRO DO SUL', NULL, '44', '87650000', '4', '7531', '7531', '14066', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 258.780, '-22,96200', '-52,16100', 358, 'S', 0.7550, NULL, NULL, '41900', 'N', 'N', 1463, NULL, '4190', '4190', NULL, '1955', 'S', 3276, 'CRUZEIRO DO SUL', 'N', '410670', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '93', NULL, '03', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410680', '4106', 'PR', '4190', '4109', '41033', '41', 'CRUZ MACHADO', NULL, '42', '84620000', '3', '7533', '7533', '14067', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1478.351, '-26,01700', '-51,34700', 940, 'S', 0.7120, NULL, NULL, '41900', 'N', 'N', 1457, NULL, '4190', '4190', NULL, '1951', 'S', 3273, 'CRUZ MACHADO', 'N', '410680', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '90', NULL, '03', 'N', NULL, NULL, NULL, 33);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410685', '4122', 'PR', '4190', '4103', '41012', '41', 'CRUZMALTINA', NULL, '43', '86855000', '2', '0848', NULL, '14399', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 312.299, '-24,01300', '-51,45900', 690, 'S', 0.6780, NULL, NULL, '41900', 'S', 'N', 1468, NULL, '4190', '4190', NULL, '1997', 'S', 3277, 'CRUZMALTINA', 'N', '410685', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '94', NULL, '03', 'N', NULL, NULL, NULL, 316);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410690', '4102', 'PR', '4190', '4110', '41037', '41', 'CURITIBA', NULL, '41', '80001970', '2', '7535', '7535', '14068', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'S', 434.967, '-25,42800', '-49,27300', 934, 'S', 0.8560, NULL, NULL, '41900', 'N', 'N', 1488, NULL, '4101', '4101', NULL, '1693', 'S', 3278, 'CURITIBA', 'N', '410690', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '95', NULL, '01', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410700', '4121', 'PR', '4190', '4104', '41017', '41', 'CURIUVA', NULL, '43', '84280000', '9', '7537', '7537', '14069', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 576.261, '-24,03300', '-50,45800', 776, 'S', 0.6750, NULL, NULL, '41900', 'S', 'N', 1490, NULL, '4190', '4190', NULL, '1947', 'S', 3279, 'CURIÚVA', 'N', '410700', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '96', NULL, '03', 'N', NULL, NULL, NULL, 375);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410710', '4114', 'PR', '4190', '4101', '41001', '41', 'DIAMANTE DO NORTE', NULL, '44', '87990000', '8', '7539', '7539', '14070', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 242.894, '-22,65600', '-52,86000', 378, 'S', 0.7380, NULL, NULL, '41900', 'N', 'N', 1533, NULL, '4190', '4190', NULL, '1963', 'S', 3280, 'DIAMANTE DO NORTE', 'N', '410710', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '98', NULL, '03', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410712', '4110', 'PR', '4190', '4106', '41023', '41', 'DIAMANTE DO SUL', NULL, '45', '85408000', '4', '5465', '5465', '14331', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 359.945, '-25,04300', '-52,68000', 620, 'S', 0.6750, NULL, NULL, '41900', 'S', 'N', 1534, NULL, '4190', '4190', NULL, '1993', 'S', 3281, 'DIAMANTE DO SUL', 'N', '410712', 'N', 'N', 'S', NULL, 25, 'N', 'N', 'N', '99', NULL, '03', 'N', NULL, NULL, NULL, 258);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410715', '4120', 'PR', '4190', '4106', '41022', '41', 'DIAMANTE D''OESTE', NULL, '45', '85896000', '7', '9915', '9915', '14317', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 309.109, '-24,94300', '-54,10300', 521, 'S', 0.7090, NULL, NULL, '41900', 'N', 'N', 1532, NULL, '4190', '4190', NULL, '1989', 'S', 3282, 'DIAMANTE D OESTE', 'N', '410715', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '97', NULL, '03', 'N', NULL, NULL, NULL, 267);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410720', '4108', 'PR', '4190', '4107', '41026', '41', 'DOIS VIZINHOS', NULL, '46', '85660000', '7', '7541', '7541', '14071', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 418.320, '-25,73400', '-53,05700', 509, 'S', 0.7730, NULL, NULL, '41900', 'N', 'N', 1567, NULL, '4190', '4190', NULL, '1960', 'S', 3283, 'DOIS VIZINHOS', 'N', '410720', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '100', NULL, '03', 'N', NULL, NULL, NULL, 34);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410725', '4112', 'PR', '4190', '4101', '41002', '41', 'DOURADINA', NULL, '44', '87485000', '6', '8465', '8465', '14298', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 419.852, '-23,38100', '-53,29200', 406, 'S', 0.7400, NULL, NULL, '41900', 'N', 'N', 1598, NULL, '4190', '4190', NULL, '1979', 'S', 3284, 'DOURADINA', 'N', '410725', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '101', NULL, '03', 'N', NULL, NULL, NULL, 312);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410730', '4115', 'PR', '4190', '4103', '41008', '41', 'DOUTOR CAMARGO', NULL, '44', '87155000', '6', '7543', '7543', '14073', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 118.278, '-23,55600', '-52,21800', 381, 'S', 0.7670, NULL, NULL, '41900', 'N', 'N', 1602, NULL, '4103', '4190', NULL, '1964', 'S', 3285, 'DOUTOR CAMARGO', 'N', '410730', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '102', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410740', '4108', 'PR', '4190', '4107', '41026', '41', 'ENEAS MARQUES', NULL, '46', '85630000', '5', '7545', '7545', '14072', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 191.998, '-25,94200', '-53,16400', 758, 'S', 0.7820, NULL, NULL, '41900', 'N', 'N', 1642, NULL, '4190', '4190', NULL, '1964', 'S', 3287, 'ENÉAS MARQUES', 'N', '410740', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '104', NULL, '03', 'N', NULL, NULL, NULL, 34);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410750', '4111', 'PR', '4190', '4102', '41005', '41', 'ENGENHEIRO BELTRAO', NULL, '44', '87270000', '4', '7547', '7547', '14074', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 467.257, '-23,79700', '-52,26900', 470, 'S', 0.7620, NULL, NULL, '41900', 'N', 'N', 1643, NULL, '4190', '4190', NULL, '1954', 'S', 3288, 'ENGENHEIRO BELTRÃO', 'N', '410750', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '105', NULL, '03', 'N', NULL, NULL, NULL, 141);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410752', '4112', 'PR', '4190', '4101', '41002', '41', 'ESPERANCA NOVA', NULL, '44', '87545000', '0', '0850', NULL, '14367', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 138.560, '-23,72400', '-53,81100', 377, 'S', 0.7440, NULL, NULL, '41900', 'N', 'N', 1675, NULL, '4190', '4190', NULL, '1997', 'S', 3290, 'ESPERANÇA NOVA', 'N', '410752', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '107', NULL, '03', 'N', NULL, NULL, NULL, 312);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410753', '4120', 'PR', '4190', '4106', '41022', '41', 'ENTRE RIOS DO OESTE', NULL, '45', '85988000', '8', '5529', '5529', '14334', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 122.071, '-24,70400', '-54,23400', 230, 'S', 0.8470, NULL, NULL, '41900', 'N', 'N', 1653, NULL, '4190', '4190', NULL, '1993', 'S', 3289, 'ENTRE RIOS DO OESTE', 'N', '410753', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '106', NULL, '03', 'N', NULL, NULL, NULL, 267);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410754', '4110', 'PR', '4190', '4108', '41029', '41', 'ESPIGAO ALTO DO IGUACU', NULL, '46', '85465000', '6', '0852', '8524', '14400', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 326.446, '-25,42400', '-52,83600', 618, 'S', 0.7080, NULL, NULL, '41900', 'N', 'N', 1679, NULL, '4190', '4190', NULL, '1997', 'S', 3291, 'ESPIGÃO ALTO DO IGUAÇU', 'N', '410754', 'N', 'N', 'S', NULL, 25, 'N', 'N', 'N', '108', NULL, '03', 'N', NULL, NULL, NULL, 258);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410755', '4111', 'PR', '4190', '4102', '41005', '41', 'FAROL', NULL, '44', '87325000', '3', '5511', '5511', '14336', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 289.232, '-24,10000', '-52,62300', 600, 'S', 0.7010, NULL, NULL, '41900', 'N', 'N', 1721, NULL, '4190', '4190', NULL, '1993', 'S', 3292, 'FAROL', 'N', '410755', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '109', NULL, '03', 'N', NULL, NULL, NULL, 141);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410760', '4116', 'PR', '4190', '4103', '41012', '41', 'FAXINAL', NULL, '43', '86840000', '3', '7549', '7549', '14075', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 715.943, '-24,00100', '-51,32000', 840, 'S', 0.7320, NULL, NULL, '41900', 'N', 'N', 1728, NULL, '4190', '4190', NULL, '1951', 'S', 3293, 'FAXINAL', 'N', '410760', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '110', NULL, '03', 'N', NULL, NULL, NULL, 373);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410765', '4102', 'PR', '4190', '4110', '41037', '41', 'FAZENDA RIO GRANDE', NULL, '41', '83820000', '2', '9983', '9983', '14335', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 116.676, '-25,65800', '-49,30800', 910, 'S', 0.7630, NULL, NULL, '41900', 'N', 'N', 1733, NULL, '4101', '4101', NULL, '1993', 'S', 3294, 'FAZENDA RIO GRANDE', 'N', '410765', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '111', NULL, '01', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410770', '4111', 'PR', '4190', '4102', '41005', '41', 'FENIX', NULL, '44', '86950000', '2', '7551', '7551', '14076', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 234.098, '-23,91600', '-51,97900', 365, 'S', 0.7360, NULL, NULL, '41900', 'N', 'N', 1749, NULL, '4190', '4190', NULL, '1960', 'S', 3295, 'FÊNIX', 'N', '410770', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '112', NULL, '03', 'N', NULL, NULL, NULL, 141);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410773', '4104', 'PR', '4190', '4109', '41031', '41', 'FERNANDES PINHEIRO', NULL, '42', '84535000', '6', '0854', NULL, '14401', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 406.501, '-25,41300', '-50,54800', 824, 'S', 0.7110, NULL, NULL, '41900', 'N', 'N', 1750, NULL, '4190', '4190', NULL, '1997', 'S', 3296, 'FERNANDES PINHEIRO', 'N', '410773', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '113', NULL, '03', 'N', NULL, NULL, NULL, 79);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410775', '4119', 'PR', '4190', '4104', '41017', '41', 'FIGUEIRA', NULL, '43', '84285000', '1', '8457', '8457', '14307', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 129.806, '-23,84900', '-50,40300', 620, 'S', 0.7110, NULL, NULL, '41900', 'N', 'N', 1763, NULL, '4190', '4190', NULL, '1982', 'S', 3297, 'FIGUEIRA', 'N', '410775', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '114', NULL, '03', 'N', NULL, NULL, NULL, 427);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410780', '4115', 'PR', '4190', '4103', '41008', '41', 'FLORAI', NULL, '44', '87185000', '1', '7553', '7553', '14077', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 191.133, '-23,31700', '-52,30400', 482, 'S', 0.7710, NULL, NULL, '41900', 'N', 'N', 1774, NULL, '4103', '4190', NULL, '1951', 'S', 3299, 'FLORAÍ', 'N', '410780', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '116', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410785', '4108', 'PR', '4190', '4107', '41026', '41', 'FLOR DA SERRA DO SUL', NULL, '46', '85618000', '0', '5475', '5475', '14337', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 254.886, '-26,25700', '-53,30700', 905, 'S', 0.7320, NULL, NULL, '41900', 'N', 'N', 1771, NULL, '4190', '4190', NULL, '1993', 'S', 3298, 'FLOR DA SERRA DO SUL', 'N', '410785', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '115', NULL, '03', 'N', NULL, NULL, NULL, 34);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410790', '4115', 'PR', '4190', '4103', '41008', '41', 'FLORESTA', NULL, '44', '87120000', '0', '7555', '7555', '14078', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 158.092, '-23,59900', '-52,08100', 392, 'S', 0.7730, NULL, NULL, '41900', 'N', 'N', 1781, NULL, '4103', '4190', NULL, '1960', 'S', 3300, 'FLORESTA', 'N', '410790', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '117', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410800', '4117', 'PR', '4190', '4103', '41007', '41', 'FLORESTOPOLIS', NULL, '43', '86165000', '7', '7557', '7557', '14079', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 246.329, '-22,86300', '-51,38700', 515, 'S', 0.7260, NULL, NULL, '41900', 'N', 'N', 1787, NULL, '4190', '4190', NULL, '1951', 'S', 3301, 'FLORESTÓPOLIS', 'N', '410800', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '118', NULL, '03', 'N', NULL, NULL, NULL, 374);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410810', '4115', 'PR', '4190', '4103', '41006', '41', 'FLORIDA', NULL, '44', '86780000', '6', '7559', '7559', '14080', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 83.046, '-23,08700', '-51,95400', 460, 'S', 0.7750, NULL, NULL, '41900', 'N', 'N', 1791, NULL, '4103', '4190', NULL, '1960', 'S', 3302, 'FLÓRIDA', 'N', '410810', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '119', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410820', '4110', 'PR', '4190', '4106', '41022', '41', 'FORMOSA DO OESTE', NULL, '44', '85830000', '5', '7561', '7561', '14081', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 275.712, '-24,29300', '-53,31300', 422, 'S', 0.7880, NULL, NULL, '41900', 'N', 'N', 1800, NULL, '4190', '4190', NULL, '1961', 'S', 3303, 'FORMOSA DO OESTE', 'N', '410820', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '120', NULL, '03', 'N', NULL, NULL, NULL, 258);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410830', '4109', 'PR', '4190', '4106', '41024', '41', 'FOZ DO IGUACU', NULL, '45', '85851970', '4', '7563', '7563', '14082', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 617.701, '-25,54800', '-54,58800', 164, 'S', 0.7880, NULL, NULL, '41900', 'N', 'N', 1816, NULL, '4190', '4190', NULL, '1914', 'S', 3304, 'FOZ DO IGUAÇU', 'N', '410830', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '121', NULL, '01', 'N', NULL, NULL, NULL, 80);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410832', '4112', 'PR', '4190', '4101', '41002', '41', 'FRANCISCO ALVES', NULL, '44', '87570000', '0', '7977', '7977', '14289', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 321.898, '-24,06600', '-53,84800', 331, 'S', 0.7360, NULL, NULL, '41900', 'N', 'N', 1821, NULL, '4190', '4190', NULL, '1972', 'S', 3306, 'FRANCISCO ALVES', 'N', '410832', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '123', NULL, '03', 'N', NULL, NULL, NULL, 312);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410840', '4108', 'PR', '4190', '4107', '41026', '41', 'FRANCISCO BELTRAO', NULL, '46', '85601970', '3', '7565', '7565', '14083', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 734.988, '-26,08100', '-53,05500', 570, 'S', 0.7910, NULL, NULL, '41900', 'N', 'N', 1824, NULL, '4190', '4190', NULL, '1951', 'S', 3307, 'FRANCISCO BELTRÃO', 'N', '410840', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '124', NULL, '02', 'N', NULL, NULL, NULL, 34);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410845', '4105', 'PR', '4190', '4108', '41029', '41', 'FOZ DO JORDAO', NULL, '42', '85145000', '2', '0856', NULL, '14402', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 235.399, '-25,73700', '-52,11900', 820, 'S', 0.6890, NULL, NULL, '41900', 'S', 'N', 1817, NULL, '4190', '4190', NULL, '1997', 'S', 3305, 'FOZ DO JORDÃO', 'N', '410845', 'N', 'N', 'S', NULL, 25, 'N', 'N', 'N', '122', NULL, '03', 'N', NULL, NULL, NULL, 32);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410850', '4106', 'PR', '4190', '4109', '41033', '41', 'GENERAL CARNEIRO', NULL, '42', '84660000', '2', '7567', '7567', '14084', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1070.252, '-26,42800', '-51,31600', 983, 'S', 0.7110, NULL, NULL, '41900', 'N', 'N', 1876, NULL, '4190', '4190', NULL, '1961', 'S', 3308, 'GENERAL CARNEIRO', 'N', '410850', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '125', NULL, '03', 'N', NULL, NULL, NULL, 33);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410855', '4122', 'PR', '4190', '4103', '41013', '41', 'GODOY MOREIRA', NULL, '43', '86938000', '1', '9947', '9947', '14319', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 131.005, '-24,17700', '-51,92400', 512, 'S', 0.6720, NULL, NULL, '41900', 'S', 'N', 1895, NULL, '4190', '4190', NULL, '1990', 'S', 3309, 'GODOY MOREIRA', 'N', '410855', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '126', NULL, '03', 'N', NULL, NULL, NULL, 316);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410860', '4111', 'PR', '4190', '4102', '41004', '41', 'GOIOERE', NULL, '44', '87360000', '1', '7569', '7569', '14085', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 564.048, '-24,18500', '-53,02800', 505, 'S', 0.7460, NULL, NULL, '41900', 'N', 'N', 1910, NULL, '4190', '4190', NULL, '1955', 'S', 3310, 'GOIOERÊ', 'N', '410860', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '127', NULL, '03', 'N', NULL, NULL, NULL, 141);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410865', '4105', 'PR', '4190', '4108', '41029', '41', 'GOIOXIM', NULL, '42', '85162000', '0', '0858', NULL, '14403', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 702.470, '-25,19500', '-51,99300', 973, 'S', 0.6800, NULL, NULL, '41900', 'S', 'N', 1911, NULL, '4190', '4190', NULL, '1997', 'S', 3311, 'GOIOXIM', 'N', '410865', 'N', 'N', 'S', NULL, 25, 'N', 'N', 'N', '128', NULL, '03', 'N', NULL, NULL, NULL, 32);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410870', '4116', 'PR', '4190', '4103', '41013', '41', 'GRANDES RIOS', NULL, '43', '86845000', '0', '7959', '7959', '14280', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 309.312, '-24,14600', '-51,50600', 610, 'S', 0.6950, NULL, NULL, '41900', 'S', 'N', 1937, NULL, '4190', '4190', NULL, '1967', 'S', 3312, 'GRANDES RIOS', 'N', '410870', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '129', NULL, '03', 'N', NULL, NULL, NULL, 373);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410880', '4120', 'PR', '4190', '4106', '41022', '41', 'GUAIRA', NULL, '44', '85980000', '9', '7571', '7571', '14086', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 560.508, '-24,08000', '-54,25600', 220, 'S', 0.7770, NULL, NULL, '41900', 'N', 'N', 1957, NULL, '4190', '4190', NULL, '1951', 'S', 3313, 'GUAÍRA', 'N', '410880', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '130', NULL, '03', 'N', NULL, NULL, NULL, 267);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410890', '4114', 'PR', '4190', '4101', '41001', '41', 'GUAIRACA', NULL, '44', '87880000', '8', '7573', '7573', '14087', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 493.939, '-22,93400', '-52,68600', 470, 'S', 0.7080, NULL, NULL, '41900', 'N', 'N', 1958, NULL, '4190', '4190', NULL, '1960', 'S', 3314, 'GUAIRAÇÁ', 'N', '410890', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '131', NULL, '03', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410895', '4104', 'PR', '4190', '4109', '41031', '41', 'GUAMIRANGA', NULL, '42', '84435000', '7', '0860', NULL, '14404', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 259.632, '-25,19100', '-50,80500', 801, 'S', 0.7020, NULL, NULL, '41900', 'N', 'N', 1964, NULL, '4190', '4190', NULL, '1997', 'S', 3315, 'GUAMIRANGA', 'N', '410895', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '132', NULL, '03', 'N', NULL, NULL, NULL, 79);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410900', '4119', 'PR', '4190', '4104', '41018', '41', 'GUAPIRAMA', NULL, '43', '86465000', '5', '7575', '7575', '14088', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 189.099, '-23,51600', '-50,04000', 520, 'S', 0.7470, NULL, NULL, '41900', 'N', 'N', 1971, NULL, '4190', '4190', NULL, '1964', 'S', 3316, 'GUAPIRAMA', 'N', '410900', 'N', 'N', 'S', NULL, 146, 'N', 'N', 'N', '133', NULL, '03', 'N', NULL, NULL, NULL, 427);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410910', '4113', 'PR', '4190', '4101', '41003', '41', 'GUAPOREMA', NULL, '44', '87810000', '4', '7577', '7577', '14089', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 200.188, '-23,34300', '-52,77900', 405, 'S', 0.7250, NULL, NULL, '41900', 'N', 'N', 1974, NULL, '4190', '4190', NULL, '1961', 'S', 3317, 'GUAPOREMA', 'N', '410910', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '134', NULL, '03', 'N', NULL, NULL, NULL, 142);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410920', '4117', 'PR', '4190', '4103', '41006', '41', 'GUARACI', NULL, '43', '86620000', '3', '7579', '7579', '14090', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 211.733, '-22,97300', '-51,65000', 540, 'S', 0.7390, NULL, NULL, '41900', 'N', 'N', 1979, NULL, '4190', '4190', NULL, '1954', 'S', 3318, 'GUARACI', 'N', '410920', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '135', NULL, '03', 'N', NULL, NULL, NULL, 374);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410930', '4110', 'PR', '4190', '4106', '41023', '41', 'GUARANIACU', NULL, '45', '85400000', '2', '7581', '7581', '14091', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1225.607, '-25,10100', '-52,87800', 923, 'S', 0.7280, NULL, NULL, '41900', 'N', 'N', 1993, NULL, '4190', '4190', NULL, '1951', 'S', 3319, 'GUARANIAÇU', 'N', '410930', 'N', 'N', 'S', NULL, 25, 'N', 'N', 'N', '136', NULL, '03', 'N', NULL, NULL, NULL, 258);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410940', '4105', 'PR', '4190', '4108', '41029', '41', 'GUARAPUAVA', NULL, '42', '85010970', '1', '7583', '7583', '14092', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 3115.329, '-25,39500', '-51,45800', 1098, 'S', 0.7730, NULL, NULL, '41900', 'N', 'N', 1997, NULL, '4190', '4190', NULL, '1982', 'S', 3320, 'GUARAPUAVA', 'N', '410940', 'N', 'N', 'S', NULL, 68, 'N', 'N', 'N', '137', NULL, '01', 'N', NULL, NULL, NULL, 32);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410950', '4101', 'PR', '4190', '4110', '41038', '41', 'GUARAQUECABA', NULL, '41', '83390000', '0', '7585', '7585', '14093', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 2018.906, '-25,30700', '-48,32900', 20, 'S', 0.6590, NULL, NULL, '41900', 'S', 'N', 1998, NULL, '4190', '4190', NULL, '1947', 'S', 3321, 'GUARAQUEÇABA', 'N', '410950', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '138', NULL, '03', 'N', NULL, NULL, NULL, 428);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410960', '4101', 'PR', '4190', '4110', '41038', '41', 'GUARATUBA', NULL, '41', '83280000', '9', '7587', '7587', '14094', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1325.883, '-25,88300', '-48,57500', 15, 'S', 0.7640, NULL, NULL, '41900', 'N', 'N', 2004, NULL, '4190', '4190', NULL, '1771', 'S', 3322, 'GUARATUBA', 'N', '410960', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '139', NULL, '03', 'N', NULL, NULL, NULL, 428);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410965', '4107', 'PR', '4190', '4108', '41030', '41', 'HONORIO SERPA', NULL, '46', '85548000', '8', '9981', '9981', '14339', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 502.235, '-26,14100', '-52,38700', 816, 'S', 0.7100, NULL, NULL, '41900', 'N', 'N', 2040, NULL, '4190', '4190', NULL, '1993', 'S', 3323, 'HONÓRIO SERPA', 'N', '410965', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '140', NULL, '03', 'N', NULL, NULL, NULL, 268);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410970', '4119', 'PR', '4190', '4104', '41017', '41', 'IBAITI', NULL, '43', '84900000', '8', '7589', '7589', '14095', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 896.846, '-23,84900', '-50,18800', 760, 'S', 0.6870, NULL, NULL, '41900', 'S', 'N', 2056, NULL, '4190', '4190', NULL, '1947', 'S', 3324, 'IBAITI', 'N', '410970', 'N', 'N', 'S', NULL, 146, 'N', 'N', 'N', '141', NULL, '03', 'N', NULL, NULL, NULL, 427);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410975', '4110', 'PR', '4190', '4106', '41023', '41', 'IBEMA', NULL, '45', '85478000', '7', '9949', '9949', '14320', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 145.442, '-25,10600', '-53,01200', 910, 'S', 0.7210, NULL, NULL, '41900', 'N', 'N', 2062, NULL, '4190', '4190', NULL, '1990', 'S', 3325, 'IBEMA', 'N', '410975', 'N', 'N', 'S', NULL, 25, 'N', 'N', 'N', '142', NULL, '03', 'N', NULL, NULL, NULL, 258);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('410990', '4112', 'PR', '4190', '4101', '41002', '41', 'ICARAIMA', NULL, '44', '87530000', '6', '7593', '7593', '14097', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 675.241, '-23,39600', '-53,61400', 305, 'S', 0.7410, NULL, NULL, '41900', 'N', 'N', 2106, NULL, '4190', '4190', NULL, '1960', 'S', 3327, 'ICARAÍMA', 'N', '410990', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '144', NULL, '03', 'N', NULL, NULL, NULL, 312);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411000', '4115', 'PR', '4190', '4103', '41006', '41', 'IGUARACU', NULL, '44', '86750000', '3', '7595', '7595', '14098', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 164.983, '-23,19700', '-51,82800', 558, 'S', 0.7400, NULL, NULL, '41900', 'N', 'N', 2134, NULL, '4103', '4104', NULL, '1955', 'S', 3328, 'IGUARAÇU', 'N', '411000', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '145', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411005', '4110', 'PR', '4190', '4106', '41023', '41', 'IGUATU', NULL, '45', '85423000', '2', '5467', '5467', '14340', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 106.937, '-24,71700', '-53,08400', 420, 'S', 0.7010, NULL, NULL, '41900', 'N', 'N', 2137, NULL, '4190', '4190', NULL, '1993', 'S', 3329, 'IGUATU', 'N', '411005', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '146', NULL, '03', 'N', NULL, NULL, NULL, 258);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411007', '4121', 'PR', '4190', '4105', '41019', '41', 'IMBAU', NULL, '42', '84250000', '8', '0862', NULL, '14341', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 331.199, '-24,44500', '-50,76100', 940, 'S', 0.6460, NULL, NULL, '41900', 'S', 'N', 2152, NULL, '4190', '4190', NULL, '1997', 'S', 3330, 'IMBAÚ', 'N', '411007', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '147', NULL, '03', 'N', NULL, NULL, NULL, 375);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411010', '4104', 'PR', '4190', '4109', '41031', '41', 'IMBITUVA', NULL, '42', '84430000', '2', '7597', '7597', '14099', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 756.531, '-25,23000', '-50,60400', 900, 'S', 0.7270, NULL, NULL, '41900', 'N', 'N', 2156, NULL, '4190', '4190', NULL, '1881', 'S', 3331, 'IMBITUVA', 'N', '411010', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '148', NULL, '03', 'N', NULL, NULL, NULL, 79);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411020', '4104', 'PR', '4190', '4108', '41029', '41', 'INACIO MARTINS', NULL, '42', '85155000', '1', '7599', '7599', '14100', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 936.913, '-25,57100', '-51,07900', 1202, 'S', 0.6900, NULL, NULL, '41900', 'S', 'N', 2160, NULL, '4190', '4190', NULL, '1960', 'S', 3332, 'INÁCIO MARTINS', 'N', '411020', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '149', NULL, '03', 'N', NULL, NULL, NULL, 79);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411030', '4114', 'PR', '4190', '4101', '41001', '41', 'INAJA', NULL, '44', '87670000', '0', '7601', '7601', '14101', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 194.705, '-22,74900', '-52,19800', 408, 'S', 0.7220, NULL, NULL, '41900', 'N', 'N', 2162, NULL, '4190', '4190', NULL, '1961', 'S', 3333, 'INAJÁ', 'N', '411030', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '150', NULL, '03', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411040', '4113', 'PR', '4190', '4101', '41003', '41', 'INDIANOPOLIS', NULL, '44', '87210000', '9', '7961', '7961', '14281', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 122.623, '-23,47600', '-52,69600', 469, 'S', 0.7490, NULL, NULL, '41900', 'N', 'N', 2172, NULL, '4190', '4190', NULL, '1967', 'S', 3334, 'INDIANÓPOLIS', 'N', '411040', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '151', NULL, '03', 'N', NULL, NULL, NULL, 142);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411050', '4103', 'PR', '4190', '4109', '41031', '41', 'IPIRANGA', NULL, '42', '84450000', '8', '7603', '7603', '14102', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 927.086, '-25,02400', '-50,58400', 800, 'S', 0.7280, NULL, NULL, '41900', 'N', 'N', 2209, NULL, '4190', '4190', NULL, '1894', 'S', 3335, 'IPIRANGA', 'N', '411050', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '152', NULL, '03', 'N', NULL, NULL, NULL, 146);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411060', '4112', 'PR', '4190', '4101', '41002', '41', 'IPORA', NULL, '44', '87560000', '7', '7605', '7605', '14103', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 647.894, '-24,00300', '-53,70400', 341, 'S', 0.7500, NULL, NULL, '41900', 'N', 'N', 2216, NULL, '4190', '4190', NULL, '1960', 'S', 3336, 'IPORÃ', 'N', '411060', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '153', NULL, '03', 'N', NULL, NULL, NULL, 312);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411065', '4110', 'PR', '4190', '4106', '41022', '41', 'IRACEMA DO OESTE', NULL, '44', '85833000', '6', '5485', '5485', '14342', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 81.538, '-24,42800', '-53,35500', 498, 'S', 0.7000, NULL, NULL, '41900', 'S', 'N', 2231, NULL, '4190', '4190', NULL, '1993', 'S', 3337, 'IRACEMA DO OESTE', 'N', '411065', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '154', NULL, '03', 'N', NULL, NULL, NULL, 258);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411070', '4104', 'PR', '4190', '4109', '41032', '41', 'IRATI', NULL, '42', '84500000', '6', '7607', '7607', '14104', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 999.515, '-25,46700', '-50,65100', 820, 'S', 0.7430, NULL, NULL, '41900', 'N', 'N', 2244, NULL, '4190', '4190', NULL, '1907', 'S', 3338, 'IRATI', 'N', '411070', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '155', NULL, '02', 'N', NULL, NULL, NULL, 79);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411080', '4111', 'PR', '4190', '4102', '41005', '41', 'IRETAMA', NULL, '44', '87280000', '5', '7609', '7609', '14105', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 570.459, '-24,42400', '-52,10600', 595, 'S', 0.6990, NULL, NULL, '41900', 'S', 'N', 2248, NULL, '4190', '4190', NULL, '1960', 'S', 3339, 'IRETAMA', 'N', '411080', 'N', 'N', 'S', NULL, 68, 'N', 'N', 'N', '156', NULL, '03', 'N', NULL, NULL, NULL, 141);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411090', '4115', 'PR', '4190', '4103', '41006', '41', 'ITAGUAJE', NULL, '44', '86670000', '4', '7611', '7611', '14106', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 190.370, '-22,61800', '-51,96600', 349, 'S', 0.7230, NULL, NULL, '41900', 'N', 'N', 2283, NULL, '4190', '4190', NULL, '1954', 'S', 3340, 'ITAGUAJÉ', 'N', '411090', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '157', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411095', '4109', 'PR', '4190', '4106', '41024', '41', 'ITAIPULANDIA', NULL, '45', '85880000', '3', '5525', '5525', '14387', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 336.173, '-25,13700', '-54,30200', 258, 'S', 0.7600, NULL, NULL, '41900', 'N', 'N', 2295, NULL, '4190', '4190', NULL, '1993', 'S', 3341, 'ITAIPULÂNDIA', 'N', '411095', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '158', NULL, '03', 'N', NULL, NULL, NULL, 80);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411100', '4118', 'PR', '4190', '4104', '41015', '41', 'ITAMBARACA', NULL, '43', '86375000', '1', '7613', '7613', '14107', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 207.003, '-23,01800', '-50,40600', 402, 'S', 0.7150, NULL, NULL, '41900', 'N', 'N', 2314, NULL, '4190', '4190', NULL, '1955', 'S', 3342, 'ITAMBARACÁ', 'N', '411100', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '159', NULL, '03', 'N', NULL, NULL, NULL, 31);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411110', '4115', 'PR', '4190', '4103', '41008', '41', 'ITAMBE', NULL, '44', '87175000', '0', '7615', '7615', '14108', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 243.821, '-23,66100', '-51,99000', 428, 'S', 0.7690, NULL, NULL, '41900', 'N', 'N', 2315, NULL, '4103', '4190', NULL, '1960', 'S', 3343, 'ITAMBÉ', 'N', '411110', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '160', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411120', '4107', 'PR', '4190', '4107', '41027', '41', 'ITAPEJARA D''OESTE', NULL, '46', '85580000', '9', '7617', '7617', '14109', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 254.077, '-25,96500', '-52,81600', 670, 'S', 0.7860, NULL, NULL, '41900', 'N', 'N', 2338, NULL, '4190', '4190', NULL, '1964', 'S', 3344, 'ITAPEJARA D OESTE', 'N', '411120', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '161', NULL, '03', 'N', NULL, NULL, NULL, 268);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411125', '4102', 'PR', '4190', '4110', '41037', '41', 'ITAPERUCU', NULL, '41', '83560000', '8', '5451', '5451', '14369', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 312.382, '-25,22000', '-49,34800', 995, 'S', 0.6750, NULL, NULL, '41900', 'S', 'N', 2341, NULL, '4101', '4101', NULL, '1993', 'S', 3345, 'ITAPERUÇU', 'N', '411125', 'N', 'N', 'S', NULL, 101, 'N', 'N', 'N', '162', NULL, '01', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411130', '4114', 'PR', '4190', '4101', '41001', '41', 'ITAUNA DO SUL', NULL, '44', '87980000', '8', '7619', '7619', '14110', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 128.870, '-22,73100', '-52,88700', 482, 'S', 0.7080, NULL, NULL, '41900', 'N', 'N', 2399, NULL, '4190', '4190', NULL, '1961', 'S', 3346, 'ITAÚNA DO SUL', 'N', '411130', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '163', NULL, '03', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411140', '4103', 'PR', '4190', '4109', '41031', '41', 'IVAI', NULL, '42', '84460000', '7', '7621', '7621', '14111', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 607.847, '-25,01100', '-50,85900', 748, 'S', 0.7010, NULL, NULL, '41900', 'N', 'N', 2425, NULL, '4190', '4190', NULL, '1961', 'S', 3347, 'IVAÍ', 'N', '411140', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '164', NULL, '03', 'N', NULL, NULL, NULL, 146);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411150', '4122', 'PR', '4190', '4103', '41013', '41', 'IVAIPORA', NULL, '43', '86870000', '6', '7623', '7623', '14112', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 432.470, '-24,24800', '-51,68500', 692, 'S', 0.7640, NULL, NULL, '41900', 'N', 'N', 2426, NULL, '4190', '4190', NULL, '1960', 'S', 3348, 'IVAIPORÃ', 'N', '411150', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '165', NULL, '03', 'N', NULL, NULL, NULL, 316);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411155', '4112', 'PR', '4190', '4101', '41002', '41', 'IVATE', NULL, '44', '87525000', '5', '9955', '9955', '14321', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 410.907, '-23,40900', '-53,36900', 410, 'S', 0.7520, NULL, NULL, '41900', 'N', 'N', 2427, NULL, '4190', '4190', NULL, '1993', 'S', 3349, 'IVATÉ', 'N', '411155', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '166', NULL, '03', 'N', NULL, NULL, NULL, 312);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411160', '4115', 'PR', '4190', '4103', '41008', '41', 'IVATUBA', NULL, '44', '87130000', '5', '7625', '7625', '14113', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 96.786, '-23,61900', '-52,22100', 340, 'S', 0.7680, NULL, NULL, '41900', 'N', 'N', 2428, NULL, '4103', '4190', NULL, '1960', 'S', 3350, 'IVATUBA', 'N', '411160', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '167', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411170', '4119', 'PR', '4190', '4104', '41017', '41', 'JABOTI', NULL, '43', '84930000', '4', '7627', '7627', '14114', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 139.210, '-23,74300', '-50,07600', 560, 'S', 0.6990, NULL, NULL, '41900', 'S', 'N', 2437, NULL, '4190', '4190', NULL, '1954', 'S', 3351, 'JABOTI', 'N', '411170', 'N', 'N', 'S', NULL, 146, 'N', 'N', 'N', '168', NULL, '03', 'N', NULL, NULL, NULL, 427);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411180', '4119', 'PR', '4190', '4104', '41016', '41', 'JACAREZINHO', NULL, '43', '86400000', '3', '7629', '7629', '14115', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 602.526, '-23,16100', '-49,96900', 501, 'S', 0.7820, NULL, NULL, '41900', 'N', 'N', 2447, NULL, '4190', '4190', NULL, '1900', 'S', 3352, 'JACAREZINHO', 'N', '411180', 'N', 'N', 'S', NULL, 146, 'N', 'N', 'N', '169', NULL, '03', 'N', NULL, NULL, NULL, 427);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411190', '4117', 'PR', '4190', '4103', '41006', '41', 'JAGUAPITA', NULL, '43', '86610000', '2', '7631', '7631', '14116', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 475.004, '-23,11300', '-51,53200', 610, 'S', 0.7610, NULL, NULL, '41900', 'N', 'N', 2460, NULL, '4190', '4190', NULL, '1947', 'S', 3353, 'JAGUAPITÃ', 'N', '411190', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '170', NULL, '03', 'N', NULL, NULL, NULL, 374);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411200', '4103', 'PR', '4190', '4105', '41020', '41', 'JAGUARIAIVA', NULL, '43', '84200000', '9', '7633', '7633', '14117', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1523.793, '-24,25100', '-49,70600', 850, 'S', 0.7570, NULL, NULL, '41900', 'N', 'N', 2468, NULL, '4190', '4190', NULL, '1875', 'S', 3354, 'JAGUARIAÍVA', 'N', '411200', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '171', NULL, '03', 'N', NULL, NULL, NULL, 146);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411210', '4116', 'PR', '4190', '4103', '41010', '41', 'JANDAIA DO SUL', NULL, '43', '86900000', '8', '7635', '7635', '14118', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 187.600, '-23,60300', '-51,64300', 807, 'S', 0.7830, NULL, NULL, '41900', 'N', 'N', 2482, NULL, '4103', '4190', NULL, '1951', 'S', 3355, 'JANDAIA DO SUL', 'N', '411210', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '172', NULL, '03', 'N', NULL, NULL, NULL, 373);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411220', '4111', 'PR', '4190', '4102', '41004', '41', 'JANIOPOLIS', NULL, '44', '87380000', '7', '7637', '7637', '14119', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 335.613, '-24,14200', '-52,78200', 560, 'S', 0.6920, NULL, NULL, '41900', 'S', 'N', 2488, NULL, '4190', '4190', NULL, '1961', 'S', 3356, 'JANIÓPOLIS', 'N', '411220', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '173', NULL, '03', 'N', NULL, NULL, NULL, 141);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411230', '4119', 'PR', '4190', '4104', '41017', '41', 'JAPIRA', NULL, '43', '84920000', '6', '7639', '7639', '14120', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 189.139, '-23,81300', '-50,13900', 660, 'S', 0.7060, NULL, NULL, '41900', 'N', 'N', 2495, NULL, '4190', '4190', NULL, '1951', 'S', 3357, 'JAPIRA', 'N', '411230', 'N', 'N', 'S', NULL, 146, 'N', 'N', 'N', '174', NULL, '03', 'N', NULL, NULL, NULL, 427);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411240', '4113', 'PR', '4190', '4101', '41003', '41', 'JAPURA', NULL, '44', '87225000', '5', '7641', '7641', '14121', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 165.184, '-23,47000', '-52,55300', 344, 'S', 0.7590, NULL, NULL, '41900', 'N', 'N', 2499, NULL, '4190', '4190', NULL, '1963', 'S', 3358, 'JAPURÁ', 'N', '411240', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '175', NULL, '03', 'N', NULL, NULL, NULL, 142);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411250', '4122', 'PR', '4190', '4103', '41013', '41', 'JARDIM ALEGRE', NULL, '43', '86860000', '4', '7643', '7643', '14122', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 393.620, '-24,17900', '-51,69200', 652, 'S', 0.7130, NULL, NULL, '41900', 'N', 'N', 2509, NULL, '4190', '4190', NULL, '1964', 'S', 3359, 'JARDIM ALEGRE', 'N', '411250', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '176', NULL, '03', 'N', NULL, NULL, NULL, 316);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411260', '4114', 'PR', '4190', '4101', '41001', '41', 'JARDIM OLINDA', NULL, '44', '87690000', '3', '7645', '7645', '14123', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 128.515, '-22,54900', '-52,06100', 260, 'S', 0.7240, NULL, NULL, '41900', 'N', 'N', 2514, NULL, '4190', '4190', NULL, '1964', 'S', 3360, 'JARDIM OLINDA', 'N', '411260', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '177', NULL, '03', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411270', '4117', 'PR', '4190', '4104', '41014', '41', 'JATAIZINHO', NULL, '43', '86210000', '2', '7647', '7647', '14124', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 159.180, '-23,25400', '-50,98000', 352, 'S', 0.7330, NULL, NULL, '41900', 'N', 'N', 2521, NULL, '4102', '4103', NULL, '1947', 'S', 3361, 'JATAIZINHO', 'N', '411270', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '178', NULL, '03', 'N', NULL, NULL, NULL, 374);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411275', '4110', 'PR', '4190', '4106', '41022', '41', 'JESUITAS', NULL, '44', '85835000', '1', '7997', '7997', '14292', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 247.496, '-24,38500', '-53,38800', 489, 'S', 0.7620, NULL, NULL, '41900', 'N', 'N', 2547, NULL, '4190', '4190', NULL, '1980', 'S', 3362, 'JESUÍTAS', 'N', '411275', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '179', NULL, '03', 'N', NULL, NULL, NULL, 258);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411280', '4119', 'PR', '4190', '4104', '41018', '41', 'JOAQUIM TAVORA', NULL, '43', '86455000', '1', '7649', '7649', '14125', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 289.173, '-23,49900', '-49,90500', 620, 'S', 0.7550, NULL, NULL, '41900', 'N', 'N', 2572, NULL, '4190', '4190', NULL, '1929', 'S', 3363, 'JOAQUIM TÁVORA', 'N', '411280', 'N', 'N', 'S', NULL, 146, 'N', 'N', 'N', '180', NULL, '03', 'N', NULL, NULL, NULL, 427);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411290', '4119', 'PR', '4190', '4104', '41016', '41', 'JUNDIAI DO SUL', NULL, '43', '86470000', '0', '7651', '7651', '14126', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 320.815, '-23,43700', '-50,24800', 520, 'S', 0.7210, NULL, NULL, '41900', 'N', 'N', 2609, NULL, '4190', '4190', NULL, '1947', 'S', 3364, 'JUNDIAÍ DO SUL', 'N', '411290', 'N', 'N', 'S', NULL, 146, 'N', 'N', 'N', '181', NULL, '03', 'N', NULL, NULL, NULL, 427);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411295', '4111', 'PR', '4190', '4102', '41004', '41', 'JURANDA', NULL, '44', '87355000', '9', '8463', '8463', '14293', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 349.721, '-24,42000', '-52,84300', 521, 'S', 0.7310, NULL, NULL, '41900', 'N', 'N', 2617, NULL, '4190', '4190', NULL, '1981', 'S', 3365, 'JURANDA', 'N', '411295', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '182', NULL, '03', 'N', NULL, NULL, NULL, 141);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411300', '4113', 'PR', '4190', '4101', '41003', '41', 'JUSSARA', NULL, '44', '87230000', '7', '7653', '7653', '14127', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 210.812, '-23,62100', '-52,46900', 382, 'S', 0.7680, NULL, NULL, '41900', 'N', 'N', 2629, NULL, '4190', '4190', NULL, '1955', 'S', 3366, 'JUSSARA', 'N', '411300', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '183', NULL, '03', 'N', NULL, NULL, NULL, 142);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411310', '4116', 'PR', '4190', '4103', '41012', '41', 'KALORE', NULL, '43', '86920000', '6', '7655', '7655', '14128', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 193.299, '-23,81700', '-51,66800', 520, 'S', 0.7530, NULL, NULL, '41900', 'N', 'N', 2635, NULL, '4190', '4190', NULL, '1961', 'S', 3367, 'KALORÉ', 'N', '411310', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '184', NULL, '03', 'N', NULL, NULL, NULL, 373);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411320', '4102', 'PR', '4190', '4110', '41036', '41', 'LAPA', NULL, '41', '83750000', '5', '7657', '7657', '14129', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2045.893, '-25,77000', '-49,71600', 908, 'S', 0.7540, NULL, NULL, '41900', 'N', 'N', 2704, NULL, '4101', '4190', NULL, '1806', 'S', 3368, 'LAPA', 'N', '411320', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '185', NULL, '01', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411325', '4105', 'PR', '4190', '4108', '41028', '41', 'LARANJAL', NULL, '42', '85275000', '4', '5501', '5501', '14371', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 559.505, '-24,88700', '-52,46900', 740, 'S', 0.6510, NULL, NULL, '41900', 'S', 'N', 2707, NULL, '4190', '4190', NULL, '1993', 'S', 3369, 'LARANJAL', 'N', '411325', 'N', 'N', 'S', NULL, 68, 'N', 'N', 'N', '186', NULL, '03', 'N', NULL, NULL, NULL, 32);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411330', '4105', 'PR', '4190', '4108', '41029', '41', 'LARANJEIRAS DO SUL', NULL, '42', '85301970', '4', '7659', '7659', '14130', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 671.121, '-25,40800', '-52,41600', 840, 'S', 0.7530, NULL, NULL, '41900', 'N', 'N', 2712, NULL, '4190', '4190', NULL, '1947', 'S', 3370, 'LARANJEIRAS DO SUL', 'N', '411330', 'N', 'N', 'S', NULL, 25, 'N', 'N', 'N', '187', NULL, '03', 'N', NULL, NULL, NULL, 32);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411340', '4118', 'PR', '4190', '4104', '41015', '41', 'LEOPOLIS', NULL, '43', '86330000', '3', '7661', '7661', '14131', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 344.920, '-23,08000', '-50,75100', 486, 'S', 0.7420, NULL, NULL, '41900', 'N', 'N', 2733, NULL, '4190', '4190', NULL, '1951', 'S', 3371, 'LEÓPOLIS', 'N', '411340', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '188', NULL, '03', 'N', NULL, NULL, NULL, 31);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411342', '4122', 'PR', '4190', '4103', '41013', '41', 'LIDIANOPOLIS', NULL, '43', '86865000', '9', '5507', '5507', '14343', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 169.138, '-24,10900', '-51,65300', 570, 'S', 0.7340, NULL, NULL, '41900', 'N', 'N', 2737, NULL, '4190', '4190', NULL, '1993', 'S', 3372, 'LIDIANÓPOLIS', 'N', '411342', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '189', NULL, '03', 'N', NULL, NULL, NULL, 316);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411345', '4110', 'PR', '4190', '4106', '41023', '41', 'LINDOESTE', NULL, '45', '85826000', '2', '9959', '9959', '14322', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 361.368, '-25,26000', '-53,57600', 585, 'S', 0.7150, NULL, NULL, '41900', 'N', 'N', 2746, NULL, '4190', '4190', NULL, '1990', 'S', 3373, 'LINDOESTE', 'N', '411345', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '190', NULL, '03', 'N', NULL, NULL, NULL, 258);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411350', '4114', 'PR', '4190', '4101', '41001', '41', 'LOANDA', NULL, '44', '87900000', '2', '7663', '7663', '14132', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 722.496, '-22,92300', '-53,13700', 495, 'S', 0.7710, NULL, NULL, '41900', 'N', 'N', 2756, NULL, '4190', '4190', NULL, '1954', 'S', 3374, 'LOANDA', 'N', '411350', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '191', NULL, '03', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411360', '4115', 'PR', '4190', '4103', '41006', '41', 'LOBATO', NULL, '44', '86790000', '1', '7665', '7665', '14133', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 240.904, '-23,00800', '-51,95100', 450, 'S', 0.7950, NULL, NULL, '41900', 'N', 'N', 2757, NULL, '4103', '4190', NULL, '1955', 'S', 3375, 'LOBATO', 'N', '411360', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '192', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411370', '4117', 'PR', '4190', '4103', '41011', '41', 'LONDRINA', NULL, '43', '86001970', '0', '7667', '7667', '14134', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1650.809, '-23,31000', '-51,16300', 585, 'S', 0.8240, NULL, NULL, '41900', 'N', 'N', 2759, NULL, '4102', '4103', NULL, '1934', 'S', 3376, 'LONDRINA', 'N', '411370', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '193', NULL, '01', 'N', NULL, NULL, NULL, 374);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411373', '4111', 'PR', '4190', '4102', '41005', '41', 'LUIZIANA', NULL, '44', '87290000', '4', '8481', '8481', '14314', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 908.604, '-24,28600', '-52,27600', 752, 'S', 0.7040, NULL, NULL, '41900', 'N', 'N', 2779, NULL, '4190', '4190', NULL, '1989', 'S', 3377, 'LUIZIANA', 'N', '411373', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '194', NULL, '03', 'N', NULL, NULL, NULL, 141);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411375', '4122', 'PR', '4190', '4103', '41013', '41', 'LUNARDELLI', NULL, '43', '86935000', '9', '8459', '8459', '14300', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 199.220, '-24,07900', '-51,73800', 640, 'S', 0.6920, NULL, NULL, '41900', 'S', 'N', 2782, NULL, '4190', '4190', NULL, '1979', 'S', 3378, 'LUNARDELLI', 'N', '411375', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '195', NULL, '03', 'N', NULL, NULL, NULL, 316);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411380', '4117', 'PR', '4190', '4103', '41006', '41', 'LUPIONOPOLIS', NULL, '43', '86635000', '9', '7669', '7669', '14135', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 121.067, '-22,75500', '-51,65700', 350, 'S', 0.7230, NULL, NULL, '41900', 'N', 'N', 2784, NULL, '4190', '4190', NULL, '1951', 'S', 3379, 'LUPIONÓPOLIS', 'N', '411380', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '196', NULL, '03', 'N', NULL, NULL, NULL, 374);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411390', '4104', 'PR', '4190', '4109', '41032', '41', 'MALLET', NULL, '42', '84570000', '8', '7671', '7671', '14136', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 723.085, '-25,87800', '-50,82100', 901, 'S', 0.7610, NULL, NULL, '41900', 'N', 'N', 2839, NULL, '4190', '4190', NULL, '1912', 'S', 3380, 'MALLET', 'N', '411390', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '197', NULL, '03', 'N', NULL, NULL, NULL, 79);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411400', '4111', 'PR', '4190', '4102', '41005', '41', 'MAMBORE', NULL, '44', '87340000', '5', '7673', '7673', '14137', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 778.683, '-24,31900', '-52,53000', 762, 'S', 0.7450, NULL, NULL, '41900', 'N', 'N', 2843, NULL, '4190', '4190', NULL, '1960', 'S', 3381, 'MAMBORÊ', 'N', '411400', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '198', NULL, '03', 'N', NULL, NULL, NULL, 141);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411410', '4115', 'PR', '4190', '4103', '41006', '41', 'MANDAGUACU', NULL, '44', '87160000', '4', '7675', '7675', '14138', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 294.010, '-23,34700', '-52,09500', 580, 'S', 0.7620, NULL, NULL, '41900', 'N', 'N', 2852, NULL, '4103', '4104', NULL, '1951', 'S', 3382, 'MANDAGUAÇU', 'N', '411410', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '199', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411420', '4115', 'PR', '4190', '4103', '41009', '41', 'MANDAGUARI', NULL, '44', '86975000', '3', '7677', '7677', '14139', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 335.816, '-23,54800', '-51,67100', 741, 'S', 0.7910, NULL, NULL, '41900', 'N', 'N', 2853, NULL, '4103', '4104', NULL, '1947', 'S', 3383, 'MANDAGUARI', 'N', '411420', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '200', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411430', '4102', 'PR', '4190', '4110', '41037', '41', 'MANDIRITUBA', NULL, '41', '83800000', '2', '7679', '7679', '14140', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 379.179, '-25,77900', '-49,32600', 925, 'S', 0.7600, NULL, NULL, '41900', 'N', 'N', 2854, NULL, '4101', '4101', NULL, '1960', 'S', 3384, 'MANDIRITUBA', 'N', '411430', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '201', NULL, '01', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411435', '4108', 'PR', '4190', '4107', '41026', '41', 'MANFRINOPOLIS', NULL, '46', '85628000', '1', '0864', NULL, '14405', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 215.682, '-26,14400', '-53,31100', 650, 'S', 0.7100, NULL, NULL, '41900', 'N', 'N', 2856, NULL, '4190', '4190', NULL, '1997', 'S', 3385, 'MANFRINÓPOLIS', 'N', '411435', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '202', NULL, '03', 'N', NULL, NULL, NULL, 34);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411440', '4107', 'PR', '4190', '4108', '41030', '41', 'MANGUEIRINHA', NULL, '46', '85540000', '1', '7511', '7511', '14056', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1073.793, '-25,94100', '-52,17600', 921, 'S', 0.7540, NULL, NULL, '41900', 'N', 'N', 2859, NULL, '4190', '4190', NULL, '1946', 'S', 3386, 'MANGUEIRINHA', 'N', '411440', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '203', NULL, '03', 'N', NULL, NULL, NULL, 268);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411450', '4122', 'PR', '4190', '4103', '41013', '41', 'MANOEL RIBAS', NULL, '43', '85260000', '0', '7681', '7681', '14141', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 571.338, '-24,51600', '-51,66800', 880, 'S', 0.7290, NULL, NULL, '41900', 'N', 'N', 2864, NULL, '4190', '4190', NULL, '1955', 'S', 3387, 'MANOEL RIBAS', 'N', '411450', 'N', 'N', 'S', NULL, 68, 'N', 'N', 'N', '204', NULL, '03', 'N', NULL, NULL, NULL, 316);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411460', '4120', 'PR', '4190', '4106', '41022', '41', 'MARECHAL CANDIDO RONDON', NULL, '45', '85960000', '9', '7683', '7683', '14142', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 748.003, '-24,55600', '-54,05700', 410, 'S', 0.8290, NULL, NULL, '41900', 'N', 'N', 2908, NULL, '4190', '4190', NULL, '1960', 'S', 3388, 'MARECHAL CÂNDIDO RONDON', 'N', '411460', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '205', NULL, '03', 'N', NULL, NULL, NULL, 267);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411470', '4112', 'PR', '4190', '4101', '41002', '41', 'MARIA HELENA', NULL, '44', '87480000', '8', '7685', '7685', '14143', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 486.234, '-23,61600', '-53,20500', 373, 'S', 0.7070, NULL, NULL, '41900', 'N', 'N', 2915, NULL, '4190', '4190', NULL, '1960', 'S', 3389, 'MARIA HELENA', 'N', '411470', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '206', NULL, '03', 'N', NULL, NULL, NULL, 312);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411480', '4115', 'PR', '4190', '4103', '41009', '41', 'MARIALVA', NULL, '44', '86990000', '7', '7687', '7687', '14144', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 475.467, '-23,48500', '-51,79200', 670, 'S', 0.7840, NULL, NULL, '41900', 'N', 'N', 2916, NULL, '4103', '4104', NULL, '1951', 'S', 3390, 'MARIALVA', 'N', '411480', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '207', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411490', '4116', 'PR', '4190', '4103', '41010', '41', 'MARILANDIA DO SUL', NULL, '43', '86825000', '6', '7433', '7433', '14017', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 384.424, '-23,74500', '-51,30800', 758, 'S', 0.7390, NULL, NULL, '41900', 'N', 'N', 2926, NULL, '4190', '4190', NULL, '1951', 'S', 3391, 'MARILÂNDIA DO SUL', 'N', '411490', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '208', NULL, '03', 'N', NULL, NULL, NULL, 373);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411500', '4114', 'PR', '4190', '4101', '41001', '41', 'MARILENA', NULL, '44', '87960000', '2', '7975', '7975', '14282', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 232.366, '-22,73600', '-53,04000', 380, 'S', 0.7380, NULL, NULL, '41900', 'N', 'N', 2927, NULL, '4190', '4190', NULL, '1967', 'S', 3392, 'MARILENA', 'N', '411500', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '209', NULL, '03', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411510', '4112', 'PR', '4190', '4101', '41002', '41', 'MARILUZ', NULL, '44', '87470000', '1', '7689', '7689', '14145', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 433.170, '-24,00200', '-53,14600', 453, 'S', 0.6750, NULL, NULL, '41900', 'S', 'N', 2929, NULL, '4190', '4190', NULL, '1963', 'S', 3393, 'MARILUZ', 'N', '411510', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '210', NULL, '03', 'N', NULL, NULL, NULL, 312);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411520', '4115', 'PR', '4190', '4103', '41009', '41', 'MARINGA', NULL, '44', '87001970', '0', '7691', '7691', '14146', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 487.930, '-23,42500', '-51,93900', 596, 'S', 0.8410, NULL, NULL, '41900', 'N', 'N', 2930, NULL, '4103', '4104', NULL, '1951', 'S', 3394, 'MARINGÁ', 'N', '411520', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '211', NULL, '01', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411530', '4107', 'PR', '4190', '4107', '41027', '41', 'MARIOPOLIS', NULL, '46', '85525000', '9', '7693', '7693', '14147', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 230.741, '-26,35500', '-52,55900', 879, 'S', 0.7990, NULL, NULL, '41900', 'N', 'N', 2933, NULL, '4190', '4190', NULL, '1960', 'S', 3395, 'MARIÓPOLIS', 'N', '411530', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '212', NULL, '03', 'N', NULL, NULL, NULL, 268);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411535', '4120', 'PR', '4190', '4106', '41022', '41', 'MARIPA', NULL, '44', '85955000', '8', '5487', '5487', '14344', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 283.802, '-24,41800', '-53,83000', 402, 'S', 0.8450, NULL, NULL, '41900', 'N', 'N', 2934, NULL, '4190', '4190', NULL, '1993', 'S', 3396, 'MARIPÁ', 'N', '411535', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '213', NULL, '03', 'N', NULL, NULL, NULL, 267);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411540', '4108', 'PR', '4190', '4107', '41026', '41', 'MARMELEIRO', NULL, '46', '85615000', '8', '7695', '7695', '14148', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 387.680, '-26,14900', '-53,02600', 660, 'S', 0.7530, NULL, NULL, '41900', 'N', 'N', 2939, NULL, '4190', '4190', NULL, '1960', 'S', 3397, 'MARMELEIRO', 'N', '411540', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '214', NULL, '03', 'N', NULL, NULL, NULL, 34);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411545', '4105', 'PR', '4190', '4108', '41029', '41', 'MARQUINHO', NULL, '42', '85168000', '7', '0866', NULL, '14406', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 511.147, '-25,11300', '-52,25400', 836, 'S', 0.6910, NULL, NULL, '41900', 'S', 'N', 2942, NULL, '4190', '4190', NULL, '1997', 'S', 3398, 'MARQUINHO', 'N', '411545', 'N', 'N', 'S', NULL, 25, 'N', 'N', 'N', '215', NULL, '03', 'N', NULL, NULL, NULL, 32);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411550', '4116', 'PR', '4190', '4103', '41012', '41', 'MARUMBI', NULL, '43', '86910000', '7', '7697', '7697', '14149', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 208.470, '-23,70600', '-51,63900', 650, 'S', 0.7350, NULL, NULL, '41900', 'N', 'N', 2949, NULL, '4190', '4190', NULL, '1960', 'S', 3399, 'MARUMBI', 'N', '411550', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '216', NULL, '03', 'N', NULL, NULL, NULL, 373);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411560', '4109', 'PR', '4190', '4106', '41024', '41', 'MATELANDIA', NULL, '45', '85887000', '6', '7699', '7699', '14150', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 639.746, '-25,24100', '-53,99600', 555, 'S', 0.7600, NULL, NULL, '41900', 'N', 'N', 2964, NULL, '4190', '4190', NULL, '1960', 'S', 3400, 'MATELÂNDIA', 'N', '411560', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '217', NULL, '03', 'N', NULL, NULL, NULL, 80);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411570', '4101', 'PR', '4190', '4110', '41038', '41', 'MATINHOS', NULL, '41', '83260000', '5', '7963', '7963', '14283', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 117.064, '-25,81800', '-48,54300', 15, 'S', 0.7930, NULL, NULL, '41900', 'N', 'N', 2974, NULL, '4190', '4190', NULL, '1967', 'S', 3401, 'MATINHOS', 'N', '411570', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '218', NULL, '03', 'N', NULL, NULL, NULL, 428);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411573', '4122', 'PR', '4190', '4108', '41028', '41', 'MATO RICO', NULL, '42', '85240000', '9', '5503', '5503', '14377', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 394.533, '-24,70500', '-52,14600', 700, 'S', 0.6400, NULL, NULL, '41900', 'S', 'N', 2979, NULL, '4190', '4190', NULL, '1993', 'S', 3402, 'MATO RICO', 'N', '411573', 'N', 'N', 'S', NULL, 68, 'N', 'N', 'N', '219', NULL, '03', 'N', NULL, NULL, NULL, 316);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411575', '4116', 'PR', '4190', '4103', '41010', '41', 'MAUA DA SERRA', NULL, '43', '86828000', '4', '5459', '5459', '14345', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 108.324, '-23,90100', '-51,22900', 1020, 'S', 0.7190, NULL, NULL, '41900', 'N', 'N', 2991, NULL, '4190', '4190', NULL, '1993', 'S', 3403, 'MAUÁ DA SERRA', 'N', '411575', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '220', NULL, '03', 'N', NULL, NULL, NULL, 373);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411580', '4109', 'PR', '4190', '4106', '41024', '41', 'MEDIANEIRA', NULL, '45', '85884000', '4', '7701', '7701', '14151', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 328.733, '-25,29500', '-54,09400', 412, 'S', 0.7790, NULL, NULL, '41900', 'N', 'N', 3001, NULL, '4190', '4190', NULL, '1960', 'S', 3404, 'MEDIANEIRA', 'N', '411580', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '221', NULL, '03', 'N', NULL, NULL, NULL, 80);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411585', '4120', 'PR', '4190', '4106', '41022', '41', 'MERCEDES', NULL, '45', '85998000', '3', '5531', '5531', '14374', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 200.864, '-24,45400', '-54,16200', 408, 'S', 0.8160, NULL, NULL, '41900', 'N', 'N', 3009, NULL, '4190', '4190', NULL, '1993', 'S', 3405, 'MERCEDES', 'N', '411585', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '222', NULL, '03', 'N', NULL, NULL, NULL, 267);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411590', '4114', 'PR', '4190', '4101', '41001', '41', 'MIRADOR', NULL, '44', '87840000', '3', '7703', '7703', '14152', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 221.506, '-23,25800', '-52,77600', 352, 'S', 0.7240, NULL, NULL, '41900', 'N', 'N', 3042, NULL, '4190', '4190', NULL, '1960', 'S', 3406, 'MIRADOR', 'N', '411590', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '223', NULL, '03', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411600', '4117', 'PR', '4190', '4103', '41007', '41', 'MIRASELVA', NULL, '43', '86615000', '0', '7705', '7705', '14153', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 90.294, '-22,96600', '-51,45500', 570, 'S', 0.7870, NULL, NULL, '41900', 'N', 'N', 3057, NULL, '4190', '4190', NULL, '1960', 'S', 3407, 'MIRASELVA', 'N', '411600', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '224', NULL, '03', 'N', NULL, NULL, NULL, 374);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411605', '4109', 'PR', '4190', '4106', '41024', '41', 'MISSAL', NULL, '45', '85890000', '9', '8469', '8469', '14294', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 319.510, '-25,09200', '-54,24800', 328, 'S', 0.7900, NULL, NULL, '41900', 'N', 'N', 3064, NULL, '4190', '4190', NULL, '1981', 'S', 3408, 'MISSAL', 'N', '411605', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '225', NULL, '03', 'N', NULL, NULL, NULL, 80);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411610', '4111', 'PR', '4190', '4102', '41004', '41', 'MOREIRA SALES', NULL, '44', '87370000', '9', '7707', '7707', '14154', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 353.892, '-24,06200', '-53,00700', 450, 'S', 0.7030, NULL, NULL, '41900', 'N', 'N', 3136, NULL, '4190', '4190', NULL, '1960', 'S', 3409, 'MOREIRA SALES', 'N', '411610', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '226', NULL, '03', 'N', NULL, NULL, NULL, 141);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411620', '4101', 'PR', '4190', '4110', '41038', '41', 'MORRETES', NULL, '41', '83350000', '8', '7709', '7709', '14155', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 684.580, '-25,47700', '-48,83400', 10, 'S', 0.7550, NULL, NULL, '41900', 'N', 'N', 3140, NULL, '4190', '4190', NULL, '1841', 'S', 3410, 'MORRETES', 'N', '411620', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '227', NULL, '03', 'N', NULL, NULL, NULL, 428);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411630', '4115', 'PR', '4190', '4103', '41006', '41', 'MUNHOZ DE MELO', NULL, '44', '86760000', '7', '7711', '7711', '14156', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 137.018, '-23,14800', '-51,77400', 568, 'S', 0.7670, NULL, NULL, '41900', 'N', 'N', 3179, NULL, '4103', '4190', NULL, '1955', 'S', 3411, 'MUNHOZ DE MELO', 'N', '411630', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '228', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411640', '4115', 'PR', '4190', '4103', '41006', '41', 'NOSSA SENHORA DAS GRACAS', NULL, '44', '86680000', '6', '7713', '7713', '14157', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 185.716, '-22,91400', '-51,79400', 489, 'S', 0.7190, NULL, NULL, '41900', 'N', 'N', 3242, NULL, '4190', '4190', NULL, '1960', 'S', 3412, 'NOSSA SENHORA DAS GRAÇAS', 'N', '411640', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '229', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411650', '4114', 'PR', '4190', '4101', '41001', '41', 'NOVA ALIANCA DO IVAI', NULL, '44', '87790000', '5', '7715', '7715', '14158', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 131.272, '-23,17700', '-52,60200', 396, 'S', 0.7420, NULL, NULL, '41900', 'N', 'N', 3249, NULL, '4190', '4190', NULL, '1960', 'S', 3413, 'NOVA ALIANÇA DO IVAÍ', 'N', '411650', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '230', NULL, '03', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411660', '4118', 'PR', '4190', '4104', '41015', '41', 'NOVA AMERICA DA COLINA', NULL, '43', '86230000', '4', '7717', '7717', '14159', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 129.476, '-23,33100', '-50,71800', 641, 'S', 0.7160, NULL, NULL, '41900', 'N', 'N', 3253, NULL, '4190', '4190', NULL, '1960', 'S', 3414, 'NOVA AMÉRICA DA COLINA', 'N', '411660', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '231', NULL, '03', 'N', NULL, NULL, NULL, 31);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411670', '4110', 'PR', '4190', '4106', '41023', '41', 'NOVA AURORA', NULL, '45', '85410000', '3', '7965', '7965', '14284', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 474.011, '-24,52900', '-53,25600', 526, 'S', 0.7710, NULL, NULL, '41900', 'N', 'N', 3257, NULL, '4190', '4190', NULL, '1967', 'S', 3415, 'NOVA AURORA', 'N', '411670', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '232', NULL, '03', 'N', NULL, NULL, NULL, 258);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411680', '4111', 'PR', '4190', '4102', '41004', '41', 'NOVA CANTU', NULL, '44', '87330000', '2', '7719', '7719', '14160', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 543.780, '-24,67300', '-52,56900', 555, 'S', 0.6980, NULL, NULL, '41900', 'S', 'N', 3270, NULL, '4190', '4190', NULL, '1963', 'S', 3416, 'NOVA CANTU', 'N', '411680', 'N', 'N', 'S', NULL, 68, 'N', 'N', 'N', '233', NULL, '03', 'N', NULL, NULL, NULL, 141);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411690', '4115', 'PR', '4190', '4103', '41006', '41', 'NOVA ESPERANCA', NULL, '44', '87600000', '1', '7721', '7721', '14161', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 401.587, '-23,18400', '-52,20500', 550, 'S', 0.7480, NULL, NULL, '41900', 'N', 'N', 3277, NULL, '4190', '4190', NULL, '1951', 'S', 3417, 'NOVA ESPERANÇA', 'N', '411690', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '234', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411695', '4108', 'PR', '4190', '4107', '41026', '41', 'NOVA ESPERANCA DO SUDOESTE', NULL, '46', '85635000', '0', '5477', '5477', '14346', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 208.472, '-25,90700', '-53,26300', 538, 'S', 0.7220, NULL, NULL, '41900', 'N', 'N', 3279, NULL, '4190', '4190', NULL, '1993', 'S', 3418, 'NOVA ESPERANÇA DO SUDOESTE', 'N', '411695', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '235', NULL, '03', 'N', NULL, NULL, NULL, 34);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411700', '4118', 'PR', '4190', '4104', '41015', '41', 'NOVA FATIMA', NULL, '43', '86310000', '8', '7723', '7723', '14162', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 283.420, '-23,43200', '-50,56400', 673, 'S', 0.7470, NULL, NULL, '41900', 'N', 'N', 3282, NULL, '4190', '4190', NULL, '1951', 'S', 3419, 'NOVA FÁTIMA', 'N', '411700', 'N', 'N', 'S', NULL, 146, 'N', 'N', 'N', '236', NULL, '03', 'N', NULL, NULL, NULL, 31);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411705', '4105', 'PR', '4190', '4108', '41029', '41', 'NOVA LARANJEIRAS', NULL, '42', '85350000', '7', '5479', '5479', '14375', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1145.485, '-25,30700', '-52,54100', 700, 'S', 0.6970, NULL, NULL, '41900', 'S', 'N', 3300, NULL, '4190', '4190', NULL, '1993', 'S', 3420, 'NOVA LARANJEIRAS', 'N', '411705', 'N', 'N', 'S', NULL, 25, 'N', 'N', 'N', '237', NULL, '03', 'N', NULL, NULL, NULL, 32);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411710', '4114', 'PR', '4190', '4101', '41001', '41', 'NOVA LONDRINA', NULL, '44', '87970000', '7', '7725', '7725', '14163', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 269.389, '-22,76600', '-52,98500', 400, 'S', 0.7620, NULL, NULL, '41900', 'N', 'N', 3302, NULL, '4190', '4190', NULL, '1954', 'S', 3421, 'NOVA LONDRINA', 'N', '411710', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '238', NULL, '03', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411720', '4112', 'PR', '4190', '4101', '41002', '41', 'NOVA OLIMPIA', NULL, '44', '87490000', '6', '7967', '7967', '14285', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 136.308, '-23,47200', '-53,08900', 438, 'S', 0.7400, NULL, NULL, '41900', 'N', 'N', 3311, NULL, '4190', '4190', NULL, '1967', 'S', 3422, 'NOVA OLÍMPIA', 'N', '411720', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '239', NULL, '03', 'N', NULL, NULL, NULL, 312);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411721', '4118', 'PR', '4190', '4104', '41014', '41', 'NOVA SANTA BARBARA', NULL, '43', '86250000', '4', '5457', '5457', '14347', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 71.763, '-23,59700', '-50,72400', 736, 'S', 0.7010, NULL, NULL, '41900', 'N', 'N', 3332, NULL, '4190', '4190', NULL, '1993', 'S', 3424, 'NOVA SANTA BÁRBARA', 'N', '411721', 'N', 'N', 'S', NULL, 146, 'N', 'N', 'N', '241', NULL, '03', 'N', NULL, NULL, NULL, 31);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411722', '4120', 'PR', '4190', '4106', '41022', '41', 'NOVA SANTA ROSA', NULL, '45', '85930000', '2', '7979', '7979', '14290', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 204.666, '-24,46600', '-53,95300', 379, 'S', 0.8060, NULL, NULL, '41900', 'N', 'N', 3334, NULL, '4190', '4190', NULL, '1973', 'S', 3425, 'NOVA SANTA ROSA', 'N', '411722', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '242', NULL, '03', 'N', NULL, NULL, NULL, 267);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411725', '4108', 'PR', '4190', '4107', '41026', '41', 'NOVA PRATA DO IGUACU', NULL, '46', '85685000', '5', '7995', '7995', '14301', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 352.565, '-25,63300', '-53,34700', 438, 'S', 0.7540, NULL, NULL, '41900', 'N', 'N', 3324, NULL, '4190', '4190', NULL, '1979', 'S', 3423, 'NOVA PRATA DO IGUAÇU', 'N', '411725', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '240', NULL, '03', 'N', NULL, NULL, NULL, 34);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411727', '4122', 'PR', '4190', '4103', '41013', '41', 'NOVA TEBAS', NULL, '42', '85250000', '1', '9913', '9913', '14315', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 545.693, '-24,43800', '-51,94500', 650, 'S', 0.6890, NULL, NULL, '41900', 'S', 'N', 3337, NULL, '4190', '4190', NULL, '1989', 'S', 3426, 'NOVA TEBAS', 'N', '411727', 'N', 'N', 'S', NULL, 68, 'N', 'N', 'N', '243', NULL, '03', 'N', NULL, NULL, NULL, 316);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411729', '4116', 'PR', '4190', '4103', '41010', '41', 'NOVO ITACOLOMI', NULL, '43', '86895000', '7', '5517', '5517', '14372', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 162.163, '-23,76400', '-51,50700', 620, 'S', 0.7060, NULL, NULL, '41900', 'N', 'N', 3365, NULL, '4190', '4190', NULL, '1993', 'S', 3427, 'NOVO ITACOLOMI', 'N', '411729', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '244', NULL, '03', 'N', NULL, NULL, NULL, 373);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411730', '4121', 'PR', '4190', '4105', '41019', '41', 'ORTIGUEIRA', NULL, '42', '84350000', '5', '7727', '7727', '14164', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 2429.560, '-24,20800', '-50,94900', 758, 'S', 0.6200, NULL, NULL, '41900', 'S', 'N', 3422, NULL, '4190', '4190', NULL, '1951', 'S', 3428, 'ORTIGUEIRA', 'N', '411730', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '245', NULL, '03', 'N', NULL, NULL, NULL, 375);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411740', '4115', 'PR', '4190', '4103', '41008', '41', 'OURIZONA', NULL, '44', '87170000', '4', '7729', '7729', '14165', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 176.457, '-23,40500', '-52,19900', 525, 'S', 0.7700, NULL, NULL, '41900', 'N', 'N', 3433, NULL, '4103', '4190', NULL, '1960', 'S', 3429, 'OURIZONA', 'N', '411740', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '246', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411745', '4120', 'PR', '4190', '4106', '41022', '41', 'OURO VERDE DO OESTE', NULL, '45', '85933000', '3', '9965', '9965', '14323', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 293.042, '-24,80500', '-53,90300', 991, 'S', 0.7640, NULL, NULL, '41900', 'N', 'N', 3446, NULL, '4190', '4190', NULL, '1990', 'S', 3430, 'OURO VERDE DO OESTE', 'N', '411745', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '247', NULL, '03', 'N', NULL, NULL, NULL, 267);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411750', '4115', 'PR', '4190', '4103', '41009', '41', 'PAICANDU', NULL, '44', '87140000', '3', '7731', '7731', '14166', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 170.837, '-23,45800', '-52,04900', 470, 'S', 0.7460, NULL, NULL, '41900', 'N', 'N', 3466, NULL, '4103', '4104', NULL, '1960', 'S', 3431, 'PAIÇANDU', 'N', '411750', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '248', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411760', '4107', 'PR', '4190', '4108', '41030', '41', 'PALMAS', NULL, '46', '85555000', '2', '7733', '7733', '14167', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1567.361, '-26,48400', '-51,99100', 1035, 'S', 0.7370, NULL, NULL, '41900', 'N', 'N', 3485, NULL, '4190', '4190', NULL, '1877', 'S', 3432, 'PALMAS', 'N', '411760', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '249', NULL, '03', 'N', NULL, NULL, NULL, 268);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411770', '4103', 'PR', '4190', '4105', '41021', '41', 'PALMEIRA', NULL, '42', '84130000', '1', '7735', '7735', '14168', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1457.261, '-25,42900', '-50,00600', 865, 'S', 0.7630, NULL, NULL, '41900', 'N', 'N', 3489, NULL, '4190', '4190', NULL, '1869', 'S', 3433, 'PALMEIRA', 'N', '411770', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '250', NULL, '03', 'N', NULL, NULL, NULL, 146);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411780', '4105', 'PR', '4190', '4108', '41028', '41', 'PALMITAL', NULL, '42', '85270000', '0', '7737', '7737', '14169', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 815.893, '-24,89300', '-52,20300', 840, 'S', 0.6700, NULL, NULL, '41900', 'S', 'N', 3504, NULL, '4190', '4190', NULL, '1961', 'S', 3434, 'PALMITAL', 'N', '411780', 'N', 'N', 'S', NULL, 68, 'N', 'N', 'N', '251', NULL, '03', 'N', NULL, NULL, NULL, 32);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411790', '4120', 'PR', '4190', '4106', '41022', '41', 'PALOTINA', NULL, '44', '85950000', '9', '7739', '7739', '14170', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 651.228, '-24,28400', '-53,84000', 333, 'S', 0.8320, NULL, NULL, '41900', 'N', 'N', 3509, NULL, '4190', '4190', NULL, '1960', 'S', 3435, 'PALOTINA', 'N', '411790', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '252', NULL, '03', 'N', NULL, NULL, NULL, 267);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411800', '4114', 'PR', '4190', '4101', '41001', '41', 'PARAISO DO NORTE', NULL, '44', '87780000', '6', '7741', '7741', '14171', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 204.565, '-23,28100', '-52,60200', 372, 'S', 0.7630, NULL, NULL, '41900', 'N', 'N', 3534, NULL, '4190', '4190', NULL, '1954', 'S', 3436, 'PARAÍSO DO NORTE', 'N', '411800', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '253', NULL, '03', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411810', '4115', 'PR', '4190', '4101', '41001', '41', 'PARANACITY', NULL, '44', '87660000', '5', '7743', '7743', '14172', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 348.951, '-22,93000', '-52,15100', 380, 'S', 0.7420, NULL, NULL, '41900', 'N', 'N', 3543, NULL, '4190', '4190', NULL, '1954', 'S', 3437, 'PARANACITY', 'N', '411810', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '254', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411820', '4101', 'PR', '4190', '4110', '41038', '41', 'PARANAGUA', NULL, '41', '83200000', '4', '7745', '7745', '14173', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 826.652, '-25,52000', '-48,50900', 3, 'S', 0.7820, NULL, NULL, '41900', 'N', 'N', 3544, NULL, '4190', '4190', NULL, '1648', 'S', 3438, 'PARANAGUÁ', 'N', '411820', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '255', NULL, '01', 'N', NULL, NULL, NULL, 428);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411830', '4114', 'PR', '4190', '4101', '41001', '41', 'PARANAPOEMA', NULL, '44', '87680000', '3', '7747', '7747', '14174', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 175.874, '-22,63400', '-52,09800', 390, 'S', 0.7060, NULL, NULL, '41900', 'N', 'N', 3549, NULL, '4190', '4190', NULL, '1964', 'S', 3439, 'PARANAPOEMA', 'N', '411830', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '256', NULL, '03', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411840', '4114', 'PR', '4190', '4101', '41001', '41', 'PARANAVAI', NULL, '44', '87700000', '2', '7749', '7749', '14175', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1202.469, '-23,07300', '-52,46500', 470, 'S', 0.7870, NULL, NULL, '41900', 'N', 'N', 3553, NULL, '4190', '4190', NULL, '1951', 'S', 3440, 'PARANAVAÍ', 'N', '411840', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '257', NULL, '02', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411845', '4120', 'PR', '4190', '4106', '41022', '41', 'PATO BRAGADO', NULL, '45', '85948000', '1', '5533', '5533', '14348', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 135.285, '-24,62600', '-54,22500', 288, 'S', 0.8210, NULL, NULL, '41900', 'N', 'N', 3599, NULL, '4190', '4190', NULL, '1993', 'S', 3441, 'PATO BRAGADO', 'N', '411845', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '258', NULL, '03', 'N', NULL, NULL, NULL, 267);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411850', '4107', 'PR', '4190', '4107', '41027', '41', 'PATO BRANCO', NULL, '46', '85500000', '1', '7751', '7751', '14176', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 539.415, '-26,22900', '-52,67100', 761, 'S', 0.8490, NULL, NULL, '41900', 'N', 'N', 3600, NULL, '4190', '4190', NULL, '1951', 'S', 3442, 'PATO BRANCO', 'N', '411850', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '259', NULL, '02', 'N', NULL, NULL, NULL, 268);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411860', '4106', 'PR', '4190', '4109', '41033', '41', 'PAULA FREITAS', NULL, '42', '84630000', '0', '7753', '7753', '14177', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 420.331, '-26,20800', '-50,93800', 748, 'S', 0.7350, NULL, NULL, '41900', 'N', 'N', 3616, NULL, '4190', '4190', NULL, '1963', 'S', 3443, 'PAULA FREITAS', 'N', '411860', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '260', NULL, '03', 'N', NULL, NULL, NULL, 33);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411870', '4106', 'PR', '4190', '4109', '41033', '41', 'PAULO FRONTIN', NULL, '42', '84635000', '9', '7755', '7755', '14178', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 369.210, '-26,04000', '-50,83600', 778, 'S', 0.7350, NULL, NULL, '41900', 'N', 'N', 3627, NULL, '4190', '4190', NULL, '1951', 'S', 3444, 'PAULO FRONTIN', 'N', '411870', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '261', NULL, '03', 'N', NULL, NULL, NULL, 33);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411880', '4111', 'PR', '4190', '4102', '41005', '41', 'PEABIRU', NULL, '44', '87250000', '8', '7757', '7757', '14179', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 469.495, '-23,91300', '-52,34300', 523, 'S', 0.7360, NULL, NULL, '41900', 'N', 'N', 3635, NULL, '4190', '4190', NULL, '1951', 'S', 3445, 'PEABIRU', 'N', '411880', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '262', NULL, '03', 'N', NULL, NULL, NULL, 141);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411885', '4112', 'PR', '4190', '4101', '41002', '41', 'PEROBAL', NULL, '44', '87538000', '7', '0868', NULL, '14407', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 406.707, '-23,89600', '-53,41000', 402, 'S', 0.7450, NULL, NULL, '41900', 'N', 'N', 3704, NULL, '4190', '4190', NULL, '1997', 'S', 3446, 'PEROBAL', 'N', '411885', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '263', NULL, '03', 'N', NULL, NULL, NULL, 312);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411890', '4112', 'PR', '4190', '4101', '41002', '41', 'PEROLA', NULL, '44', '87540000', '7', '7969', '7969', '14286', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 240.635, '-23,80500', '-53,68400', 440, 'S', 0.7590, NULL, NULL, '41900', 'N', 'N', 3705, NULL, '4190', '4190', NULL, '1966', 'S', 3447, 'PÉROLA', 'N', '411890', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '264', NULL, '03', 'N', NULL, NULL, NULL, 312);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411900', '4108', 'PR', '4190', '4107', '41025', '41', 'PEROLA D''OESTE', NULL, '46', '85740000', '4', '7759', '7759', '14180', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 206.048, '-25,82400', '-53,74000', 401, 'S', 0.7590, NULL, NULL, '41900', 'N', 'N', 3706, NULL, '4190', '4190', NULL, '1961', 'S', 3448, 'PÉROLA D OESTE', 'N', '411900', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '265', NULL, '03', 'N', NULL, NULL, NULL, 34);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411910', '4102', 'PR', '4190', '4110', '41039', '41', 'PIEN', NULL, '41', '83860000', '3', '7761', '7761', '14181', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 254.903, '-26,09800', '-49,42900', 818, 'S', 0.7530, NULL, NULL, '41900', 'N', 'N', 3732, NULL, '4101', '4190', NULL, '1961', 'S', 3449, 'PIÊN', 'N', '411910', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '266', NULL, '03', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411915', '4102', 'PR', '4190', '4110', '41037', '41', 'PINHAIS', NULL, '41', '83300000', '2', '5453', '5453', '14388', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 61.007, '-25,44500', '-49,19300', 893, 'S', 0.8150, NULL, NULL, '41900', 'N', 'N', 3754, NULL, '4101', '4101', NULL, '1993', 'S', 3450, 'PINHAIS', 'N', '411915', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '267', NULL, '01', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411920', '4119', 'PR', '4190', '4104', '41017', '41', 'PINHALAO', NULL, '43', '84925000', '2', '7763', '7763', '14182', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 220.692, '-23,79300', '-50,05600', 601, 'S', 0.7070, NULL, NULL, '41900', 'N', 'N', 3758, NULL, '4190', '4190', NULL, '1951', 'S', 3452, 'PINHALÃO', 'N', '411920', 'N', 'N', 'S', NULL, 146, 'N', 'N', 'N', '269', NULL, '03', 'N', NULL, NULL, NULL, 427);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411925', '4108', 'PR', '4190', '4107', '41026', '41', 'PINHAL DE SAO BENTO', NULL, '46', '85727000', '1', '5495', '5495', '14349', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 96.855, '-26,03000', '-53,48300', 480, 'S', 0.7080, NULL, NULL, '41900', 'N', 'N', 3756, NULL, '4190', '4190', NULL, '1993', 'S', 3451, 'PINHAL DE SÃO BENTO', 'N', '411925', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '268', NULL, '03', 'N', NULL, NULL, NULL, 34);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411930', '4105', 'PR', '4190', '4108', '41029', '41', 'PINHAO', NULL, '42', '85170000', '1', '7765', '7765', '14183', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2001.586, '-25,69600', '-51,66000', 1041, 'S', 0.7130, NULL, NULL, '41900', 'N', 'N', 3761, NULL, '4190', '4190', NULL, '1964', 'S', 3453, 'PINHÃO', 'N', '411930', 'N', 'N', 'S', NULL, 25, 'N', 'N', 'N', '270', NULL, '03', 'N', NULL, NULL, NULL, 32);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411940', '4103', 'PR', '4190', '4105', '41020', '41', 'PIRAI DO SUL', NULL, '42', '84240000', '0', '7767', '7767', '14184', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1403.067, '-24,52600', '-49,94900', 1036, 'S', 0.7300, NULL, NULL, '41900', 'N', 'N', 3783, NULL, '4190', '4190', NULL, '1947', 'S', 3454, 'PIRAÍ DO SUL', 'N', '411940', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '271', NULL, '03', 'N', NULL, NULL, NULL, 146);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411950', '4102', 'PR', '4190', '4110', '41037', '41', 'PIRAQUARA', NULL, '41', '83301970', '9', '7769', '7769', '14185', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 227.560, '-25,44200', '-49,06300', 905, 'S', 0.7440, NULL, NULL, '41900', 'N', 'N', 3800, NULL, '4101', '4101', NULL, '1890', 'S', 3455, 'PIRAQUARA', 'N', '411950', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '272', NULL, '01', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411960', '4105', 'PR', '4190', '4108', '41028', '41', 'PITANGA', NULL, '42', '85200000', '8', '7771', '7771', '14186', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1663.747, '-24,75700', '-51,76100', 952, 'S', 0.7430, NULL, NULL, '41900', 'N', 'N', 3814, NULL, '4190', '4190', NULL, '1943', 'S', 3456, 'PITANGA', 'N', '411960', 'N', 'N', 'S', NULL, 68, 'N', 'N', 'N', '273', NULL, '03', 'N', NULL, NULL, NULL, 32);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411965', '4117', 'PR', '4190', '4103', '41011', '41', 'PITANGUEIRAS', NULL, '43', '86613000', '7', '5461', '5461', '14379', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 123.229, '-23,23100', '-51,58600', 660, 'S', 0.7540, NULL, NULL, '41900', 'N', 'N', 3816, NULL, '4190', '4190', NULL, '1993', 'S', 3457, 'PITANGUEIRAS', 'N', '411965', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '274', NULL, '03', 'N', NULL, NULL, NULL, 374);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411970', '4114', 'PR', '4190', '4101', '41001', '41', 'PLANALTINA DO PARANA', NULL, '44', '87860000', '7', '7773', '7773', '14187', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 356.191, '-23,00700', '-52,91400', 465, 'S', 0.7370, NULL, NULL, '41900', 'N', 'N', 3825, NULL, '4190', '4190', NULL, '1960', 'S', 3458, 'PLANALTINA DO PARANÁ', 'N', '411970', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '275', NULL, '03', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411980', '4108', 'PR', '4190', '4107', '41025', '41', 'PLANALTO', NULL, '46', '85750000', '6', '7775', '7775', '14188', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 345.740, '-25,71600', '-53,76600', 400, 'S', 0.7630, NULL, NULL, '41900', 'N', 'N', 3828, NULL, '4190', '4190', NULL, '1963', 'S', 3459, 'PLANALTO', 'N', '411980', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '276', NULL, '03', 'N', NULL, NULL, NULL, 34);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411990', '4103', 'PR', '4190', '4105', '41021', '41', 'PONTA GROSSA', NULL, '42', '84001970', '5', '7777', '7777', '14189', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2067.545, '-25,09500', '-50,16200', 969, 'S', 0.8040, NULL, NULL, '41900', 'N', 'N', 3860, NULL, '4190', '4190', NULL, '1855', 'S', 3460, 'PONTA GROSSA', 'N', '411990', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '277', NULL, '01', 'N', NULL, NULL, NULL, 146);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('411995', '4101', 'PR', '4190', '4110', '41038', '41', 'PONTAL DO PARANA', NULL, '41', '83255000', '4', '0870', NULL, '14350', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 200.551, '-25,67400', '-48,51100', 10, 'S', 0.7880, NULL, NULL, '41900', 'N', 'N', 3864, NULL, '4190', '4190', NULL, '1997', 'S', 3461, 'PONTAL DO PARANÁ', 'N', '411995', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '278', NULL, '03', 'N', NULL, NULL, NULL, 428);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412000', '4117', 'PR', '4190', '4103', '41007', '41', 'PORECATU', NULL, '43', '86160000', '2', '7779', '7779', '14190', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 291.665, '-22,75600', '-51,37900', 420, 'S', 0.7850, NULL, NULL, '41900', 'N', 'N', 3887, NULL, '4190', '4190', NULL, '1947', 'S', 3462, 'PORECATU', 'N', '412000', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '279', NULL, '03', 'N', NULL, NULL, NULL, 374);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412010', '4103', 'PR', '4190', '4110', '41036', '41', 'PORTO AMAZONAS', NULL, '42', '84140000', '1', '7781', '7781', '14191', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 186.575, '-25,54500', '-49,89000', 793, 'S', 0.7740, NULL, NULL, '41900', 'N', 'N', 3901, NULL, '4190', '4190', NULL, '1947', 'S', 3463, 'PORTO AMAZONAS', 'N', '412010', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '280', NULL, '03', 'N', NULL, NULL, NULL, 146);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412015', '4105', 'PR', '4190', '4108', '41029', '41', 'PORTO BARREIRO', NULL, '42', '85345000', '0', '0872', NULL, '14408', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 361.982, '-25,54700', '-52,40800', 830, 'S', 0.7160, NULL, NULL, '41900', 'N', 'N', 3902, NULL, '4190', '4190', NULL, '1997', 'S', 3464, 'PORTO BARREIRO', 'N', '412015', 'N', 'N', 'S', NULL, 25, 'N', 'N', 'N', '281', NULL, '03', 'N', NULL, NULL, NULL, 32);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412020', '4114', 'PR', '4190', '4101', '41001', '41', 'PORTO RICO', NULL, '44', '87950000', '0', '7783', '7783', '14192', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 217.677, '-22,77200', '-53,26700', 252, 'S', 0.7480, NULL, NULL, '41900', 'N', 'N', 3923, NULL, '4190', '4190', NULL, '1963', 'S', 3465, 'PORTO RICO', 'N', '412020', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '282', NULL, '03', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412030', '4106', 'PR', '4190', '4109', '41033', '41', 'PORTO VITORIA', NULL, '42', '84610000', '9', '7785', '7785', '14193', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 212.582, '-26,16100', '-51,23200', 750, 'S', 0.7320, NULL, NULL, '41900', 'N', 'N', 3929, NULL, '4190', '4190', NULL, '1963', 'S', 3466, 'PORTO VITÓRIA', 'N', '412030', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '283', NULL, '03', 'N', NULL, NULL, NULL, 33);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412033', '4117', 'PR', '4190', '4103', '41007', '41', 'PRADO FERREIRA', NULL, '43', '86618000', '3', '0874', NULL, '14409', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 153.398, '-23,03900', '-51,44200', 651, 'S', 0.7560, NULL, NULL, '41900', 'N', 'N', 3947, NULL, '4190', '4190', NULL, '1997', 'S', 3467, 'PRADO FERREIRA', 'N', '412033', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '284', NULL, '03', 'N', NULL, NULL, NULL, 374);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412035', '4108', 'PR', '4190', '4107', '41025', '41', 'PRANCHITA', NULL, '46', '85730000', '8', '7991', '7991', '14308', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 225.839, '-26,02000', '-53,74000', 541, 'S', 0.8030, NULL, NULL, '41900', 'N', 'N', 3954, NULL, '4190', '4190', NULL, '1982', 'S', 3468, 'PRANCHITA', 'N', '412035', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '285', NULL, '03', 'N', NULL, NULL, NULL, 34);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412040', '4115', 'PR', '4190', '4103', '41006', '41', 'PRESIDENTE CASTELO BRANCO', NULL, '44', '87180000', '8', '7787', '7787', '14194', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 155.734, '-23,27800', '-52,15200', 570, 'S', 0.7420, NULL, NULL, '41900', 'N', 'N', 3964, NULL, '4103', '4190', NULL, '1964', 'S', 3469, 'PRESIDENTE CASTELO BRANCO', 'N', '412040', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '286', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412050', '4117', 'PR', '4190', '4103', '41007', '41', 'PRIMEIRO DE MAIO', NULL, '43', '86140000', '7', '7789', '7789', '14195', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 414.442, '-22,85100', '-51,02800', 330, 'S', 0.7470, NULL, NULL, '41900', 'N', 'N', 3992, NULL, '4102', '4190', NULL, '1951', 'S', 3470, 'PRIMEIRO DE MAIO', 'N', '412050', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '287', NULL, '03', 'N', NULL, NULL, NULL, 374);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412060', '4105', 'PR', '4190', '4109', '41031', '41', 'PRUDENTOPOLIS', NULL, '42', '84400000', '6', '7791', '7791', '14196', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2307.897, '-25,21300', '-50,97800', 840, 'S', 0.7330, NULL, NULL, '41900', 'N', 'N', 4001, NULL, '4190', '4190', NULL, '1906', 'S', 3471, 'PRUDENTÓPOLIS', 'N', '412060', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '288', NULL, '02', 'N', NULL, NULL, NULL, 32);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412065', '4111', 'PR', '4190', '4102', '41004', '41', 'QUARTO CENTENARIO', NULL, '44', '87365000', '5', '0876', NULL, '14410', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 321.875, '-24,27900', '-53,07600', 472, 'S', 0.7000, NULL, NULL, '41900', 'S', 'N', 4009, NULL, '4190', '4190', NULL, '1997', 'S', 3184, 'QUARTO CENTENÁRIO', 'N', '412065', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '289', NULL, '03', 'N', NULL, NULL, NULL, 141);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412070', '4119', 'PR', '4190', '4104', '41018', '41', 'QUATIGUA', NULL, '43', '86450000', '5', '7793', '7793', '14197', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 112.689, '-23,56700', '-49,91400', 785, 'S', 0.7620, NULL, NULL, '41900', 'N', 'N', 4011, NULL, '4190', '4190', NULL, '1947', 'S', 3472, 'QUATIGUÁ', 'N', '412070', 'N', 'N', 'S', NULL, 146, 'N', 'N', 'N', '290', NULL, '03', 'N', NULL, NULL, NULL, 427);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412080', '4102', 'PR', '4190', '4110', '41037', '41', 'QUATRO BARRAS', NULL, '41', '83420000', '4', '7795', '7795', '14198', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 179.538, '-25,36600', '-49,07700', 936, 'S', 0.7740, NULL, NULL, '41900', 'N', 'N', 4014, NULL, '4101', '4101', NULL, '1961', 'S', 3473, 'QUATRO BARRAS', 'N', '412080', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '291', NULL, '01', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412085', '4120', 'PR', '4190', '4106', '41022', '41', 'QUATRO PONTES', NULL, '45', '85940000', '3', '5535', '5535', '14378', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 114.393, '-24,57500', '-53,97700', 427, 'S', 0.8510, NULL, NULL, '41900', 'N', 'N', 4015, NULL, '4190', '4190', NULL, '1993', 'S', 3474, 'QUATRO PONTES', 'N', '412085', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '292', NULL, '03', 'N', NULL, NULL, NULL, 267);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412090', '4110', 'PR', '4190', '4108', '41029', '41', 'QUEDAS DO IGUACU', NULL, '46', '85460000', '3', '7955', '7955', '14278', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 821.503, '-25,45000', '-52,90800', 562, 'S', 0.7470, NULL, NULL, '41900', 'N', 'N', 4017, NULL, '4190', '4190', NULL, '1967', 'S', 3475, 'QUEDAS DO IGUAÇU', 'N', '412090', 'N', 'N', 'S', NULL, 25, 'N', 'N', 'N', '293', NULL, '03', 'N', NULL, NULL, NULL, 258);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412100', '4114', 'PR', '4190', '4101', '41001', '41', 'QUERENCIA DO NORTE', NULL, '44', '87930000', '0', '7797', '7797', '14199', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 914.764, '-23,08400', '-53,48400', 338, 'S', 0.7050, NULL, NULL, '41900', 'N', 'N', 4026, NULL, '4190', '4190', NULL, '1954', 'S', 3476, 'QUERÊNCIA DO NORTE', 'N', '412100', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '294', NULL, '03', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412110', '4111', 'PR', '4190', '4102', '41005', '41', 'QUINTA DO SOL', NULL, '44', '87265000', '9', '7799', '7799', '14200', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 326.178, '-23,85200', '-52,13000', 422, 'S', 0.7120, NULL, NULL, '41900', 'N', 'N', 4030, NULL, '4190', '4190', NULL, '1963', 'S', 3477, 'QUINTA DO SOL', 'N', '412110', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '295', NULL, '03', 'N', NULL, NULL, NULL, 141);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412120', '4102', 'PR', '4190', '4110', '41039', '41', 'QUITANDINHA', NULL, '41', '83840000', '8', '7801', '7801', '14201', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 447.023, '-25,87200', '-49,49800', 845, 'S', 0.7150, NULL, NULL, '41900', 'N', 'N', 4036, NULL, '4101', '4101', NULL, '1961', 'S', 3478, 'QUITANDINHA', 'N', '412120', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '296', NULL, '01', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412125', '4109', 'PR', '4190', '4106', '41024', '41', 'RAMILANDIA', NULL, '45', '85888000', '7', '5527', '5527', '14380', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 237.195, '-25,12000', '-54,02500', 580, 'S', 0.6970, NULL, NULL, '41900', 'S', 'N', 4049, NULL, '4190', '4190', NULL, '1993', 'S', 3479, 'RAMILÂNDIA', 'N', '412125', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '297', NULL, '03', 'N', NULL, NULL, NULL, 80);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412130', '4118', 'PR', '4190', '4104', '41014', '41', 'RANCHO ALEGRE', NULL, '43', '86290000', '7', '7803', '7803', '14202', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 167.646, '-23,07000', '-50,91300', 416, 'S', 0.7380, NULL, NULL, '41900', 'N', 'N', 4051, NULL, '4190', '4190', NULL, '1960', 'S', 3480, 'RANCHO ALEGRE', 'N', '412130', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '298', NULL, '03', 'N', NULL, NULL, NULL, 31);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412135', '4111', 'PR', '4190', '4102', '41004', '41', 'RANCHO ALEGRE D''OESTE', NULL, '44', '86290000', '6', '5513', '5513', '14351', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 241.416, '-24,30700', '-52,95400', 528, 'S', 0.6980, NULL, NULL, '41900', 'S', 'N', 4052, NULL, '4190', '4190', NULL, '1993', 'S', 3481, 'RANCHO ALEGRE D OESTE', 'N', '412135', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '299', NULL, '03', 'N', NULL, NULL, NULL, 141);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412140', '4108', 'PR', '4190', '4107', '41025', '41', 'REALEZA', NULL, '46', '85770000', '6', '7805', '7805', '14203', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 353.415, '-25,76700', '-53,52700', 520, 'S', 0.7830, NULL, NULL, '41900', 'N', 'N', 4057, NULL, '4190', '4190', NULL, '1961', 'S', 3482, 'REALEZA', 'N', '412140', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '300', NULL, '03', 'N', NULL, NULL, NULL, 34);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412150', '4104', 'PR', '4190', '4109', '41032', '41', 'REBOUCAS', NULL, '42', '84550000', '5', '7807', '7807', '14204', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 481.843, '-25,62100', '-50,69300', 815, 'S', 0.7110, NULL, NULL, '41900', 'N', 'N', 4058, NULL, '4190', '4190', NULL, '1930', 'S', 3483, 'REBOUÇAS', 'N', '412150', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '301', NULL, '03', 'N', NULL, NULL, NULL, 79);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412160', '4108', 'PR', '4190', '4107', '41026', '41', 'RENASCENCA', NULL, '46', '85610000', '4', '7809', '7809', '14205', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 425.082, '-26,15800', '-52,96900', 688, 'S', 0.7460, NULL, NULL, '41900', 'N', 'N', 4075, NULL, '4190', '4190', NULL, '1960', 'S', 3484, 'RENASCENÇA', 'N', '412160', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '302', NULL, '03', 'N', NULL, NULL, NULL, 34);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412170', '4121', 'PR', '4190', '4105', '41019', '41', 'RESERVA', NULL, '42', '84320000', '3', '7811', '7811', '14206', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1635.025, '-24,65000', '-50,85100', 938, 'S', 0.6460, NULL, NULL, '41900', 'S', 'N', 4079, NULL, '4190', '4190', NULL, '1921', 'S', 3485, 'RESERVA', 'N', '412170', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '303', NULL, '03', 'N', NULL, NULL, NULL, 375);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412175', '4105', 'PR', '4190', '4108', '41029', '41', 'RESERVA DO IGUACU', NULL, '42', '85195000', '2', '0878', NULL, '14411', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 834.232, '-25,83900', '-52,02800', 1020, 'S', 0.7260, NULL, NULL, '41900', 'N', 'N', 4081, NULL, '4190', '4190', NULL, '1997', 'S', 3486, 'RESERVA DO IGUAÇU', 'N', '412175', 'N', 'N', 'S', NULL, 25, 'N', 'N', 'N', '304', NULL, '03', 'N', NULL, NULL, NULL, 32);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412180', '4119', 'PR', '4190', '4104', '41016', '41', 'RIBEIRAO CLARO', NULL, '43', '86410000', '2', '7813', '7813', '14207', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 632.782, '-23,19400', '-49,75800', 690, 'S', 0.7470, NULL, NULL, '41900', 'N', 'N', 4117, NULL, '4190', '4190', NULL, '1900', 'S', 3487, 'RIBEIRÃO CLARO', 'N', '412180', 'N', 'N', 'S', NULL, 146, 'N', 'N', 'N', '305', NULL, '03', 'N', NULL, NULL, NULL, 427);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412190', '4118', 'PR', '4190', '4104', '41015', '41', 'RIBEIRAO DO PINHAL', NULL, '43', '86490000', '1', '7815', '7815', '14208', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 374.733, '-23,40800', '-50,35700', 620, 'S', 0.7150, NULL, NULL, '41900', 'N', 'N', 4121, NULL, '4190', '4190', NULL, '1947', 'S', 3488, 'RIBEIRÃO DO PINHAL', 'N', '412190', 'N', 'N', 'S', NULL, 146, 'N', 'N', 'N', '306', NULL, '03', 'N', NULL, NULL, NULL, 31);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412200', '4104', 'PR', '4190', '4109', '41032', '41', 'RIO AZUL', NULL, '42', '84560000', '8', '7817', '7817', '14209', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 629.739, '-25,73300', '-50,79600', 925, 'S', 0.7380, NULL, NULL, '41900', 'N', 'N', 4135, NULL, '4190', '4190', NULL, '1930', 'S', 3489, 'RIO AZUL', 'N', '412200', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '307', NULL, '03', 'N', NULL, NULL, NULL, 79);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412210', '4116', 'PR', '4190', '4103', '41012', '41', 'RIO BOM', NULL, '43', '86830000', '7', '7819', '7819', '14210', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 177.836, '-23,76200', '-51,41100', 680, 'S', 0.7130, NULL, NULL, '41900', 'N', 'N', 4137, NULL, '4190', '4190', NULL, '1964', 'S', 3490, 'RIO BOM', 'N', '412210', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '308', NULL, '03', 'N', NULL, NULL, NULL, 373);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412215', '4105', 'PR', '4190', '4108', '41029', '41', 'RIO BONITO DO IGUACU', NULL, '42', '85340000', '6', '5481', '5481', '14389', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 746.120, '-25,49100', '-52,52600', 700, 'S', 0.6690, NULL, NULL, '41900', 'S', 'N', 4139, NULL, '4190', '4190', NULL, '1993', 'S', 3491, 'RIO BONITO DO IGUAÇU', 'N', '412215', 'N', 'N', 'S', NULL, 25, 'N', 'N', 'N', '309', NULL, '03', 'N', NULL, NULL, NULL, 32);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412217', '4122', 'PR', '4190', '4103', '41013', '41', 'RIO BRANCO DO IVAI', NULL, '43', '86848000', '2', '0880', NULL, '14381', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 385.595, '-24,32400', '-51,31300', 650, 'S', 0.6700, NULL, NULL, '41900', 'S', 'N', 4142, NULL, '4190', '4190', NULL, '1997', 'S', 3492, 'RIO BRANCO DO IVAÍ', 'N', '412217', 'N', 'N', 'S', NULL, 68, 'N', 'N', 'N', '310', NULL, '03', 'N', NULL, NULL, NULL, 316);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412220', '4102', 'PR', '4190', '4110', '41037', '41', 'RIO BRANCO DO SUL', NULL, '41', '83540000', '6', '7821', '7821', '14211', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 814.361, '-25,19000', '-49,31400', 1053, 'S', 0.7020, NULL, NULL, '41900', 'N', 'N', 4143, NULL, '4101', '4101', NULL, '1947', 'S', 3493, 'RIO BRANCO DO SUL', 'N', '412220', 'N', 'N', 'S', NULL, 101, 'N', 'N', 'N', '311', NULL, '01', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412230', '4102', 'PR', '4190', '4110', '41039', '41', 'RIO NEGRO', NULL, '41', '83880000', '5', '7823', '7823', '14212', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 603.246, '-26,10600', '-49,79800', 780, 'S', 0.8010, NULL, NULL, '41900', 'N', 'N', 4178, NULL, '4101', '4190', NULL, '1870', 'S', 3494, 'RIO NEGRO', 'N', '412230', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '312', NULL, '03', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412240', '4117', 'PR', '4190', '4103', '41011', '41', 'ROLANDIA', NULL, '43', '86600000', '4', '7825', '7825', '14213', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 460.153, '-23,31000', '-51,36900', 730, 'S', 0.7840, NULL, NULL, '41900', 'N', 'N', 4210, NULL, '4102', '4103', NULL, '1947', 'S', 3495, 'ROLÂNDIA', 'N', '412240', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '313', NULL, '02', 'N', NULL, NULL, NULL, 374);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412250', '4111', 'PR', '4190', '4102', '41005', '41', 'RONCADOR', NULL, '44', '87320000', '3', '7827', '7827', '14214', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 750.993, '-24,60300', '-52,27500', 762, 'S', 0.7010, NULL, NULL, '41900', 'N', 'N', 4215, NULL, '4190', '4190', NULL, '1960', 'S', 3496, 'RONCADOR', 'N', '412250', 'N', 'N', 'S', NULL, 68, 'N', 'N', 'N', '314', NULL, '03', 'N', NULL, NULL, NULL, 141);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412260', '4113', 'PR', '4190', '4101', '41003', '41', 'RONDON', NULL, '44', '87800000', '2', '7829', '7829', '14215', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 556.082, '-23,41100', '-52,76100', 400, 'S', 0.7340, NULL, NULL, '41900', 'N', 'N', 4218, NULL, '4190', '4190', NULL, '1954', 'S', 3497, 'RONDON', 'N', '412260', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '315', NULL, '03', 'N', NULL, NULL, NULL, 142);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412265', '4122', 'PR', '4190', '4103', '41013', '41', 'ROSARIO DO IVAI', NULL, '43', '86850000', '1', '8473', '8473', '14313', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 371.248, '-24,27800', '-51,27500', 750, 'S', 0.6640, NULL, NULL, '41900', 'S', 'N', 4227, NULL, '4190', '4190', NULL, '1989', 'S', 3498, 'ROSÁRIO DO IVAÍ', 'N', '412265', 'N', 'N', 'S', NULL, 68, 'N', 'N', 'N', '316', NULL, '03', 'N', NULL, NULL, NULL, 316);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412270', '4116', 'PR', '4190', '4103', '41010', '41', 'SABAUDIA', NULL, '44', '86720000', '1', '7831', '7831', '14216', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 190.324, '-23,31800', '-51,55300', 730, 'S', 0.7540, NULL, NULL, '41900', 'N', 'N', 4242, NULL, '4190', '4190', NULL, '1954', 'S', 3499, 'SABÁUDIA', 'N', '412270', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '317', NULL, '03', 'N', NULL, NULL, NULL, 373);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412280', '4108', 'PR', '4190', '4107', '41026', '41', 'SALGADO FILHO', NULL, '46', '85620000', '0', '7833', '7833', '14217', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 183.080, '-26,17000', '-53,36100', 620, 'S', 0.7590, NULL, NULL, '41900', 'N', 'N', 4259, NULL, '4190', '4190', NULL, '1963', 'S', 3500, 'SALGADO FILHO', 'N', '412280', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '318', NULL, '03', 'N', NULL, NULL, NULL, 34);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412290', '4119', 'PR', '4190', '4104', '41018', '41', 'SALTO DO ITARARE', NULL, '43', '84945000', '9', '7835', '7835', '14218', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 200.517, '-23,60100', '-49,62600', 502, 'S', 0.6950, NULL, NULL, '41900', 'S', 'N', 4273, NULL, '4190', '4190', NULL, '1960', 'S', 3501, 'SALTO DO ITARARÉ', 'N', '412290', 'N', 'N', 'S', NULL, 146, 'N', 'N', 'N', '319', NULL, '03', 'N', NULL, NULL, NULL, 427);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412300', '4108', 'PR', '4190', '4107', '41026', '41', 'SALTO DO LONTRA', NULL, '46', '85670000', '6', '7837', '7837', '14219', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 313.290, '-25,78400', '-53,30900', 538, 'S', 0.7600, NULL, NULL, '41900', 'N', 'N', 4275, NULL, '4190', '4190', NULL, '1964', 'S', 3502, 'SALTO DO LONTRA', 'N', '412300', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '320', NULL, '03', 'N', NULL, NULL, NULL, 34);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412310', '4118', 'PR', '4190', '4104', '41015', '41', 'SANTA AMELIA', NULL, '43', '86370000', '5', '7839', '7839', '14220', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 77.903, '-23,26600', '-50,42400', 500, 'S', 0.7110, NULL, NULL, '41900', 'N', 'N', 4292, NULL, '4190', '4190', NULL, '1951', 'S', 3503, 'SANTA AMÉLIA', 'N', '412310', 'N', 'N', 'S', NULL, 146, 'N', 'N', 'N', '321', NULL, '03', 'N', NULL, NULL, NULL, 31);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412320', '4118', 'PR', '4190', '4104', '41014', '41', 'SANTA CECILIA DO PAVAO', NULL, '43', '86225000', '4', '7841', '7841', '14221', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 110.200, '-23,51700', '-50,78400', 660, 'S', 0.7120, NULL, NULL, '41900', 'N', 'N', 4307, NULL, '4190', '4190', NULL, '1960', 'S', 3504, 'SANTA CECÍLIA DO PAVÃO', 'N', '412320', 'N', 'N', 'S', NULL, 146, 'N', 'N', 'N', '322', NULL, '03', 'N', NULL, NULL, NULL, 31);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412330', '4114', 'PR', '4190', '4101', '41001', '41', 'SANTA CRUZ DE MONTE CASTELO', NULL, '44', '87920000', '3', '7843', '7843', '14222', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 442.012, '-22,95300', '-53,29700', 382, 'S', 0.7080, NULL, NULL, '41900', 'N', 'N', 4321, NULL, '4190', '4190', NULL, '1954', 'S', 3505, 'SANTA CRUZ DE MONTE CASTELO', 'N', '412330', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '323', NULL, '03', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412340', '4115', 'PR', '4190', '4103', '41006', '41', 'SANTA FE', NULL, '44', '86770000', '2', '7845', '7845', '14223', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 276.241, '-23,03800', '-51,80500', 538, 'S', 0.7730, NULL, NULL, '41900', 'N', 'N', 4332, NULL, '4103', '4190', NULL, '1955', 'S', 3506, 'SANTA FÉ', 'N', '412340', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '324', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412350', '4120', 'PR', '4190', '4106', '41022', '41', 'SANTA HELENA', NULL, '45', '85892000', '1', '7971', '7971', '14287', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 758.229, '-24,86000', '-54,33300', 258, 'S', 0.7990, NULL, NULL, '41900', 'N', 'N', 4341, NULL, '4190', '4190', NULL, '1967', 'S', 3507, 'SANTA HELENA', 'N', '412350', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '325', NULL, '03', 'N', NULL, NULL, NULL, 267);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412360', '4115', 'PR', '4190', '4103', '41006', '41', 'SANTA INES', NULL, '44', '86660000', '0', '7847', '7847', '14224', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 138.480, '-22,63800', '-51,90300', 360, 'S', 0.7260, NULL, NULL, '41900', 'N', 'N', 4350, NULL, '4190', '4190', NULL, '1961', 'S', 3508, 'SANTA INÊS', 'N', '412360', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '326', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412370', '4114', 'PR', '4190', '4101', '41001', '41', 'SANTA ISABEL DO IVAI', NULL, '44', '87910000', '9', '7849', '7849', '14225', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 349.497, '-23,00300', '-53,19700', 424, 'S', 0.7580, NULL, NULL, '41900', 'N', 'N', 4353, NULL, '4190', '4190', NULL, '1954', 'S', 3509, 'SANTA ISABEL DO IVAÍ', 'N', '412370', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '327', NULL, '03', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412380', '4108', 'PR', '4190', '4107', '41025', '41', 'SANTA IZABEL DO OESTE', NULL, '46', '85650000', '8', '7851', '7851', '14226', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 321.169, '-25,82100', '-53,48400', 518, 'S', 0.7670, NULL, NULL, '41900', 'N', 'N', 4356, NULL, '4190', '4190', NULL, '1963', 'S', 3510, 'SANTA IZABEL DO OESTE', 'N', '412380', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '328', NULL, '03', 'N', NULL, NULL, NULL, 34);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412382', '4110', 'PR', '4190', '4106', '41023', '41', 'SANTA LUCIA', NULL, '45', '85795000', '4', '5469', '5469', '14353', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 116.857, '-25,40700', '-53,56600', 441, 'S', 0.7250, NULL, NULL, '41900', 'N', 'N', 4359, NULL, '4190', '4190', NULL, '1993', 'S', 3511, 'SANTA LÚCIA', 'N', '412382', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '329', NULL, '03', 'N', NULL, NULL, NULL, 258);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412385', '4122', 'PR', '4190', '4108', '41028', '41', 'SANTA MARIA DO OESTE', NULL, '42', '85230000', '7', '5505', '5505', '14354', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 847.137, '-24,93900', '-51,86300', 1049, 'S', 0.6620, NULL, NULL, '41900', 'S', 'N', 4382, NULL, '4190', '4190', NULL, '1993', 'S', 3512, 'SANTA MARIA DO OESTE', 'N', '412385', 'N', 'N', 'S', NULL, 68, 'N', 'N', 'N', '330', NULL, '03', 'N', NULL, NULL, NULL, 316);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412390', '4118', 'PR', '4190', '4104', '41015', '41', 'SANTA MARIANA', NULL, '43', '86350000', '7', '7853', '7853', '14227', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 423.909, '-23,15100', '-50,51900', 455, 'S', 0.7510, NULL, NULL, '41900', 'N', 'N', 4388, NULL, '4190', '4190', NULL, '1947', 'S', 3513, 'SANTA MARIANA', 'N', '412390', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '331', NULL, '03', 'N', NULL, NULL, NULL, 31);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412395', '4114', 'PR', '4190', '4101', '41001', '41', 'SANTA MONICA', NULL, '44', '87915000', '6', '5519', '5519', '14355', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 259.956, '-23,10800', '-53,10900', 382, 'S', 0.7000, NULL, NULL, '41900', 'S', 'N', 4390, NULL, '4190', '4190', NULL, '1993', 'S', 3514, 'SANTA MÔNICA', 'N', '412395', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '332', NULL, '03', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412400', '4119', 'PR', '4190', '4104', '41018', '41', 'SANTANA DO ITARARE', NULL, '43', '84970000', '4', '7855', '7855', '14228', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 251.265, '-23,75500', '-49,62900', 545, 'S', 0.6960, NULL, NULL, '41900', 'S', 'N', 4451, NULL, '4190', '4190', NULL, '1961', 'S', 3517, 'SANTANA DO ITARARÉ', 'N', '412400', 'N', 'N', 'S', NULL, 146, 'S', 'N', 'N', '335', NULL, '03', 'N', NULL, NULL, NULL, 427);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412402', '4110', 'PR', '4190', '4106', '41023', '41', 'SANTA TEREZA DO OESTE', NULL, '45', '85825000', '0', '9969', '9969', '14324', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 326.917, '-25,05200', '-53,63300', 749, 'S', 0.7350, NULL, NULL, '41900', 'N', 'N', 4424, NULL, '4190', '4190', NULL, '1990', 'S', 3515, 'SANTA TEREZA DO OESTE', 'N', '412402', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '333', NULL, '03', 'N', NULL, NULL, NULL, 258);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412405', '4109', 'PR', '4190', '4106', '41024', '41', 'SANTA TEREZINHA DE ITAIPU', NULL, '45', '85875000', '3', '8467', '8467', '14309', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 259.393, '-25,44700', '-54,40100', 218, 'S', 0.7780, NULL, NULL, '41900', 'N', 'N', 4430, NULL, '4190', '4190', NULL, '1982', 'S', 3516, 'SANTA TEREZINHA DE ITAIPU', 'N', '412405', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '334', NULL, '03', 'N', NULL, NULL, NULL, 80);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412410', '4119', 'PR', '4190', '4104', '41016', '41', 'SANTO ANTONIO DA PLATINA', NULL, '43', '86430000', '3', '7859', '7859', '14230', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 721.625, '-23,29500', '-50,07700', 505, 'S', 0.7450, NULL, NULL, '41900', 'N', 'N', 4484, NULL, '4190', '4190', NULL, '1914', 'S', 3518, 'SANTO ANTÔNIO DA PLATINA', 'N', '412410', 'N', 'N', 'S', NULL, 146, 'N', 'N', 'N', '336', NULL, '03', 'N', NULL, NULL, NULL, 427);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412420', '4114', 'PR', '4190', '4101', '41001', '41', 'SANTO ANTONIO DO CAIUA', NULL, '44', '87730000', '2', '7861', '7861', '14231', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 219.066, '-22,73500', '-52,34200', 440, 'S', 0.7500, NULL, NULL, '41900', 'N', 'N', 4494, NULL, '4190', '4190', NULL, '1961', 'S', 3519, 'SANTO ANTÔNIO DO CAIUÁ', 'N', '412420', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '337', NULL, '03', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412430', '4118', 'PR', '4190', '4104', '41015', '41', 'SANTO ANTONIO DO PARAISO', NULL, '43', '86315000', '1', '7863', '7863', '14232', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 165.904, '-23,49400', '-50,64600', 655, 'S', 0.7150, NULL, NULL, '41900', 'N', 'N', 4504, NULL, '4190', '4190', NULL, '1960', 'S', 3520, 'SANTO ANTÔNIO DO PARAÍSO', 'N', '412430', 'N', 'N', 'S', NULL, 146, 'N', 'N', 'N', '338', NULL, '03', 'N', NULL, NULL, NULL, 31);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412440', '4108', 'PR', '4190', '4107', '41026', '41', 'SANTO ANTONIO DO SUDOESTE', NULL, '46', '85710000', '0', '7857', '7857', '14229', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 325.672, '-26,07000', '-53,72300', 548, 'S', 0.7150, NULL, NULL, '41900', 'N', 'N', 4509, NULL, '4190', '4190', NULL, '1951', 'S', 3521, 'SANTO ANTÔNIO DO SUDOESTE', 'N', '412440', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '339', NULL, '03', 'N', NULL, NULL, NULL, 34);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412450', '4115', 'PR', '4190', '4103', '41006', '41', 'SANTO INACIO', NULL, '44', '86650000', '9', '7865', '7865', '14233', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 306.871, '-22,69800', '-51,79400', 370, 'S', 0.7380, NULL, NULL, '41900', 'N', 'N', 4519, NULL, '4190', '4190', NULL, '1951', 'S', 3522, 'SANTO INÁCIO', 'N', '412450', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '340', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412460', '4114', 'PR', '4190', '4101', '41001', '41', 'SAO CARLOS DO IVAI', NULL, '44', '87770000', '8', '7867', '7867', '14234', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 225.077, '-23,31500', '-52,47600', 380, 'S', 0.7380, NULL, NULL, '41900', 'N', 'N', 4550, NULL, '4190', '4190', NULL, '1956', 'S', 3523, 'SÃO CARLOS DO IVAÍ', 'N', '412460', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '341', NULL, '03', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412470', '4118', 'PR', '4190', '4104', '41014', '41', 'SAO JERONIMO DA SERRA', NULL, '43', '86270000', '7', '7869', '7869', '14235', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 823.773, '-23,72800', '-50,74100', 976, 'S', 0.6740, NULL, NULL, '41900', 'S', 'N', 4622, NULL, '4190', '4190', NULL, '1947', 'S', 3524, 'SÃO JERÔNIMO DA SERRA', 'N', '412470', 'N', 'N', 'S', NULL, 146, 'S', 'N', 'N', '342', NULL, '03', 'N', NULL, NULL, NULL, 31);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412480', '4107', 'PR', '4190', '4107', '41027', '41', 'SAO JOAO', NULL, '46', '85570000', '6', '7871', '7871', '14236', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 388.060, '-25,82800', '-52,72500', 750, 'S', 0.7740, NULL, NULL, '41900', 'N', 'N', 4624, NULL, '4190', '4190', NULL, '1960', 'S', 3525, 'SÃO JOÃO', 'N', '412480', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '343', NULL, '03', 'N', NULL, NULL, NULL, 268);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412490', '4114', 'PR', '4190', '4101', '41001', '41', 'SAO JOAO DO CAIUA', NULL, '44', '87740000', '5', '7873', '7873', '14237', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 304.412, '-22,85200', '-52,33700', 410, 'S', 0.7120, NULL, NULL, '41900', 'N', 'N', 4650, NULL, '4190', '4190', NULL, '1954', 'S', 3526, 'SÃO JOÃO DO CAIUÁ', 'N', '412490', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '344', NULL, '03', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412500', '4122', 'PR', '4190', '4103', '41013', '41', 'SAO JOAO DO IVAI', NULL, '43', '86930000', '1', '7875', '7875', '14238', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 353.331, '-23,98000', '-51,81800', 495, 'S', 0.6890, NULL, NULL, '41900', 'S', 'N', 4654, NULL, '4190', '4190', NULL, '1964', 'S', 3527, 'SÃO JOÃO DO IVAÍ', 'N', '412500', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '345', NULL, '03', 'N', NULL, NULL, NULL, 316);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412510', '4103', 'PR', '4190', '4109', '41034', '41', 'SAO JOAO DO TRIUNFO', NULL, '42', '84150000', '0', '7877', '7877', '14239', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 720.407, '-25,68300', '-50,29700', 840, 'S', 0.6790, NULL, NULL, '41900', 'S', 'N', 4671, NULL, '4190', '4190', NULL, '1890', 'S', 3528, 'SÃO JOÃO DO TRIUNFO', 'N', '412510', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '346', NULL, '03', 'N', NULL, NULL, NULL, 146);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412520', '4108', 'PR', '4190', '4107', '41026', '41', 'SAO JORGE D''OESTE', NULL, '46', '85575000', '9', '7881', '7881', '14241', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 379.047, '-25,70600', '-52,91800', 541, 'S', 0.7540, NULL, NULL, '41900', 'N', 'N', 4680, NULL, '4190', '4190', NULL, '1963', 'S', 3531, 'SÃO JORGE D OESTE', 'N', '412520', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '347', NULL, '03', 'N', NULL, NULL, NULL, 34);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412530', '4115', 'PR', '4190', '4103', '41008', '41', 'SAO JORGE DO IVAI', NULL, '44', '87190000', '8', '7879', '7879', '14240', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 315.088, '-23,43300', '-52,29300', 430, 'S', 0.7920, NULL, NULL, '41900', 'N', 'N', 4681, NULL, '4103', '4190', NULL, '1954', 'S', 3529, 'SÃO JORGE DO IVAÍ', 'N', '412530', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '348', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412535', '4112', 'PR', '4190', '4101', '41002', '41', 'SAO JORGE DO PATROCINIO', NULL, '44', '87555000', '7', '7999', '7999', '14295', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 404.689, '-23,74100', '-53,92700', 274, 'S', 0.7080, NULL, NULL, '41900', 'N', 'N', 4682, NULL, '4190', '4190', NULL, '1981', 'S', 3530, 'SÃO JORGE DO PATROCÍNIO', 'N', '412535', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '349', NULL, '03', 'N', NULL, NULL, NULL, 312);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412540', '4119', 'PR', '4190', '4104', '41018', '41', 'SAO JOSE DA BOA VISTA', NULL, '43', '84980000', '7', '7883', '7883', '14242', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 399.670, '-23,91600', '-49,65200', 525, 'S', 0.7070, NULL, NULL, '41900', 'N', 'N', 4686, NULL, '4190', '4190', NULL, '1960', 'S', 3532, 'SÃO JOSÉ DA BOA VISTA', 'N', '412540', 'N', 'N', 'S', NULL, 146, 'N', 'N', 'N', '350', NULL, '03', 'N', NULL, NULL, NULL, 427);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412545', '4120', 'PR', '4190', '4106', '41022', '41', 'SAO JOSE DAS PALMEIRAS', NULL, '45', '85898000', '6', '8471', '8471', '14311', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 182.418, '-24,83800', '-54,06400', 530, 'S', 0.7240, NULL, NULL, '41900', 'N', 'N', 4696, NULL, '4190', '4190', NULL, '1989', 'S', 3533, 'SÃO JOSÉ DAS PALMEIRAS', 'N', '412545', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '351', NULL, '03', 'N', NULL, NULL, NULL, 267);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412550', '4102', 'PR', '4190', '4110', '41037', '41', 'SAO JOSE DOS PINHAIS', NULL, '41', '83005000', '6', '7885', '7885', '14243', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 945.717, '-25,53500', '-49,20600', 906, 'S', 0.7960, NULL, NULL, '41900', 'N', 'N', 4739, NULL, '4101', '4101', NULL, '1852', 'S', 3534, 'SÃO JOSÉ DOS PINHAIS', 'N', '412550', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '352', NULL, '01', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412555', '4113', 'PR', '4190', '4101', '41003', '41', 'SAO MANOEL DO PARANA', NULL, '44', '87215000', '5', '5515', '5515', '14382', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 95.382, '-23,40300', '-52,64400', 399, 'S', 0.7500, NULL, NULL, '41900', 'N', 'N', 4763, NULL, '4190', '4190', NULL, '1993', 'S', 3535, 'SÃO MANOEL DO PARANÁ', 'N', '412555', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '353', NULL, '03', 'N', NULL, NULL, NULL, 142);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412560', '4106', 'PR', '4190', '4109', '41034', '41', 'SAO MATEUS DO SUL', NULL, '42', '83900000', '5', '7887', '7887', '14244', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1342.633, '-25,87400', '-50,38300', 835, 'S', 0.7660, NULL, NULL, '41900', 'N', 'N', 4771, NULL, '4190', '4190', NULL, '1943', 'S', 3536, 'SÃO MATEUS DO SUL', 'N', '412560', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '354', NULL, '03', 'N', NULL, NULL, NULL, 33);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412570', '4109', 'PR', '4190', '4106', '41024', '41', 'SAO MIGUEL DO IGUACU', NULL, '45', '85877000', '4', '7889', '7889', '14245', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 851.301, '-25,34800', '-54,23800', 312, 'S', 0.7790, NULL, NULL, '41900', 'N', 'N', 4787, NULL, '4190', '4190', NULL, '1961', 'S', 3537, 'SÃO MIGUEL DO IGUAÇU', 'N', '412570', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '355', NULL, '03', 'N', NULL, NULL, NULL, 80);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412575', '4120', 'PR', '4190', '4106', '41022', '41', 'SAO PEDRO DO IGUACU', NULL, '45', '85929000', '3', '5489', '5489', '14357', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 308.328, '-24,93600', '-53,85500', 555, 'S', 0.7320, NULL, NULL, '41900', 'N', 'N', 4808, NULL, '4190', '4190', NULL, '1993', 'S', 3538, 'SÃO PEDRO DO IGUAÇU', 'N', '412575', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '356', NULL, '03', 'N', NULL, NULL, NULL, 267);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412580', '4116', 'PR', '4190', '4103', '41013', '41', 'SAO PEDRO DO IVAI', NULL, '43', '86945000', '3', '7891', '7891', '14246', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 322.692, '-23,86500', '-51,85600', 440, 'S', 0.7450, NULL, NULL, '41900', 'N', 'N', 4809, NULL, '4190', '4190', NULL, '1954', 'S', 3539, 'SÃO PEDRO DO IVAÍ', 'N', '412580', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '357', NULL, '03', 'N', NULL, NULL, NULL, 373);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412590', '4114', 'PR', '4190', '4101', '41001', '41', 'SAO PEDRO DO PARANA', NULL, '44', '87955000', '2', '7893', '7893', '14247', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 250.653, '-22,82400', '-53,22000', 285, 'S', 0.7620, NULL, NULL, '41900', 'N', 'N', 4810, NULL, '4190', '4190', NULL, '1963', 'S', 3540, 'SÃO PEDRO DO PARANÁ', 'N', '412590', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '358', NULL, '03', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412600', '4118', 'PR', '4190', '4104', '41014', '41', 'SAO SEBASTIAO DA AMOREIRA', NULL, '43', '86240000', '9', '7895', '7895', '14248', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 227.982, '-23,46500', '-50,76100', 664, 'S', 0.7240, NULL, NULL, '41900', 'N', 'N', 4829, NULL, '4190', '4190', NULL, '1951', 'S', 3541, 'SÃO SEBASTIÃO DA AMOREIRA', 'N', '412600', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '359', NULL, '03', 'N', NULL, NULL, NULL, 31);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412610', '4113', 'PR', '4190', '4101', '41003', '41', 'SAO TOME', NULL, '44', '87220000', '8', '7897', '7897', '14249', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 218.624, '-23,53800', '-52,59100', 465, 'S', 0.7380, NULL, NULL, '41900', 'N', 'N', 4853, NULL, '4190', '4190', NULL, '1960', 'S', 3542, 'SÃO TOMÉ', 'N', '412610', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '360', NULL, '03', 'N', NULL, NULL, NULL, 142);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412620', '4118', 'PR', '4190', '4104', '41017', '41', 'SAPOPEMA', NULL, '43', '84290000', '7', '7899', '7899', '14250', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 677.610, '-23,91100', '-50,58000', 759, 'S', 0.6980, NULL, NULL, '41900', 'S', 'N', 4870, NULL, '4190', '4190', NULL, '1960', 'S', 3543, 'SAPOPEMA', 'N', '412620', 'N', 'N', 'S', NULL, 146, 'N', 'N', 'N', '361', NULL, '03', 'N', NULL, NULL, NULL, 31);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412625', '4115', 'PR', '4190', '4103', '41009', '41', 'SARANDI', NULL, '44', '86985000', '6', '8461', '8461', '14296', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 103.226, '-23,44400', '-51,87400', 592, 'S', 0.7680, NULL, NULL, '41900', 'N', 'N', 4877, NULL, '4103', '4104', NULL, '1981', 'S', 3544, 'SARANDI', 'N', '412625', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '362', NULL, '02', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412627', '4107', 'PR', '4190', '4107', '41027', '41', 'SAUDADE DO IGUACU', NULL, '46', '85568000', '2', '5493', '5493', '14390', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 152.084, '-25,69400', '-52,61900', 650, 'S', 0.7810, NULL, NULL, '41900', 'N', 'N', 4886, NULL, '4190', '4190', NULL, '1993', 'S', 3545, 'SAUDADE DO IGUAÇU', 'N', '412627', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '363', NULL, '03', 'N', NULL, NULL, NULL, 268);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412630', '4103', 'PR', '4190', '4105', '41020', '41', 'SENGES', NULL, '43', '84220000', '6', '7901', '7901', '14251', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1366.628, '-24,11300', '-49,46400', 623, 'S', 0.7180, NULL, NULL, '41900', 'N', 'N', 4919, NULL, '4190', '4190', NULL, '1934', 'S', 3546, 'SENGÉS', 'N', '412630', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '364', NULL, '03', 'N', NULL, NULL, NULL, 146);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412635', '4109', 'PR', '4190', '4106', '41024', '41', 'SERRANOPOLIS DO IGUACU', NULL, '45', '85885000', '5', '0882', NULL, '14412', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 483.658, '-25,38000', '-54,05200', 320, 'S', 0.7960, NULL, NULL, '41900', 'N', 'N', 4959, NULL, '4190', '4190', NULL, '1997', 'S', 3547, 'SERRANÓPOLIS DO IGUAÇU', 'N', '412635', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '365', NULL, '03', 'N', NULL, NULL, NULL, 80);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412640', '4118', 'PR', '4190', '4104', '41015', '41', 'SERTANEJA', NULL, '43', '86340000', '5', '7903', '7903', '14252', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 444.488, '-23,03700', '-50,83800', 401, 'S', 0.7860, NULL, NULL, '41900', 'N', 'N', 4968, NULL, '4190', '4190', NULL, '1951', 'S', 3548, 'SERTANEJA', 'N', '412640', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '366', NULL, '03', 'N', NULL, NULL, NULL, 31);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412650', '4117', 'PR', '4190', '4103', '41007', '41', 'SERTANOPOLIS', NULL, '43', '86170000', '4', '7905', '7905', '14253', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 505.528, '-23,05900', '-51,03600', 361, 'S', 0.7810, NULL, NULL, '41900', 'N', 'N', 4970, NULL, '4102', '4190', NULL, '1934', 'S', 3549, 'SERTANÓPOLIS', 'N', '412650', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '367', NULL, '03', 'N', NULL, NULL, NULL, 374);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412660', '4119', 'PR', '4190', '4104', '41018', '41', 'SIQUEIRA CAMPOS', NULL, '43', '84940000', '3', '7907', '7907', '14254', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 278.035, '-23,68900', '-49,83400', 675, 'S', 0.7530, NULL, NULL, '41900', 'N', 'N', 5003, NULL, '4190', '4190', NULL, '1920', 'S', 3550, 'SIQUEIRA CAMPOS', 'N', '412660', 'N', 'N', 'S', NULL, 146, 'N', 'N', 'N', '368', NULL, '03', 'N', NULL, NULL, NULL, 427);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412665', '4107', 'PR', '4190', '4107', '41027', '41', 'SULINA', NULL, '46', '85565000', '2', '8477', '8477', '14316', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 170.760, '-25,70200', '-52,72200', 470, 'S', 0.7730, NULL, NULL, '41900', 'N', 'N', 5039, NULL, '4190', '4190', NULL, '1989', 'S', 3551, 'SULINA', 'N', '412665', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '369', NULL, '03', 'N', NULL, NULL, NULL, 268);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412667', '4117', 'PR', '4190', '4103', '41011', '41', 'TAMARANA', NULL, '43', '86125000', '8', '0884', NULL, '14358', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 472.153, '-23,72300', '-51,09700', 753, 'S', 0.6830, NULL, NULL, '41900', 'S', 'N', 5074, NULL, '4102', '4103', NULL, '1997', 'S', 3552, 'TAMARANA', 'N', '412667', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '370', NULL, '03', 'N', NULL, NULL, NULL, 374);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412670', '4114', 'PR', '4190', '4101', '41001', '41', 'TAMBOARA', NULL, '44', '87760000', '2', '7909', '7909', '14255', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 193.345, '-23,20000', '-52,46900', 340, 'S', 0.7820, NULL, NULL, '41900', 'N', 'N', 5076, NULL, '4190', '4190', NULL, '1954', 'S', 3553, 'TAMBOARA', 'N', '412670', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '371', NULL, '03', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412680', '4113', 'PR', '4190', '4101', '41003', '41', 'TAPEJARA', NULL, '44', '87430000', '1', '7911', '7911', '14256', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 591.400, '-23,73300', '-52,87300', 515, 'S', 0.7300, NULL, NULL, '41900', 'N', 'N', 5092, NULL, '4190', '4190', NULL, '1963', 'S', 3554, 'TAPEJARA', 'N', '412680', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '372', NULL, '03', 'N', NULL, NULL, NULL, 142);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412690', '4112', 'PR', '4190', '4101', '41002', '41', 'TAPIRA', NULL, '44', '87830000', '0', '7973', '7973', '14288', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 434.367, '-23,32300', '-53,06800', 370, 'S', 0.7310, NULL, NULL, '41900', 'N', 'N', 5097, NULL, '4190', '4190', NULL, '1967', 'S', 3555, 'TAPIRA', 'N', '412690', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '373', NULL, '03', 'N', NULL, NULL, NULL, 312);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412700', '4104', 'PR', '4190', '4109', '41031', '41', 'TEIXEIRA SOARES', NULL, '42', '84530000', '7', '7913', '7913', '14257', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 902.793, '-25,36800', '-50,46100', 902, 'S', 0.7380, NULL, NULL, '41900', 'N', 'N', 5131, NULL, '4190', '4190', NULL, '1917', 'S', 3556, 'TEIXEIRA SOARES', 'N', '412700', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '374', NULL, '03', 'N', NULL, NULL, NULL, 79);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412710', '4121', 'PR', '4190', '4105', '41019', '41', 'TELEMACO BORBA', NULL, '42', '84261970', '6', '7915', '7915', '14258', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1225.676, '-24,32400', '-50,61600', 700, 'S', 0.7670, NULL, NULL, '41900', 'N', 'N', 5136, NULL, '4190', '4190', NULL, '1963', 'S', 3557, 'TELÊMACO BORBA', 'N', '412710', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '375', NULL, '02', 'N', NULL, NULL, NULL, 375);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412720', '4111', 'PR', '4190', '4102', '41005', '41', 'TERRA BOA', NULL, '44', '87240000', '5', '7917', '7917', '14259', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 320.905, '-23,76800', '-52,44400', 575, 'S', 0.7440, NULL, NULL, '41900', 'N', 'N', 5155, NULL, '4190', '4190', NULL, '1955', 'S', 3558, 'TERRA BOA', 'N', '412720', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '376', NULL, '03', 'N', NULL, NULL, NULL, 141);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412730', '4114', 'PR', '4190', '4101', '41001', '41', 'TERRA RICA', NULL, '44', '87890000', '4', '7919', '7919', '14260', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 700.587, '-22,70900', '-52,61700', 442, 'S', 0.7460, NULL, NULL, '41900', 'N', 'N', 5160, NULL, '4190', '4190', NULL, '1954', 'S', 3559, 'TERRA RICA', 'N', '412730', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '377', NULL, '03', 'N', NULL, NULL, NULL, 367);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412740', '4120', 'PR', '4190', '4106', '41022', '41', 'TERRA ROXA', NULL, '44', '85990000', '3', '7921', '7921', '14261', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 800.786, '-24,15700', '-54,09700', 410, 'S', 0.7640, NULL, NULL, '41900', 'N', 'N', 5162, NULL, '4190', '4190', NULL, '1961', 'S', 3560, 'TERRA ROXA', 'N', '412740', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '378', NULL, '03', 'N', NULL, NULL, NULL, 267);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412750', '4121', 'PR', '4190', '4105', '41019', '41', 'TIBAGI', NULL, '42', '84300000', '2', '7923', '7923', '14262', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3108.746, '-24,50900', '-50,41400', 748, 'S', 0.6860, NULL, NULL, '41900', 'S', 'N', 5168, NULL, '4190', '4190', NULL, '1872', 'S', 3561, 'TIBAGI', 'N', '412750', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '379', NULL, '03', 'N', NULL, NULL, NULL, 375);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412760', '4102', 'PR', '4190', '4110', '41039', '41', 'TIJUCAS DO SUL', NULL, '41', '83190000', '1', '7925', '7925', '14263', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 672.197, '-25,92800', '-49,19900', 875, 'S', 0.7160, NULL, NULL, '41900', 'N', 'N', 5174, NULL, '4101', '4101', NULL, '1951', 'S', 3562, 'TIJUCAS DO SUL', 'N', '412760', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '380', NULL, '01', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412770', '4120', 'PR', '4190', '4106', '41022', '41', 'TOLEDO', NULL, '45', '85900910', '0', '7927', '7927', '14264', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1197.016, '-24,71400', '-53,74300', 560, 'S', 0.8270, NULL, NULL, '41900', 'N', 'N', 5192, NULL, '4190', '4102', NULL, '1951', 'S', 3563, 'TOLEDO', 'N', '412770', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '381', NULL, '01', 'N', NULL, NULL, NULL, 267);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412780', '4119', 'PR', '4190', '4104', '41018', '41', 'TOMAZINA', NULL, '43', '84935000', '9', '7929', '7929', '14265', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 591.436, '-23,77800', '-49,95000', 541, 'S', 0.7160, NULL, NULL, '41900', 'N', 'N', 5195, NULL, '4190', '4190', NULL, '1888', 'S', 3564, 'TOMAZINA', 'N', '412780', 'N', 'N', 'S', NULL, 146, 'N', 'N', 'N', '382', NULL, '03', 'N', NULL, NULL, NULL, 427);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412785', '4110', 'PR', '4190', '4106', '41023', '41', 'TRES BARRAS DO PARANA', NULL, '45', '85485000', '8', '7987', '7987', '14297', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 504.172, '-25,41900', '-53,18100', 562, 'S', 0.7200, NULL, NULL, '41900', 'N', 'N', 5219, NULL, '4190', '4190', NULL, '1980', 'S', 3565, 'TRÊS BARRAS DO PARANÁ', 'N', '412785', 'N', 'N', 'S', NULL, 25, 'N', 'N', 'N', '383', NULL, '03', 'N', NULL, NULL, NULL, 258);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412788', '4102', 'PR', '4190', '4110', '41037', '41', 'TUNAS DO PARANA', NULL, '41', '83480000', '2', '5455', '5455', '14391', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 668.481, '-24,97400', '-49,08600', 906, 'S', 0.6860, NULL, NULL, '41900', 'S', 'N', 5256, NULL, '4101', '4101', NULL, '1993', 'S', 3566, 'TUNAS DO PARANÁ', 'N', '412788', 'N', 'N', 'S', NULL, 101, 'S', 'N', 'N', '384', NULL, '01', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412790', '4113', 'PR', '4190', '4101', '41003', '41', 'TUNEIRAS DO OESTE', NULL, '44', '87450000', '8', '7931', '7931', '14266', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 698.870, '-23,87100', '-52,87600', 502, 'S', 0.7070, NULL, NULL, '41900', 'N', 'N', 5257, NULL, '4190', '4190', NULL, '1960', 'S', 3567, 'TUNEIRAS DO OESTE', 'N', '412790', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '385', NULL, '03', 'N', NULL, NULL, NULL, 142);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412795', '4120', 'PR', '4190', '4106', '41022', '41', 'TUPASSI', NULL, '44', '85945000', '7', '7993', '7993', '14302', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 310.912, '-24,58800', '-53,51200', 540, 'S', 0.8090, NULL, NULL, '41900', 'N', 'N', 5267, NULL, '4190', '4190', NULL, '1979', 'S', 3568, 'TUPÃSSI', 'N', '412795', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '386', NULL, '03', 'N', NULL, NULL, NULL, 267);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412796', '4105', 'PR', '4190', '4108', '41029', '41', 'TURVO', NULL, '42', '85150000', '5', '8453', '8453', '14310', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 902.246, '-25,04300', '-51,53000', 1040, 'S', 0.6920, NULL, NULL, '41900', 'S', 'N', 5281, NULL, '4190', '4190', NULL, '1982', 'S', 3569, 'TURVO', 'N', '412796', 'N', 'N', 'S', NULL, 68, 'N', 'N', 'N', '387', NULL, '03', 'N', NULL, NULL, NULL, 32);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412800', '4111', 'PR', '4190', '4102', '41004', '41', 'UBIRATA', NULL, '44', '85440000', '5', '7933', '7933', '14267', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 652.581, '-24,54500', '-52,98800', 508, 'S', 0.7340, NULL, NULL, '41900', 'N', 'N', 5298, NULL, '4190', '4190', NULL, '1960', 'S', 3570, 'UBIRATÃ', 'N', '412800', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '388', NULL, '03', 'N', NULL, NULL, NULL, 141);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412810', '4112', 'PR', '4190', '4101', '41002', '41', 'UMUARAMA', NULL, '44', '87502970', '4', '7935', '7935', '14268', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1232.799, '-23,76600', '-53,32500', 442, 'S', 0.8000, NULL, NULL, '41900', 'N', 'N', 5313, NULL, '4190', '4190', NULL, '1960', 'S', 3571, 'UMUARAMA', 'N', '412810', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '389', NULL, '02', 'N', NULL, NULL, NULL, 312);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412820', '4106', 'PR', '4190', '4109', '41033', '41', 'UNIAO DA VITORIA', NULL, '42', '84600000', '3', '7937', '7937', '14269', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 720.005, '-26,23000', '-51,08600', 830, 'S', 0.7930, NULL, NULL, '41900', 'N', 'N', 5318, NULL, '4190', '4190', NULL, '1890', 'S', 3572, 'UNIÃO DA VITÓRIA', 'N', '412820', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '390', NULL, '02', 'N', NULL, NULL, NULL, 33);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412830', '4115', 'PR', '4190', '4103', '41006', '41', 'UNIFLOR', NULL, '44', '87640000', '2', '7939', '7939', '14270', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 94.819, '-23,08700', '-52,15700', 540, 'S', 0.7340, NULL, NULL, '41900', 'N', 'N', 5324, NULL, '4190', '4190', NULL, '1961', 'S', 3573, 'UNIFLOR', 'N', '412830', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '391', NULL, '03', 'N', NULL, NULL, NULL, 315);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412840', '4118', 'PR', '4190', '4104', '41014', '41', 'URAI', NULL, '43', '86280000', '1', '7941', '7941', '14271', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 237.806, '-23,19800', '-50,79600', 435, 'S', 0.7510, NULL, NULL, '41900', 'N', 'N', 5327, NULL, '4190', '4190', NULL, '1947', 'S', 3574, 'URAÍ', 'N', '412840', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '392', NULL, '03', 'N', NULL, NULL, NULL, 31);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412850', '4119', 'PR', '4190', '4104', '41018', '41', 'WENCESLAU BRAZ', NULL, '43', '84950000', '0', '7943', '7943', '14272', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 397.917, '-23,87400', '-49,80300', 841, 'S', 0.7270, NULL, NULL, '41900', 'N', 'N', 5491, NULL, '4190', '4190', NULL, '1935', 'S', 3581, 'WENCESLAU BRAZ', 'N', '412850', 'N', 'N', 'S', NULL, 146, 'N', 'N', 'N', '398', NULL, '03', 'N', NULL, NULL, NULL, 427);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412853', '4121', 'PR', '4190', '4105', '41019', '41', 'VENTANIA', NULL, '42', '84345000', '4', '5497', '5497', '14383', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 759.366, '-24,24600', '-50,24300', 990, 'S', 0.6650, NULL, NULL, '41900', 'S', 'N', 5401, NULL, '4190', '4190', NULL, '1993', 'S', 3575, 'VENTANIA', 'N', '412853', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '393', NULL, '03', 'N', NULL, NULL, NULL, 375);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412855', '4110', 'PR', '4190', '4106', '41024', '41', 'VERA CRUZ DO OESTE', NULL, '45', '85845000', '9', '7989', '7989', '14303', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 327.084, '-25,05800', '-53,87700', 560, 'S', 0.7370, NULL, NULL, '41900', 'N', 'N', 5408, NULL, '4190', '4190', NULL, '1979', 'S', 3576, 'VERA CRUZ DO OESTE', 'N', '412855', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '394', NULL, '03', 'N', NULL, NULL, NULL, 258);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412860', '4108', 'PR', '4190', '4107', '41026', '41', 'VERE', NULL, '46', '85585000', '9', '7945', '7945', '14273', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 312.418, '-25,88100', '-52,90800', 505, 'S', 0.7740, NULL, NULL, '41900', 'N', 'N', 5413, NULL, '4190', '4190', NULL, '1963', 'S', 3577, 'VERÊ', 'N', '412860', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '395', NULL, '03', 'N', NULL, NULL, NULL, 34);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412862', '4112', 'PR', '4190', '4101', '41002', '41', 'ALTO PARAISO', NULL, '44', '87528000', '5', '5523', '5523', '14359', NULL, 'ATIVO', 'N', 'S', NULL, 'VILA ALTA                 ', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 967.771, '-23,50800', '-53,72800', 405, 'S', 0.7040, NULL, NULL, '41900', 'N', 'N', 5441, NULL, '4190', '4190', NULL, '1993', 'S', 3578, 'ALTO PARAÍSO', 'N', '412862', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '6', NULL, '03', 'N', NULL, NULL, NULL, 312);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412863', '4102', 'PR', '4190', '4110', '41035', '41', 'DOUTOR ULYSSES', NULL, '41', '83590000', '3', '5449', '5449', '14384', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 781.447, '-24,56800', '-49,42000', 795, 'S', 0.6270, NULL, NULL, '41900', 'S', 'N', 1607, NULL, '4101', '4101', NULL, '1993', 'S', 3286, 'DOUTOR ULYSSES', 'N', '412863', 'N', 'N', 'S', NULL, 101, 'S', 'N', 'N', '103', NULL, '01', 'N', NULL, NULL, NULL, 204);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412865', '4105', 'PR', '4190', '4108', '41029', '41', 'VIRMOND', NULL, '42', '85390000', '8', '5483', '5483', '14385', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 243.176, '-25,38100', '-52,19900', 713, 'S', 0.7190, NULL, NULL, '41900', 'N', 'N', 5464, NULL, '4190', '4190', NULL, '1993', 'S', 3579, 'VIRMOND', 'N', '412865', 'N', 'N', 'S', NULL, 25, 'N', 'N', 'N', '396', NULL, '03', 'N', NULL, NULL, NULL, 32);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412870', '4107', 'PR', '4190', '4107', '41027', '41', 'VITORINO', NULL, '46', '85520000', '8', '7947', '7947', '14274', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 307.946, '-26,27700', '-52,78400', 720, 'S', 0.7850, NULL, NULL, '41900', 'N', 'N', 5481, NULL, '4190', '4190', NULL, '1960', 'S', 3580, 'VITORINO', 'N', '412870', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '397', NULL, '03', 'N', NULL, NULL, NULL, 268);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('412880', '4112', 'PR', '4190', '4101', '41002', '41', 'XAMBRE', NULL, '44', '87535000', '7', '7949', '7949', '14275', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 359.713, '-23,73600', '-53,49000', 418, 'S', 0.7510, NULL, NULL, '41900', 'N', 'N', 5496, NULL, '4190', '4190', NULL, '1960', 'S', 3582, 'XAMBRÊ', 'N', '412880', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '399', NULL, '03', 'N', NULL, NULL, NULL, 312);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420005', '4208', 'SC', '4202', '4203', '42009', '42', 'ABDON BATISTA', NULL, '49', '89636000', '1', '9939', '9939', '20200', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 235.600, '-27,61100', '-51,02300', 716, 'S', 0.7740, NULL, NULL, '42900', 'N', 'N', 10, NULL, '4290', '4290', NULL, '1990', 'S', 4374, 'ABDON BATISTA', 'N', '420005', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '1', NULL, '03', 'N', NULL, NULL, NULL, 497);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420010', '4203', 'SC', '4201', '4201', '42003', '42', 'ABELARDO LUZ', NULL, '49', '89830000', '1', '8001', '8001', '20001', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 955.368, '-26,56500', '-52,32800', 760, 'S', 0.7850, NULL, NULL, '42900', 'N', 'N', 12, NULL, '4290', '4290', NULL, '1958', 'S', 4375, 'ABELARDO LUZ', 'N', '420010', 'N', 'N', 'S', NULL, 33, 'N', 'N', 'N', '2', NULL, '03', 'N', NULL, NULL, NULL, 502);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420020', '4204', 'SC', '4203', '4204', '42014', '42', 'AGROLANDIA', NULL, '47', '88420000', '0', '8003', '8003', '20002', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 207.119, '-27,41200', '-49,82600', 405, 'S', 0.7750, NULL, NULL, '42900', 'N', 'N', 43, NULL, '4218', '4290', NULL, '1962', 'S', 4376, 'AGROLÂNDIA', 'N', '420020', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '3', NULL, '03', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420030', '4204', 'SC', '4203', '4204', '42011', '42', 'AGRONOMICA', NULL, '47', '89188000', '9', '8005', '8005', '20003', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 135.923, '-27,26500', '-49,71100', 347, 'S', 0.8110, NULL, NULL, '42900', 'N', 'N', 44, NULL, '4218', '4290', NULL, '1964', 'S', 4377, 'AGRONÔMICA', 'N', '420030', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '4', NULL, '03', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420040', '4208', 'SC', '4202', '4201', '42004', '42', 'AGUA DOCE', NULL, '49', '89654000', '8', '8007', '8007', '20004', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1313.014, '-26,99800', '-51,55600', 847, 'S', 0.8090, NULL, NULL, '42900', 'N', 'N', 53, NULL, '4290', '4290', NULL, '1958', 'S', 4378, 'ÁGUA DOCE', 'N', '420040', 'N', 'N', 'S', NULL, 33, 'N', 'N', 'N', '5', NULL, '03', 'N', NULL, NULL, NULL, 497);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420050', '4202', 'SC', '4201', '4201', '42002', '42', 'AGUAS DE CHAPECO', NULL, '49', '89883000', '7', '8009', '8009', '20005', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 139.132, '-27,07000', '-52,98700', 291, 'S', 0.7810, NULL, NULL, '42900', 'N', 'N', 66, NULL, '4215', '4290', NULL, '1962', 'S', 4379, 'ÁGUAS DE CHAPECÓ', 'N', '420050', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '6', NULL, '03', 'N', NULL, NULL, NULL, 499);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420055', '4202', 'SC', '4201', '4201', '42002', '42', 'AGUAS FRIAS', NULL, '49', '89843000', '6', '5577', '5577', '20218', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 75.162, '-26,88000', '-52,85900', 345, 'S', 0.7990, NULL, NULL, '42900', 'N', 'N', 71, NULL, '4215', '4290', NULL, '1993', 'S', 4380, 'ÁGUAS FRIAS', 'N', '420055', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '7', NULL, '03', 'N', NULL, NULL, NULL, 499);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420060', '4207', 'SC', '4205', '4205', '42017', '42', 'AGUAS MORNAS', NULL, '48', '88150000', '6', '8011', '8011', '20006', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 360.757, '-27,69400', '-48,82400', 70, 'S', 0.7830, NULL, NULL, '42900', 'N', 'N', 73, NULL, '4201', '4201', NULL, '1961', 'S', 4381, 'ÁGUAS MORNAS', 'N', '420060', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '8', NULL, '03', 'N', NULL, NULL, NULL, 494);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420070', '4207', 'SC', '4205', '4205', '42017', '42', 'ALFREDO WAGNER', NULL, '48', '88450000', '5', '8013', '8013', '20007', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 732.277, '-27,70000', '-49,33400', 480, 'S', 0.7780, NULL, NULL, '42900', 'N', 'N', 114, NULL, '4202', '4201', NULL, '1961', 'S', 4382, 'ALFREDO WAGNER', 'N', '420070', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '9', NULL, '03', 'N', NULL, NULL, NULL, 494);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420075', '4210', 'SC', '4202', '4201', '42005', '42', 'ALTO BELA VISTA', NULL, '49', '89730000', '4', '0886', NULL, '20262', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 103.592, '-27,45800', '-51,87900', 395, 'S', 0.7950, NULL, NULL, '42900', 'N', 'N', 145, NULL, '4290', '4290', NULL, '1997', 'S', 4383, 'ALTO BELA VISTA', 'N', '420075', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '10', NULL, '03', 'N', NULL, NULL, NULL, 487);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420080', '4201', 'SC', '4201', '4201', '42001', '42', 'ANCHIETA', NULL, '49', '89970000', '4', '8015', '8015', '20008', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 228.580, '-26,53400', '-53,33100', 710, 'S', 0.7690, NULL, NULL, '42900', 'N', 'N', 221, NULL, '4290', '4290', NULL, '1963', 'S', 4384, 'ANCHIETA', 'N', '420080', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '11', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420090', '4207', 'SC', '4205', '4205', '42015', '42', 'ANGELINA', NULL, '48', '88460000', '3', '8017', '8017', '20009', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 499.947, '-27,56900', '-48,98500', 450, 'S', 0.7660, NULL, NULL, '42900', 'N', 'N', 234, NULL, '4202', '4201', NULL, '1961', 'S', 4385, 'ANGELINA', 'N', '420090', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '12', NULL, '03', 'N', NULL, NULL, NULL, 494);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420100', '4213', 'SC', '4209', '4203', '42010', '42', 'ANITA GARIBALDI', NULL, '49', '88590000', '0', '8019', '8019', '20010', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 588.612, '-27,68900', '-51,13000', 885, 'S', 0.7500, NULL, NULL, '42900', 'N', 'N', 247, NULL, '4214', '4290', NULL, '1961', 'S', 4386, 'ANITA GARIBALDI', 'N', '420100', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '13', NULL, '03', 'N', NULL, NULL, NULL, 501);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420110', '4207', 'SC', '4205', '4205', '42017', '42', 'ANITAPOLIS', NULL, '48', '88475000', '9', '8021', '8021', '20011', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 542.380, '-27,90200', '-49,12900', 430, 'S', 0.7730, NULL, NULL, '42900', 'N', 'N', 248, NULL, '4202', '4201', NULL, '1961', 'S', 4387, 'ANITÁPOLIS', 'N', '420110', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '14', NULL, '03', 'N', NULL, NULL, NULL, 494);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420120', '4207', 'SC', '4205', '4205', '42016', '42', 'ANTONIO CARLOS', NULL, '48', '88180000', '8', '8023', '8023', '20012', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 229.118, '-27,51700', '-48,76800', 30, 'S', 0.8270, NULL, NULL, '42900', 'N', 'N', 257, NULL, '4201', '4201', NULL, '1963', 'S', 4388, 'ANTÔNIO CARLOS', 'N', '420120', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '15', NULL, '03', 'N', NULL, NULL, NULL, 494);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420125', '4206', 'SC', '4203', '4204', '42012', '42', 'APIUNA', NULL, '47', '89135000', '7', '9941', '9941', '20201', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 493.529, '-27,03600', '-49,39000', 87, 'S', 0.7680, NULL, NULL, '42900', 'N', 'N', 277, NULL, '4204', '4202', NULL, '1989', 'S', 4389, 'APIÚNA', 'N', '420125', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '16', NULL, '03', 'N', NULL, NULL, NULL, 496);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420127', '4210', 'SC', '4202', '4201', '42005', '42', 'ARABUTA', NULL, '49', '89740000', '3', '5597', '5597', '20219', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 132.232, '-27,16000', '-52,14200', 408, 'S', 0.8120, NULL, NULL, '42900', 'N', 'N', 288, NULL, '4290', '4290', NULL, '1993', 'S', 4390, 'ARABUTÃ', 'N', '420127', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '17', NULL, '03', 'N', NULL, NULL, NULL, 487);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420130', '4211', 'SC', '4207', '4202', '42008', '42', 'ARAQUARI', NULL, '47', '89245000', '7', '8025', '8025', '20013', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 401.831, '-26,37000', '-48,72200', 9, 'S', 0.7670, NULL, NULL, '42900', 'N', 'N', 336, NULL, '4205', '4205', NULL, '1876', 'S', 4391, 'ARAQUARI', 'N', '420130', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '18', NULL, '03', 'N', NULL, NULL, NULL, 498);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420140', '4214', 'SC', '4206', '4206', '42020', '42', 'ARARANGUA', NULL, '48', '88900000', '6', '8027', '8027', '20014', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 303.799, '-28,93500', '-49,48600', 13, 'S', 0.8140, NULL, NULL, '42900', 'N', 'N', 338, NULL, '4210', '4203', NULL, '1880', 'S', 4392, 'ARARANGUÁ', 'N', '420140', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '19', NULL, '02', 'N', NULL, NULL, NULL, 492);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420150', '4216', 'SC', '4206', '4206', '42018', '42', 'ARMAZEM', NULL, '48', '88740000', '5', '8029', '8029', '20015', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 173.484, '-28,26200', '-49,01800', 30, 'S', 0.7950, NULL, NULL, '42900', 'N', 'N', 382, NULL, '4212', '4290', NULL, '1958', 'S', 4393, 'ARMAZÉM', 'N', '420150', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '20', NULL, '03', 'N', NULL, NULL, NULL, 495);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420160', '4209', 'SC', '4202', '4201', '42004', '42', 'ARROIO TRINTA', NULL, '49', '89590000', '4', '8031', '8031', '20016', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 94.333, '-26,93300', '-51,33900', 840, 'S', 0.7980, NULL, NULL, '42900', 'N', 'N', 394, NULL, '4290', '4290', NULL, '1961', 'S', 4394, 'ARROIO TRINTA', 'N', '420160', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '21', NULL, '03', 'N', NULL, NULL, NULL, 489);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420165', '4210', 'SC', '4202', '4201', '42005', '42', 'ARVOREDO', NULL, '49', '89778000', '3', '5599', '5599', '20244', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 90.709, '-27,07400', '-52,45600', 362, 'S', 0.7510, NULL, NULL, '42900', 'N', 'N', 398, NULL, '4215', '4290', NULL, '1993', 'S', 4395, 'ARVOREDO', 'N', '420165', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '22', NULL, '03', 'N', NULL, NULL, NULL, 487);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420170', '4206', 'SC', '4203', '4204', '42012', '42', 'ASCURRA', NULL, '47', '89138000', '3', '8033', '8033', '20017', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 111.672, '-26,95500', '-49,37600', 88, 'S', 0.8130, NULL, NULL, '42900', 'N', 'N', 400, NULL, '4204', '4202', NULL, '1963', 'S', 4396, 'ASCURRA', 'N', '420170', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '23', NULL, '03', 'N', NULL, NULL, NULL, 496);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420180', '4204', 'SC', '4203', '4204', '42014', '42', 'ATALANTA', NULL, '47', '88410000', '2', '8035', '8035', '20018', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 94.527, '-27,42000', '-49,78100', 545, 'S', 0.8100, NULL, NULL, '42900', 'N', 'N', 415, NULL, '4218', '4290', NULL, '1964', 'S', 4397, 'ATALANTA', 'N', '420180', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '24', NULL, '03', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420190', '4204', 'SC', '4203', '4204', '42011', '42', 'AURORA', NULL, '47', '89186000', '1', '8037', '8037', '20019', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 206.947, '-27,31500', '-49,63800', 350, 'S', 0.8120, NULL, NULL, '42900', 'N', 'N', 427, NULL, '4218', '4290', NULL, '1964', 'S', 4398, 'AURORA', 'N', '420190', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '25', NULL, '03', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420195', '4214', 'SC', '4206', '4206', '42020', '42', 'BALNEARIO ARROIO DO SILVA', NULL, '48', '88914000', '0', '0888', '0002', '20263', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 93.819, '-28,98400', '-49,41300', 10, 'S', 0.7940, NULL, NULL, '42900', 'N', 'N', 460, NULL, '4210', '4290', NULL, '1997', 'S', 4399, 'BALNEÁRIO ARROIO DO SILVA', 'N', '420195', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '26', NULL, '03', 'N', NULL, NULL, NULL, 492);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420200', '4205', 'SC', '4204', '4204', '42013', '42', 'BALNEARIO CAMBORIU', NULL, '47', '88330000', '8', '8039', '8039', '20020', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 46.489, '-26,99100', '-48,63500', 18, 'S', 0.8670, NULL, NULL, '42900', 'N', 'N', 462, NULL, '4207', '4204', NULL, '1964', 'S', 4401, 'BALNEÁRIO CAMBORIÚ', 'N', '420200', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '28', NULL, '01', 'N', NULL, NULL, NULL, 493);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420205', '4211', 'SC', '4207', '4202', '42008', '42', 'BALNEARIO BARRA DO SUL', NULL, '47', '89247000', '7', '5549', '5549', '20245', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 110.428, '-26,45600', '-48,61200', 8, 'S', 0.8070, NULL, NULL, '42900', 'N', 'N', 461, NULL, '4206', '4205', NULL, '1993', 'S', 4400, 'BALNEÁRIO BARRA DO SUL', 'N', '420205', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '27', NULL, '03', 'N', NULL, NULL, NULL, 498);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420207', '4214', 'SC', '4206', '4206', '42020', '42', 'BALNEARIO GAIVOTA', NULL, '48', '88955000', '3', '0890', NULL, '20264', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 147.710, '-29,15700', '-49,57900', 7, 'S', 0.7860, NULL, NULL, '42900', 'N', 'N', 463, NULL, '4210', '4290', NULL, '1997', 'S', 4402, 'BALNEÁRIO GAIVOTA', 'N', '420207', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '29', NULL, '03', 'N', NULL, NULL, NULL, 492);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420208', '4201', 'SC', '4201', '4201', '42001', '42', 'BANDEIRANTE', NULL, '49', '89905000', '1', '0892', NULL, '20265', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 146.255, '-26,76900', '-53,63800', 517, 'S', 0.7650, NULL, NULL, '42900', 'N', 'N', 474, NULL, '4290', '4290', NULL, '1997', 'S', 4403, 'BANDEIRANTE', 'N', '420208', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '31', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420209', '4201', 'SC', '4201', '4201', '42001', '42', 'BARRA BONITA', NULL, '49', '89909000', '9', '0894', NULL, '20266', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 93.469, '-26,65400', '-53,44000', 335, 'S', 0.7430, NULL, NULL, '42900', 'N', 'N', 499, NULL, '4290', '4290', NULL, '1997', 'S', 4404, 'BARRA BONITA', 'N', '420209', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '32', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420210', '4211', 'SC', '4207', '4204', '42013', '42', 'BARRA VELHA', NULL, '47', '88390000', '7', '8041', '8041', '20021', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 140.160, '-26,63200', '-48,68500', 35, 'S', 0.7920, NULL, NULL, '42900', 'N', 'N', 529, NULL, '4206', '4205', NULL, '1961', 'S', 4405, 'BARRA VELHA', 'N', '420210', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '33', NULL, '03', 'N', NULL, NULL, NULL, 498);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420213', '4212', 'SC', '4208', '4202', '42006', '42', 'BELA VISTA DO TOLDO', NULL, '47', '89478000', '1', '0896', NULL, '20267', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 534.618, '-26,27300', '-50,46400', 752, 'S', 0.7020, NULL, NULL, '42900', 'N', 'N', 569, NULL, '4206', '4290', NULL, '1997', 'S', 4406, 'BELA VISTA DO TOLDO', 'N', '420213', 'N', 'N', 'S', NULL, 70, 'N', 'N', 'N', '34', NULL, '03', 'N', NULL, NULL, NULL, 500);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420215', '4201', 'SC', '4201', '4201', '42001', '42', 'BELMONTE', NULL, '49', '89925000', '6', '5745', '5745', '20246', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 93.604, '-26,84100', '-53,57600', 612, 'S', 0.7590, NULL, NULL, '42900', 'N', 'N', 580, NULL, '4290', '4290', NULL, '1993', 'S', 4407, 'BELMONTE', 'N', '420215', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '35', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420220', '4206', 'SC', '4203', '4204', '42012', '42', 'BENEDITO NOVO', NULL, '47', '89124000', '6', '8043', '8043', '20022', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 385.402, '-26,78300', '-49,36400', 130, 'S', 0.8020, NULL, NULL, '42900', 'N', 'N', 591, NULL, '4204', '4202', NULL, '1961', 'S', 4408, 'BENEDITO NOVO', 'N', '420220', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '36', NULL, '03', 'N', NULL, NULL, NULL, 496);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420240', '4206', 'SC', '4203', '4204', '42012', '42', 'BLUMENAU', NULL, '47', '89010970', '4', '8047', '8047', '20024', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 519.837, '-26,91900', '-49,06600', 21, 'S', 0.8550, NULL, NULL, '42900', 'N', 'N', 622, NULL, '4203', '4202', NULL, '1880', 'S', 4410, 'BLUMENAU', 'N', '420240', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '38', NULL, '01', 'N', NULL, NULL, NULL, 496);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420243', '4213', 'SC', '4209', '4203', '42010', '42', 'BOCAINA DO SUL', NULL, '49', '88538000', '8', '0898', NULL, '20268', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 496.250, '-27,74400', '-49,94400', 860, 'S', 0.7160, NULL, NULL, '42900', 'N', 'N', 648, NULL, '4214', '4290', NULL, '1997', 'S', 4411, 'BOCAINA DO SUL', 'N', '420243', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '39', NULL, '03', 'N', NULL, NULL, NULL, 501);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420245', '4205', 'SC', '4204', '4204', '42013', '42', 'BOMBINHAS', NULL, '47', '88215000', '3', '5537', '5537', '20247', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 34.489, '-27,13800', '-48,51700', 32, 'S', 0.8090, NULL, NULL, '42900', 'N', 'N', 695, NULL, '4208', '4290', NULL, '1993', 'S', 4416, 'BOMBINHAS', 'N', '420245', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '44', NULL, '03', 'N', NULL, NULL, NULL, 493);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420250', '4213', 'SC', '4209', '4203', '42010', '42', 'BOM JARDIM DA SERRA', NULL, '49', '88640000', '3', '8389', '8389', '20195', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 935.177, '-28,33700', '-49,62500', 1245, 'S', 0.7580, NULL, NULL, '42900', 'N', 'N', 661, NULL, '4214', '4290', NULL, '1967', 'S', 4412, 'BOM JARDIM DA SERRA', 'N', '420250', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '40', NULL, '03', 'N', NULL, NULL, NULL, 501);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420253', '4203', 'SC', '4201', '4201', '42003', '42', 'BOM JESUS', NULL, '49', '89824000', '7', '0900', NULL, '20269', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 63.552, '-26,73400', '-52,39400', 669, 'S', 0.7340, NULL, NULL, '42900', 'N', 'N', 668, NULL, '4290', '4290', NULL, '1997', 'S', 4413, 'BOM JESUS', 'N', '420253', 'N', 'N', 'S', NULL, 33, 'N', 'N', 'N', '41', NULL, '03', 'N', NULL, NULL, NULL, 502);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420257', '4201', 'SC', '4201', '4201', '42002', '42', 'BOM JESUS DO OESTE', NULL, '49', '89873000', '8', '0902', NULL, '20270', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 67.899, '-26,69000', '-53,09800', 618, 'S', 0.7850, NULL, NULL, '42900', 'N', 'N', 678, NULL, '4290', '4290', NULL, '1997', 'S', 4414, 'BOM JESUS DO OESTE', 'N', '420257', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '42', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420260', '4213', 'SC', '4209', '4203', '42010', '42', 'BOM RETIRO', NULL, '49', '88680000', '2', '8049', '8049', '20025', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1055.501, '-27,79700', '-49,48900', 890, 'S', 0.7320, NULL, NULL, '42900', 'N', 'N', 688, NULL, '4214', '4290', NULL, '1922', 'S', 4415, 'BOM RETIRO', 'N', '420260', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '43', NULL, '03', 'N', NULL, NULL, NULL, 501);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420270', '4206', 'SC', '4203', '4204', '42012', '42', 'BOTUVERA', NULL, '47', '88370000', '1', '8051', '8051', '20026', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 303.023, '-27,19900', '-49,07500', 85, 'S', 0.7950, NULL, NULL, '42900', 'N', 'N', 727, NULL, '4204', '4202', NULL, '1962', 'S', 4417, 'BOTUVERÁ', 'N', '420270', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '45', NULL, '03', 'N', NULL, NULL, NULL, 496);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420280', '4216', 'SC', '4206', '4206', '42018', '42', 'BRACO DO NORTE', NULL, '48', '88750000', '0', '8053', '8053', '20027', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 221.311, '-28,27500', '-49,16600', 75, 'S', 0.8460, NULL, NULL, '42900', 'N', 'N', 728, NULL, '4212', '4290', NULL, '1955', 'S', 4418, 'BRAÇO DO NORTE', 'N', '420280', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '46', NULL, '03', 'N', NULL, NULL, NULL, 495);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420285', '4204', 'SC', '4203', '4204', '42011', '42', 'BRACO DO TROMBUDO', NULL, '47', '89178000', '9', '5557', '5557', '20248', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 89.681, '-27,35800', '-49,88600', 430, 'S', 0.7990, NULL, NULL, '42900', 'N', 'N', 729, NULL, '4218', '4290', NULL, '1993', 'S', 4419, 'BRAÇO DO TROMBUDO', 'N', '420285', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '47', NULL, '03', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420287', '4208', 'SC', '4202', '4203', '42009', '42', 'BRUNOPOLIS', NULL, '49', '89634000', '5', '0904', NULL, '20271', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 335.513, '-27,30600', '-50,86800', 843, 'S', 0.7420, NULL, NULL, '42900', 'N', 'N', 776, NULL, '4290', '4290', NULL, '1997', 'S', 4420, 'BRUNÓPOLIS', 'N', '420287', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '48', NULL, '03', 'N', NULL, NULL, NULL, 497);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420290', '4206', 'SC', '4203', '4204', '42012', '42', 'BRUSQUE', NULL, '47', '88350000', '9', '8055', '8055', '20028', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 283.445, '-27,09800', '-48,91800', 36, 'S', 0.8420, NULL, NULL, '42900', 'N', 'N', 777, NULL, '4204', '4202', NULL, '1881', 'S', 4421, 'BRUSQUE', 'N', '420290', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '49', NULL, '01', 'N', NULL, NULL, NULL, 496);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420300', '4209', 'SC', '4202', '4201', '42004', '42', 'CACADOR', NULL, '49', '89500000', '6', '8057', '8057', '20029', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 981.901, '-26,77500', '-51,01500', 920, 'S', 0.7930, NULL, NULL, '42900', 'N', 'N', 821, NULL, '4290', '4290', NULL, '1934', 'S', 4422, 'CAÇADOR', 'N', '420300', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '50', NULL, '02', 'N', NULL, NULL, NULL, 489);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420310', '4202', 'SC', '4201', '4201', '42002', '42', 'CAIBI', NULL, '49', '89888000', '5', '8059', '8059', '20030', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 171.711, '-27,07200', '-53,24800', 337, 'S', 0.8210, NULL, NULL, '42900', 'N', 'N', 870, NULL, '4290', '4290', NULL, '1965', 'S', 4423, 'CAIBI', 'N', '420310', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '51', NULL, '03', 'N', NULL, NULL, NULL, 499);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420315', '4209', 'SC', '4202', '4201', '42004', '42', 'CALMON', NULL, '49', '89430000', '4', '5553', '5553', '20249', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 639.528, '-26,60000', '-51,09700', 1200, 'S', 0.7000, NULL, NULL, '42900', 'S', 'N', 900, NULL, '4290', '4290', NULL, '1993', 'S', 4424, 'CALMON', 'N', '420315', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '52', NULL, '03', 'N', NULL, NULL, NULL, 489);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420320', '4205', 'SC', '4204', '4204', '42013', '42', 'CAMBORIU', NULL, '47', '88340000', '4', '8061', '8061', '20031', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 214.500, '-27,02500', '-48,65400', 8, 'S', 0.7640, NULL, NULL, '42900', 'N', 'N', 916, NULL, '4207', '4204', NULL, '1884', 'S', 4425, 'CAMBORIÚ', 'N', '420320', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '53', NULL, '02', 'N', NULL, NULL, NULL, 493);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420325', '4213', 'SC', '4209', '4203', '42010', '42', 'CAPAO ALTO', NULL, '49', '88548000', '3', '0906', NULL, '20272', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1335.280, '-27,93700', '-50,51200', 1022, 'S', 0.7250, NULL, NULL, '42900', 'N', 'N', 1036, NULL, '4214', '4290', NULL, '1997', 'S', 4432, 'CAPÃO ALTO', 'N', '420325', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '60', NULL, '03', 'N', NULL, NULL, NULL, 501);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420330', '4212', 'SC', '4208', '4202', '42007', '42', 'CAMPO ALEGRE', NULL, '47', '89294000', '3', '8063', '8063', '20032', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 496.146, '-26,19300', '-49,26600', 870, 'S', 0.7720, NULL, NULL, '42900', 'N', 'N', 943, NULL, '4206', '4205', NULL, '1896', 'S', 4426, 'CAMPO ALEGRE', 'N', '420330', 'N', 'N', 'S', NULL, 70, 'N', 'N', 'N', '54', NULL, '03', 'N', NULL, NULL, NULL, 500);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420340', '4213', 'SC', '4209', '4203', '42010', '42', 'CAMPO BELO DO SUL', NULL, '49', '88580000', '2', '8065', '8065', '20033', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1027.407, '-27,89900', '-50,76100', 1017, 'S', 0.6940, NULL, NULL, '42900', 'S', 'N', 950, NULL, '4214', '4290', NULL, '1961', 'S', 4427, 'CAMPO BELO DO SUL', 'N', '420340', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '55', NULL, '03', 'N', NULL, NULL, NULL, 501);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420350', '4203', 'SC', '4201', '4201', '42002', '42', 'CAMPO ERE', NULL, '49', '89980000', '1', '8067', '8067', '20034', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 478.734, '-26,39400', '-53,07800', 910, 'S', 0.7280, NULL, NULL, '42900', 'N', 'N', 956, NULL, '4290', '4290', NULL, '1958', 'S', 4428, 'CAMPO ERÊ', 'N', '420350', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '56', NULL, '03', 'N', NULL, NULL, NULL, 502);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420360', '4208', 'SC', '4202', '4203', '42009', '42', 'CAMPOS NOVOS', NULL, '49', '89620000', '0', '8069', '8069', '20035', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1659.625, '-27,40200', '-51,22500', 934, 'S', 0.7940, NULL, NULL, '42900', 'N', 'N', 982, NULL, '4290', '4290', NULL, '1881', 'S', 4429, 'CAMPOS NOVOS', 'N', '420360', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '57', NULL, '03', 'N', NULL, NULL, NULL, 497);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420370', '4207', 'SC', '4205', '4205', '42015', '42', 'CANELINHA', NULL, '48', '88230000', '9', '8071', '8071', '20036', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 151.409, '-27,26500', '-48,76800', 17, 'S', 0.7950, NULL, NULL, '42900', 'N', 'N', 1015, NULL, '4202', '4201', NULL, '1962', 'S', 4430, 'CANELINHA', 'N', '420370', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '58', NULL, '03', 'N', NULL, NULL, NULL, 494);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420380', '4212', 'SC', '4208', '4202', '42006', '42', 'CANOINHAS', NULL, '47', '89460000', '8', '8073', '8073', '20037', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1144.837, '-26,17700', '-50,39000', 839, 'S', 0.7800, NULL, NULL, '42900', 'N', 'N', 1024, NULL, '4206', '4290', NULL, '1911', 'S', 4431, 'CANOINHAS', 'N', '420380', 'N', 'N', 'S', NULL, 70, 'N', 'N', 'N', '59', NULL, '02', 'N', NULL, NULL, NULL, 500);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420390', '4208', 'SC', '4202', '4201', '42004', '42', 'CAPINZAL', NULL, '49', '89665000', '7', '8075', '8075', '20038', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 333.980, '-27,34400', '-51,61200', 480, 'S', 0.8130, NULL, NULL, '42900', 'N', 'N', 1053, NULL, '4290', '4290', NULL, '1948', 'S', 4433, 'CAPINZAL', 'N', '420390', 'N', 'N', 'S', NULL, 33, 'N', 'N', 'N', '61', NULL, '03', 'N', NULL, NULL, NULL, 497);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420395', '4216', 'SC', '4206', '4206', '42018', '42', 'CAPIVARI DE BAIXO', NULL, '48', '88745000', '6', '5545', '5545', '20250', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 53.165, '-28,44500', '-48,95800', 100, 'S', 0.8120, NULL, NULL, '42900', 'N', 'N', 1065, NULL, '4211', '4290', NULL, '1993', 'S', 4434, 'CAPIVARI DE BAIXO', 'N', '420395', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '62', NULL, '03', 'N', NULL, NULL, NULL, 495);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420400', '4208', 'SC', '4202', '4201', '42004', '42', 'CATANDUVAS', NULL, '49', '89670000', '4', '8077', '8077', '20039', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 198.033, '-27,07100', '-51,66200', 945, 'S', 0.7900, NULL, NULL, '42900', 'N', 'N', 1168, NULL, '4290', '4290', NULL, '1963', 'S', 4435, 'CATANDUVAS', 'N', '420400', 'N', 'N', 'S', NULL, 33, 'N', 'N', 'N', '63', NULL, '03', 'N', NULL, NULL, NULL, 497);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420410', '4202', 'SC', '4201', '4201', '42002', '42', 'CAXAMBU DO SUL', NULL, '49', '89880000', '3', '8079', '8079', '20040', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 140.578, '-27,16100', '-52,87900', 318, 'S', 0.7380, NULL, NULL, '42900', 'N', 'N', 1188, NULL, '4216', '4290', NULL, '1962', 'S', 4436, 'CAXAMBU DO SUL', 'N', '420410', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '64', NULL, '03', 'N', NULL, NULL, NULL, 499);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420415', '4208', 'SC', '4202', '4203', '42010', '42', 'CELSO RAMOS', NULL, '49', '88598000', '2', '9943', '9943', '20202', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 207.409, '-27,63400', '-51,33600', 778, 'S', 0.7620, NULL, NULL, '42900', 'N', 'N', 1199, NULL, '4290', '4290', NULL, '1990', 'S', 4437, 'CELSO RAMOS', 'N', '420415', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '65', NULL, '03', 'N', NULL, NULL, NULL, 497);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420417', '4213', 'SC', '4209', '4203', '42010', '42', 'CERRO NEGRO', NULL, '49', '88585000', '8', '5567', '5567', '20220', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 416.774, '-27,79500', '-50,87600', 996, 'S', 0.6860, NULL, NULL, '42900', 'S', 'N', 1220, NULL, '4214', '4290', NULL, '1993', 'S', 4438, 'CERRO NEGRO', 'N', '420417', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '66', NULL, '03', 'N', NULL, NULL, NULL, 501);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420419', '4204', 'SC', '4203', '4204', '42014', '42', 'CHAPADAO DO LAGEADO', NULL, '47', '88407000', '4', '0908', NULL, '20273', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 124.472, '-27,59100', '-49,55400', 600, 'S', 0.7740, NULL, NULL, '42900', 'N', 'N', 1236, NULL, '4218', '4290', NULL, '1997', 'S', 4439, 'CHAPADÃO DO LAGEADO', 'N', '420419', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '67', NULL, '03', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420420', '4202', 'SC', '4201', '4201', '42002', '42', 'CHAPECO', NULL, '49', '89801970', '2', '8081', '8081', '20041', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 624.308, '-27,09600', '-52,61800', 674, 'S', 0.8480, NULL, NULL, '42900', 'N', 'N', 1239, NULL, '4215', '4290', NULL, '1917', 'S', 4440, 'CHAPECÓ', 'N', '420420', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '68', NULL, '01', 'N', NULL, NULL, NULL, 499);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420425', '4215', 'SC', '4206', '4206', '42019', '42', 'COCAL DO SUL', NULL, '48', '88845000', '1', '5543', '5543', '20221', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 71.210, '-28,60100', '-49,32600', 58, 'S', 0.8230, NULL, NULL, '42900', 'N', 'N', 1274, NULL, '4209', '4203', NULL, '1993', 'S', 4441, 'COCAL DO SUL', 'N', '420425', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '69', NULL, '03', 'N', NULL, NULL, NULL, 490);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420430', '4210', 'SC', '4202', '4201', '42005', '42', 'CONCORDIA', NULL, '49', '89700000', '1', '8083', '8083', '20042', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 797.260, '-27,23400', '-52,02800', 569, 'S', 0.8490, NULL, NULL, '42900', 'N', 'N', 1331, NULL, '4290', '4290', NULL, '1934', 'S', 4442, 'CONCÓRDIA', 'N', '420430', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '70', NULL, '02', 'N', NULL, NULL, NULL, 487);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420435', '4202', 'SC', '4201', '4201', '42002', '42', 'CORDILHEIRA ALTA', NULL, '49', '89819000', '0', '5579', '5579', '20251', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 83.768, '-26,98400', '-52,60700', 768, 'S', 0.8260, NULL, NULL, '42900', 'N', 'N', 1365, NULL, '4290', '4290', NULL, '1993', 'S', 4443, 'CORDILHEIRA ALTA', 'N', '420435', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '71', NULL, '03', 'N', NULL, NULL, NULL, 499);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420440', '4202', 'SC', '4201', '4201', '42002', '42', 'CORONEL FREITAS', NULL, '49', '89840000', '0', '8085', '8085', '20043', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 234.157, '-26,90900', '-52,70300', 375, 'S', 0.8110, NULL, NULL, '42900', 'N', 'N', 1383, NULL, '4215', '4290', NULL, '1961', 'S', 4444, 'CORONEL FREITAS', 'N', '420440', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '72', NULL, '03', 'N', NULL, NULL, NULL, 499);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420445', '4203', 'SC', '4201', '4201', '42003', '42', 'CORONEL MARTINS', NULL, '49', '89837000', '9', '5735', '5735', '20252', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 107.408, '-26,51200', '-52,66900', 695, 'S', 0.7470, NULL, NULL, '42900', 'N', 'N', 1388, NULL, '4290', '4290', NULL, '1993', 'S', 4445, 'CORONEL MARTINS', 'N', '420445', 'N', 'N', 'S', NULL, 33, 'S', 'N', 'N', '73', NULL, '03', 'N', NULL, NULL, NULL, 502);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420450', '4211', 'SC', '4207', '4202', '42008', '42', 'CORUPA', NULL, '47', '89278000', '9', '8087', '8087', '20044', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 405.003, '-26,42500', '-49,24300', 75, 'S', 0.8180, NULL, NULL, '42900', 'N', 'N', 1410, NULL, '4206', '4205', NULL, '1958', 'S', 4447, 'CORUPÁ', 'N', '420450', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '75', NULL, '03', 'N', NULL, NULL, NULL, 498);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420455', '4213', 'SC', '4209', '4203', '42010', '42', 'CORREIA PINTO', NULL, '49', '88535000', '8', '8395', '8395', '20198', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 651.614, '-27,58500', '-50,36100', 847, 'S', 0.7720, NULL, NULL, '42900', 'N', 'N', 1399, NULL, '4213', '4290', NULL, '1982', 'S', 4446, 'CORREIA PINTO', 'N', '420455', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '74', NULL, '03', 'N', NULL, NULL, NULL, 501);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420460', '4215', 'SC', '4206', '4206', '42019', '42', 'CRICIUMA', NULL, '48', '88800000', '8', '8089', '8089', '20045', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 235.628, '-28,67800', '-49,37000', 46, 'S', 0.8220, NULL, NULL, '42900', 'N', 'N', 1430, NULL, '4209', '4203', NULL, '1925', 'S', 4448, 'CRICIÚMA', 'N', '420460', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '76', NULL, '01', 'N', NULL, NULL, NULL, 490);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420470', '4202', 'SC', '4201', '4201', '42002', '42', 'CUNHA PORA', NULL, '49', '89890000', '7', '8091', '8091', '20046', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 220.293, '-26,89400', '-53,16800', 570, 'S', 0.8240, NULL, NULL, '42900', 'N', 'N', 1481, NULL, '4290', '4290', NULL, '1958', 'S', 4449, 'CUNHA PORÃ', 'N', '420470', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '77', NULL, '03', 'N', NULL, NULL, NULL, 499);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420475', '4202', 'SC', '4201', '4201', '42002', '42', 'CUNHATAI', NULL, '49', '89886000', '6', '0910', NULL, '20274', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 54.511, '-26,96900', '-53,09300', 400, 'S', 0.8310, NULL, NULL, '42900', 'N', 'N', 1482, NULL, '4216', '4290', NULL, '1997', 'S', 4450, 'CUNHATAÍ', 'N', '420475', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '78', NULL, '03', 'N', NULL, NULL, NULL, 499);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420480', '4209', 'SC', '4202', '4203', '42009', '42', 'CURITIBANOS', NULL, '49', '89520000', '6', '8093', '8093', '20047', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 952.283, '-27,28300', '-50,58400', 987, 'S', 0.7690, NULL, NULL, '42900', 'N', 'N', 1489, NULL, '4214', '4290', NULL, '1869', 'S', 4451, 'CURITIBANOS', 'N', '420480', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '79', NULL, '03', 'N', NULL, NULL, NULL, 489);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420490', '4201', 'SC', '4201', '4201', '42001', '42', 'DESCANSO', NULL, '49', '89910000', '5', '8095', '8095', '20048', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 285.571, '-26,82600', '-53,50200', 552, 'S', 0.7960, NULL, NULL, '42900', 'N', 'N', 1524, NULL, '4290', '4290', NULL, '1956', 'S', 4452, 'DESCANSO', 'N', '420490', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '80', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420500', '4201', 'SC', '4201', '4201', '42001', '42', 'DIONISIO CERQUEIRA', NULL, '49', '89950000', '1', '8097', '8097', '20049', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 377.704, '-26,25500', '-53,64000', 830, 'S', 0.7470, NULL, NULL, '42900', 'N', 'N', 1542, NULL, '4290', '4290', NULL, '1953', 'S', 4453, 'DIONÍSIO CERQUEIRA', 'N', '420500', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '81', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420510', '4204', 'SC', '4203', '4204', '42011', '42', 'DONA EMMA', NULL, '47', '89155000', '0', '8099', '8099', '20050', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 181.018, '-26,98500', '-49,72600', 370, 'S', 0.7940, NULL, NULL, '42900', 'N', 'N', 1586, NULL, '4218', '4290', NULL, '1962', 'S', 4454, 'DONA EMMA', 'N', '420510', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '82', NULL, '03', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420515', '4206', 'SC', '4203', '4204', '42012', '42', 'DOUTOR PEDRINHO', NULL, '47', '89126000', '9', '9945', '9945', '20203', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 375.758, '-26,71400', '-49,48300', 530, 'S', 0.8020, NULL, NULL, '42900', 'N', 'N', 1604, NULL, '4204', '4202', NULL, '1989', 'S', 4455, 'DOUTOR PEDRINHO', 'N', '420515', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '83', NULL, '03', 'N', NULL, NULL, NULL, 496);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420517', '4203', 'SC', '4201', '4201', '42003', '42', 'ENTRE RIOS', NULL, '49', '89862000', '5', '0912', NULL, '20275', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 105.167, '-26,72400', '-52,56100', 400, 'S', 0.6940, NULL, NULL, '42900', 'S', 'N', 1650, NULL, '4290', '4290', NULL, '1997', 'S', 4456, 'ENTRE RIOS', 'N', '420517', 'N', 'N', 'S', NULL, 33, 'S', 'N', 'N', '84', NULL, '03', 'N', NULL, NULL, NULL, 502);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420519', '4214', 'SC', '4206', '4206', '42020', '42', 'ERMO', NULL, '48', '88935000', '1', '0914', NULL, '20276', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 63.868, '-28,98300', '-49,64400', 16, 'S', 0.7690, NULL, NULL, '42900', 'N', 'N', 1663, NULL, '4210', '4290', NULL, '1997', 'S', 4457, 'ERMO', 'N', '420519', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '85', NULL, '03', 'N', NULL, NULL, NULL, 492);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420520', '4208', 'SC', '4202', '4201', '42004', '42', 'ERVAL VELHO', NULL, '49', '89613000', '9', '8101', '8101', '20051', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 207.686, '-27,27600', '-51,44200', 674, 'S', 0.7940, NULL, NULL, '42900', 'N', 'N', 1667, NULL, '4290', '4290', NULL, '1963', 'S', 4458, 'ERVAL VELHO', 'N', '420520', 'N', 'N', 'S', NULL, 33, 'N', 'N', 'N', '86', NULL, '03', 'N', NULL, NULL, NULL, 497);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420530', '4203', 'SC', '4201', '4201', '42003', '42', 'FAXINAL DOS GUEDES', NULL, '49', '89694000', '8', '8103', '8103', '20052', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 339.637, '-26,85300', '-52,26000', 1005, 'S', 0.8190, NULL, NULL, '42900', 'N', 'N', 1730, NULL, '4216', '4290', NULL, '1958', 'S', 4459, 'FAXINAL DOS GUEDES', 'N', '420530', 'N', 'N', 'S', NULL, 33, 'N', 'N', 'N', '87', NULL, '03', 'N', NULL, NULL, NULL, 502);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420535', '4201', 'SC', '4201', '4201', '42002', '42', 'FLOR DO SERTAO', NULL, '49', '89878000', '7', '0916', NULL, '20277', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 58.708, '-26,77800', '-53,34700', 302, 'S', 0.7240, NULL, NULL, '42900', 'N', 'N', 1772, NULL, '4290', '4290', NULL, '1997', 'S', 4460, 'FLOR DO SERTÃO', 'N', '420535', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '88', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420540', '4207', 'SC', '4205', '4205', '42016', '42', 'FLORIANOPOLIS', NULL, '48', '88010970', '7', '8105', '8105', '20053', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'S', 433.317, '-27,59700', '-48,54900', 3, 'S', 0.8750, NULL, NULL, '42900', 'N', 'N', 1790, NULL, '4201', '4201', NULL, '1726', 'S', 4461, 'FLORIANÓPOLIS', 'N', '420540', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '89', NULL, '01', 'N', NULL, NULL, NULL, 494);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420543', '4202', 'SC', '4201', '4201', '42002', '42', 'FORMOSA DO SUL', NULL, '49', '89859000', '1', '5581', '5581', '20222', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 99.576, '-26,64700', '-52,79400', 500, 'S', 0.7950, NULL, NULL, '42900', 'N', 'N', 1802, NULL, '4290', '4290', NULL, '1993', 'S', 4462, 'FORMOSA DO SUL', 'N', '420543', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '90', NULL, '03', 'N', NULL, NULL, NULL, 499);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420545', '4215', 'SC', '4206', '4206', '42019', '42', 'FORQUILHINHA', NULL, '48', '88850000', '6', '0973', '0973', '20215', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 181.915, '-28,74700', '-49,47200', 42, 'S', 0.7970, NULL, NULL, '42900', 'N', 'N', 1807, NULL, '4209', '4203', NULL, '1990', 'S', 4463, 'FORQUILHINHA', 'N', '420545', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '91', NULL, '03', 'N', NULL, NULL, NULL, 490);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420550', '4209', 'SC', '4202', '4201', '42004', '42', 'FRAIBURGO', NULL, '49', '89580000', '6', '8107', '8107', '20054', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 546.249, '-27,02600', '-50,92100', 1048, 'S', 0.7790, NULL, NULL, '42900', 'N', 'N', 1818, NULL, '4290', '4290', NULL, '1961', 'S', 4464, 'FRAIBURGO', 'N', '420550', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '92', NULL, '03', 'N', NULL, NULL, NULL, 489);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420555', '4209', 'SC', '4202', '4203', '42009', '42', 'FREI ROGERIO', NULL, '49', '89530000', '5', '0918', NULL, '20278', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 157.845, '-27,17500', '-50,80500', 950, 'S', 0.7400, NULL, NULL, '42900', 'N', 'N', 1841, NULL, '4214', '4290', NULL, '1997', 'S', 4465, 'FREI ROGÉRIO', 'N', '420555', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '93', NULL, '03', 'N', NULL, NULL, NULL, 489);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420560', '4203', 'SC', '4201', '4201', '42003', '42', 'GALVAO', NULL, '49', '89838000', '5', '8109', '8109', '20055', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 121.900, '-26,45500', '-52,68600', 655, 'S', 0.7770, NULL, NULL, '42900', 'N', 'N', 1855, NULL, '4290', '4290', NULL, '1962', 'S', 4466, 'GALVÃO', 'N', '420560', 'N', 'N', 'S', NULL, 33, 'S', 'N', 'N', '94', NULL, '03', 'N', NULL, NULL, NULL, 502);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420570', '4207', 'SC', '4205', '4206', '42018', '42', 'GAROPABA', NULL, '48', '88495000', '4', '8113', '8113', '20057', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 114.670, '-28,02300', '-48,61300', 18, 'S', 0.7850, NULL, NULL, '42900', 'N', 'N', 1863, NULL, '4202', '4201', NULL, '1961', 'S', 4467, 'GAROPABA', 'N', '420570', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '95', NULL, '03', 'N', NULL, NULL, NULL, 494);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420580', '4211', 'SC', '4207', '4202', '42008', '42', 'GARUVA', NULL, '47', '89248000', '3', '8115', '8115', '20058', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 501.390, '-26,02700', '-48,85500', 25, 'S', 0.7870, NULL, NULL, '42900', 'N', 'N', 1866, NULL, '4206', '4205', NULL, '1963', 'S', 4468, 'GARUVA', 'N', '420580', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '96', NULL, '03', 'N', NULL, NULL, NULL, 498);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420590', '4206', 'SC', '4203', '4204', '42012', '42', 'GASPAR', NULL, '47', '89110000', '2', '8117', '8117', '20059', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 386.354, '-26,93100', '-48,95900', 18, 'S', 0.8320, NULL, NULL, '42900', 'N', 'N', 1867, NULL, '4203', '4202', NULL, '1934', 'S', 4469, 'GASPAR', 'N', '420590', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '97', NULL, '02', 'N', NULL, NULL, NULL, 496);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420600', '4207', 'SC', '4205', '4205', '42016', '42', 'GOVERNADOR CELSO RAMOS', NULL, '48', '88190000', '9', '8111', '8111', '20056', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 93.061, '-27,31500', '-48,55900', 40, 'S', 0.7900, NULL, NULL, '42900', 'N', 'N', 1919, NULL, '4201', '4201', NULL, '1963', 'S', 4470, 'GOVERNADOR CELSO RAMOS', 'N', '420600', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '98', NULL, '03', 'N', NULL, NULL, NULL, 494);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420610', '4216', 'SC', '4206', '4206', '42018', '42', 'GRAO PARA', NULL, '48', '88890000', '8', '8119', '8119', '20060', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 328.097, '-28,18500', '-49,21500', 110, 'S', 0.8260, NULL, NULL, '42900', 'N', 'N', 1942, NULL, '4212', '4290', NULL, '1958', 'S', 4471, 'GRÃO PARÁ', 'N', '420610', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '99', NULL, '03', 'N', NULL, NULL, NULL, 495);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420620', '4216', 'SC', '4206', '4206', '42018', '42', 'GRAVATAL', NULL, '48', '88735000', '7', '8121', '8121', '20061', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 168.473, '-28,33100', '-49,03500', 30, 'S', 0.7980, NULL, NULL, '42900', 'N', 'N', 1945, NULL, '4211', '4290', NULL, '1961', 'S', 4472, 'GRAVATAL', 'N', '420620', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '100', NULL, '03', 'N', NULL, NULL, NULL, 495);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420630', '4206', 'SC', '4203', '4204', '42012', '42', 'GUABIRUBA', NULL, '47', '88360000', '6', '8123', '8123', '20062', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 173.591, '-27,08600', '-48,98100', 60, 'S', 0.8290, NULL, NULL, '42900', 'N', 'N', 1950, NULL, '4204', '4202', NULL, '1962', 'S', 4473, 'GUABIRUBA', 'N', '420630', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '101', NULL, '03', 'N', NULL, NULL, NULL, 496);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420640', '4201', 'SC', '4201', '4201', '42001', '42', 'GUARACIABA', NULL, '49', '89920000', '5', '8125', '8125', '20063', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 330.646, '-26,59900', '-53,51800', 670, 'S', 0.7850, NULL, NULL, '42900', 'N', 'N', 1981, NULL, '4290', '4290', NULL, '1961', 'S', 4474, 'GUARACIABA', 'N', '420640', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '102', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420650', '4211', 'SC', '4207', '4202', '42008', '42', 'GUARAMIRIM', NULL, '47', '89270000', '4', '8127', '8127', '20064', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 268.119, '-26,47300', '-49,00300', 30, 'S', 0.8220, NULL, NULL, '42900', 'N', 'N', 1987, NULL, '4206', '4205', NULL, '1948', 'S', 4475, 'GUARAMIRIM', 'N', '420650', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '103', NULL, '03', 'N', NULL, NULL, NULL, 498);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420660', '4201', 'SC', '4201', '4201', '42001', '42', 'GUARUJA DO SUL', NULL, '49', '89940000', '3', '8129', '8129', '20065', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 100.550, '-26,38500', '-53,52800', 707, 'S', 0.8030, NULL, NULL, '42900', 'N', 'N', 2011, NULL, '4290', '4290', NULL, '1961', 'S', 4476, 'GUARUJÁ DO SUL', 'N', '420660', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '104', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420665', '4202', 'SC', '4201', '4201', '42002', '42', 'GUATAMBU', NULL, '49', '89817000', '2', '5583', '5583', '20223', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 204.757, '-27,13200', '-52,78700', 530, 'S', 0.7370, NULL, NULL, '42900', 'N', 'N', 2013, NULL, '4215', '4290', NULL, '1993', 'S', 4477, 'GUATAMBÚ', 'N', '420665', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '105', NULL, '03', 'N', NULL, NULL, NULL, 499);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420670', '4208', 'SC', '4202', '4201', '42004', '42', 'HERVAL D''OESTE', NULL, '49', '89610000', '2', '8131', '8131', '20066', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 222.405, '-27,19400', '-51,49500', 523, 'S', 0.7980, NULL, NULL, '42900', 'N', 'N', 2034, NULL, '4290', '4290', NULL, '1953', 'S', 4478, 'HERVAL D OESTE', 'N', '420670', 'N', 'N', 'S', NULL, 33, 'N', 'N', 'N', '106', NULL, '03', 'N', NULL, NULL, NULL, 497);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420675', '4209', 'SC', '4202', '4201', '42004', '42', 'IBIAM', NULL, '49', '89652000', '1', '0920', NULL, '20279', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 147.329, '-27,18100', '-51,23700', 724, 'S', 0.8090, NULL, NULL, '42900', 'N', 'N', 2067, NULL, '4290', '4290', NULL, '1997', 'S', 4479, 'IBIAM', 'N', '420675', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '107', NULL, '03', 'N', NULL, NULL, NULL, 489);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420680', '4208', 'SC', '4202', '4201', '42004', '42', 'IBICARE', NULL, '49', '89640000', '1', '8133', '8133', '20067', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 150.512, '-27,09200', '-51,36500', 550, 'S', 0.8040, NULL, NULL, '42900', 'N', 'N', 2072, NULL, '4290', '4290', NULL, '1962', 'S', 4480, 'IBICARÉ', 'N', '420680', 'N', 'N', 'S', NULL, 33, 'N', 'N', 'N', '108', NULL, '03', 'N', NULL, NULL, NULL, 497);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420690', '4204', 'SC', '4203', '4204', '42011', '42', 'IBIRAMA', NULL, '47', '89140000', '0', '8135', '8135', '20068', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 246.705, '-27,05700', '-49,51800', 150, 'S', 0.8260, NULL, NULL, '42900', 'N', 'N', 2087, NULL, '4217', '4290', NULL, '1934', 'S', 4481, 'IBIRAMA', 'N', '420690', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '109', NULL, '03', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420700', '4215', 'SC', '4206', '4206', '42019', '42', 'ICARA', NULL, '48', '88820000', '7', '8137', '8137', '20069', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 292.779, '-28,71300', '-49,30000', 48, 'S', 0.7800, NULL, NULL, '42900', 'N', 'N', 2104, NULL, '4209', '4203', NULL, '1961', 'S', 4482, 'IÇARA', 'N', '420700', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '110', NULL, '02', 'N', NULL, NULL, NULL, 490);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420710', '4205', 'SC', '4204', '4204', '42013', '42', 'ILHOTA', NULL, '47', '88320000', '6', '8139', '8139', '20070', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 253.442, '-26,90000', '-48,82700', 15, 'S', 0.7950, NULL, NULL, '42900', 'N', 'N', 2147, NULL, '4204', '4202', NULL, '1958', 'S', 4483, 'ILHOTA', 'N', '420710', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '111', NULL, '03', 'N', NULL, NULL, NULL, 493);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420720', '4216', 'SC', '4206', '4206', '42018', '42', 'IMARUI', NULL, '48', '88770000', '5', '8141', '8141', '20071', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 542.236, '-28,34100', '-48,82000', 6, 'S', 0.7420, NULL, NULL, '42900', 'N', 'N', 2151, NULL, '4212', '4290', NULL, '1890', 'S', 4484, 'IMARUÍ', 'N', '420720', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '112', NULL, '03', 'N', NULL, NULL, NULL, 495);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420730', '4216', 'SC', '4206', '4206', '42018', '42', 'IMBITUBA', NULL, '48', '88780000', '4', '8143', '8143', '20072', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 184.787, '-28,24000', '-48,67000', 30, 'S', 0.8050, NULL, NULL, '42900', 'N', 'N', 2155, NULL, '4212', '4290', NULL, '1958', 'S', 4485, 'IMBITUBA', 'N', '420730', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '113', NULL, '03', 'N', NULL, NULL, NULL, 495);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420740', '4204', 'SC', '4203', '4204', '42014', '42', 'IMBUIA', NULL, '47', '88440000', '3', '8145', '8145', '20073', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 121.891, '-27,49300', '-49,42400', 718, 'S', 0.7770, NULL, NULL, '42900', 'N', 'N', 2157, NULL, '4218', '4290', NULL, '1962', 'S', 4486, 'IMBUIA', 'N', '420740', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '114', NULL, '03', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420750', '4206', 'SC', '4203', '4204', '42012', '42', 'INDAIAL', NULL, '47', '89130000', '2', '8147', '8147', '20074', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 430.534, '-26,89800', '-49,23200', 64, 'S', 0.8250, NULL, NULL, '42900', 'N', 'N', 2166, NULL, '4203', '4202', NULL, '1934', 'S', 4487, 'INDAIAL', 'N', '420750', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '115', NULL, '02', 'N', NULL, NULL, NULL, 496);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420757', '4209', 'SC', '4202', '4201', '42004', '42', 'IOMERE', NULL, '49', '89558000', '7', '0922', NULL, '20280', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 114.735, '-27,00400', '-51,24200', 847, 'S', 0.8490, NULL, NULL, '42900', 'N', 'N', 2191, NULL, '4290', '4290', NULL, '1997', 'S', 4488, 'IOMERÊ', 'N', '420757', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '116', NULL, '03', 'N', NULL, NULL, NULL, 489);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420760', '4210', 'SC', '4202', '4201', '42005', '42', 'IPIRA', NULL, '49', '89669000', '1', '8149', '8149', '20075', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 150.304, '-27,40400', '-51,77300', 409, 'S', 0.8040, NULL, NULL, '42900', 'N', 'N', 2207, NULL, '4290', '4290', NULL, '1963', 'S', 4489, 'IPIRA', 'N', '420760', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '117', NULL, '03', 'N', NULL, NULL, NULL, 487);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420765', '4201', 'SC', '4201', '4201', '42001', '42', 'IPORA DO OESTE', NULL, '49', '89899000', '0', '9951', '9951', '20204', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 202.369, '-26,98800', '-53,53500', 557, 'S', 0.7800, NULL, NULL, '42900', 'N', 'N', 2217, NULL, '4290', '4290', NULL, '1989', 'S', 4490, 'IPORÃ DO OESTE', 'N', '420765', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '118', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420768', '4203', 'SC', '4201', '4201', '42003', '42', 'IPUACU', NULL, '49', '89832000', '4', '5737', '5737', '20224', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 261.391, '-26,63100', '-52,45500', 720, 'S', 0.7160, NULL, NULL, '42900', 'N', 'N', 2221, NULL, '4290', '4290', NULL, '1993', 'S', 4491, 'IPUAÇU', 'N', '420768', 'N', 'N', 'S', NULL, 33, 'N', 'N', 'N', '119', NULL, '03', 'N', NULL, NULL, NULL, 502);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420770', '4210', 'SC', '4202', '4201', '42005', '42', 'IPUMIRIM', NULL, '49', '89790000', '0', '8151', '8151', '20076', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 247.067, '-27,07700', '-52,13600', 562, 'S', 0.7980, NULL, NULL, '42900', 'N', 'N', 2227, NULL, '4290', '4290', NULL, '1963', 'S', 4492, 'IPUMIRIM', 'N', '420770', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '120', NULL, '03', 'N', NULL, NULL, NULL, 487);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420780', '4210', 'SC', '4202', '4201', '42005', '42', 'IRANI', NULL, '49', '89680000', '9', '8153', '8153', '20077', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 321.559, '-27,02500', '-51,90200', 1047, 'S', 0.7980, NULL, NULL, '42900', 'N', 'N', 2239, NULL, '4290', '4290', NULL, '1963', 'S', 4494, 'IRANI', 'N', '420780', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '122', NULL, '03', 'N', NULL, NULL, NULL, 487);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420785', '4202', 'SC', '4201', '4201', '42002', '42', 'IRATI', NULL, '49', '89856000', '8', '5585', '5585', '20225', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 69.802, '-26,65600', '-52,89200', 438, 'S', 0.7730, NULL, NULL, '42900', 'N', 'N', 2245, NULL, '4290', '4290', NULL, '1993', 'S', 4495, 'IRATI', 'N', '420785', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '123', NULL, '03', 'N', NULL, NULL, NULL, 499);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420790', '4212', 'SC', '4208', '4202', '42006', '42', 'IRINEOPOLIS', NULL, '47', '89440000', '8', '8155', '8155', '20078', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 591.290, '-26,23900', '-50,80000', 762, 'S', 0.7670, NULL, NULL, '42900', 'N', 'N', 2249, NULL, '4206', '4290', NULL, '1962', 'S', 4496, 'IRINEÓPOLIS', 'N', '420790', 'N', 'N', 'S', NULL, 70, 'N', 'N', 'N', '124', NULL, '03', 'N', NULL, NULL, NULL, 500);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420800', '4210', 'SC', '4202', '4201', '42005', '42', 'ITA', NULL, '49', '89760000', '5', '8157', '8157', '20079', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 165.463, '-27,29100', '-52,32300', 385, 'S', 0.8050, NULL, NULL, '42900', 'N', 'N', 2254, NULL, '4216', '4290', NULL, '1956', 'S', 4497, 'ITÁ', 'N', '420800', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '125', NULL, '03', 'N', NULL, NULL, NULL, 487);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420810', '4212', 'SC', '4208', '4202', '42006', '42', 'ITAIOPOLIS', NULL, '47', '89340000', '4', '8159', '8159', '20080', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1295.319, '-26,33600', '-49,90600', 925, 'S', 0.7380, NULL, NULL, '42900', 'N', 'N', 2292, NULL, '4206', '4205', NULL, '1918', 'S', 4498, 'ITAIÓPOLIS', 'N', '420810', 'N', 'N', 'S', NULL, 70, 'N', 'N', 'N', '126', NULL, '03', 'N', NULL, NULL, NULL, 500);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420820', '4205', 'SC', '4204', '4204', '42013', '42', 'ITAJAI', NULL, '47', '88301970', '3', '8161', '8161', '20081', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 289.255, '-26,90800', '-48,66200', 1, 'S', 0.8250, NULL, NULL, '42900', 'N', 'N', 2300, NULL, '4207', '4204', NULL, '1859', 'S', 4499, 'ITAJAÍ', 'N', '420820', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '127', NULL, '01', 'N', NULL, NULL, NULL, 493);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420830', '4205', 'SC', '4204', '4204', '42013', '42', 'ITAPEMA', NULL, '47', '88220000', '2', '8163', '8163', '20082', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 59.022, '-27,09000', '-48,61100', 15, 'S', 0.8350, NULL, NULL, '42900', 'N', 'N', 2339, NULL, '4208', '4204', NULL, '1962', 'S', 4500, 'ITAPEMA', 'N', '420830', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '128', NULL, '03', 'N', NULL, NULL, NULL, 493);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420840', '4201', 'SC', '4201', '4201', '42001', '42', 'ITAPIRANGA', NULL, '49', '89896000', '1', '8165', '8165', '20083', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 280.116, '-27,16900', '-53,71200', 206, 'S', 0.8320, NULL, NULL, '42900', 'N', 'N', 2353, NULL, '4290', '4290', NULL, '1953', 'S', 4501, 'ITAPIRANGA', 'N', '420840', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '129', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420845', '4211', 'SC', '4207', '4202', '42008', '42', 'ITAPOA', NULL, '47', '89249000', '0', '9985', '9985', '20216', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 257.158, '-26,11700', '-48,61600', 18, 'S', 0.7930, NULL, NULL, '42900', 'N', 'N', 2360, NULL, '4206', '4205', NULL, '1990', 'S', 4502, 'ITAPOÁ', 'N', '420845', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '130', NULL, '03', 'N', NULL, NULL, NULL, 498);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420850', '4204', 'SC', '4203', '4204', '42014', '42', 'ITUPORANGA', NULL, '47', '88400000', '0', '8167', '8167', '20084', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 336.955, '-27,41400', '-49,60100', 360, 'S', 0.8250, NULL, NULL, '42900', 'N', 'N', 2419, NULL, '4217', '4290', NULL, '1948', 'S', 4503, 'ITUPORANGA', 'N', '420850', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '131', NULL, '03', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420860', '4208', 'SC', '4202', '4201', '42004', '42', 'JABORA', NULL, '49', '89677000', '9', '8169', '8169', '20085', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 191.117, '-27,17600', '-51,73400', 689, 'S', 0.7940, NULL, NULL, '42900', 'N', 'N', 2434, NULL, '4290', '4290', NULL, '1963', 'S', 4504, 'JABORÁ', 'N', '420860', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '132', NULL, '03', 'N', NULL, NULL, NULL, 497);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420870', '4214', 'SC', '4206', '4206', '42020', '42', 'JACINTO MACHADO', NULL, '48', '88950000', '8', '8171', '8171', '20086', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 428.650, '-28,99700', '-49,76400', 50, 'S', 0.7570, NULL, NULL, '42900', 'N', 'N', 2451, NULL, '4210', '4290', NULL, '1958', 'S', 4505, 'JACINTO MACHADO', 'N', '420870', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '133', NULL, '03', 'N', NULL, NULL, NULL, 492);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420880', '4216', 'SC', '4206', '4206', '42018', '42', 'JAGUARUNA', NULL, '48', '88715000', '7', '8173', '8173', '20087', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 329.459, '-28,61500', '-49,02600', 12, 'S', 0.7930, NULL, NULL, '42900', 'N', 'N', 2474, NULL, '4212', '4290', NULL, '1891', 'S', 4506, 'JAGUARUNA', 'N', '420880', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '134', NULL, '03', 'N', NULL, NULL, NULL, 495);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420890', '4211', 'SC', '4207', '4202', '42008', '42', 'JARAGUA DO SUL', NULL, '47', '89251970', '6', '8175', '8175', '20088', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 532.590, '-26,48600', '-49,06700', 29, 'S', 0.8500, NULL, NULL, '42900', 'N', 'N', 2504, NULL, '4206', '4205', NULL, '1934', 'S', 4507, 'JARAGUÁ DO SUL', 'N', '420890', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '135', NULL, '01', 'N', NULL, NULL, NULL, 498);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420895', '4202', 'SC', '4201', '4201', '42002', '42', 'JARDINOPOLIS', NULL, '49', '89848000', '5', '5587', '5587', '20253', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 68.097, '-26,72200', '-52,86000', 525, 'S', 0.7630, NULL, NULL, '42900', 'N', 'N', 2515, NULL, '4290', '4290', NULL, '1993', 'S', 4508, 'JARDINÓPOLIS', 'N', '420895', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '136', NULL, '03', 'N', NULL, NULL, NULL, 499);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420900', '4208', 'SC', '4202', '4201', '42004', '42', 'JOACABA', NULL, '49', '89600000', '3', '8177', '8177', '20089', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 232.354, '-27,17800', '-51,50500', 522, 'S', 0.8660, NULL, NULL, '42900', 'N', 'N', 2553, NULL, '4290', '4290', NULL, '1917', 'S', 4509, 'JOAÇABA', 'N', '420900', 'N', 'N', 'S', NULL, 33, 'N', 'N', 'N', '137', NULL, '03', 'N', NULL, NULL, NULL, 497);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420910', '4211', 'SC', '4207', '4202', '42008', '42', 'JOINVILLE', NULL, '47', '89201970', '2', '8179', '8179', '20090', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1130.878, '-26,30400', '-48,84600', 3, 'S', 0.8570, NULL, NULL, '42900', 'N', 'N', 2575, NULL, '4205', '4205', NULL, '1860', 'S', 4510, 'JOINVILLE', 'N', '420910', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '138', NULL, '01', 'N', NULL, NULL, NULL, 498);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420915', '4204', 'SC', '4203', '4204', '42011', '42', 'JOSE BOITEUX', NULL, '47', '89145000', '1', '9957', '9957', '20206', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 405.519, '-26,95800', '-49,62800', 240, 'S', 0.7710, NULL, NULL, '42900', 'N', 'N', 2578, NULL, '4218', '4290', NULL, '1990', 'S', 4511, 'JOSÉ BOITEUX', 'N', '420915', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '139', NULL, '03', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420917', '4203', 'SC', '4201', '4201', '42003', '42', 'JUPIA', NULL, '49', '89839000', '7', '0924', NULL, '20281', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 91.710, '-26,39800', '-52,72800', 855, 'S', 0.7520, NULL, NULL, '42900', 'N', 'N', 2613, NULL, '4290', '4290', NULL, '1997', 'S', 4512, 'JUPIÁ', 'N', '420917', 'N', 'N', 'S', NULL, 33, 'N', 'N', 'N', '140', NULL, '03', 'N', NULL, NULL, NULL, 502);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420920', '4208', 'SC', '4202', '4201', '42004', '42', 'LACERDOPOLIS', NULL, '49', '89660000', '1', '8181', '8181', '20091', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 68.453, '-27,26000', '-51,55600', 490, 'S', 0.8540, NULL, NULL, '42900', 'N', 'N', 2637, NULL, '4290', '4290', NULL, '1963', 'S', 4513, 'LACERDÓPOLIS', 'N', '420920', 'N', 'N', 'S', NULL, 33, 'N', 'N', 'N', '141', NULL, '03', 'N', NULL, NULL, NULL, 497);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420930', '4213', 'SC', '4209', '4203', '42010', '42', 'LAGES', NULL, '49', '88502970', '0', '8183', '8183', '20092', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2644.313, '-27,81600', '-50,32600', 884, 'S', 0.8130, NULL, NULL, '42900', 'N', 'N', 2643, NULL, '4213', '4290', NULL, '1765', 'S', 4514, 'LAGES', 'N', '420930', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '142', NULL, '01', 'N', NULL, NULL, NULL, 501);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420940', '4216', 'SC', '4206', '4206', '42018', '42', 'LAGUNA', NULL, '48', '88790000', '9', '8185', '8185', '20093', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 440.525, '-28,48300', '-48,78100', 2, 'S', 0.7930, NULL, NULL, '42900', 'N', 'N', 2683, NULL, '4212', '4290', NULL, '1714', 'S', 4515, 'LAGUNA', 'N', '420940', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '143', NULL, '02', 'N', NULL, NULL, NULL, 495);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420945', '4203', 'SC', '4201', '4201', '42003', '42', 'LAJEADO GRANDE', NULL, '49', '89828000', '8', '5739', '5739', '20226', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 65.928, '-26,85800', '-52,56700', 480, 'S', 0.8130, NULL, NULL, '42900', 'N', 'N', 2690, NULL, '4290', '4290', NULL, '1993', 'S', 4516, 'LAJEADO GRANDE', 'N', '420945', 'N', 'N', 'S', NULL, 33, 'N', 'N', 'N', '144', NULL, '03', 'N', NULL, NULL, NULL, 502);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420950', '4204', 'SC', '4203', '4204', '42011', '42', 'LAURENTINO', NULL, '47', '89170000', '8', '8187', '8187', '20094', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 79.506, '-27,21700', '-49,73300', 345, 'S', 0.8250, NULL, NULL, '42900', 'N', 'N', 2715, NULL, '4218', '4290', NULL, '1962', 'S', 4517, 'LAURENTINO', 'N', '420950', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '145', NULL, '03', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420960', '4215', 'SC', '4206', '4206', '42019', '42', 'LAURO MULLER', NULL, '48', '88880000', '7', '8189', '8189', '20095', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 270.508, '-28,39300', '-49,39700', 220, 'S', 0.8000, NULL, NULL, '42900', 'N', 'N', 2717, NULL, '4210', '4290', NULL, '1956', 'S', 4518, 'LAURO MULLER', 'N', '420960', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '146', NULL, '03', 'N', NULL, NULL, NULL, 490);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420970', '4209', 'SC', '4202', '4201', '42004', '42', 'LEBON REGIS', NULL, '49', '89515000', '6', '8191', '8191', '20096', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 940.656, '-26,92900', '-50,69500', 980, 'S', 0.7350, NULL, NULL, '42900', 'N', 'N', 2725, NULL, '4290', '4290', NULL, '1958', 'S', 4519, 'LEBON RÉGIS', 'N', '420970', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '147', NULL, '03', 'N', NULL, NULL, NULL, 489);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420980', '4207', 'SC', '4205', '4205', '42015', '42', 'LEOBERTO LEAL', NULL, '48', '88445000', '5', '8193', '8193', '20097', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 291.191, '-27,50700', '-49,28700', 550, 'S', 0.7480, NULL, NULL, '42900', 'N', 'N', 2730, NULL, '4202', '4201', NULL, '1962', 'S', 4520, 'LEOBERTO LEAL', 'N', '420980', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '148', NULL, '03', 'N', NULL, NULL, NULL, 494);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420985', '4210', 'SC', '4202', '4201', '42005', '42', 'LINDOIA DO SUL', NULL, '49', '89735000', '4', '9961', '9961', '20207', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 195.056, '-27,05300', '-52,06700', 643, 'S', 0.8190, NULL, NULL, '42900', 'N', 'N', 2748, NULL, '4290', '4290', NULL, '1990', 'S', 4521, 'LINDÓIA DO SUL', 'N', '420985', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '149', NULL, '03', 'N', NULL, NULL, NULL, 487);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('420990', '4204', 'SC', '4203', '4204', '42011', '42', 'LONTRAS', NULL, '47', '89182000', '4', '8195', '8195', '20098', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 198.397, '-27,16600', '-49,54200', 330, 'S', 0.7770, NULL, NULL, '42900', 'N', 'N', 2761, NULL, '4218', '4290', NULL, '1961', 'S', 4522, 'LONTRAS', 'N', '420990', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '150', NULL, '03', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421000', '4205', 'SC', '4204', '4204', '42012', '42', 'LUIZ ALVES', NULL, '47', '89115000', '1', '8197', '8197', '20099', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 260.079, '-26,72100', '-48,93300', 70, 'S', 0.8400, NULL, NULL, '42900', 'N', 'N', 2778, NULL, '4204', '4202', NULL, '1958', 'S', 4523, 'LUIZ ALVES', 'N', '421000', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '151', NULL, '03', 'N', NULL, NULL, NULL, 493);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421003', '4208', 'SC', '4202', '4201', '42004', '42', 'LUZERNA', NULL, '49', '89609000', '5', '0926', NULL, '20282', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 116.832, '-27,13300', '-51,46700', 511, 'S', 0.8550, NULL, NULL, '42900', 'N', 'N', 2787, NULL, '4290', '4290', NULL, '1997', 'S', 4524, 'LUZERNA', 'N', '421003', 'N', 'N', 'S', NULL, 33, 'N', 'N', 'N', '152', NULL, '03', 'N', NULL, NULL, NULL, 497);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421005', '4209', 'SC', '4202', '4201', '42004', '42', 'MACIEIRA', NULL, '49', '89518000', '0', '5575', '5575', '20254', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 260.072, '-26,85600', '-51,37800', 880, 'S', 0.7720, NULL, NULL, '42900', 'N', 'N', 2810, NULL, '4290', '4290', NULL, '1993', 'S', 4525, 'MACIEIRA', 'N', '421005', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '153', NULL, '03', 'N', NULL, NULL, NULL, 489);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421010', '4212', 'SC', '4208', '4202', '42006', '42', 'MAFRA', NULL, '47', '89300000', '0', '8199', '8199', '20100', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1404.206, '-26,11100', '-49,80500', 793, 'S', 0.7880, NULL, NULL, '42900', 'N', 'N', 2820, NULL, '4206', '4205', NULL, '1917', 'S', 4526, 'MAFRA', 'N', '421010', 'N', 'N', 'S', NULL, 70, 'N', 'N', 'N', '154', NULL, '02', 'N', NULL, NULL, NULL, 500);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421020', '4207', 'SC', '4205', '4205', '42015', '42', 'MAJOR GERCINO', NULL, '48', '88260000', '9', '8201', '8201', '20101', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 285.679, '-27,41800', '-48,95100', 80, 'S', 0.7990, NULL, NULL, '42900', 'N', 'N', 2830, NULL, '4202', '4201', NULL, '1961', 'S', 4527, 'MAJOR GERCINO', 'N', '421020', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '155', NULL, '03', 'N', NULL, NULL, NULL, 494);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421030', '4212', 'SC', '4208', '4202', '42006', '42', 'MAJOR VIEIRA', NULL, '47', '89480000', '8', '8203', '8203', '20102', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 525.988, '-26,36800', '-50,32800', 786, 'S', 0.7520, NULL, NULL, '42900', 'N', 'N', 2833, NULL, '4206', '4290', NULL, '1960', 'S', 4528, 'MAJOR VIEIRA', 'N', '421030', 'N', 'N', 'S', NULL, 70, 'N', 'N', 'N', '156', NULL, '03', 'N', NULL, NULL, NULL, 500);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421040', '4214', 'SC', '4206', '4206', '42020', '42', 'MARACAJA', NULL, '48', '88915000', '7', '8391', '8391', '20196', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 63.401, '-28,84700', '-49,45300', 30, 'S', 0.8130, NULL, NULL, '42900', 'N', 'N', 2880, NULL, '4210', '4203', NULL, '1967', 'S', 4529, 'MARACAJÁ', 'N', '421040', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '157', NULL, '03', 'N', NULL, NULL, NULL, 492);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421050', '4201', 'SC', '4201', '4201', '42002', '42', 'MARAVILHA', NULL, '49', '89874000', '6', '8205', '8205', '20103', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 169.447, '-26,76100', '-53,17300', 625, 'S', 0.8170, NULL, NULL, '42900', 'N', 'N', 2898, NULL, '4290', '4290', NULL, '1958', 'S', 4530, 'MARAVILHA', 'N', '421050', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '158', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421055', '4203', 'SC', '4201', '4201', '42003', '42', 'MAREMA', NULL, '49', '89860000', '5', '9963', '9963', '20208', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 103.616, '-26,80200', '-52,62500', 417, 'S', 0.7950, NULL, NULL, '42900', 'N', 'N', 2912, NULL, '4216', '4290', NULL, '1989', 'S', 4531, 'MAREMA', 'N', '421055', 'N', 'N', 'S', NULL, 33, 'S', 'N', 'N', '159', NULL, '03', 'N', NULL, NULL, NULL, 502);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421060', '4211', 'SC', '4207', '4202', '42008', '42', 'MASSARANDUBA', NULL, '47', '89108000', '5', '8207', '8207', '20104', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 373.296, '-26,61100', '-49,00800', 38, 'S', 0.8350, NULL, NULL, '42900', 'N', 'N', 2955, NULL, '4206', '4205', NULL, '1961', 'S', 4532, 'MASSARANDUBA', 'N', '421060', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '160', NULL, '03', 'N', NULL, NULL, NULL, 498);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421070', '4209', 'SC', '4202', '4201', '42004', '42', 'MATOS COSTA', NULL, '49', '89420000', '4', '8209', '8209', '20105', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 432.177, '-26,47300', '-51,14800', 1220, 'S', 0.7460, NULL, NULL, '42900', 'N', 'N', 2983, NULL, '4290', '4290', NULL, '1962', 'S', 4533, 'MATOS COSTA', 'N', '421070', 'N', 'N', 'S', NULL, 70, 'N', 'N', 'N', '161', NULL, '03', 'N', NULL, NULL, NULL, 489);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421080', '4214', 'SC', '4206', '4206', '42020', '42', 'MELEIRO', NULL, '48', '88920000', '3', '8211', '8211', '20106', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 186.618, '-28,82900', '-49,63600', 38, 'S', 0.7930, NULL, NULL, '42900', 'N', 'N', 3004, NULL, '4210', '4290', NULL, '1961', 'S', 4534, 'MELEIRO', 'N', '421080', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '162', NULL, '03', 'N', NULL, NULL, NULL, 492);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421085', '4204', 'SC', '4203', '4204', '42011', '42', 'MIRIM DOCE', NULL, '47', '89194000', '2', '5559', '5559', '20227', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 336.313, '-27,19600', '-50,07700', 397, 'S', 0.7900, NULL, NULL, '42900', 'N', 'N', 3062, NULL, '4218', '4290', NULL, '1993', 'S', 4535, 'MIRIM DOCE', 'N', '421085', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '163', NULL, '03', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421090', '4201', 'SC', '4201', '4201', '42002', '42', 'MODELO', NULL, '49', '89872000', '2', '8213', '8213', '20107', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 92.717, '-26,77800', '-53,05500', 470, 'S', 0.7940, NULL, NULL, '42900', 'N', 'N', 3068, NULL, '4290', '4290', NULL, '1961', 'S', 4536, 'MODELO', 'N', '421090', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '164', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421100', '4201', 'SC', '4201', '4201', '42001', '42', 'MONDAI', NULL, '49', '89893000', '9', '8215', '8215', '20108', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 200.980, '-27,10300', '-53,40200', 235, 'S', 0.8090, NULL, NULL, '42900', 'N', 'N', 3082, NULL, '4290', '4290', NULL, '1953', 'S', 4537, 'MONDAÍ', 'N', '421100', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '165', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421105', '4208', 'SC', '4202', '4203', '42009', '42', 'MONTE CARLO', NULL, '49', '89618000', '8', '5561', '5561', '20228', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 162.785, '-27,22300', '-50,98000', 942, 'S', 0.7330, NULL, NULL, '42900', 'N', 'N', 3108, NULL, '4290', '4290', NULL, '1993', 'S', 4538, 'MONTE CARLO', 'N', '421105', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '166', NULL, '03', 'N', NULL, NULL, NULL, 497);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421110', '4212', 'SC', '4208', '4202', '42006', '42', 'MONTE CASTELO', NULL, '47', '89380000', '8', '8217', '8217', '20109', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 561.732, '-26,46200', '-50,23100', 820, 'S', 0.7370, NULL, NULL, '42900', 'N', 'N', 3111, NULL, '4206', '4205', NULL, '1962', 'S', 4539, 'MONTE CASTELO', 'N', '421110', 'N', 'N', 'S', NULL, 70, 'N', 'N', 'N', '167', NULL, '03', 'N', NULL, NULL, NULL, 500);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421120', '4215', 'SC', '4206', '4206', '42019', '42', 'MORRO DA FUMACA', NULL, '48', '88830000', '7', '8219', '8219', '20110', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 82.935, '-28,65100', '-49,21000', 18, 'S', 0.8040, NULL, NULL, '42900', 'N', 'N', 3147, NULL, '4209', '4203', NULL, '1962', 'S', 4540, 'MORRO DA FUMAÇA', 'N', '421120', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '168', NULL, '03', 'N', NULL, NULL, NULL, 490);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421125', '4214', 'SC', '4206', '4206', '42020', '42', 'MORRO GRANDE', NULL, '48', '88925000', '6', '5539', '5539', '20255', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 256.468, '-28,80100', '-49,72100', 90, 'S', 0.7900, NULL, NULL, '42900', 'N', 'N', 3152, NULL, '4210', '4290', NULL, '1993', 'S', 4541, 'MORRO GRANDE', 'N', '421125', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '169', NULL, '03', 'N', NULL, NULL, NULL, 492);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421130', '4205', 'SC', '4204', '4204', '42013', '42', 'NAVEGANTES', NULL, '47', '88375000', '6', '8221', '8221', '20111', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 111.461, '-26,89900', '-48,65400', 12, 'S', 0.7740, NULL, NULL, '42900', 'N', 'N', 3208, NULL, '4207', '4204', NULL, '1962', 'S', 4542, 'NAVEGANTES', 'N', '421130', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '170', NULL, '02', 'N', NULL, NULL, NULL, 493);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421140', '4202', 'SC', '4201', '4201', '42002', '42', 'NOVA ERECHIM', NULL, '49', '89865000', '5', '8223', '8223', '20112', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 64.400, '-26,90300', '-52,90600', 462, 'S', 0.8100, NULL, NULL, '42900', 'N', 'N', 3276, NULL, '4215', '4290', NULL, '1964', 'S', 4543, 'NOVA ERECHIM', 'N', '421140', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '171', NULL, '03', 'N', NULL, NULL, NULL, 499);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421145', '4202', 'SC', '4201', '4201', '42002', '42', 'NOVA ITABERABA', NULL, '49', '89818000', '4', '5589', '5589', '20229', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 137.583, '-26,94000', '-52,81200', 350, 'S', 0.7590, NULL, NULL, '42900', 'N', 'N', 3297, NULL, '4215', '4290', NULL, '1993', 'S', 4544, 'NOVA ITABERABA', 'N', '421145', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '172', NULL, '03', 'N', NULL, NULL, NULL, 499);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421150', '4207', 'SC', '4205', '4205', '42015', '42', 'NOVA TRENTO', NULL, '48', '88270000', '4', '8225', '8225', '20113', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 402.118, '-27,28600', '-48,93000', 30, 'S', 0.8150, NULL, NULL, '42900', 'N', 'N', 3339, NULL, '4202', '4201', NULL, '1892', 'S', 4545, 'NOVA TRENTO', 'N', '421150', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '173', NULL, '03', 'N', NULL, NULL, NULL, 494);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421160', '4215', 'SC', '4206', '4206', '42019', '42', 'NOVA VENEZA', NULL, '48', '88865000', '3', '8227', '8227', '20114', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 293.557, '-28,63700', '-49,49800', 74, 'S', 0.8130, NULL, NULL, '42900', 'N', 'N', 3344, NULL, '4209', '4290', NULL, '1958', 'S', 4546, 'NOVA VENEZA', 'N', '421160', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '174', NULL, '03', 'N', NULL, NULL, NULL, 490);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421165', '4203', 'SC', '4201', '4201', '42002', '42', 'NOVO HORIZONTE', NULL, '49', '89998000', '2', '5591', '5591', '20230', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 151.672, '-26,44400', '-52,83400', 710, 'S', 0.7520, NULL, NULL, '42900', 'N', 'N', 3359, NULL, '4290', '4290', NULL, '1993', 'S', 4547, 'NOVO HORIZONTE', 'N', '421165', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '175', NULL, '03', 'N', NULL, NULL, NULL, 502);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421170', '4215', 'SC', '4206', '4206', '42018', '42', 'ORLEANS', NULL, '48', '88870000', '2', '8229', '8229', '20115', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 549.824, '-28,35900', '-49,29100', 132, 'S', 0.8140, NULL, NULL, '42900', 'N', 'N', 3418, NULL, '4212', '4290', NULL, '1913', 'S', 4548, 'ORLEANS', 'N', '421170', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '176', NULL, '03', 'N', NULL, NULL, NULL, 490);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421175', '4213', 'SC', '4209', '4203', '42010', '42', 'OTACILIO COSTA', NULL, '49', '88540000', '1', '8397', '8397', '20199', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 846.576, '-27,48300', '-50,12200', 884, 'S', 0.8040, NULL, NULL, '42900', 'N', 'N', 3427, NULL, '4214', '4290', NULL, '1982', 'S', 4549, 'OTACÍLIO COSTA', 'N', '421175', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '177', NULL, '03', 'N', NULL, NULL, NULL, 501);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421180', '4208', 'SC', '4202', '4201', '42004', '42', 'OURO', NULL, '49', '89663000', '1', '8231', '8231', '20116', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 206.229, '-27,34100', '-51,61800', 485, 'S', 0.8280, NULL, NULL, '42900', 'N', 'N', 3434, NULL, '4290', '4290', NULL, '1963', 'S', 4550, 'OURO', 'N', '421180', 'N', 'N', 'S', NULL, 33, 'N', 'N', 'N', '178', NULL, '03', 'N', NULL, NULL, NULL, 497);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421185', '4203', 'SC', '4201', '4201', '42003', '42', 'OURO VERDE', NULL, '49', '89834000', '0', '5741', '5741', '20231', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 189.270, '-26,69400', '-52,31200', 758, 'S', 0.7920, NULL, NULL, '42900', 'N', 'N', 3443, NULL, '4290', '4290', NULL, '1993', 'S', 4551, 'OURO VERDE', 'N', '421185', 'N', 'N', 'S', NULL, 33, 'N', 'N', 'N', '179', NULL, '03', 'N', NULL, NULL, NULL, 502);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421187', '4210', 'SC', '4202', '4201', '42005', '42', 'PAIAL', NULL, '49', '89765000', '6', '0928', NULL, '20283', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 85.761, '-27,25200', '-52,49800', 425, 'S', 0.7520, NULL, NULL, '42900', 'N', 'N', 3465, NULL, '4215', '4290', NULL, '1997', 'S', 4552, 'PAIAL', 'N', '421187', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '180', NULL, '03', 'N', NULL, NULL, NULL, 487);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421189', '4213', 'SC', '4209', '4203', '42010', '42', 'PAINEL', NULL, '49', '88543000', '2', '0930', NULL, '20284', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 742.103, '-27,92900', '-50,10500', 1144, 'S', 0.7530, NULL, NULL, '42900', 'N', 'N', 3469, NULL, '4214', '4290', NULL, '1997', 'S', 4553, 'PAINEL', 'N', '421189', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '181', NULL, '03', 'N', NULL, NULL, NULL, 501);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421190', '4207', 'SC', '4205', '4205', '42016', '42', 'PALHOCA', NULL, '48', '88130000', '0', '8233', '8233', '20117', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 394.662, '-27,64500', '-48,66800', 3, 'S', 0.8160, NULL, NULL, '42900', 'N', 'N', 3478, NULL, '4201', '4201', NULL, '1894', 'S', 4554, 'PALHOÇA', 'N', '421190', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '182', NULL, '01', 'N', NULL, NULL, NULL, 494);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421200', '4201', 'SC', '4201', '4201', '42001', '42', 'PALMA SOLA', NULL, '49', '89985000', '7', '8235', '8235', '20118', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 331.776, '-26,34800', '-53,27800', 870, 'S', 0.7570, NULL, NULL, '42900', 'N', 'N', 3480, NULL, '4290', '4290', NULL, '1961', 'S', 4555, 'PALMA SOLA', 'N', '421200', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '183', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421205', '4213', 'SC', '4209', '4203', '42010', '42', 'PALMEIRA', NULL, '49', '88545000', '6', '0932', NULL, '20285', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 292.216, '-27,58300', '-50,15900', 0, 'S', 0.7550, NULL, NULL, '42900', 'N', 'N', 3488, NULL, '4214', '4290', NULL, '1997', 'S', 4556, 'PALMEIRA', 'N', '421205', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '184', NULL, '03', 'N', NULL, NULL, NULL, 501);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421210', '4202', 'SC', '4201', '4201', '42002', '42', 'PALMITOS', NULL, '49', '89887000', '6', '8237', '8237', '20119', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 350.690, '-27,06800', '-53,16100', 406, 'S', 0.7990, NULL, NULL, '42900', 'N', 'N', 3507, NULL, '4216', '4290', NULL, '1953', 'S', 4557, 'PALMITOS', 'N', '421210', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '185', NULL, '03', 'N', NULL, NULL, NULL, 499);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421220', '4212', 'SC', '4208', '4202', '42006', '42', 'PAPANDUVA', NULL, '47', '89370000', '5', '8239', '8239', '20120', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 759.832, '-26,37000', '-50,14400', 788, 'S', 0.7370, NULL, NULL, '42900', 'N', 'N', 3518, NULL, '4206', '4205', NULL, '1953', 'S', 4558, 'PAPANDUVA', 'N', '421220', 'N', 'N', 'S', NULL, 70, 'N', 'N', 'N', '186', NULL, '03', 'N', NULL, NULL, NULL, 500);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421223', '4201', 'SC', '4201', '4201', '42001', '42', 'PARAISO', NULL, '49', '89906000', '9', '5747', '5747', '20232', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 178.607, '-26,61400', '-53,67200', 520, 'S', 0.7730, NULL, NULL, '42900', 'N', 'N', 3533, NULL, '4290', '4290', NULL, '1993', 'S', 4559, 'PARAÍSO', 'N', '421223', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '187', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421225', '4214', 'SC', '4206', '4206', '42020', '42', 'PASSO DE TORRES', NULL, '48', '88980000', '4', '5541', '5541', '20233', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 95.054, '-29,31600', '-49,72400', 10, 'S', 0.7890, NULL, NULL, '42900', 'N', 'N', 3592, NULL, '4210', '4290', NULL, '1993', 'S', 4560, 'PASSO DE TORRES', 'N', '421225', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '188', NULL, '03', 'N', NULL, NULL, NULL, 492);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421227', '4203', 'SC', '4201', '4201', '42003', '42', 'PASSOS MAIA', NULL, '49', '89687000', '0', '5743', '5743', '20234', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 614.432, '-26,78000', '-52,05900', 800, 'S', 0.7320, NULL, NULL, '42900', 'N', 'N', 3596, NULL, '4290', '4290', NULL, '1993', 'S', 4561, 'PASSOS MAIA', 'N', '421227', 'N', 'N', 'S', NULL, 33, 'N', 'N', 'N', '189', NULL, '03', 'N', NULL, NULL, NULL, 502);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421230', '4207', 'SC', '4205', '4205', '42016', '42', 'PAULO LOPES', NULL, '48', '88490000', '4', '8241', '8241', '20121', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 450.372, '-27,96200', '-48,68400', 2, 'S', 0.7590, NULL, NULL, '42900', 'N', 'N', 3629, NULL, '4202', '4201', NULL, '1961', 'S', 4562, 'PAULO LOPES', 'N', '421230', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '190', NULL, '03', 'N', NULL, NULL, NULL, 494);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421240', '4216', 'SC', '4206', '4206', '42018', '42', 'PEDRAS GRANDES', NULL, '48', '88720000', '3', '8243', '8243', '20122', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 171.821, '-28,43600', '-49,18500', 39, 'S', 0.7990, NULL, NULL, '42900', 'N', 'N', 3658, NULL, '4212', '4290', NULL, '1961', 'S', 4563, 'PEDRAS GRANDES', 'N', '421240', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '191', NULL, '03', 'N', NULL, NULL, NULL, 495);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421250', '4205', 'SC', '4204', '4204', '42013', '42', 'PENHA', NULL, '47', '88385000', '2', '8245', '8245', '20123', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 58.783, '-26,76900', '-48,64600', 20, 'S', 0.7910, NULL, NULL, '42900', 'N', 'N', 3689, NULL, '4207', '4290', NULL, '1958', 'S', 4564, 'PENHA', 'N', '421250', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '192', NULL, '03', 'N', NULL, NULL, NULL, 493);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421260', '4210', 'SC', '4202', '4201', '42005', '42', 'PERITIBA', NULL, '49', '89750000', '1', '8247', '8247', '20124', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 96.407, '-27,37300', '-51,90400', 450, 'S', 0.8100, NULL, NULL, '42900', 'N', 'N', 3702, NULL, '4290', '4290', NULL, '1963', 'S', 4565, 'PERITIBA', 'N', '421260', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '193', NULL, '03', 'N', NULL, NULL, NULL, 487);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421270', '4204', 'SC', '4203', '4204', '42014', '42', 'PETROLANDIA', NULL, '47', '88430000', '0', '8249', '8249', '20125', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 306.153, '-27,53500', '-49,69800', 410, 'S', 0.7830, NULL, NULL, '42900', 'N', 'N', 3711, NULL, '4218', '4290', NULL, '1962', 'S', 4566, 'PETROLÂNDIA', 'N', '421270', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '194', NULL, '03', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421280', '4205', 'SC', '4204', '4204', '42013', '42', 'BALNEARIO PICARRAS', NULL, '47', '88380000', '9', '8251', '8251', '20126', NULL, 'ATIVO', 'N', 'N', NULL, 'PIÇARRAS                  ', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 99.071, '-26,76400', '-48,67200', 18, 'S', 0.7990, NULL, NULL, '42900', 'N', 'N', 3724, NULL, '4208', '4290', NULL, '1963', 'S', 4567, 'BALNEÁRIO PIÇARRAS', 'N', '421280', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '30', NULL, '03', 'N', NULL, NULL, NULL, 493);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421290', '4202', 'SC', '4201', '4201', '42002', '42', 'PINHALZINHO', NULL, '49', '89870000', '8', '8253', '8253', '20127', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 128.298, '-26,84800', '-52,99200', 515, 'S', 0.8260, NULL, NULL, '42900', 'N', 'N', 3759, NULL, '4215', '4290', NULL, '1961', 'S', 4568, 'PINHALZINHO', 'N', '421290', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '195', NULL, '03', 'N', NULL, NULL, NULL, 499);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421300', '4209', 'SC', '4202', '4201', '42004', '42', 'PINHEIRO PRETO', NULL, '49', '89570000', '5', '8255', '8255', '20128', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 65.705, '-27,05100', '-51,23100', 696, 'S', 0.8180, NULL, NULL, '42900', 'N', 'N', 3768, NULL, '4290', '4290', NULL, '1962', 'S', 4569, 'PINHEIRO PRETO', 'N', '421300', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '196', NULL, '03', 'N', NULL, NULL, NULL, 489);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421310', '4210', 'SC', '4202', '4201', '42005', '42', 'PIRATUBA', NULL, '49', '89667000', '4', '8257', '8257', '20129', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 145.701, '-27,42000', '-51,77200', 430, 'S', 0.8060, NULL, NULL, '42900', 'N', 'N', 3805, NULL, '4290', '4290', NULL, '1948', 'S', 4570, 'PIRATUBA', 'N', '421310', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '197', NULL, '03', 'N', NULL, NULL, NULL, 487);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421315', '4202', 'SC', '4201', '4201', '42002', '42', 'PLANALTO ALEGRE', NULL, '49', '89882000', '3', '5593', '5593', '20235', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 62.632, '-27,07000', '-52,86600', 495, 'S', 0.8170, NULL, NULL, '42900', 'N', 'N', 3831, NULL, '4215', '4290', NULL, '1993', 'S', 4571, 'PLANALTO ALEGRE', 'N', '421315', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '198', NULL, '03', 'N', NULL, NULL, NULL, 499);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421320', '4206', 'SC', '4203', '4204', '42012', '42', 'POMERODE', NULL, '47', '89107000', '3', '8259', '8259', '20130', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 215.904, '-26,74100', '-49,17700', 85, 'S', 0.8490, NULL, NULL, '42900', 'N', 'N', 3855, NULL, '4203', '4202', NULL, '1958', 'S', 4572, 'POMERODE', 'N', '421320', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '199', NULL, '03', 'N', NULL, NULL, NULL, 496);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421330', '4213', 'SC', '4209', '4203', '42009', '42', 'PONTE ALTA', NULL, '49', '88550000', '2', '8261', '8261', '20131', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 566.754, '-27,48400', '-50,38000', 856, 'S', 0.7270, NULL, NULL, '42900', 'N', 'N', 3868, NULL, '4214', '4290', NULL, '1964', 'S', 4573, 'PONTE ALTA', 'N', '421330', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '200', NULL, '03', 'N', NULL, NULL, NULL, 501);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421335', '4209', 'SC', '4202', '4203', '42009', '42', 'PONTE ALTA DO NORTE', NULL, '49', '89535000', '1', '5569', '5569', '20256', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 400.972, '-27,15800', '-50,46400', 962, 'S', 0.7520, NULL, NULL, '42900', 'N', 'N', 3870, NULL, '4214', '4290', NULL, '1993', 'S', 4574, 'PONTE ALTA DO NORTE', 'N', '421335', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '201', NULL, '03', 'N', NULL, NULL, NULL, 489);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421340', '4203', 'SC', '4201', '4201', '42003', '42', 'PONTE SERRADA', NULL, '49', '89683000', '1', '8263', '8263', '20132', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 564.005, '-26,87200', '-52,01600', 798, 'S', 0.7680, NULL, NULL, '42900', 'N', 'N', 3875, NULL, '4290', '4290', NULL, '1958', 'S', 4575, 'PONTE SERRADA', 'N', '421340', 'N', 'N', 'S', NULL, 33, 'N', 'N', 'N', '202', NULL, '03', 'N', NULL, NULL, NULL, 502);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421350', '4205', 'SC', '4204', '4204', '42013', '42', 'PORTO BELO', NULL, '47', '88210000', '0', '8265', '8265', '20133', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 92.762, '-27,15800', '-48,55300', 1, 'S', 0.8030, NULL, NULL, '42900', 'N', 'N', 3903, NULL, '4208', '4204', NULL, '1895', 'S', 4576, 'PORTO BELO', 'N', '421350', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '203', NULL, '03', 'N', NULL, NULL, NULL, 493);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421360', '4212', 'SC', '4208', '4202', '42006', '42', 'PORTO UNIAO', NULL, '42', '89400000', '9', '8267', '8267', '20134', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 851.239, '-26,23800', '-51,07800', 795, 'S', 0.8060, NULL, NULL, '42900', 'N', 'N', 3926, NULL, '4206', '4290', NULL, '1917', 'S', 4577, 'PORTO UNIÃO', 'N', '421360', 'N', 'N', 'S', NULL, 70, 'N', 'N', 'N', '204', NULL, '03', 'N', NULL, NULL, NULL, 500);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421370', '4204', 'SC', '4203', '4204', '42011', '42', 'POUSO REDONDO', NULL, '47', '89172000', '8', '8269', '8269', '20135', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 359.519, '-27,25800', '-49,93400', 354, 'S', 0.7860, NULL, NULL, '42900', 'N', 'N', 3942, NULL, '4218', '4290', NULL, '1958', 'S', 4578, 'POUSO REDONDO', 'N', '421370', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '205', NULL, '03', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421380', '4214', 'SC', '4206', '4206', '42020', '42', 'PRAIA GRANDE', NULL, '48', '88990000', '7', '8271', '8271', '20136', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 278.576, '-29,19700', '-49,95000', 45, 'S', 0.7630, NULL, NULL, '42900', 'N', 'N', 3950, NULL, '4210', '4290', NULL, '1958', 'S', 4579, 'PRAIA GRANDE', 'N', '421380', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '206', NULL, '03', 'N', NULL, NULL, NULL, 492);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421390', '4210', 'SC', '4202', '4201', '42005', '42', 'PRESIDENTE CASTELLO BRANCO', NULL, '49', '89745000', '6', '8273', '8273', '20137', NULL, 'ATIVO', 'N', 'N', NULL, 'PRESIDENTE CASTELO BRANCO ', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 76.940, '-27,22300', '-51,80700', 650, 'S', 0.8320, NULL, NULL, '42900', 'N', 'N', 3965, NULL, '4290', '4290', NULL, '1963', 'S', 4580, 'PRESIDENTE CASTELLO BRANCO', 'N', '421390', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '207', NULL, '03', 'N', NULL, NULL, NULL, 487);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421400', '4204', 'SC', '4203', '4204', '42011', '42', 'PRESIDENTE GETULIO', NULL, '47', '89150000', '3', '8275', '8275', '20138', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 295.650, '-27,05100', '-49,62300', 255, 'S', 0.8100, NULL, NULL, '42900', 'N', 'N', 3970, NULL, '4218', '4290', NULL, '1953', 'S', 4581, 'PRESIDENTE GETÚLIO', 'N', '421400', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '208', NULL, '03', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421410', '4204', 'SC', '4203', '4204', '42011', '42', 'PRESIDENTE NEREU', NULL, '47', '89184000', '2', '8277', '8277', '20139', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 224.672, '-27,27700', '-49,39000', 390, 'S', 0.7740, NULL, NULL, '42900', 'N', 'N', 3980, NULL, '4218', '4290', NULL, '1961', 'S', 4582, 'PRESIDENTE NEREU', 'N', '421410', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '209', NULL, '03', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421415', '4201', 'SC', '4201', '4201', '42001', '42', 'PRINCESA', NULL, '49', '89935000', '1', '0934', NULL, '20286', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 86.215, '-26,44200', '-53,59800', 588, 'S', 0.7510, NULL, NULL, '42900', 'N', 'N', 3993, NULL, '4290', '4290', NULL, '1997', 'S', 4583, 'PRINCESA', 'N', '421415', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '210', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421420', '4202', 'SC', '4201', '4201', '42002', '42', 'QUILOMBO', NULL, '49', '89850000', '1', '8279', '8279', '20140', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 279.279, '-26,72600', '-52,72100', 425, 'S', 0.8020, NULL, NULL, '42900', 'N', 'N', 4029, NULL, '4216', '4290', NULL, '1961', 'S', 4584, 'QUILOMBO', 'N', '421420', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '211', NULL, '03', 'N', NULL, NULL, NULL, 499);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421430', '4207', 'SC', '4205', '4205', '42017', '42', 'RANCHO QUEIMADO', NULL, '48', '88470000', '0', '8281', '8281', '20141', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 286.432, '-27,67300', '-49,02200', 810, 'S', 0.7730, NULL, NULL, '42900', 'N', 'N', 4053, NULL, '4202', '4201', NULL, '1962', 'S', 4585, 'RANCHO QUEIMADO', 'N', '421430', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '212', NULL, '03', 'N', NULL, NULL, NULL, 494);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421440', '4209', 'SC', '4202', '4201', '42004', '42', 'RIO DAS ANTAS', NULL, '49', '89550000', '9', '8283', '8283', '20142', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 317.190, '-26,89900', '-51,07400', 830, 'S', 0.8030, NULL, NULL, '42900', 'N', 'N', 4150, NULL, '4290', '4290', NULL, '1958', 'S', 4586, 'RIO DAS ANTAS', 'N', '421440', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '213', NULL, '03', 'N', NULL, NULL, NULL, 489);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421450', '4204', 'SC', '4203', '4204', '42011', '42', 'RIO DO CAMPO', NULL, '47', '89198000', '8', '8285', '8285', '20143', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 506.198, '-26,94900', '-50,14100', 570, 'S', 0.7970, NULL, NULL, '42900', 'N', 'N', 4157, NULL, '4218', '4290', NULL, '1961', 'S', 4587, 'RIO DO CAMPO', 'N', '421450', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '214', NULL, '03', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421460', '4204', 'SC', '4203', '4204', '42011', '42', 'RIO DO OESTE', NULL, '47', '89180000', '7', '8287', '8287', '20144', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 245.633, '-27,19300', '-49,79700', 350, 'S', 0.7990, NULL, NULL, '42900', 'N', 'N', 4159, NULL, '4218', '4290', NULL, '1958', 'S', 4588, 'RIO DO OESTE', 'N', '421460', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '215', NULL, '03', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421470', '4206', 'SC', '4203', '4204', '42012', '42', 'RIO DOS CEDROS', NULL, '47', '89121000', '6', '8289', '8289', '20145', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 555.654, '-26,73800', '-49,27400', 85, 'S', 0.8170, NULL, NULL, '42900', 'N', 'N', 4165, NULL, '4204', '4202', NULL, '1961', 'S', 4590, 'RIO DOS CEDROS', 'N', '421470', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '217', NULL, '03', 'N', NULL, NULL, NULL, 496);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421480', '4204', 'SC', '4203', '4204', '42011', '42', 'RIO DO SUL', NULL, '47', '89160000', '5', '8291', '8291', '20146', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 258.401, '-27,21400', '-49,64300', 341, 'S', 0.8270, NULL, NULL, '42900', 'N', 'N', 4162, NULL, '4217', '4290', NULL, '1930', 'S', 4589, 'RIO DO SUL', 'N', '421480', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '216', NULL, '02', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421490', '4216', 'SC', '4206', '4206', '42018', '42', 'RIO FORTUNA', NULL, '48', '88760000', '4', '8293', '8293', '20147', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 300.315, '-28,13100', '-49,10500', 130, 'S', 0.8220, NULL, NULL, '42900', 'N', 'N', 4169, NULL, '4212', '4290', NULL, '1958', 'S', 4591, 'RIO FORTUNA', 'N', '421490', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '218', NULL, '03', 'N', NULL, NULL, NULL, 495);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421500', '4212', 'SC', '4208', '4202', '42007', '42', 'RIO NEGRINHO', NULL, '47', '89295000', '0', '8295', '8295', '20148', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 908.391, '-26,25400', '-49,51800', 790, 'S', 0.7890, NULL, NULL, '42900', 'N', 'N', 4176, NULL, '4206', '4205', NULL, '1953', 'S', 4592, 'RIO NEGRINHO', 'N', '421500', 'N', 'N', 'S', NULL, 70, 'N', 'N', 'N', '219', NULL, '03', 'N', NULL, NULL, NULL, 500);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421505', '4213', 'SC', '4209', '4203', '42010', '42', 'RIO RUFINO', NULL, '49', '88658000', '9', '5571', '5571', '20236', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 282.569, '-27,86100', '-49,77900', 860, 'S', 0.7360, NULL, NULL, '42900', 'N', 'N', 4190, NULL, '4214', '4290', NULL, '1993', 'S', 4593, 'RIO RUFINO', 'N', '421505', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '220', NULL, '03', 'N', NULL, NULL, NULL, 501);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421507', '4202', 'SC', '4201', '4201', '42001', '42', 'RIQUEZA', NULL, '49', '89895000', '5', '5749', '5749', '20237', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 190.279, '-27,06700', '-53,32200', 236, 'S', 0.7950, NULL, NULL, '42900', 'N', 'N', 4198, NULL, '4290', '4290', NULL, '1993', 'S', 4594, 'RIQUEZA', 'N', '421507', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '221', NULL, '03', 'N', NULL, NULL, NULL, 499);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421510', '4206', 'SC', '4203', '4204', '42012', '42', 'RODEIO', NULL, '47', '89136000', '9', '8297', '8297', '20149', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 130.942, '-26,92300', '-49,36600', 106, 'S', 0.8100, NULL, NULL, '42900', 'N', 'N', 4204, NULL, '4204', '4202', NULL, '1936', 'S', 4595, 'RODEIO', 'N', '421510', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '222', NULL, '03', 'N', NULL, NULL, NULL, 496);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421520', '4201', 'SC', '4201', '4201', '42001', '42', 'ROMELANDIA', NULL, '49', '89908000', '8', '8299', '8299', '20150', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 223.749, '-26,67600', '-53,31400', 425, 'S', 0.7480, NULL, NULL, '42900', 'N', 'N', 4214, NULL, '4290', '4290', NULL, '1963', 'S', 4596, 'ROMELÂNDIA', 'N', '421520', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '223', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421530', '4204', 'SC', '4203', '4204', '42011', '42', 'SALETE', NULL, '47', '89196000', '7', '8301', '8301', '20151', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 179.308, '-26,98000', '-50,00000', 500, 'S', 0.8000, NULL, NULL, '42900', 'N', 'N', 4254, NULL, '4218', '4290', NULL, '1961', 'S', 4597, 'SALETE', 'N', '421530', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '224', NULL, '03', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421535', '4201', 'SC', '4201', '4201', '42002', '42', 'SALTINHO', NULL, '49', '89981000', '6', '0936', NULL, '20287', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 156.528, '-26,60900', '-53,05600', 620, 'S', 0.7450, NULL, NULL, '42900', 'N', 'N', 4268, NULL, '4290', '4290', NULL, '1997', 'S', 4598, 'SALTINHO', 'N', '421535', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '225', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421540', '4209', 'SC', '4202', '4201', '42004', '42', 'SALTO VELOSO', NULL, '49', '89595000', '6', '8303', '8303', '20152', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 105.042, '-26,90500', '-51,40600', 820, 'S', 0.7960, NULL, NULL, '42900', 'N', 'N', 4277, NULL, '4290', '4290', NULL, '1961', 'S', 4599, 'SALTO VELOSO', 'N', '421540', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '226', NULL, '03', 'N', NULL, NULL, NULL, 489);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421545', '4216', 'SC', '4206', '4206', '42018', '42', 'SANGAO', NULL, '48', '88717000', '5', '5547', '5547', '20257', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 83.058, '-28,63800', '-49,12900', 50, 'S', 0.7940, NULL, NULL, '42900', 'N', 'N', 4288, NULL, '4212', '4290', NULL, '1993', 'S', 4600, 'SANGÃO', 'N', '421545', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '227', NULL, '03', 'N', NULL, NULL, NULL, 495);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421550', '4209', 'SC', '4202', '4203', '42009', '42', 'SANTA CECILIA', NULL, '49', '89540000', '5', '8305', '8305', '20153', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1145.321, '-26,96100', '-50,42700', 1100, 'S', 0.7460, NULL, NULL, '42900', 'N', 'N', 4305, NULL, '4214', '4290', NULL, '1958', 'S', 4601, 'SANTA CECÍLIA', 'N', '421550', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '228', NULL, '03', 'N', NULL, NULL, NULL, 489);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421555', '4201', 'SC', '4201', '4201', '42001', '42', 'SANTA HELENA', NULL, '49', '89915000', '4', '5751', '5751', '20238', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 80.982, '-26,93800', '-53,61900', 530, 'S', 0.7870, NULL, NULL, '42900', 'N', 'N', 4342, NULL, '4290', '4290', NULL, '1993', 'S', 4602, 'SANTA HELENA', 'N', '421555', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '229', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421560', '4216', 'SC', '4206', '4206', '42018', '42', 'SANTA ROSA DE LIMA', NULL, '48', '88763000', '4', '8307', '8307', '20154', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 202.977, '-28,03900', '-49,12800', 240, 'S', 0.7950, NULL, NULL, '42900', 'N', 'N', 4412, NULL, '4212', '4290', NULL, '1962', 'S', 4603, 'SANTA ROSA DE LIMA', 'N', '421560', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '230', NULL, '03', 'N', NULL, NULL, NULL, 495);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421565', '4214', 'SC', '4206', '4206', '42020', '42', 'SANTA ROSA DO SUL', NULL, '48', '88965000', '3', '9967', '9967', '20209', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 151.440, '-29,13600', '-49,70000', 30, 'S', 0.7620, NULL, NULL, '42900', 'N', 'N', 4416, NULL, '4210', '4290', NULL, '1989', 'S', 4604, 'SANTA ROSA DO SUL', 'N', '421565', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '231', NULL, '03', 'N', NULL, NULL, NULL, 492);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421567', '4204', 'SC', '4203', '4202', '42006', '42', 'SANTA TEREZINHA', NULL, '47', '89199000', '9', '5555', '5555', '20239', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 716.253, '-26,77900', '-50,00800', 610, 'S', 0.7380, NULL, NULL, '42900', 'N', 'N', 4427, NULL, '4218', '4290', NULL, '1993', 'S', 4605, 'SANTA TEREZINHA', 'N', '421567', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '232', NULL, '03', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421568', '4201', 'SC', '4201', '4201', '42002', '42', 'SANTA TEREZINHA DO PROGRESSO', NULL, '49', '89983000', '7', '0938', NULL, '20288', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 118.997, '-26,61900', '-53,20200', 400, 'S', 0.7450, NULL, NULL, '42900', 'N', 'N', 4431, NULL, '4290', '4290', NULL, '1997', 'S', 4606, 'SANTA TEREZINHA DO PROGRESSO', 'N', '421568', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '233', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421569', '4202', 'SC', '4201', '4201', '42002', '42', 'SANTIAGO DO SUL', NULL, '49', '89854000', '5', '0940', NULL, '20289', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 73.562, '-26,63900', '-52,68500', 450, 'S', 0.7720, NULL, NULL, '42900', 'N', 'N', 4470, NULL, '4290', '4290', NULL, '1997', 'S', 4607, 'SANTIAGO DO SUL', 'N', '421569', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '234', NULL, '03', 'N', NULL, NULL, NULL, 499);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421570', '4207', 'SC', '4205', '4205', '42016', '42', 'SANTO AMARO DA IMPERATRIZ', NULL, '48', '88140000', '3', '8309', '8309', '20155', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 310.735, '-27,68800', '-48,77900', 18, 'S', 0.8430, NULL, NULL, '42900', 'N', 'N', 4473, NULL, '4201', '4201', NULL, '1958', 'S', 4608, 'SANTO AMARO DA IMPERATRIZ', 'N', '421570', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '235', NULL, '03', 'N', NULL, NULL, NULL, 494);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421575', '4203', 'SC', '4201', '4201', '42002', '42', 'SAO BERNARDINO', NULL, '49', '89982000', '2', '0942', NULL, '20290', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 144.960, '-26,47500', '-52,96400', 540, 'S', 0.7480, NULL, NULL, '42900', 'N', 'N', 4537, NULL, '4290', '4290', NULL, '1997', 'S', 4610, 'SÃO BERNARDINO', 'N', '421575', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '237', NULL, '03', 'N', NULL, NULL, NULL, 502);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421580', '4212', 'SC', '4208', '4202', '42007', '42', 'SAO BENTO DO SUL', NULL, '47', '89290000', '2', '8311', '8311', '20156', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 495.578, '-26,25000', '-49,37900', 838, 'S', 0.8380, NULL, NULL, '42900', 'N', 'N', 4533, NULL, '4206', '4205', NULL, '1948', 'S', 4609, 'SÃO BENTO DO SUL', 'N', '421580', 'N', 'N', 'S', NULL, 70, 'N', 'N', 'N', '236', NULL, '02', 'N', NULL, NULL, NULL, 500);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421590', '4207', 'SC', '4205', '4205', '42017', '42', 'SAO BONIFACIO', NULL, '48', '88485000', '1', '8313', '8313', '20157', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 461.301, '-27,90100', '-48,92900', 410, 'S', 0.7850, NULL, NULL, '42900', 'N', 'N', 4540, NULL, '4202', '4201', NULL, '1962', 'S', 4611, 'SÃO BONIFÁCIO', 'N', '421590', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '238', NULL, '03', 'N', NULL, NULL, NULL, 494);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421600', '4202', 'SC', '4201', '4201', '42002', '42', 'SAO CARLOS', NULL, '49', '89885000', '8', '8315', '8315', '20158', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 158.988, '-27,07800', '-53,00400', 264, 'S', 0.8110, NULL, NULL, '42900', 'N', 'N', 4548, NULL, '4215', '4290', NULL, '1953', 'S', 4612, 'SÃO CARLOS', 'N', '421600', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '239', NULL, '03', 'N', NULL, NULL, NULL, 499);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421605', '4209', 'SC', '4202', '4203', '42009', '42', 'SAO CRISTOVAO DO SUL', NULL, '49', '89533000', '7', '5573', '5573', '20258', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 348.963, '-27,26700', '-50,44100', 1025, 'S', 0.7640, NULL, NULL, '42900', 'N', 'N', 4552, NULL, '4214', '4290', NULL, '1993', 'S', 4613, 'SÃO CRISTOVÃO DO SUL', 'N', '421605', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '240', NULL, '03', 'N', NULL, NULL, NULL, 489);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421610', '4203', 'SC', '4201', '4201', '42003', '42', 'SAO DOMINGOS', NULL, '49', '89835000', '7', '8317', '8317', '20159', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 383.653, '-26,55800', '-52,53200', 635, 'S', 0.7930, NULL, NULL, '42900', 'N', 'N', 4556, NULL, '4290', '4290', NULL, '1962', 'S', 4614, 'SÃO DOMINGOS', 'N', '421610', 'N', 'N', 'S', NULL, 33, 'N', 'N', 'N', '241', NULL, '03', 'N', NULL, NULL, NULL, 502);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421620', '4211', 'SC', '4207', '4202', '42008', '42', 'SAO FRANCISCO DO SUL', NULL, '47', '89240000', '6', '8319', '8319', '20160', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 492.819, '-26,24300', '-48,63800', 9, 'S', 0.8200, NULL, NULL, '42900', 'N', 'N', 4599, NULL, '4206', '4205', NULL, '1660', 'S', 4615, 'SÃO FRANCISCO DO SUL', 'N', '421620', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '242', NULL, '03', 'N', NULL, NULL, NULL, 498);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421625', '4201', 'SC', '4201', '4201', '42001', '42', 'SAO JOAO DO OESTE', NULL, '49', '89897000', '5', '5753', '5753', '20240', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 163.650, '-27,09800', '-53,59400', 320, 'S', 0.8110, NULL, NULL, '42900', 'N', 'N', 4658, NULL, '4290', '4290', NULL, '1993', 'S', 4618, 'SÃO JOÃO DO OESTE', 'N', '421625', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '245', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421630', '4207', 'SC', '4205', '4205', '42015', '42', 'SAO JOAO BATISTA', NULL, '48', '88240000', '5', '8321', '8321', '20161', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 220.726, '-27,27600', '-48,84900', 30, 'S', 0.8190, NULL, NULL, '42900', 'N', 'N', 4626, NULL, '4202', '4201', NULL, '1958', 'S', 4616, 'SÃO JOÃO BATISTA', 'N', '421630', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '243', NULL, '03', 'N', NULL, NULL, NULL, 494);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421635', '4211', 'SC', '4207', '4204', '42013', '42', 'SAO JOAO DO ITAPERIU', NULL, '47', '88395000', '4', '5551', '5551', '20259', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 151.926, '-26,61800', '-48,76800', 33, 'S', 0.7870, NULL, NULL, '42900', 'N', 'N', 4653, NULL, '4206', '4205', NULL, '1993', 'S', 4617, 'SÃO JOÃO DO ITAPERIÚ', 'N', '421635', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '244', NULL, '03', 'N', NULL, NULL, NULL, 498);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421640', '4214', 'SC', '4206', '4206', '42020', '42', 'SAO JOAO DO SUL', NULL, '48', '88970000', '4', '8323', '8323', '20162', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 182.699, '-29,22300', '-49,81000', 15, 'S', 0.7580, NULL, NULL, '42900', 'N', 'N', 4669, NULL, '4210', '4290', NULL, '1961', 'S', 4619, 'SÃO JOÃO DO SUL', 'N', '421640', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '246', NULL, '03', 'N', NULL, NULL, NULL, 492);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421650', '4213', 'SC', '4209', '4203', '42010', '42', 'SAO JOAQUIM', NULL, '49', '88600000', '3', '8325', '8325', '20163', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1885.608, '-28,29400', '-49,93200', 1353, 'S', 0.7660, NULL, NULL, '42900', 'N', 'N', 4675, NULL, '4214', '4290', NULL, '1886', 'S', 4620, 'SÃO JOAQUIM', 'N', '421650', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '247', NULL, '03', 'N', NULL, NULL, NULL, 501);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421660', '4207', 'SC', '4205', '4205', '42016', '42', 'SAO JOSE', NULL, '48', '88103970', '2', '8327', '8327', '20164', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 113.171, '-27,61500', '-48,62800', 8, 'S', 0.8490, NULL, NULL, '42900', 'N', 'N', 4683, NULL, '4201', '4201', NULL, '1833', 'S', 4621, 'SÃO JOSÉ', 'N', '421660', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '248', NULL, '01', 'N', NULL, NULL, NULL, 494);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421670', '4201', 'SC', '4201', '4201', '42001', '42', 'SAO JOSE DO CEDRO', NULL, '49', '89930000', '1', '8329', '8329', '20165', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 279.581, '-26,45500', '-53,49400', 731, 'S', 0.8040, NULL, NULL, '42900', 'N', 'N', 4711, NULL, '4290', '4290', NULL, '1958', 'S', 4622, 'SÃO JOSÉ DO CEDRO', 'N', '421670', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '249', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421680', '4213', 'SC', '4209', '4203', '42010', '42', 'SAO JOSE DO CERRITO', NULL, '49', '88570000', '0', '8331', '8331', '20166', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 946.243, '-27,66300', '-50,58000', 879, 'S', 0.7310, NULL, NULL, '42900', 'N', 'N', 4712, NULL, '4214', '4290', NULL, '1961', 'S', 4623, 'SÃO JOSÉ DO CERRITO', 'N', '421680', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '250', NULL, '03', 'N', NULL, NULL, NULL, 501);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421690', '4203', 'SC', '4201', '4201', '42002', '42', 'SAO LOURENCO DO OESTE', NULL, '49', '89990000', '9', '8333', '8333', '20167', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 369.478, '-26,35900', '-52,85100', 893, 'S', 0.7960, NULL, NULL, '42900', 'N', 'N', 4748, NULL, '4290', '4290', NULL, '1958', 'S', 4624, 'SÃO LOURENÇO DO OESTE', 'N', '421690', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '251', NULL, '03', 'N', NULL, NULL, NULL, 502);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421700', '4216', 'SC', '4206', '4206', '42018', '42', 'SAO LUDGERO', NULL, '48', '88730000', '6', '8335', '8335', '20168', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 107.571, '-28,32600', '-49,17700', 50, 'S', 0.8250, NULL, NULL, '42900', 'N', 'N', 4751, NULL, '4212', '4290', NULL, '1962', 'S', 4625, 'SÃO LUDGERO', 'N', '421700', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '252', NULL, '03', 'N', NULL, NULL, NULL, 495);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421710', '4216', 'SC', '4206', '4206', '42018', '42', 'SAO MARTINHO', NULL, '48', '88765000', '5', '8337', '8337', '20169', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 224.531, '-28,16500', '-48,97900', 38, 'S', 0.8160, NULL, NULL, '42900', 'N', 'N', 4767, NULL, '4212', '4290', NULL, '1962', 'S', 4626, 'SÃO MARTINHO', 'N', '421710', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '253', NULL, '03', 'N', NULL, NULL, NULL, 495);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421715', '4201', 'SC', '4201', '4201', '42002', '42', 'SAO MIGUEL DA BOA VISTA', NULL, '49', '89879000', '4', '5755', '5755', '20260', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 71.922, '-26,69000', '-53,25100', 468, 'S', 0.7540, NULL, NULL, '42900', 'N', 'N', 4776, NULL, '4290', '4290', NULL, '1993', 'S', 4627, 'SÃO MIGUEL DA BOA VISTA', 'N', '421715', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '254', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421720', '4201', 'SC', '4201', '4201', '42001', '42', 'SAO MIGUEL DO OESTE', NULL, '49', '89900000', '4', '8339', '8339', '20170', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 234.396, '-26,72500', '-53,51800', 645, 'S', 0.8380, NULL, NULL, '42900', 'N', 'N', 4774, NULL, '4290', '4290', NULL, '1953', 'S', 4628, 'SÃO MIGUEL DO OESTE', 'N', '421720', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '255', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421725', '4207', 'SC', '4205', '4205', '42016', '42', 'SAO PEDRO DE ALCANTARA', NULL, '48', '88125000', '3', '0944', NULL, '20291', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 139.635, '-27,56600', '-48,80500', 230, 'S', 0.7950, NULL, NULL, '42900', 'N', 'N', 4806, NULL, '4201', '4201', NULL, '1997', 'S', 4629, 'SÃO PEDRO DE ALCÂNTARA', 'N', '421725', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '256', NULL, '03', 'N', NULL, NULL, NULL, 494);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421730', '4201', 'SC', '4201', '4201', '42002', '42', 'SAUDADES', NULL, '49', '89868000', '3', '8341', '8341', '20171', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 205.554, '-26,92400', '-53,00300', 280, 'S', 0.8310, NULL, NULL, '42900', 'N', 'N', 4887, NULL, '4215', '4290', NULL, '1961', 'S', 4630, 'SAUDADES', 'N', '421730', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '257', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421740', '4211', 'SC', '4207', '4202', '42008', '42', 'SCHROEDER', NULL, '47', '89275000', '2', '8343', '8343', '20172', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 143.818, '-26,41300', '-49,07300', 38, 'S', 0.8380, NULL, NULL, '42900', 'N', 'N', 4889, NULL, '4206', '4205', NULL, '1964', 'S', 4631, 'SCHROEDER', 'N', '421740', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '258', NULL, '03', 'N', NULL, NULL, NULL, 498);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421750', '4210', 'SC', '4202', '4201', '42005', '42', 'SEARA', NULL, '49', '89770000', '1', '8345', '8345', '20173', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 312.540, '-27,14900', '-52,31100', 550, 'S', 0.8320, NULL, NULL, '42900', 'N', 'N', 4891, NULL, '4215', '4290', NULL, '1953', 'S', 4632, 'SEARA', 'N', '421750', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '259', NULL, '03', 'N', NULL, NULL, NULL, 487);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421755', '4202', 'SC', '4201', '4201', '42002', '42', 'SERRA ALTA', NULL, '49', '89871000', '0', '9989', '9989', '20210', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 90.444, '-26,72900', '-53,04200', 648, 'S', 0.8100, NULL, NULL, '42900', 'N', 'N', 4934, NULL, '4216', '4290', NULL, '1990', 'S', 4633, 'SERRA ALTA', 'N', '421755', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '260', NULL, '03', 'N', NULL, NULL, NULL, 499);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421760', '4215', 'SC', '4206', '4206', '42019', '42', 'SIDEROPOLIS', NULL, '48', '88860000', '0', '8347', '8347', '20174', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 262.700, '-28,59800', '-49,42400', 147, 'S', 0.8170, NULL, NULL, '42900', 'N', 'N', 4983, NULL, '4209', '4290', NULL, '1958', 'S', 4634, 'SIDERÓPOLIS', 'N', '421760', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '261', NULL, '03', 'N', NULL, NULL, NULL, 490);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421770', '4214', 'SC', '4206', '4206', '42020', '42', 'SOMBRIO', NULL, '48', '88960000', '9', '8349', '8349', '20175', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 142.745, '-29,10400', '-49,62900', 15, 'S', 0.8040, NULL, NULL, '42900', 'N', 'N', 5025, NULL, '4210', '4203', NULL, '1953', 'S', 4635, 'SOMBRIO', 'N', '421770', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '262', NULL, '03', 'N', NULL, NULL, NULL, 492);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421775', '4202', 'SC', '4201', '4201', '42002', '42', 'SUL BRASIL', NULL, '49', '89855000', '8', '5595', '5595', '20242', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 112.701, '-26,73600', '-52,96500', 418, 'S', 0.7710, NULL, NULL, '42900', 'N', 'N', 5038, NULL, '4216', '4290', NULL, '1993', 'S', 4636, 'SUL BRASIL', 'N', '421775', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '263', NULL, '03', 'N', NULL, NULL, NULL, 499);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421780', '4204', 'SC', '4203', '4204', '42011', '42', 'TAIO', NULL, '47', '89190000', '8', '8351', '8351', '20176', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 693.025, '-27,11600', '-49,99800', 359, 'S', 0.8090, NULL, NULL, '42900', 'N', 'N', 5067, NULL, '4217', '4290', NULL, '1948', 'S', 4637, 'TAIÓ', 'N', '421780', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '264', NULL, '03', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421790', '4209', 'SC', '4202', '4201', '42004', '42', 'TANGARA', NULL, '49', '89642000', '7', '8353', '8353', '20177', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 389.184, '-27,10500', '-51,24700', 641, 'S', 0.8120, NULL, NULL, '42900', 'N', 'N', 5081, NULL, '4290', '4290', NULL, '1948', 'S', 4638, 'TANGARÁ', 'N', '421790', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '265', NULL, '03', 'N', NULL, NULL, NULL, 489);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421795', '4201', 'SC', '4201', '4201', '42002', '42', 'TIGRINHOS', NULL, '49', '89875000', '6', '0946', NULL, '20292', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 57.439, '-26,68800', '-53,15800', 732, 'S', 0.7410, NULL, NULL, '42900', 'N', 'N', 5172, NULL, '4290', '4290', NULL, '1997', 'S', 4639, 'TIGRINHOS', 'N', '421795', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '266', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421800', '4207', 'SC', '4205', '4205', '42015', '42', 'TIJUCAS', NULL, '48', '88200000', '4', '8355', '8355', '20178', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 276.622, '-27,24100', '-48,63400', 2, 'S', 0.8350, NULL, NULL, '42900', 'N', 'N', 5173, NULL, '4202', '4201', NULL, '1859', 'S', 4640, 'TIJUCAS', 'N', '421800', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '267', NULL, '03', 'N', NULL, NULL, NULL, 494);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421810', '4214', 'SC', '4206', '4206', '42020', '42', 'TIMBE DO SUL', NULL, '48', '88940000', '3', '8393', '8393', '20197', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 333.426, '-28,83000', '-49,84700', 123, 'S', 0.7730, NULL, NULL, '42900', 'N', 'N', 5177, NULL, '4210', '4290', NULL, '1967', 'S', 4641, 'TIMBÉ DO SUL', 'N', '421810', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '268', NULL, '03', 'N', NULL, NULL, NULL, 492);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421820', '4206', 'SC', '4203', '4204', '42012', '42', 'TIMBO', NULL, '47', '89120000', '2', '8357', '8357', '20179', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 127.251, '-26,82300', '-49,27200', 68, 'S', 0.8430, NULL, NULL, '42900', 'N', 'N', 5179, NULL, '4203', '4202', NULL, '1934', 'S', 4642, 'TIMBÓ', 'N', '421820', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '269', NULL, '03', 'N', NULL, NULL, NULL, 496);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421825', '4209', 'SC', '4202', '4202', '42006', '42', 'TIMBO GRANDE', NULL, '49', '89545000', '1', '9971', '9971', '20211', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 596.942, '-26,61500', '-50,67400', 925, 'S', 0.6800, NULL, NULL, '42900', 'S', 'N', 5180, NULL, '4290', '4290', NULL, '1990', 'S', 4643, 'TIMBÓ GRANDE', 'N', '421825', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '270', NULL, '03', 'N', NULL, NULL, NULL, 489);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421830', '4212', 'SC', '4208', '4202', '42006', '42', 'TRES BARRAS', NULL, '47', '89490000', '1', '8359', '8359', '20180', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 438.066, '-26,10600', '-50,32200', 802, 'S', 0.7580, NULL, NULL, '42900', 'N', 'N', 5218, NULL, '4206', '4290', NULL, '1960', 'S', 4644, 'TRÊS BARRAS', 'N', '421830', 'N', 'N', 'S', NULL, 70, 'N', 'N', 'N', '271', NULL, '03', 'N', NULL, NULL, NULL, 500);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421835', '4215', 'SC', '4206', '4206', '42019', '42', 'TREVISO', NULL, '48', '88862000', '0', '0948', NULL, '20293', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 157.667, '-28,51600', '-49,45800', 147, 'S', 0.8060, NULL, NULL, '42900', 'N', 'N', 5233, NULL, '4210', '4290', NULL, '1997', 'S', 4645, 'TREVISO', 'N', '421835', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '272', NULL, '03', 'N', NULL, NULL, NULL, 490);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421840', '4216', 'SC', '4206', '4206', '42018', '42', 'TREZE DE MAIO', NULL, '48', '88710000', '0', '8361', '8361', '20181', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 161.081, '-28,55900', '-49,14800', 190, 'S', 0.7960, NULL, NULL, '42900', 'N', 'N', 5234, NULL, '4212', '4290', NULL, '1961', 'S', 4646, 'TREZE DE MAIO', 'N', '421840', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '273', NULL, '03', 'N', NULL, NULL, NULL, 495);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421850', '4208', 'SC', '4202', '4201', '42004', '42', 'TREZE TILIAS', NULL, '49', '89650000', '9', '8363', '8363', '20182', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 185.205, '-27,00200', '-51,40600', 796, 'S', 0.8130, NULL, NULL, '42900', 'N', 'N', 5235, NULL, '4290', '4290', NULL, '1963', 'S', 4647, 'TREZE TÍLIAS', 'N', '421850', 'N', 'N', 'S', NULL, 33, 'N', 'N', 'N', '274', NULL, '03', 'N', NULL, NULL, NULL, 497);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421860', '4204', 'SC', '4203', '4204', '42011', '42', 'TROMBUDO CENTRAL', NULL, '47', '89176000', '8', '8365', '8365', '20183', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 102.796, '-27,29900', '-49,79000', 350, 'S', 0.8180, NULL, NULL, '42900', 'N', 'N', 5245, NULL, '4218', '4290', NULL, '1958', 'S', 4648, 'TROMBUDO CENTRAL', 'N', '421860', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '275', NULL, '03', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421870', '4216', 'SC', '4206', '4206', '42018', '42', 'TUBARAO', NULL, '48', '88701970', '7', '8367', '8367', '20184', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 300.273, '-28,46700', '-49,00700', 9, 'S', 0.8420, NULL, NULL, '42900', 'N', 'N', 5246, NULL, '4211', '4290', NULL, '1870', 'S', 4649, 'TUBARÃO', 'N', '421870', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '276', NULL, '02', 'N', NULL, NULL, NULL, 495);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421875', '4201', 'SC', '4201', '4201', '42001', '42', 'TUNAPOLIS', NULL, '49', '89898000', '6', '9991', '9991', '20217', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 132.909, '-26,96900', '-53,63900', 430, 'S', 0.8210, NULL, NULL, '42900', 'N', 'N', 5254, NULL, '4290', '4290', NULL, '1990', 'S', 4650, 'TUNÁPOLIS', 'N', '421875', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '277', NULL, '03', 'N', NULL, NULL, NULL, 491);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421880', '4214', 'SC', '4206', '4206', '42020', '42', 'TURVO', NULL, '48', '88930000', '6', '8369', '8369', '20185', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 233.941, '-28,92600', '-49,67900', 38, 'S', 0.8210, NULL, NULL, '42900', 'N', 'N', 5280, NULL, '4210', '4290', NULL, '1948', 'S', 4651, 'TURVO', 'N', '421880', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '278', NULL, '03', 'N', NULL, NULL, NULL, 492);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421885', '4202', 'SC', '4201', '4201', '42002', '42', 'UNIAO DO OESTE', NULL, '49', '89845000', '5', '9973', '9973', '20212', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 93.058, '-26,76100', '-52,85500', 462, 'S', 0.8060, NULL, NULL, '42900', 'N', 'N', 5320, NULL, '4216', '4290', NULL, '1989', 'S', 4652, 'UNIÃO DO OESTE', 'N', '421885', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '279', NULL, '03', 'N', NULL, NULL, NULL, 499);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421890', '4213', 'SC', '4209', '4203', '42010', '42', 'URUBICI', NULL, '49', '88650000', '5', '8371', '8371', '20186', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1019.232, '-28,01500', '-49,59200', 915, 'S', 0.7850, NULL, NULL, '42900', 'N', 'N', 5336, NULL, '4214', '4290', NULL, '1956', 'S', 4653, 'URUBICI', 'N', '421890', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '280', NULL, '03', 'N', NULL, NULL, NULL, 501);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421895', '4213', 'SC', '4209', '4203', '42010', '42', 'URUPEMA', NULL, '49', '88625000', '4', '9975', '9975', '20213', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 353.126, '-27,95300', '-49,87300', 1350, 'S', 0.7840, NULL, NULL, '42900', 'N', 'N', 5347, NULL, '4214', '4290', NULL, '1989', 'S', 4654, 'URUPEMA', 'N', '421895', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '281', NULL, '03', 'N', NULL, NULL, NULL, 501);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421900', '4215', 'SC', '4206', '4206', '42019', '42', 'URUSSANGA', NULL, '48', '88840000', '2', '8373', '8373', '20187', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 240.476, '-28,51800', '-49,32100', 49, 'S', 0.8450, NULL, NULL, '42900', 'N', 'N', 5349, NULL, '4210', '4290', NULL, '1900', 'S', 4655, 'URUSSANGA', 'N', '421900', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '282', NULL, '03', 'N', NULL, NULL, NULL, 490);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421910', '4203', 'SC', '4201', '4201', '42003', '42', 'VARGEAO', NULL, '49', '89690000', '1', '8375', '8375', '20188', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 166.450, '-26,86400', '-52,15500', 890, 'S', 0.8040, NULL, NULL, '42900', 'N', 'N', 5367, NULL, '4290', '4290', NULL, '1964', 'S', 4656, 'VARGEÃO', 'N', '421910', 'N', 'N', 'S', NULL, 33, 'N', 'N', 'N', '283', NULL, '03', 'N', NULL, NULL, NULL, 502);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421915', '4208', 'SC', '4202', '4203', '42009', '42', 'VARGEM', NULL, '49', '89638000', '0', '5563', '5563', '20243', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 350.124, '-27,48900', '-50,97500', 768, 'S', 0.7680, NULL, NULL, '42900', 'N', 'N', 5368, NULL, '4290', '4290', NULL, '1993', 'S', 4657, 'VARGEM', 'N', '421915', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '284', NULL, '03', 'N', NULL, NULL, NULL, 497);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421917', '4208', 'SC', '4202', '4201', '42004', '42', 'VARGEM BONITA', NULL, '49', '89675000', '6', '5565', '5565', '20261', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 298.610, '-27,00700', '-51,74000', 880, 'S', 0.7910, NULL, NULL, '42900', 'N', 'N', 5372, NULL, '4290', '4290', NULL, '1993', 'S', 4658, 'VARGEM BONITA', 'N', '421917', 'N', 'N', 'S', NULL, 33, 'S', 'N', 'N', '285', NULL, '03', 'N', NULL, NULL, NULL, 497);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421920', '4204', 'SC', '4203', '4204', '42014', '42', 'VIDAL RAMOS', NULL, '47', '88443000', '0', '8377', '8377', '20189', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 339.068, '-27,39200', '-49,35600', 370, 'S', 0.7660, NULL, NULL, '42900', 'N', 'N', 5436, NULL, '4218', '4290', NULL, '1956', 'S', 4659, 'VIDAL RAMOS', 'N', '421920', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '286', NULL, '03', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421930', '4209', 'SC', '4202', '4201', '42004', '42', 'VIDEIRA', NULL, '49', '89560000', '9', '8379', '8379', '20190', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 377.852, '-27,00800', '-51,15200', 750, 'S', 0.8510, NULL, NULL, '42900', 'N', 'N', 5437, NULL, '4290', '4290', NULL, '1943', 'S', 4660, 'VIDEIRA', 'N', '421930', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '287', NULL, '03', 'N', NULL, NULL, NULL, 489);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421935', '4204', 'SC', '4203', '4204', '42011', '42', 'VITOR MEIRELES', NULL, '47', '89148000', '8', '9977', '9977', '20214', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 371.560, '-26,88100', '-49,83300', 370, 'S', 0.7700, NULL, NULL, '42900', 'N', 'N', 5472, NULL, '4218', '4290', NULL, '1990', 'S', 4661, 'VITOR MEIRELES', 'N', '421935', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '288', NULL, '03', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421940', '4204', 'SC', '4203', '4204', '42011', '42', 'WITMARSUM', NULL, '47', '89157000', '8', '8381', '8381', '20191', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 150.798, '-26,92600', '-49,79600', 370, 'S', 0.8070, NULL, NULL, '42900', 'N', 'N', 5494, NULL, '4218', '4290', NULL, '1962', 'S', 4662, 'WITMARSUM', 'N', '421940', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '289', NULL, '03', 'N', NULL, NULL, NULL, 488);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421950', '4203', 'SC', '4201', '4201', '42003', '42', 'XANXERE', NULL, '49', '89820000', '7', '8383', '8383', '20192', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 377.553, '-26,87700', '-52,40400', 800, 'S', 0.8150, NULL, NULL, '42900', 'N', 'N', 5498, NULL, '4215', '4290', NULL, '1953', 'S', 4663, 'XANXERÊ', 'N', '421950', 'N', 'N', 'S', NULL, 33, 'N', 'N', 'N', '290', NULL, '03', 'N', NULL, NULL, NULL, 502);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421960', '4210', 'SC', '4202', '4201', '42005', '42', 'XAVANTINA', NULL, '49', '89780000', '6', '8385', '8385', '20193', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 215.069, '-27,06900', '-52,34200', 545, 'S', 0.7690, NULL, NULL, '42900', 'N', 'N', 5500, NULL, '4216', '4290', NULL, '1963', 'S', 4664, 'XAVANTINA', 'N', '421960', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '291', NULL, '03', 'N', NULL, NULL, NULL, 487);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421970', '4203', 'SC', '4201', '4201', '42003', '42', 'XAXIM', NULL, '49', '89825000', '5', '8387', '8387', '20194', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 294.715, '-26,96200', '-52,53500', 770, 'S', 0.8090, NULL, NULL, '42900', 'N', 'N', 5501, NULL, '4215', '4290', NULL, '1953', 'S', 4665, 'XAXIM', 'N', '421970', 'N', 'N', 'S', NULL, 33, 'N', 'N', 'N', '292', NULL, '03', 'N', NULL, NULL, NULL, 502);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('421985', '4208', 'SC', '4202', '4203', '42009', '42', 'ZORTEA', NULL, '49', '89633000', '3', '0950', '0950', '20294', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 190.149, '-27,45100', '-51,55500', 680, 'S', 0.7980, NULL, NULL, '42900', 'N', 'N', 5508, NULL, '4290', '4290', NULL, '1997', 'S', 4666, 'ZORTÉA', 'N', '421985', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '293', NULL, '03', 'N', NULL, NULL, NULL, 497);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430005', '4306', 'RS', '4304', '4301', '43010', '43', 'AGUA SANTA', NULL, '54', '99965000', '9', '8499', '8499', '19247', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 291.792, '-28,17700', '-52,03400', 650, 'S', 0.8020, NULL, NULL, '43900', 'N', 'N', 61, NULL, '4390', '4390', NULL, '1989', 'S', 3907, 'ÁGUA SANTA', 'N', '430005', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '2', NULL, '03', 'N', NULL, NULL, NULL, 474);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430010', '4304', 'RS', '4301', '4303', '43019', '43', 'AGUDO', NULL, '55', '96540000', '9', '8501', '8501', '19001', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 536.117, '-29,64500', '-53,24000', 83, 'S', 0.7860, NULL, NULL, '43900', 'N', 'N', 75, NULL, '4390', '4390', NULL, '1959', 'S', 3908, 'AGUDO', 'N', '430010', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '3', NULL, '03', 'N', NULL, NULL, NULL, 457);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430020', '4317', 'RS', '4303', '4301', '43008', '43', 'AJURICABA', NULL, '55', '98750000', '8', '8503', '8503', '19002', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 323.239, '-28,23900', '-53,77100', 336, 'S', 0.7810, NULL, NULL, '43900', 'N', 'N', 85, NULL, '4390', '4390', NULL, '1965', 'S', 3909, 'AJURICABA', 'N', '430020', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '4', NULL, '03', 'N', NULL, NULL, NULL, 469);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430030', '4314', 'RS', '4303', '4301', '43001', '43', 'ALECRIM', NULL, '55', '98950000', '7', '8505', '8505', '19003', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 314.745, '-27,65500', '-54,76400', 311, 'S', 0.7430, NULL, NULL, '43900', 'N', 'N', 101, NULL, '4390', '4390', NULL, '1963', 'S', 3910, 'ALECRIM', 'N', '430030', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '5', NULL, '03', 'N', NULL, NULL, NULL, 470);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430040', '4310', 'RS', '4301', '4306', '43029', '43', 'ALEGRETE', NULL, '55', '97600970', '6', '8507', '8507', '19004', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 7803.967, '-29,78300', '-55,79200', 102, 'S', 0.7930, NULL, NULL, '43900', 'N', 'N', 103, NULL, '4390', '4390', NULL, '1831', 'S', 3911, 'ALEGRETE', 'N', '430040', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '6', NULL, '02', 'N', NULL, NULL, NULL, 459);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('422000', NULL, 'SC', NULL, NULL, NULL, NULL, 'BALNEARIO RINCAO', NULL, NULL, NULL, NULL, '1192', NULL, NULL, NULL, 'ATIVO', NULL, NULL, NULL, NULL, 'N', 'N', NULL, 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, NULL, 'S', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2013', NULL, NULL, NULL, 'N', NULL, NULL, NULL, 'S', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, NULL, 490);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430045', '4314', 'RS', '4303', '4301', '43008', '43', 'ALEGRIA', NULL, '55', '98905000', '5', '8497', '8497', '19248', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 172.686, '-27,82700', '-54,05700', 383, 'S', 0.7450, NULL, NULL, '43900', 'N', 'N', 105, NULL, '4390', '4390', NULL, '1989', 'S', 3912, 'ALEGRIA', 'N', '430045', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '7', NULL, '03', 'N', NULL, NULL, NULL, 470);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430047', '4306', 'RS', '4304', '4301', '43009', '43', 'ALMIRANTE TAMANDARE DO SUL', NULL, '65', '99523000', '1', '1120', NULL, '19472', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 265.368, '-28,11300', '-52,90900', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5634, NULL, '4390', '4390', NULL, '2001', 'S', 5563, 'ALMIRANTE TAMANDARÉ DO SUL', 'N', '430047', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '8', NULL, '03', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430050', '4319', 'RS', '4304', '4301', '43003', '43', 'ALPESTRE', NULL, '55', '98480000', '5', '8509', '8509', '19005', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 328.749, '-27,24900', '-53,03500', 467, 'S', 0.7140, NULL, NULL, '43900', 'N', 'N', 127, NULL, '4390', '4390', NULL, '1963', 'S', 3913, 'ALPESTRE', 'N', '430050', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '9', NULL, '03', 'N', NULL, NULL, NULL, 471);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430055', '4306', 'RS', '4304', '4301', '43011', '43', 'ALTO ALEGRE', NULL, '54', '99430000', '4', '8495', '8495', '19249', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 114.523, '-28,77300', '-52,99000', 370, 'S', 0.7970, NULL, NULL, '43900', 'N', 'N', 138, NULL, '4390', '4390', NULL, '1989', 'S', 3914, 'ALTO ALEGRE', 'N', '430055', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '10', NULL, '03', 'N', NULL, NULL, NULL, 475);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430057', '4305', 'RS', '4305', '4305', '43023', '43', 'ALTO FELIZ', NULL, '51', '95773000', '0', '6045', '6045', '19337', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 79.204, '-29,39200', '-51,31200', 285, 'S', 0.8080, NULL, NULL, '43900', 'N', 'N', 149, NULL, '4390', '4390', NULL, '1993', 'S', 3915, 'ALTO FELIZ', 'N', '430057', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '11', NULL, '03', 'N', NULL, NULL, NULL, 482);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430060', '4302', 'RS', '4302', '4305', '43026', '43', 'ALVORADA', NULL, '51', '94801970', '4', '8511', '8511', '19006', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 70.811, '-29,99000', '-51,08400', 17, 'S', 0.7680, NULL, NULL, '43900', 'N', 'N', 175, NULL, '4301', '4301', NULL, '1965', 'S', 3916, 'ALVORADA', 'N', '430060', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '12', NULL, '01', 'N', NULL, NULL, NULL, 466);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430063', '4303', 'RS', '4306', '4307', '43032', '43', 'AMARAL FERRADOR', NULL, '51', '96635000', '8', '8493', '8493', '19250', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 506.460, '-30,87500', '-52,25300', 140, 'S', 0.7270, NULL, NULL, '43900', 'N', 'N', 187, NULL, '4390', '4390', NULL, '1989', 'S', 3917, 'AMARAL FERRADOR', 'N', '430063', 'N', 'N', 'S', NULL, 104, 'N', 'N', 'N', '13', NULL, '03', 'N', NULL, NULL, NULL, 477);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430064', '4319', 'RS', '4304', '4301', '43003', '43', 'AMETISTA DO SUL', NULL, '55', '98465000', '6', '5969', '5969', '19338', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 93.490, '-27,36100', '-53,18200', 505, 'S', 0.7540, NULL, NULL, '43900', 'N', 'N', 199, NULL, '4390', '4390', NULL, '1993', 'S', 3918, 'AMETISTA DO SUL', 'N', '430064', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '14', NULL, '03', 'N', NULL, NULL, NULL, 471);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430066', '4306', 'RS', '4304', '4302', '43014', '43', 'ANDRE DA ROCHA', NULL, '54', '95310000', '1', '8491', '8491', '19251', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 329.736, '-28,63100', '-51,57100', 700, 'S', 0.8150, NULL, NULL, '43900', 'N', 'N', 228, NULL, '4390', '4390', NULL, '1989', 'S', 3919, 'ANDRÉ DA ROCHA', 'N', '430066', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '15', NULL, '03', 'N', NULL, NULL, NULL, 474);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430070', '4316', 'RS', '4307', '4302', '43014', '43', 'ANTA GORDA', NULL, '51', '95980000', '3', '8513', '8513', '19007', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 242.963, '-28,97000', '-52,00500', 411, 'S', 0.8210, NULL, NULL, '43900', 'N', 'N', 250, NULL, '4390', '4390', NULL, '1963', 'S', 3920, 'ANTA GORDA', 'N', '430070', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '16', NULL, '03', 'N', NULL, NULL, NULL, 485);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430080', '4305', 'RS', '4305', '4302', '43016', '43', 'ANTONIO PRADO', NULL, '54', '95250000', '2', '8515', '8515', '19008', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 347.616, '-28,85800', '-51,28300', 658, 'S', 0.8410, NULL, NULL, '43900', 'N', 'N', 263, NULL, '4390', '4390', NULL, '1899', 'S', 3921, 'ANTÔNIO PRADO', 'N', '430080', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '17', NULL, '03', 'N', NULL, NULL, NULL, 482);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430085', '4302', 'RS', '4302', '4305', '43028', '43', 'ARAMBARE', NULL, '51', '96178000', '1', '5779', '5779', '19339', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 519.124, '-30,91500', '-51,49800', 5, 'S', 0.7430, NULL, NULL, '43900', 'N', 'N', 321, NULL, '4390', '4390', NULL, '1993', 'S', 3922, 'ARAMBARÉ', 'N', '430085', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '18', NULL, '03', 'N', NULL, NULL, NULL, 465);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430087', '4301', 'RS', '4302', '4305', '43026', '43', 'ARARICA', NULL, '51', '93880000', '7', '0952', NULL, '19431', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 35.292, '-29,61400', '-50,92500', 53, 'S', 0.7840, NULL, NULL, '43900', 'N', 'N', 343, NULL, '4301', '4301', NULL, '1997', 'S', 3923, 'ARARICÁ', 'N', '430087', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '19', NULL, '01', 'N', NULL, NULL, NULL, 463);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430090', '4311', 'RS', '4304', '4301', '43004', '43', 'ARATIBA', NULL, '54', '99770000', '1', '8517', '8517', '19009', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 341.072, '-27,39400', '-52,30000', 420, 'S', 0.7920, NULL, NULL, '43900', 'N', 'N', 350, NULL, '4390', '4390', NULL, '1955', 'S', 3924, 'ARATIBA', 'N', '430090', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '20', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430100', '4316', 'RS', '4307', '4304', '43021', '43', 'ARROIO DO MEIO', NULL, '51', '95940000', '8', '8519', '8519', '19010', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 157.955, '-29,40100', '-51,94500', 54, 'S', 0.8370, NULL, NULL, '43900', 'N', 'N', 389, NULL, '4390', '4390', NULL, '1934', 'S', 3925, 'ARROIO DO MEIO', 'N', '430100', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '21', NULL, '03', 'N', NULL, NULL, NULL, 485);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430105', '4318', 'RS', '4302', '4305', '43027', '43', 'ARROIO DO SAL', NULL, '51', '95585000', '7', '8489', '8489', '19252', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 120.939, '-29,55100', '-49,88900', 6, 'S', 0.8130, NULL, NULL, '43900', 'N', 'N', 390, NULL, '4302', '4390', NULL, '1989', 'S', 3926, 'ARROIO DO SAL', 'N', '430105', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '23', NULL, '03', 'N', NULL, NULL, NULL, 460);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430107', '4303', 'RS', '4306', '4307', '43033', '43', 'ARROIO DO PADRE', NULL, '53', '96155000', '3', '1122', NULL, '19473', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 124.321, '-31,44200', '-52,42200', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5636, NULL, '4304', '4390', NULL, '2001', 'S', 5528, 'ARROIO DO PADRE', 'N', '430107', 'N', 'N', 'S', NULL, 104, 'N', 'N', 'N', '22', NULL, '03', 'N', NULL, NULL, NULL, 477);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430110', '4302', 'RS', '4302', '4305', '43025', '43', 'ARROIO DOS RATOS', NULL, '51', '96740000', '7', '8521', '8521', '19011', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 425.938, '-30,07700', '-51,72900', 69, 'S', 0.7730, NULL, NULL, '43900', 'N', 'N', 392, NULL, '4301', '4390', NULL, '1964', 'S', 3928, 'ARROIO DOS RATOS', 'N', '430110', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '25', NULL, '01', 'N', NULL, NULL, NULL, 465);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430120', '4308', 'RS', '4307', '4304', '43020', '43', 'ARROIO DO TIGRE', NULL, '51', '96950000', '6', '8523', '8523', '19012', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 318.524, '-29,33300', '-53,09300', 409, 'S', 0.7640, NULL, NULL, '43900', 'N', 'N', 391, NULL, '4390', '4390', NULL, '1963', 'S', 3927, 'ARROIO DO TIGRE', 'N', '430120', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '24', NULL, '03', 'N', NULL, NULL, NULL, 483);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430130', '4303', 'RS', '4306', '4307', '43034', '43', 'ARROIO GRANDE', NULL, '53', '96330000', '5', '8525', '8525', '19013', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2518.480, '-32,23800', '-53,08700', 22, 'S', 0.7580, NULL, NULL, '43900', 'N', 'N', 393, NULL, '4390', '4390', NULL, '1873', 'S', 3929, 'ARROIO GRANDE', 'N', '430130', 'N', 'N', 'S', NULL, 104, 'N', 'N', 'N', '26', NULL, '03', 'N', NULL, NULL, NULL, 477);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430140', '4306', 'RS', '4307', '4302', '43014', '43', 'ARVOREZINHA', NULL, '51', '95995000', '4', '8527', '8527', '19014', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 271.643, '-28,87200', '-52,17500', 750, 'S', 0.7980, NULL, NULL, '43900', 'N', 'N', 399, NULL, '4390', '4390', NULL, '1959', 'S', 3930, 'ARVOREZINHA', 'N', '430140', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '27', NULL, '03', 'N', NULL, NULL, NULL, 475);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430150', '4317', 'RS', '4303', '4301', '43008', '43', 'AUGUSTO PESTANA', NULL, '55', '98740000', '3', '8529', '8529', '19015', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 347.439, '-28,51700', '-53,99200', 385, 'S', 0.7860, NULL, NULL, '43900', 'N', 'N', 422, NULL, '4390', '4390', NULL, '1965', 'S', 3931, 'AUGUSTO PESTANA', 'N', '430150', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '28', NULL, '03', 'N', NULL, NULL, NULL, 469);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430155', '4311', 'RS', '4304', '4301', '43004', '43', 'AUREA', NULL, '54', '99835000', '2', '8487', '8487', '19253', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 158.291, '-27,69800', '-52,04900', 600, 'S', 0.7420, NULL, NULL, '43900', 'N', 'N', 423, NULL, '4390', '4390', NULL, '1989', 'S', 3932, 'ÁUREA', 'N', '430155', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '29', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430160', '4307', 'RS', '4306', '4306', '43031', '43', 'BAGE', NULL, '53', '96400970', '2', '8531', '8531', '19016', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4095.526, '-31,33100', '-54,10700', 212, 'S', 0.8020, NULL, NULL, '43900', 'N', 'N', 447, NULL, '4390', '4390', NULL, '1846', 'S', 3933, 'BAGÉ', 'N', '430160', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '30', NULL, '01', 'N', NULL, NULL, NULL, 478);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430163', '4318', 'RS', '4302', '4305', '43027', '43', 'BALNEARIO PINHAL', NULL, '51', '95599000', '6', '0954', NULL, '19432', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 103.759, '-30,24700', '-50,23300', 100, 'S', 0.7920, NULL, NULL, '43900', 'N', 'N', 464, NULL, '4302', '4390', NULL, '1997', 'S', 3934, 'BALNEÁRIO PINHAL', 'N', '430163', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '31', NULL, '03', 'N', NULL, NULL, NULL, 461);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430165', '4301', 'RS', '4302', '4305', '43023', '43', 'BARAO', NULL, '51', '95730000', '1', '8485', '8485', '19254', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 124.497, '-29,37700', '-51,49600', 642, 'S', 0.8070, NULL, NULL, '43900', 'N', 'N', 480, NULL, '4390', '4390', NULL, '1989', 'S', 3935, 'BARÃO', 'N', '430165', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '32', NULL, '03', 'N', NULL, NULL, NULL, 464);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430170', '4311', 'RS', '4304', '4301', '43004', '43', 'BARAO DE COTEGIPE', NULL, '54', '99740000', '1', '8533', '8533', '19017', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 259.907, '-27,62100', '-52,38000', 687, 'S', 0.7840, NULL, NULL, '43900', 'N', 'N', 483, NULL, '4390', '4390', NULL, '1964', 'S', 3936, 'BARÃO DE COTEGIPE', 'N', '430170', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '33', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430175', '4302', 'RS', '4302', '4305', '43025', '43', 'BARAO DO TRIUNFO', NULL, '51', '96735000', '0', '5771', '5771', '19340', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 436.679, '-30,38800', '-51,73400', 258, 'S', 0.7430, NULL, NULL, '43900', 'N', 'N', 487, NULL, '4390', '4390', NULL, '1993', 'S', 3937, 'BARÃO DO TRIUNFO', 'N', '430175', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '34', NULL, '03', 'N', NULL, NULL, NULL, 465);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430180', '4306', 'RS', '4304', '4301', '43005', '43', 'BARRACAO', NULL, '54', '95370000', '0', '8535', '8535', '19018', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 516.288, '-27,67200', '-51,46100', 764, 'S', 0.7370, NULL, NULL, '43900', 'N', 'N', 530, NULL, '4390', '4390', NULL, '1964', 'S', 3943, 'BARRACÃO', 'N', '430180', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '40', NULL, '03', 'N', NULL, NULL, NULL, 474);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430185', '4319', 'RS', '4303', '4301', '43002', '43', 'BARRA DO GUARITA', NULL, '55', '98530000', '9', '6069', '6069', '19341', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 64.590, '-27,19200', '-53,71000', 194, 'S', 0.7650, NULL, NULL, '43900', 'N', 'N', 515, NULL, '4390', '4390', NULL, '1993', 'S', 3938, 'BARRA DO GUARITA', 'N', '430185', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '35', NULL, '03', 'N', NULL, NULL, NULL, 471);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430187', '4310', 'RS', '4301', '4306', '43029', '43', 'BARRA DO QUARAI', NULL, '55', '97538000', '5', '0956', '0956', '19433', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1056.146, '-30,20700', '-57,55500', 35, 'S', 0.7770, NULL, NULL, '43900', 'N', 'N', 520, NULL, '4390', '4390', NULL, '1997', 'S', 3939, 'BARRA DO QUARAÍ', 'N', '430187', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '36', NULL, '03', 'N', NULL, NULL, NULL, 459);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430190', '4302', 'RS', '4302', '4305', '43028', '43', 'BARRA DO RIBEIRO', NULL, '51', '96790000', '9', '8537', '8537', '19019', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 730.816, '-30,29100', '-51,30100', 5, 'S', 0.7940, NULL, NULL, '43900', 'N', 'N', 521, NULL, '4390', '4390', NULL, '1959', 'S', 3940, 'BARRA DO RIBEIRO', 'N', '430190', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '37', NULL, '03', 'N', NULL, NULL, NULL, 465);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430192', '4311', 'RS', '4304', '4301', '43004', '43', 'BARRA DO RIO AZUL', NULL, '54', '99795000', '5', '5959', '5959', '19342', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 147.571, '-27,40900', '-52,41000', 438, 'S', 0.7840, NULL, NULL, '43900', 'N', 'N', 522, NULL, '4390', '4390', NULL, '1993', 'S', 3941, 'BARRA DO RIO AZUL', 'N', '430192', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '38', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430195', '4315', 'RS', '4304', '4301', '43009', '43', 'BARRA FUNDA', NULL, '54', '99585000', '8', '5943', '5943', '19343', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 60.033, '-27,92300', '-53,03900', 385, 'S', 0.8130, NULL, NULL, '43900', 'N', 'N', 526, NULL, '4390', '4390', NULL, '1993', 'S', 3942, 'BARRA FUNDA', 'N', '430195', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '39', NULL, '03', 'N', NULL, NULL, NULL, 476);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430200', '4306', 'RS', '4307', '4301', '43013', '43', 'BARROS CASSAL', NULL, '54', '99360000', '6', '8539', '8539', '19020', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 648.897, '-29,09300', '-52,58300', 627, 'S', 0.6950, NULL, NULL, '43900', 'S', 'N', 547, NULL, '4390', '4390', NULL, '1963', 'S', 3944, 'BARROS CASSAL', 'N', '430200', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '41', NULL, '03', 'N', NULL, NULL, NULL, 475);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430205', '4311', 'RS', '4304', '4301', '43004', '43', 'BENJAMIN CONSTANT DO SUL', NULL, '54', '99650000', '5', '0958', NULL, '19434', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 132.396, '-27,51000', '-52,59800', 675, 'S', 0.6660, NULL, NULL, '43900', 'S', 'N', 594, NULL, '4390', '4390', NULL, '1997', 'S', 3945, 'BENJAMIN CONSTANT DO SUL', 'N', '430205', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '42', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430210', '4305', 'RS', '4305', '4302', '43016', '43', 'BENTO GONCALVES', NULL, '54', '95700000', '5', '8541', '8541', '19021', NULL, 'ATIVO', 'N', 'N', NULL, 'PINTO BANDEIRA            ', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 382.513, '-29,17100', '-51,51900', 691, 'S', 0.8700, NULL, NULL, '43900', 'N', 'N', 597, NULL, '4303', '4302', NULL, '1890', 'S', 3946, 'BENTO GONÇALVES', 'N', '430210', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '43', NULL, '01', 'N', NULL, NULL, NULL, 481);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430215', '4315', 'RS', '4304', '4301', '43009', '43', 'BOA VISTA DAS MISSOES', NULL, '55', '98335000', '4', '5981', '5981', '19344', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 195.358, '-27,66300', '-53,31400', 596, 'S', 0.7670, NULL, NULL, '43900', 'N', 'N', 637, NULL, '4390', '4390', NULL, '1993', 'S', 3947, 'BOA VISTA DAS MISSÕES', 'N', '430215', 'N', 'N', 'S', NULL, 56, 'S', 'N', 'N', '44', NULL, '03', 'N', NULL, NULL, NULL, 476);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430220', '4314', 'RS', '4303', '4301', '43002', '43', 'BOA VISTA DO BURICA', NULL, '55', '98918000', '4', '8543', '8543', '19022', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 108.732, '-27,66900', '-54,11000', 291, 'S', 0.8330, NULL, NULL, '43900', 'N', 'N', 638, NULL, '4390', '4390', NULL, '1963', 'S', 3948, 'BOA VISTA DO BURICÁ', 'N', '430220', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '45', NULL, '03', 'N', NULL, NULL, NULL, 470);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430222', '4309', 'RS', '4303', '4301', '43011', '43', 'BOA VISTA DO CADEADO', NULL, '55', '98118000', '0', '1124', NULL, '19474', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 701.111, '-28,60700', '-53,81500', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5638, NULL, '4390', '4390', NULL, '2001', 'S', 5529, 'BOA VISTA DO CADEADO', 'N', '430222', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '46', NULL, '03', 'N', NULL, NULL, NULL, 468);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430223', '4309', 'RS', '4303', '4301', '43011', '43', 'BOA VISTA DO INCRA', NULL, '55', '98120000', '8', '1126', NULL, '19475', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 503.475, '-28,81900', '-53,38700', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5640, NULL, '4390', '4390', NULL, '2001', 'S', 5530, 'BOA VISTA DO INCRA', 'N', '430223', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '47', NULL, '03', 'N', NULL, NULL, NULL, 468);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430225', '4305', 'RS', '4305', '4302', '43016', '43', 'BOA VISTA DO SUL', NULL, '54', '95727000', '3', '0960', NULL, '19435', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 94.349, '-29,35100', '-51,67600', 460, 'S', 0.8320, NULL, NULL, '43900', 'N', 'N', 641, NULL, '4390', '4390', NULL, '1997', 'S', 3949, 'BOA VISTA DO SUL', 'N', '430225', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '48', NULL, '03', 'N', NULL, NULL, NULL, 481);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430230', '4305', 'RS', '4305', '4302', '43015', '43', 'BOM JESUS', NULL, '54', '95290000', '3', '8545', '8545', '19023', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2625.681, '-28,66800', '-50,41700', 1046, 'S', 0.7500, NULL, NULL, '43900', 'N', 'N', 664, NULL, '4390', '4390', NULL, '1913', 'S', 3950, 'BOM JESUS', 'N', '430230', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '49', NULL, '03', 'N', NULL, NULL, NULL, 480);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430235', '4305', 'RS', '4305', '4305', '43023', '43', 'BOM PRINCIPIO', NULL, '51', '95765000', '2', '9823', '9823', '19244', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 88.242, '-29,48900', '-51,35300', 37, 'S', 0.8360, NULL, NULL, '43900', 'N', 'N', 684, NULL, '4390', '4390', NULL, '1982', 'S', 3951, 'BOM PRINCÍPIO', 'N', '430235', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '50', NULL, '03', 'N', NULL, NULL, NULL, 482);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430237', '4319', 'RS', '4303', '4301', '43002', '43', 'BOM PROGRESSO', NULL, '55', '98575000', '8', '6071', '6071', '19345', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 88.757, '-27,54400', '-53,86600', 480, 'S', 0.7540, NULL, NULL, '43900', 'N', 'N', 686, NULL, '4390', '4390', NULL, '1993', 'S', 3952, 'BOM PROGRESSO', 'N', '430237', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '51', NULL, '03', 'N', NULL, NULL, NULL, 471);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430240', '4316', 'RS', '4307', '4304', '43021', '43', 'BOM RETIRO DO SUL', NULL, '51', '95870000', '2', '8547', '8547', '19024', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 102.327, '-29,60900', '-51,94300', 35, 'S', 0.7900, NULL, NULL, '43900', 'N', 'N', 689, NULL, '4390', '4390', NULL, '1959', 'S', 3953, 'BOM RETIRO DO SUL', 'N', '430240', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '52', NULL, '03', 'N', NULL, NULL, NULL, 486);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430245', '4316', 'RS', '4307', '4304', '43021', '43', 'BOQUEIRAO DO LEAO', NULL, '51', '95920000', '1', '8483', '8483', '19255', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 265.527, '-29,30400', '-52,42900', 518, 'S', 0.7530, NULL, NULL, '43900', 'N', 'N', 710, NULL, '4390', '4390', NULL, '1989', 'S', 3954, 'BOQUEIRÃO DO LEÃO', 'N', '430245', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '53', NULL, '03', 'N', NULL, NULL, NULL, 485);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430250', '4312', 'RS', '4303', '4301', '43007', '43', 'BOSSOROCA', NULL, '55', '97850000', '1', '8549', '8549', '19025', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1596.219, '-28,73000', '-54,90000', 228, 'S', 0.7810, NULL, NULL, '43900', 'N', 'N', 722, NULL, '4390', '4390', NULL, '1965', 'S', 3955, 'BOSSOROCA', 'N', '430250', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '54', NULL, '03', 'N', NULL, NULL, NULL, 467);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430258', '4317', 'RS', '4303', '4301', '43008', '43', 'BOZANO', NULL, '55', '98733000', '4', '1128', '1128', '19476', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 201.039, '-28,36800', '-53,77100', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5642, NULL, '4390', '4390', NULL, '2001', 'S', 5538, 'BOZANO', 'N', '430258', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '55', NULL, '03', 'N', NULL, NULL, NULL, 469);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430260', '4315', 'RS', '4303', '4301', '43002', '43', 'BRAGA', NULL, '55', '98560000', '0', '8551', '8551', '19026', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 128.992, '-27,61400', '-53,73900', 430, 'S', 0.7030, NULL, NULL, '43900', 'N', 'N', 730, NULL, '4390', '4390', NULL, '1965', 'S', 3956, 'BRAGA', 'N', '430260', 'N', 'N', 'S', NULL, 147, 'S', 'N', 'N', '56', NULL, '03', 'N', NULL, NULL, NULL, 476);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430265', '4301', 'RS', '4302', '4305', '43023', '43', 'BROCHIER', NULL, '51', '95790000', '9', '8449', '8449', '19256', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 109.695, '-29,55100', '-51,59300', 90, 'S', 0.8010, NULL, NULL, '43900', 'N', 'N', 770, NULL, '4390', '4390', NULL, '1989', 'S', 3957, 'BROCHIER', 'N', '430265', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '57', NULL, '03', 'N', NULL, NULL, NULL, 464);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430270', '4302', 'RS', '4302', '4305', '43025', '43', 'BUTIA', NULL, '51', '96750000', '9', '8553', '8553', '19027', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 768.889, '-30,12000', '-51,96200', 71, 'S', 0.7550, NULL, NULL, '43900', 'N', 'N', 803, NULL, '4390', '4390', NULL, '1963', 'S', 3958, 'BUTIÁ', 'N', '430270', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '58', NULL, '03', 'N', NULL, NULL, NULL, 465);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430280', '4308', 'RS', '4301', '4307', '43032', '43', 'CACAPAVA DO SUL', NULL, '55', '96570000', '8', '8555', '8555', '19028', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3047.120, '-30,51200', '-53,49100', 444, 'S', 0.7680, NULL, NULL, '43900', 'N', 'N', 823, NULL, '4390', '4390', NULL, '1831', 'S', 3959, 'CAÇAPAVA DO SUL', 'N', '430280', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '59', NULL, '03', 'N', NULL, NULL, NULL, 483);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430290', '4304', 'RS', '4301', '4303', '43018', '43', 'CACEQUI', NULL, '55', '97450000', '7', '8557', '8557', '19029', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2370.016, '-29,88400', '-54,82500', 103, 'S', 0.7470, NULL, NULL, '43900', 'N', 'N', 825, NULL, '4390', '4390', NULL, '1944', 'S', 3960, 'CACEQUI', 'N', '430290', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '60', NULL, '03', 'N', NULL, NULL, NULL, 458);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430300', '4308', 'RS', '4301', '4304', '43022', '43', 'CACHOEIRA DO SUL', NULL, '51', '96700970', '4', '8559', '8559', '19030', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 3735.167, '-30,03900', '-52,89400', 68, 'S', 0.7880, NULL, NULL, '43900', 'N', 'N', 835, NULL, '4390', '4390', NULL, '1819', 'S', 3961, 'CACHOEIRA DO SUL', 'N', '430300', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '61', NULL, '02', 'N', NULL, NULL, NULL, 483);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430310', '4302', 'RS', '4302', '4305', '43026', '43', 'CACHOEIRINHA', NULL, '51', '94901970', '3', '8561', '8561', '19031', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 43.766, '-29,95100', '-51,09400', 23, 'S', 0.8130, NULL, NULL, '43900', 'N', 'N', 844, NULL, '4301', '4301', NULL, '1965', 'S', 3962, 'CACHOEIRINHA', 'N', '430310', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '62', NULL, '01', 'N', NULL, NULL, NULL, 466);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430320', '4306', 'RS', '4304', '4301', '43005', '43', 'CACIQUE DOBLE', NULL, '54', '99860000', '2', '8563', '8563', '19032', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 203.908, '-27,77000', '-51,66000', 623, 'S', 0.7340, NULL, NULL, '43900', 'N', 'N', 850, NULL, '4390', '4390', NULL, '1964', 'S', 3963, 'CACIQUE DOBLE', 'N', '430320', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '63', NULL, '03', 'N', NULL, NULL, NULL, 474);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430330', '4312', 'RS', '4303', '4301', '43006', '43', 'CAIBATE', NULL, '55', '97930000', '1', '8565', '8565', '19033', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 258.940, '-28,28800', '-54,63800', 286, 'S', 0.7840, NULL, NULL, '43900', 'N', 'N', 869, NULL, '4390', '4390', NULL, '1965', 'S', 3964, 'CAIBATÉ', 'N', '430330', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '64', NULL, '03', 'N', NULL, NULL, NULL, 467);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430340', '4319', 'RS', '4304', '4301', '43003', '43', 'CAICARA', NULL, '55', '98440000', '0', '8567', '8567', '19034', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 189.238, '-27,27400', '-53,43200', 583, 'S', 0.7940, NULL, NULL, '43900', 'N', 'N', 871, NULL, '4390', '4390', NULL, '1965', 'S', 3965, 'CAIÇARA', 'N', '430340', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '65', NULL, '03', 'N', NULL, NULL, NULL, 471);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430350', '4302', 'RS', '4302', '4305', '43028', '43', 'CAMAQUA', NULL, '51', '96180000', '9', '8569', '8569', '19035', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1679.556, '-30,85100', '-51,81200', 39, 'S', 0.7680, NULL, NULL, '43900', 'N', 'N', 909, NULL, '4390', '4390', NULL, '1864', 'S', 3966, 'CAMAQUÃ', 'N', '430350', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '66', NULL, '02', 'N', NULL, NULL, NULL, 465);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430355', '4306', 'RS', '4304', '4301', '43010', '43', 'CAMARGO', NULL, '54', '99165000', '8', '8447', '8447', '19257', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 138.069, '-28,58700', '-52,20200', 432, 'S', 0.8140, NULL, NULL, '43900', 'N', 'N', 911, NULL, '4390', '4390', NULL, '1989', 'S', 3967, 'CAMARGO', 'N', '430355', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '67', NULL, '03', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430360', '4301', 'RS', '4305', '4302', '43015', '43', 'CAMBARA DO SUL', NULL, '54', '95480000', '8', '8571', '8571', '19036', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1212.534, '-29,04800', '-50,14500', 1031, 'S', 0.7600, NULL, NULL, '43900', 'N', 'N', 913, NULL, '4390', '4390', NULL, '1963', 'S', 3968, 'CAMBARÁ DO SUL', 'N', '430360', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '68', NULL, '03', 'N', NULL, NULL, NULL, 462);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430367', '4305', 'RS', '4305', '4302', '43015', '43', 'CAMPESTRE DA SERRA', NULL, '54', '95255000', '3', '6013', '6013', '19346', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 538.000, '-28,79500', '-51,09300', 770, 'S', 0.7820, NULL, NULL, '43900', 'N', 'N', 927, NULL, '4390', '4390', NULL, '1993', 'S', 3969, 'CAMPESTRE DA SERRA', 'N', '430367', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '69', NULL, '03', 'N', NULL, NULL, NULL, 480);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430370', '4314', 'RS', '4303', '4301', '43006', '43', 'CAMPINA DAS MISSOES', NULL, '55', '98975000', '7', '8573', '8573', '19037', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 225.762, '-27,98900', '-54,83900', 163, 'S', 0.7640, NULL, NULL, '43900', 'N', 'N', 931, NULL, '4390', '4390', NULL, '1963', 'S', 3970, 'CAMPINA DAS MISSÕES', 'N', '430370', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '70', NULL, '03', 'N', NULL, NULL, NULL, 470);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430380', '4311', 'RS', '4304', '4301', '43004', '43', 'CAMPINAS DO SUL', NULL, '54', '99660000', '6', '8575', '8575', '19038', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 261.321, '-27,71600', '-52,62800', 583, 'S', 0.7890, NULL, NULL, '43900', 'N', 'N', 941, NULL, '4390', '4390', NULL, '1959', 'S', 3971, 'CAMPINAS DO SUL', 'N', '430380', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '71', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430390', '4301', 'RS', '4302', '4305', '43026', '43', 'CAMPO BOM', NULL, '51', '93700000', '5', '8577', '8577', '19039', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 61.406, '-29,67900', '-51,05300', 29, 'S', 0.8370, NULL, NULL, '43900', 'N', 'N', 951, NULL, '4301', '4301', NULL, '1959', 'S', 3972, 'CAMPO BOM', 'N', '430390', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '72', NULL, '01', 'N', NULL, NULL, NULL, 463);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500280', '5005', 'MS', '5001', '5004', '50009', '50', 'CARACOL', NULL, '67', '79270000', '3', '9053', '9053', '06027', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2938.675, '-22,01400', '-57,02400', 212, 'S', 0.7250, NULL, NULL, '50014', 'N', 'N', 1073, NULL, '5090', '5090', NULL, '1963', 'S', 2229, 'CARACOL', 'N', '500280', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '21', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430400', '4317', 'RS', '4303', '4301', '43002', '43', 'CAMPO NOVO', NULL, '55', '98570000', '2', '8579', '8579', '19040', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 222.103, '-27,67500', '-53,80300', 437, 'S', 0.7360, NULL, NULL, '43900', 'N', 'N', 969, NULL, '4390', '4390', NULL, '1959', 'S', 3973, 'CAMPO NOVO', 'N', '430400', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '73', NULL, '03', 'N', NULL, NULL, NULL, 469);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430410', '4306', 'RS', '4304', '4301', '43011', '43', 'CAMPOS BORGES', NULL, '54', '99435000', '1', '8445', '8445', '19258', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 237.293, '-28,88600', '-52,99900', 513, 'S', 0.7600, NULL, NULL, '43900', 'N', 'N', 976, NULL, '4390', '4390', NULL, '1989', 'S', 3974, 'CAMPOS BORGES', 'N', '430410', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '74', NULL, '03', 'N', NULL, NULL, NULL, 475);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430420', '4313', 'RS', '4307', '4304', '43020', '43', 'CANDELARIA', NULL, '51', '96930000', '0', '8581', '8581', '19041', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 943.731, '-29,66900', '-52,78900', 57, 'S', 0.7560, NULL, NULL, '43900', 'N', 'N', 1004, NULL, '4390', '4390', NULL, '1925', 'S', 3975, 'CANDELÁRIA', 'N', '430420', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '75', NULL, '03', 'N', NULL, NULL, NULL, 484);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430430', '4314', 'RS', '4303', '4301', '43001', '43', 'CANDIDO GODOI', NULL, '55', '98970000', '9', '8583', '8583', '19042', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 246.275, '-27,95200', '-54,75200', 321, 'S', 0.7910, NULL, NULL, '43900', 'N', 'N', 1007, NULL, '4390', '4390', NULL, '1963', 'S', 3976, 'CÂNDIDO GODÓI', 'N', '430430', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '76', NULL, '03', 'N', NULL, NULL, NULL, 470);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430435', '4307', 'RS', '4306', '4307', '43032', '43', 'CANDIOTA', NULL, '53', '96495000', '8', '6083', '6083', '19347', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 933.843, '-31,55800', '-53,67300', 220, 'S', 0.8180, NULL, NULL, '43900', 'N', 'N', 1012, NULL, '4390', '4390', NULL, '1993', 'S', 3977, 'CANDIOTA', 'N', '430435', 'N', 'N', 'S', NULL, 104, 'N', 'N', 'N', '77', NULL, '03', 'N', NULL, NULL, NULL, 478);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430440', '4305', 'RS', '4305', '4305', '43024', '43', 'CANELA', NULL, '54', '95680000', '8', '8585', '8585', '19043', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 254.579, '-29,36600', '-50,81600', 837, 'S', 0.8180, NULL, NULL, '43900', 'N', 'N', 1014, NULL, '4390', '4390', NULL, '1944', 'S', 3978, 'CANELA', 'N', '430440', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '78', NULL, '03', 'N', NULL, NULL, NULL, 479);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430450', '4303', 'RS', '4306', '4307', '43033', '43', 'CANGUCU', NULL, '53', '96600000', '7', '8587', '8587', '19044', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3525.068, '-31,39500', '-52,67600', 386, 'S', 0.7430, NULL, NULL, '43900', 'N', 'N', 1017, NULL, '4390', '4390', NULL, '1857', 'S', 3979, 'CANGUÇU', 'N', '430450', 'N', 'N', 'S', NULL, 104, 'N', 'N', 'N', '79', NULL, '02', 'N', NULL, NULL, NULL, 477);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430461', '4316', 'RS', '4307', '4304', '43021', '43', 'CANUDOS DO VALE', NULL, '51', '95933000', '4', '1130', NULL, '19477', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 82.555, '-29,32300', '-52,23400', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5644, NULL, '4390', '4390', NULL, '2001', 'S', 5531, 'CANUDOS DO VALE', 'N', '430461', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '81', NULL, '03', 'N', NULL, NULL, NULL, 485);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430462', '4306', 'RS', '4304', '4302', '43015', '43', 'CAPAO BONITO DO SUL', NULL, '54', '95308000', '2', '1132', NULL, '19478', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 527.069, '-28,12800', '-51,39500', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5646, NULL, '4390', '4390', NULL, '2001', 'S', 5532, 'CAPÃO BONITO DO SUL', 'N', '430462', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '82', NULL, '03', 'N', NULL, NULL, NULL, 474);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430463', '4318', 'RS', '4302', '4305', '43027', '43', 'CAPAO DA CANOA', NULL, '51', '95555000', '0', '8915', '8915', '19240', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 97.096, '-29,76100', '-50,03000', 6, 'S', 0.8060, NULL, NULL, '43900', 'N', 'N', 1038, NULL, '4302', '4390', NULL, '1982', 'S', 3981, 'CAPÃO DA CANOA', 'N', '430463', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '83', NULL, '03', 'N', NULL, NULL, NULL, 460);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430465', '4304', 'RS', '4301', '4303', '43017', '43', 'CAPAO DO CIPO', NULL, '55', '97753000', '5', '1134', NULL, '19479', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1022.182, '-28,92500', '-54,69200', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5648, NULL, '4390', '4390', NULL, '2001', 'S', 5533, 'CAPÃO DO CIPÓ', 'N', '430465', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '84', NULL, '03', 'N', NULL, NULL, NULL, 458);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430466', '4303', 'RS', '4306', '4307', '43033', '43', 'CAPAO DO LEAO', NULL, '53', '96160000', '3', '8973', '8973', '19237', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 785.374, '-31,76300', '-52,48400', 21, 'S', 0.7700, NULL, NULL, '43900', 'N', 'N', 1039, NULL, '4304', '4390', NULL, '1982', 'S', 3982, 'CAPÃO DO LEÃO', 'N', '430466', 'N', 'N', 'S', NULL, 104, 'N', 'N', 'N', '85', NULL, '03', 'N', NULL, NULL, NULL, 477);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430467', '4318', 'RS', '4302', '4305', '43027', '43', 'CAPIVARI DO SUL', NULL, '51', '95552000', '1', '0962', NULL, '19436', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 417.609, '-30,14500', '-50,51500', 12, 'S', 0.8070, NULL, NULL, '43900', 'N', 'N', 1066, NULL, '4302', '4390', NULL, '1997', 'S', 3985, 'CAPIVARI DO SUL', 'N', '430467', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '88', NULL, '03', 'N', NULL, NULL, NULL, 461);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430468', '4301', 'RS', '4302', '4305', '43023', '43', 'CAPELA DE SANTANA', NULL, '51', '95745000', '9', '8443', '8443', '19259', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 184.003, '-29,70000', '-51,32500', 69, 'S', 0.7640, NULL, NULL, '43900', 'N', 'N', 1043, NULL, '4301', '4390', NULL, '1989', 'S', 3983, 'CAPELA DE SANTANA', 'N', '430468', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '86', NULL, '01', 'N', NULL, NULL, NULL, 464);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430469', '4316', 'RS', '4307', '4304', '43021', '43', 'CAPITAO', NULL, '51', '95935000', '7', '6025', '6025', '19348', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 74.619, '-29,26900', '-51,98900', 465, 'S', 0.7880, NULL, NULL, '43900', 'N', 'N', 1056, NULL, '4390', '4390', NULL, '1993', 'S', 3984, 'CAPITÃO', 'N', '430469', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '87', NULL, '03', 'N', NULL, NULL, NULL, 485);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430470', '4306', 'RS', '4304', '4301', '43009', '43', 'CARAZINHO', NULL, '54', '99500000', '5', '8591', '8591', '19046', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 665.092, '-28,28400', '-52,78600', 603, 'S', 0.7990, NULL, NULL, '43900', 'N', 'N', 1089, NULL, '4390', '4390', NULL, '1931', 'S', 3987, 'CARAZINHO', 'N', '430470', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '90', NULL, '02', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430471', '4318', 'RS', '4302', '4305', '43027', '43', 'CARAA', NULL, '51', '95515000', '3', '0964', NULL, '19437', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 294.336, '-29,79000', '-50,43500', 38, 'S', 0.7340, NULL, NULL, '43900', 'N', 'N', 1070, NULL, '4302', '4390', NULL, '1997', 'S', 3986, 'CARAÁ', 'N', '430471', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '89', NULL, '03', 'N', NULL, NULL, NULL, 461);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430480', '4305', 'RS', '4305', '4302', '43016', '43', 'CARLOS BARBOSA', NULL, '54', '95185000', '4', '8593', '8593', '19047', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 229.906, '-29,29800', '-51,50400', 676, 'S', 0.8580, NULL, NULL, '43900', 'N', 'N', 1108, NULL, '4303', '4302', NULL, '1959', 'S', 3988, 'CARLOS BARBOSA', 'N', '430480', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '91', NULL, '03', 'N', NULL, NULL, NULL, 481);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430485', '4311', 'RS', '4304', '4301', '43004', '43', 'CARLOS GOMES', NULL, '54', '99825000', '3', '5961', '5961', '19349', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 83.154, '-27,71800', '-51,91400', 447, 'S', 0.7820, NULL, NULL, '43900', 'N', 'N', 1110, NULL, '4390', '4390', NULL, '1993', 'S', 3989, 'CARLOS GOMES', 'N', '430485', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '92', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430490', '4306', 'RS', '4304', '4301', '43010', '43', 'CASCA', NULL, '54', '99260000', '3', '8595', '8595', '19048', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 271.740, '-28,56100', '-51,97800', 608, 'S', 0.8290, NULL, NULL, '43900', 'N', 'N', 1143, NULL, '4390', '4390', NULL, '1954', 'S', 3990, 'CASCA', 'N', '430490', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '93', NULL, '03', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430495', '4306', 'RS', '4304', '4301', '43010', '43', 'CASEIROS', NULL, '54', '95315000', '2', '8441', '8441', '19260', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 235.679, '-28,26900', '-51,69000', 786, 'S', 0.7500, NULL, NULL, '43900', 'N', 'N', 1148, NULL, '4390', '4390', NULL, '1989', 'S', 3991, 'CASEIROS', 'N', '430495', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '94', NULL, '03', 'N', NULL, NULL, NULL, 474);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430500', '4317', 'RS', '4303', '4301', '43007', '43', 'CATUIPE', NULL, '55', '98770000', '9', '8597', '8597', '19049', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 583.240, '-28,25000', '-54,01200', 315, 'S', 0.7990, NULL, NULL, '43900', 'N', 'N', 1178, NULL, '4390', '4390', NULL, '1961', 'S', 3992, 'CATUÍPE', 'N', '430500', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '95', NULL, '03', 'N', NULL, NULL, NULL, 469);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430510', '4305', 'RS', '4305', '4302', '43016', '43', 'CAXIAS DO SUL', NULL, '54', '95001970', '8', '8599', '8599', '19050', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1643.913, '-29,16800', '-51,17900', 817, 'S', 0.8570, NULL, NULL, '43900', 'N', 'N', 1190, NULL, '4303', '4302', NULL, '1890', 'S', 3993, 'CAXIAS DO SUL', 'N', '430510', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '96', NULL, '01', 'N', NULL, NULL, NULL, 479);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430511', '4311', 'RS', '4304', '4301', '43004', '43', 'CENTENARIO', NULL, '54', '99838000', '6', '5963', '5963', '19350', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 134.331, '-27,76100', '-51,99900', 600, 'S', 0.7770, NULL, NULL, '43900', 'N', 'N', 1200, NULL, '4390', '4390', NULL, '1993', 'S', 3994, 'CENTENÁRIO', 'N', '430511', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '97', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430512', '4303', 'RS', '4306', '4307', '43033', '43', 'CERRITO', NULL, '53', '96395000', '4', '0966', NULL, '19438', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 451.889, '-31,85600', '-52,81300', 50, 'S', 0.7410, NULL, NULL, '43900', 'N', 'N', 1213, NULL, '4390', '4390', NULL, '1997', 'S', 3995, 'CERRITO', 'N', '430512', 'N', 'N', 'S', NULL, 104, 'N', 'N', 'N', '98', NULL, '03', 'N', NULL, NULL, NULL, 477);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430513', '4308', 'RS', '4301', '4304', '43022', '43', 'CERRO BRANCO', NULL, '51', '96535000', '2', '8439', '8439', '19261', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 154.105, '-29,65400', '-52,93400', 83, 'S', 0.7370, NULL, NULL, '43900', 'N', 'N', 1215, NULL, '4390', '4390', NULL, '1989', 'S', 3996, 'CERRO BRANCO', 'N', '430513', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '99', NULL, '03', 'N', NULL, NULL, NULL, 483);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430515', '4315', 'RS', '4304', '4301', '43009', '43', 'CERRO GRANDE', NULL, '55', '98340000', '7', '8437', '8437', '19262', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 73.459, '-27,60600', '-53,16700', 405, 'S', 0.7250, NULL, NULL, '43900', 'N', 'N', 1217, NULL, '4390', '4390', NULL, '1989', 'S', 3997, 'CERRO GRANDE', 'N', '430515', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '100', NULL, '03', 'N', NULL, NULL, NULL, 476);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430517', '4302', 'RS', '4302', '4305', '43028', '43', 'CERRO GRANDE DO SUL', NULL, '51', '96770000', '3', '8435', '8435', '19263', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 324.758, '-30,59000', '-51,73900', 405, 'S', 0.7340, NULL, NULL, '43900', 'N', 'N', 1218, NULL, '4390', '4390', NULL, '1989', 'S', 3998, 'CERRO GRANDE DO SUL', 'N', '430517', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '101', NULL, '03', 'N', NULL, NULL, NULL, 465);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430520', '4312', 'RS', '4303', '4301', '43006', '43', 'CERRO LARGO', NULL, '55', '97900000', '7', '8601', '8601', '19051', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 177.674, '-28,14900', '-54,73800', 211, 'S', 0.8070, NULL, NULL, '43900', 'N', 'N', 1219, NULL, '4390', '4390', NULL, '1954', 'S', 3999, 'CERRO LARGO', 'N', '430520', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '102', NULL, '03', 'N', NULL, NULL, NULL, 467);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430530', '4315', 'RS', '4303', '4301', '43009', '43', 'CHAPADA', NULL, '54', '99530000', '6', '8603', '8603', '19052', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 684.040, '-28,05500', '-53,06800', 436, 'S', 0.8160, NULL, NULL, '43900', 'N', 'N', 1229, NULL, '4390', '4390', NULL, '1959', 'S', 4000, 'CHAPADA', 'N', '430530', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '103', NULL, '03', 'N', NULL, NULL, NULL, 476);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430535', '4302', 'RS', '4302', '4305', '43025', '43', 'CHARQUEADAS', NULL, '51', '96745000', '5', '8693', '8693', '19236', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 216.513, '-29,95500', '-51,62500', 30, 'S', 0.8060, NULL, NULL, '43900', 'N', 'N', 1241, NULL, '4301', '4301', NULL, '1982', 'S', 4001, 'CHARQUEADAS', 'N', '430535', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '104', NULL, '01', 'N', NULL, NULL, NULL, 465);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430537', '4311', 'RS', '4304', '4301', '43010', '43', 'CHARRUA', NULL, '54', '99960000', '1', '5965', '5965', '19351', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 198.125, '-27,95200', '-52,01500', 665, 'S', 0.7160, NULL, NULL, '43900', 'N', 'N', 1242, NULL, '4390', '4390', NULL, '1993', 'S', 4002, 'CHARRUA', 'N', '430537', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '105', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430540', '4317', 'RS', '4303', '4301', '43008', '43', 'CHIAPETTA', NULL, '55', '98760000', '5', '8605', '8605', '19053', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 396.483, '-27,92300', '-53,94100', 483, 'S', 0.7600, NULL, NULL, '43900', 'N', 'N', 1247, NULL, '4390', '4390', NULL, '1965', 'S', 4003, 'CHIAPETA', 'N', '430540', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '106', NULL, '03', 'N', NULL, NULL, NULL, 469);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430543', '4303', 'RS', '4306', '4307', '43035', '43', 'CHUI', NULL, '53', '96255000', '9', '0968', '0968', '19439', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 203.201, '-33,69100', '-53,45700', 22, 'S', 0.8110, NULL, NULL, '43900', 'N', 'N', 1252, NULL, '4390', '4390', NULL, '1997', 'S', 4004, 'CHUÍ', 'N', '430543', 'N', 'N', 'S', NULL, 104, 'N', 'N', 'N', '107', NULL, '03', 'N', NULL, NULL, NULL, 477);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430544', '4302', 'RS', '4302', '4305', '43028', '43', 'CHUVISCA', NULL, '51', '96193000', '7', '0970', NULL, '19440', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 219.170, '-30,75800', '-51,97800', 219, 'S', 0.7760, NULL, NULL, '43900', 'N', 'N', 1254, NULL, '4390', '4390', NULL, '1997', 'S', 4005, 'CHUVISCA', 'N', '430544', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '108', NULL, '03', 'N', NULL, NULL, NULL, 465);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430545', '4318', 'RS', '4302', '4305', '43027', '43', 'CIDREIRA', NULL, '51', '95595000', '4', '8433', '8433', '19264', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 246.362, '-30,16100', '-50,23400', 60, 'S', 0.8080, NULL, NULL, '43900', 'N', 'N', 1260, NULL, '4302', '4390', NULL, '1989', 'S', 4006, 'CIDREIRA', 'N', '430545', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '109', NULL, '03', 'N', NULL, NULL, NULL, 461);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430550', '4306', 'RS', '4304', '4301', '43010', '43', 'CIRIACO', NULL, '54', '99970000', '4', '8607', '8607', '19054', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 273.872, '-28,34400', '-51,87600', 753, 'S', 0.7690, NULL, NULL, '43900', 'N', 'N', 1263, NULL, '4390', '4390', NULL, '1965', 'S', 4007, 'CIRÍACO', 'N', '430550', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '110', NULL, '03', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430558', '4316', 'RS', '4307', '4304', '43021', '43', 'COLINAS', NULL, '51', '95895000', '7', '6029', '6029', '19352', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 58.374, '-29,38800', '-51,87000', 80, 'S', 0.8110, NULL, NULL, '43900', 'N', 'N', 1289, NULL, '4390', '4390', NULL, '1993', 'S', 4008, 'COLINAS', 'N', '430558', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '111', NULL, '03', 'N', NULL, NULL, NULL, 486);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430560', '4309', 'RS', '4303', '4301', '43012', '43', 'COLORADO', NULL, '54', '99460000', '3', '8609', '8609', '19055', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 286.178, '-28,52400', '-52,99400', 428, 'S', 0.8170, NULL, NULL, '43900', 'N', 'N', 1299, NULL, '4390', '4390', NULL, '1962', 'S', 4009, 'COLORADO', 'N', '430560', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '112', NULL, '03', 'N', NULL, NULL, NULL, 468);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430570', '4317', 'RS', '4303', '4301', '43008', '43', 'CONDOR', NULL, '55', '98290000', '2', '8611', '8611', '19056', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 465.188, '-28,20800', '-53,48700', 451, 'S', 0.7930, NULL, NULL, '43900', 'N', 'N', 1338, NULL, '4390', '4390', NULL, '1965', 'S', 4010, 'CONDOR', 'N', '430570', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '113', NULL, '03', 'N', NULL, NULL, NULL, 469);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430580', '4315', 'RS', '4304', '4301', '43003', '43', 'CONSTANTINA', NULL, '54', '99680000', '1', '8613', '8613', '19057', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 202.999, '-27,73500', '-52,99200', 501, 'S', 0.7960, NULL, NULL, '43900', 'N', 'N', 1352, NULL, '4390', '4390', NULL, '1959', 'S', 4011, 'CONSTANTINA', 'N', '430580', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '114', NULL, '03', 'N', NULL, NULL, NULL, 476);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430583', '4316', 'RS', '4307', '4304', '43021', '43', 'COQUEIRO BAIXO', NULL, '51', '95955000', '5', '1136', NULL, '19480', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 112.322, '-29,17800', '-52,09300', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5650, NULL, '4390', '4390', NULL, '2001', 'S', 5534, 'COQUEIRO BAIXO', 'N', '430583', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '115', NULL, '03', 'N', NULL, NULL, NULL, 485);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430585', '4306', 'RS', '4304', '4301', '43009', '43', 'COQUEIROS DO SUL', NULL, '54', '99528000', '0', '5945', '5945', '19353', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 275.549, '-28,11900', '-52,78300', 601, 'S', 0.7670, NULL, NULL, '43900', 'N', 'N', 1358, NULL, '4390', '4390', NULL, '1993', 'S', 4012, 'COQUEIROS DO SUL', 'N', '430585', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '116', NULL, '03', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430587', '4317', 'RS', '4303', '4301', '43008', '43', 'CORONEL BARROS', NULL, '55', '98735000', '1', '6055', '6055', '19354', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 162.949, '-28,38300', '-54,06600', 311, 'S', 0.7920, NULL, NULL, '43900', 'N', 'N', 1378, NULL, '4390', '4390', NULL, '1993', 'S', 4013, 'CORONEL BARROS', 'N', '430587', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '117', NULL, '03', 'N', NULL, NULL, NULL, 469);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430590', '4315', 'RS', '4303', '4301', '43008', '43', 'CORONEL BICACO', NULL, '55', '98580000', '0', '8615', '8615', '19058', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 492.124, '-27,71600', '-53,70100', 468, 'S', 0.7680, NULL, NULL, '43900', 'N', 'N', 1379, NULL, '4390', '4390', NULL, '1963', 'S', 4014, 'CORONEL BICACO', 'N', '430590', 'N', 'N', 'S', NULL, 147, 'S', 'N', 'N', '118', NULL, '03', 'N', NULL, NULL, NULL, 476);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430593', '4305', 'RS', '4305', '4302', '43016', '43', 'CORONEL PILAR', NULL, '54', '95726000', '4', '1138', NULL, '19481', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 105.379, '-29,27300', '-51,68700', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5652, NULL, '4390', '4390', NULL, '2001', 'S', 5535, 'CORONEL PILAR', 'N', '430593', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '119', NULL, '03', 'N', NULL, NULL, NULL, 481);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430595', '4305', 'RS', '4305', '4302', '43016', '43', 'COTIPORA', NULL, '54', '95335000', '9', '8977', '8977', '19242', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 172.375, '-28,99400', '-51,69600', 609, 'S', 0.8200, NULL, NULL, '43900', 'N', 'N', 1418, NULL, '4390', '4390', NULL, '1982', 'S', 4015, 'COTIPORÃ', 'N', '430595', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '120', NULL, '03', 'N', NULL, NULL, NULL, 481);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430597', '4306', 'RS', '4304', '4301', '43010', '43', 'COXILHA', NULL, '54', '99145000', '5', '5797', '5797', '19355', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 422.790, '-28,12700', '-52,29600', 721, 'S', 0.7690, NULL, NULL, '43900', 'N', 'N', 1422, NULL, '4390', '4390', NULL, '1993', 'S', 4016, 'COXILHA', 'N', '430597', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '121', NULL, '03', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430600', '4317', 'RS', '4303', '4301', '43002', '43', 'CRISSIUMAL', NULL, '55', '98640000', '7', '8617', '8617', '19059', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 362.151, '-27,50000', '-54,10100', 410, 'S', 0.7860, NULL, NULL, '43900', 'N', 'N', 1433, NULL, '4390', '4390', NULL, '1954', 'S', 4017, 'CRISSIUMAL', 'N', '430600', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '122', NULL, '03', 'N', NULL, NULL, NULL, 469);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430605', '4303', 'RS', '4306', '4307', '43033', '43', 'CRISTAL', NULL, '51', '96195000', '6', '8431', '8431', '19265', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 681.561, '-31,00300', '-52,05000', 500, 'S', 0.7550, NULL, NULL, '43900', 'N', 'N', 1436, NULL, '4390', '4390', NULL, '1989', 'S', 4018, 'CRISTAL', 'N', '430605', 'N', 'N', 'S', NULL, 104, 'N', 'N', 'N', '123', NULL, '03', 'N', NULL, NULL, NULL, 477);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430607', '4319', 'RS', '4304', '4301', '43003', '43', 'CRISTAL DO SUL', NULL, '55', '98368000', '2', '0972', NULL, '19441', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 97.716, '-27,45400', '-53,24600', 369, 'S', 0.7040, NULL, NULL, '43900', 'N', 'N', 1437, NULL, '4390', '4390', NULL, '1997', 'S', 4019, 'CRISTAL DO SUL', 'N', '430607', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '124', NULL, '03', 'N', NULL, NULL, NULL, 471);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430610', '4309', 'RS', '4303', '4301', '43011', '43', 'CRUZ ALTA', NULL, '55', '98005000', '6', '8619', '8619', '19060', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1360.373, '-28,63900', '-53,60600', 452, 'S', 0.8250, NULL, NULL, '43900', 'N', 'N', 1454, NULL, '4390', '4390', NULL, '1833', 'S', 4020, 'CRUZ ALTA', 'N', '430610', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '125', NULL, '02', 'N', NULL, NULL, NULL, 468);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430613', '4311', 'RS', '4304', '4301', '43004', '43', 'CRUZALTENSE', NULL, '54', '99665000', '0', '1140', NULL, '19482', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 165.717, '-27,66800', '-52,64900', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5654, NULL, '4390', '4390', NULL, '2001', 'S', 5536, 'CRUZALTENSE', 'N', '430613', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '126', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430620', '4316', 'RS', '4307', '4304', '43021', '43', 'CRUZEIRO DO SUL', NULL, '51', '95930000', '5', '8621', '8621', '19061', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 155.220, '-29,51300', '-51,98500', 37, 'S', 0.8020, NULL, NULL, '43900', 'N', 'N', 1464, NULL, '4390', '4390', NULL, '1963', 'S', 4021, 'CRUZEIRO DO SUL', 'N', '430620', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '127', NULL, '03', 'N', NULL, NULL, NULL, 485);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430630', '4306', 'RS', '4304', '4301', '43010', '43', 'DAVID CANABARRO', NULL, '54', '99980000', '4', '8623', '8623', '19062', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 174.940, '-28,38800', '-51,84800', 682, 'S', 0.7980, NULL, NULL, '43900', 'N', 'N', 1511, NULL, '4390', '4390', NULL, '1965', 'S', 4022, 'DAVID CANABARRO', 'N', '430630', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '128', NULL, '03', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430632', '4319', 'RS', '4303', '4301', '43002', '43', 'DERRUBADAS', NULL, '55', '98528000', '0', '6073', '6073', '19356', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 361.284, '-27,26500', '-53,86100', 485, 'S', 0.7590, NULL, NULL, '43900', 'N', 'N', 1522, NULL, '4390', '4390', NULL, '1993', 'S', 4023, 'DERRUBADAS', 'N', '430632', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '129', NULL, '03', 'N', NULL, NULL, NULL, 471);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430635', '4312', 'RS', '4303', '4301', '43007', '43', 'DEZESSEIS DE NOVEMBRO', NULL, '55', '97845000', '3', '8429', '8429', '19266', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 216.848, '-28,21300', '-55,06800', 178, 'S', 0.7240, NULL, NULL, '43900', 'N', 'N', 1529, NULL, '4390', '4390', NULL, '1989', 'S', 4024, 'DEZESSEIS DE NOVEMBRO', 'N', '430635', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '130', NULL, '03', 'N', NULL, NULL, NULL, 467);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430637', '4304', 'RS', '4301', '4303', '43018', '43', 'DILERMANDO DE AGUIAR', NULL, '51', '97180000', '9', '0974', NULL, '19442', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 602.571, '-29,70600', '-54,20800', 127, 'S', 0.7760, NULL, NULL, '43900', 'N', 'N', 1539, NULL, '4390', '4390', NULL, '1997', 'S', 4025, 'DILERMANDO DE AGUIAR', 'N', '430637', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '131', NULL, '03', 'N', NULL, NULL, NULL, 457);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430640', '4301', 'RS', '4302', '4305', '43024', '43', 'DOIS IRMAOS', NULL, '51', '93950000', '3', '8625', '8625', '19063', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 65.156, '-29,58000', '-51,08500', 166, 'S', 0.8120, NULL, NULL, '43900', 'N', 'N', 1561, NULL, '4301', '4301', NULL, '1959', 'S', 4026, 'DOIS IRMÃOS', 'N', '430640', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '132', NULL, '01', 'N', NULL, NULL, NULL, 463);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430642', '4315', 'RS', '4304', '4301', '43003', '43', 'DOIS IRMAOS DAS MISSOES', NULL, '55', '98385000', '9', '5971', '5971', '19357', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 225.682, '-27,65900', '-53,53100', 527, 'S', 0.7310, NULL, NULL, '43900', 'N', 'N', 1562, NULL, '4390', '4390', NULL, '1993', 'S', 4027, 'DOIS IRMÃOS DAS MISSÕES', 'N', '430642', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '133', NULL, '03', 'N', NULL, NULL, NULL, 476);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430645', '4316', 'RS', '4307', '4302', '43014', '43', 'DOIS LAJEADOS', NULL, '54', '99220000', '2', '8427', '8427', '19267', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 133.373, '-28,98400', '-51,83600', 450, 'S', 0.8340, NULL, NULL, '43900', 'N', 'N', 1565, NULL, '4390', '4390', NULL, '1989', 'S', 4028, 'DOIS LAJEADOS', 'N', '430645', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '134', NULL, '03', 'N', NULL, NULL, NULL, 485);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430650', '4302', 'RS', '4302', '4305', '43028', '43', 'DOM FELICIANO', NULL, '51', '96190000', '2', '8627', '8627', '19064', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1260.176, '-30,70400', '-52,10800', 154, 'S', 0.7300, NULL, NULL, '43900', 'N', 'N', 1575, NULL, '4390', '4390', NULL, '1963', 'S', 4029, 'DOM FELICIANO', 'N', '430650', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '135', NULL, '03', 'N', NULL, NULL, NULL, 465);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430655', '4318', 'RS', '4302', '4305', '43027', '43', 'DOM PEDRO DE ALCANTARA', NULL, '51', '95568000', '1', '0976', NULL, '19443', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 78.158, '-29,36900', '-49,85000', 37, 'S', 0.7670, NULL, NULL, '43900', 'N', 'N', 1581, NULL, '4302', '4390', NULL, '1997', 'S', 4031, 'DOM PEDRO DE ALCÂNTARA', 'N', '430655', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '137', NULL, '03', 'N', NULL, NULL, NULL, 460);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430660', '4307', 'RS', '4306', '4306', '43031', '43', 'DOM PEDRITO', NULL, '53', '96450000', '1', '8629', '8629', '19065', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 5192.105, '-30,98300', '-54,67300', 141, 'S', 0.7830, NULL, NULL, '43900', 'N', 'N', 1579, NULL, '4390', '4390', NULL, '1872', 'S', 4030, 'DOM PEDRITO', 'N', '430660', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '136', NULL, '03', 'N', NULL, NULL, NULL, 478);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430670', '4304', 'RS', '4301', '4303', '43019', '43', 'DONA FRANCISCA', NULL, '55', '97280000', '0', '8631', '8631', '19066', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 114.346, '-29,62200', '-53,35700', 49, 'S', 0.7650, NULL, NULL, '43900', 'N', 'N', 1588, NULL, '4390', '4390', NULL, '1965', 'S', 4032, 'DONA FRANCISCA', 'N', '430670', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '138', NULL, '03', 'N', NULL, NULL, NULL, 457);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430673', '4314', 'RS', '4303', '4301', '43002', '43', 'DOUTOR MAURICIO CARDOSO', NULL, '55', '98925000', '4', '8425', '8425', '19268', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 256.323, '-27,50600', '-54,36100', 282, 'S', 0.7650, NULL, NULL, '43900', 'N', 'N', 1603, NULL, '4390', '4390', NULL, '1989', 'S', 4033, 'DOUTOR MAURÍCIO CARDOSO', 'N', '430673', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '139', NULL, '03', 'N', NULL, NULL, NULL, 470);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430675', '4316', 'RS', '4307', '4304', '43021', '43', 'DOUTOR RICARDO', NULL, '55', '95967000', '9', '0978', NULL, '19444', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 108.434, '-29,08600', '-51,99200', 499, 'S', 0.7850, NULL, NULL, '43900', 'N', 'N', 1605, NULL, '4390', '4390', NULL, '1997', 'S', 4034, 'DOUTOR RICARDO', 'N', '430675', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '140', NULL, '03', 'N', NULL, NULL, NULL, 485);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430676', '4302', 'RS', '4302', '4305', '43026', '43', 'ELDORADO DO SUL', NULL, '51', '92990000', '7', '8423', '8423', '19269', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 509.699, '-30,08400', '-51,61600', 19, 'S', 0.8030, NULL, NULL, '43900', 'N', 'N', 1625, NULL, '4301', '4301', NULL, '1989', 'S', 4035, 'ELDORADO DO SUL', 'N', '430676', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '141', NULL, '01', 'N', NULL, NULL, NULL, 465);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430680', '4316', 'RS', '4307', '4304', '43021', '43', 'ENCANTADO', NULL, '51', '95960000', '9', '8633', '8633', '19067', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 139.158, '-29,23600', '-51,87000', 58, 'S', 0.8310, NULL, NULL, '43900', 'N', 'N', 1638, NULL, '4390', '4390', NULL, '1915', 'S', 4036, 'ENCANTADO', 'N', '430680', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '142', NULL, '03', 'N', NULL, NULL, NULL, 485);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430690', '4308', 'RS', '4307', '4307', '43032', '43', 'ENCRUZILHADA DO SUL', NULL, '51', '96610000', '8', '8635', '8635', '19068', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3438.503, '-30,54400', '-52,52200', 432, 'S', 0.7600, NULL, NULL, '43900', 'N', 'N', 1641, NULL, '4390', '4390', NULL, '1849', 'S', 4037, 'ENCRUZILHADA DO SUL', 'N', '430690', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '143', NULL, '03', 'N', NULL, NULL, NULL, 483);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430692', '4315', 'RS', '4304', '4301', '43003', '43', 'ENGENHO VELHO', NULL, '54', '99698000', '4', '5947', '5947', '19358', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 71.193, '-27,70800', '-52,91300', 506, 'S', 0.7320, NULL, NULL, '43900', 'N', 'N', 1648, NULL, '4390', '4390', NULL, '1993', 'S', 4038, 'ENGENHO VELHO', 'N', '430692', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '144', NULL, '03', 'N', NULL, NULL, NULL, 476);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430693', '4312', 'RS', '4303', '4301', '43007', '43', 'ENTRE-IJUIS', NULL, '55', '98855000', '2', '8419', '8419', '19270', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 552.545, '-28,36000', '-54,26800', 215, 'S', 0.7670, NULL, NULL, '43900', 'N', 'N', 1655, NULL, '4390', '4390', NULL, '1989', 'S', 4040, 'ENTRE-IJUÍS', 'N', '430693', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '146', NULL, '03', 'N', NULL, NULL, NULL, 467);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430695', '4311', 'RS', '4304', '4301', '43004', '43', 'ENTRE RIOS DO SUL', NULL, '54', '99645000', '7', '8421', '8421', '19271', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 120.444, '-27,52800', '-52,73300', 605, 'S', 0.7570, NULL, NULL, '43900', 'N', 'N', 1654, NULL, '4390', '4390', NULL, '1989', 'S', 4039, 'ENTRE RIOS DO SUL', 'N', '430695', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '145', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430697', '4311', 'RS', '4304', '4301', '43004', '43', 'EREBANGO', NULL, '54', '99920000', '3', '8417', '8417', '19272', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 151.775, '-27,85500', '-52,30200', 763, 'S', 0.7810, NULL, NULL, '43900', 'N', 'N', 1659, NULL, '4390', '4390', NULL, '1989', 'S', 4041, 'EREBANGO', 'N', '430697', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '147', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430700', '4311', 'RS', '4304', '4301', '43004', '43', 'ERECHIM', NULL, '54', '99700000', '5', '8637', '8637', '19069', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 430.764, '-27,63400', '-52,27400', 783, 'S', 0.8260, NULL, NULL, '43900', 'N', 'N', 1660, NULL, '4390', '4390', NULL, '1918', 'S', 4042, 'ERECHIM', 'N', '430700', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '148', NULL, '02', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430705', '4306', 'RS', '4304', '4301', '43010', '43', 'ERNESTINA', NULL, '54', '99140000', '4', '8415', '8415', '19273', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 239.147, '-28,49900', '-52,57300', 493, 'S', 0.8060, NULL, NULL, '43900', 'N', 'N', 1664, NULL, '4390', '4390', NULL, '1989', 'S', 4043, 'ERNESTINA', 'N', '430705', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '149', NULL, '03', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430710', '4303', 'RS', '4306', '4307', '43034', '43', 'HERVAL', NULL, '53', '96310000', '4', '8639', '8639', '19070', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1758.412, '-32,02400', '-53,39600', 287, 'S', 0.7540, NULL, NULL, '43900', 'N', 'N', 2033, NULL, '4390', '4390', NULL, '1881', 'S', 4084, 'HERVAL', 'N', '430710', 'N', 'N', 'S', NULL, 104, 'S', 'N', 'N', '191', NULL, '03', 'N', NULL, NULL, NULL, 477);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430720', '4311', 'RS', '4304', '4301', '43004', '43', 'ERVAL GRANDE', NULL, '54', '99750000', '3', '8641', '8641', '19071', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 285.913, '-27,39100', '-52,57100', 763, 'S', 0.7440, NULL, NULL, '43900', 'N', 'N', 1665, NULL, '4390', '4390', NULL, '1959', 'S', 4044, 'ERVAL GRANDE', 'N', '430720', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '150', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430730', '4319', 'RS', '4303', '4301', '43003', '43', 'ERVAL SECO', NULL, '55', '98390000', '2', '8643', '8643', '19072', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 363.892, '-27,54900', '-53,50400', 425, 'S', 0.7400, NULL, NULL, '43900', 'N', 'N', 1666, NULL, '4390', '4390', NULL, '1963', 'S', 4045, 'ERVAL SECO', 'N', '430730', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '151', NULL, '03', 'N', NULL, NULL, NULL, 471);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430740', '4305', 'RS', '4305', '4302', '43015', '43', 'ESMERALDA', NULL, '54', '95380000', '1', '8645', '8645', '19073', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 833.349, '-28,05400', '-51,19000', 956, 'S', 0.7790, NULL, NULL, '43900', 'N', 'N', 1670, NULL, '4390', '4390', NULL, '1963', 'S', 4046, 'ESMERALDA', 'N', '430740', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '152', NULL, '03', 'N', NULL, NULL, NULL, 480);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430745', '4319', 'RS', '4303', '4301', '43002', '43', 'ESPERANCA DO SUL', NULL, '55', '98635000', '0', '0980', NULL, '19445', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 148.381, '-27,35500', '-53,99200', 387, 'S', 0.7080, NULL, NULL, '43900', 'N', 'N', 1674, NULL, '4390', '4390', NULL, '1997', 'S', 4047, 'ESPERANÇA DO SUL', 'N', '430745', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '153', NULL, '03', 'N', NULL, NULL, NULL, 471);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430750', '4306', 'RS', '4304', '4301', '43011', '43', 'ESPUMOSO', NULL, '54', '99400000', '0', '8647', '8647', '19074', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 783.114, '-28,72500', '-52,85000', 357, 'S', 0.7870, NULL, NULL, '43900', 'N', 'N', 1687, NULL, '4390', '4390', NULL, '1954', 'S', 4048, 'ESPUMOSO', 'N', '430750', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '154', NULL, '03', 'N', NULL, NULL, NULL, 475);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430755', '4311', 'RS', '4304', '4301', '43004', '43', 'ESTACAO', NULL, '54', '99930000', '9', '7301', '7301', '19274', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 100.266, '-27,91100', '-52,26000', 680, 'S', 0.8060, NULL, NULL, '43900', 'N', 'N', 1688, NULL, '4390', '4390', NULL, '1989', 'S', 4049, 'ESTAÇÃO', 'N', '430755', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '155', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430760', '4301', 'RS', '4302', '4305', '43026', '43', 'ESTANCIA VELHA', NULL, '51', '93600000', '9', '8649', '8649', '19075', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 52.378, '-29,64800', '-51,17400', 44, 'S', 0.8080, NULL, NULL, '43900', 'N', 'N', 1690, NULL, '4301', '4301', NULL, '1959', 'S', 4050, 'ESTÂNCIA VELHA', 'N', '430760', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '156', NULL, '01', 'N', NULL, NULL, NULL, 463);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430770', '4301', 'RS', '4302', '4305', '43026', '43', 'ESTEIO', NULL, '51', '93261970', '8', '8651', '8651', '19076', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 27.543, '-29,86100', '-51,17900', 11, 'S', 0.8420, NULL, NULL, '43900', 'N', 'N', 1691, NULL, '4301', '4301', NULL, '1954', 'S', 4051, 'ESTEIO', 'N', '430770', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '157', NULL, '01', 'N', NULL, NULL, NULL, 464);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430780', '4316', 'RS', '4307', '4304', '43021', '43', 'ESTRELA', NULL, '51', '95880000', '7', '8653', '8653', '19077', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 184.178, '-29,50200', '-51,96600', 39, 'S', 0.8290, NULL, NULL, '43900', 'N', 'N', 1695, NULL, '4390', '4390', NULL, '1876', 'S', 4052, 'ESTRELA', 'N', '430780', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '158', NULL, '03', 'N', NULL, NULL, NULL, 486);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430781', '4308', 'RS', '4307', '4304', '43020', '43', 'ESTRELA VELHA', NULL, '55', '96990000', '5', '0982', NULL, '19446', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 281.668, '-29,17700', '-53,15900', 394, 'S', 0.7410, NULL, NULL, '43900', 'N', 'N', 1703, NULL, '4390', '4390', NULL, '1997', 'S', 4053, 'ESTRELA VELHA', 'N', '430781', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '159', NULL, '03', 'N', NULL, NULL, NULL, 483);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430783', '4312', 'RS', '4303', '4301', '43007', '43', 'EUGENIO DE CASTRO', NULL, '55', '98860000', '1', '8413', '8413', '19275', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 419.376, '-28,52500', '-54,14900', 315, 'S', 0.7650, NULL, NULL, '43900', 'N', 'N', 1706, NULL, '4390', '4390', NULL, '1989', 'S', 4054, 'EUGÊNIO DE CASTRO', 'N', '430783', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '160', NULL, '03', 'N', NULL, NULL, NULL, 467);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430786', '4305', 'RS', '4305', '4302', '43016', '43', 'FAGUNDES VARELA', NULL, '54', '95333000', '4', '8411', '8411', '19276', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 134.291, '-28,88100', '-51,69800', 610, 'S', 0.8120, NULL, NULL, '43900', 'N', 'N', 1715, NULL, '4390', '4390', NULL, '1989', 'S', 4055, 'FAGUNDES VARELA', 'N', '430786', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '161', NULL, '03', 'N', NULL, NULL, NULL, 481);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430790', '4305', 'RS', '4305', '4302', '43016', '43', 'FARROUPILHA', NULL, '54', '95180000', '6', '8655', '8655', '19078', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 361.788, '-29,22500', '-51,34800', 783, 'S', 0.8440, NULL, NULL, '43900', 'N', 'N', 1722, NULL, '4303', '4302', NULL, '1934', 'S', 4056, 'FARROUPILHA', 'N', '430790', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '162', NULL, '02', 'N', NULL, NULL, NULL, 482);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430800', '4304', 'RS', '4301', '4303', '43019', '43', 'FAXINAL DO SOTURNO', NULL, '55', '97220000', '3', '8657', '8657', '19079', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 169.945, '-29,57500', '-53,44500', 53, 'S', 0.7930, NULL, NULL, '43900', 'N', 'N', 1729, NULL, '4390', '4390', NULL, '1959', 'S', 4057, 'FAXINAL DO SOTURNO', 'N', '430800', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '163', NULL, '03', 'N', NULL, NULL, NULL, 457);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430805', '4311', 'RS', '4304', '4301', '43004', '43', 'FAXINALZINHO', NULL, '54', '99655000', '2', '8409', '8409', '19277', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 143.381, '-27,42400', '-52,67300', 742, 'S', 0.7440, NULL, NULL, '43900', 'N', 'N', 1731, NULL, '4390', '4390', NULL, '1989', 'S', 4058, 'FAXINALZINHO', 'N', '430805', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '164', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430807', '4316', 'RS', '4307', '4304', '43021', '43', 'FAZENDA VILANOVA', NULL, '51', '95875000', '8', '0984', NULL, '19447', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 84.794, '-29,58900', '-51,82500', 145, 'S', 0.7660, NULL, NULL, '43900', 'N', 'N', 1734, NULL, '4390', '4390', NULL, '1997', 'S', 4059, 'FAZENDA VILANOVA', 'N', '430807', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '165', NULL, '03', 'N', NULL, NULL, NULL, 486);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430820', '4305', 'RS', '4305', '4302', '43016', '43', 'FLORES DA CUNHA', NULL, '54', '95270000', '1', '8661', '8661', '19081', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 272.662, '-29,02900', '-51,18200', 756, 'S', 0.8390, NULL, NULL, '43900', 'N', 'N', 1778, NULL, '4303', '4302', NULL, '1924', 'S', 4061, 'FLORES DA CUNHA', 'N', '430820', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '167', NULL, '03', 'N', NULL, NULL, NULL, 482);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430825', '4311', 'RS', '4304', '4301', '43004', '43', 'FLORIANO PEIXOTO', NULL, '55', '99910000', '0', '0986', NULL, '19448', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 168.429, '-27,86100', '-52,08400', 662, 'S', 0.7810, NULL, NULL, '43900', 'N', 'N', 1789, NULL, '4390', '4390', NULL, '1997', 'S', 4062, 'FLORIANO PEIXOTO', 'N', '430825', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '168', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430830', '4306', 'RS', '4307', '4301', '43013', '43', 'FONTOURA XAVIER', NULL, '54', '99370000', '0', '8663', '8663', '19082', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 583.465, '-28,98300', '-52,34600', 773, 'S', 0.7320, NULL, NULL, '43900', 'N', 'N', 1795, NULL, '4390', '4390', NULL, '1965', 'S', 4063, 'FONTOURA XAVIER', 'N', '430830', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '169', NULL, '03', 'N', NULL, NULL, NULL, 475);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430840', '4304', 'RS', '4301', '4303', '43019', '43', 'FORMIGUEIRO', NULL, '55', '97210000', '9', '8665', '8665', '19083', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 581.989, '-30,00000', '-53,49900', 129, 'S', 0.7410, NULL, NULL, '43900', 'N', 'N', 1797, NULL, '4390', '4390', NULL, '1963', 'S', 4064, 'FORMIGUEIRO', 'N', '430840', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '170', NULL, '03', 'N', NULL, NULL, NULL, 457);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430843', '4316', 'RS', '4307', '4304', '43021', '43', 'FORQUETINHA', NULL, '51', '95937000', '3', '1142', NULL, '19483', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 93.567, '-29,38200', '-52,09100', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5656, NULL, '4390', '4390', NULL, '2001', 'S', 5539, 'FORQUETINHA', 'N', '430843', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '171', NULL, '03', 'N', NULL, NULL, NULL, 485);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430845', '4309', 'RS', '4303', '4301', '43011', '43', 'FORTALEZA DOS VALOS', NULL, '55', '98125000', '8', '9827', '9827', '19238', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 650.324, '-28,79700', '-53,22300', 406, 'S', 0.8240, NULL, NULL, '43900', 'N', 'N', 1812, NULL, '4390', '4390', NULL, '1982', 'S', 4065, 'FORTALEZA DOS VALOS', 'N', '430845', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '172', NULL, '03', 'N', NULL, NULL, NULL, 468);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430850', '4319', 'RS', '4304', '4301', '43003', '43', 'FREDERICO WESTPHALEN', NULL, '55', '98400000', '8', '8667', '8667', '19084', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 264.975, '-27,35900', '-53,39400', 522, 'S', 0.8340, NULL, NULL, '43900', 'N', 'N', 1834, NULL, '4390', '4390', NULL, '1954', 'S', 4066, 'FREDERICO WESTPHALEN', 'N', '430850', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '173', NULL, '03', 'N', NULL, NULL, NULL, 471);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430860', '4305', 'RS', '4305', '4302', '43016', '43', 'GARIBALDI', NULL, '54', '95720000', '7', '8669', '8669', '19085', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 167.697, '-29,25600', '-51,53400', 617, 'S', 0.8430, NULL, NULL, '43900', 'N', 'N', 1862, NULL, '4303', '4302', NULL, '1900', 'S', 4067, 'GARIBALDI', 'N', '430860', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '174', NULL, '03', 'N', NULL, NULL, NULL, 481);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430865', '4312', 'RS', '4303', '4306', '43029', '43', 'GARRUCHOS', NULL, '55', '97690000', '6', '6081', '6081', '19359', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 799.849, '-28,18400', '-55,63900', 69, 'S', 0.7150, NULL, NULL, '43900', 'N', 'N', 1865, NULL, '4390', '4390', NULL, '1993', 'S', 4068, 'GARRUCHOS', 'N', '430865', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '175', NULL, '03', 'N', NULL, NULL, NULL, 467);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430870', '4311', 'RS', '4304', '4301', '43004', '43', 'GAURAMA', NULL, '54', '99830000', '6', '8671', '8671', '19086', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 204.149, '-27,58400', '-52,09400', 787, 'S', 0.8140, NULL, NULL, '43900', 'N', 'N', 1870, NULL, '4390', '4390', NULL, '1954', 'S', 4069, 'GAURAMA', 'N', '430870', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '176', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430880', '4302', 'RS', '4307', '4305', '43025', '43', 'GENERAL CAMARA', NULL, '51', '95820000', '5', '8673', '8673', '19087', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 494.025, '-29,90500', '-51,76000', 35, 'S', 0.7840, NULL, NULL, '43900', 'N', 'N', 1874, NULL, '4390', '4390', NULL, '1881', 'S', 4070, 'GENERAL CÂMARA', 'N', '430880', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '177', NULL, '03', 'N', NULL, NULL, NULL, 465);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430885', '4306', 'RS', '4304', '4301', '43010', '43', 'GENTIL', NULL, '54', '99160000', '4', '5799', '5799', '19360', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 184.014, '-28,43000', '-52,03600', 774, 'S', 0.7850, NULL, NULL, '43900', 'N', 'N', 1880, NULL, '4390', '4390', NULL, '1993', 'S', 4071, 'GENTIL', 'N', '430885', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '178', NULL, '03', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430890', '4311', 'RS', '4304', '4301', '43004', '43', 'GETULIO VARGAS', NULL, '54', '99900000', '4', '8677', '8677', '19089', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 286.564, '-27,89000', '-52,22800', 637, 'S', 0.7900, NULL, NULL, '43900', 'N', 'N', 1883, NULL, '4390', '4390', NULL, '1934', 'S', 4072, 'GETÚLIO VARGAS', 'N', '430890', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '179', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430900', '4314', 'RS', '4303', '4301', '43007', '43', 'GIRUA', NULL, '55', '98870000', '1', '8679', '8679', '19090', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 855.923, '-28,02800', '-54,35000', 429, 'S', 0.7750, NULL, NULL, '43900', 'N', 'N', 1886, NULL, '4390', '4390', NULL, '1955', 'S', 4073, 'GIRUÁ', 'N', '430900', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '180', NULL, '03', 'N', NULL, NULL, NULL, 470);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430905', '4302', 'RS', '4302', '4305', '43026', '43', 'GLORINHA', NULL, '51', '94380000', '0', '8407', '8407', '19278', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 323.641, '-29,88100', '-50,76700', 58, 'S', 0.7850, NULL, NULL, '43900', 'N', 'N', 1893, NULL, '4301', '4301', NULL, '1989', 'S', 4074, 'GLORINHA', 'N', '430905', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '181', NULL, '01', 'N', NULL, NULL, NULL, 466);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430910', '4305', 'RS', '4305', '4305', '43024', '43', 'GRAMADO', NULL, '54', '95670000', '0', '8681', '8681', '19091', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 237.019, '-29,37900', '-50,87400', 825, 'S', 0.8410, NULL, NULL, '43900', 'N', 'N', 1934, NULL, '4390', '4390', NULL, '1954', 'S', 4075, 'GRAMADO', 'N', '430910', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '182', NULL, '03', 'N', NULL, NULL, NULL, 479);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430912', '4315', 'RS', '4304', '4301', '43003', '43', 'GRAMADO DOS LOUREIROS', NULL, '54', '99605000', '6', '5949', '5949', '19361', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 131.395, '-27,44400', '-52,91800', 520, 'S', 0.7140, NULL, NULL, '43900', 'N', 'N', 1935, NULL, '4390', '4390', NULL, '1993', 'S', 4076, 'GRAMADO DOS LOUREIROS', 'N', '430912', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '183', NULL, '03', 'N', NULL, NULL, NULL, 476);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430915', '4313', 'RS', '4307', '4304', '43020', '43', 'GRAMADO XAVIER', NULL, '51', '96875000', '9', '5763', '5763', '19362', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 217.524, '-29,26800', '-52,57900', 463, 'S', 0.7490, NULL, NULL, '43900', 'N', 'N', 1936, NULL, '4390', '4390', NULL, '1993', 'S', 4077, 'GRAMADO XAVIER', 'N', '430915', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '184', NULL, '03', 'N', NULL, NULL, NULL, 484);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430920', '4302', 'RS', '4302', '4305', '43026', '43', 'GRAVATAI', NULL, '51', '94000970', '9', '8683', '8683', '19092', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 463.758, '-29,94400', '-50,99200', 26, 'S', 0.8110, NULL, NULL, '43900', 'N', 'N', 1944, NULL, '4301', '4301', NULL, '1880', 'S', 4078, 'GRAVATAÍ', 'N', '430920', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '185', NULL, '01', 'N', NULL, NULL, NULL, 466);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430925', '4305', 'RS', '4305', '4302', '43014', '43', 'GUABIJU', NULL, '54', '95355000', '8', '8405', '8405', '19279', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 148.393, '-28,54100', '-51,69000', 720, 'S', 0.8260, NULL, NULL, '43900', 'N', 'N', 1949, NULL, '4390', '4390', NULL, '1989', 'S', 4079, 'GUABIJU', 'N', '430925', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '186', NULL, '03', 'N', NULL, NULL, NULL, 481);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430930', '4302', 'RS', '4302', '4305', '43026', '43', 'GUAIBA', NULL, '51', '92500000', '8', '8685', '8685', '19093', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 376.973, '-30,11400', '-51,32500', 23, 'S', 0.8150, NULL, NULL, '43900', 'N', 'N', 1953, NULL, '4301', '4301', NULL, '1926', 'S', 4080, 'GUAÍBA', 'N', '430930', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '187', NULL, '01', 'N', NULL, NULL, NULL, 465);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430940', '4305', 'RS', '4305', '4302', '43014', '43', 'GUAPORE', NULL, '54', '99200000', '7', '8687', '8687', '19094', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 297.661, '-28,84600', '-51,89000', 478, 'S', 0.8260, NULL, NULL, '43900', 'N', 'N', 1973, NULL, '4390', '4390', NULL, '1903', 'S', 4081, 'GUAPORÉ', 'N', '430940', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '188', NULL, '03', 'N', NULL, NULL, NULL, 481);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430950', '4312', 'RS', '4303', '4301', '43006', '43', 'GUARANI DAS MISSOES', NULL, '55', '97950000', '6', '8689', '8689', '19095', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 290.495, '-28,14100', '-54,55800', 267, 'S', 0.7760, NULL, NULL, '43900', 'N', 'N', 1991, NULL, '4390', '4390', NULL, '1959', 'S', 4082, 'GUARANI DAS MISSÕES', 'N', '430950', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '189', NULL, '03', 'N', NULL, NULL, NULL, 467);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430955', '4301', 'RS', '4302', '4305', '43023', '43', 'HARMONIA', NULL, '51', '95785000', '5', '8403', '8403', '19280', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 44.579, '-29,54800', '-51,42600', 126, 'S', 0.8330, NULL, NULL, '43900', 'N', 'N', 2028, NULL, '4390', '4390', NULL, '1989', 'S', 4083, 'HARMONIA', 'N', '430955', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '190', NULL, '03', 'N', NULL, NULL, NULL, 464);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430957', '4313', 'RS', '4307', '4304', '43020', '43', 'HERVEIRAS', NULL, '51', '96888000', '1', '0988', NULL, '19449', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 118.280, '-29,40700', '-52,65300', 530, 'S', 0.7600, NULL, NULL, '43900', 'N', 'N', 2035, NULL, '4390', '4390', NULL, '1997', 'S', 4085, 'HERVEIRAS', 'N', '430957', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '192', NULL, '03', 'N', NULL, NULL, NULL, 484);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430960', '4314', 'RS', '4303', '4301', '43002', '43', 'HORIZONTINA', NULL, '55', '98920000', '5', '8691', '8691', '19096', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 228.849, '-27,62600', '-54,30800', 343, 'S', 0.8250, NULL, NULL, '43900', 'N', 'N', 2042, NULL, '4390', '4390', NULL, '1954', 'S', 4086, 'HORIZONTINA', 'N', '430960', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '193', NULL, '03', 'N', NULL, NULL, NULL, 470);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430965', '4307', 'RS', '4306', '4306', '43031', '43', 'HULHA NEGRA', NULL, '53', '96460000', '4', '6085', '6085', '19363', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 822.943, '-31,40400', '-53,86900', 196, 'S', 0.7610, NULL, NULL, '43900', 'N', 'N', 2045, NULL, '4390', '4390', NULL, '1993', 'S', 4087, 'HULHA NEGRA', 'N', '430965', 'N', 'N', 'S', NULL, 104, 'N', 'N', 'N', '194', NULL, '03', 'N', NULL, NULL, NULL, 478);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430970', '4317', 'RS', '4303', '4301', '43002', '43', 'HUMAITA', NULL, '55', '98670000', '4', '8695', '8695', '19097', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 135.246, '-27,56300', '-53,97400', 466, 'S', 0.8020, NULL, NULL, '43900', 'N', 'N', 2046, NULL, '4390', '4390', NULL, '1959', 'S', 4088, 'HUMAITÁ', 'N', '430970', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '195', NULL, '03', 'N', NULL, NULL, NULL, 469);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430975', '4308', 'RS', '4301', '4304', '43020', '43', 'IBARAMA', NULL, '51', '96925000', '3', '8401', '8401', '19281', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 193.109, '-29,41900', '-53,13500', 317, 'S', 0.7400, NULL, NULL, '43900', 'N', 'N', 2057, NULL, '4390', '4390', NULL, '1989', 'S', 4089, 'IBARAMA', 'N', '430975', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '196', NULL, '03', 'N', NULL, NULL, NULL, 483);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430980', '4306', 'RS', '4304', '4301', '43005', '43', 'IBIACA', NULL, '54', '99940000', '3', '8697', '8697', '19098', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 350.870, '-28,05700', '-51,85500', 620, 'S', 0.8380, NULL, NULL, '43900', 'N', 'N', 2065, NULL, '4390', '4390', NULL, '1965', 'S', 4090, 'IBIAÇÁ', 'N', '430980', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '197', NULL, '03', 'N', NULL, NULL, NULL, 474);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430990', '4306', 'RS', '4304', '4301', '43010', '43', 'IBIRAIARAS', NULL, '54', '95305000', '2', '8699', '8699', '19099', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 300.650, '-28,37000', '-51,63600', 776, 'S', 0.8010, NULL, NULL, '43900', 'N', 'N', 2085, NULL, '4390', '4390', NULL, '1965', 'S', 4091, 'IBIRAIARAS', 'N', '430990', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '198', NULL, '03', 'N', NULL, NULL, NULL, 474);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('430995', '4306', 'RS', '4304', '4301', '43013', '43', 'IBIRAPUITA', NULL, '54', '99320000', '1', '7299', '7299', '19282', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 307.028, '-28,62400', '-52,51100', 641, 'S', 0.7120, NULL, NULL, '43900', 'N', 'N', 2090, NULL, '4390', '4390', NULL, '1989', 'S', 4092, 'IBIRAPUITÃ', 'N', '430995', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '199', NULL, '03', 'N', NULL, NULL, NULL, 475);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431000', '4309', 'RS', '4303', '4301', '43011', '43', 'IBIRUBA', NULL, '54', '98200000', '9', '8701', '8701', '19100', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 611.807, '-28,62800', '-53,09000', 416, 'S', 0.8240, NULL, NULL, '43900', 'N', 'N', 2094, NULL, '4390', '4390', NULL, '1954', 'S', 4093, 'IBIRUBÁ', 'N', '431000', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '200', NULL, '03', 'N', NULL, NULL, NULL, 468);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431010', '4301', 'RS', '4302', '4305', '43024', '43', 'IGREJINHA', NULL, '51', '95650000', '8', '8703', '8703', '19101', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 136.816, '-29,57400', '-50,79000', 18, 'S', 0.8220, NULL, NULL, '43900', 'N', 'N', 2129, NULL, '4301', '4301', NULL, '1964', 'S', 4094, 'IGREJINHA', 'N', '431010', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '201', NULL, '03', 'N', NULL, NULL, NULL, 462);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431020', '4317', 'RS', '4303', '4301', '43008', '43', 'IJUI', NULL, '55', '98700000', '7', '8705', '8705', '19102', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 689.124, '-28,38800', '-53,91500', 328, 'S', 0.8030, NULL, NULL, '43900', 'N', 'N', 2140, NULL, '4390', '4390', NULL, '1912', 'S', 4095, 'IJUÍ', 'N', '431020', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '202', NULL, '02', 'N', NULL, NULL, NULL, 469);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431030', '4316', 'RS', '4307', '4302', '43014', '43', 'ILOPOLIS', NULL, '51', '95990000', '6', '8707', '8707', '19103', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 116.481, '-28,92700', '-52,12400', 683, 'S', 0.7920, NULL, NULL, '43900', 'N', 'N', 2149, NULL, '4390', '4390', NULL, '1963', 'S', 4096, 'ILÓPOLIS', 'N', '431030', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '203', NULL, '03', 'N', NULL, NULL, NULL, 485);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431033', '4318', 'RS', '4302', '4305', '43027', '43', 'IMBE', NULL, '51', '95625000', '0', '7297', '7297', '19283', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 39.549, '-29,97500', '-50,12800', 500, 'S', 0.8190, NULL, NULL, '43900', 'N', 'N', 2153, NULL, '4302', '4390', NULL, '1989', 'S', 4097, 'IMBÉ', 'N', '431033', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '204', NULL, '03', 'N', NULL, NULL, NULL, 461);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431036', '4316', 'RS', '4307', '4304', '43021', '43', 'IMIGRANTE', NULL, '51', '95885000', '3', '7295', '7295', '19284', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 73.355, '-29,35500', '-51,77700', 100, 'S', 0.8280, NULL, NULL, '43900', 'N', 'N', 2158, NULL, '4390', '4390', NULL, '1989', 'S', 4098, 'IMIGRANTE', 'N', '431036', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '205', NULL, '03', 'N', NULL, NULL, NULL, 486);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431040', '4314', 'RS', '4303', '4301', '43001', '43', 'INDEPENDENCIA', NULL, '55', '98915000', '5', '8709', '8709', '19104', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 357.435, '-27,83300', '-54,18800', 372, 'S', 0.7850, NULL, NULL, '43900', 'N', 'N', 2168, NULL, '4390', '4390', NULL, '1965', 'S', 4099, 'INDEPENDÊNCIA', 'N', '431040', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '206', NULL, '03', 'N', NULL, NULL, NULL, 470);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431041', '4317', 'RS', '4303', '4301', '43008', '43', 'INHACORA', NULL, '55', '98765000', '3', '6051', '6051', '19364', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 114.135, '-27,88300', '-54,01700', 358, 'S', 0.7540, NULL, NULL, '43900', 'N', 'N', 2180, NULL, '4390', '4390', NULL, '1993', 'S', 4100, 'INHACORÁ', 'N', '431041', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '207', NULL, '03', 'N', NULL, NULL, NULL, 469);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431043', '4305', 'RS', '4305', '4302', '43015', '43', 'IPE', NULL, '54', '95240000', '9', '8399', '8399', '19285', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 599.948, '-28,82000', '-51,27900', 750, 'S', 0.7800, NULL, NULL, '43900', 'N', 'N', 2200, NULL, '4390', '4390', NULL, '1989', 'S', 4101, 'IPÊ', 'N', '431043', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '208', NULL, '03', 'N', NULL, NULL, NULL, 482);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431046', '4311', 'RS', '4304', '4301', '43004', '43', 'IPIRANGA DO SUL', NULL, '54', '99925000', '2', '7399', '7399', '19286', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 159.230, '-27,93700', '-52,42600', 650, 'S', 0.8270, NULL, NULL, '43900', 'N', 'N', 2211, NULL, '4390', '4390', NULL, '1989', 'S', 4102, 'IPIRANGA DO SUL', 'N', '431046', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '209', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431050', '4319', 'RS', '4304', '4301', '43003', '43', 'IRAI', NULL, '55', '98460000', '4', '8711', '8711', '19105', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 182.185, '-27,19400', '-53,25100', 235, 'S', 0.7780, NULL, NULL, '43900', 'N', 'N', 2234, NULL, '4390', '4390', NULL, '1933', 'S', 4103, 'IRAÍ', 'N', '431050', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '210', NULL, '03', 'N', NULL, NULL, NULL, 471);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431053', '4304', 'RS', '4301', '4303', '43018', '43', 'ITAARA', NULL, '55', '97185000', '8', '0990', '9903', '19450', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 171.079, '-29,61000', '-53,76500', 425, 'S', 0.8010, NULL, NULL, '43900', 'N', 'N', 2255, NULL, '4390', '4390', NULL, '1997', 'S', 4104, 'ITAARA', 'N', '431053', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '211', NULL, '03', 'N', NULL, NULL, NULL, 457);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431055', '4304', 'RS', '4303', '4303', '43017', '43', 'ITACURUBI', NULL, '55', '97685000', '3', '7397', '7397', '19287', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1118.007, '-28,78700', '-55,25100', 160, 'S', 0.7700, NULL, NULL, '43900', 'N', 'N', 2275, NULL, '4390', '4390', NULL, '1989', 'S', 4105, 'ITACURUBI', 'N', '431055', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '212', NULL, '03', 'N', NULL, NULL, NULL, 458);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431057', '4306', 'RS', '4307', '4302', '43014', '43', 'ITAPUCA', NULL, '54', '95997000', '9', '6027', '6027', '19365', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 184.249, '-28,78000', '-52,17200', 660, 'S', 0.7290, NULL, NULL, '43900', 'N', 'N', 2369, NULL, '4390', '4390', NULL, '1993', 'S', 4106, 'ITAPUCA', 'N', '431057', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '213', NULL, '03', 'N', NULL, NULL, NULL, 475);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431060', '4310', 'RS', '4301', '4306', '43029', '43', 'ITAQUI', NULL, '55', '97650000', '3', '8713', '8713', '19106', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3404.047, '-29,12500', '-56,55300', 57, 'S', 0.8010, NULL, NULL, '43900', 'N', 'N', 2375, NULL, '4390', '4390', NULL, '1858', 'S', 4107, 'ITAQUI', 'N', '431060', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '214', NULL, '03', 'N', NULL, NULL, NULL, 459);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431065', '4318', 'RS', '4302', '4305', '43027', '43', 'ITATI', NULL, '51', '95538000', '2', '1144', NULL, '19484', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 201.402, '-29,48800', '-50,10500', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5658, NULL, '4302', '4390', NULL, '2001', 'S', 5540, 'ITATI', 'N', '431065', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '215', NULL, '03', 'N', NULL, NULL, NULL, 460);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431070', '4311', 'RS', '4304', '4301', '43004', '43', 'ITATIBA DO SUL', NULL, '54', '99760000', '2', '8715', '8715', '19107', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 212.121, '-27,38700', '-52,45300', 771, 'S', 0.7750, NULL, NULL, '43900', 'N', 'N', 2387, NULL, '4390', '4390', NULL, '1964', 'S', 4108, 'ITATIBA DO SUL', 'N', '431070', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '216', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431075', '4304', 'RS', '4301', '4303', '43019', '43', 'IVORA', NULL, '55', '98160000', '1', '7395', '7395', '19288', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 122.887, '-29,52000', '-53,58100', 120, 'S', 0.7770, NULL, NULL, '43900', 'N', 'N', 2431, NULL, '4390', '4390', NULL, '1989', 'S', 4109, 'IVORÁ', 'N', '431075', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '217', NULL, '03', 'N', NULL, NULL, NULL, 457);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431080', '4301', 'RS', '4302', '4305', '43024', '43', 'IVOTI', NULL, '51', '93900000', '1', '8717', '8717', '19108', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 63.138, '-29,59100', '-51,16100', 127, 'S', 0.8510, NULL, NULL, '43900', 'N', 'N', 2432, NULL, '4301', '4301', NULL, '1964', 'S', 4110, 'IVOTI', 'N', '431080', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '218', NULL, '01', 'N', NULL, NULL, NULL, 463);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431085', '4315', 'RS', '4304', '4301', '43009', '43', 'JABOTICABA', NULL, '55', '98350000', '0', '7393', '7393', '19289', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 128.053, '-27,63100', '-53,27700', 561, 'S', 0.7340, NULL, NULL, '43900', 'N', 'N', 2438, NULL, '4390', '4390', NULL, '1989', 'S', 4111, 'JABOTICABA', 'N', '431085', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '219', NULL, '03', 'N', NULL, NULL, NULL, 476);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431087', '4309', 'RS', '4303', '4301', '43011', '43', 'JACUIZINHO', NULL, '55', '99457000', '6', '1146', NULL, '19485', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 315.672, '-29,03400', '-53,05900', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5660, NULL, '4390', '4390', NULL, '2001', 'S', 5541, 'JACUIZINHO', 'N', '431087', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '220', NULL, '03', 'N', NULL, NULL, NULL, 468);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431090', '4311', 'RS', '4304', '4301', '43004', '43', 'JACUTINGA', NULL, '54', '99730000', '0', '8719', '8719', '19109', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 179.296, '-27,72900', '-52,53500', 577, 'S', 0.8000, NULL, NULL, '43900', 'N', 'N', 2459, NULL, '4390', '4390', NULL, '1964', 'S', 4112, 'JACUTINGA', 'N', '431090', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '221', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431100', '4303', 'RS', '4306', '4307', '43034', '43', 'JAGUARAO', NULL, '53', '96300000', '7', '8721', '8721', '19110', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2054.390, '-32,56600', '-53,37600', 26, 'S', 0.7640, NULL, NULL, '43900', 'N', 'N', 2463, NULL, '4390', '4390', NULL, '1832', 'S', 4113, 'JAGUARÃO', 'N', '431100', 'N', 'N', 'S', NULL, 104, 'N', 'N', 'N', '222', NULL, '03', 'N', NULL, NULL, NULL, 477);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431110', '4304', 'RS', '4301', '4303', '43018', '43', 'JAGUARI', NULL, '55', '97760000', '6', '8723', '8723', '19111', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 673.459, '-29,49700', '-54,69000', 112, 'S', 0.7950, NULL, NULL, '43900', 'N', 'N', 2467, NULL, '4390', '4390', NULL, '1920', 'S', 4114, 'JAGUARI', 'N', '431110', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '223', NULL, '03', 'N', NULL, NULL, NULL, 458);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431112', '4305', 'RS', '4305', '4302', '43015', '43', 'JAQUIRANA', NULL, '54', '95420000', '2', '7391', '7391', '19290', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 907.936, '-28,88500', '-50,35800', 927, 'S', 0.7340, NULL, NULL, '43900', 'N', 'N', 2502, NULL, '4390', '4390', NULL, '1989', 'S', 4115, 'JAQUIRANA', 'N', '431112', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '224', NULL, '03', 'N', NULL, NULL, NULL, 480);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431113', '4304', 'RS', '4301', '4303', '43017', '43', 'JARI', NULL, '55', '98175000', '0', '0992', NULL, '19451', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 856.459, '-29,29100', '-54,22400', 441, 'S', 0.7510, NULL, NULL, '43900', 'N', 'N', 2517, NULL, '4390', '4390', NULL, '1997', 'S', 4116, 'JARI', 'N', '431113', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '225', NULL, '03', 'N', NULL, NULL, NULL, 458);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431115', '4317', 'RS', '4303', '4301', '43011', '43', 'JOIA', NULL, '55', '98180000', '5', '9829', '9829', '19245', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1235.885, '-28,64700', '-54,12200', 302, 'S', 0.7740, NULL, NULL, '43900', 'N', 'N', 2574, NULL, '4390', '4390', NULL, '1982', 'S', 4117, 'JÓIA', 'N', '431115', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '226', NULL, '03', 'N', NULL, NULL, NULL, 469);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431120', '4304', 'RS', '4301', '4303', '43017', '43', 'JULIO DE CASTILHOS', NULL, '55', '98130000', '5', '8725', '8725', '19112', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1929.383, '-29,22700', '-53,68200', 513, 'S', 0.8040, NULL, NULL, '43900', 'N', 'N', 2602, NULL, '4390', '4390', NULL, '1891', 'S', 4118, 'JÚLIO DE CASTILHOS', 'N', '431120', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '227', NULL, '03', 'N', NULL, NULL, NULL, 457);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431123', '4308', 'RS', '4307', '4304', '43020', '43', 'LAGOA BONITA DO SUL', NULL, '51', '96920000', '9', '1148', NULL, '19486', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 108.500, '-29,48900', '-53,01300', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5662, NULL, '4390', '4390', NULL, '2001', 'S', 5542, 'LAGOA BONITA DO SUL', 'N', '431123', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '228', NULL, '03', 'N', NULL, NULL, NULL, 483);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431125', '4306', 'RS', '4304', '4301', '43013', '43', 'LAGOAO', NULL, '51', '99340000', '4', '7389', '7389', '19291', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 383.658, '-29,23500', '-52,79600', 577, 'S', 0.6740, NULL, NULL, '43900', 'S', 'N', 2680, NULL, '4390', '4390', NULL, '1989', 'S', 4121, 'LAGOÃO', 'N', '431125', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '231', NULL, '03', 'N', NULL, NULL, NULL, 475);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431127', '4306', 'RS', '4304', '4301', '43012', '43', 'LAGOA DOS TRES CANTOS', NULL, '54', '99495000', '0', '5951', '5951', '19366', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 138.636, '-28,57100', '-52,85800', 482, 'S', 0.8380, NULL, NULL, '43900', 'N', 'N', 2668, NULL, '4390', '4390', NULL, '1993', 'S', 4119, 'LAGOA DOS TRÊS CANTOS', 'N', '431127', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '229', NULL, '03', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431130', '4306', 'RS', '4304', '4302', '43015', '43', 'LAGOA VERMELHA', NULL, '54', '95300000', '4', '8727', '8727', '19113', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1262.225, '-28,20900', '-51,52600', 801, 'S', 0.7550, NULL, NULL, '43900', 'N', 'N', 2679, NULL, '4390', '4390', NULL, '1881', 'S', 4120, 'LAGOA VERMELHA', 'N', '431130', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '230', NULL, '03', 'N', NULL, NULL, NULL, 474);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431140', '4316', 'RS', '4307', '4304', '43021', '43', 'LAJEADO', NULL, '51', '95900000', '3', '8729', '8729', '19114', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 90.419, '-29,46700', '-51,96100', 31, 'S', 0.8380, NULL, NULL, '43900', 'N', 'N', 2687, NULL, '4390', '4390', NULL, '1891', 'S', 4122, 'LAJEADO', 'N', '431140', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '232', NULL, '02', 'N', NULL, NULL, NULL, 485);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431142', '4315', 'RS', '4304', '4301', '43009', '43', 'LAJEADO DO BUGRE', NULL, '55', '98320000', '9', '5983', '5983', '19367', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 67.903, '-27,68900', '-53,18200', 424, 'S', 0.7110, NULL, NULL, '43900', 'N', 'N', 2689, NULL, '4390', '4390', NULL, '1993', 'S', 4123, 'LAJEADO DO BUGRE', 'N', '431142', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '233', NULL, '03', 'N', NULL, NULL, NULL, 476);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431150', '4307', 'RS', '4306', '4306', '43031', '43', 'LAVRAS DO SUL', NULL, '55', '97390000', '2', '8731', '8731', '19115', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2599.811, '-30,81300', '-53,89500', 277, 'S', 0.7720, NULL, NULL, '43900', 'N', 'N', 2722, NULL, '4390', '4390', NULL, '1882', 'S', 4124, 'LAVRAS DO SUL', 'N', '431150', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '234', NULL, '03', 'N', NULL, NULL, NULL, 478);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431160', '4319', 'RS', '4304', '4301', '43003', '43', 'LIBERATO SALZANO', NULL, '55', '99690000', '1', '8733', '8733', '19116', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 245.629, '-27,60000', '-53,07300', 360, 'S', 0.7200, NULL, NULL, '43900', 'N', 'N', 2734, NULL, '4390', '4390', NULL, '1964', 'S', 4125, 'LIBERATO SALZANO', 'N', '431160', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '235', NULL, '03', 'N', NULL, NULL, NULL, 471);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431162', '4301', 'RS', '4302', '4305', '43024', '43', 'LINDOLFO COLLOR', NULL, '51', '93940000', '7', '6017', '6017', '19368', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 33.055, '-29,59700', '-51,20900', 40, 'S', 0.8050, NULL, NULL, '43900', 'N', 'N', 2749, NULL, '4390', '4390', NULL, '1993', 'S', 4126, 'LINDOLFO COLLOR', 'N', '431162', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '236', NULL, '03', 'N', NULL, NULL, NULL, 463);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431164', '4305', 'RS', '4305', '4305', '43023', '43', 'LINHA NOVA', NULL, '51', '95768000', '3', '6047', '6047', '19369', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 63.733, '-29,46800', '-51,20100', 365, 'S', 0.8140, NULL, NULL, '43900', 'N', 'N', 2750, NULL, '4390', '4390', NULL, '1993', 'S', 4127, 'LINHA NOVA', 'N', '431164', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '237', NULL, '03', 'N', NULL, NULL, NULL, 479);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431170', '4306', 'RS', '4304', '4301', '43005', '43', 'MACHADINHO', NULL, '54', '99880000', '0', '8735', '8735', '19117', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 334.449, '-27,56700', '-51,66800', 757, 'S', 0.7340, NULL, NULL, '43900', 'N', 'N', 2806, NULL, '4390', '4390', NULL, '1959', 'S', 4129, 'MACHADINHO', 'N', '431170', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '239', NULL, '03', 'N', NULL, NULL, NULL, 474);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431171', '4310', 'RS', '4301', '4306', '43029', '43', 'MACAMBARA', NULL, '55', '97645000', '8', '0994', NULL, '19452', NULL, 'ATIVO', 'N', 'S', NULL, 'MAÇAMBARA                 ', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1682.821, '-29,14300', '-56,06500', 110, 'S', 0.7430, NULL, NULL, '43900', 'N', 'N', 2794, NULL, '4390', '4390', NULL, '1997', 'S', 4128, 'MAÇAMBARÁ', 'N', '431171', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '238', NULL, '03', 'N', NULL, NULL, NULL, 459);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431173', '4318', 'RS', '4302', '4305', '43027', '43', 'MAMPITUBA', NULL, '51', '95572000', '4', '0996', NULL, '19453', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 157.875, '-29,21100', '-49,93500', 37, 'S', 0.7160, NULL, NULL, '43900', 'N', 'N', 2845, NULL, '4302', '4390', NULL, '1997', 'S', 4130, 'MAMPITUBA', 'N', '431173', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '240', NULL, '03', 'N', NULL, NULL, NULL, 460);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431175', '4310', 'RS', '4301', '4306', '43029', '43', 'MANOEL VIANA', NULL, '55', '97640000', '9', '6079', '6079', '19370', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1390.700, '-29,58900', '-55,48300', 113, 'S', 0.7540, NULL, NULL, '43900', 'N', 'N', 2866, NULL, '4390', '4390', NULL, '1993', 'S', 4131, 'MANOEL VIANA', 'N', '431175', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '241', NULL, '03', 'N', NULL, NULL, NULL, 459);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431177', '4318', 'RS', '4302', '4305', '43027', '43', 'MAQUINE', NULL, '51', '95530000', '5', '5783', '5783', '19371', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 622.121, '-29,67500', '-50,20700', 12, 'S', 0.7670, NULL, NULL, '43900', 'N', 'N', 2871, NULL, '4302', '4390', NULL, '1993', 'S', 4132, 'MAQUINÉ', 'N', '431177', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '242', NULL, '03', 'N', NULL, NULL, NULL, 460);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431179', '4301', 'RS', '4302', '4305', '43023', '43', 'MARATA', NULL, '51', '95793000', '1', '6039', '6039', '19372', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 80.354, '-29,54900', '-51,55400', 30, 'S', 0.8130, NULL, NULL, '43900', 'N', 'N', 2893, NULL, '4390', '4390', NULL, '1993', 'S', 4133, 'MARATÁ', 'N', '431179', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '243', NULL, '03', 'N', NULL, NULL, NULL, 464);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431180', '4306', 'RS', '4304', '4301', '43010', '43', 'MARAU', NULL, '54', '99150000', '9', '8737', '8737', '19118', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 649.300, '-28,44900', '-52,20000', 571, 'S', 0.8300, NULL, NULL, '43900', 'N', 'N', 2896, NULL, '4390', '4390', NULL, '1954', 'S', 4134, 'MARAU', 'N', '431180', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '244', NULL, '03', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431190', '4311', 'RS', '4304', '4301', '43004', '43', 'MARCELINO RAMOS', NULL, '54', '99800000', '8', '8739', '8739', '19119', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 229.619, '-27,46200', '-51,90600', 405, 'S', 0.7920, NULL, NULL, '43900', 'N', 'N', 2902, NULL, '4390', '4390', NULL, '1944', 'S', 4135, 'MARCELINO RAMOS', 'N', '431190', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '245', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431198', '4302', 'RS', '4302', '4305', '43026', '43', 'MARIANA PIMENTEL', NULL, '51', '92900000', '1', '5759', '5759', '19373', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 338.131, '-30,35300', '-51,58300', 119, 'S', 0.7870, NULL, NULL, '43900', 'N', 'N', 2918, NULL, '4390', '4390', NULL, '1993', 'S', 4136, 'MARIANA PIMENTEL', 'N', '431198', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '246', NULL, '03', 'N', NULL, NULL, NULL, 465);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431200', '4311', 'RS', '4304', '4301', '43004', '43', 'MARIANO MORO', NULL, '54', '99790000', '5', '8741', '8741', '19120', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 99.110, '-27,35400', '-52,14700', 475, 'S', 0.7970, NULL, NULL, '43900', 'N', 'N', 2919, NULL, '4390', '4390', NULL, '1965', 'S', 4137, 'MARIANO MORO', 'N', '431200', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '247', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431205', '4316', 'RS', '4307', '4304', '43021', '43', 'MARQUES DE SOUZA', NULL, '51', '95923000', '4', '0998', NULL, '19454', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 125.175, '-29,32800', '-52,09300', 69, 'S', 0.7950, NULL, NULL, '43900', 'N', 'N', 2941, NULL, '4390', '4390', NULL, '1997', 'S', 4138, 'MARQUES DE SOUZA', 'N', '431205', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '248', NULL, '03', 'N', NULL, NULL, NULL, 485);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431210', '4304', 'RS', '4301', '4303', '43018', '43', 'MATA', NULL, '55', '97410000', '4', '8743', '8743', '19121', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 312.120, '-29,56600', '-54,46000', 127, 'S', 0.7520, NULL, NULL, '43900', 'N', 'N', 2956, NULL, '4390', '4390', NULL, '1964', 'S', 4139, 'MATA', 'N', '431210', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '249', NULL, '03', 'N', NULL, NULL, NULL, 458);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431213', '4306', 'RS', '4304', '4301', '43010', '43', 'MATO CASTELHANO', NULL, '54', '99180000', '8', '5931', '5931', '19374', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 238.364, '-28,27800', '-52,19200', 740, 'S', 0.7740, NULL, NULL, '43900', 'N', 'N', 2976, NULL, '4390', '4390', NULL, '1993', 'S', 4140, 'MATO CASTELHANO', 'N', '431213', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '250', NULL, '03', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431215', '4313', 'RS', '4307', '4304', '43020', '43', 'MATO LEITAO', NULL, '51', '95835000', '3', '6031', '6031', '19375', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 45.903, '-29,52400', '-52,12900', 81, 'S', 0.8010, NULL, NULL, '43900', 'N', 'N', 2978, NULL, '4390', '4390', NULL, '1993', 'S', 4141, 'MATO LEITÃO', 'N', '431215', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '251', NULL, '03', 'N', NULL, NULL, NULL, 484);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431217', '4312', 'RS', '4303', '4301', '43006', '43', 'MATO QUEIMADO', NULL, '55', '97935000', '9', '1150', NULL, '19487', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 114.635, '-28,25600', '-54,61600', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5664, NULL, '4390', '4390', NULL, '2001', 'S', 5543, 'MATO QUEIMADO', 'N', '431217', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '252', NULL, '03', 'N', NULL, NULL, NULL, 467);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510325', '5109', 'MT', '5190', '5101', '51001', '51', 'COLNIZA', NULL, '66', '78335000', '4', '1080', '1080', '10193', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 27947.646, '-9,45600', '-59,22900', 0, 'S', NULL, NULL, NULL, '51900', 'S', 'N', 5694, NULL, '5190', '5190', NULL, '2001', 'S', 5566, 'COLNIZA', 'N', '510325', 'S', 'N', 'S', NULL, 163, 'N', 'N', 'N', '33', NULL, '03', 'N', NULL, NULL, NULL, 423);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431220', '4306', 'RS', '4304', '4301', '43005', '43', 'MAXIMILIANO DE ALMEIDA', NULL, '54', '99890000', '3', '8745', '8745', '19122', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 208.524, '-27,63200', '-51,80300', 583, 'S', 0.7470, NULL, NULL, '43900', 'N', 'N', 2997, NULL, '4390', '4390', NULL, '1961', 'S', 4142, 'MAXIMILIANO DE ALMEIDA', 'N', '431220', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '253', NULL, '03', 'N', NULL, NULL, NULL, 474);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431225', '4302', 'RS', '4302', '4305', '43025', '43', 'MINAS DO LEAO', NULL, '51', '96755000', '2', '5773', '5773', '19376', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 424.007, '-30,12700', '-52,04800', 64, 'S', 0.7280, NULL, NULL, '43900', 'N', 'N', 3031, NULL, '4390', '4390', NULL, '1993', 'S', 4143, 'MINAS DO LEÃO', 'N', '431225', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '254', NULL, '03', 'N', NULL, NULL, NULL, 465);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431230', '4315', 'RS', '4303', '4301', '43002', '43', 'MIRAGUAI', NULL, '55', '98540000', '2', '8747', '8747', '19123', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 130.425, '-27,49400', '-53,68600', 488, 'S', 0.7260, NULL, NULL, '43900', 'N', 'N', 3045, NULL, '4390', '4390', NULL, '1965', 'S', 4144, 'MIRAGUAÍ', 'N', '431230', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '255', NULL, '03', 'N', NULL, NULL, NULL, 476);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431235', '4306', 'RS', '4304', '4302', '43014', '43', 'MONTAURI', NULL, '54', '99255000', '1', '7387', '7387', '19292', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 82.077, '-28,65200', '-52,07000', 449, 'S', 0.8250, NULL, NULL, '43900', 'N', 'N', 3093, NULL, '4390', '4390', NULL, '1989', 'S', 4145, 'MONTAURI', 'N', '431235', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '256', NULL, '03', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431237', '4305', 'RS', '4305', '4302', '43015', '43', 'MONTE ALEGRE DOS CAMPOS', NULL, '54', '95236000', '7', '1000', NULL, '19455', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 549.740, '-28,68300', '-50,78300', 926, 'S', 0.7080, NULL, NULL, '43900', 'N', 'N', 3101, NULL, '4390', '4390', NULL, '1997', 'S', 4146, 'MONTE ALEGRE DOS CAMPOS', 'N', '431237', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '257', NULL, '03', 'N', NULL, NULL, NULL, 480);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431238', '4305', 'RS', '4305', '4302', '43016', '43', 'MONTE BELO DO SUL', NULL, '54', '95718000', '5', '5993', '5993', '19430', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 68.369, '-29,16300', '-51,63200', 645, 'S', 0.8270, NULL, NULL, '43900', 'N', 'N', 3107, NULL, '4303', '4302', NULL, '1993', 'S', 4147, 'MONTE BELO DO SUL', 'N', '431238', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '258', NULL, '03', 'N', NULL, NULL, NULL, 481);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431240', '4301', 'RS', '4302', '4305', '43023', '43', 'MONTENEGRO', NULL, '51', '95780000', '1', '8749', '8749', '19124', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 420.017, '-29,68900', '-51,46100', 31, 'S', 0.8330, NULL, NULL, '43900', 'N', 'N', 3125, NULL, '4301', '4390', NULL, '1873', 'S', 4148, 'MONTENEGRO', 'N', '431240', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '259', NULL, '01', 'N', NULL, NULL, NULL, 464);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431242', '4306', 'RS', '4304', '4301', '43013', '43', 'MORMACO', NULL, '54', '99315000', '7', '5933', '5933', '19377', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 146.109, '-28,69200', '-52,69200', 410, 'S', 0.7760, NULL, NULL, '43900', 'N', 'N', 3138, NULL, '4390', '4390', NULL, '1993', 'S', 4149, 'MORMAÇO', 'N', '431242', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '260', NULL, '03', 'N', NULL, NULL, NULL, 475);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431244', '4318', 'RS', '4302', '4305', '43027', '43', 'MORRINHOS DO SUL', NULL, '51', '95577000', '3', '5775', '5775', '19378', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 165.440, '-29,36500', '-49,93500', 180, 'S', 0.7380, NULL, NULL, '43900', 'N', 'N', 3143, NULL, '4302', '4390', NULL, '1993', 'S', 4150, 'MORRINHOS DO SUL', 'N', '431244', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '261', NULL, '03', 'N', NULL, NULL, NULL, 460);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431245', '4303', 'RS', '4306', '4307', '43033', '43', 'MORRO REDONDO', NULL, '53', '96150000', '0', '7385', '7385', '19293', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 244.643, '-31,58800', '-52,63300', 245, 'S', 0.7700, NULL, NULL, '43900', 'N', 'N', 3153, NULL, '4390', '4390', NULL, '1989', 'S', 4151, 'MORRO REDONDO', 'N', '431245', 'N', 'N', 'S', NULL, 104, 'N', 'N', 'N', '262', NULL, '03', 'N', NULL, NULL, NULL, 477);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431247', '4301', 'RS', '4302', '4305', '43024', '43', 'MORRO REUTER', NULL, '51', '93990000', '6', '6019', '6019', '19379', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 88.066, '-29,53800', '-51,08100', 492, 'S', 0.8340, NULL, NULL, '43900', 'N', 'N', 3154, NULL, '4390', '4390', NULL, '1993', 'S', 4152, 'MORRO REUTER', 'N', '431247', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '263', NULL, '03', 'N', NULL, NULL, NULL, 463);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431250', '4318', 'RS', '4302', '4305', '43027', '43', 'MOSTARDAS', NULL, '51', '96270000', '0', '8751', '8751', '19125', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1983.117, '-31,10700', '-50,92100', 17, 'S', 0.7800, NULL, NULL, '43900', 'N', 'N', 3160, NULL, '4390', '4390', NULL, '1963', 'S', 4153, 'MOSTARDAS', 'N', '431250', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '264', NULL, '03', 'N', NULL, NULL, NULL, 461);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431260', '4316', 'RS', '4307', '4304', '43021', '43', 'MUCUM', NULL, '51', '95970000', '9', '8753', '8753', '19126', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 110.892, '-29,16500', '-51,86800', 77, 'S', 0.8240, NULL, NULL, '43900', 'N', 'N', 3167, NULL, '4390', '4390', NULL, '1959', 'S', 4154, 'MUÇUM', 'N', '431260', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '265', NULL, '03', 'N', NULL, NULL, NULL, 485);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431261', '4305', 'RS', '4305', '4302', '43015', '43', 'MUITOS CAPOES', NULL, '51', '95230000', '7', '1002', '1002', '19456', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1193.131, '-28,31400', '-51,18200', 937, 'S', 0.7480, NULL, NULL, '43900', 'N', 'N', 3170, NULL, '4390', '4390', NULL, '1997', 'S', 4155, 'MUITOS CAPÕES', 'N', '431261', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '266', NULL, '03', 'N', NULL, NULL, NULL, 480);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431262', '4306', 'RS', '4304', '4301', '43010', '43', 'MULITERNO', NULL, '54', '99990000', '5', '5935', '5935', '19380', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 111.132, '-28,32900', '-51,76800', 824, 'S', 0.7430, NULL, NULL, '43900', 'N', 'N', 3171, NULL, '4390', '4390', NULL, '1993', 'S', 4156, 'MULITERNO', 'N', '431262', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '267', NULL, '03', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431265', '4306', 'RS', '4304', '4301', '43012', '43', 'NAO-ME-TOQUE', NULL, '54', '99470000', '8', '8755', '8755', '19127', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 361.670, '-28,45900', '-52,82100', 514, 'S', 0.8330, NULL, NULL, '43900', 'N', 'N', 3198, NULL, '4390', '4390', NULL, '1954', 'S', 4157, 'NÃO-ME-TOQUE', 'N', '431265', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '268', NULL, '03', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431267', '4306', 'RS', '4304', '4301', '43010', '43', 'NICOLAU VERGUEIRO', NULL, '54', '99175000', '4', '5937', '5937', '19381', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 155.820, '-28,53600', '-52,46400', 567, 'S', 0.7960, NULL, NULL, '43900', 'N', 'N', 3224, NULL, '4390', '4390', NULL, '1993', 'S', 4158, 'NICOLAU VERGUEIRO', 'N', '431267', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '269', NULL, '03', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431270', '4311', 'RS', '4304', '4301', '43003', '43', 'NONOAI', NULL, '54', '99600000', '8', '8757', '8757', '19128', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 469.313, '-27,36200', '-52,77100', 584, 'S', 0.7280, NULL, NULL, '43900', 'N', 'N', 3235, NULL, '4390', '4390', NULL, '1959', 'S', 4159, 'NONOAI', 'N', '431270', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '270', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431275', '4306', 'RS', '4304', '4302', '43014', '43', 'NOVA ALVORADA', NULL, '54', '95985000', '7', '7383', '7383', '19294', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 149.362, '-28,67800', '-52,16600', 427, 'S', 0.7980, NULL, NULL, '43900', 'N', 'N', 3250, NULL, '4390', '4390', NULL, '1989', 'S', 4160, 'NOVA ALVORADA', 'N', '431275', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '271', NULL, '03', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431280', '4305', 'RS', '4305', '4302', '43014', '43', 'NOVA ARACA', NULL, '54', '95350000', '7', '8759', '8759', '19129', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 74.360, '-28,65900', '-51,74500', 597, 'S', 0.8340, NULL, NULL, '43900', 'N', 'N', 3255, NULL, '4390', '4390', NULL, '1964', 'S', 4161, 'NOVA ARAÇÁ', 'N', '431280', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '272', NULL, '03', 'N', NULL, NULL, NULL, 481);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431290', '4305', 'RS', '4304', '4302', '43014', '43', 'NOVA BASSANO', NULL, '54', '95340000', '6', '8761', '8761', '19130', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 211.612, '-28,72400', '-51,70500', 563, 'S', 0.8440, NULL, NULL, '43900', 'N', 'N', 3259, NULL, '4390', '4390', NULL, '1964', 'S', 4162, 'NOVA BASSANO', 'N', '431290', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '273', NULL, '03', 'N', NULL, NULL, NULL, 481);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431295', '4315', 'RS', '4304', '4301', '43009', '43', 'NOVA BOA VISTA', NULL, '54', '99580000', '5', '5953', '5953', '19382', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 94.240, '-27,99400', '-52,97900', 435, 'S', 0.8150, NULL, NULL, '43900', 'N', 'N', 3261, NULL, '4390', '4390', NULL, '1993', 'S', 4163, 'NOVA BOA VISTA', 'N', '431295', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '274', NULL, '03', 'N', NULL, NULL, NULL, 476);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431300', '4316', 'RS', '4307', '4304', '43021', '43', 'NOVA BRESCIA', NULL, '51', '95950000', '3', '8763', '8763', '19131', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 102.183, '-29,21400', '-52,02800', 322, 'S', 0.8220, NULL, NULL, '43900', 'N', 'N', 3264, NULL, '4390', '4390', NULL, '1964', 'S', 4164, 'NOVA BRÉSCIA', 'N', '431300', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '275', NULL, '03', 'N', NULL, NULL, NULL, 485);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431301', '4314', 'RS', '4303', '4301', '43002', '43', 'NOVA CANDELARIA', NULL, '55', '98919000', '1', '1004', NULL, '19457', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 97.832, '-27,60700', '-54,10700', 303, 'S', 0.8080, NULL, NULL, '43900', 'N', 'N', 3269, NULL, '4390', '4390', NULL, '1997', 'S', 4165, 'NOVA CANDELÁRIA', 'N', '431301', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '276', NULL, '03', 'N', NULL, NULL, NULL, 470);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431303', '4304', 'RS', '4301', '4303', '43018', '43', 'NOVA ESPERANCA DO SUL', NULL, '55', '97770000', '7', '7381', '7381', '19295', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 191.394, '-29,41000', '-54,82900', 318, 'S', 0.7980, NULL, NULL, '43900', 'N', 'N', 3280, NULL, '4390', '4390', NULL, '1989', 'S', 4166, 'NOVA ESPERANÇA DO SUL', 'N', '431303', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '277', NULL, '03', 'N', NULL, NULL, NULL, 458);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431306', '4301', 'RS', '4302', '4305', '43026', '43', 'NOVA HARTZ', NULL, '51', '93890000', '0', '7379', '7379', '19296', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 62.558, '-29,58300', '-50,90200', 36, 'S', 0.7960, NULL, NULL, '43900', 'N', 'N', 3290, NULL, '4301', '4301', NULL, '1989', 'S', 4167, 'NOVA HARTZ', 'N', '431306', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '278', NULL, '01', 'N', NULL, NULL, NULL, 463);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431308', '4305', 'RS', '4305', '4302', '43016', '43', 'NOVA PADUA', NULL, '54', '95275000', '6', '5991', '5991', '19383', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 103.239, '-29,02900', '-51,30700', 638, 'S', 0.8320, NULL, NULL, '43900', 'N', 'N', 3317, NULL, '4303', '4302', NULL, '1993', 'S', 4168, 'NOVA PÁDUA', 'N', '431308', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '279', NULL, '03', 'N', NULL, NULL, NULL, 482);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431310', '4304', 'RS', '4301', '4303', '43019', '43', 'NOVA PALMA', NULL, '55', '97250000', '2', '8765', '8765', '19132', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 313.506, '-29,47200', '-53,46900', 117, 'S', 0.8030, NULL, NULL, '43900', 'N', 'N', 3318, NULL, '4390', '4390', NULL, '1960', 'S', 4169, 'NOVA PALMA', 'N', '431310', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '280', NULL, '03', 'N', NULL, NULL, NULL, 457);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431320', '4305', 'RS', '4305', '4305', '43024', '43', 'NOVA PETROPOLIS', NULL, '54', '95150000', '1', '8767', '8767', '19133', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 291.079, '-29,37600', '-51,11400', 579, 'S', 0.8470, NULL, NULL, '43900', 'N', 'N', 3320, NULL, '4390', '4390', NULL, '1954', 'S', 4170, 'NOVA PETRÓPOLIS', 'N', '431320', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '281', NULL, '03', 'N', NULL, NULL, NULL, 479);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431330', '4305', 'RS', '4305', '4302', '43014', '43', 'NOVA PRATA', NULL, '54', '95320000', '0', '8769', '8769', '19134', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 258.752, '-28,78400', '-51,61000', 662, 'S', 0.8390, NULL, NULL, '43900', 'N', 'N', 3323, NULL, '4390', '4390', NULL, '1924', 'S', 4171, 'NOVA PRATA', 'N', '431330', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '282', NULL, '03', 'N', NULL, NULL, NULL, 481);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431333', '4317', 'RS', '4303', '4301', '43008', '43', 'NOVA RAMADA', NULL, '54', '98758000', '4', '1006', NULL, '19458', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 254.909, '-28,06400', '-53,69700', 511, 'S', 0.7700, NULL, NULL, '43900', 'N', 'N', 3325, NULL, '4390', '4390', NULL, '1997', 'S', 4172, 'NOVA RAMADA', 'N', '431333', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '283', NULL, '03', 'N', NULL, NULL, NULL, 469);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431335', '4305', 'RS', '4305', '4302', '43016', '43', 'NOVA ROMA DO SUL', NULL, '54', '95260000', '9', '7377', '7377', '19297', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 149.057, '-28,99000', '-51,40800', 591, 'S', 0.8300, NULL, NULL, '43900', 'N', 'N', 3329, NULL, '4390', '4390', NULL, '1989', 'S', 4173, 'NOVA ROMA DO SUL', 'N', '431335', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '284', NULL, '03', 'N', NULL, NULL, NULL, 482);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431337', '4301', 'RS', '4302', '4305', '43026', '43', 'NOVA SANTA RITA', NULL, '51', '92480000', '5', '5757', '5757', '19384', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 217.868, '-29,85700', '-51,27400', 63, 'S', 0.7890, NULL, NULL, '43900', 'N', 'N', 3333, NULL, '4301', '4301', NULL, '1993', 'S', 4174, 'NOVA SANTA RITA', 'N', '431337', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '285', NULL, '01', 'N', NULL, NULL, NULL, 464);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431339', '4308', 'RS', '4301', '4304', '43022', '43', 'NOVO CABRAIS', NULL, '51', '96545000', '1', '1008', NULL, '19459', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 192.342, '-29,73500', '-52,94800', 50, 'S', 0.7290, NULL, NULL, '43900', 'N', 'N', 3355, NULL, '4390', '4390', NULL, '1997', 'S', 4176, 'NOVO CABRAIS', 'N', '431339', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '287', NULL, '03', 'N', NULL, NULL, NULL, 483);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431340', '4301', 'RS', '4302', '4305', '43026', '43', 'NOVO HAMBURGO', NULL, '51', '93000000', '9', '8771', '8771', '19135', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 223.606, '-29,67800', '-51,13100', 57, 'S', 0.8090, NULL, NULL, '43900', 'N', 'N', 3358, NULL, '4301', '4301', NULL, '1927', 'S', 4177, 'NOVO HAMBURGO', 'N', '431340', 'N', 'N', 'S', NULL, NULL, 'N', 'S', 'N', '288', NULL, '01', 'N', NULL, NULL, NULL, 463);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431342', '4314', 'RS', '4303', '4301', '43001', '43', 'NOVO MACHADO', NULL, '55', '98955000', '5', '6057', '6057', '19386', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 218.669, '-27,57400', '-54,50500', 256, 'S', 0.7730, NULL, NULL, '43900', 'N', 'N', 3368, NULL, '4390', '4390', NULL, '1993', 'S', 4178, 'NOVO MACHADO', 'N', '431342', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '289', NULL, '03', 'N', NULL, NULL, NULL, 470);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431344', '4319', 'RS', '4304', '4301', '43003', '43', 'NOVO TIRADENTES', NULL, '55', '98370000', '1', '5973', '5973', '19387', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 75.396, '-27,56300', '-53,18200', 384, 'S', 0.7390, NULL, NULL, '43900', 'N', 'N', 3378, NULL, '4390', '4390', NULL, '1993', 'S', 4179, 'NOVO TIRADENTES', 'N', '431344', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '290', NULL, '03', 'N', NULL, NULL, NULL, 471);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431346', '4315', 'RS', '4304', '4301', '43003', '43', 'NOVO XINGU', NULL, '54', '99687000', '6', '1152', NULL, '19488', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 80.587, '-27,74700', '-53,05400', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5666, NULL, '4390', '4390', NULL, '2001', 'S', 5544, 'NOVO XINGU', 'N', '431346', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '291', NULL, '03', 'N', NULL, NULL, NULL, 476);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431349', '4315', 'RS', '4304', '4301', '43009', '43', 'NOVO BARREIRO', NULL, '55', '98338000', '0', '5985', '5985', '19385', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 123.582, '-27,90900', '-53,10800', 449, 'S', 0.7670, NULL, NULL, '43900', 'N', 'N', 3353, NULL, '4390', '4390', NULL, '1993', 'S', 4175, 'NOVO BARREIRO', 'N', '431349', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '286', NULL, '03', 'N', NULL, NULL, NULL, 476);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431350', '4318', 'RS', '4302', '4305', '43027', '43', 'OSORIO', NULL, '51', '95520000', '8', '8773', '8773', '19136', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 663.267, '-29,88700', '-50,27000', 16, 'S', 0.8390, NULL, NULL, '43900', 'N', 'N', 3425, NULL, '4302', '4390', NULL, '1857', 'S', 4180, 'OSÓRIO', 'N', '431350', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '292', NULL, '03', 'N', NULL, NULL, NULL, 461);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431360', '4306', 'RS', '4304', '4301', '43005', '43', 'PAIM FILHO', NULL, '54', '99850000', '7', '8775', '8775', '19137', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 182.182, '-27,71100', '-51,76100', 576, 'S', 0.7930, NULL, NULL, '43900', 'N', 'N', 3467, NULL, '4390', '4390', NULL, '1961', 'S', 4181, 'PAIM FILHO', 'N', '431360', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '293', NULL, '03', 'N', NULL, NULL, NULL, 474);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431365', '4318', 'RS', '4302', '4305', '43027', '43', 'PALMARES DO SUL', NULL, '51', '95540000', '6', '8967', '8967', '19239', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 946.238, '-30,25800', '-50,51000', 9, 'S', 0.7870, NULL, NULL, '43900', 'N', 'N', 3483, NULL, '4302', '4390', NULL, '1982', 'S', 4182, 'PALMARES DO SUL', 'N', '431365', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '294', NULL, '03', 'N', NULL, NULL, NULL, 461);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431370', '4315', 'RS', '4304', '4301', '43009', '43', 'PALMEIRA DAS MISSOES', NULL, '55', '98300000', '6', '8777', '8777', '19138', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1415.703, '-27,89900', '-53,31400', 639, 'S', 0.7840, NULL, NULL, '43900', 'N', 'N', 3491, NULL, '4390', '4390', NULL, '1874', 'S', 4183, 'PALMEIRA DAS MISSÕES', 'N', '431370', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '295', NULL, '03', 'N', NULL, NULL, NULL, 476);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431380', '4319', 'RS', '4304', '4301', '43003', '43', 'PALMITINHO', NULL, '55', '98430000', '5', '8779', '8779', '19139', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 144.046, '-27,35500', '-53,55500', 516, 'S', 0.7670, NULL, NULL, '43900', 'N', 'N', 3506, NULL, '4390', '4390', NULL, '1965', 'S', 4184, 'PALMITINHO', 'N', '431380', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '296', NULL, '03', 'N', NULL, NULL, NULL, 471);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431390', '4317', 'RS', '4303', '4301', '43008', '43', 'PANAMBI', NULL, '55', '98280000', '4', '8781', '8781', '19140', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 490.859, '-28,29300', '-53,50200', 418, 'S', 0.8200, NULL, NULL, '43900', 'N', 'N', 3511, NULL, '4390', '4390', NULL, '1954', 'S', 4185, 'PANAMBI', 'N', '431390', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '297', NULL, '03', 'N', NULL, NULL, NULL, 469);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431395', '4313', 'RS', '4307', '4304', '43022', '43', 'PANTANO GRANDE', NULL, '51', '96690000', '3', '7375', '7375', '19298', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 847.613, '-30,19100', '-52,37400', 100, 'S', 0.7450, NULL, NULL, '43900', 'N', 'N', 3515, NULL, '4390', '4390', NULL, '1989', 'S', 4186, 'PANTANO GRANDE', 'N', '431395', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '298', NULL, '03', 'N', NULL, NULL, NULL, 484);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431400', '4305', 'RS', '4305', '4302', '43014', '43', 'PARAI', NULL, '54', '95360000', '1', '8783', '8783', '19141', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 120.418, '-28,59400', '-51,78600', 657, 'S', 0.8430, NULL, NULL, '43900', 'N', 'N', 3527, NULL, '4390', '4390', NULL, '1965', 'S', 4187, 'PARAÍ', 'N', '431400', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '299', NULL, '03', 'N', NULL, NULL, NULL, 481);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431402', '4304', 'RS', '4301', '4304', '43022', '43', 'PARAISO DO SUL', NULL, '55', '96530000', '7', '7373', '7373', '19299', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 342.448, '-29,66900', '-53,14900', 108, 'S', 0.7640, NULL, NULL, '43900', 'N', 'N', 3535, NULL, '4390', '4390', NULL, '1989', 'S', 4188, 'PARAÍSO DO SUL', 'N', '431402', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '300', NULL, '03', 'N', NULL, NULL, NULL, 457);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431403', '4301', 'RS', '4302', '4305', '43023', '43', 'PARECI NOVO', NULL, '51', '95783000', '5', '6041', '6041', '19388', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 57.405, '-29,63800', '-51,39800', 29, 'S', 0.8370, NULL, NULL, '43900', 'N', 'N', 3565, NULL, '4390', '4390', NULL, '1993', 'S', 4189, 'PARECI NOVO', 'N', '431403', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '301', NULL, '03', 'N', NULL, NULL, NULL, 464);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431405', '4301', 'RS', '4302', '4305', '43026', '43', 'PAROBE', NULL, '51', '95630000', '0', '9825', '9825', '19243', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 109.026, '-29,62900', '-50,83500', 133, 'S', 0.7860, NULL, NULL, '43900', 'N', 'N', 3579, NULL, '4301', '4301', NULL, '1982', 'S', 4190, 'PAROBÉ', 'N', '431405', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '302', NULL, '01', 'N', NULL, NULL, NULL, 462);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431406', '4308', 'RS', '4307', '4304', '43020', '43', 'PASSA SETE', NULL, '55', '96908000', '8', '1010', NULL, '19460', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 304.760, '-29,45300', '-52,96100', 589, 'S', 0.7140, NULL, NULL, '43900', 'N', 'N', 3582, NULL, '4390', '4390', NULL, '1997', 'S', 4191, 'PASSA SETE', 'N', '431406', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '303', NULL, '03', 'N', NULL, NULL, NULL, 483);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431407', '4313', 'RS', '4307', '4304', '43022', '43', 'PASSO DO SOBRADO', NULL, '51', '96685000', '6', '5765', '5765', '19389', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 265.108, '-29,74800', '-52,27500', 109, 'S', 0.7690, NULL, NULL, '43900', 'N', 'N', 3593, NULL, '4390', '4390', NULL, '1993', 'S', 4192, 'PASSO DO SOBRADO', 'N', '431407', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '304', NULL, '03', 'N', NULL, NULL, NULL, 484);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431410', '4306', 'RS', '4304', '4301', '43010', '43', 'PASSO FUNDO', NULL, '54', '99000000', '0', '8785', '8785', '19142', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 780.355, '-28,26300', '-52,40700', 687, 'S', 0.8040, NULL, NULL, '43900', 'N', 'N', 3594, NULL, '4390', '4390', NULL, '1857', 'S', 4193, 'PASSO FUNDO', 'N', '431410', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '305', NULL, '01', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431413', '4311', 'RS', '4304', '4301', '43004', '43', 'PAULO BENTO', NULL, '54', '99718000', '4', '1154', NULL, '19489', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 148.184, '-27,70300', '-52,42100', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5668, NULL, '4390', '4390', NULL, '2001', 'S', 5545, 'PAULO BENTO', 'N', '431413', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '306', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431415', '4316', 'RS', '4307', '4304', '43021', '43', 'PAVERAMA', NULL, '51', '95865000', '9', '7371', '7371', '19300', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 171.607, '-29,55200', '-51,73300', 105, 'S', 0.7890, NULL, NULL, '43900', 'N', 'N', 3632, NULL, '4390', '4390', NULL, '1989', 'S', 4194, 'PAVERAMA', 'N', '431415', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '307', NULL, '03', 'N', NULL, NULL, NULL, 486);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431417', '4303', 'RS', '4306', '4307', '43032', '43', 'PEDRAS ALTAS', NULL, '53', '96487000', '5', '1156', NULL, '19490', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1376.694, '-31,73200', '-53,58300', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5670, NULL, '4390', '4390', NULL, '2001', 'S', 5546, 'PEDRAS ALTAS', 'N', '431417', 'N', 'N', 'S', NULL, 104, 'N', 'N', 'N', '308', NULL, '03', 'N', NULL, NULL, NULL, 477);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431420', '4303', 'RS', '4306', '4307', '43033', '43', 'PEDRO OSORIO', NULL, '53', '96360000', '9', '8787', '8787', '19143', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 603.914, '-31,86400', '-52,82300', 31, 'S', 0.7690, NULL, NULL, '43900', 'N', 'N', 3675, NULL, '4390', '4390', NULL, '1959', 'S', 4195, 'PEDRO OSÓRIO', 'N', '431420', 'N', 'N', 'S', NULL, 104, 'N', 'N', 'N', '309', NULL, '03', 'N', NULL, NULL, NULL, 477);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431430', '4317', 'RS', '4303', '4301', '43008', '43', 'PEJUCARA', NULL, '55', '98270000', '8', '8789', '8789', '19144', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 414.238, '-28,42300', '-53,65600', 449, 'S', 0.7960, NULL, NULL, '43900', 'N', 'N', 3682, NULL, '4390', '4390', NULL, '1965', 'S', 4196, 'PEJUÇARA', 'N', '431430', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '310', NULL, '03', 'N', NULL, NULL, NULL, 469);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431440', '4303', 'RS', '4306', '4307', '43033', '43', 'PELOTAS', NULL, '53', '96000000', '7', '8791', '8791', '19145', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1608.768, '-31,77200', '-52,34300', 17, 'S', 0.8160, NULL, NULL, '43900', 'N', 'N', 3683, NULL, '4304', '4303', NULL, '1830', 'S', 4197, 'PELOTAS', 'N', '431440', 'N', 'N', 'S', NULL, 104, 'N', 'S', 'N', '311', NULL, '01', 'N', NULL, NULL, NULL, 477);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431442', '4305', 'RS', '4305', '4305', '43024', '43', 'PICADA CAFE', NULL, '54', '95175000', '3', '6021', '6021', '19390', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 85.094, '-29,44400', '-51,13600', 106, 'S', 0.8190, NULL, NULL, '43900', 'N', 'N', 3722, NULL, '4390', '4390', NULL, '1993', 'S', 4198, 'PICADA CAFÉ', 'N', '431442', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '312', NULL, '03', 'N', NULL, NULL, NULL, 479);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431445', '4319', 'RS', '4304', '4301', '43009', '43', 'PINHAL', NULL, '55', '98345000', '6', '7369', '7369', '19301', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 68.217, '-27,51100', '-53,21500', 368, 'S', 0.7780, NULL, NULL, '43900', 'N', 'N', 3755, NULL, '4390', '4390', NULL, '1989', 'S', 4199, 'PINHAL', 'N', '431445', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '313', NULL, '03', 'N', NULL, NULL, NULL, 471);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431446', '4305', 'RS', '4305', '4302', '43015', '43', 'PINHAL DA SERRA', NULL, '54', '95390000', '4', '1158', NULL, '19491', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 434.045, '-27,87400', '-51,17000', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5672, NULL, '4390', '4390', NULL, '2001', 'S', 5547, 'PINHAL DA SERRA', 'N', '431446', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '314', NULL, '03', 'N', NULL, NULL, NULL, 480);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431447', '4304', 'RS', '4301', '4303', '43017', '43', 'PINHAL GRANDE', NULL, '55', '98150000', '2', '5787', '5787', '19391', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 477.126, '-29,34600', '-53,30700', 394, 'S', 0.7730, NULL, NULL, '43900', 'N', 'N', 3757, NULL, '4390', '4390', NULL, '1993', 'S', 4200, 'PINHAL GRANDE', 'N', '431447', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '315', NULL, '03', 'N', NULL, NULL, NULL, 457);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431449', '4319', 'RS', '4304', '4301', '43003', '43', 'PINHEIRINHO DO VALE', NULL, '55', '98435000', '8', '5975', '5975', '19392', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 105.344, '-27,21000', '-53,61200', 187, 'S', 0.7470, NULL, NULL, '43900', 'N', 'N', 3764, NULL, '4390', '4390', NULL, '1993', 'S', 4201, 'PINHEIRINHO DO VALE', 'N', '431449', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '316', NULL, '03', 'N', NULL, NULL, NULL, 471);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431450', '4303', 'RS', '4306', '4307', '43032', '43', 'PINHEIRO MACHADO', NULL, '53', '96470000', '6', '8793', '8793', '19146', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2227.897, '-31,57800', '-53,38100', 439, 'S', 0.7520, NULL, NULL, '43900', 'N', 'N', 3767, NULL, '4390', '4390', NULL, '1878', 'S', 4202, 'PINHEIRO MACHADO', 'N', '431450', 'N', 'N', 'S', NULL, 104, 'N', 'N', 'N', '317', NULL, '03', 'N', NULL, NULL, NULL, 477);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431454', '4305', NULL, NULL, NULL, NULL, '43', 'PINTO BANDEIRA', NULL, NULL, NULL, '8', '1160', NULL, NULL, NULL, NULL, 'N', 'N', NULL, NULL, 'N', 'N', NULL, 'N', 'N', 'N', NULL, 'N', 0.000, '-29,096', '-51,45', 0, 'S', NULL, NULL, NULL, '43900', NULL, NULL, NULL, NULL, '4303', '4302', NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, NULL, 'S', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, NULL, 481);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431455', '4312', 'RS', '4303', '4301', '43007', '43', 'PIRAPO', NULL, '55', '97885000', '5', '7367', '7367', '19302', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 291.741, '-28,04500', '-55,19900', 125, 'S', 0.7200, NULL, NULL, '43900', 'N', 'N', 3796, NULL, '4390', '4390', NULL, '1989', 'S', 4203, 'PIRAPÓ', 'N', '431455', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '318', NULL, '03', 'N', NULL, NULL, NULL, 467);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431460', '4303', 'RS', '4306', '4307', '43032', '43', 'PIRATINI', NULL, '53', '96490000', '5', '8795', '8795', '19147', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3561.480, '-31,44800', '-53,10400', 349, 'S', 0.7560, NULL, NULL, '43900', 'N', 'N', 3803, NULL, '4390', '4390', NULL, '1830', 'S', 4204, 'PIRATINI', 'N', '431460', 'N', 'N', 'S', NULL, 104, 'N', 'N', 'N', '319', NULL, '03', 'N', NULL, NULL, NULL, 477);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431470', '4319', 'RS', '4304', '4301', '43003', '43', 'PLANALTO', NULL, '55', '98470000', '4', '8797', '8797', '19148', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 230.417, '-27,32900', '-53,05900', 568, 'S', 0.7410, NULL, NULL, '43900', 'N', 'N', 3827, NULL, '4390', '4390', NULL, '1963', 'S', 4205, 'PLANALTO', 'N', '431470', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '320', NULL, '03', 'N', NULL, NULL, NULL, 471);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431475', '4316', 'RS', '4302', '4305', '43023', '43', 'POCO DAS ANTAS', NULL, '51', '95740000', '3', '7365', '7365', '19303', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 62.102, '-29,45000', '-51,67100', 120, 'S', 0.8160, NULL, NULL, '43900', 'N', 'N', 3841, NULL, '4390', '4390', NULL, '1989', 'S', 4206, 'POÇO DAS ANTAS', 'N', '431475', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '321', NULL, '03', 'N', NULL, NULL, NULL, 486);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431477', '4306', 'RS', '4304', '4301', '43010', '43', 'PONTAO', NULL, '54', '99190000', '9', '5939', '5939', '19393', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 505.713, '-28,05900', '-52,67700', 683, 'S', 0.7610, NULL, NULL, '43900', 'N', 'N', 3867, NULL, '4390', '4390', NULL, '1993', 'S', 4207, 'PONTÃO', 'N', '431477', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '322', NULL, '03', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431478', '4311', 'RS', '4304', '4301', '43004', '43', 'PONTE PRETA', NULL, '54', '99735000', '7', '5967', '5967', '19394', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 100.407, '-27,65400', '-52,48800', 547, 'S', 0.7820, NULL, NULL, '43900', 'N', 'N', 3874, NULL, '4390', '4390', NULL, '1993', 'S', 4208, 'PONTE PRETA', 'N', '431478', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '323', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431480', '4301', 'RS', '4302', '4305', '43023', '43', 'PORTAO', NULL, '51', '93180000', '3', '8799', '8799', '19149', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 159.942, '-29,70200', '-51,24200', 45, 'S', 0.8310, NULL, NULL, '43900', 'N', 'N', 3889, NULL, '4301', '4301', NULL, '1963', 'S', 4209, 'PORTÃO', 'N', '431480', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '324', NULL, '01', 'N', NULL, NULL, NULL, 463);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431490', '4302', 'RS', '4302', '4305', '43026', '43', 'PORTO ALEGRE', NULL, '51', '90001970', '2', '8801', '8801', '19150', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'S', 496.827, '-30,03300', '-51,23000', 3, 'S', 0.8650, NULL, NULL, '43900', 'N', 'N', 3897, NULL, '4301', '4301', NULL, '1809', 'S', 4210, 'PORTO ALEGRE', 'N', '431490', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '325', NULL, '01', 'N', NULL, NULL, NULL, 466);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431500', '4314', 'RS', '4303', '4301', '43001', '43', 'PORTO LUCENA', NULL, '55', '98980000', '8', '8803', '8803', '19151', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 250.078, '-27,85600', '-55,01600', 114, 'S', 0.7470, NULL, NULL, '43900', 'N', 'N', 3917, NULL, '4390', '4390', NULL, '1955', 'S', 4211, 'PORTO LUCENA', 'N', '431500', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '326', NULL, '03', 'N', NULL, NULL, NULL, 470);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431505', '4314', 'RS', '4303', '4301', '43001', '43', 'PORTO MAUA', NULL, '55', '98947000', '7', '6065', '6065', '19395', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 105.560, '-27,57500', '-54,66800', 142, 'S', 0.8020, NULL, NULL, '43900', 'N', 'N', 3918, NULL, '4390', '4390', NULL, '1993', 'S', 4212, 'PORTO MAUÁ', 'N', '431505', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '327', NULL, '03', 'N', NULL, NULL, NULL, 470);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431507', '4314', 'RS', '4303', '4301', '43001', '43', 'PORTO VERA CRUZ', NULL, '55', '98985000', '3', '6067', '6067', '19396', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 113.646, '-27,73600', '-54,90100', 127, 'S', 0.7550, NULL, NULL, '43900', 'N', 'N', 3928, NULL, '4390', '4390', NULL, '1993', 'S', 4213, 'PORTO VERA CRUZ', 'N', '431507', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '328', NULL, '03', 'N', NULL, NULL, NULL, 470);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431510', '4312', 'RS', '4303', '4301', '43006', '43', 'PORTO XAVIER', NULL, '55', '98995000', '7', '8805', '8805', '19152', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 280.511, '-27,90600', '-55,13800', 115, 'S', 0.7620, NULL, NULL, '43900', 'N', 'N', 3931, NULL, '4390', '4390', NULL, '1966', 'S', 4214, 'PORTO XAVIER', 'N', '431510', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '329', NULL, '03', 'N', NULL, NULL, NULL, 467);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431513', '4316', 'RS', '4307', '4304', '43021', '43', 'POUSO NOVO', NULL, '51', '95945000', '1', '7363', '7363', '19304', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 106.532, '-29,17100', '-52,20800', 527, 'S', 0.7710, NULL, NULL, '43900', 'N', 'N', 3941, NULL, '4390', '4390', NULL, '1989', 'S', 4215, 'POUSO NOVO', 'N', '431513', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '330', NULL, '03', 'N', NULL, NULL, NULL, 485);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431514', '4301', 'RS', '4302', '4305', '43024', '43', 'PRESIDENTE LUCENA', NULL, '51', '93945000', '9', '6023', '6023', '19397', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 49.426, '-29,51900', '-51,17800', 75, 'S', 0.8200, NULL, NULL, '43900', 'N', 'N', 3977, NULL, '4390', '4390', NULL, '1993', 'S', 4216, 'PRESIDENTE LUCENA', 'N', '431514', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '331', NULL, '03', 'N', NULL, NULL, NULL, 463);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431515', '4316', 'RS', '4307', '4304', '43021', '43', 'PROGRESSO', NULL, '51', '95925000', '6', '7361', '7361', '19305', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 255.122, '-29,24400', '-52,31200', 536, 'S', 0.7380, NULL, NULL, '43900', 'N', 'N', 3996, NULL, '4390', '4390', NULL, '1989', 'S', 4217, 'PROGRESSO', 'N', '431515', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '332', NULL, '03', 'N', NULL, NULL, NULL, 485);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431517', '4305', 'RS', '4305', '4302', '43014', '43', 'PROTASIO ALVES', NULL, '54', '95345000', '2', '7359', '7359', '19306', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 172.810, '-28,75700', '-51,47300', 637, 'S', 0.8180, NULL, NULL, '43900', 'N', 'N', 3999, NULL, '4390', '4390', NULL, '1989', 'S', 4218, 'PROTÁSIO ALVES', 'N', '431517', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '333', NULL, '03', 'N', NULL, NULL, NULL, 481);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431520', '4316', 'RS', '4307', '4302', '43014', '43', 'PUTINGA', NULL, '51', '95975000', '6', '8807', '8807', '19153', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 219.937, '-29,00200', '-52,15400', 435, 'S', 0.8070, NULL, NULL, '43900', 'N', 'N', 4004, NULL, '4390', '4390', NULL, '1963', 'S', 4219, 'PUTINGA', 'N', '431520', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '334', NULL, '03', 'N', NULL, NULL, NULL, 485);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431530', '4310', 'RS', '4301', '4306', '43029', '43', 'QUARAI', NULL, '55', '97560000', '5', '8809', '8809', '19154', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3147.637, '-30,38800', '-56,45100', 112, 'S', 0.7760, NULL, NULL, '43900', 'N', 'N', 4007, NULL, '4390', '4390', NULL, '1875', 'S', 4220, 'QUARAÍ', 'N', '431530', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '335', NULL, '03', 'N', NULL, NULL, NULL, 459);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431531', '4311', 'RS', '4304', '4301', '43004', '43', 'QUATRO IRMAOS', NULL, '54', '99720000', '3', '1162', NULL, '19493', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 267.987, '-27,82100', '-52,43900', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5676, NULL, '4390', '4390', NULL, '2001', 'S', 5549, 'QUATRO IRMÃOS', 'N', '431531', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '336', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431532', '4304', 'RS', '4301', '4303', '43017', '43', 'QUEVEDOS', NULL, '55', '98140000', '1', '5789', '5789', '19398', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 543.360, '-29,35300', '-54,07200', 410, 'S', 0.7580, NULL, NULL, '43900', 'N', 'N', 4027, NULL, '4390', '4390', NULL, '1993', 'S', 4221, 'QUEVEDOS', 'N', '431532', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '337', NULL, '03', 'N', NULL, NULL, NULL, 457);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431535', '4309', 'RS', '4303', '4301', '43011', '43', 'QUINZE DE NOVEMBRO', NULL, '54', '98230000', '4', '7357', '7357', '19307', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 223.638, '-28,74200', '-53,09500', 355, 'S', 0.8280, NULL, NULL, '43900', 'N', 'N', 4032, NULL, '4390', '4390', NULL, '1989', 'S', 4222, 'QUINZE DE NOVEMBRO', 'N', '431535', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '338', NULL, '03', 'N', NULL, NULL, NULL, 468);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431540', '4315', 'RS', '4303', '4301', '43002', '43', 'REDENTORA', NULL, '55', '98550000', '4', '8811', '8811', '19155', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 302.640, '-27,66400', '-53,63800', 545, 'S', 0.6690, NULL, NULL, '43900', 'S', 'N', 4066, NULL, '4390', '4390', NULL, '1964', 'S', 4223, 'REDENTORA', 'N', '431540', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '339', NULL, '03', 'N', NULL, NULL, NULL, 476);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431545', '4316', 'RS', '4307', '4304', '43021', '43', 'RELVADO', NULL, '51', '95965000', '3', '7355', '7355', '19308', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 108.508, '-29,11100', '-52,07200', 297, 'S', 0.7780, NULL, NULL, '43900', 'N', 'N', 4072, NULL, '4390', '4390', NULL, '1989', 'S', 4224, 'RELVADO', 'N', '431545', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '340', NULL, '03', 'N', NULL, NULL, NULL, 485);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431550', '4304', 'RS', '4301', '4303', '43019', '43', 'RESTINGA SECA', NULL, '55', '97200000', '3', '8813', '8813', '19156', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 961.791, '-29,81300', '-53,37500', 49, 'S', 0.7650, NULL, NULL, '43900', 'N', 'N', 4085, NULL, '4390', '4390', NULL, '1959', 'S', 4225, 'RESTINGA SECA', 'N', '431550', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '341', NULL, '03', 'N', NULL, NULL, NULL, 457);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431555', '4311', 'RS', '4304', '4301', '43003', '43', 'RIO DOS INDIOS', NULL, '54', '99610000', '2', '5955', '5955', '19399', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 236.966, '-27,30000', '-52,84100', 595, 'S', 0.7060, NULL, NULL, '43900', 'N', 'N', 4166, NULL, '4390', '4390', NULL, '1993', 'S', 4226, 'RIO DOS ÍNDIOS', 'N', '431555', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '342', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431560', '4303', 'RS', '4306', '4307', '43035', '43', 'RIO GRANDE', NULL, '53', '96200970', '2', '8815', '8815', '19157', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 2813.907, '-32,03500', '-52,09900', 5, 'S', 0.7930, NULL, NULL, '43900', 'N', 'N', 4170, NULL, '4304', '4303', NULL, '1809', 'S', 4227, 'RIO GRANDE', 'N', '431560', 'N', 'N', 'S', NULL, 104, 'N', 'N', 'N', '343', NULL, '01', 'N', NULL, NULL, NULL, 477);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431570', '4313', 'RS', '4307', '4304', '43022', '43', 'RIO PARDO', NULL, '51', '96640000', '1', '8817', '8817', '19158', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2050.531, '-29,99000', '-52,37800', 47, 'S', 0.7540, NULL, NULL, '43900', 'N', 'N', 4182, NULL, '4390', '4390', NULL, '1809', 'S', 4228, 'RIO PARDO', 'N', '431570', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '344', NULL, '03', 'N', NULL, NULL, NULL, 484);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431575', '4301', 'RS', '4302', '4305', '43024', '43', 'RIOZINHO', NULL, '51', '95695000', '0', '7353', '7353', '19309', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 239.340, '-29,64100', '-50,45300', 90, 'S', 0.7580, NULL, NULL, '43900', 'N', 'N', 4197, NULL, '4390', '4390', NULL, '1989', 'S', 4229, 'RIOZINHO', 'N', '431575', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '345', NULL, '03', 'N', NULL, NULL, NULL, 462);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431580', '4316', 'RS', '4307', '4304', '43021', '43', 'ROCA SALES', NULL, '51', '95735000', '0', '8819', '8819', '19159', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 208.486, '-29,28400', '-51,86800', 60, 'S', 0.8120, NULL, NULL, '43900', 'N', 'N', 4201, NULL, '4390', '4390', NULL, '1954', 'S', 4230, 'ROCA SALES', 'N', '431580', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '346', NULL, '03', 'N', NULL, NULL, NULL, 485);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431590', '4319', 'RS', '4304', '4301', '43003', '43', 'RODEIO BONITO', NULL, '55', '98360000', '9', '8821', '8821', '19160', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 83.198, '-27,47100', '-53,16900', 371, 'S', 0.8090, NULL, NULL, '43900', 'N', 'N', 4205, NULL, '4390', '4390', NULL, '1963', 'S', 4231, 'RODEIO BONITO', 'N', '431590', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '347', NULL, '03', 'N', NULL, NULL, NULL, 471);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431595', '4312', 'RS', '4303', '4301', '43007', '43', 'ROLADOR', NULL, '55', '97843000', '8', '1164', NULL, '19494', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 293.488, '-28,25800', '-54,81700', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5678, NULL, '4390', '4390', NULL, '2001', 'S', 5550, 'ROLADOR', 'N', '431595', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '348', NULL, '03', 'N', NULL, NULL, NULL, 467);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431600', '4301', 'RS', '4302', '4305', '43024', '43', 'ROLANTE', NULL, '51', '95690000', '6', '8823', '8823', '19161', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 296.992, '-29,65100', '-50,57600', 38, 'S', 0.7780, NULL, NULL, '43900', 'N', 'N', 4211, NULL, '4390', '4390', NULL, '1954', 'S', 4232, 'ROLANTE', 'N', '431600', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '349', NULL, '03', 'N', NULL, NULL, NULL, 462);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431610', '4315', 'RS', '4304', '4301', '43010', '43', 'RONDA ALTA', NULL, '54', '99670000', '5', '8825', '8825', '19162', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 426.337, '-27,76700', '-52,80200', 450, 'S', 0.7800, NULL, NULL, '43900', 'N', 'N', 4216, NULL, '4390', '4390', NULL, '1963', 'S', 4233, 'RONDA ALTA', 'N', '431610', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '350', NULL, '03', 'N', NULL, NULL, NULL, 476);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431620', '4315', 'RS', '4304', '4301', '43003', '43', 'RONDINHA', NULL, '54', '99590000', '4', '8827', '8827', '19163', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 252.235, '-27,82800', '-52,91000', 440, 'S', 0.8130, NULL, NULL, '43900', 'N', 'N', 4217, NULL, '4390', '4390', NULL, '1964', 'S', 4234, 'RONDINHA', 'N', '431620', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '351', NULL, '03', 'N', NULL, NULL, NULL, 476);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431630', '4312', 'RS', '4303', '4301', '43006', '43', 'ROQUE GONZALES', NULL, '55', '97970000', '3', '8829', '8829', '19164', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 346.622, '-28,13100', '-55,02600', 151, 'S', 0.7490, NULL, NULL, '43900', 'N', 'N', 4221, NULL, '4390', '4390', NULL, '1965', 'S', 4235, 'ROQUE GONZALES', 'N', '431630', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '352', NULL, '03', 'N', NULL, NULL, NULL, 467);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431640', '4310', 'RS', '4301', '4306', '43030', '43', 'ROSARIO DO SUL', NULL, '55', '97590000', '2', '8831', '8831', '19165', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4369.657, '-30,25800', '-54,91400', 125, 'S', 0.7690, NULL, NULL, '43900', 'N', 'N', 4228, NULL, '4390', '4390', NULL, '1876', 'S', 4236, 'ROSÁRIO DO SUL', 'N', '431640', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '353', NULL, '03', 'N', NULL, NULL, NULL, 459);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431642', '4315', 'RS', '4304', '4301', '43009', '43', 'SAGRADA FAMILIA', NULL, '55', '98330000', '8', '5987', '5987', '19400', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 78.254, '-27,70700', '-53,13600', 395, 'S', 0.7350, NULL, NULL, '43900', 'N', 'N', 4247, NULL, '4390', '4390', NULL, '1993', 'S', 4237, 'SAGRADA FAMÍLIA', 'N', '431642', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '354', NULL, '03', 'N', NULL, NULL, NULL, 476);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431643', '4309', 'RS', '4303', '4301', '43011', '43', 'SALDANHA MARINHO', NULL, '55', '98250000', '6', '7339', '7339', '19310', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 221.605, '-28,39300', '-53,09500', 525, 'S', 0.8180, NULL, NULL, '43900', 'N', 'N', 4250, NULL, '4390', '4390', NULL, '1989', 'S', 4238, 'SALDANHA MARINHO', 'N', '431643', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '355', NULL, '03', 'N', NULL, NULL, NULL, 468);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431645', '4309', 'RS', '4303', '4301', '43011', '43', 'SALTO DO JACUI', NULL, '55', '99440000', '1', '8975', '8975', '19246', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 519.197, '-29,08800', '-53,21300', 322, 'S', 0.7490, NULL, NULL, '43900', 'N', 'N', 4274, NULL, '4390', '4390', NULL, '1982', 'S', 4239, 'SALTO DO JACUÍ', 'N', '431645', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '356', NULL, '03', 'N', NULL, NULL, NULL, 468);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431647', '4312', 'RS', '4303', '4301', '43006', '43', 'SALVADOR DAS MISSOES', NULL, '55', '97940000', '7', '6061', '6061', '19401', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 94.044, '-28,12600', '-54,83500', 216, 'S', 0.8130, NULL, NULL, '43900', 'N', 'N', 4279, NULL, '4390', '4390', NULL, '1993', 'S', 4240, 'SALVADOR DAS MISSÕES', 'N', '431647', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '357', NULL, '03', 'N', NULL, NULL, NULL, 467);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431650', '4301', 'RS', '4302', '4305', '43023', '43', 'SALVADOR DO SUL', NULL, '51', '95750000', '1', '8833', '8833', '19166', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 99.158, '-29,43800', '-51,51100', 493, 'S', 0.8300, NULL, NULL, '43900', 'N', 'N', 4280, NULL, '4390', '4390', NULL, '1963', 'S', 4241, 'SALVADOR DO SUL', 'N', '431650', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '358', NULL, '03', 'N', NULL, NULL, NULL, 464);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431660', '4306', 'RS', '4304', '4301', '43005', '43', 'SANANDUVA', NULL, '54', '99840000', '0', '8835', '8835', '19167', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 504.551, '-27,95000', '-51,80700', 636, 'S', 0.8040, NULL, NULL, '43900', 'N', 'N', 4284, NULL, '4390', '4390', NULL, '1954', 'S', 4242, 'SANANDUVA', 'N', '431660', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '359', NULL, '03', 'N', NULL, NULL, NULL, 474);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431670', '4309', 'RS', '4303', '4301', '43011', '43', 'SANTA BARBARA DO SUL', NULL, '55', '98240000', '9', '8837', '8837', '19168', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 971.153, '-28,35800', '-53,24700', 511, 'S', 0.7920, NULL, NULL, '43900', 'N', 'N', 4300, NULL, '4390', '4390', NULL, '1959', 'S', 4243, 'SANTA BÁRBARA DO SUL', 'N', '431670', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '361', NULL, '03', 'N', NULL, NULL, NULL, 468);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431673', '4306', 'RS', '4304', '4301', '43010', '43', 'SANTA CECILIA DO SUL', NULL, '54', '99952000', '3', '1166', NULL, '19495', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 195.545, '-28,16150', '-51,92500', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5680, NULL, '4390', '4390', NULL, '2001', 'S', 5551, 'SANTA CECÍLIA DO SUL', 'N', '431673', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '362', NULL, '03', 'N', NULL, NULL, NULL, 474);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431675', '4316', 'RS', '4307', '4304', '43021', '43', 'SANTA CLARA DO SUL', NULL, '51', '95915000', '8', '6033', '6033', '19402', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 86.552, '-29,46900', '-52,08800', 117, 'S', 0.7880, NULL, NULL, '43900', 'N', 'N', 4309, NULL, '4390', '4390', NULL, '1993', 'S', 4244, 'SANTA CLARA DO SUL', 'N', '431675', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '363', NULL, '03', 'N', NULL, NULL, NULL, 485);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431680', '4313', 'RS', '4307', '4304', '43020', '43', 'SANTA CRUZ DO SUL', NULL, '51', '96859000', '8', '8839', '8839', '19169', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 733.473, '-29,71800', '-52,42600', 73, 'S', 0.8170, NULL, NULL, '43900', 'N', 'N', 4328, NULL, '4390', '4390', NULL, '1877', 'S', 4245, 'SANTA CRUZ DO SUL', 'N', '431680', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '364', NULL, '01', 'N', NULL, NULL, NULL, 484);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431690', '4304', 'RS', '4301', '4303', '43018', '43', 'SANTA MARIA', NULL, '55', '97001970', '7', '8841', '8841', '19170', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1779.556, '-29,68400', '-53,80700', 151, 'S', 0.8450, NULL, NULL, '43900', 'N', 'N', 4372, NULL, '4390', '4390', NULL, '1857', 'S', 4246, 'SANTA MARIA', 'N', '431690', 'N', 'N', 'S', NULL, 75, 'N', 'S', 'N', '366', NULL, '01', 'N', NULL, NULL, NULL, 457);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431695', '4301', 'RS', '4302', '4305', '43024', '43', 'SANTA MARIA DO HERVAL', NULL, '51', '93995000', '6', '7337', '7337', '19311', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 139.224, '-29,49800', '-50,99300', 371, 'S', 0.8060, NULL, NULL, '43900', 'N', 'N', 4381, NULL, '4390', '4390', NULL, '1989', 'S', 4247, 'SANTA MARIA DO HERVAL', 'N', '431695', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '367', NULL, '03', 'N', NULL, NULL, NULL, 463);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431697', '4310', 'RS', '4301', '4306', '43030', '43', 'SANTA MARGARIDA DO SUL', NULL, '55', '97335000', '2', '1168', NULL, '19496', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 956.148, '-30,33900', '-54,07900', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5682, NULL, '4390', '4390', NULL, '2001', 'S', 5552, 'SANTA MARGARIDA DO SUL', 'N', '431697', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '365', NULL, '03', 'N', NULL, NULL, NULL, 459);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431700', '4303', 'RS', '4306', '4307', '43032', '43', 'SANTANA DA BOA VISTA', NULL, '53', '96590000', '4', '8843', '8843', '19171', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1420.617, '-30,87200', '-53,11500', 306, 'S', 0.7240, NULL, NULL, '43900', 'N', 'N', 4438, NULL, '4390', '4390', NULL, '1965', 'S', 4251, 'SANTANA DA BOA VISTA', 'N', '431700', 'N', 'N', 'S', NULL, 104, 'N', 'N', 'N', '371', NULL, '03', 'N', NULL, NULL, NULL, 477);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431710', '4310', 'RS', '4301', '4306', '43030', '43', 'SANTANA DO LIVRAMENTO', NULL, '55', '97573970', '3', '8845', '8845', '19172', NULL, 'ATIVO', 'N', 'S', NULL, 'SANTANA DO LIVRAMENTO     ', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 6950.370, '-30,89100', '-55,53300', 208, 'S', 0.8030, NULL, NULL, '43900', 'N', 'N', 4453, NULL, '4390', '4390', NULL, '1857', 'S', 4252, 'SANT''ANA DO LIVRAMENTO', 'N', '431710', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '360', NULL, '02', 'N', NULL, NULL, NULL, 459);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431720', '4314', 'RS', '4303', '4301', '43001', '43', 'SANTA ROSA', NULL, '55', '98900000', '2', '8847', '8847', '19173', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 489.805, '-27,87100', '-54,48100', 277, 'S', 0.8310, NULL, NULL, '43900', 'N', 'N', 4408, NULL, '4390', '4390', NULL, '1931', 'S', 4248, 'SANTA ROSA', 'N', '431720', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '368', NULL, '02', 'N', NULL, NULL, NULL, 470);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431725', '4305', 'RS', '4305', '4302', '43016', '43', 'SANTA TEREZA', NULL, '54', '95715000', '1', '5995', '5995', '19403', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 72.390, '-29,16900', '-51,73500', 87, 'S', 0.8250, NULL, NULL, '43900', 'N', 'N', 4422, NULL, '4303', '4302', NULL, '1993', 'S', 4249, 'SANTA TEREZA', 'N', '431725', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '369', NULL, '03', 'N', NULL, NULL, NULL, 481);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431730', '4303', 'RS', '4306', '4307', '43035', '43', 'SANTA VITORIA DO PALMAR', NULL, '53', '96230000', '1', '8849', '8849', '19174', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 5244.177, '-33,51900', '-53,36800', 23, 'S', 0.7990, NULL, NULL, '43900', 'N', 'N', 4434, NULL, '4390', '4390', NULL, '1872', 'S', 4250, 'SANTA VITÓRIA DO PALMAR', 'N', '431730', 'N', 'N', 'S', NULL, 104, 'N', 'N', 'N', '370', NULL, '03', 'N', NULL, NULL, NULL, 477);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431740', '4304', 'RS', '4301', '4303', '43017', '43', 'SANTIAGO', NULL, '55', '97700000', '0', '8851', '8851', '19175', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2413.075, '-29,19200', '-54,86700', 409, 'S', 0.8160, NULL, NULL, '43900', 'N', 'N', 4469, NULL, '4390', '4390', NULL, '1884', 'S', 4253, 'SANTIAGO', 'N', '431740', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '372', NULL, '02', 'N', NULL, NULL, NULL, 458);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431750', '4312', 'RS', '4303', '4301', '43007', '43', 'SANTO ANGELO', NULL, '55', '98800970', '9', '8853', '8853', '19176', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 680.498, '-28,29900', '-54,26300', 281, 'S', 0.8210, NULL, NULL, '43900', 'N', 'N', 4479, NULL, '4390', '4390', NULL, '1873', 'S', 4254, 'SANTO ÂNGELO', 'N', '431750', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '373', NULL, '02', 'N', NULL, NULL, NULL, 467);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431755', '4306', 'RS', '4304', '4301', '43010', '43', 'SANTO ANTONIO DO PALMA', NULL, '54', '99265000', '8', '5941', '5941', '19404', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 126.095, '-28,49700', '-52,02500', 669, 'S', 0.7930, NULL, NULL, '43900', 'N', 'N', 4503, NULL, '4390', '4390', NULL, '1993', 'S', 4257, 'SANTO ANTÔNIO DO PALMA', 'N', '431755', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '376', NULL, '03', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431760', '4318', 'RS', '4302', '4305', '43027', '43', 'SANTO ANTONIO DA PATRULHA', NULL, '51', '95500000', '8', '8855', '8855', '19177', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1048.904, '-29,81800', '-50,52000', 131, 'S', 0.7700, NULL, NULL, '43900', 'N', 'N', 4483, NULL, '4301', '4390', NULL, '1809', 'S', 4255, 'SANTO ANTÔNIO DA PATRULHA', 'N', '431760', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '374', NULL, '01', 'N', NULL, NULL, NULL, 461);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431770', '4312', 'RS', '4303', '4301', '43007', '43', 'SANTO ANTONIO DAS MISSOES', NULL, '55', '97870000', '7', '8857', '8857', '19178', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1714.239, '-28,51100', '-55,22800', 213, 'S', 0.7640, NULL, NULL, '43900', 'N', 'N', 4485, NULL, '4390', '4390', NULL, '1965', 'S', 4256, 'SANTO ANTÔNIO DAS MISSÕES', 'N', '431770', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '375', NULL, '03', 'N', NULL, NULL, NULL, 467);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431775', '4306', 'RS', '4304', '4301', '43009', '43', 'SANTO ANTONIO DO PLANALTO', NULL, '54', '99525000', '6', '5957', '5957', '19405', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 206.507, '-28,39600', '-52,69100', 558, 'S', 0.8130, NULL, NULL, '43900', 'N', 'N', 4506, NULL, '4390', '4390', NULL, '1993', 'S', 4258, 'SANTO ANTÔNIO DO PLANALTO', 'N', '431775', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '377', NULL, '03', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431780', '4317', 'RS', '4303', '4301', '43008', '43', 'SANTO AUGUSTO', NULL, '55', '98590000', '6', '8859', '8859', '19179', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 468.019, '-27,85100', '-53,77700', 528, 'S', 0.7660, NULL, NULL, '43900', 'N', 'N', 4513, NULL, '4390', '4390', NULL, '1959', 'S', 4259, 'SANTO AUGUSTO', 'N', '431780', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '378', NULL, '03', 'N', NULL, NULL, NULL, 469);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431790', '4314', 'RS', '4303', '4301', '43001', '43', 'SANTO CRISTO', NULL, '55', '98960000', '5', '8861', '8861', '19180', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 366.878, '-27,82400', '-54,66300', 283, 'S', 0.8030, NULL, NULL, '43900', 'N', 'N', 4514, NULL, '4390', '4390', NULL, '1955', 'S', 4260, 'SANTO CRISTO', 'N', '431790', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '379', NULL, '03', 'N', NULL, NULL, NULL, 470);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431795', '4306', 'RS', '4304', '4301', '43005', '43', 'SANTO EXPEDITO DO SUL', NULL, '54', '99895000', '4', '5977', '5977', '19406', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 125.735, '-27,90800', '-51,64500', 662, 'S', 0.7400, NULL, NULL, '43900', 'N', 'N', 4517, NULL, '4390', '4390', NULL, '1993', 'S', 4261, 'SANTO EXPEDITO DO SUL', 'N', '431795', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '380', NULL, '03', 'N', NULL, NULL, NULL, 474);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431800', '4312', 'RS', '4303', '4306', '43029', '43', 'SAO BORJA', NULL, '55', '97670000', '2', '8863', '8863', '19181', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3616.026, '-28,66100', '-56,00400', 123, 'S', 0.7980, NULL, NULL, '43900', 'N', 'N', 4541, NULL, '4390', '4390', NULL, '1817', 'S', 4262, 'SÃO BORJA', 'N', '431800', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '381', NULL, '02', 'N', NULL, NULL, NULL, 467);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431805', '4306', 'RS', '4304', '4301', '43010', '43', 'SAO DOMINGOS DO SUL', NULL, '54', '99270000', '1', '7351', '7351', '19312', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 78.952, '-28,53100', '-51,88800', 660, 'S', 0.8120, NULL, NULL, '43900', 'N', 'N', 4567, NULL, '4390', '4390', NULL, '1989', 'S', 4263, 'SÃO DOMINGOS DO SUL', 'N', '431805', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '382', NULL, '03', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431810', '4304', 'RS', '4301', '4306', '43029', '43', 'SAO FRANCISCO DE ASSIS', NULL, '55', '97610000', '1', '8865', '8865', '19182', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 2508.454, '-29,55000', '-55,13100', 151, 'S', 0.7740, NULL, NULL, '43900', 'N', 'N', 4584, NULL, '4390', '4390', NULL, '1884', 'S', 4264, 'SÃO FRANCISCO DE ASSIS', 'N', '431810', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '383', NULL, '03', 'N', NULL, NULL, NULL, 458);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431820', '4301', 'RS', '4305', '4302', '43015', '43', 'SAO FRANCISCO DE PAULA', NULL, '54', '95400000', '0', '8867', '8867', '19183', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 3273.498, '-29,44800', '-50,58400', 907, 'S', 0.7570, NULL, NULL, '43900', 'N', 'N', 4588, NULL, '4390', '4390', NULL, '1902', 'S', 4265, 'SÃO FRANCISCO DE PAULA', 'N', '431820', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '384', NULL, '03', 'N', NULL, NULL, NULL, 462);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431830', '4310', 'RS', '4301', '4306', '43030', '43', 'SAO GABRIEL', NULL, '55', '97300000', '9', '8869', '8869', '19184', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 5019.646, '-30,33600', '-54,32000', 114, 'S', 0.7800, NULL, NULL, '43900', 'N', 'N', 4600, NULL, '4390', '4390', NULL, '1846', 'S', 4266, 'SÃO GABRIEL', 'N', '431830', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '385', NULL, '02', 'N', NULL, NULL, NULL, 459);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431840', '4302', 'RS', '4302', '4305', '43025', '43', 'SAO JERONIMO', NULL, '51', '96700000', '8', '8871', '8871', '19185', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 937.049, '-29,95900', '-51,72200', 29, 'S', 0.7900, NULL, NULL, '43900', 'N', 'N', 4621, NULL, '4301', '4390', NULL, '1860', 'S', 4267, 'SÃO JERÔNIMO', 'N', '431840', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '386', NULL, '01', 'N', NULL, NULL, NULL, 465);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431842', '4306', 'RS', '4304', '4301', '43005', '43', 'SAO JOAO DA URTIGA', NULL, '54', '99855000', '4', '7349', '7349', '19313', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 171.177, '-27,82000', '-51,82800', 745, 'S', 0.7740, NULL, NULL, '43900', 'N', 'N', 4640, NULL, '4390', '4390', NULL, '1989', 'S', 4268, 'SÃO JOÃO DA URTIGA', 'N', '431842', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '387', NULL, '03', 'N', NULL, NULL, NULL, 474);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431843', '4304', 'RS', '4301', '4303', '43019', '43', 'SAO JOAO DO POLESINE', NULL, '55', '97230000', '2', '5791', '5791', '19407', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 85.633, '-29,61400', '-53,44600', 37, 'S', 0.8040, NULL, NULL, '43900', 'N', 'N', 4665, NULL, '4390', '4390', NULL, '1993', 'S', 4269, 'SÃO JOÃO DO POLÊSINE', 'N', '431843', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '388', NULL, '03', 'N', NULL, NULL, NULL, 457);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431844', '4305', 'RS', '4305', '4302', '43014', '43', 'SAO JORGE', NULL, '54', '95365000', '0', '7347', '7347', '19314', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 118.053, '-28,49900', '-51,70300', 640, 'S', 0.8140, NULL, NULL, '43900', 'N', 'N', 4679, NULL, '4390', '4390', NULL, '1989', 'S', 4270, 'SÃO JORGE', 'N', '431844', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '389', NULL, '03', 'N', NULL, NULL, NULL, 481);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431845', '4315', 'RS', '4304', '4301', '43009', '43', 'SAO JOSE DAS MISSOES', NULL, '55', '98325000', '7', '5989', '5989', '19408', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 98.070, '-27,78000', '-53,12200', 509, 'S', 0.7530, NULL, NULL, '43900', 'N', 'N', 4695, NULL, '4390', '4390', NULL, '1993', 'S', 4271, 'SÃO JOSÉ DAS MISSÕES', 'N', '431845', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '390', NULL, '03', 'N', NULL, NULL, NULL, 476);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431846', '4316', 'RS', '4307', '4301', '43013', '43', 'SAO JOSE DO HERVAL', NULL, '54', '99380000', '5', '7345', '7345', '19315', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 103.094, '-29,04400', '-52,29600', 680, 'S', 0.7420, NULL, NULL, '43900', 'N', 'N', 4717, NULL, '4390', '4390', NULL, '1989', 'S', 4272, 'SÃO JOSÉ DO HERVAL', 'N', '431846', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '391', NULL, '03', 'N', NULL, NULL, NULL, 485);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431848', '4301', 'RS', '4302', '4305', '43023', '43', 'SAO JOSE DO HORTENCIO', NULL, '51', '95755000', '1', '7343', '7343', '19316', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 64.113, '-29,52800', '-51,25100', 100, 'S', 0.8150, NULL, NULL, '43900', 'N', 'N', 4718, NULL, '4390', '4390', NULL, '1989', 'S', 4273, 'SÃO JOSÉ DO HORTÊNCIO', 'N', '431848', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '392', NULL, '03', 'N', NULL, NULL, NULL, 463);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431849', '4314', 'RS', '4303', '4301', '43001', '43', 'SAO JOSE DO INHACORA', NULL, '55', '98958000', '9', '6059', '6059', '19409', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 77.806, '-27,72500', '-54,12900', 220, 'S', 0.8200, NULL, NULL, '43900', 'N', 'N', 4719, NULL, '4390', '4390', NULL, '1993', 'S', 4274, 'SÃO JOSÉ DO INHACORÁ', 'N', '431849', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '393', NULL, '03', 'N', NULL, NULL, NULL, 470);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431850', '4303', 'RS', '4306', '4307', '43035', '43', 'SAO JOSE DO NORTE', NULL, '53', '96225000', '7', '8873', '8873', '19186', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1117.873, '-32,01500', '-52,04200', 4, 'S', 0.7030, NULL, NULL, '43900', 'S', 'N', 4723, NULL, '4304', '4390', NULL, '1831', 'S', 4275, 'SÃO JOSÉ DO NORTE', 'N', '431850', 'N', 'N', 'S', NULL, 104, 'N', 'N', 'N', '394', NULL, '03', 'N', NULL, NULL, NULL, 477);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431860', '4306', 'RS', '4304', '4301', '43005', '43', 'SAO JOSE DO OURO', NULL, '54', '99870000', '6', '8875', '8875', '19187', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 334.774, '-27,76900', '-51,59400', 769, 'S', 0.7870, NULL, NULL, '43900', 'N', 'N', 4724, NULL, '4390', '4390', NULL, '1959', 'S', 4276, 'SÃO JOSÉ DO OURO', 'N', '431860', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '395', NULL, '03', 'N', NULL, NULL, NULL, 474);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431861', '4301', 'RS', '4302', '4305', '43023', '43', 'SAO JOSE DO SUL', NULL, '51', '95748000', '4', '1170', NULL, '19497', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 60.106, '-29,53100', '-51,48200', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5684, NULL, '4390', '4390', NULL, '2001', 'S', 5537, 'SÃO JOSÉ DO SUL', 'N', '431861', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '396', NULL, '03', 'N', NULL, NULL, NULL, 464);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431862', '4305', 'RS', '4305', '4302', '43015', '43', 'SAO JOSE DOS AUSENTES', NULL, '54', '95280000', '2', '6015', '6015', '19410', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1176.685, '-28,74800', '-50,06600', 116, 'S', 0.7380, NULL, NULL, '43900', 'N', 'N', 4735, NULL, '4390', '4390', NULL, '1993', 'S', 4277, 'SÃO JOSÉ DOS AUSENTES', 'N', '431862', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '397', NULL, '03', 'N', NULL, NULL, NULL, 480);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431870', '4301', 'RS', '4302', '4305', '43026', '43', 'SAO LEOPOLDO', NULL, '51', '93001970', '5', '8877', '8877', '19188', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 102.313, '-29,76000', '-51,14700', 15, 'S', 0.8050, NULL, NULL, '43900', 'N', 'N', 4743, NULL, '4301', '4301', NULL, '1846', 'S', 4278, 'SÃO LEOPOLDO', 'N', '431870', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '398', NULL, '01', 'N', NULL, NULL, NULL, 463);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431880', '4303', 'RS', '4306', '4307', '43033', '43', 'SAO LOURENCO DO SUL', NULL, '53', '96170000', '4', '8879', '8879', '19189', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2036.130, '-31,36500', '-51,97800', 19, 'S', 0.7770, NULL, NULL, '43900', 'N', 'N', 4750, NULL, '4390', '4390', NULL, '1884', 'S', 4279, 'SÃO LOURENÇO DO SUL', 'N', '431880', 'N', 'N', 'S', NULL, 104, 'N', 'N', 'N', '399', NULL, '03', 'N', NULL, NULL, NULL, 477);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431890', '4312', 'RS', '4303', '4301', '43007', '43', 'SAO LUIZ GONZAGA', NULL, '55', '97800000', '3', '8881', '8881', '19190', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1297.922, '-28,40800', '-54,96100', 231, 'S', 0.8000, NULL, NULL, '43900', 'N', 'N', 4761, NULL, '4390', '4390', NULL, '1880', 'S', 4280, 'SÃO LUIZ GONZAGA', 'N', '431890', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '400', NULL, '03', 'N', NULL, NULL, NULL, 467);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431900', '4305', 'RS', '4305', '4302', '43016', '43', 'SAO MARCOS', NULL, '54', '95190000', '0', '8883', '8883', '19191', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 256.254, '-28,97100', '-51,06800', 746, 'S', 0.8430, NULL, NULL, '43900', 'N', 'N', 4765, NULL, '4303', '4302', NULL, '1963', 'S', 4281, 'SÃO MARCOS', 'N', '431900', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '401', NULL, '03', 'N', NULL, NULL, NULL, 482);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431910', '4317', 'RS', '4303', '4301', '43002', '43', 'SAO MARTINHO', NULL, '55', '98690000', '9', '8885', '8885', '19192', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 171.661, '-27,70700', '-53,96900', 448, 'S', 0.7970, NULL, NULL, '43900', 'N', 'N', 4766, NULL, '4390', '4390', NULL, '1963', 'S', 4282, 'SÃO MARTINHO', 'N', '431910', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '402', NULL, '03', 'N', NULL, NULL, NULL, 469);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431912', '4304', 'RS', '4301', '4303', '43018', '43', 'SAO MARTINHO DA SERRA', NULL, '55', '97190000', '5', '5793', '5793', '19411', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 671.853, '-29,53800', '-53,85500', 453, 'S', 0.7660, NULL, NULL, '43900', 'N', 'N', 4768, NULL, '4390', '4390', NULL, '1993', 'S', 4283, 'SÃO MARTINHO DA SERRA', 'N', '431912', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '403', NULL, '03', 'N', NULL, NULL, NULL, 457);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431915', '4312', 'RS', '4303', '4301', '43007', '43', 'SAO MIGUEL DAS MISSOES', NULL, '55', '98865000', '8', '7341', '7341', '19317', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1229.844, '-28,56300', '-54,55400', 305, 'S', 0.7630, NULL, NULL, '43900', 'N', 'N', 4778, NULL, '4390', '4390', NULL, '1989', 'S', 4284, 'SÃO MIGUEL DAS MISSÕES', 'N', '431915', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '404', NULL, '03', 'N', NULL, NULL, NULL, 467);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431920', '4312', 'RS', '4303', '4301', '43007', '43', 'SAO NICOLAU', NULL, '55', '97880000', '8', '8887', '8887', '19193', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 485.326, '-28,18300', '-55,26700', 148, 'S', 0.7130, NULL, NULL, '43900', 'N', 'N', 4793, NULL, '4390', '4390', NULL, '1965', 'S', 4285, 'SÃO NICOLAU', 'N', '431920', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '405', NULL, '03', 'N', NULL, NULL, NULL, 467);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431930', '4314', 'RS', '4303', '4301', '43006', '43', 'SAO PAULO DAS MISSOES', NULL, '55', '97980000', '7', '8889', '8889', '19194', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 223.886, '-28,02100', '-54,93600', 157, 'S', 0.7770, NULL, NULL, '43900', 'N', 'N', 4796, NULL, '4390', '4390', NULL, '1965', 'S', 4286, 'SÃO PAULO DAS MISSÕES', 'N', '431930', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '406', NULL, '03', 'N', NULL, NULL, NULL, 470);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431935', '4301', 'RS', '4302', '4305', '43023', '43', 'SAO PEDRO DA SERRA', NULL, '51', '95758000', '6', '6043', '6043', '19412', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 35.383, '-29,42100', '-51,51300', 463, 'S', 0.8230, NULL, NULL, '43900', 'N', 'N', 4804, NULL, '4390', '4390', NULL, '1993', 'S', 4287, 'SÃO PEDRO DA SERRA', 'N', '431935', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '407', NULL, '03', 'N', NULL, NULL, NULL, 464);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431936', '4315', 'RS', '4304', '4301', '43009', '43', 'SAO PEDRO DAS MISSOES', NULL, '55', '98323000', '4', '1172', NULL, '19498', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 83.148, '-27,07700', '-53,24600', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5686, NULL, '4390', '4390', NULL, '2001', 'S', 5553, 'SÃO PEDRO DAS MISSÕES', 'N', '431936', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '408', NULL, '03', 'N', NULL, NULL, NULL, 476);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431937', '4312', 'RS', '4303', '4301', '43006', '43', 'SAO PEDRO DO BUTIA', NULL, '55', '97920000', '2', '6063', '6063', '19413', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 107.630, '-28,12400', '-54,88700', 194, 'S', 0.8080, NULL, NULL, '43900', 'N', 'N', 4807, NULL, '4390', '4390', NULL, '1993', 'S', 4288, 'SÃO PEDRO DO BUTIÁ', 'N', '431937', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '409', NULL, '03', 'N', NULL, NULL, NULL, 467);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431940', '4304', 'RS', '4301', '4303', '43018', '43', 'SAO PEDRO DO SUL', NULL, '55', '97400000', '6', '8891', '8891', '19195', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 873.592, '-29,62100', '-54,17900', 173, 'S', 0.7720, NULL, NULL, '43900', 'N', 'N', 4813, NULL, '4390', '4390', NULL, '1926', 'S', 4289, 'SÃO PEDRO DO SUL', 'N', '431940', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '410', NULL, '03', 'N', NULL, NULL, NULL, 457);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431950', '4301', 'RS', '4302', '4305', '43023', '43', 'SAO SEBASTIAO DO CAI', NULL, '51', '95760000', '5', '8893', '8893', '19196', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 111.452, '-29,58700', '-51,37600', 17, 'S', 0.8430, NULL, NULL, '43900', 'N', 'N', 4837, NULL, '4390', '4301', NULL, '1875', 'S', 4290, 'SÃO SEBASTIÃO DO CAÍ', 'N', '431950', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '411', NULL, '03', 'N', NULL, NULL, NULL, 464);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431960', '4304', 'RS', '4301', '4303', '43018', '43', 'SAO SEPE', NULL, '55', '97340000', '4', '8895', '8895', '19197', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2188.832, '-30,16100', '-53,56500', 85, 'S', 0.7750, NULL, NULL, '43900', 'N', 'N', 4847, NULL, '4390', '4390', NULL, '1876', 'S', 4291, 'SÃO SEPÉ', 'N', '431960', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '412', NULL, '03', 'N', NULL, NULL, NULL, 457);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431970', '4311', 'RS', '4304', '4301', '43004', '43', 'SAO VALENTIM', NULL, '54', '99640000', '3', '8897', '8897', '19198', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 154.187, '-27,55800', '-52,52400', 836, 'S', 0.7660, NULL, NULL, '43900', 'N', 'N', 4855, NULL, '4390', '4390', NULL, '1959', 'S', 4292, 'SÃO VALENTIM', 'N', '431970', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '413', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431971', '4316', 'RS', '4307', '4302', '43014', '43', 'SAO VALENTIM DO SUL', NULL, '54', '99240000', '1', '5997', '5997', '19414', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 92.240, '-29,04700', '-51,76500', 550, 'S', 0.8150, NULL, NULL, '43900', 'N', 'N', 4856, NULL, '4390', '4390', NULL, '1993', 'S', 4293, 'SÃO VALENTIM DO SUL', 'N', '431971', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '414', NULL, '03', 'N', NULL, NULL, NULL, 485);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431973', '4317', 'RS', '4303', '4301', '43008', '43', 'SAO VALERIO DO SUL', NULL, '55', '98595000', '7', '6075', '6075', '19415', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 107.971, '-27,78700', '-53,93700', 421, 'S', 0.7150, NULL, NULL, '43900', 'N', 'N', 4858, NULL, '4390', '4390', NULL, '1993', 'S', 4294, 'SÃO VALÉRIO DO SUL', 'N', '431973', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '415', NULL, '03', 'N', NULL, NULL, NULL, 469);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431975', '4305', 'RS', '4305', '4305', '43023', '43', 'SAO VENDELINO', NULL, '51', '95795000', '2', '7293', '7293', '19335', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 32.087, '-29,36900', '-51,37700', 100, 'S', 0.8270, NULL, NULL, '43900', 'N', 'N', 4859, NULL, '4390', '4390', NULL, '1989', 'S', 4295, 'SÃO VENDELINO', 'N', '431975', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '416', NULL, '03', 'N', NULL, NULL, NULL, 482);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431980', '4304', 'RS', '4301', '4303', '43018', '43', 'SAO VICENTE DO SUL', NULL, '55', '97420000', '2', '8675', '8675', '19088', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1174.939, '-29,69200', '-54,67900', 129, 'S', 0.8070, NULL, NULL, '43900', 'N', 'N', 4863, NULL, '4390', '4390', NULL, '1876', 'S', 4296, 'SÃO VICENTE DO SUL', 'N', '431980', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '417', NULL, '03', 'N', NULL, NULL, NULL, 458);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('431990', '4301', 'RS', '4302', '4305', '43026', '43', 'SAPIRANGA', NULL, '51', '93800000', '1', '8899', '8899', '19199', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 137.519, '-29,63800', '-51,00700', 57, 'S', 0.8060, NULL, NULL, '43900', 'N', 'N', 4869, NULL, '4301', '4301', NULL, '1954', 'S', 4297, 'SAPIRANGA', 'N', '431990', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '418', NULL, '01', 'N', NULL, NULL, NULL, 463);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432000', '4301', 'RS', '4302', '4305', '43026', '43', 'SAPUCAIA DO SUL', NULL, '51', '93201970', '8', '8901', '8901', '19200', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 58.644, '-29,83900', '-51,14400', 23, 'S', 0.8060, NULL, NULL, '43900', 'N', 'N', 4874, NULL, '4301', '4301', NULL, '1961', 'S', 4298, 'SAPUCAIA DO SUL', 'N', '432000', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '419', NULL, '01', 'N', NULL, NULL, NULL, 464);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432010', '4315', 'RS', '4304', '4301', '43009', '43', 'SARANDI', NULL, '54', '99560000', '7', '8903', '8903', '19201', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 353.360, '-27,94400', '-52,92300', 503, 'S', 0.7910, NULL, NULL, '43900', 'N', 'N', 4876, NULL, '4390', '4390', NULL, '1939', 'S', 4299, 'SARANDI', 'N', '432010', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '420', NULL, '03', 'N', NULL, NULL, NULL, 476);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432020', '4319', 'RS', '4304', '4301', '43003', '43', 'SEBERI', NULL, '55', '98380000', '6', '8905', '8905', '19202', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 301.422, '-27,47800', '-53,40300', 546, 'S', 0.7610, NULL, NULL, '43900', 'N', 'N', 4896, NULL, '4390', '4390', NULL, '1959', 'S', 4300, 'SEBERI', 'N', '432020', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '421', NULL, '03', 'N', NULL, NULL, NULL, 471);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432023', '4317', 'RS', '4303', '4301', '43002', '43', 'SEDE NOVA', NULL, '55', '98675000', '0', '7335', '7335', '19318', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 118.519, '-27,63500', '-53,94600', 460, 'S', 0.7930, NULL, NULL, '43900', 'N', 'N', 4897, NULL, '4390', '4390', NULL, '1989', 'S', 4301, 'SEDE NOVA', 'N', '432023', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '422', NULL, '03', 'N', NULL, NULL, NULL, 469);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432026', '4308', 'RS', '4307', '4304', '43020', '43', 'SEGREDO', NULL, '51', '96910000', '3', '7317', '7317', '19319', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 247.485, '-29,26900', '-53,01200', 330, 'S', 0.7200, NULL, NULL, '43900', 'N', 'N', 4898, NULL, '4390', '4390', NULL, '1989', 'S', 4302, 'SEGREDO', 'N', '432026', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '423', NULL, '03', 'N', NULL, NULL, NULL, 483);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432030', '4309', 'RS', '4303', '4301', '43012', '43', 'SELBACH', NULL, '54', '99450000', '5', '8907', '8907', '19203', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 176.728, '-28,62900', '-52,95300', 404, 'S', 0.8560, NULL, NULL, '43900', 'N', 'N', 4899, NULL, '4390', '4390', NULL, '1965', 'S', 4303, 'SELBACH', 'N', '432030', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '424', NULL, '03', 'N', NULL, NULL, NULL, 468);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432032', '4314', 'RS', '4303', '4301', '43007', '43', 'SENADOR SALGADO FILHO', NULL, '55', '98895000', '1', '1012', NULL, '19461', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 147.209, '-28,03100', '-54,54300', 336, 'S', 0.7870, NULL, NULL, '43900', 'N', 'N', 4918, NULL, '4390', '4390', NULL, '1997', 'S', 4304, 'SENADOR SALGADO FILHO', 'N', '432032', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '425', NULL, '03', 'N', NULL, NULL, NULL, 470);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432035', '4302', 'RS', '4302', '4305', '43028', '43', 'SENTINELA DO SUL', NULL, '51', '96765000', '4', '5781', '5781', '19416', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 281.959, '-30,61100', '-51,57900', 600, 'S', 0.7770, NULL, NULL, '43900', 'N', 'N', 4924, NULL, '4390', '4390', NULL, '1993', 'S', 4305, 'SENTINELA DO SUL', 'N', '432035', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '426', NULL, '03', 'N', NULL, NULL, NULL, 465);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432040', '4306', 'RS', '4304', '4302', '43014', '43', 'SERAFINA CORREA', NULL, '54', '99250000', '4', '8909', '8909', '19204', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 163.287, '-28,71200', '-51,93500', 509, 'S', 0.8320, NULL, NULL, '43900', 'N', 'N', 4926, NULL, '4390', '4390', NULL, '1960', 'S', 4306, 'SERAFINA CORRÊA', 'N', '432040', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '427', NULL, '03', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432045', '4316', 'RS', '4307', '4304', '43021', '43', 'SERIO', NULL, '51', '95918000', '3', '6035', '6035', '19417', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 99.721, '-29,38300', '-52,26900', 626, 'S', 0.7560, NULL, NULL, '43900', 'N', 'N', 4930, NULL, '4390', '4390', NULL, '1993', 'S', 4307, 'SÉRIO', 'N', '432045', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '428', NULL, '03', 'N', NULL, NULL, NULL, 485);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432050', '4306', 'RS', '4304', '4301', '43010', '43', 'SERTAO', NULL, '54', '99170000', '3', '8911', '8911', '19205', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 439.471, '-27,98000', '-52,26000', 735, 'S', 0.8090, NULL, NULL, '43900', 'N', 'N', 4971, NULL, '4390', '4390', NULL, '1963', 'S', 4308, 'SERTÃO', 'N', '432050', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '429', NULL, '03', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432055', '4302', 'RS', '4302', '4305', '43026', '43', 'SERTAO SANTANA', NULL, '51', '92850000', '2', '5761', '5761', '19418', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 251.605, '-30,46000', '-51,60300', 75, 'S', 0.7620, NULL, NULL, '43900', 'N', 'N', 4972, NULL, '4390', '4390', NULL, '1993', 'S', 4309, 'SERTÃO SANTANA', 'N', '432055', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '430', NULL, '03', 'N', NULL, NULL, NULL, 465);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432057', '4312', 'RS', '4303', '4301', '43006', '43', 'SETE DE SETEMBRO', NULL, '51', '97960000', '8', '1014', NULL, '19462', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 129.995, '-28,13100', '-54,46300', 273, 'S', 0.7650, NULL, NULL, '43900', 'N', 'N', 4976, NULL, '4390', '4390', NULL, '1997', 'S', 4310, 'SETE DE SETEMBRO', 'N', '432057', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '431', NULL, '03', 'N', NULL, NULL, NULL, 467);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432060', '4311', 'RS', '4304', '4301', '43004', '43', 'SEVERIANO DE ALMEIDA', NULL, '54', '99810000', '2', '8913', '8913', '19206', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 167.615, '-27,43300', '-52,11600', 476, 'S', 0.8080, NULL, NULL, '43900', 'N', 'N', 4980, NULL, '4390', '4390', NULL, '1963', 'S', 4311, 'SEVERIANO DE ALMEIDA', 'N', '432060', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '432', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432065', '4304', 'RS', '4301', '4303', '43019', '43', 'SILVEIRA MARTINS', NULL, '55', '97195000', '1', '7315', '7315', '19320', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 118.307, '-29,64200', '-53,58600', 431, 'S', 0.7960, NULL, NULL, '43900', 'N', 'N', 4989, NULL, '4390', '4390', NULL, '1989', 'S', 4312, 'SILVEIRA MARTINS', 'N', '432065', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '433', NULL, '03', 'N', NULL, NULL, NULL, 457);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432067', '4313', 'RS', '4307', '4304', '43020', '43', 'SINIMBU', NULL, '51', '96890000', '7', '5767', '5767', '19419', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 510.120, '-29,53900', '-52,52200', 77, 'S', 0.7680, NULL, NULL, '43900', 'N', 'N', 5001, NULL, '4390', '4390', NULL, '1993', 'S', 4313, 'SINIMBU', 'N', '432067', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '434', NULL, '03', 'N', NULL, NULL, NULL, 484);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432070', '4308', 'RS', '4307', '4304', '43020', '43', 'SOBRADINHO', NULL, '51', '96900000', '1', '8917', '8917', '19208', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 130.390, '-29,42100', '-53,02900', 427, 'S', 0.7530, NULL, NULL, '43900', 'N', 'N', 5012, NULL, '4390', '4390', NULL, '1927', 'S', 4314, 'SOBRADINHO', 'N', '432070', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '435', NULL, '03', 'N', NULL, NULL, NULL, 483);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432080', '4306', 'RS', '4304', '4301', '43013', '43', 'SOLEDADE', NULL, '54', '99300000', '0', '8919', '8919', '19209', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1213.410, '-28,81800', '-52,51000', 726, 'S', 0.7980, NULL, NULL, '43900', 'N', 'N', 5020, NULL, '4390', '4390', NULL, '1875', 'S', 4315, 'SOLEDADE', 'N', '432080', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '436', NULL, '03', 'N', NULL, NULL, NULL, 475);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432085', '4301', 'RS', '4307', '4304', '43021', '43', 'TABAI', NULL, '51', '95863000', '9', '1016', NULL, '19463', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 94.755, '-29,64300', '-51,68200', 79, 'S', 0.7460, NULL, NULL, '43900', 'N', 'N', 5047, NULL, '4390', '4390', NULL, '1997', 'S', 4316, 'TABAÍ', 'N', '432085', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '437', NULL, '03', 'N', NULL, NULL, NULL, 464);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432090', '4306', 'RS', '4304', '4301', '43010', '43', 'TAPEJARA', NULL, '54', '99950000', '9', '8921', '8921', '19210', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 240.613, '-28,06800', '-52,01400', 658, 'S', 0.7800, NULL, NULL, '43900', 'N', 'N', 5091, NULL, '4390', '4390', NULL, '1955', 'S', 4317, 'TAPEJARA', 'N', '432090', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '438', NULL, '03', 'N', NULL, NULL, NULL, 474);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432100', '4306', 'RS', '4303', '4301', '43012', '43', 'TAPERA', NULL, '54', '99490000', '6', '8923', '8923', '19211', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 179.626, '-28,62600', '-52,87000', 409, 'S', 0.8270, NULL, NULL, '43900', 'N', 'N', 5093, NULL, '4390', '4390', NULL, '1954', 'S', 4318, 'TAPERA', 'N', '432100', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '439', NULL, '03', 'N', NULL, NULL, NULL, 475);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432110', '4302', 'RS', '4302', '4305', '43028', '43', 'TAPES', NULL, '51', '96760000', '5', '8925', '8925', '19212', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 804.091, '-30,67300', '-51,39600', 7, 'S', 0.7800, NULL, NULL, '43900', 'N', 'N', 5096, NULL, '4390', '4390', NULL, '1913', 'S', 4319, 'TAPES', 'N', '432110', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '440', NULL, '03', 'N', NULL, NULL, NULL, 465);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432120', '4301', 'RS', '4302', '4305', '43024', '43', 'TAQUARA', NULL, '51', '95600000', '4', '8927', '8927', '19213', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 457.130, '-29,65100', '-50,78100', 57, 'S', 0.8190, NULL, NULL, '43900', 'N', 'N', 5104, NULL, '4301', '4301', NULL, '1886', 'S', 4320, 'TAQUARA', 'N', '432120', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '441', NULL, '01', 'N', NULL, NULL, NULL, 462);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432130', '4316', 'RS', '4307', '4304', '43021', '43', 'TAQUARI', NULL, '51', '95860000', '3', '8929', '8929', '19214', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 349.968, '-29,80000', '-51,86400', 54, 'S', 0.7940, NULL, NULL, '43900', 'N', 'N', 5109, NULL, '4390', '4390', NULL, '1849', 'S', 4321, 'TAQUARI', 'N', '432130', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '442', NULL, '03', 'N', NULL, NULL, NULL, 486);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432132', '4319', 'RS', '4304', '4301', '43003', '43', 'TAQUARUCU DO SUL', NULL, '55', '98410000', '9', '7313', '7313', '19321', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 76.848, '-27,40000', '-53,46700', 545, 'S', 0.7690, NULL, NULL, '43900', 'N', 'N', 5114, NULL, '4390', '4390', NULL, '1989', 'S', 4322, 'TAQUARUÇU DO SUL', 'N', '432132', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '443', NULL, '03', 'N', NULL, NULL, NULL, 471);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432135', '4318', 'RS', '4302', '4305', '43027', '43', 'TAVARES', NULL, '51', '96290000', '2', '8971', '8971', '19241', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 604.255, '-31,28700', '-51,09400', 15, 'S', 0.7610, NULL, NULL, '43900', 'N', 'N', 5126, NULL, '4390', '4390', NULL, '1982', 'S', 4323, 'TAVARES', 'N', '432135', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '444', NULL, '03', 'N', NULL, NULL, NULL, 461);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432140', '4319', 'RS', '4303', '4301', '43002', '43', 'TENENTE PORTELA', NULL, '55', '98500000', '2', '8931', '8931', '19215', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 338.085, '-27,37100', '-53,75800', 390, 'S', 0.7690, NULL, NULL, '43900', 'N', 'N', 5140, NULL, '4390', '4390', NULL, '1955', 'S', 4324, 'TENENTE PORTELA', 'N', '432140', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '445', NULL, '03', 'N', NULL, NULL, NULL, 471);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432143', '4318', 'RS', '4302', '4305', '43027', '43', 'TERRA DE AREIA', NULL, '51', '95535000', '6', '7333', '7333', '19322', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 147.719, '-29,58500', '-50,07100', 14, 'S', 0.7730, NULL, NULL, '43900', 'N', 'N', 5156, NULL, '4302', '4390', NULL, '1989', 'S', 4325, 'TERRA DE AREIA', 'N', '432143', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '446', NULL, '03', 'N', NULL, NULL, NULL, 460);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432145', '4316', 'RS', '4307', '4304', '43021', '43', 'TEUTONIA', NULL, '51', '95890000', '1', '9821', '9821', '19235', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 179.170, '-29,44800', '-51,80600', 100, 'S', 0.8160, NULL, NULL, '43900', 'N', 'N', 5165, NULL, '4390', '4390', NULL, '1981', 'S', 4326, 'TEUTÔNIA', 'N', '432145', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '447', NULL, '03', 'N', NULL, NULL, NULL, 486);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432146', '4306', 'RS', '4304', '4301', '43012', '43', 'TIO HUGO', NULL, '54', '99345000', '9', '1174', '1174', '19499', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 114.235, '-28,57900', '-52,59900', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5688, NULL, '4390', '4390', NULL, '2001', 'S', 5554, 'TIO HUGO', 'N', '432146', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '448', NULL, '03', 'N', NULL, NULL, NULL, 475);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432147', '4319', 'RS', '4303', '4301', '43002', '43', 'TIRADENTES DO SUL', NULL, '55', '98680000', '7', '6077', '6077', '19420', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 234.482, '-27,39800', '-54,08400', 407, 'S', 0.7460, NULL, NULL, '43900', 'N', 'N', 5185, NULL, '4390', '4390', NULL, '1993', 'S', 4327, 'TIRADENTES DO SUL', 'N', '432147', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '449', NULL, '03', 'N', NULL, NULL, NULL, 471);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432149', '4304', 'RS', '4301', '4303', '43018', '43', 'TOROPI', NULL, '55', '97418000', '3', '1018', NULL, '19464', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 202.978, '-29,47800', '-54,22800', 133, 'S', 0.7320, NULL, NULL, '43900', 'N', 'N', 5201, NULL, '4390', '4390', NULL, '1997', 'S', 4328, 'TOROPI', 'N', '432149', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '450', NULL, '03', 'N', NULL, NULL, NULL, 457);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432150', '4318', 'RS', '4302', '4305', '43027', '43', 'TORRES', NULL, '51', '95560000', '1', '8933', '8933', '19216', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 162.128, '-29,33500', '-49,72700', 16, 'S', 0.8210, NULL, NULL, '43900', 'N', 'N', 5203, NULL, '4302', '4390', NULL, '1890', 'S', 4329, 'TORRES', 'N', '432150', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '451', NULL, '03', 'N', NULL, NULL, NULL, 460);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432160', '4318', 'RS', '4302', '4305', '43027', '43', 'TRAMANDAI', NULL, '51', '95590000', '0', '8935', '8935', '19217', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 143.918, '-29,98500', '-50,13400', 8, 'S', 0.8080, NULL, NULL, '43900', 'N', 'N', 5213, NULL, '4302', '4390', NULL, '1962', 'S', 4330, 'TRAMANDAÍ', 'N', '432160', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '452', NULL, '03', 'N', NULL, NULL, NULL, 461);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432162', '4316', 'RS', '4307', '4304', '43021', '43', 'TRAVESSEIRO', NULL, '51', '95948000', '6', '6037', '6037', '19421', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 81.106, '-29,29400', '-52,05500', 86, 'S', 0.8070, NULL, NULL, '43900', 'N', 'N', 5214, NULL, '4390', '4390', NULL, '1993', 'S', 4331, 'TRAVESSEIRO', 'N', '432162', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '453', NULL, '03', 'N', NULL, NULL, NULL, 485);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432163', '4311', 'RS', '4304', '4301', '43004', '43', 'TRES ARROIOS', NULL, '54', '99725000', '4', '7331', '7331', '19323', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 148.667, '-27,49900', '-52,14700', 580, 'S', 0.7940, NULL, NULL, '43900', 'N', 'N', 5217, NULL, '4390', '4390', NULL, '1989', 'S', 4332, 'TRÊS ARROIOS', 'N', '432163', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '454', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432166', '4318', 'RS', '4302', '4305', '43027', '43', 'TRES CACHOEIRAS', NULL, '51', '95580000', '7', '7329', '7329', '19324', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 250.478, '-29,45600', '-49,92400', 15, 'S', 0.7910, NULL, NULL, '43900', 'N', 'N', 5220, NULL, '4302', '4390', NULL, '1989', 'S', 4333, 'TRÊS CACHOEIRAS', 'N', '432166', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '455', NULL, '03', 'N', NULL, NULL, NULL, 460);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432170', '4301', 'RS', '4302', '4305', '43024', '43', 'TRES COROAS', NULL, '51', '95660000', '9', '8937', '8937', '19218', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 185.535, '-29,51700', '-50,77800', 56, 'S', 0.8020, NULL, NULL, '43900', 'N', 'N', 5222, NULL, '4390', '4390', NULL, '1959', 'S', 4334, 'TRÊS COROAS', 'N', '432170', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '456', NULL, '03', 'N', NULL, NULL, NULL, 462);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432180', '4314', 'RS', '4303', '4301', '43001', '43', 'TRES DE MAIO', NULL, '55', '98910000', '8', '8939', '8939', '19219', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 422.199, '-27,77300', '-54,24000', 343, 'S', 0.8300, NULL, NULL, '43900', 'N', 'N', 5223, NULL, '4390', '4390', NULL, '1954', 'S', 4335, 'TRÊS DE MAIO', 'N', '432180', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '457', NULL, '03', 'N', NULL, NULL, NULL, 470);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432183', '4318', 'RS', '4302', '4305', '43027', '43', 'TRES FORQUILHAS', NULL, '51', '95575000', '2', '5777', '5777', '19422', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 217.379, '-29,53700', '-50,06400', 15, 'S', 0.7560, NULL, NULL, '43900', 'N', 'N', 5224, NULL, '4302', '4390', NULL, '1993', 'S', 4336, 'TRÊS FORQUILHAS', 'N', '432183', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '458', NULL, '03', 'N', NULL, NULL, NULL, 460);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432185', '4315', 'RS', '4304', '4301', '43003', '43', 'TRES PALMEIRAS', NULL, '54', '99675000', '7', '7327', '7327', '19325', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 188.700, '-27,61500', '-52,84100', 662, 'S', 0.7670, NULL, NULL, '43900', 'N', 'N', 5228, NULL, '4390', '4390', NULL, '1989', 'S', 4337, 'TRÊS PALMEIRAS', 'N', '432185', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '459', NULL, '03', 'N', NULL, NULL, NULL, 476);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432190', '4319', 'RS', '4303', '4301', '43002', '43', 'TRES PASSOS', NULL, '55', '98600000', '7', '8941', '8941', '19220', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 268.395, '-27,45600', '-53,93200', 451, 'S', 0.8220, NULL, NULL, '43900', 'N', 'N', 5229, NULL, '4390', '4390', NULL, '1944', 'S', 4338, 'TRÊS PASSOS', 'N', '432190', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '460', NULL, '03', 'N', NULL, NULL, NULL, 471);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432195', '4315', 'RS', '4304', '4301', '43003', '43', 'TRINDADE DO SUL', NULL, '54', '99615000', '6', '7325', '7325', '19326', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 268.417, '-27,52200', '-52,89400', 640, 'S', 0.7440, NULL, NULL, '43900', 'N', 'N', 5238, NULL, '4390', '4390', NULL, '1989', 'S', 4339, 'TRINDADE DO SUL', 'N', '432195', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '461', NULL, '03', 'N', NULL, NULL, NULL, 476);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432210', '4314', 'RS', '4303', '4301', '43001', '43', 'TUCUNDUVA', NULL, '55', '98930000', '3', '8945', '8945', '19222', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 180.804, '-27,65700', '-54,44000', 223, 'S', 0.8280, NULL, NULL, '43900', 'N', 'N', 5249, NULL, '4390', '4390', NULL, '1959', 'S', 4341, 'TUCUNDUVA', 'N', '432210', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '463', NULL, '03', 'N', NULL, NULL, NULL, 470);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432215', '4306', 'RS', '4307', '4301', '43013', '43', 'TUNAS', NULL, '51', '99330000', '2', '7323', '7323', '19327', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 217.969, '-29,10300', '-52,95600', 339, 'S', 0.7190, NULL, NULL, '43900', 'N', 'N', 5255, NULL, '4390', '4390', NULL, '1989', 'S', 4342, 'TUNAS', 'N', '432215', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '464', NULL, '03', 'N', NULL, NULL, NULL, 475);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432218', '4306', 'RS', '4304', '4301', '43005', '43', 'TUPANCI DO SUL', NULL, '54', '99878000', '6', '5979', '5979', '19423', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 135.115, '-27,92500', '-51,53600', 824, 'S', 0.7380, NULL, NULL, '43900', 'N', 'N', 5262, NULL, '4390', '4390', NULL, '1993', 'S', 4343, 'TUPANCI DO SUL', 'N', '432218', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '465', NULL, '03', 'N', NULL, NULL, NULL, 474);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432220', '4309', 'RS', '4301', '4303', '43017', '43', 'TUPANCIRETA', NULL, '55', '98170000', '2', '8947', '8947', '19223', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2251.863, '-29,08100', '-53,83600', 465, 'S', 0.7870, NULL, NULL, '43900', 'N', 'N', 5263, NULL, '4390', '4390', NULL, '1928', 'S', 4344, 'TUPANCIRETÃ', 'N', '432220', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '466', NULL, '03', 'N', NULL, NULL, NULL, 468);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432225', '4301', 'RS', '4302', '4305', '43023', '43', 'TUPANDI', NULL, '51', '95775000', '1', '7321', '7321', '19328', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 59.541, '-29,47600', '-51,42100', 63, 'S', 0.8220, NULL, NULL, '43900', 'N', 'N', 5264, NULL, '4390', '4390', NULL, '1989', 'S', 4345, 'TUPANDI', 'N', '432225', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '467', NULL, '03', 'N', NULL, NULL, NULL, 464);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432230', '4314', 'RS', '4303', '4301', '43001', '43', 'TUPARENDI', NULL, '55', '98940000', '1', '8949', '8949', '19224', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 307.675, '-27,75600', '-54,48200', 328, 'S', 0.8020, NULL, NULL, '43900', 'N', 'N', 5265, NULL, '4390', '4390', NULL, '1959', 'S', 4346, 'TUPARENDI', 'N', '432230', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '468', NULL, '03', 'N', NULL, NULL, NULL, 470);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432232', '4303', 'RS', '4306', '4307', '43033', '43', 'TURUCU', NULL, '53', '96148000', '7', '1020', NULL, '19465', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 254.933, '-31,42200', '-52,17800', 30, 'S', 0.7590, NULL, NULL, '43900', 'N', 'N', 5276, NULL, '4390', '4390', NULL, '1997', 'S', 4347, 'TURUÇU', 'N', '432232', 'N', 'N', 'S', NULL, 104, 'N', 'N', 'N', '469', NULL, '03', 'N', NULL, NULL, NULL, 477);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432234', '4312', 'RS', '4303', '4301', '43007', '43', 'UBIRETAMA', NULL, '55', '98898000', '3', '1022', NULL, '19466', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 126.694, '-28,04600', '-54,68100', 208, 'S', 0.7820, NULL, NULL, '43900', 'N', 'N', 5299, NULL, '4390', '4390', NULL, '1997', 'S', 4348, 'UBIRETAMA', 'N', '432234', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '470', NULL, '03', 'N', NULL, NULL, NULL, 467);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432235', '4305', 'RS', '4305', '4302', '43014', '43', 'UNIAO DA SERRA', NULL, '54', '99215000', '0', '5999', '5999', '19424', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 130.991, '-28,79500', '-52,03700', 520, 'S', 0.8130, NULL, NULL, '43900', 'N', 'N', 5317, NULL, '4390', '4390', NULL, '1993', 'S', 4349, 'UNIÃO DA SERRA', 'N', '432235', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '471', NULL, '03', 'N', NULL, NULL, NULL, 481);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432237', '4304', 'RS', '4301', '4303', '43017', '43', 'UNISTALDA', NULL, '55', '97755000', '6', '1024', NULL, '19467', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 602.389, '-29,04700', '-55,15000', 361, 'S', 0.7460, NULL, NULL, '43900', 'N', 'N', 5325, NULL, '4390', '4390', NULL, '1997', 'S', 4350, 'UNISTALDA', 'N', '432237', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '472', NULL, '03', 'N', NULL, NULL, NULL, 458);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432240', '4310', 'RS', '4301', '4306', '43029', '43', 'URUGUAIANA', NULL, '55', '97500970', '0', '8951', '8951', '19225', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 5715.782, '-29,75500', '-57,08800', 66, 'S', 0.7880, NULL, NULL, '43900', 'N', 'N', 5344, NULL, '4390', '4390', NULL, '1846', 'S', 4351, 'URUGUAIANA', 'N', '432240', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '473', NULL, '01', 'N', NULL, NULL, NULL, 459);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432250', '4305', 'RS', '4305', '4302', '43015', '43', 'VACARIA', NULL, '54', '95200000', '9', '8953', '8953', '19226', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2123.674, '-28,51200', '-50,93400', 971, 'S', 0.8050, NULL, NULL, '43900', 'N', 'N', 5352, NULL, '4390', '4390', NULL, '1878', 'S', 4352, 'VACARIA', 'N', '432250', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '474', NULL, '02', 'N', NULL, NULL, NULL, 480);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432252', '4313', 'RS', '4307', '4305', '43025', '43', 'VALE VERDE', NULL, '51', '95833000', '5', '1026', NULL, '19468', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 329.401, '-29,78700', '-52,18400', 91, 'S', 0.7490, NULL, NULL, '43900', 'N', 'N', 5357, NULL, '4390', '4390', NULL, '1997', 'S', 4355, 'VALE VERDE', 'N', '432252', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '477', NULL, '03', 'N', NULL, NULL, NULL, 484);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432253', '4313', 'RS', '4307', '4304', '43020', '43', 'VALE DO SOL', NULL, '51', '96878000', '3', '5769', '5769', '19425', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 328.227, '-29,60400', '-52,68300', 500, 'S', 0.7590, NULL, NULL, '43900', 'N', 'N', 5355, NULL, '4390', '4390', NULL, '1993', 'S', 4353, 'VALE DO SOL', 'N', '432253', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '475', NULL, '03', 'N', NULL, NULL, NULL, 484);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432254', '4305', 'RS', '4305', '4305', '43023', '43', 'VALE REAL', NULL, '51', '95778000', '1', '6049', '6049', '19426', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 44.198, '-29,39800', '-51,25400', 450, 'S', 0.8160, NULL, NULL, '43900', 'N', 'N', 5356, NULL, '4390', '4390', NULL, '1993', 'S', 4354, 'VALE REAL', 'N', '432254', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '476', NULL, '03', 'N', NULL, NULL, NULL, 482);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432255', '4306', 'RS', '4304', '4301', '43010', '43', 'VANINI', NULL, '54', '99290000', '8', '7319', '7319', '19329', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 64.872, '-28,47800', '-51,84500', 757, 'S', 0.8000, NULL, NULL, '43900', 'N', 'N', 5366, NULL, '4390', '4390', NULL, '1989', 'S', 4356, 'VANINI', 'N', '432255', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '478', NULL, '03', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432260', '4313', 'RS', '4307', '4304', '43020', '43', 'VENANCIO AIRES', NULL, '51', '95800000', '8', '8955', '8955', '19227', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 773.239, '-29,60600', '-52,19200', 46, 'S', 0.7930, NULL, NULL, '43900', 'N', 'N', 5398, NULL, '4390', '4390', NULL, '1891', 'S', 4357, 'VENÂNCIO AIRES', 'N', '432260', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '479', NULL, '02', 'N', NULL, NULL, NULL, 484);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432270', '4313', 'RS', '4307', '4304', '43020', '43', 'VERA CRUZ', NULL, '51', '96880000', '7', '8957', '8957', '19228', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 309.620, '-29,71500', '-52,50600', 68, 'S', 0.7910, NULL, NULL, '43900', 'N', 'N', 5404, NULL, '4390', '4390', NULL, '1959', 'S', 4358, 'VERA CRUZ', 'N', '432270', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '480', NULL, '03', 'N', NULL, NULL, NULL, 484);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432280', '4305', 'RS', '4305', '4302', '43016', '43', 'VERANOPOLIS', NULL, '54', '95330000', '6', '8959', '8959', '19229', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 289.432, '-28,93600', '-51,54900', 680, 'S', 0.8500, NULL, NULL, '43900', 'N', 'N', 5410, NULL, '4390', '4390', NULL, '1898', 'S', 4359, 'VERANÓPOLIS', 'N', '432280', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '481', NULL, '03', 'N', NULL, NULL, NULL, 481);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432285', '4316', 'RS', '4307', '4304', '43021', '43', 'VESPASIANO CORREA', NULL, '51', '95972000', '5', '1028', NULL, '19469', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 113.887, '-29,06800', '-51,85900', 518, 'S', 0.8070, NULL, NULL, '43900', 'N', 'N', 5421, NULL, '4390', '4390', NULL, '1997', 'S', 4360, 'VESPASIANO CORREA', 'N', '432285', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '482', NULL, '03', 'N', NULL, NULL, NULL, 485);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432290', '4311', 'RS', '4304', '4301', '43004', '43', 'VIADUTOS', NULL, '54', '99820000', '5', '8961', '8961', '19230', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 268.473, '-27,56900', '-52,02000', 645, 'S', 0.7930, NULL, NULL, '43900', 'N', 'N', 5422, NULL, '4390', '4390', NULL, '1959', 'S', 4361, 'VIADUTOS', 'N', '432290', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '483', NULL, '03', 'N', NULL, NULL, NULL, 472);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432300', '4302', 'RS', '4302', '4305', '43026', '43', 'VIAMAO', NULL, '51', '94400970', '2', '8963', '8963', '19231', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1494.263, '-30,08100', '-51,02300', 111, 'S', 0.8080, NULL, NULL, '43900', 'N', 'N', 5423, NULL, '4301', '4301', NULL, '1880', 'S', 4362, 'VIAMÃO', 'N', '432300', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '484', NULL, '01', 'N', NULL, NULL, NULL, 466);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432310', '4319', 'RS', '4304', '4301', '43003', '43', 'VICENTE DUTRA', NULL, '55', '98450000', '1', '8965', '8965', '19232', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 195.043, '-27,16200', '-53,40500', 289, 'S', 0.7240, NULL, NULL, '43900', 'N', 'N', 5428, NULL, '4390', '4390', NULL, '1965', 'S', 4363, 'VICENTE DUTRA', 'N', '432310', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '485', NULL, '03', 'N', NULL, NULL, NULL, 471);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432320', '4306', 'RS', '4304', '4301', '43012', '43', 'VICTOR GRAEFF', NULL, '54', '99350000', '0', '8969', '8969', '19233', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 238.274, '-28,56000', '-52,74800', 411, 'S', 0.8310, NULL, NULL, '43900', 'N', 'N', 5435, NULL, '4390', '4390', NULL, '1965', 'S', 4364, 'VICTOR GRAEFF', 'N', '432320', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '486', NULL, '03', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432330', '4305', 'RS', '4305', '4302', '43016', '43', 'VILA FLORES', NULL, '54', '95334000', '9', '7311', '7311', '19330', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 107.815, '-28,86300', '-51,53300', 743, 'S', 0.8180, NULL, NULL, '43900', 'N', 'N', 5445, NULL, '4390', '4390', NULL, '1989', 'S', 4365, 'VILA FLORES', 'N', '432330', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '487', NULL, '03', 'N', NULL, NULL, NULL, 481);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432335', '4306', 'RS', '4304', '4301', '43010', '43', 'VILA LANGARO', NULL, '54', '99955000', '8', '1030', NULL, '19470', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 152.172, '-28,10700', '-52,14400', 643, 'S', 0.7830, NULL, NULL, '43900', 'N', 'N', 5446, NULL, '4390', '4390', NULL, '1997', 'S', 4366, 'VILA LÂNGARO', 'N', '432335', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '488', NULL, '03', 'N', NULL, NULL, NULL, 474);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432340', '4306', 'RS', '4304', '4301', '43010', '43', 'VILA MARIA', NULL, '54', '99155000', '8', '7309', '7309', '19331', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 181.440, '-28,53500', '-52,15400', 455, 'S', 0.8130, NULL, NULL, '43900', 'N', 'N', 5447, NULL, '4390', '4390', NULL, '1989', 'S', 4367, 'VILA MARIA', 'N', '432340', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '489', NULL, '03', 'N', NULL, NULL, NULL, 473);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432345', '4304', 'RS', '4301', '4303', '43018', '43', 'VILA NOVA DO SUL', NULL, '55', '97385000', '7', '5795', '5795', '19427', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 523.935, '-30,34400', '-53,88300', 267, 'S', 0.7360, NULL, NULL, '43900', 'N', 'N', 5450, NULL, '4390', '4390', NULL, '1993', 'S', 4368, 'VILA NOVA DO SUL', 'N', '432345', 'N', 'N', 'S', NULL, 75, 'N', 'N', 'N', '490', NULL, '03', 'N', NULL, NULL, NULL, 457);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432350', '4319', 'RS', '4304', '4301', '43003', '43', 'VISTA ALEGRE', NULL, '55', '98415000', '7', '7307', '7307', '19332', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 77.454, '-27,36700', '-53,49000', 546, 'S', 0.7640, NULL, NULL, '43900', 'N', 'N', 5467, NULL, '4390', '4390', NULL, '1989', 'S', 4369, 'VISTA ALEGRE', 'N', '432350', 'N', 'N', 'S', NULL, 56, 'N', 'N', 'N', '491', NULL, '03', 'N', NULL, NULL, NULL, 471);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432360', '4305', 'RS', '4305', '4302', '43014', '43', 'VISTA ALEGRE DO PRATA', NULL, '54', '95325000', '6', '7305', '7305', '19333', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 119.326, '-28,80900', '-51,79000', 562, 'S', 0.8070, NULL, NULL, '43900', 'N', 'N', 5469, NULL, '4390', '4390', NULL, '1989', 'S', 4370, 'VISTA ALEGRE DO PRATA', 'N', '432360', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '492', NULL, '03', 'N', NULL, NULL, NULL, 481);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432370', '4319', 'RS', '4303', '4301', '43002', '43', 'VISTA GAUCHA', NULL, '55', '98535000', '5', '7303', '7303', '19334', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 88.719, '-27,29100', '-53,70200', 497, 'S', 0.7840, NULL, NULL, '43900', 'N', 'N', 5470, NULL, '4390', '4390', NULL, '1989', 'S', 4371, 'VISTA GAÚCHA', 'N', '432370', 'N', 'N', 'S', NULL, 147, 'N', 'N', 'N', '493', NULL, '03', 'N', NULL, NULL, NULL, 471);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432375', '4312', 'RS', '4303', '4301', '43007', '43', 'VITORIA DAS MISSOES', NULL, '55', '98850000', '4', '6053', '6053', '19428', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 259.609, '-28,35100', '-54,49600', 178, 'S', 0.7600, NULL, NULL, '43900', 'N', 'N', 5476, NULL, '4390', '4390', NULL, '1993', 'S', 4372, 'VITÓRIA DAS MISSÕES', 'N', '432375', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '494', NULL, '03', 'N', NULL, NULL, NULL, 467);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432377', '4316', 'RS', '4307', '4304', '43021', '43', 'WESTFALIA', NULL, '54', '95893000', '0', '1176', NULL, '19500', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 63.702, '-29,41700', '-51,76500', 0, 'S', NULL, NULL, NULL, '43900', 'N', 'N', 5690, NULL, '4390', '4390', NULL, '2001', 'S', 5555, 'WESTFALIA', 'N', '432377', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '495', NULL, '03', 'N', NULL, NULL, NULL, 486);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('432380', '4318', 'RS', '4302', '4305', '43027', '43', 'XANGRI-LA', NULL, '51', '95588000', '4', '5785', '5785', '19429', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 60.950, '-29,80100', '-50,04400', 9, 'S', 0.8110, NULL, NULL, '43900', 'N', 'N', 5497, NULL, '4302', '4390', NULL, '1993', 'S', 4373, 'XANGRI-LÁ', 'N', '432380', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '496', NULL, '03', 'N', NULL, NULL, NULL, 460);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500020', '5010', 'MS', '5004', '5003', '50007', '50', 'AGUA CLARA', NULL, '67', '79680000', '3', '9003', '9003', '06002', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 11031.073, '-20,44800', '-52,87800', 303, 'S', 0.7580, NULL, NULL, '50042', 'N', 'N', 51, NULL, '5090', '5090', NULL, '1953', 'S', 2209, 'ÁGUA CLARA', 'N', '500020', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '1', NULL, '03', 'N', NULL, NULL, NULL, 200);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500025', '5002', 'MS', '5001', '5002', '50003', '50', 'ALCINOPOLIS', NULL, '67', '79530000', '2', '0141', '0141', '06130', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4399.676, '-18,32400', '-53,70600', 443, 'S', 0.7450, NULL, NULL, '50013', 'N', 'N', 98, NULL, '5090', '5090', NULL, '1993', 'S', 2210, 'ALCINÓPOLIS', 'N', '500025', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '2', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500060', '5009', 'MS', '5003', '5004', '50010', '50', 'AMAMBAI', NULL, '67', '79990000', '9', '9011', '9011', '06006', NULL, 'ATIVO', 'N', 'S', NULL, 'AMAMBAÍ                   ', 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 4202.298, '-23,10400', '-55,22600', 480, 'S', 0.7590, NULL, NULL, '50034', 'N', 'N', 182, NULL, '5090', '5090', NULL, '1948', 'S', 2211, 'AMAMBAI', 'N', '500060', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '3', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500070', '5001', 'MS', '5001', '5001', '50002', '50', 'ANASTACIO', NULL, '67', '79210000', '8', '9013', '9013', '06007', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 2949.206, '-20,48400', '-55,80700', 160, 'S', 0.7250, NULL, NULL, '50011', 'N', 'N', 219, NULL, '5090', '5090', NULL, '1964', 'S', 2212, 'ANASTÁCIO', 'N', '500070', 'N', 'N', 'S', NULL, 37, 'S', 'N', 'N', '4', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500080', '5007', 'MS', '5003', '5003', '50008', '50', 'ANAURILANDIA', NULL, '67', '79770000', '7', '9015', '9015', '06008', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3395.540, '-22,18800', '-52,71800', 312, 'S', 0.7200, NULL, NULL, '50033', 'N', 'N', 220, NULL, '5090', '5090', NULL, '1963', 'S', 2213, 'ANAURILÂNDIA', 'N', '500080', 'N', 'N', 'S', NULL, 127, 'N', 'N', 'N', '5', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500085', '5007', 'MS', '5003', '5004', '50011', '50', 'ANGELICA', NULL, '67', '79785000', '6', '9169', '9169', '06085', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1273.199, '-22,15300', '-53,77100', 358, 'S', 0.7290, NULL, NULL, '50033', 'N', 'N', 232, NULL, '5090', '5090', NULL, '1976', 'S', 2214, 'ANGÉLICA', 'N', '500085', 'N', 'N', 'S', NULL, 127, 'N', 'N', 'N', '6', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500090', '5009', 'MS', '5003', '5004', '50010', '50', 'ANTONIO JOAO', NULL, '67', '79910000', '6', '9017', '9017', '06009', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1143.750, '-22,19100', '-55,94800', 681, 'S', 0.7020, NULL, NULL, '50034', 'N', 'N', 260, NULL, '5090', '5090', NULL, '1964', 'S', 2215, 'ANTÔNIO JOÃO', 'N', '500090', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '7', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500100', '5008', 'MS', '5004', '5003', '50006', '50', 'APARECIDA DO TABOADO', NULL, '67', '79570000', '3', '9019', '9019', '06010', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2750.130, '-20,08700', '-51,09400', 392, 'S', 0.7630, NULL, NULL, '50041', 'N', 'N', 271, NULL, '5090', '5090', NULL, '1948', 'S', 2216, 'APARECIDA DO TABOADO', 'N', '500100', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '8', NULL, '03', 'N', NULL, NULL, NULL, 200);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500110', '5001', 'MS', '5001', '5001', '50002', '50', 'AQUIDAUANA', NULL, '67', '79200000', '2', '9021', '9021', '06011', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 16958.496, '-20,47100', '-55,78700', 147, 'S', 0.7570, NULL, NULL, '50011', 'N', 'N', 286, NULL, '5090', '5090', NULL, '1906', 'S', 2217, 'AQUIDAUANA', 'N', '500110', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '9', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500124', '5009', 'MS', '5003', '5004', '50010', '50', 'ARAL MOREIRA', NULL, '67', '79930000', '3', '9171', '9171', '06086', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1656.185, '-22,93400', '-55,63500', 609, 'S', 0.7230, NULL, NULL, '50034', 'N', 'N', 319, NULL, '5090', '5090', NULL, '1976', 'S', 2218, 'ARAL MOREIRA', 'N', '500124', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '10', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500150', '5011', 'MS', '5001', '5002', '50004', '50', 'BANDEIRANTES', NULL, '67', '79430000', '8', '9029', '9029', '06015', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3115.514, '-19,91800', '-54,36400', 629, 'S', 0.7330, NULL, NULL, '50012', 'N', 'N', 476, NULL, '5090', '5090', NULL, '1963', 'S', 2219, 'BANDEIRANTES', 'N', '500150', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '11', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500190', '5010', 'MS', '5004', '5003', '50008', '50', 'BATAGUASSU', NULL, '67', '79780000', '4', '9037', '9037', '06019', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2416.718, '-21,71400', '-52,42200', 329, 'S', 0.7380, NULL, NULL, '50042', 'N', 'N', 551, NULL, '5090', '5090', NULL, '1953', 'S', 2220, 'BATAGUASSU', 'N', '500190', 'N', 'N', 'S', NULL, 127, 'N', 'N', 'N', '12', NULL, '03', 'N', NULL, NULL, NULL, 200);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500200', '5007', 'MS', '5003', '5003', '50008', '50', 'BATAYPORA', NULL, '67', '79760000', '1', '9039', '9039', '06020', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1828.214, '-22,29500', '-53,27100', 334, 'S', 0.7040, NULL, NULL, '50033', 'N', 'N', 552, NULL, '5090', '5090', NULL, '1963', 'S', 2221, 'BATAIPORÃ', 'N', '500200', 'N', 'N', 'S', NULL, 127, 'S', 'N', 'N', '13', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500210', '5005', 'MS', '5001', '5004', '50009', '50', 'BELA VISTA', NULL, '67', '79260000', '0', '9041', '9041', '06021', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 4895.543, '-22,10900', '-56,52100', 180, 'S', 0.7550, NULL, NULL, '50014', 'N', 'N', 562, NULL, '5090', '5090', NULL, '1908', 'S', 2222, 'BELA VISTA', 'N', '500210', 'N', 'N', 'S', NULL, 37, 'N', 'N', 'N', '14', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500215', '5001', 'MS', '5001', '5004', '50009', '50', 'BODOQUENA', NULL, '67', '79390000', '9', '9801', '9801', '06112', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 2507.244, '-20,53900', '-56,71500', 132, 'S', 0.7080, NULL, NULL, '50011', 'N', 'N', 653, NULL, '5090', '5090', NULL, '1980', 'S', 2223, 'BODOQUENA', 'N', '500215', 'N', 'N', 'S', NULL, 37, 'N', 'N', 'N', '15', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500220', '5005', 'MS', '5001', '5004', '50009', '50', 'BONITO', NULL, '67', '79290000', '9', '9043', '9043', '06022', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4934.318, '-21,12100', '-56,48200', 315, 'S', 0.7670, NULL, NULL, '50014', 'N', 'N', 702, NULL, '5090', '5090', NULL, '1948', 'S', 2224, 'BONITO', 'N', '500220', 'N', 'N', 'S', NULL, 37, 'N', 'N', 'N', '16', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500230', '5010', 'MS', '5004', '5003', '50007', '50', 'BRASILANDIA', NULL, '67', '79670000', '8', '9045', '9045', '06023', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 5806.892, '-21,25600', '-52,03700', 343, 'S', 0.7570, NULL, NULL, '50042', 'N', 'N', 737, NULL, '5090', '5090', NULL, '1963', 'S', 2225, 'BRASILÂNDIA', 'N', '500230', 'N', 'N', 'S', NULL, 127, 'N', 'N', 'N', '17', NULL, '03', 'N', NULL, NULL, NULL, 200);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500240', '5003', 'MS', '5003', '5004', '50010', '50', 'CAARAPO', NULL, '67', '79940000', '7', '9055', '9055', '06028', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 2089.706, '-22,63400', '-54,82200', 471, 'S', 0.7150, NULL, NULL, '50031', 'N', 'N', 806, NULL, '5090', '5090', NULL, '1958', 'S', 2226, 'CAARAPÓ', 'N', '500240', 'N', 'N', 'S', NULL, 47, 'N', 'N', 'N', '18', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500260', '5011', 'MS', '5001', '5002', '50003', '50', 'CAMAPUA', NULL, '67', '79420000', '5', '9049', '9049', '06025', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 10758.432, '-19,53100', '-54,04400', 409, 'S', 0.7610, NULL, NULL, '50012', 'N', 'N', 908, NULL, '5090', '5090', NULL, '1948', 'S', 2227, 'CAMAPUÃ', 'N', '500260', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '19', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500270', '5011', 'MS', '5001', '5002', '50004', '50', 'CAMPO GRANDE', NULL, '67', '79002970', '4', '9051', '9051', '06026', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'S', 8096.051, '-20,44300', '-54,64600', 532, 'S', 0.8140, NULL, NULL, '50012', 'N', 'N', 959, NULL, '5090', '5001', NULL, '1899', 'S', 2228, 'CAMPO GRANDE', 'N', '500270', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '20', NULL, '01', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500290', '5008', 'MS', '5004', '5003', '50005', '50', 'CASSILANDIA', NULL, '67', '79540000', '2', '9057', '9057', '06029', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3649.830, '-19,11300', '-51,73400', 470, 'S', 0.7750, NULL, NULL, '50041', 'N', 'N', 1154, NULL, '5090', '5090', NULL, '1954', 'S', 2230, 'CASSILÂNDIA', 'N', '500290', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '22', NULL, '03', 'N', NULL, NULL, NULL, 200);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500295', '5008', 'MS', '5001', '5003', '50005', '50', 'CHAPADAO DO SUL', NULL, '67', '79560000', '1', '9787', '9787', '06122', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3850.693, '-18,79400', '-52,62300', 790, 'S', 0.8260, NULL, NULL, '50012', 'N', 'N', 1237, NULL, '5090', '5090', NULL, '1989', 'S', 2231, 'CHAPADÃO DO SUL', 'N', '500295', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '23', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500310', '5011', 'MS', '5001', '5002', '50004', '50', 'CORGUINHO', NULL, '67', '79460000', '8', '9061', '9061', '06031', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2640.814, '-19,83200', '-54,82900', 320, 'S', 0.7230, NULL, NULL, '50012', 'N', 'N', 1370, NULL, '5090', '5090', NULL, '1953', 'S', 2232, 'CORGUINHO', 'N', '500310', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '24', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500315', '5009', 'MS', '5003', '5004', '50011', '50', 'CORONEL SAPUCAIA', NULL, '67', '79995000', '7', '9997', '9997', '06121', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1028.898, '-23,27200', '-55,52900', 510, 'S', 0.7130, NULL, NULL, '50034', 'N', 'N', 1391, NULL, '5090', '5090', NULL, '1987', 'S', 2233, 'CORONEL SAPUCAIA', 'N', '500315', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '25', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500320', '5012', 'MS', '5002', '5001', '50001', '50', 'CORUMBA', NULL, '67', '79301970', '7', '9063', '9063', '06032', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 64960.863, '-19,009', '-57,653', 118, 'S', 0.7710, NULL, NULL, '50021', 'N', 'N', 1404, NULL, '5090', '5090', NULL, '1871', 'S', 2234, 'CORUMBÁ', 'N', '500320', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '26', NULL, '01', 'N', NULL, NULL, NULL, 442);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500325', '5008', 'MS', '5001', '5003', '50005', '50', 'COSTA RICA', NULL, '67', '79550000', '6', '9803', '9803', '06113', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 5722.834, '-18,54400', '-53,12900', 641, 'S', 0.7980, NULL, NULL, '50012', 'N', 'N', 1415, NULL, '5090', '5090', NULL, '1980', 'S', 2235, 'COSTA RICA', 'N', '500325', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '27', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500330', '5002', 'MS', '5001', '5002', '50003', '50', 'COXIM', NULL, '67', '79400000', '6', '9065', '9065', '06033', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 6411.552, '-18,507', '-54,76', 238, 'S', 0.7800, NULL, NULL, '50013', 'N', 'N', 1423, NULL, '5090', '5090', NULL, '1898', 'S', 2236, 'COXIM', 'N', '500330', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '28', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500345', '5004', 'MS', '5003', '5004', '50011', '50', 'DEODAPOLIS', NULL, '67', '79790000', '4', '9175', '9175', '06087', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 831.263, '-22,27600', '-54,16500', 418, 'S', 0.7390, NULL, NULL, '50031', 'N', 'N', 1520, NULL, '5090', '5090', NULL, '1976', 'S', 2237, 'DEODÁPOLIS', 'N', '500345', 'N', 'N', 'S', NULL, 47, 'N', 'N', 'N', '29', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500348', '5001', 'MS', '5001', '5001', '50002', '50', 'DOIS IRMAOS DO BURITI', NULL, '67', '79215000', '8', '9793', '9793', '06123', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 2344.611, '-20,68000', '-55,29600', 320, 'S', 0.6860, NULL, NULL, '50011', 'S', 'N', 1563, NULL, '5090', '5090', NULL, '1989', 'S', 2238, 'DOIS IRMÃOS DO BURITI', 'N', '500348', 'N', 'N', 'S', NULL, 37, 'S', 'N', 'N', '30', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500350', '5003', 'MS', '5003', '5004', '50010', '50', 'DOURADINA', NULL, '67', '79880000', '4', '9805', '9805', '06114', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 280.689, '-22,04000', '-54,61300', 553, 'S', 0.7130, NULL, NULL, '50031', 'N', 'N', 1597, NULL, '5090', '5090', NULL, '1980', 'S', 2239, 'DOURADINA', 'N', '500350', 'N', 'N', 'S', NULL, 47, 'N', 'N', 'N', '31', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500370', '5003', 'MS', '5003', '5004', '50010', '50', 'DOURADOS', NULL, '67', '79804970', '2', '9073', '9073', '06037', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 4086.387, '-22,22100', '-54,80600', 430, 'S', 0.7880, NULL, NULL, '50031', 'N', 'N', 1601, NULL, '5090', '5090', NULL, '1935', 'S', 2240, 'DOURADOS', 'N', '500370', 'N', 'N', 'S', NULL, 47, 'N', 'N', 'N', '32', NULL, '01', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500375', '5006', 'MS', '5003', '5004', '50011', '50', 'ELDORADO', NULL, '67', '79970000', '1', '9173', '9173', '06088', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1017.788, '-23,78700', '-54,28400', 342, 'S', 0.7080, NULL, NULL, '50032', 'N', 'N', 1624, NULL, '5090', '5090', NULL, '1976', 'S', 2241, 'ELDORADO', 'N', '500375', 'N', 'N', 'S', NULL, 35, 'S', 'N', 'N', '33', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500380', '5004', 'MS', '5003', '5004', '50010', '50', 'FATIMA DO SUL', NULL, '67', '79700000', '1', '9075', '9075', '06038', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 315.237, '-22,37400', '-54,51400', 352, 'S', 0.7510, NULL, NULL, '50031', 'N', 'N', 1727, NULL, '5090', '5090', NULL, '1963', 'S', 2242, 'FÁTIMA DO SUL', 'N', '500380', 'N', 'N', 'S', NULL, 47, 'N', 'N', 'N', '34', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500400', '5004', 'MS', '5003', '5004', '50011', '50', 'GLORIA DE DOURADOS', NULL, '67', '79730000', '7', '9079', '9079', '06040', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 491.758, '-22,41800', '-54,23300', 400, 'S', 0.7450, NULL, NULL, '50031', 'N', 'N', 1891, NULL, '5090', '5090', NULL, '1963', 'S', 2243, 'GLÓRIA DE DOURADOS', 'N', '500400', 'N', 'N', 'S', NULL, 47, 'N', 'N', 'N', '36', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500410', '5005', 'MS', '5001', '5004', '50009', '50', 'GUIA LOPES DA LAGUNA', NULL, '67', '79230000', '6', '9081', '9081', '06041', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1210.472, '-21,45800', '-56,11400', 272, 'S', 0.7550, NULL, NULL, '50014', 'N', 'N', 2016, NULL, '5090', '5090', NULL, '1953', 'S', 2244, 'GUIA LOPES DA LAGUNA', 'N', '500410', 'N', 'N', 'S', NULL, 37, 'N', 'N', 'N', '37', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500430', '5006', 'MS', '5003', '5004', '50011', '50', 'IGUATEMI', NULL, '67', '79960000', '4', '9085', '9085', '06043', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 2946.677, '-23,68000', '-54,56100', 342, 'S', 0.7310, NULL, NULL, '50032', 'N', 'N', 2136, NULL, '5090', '5090', NULL, '1963', 'S', 2245, 'IGUATEMI', 'N', '500430', 'N', 'N', 'S', NULL, 35, 'N', 'N', 'N', '38', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500440', '5008', 'MS', '5004', '5003', '50006', '50', 'INOCENCIA', NULL, '67', '79580000', '3', '9087', '9087', '06044', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 5776.261, '-19,72600', '-51,93000', 502, 'S', 0.7720, NULL, NULL, '50041', 'N', 'N', 2189, NULL, '5090', '5090', NULL, '1958', 'S', 2246, 'INOCÊNCIA', 'N', '500440', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '39', NULL, '03', 'N', NULL, NULL, NULL, 200);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500450', '5003', 'MS', '5003', '5004', '50010', '50', 'ITAPORA', NULL, '67', '79890000', '2', '9089', '9089', '06045', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1322.003, '-22,07900', '-54,78900', 390, 'S', 0.7120, NULL, NULL, '50031', 'N', 'N', 2362, NULL, '5090', '5090', NULL, '1953', 'S', 2247, 'ITAPORÃ', 'N', '500450', 'N', 'N', 'S', NULL, 47, 'N', 'N', 'N', '40', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500460', '5006', 'MS', '5003', '5004', '50011', '50', 'ITAQUIRAI', NULL, '67', '79965000', '1', '9807', '9807', '06115', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2063.876, '-23,47400', '-54,18500', 340, 'S', 0.7100, NULL, NULL, '50032', 'N', 'N', 2376, NULL, '5090', '5090', NULL, '1980', 'S', 2248, 'ITAQUIRAÍ', 'N', '500460', 'N', 'N', 'S', NULL, 35, 'S', 'N', 'N', '41', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500470', '5007', 'MS', '5003', '5004', '50011', '50', 'IVINHEMA', NULL, '67', '79740000', '0', '9093', '9093', '06047', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2009.887, '-22,30500', '-53,81500', 362, 'S', 0.7380, NULL, NULL, '50033', 'N', 'N', 2429, NULL, '5090', '5090', NULL, '1963', 'S', 2249, 'IVINHEMA', 'N', '500470', 'N', 'N', 'S', NULL, 127, 'N', 'N', 'N', '42', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500480', '5006', 'MS', '5003', '5004', '50011', '50', 'JAPORA', NULL, '67', '79985000', '9', '0161', '0161', '06131', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 419.804, '-23,89100', '-54,40400', 357, 'S', 0.6360, NULL, NULL, '50032', 'S', 'N', 2498, NULL, '5090', '5090', NULL, '1993', 'S', 2250, 'JAPORÃ', 'N', '500480', 'N', 'N', 'S', NULL, 35, 'N', 'N', 'N', '43', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500490', '5011', 'MS', '5001', '5002', '50004', '50', 'JARAGUARI', NULL, '67', '79440000', '8', '9097', '9097', '06049', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2913.000, '-20,14200', '-54,39900', 589, 'S', 0.7340, NULL, NULL, '50012', 'N', 'N', 2505, NULL, '5090', '5090', NULL, '1953', 'S', 2251, 'JARAGUARI', 'N', '500490', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '44', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500500', '5005', 'MS', '5001', '5004', '50009', '50', 'JARDIM', NULL, '67', '79240000', '4', '9099', '9099', '06050', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2201.725, '-21,48000', '-56,13800', 259, 'S', 0.7730, NULL, NULL, '50014', 'N', 'N', 2507, NULL, '5090', '5090', NULL, '1953', 'S', 2252, 'JARDIM', 'N', '500500', 'N', 'N', 'S', NULL, 37, 'N', 'N', 'N', '45', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500510', '5004', 'MS', '5003', '5004', '50011', '50', 'JATEI', NULL, '67', '79720000', '3', '9101', '9101', '06051', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1927.966, '-22,48200', '-54,30300', 396, 'S', 0.7150, NULL, NULL, '50031', 'S', 'N', 2523, NULL, '5090', '5090', NULL, '1963', 'S', 2253, 'JATEÍ', 'N', '500510', 'N', 'N', 'S', NULL, 47, 'N', 'N', 'N', '46', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500515', '5006', 'MS', '5003', '5004', '50010', '50', 'JUTI', NULL, '67', '79955000', '2', '9923', '9923', '06125', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1584.599, '-22,86100', '-54,60300', 373, 'S', 0.7100, NULL, NULL, '50032', 'N', 'N', 2633, NULL, '5090', '5090', NULL, '1989', 'S', 2254, 'JUTI', 'N', '500515', 'N', 'N', 'S', NULL, 47, 'S', 'N', 'N', '47', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500520', '5012', 'MS', '5002', '5001', '50001', '50', 'LADARIO', NULL, '67', '79370000', '2', '9103', '9103', '06052', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 342.509, '-19,00500', '-57,60200', 114, 'S', 0.7750, NULL, NULL, '50021', 'N', 'N', 2639, NULL, '5090', '5090', NULL, '1953', 'S', 2255, 'LADÁRIO', 'N', '500520', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '48', NULL, '03', 'N', NULL, NULL, NULL, 442);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500525', '5009', 'MS', '5003', '5004', '50010', '50', 'LAGUNA CARAPA', NULL, '67', '79920000', '1', '0163', '0163', '06132', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1733.845, '-22,54600', '-55,15000', 509, 'S', 0.7520, NULL, NULL, '50031', 'N', 'N', 2684, NULL, '5090', '5090', NULL, '1993', 'S', 2256, 'LAGUNA CARAPÃ', 'N', '500525', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '49', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500540', '5011', 'MS', '5001', '5004', '50010', '50', 'MARACAJU', NULL, '67', '79150000', '0', '9107', '9107', '06054', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 5298.840, '-21,61400', '-55,16800', 384, 'S', 0.7810, NULL, NULL, '50012', 'N', 'N', 2881, NULL, '5090', '5090', NULL, '1928', 'S', 2257, 'MARACAJU', 'N', '500540', 'N', 'N', 'S', NULL, 37, 'N', 'N', 'N', '50', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500560', '5001', 'MS', '5001', '5001', '50002', '50', 'MIRANDA', NULL, '67', '79380000', '8', '9111', '9111', '06056', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 5478.627, '-20,24100', '-56,37800', 125, 'S', 0.7240, NULL, NULL, '50011', 'N', 'N', 3048, NULL, '5090', '5090', NULL, '1871', 'S', 2258, 'MIRANDA', 'N', '500560', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '51', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500568', '5006', 'MS', '5003', '5004', '50011', '50', 'MUNDO NOVO', NULL, '67', '79980000', '1', '9179', '9179', '06090', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 479.327, '-23,93800', '-54,27100', 324, 'S', 0.7610, NULL, NULL, '50032', 'N', 'N', 3175, NULL, '5090', '5090', NULL, '1976', 'S', 2259, 'MUNDO NOVO', 'N', '500568', 'N', 'N', 'S', NULL, 35, 'N', 'N', 'N', '52', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500570', '5006', 'MS', '5003', '5004', '50011', '50', 'NAVIRAI', NULL, '67', '79950000', '7', '9113', '9113', '06057', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3193.839, '-23,06500', '-54,19100', 362, 'S', 0.7510, NULL, NULL, '50032', 'N', 'N', 3209, NULL, '5090', '5090', NULL, '1963', 'S', 2260, 'NAVIRAÍ', 'N', '500570', 'N', 'N', 'S', NULL, 35, 'N', 'N', 'N', '53', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500580', '5005', 'MS', '5001', '5004', '50009', '50', 'NIOAQUE', NULL, '67', '79220000', '6', '9115', '9115', '06058', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 3923.798, '-21,13500', '-55,83000', 200, 'S', 0.7150, NULL, NULL, '50011', 'N', 'N', 3229, NULL, '5090', '5090', NULL, '1890', 'S', 2261, 'NIOAQUE', 'N', '500580', 'N', 'N', 'S', NULL, 37, 'S', 'N', 'N', '54', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500600', '5003', 'MS', '5001', '5004', '50010', '50', 'NOVA ALVORADA DO SUL', NULL, '67', '79140000', '2', '0143', '0143', '06129', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4019.209, '-21,46600', '-54,38400', 407, 'S', 0.7450, NULL, NULL, '50012', 'N', 'N', 3251, NULL, '5090', '5090', NULL, '1993', 'S', 2262, 'NOVA ALVORADA DO SUL', 'N', '500600', 'N', 'N', 'S', NULL, 47, 'N', 'N', 'N', '55', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500620', '5007', 'MS', '5003', '5003', '50008', '50', 'NOVA ANDRADINA', NULL, '67', '79750000', '0', '9123', '9123', '06062', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4776.096, '-22,23300', '-53,34300', 380, 'S', 0.7860, NULL, NULL, '50033', 'N', 'N', 3254, NULL, '5090', '5090', NULL, '1958', 'S', 2263, 'NOVA ANDRADINA', 'N', '500620', 'N', 'N', 'S', NULL, 127, 'N', 'N', 'N', '56', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500625', '5007', 'MS', '5003', '5004', '50011', '50', 'NOVO HORIZONTE DO SUL', NULL, '67', '79745000', '9', '0159', '0159', '06133', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 849.117, '-22,66900', '-53,86000', 320, 'S', 0.7100, NULL, NULL, '50033', 'S', 'N', 3364, NULL, '5090', '5090', NULL, '1993', 'S', 2264, 'NOVO HORIZONTE DO SUL', 'N', '500625', 'N', 'N', 'S', NULL, 127, 'S', 'N', 'N', '57', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500630', '5008', 'MS', '5004', '5003', '50006', '50', 'PARANAIBA', NULL, '67', '79500000', '9', '9125', '9125', '06063', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 5402.778, '-19,67700', '-51,19100', 374, 'S', 0.7720, NULL, NULL, '50041', 'N', 'N', 3545, NULL, '5090', '5090', NULL, '1857', 'S', 2265, 'PARANAÍBA', 'N', '500630', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '58', NULL, '03', 'N', NULL, NULL, NULL, 200);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500635', '5009', 'MS', '5003', '5004', '50011', '50', 'PARANHOS', NULL, '67', '79925000', '8', '9739', '9739', '06124', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1302.138, '-23,89300', '-55,43100', 429, 'S', 0.6760, NULL, NULL, '50034', 'S', 'N', 3554, NULL, '5090', '5090', NULL, '1989', 'S', 2266, 'PARANHOS', 'N', '500635', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '59', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500640', '5002', 'MS', '5001', '5002', '50003', '50', 'PEDRO GOMES', NULL, '67', '79410000', '8', '9127', '9127', '06064', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3651.171, '-18,10100', '-54,55200', 282, 'S', 0.7230, NULL, NULL, '50013', 'N', 'N', 3671, NULL, '5090', '5090', NULL, '1963', 'S', 2267, 'PEDRO GOMES', 'N', '500640', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '60', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500660', '5009', 'MS', '5003', '5004', '50010', '50', 'PONTA PORA', NULL, '67', '79900000', '6', '9131', '9131', '06066', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 5328.621, '-22,53600', '-55,72600', 655, 'S', 0.7800, NULL, NULL, '50034', 'N', 'N', 3861, NULL, '5090', '5090', NULL, '1912', 'S', 2268, 'PONTA PORÃ', 'N', '500660', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '61', NULL, '01', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500690', '5005', 'MS', '5001', '5001', '50001', '50', 'PORTO MURTINHO', NULL, '67', '79280000', '3', '9137', '9137', '06069', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 17734.925, '-21,69900', '-57,88300', 90, 'S', 0.6980, NULL, NULL, '50014', 'S', 'N', 3919, NULL, '5090', '5090', NULL, '1911', 'S', 2269, 'PORTO MURTINHO', 'N', '500690', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '62', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500710', '5011', 'MS', '5001', '5003', '50007', '50', 'RIBAS DO RIO PARDO', NULL, '67', '79180000', '9', '9141', '9141', '06071', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 17308.718, '-20,44300', '-53,75900', 369, 'S', 0.7340, NULL, NULL, '50012', 'N', 'N', 4108, NULL, '5090', '5090', NULL, '1943', 'S', 2270, 'RIBAS DO RIO PARDO', 'N', '500710', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '63', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500720', '5003', 'MS', '5003', '5004', '50010', '50', 'RIO BRILHANTE', NULL, '67', '79130000', '8', '9143', '9143', '06072', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3987.529, '-21,80200', '-54,54600', 312, 'S', 0.7470, NULL, NULL, '50031', 'N', 'N', 4144, NULL, '5090', '5090', NULL, '1929', 'S', 2271, 'RIO BRILHANTE', 'N', '500720', 'N', 'N', 'S', NULL, 47, 'N', 'N', 'N', '64', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500730', '5002', 'MS', '5001', '5002', '50004', '50', 'RIO NEGRO', NULL, '67', '79470000', '7', '9145', '9145', '06073', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1807.665, '-19,44900', '-54,98700', 279, 'S', 0.7230, NULL, NULL, '50012', 'N', 'N', 4177, NULL, '5090', '5090', NULL, '1964', 'S', 2272, 'RIO NEGRO', 'N', '500730', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '65', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500740', '5002', 'MS', '5001', '5002', '50003', '50', 'RIO VERDE DE MATO GROSSO', NULL, '67', '79480000', '6', '9147', '9147', '06074', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 8151.975, '-18,91800', '-54,84400', 330, 'S', 0.7520, NULL, NULL, '50013', 'N', 'N', 4194, NULL, '5090', '5090', NULL, '1953', 'S', 2273, 'RIO VERDE DE MATO GROSSO', 'N', '500740', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '66', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500750', '5011', 'MS', '5001', '5002', '50004', '50', 'ROCHEDO', NULL, '67', '79450000', '5', '9149', '9149', '06075', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1560.647, '-19,95300', '-54,89300', 260, 'S', 0.7310, NULL, NULL, '50012', 'N', 'N', 4202, NULL, '5090', '5090', NULL, '1948', 'S', 2274, 'ROCHEDO', 'N', '500750', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '67', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500755', '5010', 'MS', '5004', '5003', '50007', '50', 'SANTA RITA DO PARDO', NULL, '67', '79690000', '4', '9745', '9745', '06126', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 6141.615, '-21,30300', '-52,83100', 360, 'S', 0.7220, NULL, NULL, '50042', 'N', 'N', 4404, NULL, '5090', '5090', NULL, '1989', 'S', 2275, 'SANTA RITA DO PARDO', 'N', '500755', 'N', 'N', 'S', NULL, 127, 'N', 'N', 'N', '68', NULL, '03', 'N', NULL, NULL, NULL, 200);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500769', '5011', 'MS', '5001', '5002', '50003', '50', 'SAO GABRIEL DO OESTE', NULL, '67', '79490000', '5', '9809', '9809', '06116', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3864.859, '-19,39500', '-54,56600', 658, 'S', 0.8080, NULL, NULL, '50012', 'N', 'N', 4604, NULL, '5090', '5090', NULL, '1980', 'S', 2276, 'SÃO GABRIEL DO OESTE', 'N', '500769', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '69', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500770', '5009', 'MS', '5003', '5004', '50011', '50', 'SETE QUEDAS', NULL, '67', '79935000', '3', '9813', '9813', '06118', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 825.925, '-23,97000', '-55,03600', 407, 'S', 0.7190, NULL, NULL, '50034', 'N', 'N', 4978, NULL, '5090', '5090', NULL, '1980', 'S', 2278, 'SETE QUEDAS', 'N', '500770', 'N', 'N', 'S', NULL, 35, 'S', 'N', 'N', '71', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500780', '5010', 'MS', '5004', '5003', '50006', '50', 'SELVIRIA', NULL, '67', '79590000', '2', '9811', '9811', '06117', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3258.653, '-20,36700', '-51,41900', 357, 'S', 0.7360, NULL, NULL, '50042', 'N', 'N', 4900, NULL, '5090', '5090', NULL, '1980', 'S', 2277, 'SELVÍRIA', 'N', '500780', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '70', NULL, '03', 'N', NULL, NULL, NULL, 200);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500790', '5011', 'MS', '5001', '5002', '50004', '50', 'SIDROLANDIA', NULL, '67', '79170000', '1', '9157', '9157', '06079', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 5286.490, '-20,93200', '-54,96100', 484, 'S', 0.7590, NULL, NULL, '50012', 'N', 'N', 4984, NULL, '5090', '5090', NULL, '1953', 'S', 2279, 'SIDROLÂNDIA', 'N', '500790', 'N', 'N', 'S', NULL, 37, 'N', 'N', 'N', '72', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500793', '5002', 'MS', '5001', '5002', '50003', '50', 'SONORA', NULL, '67', '79415000', '5', '9757', '9757', '06128', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4075.437, '-17,57700', '-54,75800', 442, 'S', 0.7690, NULL, NULL, '50013', 'N', 'N', 5026, NULL, '5090', '5090', NULL, '1989', 'S', 2280, 'SONORA', 'N', '500793', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '73', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500795', '5009', 'MS', '5003', '5004', '50011', '50', 'TACURU', NULL, '67', '79975000', '0', '9815', '9815', '06119', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 1785.315, '-23,63300', '-55,01600', 372, 'S', 0.6620, NULL, NULL, '50034', 'S', 'N', 5062, NULL, '5090', '5090', NULL, '1980', 'S', 2281, 'TACURU', 'N', '500795', 'N', 'N', 'S', NULL, 35, 'N', 'N', 'N', '74', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500797', '5007', 'MS', '5003', '5003', '50008', '50', 'TAQUARUSSU', NULL, '67', '79765000', '6', '9817', '9817', '06120', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1041.121, '-22,48800', '-53,35100', 276, 'S', 0.7050, NULL, NULL, '50033', 'N', 'N', 5115, NULL, '5090', '5090', NULL, '1980', 'S', 2282, 'TAQUARUSSU', 'N', '500797', 'N', 'N', 'S', NULL, 127, 'N', 'N', 'N', '75', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500800', '5011', 'MS', '5001', '5002', '50004', '50', 'TERENOS', NULL, '67', '79190000', '8', '9159', '9159', '06080', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2841.240, '-20,44200', '-54,86000', 437, 'S', 0.7310, NULL, NULL, '50012', 'N', 'N', 5148, NULL, '5090', '5090', NULL, '1953', 'S', 2283, 'TERENOS', 'N', '500800', 'N', 'N', 'S', NULL, 37, 'N', 'N', 'N', '76', NULL, '03', 'N', NULL, NULL, NULL, 441);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500830', '5010', 'MS', '5004', '5003', '50007', '50', 'TRES LAGOAS', NULL, '67', '79601970', '5', '9165', '9165', '06083', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 10206.370, '-20,75100', '-51,67800', 319, 'S', 0.7840, NULL, NULL, '50042', 'N', 'N', 5226, NULL, '5090', '5090', NULL, '1915', 'S', 2284, 'TRÊS LAGOAS', 'N', '500830', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '77', NULL, '01', 'N', NULL, NULL, NULL, 200);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('500840', '5004', 'MS', '5003', '5004', '50010', '50', 'VICENTINA', NULL, '67', '79710000', '4', '9187', '9187', '06127', NULL, 'ATIVO', 'N', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 310.216, '-22,40900', '-54,43600', 368, 'S', 0.7270, NULL, NULL, '50031', 'N', 'N', 5429, NULL, '5090', '5090', NULL, '1989', 'S', 2285, 'VICENTINA', 'N', '500840', 'N', 'N', 'S', NULL, 47, 'N', 'N', 'N', '78', NULL, '03', 'N', NULL, NULL, NULL, 296);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510010', '5101', 'MT', '5190', '5104', '51016', '51', 'ACORIZAL', NULL, '65', '78480000', '2', '9001', '9001', '10001', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 841.166, '-15,20500', '-56,36600', 164, 'S', 0.6950, NULL, NULL, '51900', 'S', 'N', 25, NULL, '5102', '5190', NULL, '1953', 'S', 2286, 'ACORIZAL', 'N', '510010', 'S', 'N', 'S', NULL, 16, 'N', 'N', 'N', '1', NULL, '03', 'N', NULL, NULL, NULL, 76);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510020', '5103', 'MT', '5190', '5102', '51010', '51', 'AGUA BOA', NULL, '66', '78635000', '1', '9191', '9191', '10095', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'S', NULL, 'N', 7484.205, '-14,05000', '-52,15900', 400, 'S', 0.7770, NULL, NULL, '51900', 'S', 'N', 47, NULL, '5190', '5190', NULL, '1979', 'S', 2287, 'ÁGUA BOA', 'N', '510020', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '2', NULL, '03', 'N', NULL, NULL, NULL, 144);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510025', '5104', 'MT', '5190', '5101', '51002', '51', 'ALTA FLORESTA', NULL, '66', '78580000', '0', '8987', '8987', '10096', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 8947.069, '-9,87600', '-56,08600', 283, 'S', 0.7790, NULL, NULL, '51900', 'S', 'N', 129, NULL, '5190', '5190', NULL, '1979', 'S', 2288, 'ALTA FLORESTA', 'N', '510025', 'S', 'N', 'S', NULL, 74, 'S', 'N', 'S', '3', NULL, '02', 'N', NULL, NULL, NULL, 370);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510030', '5107', 'MT', '5190', '5105', '51022', '51', 'ALTO ARAGUAIA', NULL, '66', '78780000', '0', '9005', '9005', '10003', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 5538.022, '-17,31500', '-53,21500', 692, 'S', 0.7860, NULL, NULL, '51900', 'S', 'N', 144, NULL, '5190', '5190', NULL, '1938', 'S', 2289, 'ALTO ARAGUAIA', 'N', '510030', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '4', NULL, '03', 'N', NULL, NULL, NULL, 371);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510035', '5116', 'MT', '5190', '5102', '51009', '51', 'ALTO BOA VISTA', NULL, '66', '78665000', '9', '0127', '0127', '10162', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2241.826, '-11,67400', '-51,38800', 0, 'S', 0.7080, NULL, NULL, '51900', 'S', 'N', 146, NULL, '5190', '5190', NULL, '1993', 'S', 2290, 'ALTO BOA VISTA', 'N', '510035', 'S', 'N', 'S', NULL, 19, 'N', 'N', 'N', '5', NULL, '03', 'N', NULL, NULL, NULL, 443);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510040', '5107', 'MT', '5190', '5105', '51022', '51', 'ALTO GARCAS', NULL, '66', '78770000', '9', '9007', '9007', '10004', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3660.387, '-16,94400', '-53,52800', 754, 'S', 0.7950, NULL, NULL, '51900', 'S', 'N', 150, NULL, '5190', '5190', NULL, '1953', 'S', 2291, 'ALTO GARÇAS', 'N', '510040', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '6', NULL, '03', 'N', NULL, NULL, NULL, 371);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510050', '5113', 'MT', '5190', '5104', '51015', '51', 'ALTO PARAGUAI', NULL, '65', '78410000', '8', '9009', '9009', '10005', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2052.519, '-14,51400', '-56,48300', 238, 'S', 0.7040, NULL, NULL, '51900', 'S', 'N', 154, NULL, '5190', '5190', NULL, '1953', 'S', 2292, 'ALTO PARAGUAI', 'N', '510050', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '7', NULL, '03', 'N', NULL, NULL, NULL, 201);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510060', '5107', 'MT', '5190', '5105', '51022', '51', 'ALTO TAQUARI', NULL, '66', '78785000', '7', '9911', '9911', '10124', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1394.760, '-17,82600', '-53,28200', 851, 'S', 0.8040, NULL, NULL, '51900', 'S', 'N', 163, NULL, '5190', '5190', NULL, '1986', 'S', 2293, 'ALTO TAQUARI', 'N', '510060', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '8', NULL, '03', 'N', NULL, NULL, NULL, 371);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510080', '5104', 'MT', '5190', '5101', '51002', '51', 'APIACAS', NULL, '66', '78595000', '5', '9773', '9773', '10150', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 20364.204, '-9,54400', '-57,44900', 220, 'S', 0.7130, NULL, NULL, '51900', 'S', 'N', 274, NULL, '5190', '5190', NULL, '1989', 'S', 2294, 'APIACÁS', 'N', '510080', 'S', 'N', 'S', NULL, 74, 'N', 'N', 'N', '9', NULL, '03', 'N', NULL, NULL, NULL, 370);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510100', '5108', 'MT', '5190', '5102', '51011', '51', 'ARAGUAIANA', NULL, '66', '78685000', '1', '9869', '9869', '10125', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 6415.109, '-15,73400', '-51,83100', 269, 'S', 0.7370, NULL, NULL, '51900', 'S', 'N', 310, NULL, '5190', '5190', NULL, '1986', 'S', 2295, 'ARAGUAIANA', 'N', '510100', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '10', NULL, '03', 'N', NULL, NULL, NULL, 262);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510120', '5107', 'MT', '5190', '5105', '51020', '51', 'ARAGUAINHA', NULL, '66', '78615000', '9', '9023', '9023', '10012', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 688.676, '-16,85600', '-53,03300', 462, 'S', 0.7310, NULL, NULL, '51900', 'S', 'N', 312, NULL, '5190', '5190', NULL, '1963', 'S', 2296, 'ARAGUAINHA', 'N', '510120', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '11', NULL, '03', 'N', NULL, NULL, NULL, 371);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510125', '5102', 'MT', '5190', '5103', '51014', '51', 'ARAPUTANGA', NULL, '65', '78260000', '8', '8989', '8989', '10097', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1602.731, '-15,47100', '-58,35300', 200, 'S', 0.7540, NULL, NULL, '51900', 'S', 'N', 335, NULL, '5190', '5190', NULL, '1979', 'S', 2297, 'ARAPUTANGA', 'N', '510125', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '12', NULL, '03', 'N', NULL, NULL, NULL, 202);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510130', '5105', 'MT', '5190', '5104', '51015', '51', 'ARENAPOLIS', NULL, '65', '78420000', '8', '9025', '9025', '10013', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 414.678, '-14,45000', '-56,84600', 247, 'S', 0.7210, NULL, NULL, '51900', 'S', 'N', 371, NULL, '5190', '5190', NULL, '1953', 'S', 2298, 'ARENÁPOLIS', 'N', '510130', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '13', NULL, '03', 'N', NULL, NULL, NULL, 77);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510140', '5109', 'MT', '5190', '5101', '51001', '51', 'ARIPUANA', NULL, '66', '78325000', '7', '9027', '9027', '10014', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'S', NULL, 'N', 25048.965, '-10,16700', '-59,45900', 105, 'S', 0.7040, NULL, NULL, '51900', 'S', 'N', 377, NULL, '5190', '5190', NULL, '1943', 'S', 2299, 'ARIPUANÃ', 'N', '510140', 'S', 'N', 'S', NULL, 163, 'N', 'N', 'N', '14', NULL, '03', 'N', NULL, NULL, NULL, 423);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510160', '5101', 'MT', '5190', '5104', '51018', '51', 'BARAO DE MELGACO', NULL, '65', '78190000', '5', '9031', '0310', '10016', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 11182.846, '-16,27900', '-55,95800', 156, 'S', 0.6720, NULL, NULL, '51900', 'S', 'N', 485, NULL, '5102', '5190', NULL, '1953', 'S', 2300, 'BARÃO DE MELGAÇO', 'N', '510160', 'S', 'N', 'S', NULL, 16, 'N', 'N', 'N', '15', NULL, '03', 'N', NULL, NULL, NULL, 76);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510170', '5105', 'MT', '5190', '5103', '51013', '51', 'BARRA DO BUGRES', NULL, '65', '78390000', '4', '9033', '9033', '10017', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 7228.902, '-15,07300', '-57,18100', 171, 'S', 0.7150, NULL, NULL, '51900', 'S', 'N', 510, NULL, '5190', '5190', NULL, '1943', 'S', 2301, 'BARRA DO BUGRES', 'N', '510170', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '16', NULL, '03', 'N', NULL, NULL, NULL, 77);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510180', '5108', 'MT', '5190', '5102', '51011', '51', 'BARRA DO GARCAS', NULL, '66', '78600000', '3', '9035', '9035', '10018', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 9141.841, '-15,89000', '-52,25700', 318, 'S', 0.7910, NULL, NULL, '51900', 'N', 'N', 514, NULL, '5190', '5190', NULL, '1914', 'S', 2302, 'BARRA DO GARÇAS', 'N', '510180', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'S', '17', NULL, '02', 'N', NULL, NULL, NULL, 262);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510185', '5103', 'MT', '5190', '5102', '51009', '51', 'BOM JESUS DO ARAGUAIA', NULL, '66', '78678000', '2', '1078', NULL, '10192', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4279.088, '-12,17500', '-51,50300', 0, 'S', NULL, NULL, NULL, '51900', 'S', 'N', 5692, NULL, '5190', '5190', NULL, '2001', 'S', 5565, 'BOM JESUS DO ARAGUAIA', 'N', '510185', 'S', 'N', 'S', NULL, 19, 'N', 'N', 'N', '18', NULL, '03', 'N', NULL, NULL, NULL, 144);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510190', '5109', 'MT', '5190', '5101', '51001', '51', 'BRASNORTE', NULL, '66', '78350000', '2', '9873', '9873', '10148', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 15959.328, '-12,15500', '-57,97900', 317, 'S', 0.7570, NULL, NULL, '51900', 'S', 'N', 745, NULL, '5190', '5190', NULL, '1989', 'S', 2303, 'BRASNORTE', 'N', '510190', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '19', NULL, '03', 'N', NULL, NULL, NULL, 423);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510250', '5102', 'MT', '5190', '5104', '51018', '51', 'CACERES', NULL, '65', '78200000', '4', '9047', '9047', '10024', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 24398.399, '-16,07100', '-57,67900', 118, 'S', 0.7370, NULL, NULL, '51900', 'N', 'N', 826, NULL, '5190', '5190', NULL, '1859', 'S', 2304, 'CÁCERES', 'N', '510250', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'S', '20', NULL, '01', 'N', NULL, NULL, NULL, 202);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510260', '5108', 'MT', '5190', '5102', '51010', '51', 'CAMPINAPOLIS', NULL, '66', '78630000', '3', '9863', '9863', '10126', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'S', NULL, 'N', 5970.464, '-14,51600', '-52,89500', 450, 'S', 0.6730, NULL, NULL, '51900', 'S', 'N', 938, NULL, '5190', '5190', NULL, '1986', 'S', 2305, 'CAMPINÁPOLIS', 'N', '510260', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '21', NULL, '03', 'N', NULL, NULL, NULL, 262);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510263', '5105', 'MT', '5190', '5101', '51004', '51', 'CAMPO NOVO DO PARECIS', NULL, '65', '78360000', '7', '9777', '9777', '10151', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 9448.384, '-13,67500', '-57,89200', 572, 'S', 0.8090, NULL, NULL, '51900', 'S', 'N', 971, NULL, '5190', '5190', NULL, '1989', 'S', 2306, 'CAMPO NOVO DO PARECIS', 'N', '510263', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '22', NULL, '03', 'N', NULL, NULL, NULL, 77);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510267', '5107', 'MT', '5190', '5105', '51019', '51', 'CAMPO VERDE', NULL, '66', '78840000', '8', '9779', '9779', '10152', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 4794.555, '-15,54700', '-55,16900', 736, 'S', 0.8000, NULL, NULL, '51900', 'S', 'N', 973, NULL, '5190', '5190', NULL, '1989', 'S', 2307, 'CAMPO VERDE', 'N', '510267', 'S', 'N', 'S', NULL, 16, 'N', 'N', 'N', '23', NULL, '03', 'N', NULL, NULL, NULL, 371);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510268', '5112', 'MT', '5190', '5101', '51004', '51', 'CAMPOS DE JULIO', NULL, '65', '78307000', '6', '1032', NULL, '10183', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 6804.577, '-13,89900', '-59,14800', 0, 'S', 0.8100, NULL, NULL, '51900', 'S', 'N', 977, NULL, '5190', '5190', NULL, '1997', 'S', 2308, 'CAMPOS DE JÚLIO', 'N', '510268', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '24', NULL, '03', 'N', NULL, NULL, NULL, 444);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510269', '5106', 'MT', '5190', '5102', '51009', '51', 'CANABRAVA DO NORTE', NULL, '74', '78658000', '4', '0129', '0129', '10163', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3449.984, '-11,05400', '-51,83100', 225, 'S', 0.6930, NULL, NULL, '51900', 'S', 'N', 987, NULL, '5190', '5190', NULL, '1993', 'S', 2309, 'CANABRAVA DO NORTE', 'N', '510269', 'S', 'N', 'S', NULL, 19, 'N', 'N', 'N', '25', NULL, '03', 'N', NULL, NULL, NULL, 143);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510270', '5103', 'MT', '5190', '5102', '51010', '51', 'CANARANA', NULL, '66', '78640000', '2', '9193', '9193', '10098', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'S', NULL, 'N', 10834.325, '-13,55000', '-52,16600', 420, 'S', 0.7610, NULL, NULL, '51900', 'S', 'N', 995, NULL, '5190', '5190', NULL, '1979', 'S', 2310, 'CANARANA', 'N', '510270', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '26', NULL, '03', 'N', NULL, NULL, NULL, 144);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510279', '5104', 'MT', '5190', '5101', '51002', '51', 'CARLINDA', NULL, '66', '78587000', '3', '1034', NULL, '10184', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2417.212, '-9,95800', '-55,83200', 290, 'S', 0.7000, NULL, NULL, '51900', 'S', 'N', 1106, NULL, '5190', '5190', NULL, '1997', 'S', 2311, 'CARLINDA', 'N', '510279', 'S', 'N', 'S', NULL, 74, 'N', 'N', 'N', '27', NULL, '03', 'N', NULL, NULL, NULL, 370);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510285', '5109', 'MT', '5190', '5101', '51001', '51', 'CASTANHEIRA', NULL, '66', '78345000', '0', '9783', '9783', '10153', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 3948.861, '-11,13300', '-58,60300', 400, 'S', 0.7300, NULL, NULL, '51900', 'S', 'N', 1156, NULL, '5190', '5190', NULL, '1989', 'S', 2312, 'CASTANHEIRA', 'N', '510285', 'S', 'N', 'S', NULL, 163, 'N', 'N', 'N', '28', NULL, '03', 'N', NULL, NULL, NULL, 423);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510300', '5101', 'MT', '5190', '5104', '51017', '51', 'CHAPADA DOS GUIMARAES', NULL, '65', '78195000', '7', '9059', '9059', '10030', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 6206.573, '-15,46100', '-55,75000', 811, 'S', 0.7110, NULL, NULL, '51900', 'S', 'N', 1233, NULL, '5102', '5190', NULL, '1953', 'S', 2313, 'CHAPADA DOS GUIMARÃES', 'N', '510300', 'S', 'N', 'S', NULL, 16, 'N', 'N', 'N', '29', NULL, '03', 'N', NULL, NULL, NULL, 76);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510305', '5114', 'MT', '5190', '5101', '51007', '51', 'CLAUDIA', NULL, '66', '78540000', '6', '9789', '9789', '10154', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3820.948, '-11,51500', '-54,89100', 368, 'S', 0.8130, NULL, NULL, '51900', 'S', 'N', 1266, NULL, '5190', '5190', NULL, '1989', 'S', 2314, 'CLÁUDIA', 'N', '510305', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '30', NULL, '03', 'N', NULL, NULL, NULL, 248);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510310', '5103', 'MT', '5190', '5102', '51011', '51', 'COCALINHO', NULL, '66', '78680000', '6', '9865', '9865', '10127', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 16538.832, '-14,39700', '-50,99600', 241, 'S', 0.7270, NULL, NULL, '51900', 'S', 'N', 1276, NULL, '5190', '5190', NULL, '1986', 'S', 2315, 'COCALINHO', 'N', '510310', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '31', NULL, '03', 'N', NULL, NULL, NULL, 144);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510320', '5115', 'MT', '5190', '5101', '51003', '51', 'COLIDER', NULL, '66', '78500000', '5', '8979', '8979', '10099', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 3038.249, '-10,81300', '-55,45500', 265, 'S', 0.7500, NULL, NULL, '51900', 'S', 'N', 1287, NULL, '5190', '5190', NULL, '1979', 'S', 2316, 'COLÍDER', 'N', '510320', 'S', 'N', 'S', NULL, 74, 'N', 'N', 'N', '32', NULL, '03', 'N', NULL, NULL, NULL, 424);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510330', '5112', 'MT', '5190', '5101', '51004', '51', 'COMODORO', NULL, '65', '78310000', '4', '9883', '9883', '10128', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 21743.362, '-13,66300', '-59,78600', 600, 'S', 0.7240, NULL, NULL, '51900', 'S', 'N', 1307, NULL, '5190', '5190', NULL, '1986', 'S', 2317, 'COMODORO', 'N', '510330', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '34', NULL, '03', 'N', NULL, NULL, NULL, 444);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510335', '5106', 'MT', '5190', '5102', '51009', '51', 'CONFRESA', NULL, '66', '78652000', '3', '0131', '0131', '10179', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 5796.382, '-10,64400', '-51,56900', 240, 'S', 0.7040, NULL, NULL, '51900', 'S', 'N', 1341, NULL, '5190', '5190', NULL, '1993', 'S', 2318, 'CONFRESA', 'N', '510335', 'S', 'N', 'S', NULL, 19, 'N', 'N', 'N', '35', NULL, '03', 'N', NULL, NULL, NULL, 143);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510336', '5112', 'MT', '5190', '5103', '51012', '51', 'CONQUISTA D''OESTE', NULL, '65', '78254000', '1', '1082', NULL, '10194', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2698.008, '-14,54100', '-59,54800', 0, 'S', NULL, NULL, NULL, '51900', 'S', 'N', 5696, NULL, '5190', '5190', NULL, '2001', 'S', 5567, 'CONQUISTA D OESTE', 'N', '510336', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '36', NULL, '03', 'N', NULL, NULL, NULL, 444);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510337', '5109', 'MT', '5190', '5101', '51001', '51', 'COTRIGUACU', NULL, '66', '78330000', '9', '0089', '0089', '10164', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'S', NULL, 'N', 9123.582, '-9,85800', '-58,41400', 200, 'S', 0.7210, NULL, NULL, '51900', 'S', 'N', 1419, NULL, '5190', '5190', NULL, '1993', 'S', 2319, 'COTRIGUAÇU', 'N', '510337', 'S', 'N', 'S', NULL, 163, 'N', 'N', 'N', '37', NULL, '03', 'N', NULL, NULL, NULL, 423);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510340', '5101', 'MT', '5190', '5104', '51017', '51', 'CUIABA', NULL, '65', '78005000', '3', '9067', '9067', '10034', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'S', 3538.167, '-15,59600', '-56,09700', 176, 'S', 0.8210, NULL, NULL, '51900', 'N', 'N', 1471, NULL, '5101', '5101', NULL, '1719', 'S', 2320, 'CUIABÁ', 'N', '510340', 'S', 'N', 'S', NULL, 16, 'S', 'S', 'S', '38', NULL, '01', 'N', NULL, NULL, NULL, 76);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510343', '5102', 'MT', '5190', '5104', '51018', '51', 'CURVELANDIA', NULL, '65', '78237000', '7', '1084', NULL, '10195', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 748.363, '-15,60800', '-57,91500', 0, 'S', NULL, NULL, NULL, '51900', 'S', 'N', 5698, NULL, '5190', '5190', NULL, '2001', 'S', 5568, 'CURVELÂNDIA', 'N', '510343', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '39', NULL, '03', 'N', NULL, NULL, NULL, 202);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510345', '5105', 'MT', '5190', '5103', '51013', '51', 'DENISE', NULL, '65', '78380000', '2', '9833', '9833', '10121', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1300.924, '-14,74000', '-57,05400', 211, 'S', 0.7360, NULL, NULL, '51900', 'S', 'N', 1519, NULL, '5190', '5190', NULL, '1982', 'S', 2321, 'DENISE', 'N', '510345', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '40', NULL, '03', 'N', NULL, NULL, NULL, 77);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510350', '5113', 'MT', '5190', '5101', '51004', '51', 'DIAMANTINO', NULL, '65', '78400000', '2', '9069', '9069', '10035', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'S', NULL, 'N', 7630.212, '-14,40900', '-56,44600', 269, 'S', 0.7880, NULL, NULL, '51900', 'S', 'N', 1536, NULL, '5190', '5190', NULL, '1906', 'S', 2322, 'DIAMANTINO', 'N', '510350', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '41', NULL, '03', 'N', NULL, NULL, NULL, 201);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510360', '5107', 'MT', '5190', '5105', '51021', '51', 'DOM AQUINO', NULL, '66', '78830000', '1', '9071', '9071', '10036', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2205.079, '-15,81100', '-54,91800', 283, 'S', 0.7220, NULL, NULL, '51900', 'S', 'N', 1569, NULL, '5190', '5190', NULL, '1958', 'S', 2323, 'DOM AQUINO', 'N', '510360', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '42', NULL, '03', 'N', NULL, NULL, NULL, 371);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510370', '5114', 'MT', '5190', '5101', '51007', '51', 'FELIZ NATAL', NULL, '66', '78885000', '0', '1036', '1036', '10185', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 11448.049, '-12,38600', '-54,92000', 370, 'S', 0.7480, NULL, NULL, '51900', 'S', 'N', 1748, NULL, '5190', '5190', NULL, '1997', 'S', 2324, 'FELIZ NATAL', 'N', '510370', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '43', NULL, '03', 'N', NULL, NULL, NULL, 248);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510380', '5112', 'MT', '5190', '5103', '51014', '51', 'FIGUEIROPOLIS D''OESTE', NULL, '65', '78290000', '9', '9881', '9881', '10129', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 890.949, '-15,44500', '-58,74000', 300, 'S', 0.7050, NULL, NULL, '51900', 'S', 'N', 1765, NULL, '5190', '5190', NULL, '1986', 'S', 2325, 'FIGUEIRÓPOLIS D OESTE', 'N', '510380', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '44', NULL, '03', 'N', NULL, NULL, NULL, 444);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510385', '5103', 'MT', '5190', '5101', '51008', '51', 'GAUCHA DO NORTE', NULL, '66', '78875000', '8', '1038', '1038', '10186', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 16898.569, '-13,24200', '-53,08000', 0, 'S', 0.7020, NULL, NULL, '51900', 'S', 'N', 1869, NULL, '5190', '5190', NULL, '1997', 'S', 2326, 'GAÚCHA DO NORTE', 'N', '510385', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '45', NULL, '03', 'N', NULL, NULL, NULL, 144);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510390', '5108', 'MT', '5190', '5105', '51020', '51', 'GENERAL CARNEIRO', NULL, '66', '78620000', '8', '9077', '9077', '10039', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 3721.078, '-15,71100', '-52,75500', 343, 'S', 0.6950, NULL, NULL, '51900', 'S', 'N', 1875, NULL, '5190', '5190', NULL, '1963', 'S', 2327, 'GENERAL CARNEIRO', 'N', '510390', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '46', NULL, '03', 'N', NULL, NULL, NULL, 262);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510395', '5102', 'MT', '5190', '5103', '51014', '51', 'GLORIA D''OESTE', NULL, '65', '78293000', '7', '0135', '0135', '10165', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 846.053, '-15,76800', '-58,35600', 0, 'S', 0.7310, NULL, NULL, '51900', 'S', 'N', 1890, NULL, '5190', '5190', NULL, '1993', 'S', 2328, 'GLÓRIA D OESTE', 'N', '510395', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '47', NULL, '03', 'N', NULL, NULL, NULL, 202);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510410', '5111', 'MT', '5190', '5101', '51003', '51', 'GUARANTA DO NORTE', NULL, '66', '78520000', '4', '9887', '9887', '10130', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4713.043, '-9,78800', '-54,91000', 345, 'S', 0.7570, NULL, NULL, '51900', 'S', 'N', 1995, NULL, '5190', '5190', NULL, '1986', 'S', 2329, 'GUARANTÃ DO NORTE', 'N', '510410', 'S', 'N', 'S', NULL, 74, 'N', 'N', 'N', '48', NULL, '03', 'N', NULL, NULL, NULL, 362);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510420', '5107', 'MT', '5190', '5105', '51020', '51', 'GUIRATINGA', NULL, '66', '78760000', '3', '9083', '9083', '10042', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 5358.322, '-16,34900', '-53,75800', 510, 'S', 0.7610, NULL, NULL, '51900', 'S', 'N', 2020, NULL, '5190', '5190', NULL, '1943', 'S', 2330, 'GUIRATINGA', 'N', '510420', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '49', NULL, '03', 'N', NULL, NULL, NULL, 371);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510450', '5102', 'MT', '5190', '5103', '51014', '51', 'INDIAVAI', NULL, '65', '78295000', '0', '9877', '9877', '10131', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 600.326, '-15,49400', '-58,57300', 215, 'S', 0.7140, NULL, NULL, '51900', 'S', 'N', 2176, NULL, '5190', '5190', NULL, '1986', 'S', 2331, 'INDIAVAÍ', 'N', '510450', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '50', NULL, '03', 'N', NULL, NULL, NULL, 202);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510455', '5115', 'MT', '5190', '5101', '51007', '51', 'ITAUBA', NULL, '66', '78510000', '9', '9901', '9901', '10132', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 4538.338, '-11,06200', '-55,27600', 240, 'S', 0.7400, NULL, NULL, '51900', 'S', 'N', 2394, NULL, '5190', '5190', NULL, '1986', 'S', 2332, 'ITAÚBA', 'N', '510455', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '53', NULL, '03', 'N', NULL, NULL, NULL, 424);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510460', '5107', 'MT', '5190', '5105', '51021', '51', 'ITIQUIRA', NULL, '65', '78790000', '9', '9091', '9091', '10046', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 8638.691, '-17,20900', '-54,15000', 522, 'S', 0.7670, NULL, NULL, '51900', 'S', 'N', 2403, NULL, '5190', '5190', NULL, '1953', 'S', 2333, 'ITIQUIRA', 'N', '510460', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '54', NULL, '03', 'N', NULL, NULL, NULL, 371);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510480', '5107', 'MT', '5190', '5105', '51021', '51', 'JACIARA', NULL, '66', '78820000', '7', '9095', '9095', '10048', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1658.720, '-15,96500', '-54,96800', 367, 'S', 0.7880, NULL, NULL, '51900', 'S', 'N', 2449, NULL, '5190', '5190', NULL, '1958', 'S', 2334, 'JACIARA', 'N', '510480', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '55', NULL, '03', 'N', NULL, NULL, NULL, 371);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510490', '5101', 'MT', '5190', '5104', '51016', '51', 'JANGADA', NULL, '65', '78490000', '6', '9861', '9861', '10149', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 1021.939, '-15,23600', '-56,48900', 178, 'S', 0.6800, NULL, NULL, '51900', 'S', 'N', 2487, NULL, '5102', '5190', NULL, '1989', 'S', 2335, 'JANGADA', 'N', '510490', 'S', 'N', 'S', NULL, 16, 'N', 'N', 'N', '56', NULL, '03', 'N', NULL, NULL, NULL, 76);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510500', '5112', 'MT', '5190', '5103', '51014', '51', 'JAURU', NULL, '65', '78255000', '2', '8991', '8991', '10100', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1217.480, '-15,34200', '-58,86600', 405, 'S', 0.6800, NULL, NULL, '51900', 'S', 'N', 2531, NULL, '5190', '5190', NULL, '1979', 'S', 2336, 'JAURU', 'N', '510500', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '57', NULL, '03', 'N', NULL, NULL, NULL, 444);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510510', '5110', 'MT', '5190', '5101', '51005', '51', 'JUARA', NULL, '66', '78575000', '1', '9819', '9819', '10122', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'S', NULL, 'N', 21387.334, '-11,25500', '-57,52000', 292, 'S', 0.7630, NULL, NULL, '51900', 'S', 'N', 2587, NULL, '5190', '5190', NULL, '1981', 'S', 2337, 'JUARA', 'N', '510510', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '58', NULL, '03', 'N', NULL, NULL, NULL, 415);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510515', '5109', 'MT', '5190', '5101', '51001', '51', 'JUINA', NULL, '66', '78320000', '0', '9831', '9831', '10123', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'S', NULL, 'N', 26251.276, '-11,37800', '-58,74100', 442, 'S', 0.7490, NULL, NULL, '51900', 'S', 'N', 2599, NULL, '5190', '5190', NULL, '1982', 'S', 2338, 'JUÍNA', 'N', '510515', 'S', 'N', 'S', NULL, 163, 'N', 'N', 'S', '59', NULL, '03', 'N', NULL, NULL, NULL, 423);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510517', '5109', 'MT', '5190', '5101', '51001', '51', 'JURUENA', NULL, '66', '78340000', '6', '9921', '9921', '10155', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 3190.476, '-10,31800', '-58,35900', 300, 'S', 0.7510, NULL, NULL, '51900', 'S', 'N', 2624, NULL, '5190', '5190', NULL, '1989', 'S', 2339, 'JURUENA', 'N', '510517', 'S', 'N', 'S', NULL, 163, 'N', 'N', 'N', '60', NULL, '03', 'N', NULL, NULL, NULL, 423);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510520', '5107', 'MT', '5190', '5105', '51021', '51', 'JUSCIMEIRA', NULL, '66', '78810000', '0', '9189', '9189', '10101', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2205.018, '-16,05100', '-54,88400', 251, 'S', 0.7180, NULL, NULL, '51900', 'S', 'N', 2626, NULL, '5190', '5190', NULL, '1979', 'S', 2340, 'JUSCIMEIRA', 'N', '510520', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '61', NULL, '03', 'N', NULL, NULL, NULL, 371);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510523', '5102', 'MT', '5190', '5103', '51014', '51', 'LAMBARI D''OESTE', NULL, '65', '78278000', '4', '0137', '0137', '10166', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1337.245, '-15,32300', '-58,00400', 186, 'S', 0.6920, NULL, NULL, '51900', 'S', 'N', 2701, NULL, '5190', '5190', NULL, '1993', 'S', 2341, 'LAMBARI D OESTE', 'N', '510523', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '62', NULL, '03', 'N', NULL, NULL, NULL, 202);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510525', '5114', 'MT', '5190', '5101', '51006', '51', 'LUCAS DO RIO VERDE', NULL, '65', '78455000', '9', '9925', '9925', '10156', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3659.859, '-13,05000', '-55,91100', 390, 'S', 0.8180, NULL, NULL, '51900', 'S', 'N', 2766, NULL, '5190', '5190', NULL, '1989', 'S', 2342, 'LUCAS DO RIO VERDE', 'N', '510525', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '63', NULL, '03', 'N', NULL, NULL, NULL, 248);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510530', '5116', 'MT', '5190', '5102', '51009', '51', 'LUCIARA', NULL, '66', '78660000', '9', '9105', '9105', '10053', NULL, 'ATIVO', 'S', 'N', NULL, 'LUCIÁRA                   ', 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 4145.262, '-11,22200', '-50,66900', 197, 'S', 0.6910, NULL, NULL, '51900', 'S', 'N', 2770, NULL, '5190', '5190', NULL, '1963', 'S', 2343, 'LUCIARA', 'N', '510530', 'S', 'N', 'S', NULL, 19, 'N', 'N', 'N', '64', NULL, '03', 'N', NULL, NULL, NULL, 443);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510550', '5112', 'MT', '5190', '5103', '51012', '51', 'VILA BELA DA SANTISSIMA TRINDADE', NULL, '65', '78245000', '7', '9109', '9109', '10055', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 13630.948, '-15,00800', '-59,95100', 198, 'S', 0.7150, NULL, NULL, '51900', 'S', 'N', 5442, NULL, '5190', '5190', NULL, '1746', 'S', 2410, 'VILA BELA DA SANTÍSSIMA TRINDADE', 'N', '510550', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '140', NULL, '03', 'N', NULL, NULL, NULL, 444);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510558', '5115', 'MT', '5190', '5101', '51007', '51', 'MARCELANDIA', NULL, '66', '78535000', '0', '9899', '9899', '10133', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 12294.144, '-11,13300', '-54,59700', 290, 'S', 0.7710, NULL, NULL, '51900', 'S', 'N', 2901, NULL, '5190', '5190', NULL, '1986', 'S', 2344, 'MARCELÂNDIA', 'N', '510558', 'S', 'N', 'S', NULL, 74, 'N', 'N', 'N', '65', NULL, '03', 'N', NULL, NULL, NULL, 424);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510560', '5111', 'MT', '5190', '5101', '51003', '51', 'MATUPA', NULL, '66', '78525000', '6', '9929', '9929', '10157', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 5151.850, '-10,05700', '-54,93300', 280, 'S', 0.7530, NULL, NULL, '51900', 'S', 'N', 2987, NULL, '5190', '5190', NULL, '1989', 'S', 2345, 'MATUPÁ', 'N', '510560', 'S', 'N', 'S', NULL, 74, 'N', 'N', 'N', '66', NULL, '03', 'N', NULL, NULL, NULL, 362);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510562', '5102', 'MT', '5190', '5103', '51014', '51', 'MIRASSOL D''OESTE', NULL, '65', '78280000', '2', '9177', '9177', '10089', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1072.537, '-15,67500', '-58,09600', 260, 'S', 0.7390, NULL, NULL, '51900', 'S', 'N', 3059, NULL, '5190', '5190', NULL, '1976', 'S', 2346, 'MIRASSOL D OESTE', 'N', '510562', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '67', NULL, '03', 'N', NULL, NULL, NULL, 202);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510590', '5113', 'MT', '5190', '5101', '51006', '51', 'NOBRES', NULL, '65', '78460000', '3', '9117', '9117', '10059', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'S', NULL, 'N', 3859.509, '-14,72000', '-56,32800', 200, 'S', 0.7240, NULL, NULL, '51900', 'S', 'N', 3234, NULL, '5102', '5190', NULL, '1963', 'S', 2347, 'NOBRES', 'N', '510590', 'S', 'N', 'S', NULL, 16, 'N', 'N', 'N', '68', NULL, '03', 'N', NULL, NULL, NULL, 201);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510600', '5113', 'MT', '5190', '5104', '51015', '51', 'NORTELANDIA', NULL, '65', '78430000', '0', '9119', '9119', '10060', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1350.778, '-14,45500', '-56,80300', 244, 'S', 0.7180, NULL, NULL, '51900', 'S', 'N', 3238, NULL, '5190', '5190', NULL, '1953', 'S', 2348, 'NORTELÂNDIA', 'N', '510600', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '69', NULL, '03', 'N', NULL, NULL, NULL, 201);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510610', '5101', 'MT', '5190', '5104', '51017', '51', 'NOSSA SENHORA DO LIVRAMENTO', NULL, '65', '78170000', '9', '9121', '9121', '10061', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 5192.568, '-15,77500', '-56,34600', 232, 'S', 0.6550, NULL, NULL, '51900', 'S', 'N', 3245, NULL, '5101', '5190', NULL, '1883', 'S', 2349, 'NOSSA SENHORA DO LIVRAMENTO', 'N', '510610', 'S', 'N', 'S', NULL, 16, 'N', 'N', 'N', '70', NULL, '03', 'N', NULL, NULL, NULL, 76);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510615', '5104', 'MT', '5190', '5101', '51002', '51', 'NOVA BANDEIRANTES', NULL, '66', '78565000', '8', '0117', '0117', '10180', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 9531.206, '-9,81400', '-57,86200', 200, 'S', 0.7020, NULL, NULL, '51900', 'S', 'N', 3258, NULL, '5190', '5190', NULL, '1993', 'S', 2350, 'NOVA BANDEIRANTES', 'N', '510615', 'S', 'N', 'S', NULL, 74, 'N', 'N', 'N', '71', NULL, '03', 'N', NULL, NULL, NULL, 370);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510617', '5103', 'MT', '5190', '5102', '51010', '51', 'NOVA NAZARE', NULL, '66', '78638000', '4', '1086', '1086', '10196', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4038.699, '-13,99000', '-51,79800', 0, 'S', NULL, NULL, NULL, '51900', 'S', 'N', 5700, NULL, '5190', '5190', NULL, '2001', 'S', 5569, 'NOVA NAZARÉ', 'N', '510617', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '80', NULL, '03', 'N', NULL, NULL, NULL, 144);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510618', '5112', 'MT', '5190', '5103', '51012', '51', 'NOVA LACERDA', NULL, '65', '78243000', '2', '1040', '1040', '10187', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4734.162, '-14,47600', '-59,60900', 190, 'S', 0.7190, NULL, NULL, '51900', 'S', 'N', 3299, NULL, '5190', '5190', NULL, '1997', 'S', 2354, 'NOVA LACERDA', 'N', '510618', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '75', NULL, '03', 'N', NULL, NULL, NULL, 444);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510619', '5115', 'MT', '5190', '5101', '51007', '51', 'NOVA SANTA HELENA', NULL, '66', '78548000', '0', '1088', NULL, '10197', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 2627.835, '-10,85200', '-55,17700', 0, 'S', NULL, NULL, NULL, '51900', 'S', 'N', 5702, NULL, '5190', '5190', NULL, '2001', 'S', 5570, 'NOVA SANTA HELENA', 'N', '510619', 'S', 'N', 'S', NULL, 74, 'N', 'N', 'N', '82', NULL, '03', 'N', NULL, NULL, NULL, 424);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510620', '5101', 'MT', '5190', '5101', '51008', '51', 'NOVA BRASILANDIA', NULL, '66', '78860000', '8', '8981', '8981', '10102', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3266.215, '-14,95700', '-54,96600', 540, 'S', 0.7100, NULL, NULL, '51900', 'S', 'N', 3262, NULL, '5102', '5190', NULL, '1979', 'S', 2351, 'NOVA BRASILÂNDIA', 'N', '510620', 'S', 'N', 'S', NULL, 16, 'S', 'N', 'N', '72', NULL, '03', 'N', NULL, NULL, NULL, 76);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510621', '5115', 'MT', '5190', '5101', '51003', '51', 'NOVA CANAA DO NORTE', NULL, '66', '78515000', '6', '9889', '9889', '10134', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 5968.991, '-10,55800', '-55,95300', 301, 'S', 0.7020, NULL, NULL, '51900', 'S', 'N', 3267, NULL, '5190', '5190', NULL, '1986', 'S', 2352, 'NOVA CANAÃ DO NORTE', 'N', '510621', 'S', 'N', 'S', NULL, 74, 'N', 'N', 'N', '73', NULL, '03', 'N', NULL, NULL, NULL, 424);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510622', '5114', 'MT', '5190', '5101', '51006', '51', 'NOVA MUTUM', NULL, '65', '78450000', '4', '9937', '9937', '10158', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 9537.923, '-13,83800', '-56,08400', 460, 'S', 0.8010, NULL, NULL, '51900', 'S', 'N', 3308, NULL, '5190', '5190', NULL, '1989', 'S', 2358, 'NOVA MUTUM', 'N', '510622', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '79', NULL, '03', 'N', NULL, NULL, NULL, 248);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510623', '5105', 'MT', '5190', '5103', '51013', '51', 'NOVA OLIMPIA', NULL, '65', '78370000', '2', '9893', '9893', '10135', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1567.669, '-14,79700', '-57,28800', 228, 'S', 0.7420, NULL, NULL, '51900', 'S', 'N', 3310, NULL, '5190', '5190', NULL, '1986', 'S', 2359, 'NOVA OLÍMPIA', 'N', '510623', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '81', NULL, '03', 'N', NULL, NULL, NULL, 77);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510624', '5114', 'MT', '5190', '5101', '51006', '51', 'NOVA UBIRATA', NULL, '66', '78888000', '0', '1042', '7000', '10188', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 12694.974, '-12,99100', '-55,25500', 400, 'S', 0.7790, NULL, NULL, '51900', 'S', 'N', 3340, NULL, '5190', '5190', NULL, '1997', 'S', 2360, 'NOVA UBIRATÃ', 'N', '510624', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '83', NULL, '03', 'N', NULL, NULL, NULL, 248);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510625', '5108', 'MT', '5190', '5102', '51010', '51', 'NOVA XAVANTINA', NULL, '66', '78690000', '7', '9195', '9195', '10111', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 5526.733, '-14,67300', '-52,35300', 275, 'S', 0.7600, NULL, NULL, '51900', 'S', 'N', 3347, NULL, '5190', '5190', NULL, '1980', 'S', 2361, 'NOVA XAVANTINA', 'N', '510625', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '84', NULL, '03', 'N', NULL, NULL, NULL, 262);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510626', '5111', 'MT', '5190', '5101', '51003', '51', 'NOVO MUNDO', NULL, '66', '78528000', '5', '1044', NULL, '10189', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 5801.766, '-9,95000', '-55,19800', 330, 'S', 0.7320, NULL, NULL, '51900', 'S', 'N', 3369, NULL, '5190', '5190', NULL, '1997', 'S', 2363, 'NOVO MUNDO', 'N', '510626', 'S', 'N', 'S', NULL, 74, 'N', 'N', 'N', '86', NULL, '03', 'N', NULL, NULL, NULL, 362);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510627', '5110', 'MT', '5190', '5101', '51005', '51', 'NOVO HORIZONTE DO NORTE', NULL, '66', '78570000', '3', '9903', '9031', '10136', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 938.389, '-11,41300', '-57,35200', 220, 'S', 0.7020, NULL, NULL, '51900', 'S', 'N', 3362, NULL, '5190', '5190', NULL, '1976', 'S', 2362, 'NOVO HORIZONTE DO NORTE', 'N', '510627', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '85', NULL, '03', 'N', NULL, NULL, NULL, 415);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510628', '5108', 'MT', '5190', '5102', '51010', '51', 'NOVO SAO JOAQUIM', NULL, '66', '78625000', '1', '9867', '9867', '10137', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 5022.477, '-14,90600', '-53,01800', 400, 'S', 0.7430, NULL, NULL, '51900', 'S', 'N', 3377, NULL, '5190', '5190', NULL, '1986', 'S', 2364, 'NOVO SÃO JOAQUIM', 'N', '510628', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '88', NULL, '03', 'N', NULL, NULL, NULL, 262);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510629', '5104', 'MT', '5190', '5101', '51002', '51', 'PARANAITA', NULL, '66', '78590000', '9', '9885', '9885', '10138', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4830.143, '-9,66500', '-56,47700', 249, 'S', 0.7180, NULL, NULL, '51900', 'S', 'N', 3547, NULL, '5190', '5190', NULL, '1987', 'S', 2365, 'PARANAÍTA', 'N', '510629', 'S', 'N', 'S', NULL, 74, 'N', 'N', 'N', '89', NULL, '03', 'N', NULL, NULL, NULL, 370);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510630', '5107', 'MT', '5190', '5101', '51008', '51', 'PARANATINGA', NULL, '66', '78870000', '7', '8983', '8983', '10103', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'S', NULL, 'N', 24177.568, '-14,43200', '-54,05100', 460, 'S', 0.7240, NULL, NULL, '51900', 'S', 'N', 3552, NULL, '5190', '5190', NULL, '1979', 'S', 2366, 'PARANATINGA', 'N', '510630', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '90', NULL, '03', 'N', NULL, NULL, NULL, 371);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510631', '5116', 'MT', '5190', '5102', '51009', '51', 'NOVO SANTO ANTONIO', NULL, '66', '78674000', '5', '1090', NULL, '10198', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4368.459, '-12,29000', '-50,96800', 0, 'S', NULL, NULL, NULL, '51900', 'S', 'N', 5704, NULL, '5190', '5190', NULL, '2001', 'S', 5571, 'NOVO SANTO ANTÔNIO', 'N', '510631', 'S', 'N', 'S', NULL, 19, 'S', 'N', 'N', '87', NULL, '03', 'N', NULL, NULL, NULL, 443);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510637', '5107', 'MT', '5190', '5105', '51021', '51', 'PEDRA PRETA', NULL, '66', '78795000', '2', '9181', '9181', '10091', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4193.207, '-16,62300', '-54,47400', 248, 'S', 0.7350, NULL, NULL, '51900', 'S', 'N', 3651, NULL, '5190', '5190', NULL, '1976', 'S', 2367, 'PEDRA PRETA', 'N', '510637', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '91', NULL, '03', 'N', NULL, NULL, NULL, 371);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510642', '5111', 'MT', '5190', '5101', '51003', '51', 'PEIXOTO DE AZEVEDO', NULL, '66', '78530000', '2', '9891', '9891', '10139', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'S', NULL, 'N', 14398.661, '-10,22900', '-54,98300', 346, 'S', 0.7190, NULL, NULL, '51900', 'S', 'N', 3681, NULL, '5190', '5190', NULL, '1986', 'S', 2368, 'PEIXOTO DE AZEVEDO', 'N', '510642', 'S', 'N', 'S', NULL, 74, 'N', 'N', 'N', '92', NULL, '03', 'N', NULL, NULL, NULL, 362);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510645', '5101', 'MT', '5190', '5101', '51008', '51', 'PLANALTO DA SERRA', NULL, '66', '78855000', '5', '0091', '0091', '10181', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2454.108, '-14,65800', '-54,77400', 319, 'S', 0.7380, NULL, NULL, '51900', 'S', 'N', 3832, NULL, '5102', '5190', NULL, '1993', 'S', 2369, 'PLANALTO DA SERRA', 'N', '510645', 'S', 'N', 'S', NULL, 16, 'S', 'N', 'N', '93', NULL, '03', 'N', NULL, NULL, NULL, 76);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510650', '5101', 'MT', '5190', '5104', '51018', '51', 'POCONE', NULL, '65', '78175000', '5', '9129', '9129', '10065', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 17260.861, '-16,25700', '-56,62300', 142, 'S', 0.6790, NULL, NULL, '51900', 'S', 'N', 3848, NULL, '5102', '5190', NULL, '1831', 'S', 2370, 'POCONÉ', 'N', '510650', 'S', 'N', 'S', NULL, 16, 'N', 'N', 'S', '94', NULL, '03', 'N', NULL, NULL, NULL, 76);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510665', '5108', 'MT', '5190', '5105', '51020', '51', 'PONTAL DO ARAGUAIA', NULL, '66', '78698000', '3', '0095', '0095', '10170', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2755.095, '-15,93400', '-52,31700', 370, 'S', 0.7890, NULL, NULL, '51900', 'S', 'N', 3863, NULL, '5190', '5190', NULL, '1993', 'S', 2371, 'PONTAL DO ARAGUAIA', 'N', '510665', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '95', NULL, '03', 'N', NULL, NULL, NULL, 262);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510670', '5108', 'MT', '5190', '5105', '51020', '51', 'PONTE BRANCA', NULL, '66', '78610000', '3', '9133', '9133', '10067', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 687.812, '-16,76400', '-52,83300', 424, 'S', 0.7380, NULL, NULL, '51900', 'S', 'N', 3872, NULL, '5190', '5190', NULL, '1953', 'S', 2372, 'PONTE BRANCA', 'N', '510670', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '96', NULL, '03', 'N', NULL, NULL, NULL, 262);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510675', '5112', 'MT', '5190', '5103', '51012', '51', 'PONTES E LACERDA', NULL, '65', '78250000', '2', '8999', '8999', '10104', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 8423.347, '-15,22600', '-59,33500', 254, 'S', 0.7530, NULL, NULL, '51900', 'S', 'N', 3876, NULL, '5190', '5190', NULL, '1979', 'S', 2373, 'PONTES E LACERDA', 'N', '510675', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'S', '97', NULL, '03', 'N', NULL, NULL, NULL, 444);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510677', '5106', 'MT', '5190', '5102', '51009', '51', 'PORTO ALEGRE DO NORTE', NULL, '66', '78655000', '8', '9895', '9895', '10140', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3977.416, '-10,87800', '-51,63300', 205, 'S', 0.7090, NULL, NULL, '51900', 'S', 'N', 3898, NULL, '5190', '5190', NULL, '1986', 'S', 2374, 'PORTO ALEGRE DO NORTE', 'N', '510677', 'S', 'N', 'S', NULL, 19, 'N', 'N', 'N', '98', NULL, '03', 'N', NULL, NULL, NULL, 143);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510680', '5110', 'MT', '5190', '5101', '51005', '51', 'PORTO DOS GAUCHOS', NULL, '66', '78560000', '2', '9135', '9135', '10068', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 7011.545, '-11,53500', '-57,41400', 259, 'S', 0.7560, NULL, NULL, '51900', 'S', 'N', 3909, NULL, '5190', '5190', NULL, '1963', 'S', 2375, 'PORTO DOS GAÚCHOS', 'N', '510680', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '99', NULL, '03', 'N', NULL, NULL, NULL, 415);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510682', '5102', 'MT', '5190', '5103', '51014', '51', 'PORTO ESPERIDIAO', NULL, '65', '78240000', '8', '9875', '9875', '10141', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 5815.306, '-15,85300', '-58,46000', 160, 'S', 0.6950, NULL, NULL, '51900', 'S', 'N', 3910, NULL, '5190', '5190', NULL, '1986', 'S', 2376, 'PORTO ESPERIDIÃO', 'N', '510682', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '100', NULL, '03', 'N', NULL, NULL, NULL, 202);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510685', '5105', 'MT', '5190', '5103', '51013', '51', 'PORTO ESTRELA', NULL, '65', '78398000', '1', '0101', '0101', '10171', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2065.241, '-15,32400', '-57,22800', 134, 'S', 0.6540, NULL, NULL, '51900', 'S', 'N', 3911, NULL, '5190', '5190', NULL, '1993', 'S', 2377, 'PORTO ESTRELA', 'N', '510685', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '101', NULL, '03', 'N', NULL, NULL, NULL, 77);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510700', '5107', 'MT', '5190', '5105', '51020', '51', 'POXOREO', NULL, '66', '78800000', '8', '9139', '9139', '10070', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 6923.227, '-15,83700', '-54,38900', 360, 'S', 0.7430, NULL, NULL, '51900', 'S', 'N', 3943, NULL, '5190', '5190', NULL, '1938', 'S', 2378, 'POXORÉO', 'N', '510700', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '102', NULL, '03', 'N', NULL, NULL, NULL, 371);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510704', '5107', 'MT', '5190', '5105', '51019', '51', 'PRIMAVERA DO LESTE', NULL, '66', '78850000', '0', '9871', '9871', '10142', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 5472.207, '-15,52800', '-54,34600', 465, 'S', 0.8050, NULL, NULL, '51900', 'N', 'N', 3990, NULL, '5190', '5190', NULL, '1987', 'S', 2379, 'PRIMAVERA DO LESTE', 'N', '510704', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '103', NULL, '03', 'N', NULL, NULL, NULL, 371);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510706', '5103', 'MT', '5190', '5102', '51010', '51', 'QUERENCIA', NULL, '66', '78643000', '5', '0097', '0097', '10172', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 17850.249, '-12,47600', '-52,37800', 0, 'S', 0.7500, NULL, NULL, '51900', 'S', 'N', 4025, NULL, '5190', '5190', NULL, '1993', 'S', 2380, 'QUERÊNCIA', 'N', '510706', 'S', 'N', 'S', NULL, 19, 'N', 'N', 'N', '104', NULL, '03', 'N', NULL, NULL, NULL, 144);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510710', '5102', 'MT', '5190', '5103', '51014', '51', 'SAO JOSE DOS QUATRO MARCOS', NULL, '65', '78285000', '7', '8993', '8993', '10105', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1280.846, '-15,62100', '-58,17600', 230, 'S', 0.7350, NULL, NULL, '51900', 'S', 'N', 4740, NULL, '5190', '5190', NULL, '1979', 'S', 2396, 'SÃO JOSÉ DOS QUATRO MARCOS', 'N', '510710', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '124', NULL, '03', 'N', NULL, NULL, NULL, 202);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510715', '5102', 'MT', '5190', '5103', '51014', '51', 'RESERVA DO CABACAL', NULL, '65', '78265000', '6', '9879', '9879', '10143', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 370.820, '-15,08000', '-58,46600', 335, 'S', 0.6800, NULL, NULL, '51900', 'S', 'N', 4080, NULL, '5190', '5190', NULL, '1986', 'S', 2381, 'RESERVA DO CABAÇAL', 'N', '510715', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '105', NULL, '03', 'N', NULL, NULL, NULL, 202);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510718', '5103', 'MT', '5190', '5102', '51009', '51', 'RIBEIRAO CASCALHEIRA', NULL, '66', '78675000', '0', '9741', '9741', '10159', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 11356.472, '-12,94200', '-51,82400', 386, 'S', 0.6940, NULL, NULL, '51900', 'S', 'N', 4116, NULL, '5190', '5190', NULL, '1989', 'S', 2382, 'RIBEIRÃO CASCALHEIRA', 'N', '510718', 'S', 'N', 'S', NULL, 19, 'N', 'N', 'N', '106', NULL, '03', 'N', NULL, NULL, NULL, 144);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510719', '5108', 'MT', '5190', '5105', '51020', '51', 'RIBEIRAOZINHO', NULL, '66', '78613000', '8', '0099', '0099', '10173', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 623.453, '-16,48500', '-52,69200', 477, 'S', 0.7300, NULL, NULL, '51900', 'S', 'N', 4128, NULL, '5190', '5190', NULL, '1993', 'S', 2383, 'RIBEIRÃOZINHO', 'N', '510719', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '107', NULL, '03', 'N', NULL, NULL, NULL, 262);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510720', '5102', 'MT', '5190', '5103', '51014', '51', 'RIO BRANCO', NULL, '65', '78275000', '6', '8995', '8995', '10106', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 501.496, '-15,24100', '-58,11600', 180, 'S', 0.6980, NULL, NULL, '51900', 'S', 'N', 4141, NULL, '5190', '5190', NULL, '1979', 'S', 2384, 'RIO BRANCO', 'N', '510720', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '108', NULL, '03', 'N', NULL, NULL, NULL, 202);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510724', '5114', 'MT', '5190', '5101', '51007', '51', 'SANTA CARMEM', NULL, '66', '78545000', '8', '0123', '0123', '10174', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3920.277, '-11,91300', '-55,22600', 386, 'S', 0.7870, NULL, NULL, '51900', 'S', 'N', 4304, NULL, '5190', '5190', NULL, '1993', 'S', 2388, 'SANTA CARMEM', 'N', '510724', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '113', NULL, '03', 'N', NULL, NULL, NULL, 248);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510726', '5105', 'MT', '5190', '5104', '51015', '51', 'SANTO AFONSO', NULL, '65', '78425000', '3', '0115', '0115', '10175', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1169.503, '-14,49800', '-57,00200', 400, 'S', 0.7280, NULL, NULL, '51900', 'S', 'N', 4471, NULL, '5190', '5190', NULL, '1993', 'S', 2390, 'SANTO AFONSO', 'N', '510726', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '117', NULL, '03', 'N', NULL, NULL, NULL, 77);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510729', '5107', 'MT', '5190', '5105', '51021', '51', 'SAO JOSE DO POVO', NULL, '66', '78773000', '7', '6087', '6087', '10161', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 444.106, '-16,46500', '-54,25500', 281, 'S', 0.6990, NULL, NULL, '51900', 'S', 'N', 4727, NULL, '5190', '5190', NULL, '1993', 'S', 2393, 'SÃO JOSÉ DO POVO', 'N', '510729', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '121', NULL, '03', 'N', NULL, NULL, NULL, 371);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510730', '5113', 'MT', '5190', '5101', '51005', '51', 'SAO JOSE DO RIO CLARO', NULL, '66', '78435000', '5', '9199', '9199', '10107', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 5057.854, '-13,44700', '-56,72100', 350, 'S', 0.7540, NULL, NULL, '51900', 'S', 'N', 4728, NULL, '5190', '5190', NULL, '1979', 'S', 2394, 'SÃO JOSÉ DO RIO CLARO', 'N', '510730', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '122', NULL, '03', 'N', NULL, NULL, NULL, 201);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510735', '5106', 'MT', '5190', '5102', '51009', '51', 'SAO JOSE DO XINGU', NULL, '66', '78663000', '4', '0133', '0133', '10176', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 7463.654, '-10,80400', '-52,74400', 337, 'S', 0.6810, NULL, NULL, '51900', 'S', 'N', 4734, NULL, '5190', '5190', NULL, '1993', 'S', 2395, 'SÃO JOSÉ DO XINGU', 'N', '510735', 'S', 'N', 'S', NULL, 19, 'N', 'N', 'N', '123', NULL, '03', 'N', NULL, NULL, NULL, 143);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510740', '5107', 'MT', '5190', '5105', '51021', '51', 'SAO PEDRO DA CIPA', NULL, '66', '78835000', '4', '0093', '0093', '10177', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 344.360, '-16,00100', '-54,92100', 264, 'S', 0.7170, NULL, NULL, '51900', 'S', 'N', 4803, NULL, '5190', '5190', NULL, '1993', 'S', 2397, 'SÃO PEDRO DA CIPA', 'N', '510740', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '125', NULL, '03', 'N', NULL, NULL, NULL, 371);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510757', '5112', 'MT', '5190', '5101', '51001', '51', 'RONDOLANDIA', NULL, '66', '78338000', '8', '1092', NULL, '10199', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 12653.688, '-10,83800', '-61,47100', 0, 'S', NULL, NULL, NULL, '51900', 'S', 'N', 5706, NULL, '5190', '5190', NULL, '2001', 'S', 5572, 'RONDOLÂNDIA', 'N', '510757', 'S', 'N', 'S', NULL, 163, 'N', 'N', 'N', '109', NULL, '03', 'N', NULL, NULL, NULL, 444);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510760', '5107', 'MT', '5190', '5105', '51021', '51', 'RONDONOPOLIS', NULL, '66', '78700970', '2', '9151', '9151', '10076', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 4165.232, '-16,47100', '-54,63600', 227, 'S', 0.7910, NULL, NULL, '51900', 'N', 'N', 4220, NULL, '5190', '5190', NULL, '1953', 'S', 2385, 'RONDONÓPOLIS', 'N', '510760', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'S', '110', NULL, '01', 'N', NULL, NULL, NULL, 371);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510770', '5113', 'MT', '5190', '5104', '51016', '51', 'ROSARIO OESTE', NULL, '65', '78470000', '1', '9153', '9153', '10077', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 8802.047, '-14,83600', '-56,42800', 192, 'S', 0.7150, NULL, NULL, '51900', 'S', 'N', 4229, NULL, '5102', '5190', NULL, '1833', 'S', 2386, 'ROSÁRIO OESTE', 'N', '510770', 'S', 'N', 'S', NULL, 16, 'N', 'N', 'N', '111', NULL, '03', 'N', NULL, NULL, NULL, 201);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510774', '5106', 'MT', '5190', '5102', '51009', '51', 'SANTA CRUZ DO XINGU', NULL, '66', '78664000', '3', '1094', NULL, '10200', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 5625.401, '-10,15500', '-52,39200', 0, 'S', NULL, NULL, NULL, '51900', 'S', 'N', 5708, NULL, '5190', '5190', NULL, '2001', 'S', 5573, 'SANTA CRUZ DO XINGU', 'N', '510774', 'S', 'N', 'S', NULL, 19, 'S', 'N', 'N', '114', NULL, '03', 'N', NULL, NULL, NULL, 143);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510775', '5102', 'MT', '5190', '5103', '51014', '51', 'SALTO DO CEU', NULL, '65', '78270000', '0', '8997', '8997', '10108', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1312.186, '-15,13000', '-58,12700', 300, 'S', 0.7020, NULL, NULL, '51900', 'S', 'N', 4272, NULL, '5190', '5190', NULL, '1979', 'S', 2387, 'SALTO DO CÉU', 'N', '510775', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '112', NULL, '03', 'N', NULL, NULL, NULL, 202);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510776', '5114', 'MT', '5190', '5101', '51006', '51', 'SANTA RITA DO TRIVELATO', NULL, '65', '78453000', '8', '1096', NULL, '10201', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3345.196, '-13,81300', '-55,26700', 0, 'S', NULL, NULL, NULL, '51900', 'S', 'N', 5710, NULL, '5190', '5190', NULL, '2001', 'S', 5574, 'SANTA RITA DO TRIVELATO', 'N', '510776', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '115', NULL, '03', 'N', NULL, NULL, NULL, 248);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510777', '5106', 'MT', '5190', '5102', '51009', '51', 'SANTA TEREZINHA', NULL, '66', '78650000', '6', '9197', '9197', '10109', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 6450.838, '-10,47000', '-50,50300', 198, 'S', 0.6650, NULL, NULL, '51900', 'S', 'N', 4426, NULL, '5190', '5190', NULL, '1980', 'S', 2389, 'SANTA TEREZINHA', 'N', '510777', 'S', 'N', 'S', NULL, 19, 'N', 'N', 'N', '116', NULL, '03', 'N', NULL, NULL, NULL, 143);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510779', '5107', 'MT', '5190', '5102', '51010', '51', 'SANTO ANTONIO DO LESTE', NULL, '66', '78628000', '2', '1098', NULL, '10202', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3596.798, '-14,79600', '-53,64000', 0, 'S', NULL, NULL, NULL, '51900', 'S', 'N', 5712, NULL, '5190', '5190', NULL, '2001', 'S', 5575, 'SANTO ANTÔNIO DO LESTE', 'N', '510779', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '118', NULL, '03', 'N', NULL, NULL, NULL, 371);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510780', '5101', 'MT', '5190', '5104', '51017', '51', 'SANTO ANTONIO DO LEVERGER', NULL, '65', '78180000', '0', '9155', '9155', '10078', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'S', NULL, 'N', 12260.081, '-15,86600', '-56,07700', 141, 'S', 0.7170, NULL, NULL, '51900', 'S', 'N', 4501, NULL, '5101', '5190', NULL, '1899', 'S', 2391, 'SANTO ANTÔNIO DO LEVERGER', 'N', '510780', 'S', 'N', 'S', NULL, 16, 'N', 'N', 'N', '119', NULL, '03', 'N', NULL, NULL, NULL, 76);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510785', '5116', 'MT', '5190', '5102', '51009', '51', 'SAO FELIX DO ARAGUAIA', NULL, '66', '78670000', '9', '9183', '9183', '10092', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 16848.221, '-11,61700', '-50,66900', 195, 'S', 0.7260, NULL, NULL, '51900', 'S', 'N', 4573, NULL, '5190', '5190', NULL, '1976', 'S', 2392, 'SÃO FÉLIX DO ARAGUAIA', 'N', '510785', 'S', 'N', 'S', NULL, 19, 'N', 'N', 'N', '120', NULL, '03', 'N', NULL, NULL, NULL, 443);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510787', '5105', 'MT', '5190', '5101', '51004', '51', 'SAPEZAL', NULL, '65', '78365000', '5', '1046', NULL, '10190', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 13597.506, '-12,98900', '-58,76400', 370, 'S', 0.8030, NULL, NULL, '51900', 'S', 'N', 4868, NULL, '5190', '5190', NULL, '1997', 'S', 2398, 'SAPEZAL', 'N', '510787', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '126', NULL, '03', 'N', NULL, NULL, NULL, 77);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510788', '5116', 'MT', '5190', '5102', '51009', '51', 'SERRA NOVA DOURADA', NULL, '66', '78668000', '3', '1100', NULL, '10203', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1479.893, '-12,09200', '-51,40200', 0, 'S', NULL, NULL, NULL, '51900', 'S', 'N', 5714, NULL, '5190', '5190', NULL, '2001', 'S', 5576, 'SERRA NOVA DOURADA', 'N', '510788', 'S', 'N', 'S', NULL, 19, 'S', 'N', 'N', '127', NULL, '03', 'N', NULL, NULL, NULL, 443);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510790', '5114', 'MT', '5190', '5101', '51007', '51', 'SINOP', NULL, '66', '78550000', '9', '8985', '8985', '10110', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3194.339, '-11,86400', '-55,50400', 345, 'S', 0.8070, NULL, NULL, '51900', 'N', 'N', 5002, NULL, '5190', '5190', NULL, '1979', 'S', 2399, 'SINOP', 'N', '510790', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'S', '128', NULL, '01', 'N', NULL, NULL, NULL, 248);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510792', '5114', 'MT', '5190', '5101', '51006', '51', 'SORRISO', NULL, '66', '78890000', '5', '9907', '9907', '10144', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 9345.755, '-12,54500', '-55,71100', 365, 'S', 0.8240, NULL, NULL, '51900', 'S', 'N', 5029, NULL, '5190', '5190', NULL, '1987', 'S', 2400, 'SORRISO', 'N', '510792', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'S', '129', NULL, '02', 'N', NULL, NULL, NULL, 248);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510794', '5110', 'MT', '5190', '5101', '51005', '51', 'TABAPORA', NULL, '66', '78563000', '1', '0125', '0125', '10178', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 8225.389, '-10,80700', '-56,62000', 0, 'S', 0.7340, NULL, NULL, '51900', 'S', 'N', 5048, NULL, '5190', '5190', NULL, '1993', 'S', 2401, 'TABAPORÃ', 'N', '510794', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '130', NULL, '03', 'N', NULL, NULL, NULL, 415);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510795', '5105', 'MT', '5190', '5103', '51013', '51', 'TANGARA DA SERRA', NULL, '65', '78300000', '8', '9185', '9185', '10093', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 11565.976, '-14,61900', '-57,48600', 387, 'S', 0.7800, NULL, NULL, '51900', 'N', 'N', 5082, NULL, '5190', '5190', NULL, '1976', 'S', 2402, 'TANGARÁ DA SERRA', 'N', '510795', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'S', '131', NULL, '01', 'N', NULL, NULL, NULL, 77);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510800', '5114', 'MT', '5190', '5101', '51006', '51', 'TAPURAH', NULL, '66', '78555000', '6', '9763', '9763', '10160', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 11600.132, '-12,77200', '-56,55400', 393, 'S', 0.7830, NULL, NULL, '51900', 'S', 'N', 5103, NULL, '5190', '5190', NULL, '1989', 'S', 2403, 'TAPURAH', 'N', '510800', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '132', NULL, '03', 'N', NULL, NULL, NULL, 248);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510805', '5111', 'MT', '5190', '5101', '51003', '51', 'TERRA NOVA DO NORTE', NULL, '66', '78505000', '5', '9909', '9909', '10145', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 2302.332, '-10,51700', '-55,23100', 250, 'S', 0.7480, NULL, NULL, '51900', 'S', 'N', 5159, NULL, '5190', '5190', NULL, '1986', 'S', 2404, 'TERRA NOVA DO NORTE', 'N', '510805', 'S', 'N', 'S', NULL, 74, 'N', 'N', 'N', '133', NULL, '03', 'N', NULL, NULL, NULL, 362);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510810', '5107', 'MT', '5190', '5105', '51020', '51', 'TESOURO', NULL, '66', '78775000', '5', '9161', '9161', '10081', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4017.269, '-16,07900', '-53,55300', 410, 'S', 0.7590, NULL, NULL, '51900', 'S', 'N', 5164, NULL, '5190', '5190', NULL, '1953', 'S', 2405, 'TESOURO', 'N', '510810', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '134', NULL, '03', 'N', NULL, NULL, NULL, 371);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510820', '5108', 'MT', '5190', '5105', '51020', '51', 'TORIXOREU', NULL, '66', '78695000', '4', '9163', '9163', '10082', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2397.925, '-16,19900', '-52,55600', 335, 'S', 0.7700, NULL, NULL, '51900', 'S', 'N', 5200, NULL, '5190', '5190', NULL, '1953', 'S', 2406, 'TORIXORÉU', 'N', '510820', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '135', NULL, '03', 'N', NULL, NULL, NULL, 262);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510830', '5114', 'MT', '5190', '5101', '51007', '51', 'UNIAO DO SUL', NULL, '66', '78543000', '3', '1048', NULL, '10191', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 4581.121, '-11,53300', '-54,35300', 350, 'S', 0.7680, NULL, NULL, '51900', 'S', 'N', 5321, NULL, '5190', '5190', NULL, '1997', 'S', 2407, 'UNIÃO DO SUL', 'N', '510830', 'S', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '136', NULL, '03', 'N', NULL, NULL, NULL, 248);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510835', '5112', 'MT', '5190', '5103', '51012', '51', 'VALE DE SAO DOMINGOS', NULL, '65', '78253000', '2', '1102', NULL, '10204', NULL, 'ATIVO', 'S', 'S', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2001.347, '-15,29400', '-59,06100', 0, 'S', NULL, NULL, NULL, '51900', 'S', 'N', 5716, NULL, '5190', '5190', NULL, '2001', 'S', 5577, 'VALE DE SÃO DOMINGOS', 'N', '510835', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '137', NULL, '03', 'N', NULL, NULL, NULL, 444);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510840', '5101', 'MT', '5190', '5104', '51017', '51', 'VARZEA GRANDE', NULL, '65', '78110970', '2', '9167', '9167', '10084', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 938.057, '-15,64700', '-56,13300', 190, 'S', 0.7900, NULL, NULL, '51900', 'N', 'N', 5390, NULL, '5101', '5101', NULL, '1948', 'S', 2408, 'VÁRZEA GRANDE', 'N', '510840', 'S', 'N', 'S', NULL, 16, 'S', 'S', 'S', '138', NULL, '01', 'N', NULL, NULL, NULL, 76);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510850', '5114', 'MT', '5190', '5101', '51007', '51', 'VERA', NULL, '66', '78880000', '1', '9905', '9905', '10146', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2950.868, '-12,30600', '-55,31700', 383, 'S', 0.7720, NULL, NULL, '51900', 'S', 'N', 5403, NULL, '5190', '5190', NULL, '1986', 'S', 2409, 'VERA', 'N', '510850', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '139', NULL, '03', 'N', NULL, NULL, NULL, 248);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510860', '5106', 'MT', '5190', '5102', '51009', '51', 'VILA RICA', NULL, '66', '78645000', '0', '9897', '9897', '10147', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 7433.445, '-10,01200', '-51,11600', 255, 'S', 0.7230, NULL, NULL, '51900', 'S', 'N', 5454, NULL, '5190', '5190', NULL, '1986', 'S', 2411, 'VILA RICA', 'N', '510860', 'S', 'N', 'S', NULL, 19, 'N', 'N', 'N', '141', NULL, '03', 'N', NULL, NULL, NULL, 143);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510880', '5115', 'MT', '5190', '5101', '51003', '51', 'NOVA GUARITA', NULL, '66', '78508000', '8', '0121', '0121', '10167', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1087.310, '-10,31600', '-55,41000', 300, 'S', 0.7240, NULL, NULL, '51900', 'S', 'N', 3288, NULL, '5190', '5190', NULL, '1993', 'S', 2353, 'NOVA GUARITA', 'N', '510880', 'S', 'N', 'S', NULL, 74, 'N', 'N', 'N', '74', NULL, '03', 'N', NULL, NULL, NULL, 424);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510885', '5105', 'MT', '5190', '5104', '51015', '51', 'NOVA MARILANDIA', NULL, '65', '78415000', '7', '0103', '0103', '10168', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1942.816, '-14,36400', '-56,96900', 300, 'S', 0.7010, NULL, NULL, '51900', 'S', 'N', 3304, NULL, '5190', '5190', NULL, '1993', 'S', 2355, 'NOVA MARILÂNDIA', 'N', '510885', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '76', NULL, '03', 'N', NULL, NULL, NULL, 77);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510890', '5113', 'MT', '5190', '5101', '51005', '51', 'NOVA MARINGA', NULL, '66', '78445000', '7', '0111', '0111', '10169', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 11512.471, '-13,02600', '-57,07400', 370, 'S', 0.7400, NULL, NULL, '51900', 'S', 'N', 3305, NULL, '5190', '5190', NULL, '1993', 'S', 2356, 'NOVA MARINGÁ', 'N', '510890', 'S', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '77', NULL, '03', 'N', NULL, NULL, NULL, 201);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('510895', '5104', 'MT', '5190', '5101', '51002', '51', 'NOVA MONTE VERDE', NULL, '66', '78593000', '6', '0119', '0119', '10182', NULL, 'ATIVO', 'S', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 6500.166, '-9,98200', '-57,53500', 330, 'S', 0.7220, NULL, NULL, '51900', 'S', 'N', 3307, NULL, '5190', '5190', NULL, '1993', 'S', 2357, 'NOVA MONTE VERDE', 'N', '510895', 'S', 'N', 'S', NULL, 74, 'N', 'N', 'N', '78', NULL, '03', 'N', NULL, NULL, NULL, 370);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520005', '5201', 'GO', '5201', '5203', '52010', '52', 'ABADIA DE GOIAS', NULL, '62', '75345000', '0', '1050', NULL, '08314', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 146.458, '-16,75700', '-49,43800', 898, 'S', 0.7420, NULL, NULL, '52900', 'N', 'N', 1, NULL, '5201', '5290', NULL, '1997', 'S', 897, 'ABADIA DE GOIÁS', 'N', '520005', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '1', NULL, '03', 'N', NULL, NULL, NULL, 405);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520010', '5209', 'GO', '5203', '5204', '52012', '52', 'ABADIANIA', NULL, '62', '72940000', '0', '9201', '9201', '08001', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1044.159, '-16,20400', '-48,70700', 1052, 'S', 0.7230, NULL, NULL, '52900', 'N', 'N', 3, NULL, '5301', '5301', NULL, '1953', 'S', 898, 'ABADIÂNIA', 'S', '520010', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '2', NULL, '01', 'N', NULL, NULL, NULL, 61);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520013', '5213', 'GO', '5204', '5205', '52014', '52', 'ACREUNA', NULL, '64', '75960000', '4', '9645', '9645', '08223', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1565.989, '-17,39600', '-50,37700', 542, 'S', 0.7630, NULL, NULL, '52900', 'N', 'N', 27, NULL, '5290', '5290', NULL, '1989', 'S', 899, 'ACREÚNA', 'N', '520013', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '3', NULL, '03', 'N', NULL, NULL, NULL, 120);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520015', '5212', 'GO', '5201', '5203', '52009', '52', 'ADELANDIA', NULL, '64', '76155000', '9', '9769', '9769', '08246', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 115.353, '-16,41500', '-50,16600', 649, 'S', 0.7150, NULL, NULL, '52900', 'N', 'N', 31, NULL, '5290', '5290', NULL, '1989', 'S', 900, 'ADELÂNDIA', 'N', '520015', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '4', NULL, '03', 'N', NULL, NULL, NULL, 353);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520017', '5204', 'GO', '5202', '5204', '52012', '52', 'AGUA FRIA DE GOIAS', NULL, '62', '73780000', '5', '9771', '9771', '08247', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 2029.406, '-14,98600', '-47,78400', 980, 'S', 0.6950, NULL, NULL, '52900', 'S', 'N', 57, NULL, '5301', '5301', NULL, '1989', 'S', 901, 'ÁGUA FRIA DE GOIÁS', 'S', '520017', 'N', 'N', 'S', NULL, 38, 'N', 'N', 'N', '5', NULL, '01', 'N', NULL, NULL, NULL, 350);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520020', '5215', 'GO', '5205', '5205', '52015', '52', 'AGUA LIMPA', NULL, '64', '75665000', '9', '9203', '9203', '08002', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 452.856, '-18,07400', '-48,76200', 682, 'S', 0.7390, NULL, NULL, '52900', 'N', 'N', 58, NULL, '5290', '5290', NULL, '1958', 'S', 902, 'ÁGUA LIMPA', 'N', '520020', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '6', NULL, '03', 'N', NULL, NULL, NULL, 354);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520025', '5203', 'GO', '5202', '5204', '52012', '52', 'AGUAS LINDAS DE GOIAS', NULL, '61', '72910000', '8', '1052', '1052', '08315', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 191.198, '-15,76200', '-48,28200', 1080, 'S', 0.7170, NULL, NULL, '52900', 'N', 'N', 72, NULL, '5301', '5301', NULL, '1997', 'S', 903, 'ÁGUAS LINDAS DE GOIÁS', 'S', '520025', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '7', NULL, '01', 'N', NULL, NULL, NULL, 118);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520030', '5209', 'GO', '5203', '5204', '52012', '52', 'ALEXANIA', NULL, '62', '72920000', '8', '9205', '9205', '08003', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 847.891, '-16,08200', '-48,50700', 1096, 'S', 0.6960, NULL, NULL, '52900', 'S', 'N', 109, NULL, '5301', '5301', NULL, '1958', 'S', 904, 'ALEXÂNIA', 'S', '520030', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '8', NULL, '01', 'N', NULL, NULL, NULL, 61);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520050', '5215', 'GO', '5205', '5205', '52015', '52', 'ALOANDIA', NULL, '64', '75615000', '6', '9209', '9209', '08005', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 102.160, '-17,72800', '-49,48000', 672, 'S', 0.7430, NULL, NULL, '52900', 'N', 'N', 125, NULL, '5290', '5290', NULL, '1953', 'S', 905, 'ALOÂNDIA', 'N', '520050', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '9', NULL, '03', 'N', NULL, NULL, NULL, 354);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520055', '5207', 'GO', '5203', '5202', '52004', '52', 'ALTO HORIZONTE', NULL, '62', '76560000', '5', '0085', '0085', '08295', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 503.762, '-14,19600', '-49,33900', 375, 'S', 0.7430, NULL, NULL, '52900', 'N', 'N', 151, NULL, '5290', '5290', NULL, '1993', 'S', 906, 'ALTO HORIZONTE', 'N', '520055', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '10', NULL, '03', 'N', NULL, NULL, NULL, 9);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520393', '5212', 'GO', '5201', '5203', '52009', '52', 'BURITI DE GOIAS', NULL, '64', '76152000', '9', '0063', '0063', '08305', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 199.291, '-16,18100', '-50,43100', 520, 'S', 0.7310, NULL, NULL, '52900', 'N', 'N', 791, NULL, '5290', '5290', NULL, '1993', 'S', 936, 'BURITI DE GOIÁS', 'N', '520393', 'N', 'N', 'S', NULL, 67, 'N', 'N', 'N', '40', NULL, '03', 'N', NULL, NULL, NULL, 353);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520060', '5204', 'GO', '5202', '5202', '52005', '52', 'ALTO PARAISO DE GOIAS', NULL, '62', '73770000', '5', '9211', '9211', '08006', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 2593.885, '-14,13300', '-47,51000', 1186, 'S', 0.7380, NULL, NULL, '52900', 'N', 'N', 156, NULL, '5290', '5290', NULL, '1953', 'S', 907, 'ALTO PARAÍSO DE GOIÁS', 'N', '520060', 'N', 'N', 'S', NULL, 121, 'N', 'N', 'N', '11', NULL, '03', 'N', NULL, NULL, NULL, 350);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520080', '5217', 'GO', '5202', '5204', '52011', '52', 'ALVORADA DO NORTE', NULL, '62', '73950000', '3', '9215', '9215', '08008', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1259.495, '-14,48100', '-46,49200', 490, 'S', 0.6880, NULL, NULL, '52900', 'S', 'N', 179, NULL, '5290', '5290', NULL, '1963', 'S', 908, 'ALVORADA DO NORTE', 'N', '520080', 'N', 'N', 'S', NULL, 125, 'N', 'N', 'N', '12', NULL, '03', 'N', NULL, NULL, NULL, 184);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520082', '5207', 'GO', '5203', '5202', '52004', '52', 'AMARALINA', NULL, '62', '76493000', '9', '1054', NULL, '08316', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1412.909, '-13,92600', '-49,29700', 55, 'S', 0.6480, NULL, NULL, '52900', 'S', 'N', 188, NULL, '5290', '5290', NULL, '1997', 'S', 909, 'AMARALINA', 'N', '520082', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '13', NULL, '03', 'N', NULL, NULL, NULL, 9);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520085', '5210', 'GO', '5201', '5203', '52009', '52', 'AMERICANO DO BRASIL', NULL, '64', '76165000', '2', '9661', '9661', '08225', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 133.562, '-16,25500', '-49,98300', 890, 'S', 0.7320, NULL, NULL, '52900', 'N', 'N', 196, NULL, '5290', '5290', NULL, '1980', 'S', 910, 'AMERICANO DO BRASIL', 'N', '520085', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '14', NULL, '03', 'N', NULL, NULL, NULL, 236);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520090', '5211', 'GO', '5201', '5203', '52008', '52', 'AMORINOPOLIS', NULL, '64', '76140000', '2', '9217', '9217', '08009', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 408.524, '-16,61900', '-51,09400', 641, 'S', 0.7320, NULL, NULL, '52900', 'N', 'N', 201, NULL, '5290', '5290', NULL, '1958', 'S', 911, 'AMORINÓPOLIS', 'N', '520090', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '15', NULL, '03', 'N', NULL, NULL, NULL, 352);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520110', '5209', 'GO', '5203', '5203', '52007', '52', 'ANAPOLIS', NULL, '62', '75001970', '8', '9221', '9221', '08011', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 918.375, '-16,32700', '-48,95300', 1017, 'S', 0.7880, NULL, NULL, '52900', 'N', 'N', 216, NULL, '5290', '5290', NULL, '1887', 'S', 912, 'ANÁPOLIS', 'N', '520110', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '16', NULL, '01', 'N', NULL, NULL, NULL, 61);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520120', '5216', 'GO', '5205', '5205', '52017', '52', 'ANHANGUERA', NULL, '64', '75770000', '7', '9223', '9223', '08012', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 56.642, '-18,33700', '-48,21900', 561, 'S', 0.8020, NULL, NULL, '52900', 'N', 'N', 242, NULL, '5290', '5290', NULL, '1953', 'S', 913, 'ANHANGUERA', 'N', '520120', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '17', NULL, '03', 'N', NULL, NULL, NULL, 351);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520130', '5201', 'GO', '5201', '5203', '52009', '52', 'ANICUNS', NULL, '64', '76170000', '6', '9225', '9225', '08013', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 961.608, '-16,46100', '-49,96200', 692, 'S', 0.7210, NULL, NULL, '52900', 'N', 'N', 245, NULL, '5290', '5290', NULL, '1911', 'S', 914, 'ANICUNS', 'N', '520130', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '18', NULL, '03', 'N', NULL, NULL, NULL, 405);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520140', '5202', 'GO', '5205', '5203', '52010', '52', 'APARECIDA DE GOIANIA', NULL, '62', '74980970', '5', '9227', '9227', '08014', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 288.465, '-16,82200', '-49,24500', 808, 'S', 0.7640, NULL, NULL, '52900', 'N', 'N', 268, NULL, '5201', '5201', NULL, '1963', 'S', 915, 'APARECIDA DE GOIÂNIA', 'N', '520140', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '19', NULL, '01', 'N', NULL, NULL, NULL, 60);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520145', '5213', 'GO', '5204', '5205', '52013', '52', 'APARECIDA DO RIO DOCE', NULL, '64', '75827000', '4', '0071', '0071', '08303', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 602.288, '-18,29900', '-51,14500', 0, 'S', 0.7540, NULL, NULL, '52900', 'N', 'N', 269, NULL, '5290', '5290', NULL, '1993', 'S', 916, 'APARECIDA DO RIO DOCE', 'N', '520145', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '20', NULL, '03', 'N', NULL, NULL, NULL, 120);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520150', '5214', 'GO', '5204', '5205', '52013', '52', 'APORE', NULL, '64', '75825000', '4', '9229', '9229', '08015', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 2900.344, '-18,96500', '-51,92600', 538, 'S', 0.7520, NULL, NULL, '52900', 'N', 'N', 280, NULL, '5290', '5290', NULL, '1958', 'S', 917, 'APORÉ', 'N', '520150', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '21', NULL, '03', 'N', NULL, NULL, NULL, 185);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520160', '5201', 'GO', '5201', '5203', '52007', '52', 'ARACU', NULL, '62', '75410000', '3', '9231', '9231', '08016', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 153.599, '-16,35800', '-49,68100', 716, 'S', 0.7330, NULL, NULL, '52900', 'N', 'N', 303, NULL, '5290', '5290', NULL, '1958', 'S', 918, 'ARAÇU', 'N', '520160', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '22', NULL, '03', 'N', NULL, NULL, NULL, 405);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520170', '5211', 'GO', '5201', '5201', '52003', '52', 'ARAGARCAS', NULL, '64', '76240000', '2', '9233', '9233', '08017', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 711.649, '-15,89800', '-52,25100', 310, 'S', 0.7480, NULL, NULL, '52900', 'N', 'N', 305, NULL, '5290', '5290', NULL, '1953', 'S', 919, 'ARAGARÇAS', 'N', '520170', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '23', NULL, '03', 'N', NULL, NULL, NULL, 352);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520180', '5202', 'GO', '5205', '5203', '52010', '52', 'ARAGOIANIA', NULL, '62', '75360000', '1', '9235', '9235', '08018', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 218.755, '-16,91200', '-49,45100', 859, 'S', 0.7590, NULL, NULL, '52900', 'N', 'N', 306, NULL, '5201', '5290', NULL, '1958', 'S', 920, 'ARAGOIÂNIA', 'N', '520180', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '24', NULL, '03', 'N', NULL, NULL, NULL, 60);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520215', '5210', 'GO', '5201', '5201', '52002', '52', 'ARAGUAPAZ', NULL, '62', '76720000', '5', '9669', '9669', '08235', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 2193.692, '-15,09100', '-50,63200', 304, 'S', 0.7290, NULL, NULL, '52900', 'N', 'N', 315, NULL, '5290', '5290', NULL, '1982', 'S', 921, 'ARAGUAPAZ', 'N', '520215', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '25', NULL, '03', 'N', NULL, NULL, NULL, 236);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520235', '5211', 'GO', '5201', '5201', '52003', '52', 'ARENOPOLIS', NULL, '64', '76235000', '3', '9671', '9671', '08236', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1074.591, '-16,38600', '-51,56000', 416, 'S', 0.7390, NULL, NULL, '52900', 'N', 'N', 372, NULL, '5290', '5290', NULL, '1982', 'S', 922, 'ARENÓPOLIS', 'N', '520235', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '26', NULL, '03', 'N', NULL, NULL, NULL, 352);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520250', '5210', 'GO', '5201', '5201', '52002', '52', 'ARUANA', NULL, '62', '76710000', '2', '9249', '9249', '08025', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'S', NULL, 'N', 3050.303, '-14,92000', '-51,08300', 250, 'S', 0.7210, NULL, NULL, '52900', 'N', 'N', 396, NULL, '5290', '5290', NULL, '1958', 'S', 923, 'ARUANÃ', 'N', '520250', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '27', NULL, '03', 'N', NULL, NULL, NULL, 236);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520260', '5212', 'GO', '5201', '5203', '52009', '52', 'AURILANDIA', NULL, '64', '76120000', '1', '9251', '9251', '08026', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 565.152, '-16,68200', '-50,46500', 520, 'S', 0.7320, NULL, NULL, '52900', 'N', 'N', 426, NULL, '5290', '5290', NULL, '1948', 'S', 924, 'AURILÂNDIA', 'N', '520260', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '28', NULL, '03', 'N', NULL, NULL, NULL, 353);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520280', '5201', 'GO', '5201', '5203', '52009', '52', 'AVELINOPOLIS', NULL, '64', '75395000', '9', '9255', '9255', '08028', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 164.040, '-16,46600', '-49,75800', 729, 'S', 0.7370, NULL, NULL, '52900', 'N', 'N', 437, NULL, '5290', '5290', NULL, '1963', 'S', 925, 'AVELINÓPOLIS', 'N', '520280', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '29', NULL, '03', 'N', NULL, NULL, NULL, 405);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520310', '5211', 'GO', '5201', '5201', '52003', '52', 'BALIZA', NULL, '62', '76250000', '4', '9261', '9261', '08031', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1782.592, '-16,19600', '-52,54500', 342, 'S', 0.7150, NULL, NULL, '52900', 'N', 'N', 459, NULL, '5290', '5290', NULL, '1942', 'S', 926, 'BALIZA', 'N', '520310', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '30', NULL, '03', 'N', NULL, NULL, NULL, 352);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520320', '5208', 'GO', '5203', '5203', '52006', '52', 'BARRO ALTO', NULL, '62', '76390000', '3', '9263', '9263', '08032', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1093.243, '-14,97100', '-48,91600', 605, 'S', 0.7080, NULL, NULL, '52900', 'N', 'N', 543, NULL, '5290', '5290', NULL, '1958', 'S', 927, 'BARRO ALTO', 'N', '520320', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '31', NULL, '03', 'N', NULL, NULL, NULL, 519);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520330', '5202', 'GO', '5205', '5203', '52010', '52', 'BELA VISTA DE GOIAS', NULL, '62', '75240000', '2', '9265', '9265', '08033', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1276.617, '-16,97300', '-48,95300', 803, 'S', 0.7440, NULL, NULL, '52900', 'N', 'N', 563, NULL, '5201', '5290', NULL, '1896', 'S', 928, 'BELA VISTA DE GOIÁS', 'N', '520330', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '32', NULL, '03', 'N', NULL, NULL, NULL, 60);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520340', '5211', 'GO', '5201', '5201', '52003', '52', 'BOM JARDIM DE GOIAS', NULL, '64', '76245000', '1', '9267', '9267', '08034', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1850.738, '-16,21000', '-52,17200', 386, 'S', 0.7370, NULL, NULL, '52900', 'N', 'N', 662, NULL, '5290', '5290', NULL, '1953', 'S', 929, 'BOM JARDIM DE GOIÁS', 'N', '520340', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '33', NULL, '03', 'N', NULL, NULL, NULL, 352);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520350', '5215', 'GO', '5205', '5205', '52015', '52', 'BOM JESUS DE GOIAS', NULL, '64', '75570000', '0', '9269', '9269', '08035', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1405.218, '-18,21500', '-49,74200', 619, 'S', 0.7720, NULL, NULL, '52900', 'N', 'N', 673, NULL, '5290', '5290', NULL, '1963', 'S', 930, 'BOM JESUS DE GOIÁS', 'N', '520350', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '34', NULL, '03', 'N', NULL, NULL, NULL, 354);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520890', '5210', 'GO', '5201', '5201', '52002', '52', 'GOIAS', NULL, '62', '76600000', '5', '9377', '9377', '08089', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3108.008, '-15,93400', '-50,14000', 496, 'S', 0.7360, NULL, NULL, '52900', 'N', 'N', 1907, NULL, '5290', '5290', NULL, '1736', 'S', 991, 'GOIÁS', 'N', '520890', 'N', 'N', 'S', NULL, 67, 'N', 'N', 'N', '97', NULL, '03', 'N', NULL, NULL, NULL, 236);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520355', '5202', 'GO', '5205', '5203', '52010', '52', 'BONFINOPOLIS', NULL, '62', '75195000', '9', '9775', '9775', '08252', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 122.257, '-16,61800', '-48,96300', 948, 'S', 0.7230, NULL, NULL, '52900', 'N', 'N', 699, NULL, '5201', '5290', NULL, '1989', 'S', 931, 'BONFINÓPOLIS', 'N', '520355', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '35', NULL, '03', 'N', NULL, NULL, NULL, 60);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520357', '5206', 'GO', '5203', '5202', '52004', '52', 'BONOPOLIS', NULL, '62', '76555000', '5', '1056', NULL, '08317', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 1628.479, '-13,63600', '-49,81000', 290, 'S', 0.6830, NULL, NULL, '52900', 'S', 'N', 708, NULL, '5290', '5290', NULL, '1997', 'S', 932, 'BONÓPOLIS', 'N', '520357', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '36', NULL, '03', 'N', NULL, NULL, NULL, 406);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520360', '5201', 'GO', '5201', '5203', '52007', '52', 'BRAZABRANTES', NULL, '62', '75440000', '9', '9271', '9271', '08036', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'S', 'N', 'N', NULL, 'N', 123.548, '-16,43100', '-49,38900', 761, 'S', 0.7490, NULL, NULL, '52900', 'N', 'N', 749, NULL, '5201', '5290', NULL, '1958', 'S', 933, 'BRAZABRANTES', 'N', '520360', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '37', NULL, '03', 'N', NULL, NULL, NULL, 405);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520380', '5210', 'GO', '5201', '5201', '52002', '52', 'BRITANIA', NULL, '62', '76280000', '7', '9275', '9275', '08038', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1461.181, '-15,24100', '-51,16100', 263, 'S', 0.7230, NULL, NULL, '52900', 'N', 'N', 769, NULL, '5290', '5290', NULL, '1963', 'S', 934, 'BRITÂNIA', 'N', '520380', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '38', NULL, '03', 'N', NULL, NULL, NULL, 236);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520390', '5215', 'GO', '5205', '5205', '52015', '52', 'BURITI ALEGRE', NULL, '64', '75660000', '6', '9277', '9277', '08039', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 897.394, '-18,14400', '-49,04400', 786, 'S', 0.7580, NULL, NULL, '52900', 'N', 'N', 789, NULL, '5290', '5290', NULL, '1920', 'S', 935, 'BURITI ALEGRE', 'N', '520390', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '39', NULL, '03', 'N', NULL, NULL, NULL, 354);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520396', '5217', 'GO', '5202', '5204', '52011', '52', 'BURITINOPOLIS', NULL, '62', '73975000', '2', '0061', '0061', '08312', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 268.115, '-14,47900', '-46,40800', 55, 'S', 0.6000, NULL, NULL, '52900', 'S', 'N', 796, NULL, '5290', '5290', NULL, '1993', 'S', 937, 'BURITINÓPOLIS', 'N', '520396', 'N', 'N', 'S', NULL, 125, 'N', 'N', 'N', '41', NULL, '03', 'N', NULL, NULL, NULL, 184);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520400', '5204', 'GO', '5202', '5204', '52012', '52', 'CABECEIRAS', NULL, '61', '73870000', '3', '9279', '9279', '08040', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1127.601, '-15,80100', '-46,92700', 926, 'S', 0.6950, NULL, NULL, '52900', 'S', 'N', 811, NULL, '5301', '5301', NULL, '1958', 'S', 938, 'CABECEIRAS', 'S', '520400', 'N', 'N', 'S', NULL, 38, 'N', 'N', 'N', '42', NULL, '01', 'N', NULL, NULL, NULL, 350);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520410', '5213', 'GO', '5204', '5205', '52018', '52', 'CACHOEIRA ALTA', NULL, '64', '75870000', '2', '9281', '9281', '08041', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1654.343, '-18,76300', '-50,94200', 483, 'S', 0.7370, NULL, NULL, '52900', 'N', 'N', 828, NULL, '5290', '5290', NULL, '1953', 'S', 939, 'CACHOEIRA ALTA', 'N', '520410', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '43', NULL, '03', 'N', NULL, NULL, NULL, 120);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520500', '5208', 'GO', '5203', '5203', '52006', '52', 'CARMO DO RIO VERDE', NULL, '62', '76340000', '0', '9299', '9299', '08050', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 455.924, '-15,35400', '-49,70800', 629, 'S', 0.7280, NULL, NULL, '52900', 'N', 'N', 1119, NULL, '5290', '5290', NULL, '1952', 'S', 952, 'CARMO DO RIO VERDE', 'N', '520500', 'N', 'N', 'S', NULL, 67, 'N', 'N', 'N', '57', NULL, '03', 'N', NULL, NULL, NULL, 119);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520505', '5213', 'GO', '5204', '5205', '52013', '52', 'CASTELANDIA', NULL, '64', '75925000', '9', '0081', '0081', '08296', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 297.428, '-18,09100', '-50,20100', 442, 'S', 0.7320, NULL, NULL, '52900', 'N', 'N', 1158, NULL, '5290', '5290', NULL, '1993', 'S', 953, 'CASTELÂNDIA', 'N', '520505', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '58', NULL, '03', 'N', NULL, NULL, NULL, 120);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520690', '5216', 'GO', '5205', '5205', '52017', '52', 'DAVINOPOLIS', NULL, '64', '75730000', '9', '9339', '9339', '08070', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 520.040, '-18,15300', '-47,56200', 771, 'S', 0.7330, NULL, NULL, '52900', 'N', 'N', 1513, NULL, '5290', '5290', NULL, '1963', 'S', 973, 'DAVINÓPOLIS', 'N', '520690', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '78', NULL, '03', 'N', NULL, NULL, NULL, 351);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520710', '5211', 'GO', '5201', '5201', '52003', '52', 'DIORAMA', NULL, '64', '76260000', '5', '9343', '9343', '08072', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 687.339, '-16,23400', '-51,25600', 506, 'S', 0.7330, NULL, NULL, '52900', 'N', 'N', 1543, NULL, '5290', '5290', NULL, '1958', 'S', 974, 'DIORAMA', 'N', '520710', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '79', NULL, '03', 'N', NULL, NULL, NULL, 352);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520725', '5214', 'GO', '5204', '5205', '52013', '52', 'DOVERLANDIA', NULL, '64', '75855000', '3', '9675', '9675', '08240', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3207.543, '-16,72000', '-52,31900', 509, 'S', 0.7100, NULL, NULL, '52900', 'N', 'N', 1608, NULL, '5290', '5290', NULL, '1982', 'S', 976, 'DOVERLÂNDIA', 'N', '520725', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '81', NULL, '03', 'N', NULL, NULL, NULL, 185);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520735', '5202', 'GO', '5205', '5205', '52014', '52', 'EDEALINA', NULL, '64', '75945000', '2', '9795', '9795', '08260', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 603.652, '-17,42600', '-49,66500', 578, 'S', 0.7680, NULL, NULL, '52900', 'N', 'N', 1620, NULL, '5290', '5290', NULL, '1989', 'S', 977, 'EDEALINA', 'N', '520735', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '82', NULL, '03', 'N', NULL, NULL, NULL, 60);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520740', '5202', 'GO', '5205', '5205', '52014', '52', 'EDEIA', NULL, '64', '75940000', '2', '9349', '9349', '08075', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1461.519, '-17,33900', '-49,93100', 601, 'S', 0.7590, NULL, NULL, '52900', 'N', 'N', 1621, NULL, '5290', '5290', NULL, '1948', 'S', 978, 'EDÉIA', 'N', '520740', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '83', NULL, '03', 'N', NULL, NULL, NULL, 60);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520750', '5206', 'GO', '5203', '5202', '52004', '52', 'ESTRELA DO NORTE', NULL, '62', '76485000', '1', '9351', '9351', '08076', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 301.641, '-13,86800', '-49,07300', 453, 'S', 0.7460, NULL, NULL, '52900', 'S', 'N', 1701, NULL, '5290', '5290', NULL, '1958', 'S', 979, 'ESTRELA DO NORTE', 'N', '520750', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '84', NULL, '03', 'N', NULL, NULL, NULL, 406);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520753', '5210', 'GO', '5201', '5201', '52002', '52', 'FAINA', NULL, '62', '76740000', '5', '9797', '9797', '08261', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1944.953, '-15,44600', '-50,36100', 360, 'S', 0.7030, NULL, NULL, '52900', 'N', 'N', 1716, NULL, '5290', '5290', NULL, '1989', 'S', 980, 'FAINA', 'N', '520753', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '85', NULL, '03', 'N', NULL, NULL, NULL, 236);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520760', '5211', 'GO', '5201', '5203', '52008', '52', 'FAZENDA NOVA', NULL, '62', '76220000', '0', '9353', '9353', '08077', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1281.316, '-16,18300', '-50,78000', 476, 'S', 0.7460, NULL, NULL, '52900', 'N', 'N', 1732, NULL, '5290', '5290', NULL, '1953', 'S', 981, 'FAZENDA NOVA', 'N', '520760', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '86', NULL, '03', 'N', NULL, NULL, NULL, 352);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520780', '5212', 'GO', '5201', '5203', '52009', '52', 'FIRMINOPOLIS', NULL, '64', '76105000', '8', '9357', '9357', '08079', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 406.109, '-16,58200', '-50,30500', 685, 'S', 0.7450, NULL, NULL, '52900', 'N', 'N', 1769, NULL, '5290', '5290', NULL, '1948', 'S', 982, 'FIRMINÓPOLIS', 'N', '520780', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '87', NULL, '03', 'N', NULL, NULL, NULL, 353);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520790', '5204', 'GO', '5202', '5204', '52011', '52', 'FLORES DE GOIAS', NULL, '62', '73890000', '7', '9359', '9359', '08080', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3709.419, '-14,44900', '-47,05000', 440, 'S', 0.6420, NULL, NULL, '52900', 'S', 'N', 1779, NULL, '5290', '5290', NULL, '1963', 'S', 983, 'FLORES DE GOIÁS', 'N', '520790', 'N', 'N', 'S', NULL, 125, 'N', 'N', 'N', '88', NULL, '03', 'N', NULL, NULL, NULL, 350);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520800', '5204', 'GO', '5202', '5204', '52012', '52', 'FORMOSA', NULL, '61', '73800000', '4', '9361', '9361', '08081', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 5806.891, '-15,53700', '-47,33400', 916, 'S', 0.7500, NULL, NULL, '52900', 'N', 'N', 1798, NULL, '5301', '5301', NULL, '1843', 'S', 984, 'FORMOSA', 'S', '520800', 'N', 'N', 'S', NULL, 38, 'S', 'N', 'N', '89', NULL, '01', 'N', NULL, NULL, NULL, 350);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520810', '5206', 'GO', '5203', '5202', '52004', '52', 'FORMOSO', NULL, '62', '76470000', '3', '9363', '9363', '08082', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 844.285, '-13,65400', '-48,88200', 569, 'S', 0.7370, NULL, NULL, '52900', 'N', 'N', 1804, NULL, '5290', '5290', NULL, '1963', 'S', 985, 'FORMOSO', 'N', '520810', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '90', NULL, '03', 'N', NULL, NULL, NULL, 406);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520815', '5209', 'GO', '5203', '5205', '52016', '52', 'GAMELEIRA DE GOIAS', NULL, '62', '75184000', '2', '1072', NULL, '08325', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 595.316, '-16,46350', '-48,67010', 0, 'S', NULL, NULL, NULL, '52900', 'N', 'N', 5616, NULL, '5290', '5290', NULL, '2001', 'S', 5579, 'GAMELEIRA DE GOIÁS', 'N', '520815', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '91', NULL, '03', 'N', NULL, NULL, NULL, 61);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520830', '5205', 'GO', '5202', '5204', '52011', '52', 'DIVINOPOLIS DE GOIAS', NULL, '62', '73865000', '1', '9309', '9309', '08055', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 831.134, '-13,29500', '-46,39300', 620, 'S', 0.6750, NULL, NULL, '52900', 'S', 'N', 1554, NULL, '5290', '5290', NULL, '1989', 'S', 975, 'DIVINÓPOLIS DE GOIÁS', 'N', '520830', 'N', 'N', 'S', NULL, 125, 'S', 'N', 'N', '80', NULL, '03', 'N', NULL, NULL, NULL, 183);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520840', '5209', 'GO', '5203', '5203', '52010', '52', 'GOIANAPOLIS', NULL, '62', '75170000', '0', '9367', '9367', '08084', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 162.380, '-16,51100', '-49,02400', 982, 'S', 0.6890, NULL, NULL, '52900', 'S', 'N', 1899, NULL, '5201', '5290', NULL, '1958', 'S', 986, 'GOIANÁPOLIS', 'N', '520840', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '92', NULL, '03', 'N', NULL, NULL, NULL, 61);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520850', '5216', 'GO', '5205', '5205', '52017', '52', 'GOIANDIRA', NULL, '64', '75740000', '9', '9369', '9369', '08085', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 560.707, '-18,13300', '-48,08500', 848, 'S', 0.7650, NULL, NULL, '52900', 'N', 'N', 1900, NULL, '5290', '5290', NULL, '1931', 'S', 987, 'GOIANDIRA', 'N', '520850', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '93', NULL, '03', 'N', NULL, NULL, NULL, 351);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520860', '5208', 'GO', '5203', '5203', '52006', '52', 'GOIANESIA', NULL, '62', '76380000', '8', '9371', '9371', '08086', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1547.650, '-15,31700', '-49,11700', 640, 'S', 0.7430, NULL, NULL, '52900', 'N', 'N', 1901, NULL, '5290', '5290', NULL, '1953', 'S', 988, 'GOIANÉSIA', 'N', '520860', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '94', NULL, '02', 'N', NULL, NULL, NULL, 519);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520870', '5201', 'GO', '5201', '5203', '52010', '52', 'GOIANIA', NULL, '62', '74030970', '7', '9373', '9373', '08087', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'S', 739.492, '-16,67900', '-49,25400', 749, 'S', 0.8320, NULL, NULL, '52900', 'N', 'N', 1903, NULL, '5201', '5201', NULL, '1935', 'S', 989, 'GOIÂNIA', 'N', '520870', 'N', 'N', 'S', NULL, NULL, 'S', 'S', 'N', '95', NULL, '01', 'N', NULL, NULL, NULL, 405);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520880', '5201', 'GO', '5201', '5203', '52010', '52', 'GOIANIRA', NULL, '62', '75370000', '6', '9375', '9375', '08088', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 200.402, '-16,49600', '-49,42600', 757, 'S', 0.7400, NULL, NULL, '52900', 'N', 'N', 1905, NULL, '5201', '5201', NULL, '1958', 'S', 990, 'GOIANIRA', 'N', '520880', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '96', NULL, '03', 'N', NULL, NULL, NULL, 405);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520910', '5215', 'GO', '5205', '5205', '52015', '52', 'GOIATUBA', NULL, '64', '75600000', '1', '9379', '9379', '08090', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2475.107, '-18,01300', '-49,35700', 774, 'S', 0.8120, NULL, NULL, '52900', 'N', 'N', 1909, NULL, '5290', '5290', NULL, '1938', 'S', 992, 'GOIATUBA', 'N', '520910', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '98', NULL, '03', 'N', NULL, NULL, NULL, 354);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520915', '5215', 'GO', '5205', '5205', '52018', '52', 'GOUVELANDIA', NULL, '64', '75865000', '0', '9799', '9799', '08263', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 830.770, '-18,64200', '-50,06600', 395, 'S', 0.7380, NULL, NULL, '52900', 'N', 'N', 1917, NULL, '5290', '5290', NULL, '1989', 'S', 993, 'GOUVELÂNDIA', 'N', '520915', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '99', NULL, '03', 'N', NULL, NULL, NULL, 354);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520920', '5201', 'GO', '5201', '5203', '52010', '52', 'GUAPO', NULL, '62', '75350000', '0', '9381', '9381', '08091', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 517.005, '-16,83100', '-49,53200', 707, 'S', 0.7290, NULL, NULL, '52900', 'N', 'N', 1972, NULL, '5201', '5290', NULL, '1948', 'S', 994, 'GUAPÓ', 'N', '520920', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '100', NULL, '03', 'N', NULL, NULL, NULL, 405);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520929', '5210', 'GO', '5201', '5203', '52006', '52', 'GUARAITA', NULL, '62', '76690000', '1', '0065', '0065', '08306', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 205.306, '-15,61400', '-50,02400', 669, 'S', 0.6970, NULL, NULL, '52900', 'S', 'N', 1985, NULL, '5290', '5290', NULL, '1993', 'S', 995, 'GUARAÍTA', 'N', '520929', 'N', 'N', 'S', NULL, 67, 'N', 'N', 'N', '101', NULL, '03', 'N', NULL, NULL, NULL, 236);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520940', '5217', 'GO', '5202', '5204', '52011', '52', 'GUARANI DE GOIAS', NULL, '62', '73910000', '8', '9383', '9383', '08092', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1229.122, '-13,93600', '-46,48000', 521, 'S', 0.6320, NULL, NULL, '52900', 'S', 'N', 1992, NULL, '5290', '5290', NULL, '1963', 'S', 996, 'GUARANI DE GOIÁS', 'N', '520940', 'N', 'N', 'S', NULL, 125, 'S', 'N', 'N', '102', NULL, '03', 'N', NULL, NULL, NULL, 184);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520945', '5208', 'GO', '5203', '5203', '52006', '52', 'GUARINOS', NULL, '62', '76385000', '7', '9993', '9993', '08292', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 595.865, '-14,73200', '-49,70200', 480, 'S', 0.6940, NULL, NULL, '52900', 'S', 'N', 2009, NULL, '5290', '5290', NULL, '1989', 'S', 997, 'GUARINOS', 'N', '520945', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '103', NULL, '03', 'N', NULL, NULL, NULL, 119);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520960', '5210', 'GO', '5201', '5203', '52007', '52', 'HEITORAI', NULL, '62', '76670000', '6', '9387', '9387', '08094', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 229.666, '-15,71900', '-49,82900', 658, 'S', 0.7440, NULL, NULL, '52900', 'N', 'N', 2029, NULL, '5290', '5290', NULL, '1963', 'S', 998, 'HEITORAÍ', 'N', '520960', 'N', 'N', 'S', NULL, 67, 'N', 'N', 'N', '104', NULL, '03', 'N', NULL, NULL, NULL, 236);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520970', '5202', 'GO', '5205', '5203', '52010', '52', 'HIDROLANDIA', NULL, '62', '75340000', '5', '9389', '9389', '08095', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 944.238, '-16,96200', '-49,22900', 814, 'S', 0.7360, NULL, NULL, '52900', 'N', 'N', 2037, NULL, '5201', '5290', NULL, '1948', 'S', 999, 'HIDROLÂNDIA', 'N', '520970', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '105', NULL, '03', 'N', NULL, NULL, NULL, 60);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520980', '5207', 'GO', '5203', '5203', '52006', '52', 'HIDROLINA', NULL, '62', '76375000', '4', '9391', '9391', '08096', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 580.386, '-14,72400', '-49,46500', 603, 'S', 0.7370, NULL, NULL, '52900', 'N', 'N', 2038, NULL, '5290', '5290', NULL, '1958', 'S', 1000, 'HIDROLINA', 'N', '520980', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '106', NULL, '03', 'N', NULL, NULL, NULL, 9);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520990', '5217', 'GO', '5202', '5204', '52011', '52', 'IACIARA', NULL, '62', '73920000', '3', '9393', '9393', '08097', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1625.284, '-14,09600', '-46,63200', 571, 'S', 0.7040, NULL, NULL, '52900', 'N', 'N', 2050, NULL, '5290', '5290', NULL, '1958', 'S', 1001, 'IACIARA', 'N', '520990', 'N', 'N', 'S', NULL, 125, 'N', 'N', 'N', '107', NULL, '03', 'N', NULL, NULL, NULL, 184);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520993', '5215', 'GO', '5205', '5205', '52015', '52', 'INACIOLANDIA', NULL, '64', '75550000', '7', '0069', '0069', '08307', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 688.398, '-18,48800', '-49,98700', 442, 'S', 0.7170, NULL, NULL, '52900', 'N', 'N', 2161, NULL, '5290', '5290', NULL, '1993', 'S', 1002, 'INACIOLÂNDIA', 'N', '520993', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '108', NULL, '03', 'N', NULL, NULL, NULL, 354);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520995', '5202', 'GO', '5205', '5205', '52014', '52', 'INDIARA', NULL, '64', '75955000', '2', '9681', '9681', '08242', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 956.473, '-17,14200', '-49,98700', 550, 'S', 0.7300, NULL, NULL, '52900', 'N', 'N', 2174, NULL, '5290', '5290', NULL, '1982', 'S', 1003, 'INDIARA', 'N', '520995', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '109', NULL, '03', 'N', NULL, NULL, NULL, 60);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521000', '5201', 'GO', '5201', '5203', '52007', '52', 'INHUMAS', NULL, '62', '75400000', '0', '9395', '9395', '08098', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 613.349, '-16,35800', '-49,49600', 770, 'S', 0.7650, NULL, NULL, '52900', 'N', 'N', 2187, NULL, '5201', '5290', NULL, '1931', 'S', 1004, 'INHUMAS', 'N', '521000', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '110', NULL, '03', 'N', NULL, NULL, NULL, 405);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521010', '5216', 'GO', '5205', '5205', '52017', '52', 'IPAMERI', NULL, '64', '75780000', '9', '9397', '9397', '08099', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4368.688, '-17,72200', '-48,16000', 764, 'S', 0.7580, NULL, NULL, '52900', 'N', 'N', 2193, NULL, '5290', '5290', NULL, '1870', 'S', 1005, 'IPAMERI', 'N', '521010', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '111', NULL, '03', 'N', NULL, NULL, NULL, 351);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521015', '5208', 'GO', '5203', '5203', '52006', '52', 'IPIRANGA DE GOIAS', NULL, '62', '76304000', '8', '1074', NULL, '08326', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 241.464, '-15,17000', '-49,67000', 0, 'S', NULL, NULL, NULL, '52900', 'N', 'N', 5722, NULL, '5290', '5290', NULL, '2001', 'S', 5580, 'IPIRANGA DE GOIÁS', 'N', '521015', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '112', NULL, '03', 'N', NULL, NULL, NULL, 119);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521020', '5211', 'GO', '5201', '5203', '52008', '52', 'IPORA', NULL, '64', '76200000', '8', '9399', '9399', '08100', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1026.387, '-16,44200', '-51,11800', 584, 'S', 0.7800, NULL, NULL, '52900', 'N', 'N', 2215, NULL, '5290', '5290', NULL, '1948', 'S', 1006, 'IPORÁ', 'N', '521020', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '113', NULL, '03', 'N', NULL, NULL, NULL, 352);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521030', '5211', 'GO', '5201', '5203', '52008', '52', 'ISRAELANDIA', NULL, '64', '76205000', '7', '9401', '9401', '08101', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 577.480, '-16,31800', '-50,90800', 378, 'S', 0.7300, NULL, NULL, '52900', 'N', 'N', 2253, NULL, '5290', '5290', NULL, '1958', 'S', 1007, 'ISRAELÂNDIA', 'N', '521030', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '114', NULL, '03', 'N', NULL, NULL, NULL, 352);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521040', '5210', 'GO', '5201', '5203', '52007', '52', 'ITABERAI', NULL, '62', '76630000', '6', '9403', '9403', '08102', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1471.173, '-16,02000', '-49,81000', 701, 'S', 0.7390, NULL, NULL, '52900', 'N', 'N', 2262, NULL, '5290', '5290', NULL, '1868', 'S', 1008, 'ITABERAÍ', 'N', '521040', 'N', 'N', 'S', NULL, 67, 'N', 'N', 'N', '115', NULL, '03', 'N', NULL, NULL, NULL, 236);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521056', '5201', 'GO', '5201', '5203', '52007', '52', 'ITAGUARI', NULL, '62', '76650000', '2', '9919', '9919', '08264', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 135.525, '-15,91900', '-49,60400', 687, 'S', 0.7200, NULL, NULL, '52900', 'N', 'N', 2285, NULL, '5290', '5290', NULL, '1989', 'S', 1009, 'ITAGUARI', 'N', '521056', 'N', 'N', 'S', NULL, 67, 'N', 'N', 'N', '116', NULL, '03', 'N', NULL, NULL, NULL, 405);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521060', '5208', 'GO', '5203', '5203', '52007', '52', 'ITAGUARU', NULL, '62', '76660000', '4', '9407', '9407', '08104', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 239.936, '-15,75800', '-49,63400', 770, 'S', 0.7460, NULL, NULL, '52900', 'N', 'N', 2286, NULL, '5290', '5290', NULL, '1958', 'S', 1010, 'ITAGUARU', 'N', '521060', 'N', 'N', 'S', NULL, 67, 'N', 'N', 'N', '117', NULL, '03', 'N', NULL, NULL, NULL, 519);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521080', '5213', 'GO', '5204', '5205', '52018', '52', 'ITAJA', NULL, '64', '75815000', '2', '9411', '9411', '08106', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2091.394, '-19,06700', '-51,54400', 442, 'S', 0.7470, NULL, NULL, '52900', 'N', 'N', 2298, NULL, '5290', '5290', NULL, '1958', 'S', 1011, 'ITAJÁ', 'N', '521080', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '118', NULL, '03', 'N', NULL, NULL, NULL, 120);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521090', '5208', 'GO', '5203', '5203', '52006', '52', 'ITAPACI', NULL, '62', '76360000', '1', '9413', '9413', '08107', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 956.126, '-14,95100', '-49,54900', 557, 'S', 0.7240, NULL, NULL, '52900', 'N', 'N', 2329, NULL, '5290', '5290', NULL, '1945', 'S', 1012, 'ITAPACI', 'N', '521090', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '119', NULL, '03', 'N', NULL, NULL, NULL, 119);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521100', '5210', 'GO', '5201', '5201', '52002', '52', 'ITAPIRAPUA', NULL, '62', '76290000', '8', '9415', '9415', '08108', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2043.699, '-15,82300', '-50,61300', 348, 'S', 0.7070, NULL, NULL, '52900', 'N', 'N', 2354, NULL, '5290', '5290', NULL, '1958', 'S', 1013, 'ITAPIRAPUÃ', 'N', '521100', 'N', 'N', 'S', NULL, 67, 'N', 'N', 'N', '120', NULL, '03', 'N', NULL, NULL, NULL, 236);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521120', '5210', 'GO', '5201', '5203', '52006', '52', 'ITAPURANGA', NULL, '62', '76680000', '6', '9419', '9419', '08110', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1277.160, '-15,56200', '-49,94900', 651, 'S', 0.7350, NULL, NULL, '52900', 'N', 'N', 2372, NULL, '5290', '5290', NULL, '1953', 'S', 1014, 'ITAPURANGA', 'N', '521120', 'N', 'N', 'S', NULL, 67, 'N', 'N', 'N', '121', NULL, '03', 'N', NULL, NULL, NULL, 236);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521130', '5213', 'GO', '5204', '5205', '52018', '52', 'ITARUMA', NULL, '64', '75810000', '5', '9421', '9421', '08111', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3433.619, '-18,76900', '-51,34800', 474, 'S', 0.7350, NULL, NULL, '52900', 'N', 'N', 2383, NULL, '5290', '5290', NULL, '1953', 'S', 1015, 'ITARUMÃ', 'N', '521130', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '122', NULL, '03', 'N', NULL, NULL, NULL, 120);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521140', '5201', 'GO', '5201', '5203', '52007', '52', 'ITAUCU', NULL, '62', '75450000', '4', '9423', '9423', '08112', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 383.682, '-16,20100', '-49,60800', 839, 'S', 0.7420, NULL, NULL, '52900', 'N', 'N', 2396, NULL, '5290', '5290', NULL, '1948', 'S', 1016, 'ITAUÇU', 'N', '521140', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '123', NULL, '03', 'N', NULL, NULL, NULL, 405);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521150', '5215', 'GO', '5205', '5205', '52015', '52', 'ITUMBIARA', NULL, '64', '75503900', '3', '9425', '9425', '08113', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2461.280, '-18,42000', '-49,21800', 448, 'S', 0.7820, NULL, NULL, '52900', 'N', 'N', 2415, NULL, '5290', '5290', NULL, '1909', 'S', 1017, 'ITUMBIARA', 'N', '521150', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '124', NULL, '01', 'N', NULL, NULL, NULL, 354);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521160', '5211', 'GO', '5201', '5203', '52008', '52', 'IVOLANDIA', NULL, '64', '76130000', '2', '9427', '9427', '08114', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1262.837, '-16,60200', '-50,79400', 637, 'S', 0.7210, NULL, NULL, '52900', 'N', 'N', 2430, NULL, '5290', '5290', NULL, '1953', 'S', 1018, 'IVOLÂNDIA', 'N', '521160', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '125', NULL, '03', 'N', NULL, NULL, NULL, 352);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521170', '5202', 'GO', '5205', '5205', '52014', '52', 'JANDAIA', NULL, '64', '75950000', '1', '9429', '9429', '08115', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 864.104, '-17,04900', '-50,14600', 637, 'S', 0.7460, NULL, NULL, '52900', 'N', 'N', 2481, NULL, '5290', '5290', NULL, '1953', 'S', 1019, 'JANDAIA', 'N', '521170', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '126', NULL, '03', 'N', NULL, NULL, NULL, 60);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521180', '5208', 'GO', '5203', '5203', '52007', '52', 'JARAGUA', NULL, '62', '76330000', '0', '9431', '9431', '08116', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1888.938, '-15,75700', '-49,33400', 666, 'S', 0.7280, NULL, NULL, '52900', 'N', 'N', 2503, NULL, '5290', '5290', NULL, '1833', 'S', 1020, 'JARAGUÁ', 'N', '521180', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '127', NULL, '03', 'N', NULL, NULL, NULL, 519);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521190', '5214', 'GO', '5204', '5205', '52013', '52', 'JATAI', NULL, '64', '75800000', '9', '9433', '9433', '08117', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 7174.217, '-17,88100', '-51,71400', 696, 'S', 0.7930, NULL, NULL, '52900', 'N', 'N', 2520, NULL, '5290', '5290', NULL, '1882', 'S', 1021, 'JATAÍ', 'N', '521190', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '128', NULL, '01', 'N', NULL, NULL, NULL, 185);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521200', '5211', 'GO', '5201', '5203', '52008', '52', 'JAUPACI', NULL, '64', '76210000', '6', '9435', '9435', '08118', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 527.200, '-16,17800', '-50,95300', 354, 'S', 0.7100, NULL, NULL, '52900', 'N', 'N', 2530, NULL, '5290', '5290', NULL, '1958', 'S', 1022, 'JAUPACI', 'N', '521200', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '129', NULL, '03', 'N', NULL, NULL, NULL, 352);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521205', '5201', 'GO', '5201', '5203', '52007', '52', 'JESUPOLIS', NULL, '62', '75495000', '5', '0049', '0049', '08300', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 120.919, '-15,95100', '-49,37400', 0, 'S', 0.7210, NULL, NULL, '52900', 'N', 'N', 2548, NULL, '5290', '5290', NULL, '1993', 'S', 1023, 'JESÚPOLIS', 'N', '521205', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '130', NULL, '03', 'N', NULL, NULL, NULL, 405);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521210', '5215', 'GO', '5205', '5205', '52015', '52', 'JOVIANIA', NULL, '64', '75610000', '5', '9437', '9437', '08119', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 454.884, '-17,80500', '-49,61400', 807, 'S', 0.7870, NULL, NULL, '52900', 'N', 'N', 2586, NULL, '5290', '5290', NULL, '1958', 'S', 1024, 'JOVIÂNIA', 'N', '521210', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '131', NULL, '03', 'N', NULL, NULL, NULL, 354);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521220', '5210', 'GO', '5201', '5201', '52002', '52', 'JUSSARA', NULL, '62', '76270000', '4', '9439', '9439', '08120', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4092.456, '-15,86500', '-50,86800', 317, 'S', 0.7400, NULL, NULL, '52900', 'N', 'N', 2628, NULL, '5290', '5290', NULL, '1958', 'S', 1025, 'JUSSARA', 'N', '521220', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '132', NULL, '03', 'N', NULL, NULL, NULL, 236);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521225', '5213', 'GO', '5204', '5205', '52018', '52', 'LAGOA SANTA', NULL, '64', '75819000', '3', '1076', NULL, '08327', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 458.865, '-19,18300', '-51,39100', 0, 'S', NULL, NULL, NULL, '52900', 'N', 'N', 5724, NULL, '5290', '5290', NULL, '2001', 'S', 5581, 'LAGOA SANTA', 'N', '521225', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '133', NULL, '03', 'N', NULL, NULL, NULL, 120);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521230', '5202', 'GO', '5205', '5203', '52010', '52', 'LEOPOLDO DE BULHOES', NULL, '62', '75190000', '3', '9443', '9443', '08122', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 495.015, '-16,61900', '-48,74400', 1030, 'S', 0.7150, NULL, NULL, '52900', 'N', 'N', 2732, NULL, '5290', '5290', NULL, '1948', 'S', 1026, 'LEOPOLDO DE BULHÕES', 'N', '521230', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '134', NULL, '03', 'N', NULL, NULL, NULL, 60);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521250', '5203', 'GO', '5202', '5204', '52012', '52', 'LUZIANIA', NULL, '61', '72800000', '1', '9445', '9445', '08123', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3961.536, '-16,25300', '-47,95000', 930, 'S', 0.7560, NULL, NULL, '52900', 'N', 'N', 2788, NULL, '5301', '5301', NULL, '1833', 'S', 1027, 'LUZIÂNIA', 'S', '521250', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '135', NULL, '01', 'N', NULL, NULL, NULL, 118);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521260', '5202', 'GO', '5205', '5205', '52015', '52', 'MAIRIPOTABA', NULL, '64', '75630000', '0', '9447', '9447', '08124', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 460.975, '-17,29900', '-49,49100', 658, 'S', 0.7610, NULL, NULL, '52900', 'N', 'N', 2829, NULL, '5290', '5290', NULL, '1953', 'S', 1028, 'MAIRIPOTABA', 'N', '521260', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '136', NULL, '03', 'N', NULL, NULL, NULL, 60);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521270', '5217', 'GO', '5202', '5204', '52011', '52', 'MAMBAI', NULL, '62', '73970000', '9', '9449', '9449', '08125', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 859.555, '-14,48800', '-46,11300', 709, 'S', 0.6470, NULL, NULL, '52900', 'S', 'N', 2842, NULL, '5290', '5290', NULL, '1958', 'S', 1029, 'MAMBAÍ', 'N', '521270', 'N', 'N', 'S', NULL, 125, 'S', 'N', 'N', '137', NULL, '03', 'N', NULL, NULL, NULL, 184);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521280', '5207', 'GO', '5203', '5202', '52004', '52', 'MARA ROSA', NULL, '62', '76490000', '8', '9451', '9451', '08126', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1703.948, '-14,01700', '-49,17800', 530, 'S', 0.7130, NULL, NULL, '52900', 'N', 'N', 2874, NULL, '5290', '5290', NULL, '1953', 'S', 1030, 'MARA ROSA', 'N', '521280', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '138', NULL, '03', 'N', NULL, NULL, NULL, 9);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521290', '5216', 'GO', '5205', '5205', '52015', '52', 'MARZAGAO', NULL, '64', '75670000', '7', '9453', '9453', '08127', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 228.091, '-17,98100', '-48,64100', 604, 'S', 0.7790, NULL, NULL, '52900', 'N', 'N', 2950, NULL, '5290', '5290', NULL, '1949', 'S', 1031, 'MARZAGÃO', 'N', '521290', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '139', NULL, '03', 'N', NULL, NULL, NULL, 351);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521295', '5210', 'GO', '5201', '5201', '52002', '52', 'MATRINCHA', NULL, '62', '76730000', '6', '9927', '9927', '08266', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1150.891, '-15,44400', '-50,74600', 315, 'S', 0.7100, NULL, NULL, '52900', 'N', 'N', 2985, NULL, '5290', '5290', NULL, '1989', 'S', 1032, 'MATRINCHÃ', 'N', '521295', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '140', NULL, '03', 'N', NULL, NULL, NULL, 236);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521300', '5213', 'GO', '5204', '5205', '52013', '52', 'MAURILANDIA', NULL, '64', '75930000', '4', '9457', '9457', '08129', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 393.793, '-17,97100', '-50,33900', 450, 'S', 0.7260, NULL, NULL, '52900', 'N', 'N', 2993, NULL, '5290', '5290', NULL, '1963', 'S', 1033, 'MAURILÂNDIA', 'N', '521300', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '141', NULL, '03', 'N', NULL, NULL, NULL, 120);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521305', '5209', 'GO', '5203', '5204', '52012', '52', 'MIMOSO DE GOIAS', NULL, '62', '73730000', '3', '9931', '9931', '08267', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1386.910, '-15,05600', '-48,16100', 675, 'S', 0.6640, NULL, NULL, '52900', 'S', 'N', 3027, NULL, '5301', '5301', NULL, '1989', 'S', 1034, 'MIMOSO DE GOIÁS', 'S', '521305', 'N', 'N', 'S', NULL, 38, 'N', 'N', 'N', '142', NULL, '01', 'N', NULL, NULL, NULL, 519);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521308', '5206', 'GO', '5203', '5202', '52004', '52', 'MINACU', NULL, '62', '76450000', '7', '9647', '9647', '08224', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2860.719, '-13,53300', '-48,22000', 351, 'S', 0.7490, NULL, NULL, '52900', 'N', 'N', 3029, NULL, '5290', '5290', NULL, '1976', 'S', 1035, 'MINAÇU', 'N', '521308', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '143', NULL, '03', 'N', NULL, NULL, NULL, 406);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521310', '5214', 'GO', '5204', '5205', '52013', '52', 'MINEIROS', NULL, '64', '75830000', '3', '9459', '9459', '08130', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 8896.304, '-17,56900', '-52,55100', 750, 'S', 0.7800, NULL, NULL, '52900', 'N', 'N', 3034, NULL, '5290', '5290', NULL, '1905', 'S', 1036, 'MINEIROS', 'N', '521310', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '144', NULL, '03', 'N', NULL, NULL, NULL, 185);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521340', '5211', 'GO', '5201', '5203', '52008', '52', 'MOIPORA', NULL, '64', '76135000', '0', '9465', '9465', '08133', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 460.623, '-16,54600', '-50,73900', 678, 'S', 0.7300, NULL, NULL, '52900', 'N', 'N', 3073, NULL, '5290', '5290', NULL, '1958', 'S', 1037, 'MOIPORÁ', 'N', '521340', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '145', NULL, '03', 'N', NULL, NULL, NULL, 352);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521350', '5205', 'GO', '5202', '5202', '52005', '52', 'MONTE ALEGRE DE GOIAS', NULL, '62', '73830000', '9', '9467', '9467', '08134', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3119.791, '-13,25600', '-46,90100', 557, 'S', 0.6250, NULL, NULL, '52900', 'S', 'N', 3096, NULL, '5290', '5290', NULL, '1947', 'S', 1038, 'MONTE ALEGRE DE GOIÁS', 'N', '521350', 'N', 'N', 'S', NULL, 121, 'S', 'N', 'N', '146', NULL, '03', 'N', NULL, NULL, NULL, 183);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521370', '5211', 'GO', '5201', '5201', '52003', '52', 'MONTES CLAROS DE GOIAS', NULL, '62', '76255000', '7', '9471', '9471', '08136', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2899.177, '-16,00800', '-51,39700', 472, 'S', 0.7500, NULL, NULL, '52900', 'N', 'N', 3128, NULL, '5290', '5290', NULL, '1963', 'S', 1039, 'MONTES CLAROS DE GOIÁS', 'N', '521370', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '147', NULL, '03', 'N', NULL, NULL, NULL, 352);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521375', '5213', 'GO', '5204', '5205', '52013', '52', 'MONTIVIDIU', NULL, '64', '75915000', '6', '9933', '9933', '08268', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1874.611, '-17,44400', '-51,17500', 821, 'S', 0.7940, NULL, NULL, '52900', 'N', 'N', 3130, NULL, '5290', '5290', NULL, '1989', 'S', 1040, 'MONTIVIDIU', 'N', '521375', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '148', NULL, '03', 'N', NULL, NULL, NULL, 120);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521377', '5206', 'GO', '5203', '5202', '52004', '52', 'MONTIVIDIU DO NORTE', NULL, '62', '76465000', '2', '0079', '0079', '08309', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1332.991, '-13,11300', '-48,60700', 0, 'S', 0.6540, NULL, NULL, '52900', 'S', 'N', 3131, NULL, '5290', '5290', NULL, '1993', 'S', 1041, 'MONTIVIDIU DO NORTE', 'N', '521377', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '149', NULL, '03', 'N', NULL, NULL, NULL, 406);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521380', '5215', 'GO', '5205', '5205', '52015', '52', 'MORRINHOS', NULL, '64', '75650000', '6', '9473', '9473', '08137', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2846.191, '-17,73200', '-49,10100', 771, 'S', 0.8060, NULL, NULL, '52900', 'N', 'N', 3141, NULL, '5290', '5290', NULL, '1871', 'S', 1042, 'MORRINHOS', 'N', '521380', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '150', NULL, '03', 'N', NULL, NULL, NULL, 354);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521385', '5208', 'GO', '5203', '5203', '52006', '52', 'MORRO AGUDO DE GOIAS', NULL, '62', '76355000', '5', '9935', '9935', '08269', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 282.615, '-15,32100', '-50,05700', 691, 'S', 0.7170, NULL, NULL, '52900', 'N', 'N', 3145, NULL, '5290', '5290', NULL, '1989', 'S', 1043, 'MORRO AGUDO DE GOIÁS', 'N', '521385', 'N', 'N', 'S', NULL, 67, 'N', 'N', 'N', '151', NULL, '03', 'N', NULL, NULL, NULL, 119);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521390', '5210', 'GO', '5201', '5203', '52009', '52', 'MOSSAMEDES', NULL, '64', '76150000', '5', '9475', '9475', '08138', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 684.451, '-16,12700', '-50,21500', 615, 'S', 0.7500, NULL, NULL, '52900', 'N', 'N', 3158, NULL, '5290', '5290', NULL, '1958', 'S', 1044, 'MOSSÂMEDES', 'N', '521390', 'N', 'N', 'S', NULL, 67, 'N', 'N', 'N', '152', NULL, '03', 'N', NULL, NULL, NULL, 236);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521400', '5210', 'GO', '5201', '5201', '52001', '52', 'MOZARLANDIA', NULL, '62', '76700000', '2', '9477', '9477', '08139', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1734.359, '-14,74500', '-50,57100', 309, 'S', 0.7280, NULL, NULL, '52900', 'N', 'N', 3162, NULL, '5290', '5290', NULL, '1963', 'S', 1045, 'MOZARLÂNDIA', 'N', '521400', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '153', NULL, '03', 'N', NULL, NULL, NULL, 236);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521405', '5206', 'GO', '5203', '5201', '52001', '52', 'MUNDO NOVO', NULL, '62', '76530000', '1', '9651', '9651', '08227', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2146.649, '-13,77600', '-50,28100', 263, 'S', 0.6920, NULL, NULL, '52900', 'S', 'N', 3176, NULL, '5290', '5290', NULL, '1980', 'S', 1046, 'MUNDO NOVO', 'N', '521405', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '154', NULL, '03', 'N', NULL, NULL, NULL, 406);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521410', '5206', 'GO', '5203', '5202', '52004', '52', 'MUTUNOPOLIS', NULL, '62', '76540000', '1', '9479', '9479', '08140', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 869.033, '-13,73300', '-49,27500', 413, 'S', 0.7220, NULL, NULL, '52900', 'N', 'N', 3193, NULL, '5290', '5290', NULL, '1958', 'S', 1047, 'MUTUNÓPOLIS', 'N', '521410', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '155', NULL, '03', 'N', NULL, NULL, NULL, 406);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521440', '5201', 'GO', '5201', '5203', '52009', '52', 'NAZARIO', NULL, '64', '76180000', '8', '9485', '9485', '08143', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 300.089, '-16,58200', '-49,88200', 649, 'S', 0.7650, NULL, NULL, '52900', 'N', 'N', 3217, NULL, '5290', '5290', NULL, '1948', 'S', 1048, 'NAZÁRIO', 'N', '521440', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '156', NULL, '03', 'N', NULL, NULL, NULL, 405);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521450', '5201', 'GO', '5201', '5203', '52010', '52', 'NEROPOLIS', NULL, '62', '75460000', '7', '9487', '9487', '08144', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 204.216, '-16,40600', '-49,21900', 832, 'S', 0.7850, NULL, NULL, '52900', 'N', 'N', 3220, NULL, '5201', '5201', NULL, '1948', 'S', 1049, 'NERÓPOLIS', 'N', '521450', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '157', NULL, '03', 'N', NULL, NULL, NULL, 405);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521460', '5207', 'GO', '5203', '5202', '52004', '52', 'NIQUELANDIA', NULL, '62', '76420000', '6', '9489', '9489', '08145', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 9843.170, '-14,47400', '-48,46000', 583, 'S', 0.7390, NULL, NULL, '52900', 'N', 'N', 3231, NULL, '5290', '5290', NULL, '1833', 'S', 1050, 'NIQUELÂNDIA', 'N', '521460', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '158', NULL, '03', 'N', NULL, NULL, NULL, 9);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521470', '5208', 'GO', '5203', '5203', '52006', '52', 'NOVA AMERICA', NULL, '62', '76345000', '5', '9491', '9491', '08146', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 212.023, '-15,02200', '-49,89600', 796, 'S', 0.7150, NULL, NULL, '52900', 'N', 'N', 3252, NULL, '5290', '5290', NULL, '1958', 'S', 1051, 'NOVA AMÉRICA', 'N', '521470', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '159', NULL, '03', 'N', NULL, NULL, NULL, 119);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521480', '5216', 'GO', '5205', '5205', '52017', '52', 'NOVA AURORA', NULL, '64', '75750000', '4', '9493', '9493', '08147', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 302.660, '-18,05900', '-48,25500', 719, 'S', 0.7850, NULL, NULL, '52900', 'N', 'N', 3256, NULL, '5290', '5290', NULL, '1953', 'S', 1052, 'NOVA AURORA', 'N', '521480', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '160', NULL, '03', 'N', NULL, NULL, NULL, 351);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521483', '5210', 'GO', '5201', '5201', '52001', '52', 'NOVA CRIXAS', NULL, '62', '76520000', '8', '9653', '9653', '08228', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 7298.795, '-14,09900', '-50,32700', 282, 'S', 0.6860, NULL, NULL, '52900', 'S', 'N', 3273, NULL, '5290', '5290', NULL, '1980', 'S', 1053, 'NOVA CRIXÁS', 'N', '521483', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '161', NULL, '03', 'N', NULL, NULL, NULL, 236);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521486', '5208', 'GO', '5203', '5203', '52006', '52', 'NOVA GLORIA', NULL, '62', '76305000', '1', '9655', '9655', '08229', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 412.975, '-15,14300', '-49,57100', 562, 'S', 0.7240, NULL, NULL, '52900', 'N', 'N', 3286, NULL, '5290', '5290', NULL, '1980', 'S', 1054, 'NOVA GLÓRIA', 'N', '521486', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '162', NULL, '03', 'N', NULL, NULL, NULL, 119);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521487', '5207', 'GO', '5203', '5202', '52004', '52', 'NOVA IGUACU DE GOIAS', NULL, '62', '76495000', '9', '0087', '0087', '08270', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 628.441, '-14,28900', '-49,38900', 375, 'S', 0.7230, NULL, NULL, '52900', 'S', 'N', 3293, NULL, '5290', '5290', NULL, '1993', 'S', 1055, 'NOVA IGUAÇU DE GOIÁS', 'N', '521487', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '163', NULL, '03', 'N', NULL, NULL, NULL, 9);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521490', '5217', 'GO', '5202', '5202', '52005', '52', 'NOVA ROMA', NULL, '62', '73820000', '3', '9495', '9495', '08148', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2135.945, '-13,74200', '-46,88000', 610, 'S', 0.6790, NULL, NULL, '52900', 'S', 'N', 3328, NULL, '5290', '5290', NULL, '1958', 'S', 1056, 'NOVA ROMA', 'N', '521490', 'N', 'N', 'S', NULL, 121, 'S', 'N', 'N', '164', NULL, '03', 'N', NULL, NULL, NULL, 184);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521500', '5201', 'GO', '5201', '5203', '52007', '52', 'NOVA VENEZA', NULL, '62', '75470000', '9', '9497', '9497', '08149', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 123.376, '-16,37100', '-49,32300', 806, 'S', 0.7320, NULL, NULL, '52900', 'N', 'N', 3345, NULL, '5201', '5290', NULL, '1958', 'S', 1057, 'NOVA VENEZA', 'N', '521500', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '165', NULL, '03', 'N', NULL, NULL, NULL, 405);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521520', '5211', 'GO', '5201', '5203', '52008', '52', 'NOVO BRASIL', NULL, '62', '76285000', '7', '9501', '9501', '08151', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 649.954, '-16,03400', '-50,71100', 400, 'S', 0.7120, NULL, NULL, '52900', 'N', 'N', 3354, NULL, '5290', '5290', NULL, '1958', 'S', 1058, 'NOVO BRASIL', 'N', '521520', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '166', NULL, '03', 'N', NULL, NULL, NULL, 352);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521523', '5203', 'GO', '5202', '5204', '52012', '52', 'NOVO GAMA', NULL, '61', '72860000', '1', '1058', '1058', '08318', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 191.675, '-16,05900', '-48,03900', 1100, 'S', 0.7420, NULL, NULL, '52900', 'N', 'N', 3357, NULL, '5301', '5301', NULL, '1997', 'S', 1059, 'NOVO GAMA', 'S', '521523', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '167', NULL, '01', 'N', NULL, NULL, NULL, 118);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521525', '5206', 'GO', '5203', '5201', '52001', '52', 'NOVO PLANALTO', NULL, '62', '76580000', '6', '9735', '9735', '08273', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1242.639, '-13,24400', '-49,50400', 304, 'S', 0.7150, NULL, NULL, '52900', 'N', 'N', 3373, NULL, '5290', '5290', NULL, '1989', 'S', 1060, 'NOVO PLANALTO', 'N', '521525', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '168', NULL, '03', 'N', NULL, NULL, NULL, 406);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521530', '5202', 'GO', '5205', '5205', '52016', '52', 'ORIZONA', NULL, '64', '75280000', '6', '9503', '9503', '08152', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1972.865, '-17,03100', '-48,29600', 806, 'S', 0.7680, NULL, NULL, '52900', 'N', 'N', 3416, NULL, '5290', '5290', NULL, '1906', 'S', 1061, 'ORIZONA', 'N', '521530', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '169', NULL, '03', 'N', NULL, NULL, NULL, 60);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521540', '5201', 'GO', '5201', '5203', '52007', '52', 'OURO VERDE DE GOIAS', NULL, '62', '75165000', '5', '9505', '9505', '08153', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 209.679, '-16,22000', '-49,19300', 1040, 'S', 0.7190, NULL, NULL, '52900', 'N', 'N', 3444, NULL, '5290', '5290', NULL, '1963', 'S', 1062, 'OURO VERDE DE GOIÁS', 'N', '521540', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '170', NULL, '03', 'N', NULL, NULL, NULL, 405);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521550', '5216', 'GO', '5205', '5205', '52017', '52', 'OUVIDOR', NULL, '64', '75715000', '4', '9507', '9507', '08154', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 413.786, '-18,23400', '-47,83900', 810, 'S', 0.7850, NULL, NULL, '52900', 'N', 'N', 3449, NULL, '5290', '5290', NULL, '1953', 'S', 1063, 'OUVIDOR', 'N', '521550', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '171', NULL, '03', 'N', NULL, NULL, NULL, 351);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521560', '5209', 'GO', '5203', '5204', '52012', '52', 'PADRE BERNARDO', NULL, '61', '73700000', '3', '9509', '9509', '08155', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3137.903, '-15,16000', '-48,28400', 629, 'S', 0.7050, NULL, NULL, '52900', 'N', 'N', 3459, NULL, '5301', '5301', NULL, '1963', 'S', 1064, 'PADRE BERNARDO', 'S', '521560', 'N', 'N', 'S', NULL, 38, 'N', 'N', 'N', '172', NULL, '01', 'N', NULL, NULL, NULL, 519);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521565', '5211', 'GO', '5201', '5205', '52013', '52', 'PALESTINA DE GOIAS', NULL, '64', '75845000', '2', '9737', '9737', '08274', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1320.683, '-16,73300', '-51,53300', 741, 'S', 0.7390, NULL, NULL, '52900', 'N', 'N', 3475, NULL, '5290', '5290', NULL, '1989', 'S', 1065, 'PALESTINA DE GOIÁS', 'N', '521565', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '173', NULL, '03', 'N', NULL, NULL, NULL, 352);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521570', '5212', 'GO', '5201', '5205', '52014', '52', 'PALMEIRAS DE GOIAS', NULL, '64', '76190000', '2', '9511', '9511', '08156', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1539.683, '-16,80500', '-49,92600', 596, 'S', 0.7600, NULL, NULL, '52900', 'N', 'N', 3498, NULL, '5290', '5290', NULL, '1887', 'S', 1066, 'PALMEIRAS DE GOIÁS', 'N', '521570', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '174', NULL, '03', 'N', NULL, NULL, NULL, 353);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521580', '5216', 'GO', '5205', '5205', '52016', '52', 'PALMELO', NULL, '64', '75210000', '1', '9513', '9513', '08157', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 58.997, '-17,32400', '-48,42400', 754, 'S', 0.7870, NULL, NULL, '52900', 'N', 'N', 3502, NULL, '5290', '5290', NULL, '1953', 'S', 1067, 'PALMELO', 'N', '521580', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '175', NULL, '03', 'N', NULL, NULL, NULL, 351);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521590', '5212', 'GO', '5201', '5205', '52014', '52', 'PALMINOPOLIS', NULL, '64', '75990000', '0', '9515', '9515', '08158', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 387.693, '-16,79600', '-50,16500', 719, 'S', 0.7530, NULL, NULL, '52900', 'N', 'N', 3503, NULL, '5290', '5290', NULL, '1961', 'S', 1068, 'PALMINÓPOLIS', 'N', '521590', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '176', NULL, '03', 'N', NULL, NULL, NULL, 353);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521600', '5215', 'GO', '5205', '5205', '52015', '52', 'PANAMA', NULL, '64', '75580000', '7', '9517', '9517', '08159', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 433.759, '-18,17700', '-49,35400', 733, 'S', 0.7340, NULL, NULL, '52900', 'N', 'N', 3510, NULL, '5290', '5290', NULL, '1952', 'S', 1069, 'PANAMÁ', 'N', '521600', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '177', NULL, '03', 'N', NULL, NULL, NULL, 354);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521630', '5213', 'GO', '5204', '5205', '52018', '52', 'PARANAIGUARA', NULL, '64', '75880000', '4', '9455', '9455', '08128', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1153.786, '-18,91600', '-50,65400', 479, 'S', 0.7510, NULL, NULL, '52900', 'N', 'N', 3546, NULL, '5290', '5290', NULL, '1953', 'S', 1070, 'PARANAIGUARA', 'N', '521630', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '178', NULL, '03', 'N', NULL, NULL, NULL, 120);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521640', '5212', 'GO', '5201', '5205', '52014', '52', 'PARAUNA', NULL, '64', '75980000', '3', '9523', '9523', '08162', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3781.219, '-16,94800', '-50,44900', 721, 'S', 0.7420, NULL, NULL, '52900', 'N', 'N', 3562, NULL, '5290', '5290', NULL, '1934', 'S', 1071, 'PARAÚNA', 'N', '521640', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '179', NULL, '03', 'N', NULL, NULL, NULL, 353);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521645', '5214', 'GO', '5204', '5205', '52013', '52', 'PEROLANDIA', NULL, '64', '75823000', '2', '0075', '0075', '08301', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1029.622, '-17,52900', '-52,06400', 889, 'S', 0.7300, NULL, NULL, '52900', 'N', 'N', 3707, NULL, '5290', '5290', NULL, '1993', 'S', 1072, 'PEROLÂNDIA', 'N', '521645', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '180', NULL, '03', 'N', NULL, NULL, NULL, 185);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521680', '5201', 'GO', '5201', '5203', '52007', '52', 'PETROLINA DE GOIAS', NULL, '62', '75480000', '9', '9531', '9531', '08166', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 540.451, '-16,09500', '-49,33800', 720, 'S', 0.7330, NULL, NULL, '52900', 'N', 'N', 3714, NULL, '5290', '5290', NULL, '1948', 'S', 1073, 'PETROLINA DE GOIÁS', 'N', '521680', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '181', NULL, '03', 'N', NULL, NULL, NULL, 405);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521690', '5208', 'GO', '5203', '5203', '52006', '52', 'PILAR DE GOIAS', NULL, '62', '76370000', '8', '9535', '9535', '08168', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 906.648, '-14,76400', '-49,57800', 753, 'S', 0.7000, NULL, NULL, '52900', 'S', 'N', 3736, NULL, '5290', '5290', NULL, '1953', 'S', 1074, 'PILAR DE GOIÁS', 'N', '521690', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '182', NULL, '03', 'N', NULL, NULL, NULL, 119);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521710', '5202', 'GO', '5205', '5205', '52015', '52', 'PIRACANJUBA', NULL, '64', '75640000', '4', '9539', '9539', '08170', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2405.114, '-17,30300', '-49,01800', 742, 'S', 0.7550, NULL, NULL, '52900', 'N', 'N', 3777, NULL, '5290', '5290', NULL, '1869', 'S', 1075, 'PIRACANJUBA', 'N', '521710', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '183', NULL, '03', 'N', NULL, NULL, NULL, 60);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521720', '5211', 'GO', '5201', '5201', '52003', '52', 'PIRANHAS', NULL, '64', '76230000', '3', '9541', '9541', '08171', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2047.760, '-16,42700', '-51,82200', 389, 'S', 0.7370, NULL, NULL, '52900', 'N', 'N', 3792, NULL, '5290', '5290', NULL, '1953', 'S', 1076, 'PIRANHAS', 'N', '521720', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '184', NULL, '03', 'N', NULL, NULL, NULL, 352);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521730', '5209', 'GO', '5203', '5204', '52012', '52', 'PIRENOPOLIS', NULL, '62', '72980000', '2', '9543', '9543', '08172', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2227.793, '-15,85200', '-48,95900', 770, 'S', 0.7130, NULL, NULL, '52900', 'N', 'N', 3807, NULL, '5301', '5301', NULL, '1832', 'S', 1077, 'PIRENÓPOLIS', 'S', '521730', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '185', NULL, '01', 'N', NULL, NULL, NULL, 61);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521740', '5216', 'GO', '5205', '5205', '52016', '52', 'PIRES DO RIO', NULL, '64', '75200000', '1', '9545', '9545', '08173', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1073.369, '-17,30100', '-48,28000', 758, 'S', 0.7850, NULL, NULL, '52900', 'N', 'N', 3808, NULL, '5290', '5290', NULL, '1930', 'S', 1078, 'PIRES DO RIO', 'N', '521740', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '186', NULL, '03', 'N', NULL, NULL, NULL, 351);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521760', '5204', 'GO', '5202', '5204', '52012', '52', 'PLANALTINA', NULL, '61', '73750000', '9', '9595', '9595', '08198', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2539.113, '-15,45300', '-47,61400', 944, 'S', 0.7230, NULL, NULL, '52900', 'N', 'N', 3824, NULL, '5301', '5301', NULL, '1891', 'S', 1079, 'PLANALTINA', 'S', '521760', 'N', 'N', 'S', NULL, 38, 'S', 'N', 'N', '187', NULL, '01', 'N', NULL, NULL, NULL, 350);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521770', '5202', 'GO', '5205', '5205', '52015', '52', 'PONTALINA', NULL, '64', '75620000', '8', '9549', '9549', '08175', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1428.194, '-17,52600', '-49,44900', 610, 'S', 0.8050, NULL, NULL, '52900', 'N', 'N', 3865, NULL, '5290', '5290', NULL, '1935', 'S', 1080, 'PONTALINA', 'N', '521770', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '188', NULL, '03', 'N', NULL, NULL, NULL, 60);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521800', '5206', 'GO', '5203', '5202', '52004', '52', 'PORANGATU', NULL, '62', '76550000', '3', '9555', '9555', '08178', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4820.485, '-13,44100', '-49,14900', 396, 'S', 0.7610, NULL, NULL, '52900', 'N', 'N', 3885, NULL, '5290', '5290', NULL, '1948', 'S', 1081, 'PORANGATU', 'N', '521800', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '189', NULL, '03', 'N', NULL, NULL, NULL, 406);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521805', '5213', 'GO', '5204', '5205', '52015', '52', 'PORTEIRAO', NULL, '64', '75603000', '2', '1060', NULL, '08319', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 603.917, '-17,81500', '-50,16400', 470, 'S', 0.7240, NULL, NULL, '52900', 'N', 'N', 3890, NULL, '5290', '5290', NULL, '1997', 'S', 1082, 'PORTEIRÃO', 'N', '521805', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '190', NULL, '03', 'N', NULL, NULL, NULL, 120);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521810', '5214', 'GO', '5204', '5205', '52013', '52', 'PORTELANDIA', NULL, '64', '75835000', '2', '9557', '9557', '08179', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 550.646, '-17,35400', '-52,67900', 858, 'S', 0.7800, NULL, NULL, '52900', 'N', 'N', 3894, NULL, '5290', '5290', NULL, '1963', 'S', 1083, 'PORTELÂNDIA', 'N', '521810', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '191', NULL, '03', 'N', NULL, NULL, NULL, 185);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521830', '5217', 'GO', '5202', '5204', '52011', '52', 'POSSE', NULL, '62', '73900000', '0', '9561', '9561', '08181', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1949.632, '-14,09300', '-46,36900', 811, 'S', 0.7110, NULL, NULL, '52900', 'N', 'N', 3932, NULL, '5290', '5290', NULL, '1872', 'S', 1084, 'POSSE', 'N', '521830', 'N', 'N', 'S', NULL, 125, 'N', 'N', 'N', '192', NULL, '03', 'N', NULL, NULL, NULL, 184);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521839', '5202', 'GO', '5205', '5205', '52015', '52', 'PROFESSOR JAMIL', NULL, '64', '75645000', '1', '0051', '0051', '08302', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 347.464, '-17,25100', '-49,24400', 748, 'S', 0.7360, NULL, NULL, '52900', 'N', 'N', 3995, NULL, '5290', '5290', NULL, '1993', 'S', 1085, 'PROFESSOR JAMIL', 'N', '521839', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '193', NULL, '03', 'N', NULL, NULL, NULL, 60);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521850', '5213', 'GO', '5204', '5205', '52018', '52', 'QUIRINOPOLIS', NULL, '64', '75860000', '8', '9563', '9563', '08182', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3780.173, '-18,44800', '-50,45200', 541, 'S', 0.7800, NULL, NULL, '52900', 'N', 'N', 4034, NULL, '5290', '5290', NULL, '1943', 'S', 1086, 'QUIRINÓPOLIS', 'N', '521850', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '194', NULL, '03', 'N', NULL, NULL, NULL, 120);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521860', '5208', 'GO', '5203', '5203', '52006', '52', 'RIALMA', NULL, '62', '76310000', '7', '9565', '9565', '08183', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 268.958, '-15,31500', '-49,58400', 582, 'S', 0.7770, NULL, NULL, '52900', 'N', 'N', 4105, NULL, '5290', '5290', NULL, '1953', 'S', 1087, 'RIALMA', 'N', '521860', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '195', NULL, '03', 'N', NULL, NULL, NULL, 119);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521870', '5208', 'GO', '5203', '5203', '52006', '52', 'RIANAPOLIS', NULL, '62', '76315000', '6', '9567', '9567', '08184', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 159.345, '-15,44700', '-49,51000', 589, 'S', 0.7590, NULL, NULL, '52900', 'N', 'N', 4106, NULL, '5290', '5290', NULL, '1958', 'S', 1088, 'RIANÁPOLIS', 'N', '521870', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '196', NULL, '03', 'N', NULL, NULL, NULL, 119);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520420', '5212', 'GO', '5201', '5203', '52008', '52', 'CACHOEIRA DE GOIAS', NULL, '64', '76125000', '1', '9283', '9283', '08042', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 415.730, '-16,66800', '-50,64700', 764, 'S', 0.7040, NULL, NULL, '52900', 'N', 'N', 830, NULL, '5290', '5290', NULL, '1953', 'S', 940, 'CACHOEIRA DE GOIÁS', 'N', '520420', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '44', NULL, '03', 'N', NULL, NULL, NULL, 353);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520425', '5215', 'GO', '5205', '5205', '52015', '52', 'CACHOEIRA DOURADA', NULL, '64', '75560000', '0', '9673', '9673', '08237', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 521.130, '-18,49200', '-49,47500', 459, 'S', 0.7590, NULL, NULL, '52900', 'N', 'N', 838, NULL, '5290', '5290', NULL, '1982', 'S', 941, 'CACHOEIRA DOURADA', 'N', '520425', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '45', NULL, '03', 'N', NULL, NULL, NULL, 354);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520430', '5213', 'GO', '5204', '5205', '52018', '52', 'CACU', NULL, '64', '75813000', '0', '9285', '9285', '08043', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2251.098, '-18,55700', '-51,13100', 469, 'S', 0.7830, NULL, NULL, '52900', 'N', 'N', 853, NULL, '5290', '5290', NULL, '1953', 'S', 942, 'CAÇU', 'N', '520430', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '46', NULL, '03', 'N', NULL, NULL, NULL, 120);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520440', '5214', 'GO', '5204', '5205', '52013', '52', 'CAIAPONIA', NULL, '64', '75850000', '9', '9287', '9287', '08044', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 8653.189, '-16,95700', '-51,81000', 692, 'S', 0.7350, NULL, NULL, '52900', 'N', 'N', 868, NULL, '5290', '5290', NULL, '1873', 'S', 943, 'CAIAPÔNIA', 'N', '520440', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '47', NULL, '03', 'N', NULL, NULL, NULL, 185);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520450', '5216', 'GO', '5205', '5205', '52015', '52', 'CALDAS NOVAS', NULL, '64', '75690000', '8', '9289', '9289', '08045', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1589.518, '-17,74400', '-48,62600', 686, 'S', 0.8020, NULL, NULL, '52900', 'N', 'N', 895, NULL, '5290', '5290', NULL, '1911', 'S', 944, 'CALDAS NOVAS', 'N', '520450', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '48', NULL, '02', 'N', NULL, NULL, NULL, 351);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520455', '5202', 'GO', '5205', '5203', '52010', '52', 'CALDAZINHA', NULL, '62', '75245000', '7', '0031', '0031', '08311', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 311.687, '-16,71400', '-49,00200', 866, 'S', 0.7420, NULL, NULL, '52900', 'N', 'N', 896, NULL, '5201', '5290', NULL, '1993', 'S', 945, 'CALDAZINHA', 'N', '520455', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '49', NULL, '03', 'N', NULL, NULL, NULL, 60);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520460', '5201', 'GO', '5201', '5205', '52014', '52', 'CAMPESTRE DE GOIAS', NULL, '62', '75385000', '7', '9291', '9291', '08046', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 273.816, '-16,76200', '-49,69400', 651, 'S', 0.7150, NULL, NULL, '52900', 'N', 'N', 928, NULL, '5290', '5290', NULL, '1963', 'S', 946, 'CAMPESTRE DE GOIÁS', 'N', '520460', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '50', NULL, '03', 'N', NULL, NULL, NULL, 405);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520465', '5206', 'GO', '5203', '5202', '52004', '52', 'CAMPINACU', NULL, '62', '76440000', '6', '9687', '9687', '08239', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1974.367, '-13,79000', '-48,57100', 690, 'S', 0.7330, NULL, NULL, '52900', 'N', 'N', 937, NULL, '5290', '5290', NULL, '1982', 'S', 947, 'CAMPINAÇU', 'N', '520465', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '51', NULL, '03', 'N', NULL, NULL, NULL, 406);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520470', '5207', 'GO', '5203', '5202', '52004', '52', 'CAMPINORTE', NULL, '62', '76410000', '6', '9293', '9293', '08047', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1068.274, '-14,31400', '-49,15200', 537, 'S', 0.7500, NULL, NULL, '52900', 'N', 'N', 942, NULL, '5290', '5290', NULL, '1963', 'S', 948, 'CAMPINORTE', 'N', '520470', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '52', NULL, '03', 'N', NULL, NULL, NULL, 9);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520480', '5216', 'GO', '5205', '5205', '52017', '52', 'CAMPO ALEGRE DE GOIAS', NULL, '64', '75795000', '5', '9295', '9295', '08048', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2463.014, '-17,63900', '-47,78200', 877, 'S', 0.8020, NULL, NULL, '52900', 'N', 'N', 945, NULL, '5290', '5290', NULL, '1953', 'S', 949, 'CAMPO ALEGRE DE GOIÁS', 'N', '520480', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '53', NULL, '03', 'N', NULL, NULL, NULL, 351);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520485', '5209', 'GO', '5203', '5203', '52007', '52', 'CAMPO LIMPO DE GOIAS', NULL, '62', '75160000', '4', '1070', NULL, '08324', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 156.202, '-16,29700', '-49,08800', 0, 'S', NULL, NULL, NULL, '52900', 'N', 'N', 5718, NULL, '5290', '5290', NULL, '2001', 'S', 5578, 'CAMPO LIMPO DE GOIÁS', 'N', '520485', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '54', NULL, '03', 'N', NULL, NULL, NULL, 61);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520490', '5205', 'GO', '5202', '5202', '52005', '52', 'CAMPOS BELOS', NULL, '62', '73840000', '4', '9297', '9297', '08049', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 724.060, '-13,03700', '-46,77200', 643, 'S', 0.7080, NULL, NULL, '52900', 'N', 'N', 975, NULL, '5290', '5290', NULL, '1989', 'S', 950, 'CAMPOS BELOS', 'N', '520490', 'N', 'N', 'S', NULL, 121, 'N', 'N', 'N', '55', NULL, '03', 'N', NULL, NULL, NULL, 183);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520495', '5208', 'GO', '5203', '5202', '52004', '52', 'CAMPOS VERDES', NULL, '62', '76515000', '3', '9781', '9781', '08254', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 441.702, '-14,25800', '-49,65800', 420, 'S', 0.6940, NULL, NULL, '52900', 'S', 'N', 985, NULL, '5290', '5290', NULL, '1989', 'S', 951, 'CAMPOS VERDES', 'N', '520495', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '56', NULL, '03', 'N', NULL, NULL, NULL, 119);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520510', '5216', 'GO', '5205', '5205', '52017', '52', 'CATALAO', NULL, '64', '75701970', '9', '9301', '9301', '08051', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3777.652, '-18,17000', '-47,94200', 835, 'S', 0.8180, NULL, NULL, '52900', 'N', 'N', 1165, NULL, '5290', '5290', NULL, '1833', 'S', 954, 'CATALÃO', 'N', '520510', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '59', NULL, '01', 'N', NULL, NULL, NULL, 351);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520520', '5201', 'GO', '5201', '5203', '52007', '52', 'CATURAI', NULL, '62', '75430000', '8', '9303', '9303', '08052', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 207.154, '-16,44700', '-49,49400', 763, 'S', 0.7280, NULL, NULL, '52900', 'N', 'N', 1181, NULL, '5201', '5290', NULL, '1958', 'S', 955, 'CATURAÍ', 'N', '520520', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '60', NULL, '03', 'N', NULL, NULL, NULL, 405);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520530', '5205', 'GO', '5202', '5202', '52005', '52', 'CAVALCANTE', NULL, '62', '73790000', '7', '9305', '9305', '08053', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 6953.646, '-13,79800', '-47,45800', 823, 'S', 0.6090, NULL, NULL, '52900', 'S', 'N', 1186, NULL, '5290', '5290', NULL, '1831', 'S', 956, 'CAVALCANTE', 'N', '520530', 'N', 'N', 'S', NULL, 121, 'N', 'N', 'N', '61', NULL, '03', 'N', NULL, NULL, NULL, 183);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520540', '5208', 'GO', '5203', '5203', '52006', '52', 'CERES', NULL, '62', '76300000', '6', '9307', '9307', '08054', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 213.497, '-15,30800', '-49,59800', 571, 'S', 0.7820, NULL, NULL, '52900', 'N', 'N', 1210, NULL, '5290', '5290', NULL, '1953', 'S', 957, 'CERES', 'N', '520540', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '62', NULL, '03', 'N', NULL, NULL, NULL, 119);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520545', '5202', 'GO', '5205', '5205', '52014', '52', 'CEZARINA', NULL, '64', '76195000', '5', '9785', '9785', '08256', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 415.809, '-16,97200', '-49,77600', 596, 'S', 0.7470, NULL, NULL, '52900', 'N', 'N', 1223, NULL, '5290', '5290', NULL, '1989', 'S', 958, 'CEZARINA', 'N', '520545', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '63', NULL, '03', 'N', NULL, NULL, NULL, 60);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520547', '5214', 'GO', '5204', '5205', '52013', '52', 'CHAPADAO DO CEU', NULL, '64', '75828000', '1', '0073', '0073', '08297', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2354.822, '-18,40800', '-52,54900', 725, 'S', 0.8340, NULL, NULL, '52900', 'N', 'N', 1235, NULL, '5290', '5290', NULL, '1993', 'S', 959, 'CHAPADÃO DO CÉU', 'N', '520547', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '64', NULL, '03', 'N', NULL, NULL, NULL, 185);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520549', '5203', 'GO', '5202', '5204', '52012', '52', 'CIDADE OCIDENTAL', NULL, '61', '72880000', '7', '0077', '0077', '08298', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 388.162, '-16,07700', '-47,92500', 1057, 'S', 0.7950, NULL, NULL, '52900', 'N', 'N', 1258, NULL, '5301', '5301', NULL, '1993', 'S', 960, 'CIDADE OCIDENTAL', 'S', '520549', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '65', NULL, '01', 'N', NULL, NULL, NULL, 118);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520551', '5209', 'GO', '5203', '5204', '52012', '52', 'COCALZINHO DE GOIAS', NULL, '62', '72975000', '3', '0055', '0055', '08299', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1787.994, '-15,79400', '-48,77600', 1152, 'S', 0.7040, NULL, NULL, '52900', 'N', 'N', 1277, NULL, '5301', '5301', NULL, '1993', 'S', 961, 'COCALZINHO DE GOIÁS', 'S', '520551', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '66', NULL, '01', 'N', NULL, NULL, NULL, 61);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520552', '5207', 'GO', '5203', '5202', '52005', '52', 'COLINAS DO SUL', NULL, '62', '73740000', '1', '9791', '9791', '08257', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1708.215, '-14,15100', '-48,07800', 535, 'S', 0.6710, NULL, NULL, '52900', 'S', 'N', 1291, NULL, '5290', '5290', NULL, '1989', 'S', 962, 'COLINAS DO SUL', 'N', '520552', 'N', 'N', 'S', NULL, 121, 'N', 'N', 'N', '67', NULL, '03', 'N', NULL, NULL, NULL, 9);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520570', '5212', 'GO', '5201', '5203', '52008', '52', 'CORREGO DO OURO', NULL, '64', '76145000', '3', '9315', '9315', '08058', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 462.302, '-16,29400', '-50,54800', 563, 'S', 0.7260, NULL, NULL, '52900', 'N', 'N', 1396, NULL, '5290', '5290', NULL, '1953', 'S', 963, 'CÓRREGO DO OURO', 'N', '520570', 'N', 'N', 'S', NULL, 67, 'N', 'N', 'N', '68', NULL, '03', 'N', NULL, NULL, NULL, 353);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520580', '5209', 'GO', '5203', '5204', '52012', '52', 'CORUMBA DE GOIAS', NULL, '62', '72960000', '2', '9317', '9317', '08059', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1062.457, '-15,92400', '-48,80900', 962, 'S', 0.7160, NULL, NULL, '52900', 'N', 'N', 1405, NULL, '5301', '5301', NULL, '1875', 'S', 964, 'CORUMBÁ DE GOIÁS', 'S', '520580', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '69', NULL, '01', 'N', NULL, NULL, NULL, 61);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520590', '5216', 'GO', '5205', '5205', '52017', '52', 'CORUMBAIBA', NULL, '64', '75680000', '1', '9319', '9319', '08060', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1881.712, '-18,14200', '-48,56200', 633, 'S', 0.7670, NULL, NULL, '52900', 'N', 'N', 1406, NULL, '5290', '5290', NULL, '1905', 'S', 965, 'CORUMBAÍBA', 'N', '520590', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '70', NULL, '03', 'N', NULL, NULL, NULL, 351);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520620', '5203', 'GO', '5202', '5204', '52012', '52', 'CRISTALINA', NULL, '61', '73850000', '6', '9325', '9325', '08063', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 6160.722, '-16,76900', '-47,61400', 1189, 'S', 0.7610, NULL, NULL, '52900', 'N', 'N', 1441, NULL, '5301', '5301', NULL, '1916', 'S', 966, 'CRISTALINA', 'S', '520620', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '71', NULL, '01', 'N', NULL, NULL, NULL, 118);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520630', '5202', 'GO', '5205', '5205', '52016', '52', 'CRISTIANOPOLIS', NULL, '64', '75230000', '5', '9327', '9327', '08064', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 225.357, '-17,19900', '-48,70400', 802, 'S', 0.7710, NULL, NULL, '52900', 'N', 'N', 1443, NULL, '5290', '5290', NULL, '1953', 'S', 967, 'CRISTIANÓPOLIS', 'N', '520630', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '72', NULL, '03', 'N', NULL, NULL, NULL, 60);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520640', '5208', 'GO', '5203', '5201', '52001', '52', 'CRIXAS', NULL, '62', '76510000', '4', '9329', '9329', '08065', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 4661.077, '-14,54900', '-49,96900', 389, 'S', 0.7170, NULL, NULL, '52900', 'N', 'N', 1448, NULL, '5290', '5290', NULL, '1953', 'S', 968, 'CRIXÁS', 'N', '520640', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '73', NULL, '03', 'N', NULL, NULL, NULL, 119);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520650', '5202', 'GO', '5205', '5205', '52015', '52', 'CROMINIA', NULL, '64', '75635000', '3', '9331', '9331', '08066', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 369.917, '-17,28800', '-49,38100', 694, 'S', 0.7690, NULL, NULL, '52900', 'N', 'N', 1451, NULL, '5290', '5290', NULL, '1953', 'S', 969, 'CROMÍNIA', 'N', '520650', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '74', NULL, '03', 'N', NULL, NULL, NULL, 60);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520660', '5216', 'GO', '5205', '5205', '52017', '52', 'CUMARI', NULL, '64', '75760000', '2', '9333', '9333', '08067', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 579.877, '-18,26300', '-48,15100', 692, 'S', 0.7560, NULL, NULL, '52900', 'N', 'N', 1476, NULL, '5290', '5290', NULL, '1947', 'S', 970, 'CUMARI', 'N', '520660', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '75', NULL, '03', 'N', NULL, NULL, NULL, 351);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520670', '5217', 'GO', '5202', '5204', '52011', '52', 'DAMIANOPOLIS', NULL, '62', '73980000', '1', '9335', '9335', '08068', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 415.349, '-14,56400', '-46,17700', 746, 'S', 0.6340, NULL, NULL, '52900', 'S', 'N', 1505, NULL, '5290', '5290', NULL, '1958', 'S', 971, 'DAMIANÓPOLIS', 'N', '520670', 'N', 'N', 'S', NULL, 125, 'N', 'N', 'N', '76', NULL, '03', 'N', NULL, NULL, NULL, 184);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('520680', '5201', 'GO', '5201', '5203', '52007', '52', 'DAMOLANDIA', NULL, '62', '75420000', '0', '9337', '9337', '08069', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 84.632, '-16,25300', '-49,37000', 819, 'S', 0.7390, NULL, NULL, '52900', 'N', 'N', 1507, NULL, '5290', '5290', NULL, '1958', 'S', 972, 'DAMOLÂNDIA', 'N', '520680', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '77', NULL, '03', 'N', NULL, NULL, NULL, 405);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521878', '5216', 'GO', '5205', '5205', '52015', '52', 'RIO QUENTE', NULL, '64', '75695000', '9', '9995', '9995', '08293', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 256.739, '-17,77400', '-48,77300', 663, 'S', 0.8060, NULL, NULL, '52900', 'N', 'N', 4188, NULL, '5290', '5290', NULL, '1989', 'S', 1089, 'RIO QUENTE', 'N', '521878', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '197', NULL, '03', 'N', NULL, NULL, NULL, 351);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521880', '5213', 'GO', '5204', '5205', '52013', '52', 'RIO VERDE', NULL, '64', '75901070', '5', '9571', '9571', '08186', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 8388.295, '-17,79800', '-50,92800', 715, 'S', 0.8070, NULL, NULL, '52900', 'N', 'N', 4193, NULL, '5290', '5290', NULL, '1854', 'S', 1090, 'RIO VERDE', 'N', '521880', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '198', NULL, '01', 'N', NULL, NULL, NULL, 120);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521890', '5208', 'GO', '5203', '5203', '52006', '52', 'RUBIATABA', NULL, '62', '76350000', '4', '9573', '9573', '08187', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'S', NULL, 'N', 748.273, '-15,16400', '-49,80300', 632, 'S', 0.7480, NULL, NULL, '52900', 'N', 'N', 4234, NULL, '5290', '5290', NULL, '1953', 'S', 1091, 'RUBIATABA', 'N', '521890', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '199', NULL, '03', 'N', NULL, NULL, NULL, 119);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521900', '5212', 'GO', '5201', '5203', '52009', '52', 'SANCLERLANDIA', NULL, '64', '76160000', '1', '9575', '9575', '08188', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 496.824, '-16,19800', '-50,31400', 607, 'S', 0.7340, NULL, NULL, '52900', 'N', 'N', 4285, NULL, '5290', '5290', NULL, '1963', 'S', 1092, 'SANCLERLÂNDIA', 'N', '521900', 'N', 'N', 'S', NULL, 67, 'N', 'N', 'N', '200', NULL, '03', 'N', NULL, NULL, NULL, 353);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521910', '5201', 'GO', '5201', '5203', '52009', '52', 'SANTA BARBARA DE GOIAS', NULL, '62', '75390000', '0', '9577', '9577', '08189', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 139.598, '-16,57400', '-49,69400', 639, 'S', 0.7330, NULL, NULL, '52900', 'N', 'N', 4296, NULL, '5290', '5290', NULL, '1963', 'S', 1093, 'SANTA BÁRBARA DE GOIÁS', 'N', '521910', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '201', NULL, '03', 'N', NULL, NULL, NULL, 405);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521920', '5216', 'GO', '5205', '5205', '52016', '52', 'SANTA CRUZ DE GOIAS', NULL, '64', '75220000', '9', '9579', '9579', '08190', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1108.920, '-17,31600', '-48,48200', 754, 'S', 0.7820, NULL, NULL, '52900', 'N', 'N', 4319, NULL, '5290', '5290', NULL, '1947', 'S', 1094, 'SANTA CRUZ DE GOIÁS', 'N', '521920', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '202', NULL, '03', 'N', NULL, NULL, NULL, 351);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521925', '5210', 'GO', '5201', '5201', '52002', '52', 'SANTA FE DE GOIAS', NULL, '62', '76265000', '8', '9743', '9743', '08279', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1160.800, '-15,76900', '-51,10600', 362, 'S', 0.7140, NULL, NULL, '52900', 'N', 'N', 4333, NULL, '5290', '5290', NULL, '1989', 'S', 1095, 'SANTA FÉ DE GOIÁS', 'N', '521925', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '203', NULL, '03', 'N', NULL, NULL, NULL, 236);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521930', '5213', 'GO', '5204', '5205', '52013', '52', 'SANTA HELENA DE GOIAS', NULL, '64', '75920000', '8', '9581', '9581', '08191', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1127.855, '-17,81400', '-50,59700', 562, 'S', 0.7470, NULL, NULL, '52900', 'N', 'N', 4345, NULL, '5290', '5290', NULL, '1948', 'S', 1096, 'SANTA HELENA DE GOIÁS', 'N', '521930', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '204', NULL, '03', 'N', NULL, NULL, NULL, 120);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521935', '5208', 'GO', '5203', '5203', '52006', '52', 'SANTA ISABEL', NULL, '62', '76320000', '7', '9689', '9689', '08244', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 806.814, '-15,29800', '-49,42700', 611, 'S', 0.7200, NULL, NULL, '52900', 'N', 'N', 4351, NULL, '5290', '5290', NULL, '1982', 'S', 1097, 'SANTA ISABEL', 'N', '521935', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '205', NULL, '03', 'N', NULL, NULL, NULL, 119);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521940', '5214', 'GO', '5204', '5205', '52013', '52', 'SANTA RITA DO ARAGUAIA', NULL, '64', '75840000', '7', '9583', '9583', '08192', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1361.764, '-17,32600', '-53,20500', 691, 'S', 0.7560, NULL, NULL, '52900', 'N', 'N', 4400, NULL, '5290', '5290', NULL, '1953', 'S', 1098, 'SANTA RITA DO ARAGUAIA', 'N', '521940', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '206', NULL, '03', 'N', NULL, NULL, NULL, 185);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521945', '5208', 'GO', '5203', '5203', '52006', '52', 'SANTA RITA DO NOVO DESTINO', NULL, '62', '76395000', '6', '1062', NULL, '08320', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 956.037, '-15,13500', '-49,12000', 790, 'S', 0.6840, NULL, NULL, '52900', 'S', 'N', 4403, NULL, '5290', '5290', NULL, '1997', 'S', 1099, 'SANTA RITA DO NOVO DESTINO', 'N', '521945', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '207', NULL, '03', 'N', NULL, NULL, NULL, 519);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521950', '5201', 'GO', '5201', '5203', '52007', '52', 'SANTA ROSA DE GOIAS', NULL, '62', '75455000', '6', '9585', '9585', '08193', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 170.970, '-16,08500', '-49,49400', 837, 'S', 0.7150, NULL, NULL, '52900', 'N', 'N', 4410, NULL, '5290', '5290', NULL, '1958', 'S', 1100, 'SANTA ROSA DE GOIÁS', 'N', '521950', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '208', NULL, '03', 'N', NULL, NULL, NULL, 405);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521960', '5206', 'GO', '5203', '5202', '52004', '52', 'SANTA TEREZA DE GOIAS', NULL, '62', '76480000', '5', '9587', '9587', '08194', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 794.553, '-13,71400', '-49,01500', 409, 'S', 0.7290, NULL, NULL, '52900', 'N', 'N', 4423, NULL, '5290', '5290', NULL, '1963', 'S', 1101, 'SANTA TEREZA DE GOIÁS', 'N', '521960', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '209', NULL, '03', 'N', NULL, NULL, NULL, 406);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521970', '5208', 'GO', '5203', '5202', '52004', '52', 'SANTA TEREZINHA DE GOIAS', NULL, '62', '76500000', '4', '9589', '9589', '08195', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1202.195, '-14,43800', '-49,70600', 353, 'S', 0.7210, NULL, NULL, '52900', 'N', 'N', 4429, NULL, '5290', '5290', NULL, '1963', 'S', 1102, 'SANTA TEREZINHA DE GOIÁS', 'N', '521970', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '210', NULL, '03', 'N', NULL, NULL, NULL, 119);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521971', '5213', 'GO', '5204', '5205', '52013', '52', 'SANTO ANTONIO DA BARRA', NULL, '64', '75935000', '2', '0083', '0083', '08308', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 451.596, '-17,56100', '-50,63400', 578, 'S', 0.7460, NULL, NULL, '52900', 'N', 'N', 4482, NULL, '5290', '5290', NULL, '1993', 'S', 1103, 'SANTO ANTÔNIO DA BARRA', 'N', '521971', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '211', NULL, '03', 'N', NULL, NULL, NULL, 120);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521973', '5201', 'GO', '5201', '5203', '52010', '52', 'SANTO ANTONIO DE GOIAS', NULL, '62', '75375000', '8', '0053', '0053', '08294', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 132.803, '-16,48400', '-49,31100', 0, 'S', 0.7490, NULL, NULL, '52900', 'N', 'N', 4486, NULL, '5201', '5290', NULL, '1993', 'S', 1104, 'SANTO ANTÔNIO DE GOIÁS', 'N', '521973', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '212', NULL, '03', 'N', NULL, NULL, NULL, 405);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521975', '5203', 'GO', '5202', '5204', '52012', '52', 'SANTO ANTONIO DO DESCOBERTO', NULL, '61', '72900000', '3', '9677', '9677', '08245', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 938.309, '-15,94000', '-48,25500', 912, 'S', 0.7090, NULL, NULL, '52900', 'N', 'N', 4495, NULL, '5301', '5301', NULL, '1982', 'S', 1105, 'SANTO ANTÔNIO DO DESCOBERTO', 'S', '521975', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '213', NULL, '01', 'N', NULL, NULL, NULL, 118);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521980', '5217', 'GO', '5202', '5204', '52011', '52', 'SAO DOMINGOS', NULL, '62', '73860000', '3', '9591', '9591', '08196', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3295.558, '-13,39800', '-46,31800', 677, 'S', 0.6310, NULL, NULL, '52900', 'S', 'N', 4554, NULL, '5290', '5290', NULL, '1854', 'S', 1106, 'SÃO DOMINGOS', 'N', '521980', 'N', 'N', 'S', NULL, 125, 'S', 'N', 'N', '214', NULL, '03', 'N', NULL, NULL, NULL, 184);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('521990', '5201', 'GO', '5201', '5203', '52007', '52', 'SAO FRANCISCO DE GOIAS', NULL, '62', '75490000', '2', '9593', '9593', '08197', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 339.368, '-15,93100', '-49,26100', 747, 'S', 0.7260, NULL, NULL, '52900', 'N', 'N', 4586, NULL, '5290', '5290', NULL, '1953', 'S', 1107, 'SÃO FRANCISCO DE GOIÁS', 'N', '521990', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '215', NULL, '03', 'N', NULL, NULL, NULL, 405);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522000', '5204', 'GO', '5202', '5202', '52005', '52', 'SAO JOAO D''ALIANCA', NULL, '62', '73760000', '9', '9597', '9597', '08199', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 3327.364, '-14,70600', '-47,52500', 986, 'S', 0.7180, NULL, NULL, '52900', 'N', 'N', 4628, NULL, '5290', '5290', NULL, '1953', 'S', 1109, 'SÃO JOÃO D ALIANÇA', 'N', '522000', 'N', 'N', 'S', NULL, 121, 'N', 'N', 'N', '216', NULL, '03', 'N', NULL, NULL, NULL, 350);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522005', '5212', 'GO', '5201', '5205', '52014', '52', 'SAO JOAO DA PARAUNA', NULL, '64', '75985000', '8', '9747', '9747', '08282', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 305.357, '-16,81500', '-50,41000', 640, 'S', 0.7790, NULL, NULL, '52900', 'N', 'N', 4636, NULL, '5290', '5290', NULL, '1989', 'S', 1108, 'SÃO JOÃO DA PARAÚNA', 'N', '522005', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '217', NULL, '03', 'N', NULL, NULL, NULL, 353);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522010', '5212', 'GO', '5201', '5203', '52009', '52', 'SAO LUIS DE MONTES BELOS', NULL, '64', '76100000', '8', '9599', '9599', '08200', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 826.189, '-16,52500', '-50,37200', 579, 'S', 0.7520, NULL, NULL, '52900', 'N', 'N', 4753, NULL, '5290', '5290', NULL, '1953', 'S', 1110, 'SÃO LUÍS DE MONTES BELOS', 'N', '522010', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '218', NULL, '03', 'N', NULL, NULL, NULL, 353);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522015', '5208', 'GO', '5203', '5203', '52006', '52', 'SAO LUIZ DO NORTE', NULL, '62', '76365000', '7', '9749', '9749', '08283', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 586.060, '-14,86300', '-49,32900', 564, 'S', 0.7100, NULL, NULL, '52900', 'N', 'N', 4760, NULL, '5290', '5290', NULL, '1989', 'S', 1111, 'SÃO LUÍZ DO NORTE', 'N', '522015', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '219', NULL, '03', 'N', NULL, NULL, NULL, 119);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522020', '5206', 'GO', '5203', '5201', '52001', '52', 'SAO MIGUEL DO ARAGUAIA', NULL, '62', '76590000', '7', '9601', '9601', '08201', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 6144.380, '-13,27500', '-50,16300', 337, 'S', 0.7370, NULL, NULL, '52900', 'N', 'N', 4783, NULL, '5290', '5290', NULL, '1958', 'S', 1112, 'SÃO MIGUEL DO ARAGUAIA', 'N', '522020', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '220', NULL, '03', 'N', NULL, NULL, NULL, 406);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522026', '5202', 'GO', '5205', '5205', '52016', '52', 'SAO MIGUEL DO PASSA QUATRO', NULL, '62', '75185000', '4', '9751', '9751', '08284', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 537.781, '-17,05900', '-48,66300', 801, 'S', 0.7670, NULL, NULL, '52900', 'N', 'N', 4788, NULL, '5290', '5290', NULL, '1989', 'S', 1113, 'SÃO MIGUEL DO PASSA QUATRO', 'N', '522026', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '221', NULL, '03', 'N', NULL, NULL, NULL, 60);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522028', '5208', 'GO', '5203', '5203', '52006', '52', 'SAO PATRICIO', NULL, '62', '76343000', '0', '1064', NULL, '08321', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 134.518, '-15,35000', '-49,81800', 560, 'S', 0.7280, NULL, NULL, '52900', 'N', 'N', 4794, NULL, '5290', '5290', NULL, '1997', 'S', 1114, 'SÃO PATRÍCIO', 'N', '522028', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '222', NULL, '03', 'N', NULL, NULL, NULL, 119);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522040', '5213', 'GO', '5204', '5205', '52018', '52', 'SAO SIMAO', NULL, '64', '75890000', '5', '9605', '9605', '08203', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 414.055, '-18,99100', '-50,54400', 367, 'S', 0.7540, NULL, NULL, '52900', 'N', 'N', 4849, NULL, '5290', '5290', NULL, '1958', 'S', 1115, 'SÃO SIMÃO', 'N', '522040', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '223', NULL, '03', 'N', NULL, NULL, NULL, 120);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522045', '5202', 'GO', '5205', '5203', '52010', '52', 'SENADOR CANEDO', NULL, '62', '75250000', '4', '9753', '9753', '08286', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 244.745, '-16,70800', '-49,09300', 801, 'S', 0.7290, NULL, NULL, '52900', 'N', 'N', 4905, NULL, '5201', '5201', NULL, '1989', 'S', 1116, 'SENADOR CANEDO', 'N', '522045', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '224', NULL, '01', 'N', NULL, NULL, NULL, 60);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522050', '5214', 'GO', '5204', '5205', '52013', '52', 'SERRANOPOLIS', NULL, '64', '75820000', '4', '9607', '9607', '08204', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 5526.526, '-18,30600', '-51,96200', 742, 'S', 0.7420, NULL, NULL, '52900', 'N', 'N', 4957, NULL, '5290', '5290', NULL, '1958', 'S', 1117, 'SERRANÓPOLIS', 'N', '522050', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '225', NULL, '03', 'N', NULL, NULL, NULL, 185);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522060', '5202', 'GO', '5205', '5205', '52016', '52', 'SILVANIA', NULL, '62', '75180000', '3', '9609', '9609', '08205', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2264.769, '-16,65900', '-48,60800', 898, 'S', 0.7740, NULL, NULL, '52900', 'N', 'N', 4987, NULL, '5290', '5290', NULL, '1833', 'S', 1118, 'SILVÂNIA', 'N', '522060', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '226', NULL, '03', 'N', NULL, NULL, NULL, 60);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522068', '5217', 'GO', '5202', '5204', '52011', '52', 'SIMOLANDIA', NULL, '62', '73930000', '6', '9755', '9755', '08287', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 347.823, '-14,47400', '-46,48300', 500, 'S', 0.6570, NULL, NULL, '52900', 'S', 'N', 4998, NULL, '5290', '5290', NULL, '1989', 'S', 1119, 'SIMOLÂNDIA', 'N', '522068', 'N', 'N', 'S', NULL, 125, 'N', 'N', 'N', '227', NULL, '03', 'N', NULL, NULL, NULL, 184);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522070', '5217', 'GO', '5202', '5204', '52011', '52', 'SITIO D''ABADIA', NULL, '62', '73990000', '2', '9611', '9611', '08206', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1598.337, '-14,80500', '-46,25300', 748, 'S', 0.6430, NULL, NULL, '52900', 'S', 'N', 5006, NULL, '5290', '5290', NULL, '1850', 'S', 1120, 'SÍTIO D ABADIA', 'N', '522070', 'N', 'N', 'S', NULL, 125, 'N', 'N', 'N', '228', NULL, '03', 'N', NULL, NULL, NULL, 184);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522100', '5201', 'GO', '5201', '5203', '52007', '52', 'TAQUARAL DE GOIAS', NULL, '62', '76640000', '7', '9617', '9617', '08209', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 201.392, '-16,05400', '-49,60600', 769, 'S', 0.7260, NULL, NULL, '52900', 'N', 'N', 5107, NULL, '5290', '5290', NULL, '1963', 'S', 1121, 'TAQUARAL DE GOIÁS', 'N', '522100', 'N', 'N', 'S', NULL, 67, 'N', 'N', 'N', '229', NULL, '03', 'N', NULL, NULL, NULL, 405);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522108', '5205', 'GO', '5202', '5202', '52005', '52', 'TERESINA DE GOIAS', NULL, '62', '73795000', '0', '9759', '9759', '08289', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 774.635, '-13,77600', '-47,26500', 754, 'S', 0.6720, NULL, NULL, '52900', 'S', 'N', 5150, NULL, '5290', '5290', NULL, '1989', 'S', 1122, 'TERESINA DE GOIÁS', 'N', '522108', 'N', 'N', 'S', NULL, 121, 'N', 'N', 'N', '230', NULL, '03', 'N', NULL, NULL, NULL, 183);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522119', '5209', 'GO', '5203', '5203', '52010', '52', 'TEREZOPOLIS DE GOIAS', NULL, '62', '75175000', '7', '0057', '0057', '08304', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 106.976, '-16,39500', '-49,08000', 0, 'S', 0.7070, NULL, NULL, '52900', 'N', 'N', 5153, NULL, '5201', '5290', NULL, '1993', 'S', 1123, 'TEREZÓPOLIS DE GOIÁS', 'N', '522119', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '231', NULL, '03', 'N', NULL, NULL, NULL, 61);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522130', '5216', 'GO', '5205', '5205', '52017', '52', 'TRES RANCHOS', NULL, '64', '75720000', '4', '9623', '9623', '08212', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 282.064, '-18,35400', '-47,78300', 687, 'S', 0.7880, NULL, NULL, '52900', 'N', 'N', 5231, NULL, '5290', '5290', NULL, '1953', 'S', 1124, 'TRÊS RANCHOS', 'N', '522130', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '232', NULL, '03', 'N', NULL, NULL, NULL, 351);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522140', '5201', 'GO', '5201', '5203', '52010', '52', 'TRINDADE', NULL, '62', '75380000', '3', '9625', '9625', '08213', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 713.280, '-16,64900', '-49,48900', 756, 'S', 0.7590, NULL, NULL, '52900', 'N', 'N', 5237, NULL, '5201', '5201', NULL, '1943', 'S', 1125, 'TRINDADE', 'N', '522140', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '233', NULL, '01', 'N', NULL, NULL, NULL, 405);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522145', '5206', 'GO', '5203', '5202', '52004', '52', 'TROMBAS', NULL, '62', '76460000', '2', '9761', '9761', '08290', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'S', 'N', NULL, 'N', 799.123, '-13,50900', '-48,74000', 355, 'S', 0.7430, NULL, NULL, '52900', 'N', 'N', 5244, NULL, '5290', '5290', NULL, '1989', 'S', 1126, 'TROMBAS', 'N', '522145', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '234', NULL, '03', 'N', NULL, NULL, NULL, 406);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522150', '5212', 'GO', '5201', '5203', '52009', '52', 'TURVANIA', NULL, '64', '76110000', '2', '9631', '9631', '08216', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 472.346, '-16,61400', '-50,13400', 659, 'S', 0.7360, NULL, NULL, '52900', 'N', 'N', 5278, NULL, '5290', '5290', NULL, '1958', 'S', 1127, 'TURVÂNIA', 'N', '522150', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '235', NULL, '03', 'N', NULL, NULL, NULL, 353);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522155', '5213', 'GO', '5204', '5205', '52014', '52', 'TURVELANDIA', NULL, '64', '75970000', '1', '9765', '9765', '08291', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 934.260, '-17,85300', '-50,30200', 459, 'S', 0.6850, NULL, NULL, '52900', 'S', 'N', 5279, NULL, '5290', '5290', NULL, '1989', 'S', 1128, 'TURVELÂNDIA', 'N', '522155', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '236', NULL, '03', 'N', NULL, NULL, NULL, 120);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522157', '5208', 'GO', '5203', '5201', '52001', '52', 'UIRAPURU', NULL, '62', '76525000', '7', '0059', '0059', '08310', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1153.472, '-14,28500', '-49,92200', 0, 'S', 0.6620, NULL, NULL, '52900', 'S', 'N', 5303, NULL, '5290', '5290', NULL, '1993', 'S', 1129, 'UIRAPURU', 'N', '522157', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '237', NULL, '03', 'N', NULL, NULL, NULL, 119);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522160', '5207', 'GO', '5203', '5202', '52004', '52', 'URUACU', NULL, '62', '76400000', '1', '9633', '9633', '08217', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2141.776, '-14,52500', '-49,14100', 520, 'S', 0.7380, NULL, NULL, '52900', 'N', 'N', 5332, NULL, '5290', '5290', NULL, '1931', 'S', 1130, 'URUAÇU', 'N', '522160', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '238', NULL, '03', 'N', NULL, NULL, NULL, 9);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522170', '5208', 'GO', '5203', '5203', '52006', '52', 'URUANA', NULL, '62', '76335000', '0', '9635', '9635', '08218', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 522.127, '-15,49800', '-49,68800', 586, 'S', 0.7580, NULL, NULL, '52900', 'N', 'N', 5333, NULL, '5290', '5290', NULL, '1948', 'S', 1131, 'URUANA', 'N', '522170', 'N', 'N', 'S', NULL, 67, 'N', 'N', 'N', '239', NULL, '03', 'N', NULL, NULL, NULL, 119);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522180', '5216', 'GO', '5205', '5205', '52016', '52', 'URUTAI', NULL, '64', '75790000', '9', '9637', '9637', '08219', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 626.717, '-17,46400', '-48,20300', 807, 'S', 0.7600, NULL, NULL, '52900', 'N', 'N', 5350, NULL, '5290', '5290', NULL, '1947', 'S', 1132, 'URUTAÍ', 'N', '522180', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '240', NULL, '03', 'N', NULL, NULL, NULL, 351);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522185', '5203', 'GO', '5202', '5204', '52012', '52', 'VALPARAISO DE GOIAS', NULL, '61', '72870000', '8', '1066', '1066', '08322', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 60.111, '-16,06600', '-47,97900', 1080, 'S', 0.7950, NULL, NULL, '52900', 'N', 'N', 5365, NULL, '5301', '5301', NULL, '1997', 'S', 1133, 'VALPARAÍSO DE GOIÁS', 'S', '522185', 'N', 'N', 'S', NULL, NULL, 'S', 'N', 'N', '241', NULL, '01', 'N', NULL, NULL, NULL, 118);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522190', '5202', 'GO', '5205', '5205', '52014', '52', 'VARJAO', NULL, '62', '75355000', '8', '9639', '9639', '08220', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 519.029, '-17,04500', '-49,63100', 609, 'S', 0.7290, NULL, NULL, '52900', 'N', 'N', 5379, NULL, '5290', '5290', NULL, '1958', 'S', 1134, 'VARJÃO', 'N', '522190', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '242', NULL, '03', 'N', NULL, NULL, NULL, 60);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522220', '5204', 'GO', '5202', '5204', '52012', '52', 'VILA BOA', NULL, '62', '73825000', '3', '0067', '0067', '08313', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1060.170, '-15,03800', '-47,05900', 0, 'S', 0.6740, NULL, NULL, '52900', 'S', 'N', 5443, NULL, '5301', '5301', NULL, '1993', 'S', 1137, 'VILA BOA', 'S', '522220', 'N', 'N', 'S', NULL, 38, 'N', 'N', 'N', '245', NULL, '01', 'N', NULL, NULL, NULL, 350);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('522230', '5208', 'GO', '5203', '5204', '52012', '52', 'VILA PROPICIO', NULL, '62', '76393000', '2', '1068', NULL, '08323', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 2181.575, '-15,45700', '-48,88900', 744, 'S', 0.6740, NULL, NULL, '52900', 'S', 'N', 5453, NULL, '5290', '5290', NULL, '1997', 'S', 1138, 'VILA PROPÍCIO', 'N', '522230', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '246', NULL, '03', 'N', NULL, NULL, NULL, 519);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('530010', '5301', 'DF', '5301', '5301', '53001', '53', 'BRASILIA', NULL, '61', '70000000', '8', '9701', '9701', '23001', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'S', 'N', 'N', 'S', 'N', 'S', NULL, 'S', 5801.937, '-15,78000', '-47,93000', 1171, 'S', 0.8440, NULL, NULL, '53001', 'N', 'N', 743, NULL, '5301', '5301', NULL, '1960', 'S', 801, 'BRASÍLIA', 'N', '530010', 'N', 'N', 'S', NULL, 38, 'S', 'S', 'N', '1', NULL, '01', 'N', NULL, NULL, NULL, 440);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('353080', '3514', 'SP', '3515', '3507', '35031', '35', 'MOGI MIRIM', NULL, '19', '13800000', '5', '6717', '6717', '21309', NULL, 'ATIVO', 'N', 'N', NULL, 'MOJI-MIRIM                ', 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 499.115, '-22,43200', '-46,95800', 632, 'S', 0.8250, NULL, NULL, '35141', 'N', 'N', 3072, NULL, '3590', '3509', NULL, '1769', 'S', 5089, 'MOGI MIRIM', 'N', '353080', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '348', NULL, '02', 'N', NULL, NULL, NULL, 432);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('311750', '3109', 'MG', '3103', '3107', '31028', '31', 'CONCEICAO DO MATO DENTRO', NULL, '31', '35860000', '4', '4349', '4349', '11175', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 1671.465, '-19,03700', '-43,42500', 701, 'S', 0.6720, NULL, NULL, '31025', 'S', 'N', 1324, NULL, '3190', '3190', NULL, '1840', 'S', 1548, 'CONCEIÇÃO DO MATO DENTRO', 'N', '311750', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '193', NULL, '03', 'N', NULL, NULL, NULL, 245);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('316200', '3111', 'MG', '3101', '3110', '31053', '31', 'SAO GONCALO DO SAPUCAI', NULL, '35', '37490000', '5', '5239', '5239', '11620', NULL, 'ATIVO', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', 517.974, '-21,89200', '-45,59500', 868, 'S', 0.7690, NULL, NULL, '31012', 'N', 'N', 4618, NULL, '3190', '3190', NULL, '1878', 'S', 2079, 'SÃO GONÇALO DO SAPUCAÍ', 'N', '316200', 'N', 'N', 'S', NULL, NULL, 'N', 'N', 'N', '724', NULL, '03', 'N', NULL, NULL, NULL, 59);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539936', '5301', 'DF', '5301', '5301', '53001', '53', 'FERCAL', NULL, '61', NULL, NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, NULL, 'S', NULL, NULL, NULL, '53001', 'N', 'N', NULL, NULL, '5301', '5301', NULL, NULL, 'N', NULL, 'FERCAL', 'N', NULL, 'N', 'N', NULL, NULL, NULL, 'N', 'N', NULL, 'N', NULL, NULL, 'N', 'N', 'N', '2018-07-10', NULL);
INSERT INTO "dbgeral"."tb_municipio" VALUES ('539937', '5301', 'DF', '5301', '5301', '53001', '53', 'PLANO PILOTO', NULL, '61', NULL, NULL, NULL, NULL, NULL, NULL, 'REG ADM', 'N', 'N', NULL, NULL, 'N', 'N', 'N', 'N', 'N', 'N', NULL, 'N', NULL, NULL, NULL, NULL, 'S', NULL, NULL, NULL, '53001', 'N', 'N', NULL, NULL, '5301', '5301', NULL, NULL, 'N', NULL, 'PLANO PILOTO', 'N', NULL, 'N', 'N', NULL, NULL, NULL, 'N', 'N', NULL, 'N', NULL, NULL, 'N', 'N', 'N', '2018-07-10', NULL);

-- ----------------------------
-- Table structure for tb_pais
-- ----------------------------
DROP TABLE IF EXISTS "dbgeral"."tb_pais";
CREATE TABLE "dbgeral"."tb_pais" (
  "co_seq_pais" numeric(3,0) NOT NULL,
  "no_pais" varchar(70) COLLATE "pg_catalog"."default" NOT NULL,
  "co_grupo_pais" numeric(6,0),
  "ds_nacionalidade" varchar(50) COLLATE "pg_catalog"."default",
  "co_pais_siape" varchar(3) COLLATE "pg_catalog"."default",
  "st_registro_ativo" varchar(1) COLLATE "pg_catalog"."default" DEFAULT 'S'::character varying,
  "sg_moeda" varchar(10) COLLATE "pg_catalog"."default",
  "ds_moeda" varchar(50) COLLATE "pg_catalog"."default",
  "co_pais_siafi" varchar(3) COLLATE "pg_catalog"."default",
  "sg_pais" varchar(3) COLLATE "pg_catalog"."default",
  "co_continente" numeric(1,0),
  "st_america_latina" varchar(1) COLLATE "pg_catalog"."default",
  "st_mercosul" varchar(1) COLLATE "pg_catalog"."default",
  "co_pais_cef" varchar(3) COLLATE "pg_catalog"."default",
  "co_seq_antigo" numeric(6,0),
  "co_pais_svs" numeric(3,0),
  "co_cidade_capital" numeric(6,0),
  "no_pais_ingles" varchar(70) COLLATE "pg_catalog"."default",
  "no_pais_frances" varchar(70) COLLATE "pg_catalog"."default",
  "co_pais_bancocentral" numeric(4,0),
  "st_uniao_europeia" varchar(1) COLLATE "pg_catalog"."default" DEFAULT 'N'::character varying,
  "sg_internet" varchar(3) COLLATE "pg_catalog"."default",
  "sg_pais_iso3166" varchar(2) COLLATE "pg_catalog"."default",
  "no_pais_ingles_onu" varchar(70) COLLATE "pg_catalog"."default",
  "no_pais_frances_onu" varchar(70) COLLATE "pg_catalog"."default",
  "no_pais_espanhol_onu" varchar(70) COLLATE "pg_catalog"."default",
  "co_pais_onu" varchar(3) COLLATE "pg_catalog"."default",
  "nu_ddi_pais" varchar(3) COLLATE "pg_catalog"."default",
  "co_pais_cadsus" varchar(3) COLLATE "pg_catalog"."default",
  "co_nacionalidade" numeric(2,0),
  "dt_manutencao" date,
  "sg_pais_iso3166_3" varchar(3) COLLATE "pg_catalog"."default"
)
;
COMMENT ON COLUMN "dbgeral"."tb_pais"."co_seq_pais" IS 'Sequencial de identificação do País.';
COMMENT ON COLUMN "dbgeral"."tb_pais"."no_pais" IS 'Nome do País.';
COMMENT ON COLUMN "dbgeral"."tb_pais"."co_grupo_pais" IS 'Código sequencial do grupo dos países. Chave estrangeira com origem em TB_GRUPO_PAIS.';
COMMENT ON COLUMN "dbgeral"."tb_pais"."ds_nacionalidade" IS 'IdentificaÆo da nacionalidade dos nascidos no pa¡s. Gent¡lico';
COMMENT ON COLUMN "dbgeral"."tb_pais"."co_pais_siape" IS 'Código do país no SIAPE.';
COMMENT ON COLUMN "dbgeral"."tb_pais"."st_registro_ativo" IS 'Indica se o registro encontra_se ativo
S = SIM
N = NÃO';
COMMENT ON COLUMN "dbgeral"."tb_pais"."sg_moeda" IS 'Cifra da moeda oficial do país.';
COMMENT ON COLUMN "dbgeral"."tb_pais"."ds_moeda" IS 'Moeda oficial do país.';
COMMENT ON COLUMN "dbgeral"."tb_pais"."co_pais_siafi" IS 'Código do país no SIAFI.';
COMMENT ON COLUMN "dbgeral"."tb_pais"."sg_pais" IS 'Sigla do país, pela codificação ISO 3166-1 alpha-3.';
COMMENT ON COLUMN "dbgeral"."tb_pais"."co_continente" IS 'Código sequencial do continente. Chave estrangeira com origem em TB_CONTINENTE.';
COMMENT ON COLUMN "dbgeral"."tb_pais"."st_america_latina" IS 'Informa se o país pertence a América Latina.';
COMMENT ON COLUMN "dbgeral"."tb_pais"."st_mercosul" IS 'Informa se o país pertence ao Mercosul (Mercado Comum do Cone Sul) (Membro, Convidado, Não pertence).';
COMMENT ON COLUMN "dbgeral"."tb_pais"."co_pais_cef" IS 'Código do país na Caixa Econômica.';
COMMENT ON COLUMN "dbgeral"."tb_pais"."co_seq_antigo" IS 'Código sequencial de país referente a esse registro na DBGERAL do banco MSDF.';
COMMENT ON COLUMN "dbgeral"."tb_pais"."co_pais_svs" IS 'Código do País conforme a tabela utilizada pela SVS.';
COMMENT ON COLUMN "dbgeral"."tb_pais"."co_cidade_capital" IS 'Sequencial de identificação da cidade que é capital do país.';
COMMENT ON COLUMN "dbgeral"."tb_pais"."no_pais_ingles" IS 'Nome do país na língua inglesa, fonte ECT';
COMMENT ON COLUMN "dbgeral"."tb_pais"."no_pais_frances" IS 'Nome do país na língua francesa, fonte ECT';
COMMENT ON COLUMN "dbgeral"."tb_pais"."co_pais_bancocentral" IS 'Código do país no cadastro do Banco Central do Brasil';
COMMENT ON COLUMN "dbgeral"."tb_pais"."st_uniao_europeia" IS 'Identifica se o pa¡s pertence  UniÆo Europia.';
COMMENT ON COLUMN "dbgeral"."tb_pais"."sg_internet" IS 'Sigla de identificaÆo dos pa¡ses nos endereos web ccTLD (Country Code Top-Level Domain).';
COMMENT ON COLUMN "dbgeral"."tb_pais"."sg_pais_iso3166" IS 'Sigla do país, pela codificação ISO 3166-1 alpha-2.';
COMMENT ON COLUMN "dbgeral"."tb_pais"."no_pais_ingles_onu" IS 'Nome do pa¡s, curto, em ingls. Pela ISO 3166-1';
COMMENT ON COLUMN "dbgeral"."tb_pais"."no_pais_frances_onu" IS 'Nome do pa¡s, curto, em francs. Pela ISO 3166-1';
COMMENT ON COLUMN "dbgeral"."tb_pais"."no_pais_espanhol_onu" IS 'Nome do pa¡s, curto, em espanhol. Pela ISO 3166-1';
COMMENT ON COLUMN "dbgeral"."tb_pais"."co_pais_onu" IS 'C¢digo do Pa¡s pela ONU';
COMMENT ON COLUMN "dbgeral"."tb_pais"."nu_ddi_pais" IS 'Código DDI do País - Fonte EMBRATEL.';
COMMENT ON COLUMN "dbgeral"."tb_pais"."co_pais_cadsus" IS 'Código do País no CADSUS';
COMMENT ON COLUMN "dbgeral"."tb_pais"."co_nacionalidade" IS 'Código da Nacionalidade pelo sistema SIH/SUS, atendendo a Portaria nº 409 de 05 de agosto de 1999. Criado em 05/09/2013';
COMMENT ON COLUMN "dbgeral"."tb_pais"."dt_manutencao" IS 'O campo armazena a data da manutenção do registro. Criado em 22/11/2013';
COMMENT ON COLUMN "dbgeral"."tb_pais"."sg_pais_iso3166_3" IS 'Sigla do País, pela codificação ISO 3166-3, 
conforme os sites: 
http://userpage.chemie.fu-berlin.de/diverse/doc/ISO_3166.html
http://www.nationsonline.org/oneworld/country_code_list.htm .';
COMMENT ON TABLE "dbgeral"."tb_pais" IS 'Contém informações sobre países.';

-- ----------------------------
-- Records of tb_pais
-- ----------------------------
INSERT INTO "dbgeral"."tb_pais" VALUES (157, 'EMIRADOS ARABES UNIDOS', 4, '', '052', 'S', 'AED', 'DIRHAM DOS EMIRADOS', '', 'ARE', 3, 'N', 'N', '', 98, NULL, 293, 'UNITED ARAB EMIRATES', 'EMIRATS ARABES UNIS', 2445, 'N', '.ae', 'AE', 'UNITED ARAB EMIRATES', 'ÉMIRATS ARABES UNIS', 'EMIRATOS ÁRABES UNIDOS (LOS)', '784', '971', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (125, 'PAQUISTÃO', 2, 'PAQUISTANESA', '125', 'S', 'PKR', 'PAKISTANI RUPEES', '', 'PAK', 3, 'N', 'N', '', 66, NULL, 271, 'PAKISTAN', 'PAKISTAN', 5762, 'N', '.pk', 'PK', 'PAKISTAN', 'PAKISTAN', 'PAKISTÁN (EL)', '586', '92', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (50, 'SIRIA, REPUBLICA ARABE DA', 3, 'SIRIA', '144', 'S', 'SYP', 'LIBRA SIRIA', '', 'SYR', 3, 'N', 'N', '', 187, NULL, 215, 'SYRIAN ARAB REPUBLIC', 'SYRIENNE', 7447, 'N', '.sy', 'SY', 'SYRIAN ARAB REPUBLIC', 'RÉPUBLIQUE ARABE SYRIENNE (LA)', 'REPÚBLICA ÁRABE SIRIA', '760', '963', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (27, 'SANTA LUCIA', 3, 'SANTA-LUCENSE', '137', 'S', 'XCD', 'DOLAR', '', 'LCA', 1, 'N', 'N', '', 164, NULL, 203, 'SAINT LUCIA', 'SAINTE-LUCIE', 7153, 'N', '.lc', 'LC', 'SAINT LUCIA', 'SAINTE-LUCIE', 'SANTA LUCÍA', '662', '1', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (33, 'BRUNEI', 4, 'BRUNEIANA', '025', 'S', 'BND', 'DOLAR', '', 'BRN', 3, 'N', 'N', '', 170, NULL, 206, 'BRUNEI DARUSSALAM', 'BRUNEI DARUSSALAM', 1082, 'N', '.bn', 'BN', 'BRUNEI DARUSSALAM', 'BRUNÉI DARUSSALAM', 'BRUNEI DARUSSALAM', '96', '673', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (58, 'GUADALUPE', 4, 'GUADALUPENSE', '179', 'S', 'EUR', 'EURO', '', 'GLP', 1, 'N', 'N', '', 195, NULL, 386, 'GUADELOUPE', 'GUADELOUPE', 3093, 'N', '.gp', 'GP', 'GUADELOUPE', 'GUADELOUPE', '', '312', '590', NULL, NULL, '2013-12-05', 'GLP');
INSERT INTO "dbgeral"."tb_pais" VALUES (61, 'BUTAO', 2, 'BUTANESA', '029', 'S', 'BTN', 'DZONGKHA', '', 'BTN', 3, 'N', 'N', '', 2, NULL, 223, 'BHUTAN', 'BHOUTAN', 1198, 'N', '.bt', 'BT', 'BHUTAN', 'BHOUTAN', 'BHUTÁN', '64', '975', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (94, 'BIELORUSSIA', 3, 'BIELORUSSO', '229', 'S', 'BYB', 'RUBLO BIELORUSSO', '', 'BLR', 4, 'N', 'N', '', 35, NULL, 250, 'BELARUS', 'BÉLARUS', 850, 'N', '.by', 'BY', 'BELARUS', 'BÉLARUS', 'BELARÚS', '112', '375', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (478, 'PHOENIX', NULL, '', '', 'N', '', '', '', 'USA', NULL, 'N', 'N', '', 182, NULL, NULL, '', '', NULL, 'N', '', '', '', '', '', '', NULL, NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (136, 'TURQUIA', 3, '', '159', 'S', 'TRY', 'LIRA TURCA', '', 'TUR', 3, 'N', 'N', '', 77, NULL, 278, 'TURKEY', 'TURQUIE', 8273, 'N', '.tr', 'TR', 'TURKEY', 'TURQUIE', 'TURQUÍA', '792', '90', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (97, 'CATAR', 4, 'CATARIANA', '034', 'S', 'QR', 'RIYAL CATARI', '', 'QAT', 3, 'N', 'N', '', 38, NULL, 91, 'QATAR', 'QATAR', 1546, 'N', '.qa', 'QA', 'QATAR', 'QATAR', 'QATAR', '634', '974', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (481, 'MAN, ILHA DE', NULL, 'MANES', '', 'S', 'GBP', 'LIBRA MANESA', '', 'IMN', NULL, 'N', 'N', '', NULL, NULL, NULL, 'ISLE OF MAN', 'ÎLE DE MAN', 3595, 'N', '.im', 'IM', 'ISLE OF MAN', 'ILE DE MAN', 'ISLA DE MAN', '833', NULL, NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (48, 'ROMÊNIA', 3, 'ROMENA', '133', 'S', 'ROL', 'LEU', '', 'ROM', 4, 'N', 'N', '', 185, NULL, 213, 'ROMANIA', 'ROUMANIE', 6700, 'N', '.ro', 'RO', 'ROMANIA', 'ROUMANIE', 'RUMANIA', '642', '40', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (155, 'CROACIA', 3, '', '242', 'S', 'HRK', 'KUNA', '', 'HRV', 4, 'N', 'N', '', 96, NULL, 292, 'CROATIA', 'CROATIE', 1953, 'N', '.hr', 'HR', 'CROATIA', 'CROATIE', 'CROACIA', '191', '385', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (237, 'POLINÉSIA FRANCESA', NULL, 'FRANCO-POLINESIA', '', 'S', 'XPF', 'FRANCO DO PACIFICO', '', 'PYF', 5, 'N', 'N', '', NULL, NULL, 379, 'FRENCH POLYNESIA', 'POLYNÉSIE FRANÇAISE', 5991, 'N', '.pf', 'PF', 'FRENCH POLYNESIA', 'POLYNÉSIE FRANÇAISE', '', '258', '689', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (101, 'DOMINICA', 2, 'DOMINICANA / DOMINIQUENSE', '049', 'S', 'XCD', 'DOLAR DAS CARAIBAS ORIENTAIS', '', 'DMA', 1, 'N', 'N', '', 42, NULL, 253, 'DOMINICA', 'DOMINIQUE', 2356, 'N', '.dm', 'DM', 'DOMINICA', 'DOMINIQUE', 'DOMINICA', '212', '1', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (160, 'FINLANDIA', 4, 'FINLANDESA', '059', 'S', 'EUR', 'EURO', '', 'FIN', 4, 'N', 'N', '', 101, NULL, 108, 'FINLAND', 'FINLANDE', 2712, 'N', '.fi', 'FI', 'FINLAND', 'FINLANDE', 'FINLANDIA', '246', '358', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (104, 'ESLOVAQUIA', 3, 'ESLOVACA', '230', 'S', 'SKK', 'COROA ESLOVACA', '', 'SVK', 4, 'N', 'N', '', 45, NULL, 255, 'SLOVAKIA', 'SLOVAQUIE', 2470, 'N', '.sk', 'SK', 'SLOVAKIA', 'SLOVAQUIE', 'ESLOVAQUIA', '703', '421', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (479, 'MIANMAR, UNIÃO DE (BIRMÂNIA)', 2, 'BIRMANÊS-BIRMÃ-MIANMARENSE', '', 'S', 'MMK', 'QUIAT', '', 'MMR', 3, 'N', 'N', '', 3, NULL, 224, 'BURMA (MYANMAR)', 'MYANMAR (BIRMANIE)', 930, 'N', '.mm', 'MM', 'MYANMAR', 'MYANMAR (LE)', 'MYANMAR', '104', '95', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (49, 'RUSSIA, FEDERAÇÃO DA', 4, 'RUSSA', '256', 'S', 'RUR', 'RUBLO', '', 'RUS', 4, 'N', 'N', '', 186, NULL, 214, 'RUSSIAN FEDERATION', 'FÉDÉRATION DE RUSSIE', 6769, 'N', '.ru', 'RU', 'RUSSIAN FEDERATION', 'RUSSIE, FÉDÉRATION DE', 'FEDERACIÓN DE RUSIA (LA)', '643', '7', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (138, 'VENEZUELA', 3, 'VENEZUELANA', '166', 'S', 'VEF', 'BOLIVAR VENEZUELANO', '', 'VEN', 1, 'S', 'S', '', 79, NULL, 46, 'VENEZUELA', 'VÉNÉZUÉLA', 8508, 'N', '.ve', 'VE', 'VENEZUELA (BOLIVARIAN REPUBLIC OF)', 'VENEZUELA (RÉPUBLIQUE BOLIVARIENNE DU)', 'VENEZUELA', '862', '58', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (142, 'ARMENIA, REPUBLICA DA', 2, 'ARMENA', '239', 'S', 'AMD', 'DRAM', '', 'ARM', 3, 'N', 'N', '', 83, NULL, 281, 'ARMENIA', 'ARMÉNIE', 647, 'N', '.am', 'AM', 'ARMENIA', 'ARMÉNIE', 'ARMENIA', '51', '374', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (31, 'ANGOLA', 3, 'ANGOLENSE', '007', 'S', 'AOA', 'KWANZA', '', 'AGO', 2, 'N', 'N', '', 168, NULL, 2, 'ANGOLA', 'ANGOLA', 400, 'N', '.ao', 'AO', 'ANGOLA', 'ANGOLA', 'ANGOLA', '24', '244', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (140, 'AFRICA DO SUL', 3, 'SUL AFRICANA', '002', 'S', 'ZAR', 'RAND', '', 'ZAF', 2, 'N', 'N', '', 81, NULL, 111, 'SOUTH AFRICA', 'AFRIQUE DU SUD', 7560, 'N', '.za', 'ZA', 'SOUTH AFRICA', 'AFRIQUE DU SUD', 'SUDÁFRICA', '', '27', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (30, 'UZBEQUISTAO', 3, 'UZBEQUE', '268', 'S', 'UZS', 'SOM UZBEQUE', '', 'UZB', 3, 'N', 'N', '', 167, NULL, 205, 'UZBEKISTAN', 'OUZBÉKISTAN', 8478, 'N', '.uz', 'UZ', 'UZBEKISTAN', 'OUZBÉKISTAN', 'UZBEKISTÁN', '860', '998', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (133, 'SENEGAL', 3, '', '141', 'S', 'XOF', 'CFA FRANC', '', 'SEN', 2, 'N', 'N', '', 74, NULL, 77, 'SENEGAL', 'SÉNÉGAL', 7285, 'N', '.sn', 'SN', 'SENEGAL', 'SÉNÉGAL', 'SENEGAL (EL)', '686', '221', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (13, 'CAMBOJA', 3, 'CAMBOJANA', '032', 'S', 'KHR', 'RIEL', '', 'KHM', 3, 'N', 'N', '', 150, NULL, 194, 'CAMBODIA', 'CAMBODGE', 1414, 'N', '.kh', 'KH', 'CAMBODIA', 'CAMBODGE', 'CAMBOYA', '116', '855', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (112, 'GUINE-BISSAU', 3, 'GUINEENSE', '071', 'S', 'GWP', 'PESO', '', 'GNB', 2, 'N', 'N', '', 53, NULL, 261, 'GUINEA-BISSAU', 'GUINÉE-BISSAU', 3344, 'N', '.gw', 'GW', 'GUINEA-BISSAU', 'GUINÉE-BISSAU', 'GUINEA-BISSAU', '624', '245', NULL, NULL, '2013-12-05', 'GNB');
INSERT INTO "dbgeral"."tb_pais" VALUES (225, 'ILHAS PITCAIRN', NULL, 'PITCAIRNES', '', 'S', 'NZD', 'DOLAR DA NOVA ZELANDIA', '', 'PCN', 5, 'N', 'N', '', NULL, NULL, 367, 'PITCAIRN', 'ILÊS PITCAIRN', 5932, 'N', '.pn', 'PN', 'PITCAIRN', 'PITCAIRN', 'ISLAS PITCAIRN', '612', NULL, NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (115, 'ILHAS MARSHAL', 2, 'MARSHALINA', '232', 'S', 'USD', 'DOLAR AMERICANO', '', 'MHL', 5, 'N', 'N', '', 56, NULL, 263, 'MARSHALL ISLANDS', 'ÎLES MARSHALL', 4766, 'N', '.mh', 'MH', 'MARSHALL ISLANDS', 'MARSHALL, ÎLES', '', '584', '692', NULL, NULL, '2013-12-05', 'MHL');
INSERT INTO "dbgeral"."tb_pais" VALUES (121, 'MAURITANIA', 2, 'MAURITANA', '110', 'S', 'MRO', 'OUGUIYA', '', 'MRT', 2, 'N', 'N', '', 62, NULL, 268, 'MAURITANIA', 'MAURITANIE', 4880, 'N', '.mr', 'MR', 'MAURITANIA', 'MAURITANIE', 'MAURITANIA', '478', '222', NULL, NULL, '2013-12-05', 'MRT');
INSERT INTO "dbgeral"."tb_pais" VALUES (186, 'TAILANDIA', 3, 'TAILANDESA', '152', 'S', 'THB', 'BAHT', '', 'THA', 3, 'N', 'N', '', 127, NULL, 126, 'THAILAND', 'THAÏLANDE', 7765, 'N', '.th', 'TH', 'THAILAND', 'THAÏLANDE', 'TAILANDIA', '764', '66', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (187, 'TAITI', 5, 'TAHITIANO', '246', 'N', '', 'FRANCO DO PACIFICO', '', '', 5, 'N', 'N', '', 128, NULL, 309, '', 'TAHITI', NULL, 'N', '', '', '', 'TAHITI', 'TAHITÍ', '', '689', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (190, 'ZAMBIA', 2, 'ZAMBIANO', '169', 'S', 'ZMK', 'QUACHA', '', 'ZMB', 2, 'N', 'N', '', 131, NULL, 312, 'ZAMBIA', 'ZAMBIE', 8907, 'N', '.zm', 'ZM', 'ZAMBIA', 'ZAMBIE', 'ZAMBIA', '894', '260', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (123, 'NEPAL', 2, 'NEPALESA', '116', 'S', 'NPR', 'NEPALESE RUPEE', '', 'NPL', 3, 'N', 'N', '', 64, NULL, 270, 'NEPAL', 'NÉPAL', 5177, 'N', '.np', 'NP', 'NEPAL', 'NÉPAL', 'NEPAL', '524', '977', NULL, NULL, '2013-12-05', 'NPL');
INSERT INTO "dbgeral"."tb_pais" VALUES (130, 'ILHAS SALOMAO', 2, 'SALOMÔNICA', '', 'S', 'SBD', 'DOLAR', '', 'SLB', 5, 'N', 'N', '', 71, NULL, 273, 'SOLOMON ISLANDS', 'ÎLES SALOMON', 6777, 'N', '.sb', 'SB', 'SOLOMON ISLANDS', 'SALOMON, ÎLES', 'ISLAS SALOMÓN (LAS)', '90', '677', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (196, 'DINAMARCA', 4, 'DINAMARQUESA', '047', 'S', 'DKK', 'COROA', '', 'DNK', 4, 'N', 'N', '', 137, NULL, 49, 'DENMARK', 'DANEMARK', 2321, 'N', '.dk', 'DK', 'DENMARK', 'DANEMARK', 'DINAMARCA', '', '45', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (198, 'TIMOR LESTE', 3, 'TIMORENSE', '219', 'S', 'USD', 'DOLAR AMERICANO', '', 'TMP', 3, 'N', 'N', '', 198, NULL, 100, 'EAST TIMOR', 'TIMOR ORIENTAL', 7951, 'N', '.tl', 'TL', 'TIMOR-LESTE', 'TIMOR-LESTE', 'TIMOR-LESTE', '626', '670', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (206, 'ESCOCIA', 4, 'ESCOCESA', '', 'S', 'GBP', 'LIBRA ESTERLINA', '', '', 4, 'N', 'N', '', 200, NULL, 335, 'SCOTLAND', '', NULL, 'N', '', '', '', '', '', '829', '44', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (207, 'ANGUILLA', NULL, 'ANGUILANA', '', 'S', 'XCD', 'DOLAR DAS CARAIBAS ORIENTAIS', '', 'AIA', 1, 'N', 'N', '', NULL, NULL, 349, 'ANGUILLA', 'ANGUILLA', 418, 'N', '.ai', 'AI', 'ANGUILLA', 'ANGUILLA', '', '660', '1', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (209, 'BERMUDAS', NULL, 'BERMUDIANA', '', 'S', '', 'DOLAR BERMUDIANO', '', 'BMU', 1, 'N', 'N', '', NULL, NULL, 351, 'BERMUDA', 'BERMUDES', 209, 'N', '.bm', 'BM', 'BERMUDA', 'BERMUDES', '', '60', '1', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (217, 'ILHAS DE GUERNSEY', NULL, 'CANALINA', '', 'S', '', 'LIBRA ESTERLINA', '', 'GGY', 4, 'N', 'N', '', NULL, NULL, 359, 'GUERNSEY', 'ÎLES GUERNSEY', 1504, 'N', '.gg', 'GG', 'GUERNSEY', 'GUERNESEY', '', '831', '44', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (218, 'ILHAS DE JERSEY', NULL, 'CANALINA', '', 'S', 'GBP', 'LIBRA DE JERSEY', '', 'JEY', 4, 'N', 'N', '', NULL, NULL, 360, 'JERSEY', 'ÎLES JERSEY', 1508, 'N', '.je', 'JE', 'JERSEY', 'JERSEY', '', '832', '44', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (239, 'SAMOA AMERICANA', NULL, 'SAMOANA', '', 'S', 'USD', 'DOLAR AMERICANO', '', 'ASM', 5, 'N', 'N', '', NULL, NULL, 381, 'AMERICAN SAMOA', 'SAMOA AMÉRICAINES', 6912, 'N', '.as', 'AS', 'AMERICAN SAMOA', 'SAMOA AMÉRICAINES', 'SAMOA', '16', '684', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (204, 'SERVIA E MONTENEGRO', NULL, '', '', 'N', 'CSD', 'DINAR SERVIO/EURO', '', '', 4, 'N', 'N', '', NULL, NULL, 321, 'SERBIA AND MONTENEGRO', 'Serbie-et-Monténégro', NULL, 'N', '', '', 'SERBIA AND MONTENEGRO [SUPERSEDED]', 'Serbie-et-Monténégro (la) [appellation périmée]', 'SERBIA Y MONTENEGRO', '891', '381', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (143, 'AUSTRIA', 4, 'AUSTRIACA', '013', 'S', 'EUR', 'EURO', '', 'AUT', 4, 'N', 'N', '', 84, NULL, 107, 'AUSTRIA', 'AUTRICHE', 728, 'N', '.at', 'AT', 'AUSTRIA', 'AUTRICHE', 'AUSTRIA', '40', '43', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (148, 'BULGARIA, REPUBLICA DA', 3, 'BULGARA', '026', 'S', 'BGN', 'LEV', '', 'BGR', 4, 'N', 'N', '', 89, NULL, 286, 'BULGARIA', 'BULGARIE', 1112, 'N', '.bg', 'BG', 'BULGARIA', 'BULGARIE', 'BULGARIA', '', '359', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (151, 'COLOMBIA', 3, 'COLOMBIANA', '040', 'S', 'COP', 'PESO COLOMBIANO', '', 'COL', 1, 'S', 'N', '', 92, NULL, 42, 'COLOMBIA', 'COLÔMBIE', 1694, 'N', '.co', 'CO', 'COLOMBIA', 'COLOMBIE', 'COLOMBIA', '170', '57', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (191, 'AFEGANISTAO', 2, 'AFEGANISTA', '001', 'S', 'AFA', 'AFEGANS', '', 'AFG', 3, 'N', 'N', '', 132, NULL, 313, 'AFGHANISTAN', 'AFGHANISTAN', 132, 'N', '.af', 'AF', 'FORMER YUGOSLAV REPUBLIC OF MACEDONIA', 'AFGHANISTAN', 'AFGANISTÁN (EL)', '4', '93', NULL, NULL, NULL, 'AFG');
INSERT INTO "dbgeral"."tb_pais" VALUES (210, 'GIBRALTAR', NULL, 'GIBRALTARIANA', '', 'S', 'GIP', 'LIBRA DE GIBRALTAR', '', 'GIB', 4, 'N', 'N', '', NULL, NULL, 352, 'GIBRALTAR', 'GIBRALTAR', 2933, 'N', '.gi', 'GI', 'GIBRALTAR', 'GIBRALTAR', '', '292', '350', NULL, NULL, '2013-12-05', 'GIB');
INSERT INTO "dbgeral"."tb_pais" VALUES (212, 'GUAM', NULL, 'GUAMIANENSE', '', 'S', 'USD', 'DOLAR AMERICANO', '', 'GUM', 5, 'N', 'N', '', NULL, NULL, 354, 'GUAM', 'GUAM', 3131, 'N', '.gu', 'GU', 'GUAM', 'GUAM', '', '316', '1', NULL, NULL, '2013-12-05', 'GUM');
INSERT INTO "dbgeral"."tb_pais" VALUES (156, 'CUBA', 3, 'CUBANA', '046', 'S', 'CUP', 'PESO CUBANO', '', 'CUB', 1, 'N', 'N', '', 97, NULL, 58, 'CUBA', 'CUBA', 1996, 'N', '.cu', 'CU', 'CUBA', 'CUBA', 'CUBA', '192', '53', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (159, 'ETIOPIA', 2, '', '056', 'S', 'ETB', 'BIRR', '', 'ETH', 2, 'N', 'N', '', 100, NULL, 294, 'ETHIOPIA', 'ETHIOPIE', 2534, 'N', '.et', 'ET', 'ETHIOPIA', 'ÉTHIOPIE', 'ETIOPÍA', '231', '251', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (89, 'TONGA', 2, 'TONGALESA  /  TONGANESA', '156', 'S', 'TOP', 'PAANGA', '', 'TON', 5, 'N', 'N', '', 30, NULL, 246, 'TONGA', 'TONGA', 8109, 'N', '.to', 'TO', 'TONGA', 'TONGA', 'TONGA', '776', '676', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (98, 'CHADE', 2, 'CHADIANA', '035', 'S', 'XAF', 'FRANCO', '', 'TCD', 2, 'N', 'N', '', 39, NULL, 251, 'CHAD', 'TCHAD', 7889, 'N', '.td', 'TD', 'CHAD', 'TCHAD', 'CHAD (EL)', '148', '235', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (108, 'GAMBIA', 2, 'GAMBIANA', '063', 'S', 'GMD', 'DALASI', '', 'GMB', 2, 'N', 'N', '', 49, NULL, 258, 'GAMBIA', 'GAMBIE', 2852, 'N', '.gm', 'GM', 'GAMBIA', 'GAMBIE', 'GAMBIA', '270', '220', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (128, 'REPÚBLICA CENTRO-AFRICANA', 2, 'CENTRO-AFRICANA', '131', 'S', 'XAF', 'FRANCO CFA', '', 'CAF', 2, 'N', 'N', '', 69, NULL, 272, 'CENTRAL AFRICAN REPUBLIC', 'CENTRAFRIQUE', 6408, 'N', '.cf', 'CF', 'CENTRAL AFRICAN REPUBLIC', 'CENTRAFRICAINE, RÉPUBLIQUE', 'REPÚBLICA CENTROAFRICANA (LA)', '140', '236', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (132, 'SAN MARINO', 4, 'SAMARINESA', '136', 'S', 'EUR', 'EURO', '', 'SMR', 4, 'N', 'N', '', 73, NULL, 275, 'SAN MARINO', 'SAINT-MARIN', 6971, 'N', '.sm', 'SM', 'SAN MARINO', 'SAINT-MARIN', 'SAN MARINO', '674', '378', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (134, 'SERRA LEOA', 2, 'LEONESA', '142', 'S', 'SLL', 'LEONE', '', 'SLE', 2, 'N', 'N', '', 75, NULL, 276, 'SIERRA LEONE', 'SIERRA LEONE', 7358, 'N', '.sl', 'SL', 'SIERRA LEONE', 'SIERRA LEONE', 'SIERRA LEONA', '694', '232', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (135, 'SRI LANKA', 2, 'CINGALESA', '146', 'S', 'LKR', 'RUPEE', '', 'LKA', 3, 'N', 'N', '', 76, NULL, 277, 'SRI LANKA', 'SRI LANKA', 7501, 'N', '.lk', 'LK', 'SRI LANKA', 'SRI LANKA', 'SRI LANKA', '144', '94', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (144, 'AZERBAIJAO, REPUBLICA DO', 3, 'AZERBAIDJANO', '243', 'S', 'AZM', 'MANAT', '', 'AZE', 3, 'N', 'N', '', 85, NULL, 282, 'AZERBAIJAN', 'AZERBAÏJAN', 736, 'N', '.az', 'AZ', 'AZERBAIJAN', 'AZERBAÏDJAN', 'AZERBAIYÁN', '31', '994', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (145, 'BANGLADESH', 2, 'BENGALESA', '015', 'S', 'BDT', 'TAKA', '', 'BDG', 3, 'N', 'N', '', 86, NULL, 283, 'BANGLADESH', 'BANGLADESH', 817, 'N', '.bd', 'BD', 'BANGLADESH', 'BANGLADESH', 'BANGLADESH', '50', '880', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (146, 'BENIN', 2, 'BENINENSE', '020', 'S', ' XOF', 'FRANCO', '', 'BEN', 2, 'N', 'N', '', 87, NULL, 328, 'BENIN', 'BÉNIN', 2291, 'N', '.bj', 'BJ', 'BENIN', 'BÉNIN', 'BENIN', '204', '229', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (147, 'BOSNIA-HERZEGOVINA, REPUBLICA DA', 3, 'BÓSNIA', '260', 'S', 'BAM', 'MARCO CONVERTIVEL', '', 'BIH', 4, 'N', 'N', '', 88, NULL, 285, 'BOSNIA AND HERZEGOVINA', 'BOSNIE-HERZÉGOVINE', 981, 'N', '.ba', 'BA', 'BOSNIA AND HERZEGOVINA', 'BOSNIE-HERZÉGOVINE', 'BOSNIA Y HERZEGOVINA', '70', '387', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (179, 'OMÃ, SULTANATO', 5, 'OMANES', '122', 'S', 'OMR', 'RIAL OMANI', '', 'OMN', 3, 'N', 'N', '', 120, NULL, 304, 'OMAN', 'SULTANAT D´OMAN', 5568, 'N', '.om', 'OM', 'OMAN', 'OMAN', 'OMÁN', '512', '968', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (149, 'BURKINA FASO', 2, 'BURQUINENSE', '027', 'S', 'XAF', 'FRANCO CFA', '', 'BFA', 2, 'N', 'N', '', 90, NULL, 287, 'BURKINA FASO', 'BURKINA FASO', 310, 'N', '.bf', 'BF', 'BURKINA FASO', 'BURKINA FASO', 'BURKINA FASO', '854', '226', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (150, 'BURUNDI  ', 2, 'BURUNDINESA', '031', 'S', 'FBU', 'FRANCO BURUNDES', '', 'BDI', 2, 'N', 'N', '', 91, NULL, 288, 'BURUNDI', 'BURUNDI', 1155, 'N', '.bi', 'BI', 'BURUNDI', 'BURUNDI', 'BURUNDI', '108', '257', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (85, 'TADJIQUISTAO, REPUBLICA DO', 2, 'TADJIQUE', '258', 'S', 'TJS', 'TAJIKISTANI SOMONI', '', 'TJK', 3, 'N', 'N', '', 26, NULL, 243, 'TAJIKISTAN', 'TADJIKISTAN', 7722, 'N', '.tj', 'TJ', 'TAJIKISTAN', 'TADJIKISTAN', 'TAYIKISTÁN', '762', '992', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (88, 'TOGO', 2, 'TOGOLÊS', '155', 'S', 'XOF', 'FRANCO CFA', '', 'TGO', 2, 'N', 'N', '', 29, NULL, 245, 'TOGO', 'TOGO', 8001, 'N', '.tg', 'TG', 'TOGO', 'TOGO', 'TOGO (EL)', '768', '228', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (152, 'CAMAROES', 2, 'CAMARONESA', '031', 'S', 'XAF', 'FRANCO CFA', '', 'CMR', 2, 'N', 'N', '', 93, NULL, 289, 'CAMEROON', 'CAMEROUN', 1457, 'N', '.cm', 'CM', 'CAMEROON', 'CAMEROUN', 'CAMERÚN (EL)', '120', '237', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (99, 'CHIPRE', 4, '', '038', 'S', 'CYP', 'LIBRA CIPRIOTA', '', 'CYP', 4, 'N', 'N', '', 40, NULL, 252, 'CYPRUS', 'CHYPRE', 1635, 'N', '.cy', 'CY', 'CYPRUS', 'CHYPRE', 'CHIPRE', '196', '357', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (102, 'EGITO', 3, 'EGIPSIA', '050', 'S', 'EGP', 'LIBRA EGIPSIA', '', 'EGY', 2, 'N', 'N', '', 43, NULL, 254, 'EGYPT', 'EGYPTE', 2402, 'N', '.eg', 'EG', 'EGYPT', 'ÉGYPTE', 'EGIPTO', '818', '20', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (107, 'FILIPINAS', 2, '', '058', 'S', 'PHP', 'PESO', '', 'PHL', 3, 'N', 'N', '', 48, NULL, 104, 'PHILIPPINES', 'PHILIPPINES', 2674, 'N', '.ph', 'PH', 'PHILIPPINES', 'PHILIPPINES', 'FILIPINAS', '608', '63', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (153, 'CONGO, REPUBLICA DO (BRAZZAVILLE)', 2, 'CONGOLESA', '041', 'S', 'XAF', 'FRANCO CFA', '', 'COG', 2, 'N', 'N', '', 94, NULL, 290, 'CONGO', 'RÉPUBLIQUE DU CONGO', 1775, 'N', '.cg', 'CG', 'CONGO', 'CONGO', 'CONGO (EL)', '', '242', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (154, 'COSTA DO MARFIM', 2, 'MARFINENSE', '044', 'S', 'FUA', 'FRANCO CFA', '', 'CIV', 2, 'N', 'N', '', 95, NULL, 291, 'CÔTE D''IVOIRE', 'RÉP. CÔTE D''IVOIRE', 1937, 'N', '.ci', 'CI', 'CÔTE D''IVOIRE', 'CÔTE D''IVOIRE', 'CÔTE D''IVOIRE', '', '225', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (124, 'PANAMA', 3, 'PANAMENHA', '123', 'S', 'PAB', 'BALBOA', '', 'PAN', 1, 'S', 'N', '', 65, NULL, 14, 'PANAMA', 'PANAMA', 5800, 'N', '.pa', 'PA', 'PANAMA', 'PANAMA', 'PANAMÁ', '591', '507', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (129, 'REPÚBLICA DOMINICANA', 3, 'DOMINICANA', '132', 'S', 'DOP', 'PESO', '', 'DOM', 1, 'N', 'N', '', 70, NULL, 31, 'DOMINICAN REPUBLIC', 'DOMINICAINE', 6475, 'N', '.do', 'DO', 'DOMINICAN REPUBLIC', 'DOMINICAINE, RÉPUBLIQUE', 'REPÚBLICA DOMINICANA (LA)', '214', '1', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (139, 'ZIMBABUE', 2, 'ZIMBABUENSE', '170', 'S', 'ZWD', 'DOLAR ZIMBABUENSE', '', 'ZWE', 2, 'N', 'N', '', 80, NULL, 279, 'ZIMBABWE', 'ZIMBABWE', 6653, 'N', '.zw', 'ZW', 'ZIMBABWE', 'ZIMBABWE', 'ZIMBABWE', '716', '263', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (141, 'ARABIA SAUDITA', 4, '', '009', 'S', 'SAR', 'RIYAL', '', 'SAU', 3, 'N', 'N', '', 82, NULL, 280, 'SAUDI ARABIA', 'ARABIE SAOUDITE', 531, 'N', '.sa', 'SA', 'SAUDI ARABIA', 'ARABIE SAOUDITE', 'ARABIA SAUDITA (LA)', '682', '966', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (23, 'SUÉCIA', 4, 'SUECA', '149', 'S', 'SEK', 'COROA SUECA (KRONA)', '', 'SWE', 4, 'N', 'N', '', 160, NULL, 200, 'SWEDEN', 'SUÈDE', 7641, 'N', '.se', 'SE', 'SWEDEN', 'SUÈDE (LA)', 'SUECIA', '752', '46', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (162, 'GRECIA', 4, 'GREGA', '067', 'S', 'EUR', 'EURO', '', 'GRC', 4, 'N', 'N', '', 103, NULL, 296, 'GREECE', 'GRÈCE', 3018, 'N', '.gr', 'GR', 'GREECE', 'GRÈCE', 'GRECIA', '300', '30', NULL, NULL, '2013-12-05', 'GRC');
INSERT INTO "dbgeral"."tb_pais" VALUES (24, 'NORUEGA', 4, 'NORUEGUESA', '120', 'S', 'NOK', 'COROA', '', 'NOR', 4, 'N', 'N', '', 161, NULL, 87, 'NORWAY', 'NORVÈGE', 5380, 'N', '.no', 'NO', 'NORWAY', 'NORVÈGE', 'NORUEGA', '578', '47', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (2, 'GABAO', 3, 'BAGAONITA', '062', 'S', 'XAF', 'FRANCO CFA', '', 'GAB', 2, 'N', 'N', '', 139, NULL, 144, 'GABON', 'GABON', 2810, 'N', '.ga', 'GA', 'GABON', 'GABON', 'GABÓN (EL)', '266', '241', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (10, 'TURCOMENISTAO, REPUBLICA DO', 3, 'TURCOMANA', '250', 'S', '', 'MANAT TURCOMANO', '', 'TKM', 3, 'N', 'N', '', 147, NULL, 192, 'TURKMENISTAN', 'TURKMÉNISTAN', 8249, 'N', '.tm', 'TM', 'TURKMENISTAN', 'TURKMÉNISTAN', 'TURKMENISTÁN', '795', '993', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (18, 'ISLANDIA', 3, 'ISLANDÊS', '086', 'S', 'KR', 'KRONA', '', 'ISL', 4, 'N', 'N', '', 155, NULL, 198, 'ICELAND', 'ISLANDE', 3794, 'N', '.is', 'IS', 'ICELAND', 'ISLANDE', 'ISLANDIA', '352', '354', NULL, NULL, '2013-12-05', 'ISL');
INSERT INTO "dbgeral"."tb_pais" VALUES (26, 'REPÚBLICA TCHECA', 4, 'TCHECA', '267', 'S', 'CZK', 'COROA TCHECA', '', 'CZE', 4, 'N', 'N', '', 163, NULL, 202, 'CZECH REPUBLIC', 'TCHÈQUE', 7919, 'N', '.cz', 'CZ', 'CZECH REPUBLIC', 'TCHÈQUE, RÉPUBLIQUE', 'REPÚBLICA CHECA (LA)', '203', '420', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (39, 'UCRANIA', 3, 'UCRANIANA', '221', 'S', 'UAH', 'HRYVNIA', '', 'UKR', 4, 'N', 'N', '', 176, NULL, 210, 'UKRAINE', 'UKRAINE', 8311, 'N', '.ua', 'UA', 'UKRAINE', 'UKRAINE', 'UCRANIA', '804', '380', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (42, 'ANTIGUA E BARBUDA', 3, 'ANTIGUANA', '008', 'S', '', 'DOLAR CARIBENHO', '', 'ATG', 1, 'N', 'N', '', 179, NULL, 211, 'ANTIGUA AND BARBUDA', 'ANTIGUA-ET-BARBUDA', 434, 'N', '.ag', 'AG', 'ANTIGUA AND BARBUDA', 'ANTIGUA-ET-BARBUDA', 'ANTIGUA Y BARBUDA', '28', '1', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (60, 'DJIBUTI', 3, 'DJIBUTIANO', '048', 'S', 'DJF', 'FRANCO DO DJIBOUTI', '', 'DJI', 2, 'N', 'N', '', 138, NULL, 222, 'DJIBOUTI', 'DJIBOUTI', 7838, 'N', '.dj', 'DJ', 'DJIBOUTI', 'DJIBOUTI', 'DJIBOUTI', '262', '253', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (67, 'BELIZE', 2, 'BELIZENHA', '019', 'S', 'BZD', 'DOLAR DO BELIZE', '', 'BLZ', 1, 'N', 'N', '', 8, NULL, 228, 'BELIZE', 'BELIZE', 884, 'N', '.bz', 'BZ', 'BELIZE', 'BELIZE', 'BELICE', '84', '501', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (69, 'BOTSUANA', 2, 'BETCHUANA / BOTSUANO', '023', 'S', 'BWP', 'PULA', '', 'BWA', 2, 'N', 'N', '', 10, NULL, 230, 'BOTSWANA', 'BOTSWANA', 1015, 'N', '.bw', 'BW', 'BOTSWANA', 'BOTSWANA', 'BOTSWANA', '72', '267', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (83, 'SUAZILANDIA', 2, 'SUAZI  /  SUZAI', '147', 'S', 'SZL', 'LILANGENI', '', 'SWZ', 2, 'N', 'N', '', 24, NULL, 242, 'SWAZILAND', 'SWAZILAND', 7544, 'N', '.sz', 'SZ', 'SWAZILAND', 'SWAZILAND', 'SWAZILANDIA', '748', '268', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (158, 'ESLOVENIA', 3, 'ESLOVENO', '244', 'S', 'SIT', 'TOLAR', '', 'SVN', 4, 'N', 'N', '', 99, NULL, 138, 'SLOVENIA', 'SLOVÉNIE', 2461, 'N', '.si', 'SI', 'SLOVENIA', 'SLOVÉNIE', 'ESLOVENIA', '705', '386', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (65, 'ALBANIA, REPUBLICA DA', 2, 'ALBANESA', '003', 'S', 'ALL', 'LEK', '', 'ALB', 4, 'N', 'N', '', 6, NULL, 227, 'ALBANIA', 'ALBANIE', 175, 'N', '.al', 'AL', 'ALBANIA', 'ALBANIE', 'ALBANIA', '8', '355', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (66, 'ARGELIA', 2, 'ARGELIANA', '010', 'S', 'DZD', 'DINAR ARGELINO', '', 'DZA', 2, 'N', 'N', '', 7, NULL, 117, 'ALGERIA', 'ALGÉRIE', 590, 'N', '.dz', 'DZ', 'ALGERIA', 'ALGÉRIE', 'ARGELIA', '12', '213', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (161, 'GRANADA', 2, 'GRANADINO', '066', 'S', 'XCD', 'DOLAR CARAIBAS ORIEN', '', 'GRD', 1, 'N', 'N', '', 102, NULL, 295, 'GRENADA', 'GRENADE', 2976, 'N', '.gd', 'GD', 'GRENADA', 'GRENADE', 'GRANADA', '308', '1', NULL, NULL, '2013-12-05', 'GRD');
INSERT INTO "dbgeral"."tb_pais" VALUES (168, 'LETONIA, REPUBLICA DA', 3, 'LETÃ', '245', 'S', 'LVL', 'LAT', '', 'LVA', 4, 'N', 'N', '', 109, NULL, 265, 'LATVIA', 'LETTONIE', 4278, 'N', '.lv', 'LV', 'LATVIA', 'LETTONIE', 'LETONIA', '428', '371', NULL, NULL, '2013-12-05', 'LVA');
INSERT INTO "dbgeral"."tb_pais" VALUES (172, 'MALTA', 2, 'MALTESA', '107', 'S', 'MTL', 'LIRA', '', 'MLT', 4, 'N', 'N', '', 113, NULL, 299, 'MALTA', 'MALTE', 4677, 'N', '.mt', 'MT', 'MALTA', 'MALTE', 'MALTA', '470', '356', NULL, NULL, '2013-12-05', 'MLT');
INSERT INTO "dbgeral"."tb_pais" VALUES (51, 'ZAIRE', 9, '', '168', 'N', '', 'FRANCO CONGOLES', '', '', 2, 'N', 'N', '', 188, NULL, NULL, 'ZAIRE, REPUBLIC OF', 'RÉPUBLIQUE DU ZAIRE', NULL, 'N', '', '', '', '', '', '', '243', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (220, 'ILHAS GEORGIA DO SUL E ILHAS SANDWICH DO SUL', NULL, '', '', 'S', 'GBP', 'LIBRA ESTERLINA', '', 'SGS', 4, 'N', 'N', '', NULL, NULL, 362, 'SOUTH GEORGIA AND THE SOUTH SANDWICH ISLANDS', 'GÉORGIE DU SUD ET LES ÎLES SANDWICH DU SUD', NULL, 'N', '.gs', 'GS', 'SOUTH GEORGIA AND THE SOUTH SANDWICH ISLANDS', 'GÉORGIE DU SUD ET LES ÎLES SANDWICH DU SUD', 'Islas Georgias del Sur y Sandwich del Sur', '239', NULL, NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (173, 'MAURICIO', 4, 'MAURICIANA', '109', 'S', 'MUR', 'RUPEE', '', 'MUS', 2, 'N', 'N', '', 114, NULL, 300, 'MAURITIUS', 'MAURICE', 4855, 'N', '.mu', 'MU', 'MAURITIUS', 'MAURICE', 'MAURICIO', '480', '230', NULL, NULL, '2013-12-05', 'MUS');
INSERT INTO "dbgeral"."tb_pais" VALUES (176, 'NIGER', 2, 'NIGERINO', '118', 'S', 'XOF', 'FRANC CFA', '', 'NER', 2, 'N', 'N', '', 117, NULL, 303, 'NIGER', 'NIGER', 5258, 'N', '.ne', 'NE', 'NIGER', 'NIGER', '', '562', '227', NULL, NULL, '2013-12-05', 'NER');
INSERT INTO "dbgeral"."tb_pais" VALUES (180, 'PALAU', 2, 'PALAUENSE', '251', 'S', 'USD', 'DOLAR', '', 'PLW', 5, 'N', 'N', '', 121, NULL, 305, 'PALAU', 'PALAOS', 5754, 'N', '.pw', 'PW', 'PALAU', 'PALAOS', 'PALAU', '585', '680', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (482, 'ESTADO DA PALESTINA', NULL, 'PALESTINA', NULL, 'S', NULL, NULL, NULL, NULL, NULL, 'N', 'N', NULL, 207, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, '970', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (194, 'CINGAPURA', 4, 'SINGAPURIANO', '039', 'S', 'SGD', 'DOLAR DE SINGAPURA', '', 'SGP', 3, 'N', 'N', '', 135, NULL, 314, 'SINGAPORE', 'SINGAPOUR', 7412, 'N', '.sg', 'SG', 'SINGAPORE', 'SINGAPOUR', 'SINGAPUR', '702', '65', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (214, 'ILHA CHRISTMAS (NAVIDAD)', NULL, 'CHRISTMAS', '', 'S', 'AUD', 'DOLAR AUSTRALIANO', '', 'CXR', 3, 'N', 'N', '', NULL, NULL, 356, 'CHRISTMAS ISLAND', 'ÎLE CHRISTMAS', 5118, 'N', '.cx', 'CX', 'CHRISTMAS ISLAND', 'ÎLE CHRISTMAS', 'ISLA DE NAVIDAD', '162', NULL, NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (7, 'PERU', 3, 'PERUANA', '127', 'S', 'S/.', 'SOL', '', 'PER', 1, 'S', 'N', '', 144, NULL, 65, 'PERU', 'PÉROU', 5894, 'N', '.pe', 'PE', 'PERU', 'PÉROU', 'PERÚ (EL)', '604', '51', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (8, 'SEYCHELLES', 6, 'SEYCHELENSE', '143', 'S', 'SCR', 'SEYCHELLES RUPEE', '', 'SYC', 2, 'N', 'N', '', 145, NULL, 190, 'SEYCHELLES', 'SEYCHELLES', 7315, 'N', '.sc', 'SC', 'SEYCHELLES', 'SEYCHELLES', 'SEYCHELLES', '690', '248', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (3, 'GEORGIA', 3, 'GEORGIANA', '249', 'S', 'GEL', 'LARI', '', 'GEO', 3, 'N', 'N', '', 140, NULL, 186, 'GEORGIA', 'GÉORGIE', 2917, 'N', '.ge', 'GE', 'GEORGIA', 'GÉORGIE', 'GEORGIA', '268', '995', NULL, NULL, '2013-12-05', 'GEO');
INSERT INTO "dbgeral"."tb_pais" VALUES (72, 'HONDURAS', 2, 'HONDURENHA', '075', 'S', 'HNL', 'LEMPIRA', '', 'HND', 1, 'S', 'N', '', 13, NULL, 232, 'HONDURAS', 'HONDURAS', 3450, 'N', '.hn', 'HN', 'HONDURAS', 'HONDURAS', 'HONDURAS', '340', '504', NULL, NULL, '2013-12-05', 'HND');
INSERT INTO "dbgeral"."tb_pais" VALUES (54, 'ISRAEL', 4, 'ISRAELENSE', '087', 'S', 'NIS', 'SHEKEL', '', 'ISR', 3, 'N', 'N', '', 191, NULL, 218, 'ISRAEL', 'ISRAËL', 3832, 'N', '.il', 'IL', 'ISRAEL', 'ISRAËL', 'ISRAEL', '376', '972', NULL, NULL, '2013-12-05', 'ISR');
INSERT INTO "dbgeral"."tb_pais" VALUES (11, 'SOMALIA', 3, 'SOMALI', '145', 'S', 'SOS', 'XELIM', '', 'SOM', 2, 'N', 'N', '', 148, NULL, 193, 'SOMALIA', 'SOMALIE', 7480, 'N', '.so', 'SO', 'SOMALIA', 'SOMALIE', 'SOMALIA', '706', '252', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (12, 'BARBADOS', 3, 'BARBADIANA', '016', 'S', 'BBD', 'DOLAR DE BARBADOS', '', 'BRB', 1, 'N', 'N', '', 149, NULL, 43, 'BARBADOS', 'BARBADE', 833, 'N', '.bb', 'BB', 'BARBADOS', 'BARBADE', 'BARBADOS', '52', '1', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (52, 'BAHAMAS, ILHAS', 5, 'BAHAMENSE', '014', 'S', 'BSD', 'DOLAR DAS BAHAMAS', '', 'BHS', 1, 'N', 'N', '', 189, NULL, 217, 'BAHAMAS', 'BAHAMAS', 779, 'N', '.bs', 'BS', 'BAHAMAS', 'BAHAMAS', 'BAHAMAS (LAS)', '44', '1', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (64, 'TUVALU', 2, 'TUVALUANA', '160', 'S', '', 'DOLLAR', '', 'TUV', 5, 'N', 'N', '', 5, NULL, 226, 'TUVALU', 'TUVALU', 8281, 'N', '.tv', 'TV', 'TUVALU', 'TUVALU', 'TUVALU', '798', '688', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (216, 'ILHAS CAYMAN', NULL, 'CAIMANÊS', '', 'S', 'KYD', 'DOLAR CAIMANO', '', 'CYM', 1, 'N', 'N', '', NULL, NULL, 358, 'CAYMAN ISLANDS', 'ÎLES CAIMANES', 1376, 'N', '.ky', 'KY', 'CAYMAN ISLANDS', 'ÎLES CAIMANES', 'ISLAS CAIMÁN', '136', '1', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (57, 'PORTO RICO', 4, 'PORTO-RIQUENHO', '210', 'S', 'USD', 'DOLAR', '', 'PRI', 1, 'N', 'N', '', 194, NULL, 26, 'PUERTO RICO', 'PORTO RICO', 6114, 'N', '.pr', 'PR', 'PUERTO RICO', 'PORTO RICO', 'PUERTO RICO', '630', '1', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (70, 'ERITREIA', 2, 'ERITREIA', '225', 'S', 'ERN', 'NAKFA', '', 'ERI', 2, 'N', 'N', '', 11, NULL, 231, 'ERITREA', 'ERYTHRÉE', 2437, 'N', '.er', 'ER', 'ERITREA', 'ÉRYTHRÉE', 'ERITREA', '232', '291', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (91, 'TUNISIA', 2, 'TUNISIANA', '158', 'S', 'TND', 'DINAR TUNISIANO', '', 'TUN', 2, 'N', 'N', '', 32, NULL, 247, 'TUNISIA', 'TUNISIE', 8206, 'N', '.tn', 'TN', 'TUNISIA', 'TUNISIE', 'TÚNEZ', '788', '216', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (71, 'EQUADOR', 2, 'EQUATORIANA', '053', 'S', 'US$', 'DOLAR AMERICANO', '', 'ECU', 1, 'S', 'N', '', 12, NULL, 22, 'ECUADOR', 'EQUATEUR', 2399, 'N', '.ec', 'EC', 'ECUADOR', 'ÉQUATEUR', 'ECUADOR (EL)', '218', '593', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (106, 'FIJI', 2, 'FIJIANA', '057', 'S', 'FJD', 'DOLAR FIJIANO', '', 'FJI', 5, 'N', 'N', '', 47, NULL, 257, 'FIJI', 'FIDJI', 8702, 'N', '.fj', 'FJ', 'FIJI', 'FIDJI', 'FIJI', '242', '679', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (109, 'GANA', 2, 'GANENSE', '064', 'S', 'GHC', 'CEDI', '', 'GHA', 2, 'N', 'N', '', 50, NULL, 259, 'GHANA', 'GHANA', 2895, 'N', '.gh', 'GH', 'GHANA', 'GHANA', 'GHANA', '288', '233', NULL, NULL, '2013-12-05', 'GHA');
INSERT INTO "dbgeral"."tb_pais" VALUES (84, 'SURINAME', 2, 'SURINAMITA', '151', 'S', 'SRD', 'DOLAR DO SURINAME', '', 'SUR', 1, 'S', 'N', '', 25, NULL, 68, 'SURINAME', 'SURINAME', 7706, 'N', '.sr', 'SR', 'SURINAME', 'SURINAME', 'SURINAME', '740', '597', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (95, 'CABO VERDE, REPUBLICA DE', 2, '', '030', 'S', 'CV', 'ESCUDO', '', 'CPV', 2, 'N', 'N', '', 36, NULL, 131, 'CAPE VERDE', 'CAP-VERT', 1279, 'N', '.cv', 'CV', 'CAPE VERDE', 'CAP-VERT', 'CABO VERDE', '132', '238', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (100, 'COSTA RICA', 4, '', '045', 'S', 'CRC', 'COLON', '', 'CRI', 1, 'S', 'N', '', 41, NULL, 25, 'COSTA RICA', 'COSTA-RICA', 1961, 'N', '.cr', 'CR', 'COSTA RICA', 'COSTA RICA', 'COSTA RICA', '188', '506', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (103, 'EL SALVADOR', 2, '', '051', 'S', 'SVC', 'COLON', '', 'SLV', 1, 'S', 'N', '', 44, NULL, 27, 'EL SALVADOR', 'EL SALVADOR', 6874, 'N', '.sv', 'SV', 'EL SALVADOR', 'EL SALVADOR', 'EL SALVADOR', '222', '503', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (113, 'GUINE EQUATORIAL', 2, 'GUINÉU-EQUATORIANO', '072', 'S', 'XAF', 'FRANCO CFA', '', 'GNQ', 2, 'N', 'N', '', 54, NULL, 262, 'EQUATORIAL GUINEA', 'GUINÉE ÉQUATORIALE', 3310, 'N', '.gq', 'GQ', 'EQUATORIAL GUINEA', 'GUINÉE ÉQUATORIALE', 'GUINEA ECUATORIAL (LA)', '226', '240', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (219, 'ILHAS FAROE', NULL, 'FAROENSE', '', 'S', '', 'COROA DINAMARQUESA', '', 'FRO', 4, 'N', 'N', '', NULL, NULL, 361, 'FAROE ISLANDS', 'ÎLES FAROE', 2593, 'N', '.fo', 'FO', 'FAROE ISLANDS', 'FÉROÉ, ÎLES', '', '', '298', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (226, 'ILHAS REUNIAO', NULL, 'RENUNIONENSE', '', 'S', 'EUR', 'EURO', '', 'REU', 2, 'N', 'N', '', NULL, NULL, 368, 'REUNION', 'RÉUNION', 6602, 'N', '.re', 'RE', 'REUNION', 'RÉUNION', 'REUNIÓN', '638', '262', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (240, 'SAO PEDRO E MIQUELON', NULL, 'MIQUELENSES', '', 'S', '', 'EURO', '', 'SPM', 1, 'N', 'N', '', NULL, NULL, 382, 'SAINT PIERRE AND MIQUELON', 'ST-PIERRE ET MIQUELON', 7005, 'N', '.pm', 'PM', 'SAINT PIERRE AND MIQUELON', 'SAINT-PIERRE-ET-MIQUELON', '', '', '508', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (181, 'PAPUA NOVA GUINE', 2, 'PAPUÁSIA  /  PAPUA', '124', 'S', 'PGK', 'KINA', '', 'PNG', 5, 'N', 'N', '', 122, NULL, 306, 'PAPUA NEW GUINEA', 'PAPOUASIE-NOUVELLE-GUINEE', 5452, 'N', '.pg', 'PG', 'PAPUA NEW GUINEA', 'PAPOUASIE-NOUVELLE-GUINÉE', 'PAPUA NUEVA GUINEA', '598', '675', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (28, 'SUDÃO', 3, 'SUDANES', '148', 'S', 'SDD', 'DINAR SUDANES', '', 'SDN', 2, 'N', 'N', '', 165, NULL, 204, 'SUDAN', 'SOUDAN', 7595, 'N', '.sd', 'SD', 'SUDAN (THE)', 'SOUDAN', 'SUDÁN (EL)', '736', '249', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (29, 'TAIWAN (FORMOSA, REPÚBLICA DA CHINA)', 4, 'TAIWANÊS', '060', 'S', 'TWD', 'RENMINBI', '', 'TWN', 3, 'N', 'N', '', 166, NULL, 123, 'TAIWAN, PROVINCE OF CHINA', 'TAIWAN', 1619, 'N', '.tw', 'TW', 'TAIWAN, PROVINCE OF CHINA', 'TAIWAN', 'TAIWAN', '157', '886', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (224, 'VIRGENS,ILHAS (BRITANICAS)', NULL, 'VIRGINENSE BRITANICO', '', 'S', 'USD', 'DOLAR AMERICANO', '', 'VGB', 1, 'N', 'N', '', NULL, NULL, 366, 'BRITISH VIRGIN ISLANDS', 'ÎLES VIERGENS BRITANNIQUES', 8630, 'N', '.vg', 'VG', 'BRITISH VIRGIN ISLANDS', 'ÎLES VIERGENS BRITANNIQUES', 'ISLAS VÍRGENES BRITÁNICAS', '92', '1', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (25, 'POLONIA', 3, 'POLONESA', '128', 'S', 'PLN', 'ZLOTY', '', 'POL', 4, 'N', 'N', '', 162, NULL, 201, 'POLAND', 'POLOGNE', 6033, 'N', '.pl', 'PL', 'POLAND', 'POLOGNE', 'POLONIA', '616', '48', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (221, 'ILHAS SVALBARD E JAN MAYEN', 4, 'SVALBARDIANA', '', 'S', 'NOK', 'COROA NORUEGUESA', '', 'SJM', 4, 'N', 'N', '', NULL, NULL, 363, 'SVALBARD AND JAN MAYEN', 'SVALBARD ET ÎLE JAN MAYEN', NULL, 'N', '.sj', 'SJ', 'SVALBARD AND JAN MAYEN', 'SVALBARD ET ÎLE JAN MAYEN', '', '744', '47', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (222, 'TURCAS E CAICOS,ILHAS', NULL, 'TURKES', '', 'S', '', 'U.S. DOLAR', '', 'TCA', 1, 'N', 'N', '', NULL, NULL, 364, 'TURKS AND CAICOS ISLANDS', 'TURKS ET CAÏQUES, ÎLES', 8230, 'N', '.tc', 'TC', 'TURKS AND CAICOS ISLANDS', 'TURKS ET CAÏQUES, ÎLES', '', '796', '1', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (229, 'ILHAS WALLIS E FUTUNA', NULL, 'WALLISIANA-FUTUNENSE', '', 'S', 'CFP', 'FRANCO FRANCES DO PACIFICO', '', 'WLF', 5, 'N', 'N', '', NULL, NULL, 371, 'WALLIS AND FUTUNA ISLANDS', 'ÎLES WALLIS-ET-FUTUNA', NULL, 'N', '.wf', 'WF', 'WALLIS AND FUTUNA ISLANDS', 'ÎLES WALLIS-ET-FUTUNA', 'WALLIS Y FUTUNA', '876', '681', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (183, 'SAO CRISTOVAO E NEVES, ILHAS', 2, 'SÃO-CRISTOVENSE', '138', 'S', 'XCD', 'EAST CARIBBEAN DOLAR', '', 'KNA', 1, 'N', 'N', '', 124, NULL, 220, 'SAINT CHRISTOPHER AND NEVIS', 'SAINT-CHRISTOPHE-ET-NEVIS', 6955, 'N', '.kn', 'KN', 'SAINT KITTS AND NEVIS', 'Saint-Kitts-et-Nevis [masc.]', 'SAINT KITTS Y NEVIS', '659', '1', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (15, 'GUINE ', 2, '', '070', 'S', 'GNF', 'FRANCO GUINEENSE', '', 'GIN', 2, 'N', 'N', '', 152, NULL, 196, 'GUINEA', 'GUINÉE', 3298, 'N', '.gn', 'GN', 'GUINEA', 'GUINÉE', 'GUINEA', '324', '224', NULL, NULL, '2013-12-05', 'GIN');
INSERT INTO "dbgeral"."tb_pais" VALUES (14, 'CAZAQUISTAO, REPUBLICA DO', 3, 'CAZAQUISTANESA', '264', 'S', 'KZT', 'TENGE', '', 'KAZ', 3, 'N', 'N', '', 151, NULL, 195, 'KAZAKHSTAN', 'KAZAKHSTAN', 1538, 'N', '.kz', 'KZ', 'KAZAKHSTAN', 'KAZAKHSTAN', 'KAZAJSTÁN', '398', '7', NULL, NULL, '2013-12-05', 'KAZ');
INSERT INTO "dbgeral"."tb_pais" VALUES (90, 'TRINIDAD E TOBAGO', 2, 'TRINITINA  /  TOBAGUIANA', '157', 'S', 'TTD', 'DOLLAR', '', 'TTO', 1, 'N', 'N', '', 31, NULL, 19, 'TRINIDAD AND TOBAGO', 'TRINITÉ-ET-TOBAGO', 8150, 'N', '.tt', 'TT', 'TRINIDAD AND TOBAGO', 'TRINITÉ-ET-TOBAGO', 'TRINIDAD Y TABAGO', '780', '1', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (116, 'IRÃ, REPÚBLICA ISLÂMICA DO', 2, 'IRANIANO', '083', 'S', 'IRR', 'RIAL', '', 'IRN', 3, 'N', 'N', '', 57, NULL, 264, 'IRAN, ISLAMIC REPUBLIC OF', 'RÉPUBLIQUE ISLAMIQUE d''IRAN', 3727, 'N', '.ir', 'IR', 'IRAN, ISLAMIC REPUBLIC OF', 'RÉPUBLIQUE ISLAMIQUE d''IRAN', 'REPÚBLICA ISLÁMICA DE IRÁN', '364', '98', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (93, 'BAHREIN, ILHAS', 4, 'BARENITA', '017', 'S', 'BHD', 'DINAR DO BAHREIN', '', 'BHR', 3, 'N', 'N', '', 34, NULL, 249, 'BAHRAIN', 'BAHRAIN', 809, 'N', '.bh', 'BH', 'BAHRAIN', 'BAHREÏN', 'BAHREIN', '48', '973', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (119, 'MACEDONIA', 3, 'MACEDONIO', '234', 'S', 'MKD', 'DINAR MACEDONIO', '', 'MKD', 4, 'N', 'N', '', 60, NULL, 266, 'REPUBLIC OF MACEDONIA', 'RÉPUBLIQUE DE MACÉDOINE', 4499, 'N', '.mk', 'MK', 'FORMER YUGOSLAV REPUBLIC OF MACEDONIA', 'ANCIENNE RÉPUBLIQUE YOUGOSLAVE DE MACÉDOINE', 'REPÚBLICA DE MACEDONIA', '807', '389', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (86, 'TANZÂNIA, REPÚBLICA UNIDA DA', 2, 'TANZANIANO', '153', 'S', 'TZS', 'XELIM TANZANIANO', '', 'TZA', 2, 'N', 'N', '', 27, NULL, 244, 'TANZANIA', 'TANZANIE', 7803, 'N', '.tz', 'TZ', 'TANZANIA, UNITED REPUBLIC OF', 'RÉPUBLIQUE-UNIE DE TANZANIE', 'REPÚBLICA UNIDA DE TANZANIA', '834', '255', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (40, 'VIETNA', 3, 'VIETNAMITA', '167', 'S', 'VND', 'DONG', '', 'VNM', 3, 'N', 'N', '', 177, NULL, 149, 'VIET NAM', 'VIET NAM', 8583, 'N', '.vn', 'VN', 'VIET NAM', 'VIET NAM', 'VIET NAM', '704', '84', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (120, 'MALAVI', 4, 'MALAWIANO  /   MALAUIANA', '104', 'S', 'D', 'KWACHA', '', 'MWI', 2, 'N', 'N', '', 204, NULL, 267, 'MALAWI', 'MALAWI', 4588, 'N', '.mw', 'MW', 'MALAWI', 'MALAWI', 'MALAWI', '454', '265', NULL, NULL, '2013-12-05', 'MWI');
INSERT INTO "dbgeral"."tb_pais" VALUES (227, 'ILHAS SANTA HELENA', NULL, 'HELENENSE', '', 'S', 'SHP', 'LIBRA DE SANTA HELENA', '', 'SHN', 2, 'N', 'N', '', NULL, NULL, 369, 'SAINT HELENA', 'SAINTE-HÉLÈNE', 7102, 'N', '.sh', 'SH', 'SAINT HELENA', 'SAINTE-HÉLÈNE', '', '', '290', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (228, 'TOQUELAU,ILHAS', NULL, 'TOKELAUANO', '', 'S', '', 'DOLAR DA NOVA ZELANDIA', '', 'TKL', 5, 'N', 'N', '', NULL, NULL, 370, 'TOKELAU', 'TOKELAU', 8052, 'N', '.tk', 'TK', 'TOKELAU', 'TOKELAU', 'TOKELAU', '772', '690', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (238, 'SAARA OCIDENTAL', NULL, 'SAARIANA', '', 'S', 'MAD', 'DIRHAM', '', 'ESH', 2, 'N', 'N', '', NULL, NULL, 380, 'WESTERN SAHARA', 'SAHARA OCCIDENTAL', 6858, 'N', '.eh', 'EH', 'WESTERN SAHARA', 'SAHARA OCCIDENTAL', 'SAHARA OCCIDENTAL', '732', '212', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (241, 'VATICANO, ESTADO DA CIDADE DO', NULL, 'VATICANO', '', 'S', 'EUR', 'EURO', '', 'VAT', 4, 'N', 'N', '', NULL, NULL, 383, 'VATICAN', 'VATICAN', 8486, 'N', '.va', 'VA', 'VATICAN CITY STATE', 'VATICAN, ÉTAT DE LA CITÉ DU', 'CIUDAD DEL VATICANO', '255', '39', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (92, 'AUSTRALIA', 3, 'AUSTRALIANA', '012', 'S', 'AUD', 'DOLAR AUSTRALIANO', '', 'AUS', 5, 'N', 'N', '', 33, NULL, 248, 'AUSTRALIA', 'AUSTRALIE', 698, 'N', '.au', 'AU', 'AUSTRALIA', 'AUSTRALIE', 'AUSTRALIA', '36', '61', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (105, 'ESTONIA, REPUBLICA DA', 3, 'ESTONIANA', '231', 'S', 'EEK', 'COROA ESTONIANA', '', 'EST', 4, 'N', 'N', '', 46, NULL, 256, 'ESTONIA', 'ESTONIE', 2518, 'N', '.ee', 'EE', 'ESTONIA', 'ESTONIE', 'ESTONIA', '233', '372', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (208, 'ARUBA', NULL, 'ARUBANA', '', 'S', 'AWG', 'FLORIM DE ARUBA', '', 'ABW', 1, 'N', 'N', '', NULL, NULL, 350, 'ARUBA', 'ARUBA', 655, 'N', '.aw', 'AW', 'ARUBA', 'ARUBA', '', '533', '297', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (223, 'VIRGENS,ILHAS (E.U.A.)', NULL, 'VIRGINENSE AMERICANO', '', 'S', 'USD', 'DOLAR AMERICANO', '', 'VIR', 1, 'N', 'N', '', NULL, NULL, 365, 'UNITED STATES VIRGIN ISLANDS', 'ÎLES VIERGES AMÉRICAINES', 8664, 'N', '.vi', 'VI', 'UNITED STATES VIRGIN ISLANDS', 'ILES VIERGES AMÉRICAINES', 'ISLAS VÍRGENES DE LOS ESTADOS UNIDOS', '850', '1', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (131, 'SAMOA, ESTADO INDEPENDENTE DE (SAMOA OCIDENTAL)', 4, 'SAMOANA', '135', 'S', 'WST', 'TALA', '', 'WSM', 5, 'N', 'N', '', 72, NULL, 274, 'SAMOA', 'SAMOA', 6904, 'N', '.ws', 'WS', 'SAMOA', 'SAMOA', 'SAMOA, ESTADO INDEPENDIENTE DE', '882', '685', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (230, 'SÉRVIA', NULL, 'SERVIA', '', 'S', 'RSD', 'DINAR SERVIO', '', 'SRB', 4, 'N', 'N', '', 218, NULL, 372, 'SERBIA', 'SERBIE', 7370, 'N', '.rs', 'RS', 'SERBIA', 'SERBIE', 'SERBIA', '688', '381', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (231, 'MONTENEGRO', NULL, 'MONTENEGRINA', '', 'S', 'EUR', 'EURO', '', 'MNE', 4, 'N', 'N', '', 215, NULL, 373, 'MONTENEGRO', 'MONTÉNÉGRO (LE)', 4985, 'N', '.me', 'ME', 'MONTENEGRO', 'MONTÉNÉGRO (LE)', 'MONTENEGRO', '499', '382', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (480, 'CONGO, REPUBLICA DEMOCRATICA DO (ZAIRE)', 2, 'CONGUÊS, CONGOLÊS', '', 'S', 'CDF', 'FRANCO CONGOLÊS', '', 'COD', 2, 'N', 'N', '', 214, NULL, NULL, 'CONGO, THE DEMOCRATIC REPUBLIC OF THE', 'RÉPUBLIQUE DÉMOCRATIQUE DU CONGO', 8885, 'N', '.cd', 'CD', 'CONGO, THE DEMOCRATIC REPUBLIC OF THE', 'CONGO, LA RÉPUBLIQUE DÉMOCRATIQUE DU', 'REPÚBLICA DEMOCRÁTICA DEL CONGO (LA)', '', '242', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (184, 'SAO VICENTE E GRANADINAS', 2, 'SÃO-VICENTINA', '140', 'S', 'XCD', 'EAST CARIBBEAN DOLAR', '', 'VCT', 1, 'N', 'N', '', 125, NULL, 308, 'SAINT VINCENT AND THE GRENADINES', 'SAINT-VICENT-ET-GRENADINES', 7056, 'N', '.vc', 'VC', 'SAINT VINCENT AND THE GRENADINES', 'SAINT-VINCENT-ET-LES GRENADINES', 'SAN VICENTE Y LAS GRANADINAS', '670', '1', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (185, 'SAO TOME E PRINCIPE', 2, 'SÃO-TOMEENSE', '139', 'S', 'STD', 'DOBRA', '', 'STP', 2, 'N', 'N', '', 126, NULL, 109, 'SAO TOME AND PRINCIPE', 'SAO TOMÉ-ET-PRINCIPE', NULL, 'N', '.st', 'ST', 'SAO TOME AND PRINCIPE', 'SAO TOMÉ-ET-PRINCIPE', 'SANTO TOMÉ Y PRÍNCIPE', '678', '239', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (4, 'IÊMEN', 3, 'IEMENITA', '077', 'S', 'YER', 'RIAL IEMENITA', '', 'YEM', 4, 'N', 'N', '', 141, NULL, 187, 'YEMEN', 'YÉMEN', 3573, 'N', '.ye', 'YE', 'YEMEN', 'YÉMEN', 'YEMEN (EL)', '887', '967', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (188, 'UGANDA', 2, 'UGANDENSE', '161', 'S', 'UGX', 'SHILLING', '', 'UGA', 2, 'N', 'N', '', 129, NULL, 310, 'UGANDA', 'OUGANDA', 8338, 'N', '.ug', 'UG', 'UGANDA', 'OUGANDA', 'UGANDA', '800', '256', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (189, 'VANUATU', 2, 'VANUATENSE', '164', 'S', 'VUV', 'VATU', '', 'VUT', 5, 'N', 'N', '', 130, NULL, 311, 'VANUATU', 'VANUATU', 5517, 'N', '.vu', 'VU', 'VANUATU', 'VANUATU', 'VANUATU', '548', '678', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (200, 'ILHAS FALKLAND (MALVINAS)', NULL, 'MALVINOS  /  MALVINENSES  /  KELPERS', '', 'S', 'FKP', 'LIBRA ESTERLINA', '', 'FLK', 1, 'S', 'N', '', NULL, NULL, 317, 'FALKLAND ISLANDS (MALVINAS)', 'ÎLES FALKLAND', 2550, 'N', '.fk', 'FK', 'FALKLAND ISLANDS (MALVINAS)', 'FALKLAND, ÎLES (MALVINAS)', 'MALDIVAS', '', '500', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (211, 'GROENLANDIA', NULL, 'GROENLANDESA', '', 'S', 'DKK', 'COROA DINAMARQUESA', '', 'GRL', 1, 'N', 'N', '', NULL, NULL, 353, 'GREENLAND', 'GROENLAND', 3050, 'N', '.gl', 'GL', 'GREENLAND', 'GROENLAND', '', '304', '299', NULL, NULL, '2013-12-05', 'GRL');
INSERT INTO "dbgeral"."tb_pais" VALUES (110, 'GUATEMALA', 2, 'GUALTEMATECA', '068', 'S', 'GTQ', 'QUETZAL', '', 'GTM', 1, 'S', 'N', '', 51, NULL, 56, 'GUATEMALA', 'GUATÉMALA', 3174, 'N', '.gt', 'GT', 'GUATEMALA', 'GUATEMALA', 'GUATEMALA', '320', '502', NULL, NULL, '2013-12-05', 'GTM');
INSERT INTO "dbgeral"."tb_pais" VALUES (213, 'HONG KONG', NULL, 'HONG-KONGUIANA', '', 'S', 'HKD', 'DOLAR DE HONG KONG', '', 'HKG', 3, 'N', 'N', '', 190, NULL, 355, 'HONG KONG', 'HONG KONG', 3514, 'N', '.hk', 'HK', 'HONG KONG', 'HONG-KONG', '', '', '852', NULL, NULL, '2013-12-05', 'HKG');
INSERT INTO "dbgeral"."tb_pais" VALUES (47, 'KUWAIT, ESTADO DO (COVEITE)', 4, '', '094', 'S', 'KWD', 'DINAR', '', 'KWT', NULL, 'N', 'N', '', 184, NULL, 212, 'KUWAIT', 'KUWAIT', 1988, 'N', '.kw', 'KW', 'KUWAIT', 'KOWEÏT', 'KUWAIT', '414', '965', NULL, NULL, '2013-12-05', 'KWT');
INSERT INTO "dbgeral"."tb_pais" VALUES (483, 'Tobago', 3, NULL, NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 28, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (485, 'Malavi', 4, NULL, '104', 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 61, NULL, NULL, NULL, NULL, 4588, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (486, 'Moldova', 4, NULL, '235', 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 63, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (487, 'Macau', 5, NULL, '202', 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 110, NULL, NULL, NULL, NULL, 4472, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (488, 'Coreia do Norte', 3, NULL, '042', 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 136, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (489, 'Não Informado', 1, NULL, '000', 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 197, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (490, 'Paris', NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 199, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (491, 'Republica Eslovaca ', 3, NULL, NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 213, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (492, 'Kiribati', 3, NULL, NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 203, NULL, NULL, NULL, NULL, 4111, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (493, 'Republica Togolesa', 2, NULL, NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 210, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (494, 'Guine', 2, NULL, NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 209, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (495, 'Lemen ', 3, NULL, NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 211, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (496, 'Seicheles', 5, NULL, NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 217, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (497, 'Republica  Quirguiz', 5, NULL, NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 216, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (32, 'ARGENTINA', 3, 'ARGENTINO', '011', 'S', '$(ARG)', 'PESO ARGENTINO', '', 'ARG', 1, 'S', 'M', '', 169, NULL, 44, 'ARGENTINA', 'ARGENTINE', 639, 'N', '.ar', 'AR', 'ARGENTINA', 'ARGENTINE', 'ARGENTINA (LA)', '32', '54', NULL, 21, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (43, 'BELGICA', 4, 'BELGA', '018', 'S', 'EUR', 'EURO BELGA', '', 'BEL', 4, 'N', 'N', '', 180, NULL, 74, 'BELGIUM', 'BELGIQUE', 876, 'N', '.be', 'BE', 'BELGIUM', 'BELGIQUE', 'BÉLGICA', '56', '32', NULL, 31, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (68, 'BOLIVIA', 2, 'BOLIVIANO', '022', 'S', '$B', 'BOLIVIANO', '', 'BOL', 1, 'S', 'C', '', 9, NULL, 118, 'BOLIVIA', 'BOLIVIE', 973, 'N', '.bo', 'BO', 'BOLIVIA', 'BOLIVIE', 'BOLIVIA', '68', '591', NULL, 22, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (1, 'BRASIL', 1, 'BRASILEIRO', '024', 'S', 'R$', 'REAL', '', 'BRA', 1, 'S', 'M', '', 1, NULL, 185, 'BRAZIL', 'BRÉSIL', 1058, 'N', '.br', 'BR', 'BRAZIL', 'BRÉSIL', 'BRASIL (EL)', '76', '55', NULL, 10, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (38, 'REINO UNIDO', 4, 'BRITÂNICO', '254', 'S', 'GBP', 'LIBRA ESTERLINA', '', 'UK', 4, 'N', 'N', '', 175, NULL, 80, 'UNITED KINGDOM OF GREAT BRITAIN AND NORTHERN IRELAND', 'ROYAUME-UNI DE GRANDE-BRETAGNE ET D''IRLANDE DU NORD)', 6289, 'N', '.uk', 'UK', 'UNITED KINGDOM OF GREAT BRITAIN AND NORTHERN IRELAND (THE)', 'ROYAUME-UNI DE GRANDE-BRETAGNE ET D''IRLANDE DU NORD)', 'EL REINO UNIDO DE GRAN BRETAÑA E IRLANDA DEL NORTE (EL)', '', '44', NULL, 32, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (96, 'CANADA', 4, 'CANADENSE', '033', 'S', '$', 'DOLAR CANADENSE', '', 'CAN', 1, 'N', 'N', '', 37, NULL, 82, 'CANADA', 'CANADA', 1490, 'N', '.ca', 'CA', 'CANADA', 'CANADA', 'CANADÁ (EL)', '124', '1', NULL, 34, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (192, 'CHILE', 3, 'CHILENO', '036', 'S', 'CLP', 'PESO CHILENO', '', 'CHL', 1, 'S', 'C', '', 133, NULL, 29, 'CHILE', 'CHILI', 1589, 'N', '.cl', 'CL', 'CHILE', 'CHILI', 'CHILE', '152', '56', NULL, 23, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (193, 'CHINA, REPUBLICA POPULAR', 4, 'CHINÊS', '037', 'S', 'CNY', 'RENMINBI', '', 'CHN', 3, 'N', 'N', '', 134, NULL, 17, 'CHINA', 'CHINE', 1600, 'N', '.cn', 'CN', 'CHINA', 'CHINE', 'CHINA', '', '86', NULL, 42, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (44, 'ESPANHA', 4, 'ESPANHOL', '054', 'S', 'EUR', 'EURO', '', 'ESP', 4, 'N', 'N', '', 181, NULL, 3, 'SPAIN', 'ESPAGNE', 2453, 'N', '.es', 'ES', 'SPAIN', 'ESPAGNE', 'ESPAÑA', '724', '34', NULL, 35, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (46, 'FRANCA', 4, 'FRANCÊS', '061', 'S', 'EUR', 'EURO', '', 'FRA', 4, 'N', 'N', '', 183, NULL, 15, 'FRANCE', 'FRANCE', 2755, 'N', '.fr', 'FR', 'FRANCE', 'FRANCE', 'FRANCIA', '250', '33', NULL, 37, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (45, 'ESTADOS UNIDOS DA AMERICA', 4, 'NORTE-AMERICANO', '055', 'S', '$', 'DOLAR AMERICANO', '', 'USA', 1, 'N', 'N', '', 182, NULL, 72, 'UNITED STATES', 'ETATS-UNIS AMÉRIQUE', 2496, 'N', '.us', 'US', 'UNITED STATES', 'ÉTATS-UNIS', 'ESTADOS UNIDOS DE AMÉRICA (LOS)', '', '1', NULL, 36, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (126, 'PARAGUAI', 2, 'PARAGUAIO', '126', 'S', 'PYG', 'GUARANI', '', 'PRY', 1, 'S', 'M', '', 67, NULL, 39, 'PARAGUAY', 'PARAGUAY', 5860, 'N', '.py', 'PY', 'PARAGUAY', 'PARAGUAY', 'PARAGUAY (EL)', '600', '595', NULL, 24, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (182, 'PORTUGAL', 4, 'PORTUGUÊS', '129', 'S', 'EUR', 'EURO', '', 'PRT', 4, 'N', 'N', '', 123, NULL, 66, 'PORTUGAL', 'PORTUGAL', 6076, 'N', '.pt', 'PT', 'PORTUGAL', 'PORTUGAL', 'PORTUGAL', '620', '351', NULL, 45, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (9, 'SUÍÇA', 4, 'SUÍÇO', '150', 'S', 'CHF', 'FRANCO SUÍÇO', '', 'CHE', 4, 'N', 'N', '', 146, NULL, 191, 'SWITZERLAND', 'SUISSE', 7676, 'N', '.ch', 'CH', 'SWITZERLAND', 'SUISSE', 'SUIZA', '756', '41', NULL, 38, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (137, 'URUGUAI', 3, 'URUGUAIO', '163', 'S', 'UYU', 'PESO URUGUAIO', '', 'URY', 1, 'S', 'M', '', 78, NULL, 10, 'URUGUAY', 'URUGUAY', 8451, 'N', '.uy', 'UY', 'URUGUAY', 'URUGUAY', 'URUGUAY (EL)', '858', '598', NULL, 25, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (111, 'GUIANA FRANCESA', 2, 'GUIANENSE', '069', 'S', 'EUR', 'EURO', '', 'GUF', 1, 'S', 'N', '', 219, NULL, 45, 'FRENCH GUIANA', 'GUYANE FRANÇAISE', 3255, 'N', '.gf', 'GF', 'FRENCH GUIANA', 'GUYANE FRANÇAISE', '', '254', '594', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (484, 'Iugoslavia', 3, NULL, '089', 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 484, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (201, 'ANDORRA', NULL, 'ANDORRANA', '', 'S', 'ADP', 'EURO', '', 'AND', 4, 'N', 'N', '', 205, NULL, 318, 'ANDORRA', 'ANDORRE', 370, 'N', '.ad', 'AD', 'ANDORRA', 'ANDORRE', 'ANDORRA', '20', '376', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (202, 'ILHAS COMORES', NULL, 'COMORENSE', '', 'S', 'KMF', 'FRANCO DAS COMORES', '', 'COM', 2, 'N', 'N', '', 202, NULL, 319, 'COMOROS', 'COMORES', 1732, 'N', '.km', 'KM', 'COMOROS', 'COMORES', 'COMORAS (LAS)', '174', '269', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (203, 'ILHAS COOK', NULL, 'COOKENSE', '', 'S', 'NZD', 'DOLAR NOVA ZELANDIA', '', 'COK', 5, 'N', 'N', '', NULL, NULL, 320, 'COOK ISLANDS', 'ÎLES COOK', 1830, 'N', '.ck', 'CK', 'COOK ISLANDS', 'COOK, ÎLES', 'ISLAS COOK (LAS)', '184', '682', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (205, 'RUANDA', NULL, 'RUANDESA', '', 'S', 'RWF', 'RWANDAN FRANC', '', 'RWA', 2, 'N', 'N', '', 201, NULL, 322, 'RWANDA', 'RWANDA', 6750, 'N', '.rw', 'RW', 'RWANDA', 'RWANDA', 'RWANDA', '646', '250', NULL, NULL, NULL, NULL);
INSERT INTO "dbgeral"."tb_pais" VALUES (41, 'ALEMANHA', 4, 'ALEMÃO', '004', 'S', 'EUR', 'EURO', '', 'DEU', 4, 'N', 'N', '', 178, NULL, 83, 'GERMANY', 'ALLEMAGNE', 230, 'N', '.de', 'DE', 'GERMANY', 'ALLEMAGNE', 'ALEMANIA', '276', '49', NULL, 30, '2013-12-05', 'DEU');
INSERT INTO "dbgeral"."tb_pais" VALUES (199, 'GUIANA', 2, '', '', 'S', 'GYD', 'GUYANESE', '', 'GUY', 1, 'S', 'N', '', 52, NULL, 316, 'GUYANA', 'GUYANE', 3379, 'N', '.gy', 'GY', 'GUYANA', 'GUYANA', 'GUYANA', '328', '592', NULL, NULL, '2013-12-05', 'GUY');
INSERT INTO "dbgeral"."tb_pais" VALUES (19, 'ITALIA', 4, 'ITALIANO', '088', 'S', 'EUR', 'EURO', '', 'ITA', 4, 'N', 'N', '', 156, NULL, 71, 'ITALY', 'ITALIE', 3867, 'N', '.it', 'IT', 'ITALY', 'ITALIE', 'ITALIA', '380', '39', NULL, 39, '2013-12-05', 'ITA');
INSERT INTO "dbgeral"."tb_pais" VALUES (55, 'JAPAO', 5, 'JAPONÊS', '091', 'S', 'JPY', 'YEN', '', 'JPN', 3, 'N', 'N', '', 192, NULL, 32, 'JAPAN', 'JAPON', 3999, 'N', '.jp', 'JP', 'JAPAN', 'JAPON', 'JAPÓN (EL)', '392', '81', NULL, 41, '2013-12-05', 'JPN');
INSERT INTO "dbgeral"."tb_pais" VALUES (34, 'COREIA, REPÚBLICA DA (COREIA DO SUL)', 4, 'COREANO', '043', 'S', 'KPW', 'WON', '', 'KOR', 3, 'N', 'N', '', 171, NULL, 207, 'KOREA, REPUBLIC OF', 'RÉP CORÉE', 1902, 'N', '.kr', 'KR', 'KOREA, REPUBLIC OF', 'CORÉE, RÉPUBLIQUE DE', 'REPÚBLICA DE COREA (LA)', '', '82', NULL, 43, '2013-12-05', 'KOR');
INSERT INTO "dbgeral"."tb_pais" VALUES (498, 'AALAND ISLANDS', NULL, NULL, NULL, 'S', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, 'AX', 'AALAND ISLANDS', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'ALA');
INSERT INTO "dbgeral"."tb_pais" VALUES (499, 'ANTARCTICA', NULL, NULL, NULL, 'S', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, 'AQ', 'ANTARCTICA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'ATA');
INSERT INTO "dbgeral"."tb_pais" VALUES (500, 'BOUVET ISLAND', NULL, NULL, NULL, 'S', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, 'BV', 'BOUVET ISLAND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'BVT');
INSERT INTO "dbgeral"."tb_pais" VALUES (501, 'BRITISH INDIAN OCEAN TERRITORY', NULL, NULL, NULL, 'S', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, 'IO', 'BRITISH INDIAN OCEAN TERRITORY', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'IOT');
INSERT INTO "dbgeral"."tb_pais" VALUES (502, 'FRENCH SOUTHERN TERRITORIES', NULL, NULL, NULL, 'S', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, 'TF', 'FRENCH SOUTHERN TERRITORIES', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'ATF');
INSERT INTO "dbgeral"."tb_pais" VALUES (114, 'HAITI', 2, 'HAITIANA', '073', 'S', 'HTG', 'GOURDE', '', 'HTI', 1, 'N', 'N', '', 55, NULL, 18, 'HAITI', 'HAÏTI', 3417, 'N', '.ht', 'HT', 'HAITI', 'HAÏTI', 'HAITÍ', '332', '509', NULL, NULL, '2013-12-05', 'HTI');
INSERT INTO "dbgeral"."tb_pais" VALUES (20, 'LIECHTENSTEIN', 4, 'LIECHTENSTEINIENSE', '100', 'S', 'CHF', 'FRANCO SUICO', '', 'LIE', 4, 'N', 'N', '', 157, NULL, 199, 'LIECHTENSTEIN', 'LIECHTENSTEIN', 4405, 'N', '.li', 'LI', 'LIECHTENSTEIN', 'LIECHTENSTEIN', 'LIECHTENSTEIN', '438', '423', NULL, NULL, '2013-12-05', 'LIE');
INSERT INTO "dbgeral"."tb_pais" VALUES (35, 'LUXEMBURGO', 4, 'LUXEMBURGUESA', '101', 'S', 'LUF', 'EURO', '', 'LUX', 4, 'N', 'N', '', 172, NULL, 208, 'LUXEMBOURG', 'LUXEMBOURG', 4456, 'N', '.lu', 'LU', 'LUXEMBOURG', 'LUXEMBOURG', 'LUXEMBURGO', '442', '352', NULL, NULL, '2013-12-05', 'LUX');
INSERT INTO "dbgeral"."tb_pais" VALUES (74, 'LESOTO', 2, 'LESOTA', '096', 'S', 'L', 'LOTI', '', 'LSO', 2, 'N', 'N', '', 15, NULL, 234, 'LESOTHO', 'LESOTHO', 4260, 'N', '.ls', 'LS', 'LESOTHO', 'LESOTHO', 'LESOTHO', '426', '266', NULL, NULL, '2013-12-05', 'LSO');
INSERT INTO "dbgeral"."tb_pais" VALUES (76, 'LIBERIA', 2, 'LIBERIANA', '098', 'S', 'LRD', 'LIBERIAN DOLLAR', '', 'LBR', 2, 'N', 'N', '', 17, NULL, 236, 'LIBERIA', 'LIBÉRIA', 4340, 'N', '.lr', 'LR', 'LIBERIA', 'LIBÉRIA', 'LIBERIA', '430', '231', NULL, NULL, '2013-12-05', 'LBR');
INSERT INTO "dbgeral"."tb_pais" VALUES (81, 'QUIRGUISTÃO', 2, 'QUIRGUIZ', '226', 'S', '', 'SOM', '', 'KGZ', 3, 'N', 'N', '', 22, NULL, 240, 'KYRGYZSTAN', 'KIRGHIZISTAN', 6254, 'N', '.kg', 'KG', 'KYRGYZSTAN', 'KIRGHIZISTAN', 'KIRGUISTÁN', '', '996', NULL, NULL, '2013-12-05', 'KGZ');
INSERT INTO "dbgeral"."tb_pais" VALUES (82, 'QUIRIBATI', 3, 'KIRIBATIANA', '257', 'S', 'AUD', 'DOLAR AUSTRALIANO', '', 'KIR', 4, 'N', 'N', '', 23, NULL, 241, 'KIRIBATI', 'KIRIBATI', 4111, 'N', '.ki', 'KI', 'KIRIBATI', 'KIRIBATI', 'KIRIBATI', '296', '686', NULL, NULL, '2013-12-05', 'KIR');
INSERT INTO "dbgeral"."tb_pais" VALUES (170, 'MADAGASCAR', 2, 'MALGAXE', '102', 'S', 'FMG', 'FRANCO MAGALASI', '', 'MDG', 2, 'N', 'N', '', 111, NULL, 298, 'MADAGASCAR', 'MADAGASCAR', 4502, 'N', '.mg', 'MG', 'MADAGASCAR', 'MADAGASCAR', 'MADAGASCAR', '450', '261', NULL, NULL, '2013-12-05', 'MDG');
INSERT INTO "dbgeral"."tb_pais" VALUES (171, 'MALASIA', 3, 'MALAIA', '103', 'S', 'MYR', 'RINGGIT', '', 'MYS', 3, 'N', 'N', '', 112, NULL, 129, 'MALAYSIA', 'MALAISIE', 4553, 'N', '.my', 'MY', 'MALAYSIA', 'MALAISIE', 'MALASIA', '458', '60', NULL, NULL, '2013-12-05', 'MYS');
INSERT INTO "dbgeral"."tb_pais" VALUES (163, 'HUNGRIA, REPUBLICA DA', 3, '', '076', 'S', 'HUF', 'FORINT', '', 'HUN', 4, 'N', 'N', '', 104, NULL, 141, 'HUNGARY', 'HONGRIE', 3557, 'N', '.hu', 'HU', 'HUNGARY', 'HONGRIE', 'HUNGRÍA', '345', '36', NULL, NULL, '2013-12-05', 'HUN');
INSERT INTO "dbgeral"."tb_pais" VALUES (164, 'INDIA', 3, 'INDIANA', '081', 'S', 'INR', 'RUPIA INDIANA', '', 'IND', 3, 'N', 'N', '', 105, NULL, 84, 'INDIA', 'INDE', 3611, 'N', '.in', 'IN', 'INDIA', 'INDE', 'INDIA (LA)', '356', '91', NULL, NULL, '2013-12-05', 'IND');
INSERT INTO "dbgeral"."tb_pais" VALUES (165, 'INDONESIA', 3, '', '082', 'S', 'IDR', 'RUPIA', '', 'IDN', 3, 'N', 'N', '', 106, NULL, 96, 'INDONESIA', 'INDONÉSIE', 3654, 'N', '.id', 'ID', 'INDONESIA', 'INDONÉSIE', 'INDONESIA', '360', '62', NULL, NULL, '2013-12-05', 'IDN');
INSERT INTO "dbgeral"."tb_pais" VALUES (16, 'IRAQUE', 3, 'IRAQUIANA', '084', 'S', 'IQD', 'DINAR IRAQUIANO', '', 'IRQ', 3, 'N', 'N', '', 153, NULL, 40, 'IRAQ', 'IRAQ', 3697, 'N', '.iq', 'IQ', 'IRAQ', 'IRAQ', 'IRAQ (EL)', '368', '964', NULL, NULL, '2013-12-05', 'IRQ');
INSERT INTO "dbgeral"."tb_pais" VALUES (17, 'IRLANDA', 4, 'IRLANDESA', '222', 'S', 'EUR', 'EURO', '', 'IRL', 4, 'N', 'N', '', 154, NULL, 197, 'IRELAND', 'IRLANDE', 3751, 'N', '.ie', 'IE', 'IRELAND', 'IRLANDE', 'IRLANDA', '372', '353', NULL, NULL, '2013-12-05', 'IRL');
INSERT INTO "dbgeral"."tb_pais" VALUES (166, 'JAMAICA', 3, 'JAMAICANA', '090', 'S', 'JMD', 'DOLLAR', '', 'JAM', 1, 'N', 'N', '', 107, NULL, 62, 'JAMAICA', 'JAMAÏQUE', 3913, 'N', '.jm', 'JM', 'JAMAICA', 'JAMAÏQUE', 'JAMAICA', '388', '1', NULL, NULL, '2013-12-05', 'JAM');
INSERT INTO "dbgeral"."tb_pais" VALUES (167, 'JORDANIA', 3, 'JORDANIANA', '092', 'S', 'JOD', 'DINAR JORDANICO', '', 'JOR', 3, 'N', 'N', '', 108, NULL, 36, 'JORDAN', 'JORDANIE', 4030, 'N', '.jo', 'JO', 'JORDAN', 'JORDANIE', 'JORDANIA', '400', '962', NULL, NULL, '2013-12-05', 'JOR');
INSERT INTO "dbgeral"."tb_pais" VALUES (127, 'QUENIA', 3, 'QUENIANA', '130', 'S', 'KES', 'SHILLING', '', 'KEN', 2, 'N', 'N', '', 68, NULL, 90, 'KENYA', 'KENYA', 6238, 'N', '.ke', 'KE', 'KENYA', 'KENYA', 'KENYA', '404', '254', NULL, NULL, '2013-12-05', 'KEN');
INSERT INTO "dbgeral"."tb_pais" VALUES (75, 'LIBANO', 2, 'LIBANESA', '097', 'S', 'LBP', 'LIBRA LIBANESA', '', 'LBN', 3, 'N', 'N', '', 16, NULL, 235, 'LEBANON', 'LIBAN', 4316, 'N', '.lb', 'LB', 'LEBANON', 'LIBAN', 'LÍBANO (EL)', '422', '961', NULL, NULL, '2013-12-05', 'LBN');
INSERT INTO "dbgeral"."tb_pais" VALUES (5, 'LIBIA', 3, 'LIBIO', '099', 'S', 'LYD', 'DINAR LIBANES', '', 'LBY', 2, 'N', 'N', '', 142, NULL, 188, 'LIBYAN ARAB JAMAHIRIYA', 'JAMAHIRIYA ARABE LIBYENNE', 4383, 'N', '.ly', 'LY', 'LIBYAN ARAB JAMAHIRIYA', 'LIBYENNE, JAMAHIRIYA ARABE', 'REPÚBLICA ÁRABE LIBIA POPULAR SOCIALISTA', '434', '218', NULL, NULL, '2013-12-05', 'LBY');
INSERT INTO "dbgeral"."tb_pais" VALUES (118, 'LITUANIA, REPUBLICA DA', 3, '', '233', 'S', 'LTL', 'LITAS', '', 'LTU', 4, 'N', 'N', '', 59, NULL, 297, 'LITHUANIA', 'LITUANIE', 4421, 'N', '.lt', 'LT', 'LITHUANIA', 'LITUANIE', 'LITUANIA', '440', '370', NULL, NULL, '2013-12-05', 'LTU');
INSERT INTO "dbgeral"."tb_pais" VALUES (232, 'MACAU', NULL, 'MACAUENSE', '', 'S', 'MOP', 'PATACA', '', 'MAC', 3, 'N', 'N', '', NULL, NULL, 374, 'MACAU', 'MACAO', 4472, 'N', '.mo', 'MO', 'MACAO', 'MACAO', 'MACAO', '446', '853', NULL, NULL, '2013-12-05', 'MAC');
INSERT INTO "dbgeral"."tb_pais" VALUES (233, 'MARTINICA', NULL, 'MARTINIQUENSE', '', 'S', '', 'EURO', '', 'MTQ', 1, 'N', 'N', '', NULL, NULL, 375, 'MARTINIQUE', 'MARTINIQUE', 4774, 'N', '.mq', 'MQ', 'MARTINIQUE', 'MARTINIQUE', '', '474', '596', NULL, NULL, '2013-12-05', 'MTQ');
INSERT INTO "dbgeral"."tb_pais" VALUES (234, 'MAYOTTE, ILHA', NULL, 'MAYOTTINA', '', 'S', 'EUR', 'EURO', '', 'MYT', 2, 'N', 'N', '', NULL, NULL, 376, 'MAYOTTE', 'MAYOTTE', NULL, 'N', '.yt', 'YT', 'MAYOTTE', 'MAYOTTE', '', '175', '269', NULL, NULL, '2013-12-05', 'MYT');
INSERT INTO "dbgeral"."tb_pais" VALUES (21, 'MEXICO', 3, 'MEXICANA', '111', 'S', 'MXP', 'PESO MEXICANO', '', 'MEX', 1, 'S', 'N', '', 158, NULL, 106, 'MEXICO', 'MEXIQUE', 4936, 'N', '.mx', 'MX', 'MEXICO', 'MEXIQUE', 'MÉXICO', '484', '52', NULL, NULL, '2013-12-05', 'MEX');
INSERT INTO "dbgeral"."tb_pais" VALUES (174, 'MICRONESIA, ESTADOS FEDERADOS DA', 2, 'MICRONÉSIO', '261', 'S', 'USD', 'DOLAR AMERICANO', '', 'FSM', 5, 'N', 'N', '', 115, NULL, 384, 'MICRONESIA, FEDERATED STATES OF', 'MICRONÉSIE (ÉTATS FÉDÉRÉS DE)', 4995, 'N', '.fm', 'FM', 'MICRONESIA, FEDERATED STATES OF', 'MICRONÉSIE (ÉTATS FÉDÉRÉS DE)', 'MICRONESIA (ESTADOS FEDERADOS DE)', '583', '691', NULL, NULL, '2013-12-05', 'FSM');
INSERT INTO "dbgeral"."tb_pais" VALUES (122, 'MOLDÁVIA, REPUBLICA DA', 4, 'MOLDOVANO, MOLDAVIANO', '235', 'S', 'MDL', 'LEU', '', 'MDA', 4, 'N', 'N', '', 212, NULL, 269, 'MOLDOVA, REPUBLIC OF', 'MOLDOVA', 4944, 'N', '.md', 'MD', 'MOLDOVA, REPUBLIC OF', 'MOLDOVA', 'MOLDOVA', '498', '373', NULL, NULL, '2013-12-05', 'MDA');
INSERT INTO "dbgeral"."tb_pais" VALUES (56, 'MONACO', 5, '', '113', 'S', 'EUR', 'EURO', '', 'MCO', 4, 'N', 'N', '', 193, NULL, 219, 'MONACO', 'MONACO', 4952, 'N', '.mc', 'MC', 'MONACO', 'MONACO', 'MÓNACO', '492', '377', NULL, NULL, '2013-12-05', 'MCO');
INSERT INTO "dbgeral"."tb_pais" VALUES (235, 'MONTSERRAT', NULL, 'MONTSERRATIANA', '', 'S', 'EC$', 'DOLAR DO LESTE DO CARIBE', '', 'MSR', 1, 'N', 'N', '', NULL, NULL, 377, 'MONTSERRAT', 'MONTSERRAT', 5010, 'N', '.ms', 'MS', 'MONTSERRAT', 'MONTSERRAT', 'MONTSERRAT', '500', '1', NULL, NULL, '2013-12-05', 'MSR');
INSERT INTO "dbgeral"."tb_pais" VALUES (6, 'MARROCOS', 3, '', '108', 'S', 'MAD', 'DIRHAM', '', 'MAR', 2, 'N', 'N', '', 143, NULL, 189, 'MOROCCO', 'MAROC', 4740, 'N', '.ma', 'MA', 'MOROCCO', 'MAROC', 'MARRUECOS', '504', '212', NULL, NULL, '2013-12-05', 'MAR');
INSERT INTO "dbgeral"."tb_pais" VALUES (22, 'MOCAMBIQUE', 3, '', '112', 'S', 'MT', 'METICAL', '', 'MOZ', 2, 'N', 'N', '', 159, NULL, 4, 'MOZAMBIQUE', 'MOZAMBIQUE', 5053, 'N', '.mz', 'MZ', 'MOZAMBIQUE', 'MOZAMBIQUE', 'MOZAMBIQUE', '508', '258', NULL, NULL, '2013-12-05', 'MOZ');
INSERT INTO "dbgeral"."tb_pais" VALUES (62, 'MYANMAR', 2, 'BIRMANÊS-BIRMÃ-MIANMARENSE', '', 'N', 'MMK', 'QUIATE', '', 'MMR', 3, 'N', 'N', '', 3, NULL, 224, 'MYANMAR', 'MYANMAR (BIRMANIE)', 930, 'N', '.mm', 'MM', 'MYANMAR', 'MYANMAR', 'MYANMAR', '104', '95', NULL, NULL, '2013-12-05', 'MMR');
INSERT INTO "dbgeral"."tb_pais" VALUES (37, 'PAISES BAIXOS (HOLANDA)', 4, 'NEERLANDES', '', 'S', 'EUR', 'EURO', '', 'NLD', 4, 'N', 'N', '', 174, NULL, 37, 'NETHERLANDS', 'PAYS-BAS', 5738, 'N', '.nl', 'NL', 'NETHERLANDS', 'PAYS-BAS', 'PAISES BAJOS', '528', '31', NULL, NULL, '2013-12-05', 'NLD');
INSERT INTO "dbgeral"."tb_pais" VALUES (236, 'NOVA CALEDONIA', NULL, 'NEOCALEDONIO', '', 'S', 'CFP', 'FRANCO DO PACIFICO', '', 'NCL', 5, 'N', 'N', '', NULL, NULL, 378, 'NEW CALEDONIA', 'NOUVELLE-CALÉDONIE', 5428, 'N', '.nc', 'NC', 'NEW CALEDONIA', 'NOUVELLE-CALÉDONIE', 'NUEVA CALEDONIA', '540', '687', NULL, NULL, '2013-12-05', 'NCL');
INSERT INTO "dbgeral"."tb_pais" VALUES (178, 'NOVA ZELANDIA', 3, 'NEOZELANDES', '121', 'S', 'NZD', 'DOLAR DA NOVA ZELAND', '', 'NZL', 5, 'N', 'N', '', 119, NULL, 128, 'NEW ZEALAND', 'NOUVELLE-ZÉLANDE', 5487, 'N', '.nz', 'NZ', 'NEW ZEALAND', 'NOUVELLE-ZÉLANDE', 'NUEVA ZELANDIA', '554', '64', NULL, NULL, '2013-12-05', 'NZL');
INSERT INTO "dbgeral"."tb_pais" VALUES (175, 'NICARÁGUA', 2, 'NICARAGUENSE', '117', 'S', 'NIO', 'CORDOBA', '', 'NIC', 1, 'S', 'N', '', 116, NULL, 302, 'NICARAGUA', 'NICARAGUA', 5215, 'N', '.ni', 'NI', 'NICARAGUA', 'NICARAGUA', 'NICARAGUA', '558', '505', NULL, NULL, '2013-12-05', 'NIC');
INSERT INTO "dbgeral"."tb_pais" VALUES (177, 'NIGÉRIA', 3, '', '119', 'S', 'NGN', 'NAIRA', '', 'NGA', 2, 'N', 'N', '', 118, NULL, 147, 'NIGERIA', 'NIGÉRIA', 5282, 'N', '.ng', 'NG', 'NIGERIA', 'NIGÉRIA', 'NIGERIA', '566', '234', NULL, NULL, '2013-12-05', 'NGA');
INSERT INTO "dbgeral"."tb_pais" VALUES (215, 'NORFOLK, ILHA', NULL, 'NORFOLKER', '', 'S', 'AUD', 'DOLAR AUSTRALIANO', '', 'NFK', 5, 'N', 'N', '', NULL, NULL, 357, 'NORFOLK ISLAND', 'ÎLE NORFOLK', 5355, 'N', '.nf', 'NF', 'NORFOLK ISLAND', 'ÎLE NORFOLK', 'ISLA NORFOLK', '574', '672', NULL, NULL, '2013-12-05', 'NFK');
INSERT INTO "dbgeral"."tb_pais" VALUES (195, 'COREIA, REPÚBLICA POPULAR DEMOCRÁTICA DA (COREIA DO NORTE)', 3, 'NORTE COREANA', '042', 'S', 'KPW', 'WON NORTE COREANO', '', 'PRK', 3, 'N', 'N', '', 208, NULL, 315, 'KOREA, DEMOCRATIC PEOPLE''S REPUBLIC OF', 'RÉP. POP. DÉM. CORÉE', 1872, 'N', '.kp', 'KP', 'KOREA, DEMOCRATIC PEOPLE''S REPUBLIC OF', 'CORÉE, RÉPUBLIQUE POPULAIRE DÉMOCRATIQUE DE', 'REPÚBLICA POPULAR DEMOCRÁTICA DE COREA (LA)', '', '850', NULL, NULL, '2013-12-05', 'PRK');
INSERT INTO "dbgeral"."tb_pais" VALUES (73, 'LAOS, REPÚBLICA DEMOCRÁTICA POPULAR', 2, 'LAOSIANO', '095', 'S', 'LAK', 'KIP', '', 'LAO', 3, 'N', 'N', '', 14, NULL, 233, 'LAO PEOPLE''S DEMOCRATIC REPUBLIC', 'RÉPUBLIQUE POPULAIRE DÉMOCRATIQUE LAO', 4200, 'N', '.la', 'LA', 'LAO PEOPLE''S DEMOCRATIC REPUBLIC', 'RÉPUBLIQUE POPULAIRE DÉMOCRATIQUE LAO', 'REPÚBLICA DEMOCRÁTICA POPULAR LAO', '418', '856', NULL, NULL, '2013-12-05', 'LAO');
INSERT INTO "dbgeral"."tb_pais" VALUES (36, 'MALDIVAS', 4, 'MALDÍVIA', '105', 'S', 'MRF', 'RUPIA MALDIVA', '', 'MDV', 3, 'N', 'N', '', 173, NULL, 209, 'MALDIVES', 'MALDIVES', 4618, 'N', '.mv', 'MV', 'MALDIVES', 'MALDIVES', 'MALDIVAS', '462', '960', NULL, NULL, '2013-12-05', 'MDV');
INSERT INTO "dbgeral"."tb_pais" VALUES (59, 'ANTILHAS HOLANDESAS', 4, 'ANTILHANO', '173', 'S', 'ANG', 'GUILDER', '', 'ANT', 1, 'N', 'N', '', 196, NULL, 221, 'NETHERLANDS ANTILLES', 'ANTILLES NÉERLANDAISES', 477, 'N', '.an', 'AN', 'NETHERLANDS ANTILLES', 'ANTILLES NÉERLANDAISES', '', '530', '599', NULL, NULL, '2013-12-05', 'ANT');
INSERT INTO "dbgeral"."tb_pais" VALUES (63, 'NAURU', 2, 'NAURUANA', '115', 'S', 'AUD', 'DOLAR', '', 'NRU', 5, 'N', 'N', '', 4, NULL, 385, 'NAURU', 'NAURU', 5088, 'N', '.nr', 'NR', 'NAURU', 'NAURU', 'NAURU', '520', '674', NULL, NULL, '2013-12-05', 'NRU');
INSERT INTO "dbgeral"."tb_pais" VALUES (77, 'MALI', 2, 'MAILANO', '106', 'S', 'CFA', 'FRANCO CFA', '', 'MLI', 2, 'N', 'N', '', 18, NULL, 237, 'MALI', 'MALI', 4642, 'N', '.ml', 'ML', 'MALI', 'MALI', 'MALÍ', '466', '223', NULL, NULL, '2013-12-05', 'MLI');
INSERT INTO "dbgeral"."tb_pais" VALUES (78, 'MONGOLIA', 2, 'MONGOL', '114', 'S', 'TUG', 'TUGRIK/TOGROG', '', 'MNG', 3, 'N', 'N', '', 19, NULL, 238, 'MONGOLIA', 'MONGOLIE', 4979, 'N', '.mn', 'MN', 'MONGOLIA', 'MONGOLIE', 'MONGOLIA', '496', '976', NULL, NULL, '2013-12-05', 'MNG');
INSERT INTO "dbgeral"."tb_pais" VALUES (79, 'NAMÍBIA', 3, 'NAMIBIANA', '206', 'S', 'NAD', 'DOLAR NAMIBIANO', '', 'NAM', 2, 'N', 'N', '', 20, NULL, 110, 'NAMIBIA', 'NAMIBIE', 5070, 'N', '.na', 'NA', 'NAMIBIA', 'NAMIBIE', 'NAMIBIA', '516', '264', NULL, NULL, '2013-12-05', 'NAM');
INSERT INTO "dbgeral"."tb_pais" VALUES (80, 'NIUE, ILHA', 3, 'NIUEANA', '207', 'S', '', 'NEW ZEALAND DOLAR', '', 'NIU', 5, 'N', 'N', '', 21, NULL, 239, 'NIUE', 'NIUÉ', 5312, 'N', '.nu', 'NU', 'NIUE', 'NIUÉ', '', '570', '683', NULL, NULL, '2013-12-05', 'NIU');

-- ----------------------------
-- Table structure for tb_raca_cor
-- ----------------------------
DROP TABLE IF EXISTS "dbgeral"."tb_raca_cor";
CREATE TABLE "dbgeral"."tb_raca_cor" (
  "co_raca_cor" varchar(2) COLLATE "pg_catalog"."default" NOT NULL,
  "ds_raca_cor" varchar(25) COLLATE "pg_catalog"."default",
  "st_registro_ativo" varchar(1) COLLATE "pg_catalog"."default",
  "st_cadsus" varchar(1) COLLATE "pg_catalog"."default" DEFAULT 'S'::character varying,
  "st_cnes" varchar(1) COLLATE "pg_catalog"."default" DEFAULT 'S'::character varying,
  "co_raca" varchar(1) COLLATE "pg_catalog"."default",
  "co_raca_cor_portaria" varchar(2) COLLATE "pg_catalog"."default" NOT NULL
)
;
COMMENT ON COLUMN "dbgeral"."tb_raca_cor"."co_raca_cor" IS 'Código da raça/cor.';
COMMENT ON COLUMN "dbgeral"."tb_raca_cor"."ds_raca_cor" IS 'Descrição da raça/cor. Ex: Negro.';
COMMENT ON COLUMN "dbgeral"."tb_raca_cor"."st_registro_ativo" IS 'Indica se o registro está ativo na tabela. Utilizado como indicativo de registro deletado logicamente.';
COMMENT ON COLUMN "dbgeral"."tb_raca_cor"."st_cadsus" IS 'Status utilizado como filtro para compor os domínios das tabelas do sistema CADSUS do RJ. Domínio: S - sim, N - não.';
COMMENT ON COLUMN "dbgeral"."tb_raca_cor"."st_cnes" IS 'Status utilizado como filtro para compor os domínios das tabelas do sistema CNES do RJ. Domínio: S - Utilizado pelo CNES, N - Não utilizado pelo CNES.';
COMMENT ON COLUMN "dbgeral"."tb_raca_cor"."co_raca" IS 'Código utilizado pelo CNES (DE/PARA): 1-Branca, 2-Preta, 3-Amarela, 4-Parda, 5-Indigena, 9-Sem Informação e X-Invalido';
COMMENT ON COLUMN "dbgeral"."tb_raca_cor"."co_raca_cor_portaria" IS 'Código utilizado de acordo com a PORTARIA N° 719, DE 28 DE DEZEMBRO DE 2007: 01-Branca, 02-Preta, 03-Parda, 04-Amarela, 05-Indígena, 99-Sem Informação e X-Inválido, em atendimento ao Art. 1º no que se refere aos Sistemas SIA/SIH/SUS, para efetivação do registro nos instrumentos de coleta de dados de identificação do usuário do SUS, atendendo a classificação expressada pelo próprio usuário ou seu responsável.';
COMMENT ON TABLE "dbgeral"."tb_raca_cor" IS 'Esta tabela contém os códigos e as respectivas descrições da etnia dos povos indígenas em atendimento a PORTARIA Nº 508, DE 28 DE SETEMBRO DE 2010 e, os códigos referentes a PORTARIA N° 719, DE 28 DE DEZEMBRO DE 2007 para efetivação do registro nos instrumentos de coleta de dados de identificação do usuário do SUS, atendendo a classificação expressada pelo próprio usuário ou seu responsável';

-- ----------------------------
-- Records of tb_raca_cor
-- ----------------------------
INSERT INTO "dbgeral"."tb_raca_cor" VALUES ('X', 'INVALIDO', 'N', 'S', 'S', 'X', 'X');
INSERT INTO "dbgeral"."tb_raca_cor" VALUES ('01', 'BRANCA', 'S', 'S', 'S', '1', '01');
INSERT INTO "dbgeral"."tb_raca_cor" VALUES ('03', 'AMARELA', 'S', 'S', 'S', '3', '04');
INSERT INTO "dbgeral"."tb_raca_cor" VALUES ('04', 'PARDA', 'S', 'S', 'S', '4', '03');
INSERT INTO "dbgeral"."tb_raca_cor" VALUES ('05', 'INDIGENA', 'S', 'S', 'S', '5', '05');
INSERT INTO "dbgeral"."tb_raca_cor" VALUES ('99', 'SEM INFORMACAO', 'S', 'S', 'S', '9', '99');
INSERT INTO "dbgeral"."tb_raca_cor" VALUES ('02', 'PRETA', 'S', 'S', 'S', '2', '02');

-- ----------------------------
-- Table structure for tb_sexo
-- ----------------------------
DROP TABLE IF EXISTS "dbgeral"."tb_sexo";
CREATE TABLE "dbgeral"."tb_sexo" (
  "co_sexo" varchar(1) COLLATE "pg_catalog"."default" NOT NULL,
  "ds_sexo" varchar(10) COLLATE "pg_catalog"."default",
  "st_registro_ativo" varchar(1) COLLATE "pg_catalog"."default",
  "st_cadsus" varchar(1) COLLATE "pg_catalog"."default" DEFAULT 'S'::character varying
)
;
COMMENT ON COLUMN "dbgeral"."tb_sexo"."co_sexo" IS 'c¢digo do sexo da pessoa';
COMMENT ON COLUMN "dbgeral"."tb_sexo"."ds_sexo" IS 'Descrição do sexo da pessoa. Ex: Feminino.';
COMMENT ON COLUMN "dbgeral"."tb_sexo"."st_registro_ativo" IS 'Indica se o registro está ativo.';
COMMENT ON COLUMN "dbgeral"."tb_sexo"."st_cadsus" IS 'Status utilizado como filtro para compor os domínios das tabelas do sistema CADSUS do RJ. S - sim, N - não.';
COMMENT ON TABLE "dbgeral"."tb_sexo" IS 'Contém informações sobre os sexos existentes.';

-- ----------------------------
-- Records of tb_sexo
-- ----------------------------
INSERT INTO "dbgeral"."tb_sexo" VALUES ('M', 'MASCULINO', 'S', 'S');
INSERT INTO "dbgeral"."tb_sexo" VALUES ('F', 'FEMININO', 'S', 'S');
INSERT INTO "dbgeral"."tb_sexo" VALUES ('I', 'IGNORADO', 'S', 'S');
INSERT INTO "dbgeral"."tb_sexo" VALUES ('X', 'INVALIDO', 'N', 'S');

-- ----------------------------
-- Table structure for tb_uf
-- ----------------------------
DROP TABLE IF EXISTS "dbgeral"."tb_uf";
CREATE TABLE "dbgeral"."tb_uf" (
  "co_uf_ibge" varchar(2) COLLATE "pg_catalog"."default" NOT NULL,
  "sg_uf" varchar(2) COLLATE "pg_catalog"."default" NOT NULL,
  "co_regiao" varchar(1) COLLATE "pg_catalog"."default",
  "co_pais" numeric(3,0),
  "no_uf" varchar(30) COLLATE "pg_catalog"."default",
  "co_uf_sinpas" varchar(2) COLLATE "pg_catalog"."default",
  "nu_area" numeric(11,3),
  "co_uf_ldo" varchar(4) COLLATE "pg_catalog"."default",
  "nu_latitude" varchar(10) COLLATE "pg_catalog"."default",
  "co_uf_inss" varchar(2) COLLATE "pg_catalog"."default",
  "co_uf_siafi" varchar(2) COLLATE "pg_catalog"."default",
  "nu_longitude" varchar(10) COLLATE "pg_catalog"."default",
  "nu_ordem_regiao" numeric(2,0),
  "ds_naturalidade" varchar(50) COLLATE "pg_catalog"."default",
  "co_municipio_ibge_capital" varchar(6) COLLATE "pg_catalog"."default",
  "st_registro_ativo" varchar(1) COLLATE "pg_catalog"."default",
  "co_estado_svs" numeric(2,0),
  "no_uf_acentuado" varchar(30) COLLATE "pg_catalog"."default",
  "co_iso_3166_2" varchar(5) COLLATE "pg_catalog"."default",
  "st_cadsus" varchar(1) COLLATE "pg_catalog"."default" DEFAULT 'S'::character varying
)
;
COMMENT ON COLUMN "dbgeral"."tb_uf"."co_uf_ibge" IS 'Código IBGE da Unidade da Federação.';
COMMENT ON COLUMN "dbgeral"."tb_uf"."sg_uf" IS 'Sigla da Unidade da Federação';
COMMENT ON COLUMN "dbgeral"."tb_uf"."co_regiao" IS 'Código IBGE da Região. Chave estrangeira com origem em TB_REGIAO.';
COMMENT ON COLUMN "dbgeral"."tb_uf"."co_pais" IS 'Sequencial de identificação do País. Chave estrangeira com origem em TB_PAIS.';
COMMENT ON COLUMN "dbgeral"."tb_uf"."no_uf" IS 'Nome da Unidade da Federação';
COMMENT ON COLUMN "dbgeral"."tb_uf"."co_uf_sinpas" IS 'Código SINPAS (Sistema Integrado de Previdência e Assistência Social) da Unidade da Federação.';
COMMENT ON COLUMN "dbgeral"."tb_uf"."nu_area" IS 'Área em Km² da Unidade da Federação (Resolução 05 10/10/2002 - IBGE).';
COMMENT ON COLUMN "dbgeral"."tb_uf"."co_uf_ldo" IS 'Código da Lei de Diretrizes Orçamentárias.';
COMMENT ON COLUMN "dbgeral"."tb_uf"."nu_latitude" IS 'Latitude da Unidade da Federação';
COMMENT ON COLUMN "dbgeral"."tb_uf"."co_uf_inss" IS 'Código da Unidade da Federação no INSS.';
COMMENT ON COLUMN "dbgeral"."tb_uf"."co_uf_siafi" IS 'Código da Unidade da Federação no SIAFI.';
COMMENT ON COLUMN "dbgeral"."tb_uf"."nu_longitude" IS 'Longitude da Unidade da Federação';
COMMENT ON COLUMN "dbgeral"."tb_uf"."nu_ordem_regiao" IS 'Indica o número de ordem da UF na sua região. CO_REGIAO + NU_ORDEM_REGIAO = CO_UF_IBGE Exceto Mato Grosso do Sul.';
COMMENT ON COLUMN "dbgeral"."tb_uf"."ds_naturalidade" IS 'Descrição da naturalidade de quem nasceu na Unidade da Federação';
COMMENT ON COLUMN "dbgeral"."tb_uf"."co_municipio_ibge_capital" IS 'Código IBGE do Município capital da Unidade da Federação. Chave estrangeira com origem em TB_MUNICIPIO.';
COMMENT ON COLUMN "dbgeral"."tb_uf"."st_registro_ativo" IS 'Indica se o registro está ativo.';
COMMENT ON COLUMN "dbgeral"."tb_uf"."co_estado_svs" IS 'Código do estado conforme a tabela utilizada pela SVS.';
COMMENT ON COLUMN "dbgeral"."tb_uf"."no_uf_acentuado" IS 'nome uf acentuado';
COMMENT ON COLUMN "dbgeral"."tb_uf"."co_iso_3166_2" IS 'Baseado na ISO 3166-2:BR.Trata-se de um sistema de geocódigo criado para codificar os nomes das subdivisões de países e áreas dependentes';
COMMENT ON COLUMN "dbgeral"."tb_uf"."st_cadsus" IS 'Status utilizado como filtro para compor os domínios das tabelas do sistema CADSUS do RJ. S - sim, N - não.';
COMMENT ON TABLE "dbgeral"."tb_uf" IS 'Tabela Contém informações referentes às Unidades Federativas.';

-- ----------------------------
-- Records of tb_uf
-- ----------------------------
INSERT INTO "dbgeral"."tb_uf" VALUES ('XX', 'XX', NULL, NULL, 'INVALIDA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, 'INVÁLIDA', NULL, 'S');
INSERT INTO "dbgeral"."tb_uf" VALUES ('11', 'RO', '1', 1, 'RONDONIA', '26', 238512.800, '0011', '-8,75729', NULL, '41', '-63,90237', 2, 'RONDONENSE', '110020', 'S', NULL, 'RONDÔNIA', 'BR-RO', 'S');
INSERT INTO "dbgeral"."tb_uf" VALUES ('12', 'AC', '1', 1, 'ACRE', '24', 153149.900, '0012', '-9,97158', NULL, '01', '-67,80610', 1, 'ACREANO', '120040', 'S', NULL, 'ACRE', 'BR-AC', 'S');
INSERT INTO "dbgeral"."tb_uf" VALUES ('13', 'AM', '1', 1, 'AMAZONAS', '03', 1577820.200, '0013', '-3,10119', NULL, '05', '-60,02175', 3, 'AMAZONENSE', '130260', 'S', NULL, 'AMAZONAS', 'BR-AM', 'S');
INSERT INTO "dbgeral"."tb_uf" VALUES ('14', 'RR', '1', 1, 'RORAIMA', '27', 225116.100, '0014', '2,81853', NULL, '42', '-60,67073', 4, 'RORAIMENSE', '140010', 'S', NULL, 'RORAIMA', 'BR-RR', 'S');
INSERT INTO "dbgeral"."tb_uf" VALUES ('15', 'PA', '1', 1, 'PARA', '12', 1253164.500, '0015', '-1,45356', NULL, '25', '-48,50271', 5, 'PARAENSE', '150140', 'S', NULL, 'PARÁ', 'BR-PA', 'S');
INSERT INTO "dbgeral"."tb_uf" VALUES ('16', 'AP', '1', 1, 'AMAPA', '25', 143453.700, '0016', '-0,03672', NULL, '04', '-51,06000', 6, 'AMAPAENSE', '160030', 'S', NULL, 'AMAPÁ', 'BR-AP', 'S');
INSERT INTO "dbgeral"."tb_uf" VALUES ('17', 'TO', '1', 1, 'TOCANTINS', '28', 27842070.000, '0017', '-10,20779', NULL, '48', '-48,35627', 7, 'TOCANTINENSE', '172100', 'S', NULL, 'TOCANTINS', 'BR-TO', 'S');
INSERT INTO "dbgeral"."tb_uf" VALUES ('21', 'MA', '2', 1, 'MARANHAO', '09', 333365.600, '0021', '-2,52463', NULL, '17', '-44,30169', 1, 'MARANHENSE', '211130', 'S', NULL, 'MARANHÃO', 'BR-MA', 'S');
INSERT INTO "dbgeral"."tb_uf" VALUES ('22', 'PI', '2', 1, 'PIAUI', '16', 252378.500, '0022', '-5,08689', NULL, '33', '-42,80119', 2, 'PIAUIENSE', '221100', 'S', NULL, 'PIAUÍ', 'BR-PI', 'S');
INSERT INTO "dbgeral"."tb_uf" VALUES ('23', 'CE', '2', 1, 'CEARA', '05', 146348.300, '0023', '-3,71701', NULL, '09', '-38,53926', 3, 'CEARENSE', '230440', 'S', NULL, 'CEARÁ', 'BR-CE', 'S');
INSERT INTO "dbgeral"."tb_uf" VALUES ('24', 'RN', '2', 1, 'RIO GRANDE DO NORTE', '18', 53306.800, '0024', '-5,79045', NULL, '37', '-35,20576', 4, 'RIOGRANDENSE', '240810', 'S', NULL, 'RIO GRANDE DO NORTE', 'BR-RN', 'S');
INSERT INTO "dbgeral"."tb_uf" VALUES ('25', 'PB', '2', 1, 'PARAIBA', '13', 56584.600, '0025', '-7,10915', NULL, '27', '-34,85796', 5, 'PARAIBANO', '250750', 'S', NULL, 'PARAÍBA', 'BR-PB', 'S');
INSERT INTO "dbgeral"."tb_uf" VALUES ('26', 'PE', '2', 1, 'PERNAMBUCO', '15', 98937.800, '0026', '-8,05237', NULL, '31', '-34,87548', 6, 'PERNAMBUCANO', '261160', 'S', NULL, 'PERNAMBUCO', 'BR-PE', 'S');
INSERT INTO "dbgeral"."tb_uf" VALUES ('27', 'AL', '2', 1, 'ALAGOAS', '02', 27933.100, '0027', '-9,65966', NULL, '03', '-35,73452', 7, 'ALAGOANO', '270430', 'S', NULL, 'ALAGOAS', 'BR-AL', 'S');
INSERT INTO "dbgeral"."tb_uf" VALUES ('28', 'SE', '2', 1, 'SERGIPE', '22', 22050.400, '0028', '-10,90678', NULL, '47', '-37,06972', 8, 'SERGIPANO', '280030', 'S', NULL, 'SERGIPE', 'BR-SE', 'S');
INSERT INTO "dbgeral"."tb_uf" VALUES ('29', 'BA', '2', 1, 'BAHIA', '04', 567295.300, '0029', '-12,96938', NULL, '07', '-38,50661', 9, 'BAIANO', '292740', 'S', NULL, 'BAHIA', 'BR-BA', 'S');
INSERT INTO "dbgeral"."tb_uf" VALUES ('31', 'MG', '3', 1, 'MINAS GERAIS', '11', 588383.600, '0031', '-19,91921', NULL, '23', '-43,93604', 1, 'MINEIRO', '310620', 'S', NULL, 'MINAS GERAIS', 'BR-MG', 'S');
INSERT INTO "dbgeral"."tb_uf" VALUES ('32', 'ES', '3', 1, 'ESPIRITO SANTO', '07', 46184.100, '0032', '-20,31836', NULL, '13', '-40,33604', 2, 'CAPIXABA', '320530', 'S', NULL, 'ESPÍRITO SANTO', 'BR-ES', 'S');
INSERT INTO "dbgeral"."tb_uf" VALUES ('33', 'RJ', '3', 1, 'RIO DE JANEIRO', '17', 43909.700, '0033', '-22,90169', NULL, '35', '-43,20458', 3, 'FLUMINENSE', '330455', 'S', NULL, 'RIO DE JANEIRO', 'BR-RJ', 'S');
INSERT INTO "dbgeral"."tb_uf" VALUES ('35', 'SP', '3', 1, 'SAO PAULO', '21', 248808.800, '0035', '-23,54198', NULL, '45', '-46,63503', 5, 'PAULISTA', '355030', 'S', NULL, 'SÃO PAULO', 'BR-SP', 'S');
INSERT INTO "dbgeral"."tb_uf" VALUES ('41', 'PR', '4', 1, 'PARANA', '14', 199709.100, '0041', '-25,42344', NULL, '29', '-49,27056', 1, 'PARANAENSE', '410690', 'S', NULL, 'PARANÁ', 'BR-PR', 'S');
INSERT INTO "dbgeral"."tb_uf" VALUES ('42', 'SC', '4', 1, 'SANTA CATARINA', '20', 95442.900, '0042', '-27,59147', NULL, '43', '-48,54299', 2, 'CATARINENSE', '420540', 'S', NULL, 'SANTA CATARINA', 'BR-SC', 'S');
INSERT INTO "dbgeral"."tb_uf" VALUES ('43', 'RS', '4', 1, 'RIO GRANDE DO SUL', '19', 282062.000, '0043', '-30,02666', NULL, '39', '-51,22480', 3, 'GAUCHO', '431490', 'S', NULL, 'RIO GRANDE DO SUL', 'BR-RS', 'S');
INSERT INTO "dbgeral"."tb_uf" VALUES ('50', 'MS', '5', 1, 'MATO GROSSO DO SUL', '06', 358158.700, '0054', '-20,43909', NULL, '21', '-54,64130', 4, 'SUL MATO GROSSENSE', '500270', 'S', NULL, 'MATO GROSSO DO SUL', 'BR-MS', 'S');
INSERT INTO "dbgeral"."tb_uf" VALUES ('51', 'MT', '5', 1, 'MATO GROSSO', '10', 906806.900, '0051', '-15,59113', NULL, '19', '-56,09147', 1, 'MATO GROSSENSE', '510340', 'S', NULL, 'MATO GROSSO', 'BR-MT', 'S');
INSERT INTO "dbgeral"."tb_uf" VALUES ('52', 'GO', '5', 1, 'GOIAS', '08', 341289.500, '0052', '-16,67395', NULL, '15', '-49,25237', 2, 'GOIANO', '520870', 'S', NULL, 'GOIÁS', 'BR-GO', 'S');
INSERT INTO "dbgeral"."tb_uf" VALUES ('53', 'DF', '5', 1, 'DISTRITO FEDERAL', '23', 5822.100, '0053', '-15,77463', NULL, '11', '-47,92463', 3, 'BRASILIENSE', '530010', 'S', NULL, 'DISTRITO FEDERAL', 'BR-DF', 'S');

-- ----------------------------
-- Checks structure for table tb_municipio
-- ----------------------------
ALTER TABLE "dbgeral"."tb_municipio" ADD CONSTRAINT "ck_municipiostregistroativo" CHECK (st_registro_ativo::text = 'N'::text OR st_registro_ativo::text = 'S'::text);
ALTER TABLE "dbgeral"."tb_municipio" ADD CONSTRAINT "ck_municipio_stseca" CHECK (st_seca::text = 'S'::text OR st_seca::text = 'N'::text);
ALTER TABLE "dbgeral"."tb_municipio" ADD CONSTRAINT "ck_municipio_stprmi" CHECK (st_prmi::text = 'S'::text OR st_prmi::text = 'N'::text);
ALTER TABLE "dbgeral"."tb_municipio" ADD CONSTRAINT "ck_municipio_stindigena" CHECK (st_indigena::text = 'S'::text OR st_indigena::text = 'N'::text);
ALTER TABLE "dbgeral"."tb_municipio" ADD CONSTRAINT "ck_municipio_stcomunsolidaria" CHECK (st_comunidade_solidaria::text = 'S'::text OR st_comunidade_solidaria::text = 'N'::text);
ALTER TABLE "dbgeral"."tb_municipio" ADD CONSTRAINT "ck_municipio_stcapital" CHECK (st_capital::text = 'N'::text OR st_capital::text = 'S'::text);
ALTER TABLE "dbgeral"."tb_municipio" ADD CONSTRAINT "ck_municipio_stcalamidade" CHECK (st_calamidade::text = 'S'::text OR st_calamidade::text = 'N'::text);
ALTER TABLE "dbgeral"."tb_municipio" ADD CONSTRAINT "ck_municipio_grupopac2" CHECK (co_grupo_pac2::text = ANY (ARRAY[NULL::character varying::text, '01'::character varying::text, '02'::character varying::text, '03'::character varying::text]));
ALTER TABLE "dbgeral"."tb_municipio" ADD CONSTRAINT "nn_municipio_nomunicipio" CHECK (no_municipio IS NOT NULL);
ALTER TABLE "dbgeral"."tb_municipio" ADD CONSTRAINT "nn_municipio_comunicipioibge" CHECK (co_municipio_ibge IS NOT NULL);

-- ----------------------------
-- Primary Key structure for table tb_municipio
-- ----------------------------
ALTER TABLE "dbgeral"."tb_municipio" ADD CONSTRAINT "pk_municipio" PRIMARY KEY ("co_municipio_ibge");

-- ----------------------------
-- Checks structure for table tb_pais
-- ----------------------------
ALTER TABLE "dbgeral"."tb_pais" ADD CONSTRAINT "nn_pais_nopais" CHECK (no_pais IS NOT NULL);
ALTER TABLE "dbgeral"."tb_pais" ADD CONSTRAINT "nn_pais_coseqpais" CHECK (co_seq_pais IS NOT NULL);
ALTER TABLE "dbgeral"."tb_pais" ADD CONSTRAINT "ck_pais_stregistroativo" CHECK (st_registro_ativo::text = 'S'::text OR st_registro_ativo::text = 'N'::text);

-- ----------------------------
-- Primary Key structure for table tb_pais
-- ----------------------------
ALTER TABLE "dbgeral"."tb_pais" ADD CONSTRAINT "pk_pais" PRIMARY KEY ("co_seq_pais");

-- ----------------------------
-- Uniques structure for table tb_raca_cor
-- ----------------------------
ALTER TABLE "dbgeral"."tb_raca_cor" ADD CONSTRAINT "uk_raca_cor" UNIQUE ("co_raca_cor");

-- ----------------------------
-- Primary Key structure for table tb_raca_cor
-- ----------------------------
ALTER TABLE "dbgeral"."tb_raca_cor" ADD CONSTRAINT "pk_raca_cor" PRIMARY KEY ("co_raca_cor_portaria");

-- ----------------------------
-- Checks structure for table tb_sexo
-- ----------------------------
ALTER TABLE "dbgeral"."tb_sexo" ADD CONSTRAINT "nn_sexo_cosexo" CHECK (co_sexo IS NOT NULL);

-- ----------------------------
-- Primary Key structure for table tb_sexo
-- ----------------------------
ALTER TABLE "dbgeral"."tb_sexo" ADD CONSTRAINT "pk_sexo" PRIMARY KEY ("co_sexo");

-- ----------------------------
-- Indexes structure for table tb_uf
-- ----------------------------
CREATE UNIQUE INDEX "uc_ufsguf" ON "dbgeral"."tb_uf" USING btree (
  "sg_uf" COLLATE "pg_catalog"."default" "pg_catalog"."text_ops" ASC NULLS LAST
);

-- ----------------------------
-- Uniques structure for table tb_uf
-- ----------------------------
ALTER TABLE "dbgeral"."tb_uf" ADD CONSTRAINT "uk_uf_sguf" UNIQUE ("sg_uf");

-- ----------------------------
-- Checks structure for table tb_uf
-- ----------------------------
ALTER TABLE "dbgeral"."tb_uf" ADD CONSTRAINT "nn_uf_sguf" CHECK (sg_uf IS NOT NULL);
ALTER TABLE "dbgeral"."tb_uf" ADD CONSTRAINT "nn_uf_coufibge" CHECK (co_uf_ibge IS NOT NULL);

-- ----------------------------
-- Primary Key structure for table tb_uf
-- ----------------------------
ALTER TABLE "dbgeral"."tb_uf" ADD CONSTRAINT "pk_uf" PRIMARY KEY ("co_uf_ibge");

-- ----------------------------
-- Foreign Keys structure for table tb_municipio
-- ----------------------------
ALTER TABLE "dbgeral"."tb_municipio" ADD CONSTRAINT "fk_municipio_sguf" FOREIGN KEY ("sg_uf") REFERENCES "dbgeral"."tb_uf" ("sg_uf") ON DELETE NO ACTION ON UPDATE NO ACTION;
ALTER TABLE "dbgeral"."tb_municipio" ADD CONSTRAINT "fk_municipio_uf_codibge" FOREIGN KEY ("co_uf_ibge") REFERENCES "dbgeral"."tb_uf" ("co_uf_ibge") ON DELETE NO ACTION ON UPDATE NO ACTION;

-- ----------------------------
-- Foreign Keys structure for table tb_uf
-- ----------------------------
ALTER TABLE "dbgeral"."tb_uf" ADD CONSTRAINT "fk_uf_pais" FOREIGN KEY ("co_pais") REFERENCES "dbgeral"."tb_pais" ("co_seq_pais") ON DELETE NO ACTION ON UPDATE NO ACTION;
